/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/editor/common/core/range","vs/base/common/errors","vs/editor/common/core/position","vs/base/common/strings","vs/editor/common/core/offsetRange","vs/base/common/lifecycle","vs/base/common/event","vs/editor/common/diff/algorithms/diffAlgorithm","vs/base/common/assert","vs/base/common/objects","vs/editor/common/core/lineRange","vs/base/common/platform","vs/base/common/uri","vs/base/common/functional","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/cancellation","vs/base/common/diff/diff","vs/base/common/types","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/diff/linesDiffComputer","vs/editor/common/diff/smartLinesDiffComputer","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/arrays","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/cache","vs/base/common/hash","vs/base/common/codicons","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/diff/algorithms/joinSequenceDiffs","vs/editor/common/diff/algorithms/myersDiffAlgorithm","vs/editor/common/diff/algorithms/utils","vs/editor/common/diff/algorithms/dynamicProgrammingDiffing","vs/editor/common/diff/standardLinesDiffComputer","vs/editor/common/diff/linesDiffComputers","vs/editor/common/languages/defaultDocumentColorsComputer","vs/editor/common/languages/linkComputer","vs/editor/common/languages/supports/inplaceReplaceSupport","vs/editor/common/model","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/unicodeTextModelHighlighter","vs/editor/common/standalone/standaloneEnums","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/platform","vs/nls","vs/nls!vs/editor/common/services/editorSimpleWorker","vs/base/common/process","vs/base/common/path","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/editor/common/services/editorBaseApi","vs/css","vs/base/common/worker/simpleWorker","vs/editor/common/services/editorSimpleWorker"],K=function(H){for(var t=[],k=0,D=H.length;k<D;k++)t[k]=Z[H[k]];return t};const Ve=this,We=typeof global=="object"?global:{};var de;(function(H){H.global=Ve;class t{get isWindows(){return this._detect(),this._isWindows}get isNode(){return this._detect(),this._isNode}get isElectronRenderer(){return this._detect(),this._isElectronRenderer}get isWebWorker(){return this._detect(),this._isWebWorker}get isElectronNodeIntegrationWebWorker(){return this._detect(),this._isElectronNodeIntegrationWebWorker}constructor(){this._detected=!1,this._isWindows=!1,this._isNode=!1,this._isElectronRenderer=!1,this._isWebWorker=!1,this._isElectronNodeIntegrationWebWorker=!1}_detect(){this._detected||(this._detected=!0,this._isWindows=t._isWindows(),this._isNode=typeof module<"u"&&!!module.exports,this._isElectronRenderer=typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="renderer",this._isWebWorker=typeof H.global.importScripts=="function",this._isElectronNodeIntegrationWebWorker=this._isWebWorker&&typeof process<"u"&&typeof process.versions<"u"&&typeof process.versions.electron<"u"&&process.type==="worker")}static _isWindows(){return typeof navigator<"u"&&navigator.userAgent&&navigator.userAgent.indexOf("Windows")>=0?!0:typeof process<"u"?process.platform==="win32":!1}}H.Environment=t})(de||(de={}));var de;(function(H){class t{constructor(a,v,c){this.type=a,this.detail=v,this.timestamp=c}}H.LoaderEvent=t;class k{constructor(a){this._events=[new t(1,"",a)]}record(a,v){this._events.push(new t(a,v,H.Utilities.getHighPerformanceTimestamp()))}getEvents(){return this._events}}H.LoaderEventRecorder=k;class D{record(a,v){}getEvents(){return[]}}D.INSTANCE=new D,H.NullLoaderEventRecorder=D})(de||(de={}));var de;(function(H){class t{static fileUriToFilePath(D,i){if(i=decodeURI(i).replace(/%23/g,"#"),D){if(/^file:\/\/\//.test(i))return i.substr(8);if(/^file:\/\//.test(i))return i.substr(5)}else if(/^file:\/\//.test(i))return i.substr(7);return i}static startsWith(D,i){return D.length>=i.length&&D.substr(0,i.length)===i}static endsWith(D,i){return D.length>=i.length&&D.substr(D.length-i.length)===i}static containsQueryString(D){return/^[^\#]*\?/gi.test(D)}static isAbsolutePath(D){return/^((http:\/\/)|(https:\/\/)|(file:\/\/)|(\/))/.test(D)}static forEachProperty(D,i){if(D){let a;for(a in D)D.hasOwnProperty(a)&&i(a,D[a])}}static isEmpty(D){let i=!0;return t.forEachProperty(D,()=>{i=!1}),i}static recursiveClone(D){if(!D||typeof D!="object"||D instanceof RegExp||!Array.isArray(D)&&Object.getPrototypeOf(D)!==Object.prototype)return D;let i=Array.isArray(D)?[]:{};return t.forEachProperty(D,(a,v)=>{v&&typeof v=="object"?i[a]=t.recursiveClone(v):i[a]=v}),i}static generateAnonymousModule(){return"===anonymous"+t.NEXT_ANONYMOUS_ID+++"==="}static isAnonymousModule(D){return t.startsWith(D,"===anonymous")}static getHighPerformanceTimestamp(){return this.PERFORMANCE_NOW_PROBED||(this.PERFORMANCE_NOW_PROBED=!0,this.HAS_PERFORMANCE_NOW=H.global.performance&&typeof H.global.performance.now=="function"),this.HAS_PERFORMANCE_NOW?H.global.performance.now():Date.now()}}t.NEXT_ANONYMOUS_ID=1,t.PERFORMANCE_NOW_PROBED=!1,t.HAS_PERFORMANCE_NOW=!1,H.Utilities=t})(de||(de={}));var de;(function(H){function t(i){if(i instanceof Error)return i;const a=new Error(i.message||String(i)||"Unknown Error");return i.stack&&(a.stack=i.stack),a}H.ensureError=t;class k{static validateConfigurationOptions(a){function v(c){if(c.phase==="loading"){console.error('Loading "'+c.moduleId+'" failed'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}if(c.phase==="factory"){console.error('The factory function of "'+c.moduleId+'" has thrown an exception'),console.error(c),console.error("Here are the modules that depend on it:"),console.error(c.neededBy);return}}if(a=a||{},typeof a.baseUrl!="string"&&(a.baseUrl=""),typeof a.isBuild!="boolean"&&(a.isBuild=!1),typeof a.paths!="object"&&(a.paths={}),typeof a.config!="object"&&(a.config={}),typeof a.catchError>"u"&&(a.catchError=!1),typeof a.recordStats>"u"&&(a.recordStats=!1),typeof a.urlArgs!="string"&&(a.urlArgs=""),typeof a.onError!="function"&&(a.onError=v),Array.isArray(a.ignoreDuplicateModules)||(a.ignoreDuplicateModules=[]),a.baseUrl.length>0&&(H.Utilities.endsWith(a.baseUrl,"/")||(a.baseUrl+="/")),typeof a.cspNonce!="string"&&(a.cspNonce=""),typeof a.preferScriptTags>"u"&&(a.preferScriptTags=!1),a.nodeCachedData&&typeof a.nodeCachedData=="object"&&(typeof a.nodeCachedData.seed!="string"&&(a.nodeCachedData.seed="seed"),(typeof a.nodeCachedData.writeDelay!="number"||a.nodeCachedData.writeDelay<0)&&(a.nodeCachedData.writeDelay=1e3*7),!a.nodeCachedData.path||typeof a.nodeCachedData.path!="string")){const c=t(new Error("INVALID cached data configuration, 'path' MUST be set"));c.phase="configuration",a.onError(c),a.nodeCachedData=void 0}return a}static mergeConfigurationOptions(a=null,v=null){let c=H.Utilities.recursiveClone(v||{});return H.Utilities.forEachProperty(a,(s,u)=>{s==="ignoreDuplicateModules"&&typeof c.ignoreDuplicateModules<"u"?c.ignoreDuplicateModules=c.ignoreDuplicateModules.concat(u):s==="paths"&&typeof c.paths<"u"?H.Utilities.forEachProperty(u,(f,M)=>c.paths[f]=M):s==="config"&&typeof c.config<"u"?H.Utilities.forEachProperty(u,(f,M)=>c.config[f]=M):c[s]=H.Utilities.recursiveClone(u)}),k.validateConfigurationOptions(c)}}H.ConfigurationOptionsUtil=k;class D{constructor(a,v){if(this._env=a,this.options=k.mergeConfigurationOptions(v),this._createIgnoreDuplicateModulesMap(),this._createSortedPathsRules(),this.options.baseUrl===""&&this.options.nodeRequire&&this.options.nodeRequire.main&&this.options.nodeRequire.main.filename&&this._env.isNode){let c=this.options.nodeRequire.main.filename,s=Math.max(c.lastIndexOf("/"),c.lastIndexOf("\\"));this.options.baseUrl=c.substring(0,s+1)}}_createIgnoreDuplicateModulesMap(){this.ignoreDuplicateModulesMap={};for(let a=0;a<this.options.ignoreDuplicateModules.length;a++)this.ignoreDuplicateModulesMap[this.options.ignoreDuplicateModules[a]]=!0}_createSortedPathsRules(){this.sortedPathsRules=[],H.Utilities.forEachProperty(this.options.paths,(a,v)=>{Array.isArray(v)?this.sortedPathsRules.push({from:a,to:v}):this.sortedPathsRules.push({from:a,to:[v]})}),this.sortedPathsRules.sort((a,v)=>v.from.length-a.from.length)}cloneAndMerge(a){return new D(this._env,k.mergeConfigurationOptions(a,this.options))}getOptionsLiteral(){return this.options}_applyPaths(a){let v;for(let c=0,s=this.sortedPathsRules.length;c<s;c++)if(v=this.sortedPathsRules[c],H.Utilities.startsWith(a,v.from)){let u=[];for(let f=0,M=v.to.length;f<M;f++)u.push(v.to[f]+a.substr(v.from.length));return u}return[a]}_addUrlArgsToUrl(a){return H.Utilities.containsQueryString(a)?a+"&"+this.options.urlArgs:a+"?"+this.options.urlArgs}_addUrlArgsIfNecessaryToUrl(a){return this.options.urlArgs?this._addUrlArgsToUrl(a):a}_addUrlArgsIfNecessaryToUrls(a){if(this.options.urlArgs)for(let v=0,c=a.length;v<c;v++)a[v]=this._addUrlArgsToUrl(a[v]);return a}moduleIdToPaths(a){if(this._env.isNode&&this.options.amdModulesPattern instanceof RegExp&&!this.options.amdModulesPattern.test(a))return this.isBuild()?["empty:"]:["node|"+a];let v=a,c;if(!H.Utilities.endsWith(v,".js")&&!H.Utilities.isAbsolutePath(v)){c=this._applyPaths(v);for(let s=0,u=c.length;s<u;s++)this.isBuild()&&c[s]==="empty:"||(H.Utilities.isAbsolutePath(c[s])||(c[s]=this.options.baseUrl+c[s]),!H.Utilities.endsWith(c[s],".js")&&!H.Utilities.containsQueryString(c[s])&&(c[s]=c[s]+".js"))}else!H.Utilities.endsWith(v,".js")&&!H.Utilities.containsQueryString(v)&&(v=v+".js"),c=[v];return this._addUrlArgsIfNecessaryToUrls(c)}requireToUrl(a){let v=a;return H.Utilities.isAbsolutePath(v)||(v=this._applyPaths(v)[0],H.Utilities.isAbsolutePath(v)||(v=this.options.baseUrl+v)),this._addUrlArgsIfNecessaryToUrl(v)}isBuild(){return this.options.isBuild}shouldInvokeFactory(a){return!!(!this.options.isBuild||H.Utilities.isAnonymousModule(a)||this.options.buildForceInvokeFactory&&this.options.buildForceInvokeFactory[a])}isDuplicateMessageIgnoredFor(a){return this.ignoreDuplicateModulesMap.hasOwnProperty(a)}getConfigForModule(a){if(this.options.config)return this.options.config[a]}shouldCatchError(){return this.options.catchError}shouldRecordStats(){return this.options.recordStats}onError(a){this.options.onError(a)}}H.Configuration=D})(de||(de={}));var de;(function(H){class t{constructor(u){this._env=u,this._scriptLoader=null,this._callbackMap={}}load(u,f,M,h){if(!this._scriptLoader)if(this._env.isWebWorker)this._scriptLoader=new i;else if(this._env.isElectronRenderer){const{preferScriptTags:e}=u.getConfig().getOptionsLiteral();e?this._scriptLoader=new k:this._scriptLoader=new a(this._env)}else this._env.isNode?this._scriptLoader=new a(this._env):this._scriptLoader=new k;let o={callback:M,errorback:h};if(this._callbackMap.hasOwnProperty(f)){this._callbackMap[f].push(o);return}this._callbackMap[f]=[o],this._scriptLoader.load(u,f,()=>this.triggerCallback(f),e=>this.triggerErrorback(f,e))}triggerCallback(u){let f=this._callbackMap[u];delete this._callbackMap[u];for(let M=0;M<f.length;M++)f[M].callback()}triggerErrorback(u,f){let M=this._callbackMap[u];delete this._callbackMap[u];for(let h=0;h<M.length;h++)M[h].errorback(f)}}class k{attachListeners(u,f,M){let h=()=>{u.removeEventListener("load",o),u.removeEventListener("error",e)},o=N=>{h(),f()},e=N=>{h(),M(N)};u.addEventListener("load",o),u.addEventListener("error",e)}load(u,f,M,h){if(/^node\|/.test(f)){let o=u.getConfig().getOptionsLiteral(),e=v(u.getRecorder(),o.nodeRequire||H.global.nodeRequire),N=f.split("|"),y=null;try{y=e(N[1])}catch(R){h(R);return}u.enqueueDefineAnonymousModule([],()=>y),M()}else{let o=document.createElement("script");o.setAttribute("async","async"),o.setAttribute("type","text/javascript"),this.attachListeners(o,M,h);const{trustedTypesPolicy:e}=u.getConfig().getOptionsLiteral();e&&(f=e.createScriptURL(f)),o.setAttribute("src",f);const{cspNonce:N}=u.getConfig().getOptionsLiteral();N&&o.setAttribute("nonce",N),document.getElementsByTagName("head")[0].appendChild(o)}}}function D(s){const{trustedTypesPolicy:u}=s.getConfig().getOptionsLiteral();try{return(u?self.eval(u.createScript("","true")):new Function("true")).call(self),!0}catch{return!1}}class i{constructor(){this._cachedCanUseEval=null}_canUseEval(u){return this._cachedCanUseEval===null&&(this._cachedCanUseEval=D(u)),this._cachedCanUseEval}load(u,f,M,h){if(/^node\|/.test(f)){const o=u.getConfig().getOptionsLiteral(),e=v(u.getRecorder(),o.nodeRequire||H.global.nodeRequire),N=f.split("|");let y=null;try{y=e(N[1])}catch(R){h(R);return}u.enqueueDefineAnonymousModule([],function(){return y}),M()}else{const{trustedTypesPolicy:o}=u.getConfig().getOptionsLiteral();if(!(/^((http:)|(https:)|(file:))/.test(f)&&f.substring(0,self.origin.length)!==self.origin)&&this._canUseEval(u)){fetch(f).then(N=>{if(N.status!==200)throw new Error(N.statusText);return N.text()}).then(N=>{N=`${N}
//# sourceURL=${f}`,(o?self.eval(o.createScript("",N)):new Function(N)).call(self),M()}).then(void 0,h);return}try{o&&(f=o.createScriptURL(f)),importScripts(f),M()}catch(N){h(N)}}}}class a{constructor(u){this._env=u,this._didInitialize=!1,this._didPatchNodeRequire=!1}_init(u){this._didInitialize||(this._didInitialize=!0,this._fs=u("fs"),this._vm=u("vm"),this._path=u("path"),this._crypto=u("crypto"))}_initNodeRequire(u,f){const{nodeCachedData:M}=f.getConfig().getOptionsLiteral();if(!M||this._didPatchNodeRequire)return;this._didPatchNodeRequire=!0;const h=this,o=u("module");function e(N){const y=N.constructor;let R=function(E){try{return N.require(E)}finally{}};return R.resolve=function(E,g){return y._resolveFilename(E,N,!1,g)},R.resolve.paths=function(E){return y._resolveLookupPaths(E,N)},R.main=process.mainModule,R.extensions=y._extensions,R.cache=y._cache,R}o.prototype._compile=function(N,y){const R=o.wrap(N.replace(/^#!.*/,"")),b=f.getRecorder(),E=h._getCachedDataPath(M,y),g={filename:y};let m;try{const L=h._fs.readFileSync(E);m=L.slice(0,16),g.cachedData=L.slice(16),b.record(60,E)}catch{b.record(61,E)}const r=new h._vm.Script(R,g),l=r.runInThisContext(g),A=h._path.dirname(y),d=e(this),$=[this.exports,d,this,y,A,process,We,Buffer],w=l.apply(this.exports,$);return h._handleCachedData(r,R,E,!g.cachedData,f),h._verifyCachedData(r,R,E,m,f),w}}load(u,f,M,h){const o=u.getConfig().getOptionsLiteral(),e=v(u.getRecorder(),o.nodeRequire||H.global.nodeRequire),N=o.nodeInstrumenter||function(R){return R};this._init(e),this._initNodeRequire(e,u);let y=u.getRecorder();if(/^node\|/.test(f)){let R=f.split("|"),b=null;try{b=e(R[1])}catch(E){h(E);return}u.enqueueDefineAnonymousModule([],()=>b),M()}else{f=H.Utilities.fileUriToFilePath(this._env.isWindows,f);const R=this._path.normalize(f),b=this._getElectronRendererScriptPathOrUri(R),E=!!o.nodeCachedData,g=E?this._getCachedDataPath(o.nodeCachedData,f):void 0;this._readSourceAndCachedData(R,g,y,(m,r,l,A)=>{if(m){h(m);return}let d;r.charCodeAt(0)===a._BOM?d=a._PREFIX+r.substring(1)+a._SUFFIX:d=a._PREFIX+r+a._SUFFIX,d=N(d,R);const $={filename:b,cachedData:l},w=this._createAndEvalScript(u,d,$,M,h);this._handleCachedData(w,d,g,E&&!l,u),this._verifyCachedData(w,d,g,A,u)})}}_createAndEvalScript(u,f,M,h,o){const e=u.getRecorder();e.record(31,M.filename);const N=new this._vm.Script(f,M),y=N.runInThisContext(M),R=u.getGlobalAMDDefineFunc();let b=!1;const E=function(){return b=!0,R.apply(null,arguments)};return E.amd=R.amd,y.call(H.global,u.getGlobalAMDRequireFunc(),E,M.filename,this._path.dirname(M.filename)),e.record(32,M.filename),b?h():o(new Error(`Didn't receive define call in ${M.filename}!`)),N}_getElectronRendererScriptPathOrUri(u){if(!this._env.isElectronRenderer)return u;let f=u.match(/^([a-z])\:(.*)/i);return f?`file:///${(f[1].toUpperCase()+":"+f[2]).replace(/\\/g,"/")}`:`file://${u}`}_getCachedDataPath(u,f){const M=this._crypto.createHash("md5").update(f,"utf8").update(u.seed,"utf8").update(process.arch,"").digest("hex"),h=this._path.basename(f).replace(/\.js$/,"");return this._path.join(u.path,`${h}-${M}.code`)}_handleCachedData(u,f,M,h,o){u.cachedDataRejected?this._fs.unlink(M,e=>{o.getRecorder().record(62,M),this._createAndWriteCachedData(u,f,M,o),e&&o.getConfig().onError(e)}):h&&this._createAndWriteCachedData(u,f,M,o)}_createAndWriteCachedData(u,f,M,h){let o=Math.ceil(h.getConfig().getOptionsLiteral().nodeCachedData.writeDelay*(1+Math.random())),e=-1,N=0,y;const R=()=>{setTimeout(()=>{y||(y=this._crypto.createHash("md5").update(f,"utf8").digest());const b=u.createCachedData();if(!(b.length===0||b.length===e||N>=5)){if(b.length<e){R();return}e=b.length,this._fs.writeFile(M,Buffer.concat([y,b]),E=>{E&&h.getConfig().onError(E),h.getRecorder().record(63,M),R()})}},o*Math.pow(4,N++))};R()}_readSourceAndCachedData(u,f,M,h){if(!f)this._fs.readFile(u,{encoding:"utf8"},h);else{let o,e,N,y=2;const R=b=>{b?h(b):--y===0&&h(void 0,o,e,N)};this._fs.readFile(u,{encoding:"utf8"},(b,E)=>{o=E,R(b)}),this._fs.readFile(f,(b,E)=>{!b&&E&&E.length>0?(N=E.slice(0,16),e=E.slice(16),M.record(60,f)):M.record(61,f),R()})}}_verifyCachedData(u,f,M,h,o){h&&(u.cachedDataRejected||setTimeout(()=>{const e=this._crypto.createHash("md5").update(f,"utf8").digest();h.equals(e)||(o.getConfig().onError(new Error(`FAILED TO VERIFY CACHED DATA, deleting stale '${M}' now, but a RESTART IS REQUIRED`)),this._fs.unlink(M,N=>{N&&o.getConfig().onError(N)}))},Math.ceil(5e3*(1+Math.random()))))}}a._BOM=65279,a._PREFIX="(function (require, define, __filename, __dirname) { ",a._SUFFIX=`
});`;function v(s,u){if(u.__$__isRecorded)return u;const f=function(h){s.record(33,h);try{return u(h)}finally{s.record(34,h)}};return f.__$__isRecorded=!0,f}H.ensureRecordedNodeRequire=v;function c(s){return new t(s)}H.createScriptLoader=c})(de||(de={}));var de;(function(H){class t{constructor(s){let u=s.lastIndexOf("/");u!==-1?this.fromModulePath=s.substr(0,u+1):this.fromModulePath=""}static _normalizeModuleId(s){let u=s,f;for(f=/\/\.\//;f.test(u);)u=u.replace(f,"/");for(u=u.replace(/^\.\//g,""),f=/\/(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//;f.test(u);)u=u.replace(f,"/");return u=u.replace(/^(([^\/])|([^\/][^\/\.])|([^\/\.][^\/])|([^\/][^\/][^\/]+))\/\.\.\//,""),u}resolveModule(s){let u=s;return H.Utilities.isAbsolutePath(u)||(H.Utilities.startsWith(u,"./")||H.Utilities.startsWith(u,"../"))&&(u=t._normalizeModuleId(this.fromModulePath+u)),u}}t.ROOT=new t(""),H.ModuleIdResolver=t;class k{constructor(s,u,f,M,h,o){this.id=s,this.strId=u,this.dependencies=f,this._callback=M,this._errorback=h,this.moduleIdResolver=o,this.exports={},this.error=null,this.exportsPassedIn=!1,this.unresolvedDependenciesCount=this.dependencies.length,this._isComplete=!1}static _safeInvokeFunction(s,u){try{return{returnedValue:s.apply(H.global,u),producedError:null}}catch(f){return{returnedValue:null,producedError:f}}}static _invokeFactory(s,u,f,M){return s.shouldInvokeFactory(u)?s.shouldCatchError()?this._safeInvokeFunction(f,M):{returnedValue:f.apply(H.global,M),producedError:null}:{returnedValue:null,producedError:null}}complete(s,u,f,M){this._isComplete=!0;let h=null;if(this._callback)if(typeof this._callback=="function"){s.record(21,this.strId);let o=k._invokeFactory(u,this.strId,this._callback,f);h=o.producedError,s.record(22,this.strId),!h&&typeof o.returnedValue<"u"&&(!this.exportsPassedIn||H.Utilities.isEmpty(this.exports))&&(this.exports=o.returnedValue)}else this.exports=this._callback;if(h){let o=H.ensureError(h);o.phase="factory",o.moduleId=this.strId,o.neededBy=M(this.id),this.error=o,u.onError(o)}this.dependencies=null,this._callback=null,this._errorback=null,this.moduleIdResolver=null}onDependencyError(s){return this._isComplete=!0,this.error=s,this._errorback?(this._errorback(s),!0):!1}isComplete(){return this._isComplete}}H.Module=k;class D{constructor(){this._nextId=0,this._strModuleIdToIntModuleId=new Map,this._intModuleIdToStrModuleId=[],this.getModuleId("exports"),this.getModuleId("module"),this.getModuleId("require")}getMaxModuleId(){return this._nextId}getModuleId(s){let u=this._strModuleIdToIntModuleId.get(s);return typeof u>"u"&&(u=this._nextId++,this._strModuleIdToIntModuleId.set(s,u),this._intModuleIdToStrModuleId[u]=s),u}getStrModuleId(s){return this._intModuleIdToStrModuleId[s]}}class i{constructor(s){this.id=s}}i.EXPORTS=new i(0),i.MODULE=new i(1),i.REQUIRE=new i(2),H.RegularDependency=i;class a{constructor(s,u,f){this.id=s,this.pluginId=u,this.pluginParam=f}}H.PluginDependency=a;class v{constructor(s,u,f,M,h=0){this._env=s,this._scriptLoader=u,this._loaderAvailableTimestamp=h,this._defineFunc=f,this._requireFunc=M,this._moduleIdProvider=new D,this._config=new H.Configuration(this._env),this._hasDependencyCycle=!1,this._modules2=[],this._knownModules2=[],this._inverseDependencies2=[],this._inversePluginDependencies2=new Map,this._currentAnonymousDefineCall=null,this._recorder=null,this._buildInfoPath=[],this._buildInfoDefineStack=[],this._buildInfoDependencies=[]}reset(){return new v(this._env,this._scriptLoader,this._defineFunc,this._requireFunc,this._loaderAvailableTimestamp)}getGlobalAMDDefineFunc(){return this._defineFunc}getGlobalAMDRequireFunc(){return this._requireFunc}static _findRelevantLocationInStack(s,u){let f=o=>o.replace(/\\/g,"/"),M=f(s),h=u.split(/\n/);for(let o=0;o<h.length;o++){let e=h[o].match(/(.*):(\d+):(\d+)\)?$/);if(e){let N=e[1],y=e[2],R=e[3],b=Math.max(N.lastIndexOf(" ")+1,N.lastIndexOf("(")+1);if(N=N.substr(b),N=f(N),N===M){let E={line:parseInt(y,10),col:parseInt(R,10)};return E.line===1&&(E.col-=53),E}}}throw new Error("Could not correlate define call site for needle "+s)}getBuildInfo(){if(!this._config.isBuild())return null;let s=[],u=0;for(let f=0,M=this._modules2.length;f<M;f++){let h=this._modules2[f];if(!h)continue;let o=this._buildInfoPath[h.id]||null,e=this._buildInfoDefineStack[h.id]||null,N=this._buildInfoDependencies[h.id];s[u++]={id:h.strId,path:o,defineLocation:o&&e?v._findRelevantLocationInStack(o,e):null,dependencies:N,shim:null,exports:h.exports}}return s}getRecorder(){return this._recorder||(this._config.shouldRecordStats()?this._recorder=new H.LoaderEventRecorder(this._loaderAvailableTimestamp):this._recorder=H.NullLoaderEventRecorder.INSTANCE),this._recorder}getLoaderEvents(){return this.getRecorder().getEvents()}enqueueDefineAnonymousModule(s,u){if(this._currentAnonymousDefineCall!==null)throw new Error("Can only have one anonymous define call per script file");let f=null;this._config.isBuild()&&(f=new Error("StackLocation").stack||null),this._currentAnonymousDefineCall={stack:f,dependencies:s,callback:u}}defineModule(s,u,f,M,h,o=new t(s)){let e=this._moduleIdProvider.getModuleId(s);if(this._modules2[e]){this._config.isDuplicateMessageIgnoredFor(s)||console.warn("Duplicate definition of module '"+s+"'");return}let N=new k(e,s,this._normalizeDependencies(u,o),f,M,o);this._modules2[e]=N,this._config.isBuild()&&(this._buildInfoDefineStack[e]=h,this._buildInfoDependencies[e]=(N.dependencies||[]).map(y=>this._moduleIdProvider.getStrModuleId(y.id))),this._resolve(N)}_normalizeDependency(s,u){if(s==="exports")return i.EXPORTS;if(s==="module")return i.MODULE;if(s==="require")return i.REQUIRE;let f=s.indexOf("!");if(f>=0){let M=u.resolveModule(s.substr(0,f)),h=u.resolveModule(s.substr(f+1)),o=this._moduleIdProvider.getModuleId(M+"!"+h),e=this._moduleIdProvider.getModuleId(M);return new a(o,e,h)}return new i(this._moduleIdProvider.getModuleId(u.resolveModule(s)))}_normalizeDependencies(s,u){let f=[],M=0;for(let h=0,o=s.length;h<o;h++)f[M++]=this._normalizeDependency(s[h],u);return f}_relativeRequire(s,u,f,M){if(typeof u=="string")return this.synchronousRequire(u,s);this.defineModule(H.Utilities.generateAnonymousModule(),u,f,M,null,s)}synchronousRequire(s,u=new t(s)){let f=this._normalizeDependency(s,u),M=this._modules2[f.id];if(!M)throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This is the first mention of this module!");if(!M.isComplete())throw new Error("Check dependency list! Synchronous require cannot resolve module '"+s+"'. This module has not been resolved completely yet.");if(M.error)throw M.error;return M.exports}configure(s,u){let f=this._config.shouldRecordStats();u?this._config=new H.Configuration(this._env,s):this._config=this._config.cloneAndMerge(s),this._config.shouldRecordStats()&&!f&&(this._recorder=null)}getConfig(){return this._config}_onLoad(s){if(this._currentAnonymousDefineCall!==null){let u=this._currentAnonymousDefineCall;this._currentAnonymousDefineCall=null,this.defineModule(this._moduleIdProvider.getStrModuleId(s),u.dependencies,u.callback,null,u.stack)}}_createLoadError(s,u){let f=this._moduleIdProvider.getStrModuleId(s),M=(this._inverseDependencies2[s]||[]).map(o=>this._moduleIdProvider.getStrModuleId(o));const h=H.ensureError(u);return h.phase="loading",h.moduleId=f,h.neededBy=M,h}_onLoadError(s,u){const f=this._createLoadError(s,u);this._modules2[s]||(this._modules2[s]=new k(s,this._moduleIdProvider.getStrModuleId(s),[],()=>{},null,null));let M=[];for(let e=0,N=this._moduleIdProvider.getMaxModuleId();e<N;e++)M[e]=!1;let h=!1,o=[];for(o.push(s),M[s]=!0;o.length>0;){let e=o.shift(),N=this._modules2[e];N&&(h=N.onDependencyError(f)||h);let y=this._inverseDependencies2[e];if(y)for(let R=0,b=y.length;R<b;R++){let E=y[R];M[E]||(o.push(E),M[E]=!0)}}h||this._config.onError(f)}_hasDependencyPath(s,u){let f=this._modules2[s];if(!f)return!1;let M=[];for(let o=0,e=this._moduleIdProvider.getMaxModuleId();o<e;o++)M[o]=!1;let h=[];for(h.push(f),M[s]=!0;h.length>0;){let e=h.shift().dependencies;if(e)for(let N=0,y=e.length;N<y;N++){let R=e[N];if(R.id===u)return!0;let b=this._modules2[R.id];b&&!M[R.id]&&(M[R.id]=!0,h.push(b))}}return!1}_findCyclePath(s,u,f){if(s===u||f===50)return[s];let M=this._modules2[s];if(!M)return null;let h=M.dependencies;if(h)for(let o=0,e=h.length;o<e;o++){let N=this._findCyclePath(h[o].id,u,f+1);if(N!==null)return N.push(s),N}return null}_createRequire(s){let u=(f,M,h)=>this._relativeRequire(s,f,M,h);return u.toUrl=f=>this._config.requireToUrl(s.resolveModule(f)),u.getStats=()=>this.getLoaderEvents(),u.hasDependencyCycle=()=>this._hasDependencyCycle,u.config=(f,M=!1)=>{this.configure(f,M)},u.__$__nodeRequire=H.global.nodeRequire,u}_loadModule(s){if(this._modules2[s]||this._knownModules2[s])return;this._knownModules2[s]=!0;let u=this._moduleIdProvider.getStrModuleId(s),f=this._config.moduleIdToPaths(u),M=/^@[^\/]+\/[^\/]+$/;this._env.isNode&&(u.indexOf("/")===-1||M.test(u))&&f.push("node|"+u);let h=-1,o=e=>{if(h++,h>=f.length)this._onLoadError(s,e);else{let N=f[h],y=this.getRecorder();if(this._config.isBuild()&&N==="empty:"){this._buildInfoPath[s]=N,this.defineModule(this._moduleIdProvider.getStrModuleId(s),[],null,null,null),this._onLoad(s);return}y.record(10,N),this._scriptLoader.load(this,N,()=>{this._config.isBuild()&&(this._buildInfoPath[s]=N),y.record(11,N),this._onLoad(s)},R=>{y.record(12,N),o(R)})}};o(null)}_loadPluginDependency(s,u){if(this._modules2[u.id]||this._knownModules2[u.id])return;this._knownModules2[u.id]=!0;let f=M=>{this.defineModule(this._moduleIdProvider.getStrModuleId(u.id),[],M,null,null)};f.error=M=>{this._config.onError(this._createLoadError(u.id,M))},s.load(u.pluginParam,this._createRequire(t.ROOT),f,this._config.getOptionsLiteral())}_resolve(s){let u=s.dependencies;if(u)for(let f=0,M=u.length;f<M;f++){let h=u[f];if(h===i.EXPORTS){s.exportsPassedIn=!0,s.unresolvedDependenciesCount--;continue}if(h===i.MODULE){s.unresolvedDependenciesCount--;continue}if(h===i.REQUIRE){s.unresolvedDependenciesCount--;continue}let o=this._modules2[h.id];if(o&&o.isComplete()){if(o.error){s.onDependencyError(o.error);return}s.unresolvedDependenciesCount--;continue}if(this._hasDependencyPath(h.id,s.id)){this._hasDependencyCycle=!0,console.warn("There is a dependency cycle between '"+this._moduleIdProvider.getStrModuleId(h.id)+"' and '"+this._moduleIdProvider.getStrModuleId(s.id)+"'. The cyclic path follows:");let e=this._findCyclePath(h.id,s.id,0)||[];e.reverse(),e.push(h.id),console.warn(e.map(N=>this._moduleIdProvider.getStrModuleId(N)).join(` => 
`)),s.unresolvedDependenciesCount--;continue}if(this._inverseDependencies2[h.id]=this._inverseDependencies2[h.id]||[],this._inverseDependencies2[h.id].push(s.id),h instanceof a){let e=this._modules2[h.pluginId];if(e&&e.isComplete()){this._loadPluginDependency(e.exports,h);continue}let N=this._inversePluginDependencies2.get(h.pluginId);N||(N=[],this._inversePluginDependencies2.set(h.pluginId,N)),N.push(h),this._loadModule(h.pluginId);continue}this._loadModule(h.id)}s.unresolvedDependenciesCount===0&&this._onModuleComplete(s)}_onModuleComplete(s){let u=this.getRecorder();if(s.isComplete())return;let f=s.dependencies,M=[];if(f)for(let N=0,y=f.length;N<y;N++){let R=f[N];if(R===i.EXPORTS){M[N]=s.exports;continue}if(R===i.MODULE){M[N]={id:s.strId,config:()=>this._config.getConfigForModule(s.strId)};continue}if(R===i.REQUIRE){M[N]=this._createRequire(s.moduleIdResolver);continue}let b=this._modules2[R.id];if(b){M[N]=b.exports;continue}M[N]=null}const h=N=>(this._inverseDependencies2[N]||[]).map(y=>this._moduleIdProvider.getStrModuleId(y));s.complete(u,this._config,M,h);let o=this._inverseDependencies2[s.id];if(this._inverseDependencies2[s.id]=null,o)for(let N=0,y=o.length;N<y;N++){let R=o[N],b=this._modules2[R];b.unresolvedDependenciesCount--,b.unresolvedDependenciesCount===0&&this._onModuleComplete(b)}let e=this._inversePluginDependencies2.get(s.id);if(e){this._inversePluginDependencies2.delete(s.id);for(let N=0,y=e.length;N<y;N++)this._loadPluginDependency(s.exports,e[N])}}}H.ModuleManager=v})(de||(de={}));var Y,de;(function(H){const t=new H.Environment;let k=null;const D=function(c,s,u){typeof c!="string"&&(u=s,s=c,c=null),(typeof s!="object"||!Array.isArray(s))&&(u=s,s=null),s||(s=["require","exports","module"]),c?k.defineModule(c,s,u,null,null):k.enqueueDefineAnonymousModule(s,u)};D.amd={jQuery:!0};const i=function(c,s=!1){k.configure(c,s)},a=function(){if(arguments.length===1){if(arguments[0]instanceof Object&&!Array.isArray(arguments[0])){i(arguments[0]);return}if(typeof arguments[0]=="string")return k.synchronousRequire(arguments[0])}if((arguments.length===2||arguments.length===3)&&Array.isArray(arguments[0])){k.defineModule(H.Utilities.generateAnonymousModule(),arguments[0],arguments[1],arguments[2],null);return}throw new Error("Unrecognized require call")};a.config=i,a.getConfig=function(){return k.getConfig().getOptionsLiteral()},a.reset=function(){k=k.reset()},a.getBuildInfo=function(){return k.getBuildInfo()},a.getStats=function(){return k.getLoaderEvents()},a.define=D;function v(){if(typeof H.global.require<"u"||typeof require<"u"){const c=H.global.require||require;if(typeof c=="function"&&typeof c.resolve=="function"){const s=H.ensureRecordedNodeRequire(k.getRecorder(),c);H.global.nodeRequire=s,a.nodeRequire=s,a.__$__nodeRequire=s}}t.isNode&&!t.isElectronRenderer&&!t.isElectronNodeIntegrationWebWorker?module.exports=a:(t.isElectronRenderer||(H.global.define=D),H.global.require=a)}H.init=v,(typeof H.global.define!="function"||!H.global.define.amd)&&(k=new H.ModuleManager(t,H.createScriptLoader(t),D,a,H.Utilities.getHighPerformanceTimestamp()),typeof H.global.require<"u"&&typeof H.global.require!="function"&&a.config(H.global.require),Y=function(){return D.apply(null,arguments)},Y.amd=D.amd,typeof doNotInitLoader>"u"&&v())})(de||(de={})),Y(Z[62],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=void 0;function k(c,s,u,f){if(f=f||{},(f["vs/css"]||{}).disabled){u({});return}const h=s.toUrl(c+".css");D(c,h,()=>{u({})},o=>{typeof u.error=="function"&&u.error("Could not find "+h+".")})}t.load=k;function D(c,s,u,f){if(i(c,s)){u();return}a(c,s,u,f)}function i(c,s){const u=document.getElementsByTagName("link");for(let f=0,M=u.length;f<M;f++){const h=u[f].getAttribute("data-name"),o=u[f].getAttribute("href");if(h===c||o===s)return!0}return!1}function a(c,s,u,f){const M=document.createElement("link");M.setAttribute("rel","stylesheet"),M.setAttribute("type","text/css"),M.setAttribute("data-name",c),v(c,M,u,f),M.setAttribute("href",s),(document.head||document.getElementsByTagName("head")[0]).appendChild(M)}function v(c,s,u,f){const M=()=>{s.removeEventListener("load",h),s.removeEventListener("error",o)},h=e=>{M(),u()},o=e=>{M(),f(e)};s.addEventListener("load",h),s.addEventListener("error",o)}}),Y("vs/nls",["require","exports"],function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.load=t.create=t.setPseudoTranslation=t.getConfiguredDefaultLocale=t.localize=void 0;let k=typeof document<"u"&&document.location&&document.location.hash.indexOf("pseudo=true")>=0;const D="i-default";function i(e,N){let y;return N.length===0?y=e:y=e.replace(/\{(\d+)\}/g,(R,b)=>{const E=b[0],g=N[E];let m=R;return typeof g=="string"?m=g:(typeof g=="number"||typeof g=="boolean"||g===void 0||g===null)&&(m=String(g)),m}),k&&(y="\uFF3B"+y.replace(/[aouei]/g,"$&$&")+"\uFF3D"),y}function a(e,N){let y=e[N];return y||(y=e["*"],y)?y:null}function v(e){return e.charAt(e.length-1)==="/"?e:e+"/"}async function c(e,N,y){const R=v(e)+v(N)+"vscode/"+v(y),b=await fetch(R);if(b.ok)return await b.json();throw new Error(`${b.status} - ${b.statusText}`)}function s(e){return function(N,y){const R=Array.prototype.slice.call(arguments,2);return i(e[N],R)}}function u(e,N,...y){return i(N,y)}t.localize=u;function f(e){}t.getConfiguredDefaultLocale=f;function M(e){k=e}t.setPseudoTranslation=M;function h(e,N){return{localize:s(N[e]),getConfiguredDefaultLocale:N.getConfiguredDefaultLocale??(y=>{})}}t.create=h;function o(e,N,y,R){const b=R["vs/nls"]??{};if(!e||e.length===0)return y({localize:u,getConfiguredDefaultLocale:()=>b.availableLanguages?.["*"]});const E=b.availableLanguages?a(b.availableLanguages,e):null,g=E===null||E===D;let m=".nls";g||(m=m+"."+E);const r=l=>{Array.isArray(l)?l.localize=s(l):l.localize=s(l[e]),l.getConfiguredDefaultLocale=()=>b.availableLanguages?.["*"],y(l)};typeof b.loadBundle=="function"?b.loadBundle(e,E,(l,A)=>{l?N([e+".nls"],r):r(A)}):b.translationServiceUrl&&!g?(async()=>{try{const l=await c(b.translationServiceUrl,E,e);return r(l)}catch(l){if(!E.includes("-"))return console.error(l),N([e+".nls"],r);try{const A=E.split("-")[0],d=await c(b.translationServiceUrl,A,e);return b.availableLanguages??={},b.availableLanguages["*"]=A,r(d)}catch(A){return console.error(A),N([e+".nls"],r)}}})():N([e+m],r,l=>{if(m===".nls"){console.error("Failed trying to load default language strings",l);return}console.error(`Failed to load message bundle for language ${E}. Falling back to the default language:`,l),N([e+".nls"],r)})}t.load=o}),function(){const H=globalThis.MonacoEnvironment,t=H&&H.baseUrl?H.baseUrl:"../../../";function k(f,M){if(H?.createTrustedTypesPolicy)try{return H.createTrustedTypesPolicy(f,M)}catch(h){console.warn(h);return}try{return self.trustedTypes?.createPolicy(f,M)}catch(h){console.warn(h);return}}const D=k("amdLoader",{createScriptURL:f=>f,createScript:(f,...M)=>{const h=M.slice(0,-1).join(","),o=M.pop().toString();return`(function anonymous(${h}) { ${o}
})`}});function i(){try{return(D?globalThis.eval(D.createScript("","true")):new Function("true")).call(globalThis),!0}catch{return!1}}function a(){return new Promise((f,M)=>{if(typeof globalThis.define=="function"&&globalThis.define.amd)return f();const h=t+"vs/loader.js";if(!(/^((http:)|(https:)|(file:))/.test(h)&&h.substring(0,globalThis.origin.length)!==globalThis.origin)&&i()){fetch(h).then(e=>{if(e.status!==200)throw new Error(e.statusText);return e.text()}).then(e=>{e=`${e}
//# sourceURL=${h}`,(D?globalThis.eval(D.createScript("",e)):new Function(e)).call(globalThis),f()}).then(void 0,M);return}D?importScripts(D.createScriptURL(h)):importScripts(h),f()})}function v(){require.config({baseUrl:t,catchError:!0,trustedTypesPolicy:D,amdModulesPattern:/^vs\//})}function c(f){a().then(()=>{v(),require([f],function(M){setTimeout(function(){const h=M.create((o,e)=>{globalThis.postMessage(o,e)},null);for(globalThis.onmessage=o=>h.onmessage(o.data,o.ports);u.length>0;){const o=u.shift();h.onmessage(o.data,o.ports)}},0)})})}typeof globalThis.define=="function"&&globalThis.define.amd&&v();let s=!0;const u=[];globalThis.onmessage=f=>{if(!s){u.push(f);return}s=!1,c(f.data)}}(),Y(Z[27],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8r=t.$7r=t.$6r=t.$5r=void 0;function k(c,s){const u=Math.pow(10,s);return Math.round(c*u)/u}class D{constructor(s,u,f,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,s))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=k(Math.max(Math.min(1,M),0),3)}static equals(s,u){return s.r===u.r&&s.g===u.g&&s.b===u.b&&s.a===u.a}}t.$5r=D;class i{constructor(s,u,f,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=k(Math.max(Math.min(1,u),0),3),this.l=k(Math.max(Math.min(1,f),0),3),this.a=k(Math.max(Math.min(1,M),0),3)}static equals(s,u){return s.h===u.h&&s.s===u.s&&s.l===u.l&&s.a===u.a}static fromRGBA(s){const u=s.r/255,f=s.g/255,M=s.b/255,h=s.a,o=Math.max(u,f,M),e=Math.min(u,f,M);let N=0,y=0;const R=(e+o)/2,b=o-e;if(b>0){switch(y=Math.min(R<=.5?b/(2*R):b/(2-2*R),1),o){case u:N=(f-M)/b+(f<M?6:0);break;case f:N=(M-u)/b+2;break;case M:N=(u-f)/b+4;break}N*=60,N=Math.round(N)}return new i(N,y,R,h)}static i(s,u,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?s+(u-s)*6*f:f<1/2?u:f<2/3?s+(u-s)*(2/3-f)*6:s}static toRGBA(s){const u=s.h/360,{s:f,l:M,a:h}=s;let o,e,N;if(f===0)o=e=N=M;else{const y=M<.5?M*(1+f):M+f-M*f,R=2*M-y;o=i.i(R,y,u+1/3),e=i.i(R,y,u),N=i.i(R,y,u-1/3)}return new D(Math.round(o*255),Math.round(e*255),Math.round(N*255),h)}}t.$6r=i;class a{constructor(s,u,f,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,s),0)|0,this.s=k(Math.max(Math.min(1,u),0),3),this.v=k(Math.max(Math.min(1,f),0),3),this.a=k(Math.max(Math.min(1,M),0),3)}static equals(s,u){return s.h===u.h&&s.s===u.s&&s.v===u.v&&s.a===u.a}static fromRGBA(s){const u=s.r/255,f=s.g/255,M=s.b/255,h=Math.max(u,f,M),o=Math.min(u,f,M),e=h-o,N=h===0?0:e/h;let y;return e===0?y=0:h===u?y=((f-M)/e%6+6)%6:h===f?y=(M-u)/e+2:y=(u-f)/e+4,new a(Math.round(y*60),N,h,s.a)}static toRGBA(s){const{h:u,s:f,v:M,a:h}=s,o=M*f,e=o*(1-Math.abs(u/60%2-1)),N=M-o;let[y,R,b]=[0,0,0];return u<60?(y=o,R=e):u<120?(y=e,R=o):u<180?(R=o,b=e):u<240?(R=e,b=o):u<300?(y=e,b=o):u<=360&&(y=o,b=e),y=Math.round((y+N)*255),R=Math.round((R+N)*255),b=Math.round((b+N)*255),new D(y,R,b,h)}}t.$7r=a;class v{static fromHex(s){return v.Format.CSS.parseHex(s)||v.red}static equals(s,u){return!s&&!u?!0:!s||!u?!1:s.equals(u)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:a.fromRGBA(this.rgba)}constructor(s){if(s)if(s instanceof D)this.rgba=s;else if(s instanceof i)this.i=s,this.rgba=i.toRGBA(s);else if(s instanceof a)this.j=s,this.rgba=a.toRGBA(s);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(s){return!!s&&D.equals(this.rgba,s.rgba)&&i.equals(this.hsla,s.hsla)&&a.equals(this.hsva,s.hsva)}getRelativeLuminance(){const s=v.k(this.rgba.r),u=v.k(this.rgba.g),f=v.k(this.rgba.b),M=.2126*s+.7152*u+.0722*f;return k(M,4)}static k(s){const u=s/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(s){const u=this.getRelativeLuminance(),f=s.getRelativeLuminance();return u>f?(u+.05)/(f+.05):(f+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(s){const u=this.getRelativeLuminance(),f=s.getRelativeLuminance();return u>f}isDarkerThan(s){const u=this.getRelativeLuminance(),f=s.getRelativeLuminance();return u<f}lighten(s){return new v(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*s,this.hsla.a))}darken(s){return new v(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*s,this.hsla.a))}transparent(s){const{r:u,g:f,b:M,a:h}=this.rgba;return new v(new D(u,f,M,h*s))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new v(new D(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(s){const u=s.rgba,f=this.rgba.a,M=u.a,h=f+M*(1-f);if(h<1e-6)return v.transparent;const o=this.rgba.r*f/h+u.r*M*(1-f)/h,e=this.rgba.g*f/h+u.g*M*(1-f)/h,N=this.rgba.b*f/h+u.b*M*(1-f)/h;return new v(new D(o,e,N,h))}makeOpaque(s){if(this.isOpaque()||s.rgba.a!==1)return this;const{r:u,g:f,b:M,a:h}=this.rgba;return new v(new D(s.rgba.r-h*(s.rgba.r-u),s.rgba.g-h*(s.rgba.g-f),s.rgba.b-h*(s.rgba.b-M),1))}flatten(...s){const u=s.reduceRight((f,M)=>v.o(M,f));return v.o(this,u)}static o(s,u){const f=1-s.rgba.a;return new v(new D(f*u.rgba.r+s.rgba.a*s.rgba.r,f*u.rgba.g+s.rgba.a*s.rgba.g,f*u.rgba.b+s.rgba.a*s.rgba.b))}toString(){return this.u||(this.u=v.Format.CSS.format(this)),this.u}static getLighterColor(s,u,f){if(s.isLighterThan(u))return s;f=f||.5;const M=s.getRelativeLuminance(),h=u.getRelativeLuminance();return f=f*(h-M)/h,s.lighten(f)}static getDarkerColor(s,u,f){if(s.isDarkerThan(u))return s;f=f||.5;const M=s.getRelativeLuminance(),h=u.getRelativeLuminance();return f=f*(M-h)/M,s.darken(f)}static{this.white=new v(new D(255,255,255,1))}static{this.black=new v(new D(0,0,0,1))}static{this.red=new v(new D(255,0,0,1))}static{this.blue=new v(new D(0,0,255,1))}static{this.green=new v(new D(0,255,0,1))}static{this.cyan=new v(new D(0,255,255,1))}static{this.lightgrey=new v(new D(211,211,211,1))}static{this.transparent=new v(new D(0,0,0,0))}}t.$8r=v,function(c){let s;(function(u){let f;(function(M){function h(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:c.Format.CSS.formatRGBA(r)}M.formatRGB=h;function o(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}M.formatRGBA=o;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:c.Format.CSS.formatHSLA(r)}M.formatHSL=e;function N(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}M.formatHSLA=N;function y(r){const l=r.toString(16);return l.length!==2?"0"+l:l}function R(r){return`#${y(r.rgba.r)}${y(r.rgba.g)}${y(r.rgba.b)}`}M.formatHex=R;function b(r,l=!1){return l&&r.rgba.a===1?c.Format.CSS.formatHex(r):`#${y(r.rgba.r)}${y(r.rgba.g)}${y(r.rgba.b)}${y(Math.round(r.rgba.a*255))}`}M.formatHexA=b;function E(r){return r.isOpaque()?c.Format.CSS.formatHex(r):c.Format.CSS.formatRGBA(r)}M.format=E;function g(r){const l=r.length;if(l===0||r.charCodeAt(0)!==35)return null;if(l===7){const A=16*m(r.charCodeAt(1))+m(r.charCodeAt(2)),d=16*m(r.charCodeAt(3))+m(r.charCodeAt(4)),$=16*m(r.charCodeAt(5))+m(r.charCodeAt(6));return new c(new D(A,d,$,1))}if(l===9){const A=16*m(r.charCodeAt(1))+m(r.charCodeAt(2)),d=16*m(r.charCodeAt(3))+m(r.charCodeAt(4)),$=16*m(r.charCodeAt(5))+m(r.charCodeAt(6)),w=16*m(r.charCodeAt(7))+m(r.charCodeAt(8));return new c(new D(A,d,$,w/255))}if(l===4){const A=m(r.charCodeAt(1)),d=m(r.charCodeAt(2)),$=m(r.charCodeAt(3));return new c(new D(16*A+A,16*d+d,16*$+$))}if(l===5){const A=m(r.charCodeAt(1)),d=m(r.charCodeAt(2)),$=m(r.charCodeAt(3)),w=m(r.charCodeAt(4));return new c(new D(16*A+A,16*d+d,16*$+$,(16*w+w)/255))}return null}M.parseHex=g;function m(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=u.CSS||(u.CSS={}))})(s=c.Format||(c.Format={}))}(v||(t.$8r=v={}))}),Y(Z[28],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ju=void 0;class k{constructor(i,a,v,c){this.originalStart=i,this.originalLength=a,this.modifiedStart=v,this.modifiedLength=c}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$ju=k}),Y(Z[3],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.$Y=t.$X=t.setUnexpectedErrorHandler=t.$V=t.$U=void 0;class k{constructor(){this.b=[],this.a=function(l){setTimeout(()=>{throw l.stack?g.isErrorNoTelemetry(l)?new g(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.b.push(l),()=>{this.d(l)}}c(l){this.b.forEach(A=>{A(l)})}d(l){this.b.splice(this.b.indexOf(l),1)}setUnexpectedErrorHandler(l){this.a=l}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(l){this.a(l),this.c(l)}onUnexpectedExternalError(l){this.a(l)}}t.$U=k,t.$V=new k;function D(r){t.$V.setUnexpectedErrorHandler(r)}t.setUnexpectedErrorHandler=D;function i(r){if(!r||typeof r!="object")return!1;const l=r;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}t.$X=i;function a(r){u(r)||t.$V.onUnexpectedError(r)}t.$Y=a;function v(r){u(r)||t.$V.onUnexpectedExternalError(r)}t.$Z=v;function c(r){if(r instanceof Error){const{name:l,message:A}=r,d=r.stacktrace||r.stack;return{$isError:!0,name:l,message:A,stack:d,noTelemetry:g.isErrorNoTelemetry(r)}}return r}t.$1=c;const s="Canceled";function u(r){return r instanceof f?!0:r instanceof Error&&r.name===s&&r.message===s}t.$2=u;class f extends Error{constructor(){super(s),this.name=this.message}}t.$3=f;function M(){const r=new Error(s);return r.name=r.message,r}t.$4=M;function h(r){return r?new Error(`Illegal argument: ${r}`):new Error("Illegal argument")}t.$5=h;function o(r){return r?new Error(`Illegal state: ${r}`):new Error("Illegal state")}t.$6=o;function e(r){return r?new Error(`readonly property '${r} cannot be changed'`):new Error("readonly property cannot be changed")}t.$7=e;function N(r){const l=new Error(`${r} has been disposed`);return l.name="DISPOSED",l}t.$8=N;function y(r){return r?r.message?r.message:r.stack?r.stack.split(`
`)[0]:String(r):"Error"}t.$9=y;class R extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}t.$0=R;class b extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}t.$$=b;class E extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$_=E;class g extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof g)return l;const A=new g;return A.message=l.message,A.stack=l.stack,A}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}t.$ab=g;class m extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}t.$bb=m}),Y(Z[29],K([0,1,3]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.CompareResult=t.$Mf=t.$Lf=t.$Kf=t.$Jf=t.$If=t.$Hf=t.$Gf=t.$Ff=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.top=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=void 0;function D(S,q=0){return S[S.length-(1+q)]}t.$$e=D;function i(S){if(S.length===0)throw new Error("Invalid tail call");return[S.slice(0,S.length-1),S[S.length-1]]}t.$_e=i;function a(S,q,B=(V,z)=>V===z){if(S===q)return!0;if(!S||!q||S.length!==q.length)return!1;for(let V=0,z=S.length;V<z;V++)if(!B(S[V],q[V]))return!1;return!0}t.$af=a;function v(S,q){const B=S.length-1;q<B&&(S[q]=S[B]),S.pop()}t.$bf=v;function c(S,q,B){return s(S.length,V=>B(S[V],q))}t.$cf=c;function s(S,q){let B=0,V=S-1;for(;B<=V;){const z=(B+V)/2|0,J=q(z);if(J<0)B=z+1;else if(J>0)V=z-1;else return z}return-(B+1)}t.$df=s;function u(S,q){let B=0,V=S.length;if(V===0)return 0;for(;B<V;){const z=Math.floor((B+V)/2);q(S[z])?V=z:B=z+1}return B}t.$ef=u;function f(S,q,B){if(S=S|0,S>=q.length)throw new TypeError("invalid index");const V=q[Math.floor(q.length*Math.random())],z=[],J=[],te=[];for(const se of q){const fe=B(se,V);fe<0?z.push(se):fe>0?J.push(se):te.push(se)}return S<z.length?f(S,z,B):S<z.length+te.length?te[0]:f(S-(z.length+te.length),J,B)}t.$ff=f;function M(S,q){const B=[];let V;for(const z of S.slice(0).sort(q))!V||q(V[0],z)!==0?(V=[z],B.push(V)):V.push(z);return B}t.$gf=M;function h(S,q,B){const V=[];function z(se,fe,he){if(fe===0&&he.length===0)return;const $e=V[V.length-1];$e&&$e.start+$e.deleteCount===se?($e.deleteCount+=fe,$e.toInsert.push(...he)):V.push({start:se,deleteCount:fe,toInsert:he})}let J=0,te=0;for(;;){if(J===S.length){z(J,0,q.slice(te));break}if(te===q.length){z(J,S.length-J,[]);break}const se=S[J],fe=q[te],he=B(se,fe);he===0?(J+=1,te+=1):he<0?(z(J,1,[]),J+=1):he>0&&(z(J,0,[fe]),te+=1)}return V}t.$hf=h;function o(S,q,B){const V=h(S,q,B),z=[],J=[];for(const te of V)z.push(...S.slice(te.start,te.start+te.deleteCount)),J.push(...te.toInsert);return{removed:z,added:J}}t.$if=o;function e(S,q,B){if(B===0)return[];const V=S.slice(0,B).sort(q);return y(S,q,V,B,S.length),V}t.top=e;function N(S,q,B,V,z){return B===0?Promise.resolve([]):new Promise((J,te)=>{(async()=>{const se=S.length,fe=S.slice(0,B).sort(q);for(let he=B,$e=Math.min(B+V,se);he<se;he=$e,$e=Math.min($e+V,se)){if(he>B&&await new Promise(ye=>setTimeout(ye)),z&&z.isCancellationRequested)throw new k.$3;y(S,q,fe,he,$e)}return fe})().then(J,te)})}t.$kf=N;function y(S,q,B,V,z){for(const J=B.length;V<z;V++){const te=S[V];if(q(te,B[J-1])<0){B.pop();const se=u(B,fe=>q(te,fe)<0);B.splice(se,0,te)}}}function R(S){return S.filter(q=>!!q)}t.$lf=R;function b(S){let q=0;for(let B=0;B<S.length;B++)S[B]&&(S[q]=S[B],q+=1);S.length=q}t.$mf=b;function E(S,q,B){S.splice(B,0,S.splice(q,1)[0])}t.$nf=E;function g(S){return!Array.isArray(S)||S.length===0}t.$of=g;function m(S){return Array.isArray(S)&&S.length>0}t.$pf=m;function r(S,q=B=>B){const B=new Set;return S.filter(V=>{const z=q(V);return B.has(z)?!1:(B.add(z),!0)})}t.$qf=r;function l(S){const q=new Set;return B=>{const V=S(B);return q.has(V)?!1:(q.add(V),!0)}}t.$rf=l;function A(S,q){const B=d(S,q);if(B!==-1)return S[B]}t.$sf=A;function d(S,q){for(let B=S.length-1;B>=0;B--){const V=S[B];if(q(V))return B}return-1}t.$tf=d;function $(S,q){return S.length>0?S[0]:q}t.$uf=$;function w(S,q){return S.length>0?S[S.length-1]:q}t.$vf=w;function L(S,q,B=(V,z)=>V===z){let V=0;for(let z=0,J=Math.min(S.length,q.length);z<J&&B(S[z],q[z]);z++)V++;return V}t.$wf=L;function p(S){return[].concat(...S)}t.$xf=p;function F(S,q){let B=typeof q=="number"?S:0;typeof q=="number"?B=S:(B=0,q=S);const V=[];if(B<=q)for(let z=B;z<q;z++)V.push(z);else for(let z=B;z>q;z--)V.push(z);return V}t.$yf=F;function P(S,q,B){return S.reduce((V,z)=>(V[q(z)]=B?B(z):z,V),Object.create(null))}t.$zf=P;function I(S,q){return S.push(q),()=>O(S,q)}t.$Af=I;function O(S,q){const B=S.indexOf(q);if(B>-1)return S.splice(B,1),q}t.$Bf=O;function U(S,q,B){const V=S.slice(0,q),z=S.slice(q);return V.concat(B,z)}t.$Cf=U;function C(S,q){let B;if(typeof q=="number"){let V=q;B=()=>{const z=Math.sin(V++)*179426549;return z-Math.floor(z)}}else B=Math.random;for(let V=S.length-1;V>0;V-=1){const z=Math.floor(B()*(V+1)),J=S[V];S[V]=S[z],S[z]=J}}t.$Df=C;function _(S,q){const B=S.indexOf(q);B>-1&&(S.splice(B,1),S.unshift(q))}t.$Ef=_;function W(S,q){const B=S.indexOf(q);B>-1&&(S.splice(B,1),S.push(q))}t.$Ff=W;function G(S,q){for(const B of q)S.push(B)}t.$Gf=G;function X(S,q){return Array.isArray(S)?S.map(q):q(S)}t.$Hf=X;function ne(S){return Array.isArray(S)?S:[S]}t.$If=ne;function n(S){return S[Math.floor(Math.random()*S.length)]}t.$Jf=n;function oe(S,q){for(const B of S){const V=q(B);if(V!==void 0)return V}}t.$Kf=oe;function ce(S,q,B){const V=ge(S,q),z=S.length,J=B.length;S.length=z+J;for(let te=z-1;te>=V;te--)S[te+J]=S[te];for(let te=0;te<J;te++)S[te+V]=B[te]}t.$Lf=ce;function me(S,q,B,V){const z=ge(S,q),J=S.splice(z,B);return ce(S,z,V),J}t.$Mf=me;function ge(S,q){return q<0?Math.max(q+S.length,0):Math.min(q,S.length)}var ve;(function(S){function q(z){return z<0}S.isLessThan=q;function B(z){return z>0}S.isGreaterThan=B;function V(z){return z===0}S.isNeitherLessOrGreaterThan=V,S.greaterThan=1,S.lessThan=-1,S.neitherLessOrGreaterThan=0})(ve||(t.CompareResult=ve={}));function Le(S,q){return(B,V)=>q(S(B),S(V))}t.$Nf=Le;function Ae(...S){return(q,B)=>{for(const V of S){const z=V(q,B);if(!ve.isNeitherLessOrGreaterThan(z))return z}return ve.neitherLessOrGreaterThan}}t.$Of=Ae;const Ne=(S,q)=>S-q;t.$Pf=Ne;function Fe(S,q){if(S.length===0)return;let B=S[0];for(let V=1;V<S.length;V++){const z=S[V];q(z,B)>0&&(B=z)}return B}t.$Qf=Fe;function le(S,q){if(S.length===0)return;let B=S[0];for(let V=1;V<S.length;V++){const z=S[V];q(z,B)>=0&&(B=z)}return B}t.$Rf=le;function ae(S,q){return Fe(S,(B,V)=>-q(B,V))}t.$Sf=ae;class ie{constructor(q){this.f=q,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(q){let B=this.c;for(;B<this.f.length&&q(this.f[B]);)B++;const V=B===this.c?null:this.f.slice(this.c,B);return this.c=B,V}takeFromEndWhile(q){let B=this.d;for(;B>=0&&q(this.f[B]);)B--;const V=B===this.d?null:this.f.slice(B+1,this.d+1);return this.d=B,V}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const q=this.f[this.c];return this.c++,q}removeLast(){const q=this.f[this.d];return this.d--,q}takeCount(q){const B=this.f.slice(this.c,this.c+q);return this.c+=q,B}}t.$Tf=ie;class ue{static{this.empty=new ue(q=>{})}constructor(q){this.iterate=q}forEach(q){this.iterate(B=>(q(B),!0))}toArray(){const q=[];return this.iterate(B=>(q.push(B),!0)),q}filter(q){return new ue(B=>this.iterate(V=>q(V)?B(V):!0))}map(q){return new ue(B=>this.iterate(V=>B(q(V))))}some(q){let B=!1;return this.iterate(V=>(B=q(V),!B)),B}findFirst(q){let B;return this.iterate(V=>q(V)?(B=V,!1):!0),B}findLast(q){let B;return this.iterate(V=>(q(V)&&(B=V),!0)),B}findLastMaxBy(q){let B,V=!0;return this.iterate(z=>((V||ve.isGreaterThan(q(z,B)))&&(V=!1,B=z),!0)),B}}t.$Uf=ue}),Y(Z[10],K([0,1,3]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qc=t.$pc=t.$oc=t.$nc=t.ok=void 0;function D(s,u){if(!s)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}t.ok=D;function i(s,u="Unreachable"){throw new Error(u)}t.$nc=i;function a(s){if(!s)throw new k.$bb("Assertion Failed")}t.$oc=a;function v(s){if(!s()){debugger;s(),(0,k.$Y)(new k.$bb("Assertion Failed"))}}t.$pc=v;function c(s,u){let f=0;for(;f<s.length-1;){const M=s[f],h=s[f+1];if(!u(M,h))return!1;f++}return!0}t.$qc=c}),Y(Z[15],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=void 0;function k(D){const i=this;let a=!1,v;return function(){return a||(a=!0,v=D.apply(i,arguments)),v}}t.$cb=k}),Y(Z[16],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var k;(function(D){function i(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}D.is=i;const a=Object.freeze([]);function v(){return a}D.empty=v;function*c(g){yield g}D.single=c;function s(g){return i(g)?g:c(g)}D.wrap=s;function u(g){return g||a}D.from=u;function f(g){return!g||g[Symbol.iterator]().next().done===!0}D.isEmpty=f;function M(g){return g[Symbol.iterator]().next().value}D.first=M;function h(g,m){for(const r of g)if(m(r))return!0;return!1}D.some=h;function o(g,m){for(const r of g)if(m(r))return r}D.find=o;function*e(g,m){for(const r of g)m(r)&&(yield r)}D.filter=e;function*N(g,m){let r=0;for(const l of g)yield m(l,r++)}D.map=N;function*y(...g){for(const m of g)for(const r of m)yield r}D.concat=y;function R(g,m,r){let l=r;for(const A of g)l=m(l,A);return l}D.reduce=R;function*b(g,m,r=g.length){for(m<0&&(m+=g.length),r<0?r+=g.length:r>g.length&&(r=g.length);m<r;m++)yield g[m]}D.slice=b;function E(g,m=Number.POSITIVE_INFINITY){const r=[];if(m===0)return[r,g];const l=g[Symbol.iterator]();for(let A=0;A<m;A++){const d=l.next();if(d.done)return[r,D.empty()];r.push(d.value)}return[r,{[Symbol.iterator](){return l}}]}D.consume=E})(k||(t.Iterable=k={}))}),Y(Z[30],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iq=t.KeyMod=t.KeyCodeUtils=t.$hq=t.$gq=t.$fq=t.$eq=t.$dq=t.ScanCode=t.KeyCode=void 0;var k;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(k||(t.KeyCode=k={}));var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(D||(t.ScanCode=D={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(N,y){this._keyCodeToStr[N]=y,this._strToKeyCode[y.toLowerCase()]=N}keyCodeToStr(N){return this._keyCodeToStr[N]}strToKeyCode(N){return this._strToKeyCode[N.toLowerCase()]||0}}const a=new i,v=new i,c=new i;t.$dq=new Array(230),t.$eq={};const s=[],u=Object.create(null),f=Object.create(null);t.$fq={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>u[e]||0,toString:e=>s[e]||"None"},t.$gq=[],t.$hq=[];for(let e=0;e<=193;e++)t.$gq[e]=-1;for(let e=0;e<=132;e++)t.$hq[e]=-1;(function(){const e="",N=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],y=[],R=[];for(const b of N){const[E,g,m,r,l,A,d,$,w]=b;if(R[g]||(R[g]=!0,s[g]=m,u[m]=g,f[m.toLowerCase()]=g,E&&(t.$gq[g]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$hq[r]=g))),!y[r]){if(y[r]=!0,!l)throw new Error(`String representation missing for key code ${r} around scan code ${m}`);a.define(r,l),v.define(r,$||l),c.define(r,w||$||l)}A&&(t.$dq[A]=r),d&&(t.$eq[d]=r)}t.$hq[3]=46})();var M;(function(e){function N(m){return a.keyCodeToStr(m)}e.toString=N;function y(m){return a.strToKeyCode(m)}e.fromString=y;function R(m){return v.keyCodeToStr(m)}e.toUserSettingsUS=R;function b(m){return c.keyCodeToStr(m)}e.toUserSettingsGeneral=b;function E(m){return v.strToKeyCode(m)||c.strToKeyCode(m)}e.fromUserSettings=E;function g(m){if(m>=98&&m<=113)return null;switch(m){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return a.keyCodeToStr(m)}e.toElectronAccelerator=g})(M||(t.KeyCodeUtils=M={}));var h;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(h||(t.KeyMod=h={}));function o(e,N){const y=(N&65535)<<16>>>0;return(e|y)>>>0}t.$iq=o}),Y(Z[31],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$T=void 0;class k{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$T=k}),Y(Z[7],K([0,1,15,16]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tb=t.$sb=t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=t.$eb=t.$db=void 0;const i=!1;let a=null;function v(w){a=w}if(t.$db=v,i){const w="__is_disposable_tracked__";v(new class{trackDisposable(L){const p=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[w]||console.log(p)},3e3)}setParent(L,p){if(L&&L!==b.None)try{L[w]=!0}catch{}}markAsDisposed(L){if(L&&L!==b.None)try{L[w]=!0}catch{}}markAsSingleton(L){}})}function c(w){return a?.trackDisposable(w),w}function s(w){a?.markAsDisposed(w)}function u(w,L){a?.setParent(w,L)}function f(w,L){if(a)for(const p of w)a.setParent(p,L)}function M(w){return a?.markAsSingleton(w),w}t.$eb=M;function h(w){return typeof w.dispose=="function"&&w.dispose.length===0}t.$fb=h;function o(w){if(D.Iterable.is(w)){const L=[];for(const p of w)if(p)try{p.dispose()}catch(F){L.push(F)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(w)?[]:w}else if(w)return w.dispose(),w}t.$gb=o;function e(w){for(const L of w)h(L)&&L.dispose();return[]}t.$hb=e;function N(...w){const L=y(()=>o(w));return f(w,L),L}t.$ib=N;function y(w){const L=c({dispose:(0,k.$cb)(()=>{s(L),w()})});return L}t.$jb=y;class R{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,c(this)}dispose(){this.g||(s(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return u(L,this),this.g?R.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}}t.$kb=R;class b{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new R,c(this),u(this.q,this)}dispose(){s(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}t.$lb=b;class E{constructor(){this.b=!1,c(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&u(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,s(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&u(L,null),L}}t.$mb=E;class g{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$nb=g;class m{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,c(this)}set(L){let p=L;return this.unset=()=>p=void 0,this.isset=()=>p!==void 0,this.dispose=()=>{p&&(p(),p=void 0,s(this))},this}}t.$ob=m;class r{constructor(){this.a=new Map}acquire(L,...p){let F=this.a.get(L);F||(F={counter:0,object:this.b(L,...p)},this.a.set(L,F));const{object:P}=F,I=(0,k.$cb)(()=>{--F.counter===0&&(this.c(L,F.object),this.a.delete(L))});return F.counter++,{object:P,dispose:I}}}t.$pb=r;class l{constructor(L){this.a=L}async acquire(L,...p){const F=this.a.acquire(L,...p);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(P){throw F.dispose(),P}}}t.$qb=l;class A{constructor(L){this.object=L}dispose(){}}t.$rb=A;function d(w){const L=new R;try{w(L)}finally{L.dispose()}}t.$sb=d;class ${constructor(){this.a=new Map,this.b=!1,c(this)}dispose(){s(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get(L){return this.a.get(L)}set(L,p,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(L)?.dispose(),this.a.set(L,p)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$tb=$}),Y(Z[17],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lc=void 0;class k{static{this.Undefined=new k(void 0)}constructor(a){this.element=a,this.next=k.Undefined,this.prev=k.Undefined}}class D{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let a=this.a;for(;a!==k.Undefined;){const v=a.next;a.prev=k.Undefined,a.next=k.Undefined,a=v}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(a){return this.d(a,!1)}push(a){return this.d(a,!0)}d(a,v){const c=new k(a);if(this.a===k.Undefined)this.a=c,this.b=c;else if(v){const u=this.b;this.b=c,c.prev=u,u.next=c}else{const u=this.a;this.a=c,c.next=u,u.prev=c}this.c+=1;let s=!1;return()=>{s||(s=!0,this.e(c))}}shift(){if(this.a!==k.Undefined){const a=this.a.element;return this.e(this.a),a}}pop(){if(this.b!==k.Undefined){const a=this.b.element;return this.e(this.b),a}}e(a){if(a.prev!==k.Undefined&&a.next!==k.Undefined){const v=a.prev;v.next=a.next,a.next.prev=v}else a.prev===k.Undefined&&a.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):a.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):a.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let a=this.a;for(;a!==k.Undefined;)yield a.element,a=a.next}}t.$lc=D}),Y(Z[18],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class D{static create(a){return new D(a)}constructor(a){this.c=k&&a===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$3c=D}),Y(Z[8],K([0,1,3,15,7,17,18]),function(H,t,k,D,i,a,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cd=t.$bd=t.$ad=t.$_c=t.$$c=t.$0c=t.$9c=t.$8c=t.$7c=t.$6c=t.$5c=t.Event=void 0;const c=!1,s=!1;var u;(function(p){p.None=()=>i.$lb.None;function F(S){if(s){const{onDidAddListener:q}=S,B=e.create();let V=0;S.onDidAddListener=()=>{++V===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),B.print()),q?.()}}}function P(S,q){return ne(S,()=>{},0,void 0,!0,void 0,q)}p.defer=P;function I(S){return(q,B=null,V)=>{let z=!1,J;return J=S(te=>{if(!z)return J?J.dispose():z=!0,q.call(B,te)},null,V),z&&J.dispose(),J}}p.once=I;function O(S,q,B){return X((V,z=null,J)=>S(te=>V.call(z,q(te)),null,J),B)}p.map=O;function U(S,q,B){return X((V,z=null,J)=>S(te=>{q(te),V.call(z,te)},null,J),B)}p.forEach=U;function C(S,q,B){return X((V,z=null,J)=>S(te=>q(te)&&V.call(z,te),null,J),B)}p.filter=C;function _(S){return S}p.signal=_;function W(...S){return(q,B=null,V)=>(0,i.$ib)(...S.map(z=>z(J=>q.call(B,J),null,V)))}p.any=W;function G(S,q,B,V){let z=B;return O(S,J=>(z=q(z,J),z),V)}p.reduce=G;function X(S,q){let B;const V={onWillAddFirstListener(){B=S(z.fire,z)},onDidRemoveLastListener(){B?.dispose()}};q||F(V);const z=new E(V);return q?.add(z),z.event}function ne(S,q,B=100,V=!1,z=!1,J,te){let se,fe,he,$e=0,ye;const Ie={leakWarningThreshold:J,onWillAddFirstListener(){se=S(Se=>{$e++,fe=q(fe,Se),V&&!he&&(ke.fire(fe),fe=void 0),ye=()=>{const Ue=fe;fe=void 0,he=void 0,(!V||$e>1)&&ke.fire(Ue),$e=0},typeof B=="number"?(clearTimeout(he),he=setTimeout(ye,B)):he===void 0&&(he=0,queueMicrotask(ye))})},onWillRemoveListener(){z&&$e>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,se.dispose()}};te||F(Ie);const ke=new E(Ie);return te?.add(ke),ke.event}p.debounce=ne;function n(S,q=0,B){return p.debounce(S,(V,z)=>V?(V.push(z),V):[z],q,void 0,!0,void 0,B)}p.accumulate=n;function oe(S,q=(V,z)=>V===z,B){let V=!0,z;return C(S,J=>{const te=V||!q(J,z);return V=!1,z=J,te},B)}p.latch=oe;function ce(S,q,B){return[p.filter(S,q,B),p.filter(S,V=>!q(V),B)]}p.split=ce;function me(S,q=!1,B=[]){let V=B.slice(),z=S(se=>{V?V.push(se):te.fire(se)});const J=()=>{V?.forEach(se=>te.fire(se)),V=null},te=new E({onWillAddFirstListener(){z||(z=S(se=>te.fire(se)))},onDidAddFirstListener(){V&&(q?setTimeout(J):J())},onDidRemoveLastListener(){z&&z.dispose(),z=null}});return te.event}p.buffer=me;class ge{constructor(q){this.event=q,this.d=new i.$kb}map(q){return new ge(O(this.event,q,this.d))}forEach(q){return new ge(U(this.event,q,this.d))}filter(q){return new ge(C(this.event,q,this.d))}reduce(q,B){return new ge(G(this.event,q,B,this.d))}latch(){return new ge(oe(this.event,void 0,this.d))}debounce(q,B=100,V=!1,z=!1,J){return new ge(ne(this.event,q,B,V,z,J,this.d))}on(q,B,V){return this.event(q,B,V)}once(q,B,V){return I(this.event)(q,B,V)}dispose(){this.d.dispose()}}function ve(S){return new ge(S)}p.chain=ve;function Le(S,q,B=V=>V){const V=(...se)=>te.fire(B(...se)),z=()=>S.on(q,V),J=()=>S.removeListener(q,V),te=new E({onWillAddFirstListener:z,onDidRemoveLastListener:J});return te.event}p.fromNodeEventEmitter=Le;function Ae(S,q,B=V=>V){const V=(...se)=>te.fire(B(...se)),z=()=>S.addEventListener(q,V),J=()=>S.removeEventListener(q,V),te=new E({onWillAddFirstListener:z,onDidRemoveLastListener:J});return te.event}p.fromDOMEventEmitter=Ae;function Ne(S){return new Promise(q=>I(S)(q))}p.toPromise=Ne;function Fe(S,q){return q(void 0),S(B=>q(B))}p.runAndSubscribe=Fe;function le(S,q){let B=null;function V(J){B?.dispose(),B=new i.$kb,q(J,B)}V(void 0);const z=S(J=>V(J));return(0,i.$jb)(()=>{z.dispose(),B?.dispose()})}p.runAndSubscribeWithStore=le;class ae{constructor(q,B){this._observable=q,this.d=0,this.f=!1;const V={onWillAddFirstListener:()=>{q.addObserver(this)},onDidRemoveLastListener:()=>{q.removeObserver(this)}};B||F(V),this.emitter=new E(V),B&&B.add(this.emitter)}beginUpdate(q){this.d++}handlePossibleChange(q){}handleChange(q,B){this.f=!0}endUpdate(q){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function ie(S,q){return new ae(S,q).emitter.event}p.fromObservable=ie;function ue(S){return q=>{let B=0,V=!1;const z={beginUpdate(){B++},endUpdate(){B--,B===0&&(S.reportChanges(),V&&(V=!1,q()))},handlePossibleChange(){},handleChange(){V=!0}};return S.addObserver(z),S.reportChanges(),{dispose(){S.removeObserver(z)}}}}p.fromObservableLight=ue})(u||(t.Event=u={}));class f{static{this.all=new Set}static{this.d=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${f.d++}`,f.all.add(this)}start(F){this.f=new v.$3c,this.listenerCount=F}stop(){if(this.f){const F=this.f.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.f=void 0}}}t.$5c=f;let M=-1;function h(p){const F=M;return M=p,{dispose(){M=F}}}t.$6c=h;class o{constructor(F,P=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=P,this.f=0}dispose(){this.d?.clear()}check(F,P){const I=this.threshold;if(I<=0||P<I)return;this.d||(this.d=new Map);const O=this.d.get(F.value)||0;if(this.d.set(F.value,O+1),this.f-=1,this.f<=0){this.f=I*.5;let U,C=0;for(const[_,W]of this.d)(!U||C<W)&&(U=_,C=W);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${C}):`),console.warn(U)}return()=>{const U=this.d.get(F.value)||0;this.d.set(F.value,U-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let N=0;class y{constructor(F){this.value=F,this.id=N++}}const R=2,b=(p,F)=>{if(p instanceof y)F(p);else for(let P=0;P<p.length;P++){const I=p[P];I&&F(I)}};class E{constructor(F){this.u=0,this.d=F,this.f=M>0||this.d?.leakWarningThreshold?new o(this.d?.leakWarningThreshold??M):void 0,this.g=this.d?._profName?new f(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(c){const F=this.q;queueMicrotask(()=>{b(F,P=>P.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(F,P,I)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.$lb.None;if(this.j)return i.$lb.None;P&&(F=F.bind(P));const O=new y(F);let U,C;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(O.stack=e.create(),U=this.f.check(O.stack,this.u+1)),c&&(O.stack=C??e.create()),this.q?this.q instanceof y?(this.t??=new m,this.q=[this.q,O]):this.q.push(O):(this.d?.onWillAddFirstListener?.(this),this.q=O,this.d?.onDidAddFirstListener?.(this)),this.u++;const _=(0,i.$jb)(()=>{U?.(),this.v(O)});return I instanceof i.$kb?I.add(_):Array.isArray(I)&&I.push(_),_},this.m}v(F){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const P=this.q,I=P.indexOf(F);if(I===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,P[I]=void 0;const O=this.t.current===this;if(this.u*R<=P.length){let U=0;for(let C=0;C<P.length;C++)P[C]?P[U++]=P[C]:O&&(this.t.end--,U<this.t.i&&this.t.i--);P.length=U}}w(F,P){if(!F)return;const I=this.d?.onListenerError||k.$Y;if(!I){F.value(P);return}try{F.value(P)}catch(O){I(O)}}x(F){const P=F.current.q;for(;F.i<F.end;)this.w(P[F.i++],F.value);F.reset()}fire(F){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof y)this.w(this.q,F);else{const P=this.t;P.enqueue(this,F,this.q.length),this.x(P)}this.g?.stop()}hasListeners(){return this.u>0}}t.$7c=E;const g=()=>new m;t.$8c=g;class m{constructor(){this.i=-1,this.end=0}enqueue(F,P,I){this.i=0,this.end=I,this.current=F,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends E{async fireAsync(F,P,I){if(this.q)for(this.h||(this.h=new a.$lc),b(this.q,O=>this.h.push([O.value,F]));this.h.size>0&&!P.isCancellationRequested;){const[O,U]=this.h.shift(),C=[],_={...U,token:P,waitUntil:W=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");I&&(W=I(W,O)),C.push(W)}};try{O(_)}catch(W){(0,k.$Y)(W);continue}Object.freeze(C),await Promise.allSettled(C).then(W=>{for(const G of W)G.status==="rejected"&&(0,k.$Y)(G.reason)})}}}t.$9c=r;class l extends E{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new a.$lc,this.y=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.y(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.u&&(this.h!==0?this.s.push(F):super.fire(F))}}t.$0c=l;class A extends l{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}t.$$c=A;class d extends E{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(P=>super.fire(P)),this.h=[]}))}}t.$_c=d;class ${constructor(){this.f=!1,this.g=[],this.d=new E({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(F){const P={event:F,listener:null};this.g.push(P),this.f&&this.k(P);const I=()=>{this.f&&this.m(P);const O=this.g.indexOf(P);this.g.splice(O,1)};return(0,i.$jb)((0,D.$cb)(I))}h(){this.f=!0,this.g.forEach(F=>this.k(F))}j(){this.f=!1,this.g.forEach(F=>this.m(F))}k(F){F.listener=F.event(P=>this.d.fire(P))}m(F){F.listener&&F.listener.dispose(),F.listener=null}dispose(){this.d.dispose()}}t.$ad=$;class w{constructor(){this.d=[]}wrapEvent(F){return(P,I,O)=>F(U=>{const C=this.d[this.d.length-1];C?C.push(()=>P.call(I,U)):P.call(I,U)},void 0,O)}bufferEvents(F){const P=[];this.d.push(P);const I=F();return this.d.pop(),P.forEach(O=>O()),I}}t.$bd=w;class L{constructor(){this.d=!1,this.f=u.None,this.g=i.$lb.None,this.h=new E({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(F){this.f=F,this.d&&(this.g.dispose(),this.g=F(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}t.$cd=L}),Y(Z[19],K([0,1,8]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dd=t.CancellationToken=void 0;const D=Object.freeze(function(c,s){const u=setTimeout(c.bind(s),0);return{dispose(){clearTimeout(u)}}});var i;(function(c){function s(u){return u===c.None||u===c.Cancelled||u instanceof a?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}c.isCancellationToken=s,c.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),c.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(i||(t.CancellationToken=i={}));class a{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?D:(this.b||(this.b=new k.$7c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class v{constructor(s){this.a=void 0,this.b=void 0,this.b=s&&s.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new a),this.a}cancel(){this.a?this.a instanceof a&&this.a.cancel():this.a=i.Cancelled}dispose(s=!1){s&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof a&&this.a.dispose():this.a=i.None}}t.$dd=v}),Y(Z[32],K([0,1,19]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gd=t.$fd=t.$ed=void 0;class D{constructor(c){this.b=c,this.a=null}get(){if(this.a)return this.a;const c=new k.$dd,s=this.b(c.token);return this.a={promise:s,dispose:()=>{this.a=null,c.cancel(),c.dispose()}},this.a}}t.$ed=D;class i{constructor(c){this.c=c,this.a=void 0,this.b=void 0}get(c){const s=JSON.stringify(c);return this.b!==s&&(this.b=s,this.a=this.c(c)),this.a}}t.$fd=i;class a{get cachedValues(){return this.a}constructor(c){this.b=c,this.a=new Map}get(c){if(this.a.has(c))return this.a.get(c);const s=this.b(c);return this.a.set(c,s),s}}t.$gd=a}),Y(Z[5],K([0,1,32,31]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$he=t.$ge=t.$fe=t.$ee=t.GraphemeBreakType=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=t.$7d=t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.$Td=t.$Sd=t.$Rd=t.$Qd=t.$Pd=t.$Od=t.$Nd=t.$Md=t.$Ld=t.$Kd=t.$Jd=t.$Id=t.$Hd=t.$Gd=t.$Fd=t.$Ed=t.$Dd=t.$Cd=t.$Bd=t.$Ad=t.$zd=t.$yd=t.$xd=t.$wd=t.$vd=t.$ud=t.$td=t.$sd=t.$rd=t.$qd=t.$pd=t.$od=t.$nd=t.$md=t.$ld=t.$kd=t.$jd=void 0;function i(T){return!T||typeof T!="string"?!0:T.trim().length===0}t.$jd=i;const a=/{(\d+)}/g;function v(T,...j){return j.length===0?T:T.replace(a,function(x,Q){const ee=parseInt(Q,10);return isNaN(ee)||ee<0||ee>=j.length?x:j[ee]})}t.$kd=v;const c=/{([^}]+)}/g;function s(T,j){return T.replace(c,(x,Q)=>j[Q]??x)}t.$ld=s;function u(T){return T.replace(/[<>&]/g,function(j){switch(j){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return j}})}t.$md=u;function f(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$nd=f;function M(T,j){let x=0;const Q=j.charCodeAt(0);for(let ee=T.length-1;ee>=0;ee--)T.charCodeAt(ee)===Q&&x++;return x}t.$od=M;function h(T,j,x="\u2026"){return T.length<=j?T:`${T.substr(0,j)}${x}`}t.$pd=h;function o(T,j=" "){const x=e(T,j);return N(x,j)}t.$qd=o;function e(T,j){if(!T||!j)return T;const x=j.length;if(x===0||T.length===0)return T;let Q=0;for(;T.indexOf(j,Q)===Q;)Q=Q+x;return T.substring(Q)}t.$rd=e;function N(T,j){if(!T||!j)return T;const x=j.length,Q=T.length;if(x===0||Q===0)return T;let ee=Q,re=-1;for(;re=T.lastIndexOf(j,ee-1),!(re===-1||re+x!==ee);){if(re===0)return"";ee=re}return T.substring(0,ee)}t.$sd=N;function y(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$td=y;function R(T){return T.replace(/\*/g,"")}t.$ud=R;function b(T,j,x={}){if(!T)throw new Error("Cannot create regex from empty string");j||(T=f(T)),x.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let Q="";return x.global&&(Q+="g"),x.matchCase||(Q+="i"),x.multiline&&(Q+="m"),x.unicode&&(Q+="u"),new RegExp(T,Q)}t.$vd=b;function E(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}t.$wd=E;function g(T){return!!T.match(/([^\\]|^)(\\\\)*\\\d+/)}t.$xd=g;function m(T){return(T.global?"g":"")+(T.ignoreCase?"i":"")+(T.multiline?"m":"")+(T.unicode?"u":"")}t.$yd=m;function r(T){return T.split(/\r\n|\r|\n/)}t.$zd=r;function l(T){for(let j=0,x=T.length;j<x;j++){const Q=T.charCodeAt(j);if(Q!==32&&Q!==9)return j}return-1}t.$Ad=l;function A(T,j=0,x=T.length){for(let Q=j;Q<x;Q++){const ee=T.charCodeAt(Q);if(ee!==32&&ee!==9)return T.substring(j,Q)}return T.substring(j,x)}t.$Bd=A;function d(T,j=T.length-1){for(let x=j;x>=0;x--){const Q=T.charCodeAt(x);if(Q!==32&&Q!==9)return x}return-1}t.$Cd=d;function $(T,j,x){const Q=[];let ee=0;for(const re of T.matchAll(j)){if(Q.push(T.slice(ee,re.index)),re.index===void 0)throw new Error("match.index should be defined");ee=re.index+re[0].length,Q.push(x(re[0],...re.slice(1),re.index,T,re.groups))}return Q.push(T.slice(ee)),Promise.all(Q).then(re=>re.join(""))}t.$Dd=$;function w(T,j){return T<j?-1:T>j?1:0}t.$Ed=w;function L(T,j,x=0,Q=T.length,ee=0,re=j.length){for(;x<Q&&ee<re;x++,ee++){const Re=T.charCodeAt(x),Ee=j.charCodeAt(ee);if(Re<Ee)return-1;if(Re>Ee)return 1}const be=Q-x,pe=re-ee;return be<pe?-1:be>pe?1:0}t.$Fd=L;function p(T,j){return F(T,j,0,T.length,0,j.length)}t.$Gd=p;function F(T,j,x=0,Q=T.length,ee=0,re=j.length){for(;x<Q&&ee<re;x++,ee++){let Re=T.charCodeAt(x),Ee=j.charCodeAt(ee);if(Re===Ee)continue;if(Re>=128||Ee>=128)return L(T.toLowerCase(),j.toLowerCase(),x,Q,ee,re);I(Re)&&(Re-=32),I(Ee)&&(Ee-=32);const we=Re-Ee;if(we!==0)return we}const be=Q-x,pe=re-ee;return be<pe?-1:be>pe?1:0}t.$Hd=F;function P(T){return T>=48&&T<=57}t.$Id=P;function I(T){return T>=97&&T<=122}t.$Jd=I;function O(T){return T>=65&&T<=90}t.$Kd=O;function U(T,j){return T.length===j.length&&F(T,j)===0}t.$Ld=U;function C(T,j){const x=j.length;return j.length>T.length?!1:F(T,j,0,x)===0}t.$Md=C;function _(T,j){const x=Math.min(T.length,j.length);let Q;for(Q=0;Q<x;Q++)if(T.charCodeAt(Q)!==j.charCodeAt(Q))return Q;return x}t.$Nd=_;function W(T,j){const x=Math.min(T.length,j.length);let Q;const ee=T.length-1,re=j.length-1;for(Q=0;Q<x;Q++)if(T.charCodeAt(ee-Q)!==j.charCodeAt(re-Q))return Q;return x}t.$Od=W;function G(T){return 55296<=T&&T<=56319}t.$Pd=G;function X(T){return 56320<=T&&T<=57343}t.$Qd=X;function ne(T,j){return(T-55296<<10)+(j-56320)+65536}t.$Rd=ne;function n(T,j,x){const Q=T.charCodeAt(x);if(G(Q)&&x+1<j){const ee=T.charCodeAt(x+1);if(X(ee))return ne(Q,ee)}return Q}t.$Sd=n;function oe(T,j){const x=T.charCodeAt(j-1);if(X(x)&&j>1){const Q=T.charCodeAt(j-2);if(G(Q))return ne(Q,x)}return x}class ce{get offset(){return this.e}constructor(j,x=0){this.c=j,this.d=j.length,this.e=x}setOffset(j){this.e=j}prevCodePoint(){const j=oe(this.c,this.e);return this.e-=j>=65536?2:1,j}nextCodePoint(){const j=n(this.c,this.d,this.e);return this.e+=j>=65536?2:1,j}eol(){return this.e>=this.d}}t.$Td=ce;class me{get offset(){return this.c.offset}constructor(j,x=0){this.c=new ce(j,x)}nextGraphemeLength(){const j=_e.getInstance(),x=this.c,Q=x.offset;let ee=j.getGraphemeBreakType(x.nextCodePoint());for(;!x.eol();){const re=x.offset,be=j.getGraphemeBreakType(x.nextCodePoint());if(Se(ee,be)){x.setOffset(re);break}ee=be}return x.offset-Q}prevGraphemeLength(){const j=_e.getInstance(),x=this.c,Q=x.offset;let ee=j.getGraphemeBreakType(x.prevCodePoint());for(;x.offset>0;){const re=x.offset,be=j.getGraphemeBreakType(x.prevCodePoint());if(Se(be,ee)){x.setOffset(re);break}ee=be}return Q-x.offset}eol(){return this.c.eol()}}t.$Ud=me;function ge(T,j){return new me(T,j).nextGraphemeLength()}t.$Vd=ge;function ve(T,j){return new me(T,j).prevGraphemeLength()}t.$Wd=ve;function Le(T,j){j>0&&X(T.charCodeAt(j))&&j--;const x=j+ge(T,j);return[x-ve(T,x),x]}t.$Xd=Le;function Ae(T){const j=new me(T);let x=0;for(;!j.eol();)x++,j.nextGraphemeLength();return x}t.$Yd=Ae;let Ne;function Fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function le(T){return Ne||(Ne=Fe()),Ne.test(T)}t.$Zd=le;const ae=/^[\t\n\r\x20-\x7E]*$/;function ie(T){return ae.test(T)}t.$1d=ie,t.$2d=/[\u2028\u2029]/;function ue(T){return t.$2d.test(T)}t.$3d=ue;function S(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}t.$4d=S;function q(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}t.$5d=q;function B(T,j){if(T.length<j)return T;const x=/\b/g;let Q=0;for(;x.test(T)&&!(T.length-x.lastIndex<j);)Q=x.lastIndex,x.lastIndex+=1;return T.substring(Q).replace(/^\s/,"")}t.$6d=B;const V=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,z=/\x1b\].*?\x07/g;function J(T){return T&&(T=T.replace(V,"").replace(z,"")),T}t.$7d=J,t.$8d=String.fromCharCode(65279);function te(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}t.$9d=te;function se(T){return te(T)?T.substr(1):T}t.$0d=se;function fe(T,j){if(!T||!j||T.length<j.length)return!1;const x=j.length,Q=T.toLowerCase();let ee=0,re=-1;for(;ee<x;){const be=Q.indexOf(j[ee],re+1);if(be<0)return!1;re=be,ee++}return!0}t.$$d=fe;function he(T,j=!1){return T?(j&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}t.$_d=he;function $e(T){return T.charAt(0).toUpperCase()+T.slice(1)}t.$ae=$e;function ye(T,j=1){if(j===0)return"";let x=-1;do x=T.indexOf(`
`,x+1),j--;while(j>0&&x>=0);return x===-1?T:(T[x-1]==="\r"&&x--,T.substr(0,x))}t.$be=ye;function Ie(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}t.$ce=Ie;function ke(T){return _e.getInstance().getGraphemeBreakType(T)}t.$de=ke;function Se(T,j){return T===0?j!==5&&j!==7:T===2&&j===3?!1:T===4||T===2||T===3||j===4||j===2||j===3?!0:!(T===8&&(j===8||j===9||j===11||j===12)||(T===11||T===9)&&(j===9||j===10)||(T===12||T===10)&&j===10||j===5||j===13||j===7||T===1||T===13&&j===14||T===6&&j===6)}var Ue;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(Ue||(t.GraphemeBreakType=Ue={}));class _e{static{this.c=null}static getInstance(){return _e.c||(_e.c=new _e),_e.c}constructor(){this.d=je()}getGraphemeBreakType(j){if(j<32)return j===10?3:j===13?2:4;if(j<127)return 0;const x=this.d,Q=x.length/3;let ee=1;for(;ee<=Q;)if(j<x[3*ee])ee=2*ee;else if(j>x[3*ee+1])ee=2*ee+1;else return x[3*ee+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ce(T,j){if(T===0)return 0;const x=He(T,j);if(x!==void 0)return x;const Q=new ce(j,T);return Q.prevCodePoint(),Q.offset}t.$ee=Ce;function He(T,j){const x=new ce(j,T);let Q=x.prevCodePoint();for(;ze(Q)||Q===65039||Q===8419;){if(x.offset===0)return;Q=x.prevCodePoint()}if(!q(Q))return;let ee=x.offset;return ee>0&&x.prevCodePoint()===8205&&(ee=x.offset),ee}function ze(T){return 127995<=T&&T<=127999}var Oe;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(Oe||(Oe={})),t.$fe="\xA0";class De{static{this.c=new D.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new k.$fd(j=>{function x(we){const Pe=new Map;for(let Me=0;Me<we.length;Me+=2)Pe.set(we[Me],we[Me+1]);return Pe}function Q(we,Pe){const Me=new Map(we);for(const[qe,Be]of Pe)Me.set(qe,Be);return Me}function ee(we,Pe){if(!we)return Pe;const Me=new Map;for(const[qe,Be]of we)Pe.has(qe)&&Me.set(qe,Be);return Me}const re=this.c.value;let be=j.filter(we=>!we.startsWith("_")&&we in re);be.length===0&&(be=["_default"]);let pe;for(const we of be){const Pe=x(re[we]);pe=ee(pe,Pe)}const Re=x(re._common),Ee=Q(Re,pe);return new De(Ee)})}static getInstance(j){return De.d.get(Array.from(j))}static{this.e=new D.$T(()=>Object.keys(De.c.value).filter(j=>!j.startsWith("_")))}static getLocales(){return De.e.value}constructor(j){this.f=j}isAmbiguous(j){return this.f.has(j)}getPrimaryConfusable(j){return this.f.get(j)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$ge=De;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(j){return Te.e().has(j)}static get codePoints(){return Te.e()}}t.$he=Te}),Y(Z[33],K([0,1,5]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hi=t.$gi=t.$fi=t.$ei=t.$di=t.$ci=t.$bi=void 0;function D(R){return i(R,0)}t.$bi=D;function i(R,b){switch(typeof R){case"object":return R===null?a(349,b):Array.isArray(R)?s(R,b):u(R,b);case"string":return c(R,b);case"boolean":return v(R,b);case"number":return a(R,b);case"undefined":return a(937,b);default:return a(617,b)}}t.$ci=i;function a(R,b){return(b<<5)-b+R|0}t.$di=a;function v(R,b){return a(R?433:863,b)}function c(R,b){b=a(149417,b);for(let E=0,g=R.length;E<g;E++)b=a(R.charCodeAt(E),b);return b}t.$ei=c;function s(R,b){return b=a(104579,b),R.reduce((E,g)=>i(g,E),b)}function u(R,b){return b=a(181387,b),Object.keys(R).sort().reduce((E,g)=>(E=c(g,E),i(R[g],E)),b)}class f{constructor(){this.g=0}get value(){return this.g}hash(b){return this.g=i(b,this.g),this.g}}t.$fi=f;var M;(function(R){R[R.BLOCK_SIZE=64]="BLOCK_SIZE",R[R.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function h(R,b,E=32){const g=E-b,m=~((1<<g)-1);return(R<<b|(m&R)>>>g)>>>0}function o(R,b=0,E=R.byteLength,g=0){for(let m=0;m<E;m++)R[b+m]=g}function e(R,b,E="0"){for(;R.length<b;)R=E+R;return R}function N(R,b=32){return R instanceof ArrayBuffer?Array.from(new Uint8Array(R)).map(E=>E.toString(16).padStart(2,"0")).join(""):e((R>>>0).toString(16),b/4)}t.$gi=N;class y{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(b){const E=b.length;if(E===0)return;const g=this.p;let m=this.r,r=this.u,l,A;for(r!==0?(l=r,A=-1,r=0):(l=b.charCodeAt(0),A=0);;){let d=l;if(k.$Pd(l))if(A+1<E){const $=b.charCodeAt(A+1);k.$Qd($)?(A++,d=k.$Rd(l,$)):d=65533}else{r=l;break}else k.$Qd(l)&&(d=65533);if(m=this.w(g,m,d),A++,A<E)l=b.charCodeAt(A);else break}this.r=m,this.u=r}w(b,E,g){return g<128?b[E++]=g:g<2048?(b[E++]=192|(g&1984)>>>6,b[E++]=128|(g&63)>>>0):g<65536?(b[E++]=224|(g&61440)>>>12,b[E++]=128|(g&4032)>>>6,b[E++]=128|(g&63)>>>0):(b[E++]=240|(g&1835008)>>>18,b[E++]=128|(g&258048)>>>12,b[E++]=128|(g&4032)>>>6,b[E++]=128|(g&63)>>>0),E>=64&&(this.y(),E-=64,this.t+=64,b[0]=b[64+0],b[1]=b[64+1],b[2]=b[64+2]),E}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),N(this.h)+N(this.l)+N(this.m)+N(this.n)+N(this.o)}x(){this.p[this.r++]=128,o(this.p,this.r),this.r>56&&(this.y(),o(this.p));const b=8*this.t;this.q.setUint32(56,Math.floor(b/4294967296),!1),this.q.setUint32(60,b%4294967296,!1),this.y()}y(){const b=y.g,E=this.q;for(let L=0;L<64;L+=4)b.setUint32(L,E.getUint32(L,!1),!1);for(let L=64;L<320;L+=4)b.setUint32(L,h(b.getUint32(L-12,!1)^b.getUint32(L-32,!1)^b.getUint32(L-56,!1)^b.getUint32(L-64,!1),1),!1);let g=this.h,m=this.l,r=this.m,l=this.n,A=this.o,d,$,w;for(let L=0;L<80;L++)L<20?(d=m&r|~m&l,$=1518500249):L<40?(d=m^r^l,$=1859775393):L<60?(d=m&r|m&l|r&l,$=2400959708):(d=m^r^l,$=3395469782),w=h(g,5)+d+A+$+b.getUint32(L*4,!1)&4294967295,A=l,l=r,r=h(m,30),m=g,g=w;this.h=this.h+g&4294967295,this.l=this.l+m&4294967295,this.m=this.m+r&4294967295,this.n=this.n+l&4294967295,this.o=this.o+A&4294967295}}t.$hi=y}),Y(Z[20],K([0,1,28,33]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mu=t.$lu=t.$ku=void 0;class i{constructor(h){this.a=h}getElements(){const h=this.a,o=new Int32Array(h.length);for(let e=0,N=h.length;e<N;e++)o[e]=h.charCodeAt(e);return o}}t.$ku=i;function a(M,h,o){return new f(new i(M),new i(h)).ComputeDiff(o).changes}t.$lu=a;class v{static Assert(h,o){if(!h)throw new Error(o)}}class c{static Copy(h,o,e,N,y){for(let R=0;R<y;R++)e[N+R]=h[o+R]}static Copy2(h,o,e,N,y){for(let R=0;R<y;R++)e[N+R]=h[o+R]}}var s;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(s||(s={}));class u{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new k.$ju(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(h,o){this.b=Math.min(this.b,h),this.c=Math.min(this.c,o),this.d++}AddModifiedElement(h,o){this.b=Math.min(this.b,h),this.c=Math.min(this.c,o),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class f{constructor(h,o,e=null){this.a=e,this.b=h,this.c=o;const[N,y,R]=f.o(h),[b,E,g]=f.o(o);this.d=R&&g,this.e=N,this.f=y,this.g=b,this.h=E,this.k=[],this.m=[]}static n(h){return h.length>0&&typeof h[0]=="string"}static o(h){const o=h.getElements();if(f.n(o)){const e=new Int32Array(o.length);for(let N=0,y=o.length;N<y;N++)e[N]=(0,D.$ei)(o[N],0);return[o,e,!0]}return o instanceof Int32Array?[[],o,!1]:[[],new Int32Array(o),!1]}p(h,o){return this.f[h]!==this.h[o]?!1:this.d?this.e[h]===this.g[o]:!0}q(h,o){if(!this.p(h,o))return!1;const e=f.r(this.b,h),N=f.r(this.c,o);return e===N}static r(h,o){return typeof h.getStrictElement=="function"?h.getStrictElement(o):null}s(h,o){return this.f[h]!==this.f[o]?!1:this.d?this.e[h]===this.e[o]:!0}u(h,o){return this.h[h]!==this.h[o]?!1:this.d?this.g[h]===this.g[o]:!0}ComputeDiff(h){return this.v(0,this.f.length-1,0,this.h.length-1,h)}v(h,o,e,N,y){const R=[!1];let b=this.w(h,o,e,N,R);return y&&(b=this.z(b)),{quitEarly:R[0],changes:b}}w(h,o,e,N,y){for(y[0]=!1;h<=o&&e<=N&&this.p(h,e);)h++,e++;for(;o>=h&&N>=e&&this.p(o,N);)o--,N--;if(h>o||e>N){let r;return e<=N?(v.Assert(h===o+1,"originalStart should only be one more than originalEnd"),r=[new k.$ju(h,0,e,N-e+1)]):h<=o?(v.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[new k.$ju(h,o-h+1,e,0)]):(v.Assert(h===o+1,"originalStart should only be one more than originalEnd"),v.Assert(e===N+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const R=[0],b=[0],E=this.y(h,o,e,N,R,b,y),g=R[0],m=b[0];if(E!==null)return E;if(!y[0]){const r=this.w(h,g,e,m,y);let l=[];return y[0]?l=[new k.$ju(g+1,o-(g+1)+1,m+1,N-(m+1)+1)]:l=this.w(g+1,o,m+1,N,y),this.H(r,l)}return[new k.$ju(h,o-h+1,e,N-e+1)]}x(h,o,e,N,y,R,b,E,g,m,r,l,A,d,$,w,L,p){let F=null,P=null,I=new u,O=o,U=e,C=A[0]-w[0]-N,_=-1073741824,W=this.k.length-1;do{const G=C+h;G===O||G<U&&g[G-1]<g[G+1]?(r=g[G+1],d=r-C-N,r<_&&I.MarkNextChange(),_=r,I.AddModifiedElement(r+1,d),C=G+1-h):(r=g[G-1]+1,d=r-C-N,r<_&&I.MarkNextChange(),_=r-1,I.AddOriginalElement(r,d+1),C=G-1-h),W>=0&&(g=this.k[W],h=g[0],O=1,U=g.length-1)}while(--W>=-1);if(F=I.getReverseChanges(),p[0]){let G=A[0]+1,X=w[0]+1;if(F!==null&&F.length>0){const ne=F[F.length-1];G=Math.max(G,ne.getOriginalEnd()),X=Math.max(X,ne.getModifiedEnd())}P=[new k.$ju(G,l-G+1,X,$-X+1)]}else{I=new u,O=R,U=b,C=A[0]-w[0]-E,_=1073741824,W=L?this.m.length-1:this.m.length-2;do{const G=C+y;G===O||G<U&&m[G-1]>=m[G+1]?(r=m[G+1]-1,d=r-C-E,r>_&&I.MarkNextChange(),_=r+1,I.AddOriginalElement(r+1,d+1),C=G+1-y):(r=m[G-1],d=r-C-E,r>_&&I.MarkNextChange(),_=r,I.AddModifiedElement(r+1,d+1),C=G-1-y),W>=0&&(m=this.m[W],y=m[0],O=1,U=m.length-1)}while(--W>=-1);P=I.getChanges()}return this.H(F,P)}y(h,o,e,N,y,R,b){let E=0,g=0,m=0,r=0,l=0,A=0;h--,e--,y[0]=0,R[0]=0,this.k=[],this.m=[];const d=o-h+(N-e),$=d+1,w=new Int32Array($),L=new Int32Array($),p=N-e,F=o-h,P=h-e,I=o-N,U=(F-p)%2===0;w[p]=h,L[F]=o,b[0]=!1;for(let C=1;C<=d/2+1;C++){let _=0,W=0;m=this.J(p-C,C,p,$),r=this.J(p+C,C,p,$);for(let X=m;X<=r;X+=2){X===m||X<r&&w[X-1]<w[X+1]?E=w[X+1]:E=w[X-1]+1,g=E-(X-p)-P;const ne=E;for(;E<o&&g<N&&this.p(E+1,g+1);)E++,g++;if(w[X]=E,E+g>_+W&&(_=E,W=g),!U&&Math.abs(X-F)<=C-1&&E>=L[X])return y[0]=E,R[0]=g,ne<=L[X]&&1447>0&&C<=1447+1?this.x(p,m,r,P,F,l,A,I,w,L,E,o,y,g,N,R,U,b):null}const G=(_-h+(W-e)-C)/2;if(this.a!==null&&!this.a(_,G))return b[0]=!0,y[0]=_,R[0]=W,G>0&&1447>0&&C<=1447+1?this.x(p,m,r,P,F,l,A,I,w,L,E,o,y,g,N,R,U,b):(h++,e++,[new k.$ju(h,o-h+1,e,N-e+1)]);l=this.J(F-C,C,F,$),A=this.J(F+C,C,F,$);for(let X=l;X<=A;X+=2){X===l||X<A&&L[X-1]>=L[X+1]?E=L[X+1]-1:E=L[X-1],g=E-(X-F)-I;const ne=E;for(;E>h&&g>e&&this.p(E,g);)E--,g--;if(L[X]=E,U&&Math.abs(X-p)<=C&&E<=w[X])return y[0]=E,R[0]=g,ne>=w[X]&&1447>0&&C<=1447+1?this.x(p,m,r,P,F,l,A,I,w,L,E,o,y,g,N,R,U,b):null}if(C<=1447){let X=new Int32Array(r-m+2);X[0]=p-m+1,c.Copy2(w,m,X,1,r-m+1),this.k.push(X),X=new Int32Array(A-l+2),X[0]=F-l+1,c.Copy2(L,l,X,1,A-l+1),this.m.push(X)}}return this.x(p,m,r,P,F,l,A,I,w,L,E,o,y,g,N,R,U,b)}z(h){for(let o=0;o<h.length;o++){const e=h[o],N=o<h.length-1?h[o+1].originalStart:this.f.length,y=o<h.length-1?h[o+1].modifiedStart:this.h.length,R=e.originalLength>0,b=e.modifiedLength>0;for(;e.originalStart+e.originalLength<N&&e.modifiedStart+e.modifiedLength<y&&(!R||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!b||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const g=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!g)break;e.originalStart++,e.modifiedStart++}const E=[null];if(o<h.length-1&&this.I(h[o],h[o+1],E)){h[o]=E[0],h.splice(o+1,1),o--;continue}}for(let o=h.length-1;o>=0;o--){const e=h[o];let N=0,y=0;if(o>0){const r=h[o-1];N=r.originalStart+r.originalLength,y=r.modifiedStart+r.modifiedLength}const R=e.originalLength>0,b=e.modifiedLength>0;let E=0,g=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const l=e.originalStart-r,A=e.modifiedStart-r;if(l<N||A<y||R&&!this.s(l,l+e.originalLength)||b&&!this.u(A,A+e.modifiedLength))break;const $=(l===N&&A===y?5:0)+this.G(l,e.originalLength,A,e.modifiedLength);$>g&&(g=$,E=r)}e.originalStart-=E,e.modifiedStart-=E;const m=[null];if(o>0&&this.I(h[o-1],h[o],m)){h[o-1]=m[0],h.splice(o,1),o++;continue}}if(this.d)for(let o=1,e=h.length;o<e;o++){const N=h[o-1],y=h[o],R=y.originalStart-N.originalStart-N.originalLength,b=N.originalStart,E=y.originalStart+y.originalLength,g=E-b,m=N.modifiedStart,r=y.modifiedStart+y.modifiedLength,l=r-m;if(R<5&&g<20&&l<20){const A=this.A(b,g,m,l,R);if(A){const[d,$]=A;(d!==N.originalStart+N.originalLength||$!==N.modifiedStart+N.modifiedLength)&&(N.originalLength=d-N.originalStart,N.modifiedLength=$-N.modifiedStart,y.originalStart=d+R,y.modifiedStart=$+R,y.originalLength=E-y.originalStart,y.modifiedLength=r-y.modifiedStart)}}}return h}A(h,o,e,N,y){if(o<y||N<y)return null;const R=h+o-y+1,b=e+N-y+1;let E=0,g=0,m=0;for(let r=h;r<R;r++)for(let l=e;l<b;l++){const A=this.B(r,l,y);A>0&&A>E&&(E=A,g=r,m=l)}return E>0?[g,m]:null}B(h,o,e){let N=0;for(let y=0;y<e;y++){if(!this.p(h+y,o+y))return 0;N+=this.e[h+y].length}return N}C(h){return h<=0||h>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[h])}D(h,o){if(this.C(h)||this.C(h-1))return!0;if(o>0){const e=h+o;if(this.C(e-1)||this.C(e))return!0}return!1}E(h){return h<=0||h>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[h])}F(h,o){if(this.E(h)||this.E(h-1))return!0;if(o>0){const e=h+o;if(this.E(e-1)||this.E(e))return!0}return!1}G(h,o,e,N){const y=this.D(h,o)?1:0,R=this.F(e,N)?1:0;return y+R}H(h,o){const e=[];if(h.length===0||o.length===0)return o.length>0?o:h;if(this.I(h[h.length-1],o[0],e)){const N=new Array(h.length+o.length-1);return c.Copy(h,0,N,0,h.length-1),N[h.length-1]=e[0],c.Copy(o,1,N,h.length,o.length-1),N}else{const N=new Array(h.length+o.length);return c.Copy(h,0,N,0,h.length),c.Copy(o,0,N,h.length,o.length),N}}I(h,o,e){if(v.Assert(h.originalStart<=o.originalStart,"Left change is not less than or equal to right change"),v.Assert(h.modifiedStart<=o.modifiedStart,"Left change is not less than or equal to right change"),h.originalStart+h.originalLength>=o.originalStart||h.modifiedStart+h.modifiedLength>=o.modifiedStart){const N=h.originalStart;let y=h.originalLength;const R=h.modifiedStart;let b=h.modifiedLength;return h.originalStart+h.originalLength>=o.originalStart&&(y=o.originalStart+o.originalLength-h.originalStart),h.modifiedStart+h.modifiedLength>=o.modifiedStart&&(b=o.modifiedStart+o.modifiedLength-h.modifiedStart),e[0]=new k.$ju(N,y,R,b),!0}else return e[0]=null,!1}J(h,o,e,N){if(h>=0&&h<N)return h;const y=e,R=N-e-1,b=o%2===0;if(h<0){const E=y%2===0;return b===E?0:1}else{const E=R%2===0;return b===E?N-1:N-2}}}t.$mu=f}),Y(Z[21],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=void 0;function k(l){return typeof l=="string"}t.$ie=k;function D(l){return Array.isArray(l)&&l.every(A=>k(A))}t.$je=D;function i(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}t.$ke=i;function a(l){const A=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof A}t.$le=a;function v(l){return typeof l=="number"&&!isNaN(l)}t.$me=v;function c(l){return!!l&&typeof l[Symbol.iterator]=="function"}t.$ne=c;function s(l){return l===!0||l===!1}t.$oe=s;function u(l){return typeof l>"u"}t.$pe=u;function f(l){return!M(l)}t.$qe=f;function M(l){return u(l)||l===null}t.$re=M;function h(l,A){if(!l)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}t.$se=h;function o(l){if(M(l))throw new Error("Assertion Failed: argument is undefined or null");return l}t.$te=o;function e(...l){const A=[];for(let d=0;d<l.length;d++){const $=l[d];if(M($))throw new Error(`Assertion Failed: argument at index ${d} is undefined or null`);A.push($)}return A}t.$ue=e;const N=Object.prototype.hasOwnProperty;function y(l){if(!i(l))return!1;for(const A in l)if(N.call(l,A))return!1;return!0}t.$ve=y;function R(l){return typeof l=="function"}t.$we=R;function b(...l){return l.length>0&&l.every(R)}t.$xe=b;function E(l,A){const d=Math.min(l.length,A.length);for(let $=0;$<d;$++)g(l[$],A[$])}t.$ye=E;function g(l,A){if(k(A)){if(typeof l!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(R(A)){try{if(l instanceof A)return}catch{}if(!M(l)&&l.constructor===A||A.length===1&&A.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$ze=g;function m(l){return l===null?void 0:l}t.$Ae=m;function r(l){return typeof l>"u"?null:l}t.$Be=r}),Y(Z[34],K([0,1,21]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Aj=t.$zj=t.$yj=void 0;const D=Object.create(null);function i(c,s){if((0,k.$ie)(s)){const u=D[s];if(u===void 0)throw new Error(`${c} references an unknown codicon: ${s}`);s=u}return D[c]=s,{id:c}}function a(){return D}t.$yj=a;function v(){return Object.values(t.$Aj)}t.$zj=v,t.$Aj={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),Y(Z[11],K([0,1,21]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qm=t.$Pm=t.$Om=t.$Nm=t.$Mm=t.$Lm=t.$Km=t.$Jm=t.$Im=t.$Hm=t.$Gm=t.$Fm=void 0;function D(R){if(!R||typeof R!="object"||R instanceof RegExp)return R;const b=Array.isArray(R)?[]:{};return Object.entries(R).forEach(([E,g])=>{b[E]=g&&typeof g=="object"?D(g):g}),b}t.$Fm=D;function i(R){if(!R||typeof R!="object")return R;const b=[R];for(;b.length>0;){const E=b.shift();Object.freeze(E);for(const g in E)if(a.call(E,g)){const m=E[g];typeof m=="object"&&!Object.isFrozen(m)&&!(0,k.$le)(m)&&b.push(m)}}return R}t.$Gm=i;const a=Object.prototype.hasOwnProperty;function v(R,b){return c(R,b,new Set)}t.$Hm=v;function c(R,b,E){if((0,k.$re)(R))return R;const g=b(R);if(typeof g<"u")return g;if(Array.isArray(R)){const m=[];for(const r of R)m.push(c(r,b,E));return m}if((0,k.$ke)(R)){if(E.has(R))throw new Error("Cannot clone recursive data-structure");E.add(R);const m={};for(const r in R)a.call(R,r)&&(m[r]=c(R[r],b,E));return E.delete(R),m}return R}function s(R,b,E=!0){return(0,k.$ke)(R)?((0,k.$ke)(b)&&Object.keys(b).forEach(g=>{g in R?E&&((0,k.$ke)(R[g])&&(0,k.$ke)(b[g])?s(R[g],b[g],E):R[g]=b[g]):R[g]=b[g]}),R):b}t.$Im=s;function u(R,b){if(R===b)return!0;if(R==null||b===null||b===void 0||typeof R!=typeof b||typeof R!="object"||Array.isArray(R)!==Array.isArray(b))return!1;let E,g;if(Array.isArray(R)){if(R.length!==b.length)return!1;for(E=0;E<R.length;E++)if(!u(R[E],b[E]))return!1}else{const m=[];for(g in R)m.push(g);m.sort();const r=[];for(g in b)r.push(g);if(r.sort(),!u(m,r))return!1;for(E=0;E<m.length;E++)if(!u(R[m[E]],b[m[E]]))return!1}return!0}t.$Jm=u;function f(R){const b=new Set;return JSON.stringify(R,(E,g)=>{if((0,k.$ke)(g)||Array.isArray(g)){if(b.has(g))return"[Circular]";b.add(g)}return g})}t.$Km=f;function M(R,b){const E=Object.create(null);return!R||!b||Object.keys(b).forEach(m=>{const r=R[m],l=b[m];u(r,l)||(E[m]=l)}),E}t.$Lm=M;function h(R,b){const E=b.toLowerCase(),g=Object.keys(R).find(m=>m.toLowerCase()===E);return g?R[g]:R[b]}t.$Mm=h;function o(R,b){const E=Object.create(null);for(const[g,m]of Object.entries(R))b(g,m)&&(E[g]=m);return E}t.$Nm=o;function e(R){let b=[];for(;Object.prototype!==R;)b=b.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return b}t.$Om=e;function N(R){const b=[];for(const E of e(R))typeof R[E]=="function"&&b.push(E);return b}t.$Pm=N;function y(R,b){const E=m=>function(){const r=Array.prototype.slice.call(arguments,0);return b(m,r)},g={};for(const m of R)g[m]=E(m);return g}t.$Qm=y}),Y(Z[22],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$id=t.$hd=t.Constants=void 0;var k;(function(a){a[a.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",a[a.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",a[a.MAX_UINT_8=255]="MAX_UINT_8",a[a.MAX_UINT_16=65535]="MAX_UINT_16",a[a.MAX_UINT_32=4294967295]="MAX_UINT_32",a[a.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(k||(t.Constants=k={}));function D(a){return a<0?0:a>255?255:a|0}t.$hd=D;function i(a){return a<0?0:a>4294967295?4294967295:a|0}t.$id=i}),Y(Z[23],K([0,1,22]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2r=t.$1r=void 0;class D{constructor(c){const s=(0,k.$hd)(c);this.c=s,this.a=D.d(s),this.b=new Map}static d(c){const s=new Uint8Array(256);return s.fill(c),s}set(c,s){const u=(0,k.$hd)(s);c>=0&&c<256?this.a[c]=u:this.b.set(c,u)}get(c){return c>=0&&c<256?this.a[c]:this.b.get(c)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}t.$1r=D;var i;(function(v){v[v.False=0]="False",v[v.True=1]="True"})(i||(i={}));class a{constructor(){this.a=new D(0)}add(c){this.a.set(c,1)}has(c){return this.a.get(c)===1}clear(){return this.a.clear()}}t.$2r=a}),Y(Z[6],K([0,1,3]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bC=void 0;class D{static addRange(a,v){let c=0;for(;c<v.length&&v[c].endExclusive<a.start;)c++;let s=c;for(;s<v.length&&v[s].start<=a.endExclusive;)s++;if(c===s)v.splice(c,0,a);else{const u=Math.min(a.start,v[c].start),f=Math.max(a.endExclusive,v[s-1].endExclusive);v.splice(c,s-c,new D(u,f))}}static tryCreate(a,v){if(!(a>v))return new D(a,v)}constructor(a,v){if(this.start=a,this.endExclusive=v,a>v)throw new k.$bb(`Invalid range: ${this.toString()}`)}get isEmpty(){return this.start===this.endExclusive}delta(a){return new D(this.start+a,this.endExclusive+a)}get length(){return this.endExclusive-this.start}toString(){return`[${this.start}, ${this.endExclusive})`}equals(a){return this.start===a.start&&this.endExclusive===a.endExclusive}containsRange(a){return this.start<=a.start&&a.endExclusive<=this.endExclusive}contains(a){return this.start<=a&&a<this.endExclusive}join(a){return new D(Math.min(this.start,a.start),Math.max(this.endExclusive,a.endExclusive))}intersect(a){const v=Math.max(this.start,a.start),c=Math.min(this.endExclusive,a.endExclusive);if(v<=c)return new D(v,c)}}t.$bC=D}),Y(Z[4],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Lr=void 0;class k{constructor(i,a){this.lineNumber=i,this.column=a}with(i=this.lineNumber,a=this.column){return i===this.lineNumber&&a===this.column?this:new k(i,a)}delta(i=0,a=0){return this.with(this.lineNumber+i,this.column+a)}equals(i){return k.equals(this,i)}static equals(i,a){return!i&&!a?!0:!!i&&!!a&&i.lineNumber===a.lineNumber&&i.column===a.column}isBefore(i){return k.isBefore(this,i)}static isBefore(i,a){return i.lineNumber<a.lineNumber?!0:a.lineNumber<i.lineNumber?!1:i.column<a.column}isBeforeOrEqual(i){return k.isBeforeOrEqual(this,i)}static isBeforeOrEqual(i,a){return i.lineNumber<a.lineNumber?!0:a.lineNumber<i.lineNumber?!1:i.column<=a.column}static compare(i,a){const v=i.lineNumber|0,c=a.lineNumber|0;if(v===c){const s=i.column|0,u=a.column|0;return s-u}return v-c}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(i){return new k(i.lineNumber,i.column)}static isIPosition(i){return i&&typeof i.lineNumber=="number"&&typeof i.column=="number"}}t.$Lr=k}),Y(Z[2],K([0,1,4]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mr=void 0;class D{constructor(a,v,c,s){a>c||a===c&&v>s?(this.startLineNumber=c,this.startColumn=s,this.endLineNumber=a,this.endColumn=v):(this.startLineNumber=a,this.startColumn=v,this.endLineNumber=c,this.endColumn=s)}isEmpty(){return D.isEmpty(this)}static isEmpty(a){return a.startLineNumber===a.endLineNumber&&a.startColumn===a.endColumn}containsPosition(a){return D.containsPosition(this,a)}static containsPosition(a,v){return!(v.lineNumber<a.startLineNumber||v.lineNumber>a.endLineNumber||v.lineNumber===a.startLineNumber&&v.column<a.startColumn||v.lineNumber===a.endLineNumber&&v.column>a.endColumn)}static strictContainsPosition(a,v){return!(v.lineNumber<a.startLineNumber||v.lineNumber>a.endLineNumber||v.lineNumber===a.startLineNumber&&v.column<=a.startColumn||v.lineNumber===a.endLineNumber&&v.column>=a.endColumn)}containsRange(a){return D.containsRange(this,a)}static containsRange(a,v){return!(v.startLineNumber<a.startLineNumber||v.endLineNumber<a.startLineNumber||v.startLineNumber>a.endLineNumber||v.endLineNumber>a.endLineNumber||v.startLineNumber===a.startLineNumber&&v.startColumn<a.startColumn||v.endLineNumber===a.endLineNumber&&v.endColumn>a.endColumn)}strictContainsRange(a){return D.strictContainsRange(this,a)}static strictContainsRange(a,v){return!(v.startLineNumber<a.startLineNumber||v.endLineNumber<a.startLineNumber||v.startLineNumber>a.endLineNumber||v.endLineNumber>a.endLineNumber||v.startLineNumber===a.startLineNumber&&v.startColumn<=a.startColumn||v.endLineNumber===a.endLineNumber&&v.endColumn>=a.endColumn)}plusRange(a){return D.plusRange(this,a)}static plusRange(a,v){let c,s,u,f;return v.startLineNumber<a.startLineNumber?(c=v.startLineNumber,s=v.startColumn):v.startLineNumber===a.startLineNumber?(c=v.startLineNumber,s=Math.min(v.startColumn,a.startColumn)):(c=a.startLineNumber,s=a.startColumn),v.endLineNumber>a.endLineNumber?(u=v.endLineNumber,f=v.endColumn):v.endLineNumber===a.endLineNumber?(u=v.endLineNumber,f=Math.max(v.endColumn,a.endColumn)):(u=a.endLineNumber,f=a.endColumn),new D(c,s,u,f)}intersectRanges(a){return D.intersectRanges(this,a)}static intersectRanges(a,v){let c=a.startLineNumber,s=a.startColumn,u=a.endLineNumber,f=a.endColumn;const M=v.startLineNumber,h=v.startColumn,o=v.endLineNumber,e=v.endColumn;return c<M?(c=M,s=h):c===M&&(s=Math.max(s,h)),u>o?(u=o,f=e):u===o&&(f=Math.min(f,e)),c>u||c===u&&s>f?null:new D(c,s,u,f)}equalsRange(a){return D.equalsRange(this,a)}static equalsRange(a,v){return!a&&!v?!0:!!a&&!!v&&a.startLineNumber===v.startLineNumber&&a.startColumn===v.startColumn&&a.endLineNumber===v.endLineNumber&&a.endColumn===v.endColumn}getEndPosition(){return D.getEndPosition(this)}static getEndPosition(a){return new k.$Lr(a.endLineNumber,a.endColumn)}getStartPosition(){return D.getStartPosition(this)}static getStartPosition(a){return new k.$Lr(a.startLineNumber,a.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(a,v){return new D(this.startLineNumber,this.startColumn,a,v)}setStartPosition(a,v){return new D(a,v,this.endLineNumber,this.endColumn)}collapseToStart(){return D.collapseToStart(this)}static collapseToStart(a){return new D(a.startLineNumber,a.startColumn,a.startLineNumber,a.startColumn)}collapseToEnd(){return D.collapseToEnd(this)}static collapseToEnd(a){return new D(a.endLineNumber,a.endColumn,a.endLineNumber,a.endColumn)}delta(a){return new D(this.startLineNumber+a,this.startColumn,this.endLineNumber+a,this.endColumn)}static fromPositions(a,v=a){return new D(a.lineNumber,a.column,v.lineNumber,v.column)}static lift(a){return a?new D(a.startLineNumber,a.startColumn,a.endLineNumber,a.endColumn):null}static isIRange(a){return a&&typeof a.startLineNumber=="number"&&typeof a.startColumn=="number"&&typeof a.endLineNumber=="number"&&typeof a.endColumn=="number"}static areIntersectingOrTouching(a,v){return!(a.endLineNumber<v.startLineNumber||a.endLineNumber===v.startLineNumber&&a.endColumn<v.startColumn||v.endLineNumber<a.startLineNumber||v.endLineNumber===a.startLineNumber&&v.endColumn<a.startColumn)}static areIntersecting(a,v){return!(a.endLineNumber<v.startLineNumber||a.endLineNumber===v.startLineNumber&&a.endColumn<=v.startColumn||v.endLineNumber<a.startLineNumber||v.endLineNumber===a.startLineNumber&&v.endColumn<=a.startColumn)}static compareRangesUsingStarts(a,v){if(a&&v){const u=a.startLineNumber|0,f=v.startLineNumber|0;if(u===f){const M=a.startColumn|0,h=v.startColumn|0;if(M===h){const o=a.endLineNumber|0,e=v.endLineNumber|0;if(o===e){const N=a.endColumn|0,y=v.endColumn|0;return N-y}return o-e}return M-h}return u-f}return(a?1:0)-(v?1:0)}static compareRangesUsingEnds(a,v){return a.endLineNumber===v.endLineNumber?a.endColumn===v.endColumn?a.startLineNumber===v.startLineNumber?a.startColumn-v.startColumn:a.startLineNumber-v.startLineNumber:a.endColumn-v.endColumn:a.endLineNumber-v.endLineNumber}static spansMultipleLines(a){return a.endLineNumber>a.startLineNumber}toJSON(){return this}}t.$Mr=D}),Y(Z[35],K([0,1,2]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tr=void 0;class D{static insert(a,v){return{range:new k.$Mr(a.lineNumber,a.column,a.lineNumber,a.column),text:v,forceMoveMarkers:!0}}static delete(a){return{range:a,text:null}}static replace(a,v){return{range:a,text:v}}static replaceMove(a,v){return{range:a,text:v,forceMoveMarkers:!0}}}t.$Tr=D}),Y(Z[12],K([0,1,3,2]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nr=void 0;class i{static fromRange(v){return new i(v.startLineNumber,v.endLineNumber)}static subtract(v,c){return c?v.startLineNumber<c.startLineNumber&&c.endLineNumberExclusive<v.endLineNumberExclusive?[new i(v.startLineNumber,c.startLineNumber),new i(c.endLineNumberExclusive,v.endLineNumberExclusive)]:c.startLineNumber<=v.startLineNumber&&v.endLineNumberExclusive<=c.endLineNumberExclusive?[]:c.endLineNumberExclusive<v.endLineNumberExclusive?[new i(Math.max(c.endLineNumberExclusive,v.startLineNumber),v.endLineNumberExclusive)]:[new i(v.startLineNumber,Math.min(c.startLineNumber,v.endLineNumberExclusive))]:[v]}static joinMany(v){if(v.length===0)return[];let c=v[0];for(let s=1;s<v.length;s++)c=this.join(c,v[s]);return c}static join(v,c){if(v.length===0)return c;if(c.length===0)return v;const s=[];let u=0,f=0,M=null;for(;u<v.length||f<c.length;){let h=null;if(u<v.length&&f<c.length){const o=v[u],e=c[f];o.startLineNumber<e.startLineNumber?(h=o,u++):(h=e,f++)}else u<v.length?(h=v[u],u++):(h=c[f],f++);M===null?M=h:M.endLineNumberExclusive>=h.startLineNumber?M=new i(M.startLineNumber,Math.max(M.endLineNumberExclusive,h.endLineNumberExclusive)):(s.push(M),M=h)}return M!==null&&s.push(M),s}static ofLength(v,c){return new i(v,v+c)}static deserialize(v){return new i(v[0],v[1])}constructor(v,c){if(v>c)throw new k.$bb(`startLineNumber ${v} cannot be after endLineNumberExclusive ${c}`);this.startLineNumber=v,this.endLineNumberExclusive=c}contains(v){return this.startLineNumber<=v&&v<this.endLineNumberExclusive}get isEmpty(){return this.startLineNumber===this.endLineNumberExclusive}delta(v){return new i(this.startLineNumber+v,this.endLineNumberExclusive+v)}get length(){return this.endLineNumberExclusive-this.startLineNumber}join(v){return new i(Math.min(this.startLineNumber,v.startLineNumber),Math.max(this.endLineNumberExclusive,v.endLineNumberExclusive))}toString(){return`[${this.startLineNumber},${this.endLineNumberExclusive})`}intersect(v){const c=Math.max(this.startLineNumber,v.startLineNumber),s=Math.min(this.endLineNumberExclusive,v.endLineNumberExclusive);if(c<=s)return new i(c,s)}intersectsStrict(v){return this.startLineNumber<v.endLineNumberExclusive&&v.startLineNumber<this.endLineNumberExclusive}overlapOrTouch(v){return this.startLineNumber<=v.endLineNumberExclusive&&v.startLineNumber<=this.endLineNumberExclusive}equals(v){return this.startLineNumber===v.startLineNumber&&this.endLineNumberExclusive===v.endLineNumberExclusive}toInclusiveRange(){return this.isEmpty?null:new D.$Mr(this.startLineNumber,1,this.endLineNumberExclusive-1,Number.MAX_SAFE_INTEGER)}toExclusiveRange(){return new D.$Mr(this.startLineNumber,1,this.endLineNumberExclusive,1)}mapToLineArray(v){const c=[];for(let s=this.startLineNumber;s<this.endLineNumberExclusive;s++)c.push(v(s));return c}forEach(v){for(let c=this.startLineNumber;c<this.endLineNumberExclusive;c++)v(c)}serialize(){return[this.startLineNumber,this.endLineNumberExclusive]}includes(v){return this.startLineNumber<=v&&v<this.endLineNumberExclusive}}t.$Nr=i}),Y(Z[36],K([0,1,4,2]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ur=t.SelectionDirection=void 0;var i;(function(v){v[v.LTR=0]="LTR",v[v.RTL=1]="RTL"})(i||(t.SelectionDirection=i={}));class a extends D.$Mr{constructor(c,s,u,f){super(c,s,u,f),this.selectionStartLineNumber=c,this.selectionStartColumn=s,this.positionLineNumber=u,this.positionColumn=f}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(c){return a.selectionsEqual(this,c)}static selectionsEqual(c,s){return c.selectionStartLineNumber===s.selectionStartLineNumber&&c.selectionStartColumn===s.selectionStartColumn&&c.positionLineNumber===s.positionLineNumber&&c.positionColumn===s.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(c,s){return this.getDirection()===0?new a(this.startLineNumber,this.startColumn,c,s):new a(c,s,this.startLineNumber,this.startColumn)}getPosition(){return new k.$Lr(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new k.$Lr(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(c,s){return this.getDirection()===0?new a(c,s,this.endLineNumber,this.endColumn):new a(this.endLineNumber,this.endColumn,c,s)}static fromPositions(c,s=c){return new a(c.lineNumber,c.column,s.lineNumber,s.column)}static fromRange(c,s){return s===0?new a(c.startLineNumber,c.startColumn,c.endLineNumber,c.endColumn):new a(c.endLineNumber,c.endColumn,c.startLineNumber,c.startColumn)}static liftSelection(c){return new a(c.selectionStartLineNumber,c.selectionStartColumn,c.positionLineNumber,c.positionColumn)}static selectionsArrEqual(c,s){if(c&&!s||!c&&s)return!1;if(!c&&!s)return!0;if(c.length!==s.length)return!1;for(let u=0,f=c.length;u<f;u++)if(!this.selectionsEqual(c[u],s[u]))return!1;return!0}static isISelection(c){return c&&typeof c.selectionStartLineNumber=="number"&&typeof c.selectionStartColumn=="number"&&typeof c.positionLineNumber=="number"&&typeof c.positionColumn=="number"}static createWithDirection(c,s,u,f,M){return M===0?new a(c,s,u,f):new a(u,f,c,s)}}t.$Ur=a}),Y(Z[37],K([0,1,23]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4r=t.$3r=t.WordCharacterClass=void 0;var D;(function(v){v[v.Regular=0]="Regular",v[v.Whitespace=1]="Whitespace",v[v.WordSeparator=2]="WordSeparator"})(D||(t.WordCharacterClass=D={}));class i extends k.$1r{constructor(c){super(0);for(let s=0,u=c.length;s<u;s++)this.set(c.charCodeAt(s),2);this.set(32,1),this.set(9,1)}}t.$3r=i;function a(v){const c={};return s=>(c.hasOwnProperty(s)||(c[s]=v(s)),c[s])}t.$4r=a(v=>new i(v))}),Y(Z[24],K([0,1,16,7,17]),function(H,t,k,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kr=t.$Jr=t.$Ir=t.$Hr=t.$Gr=void 0,t.$Gr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function a(M=""){let h="(-?\\d*\\.\\d\\w*)|([^";for(const o of t.$Gr)M.indexOf(o)>=0||(h+="\\"+o);return h+="\\s]+)",new RegExp(h,"g")}t.$Hr=a();function v(M){let h=t.$Hr;if(M&&M instanceof RegExp)if(M.global)h=M;else{let o="g";M.ignoreCase&&(o+="i"),M.multiline&&(o+="m"),M.unicode&&(o+="u"),h=new RegExp(M.source,o)}return h.lastIndex=0,h}t.$Ir=v;const c=new i.$lc;c.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function s(M){const h=c.unshift(M);return(0,D.$jb)(h)}t.$Jr=s;function u(M,h,o,e,N){if(N||(N=k.Iterable.first(c)),o.length>N.maxLen){let g=M-N.maxLen/2;return g<0?g=0:e+=g,o=o.substring(g,M+N.maxLen/2),u(M,h,o,e,N)}const y=Date.now(),R=M-1-e;let b=-1,E=null;for(let g=1;!(Date.now()-y>=N.timeBudget);g++){const m=R-N.windowSize*g;h.lastIndex=Math.max(0,m);const r=f(h,o,R,b);if(!r&&E||(E=r,m<=0))break;b=m}if(E){const g={word:E[0],startColumn:e+1+E.index,endColumn:e+1+E.index+E[0].length};return h.lastIndex=0,g}return null}t.$Kr=u;function f(M,h,o,e){let N;for(;N=M.exec(h);){const y=N.index||0;if(y<=o&&M.lastIndex>=o)return N;if(e>0&&y>e)return null}return null}}),Y(Z[9],K([0,1,3,6]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cX=t.$bX=t.$aX=t.$_W=void 0;class i{static trivial(u,f){return new i([new a(new D.$bC(0,u.length),new D.$bC(0,f.length))],!1)}static trivialTimedOut(u,f){return new i([new a(new D.$bC(0,u.length),new D.$bC(0,f.length))],!0)}constructor(u,f){this.diffs=u,this.hitTimeout=f}}t.$_W=i;class a{constructor(u,f){this.seq1Range=u,this.seq2Range=f}reverse(){return new a(this.seq2Range,this.seq1Range)}toString(){return`${this.seq1Range} <-> ${this.seq2Range}`}join(u){return new a(this.seq1Range.join(u.seq1Range),this.seq2Range.join(u.seq2Range))}delta(u){return u===0?this:new a(this.seq1Range.delta(u),this.seq2Range.delta(u))}}t.$aX=a;class v{static{this.instance=new v}isValid(){return!0}}t.$bX=v;class c{constructor(u){if(this.c=u,this.a=Date.now(),this.b=!0,u<=0)throw new k.$bb("timeout must be positive")}isValid(){if(!(Date.now()-this.a<this.c)&&this.b){this.b=!1;debugger}return this.b}disable(){this.c=Number.MAX_SAFE_INTEGER,this.isValid=()=>!0,this.b=!0}}t.$cX=c}),Y(Z[38],K([0,1,6,9]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jX=t.$iX=t.$hX=t.$gX=t.$fX=void 0;function i(f,M,h){let o=h;return o=c(f,M,o),o=s(f,M,o),o}t.$fX=i;function a(f,M,h){const o=[];for(const e of h){const N=o[o.length-1];if(!N){o.push(e);continue}e.seq1Range.start-N.seq1Range.endExclusive<=2||e.seq2Range.start-N.seq2Range.endExclusive<=2?o[o.length-1]=new D.$aX(N.seq1Range.join(e.seq1Range),N.seq2Range.join(e.seq2Range)):o.push(e)}return o}t.$gX=a;function v(f,M,h){let o=h;if(o.length===0)return o;let e=0,N;do{N=!1;const y=[o[0]];for(let R=1;R<o.length;R++){let g=function(r,l){const A=new k.$bC(E.seq1Range.endExclusive,b.seq1Range.start);if(f.countLinesIn(A)>5||A.length>500)return!1;const $=f.getText(A).trim();if($.length>20||$.split(/\r\n|\r|\n/).length>1)return!1;const w=f.countLinesIn(r.seq1Range),L=r.seq1Range.length,p=M.countLinesIn(r.seq2Range),F=r.seq2Range.length,P=f.countLinesIn(l.seq1Range),I=l.seq1Range.length,O=M.countLinesIn(l.seq2Range),U=l.seq2Range.length,C=2*40+50;function _(W){return Math.min(W,C)}return Math.pow(Math.pow(_(w*40+L),1.5)+Math.pow(_(p*40+F),1.5),1.5)+Math.pow(Math.pow(_(P*40+I),1.5)+Math.pow(_(O*40+U),1.5),1.5)>(C**1.5)**1.5*1.3};const b=o[R],E=y[y.length-1];g(E,b)?(N=!0,y[y.length-1]=y[y.length-1].join(b)):y.push(b)}o=y}while(e++<10&&N);return o}t.$hX=v;function c(f,M,h){if(h.length===0)return h;const o=[];o.push(h[0]);for(let N=1;N<h.length;N++){const y=o[o.length-1];let R=h[N];if(R.seq1Range.isEmpty||R.seq2Range.isEmpty){const b=R.seq1Range.start-y.seq1Range.endExclusive;let E;for(E=1;E<=b&&!(f.getElement(R.seq1Range.start-E)!==f.getElement(R.seq1Range.endExclusive-E)||M.getElement(R.seq2Range.start-E)!==M.getElement(R.seq2Range.endExclusive-E));E++);if(E--,E===b){o[o.length-1]=new D.$aX(new k.$bC(y.seq1Range.start,R.seq1Range.endExclusive-b),new k.$bC(y.seq2Range.start,R.seq2Range.endExclusive-b));continue}R=R.delta(-E)}o.push(R)}const e=[];for(let N=0;N<o.length-1;N++){const y=o[N+1];let R=o[N];if(R.seq1Range.isEmpty||R.seq2Range.isEmpty){const b=y.seq1Range.start-R.seq1Range.endExclusive;let E;for(E=0;E<b&&!(f.getElement(R.seq1Range.start+E)!==f.getElement(R.seq1Range.endExclusive+E)||M.getElement(R.seq2Range.start+E)!==M.getElement(R.seq2Range.endExclusive+E));E++);if(E===b){o[N+1]=new D.$aX(new k.$bC(R.seq1Range.start+b,y.seq1Range.endExclusive),new k.$bC(R.seq2Range.start+b,y.seq2Range.endExclusive));continue}E>0&&(R=R.delta(E))}e.push(R)}return o.length>0&&e.push(o[o.length-1]),e}t.$iX=c;function s(f,M,h){if(!f.getBoundaryScore||!M.getBoundaryScore)return h;for(let o=0;o<h.length;o++){const e=o>0?h[o-1]:void 0,N=h[o],y=o+1<h.length?h[o+1]:void 0,R=new k.$bC(e?e.seq1Range.start+1:0,y?y.seq1Range.endExclusive-1:f.length),b=new k.$bC(e?e.seq2Range.start+1:0,y?y.seq2Range.endExclusive-1:M.length);N.seq1Range.isEmpty?h[o]=u(N,f,M,R,b):N.seq2Range.isEmpty&&(h[o]=u(N.reverse(),M,f,b,R).reverse())}return h}t.$jX=s;function u(f,M,h,o,e){let y=1;for(;f.seq1Range.start-y>=o.start&&f.seq2Range.start-y>=e.start&&h.getElement(f.seq2Range.start-y)===h.getElement(f.seq2Range.endExclusive-y)&&y<100;)y++;y--;let R=0;for(;f.seq1Range.start+R<o.endExclusive&&f.seq2Range.endExclusive+R<e.endExclusive&&h.getElement(f.seq2Range.start+R)===h.getElement(f.seq2Range.endExclusive+R)&&R<100;)R++;if(y===0&&R===0)return f;let b=0,E=-1;for(let g=-y;g<=R;g++){const m=f.seq2Range.start+g,r=f.seq2Range.endExclusive+g,l=f.seq1Range.start+g,A=M.getBoundaryScore(l)+h.getBoundaryScore(m)+h.getBoundaryScore(r);A>E&&(E=A,b=g)}return f.delta(b)}}),Y(Z[39],K([0,1,6,9]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kX=void 0;class i{compute(u,f,M=D.$bX.instance){if(u.length===0||f.length===0)return D.$_W.trivial(u,f);function h(m,r){for(;m<u.length&&r<f.length&&u.getElement(m)===f.getElement(r);)m++,r++;return m}let o=0;const e=new v;e.set(0,h(0,0));const N=new c;N.set(0,e.get(0)===0?null:new a(null,0,0,e.get(0)));let y=0;e:for(;;){if(o++,!M.isValid())return D.$_W.trivialTimedOut(u,f);const m=-Math.min(o,f.length+o%2),r=Math.min(o,u.length+o%2);for(y=m;y<=r;y+=2){const l=y===r?-1:e.get(y+1),A=y===m?-1:e.get(y-1)+1,d=Math.min(Math.max(l,A),u.length),$=d-y;if(d>u.length||$>f.length)continue;const w=h(d,$);e.set(y,w);const L=d===l?N.get(y+1):N.get(y-1);if(N.set(y,w!==d?new a(L,d,$,w-d):L),e.get(y)===u.length&&e.get(y)-y===f.length)break e}}let R=N.get(y);const b=[];let E=u.length,g=f.length;for(;;){const m=R?R.x+R.length:0,r=R?R.y+R.length:0;if((m!==E||r!==g)&&b.push(new D.$aX(new k.$bC(m,E),new k.$bC(r,g))),!R)break;E=R.x,g=R.y,R=R.prev}return b.reverse(),new D.$_W(b,!1)}}t.$kX=i;class a{constructor(u,f,M,h){this.prev=u,this.x=f,this.y=M,this.length=h}}class v{constructor(){this.a=new Int32Array(10),this.b=new Int32Array(10)}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,f){if(u<0){if(u=-u-1,u>=this.b.length){const M=this.b;this.b=new Int32Array(M.length*2),this.b.set(M)}this.b[u]=f}else{if(u>=this.a.length){const M=this.a;this.a=new Int32Array(M.length*2),this.a.set(M)}this.a[u]=f}}}class c{constructor(){this.a=[],this.b=[]}get(u){return u<0?(u=-u-1,this.b[u]):this.a[u]}set(u,f){u<0?(u=-u-1,this.b[u]=f):this.a[u]=f}}}),Y(Z[40],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dX=void 0;class k{constructor(i,a){this.width=i,this.height=a,this.a=[],this.a=new Array(i*a)}get(i,a){return this.a[i+a*this.width]}set(i,a,v){this.a[i+a*this.width]=v}}t.$dX=k}),Y(Z[41],K([0,1,6,9,40]),function(H,t,k,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eX=void 0;class a{compute(c,s,u=D.$bX.instance,f){if(c.length===0||s.length===0)return D.$_W.trivial(c,s);const M=new i.$dX(c.length,s.length),h=new i.$dX(c.length,s.length),o=new i.$dX(c.length,s.length);for(let g=0;g<c.length;g++)for(let m=0;m<s.length;m++){if(!u.isValid())return D.$_W.trivialTimedOut(c,s);const r=g===0?0:M.get(g-1,m),l=m===0?0:M.get(g,m-1);let A;c.getElement(g)===s.getElement(m)?(g===0||m===0?A=0:A=M.get(g-1,m-1),g>0&&m>0&&h.get(g-1,m-1)===3&&(A+=o.get(g-1,m-1)),A+=f?f(g,m):1):A=-1;const d=Math.max(r,l,A);if(d===A){const $=g>0&&m>0?o.get(g-1,m-1):0;o.set(g,m,$+1),h.set(g,m,3)}else d===r?(o.set(g,m,0),h.set(g,m,1)):d===l&&(o.set(g,m,0),h.set(g,m,2));M.set(g,m,d)}const e=[];let N=c.length,y=s.length;function R(g,m){(g+1!==N||m+1!==y)&&e.push(new D.$aX(new k.$bC(g+1,N),new k.$bC(m+1,y))),N=g,y=m}let b=c.length-1,E=s.length-1;for(;b>=0&&E>=0;)h.get(b,E)===3?(R(b,E),b--,E--):h.get(b,E)===1?b--:E--;return R(-1,-1),e.reverse(),new D.$_W(e,!1)}}t.$eX=a}),Y(Z[25],K([0,1,12]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sr=t.$Rr=t.$Qr=t.$Pr=t.$Or=void 0;class D{constructor(u,f,M){this.changes=u,this.moves=f,this.hitTimeout=M}}t.$Or=D;class i{static inverse(u,f,M){const h=[];let o=1,e=1;for(const y of u){const R=new i(new k.$Nr(o,y.originalRange.startLineNumber),new k.$Nr(e,y.modifiedRange.startLineNumber),void 0);R.modifiedRange.isEmpty||h.push(R),o=y.originalRange.endLineNumberExclusive,e=y.modifiedRange.endLineNumberExclusive}const N=new i(new k.$Nr(o,f+1),new k.$Nr(e,M+1),void 0);return N.modifiedRange.isEmpty||h.push(N),h}constructor(u,f,M){this.originalRange=u,this.modifiedRange=f,this.innerChanges=M}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}get changedLineCount(){return Math.max(this.originalRange.length,this.modifiedRange.length)}flip(){return new i(this.modifiedRange,this.originalRange,this.innerChanges?.map(u=>u.flip()))}}t.$Pr=i;class a{constructor(u,f){this.originalRange=u,this.modifiedRange=f}toString(){return`{${this.originalRange.toString()}->${this.modifiedRange.toString()}}`}flip(){return new a(this.modifiedRange,this.originalRange)}}t.$Qr=a;class v{constructor(u,f){this.original=u,this.modified=f}toString(){return`{${this.original.toString()}->${this.modified.toString()}}`}flip(){return new v(this.modified,this.original)}}t.$Rr=v;class c{constructor(u,f){this.lineRangeMapping=u,this.changes=f}flip(){return new c(this.lineRangeMapping.flip(),this.changes.map(u=>u.flip()))}}t.$Sr=c}),Y(Z[26],K([0,1,20,25,5,2,10,12]),function(H,t,k,D,i,a,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ou=t.$nu=void 0;const s=3;class u{computeDiff(m,r,l){const d=new y(m,r,{maxComputationTime:l.maxComputationTimeMs,shouldIgnoreTrimWhitespace:l.ignoreTrimWhitespace,shouldComputeCharChanges:!0,shouldMakePrettyDiff:!0,shouldPostProcessCharChanges:!0}).computeDiff(),$=[];let w=null;for(const L of d.changes){let p;L.originalEndLineNumber===0?p=new c.$Nr(L.originalStartLineNumber+1,L.originalStartLineNumber+1):p=new c.$Nr(L.originalStartLineNumber,L.originalEndLineNumber+1);let F;L.modifiedEndLineNumber===0?F=new c.$Nr(L.modifiedStartLineNumber+1,L.modifiedStartLineNumber+1):F=new c.$Nr(L.modifiedStartLineNumber,L.modifiedEndLineNumber+1);let P=new D.$Pr(p,F,L.charChanges?.map(I=>new D.$Qr(new a.$Mr(I.originalStartLineNumber,I.originalStartColumn,I.originalEndLineNumber,I.originalEndColumn),new a.$Mr(I.modifiedStartLineNumber,I.modifiedStartColumn,I.modifiedEndLineNumber,I.modifiedEndColumn))));w&&(w.modifiedRange.endLineNumberExclusive===P.modifiedRange.startLineNumber||w.originalRange.endLineNumberExclusive===P.originalRange.startLineNumber)&&(P=new D.$Pr(w.originalRange.join(P.originalRange),w.modifiedRange.join(P.modifiedRange),w.innerChanges&&P.innerChanges?w.innerChanges.concat(P.innerChanges):void 0),$.pop()),$.push(P),w=P}return(0,v.$pc)(()=>(0,v.$qc)($,(L,p)=>p.originalRange.startLineNumber-L.originalRange.endLineNumberExclusive===p.modifiedRange.startLineNumber-L.modifiedRange.endLineNumberExclusive&&L.originalRange.endLineNumberExclusive<p.originalRange.startLineNumber&&L.modifiedRange.endLineNumberExclusive<p.modifiedRange.startLineNumber)),new D.$Or($,[],d.quitEarly)}}t.$nu=u;function f(g,m,r,l){return new k.$mu(g,m,r).ComputeDiff(l)}class M{constructor(m){const r=[],l=[];for(let A=0,d=m.length;A<d;A++)r[A]=R(m[A],1),l[A]=b(m[A],1);this.lines=m,this.a=r,this.b=l}getElements(){const m=[];for(let r=0,l=this.lines.length;r<l;r++)m[r]=this.lines[r].substring(this.a[r]-1,this.b[r]-1);return m}getStrictElement(m){return this.lines[m]}getStartLineNumber(m){return m+1}getEndLineNumber(m){return m+1}createCharSequence(m,r,l){const A=[],d=[],$=[];let w=0;for(let L=r;L<=l;L++){const p=this.lines[L],F=m?this.a[L]:1,P=m?this.b[L]:p.length+1;for(let I=F;I<P;I++)A[w]=p.charCodeAt(I-1),d[w]=L+1,$[w]=I,w++;!m&&L<l&&(A[w]=10,d[w]=L+1,$[w]=p.length+1,w++)}return new h(A,d,$)}}class h{constructor(m,r,l){this.a=m,this.b=r,this.d=l}toString(){return"["+this.a.map((m,r)=>(m===10?"\\n":String.fromCharCode(m))+`-(${this.b[r]},${this.d[r]})`).join(", ")+"]"}e(m,r){if(m<0||m>=r.length)throw new Error("Illegal index")}getElements(){return this.a}getStartLineNumber(m){return m>0&&m===this.b.length?this.getEndLineNumber(m-1):(this.e(m,this.b),this.b[m])}getEndLineNumber(m){return m===-1?this.getStartLineNumber(m+1):(this.e(m,this.b),this.a[m]===10?this.b[m]+1:this.b[m])}getStartColumn(m){return m>0&&m===this.d.length?this.getEndColumn(m-1):(this.e(m,this.d),this.d[m])}getEndColumn(m){return m===-1?this.getStartColumn(m+1):(this.e(m,this.d),this.a[m]===10?1:this.d[m]+1)}}class o{constructor(m,r,l,A,d,$,w,L){this.originalStartLineNumber=m,this.originalStartColumn=r,this.originalEndLineNumber=l,this.originalEndColumn=A,this.modifiedStartLineNumber=d,this.modifiedStartColumn=$,this.modifiedEndLineNumber=w,this.modifiedEndColumn=L}static createFromDiffChange(m,r,l){const A=r.getStartLineNumber(m.originalStart),d=r.getStartColumn(m.originalStart),$=r.getEndLineNumber(m.originalStart+m.originalLength-1),w=r.getEndColumn(m.originalStart+m.originalLength-1),L=l.getStartLineNumber(m.modifiedStart),p=l.getStartColumn(m.modifiedStart),F=l.getEndLineNumber(m.modifiedStart+m.modifiedLength-1),P=l.getEndColumn(m.modifiedStart+m.modifiedLength-1);return new o(A,d,$,w,L,p,F,P)}}function e(g){if(g.length<=1)return g;const m=[g[0]];let r=m[0];for(let l=1,A=g.length;l<A;l++){const d=g[l],$=d.originalStart-(r.originalStart+r.originalLength),w=d.modifiedStart-(r.modifiedStart+r.modifiedLength);Math.min($,w)<s?(r.originalLength=d.originalStart+d.originalLength-r.originalStart,r.modifiedLength=d.modifiedStart+d.modifiedLength-r.modifiedStart):(m.push(d),r=d)}return m}class N{constructor(m,r,l,A,d){this.originalStartLineNumber=m,this.originalEndLineNumber=r,this.modifiedStartLineNumber=l,this.modifiedEndLineNumber=A,this.charChanges=d}static createFromDiffResult(m,r,l,A,d,$,w){let L,p,F,P,I;if(r.originalLength===0?(L=l.getStartLineNumber(r.originalStart)-1,p=0):(L=l.getStartLineNumber(r.originalStart),p=l.getEndLineNumber(r.originalStart+r.originalLength-1)),r.modifiedLength===0?(F=A.getStartLineNumber(r.modifiedStart)-1,P=0):(F=A.getStartLineNumber(r.modifiedStart),P=A.getEndLineNumber(r.modifiedStart+r.modifiedLength-1)),$&&r.originalLength>0&&r.originalLength<20&&r.modifiedLength>0&&r.modifiedLength<20&&d()){const O=l.createCharSequence(m,r.originalStart,r.originalStart+r.originalLength-1),U=A.createCharSequence(m,r.modifiedStart,r.modifiedStart+r.modifiedLength-1);if(O.getElements().length>0&&U.getElements().length>0){let C=f(O,U,d,!0).changes;w&&(C=e(C)),I=[];for(let _=0,W=C.length;_<W;_++)I.push(o.createFromDiffChange(C[_],O,U))}}return new N(L,p,F,P,I)}}class y{constructor(m,r,l){this.a=l.shouldComputeCharChanges,this.b=l.shouldPostProcessCharChanges,this.d=l.shouldIgnoreTrimWhitespace,this.e=l.shouldMakePrettyDiff,this.f=m,this.g=r,this.h=new M(m),this.j=new M(r),this.k=E(l.maxComputationTime),this.l=E(l.maxComputationTime===0?0:Math.min(l.maxComputationTime,5e3))}computeDiff(){if(this.h.lines.length===1&&this.h.lines[0].length===0)return this.j.lines.length===1&&this.j.lines[0].length===0?{quitEarly:!1,changes:[]}:{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:1,modifiedStartLineNumber:1,modifiedEndLineNumber:this.j.lines.length,charChanges:void 0}]};if(this.j.lines.length===1&&this.j.lines[0].length===0)return{quitEarly:!1,changes:[{originalStartLineNumber:1,originalEndLineNumber:this.h.lines.length,modifiedStartLineNumber:1,modifiedEndLineNumber:1,charChanges:void 0}]};const m=f(this.h,this.j,this.k,this.e),r=m.changes,l=m.quitEarly;if(this.d){const w=[];for(let L=0,p=r.length;L<p;L++)w.push(N.createFromDiffResult(this.d,r[L],this.h,this.j,this.l,this.a,this.b));return{quitEarly:l,changes:w}}const A=[];let d=0,$=0;for(let w=-1,L=r.length;w<L;w++){const p=w+1<L?r[w+1]:null,F=p?p.originalStart:this.f.length,P=p?p.modifiedStart:this.g.length;for(;d<F&&$<P;){const I=this.f[d],O=this.g[$];if(I!==O){{let U=R(I,1),C=R(O,1);for(;U>1&&C>1;){const _=I.charCodeAt(U-2),W=O.charCodeAt(C-2);if(_!==W)break;U--,C--}(U>1||C>1)&&this.m(A,d+1,1,U,$+1,1,C)}{let U=b(I,1),C=b(O,1);const _=I.length+1,W=O.length+1;for(;U<_&&C<W;){const G=I.charCodeAt(U-1),X=I.charCodeAt(C-1);if(G!==X)break;U++,C++}(U<_||C<W)&&this.m(A,d+1,U,_,$+1,C,W)}}d++,$++}p&&(A.push(N.createFromDiffResult(this.d,p,this.h,this.j,this.l,this.a,this.b)),d+=p.originalLength,$+=p.modifiedLength)}return{quitEarly:l,changes:A}}m(m,r,l,A,d,$,w){if(this.n(m,r,l,A,d,$,w))return;let L;this.a&&(L=[new o(r,l,r,A,d,$,d,w)]),m.push(new N(r,r,d,d,L))}n(m,r,l,A,d,$,w){const L=m.length;if(L===0)return!1;const p=m[L-1];return p.originalEndLineNumber===0||p.modifiedEndLineNumber===0?!1:p.originalEndLineNumber===r&&p.modifiedEndLineNumber===d?(this.a&&p.charChanges&&p.charChanges.push(new o(r,l,r,A,d,$,d,w)),!0):p.originalEndLineNumber+1===r&&p.modifiedEndLineNumber+1===d?(p.originalEndLineNumber=r,p.modifiedEndLineNumber=d,this.a&&p.charChanges&&p.charChanges.push(new o(r,l,r,A,d,$,d,w)),!0):!1}}t.$ou=y;function R(g,m){const r=i.$Ad(g);return r===-1?m:r+1}function b(g,m){const r=i.$Cd(g);return r===-1?m:r+2}function E(g){if(g===0)return()=>!0;const m=Date.now();return()=>Date.now()-m<g}}),Y(Z[42],K([0,1,10,12,6,4,2,9,41,38,39,25]),function(H,t,k,D,i,a,v,c,s,u,f,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pX=t.$oX=t.$nX=t.$mX=t.$lX=void 0;class h{constructor(){this.b=new s.$eX,this.f=new f.$kX}computeDiff(P,I,O){if(P.length===1&&P[0].length===0||I.length===1&&I[0].length===0)return{changes:[new M.$Pr(new D.$Nr(1,P.length+1),new D.$Nr(1,I.length+1),[new M.$Qr(new v.$Mr(1,1,P.length,P[0].length+1),new v.$Mr(1,1,I.length,I[0].length+1))])],hitTimeout:!1,moves:[]};const U=O.maxComputationTimeMs===0?c.$bX.instance:new c.$cX(O.maxComputationTimeMs),C=!O.ignoreTrimWhitespace,_=new Map;function W(le){let ae=_.get(le);return ae===void 0&&(ae=_.size,_.set(le,ae)),ae}const G=P.map(le=>W(le.trim())),X=I.map(le=>W(le.trim())),ne=new b(G,P),n=new b(X,I),oe=(()=>ne.length+n.length<1500?this.b.compute(ne,n,U,(le,ae)=>P[le]===I[ae]?I[ae].length===0?.1:1+Math.log(1+I[ae].length):.99):this.f.compute(ne,n))();let ce=oe.diffs,me=oe.hitTimeout;ce=(0,u.$fX)(ne,n,ce);const ge=[],ve=le=>{if(C)for(let ae=0;ae<le;ae++){const ie=Le+ae,ue=Ae+ae;if(P[ie]!==I[ue]){const S=this.h(P,I,new c.$aX(new i.$bC(ie,ie+1),new i.$bC(ue,ue+1)),U,C);for(const q of S.mappings)ge.push(q);S.hitTimeout&&(me=!0)}}};let Le=0,Ae=0;for(const le of ce){(0,k.$pc)(()=>le.seq1Range.start-Le===le.seq2Range.start-Ae);const ae=le.seq1Range.start-Le;ve(ae),Le=le.seq1Range.endExclusive,Ae=le.seq2Range.endExclusive;const ie=this.h(P,I,le,U,C);ie.hitTimeout&&(me=!0);for(const ue of ie.mappings)ge.push(ue)}ve(P.length-Le);const Ne=N(ge,P,I),Fe=[];if(O.computeMoves){const le=Ne.filter(ie=>ie.modifiedRange.isEmpty&&ie.originalRange.length>=3).map(ie=>new p(ie.originalRange,P)),ae=new Set(Ne.filter(ie=>ie.originalRange.isEmpty&&ie.modifiedRange.length>=3).map(ie=>new p(ie.modifiedRange,I)));for(const ie of le){let ue=-1,S;for(const q of ae){const B=ie.computeSimilarity(q);B>ue&&(ue=B,S=q)}if(ue>.9&&S){const q=this.h(P,I,new c.$aX(new i.$bC(ie.range.startLineNumber-1,ie.range.endLineNumberExclusive-1),new i.$bC(S.range.startLineNumber-1,S.range.endLineNumberExclusive-1)),U,C),B=N(q.mappings,P,I,!0);ae.delete(S),Fe.push(new M.$Sr(new M.$Rr(ie.range,S.range),B))}}}return(0,k.$pc)(()=>{function le(ie,ue){if(ie.lineNumber<1||ie.lineNumber>ue.length)return!1;const S=ue[ie.lineNumber-1];return!(ie.column<1||ie.column>S.length+1)}function ae(ie,ue){return!(ie.startLineNumber<1||ie.startLineNumber>ue.length+1||ie.endLineNumberExclusive<1||ie.endLineNumberExclusive>ue.length+1)}for(const ie of Ne){if(!ie.innerChanges)return!1;for(const ue of ie.innerChanges)if(!(le(ue.modifiedRange.getStartPosition(),I)&&le(ue.modifiedRange.getEndPosition(),I)&&le(ue.originalRange.getStartPosition(),P)&&le(ue.originalRange.getEndPosition(),P)))return!1;if(!ae(ie.modifiedRange,I)||!ae(ie.originalRange,P))return!1}return!0}),new M.$Or(Ne,Fe,me)}h(P,I,O,U,C){const _=new g(P,O.seq1Range,C),W=new g(I,O.seq2Range,C),G=_.length+W.length<500?this.b.compute(_,W,U):this.f.compute(_,W,U);let X=G.diffs;return X=(0,u.$fX)(_,W,X),X=o(_,W,X),X=(0,u.$gX)(_,W,X),X=(0,u.$hX)(_,W,X),{mappings:X.map(n=>new M.$Qr(_.translateRange(n.seq1Range),W.translateRange(n.seq2Range))),hitTimeout:G.hitTimeout}}}t.$lX=h;function o(F,P,I){const O=[];let U;function C(){if(!U)return;const W=U.s1Range.length-U.deleted,G=U.s2Range.length-U.added;Math.max(U.deleted,U.added)+(U.count-1)>W&&O.push(new c.$aX(U.s1Range,U.s2Range)),U=void 0}for(const W of I){let G=function(ce,me){if(!U||!U.s1Range.containsRange(ce)||!U.s2Range.containsRange(me))if(U&&!(U.s1Range.endExclusive<ce.start&&U.s2Range.endExclusive<me.start)){const Le=i.$bC.tryCreate(U.s1Range.endExclusive,ce.start),Ae=i.$bC.tryCreate(U.s2Range.endExclusive,me.start);U.deleted+=Le?.length??0,U.added+=Ae?.length??0,U.s1Range=U.s1Range.join(ce),U.s2Range=U.s2Range.join(me)}else C(),U={added:0,deleted:0,count:0,s1Range:ce,s2Range:me};const ge=ce.intersect(W.seq1Range),ve=me.intersect(W.seq2Range);U.count++,U.deleted+=ge?.length??0,U.added+=ve?.length??0};const X=F.findWordContaining(W.seq1Range.start-1),ne=P.findWordContaining(W.seq2Range.start-1),n=F.findWordContaining(W.seq1Range.endExclusive),oe=P.findWordContaining(W.seq2Range.endExclusive);X&&n&&ne&&oe&&X.equals(n)&&ne.equals(oe)?G(X,ne):(X&&ne&&G(X,ne),n&&oe&&G(n,oe))}return C(),e(I,O)}function e(F,P){const I=[];for(;F.length>0||P.length>0;){const O=F[0],U=P[0];let C;O&&(!U||O.seq1Range.start<U.seq1Range.start)?C=F.shift():C=P.shift(),I.length>0&&I[I.length-1].seq1Range.endExclusive>=C.seq1Range.start?I[I.length-1]=I[I.length-1].join(C):I.push(C)}return I}function N(F,P,I,O=!1){const U=[];for(const C of R(F.map(_=>y(_,P,I)),(_,W)=>_.originalRange.overlapOrTouch(W.originalRange)||_.modifiedRange.overlapOrTouch(W.modifiedRange))){const _=C[0],W=C[C.length-1];U.push(new M.$Pr(_.originalRange.join(W.originalRange),_.modifiedRange.join(W.modifiedRange),C.map(G=>G.innerChanges[0])))}return(0,k.$pc)(()=>!O&&U.length>0&&U[0].originalRange.startLineNumber!==U[0].modifiedRange.startLineNumber?!1:(0,k.$qc)(U,(C,_)=>_.originalRange.startLineNumber-C.originalRange.endLineNumberExclusive===_.modifiedRange.startLineNumber-C.modifiedRange.endLineNumberExclusive&&C.originalRange.endLineNumberExclusive<_.originalRange.startLineNumber&&C.modifiedRange.endLineNumberExclusive<_.modifiedRange.startLineNumber)),U}t.$mX=N;function y(F,P,I){let O=0,U=0;F.modifiedRange.endColumn===1&&F.originalRange.endColumn===1&&F.originalRange.startLineNumber+O<=F.originalRange.endLineNumber&&F.modifiedRange.startLineNumber+O<=F.modifiedRange.endLineNumber&&(U=-1),F.modifiedRange.startColumn-1>=I[F.modifiedRange.startLineNumber-1].length&&F.originalRange.startColumn-1>=P[F.originalRange.startLineNumber-1].length&&F.originalRange.startLineNumber<=F.originalRange.endLineNumber+U&&F.modifiedRange.startLineNumber<=F.modifiedRange.endLineNumber+U&&(O=1);const C=new D.$Nr(F.originalRange.startLineNumber+O,F.originalRange.endLineNumber+1+U),_=new D.$Nr(F.modifiedRange.startLineNumber+O,F.modifiedRange.endLineNumber+1+U);return new M.$Pr(C,_,[F])}t.$nX=y;function*R(F,P){let I,O;for(const U of F)O!==void 0&&P(O,U)?I.push(U):(I&&(yield I),I=[U]),O=U;I&&(yield I)}class b{constructor(P,I){this.b=P,this.f=I}getElement(P){return this.b[P]}get length(){return this.b.length}getBoundaryScore(P){const I=P===0?0:E(this.f[P-1]),O=P===this.f.length?0:E(this.f[P]);return 1e3-(I+O)}}t.$oX=b;function E(F){let P=0;for(;P<F.length&&(F.charCodeAt(P)===32||F.charCodeAt(P)===9);)P++;return P}class g{constructor(P,I,O){this.lines=P,this.considerWhitespaceChanges=O,this.b=[],this.f=[],this.h=[];let U=!1;I.start>0&&I.endExclusive>=P.length&&(I=new i.$bC(I.start-1,I.endExclusive),U=!0),this.lineRange=I;for(let C=this.lineRange.start;C<this.lineRange.endExclusive;C++){let _=P[C],W=0;if(U)W=_.length,_="",U=!1;else if(!O){const G=_.trimStart();W=_.length-G.length,_=G.trimEnd()}this.h.push(W);for(let G=0;G<_.length;G++)this.b.push(_.charCodeAt(G));C<P.length-1&&(this.b.push(`
`.charCodeAt(0)),this.f[C-this.lineRange.start]=this.b.length)}this.h.push(0)}toString(){return`Slice: "${this.text}"`}get text(){return this.getText(new i.$bC(0,this.length))}getText(P){return this.b.slice(P.start,P.endExclusive).map(I=>String.fromCharCode(I)).join("")}getElement(P){return this.b[P]}get length(){return this.b.length}getBoundaryScore(P){const I=d(P>0?this.b[P-1]:-1),O=d(P<this.b.length?this.b[P]:-1);if(I===6&&O===7)return 0;let U=0;return I!==O&&(U+=10,O===1&&(U+=1)),U+=A(I),U+=A(O),U}translateOffset(P){if(this.lineRange.isEmpty)return new a.$Lr(this.lineRange.start+1,1);let I=0,O=this.f.length;for(;I<O;){const C=Math.floor((I+O)/2);this.f[C]>P?O=C:I=C+1}const U=I===0?0:this.f[I-1];return new a.$Lr(this.lineRange.start+I+1,P-U+1+this.h[I])}translateRange(P){return v.$Mr.fromPositions(this.translateOffset(P.start),this.translateOffset(P.endExclusive))}findWordContaining(P){if(P<0||P>=this.b.length||!m(this.b[P]))return;let I=P;for(;I>0&&m(this.b[I-1]);)I--;let O=P;for(;O<this.b.length&&m(this.b[O]);)O++;return new i.$bC(I,O)}countLinesIn(P){return this.translateOffset(P.endExclusive).lineNumber-this.translateOffset(P.start).lineNumber}}t.$pX=g;function m(F){return F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57}var r;(function(F){F[F.WordLower=0]="WordLower",F[F.WordUpper=1]="WordUpper",F[F.WordNumber=2]="WordNumber",F[F.End=3]="End",F[F.Other=4]="Other",F[F.Space=5]="Space",F[F.LineBreakCR=6]="LineBreakCR",F[F.LineBreakLF=7]="LineBreakLF"})(r||(r={}));const l={[0]:0,[1]:0,[2]:0,[3]:10,[4]:2,[5]:3,[6]:10,[7]:10};function A(F){return l[F]}function d(F){return F===10?7:F===13?6:$(F)?5:F>=97&&F<=122?0:F>=65&&F<=90?1:F>=48&&F<=57?2:F===-1?3:4}function $(F){return F===32||F===9}const w=new Map;function L(F){let P=w.get(F);return P===void 0&&(P=w.size,w.set(F,P)),P}class p{constructor(P,I){this.range=P,this.lines=I,this.f=[];let O=0;for(let U=P.startLineNumber-1;U<P.endLineNumberExclusive-1;U++){const C=I[U];for(let W=0;W<C.length;W++){O++;const G=C[W],X=L(G);this.f[X]=(this.f[X]||0)+1}O++;const _=L(`
`);this.f[_]=(this.f[_]||0)+1}this.b=O}computeSimilarity(P){let I=0;const O=Math.max(this.f.length,P.f.length);for(let U=0;U<O;U++)I+=Math.abs((this.f[U]??0)-(P.f[U]??0));return 1-I/(this.b+P.b)}}}),Y(Z[43],K([0,1,26,42]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qX=void 0,t.$qX={getLegacy:()=>new k.$nu,getAdvanced:()=>new D.$lX}}),Y(Z[44],K([0,1,27]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rX=void 0;function D(h){const o=[];for(const e of h){const N=Number(e);(N||N===0&&e.replace(/\s/g,"")!=="")&&o.push(N)}return o}function i(h,o,e,N){return{red:h/255,blue:e/255,green:o/255,alpha:N}}function a(h,o){const e=o.index,N=o[0].length;if(!e)return;const y=h.positionAt(e);return{startLineNumber:y.lineNumber,startColumn:y.column,endLineNumber:y.lineNumber,endColumn:y.column+N}}function v(h,o){if(!h)return;const e=k.$8r.Format.CSS.parseHex(o);if(e)return{range:h,color:i(e.rgba.r,e.rgba.g,e.rgba.b,e.rgba.a)}}function c(h,o,e){if(!h||o.length!==1)return;const y=o[0].values(),R=D(y);return{range:h,color:i(R[0],R[1],R[2],e?R[3]:1)}}function s(h,o,e){if(!h||o.length!==1)return;const y=o[0].values(),R=D(y),b=new k.$8r(new k.$6r(R[0],R[1]/100,R[2]/100,e?R[3]:1));return{range:h,color:i(b.rgba.r,b.rgba.g,b.rgba.b,b.rgba.a)}}function u(h,o){return typeof h=="string"?[...h.matchAll(o)]:h.findMatches(o)}function f(h){const o=[],N=u(h,/\b(rgb|rgba|hsl|hsla)(\([0-9\s,.\%]*\))|(#)([A-Fa-f0-9]{3})\b|(#)([A-Fa-f0-9]{4})\b|(#)([A-Fa-f0-9]{6})\b|(#)([A-Fa-f0-9]{8})\b/gm);if(N.length>0)for(const y of N){const R=y.filter(m=>m!==void 0),b=R[1],E=R[2];if(!E)continue;let g;if(b==="rgb"){const m=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*\)$/gm;g=c(a(h,y),u(E,m),!1)}else if(b==="rgba"){const m=/^\(\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(25[0-5]|2[0-4][0-9]|1[0-9]{2}|[1-9][0-9]|[0-9])\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=c(a(h,y),u(E,m),!0)}else if(b==="hsl"){const m=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*\)$/gm;g=s(a(h,y),u(E,m),!1)}else if(b==="hsla"){const m=/^\(\s*(36[0]|3[0-5][0-9]|[12][0-9][0-9]|[1-9]?[0-9])\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(100|\d{1,2}[.]\d*|\d{1,2})%\s*,\s*(0[.][0-9]+|[.][0-9]+|[01][.]|[01])\s*\)$/gm;g=s(a(h,y),u(E,m),!0)}else b==="#"&&(g=v(a(h,y),b+E));g&&o.push(g)}return o}function M(h){return!h||typeof h.getValue!="function"||typeof h.positionAt!="function"?[]:f(h)}t.$rX=M}),Y(Z[45],K([0,1,23]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8W=t.$7W=t.$6W=t.State=void 0;var D;(function(o){o[o.Invalid=0]="Invalid",o[o.Start=1]="Start",o[o.H=2]="H",o[o.HT=3]="HT",o[o.HTT=4]="HTT",o[o.HTTP=5]="HTTP",o[o.F=6]="F",o[o.FI=7]="FI",o[o.FIL=8]="FIL",o[o.BeforeColon=9]="BeforeColon",o[o.AfterColon=10]="AfterColon",o[o.AlmostThere=11]="AlmostThere",o[o.End=12]="End",o[o.Accept=13]="Accept",o[o.LastKnownState=14]="LastKnownState"})(D||(t.State=D={}));class i{constructor(e,N,y){const R=new Uint8Array(e*N);for(let b=0,E=e*N;b<E;b++)R[b]=y;this.a=R,this.rows=e,this.cols=N}get(e,N){return this.a[e*this.cols+N]}set(e,N,y){this.a[e*this.cols+N]=y}}class a{constructor(e){let N=0,y=0;for(let b=0,E=e.length;b<E;b++){const[g,m,r]=e[b];m>N&&(N=m),g>y&&(y=g),r>y&&(y=r)}N++,y++;const R=new i(y,N,0);for(let b=0,E=e.length;b<E;b++){const[g,m,r]=e[b];R.set(g,m,r)}this.a=R,this.b=N}nextState(e,N){return N<0||N>=this.b?0:this.a.get(e,N)}}t.$6W=a;let v=null;function c(){return v===null&&(v=new a([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),v}var s;(function(o){o[o.None=0]="None",o[o.ForceTermination=1]="ForceTermination",o[o.CannotEndIn=2]="CannotEndIn"})(s||(s={}));let u=null;function f(){if(u===null){u=new k.$1r(0);const o=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let N=0;N<o.length;N++)u.set(o.charCodeAt(N),1);const e=".,;:";for(let N=0;N<e.length;N++)u.set(e.charCodeAt(N),2)}return u}class M{static a(e,N,y,R,b){let E=b-1;do{const g=N.charCodeAt(E);if(e.get(g)!==2)break;E--}while(E>R);if(R>0){const g=N.charCodeAt(R-1),m=N.charCodeAt(E);(g===40&&m===41||g===91&&m===93||g===123&&m===125)&&E--}return{range:{startLineNumber:y,startColumn:R+1,endLineNumber:y,endColumn:E+2},url:N.substring(R,E+1)}}static computeLinks(e,N=c()){const y=f(),R=[];for(let b=1,E=e.getLineCount();b<=E;b++){const g=e.getLineContent(b),m=g.length;let r=0,l=0,A=0,d=1,$=!1,w=!1,L=!1,p=!1;for(;r<m;){let F=!1;const P=g.charCodeAt(r);if(d===13){let I;switch(P){case 40:$=!0,I=0;break;case 41:I=$?0:1;break;case 91:L=!0,w=!0,I=0;break;case 93:L=!1,I=w?0:1;break;case 123:p=!0,I=0;break;case 125:I=p?0:1;break;case 39:case 34:case 96:A===P?I=1:A===39||A===34||A===96?I=0:I=1;break;case 42:I=A===42?1:0;break;case 124:I=A===124?1:0;break;case 32:I=L?0:1;break;default:I=y.get(P)}I===1&&(R.push(M.a(y,g,b,l,r)),F=!0)}else if(d===12){let I;P===91?(w=!0,I=0):I=y.get(P),I===1?F=!0:d=13}else d=N.nextState(d,P),d===0&&(F=!0);F&&(d=1,$=!1,w=!1,p=!1,l=r+1,A=P),r++}d===13&&R.push(M.a(y,g,b,l,m))}return R}}t.$7W=M;function h(o){return!o||typeof o.getLineCount!="function"||typeof o.getLineContent!="function"?[]:M.computeLinks(o)}t.$8W=h}),Y(Z[46],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9W=void 0;class k{constructor(){this.c=[["true","false"],["True","False"],["Private","Public","Friend","ReadOnly","Partial","Protected","WriteOnly"],["public","protected","private"]]}static{this.INSTANCE=new k}navigateValueSet(i,a,v,c,s){if(i&&a){const u=this.a(a,s);if(u)return{range:i,value:u}}if(v&&c){const u=this.a(c,s);if(u)return{range:v,value:u}}return null}a(i,a){const v=this.b(i,a);return v!==null?v:this.d(i,a)}b(i,a){const v=Math.pow(10,i.length-(i.lastIndexOf(".")+1));let c=Number(i);const s=parseFloat(i);return!isNaN(c)&&!isNaN(s)&&c===s?c===0&&!a?null:(c=Math.floor(c*v),c+=a?v:-v,String(c/v)):null}d(i,a){return this.e(this.c,i,a)}e(i,a,v){let c=null;for(let s=0,u=i.length;c===null&&s<u;s++)c=this.f(i[s],a,v);return c}f(i,a,v){let c=i.indexOf(a);return c>=0?(c+=v?1:-1,c<0?c=i.length-1:c%=i.length,i[c]):null}}t.$9W=k}),Y(Z[47],K([0,1,11]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zt=t.$Yt=t.$Xt=t.$Wt=t.ModelConstants=t.PositionAffinity=t.$Vt=t.TrackedRangeStickiness=t.$Ut=t.$Tt=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.InjectedTextCursorStops=t.MinimapPosition=t.GlyphMarginLane=t.OverviewRulerLane=void 0;var D;(function(g){g[g.Left=1]="Left",g[g.Center=2]="Center",g[g.Right=4]="Right",g[g.Full=7]="Full"})(D||(t.OverviewRulerLane=D={}));var i;(function(g){g[g.Left=1]="Left",g[g.Right=2]="Right"})(i||(t.GlyphMarginLane=i={}));var a;(function(g){g[g.Inline=1]="Inline",g[g.Gutter=2]="Gutter"})(a||(t.MinimapPosition=a={}));var v;(function(g){g[g.Both=0]="Both",g[g.Right=1]="Right",g[g.Left=2]="Left",g[g.None=3]="None"})(v||(t.InjectedTextCursorStops=v={}));var c;(function(g){g[g.TextDefined=0]="TextDefined",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(c||(t.EndOfLinePreference=c={}));var s;(function(g){g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(s||(t.DefaultEndOfLine=s={}));var u;(function(g){g[g.LF=0]="LF",g[g.CRLF=1]="CRLF"})(u||(t.EndOfLineSequence=u={}));class f{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(m){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,m.tabSize|0),m.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,m.indentSize|0),this.a=!1),this.insertSpaces=!!m.insertSpaces,this.defaultEOL=m.defaultEOL|0,this.trimAutoWhitespace=!!m.trimAutoWhitespace,this.bracketPairColorizationOptions=m.bracketPairColorizationOptions}equals(m){return this.tabSize===m.tabSize&&this.a===m.a&&this.indentSize===m.indentSize&&this.insertSpaces===m.insertSpaces&&this.defaultEOL===m.defaultEOL&&this.trimAutoWhitespace===m.trimAutoWhitespace&&(0,k.$Jm)(this.bracketPairColorizationOptions,m.bracketPairColorizationOptions)}createChangeEvent(m){return{tabSize:this.tabSize!==m.tabSize,indentSize:this.indentSize!==m.indentSize,insertSpaces:this.insertSpaces!==m.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==m.trimAutoWhitespace}}}t.$Tt=f;class M{constructor(m,r){this._findMatchBrand=void 0,this.range=m,this.matches=r}}t.$Ut=M;var h;(function(g){g[g.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",g[g.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",g[g.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",g[g.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(h||(t.TrackedRangeStickiness=h={}));function o(g){return g&&typeof g.read=="function"}t.$Vt=o;var e;(function(g){g[g.Left=0]="Left",g[g.Right=1]="Right",g[g.None=2]="None",g[g.LeftOfInjectedText=3]="LeftOfInjectedText",g[g.RightOfInjectedText=4]="RightOfInjectedText"})(e||(t.PositionAffinity=e={}));var N;(function(g){g[g.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(N||(t.ModelConstants=N={}));class y{constructor(m,r,l,A,d,$){this.identifier=m,this.range=r,this.text=l,this.forceMoveMarkers=A,this.isAutoWhitespaceEdit=d,this._isTracked=$}}t.$Wt=y;class R{constructor(m,r,l){this.regex=m,this.wordSeparators=r,this.simpleSearch=l}}t.$Xt=R;class b{constructor(m,r,l){this.reverseEdits=m,this.changes=r,this.trimAutoWhitespaceLineNumbers=l}}t.$Yt=b;function E(g){return!g.isTooLargeForSyncing()&&!g.isForSimpleWidget}t.$Zt=E}),Y(Z[48],K([0,1,29,22]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tu=t.$su=t.$ru=void 0;class i{constructor(s){this.a=s,this.b=new Uint32Array(s.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(s,u){s=(0,D.$id)(s);const f=this.a,M=this.b,h=u.length;return h===0?!1:(this.a=new Uint32Array(f.length+h),this.a.set(f.subarray(0,s),0),this.a.set(f.subarray(s),s+h),this.a.set(u,s),s-1<this.c[0]&&(this.c[0]=s-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(M.subarray(0,this.c[0]+1)),!0)}setValue(s,u){return s=(0,D.$id)(s),u=(0,D.$id)(u),this.a[s]===u?!1:(this.a[s]=u,s-1<this.c[0]&&(this.c[0]=s-1),!0)}removeValues(s,u){s=(0,D.$id)(s),u=(0,D.$id)(u);const f=this.a,M=this.b;if(s>=f.length)return!1;const h=f.length-s;return u>=h&&(u=h),u===0?!1:(this.a=new Uint32Array(f.length-u),this.a.set(f.subarray(0,s),0),this.a.set(f.subarray(s+u),s),this.b=new Uint32Array(this.a.length),s-1<this.c[0]&&(this.c[0]=s-1),this.c[0]>=0&&this.b.set(M.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(s){return s<0?0:(s=(0,D.$id)(s),this.d(s))}d(s){if(s<=this.c[0])return this.b[s];let u=this.c[0]+1;u===0&&(this.b[0]=this.a[0],u++),s>=this.a.length&&(s=this.a.length-1);for(let f=u;f<=s;f++)this.b[f]=this.b[f-1]+this.a[f];return this.c[0]=Math.max(this.c[0],s),this.b[s]}getIndexOf(s){s=Math.floor(s),this.getTotalSum();let u=0,f=this.a.length-1,M=0,h=0,o=0;for(;u<=f;)if(M=u+(f-u)/2|0,h=this.b[M],o=h-this.a[M],s<o)f=M-1;else if(s>=h)u=M+1;else break;return new v(M,s-o)}}t.$ru=i;class a{constructor(s){this.a=s,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(s){return this.g(),s===0?0:this.d[s-1]}getIndexOf(s){this.g();const u=this.e[s],f=u>0?this.d[u-1]:0;return new v(u,s-f)}removeValues(s,u){this.a.splice(s,u),this.f(s)}insertValues(s,u){this.a=(0,k.$Cf)(this.a,s,u),this.f(s)}f(s){this.b=!1,this.c=Math.min(this.c,s-1)}g(){if(!this.b){for(let s=this.c+1,u=this.a.length;s<u;s++){const f=this.a[s],M=s>0?this.d[s-1]:0;this.d[s]=M+f;for(let h=0;h<f;h++)this.e[M+h]=s}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(s,u){this.a[s]!==u&&(this.a[s]=u,this.f(s))}}t.$su=a;class v{constructor(s,u){this.index=s,this.remainder=u,this._prefixSumIndexOfResultBrand=void 0,this.index=s,this.remainder=u}}t.$tu=v}),Y(Z[49],K([0,1,5,4,48]),function(H,t,k,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uu=void 0;class a{constructor(c,s,u,f){this.d=c,this.f=s,this.g=u,this.h=f,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(c){c.eol&&c.eol!==this.g&&(this.g=c.eol,this.j=null);const s=c.changes;for(const u of s)this.o(u.range),this.p(new D.$Lr(u.range.startLineNumber,u.range.startColumn),u.text);this.h=c.versionId,this.k=null}l(){if(!this.j){const c=this.g.length,s=this.f.length,u=new Uint32Array(s);for(let f=0;f<s;f++)u[f]=this.f[f].length+c;this.j=new i.$ru(u)}}n(c,s){this.f[c]=s,this.j&&this.j.setValue(c,this.f[c].length+this.g.length)}o(c){if(c.startLineNumber===c.endLineNumber){if(c.startColumn===c.endColumn)return;this.n(c.startLineNumber-1,this.f[c.startLineNumber-1].substring(0,c.startColumn-1)+this.f[c.startLineNumber-1].substring(c.endColumn-1));return}this.n(c.startLineNumber-1,this.f[c.startLineNumber-1].substring(0,c.startColumn-1)+this.f[c.endLineNumber-1].substring(c.endColumn-1)),this.f.splice(c.startLineNumber,c.endLineNumber-c.startLineNumber),this.j&&this.j.removeValues(c.startLineNumber,c.endLineNumber-c.startLineNumber)}p(c,s){if(s.length===0)return;const u=(0,k.$zd)(s);if(u.length===1){this.n(c.lineNumber-1,this.f[c.lineNumber-1].substring(0,c.column-1)+u[0]+this.f[c.lineNumber-1].substring(c.column-1));return}u[u.length-1]+=this.f[c.lineNumber-1].substring(c.column-1),this.n(c.lineNumber-1,this.f[c.lineNumber-1].substring(0,c.column-1)+u[0]);const f=new Uint32Array(u.length-1);for(let M=1;M<u.length;M++)this.f.splice(c.lineNumber+M-1,0,u[M]),f[M-1]=u[M].length+this.g.length;this.j&&this.j.insertValues(c.lineNumber,f)}}t.$uu=a}),Y(Z[50],K([0,1,5,37,4,2,47]),function(H,t,k,D,i,a,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6B=t.$5B=t.$4B=t.$3B=t.$2B=t.$1B=void 0;const c=999;class s{constructor(b,E,g,m){this.searchString=b,this.isRegex=E,this.matchCase=g,this.wordSeparators=m}parseSearchRequest(){if(this.searchString==="")return null;let b;this.isRegex?b=u(this.searchString):b=this.searchString.indexOf(`
`)>=0;let E=null;try{E=k.$vd(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:b,global:!0,unicode:!0})}catch{return null}if(!E)return null;let g=!this.isRegex&&!b;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new v.$Xt(E,this.wordSeparators?(0,D.$4r)(this.wordSeparators):null,g?this.searchString:null)}}t.$1B=s;function u(R){if(!R||R.length===0)return!1;for(let b=0,E=R.length;b<E;b++){const g=R.charCodeAt(b);if(g===10)return!0;if(g===92){if(b++,b>=E)break;const m=R.charCodeAt(b);if(m===110||m===114||m===87)return!0}}return!1}t.$2B=u;function f(R,b,E){if(!E)return new v.$Ut(R,null);const g=[];for(let m=0,r=b.length;m<r;m++)g[m]=b[m];return new v.$Ut(R,g)}t.$3B=f;class M{constructor(b){const E=[];let g=0;for(let m=0,r=b.length;m<r;m++)b.charCodeAt(m)===10&&(E[g++]=m);this.a=E}findLineFeedCountBeforeOffset(b){const E=this.a;let g=0,m=E.length-1;if(m===-1||b<=E[0])return 0;for(;g<m;){const r=g+((m-g)/2>>0);E[r]>=b?m=r-1:E[r+1]>=b?(g=r,m=r):g=r+1}return g+1}}class h{static findMatches(b,E,g,m,r){const l=E.parseSearchRequest();return l?l.regex.multiline?this.b(b,g,new y(l.wordSeparators,l.regex),m,r):this.c(b,g,l,m,r):[]}static a(b,E,g,m,r,l){let A,d=0;m?(d=m.findLineFeedCountBeforeOffset(r),A=E+r+d):A=E+r;let $;if(m){const F=m.findLineFeedCountBeforeOffset(r+l.length)-d;$=A+l.length+F}else $=A+l.length;const w=b.getPositionAt(A),L=b.getPositionAt($);return new a.$Mr(w.lineNumber,w.column,L.lineNumber,L.column)}static b(b,E,g,m,r){const l=b.getOffsetAt(E.getStartPosition()),A=b.getValueInRange(E,1),d=b.getEOL()===`\r
`?new M(A):null,$=[];let w=0,L;for(g.reset(0);L=g.next(A);)if($[w++]=f(this.a(b,l,A,d,L.index,L[0]),L,m),w>=r)return $;return $}static c(b,E,g,m,r){const l=[];let A=0;if(E.startLineNumber===E.endLineNumber){const $=b.getLineContent(E.startLineNumber).substring(E.startColumn-1,E.endColumn-1);return A=this.d(g,$,E.startLineNumber,E.startColumn-1,A,l,m,r),l}const d=b.getLineContent(E.startLineNumber).substring(E.startColumn-1);A=this.d(g,d,E.startLineNumber,E.startColumn-1,A,l,m,r);for(let $=E.startLineNumber+1;$<E.endLineNumber&&A<r;$++)A=this.d(g,b.getLineContent($),$,0,A,l,m,r);if(A<r){const $=b.getLineContent(E.endLineNumber).substring(0,E.endColumn-1);A=this.d(g,$,E.endLineNumber,0,A,l,m,r)}return l}static d(b,E,g,m,r,l,A,d){const $=b.wordSeparators;if(!A&&b.simpleSearch){const p=b.simpleSearch,F=p.length,P=E.length;let I=-F;for(;(I=E.indexOf(p,I+F))!==-1;)if((!$||N($,E,P,I,F))&&(l[r++]=new v.$Ut(new a.$Mr(g,I+1+m,g,I+1+F+m),null),r>=d))return r;return r}const w=new y(b.wordSeparators,b.regex);let L;w.reset(0);do if(L=w.next(E),L&&(l[r++]=f(new a.$Mr(g,L.index+1+m,g,L.index+1+L[0].length+m),L,A),r>=d))return r;while(L);return r}static findNextMatch(b,E,g,m){const r=E.parseSearchRequest();if(!r)return null;const l=new y(r.wordSeparators,r.regex);return r.regex.multiline?this.e(b,g,l,m):this.f(b,g,l,m)}static e(b,E,g,m){const r=new i.$Lr(E.lineNumber,1),l=b.getOffsetAt(r),A=b.getLineCount(),d=b.getValueInRange(new a.$Mr(r.lineNumber,r.column,A,b.getLineMaxColumn(A)),1),$=b.getEOL()===`\r
`?new M(d):null;g.reset(E.column-1);const w=g.next(d);return w?f(this.a(b,l,d,$,w.index,w[0]),w,m):E.lineNumber!==1||E.column!==1?this.e(b,new i.$Lr(1,1),g,m):null}static f(b,E,g,m){const r=b.getLineCount(),l=E.lineNumber,A=b.getLineContent(l),d=this.g(g,A,l,E.column,m);if(d)return d;for(let $=1;$<=r;$++){const w=(l+$-1)%r,L=b.getLineContent(w+1),p=this.g(g,L,w+1,1,m);if(p)return p}return null}static g(b,E,g,m,r){b.reset(m-1);const l=b.next(E);return l?f(new a.$Mr(g,l.index+1,g,l.index+1+l[0].length),l,r):null}static findPreviousMatch(b,E,g,m){const r=E.parseSearchRequest();if(!r)return null;const l=new y(r.wordSeparators,r.regex);return r.regex.multiline?this.h(b,g,l,m):this.j(b,g,l,m)}static h(b,E,g,m){const r=this.b(b,new a.$Mr(1,1,E.lineNumber,E.column),g,m,10*c);if(r.length>0)return r[r.length-1];const l=b.getLineCount();return E.lineNumber!==l||E.column!==b.getLineMaxColumn(l)?this.h(b,new i.$Lr(l,b.getLineMaxColumn(l)),g,m):null}static j(b,E,g,m){const r=b.getLineCount(),l=E.lineNumber,A=b.getLineContent(l).substring(0,E.column-1),d=this.k(g,A,l,m);if(d)return d;for(let $=1;$<=r;$++){const w=(r+l-$-1)%r,L=b.getLineContent(w+1),p=this.k(g,L,w+1,m);if(p)return p}return null}static k(b,E,g,m){let r=null,l;for(b.reset(0);l=b.next(E);)r=f(new a.$Mr(g,l.index+1,g,l.index+1+l[0].length),l,m);return r}}t.$4B=h;function o(R,b,E,g,m){if(g===0)return!0;const r=b.charCodeAt(g-1);if(R.get(r)!==0||r===13||r===10)return!0;if(m>0){const l=b.charCodeAt(g);if(R.get(l)!==0)return!0}return!1}function e(R,b,E,g,m){if(g+m===E)return!0;const r=b.charCodeAt(g+m);if(R.get(r)!==0||r===13||r===10)return!0;if(m>0){const l=b.charCodeAt(g+m-1);if(R.get(l)!==0)return!0}return!1}function N(R,b,E,g,m){return o(R,b,E,g,m)&&e(R,b,E,g,m)}t.$5B=N;class y{constructor(b,E){this._wordSeparators=b,this.a=E,this.b=-1,this.c=0}reset(b){this.a.lastIndex=b,this.b=-1,this.c=0}next(b){const E=b.length;let g;do{if(this.b+this.c===E||(g=this.a.exec(b),!g))return null;const m=g.index,r=g[0].length;if(m===this.b&&r===this.c){if(r===0){k.$Sd(b,E,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=m,this.c=r,!this._wordSeparators||N(this._wordSeparators,b,E,m,r))return g}while(g);return null}}t.$6B=y}),Y(Z[51],K([0,1,2,50,5,10,24]),function(H,t,k,D,i,a,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnicodeHighlighterReasonKind=t.$5W=void 0;class c{static computeUnicodeHighlights(e,N,y){const R=y?y.startLineNumber:1,b=y?y.endLineNumber:e.getLineCount(),E=new f(N),g=E.getCandidateCodePoints();let m;g==="allNonBasicAscii"?m=new RegExp("[^\\t\\n\\r\\x20-\\x7E]","g"):m=new RegExp(`${s(Array.from(g))}`,"g");const r=new D.$6B(null,m),l=[];let A=!1,d,$=0,w=0,L=0;e:for(let p=R,F=b;p<=F;p++){const P=e.getLineContent(p),I=P.length;r.reset(0);do if(d=r.next(P),d){let O=d.index,U=d.index+d[0].length;if(O>0){const G=P.charCodeAt(O-1);i.$Pd(G)&&O--}if(U+1<I){const G=P.charCodeAt(U-1);i.$Pd(G)&&U++}const C=P.substring(O,U);let _=(0,v.$Kr)(O+1,v.$Hr,P,0);_&&_.endColumn<=O+1&&(_=null);const W=E.shouldHighlightNonBasicASCII(C,_?_.word:null);if(W!==0){W===3?$++:W===2?w++:W===1?L++:(0,a.$nc)(W);const G=1e3;if(l.length>=G){A=!0;break e}l.push(new k.$Mr(p,O+1,p,U+1))}}while(d)}return{ranges:l,hasMore:A,ambiguousCharacterCount:$,invisibleCharacterCount:w,nonBasicAsciiCharacterCount:L}}static computeUnicodeHighlightReason(e,N){const y=new f(N);switch(y.shouldHighlightNonBasicASCII(e,null)){case 0:return null;case 2:return{kind:1};case 3:{const b=e.codePointAt(0),E=y.ambiguousCharacters.getPrimaryConfusable(b),g=i.$ge.getLocales().filter(m=>!i.$ge.getInstance(new Set([...N.allowedLocales,m])).isAmbiguous(b));return{kind:0,confusableWith:String.fromCodePoint(E),notAmbiguousInLocales:g}}case 1:return{kind:2}}}}t.$5W=c;function s(o,e){return`[${i.$nd(o.map(y=>String.fromCodePoint(y)).join(""))}]`}var u;(function(o){o[o.Ambiguous=0]="Ambiguous",o[o.Invisible=1]="Invisible",o[o.NonBasicAscii=2]="NonBasicAscii"})(u||(t.UnicodeHighlighterReasonKind=u={}));class f{constructor(e){this.b=e,this.a=new Set(e.allowedCodePoints),this.ambiguousCharacters=i.$ge.getInstance(new Set(e.allowedLocales))}getCandidateCodePoints(){if(this.b.nonBasicASCII)return"allNonBasicAscii";const e=new Set;if(this.b.invisibleCharacters)for(const N of i.$he.codePoints)M(String.fromCodePoint(N))||e.add(N);if(this.b.ambiguousCharacters)for(const N of this.ambiguousCharacters.getConfusableCodePoints())e.add(N);for(const N of this.a)e.delete(N);return e}shouldHighlightNonBasicASCII(e,N){const y=e.codePointAt(0);if(this.a.has(y))return 0;if(this.b.nonBasicASCII)return 1;let R=!1,b=!1;if(N)for(const E of N){const g=E.codePointAt(0),m=i.$1d(E);R=R||m,!m&&!this.ambiguousCharacters.isAmbiguous(g)&&!i.$he.isInvisibleCharacter(g)&&(b=!0)}return!R&&b?0:this.b.invisibleCharacters&&!M(e)&&i.$he.isInvisibleCharacter(y)?2:this.b.ambiguousCharacters&&this.ambiguousCharacters.isAmbiguous(y)?3:0}}function M(o){return o===" "||o===`
`||o==="	"}var h;(function(o){o[o.None=0]="None",o[o.NonBasicASCII=1]="NonBasicASCII",o[o.Invisible=2]="Invisible",o[o.Ambiguous=3]="Ambiguous"})(h||(h={}))}),Y(Z[52],K([0,1]),function(H,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WrappingIndent=t.TrackedRangeStickiness=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.SymbolTag=t.SymbolKind=t.SignatureHelpTriggerKind=t.SelectionDirection=t.ScrollbarVisibility=t.ScrollType=t.RenderMinimap=t.RenderLineNumbersType=t.PositionAffinity=t.OverviewRulerLane=t.OverlayWidgetPositionPreference=t.MouseTargetType=t.MinimapPosition=t.MarkerTag=t.MarkerSeverity=t.KeyCode=t.InlineCompletionTriggerKind=t.InlayHintKind=t.InjectedTextCursorStops=t.IndentAction=t.GlyphMarginLane=t.EndOfLineSequence=t.EndOfLinePreference=t.EditorOption=t.EditorAutoIndentStrategy=t.DocumentHighlightKind=t.DefaultEndOfLine=t.CursorChangeReason=t.ContentWidgetPositionPreference=t.CompletionTriggerKind=t.CompletionItemTag=t.CompletionItemKind=t.CompletionItemInsertTextRule=t.CodeActionTriggerType=t.AccessibilitySupport=void 0;var k;(function(n){n[n.Unknown=0]="Unknown",n[n.Disabled=1]="Disabled",n[n.Enabled=2]="Enabled"})(k||(t.AccessibilitySupport=k={}));var D;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(D||(t.CodeActionTriggerType=D={}));var i;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(i||(t.CompletionItemInsertTextRule=i={}));var a;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(a||(t.CompletionItemKind=a={}));var v;(function(n){n[n.Deprecated=1]="Deprecated"})(v||(t.CompletionItemTag=v={}));var c;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(t.CompletionTriggerKind=c={}));var s;(function(n){n[n.EXACT=0]="EXACT",n[n.ABOVE=1]="ABOVE",n[n.BELOW=2]="BELOW"})(s||(t.ContentWidgetPositionPreference=s={}));var u;(function(n){n[n.NotSet=0]="NotSet",n[n.ContentFlush=1]="ContentFlush",n[n.RecoverFromMarkers=2]="RecoverFromMarkers",n[n.Explicit=3]="Explicit",n[n.Paste=4]="Paste",n[n.Undo=5]="Undo",n[n.Redo=6]="Redo"})(u||(t.CursorChangeReason=u={}));var f;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(f||(t.DefaultEndOfLine=f={}));var M;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(M||(t.DocumentHighlightKind=M={}));var h;(function(n){n[n.None=0]="None",n[n.Keep=1]="Keep",n[n.Brackets=2]="Brackets",n[n.Advanced=3]="Advanced",n[n.Full=4]="Full"})(h||(t.EditorAutoIndentStrategy=h={}));var o;(function(n){n[n.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",n[n.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",n[n.accessibilitySupport=2]="accessibilitySupport",n[n.accessibilityPageSize=3]="accessibilityPageSize",n[n.ariaLabel=4]="ariaLabel",n[n.ariaRequired=5]="ariaRequired",n[n.autoClosingBrackets=6]="autoClosingBrackets",n[n.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",n[n.autoClosingDelete=8]="autoClosingDelete",n[n.autoClosingOvertype=9]="autoClosingOvertype",n[n.autoClosingQuotes=10]="autoClosingQuotes",n[n.autoIndent=11]="autoIndent",n[n.automaticLayout=12]="automaticLayout",n[n.autoSurround=13]="autoSurround",n[n.bracketPairColorization=14]="bracketPairColorization",n[n.guides=15]="guides",n[n.codeLens=16]="codeLens",n[n.codeLensFontFamily=17]="codeLensFontFamily",n[n.codeLensFontSize=18]="codeLensFontSize",n[n.colorDecorators=19]="colorDecorators",n[n.colorDecoratorsLimit=20]="colorDecoratorsLimit",n[n.columnSelection=21]="columnSelection",n[n.comments=22]="comments",n[n.contextmenu=23]="contextmenu",n[n.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",n[n.cursorBlinking=25]="cursorBlinking",n[n.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",n[n.cursorStyle=27]="cursorStyle",n[n.cursorSurroundingLines=28]="cursorSurroundingLines",n[n.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",n[n.cursorWidth=30]="cursorWidth",n[n.disableLayerHinting=31]="disableLayerHinting",n[n.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",n[n.domReadOnly=33]="domReadOnly",n[n.dragAndDrop=34]="dragAndDrop",n[n.dropIntoEditor=35]="dropIntoEditor",n[n.emptySelectionClipboard=36]="emptySelectionClipboard",n[n.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",n[n.extraEditorClassName=38]="extraEditorClassName",n[n.fastScrollSensitivity=39]="fastScrollSensitivity",n[n.find=40]="find",n[n.fixedOverflowWidgets=41]="fixedOverflowWidgets",n[n.folding=42]="folding",n[n.foldingStrategy=43]="foldingStrategy",n[n.foldingHighlight=44]="foldingHighlight",n[n.foldingImportsByDefault=45]="foldingImportsByDefault",n[n.foldingMaximumRegions=46]="foldingMaximumRegions",n[n.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",n[n.fontFamily=48]="fontFamily",n[n.fontInfo=49]="fontInfo",n[n.fontLigatures=50]="fontLigatures",n[n.fontSize=51]="fontSize",n[n.fontWeight=52]="fontWeight",n[n.fontVariations=53]="fontVariations",n[n.formatOnPaste=54]="formatOnPaste",n[n.formatOnType=55]="formatOnType",n[n.glyphMargin=56]="glyphMargin",n[n.gotoLocation=57]="gotoLocation",n[n.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",n[n.hover=59]="hover",n[n.inDiffEditor=60]="inDiffEditor",n[n.inlineSuggest=61]="inlineSuggest",n[n.letterSpacing=62]="letterSpacing",n[n.lightbulb=63]="lightbulb",n[n.lineDecorationsWidth=64]="lineDecorationsWidth",n[n.lineHeight=65]="lineHeight",n[n.lineNumbers=66]="lineNumbers",n[n.lineNumbersMinChars=67]="lineNumbersMinChars",n[n.linkedEditing=68]="linkedEditing",n[n.links=69]="links",n[n.matchBrackets=70]="matchBrackets",n[n.minimap=71]="minimap",n[n.mouseStyle=72]="mouseStyle",n[n.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",n[n.mouseWheelZoom=74]="mouseWheelZoom",n[n.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",n[n.multiCursorModifier=76]="multiCursorModifier",n[n.multiCursorPaste=77]="multiCursorPaste",n[n.multiCursorLimit=78]="multiCursorLimit",n[n.occurrencesHighlight=79]="occurrencesHighlight",n[n.overviewRulerBorder=80]="overviewRulerBorder",n[n.overviewRulerLanes=81]="overviewRulerLanes",n[n.padding=82]="padding",n[n.pasteAs=83]="pasteAs",n[n.parameterHints=84]="parameterHints",n[n.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",n[n.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",n[n.quickSuggestions=87]="quickSuggestions",n[n.quickSuggestionsDelay=88]="quickSuggestionsDelay",n[n.readOnly=89]="readOnly",n[n.readOnlyMessage=90]="readOnlyMessage",n[n.renameOnType=91]="renameOnType",n[n.renderControlCharacters=92]="renderControlCharacters",n[n.renderFinalNewline=93]="renderFinalNewline",n[n.renderLineHighlight=94]="renderLineHighlight",n[n.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",n[n.renderValidationDecorations=96]="renderValidationDecorations",n[n.renderWhitespace=97]="renderWhitespace",n[n.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",n[n.roundedSelection=99]="roundedSelection",n[n.rulers=100]="rulers",n[n.scrollbar=101]="scrollbar",n[n.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",n[n.scrollBeyondLastLine=103]="scrollBeyondLastLine",n[n.scrollPredominantAxis=104]="scrollPredominantAxis",n[n.selectionClipboard=105]="selectionClipboard",n[n.selectionHighlight=106]="selectionHighlight",n[n.selectOnLineNumbers=107]="selectOnLineNumbers",n[n.showFoldingControls=108]="showFoldingControls",n[n.showUnused=109]="showUnused",n[n.snippetSuggestions=110]="snippetSuggestions",n[n.smartSelect=111]="smartSelect",n[n.smoothScrolling=112]="smoothScrolling",n[n.stickyScroll=113]="stickyScroll",n[n.stickyTabStops=114]="stickyTabStops",n[n.stopRenderingLineAfter=115]="stopRenderingLineAfter",n[n.suggest=116]="suggest",n[n.suggestFontSize=117]="suggestFontSize",n[n.suggestLineHeight=118]="suggestLineHeight",n[n.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",n[n.suggestSelection=120]="suggestSelection",n[n.tabCompletion=121]="tabCompletion",n[n.tabIndex=122]="tabIndex",n[n.unicodeHighlighting=123]="unicodeHighlighting",n[n.unusualLineTerminators=124]="unusualLineTerminators",n[n.useShadowDOM=125]="useShadowDOM",n[n.useTabStops=126]="useTabStops",n[n.wordBreak=127]="wordBreak",n[n.wordSeparators=128]="wordSeparators",n[n.wordWrap=129]="wordWrap",n[n.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",n[n.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",n[n.wordWrapColumn=132]="wordWrapColumn",n[n.wordWrapOverride1=133]="wordWrapOverride1",n[n.wordWrapOverride2=134]="wordWrapOverride2",n[n.wrappingIndent=135]="wrappingIndent",n[n.wrappingStrategy=136]="wrappingStrategy",n[n.showDeprecated=137]="showDeprecated",n[n.inlayHints=138]="inlayHints",n[n.editorClassName=139]="editorClassName",n[n.pixelRatio=140]="pixelRatio",n[n.tabFocusMode=141]="tabFocusMode",n[n.layoutInfo=142]="layoutInfo",n[n.wrappingInfo=143]="wrappingInfo",n[n.defaultColorDecorators=144]="defaultColorDecorators",n[n.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(o||(t.EditorOption=o={}));var e;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(e||(t.EndOfLinePreference=e={}));var N;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(N||(t.EndOfLineSequence=N={}));var y;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(y||(t.GlyphMarginLane=y={}));var R;(function(n){n[n.None=0]="None",n[n.Indent=1]="Indent",n[n.IndentOutdent=2]="IndentOutdent",n[n.Outdent=3]="Outdent"})(R||(t.IndentAction=R={}));var b;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(b||(t.InjectedTextCursorStops=b={}));var E;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(E||(t.InlayHintKind=E={}));var g;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(g||(t.InlineCompletionTriggerKind=g={}));var m;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.Unknown=0]="Unknown",n[n.Backspace=1]="Backspace",n[n.Tab=2]="Tab",n[n.Enter=3]="Enter",n[n.Shift=4]="Shift",n[n.Ctrl=5]="Ctrl",n[n.Alt=6]="Alt",n[n.PauseBreak=7]="PauseBreak",n[n.CapsLock=8]="CapsLock",n[n.Escape=9]="Escape",n[n.Space=10]="Space",n[n.PageUp=11]="PageUp",n[n.PageDown=12]="PageDown",n[n.End=13]="End",n[n.Home=14]="Home",n[n.LeftArrow=15]="LeftArrow",n[n.UpArrow=16]="UpArrow",n[n.RightArrow=17]="RightArrow",n[n.DownArrow=18]="DownArrow",n[n.Insert=19]="Insert",n[n.Delete=20]="Delete",n[n.Digit0=21]="Digit0",n[n.Digit1=22]="Digit1",n[n.Digit2=23]="Digit2",n[n.Digit3=24]="Digit3",n[n.Digit4=25]="Digit4",n[n.Digit5=26]="Digit5",n[n.Digit6=27]="Digit6",n[n.Digit7=28]="Digit7",n[n.Digit8=29]="Digit8",n[n.Digit9=30]="Digit9",n[n.KeyA=31]="KeyA",n[n.KeyB=32]="KeyB",n[n.KeyC=33]="KeyC",n[n.KeyD=34]="KeyD",n[n.KeyE=35]="KeyE",n[n.KeyF=36]="KeyF",n[n.KeyG=37]="KeyG",n[n.KeyH=38]="KeyH",n[n.KeyI=39]="KeyI",n[n.KeyJ=40]="KeyJ",n[n.KeyK=41]="KeyK",n[n.KeyL=42]="KeyL",n[n.KeyM=43]="KeyM",n[n.KeyN=44]="KeyN",n[n.KeyO=45]="KeyO",n[n.KeyP=46]="KeyP",n[n.KeyQ=47]="KeyQ",n[n.KeyR=48]="KeyR",n[n.KeyS=49]="KeyS",n[n.KeyT=50]="KeyT",n[n.KeyU=51]="KeyU",n[n.KeyV=52]="KeyV",n[n.KeyW=53]="KeyW",n[n.KeyX=54]="KeyX",n[n.KeyY=55]="KeyY",n[n.KeyZ=56]="KeyZ",n[n.Meta=57]="Meta",n[n.ContextMenu=58]="ContextMenu",n[n.F1=59]="F1",n[n.F2=60]="F2",n[n.F3=61]="F3",n[n.F4=62]="F4",n[n.F5=63]="F5",n[n.F6=64]="F6",n[n.F7=65]="F7",n[n.F8=66]="F8",n[n.F9=67]="F9",n[n.F10=68]="F10",n[n.F11=69]="F11",n[n.F12=70]="F12",n[n.F13=71]="F13",n[n.F14=72]="F14",n[n.F15=73]="F15",n[n.F16=74]="F16",n[n.F17=75]="F17",n[n.F18=76]="F18",n[n.F19=77]="F19",n[n.F20=78]="F20",n[n.F21=79]="F21",n[n.F22=80]="F22",n[n.F23=81]="F23",n[n.F24=82]="F24",n[n.NumLock=83]="NumLock",n[n.ScrollLock=84]="ScrollLock",n[n.Semicolon=85]="Semicolon",n[n.Equal=86]="Equal",n[n.Comma=87]="Comma",n[n.Minus=88]="Minus",n[n.Period=89]="Period",n[n.Slash=90]="Slash",n[n.Backquote=91]="Backquote",n[n.BracketLeft=92]="BracketLeft",n[n.Backslash=93]="Backslash",n[n.BracketRight=94]="BracketRight",n[n.Quote=95]="Quote",n[n.OEM_8=96]="OEM_8",n[n.IntlBackslash=97]="IntlBackslash",n[n.Numpad0=98]="Numpad0",n[n.Numpad1=99]="Numpad1",n[n.Numpad2=100]="Numpad2",n[n.Numpad3=101]="Numpad3",n[n.Numpad4=102]="Numpad4",n[n.Numpad5=103]="Numpad5",n[n.Numpad6=104]="Numpad6",n[n.Numpad7=105]="Numpad7",n[n.Numpad8=106]="Numpad8",n[n.Numpad9=107]="Numpad9",n[n.NumpadMultiply=108]="NumpadMultiply",n[n.NumpadAdd=109]="NumpadAdd",n[n.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",n[n.NumpadSubtract=111]="NumpadSubtract",n[n.NumpadDecimal=112]="NumpadDecimal",n[n.NumpadDivide=113]="NumpadDivide",n[n.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",n[n.ABNT_C1=115]="ABNT_C1",n[n.ABNT_C2=116]="ABNT_C2",n[n.AudioVolumeMute=117]="AudioVolumeMute",n[n.AudioVolumeUp=118]="AudioVolumeUp",n[n.AudioVolumeDown=119]="AudioVolumeDown",n[n.BrowserSearch=120]="BrowserSearch",n[n.BrowserHome=121]="BrowserHome",n[n.BrowserBack=122]="BrowserBack",n[n.BrowserForward=123]="BrowserForward",n[n.MediaTrackNext=124]="MediaTrackNext",n[n.MediaTrackPrevious=125]="MediaTrackPrevious",n[n.MediaStop=126]="MediaStop",n[n.MediaPlayPause=127]="MediaPlayPause",n[n.LaunchMediaPlayer=128]="LaunchMediaPlayer",n[n.LaunchMail=129]="LaunchMail",n[n.LaunchApp2=130]="LaunchApp2",n[n.Clear=131]="Clear",n[n.MAX_VALUE=132]="MAX_VALUE"})(m||(t.KeyCode=m={}));var r;(function(n){n[n.Hint=1]="Hint",n[n.Info=2]="Info",n[n.Warning=4]="Warning",n[n.Error=8]="Error"})(r||(t.MarkerSeverity=r={}));var l;(function(n){n[n.Unnecessary=1]="Unnecessary",n[n.Deprecated=2]="Deprecated"})(l||(t.MarkerTag=l={}));var A;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(A||(t.MinimapPosition=A={}));var d;(function(n){n[n.UNKNOWN=0]="UNKNOWN",n[n.TEXTAREA=1]="TEXTAREA",n[n.GUTTER_GLYPH_MARGIN=2]="GUTTER_GLYPH_MARGIN",n[n.GUTTER_LINE_NUMBERS=3]="GUTTER_LINE_NUMBERS",n[n.GUTTER_LINE_DECORATIONS=4]="GUTTER_LINE_DECORATIONS",n[n.GUTTER_VIEW_ZONE=5]="GUTTER_VIEW_ZONE",n[n.CONTENT_TEXT=6]="CONTENT_TEXT",n[n.CONTENT_EMPTY=7]="CONTENT_EMPTY",n[n.CONTENT_VIEW_ZONE=8]="CONTENT_VIEW_ZONE",n[n.CONTENT_WIDGET=9]="CONTENT_WIDGET",n[n.OVERVIEW_RULER=10]="OVERVIEW_RULER",n[n.SCROLLBAR=11]="SCROLLBAR",n[n.OVERLAY_WIDGET=12]="OVERLAY_WIDGET",n[n.OUTSIDE_EDITOR=13]="OUTSIDE_EDITOR"})(d||(t.MouseTargetType=d={}));var $;(function(n){n[n.TOP_RIGHT_CORNER=0]="TOP_RIGHT_CORNER",n[n.BOTTOM_RIGHT_CORNER=1]="BOTTOM_RIGHT_CORNER",n[n.TOP_CENTER=2]="TOP_CENTER"})($||(t.OverlayWidgetPositionPreference=$={}));var w;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(w||(t.OverviewRulerLane=w={}));var L;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(L||(t.PositionAffinity=L={}));var p;(function(n){n[n.Off=0]="Off",n[n.On=1]="On",n[n.Relative=2]="Relative",n[n.Interval=3]="Interval",n[n.Custom=4]="Custom"})(p||(t.RenderLineNumbersType=p={}));var F;(function(n){n[n.None=0]="None",n[n.Text=1]="Text",n[n.Blocks=2]="Blocks"})(F||(t.RenderMinimap=F={}));var P;(function(n){n[n.Smooth=0]="Smooth",n[n.Immediate=1]="Immediate"})(P||(t.ScrollType=P={}));var I;(function(n){n[n.Auto=1]="Auto",n[n.Hidden=2]="Hidden",n[n.Visible=3]="Visible"})(I||(t.ScrollbarVisibility=I={}));var O;(function(n){n[n.LTR=0]="LTR",n[n.RTL=1]="RTL"})(O||(t.SelectionDirection=O={}));var U;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(U||(t.SignatureHelpTriggerKind=U={}));var C;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(C||(t.SymbolKind=C={}));var _;(function(n){n[n.Deprecated=1]="Deprecated"})(_||(t.SymbolTag=_={}));var W;(function(n){n[n.Hidden=0]="Hidden",n[n.Blink=1]="Blink",n[n.Smooth=2]="Smooth",n[n.Phase=3]="Phase",n[n.Expand=4]="Expand",n[n.Solid=5]="Solid"})(W||(t.TextEditorCursorBlinkingStyle=W={}));var G;(function(n){n[n.Line=1]="Line",n[n.Block=2]="Block",n[n.Underline=3]="Underline",n[n.LineThin=4]="LineThin",n[n.BlockOutline=5]="BlockOutline",n[n.UnderlineThin=6]="UnderlineThin"})(G||(t.TextEditorCursorStyle=G={}));var X;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(X||(t.TrackedRangeStickiness=X={}));var ne;(function(n){n[n.None=0]="None",n[n.Same=1]="Same",n[n.Indent=2]="Indent",n[n.DeepIndent=3]="DeepIndent"})(ne||(t.WrappingIndent=ne={}))}),Y(Z[53],K([0,1,8,7]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cs=void 0;class i{constructor(){this.a=new Map,this.b=new Map,this.c=new k.$7c,this.onDidChange=this.c.event,this.d=null}handleChange(c){this.c.fire({changedLanguages:c,changedColorMap:!1})}register(c,s){return this.a.set(c,s),this.handleChange([c]),(0,D.$jb)(()=>{this.a.get(c)===s&&(this.a.delete(c),this.handleChange([c]))})}get(c){return this.a.get(c)||null}registerFactory(c,s){this.b.get(c)?.dispose();const u=new a(this,c,s);return this.b.set(c,u),(0,D.$jb)(()=>{const f=this.b.get(c);!f||f!==u||(this.b.delete(c),f.dispose())})}async getOrCreate(c){const s=this.get(c);if(s)return s;const u=this.b.get(c);return!u||u.isResolved?null:(await u.resolve(),this.get(c))}isResolved(c){if(this.get(c))return!0;const u=this.b.get(c);return!!(!u||u.isResolved)}setColorMap(c){this.d=c,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}t.$cs=i;class a extends D.$lb{get isResolved(){return this.c}constructor(c,s,u){super(),this.f=c,this.g=s,this.h=u,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const c=await this.h.tokenizationSupport;this.c=!0,c&&!this.a&&this.B(this.f.register(this.g,c))}}}),Y(Z[54],K([55,56]),function(H,t){return H.create("vs/base/common/platform",t)}),Y(Z[13],K([0,1,54]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$H=t.$G=t.$F=t.$E=t.$D=t.$C=t.OS=t.OperatingSystem=t.$A=t.$z=t.$y=t.$x=t.$w=t.Language=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=t.$f=void 0,t.$f="en";let D=!1,i=!1,a=!1,v=!1,c=!1,s=!1,u=!1,f=!1,M=!1,h=!1,o,e=t.$f,N=t.$f,y,R;t.$g=typeof self=="object"?self:typeof global=="object"?global:{};let b;typeof t.$g.vscode<"u"&&typeof t.$g.vscode.process<"u"?b=t.$g.vscode.process:typeof process<"u"&&(b=process);const E=typeof b?.versions?.electron=="string",g=E&&b?.type==="renderer";if(typeof navigator=="object"&&!g)R=navigator.userAgent,D=R.indexOf("Windows")>=0,i=R.indexOf("Macintosh")>=0,f=(R.indexOf("Macintosh")>=0||R.indexOf("iPad")>=0||R.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,a=R.indexOf("Linux")>=0,h=R?.indexOf("Mobi")>=0,s=!0,o=k.getConfiguredDefaultLocale(k.localize(0,null))||t.$f,e=o,N=navigator.language;else if(typeof b=="object"){D=b.platform==="win32",i=b.platform==="darwin",a=b.platform==="linux",v=a&&!!b.env.SNAP&&!!b.env.SNAP_REVISION,u=E,M=!!b.env.CI||!!b.env.BUILD_ARTIFACTSTAGINGDIRECTORY,o=t.$f,e=t.$f;const p=b.env.VSCODE_NLS_CONFIG;if(p)try{const F=JSON.parse(p),P=F.availableLanguages["*"];o=F.locale,N=F.osLocale,e=P||t.$f,y=F._translationsConfigFile}catch{}c=!0}else console.error("Unable to resolve platform.");var m;(function(p){p[p.Web=0]="Web",p[p.Mac=1]="Mac",p[p.Linux=2]="Linux",p[p.Windows=3]="Windows"})(m||(t.Platform=m={}));function r(p){switch(p){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=r;let l=0;i?l=1:D?l=3:a&&(l=2),t.$i=D,t.$j=i,t.$k=a,t.$l=v,t.$m=c,t.$n=u,t.$o=s,t.$p=s&&typeof t.$g.importScripts=="function",t.$q=f,t.$r=h,t.$s=M,t.$t=l,t.$u=R,t.$v=e;var A;(function(p){function F(){return t.$v}p.value=F;function P(){return t.$v.length===2?t.$v==="en":t.$v.length>=3?t.$v[0]==="e"&&t.$v[1]==="n"&&t.$v[2]==="-":!1}p.isDefaultVariant=P;function I(){return t.$v==="en"}p.isDefault=I})(A||(t.Language=A={})),t.$w=o,t.$x=N,t.$y=y,t.$z=typeof t.$g.postMessage=="function"&&!t.$g.importScripts,t.$A=(()=>{if(t.$z){const p=[];t.$g.addEventListener("message",P=>{if(P.data&&P.data.vscodeScheduleAsyncWork)for(let I=0,O=p.length;I<O;I++){const U=p[I];if(U.id===P.data.vscodeScheduleAsyncWork){p.splice(I,1),U.callback();return}}});let F=0;return P=>{const I=++F;p.push({id:I,callback:P}),t.$g.postMessage({vscodeScheduleAsyncWork:I},"*")}}return p=>setTimeout(p)})();var d;(function(p){p[p.Windows=1]="Windows",p[p.Macintosh=2]="Macintosh",p[p.Linux=3]="Linux"})(d||(t.OperatingSystem=d={})),t.OS=i||f?2:D?1:3;let $=!0,w=!1;function L(){if(!w){w=!0;const p=new Uint8Array(2);p[0]=1,p[1]=2,$=new Uint16Array(p.buffer)[0]===(2<<8)+1}return $}t.$C=L,t.$D=!!(t.$u&&t.$u.indexOf("Chrome")>=0),t.$E=!!(t.$u&&t.$u.indexOf("Firefox")>=0),t.$F=!!(!t.$D&&t.$u&&t.$u.indexOf("Safari")>=0),t.$G=!!(t.$u&&t.$u.indexOf("Edg/")>=0),t.$H=!!(t.$u&&t.$u.indexOf("Android")>=0)}),Y(Z[57],K([0,1,13]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8b=t.$7b=t.env=t.cwd=void 0;let D;if(typeof k.$g.vscode<"u"&&typeof k.$g.vscode.process<"u"){const i=k.$g.vscode.process;D={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return k.$i?"win32":k.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=D.cwd,t.env=D.env,t.$7b=D.platform,t.$8b=D.arch}),Y(Z[58],K([0,1,57]),function(H,t,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kc=t.sep=t.$ic=t.$hc=t.$gc=t.$fc=t.$ec=t.$dc=t.$cc=t.$bc=t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=void 0;const D=65,i=97,a=90,v=122,c=46,s=47,u=92,f=58,M=63;class h extends Error{constructor(l,A,d){let $;typeof A=="string"&&A.indexOf("not ")===0?($="must not be",A=A.replace(/^not /,"")):$="must be";const w=l.indexOf(".")!==-1?"property":"argument";let L=`The "${l}" ${w} ${$} of type ${A}`;L+=`. Received type ${typeof d}`,super(L),this.code="ERR_INVALID_ARG_TYPE"}}function o(r,l){if(r===null||typeof r!="object")throw new h(l,"Object",r)}function e(r,l){if(typeof r!="string")throw new h(l,"string",r)}const N=k.$7b==="win32";function y(r){return r===s||r===u}function R(r){return r===s}function b(r){return r>=D&&r<=a||r>=i&&r<=v}function E(r,l,A,d){let $="",w=0,L=-1,p=0,F=0;for(let P=0;P<=r.length;++P){if(P<r.length)F=r.charCodeAt(P);else{if(d(F))break;F=s}if(d(F)){if(!(L===P-1||p===1))if(p===2){if($.length<2||w!==2||$.charCodeAt($.length-1)!==c||$.charCodeAt($.length-2)!==c){if($.length>2){const I=$.lastIndexOf(A);I===-1?($="",w=0):($=$.slice(0,I),w=$.length-1-$.lastIndexOf(A)),L=P,p=0;continue}else if($.length!==0){$="",w=0,L=P,p=0;continue}}l&&($+=$.length>0?`${A}..`:"..",w=2)}else $.length>0?$+=`${A}${r.slice(L+1,P)}`:$=r.slice(L+1,P),w=P-L-1;L=P,p=0}else F===c&&p!==-1?++p:p=-1}return $}function g(r,l){o(l,"pathObject");const A=l.dir||l.root,d=l.base||`${l.name||""}${l.ext||""}`;return A?A===l.root?`${A}${d}`:`${A}${r}${d}`:d}t.$9b={resolve(...r){let l="",A="",d=!1;for(let $=r.length-1;$>=-1;$--){let w;if($>=0){if(w=r[$],e(w,"path"),w.length===0)continue}else l.length===0?w=k.cwd():(w=k.env[`=${l}`]||k.cwd(),(w===void 0||w.slice(0,2).toLowerCase()!==l.toLowerCase()&&w.charCodeAt(2)===u)&&(w=`${l}\\`));const L=w.length;let p=0,F="",P=!1;const I=w.charCodeAt(0);if(L===1)y(I)&&(p=1,P=!0);else if(y(I))if(P=!0,y(w.charCodeAt(1))){let O=2,U=O;for(;O<L&&!y(w.charCodeAt(O));)O++;if(O<L&&O!==U){const C=w.slice(U,O);for(U=O;O<L&&y(w.charCodeAt(O));)O++;if(O<L&&O!==U){for(U=O;O<L&&!y(w.charCodeAt(O));)O++;(O===L||O!==U)&&(F=`\\\\${C}\\${w.slice(U,O)}`,p=O)}}}else p=1;else b(I)&&w.charCodeAt(1)===f&&(F=w.slice(0,2),p=2,L>2&&y(w.charCodeAt(2))&&(P=!0,p=3));if(F.length>0)if(l.length>0){if(F.toLowerCase()!==l.toLowerCase())continue}else l=F;if(d){if(l.length>0)break}else if(A=`${w.slice(p)}\\${A}`,d=P,P&&l.length>0)break}return A=E(A,!d,"\\",y),d?`${l}\\${A}`:`${l}${A}`||"."},normalize(r){e(r,"path");const l=r.length;if(l===0)return".";let A=0,d,$=!1;const w=r.charCodeAt(0);if(l===1)return R(w)?"\\":r;if(y(w))if($=!0,y(r.charCodeAt(1))){let p=2,F=p;for(;p<l&&!y(r.charCodeAt(p));)p++;if(p<l&&p!==F){const P=r.slice(F,p);for(F=p;p<l&&y(r.charCodeAt(p));)p++;if(p<l&&p!==F){for(F=p;p<l&&!y(r.charCodeAt(p));)p++;if(p===l)return`\\\\${P}\\${r.slice(F)}\\`;p!==F&&(d=`\\\\${P}\\${r.slice(F,p)}`,A=p)}}}else A=1;else b(w)&&r.charCodeAt(1)===f&&(d=r.slice(0,2),A=2,l>2&&y(r.charCodeAt(2))&&($=!0,A=3));let L=A<l?E(r.slice(A),!$,"\\",y):"";return L.length===0&&!$&&(L="."),L.length>0&&y(r.charCodeAt(l-1))&&(L+="\\"),d===void 0?$?`\\${L}`:L:$?`${d}\\${L}`:`${d}${L}`},isAbsolute(r){e(r,"path");const l=r.length;if(l===0)return!1;const A=r.charCodeAt(0);return y(A)||l>2&&b(A)&&r.charCodeAt(1)===f&&y(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let l,A;for(let w=0;w<r.length;++w){const L=r[w];e(L,"path"),L.length>0&&(l===void 0?l=A=L:l+=`\\${L}`)}if(l===void 0)return".";let d=!0,$=0;if(typeof A=="string"&&y(A.charCodeAt(0))){++$;const w=A.length;w>1&&y(A.charCodeAt(1))&&(++$,w>2&&(y(A.charCodeAt(2))?++$:d=!1))}if(d){for(;$<l.length&&y(l.charCodeAt($));)$++;$>=2&&(l=`\\${l.slice($)}`)}return t.$9b.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l)return"";const A=t.$9b.resolve(r),d=t.$9b.resolve(l);if(A===d||(r=A.toLowerCase(),l=d.toLowerCase(),r===l))return"";let $=0;for(;$<r.length&&r.charCodeAt($)===u;)$++;let w=r.length;for(;w-1>$&&r.charCodeAt(w-1)===u;)w--;const L=w-$;let p=0;for(;p<l.length&&l.charCodeAt(p)===u;)p++;let F=l.length;for(;F-1>p&&l.charCodeAt(F-1)===u;)F--;const P=F-p,I=L<P?L:P;let O=-1,U=0;for(;U<I;U++){const _=r.charCodeAt($+U);if(_!==l.charCodeAt(p+U))break;_===u&&(O=U)}if(U!==I){if(O===-1)return d}else{if(P>I){if(l.charCodeAt(p+U)===u)return d.slice(p+U+1);if(U===2)return d.slice(p+U)}L>I&&(r.charCodeAt($+U)===u?O=U:U===2&&(O=3)),O===-1&&(O=0)}let C="";for(U=$+O+1;U<=w;++U)(U===w||r.charCodeAt(U)===u)&&(C+=C.length===0?"..":"\\..");return p+=O,C.length>0?`${C}${d.slice(p,F)}`:(d.charCodeAt(p)===u&&++p,d.slice(p,F))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const l=t.$9b.resolve(r);if(l.length<=2)return r;if(l.charCodeAt(0)===u){if(l.charCodeAt(1)===u){const A=l.charCodeAt(2);if(A!==M&&A!==c)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(b(l.charCodeAt(0))&&l.charCodeAt(1)===f&&l.charCodeAt(2)===u)return`\\\\?\\${l}`;return r},dirname(r){e(r,"path");const l=r.length;if(l===0)return".";let A=-1,d=0;const $=r.charCodeAt(0);if(l===1)return y($)?r:".";if(y($)){if(A=d=1,y(r.charCodeAt(1))){let p=2,F=p;for(;p<l&&!y(r.charCodeAt(p));)p++;if(p<l&&p!==F){for(F=p;p<l&&y(r.charCodeAt(p));)p++;if(p<l&&p!==F){for(F=p;p<l&&!y(r.charCodeAt(p));)p++;if(p===l)return r;p!==F&&(A=d=p+1)}}}}else b($)&&r.charCodeAt(1)===f&&(A=l>2&&y(r.charCodeAt(2))?3:2,d=A);let w=-1,L=!0;for(let p=l-1;p>=d;--p)if(y(r.charCodeAt(p))){if(!L){w=p;break}}else L=!1;if(w===-1){if(A===-1)return".";w=A}return r.slice(0,w)},basename(r,l){l!==void 0&&e(l,"ext"),e(r,"path");let A=0,d=-1,$=!0,w;if(r.length>=2&&b(r.charCodeAt(0))&&r.charCodeAt(1)===f&&(A=2),l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let L=l.length-1,p=-1;for(w=r.length-1;w>=A;--w){const F=r.charCodeAt(w);if(y(F)){if(!$){A=w+1;break}}else p===-1&&($=!1,p=w+1),L>=0&&(F===l.charCodeAt(L)?--L===-1&&(d=w):(L=-1,d=p))}return A===d?d=p:d===-1&&(d=r.length),r.slice(A,d)}for(w=r.length-1;w>=A;--w)if(y(r.charCodeAt(w))){if(!$){A=w+1;break}}else d===-1&&($=!1,d=w+1);return d===-1?"":r.slice(A,d)},extname(r){e(r,"path");let l=0,A=-1,d=0,$=-1,w=!0,L=0;r.length>=2&&r.charCodeAt(1)===f&&b(r.charCodeAt(0))&&(l=d=2);for(let p=r.length-1;p>=l;--p){const F=r.charCodeAt(p);if(y(F)){if(!w){d=p+1;break}continue}$===-1&&(w=!1,$=p+1),F===c?A===-1?A=p:L!==1&&(L=1):A!==-1&&(L=-1)}return A===-1||$===-1||L===0||L===1&&A===$-1&&A===d+1?"":r.slice(A,$)},format:g.bind(null,"\\"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const A=r.length;let d=0,$=r.charCodeAt(0);if(A===1)return y($)?(l.root=l.dir=r,l):(l.base=l.name=r,l);if(y($)){if(d=1,y(r.charCodeAt(1))){let O=2,U=O;for(;O<A&&!y(r.charCodeAt(O));)O++;if(O<A&&O!==U){for(U=O;O<A&&y(r.charCodeAt(O));)O++;if(O<A&&O!==U){for(U=O;O<A&&!y(r.charCodeAt(O));)O++;O===A?d=O:O!==U&&(d=O+1)}}}}else if(b($)&&r.charCodeAt(1)===f){if(A<=2)return l.root=l.dir=r,l;if(d=2,y(r.charCodeAt(2))){if(A===3)return l.root=l.dir=r,l;d=3}}d>0&&(l.root=r.slice(0,d));let w=-1,L=d,p=-1,F=!0,P=r.length-1,I=0;for(;P>=d;--P){if($=r.charCodeAt(P),y($)){if(!F){L=P+1;break}continue}p===-1&&(F=!1,p=P+1),$===c?w===-1?w=P:I!==1&&(I=1):w!==-1&&(I=-1)}return p!==-1&&(w===-1||I===0||I===1&&w===p-1&&w===L+1?l.base=l.name=r.slice(L,p):(l.name=r.slice(L,w),l.base=r.slice(L,p),l.ext=r.slice(w,p))),L>0&&L!==d?l.dir=r.slice(0,L-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const m=(()=>{if(N){const r=/\\/g;return()=>{const l=k.cwd().replace(r,"/");return l.slice(l.indexOf("/"))}}return()=>k.cwd()})();t.$0b={resolve(...r){let l="",A=!1;for(let d=r.length-1;d>=-1&&!A;d--){const $=d>=0?r[d]:m();e($,"path"),$.length!==0&&(l=`${$}/${l}`,A=$.charCodeAt(0)===s)}return l=E(l,!A,"/",R),A?`/${l}`:l.length>0?l:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===s,A=r.charCodeAt(r.length-1)===s;return r=E(r,!l,"/",R),r.length===0?l?"/":A?"./":".":(A&&(r+="/"),l?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===s},join(...r){if(r.length===0)return".";let l;for(let A=0;A<r.length;++A){const d=r[A];e(d,"path"),d.length>0&&(l===void 0?l=d:l+=`/${d}`)}return l===void 0?".":t.$0b.normalize(l)},relative(r,l){if(e(r,"from"),e(l,"to"),r===l||(r=t.$0b.resolve(r),l=t.$0b.resolve(l),r===l))return"";const A=1,d=r.length,$=d-A,w=1,L=l.length-w,p=$<L?$:L;let F=-1,P=0;for(;P<p;P++){const O=r.charCodeAt(A+P);if(O!==l.charCodeAt(w+P))break;O===s&&(F=P)}if(P===p)if(L>p){if(l.charCodeAt(w+P)===s)return l.slice(w+P+1);if(P===0)return l.slice(w+P)}else $>p&&(r.charCodeAt(A+P)===s?F=P:P===0&&(F=0));let I="";for(P=A+F+1;P<=d;++P)(P===d||r.charCodeAt(P)===s)&&(I+=I.length===0?"..":"/..");return`${I}${l.slice(w+F)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const l=r.charCodeAt(0)===s;let A=-1,d=!0;for(let $=r.length-1;$>=1;--$)if(r.charCodeAt($)===s){if(!d){A=$;break}}else d=!1;return A===-1?l?"/":".":l&&A===1?"//":r.slice(0,A)},basename(r,l){l!==void 0&&e(l,"ext"),e(r,"path");let A=0,d=-1,$=!0,w;if(l!==void 0&&l.length>0&&l.length<=r.length){if(l===r)return"";let L=l.length-1,p=-1;for(w=r.length-1;w>=0;--w){const F=r.charCodeAt(w);if(F===s){if(!$){A=w+1;break}}else p===-1&&($=!1,p=w+1),L>=0&&(F===l.charCodeAt(L)?--L===-1&&(d=w):(L=-1,d=p))}return A===d?d=p:d===-1&&(d=r.length),r.slice(A,d)}for(w=r.length-1;w>=0;--w)if(r.charCodeAt(w)===s){if(!$){A=w+1;break}}else d===-1&&($=!1,d=w+1);return d===-1?"":r.slice(A,d)},extname(r){e(r,"path");let l=-1,A=0,d=-1,$=!0,w=0;for(let L=r.length-1;L>=0;--L){const p=r.charCodeAt(L);if(p===s){if(!$){A=L+1;break}continue}d===-1&&($=!1,d=L+1),p===c?l===-1?l=L:w!==1&&(w=1):l!==-1&&(w=-1)}return l===-1||d===-1||w===0||w===1&&l===d-1&&l===A+1?"":r.slice(l,d)},format:g.bind(null,"/"),parse(r){e(r,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return l;const A=r.charCodeAt(0)===s;let d;A?(l.root="/",d=1):d=0;let $=-1,w=0,L=-1,p=!0,F=r.length-1,P=0;for(;F>=d;--F){const I=r.charCodeAt(F);if(I===s){if(!p){w=F+1;break}continue}L===-1&&(p=!1,L=F+1),I===c?$===-1?$=F:P!==1&&(P=1):$!==-1&&(P=-1)}if(L!==-1){const I=w===0&&A?1:w;$===-1||P===0||P===1&&$===L-1&&$===w+1?l.base=l.name=r.slice(I,L):(l.name=r.slice(I,$),l.base=r.slice(I,L),l.ext=r.slice($,L))}return w>0?l.dir=r.slice(0,w-1):A&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},t.$0b.win32=t.$9b.win32=t.$9b,t.$0b.posix=t.$9b.posix=t.$0b,t.$$b=N?t.$9b.normalize:t.$0b.normalize,t.$_b=N?t.$9b.isAbsolute:t.$0b.isAbsolute,t.$ac=N?t.$9b.join:t.$0b.join,t.$bc=N?t.$9b.resolve:t.$0b.resolve,t.$cc=N?t.$9b.relative:t.$0b.relative,t.$dc=N?t.$9b.dirname:t.$0b.dirname,t.$ec=N?t.$9b.basename:t.$0b.basename,t.$fc=N?t.$9b.extname:t.$0b.extname,t.$gc=N?t.$9b.format:t.$0b.format,t.$hc=N?t.$9b.parse:t.$0b.parse,t.$ic=N?t.$9b.toNamespacedPath:t.$0b.toNamespacedPath,t.sep=N?t.$9b.sep:t.$0b.sep,t.$kc=N?t.$9b.delimiter:t.$0b.delimiter}),Y(Z[14],K([0,1,58,13]),function(H,t,k,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ue=t.$Te=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,a=/^\//,v=/^\/\//;function c(d,$){if(!d.scheme&&$)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!i.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!a.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(v.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function s(d,$){return!d&&!$?"file":d}function u(d,$){switch(d){case"https":case"http":case"file":$?$[0]!==M&&($=M+$):$=M;break}return $}const f="",M="/",h=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri($){return $ instanceof o?!0:$?typeof $.authority=="string"&&typeof $.fragment=="string"&&typeof $.path=="string"&&typeof $.query=="string"&&typeof $.scheme=="string"&&typeof $.fsPath=="string"&&typeof $.with=="function"&&typeof $.toString=="function":!1}constructor($,w,L,p,F,P=!1){typeof $=="object"?(this.scheme=$.scheme||f,this.authority=$.authority||f,this.path=$.path||f,this.query=$.query||f,this.fragment=$.fragment||f):(this.scheme=s($,P),this.authority=w||f,this.path=u(this.scheme,L||f),this.query=p||f,this.fragment=F||f,c(this,P))}get fsPath(){return g(this,!1)}with($){if(!$)return this;let{scheme:w,authority:L,path:p,query:F,fragment:P}=$;return w===void 0?w=this.scheme:w===null&&(w=f),L===void 0?L=this.authority:L===null&&(L=f),p===void 0?p=this.path:p===null&&(p=f),F===void 0?F=this.query:F===null&&(F=f),P===void 0?P=this.fragment:P===null&&(P=f),w===this.scheme&&L===this.authority&&p===this.path&&F===this.query&&P===this.fragment?this:new y(w,L,p,F,P)}static parse($,w=!1){const L=h.exec($);return L?new y(L[2]||f,A(L[4]||f),A(L[5]||f),A(L[7]||f),A(L[9]||f),w):new y(f,f,f,f,f)}static file($){let w=f;if(D.$i&&($=$.replace(/\\/g,M)),$[0]===M&&$[1]===M){const L=$.indexOf(M,2);L===-1?(w=$.substring(2),$=M):(w=$.substring(2,L),$=$.substring(L)||M)}return new y("file",w,$,f,f)}static from($,w){return new y($.scheme,$.authority,$.path,$.query,$.fragment,w)}static joinPath($,...w){if(!$.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let L;return D.$i&&$.scheme==="file"?L=o.file(k.$9b.join(g($,!0),...w)).path:L=k.$0b.join($.path,...w),$.with({path:L})}toString($=!1){return m(this,$)}toJSON(){return this}static revive($){if($){if($ instanceof o)return $;{const w=new y($);return w._formatted=$.external??null,w._fsPath=$._sep===N?$.fsPath??null:null,w}}else return $}}t.URI=o;function e(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}t.$Te=e;const N=D.$i?1:void 0;class y extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString($=!1){return $?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const $={$mid:1};return this._fsPath&&($.fsPath=this._fsPath,$._sep=N),this._formatted&&($.external=this._formatted),this.path&&($.path=this.path),this.scheme&&($.scheme=this.scheme),this.authority&&($.authority=this.authority),this.query&&($.query=this.query),this.fragment&&($.fragment=this.fragment),$}}const R={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(d,$,w){let L,p=-1;for(let F=0;F<d.length;F++){const P=d.charCodeAt(F);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||$&&P===47||w&&P===91||w&&P===93||w&&P===58)p!==-1&&(L+=encodeURIComponent(d.substring(p,F)),p=-1),L!==void 0&&(L+=d.charAt(F));else{L===void 0&&(L=d.substr(0,F));const I=R[P];I!==void 0?(p!==-1&&(L+=encodeURIComponent(d.substring(p,F)),p=-1),L+=I):p===-1&&(p=F)}}return p!==-1&&(L+=encodeURIComponent(d.substring(p))),L!==void 0?L:d}function E(d){let $;for(let w=0;w<d.length;w++){const L=d.charCodeAt(w);L===35||L===63?($===void 0&&($=d.substr(0,w)),$+=R[L]):$!==void 0&&($+=d[w])}return $!==void 0?$:d}function g(d,$){let w;return d.authority&&d.path.length>1&&d.scheme==="file"?w=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?$?w=d.path.substr(1):w=d.path[1].toLowerCase()+d.path.substr(2):w=d.path,D.$i&&(w=w.replace(/\//g,"\\")),w}t.$Ue=g;function m(d,$){const w=$?E:b;let L="",{scheme:p,authority:F,path:P,query:I,fragment:O}=d;if(p&&(L+=p,L+=":"),(F||p==="file")&&(L+=M,L+=M),F){let U=F.indexOf("@");if(U!==-1){const C=F.substr(0,U);F=F.substr(U+1),U=C.lastIndexOf(":"),U===-1?L+=w(C,!1,!1):(L+=w(C.substr(0,U),!1,!1),L+=":",L+=w(C.substr(U+1),!1,!0)),L+="@"}F=F.toLowerCase(),U=F.lastIndexOf(":"),U===-1?L+=w(F,!1,!0):(L+=w(F.substr(0,U),!1,!0),L+=F.substr(U))}if(P){if(P.length>=3&&P.charCodeAt(0)===47&&P.charCodeAt(2)===58){const U=P.charCodeAt(1);U>=65&&U<=90&&(P=`/${String.fromCharCode(U+32)}:${P.substr(3)}`)}else if(P.length>=2&&P.charCodeAt(1)===58){const U=P.charCodeAt(0);U>=65&&U<=90&&(P=`${String.fromCharCode(U+32)}:${P.substr(2)}`)}L+=w(P,!0,!1)}return I&&(L+="?",L+=w(I,!1,!1)),O&&(L+="#",L+=$?O:b(O,!1,!1)),L}function r(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+r(d.substr(3)):d}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(d){return d.match(l)?d.replace(l,$=>r($)):d}}),Y(Z[63],K([0,1,3,8,7,11,13,5]),function(H,t,k,D,i,a,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.SimpleWorkerServer=t.SimpleWorkerClient=t.logOnceWebWorkerWarning=void 0;const s="$initialize";let u=!1;function f(A){v.$o&&(u||(u=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(A.message))}t.logOnceWebWorkerWarning=f;var M;(function(A){A[A.Request=0]="Request",A[A.Reply=1]="Reply",A[A.SubscribeEvent=2]="SubscribeEvent",A[A.Event=3]="Event",A[A.UnsubscribeEvent=4]="UnsubscribeEvent"})(M||(M={}));class h{constructor(d,$,w,L){this.vsWorker=d,this.req=$,this.method=w,this.args=L,this.type=0}}class o{constructor(d,$,w,L){this.vsWorker=d,this.seq=$,this.res=w,this.err=L,this.type=1}}class e{constructor(d,$,w,L){this.vsWorker=d,this.req=$,this.eventName=w,this.arg=L,this.type=2}}class N{constructor(d,$,w){this.vsWorker=d,this.req=$,this.event=w,this.type=3}}class y{constructor(d,$){this.vsWorker=d,this.req=$,this.type=4}}class R{constructor(d){this.a=-1,this.g=d,this.b=0,this.c=Object.create(null),this.d=new Map,this.f=new Map}setWorkerId(d){this.a=d}sendMessage(d,$){const w=String(++this.b);return new Promise((L,p)=>{this.c[w]={resolve:L,reject:p},this.o(new h(this.a,w,d,$))})}listen(d,$){let w=null;const L=new D.$7c({onWillAddFirstListener:()=>{w=String(++this.b),this.d.set(w,L),this.o(new e(this.a,w,d,$))},onDidRemoveLastListener:()=>{this.d.delete(w),this.o(new y(this.a,w)),w=null}});return L.event}handleMessage(d){!d||!d.vsWorker||this.a!==-1&&d.vsWorker!==this.a||this.h(d)}h(d){switch(d.type){case 1:return this.j(d);case 0:return this.k(d);case 2:return this.l(d);case 3:return this.m(d);case 4:return this.n(d)}}j(d){if(!this.c[d.seq]){console.warn("Got reply to unknown seq");return}const $=this.c[d.seq];if(delete this.c[d.seq],d.err){let w=d.err;d.err.$isError&&(w=new Error,w.name=d.err.name,w.message=d.err.message,w.stack=d.err.stack),$.reject(w);return}$.resolve(d.res)}k(d){const $=d.req;this.g.handleMessage(d.method,d.args).then(L=>{this.o(new o(this.a,$,L,void 0))},L=>{L.detail instanceof Error&&(L.detail=(0,k.$1)(L.detail)),this.o(new o(this.a,$,void 0,(0,k.$1)(L)))})}l(d){const $=d.req,w=this.g.handleEvent(d.eventName,d.arg)(L=>{this.o(new N(this.a,$,L))});this.f.set($,w)}m(d){if(!this.d.has(d.req)){console.warn("Got event for unknown req");return}this.d.get(d.req).fire(d.event)}n(d){if(!this.f.has(d.req)){console.warn("Got unsubscribe for unknown req");return}this.f.get(d.req).dispose(),this.f.delete(d.req)}o(d){const $=[];if(d.type===0)for(let w=0;w<d.args.length;w++)d.args[w]instanceof ArrayBuffer&&$.push(d.args[w]);else d.type===1&&d.res instanceof ArrayBuffer&&$.push(d.res);this.g.sendMessage(d,$)}}class b extends i.$lb{constructor(d,$,w){super();let L=null;this.a=this.B(d.create("vs/base/common/worker/simpleWorker",U=>{this.c.handleMessage(U)},U=>{L?.(U)})),this.c=new R({sendMessage:(U,C)=>{this.a.postMessage(U,C)},handleMessage:(U,C)=>{if(typeof w[U]!="function")return Promise.reject(new Error("Missing method "+U+" on main thread host."));try{return Promise.resolve(w[U].apply(w,C))}catch(_){return Promise.reject(_)}},handleEvent:(U,C)=>{if(g(U)){const _=w[U].call(w,C);if(typeof _!="function")throw new Error(`Missing dynamic event ${U} on main thread host.`);return _}if(E(U)){const _=w[U];if(typeof _!="function")throw new Error(`Missing event ${U} on main thread host.`);return _}throw new Error(`Malformed event name ${U}`)}}),this.c.setWorkerId(this.a.getId());let p=null;const F=globalThis.require;typeof F<"u"&&typeof F.getConfig=="function"?p=F.getConfig():typeof globalThis.requirejs<"u"&&(p=globalThis.requirejs.s.contexts._.config);const P=(0,a.$Pm)(w);this.b=this.c.sendMessage(s,[this.a.getId(),JSON.parse(JSON.stringify(p)),$,P]);const I=(U,C)=>this.g(U,C),O=(U,C)=>this.c.listen(U,C);this.f=new Promise((U,C)=>{L=C,this.b.then(_=>{U(m(_,I,O))},_=>{C(_),this.h("Worker failed to load "+$,_)})})}getProxyObject(){return this.f}g(d,$){return new Promise((w,L)=>{this.b.then(()=>{this.c.sendMessage(d,$).then(w,L)},L)})}h(d,$){console.error(d),console.info($)}}t.SimpleWorkerClient=b;function E(A){return A[0]==="o"&&A[1]==="n"&&c.$Kd(A.charCodeAt(2))}function g(A){return/^onDynamic/.test(A)&&c.$Kd(A.charCodeAt(9))}function m(A,d,$){const w=F=>function(){const P=Array.prototype.slice.call(arguments,0);return d(F,P)},L=F=>function(P){return $(F,P)},p={};for(const F of A){if(g(F)){p[F]=L(F);continue}if(E(F)){p[F]=$(F,void 0);continue}p[F]=w(F)}return p}class r{constructor(d,$){this.a=$,this.b=null,this.c=new R({sendMessage:(w,L)=>{d(w,L)},handleMessage:(w,L)=>this.d(w,L),handleEvent:(w,L)=>this.f(w,L)})}onmessage(d){this.c.handleMessage(d)}d(d,$){if(d===s)return this.g($[0],$[1],$[2],$[3]);if(!this.b||typeof this.b[d]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+d));try{return Promise.resolve(this.b[d].apply(this.b,$))}catch(w){return Promise.reject(w)}}f(d,$){if(!this.b)throw new Error("Missing requestHandler");if(g(d)){const w=this.b[d].call(this.b,$);if(typeof w!="function")throw new Error(`Missing dynamic event ${d} on request handler.`);return w}if(E(d)){const w=this.b[d];if(typeof w!="function")throw new Error(`Missing event ${d} on request handler.`);return w}throw new Error(`Malformed event name ${d}`)}g(d,$,w,L){this.c.setWorkerId(d);const P=m(L,(I,O)=>this.c.sendMessage(I,O),(I,O)=>this.c.listen(I,O));return this.a?(this.b=this.a(P),Promise.resolve((0,a.$Pm)(this.b))):($&&(typeof $.baseUrl<"u"&&delete $.baseUrl,typeof $.paths<"u"&&typeof $.paths.vs<"u"&&delete $.paths.vs,typeof $.trustedTypesPolicy!==void 0&&delete $.trustedTypesPolicy,$.catchError=!0,globalThis.require.config($)),new Promise((I,O)=>{(globalThis.require||H)([w],C=>{if(this.b=C.create(P),!this.b){O(new Error("No RequestHandler!"));return}I((0,a.$Pm)(this.b))},O)}))}}t.SimpleWorkerServer=r;function l(A){return new r(A,null)}t.create=l}),Y(Z[59],K([55,56]),function(H,t){return H.create("vs/editor/common/languages",t)}),Y(Z[60],K([0,1,34,14,35,2,53,59]),function(H,t,k,D,i,a,v,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExternalUriOpenerPriority=t.$us=t.$ts=t.InlayHintKind=t.CommentState=t.CommentMode=t.CommentThreadState=t.CommentThreadCollapsibleState=t.Command=t.$ss=t.$rs=t.SymbolKinds=t.SymbolTag=t.$qs=t.$ps=t.SymbolKind=t.$os=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.$ns=t.InlineCompletionTriggerKind=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.CompletionItemKinds=t.CompletionItemKind=t.$ms=t.$ls=t.$ks=void 0;class s{constructor(W,G,X){this.offset=W,this.type=G,this.language=X,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}t.$ks=s;class u{constructor(W,G){this.tokens=W,this.endState=G,this._tokenizationResultBrand=void 0}}t.$ls=u;class f{constructor(W,G){this.tokens=W,this.endState=G,this._encodedTokenizationResultBrand=void 0}}t.$ms=f;var M;(function(_){_[_.Method=0]="Method",_[_.Function=1]="Function",_[_.Constructor=2]="Constructor",_[_.Field=3]="Field",_[_.Variable=4]="Variable",_[_.Class=5]="Class",_[_.Struct=6]="Struct",_[_.Interface=7]="Interface",_[_.Module=8]="Module",_[_.Property=9]="Property",_[_.Event=10]="Event",_[_.Operator=11]="Operator",_[_.Unit=12]="Unit",_[_.Value=13]="Value",_[_.Constant=14]="Constant",_[_.Enum=15]="Enum",_[_.EnumMember=16]="EnumMember",_[_.Keyword=17]="Keyword",_[_.Text=18]="Text",_[_.Color=19]="Color",_[_.File=20]="File",_[_.Reference=21]="Reference",_[_.Customcolor=22]="Customcolor",_[_.Folder=23]="Folder",_[_.TypeParameter=24]="TypeParameter",_[_.User=25]="User",_[_.Issue=26]="Issue",_[_.Snippet=27]="Snippet"})(M||(t.CompletionItemKind=M={}));var h;(function(_){const W=new Map;W.set(0,k.$Aj.symbolMethod),W.set(1,k.$Aj.symbolFunction),W.set(2,k.$Aj.symbolConstructor),W.set(3,k.$Aj.symbolField),W.set(4,k.$Aj.symbolVariable),W.set(5,k.$Aj.symbolClass),W.set(6,k.$Aj.symbolStruct),W.set(7,k.$Aj.symbolInterface),W.set(8,k.$Aj.symbolModule),W.set(9,k.$Aj.symbolProperty),W.set(10,k.$Aj.symbolEvent),W.set(11,k.$Aj.symbolOperator),W.set(12,k.$Aj.symbolUnit),W.set(13,k.$Aj.symbolValue),W.set(15,k.$Aj.symbolEnum),W.set(14,k.$Aj.symbolConstant),W.set(15,k.$Aj.symbolEnum),W.set(16,k.$Aj.symbolEnumMember),W.set(17,k.$Aj.symbolKeyword),W.set(27,k.$Aj.symbolSnippet),W.set(18,k.$Aj.symbolText),W.set(19,k.$Aj.symbolColor),W.set(20,k.$Aj.symbolFile),W.set(21,k.$Aj.symbolReference),W.set(22,k.$Aj.symbolCustomColor),W.set(23,k.$Aj.symbolFolder),W.set(24,k.$Aj.symbolTypeParameter),W.set(25,k.$Aj.account),W.set(26,k.$Aj.issues);function G(n){let oe=W.get(n);return oe||(console.info("No codicon found for CompletionItemKind "+n),oe=k.$Aj.symbolProperty),oe}_.toIcon=G;const X=new Map;X.set("method",0),X.set("function",1),X.set("constructor",2),X.set("field",3),X.set("variable",4),X.set("class",5),X.set("struct",6),X.set("interface",7),X.set("module",8),X.set("property",9),X.set("event",10),X.set("operator",11),X.set("unit",12),X.set("value",13),X.set("constant",14),X.set("enum",15),X.set("enum-member",16),X.set("enumMember",16),X.set("keyword",17),X.set("snippet",27),X.set("text",18),X.set("color",19),X.set("file",20),X.set("reference",21),X.set("customcolor",22),X.set("folder",23),X.set("type-parameter",24),X.set("typeParameter",24),X.set("account",25),X.set("issue",26);function ne(n,oe){let ce=X.get(n);return typeof ce>"u"&&!oe&&(ce=9),ce}_.fromString=ne})(h||(t.CompletionItemKinds=h={}));var o;(function(_){_[_.Deprecated=1]="Deprecated"})(o||(t.CompletionItemTag=o={}));var e;(function(_){_[_.None=0]="None",_[_.KeepWhitespace=1]="KeepWhitespace",_[_.InsertAsSnippet=4]="InsertAsSnippet"})(e||(t.CompletionItemInsertTextRule=e={}));var N;(function(_){_[_.Invoke=0]="Invoke",_[_.TriggerCharacter=1]="TriggerCharacter",_[_.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(N||(t.CompletionTriggerKind=N={}));var y;(function(_){_[_.Automatic=0]="Automatic",_[_.Explicit=1]="Explicit"})(y||(t.InlineCompletionTriggerKind=y={}));class R{constructor(W,G,X,ne){this.range=W,this.text=G,this.completionKind=X,this.isSnippetText=ne}equals(W){return a.$Mr.lift(this.range).equalsRange(W.range)&&this.text===W.text&&this.completionKind===W.completionKind&&this.isSnippetText===W.isSnippetText}}t.$ns=R;var b;(function(_){_[_.Invoke=1]="Invoke",_[_.Auto=2]="Auto"})(b||(t.CodeActionTriggerType=b={}));var E;(function(_){_[_.Invoke=1]="Invoke",_[_.TriggerCharacter=2]="TriggerCharacter",_[_.ContentChange=3]="ContentChange"})(E||(t.SignatureHelpTriggerKind=E={}));var g;(function(_){_[_.Text=0]="Text",_[_.Read=1]="Read",_[_.Write=2]="Write"})(g||(t.DocumentHighlightKind=g={}));function m(_){return _&&D.URI.isUri(_.uri)&&a.$Mr.isIRange(_.range)&&(a.$Mr.isIRange(_.originSelectionRange)||a.$Mr.isIRange(_.targetSelectionRange))}t.$os=m;var r;(function(_){_[_.File=0]="File",_[_.Module=1]="Module",_[_.Namespace=2]="Namespace",_[_.Package=3]="Package",_[_.Class=4]="Class",_[_.Method=5]="Method",_[_.Property=6]="Property",_[_.Field=7]="Field",_[_.Constructor=8]="Constructor",_[_.Enum=9]="Enum",_[_.Interface=10]="Interface",_[_.Function=11]="Function",_[_.Variable=12]="Variable",_[_.Constant=13]="Constant",_[_.String=14]="String",_[_.Number=15]="Number",_[_.Boolean=16]="Boolean",_[_.Array=17]="Array",_[_.Object=18]="Object",_[_.Key=19]="Key",_[_.Null=20]="Null",_[_.EnumMember=21]="EnumMember",_[_.Struct=22]="Struct",_[_.Event=23]="Event",_[_.Operator=24]="Operator",_[_.TypeParameter=25]="TypeParameter"})(r||(t.SymbolKind=r={})),t.$ps={[17]:(0,c.localize)(0,null),[16]:(0,c.localize)(1,null),[4]:(0,c.localize)(2,null),[13]:(0,c.localize)(3,null),[8]:(0,c.localize)(4,null),[9]:(0,c.localize)(5,null),[21]:(0,c.localize)(6,null),[23]:(0,c.localize)(7,null),[7]:(0,c.localize)(8,null),[0]:(0,c.localize)(9,null),[11]:(0,c.localize)(10,null),[10]:(0,c.localize)(11,null),[19]:(0,c.localize)(12,null),[5]:(0,c.localize)(13,null),[1]:(0,c.localize)(14,null),[2]:(0,c.localize)(15,null),[20]:(0,c.localize)(16,null),[15]:(0,c.localize)(17,null),[18]:(0,c.localize)(18,null),[24]:(0,c.localize)(19,null),[3]:(0,c.localize)(20,null),[6]:(0,c.localize)(21,null),[14]:(0,c.localize)(22,null),[22]:(0,c.localize)(23,null),[25]:(0,c.localize)(24,null),[12]:(0,c.localize)(25,null)};function l(_,W){return(0,c.localize)(26,null,_,t.$ps[W])}t.$qs=l;var A;(function(_){_[_.Deprecated=1]="Deprecated"})(A||(t.SymbolTag=A={}));var d;(function(_){const W=new Map;W.set(0,k.$Aj.symbolFile),W.set(1,k.$Aj.symbolModule),W.set(2,k.$Aj.symbolNamespace),W.set(3,k.$Aj.symbolPackage),W.set(4,k.$Aj.symbolClass),W.set(5,k.$Aj.symbolMethod),W.set(6,k.$Aj.symbolProperty),W.set(7,k.$Aj.symbolField),W.set(8,k.$Aj.symbolConstructor),W.set(9,k.$Aj.symbolEnum),W.set(10,k.$Aj.symbolInterface),W.set(11,k.$Aj.symbolFunction),W.set(12,k.$Aj.symbolVariable),W.set(13,k.$Aj.symbolConstant),W.set(14,k.$Aj.symbolString),W.set(15,k.$Aj.symbolNumber),W.set(16,k.$Aj.symbolBoolean),W.set(17,k.$Aj.symbolArray),W.set(18,k.$Aj.symbolObject),W.set(19,k.$Aj.symbolKey),W.set(20,k.$Aj.symbolNull),W.set(21,k.$Aj.symbolEnumMember),W.set(22,k.$Aj.symbolStruct),W.set(23,k.$Aj.symbolEvent),W.set(24,k.$Aj.symbolOperator),W.set(25,k.$Aj.symbolTypeParameter);function G(X){let ne=W.get(X);return ne||(console.info("No codicon found for SymbolKind "+X),ne=k.$Aj.symbolProperty),ne}_.toIcon=G})(d||(t.SymbolKinds=d={}));class ${static asEditOperation(W){return i.$Tr.replace(a.$Mr.lift(W.range),W.text)}}t.$rs=$;class w{static{this.Comment=new w("comment")}static{this.Imports=new w("imports")}static{this.Region=new w("region")}static fromValue(W){switch(W){case"comment":return w.Comment;case"imports":return w.Imports;case"region":return w.Region}return new w(W)}constructor(W){this.value=W}}t.$ss=w;var L;(function(_){function W(G){return!G||typeof G!="object"?!1:typeof G.id=="string"&&typeof G.title=="string"}_.is=W})(L||(t.Command=L={}));var p;(function(_){_[_.Collapsed=0]="Collapsed",_[_.Expanded=1]="Expanded"})(p||(t.CommentThreadCollapsibleState=p={}));var F;(function(_){_[_.Unresolved=0]="Unresolved",_[_.Resolved=1]="Resolved"})(F||(t.CommentThreadState=F={}));var P;(function(_){_[_.Editing=0]="Editing",_[_.Preview=1]="Preview"})(P||(t.CommentMode=P={}));var I;(function(_){_[_.Published=0]="Published",_[_.Draft=1]="Draft"})(I||(t.CommentState=I={}));var O;(function(_){_[_.Type=1]="Type",_[_.Parameter=2]="Parameter"})(O||(t.InlayHintKind=O={}));class U{constructor(W){this.b=W,this.a=null}dispose(){this.a&&this.a.then(W=>{W&&W.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}t.$ts=U,t.$us=new v.$cs;var C;(function(_){_[_.None=0]="None",_[_.Option=1]="Option",_[_.Default=2]="Default",_[_.Preferred=3]="Preferred"})(C||(t.ExternalUriOpenerPriority=C={}))}),Y(Z[61],K([0,1,19,8,30,14,4,2,36,60,52]),function(H,t,k,D,i,a,v,c,s,u,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$W=t.$0W=void 0;class M{static{this.CtrlCmd=2048}static{this.Shift=1024}static{this.Alt=512}static{this.WinCtrl=256}static chord(e,N){return(0,i.$iq)(e,N)}}t.$0W=M;function h(){return{editor:void 0,languages:void 0,CancellationTokenSource:k.$dd,Emitter:D.$7c,KeyCode:f.KeyCode,KeyMod:M,Position:v.$Lr,Range:c.$Mr,Selection:s.$Ur,SelectionDirection:f.SelectionDirection,MarkerSeverity:f.MarkerSeverity,MarkerTag:f.MarkerTag,Uri:a.URI,Token:u.$ks}}t.$$W=h}),Y(Z[64],K([0,1,20,14,4,2,49,24,45,46,61,18,51,26,43,11,3,44]),function(H,t,k,D,i,a,v,c,s,u,f,M,h,o,e,N,y,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.create=t.EditorSimpleWorker=void 0;class b extends v.$uu{get uri(){return this.d}get eol(){return this.g}getValue(){return this.getText()}findMatches(r){const l=[];for(let A=0;A<this.f.length;A++){const d=this.f[A],$=this.offsetAt(new i.$Lr(A+1,1)),w=d.matchAll(r);for(const L of w)(L.index||L.index===0)&&(L.index=L.index+$),l.push(L)}return l}getLinesContent(){return this.f.slice(0)}getLineCount(){return this.f.length}getLineContent(r){return this.f[r-1]}getWordAtPosition(r,l){const A=(0,c.$Kr)(r.column,(0,c.$Ir)(l),this.f[r.lineNumber-1],0);return A?new a.$Mr(r.lineNumber,A.startColumn,r.lineNumber,A.endColumn):null}getWordUntilPosition(r,l){const A=this.getWordAtPosition(r,l);return A?{word:this.f[r.lineNumber-1].substring(A.startColumn-1,r.column-1),startColumn:A.startColumn,endColumn:r.column}:{word:"",startColumn:r.column,endColumn:r.column}}words(r){const l=this.f,A=this.q.bind(this);let d=0,$="",w=0,L=[];return{*[Symbol.iterator](){for(;;)if(w<L.length){const p=$.substring(L[w].start,L[w].end);w+=1,yield p}else if(d<l.length)$=l[d],L=A($,r),w=0,d+=1;else break}}}getLineWords(r,l){const A=this.f[r-1],d=this.q(A,l),$=[];for(const w of d)$.push({word:A.substring(w.start,w.end),startColumn:w.start+1,endColumn:w.end+1});return $}q(r,l){const A=[];let d;for(l.lastIndex=0;(d=l.exec(r))&&d[0].length!==0;)A.push({start:d.index,end:d.index+d[0].length});return A}getValueInRange(r){if(r=this.r(r),r.startLineNumber===r.endLineNumber)return this.f[r.startLineNumber-1].substring(r.startColumn-1,r.endColumn-1);const l=this.g,A=r.startLineNumber-1,d=r.endLineNumber-1,$=[];$.push(this.f[A].substring(r.startColumn-1));for(let w=A+1;w<d;w++)$.push(this.f[w]);return $.push(this.f[d].substring(0,r.endColumn-1)),$.join(l)}offsetAt(r){return r=this.s(r),this.l(),this.j.getPrefixSum(r.lineNumber-2)+(r.column-1)}positionAt(r){r=Math.floor(r),r=Math.max(0,r),this.l();const l=this.j.getIndexOf(r),A=this.f[l.index].length;return{lineNumber:1+l.index,column:1+Math.min(l.remainder,A)}}r(r){const l=this.s({lineNumber:r.startLineNumber,column:r.startColumn}),A=this.s({lineNumber:r.endLineNumber,column:r.endColumn});return l.lineNumber!==r.startLineNumber||l.column!==r.startColumn||A.lineNumber!==r.endLineNumber||A.column!==r.endColumn?{startLineNumber:l.lineNumber,startColumn:l.column,endLineNumber:A.lineNumber,endColumn:A.column}:r}s(r){if(!i.$Lr.isIPosition(r))throw new Error("bad position");let{lineNumber:l,column:A}=r,d=!1;if(l<1)l=1,A=1,d=!0;else if(l>this.f.length)l=this.f.length,A=this.f[l-1].length+1,d=!0;else{const $=this.f[l-1].length+1;A<1?(A=1,d=!0):A>$&&(A=$,d=!0)}return d?{lineNumber:l,column:A}:r}}class E{constructor(r,l){this.d=r,this.f=Object.create(null),this.g=l,this.h=null}dispose(){this.f=Object.create(null)}j(r){return this.f[r]}k(){const r=[];return Object.keys(this.f).forEach(l=>r.push(this.f[l])),r}acceptNewModel(r){this.f[r.url]=new b(D.URI.parse(r.url),r.lines,r.EOL,r.versionId)}acceptModelChanged(r,l){if(!this.f[r])return;this.f[r].onEvents(l)}acceptRemovedModel(r){this.f[r]&&delete this.f[r]}async computeUnicodeHighlights(r,l,A){const d=this.j(r);return d?h.$5W.computeUnicodeHighlights(d,l,A):{ranges:[],hasMore:!1,ambiguousCharacterCount:0,invisibleCharacterCount:0,nonBasicAsciiCharacterCount:0}}async computeDiff(r,l,A,d){const $=this.j(r),w=this.j(l);return!$||!w?null:E.l($,w,A,d)}static l(r,l,A,d){const $=d==="advanced"?e.$qX.getAdvanced():e.$qX.getLegacy(),w=r.getLinesContent(),L=l.getLinesContent(),p=$.computeDiff(w,L,A),F=p.changes.length>0?!1:this.n(r,l);function P(I){return I.map(O=>[O.originalRange.startLineNumber,O.originalRange.endLineNumberExclusive,O.modifiedRange.startLineNumber,O.modifiedRange.endLineNumberExclusive,O.innerChanges?.map(U=>[U.originalRange.startLineNumber,U.originalRange.startColumn,U.originalRange.endLineNumber,U.originalRange.endColumn,U.modifiedRange.startLineNumber,U.modifiedRange.startColumn,U.modifiedRange.endLineNumber,U.modifiedRange.endColumn])])}return{identical:F,quitEarly:p.hitTimeout,changes:P(p.changes),moves:p.moves.map(I=>[I.lineRangeMapping.original.startLineNumber,I.lineRangeMapping.original.endLineNumberExclusive,I.lineRangeMapping.modified.startLineNumber,I.lineRangeMapping.modified.endLineNumberExclusive,P(I.changes)])}}static n(r,l){const A=r.getLineCount(),d=l.getLineCount();if(A!==d)return!1;for(let $=1;$<=A;$++){const w=r.getLineContent($),L=l.getLineContent($);if(w!==L)return!1}return!0}async computeDirtyDiff(r,l,A){const d=this.j(r),$=this.j(l);if(!d||!$)return null;const w=d.getLinesContent(),L=$.getLinesContent();return new o.$ou(w,L,{shouldComputeCharChanges:!1,shouldPostProcessCharChanges:!1,shouldIgnoreTrimWhitespace:A,shouldMakePrettyDiff:!0,maxComputationTime:1e3}).computeDiff().changes}static{this.o=1e5}async computeMoreMinimalEdits(r,l,A){const d=this.j(r);if(!d)return l;const $=[];let w;l=l.slice(0).sort((L,p)=>{if(L.range&&p.range)return a.$Mr.compareRangesUsingStarts(L.range,p.range);const F=L.range?0:1,P=p.range?0:1;return F-P});for(let{range:L,text:p,eol:F}of l){if(typeof F=="number"&&(w=F),a.$Mr.isEmpty(L)&&!p)continue;const P=d.getValueInRange(L);if(p=p.replace(/\r\n|\n|\r/g,d.eol),P===p)continue;if(Math.max(p.length,P.length)>E.o){$.push({range:L,text:p});continue}const I=(0,k.$lu)(P,p,A),O=d.offsetAt(a.$Mr.lift(L).getStartPosition());for(const U of I){const C=d.positionAt(O+U.originalStart),_=d.positionAt(O+U.originalStart+U.originalLength),W={text:p.substr(U.modifiedStart,U.modifiedLength),range:{startLineNumber:C.lineNumber,startColumn:C.column,endLineNumber:_.lineNumber,endColumn:_.column}};d.getValueInRange(W.range)!==W.text&&$.push(W)}}return typeof w=="number"&&$.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),$}async computeHumanReadableDiff(r,l,A){const d=this.j(r);if(!d)return l;const $=[];let w;l=l.slice(0).sort((L,p)=>{if(L.range&&p.range)return a.$Mr.compareRangesUsingStarts(L.range,p.range);const F=L.range?0:1,P=p.range?0:1;return F-P});for(let{range:L,text:p,eol:F}of l){let _=function(G,X){return new i.$Lr(G.lineNumber+X.lineNumber-1,X.lineNumber===1?G.column+X.column-1:X.column)},W=function(G,X){const ne=[];for(let n=X.startLineNumber;n<=X.endLineNumber;n++){const oe=G[n-1];n===X.startLineNumber&&n===X.endLineNumber?ne.push(oe.substring(X.startColumn-1,X.endColumn-1)):n===X.startLineNumber?ne.push(oe.substring(X.startColumn-1)):n===X.endLineNumber?ne.push(oe.substring(0,X.endColumn-1)):ne.push(oe)}return ne};if(typeof F=="number"&&(w=F),a.$Mr.isEmpty(L)&&!p)continue;const P=d.getValueInRange(L);if(p=p.replace(/\r\n|\n|\r/g,d.eol),P===p)continue;if(Math.max(p.length,P.length)>E.o){$.push({range:L,text:p});continue}const I=P.split(/\r\n|\n|\r/),O=p.split(/\r\n|\n|\r/),U=e.$qX.getAdvanced().computeDiff(I,O,A),C=a.$Mr.lift(L).getStartPosition();for(const G of U.changes)if(G.innerChanges)for(const X of G.innerChanges)$.push({range:a.$Mr.fromPositions(_(C,X.originalRange.getStartPosition()),_(C,X.originalRange.getEndPosition())),text:W(O,X.modifiedRange).join(d.eol)});else throw new y.$bb("The experimental diff algorithm always produces inner changes")}return typeof w=="number"&&$.push({eol:w,text:"",range:{startLineNumber:0,startColumn:0,endLineNumber:0,endColumn:0}}),$}async computeLinks(r){const l=this.j(r);return l?(0,s.$8W)(l):null}async computeDefaultDocumentColors(r){const l=this.j(r);return l?(0,R.$rX)(l):null}static{this.p=1e4}async textualSuggest(r,l,A,d){const $=new M.$3c,w=new RegExp(A,d),L=new Set;e:for(const p of r){const F=this.j(p);if(F){for(const P of F.words(w))if(!(P===l||!isNaN(Number(P)))&&(L.add(P),L.size>E.p))break e}}return{words:Array.from(L),duration:$.elapsed()}}async computeWordRanges(r,l,A,d){const $=this.j(r);if(!$)return Object.create(null);const w=new RegExp(A,d),L=Object.create(null);for(let p=l.startLineNumber;p<l.endLineNumber;p++){const F=$.getLineWords(p,w);for(const P of F){if(!isNaN(Number(P.word)))continue;let I=L[P.word];I||(I=[],L[P.word]=I),I.push({startLineNumber:p,startColumn:P.startColumn,endLineNumber:p,endColumn:P.endColumn})}}return L}async navigateValueSet(r,l,A,d,$){const w=this.j(r);if(!w)return null;const L=new RegExp(d,$);l.startColumn===l.endColumn&&(l={startLineNumber:l.startLineNumber,startColumn:l.startColumn,endLineNumber:l.endLineNumber,endColumn:l.endColumn+1});const p=w.getValueInRange(l),F=w.getWordAtPosition({lineNumber:l.startLineNumber,column:l.startColumn},L);if(!F)return null;const P=w.getValueInRange(F);return u.$9W.INSTANCE.navigateValueSet(l,p,F,P,A)}loadForeignModule(r,l,A){const d=(L,p)=>this.d.fhr(L,p),w={host:(0,N.$Qm)(A,d),getMirrorModels:()=>this.k()};return this.g?(this.h=this.g(w,l),Promise.resolve((0,N.$Pm)(this.h))):new Promise((L,p)=>{H([r],F=>{this.h=F.create(w,l),L((0,N.$Pm)(this.h))},p)})}fmr(r,l){if(!this.h||typeof this.h[r]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+r));try{return Promise.resolve(this.h[r].apply(this.h,l))}catch(A){return Promise.reject(A)}}}t.EditorSimpleWorker=E;function g(m){return new E(m,null)}t.create=g,typeof importScripts=="function"&&(globalThis.monaco=(0,f.$$W)())})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c3e3dba23e8fadc360aed75ce363ba185c49794/core/vs/base/worker/workerMain.js.map
