/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/base/common/types","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/arrays","vs/base/common/strings","vs/platform/telemetry/common/telemetry","os","vs/platform/environment/electron-main/environmentMainService","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/uuid","vs/base/common/extpath","vs/platform/environment/common/environment","vs/platform/state/node/state","vs/base/common/map","vs/base/common/process","vs/base/common/objects","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/json","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/stream","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/utilityProcess/electron-main/utilityProcess","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","crypto","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/lazy","vs/base/common/normalization","vs/base/node/id","net","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/parts/ipc/node/ipc.net","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/code/electron-main/auth","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","string_decoder","vs/code/electron-main/main"],ie=function(G){for(var e=[],E=0,C=G.length;E<C;E++)e[E]=te[G[E]];return e};define(te[134],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8r=e.$7r=e.$6r=e.$5r=void 0;function E(S,f){const u=Math.pow(10,f);return Math.round(S*u)/u}class C{constructor(f,u,$,d=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,u))|0,this.b=Math.min(255,Math.max(0,$))|0,this.a=E(Math.max(Math.min(1,d),0),3)}static equals(f,u){return f.r===u.r&&f.g===u.g&&f.b===u.b&&f.a===u.a}}e.$5r=C;class r{constructor(f,u,$,d){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,u),0),3),this.l=E(Math.max(Math.min(1,$),0),3),this.a=E(Math.max(Math.min(1,d),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.l===u.l&&f.a===u.a}static fromRGBA(f){const u=f.r/255,$=f.g/255,d=f.b/255,p=f.a,h=Math.max(u,$,d),v=Math.min(u,$,d);let y=0,o=0;const g=(v+h)/2,c=h-v;if(c>0){switch(o=Math.min(g<=.5?c/(2*g):c/(2-2*g),1),h){case u:y=($-d)/c+($<d?6:0);break;case $:y=(d-u)/c+2;break;case d:y=(u-$)/c+4;break}y*=60,y=Math.round(y)}return new r(y,o,g,p)}static i(f,u,$){return $<0&&($+=1),$>1&&($-=1),$<1/6?f+(u-f)*6*$:$<1/2?u:$<2/3?f+(u-f)*(2/3-$)*6:f}static toRGBA(f){const u=f.h/360,{s:$,l:d,a:p}=f;let h,v,y;if($===0)h=v=y=d;else{const o=d<.5?d*(1+$):d+$-d*$,g=2*d-o;h=r.i(g,o,u+1/3),v=r.i(g,o,u),y=r.i(g,o,u-1/3)}return new C(Math.round(h*255),Math.round(v*255),Math.round(y*255),p)}}e.$6r=r;class M{constructor(f,u,$,d){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=E(Math.max(Math.min(1,u),0),3),this.v=E(Math.max(Math.min(1,$),0),3),this.a=E(Math.max(Math.min(1,d),0),3)}static equals(f,u){return f.h===u.h&&f.s===u.s&&f.v===u.v&&f.a===u.a}static fromRGBA(f){const u=f.r/255,$=f.g/255,d=f.b/255,p=Math.max(u,$,d),h=Math.min(u,$,d),v=p-h,y=p===0?0:v/p;let o;return v===0?o=0:p===u?o=(($-d)/v%6+6)%6:p===$?o=(d-u)/v+2:o=(u-$)/v+4,new M(Math.round(o*60),y,p,f.a)}static toRGBA(f){const{h:u,s:$,v:d,a:p}=f,h=d*$,v=h*(1-Math.abs(u/60%2-1)),y=d-h;let[o,g,c]=[0,0,0];return u<60?(o=h,g=v):u<120?(o=v,g=h):u<180?(g=h,c=v):u<240?(g=v,c=h):u<300?(o=v,c=h):u<=360&&(o=h,c=v),o=Math.round((o+y)*255),g=Math.round((g+y)*255),c=Math.round((c+y)*255),new C(o,g,c,p)}}e.$7r=M;class R{static fromHex(f){return R.Format.CSS.parseHex(f)||R.red}static equals(f,u){return!f&&!u?!0:!f||!u?!1:f.equals(u)}get hsla(){return this.i?this.i:r.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:M.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof C)this.rgba=f;else if(f instanceof r)this.i=f,this.rgba=r.toRGBA(f);else if(f instanceof M)this.j=f,this.rgba=M.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&C.equals(this.rgba,f.rgba)&&r.equals(this.hsla,f.hsla)&&M.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=R.k(this.rgba.r),u=R.k(this.rgba.g),$=R.k(this.rgba.b),d=.2126*f+.7152*u+.0722*$;return E(d,4)}static k(f){const u=f/255;return u<=.03928?u/12.92:Math.pow((u+.055)/1.055,2.4)}getContrastRatio(f){const u=this.getRelativeLuminance(),$=f.getRelativeLuminance();return u>$?(u+.05)/($+.05):($+.05)/(u+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const u=this.getRelativeLuminance(),$=f.getRelativeLuminance();return u>$}isDarkerThan(f){const u=this.getRelativeLuminance(),$=f.getRelativeLuminance();return u<$}lighten(f){return new R(new r(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new R(new r(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:u,g:$,b:d,a:p}=this.rgba;return new R(new C(u,$,d,p*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const u=f.rgba,$=this.rgba.a,d=u.a,p=$+d*(1-$);if(p<1e-6)return R.transparent;const h=this.rgba.r*$/p+u.r*d*(1-$)/p,v=this.rgba.g*$/p+u.g*d*(1-$)/p,y=this.rgba.b*$/p+u.b*d*(1-$)/p;return new R(new C(h,v,y,p))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:u,g:$,b:d,a:p}=this.rgba;return new R(new C(f.rgba.r-p*(f.rgba.r-u),f.rgba.g-p*(f.rgba.g-$),f.rgba.b-p*(f.rgba.b-d),1))}flatten(...f){const u=f.reduceRight(($,d)=>R.o(d,$));return R.o(this,u)}static o(f,u){const $=1-f.rgba.a;return new R(new C($*u.rgba.r+f.rgba.a*f.rgba.r,$*u.rgba.g+f.rgba.a*f.rgba.g,$*u.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=R.Format.CSS.format(this)),this.u}static getLighterColor(f,u,$){if(f.isLighterThan(u))return f;$=$||.5;const d=f.getRelativeLuminance(),p=u.getRelativeLuminance();return $=$*(p-d)/p,f.lighten($)}static getDarkerColor(f,u,$){if(f.isDarkerThan(u))return f;$=$||.5;const d=f.getRelativeLuminance(),p=u.getRelativeLuminance();return $=$*(d-p)/d,f.darken($)}static{this.white=new R(new C(255,255,255,1))}static{this.black=new R(new C(0,0,0,1))}static{this.red=new R(new C(255,0,0,1))}static{this.blue=new R(new C(0,0,255,1))}static{this.green=new R(new C(0,255,0,1))}static{this.cyan=new R(new C(0,255,255,1))}static{this.lightgrey=new R(new C(211,211,211,1))}static{this.transparent=new R(new C(0,0,0,0))}}e.$8r=R,function(S){let f;(function(u){let $;(function(d){function p(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}d.formatRGB=p;function h(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}d.formatRGBA=h;function v(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}d.formatHSL=v;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}d.formatHSLA=y;function o(t){const l=t.toString(16);return l.length!==2?"0"+l:l}function g(t){return`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}`}d.formatHex=g;function c(t,l=!1){return l&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${o(t.rgba.r)}${o(t.rgba.g)}${o(t.rgba.b)}${o(Math.round(t.rgba.a*255))}`}d.formatHexA=c;function b(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}d.format=b;function k(t){const l=t.length;if(l===0||t.charCodeAt(0)!==35)return null;if(l===7){const s=16*w(t.charCodeAt(1))+w(t.charCodeAt(2)),n=16*w(t.charCodeAt(3))+w(t.charCodeAt(4)),i=16*w(t.charCodeAt(5))+w(t.charCodeAt(6));return new S(new C(s,n,i,1))}if(l===9){const s=16*w(t.charCodeAt(1))+w(t.charCodeAt(2)),n=16*w(t.charCodeAt(3))+w(t.charCodeAt(4)),i=16*w(t.charCodeAt(5))+w(t.charCodeAt(6)),a=16*w(t.charCodeAt(7))+w(t.charCodeAt(8));return new S(new C(s,n,i,a/255))}if(l===4){const s=w(t.charCodeAt(1)),n=w(t.charCodeAt(2)),i=w(t.charCodeAt(3));return new S(new C(16*s+s,16*n+n,16*i+i))}if(l===5){const s=w(t.charCodeAt(1)),n=w(t.charCodeAt(2)),i=w(t.charCodeAt(3)),a=w(t.charCodeAt(4));return new S(new C(16*s+s,16*n+n,16*i+i,(16*a+a)/255))}return null}d.parseHex=k;function w(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})($=u.CSS||(u.CSS={}))})(f=S.Format||(S.Format={}))}(R||(e.$8r=R={}))}),define(te[55],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=e.$Sg=e.$Rg=void 0;function E(R){return(S,f,u)=>{let $=null,d=null;if(typeof u.value=="function"?($="value",d=u.value):typeof u.get=="function"&&($="get",d=u.get),!d)throw new Error("not supported");u[$]=R(d,f)}}function C(R,S,f){let u=null,$=null;if(typeof f.value=="function"?(u="value",$=f.value,$.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(u="get",$=f.get),!$)throw new Error("not supported");const d=`$memoize$${S}`;f[u]=function(...p){return this.hasOwnProperty(d)||Object.defineProperty(this,d,{configurable:!1,enumerable:!1,writable:!1,value:$.apply(this,p)}),this[d]}}e.$Rg=C;function r(R,S,f){return E((u,$)=>{const d=`$debounce$${$}`,p=`$debounce$result$${$}`;return function(...h){this[p]||(this[p]=f?f():void 0),clearTimeout(this[d]),S&&(this[p]=S(this[p],...h),h=[this[p]]),this[d]=setTimeout(()=>{u.apply(this,h),this[p]=f?f():void 0},R)}})}e.$Sg=r;function M(R,S,f){return E((u,$)=>{const d=`$throttle$timer$${$}`,p=`$throttle$result$${$}`,h=`$throttle$lastRun$${$}`,v=`$throttle$pending$${$}`;return function(...y){if(this[p]||(this[p]=f?f():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),S&&(this[p]=S(this[p],...y)),this[v])return;const o=this[h]+R;o<=Date.now()?(this[h]=Date.now(),u.apply(this,[this[p]]),this[p]=f?f():void 0):(this[v]=!0,this[d]=setTimeout(()=>{this[v]=!1,this[h]=Date.now(),u.apply(this,[this[p]]),this[p]=f?f():void 0},o-Date.now()))}})}e.$Tg=M}),define(te[13],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class E{constructor(){this.b=[],this.a=function(l){setTimeout(()=>{throw l.stack?k.isErrorNoTelemetry(l)?new k(l.message+`

`+l.stack):new Error(l.message+`

`+l.stack):l},0)}}addListener(l){return this.b.push(l),()=>{this.d(l)}}c(l){this.b.forEach(s=>{s(l)})}d(l){this.b.splice(this.b.indexOf(l),1)}setUnexpectedErrorHandler(l){this.a=l}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(l){this.a(l),this.c(l)}onUnexpectedExternalError(l){this.a(l)}}e.$U=E,e.$V=new E;function C(t){e.$V.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=C;function r(t){if(!t||typeof t!="object")return!1;const l=t;return l.code==="EPIPE"&&l.syscall?.toUpperCase()==="WRITE"}e.$X=r;function M(t){u(t)||e.$V.onUnexpectedError(t)}e.$Y=M;function R(t){u(t)||e.$V.onUnexpectedExternalError(t)}e.$Z=R;function S(t){if(t instanceof Error){const{name:l,message:s}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:l,message:s,stack:n,noTelemetry:k.isErrorNoTelemetry(t)}}return t}e.$1=S;const f="Canceled";function u(t){return t instanceof $?!0:t instanceof Error&&t.name===f&&t.message===f}e.$2=u;class $ extends Error{constructor(){super(f),this.name=this.message}}e.$3=$;function d(){const t=new Error(f);return t.name=t.message,t}e.$4=d;function p(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$5=p;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$6=h;function v(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=v;function y(t){const l=new Error(`${t} has been disposed`);return l.name="DISPOSED",l}e.$8=y;function o(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$9=o;class g extends Error{constructor(l){super("NotImplemented"),l&&(this.message=l)}}e.$0=g;class c extends Error{constructor(l){super("NotSupported"),l&&(this.message=l)}}e.$$=c;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=b;class k extends Error{constructor(l){super(l),this.name="CodeExpectedError"}static fromError(l){if(l instanceof k)return l;const s=new k;return s.message=l.message,s.stack=l.stack,s}static isErrorNoTelemetry(l){return l.name==="CodeExpectedError"}}e.$ab=k;class w extends Error{constructor(l){super(l||"An unexpected bug occurred."),Object.setPrototypeOf(this,w.prototype)}}e.$bb=w}),define(te[24],ie([0,1,13]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.CompareResult=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.top=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=void 0;function C(z,B=0){return z[z.length-(1+B)]}e.$$e=C;function r(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$_e=r;function M(z,B,Y=(se,le)=>se===le){if(z===B)return!0;if(!z||!B||z.length!==B.length)return!1;for(let se=0,le=z.length;se<le;se++)if(!Y(z[se],B[se]))return!1;return!0}e.$af=M;function R(z,B){const Y=z.length-1;B<Y&&(z[B]=z[Y]),z.pop()}e.$bf=R;function S(z,B,Y){return f(z.length,se=>Y(z[se],B))}e.$cf=S;function f(z,B){let Y=0,se=z-1;for(;Y<=se;){const le=(Y+se)/2|0,ge=B(le);if(ge<0)Y=le+1;else if(ge>0)se=le-1;else return le}return-(Y+1)}e.$df=f;function u(z,B){let Y=0,se=z.length;if(se===0)return 0;for(;Y<se;){const le=Math.floor((Y+se)/2);B(z[le])?se=le:Y=le+1}return Y}e.$ef=u;function $(z,B,Y){if(z=z|0,z>=B.length)throw new TypeError("invalid index");const se=B[Math.floor(B.length*Math.random())],le=[],ge=[],Pe=[];for(const Re of B){const Ae=Y(Re,se);Ae<0?le.push(Re):Ae>0?ge.push(Re):Pe.push(Re)}return z<le.length?$(z,le,Y):z<le.length+Pe.length?Pe[0]:$(z-(le.length+Pe.length),ge,Y)}e.$ff=$;function d(z,B){const Y=[];let se;for(const le of z.slice(0).sort(B))!se||B(se[0],le)!==0?(se=[le],Y.push(se)):se.push(le);return Y}e.$gf=d;function p(z,B,Y){const se=[];function le(Re,Ae,Le){if(Ae===0&&Le.length===0)return;const He=se[se.length-1];He&&He.start+He.deleteCount===Re?(He.deleteCount+=Ae,He.toInsert.push(...Le)):se.push({start:Re,deleteCount:Ae,toInsert:Le})}let ge=0,Pe=0;for(;;){if(ge===z.length){le(ge,0,B.slice(Pe));break}if(Pe===B.length){le(ge,z.length-ge,[]);break}const Re=z[ge],Ae=B[Pe],Le=Y(Re,Ae);Le===0?(ge+=1,Pe+=1):Le<0?(le(ge,1,[]),ge+=1):Le>0&&(le(ge,0,[Ae]),Pe+=1)}return se}e.$hf=p;function h(z,B,Y){const se=p(z,B,Y),le=[],ge=[];for(const Pe of se)le.push(...z.slice(Pe.start,Pe.start+Pe.deleteCount)),ge.push(...Pe.toInsert);return{removed:le,added:ge}}e.$if=h;function v(z,B,Y){if(Y===0)return[];const se=z.slice(0,Y).sort(B);return o(z,B,se,Y,z.length),se}e.top=v;function y(z,B,Y,se,le){return Y===0?Promise.resolve([]):new Promise((ge,Pe)=>{(async()=>{const Re=z.length,Ae=z.slice(0,Y).sort(B);for(let Le=Y,He=Math.min(Y+se,Re);Le<Re;Le=He,He=Math.min(He+se,Re)){if(Le>Y&&await new Promise(me=>setTimeout(me)),le&&le.isCancellationRequested)throw new E.$3;o(z,B,Ae,Le,He)}return Ae})().then(ge,Pe)})}e.$kf=y;function o(z,B,Y,se,le){for(const ge=Y.length;se<le;se++){const Pe=z[se];if(B(Pe,Y[ge-1])<0){Y.pop();const Re=u(Y,Ae=>B(Pe,Ae)<0);Y.splice(Re,0,Pe)}}}function g(z){return z.filter(B=>!!B)}e.$lf=g;function c(z){let B=0;for(let Y=0;Y<z.length;Y++)z[Y]&&(z[B]=z[Y],B+=1);z.length=B}e.$mf=c;function b(z,B,Y){z.splice(Y,0,z.splice(B,1)[0])}e.$nf=b;function k(z){return!Array.isArray(z)||z.length===0}e.$of=k;function w(z){return Array.isArray(z)&&z.length>0}e.$pf=w;function t(z,B=Y=>Y){const Y=new Set;return z.filter(se=>{const le=B(se);return Y.has(le)?!1:(Y.add(le),!0)})}e.$qf=t;function l(z){const B=new Set;return Y=>{const se=z(Y);return B.has(se)?!1:(B.add(se),!0)}}e.$rf=l;function s(z,B){const Y=n(z,B);if(Y!==-1)return z[Y]}e.$sf=s;function n(z,B){for(let Y=z.length-1;Y>=0;Y--){const se=z[Y];if(B(se))return Y}return-1}e.$tf=n;function i(z,B){return z.length>0?z[0]:B}e.$uf=i;function a(z,B){return z.length>0?z[z.length-1]:B}e.$vf=a;function m(z,B,Y=(se,le)=>se===le){let se=0;for(let le=0,ge=Math.min(z.length,B.length);le<ge&&Y(z[le],B[le]);le++)se++;return se}e.$wf=m;function P(z){return[].concat(...z)}e.$xf=P;function I(z,B){let Y=typeof B=="number"?z:0;typeof B=="number"?Y=z:(Y=0,B=z);const se=[];if(Y<=B)for(let le=Y;le<B;le++)se.push(le);else for(let le=Y;le>B;le--)se.push(le);return se}e.$yf=I;function D(z,B,Y){return z.reduce((se,le)=>(se[B(le)]=Y?Y(le):le,se),Object.create(null))}e.$zf=D;function O(z,B){return z.push(B),()=>L(z,B)}e.$Af=O;function L(z,B){const Y=z.indexOf(B);if(Y>-1)return z.splice(Y,1),B}e.$Bf=L;function N(z,B,Y){const se=z.slice(0,B),le=z.slice(B);return se.concat(Y,le)}e.$Cf=N;function q(z,B){let Y;if(typeof B=="number"){let se=B;Y=()=>{const le=Math.sin(se++)*179426549;return le-Math.floor(le)}}else Y=Math.random;for(let se=z.length-1;se>0;se-=1){const le=Math.floor(Y()*(se+1)),ge=z[se];z[se]=z[le],z[le]=ge}}e.$Df=q;function re(z,B){const Y=z.indexOf(B);Y>-1&&(z.splice(Y,1),z.unshift(B))}e.$Ef=re;function ne(z,B){const Y=z.indexOf(B);Y>-1&&(z.splice(Y,1),z.push(B))}e.$Ff=ne;function ee(z,B){for(const Y of B)z.push(Y)}e.$Gf=ee;function ae(z,B){return Array.isArray(z)?z.map(B):B(z)}e.$Hf=ae;function ue(z){return Array.isArray(z)?z:[z]}e.$If=ue;function K(z){return z[Math.floor(Math.random()*z.length)]}e.$Jf=K;function X(z,B){for(const Y of z){const se=B(Y);if(se!==void 0)return se}}e.$Kf=X;function U(z,B,Y){const se=T(z,B),le=z.length,ge=Y.length;z.length=le+ge;for(let Pe=le-1;Pe>=se;Pe--)z[Pe+ge]=z[Pe];for(let Pe=0;Pe<ge;Pe++)z[Pe+se]=Y[Pe]}e.$Lf=U;function W(z,B,Y,se){const le=T(z,B),ge=z.splice(le,Y);return U(z,le,se),ge}e.$Mf=W;function T(z,B){return B<0?Math.max(B+z.length,0):Math.min(B,z.length)}var J;(function(z){function B(le){return le<0}z.isLessThan=B;function Y(le){return le>0}z.isGreaterThan=Y;function se(le){return le===0}z.isNeitherLessOrGreaterThan=se,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(J||(e.CompareResult=J={}));function Z(z,B){return(Y,se)=>B(z(Y),z(se))}e.$Nf=Z;function ce(...z){return(B,Y)=>{for(const se of z){const le=se(B,Y);if(!J.isNeitherLessOrGreaterThan(le))return le}return J.neitherLessOrGreaterThan}}e.$Of=ce;const oe=(z,B)=>z-B;e.$Pf=oe;function j(z,B){if(z.length===0)return;let Y=z[0];for(let se=1;se<z.length;se++){const le=z[se];B(le,Y)>0&&(Y=le)}return Y}e.$Qf=j;function A(z,B){if(z.length===0)return;let Y=z[0];for(let se=1;se<z.length;se++){const le=z[se];B(le,Y)>=0&&(Y=le)}return Y}e.$Rf=A;function F(z,B){return j(z,(Y,se)=>-B(Y,se))}e.$Sf=F;class H{constructor(B){this.f=B,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(B){let Y=this.c;for(;Y<this.f.length&&B(this.f[Y]);)Y++;const se=Y===this.c?null:this.f.slice(this.c,Y);return this.c=Y,se}takeFromEndWhile(B){let Y=this.d;for(;Y>=0&&B(this.f[Y]);)Y--;const se=Y===this.d?null:this.f.slice(Y+1,this.d+1);return this.d=Y,se}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const B=this.f[this.c];return this.c++,B}removeLast(){const B=this.f[this.d];return this.d--,B}takeCount(B){const Y=this.f.slice(this.c,this.c+B);return this.c+=B,Y}}e.$Tf=H;class V{static{this.empty=new V(B=>{})}constructor(B){this.iterate=B}forEach(B){this.iterate(Y=>(B(Y),!0))}toArray(){const B=[];return this.iterate(Y=>(B.push(Y),!0)),B}filter(B){return new V(Y=>this.iterate(se=>B(se)?Y(se):!0))}map(B){return new V(Y=>this.iterate(se=>Y(B(se))))}some(B){let Y=!1;return this.iterate(se=>(Y=B(se),!Y)),Y}findFirst(B){let Y;return this.iterate(se=>B(se)?(Y=se,!1):!0),Y}findLast(B){let Y;return this.iterate(se=>(B(se)&&(Y=se),!0)),Y}findLastMaxBy(B){let Y,se=!0;return this.iterate(le=>((se||J.isGreaterThan(B(le,Y)))&&(se=!1,Y=le),!0)),Y}}e.$Uf=V}),define(te[135],ie([0,1,13]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.ok=void 0;function C(f,u){if(!f)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=C;function r(f,u="Unreachable"){throw new Error(u)}e.$nc=r;function M(f){if(!f)throw new E.$bb("Assertion Failed")}e.$oc=M;function R(f){if(!f()){debugger;f(),(0,E.$Y)(new E.$bb("Assertion Failed"))}}e.$pc=R;function S(f,u){let $=0;for(;$<f.length-1;){const d=f[$],p=f[$+1];if(!u(d,p))return!1;$++}return!0}e.$qc=S}),define(te[49],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function E(C){const r=this;let M=!1,R;return function(){return M||(M=!0,R=C.apply(r,arguments)),R}}e.$cb=E}),define(te[68],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(C){function r(k){return k&&typeof k=="object"&&typeof k[Symbol.iterator]=="function"}C.is=r;const M=Object.freeze([]);function R(){return M}C.empty=R;function*S(k){yield k}C.single=S;function f(k){return r(k)?k:S(k)}C.wrap=f;function u(k){return k||M}C.from=u;function $(k){return!k||k[Symbol.iterator]().next().done===!0}C.isEmpty=$;function d(k){return k[Symbol.iterator]().next().value}C.first=d;function p(k,w){for(const t of k)if(w(t))return!0;return!1}C.some=p;function h(k,w){for(const t of k)if(w(t))return t}C.find=h;function*v(k,w){for(const t of k)w(t)&&(yield t)}C.filter=v;function*y(k,w){let t=0;for(const l of k)yield w(l,t++)}C.map=y;function*o(...k){for(const w of k)for(const t of w)yield t}C.concat=o;function g(k,w,t){let l=t;for(const s of k)l=w(l,s);return l}C.reduce=g;function*c(k,w,t=k.length){for(w<0&&(w+=k.length),t<0?t+=k.length:t>k.length&&(t=k.length);w<t;w++)yield k[w]}C.slice=c;function b(k,w=Number.POSITIVE_INFINITY){const t=[];if(w===0)return[t,k];const l=k[Symbol.iterator]();for(let s=0;s<w;s++){const n=l.next();if(n.done)return[t,C.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return l}}]}C.consume=b})(E||(e.Iterable=E={}))}),define(te[45],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var r;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(r||(e.ParseErrorCode=r={}));var M;(function(t){t.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function R(t,l=!1){let s=0;const n=t.length;let i="",a=0,m=16,P=0;function I(ne){let ee=0,ae=0;for(;ee<ne;){const ue=t.charCodeAt(s);if(ue>=48&&ue<=57)ae=ae*16+ue-48;else if(ue>=65&&ue<=70)ae=ae*16+ue-65+10;else if(ue>=97&&ue<=102)ae=ae*16+ue-97+10;else break;s++,ee++}return ee<ne&&(ae=-1),ae}function D(ne){s=ne,i="",a=0,m=16,P=0}function O(){const ne=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&u(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&u(t.charCodeAt(s)))for(s++;s<t.length&&u(t.charCodeAt(s));)s++;else return P=3,t.substring(ne,s);let ee=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&u(t.charCodeAt(s))){for(s++;s<t.length&&u(t.charCodeAt(s));)s++;ee=s}else P=3;return t.substring(ne,ee)}function L(){let ne="",ee=s;for(;;){if(s>=n){ne+=t.substring(ee,s),P=2;break}const ae=t.charCodeAt(s);if(ae===34){ne+=t.substring(ee,s),s++;break}if(ae===92){if(ne+=t.substring(ee,s),s++,s>=n){P=2;break}switch(t.charCodeAt(s++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const K=I(4);K>=0?ne+=String.fromCharCode(K):P=4;break}default:P=5}ee=s;continue}if(ae>=0&&ae<=31)if(f(ae)){ne+=t.substring(ee,s),P=2;break}else P=6;s++}return ne}function N(){if(i="",P=0,a=s,s>=n)return a=n,m=17;let ne=t.charCodeAt(s);if(S(ne)){do s++,i+=String.fromCharCode(ne),ne=t.charCodeAt(s);while(S(ne));return m=15}if(f(ne))return s++,i+=String.fromCharCode(ne),ne===13&&t.charCodeAt(s)===10&&(s++,i+=`
`),m=14;switch(ne){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,i=L(),m=10;case 47:{const ee=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!f(t.charCodeAt(s));)s++;return i=t.substring(ee,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const ae=n-1;let ue=!1;for(;s<ae;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ue=!0;break}s++}return ue||(s++,P=1),i=t.substring(ee,s),m=13}return i+=String.fromCharCode(ne),s++,m=16}case 45:if(i+=String.fromCharCode(ne),s++,s===n||!u(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=O(),m=11;default:for(;s<n&&q(ne);)s++,ne=t.charCodeAt(s);if(a!==s){switch(i=t.substring(a,s),i){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return i+=String.fromCharCode(ne),s++,m=16}}function q(ne){if(S(ne)||f(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let ne;do ne=N();while(ne>=12&&ne<=15);return ne}return{setPosition:D,getPosition:()=>s,scan:l?re:N,getToken:()=>m,getTokenValue:()=>i,getTokenOffset:()=>a,getTokenLength:()=>s-a,getTokenError:()=>P}}e.$tm=R;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function u(t){return t>=48&&t<=57}var $;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})($||($={}));function d(t,l){const s=[],n=new Object;let i;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function P(I,D,O,L){a.value=I,a.offset=D,a.length=O,a.type=L,a.colonOffset=void 0,i=a}try{b(t,{onObjectBegin:(I,D)=>{if(l<=I)throw n;i=void 0,m=l>I,s.push("")},onObjectProperty:(I,D,O)=>{if(l<D||(P(I,D,O,"property"),s[s.length-1]=I,l<=D+O))throw n},onObjectEnd:(I,D)=>{if(l<=I)throw n;i=void 0,s.pop()},onArrayBegin:(I,D)=>{if(l<=I)throw n;i=void 0,s.push(0)},onArrayEnd:(I,D)=>{if(l<=I)throw n;i=void 0,s.pop()},onLiteralValue:(I,D,O)=>{if(l<D||(P(I,D,O,w(I)),l<=D+O))throw n},onSeparator:(I,D,O)=>{if(l<=D)throw n;if(I===":"&&i&&i.type==="property")i.colonOffset=D,m=!1,i=void 0;else if(I===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(m=!0,s[s.length-1]=""),i=void 0}}})}catch(I){if(I!==n)throw I}return{path:s,previousNode:i,isAtPropertyKey:m,matches:I=>{let D=0;for(let O=0;D<I.length&&O<s.length;O++)if(I[D]===s[O]||I[D]==="*")D++;else if(I[D]!=="**")return!1;return D===I.length}}}e.$um=d;function p(t,l=[],s=M.DEFAULT){let n=null,i=[];const a=[];function m(I){Array.isArray(i)?i.push(I):n!==null&&(i[n]=I)}return b(t,{onObjectBegin:()=>{const I={};m(I),a.push(i),i=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{i=a.pop()},onArrayBegin:()=>{const I=[];m(I),a.push(i),i=I,n=null},onArrayEnd:()=>{i=a.pop()},onLiteralValue:m,onError:(I,D,O)=>{l.push({error:I,offset:D,length:O})}},s),i[0]}e.$vm=p;function h(t,l=[],s=M.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function a(I){return n.children.push(I),I}b(t,{onObjectBegin:I=>{n=a({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,D,O)=>{n=a({type:"property",offset:D,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:D,length:O,parent:n})},onObjectEnd:(I,D)=>{n.length=I+D-n.offset,n=n.parent,i(I+D)},onArrayBegin:(I,D)=>{n=a({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,D)=>{n.length=I+D-n.offset,n=n.parent,i(I+D)},onLiteralValue:(I,D,O)=>{a({type:w(I),offset:D,length:O,parent:n,value:I}),i(D+O)},onSeparator:(I,D,O)=>{n.type==="property"&&(I===":"?n.colonOffset=D:I===","&&i(D))},onError:(I,D,O)=>{l.push({error:I,offset:D,length:O})}},s);const P=n.children[0];return P&&delete P.parent,P}e.$wm=h;function v(t,l){if(!t)return;let s=t;for(const n of l)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let i=!1;for(const a of s.children)if(Array.isArray(a.children)&&a.children[0].value===n){s=a.children[1],i=!0;break}if(!i)return}else{const i=n;if(s.type!=="array"||i<0||!Array.isArray(s.children)||i>=s.children.length)return;s=s.children[i]}return s}e.$xm=v;function y(t){if(!t.parent||!t.parent.children)return[];const l=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;l.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&l.push(s)}return l}e.$ym=y;function o(t){switch(t.type){case"array":return t.children.map(o);case"object":{const l=Object.create(null);for(const s of t.children){const n=s.children[1];n&&(l[s.children[0].value]=o(n))}return l}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$zm=o;function g(t,l,s=!1){return l>=t.offset&&l<t.offset+t.length||s&&l===t.offset+t.length}e.$Am=g;function c(t,l,s=!1){if(g(t,l,s)){const n=t.children;if(Array.isArray(n))for(let i=0;i<n.length&&n[i].offset<=l;i++){const a=c(n[i],l,s);if(a)return a}return t}}e.$Bm=c;function b(t,l,s=M.DEFAULT){const n=R(t,!1);function i(Z){return Z?()=>Z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function a(Z){return Z?ce=>Z(ce,n.getTokenOffset(),n.getTokenLength()):()=>!0}const m=i(l.onObjectBegin),P=a(l.onObjectProperty),I=i(l.onObjectEnd),D=i(l.onArrayBegin),O=i(l.onArrayEnd),L=a(l.onLiteralValue),N=a(l.onSeparator),q=i(l.onComment),re=a(l.onError),ne=s&&s.disallowComments,ee=s&&s.allowTrailingComma;function ae(){for(;;){const Z=n.scan();switch(n.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:ne||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(Z){case 12:case 13:ne?ue(10):q();break;case 16:ue(1);break;case 15:case 14:break;default:return Z}}}function ue(Z,ce=[],oe=[]){if(re(Z),ce.length+oe.length>0){let j=n.getToken();for(;j!==17;){if(ce.indexOf(j)!==-1){ae();break}else if(oe.indexOf(j)!==-1)break;j=ae()}}}function K(Z){const ce=n.getTokenValue();return Z?L(ce):P(ce),ae(),!0}function X(){switch(n.getToken()){case 11:{let Z=0;try{Z=JSON.parse(n.getTokenValue()),typeof Z!="number"&&(ue(2),Z=0)}catch{ue(2)}L(Z);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return ae(),!0}function U(){return n.getToken()!==10?(ue(3,[],[2,5]),!1):(K(!1),n.getToken()===6?(N(":"),ae(),J()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function W(){m(),ae();let Z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Z||ue(4,[],[]),N(","),ae(),n.getToken()===2&&ee)break}else Z&&ue(6,[],[]);U()||ue(4,[],[2,5]),Z=!0}return I(),n.getToken()!==2?ue(7,[2],[]):ae(),!0}function T(){D(),ae();let Z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Z||ue(4,[],[]),N(","),ae(),n.getToken()===4&&ee)break}else Z&&ue(6,[],[]);J()||ue(4,[],[4,5]),Z=!0}return O(),n.getToken()!==4?ue(8,[4],[]):ae(),!0}function J(){switch(n.getToken()){case 3:return T();case 1:return W();case 10:return K(!0);default:return X()}}return ae(),n.getToken()===17?s.allowEmptyContent?!0:(ue(4,[],[]),!1):J()?(n.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$Cm=b;function k(t,l){const s=R(t),n=[];let i,a=0,m;do switch(m=s.getPosition(),i=s.scan(),i){case 12:case 13:case 17:a!==m&&n.push(t.substring(a,m)),l!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,l)),a=s.getPosition();break}while(i!==17);return n.join("")}e.$Dm=k;function w(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Em=w}),define(te[136],ie([0,1,45]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=e.$3R=e.$2R=e.$1R=void 0;function C(u,$,d){let p,h,v,y,o;if($){for(y=$.offset,o=y+$.length,v=y;v>0&&!f(u,v-1);)v--;let m=o;for(;m<u.length&&!f(u,m);)m++;h=u.substring(v,m),p=R(h,d)}else h=u,p=0,v=0,y=0,o=u.length;const g=S(d,u);let c=!1,b=0,k;d.insertSpaces?k=M(" ",d.tabSize||4):k="	";const w=(0,E.$tm)(h,!1);let t=!1;function l(){return g+M(k,p+b)}function s(){let m=w.scan();for(c=!1;m===15||m===14;)c=c||m===14,m=w.scan();return t=m===16||w.getTokenError()!==0,m}const n=[];function i(m,P,I){!t&&P<o&&I>y&&u.substring(P,I)!==m&&n.push({offset:P,length:I-P,content:m})}let a=s();if(a!==17){const m=w.getTokenOffset()+v,P=M(k,p);i(P,v,m)}for(;a!==17;){let m=w.getTokenOffset()+w.getTokenLength()+v,P=s(),I="";for(;!c&&(P===12||P===13);){const O=w.getTokenOffset()+v;i(" ",m,O),m=w.getTokenOffset()+w.getTokenLength()+v,I=P===12?l():"",P=s()}if(P===2)a!==1&&(b--,I=l());else if(P===4)a!==3&&(b--,I=l());else{switch(a){case 3:case 1:b++,I=l();break;case 5:case 12:I=l();break;case 13:c?I=l():I=" ";break;case 6:I=" ";break;case 10:if(P===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?I=" ":P!==5&&P!==17&&(t=!0);break;case 16:t=!0;break}c&&(P===12||P===13)&&(I=l())}const D=w.getTokenOffset()+v;i(I,m,D),a=P}return n}e.$1R=C;function r(u,$){const d=JSON.stringify(u,void 0,$.insertSpaces?$.tabSize||4:"	");return $.eol!==void 0?d.replace(/\r\n|\r|\n/g,$.eol):d}e.$2R=r;function M(u,$){let d="";for(let p=0;p<$;p++)d+=u;return d}function R(u,$){let d=0,p=0;const h=$.tabSize||4;for(;d<u.length;){const v=u.charAt(d);if(v===" ")p++;else if(v==="	")p+=h;else break;d++}return Math.floor(p/h)}function S(u,$){for(let d=0;d<$.length;d++){const p=$.charAt(d);if(p==="\r")return d+1<$.length&&$.charAt(d+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return u&&u.eol||`
`}e.$3R=S;function f(u,$){return`\r
`.indexOf(u.charAt($))!==-1}e.$4R=f}),define(te[137],ie([0,1,45,136]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9R=e.$8R=e.$7R=e.$6R=e.$5R=void 0;function r(u,$,d){return M(u,$,void 0,d)}e.$5R=r;function M(u,$,d,p,h){const v=$.slice(),y=[],o=(0,E.$wm)(u,y);let g,c;for(;v.length>0&&(c=v.pop(),g=(0,E.$xm)(o,v),g===void 0&&d!==void 0);)typeof c=="string"?d={[c]:d}:d=[d];if(g)if(g.type==="object"&&typeof c=="string"&&Array.isArray(g.children)){const b=(0,E.$xm)(g,[c]);if(b!==void 0)if(d===void 0){if(!b.parent)throw new Error("Malformed AST");const k=g.children.indexOf(b.parent);let w,t=b.parent.offset+b.parent.length;if(k>0){const l=g.children[k-1];w=l.offset+l.length}else w=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return R(u,{offset:w,length:t-w,content:""},p)}else return R(u,{offset:b.offset,length:b.length,content:JSON.stringify(d)},p);else{if(d===void 0)return[];const k=`${JSON.stringify(c)}: ${JSON.stringify(d)}`,w=h?h(g.children.map(l=>l.children[0].value)):g.children.length;let t;if(w>0){const l=g.children[w-1];t={offset:l.offset+l.length,length:0,content:","+k}}else g.children.length===0?t={offset:g.offset+1,length:0,content:k}:t={offset:g.offset+1,length:0,content:k+","};return R(u,t,p)}}else if(g.type==="array"&&typeof c=="number"&&Array.isArray(g.children))if(d!==void 0){const b=`${JSON.stringify(d)}`;let k;if(g.children.length===0||c===0)k={offset:g.offset+1,length:0,content:g.children.length===0?b:b+","};else{const w=c===-1||c>g.children.length?g.children.length:c,t=g.children[w-1];k={offset:t.offset+t.length,length:0,content:","+b}}return R(u,k,p)}else{const b=c,k=g.children[b];let w;if(g.children.length===1)w={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===b){const t=g.children[b-1],l=t.offset+t.length,s=g.offset+g.length;w={offset:l,length:s-2-l,content:""}}else w={offset:k.offset,length:g.children[b+1].offset-k.offset,content:""};return R(u,w,p)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${g.type}`);else{if(d===void 0)throw new Error("Can not delete in empty document");return R(u,{offset:o?o.offset:0,length:o?o.length:0,content:JSON.stringify(d)},p)}}e.$6R=M;function R(u,$,d){let p=S(u,$),h=$.offset,v=$.offset+$.content.length;if($.length===0||$.content.length===0){for(;h>0&&!(0,C.$4R)(p,h-1);)h--;for(;v<p.length&&!(0,C.$4R)(p,v);)v++}const y=(0,C.$1R)(p,{offset:h,length:v-h},d);for(let g=y.length-1;g>=0;g--){const c=y[g];p=S(p,c),h=Math.min(h,c.offset),v=Math.max(v,c.offset+c.length),v+=c.content.length-c.length}const o=u.length-(p.length-v)-h;return[{offset:h,length:o,content:p.substring(h,v)}]}e.$7R=R;function S(u,$){return u.substring(0,$.offset)+$.content+u.substring($.offset+$.length)}e.$8R=S;function f(u,$){const d=$.slice(0).sort((h,v)=>{const y=h.offset-v.offset;return y===0?h.length-v.length:y});let p=u.length;for(let h=d.length-1;h>=0;h--){const v=d[h];if(v.offset+v.length<=p)u=S(u,v);else throw new Error("Overlapping edit");p=v.offset}return u}e.$9R=f}),define(te[85],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class E{constructor(r){this.d=r,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(r){this.c=r}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=E}),define(te[2],ie([0,1,49,68]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const r=!1;let M=null;function R(a){M=a}if(e.$db=R,r){const a="__is_disposable_tracked__";R(new class{trackDisposable(m){const P=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[a]||console.log(P)},3e3)}setParent(m,P){if(m&&m!==c.None)try{m[a]=!0}catch{}}markAsDisposed(m){if(m&&m!==c.None)try{m[a]=!0}catch{}}markAsSingleton(m){}})}function S(a){return M?.trackDisposable(a),a}function f(a){M?.markAsDisposed(a)}function u(a,m){M?.setParent(a,m)}function $(a,m){if(M)for(const P of a)M.setParent(P,m)}function d(a){return M?.markAsSingleton(a),a}e.$eb=d;function p(a){return typeof a.dispose=="function"&&a.dispose.length===0}e.$fb=p;function h(a){if(C.Iterable.is(a)){const m=[];for(const P of a)if(P)try{P.dispose()}catch(I){m.push(I)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(a)?[]:a}else if(a)return a.dispose(),a}e.$gb=h;function v(a){for(const m of a)p(m)&&m.dispose();return[]}e.$hb=v;function y(...a){const m=o(()=>h(a));return $(a,m),m}e.$ib=y;function o(a){const m=S({dispose:(0,E.$cb)(()=>{f(m),a()})});return m}e.$jb=o;class g{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(f(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return u(m,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(m),m}}e.$kb=g;class c{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new g,S(this),u(this.q,this)}dispose(){f(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}e.$lb=c;class b{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&u(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,f(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&u(m,null),m}}e.$mb=b;class k{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=k;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(m){let P=m;return this.unset=()=>P=void 0,this.isset=()=>P!==void 0,this.dispose=()=>{P&&(P(),P=void 0,f(this))},this}}e.$ob=w;class t{constructor(){this.a=new Map}acquire(m,...P){let I=this.a.get(m);I||(I={counter:0,object:this.b(m,...P)},this.a.set(m,I));const{object:D}=I,O=(0,E.$cb)(()=>{--I.counter===0&&(this.c(m,I.object),this.a.delete(m))});return I.counter++,{object:D,dispose:O}}}e.$pb=t;class l{constructor(m){this.a=m}async acquire(m,...P){const I=this.a.acquire(m,...P);try{return{object:await I.object,dispose:()=>I.dispose()}}catch(D){throw I.dispose(),D}}}e.$qb=l;class s{constructor(m){this.object=m}dispose(){}}e.$rb=s;function n(a){const m=new g;try{a(m)}finally{m.dispose()}}e.$sb=n;class i{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){f(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get(m){return this.a.get(m)}set(m,P,I=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),I||this.a.get(m)?.dispose(),this.a.set(m,P)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=i}),define(te[101],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lc=void 0;class E{static{this.Undefined=new E(void 0)}constructor(M){this.element=M,this.next=E.Undefined,this.prev=E.Undefined}}class C{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let M=this.a;for(;M!==E.Undefined;){const R=M.next;M.prev=E.Undefined,M.next=E.Undefined,M=R}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,R){const S=new E(M);if(this.a===E.Undefined)this.a=S,this.b=S;else if(R){const u=this.b;this.b=S,S.prev=u,u.next=S}else{const u=this.a;this.a=S,S.next=u,u.prev=S}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(S))}}shift(){if(this.a!==E.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==E.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==E.Undefined&&M.next!==E.Undefined){const R=M.prev;R.next=M.next,M.next.prev=R}else M.prev===E.Undefined&&M.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):M.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):M.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==E.Undefined;)yield M.element,M=M.next}}e.$lc=C}),define(te[35],ie([0,1]),function(G,e){"use strict";var E,C,r;Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.Touch=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;function M(y,o,g){let c=y.get(o);return c===void 0&&(c=g,y.set(o,c)),c}e.$ii=M;function R(y){const o=[];return y.forEach((g,c)=>{o.push(`${c} => ${g}`)}),`Map(${y.size}) {${o.join(", ")}}`}e.$ji=R;function S(y){const o=[];return y.forEach(g=>{o.push(g)}),`Set(${y.size}) {${o.join(", ")}}`}e.$ki=S;class f{constructor(o,g){this.uri=o,this.value=g}}class u{static{this.a=o=>o.toString()}constructor(o,g){this[E]="ResourceMap",o instanceof u?(this.b=new Map(o.b),this.c=g??u.a):(this.b=new Map,this.c=o??u.a)}set(o,g){return this.b.set(this.c(o),new f(o,g)),this}get(o){return this.b.get(this.c(o))?.value}has(o){return this.b.has(this.c(o))}get size(){return this.b.size}clear(){this.b.clear()}delete(o){return this.b.delete(this.c(o))}forEach(o,g){typeof g<"u"&&(o=o.bind(g));for(const[c,b]of this.b)o(b.value,b.uri,this)}*values(){for(const o of this.b.values())yield o.value}*keys(){for(const o of this.b.values())yield o.uri}*entries(){for(const o of this.b.values())yield[o.uri,o.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,o]of this.b)yield[o.uri,o.value]}}e.$li=u;class ${constructor(o,g){this[C]="ResourceSet",!o||typeof o=="function"?this.a=new u(o):(this.a=new u(g),o.forEach(this.add,this))}get size(){return this.a.size}add(o){return this.a.set(o,o),this}clear(){this.a.clear()}delete(o){return this.a.delete(o)}forEach(o,g){this.a.forEach((c,b)=>o.call(g,b,b,this))}has(o){return this.a.has(o)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$mi=$;var d;(function(y){y[y.None=0]="None",y[y.AsOld=1]="AsOld",y[y.AsNew=2]="AsNew"})(d||(e.Touch=d={}));class p{constructor(){this[r]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(o){return this.a.has(o)}get(o,g=0){const c=this.a.get(o);if(c)return g!==0&&this.j(c,g),c.value}set(o,g,c=0){let b=this.a.get(o);if(b)b.value=g,c!==0&&this.j(b,c);else{switch(b={key:o,value:g,next:void 0,previous:void 0},c){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(o,b),this.d++}return this}delete(o){return!!this.remove(o)}remove(o){const g=this.a.get(o);if(g)return this.a.delete(o),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const o=this.b;return this.a.delete(o.key),this.i(o),this.d--,o.value}forEach(o,g){const c=this.e;let b=this.b;for(;b;){if(g?o.bind(g)(b.value,b.key,this):o(b.value,b.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const o=this,g=this.e;let c=this.b;const b={[Symbol.iterator](){return b},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const k={value:c.key,done:!1};return c=c.next,k}else return{value:void 0,done:!0}}};return b}values(){const o=this,g=this.e;let c=this.b;const b={[Symbol.iterator](){return b},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const k={value:c.value,done:!1};return c=c.next,k}else return{value:void 0,done:!0}}};return b}entries(){const o=this,g=this.e;let c=this.b;const b={[Symbol.iterator](){return b},next(){if(o.e!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const k={value:[c.key,c.value],done:!1};return c=c.next,k}else return{value:void 0,done:!0}}};return b}[(r=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(o){if(o>=this.size)return;if(o===0){this.clear();return}let g=this.b,c=this.size;for(;g&&c>o;)this.a.delete(g.key),g=g.next,c--;this.b=g,this.d=c,g&&(g.previous=void 0),this.e++}g(o){if(!this.b&&!this.c)this.c=o;else if(this.b)o.next=this.b,this.b.previous=o;else throw new Error("Invalid list");this.b=o,this.e++}h(o){if(!this.b&&!this.c)this.b=o;else if(this.c)o.previous=this.c,this.c.next=o;else throw new Error("Invalid list");this.c=o,this.e++}i(o){if(o===this.b&&o===this.c)this.b=void 0,this.c=void 0;else if(o===this.b){if(!o.next)throw new Error("Invalid list");o.next.previous=void 0,this.b=o.next}else if(o===this.c){if(!o.previous)throw new Error("Invalid list");o.previous.next=void 0,this.c=o.previous}else{const g=o.next,c=o.previous;if(!g||!c)throw new Error("Invalid list");g.previous=c,c.next=g}o.next=void 0,o.previous=void 0,this.e++}j(o,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(o===this.b)return;const c=o.next,b=o.previous;o===this.c?(b.next=void 0,this.c=b):(c.previous=b,b.next=c),o.previous=void 0,o.next=this.b,this.b.previous=o,this.b=o,this.e++}else if(g===2){if(o===this.c)return;const c=o.next,b=o.previous;o===this.b?(c.previous=void 0,this.b=c):(c.previous=b,b.next=c),o.next=void 0,o.previous=this.c,this.c.next=o,this.c=o,this.e++}}}toJSON(){const o=[];return this.forEach((g,c)=>{o.push([c,g])}),o}fromJSON(o){this.clear();for(const[g,c]of o)this.set(g,c)}}e.$ni=p;class h extends p{constructor(o,g=1){super(),this.k=o,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(o){this.k=o,this.m()}get ratio(){return this.l}set ratio(o){this.l=Math.min(Math.max(0,o),1),this.m()}get(o,g=2){return super.get(o,g)}peek(o){return super.get(o,0)}set(o,g){return super.set(o,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$oi=h;class v{constructor(){this.a=new Map}add(o){return this.a.set(o,(this.a.get(o)||0)+1),this}delete(o){let g=this.a.get(o)||0;return g===0?!1:(g--,g===0?this.a.delete(o):this.a.set(o,g),!0)}has(o){return this.a.has(o)}}e.$pi=v}),define(te[86],ie([0,1,35]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=void 0;const C=new E.$oi(1e4);function r(u){return f(u,"NFC",C)}e.$5k=r;const M=new E.$oi(1e4);function R(u){return f(u,"NFD",M)}e.$6k=R;const S=/[^\u0000-\u0080]/;function f(u,$,d){if(!u)return u;const p=d.get(u);if(p)return p;let h;return S.test(u)?h=u.normalize($):h=u,d.set(u,h),h}e.$7k=function(){const u=/[\u0300-\u036f]/g;return function($){return R($).replace(u,"")}}()}),define(te[138],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=e.rot=e.$rl=void 0;function E(S,f,u){return Math.min(Math.max(S,f),u)}e.$rl=E;function C(S,f){return(f+S%f)%f}e.rot=C;class r{constructor(){this.a=0}getNext(){return this.a++}}e.$tl=r;class M{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ul=M;class R{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const u=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=u,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$vl=R}),function(){function G(r){const M=[];typeof r=="number"&&M.push("code/timeOrigin",r);function R(f){M.push(f,Date.now())}function S(){const f=[];for(let u=0;u<M.length;u+=2)f.push({name:M[u],startTime:M[u+1]});return f}return{mark:R,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(r){performance.mark(r)},getMarks(){let r=performance.timeOrigin;typeof r!="number"&&(r=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(r)}];for(const R of performance.getEntriesByType("mark"))M.push({name:R.name,startTime:Math.round(r+R.startTime)});return M}};if(typeof process=="object"){const r=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(r)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function E(r){return r.MonacoPerformanceMarks||(r.MonacoPerformanceMarks=e()),r.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=E(C))}(),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var C in E)(typeof exports=="object"?exports:G)[C]=E[C]}}(typeof self<"u"?self:this,function(){return function(G){var e={};function E(C){if(e[C])return e[C].exports;var r=e[C]={i:C,l:!1,exports:{}};return G[C].call(r.exports,r,r.exports,E),r.l=!0,r.exports}return E.m=G,E.c=e,E.d=function(C,r,M){E.o(C,r)||Object.defineProperty(C,r,{enumerable:!0,get:M})},E.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},E.t=function(C,r){if(1&r&&(C=E(C)),8&r||4&r&&typeof C=="object"&&C&&C.__esModule)return C;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:C}),2&r&&typeof C!="string")for(var R in C)E.d(M,R,function(S){return C[S]}.bind(null,R));return M},E.n=function(C){var r=C&&C.__esModule?function(){return C.default}:function(){return C};return E.d(r,"a",r),r},E.o=function(C,r){return Object.prototype.hasOwnProperty.call(C,r)},E.p="",E(E.s=0)}([function(G,e,E){(function(C){var r;e=G.exports=oe,r=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],f=e.src=[],u=0,$=u++;f[$]="0|[1-9]\\d*";var d=u++;f[d]="[0-9]+";var p=u++;f[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=u++;f[h]="("+f[$]+")\\.("+f[$]+")\\.("+f[$]+")";var v=u++;f[v]="("+f[d]+")\\.("+f[d]+")\\.("+f[d]+")";var y=u++;f[y]="(?:"+f[$]+"|"+f[p]+")";var o=u++;f[o]="(?:"+f[d]+"|"+f[p]+")";var g=u++;f[g]="(?:-("+f[y]+"(?:\\."+f[y]+")*))";var c=u++;f[c]="(?:-?("+f[o]+"(?:\\."+f[o]+")*))";var b=u++;f[b]="[0-9A-Za-z-]+";var k=u++;f[k]="(?:\\+("+f[b]+"(?:\\."+f[b]+")*))";var w=u++,t="v?"+f[h]+f[g]+"?"+f[k]+"?";f[w]="^"+t+"$";var l="[v=\\s]*"+f[v]+f[c]+"?"+f[k]+"?",s=u++;f[s]="^"+l+"$";var n=u++;f[n]="((?:<|>)?=?)";var i=u++;f[i]=f[d]+"|x|X|\\*";var a=u++;f[a]=f[$]+"|x|X|\\*";var m=u++;f[m]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[g]+")?"+f[k]+"?)?)?";var P=u++;f[P]="[v=\\s]*("+f[i]+")(?:\\.("+f[i]+")(?:\\.("+f[i]+")(?:"+f[c]+")?"+f[k]+"?)?)?";var I=u++;f[I]="^"+f[n]+"\\s*"+f[m]+"$";var D=u++;f[D]="^"+f[n]+"\\s*"+f[P]+"$";var O=u++;f[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=u++;f[L]="(?:~>?)";var N=u++;f[N]="(\\s*)"+f[L]+"\\s+",S[N]=new RegExp(f[N],"g");var q=u++;f[q]="^"+f[L]+f[m]+"$";var re=u++;f[re]="^"+f[L]+f[P]+"$";var ne=u++;f[ne]="(?:\\^)";var ee=u++;f[ee]="(\\s*)"+f[ne]+"\\s+",S[ee]=new RegExp(f[ee],"g");var ae=u++;f[ae]="^"+f[ne]+f[m]+"$";var ue=u++;f[ue]="^"+f[ne]+f[P]+"$";var K=u++;f[K]="^"+f[n]+"\\s*("+l+")$|^$";var X=u++;f[X]="^"+f[n]+"\\s*("+t+")$|^$";var U=u++;f[U]="(\\s*)"+f[n]+"\\s*("+l+"|"+f[m]+")",S[U]=new RegExp(f[U],"g");var W=u++;f[W]="^\\s*("+f[m]+")\\s+-\\s+("+f[m]+")\\s*$";var T=u++;f[T]="^\\s*("+f[P]+")\\s+-\\s+("+f[P]+")\\s*$";var J=u++;f[J]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)r(Z,f[Z]),S[Z]||(S[Z]=new RegExp(f[Z]));function ce(_,he){if(_ instanceof oe)return _;if(typeof _!="string"||_.length>M||!(he?S[s]:S[w]).test(_))return null;try{return new oe(_,he)}catch{return null}}function oe(_,he){if(_ instanceof oe){if(_.loose===he)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof oe))return new oe(_,he);r("SemVer",_,he),this.loose=he;var de=_.trim().match(he?S[s]:S[w]);if(!de)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Ce=+Se;if(Ce>=0&&Ce<R)return Ce}return Se}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=ce,e.valid=function(_,he){var de=ce(_,he);return de?de.version:null},e.clean=function(_,he){var de=ce(_.trim().replace(/^[=v]+/,""),he);return de?de.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(_){return r("SemVer.compare",this.version,this.loose,_),_ instanceof oe||(_=new oe(_,this.loose)),this.compareMain(_)||this.comparePre(_)},oe.prototype.compareMain=function(_){return _ instanceof oe||(_=new oe(_,this.loose)),A(this.major,_.major)||A(this.minor,_.minor)||A(this.patch,_.patch)},oe.prototype.comparePre=function(_){if(_ instanceof oe||(_=new oe(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var he=0;do{var de=this.prerelease[he],Se=_.prerelease[he];if(r("prerelease compare",he,de,Se),de===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if(de===void 0)return-1;if(de!==Se)return A(de,Se)}while(++he)},oe.prototype.inc=function(_,he){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,he,de,Se){typeof de=="string"&&(Se=de,de=void 0);try{return new oe(_,de).inc(he,Se).version}catch{return null}},e.diff=function(_,he){if(z(_,he))return null;var de=ce(_),Se=ce(he);if(de.prerelease.length||Se.prerelease.length){for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==Se[Ce])return"pre"+Ce;return"prerelease"}for(var Ce in de)if((Ce==="major"||Ce==="minor"||Ce==="patch")&&de[Ce]!==Se[Ce])return Ce},e.compareIdentifiers=A;var j=/^[0-9]+$/;function A(_,he){var de=j.test(_),Se=j.test(he);return de&&Se&&(_=+_,he=+he),de&&!Se?-1:Se&&!de?1:_<he?-1:_>he?1:0}function F(_,he,de){return new oe(_,de).compare(new oe(he,de))}function H(_,he,de){return F(_,he,de)>0}function V(_,he,de){return F(_,he,de)<0}function z(_,he,de){return F(_,he,de)===0}function B(_,he,de){return F(_,he,de)!==0}function Y(_,he,de){return F(_,he,de)>=0}function se(_,he,de){return F(_,he,de)<=0}function le(_,he,de,Se){var Ce;switch(he){case"===":typeof _=="object"&&(_=_.version),typeof de=="object"&&(de=de.version),Ce=_===de;break;case"!==":typeof _=="object"&&(_=_.version),typeof de=="object"&&(de=de.version),Ce=_!==de;break;case"":case"=":case"==":Ce=z(_,de,Se);break;case"!=":Ce=B(_,de,Se);break;case">":Ce=H(_,de,Se);break;case">=":Ce=Y(_,de,Se);break;case"<":Ce=V(_,de,Se);break;case"<=":Ce=se(_,de,Se);break;default:throw new TypeError("Invalid operator: "+he)}return Ce}function ge(_,he){if(_ instanceof ge){if(_.loose===he)return _;_=_.value}if(!(this instanceof ge))return new ge(_,he);r("comparator",_,he),this.loose=he,this.parse(_),this.semver===Pe?this.value="":this.value=this.operator+this.semver.version,r("comp",this)}e.rcompareIdentifiers=function(_,he){return A(he,_)},e.major=function(_,he){return new oe(_,he).major},e.minor=function(_,he){return new oe(_,he).minor},e.patch=function(_,he){return new oe(_,he).patch},e.compare=F,e.compareLoose=function(_,he){return F(_,he,!0)},e.rcompare=function(_,he,de){return F(he,_,de)},e.sort=function(_,he){return _.sort(function(de,Se){return e.compare(de,Se,he)})},e.rsort=function(_,he){return _.sort(function(de,Se){return e.rcompare(de,Se,he)})},e.gt=H,e.lt=V,e.eq=z,e.neq=B,e.gte=Y,e.lte=se,e.cmp=le,e.Comparator=ge;var Pe={};function Re(_,he){if(_ instanceof Re)return _.loose===he?_:new Re(_.raw,he);if(_ instanceof ge)return new Re(_.value,he);if(!(this instanceof Re))return new Re(_,he);if(this.loose=he,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Ae(_){return!_||_.toLowerCase()==="x"||_==="*"}function Le(_,he,de,Se,Ce,je,Oe,Te,We,qe,ze,Q,fe){return((he=Ae(de)?"":Ae(Se)?">="+de+".0.0":Ae(Ce)?">="+de+"."+Se+".0":">="+he)+" "+(Te=Ae(We)?"":Ae(qe)?"<"+(+We+1)+".0.0":Ae(ze)?"<"+We+"."+(+qe+1)+".0":Q?"<="+We+"."+qe+"."+ze+"-"+Q:"<="+Te)).trim()}function He(_,he){for(var de=0;de<_.length;de++)if(!_[de].test(he))return!1;if(he.prerelease.length){for(de=0;de<_.length;de++)if(r(_[de].semver),_[de].semver!==Pe&&_[de].semver.prerelease.length>0){var Se=_[de].semver;if(Se.major===he.major&&Se.minor===he.minor&&Se.patch===he.patch)return!0}return!1}return!0}function me(_,he,de){try{he=new Re(he,de)}catch{return!1}return he.test(_)}function be(_,he,de,Se){var Ce,je,Oe,Te,We;switch(_=new oe(_,Se),he=new Re(he,Se),de){case">":Ce=H,je=se,Oe=V,Te=">",We=">=";break;case"<":Ce=V,je=Y,Oe=H,Te="<",We="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(me(_,he,Se))return!1;for(var qe=0;qe<he.set.length;++qe){var ze=he.set[qe],Q=null,fe=null;if(ze.forEach(function($e){$e.semver===Pe&&($e=new ge(">=0.0.0")),Q=Q||$e,fe=fe||$e,Ce($e.semver,Q.semver,Se)?Q=$e:Oe($e.semver,fe.semver,Se)&&(fe=$e)}),Q.operator===Te||Q.operator===We||(!fe.operator||fe.operator===Te)&&je(_,fe.semver)||fe.operator===We&&Oe(_,fe.semver))return!1}return!0}ge.prototype.parse=function(_){var he=this.loose?S[K]:S[X],de=_.match(he);if(!de)throw new TypeError("Invalid comparator: "+_);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new oe(de[2],this.loose):this.semver=Pe},ge.prototype.toString=function(){return this.value},ge.prototype.test=function(_){return r("Comparator.test",_,this.loose),this.semver===Pe||(typeof _=="string"&&(_=new oe(_,this.loose)),le(_,this.operator,this.semver,this.loose))},ge.prototype.intersects=function(_,he){if(!(_ instanceof ge))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Re(_.value,he),me(this.value,de,he);if(_.operator==="")return de=new Re(this.value,he),me(_.semver,de,he);var Se=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),Ce=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),je=this.semver.version===_.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),Te=le(this.semver,"<",_.semver,he)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),We=le(this.semver,">",_.semver,he)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return Se||Ce||je&&Oe||Te||We},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(_){var he=this.loose;_=_.trim(),r("range",_,he);var de=he?S[T]:S[W];_=_.replace(de,Le),r("hyphen replace",_),_=_.replace(S[U],"$1$2$3"),r("comparator trim",_,S[U]),_=(_=(_=_.replace(S[N],"$1~")).replace(S[ee],"$1^")).split(/\s+/).join(" ");var Se=he?S[K]:S[X],Ce=_.split(" ").map(function(je){return function(Oe,Te){return r("comp",Oe),Oe=function(We,qe){return We.trim().split(/\s+/).map(function(ze){return function(Q,fe){r("caret",Q,fe);var $e=fe?S[ue]:S[ae];return Q.replace($e,function(ve,ye,De,Fe,Be){var Ge;return r("caret",Q,ve,ye,De,Fe,Be),Ae(ye)?Ge="":Ae(De)?Ge=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ae(Fe)?Ge=ye==="0"?">="+ye+"."+De+".0 <"+ye+"."+(+De+1)+".0":">="+ye+"."+De+".0 <"+(+ye+1)+".0.0":Be?(r("replaceCaret pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Ge=ye==="0"?De==="0"?">="+ye+"."+De+"."+Fe+Be+" <"+ye+"."+De+"."+(+Fe+1):">="+ye+"."+De+"."+Fe+Be+" <"+ye+"."+(+De+1)+".0":">="+ye+"."+De+"."+Fe+Be+" <"+(+ye+1)+".0.0"):(r("no pr"),Ge=ye==="0"?De==="0"?">="+ye+"."+De+"."+Fe+" <"+ye+"."+De+"."+(+Fe+1):">="+ye+"."+De+"."+Fe+" <"+ye+"."+(+De+1)+".0":">="+ye+"."+De+"."+Fe+" <"+(+ye+1)+".0.0"),r("caret return",Ge),Ge})}(ze,qe)}).join(" ")}(Oe,Te),r("caret",Oe),Oe=function(We,qe){return We.trim().split(/\s+/).map(function(ze){return function(Q,fe){var $e=fe?S[re]:S[q];return Q.replace($e,function(ve,ye,De,Fe,Be){var Ge;return r("tilde",Q,ve,ye,De,Fe,Be),Ae(ye)?Ge="":Ae(De)?Ge=">="+ye+".0.0 <"+(+ye+1)+".0.0":Ae(Fe)?Ge=">="+ye+"."+De+".0 <"+ye+"."+(+De+1)+".0":Be?(r("replaceTilde pr",Be),Be.charAt(0)!=="-"&&(Be="-"+Be),Ge=">="+ye+"."+De+"."+Fe+Be+" <"+ye+"."+(+De+1)+".0"):Ge=">="+ye+"."+De+"."+Fe+" <"+ye+"."+(+De+1)+".0",r("tilde return",Ge),Ge})}(ze,qe)}).join(" ")}(Oe,Te),r("tildes",Oe),Oe=function(We,qe){return r("replaceXRanges",We,qe),We.split(/\s+/).map(function(ze){return function(Q,fe){Q=Q.trim();var $e=fe?S[D]:S[I];return Q.replace($e,function(ve,ye,De,Fe,Be,Ge){r("xRange",Q,ve,ye,De,Fe,Be,Ge);var xe=Ae(De),Xe=xe||Ae(Fe),Ze=Xe||Ae(Be);return ye==="="&&Ze&&(ye=""),xe?ve=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Ze?(Xe&&(Fe=0),Ze&&(Be=0),ye===">"?(ye=">=",Xe?(De=+De+1,Fe=0,Be=0):Ze&&(Fe=+Fe+1,Be=0)):ye==="<="&&(ye="<",Xe?De=+De+1:Fe=+Fe+1),ve=ye+De+"."+Fe+"."+Be):Xe?ve=">="+De+".0.0 <"+(+De+1)+".0.0":Ze&&(ve=">="+De+"."+Fe+".0 <"+De+"."+(+Fe+1)+".0"),r("xRange return",ve),ve})}(ze,qe)}).join(" ")}(Oe,Te),r("xrange",Oe),Oe=function(We,qe){return r("replaceStars",We,qe),We.trim().replace(S[J],"")}(Oe,Te),r("stars",Oe),Oe}(je,he)}).join(" ").split(/\s+/);return this.loose&&(Ce=Ce.filter(function(je){return!!je.match(Se)})),Ce=Ce.map(function(je){return new ge(je,he)})},Re.prototype.intersects=function(_,he){if(!(_ instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Se){return _.set.some(function(Ce){return Ce.every(function(je){return Se.intersects(je,he)})})})})},e.toComparators=function(_,he){return new Re(_,he).set.map(function(de){return de.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new oe(_,this.loose));for(var he=0;he<this.set.length;he++)if(He(this.set[he],_))return!0;return!1},e.satisfies=me,e.maxSatisfying=function(_,he,de){var Se=null,Ce=null;try{var je=new Re(he,de)}catch{return null}return _.forEach(function(Oe){je.test(Oe)&&(Se&&Ce.compare(Oe)!==-1||(Ce=new oe(Se=Oe,de)))}),Se},e.minSatisfying=function(_,he,de){var Se=null,Ce=null;try{var je=new Re(he,de)}catch{return null}return _.forEach(function(Oe){je.test(Oe)&&(Se&&Ce.compare(Oe)!==1||(Ce=new oe(Se=Oe,de)))}),Se},e.validRange=function(_,he){try{return new Re(_,he).range||"*"}catch{return null}},e.ltr=function(_,he,de){return be(_,he,"<",de)},e.gtr=function(_,he,de){return be(_,he,">",de)},e.outside=be,e.prerelease=function(_,he){var de=ce(_,he);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(_,he,de){return _=new Re(_,de),he=new Re(he,de),_.intersects(he)},e.coerce=function(_){if(_ instanceof oe)return _;if(typeof _!="string")return null;var he=_.match(S[O]);return he==null?null:ce((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,E(1))},function(G,e){var E,C,r=G.exports={};function M(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function S(o){if(E===setTimeout)return setTimeout(o,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(o,0);try{return E(o,0)}catch{try{return E.call(null,o,0)}catch{return E.call(this,o,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{C=typeof clearTimeout=="function"?clearTimeout:R}catch{C=R}})();var f,u=[],$=!1,d=-1;function p(){$&&f&&($=!1,f.length?u=f.concat(u):d=-1,u.length&&h())}function h(){if(!$){var o=S(p);$=!0;for(var g=u.length;g;){for(f=u,u=[];++d<g;)f&&f[d].run();d=-1,g=u.length}f=null,$=!1,function(c){if(C===clearTimeout)return clearTimeout(c);if((C===R||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(c);try{C(c)}catch{try{return C.call(null,c)}catch{return C.call(this,c)}}}(o)}}function v(o,g){this.fun=o,this.array=g}function y(){}r.nextTick=function(o){var g=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)g[c-1]=arguments[c];u.push(new v(o,g)),u.length!==1||$||S(h)},v.prototype.run=function(){this.fun.apply(null,this.array)},r.title="browser",r.browser=!0,r.env={},r.argv=[],r.version="",r.versions={},r.on=y,r.addListener=y,r.once=y,r.off=y,r.removeListener=y,r.removeAllListeners=y,r.emit=y,r.prependListener=y,r.prependOnceListener=y,r.listeners=function(o){return[]},r.binding=function(o){throw new Error("process.binding is not supported")},r.cwd=function(){return"/"},r.chdir=function(o){throw new Error("process.chdir is not supported")},r.umask=function(){return 0}}])}),define(te[139],ie([0,1]),function(G,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class C{constructor(S,f,u){this.level=S,this.key=f,this.value=u,this.forward=[]}}const r=void 0;class M{constructor(S,f=2**16){this.comparator=S,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new C(this.c,r,r)}get size(){return this.f}clear(){this.e=new C(this.c,r,r)}has(S){return!!M.g(this,S,this.comparator)}get(S){return M.g(this,S,this.comparator)?.value}set(S,f){return M.h(this,S,f,this.comparator)&&(this.f+=1),this}delete(S){const f=M.k(this,S,this.comparator);return f&&(this.f-=1),f}forEach(S,f){let u=this.e.forward[0];for(;u;)S.call(f,u.value,u.key,this),u=u.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",f=this.e.forward[0];for(;f;)S+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return S}static g(S,f,u){let $=S.e;for(let d=S.d-1;d>=0;d--)for(;$.forward[d]&&u($.forward[d].key,f)<0;)$=$.forward[d];if($=$.forward[0],$&&u($.key,f)===0)return $}static h(S,f,u,$){const d=[];let p=S.e;for(let h=S.d-1;h>=0;h--){for(;p.forward[h]&&$(p.forward[h].key,f)<0;)p=p.forward[h];d[h]=p}if(p=p.forward[0],p&&$(p.key,f)===0)return p.value=u,!1;{const h=M.j(S);if(h>S.d){for(let v=S.d;v<h;v++)d[v]=S.e;S.d=h}p=new C(h,f,u);for(let v=0;v<h;v++)p.forward[v]=d[v].forward[v],d[v].forward[v]=p;return!0}}static j(S,f=.5){let u=1;for(;Math.random()<f&&u<S.c;)u+=1;return u}static k(S,f,u){const $=[];let d=S.e;for(let p=S.d-1;p>=0;p--){for(;d.forward[p]&&u(d.forward[p].key,f)<0;)d=d.forward[p];$[p]=d}if(d=d.forward[0],!d||u(d.key,f)!==0)return!1;for(let p=0;p<S.d&&$[p].forward[p]===d;p++)$[p].forward[p]=d.forward[p];for(;S.d>0&&S.e.forward[S.d-1]===r;)S.d-=1;return!0}}e.$_q=M}),define(te[69],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(M){return new C(M)}constructor(M){this.c=E&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3c=C}),define(te[3],ie([0,1,13,49,2,101,69]),function(G,e,E,C,r,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.Event=void 0;const S=!1,f=!1;var u;(function(P){P.None=()=>r.$lb.None;function I(z){if(f){const{onDidAddListener:B}=z,Y=v.create();let se=0;z.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Y.print()),B?.()}}}function D(z,B){return ue(z,()=>{},0,void 0,!0,void 0,B)}P.defer=D;function O(z){return(B,Y=null,se)=>{let le=!1,ge;return ge=z(Pe=>{if(!le)return ge?ge.dispose():le=!0,B.call(Y,Pe)},null,se),le&&ge.dispose(),ge}}P.once=O;function L(z,B,Y){return ae((se,le=null,ge)=>z(Pe=>se.call(le,B(Pe)),null,ge),Y)}P.map=L;function N(z,B,Y){return ae((se,le=null,ge)=>z(Pe=>{B(Pe),se.call(le,Pe)},null,ge),Y)}P.forEach=N;function q(z,B,Y){return ae((se,le=null,ge)=>z(Pe=>B(Pe)&&se.call(le,Pe),null,ge),Y)}P.filter=q;function re(z){return z}P.signal=re;function ne(...z){return(B,Y=null,se)=>(0,r.$ib)(...z.map(le=>le(ge=>B.call(Y,ge),null,se)))}P.any=ne;function ee(z,B,Y,se){let le=Y;return L(z,ge=>(le=B(le,ge),le),se)}P.reduce=ee;function ae(z,B){let Y;const se={onWillAddFirstListener(){Y=z(le.fire,le)},onDidRemoveLastListener(){Y?.dispose()}};B||I(se);const le=new b(se);return B?.add(le),le.event}function ue(z,B,Y=100,se=!1,le=!1,ge,Pe){let Re,Ae,Le,He=0,me;const be={leakWarningThreshold:ge,onWillAddFirstListener(){Re=z(he=>{He++,Ae=B(Ae,he),se&&!Le&&(_.fire(Ae),Ae=void 0),me=()=>{const de=Ae;Ae=void 0,Le=void 0,(!se||He>1)&&_.fire(de),He=0},typeof Y=="number"?(clearTimeout(Le),Le=setTimeout(me,Y)):Le===void 0&&(Le=0,queueMicrotask(me))})},onWillRemoveListener(){le&&He>0&&me?.()},onDidRemoveLastListener(){me=void 0,Re.dispose()}};Pe||I(be);const _=new b(be);return Pe?.add(_),_.event}P.debounce=ue;function K(z,B=0,Y){return P.debounce(z,(se,le)=>se?(se.push(le),se):[le],B,void 0,!0,void 0,Y)}P.accumulate=K;function X(z,B=(se,le)=>se===le,Y){let se=!0,le;return q(z,ge=>{const Pe=se||!B(ge,le);return se=!1,le=ge,Pe},Y)}P.latch=X;function U(z,B,Y){return[P.filter(z,B,Y),P.filter(z,se=>!B(se),Y)]}P.split=U;function W(z,B=!1,Y=[]){let se=Y.slice(),le=z(Re=>{se?se.push(Re):Pe.fire(Re)});const ge=()=>{se?.forEach(Re=>Pe.fire(Re)),se=null},Pe=new b({onWillAddFirstListener(){le||(le=z(Re=>Pe.fire(Re)))},onDidAddFirstListener(){se&&(B?setTimeout(ge):ge())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return Pe.event}P.buffer=W;class T{constructor(B){this.event=B,this.d=new r.$kb}map(B){return new T(L(this.event,B,this.d))}forEach(B){return new T(N(this.event,B,this.d))}filter(B){return new T(q(this.event,B,this.d))}reduce(B,Y){return new T(ee(this.event,B,Y,this.d))}latch(){return new T(X(this.event,void 0,this.d))}debounce(B,Y=100,se=!1,le=!1,ge){return new T(ue(this.event,B,Y,se,le,ge,this.d))}on(B,Y,se){return this.event(B,Y,se)}once(B,Y,se){return O(this.event)(B,Y,se)}dispose(){this.d.dispose()}}function J(z){return new T(z)}P.chain=J;function Z(z,B,Y=se=>se){const se=(...Re)=>Pe.fire(Y(...Re)),le=()=>z.on(B,se),ge=()=>z.removeListener(B,se),Pe=new b({onWillAddFirstListener:le,onDidRemoveLastListener:ge});return Pe.event}P.fromNodeEventEmitter=Z;function ce(z,B,Y=se=>se){const se=(...Re)=>Pe.fire(Y(...Re)),le=()=>z.addEventListener(B,se),ge=()=>z.removeEventListener(B,se),Pe=new b({onWillAddFirstListener:le,onDidRemoveLastListener:ge});return Pe.event}P.fromDOMEventEmitter=ce;function oe(z){return new Promise(B=>O(z)(B))}P.toPromise=oe;function j(z,B){return B(void 0),z(Y=>B(Y))}P.runAndSubscribe=j;function A(z,B){let Y=null;function se(ge){Y?.dispose(),Y=new r.$kb,B(ge,Y)}se(void 0);const le=z(ge=>se(ge));return(0,r.$jb)(()=>{le.dispose(),Y?.dispose()})}P.runAndSubscribeWithStore=A;class F{constructor(B,Y){this._observable=B,this.d=0,this.f=!1;const se={onWillAddFirstListener:()=>{B.addObserver(this)},onDidRemoveLastListener:()=>{B.removeObserver(this)}};Y||I(se),this.emitter=new b(se),Y&&Y.add(this.emitter)}beginUpdate(B){this.d++}handlePossibleChange(B){}handleChange(B,Y){this.f=!0}endUpdate(B){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function H(z,B){return new F(z,B).emitter.event}P.fromObservable=H;function V(z){return B=>{let Y=0,se=!1;const le={beginUpdate(){Y++},endUpdate(){Y--,Y===0&&(z.reportChanges(),se&&(se=!1,B()))},handlePossibleChange(){},handleChange(){se=!0}};return z.addObserver(le),z.reportChanges(),{dispose(){z.removeObserver(le)}}}}P.fromObservableLight=V})(u||(e.Event=u={}));class ${static{this.all=new Set}static{this.d=0}constructor(I){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${I}_${$.d++}`,$.all.add(this)}start(I){this.f=new R.$3c,this.listenerCount=I}stop(){if(this.f){const I=this.f.elapsed();this.durations.push(I),this.elapsedOverall+=I,this.invocationCount+=1,this.f=void 0}}}e.$5c=$;let d=-1;function p(P){const I=d;return d=P,{dispose(){d=I}}}e.$6c=p;class h{constructor(I,D=Math.random().toString(18).slice(2,5)){this.threshold=I,this.name=D,this.f=0}dispose(){this.d?.clear()}check(I,D){const O=this.threshold;if(O<=0||D<O)return;this.d||(this.d=new Map);const L=this.d.get(I.value)||0;if(this.d.set(I.value,L+1),this.f-=1,this.f<=0){this.f=O*.5;let N,q=0;for(const[re,ne]of this.d)(!N||q<ne)&&(N=re,q=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${q}):`),console.warn(N)}return()=>{const N=this.d.get(I.value)||0;this.d.set(I.value,N-1)}}}class v{static create(){return new v(new Error().stack??"")}constructor(I){this.value=I}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let y=0;class o{constructor(I){this.value=I,this.id=y++}}const g=2,c=(P,I)=>{if(P instanceof o)I(P);else for(let D=0;D<P.length;D++){const O=P[D];O&&I(O)}};class b{constructor(I){this.u=0,this.d=I,this.f=d>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??d):void 0,this.g=this.d?._profName?new $(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(S){const I=this.q;queueMicrotask(()=>{c(I,D=>D.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(I,D,O)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),r.$lb.None;if(this.j)return r.$lb.None;D&&(I=I.bind(D));const L=new o(I);let N,q;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(L.stack=v.create(),N=this.f.check(L.stack,this.u+1)),S&&(L.stack=q??v.create()),this.q?this.q instanceof o?(this.t??=new w,this.q=[this.q,L]):this.q.push(L):(this.d?.onWillAddFirstListener?.(this),this.q=L,this.d?.onDidAddFirstListener?.(this)),this.u++;const re=(0,r.$jb)(()=>{N?.(),this.v(L)});return O instanceof r.$kb?O.add(re):Array.isArray(O)&&O.push(re),re},this.m}v(I){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const D=this.q,O=D.indexOf(I);if(O===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,D[O]=void 0;const L=this.t.current===this;if(this.u*g<=D.length){let N=0;for(let q=0;q<D.length;q++)D[q]?D[N++]=D[q]:L&&(this.t.end--,N<this.t.i&&this.t.i--);D.length=N}}w(I,D){if(!I)return;const O=this.d?.onListenerError||E.$Y;if(!O){I.value(D);return}try{I.value(D)}catch(L){O(L)}}x(I){const D=I.current.q;for(;I.i<I.end;)this.w(D[I.i++],I.value);I.reset()}fire(I){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof o)this.w(this.q,I);else{const D=this.t;D.enqueue(this,I,this.q.length),this.x(D)}this.g?.stop()}hasListeners(){return this.u>0}}e.$7c=b;const k=()=>new w;e.$8c=k;class w{constructor(){this.i=-1,this.end=0}enqueue(I,D,O){this.i=0,this.end=O,this.current=I,this.value=D}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends b{async fireAsync(I,D,O){if(this.q)for(this.h||(this.h=new M.$lc),c(this.q,L=>this.h.push([L.value,I]));this.h.size>0&&!D.isCancellationRequested;){const[L,N]=this.h.shift(),q=[],re={...N,token:D,waitUntil:ne=>{if(Object.isFrozen(q))throw new Error("waitUntil can NOT be called asynchronous");O&&(ne=O(ne,L)),q.push(ne)}};try{L(re)}catch(ne){(0,E.$Y)(ne);continue}Object.freeze(q),await Promise.allSettled(q).then(ne=>{for(const ee of ne)ee.status==="rejected"&&(0,E.$Y)(ee.reason)})}}}e.$9c=t;class l extends b{get isPaused(){return this.h!==0}constructor(I){super(I),this.h=0,this.s=new M.$lc,this.y=I?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const I=Array.from(this.s);this.s.clear(),super.fire(this.y(I))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(I){this.u&&(this.h!==0?this.s.push(I):super.fire(I))}}e.$0c=l;class s extends l{constructor(I){super(I),this.k=I.delay??100}fire(I){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(I)}}e.$$c=s;class n extends b{constructor(I){super(I),this.h=[],this.k=I?.merge}fire(I){this.hasListeners()&&(this.h.push(I),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(D=>super.fire(D)),this.h=[]}))}}e.$_c=n;class i{constructor(){this.f=!1,this.g=[],this.d=new b({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(I){const D={event:I,listener:null};this.g.push(D),this.f&&this.k(D);const O=()=>{this.f&&this.m(D);const L=this.g.indexOf(D);this.g.splice(L,1)};return(0,r.$jb)((0,C.$cb)(O))}h(){this.f=!0,this.g.forEach(I=>this.k(I))}j(){this.f=!1,this.g.forEach(I=>this.m(I))}k(I){I.listener=I.event(D=>this.d.fire(D))}m(I){I.listener&&I.listener.dispose(),I.listener=null}dispose(){this.d.dispose()}}e.$ad=i;class a{constructor(){this.d=[]}wrapEvent(I){return(D,O,L)=>I(N=>{const q=this.d[this.d.length-1];q?q.push(()=>D.call(O,N)):D.call(O,N)},void 0,L)}bufferEvents(I){const D=[];this.d.push(D);const O=I();return this.d.pop(),D.forEach(L=>L()),O}}e.$bd=a;class m{constructor(){this.d=!1,this.f=u.None,this.g=r.$lb.None,this.h=new b({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(I){this.f=I,this.d&&(this.g.dispose(),this.g=I(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$cd=m}),define(te[21],ie([0,1,3]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=e.CancellationToken=void 0;const C=Object.freeze(function(S,f){const u=setTimeout(S.bind(f),0);return{dispose(){clearTimeout(u)}}});var r;(function(S){function f(u){return u===S.None||u===S.Cancelled||u instanceof M?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}S.isCancellationToken=f,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(r||(e.CancellationToken=r={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new E.$7c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(f){this.a=void 0,this.b=void 0,this.b=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new M),this.a}cancel(){this.a?this.a instanceof M&&this.a.cancel():this.a=r.Cancelled}dispose(f=!1){f&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof M&&this.a.dispose():this.a=r.None}}e.$dd=R}),define(te[140],ie([0,1,21]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gd=e.$fd=e.$ed=void 0;class C{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new E.$dd,f=this.b(S.token);return this.a={promise:f,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$ed=C;class r{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const f=JSON.stringify(S);return this.b!==f&&(this.b=f,this.a=this.c(S)),this.a}}e.$fd=r;class M{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const f=this.b(S);return this.a.set(S,f),f}}e.$gd=M}),define(te[56],ie([0,1,13,2]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function r(k){const w=k;return w?typeof w.read=="function":!1}e.$ub=r;function M(k){const w=k;return w?[w.on,w.pause,w.resume,w.destroy].every(t=>typeof t=="function"):!1}e.$vb=M;function R(k){const w=k;return w?M(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}e.$wb=R;function S(k,w){return new f(k,w)}e.$xb=S;class f{constructor(w,t){this.e=w,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(w){if(!this.a.destroyed){if(this.a.flowing)this.g(w);else if(this.b.data.push(w),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(w){this.a.destroyed||(this.a.flowing?this.h(w):this.b.error.push(w))}end(w){this.a.destroyed||(typeof w<"u"&&this.write(w),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(w){this.c.data.slice(0).forEach(t=>t(w))}h(w){this.c.error.length===0?(0,E.$Y)(w):this.c.error.slice(0).forEach(t=>t(w))}i(){this.c.end.slice(0).forEach(w=>w())}on(w,t){if(!this.a.destroyed)switch(w){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(w,t){if(this.a.destroyed)return;let l;switch(w){case"data":l=this.c.data;break;case"end":l=this.c.end;break;case"error":l=this.c.error;break}if(l){const s=l.indexOf(t);s>=0&&l.splice(s,1)}}j(){if(this.b.data.length>0){const w=this.e(this.b.data);this.g(w),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(l=>l())}}k(){if(this.c.error.length>0){for(const w of this.b.error)this.h(w);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(k,w){const t=[];let l;for(;(l=k.read())!==null;)t.push(l);return w(t)}e.$yb=u;function $(k,w,t){const l=[];let s;for(;(s=k.read())!==null&&l.length<t;)l.push(s);return s===null&&l.length>0?w(l):{read:()=>{if(l.length>0)return l.shift();if(typeof s<"u"){const n=s;return s=void 0,n}return k.read()}}}e.$zb=$;function d(k,w){return new Promise((t,l)=>{const s=[];p(k,{onData:n=>{w&&s.push(n)},onError:n=>{w?l(n):t(void 0)},onEnd:()=>{t(w?w(s):void 0)}})})}e.$Ab=d;function p(k,w){let t=!1;return k.on("error",l=>{t||w.onError(l)}),k.on("end",()=>{t||w.onEnd()}),k.on("data",l=>{t||w.onData(l)}),(0,C.$jb)(()=>t=!0)}e.$Bb=p;function h(k,w){return new Promise((t,l)=>{const s=new C.$kb,n=[],i=P=>{if(n.push(P),n.length>w)return s.dispose(),k.pause(),t({stream:k,buffer:n,ended:!1})},a=P=>l(P),m=()=>t({stream:k,buffer:n,ended:!0});s.add((0,C.$jb)(()=>k.removeListener("error",a))),k.on("error",a),s.add((0,C.$jb)(()=>k.removeListener("end",m))),k.on("end",m),s.add((0,C.$jb)(()=>k.removeListener("data",i))),k.on("data",i)})}e.$Cb=h;function v(k,w){const t=S(w);return t.end(k),t}e.$Db=v;function y(){const k=S(()=>{throw new Error("not supported")});return k.end(),k}e.$Eb=y;function o(k){let w=!1;return{read:()=>w?null:(w=!0,k)}}e.$Fb=o;function g(k,w,t){const l=S(t);return p(k,{onData:s=>l.write(w.data(s)),onError:s=>l.error(w.error?w.error(s):s),onEnd:()=>l.end()}),l}e.$Gb=g;function c(k,w,t){let l=!1;return{read:()=>{const s=w.read();return l?s:(l=!0,s!==null?t([k,s]):k)}}}e.$Hb=c;function b(k,w,t){let l=!1;const s=S(t);return p(w,{onData:n=>l?s.write(n):(l=!0,s.write(t([k,n]))),onError:n=>s.error(n),onEnd:()=>{l||(l=!0,s.write(k)),s.end()}}),s}e.$Ib=b}),define(te[17],ie([0,1,85,56]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const r=typeof Buffer<"u",M=new E.$T(()=>new Uint8Array(256));let R,S;class f{static alloc(O){return r?new f(Buffer.allocUnsafe(O)):new f(new Uint8Array(O))}static wrap(O){return r&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new f(O)}static fromString(O,L){return!(L?.dontUseNodeBuffer||!1)&&r?new f(Buffer.from(O)):(R||(R=new TextEncoder),new f(R.encode(O)))}static fromByteArray(O){const L=f.alloc(O.length);for(let N=0,q=O.length;N<q;N++)L.buffer[N]=O[N];return L}static concat(O,L){if(typeof L>"u"){L=0;for(let re=0,ne=O.length;re<ne;re++)L+=O[re].byteLength}const N=f.alloc(L);let q=0;for(let re=0,ne=O.length;re<ne;re++){const ee=O[re];N.set(ee,q),q+=ee.byteLength}return N}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=f.alloc(this.byteLength);return O.set(this),O}toString(){return r?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(O,L){return new f(this.buffer.subarray(O,L))}set(O,L){if(O instanceof f)this.buffer.set(O.buffer,L);else if(O instanceof Uint8Array)this.buffer.set(O,L);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),L);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return p(this.buffer,O)}writeUInt32BE(O,L){h(this.buffer,O,L)}readUInt32LE(O){return v(this.buffer,O)}writeUInt32LE(O,L){y(this.buffer,O,L)}readUInt8(O){return o(this.buffer,O)}writeUInt8(O,L){g(this.buffer,O,L)}indexOf(O,L=0){return u(this.buffer,O instanceof f?O.buffer:O,L)}}e.$Jb=f;function u(D,O,L=0){const N=O.byteLength,q=D.byteLength;if(N===0)return 0;if(N===1)return D.indexOf(O[0]);if(N>q-L)return-1;const re=M.value;re.fill(O.length);for(let ue=0;ue<O.length;ue++)re[O[ue]]=O.length-ue-1;let ne=L+O.length-1,ee=ne,ae=-1;for(;ne<q;)if(D[ne]===O[ee]){if(ee===0){ae=ne;break}ne--,ee--}else ne+=Math.max(O.length-ee,re[D[ne]]),ee=O.length-1;return ae}e.$Kb=u;function $(D,O){return D[O+0]<<0>>>0|D[O+1]<<8>>>0}e.$Lb=$;function d(D,O,L){D[L+0]=O&255,O=O>>>8,D[L+1]=O&255}e.$Mb=d;function p(D,O){return D[O]*2**24+D[O+1]*2**16+D[O+2]*2**8+D[O+3]}e.$Nb=p;function h(D,O,L){D[L+3]=O,O=O>>>8,D[L+2]=O,O=O>>>8,D[L+1]=O,O=O>>>8,D[L]=O}e.$Ob=h;function v(D,O){return D[O+0]<<0>>>0|D[O+1]<<8>>>0|D[O+2]<<16>>>0|D[O+3]<<24>>>0}e.$Pb=v;function y(D,O,L){D[L+0]=O&255,O=O>>>8,D[L+1]=O&255,O=O>>>8,D[L+2]=O&255,O=O>>>8,D[L+3]=O&255}e.$Qb=y;function o(D,O){return D[O]}e.$Rb=o;function g(D,O,L){D[L]=O}e.$Sb=g;function c(D){return C.$yb(D,O=>f.concat(O))}e.$Tb=c;function b(D){return C.$Fb(D)}e.$Ub=b;function k(D){return C.$Ab(D,O=>f.concat(O))}e.$Vb=k;async function w(D){return D.ended?f.concat(D.buffer):f.concat([...D.buffer,await k(D.stream)])}e.$Wb=w;function t(D){return C.$Db(D,O=>f.concat(O))}e.$Xb=t;function l(D){return C.$Gb(D,{data:O=>typeof O=="string"?f.fromString(O):f.wrap(O)},O=>f.concat(O))}e.$Yb=l;function s(D){return C.$xb(O=>f.concat(O),D)}e.$Zb=s;function n(D,O){return C.$Hb(D,O,L=>f.concat(L))}e.$1b=n;function i(D,O){return C.$Ib(D,O,L=>f.concat(L))}e.$2b=i;function a(D){let O=0,L=0,N=0;const q=new Uint8Array(Math.floor(D.length/4*3)),re=ee=>{switch(L){case 3:q[N++]=O|ee,L=0;break;case 2:q[N++]=O|ee>>>2,O=ee<<6,L=3;break;case 1:q[N++]=O|ee>>>4,O=ee<<4,L=2;break;default:O=ee<<2,L=1}};for(let ee=0;ee<D.length;ee++){const ae=D.charCodeAt(ee);if(ae>=65&&ae<=90)re(ae-65);else if(ae>=97&&ae<=122)re(ae-97+26);else if(ae>=48&&ae<=57)re(ae-48+52);else if(ae===43||ae===45)re(62);else if(ae===47||ae===95)re(63);else{if(ae===61)break;throw new SyntaxError(`Unexpected base64 character ${D[ee]}`)}}const ne=N;for(;L>0;)re(0);return f.wrap(q).slice(0,ne)}e.$3b=a;const m="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:D},O=!0,L=!1){const N=L?P:m;let q="";const re=D.byteLength%3;let ne=0;for(;ne<D.byteLength-re;ne+=3){const ee=D[ne+0],ae=D[ne+1],ue=D[ne+2];q+=N[ee>>>2],q+=N[(ee<<4|ae>>>4)&63],q+=N[(ae<<2|ue>>>6)&63],q+=N[ue&63]}if(re===1){const ee=D[ne+0];q+=N[ee>>>2],q+=N[ee<<4&63],O&&(q+="==")}else if(re===2){const ee=D[ne+0],ae=D[ne+1];q+=N[ee>>>2],q+=N[(ee<<4|ae>>>4)&63],q+=N[ae<<2&63],O&&(q+="=")}return q}e.$4b=I}),define(te[25],ie([0,1,140,85]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.GraphemeBreakType=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=void 0;function r(Q){return!Q||typeof Q!="string"?!0:Q.trim().length===0}e.$jd=r;const M=/{(\d+)}/g;function R(Q,...fe){return fe.length===0?Q:Q.replace(M,function($e,ve){const ye=parseInt(ve,10);return isNaN(ye)||ye<0||ye>=fe.length?$e:fe[ye]})}e.$kd=R;const S=/{([^}]+)}/g;function f(Q,fe){return Q.replace(S,($e,ve)=>fe[ve]??$e)}e.$ld=f;function u(Q){return Q.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$md=u;function $(Q){return Q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$nd=$;function d(Q,fe){let $e=0;const ve=fe.charCodeAt(0);for(let ye=Q.length-1;ye>=0;ye--)Q.charCodeAt(ye)===ve&&$e++;return $e}e.$od=d;function p(Q,fe,$e="\u2026"){return Q.length<=fe?Q:`${Q.substr(0,fe)}${$e}`}e.$pd=p;function h(Q,fe=" "){const $e=v(Q,fe);return y($e,fe)}e.$qd=h;function v(Q,fe){if(!Q||!fe)return Q;const $e=fe.length;if($e===0||Q.length===0)return Q;let ve=0;for(;Q.indexOf(fe,ve)===ve;)ve=ve+$e;return Q.substring(ve)}e.$rd=v;function y(Q,fe){if(!Q||!fe)return Q;const $e=fe.length,ve=Q.length;if($e===0||ve===0)return Q;let ye=ve,De=-1;for(;De=Q.lastIndexOf(fe,ye-1),!(De===-1||De+$e!==ye);){if(De===0)return"";ye=De}return Q.substring(0,ye)}e.$sd=y;function o(Q){return Q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$td=o;function g(Q){return Q.replace(/\*/g,"")}e.$ud=g;function c(Q,fe,$e={}){if(!Q)throw new Error("Cannot create regex from empty string");fe||(Q=$(Q)),$e.wholeWord&&(/\B/.test(Q.charAt(0))||(Q="\\b"+Q),/\B/.test(Q.charAt(Q.length-1))||(Q=Q+"\\b"));let ve="";return $e.global&&(ve+="g"),$e.matchCase||(ve+="i"),$e.multiline&&(ve+="m"),$e.unicode&&(ve+="u"),new RegExp(Q,ve)}e.$vd=c;function b(Q){return Q.source==="^"||Q.source==="^$"||Q.source==="$"||Q.source==="^\\s*$"?!1:!!(Q.exec("")&&Q.lastIndex===0)}e.$wd=b;function k(Q){return!!Q.match(/([^\\]|^)(\\\\)*\\\d+/)}e.$xd=k;function w(Q){return(Q.global?"g":"")+(Q.ignoreCase?"i":"")+(Q.multiline?"m":"")+(Q.unicode?"u":"")}e.$yd=w;function t(Q){return Q.split(/\r\n|\r|\n/)}e.$zd=t;function l(Q){for(let fe=0,$e=Q.length;fe<$e;fe++){const ve=Q.charCodeAt(fe);if(ve!==32&&ve!==9)return fe}return-1}e.$Ad=l;function s(Q,fe=0,$e=Q.length){for(let ve=fe;ve<$e;ve++){const ye=Q.charCodeAt(ve);if(ye!==32&&ye!==9)return Q.substring(fe,ve)}return Q.substring(fe,$e)}e.$Bd=s;function n(Q,fe=Q.length-1){for(let $e=fe;$e>=0;$e--){const ve=Q.charCodeAt($e);if(ve!==32&&ve!==9)return $e}return-1}e.$Cd=n;function i(Q,fe,$e){const ve=[];let ye=0;for(const De of Q.matchAll(fe)){if(ve.push(Q.slice(ye,De.index)),De.index===void 0)throw new Error("match.index should be defined");ye=De.index+De[0].length,ve.push($e(De[0],...De.slice(1),De.index,Q,De.groups))}return ve.push(Q.slice(ye)),Promise.all(ve).then(De=>De.join(""))}e.$Dd=i;function a(Q,fe){return Q<fe?-1:Q>fe?1:0}e.$Ed=a;function m(Q,fe,$e=0,ve=Q.length,ye=0,De=fe.length){for(;$e<ve&&ye<De;$e++,ye++){const Ge=Q.charCodeAt($e),xe=fe.charCodeAt(ye);if(Ge<xe)return-1;if(Ge>xe)return 1}const Fe=ve-$e,Be=De-ye;return Fe<Be?-1:Fe>Be?1:0}e.$Fd=m;function P(Q,fe){return I(Q,fe,0,Q.length,0,fe.length)}e.$Gd=P;function I(Q,fe,$e=0,ve=Q.length,ye=0,De=fe.length){for(;$e<ve&&ye<De;$e++,ye++){let Ge=Q.charCodeAt($e),xe=fe.charCodeAt(ye);if(Ge===xe)continue;if(Ge>=128||xe>=128)return m(Q.toLowerCase(),fe.toLowerCase(),$e,ve,ye,De);O(Ge)&&(Ge-=32),O(xe)&&(xe-=32);const Xe=Ge-xe;if(Xe!==0)return Xe}const Fe=ve-$e,Be=De-ye;return Fe<Be?-1:Fe>Be?1:0}e.$Hd=I;function D(Q){return Q>=48&&Q<=57}e.$Id=D;function O(Q){return Q>=97&&Q<=122}e.$Jd=O;function L(Q){return Q>=65&&Q<=90}e.$Kd=L;function N(Q,fe){return Q.length===fe.length&&I(Q,fe)===0}e.$Ld=N;function q(Q,fe){const $e=fe.length;return fe.length>Q.length?!1:I(Q,fe,0,$e)===0}e.$Md=q;function re(Q,fe){const $e=Math.min(Q.length,fe.length);let ve;for(ve=0;ve<$e;ve++)if(Q.charCodeAt(ve)!==fe.charCodeAt(ve))return ve;return $e}e.$Nd=re;function ne(Q,fe){const $e=Math.min(Q.length,fe.length);let ve;const ye=Q.length-1,De=fe.length-1;for(ve=0;ve<$e;ve++)if(Q.charCodeAt(ye-ve)!==fe.charCodeAt(De-ve))return ve;return $e}e.$Od=ne;function ee(Q){return 55296<=Q&&Q<=56319}e.$Pd=ee;function ae(Q){return 56320<=Q&&Q<=57343}e.$Qd=ae;function ue(Q,fe){return(Q-55296<<10)+(fe-56320)+65536}e.$Rd=ue;function K(Q,fe,$e){const ve=Q.charCodeAt($e);if(ee(ve)&&$e+1<fe){const ye=Q.charCodeAt($e+1);if(ae(ye))return ue(ve,ye)}return ve}e.$Sd=K;function X(Q,fe){const $e=Q.charCodeAt(fe-1);if(ae($e)&&fe>1){const ve=Q.charCodeAt(fe-2);if(ee(ve))return ue(ve,$e)}return $e}class U{get offset(){return this.e}constructor(fe,$e=0){this.c=fe,this.d=fe.length,this.e=$e}setOffset(fe){this.e=fe}prevCodePoint(){const fe=X(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=K(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$Td=U;class W{get offset(){return this.c.offset}constructor(fe,$e=0){this.c=new U(fe,$e)}nextGraphemeLength(){const fe=Se.getInstance(),$e=this.c,ve=$e.offset;let ye=fe.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const De=$e.offset,Fe=fe.getGraphemeBreakType($e.nextCodePoint());if(he(ye,Fe)){$e.setOffset(De);break}ye=Fe}return $e.offset-ve}prevGraphemeLength(){const fe=Se.getInstance(),$e=this.c,ve=$e.offset;let ye=fe.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const De=$e.offset,Fe=fe.getGraphemeBreakType($e.prevCodePoint());if(he(Fe,ye)){$e.setOffset(De);break}ye=Fe}return ve-$e.offset}eol(){return this.c.eol()}}e.$Ud=W;function T(Q,fe){return new W(Q,fe).nextGraphemeLength()}e.$Vd=T;function J(Q,fe){return new W(Q,fe).prevGraphemeLength()}e.$Wd=J;function Z(Q,fe){fe>0&&ae(Q.charCodeAt(fe))&&fe--;const $e=fe+T(Q,fe);return[$e-J(Q,$e),$e]}e.$Xd=Z;function ce(Q){const fe=new W(Q);let $e=0;for(;!fe.eol();)$e++,fe.nextGraphemeLength();return $e}e.$Yd=ce;let oe;function j(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function A(Q){return oe||(oe=j()),oe.test(Q)}e.$Zd=A;const F=/^[\t\n\r\x20-\x7E]*$/;function H(Q){return F.test(Q)}e.$1d=H,e.$2d=/[\u2028\u2029]/;function V(Q){return e.$2d.test(Q)}e.$3d=V;function z(Q){return Q>=11904&&Q<=55215||Q>=63744&&Q<=64255||Q>=65281&&Q<=65374}e.$4d=z;function B(Q){return Q>=127462&&Q<=127487||Q===8986||Q===8987||Q===9200||Q===9203||Q>=9728&&Q<=10175||Q===11088||Q===11093||Q>=127744&&Q<=128591||Q>=128640&&Q<=128764||Q>=128992&&Q<=129008||Q>=129280&&Q<=129535||Q>=129648&&Q<=129782}e.$5d=B;function Y(Q,fe){if(Q.length<fe)return Q;const $e=/\b/g;let ve=0;for(;$e.test(Q)&&!(Q.length-$e.lastIndex<fe);)ve=$e.lastIndex,$e.lastIndex+=1;return Q.substring(ve).replace(/^\s/,"")}e.$6d=Y;const se=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,le=/\x1b\].*?\x07/g;function ge(Q){return Q&&(Q=Q.replace(se,"").replace(le,"")),Q}e.$7d=ge,e.$8d=String.fromCharCode(65279);function Pe(Q){return!!(Q&&Q.length>0&&Q.charCodeAt(0)===65279)}e.$9d=Pe;function Re(Q){return Pe(Q)?Q.substr(1):Q}e.$0d=Re;function Ae(Q,fe){if(!Q||!fe||Q.length<fe.length)return!1;const $e=fe.length,ve=Q.toLowerCase();let ye=0,De=-1;for(;ye<$e;){const Fe=ve.indexOf(fe[ye],De+1);if(Fe<0)return!1;De=Fe,ye++}return!0}e.$$d=Ae;function Le(Q,fe=!1){return Q?(fe&&(Q=Q.replace(/\\./g,"")),Q.toLowerCase()!==Q):!1}e.$_d=Le;function He(Q){return Q.charAt(0).toUpperCase()+Q.slice(1)}e.$ae=He;function me(Q,fe=1){if(fe===0)return"";let $e=-1;do $e=Q.indexOf(`
`,$e+1),fe--;while(fe>0&&$e>=0);return $e===-1?Q:(Q[$e-1]==="\r"&&$e--,Q.substr(0,$e))}e.$be=me;function be(Q){return Q=Q%(2*26),Q<26?String.fromCharCode(97+Q):String.fromCharCode(65+Q-26)}e.$ce=be;function _(Q){return Se.getInstance().getGraphemeBreakType(Q)}e.$de=_;function he(Q,fe){return Q===0?fe!==5&&fe!==7:Q===2&&fe===3?!1:Q===4||Q===2||Q===3||fe===4||fe===2||fe===3?!0:!(Q===8&&(fe===8||fe===9||fe===11||fe===12)||(Q===11||Q===9)&&(fe===9||fe===10)||(Q===12||Q===10)&&fe===10||fe===5||fe===13||fe===7||Q===1||Q===13&&fe===14||Q===6&&fe===6)}var de;(function(Q){Q[Q.Other=0]="Other",Q[Q.Prepend=1]="Prepend",Q[Q.CR=2]="CR",Q[Q.LF=3]="LF",Q[Q.Control=4]="Control",Q[Q.Extend=5]="Extend",Q[Q.Regional_Indicator=6]="Regional_Indicator",Q[Q.SpacingMark=7]="SpacingMark",Q[Q.L=8]="L",Q[Q.V=9]="V",Q[Q.T=10]="T",Q[Q.LV=11]="LV",Q[Q.LVT=12]="LVT",Q[Q.ZWJ=13]="ZWJ",Q[Q.Extended_Pictographic=14]="Extended_Pictographic"})(de||(e.GraphemeBreakType=de={}));class Se{static{this.c=null}static getInstance(){return Se.c||(Se.c=new Se),Se.c}constructor(){this.d=Ce()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const $e=this.d,ve=$e.length/3;let ye=1;for(;ye<=ve;)if(fe<$e[3*ye])ye=2*ye;else if(fe>$e[3*ye+1])ye=2*ye+1;else return $e[3*ye+2];return 0}}function Ce(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function je(Q,fe){if(Q===0)return 0;const $e=Oe(Q,fe);if($e!==void 0)return $e;const ve=new U(fe,Q);return ve.prevCodePoint(),ve.offset}e.$ee=je;function Oe(Q,fe){const $e=new U(fe,Q);let ve=$e.prevCodePoint();for(;Te(ve)||ve===65039||ve===8419;){if($e.offset===0)return;ve=$e.prevCodePoint()}if(!B(ve))return;let ye=$e.offset;return ye>0&&$e.prevCodePoint()===8205&&(ye=$e.offset),ye}function Te(Q){return 127995<=Q&&Q<=127999}var We;(function(Q){Q[Q.zwj=8205]="zwj",Q[Q.emojiVariantSelector=65039]="emojiVariantSelector",Q[Q.enclosingKeyCap=8419]="enclosingKeyCap"})(We||(We={})),e.$fe="\xA0";class qe{static{this.c=new C.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new E.$fd(fe=>{function $e(Xe){const Ze=new Map;for(let tt=0;tt<Xe.length;tt+=2)Ze.set(Xe[tt],Xe[tt+1]);return Ze}function ve(Xe,Ze){const tt=new Map(Xe);for(const[ot,ct]of Ze)tt.set(ot,ct);return tt}function ye(Xe,Ze){if(!Xe)return Ze;const tt=new Map;for(const[ot,ct]of Xe)Ze.has(ot)&&tt.set(ot,ct);return tt}const De=this.c.value;let Fe=fe.filter(Xe=>!Xe.startsWith("_")&&Xe in De);Fe.length===0&&(Fe=["_default"]);let Be;for(const Xe of Fe){const Ze=$e(De[Xe]);Be=ye(Be,Ze)}const Ge=$e(De._common),xe=ve(Ge,Be);return new qe(xe)})}static getInstance(fe){return qe.d.get(Array.from(fe))}static{this.e=new C.$T(()=>Object.keys(qe.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return qe.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ge=qe;class ze{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(ze.c())),this.d}static isInvisibleCharacter(fe){return ze.e().has(fe)}static get codePoints(){return ze.e()}}e.$he=ze}),define(te[57],ie([0,1,25]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=void 0;function C(g){return r(g,0)}e.$bi=C;function r(g,c){switch(typeof g){case"object":return g===null?M(349,c):Array.isArray(g)?f(g,c):u(g,c);case"string":return S(g,c);case"boolean":return R(g,c);case"number":return M(g,c);case"undefined":return M(937,c);default:return M(617,c)}}e.$ci=r;function M(g,c){return(c<<5)-c+g|0}e.$di=M;function R(g,c){return M(g?433:863,c)}function S(g,c){c=M(149417,c);for(let b=0,k=g.length;b<k;b++)c=M(g.charCodeAt(b),c);return c}e.$ei=S;function f(g,c){return c=M(104579,c),g.reduce((b,k)=>r(k,b),c)}function u(g,c){return c=M(181387,c),Object.keys(g).sort().reduce((b,k)=>(b=S(k,b),r(g[k],b)),c)}class ${constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=r(c,this.g),this.g}}e.$fi=$;var d;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(d||(d={}));function p(g,c,b=32){const k=b-c,w=~((1<<k)-1);return(g<<c|(w&g)>>>k)>>>0}function h(g,c=0,b=g.byteLength,k=0){for(let w=0;w<b;w++)g[c+w]=k}function v(g,c,b="0"){for(;g.length<c;)g=b+g;return g}function y(g,c=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(b=>b.toString(16).padStart(2,"0")).join(""):v((g>>>0).toString(16),c/4)}e.$gi=y;class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const b=c.length;if(b===0)return;const k=this.p;let w=this.r,t=this.u,l,s;for(t!==0?(l=t,s=-1,t=0):(l=c.charCodeAt(0),s=0);;){let n=l;if(E.$Pd(l))if(s+1<b){const i=c.charCodeAt(s+1);E.$Qd(i)?(s++,n=E.$Rd(l,i)):n=65533}else{t=l;break}else E.$Qd(l)&&(n=65533);if(w=this.w(k,w,n),s++,s<b)l=c.charCodeAt(s);else break}this.r=w,this.u=t}w(c,b,k){return k<128?c[b++]=k:k<2048?(c[b++]=192|(k&1984)>>>6,c[b++]=128|(k&63)>>>0):k<65536?(c[b++]=224|(k&61440)>>>12,c[b++]=128|(k&4032)>>>6,c[b++]=128|(k&63)>>>0):(c[b++]=240|(k&1835008)>>>18,c[b++]=128|(k&258048)>>>12,c[b++]=128|(k&4032)>>>6,c[b++]=128|(k&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=o.g,b=this.q;for(let m=0;m<64;m+=4)c.setUint32(m,b.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)c.setUint32(m,p(c.getUint32(m-12,!1)^c.getUint32(m-32,!1)^c.getUint32(m-56,!1)^c.getUint32(m-64,!1),1),!1);let k=this.h,w=this.l,t=this.m,l=this.n,s=this.o,n,i,a;for(let m=0;m<80;m++)m<20?(n=w&t|~w&l,i=1518500249):m<40?(n=w^t^l,i=1859775393):m<60?(n=w&t|w&l|t&l,i=2400959708):(n=w^t^l,i=3395469782),a=p(k,5)+n+s+i+c.getUint32(m*4,!1)&4294967295,s=l,l=t,t=p(w,30),w=k,k=a;this.h=this.h+k&4294967295,this.l=this.l+w&4294967295,this.m=this.m+t&4294967295,this.n=this.n+l&4294967295,this.o=this.o+s&4294967295}}e.$hi=o}),define(te[70],ie([0,1,25]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(r){r[r.Ignore=0]="Ignore",r[r.Info=1]="Info",r[r.Warning=2]="Warning",r[r.Error=3]="Error"})(C||(C={})),function(r){const M="error",R="warning",S="warn",f="info",u="ignore";function $(p){return p?E.$Ld(M,p)?r.Error:E.$Ld(R,p)||E.$Ld(S,p)?r.Warning:E.$Ld(f,p)?r.Info:r.Ignore:r.Ignore}r.fromValue=$;function d(p){switch(p){case r.Error:return M;case r.Warning:return R;case r.Info:return f;default:return u}}r.toString=d}(C||(C={})),e.default=C}),define(te[141],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0,e.$4c=Symbol("MicrotaskDelay")}),define(te[58],ie([0,1,24,25]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0;class r{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const v=h.charCodeAt(0),y=this.b.charCodeAt(this.c);return v-y}value(){return this.b[this.c]}}e.$ph=r;class M{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,C.$Fd)(h,this.b,0,h.length,this.c,this.d):(0,C.$Hd)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$qh=M;class R{constructor(h=!0,v=!0){this.f=h,this.g=v}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let v=h.length-1;v>=0;v--,this.c--){const y=this.b.charCodeAt(v);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const v=this.b.charCodeAt(this.e);if(v===47||this.f&&v===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,C.$Fd)(h,this.b,0,h.length,this.d,this.e):(0,C.$Hd)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$rh=R;var S;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(S||(S={}));class f{constructor(h,v){this.f=h,this.g=v,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,C.$Gd)(h,this.c.scheme);if(this.d[this.e]===2)return(0,C.$Gd)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,C.$Ed)(h,this.c.query);if(this.d[this.e]===5)return(0,C.$Ed)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$sh=f;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var $;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})($||($={}));class d{static forUris(h=()=>!1,v=()=>!1){return new d(new f(h,v))}static forPaths(h=!1){return new d(new R(void 0,!h))}static forStrings(){return new d(new r)}static forConfigKeys(){return new d(new M)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,v){if(v){const y=v.slice(0);(0,E.$Df)(y);for(const o of y)this.set(o,h)}else{const y=h.slice(0);(0,E.$Df)(y);for(const o of y)this.set(o[0],o[1])}}set(h,v){const y=this.b.reset(h);let o;this.c||(this.c=new u,this.c.segment=y.value());const g=[];for(o=this.c;;){const b=y.cmp(o.segment);if(b>0)o.left||(o.left=new u,o.left.segment=y.value()),g.push([-1,o]),o=o.left;else if(b<0)o.right||(o.right=new u,o.right.segment=y.value()),g.push([1,o]),o=o.right;else if(y.hasNext())y.next(),o.mid||(o.mid=new u,o.mid.segment=y.value()),g.push([0,o]),o=o.mid;else break}const c=o.value;o.value=v,o.key=h;for(let b=g.length-1;b>=0;b--){const k=g[b][1];k.updateHeight();const w=k.balanceFactor();if(w<-1||w>1){const t=g[b][0],l=g[b+1][0];if(t===1&&l===1)g[b][1]=k.rotateLeft();else if(t===-1&&l===-1)g[b][1]=k.rotateRight();else if(t===1&&l===-1)k.right=g[b+1][1]=g[b+1][1].rotateRight(),g[b][1]=k.rotateLeft();else if(t===-1&&l===1)k.left=g[b+1][1]=g[b+1][1].rotateLeft(),g[b][1]=k.rotateRight();else throw new Error;if(b>0)switch(g[b-1][0]){case-1:g[b-1][1].left=g[b][1];break;case 1:g[b-1][1].right=g[b][1];break;case 0:g[b-1][1].mid=g[b][1];break}else this.c=g[0][1]}}return c}get(h){return this.d(h)?.value}d(h){const v=this.b.reset(h);let y=this.c;for(;y;){const o=v.cmp(y.segment);if(o>0)y=y.left;else if(o<0)y=y.right;else if(v.hasNext())v.next(),y=y.mid;else break}return y}has(h){const v=this.d(h);return!(v?.value===void 0&&v?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,v){const y=this.b.reset(h),o=[];let g=this.c;for(;g;){const c=y.cmp(g.segment);if(c>0)o.push([-1,g]),g=g.left;else if(c<0)o.push([1,g]),g=g.right;else if(y.hasNext())y.next(),o.push([0,g]),g=g.mid;else break}if(g){if(v?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const c=this.f(g.right);if(c.key){const{key:b,value:k,segment:w}=c;this.e(c.key,!1),g.key=b,g.value=k,g.segment=w}}else{const c=g.left??g.right;if(o.length>0){const[b,k]=o[o.length-1];switch(b){case-1:k.left=c;break;case 0:k.mid=c;break;case 1:k.right=c;break}}else this.c=c}for(let c=o.length-1;c>=0;c--){const b=o[c][1];b.updateHeight();const k=b.balanceFactor();if(k>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),o[c][1]=b.rotateLeft()):k<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),o[c][1]=b.rotateRight()),c>0)switch(o[c-1][0]){case-1:o[c-1][1].left=o[c][1];break;case 1:o[c-1][1].right=o[c][1];break;case 0:o[c-1][1].mid=o[c][1];break}else this.c=o[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const v=this.b.reset(h);let y=this.c,o;for(;y;){const g=v.cmp(y.segment);if(g>0)y=y.left;else if(g<0)y=y.right;else if(v.hasNext())v.next(),o=y.value||o,y=y.mid;else break}return y&&y.value||o}findSuperstr(h){return this.g(h,!1)}g(h,v){const y=this.b.reset(h);let o=this.c;for(;o;){const g=y.cmp(o.segment);if(g>0)o=o.left;else if(g<0)o=o.right;else if(y.hasNext())y.next(),o=o.mid;else return o.mid?this.h(o.mid):v?o.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[v,y]of this)h(y,v)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const v=[];return this.j(h,v),v[Symbol.iterator]()}j(h,v){h&&(h.left&&this.j(h.left,v),h.value&&v.push([h.key,h.value]),h.mid&&this.j(h.mid,v),h.right&&this.j(h.right,v))}_isBalanced(){const h=v=>{if(!v)return!0;const y=v.balanceFactor();return y<-1||y>1?!1:h(v.left)&&h(v.right)};return h(this.c)}}e.$th=d}),define(te[10],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;function E(l){return typeof l=="string"}e.$ie=E;function C(l){return Array.isArray(l)&&l.every(s=>E(s))}e.$je=C;function r(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.$ke=r;function M(l){const s=Object.getPrototypeOf(Uint8Array);return typeof l=="object"&&l instanceof s}e.$le=M;function R(l){return typeof l=="number"&&!isNaN(l)}e.$me=R;function S(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.$ne=S;function f(l){return l===!0||l===!1}e.$oe=f;function u(l){return typeof l>"u"}e.$pe=u;function $(l){return!d(l)}e.$qe=$;function d(l){return u(l)||l===null}e.$re=d;function p(l,s){if(!l)throw new Error(s?`Unexpected type, expected '${s}'`:"Unexpected type")}e.$se=p;function h(l){if(d(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.$te=h;function v(...l){const s=[];for(let n=0;n<l.length;n++){const i=l[n];if(d(i))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);s.push(i)}return s}e.$ue=v;const y=Object.prototype.hasOwnProperty;function o(l){if(!r(l))return!1;for(const s in l)if(y.call(l,s))return!1;return!0}e.$ve=o;function g(l){return typeof l=="function"}e.$we=g;function c(...l){return l.length>0&&l.every(g)}e.$xe=c;function b(l,s){const n=Math.min(l.length,s.length);for(let i=0;i<n;i++)k(l[i],s[i])}e.$ye=b;function k(l,s){if(E(s)){if(typeof l!==s)throw new Error(`argument does not match constraint: typeof ${s}`)}else if(g(s)){try{if(l instanceof s)return}catch{}if(!d(l)&&l.constructor===s||s.length===1&&s.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$ze=k;function w(l){return l===null?void 0:l}e.$Ae=w;function t(l){return typeof l>"u"?null:l}e.$Be=t}),define(te[71],ie([0,1,10]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=void 0;const C=Object.create(null);function r(S,f){if((0,E.$ie)(f)){const u=C[f];if(u===void 0)throw new Error(`${S} references an unknown codicon: ${f}`);f=u}return C[S]=f,{id:S}}function M(){return C}e.$yj=M;function R(){return Object.values(e.$Aj)}e.$zj=R,e.$Aj={add:r("add",6e4),plus:r("plus",6e4),gistNew:r("gist-new",6e4),repoCreate:r("repo-create",6e4),lightbulb:r("lightbulb",60001),lightBulb:r("light-bulb",60001),repo:r("repo",60002),repoDelete:r("repo-delete",60002),gistFork:r("gist-fork",60003),repoForked:r("repo-forked",60003),gitPullRequest:r("git-pull-request",60004),gitPullRequestAbandoned:r("git-pull-request-abandoned",60004),recordKeys:r("record-keys",60005),keyboard:r("keyboard",60005),tag:r("tag",60006),tagAdd:r("tag-add",60006),tagRemove:r("tag-remove",60006),person:r("person",60007),personFollow:r("person-follow",60007),personOutline:r("person-outline",60007),personFilled:r("person-filled",60007),gitBranch:r("git-branch",60008),gitBranchCreate:r("git-branch-create",60008),gitBranchDelete:r("git-branch-delete",60008),sourceControl:r("source-control",60008),mirror:r("mirror",60009),mirrorPublic:r("mirror-public",60009),star:r("star",60010),starAdd:r("star-add",60010),starDelete:r("star-delete",60010),starEmpty:r("star-empty",60010),comment:r("comment",60011),commentAdd:r("comment-add",60011),alert:r("alert",60012),warning:r("warning",60012),search:r("search",60013),searchSave:r("search-save",60013),logOut:r("log-out",60014),signOut:r("sign-out",60014),logIn:r("log-in",60015),signIn:r("sign-in",60015),eye:r("eye",60016),eyeUnwatch:r("eye-unwatch",60016),eyeWatch:r("eye-watch",60016),circleFilled:r("circle-filled",60017),primitiveDot:r("primitive-dot",60017),closeDirty:r("close-dirty",60017),debugBreakpoint:r("debug-breakpoint",60017),debugBreakpointDisabled:r("debug-breakpoint-disabled",60017),debugHint:r("debug-hint",60017),primitiveSquare:r("primitive-square",60018),edit:r("edit",60019),pencil:r("pencil",60019),info:r("info",60020),issueOpened:r("issue-opened",60020),gistPrivate:r("gist-private",60021),gitForkPrivate:r("git-fork-private",60021),lock:r("lock",60021),mirrorPrivate:r("mirror-private",60021),close:r("close",60022),removeClose:r("remove-close",60022),x:r("x",60022),repoSync:r("repo-sync",60023),sync:r("sync",60023),clone:r("clone",60024),desktopDownload:r("desktop-download",60024),beaker:r("beaker",60025),microscope:r("microscope",60025),vm:r("vm",60026),deviceDesktop:r("device-desktop",60026),file:r("file",60027),fileText:r("file-text",60027),more:r("more",60028),ellipsis:r("ellipsis",60028),kebabHorizontal:r("kebab-horizontal",60028),mailReply:r("mail-reply",60029),reply:r("reply",60029),organization:r("organization",60030),organizationFilled:r("organization-filled",60030),organizationOutline:r("organization-outline",60030),newFile:r("new-file",60031),fileAdd:r("file-add",60031),newFolder:r("new-folder",60032),fileDirectoryCreate:r("file-directory-create",60032),trash:r("trash",60033),trashcan:r("trashcan",60033),history:r("history",60034),clock:r("clock",60034),folder:r("folder",60035),fileDirectory:r("file-directory",60035),symbolFolder:r("symbol-folder",60035),logoGithub:r("logo-github",60036),markGithub:r("mark-github",60036),github:r("github",60036),terminal:r("terminal",60037),console:r("console",60037),repl:r("repl",60037),zap:r("zap",60038),symbolEvent:r("symbol-event",60038),error:r("error",60039),stop:r("stop",60039),variable:r("variable",60040),symbolVariable:r("symbol-variable",60040),array:r("array",60042),symbolArray:r("symbol-array",60042),symbolModule:r("symbol-module",60043),symbolPackage:r("symbol-package",60043),symbolNamespace:r("symbol-namespace",60043),symbolObject:r("symbol-object",60043),symbolMethod:r("symbol-method",60044),symbolFunction:r("symbol-function",60044),symbolConstructor:r("symbol-constructor",60044),symbolBoolean:r("symbol-boolean",60047),symbolNull:r("symbol-null",60047),symbolNumeric:r("symbol-numeric",60048),symbolNumber:r("symbol-number",60048),symbolStructure:r("symbol-structure",60049),symbolStruct:r("symbol-struct",60049),symbolParameter:r("symbol-parameter",60050),symbolTypeParameter:r("symbol-type-parameter",60050),symbolKey:r("symbol-key",60051),symbolText:r("symbol-text",60051),symbolReference:r("symbol-reference",60052),goToFile:r("go-to-file",60052),symbolEnum:r("symbol-enum",60053),symbolValue:r("symbol-value",60053),symbolRuler:r("symbol-ruler",60054),symbolUnit:r("symbol-unit",60054),activateBreakpoints:r("activate-breakpoints",60055),archive:r("archive",60056),arrowBoth:r("arrow-both",60057),arrowDown:r("arrow-down",60058),arrowLeft:r("arrow-left",60059),arrowRight:r("arrow-right",60060),arrowSmallDown:r("arrow-small-down",60061),arrowSmallLeft:r("arrow-small-left",60062),arrowSmallRight:r("arrow-small-right",60063),arrowSmallUp:r("arrow-small-up",60064),arrowUp:r("arrow-up",60065),bell:r("bell",60066),bold:r("bold",60067),book:r("book",60068),bookmark:r("bookmark",60069),debugBreakpointConditionalUnverified:r("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:r("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:r("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:r("debug-breakpoint-data-unverified",60072),debugBreakpointData:r("debug-breakpoint-data",60073),debugBreakpointDataDisabled:r("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:r("debug-breakpoint-log-unverified",60074),debugBreakpointLog:r("debug-breakpoint-log",60075),debugBreakpointLogDisabled:r("debug-breakpoint-log-disabled",60075),briefcase:r("briefcase",60076),broadcast:r("broadcast",60077),browser:r("browser",60078),bug:r("bug",60079),calendar:r("calendar",60080),caseSensitive:r("case-sensitive",60081),check:r("check",60082),checklist:r("checklist",60083),chevronDown:r("chevron-down",60084),dropDownButton:r("drop-down-button",60084),chevronLeft:r("chevron-left",60085),chevronRight:r("chevron-right",60086),chevronUp:r("chevron-up",60087),chromeClose:r("chrome-close",60088),chromeMaximize:r("chrome-maximize",60089),chromeMinimize:r("chrome-minimize",60090),chromeRestore:r("chrome-restore",60091),circle:r("circle",60092),circleOutline:r("circle-outline",60092),debugBreakpointUnverified:r("debug-breakpoint-unverified",60092),circleSlash:r("circle-slash",60093),circuitBoard:r("circuit-board",60094),clearAll:r("clear-all",60095),clippy:r("clippy",60096),closeAll:r("close-all",60097),cloudDownload:r("cloud-download",60098),cloudUpload:r("cloud-upload",60099),code:r("code",60100),collapseAll:r("collapse-all",60101),colorMode:r("color-mode",60102),commentDiscussion:r("comment-discussion",60103),compareChanges:r("compare-changes",60157),creditCard:r("credit-card",60105),dash:r("dash",60108),dashboard:r("dashboard",60109),database:r("database",60110),debugContinue:r("debug-continue",60111),debugDisconnect:r("debug-disconnect",60112),debugPause:r("debug-pause",60113),debugRestart:r("debug-restart",60114),debugStart:r("debug-start",60115),debugStepInto:r("debug-step-into",60116),debugStepOut:r("debug-step-out",60117),debugStepOver:r("debug-step-over",60118),debugStop:r("debug-stop",60119),debug:r("debug",60120),deviceCameraVideo:r("device-camera-video",60121),deviceCamera:r("device-camera",60122),deviceMobile:r("device-mobile",60123),diffAdded:r("diff-added",60124),diffIgnored:r("diff-ignored",60125),diffModified:r("diff-modified",60126),diffRemoved:r("diff-removed",60127),diffRenamed:r("diff-renamed",60128),diff:r("diff",60129),discard:r("discard",60130),editorLayout:r("editor-layout",60131),emptyWindow:r("empty-window",60132),exclude:r("exclude",60133),extensions:r("extensions",60134),eyeClosed:r("eye-closed",60135),fileBinary:r("file-binary",60136),fileCode:r("file-code",60137),fileMedia:r("file-media",60138),filePdf:r("file-pdf",60139),fileSubmodule:r("file-submodule",60140),fileSymlinkDirectory:r("file-symlink-directory",60141),fileSymlinkFile:r("file-symlink-file",60142),fileZip:r("file-zip",60143),files:r("files",60144),filter:r("filter",60145),flame:r("flame",60146),foldDown:r("fold-down",60147),foldUp:r("fold-up",60148),fold:r("fold",60149),folderActive:r("folder-active",60150),folderOpened:r("folder-opened",60151),gear:r("gear",60152),gift:r("gift",60153),gistSecret:r("gist-secret",60154),gist:r("gist",60155),gitCommit:r("git-commit",60156),gitCompare:r("git-compare",60157),gitMerge:r("git-merge",60158),githubAction:r("github-action",60159),githubAlt:r("github-alt",60160),globe:r("globe",60161),grabber:r("grabber",60162),graph:r("graph",60163),gripper:r("gripper",60164),heart:r("heart",60165),home:r("home",60166),horizontalRule:r("horizontal-rule",60167),hubot:r("hubot",60168),inbox:r("inbox",60169),issueClosed:r("issue-closed",60324),issueReopened:r("issue-reopened",60171),issues:r("issues",60172),italic:r("italic",60173),jersey:r("jersey",60174),json:r("json",60175),bracket:r("bracket",60175),kebabVertical:r("kebab-vertical",60176),key:r("key",60177),law:r("law",60178),lightbulbAutofix:r("lightbulb-autofix",60179),linkExternal:r("link-external",60180),link:r("link",60181),listOrdered:r("list-ordered",60182),listUnordered:r("list-unordered",60183),liveShare:r("live-share",60184),loading:r("loading",60185),location:r("location",60186),mailRead:r("mail-read",60187),mail:r("mail",60188),markdown:r("markdown",60189),megaphone:r("megaphone",60190),mention:r("mention",60191),milestone:r("milestone",60192),mortarBoard:r("mortar-board",60193),move:r("move",60194),multipleWindows:r("multiple-windows",60195),mute:r("mute",60196),noNewline:r("no-newline",60197),note:r("note",60198),octoface:r("octoface",60199),openPreview:r("open-preview",60200),package_:r("package",60201),paintcan:r("paintcan",60202),pin:r("pin",60203),play:r("play",60204),run:r("run",60204),plug:r("plug",60205),preserveCase:r("preserve-case",60206),preview:r("preview",60207),project:r("project",60208),pulse:r("pulse",60209),question:r("question",60210),quote:r("quote",60211),radioTower:r("radio-tower",60212),reactions:r("reactions",60213),references:r("references",60214),refresh:r("refresh",60215),regex:r("regex",60216),remoteExplorer:r("remote-explorer",60217),remote:r("remote",60218),remove:r("remove",60219),replaceAll:r("replace-all",60220),replace:r("replace",60221),repoClone:r("repo-clone",60222),repoForcePush:r("repo-force-push",60223),repoPull:r("repo-pull",60224),repoPush:r("repo-push",60225),report:r("report",60226),requestChanges:r("request-changes",60227),rocket:r("rocket",60228),rootFolderOpened:r("root-folder-opened",60229),rootFolder:r("root-folder",60230),rss:r("rss",60231),ruby:r("ruby",60232),saveAll:r("save-all",60233),saveAs:r("save-as",60234),save:r("save",60235),screenFull:r("screen-full",60236),screenNormal:r("screen-normal",60237),searchStop:r("search-stop",60238),server:r("server",60240),settingsGear:r("settings-gear",60241),settings:r("settings",60242),shield:r("shield",60243),smiley:r("smiley",60244),sortPrecedence:r("sort-precedence",60245),splitHorizontal:r("split-horizontal",60246),splitVertical:r("split-vertical",60247),squirrel:r("squirrel",60248),starFull:r("star-full",60249),starHalf:r("star-half",60250),symbolClass:r("symbol-class",60251),symbolColor:r("symbol-color",60252),symbolCustomColor:r("symbol-customcolor",60252),symbolConstant:r("symbol-constant",60253),symbolEnumMember:r("symbol-enum-member",60254),symbolField:r("symbol-field",60255),symbolFile:r("symbol-file",60256),symbolInterface:r("symbol-interface",60257),symbolKeyword:r("symbol-keyword",60258),symbolMisc:r("symbol-misc",60259),symbolOperator:r("symbol-operator",60260),symbolProperty:r("symbol-property",60261),wrench:r("wrench",60261),wrenchSubaction:r("wrench-subaction",60261),symbolSnippet:r("symbol-snippet",60262),tasklist:r("tasklist",60263),telescope:r("telescope",60264),textSize:r("text-size",60265),threeBars:r("three-bars",60266),thumbsdown:r("thumbsdown",60267),thumbsup:r("thumbsup",60268),tools:r("tools",60269),triangleDown:r("triangle-down",60270),triangleLeft:r("triangle-left",60271),triangleRight:r("triangle-right",60272),triangleUp:r("triangle-up",60273),twitter:r("twitter",60274),unfold:r("unfold",60275),unlock:r("unlock",60276),unmute:r("unmute",60277),unverified:r("unverified",60278),verified:r("verified",60279),versions:r("versions",60280),vmActive:r("vm-active",60281),vmOutline:r("vm-outline",60282),vmRunning:r("vm-running",60283),watch:r("watch",60284),whitespace:r("whitespace",60285),wholeWord:r("whole-word",60286),window:r("window",60287),wordWrap:r("word-wrap",60288),zoomIn:r("zoom-in",60289),zoomOut:r("zoom-out",60290),listFilter:r("list-filter",60291),listFlat:r("list-flat",60292),listSelection:r("list-selection",60293),selection:r("selection",60293),listTree:r("list-tree",60294),debugBreakpointFunctionUnverified:r("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:r("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:r("debug-breakpoint-function-disabled",60296),debugStackframeActive:r("debug-stackframe-active",60297),circleSmallFilled:r("circle-small-filled",60298),debugStackframeDot:r("debug-stackframe-dot",60298),debugStackframe:r("debug-stackframe",60299),debugStackframeFocused:r("debug-stackframe-focused",60299),debugBreakpointUnsupported:r("debug-breakpoint-unsupported",60300),symbolString:r("symbol-string",60301),debugReverseContinue:r("debug-reverse-continue",60302),debugStepBack:r("debug-step-back",60303),debugRestartFrame:r("debug-restart-frame",60304),callIncoming:r("call-incoming",60306),callOutgoing:r("call-outgoing",60307),menu:r("menu",60308),expandAll:r("expand-all",60309),feedback:r("feedback",60310),groupByRefType:r("group-by-ref-type",60311),ungroupByRefType:r("ungroup-by-ref-type",60312),account:r("account",60313),bellDot:r("bell-dot",60314),debugConsole:r("debug-console",60315),library:r("library",60316),output:r("output",60317),runAll:r("run-all",60318),syncIgnored:r("sync-ignored",60319),pinned:r("pinned",60320),githubInverted:r("github-inverted",60321),debugAlt:r("debug-alt",60305),serverProcess:r("server-process",60322),serverEnvironment:r("server-environment",60323),pass:r("pass",60324),stopCircle:r("stop-circle",60325),playCircle:r("play-circle",60326),record:r("record",60327),debugAltSmall:r("debug-alt-small",60328),vmConnect:r("vm-connect",60329),cloud:r("cloud",60330),merge:r("merge",60331),exportIcon:r("export",60332),graphLeft:r("graph-left",60333),magnet:r("magnet",60334),notebook:r("notebook",60335),redo:r("redo",60336),checkAll:r("check-all",60337),pinnedDirty:r("pinned-dirty",60338),passFilled:r("pass-filled",60339),circleLargeFilled:r("circle-large-filled",60340),circleLarge:r("circle-large",60341),circleLargeOutline:r("circle-large-outline",60341),combine:r("combine",60342),gather:r("gather",60342),table:r("table",60343),variableGroup:r("variable-group",60344),typeHierarchy:r("type-hierarchy",60345),typeHierarchySub:r("type-hierarchy-sub",60346),typeHierarchySuper:r("type-hierarchy-super",60347),gitPullRequestCreate:r("git-pull-request-create",60348),runAbove:r("run-above",60349),runBelow:r("run-below",60350),notebookTemplate:r("notebook-template",60351),debugRerun:r("debug-rerun",60352),workspaceTrusted:r("workspace-trusted",60353),workspaceUntrusted:r("workspace-untrusted",60354),workspaceUnspecified:r("workspace-unspecified",60355),terminalCmd:r("terminal-cmd",60356),terminalDebian:r("terminal-debian",60357),terminalLinux:r("terminal-linux",60358),terminalPowershell:r("terminal-powershell",60359),terminalTmux:r("terminal-tmux",60360),terminalUbuntu:r("terminal-ubuntu",60361),terminalBash:r("terminal-bash",60362),arrowSwap:r("arrow-swap",60363),copy:r("copy",60364),personAdd:r("person-add",60365),filterFilled:r("filter-filled",60366),wand:r("wand",60367),debugLineByLine:r("debug-line-by-line",60368),inspect:r("inspect",60369),layers:r("layers",60370),layersDot:r("layers-dot",60371),layersActive:r("layers-active",60372),compass:r("compass",60373),compassDot:r("compass-dot",60374),compassActive:r("compass-active",60375),azure:r("azure",60376),issueDraft:r("issue-draft",60377),gitPullRequestClosed:r("git-pull-request-closed",60378),gitPullRequestDraft:r("git-pull-request-draft",60379),debugAll:r("debug-all",60380),debugCoverage:r("debug-coverage",60381),runErrors:r("run-errors",60382),folderLibrary:r("folder-library",60383),debugContinueSmall:r("debug-continue-small",60384),beakerStop:r("beaker-stop",60385),graphLine:r("graph-line",60386),graphScatter:r("graph-scatter",60387),pieChart:r("pie-chart",60388),bracketDot:r("bracket-dot",60389),bracketError:r("bracket-error",60390),lockSmall:r("lock-small",60391),azureDevops:r("azure-devops",60392),verifiedFilled:r("verified-filled",60393),newLine:r("newline",60394),layout:r("layout",60395),layoutActivitybarLeft:r("layout-activitybar-left",60396),layoutActivitybarRight:r("layout-activitybar-right",60397),layoutPanelLeft:r("layout-panel-left",60398),layoutPanelCenter:r("layout-panel-center",60399),layoutPanelJustify:r("layout-panel-justify",60400),layoutPanelRight:r("layout-panel-right",60401),layoutPanel:r("layout-panel",60402),layoutSidebarLeft:r("layout-sidebar-left",60403),layoutSidebarRight:r("layout-sidebar-right",60404),layoutStatusbar:r("layout-statusbar",60405),layoutMenubar:r("layout-menubar",60406),layoutCentered:r("layout-centered",60407),layoutSidebarRightOff:r("layout-sidebar-right-off",60416),layoutPanelOff:r("layout-panel-off",60417),layoutSidebarLeftOff:r("layout-sidebar-left-off",60418),target:r("target",60408),indent:r("indent",60409),recordSmall:r("record-small",60410),errorSmall:r("error-small",60411),arrowCircleDown:r("arrow-circle-down",60412),arrowCircleLeft:r("arrow-circle-left",60413),arrowCircleRight:r("arrow-circle-right",60414),arrowCircleUp:r("arrow-circle-up",60415),heartFilled:r("heart-filled",60420),map:r("map",60421),mapFilled:r("map-filled",60422),circleSmall:r("circle-small",60423),bellSlash:r("bell-slash",60424),bellSlashDot:r("bell-slash-dot",60425),commentUnresolved:r("comment-unresolved",60426),gitPullRequestGoToChanges:r("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:r("git-pull-request-new-changes",60428),searchFuzzy:r("search-fuzzy",60429),commentDraft:r("comment-draft",60430),send:r("send",60431),sparkle:r("sparkle",60432),insert:r("insert",60433),dialogError:r("dialog-error","error"),dialogWarning:r("dialog-warning","warning"),dialogInfo:r("dialog-info","info"),dialogClose:r("dialog-close","close"),treeItemExpanded:r("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:r("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:r("tree-filter-on-type-off","list-selection"),treeFilterClear:r("tree-filter-clear","close"),treeItemLoading:r("tree-item-loading","loading"),menuSelection:r("menu-selection","check"),menuSubmenu:r("menu-submenu","chevron-right"),menuBarMore:r("menubar-more","more"),scrollbarButtonLeft:r("scrollbar-button-left","triangle-left"),scrollbarButtonRight:r("scrollbar-button-right","triangle-right"),scrollbarButtonUp:r("scrollbar-button-up","triangle-up"),scrollbarButtonDown:r("scrollbar-button-down","triangle-down"),toolBarMore:r("toolbar-more","more"),quickInputBack:r("quick-input-back","arrow-left")}}),define(te[37],ie([0,1,10]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0;function C(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const c=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([b,k])=>{c[b]=k&&typeof k=="object"?C(k):k}),c}e.$Fm=C;function r(g){if(!g||typeof g!="object")return g;const c=[g];for(;c.length>0;){const b=c.shift();Object.freeze(b);for(const k in b)if(M.call(b,k)){const w=b[k];typeof w=="object"&&!Object.isFrozen(w)&&!(0,E.$le)(w)&&c.push(w)}}return g}e.$Gm=r;const M=Object.prototype.hasOwnProperty;function R(g,c){return S(g,c,new Set)}e.$Hm=R;function S(g,c,b){if((0,E.$re)(g))return g;const k=c(g);if(typeof k<"u")return k;if(Array.isArray(g)){const w=[];for(const t of g)w.push(S(t,c,b));return w}if((0,E.$ke)(g)){if(b.has(g))throw new Error("Cannot clone recursive data-structure");b.add(g);const w={};for(const t in g)M.call(g,t)&&(w[t]=S(g[t],c,b));return b.delete(g),w}return g}function f(g,c,b=!0){return(0,E.$ke)(g)?((0,E.$ke)(c)&&Object.keys(c).forEach(k=>{k in g?b&&((0,E.$ke)(g[k])&&(0,E.$ke)(c[k])?f(g[k],c[k],b):g[k]=c[k]):g[k]=c[k]}),g):c}e.$Im=f;function u(g,c){if(g===c)return!0;if(g==null||c===null||c===void 0||typeof g!=typeof c||typeof g!="object"||Array.isArray(g)!==Array.isArray(c))return!1;let b,k;if(Array.isArray(g)){if(g.length!==c.length)return!1;for(b=0;b<g.length;b++)if(!u(g[b],c[b]))return!1}else{const w=[];for(k in g)w.push(k);w.sort();const t=[];for(k in c)t.push(k);if(t.sort(),!u(w,t))return!1;for(b=0;b<w.length;b++)if(!u(g[w[b]],c[w[b]]))return!1}return!0}e.$Jm=u;function $(g){const c=new Set;return JSON.stringify(g,(b,k)=>{if((0,E.$ke)(k)||Array.isArray(k)){if(c.has(k))return"[Circular]";c.add(k)}return k})}e.$Km=$;function d(g,c){const b=Object.create(null);return!g||!c||Object.keys(c).forEach(w=>{const t=g[w],l=c[w];u(t,l)||(b[w]=l)}),b}e.$Lm=d;function p(g,c){const b=c.toLowerCase(),k=Object.keys(g).find(w=>w.toLowerCase()===b);return k?g[k]:g[c]}e.$Mm=p;function h(g,c){const b=Object.create(null);for(const[k,w]of Object.entries(g))c(k,w)&&(b[k]=w);return b}e.$Nm=h;function v(g){let c=[];for(;Object.prototype!==g;)c=c.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return c}e.$Om=v;function y(g){const c=[];for(const b of v(g))typeof g[b]=="function"&&c.push(b);return c}e.$Pm=y;function o(g,c){const b=w=>function(){const t=Array.prototype.slice.call(arguments,0);return c(w,t)},k={};for(const w of g)k[w]=b(w);return k}e.$Qm=o}),define(te[102],ie([0,1,71]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Bj=e.ThemeColor=void 0;var C;(function(R){function S(f){return f&&typeof f=="object"&&typeof f.id=="string"}R.isThemeColor=S})(C||(e.ThemeColor=C={}));function r(R){return{id:R}}e.$Bj=r;var M;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function f(c){const b=S.exec(c.id);if(!b)return f(E.$Aj.error);const[,k,w]=b,t=["codicon","codicon-"+k];return w&&t.push("codicon-modifier-"+w.substring(1)),t}R.asClassNameArray=f;function u(c){return f(c).join(" ")}R.asClassName=u;function $(c){return"."+f(c).join(".")}R.asCSSSelector=$;function d(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||C.isThemeColor(c.color))}R.isThemeIcon=d;const p=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function h(c){const b=p.exec(c);if(!b)return;const[,k]=b;return{id:k}}R.fromString=h;function v(c){return{id:c}}R.fromId=v;function y(c,b){let k=c.id;const w=k.lastIndexOf("~");return w!==-1&&(k=k.substring(0,w)),b&&(k=`${k}~${b}`),{id:k}}R.modify=y;function o(c){const b=c.id.lastIndexOf("~");if(b!==-1)return c.id.substring(b+1)}R.getModifier=o;function g(c,b){return c.id===b.id&&c.color?.id===b.color?.id}R.isEqual=g})(M||(e.ThemeIcon=M={}))}),define(te[31],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(r){return E.test(r)}e.$4e=C,e.$5e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let r;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?r=crypto.getRandomValues.bind(crypto):r=function(S){for(let f=0;f<S.length;f++)S[f]=Math.floor(Math.random()*256);return S};const M=new Uint8Array(16),R=[];for(let S=0;S<256;S++)R.push(S.toString(16).padStart(2,"0"));return function(){r(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let f=0,u="";return u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u+="-",u+=R[M[f++]],u+=R[M[f++]],u+="-",u+=R[M[f++]],u+=R[M[f++]],u+="-",u+=R[M[f++]],u+=R[M[f++]],u+="-",u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u+=R[M[f++]],u}}()}),define(te[142],ie([0,1,72,42,49]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eS=void 0;async function M(R,S){if(await new Promise(($,d)=>{const p=C.createReadStream(R),h=E.createHash("sha1");p.pipe(h);const v=(0,r.$cb)((y,o)=>{p.removeAllListeners(),h.removeAllListeners(),y?d(y):$(o)});p.once("error",v),p.once("end",v),h.once("error",v),h.once("data",y=>v(void 0,y.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$eS=M}),define(te[143],ie([0,1,27]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=void 0;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function r(R){const S=R.replace(/\-/g,":").toLowerCase();return!C.has(S)}function M(){const R=(0,E.networkInterfaces)();for(const S in R){const f=R[S];if(f){for(const{mac:u}of f)if(r(u))return u}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$qm=M}),define(te[87],ie([0,1,27,58,31,143]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0,e.$rm=new class{c(u){return this.a||(this.a=C.$th.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(u)}value(){if(this.b===void 0){let u=0,$=0;const d=(0,E.networkInterfaces)();for(const p in d){const h=d[p];if(h)for(const{mac:v,internal:y}of h)y||($+=1,this.c(v.toUpperCase())&&(u+=1))}this.b=$>0?u/$:0}return this.b}};let R;async function S(u){return R||(R=(async()=>await f(u)||r.$5e())()),R}e.$sm=S;async function f(u){try{const $=await new Promise((p,h)=>{G(["crypto"],p,h)}),d=(0,M.$qm)();return $.createHash("sha256").update(d,"utf8").digest("hex")}catch($){u($);return}}}),define(te[103],ie([0,1,88]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9e=e.$8e=e.$7e=void 0;function C(S,f,u,$=1){let d=!1;return new Promise(p=>{const h=setTimeout(()=>{if(!d)return d=!0,p(0)},u);r(S,f,$,v=>{if(!d)return d=!0,clearTimeout(h),p(v)})})}e.$7e=C;function r(S,f,u,$){if(f===0)return $(0);const d=new E.Socket;d.once("connect",()=>(R(d),r(S+u,f-1,u,$))),d.once("data",()=>{}),d.once("error",p=>(R(d),p.code!=="ECONNREFUSED"?r(S+u,f-1,u,$):$(S))),d.connect(S,"127.0.0.1")}e.$8e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(S,f,u,$="127.0.0.1"){let d=!1,p,h=1;const v=E.createServer({pauseOnConnect:!0});function y(o,g){d||(d=!0,v.removeAllListeners(),v.close(),p&&clearTimeout(p),g(o))}return new Promise(o=>{p=setTimeout(()=>{y(0,o)},u),v.on("listening",()=>{y(S,o)}),v.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&h<f?(S++,h++,v.listen(S,$)):y(0,o)}),v.on("close",()=>{y(0,o)}),v.listen(S,$)})}e.$9e=M;function R(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(f){console.error(f)}}}),function(){function G(){function e(){return process.uncHostAllowlist}function E(f){const u=new Set;if(Array.isArray(f))for(const $ of f)typeof $=="string"&&u.add($);return Array.from(u)}function C(){const f=e();return f?Array.from(f):[]}function r(f){if(process.platform!=="win32")return;const u=e();if(u)if(typeof f=="string")u.add(f.toLowerCase());else for(const $ of E(f))r($)}function M(f){if(typeof f!="string")return;const u=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let $;for(const d of u){if(f.indexOf(d)!==0)continue;const h=f.indexOf("\\",d.length);if(h===-1)continue;const v=f.substring(d.length,h);if(v){$=v;break}}return $}function R(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:r,getUNCHost:M,disableUNCAccessRestrictions:R,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return G()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=G():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(te[144],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iS=e.$hS=void 0,e.$hS="vscode:contextmenu",e.$iS="vscode:onCloseContextMenu"}),define(te[145],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pS=void 0;class E{constructor(r,M){this.a=r,this.onMessage=M}send(r){try{this.a.send("vscode:message",r.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$pS=E}),define(te[38],ie([0,1,14,13]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jS=void 0;class r{constructor(){this.a=new WeakMap}on(R,S){const f=(u,...$)=>{this.b(R,u)&&S(u,...$)};return this.a.set(S,f),E.ipcMain.on(R,f),this}once(R,S){return E.ipcMain.once(R,(f,...u)=>{this.b(R,f)&&S(f,...u)}),this}handle(R,S){return E.ipcMain.handle(R,(f,...u)=>this.b(R,f)?S(f,...u):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return E.ipcMain.removeHandler(R),this}removeListener(R,S){const f=this.a.get(S);return f&&(E.ipcMain.removeListener(R,f),this.a.delete(S)),this}b(R,S){if(!R||!R.startsWith("vscode:"))return(0,C.$Y)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const f=S.senderFrame,u=f.url;if(!u)return!0;let $="unknown";try{$=new URL(u).host}catch{return(0,C.$Y)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${u}'.`),!1}return $!=="vscode-app"?((0,C.$Y)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${$}'.`),!1):f.parent!==null?((0,C.$Y)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${$}' is not a main frame.`),!1):!0}}e.$jS=new r}),define(te[146],ie([0,1,14,38,10,144]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kS=void 0;function R(){C.$jS.on(M.$hS,(f,u,$,d,p)=>{const h=S(f,d,$);h.popup({window:(0,r.$Ae)(E.BrowserWindow.fromWebContents(f.sender)),x:p?p.x:void 0,y:p?p.y:void 0,positioningItem:p?p.positioningItem:void 0,callback:()=>{h&&f.sender.send(M.$iS,u)}})})}e.$kS=R;function S(f,u,$){const d=new E.Menu;return $.forEach(p=>{let h;p.type==="separator"?h=new E.MenuItem({type:p.type}):Array.isArray(p.submenu)?h=new E.MenuItem({submenu:S(f,u,p.submenu),label:p.label}):h=new E.MenuItem({label:p.label,type:p.type,accelerator:p.accelerator,checked:p.checked,enabled:p.enabled,visible:p.visible,click:(v,y,o)=>f.sender.send(u,p.id,o)}),d.append(h)}),d}}),define(te[147],ie([12,11]),function(G,e){return G.create("vs/base/common/date",e)}),define(te[148],ie([0,1,147]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=void 0;const C=60,r=C*60,M=r*24,R=M*7,S=M*30,f=M*365;function u(d,p,h,v){typeof d!="number"&&(d=d.getTime());const y=Math.round((new Date().getTime()-d)/1e3);if(y<-30)return(0,E.localize)(0,null,u(new Date().getTime()+y*1e3,!1));if(!v&&y<30)return(0,E.localize)(1,null);let o;return y<C?(o=y,p?o===1?h?(0,E.localize)(2,null,o):(0,E.localize)(3,null,o):h?(0,E.localize)(4,null,o):(0,E.localize)(5,null,o):o===1?h?(0,E.localize)(6,null,o):(0,E.localize)(7,null,o):h?(0,E.localize)(8,null,o):(0,E.localize)(9,null,o)):y<r?(o=Math.floor(y/C),p?o===1?h?(0,E.localize)(10,null,o):(0,E.localize)(11,null,o):h?(0,E.localize)(12,null,o):(0,E.localize)(13,null,o):o===1?h?(0,E.localize)(14,null,o):(0,E.localize)(15,null,o):h?(0,E.localize)(16,null,o):(0,E.localize)(17,null,o)):y<M?(o=Math.floor(y/r),p?o===1?h?(0,E.localize)(18,null,o):(0,E.localize)(19,null,o):h?(0,E.localize)(20,null,o):(0,E.localize)(21,null,o):o===1?h?(0,E.localize)(22,null,o):(0,E.localize)(23,null,o):h?(0,E.localize)(24,null,o):(0,E.localize)(25,null,o)):y<R?(o=Math.floor(y/M),p?o===1?(0,E.localize)(26,null,o):(0,E.localize)(27,null,o):o===1?(0,E.localize)(28,null,o):(0,E.localize)(29,null,o)):y<S?(o=Math.floor(y/R),p?o===1?h?(0,E.localize)(30,null,o):(0,E.localize)(31,null,o):h?(0,E.localize)(32,null,o):(0,E.localize)(33,null,o):o===1?h?(0,E.localize)(34,null,o):(0,E.localize)(35,null,o):h?(0,E.localize)(36,null,o):(0,E.localize)(37,null,o)):y<f?(o=Math.floor(y/S),p?o===1?h?(0,E.localize)(38,null,o):(0,E.localize)(39,null,o):h?(0,E.localize)(40,null,o):(0,E.localize)(41,null,o):o===1?h?(0,E.localize)(42,null,o):(0,E.localize)(43,null,o):h?(0,E.localize)(44,null,o):(0,E.localize)(45,null,o)):(o=Math.floor(y/f),p?o===1?h?(0,E.localize)(46,null,o):(0,E.localize)(47,null,o):h?(0,E.localize)(48,null,o):(0,E.localize)(49,null,o):o===1?h?(0,E.localize)(50,null,o):(0,E.localize)(51,null,o):h?(0,E.localize)(52,null,o):(0,E.localize)(53,null,o))}e.$Pl=u;function $(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ql=$}),define(te[149],ie([12,11]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(te[50],ie([0,1,24,10,149]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=void 0;function M(d,p){return p&&(d.stack||d.stacktrace)?r.localize(0,null,S(d),R(d.stack)||R(d.stacktrace)):S(d)}function R(d){return Array.isArray(d)?d.join(`
`):d}function S(d){return d.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${d.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof d.code=="string"&&typeof d.errno=="number"&&typeof d.syscall=="string"?r.localize(1,null,d.message):d.message||r.localize(2,null)}function f(d=null,p=!1){if(!d)return r.localize(3,null);if(Array.isArray(d)){const h=E.$lf(d),v=f(h[0],p);return h.length>1?r.localize(4,null,v,h.length):v}if(C.$ie(d))return d;if(d.detail){const h=d.detail;if(h.error)return M(h.error,p);if(h.exception)return M(h.exception,p)}return d.stack?M(d,p):d.message?d.message:r.localize(5,null)}e.$$h=f;function u(d){const p=d;return p instanceof Error&&Array.isArray(p.actions)}e.$_h=u;function $(d,p){let h;return typeof d=="string"?h=new Error(d):h=d,h.actions=p,h}e.$ai=$}),define(te[150],ie([12,11]),function(G,e){return G.create("vs/base/common/jsonErrorMessages",e)}),define(te[151],ie([0,1,150]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=void 0;function C(r){switch(r){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.$_o=C}),define(te[152],ie([12,11]),function(G,e){return G.create("vs/base/common/platform",e)}),define(te[4],ie([0,1,152]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let C=!1,r=!1,M=!1,R=!1,S=!1,f=!1,u=!1,$=!1,d=!1,p=!1,h,v=e.$f,y=e.$f,o,g;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?c=e.$g.vscode.process:typeof process<"u"&&(c=process);const b=typeof c?.versions?.electron=="string",k=b&&c?.type==="renderer";if(typeof navigator=="object"&&!k)g=navigator.userAgent,C=g.indexOf("Windows")>=0,r=g.indexOf("Macintosh")>=0,$=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=g.indexOf("Linux")>=0,p=g?.indexOf("Mobi")>=0,f=!0,h=E.getConfiguredDefaultLocale(E.localize(0,null))||e.$f,v=h,y=navigator.language;else if(typeof c=="object"){C=c.platform==="win32",r=c.platform==="darwin",M=c.platform==="linux",R=M&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,u=b,d=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$f,v=e.$f;const P=c.env.VSCODE_NLS_CONFIG;if(P)try{const I=JSON.parse(P),D=I.availableLanguages["*"];h=I.locale,y=I.osLocale,v=D||e.$f,o=I._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var w;(function(P){P[P.Web=0]="Web",P[P.Mac=1]="Mac",P[P.Linux=2]="Linux",P[P.Windows=3]="Windows"})(w||(e.Platform=w={}));function t(P){switch(P){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let l=0;r?l=1:C?l=3:M&&(l=2),e.$i=C,e.$j=r,e.$k=M,e.$l=R,e.$m=S,e.$n=u,e.$o=f,e.$p=f&&typeof e.$g.importScripts=="function",e.$q=$,e.$r=p,e.$s=d,e.$t=l,e.$u=g,e.$v=v;var s;(function(P){function I(){return e.$v}P.value=I;function D(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}P.isDefaultVariant=D;function O(){return e.$v==="en"}P.isDefault=O})(s||(e.Language=s={})),e.$w=h,e.$x=y,e.$y=o,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const P=[];e.$g.addEventListener("message",D=>{if(D.data&&D.data.vscodeScheduleAsyncWork)for(let O=0,L=P.length;O<L;O++){const N=P[O];if(N.id===D.data.vscodeScheduleAsyncWork){P.splice(O,1),N.callback();return}}});let I=0;return D=>{const O=++I;P.push({id:O,callback:D}),e.$g.postMessage({vscodeScheduleAsyncWork:O},"*")}}return P=>setTimeout(P)})();var n;(function(P){P[P.Windows=1]="Windows",P[P.Macintosh=2]="Macintosh",P[P.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=r||$?2:C?1:3;let i=!0,a=!1;function m(){if(!a){a=!0;const P=new Uint8Array(2);P[0]=1,P[1]=2,i=new Uint16Array(P.buffer)[0]===(2<<8)+1}return i}e.$C=m,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(te[36],ie([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8b=e.$7b=e.env=e.cwd=void 0;let C;if(typeof E.$g.vscode<"u"&&typeof E.$g.vscode.process<"u"){const r=E.$g.vscode.process;C={get platform(){return r.platform},get arch(){return r.arch},get env(){return r.env},cwd(){return r.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return E.$i?"win32":E.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$7b=C.platform,e.$8b=C.arch}),define(te[9],ie([0,1,36]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kc=e.sep=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=void 0;const C=65,r=97,M=90,R=122,S=46,f=47,u=92,$=58,d=63;class p extends Error{constructor(l,s,n){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const a=l.indexOf(".")!==-1?"property":"argument";let m=`The "${l}" ${a} ${i} of type ${s}`;m+=`. Received type ${typeof n}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,l){if(t===null||typeof t!="object")throw new p(l,"Object",t)}function v(t,l){if(typeof t!="string")throw new p(l,"string",t)}const y=E.$7b==="win32";function o(t){return t===f||t===u}function g(t){return t===f}function c(t){return t>=C&&t<=M||t>=r&&t<=R}function b(t,l,s,n){let i="",a=0,m=-1,P=0,I=0;for(let D=0;D<=t.length;++D){if(D<t.length)I=t.charCodeAt(D);else{if(n(I))break;I=f}if(n(I)){if(!(m===D-1||P===1))if(P===2){if(i.length<2||a!==2||i.charCodeAt(i.length-1)!==S||i.charCodeAt(i.length-2)!==S){if(i.length>2){const O=i.lastIndexOf(s);O===-1?(i="",a=0):(i=i.slice(0,O),a=i.length-1-i.lastIndexOf(s)),m=D,P=0;continue}else if(i.length!==0){i="",a=0,m=D,P=0;continue}}l&&(i+=i.length>0?`${s}..`:"..",a=2)}else i.length>0?i+=`${s}${t.slice(m+1,D)}`:i=t.slice(m+1,D),a=D-m-1;m=D,P=0}else I===S&&P!==-1?++P:P=-1}return i}function k(t,l){h(l,"pathObject");const s=l.dir||l.root,n=l.base||`${l.name||""}${l.ext||""}`;return s?s===l.root?`${s}${n}`:`${s}${t}${n}`:n}e.$9b={resolve(...t){let l="",s="",n=!1;for(let i=t.length-1;i>=-1;i--){let a;if(i>=0){if(a=t[i],v(a,"path"),a.length===0)continue}else l.length===0?a=E.cwd():(a=E.env[`=${l}`]||E.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==l.toLowerCase()&&a.charCodeAt(2)===u)&&(a=`${l}\\`));const m=a.length;let P=0,I="",D=!1;const O=a.charCodeAt(0);if(m===1)o(O)&&(P=1,D=!0);else if(o(O))if(D=!0,o(a.charCodeAt(1))){let L=2,N=L;for(;L<m&&!o(a.charCodeAt(L));)L++;if(L<m&&L!==N){const q=a.slice(N,L);for(N=L;L<m&&o(a.charCodeAt(L));)L++;if(L<m&&L!==N){for(N=L;L<m&&!o(a.charCodeAt(L));)L++;(L===m||L!==N)&&(I=`\\\\${q}\\${a.slice(N,L)}`,P=L)}}}else P=1;else c(O)&&a.charCodeAt(1)===$&&(I=a.slice(0,2),P=2,m>2&&o(a.charCodeAt(2))&&(D=!0,P=3));if(I.length>0)if(l.length>0){if(I.toLowerCase()!==l.toLowerCase())continue}else l=I;if(n){if(l.length>0)break}else if(s=`${a.slice(P)}\\${s}`,n=D,D&&l.length>0)break}return s=b(s,!n,"\\",o),n?`${l}\\${s}`:`${l}${s}`||"."},normalize(t){v(t,"path");const l=t.length;if(l===0)return".";let s=0,n,i=!1;const a=t.charCodeAt(0);if(l===1)return g(a)?"\\":t;if(o(a))if(i=!0,o(t.charCodeAt(1))){let P=2,I=P;for(;P<l&&!o(t.charCodeAt(P));)P++;if(P<l&&P!==I){const D=t.slice(I,P);for(I=P;P<l&&o(t.charCodeAt(P));)P++;if(P<l&&P!==I){for(I=P;P<l&&!o(t.charCodeAt(P));)P++;if(P===l)return`\\\\${D}\\${t.slice(I)}\\`;P!==I&&(n=`\\\\${D}\\${t.slice(I,P)}`,s=P)}}}else s=1;else c(a)&&t.charCodeAt(1)===$&&(n=t.slice(0,2),s=2,l>2&&o(t.charCodeAt(2))&&(i=!0,s=3));let m=s<l?b(t.slice(s),!i,"\\",o):"";return m.length===0&&!i&&(m="."),m.length>0&&o(t.charCodeAt(l-1))&&(m+="\\"),n===void 0?i?`\\${m}`:m:i?`${n}\\${m}`:`${n}${m}`},isAbsolute(t){v(t,"path");const l=t.length;if(l===0)return!1;const s=t.charCodeAt(0);return o(s)||l>2&&c(s)&&t.charCodeAt(1)===$&&o(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let l,s;for(let a=0;a<t.length;++a){const m=t[a];v(m,"path"),m.length>0&&(l===void 0?l=s=m:l+=`\\${m}`)}if(l===void 0)return".";let n=!0,i=0;if(typeof s=="string"&&o(s.charCodeAt(0))){++i;const a=s.length;a>1&&o(s.charCodeAt(1))&&(++i,a>2&&(o(s.charCodeAt(2))?++i:n=!1))}if(n){for(;i<l.length&&o(l.charCodeAt(i));)i++;i>=2&&(l=`\\${l.slice(i)}`)}return e.$9b.normalize(l)},relative(t,l){if(v(t,"from"),v(l,"to"),t===l)return"";const s=e.$9b.resolve(t),n=e.$9b.resolve(l);if(s===n||(t=s.toLowerCase(),l=n.toLowerCase(),t===l))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===u;)i++;let a=t.length;for(;a-1>i&&t.charCodeAt(a-1)===u;)a--;const m=a-i;let P=0;for(;P<l.length&&l.charCodeAt(P)===u;)P++;let I=l.length;for(;I-1>P&&l.charCodeAt(I-1)===u;)I--;const D=I-P,O=m<D?m:D;let L=-1,N=0;for(;N<O;N++){const re=t.charCodeAt(i+N);if(re!==l.charCodeAt(P+N))break;re===u&&(L=N)}if(N!==O){if(L===-1)return n}else{if(D>O){if(l.charCodeAt(P+N)===u)return n.slice(P+N+1);if(N===2)return n.slice(P+N)}m>O&&(t.charCodeAt(i+N)===u?L=N:N===2&&(L=3)),L===-1&&(L=0)}let q="";for(N=i+L+1;N<=a;++N)(N===a||t.charCodeAt(N)===u)&&(q+=q.length===0?"..":"\\..");return P+=L,q.length>0?`${q}${n.slice(P,I)}`:(n.charCodeAt(P)===u&&++P,n.slice(P,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const l=e.$9b.resolve(t);if(l.length<=2)return t;if(l.charCodeAt(0)===u){if(l.charCodeAt(1)===u){const s=l.charCodeAt(2);if(s!==d&&s!==S)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(c(l.charCodeAt(0))&&l.charCodeAt(1)===$&&l.charCodeAt(2)===u)return`\\\\?\\${l}`;return t},dirname(t){v(t,"path");const l=t.length;if(l===0)return".";let s=-1,n=0;const i=t.charCodeAt(0);if(l===1)return o(i)?t:".";if(o(i)){if(s=n=1,o(t.charCodeAt(1))){let P=2,I=P;for(;P<l&&!o(t.charCodeAt(P));)P++;if(P<l&&P!==I){for(I=P;P<l&&o(t.charCodeAt(P));)P++;if(P<l&&P!==I){for(I=P;P<l&&!o(t.charCodeAt(P));)P++;if(P===l)return t;P!==I&&(s=n=P+1)}}}}else c(i)&&t.charCodeAt(1)===$&&(s=l>2&&o(t.charCodeAt(2))?3:2,n=s);let a=-1,m=!0;for(let P=l-1;P>=n;--P)if(o(t.charCodeAt(P))){if(!m){a=P;break}}else m=!1;if(a===-1){if(s===-1)return".";a=s}return t.slice(0,a)},basename(t,l){l!==void 0&&v(l,"ext"),v(t,"path");let s=0,n=-1,i=!0,a;if(t.length>=2&&c(t.charCodeAt(0))&&t.charCodeAt(1)===$&&(s=2),l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let m=l.length-1,P=-1;for(a=t.length-1;a>=s;--a){const I=t.charCodeAt(a);if(o(I)){if(!i){s=a+1;break}}else P===-1&&(i=!1,P=a+1),m>=0&&(I===l.charCodeAt(m)?--m===-1&&(n=a):(m=-1,n=P))}return s===n?n=P:n===-1&&(n=t.length),t.slice(s,n)}for(a=t.length-1;a>=s;--a)if(o(t.charCodeAt(a))){if(!i){s=a+1;break}}else n===-1&&(i=!1,n=a+1);return n===-1?"":t.slice(s,n)},extname(t){v(t,"path");let l=0,s=-1,n=0,i=-1,a=!0,m=0;t.length>=2&&t.charCodeAt(1)===$&&c(t.charCodeAt(0))&&(l=n=2);for(let P=t.length-1;P>=l;--P){const I=t.charCodeAt(P);if(o(I)){if(!a){n=P+1;break}continue}i===-1&&(a=!1,i=P+1),I===S?s===-1?s=P:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||i===-1||m===0||m===1&&s===i-1&&s===n+1?"":t.slice(s,i)},format:k.bind(null,"\\"),parse(t){v(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const s=t.length;let n=0,i=t.charCodeAt(0);if(s===1)return o(i)?(l.root=l.dir=t,l):(l.base=l.name=t,l);if(o(i)){if(n=1,o(t.charCodeAt(1))){let L=2,N=L;for(;L<s&&!o(t.charCodeAt(L));)L++;if(L<s&&L!==N){for(N=L;L<s&&o(t.charCodeAt(L));)L++;if(L<s&&L!==N){for(N=L;L<s&&!o(t.charCodeAt(L));)L++;L===s?n=L:L!==N&&(n=L+1)}}}}else if(c(i)&&t.charCodeAt(1)===$){if(s<=2)return l.root=l.dir=t,l;if(n=2,o(t.charCodeAt(2))){if(s===3)return l.root=l.dir=t,l;n=3}}n>0&&(l.root=t.slice(0,n));let a=-1,m=n,P=-1,I=!0,D=t.length-1,O=0;for(;D>=n;--D){if(i=t.charCodeAt(D),o(i)){if(!I){m=D+1;break}continue}P===-1&&(I=!1,P=D+1),i===S?a===-1?a=D:O!==1&&(O=1):a!==-1&&(O=-1)}return P!==-1&&(a===-1||O===0||O===1&&a===P-1&&a===m+1?l.base=l.name=t.slice(m,P):(l.name=t.slice(m,a),l.base=t.slice(m,P),l.ext=t.slice(a,P))),m>0&&m!==n?l.dir=t.slice(0,m-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null};const w=(()=>{if(y){const t=/\\/g;return()=>{const l=E.cwd().replace(t,"/");return l.slice(l.indexOf("/"))}}return()=>E.cwd()})();e.$0b={resolve(...t){let l="",s=!1;for(let n=t.length-1;n>=-1&&!s;n--){const i=n>=0?t[n]:w();v(i,"path"),i.length!==0&&(l=`${i}/${l}`,s=i.charCodeAt(0)===f)}return l=b(l,!s,"/",g),s?`/${l}`:l.length>0?l:"."},normalize(t){if(v(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f,s=t.charCodeAt(t.length-1)===f;return t=b(t,!l,"/",g),t.length===0?l?"/":s?"./":".":(s&&(t+="/"),l?`/${t}`:t)},isAbsolute(t){return v(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let l;for(let s=0;s<t.length;++s){const n=t[s];v(n,"path"),n.length>0&&(l===void 0?l=n:l+=`/${n}`)}return l===void 0?".":e.$0b.normalize(l)},relative(t,l){if(v(t,"from"),v(l,"to"),t===l||(t=e.$0b.resolve(t),l=e.$0b.resolve(l),t===l))return"";const s=1,n=t.length,i=n-s,a=1,m=l.length-a,P=i<m?i:m;let I=-1,D=0;for(;D<P;D++){const L=t.charCodeAt(s+D);if(L!==l.charCodeAt(a+D))break;L===f&&(I=D)}if(D===P)if(m>P){if(l.charCodeAt(a+D)===f)return l.slice(a+D+1);if(D===0)return l.slice(a+D)}else i>P&&(t.charCodeAt(s+D)===f?I=D:D===0&&(I=0));let O="";for(D=s+I+1;D<=n;++D)(D===n||t.charCodeAt(D)===f)&&(O+=O.length===0?"..":"/..");return`${O}${l.slice(a+I)}`},toNamespacedPath(t){return t},dirname(t){if(v(t,"path"),t.length===0)return".";const l=t.charCodeAt(0)===f;let s=-1,n=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===f){if(!n){s=i;break}}else n=!1;return s===-1?l?"/":".":l&&s===1?"//":t.slice(0,s)},basename(t,l){l!==void 0&&v(l,"ext"),v(t,"path");let s=0,n=-1,i=!0,a;if(l!==void 0&&l.length>0&&l.length<=t.length){if(l===t)return"";let m=l.length-1,P=-1;for(a=t.length-1;a>=0;--a){const I=t.charCodeAt(a);if(I===f){if(!i){s=a+1;break}}else P===-1&&(i=!1,P=a+1),m>=0&&(I===l.charCodeAt(m)?--m===-1&&(n=a):(m=-1,n=P))}return s===n?n=P:n===-1&&(n=t.length),t.slice(s,n)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===f){if(!i){s=a+1;break}}else n===-1&&(i=!1,n=a+1);return n===-1?"":t.slice(s,n)},extname(t){v(t,"path");let l=-1,s=0,n=-1,i=!0,a=0;for(let m=t.length-1;m>=0;--m){const P=t.charCodeAt(m);if(P===f){if(!i){s=m+1;break}continue}n===-1&&(i=!1,n=m+1),P===S?l===-1?l=m:a!==1&&(a=1):l!==-1&&(a=-1)}return l===-1||n===-1||a===0||a===1&&l===n-1&&l===s+1?"":t.slice(l,n)},format:k.bind(null,"/"),parse(t){v(t,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return l;const s=t.charCodeAt(0)===f;let n;s?(l.root="/",n=1):n=0;let i=-1,a=0,m=-1,P=!0,I=t.length-1,D=0;for(;I>=n;--I){const O=t.charCodeAt(I);if(O===f){if(!P){a=I+1;break}continue}m===-1&&(P=!1,m=I+1),O===S?i===-1?i=I:D!==1&&(D=1):i!==-1&&(D=-1)}if(m!==-1){const O=a===0&&s?1:a;i===-1||D===0||D===1&&i===m-1&&i===a+1?l.base=l.name=t.slice(O,m):(l.name=t.slice(O,i),l.base=t.slice(O,m),l.ext=t.slice(i,m))}return a>0?l.dir=t.slice(0,a-1):s&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.$0b.win32=e.$9b.win32=e.$9b,e.$0b.posix=e.$9b.posix=e.$0b,e.$$b=y?e.$9b.normalize:e.$0b.normalize,e.$_b=y?e.$9b.isAbsolute:e.$0b.isAbsolute,e.$ac=y?e.$9b.join:e.$0b.join,e.$bc=y?e.$9b.resolve:e.$0b.resolve,e.$cc=y?e.$9b.relative:e.$0b.relative,e.$dc=y?e.$9b.dirname:e.$0b.dirname,e.$ec=y?e.$9b.basename:e.$0b.basename,e.$fc=y?e.$9b.extname:e.$0b.extname,e.$gc=y?e.$9b.format:e.$0b.format,e.$hc=y?e.$9b.parse:e.$0b.parse,e.$ic=y?e.$9b.toNamespacedPath:e.$0b.toNamespacedPath,e.sep=y?e.$9b.sep:e.$0b.sep,e.$kc=y?e.$9b.delimiter:e.$0b.delimiter}),define(te[32],ie([0,1,9,4,25,10]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function R(a){return a===47||a===92}e.$Ce=R;function S(a){return a.replace(/[\\/]/g,E.$0b.sep)}e.$De=S;function f(a){return a.indexOf("/")===-1&&(a=S(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$Ee=f;function u(a,m=E.$0b.sep){if(!a)return"";const P=a.length,I=a.charCodeAt(0);if(R(I)){if(R(a.charCodeAt(1))&&!R(a.charCodeAt(2))){let O=3;const L=O;for(;O<P&&!R(a.charCodeAt(O));O++);if(L!==O&&!R(a.charCodeAt(O+1))){for(O+=1;O<P;O++)if(R(a.charCodeAt(O)))return a.slice(0,O+1).replace(/[\\/]/g,m)}}return m}else if(g(I)&&a.charCodeAt(1)===58)return R(a.charCodeAt(2))?a.slice(0,2)+m:a.slice(0,2);let D=a.indexOf("://");if(D!==-1){for(D+=3;D<P;D++)if(R(a.charCodeAt(D)))return a.slice(0,D+1)}return""}e.$Fe=u;function $(a){if(!C.$i||!a||a.length<5)return!1;let m=a.charCodeAt(0);if(m!==92||(m=a.charCodeAt(1),m!==92))return!1;let P=2;const I=P;for(;P<a.length&&(m=a.charCodeAt(P),m!==92);P++);return!(I===P||(m=a.charCodeAt(P+1),isNaN(m)||m===92))}e.$Ge=$;const d=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function v(a,m=C.$i){const P=m?d:p;return!(!a||a.length===0||/^\s+$/.test(a)||(P.lastIndex=0,P.test(a))||m&&h.test(a)||a==="."||a===".."||m&&a[a.length-1]==="."||m&&a.length!==a.trim().length||a.length>255)}e.$He=v;function y(a,m,P){const I=a===m;return!P||I?I:!a||!m?!1:(0,r.$Ld)(a,m)}e.$Ie=y;function o(a,m,P,I=E.sep){if(a===m)return!0;if(!a||!m||m.length>a.length)return!1;if(P){if(!(0,r.$Md)(a,m))return!1;if(m.length===a.length)return!0;let O=m.length;return m.charAt(m.length-1)===I&&O--,a.charAt(O)===I}return m.charAt(m.length-1)!==I&&(m+=I),a.indexOf(m)===0}e.$Je=o;function g(a){return a>=65&&a<=90||a>=97&&a<=122}e.$Ke=g;function c(a,m){return C.$i&&a.endsWith(":")&&(a+=E.sep),(0,E.$_b)(a)||(a=(0,E.$ac)(m,a)),a=(0,E.$$b)(a),C.$i?(a=(0,r.$sd)(a,E.sep),a.endsWith(":")&&(a+=E.sep)):(a=(0,r.$sd)(a,E.sep),a||(a=E.sep)),a}e.$Le=c;function b(a){const m=(0,E.$$b)(a);return C.$i?a.length>3?!1:k(m)&&(a.length===2||m.charCodeAt(2)===92):m===E.$0b.sep}e.$Me=b;function k(a,m=C.$i){return m?g(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$Ne=k;function w(a,m=C.$i){return k(a,m)?a[0]:void 0}e.$Oe=w;function t(a,m,P){return m.length>a.length?-1:a===m?0:(P&&(a=a.toLowerCase(),m=m.toLowerCase()),a.indexOf(m))}e.$Pe=t;function l(a){const m=a.split(":");let P,I,D;for(const O of m){const L=Number(O);(0,M.$me)(L)?I===void 0?I=L:D===void 0&&(D=L):P=P?[P,O].join(":"):O}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:I!==void 0?I:void 0,column:D!==void 0?D:I!==void 0?1:void 0}}e.$Qe=l;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(a,m,P=8){let I="";for(let O=0;O<P;O++){let L;O===0&&C.$i&&!m&&(P===3||P===4)?L=n:L=s,I+=L.charAt(Math.floor(Math.random()*L.length))}let D;return m?D=`${m}-${I}`:D=I,a?(0,E.$ac)(a,D):D}e.$Re=i}),define(te[73],ie([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.TerminateResponseCode=e.Source=void 0;var C;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(C||(e.Source=C={}));var r;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(r||(e.TerminateResponseCode=r={}));function M(S,...f){const u=f.reduce((p,h)=>(p[h]=!0,p),{}),$=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(p=>!u[p]).forEach(p=>{for(let h=0;h<$.length;h++)if(p.search($[h])!==-1){delete S[p];break}})}e.$dl=M;function R(S){S&&(delete S.DEBUG,E.$j&&delete S.DYLD_LIBRARY_PATH,E.$k&&delete S.LD_PRELOAD)}e.$el=R}),define(te[7],ie([0,1,9,4]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ue=e.$Te=e.URI=void 0;const r=/^\w[\w\d+.-]*$/,M=/^\//,R=/^\/\//;function S(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!r.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!M.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(n,i){return!n&&!i?"file":n}function u(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==d&&(i=d+i):i=d;break}return i}const $="",d="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,a,m,P,I,D=!1){typeof i=="object"?(this.scheme=i.scheme||$,this.authority=i.authority||$,this.path=i.path||$,this.query=i.query||$,this.fragment=i.fragment||$):(this.scheme=f(i,D),this.authority=a||$,this.path=u(this.scheme,m||$),this.query=P||$,this.fragment=I||$,S(this,D))}get fsPath(){return k(this,!1)}with(i){if(!i)return this;let{scheme:a,authority:m,path:P,query:I,fragment:D}=i;return a===void 0?a=this.scheme:a===null&&(a=$),m===void 0?m=this.authority:m===null&&(m=$),P===void 0?P=this.path:P===null&&(P=$),I===void 0?I=this.query:I===null&&(I=$),D===void 0?D=this.fragment:D===null&&(D=$),a===this.scheme&&m===this.authority&&P===this.path&&I===this.query&&D===this.fragment?this:new o(a,m,P,I,D)}static parse(i,a=!1){const m=p.exec(i);return m?new o(m[2]||$,s(m[4]||$),s(m[5]||$),s(m[7]||$),s(m[9]||$),a):new o($,$,$,$,$)}static file(i){let a=$;if(C.$i&&(i=i.replace(/\\/g,d)),i[0]===d&&i[1]===d){const m=i.indexOf(d,2);m===-1?(a=i.substring(2),i=d):(a=i.substring(2,m),i=i.substring(m)||d)}return new o("file",a,i,$,$)}static from(i,a){return new o(i.scheme,i.authority,i.path,i.query,i.fragment,a)}static joinPath(i,...a){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return C.$i&&i.scheme==="file"?m=h.file(E.$9b.join(k(i,!0),...a)).path:m=E.$0b.join(i.path,...a),i.with({path:m})}toString(i=!1){return w(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const a=new o(i);return a._formatted=i.external??null,a._fsPath=i._sep===y?i.fsPath??null:null,a}}else return i}}e.URI=h;function v(n){return!n||typeof n!="object"?!1:typeof n.scheme=="string"&&(typeof n.authority=="string"||typeof n.authority>"u")&&(typeof n.path=="string"||typeof n.path>"u")&&(typeof n.query=="string"||typeof n.query>"u")&&(typeof n.fragment=="string"||typeof n.fragment>"u")}e.$Te=v;const y=C.$i?1:void 0;class o extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=k(this,!1)),this._fsPath}toString(i=!1){return i?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=y),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(n,i,a){let m,P=-1;for(let I=0;I<n.length;I++){const D=n.charCodeAt(I);if(D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57||D===45||D===46||D===95||D===126||i&&D===47||a&&D===91||a&&D===93||a&&D===58)P!==-1&&(m+=encodeURIComponent(n.substring(P,I)),P=-1),m!==void 0&&(m+=n.charAt(I));else{m===void 0&&(m=n.substr(0,I));const O=g[D];O!==void 0?(P!==-1&&(m+=encodeURIComponent(n.substring(P,I)),P=-1),m+=O):P===-1&&(P=I)}}return P!==-1&&(m+=encodeURIComponent(n.substring(P))),m!==void 0?m:n}function b(n){let i;for(let a=0;a<n.length;a++){const m=n.charCodeAt(a);m===35||m===63?(i===void 0&&(i=n.substr(0,a)),i+=g[m]):i!==void 0&&(i+=n[a])}return i!==void 0?i:n}function k(n,i){let a;return n.authority&&n.path.length>1&&n.scheme==="file"?a=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?a=n.path.substr(1):a=n.path[1].toLowerCase()+n.path.substr(2):a=n.path,C.$i&&(a=a.replace(/\//g,"\\")),a}e.$Ue=k;function w(n,i){const a=i?b:c;let m="",{scheme:P,authority:I,path:D,query:O,fragment:L}=n;if(P&&(m+=P,m+=":"),(I||P==="file")&&(m+=d,m+=d),I){let N=I.indexOf("@");if(N!==-1){const q=I.substr(0,N);I=I.substr(N+1),N=q.lastIndexOf(":"),N===-1?m+=a(q,!1,!1):(m+=a(q.substr(0,N),!1,!1),m+=":",m+=a(q.substr(N+1),!1,!0)),m+="@"}I=I.toLowerCase(),N=I.lastIndexOf(":"),N===-1?m+=a(I,!1,!0):(m+=a(I.substr(0,N),!1,!0),m+=I.substr(N))}if(D){if(D.length>=3&&D.charCodeAt(0)===47&&D.charCodeAt(2)===58){const N=D.charCodeAt(1);N>=65&&N<=90&&(D=`/${String.fromCharCode(N+32)}:${D.substr(3)}`)}else if(D.length>=2&&D.charCodeAt(1)===58){const N=D.charCodeAt(0);N>=65&&N<=90&&(D=`${String.fromCharCode(N+32)}:${D.substr(2)}`)}m+=a(D,!0,!1)}return O&&(m+="?",m+=a(O,!1,!1)),L&&(m+="#",m+=i?L:c(L,!1,!1)),m}function t(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+t(n.substr(3)):n}}const l=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(n){return n.match(l)?n.replace(l,i=>t(i)):n}}),define(te[153],ie([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Cp=e.$Bp=e.$Ap=void 0;function C(u){const $=u;return $&&typeof $.type=="string"&&typeof $.severity=="string"}e.$Ap=C;function r(u){const $=[];let d;try{const p=JSON.parse(u.arguments),h=p[p.length-1];h&&h.__$stack&&(p.pop(),d=h.__$stack),$.push(...p)}catch{$.push("Unable to log remote console arguments",u.arguments)}return{args:$,stack:d}}e.$Bp=r;function M(u){if(typeof u!="string")return M(r(u).stack);const $=u;if($){const d=R($),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(d||"");if(p&&p.length===4)return{uri:E.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$Cp=M;function R(u){if(!u)return u;const $=u.indexOf(`
`);return $===-1?u:u.substring(0,$)}function S(u,$){const{args:d,stack:p}=r(u),h=typeof d[0]=="string"&&d.length===1;let v=R(p);v&&(v=`(${v.trim()})`);let y=[];if(typeof d[0]=="string"?v&&h?y=[`%c[${$}] %c${d[0]} %c${v}`,f("blue"),f(""),f("grey")]:y=[`%c[${$}] %c${d[0]}`,f("blue"),f(""),...d.slice(1)]:y=[`%c[${$}]%`,f("blue"),...d],v&&!h&&y.push(v),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,y)}e.log=S;function f(u){return`color: ${u}`}}),define(te[74],ie([0,1,17,25,7]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=e.$Vg=e.$Ug=void 0;function M(u){return JSON.stringify(u,S)}e.$Ug=M;function R(u){let $=JSON.parse(u);return $=f($),$}e.$Vg=R;function S(u,$){return $ instanceof RegExp?{$mid:2,source:$.source,flags:(0,C.$yd)($)}:$}function f(u,$=0){if(!u||$>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return r.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 16:return new Date(u.source)}if(u instanceof E.$Jb||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let d=0;d<u.length;++d)u[d]=f(u[d],$+1);else for(const d in u)Object.hasOwnProperty.call(u,d)&&(u[d]=f(u[d],$+1))}return u}e.$Wg=f}),define(te[15],ie([0,1,13,4,7]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.Schemas=void 0;var M;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm"})(M||(e.Schemas=M={})),e.$Ve="vscode-tkn",e.$We="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${M.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${M.vscodeRemoteResource}`}set($,d,p){this.a[$]=d,this.b[$]=p}setConnectionToken($,d){this.c[$]=d}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(o){return E.$Y(o),$}const d=$.authority;let p=this.a[d];p&&p.indexOf(":")!==-1&&p.indexOf("[")===-1&&(p=`[${p}]`);const h=this.b[d],v=this.c[d];let y=`path=${encodeURIComponent($.path)}`;return typeof v=="string"&&(y+=`&${e.$We}=${encodeURIComponent(v)}`),r.URI.from({scheme:C.$o?this.d:M.vscodeRemoteResource,authority:`${p}:${h}`,path:this.f,query:y})}}e.$Xe=new R,e.$Ye="vs/../../extensions",e.$Ze="vs/../../node_modules",e.$1e="vs/../../node_modules.asar",e.$2e="vs/../../node_modules.asar.unpacked";class S{static{this.a="vscode-app"}asBrowserUri($){const d=this.b($,G);return this.uriToBrowserUri(d)}uriToBrowserUri($){return $.scheme===M.vscodeRemote?e.$Xe.rewrite($):$.scheme===M.file&&(C.$m||C.$p&&C.$g.origin===`${M.vscodeFileResource}://${S.a}`)?$.with({scheme:M.vscodeFileResource,authority:$.authority||S.a,query:null,fragment:null}):$}asFileUri($){const d=this.b($,G);return this.uriToFileUri(d)}uriToFileUri($){return $.scheme===M.vscodeFileResource?$.with({scheme:M.file,authority:$.authority!==S.a?$.authority:null,query:null,fragment:null}):$}b($,d){return r.URI.isUri($)?$:r.URI.parse(d.toUrl($))}}e.$3e=new S;var f;(function(u){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze($.get("3"));const d="vscode-coi";function p(v){let y;typeof v=="string"?y=new URL(v).searchParams:v instanceof URL?y=v.searchParams:r.URI.isUri(v)&&(y=new URL(v.toString(!0)).searchParams);const o=y?.get(d);if(o)return $.get(o)}u.getHeadersFromQuery=p;function h(v,y,o){if(!globalThis.crossOriginIsolated)return;const g=y&&o?"3":o?"2":"1";v instanceof URLSearchParams?v.set(d,g):v[d]=g}u.addSearchParam=h})(f||(e.COI=f={}))}),define(te[19],ie([0,1,32,15,9,4,25,7]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.DataUri=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function f(h){return(0,S.$Ue)(h,!0)}e.$Vf=f;class u{constructor(v){this.a=v}compare(v,y,o=!1){return v===y?0:(0,R.$Ed)(this.getComparisonKey(v,o),this.getComparisonKey(y,o))}isEqual(v,y,o=!1){return v===y?!0:!v||!y?!1:this.getComparisonKey(v,o)===this.getComparisonKey(y,o)}getComparisonKey(v,y=!1){return v.with({path:this.a(v)?v.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(v){return this.a(v)}isEqualOrParent(v,y,o=!1){if(v.scheme===y.scheme){if(v.scheme===C.Schemas.file)return E.$Je(f(v),f(y),this.a(v))&&v.query===y.query&&(o||v.fragment===y.fragment);if((0,e.$ag)(v.authority,y.authority))return E.$Je(v.path,y.path,this.a(v),"/")&&v.query===y.query&&(o||v.fragment===y.fragment)}return!1}joinPath(v,...y){return S.URI.joinPath(v,...y)}basenameOrAuthority(v){return(0,e.$5f)(v)||v.authority}basename(v){return r.$0b.basename(v.path)}extname(v){return r.$0b.extname(v.path)}dirname(v){if(v.path.length===0)return v;let y;return v.scheme===C.Schemas.file?y=S.URI.file(r.$dc(f(v))).path:(y=r.$0b.dirname(v.path),v.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${v.toString})) resulted in a relative path`),y="/")),v.with({path:y})}normalizePath(v){if(!v.path.length)return v;let y;return v.scheme===C.Schemas.file?y=S.URI.file(r.$$b(f(v))).path:y=r.$0b.normalize(v.path),v.with({path:y})}relativePath(v,y){if(v.scheme!==y.scheme||!(0,e.$ag)(v.authority,y.authority))return;if(v.scheme===C.Schemas.file){const c=r.$cc(f(v),f(y));return M.$i?E.$De(c):c}let o=v.path||"/";const g=y.path||"/";if(this.a(v)){let c=0;for(const b=Math.min(o.length,g.length);c<b&&!(o.charCodeAt(c)!==g.charCodeAt(c)&&o.charAt(c).toLowerCase()!==g.charAt(c).toLowerCase());c++);o=g.substr(0,c)+o.substr(c)}return r.$0b.relative(o,g)}resolvePath(v,y){if(v.scheme===C.Schemas.file){const o=S.URI.file(r.$bc(f(v),y));return v.with({authority:o.authority,path:o.path})}return y=E.$Ee(y),v.with({path:r.$0b.resolve(v.path,y)})}isAbsolutePath(v){return!!v.path&&v.path[0]==="/"}isEqualAuthority(v,y){return v===y||v!==void 0&&y!==void 0&&(0,R.$Ld)(v,y)}hasTrailingPathSeparator(v,y=r.sep){if(v.scheme===C.Schemas.file){const o=f(v);return o.length>E.$Fe(o).length&&o[o.length-1]===y}else{const o=v.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(v.fsPath)}}removeTrailingPathSeparator(v,y=r.sep){return(0,e.$bg)(v,y)?v.with({path:v.path.substr(0,v.path.length-1)}):v}addTrailingPathSeparator(v,y=r.sep){let o=!1;if(v.scheme===C.Schemas.file){const g=f(v);o=g!==void 0&&g.length===E.$Fe(g).length&&g[g.length-1]===y}else{y="/";const g=v.path;o=g.length===1&&g.charCodeAt(g.length-1)===47}return!o&&!(0,e.$bg)(v,y)?v.with({path:v.path+"/"}):v}}e.$Wf=u,e.$Xf=new u(()=>!1),e.$Yf=new u(h=>h.scheme===C.Schemas.file?!M.$k:!0),e.$Zf=new u(h=>!0),e.$1f=e.$Xf.isEqual.bind(e.$Xf),e.$2f=e.$Xf.isEqualOrParent.bind(e.$Xf),e.$3f=e.$Xf.getComparisonKey.bind(e.$Xf),e.$4f=e.$Xf.basenameOrAuthority.bind(e.$Xf),e.$5f=e.$Xf.basename.bind(e.$Xf),e.$6f=e.$Xf.extname.bind(e.$Xf),e.$7f=e.$Xf.dirname.bind(e.$Xf),e.$8f=e.$Xf.joinPath.bind(e.$Xf),e.$9f=e.$Xf.normalizePath.bind(e.$Xf),e.$0f=e.$Xf.relativePath.bind(e.$Xf),e.$$f=e.$Xf.resolvePath.bind(e.$Xf),e.$_f=e.$Xf.isAbsolutePath.bind(e.$Xf),e.$ag=e.$Xf.isEqualAuthority.bind(e.$Xf),e.$bg=e.$Xf.hasTrailingPathSeparator.bind(e.$Xf),e.$cg=e.$Xf.removeTrailingPathSeparator.bind(e.$Xf),e.$dg=e.$Xf.addTrailingPathSeparator.bind(e.$Xf);function $(h,v){const y=[];for(let o=0;o<h.length;o++){const g=v(h[o]);h.some((c,b)=>b===o?!1:(0,e.$2f)(g,v(c)))||y.push(h[o])}return y}e.$eg=$;var d;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function v(y){const o=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(b=>{const[k,w]=b.split(":");k&&w&&o.set(k,w)});const c=y.path.substring(0,y.path.indexOf(";"));return c&&o.set(h.META_DATA_MIME,c),o}h.parseMetaData=v})(d||(e.DataUri=d={}));function p(h,v,y){if(v){let o=h.path;return o&&o[0]!==r.$0b.sep&&(o=r.$0b.sep+o),h.with({scheme:y,authority:v,path:o})}return h.with({scheme:y})}e.$fg=p}),define(te[8],ie([0,1,21,13,3,2,19,4,141]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.$Pg=e.$Og=e.Promises=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function u(j){return!!j&&typeof j.then=="function"}e.$gg=u;function $(j){const A=new E.$dd,F=j(A.token),H=new Promise((V,z)=>{const B=A.token.onCancellationRequested(()=>{B.dispose(),A.dispose(),z(new C.$3)});Promise.resolve(F).then(Y=>{B.dispose(),A.dispose(),V(Y)},Y=>{B.dispose(),A.dispose(),z(Y)})});return new class{cancel(){A.cancel()}then(V,z){return H.then(V,z)}catch(V){return this.then(void 0,V)}finally(V){return H.finally(V)}}}e.$hg=$;function d(j,A,F){return new Promise((H,V)=>{const z=A.onCancellationRequested(()=>{z.dispose(),H(F)});j.then(H,V).finally(()=>z.dispose())})}e.$ig=d;function p(j,A){return new Promise((F,H)=>{const V=A.onCancellationRequested(()=>{V.dispose(),H(new C.$3)});j.then(F,H).finally(()=>V.dispose())})}e.$jg=p;async function h(j){let A=-1;const F=j.map((H,V)=>H.then(z=>(A=V,z)));try{return await Promise.race(F)}finally{j.forEach((H,V)=>{V!==A&&H.cancel()})}}e.$kg=h;function v(j,A,F){let H;const V=setTimeout(()=>{H?.(void 0),F?.()},A);return Promise.race([j.finally(()=>clearTimeout(V)),new Promise(z=>H=z)])}e.$lg=v;function y(j){return new Promise((A,F)=>{const H=j();u(H)?H.then(A,F):A(H)})}e.$mg=y;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(A){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=A,!this.b){const F=()=>{if(this.b=null,this.f)return;const H=this.queue(this.d);return this.d=null,H};this.b=new Promise(H=>{this.a.then(F,F).then(H)})}return new Promise((F,H)=>{this.b.then(F,H)})}return this.a=A(),new Promise((F,H)=>{this.a.then(V=>{this.a=null,F(V)},V=>{this.a=null,H(V)})})}dispose(){this.f=!0}}e.$ng=o;class g{constructor(){this.a=Promise.resolve(null)}queue(A){return this.a=this.a.then(()=>A(),()=>A())}}e.$og=g;class c{constructor(){this.a=new Map}queue(A,F){const V=(this.a.get(A)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(A)===V&&this.a.delete(A)});return this.a.set(A,V),V}}e.$pg=c;const b=(j,A)=>{let F=!0;const H=setTimeout(()=>{F=!1,A()},j);return{isTriggered:()=>F,dispose:()=>{clearTimeout(H),F=!1}}},k=j=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,j())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};class w{constructor(A){this.defaultDelay=A,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(A,F=this.defaultDelay){this.g=A,this.h(),this.b||(this.b=new Promise((V,z)=>{this.d=V,this.f=z}).then(()=>{if(this.b=null,this.d=null,this.g){const V=this.g;return this.g=null,V()}}));const H=()=>{this.a=null,this.d?.(null)};return this.a=F===f.$4c?k(H):b(F,H),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$qg=w;class t{constructor(A){this.a=new w(A),this.b=new o}trigger(A,F){return this.a.trigger(()=>this.b.queue(A),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$rg=t;class l{constructor(){this.a=!1,this.b=new Promise((A,F)=>{this.d=A})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$sg=l;class s extends l{constructor(A){super(),this.f=setTimeout(()=>this.open(),A)}open(){clearTimeout(this.f),super.open()}}e.$tg=s;function n(j,A){return A?new Promise((F,H)=>{const V=setTimeout(()=>{z.dispose(),F()},j),z=A.onCancellationRequested(()=>{clearTimeout(V),z.dispose(),H(new C.$3)})}):$(F=>n(j,F))}e.$ug=n;function i(j,A=0){const F=setTimeout(j,A);return(0,M.$jb)(()=>clearTimeout(F))}e.$vg=i;function a(j){const A=[];let F=0;const H=j.length;function V(){return F<H?j[F++]():null}function z(B){B!=null&&A.push(B);const Y=V();return Y?Y.then(z):Promise.resolve(A)}return Promise.resolve(null).then(z)}e.$wg=a;function m(j,A=H=>!!H,F=null){let H=0;const V=j.length,z=()=>{if(H>=V)return Promise.resolve(F);const B=j[H++];return Promise.resolve(B()).then(se=>A(se)?Promise.resolve(se):z())};return z()}e.$xg=m;function P(j,A=H=>!!H,F=null){if(j.length===0)return Promise.resolve(F);let H=j.length;const V=()=>{H=-1;for(const z of j)z.cancel?.()};return new Promise((z,B)=>{for(const Y of j)Y.then(se=>{--H>=0&&A(se)?(V(),z(se)):H===0&&z(F)}).catch(se=>{--H>=0&&(V(),B(se))})})}e.$yg=P;class I{constructor(A){this.a=0,this.d=A,this.f=[],this.b=0,this.g=new r.$7c}get onDrained(){return this.g.event}get size(){return this.a}queue(A){return this.a++,new Promise((F,H)=>{this.f.push({factory:A,c:F,e:H}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const A=this.f.shift();this.b++;const F=A.factory();F.then(A.c,A.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$zg=I;class D extends I{constructor(){super(1)}}e.$Ag=D;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const A=new W;return this.b.add(A),A.p}d(){for(const[,A]of this.a)if(A.size>0)return!1;return!0}queueFor(A,F=R.$Xf){const H=F.getComparisonKey(A);let V=this.a.get(H);return V||(V=new D,r.Event.once(V.onDrained)(()=>{V?.dispose(),this.a.delete(H),this.f()}),this.a.set(H,V)),V}f(){this.d()&&this.g()}g(){for(const A of this.b)A.complete();this.b.clear()}dispose(){for(const[,A]of this.a)A.dispose();this.a.clear(),this.g()}}e.$Bg=O;class L{constructor(A,F){this.a=-1,typeof A=="function"&&typeof F=="number"&&this.setIfNotSet(A,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(A,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,A()},F)}setIfNotSet(A,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,A()},F))}}e.$Cg=L;class N{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(A,F){this.cancel(),this.a=setInterval(()=>{A()},F)}}e.$Dg=N;class q{constructor(A,F){this.b=-1,this.a=A,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(A=this.d){this.cancel(),this.b=setTimeout(this.f,A)}get delay(){return this.d}set delay(A){this.d=A}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Eg=q;class re{constructor(A,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=A,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(A=this.b){A%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(A/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Fg=re;class ne extends q{constructor(A,F){super(A,F),this.j=[]}work(A){this.j.push(A),this.isScheduled()||this.schedule()}h(){const A=this.j;this.j=[],this.a?.(A)}dispose(){this.j=[],super.dispose()}}e.$Gg=ne;class ee extends M.$lb{constructor(A,F){super(),this.g=A,this.h=F,this.a=[],this.b=this.B(new M.$mb),this.f=!1}get pending(){return this.a.length}work(A){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+A.length>this.g.maxBufferedWork)return!1}else if(this.pending+A.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of A)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new q(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Hg=ee,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ig=j=>{(0,S.$A)(()=>{if(A)return;const F=Date.now()+15;j(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.$Ig=(j,A)=>{const F=requestIdleCallback(j,typeof A=="number"?{timeout:A}:void 0);let H=!1;return{dispose(){H||(H=!0,cancelIdleCallback(F))}}}}();class ae{constructor(A){this.d=!1,this.a=()=>{try{this.f=A()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.$Ig)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Jg=ae;async function ue(j,A,F){let H;for(let V=0;V<F;V++)try{return await j()}catch(z){H=z,await n(A)}throw H}e.$Kg=ue;class K{hasPending(A){return this.a?typeof A=="number"?this.a.taskId===A:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(A,F,H){return this.a={taskId:A,cancel:()=>H?.(),promise:F},F.then(()=>this.d(A),()=>this.d(A)),F}d(A){this.a&&A===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const A=this.b;this.b=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this.b)this.b.run=A;else{let F,H;const V=new Promise((z,B)=>{F=z,H=B});this.b={run:A,promise:V,promiseResolve:F,promiseReject:H}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lg=K;class X{constructor(A,F=()=>Date.now()){this.d=A,this.f=F,this.a=0,this.b=0}increment(){const A=this.f();return A-this.a>this.d&&(this.a=A,this.b=0),this.b++,this.b}}e.$Mg=X;var U;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(U||(U={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((A,F)=>{this.a=A,this.b=F})}complete(A){return new Promise(F=>{this.a(A),this.d={outcome:0,value:A},F()})}error(A){return new Promise(F=>{this.b(A),this.d={outcome:1,value:A},F()})}cancel(){return this.error(new C.$3)}}e.$Ng=W;var T;(function(j){async function A(H){let V;const z=await Promise.all(H.map(B=>B.then(Y=>Y,Y=>{V||(V=Y)})));if(typeof V<"u")throw V;return z}j.settled=A;function F(H){return new Promise(async(V,z)=>{try{await H(V,z)}catch(B){z(B)}})}j.withAsyncBody=F})(T||(e.Promises=T={}));var J;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(J||(J={}));class Z{static fromArray(A){return new Z(F=>{F.emitMany(A)})}static fromPromise(A){return new Z(async F=>{F.emitMany(await A)})}static fromPromises(A){return new Z(async F=>{await Promise.all(A.map(async H=>F.emitOne(await H)))})}static merge(A){return new Z(async F=>{await Promise.all(A.map(async H=>{for await(const V of H)F.emitOne(V)}))})}static{this.EMPTY=Z.fromArray([])}constructor(A){this.a=0,this.b=[],this.d=null,this.f=new r.$7c,queueMicrotask(async()=>{const F={emitOne:H=>this.g(H),emitMany:H=>this.h(H),reject:H=>this.k(H)};try{await Promise.resolve(A(F)),this.j()}catch(H){this.k(H)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(A<this.b.length)return{done:!1,value:this.b[A++]};if(this.a===1)return{done:!0,value:void 0};await r.Event.toPromise(this.f.event)}while(!0)}}}static map(A,F){return new Z(async H=>{for await(const V of A)H.emitOne(F(V))})}map(A){return Z.map(this,A)}static filter(A,F){return new Z(async H=>{for await(const V of A)F(V)&&H.emitOne(V)})}filter(A){return Z.filter(this,A)}static coalesce(A){return Z.filter(A,F=>!!F)}coalesce(){return Z.coalesce(this)}static async toPromise(A){const F=[];for await(const H of A)F.push(H);return F}toPromise(){return Z.toPromise(this)}g(A){this.a===0&&(this.b.push(A),this.f.fire())}h(A){this.a===0&&(this.b=this.b.concat(A),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(A){this.a===0&&(this.a=2,this.d=A,this.f.fire())}}e.$Og=Z;class ce extends Z{constructor(A,F){super(F),this.l=A}cancel(){this.l.cancel()}}e.$Pg=ce;function oe(j){const A=new E.$dd,F=j(A.token);return new ce(A,async H=>{const V=A.token.onCancellationRequested(()=>{V.dispose(),A.dispose(),H.reject(new C.$3)});try{for await(const z of F){if(A.token.isCancellationRequested)return;H.emitOne(z)}V.dispose(),A.dispose()}catch(z){V.dispose(),A.dispose(),H.reject(z)}})}e.$Qg=oe}),define(te[104],ie([0,1,24,8,32,35,9,4,25]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=void 0;function u(){return Object.create(null)}e.$0i=u,e.$$i="**",e.$_i="/";const $="[/\\\\]",d="[^/\\\\]",p=/\//g;function h(X,U){switch(X){case 0:return"";case 1:return`${d}*?`;default:return`(?:${$}|${d}+${$}${U?`|${$}${d}+`:""})*?`}}function v(X,U){if(!X)return[];const W=[];let T=!1,J=!1,Z="";for(const ce of X){switch(ce){case U:if(!T&&!J){W.push(Z),Z="";continue}break;case"{":T=!0;break;case"}":T=!1;break;case"[":J=!0;break;case"]":J=!1;break}Z+=ce}return Z&&W.push(Z),W}e.$aj=v;function y(X){if(!X)return"";let U="";const W=v(X,e.$_i);if(W.every(T=>T===e.$$i))U=".*";else{let T=!1;W.forEach((J,Z)=>{if(J===e.$$i){if(T)return;U+=h(2,Z===W.length-1)}else{let ce=!1,oe="",j=!1,A="";for(const F of J){if(F!=="}"&&ce){oe+=F;continue}if(j&&(F!=="]"||!A)){let H;F==="-"?H=F:(F==="^"||F==="!")&&!A?H="^":F===e.$_i?H="":H=(0,f.$nd)(F),A+=H;continue}switch(F){case"{":ce=!0;continue;case"[":j=!0;continue;case"}":{const V=`(?:${v(oe,",").map(z=>y(z)).join("|")})`;U+=V,ce=!1,oe="";break}case"]":{U+="["+A+"]",j=!1,A="";break}case"?":U+=d;continue;case"*":U+=h(1);continue;default:U+=(0,f.$nd)(F)}}Z<W.length-1&&(W[Z+1]!==e.$$i||Z+2<W.length)&&(U+=$)}T=J===e.$$i})}return U}const o=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,k=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new M.$oi(1e4),l=function(){return!1},s=function(){return null};function n(X,U){if(!X)return s;let W;typeof X!="string"?W=X.pattern:W=X,W=W.trim();const T=`${W}_${!!U.trimForExclusions}`;let J=t.get(T);if(J)return i(J,X);let Z;return o.test(W)?J=m(W.substr(4),W):(Z=g.exec(a(W,U)))?J=P(Z[1],W):(U.trimForExclusions?b:c).test(W)?J=I(W,U):(Z=k.exec(a(W,U)))?J=D(Z[1].substr(1),W,!0):(Z=w.exec(a(W,U)))?J=D(Z[1],W,!1):J=O(W),t.set(T,J),i(J,X)}function i(X,U){if(typeof U=="string")return X;const W=function(T,J){return(0,r.$Je)(T,U.base,!S.$k)?X((0,f.$rd)(T.substr(U.base.length),R.sep),J):null};return W.allBasenames=X.allBasenames,W.allPaths=X.allPaths,W.basenames=X.basenames,W.patterns=X.patterns,W}function a(X,U){return U.trimForExclusions&&X.endsWith("/**")?X.substr(0,X.length-2):X}function m(X,U){return function(W,T){return typeof W=="string"&&W.endsWith(X)?U:null}}function P(X,U){const W=`/${X}`,T=`\\${X}`,J=function(ce,oe){return typeof ce!="string"?null:oe?oe===X?U:null:ce===X||ce.endsWith(W)||ce.endsWith(T)?U:null},Z=[X];return J.basenames=Z,J.patterns=[U],J.allBasenames=Z,J}function I(X,U){const W=ue(X.slice(1,-1).split(",").map(oe=>n(oe,U)).filter(oe=>oe!==s),X),T=W.length;if(!T)return s;if(T===1)return W[0];const J=function(oe,j){for(let A=0,F=W.length;A<F;A++)if(W[A](oe,j))return X;return null},Z=W.find(oe=>!!oe.allBasenames);Z&&(J.allBasenames=Z.allBasenames);const ce=W.reduce((oe,j)=>j.allPaths?oe.concat(j.allPaths):oe,[]);return ce.length&&(J.allPaths=ce),J}function D(X,U,W){const T=R.sep===R.$0b.sep,J=T?X:X.replace(p,R.sep),Z=R.sep+J,ce=R.$0b.sep+X;let oe;return W?oe=function(j,A){return typeof j=="string"&&(j===J||j.endsWith(Z)||!T&&(j===X||j.endsWith(ce)))?U:null}:oe=function(j,A){return typeof j=="string"&&(j===J||!T&&j===X)?U:null},oe.allPaths=[(W?"*/":"./")+X],oe}function O(X){try{const U=new RegExp(`^${y(X)}$`);return function(W){return U.lastIndex=0,typeof W=="string"&&U.test(W)?X:null}}catch{return s}}function L(X,U,W){return!X||typeof U!="string"?!1:N(X)(U,void 0,W)}e.$bj=L;function N(X,U={}){if(!X)return l;if(typeof X=="string"||q(X)){const W=n(X,U);if(W===s)return l;const T=function(J,Z){return!!W(J,Z)};return W.allBasenames&&(T.allBasenames=W.allBasenames),W.allPaths&&(T.allPaths=W.allPaths),T}return ee(X,U)}e.$cj=N;function q(X){const U=X;return U?typeof U.base=="string"&&typeof U.pattern=="string":!1}e.$dj=q;function re(X){return X.allBasenames||[]}e.$ej=re;function ne(X){return X.allPaths||[]}e.$fj=ne;function ee(X,U){const W=ue(Object.getOwnPropertyNames(X).map(oe=>ae(oe,X[oe],U)).filter(oe=>oe!==s)),T=W.length;if(!T)return s;if(!W.some(oe=>!!oe.requiresSiblings)){if(T===1)return W[0];const oe=function(F,H){let V;for(let z=0,B=W.length;z<B;z++){const Y=W[z](F,H);if(typeof Y=="string")return Y;(0,C.$gg)(Y)&&(V||(V=[]),V.push(Y))}return V?(async()=>{for(const z of V){const B=await z;if(typeof B=="string")return B}return null})():null},j=W.find(F=>!!F.allBasenames);j&&(oe.allBasenames=j.allBasenames);const A=W.reduce((F,H)=>H.allPaths?F.concat(H.allPaths):F,[]);return A.length&&(oe.allPaths=A),oe}const J=function(oe,j,A){let F,H;for(let V=0,z=W.length;V<z;V++){const B=W[V];B.requiresSiblings&&A&&(j||(j=(0,R.$ec)(oe)),F||(F=j.substr(0,j.length-(0,R.$fc)(oe).length)));const Y=B(oe,j,F,A);if(typeof Y=="string")return Y;(0,C.$gg)(Y)&&(H||(H=[]),H.push(Y))}return H?(async()=>{for(const V of H){const z=await V;if(typeof z=="string")return z}return null})():null},Z=W.find(oe=>!!oe.allBasenames);Z&&(J.allBasenames=Z.allBasenames);const ce=W.reduce((oe,j)=>j.allPaths?oe.concat(j.allPaths):oe,[]);return ce.length&&(J.allPaths=ce),J}function ae(X,U,W){if(U===!1)return s;const T=n(X,W);if(T===s)return s;if(typeof U=="boolean")return T;if(U){const J=U.when;if(typeof J=="string"){const Z=(ce,oe,j,A)=>{if(!A||!T(ce,oe))return null;const F=J.replace("$(basename)",()=>j),H=A(F);return(0,C.$gg)(H)?H.then(V=>V?X:null):H?X:null};return Z.requiresSiblings=!0,Z}}return T}function ue(X,U){const W=X.filter(oe=>!!oe.basenames);if(W.length<2)return X;const T=W.reduce((oe,j)=>{const A=j.basenames;return A?oe.concat(A):oe},[]);let J;if(U){J=[];for(let oe=0,j=T.length;oe<j;oe++)J.push(U)}else J=W.reduce((oe,j)=>{const A=j.patterns;return A?oe.concat(A):oe},[]);const Z=function(oe,j){if(typeof oe!="string")return null;if(!j){let F;for(F=oe.length;F>0;F--){const H=oe.charCodeAt(F-1);if(H===47||H===92)break}j=oe.substr(F)}const A=T.indexOf(j);return A!==-1?J[A]:null};Z.basenames=T,Z.patterns=J,Z.allBasenames=T;const ce=X.filter(oe=>!oe.basenames);return ce.push(Z),ce}function K(X,U){return(0,E.$af)(X,U,(W,T)=>typeof W=="string"&&typeof T=="string"?W===T:typeof W!="string"&&typeof T!="string"?W.base===T.base&&W.pattern===T.pattern:!1)}e.$gj=K}),define(te[46],ie([0,1,24,32,9,4,19,25]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7z=e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=void 0;function f(n,i){const{os:a,tildify:m,relative:P}=i;if(P){const O=u(n,P,a);if(typeof O=="string")return O}let I=n.fsPath;if(a===1&&!M.$i?I=I.replace(/\//g,"\\"):a!==1&&M.$i&&(I=I.replace(/\\/g,"/")),a!==1&&m?.userHome){const O=m.userHome.fsPath;let L;n.scheme!==m.userHome.scheme&&n.path.startsWith(r.$0b.sep)?L=m.userHome.with({path:n.path}).fsPath:L=n.fsPath,I=p(L,O,a)}return(a===1?r.$9b:r.$0b).normalize($(I,a===1))}e.$Xz=f;function u(n,i,a){const m=a===1?r.$9b:r.$0b,P=a===3?R.$Xf:R.$Zf,I=i.getWorkspace(),D=(0,E.$uf)(I.folders);if(!D)return;n.scheme!==D.uri.scheme&&n.path.startsWith(r.$0b.sep)&&(n=D.uri.with({path:n.path}));const O=i.getWorkspaceFolder(n);if(!O)return;let L;if(P.isEqual(O.uri,n)?L="":L=P.relativePath(O.uri,n)??"",L&&(L=m.normalize(L)),I.folders.length>1&&!i.noPrefix){const N=O.name?O.name:P.basenameOrAuthority(O.uri);L=L?`${N} \u2022 ${L}`:N}return L}function $(n,i=M.$i){return(0,C.$Ne)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.$Yz=$;let d=Object.create(null);function p(n,i,a=M.OS){if(a===1||!n||!i)return n;let m=d.original===i?d.normalized:void 0;m||(m=i,M.$i&&(m=(0,C.$De)(m)),m=`${(0,S.$sd)(m,r.$0b.sep)}${r.$0b.sep}`,d={original:i,normalized:m});let P=n;return M.$i&&(P=(0,C.$De)(P)),(a===3?P.startsWith(m):(0,S.$Md)(P,m))?`~/${P.substr(m.length)}`:n}e.$Zz=p;function h(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.$1z=h;const v="\u2026",y="\\\\",o="~";function g(n,i=r.sep){const a=new Array(n.length);let m=!1;for(let P=0;P<n.length;P++){const I=n[P];if(I===""){a[P]=`.${i}`;continue}if(!I){a[P]=I;continue}m=!0;let D="",O=I;O.indexOf(y)===0?(D=O.substr(0,O.indexOf(y)+y.length),O=O.substr(O.indexOf(y)+y.length)):O.indexOf(i)===0?(D=O.substr(0,O.indexOf(i)+i.length),O=O.substr(O.indexOf(i)+i.length)):O.indexOf(o)===0&&(D=O.substr(0,O.indexOf(o)+o.length),O=O.substr(O.indexOf(o)+o.length));const L=O.split(i);for(let N=1;m&&N<=L.length;N++)for(let q=L.length-N;m&&q>=0;q--){m=!1;let re=L.slice(q,q+N).join(i);for(let ne=0;!m&&ne<n.length;ne++)if(ne!==P&&n[ne]&&n[ne].indexOf(re)>-1){const ee=q+N===L.length,ae=q>0&&n[ne].indexOf(i)>-1?i+re:re,ue=n[ne].endsWith(ae);m=!ee||ue}if(!m){let ne="";(L[0].endsWith(":")||D!=="")&&(q===1&&(q=0,N++,re=L[0]+i+re),q>0&&(ne=L[0]+i),ne=D+ne),q>0&&(ne=ne+v+i),ne=ne+re,q+N<L.length&&(ne=ne+i+v),a[P]=ne}}m&&(a[P]=I)}return a}e.$2z=g;var c;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function b(n,i=Object.create(null)){const a=[];let m=!1,P="";for(const I of n)if(I==="$"||m&&I==="{")P&&a.push({value:P,type:c.TEXT}),P="",m=!0;else if(I==="}"&&m){const D=i[P];if(typeof D=="string")D.length&&a.push({value:D,type:c.VARIABLE});else if(D){const O=a[a.length-1];(!O||O.type!==c.SEPARATOR)&&a.push({value:D.label,type:c.SEPARATOR})}P="",m=!1}else P+=I;return P&&!m&&a.push({value:P,type:c.TEXT}),a.filter((I,D)=>{if(I.type===c.SEPARATOR){const O=a[D-1],L=a[D+1];return[O,L].every(N=>N&&(N.type===c.VARIABLE||N.type===c.TEXT)&&N.value.length>0)}return!0}).map(I=>I.value).join("")}e.$3z=b;function k(n,i){return M.$j||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):n.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$4z=k;function w(n,i){return M.$j||i?n.replace(/\(&&\w\)|&&/g,""):M.$i?n.replace(/&&|&/g,a=>a==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.$5z=w;function t(n){return n.replace(/&/g,"&&")}e.$6z=t;function l(n){if(n.endsWith("]")){const i=n.lastIndexOf(" [",n.length-2);if(i!==-1){const a=s(n.substring(0,i));return{name:a.name,parentPath:a.parentPath+n.substring(i)}}}return s(n)}e.$7z=l;function s(n){const i=n.indexOf("/")!==-1?r.$0b:r.$9b,a=i.basename(n),m=i.dirname(n);return a.length?{name:a,parentPath:m}:{name:m,parentPath:""}}}),define(te[154],ie([0,1,17,7]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.$mm=e.$lm=void 0;function r(d){return d.toJSON()}class M{constructor(p){this.a=p}transformIncoming(p){const h=this.a.transformIncoming(p);return h===p?p:r(C.URI.from(h))}transformOutgoing(p){const h=this.a.transformOutgoing(p);return h===p?p:r(C.URI.from(h))}transformOutgoingURI(p){const h=this.a.transformOutgoing(p);return h===p?p:C.URI.from(h)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$lm=M,e.$mm=new class{transformIncoming(d){return d}transformOutgoing(d){return d}transformOutgoingURI(d){return d}transformOutgoingScheme(d){return d}};function R(d,p,h){if(!d||h>200)return null;if(typeof d=="object"){if(d instanceof C.URI)return p.transformOutgoing(d);for(const v in d)if(Object.hasOwnProperty.call(d,v)){const y=R(d[v],p,h+1);y!==null&&(d[v]=y)}}return null}function S(d,p){const h=R(d,p,0);return h===null?d:h}e.$nm=S;function f(d,p,h,v){if(!d||v>200)return null;if(typeof d=="object"){if(d.$mid===1)return h?C.URI.revive(p.transformIncoming(d)):p.transformIncoming(d);if(d instanceof E.$Jb)return null;for(const y in d)if(Object.hasOwnProperty.call(d,y)){const o=f(d[y],p,h,v+1);o!==null&&(d[y]=o)}}return null}function u(d,p){const h=f(d,p,!1,0);return h===null?d:h}e.$om=u;function $(d,p){const h=f(d,p,!0,0);return h===null?d:h}e.$pm=$}),define(te[22],ie([0,1,42,27,155,8,32,86,9,4,19,7]),function(G,e,E,C,r,M,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(ee){ee[ee.UNLINK=0]="UNLINK",ee[ee.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function h(ee,ae=p.UNLINK,ue){if((0,R.$Me)(ee))throw new Error("rimraf - will refuse to recursively delete root");return ae===p.UNLINK?y(ee):v(ee,ue)}async function v(ee,ae=(0,R.$Re)((0,C.tmpdir)())){try{try{await E.promises.rename(ee,ae)}catch(ue){return ue.code==="ENOENT"?void 0:y(ee)}y(ae).catch(ue=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function y(ee){return(0,r.promisify)(E.rm)(ee,{recursive:!0,force:!0,maxRetries:3})}function o(ee){if((0,R.$Me)(ee))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(ee,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=o;async function g(ee,ae){return k(await(ae?c(ee):(0,r.promisify)(E.readdir)(ee)))}async function c(ee){try{return await(0,r.promisify)(E.readdir)(ee,{withFileTypes:!0})}catch(K){console.warn("[node.js fs] readdir with filetypes failed with error: ",K)}const ae=[],ue=await g(ee);for(const K of ue){let X=!1,U=!1,W=!1;try{const T=await e.Promises.lstat((0,f.$ac)(ee,K));X=T.isFile(),U=T.isDirectory(),W=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}ae.push({name:K,isFile:()=>X,isDirectory:()=>U,isSymbolicLink:()=>W})}return ae}function b(ee){return k(E.readdirSync(ee))}e.readdirSync=b;function k(ee){return ee.map(ae=>typeof ae=="string"?u.$j?(0,S.$5k)(ae):ae:(ae.name=u.$j?(0,S.$5k)(ae.name):ae.name,ae))}async function w(ee){const ae=await g(ee),ue=[];for(const K of ae)await l.existsDirectory((0,f.$ac)(ee,K))&&ue.push(K);return ue}function t(ee,ae=1e3){return new Promise(ue=>{let K=!1;const X=setInterval(()=>{K||(K=!0,E.access(ee,U=>{K=!1,U&&(clearInterval(X),ue(void 0))}))},ae)})}e.whenDeleted=t;var l;(function(ee){async function ae(X){let U;try{if(U=await e.Promises.lstat(X),!U.isSymbolicLink())return{stat:U}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:U?.isSymbolicLink()?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};if(u.$i&&W.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&U)return{stat:U,symbolicLink:{dangling:!0}};throw T}throw W}}ee.stat=ae;async function ue(X){try{const{stat:U,symbolicLink:W}=await ee.stat(X);return U.isFile()&&W?.dangling!==!0}catch{}return!1}ee.existsFile=ue;async function K(X){try{const{stat:U,symbolicLink:W}=await ee.stat(X);return U.isDirectory()&&W?.dangling!==!0}catch{}return!1}ee.existsDirectory=K})(l||(e.SymlinkSupport=l={}));const s=new M.$Bg;function n(ee,ae,ue){return s.queueFor(d.URI.file(ee),$.$Yf).queue(()=>{const K=I(ue);return new Promise((X,U)=>m(ee,ae,K,W=>W?U(W):X()))})}let i=!0;function a(ee){i=ee}e.configureFlushOnWrite=a;function m(ee,ae,ue,K){if(!i)return E.writeFile(ee,ae,{mode:ue.mode,flag:ue.flag},K);E.open(ee,ue.flag,ue.mode,(X,U)=>{if(X)return K(X);E.writeFile(U,ae,W=>{if(W)return E.close(U,()=>K(W));E.fdatasync(U,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),a(!1)),E.close(U,J=>K(J))))})})}function P(ee,ae,ue){const K=I(ue);if(!i)return E.writeFileSync(ee,ae,{mode:K.mode,flag:K.flag});const X=E.openSync(ee,K.flag,K.mode);try{E.writeFileSync(X,ae);try{E.fdatasyncSync(X)}catch(U){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",U),a(!1)}}finally{E.closeSync(X)}}e.writeFileSync=P;function I(ee){return ee?{mode:typeof ee.mode=="number"?ee.mode:438,flag:typeof ee.flag=="string"?ee.flag:"w"}:{mode:438,flag:"w"}}async function D(ee,ae){if(ee!==ae)try{await e.Promises.rename(ee,ae)}catch(ue){if(ee.toLowerCase()!==ae.toLowerCase()&&ue.code==="EXDEV"||ee.endsWith("."))await O(ee,ae,{preserveSymlinks:!1}),await h(ee,p.MOVE);else throw ue}}async function O(ee,ae,ue){return N(ee,ae,{root:{source:ee,target:ae},options:ue,handledSourcePaths:new Set})}const L=511;async function N(ee,ae,ue){if(ue.handledSourcePaths.has(ee))return;ue.handledSourcePaths.add(ee);const{stat:K,symbolicLink:X}=await l.stat(ee);if(X){if(ue.options.preserveSymlinks)try{return await ne(ee,ae,ue)}catch(U){console.warn("[node.js fs] copy of symlink failed: ",U)}if(X.dangling)return}return K.isDirectory()?q(ee,ae,K.mode&L,ue):re(ee,ae,K.mode&L)}async function q(ee,ae,ue,K){await e.Promises.mkdir(ae,{recursive:!0,mode:ue});const X=await g(ee);for(const U of X)await N((0,f.$ac)(ee,U),(0,f.$ac)(ae,U),K)}async function re(ee,ae,ue){await e.Promises.copyFile(ee,ae),await e.Promises.chmod(ae,ue)}async function ne(ee,ae,ue){let K=await e.Promises.readlink(ee);(0,R.$Je)(K,ue.root.source,!u.$k)&&(K=(0,f.$ac)(ue.root.target,K.substr(ue.root.source.length+1))),await e.Promises.symlink(K,ae)}e.Promises=new class{get access(){return(0,r.promisify)(E.access)}get stat(){return(0,r.promisify)(E.stat)}get lstat(){return(0,r.promisify)(E.lstat)}get utimes(){return(0,r.promisify)(E.utimes)}get read(){return(ee,ae,ue,K,X)=>new Promise((U,W)=>{E.read(ee,ae,ue,K,X,(T,J,Z)=>T?W(T):U({bytesRead:J,buffer:Z}))})}get readFile(){return(0,r.promisify)(E.readFile)}get write(){return(ee,ae,ue,K,X)=>new Promise((U,W)=>{E.write(ee,ae,ue,K,X,(T,J,Z)=>T?W(T):U({bytesWritten:J,buffer:Z}))})}get appendFile(){return(0,r.promisify)(E.appendFile)}get fdatasync(){return(0,r.promisify)(E.fdatasync)}get truncate(){return(0,r.promisify)(E.truncate)}get rename(){return(0,r.promisify)(E.rename)}get copyFile(){return(0,r.promisify)(E.copyFile)}get open(){return(0,r.promisify)(E.open)}get close(){return(0,r.promisify)(E.close)}get symlink(){return(0,r.promisify)(E.symlink)}get readlink(){return(0,r.promisify)(E.readlink)}get chmod(){return(0,r.promisify)(E.chmod)}get mkdir(){return(0,r.promisify)(E.mkdir)}get unlink(){return(0,r.promisify)(E.unlink)}get rmdir(){return(0,r.promisify)(E.rmdir)}get realpath(){return(0,r.promisify)(E.realpath)}async exists(ee){try{return await e.Promises.access(ee),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return w}get writeFile(){return n}get rm(){return h}get move(){return D}get copy(){return O}}}),define(te[105],ie([0,1,42,9,4,25,22]),function(G,e,E,C,r,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.$Hp=void 0;function S(p){if(r.$k)return p;const h=(0,C.$dc)(p);if(p===h)return p;const v=((0,C.$ec)(p)||p).toLowerCase();try{const o=(0,R.readdirSync)(h).filter(g=>g.toLowerCase()===v);if(o.length===1){const g=S(h);if(g)return(0,C.$ac)(g,o[0])}else if(o.length>1){const g=o.indexOf(v);if(g>=0){const c=S(h);if(c)return(0,C.$ac)(c,o[g])}}}catch{}return null}e.$Hp=S;async function f(p){if(r.$k)return p;const h=(0,C.$dc)(p);if(p===h)return p;const v=((0,C.$ec)(p)||p).toLowerCase();try{const o=(await R.Promises.readdir(h)).filter(g=>g.toLowerCase()===v);if(o.length===1){const g=await f(h);if(g)return(0,C.$ac)(g,o[0])}else if(o.length>1){const g=o.indexOf(v);if(g>=0){const c=await f(h);if(c)return(0,C.$ac)(c,o[g])}}}catch{}return null}e.$Ip=f;async function u(p){try{return await R.Promises.realpath(p)}catch{const v=d(p);return await R.Promises.access(v,E.constants.R_OK),v}}e.$Jp=u;function $(p){try{return E.realpathSync(p)}catch{const v=d(p);return E.accessSync(v,E.constants.R_OK),v}}e.$Kp=$;function d(p){return(0,M.$sd)((0,C.$$b)(p),C.sep)}}),define(te[106],ie([0,1,27,9,22]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=void 0;const M=/^\d+$/,R=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var f;(function(k){k[k.x64=0]="x64",k[k.x86=1]="x86",k[k.ARM=2]="ARM"})(f||(f={}));let u;switch(process.arch){case"ia32":case"x32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let $;process.env.PROCESSOR_ARCHITEW6432?$=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?$=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?$=1:$=0;class d{constructor(w,t,l){this.exePath=w,this.displayName=t,this.a=l}async exists(){return this.a===void 0&&(this.a=await r.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:k=!1}={}){return k?u===0?process.env["ProgramFiles(x86)"]||null:$===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:k=!1,findPreview:w=!1}={}){const t=p({useAlternateBitness:k});if(!t)return null;const l=C.$ac(t,"PowerShell");if(!await r.SymlinkSupport.existsDirectory(l))return null;let s=-1,n=null;for(const m of await r.Promises.readdir(l)){let P=-1;if(w){const D=m.indexOf("-");if(D<0)continue;const O=m.substring(0,D);if(!M.test(O)||m.substring(D+1)!=="preview")continue;P=parseInt(O,10)}else{if(!M.test(m))continue;P=parseInt(m,10)}if(P<=s)continue;const I=C.$ac(l,m,"pwsh.exe");await r.SymlinkSupport.existsFile(I)&&(n=I,s=P)}if(!n)return null;const i=t.includes("x86")?" (x86)":"",a=w?" Preview":"";return new d(n,`PowerShell${a}${i}`,!0)}async function v({findPreview:k}={}){if(!process.env.LOCALAPPDATA)return null;const w=C.$ac(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await r.SymlinkSupport.existsDirectory(w))return null;const{pwshMsixDirRegex:t,pwshMsixName:l}=k?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const s of await r.Promises.readdir(w))if(t.test(s)){const n=C.$ac(w,s,"pwsh.exe");return new d(n,l)}return null}function y(){const k=C.$ac(E.homedir(),".dotnet","tools","pwsh.exe");return new d(k,".NET Core PowerShell Global Tool")}function o(){const k=C.$ac(process.env.windir,u===1&&$!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new d(k,"Windows PowerShell",!0)}async function*g(){let k=await h();k&&(yield k),k=await h({useAlternateBitness:!0}),k&&(yield k),k=await v(),k&&(yield k),k=y(),k&&(yield k),k=await h({findPreview:!0}),k&&(yield k),k=await v({findPreview:!0}),k&&(yield k),k=await h({useAlternateBitness:!0,findPreview:!0}),k&&(yield k),k=o(),k&&(yield k)}async function*c(){for await(const k of g())await k.exists()&&(yield k)}e.$bl=c;async function b(){for await(const k of c())return k;return null}e.$cl=b}),define(te[89],ie([0,1,9,4,36,73,10,22]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function f(d=r.env){return d.comspec||"cmd.exe"}e.$fl=f;function u(d){let p=[],h=!1;const v=function(y){if(h){p.push(y);return}(!d.send(y,g=>{if(g&&console.error(g),h=!1,p.length>0){const c=p.slice(0);p=[],c.forEach(b=>v(b))}})||C.$i)&&(h=!0)};return{send:v}}e.$gl=u;var $;(function(d){async function p(h,v,y){if(E.$_b(h))return h;if(v===void 0&&(v=r.cwd()),E.$dc(h)!=="."||(y===void 0&&R.$ie(r.env.PATH)&&(y=r.env.PATH.split(E.$kc)),y===void 0||y.length===0))return E.$ac(v,h);async function g(c){if(await S.Promises.exists(c)){let b;try{b=await S.Promises.stat(c)}catch(k){k.message.startsWith("EACCES")&&(b=await S.Promises.lstat(c))}return b?!b.isDirectory():!1}return!1}for(const c of y){let b;if(E.$_b(c)?b=E.$ac(c,h):b=E.$ac(v,c,h),await g(b))return b;let k=b+".com";if(await g(k)||(k=b+".exe",await g(k)))return k}return E.$ac(v,h)}d.findExecutable=p})($||(e.win32=$={}))}),define(te[107],ie([0,1,47,15]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;function r(R){return new Promise((S,f)=>{let u;const $=new Map;function d(h,v,y,o,g){const c=$.get(v);if(h===R||c){const b={name:p(y),cmd:y,pid:h,ppid:v,load:o,mem:g};$.set(h,b),h===R&&(u=b),c&&(c.children||(c.children=[]),c.children.push(b),c.children.length>1&&(c.children=c.children.sort((k,w)=>k.pid-w.pid)))}}function p(h){const v=/--utility-sub-type=network/i,y=/--ms-enable-electron-run-as-node/i,o=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,c=/conhost\.exe.+--headless/i,b=/--type=([a-zA-Z-]+)/;if(o.exec(h))return"electron-crash-reporter";if(g.exec(h))return"winpty-agent";if(c.exec(h))return"conpty-agent";let k=b.exec(h);if(k&&k.length===2)return k[1]==="renderer"?"window":k[1]==="utility"?v.exec(h)?"utility-network-service":"utility-process":k[1]==="extensionHost"?"extension-host":k[1];const w=/[a-zA-Z-]+\.js/g;let t="";do k=w.exec(h),k&&(t+=k+" ");while(k);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:y.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=v=>v.indexOf("\\\\?\\")===0||v.indexOf("\\??\\")===0?v.substring(4):v.indexOf('"\\\\?\\')===0||v.indexOf('"\\??\\')===0?'"'+v.substring(5):v;new Promise((v,y)=>{G(["@vscode/windows-process-tree"],v,y)}).then(v=>{v.getProcessList(R,y=>{if(!y){f(new Error(`Root process ${R} not found`));return}v.getProcessCpuUsage(y,o=>{const g=new Map;o.forEach(c=>{const b=h(c.commandLine||"");g.set(c.pid,{name:p(b),cmd:b,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),u=g.get(R),u?(g.forEach(c=>{const b=g.get(c.ppid);b&&(b.children||(b.children=[]),b.children.push(c))}),g.forEach(c=>{c.children&&(c.children=c.children.sort((b,k)=>b.pid-k.pid))}),S(u)):f(new Error(`Root process ${R} not found`))})},v.ProcessDataFlag.CommandLine|v.ProcessDataFlag.Memory)})}else{let h=function(){let v=[u];const y=[];for(;v.length;){const g=v.shift();g&&(y.push(g.pid),g.children&&(v=v.concat(g.children)))}let o=JSON.stringify(C.$3e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);o+=" "+y.join(" "),(0,E.exec)(o,{},(g,c,b)=>{if(g||b)f(g||new Error(b.toString()));else{const k=c.toString().split(`
`);for(let w=0;w<y.length;w++){const t=$.get(y[w]);t.load=parseFloat(k[w])}if(!u){f(new Error(`Root process ${R} not found`));return}S(u)}})};(0,E.exec)("which ps",{},(v,y,o)=>{if(v||o)if(process.platform!=="linux")f(v||new Error(o.toString()));else{const g=JSON.stringify(C.$3e.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(g,{},(c,b,k)=>{c||k?f(c||new Error(k.toString())):(M(b,d),h())})}else{const g=y.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${g} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,k,w)=>{b||w&&!w.includes("screen size is bogus")?f(b||new Error(w.toString())):(M(k,d),process.platform==="linux"?h():u?S(u):f(new Error(`Root process ${R} not found`)))})}})}})}e.$dr=r;function M(R,S){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=R.toString().split(`
`);for(const $ of u){const d=f.exec($.trim());d&&d.length===6&&S(parseInt(d[1]),parseInt(d[2]),d[5],parseFloat(d[3]),parseFloat(d[4]))}}}),define(te[108],ie([0,1,27,4,106,89]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=void 0;async function R(d,p){return d===1?C.$i?$():M.$fl(p):f(d,p)}e.$hl=R;let S=null;function f(d,p){if(C.$k&&d===2||C.$j&&d===3)return"/bin/bash";if(!S){let h;if(C.$i)h="/bin/bash";else{if(h=p.SHELL,!h)try{h=(0,E.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}S=h}return S}let u=null;async function $(){return u||(u=(await(0,r.$cl)()).exePath),u}});var pe=this&&this.__decorate||function(G,e,E,C){var r=arguments.length,M=r<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,E):C,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(G,e,E,C);else for(var S=G.length-1;S>=0;S--)(R=G[S])&&(M=(r<3?R(M):r>3?R(e,E,M):R(e,E))||M);return r>3&&M&&Object.defineProperty(e,E,M),M};define(te[43],ie([0,1,24,8,17,21,55,13,3,2,74,25,10]),function(G,e,E,C,r,M,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.ProxyChannel=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.RequestInitiator=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=void 0;var h;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(h||(h={}));function v(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(y||(y={}));function o(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(g||(g={}));function c(U){let W=0;for(let T=0;;T+=7){const J=U.read(1);if(W|=(J.buffer[0]&127)<<T,!(J.buffer[0]&128))return W}}const b=s(0);function k(U,W){if(W===0){U.write(b);return}let T=0;for(let Z=W;Z!==0;Z=Z>>>7)T++;const J=r.$Jb.alloc(T);for(let Z=0;W!==0;Z++)J.buffer[Z]=W&127,W=W>>>7,W>0&&(J.buffer[Z]|=128);U.write(J)}class w{constructor(W){this.b=W,this.a=0}read(W){const T=this.b.slice(this.a,this.a+W);return this.a+=T.byteLength,T}}e.$Xg=w;class t{constructor(){this.a=[]}get buffer(){return r.$Jb.concat(this.a)}write(W){this.a.push(W)}}e.$Yg=t;var l;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object",U[U.Int=6]="Int"})(l||(l={}));function s(U){const W=r.$Jb.alloc(1);return W.writeUInt8(U,0),W}const n={Undefined:s(l.Undefined),String:s(l.String),Buffer:s(l.Buffer),VSBuffer:s(l.VSBuffer),Array:s(l.Array),Object:s(l.Object),Uint:s(l.Int)},i=typeof Buffer<"u";function a(U,W){if(typeof W>"u")U.write(n.Undefined);else if(typeof W=="string"){const T=r.$Jb.fromString(W);U.write(n.String),k(U,T.byteLength),U.write(T)}else if(i&&Buffer.isBuffer(W)){const T=r.$Jb.wrap(W);U.write(n.Buffer),k(U,T.byteLength),U.write(T)}else if(W instanceof r.$Jb)U.write(n.VSBuffer),k(U,W.byteLength),U.write(W);else if(Array.isArray(W)){U.write(n.Array),k(U,W.length);for(const T of W)a(U,T)}else if(typeof W=="number"&&(W|0)===W)U.write(n.Uint),k(U,W);else{const T=r.$Jb.fromString(JSON.stringify(W));U.write(n.Object),k(U,T.byteLength),U.write(T)}}e.$Zg=a;function m(U){switch(U.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return U.read(c(U)).toString();case l.Buffer:return U.read(c(U)).buffer;case l.VSBuffer:return U.read(c(U));case l.Array:{const T=c(U),J=[];for(let Z=0;Z<T;Z++)J.push(m(U));return J}case l.Object:return JSON.parse(U.read(c(U)).toString());case l.Int:return c(U)}}e.$1g=m;class P{constructor(W,T,J=null,Z=1e3){this.h=W,this.j=T,this.k=J,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(W,T){this.b.set(W,T),setTimeout(()=>this.w(W),0)}m(W){switch(W.type){case 200:{const T=this.o([W.type]);this.k?.logOutgoing(T,0,1,o(W.type));return}case 201:case 202:case 204:case 203:{const T=this.o([W.type,W.id],W.data);this.k?.logOutgoing(T,W.id,1,o(W.type),W.data);return}}}o(W,T=void 0){const J=new t;return a(J,W),a(J,T),this.p(J.buffer)}p(W){try{return this.h.send(W),W.byteLength}catch{return 0}}q(W){const T=new w(W),J=m(T),Z=m(T),ce=J[0];switch(ce){case 100:return this.k?.logIncoming(W.byteLength,J[1],1,`${v(ce)}: ${J[2]}.${J[3]}`,Z),this.s({type:ce,id:J[1],channelName:J[2],name:J[3],arg:Z});case 102:return this.k?.logIncoming(W.byteLength,J[1],1,`${v(ce)}: ${J[2]}.${J[3]}`,Z),this.t({type:ce,id:J[1],channelName:J[2],name:J[3],arg:Z});case 101:return this.k?.logIncoming(W.byteLength,J[1],1,`${v(ce)}`),this.u({type:ce,id:J[1]});case 103:return this.k?.logIncoming(W.byteLength,J[1],1,`${v(ce)}`),this.u({type:ce,id:J[1]})}}s(W){const T=this.b.get(W.channelName);if(!T){this.v(W);return}const J=new M.$dd;let Z;try{Z=T.call(this.j,W.name,W.arg,J.token)}catch(j){Z=Promise.reject(j)}const ce=W.id;Z.then(j=>{this.m({id:ce,data:j,type:201}),this.d.delete(W.id)},j=>{j instanceof Error?this.m({id:ce,data:{message:j.message,name:j.name,stack:j.stack?j.stack.split?j.stack.split(`
`):j.stack:void 0},type:202}):this.m({id:ce,data:j,type:203}),this.d.delete(W.id)});const oe=(0,u.$jb)(()=>J.cancel());this.d.set(W.id,oe)}t(W){const T=this.b.get(W.channelName);if(!T){this.v(W);return}const J=W.id,ce=T.listen(this.j,W.name,W.arg)(oe=>this.m({id:J,data:oe,type:204}));this.d.set(W.id,ce)}u(W){const T=this.d.get(W.id);T&&(T.dispose(),this.d.delete(W.id))}v(W){let T=this.g.get(W.channelName);T||(T=[],this.g.set(W.channelName,T));const J=setTimeout(()=>{console.error(`Unknown channel: ${W.channelName}`),W.type===100&&this.m({id:W.id,data:{name:"Unknown channel",message:`Channel name '${W.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);T.push({request:W,timeoutTimer:J})}w(W){const T=this.g.get(W);if(T){for(const J of T)switch(clearTimeout(J.timeoutTimer),J.request.type){case 100:this.s(J.request);break;case 102:this.t(J.request);break}this.g.delete(W)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$gb)(this.d.values()),this.d.clear()}}e.$2g=P;var I;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class D{constructor(W,T=null){this.l=W,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$7c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(J=>this.s(J)),this.j=T}getChannel(W){const T=this;return{call(J,Z,ce){return T.a?Promise.reject(new S.$3):T.m(W,J,Z,ce)},listen(J,Z){return T.a?f.Event.None:T.o(W,J,Z)}}}m(W,T,J,Z=M.CancellationToken.None){const ce=this.g++,j={id:ce,type:100,channelName:W,name:T,arg:J};if(Z.isCancellationRequested)return Promise.reject(new S.$3);let A;return new Promise((H,V)=>{if(Z.isCancellationRequested)return V(new S.$3);const z=()=>{const le=ge=>{switch(ge.type){case 201:this.f.delete(ce),H(ge.data);break;case 202:{this.f.delete(ce);const Pe=new Error(ge.data.message);Pe.stack=Array.isArray(ge.data.stack)?ge.data.stack.join(`
`):ge.data.stack,Pe.name=ge.data.name,V(Pe);break}case 203:this.f.delete(ce),V(ge.data);break}};this.f.set(ce,le),this.p(j)};let B=null;this.b===g.Idle?z():(B=(0,C.$hg)(le=>this.u()),B.then(()=>{B=null,z()}));const Y=()=>{B?(B.cancel(),B=null):this.p({id:ce,type:101}),V(new S.$3)},se=Z.onCancellationRequested(Y);A=(0,u.$ib)((0,u.$jb)(Y),se),this.d.add(A)}).finally(()=>{this.d.delete(A)})}o(W,T,J){const Z=this.g++,oe={id:Z,type:102,channelName:W,name:T,arg:J};let j=null;const A=new f.$7c({onWillAddFirstListener:()=>{j=(0,C.$hg)(H=>this.u()),j.then(()=>{j=null,this.d.add(A),this.p(oe)})},onDidRemoveLastListener:()=>{j?(j.cancel(),j=null):(this.d.delete(A),this.p({id:Z,type:103}))}}),F=H=>A.fire(H.data);return this.f.set(Z,F),A.event}p(W){switch(W.type){case 100:case 102:{const T=this.q([W.type,W.id,W.channelName,W.name],W.arg);this.j?.logOutgoing(T,W.id,0,`${v(W.type)}: ${W.channelName}.${W.name}`,W.arg);return}case 101:case 103:{const T=this.q([W.type,W.id]);this.j?.logOutgoing(T,W.id,0,v(W.type));return}}}q(W,T=void 0){const J=new t;return a(J,W),a(J,T),this.r(J.buffer)}r(W){try{return this.l.send(W),W.byteLength}catch{return 0}}s(W){const T=new w(W),J=m(T),Z=m(T),ce=J[0];switch(ce){case 200:return this.j?.logIncoming(W.byteLength,0,0,o(ce)),this.t({type:J[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(W.byteLength,J[1],0,o(ce),Z),this.t({type:J[0],id:J[1],data:Z})}}t(W){if(W.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(W.id)?.(W)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$gb)(this.d.values()),this.d.clear()}}e.$3g=D,pe([R.$Rg],D.prototype,"onDidInitializePromise",null);class O{get connections(){const W=[];return this.f.forEach(T=>W.push(T)),W}constructor(W){this.a=new Map,this.f=new Set,this.g=new f.$7c,this.onDidAddConnection=this.g.event,this.h=new f.$7c,this.onDidRemoveConnection=this.h.event,W(({protocol:T,onDidClientDisconnect:J})=>{f.Event.once(T.onMessage)(ce=>{const oe=new w(ce),j=m(oe),A=new P(T,j),F=new D(T);this.a.forEach((V,z)=>A.registerChannel(z,V));const H={channelServer:A,channelClient:F,ctx:j};this.f.add(H),this.g.fire(H),J(()=>{A.dispose(),F.dispose(),this.f.delete(H),this.h.fire(H)})})})}getChannel(W,T){const J=this;return{call(Z,ce,oe){let j;if((0,p.$we)(T)){const F=(0,E.$Jf)(J.connections.filter(T));j=F?Promise.resolve(F):f.Event.toPromise(f.Event.filter(J.onDidAddConnection,T))}else j=T.routeCall(J,Z,ce);const A=j.then(F=>F.channelClient.getChannel(W));return N(A).call(Z,ce,oe)},listen(Z,ce){if((0,p.$we)(T))return J.j(W,T,Z,ce);const oe=T.routeEvent(J,Z,ce).then(j=>j.channelClient.getChannel(W));return N(oe).listen(Z,ce)}}}j(W,T,J,Z){const ce=this;let oe=new u.$kb;const j=new f.$7c({onWillAddFirstListener:()=>{oe=new u.$kb;const A=new f.$ad,F=new Map,H=z=>{const Y=z.channelClient.getChannel(W).listen(J,Z),se=A.add(Y);F.set(z,se)},V=z=>{const B=F.get(z);B&&(B.dispose(),F.delete(z))};ce.connections.filter(T).forEach(H),f.Event.filter(ce.onDidAddConnection,T)(H,void 0,oe),ce.onDidRemoveConnection(V,void 0,oe),A.event(j.fire,j,oe),oe.add(A)},onDidRemoveLastListener:()=>{oe.dispose()}});return j.event}registerChannel(W,T){this.a.set(W,T),this.f.forEach(J=>{J.channelServer.registerChannel(W,T)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$4g=O;class L{constructor(W,T,J=null){const Z=new t;a(Z,T),W.send(Z.buffer),this.a=new D(W,J),this.d=new P(W,T,J)}getChannel(W){return this.a.getChannel(W)}registerChannel(W,T){this.d.registerChannel(W,T)}dispose(){this.a.dispose(),this.d.dispose()}}e.$5g=L;function N(U){return{call(W,T,J){return U.then(Z=>Z.call(W,T,J))},listen(W,T){const J=new f.$cd;return U.then(Z=>J.input=Z.listen(W,T)),J.event}}}e.$6g=N;function q(U){let W=!1;return{call(T,J,Z){return W?U.call(T,J,Z):(0,C.$ug)(0).then(()=>W=!0).then(()=>U.call(T,J,Z))},listen(T,J){if(W)return U.listen(T,J);const Z=new f.$cd;return(0,C.$ug)(0).then(()=>W=!0).then(()=>Z.input=U.listen(T,J)),Z.event}}}e.$7g=q;class re{constructor(W){this.a=W}routeCall(W){return this.b(W)}routeEvent(W){return this.b(W)}async b(W){for(const T of W.connections)if(await Promise.resolve(this.a(T.ctx)))return Promise.resolve(T);return await f.Event.toPromise(W.onDidAddConnection),await this.b(W)}}e.$8g=re;var ne;(function(U){function W(ce,oe){const j=ce,A=oe&&oe.disableMarshalling,F=new Map;for(const H in j)J(H)&&F.set(H,f.Event.buffer(j[H],!0));return new class{listen(H,V,z){const B=F.get(V);if(B)return B;if(Z(V)){const Y=j[V];if(typeof Y=="function")return Y.call(j,z)}throw new S.$ab(`Event not found: ${V}`)}call(H,V,z){const B=j[V];if(typeof B=="function"){if(!A&&Array.isArray(z))for(let Y=0;Y<z.length;Y++)z[Y]=(0,$.$Wg)(z[Y]);return B.apply(j,z)}throw new S.$ab(`Method not found: ${V}`)}}}U.fromService=W;function T(ce,oe){const j=oe&&oe.disableMarshalling;return new Proxy({},{get(A,F){if(typeof F=="string")return oe?.properties?.has(F)?oe.properties.get(F):Z(F)?function(H){return ce.listen(F,H)}:J(F)?ce.listen(F):async function(...H){let V;oe&&!(0,p.$re)(oe.context)?V=[oe.context,...H]:V=H;const z=await ce.call(F,V);return j?z:(0,$.$Wg)(z)};throw new S.$ab(`Property not found: ${String(F)}`)}})}U.toService=T;function J(ce){return ce[0]==="o"&&ce[1]==="n"&&d.$Kd(ce.charCodeAt(2))}function Z(ce){return/^onDynamic/.test(ce)&&d.$Kd(ce.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ae(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){const W=U.toString();if(W!=="[object Object]")return W}return U}function ue(U){return Array.isArray(U)?U.map(ae):ae(U)}function K(U,W,T,J,Z,ce,oe){oe=ue(oe);const j=ee[Z],A=j[J%j.length];let F=[`%c[${U}]%c[${String(W).padStart(7," ")}]%c[len: ${String(T).padStart(5," ")}]%c${String(J).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(ce)?(F=F.concat(oe),F.push(")")):F.push(oe),console.log.apply(console,F)}class X{constructor(W,T){this.d=W,this.f=T,this.a=0,this.b=0}logOutgoing(W,T,J,Z,ce){this.b+=W,K(this.d,this.b,W,T,J,Z,ce)}logIncoming(W,T,J,Z,ce){this.a+=W,K(this.f,this.a,W,T,J,Z,ce)}}e.$9g=X}),define(te[156],ie([0,1,17,3,43]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nS=e.$mS=void 0;class M{constructor(f){this.a=f,this.onMessage=C.Event.fromDOMEventEmitter(this.a,"message",u=>E.$Jb.wrap(u.data)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$mS=M;class R extends r.$5g{constructor(f,u){const $=new M(f);super($,u),this.b=$}dispose(){this.b.disconnect()}}e.$nS=R}),define(te[109],ie([0,1,17,3,2,43]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bh=e.$ah=e.$_g=e.$$g=e.ProtocolConstants=e.$0g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(n){n.Created="created",n.Read="read",n.Write="write",n.Open="open",n.Error="error",n.Close="close",n.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",n.NodeEndReceived="nodeEndReceived",n.NodeEndSent="nodeEndSent",n.NodeDrainBegin="nodeDrainBegin",n.NodeDrainEnd="nodeDrainEnd",n.zlibInflateError="zlibInflateError",n.zlibInflateData="zlibInflateData",n.zlibInflateInitialWrite="zlibInflateInitialWrite",n.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",n.zlibInflateWrite="zlibInflateWrite",n.zlibInflateFlushFired="zlibInflateFlushFired",n.zlibDeflateError="zlibDeflateError",n.zlibDeflateData="zlibDeflateData",n.zlibDeflateWrite="zlibDeflateWrite",n.zlibDeflateFlushFired="zlibDeflateFlushFired",n.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",n.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",n.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",n.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",n.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",n.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",n.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",n.ProtocolHeaderRead="protocolHeaderRead",n.ProtocolMessageRead="protocolMessageRead",n.ProtocolHeaderWrite="protocolHeaderWrite",n.ProtocolMessageWrite="protocolMessageWrite",n.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var S;(function(n){n.enableDiagnostics=!1,n.records=[];const i=new WeakMap;let a=0;function m(I,D){if(!i.has(I)){const O=String(++a);i.set(I,O)}return i.get(I)}function P(I,D,O,L){if(!n.enableDiagnostics)return;const N=m(I,D);if(L instanceof E.$Jb||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const q=E.$Jb.alloc(L.byteLength);q.set(L),n.records.push({timestamp:Date.now(),id:N,label:D,type:O,buff:q})}else n.records.push({timestamp:Date.now(),id:N,label:D,type:O,data:L})}n.traceSocketEvent=P})(S||(e.SocketDiagnostics=S={}));var f;(function(n){n[n.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",n[n.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let u=null;function $(){return u||(u=E.$Jb.alloc(0)),u}class d{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,a){if(i===0)return $();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const D=this.a[0];return a&&(this.a.shift(),this.b-=i),D}if(this.a[0].byteLength>i){const D=this.a[0].slice(0,i);return a&&(this.a[0]=this.a[0].slice(i),this.b-=i),D}const m=E.$Jb.alloc(i);let P=0,I=0;for(;i>0;){const D=this.a[I];if(D.byteLength>i){const O=D.slice(0,i);m.set(O,P),P+=i,a&&(this.a[I]=D.slice(i),this.b-=i),i-=i}else m.set(D,P),P+=D.byteLength,a?(this.a.shift(),this.b-=D.byteLength):I++,i-=D.byteLength}return m}}e.$0g=d;var p;(function(n){n[n.None=0]="None",n[n.Regular=1]="Regular",n[n.Control=2]="Control",n[n.Ack=3]="Ack",n[n.Disconnect=5]="Disconnect",n[n.ReplayRequest=6]="ReplayRequest",n[n.Pause=7]="Pause",n[n.Resume=8]="Resume",n[n.KeepAlive=9]="KeepAlive"})(p||(p={}));function h(n){switch(n){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var v;(function(n){n[n.HeaderLength=13]="HeaderLength",n[n.AcknowledgeTime=2e3]="AcknowledgeTime",n[n.TimeoutTime=2e4]="TimeoutTime",n[n.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",n[n.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",n[n.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(v||(e.ProtocolConstants=v={}));class y{constructor(i,a,m,P){this.type=i,this.id=a,this.ack=m,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class o extends r.$lb{constructor(i){super(),this.f=this.B(new C.$7c),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new d,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const m=this.g.messageType,P=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new y(m,P,I,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=E.$Jb.alloc(13);a.writeUInt8(i.type,0),a.writeUInt32BE(i.id,1),a.writeUInt32BE(i.ack,5),a.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(a,i.data)}g(i,a){const m=this.f===0;return this.d.push(i,a),this.f+=i.byteLength+a.byteLength,m}h(){const i=E.$Jb.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,a){this.g(i,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class c extends r.$lb{constructor(i){super(),this.f=new C.$7c,this.onMessage=this.f.event,this.g=new C.$7c,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new g(this.a)),this.c=this.B(new o(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new y(1,0,0,i))}}e.$$g=c;class b extends M.$5g{static fromSocket(i,a){return new b(new c(i),a)}get onDidDispose(){return this.b.onDidDispose}constructor(i,a,m=null){super(i,a,m),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$_g=b;class k{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$7c({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$ah=k;class w{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,a=this.a;for(;a;)a=a.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let a=0,m=this.a;for(;m;)i[a++]=m.data,m=m.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const a=new w(i);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class l{static{this.a=10}static{this.b=null}static getInstance(){return l.b||(l.b=new l),l.b}constructor(){this.c=[];const i=Date.now();for(let a=0;a<l.a;a++)this.c[a]=i-1e3*a;setInterval(()=>{for(let a=l.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),a=(1+l.a)*1e3;let m=0;for(let P=0;P<l.a;P++)i-this.c[P]<=a&&m++;return 1-m/l.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new k,this.onControlMessage=this.u.event,this.v=new k,this.onMessage=this.v.event,this.w=new k,this.onDidDispose=this.w.event,this.x=new k,this.onSocketClose=this.x.event,this.y=new k,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??l.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new r.$kb,this.o=i.socket,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new y(5,0,0,$());this.p.write(i),this.p.flush()}sendPause(){const i=new y(7,0,0,$());this.p.write(i)}sendResume(){const i=new y(8,0,0,$());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,a){this.a=!0,this.r.dispose(),this.r=new r.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new g(this.o)),this.q=this.r.add(new o(this.o)),this.r.add(this.q.onMessage(m=>this.z(m))),this.r.add(this.o.onClose(m=>this.x.fire(m))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new y(3,0,this.h,$());this.p.write(i);const a=this.b.toArray();for(let m=0,P=a.length;m<P;m++)this.p.write(a[m]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const a=this.b.peek();if(a&&a.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new y(6,0,0,$())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let m=0,P=a.length;m<P;m++)this.p.write(a[m]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const a=++this.c;this.h=this.g;const m=new y(1,a,this.h,i);this.b.push(m),this.a||(this.p.write(m),this.B())}sendControl(i){const a=new y(2,0,0,i);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),a=Date.now()-i.writtenTime,m=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(a>=2e4&&m>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:m});return}const I=Math.max(2e4-a,2e4-m,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new y(3,0,this.h,$());this.p.write(i)}D(){this.h=this.g;const i=new y(9,0,this.h,$());this.p.write(i)}}e.$bh=s}),define(te[157],ie([0,1,38,17,3,2,43,145]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qS=void 0;function f($,d){const p=r.Event.fromNodeEventEmitter(E.$jS,d,(v,y)=>({event:v,message:y})),h=r.Event.filter(p,({event:v})=>v.sender.id===$);return r.Event.map(h,({message:v})=>v&&C.$Jb.wrap(v))}class u extends R.$4g{static{this.b=new Map}static d(){const d=r.Event.fromNodeEventEmitter(E.$jS,"vscode:hello",({sender:p})=>p);return r.Event.map(d,p=>{const h=p.id;u.b.get(h)?.dispose();const y=new r.$7c;u.b.set(h,(0,M.$jb)(()=>y.fire()));const o=f(h,"vscode:message"),g=r.Event.any(r.Event.signal(f(h,"vscode:disconnect")),y.event);return{protocol:new S.$pS(p,o),onDidClientDisconnect:g}})}constructor(){super(u.d())}}e.$qS=u}),define(te[110],ie([0,1,38,3,31,156]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sS=e.$rS=void 0;class R extends M.$nS{constructor(u,$){super({addEventListener:(d,p)=>u.addListener(d,p),removeEventListener:(d,p)=>u.removeListener(d,p),postMessage:d=>u.postMessage(d),start:()=>u.start(),close:()=>u.close()},$)}}e.$rS=R;async function S(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const u=(0,r.$5e)();f.webContents.send("vscode:createMessageChannel",u);const $=C.Event.fromNodeEventEmitter(E.$jS,"vscode:createMessageChannelResult",(p,h)=>({nonce:h,port:p.ports[0]})),{port:d}=await C.Event.toPromise(C.Event.once(C.Event.filter($,p=>p.nonce===u)));return d}e.$sS=S}),define(te[158],ie([0,1,47,8,17,21,153,13,3,2,37,89,73,43]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=void 0;class v extends h.$2g{constructor(g){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",c=>r.$Jb.wrap(Buffer.from(c,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.$Ep=v;class y{constructor(g,c){this.i=g,this.j=c,this.c=new Set,this.g=new Map,this.h=new f.$7c,this.onDidProcessExit=this.h.event;const b=c&&c.timeout?c.timeout:6e4;this.b=new C.$qg(b),this.d=null,this.f=null}getChannel(g){const c=this;return{call(b,k,w){return c.k(g,b,k,w)},listen(b,k){return c.l(g,b,k)}}}k(g,c,b,k=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(k.isCancellationRequested)return Promise.reject(S.$4());this.b.cancel();const w=this.n(g),t=(0,C.$hg)(n=>w.call(c,b,n)),l=k.onCancellationRequested(()=>t.cancel()),s=(0,u.$jb)(()=>t.cancel());return this.c.add(s),t.finally(()=>{l.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,c,b){if(!this.b)return f.Event.None;this.b.cancel();let k;const w=new f.$7c({onWillAddFirstListener:()=>{k=this.n(g).listen(c,b)(w.fire,w),this.c.add(k)},onDidRemoveLastListener:()=>{this.c.delete(k),k.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return w.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,$.$Fm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,p.$el)(c.env),this.d=(0,E.fork)(this.i,g,c);const b=new f.$7c;f.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,R.$Ap)(i)){(0,R.log)(i,`IPC Library: ${this.j.serverName}`);return}b.fire(r.$Jb.wrap(Buffer.from(i,"base64")))});const w=this.j.useQueue?(0,d.$gl)(this.d):this.d,t=i=>this.d&&this.d.connected&&w.send(i.buffer.toString("base64")),l=b.event,s={send:t,onMessage:l};this.f=new h.$3g(s);const n=()=>this.o();process.once("exit",n),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,a)=>{process.removeListener("exit",n),this.c.forEach(m=>(0,u.$gb)(m)),this.c.clear(),i!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:a})})}return this.f}n(g){let c=this.g.get(g);return c||(c=this.m.getChannel(g),this.g.set(g,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Fp=y}),define(te[111],ie([0,1,8,3,2,74,10]),function(G,e,E,C,r,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.StorageState=e.$Do=e.StorageHint=void 0;var S;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function f(p){const h=p;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Do=f;var u;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(u||(e.StorageState=u={}));class $ extends r.$lb{static{this.a=100}constructor(h,v=Object.create(null)){super(),this.m=h,this.n=v,this.b=this.B(new C.$0c),this.onDidChangeStorage=this.b.event,this.c=u.None,this.f=new Map,this.g=new E.$rg($.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){this.b.pause();try{h.changed?.forEach((v,y)=>this.s(y,v)),h.deleted?.forEach(v=>this.s(v,void 0))}finally{this.b.resume()}}s(h,v){if(this.c===u.Closed)return;let y=!1;(0,R.$re)(v)?y=this.f.delete(h):this.f.get(h)!==v&&(this.f.set(h,v),y=!0),y&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===u.None&&(this.c=u.Initialized,this.n.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,v){const y=this.f.get(h);return(0,R.$re)(y)?v:y}getBoolean(h,v){const y=this.get(h);return(0,R.$re)(y)?v:y==="true"}getNumber(h,v){const y=this.get(h);return(0,R.$re)(y)?v:parseInt(y,10)}getObject(h,v){const y=this.get(h);return(0,R.$re)(y)?v:(0,M.$Vg)(y)}async set(h,v,y=!1){if(this.c===u.Closed)return;if((0,R.$re)(v))return this.delete(h,y);const o=(0,R.$ke)(v)||Array.isArray(v)?(0,M.$Ug)(v):String(v);if(this.f.get(h)!==o)return this.f.set(h,o),this.j.set(h,o),this.h.delete(h),this.b.fire({key:h,external:y}),this.w()}async delete(h,v=!1){if(!(this.c===u.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:v}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=u.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===S.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Eo=$;class d{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((v,y)=>this.a.set(y,v)),h.delete?.forEach(v=>this.a.delete(v))}async close(){}}e.$Fo=d}),define(te[159],ie([0,1,8,3,35,9,22]),function(G,e,E,C,r,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PS=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return C.Event.None}static{this.a=2e3}static{this.b=256}constructor($,d=Object.create(null)){this.g=$,this.h=d,this.c=(0,M.$ec)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const $=await this.f,d=new Map;return(await this.s($,"SELECT * FROM ItemTable")).forEach(h=>d.set(h.key,h.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${d.size} rows`),d}async updateItems($){const d=await this.f;return this.j(d,$)}j($,d){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${d.insert?(0,r.$ji)(d.insert):"0"}), delete(${d.delete?(0,r.$ki)(d.delete):"0"})`),this.t($,()=>{const p=d.insert,h=d.delete;if(p&&p.size>0){const v=[];v.push([]);let y=0;p.forEach((o,g)=>{let c=v[y];c.length>S.b&&(y++,c=[],v.push(c)),c.push(g,o)}),v.forEach(o=>{this.u($,`INSERT INTO ItemTable VALUES ${new Array(o.length/2).fill("(?,?)").join(",")}`,g=>g.run(o),()=>{const g=[];let c=0;return p.forEach((b,k)=>{g.push(k),c+=b.length}),`Keys: ${g.join(", ")} Length: ${c}`})})}if(h&&h.size){const v=[];v.push([]);let y=0;h.forEach(o=>{let g=v[y];g.length>S.b&&(y++,g=[],v.push(g)),g.push(o)}),v.forEach(o=>{this.u($,`DELETE FROM ItemTable WHERE key IN (${new Array(o.length).fill("?").join(",")})`,g=>g.run(o),()=>{const g=[];return h.forEach(c=>{g.push(c)}),`Keys: ${g.join(", ")}`})})}})}async close($){this.d.trace(`[storage ${this.c}] close()`);const d=await this.f;return this.k(d,$)}k($,d){return new Promise((p,h)=>{$.db.close(v=>(v&&this.o($,`[storage ${this.c}] close(): ${v}`),this.g===S.IN_MEMORY_PATH?p():!$.isErroneous&&!$.isInMemory?this.l().then(p,y=>(this.d.error(`[storage ${this.c}] backup(): ${y}`),p())):typeof d=="function"?R.Promises.unlink(this.g).then(()=>this.p(this.g).then(y=>{const o=()=>this.k(y,void 0);return this.j(y,{insert:d()}).then(()=>o(),g=>(o(),Promise.reject(g)))})).then(p,h):h(v||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const $=this.m(this.g);return R.Promises.copy(this.g,$,{preserveSymlinks:!1})}m($){return`${$}.backup`}async checkIntegrity($){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${$})`);const d=await this.f,p=await this.r(d,$?"PRAGMA integrity_check":"PRAGMA quick_check"),h=$?p.integrity_check:p.quick_check;return d.isErroneous?`${h} (last error: ${d.lastError})`:d.isInMemory?`${h} (in-memory!)`:h}async n($,d=!0){this.d.trace(`[storage ${this.c}] open(${$}, retryOnBusy: ${d})`);try{return await this.p($)}catch(p){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${p}`),p.code==="SQLITE_BUSY"&&d)return await(0,E.$ug)(S.a),this.n($,!1);try{await R.Promises.unlink($);try{await R.Promises.rename(this.m($),$)}catch{}return await this.p($)}catch(h){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${h}`),this.p(S.IN_MEMORY_PATH)}}}o($,d){$.isErroneous=!0,$.lastError=d,this.d.error(d)}p($){return new Promise((d,p)=>{new Promise((h,v)=>{G(["@vscode/sqlite3"],h,v)}).then(h=>{const v={db:new(this.d.isTracing?h.verbose().Database:h.Database)($,y=>y?v.db&&y.code!=="SQLITE_CANTOPEN"?v.db.close(()=>p(y)):p(y):this.q(v,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>d(v),o=>v.db.close(()=>p(o)))),isInMemory:$===S.IN_MEMORY_PATH};v.db.on("error",y=>this.o(v,`[storage ${this.c}] Error (event): ${y}`)),this.d.isTracing&&v.db.on("trace",y=>this.d.trace(`[storage ${this.c}] Trace (event): ${y}`))},p)})}q($,d){return new Promise((p,h)=>{$.db.exec(d,v=>v?(this.o($,`[storage ${this.c}] exec(): ${v}`),h(v)):p())})}r($,d){return new Promise((p,h)=>{$.db.get(d,(v,y)=>v?(this.o($,`[storage ${this.c}] get(): ${v}`),h(v)):p(y))})}s($,d){return new Promise((p,h)=>{$.db.all(d,(v,y)=>v?(this.o($,`[storage ${this.c}] all(): ${v}`),h(v)):p(y))})}t($,d){return new Promise((p,h)=>{$.db.serialize(()=>{$.db.run("BEGIN TRANSACTION"),d(),$.db.run("END TRANSACTION",v=>v?(this.o($,`[storage ${this.c}] transaction(): ${v}`),h(v)):p())})})}u($,d,p,h){const v=$.db.prepare(d),y=o=>{this.o($,`[storage ${this.c}] prepare(): ${o} (${d}). Details: ${h()}`)};v.on("error",y),p(v),v.finalize(o=>{o&&y(o),v.removeListener("error",y)})}}e.$PS=S;class f{static{this.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}constructor($){$&&typeof $.logTrace=="function"&&process.env[f.VSCODE_TRACE_STORAGE]&&(this.a=$.logTrace),$&&typeof $.logError=="function"&&(this.b=$.logError)}get isTracing(){return!!this.a}trace($){this.a?.($)}error($){this.b?.($)}}}),define(te[160],ie([12,11]),function(G,e){return G.create("vs/code/electron-main/app",e)}),define(te[161],ie([12,11]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[162],ie([12,11]),function(G,e){return G.create("vs/platform/contextkey/common/contextkey",e)}),define(te[163],ie([12,11]),function(G,e){return G.create("vs/platform/contextkey/common/scanner",e)}),define(te[164],ie([12,11]),function(G,e){return G.create("vs/platform/dialogs/common/dialogs",e)}),define(te[165],ie([12,11]),function(G,e){return G.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[166],ie([12,11]),function(G,e){return G.create("vs/platform/environment/node/argv",e)}),define(te[167],ie([12,11]),function(G,e){return G.create("vs/platform/environment/node/argvHelper",e)}),define(te[168],ie([12,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[169],ie([12,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[170],ie([12,11]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[171],ie([12,11]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[172],ie([12,11]),function(G,e){return G.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[173],ie([12,11]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(te[174],ie([12,11]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(te[175],ie([12,11]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(te[176],ie([12,11]),function(G,e){return G.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[177],ie([12,11]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[178],ie([12,11]),function(G,e){return G.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[179],ie([12,11]),function(G,e){return G.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[180],ie([12,11]),function(G,e){return G.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[181],ie([12,11]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(te[182],ie([12,11]),function(G,e){return G.create("vs/platform/shell/node/shellEnv",e)}),define(te[183],ie([12,11]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[184],ie([12,11]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[185],ie([12,11]),function(G,e){return G.create("vs/platform/terminal/common/terminalProfiles",e)}),define(te[186],ie([12,11]),function(G,e){return G.create("vs/platform/update/common/update.config.contribution",e)}),define(te[187],ie([12,11]),function(G,e){return G.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[188],ie([12,11]),function(G,e){return G.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[189],ie([12,11]),function(G,e){return G.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[190],ie([12,11]),function(G,e){return G.create("vs/platform/workspace/common/workspace",e)}),define(te[191],ie([12,11]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[192],ie([12,11]),function(G,e){return G.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[193],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zab=e.$yab=void 0;function E(r){return r&&r.hasOwnProperty("folderUri")}e.$yab=E;function C(r){return r&&r.hasOwnProperty("workspace")}e.$zab=C}),define(te[194],ie([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q3b=e.$p3b=e.$o3b=void 0;function C(R){return typeof R?.backupFolder=="string"}e.$o3b=C;function r(R){let S=[];try{Array.isArray(R.workspaces)&&(S=R.workspaces.map(f=>({workspace:{id:f.id,configPath:E.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$p3b=r;function M(R){let S=[];try{Array.isArray(R.folders)&&(S=R.folders.map(f=>({folderUri:E.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$q3b=M}),define(te[195],ie([0,1,13,163]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.TokenType=void 0;var r;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(r||(e.TokenType=r={}));function M(...u){switch(u.length){case 1:return(0,C.localize)(0,null,u[0]);case 2:return(0,C.localize)(1,null,u[0],u[1]);case 3:return(0,C.localize)(2,null,u[0],u[1],u[2]);default:return}}const R=(0,C.localize)(3,null),S=(0,C.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme($){switch($.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return $.isTripleEq?"===":"==";case 4:return $.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return $.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return $.lexeme;case 18:return $.lexeme;case 19:return $.lexeme;case 20:return"EOF";default:throw(0,E.$6)(`unhandled token type: ${JSON.stringify($)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map($=>$.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset($){return this.c=$,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const d=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:d})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const d=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:d})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h($){return this.r()||this.c.charCodeAt(this.e)!==$?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k($){this.f.push({type:$,offset:this.d})}l($){const d=this.d,p=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:p};this.g.push({offset:d,lexeme:p,additionalInfo:$}),this.f.push(h)}n(){this.m.lastIndex=this.d;const $=this.m.exec(this.c);if($){this.e=this.d+$[0].length;const d=this.c.substring(this.d,this.e),p=f.b.get(d);p?this.k(p):this.f.push({type:17,lexeme:d,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let $=this.e,d=!1,p=!1;for(;;){if($>=this.c.length){this.e=$,this.l(S);return}const v=this.c.charCodeAt($);if(d)d=!1;else if(v===47&&!p){$++;break}else v===91?p=!0:v===92?d=!0:v===93&&(p=!1);$++}for(;$<this.c.length&&f.a.has(this.c.charCodeAt($));)$++;this.e=$;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$qi=f}),define(te[196],ie([0,1,3,2]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=e.$qn=void 0;class r{constructor(){this.a=new E.$7c,this.b=new E.$7c,this.c=new E.$7c,this.d=new E.$7c}static{this.ChannelName="extensionhostdebugservice"}call(S,f,u){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:u[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:u[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:u[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:u[0],port:u[1],subId:u[2]}))}throw new Error("Method not implemented.")}listen(S,f,u){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$qn=r;class M extends C.$lb{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,f,u){this.b.call("attach",[S,f,u])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,f){this.b.call("terminate",[S,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,f){return this.b.call("openExtensionDevelopmentHostWindow",[S,f])}}e.$rn=M}),define(te[197],ie([0,1,148,55,15,9,36,19,7]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0,e.$Rl=/^([^.]+\..+):(.+)$/;class u{get appRoot(){return(0,M.$dc)(r.$3e.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,M.$ac)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,S.$8f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:r.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$8f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,E.$Ql)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$ac)(this.userDataPath,"logs",h)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$8f)(f.URI.file((0,M.$ac)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$8f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$8f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$8f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=R.env.VSCODE_PORTABLE;return h?f.URI.file((0,M.$ac)(h,"argv.json")):(0,S.$8f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,M.$ac)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,M.$bc)(h):(0,M.$$b)((0,M.$ac)(r.$3e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?f.URI.file((0,M.$bc)(h)):f.URI.file((0,M.$ac)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,M.$bc)(h);const v=R.env.VSCODE_EXTENSIONS;if(v)return v;const y=R.env.VSCODE_PORTABLE;return y?(0,M.$ac)(y,"extensions"):(0,S.$8f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(v=>/^[^:/?#]+?:\/\//.test(v)?f.URI.parse(v):f.URI.file((0,M.$$b)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?f.URI.parse(h):f.URI.file((0,M.$$b)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return $(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Rl.test(h))}get extensionLogLevel(){const h=[];for(const v of this.args.log||[]){const y=e.$Rl.exec(v);y&&y[1]&&y[2]&&h.push([y[1],y[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,S.$8f)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=R.env.VSCODE_PORTABLE;return h?f.URI.file((0,M.$ac)(h,"policy.json")):(0,S.$8f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,v,y){this.a=h,this.b=v,this.c=y,this.editSessionId=this.args.editSessionId}}e.$Sl=u,pe([C.$Rg],u.prototype,"appRoot",null),pe([C.$Rg],u.prototype,"userHome",null),pe([C.$Rg],u.prototype,"userDataPath",null),pe([C.$Rg],u.prototype,"appSettingsHome",null),pe([C.$Rg],u.prototype,"tmpDir",null),pe([C.$Rg],u.prototype,"cacheHome",null),pe([C.$Rg],u.prototype,"stateResource",null),pe([C.$Rg],u.prototype,"userRoamingDataHome",null),pe([C.$Rg],u.prototype,"userDataSyncHome",null),pe([C.$Rg],u.prototype,"sync",null),pe([C.$Rg],u.prototype,"machineSettingsResource",null),pe([C.$Rg],u.prototype,"workspaceStorageHome",null),pe([C.$Rg],u.prototype,"localHistoryHome",null),pe([C.$Rg],u.prototype,"keyboardLayoutResource",null),pe([C.$Rg],u.prototype,"argvResource",null),pe([C.$Rg],u.prototype,"isExtensionDevelopment",null),pe([C.$Rg],u.prototype,"untitledWorkspacesHome",null),pe([C.$Rg],u.prototype,"builtinExtensionsPath",null),pe([C.$Rg],u.prototype,"extensionsPath",null),pe([C.$Rg],u.prototype,"extensionDevelopmentLocationURI",null),pe([C.$Rg],u.prototype,"extensionDevelopmentKind",null),pe([C.$Rg],u.prototype,"extensionTestsLocationURI",null),pe([C.$Rg],u.prototype,"debugExtensionHost",null),pe([C.$Rg],u.prototype,"logLevel",null),pe([C.$Rg],u.prototype,"extensionLogLevel",null),pe([C.$Rg],u.prototype,"serviceMachineIdResource",null),pe([C.$Rg],u.prototype,"disableTelemetry",null),pe([C.$Rg],u.prototype,"disableWorkspaceTrust",null),pe([C.$Rg],u.prototype,"policyFile",null);function $(p,h){return d(p["inspect-extensions"],p["inspect-brk-extensions"],5870,h,p.debugId,p.extensionEnvironment)}e.$Tl=$;function d(p,h,v,y,o,g){const b=Number(h||p)||(y?null:v),k=b?!!h:!1;let w;if(g)try{w=JSON.parse(g)}catch{}return{port:b,break:k,debugId:o,env:w}}e.$Ul=d}),define(te[112],ie([0,1,307,4,166]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ml=e.$ll=e.$kl=e.$jl=e.$il=void 0;const M={o:(0,r.localize)(0,null),e:(0,r.localize)(1,null),t:(0,r.localize)(2,null)};e.$il={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,r.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,r.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,r.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,r.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,r.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,r.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,r.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,r.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,r.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,r.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,r.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,r.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,r.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,r.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,r.localize)(17,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,r.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,r.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,r.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,r.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,r.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,r.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,r.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,r.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,r.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,r.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,r.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,r.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,r.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,r.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,r.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,r.localize)(33,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,r.localize)(34,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,r.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(y,o,g=R){const c=y.find(a=>a.length>0&&a[0]!=="-"),b={},k=["_"],w=[],t={};let l;for(const a in o){const m=o[a];m.type==="subcommand"?a===c&&(l=m):(m.alias&&(b[a]=m.alias),m.type==="string"||m.type==="string[]"?(k.push(a),m.deprecates&&k.push(...m.deprecates)):m.type==="boolean"&&(w.push(a),m.deprecates&&w.push(...m.deprecates)),m.global&&(t[a]=m))}if(l&&c){const a=t;for(const D in l.options)a[D]=l.options[D];const m=y.filter(D=>D!==c),P=g.getSubcommandReporter?g.getSubcommandReporter(c):void 0,I=S(m,a,P);return{[c]:I,_:[]}}const s=E(y,{string:k,boolean:w,alias:b}),n={},i=s;n._=s._.map(a=>String(a)).filter(a=>a.length>0),delete i._;for(const a in o){const m=o[a];if(m.type==="subcommand")continue;m.alias&&delete i[m.alias];let P=i[a];if(m.deprecates)for(const I of m.deprecates)i.hasOwnProperty(I)&&(P||(P=i[I],P&&g.onDeprecatedOption(I,m.deprecationMessage||(0,r.localize)(36,null,a))),delete i[I]);if(typeof P<"u"){if(m.type==="string[]"){if(Array.isArray(P)||(P=[P]),!m.allowEmptyValue){const I=P.filter(D=>D.length>0);I.length!==P.length&&(g.onEmptyValue(a),P=I.length>0?I:void 0)}}else m.type==="string"&&(Array.isArray(P)?(P=P.pop(),g.onMultipleValues(a,P)):!P&&!m.allowEmptyValue&&(g.onEmptyValue(a),P=void 0));n[a]=P,m.deprecationMessage&&g.onDeprecatedOption(a,m.deprecationMessage)}delete i[a]}for(const a in i)g.onUnknownOption(a);return n}e.$jl=S;function f(y,o){let g="";return o.args&&(Array.isArray(o.args)?g=` <${o.args.join("> <")}>`:g=` <${o.args}>`),o.alias?`-${o.alias} --${y}${g}`:`--${y}${g}`}function u(y,o){const g=[];for(const c in y){const b=y[c],k=f(c,b);g.push([k,b.description])}return $(g,o)}e.$kl=u;function $(y,o){const c=y.reduce((w,t)=>Math.max(w,t[0].length),12)+2+1;if(o-c<25)return y.reduce((w,t)=>w.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const b=o-c-1,k=[];for(const w of y){const t=w[0],l=p(w[1],b),s=d(c-t.length-2);k.push("  "+t+s+l[0]);for(let n=1;n<l.length;n++)k.push(d(c)+l[n])}return k}function d(y){return" ".repeat(y)}function p(y,o){const g=[];for(;y.length;){const c=y.length<o?y.length:y.lastIndexOf(" ",o),b=y.slice(0,c).trim();y=y.slice(c),g.push(b)}return g}function h(y,o,g,c,b){const k=process.stdout.isTTY&&process.stdout.columns||80,w=b?.noInputFiles!==!0?`[${(0,r.localize)(37,null)}...]`:"",t=[`${y} ${g}`];t.push(""),t.push(`${(0,r.localize)(38,null)}: ${o} [${(0,r.localize)(39,null)}]${w}`),t.push(""),b?.noPipe!==!0&&(C.$i?t.push((0,r.localize)(40,null,o)):t.push((0,r.localize)(41,null,o)),t.push(""));const l={},s=[];for(const n in c){const i=c[n];if(i.type==="subcommand")i.description&&s.push({command:n,description:i.description});else if(i.description&&i.cat){let a=l[i.cat];a||(l[i.cat]=a={}),a[n]=i}}for(const n in l){const i=n,a=l[i];a&&(t.push(M[i]),t.push(...u(a,k)),t.push(""))}return s.length&&(t.push((0,r.localize)(42,null)),t.push(...$(s.map(n=>[n.command,n.description]),k)),t.push("")),t.join(`
`)}e.$ll=h;function v(y,o){return`${y||(0,r.localize)(43,null)}
${o||(0,r.localize)(44,null)}
${process.arch}`}e.$ml=v}),define(te[198],ie([0,1,88,196,112]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x3b=void 0;class M extends C.$qn{constructor(S){super(),this.f=S}call(S,f,u){return f==="openExtensionDevelopmentHostWindow"?this.g(u[0],u[1]):super.call(S,f,u)}async g(S,f){const u=(0,r.$jl)(S,r.$il);u.debugRenderer=f;const $=u.extensionDevelopmentPath;if(!$)return{success:!1};const[d]=await this.f.openExtensionDevelopmentHostWindow($,{context:5,cli:u,forceProfile:u.profile,forceTempProfile:u["profile-temp"]});if(!f)return{success:!0};const p=d.win;if(!p)return{success:!0};const h=p.webContents.debugger;let v=h.isAttached()?1/0:0;const y=(0,E.createServer)(o=>{v++===0&&h.attach();let g=!1;const c=w=>{g||o.write(JSON.stringify(w)+"\0")},b=(w,t,l,s)=>c({method:t,params:l,sessionId:s});p.on("close",()=>{h.removeListener("message",b),o.end(),g=!0}),h.addListener("message",b);let k=Buffer.alloc(0);o.on("data",w=>{k=Buffer.concat([k,w]);for(let t=k.indexOf(0);t!==-1;t=k.indexOf(0)){let l;try{const s=k.slice(0,t).toString("utf8");k=k.slice(t+1),l=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}h.sendCommand(l.method,l.params,l.sessionId).then(s=>c({id:l.id,sessionId:l.sessionId,result:s})).catch(s=>c({id:l.id,sessionId:l.sessionId,error:{code:0,message:s.message}}))}}),o.on("error",w=>{console.error("error on cdp pipe:",w)}),o.on("close",()=>{g=!0,--v===0&&h.detach()})});return await new Promise(o=>y.listen(0,o)),p.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$x3b=M}),define(te[63],ie([0,1,308,167,112]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ql=e.$pl=e.$ol=e.$nl=void 0;function M(d,p){const h=(b,k)=>{console.warn((0,C.localize)(0,null,b,k))},v=b=>{console.warn((0,C.localize)(1,null,b))},y=(b,k)=>{console.warn((0,C.localize)(2,null,b,k))},o=b=>({onUnknownOption:k=>{b!=="tunnel"&&console.warn((0,C.localize)(3,null,k,b))},onMultipleValues:h,onEmptyValue:v,onDeprecatedOption:y,getSubcommandReporter:b!=="tunnel"?o:void 0}),g={onUnknownOption:b=>{console.warn((0,C.localize)(4,null,b))},onMultipleValues:h,onEmptyValue:v,onDeprecatedOption:y,getSubcommandReporter:o},c=(0,r.$jl)(d,r.$il,p?g:void 0);return c.goto&&c._.forEach(b=>E(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(b),(0,C.localize)(5,null))),c}function R(d){const p=d.findIndex(h=>!/^-/.test(h));if(p>-1)return[...d.slice(0,p),...d.slice(p+1)]}function S(d){let[,...p]=d;process.env.VSCODE_DEV&&(p=R(p)||[]);const h=!$(process.env);return M(p,h)}e.$nl=S;function f(d){let[,,...p]=d;return process.env.VSCODE_DEV&&(p=R(p)||[]),M(p,!0)}e.$ol=f;function u(d,...p){const h=d.indexOf("--");return h===-1?d.push(...p):d.splice(h,0,...p),d}e.$pl=u;function $(d){return d.VSCODE_CLI==="1"}e.$ql=$}),function(){"use strict";function G(e,E,C){function r(R,S){const f=M(R,S),u=[f];return e.isAbsolute(f)||u.unshift(C),e.resolve(...u)}function M(R,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,S);const $=R["user-data-dir"];if($)return $;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const d=process.env.USERPROFILE;if(typeof d!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(d,"AppData","Roaming")}break;case"darwin":u=e.join(E.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,S)}return{getUserDataPath:r}}if(typeof define=="function")define(te[199],ie([113,27,36]),function(e,E,C){return G(e,E,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=G(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[90],ie([0,1,27,197,199]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=void 0;class M extends C.$Sl{constructor(u,$){super(u,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,r.getUserDataPath)(u,$.nameShort)},$)}}e.$Vl=M;function R(f,u){return(0,C.$Ul)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,u,f.extensionEnvironment)}e.$Wl=R;function S(f,u){return(0,C.$Ul)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,u,f.extensionEnvironment)}e.$Xl=S}),define(te[200],ie([0,1,42,27,32]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X4b=void 0;function M(R){const S=(0,r.$Re)((0,C.tmpdir)());try{return(0,E.writeFileSync)(S,""),R&&console.log(`Marker file for --wait created: ${S}`),S}catch(f){R&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$X4b=M}),define(te[201],ie([0,1,10,169]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;function r(R,S,f){try{M(R,S,f)}catch(u){console.error(u?.message??u)}return R}e.$ap=r;function M(R,S,f){const u=($,d,p)=>{const h=$[d];if((0,E.$ie)(h)){const v=h,y=v.length;if(y>1&&v[0]==="%"&&v[y-1]==="%"){const o=v.substr(1,y-2);let g=S[o];g===void 0&&f&&(g=f[o]);const c=typeof g=="string"?g:g?.message,b=f?.[o],k=typeof b=="string"?b:b?.message;if(!c){k||console.warn(`[${R.name}]: ${(0,C.localize)(0,null,o)}`);return}if(p&&(d==="title"||d==="category")&&k&&k!==c){const w={value:c,original:k};$[d]=w}else $[d]=c}}else if((0,E.$ke)(h))for(const v in h)h.hasOwnProperty(v)&&(v==="commands"?u(h,v,!0):u(h,v,p));else if(Array.isArray(h))for(let v=0;v<h.length;v++)u(h,v,p)};for(const $ in R)R.hasOwnProperty($)&&u(R,$)}}),define(te[202],ie([0,1,19,70,171,203]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function f(g){return g=g.trim(),g==="*"||R.test(g)}e.$po=f;function u(g){if(!f(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=g.match(R);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$qo=u;function $(g){if(!g)return null;const c=g.majorBase,b=g.majorMustEqual,k=g.minorBase;let w=g.minorMustEqual;const t=g.patchBase;let l=g.patchMustEqual;g.hasCaret&&(c===0||(w=!1),l=!1);let s=0;if(g.preRelease){const n=S.exec(g.preRelease);if(n){const[,i,a,m]=n;s=Date.UTC(Number(i),Number(a)-1,Number(m))}}return{majorBase:c,majorMustEqual:b,minorBase:k,minorMustEqual:w,patchBase:t,patchMustEqual:l,isMinimum:g.hasGreaterEquals,notBefore:s}}e.$ro=$;function d(g,c,b){let k;typeof g=="string"?k=$(u(g)):k=g;let w;c instanceof Date?w=c.getTime():typeof c=="string"&&(w=new Date(c).getTime());let t;if(typeof b=="string"?t=$(u(b)):t=b,!k||!t)return!1;const l=k.majorBase,s=k.minorBase,n=k.patchBase;let i=t.majorBase,a=t.minorBase,m=t.patchBase;const P=t.notBefore;let I=t.majorMustEqual,D=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?l>i?!0:l<i?!1:s>a?!0:s<a||w&&w<P?!1:n>=m:(l===1&&i===0&&(!I||!D||!O)&&(i=1,a=0,m=0,I=!0,D=!1,O=!1),l<i?!1:l>i?!I:s<a?!1:s>a?!D:n<m?!1:n>m?!O:!(w&&w<P))}e.$so=d;function p(g,c,b,k,w){const t=[];if(typeof k.publisher<"u"&&typeof k.publisher!="string")return t.push([C.default.Error,r.localize(0,null)]),t;if(typeof k.name!="string")return t.push([C.default.Error,r.localize(1,null,"name")]),t;if(typeof k.version!="string")return t.push([C.default.Error,r.localize(2,null,"version")]),t;if(!k.engines)return t.push([C.default.Error,r.localize(3,null,"engines")]),t;if(typeof k.engines.vscode!="string")return t.push([C.default.Error,r.localize(4,null,"engines.vscode")]),t;if(typeof k.extensionDependencies<"u"&&!o(k.extensionDependencies))return t.push([C.default.Error,r.localize(5,null,"extensionDependencies")]),t;if(typeof k.activationEvents<"u"){if(!o(k.activationEvents))return t.push([C.default.Error,r.localize(6,null,"activationEvents")]),t;if(typeof k.main>"u"&&typeof k.browser>"u")return t.push([C.default.Error,r.localize(7,null,"activationEvents","main","browser")]),t}if(typeof k.extensionKind<"u"&&typeof k.main>"u"&&t.push([C.default.Warning,r.localize(8,null,"extensionKind")]),typeof k.main<"u"){if(typeof k.main!="string")return t.push([C.default.Error,r.localize(9,null,"main")]),t;{const n=(0,E.$8f)(b,k.main);(0,E.$2f)(n,b)||t.push([C.default.Warning,r.localize(10,null,n.path,b.path)])}}if(typeof k.browser<"u"){if(typeof k.browser!="string")return t.push([C.default.Error,r.localize(11,null,"browser")]),t;{const n=(0,E.$8f)(b,k.browser);(0,E.$2f)(n,b)||t.push([C.default.Warning,r.localize(12,null,n.path,b.path)])}}if(!M.valid(k.version))return t.push([C.default.Error,r.localize(13,null)]),t;const l=[];if(!h(g,c,k,w,l))for(const n of l)t.push([C.default.Error,n]);return t}e.$to=p;function h(g,c,b,k,w){return k||typeof b.main>"u"&&typeof b.browser>"u"?!0:y(g,c,b.engines.vscode,w)}e.$uo=h;function v(g,c,b){return g==="*"||y(c,b,g)}e.$vo=v;function y(g,c,b,k=[]){const w=$(u(b));if(!w)return k.push(r.localize(14,null,b)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return k.push(r.localize(15,null,b)),!1}else if(!w.majorMustEqual)return k.push(r.localize(16,null,b)),!1;return d(g,c,w)?!0:(k.push(r.localize(17,null,g,b)),!1)}function o(g){if(!Array.isArray(g))return!1;for(let c=0,b=g.length;c<b;c++)if(typeof g[c]!="string")return!1;return!0}}),define(te[204],ie([0,1,17,31]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=void 0;async function r(M,R,S){let f=S&&S.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const $=(await R.readFile(M.serviceMachineIdResource)).value.toString();f=(0,C.$4e)($)?$:null}catch{f=null}if(!f){f=(0,C.$5e)();try{await R.writeFile(M.serviceMachineIdResource,E.$Jb.fromString(f))}catch{}}return S?.store("storage.serviceMachineId",f,-1,1),f}e.$Oo=r}),define(te[75],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=void 0;class E{constructor(r,M=[],R=!1){this.ctor=r,this.staticArguments=M,this.supportsDelayedInstantiation=R}}e.$kh=E}),define(te[205],ie([0,1,75]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.InstantiationType=void 0;const C=[];var r;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(r||(e.InstantiationType=r={}));function M(S,f,u){f instanceof E.$kh||(f=new E.$kh(f,[],!!u)),C.push([S,f])}e.$0q=M;function R(){return C}e.$$q=R}),define(te[206],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;class E{constructor(M,R){this.key=M,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Qp=E;class C{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const R of this.a.values())R.outgoing.size===0&&M.push(R);return M}insertEdge(M,R){const S=this.lookupOrInsertNode(M),f=this.lookupOrInsertNode(R);S.outgoing.set(f.key,f),f.incoming.set(S.key,S)}removeNode(M){const R=this.b(M);this.a.delete(R);for(const S of this.a.values())S.outgoing.delete(R),S.incoming.delete(R)}lookupOrInsertNode(M){const R=this.b(M);let S=this.a.get(R);return S||(S=new E(R,M),this.a.set(R,S)),S}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[R,S]of this.a)M.push(`${R}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,R]of this.a){const S=new Set([M]),f=this.c(R,S);if(f)return f}}c(M,R){for(const[S,f]of M.outgoing){if(R.has(S))return[...R,S].join(" -> ");R.add(S);const u=this.c(f,R);if(u)return u;R.delete(S)}}}e.$Rp=C}),define(te[6],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function S(f){return f[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=S})(E||(e._util=E={})),e.$mh=r("instantiationService");function C(R,S,f){S[E.DI_TARGET]===S?S[E.DI_DEPENDENCIES].push({id:R,index:f}):(S[E.DI_DEPENDENCIES]=[{id:R,index:f}],S[E.DI_TARGET]=S)}function r(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const S=function(f,u,$){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(S,f,$)};return S.toString=()=>R,E.serviceIds.set(R,S),S}e.$nh=r;function M(R){return R}e.$oh=M}),define(te[64],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r3b=void 0,e.$r3b=(0,E.$nh)("backupMainService")}),define(te[18],ie([0,1,10,7,6]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.ConfigurationTarget=e.$Vh=e.$Uh=e.$Th=void 0,e.$Th=(0,r.$nh)("configurationService");function M(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof C.URI)}e.$Uh=M;function R(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||Array.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof C.URI)}e.$Vh=R;var S;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.USER=2]="USER",g[g.USER_LOCAL=3]="USER_LOCAL",g[g.USER_REMOTE=4]="USER_REMOTE",g[g.WORKSPACE=5]="WORKSPACE",g[g.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",g[g.DEFAULT=7]="DEFAULT",g[g.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function f(g){switch(g){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Wh=f;function u(g){return g.applicationValue!==void 0||g.userValue!==void 0||g.userLocalValue!==void 0||g.userRemoteValue!==void 0||g.workspaceValue!==void 0||g.workspaceFolderValue!==void 0}e.$Xh=u;function $(g,c){const b=Object.create(null);for(const k in g)d(b,k,g[k],c);return b}e.$Yh=$;function d(g,c,b,k){const w=c.split("."),t=w.pop();let l=g;for(let s=0;s<w.length;s++){const n=w[s];let i=l[n];switch(typeof i){case"undefined":i=l[n]=Object.create(null);break;case"object":break;default:k(`Ignoring ${c} as ${w.slice(0,s+1).join(".")} is ${JSON.stringify(i)}`);return}l=i}if(typeof l=="object"&&l!==null)try{l[t]=b}catch{k(`Ignoring ${c} as ${w.join(".")} is ${JSON.stringify(l)}`)}else k(`Ignoring ${c} as ${w.join(".")} is ${JSON.stringify(l)}`)}e.$Zh=d;function p(g,c){const b=c.split(".");h(g,b)}e.$1h=p;function h(g,c){const b=c.shift();if(c.length===0){delete g[b];return}if(Object.keys(g).indexOf(b)!==-1){const k=g[b];typeof k=="object"&&!Array.isArray(k)&&(h(k,c),Object.keys(k).length===0&&delete g[b])}}function v(g,c,b){function k(l,s){let n=l;for(const i of s){if(typeof n!="object"||n===null)return;n=n[i]}return n}const w=c.split("."),t=k(g,w);return typeof t>"u"?b:t}e.$2h=v;function y(g,c,b){Object.keys(c).forEach(k=>{k!=="__proto__"&&(k in g?E.$ke(g[k])&&E.$ke(c[k])?y(g[k],c[k],b):b&&(g[k]=c[k]):g[k]=c[k])})}e.$3h=y;function o(g){return g.replace(/[\[\]]/g,"")}e.$4h=o}),define(te[114],ie([0,1,4,25,195,6,162,13]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ContextKeyExprType=e.$ri=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",E.$j),f.set("isLinux",E.$k),f.set("isWindows",E.$i),f.set("isWeb",E.$o),f.set("isMacNative",E.$j&&!E.$o),f.set("isEdge",E.$G),f.set("isFirefox",E.$E),f.set("isChrome",E.$D),f.set("isSafari",E.$F);function u(j,A){if(f.get(j)!==void 0)throw(0,S.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(j,A)}e.$ri=u;const $=Object.prototype.hasOwnProperty;var d;(function(j){j[j.False=0]="False",j[j.True=1]="True",j[j.Defined=2]="Defined",j[j.Not=3]="Not",j[j.Equals=4]="Equals",j[j.NotEquals=5]="NotEquals",j[j.And=6]="And",j[j.Regex=7]="Regex",j[j.NotRegex=8]="NotRegex",j[j.Or=9]="Or",j[j.In=10]="In",j[j.NotIn=11]="NotIn",j[j.Greater=12]="Greater",j[j.GreaterEquals=13]="GreaterEquals",j[j.Smaller=14]="Smaller",j[j.SmallerEquals=15]="SmallerEquals"})(d||(e.ContextKeyExprType=d={}));const p={regexParsingWithErrorRecovery:!0},h=(0,R.localize)(0,null),v=(0,R.localize)(1,null),y=(0,R.localize)(2,null),o=(0,R.localize)(3,null),g=(0,R.localize)(4,null),c=(0,R.localize)(5,null),b=(0,R.localize)(6,null),k=(0,R.localize)(7,null);class w{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=p){this.k=A,this.d=new r.$qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:v});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const H=this.D(),V=H.type===17?c:void 0;throw this.h.push({message:g,offset:H.offset,lexeme:r.$qi.getLexeme(H),additionalInfo:V}),w.c}return F}catch(F){if(F!==w.c)throw F;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const F=this.o();A.push(F)}return A.length===1?A[0]:t.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const F=this.s();A.push(F)}return A.length===1?A[0]:t.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,o),F?.negate()}case 17:return this.z(),L.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,o),F}case 17:{const F=A.lexeme;if(this.z(),this.y(9)){const V=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),V.type!==10)throw this.B("REGEX",V);const z=V.lexeme,B=z.lastIndexOf("/"),Y=B===z.length-1?void 0:this.w(z.substring(B+1));let se;try{se=new RegExp(z.substring(1,B),Y)}catch{throw this.B("REGEX",V)}return ae.create(F,se)}switch(V.type){case 10:case 19:{const z=[V.lexeme];this.z();let B=this.D(),Y=0;for(let Re=0;Re<V.lexeme.length;Re++)V.lexeme.charCodeAt(Re)===40?Y++:V.lexeme.charCodeAt(Re)===41&&Y--;for(;!this.E()&&B.type!==15&&B.type!==16;){switch(B.type){case 0:Y++;break;case 1:Y--;break;case 10:case 18:for(let Re=0;Re<B.lexeme.length;Re++)B.lexeme.charCodeAt(Re)===40?Y++:V.lexeme.charCodeAt(Re)===41&&Y--}if(Y<0)break;z.push(r.$qi.getLexeme(B)),this.z(),B=this.D()}const se=z.join(""),le=se.lastIndexOf("/"),ge=le===se.length-1?void 0:this.w(se.substring(le+1));let Pe;try{Pe=new RegExp(se.substring(1,le),ge)}catch{throw this.B("REGEX",V)}return t.regex(F,Pe)}case 18:{const z=V.lexeme;this.z();let B=null;if(!(0,C.$jd)(z)){const Y=z.indexOf("/"),se=z.lastIndexOf("/");if(Y!==se&&Y>=0){const le=z.slice(Y+1,se),ge=z[se+1]==="i"?"i":"";try{B=new RegExp(le,ge)}catch{throw this.B("REGEX",V)}}}if(B===null)throw this.B("REGEX",V);return ae.create(F,B)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const V=this.u();return t.notIn(F,V)}switch(this.D().type){case 3:{this.z();const V=this.u();if(this.x().type===18)return t.equals(F,V);switch(V){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,V)}}case 4:{this.z();const V=this.u();if(this.x().type===18)return t.notEquals(F,V);switch(V){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,V)}}case 5:return this.z(),ne.create(F,this.u());case 6:return this.z(),ee.create(F,this.u());case 7:return this.z(),q.create(F,this.u());case 8:return this.z(),re.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:b,offset:A.offset,lexeme:"",additionalInfo:k}),w.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,F){if(this.C(A))return this.z();throw this.B(F,this.D())}B(A,F,H){const V=(0,R.localize)(8,null,A,r.$qi.getLexeme(F)),z=F.offset,B=r.$qi.getLexeme(F);return this.h.push({message:V,offset:z,lexeme:B,additionalInfo:H}),w.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$si=w;class t{static false(){return i.INSTANCE}static true(){return a.INSTANCE}static has(A){return m.create(A)}static equals(A,F){return P.create(A,F)}static notEquals(A,F){return O.create(A,F)}static regex(A,F){return ae.create(A,F)}static in(A,F){return I.create(A,F)}static notIn(A,F){return D.create(A,F)}static not(A){return L.create(A)}static and(...A){return X.create(A,null,!0)}static or(...A){return U.create(A,null,!0)}static greater(A,F){return q.create(A,F)}static greaterEquals(A,F){return re.create(A,F)}static smaller(A,F){return ne.create(A,F)}static smallerEquals(A,F){return ee.create(A,F)}static{this.c=new w({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$ti=t;function l(j){const A=new w({regexParsingWithErrorRecovery:!1});return j.map(F=>(A.parse(F),A.lexingErrors.length>0?A.lexingErrors.map(H=>({errorMessage:H.additionalInfo?(0,R.localize)(9,null,H.additionalInfo):(0,R.localize)(10,null),offset:H.offset,length:H.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(H=>({errorMessage:H.additionalInfo?`${H.message}. ${H.additionalInfo}`:H.message,offset:H.offset,length:H.lexeme.length})):[]))}e.$ui=l;function s(j,A){const F=j?j.substituteConstants():void 0,H=A?A.substituteConstants():void 0;return!F&&!H?!0:!F||!H?!1:F.equals(H)}e.$vi=s;function n(j,A){return j.cmp(A)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return a.INSTANCE}}e.$wi=i;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return i.INSTANCE}}e.$xi=a;class m{static create(A,F=null){const H=f.get(A);return typeof H=="boolean"?H?a.INSTANCE:i.INSTANCE:new m(A,F)}constructor(A,F){this.key=A,this.c=F,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:T(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=f.get(this.key);return typeof A=="boolean"?A?a.INSTANCE:i.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$yi=m;class P{static create(A,F,H=null){if(typeof F=="boolean")return F?m.create(A,H):L.create(A,H);const V=f.get(A);return typeof V=="boolean"?F===(V?"true":"false")?a.INSTANCE:i.INSTANCE:new P(A,F,H)}constructor(A,F,H){this.c=A,this.d=F,this.f=H,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:J(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=f.get(this.c);if(typeof A=="boolean"){const F=A?"true":"false";return this.d===F?a.INSTANCE:i.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$zi=P;class I{static create(A,F){return new I(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:J(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const F=A.getValue(this.f),H=A.getValue(this.d);return Array.isArray(F)?F.includes(H):typeof H=="string"&&typeof F=="object"&&F!==null?$.call(F,H):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=D.create(this.d,this.f)),this.c}}e.$Ai=I;class D{static create(A,F){return new D(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=11,this.c=I.create(A,F)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Bi=D;class O{static create(A,F,H=null){if(typeof F=="boolean")return F?L.create(A,H):m.create(A,H);const V=f.get(A);return typeof V=="boolean"?F===(V?"true":"false")?i.INSTANCE:a.INSTANCE:new O(A,F,H)}constructor(A,F,H){this.c=A,this.d=F,this.f=H,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:J(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=f.get(this.c);if(typeof A=="boolean"){const F=A?"true":"false";return this.d===F?i.INSTANCE:a.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ci=O;class L{static create(A,F=null){const H=f.get(A);return typeof H=="boolean"?H?i.INSTANCE:a.INSTANCE:new L(A,F)}constructor(A,F){this.c=A,this.d=F,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:T(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=f.get(this.c);return typeof A=="boolean"?A?i.INSTANCE:a.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=m.create(this.c,this)),this.d}}e.$Di=L;function N(j,A){if(typeof j=="string"){const F=parseFloat(j);isNaN(F)||(j=F)}return typeof j=="string"||typeof j=="number"?A(j):i.INSTANCE}class q{static create(A,F,H=null){return N(F,V=>new q(A,V,H))}constructor(A,F,H){this.c=A,this.d=F,this.f=H,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:J(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$Ei=q;class re{static create(A,F,H=null){return N(F,V=>new re(A,V,H))}constructor(A,F,H){this.c=A,this.d=F,this.f=H,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:J(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Fi=re;class ne{static create(A,F,H=null){return N(F,V=>new ne(A,V,H))}constructor(A,F,H){this.c=A,this.d=F,this.f=H,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:J(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$Gi=ne;class ee{static create(A,F,H=null){return N(F,V=>new ee(A,V,H))}constructor(A,F,H){this.c=A,this.d=F,this.f=H,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:J(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Hi=ee;class ae{static create(A,F){return new ae(A,F)}constructor(A,F){this.d=A,this.f=F,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const F=this.f?this.f.source:"",H=A.f?A.f.source:"";return F<H?-1:F>H?1:0}equals(A){if(A.type===this.type){const F=this.f?this.f.source:"",H=A.f?A.f.source:"";return this.d===A.d&&F===H}return!1}substituteConstants(){return this}evaluate(A){const F=A.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$Ii=ae;class ue{static create(A){return new ue(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new ue(this.c.map(A))}negate(){return this.c}}e.$Ji=ue;function K(j){let A=null;for(let F=0,H=j.length;F<H;F++){const V=j[F].substituteConstants();if(j[F]!==V&&A===null){A=[];for(let z=0;z<F;z++)A[z]=j[z]}A!==null&&(A[F]=V)}return A===null?j:A}class X{static create(A,F,H){return X.d(A,F,H)}constructor(A,F){this.expr=A,this.c=F,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let F=0,H=this.expr.length;F<H;F++){const V=n(this.expr[F],A.expr[F]);if(V!==0)return V}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let F=0,H=this.expr.length;F<H;F++)if(!this.expr[F].equals(A.expr[F]))return!1;return!0}return!1}substituteConstants(){const A=K(this.expr);return A===this.expr?this:X.create(A,this.c,!1)}evaluate(A){for(let F=0,H=this.expr.length;F<H;F++)if(!this.expr[F].evaluate(A))return!1;return!0}static d(A,F,H){const V=[];let z=!1;for(const B of A)if(B){if(B.type===1){z=!0;continue}if(B.type===0)return i.INSTANCE;if(B.type===6){V.push(...B.expr);continue}V.push(B)}if(V.length===0&&z)return a.INSTANCE;if(V.length!==0){if(V.length===1)return V[0];V.sort(n);for(let B=1;B<V.length;B++)V[B-1].equals(V[B])&&(V.splice(B,1),B--);if(V.length===1)return V[0];for(;V.length>1;){const B=V[V.length-1];if(B.type!==9)break;V.pop();const Y=V.pop(),se=V.length===0,le=U.create(B.expr.map(ge=>X.create([ge,Y],null,H)),null,se);le&&(V.push(le),V.sort(n))}if(V.length===1)return V[0];if(H){for(let B=0;B<V.length;B++)for(let Y=B+1;Y<V.length;Y++)if(V[B].negate().equals(V[Y]))return i.INSTANCE;if(V.length===1)return V[0]}return new X(V,F)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const F of this.expr)A.push(...F.keys());return A}map(A){return new X(this.expr.map(F=>F.map(A)),null)}negate(){if(!this.c){const A=[];for(const F of this.expr)A.push(F.negate());this.c=U.create(A,this,!0)}return this.c}}e.$Ki=X;class U{static create(A,F,H){return U.d(A,F,H)}constructor(A,F){this.expr=A,this.c=F,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let F=0,H=this.expr.length;F<H;F++){const V=n(this.expr[F],A.expr[F]);if(V!==0)return V}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let F=0,H=this.expr.length;F<H;F++)if(!this.expr[F].equals(A.expr[F]))return!1;return!0}return!1}substituteConstants(){const A=K(this.expr);return A===this.expr?this:U.create(A,this.c,!1)}evaluate(A){for(let F=0,H=this.expr.length;F<H;F++)if(this.expr[F].evaluate(A))return!0;return!1}static d(A,F,H){let V=[],z=!1;if(A){for(let B=0,Y=A.length;B<Y;B++){const se=A[B];if(se){if(se.type===0){z=!0;continue}if(se.type===1)return a.INSTANCE;if(se.type===9){V=V.concat(se.expr);continue}V.push(se)}}if(V.length===0&&z)return i.INSTANCE;V.sort(n)}if(V.length!==0){if(V.length===1)return V[0];for(let B=1;B<V.length;B++)V[B-1].equals(V[B])&&(V.splice(B,1),B--);if(V.length===1)return V[0];if(H){for(let B=0;B<V.length;B++)for(let Y=B+1;Y<V.length;Y++)if(V[B].negate().equals(V[Y]))return a.INSTANCE;if(V.length===1)return V[0]}return new U(V,F)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const F of this.expr)A.push(...F.keys());return A}map(A){return new U(this.expr.map(F=>F.map(A)),null)}negate(){if(!this.c){const A=[];for(const F of this.expr)A.push(F.negate());for(;A.length>1;){const F=A.shift(),H=A.shift(),V=[];for(const z of oe(F))for(const B of oe(H))V.push(X.create([z,B],null,!1));A.unshift(U.create(V,null,!1))}this.c=U.create(A,this,!0)}return this.c}}e.$Li=U;class W extends m{static{this.d=[]}static all(){return W.d.values()}constructor(A,F,H){super(A,null),this.f=F,typeof H=="object"?W.d.push({...H,key:A}):H!==!0&&W.d.push({key:A,description:H,type:F!=null?typeof F:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return P.create(this.key,A)}notEqualsTo(A){return O.create(this.key,A)}}e.$Mi=W,e.$Ni=(0,M.$nh)("contextKeyService");function T(j,A){return j<A?-1:j>A?1:0}function J(j,A,F,H){return j<F?-1:j>F?1:A<H?-1:A>H?1:0}function Z(j,A){if(j.type===0||A.type===1)return!0;if(j.type===9)return A.type===9?ce(j.expr,A.expr):!1;if(A.type===9){for(const F of A.expr)if(Z(j,F))return!0;return!1}if(j.type===6){if(A.type===6)return ce(A.expr,j.expr);for(const F of j.expr)if(Z(F,A))return!0;return!1}return j.equals(A)}e.$Oi=Z;function ce(j,A){let F=0,H=0;for(;F<j.length&&H<A.length;){const V=j[F].cmp(A[H]);if(V<0)return!1;V===0&&F++,H++}return F===j.length}function oe(j){return j.type===9?j.expr:[j]}}),define(te[76],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=void 0,e.$kn=(0,E.$nh)("credentialsService"),e.$ln=(0,E.$nh)("credentialsMainService");class C{constructor(){this.a={}}async getPassword(M,R){return this.a[M]?.[R]??null}async setPassword(M,R,S){this.a[M]=this.a[M]??{},this.a[M][R]=S}async deletePassword(M,R){return this.a[M]?.[R]?(delete this.a[M][R],Object.keys(this.a[M]).length===0&&delete this.a[M],!0):!1}async findPassword(M){return JSON.stringify(this.a[M])??null}async findCredentials(M){const R=[];for(const S of Object.keys(this.a[M]||{}))R.push({account:S,password:this.a[M][S]});return R}async clear(){this.a={}}}e.$mn=C}),define(te[91],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.ID=void 0,e.ID="diagnosticsService",e.$3l=(0,E.$nh)(e.ID);function C(M){return!!M.hostName&&!!M.errorMessage}e.$4l=C;class r{async getPerformanceInfo(R,S){return{}}async getSystemInfo(R,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,S){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.$5l=r}),define(te[92],ie([0,1,19,70,164,6,46,4,37]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_z=e.$$z=e.ConfirmResult=e.$0z=e.$9z=e.$8z=void 0,e.$8z=(0,M.$nh)("dialogService");var u;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})(u||(u={}));class ${a(o){return this.d(o,u.Confirmation)}b(o){return this.d(o,u.Prompt)}c(o){return this.d(o,u.Input)}d(o,g){const c=[];switch(g){case u.Confirmation:{const b=o;b.primaryButton?c.push(b.primaryButton):c.push((0,r.localize)(0,null)),b.cancelButton?c.push(b.cancelButton):c.push((0,r.localize)(1,null));break}case u.Prompt:{const b=o;Array.isArray(b.buttons)&&b.buttons.length>0&&c.push(...b.buttons.map(k=>k.label)),b.cancelButton&&(b.cancelButton===!0?c.push((0,r.localize)(2,null)):typeof b.cancelButton=="string"?c.push(b.cancelButton):b.cancelButton.label?c.push(b.cancelButton.label):c.push((0,r.localize)(3,null))),c.length===0&&c.push((0,r.localize)(4,null));break}case u.Input:{const b=o;b.primaryButton?c.push(b.primaryButton):c.push((0,r.localize)(5,null)),b.cancelButton?c.push(b.cancelButton):c.push((0,r.localize)(6,null));break}}return c}e(o){if(typeof o=="string")return o;if(typeof o=="number")return o===C.default.Info?"info":o===C.default.Error?"error":o===C.default.Warning?"warning":"none"}async f(o,g,c){const b=[...o.buttons??[]];return o.cancelButton&&typeof o.cancelButton!="string"&&typeof o.cancelButton!="boolean"&&b.push(o.cancelButton),{result:await b[g]?.run({checkboxChecked:c}),checkboxChecked:c}}}e.$9z=$,e.$0z=(0,M.$nh)("fileDialogService");var d;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(d||(e.ConfirmResult=d={}));const p=10;function h(y){const o=[];return o.push(...y.slice(0,p).map(g=>typeof g=="string"?g:(0,E.$5f)(g))),y.length>p&&(y.length-p===1?o.push((0,r.localize)(7,null)):o.push((0,r.localize)(8,null,y.length-p))),o.push(""),o.join(`
`)}e.$$z=h;function v(y,o){const g=(0,f.$Fm)(y);let c=(g.buttons??[]).map(t=>(0,R.$5z)(t)),b=(y.buttons||[]).map((t,l)=>l),k=0,w=g.cancelId??c.length-1;if(c.length>1){const t=typeof w=="number"?c[w]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&c.length>1&&w!==1){c.splice(w,1),c.splice(1,0,t);const l=b[w];b.splice(w,1),b.splice(1,0,l),w=1}S.$k&&c.length>1&&(c=c.reverse(),b=b.reverse(),k=c.length-1,typeof t=="string"&&(w=k-1))}else if(S.$i&&typeof t=="string"&&c.length>1&&w!==c.length-1){c.splice(w,1),c.push(t);const l=b[w];b.splice(w,1),b.push(l),w=c.length-1}}return g.buttons=c,g.defaultId=k,g.cancelId=w,g.noLink=!0,g.title=g.title||o.nameLong,{options:g,buttonIndeces:b}}e.$_z=v}),define(te[115],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jqb=e.$iqb=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$hqb=e.$gqb=void 0,e.$gqb=(0,E.$nh)("encryptionService"),e.$hqb=(0,E.$nh)("encryptionMainService");var C;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(C||(e.PasswordStoreCLIOption=C={}));var r;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(r||(e.KnownStorageProvider=r={}));function M(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$iqb=M;function R(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$jqb=R}),define(te[33],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=void 0,e.$uh=(0,E.$nh)("environmentService"),e.$vh=(0,E.$oh)(e.$uh)}),define(te[116],ie([0,1,168,6]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Nn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0,e.$Bn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Cn=new RegExp(e.$Bn),e.$Dn="__web_extension",e.$En="skipWalkthrough",e.$Fn="extensionsSync";function r(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Gn=r;function M(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Hn=M;function R(c,b){switch(c){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$In=R;function S(c,b){return b==="web"&&!c.includes("web")}e.$Jn=S;function f(c,b,k){return S(b,k)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===k?!0:u(k).includes(c)}e.$Kn=f;function u(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Ln=u;function $(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$Mn=$;var d;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var p;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var h;(function(c){c.Install="install",c.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var v;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$Nn=(0,C.$nh)("extensionGalleryService");var y;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var o;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(o||(e.ExtensionSignaturetErrorCode=o={}));class g extends Error{constructor(b,k){super(b),this.code=k,this.name=k}}e.$On=g,e.$Pn=(0,C.$nh)("extensionManagementService"),e.$Qn="extensionsIdentifiers/disabled",e.$Rn="extensionsIdentifiers/enabled",e.$Sn=(0,C.$nh)("IGlobalExtensionEnablementService"),e.$Tn=(0,C.$nh)("IExtensionTipsService"),e.$Un=(0,E.localize)(0,null),e.$Vn={value:e.$Un,original:"Extensions"},e.$Wn={value:(0,E.localize)(1,null),original:"Preferences"}}),define(te[207],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljb=void 0,e.$ljb=(0,E.$nh)("extensionUrlTrustService")}),define(te[208],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N3b=e.$M3b=void 0,e.$M3b=(0,E.$nh)("extensionHostStarter"),e.$N3b="extensionHostStarter"}),define(te[117],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hVb=e.$gVb=e.$fVb=void 0,e.$fVb=(0,E.$nh)("externalTerminal"),e.$gVb="Terminal.app",e.$hVb=(0,E.$nh)("externalTerminal")}),define(te[209],ie([0,1,47,15,9,4,73,22,89,172,117]),function(G,e,E,C,r,M,R,S,f,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R3b=e.$Q3b=e.$P3b=void 0;const d=u.localize(0,null);class p{async getDefaultTerminalForPlatforms(){return{windows:h.getDefaultTerminalWindows(),linux:await y.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class h extends p{static{this.b="cmd.exe"}openTerminal(k,w){return this.spawnTerminal(E,k,f.$fl(),w)}spawnTerminal(k,w,t,l){const s=w.windowsExec||h.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const n=r.$ec(s,".exe").toLowerCase();if(n==="cmder")return k.spawn(s,l?[l]:void 0),Promise.resolve(void 0);const i=["/c","start","/wait"];return s.indexOf(" ")>=0&&i.push('""'),i.push(s),n==="wt"&&i.push("-d ."),new Promise((a,m)=>{const P=o(process),I=k.spawn(t,i,{cwd:l,env:P});I.on("error",m),I.on("exit",()=>a())})}runInTerminal(k,w,t,l,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:h.getDefaultTerminalWindows();return new Promise((i,a)=>{const m=`"${w} - ${d}"`,P=`""${t.join('" "')}" & pause"`,I=Object.assign({},o(process),l);Object.keys(I).filter(q=>I[q]===null).forEach(q=>delete I[q]);const D={cwd:w,env:I,windowsVerbatimArguments:!0};let O,L;r.$ec(n,".exe")==="wt"?(O=n,L=["-d",".",h.b,"/c",P]):(O=h.b,L=["/c","start",m,"/wait",n,"/c",P]),E.spawn(O,L,D).on("error",q=>{a(g(q))}),i(void 0)})}static getDefaultTerminalWindows(){if(!h.d){const k=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${k?"Sysnative":"System32"}\\cmd.exe`}return h.d}}e.$P3b=h;class v extends p{static{this.b="/usr/bin/osascript"}openTerminal(k,w){return this.spawnTerminal(E,k,w)}runInTerminal(k,w,t,l,s){const n=s.osxExec||$.$gVb;return new Promise((i,a)=>{if(n===$.$gVb||n==="iTerm.app"){const m=n===$.$gVb?"TerminalHelper":"iTermHelper",I=[C.$3e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`).fsPath,"-t",k||d,"-w",w];for(const L of t)I.push("-a"),I.push(L);if(l){const L=Object.assign({},o(process),l);for(const N in L){const q=L[N];q===null?(I.push("-u"),I.push(N)):(I.push("-e"),I.push(`${N}=${q}`))}}let D="";const O=E.spawn(v.b,I);O.on("error",L=>{a(g(L))}),O.stderr.on("data",L=>{D+=L.toString()}),O.on("exit",L=>{if(L===0)i(void 0);else if(D){const N=D.split(`
`,1);a(new Error(N[0]))}else a(new Error(u.localize(1,null,m,L)))})}else a(new Error(u.localize(2,null,n)))})}spawnTerminal(k,w,t){const l=w.osxExec||$.$gVb;return new Promise((s,n)=>{const i=["-a",l];t&&i.push(t);const a=o(process),m=k.spawn("/usr/bin/open",i,{cwd:t,env:a});m.on("error",n),m.on("exit",()=>s())})}}e.$Q3b=v;class y extends p{static{this.b=u.localize(3,null)}openTerminal(k,w){return this.spawnTerminal(E,k,w)}runInTerminal(k,w,t,l,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((i,a)=>{const m=[];n.then(P=>{P.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const I=`${c(t)}; echo; read -p "${y.b}" -n1;`;m.push(`''${I}''`);const D=Object.assign({},o(process),l);Object.keys(D).filter(q=>D[q]===null).forEach(q=>delete D[q]);const O={cwd:w,env:D};let L="";const N=E.spawn(P,m,O);N.on("error",q=>{a(g(q))}),N.stderr.on("data",q=>{L+=q.toString()}),N.on("exit",q=>{if(q===0)i(void 0);else if(L){const re=L.split(`
`,1);a(new Error(re[0]))}else a(new Error(u.localize(4,null,P,q)))})})})}static async getDefaultTerminalLinuxReady(){if(!y.d)if(!M.$k)y.d=Promise.resolve("xterm");else{const k=await S.Promises.exists("/etc/debian_version");y.d=new Promise(w=>{k?w("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?w("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?w("konsole"):process.env.COLORTERM?w(process.env.COLORTERM):process.env.TERM?w(process.env.TERM):w("xterm")})}return y.d}spawnTerminal(k,w,t){const l=w.linuxExec?Promise.resolve(w.linuxExec):y.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{l.then(i=>{const a=o(process),m=k.spawn(i,[],{cwd:t,env:a});m.on("error",n),m.on("exit",()=>s())})})}}e.$R3b=y;function o(b){const k={...b.env};return(0,R.$dl)(k),k}function g(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(u.localize(5,null,b.path)):b}function c(b){let k="";for(const w of b)w.indexOf(" ")>=0?k+='"'+w+'"':k+=w,k+=" ";return k}}),define(te[16],ie([0,1,58,9,25,10,7,174,6,4,15]),function(G,e,E,C,r,M,R,S,f,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.FileKind=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileOperationResult=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileChangeType=e.$8j=e.FileOperation=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.FileSystemProviderErrorCode=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Rj=e.$Qj=void 0,e.$Qj=(0,f.$nh)("fileService");function d(T){return T.create===!0}e.$Rj=d;var p;(function(T){T[T.Unknown=0]="Unknown",T[T.File=1]="File",T[T.Directory=2]="Directory",T[T.SymbolicLink=64]="SymbolicLink"})(p||(e.FileType=p={}));var h;(function(T){T[T.Readonly=1]="Readonly",T[T.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var v;(function(T){T[T.None=0]="None",T[T.FileReadWrite=2]="FileReadWrite",T[T.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",T[T.FileReadStream=16]="FileReadStream",T[T.FileFolderCopy=8]="FileFolderCopy",T[T.PathCaseSensitive=1024]="PathCaseSensitive",T[T.Readonly=2048]="Readonly",T[T.Trash=4096]="Trash",T[T.FileWriteUnlock=8192]="FileWriteUnlock",T[T.FileAtomicRead=16384]="FileAtomicRead",T[T.FileAtomicWrite=32768]="FileAtomicWrite",T[T.FileAtomicDelete=65536]="FileAtomicDelete",T[T.FileClone=131072]="FileClone"})(v||(e.FileSystemProviderCapabilities=v={}));function y(T){return!!(T.capabilities&2)}e.$Sj=y;function o(T){return!!(T.capabilities&8)}e.$Tj=o;function g(T){return!!(T.capabilities&131072)}e.$Uj=g;function c(T){return!!(T.capabilities&4)}e.$Vj=c;function b(T){return!!(T.capabilities&16)}e.$Wj=b;function k(T){return y(T)?!!(T.capabilities&16384):!1}e.$Xj=k;function w(T){return y(T)?!!(T.capabilities&32768):!1}e.$Yj=w;function t(T){return!!(T.capabilities&65536)}e.$Zj=t;function l(T){return!!(T.capabilities&2048)}e.$1j=l;var s;(function(T){T.FileExists="EntryExists",T.FileNotFound="EntryNotFound",T.FileNotADirectory="EntryNotADirectory",T.FileIsADirectory="EntryIsADirectory",T.FileExceedsStorageQuota="EntryExceedsStorageQuota",T.FileTooLarge="EntryTooLarge",T.FileWriteLocked="EntryWriteLocked",T.NoPermissions="NoPermissions",T.Unavailable="Unavailable",T.Unknown="Unknown"})(s||(e.FileSystemProviderErrorCode=s={}));class n extends Error{static create(J,Z){const ce=new n(J.toString(),Z);return m(ce,Z),ce}constructor(J,Z){super(J),this.code=Z}}e.$2j=n;function i(T,J){return n.create(T,J)}e.$3j=i;function a(T){return T||i((0,S.localize)(0,null),s.Unknown)}e.$4j=a;function m(T,J){return T.name=J?`${J} (FileSystemError)`:"FileSystemError",T}e.$5j=m;function P(T){if(!T)return s.Unknown;if(T instanceof n)return T.code;const J=/^(.+) \(FileSystemError\)$/.exec(T.name);if(!J)return s.Unknown;switch(J[1]){case s.FileExists:return s.FileExists;case s.FileIsADirectory:return s.FileIsADirectory;case s.FileNotADirectory:return s.FileNotADirectory;case s.FileNotFound:return s.FileNotFound;case s.FileTooLarge:return s.FileTooLarge;case s.FileWriteLocked:return s.FileWriteLocked;case s.NoPermissions:return s.NoPermissions;case s.Unavailable:return s.Unavailable}return s.Unknown}e.$6j=P;function I(T){if(T instanceof re)return T.fileOperationResult;switch(P(T)){case s.FileNotFound:return 1;case s.FileIsADirectory:return 0;case s.FileNotADirectory:return 9;case s.FileWriteLocked:return 5;case s.NoPermissions:return 6;case s.FileExists:return 4;case s.FileTooLarge:return 7;default:return 10}}e.$7j=I;var D;(function(T){T[T.CREATE=0]="CREATE",T[T.DELETE=1]="DELETE",T[T.MOVE=2]="MOVE",T[T.COPY=3]="COPY",T[T.WRITE=4]="WRITE"})(D||(e.FileOperation=D={}));class O{constructor(J,Z,ce){this.resource=J,this.operation=Z,this.target=ce}isOperation(J){return this.operation===J}}e.$8j=O;var L;(function(T){T[T.UPDATED=0]="UPDATED",T[T.ADDED=1]="ADDED",T[T.DELETED=2]="DELETED"})(L||(e.FileChangeType=L={}));class N{constructor(J,Z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const oe of J){const j=ce.get(oe.type);switch(j?j.push([oe.resource,oe]):ce.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,j]of ce)switch(oe){case 1:this.a=E.$th.forUris(()=>Z),this.a.fill(j);break;case 0:this.b=E.$th.forUris(()=>Z),this.b.fill(j);break;case 2:this.c=E.$th.forUris(()=>Z),this.c.fill(j);break}}contains(J,...Z){return this.d(J,{includeChildren:!1},...Z)}affects(J,...Z){return this.d(J,{includeChildren:!0},...Z)}d(J,Z,...ce){if(!J)return!1;const oe=ce.length>0;return!!((!oe||ce.includes(1))&&(this.a?.get(J)||Z.includeChildren&&this.a?.findSuperstr(J))||(!oe||ce.includes(0))&&(this.b?.get(J)||Z.includeChildren&&this.b?.findSuperstr(J))||(!oe||ce.includes(2))&&(this.c?.findSubstr(J)||Z.includeChildren&&this.c?.findSuperstr(J)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$9j=N;function q(T,J,Z){return!T||!J||T===J||J.length>T.length?!1:(J.charAt(J.length-1)!==C.sep&&(J+=C.sep),Z?(0,r.$Md)(T,J):T.indexOf(J)===0)}e.$0j=q;class re extends Error{constructor(J,Z,ce){super(J),this.fileOperationResult=Z,this.options=ce}}e.$$j=re;class ne extends re{constructor(J,Z,ce,oe){super(J,Z,oe),this.fileOperationResult=Z,this.size=ce}}e.$_j=ne;class ee extends re{constructor(J,Z,ce){super(J,2,ce),this.stat=Z}}e.$ak=ee;var ae;(function(T){T[T.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",T[T.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",T[T.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",T[T.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",T[T.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",T[T.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",T[T.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",T[T.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",T[T.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",T[T.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",T[T.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$bk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ck={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$dk="files.associations",e.$ek="files.exclude",e.$fk="files.readonlyInclude",e.$gk="files.readonlyExclude",e.$hk="files.readonlyFromPermissions";var ue;(function(T){T[T.FILE=0]="FILE",T[T.FOLDER=1]="FOLDER",T[T.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$ik="";function K(T){if(!(typeof T.size!="number"||typeof T.mtime!="number"))return T.mtime.toString(29)+T.size.toString(31)}e.$jk=K;async function X(T,J){if(!J.hasProvider(R.URI.from({scheme:T.scheme})))return new Promise(Z=>{const ce=J.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===T.scheme&&oe.added&&(ce.dispose(),Z())})})}e.$kk=X;class U{static{this.KB=1024}static{this.MB=U.KB*U.KB}static{this.GB=U.MB*U.KB}static{this.TB=U.GB*U.KB}static formatSize(J){return(0,M.$me)(J)||(J=0),J<U.KB?(0,S.localize)(1,null,J.toFixed(0)):J<U.MB?(0,S.localize)(2,null,(J/U.KB).toFixed(2)):J<U.GB?(0,S.localize)(3,null,(J/U.MB).toFixed(2)):J<U.TB?(0,S.localize)(4,null,(J/U.GB).toFixed(2)):(0,S.localize)(5,null,(J/U.TB).toFixed(2))}}e.$lk=U;function W(T){const J=typeof T=="string"||T?.scheme===$.Schemas.vscodeRemote;return typeof T!="string"&&T?.scheme===$.Schemas.file?1024*U.MB:J?10*U.MB:u.$o?50*U.MB:1024*U.MB}e.$mk=W}),define(te[210],ie([0,1,17,50,13,3,2,56,7,31,16]),function(G,e,E,C,r,M,R,S,f,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0,e.$EM="localFilesystem";class d extends R.$lb{constructor(h,v){super(),this.a=h,this.b=v,this.onDidChangeCapabilities=M.Event.None,this.f=this.B(new M.$7c),this.onDidChangeFile=this.f.event,this.g=this.B(new M.$7c),this.onDidWatchError=this.g.event,this.h=(0,u.$5e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,v){const{buffer:y}=await this.a.call("readFile",[h,v]);return y}readFileStream(h,v,y){const o=(0,S.$xb)(c=>E.$Jb.concat(c.map(b=>E.$Jb.wrap(b))).buffer),g=this.a.listen("readFileStream",[h,v])(c=>{if(c instanceof E.$Jb)o.write(c.buffer);else{if(c==="end")o.end();else{let b;if(c instanceof Error)b=c;else{const k=c;b=(0,$.$3j)(k.message??(0,C.$$h)(k),k.code??$.FileSystemProviderErrorCode.Unknown)}o.error(b),o.end()}g.dispose()}});return y.onCancellationRequested(()=>{o.error((0,r.$4)()),o.end(),g.dispose()}),o}writeFile(h,v,y){return this.a.call("writeFile",[h,E.$Jb.wrap(v),y])}open(h,v){return this.a.call("open",[h,v])}close(h){return this.a.call("close",[h])}async read(h,v,y,o,g){const[c,b]=await this.a.call("read",[h,v,g]);return y.set(c.buffer.slice(0,b),o),b}write(h,v,y,o,g){return this.a.call("write",[h,v,E.$Jb.wrap(y),o,g])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,v){return this.a.call("delete",[h,v])}rename(h,v,y){return this.a.call("rename",[h,v,y])}copy(h,v,y){return this.a.call("copy",[h,v,y])}cloneFile(h,v){return this.a.call("cloneFile",[h,v])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const v=h;this.f.fire(v.map(y=>({resource:f.URI.revive(y.resource),type:y.type})))}else{const v=h;this.g.fire(v)}}))}watch(h,v){const y=(0,u.$5e)();return this.a.call("watch",[this.h,y,h,v]),(0,R.$jb)(()=>this.a.call("unwatch",[this.h,y]))}}e.$FM=d}),define(te[118],ie([0,1,17,13,175,16]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;async function R($,d,p,h,v,y){let o;try{await S($,d,p,h,v,y)}catch(g){o=g}finally{o&&v.errorTransformer&&(o=v.errorTransformer(o)),typeof o<"u"&&p.error(o),p.end()}}e.$pp=R;async function S($,d,p,h,v,y){f(y);const o=await $.open(d,{create:!1});try{f(y);let g=0,c=0,b=v&&typeof v.length=="number"?v.length:void 0,k=E.$Jb.alloc(Math.min(v.bufferSize,typeof b=="number"?b:v.bufferSize)),w=v&&typeof v.position=="number"?v.position:0,t=0;do c=await $.read(o,w,k.buffer,t,k.byteLength-t),w+=c,t+=c,g+=c,typeof b=="number"&&(b-=c),t===k.byteLength&&(await p.write(h(k)),k=E.$Jb.alloc(Math.min(v.bufferSize,typeof b=="number"?b:v.bufferSize)),t=0);while(c>0&&(typeof b!="number"||b>0)&&f(y)&&u(g,v));if(t>0){let l=t;typeof b=="number"&&(l=Math.min(t,b)),p.write(h(k.slice(0,l)))}}catch(g){throw(0,M.$4j)(g)}finally{await $.close(o)}}function f($){if($.isCancellationRequested)throw(0,C.$4)();return!0}function u($,d){if(typeof d?.limits?.size=="number"&&$>d.limits.size)throw(0,M.$3j)((0,r.localize)(0,null),M.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[77],ie([0,1,104,2,9,4,7,16]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=void 0;function f(g){return g.recursive===!0}e.$rp=f;class u extends C.$lb{static{this.a=5}constructor(c,b,k,w){super(),this.h=c,this.i=b,this.j=k,this.k=w,this.c=this.B(new C.$mb),this.f=void 0,this.g=0}m(){const c=new C.$kb;this.c.value=c,this.b=this.l(c),this.b.setVerboseLogging(this.j),c.add(this.b.onDidChangeFile(b=>this.h(b))),c.add(this.b.onDidLogMessage(b=>this.i(b))),c.add(this.b.onDidError(b=>this.n(b)))}n(c){this.k.restartOnError?this.g<u.a&&this.f?(this.r(`restarting watcher after error: ${c}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${c}`):this.r(c)}p(c){this.g++,this.m(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.j=c,await this.b?.setVerboseLogging(c)}r(c){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${c}`})}s(c){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$sp=u;class $ extends u{constructor(c,b,k){super(c,b,k,{type:"node.js",restartOnError:!1})}}e.$tp=$;class d extends u{constructor(c,b,k){super(c,b,k,{type:"universal",restartOnError:!0})}}e.$up=d;function p(g){return g.map(c=>({type:c.type,resource:R.URI.file(c.path)}))}e.$vp=p;function h(g){const c=new o;for(const b of g)c.processEvent(b);return c.coalesce()}e.$wp=h;function v(g,c){return typeof c=="string"&&!c.startsWith(E.$$i)&&!(0,r.$_b)(c)?{base:g,pattern:c}:c}e.$xp=v;function y(g,c){const b=[];for(const k of c)b.push((0,E.$cj)(v(g,k)));return b}e.$yp=y;class o{constructor(){this.a=new Set,this.b=new Map}c(c){return M.$k?c.path:c.path.toLowerCase()}processEvent(c){const b=this.b.get(this.c(c));let k=!1;if(b){const w=b.type,t=c.type;b.path!==c.path&&(c.type===2||c.type===1)?k=!0:w===1&&t===2?(this.b.delete(this.c(c)),this.a.delete(b)):w===2&&t===1?b.type=0:w===1&&t===0||(b.type=t)}else k=!0;k&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],b=[];return Array.from(this.a).filter(k=>k.type!==2?(c.push(k),!1):!0).sort((k,w)=>k.path.length-w.path.length).filter(k=>b.some(w=>(0,S.$0j)(k.path,w,!M.$k))?!1:(b.push(k.path),!0)).concat(c)}}}),define(te[211],ie([0,1,42,8,21,32,2,86,9,4,105,22,77]),function(G,e,E,C,r,M,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=void 0;class h extends R.$lb{static{this.a=100}static{this.b=75}constructor(o,g,c,b){super(),this.j=o,this.k=g,this.l=c,this.m=b,this.c=this.B(new C.$Hg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},k=>this.k(k))),this.f=this.B(new C.$Gg(k=>this.u(k),h.b)),this.g=(0,p.$yp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,p.$yp)(this.j.path,this.j.includes):void 0,this.i=new r.$dd,this.ready=this.n()}async n(){try{const o=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const g=await d.Promises.stat(o);this.B(await this.s(o,g.isDirectory()))}catch(o){o.code!=="ENOENT"?this.w(o):this.z(o)}}async r(o){let g=o.path;try{g=await d.Promises.realpath(o.path),o.path===g&&(g=await(0,$.$Ip)(o.path)??o.path),o.path!==g&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${o.path}, real: ${g})`)}catch{}return g}async s(o,g){if(u.$j&&(0,M.$Je)(o,"/Volumes/",!0))return this.w(`Refusing to watch ${o} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$lb.None;const c=new r.$dd(this.i.token),b=new R.$kb;try{const k=(0,f.$ec)(o),w=(0,E.watch)(o);b.add((0,R.$jb)(()=>{w.removeAllListeners(),w.close()})),this.z(`Started watching: '${o}'`);const t=new Set;if(g)try{for(const s of await d.Promises.readdir(o))t.add(s)}catch(s){this.w(s)}const l=new Map;b.add((0,R.$jb)(()=>{for(const[,s]of l)s.dispose();l.clear()})),w.on("error",(s,n)=>{this.w(`Failed to watch ${o} for changes using fs.watch() (${s}, ${n})`),this.dispose()}),w.on("change",(s,n)=>{if(c.token.isCancellationRequested)return;this.z(`[raw] ["${s}"] ${n}`);let i="";if(n&&(i=n.toString(),u.$j&&(i=(0,S.$5k)(i))),!(!i||s!=="change"&&s!=="rename"))if(g)if(s==="rename"){l.get(i)?.dispose();const a=setTimeout(async()=>{if(l.delete(i),i===k&&!await d.Promises.exists(o)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const m=await this.v((0,f.$ac)(o,i));if(c.token.isCancellationRequested)return;let P;m?t.has(i)?P=0:(P=1,t.add(i)):(t.delete(i),P=2),this.t({path:(0,f.$ac)(this.j.path,i),type:P})},h.a);l.set(i,(0,R.$jb)(()=>clearTimeout(a)))}else{let a;t.has(i)?a=0:(a=1,t.add(i)),this.t({path:(0,f.$ac)(this.j.path,i),type:a})}else if(s==="rename"||i!==k){const a=setTimeout(async()=>{const m=await d.Promises.exists(o);c.token.isCancellationRequested||(m?(this.t({path:this.j.path,type:0},!0),b.add(await this.s(o,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);b.clear(),b.add((0,R.$jb)(()=>clearTimeout(a)))}else this.t({path:this.j.path,type:0},!0)})}catch(k){await d.Promises.exists(o)&&!c.token.isCancellationRequested&&this.w(`Failed to watch ${o} for changes using fs.watch() (${k.toString()})`)}return(0,R.$jb)(()=>{c.dispose(!0),b.dispose()})}t(o,g=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${o.type===1?"[ADDED]":o.type===2?"[DELETED]":"[CHANGED]"} ${o.path}`),!g&&this.g.some(c=>c(o.path))?this.m&&this.z(` >> ignored (excluded) ${o.path}`):!g&&this.h&&this.h.length>0&&!this.h.some(c=>c(o.path))?this.m&&this.z(` >> ignored (not included) ${o.path}`):this.f.work(o))}u(o){const g=(0,p.$wp)(o);if(g.length>0){if(this.m)for(const b of g)this.z(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`);this.c.work(g)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(o){if(u.$k)return d.Promises.exists(o);try{const g=(0,f.$ec)(o);return(await d.Promises.readdir((0,f.$dc)(o))).some(b=>b===g)}catch(g){return this.z(g),!1}}setVerboseLogging(o){this.m=o}w(o){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${o}`})}y(o){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${o}`})}z(o){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${o}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Lp=h;async function v(y,o,g,c,b=512){const k=await d.Promises.open(y,"r"),w=Buffer.allocUnsafe(b),t=new r.$dd(c);let l,s=!1;const n={path:y,excludes:[],recursive:!1},i=new h(n,a=>{(async()=>{for(const{type:m}of a)if(m===0){if(s)return;s=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:P}=await d.Promises.read(k,w,0,b,null);if(!P||t.token.isCancellationRequested)break;o(w.slice(0,P))}}catch(P){l=new Error(P),t.dispose(!0)}finally{s=!1}}})()});return await i.ready,g(),new Promise((a,m)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await d.Promises.close(k)}catch(P){l=new Error(P)}l?m(l):a()})})}e.$Mp=v}),define(te[212],ie([0,1,3,104,2,4,211]),function(G,e,E,C,r,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class S extends r.$lb{constructor(){super(...arguments),this.a=this.B(new E.$7c),this.onDidChangeFile=this.a.event,this.b=this.B(new E.$7c),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(u){const $=this.i(u),d=$.filter(h=>{const v=this.c.get(h.path);return v?!(0,C.$gj)(v.request.excludes,h.excludes)||!(0,C.$gj)(v.request.includes,h.includes):!0}),p=Array.from(this.c.values()).filter(({request:h})=>!$.find(v=>v.path===h.path&&(0,C.$gj)(v.excludes,h.excludes)&&(0,C.$gj)(v.includes,h.includes))).map(({request:h})=>h.path);d.length&&this.j(`Request to start watching: ${d.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),p.length&&this.j(`Request to stop watching: ${p.join(",")}`);for(const h of p)this.h(h);for(const h of d)this.g(h)}g(u){const $=new R.$Lp(u,p=>this.a.fire(p),p=>this.b.fire(p),this.f),d={request:u,instance:$};this.c.set(u.path,d)}async stop(){for(const[u]of this.c)this.h(u);this.c.clear()}h(u){const $=this.c.get(u);$&&(this.c.delete(u),$.instance.dispose())}i(u){const $=new Map;for(const d of u){const p=M.$k?d.path:d.path.toLowerCase();$.set(p,d)}return Array.from($.values())}async setVerboseLogging(u){this.f=u;for(const[,$]of this.c)$.instance.setVerboseLogging(u)}j(u){this.f&&this.b.fire({type:"trace",message:this.k(u)})}k(u,$){return $?`[File Watcher (node.js)] ${u} (path: ${$.request.path})`:`[File Watcher (node.js)] ${u}`}}e.$Np=S}),define(te[213],ie([0,1,77,212]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;class r extends E.$tp{constructor(R,S,f){super(R,S,f),this.m()}l(){return new C.$Np}}e.$Op=r}),define(te[214],ie([0,1,15,43,158,77]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;class R extends M.$up{constructor(f,u,$){super(f,u,$),this.m()}l(f){const u=f.add(new r.$Fp(E.$3e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(u.onDidProcessExit(({code:$,signal:d})=>this.n(`terminated by itself with code ${$}, signal: ${d}`))),C.ProxyChannel.toService((0,C.$7g)(u.getChannel("watcher")))}}e.$Gp=R}),define(te[93],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=void 0;class E{constructor(...r){this.a=new Map;for(const[M,R]of r)this.set(M,R)}set(r,M){const R=this.a.get(r);return this.a.set(r,M),R}has(r){return this.a.has(r)}get(r){return this.a.get(r)}}e.$lh=E}),define(te[215],ie([0,1,8,13,2,75,206,6,93,101]),function(G,e,E,C,r,M,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;const $=!1;class d extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class p{constructor(o=new f.$lh,g=!1,c,b=$){this.f=o,this.g=g,this.h=c,this.i=b,this.o=new Set,this.f.set(S.$mh,this),this._globalGraph=b?c?._globalGraph??new R.$Rp(k=>k):void 0}createChild(o){return new p(o,this.g,this,this.i)}invokeFunction(o,...g){const c=v.traceInvocation(this.i,o);let b=!1;try{return o({get:w=>{if(b)throw(0,C.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(w,c);if(!t)throw new Error(`[invokeFunction] unknown service '${w}'`);return t}},...g)}finally{b=!0,c.stop()}}createInstance(o,...g){let c,b;return o instanceof M.$kh?(c=v.traceCreation(this.i,o.ctor),b=this.j(o.ctor,o.staticArguments.concat(g),c)):(c=v.traceCreation(this.i,o),b=this.j(o,g,c)),c.stop(),b}j(o,g=[],c){const b=S._util.getServiceDependencies(o).sort((t,l)=>t.index-l.index),k=[];for(const t of b){const l=this.m(t.id,c);l||this.u(`[createInstance] ${o.name} depends on UNKNOWN service ${t.id}.`,!1),k.push(l)}const w=b.length>0?b[0].index:g.length;if(g.length!==w){console.trace(`[createInstance] First service dependency of ${o.name} at position ${w+1} conflicts with ${g.length} static arguments`);const t=w-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,w)}return Reflect.construct(o,g.concat(k))}k(o,g){if(this.f.get(o)instanceof M.$kh)this.f.set(o,g);else if(this.h)this.h.k(o,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(o){const g=this.f.get(o);return!g&&this.h?this.h.l(o):g}m(o,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const c=this.l(o);return c instanceof M.$kh?this.q(o,c,g.branch(o,!0)):(g.branch(o,!1),c)}q(o,g,c){if(this.o.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.o.add(o);try{return this.r(o,g,c)}finally{this.o.delete(o)}}r(o,g,c){const b=new R.$Rp(t=>t.id.toString());let k=0;const w=[{id:o,desc:g,_trace:c}];for(;w.length;){const t=w.pop();if(b.lookupOrInsertNode(t),k++>1e3)throw new d(b);for(const l of S._util.getServiceDependencies(t.desc.ctor)){const s=this.l(l.id);if(s||this.u(`[createInstance] ${o} depends on ${l.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(l.id)),s instanceof M.$kh){const n={id:l.id,desc:s,_trace:t._trace.branch(l.id,!0)};b.insertEdge(t,n),w.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new d(b);break}for(const{data:l}of t){if(this.l(l.id)instanceof M.$kh){const n=this.s(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this.k(l.id,n)}b.removeNode(l)}}return this.l(o)}s(o,g,c=[],b,k){if(this.f.get(o)instanceof M.$kh)return this.t(o,g,c,b,k);if(this.h)return this.h.s(o,g,c,b,k);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(o,g,c=[],b,k){if(b){const w=new p(void 0,this.g,this,this.i);w.c=String(o);const t=new Map,l=new E.$Jg(()=>{const s=w.j(g,c,k);for(const[n,i]of t){const a=s[n];if(typeof a=="function")for(const m of i)a.apply(s,m)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,n){if(!l.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let m=t.get(n);return m||(m=new u.$lc,t.set(n,m)),(I,D,O)=>{const L=m.push([I,D,O]);return(0,r.$jb)(L)}}if(n in s)return s[n];const i=l.value;let a=i[n];return typeof a!="function"||(a=a.bind(i),s[n]=a),a},set(s,n,i){return l.value[n]=i,!0},getPrototypeOf(s){return g.prototype}})}else return this.j(g,c,k)}u(o,g){if(g&&console.warn(o),this.g)throw new Error(o)}}e.$Sp=p;var h;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(h||(h={}));class v{static{this.all=new Set}static{this.c=new class extends v{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,g){return o?new v(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):v.c}static traceCreation(o,g){return o?new v(1,g.name):v.c}static{this.f=0}constructor(o,g){this.type=o,this.name=g,this.g=Date.now(),this.h=[]}branch(o,g){const c=new v(3,o.toString());return this.h.push([o,g,c]),c}stop(){const o=Date.now()-this.g;v.f+=o;let g=!1;function c(k,w){const t=[],l=new Array(k+1).join("	");for(const[s,n,i]of w.h)if(n&&i){g=!0,t.push(`${l}CREATES -> ${s}`);const a=c(k+1,i);a&&t.push(a)}else t.push(`${l}uses -> ${s}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${v.f.toFixed(2)}ms)`];(o>2||g)&&v.all.add(b.join(`
`))}}e.$Tp=v}),define(te[216],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$srb=e.IssueType=void 0;var C;(function(r){r[r.Bug=0]="Bug",r[r.PerformanceIssue=1]="PerformanceIssue",r[r.FeatureRequest=2]="FeatureRequest"})(C||(e.IssueType=C={})),e.$srb=(0,E.$nh)("issueService")}),define(te[5],ie([0,1,50,3,57,2,35,4,19,10,7,114,6]),function(G,e,E,C,r,M,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.log=e.$Si=e.LogLevel=e.$Ri=e.$Qi=e.$Pi=void 0,e.$Pi=(0,p.$nh)("logService"),e.$Qi=(0,p.$nh)("loggerService");function h(){return new Date().toISOString()}function v(I){return(0,u.$me)(I)}e.$Ri=v;var y;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$Si=y.Info;function o(I,D,O){switch(D){case y.Trace:I.trace(O);break;case y.Debug:I.debug(O);break;case y.Info:I.info(O);break;case y.Warning:I.warn(O);break;case y.Error:I.error(O);break;case y.Off:break;default:throw new Error(`Invalid log level ${D}`)}}e.log=o;function g(I,D=!1){let O="";for(let L=0;L<I.length;L++){let N=I[L];if(N instanceof Error&&(N=(0,E.$$h)(N,D)),typeof N=="object")try{N=JSON.stringify(N)}catch{}O+=(L>0?" ":"")+N}return O}class c extends M.$lb{constructor(){super(...arguments),this.b=e.$Si,this.c=this.B(new C.$7c),this.onDidChangeLogLevel=this.c.event}setLevel(D){this.b!==D&&(this.b=D,this.c.fire(this.b))}getLevel(){return this.b}f(D){return this.b!==y.Off&&this.b<=D}}e.$Ui=c;class b extends c{constructor(D){super(),this.h=D}f(D){return this.h||super.f(D)}trace(D,...O){this.f(y.Trace)&&this.g(y.Trace,g([D,...O],!0))}debug(D,...O){this.f(y.Debug)&&this.g(y.Debug,g([D,...O]))}info(D,...O){this.f(y.Info)&&this.g(y.Info,g([D,...O]))}warn(D,...O){this.f(y.Warning)&&this.g(y.Warning,g([D,...O]))}error(D,...O){if(this.f(y.Error))if(D instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=D.stack,this.g(y.Error,g(L))}else this.g(y.Error,g([D,...O]))}flush(){}}e.$Vi=b;class k extends c{constructor(D=e.$Si){super(),this.setLevel(D),this.g=!S.$i}trace(D,...O){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,D,...O):console.log(`[main ${h()}]`,D,...O))}debug(D,...O){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,D,...O):console.log(`[main ${h()}]`,D,...O))}info(D,...O){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,D,...O):console.log(`[main ${h()}]`,D,...O))}warn(D,...O){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,D,...O):console.warn(`[main ${h()}]`,D,...O))}error(D,...O){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,D,...O):console.error(`[main ${h()}]`,D,...O))}dispose(){}flush(){}}e.$Wi=k;class w extends c{constructor(D=e.$Si,O=!0){super(),this.g=O,this.setLevel(D)}trace(D,...O){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",D,...O):console.log(D,...O))}debug(D,...O){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",D,...O):console.log(D,...O))}info(D,...O){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",D,...O):console.log(D,...O))}warn(D,...O){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",D,...O):console.log(D,...O))}error(D,...O){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",D,...O):console.error(D,...O))}dispose(){}flush(){}}e.$Xi=w;class t extends c{constructor(D,O=e.$Si){super(),this.g=D,this.setLevel(O)}trace(D,...O){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(D),...O])}debug(D,...O){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(D),...O])}info(D,...O){this.f(y.Info)&&this.g.log(y.Info,[this.h(D),...O])}warn(D,...O){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(D),...O])}error(D,...O){this.f(y.Error)&&this.g.log(y.Error,[this.h(D),...O])}h(D){return typeof D=="string"?D:(0,E.$$h)(D,this.f(y.Trace))}dispose(){}flush(){}}e.$Yi=t;class l extends c{constructor(D){super(),this.g=D,D.length&&this.setLevel(D[0].getLevel())}setLevel(D){for(const O of this.g)O.setLevel(D);super.setLevel(D)}trace(D,...O){for(const L of this.g)L.trace(D,...O)}debug(D,...O){for(const L of this.g)L.debug(D,...O)}info(D,...O){for(const L of this.g)L.info(D,...O)}warn(D,...O){for(const L of this.g)L.warn(D,...O)}error(D,...O){for(const L of this.g)L.error(D,...O)}flush(){for(const D of this.g)D.flush()}dispose(){for(const D of this.g)D.dispose()}}e.$Zi=l;class s extends M.$lb{constructor(D,O,L){if(super(),this.h=D,this.j=O,this.b=new R.$li,this.c=this.B(new C.$7c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$7c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$7c),this.onDidChangeVisibility=this.g.event,L)for(const N of L)this.b.set(N.resource,{logger:void 0,info:N})}k(D){return(0,u.$ie)(D)?[...this.b.values()].find(O=>O.info.id===D):this.b.get(D)}getLogger(D){return this.k(D)?.logger}createLogger(D,O){const L=this.l(D),N=(0,u.$ie)(D)?D:O?.id??(0,r.$bi)(L.toString()).toString(16);let q=this.b.get(L)?.logger;const re=O?.logLevel==="always"?y.Trace:O?.logLevel;q||(q=this.m(L,re??this.getLogLevel(L)??this.h,{...O,id:N}));const ne={logger:q,info:{resource:L,id:N,logLevel:re,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(ne.info),this.b.set(L,ne),q}l(D){return(0,u.$ie)(D)?(0,f.$8f)(this.j,`${D}.log`):D}setLogLevel(D,O){if($.URI.isUri(D)){const L=D,N=O,q=this.b.get(L);q&&N!==q.info.logLevel&&(q.info.logLevel=N===this.h?void 0:N,q.logger?.setLevel(N),this.b.set(q.info.resource,q),this.f.fire([L,N]))}else{this.h=D;for(const[L,N]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(D,O){const L=this.k(D);L&&O!==!L.info.hidden&&(L.info.hidden=!O,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,O]))}getLogLevel(D){let O;return D&&(O=this.b.get(D)?.info.logLevel),O??this.h}registerLogger(D){const O=this.b.get(D.resource);O?O.info.hidden!==D.hidden&&this.setVisibility(D.resource,!D.hidden):(this.b.set(D.resource,{info:D,logger:void 0}),this.c.fire({added:[D],removed:[]}))}deregisterLogger(D){const O=this.b.get(D);O&&(O.logger&&O.logger.dispose(),this.b.delete(D),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const D of this.b.values())yield D.info}getRegisteredLogger(D){return this.b.get(D)?.info}dispose(){this.b.forEach(D=>D.logger?.dispose()),this.b.clear(),super.dispose()}}e.$1i=s;class n{constructor(){this.onDidChangeLogLevel=new C.$7c().event}setLevel(D){}getLevel(){return y.Info}trace(D,...O){}debug(D,...O){}info(D,...O){}warn(D,...O){}error(D,...O){}critical(D,...O){}dispose(){}flush(){}}e.$2i=n;class i extends n{}e.$3i=i;function a(I){if(I.verbose)return y.Trace;if(typeof I.logLevel=="string"){const D=P(I.logLevel.toLowerCase());if(D!==void 0)return D}return e.$Si}e.$4i=a;function m(I){switch(I){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$5i=m;function P(I){switch(I){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$6i=P,e.$7i=new d.$Mi("logLevel",m(y.Info))});var x=this&&this.__param||function(G,e){return function(E,C){e(E,C,G)}};define(te[217],ie([0,1,76,3,2,5,4,8]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nn=void 0;let f=class ut extends r.$lb{static{this.a=2500}static{this.b=ut.a-100}constructor($){super(),this.h=$,this.c=this.B(new C.$7c),this.onDidChangePassword=this.c.event,this.g=new S.$pg}async getPassword($,d){this.h.trace("Going to get password from keytar:",$,d);let p;try{p=await this.i()}catch{return null}return await this.g.queue($+d,()=>this.k(p,$,d))}async k($,d,p){this.h.trace("Doing get password from keytar:",d,p);const h=await(0,S.$Kg)(()=>$.getPassword(d,p),50,3);if(!h)return this.h.trace("Did not get a password from keytar for account:",p),h;let v,y;try{const o=JSON.parse(h);v=o.content,y=o.hasNextChunk}catch{}if(!v||!y)return this.h.trace("Got password from keytar for account:",p),h;try{let o=1;for(;y;){const g=await(0,S.$Kg)(()=>$.getPassword(d,`${p}-${o}`),50,3),c=JSON.parse(g);v+=c.content,y=c.hasNextChunk,o++}return this.h.trace(`Got ${o}-chunked password from keytar for account:`,p),v}catch(o){return this.h.error(o),h}}async setPassword($,d,p){this.h.trace("Going to set password using keytar:",$,d);let h;try{h=await this.i()}catch(v){throw this.j?.(v),v}await this.g.queue($+d,()=>this.l(h,$,d,p)),this.c.fire({service:$,account:d})}async l($,d,p,h){if(this.h.trace("Doing set password from keytar:",d,p),!R.$i){await(0,S.$Kg)(()=>$.setPassword(d,p,h),50,3),this.h.trace("Set password from keytar for account:",p);return}if(await this.m($,d,p),h.length<=ut.b){await(0,S.$Kg)(()=>$.setPassword(d,p,h),50,3),this.h.trace("Set password from keytar for account:",p);return}let v=0,y=0,o=!0;for(;o;){const g=h.substring(v,v+ut.b);v+=ut.b,o=h.length-v>0;const c={content:g,hasNextChunk:o};await(0,S.$Kg)(()=>$.setPassword(d,y?`${p}-${y}`:p,JSON.stringify(c)),50,3),y++}this.h.trace(`Set${y?` ${y}-chunked`:""} password from keytar for account:`,p)}async deletePassword($,d){this.h.trace("Going to delete password using keytar:",$,d);let p;try{p=await this.i()}catch(v){throw this.j?.(v),v}const h=await this.g.queue($+d,()=>this.m(p,$,d));return h&&this.c.fire({service:$,account:d}),h}async m($,d,p){this.h.trace("Doing delete password from keytar:",d,p);const h=await $.getPassword(d,p);if(!h)return this.h.trace("Did not get a password to delete from keytar for account:",p),!1;let v,y;try{const g=JSON.parse(h);v=g.content,y=g.hasNextChunk}catch{}let o=0;if(v&&y)try{for(o++;y;){const g=`${p}-${o}`,c=await $.getPassword(d,g);await $.deletePassword(d,g),y=JSON.parse(c).hasNextChunk,o++}}catch(g){this.h.error(g)}return await $.deletePassword(d,p)?(this.h.trace(`Deleted${o?` ${o}-chunked`:""} password from keytar for account:`,p),!0):(this.h.trace(`Keytar failed to delete${o?` ${o}-chunked`:""} password for account:`,p),!1)}async findPassword($){let d;try{d=await this.i()}catch{return null}return await d.findPassword($)}async findCredentials($){let d;try{d=await this.i()}catch{return[]}return await d.findCredentials($)}clear(){return this.f instanceof E.$mn?this.f.clear():Promise.resolve()}};e.$nn=f,e.$nn=f=pe([x(0,M.$Pi)],f)}),define(te[218],ie([0,1,14,4,5]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K3b=void 0;const M=E.safeStorage;let R=class{constructor(f,u){this.a=f,this.b=u,E.app.commandLine.getSwitchValue("password-store")==="basic"&&M.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.b.trace("[EncryptionMainService] Encrypting value.");try{const u=JSON.stringify(M.encryptString(f));return this.b.trace("[EncryptionMainService] Encrypted value."),u}catch(u){throw this.b.error(u),u}}async decrypt(f){let u;try{if(u=JSON.parse(f),!u.data)return this.b.trace("[EncryptionMainService] Unable to parse encrypted value. Attempting old decryption."),this.c(f)}catch(d){return this.b.trace("[EncryptionMainService] Unable to parse encrypted value. Attempting old decryption.",d),this.c(f)}const $=Buffer.from(u.data);this.b.trace("[EncryptionMainService] Decrypting value.");try{const d=M.decryptString($);return this.b.trace("[EncryptionMainService] Decrypted value."),d}catch(d){throw this.b.error(d),d}}isEncryptionAvailable(){return Promise.resolve(M.isEncryptionAvailable())}getKeyStorageProvider(){if(C.$i)return Promise.resolve("dpapi");if(C.$j)return Promise.resolve("keychain_access");if(M.getSelectedStorageBackend)try{const f=M.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.b.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(C.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(C.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!M.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");M.setUsePlainTextEncryption(!0)}async c(f){let u;try{u=await new Promise(($,d)=>G(["vscode-encrypt"],$,d))}catch{return f}try{return u.decrypt(this.a,f)}catch($){return this.b.error($),f}}};e.$K3b=R,e.$K3b=R=pe([x(1,r.$Pi)],R)}),define(te[219],ie([0,1,24,8,13,3,2,9,77,5]),function(G,e,E,C,r,M,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;class $ extends R.$lb{constructor(p,h){super(),this.a=p,this.b=h,this.c=this.B(new M.$7c),this.onDidChangeFile=this.c.event,this.g=this.B(new M.$7c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new C.$rg(0)),this.s=[],this.t=this.B(new C.$rg(0))}watch(p,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(p,h):this.u(p,h)}l(p,h){const v={path:this.C(p),excludes:h.excludes,includes:h.includes,recursive:h.recursive},y=(0,E.$Af)(this.j,v);return this.m(),(0,R.$jb)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(p=>(0,r.$Y)(p))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,f.$vp)(h)),h=>this.z(h),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const p=this.b?.watcher?.recursive?.usePolling;if(p===!0)for(const h of this.j)(0,f.$rp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(p))for(const h of this.j)(0,f.$rp)(h)&&p.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(p,h){const v={path:this.C(p),excludes:h.excludes,includes:h.includes,recursive:!1},y=(0,E.$Af)(this.s,v);return this.v(),(0,R.$jb)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(p=>(0,r.$Y)(p))}w(){return this.r||(this.r=this.B(this.y(p=>this.c.fire((0,f.$vp)(p)),p=>this.z(p),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.r.watch(this.s)}z(p){p.type==="error"&&this.g.fire(p.message),this.a[p.type](p.message)}C(p){return(0,S.$$b)(p.fsPath)}}e.$zp=$}),define(te[220],ie([0,1,24,8,17,21,3,57,68,2,58,15,65,19,56,173,16,118,5,13]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=void 0;let k=class extends u.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new R.$7c),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.$7c),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.$7c),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new R.$7c),this.onDidRunOperation=this.m.event,this.R=this.B(new R.$7c),this.onDidFilesChange=this.R.event,this.S=this.B(new R.$7c),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new C.$Bg)}registerProvider(t,l){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${t}`);const s=new u.$kb;return this.h.set(t,l),this.c.fire({added:!0,scheme:t,provider:l}),s.add(l.onDidChangeFile(n=>this.R.fire(new o.$9j(n,!this.O(l))))),typeof l.onDidWatchError=="function"&&s.add(l.onDidWatchError(n=>this.S.fire(new Error(n)))),s.add(l.onDidChangeCapabilities(()=>this.g.fire({provider:l,scheme:t}))),(0,u.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:l}),this.h.delete(t),(0,u.$gb)(s)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const l=[];this.f.fire({scheme:t,join(s){l.push(s)}}),!this.h.has(t)&&await C.Promises.settled(l)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,l){const s=this.h.get(t.scheme);return!!(s&&s.capabilities&l)}listCapabilities(){return f.Iterable.map(this.h,([t,l])=>({scheme:t,capabilities:l.capabilities}))}async j(t){if(!(0,h.$_f)(t))throw new o.$$j((0,y.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const l=this.h.get(t.scheme);if(!l){const s=new b.$ab;throw s.message=(0,y.localize)(1,null,t.toString()),s}return l}async k(t){const l=await this.j(t);if((0,o.$Vj)(l)||(0,o.$Sj)(l)||(0,o.$Wj)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const l=await this.j(t);if((0,o.$Vj)(l)||(0,o.$Sj)(l))return l;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,l){try{return await this.n(t,l)}catch(s){throw(0,o.$6j)(s)===o.FileSystemProviderErrorCode.FileNotFound?new o.$$j((0,y.localize)(2,null,this.nb(t)),1):(0,o.$4j)(s)}}async n(t,l){const s=await this.j(t),n=this.O(s),i=l?.resolveTo,a=l?.resolveSingleChildDescendants,m=l?.resolveMetadata,P=await s.stat(t);let I;return this.p(s,t,P,void 0,!!m,(D,O)=>(I||(I=$.$th.forUris(()=>!n),I.set(t,!0),i&&I.fill(!0,i)),I.get(D.resource)||I.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&a?O===1:!1))}async p(t,l,s,n,i,a){const{providerExtUri:m}=this.N(t),P={resource:l,name:m.basename(l),isFile:(s.type&o.FileType.File)!==0,isDirectory:(s.type&o.FileType.Directory)!==0,isSymbolicLink:(s.type&o.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&o.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((s.permissions??0)&o.FilePermission.Locked),etag:(0,o.$jk)({mtime:s.mtime,size:s.size}),children:void 0};if(P.isDirectory&&a(P,n)){try{const I=await t.readdir(l),D=await C.Promises.settled(I.map(async([O,L])=>{try{const N=m.joinPath(l,O),q=i?await t.stat(N):{type:L};return await this.p(t,N,q,I.length,i,a)}catch(N){return this.b.trace(N),null}}));P.children=(0,E.$lf)(D)}catch(I){this.b.trace(I),P.children=[]}return P}return P}async resolveAll(t){return C.Promises.settled(t.map(async l=>{try{return{stat:await this.n(l.resource,l.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(t){const l=await this.j(t),s=await l.stat(t);return this.p(l,t,s,void 0,!0,()=>!1)}async exists(t){const l=await this.j(t);try{return!!await l.stat(t)}catch{return!1}}async canCreateFile(t,l){try{await this.r(t,l)}catch(s){return s}return!0}async r(t,l){if(!l?.overwrite&&await this.exists(t))throw new o.$$j((0,y.localize)(3,null,this.nb(t)),3,l)}async createFile(t,l=r.$Jb.fromString(""),s){await this.r(t,s);const n=await this.writeFile(t,l);return this.m.fire(new o.$8j(t,0,n)),n}async writeFile(t,l,s){const n=this.lb(await this.l(t),t),{providerExtUri:i}=this.N(n);try{await this.s(n,t,s)||await this.P(n,i.dirname(t));let m;if((0,o.$Sj)(n)&&!(l instanceof r.$Jb))if((0,v.$vb)(l)){const P=await(0,v.$Cb)(l,3);P.ended?m=r.$Jb.concat(P.buffer):m=P}else m=(0,v.$zb)(l,P=>r.$Jb.concat(P),3);else m=l;if(!(0,o.$Vj)(n)||(0,o.$Sj)(n)&&m instanceof r.$Jb)await this.cb(n,t,s,m);else{const P=m instanceof r.$Jb?(0,r.$Ub)(m):m;s?.atomic!==!1&&s?.atomic?.postfix?await this.Y(n,t,(0,h.$8f)((0,h.$7f)(t),`${(0,h.$5f)(t)}${s.atomic.postfix}`),s,P):await this.Z(n,t,s,P)}this.m.fire(new o.$8j(t,4))}catch(a){throw new o.$$j((0,y.localize)(4,null,this.nb(t),(0,o.$4j)(a).toString()),(0,o.$7j)(a),s)}return this.resolve(t,{resolveMetadata:!0})}async s(t,l,s){const n=!!s?.unlock;if(n&&!(t.capabilities&8192))throw new Error((0,y.localize)(5,null,this.nb(l)));if(!!s?.atomic){if(!(t.capabilities&32768))throw new Error((0,y.localize)(6,null,this.nb(l)));if(n)throw new Error((0,y.localize)(7,null,this.nb(l)))}let a;try{a=await t.stat(l)}catch{return}if(a.type&o.FileType.Directory)throw new o.$$j((0,y.localize)(8,null,this.nb(l)),0,s);if(this.mb(l,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==o.$ik&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,o.$jk)({mtime:s.mtime,size:a.size}))throw new o.$$j((0,y.localize)(9,null),3,s);return a}async readFile(t,l,s){const n=await this.k(t);return l?.atomic?this.t(n,t,l,s):this.u(n,t,l,s)}async t(t,l,s,n){return new Promise((i,a)=>{this.X.queueFor(l,this.N(t).providerExtUri).queue(async()=>{try{const m=await this.u(t,l,s,n);i(m)}catch(m){a(m)}})})}async u(t,l,s,n){const i=await this.v(t,l,{...s,preferUnbuffered:!0},n);return{...i,value:await(0,r.$Vb)(i.value)}}async readFileStream(t,l,s){const n=await this.k(t);return this.v(n,t,l,s)}async v(t,l,s,n){const i=new M.$dd(n),a=this.F(l,s).then(P=>P,P=>{throw i.cancel(),P});let m;try{return typeof s?.etag=="string"&&s.etag!==o.$ik&&await a,s?.atomic&&(0,o.$Xj)(t)||!((0,o.$Vj)(t)||(0,o.$Wj)(t))||(0,o.$Sj)(t)&&s?.preferUnbuffered?m=this.D(t,l,s):(0,o.$Wj)(t)?m=this.z(t,l,i.token,s):m=this.C(t,l,i.token,s),{...await a,value:m}}catch(P){throw m&&await(0,v.$Ab)(m),this.w(P,l,s)}}w(t,l,s){const n=(0,y.localize)(10,null,this.nb(l),(0,o.$4j)(t).toString());return t instanceof o.$ak?new o.$ak(n,t.stat,s):t instanceof o.$_j?new o.$_j(n,t.fileOperationResult,t.size,t.options):new o.$$j(n,(0,o.$7j)(t),s)}z(t,l,s,n=Object.create(null)){const i=t.readFileStream(l,n,s);return(0,v.$Gb)(i,{data:a=>a instanceof r.$Jb?a:r.$Jb.wrap(a),error:a=>this.w(a,l,n)},a=>r.$Jb.concat(a))}C(t,l,s,n=Object.create(null)){const i=(0,r.$Zb)();return(0,g.$pp)(t,l,i,a=>a,{...n,bufferSize:this.a,errorTransformer:a=>this.w(a,l,n)},s),i}D(t,l,s){const n=(0,v.$xb)(i=>r.$Jb.concat(i));return(async()=>{try{let i;s?.atomic&&(0,o.$Xj)(t)?i=await t.readFile(l,{atomic:!0}):i=await t.readFile(l),typeof s?.position=="number"&&(i=i.slice(s.position)),typeof s?.length=="number"&&(i=i.slice(0,s.length)),this.G(l,i.byteLength,s),n.end(r.$Jb.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async F(t,l){const s=await this.resolve(t,{resolveMetadata:!0});if(s.isDirectory)throw new o.$$j((0,y.localize)(11,null,this.nb(t)),0,l);if(typeof l?.etag=="string"&&l.etag!==o.$ik&&l.etag===s.etag)throw new o.$ak((0,y.localize)(12,null),s,l);return this.G(t,s.size,l),s}G(t,l,s){if(typeof s?.limits?.size=="number"&&l>s.limits.size)throw new o.$_j((0,y.localize)(13,null,this.nb(t)),7,l,s)}async canMove(t,l,s){return this.H(t,l,"move",s)}async canCopy(t,l,s){return this.H(t,l,"copy",s)}async H(t,l,s,n){if(t.toString()!==l.toString())try{const i=s==="move"?this.lb(await this.l(t),t):await this.k(t),a=this.lb(await this.l(l),l);await this.M(i,t,a,l,s,n)}catch(i){return i}return!0}async move(t,l,s){const n=this.lb(await this.l(t),t),i=this.lb(await this.l(l),l),a=await this.I(n,t,i,l,"move",!!s),m=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new o.$8j(t,a==="move"?2:3,m)),m}async copy(t,l,s){const n=await this.k(t),i=this.lb(await this.l(l),l),a=await this.I(n,t,i,l,"copy",!!s),m=await this.resolve(l,{resolveMetadata:!0});return this.m.fire(new o.$8j(t,a==="copy"?3:2,m)),m}async I(t,l,s,n,i,a){if(l.toString()===n.toString())return i;const{exists:m,isSameResourceWithDifferentPathCase:P}=await this.M(t,l,s,n,i,a);if(m&&!P&&a&&await this.del(n,{recursive:!0}),await this.P(s,this.N(s).providerExtUri.dirname(n)),i==="copy"){if(t===s&&(0,o.$Tj)(t))await t.copy(l,n,{overwrite:a});else{const I=await this.resolve(l);I.isDirectory?await this.L(t,I,s,n):await this.J(t,l,s,n)}return i}else return t===s?(await t.rename(l,n,{overwrite:a}),i):(await this.I(t,l,s,n,"copy",a),await this.del(l,{recursive:!0}),"copy")}async J(t,l,s,n){if((0,o.$Vj)(t)&&(0,o.$Vj)(s))return this.eb(t,l,s,n);if((0,o.$Vj)(t)&&(0,o.$Sj)(s))return this.kb(t,l,s,n);if((0,o.$Sj)(t)&&(0,o.$Vj)(s))return this.ib(t,l,s,n);if((0,o.$Sj)(t)&&(0,o.$Sj)(s))return this.gb(t,l,s,n)}async L(t,l,s,n){await s.mkdir(n),Array.isArray(l.children)&&await C.Promises.settled(l.children.map(async i=>{const a=this.N(s).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.L(t,await this.resolve(i.resource),s,a):this.J(t,i.resource,s,a)}))}async M(t,l,s,n,i,a){let m=!1;if(t===s){const{providerExtUri:I,isPathCaseSensitive:D}=this.N(t);if(D||(m=I.isEqual(l,n)),m&&i==="copy")throw new Error((0,y.localize)(14,null,this.nb(l),this.nb(n)));if(!m&&I.isEqualOrParent(n,l))throw new Error((0,y.localize)(15,null,this.nb(l),this.nb(n)))}const P=await this.exists(n);if(P&&!m){if(!a)throw new o.$$j((0,y.localize)(16,null,this.nb(l),this.nb(n)),4);if(t===s){const{providerExtUri:I}=this.N(t);if(I.isEqualOrParent(l,n))throw new Error((0,y.localize)(17,null,this.nb(l),this.nb(n)))}}return{exists:P,isSameResourceWithDifferentPathCase:m}}N(t){const l=this.O(t);return{providerExtUri:l?h.$Xf:h.$Zf,isPathCaseSensitive:l}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const l=this.lb(await this.j(t),t);await this.P(l,t);const s=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new o.$8j(t,0,s)),s}async P(t,l){const s=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(l,n.dirname(l));)try{if(!((await t.stat(l)).type&o.FileType.Directory))throw new Error((0,y.localize)(18,null,this.nb(l)));break}catch(i){if((0,o.$6j)(i)!==o.FileSystemProviderErrorCode.FileNotFound)throw i;s.push(n.basename(l)),l=n.dirname(l)}for(let i=s.length-1;i>=0;i--){l=n.joinPath(l,s[i]);try{await t.mkdir(l)}catch(a){if((0,o.$6j)(a)!==o.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(t,l){try{await this.Q(t,l)}catch(s){return s}return!0}async Q(t,l){const s=this.lb(await this.j(t),t),n=!!l?.useTrash;if(n&&!(s.capabilities&4096))throw new Error((0,y.localize)(19,null,this.nb(t)));const i=l?.atomic;if(i&&!(s.capabilities&65536))throw new Error((0,y.localize)(20,null,this.nb(t)));if(n&&i)throw new Error((0,y.localize)(21,null,this.nb(t)));let a;try{a=await s.stat(t)}catch{}if(a)this.mb(t,a);else throw new o.$$j((0,y.localize)(22,null,this.nb(t)),1);if(!!!l?.recursive){const P=await this.resolve(t);if(P.isDirectory&&Array.isArray(P.children)&&P.children.length>0)throw new Error((0,y.localize)(23,null,this.nb(t)))}return s}async del(t,l){const s=await this.Q(t,l),n=!!l?.useTrash,i=!!l?.recursive,a=l?.atomic??!1;await s.delete(t,{recursive:i,useTrash:n,atomic:a}),this.m.fire(new o.$8j(t,1))}async cloneFile(t,l){const s=await this.j(t),n=this.lb(await this.l(l),l);if(s===n&&this.N(s).providerExtUri.isEqual(t,l))return;if(s===n&&(0,o.$Uj)(s))return s.cloneFile(t,l);await this.P(n,this.N(n).providerExtUri.dirname(l));const i=this.X.queueFor(t,this.N(s).providerExtUri);return s===n&&(0,o.$Tj)(s)?i.queue(()=>s.copy(t,l,{overwrite:!0})):i.queue(()=>this.J(s,t,n,l))}watch(t,l={recursive:!1,excludes:[]}){const s=new u.$kb;let n=!1,i=()=>{n=!0};return s.add((0,u.$jb)(()=>i())),(async()=>{try{const a=await this.W(t,l);n?(0,u.$gb)(a):i=()=>(0,u.$gb)(a)}catch(a){this.b.error(a)}})(),s}async W(t,l){const s=await this.j(t),n=(0,S.$bi)([this.N(s).providerExtUri.getComparisonKey(t),l]);let i=this.U.get(n);return i||(i={count:0,disposable:s.watch(t,l)},this.U.set(n,i)),i.count+=1,(0,u.$jb)(()=>{i&&(i.count--,i.count===0&&((0,u.$gb)(i.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,u.$gb)(t.disposable);this.U.clear()}async Y(t,l,s,n,i){await this.Z(t,s,n,i);try{await t.rename(s,l,{overwrite:!0})}catch(a){try{await t.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async Z(t,l,s,n){return this.X.queueFor(l,this.N(t).providerExtUri).queue(async()=>{const i=await t.open(l,{create:!0,unlock:s?.unlock??!1});try{(0,v.$vb)(n)||(0,v.$wb)(n)?await this.$(t,i,n):await this.ab(t,i,n)}catch(a){throw(0,o.$4j)(a)}finally{await t.close(i)}})}async $(t,l,s){let n=0,i;if((0,v.$wb)(s)){if(s.buffer.length>0){const a=r.$Jb.concat(s.buffer);await this.bb(t,l,a,a.byteLength,n,0),n+=a.byteLength}if(s.ended)return;i=s.stream}else i=s;return new Promise((a,m)=>{(0,v.$Bb)(i,{onData:async P=>{i.pause();try{await this.bb(t,l,P,P.byteLength,n,0)}catch(I){return m(I)}n+=P.byteLength,setTimeout(()=>i.resume())},onError:P=>m(P),onEnd:()=>a()})})}async ab(t,l,s){let n=0,i;for(;(i=s.read())!==null;)await this.bb(t,l,i,i.byteLength,n,0),n+=i.byteLength}async bb(t,l,s,n,i,a){let m=0;for(;m<n;){const P=await t.write(l,i+m,s.buffer,a+m,n-m);m+=P}}async cb(t,l,s,n){return this.X.queueFor(l,this.N(t).providerExtUri).queue(()=>this.db(t,l,s,n))}async db(t,l,s,n){let i;n instanceof r.$Jb?i=n:(0,v.$vb)(n)?i=await(0,r.$Vb)(n):(0,v.$wb)(n)?i=await(0,r.$Wb)(n):i=(0,r.$Tb)(n),await t.writeFile(l,i.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async eb(t,l,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.fb(t,l,s,n))}async fb(t,l,s,n){let i,a;try{i=await t.open(l,{create:!1}),a=await s.open(n,{create:!0,unlock:!1});const m=r.$Jb.alloc(this.a);let P=0,I=0,D=0;do D=await t.read(i,P,m.buffer,I,m.byteLength-I),await this.bb(s,a,m,D,P,I),P+=D,I+=D,I===m.byteLength&&(I=0);while(D>0)}catch(m){throw(0,o.$4j)(m)}finally{await C.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async gb(t,l,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.hb(t,l,s,n))}async hb(t,l,s,n){return s.writeFile(n,await t.readFile(l),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,l,s,n){return this.X.queueFor(n,this.N(s).providerExtUri).queue(()=>this.jb(t,l,s,n))}async jb(t,l,s,n){const i=await s.open(n,{create:!0,unlock:!1});try{const a=await t.readFile(l);await this.bb(s,i,r.$Jb.wrap(a),a.byteLength,0,0)}catch(a){throw(0,o.$4j)(a)}finally{await s.close(i)}}async kb(t,l,s,n){const i=await(0,r.$Vb)(this.C(t,l,M.CancellationToken.None));await this.cb(s,n,void 0,i)}lb(t,l){if(t.capabilities&2048)throw new o.$$j((0,y.localize)(24,null,this.nb(l)),6);return t}mb(t,l){if((l.permissions??0)&o.FilePermission.Readonly)throw new o.$$j((0,y.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===d.Schemas.file?t.fsPath:t.toString(!0)}};e.$qp=k,e.$qp=k=pe([x(0,c.$Pi)],k)}),define(te[94],ie([0,1,42,309,8,35,17,3,32,2,9,4,19,56,22,177,16,118,219,50,214,213]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0,(()=>{try{(0,C.gracefulify)(E)}catch(l){console.error(`Error enabling graceful-fs: ${(0,b.$$h)(l)}`)}})();class t extends c.$zp{static{this.D=!1}constructor(s,n){super(s,n),this.onDidChangeCapabilities=S.Event.None,this.I=new M.$li(i=>p.$Yf.getComparisonKey(i)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,d.$k&&(this.F|=1024)),this.F}async stat(s){try{const{stat:n,symbolicLink:i}=await v.SymlinkSupport.stat(this.C(s));return{type:this.H(n,i),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:o.FilePermission.Locked}}catch(n){throw this.ab(n)}}async G(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const n=await v.Promises.readdir(this.C(s),{withFileTypes:!0}),i=[];return await Promise.all(n.map(async a=>{try{let m;a.isSymbolicLink()?m=(await this.stat((0,p.$8f)(s,a.name))).type:m=this.H(a),i.push([a.name,m])}catch(m){this.a.trace(m)}})),i}catch(n){throw this.ab(n)}}H(s,n){let i;return n?.dangling?i=o.FileType.Unknown:s.isFile()?i=o.FileType.File:s.isDirectory()?i=o.FileType.Directory:i=o.FileType.Unknown,n&&(i|=o.FileType.SymbolicLink),i}async J(s){const n=this.C(s);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let i;for(;i=this.I.get(s);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await i.wait();const a=new r.$sg;return this.I.set(s,a),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,u.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.I.get(s)===a&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.I.delete(s)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),a.open()})}async readFile(s,n){let i;try{n?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(s)})`),i=await this.J(s));const a=this.C(s);return await v.Promises.readFile(a)}catch(a){throw this.ab(a)}finally{i?.dispose()}}L(s){t.D&&this.a.trace(s)}readFileStream(s,n,i){const a=(0,h.$xb)(m=>R.$Jb.concat(m.map(P=>R.$Jb.wrap(P))).buffer);return(0,g.$pp)(this,s,a,m=>m.buffer,{...n,bufferSize:256*1024},i),a}async writeFile(s,n,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.M(s,(0,p.$8f)((0,p.$7f)(s),`${(0,p.$5f)(s)}${i.atomic.postfix}`),n,i):this.N(s,n,i)}async M(s,n,i,a){await this.N(n,i,a);try{await this.rename(n,s,{overwrite:!0})}catch(m){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw m}}async N(s,n,i){let a;try{const m=this.C(s);if(!i.create||!i.overwrite){if(await v.Promises.exists(m)){if(!i.overwrite)throw(0,o.$3j)((0,y.localize)(0,null),o.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,o.$3j)((0,y.localize)(1,null),o.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(s,{create:!0,unlock:i.unlock}),await this.write(a,0,n,0,n.byteLength)}catch(m){throw await this.bb(s,m)}finally{typeof a=="number"&&await this.close(a)}}static{this.R=!0}static configureFlushOnWrite(s){t.R=s}async open(s,n){const i=this.C(s);let a;(0,o.$Rj)(n)&&(a=await this.J(s));let m;try{if((0,o.$Rj)(n)&&n.unlock)try{const{stat:I}=await v.SymlinkSupport.stat(i);I.mode&128||await v.Promises.chmod(i,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let P;if((0,o.$Rj)(n)){if(d.$i)try{await v.Promises.truncate(i,0),P="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}P||(P="w")}else P="r";m=await v.Promises.open(i,P)}catch(P){throw a?.dispose(),(0,o.$Rj)(n)?await this.bb(s,P):this.ab(P)}if(this.O.set(m,0),(0,o.$Rj)(n)&&this.Q.set(m,s),a){const P=this.P.get(m);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${m} (${i})`),this.P.set(m,a),P&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${m} (${i})`),P.dispose())}return m}async close(s){const n=this.P.get(s);try{if(this.O.delete(s),this.Q.delete(s)&&t.R)try{await v.Promises.fdatasync(s)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await v.Promises.close(s)}catch(i){throw this.ab(i)}finally{n&&(this.P.get(s)===n&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.P.delete(s)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),n.dispose())}}async read(s,n,i,a,m){const P=this.S(s,n);let I=null;try{I=(await v.Promises.read(s,i,a,m,P)).bytesRead}catch(D){throw this.ab(D)}finally{this.U(s,P,I)}return I}S(s,n){return n===this.O.get(s)?null:n}U(s,n,i){const a=this.O.get(s);typeof a=="number"&&(typeof n=="number"||(typeof i=="number"?this.O.set(s,a+i):this.O.delete(s)))}async write(s,n,i,a,m){return(0,r.$Kg)(()=>this.W(s,n,i,a,m),100,3)}async W(s,n,i,a,m){const P=this.S(s,n);let I=null;try{I=(await v.Promises.write(s,i,a,m,P)).bytesWritten}catch(D){throw await this.bb(this.Q.get(s),D)}finally{this.U(s,P,I)}return I}async mkdir(s){try{await v.Promises.mkdir(this.C(s))}catch(n){throw this.ab(n)}}async delete(s,n){try{const i=this.C(s);if(n.recursive){let a;n?.atomic!==!1&&n.atomic.postfix&&(a=(0,$.$ac)((0,$.$dc)(i),`${(0,$.$ec)(i)}${n.atomic.postfix}`)),await v.Promises.rm(i,v.RimRafMode.MOVE,a)}else try{await v.Promises.unlink(i)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let m=!1;try{const{stat:P,symbolicLink:I}=await v.SymlinkSupport.stat(i);m=P.isDirectory()&&!I}catch{}if(m)await v.Promises.rmdir(i);else throw a}else throw a}}catch(i){throw this.ab(i)}}async rename(s,n,i){const a=this.C(s),m=this.C(n);if(a!==m)try{await this.X(s,n,"move",i.overwrite),await v.Promises.move(a,m)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(2,null,(0,$.$ec)(a),(0,$.$ec)((0,$.$dc)(m)),P.toString()))),this.ab(P)}}async copy(s,n,i){const a=this.C(s),m=this.C(n);if(a!==m)try{await this.X(s,n,"copy",i.overwrite),await v.Promises.copy(a,m,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(3,null,(0,$.$ec)(a),(0,$.$ec)((0,$.$dc)(m)),P.toString()))),this.ab(P)}}async X(s,n,i,a){const m=this.C(s),P=this.C(n);let I=!1;if(!!(this.capabilities&1024)||(I=(0,f.$Ie)(m,P,!0)),I){if(i==="copy")throw(0,o.$3j)((0,y.localize)(4,null),o.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const O=await this.G(s);if(!O)throw(0,o.$3j)((0,y.localize)(5,null),o.FileSystemProviderErrorCode.FileNotFound);const L=await this.G(n);if(L){if(!a)throw(0,o.$3j)((0,y.localize)(6,null),o.FileSystemProviderErrorCode.FileExists);O.type&o.FileType.File&&L.type&o.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,n){return this.Y(s,n,!1)}async Y(s,n,i){const a=this.C(s),m=this.C(n),P=!!(this.capabilities&1024);if((0,f.$Ie)(a,m,!P))return;const I=new u.$kb;try{const[D,O]=await Promise.all([this.J(s),this.J(n)]);I.add(D),I.add(O),i&&await v.Promises.mkdir((0,$.$dc)(m),{recursive:!0}),await v.Promises.copyFile(a,m)}catch(D){if(D.code==="ENOENT"&&!i)return this.Y(s,n,!0);throw this.ab(D)}finally{I.dispose()}}p(s,n,i){return new k.$Gp(a=>s(a),a=>n(a),i)}y(s,n,i){return new w.$Op(a=>s(a),a=>n(a),i)}ab(s){if(s instanceof o.$2j)return s;let n=s,i;switch(s.code){case"ENOENT":i=o.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=o.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=o.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=o.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=o.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=o.FileSystemProviderErrorCode.Unknown;break;default:i=o.FileSystemProviderErrorCode.Unknown}return(0,o.$3j)(n,i)}async bb(s,n){let i=this.ab(n);if(s&&i.code===o.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await v.SymlinkSupport.stat(this.C(s));a.mode&128||(i=(0,o.$3j)(n,o.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return i}}e.$Pp=t}),define(te[221],ie([0,1,3,94,2,17,56,21]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kr=e.$jr=void 0;class f extends r.$lb{constructor(d,p){super(),this.a=d,this.b=p,this.w=new Map,this.y=new Map}call(d,p,h){const v=this.c(d);switch(p){case"stat":return this.g(v,h[0]);case"readdir":return this.h(v,h[0]);case"open":return this.l(v,h[0],h[1]);case"close":return this.m(h[0]);case"read":return this.n(h[0],h[1],h[2]);case"readFile":return this.i(v,h[0],h[1]);case"write":return this.p(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.k(v,h[0],h[1],h[2]);case"rename":return this.t(v,h[0],h[1],h[2]);case"copy":return this.u(v,h[0],h[1],h[2]);case"cloneFile":return this.v(v,h[0],h[1]);case"mkdir":return this.r(v,h[0]);case"delete":return this.s(v,h[0],h[1]);case"watch":return this.C(v,h[0],h[1],h[2],h[3]);case"unwatch":return this.D(h[0],h[1])}throw new Error(`IPC Command ${p} not found`)}listen(d,p,h){const v=this.c(d);switch(p){case"fileChange":return this.z(v,h[0]);case"readFileStream":return this.j(v,h[0],h[1])}throw new Error(`Unknown event ${p}`)}g(d,p){const h=this.f(d,p,!0);return this.a.stat(h)}h(d,p){const h=this.f(d,p);return this.a.readdir(h)}async i(d,p,h){const v=this.f(d,p,!0),y=await this.a.readFile(v,h);return M.$Jb.wrap(y)}j(d,p,h){const v=this.f(d,p,!0),y=new S.$dd,o=new E.$7c({onDidRemoveLastListener:()=>{y.cancel()}}),g=this.a.readFileStream(v,h,y.token);return(0,R.$Bb)(g,{onData:c=>o.fire(M.$Jb.wrap(c)),onError:c=>o.fire(c),onEnd:()=>{o.fire("end"),o.dispose(),y.dispose()}}),o.event}k(d,p,h,v){const y=this.f(d,p);return this.a.writeFile(y,h.buffer,v)}l(d,p,h){const v=this.f(d,p,!0);return this.a.open(v,h)}m(d){return this.a.close(d)}async n(d,p,h){const v=M.$Jb.alloc(h),y=0,o=await this.a.read(d,p,v.buffer,y,h);return[v,o]}p(d,p,h,v,y){return this.a.write(d,p,h.buffer,v,y)}r(d,p){const h=this.f(d,p);return this.a.mkdir(h)}s(d,p,h){const v=this.f(d,p);return this.a.delete(v,h)}t(d,p,h,v){const y=this.f(d,p),o=this.f(d,h);return this.a.rename(y,o,v)}u(d,p,h,v){const y=this.f(d,p),o=this.f(d,h);return this.a.copy(y,o,v)}v(d,p,h){const v=this.f(d,p),y=this.f(d,h);return this.a.cloneFile(v,y)}z(d,p){const h=new E.$7c({onWillAddFirstListener:()=>{this.w.set(p,this.F(d,h))},onDidRemoveLastListener:()=>{(0,r.$gb)(this.w.get(p)),this.w.delete(p)}});return h.event}async C(d,p,h,v,y){const o=this.w.get(p);if(o){const g=this.f(d,v),c=o.watch(h,g,y);this.y.set(p+h,c)}}async D(d,p){const h=d+p,v=this.y.get(h);v&&((0,r.$gb)(v),this.y.delete(h))}dispose(){super.dispose();for(const[,d]of this.y)d.dispose();this.y.clear();for(const[,d]of this.w)d.dispose();this.w.clear()}}e.$jr=f;class u extends r.$lb{constructor(d,p,h,v){super(),this.c=d,this.f=h,this.g=v,this.a=new Map,this.b=this.B(new C.$Pp(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(p)}h(d){const p=this.B(new E.$7c);this.B(p.event(h=>{d.fire(h.map(v=>({resource:this.c.transformOutgoingURI(v.resource),type:v.type})))})),this.B(this.b.onDidChangeFile(h=>p.fire(h))),this.B(this.b.onDidWatchError(h=>d.fire(h)))}i(d){}j(d){}watch(d,p,h){const v=this.j(this.g);return Array.isArray(v)&&(h.excludes=[...h.excludes,...v]),this.a.set(d,this.b.watch(p,h)),(0,r.$jb)(()=>{(0,r.$gb)(this.a.get(d)),this.a.delete(d)})}dispose(){super.dispose();for(const[,d]of this.a)d.dispose();this.a.clear()}}e.$kr=u}),define(te[222],ie([0,1,14,176,4,7,16,9,221,154]),function(G,e,E,C,r,M,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S3b=void 0;class $ extends f.$jr{constructor(h,v,y){super(h,v),this.G=y}c(h){return u.$mm}f(h,v){return M.URI.revive(v)}async s(h,v,y){if(!y.useTrash)return super.s(h,v,y);const o=this.f(h,v),g=(0,S.$$b)(o.fsPath);try{await E.shell.trashItem(g)}catch{throw(0,R.$3j)(r.$i?(0,C.localize)(0,null,(0,S.$ec)(g)):(0,C.localize)(1,null,(0,S.$ec)(g)),R.FileSystemProviderErrorCode.Unknown)}}F(h,v){return new d(h,v,this.b,this.G)}}e.$S3b=$;class d extends f.$kr{watch(h,v,y){if(y.recursive)throw(0,R.$3j)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(h,v,y)}}}),define(te[223],ie([0,1,5]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VZb=void 0;class C extends E.$Vi{constructor(M=E.$Si){super(),this.k=[],this.l=void 0,this.setLevel(M),this.B(this.onDidChangeLogLevel(R=>{this.l?.setLevel(R)}))}set logger(M){this.l=M;for(const{level:R,message:S}of this.k)(0,E.log)(M,R,S);this.k=[]}g(M,R){this.l?(0,E.log)(this.l,M,R):this.getLevel()<=M&&this.k.push({level:M,message:R})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.$VZb=C}),define(te[224],ie([0,1,7,3,5,2]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=void 0;class R extends r.$1i{constructor(d,p,h,v,y){super(p,h,v),this.n=d,this.p=y,this.B(y.listen("onDidChangeLogLevel",d)(o=>{(0,r.$Ri)(o)?super.setLogLevel(o):super.setLogLevel(E.URI.revive(o[0]),o[1])})),this.B(y.listen("onDidChangeVisibility",d)(([o,g])=>super.setVisibility(E.URI.revive(o),g))),this.B(y.listen("onDidChangeLoggers",d)(({added:o,removed:g})=>{for(const c of o)super.registerLogger({...c,resource:E.URI.revive(c.resource)});for(const c of g)super.deregisterLogger(c.resource)}))}createConsoleMainLogger(){return new r.$Yi({log:(d,p)=>{this.p.call("consoleLog",[d,p])}})}registerLogger(d){super.registerLogger(d),this.p.call("registerLogger",[d,this.n])}deregisterLogger(d){super.deregisterLogger(d),this.p.call("deregisterLogger",[d,this.n])}setLogLevel(d,p){super.setLogLevel(d,p),this.p.call("setLogLevel",[d,p])}setVisibility(d,p){super.setVisibility(d,p),this.p.call("setVisibility",[this.l(d),p])}m(d,p,h){return new S(this.p,d,p,h,this.n)}static setLogLevel(d,p,h){return d.call("setLogLevel",[p,h])}}e.$Lq=R;class S extends r.$Vi{constructor(d,p,h,v,y){super(v?.logLevel==="always"),this.m=d,this.n=p,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[p,v,y]).then(()=>{this.r(this.l),this.k=!0})}g(d,p){const h=[[d,p]];this.k?this.r(h):this.l.push(...h)}r(d){this.m.call("log",[this.n,d])}}class f{constructor(d,p){this.a=d,this.b=p}listen(d,p){const h=this.b(d);switch(p){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,v=>({added:[...v.added].map(y=>this.c(y,h)),removed:[...v.removed].map(y=>this.c(y,h))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,v=>[h.transformOutgoingURI(v[0]),v[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,v=>(0,r.$Ri)(v)?v:[h.transformOutgoingURI(v[0]),v[1]])}throw new Error(`Event not found: ${p}`)}async call(d,p,h){const v=this.b(d);switch(p){case"setLogLevel":return(0,r.$Ri)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(E.URI.revive(v.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,v)))}throw new Error(`Call not found: ${p}`)}c(d,p){return{...d,resource:p.transformOutgoingURI(d.resource)}}}e.$Mq=f;class u extends M.$lb{constructor(d,p){super(),p.call("setLogLevel",[d.getLogLevel()]),this.B(d.onDidChangeLogLevel(h=>p.call("setLogLevel",[h]))),p.call("getRegisteredLoggers").then(h=>{for(const v of h)d.registerLogger({...v,resource:E.URI.revive(v.resource)})}),this.B(p.listen("onDidChangeVisibility")(([h,v])=>d.setVisibility(E.URI.revive(h),v))),this.B(p.listen("onDidChangeLoggers")(({added:h,removed:v})=>{for(const y of h)d.registerLogger({...y,resource:E.URI.revive(y.resource)});for(const y of v)d.deregisterLogger(y.resource)}))}}e.$Nq=u}),define(te[225],ie([0,1,2,5]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;class r extends E.$lb{constructor(R,S=[]){super(),this.a=new C.$Zi([R,...S]),this.B(R.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...S){this.a.trace(R,...S)}debug(R,...S){this.a.debug(R,...S)}info(R,...S){this.a.info(R,...S)}warn(R,...S){this.a.warn(R,...S)}error(R,...S){this.a.error(R,...S)}flush(){this.a.flush()}}e.$WM=r}),define(te[226],ie([0,1,35,7,5]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O4b=void 0;class M{constructor(S){this.b=S,this.a=new E.$li}listen(S,f,u){switch(f){case"onDidChangeLoggers":return u?this.b.getOnDidChangeLoggersEvent(u):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return u?this.b.getOnDidChangeLogLevelEvent(u):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return u?this.b.getOnDidChangeVisibilityEvent(u):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(S,f,u){switch(f){case"createLogger":this.c(C.URI.revive(u[0]),u[1],u[2]);return;case"log":return this.e(C.URI.revive(u[0]),u[1]);case"consoleLog":return this.d(u[0],u[1]);case"setLogLevel":return(0,r.$Ri)(u[0])?this.b.setLogLevel(u[0]):this.b.setLogLevel(C.URI.revive(u[0]),u[1]);case"setVisibility":return this.b.setVisibility(C.URI.revive(u[0]),u[1]);case"registerLogger":return this.b.registerLogger({...u[0],resource:C.URI.revive(u[0].resource)},u[1]);case"deregisterLogger":return this.b.deregisterLogger(C.URI.revive(u[0]))}throw new Error(`Call not found: ${f}`)}c(S,f,u){this.a.set(S,this.b.createLogger(S,f,u))}d(S,f){let u=console.log;switch(S){case r.LogLevel.Error:u=console.error;break;case r.LogLevel.Warning:u=console.warn;break;case r.LogLevel.Info:u=console.info;break}u.call(console,...f)}e(S,f){const u=this.a.get(S);if(!u)throw new Error("Create the logger before logging");for(const[$,d]of f)(0,r.log)(u,$,d)}}e.$O4b=M}),define(te[227],ie([0,1,16,5]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=void 0;var r;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(r||(r={}));async function M(u,$,d,p,h){try{const v=await new Promise((o,g)=>{G(["@vscode/spdlog"],o,g)});v.setFlushOn(r.Trace);const y=await v.createAsyncRotatingLogger(u,$,d,p);return h?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(v){console.error(v)}return null}function R(u,$,d){switch($){case C.LogLevel.Trace:u.trace(d);break;case C.LogLevel.Debug:u.debug(d);break;case C.LogLevel.Info:u.info(d);break;case C.LogLevel.Warning:u.warn(d);break;case C.LogLevel.Error:u.error(d);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${$}`)}}function S(u,$){switch($){case C.LogLevel.Trace:u.setLevel(r.Trace);break;case C.LogLevel.Debug:u.setLevel(r.Debug);break;case C.LogLevel.Info:u.setLevel(r.Info);break;case C.LogLevel.Warning:u.setLevel(r.Warning);break;case C.LogLevel.Error:u.setLevel(r.Error);break;case C.LogLevel.Off:u.setLevel(r.Off);break;default:throw new Error(`Invalid log level ${$}`)}}class f extends C.$Vi{constructor($,d,p,h,v){super(),this.k=[],this.setLevel(v),this.l=this.n($,d,p,h),this.B(this.onDidChangeLogLevel(y=>{this.m&&S(this.m,y)}))}async n($,d,p,h){const v=p?6:1,y=30/v*E.$lk.MB,o=await M($,d,y,v,h);if(o){this.m=o,S(this.m,this.getLevel());for(const{level:g,message:c}of this.k)R(this.m,g,c);this.k=[]}}g($,d){this.m?R(this.m,$,d):this.getLevel()<=$&&this.k.push({level:$,message:d})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$LM=f}),define(te[228],ie([0,1,31,5,227]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=void 0;class M extends C.$1i{m(S,f,u){return new r.$LM((0,E.$5e)(),S.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,f)}}e.$MM=M}),define(te[66],ie([0,1,35,3,6,5,228]),function(G,e,E,C,r,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f4b=e.$e4b=void 0,e.$e4b=(0,r.$oh)(M.$Qi);class S extends R.$MM{constructor(){super(...arguments),this.p=new E.$li}createLogger(u,$,d){d!==void 0&&this.p.set(this.l(u),d);try{return super.createLogger(u,$)}catch(p){throw this.p.delete(this.l(u)),p}}registerLogger(u,$){$!==void 0&&this.p.set(u.resource,$),super.registerLogger(u)}deregisterLogger(u){this.p.delete(u),super.deregisterLogger(u)}getRegisteredLoggers(u){const $=[];for(const d of super.getRegisteredLoggers())u===this.p.get(d.resource)&&$.push(d);return $}getOnDidChangeLogLevelEvent(u){return C.Event.filter(this.onDidChangeLogLevel,$=>(0,M.$Ri)($)||this.s($[0],u))}getOnDidChangeVisibilityEvent(u){return C.Event.filter(this.onDidChangeVisibility,([$])=>this.s($,u))}getOnDidChangeLoggersEvent(u){return C.Event.filter(C.Event.map(this.onDidChangeLoggers,$=>({added:[...$.added].filter(p=>this.s(p.resource,u)),removed:[...$.removed].filter(p=>this.s(p.resource,u))})),$=>$.added.length>0||$.removed.length>0)}deregisterLoggers(u){for(const[$,d]of this.p)d===u&&this.deregisterLogger($)}s(u,$){const d=this.p.get(u);return d===void 0||d===$}dispose(){super.dispose(),this.p.clear()}}e.$f4b=S}),define(te[229],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$3b=e.$03b=e.$93b=e.$83b=void 0;function E(R){return R.submenu!==void 0}e.$83b=E;function C(R){return R.id==="vscode.menubar.separator"}e.$93b=C;function r(R){return R.uri!==void 0}e.$03b=r;function M(R){return!E(R)&&!C(R)&&!r(R)}e.$$3b=M}),define(te[39],ie([0,1,3,68,2,6]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=void 0,e.$Tm=(0,M.$nh)("policy");class R extends r.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.$7c),this.onDidChange=this.h.event}async updatePolicyDefinitions(u){const $=Object.keys(this.f).length;return this.f={...u,...this.f},$!==Object.keys(this.f).length&&await this.i(u),C.Iterable.reduce(this.g.entries(),(d,[p,h])=>({...d,[p]:h}),{})}getPolicyValue(u){return this.g.get(u)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(u,[$,d])=>({...u,[$]:{definition:d,value:this.g.get($)}}),{})}}e.$Um=R;class S{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Vm=S}),define(te[230],ie([0,1,8,3,68,10,16,5,39]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$64b=void 0;function u(d,p){const h=[];for(const v of new Set(r.Iterable.concat(d.keys(),p.keys())))d.get(v)!==p.get(v)&&h.push(v);return h}let $=class extends f.$Um{constructor(p,h,v){super(),this.j=p,this.k=h,this.l=v,this.c=this.B(new E.$rg(500));const y=C.Event.filter(h.onDidFilesChange,o=>o.affects(p));this.B(h.watch(p)),this.B(y(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const p=new Map;try{const h=await this.k.readFile(this.j),v=JSON.parse(h.value.toString());if(!(0,M.$ke)(v))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(v))this.f[y]&&p.set(y,v[y])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return p}async p(){const p=await this.n(),h=u(this.g,p);this.g=p,h.length>0&&this.h.fire(h)}};e.$64b=$,e.$64b=$=pe([x(1,R.$Qj),x(2,S.$Pi)],$)}),define(te[231],ie([0,1,3,2,39]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I4b=e.$H4b=void 0;class M{constructor(f){this.b=f,this.a=new C.$kb}listen(f,u){switch(u){case"onDidChange":return E.Event.map(this.b.onDidChange,$=>$.reduce((d,p)=>({...d,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${u}`)}call(f,u,$){switch(u){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions($)}throw new Error(`Call not found: ${u}`)}dispose(){this.a.dispose()}}e.$H4b=M;class R extends r.$Um{constructor(f,u){super(),this.a=u;for(const $ in f){const{definition:d,value:p}=f[$];this.f[$]=d,p!==void 0&&this.g.set($,p)}this.a.listen("onDidChange")($=>{for(const d in $){const p=$[d];p===null?this.g.delete(d):this.g.set(d,p)}this.h.fire(Object.keys($))})}async i(f){const u=await this.a.call("updatePolicyDefinitions",f);for(const $ in u)this.g.set($,u[$])}}e.$I4b=R}),define(te[232],ie([0,1,39,8,310,2,5]),function(G,e,E,C,r,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$54b=void 0;let S=class extends E.$Um{constructor(u,$){super(),this.j=u,this.k=$,this.a=new C.$ng,this.b=this.B(new M.$mb)}async i(u){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`),await this.a.queue(()=>new Promise(($,d)=>{try{this.b.value=(0,r.createWatcher)(this.k,u,p=>{this.m(p),$()})}catch(p){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",p),d(p)}}))}m(u){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const $ in u){const d=u[$];d===void 0?this.g.delete($):this.g.set($,d)}this.h.fire(Object.keys(u))}};e.$54b=S,e.$54b=S=pe([x(0,R.$Pi)],S)}),define(te[78],ie([0,1,4,36]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let r;if(typeof E.$g.vscode<"u"&&typeof E.$g.vscode.context<"u"){const M=E.$g.vscode.context.configuration();if(M)r=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(r=globalThis._VSCODE_PRODUCT_JSON,C.env.VSCODE_DEV&&Object.assign(r,{nameShort:`${r.nameShort} Dev`,nameLong:`${r.nameLong} Dev`,dataFolderName:`${r.dataFolderName}-dev`,serverDataFolderName:r.serverDataFolderName?`${r.serverDataFolderName}-dev`:void 0}),!r.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(r,{version:M.version})}}else r={},Object.keys(r).length===0&&Object.assign(r,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=r}),define(te[23],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=void 0,e.$8i=(0,E.$nh)("productService"),e.$9i="vscode://schemas/vscode-product"}),define(te[233],ie([0,1,72,5,23]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L3b=void 0;let M=class{constructor(S,f){this.b=S,this.c=f,this.a=new Map}async isExtensionUrlTrusted(S,f){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const u=/^(.*)#([^#]+)$/.exec(f);if(!u)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",f),!1;const[,$,d]=u;let p=this.a.get(S);if(!p){if(p=this.b.trustedExtensionUrlPublicKeys[S],!p||p.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",S),!1;this.a.set(S,[...p])}const h=Buffer.from(decodeURIComponent(d),"base64");if(h.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",f),!1;const v=h.slice(0,6),y=h.readUIntBE(0,6),o=Date.now()-y;if(o<0||o>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",f),!1;const g=h.slice(6),c=E.createVerify("SHA256");c.write(v),c.write(Buffer.from($)),c.end();for(let b=0;b<p.length;b++){let k=p[b];if(k!==null){if(typeof k=="string")try{k=E.createPublicKey({key:Buffer.from(k,"base64"),format:"der",type:"spki"}),p[b]=k}catch(w){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${b+1} for ${S}:`,w),p[b]=null;continue}if(c.verify(k,g))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",f),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",f),!1}};e.$L3b=M,e.$L3b=M=pe([x(0,r.$8i),x(1,C.$Pi)],M)}),define(te[234],ie([0,1,8,5]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X3b=void 0;let r=class{constructor(R,S,f){this.a=R,this.b=S,this.c=f}async inspect(R){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.$ug)(R);const f=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const R=this.a.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async e(){const R=this.a.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};e.$X3b=r,e.$X3b=r=pe([x(2,C.$Pi)],r)}),define(te[79],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$13b=void 0,e.$13b=(0,E.$nh)("protocolMainService")}),define(te[44],ie([0,1,135,10]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;class r{constructor(){this.a=new Map}add(R,S){E.ok(C.$ie(R)),E.ok(C.$ke(S)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,S)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Rm=new r}),define(te[235],ie([0,1,3,44]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=void 0,e.$Sm={JSONContribution:"base.contributions.json"};function r(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class M{constructor(){this.b=new E.$7c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,u){this.a[r(f)]=u,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const R=new M;C.$Rm.add(e.$Sm.JSONContribution,R)}),define(te[59],ie([0,1,24,3,10,161,18,235,44]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.ConfigurationScope=e.$Wm=e.EditPresentationTypes=void 0;var u;(function(w){w.Multiline="multilineText",w.Singleline="singlelineText"})(u||(e.EditPresentationTypes=u={})),e.$Wm={Configuration:"base.contributions.configuration"};var $;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})($||(e.ConfigurationScope=$={})),e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m="vscode://schemas/settings/resourceLanguage",e.$5m="vscode://schemas/settings/configurationDefaults";const d=f.$Rm.as(S.$Sm.JSONContribution);class p{constructor(){this.h=new Set,this.i=new C.$7c,this.onDidSchemaChange=this.i.event,this.j=new C.$7c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},d.registerSchema(e.$4m,this.g),this.v()}registerConfiguration(t,l=!0){this.registerConfigurations([t],l)}registerConfigurations(t,l=!0){const s=new Set;this.n(t,l,s),d.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const l=new Set;this.o(t,l),d.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:l})}updateConfigurations({add:t,remove:l}){const s=new Set;this.o(l,s),this.n(t,!1,s),d.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const l=new Set;this.k(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}k(t,l){const s=[];for(const{overrides:n,source:i}of t)for(const a in n)if(l.add(a),e.$7m.test(a)){const m=this.a.get(a),P=m?.valuesSources??new Map;if(i)for(const L of Object.keys(n[a]))P.set(L,i);const I={...m?.value||{},...n[a]};this.a.set(a,{source:i,value:I,valuesSources:P});const D=(0,R.$4h)(a),O={type:"object",default:I,description:M.localize(1,null,D),$ref:e.$4m,defaultDefaultValue:I,source:r.$ie(i)?void 0:i,defaultValueSource:i};s.push(...y(a)),this.d[a]=O,this.b.properties[a]=O}else{this.a.set(a,{value:n[a],source:i});const m=this.d[a];m&&(this.w(a,m),this.r(a,m))}this.m(s)}deregisterDefaultConfigurations(t){const l=new Set;this.l(t,l),this.i.fire(),this.j.fire({properties:l,defaultsOverrides:!0})}l(t,l){for(const{overrides:s,source:n}of t)for(const i in s){const a=this.a.get(i),m=r.$ie(n)?n:n?.id,P=r.$ie(a?.source)?a?.source:a?.source?.id;if(m===P)if(l.add(i),this.a.delete(i),e.$7m.test(i))delete this.d[i],delete this.b.properties[i];else{const I=this.d[i];I&&(this.w(i,I),this.r(i,I))}}this.u()}deltaConfiguration(t){let l=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),l=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),l=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:l})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const l of t)this.h.add(l);this.u()}n(t,l,s){t.forEach(n=>{this.p(n,l,n.extensionInfo,n.restrictedProperties,void 0,s),this.c.push(n),this.q(n)})}o(t,l){const s=n=>{if(n.properties)for(const i in n.properties){l.add(i);const a=this.d[i];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[i],this.s(i,n.properties[i])}n.allOf?.forEach(i=>s(i))};for(const n of t){s(n);const i=this.c.indexOf(n);i!==-1&&this.c.splice(i,1)}}p(t,l=!0,s,n,i=3,a){i=r.$re(t.scope)?i:t.scope;const m=t.properties;if(m)for(const I in m){const D=m[I];if(l&&b(I,D)){delete m[I];continue}if(D.source=s,D.defaultDefaultValue=m[I].default,this.w(I,D),e.$7m.test(I)?D.scope=void 0:(D.scope=r.$re(D.scope)?i:D.scope,D.restricted=r.$re(D.restricted)?!!n?.includes(I):D.restricted),m[I].hasOwnProperty("included")&&!m[I].included){this.f[I]=m[I],delete m[I];continue}else this.d[I]=m[I],m[I].policy?.name&&this.e.set(m[I].policy.name,I);!m[I].deprecationMessage&&m[I].markdownDeprecationMessage&&(m[I].deprecationMessage=m[I].markdownDeprecationMessage),a.add(I)}const P=t.allOf;if(P)for(const I of P)this.p(I,l,s,n,i,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const l=s=>{const n=s.properties;if(n)for(const a in n)this.r(a,n[a]);s.allOf?.forEach(l)};l(t)}r(t,l){switch(e.$Xm.properties[t]=l,l.scope){case 1:e.$Ym.properties[t]=l;break;case 2:e.$Zm.properties[t]=l;break;case 6:e.$1m.properties[t]=l;break;case 3:e.$2m.properties[t]=l;break;case 4:e.$3m.properties[t]=l;break;case 5:e.$3m.properties[t]=l,this.g.properties[t]=l;break}}s(t,l){switch(delete e.$Xm.properties[t],l.scope){case 1:delete e.$Ym.properties[t];break;case 2:delete e.$Zm.properties[t];break;case 6:delete e.$1m.properties[t];break;case 3:delete e.$2m.properties[t];break;case 4:case 5:delete e.$3m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const l=`[${t}]`,s={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$4m};this.w(l,s),e.$Xm.properties[l]=s,e.$Ym.properties[l]=s,e.$Zm.properties[l]=s,e.$1m.properties[l]=s,e.$2m.properties[l]=s,e.$3m.properties[l]=s}}v(){const t={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$4m};e.$Xm.patternProperties[e.$6m]=t,e.$Ym.patternProperties[e.$6m]=t,e.$Zm.patternProperties[e.$6m]=t,e.$1m.patternProperties[e.$6m]=t,e.$2m.patternProperties[e.$6m]=t,e.$3m.patternProperties[e.$6m]=t,this.i.fire()}w(t,l){const s=this.a.get(t);let n=s?.value,i=s?.source;r.$pe(n)&&(n=l.defaultDefaultValue,i=void 0),r.$pe(n)&&(n=g(l.type)),l.default=n,l.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",v=new RegExp(h,"g");e.$6m=`^(${h})+$`,e.$7m=new RegExp(e.$6m);function y(w){const t=[];if(e.$7m.test(w)){let l=v.exec(w);for(;l?.length;){const s=l[1].trim();s&&t.push(s),l=v.exec(w)}}return(0,E.$qf)(t)}e.$8m=y;function o(w){return w.reduce((t,l)=>`${t}[${l}]`,"")}e.$9m=o;function g(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$0m=g;const c=new p;f.$Rm.add(e.$Wm.Configuration,c);function b(w,t){return w.trim()?e.$7m.test(w)?M.localize(7,null,w):c.getConfigurationProperties()[w]!==void 0?M.localize(8,null,w):t.policy?.name&&c.getPolicyConfigurations().get(t.policy?.name)!==void 0?M.localize(9,null,w,t.policy?.name,c.getPolicyConfigurations().get(t.policy?.name)):null:M.localize(6,null)}e.$$m=b;function k(){const w=[],t=c.getConfigurationProperties();for(const l of Object.keys(t))w.push([l,t[l].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.$_m=k}),define(te[119],ie([0,1,24,3,45,2,35,37,10,7,18,59,44]),function(G,e,E,C,r,M,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function h(l){return Object.isFrozen(l)?l:S.$Gm(l)}class v{constructor(s={},n=[],i=[],a){this.b=s,this.c=n,this.d=i,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(n=>{if(n instanceof v)return n;const i=new y("");return i.parseRaw(n),i.configurationModel});this.f=s.reduce((n,i)=>i===n?i:n.merge(i),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,$.$2h)(this.contents,s):this.contents}inspect(s,n){const i=this.rawConfiguration.getValue(s),a=n?this.rawConfiguration.getOverrideValue(s,n):void 0,m=n?this.rawConfiguration.override(n).getValue(s):i;return{value:i,override:a,merged:m}}getOverrideValue(s,n){const i=this.i(n);return i?s?(0,$.$2h)(i,s):i:void 0}getKeysForOverrideIdentifier(s){const n=[];for(const i of this.overrides)i.identifiers.includes(s)&&n.push(...i.keys);return E.$qf(n)}getAllOverrideIdentifiers(){const s=[];for(const n of this.overrides)s.push(...n.identifiers);return E.$qf(s)}override(s){let n=this.a.get(s);return n||(n=this.g(s),this.a.set(s,n)),n}merge(...s){const n=S.$Fm(this.contents),i=S.$Fm(this.overrides),a=[...this.keys],m=this.raw?.length?[...this.raw]:[this];for(const P of s)if(m.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(n,P.contents);for(const I of P.overrides){const[D]=i.filter(O=>E.$af(O.identifiers,I.identifiers));D?(this.h(D.contents,I.contents),D.keys.push(...I.keys),D.keys=E.$qf(D.keys)):i.push(S.$Fm(I))}for(const I of P.keys)a.indexOf(I)===-1&&a.push(I)}return new v(n,a,i,m.every(P=>P instanceof v)?void 0:m)}g(s){const n=this.i(s);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const a of E.$qf([...Object.keys(this.contents),...Object.keys(n)])){let m=this.contents[a];const P=n[a];P&&(typeof m=="object"&&typeof P=="object"?(m=S.$Fm(m),this.h(m,P)):m=P),i[a]=m}return new v(i,this.keys,this.overrides)}h(s,n){for(const i of Object.keys(n)){if(i in s&&f.$ke(s[i])&&f.$ke(n[i])){this.h(s[i],n[i]);continue}s[i]=S.$Fm(n[i])}}i(s){let n=null,i=null;const a=m=>{m&&(i?this.h(i,m):i=S.$Fm(m))};for(const m of this.overrides)m.identifiers.length===1&&m.identifiers[0]===s?n=m.contents:m.identifiers.includes(s)&&a(m.contents);return a(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,n){this.j(s,n,!0)}setValue(s,n){this.j(s,n,!1)}removeValue(s){const n=this.keys.indexOf(s);n!==-1&&(this.keys.splice(n,1),(0,$.$1h)(this.contents,s),d.$7m.test(s)&&this.overrides.splice(this.overrides.findIndex(i=>E.$af(i.identifiers,(0,d.$8m)(s))),1))}j(s,n,i){(0,$.$Zh)(this.contents,s,n,a=>console.error(a)),i=i||this.keys.indexOf(s)===-1,i&&this.keys.push(s),d.$7m.test(s)&&this.overrides.push({identifiers:(0,d.$8m)(s),keys:Object.keys(this.contents[s]),contents:(0,$.$Yh)(this.contents[s],a=>console.error(a))})}}e.$an=v;class y{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new v}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,n){if(!f.$re(s)){const i=this.g(s);this.parseRaw(i,n)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,n){this.a=s;const{contents:i,keys:a,overrides:m,restricted:P,hasExcludedProperties:I}=this.h(s,n);this.b=new v(i,a,m,I?[s]:void 0),this.c=P||[]}g(s){let n={},i=null,a=[];const m=[],P=[];function I(O){Array.isArray(a)?a.push(O):i!==null&&(a[i]=O)}const D={onObjectBegin:()=>{const O={};I(O),m.push(a),a=O,i=null},onObjectProperty:O=>{i=O},onObjectEnd:()=>{a=m.pop()},onArrayBegin:()=>{const O=[];I(O),m.push(a),a=O,i=null},onArrayEnd:()=>{a=m.pop()},onLiteralValue:I,onError:(O,L,N)=>{P.push({error:O,offset:L,length:N})}};if(s)try{r.$Cm(s,D),n=a[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return n}h(s,n){const i=p.$Rm.as(d.$Wm.Configuration).getConfigurationProperties(),a=this.i(s,i,!0,n);s=a.raw;const m=(0,$.$Yh)(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`)),P=Object.keys(s),I=this.j(s,D=>console.error(`Conflict in settings file ${this.f}: ${D}`));return{contents:m,keys:P,overrides:I,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(s,n,i,a){let m=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:m};const P={},I=[];for(const D in s)if(d.$7m.test(D)&&i){const O=this.i(s[D],n,!1,a);P[D]=O.raw,m=m||O.hasExcludedProperties,I.push(...O.restricted)}else{const O=n[D],L=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&I.push(D),!a.exclude?.includes(D)&&(a.include?.includes(D)||(L===void 0||a.scopes===void 0||a.scopes.includes(L))&&!(a.skipRestricted&&O?.restricted))?P[D]=s[D]:m=!0}return{raw:P,restricted:I,hasExcludedProperties:m}}j(s,n){const i=[];for(const a of Object.keys(s))if(d.$7m.test(a)){const m={};for(const P in s[a])m[P]=s[a][P];i.push({identifiers:(0,d.$8m)(a),keys:Object.keys(m),contents:(0,$.$Yh)(m,n)})}return i}}e.$bn=y;class o extends M.$lb{constructor(s,n,i,a){super(),this.c=s,this.f=n,this.g=a,this.b=this.B(new C.$7c),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,m=>m.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,m=>(m.isOperation(0)||m.isOperation(3)||m.isOperation(1)||m.isOperation(4))&&i.isEqual(m.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new v}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$cn=o;class g{constructor(s,n,i,a,m,P,I,D,O,L,N,q,re){this.a=s,this.b=n,this.c=i,this.overrideIdentifiers=a,this.d=m,this.f=P,this.g=I,this.h=D,this.i=O,this.j=L,this.k=N,this.l=q,this.m=re}get value(){return h(this.c)}n(s,n,i){const a=s.inspect(n,i);return{get value(){return h(a.value)},get override(){return h(a.override)},get merged(){return h(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(s,n,i,a,m=new v,P=new v,I=new R.$li,D=new v,O=new R.$li){this.c=s,this.d=n,this.f=i,this.g=a,this.h=m,this.i=P,this.j=I,this.l=D,this.m=O,this.a=null,this.b=new R.$li,this.n=null}getValue(s,n,i){return this.q(s,n,i).getValue(s)}updateValue(s,n,i={}){let a;i.resource?(a=this.m.get(i.resource),a||(a=new v,this.m.set(i.resource,a))):a=this.l,n===void 0?a.removeValue(s):a.setValue(s,n),i.resource||(this.a=null)}inspect(s,n,i){const a=this.q(s,n,i),m=this.u(n.resource,i),P=n.resource?this.m.get(n.resource)||this.l:this.l,I=new Set;for(const D of a.overrides)for(const O of D.identifiers)a.getOverrideValue(s,O)!==void 0&&I.add(O);return new g(s,n,a.getValue(s),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,m||void 0,P)}keys(s){const n=this.u(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,n){this.j.set(s,n),this.b.delete(s)}deleteFolderConfiguration(s){this.p.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,n){const i=[];if(!n){const{added:a,updated:m,removed:P}=w(this.c,s);n=[...a,...m,...P]}for(const a of n)for(const m of(0,d.$8m)(a)){const P=this.c.getKeysForOverrideIdentifier(m),I=s.getKeysForOverrideIdentifier(m),D=[...I.filter(O=>P.indexOf(O)===-1),...P.filter(O=>I.indexOf(O)===-1),...P.filter(O=>!S.$Jm(this.c.override(m).getValue(O),s.override(m).getValue(O)))];i.push([m,D])}return this.updateDefaultConfiguration(s),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(s){const{added:n,updated:i,removed:a}=w(this.d,s),m=[...n,...i,...a];return m.length&&this.updatePolicyConfiguration(s),{keys:m,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:n,updated:i,removed:a,overrides:m}=w(this.applicationConfiguration,s),P=[...n,...i,...a];return P.length&&this.updateApplicationConfiguration(s),{keys:P,overrides:m}}compareAndUpdateLocalUserConfiguration(s){const{added:n,updated:i,removed:a,overrides:m}=w(this.localUserConfiguration,s),P=[...n,...i,...a];return P.length&&this.updateLocalUserConfiguration(s),{keys:P,overrides:m}}compareAndUpdateRemoteUserConfiguration(s){const{added:n,updated:i,removed:a,overrides:m}=w(this.remoteUserConfiguration,s),P=[...n,...i,...a];return P.length&&this.updateRemoteUserConfiguration(s),{keys:P,overrides:m}}compareAndUpdateWorkspaceConfiguration(s){const{added:n,updated:i,removed:a,overrides:m}=w(this.workspaceConfiguration,s),P=[...n,...i,...a];return P.length&&this.updateWorkspaceConfiguration(s),{keys:P,overrides:m}}compareAndUpdateFolderConfiguration(s,n){const i=this.p.get(s),{added:a,updated:m,removed:P,overrides:I}=w(i,n),D=[...a,...m,...P];return(D.length||!i)&&this.updateFolderConfiguration(s,n),{keys:D,overrides:I}}compareAndDeleteFolderConfiguration(s){const n=this.p.get(s);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:i,updated:a,removed:m,overrides:P}=w(n,void 0);return{keys:[...i,...a,...m],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(s,n,i){let a=this.r(n,i);return n.overrideIdentifier&&(a=a.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(a=a.merge(this.d)),a}r({resource:s},n){let i=this.s();if(n&&s){const a=n.getFolder(s);a&&(i=this.t(a.uri)||i);const m=this.m.get(s);m&&(i=i.merge(m))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(s){let n=this.b.get(s);if(!n){const i=this.s(),a=this.j.get(s);a?(n=i.merge(a),this.b.set(s,n)):n=i}return n}u(s,n){if(n&&s){const i=n.getFolder(s);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,n)=>{const{contents:i,overrides:a,keys:m}=this.j.get(n);return s.push([n,{contents:i,overrides:a,keys:m}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(n=>s.add(n)),this.userConfiguration.keys.forEach(n=>s.add(n)),this.i.keys.forEach(n=>s.add(n)),this.j.forEach(n=>n.keys.forEach(i=>s.add(i))),[...s.values()]}v(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>s.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(i=>s.add(i))),[...s.values()]}w(s){const n=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.i.getKeysForOverrideIdentifier(s).forEach(i=>n.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(s).forEach(a=>n.add(a))),[...n.values()]}static parse(s){const n=this.x(s.defaults),i=this.x(s.policy),a=this.x(s.application),m=this.x(s.user),P=this.x(s.workspace),I=s.folders.reduce((D,O)=>(D.set(u.URI.revive(O[0]),this.x(O[1])),D),new R.$li);return new c(n,i,a,m,new v,P,I,new v,new R.$li)}static x(s){return new v(s.contents,s.keys,s.overrides)}}e.$dn=c;function b(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const s=new Set,n=new Map;for(const a of l)a.keys.forEach(m=>s.add(m)),a.overrides.forEach(([m,P])=>{const I=(0,R.$ii)(n,m,new Set);P.forEach(D=>I.add(D))});const i=[];return n.forEach((a,m)=>i.push([m,[...a.values()]])),{keys:[...s.values()],overrides:i}}e.$en=b;class k{constructor(s,n,i,a){this.change=s,this.f=n,this.g=i,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const m of s.keys)this.affectedKeys.add(m);for(const[,m]of s.overrides)for(const P of m)this.affectedKeys.add(P);this.d=this.a;for(const m of this.affectedKeys)this.d+=m+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(s,n){const i=this.a+s,a=this.d.indexOf(i);if(a<0)return!1;const m=a+i.length;if(m>=this.d.length)return!1;const P=this.d.charCodeAt(m);if(P!==this.b&&P!==this.c)return!1;if(n){const I=this.previousConfiguration?this.previousConfiguration.getValue(s,n,this.f?.workspace):void 0,D=this.g.getValue(s,n,this.h);return!S.$Jm(I,D)}return!0}}e.$fn=k;function w(l,s){const{added:n,removed:i,updated:a}=t(s?.rawConfiguration,l?.rawConfiguration),m=[],P=l?.getAllOverrideIdentifiers()||[],I=s?.getAllOverrideIdentifiers()||[];if(s){const D=I.filter(O=>!P.includes(O));for(const O of D)m.push([O,s.getKeysForOverrideIdentifier(O)])}if(l){const D=P.filter(O=>!I.includes(O));for(const O of D)m.push([O,l.getKeysForOverrideIdentifier(O)])}if(s&&l){for(const D of P)if(I.includes(D)){const O=t({contents:l.getOverrideValue(void 0,D)||{},keys:l.getKeysForOverrideIdentifier(D)},{contents:s.getOverrideValue(void 0,D)||{},keys:s.getKeysForOverrideIdentifier(D)});m.push([D,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:i,updated:a,overrides:m}}function t(l,s){const n=l?s?l.keys.filter(m=>s.keys.indexOf(m)===-1):[...l.keys]:[],i=s?l?s.keys.filter(m=>l.keys.indexOf(m)===-1):[...s.keys]:[],a=[];if(l&&s){for(const m of s.keys)if(l.keys.indexOf(m)!==-1){const P=(0,$.$2h)(s.contents,m),I=(0,$.$2h)(l.contents,m);S.$Jm(P,I)||a.push(m)}}return{added:n,removed:i,updated:a}}}),define(te[236],ie([0,1,24,3,2,37,10,119,59,5,39,44]),function(G,e,E,C,r,M,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=void 0;class p extends r.$lb{constructor(){super(...arguments),this.a=this.B(new C.$7c),this.onDidChangeConfiguration=this.a.event,this.b=new S.$an}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(d.$Rm.as(f.$Wm.Configuration).onDidUpdateConfiguration(({properties:o,defaultsOverrides:g})=>this.c(Array.from(o),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(o,g){this.h(o,d.$Rm.as(f.$Wm.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:o})}f(){return{}}g(){this.b=new S.$an;const o=d.$Rm.as(f.$Wm.Configuration).getConfigurationProperties();this.h(Object.keys(o),o)}h(o,g){const c=this.f();for(const b of o){const k=c[b],w=g[b];k!==void 0?this.b.addValue(b,k):w?this.b.addValue(b,w.default):this.b.removeValue(b)}}}e.$gn=p;class h{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=new S.$an}async initialize(){return this.configurationModel}}e.$hn=h;let v=class extends r.$lb{get configurationModel(){return this.b}constructor(o,g,c){super(),this.c=o,this.f=g,this.g=c,this.a=this.B(new C.$7c),this.onDidChangeConfiguration=this.a.event,this.b=new S.$an}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(o=>this.i(o))),this.B(this.c.onDidChangeConfiguration(async({properties:o})=>this.j(await this.h(o),!0))),this.b}async h(o){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",o);const g={},c=[],b=d.$Rm.as(f.$Wm.Configuration).getConfigurationProperties();for(const k of o){const w=b[k];if(!w){c.push(k);continue}if(w.policy){if(w.type!=="string"&&w.type!=="number"){this.g.warn(`Policy ${w.policy.name} has unsupported type ${w.type}`);continue}c.push(k),g[w.policy.name]={type:w.type}}}return(0,R.$ve)(g)||await this.f.updatePolicyDefinitions(g),c}i(o){this.g.trace("PolicyConfiguration#onDidChangePolicies",o);const g=d.$Rm.as(f.$Wm.Configuration).getPolicyConfigurations(),c=(0,E.$lf)(o.map(b=>g.get(b)));this.j(c,!0)}j(o,g){this.g.trace("PolicyConfiguration#update",o);const c=d.$Rm.as(f.$Wm.Configuration).getConfigurationProperties(),b=[],k=this.b.isEmpty();for(const w of o){const t=c[w]?.policy?.name;if(t){const l=this.f.getPolicyValue(t);(k?l!==void 0:!(0,M.$Jm)(this.b.getValue(w),l))&&b.push([w,l])}else this.b.getValue(w)!==void 0&&b.push([w,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const w=this.b;this.b=new S.$an;for(const t of w.keys)this.b.setValue(t,w.getValue(t));for(const[t,l]of b)l===void 0?this.b.removeValue(t):this.b.setValue(t,l);g&&this.a.fire(this.b)}}};e.$in=v,e.$in=v=pe([x(1,$.$Tm),x(2,u.$Pi)],v)}),define(te[237],ie([0,1,8,3,2,19,18,119,236,39]),function(G,e,E,C,r,M,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class $ extends r.$lb{constructor(p,h,v,y){super(),this.i=p,this.h=this.B(new C.$7c),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$gn),this.c=v instanceof u.$Vm?new f.$hn:this.B(new f.$in(this.b,v,y)),this.f=this.B(new S.$cn(this.i,{},M.$Yf,h)),this.a=new S.$dn(this.b.configurationModel,this.c.configurationModel,new S.$an,new S.$an),this.g=this.B(new E.$Eg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:o,properties:g})=>this.k(o,g))),this.B(this.c.onDidChangeConfiguration(o=>this.l(o))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[p,h,v]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new S.$dn(p,h,new S.$an,v)}getConfigurationData(){return this.a.toData()}getValue(p,h){const v=typeof p=="string"?p:void 0,y=(0,R.$Uh)(p)?p:(0,R.$Uh)(h)?h:{};return this.a.getValue(v,y,void 0)}updateValue(p,h,v,y){return Promise.reject(new Error("not supported"))}inspect(p){return this.a.inspect(p,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const p=await this.f.loadConfiguration();this.j(p)}j(p){const h=this.a.toData(),v=this.a.compareAndUpdateLocalUserConfiguration(p);this.m(v,h,2)}k(p,h){const v=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(p,h);this.m(y,v,7)}l(p){const h=this.a.toData(),v=this.a.compareAndUpdatePolicyConfiguration(p);this.m(v,h,7)}m(p,h,v){const y=new S.$fn(p,{data:h},this.a);y.source=v,y.sourceConfig=this.n(v),this.h.fire(y)}n(p){switch(p){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$jn=$}),define(te[238],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V4b=e.$U4b=e.$T4b=void 0,e.$T4b="request",e.$U4b="remoteResourceHandler";class E{async routeCall(r,M,R){if(M!==e.$T4b)throw new Error(`Call not found: ${M}`);const S=R[0];if(S?.authority){const f=r.connections.find(u=>u.ctx===S.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(r,M){throw new Error(`Event not found: ${M}`)}}e.$V4b=E}),define(te[239],ie([0,1,13,6]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=e.RemoteAuthorityResolverErrorCode=e.$wk=e.$vk=e.RemoteConnectionType=e.$uk=void 0,e.$uk=(0,C.$nh)("remoteAuthorityResolverService");var r;(function($){$[$.WebSocket=0]="WebSocket",$[$.Managed=1]="Managed"})(r||(e.RemoteConnectionType=r={}));class M{constructor(d){this.id=d,this.type=1}toString(){return`Managed(${this.id})`}}e.$vk=M;class R{constructor(d,p){this.host=d,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$wk=R;var S;(function($){$.Unknown="Unknown",$.NotAvailable="NotAvailable",$.TemporarilyNotAvailable="TemporarilyNotAvailable",$.NoResolverFound="NoResolverFound",$.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class f extends E.$ab{static isNotAvailable(d){return d instanceof f&&d._code===S.NotAvailable}static isTemporarilyNotAvailable(d){return d instanceof f&&d._code===S.TemporarilyNotAvailable}static isNoResolverFound(d){return d instanceof f&&d._code===S.NoResolverFound}static isInvalidAuthority(d){return d instanceof f&&d._code===S.InvalidAuthority}static isHandled(d){return d instanceof f&&d.isHandled}constructor(d,p=S.Unknown,h){super(d),this._message=d,this._code=p,this._detail=h,this.isHandled=p===S.NotAvailable&&h===!0,Object.setPrototypeOf(this,f.prototype)}}e.$xk=f;function u($){const d=$.indexOf("+");return d===-1?$:$.substring(0,d)}e.$yk=u}),define(te[60],ie([0,1,15]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=void 0;function C(u){return u.scheme===E.Schemas.vscodeRemote?u.authority:void 0}e.$zk=C;function r(u){if(!u)return;const $=u.indexOf("+");return $<0?u:u.substr(0,$)}e.$Ak=r;function M(u){return`/${u.quality??"oss"}-${u.commit??"dev"}`}e.$Bk=M;function R(u){const{host:$,port:d}=f(u);if(typeof d>"u")throw new Error("Remote authority doesn't contain a port!");return{host:$,port:d}}e.$Ck=R;function S(u,$){let{host:d,port:p}=f(u);return typeof p>"u"&&(p=$),{host:d,port:p}}e.$Dk=S;function f(u){const $=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if($)return{host:$[1],port:parseInt($[2],10)};const d=u.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const p=u.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:u,port:void 0}}}),define(te[120],ie([0,1,25,6,60]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.TargetPlatform=e.ExtensionType=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=void 0,e.$zl="extensions.user.cache",e.$Al="extensions.builtin.cache",e.$Bl="undefined_publisher",e.$Cl=["ui","workspace","web"];function M(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Dl=M,e.$El=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(R||(e.ExtensionType=R={}));var S;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class f{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,g){if(typeof o>"u"||o===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof o=="string"||typeof g=="string"){const c=typeof o=="string"?o:o.value,b=typeof g=="string"?g:g.value;return E.$Ld(c,b)}return o._lower===g._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Fl=f;class u{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const g of o)this.add(g)}add(o){this.c.add(f.toKey(o))}delete(o){return this.c.delete(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}}e.$Gl=u;class ${constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(f.toKey(o))}get(o){return this.c.get(f.toKey(o))}has(o){return this.c.has(f.toKey(o))}set(o,g){this.c.set(f.toKey(o),g)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Hl=$;function d(y){return p(y)}e.$Il=d;function p(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$Jl=p;function h(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$Kl=h;function v(y,o){if(o){const g=`onResolveRemoteAuthority:${(0,r.$Ak)(o)}`;return!!y.activationEvents?.includes(g)}return!1}e.$Ll=v,e.$Ml=(0,C.$nh)("IBuiltinExtensionsScannerService")}),define(te[240],ie([0,1,8,17,21,13,3,2,65,69,31,109,239,60]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.PersistentConnectionEventType=e.$Kk=e.$Jk=e.$Ik=e.ConnectionType=void 0;const v=30*1e3;var y;(function(j){j[j.Management=1]="Management",j[j.ExtensionHost=2]="ExtensionHost",j[j.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function o(j){switch(j){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(j){const A=new r.$dd;return setTimeout(()=>A.cancel(),j),A.token}function c(j,A){if(j.isCancellationRequested||A.isCancellationRequested)return r.CancellationToken.Cancelled;const F=new r.$dd;return j.onCancellationRequested(()=>F.cancel()),A.onCancellationRequested(()=>F.cancel()),F.token}class b{get didTimeout(){return this.c==="timedout"}constructor(A){this.c="pending",this.d=new S.$kb,this.promise=new Promise((F,H)=>{this.f=F,this.g=H}),A.isCancellationRequested?this.h():this.d.add(A.onCancellationRequested(()=>this.h()))}registerDisposable(A){this.c==="pending"?this.d.add(A):A.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(A))}reject(A){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(A))}}function k(j,A){const F=new b(A);return F.registerDisposable(j.onControlMessage(H=>{const V=JSON.parse(H.toString()),z=W(V);z?F.reject(z):F.resolve(V)})),F.promise}function w(j,A,F,H,V,z,B,Y){const se=new b(Y),le=u.$3c.create(!1);return j.info(`Creating a socket (${B})...`),f.mark(`code/willCreateSocket/${z}`),A.connect(F,H,V,B).then(ge=>{se.didTimeout?(f.mark(`code/didCreateSocketError/${z}`),j.info(`Creating a socket (${B}) finished after ${le.elapsed()} ms, but this is too late and has timed out already.`),ge?.dispose()):(f.mark(`code/didCreateSocketOK/${z}`),j.info(`Creating a socket (${B}) was successful after ${le.elapsed()} ms.`),se.resolve(ge))},ge=>{f.mark(`code/didCreateSocketError/${z}`),j.info(`Creating a socket (${B}) returned an error after ${le.elapsed()} ms.`),j.error(ge),se.reject(ge)}),se.promise}function t(j,A){const F=new b(A);return j.then(H=>{F.didTimeout||F.resolve(H)},H=>{F.didTimeout||F.reject(H)}),F.promise}async function l(j,A,F,H){const V=ce(j,A);j.logService.trace(`${V} 1/6. invoking socketFactory.connect().`);let z;try{z=await w(j.logService,j.remoteSocketFactoryService,j.connectTo,(0,h.$Bk)(j),`reconnectionToken=${j.reconnectionToken}&reconnection=${j.reconnectionProtocol?"true":"false"}`,o(A),`renderer-${o(A)}-${j.reconnectionToken}`,H)}catch(ge){throw j.logService.error(`${V} socketFactory.connect() failed or timed out. Error:`),j.logService.error(ge),ge}j.logService.trace(`${V} 2/6. socketFactory.connect() was successful.`);let B,Y;j.reconnectionProtocol?(j.reconnectionProtocol.beginAcceptReconnection(z,null),B=j.reconnectionProtocol,Y=!1):(B=new d.$bh({socket:z}),Y=!0),j.logService.trace(`${V} 3/6. sending AuthRequest control message.`);const se=await t(j.signService.createNewMessage((0,$.$5e)()),H),le={type:"auth",auth:j.connectionToken||"00000000000000000000",data:se.data};B.sendControl(C.$Jb.fromString(JSON.stringify(le)));try{const ge=await k(B,c(H,g(1e4)));if(ge.type!=="sign"||typeof ge.data!="string"){const Le=new Error("Unexpected handshake message");throw Le.code="VSCODE_CONNECTION_ERROR",Le}if(j.logService.trace(`${V} 4/6. received SignRequest control message.`),!await t(j.signService.validate(se,ge.signedData),H)){const Le=new Error("Refused to connect to unsupported server");throw Le.code="VSCODE_CONNECTION_ERROR",Le}const Re=await t(j.signService.sign(ge.data),H),Ae={type:"connectionType",commit:j.commit,signedData:Re,desiredConnectionType:A};return F&&(Ae.args=F),j.logService.trace(`${V} 5/6. sending ConnectionTypeRequest control message.`),B.sendControl(C.$Jb.fromString(JSON.stringify(Ae))),{protocol:B,ownsProtocol:Y}}catch(ge){throw ge&&ge.code==="ETIMEDOUT"&&(j.logService.error(`${V} the handshake timed out. Error:`),j.logService.error(ge)),ge&&ge.code==="VSCODE_CONNECTION_ERROR"&&(j.logService.error(`${V} received error control message when negotiating connection. Error:`),j.logService.error(ge)),Y&&U(B),ge}}async function s(j,A,F,H){const V=Date.now(),z=ce(j,A),{protocol:B,ownsProtocol:Y}=await l(j,A,F,H),se=new b(H);return se.registerDisposable(B.onControlMessage(le=>{const ge=JSON.parse(le.toString()),Pe=W(ge);Pe?(j.logService.error(`${z} received error control message when negotiating connection. Error:`),j.logService.error(Pe),Y&&U(B),se.reject(Pe)):(j.reconnectionProtocol?.endAcceptReconnection(),j.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${oe(V)}!`),se.resolve({protocol:B,firstMessage:ge}))})),se.promise}async function n(j,A){const{protocol:F}=await s(j,1,void 0,A);return{protocol:F}}async function i(j,A,F){const{protocol:H,firstMessage:V}=await s(j,2,A,F),z=V&&V.debugPort;return{protocol:H,debugPort:z}}async function a(j,A,F){const H=Date.now(),V=ce(j,3),{protocol:z}=await l(j,3,A,F);return j.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${oe(H)}!`),z}async function m(j,A,F){const{connectTo:H,connectionToken:V}=await j.addressProvider.getAddress();return{commit:j.commit,quality:j.quality,connectTo:H,connectionToken:V,reconnectionToken:A,reconnectionProtocol:F,remoteSocketFactoryService:j.remoteSocketFactoryService,signService:j.signService,logService:j.logService}}async function P(j,A,F){return D(j,async H=>{const{protocol:V}=await n(H,r.CancellationToken.None);return new K(j,A,F,H.reconnectionToken,V)})}e.$Ik=P;async function I(j,A){return D(j,async F=>{const{protocol:H,debugPort:V}=await i(F,A,r.CancellationToken.None);return new X(j,A,F.reconnectionToken,H,V)})}e.$Jk=I;async function D(j,A){for(let H=1;;H++)try{const V=(0,$.$5e)(),z=await m(j,V,null);return await A(z)}catch(V){if(H<5)j.logService.error(`[remote-connection][attempt ${H}] An error occurred in initial connection! Will retry... Error:`),j.logService.error(V);else throw j.logService.error(`[remote-connection][attempt ${H}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),j.logService.error(V),ue.triggerPermanentFailure(0,0,p.$xk.isHandled(V)),V}}async function O(j,A,F){const H=await m(j,(0,$.$5e)(),null);return await a(H,{host:A,port:F},r.CancellationToken.None)}e.$Kk=O;function L(j){return(0,E.$hg)(A=>new Promise((F,H)=>{const V=setTimeout(F,j*1e3);A.onCancellationRequested(()=>{clearTimeout(V),F()})}))}var N;(function(j){j[j.ConnectionLost=0]="ConnectionLost",j[j.ReconnectionWait=1]="ReconnectionWait",j[j.ReconnectionRunning=2]="ReconnectionRunning",j[j.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",j[j.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class q{constructor(A,F){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.type=0}}e.$Lk=q;class re{constructor(A,F,H,V){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.durationSeconds=H,this.c=V,this.type=1}skipWait(){this.c.cancel()}}e.$Mk=re;class ne{constructor(A,F,H){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=H,this.type=2}}e.$Nk=ne;class ee{constructor(A,F,H){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=H,this.type=4}}e.$Ok=ee;class ae{constructor(A,F,H,V){this.reconnectionToken=A,this.millisSinceLastIncomingData=F,this.attempt=H,this.handled=V,this.type=3}}e.$Pk=ae;class ue extends S.$lb{static triggerPermanentFailure(A,F,H){this._permanentFailure=!0,this.f=A,this.g=F,this.h=H,this.i.forEach(V=>V.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(A=>A.s())}static debugPauseSocketWriting(){this.i.forEach(A=>A.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||ue._permanentFailure}constructor(A,F,H,V,z){super(),this.n=A,this.p=F,this.reconnectionToken=H,this.protocol=V,this.r=z,this.j=this.B(new R.$7c),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new ee(this.reconnectionToken,0,0)),this.B(V.onSocketClose(B=>{const Y=Z(this.n,this.reconnectionToken,!0);B?B.type===0?(this.p.logService.info(`${Y} received socket close event (hadError: ${B.hadError}).`),B.error&&this.p.logService.error(B.error)):(this.p.logService.info(`${Y} received socket close event (wasClean: ${B.wasClean}, code: ${B.code}, reason: ${B.reason}).`),B.event&&this.p.logService.error(B.event)):this.p.logService.info(`${Y} received socket close event.`),this.s()})),this.B(V.onSocketTimeout(B=>{const Y=Z(this.n,this.reconnectionToken,!0);this.p.logService.info(`${Y} received socket timeout event (unacknowledgedMsgCount: ${B.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${B.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${B.timeSinceLastReceivedSomeData}).`),this.s()})),ue.i.push(this),this.B((0,S.$jb)(()=>{const B=ue.i.indexOf(this);B>=0&&ue.i.splice(B,1)})),this.k&&this.v(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const A=Z(this.n,this.reconnectionToken,!0);this.p.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let H=-1;do{H++;const V=H<F.length?F[H]:F[F.length-1];try{if(V>0){const B=L(V);this.j.fire(new re(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V,B)),this.p.logService.info(`${A} waiting for ${V} seconds before reconnecting...`);try{await B}catch{}}if(this.k){this.p.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1)),this.p.logService.info(`${A} resolving connection...`);const z=await m(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${A} connecting to ${z.connectTo}...`),await this.y(z,g(v)),this.p.logService.info(`${A} reconnected!`),this.j.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(H>360){this.p.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}if(p.$xk.isTemporarilyNotAvailable(z)){this.p.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this.p.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if((0,M.$2)(z)){this.p.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(z);continue}if(z instanceof p.$xk){this.p.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),H+1,p.$xk.isHandled(z));break}this.p.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(z),this.u(this.protocol.getMillisSinceLastIncomingData(),H+1,!1);break}}while(!this.k&&!this.m)}u(A,F,H){this.r?ue.triggerPermanentFailure(A,F,H):this.v(A,F,H)}v(A,F,H){this.j.fire(new ae(this.reconnectionToken,A,F,H)),U(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$Qk=ue;class K extends ue{constructor(A,F,H,V,z){super(1,A,V,z,!0),this.client=this.B(new d.$_g(z,{remoteAuthority:F,clientId:H},A.ipcLogger))}async y(A,F){await n(A,F)}}e.$Rk=K;class X extends ue{constructor(A,F,H,V,z){super(2,A,H,V,!1),this.z=F,this.debugPort=z}async y(A,F){await i(A,this.z,F)}}e.$Sk=X;function U(j){try{j.acceptDisconnect();const A=j.getSocket();j.dispose(),A.dispose()}catch(A){(0,M.$Y)(A)}}function W(j){if(j&&j.type==="error"){const A=new Error(`Connection error: ${j.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function T(j,A){for(;j.length<A;)j+=" ";return j}function J(j,A){return`[remote-connection][${T(o(j),13)}][${A.substr(0,5)}\u2026]`}function Z(j,A,F){return`${J(j,A)}[${F?"reconnect":"initial"}]`}function ce(j,A){return`${Z(A,j.reconnectionToken,!!j.reconnectionProtocol)}[${j.connectTo}]`}function oe(j){return`${Date.now()-j} ms`}}),define(te[241],ie([0,1,2,6]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=void 0,e.$Ek=(0,C.$nh)("remoteSocketFactoryService");class r{constructor(){this.a={}}register(R,S){return this.a[R]??=[],this.a[R].push(S),(0,E.$jb)(()=>{const f=this.a[R]?.indexOf(S);typeof f=="number"&&f>=0&&this.a[R]?.splice(f,1)})}b(R){return(this.a[R.type]||[]).find(f=>f.supports(R))}connect(R,S,f,u){const $=this.b(R);if(!$)throw new Error(`No socket factory found for ${R}`);return $.connect(R,S,f,u)}}e.$Fk=r}),define(te[242],ie([0,1,27,47,42,113]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W3b=void 0;let R;async function S(h=!1){return(R===void 0||h)&&(R=f()),R}e.$W3b=S;async function f(){const h=u();if(h===void 0)return!1;if(h>=22e3){const v=d();if(v)return new Promise(y=>{C.execFile(v,["--status"],o=>y(!o))})}else{const v=p();if(v)try{if((await r.promises.stat(v)).isFile())return!0}catch{}}return!1}function u(){const h=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(h)return parseInt(h[3])}function $(h){const v=process.env.SystemRoot;if(v){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return M.join(v,y?"Sysnative":"System32",h)}}function d(){return $("wsl.exe")}function p(){return $("lxss\\LxssManager.dll")}}),define(te[51],ie([0,1,17,13,2,181,59,6,5,44]),function(G,e,E,C,r,M,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$wo=(0,S.$nh)("requestService");class ${constructor(w){this.b=w}toJSON(){if(!this.a){const w=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?w[t]="*****":w[t]=this.b[t];this.a=w}return this.a}}class d extends r.$lb{constructor(w){super(),this.b=0,this.a=w.createLogger("network",{name:(0,M.localize)(0,null),when:f.$7i.isEqualTo((0,f.$5i)(f.LogLevel.Trace)).serialize()})}async c(w,t,l){const s=`${w} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new $(t.headers??{}));try{const n=await l();return this.a.trace(`${s} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${s} - error`,t.type,(0,C.$9)(n)),n}}}e.$xo=d;function p(k){return k.res.statusCode&&k.res.statusCode>=200&&k.res.statusCode<300||k.res.statusCode===1223}e.$yo=p;function h(k){return k.res.statusCode===204}async function v(k){return h(k)?null:(await(0,E.$Vb)(k.stream)).toString()}e.$zo=v;async function y(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);return v(k)}e.$Ao=y;async function o(k){if(!p(k))throw new Error("Server returned "+k.res.statusCode);if(h(k))return null;const t=(await(0,E.$Vb)(k.stream)).toString();try{return JSON.parse(t)}catch(l){throw l.message+=`:
`+t,l}}e.$Bo=o;function g(k){b(k)}e.$Co=g;let c;function b(k){const w=u.$Rm.as(R.$Wm.Configuration),t=c;c={id:"http",order:15,title:(0,M.localize)(1,null),type:"object",scope:k,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,M.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,M.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,M.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,M.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,M.localize)(6,null),(0,M.localize)(7,null),(0,M.localize)(8,null),(0,M.localize)(9,null)],default:"override",description:(0,M.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,M.localize)(11,null),restricted:!0}}},w.updateConfigurations({add:[c],remove:t?[t]:[]})}b(1)}),define(te[243],ie([0,1,17,21]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=void 0;class r{constructor(S){this.a=S}listen(S,f){throw new Error("Invalid listen")}call(S,f,u,$=C.CancellationToken.None){switch(f){case"request":return this.a.request(u[0],$).then(async({res:d,stream:p})=>{const h=await(0,E.$Vb)(p);return[{statusCode:d.statusCode,headers:d.headers},h]});case"resolveProxy":return this.a.resolveProxy(u[0])}throw new Error("Invalid call")}}e.$yq=r;class M{constructor(S){this.a=S}async request(S,f){const[u,$]=await this.a.call("request",[S],f);return{res:u,stream:(0,E.$Xb)($)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}}e.$zq=M}),define(te[244],ie([0,1,245,10]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;function r(R,S){return R.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:R.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function M(R,S,f={}){const u=(0,E.parse)(R),$=f.proxyUrl||r(u,S);if(!$)return null;const d=(0,E.parse)($);if(!/^https?:$/.test(d.protocol||""))return null;const p={host:d.hostname||"",port:d.port||(d.protocol==="https"?"443":"80"),auth:d.auth,rejectUnauthorized:(0,C.$oe)(f.strictSSL)?f.strictSSL:!0};return u.protocol==="http:"?new(await new Promise((h,v)=>{G(["http-proxy-agent"],h,v)}))(p):new(await new Promise((h,v)=>{G(["https-proxy-agent"],h,v)}))(p)}e.$Aq=M}),define(te[95],ie([0,1,47,9,182,21,50,13,4,31,108,63,8,138]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=void 0;let v;async function y(g,c,b,k){return b["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,d.$ql)(k)&&!b["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,d.$ql)(k)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),v||(v=p.Promises.withAsyncBody(async(w,t)=>{const l=new M.$dd;let s=1e4;const n=g.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(s=(0,h.$rl)(n,1,120)*1e3);const i=setTimeout(()=>{l.dispose(!0),t(new Error((0,r.localize)(0,null)))},s);try{w(await o(c,l.token))}catch(a){!(0,S.$2)(a)&&!l.token.isCancellationRequested?t(new Error((0,r.localize)(1,null,(0,R.$$h)(a)))):w({})}finally{clearTimeout(i),l.dispose()}})),v)}e.$wl=y;async function o(g,c){const b=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",b);const k=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",k);const w=(0,u.$5e)().replace(/-/g,"").substr(0,12),t=new RegExp(w+"({.*})"+w),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",l);const s=await(0,$.$hl)(f.OS,l);return g.trace("getUnixShellEnvironment#shell",s),new Promise((n,i)=>{if(c.isCancellationRequested)return i(new S.$3);const a=(0,C.$ec)(s);let m,P;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(m=`& '${process.execPath}' ${I} -p '''${w}'' + JSON.stringify(process.env) + ''${w}'''`,P=["-Login","-Command"]):a==="nu"?(m=`^'${process.execPath}' ${I} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,P=["-i","-l","-c"]):(m=`'${process.execPath}' ${I} -p '"${w}" + JSON.stringify(process.env) + "${w}"'`,a==="tcsh"||a==="csh"?P=["-ic"]:P=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),m);const D=(0,E.spawn)(s,[...P,m],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});c.onCancellationRequested(()=>(D.kill(),i(new S.$3))),D.on("error",N=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,R.$$h)(N)),i(N)});const O=[];D.stdout.on("data",N=>O.push(N));const L=[];D.stderr.on("data",N=>L.push(N)),D.on("close",(N,q)=>{const re=Buffer.concat(O).toString("utf8");g.trace("getUnixShellEnvironment#raw",re);const ne=Buffer.concat(L).toString("utf8");if(ne.trim()&&g.trace("getUnixShellEnvironment#stderr",ne),N||q)return i(new Error((0,r.localize)(2,null,N,q)));const ee=t.exec(re),ae=ee?ee[1]:"{}";try{const ue=JSON.parse(ae);b?ue.ELECTRON_RUN_AS_NODE=b:delete ue.ELECTRON_RUN_AS_NODE,k?ue.ELECTRON_NO_ATTACH_CONSOLE=k:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ue),n(ue)}catch(ue){g.error("getUnixShellEnvironment#errorCaught",(0,R.$$h)(ue)),i(ue)}})})}}),define(te[246],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jZb=void 0;class E{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(r){try{const M=await this.c();if(M){const R=String(E.a++);return this.b.set(R,M),{id:R,data:M.createNewMessage(r)}}}catch{}return{id:"",data:r}}async validate(r,M){if(!r.id)return!0;const R=this.b.get(r.id);if(!R)return!1;this.b.delete(r.id);try{return R.validate(M)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(r){try{return await this.d(r)}catch{}return r}}e.$jZb=E}),define(te[96],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=void 0,e.$Gk="signService",e.$Hk=(0,E.$nh)(e.$Gk)}),define(te[247],ie([0,1,246]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$44b=void 0;class C extends E.$jZb{c(){return this.h().then(M=>new M.validator)}d(M){return this.h().then(R=>new R.signer().sign(M))}h(){return new Promise((M,R)=>G(["vsda"],M,R))}}e.$44b=C}),define(te[34],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=void 0,e.$NM=(0,E.$nh)("stateReadService"),e.$OM=(0,E.$nh)("stateService")}),define(te[121],ie([0,1,8,17,10,33,16,5]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.$PM=e.SaveStrategy=void 0;var f;(function(p){p[p.IMMEDIATE=0]="IMMEDIATE",p[p.DELAYED=1]="DELAYED"})(f||(e.SaveStrategy=f={}));class u{constructor(h,v,y,o){this.f=h,this.g=y,this.h=o,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=v===0?void 0:new E.$rg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(h){h.fileOperationResult!==1&&this.g.error(h)}}getItem(h,v){const y=this.a[h];return(0,r.$re)(y)?v:y}setItem(h,v){this.setItems([{key:h,data:v}])}setItems(h){let v=!1;for(const{key:y,data:o}of h)this.a[y]!==o&&((0,r.$re)(o)?(0,r.$pe)(this.a[y])||(this.a[y]=void 0,v=!0):(this.a[y]=o,v=!0));v&&this.j()}removeItem(h){(0,r.$pe)(this.a[h])||(this.a[h]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const h=JSON.stringify(this.a,null,4);if(h!==this.b)try{await this.h.writeFile(this.f,C.$Jb.fromString(h),{atomic:{postfix:".vsctmp"}}),this.b=h}catch(v){this.g.error(v)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$PM=u;let $=class{constructor(h,v,y,o){this.a=new u(v.stateResource,h,y,o)}async init(){await this.a.init()}getItem(h,v){return this.a.getItem(h,v)}};e.$QM=$,e.$QM=$=pe([x(1,M.$uh),x(2,S.$Pi),x(3,R.$Qj)],$);class d extends ${setItem(h,v){this.a.setItem(h,v)}setItems(h){this.a.setItems(h)}removeItem(h){this.a.removeItem(h)}close(){return this.a.close()}}e.$RM=d}),define(te[122],ie([0,1,4,36,31]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=void 0;function M(f){if(E.$t===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function R(f,u,$,d,p,h,v,y){const o=Object.create(null);o["common.machineId"]=h,o.sessionID=(0,r.$5e)()+Date.now(),o.commitHash=d,o.version=p,o["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,E.$h)(E.$t),o["common.nodePlatform"]=C.$7b,o["common.nodeArch"]=$,o["common.product"]=y||"desktop",v&&(o["common.msftInternal"]=v);let g=0;const c=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),E.$l&&(o["common.snap"]="true");const b=M(u);return b&&(o["common.platformDetail"]=b),o}e.$Xn=R;function S(f){const u=C.env.USERDNSDOMAIN;if(!u)return!1;const $=u.toLowerCase();return f.some(d=>$===d)}e.$Yn=S}),define(te[26],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=void 0,e.$Tk=(0,E.$nh)("telemetryService"),e.$Uk=(0,E.$nh)("customEndpointTelemetryService"),e.$Vk="telemetry.currentSessionDate",e.$Wk="telemetry.firstSessionDate",e.$Xk="telemetry.lastSessionDate",e.$Yk="telemetry.machineId",e.$Zk="telemetry",e.$1k="telemetry.telemetryLevel",e.$2k="telemetry.enableCrashReporter",e.$3k="telemetry.enableTelemetry";var C;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var r;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(r||(e.TelemetryConfiguration=r={}))}),define(te[248],ie([0,1,27,8,45,15,9,4,7,87,22,107,91,16,23,26]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=e.$fr=e.$er=void 0;const o=new Map;async function g(t,l){const s=`${t}::${l.join(":")}`,n=o.get(s);if(n)return n;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,m=new Map,P=2e4;function I(O,L,N,q){const re=L.substring(O.length+1);return C.Promises.withAsyncBody(async ne=>{let ee;try{ee=await $.Promises.readdir(L,{withFileTypes:!0})}catch{ne();return}if(q.count>=P){q.count+=ee.length,q.maxReached=!0,ne();return}let ae=ee.length;if(ae===0){ne();return}let ue=ee;q.count+ee.length>P&&(q.maxReached=!0,ae=P-q.count,ue=ee.slice(0,ae)),q.count+=ee.length;for(const K of ue)if(K.isDirectory()){if(N.includes(K.name)||await I(O,(0,R.$ac)(L,K.name),N,q),--ae===0){ne();return}}else{const X=K.name.lastIndexOf(".");if(X>=0){const U=K.name.substring(X+1);U&&a.set(U,(a.get(U)??0)+1)}for(const U of i)U.relativePathPattern?.test(re)!==!1&&U.filePattern.test(K.name)&&m.set(U.tag,(m.get(U.tag)??0)+1);if(--ae===0){ne();return}}})}const D=C.Promises.withAsyncBody(async O=>{const L={count:0,maxReached:!1};await I(t,t,l,L);const N=await k(t);O({configFiles:c(m),fileTypes:c(a),fileCount:L.count,maxFilesReached:L.maxReached,launchConfigFiles:N})});return o.set(s,D),D}e.$er=g;function c(t){return Array.from(t.entries(),([l,s])=>({name:l,count:s})).sort((l,s)=>s.count-l.count)}function b(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/h.$lk.GB).toFixed(2)}GB (${(E.freemem()/h.$lk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(u.$rm.value()*100)}%`},l=E.cpus();return l&&l.length>0&&(t.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),t}e.$fr=b;async function k(t){try{const l=new Map,s=(0,R.$ac)(t,".vscode","launch.json"),n=await $.Promises.readFile(s),i=[],a=(0,r.$vm)(n.toString(),i);if(i.length)return console.log(`Unable to parse ${s}`),[];if((0,r.$Em)(a)==="object"&&a.configurations)for(const m of a.configurations){const P=m.type;P&&(l.has(P)?l.set(P,l.get(P)+1):l.set(P,1))}return c(l)}catch{return[]}}e.$gr=k;let w=class{constructor(l,s){this.c=l,this.d=s}f(l){const s=[];return s.push(`OS Version:       ${l.os}`),s.push(`CPUs:             ${l.cpus}`),s.push(`Memory (System):  ${l.memory}`),s.push(`VM:               ${l.vmHint}`),s.join(`
`)}g(l){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const n=E.cpus();return n&&n.length>0&&s.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),s.push(`Memory (System):  ${(E.totalmem()/h.$lk.GB).toFixed(2)}GB (${(E.freemem()/h.$lk.GB).toFixed(2)}GB free)`),S.$i||s.push(`Load (avg):       ${E.loadavg().map(i=>Math.round(i)).join(", ")}`),s.push(`VM:               ${Math.round(u.$rm.value()*100)}%`),s.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${l.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(l.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(l,s){return Promise.all([(0,d.$dr)(l.mainPID),this.k(l)]).then(async n=>{let[i,a]=n,m=this.m(l,i);return s.forEach(P=>{if((0,p.$4l)(P))m+=`
${P.errorMessage}`,a+=`
${P.errorMessage}`;else if(m+=`

Remote: ${P.hostName}`,P.processes&&(m+=`
${this.m(l,P.processes)}`),P.workspaceMetadata){a+=`
|  Remote: ${P.hostName}`;for(const I of Object.keys(P.workspaceMetadata)){const D=P.workspaceMetadata[I];let O=`${D.fileCount} files`;D.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${I}): ${O}`,a+=this.h(D)}}}),{processInfo:m,workspaceInfo:a}})}async getSystemInfo(l,s){const{memory:n,vmHint:i,os:a,cpus:m}=b(),P={os:a,memory:n,cpus:m,vmHint:i,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:s};return S.$i||(P.load=`${E.loadavg().map(I=>Math.round(I)).join(", ")}`),S.$k&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(l,s){const n=[];return(0,d.$dr)(l.mainPID).then(async i=>(n.push(""),n.push(this.g(l)),n.push(""),n.push(this.m(l,i)),l.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(l))),s.forEach(a=>{if((0,p.$4l)(a))n.push(`
${a.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${a.hostName}`),n.push(this.f(a.machineInfo)),a.processes&&n.push(this.m(l,a.processes)),a.workspaceMetadata)for(const m of Object.keys(a.workspaceMetadata)){const P=a.workspaceMetadata[m];let I=`${P.fileCount} files`;P.maxFilesReached&&(I=`more than ${I}`),n.push(`Folder (${m}): ${I}`),n.push(this.h(P))}}),n.push(""),n.push(""),n.join(`
`)))}h(l){const s=[];let i=0;const a=(D,O)=>{const L=` ${D}(${O})`;i+L.length>60?(s.push(m),m="|                 ",i=m.length):i+=L.length,m+=L};let m="|      File types:";const P=10,I=l.fileTypes.length>P?P:l.fileTypes.length;for(let D=0;D<I;D++){const O=l.fileTypes[D];a(O.name,O.count)}if(s.push(m),l.configFiles.length>=0&&(m="|      Conf files:",i=0,l.configFiles.forEach(D=>{a(D.name,D.count)}),s.push(m)),l.launchConfigFiles.length>0){let D="|      Launch Configs:";l.launchConfigFiles.forEach(O=>{const L=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;D+=L}),s.push(D)}return s.join(`
`)}j(l){const s=Math.max(...Object.keys(l).map(n=>n.length));return Object.keys(l).map(n=>`${n}:  ${" ".repeat(s-n.length)}  ${l[n]}`).join(`
                  `)}k(l){const s=[],n=[];return l.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(s.push(`|  Window (${i.title})`),i.folderURIs.forEach(a=>{const m=f.URI.revive(a);if(m.scheme===M.Schemas.file){const P=m.fsPath;n.push(g(P,["node_modules",".git"]).then(I=>{let D=`${I.fileCount} files`;I.maxFilesReached&&(D=`more than ${D}`),s.push(`|    Folder (${(0,R.$ec)(P)}): ${D}`),s.push(this.h(I))}).catch(I=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${I.toString()})`)}))}else s.push(`|    Folder (${m.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(i=>s.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(l,s){const n=new Map;l.windows.forEach(a=>n.set(a.pid,`window [${a.id}] (${a.title})`)),l.pidToNames.forEach(({pid:a,name:m})=>n.set(a,m));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),s&&this.n(l.mainPID,n,i,s,0),i.join(`
`)}n(l,s,n,i,a){const m=a===0;let P;m?P=i.pid===l?`${this.d.applicationName} main`:"remote agent":s.has(i.pid)?P=s.get(i.pid):P=`${"  ".repeat(a)} ${i.name}`;const I=process.platform==="win32"?i.mem:E.totalmem()*(i.mem/100);n.push(`${i.load.toFixed(0).padStart(5," ")}	${(I/h.$lk.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(i.children)&&i.children.forEach(D=>this.n(l,s,n,D,a+1))}async getWorkspaceFileExtensions(l){const s=new Set;for(const{uri:n}of l.folders){const i=f.URI.revive(n);if(i.scheme!==M.Schemas.file)continue;const a=i.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(P=>s.add(P.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(l){for(const{uri:s}of l.folders){const n=f.URI.revive(s);if(n.scheme!==M.Schemas.file)continue;const i=n.fsPath;try{const a=await g(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),a.fileTypes.forEach(m=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:m.name,count:m.count})}),a.launchConfigFiles.forEach(m=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:m.name,count:m.count})}),a.configFiles.forEach(m=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:m.name,count:m.count})})}catch{}}}};e.$hr=w,e.$hr=w=pe([x(0,y.$Tk),x(1,v.$8i)],w)}),define(te[249],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j4b=e.$i4b=void 0;class E{constructor(M){this.b=M}listen(M,R){throw new Error(`Event not found: ${R}`)}call(M,R,{eventName:S,data:f}){return this.b.forEach(u=>u.log(S,f)),Promise.resolve(null)}}e.$i4b=E;class C{constructor(M){this.b=M}log(M,R){return this.b.call("log",{eventName:M,data:R}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$j4b=C}),define(te[52],ie([0,1,37,10,3,18,60,122,26]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=void 0;class u{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$Zn=u;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$1n=$,e.$2n=new $;class d{async publicLog(i,a,m){}async publicLogError(i,a,m){}}e.$3n=d,e.$4n="telemetry",e.$5n="extensionTelemetryLog",e.$6n={log:()=>null,flush:()=>Promise.resolve(null)};function p(n,i){return r.Event.debounce(i.onDidChangeConfiguration,(m,P)=>{const I=m?new Set([...m.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:I}},1e3,!0)(m=>{m.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,M.$Wh)(m.source),configurationKeys:Array.from(m.affectedKeys)})})}e.$7n=p;function h(n,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!n.enableTelemetry||i.extensionTestsLocationURI)}e.$8n=h;function v(n,i){return!(i.isBuilt||i.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.$9n=v;function y(n){const i=n.getValue(f.$1k),a=n.getValue(f.$2k);if(n.getValue(f.$3k)===!1||a===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$0n=y;function o(n){const i={},a={},m={};b(n,m);for(let P in m){P=P.length>150?P.substr(P.length-149):P;const I=m[P];typeof I=="number"?a[P]=I:typeof I=="boolean"?a[P]=I?1:0:typeof I=="string"?(I.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${I.length}`),i[P]=I.substring(0,8191)):typeof I<"u"&&I!==null&&(i[P]=I)}return{properties:i,measurements:a}}e.$$n=o;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(n){if(!n)return"none";const i=(0,R.$Ak)(n);return g.has(i)?i:"other"}e.$_n=c;function b(n,i,a=0,m){if(n)for(const P of Object.getOwnPropertyNames(n)){const I=n[P],D=m?m+P:P;Array.isArray(I)?i[D]=(0,E.$Km)(I):I instanceof Date?i[D]=I.toISOString():(0,C.$ke)(I)?a<2?b(I,i,a+1,D+"."):i[D]=(0,E.$Km)(I):i[D]=I}}function k(n,i){const a=n.msftInternalDomains||[],m=i.getValue("telemetry.internalTesting");return(0,S.$Yn)(a)||m}e.$ao=k;function w(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.$bo=w;function t(n,i){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let a=n;const m=[];for(const O of i)for(;;){const L=O.exec(n);if(!L)break;m.push([L.index,O.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,I=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let D=0;for(a="";;){const O=I.exec(n);if(!O)break;const L=m.some(([N,q])=>O.index<q&&N<I.lastIndex);!P.test(O[0])&&!L&&(a+=n.substring(D,O.index)+"<REDACTED: user-file-path>",D=I.lastIndex)}return D<n.length&&(a+=n.substr(D)),a}function l(n){if(!n)return n;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of i)if(a.regex.test(n))return`<REDACTED: ${a.label}>`;return n}function s(n,i){return(0,E.$Hm)(n,a=>{if(a instanceof u||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let m=a.replaceAll("%20"," ");m=t(m,i);for(const P of i)m=m.replace(P,"");return m=l(m),m}})}e.$co=s}),define(te[123],ie([0,1,25,116,120,4,7,13,36,52]),function(G,e,E,C,r,M,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=void 0;function $(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,E.$Gd)(s.id,n.id)===0}e.$do=$;const d=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(n){const i=n.manifest?n.manifest.version:n.version,a=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new p(n.identifier,i,a)}static parse(n){const i=d.exec(n);return i&&i[1]&&i[2]?new p({id:i[1]},i[2],i[4]||void 0):null}constructor(n,i,a="undefined"){this.version=i,this.targetPlatform=a,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof p?$(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$eo=p;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(s){const n=h.exec(s);return n&&n[1]?[o(n[1]),n[2]]:[o(s),void 0]}e.$fo=v;function y(s,n){return`${s}.${n}`}e.$go=y;function o(s){return s.toLowerCase()}e.$ho=o;function g(s,n){return o(y(s??r.$Bl,n))}e.$io=g;function c(s,n){const i=[],a=m=>{for(const P of i)if(P.some(I=>$(n(I),n(m))))return P;return null};for(const m of s){const P=a(m);P?P.push(m):i.push([m])}return i}e.$jo=c;function b(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$ko=b;function k(s){return{id:new u.$Zn(s.identifier.id),name:new u.$Zn(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$lo=k,e.$mo=new r.$Fl("pprice.better-merge");function w(s,n){const i=[],a=n.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const m=a.shift();if(m&&i.every(P=>!$(P.identifier,{id:m}))){const P=s.filter(I=>$(I.identifier,{id:m}));P.length===1&&(i.push(P[0]),a.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$no=w;async function t(s,n){if(!M.$k)return!1;let i;try{i=(await s.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await s.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(m){n.debug("Error while getting the os-release file.",(0,S.$9)(m))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function l(s,n){const i=await t(s,n),a=(0,C.$In)(i?"alpine":M.$t,f.$8b);return n.debug("ComputeTargetPlatform:",a),a}e.$oo=l}),define(te[250],ie([0,1,204,52]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=void 0;async function r(M,R,S,f,u,$,d){const p={"X-Market-Client-Id":`VSCode ${M}`,"User-Agent":`VSCode ${M} (${R.nameShort})`};if((0,C.$8n)(R,S)&&(0,C.$0n)(f)===3){const h=await(0,E.$Oo)(S,u,$);p["X-Market-User-Id"]=h,p["VSCode-SessionId"]=d.machineId||h}return p}e.$Po=r}),define(te[251],ie([0,1,2,37,4,25,183,18,59,78,23,44,26,52]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;let v=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(g,c,b){this.k=c,this.l=b,this.d={},this.i=new E.$kb,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const k of this.f)this.j.push(new RegExp((0,M.$nd)(k),"gi")),k.indexOf("\\")>=0&&this.j.push(new RegExp((0,M.$nd)(k.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(k=>{(k.affectsConfiguration(p.$1k)||k.affectsConfiguration(p.$3k)||k.affectsConfiguration(p.$2k))&&this.m()}))}setExperimentProperty(g,c){this.d[g]=c}m(){let g=(0,h.$0n)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const b=c.usage?3:c.error?2:0;g=Math.min(g,b)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,c,b){this.g<c||(b=(0,C.$Im)(b,this.d),b=(0,h.$co)(b,this.j),b=(0,C.$Im)(b,this.c),this.b.forEach(k=>k.log(g,b)))}publicLog(g,c){this.n(g,3,c)}publicLog2(g,c){this.publicLog(g,c)}publicLogError(g,c){this.h&&this.n(g,2,c)}publicLogError2(g,c){this.publicLogError(g,c)}};e.$Dq=v,e.$Dq=v=pe([x(1,S.$Th),x(2,$.$8i)],v);function y(){const o=(0,R.localize)(0,null,u.default.nameLong),g=u.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",u.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=r.$o?"":(0,R.localize)(3,null),b=(0,R.localize)(4,null),k=(0,R.localize)(5,null),w=(0,R.localize)(6,null),t=(0,R.localize)(7,null),l=`
|       | ${b} | ${k} | ${w} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,R.localize)(8,null);return`
${o} ${g} ${c}

&nbsp;

${t}
${l}

&nbsp;

${s}
`}d.$Rm.as(f.$Wm.Configuration).registerConfiguration({id:p.$Zk,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[p.$1k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),d.$Rm.as(f.$Wm.Configuration).registerConfiguration({id:p.$Zk,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[p.$3k]:{type:"boolean",markdownDescription:u.default.privacyStatementUrl?(0,R.localize)(16,null,u.default.nameLong,u.default.privacyStatementUrl):(0,R.localize)(15,null,u.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${p.$1k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[252],ie([0,1,4,87,26]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M4b=void 0;async function M(R,S){let f=R.getItem(r.$Yk);return(typeof f!="string"||E.$j&&f==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(f=await(0,C.$sm)(S.error.bind(S))),f}e.$M4b=M}),define(te[253],ie([0,1,26,252]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N4b=void 0;async function r(M,R){const S=await(0,C.$M4b)(M,R);return M.setItem(E.$Yk,S),S}e.$N4b=r}),define(te[124],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(E||(e.EnvironmentVariableMutatorType=E={}))}),define(te[254],ie([0,1,4,124]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=void 0;const r=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor($){this.collections=$,this.a=new Map,this.b=new Map,$.forEach((d,p)=>{this.d(d,p);const h=d.map.entries();let v=h.next();for(;!v.done;){const y=v.value[1],o=v.value[0];let g=this.a.get(o);if(g||(g=[],this.a.set(o,g)),g.length>0&&g[0].type===C.EnvironmentVariableMutatorType.Replace){v=h.next();continue}const c={extensionIdentifier:p,value:y.value,type:y.type,scope:y.scope,variable:y.variable,options:y.options};c.scope||delete c.scope,g.unshift(c),v=h.next()}})}async applyToProcessEnvironment($,d,p){let h;E.$i&&(h={},Object.keys($).forEach(v=>h[v.toLowerCase()]=v));for(const[v,y]of this.getVariableMap(d)){const o=E.$i&&h[v.toLowerCase()]||v;for(const g of y){const c=p?await p(g.value):g.value;if(g.options?.applyAtProcessCreation??!0)switch(g.type){case C.EnvironmentVariableMutatorType.Append:$[o]=($[o]||"")+c;break;case C.EnvironmentVariableMutatorType.Prepend:$[o]=c+($[o]||"");break;case C.EnvironmentVariableMutatorType.Replace:$[o]=c;break}if(g.options?.applyAtShellIntegration??!1){const b=`VSCODE_ENV_${r.get(g.type)}`;$[b]=($[b]?$[b]+":":"")+v+"="+this.c(c)}}}}c($){return $.replaceAll(":","\\x3a")}diff($,d){const p=new Map,h=new Map,v=new Map;if($.getVariableMap(d).forEach((y,o)=>{const g=this.getVariableMap(d).get(o),c=S(y,g);c&&p.set(o,c)}),this.getVariableMap(d).forEach((y,o)=>{const g=$.getVariableMap(d).get(o),c=S(y,g);c&&v.set(o,c)}),this.getVariableMap(d).forEach((y,o)=>{const g=$.getVariableMap(d).get(o),c=f(y,g);c&&h.set(o,c)}),!(p.size===0&&h.size===0&&v.size===0))return{added:p,changed:h,removed:v}}getVariableMap($){const d=new Map;for(const p of this.a.values()){const h=p.filter(v=>R(v,$));h.length>0&&d.set(h[0].variable,h)}return d}getDescriptionMap($){const d=new Map;for(const p of this.b.values()){const h=p.filter(v=>R(v,$,!0));for(const v of h)d.set(v.extensionIdentifier,v.description)}return d}d($,d){if(!$.descriptionMap)return;const p=$.descriptionMap.entries();let h=p.next();for(;!h.done;){const v=h.value[1],y=h.value[0];let o=this.b.get(y);o||(o=[],this.b.set(y,o));const g={extensionIdentifier:d,scope:v.scope,description:v.description};g.scope||delete g.scope,o.push(g),h=p.next()}}}e.$4q=M;function R(u,$,d=!1){return u.scope?!!(u.scope.workspaceFolder&&$?.workspaceFolder&&u.scope.workspaceFolder.index===$.workspaceFolder.index):d?$===u.scope:!0}function S(u,$){if(!$)return u;const d=new Set;$.forEach(h=>d.add(h.extensionIdentifier));const p=[];return u.forEach(h=>{d.has(h.extensionIdentifier)||p.push(h)}),p.length===0?void 0:p}function f(u,$){if(!$)return;const d=new Map;$.forEach(h=>d.set(h.extensionIdentifier,h));const p=[];return u.forEach(h=>{const v=d.get(h.extensionIdentifier);v&&(h.type!==v.type||h.value!==v.value||h.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index)&&p.push(v)}),p.length===0?void 0:p}}),define(te[255],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=void 0;function E(f){return[...f.entries()]}e.$Xq=E;function C(f){return f?[...f.entries()]:[]}e.$Yq=C;function r(f){return new Map(f)}e.$Zq=r;function M(f){return new Map(f??[])}e.$1q=M;function R(f){return Array.from(f.entries()).map(u=>[u[0],E(u[1].map),C(u[1].descriptionMap)])}e.$2q=R;function S(f){return new Map(f.map(u=>[u[0],{map:r(u[1]),descriptionMap:M(u[2])}]))}e.$3q=S}),define(te[256],ie([0,1,8,21,3,2,5]),function(G,e,E,C,r,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oq=void 0;let S=class extends M.$lb{constructor(u,$){super(),this.h=$,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new r.$7c),this.onCreateRequest=this.g.event,this.b=u===void 0?15e3:u}createRequest(u){return new Promise(($,d)=>{const p=++this.a;this.c.set(p,$),this.g.fire({requestId:p,...u});const h=new C.$dd;(0,E.$ug)(this.b,h.token).then(()=>d(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,M.$jb)(()=>h.cancel())])})}acceptReply(u,$){const d=this.c.get(u);d?(this.c.delete(u),(0,M.$gb)(this.f.get(u)||[]),this.f.delete(u),d($)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.$Oq=S,e.$Oq=S=pe([x(1,R.$Pi)],S)}),define(te[125],ie([0,1,6,114,44]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$Hq=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$Gq=void 0,e.$Gq=new C.$Mi("terminalTabFocusMode",!1,!0);var M;(function(w){w.DefaultProfile="terminal.integrated.defaultProfile.",w.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var R;(function(w){w.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",w.AutomationProfileLinux="terminal.integrated.automationProfile.linux",w.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",w.AutomationProfileWindows="terminal.integrated.automationProfile.windows",w.ProfilesWindows="terminal.integrated.profiles.windows",w.ProfilesMacOs="terminal.integrated.profiles.osx",w.ProfilesLinux="terminal.integrated.profiles.linux",w.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",w.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",w.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",w.UseWslProfiles="terminal.integrated.useWslProfiles",w.TabsDefaultColor="terminal.integrated.tabs.defaultColor",w.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",w.TabsEnabled="terminal.integrated.tabs.enabled",w.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",w.TabsHideCondition="terminal.integrated.tabs.hideCondition",w.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",w.TabsShowActions="terminal.integrated.tabs.showActions",w.TabsLocation="terminal.integrated.tabs.location",w.TabsFocusMode="terminal.integrated.tabs.focusMode",w.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",w.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",w.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",w.CopyOnSelection="terminal.integrated.copyOnSelection",w.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",w.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",w.FontFamily="terminal.integrated.fontFamily",w.FontSize="terminal.integrated.fontSize",w.LetterSpacing="terminal.integrated.letterSpacing",w.LineHeight="terminal.integrated.lineHeight",w.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",w.TabStopWidth="terminal.integrated.tabStopWidth",w.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",w.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",w.BellDuration="terminal.integrated.bellDuration",w.FontWeight="terminal.integrated.fontWeight",w.FontWeightBold="terminal.integrated.fontWeightBold",w.CursorBlinking="terminal.integrated.cursorBlinking",w.CursorStyle="terminal.integrated.cursorStyle",w.CursorWidth="terminal.integrated.cursorWidth",w.Scrollback="terminal.integrated.scrollback",w.DetectLocale="terminal.integrated.detectLocale",w.DefaultLocation="terminal.integrated.defaultLocation",w.GpuAcceleration="terminal.integrated.gpuAcceleration",w.TerminalTitleSeparator="terminal.integrated.tabs.separator",w.TerminalTitle="terminal.integrated.tabs.title",w.TerminalDescription="terminal.integrated.tabs.description",w.RightClickBehavior="terminal.integrated.rightClickBehavior",w.Cwd="terminal.integrated.cwd",w.ConfirmOnExit="terminal.integrated.confirmOnExit",w.ConfirmOnKill="terminal.integrated.confirmOnKill",w.EnableBell="terminal.integrated.enableBell",w.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",w.AllowChords="terminal.integrated.allowChords",w.AllowMnemonics="terminal.integrated.allowMnemonics",w.TabFocusMode="terminal.integrated.tabFocusMode",w.EnvMacOs="terminal.integrated.env.osx",w.EnvLinux="terminal.integrated.env.linux",w.EnvWindows="terminal.integrated.env.windows",w.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",w.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",w.ShowExitAlert="terminal.integrated.showExitAlert",w.SplitCwd="terminal.integrated.splitCwd",w.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",w.WordSeparators="terminal.integrated.wordSeparators",w.EnableFileLinks="terminal.integrated.enableFileLinks",w.UnicodeVersion="terminal.integrated.unicodeVersion",w.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",w.LocalEchoEnabled="terminal.integrated.localEchoEnabled",w.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",w.LocalEchoStyle="terminal.integrated.localEchoStyle",w.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",w.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",w.CustomGlyphs="terminal.integrated.customGlyphs",w.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",w.InheritEnv="terminal.integrated.inheritEnv",w.ShowLinkHover="terminal.integrated.showLinkHover",w.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",w.AutoReplies="terminal.integrated.autoReplies",w.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",w.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",w.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",w.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",w.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",w.EnableImages="terminal.integrated.enableImages",w.SmoothScrolling="terminal.integrated.smoothScrolling",w.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",w.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay"})(R||(e.TerminalSettingId=R={}));var S;(function(w){w.PowerShell="pwsh",w.Bash="bash",w.Fish="fish",w.Sh="sh",w.Csh="csh",w.Ksh="ksh",w.Zsh="zsh"})(S||(e.PosixShellType=S={}));var f;(function(w){w.CommandPrompt="cmd",w.PowerShell="pwsh",w.Wsl="wsl",w.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var u;(function(w){w[w.Api=0]="Api",w[w.Process=1]="Process",w[w.Sequence=2]="Sequence",w[w.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var $;(function(w){w.LocalPty="localPty",w.PtyHost="ptyHost",w.PtyHostWindow="ptyHostWindow",w.Logger="logger",w.Heartbeat="heartbeat"})($||(e.TerminalIpcChannels=$={}));var d;(function(w){w.Cwd="cwd",w.InitialCwd="initialCwd",w.FixedDimensions="fixedDimensions",w.Title="title",w.ShellType="shellType",w.HasChildProcesses="hasChildProcesses",w.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",w.OverrideDimensions="overrideDimensions",w.FailedShellIntegrationActivation="failedShellIntegrationActivation",w.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(d||(e.ProcessPropertyType=d={})),e.$Hq=(0,E.$nh)("ptyService");var p;(function(w){w[w.BeatInterval=5e3]="BeatInterval",w[w.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",w[w.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",w[w.SecondWaitMultiplier=1]="SecondWaitMultiplier",w[w.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var h;(function(w){w[w.Panel=1]="Panel",w[w.Editor=2]="Editor"})(h||(e.TerminalLocation=h={}));var v;(function(w){w.TerminalView="view",w.Editor="editor"})(v||(e.TerminalLocationString=v={}));var y;(function(w){w[w.GraceTime=6e4]="GraceTime",w[w.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var o;(function(w){w[w.HighWatermarkChars=1e5]="HighWatermarkChars",w[w.LowWatermarkChars=5e3]="LowWatermarkChars",w[w.CharCountAckSize=5e3]="CharCountAckSize"})(o||(e.FlowControlConstants=o={}));var g;(function(w){w.GitBash="Git Bash",w.Pwsh="PowerShell"})(g||(e.ProfileSource=g={}));var c;(function(w){w[w.Off=0]="Off",w[w.FinalTerm=1]="FinalTerm",w[w.VSCode=2]="VSCode"})(c||(e.ShellIntegrationStatus=c={}));var b;(function(w){w[w.Unknown=0]="Unknown",w[w.Shutdown=1]="Shutdown",w[w.Process=2]="Process",w[w.User=3]="User",w[w.Extension=4]="Extension"})(b||(e.TerminalExitReason=b={})),e.$Iq={Backend:"workbench.contributions.terminal.processBackend"};class k{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const l=this.b(t.remoteAuthority);if(this.a.has(l))throw new Error(`A terminal backend with remote authority '${l}' was already registered.`);this.a.set(l,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}r.$Rm.add(e.$Iq.Backend,new k),e.$Jq=(0,E.$nh)("localPtyService"),e.$Kq=(0,E.$nh)("terminalLogService")}),define(te[257],ie([0,1,71,7,185,102]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sq=e.$Rq=e.$Qq=e.$Pq=void 0;function R(p,h){const v=[{name:null,description:(0,r.localize)(0,null)}];return v.push(...p.map(y=>({name:y.profileName,description:S(y)}))),h&&v.push(...h.map(y=>({name:y.title,description:f(y)}))),{values:v.map(y=>y.name),markdownDescriptions:v.map(y=>y.description)}}e.$Pq=R;function S(p){let h=`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:E.$Aj.terminal.id}) ${p.profileName}
- path: ${p.path}`;return p.args&&(typeof p.args=="string"?h+=`
- args: "${p.args}"`:h+=`
- args: [${p.args.length===0?"":`'${p.args.join("','")}'`}]`),p.overrideName!==void 0&&(h+=`
- overrideName: ${p.overrideName}`),p.color&&(h+=`
- color: ${p.color}`),p.env&&(h+=`
- env: ${JSON.stringify(p.env)}`),h}function f(p){return`$(${M.ThemeIcon.isThemeIcon(p.icon)?p.icon.id:p.icon?p.icon:E.$Aj.terminal.id}) ${p.title}
- extensionIdentifier: ${p.extensionIdentifier}`}function u(p,h){if(!p&&!h)return!0;if(typeof p=="string"&&typeof h=="string")return p===h;if(Array.isArray(p)&&Array.isArray(h)){if(p.length!==h.length)return!1;for(let v=0;v<p.length;v++)if(p[v]!==h[v])return!1;return!0}return!1}e.$Qq=u;function $(p,h){if(!p&&!h)return!0;if(!p||!h)return!1;if(M.ThemeIcon.isThemeIcon(p)&&M.ThemeIcon.isThemeIcon(h))return p.id===h.id&&p.color===h.color;if(typeof p=="object"&&"light"in p&&"dark"in p&&typeof h=="object"&&"light"in h&&"dark"in h){const v=p,y=h;if((C.URI.isUri(v.light)||d(v.light))&&(C.URI.isUri(v.dark)||d(v.dark))&&(C.URI.isUri(y.light)||d(y.light))&&(C.URI.isUri(y.dark)||d(y.dark)))return v.light.path===y.light.path&&v.dark.path===y.dark.path}if(C.URI.isUri(p)&&C.URI.isUri(h)||d(p)||d(h)){const v=p,y=h;return v.path===y.path&&v.scheme===y.scheme}return!1}e.$Rq=$;function d(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}e.$Sq=d}),define(te[258],ie([0,1,71,4,184,59,44,257]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=e.$Tq=void 0,e.$Tq={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Uq={type:"string",enum:Array.from((0,E.$zj)(),o=>o.id),markdownEnumDescriptions:Array.from((0,E.$zj)(),o=>`$(${o.id})`)};const f={args:{description:(0,r.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,r.localize)(1,null),type:"boolean"},icon:{description:(0,r.localize)(2,null),...e.$Uq},color:{description:(0,r.localize)(3,null),...e.$Tq},env:{markdownDescription:(0,r.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},u={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},$={type:"object",required:["path"],properties:{path:{description:(0,r.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function d(o){const g=o===2?"linux":o===1?"osx":"windows";return(0,r.localize)(7,null,(0,C.$h)(o),'```json\n"terminal.integrated.profile.'+g+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const p={id:"terminal",order:100,title:(0,r.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},$],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:d(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,r.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(13,null),type:"string"},id:{description:(0,r.localize)(14,null),type:"string"},title:{description:(0,r.localize)(15,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:d(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(16,null),type:"string"},id:{description:(0,r.localize)(17,null),type:"string"},title:{description:(0,r.localize)(18,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:d(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,r.localize)(19,null),type:"string"},id:{description:(0,r.localize)(20,null),type:"string"},title:{description:(0,r.localize)(21,null),type:"string"},...f}},{type:"null"},u]}},["terminal.integrated.useWslProfiles"]:{description:(0,r.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,r.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,r.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,r.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,r.localize)(26,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){R.$Rm.as(M.$Wm.Configuration).registerConfiguration(p),y()}e.$Vq=h;let v;function y(o,g){const c=R.$Rm.as(M.$Wm.Configuration);let b;o&&(b=(0,S.$Pq)(o?.profiles,g));const k=v;v={id:"terminal",order:100,title:(0,r.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,r.localize)(28,null),type:["string","null"],default:null,enum:o?.os===3?b?.values:void 0,markdownEnumDescriptions:o?.os===3?b?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,r.localize)(29,null),type:["string","null"],default:null,enum:o?.os===2?b?.values:void 0,markdownEnumDescriptions:o?.os===2?b?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,r.localize)(30,null),type:["string","null"],default:null,enum:o?.os===1?b?.values:void 0,markdownEnumDescriptions:o?.os===1?b?.markdownDescriptions:void 0}}},c.updateConfigurations({add:[v],remove:k?[k]:[]})}e.$Wq=y}),define(te[259],ie([0,1,27,15,37,9,4,36,25,10,22,124,255,254]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=e.$6q=e.$5q=void 0;function v(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let i=0;return n&&n.length===4&&(i=parseInt(n[3])),i}e.$5q=v;async function y(n,i,a,m=S.env,P=$.Promises.exists){if(M.$_b(n))return await P(n)?n:void 0;if(i===void 0&&(i=S.cwd()),M.$dc(n)!=="."){const L=M.$ac(i,n);return await P(L)?L:void 0}const D=(0,r.$Mm)(m,"PATH");if(a===void 0&&(0,u.$ie)(D)&&(a=D.split(M.$kc)),a===void 0||a.length===0){const L=M.$ac(i,n);return await P(L)?L:void 0}for(const L of a){let N;if(M.$_b(L)?N=M.$ac(L,n):N=M.$ac(i,L,n),await P(N))return N;if(R.$i){let q=N+".com";if(await P(q)||(q=N+".exe",await P(q)))return q}}const O=M.$ac(i,n);return await P(O)?O:void 0}e.$6q=y;function o(n,i,a,m,P){const I=R.$i&&(!i.windowsEnableConpty||v()<18309);if(!i.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||I)return;const D=n.args,O=S.$7b==="win32"?M.$ec(n.executable).toLowerCase():M.$ec(n.executable),L=M.$dc(C.$3e.asFileUri("").fsPath);let N;const q={VSCODE_INJECTION:"1"};if(i.shellIntegration.nonce&&(q.VSCODE_NONCE=i.shellIntegration.nonce),R.$i){if(O==="pwsh.exe"||O==="powershell.exe")return!D||l(D)?N=b.get(c.WindowsPwsh):t(D)&&(N=b.get(c.WindowsPwshLogin)),N?(N=[...N],N[N.length-1]=(0,f.$kd)(N[N.length-1],L,""),{newArgs:N,envMixin:q}):void 0;m.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(O){case"bash":return!D||D.length===0?N=b.get(c.Bash):s(D)&&(q.VSCODE_SHELL_LOGIN="1",g(i,q),N=b.get(c.Bash)),N?(N=[...N],N[N.length-1]=(0,f.$kd)(N[N.length-1],L),{newArgs:N,envMixin:q}):void 0;case"fish":{const re=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ne=M.$ac(L,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${re}:${ne}`,g(i,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!D||l(D)?N=b.get(c.Pwsh):t(D)&&(N=b.get(c.PwshLogin)),N?(N=[...N],N[N.length-1]=(0,f.$kd)(N[N.length-1],L,""),{newArgs:N,envMixin:q}):void 0;case"zsh":{if(!D||D.length===0?N=b.get(c.Zsh):s(D)?(N=b.get(c.ZshLogin),g(i,q)):(D===b.get(c.Zsh)||D===b.get(c.ZshLogin))&&(N=D),!N)return;N=[...N],N[N.length-1]=(0,f.$kd)(N[N.length-1],L);let re;try{re=E.userInfo().username}catch{re="unknown"}const ne=M.$ac(E.tmpdir(),`${re}-${P.applicationName}-zsh`);q.ZDOTDIR=ne;const ee=a?.ZDOTDIR??E.homedir()??"~";q.USER_ZDOTDIR=ee;const ae=[];return ae.push({source:M.$ac(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$ac(ne,".zshrc")}),ae.push({source:M.$ac(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$ac(ne,".zprofile")}),ae.push({source:M.$ac(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$ac(ne,".zshenv")}),ae.push({source:M.$ac(L,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$ac(ne,".zlogin")}),{newArgs:N,envMixin:q,filesToCopy:ae}}}m.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.$7q=o;function g(n,i){if(R.$j&&n.environmentVariableCollections){const a=(0,p.$3q)(n.environmentVariableCollections),P=new h.$4q(a).getVariableMap({workspaceFolder:n.workspaceFolder}).get("PATH"),I=[];if(P)for(const D of P)D.type===d.EnvironmentVariableMutatorType.Prepend&&I.push(D.value);I.length>0&&(i.VSCODE_PATH_PREFIX=I.join(""))}}var c;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(c||(c={}));const b=new Map;b.set(c.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),b.set(c.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),b.set(c.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),b.set(c.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),b.set(c.Zsh,["-i"]),b.set(c.ZshLogin,["-il"]),b.set(c.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const k=["-login","-l"],w=["-nol","-nologo"];function t(n){return typeof n=="string"?k.includes(n.toLowerCase()):n.length===1&&k.includes(n[0].toLowerCase())||n.length===2&&(k.includes(n[0].toLowerCase())||k.includes(n[1].toLowerCase()))&&(w.includes(n[0].toLowerCase())||w.includes(n[1].toLowerCase()))}function l(n){return typeof n=="string"?w.includes(n.toLowerCase()):n.length===0||n?.length===1&&w.includes(n[0].toLowerCase())}function s(n){return n==="string"&&k.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&k.includes(n[0].toLowerCase())}}),define(te[260],ie([0,1,47,71,9,4,10,22,106,259,113]),function(G,e,E,C,r,M,R,S,f,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;let d,p=!0;function h(i,a,m,P,I=process.env,D,O,L,N){return D=D||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},M.$i?v(m,D,I,O,P.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:P.getValue("terminal.integrated.profiles.windows"),typeof a=="string"?a:P.getValue("terminal.integrated.defaultProfile.windows"),N,L):l(D,O,m,i&&typeof i=="object"?{...i}:P.getValue(M.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof a=="string"?a:P.getValue(M.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),N,L,I)}e.$8q=h;async function v(i,a,m,P,I,D,O,L,N){const q=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),re=`${process.env.windir}\\${q?"Sysnative":"System32"}`;let ne=!1;(0,u.$5q)()>=16299&&(ne=!0),await c(L);const ee=new Map;if(i){ee.set("PowerShell",{source:"PowerShell",icon:C.$Aj.terminalPowershell,isAutoDetected:!0}),ee.set("Windows PowerShell",{path:`${re}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$Aj.terminalPowershell,isAutoDetected:!0}),ee.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ee.set("Command Prompt",{path:`${re}\\cmd.exe`,icon:C.$Aj.terminalCmd,isAutoDetected:!0}),ee.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ee.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:C.$Aj.terminalBash,isAutoDetected:!0});const ue=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ee.set("Cmder",{path:`${re}\\cmd.exe`,args:["/K",ue],requiresPath:process.env.CMDER_ROOT?ue:{path:ue,isUnsafe:!0},isAutoDetected:!0})}s(D,ee);const ae=await y(ee.entries(),O,a,m,P,N);if(i&&I)try{const ue=await w(`${re}\\${ne?"wsl":"bash"}.exe`,O);for(const K of ue)(!D||!(K.profileName in D))&&ae.push(K)}catch{p&&(P?.info("WSL is not installed, so could not detect WSL profiles"),p=!1)}return ae}async function y(i,a,m,P=process.env,I,D){const O=[];for(const[L,N]of i)O.push(o(L,N,a,m,P,I,D));return(await Promise.all(O)).filter(L=>!!L)}async function o(i,a,m,P,I=process.env,D,O){if(a===null)return;let L,N,q;if("source"in a&&!("path"in a)){const ae=d?.get(a.source);if(!ae)return;L=ae.paths,N=a.args||ae.args,a.icon?q=g(a.icon):ae.icon&&(q=ae.icon)}else L=Array.isArray(a.path)?a.path:[a.path],N=M.$i||Array.isArray(a.args)?a.args:void 0,q=g(a.icon);let re;if(O){const ae=L.map(K=>typeof K=="string"?K:K.path),ue=await O(ae);re=new Array(L.length);for(let K=0;K<L.length;K++)typeof L[K]=="string"?re[K]=ue[K]:re[K]={path:ue[K],isUnsafe:!0}}else re=L.slice();let ne;if(a.requiresPath){let ae;if((0,R.$ie)(a.requiresPath)?ae=a.requiresPath:(ae=a.requiresPath.path,a.requiresPath.isUnsafe&&(ne=ae)),!await P.existsFile(ae))return}const ee=await n(i,m,re,P,I,N,a.env,a.overrideName,a.isAutoDetected,ne);if(!ee){D?.debug("Terminal profile not validated",i,L);return}return ee.isAutoDetected=a.isAutoDetected,ee.icon=q,ee.color=a.color,ee}function g(i){return typeof i=="string"?{id:i}:i}async function c(i){if(d&&!i)return;const[a,m]=await Promise.all([b(),i||k()]);d=new Map,d.set("Git Bash",{profileName:"Git Bash",paths:a,args:["--login","-i"]}),d.set("PowerShell",{profileName:"PowerShell",paths:m,icon:C.$Aj.terminalPowershell})}async function b(){const i=new Set,a=await(0,u.$6q)("git.exe");if(a){const I=(0,$.dirname)(a);i.add((0,$.resolve)(I,"../.."))}function m(I,D){D&&I.add(D)}m(i,process.env.ProgramW6432),m(i,process.env.ProgramFiles),m(i,process.env["ProgramFiles(X86)"]),m(i,`${process.env.LocalAppData}\\Program`);const P=[];for(const I of i)P.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return P.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),P}async function k(){const i=[];for await(const a of(0,f.$bl)())i.push(a.exePath);return i}async function w(i,a){const m=[],P=await new Promise((O,L)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(N,q)=>{if(N)return L("Problem occurred when getting wsl distros");O(q)})});if(!P)return[];const I=new RegExp(/[\r?\n]/),D=P.split(I).filter(O=>O.trim().length>0&&O!=="");for(const O of D){if(O===""||O.startsWith("docker-desktop"))continue;const L=`${O} (WSL)`,N={profileName:L,path:i,args:["-d",`${O}`],isDefault:L===a,icon:t(O),isAutoDetected:!1};m.push(N)}return m}function t(i){return i.includes("Ubuntu")?C.$Aj.terminalUbuntu:i.includes("Debian")?C.$Aj.terminalDebian:C.$Aj.terminalLinux}async function l(i,a,m,P,I,D,O,L){const N=new Map;if(m){const q=(await i.readFile("/etc/shells")).toString(),re=(D||q.split(`
`)).map(ee=>{const ae=ee.indexOf("#");return ae===-1?ee:ee.substring(0,ae)}).filter(ee=>ee.trim().length>0),ne=new Map;for(const ee of re){let ae=(0,r.$ec)(ee),ue=ne.get(ae)||0;ue++,ue>1&&(ae=`${ae} (${ue})`),ne.set(ae,ue),N.set(ae,{path:ee,isAutoDetected:!0})}}return s(P,N),await y(N.entries(),I,i,L,a,O)}function s(i,a){if(i)for(const[m,P]of Object.entries(i))P===null||typeof P!="object"||!("path"in P)&&!("source"in P)?a.delete(m):(P.icon=P.icon||a.get(m)?.icon,a.set(m,P))}async function n(i,a,m,P,I,D,O,L,N,q){if(m.length===0)return Promise.resolve(void 0);const re=m.shift();if(re==="")return n(i,a,m,P,I,D,O,L,N);const ne=typeof re!="string"&&re.isUnsafe,ee=typeof re=="string"?re:re.path,ae={profileName:i,path:ee,args:D,env:O,overrideName:L,isAutoDetected:N,isDefault:i===a,isUnsafePath:ne,requiresUnsafePath:q};if((0,r.$ec)(ee)===ee){const K=I.PATH?I.PATH.split(r.$kc):void 0,X=await(0,u.$6q)(ee,void 0,K,void 0,P.existsFile);return X?(ae.path=X,ae.isFromPath=!0,ae):n(i,a,m,P,I,D)}return await P.existsFile((0,r.$$b)(ee))?ae:n(i,a,m,P,I,D,O,L,N)}}),define(te[261],ie([0,1,3,2,4,43,18,5,224,95,256,125,258,260,108,69]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;var o;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(o||(o={}));let g=class extends C.$lb{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.P()}constructor(b,k,w,t){super(),this.H=b,this.I=k,this.J=w,this.L=t,this.j=!1,this.k=0,this.l=!0,this.m=!1,this.r=this.B(new E.$7c),this.onPtyHostExit=this.r.event,this.s=this.B(new E.$7c),this.onPtyHostStart=this.s.event,this.t=this.B(new E.$7c),this.onPtyHostUnresponsive=this.t.event,this.u=this.B(new E.$7c),this.onPtyHostResponsive=this.u.event,this.v=this.B(new E.$7c),this.onPtyHostRequestResolveVariables=this.v.event,this.w=this.B(new E.$7c),this.onProcessData=this.w.event,this.y=this.B(new E.$7c),this.onProcessReady=this.y.event,this.z=this.B(new E.$7c),this.onProcessReplay=this.z.event,this.C=this.B(new E.$7c),this.onProcessOrphanQuestion=this.C.event,this.D=this.B(new E.$7c),this.onDidRequestDetach=this.D.event,this.F=this.B(new E.$7c),this.onDidChangeProperty=this.F.event,this.G=this.B(new E.$7c),this.onProcessExit=this.G.event,(0,p.$Vq)(),this.B(this.H),this.B((0,C.$jb)(()=>this.Q())),this.i=this.B(new $.$Oq(void 0,this.J)),this.i.onCreateRequest(this.v.fire,this.v),this.H.onRequestConnection&&E.Event.once(this.H.onRequestConnection)(()=>this.h()),this.H.onWillShutdown?.(()=>this.j=!0)}get M(){return this.I.getValue("terminal.integrated.ignoreProcessNames")}async N(){return this.g?.refreshIgnoreProcessNames?.(this.M)}async O(){if(r.$i)return process.env;try{return await(0,u.$wl)(this.I,this.J,{_:[]},process.env)}catch(b){return this.J.error("ptyHost was unable to resolve shell environment",b),{}}}P(){const b=this.H.start(),k=b.client;this.J.getLevel()===S.LogLevel.Trace&&this.J.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),M.ProxyChannel.toService(k.getChannel(d.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.R()),this.R(!0),this.B(b.onDidProcessExit(l=>{this.r.fire(l.code),!this.j&&!this.m&&(this.k<=o.MaxRestarts?(this.J.error(`ptyHost terminated unexpectedly with code ${l.code}`),this.k++,this.restartPtyHost()):this.J.error(`ptyHost terminated unexpectedly with code ${l.code}, giving up`))}));const t=M.ProxyChannel.toService(k.getChannel(d.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(l=>this.w.fire(l))),this.B(t.onProcessReady(l=>this.y.fire(l))),this.B(t.onProcessExit(l=>this.G.fire(l))),this.B(t.onDidChangeProperty(l=>this.F.fire(l))),this.B(t.onProcessReplay(l=>this.z.fire(l))),this.B(t.onProcessOrphanQuestion(l=>this.C.fire(l))),this.B(t.onDidRequestDetach(l=>this.D.fire(l))),this.B(new f.$Nq(this.L,k.getChannel(d.TerminalIpcChannels.Logger))),this.a=b,this.b=t,this.s.fire(),this.B(this.I.onDidChangeConfiguration(async l=>{l.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.N()})),this.N(),[b,t]}dispose(){this.m=!0,super.dispose()}async createProcess(b,k,w,t,l,s,n,i,a,m,P){const I=setTimeout(()=>this.W(),d.HeartbeatConstants.CreateProcessTimeout),D=await this.f.createProcess(b,k,w,t,l,s,n,i,a,m,P);return clearTimeout(I),D}updateTitle(b,k,w){return this.f.updateTitle(b,k,w)}updateIcon(b,k,w,t){return this.f.updateIcon(b,k,w,t)}attachToProcess(b){return this.f.attachToProcess(b)}detachFromProcess(b,k){return this.f.detachFromProcess(b,k)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(b){return this.f.start(b)}shutdown(b,k){return this.f.shutdown(b,k)}input(b,k){return this.f.input(b,k)}processBinary(b,k){return this.f.processBinary(b,k)}resize(b,k,w){return this.f.resize(b,k,w)}clearBuffer(b){return this.f.clearBuffer(b)}acknowledgeDataEvent(b,k){return this.f.acknowledgeDataEvent(b,k)}setUnicodeVersion(b,k){return this.f.setUnicodeVersion(b,k)}getInitialCwd(b){return this.f.getInitialCwd(b)}getCwd(b){return this.f.getCwd(b)}async getLatency(){const b=new y.$3c,k=await this.f.getLatency();return b.stop(),[{label:"ptyhostservice<->ptyhost",latency:b.elapsed()},...k]}orphanQuestionReply(b){return this.f.orphanQuestionReply(b)}installAutoReply(b,k){return this.f.installAutoReply(b,k)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(b){return this.f.uninstallAutoReply(b)}getDefaultSystemShell(b){return this.g?.getDefaultSystemShell(b)??(0,v.$hl)(b??r.OS,process.env)}async getProfiles(b,k,w,t=!1){const l=await this.O();return(0,h.$8q)(k,w,t,this.I,l,void 0,this.J,this.Y.bind(this,b))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(b,k){return this.f.getWslPath(b,k)}getRevivedPtyNewId(b,k){return this.f.getRevivedPtyNewId(b,k)}setTerminalLayoutInfo(b){return this.f.setTerminalLayoutInfo(b)}async getTerminalLayoutInfo(b){return this.g?.getTerminalLayoutInfo(b)}async requestDetachInstance(b,k){return this.f.requestDetachInstance(b,k)}async acceptDetachInstanceReply(b,k){return this.f.acceptDetachInstanceReply(b,k)}async freePortKillProcess(b){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(b)}async serializeTerminalState(b){return this.f.serializeTerminalState(b)}async reviveTerminalProcesses(b,k,w){return this.f.reviveTerminalProcesses(b,k,w)}async refreshProperty(b,k){return this.f.refreshProperty(b,k)}async updateProperty(b,k,w){return this.f.updateProperty(b,k,w)}async restartPtyHost(){this.Q(),this.l=!0,this.P()}Q(){this.f.shutdownAll(),this.c.store.dispose()}R(b){this.X(),this.n=setTimeout(()=>this.S(),b?d.HeartbeatConstants.ConnectingBeatInterval:d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier),this.l||(this.l=!0,this.u.fire())}S(){this.J.warn(`No ptyHost heartbeat after ${d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.n=void 0,this.p=setTimeout(()=>this.U(),d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.SecondWaitMultiplier)}U(){this.J.error(`No ptyHost heartbeat after ${(d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier+d.HeartbeatConstants.BeatInterval*d.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.p=void 0,this.l&&(this.l=!1,this.t.fire())}W(){this.X(),this.J.error(`No ptyHost response to createProcess after ${d.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.l&&(this.l=!1,this.t.fire())}X(){this.n&&(clearTimeout(this.n),this.n=void 0),this.p&&(clearTimeout(this.p),this.p=void 0)}Y(b,k){return this.i.createRequest({workspaceId:b,originalText:k})}async acceptPtyHostResolvedVariables(b,k){this.i.acceptReply(b,k)}};e.$9q=g,e.$9q=g=pe([x(1,R.$Th),x(2,S.$Pi),x(3,S.$Qi)],g)}),define(te[80],ie([0,1,14,3,2,4,18,6,34]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V3b=e.$U3b=void 0;const u="#FFFFFF",$="#1E1E1E",d="#000000",p="#FFFFFF",h="theme",v="themeBackground",y="windowSplash";e.$U3b=(0,S.$nh)("themeMainService");let o=class extends r.$lb{constructor(c,b){super(),this.b=c,this.c=b,this.a=this.B(new C.$7c),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(M.$i){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(M.$j){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(M.$k&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const c=this.getColorScheme();if(c.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return c.dark?d:p;let b=this.b.getItem(v,null);if(!b)switch(this.b.getItem(h,"vs-dark").split(" ")[0]){case"vs":b=u;break;case"hc-black":b=d;break;case"hc-light":b=p;break;default:b=$}return M.$j&&b.toUpperCase()===$&&(b="#171717"),b}saveWindowSplash(c,b){this.b.setItems([{key:h,data:b.baseTheme},{key:v,data:b.colorInfo.background},{key:y,data:b}]),typeof c=="number"&&this.f(c,b)}f(c,b){for(const k of E.BrowserWindow.getAllWindows())if(k.id===c){k.setBackgroundColor(b.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(y)}};e.$V3b=o,e.$V3b=o=pe([x(0,f.$OM),x(1,R.$Th)],o)}),define(te[126],ie([0,1,3,18,6,5]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nz=e.$Mz=e.$Lz=e.$Kz=e.$Jz=e.$Iz=e.$Hz=e.$Gz=e.ProvidedOnAutoForward=e.$Fz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ez=e.$Dz=void 0,e.$Dz=(0,r.$nh)("tunnelService"),e.$Ez=(0,r.$nh)("sharedTunnelsService");var R;(function(o){o.Http="http",o.Https="https"})(R||(e.TunnelProtocol=R={}));var S;(function(o){o.ConstantPrivate="constantPrivate",o.Private="private",o.Public="public"})(S||(e.TunnelPrivacyId=S={}));function f(o){return!!o.forwardPort}e.$Fz=f;var u;(function(o){o[o.Notify=1]="Notify",o[o.OpenBrowser=2]="OpenBrowser",o[o.OpenPreview=3]="OpenPreview",o[o.Silent=4]="Silent",o[o.Ignore=5]="Ignore",o[o.OpenBrowserOnce=6]="OpenBrowserOnce"})(u||(e.ProvidedOnAutoForward=u={}));function $(o){if(o.scheme!=="http"&&o.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(o.authority);if(g)return{address:g[1],port:+g[2]}}e.$Gz=$,e.$Hz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function d(o){return e.$Hz.indexOf(o)>=0}e.$Iz=d,e.$Jz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function p(o){return e.$Jz.indexOf(o)>=0}e.$Kz=p;function h(o,g,c,b){if(c===1)return!1;if(c===2&&p(g)){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(b);if(k?.length===4&&parseInt(k[1])>=18)return!1}return o<1024}e.$Lz=h;class v{constructor(g,c,b){this.remoteAddress=g,this.localAddress=c,this.b=b,this.a=new E.$7c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Mz=v;let y=class{constructor(g,c){this.i=g,this.j=c,this.a=new E.$7c,this.onTunnelOpened=this.a.event,this.b=new E.$7c,this.onTunnelClosed=this.b.event,this.c=new E.$7c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const g=this.j.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(g){return this.e=g,g?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(g){this.f=g.elevation,this.g=g.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const g=[],c=Array.from(this.d.values());for(const b of c){const k=Array.from(b.values());for(const w of k){const t=await w.value;t&&g.push(t)}}return g}async dispose(){for(const g of this.d.values()){for(const{value:c}of g.values())await c.then(b=>b?.dispose());g.clear()}this.d.clear()}setEnvironmentTunnel(g,c,b,k,w){this.o(g,c,Promise.resolve({tunnelRemoteHost:g,tunnelRemotePort:c,localAddress:b,privacy:k,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(g,c){(p(g)||d(g))&&(g=e.$Hz[0]);const b=this.q(g,c);if(b)return++b.refcount,b.value}openTunnel(g,c,b,k,w,t=!1,l,s){this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${b} on local port ${w}.`);const n=this.e??g;if(!n)return;if(c||(c="localhost"),k||(k=this.k),this.e&&this.h.has(b)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(n,c,b,k,w,t,l,s);return i?i.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(c,b);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const m=this.m(a);return(a.tunnelRemoteHost!==c||a.tunnelRemotePort!==b)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&a.privacy!==l&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(m),m}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const c=this.d.get(g.tunnelRemoteHost);if(c){const b=c.get(g.tunnelRemotePort);b&&(b.refcount--,await this.n(g.tunnelRemoteHost,g.tunnelRemotePort,b))}}}}async n(g,c,b){if(b.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${c}.`);const k=b.value.then(async w=>{w&&(await w.dispose(!0),this.b.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this.d.has(g)&&this.d.get(g).delete(c),k}}async closeTunnel(g,c){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${c} `);const b=this.d.get(g);if(b&&b.has(c)){const k=b.get(c);k.refcount=0,await this.n(g,c,k)}}o(g,c,b){this.d.has(g)||this.d.set(g,new Map),this.d.get(g).set(c,{refcount:1,value:b})}async p(g,c){const b=this.d.get(g);if(b){const k=b.get(c);(k?await k.value:void 0)||b.delete(c),b.size===0&&this.d.delete(g)}}q(g,c){const b=[g];d(g)?(b.push(...e.$Hz),b.push(...e.$Jz)):p(g)&&b.push(...e.$Jz);const k=b.map(w=>this.d.get(w));for(const w of k){const t=w?.get(c);if(t)return t}}canTunnel(g){return!!$(g)}s(g,c,b,k,w,t,l){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${b} on local port ${k}.`);const s=b;this.h.add(s);const n=k===void 0?b:k,i={elevationRequired:w?this.isPortPrivileged(n):!1},a={remoteAddress:{host:c,port:b},localAddressPort:k,privacy:t,public:t?t!==S.Private:void 0,protocol:l},m=g.forwardPort(a,i);return m?(this.o(c,b,m),m.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),m}};e.$Nz=y,e.$Nz=y=pe([x(0,M.$Pi),x(1,C.$Th)],y)}),define(te[262],ie([0,1,88,27,103,8,2,18,5,23,240,126,96,4,241]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$24b=e.$14b=e.$Z4b=void 0;async function y(k,w,t,l,s){let n;for(let i=3;i&&(n?.dispose(),n=await new o(k,w,t,l,s).waitForReady(),!(s&&r.$8e[s]||!r.$8e[n.tunnelLocalPort]));i--);return n}class o extends R.$lb{constructor(w,t,l,s,n){super(),this.j=t,this.k=n,this.privacy=d.TunnelPrivacyId.Private,this.i=new Map,this.a=w,this.b=E.createServer(),this.c=new M.$sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=i=>this.l(i),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=s,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const w=this.k??this.tunnelRemotePort,t=(0,d.$Kz)(this.j)?"0.0.0.0":"127.0.0.1";let l=await(0,r.$9e)(w,2,1e3,t),s=null;return this.b.listen(l,this.j),await this.c.wait(),s=this.b.address(),s||(l=0,this.b.listen(l,this.j),await this.c.wait(),s=this.b.address()),this.tunnelLocalPort=s.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${s.port}`,this}async l(w){w.pause();const t=(0,d.$Iz)(this.tunnelRemoteHost)||(0,d.$Kz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,$.$Kk)(this.a,t,this.tunnelRemotePort),s=l.getSocket().socket,n=l.readEntireBuffer();l.dispose(),n.byteLength>0&&w.write(n.buffer),w.on("end",()=>{w.localAddress&&this.i.delete(w.localAddress),s.end()}),w.on("close",()=>s.end()),w.on("error",()=>{w.localAddress&&this.i.delete(w.localAddress),s.destroy()}),s.on("end",()=>w.end()),s.on("close",()=>w.end()),s.on("error",()=>{w.destroy()}),w.pipe(s),s.pipe(w),w.localAddress&&this.i.set(w.localAddress,()=>{w.end(),s.end()})}}let g=class extends d.$Nz{constructor(w,t,l,s,n){super(t,n),this.t=w,this.u=l,this.v=s}isPortPrivileged(w){return(0,d.$Lz)(w,this.k,h.OS,C.release())}r(w,t,l,s,n,i,a,m){const P=this.q(t,l);if(P)return++P.refcount,P.value;if((0,d.$Fz)(w))return this.s(w,t,l,n,i,a,m);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${l} on local port ${n}.`);const I={commit:this.v.commit,quality:this.v.quality,addressProvider:w,remoteSocketFactoryService:this.t,signService:this.u,logService:this.i,ipcLogger:null},D=y(I,s,t,l,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,l,D),D}}};e.$Z4b=g,e.$Z4b=g=pe([x(0,v.$Ek),x(1,f.$Pi),x(2,p.$Hk),x(3,u.$8i),x(4,S.$Th)],g);let c=class extends g{constructor(w,t,l,s,n){super(w,t,l,s,n)}};e.$14b=c,e.$14b=c=pe([x(0,v.$Ek),x(1,f.$Pi),x(2,p.$Hk),x(3,u.$8i),x(4,S.$Th)],c);let b=class extends R.$lb{constructor(w,t,l,s,n){super(),this.b=w,this.c=t,this.f=l,this.g=s,this.h=n,this.a=new Map}async openTunnel(w,t,l,s,n,i,a,m,P){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${s} on local port ${i}.`),!this.a.has(w)){const I=new c(this.b,this.c,this.g,this.f,this.h);this.B(I),this.a.set(w,I),I.onTunnelClosed(async()=>{(await I.tunnels).length===0&&(I.dispose(),this.a.delete(w))})}return this.a.get(w).openTunnel(t,l,s,n,i,a,m,P)}};e.$24b=b,e.$24b=b=pe([x(0,v.$Ek),x(1,f.$Pi),x(2,u.$8i),x(3,p.$Hk),x(4,S.$Th)],b)}),define(te[48],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zib=e.$yib=e.DisablementReason=e.UpdateType=e.StateType=void 0;var C;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.Disabled="disabled",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(C||(e.StateType=C={}));var r;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(r||(e.UpdateType=r={}));var M;(function(R){R[R.NotBuilt=0]="NotBuilt",R[R.DisabledByEnvironment=1]="DisabledByEnvironment",R[R.ManuallyDisabled=2]="ManuallyDisabled",R[R.MissingConfiguration=3]="MissingConfiguration",R[R.InvalidConfiguration=4]="InvalidConfiguration",R[R.RunningAsAdmin=5]="RunningAsAdmin"})(M||(e.DisablementReason=M={})),e.$yib={Uninitialized:{type:"uninitialized"},Disabled:R=>({type:"disabled",reason:R}),Idle:(R,S)=>({type:"idle",updateType:R,error:S}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.$zib=(0,E.$nh)("updateService")}),define(te[263],ie([0,1,4,186,59,44]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.$Rm.as(r.$Wm.Configuration).registerConfiguration({id:"update",order:15,title:(0,C.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,C.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,C.localize)(2,null),(0,C.localize)(3,null),(0,C.localize)(4,null),(0,C.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,C.localize)(6,null),deprecationMessage:(0,C.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,C.localize)(8,null),description:(0,C.localize)(9,null),included:E.$i&&!E.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,C.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[264],ie([0,1,3,48]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l4b=e.$k4b=void 0;class r{constructor(S){this.a=S}listen(S,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(S,f,u){switch(f){case"checkForUpdates":return this.a.checkForUpdates(u);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(u)}throw new Error(`Call not found: ${f}`)}}e.$k4b=r;class M{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new E.$7c,this.onStateChange=this.a.event,this.b=C.$yib.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$l4b=M}),define(te[40],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=void 0,e.$nk=(0,E.$nh)("IUriIdentityService")}),define(te[265],ie([0,1,40,205,16,19,139,3,2]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class u{static{this._clock=0}constructor(p){this.uri=p,this.time=u._clock++}touch(){return this.time=u._clock++,this}}let $=class{constructor(p){this.g=p,this.c=new f.$kb,this.f=2**16;const h=new Map,v=y=>{let o=h.get(y.scheme);return o===void 0&&(o=p.hasProvider(y)&&!this.g.hasCapability(y,1024),h.set(y.scheme,o)),o};this.c.add(S.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(y=>{h.delete(y.scheme)})),this.extUri=new M.$Wf(v),this.d=new R.$_q((y,o)=>this.extUri.compare(y,o,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,M.$9f)(p));const h=this.d.get(p);return h?h.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new u(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((v,y)=>v[1].time<y[1].time?1:v[1].time>y[1].time?-1:0);u._clock=0,this.d.clear();const h=this.f*.5;for(let v=0;v<h;v++)this.d.set(p[v][0],p[v][1].touch())}};e.$ar=$,e.$ar=$=pe([x(0,r.$Qj)],$),(0,C.$0q)(E.$nk,$,1)}),define(te[127],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjb=void 0,e.$kjb=(0,E.$nh)("urlService")}),define(te[266],ie([0,1,7]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u4b=e.$t4b=e.$s4b=void 0;class C{constructor(S){this.a=S}listen(S,f){throw new Error(`Event not found: ${f}`)}call(S,f,u){switch(f){case"handleURL":return this.a.handleURL(E.URI.revive(u[0]),u[1])}throw new Error(`Call not found: ${f}`)}}e.$s4b=C;class r{constructor(S){this.a=S}handleURL(S,f){return this.a.call("handleURL",[S.toJSON(),f])}}e.$t4b=r;class M{constructor(S,f){this.a=S,this.b=f}async routeCall(S,f,u,$){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(u)&&u.length>0){const d=E.URI.revive(u[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",d.toString(!0)),d.query){const p=/\bwindowId=(\d+)/.exec(d.query);if(p){const h=p[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${h}"`,d.toString(!0));const v=new RegExp(`window:${h}`),y=S.connections.find(o=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",o.ctx),v.test(o.ctx)));if(y)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",d.toString(!0)),y;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",d.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",d.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,f,u,$)}routeEvent(S,f){throw new Error(`Event not found: ${f}`)}}e.$u4b=M}),define(te[267],ie([0,1,8,2,7,23]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqb=e.$nqb=void 0;class R extends C.$lb{constructor(){super(...arguments),this.a=new Set}open(u,$){const d=[...this.a.values()];return(0,E.$xg)(d.map(p=>()=>p.handleURL(u,$)),void 0,!1).then(p=>p||!1)}registerHandler(u){return this.a.add(u),(0,C.$jb)(()=>this.a.delete(u))}}e.$nqb=R;let S=class extends R{constructor(u){super(),this.b=u}create(u){let{authority:$,path:d,query:p,fragment:h}=u||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return $&&d&&d.indexOf("/")!==0&&(d=`/${d}`),r.URI.from({scheme:this.b.urlProtocol,authority:$,path:d,query:p,fragment:h})}};e.$oqb=S,e.$oqb=S=pe([x(0,M.$8i)],S)}),define(te[268],ie([0,1,14,8,3,2,4,7]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v4b=void 0;class f{constructor($,d,p,h,v,y){if(this.f=d,this.g=y,this.a=[],this.b=0,this.c=M.$lb.None,this.d=new M.$kb,$&&(y.trace("ElectronURLListener initialUrisToHandle:",$.map(c=>c.originalUrl)),this.a=$),R.$i){const c=h.isBuilt?[]:[`"${h.appRoot}"`];c.push("--open-url","--"),E.app.setAsDefaultProtocolClient(v.urlProtocol,process.execPath,c)}const o=r.Event.map(r.Event.fromNodeEventEmitter(E.app,"open-url",(c,b)=>({event:c,url:b})),({event:c,url:b})=>(c.preventDefault(),b));this.d.add(o(c=>{const b=this.h(c);b&&this.f.open(b,{originalUrl:c})})),p.getWindows().filter(c=>c.isReady).length>0?(y.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(y.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),r.Event.once(p.onDidSignalReadyWindow)(this.i,this,this.d))}h($){try{return S.URI.parse($)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const $=[];for(const d of this.a)await this.f.open(d.uri,{originalUrl:d.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",d.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",d.originalUrl),$.push(d));$.length!==0&&(this.a=$,this.c=(0,C.$vg)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.$v4b=f}),define(te[269],ie([0,1,3,2,16,56,58,17]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$74b=void 0;class f extends C.$lb{get capabilities(){return this.f.capabilities&-5}constructor($,d,p,h){super(),this.c=$,this.f=d,this.g=p,this.h=h,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new E.$7c),this.onDidChangeFile=this.a.event,this.b=R.$th.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(v=>this.i(v)))}watch($,d){this.b.set($,$);const p=this.f.watch(this.j($),d);return(0,C.$jb)(()=>{this.b.delete($),p.dispose()})}stat($){return this.f.stat(this.j($))}mkdir($){return this.f.mkdir(this.j($))}rename($,d,p){return this.f.rename(this.j($),this.j(d),p)}readFile($){return this.f.readFile(this.j($),{atomic:!0})}readFileStream($,d,p){const h=(0,M.$xb)(v=>S.$Jb.concat(v.map(y=>S.$Jb.wrap(y))).buffer);return(async()=>{try{const v=await this.readFile($);h.end(v)}catch(v){h.error(v),h.end()}})(),h}readdir($){return this.f.readdir(this.j($))}writeFile($,d,p){return this.f.writeFile(this.j($),d,p)}delete($,d){return this.f.delete(this.j($),d)}copy($,d,p){if((0,r.$Tj)(this.f))return this.f.copy(this.j($),this.j(d),p);throw new Error("copy not supported")}i($){const d=[];for(const p of $){if(p.resource.scheme!==this.c)continue;const h=this.k(p.resource);this.b.findSubstr(h)&&d.push({resource:h,type:p.type})}d.length&&(this.h.debug("User data changed"),this.a.fire(d))}j($){return $.with({scheme:this.c})}k($){return $.with({scheme:this.g})}}e.$74b=f}),define(te[270],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P4b=void 0,e.$P4b="utilityProcessWorker"}),define(te[271],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w4b=void 0,e.$w4b=(0,E.$nh)("webviewManagerService")}),define(te[272],ie([0,1,14,2,15,7]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x4b=void 0;class R extends C.$lb{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);E.protocol.registerFileProtocol(r.Schemas.vscodeWebview,f)}b(f,u){try{const $=M.URI.parse(f.url),d=R.a.get($.path);if(typeof d=="string"){const p=`vs/workbench/contrib/webview/browser/pre/${d}`,h=r.$3e.asFileUri(p);return u({path:h.fsPath,headers:{...r.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return u({error:-10})}catch{}return u({error:-2})}}e.$x4b=R}),define(te[81],ie([0,1,4]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ED=e.$DD=e.$CD=e.$BD=e.$AD=e.$zD=e.$yD=e.$xD=void 0,e.$xD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C($){return!!$.workspaceUri}e.$yD=C;function r($){return!!$.folderUri}e.$zD=r;function M($){return!!$.fileUri}e.$AD=M;function R($){const d=S($),p=$.getValue("window.menuBarVisibility");return p==="default"||d==="native"&&p==="compact"||E.$j&&E.$m?"classic":p}e.$BD=R;function S($){if(E.$o)return"custom";const d=$.getValue("window");if(d){if(E.$j&&d.nativeTabs===!0||E.$j&&d.nativeFullScreen===!1)return"native";const v=d.titleBarStyle;if(v==="native"||v==="custom")return v}return E.$k?"native":"custom"}e.$CD=S;function f($){if(!E.$i||E.$o||S($)==="native")return!1;const d=$.getValue("window.experimental.windowControlsOverlay.enabled");return typeof d=="boolean"?d:!0}e.$DD=f;function u($=0){return Math.pow(1.2,$)}e.$ED=u}),define(te[128],ie([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$02b=e.UnloadReason=e.LoadReason=void 0;var E;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(E||(e.LoadReason=E={}));var C;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(C||(e.UnloadReason=C={}));const r=function(S=1){return{width:1024,height:768,mode:S}};e.$02b=r;var M;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(M||(e.WindowMode=M={}));var R;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(R||(e.WindowError=R={}))}),define(te[29],ie([0,1,6]),function(G,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.$m3b=void 0,e.$m3b=(0,E.$nh)("windowsMainService");var C;(function(r){r[r.CLI=0]="CLI",r[r.DOCK=1]="DOCK",r[r.MENU=2]="MENU",r[r.DIALOG=3]="DIALOG",r[r.DESKTOP=4]="DESKTOP",r[r.API=5]="API"})(C||(e.OpenContext=C={}))}),define(te[273],ie([0,1,76,5,33,23,29,217]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G4b=void 0;let f=class extends S.$nn{constructor($,d,p,h){super($),this.n=d,this.p=p,this.r=h,this.j=v=>{this.r.sendToFocused("vscode:showCredentialsError",v.message??v)}}async getSecretStoragePrefix(){return Promise.resolve(this.p.urlProtocol)}async i(){if(this.f)return this.f;if(this.n.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.$mn,this.f;const $=await new Promise((d,p)=>{G(["keytar"],d,p)});return await $.findCredentials("test-keytar-loads"),this.f=$,this.f}};e.$G4b=f,e.$G4b=f=pe([x(0,C.$Pi),x(1,r.$vh),x(2,M.$8i),x(3,R.$m3b)],f)}),define(te[274],ie([0,1,14,24,4,7,22,18,63,6,5,127,29]),function(G,e,E,C,r,M,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$73b=e.$63b=e.ID=void 0,e.ID="launchMainService",e.$63b=(0,u.$nh)(e.ID);let h=class{constructor(y,o,g,c){this.a=y,this.b=o,this.c=g,this.d=c}async start(y,o){this.a.trace("Received data from other instance: ",y,o),r.$j&&E.app.focus({steal:!0});const g=this.e(y);if(g.length){let c=Promise.resolve();if(this.b.getWindowCount()===0){const b=(0,C.$uf)(await this.b.openEmptyWindow({context:4}));b&&(c=b.ready())}c.then(()=>{for(const{uri:b,originalUrl:k}of g)this.c.open(b,{originalUrl:k})})}else return this.f(y,o)}e(y){return y["open-url"]&&y._urls&&y._urls.length>0?(0,C.$lf)(y._urls.map(o=>{try{return{uri:M.URI.parse(o),originalUrl:o}}catch{return null}})):[]}async f(y,o){const g=(0,f.$ql)(o)?0:4;let c=[];const b=y.wait&&y.waitMarkerFilePath?M.URI.file(y.waitMarkerFilePath):void 0,k=y.remote||void 0,w={context:g,cli:y,userEnv:o,waitMarkerFileURI:b,remoteAuthority:k,forceProfile:y.profile,forceTempProfile:y["profile-temp"]};if(y.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(y.extensionDevelopmentPath,w);else if(!y._.length&&!y["folder-uri"]&&!y["file-uri"]){let t=!1;if(y["new-window"]||y["unity-launch"]||w.forceProfile||w.forceTempProfile)t=!0;else if(y["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!r.$j}if(t)c=await this.b.open({...w,forceNewWindow:!0,forceEmpty:!0});else{const l=this.b.getLastActiveWindow();l?(this.b.openExistingWindow(l,w),c=[l]):c=await this.b.open({...w,forceEmpty:!0})}}else c=await this.b.open({...w,forceNewWindow:y["new-window"],preferNewWindow:!y["reuse-window"]&&!y.wait,forceReuseWindow:y["reuse-window"],diffMode:y.diff,mergeMode:y.merge,addMode:y.add,noRecentEntry:!!y["skip-add-to-recently-opened"],gotoLineMode:y.goto});if(b&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,R.whenDeleted)(b.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$73b=h,e.$73b=h=pe([x(0,$.$Pi),x(1,p.$m3b),x(2,d.$kjb),x(3,S.$Th)],h)}),define(te[275],ie([0,1,14,3,2,272,29]),function(G,e,E,C,r,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y4b=void 0;let S=class extends r.$lb{constructor(u){super(),this.b=u,this.a=this.B(new C.$7c),this.onFoundInFrame=this.a.event,this.B(new M.$x4b)}async setIgnoreMenuShortcuts(u,$){let d;if(typeof u.windowId=="number"){const{windowId:p}=u,h=this.b.getWindowById(p);if(!h?.win)throw new Error(`Invalid windowId: ${p}`);d=h.win.webContents}else{const{webContentsId:p}=u;if(d=E.webContents.fromId(p),!d)throw new Error(`Invalid webContentsId: ${p}`)}d.isDestroyed()||d.setIgnoreMenuShortcuts($)}async findInFrame(u,$,d,p){const v=this.c(u,$);if(typeof v.findInFrame=="function"){v.findInFrame(d,{findNext:p.findNext,forward:p.forward});const y=(o,g)=>{g.finalUpdate&&(this.a.fire(g),v.removeListener("found-in-frame",y))};v.on("found-in-frame",y)}}async stopFindInFrame(u,$,d){const h=this.c(u,$);typeof h.stopFindInFrame=="function"&&h.stopFindInFrame(d.keepSelection?"keepSelection":"clearSelection")}c(u,$){const d=this.b.getWindowById(u.windowId);if(!d?.win)throw new Error(`Invalid windowId: ${u}`);const p=d.win.webContents.mainFrame.framesInSubtree.find(h=>h.name===$);if(!p)throw new Error(`Unknown frame: ${$}`);return p}};e.$y4b=S,e.$y4b=S=pe([x(0,R.$m3b)],S)}),define(te[276],ie([0,1,8,3,2]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E4b=void 0;class M extends r.$lb{constructor({onDidOpenWindow:S,onDidFocusWindow:f,getActiveWindowId:u}){super(),this.a=this.B(new r.$kb),C.Event.latch(C.Event.any(S,f))(this.f,this,this.a),this.b=(0,E.$hg)(()=>u()),(async()=>{try{const d=await this.b;this.c=typeof this.c=="number"?this.c:d}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$E4b=M}),define(te[30],ie([0,1,190,9,58,19,7,6,15]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.WorkbenchState=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$wh=(0,S.$nh)("contextService");function u(n){const i=n;return typeof i?.id=="string"&&R.URI.isUri(i.uri)}e.$xh=u;function $(n){return typeof n?.id=="string"&&!u(n)&&!p(n)}e.$yh=$,e.$zh={id:"ext-dev"},e.$Ah={id:"empty-window"};function d(n,i){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,C.$ec)(n)}:i?e.$zh:e.$Ah;const a=n;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$Bh=d;function p(n){const i=n;return typeof i?.id=="string"&&R.URI.isUri(i.configPath)}e.$Ch=p;function h(n){const i=n;if(i?.uri)return{id:i.id,uri:R.URI.revive(i.uri)};const a=n;if(a?.configPath)return{id:a.id,configPath:R.URI.revive(a.configPath)};if(n?.id)return{id:n.id}}e.$Dh=h;var v;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(v||(e.WorkbenchState=v={}));function y(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$Eh=y;function o(n){const i=n;return!!(i&&typeof i=="object"&&R.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$Fh=o;class g{constructor(i,a,m,P,I){this.h=i,this.j=m,this.k=P,this.l=I,this.c=r.$th.forUris(this.l,()=>!0),this.folders=a}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=r.$th.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gh=g;class c{constructor(i,a){this.raw=a,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,M.$8f)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hh=c;function b(n){return new c({uri:n,index:0,name:(0,M.$4f)(n)},{uri:n.toString()})}e.$Ih=b,e.$Jh="code-workspace",e.$Kh=`.${e.$Jh}`,e.$Lh=[{name:(0,E.localize)(0,null),extensions:[e.$Jh]}],e.$Mh="workspace.json";function k(n,i){return M.$Yf.isEqualOrParent(n,i.untitledWorkspacesHome)}e.$Nh=k;function w(n){let i;return R.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===f.Schemas.tmp}e.$Oh=w,e.$Ph="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.$Ph}e.$Qh=t;function l(n,i){return!k(n,i)&&!w(n)}e.$Rh=l;function s(n){return(typeof n=="string"?(0,C.$fc)(n):(0,M.$6f)(n))===e.$Kh}e.$Sh=s}),define(te[61],ie([0,1,14,8,57,46,2,86,4,10,22,165,92,6,5,23,30]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z3b=e.$y3b=void 0,e.$y3b=(0,h.$nh)("dialogMainService");let g=class{constructor(b,k){this.d=b,this.e=k,this.a=new Map,this.b=new Map,this.c=new C.$Ag}pickFileFolder(b,k){return this.f({...b,pickFolders:!0,pickFiles:!0,title:(0,d.localize)(0,null)},k)}pickFolder(b,k){return this.f({...b,pickFolders:!0,title:(0,d.localize)(1,null)},k)}pickFile(b,k){return this.f({...b,pickFiles:!0,title:(0,d.localize)(2,null)},k)}pickWorkspace(b,k){const w=(0,d.localize)(3,null),t=(0,M.$5z)((0,d.localize)(4,null)),l=o.$Lh;return this.f({...b,pickFiles:!0,title:w,filters:l,buttonLabel:t},k)}async f(b,k){const w={title:b.title,buttonLabel:b.buttonLabel,filters:b.filters,defaultPath:b.defaultPath};(typeof b.pickFiles=="boolean"||typeof b.pickFolders=="boolean")&&(w.properties=void 0,b.pickFiles&&b.pickFolders&&(w.properties=["multiSelections","openDirectory","openFile","createDirectory"])),w.properties||(w.properties=["multiSelections",b.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&w.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(w,(0,u.$Ae)(k||E.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(b){if(b){let k=this.b.get(b.id);return k||(k=new C.$Ag,this.b.set(b.id,k)),k}else return this.c}showMessageBox(b,k){return this.g(k).queue(async()=>{const{options:w,buttonIndeces:t}=(0,p.$_z)(b,this.e);let l;return k?l=await E.dialog.showMessageBox(k,w):l=await E.dialog.showMessageBox(w),{response:t[l.response],checkboxChecked:l.checkboxChecked}})}async showSaveDialog(b,k){const w=this.j(b,k);if(!w)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(k).queue(async()=>{let t;return k?t=await E.dialog.showSaveDialog(k,b):t=await E.dialog.showSaveDialog(b),t.filePath=this.h(t.filePath),t})}finally{(0,R.$gb)(w)}}h(b){return b&&f.$j&&(b=(0,S.$5k)(b)),b}i(b){return b.map(k=>this.h(k))}async showOpenDialog(b,k){b.defaultPath&&(await $.Promises.exists(b.defaultPath)||(b.defaultPath=void 0));const w=this.j(b,k);if(!w)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(k).queue(async()=>{let t;return k?t=await E.dialog.showOpenDialog(k,b):t=await E.dialog.showOpenDialog(b),t.filePaths=this.i(t.filePaths),t})}finally{(0,R.$gb)(w)}}j(b,k){if(!k)return R.$lb.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",b);let w=this.a.get(k.id);w||(w=new Set,this.a.set(k.id,w));const t=(0,r.$bi)(b);if(!w.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",b),w.add(t),(0,R.$jb)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",b),w?.delete(t),w?.size===0&&this.a.delete(k.id)})}};e.$z3b=g,e.$z3b=g=pe([x(0,v.$Pi),x(1,y.$8i)],g)}),define(te[277],ie([0,1,3,2,74,30]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h4b=void 0;class R extends C.$lb{static{this.a=100}constructor(f,u){super(),this.f=f,this.g=u,this.b=this.B(new E.$7c),this.c=new Map,this.h(u.applicationStorage,this.b)}h(f,u){this.B(E.Event.debounce(f.onDidChangeStorage,($,d)=>($?$.push(d):$=[d],$),R.a)($=>{$.length&&u.fire(this.i($,f))}))}i(f,u){const $=new Map,d=new Set;return f.forEach(p=>{const h=u.get(p.key);typeof h=="string"?$.set(p.key,h):d.add(p.key)}),{changed:Array.from($.entries()),deleted:Array.from(d.values())}}listen(f,u,$){switch(u){case"onDidChangeStorage":{const d=$.profile?(0,r.$Wg)($.profile):void 0;if(!d)return this.b.event;let p=this.c.get(d.id);return p||(p=this.B(new E.$7c),this.h(this.g.profileStorage(d),p),this.c.set(d.id,p)),p.event}}throw new Error(`Event not found: ${u}`)}async call(f,u,$){const d=$.profile?(0,r.$Wg)($.profile):void 0,p=(0,M.$Dh)($.workspace),h=await this.j(d,p);switch(u){case"getItems":return Array.from(h.items.entries());case"updateItems":{const v=$;if(v.insert)for(const[y,o]of v.insert)h.set(y,o);v.delete?.forEach(y=>h.delete(y));break}case"isUsed":{const v=$.payload;if(typeof v=="string")return this.g.isUsed(v)}default:throw new Error(`Call not found: ${u}`)}}async j(f,u){let $;u?$=this.g.workspaceStorage(u):f?$=this.g.profileStorage(f):$=this.g.applicationStorage;try{await $.init()}catch(d){this.f.error(`StorageIPC#init: Unable to init ${u?"workspace":f?"profile":"application"} storage due to ${d}`)}return $}}e.$h4b=R}),define(te[41],ie([0,1,57,3,2,19,7,187,33,16,6,5,30,35,40,8,31,25,10]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.ProfileResourceType=void 0;var b;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(b||(e.ProfileResourceType=b={}));function k(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&R.URI.isUri(i.location)&&R.URI.isUri(i.globalStorageHome)&&R.URI.isUri(i.settingsResource)&&R.URI.isUri(i.keybindingsResource)&&R.URI.isUri(i.tasksResource)&&R.URI.isUri(i.snippetsHome)&&R.URI.isUri(i.extensionsResource))}e.$ok=k,e.$pk=(0,$.$nh)("IUserDataProfilesService");function w(n,i){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,location:R.URI.revive(n.location).with({scheme:i}),globalStorageHome:R.URI.revive(n.globalStorageHome).with({scheme:i}),settingsResource:R.URI.revive(n.settingsResource).with({scheme:i}),keybindingsResource:R.URI.revive(n.keybindingsResource).with({scheme:i}),tasksResource:R.URI.revive(n.tasksResource).with({scheme:i}),snippetsHome:R.URI.revive(n.snippetsHome).with({scheme:i}),extensionsResource:R.URI.revive(n.extensionsResource).with({scheme:i}),cacheHome:R.URI.revive(n.cacheHome).with({scheme:i}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$qk=w;function t(n,i,a,m,P,I){return{id:n,name:i,location:a,isDefault:!1,shortName:P?.shortName,globalStorageHome:I&&P?.useDefaultFlags?.globalState?I.globalStorageHome:(0,M.$8f)(a,"globalStorage"),settingsResource:I&&P?.useDefaultFlags?.settings?I.settingsResource:(0,M.$8f)(a,"settings.json"),keybindingsResource:I&&P?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,M.$8f)(a,"keybindings.json"),tasksResource:I&&P?.useDefaultFlags?.tasks?I.tasksResource:(0,M.$8f)(a,"tasks.json"),snippetsHome:I&&P?.useDefaultFlags?.snippets?I.snippetsHome:(0,M.$8f)(a,"snippets"),extensionsResource:I&&P?.useDefaultFlags?.extensions?I.extensionsResource:(0,M.$8f)(a,"extensions.json"),cacheHome:(0,M.$8f)(m,n),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$rk=t;let l=class extends r.$lb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,a,m,P){super(),this.n=i,this.r=a,this.s=m,this.t=P,this.f=!0,this.h=this.B(new C.$7c),this.onDidChangeProfiles=this.h.event,this.i=this.B(new C.$7c),this.onWillCreateProfile=this.i.event,this.j=this.B(new C.$7c),this.onWillRemoveProfile=this.j.event,this.k=this.B(new C.$7c),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.$li,emptyWindows:new Map},this.profilesHome=(0,M.$8f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,M.$8f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=this.w(),a=[i];if(this.f)try{for(const I of this.J()){if(!I.name||!(0,c.$ie)(I.name)||!I.location){this.t.warn("Skipping the invalid stored profile",I.location||I.name);continue}a.push(t((0,M.$5f)(I.location),I.name,I.location,this.g,{shortName:I.shortName,useDefaultFlags:I.useDefaultFlags},i))}}catch(I){this.t.error(I)}const m=new h.$li,P=new Map;if(a.length)try{const I=this.M();if(I.workspaces)for(const[D,O]of Object.entries(I.workspaces)){const L=R.URI.parse(D),N=a.find(q=>q.id===O);N&&m.set(L,N)}if(I.emptyWindows)for(const[D,O]of Object.entries(I.emptyWindows)){const L=a.find(N=>N.id===O);L&&P.set(D,L)}}catch(I){this.t.error(I)}this.u={profiles:a,workspaces:m,emptyWindows:P}}return this.u}w(){const i=t("__default__profile__",(0,S.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...i,extensionsResource:this.O()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const a="Temp",m=new RegExp(`${(0,g.$nd)(a)}\\s(\\d+)`);let P=0;for(const D of this.profiles){const O=m.exec(D.name),L=O?parseInt(O[1]):0;P=L>P?L:P}const I=`${a} ${P+1}`;return this.createProfile((0,E.$bi)((0,o.$5e)()).toString(16),I,{transient:!0},i)}async createNamedProfile(i,a,m){return this.createProfile((0,E.$bi)((0,o.$5e)()).toString(16),i,a,m)}async createProfile(i,a,m,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.y(i,a,m);return P&&await this.setProfileForWorkspace(P,I),I}async y(i,a,m){if(!(0,c.$ie)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.l.get(a);return P||(P=(async()=>{try{const I=this.profiles.find(L=>L.name===a||L.id===i);if(I)return I;const D=t(i,a,(0,M.$8f)(this.profilesHome,i),this.g,m,this.defaultProfile);await this.r.createFolder(D.location);const O=[];return this.i.fire({profile:D,join(L){O.push(L)}}),await y.Promises.settled(O),this.D([D],[],[]),D}finally{this.l.delete(a)}})(),this.l.set(a,P)),P}async updateProfile(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let m=this.profiles.find(P=>P.id===i.id);if(!m)throw new Error(`Profile '${i.name}' does not exist`);return m=t(m.id,a.name??m.name,m.location,this.g,{shortName:a.shortName??m.shortName,transient:a.transient??m.isTransient,useDefaultFlags:a.useDefaultFlags??m.useDefaultFlags},this.defaultProfile),this.D([],[],[m]),m}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(P=>P.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);const m=[];this.j.fire({profile:a,join(P){m.push(P)}});try{await Promise.allSettled(m)}catch(P){this.t.error(P)}for(const P of[...this.v.emptyWindows.keys()])a.id===this.v.emptyWindows.get(P)?.id&&this.v.emptyWindows.delete(P);for(const P of[...this.v.workspaces.keys()])a.id===this.v.workspaces.get(P)?.id&&this.v.workspaces.delete(P);this.H(),this.D([],[a],[]);try{await this.r.del(a.cacheHome,{recursive:!0})}catch(P){(0,u.$7j)(P)!==1&&this.t.error(P)}}async setProfileForWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const m=this.profiles.find(P=>P.id===a.id);if(!m)throw new Error(`Profile '${a.name}' does not exist`);this.G(i,m)}unsetWorkspace(i,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,a)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(a=>a.isDirectory&&this.profiles.every(m=>!this.s.extUri.isEqual(m.location,a.resource))).map(a=>this.r.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(a=>!this.C(a));await Promise.allSettled(i.map(a=>this.removeProfile(a)))}getProfileForWorkspace(i){const a=this.z(i);return R.URI.isUri(a)?this.m.workspaces.get(a)??this.v.workspaces.get(a):this.m.emptyWindows.get(a)??this.v.emptyWindows.get(a)}z(i){return(0,p.$xh)(i)?i.uri:(0,p.$Ch)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.m.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.emptyWindows.values()].some(a=>this.s.extUri.isEqual(a.location,i.location))||[...this.v.workspaces.values()].some(a=>this.s.extUri.isEqual(a.location,i.location)))}D(i,a,m){const P=[...this.profiles,...i],I=[];this.m.profiles=[];for(let D of P)D.isDefault||a.some(O=>D.id===O.id)||(D=m.find(O=>D.id===O.id)??D,D.isTransient?this.m.profiles.push(D):I.push({location:D.location,name:D.name,shortName:D.shortName,useDefaultFlags:D.useDefaultFlags}));this.L(I),this.u=void 0,this.F(i,a,m)}F(i,a,m){this.h.fire({added:i,removed:a,updated:m,all:this.profiles})}G(i,a,m){m=a?.isTransient?!0:m,m||this.G(i,void 0,!0);const P=this.z(i),I=m?this.m:this.v;R.URI.isUri(P)?(I.workspaces.delete(P),a&&I.workspaces.set(P,a)):(I.emptyWindows.delete(P),a&&I.emptyWindows.set(P,a)),m||this.H()}H(){const i={};for(const[m,P]of this.v.workspaces.entries())i[m.toString()]=P.id;const a={};for(const[m,P]of this.v.emptyWindows.entries())a[m.toString()]=P.id;this.N({workspaces:i,emptyWindows:a}),this.u=void 0}I(i){const a={},m=this.w();if(i.workspaces)for(const[I,D]of Object.entries(i.workspaces)){const O=R.URI.parse(D);a[I]=this.s.extUri.isEqual(O,m.location)?m.id:this.s.extUri.basename(O)}const P={};if(i.emptyWindows)for(const[I,D]of Object.entries(i.emptyWindows)){const O=R.URI.parse(D);P[I]=this.s.extUri.isEqual(O,m.location)?m.id:this.s.extUri.basename(O)}return{workspaces:a,emptyWindows:P}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};e.$sk=l,e.$sk=l=pe([x(0,f.$uh),x(1,u.$Qj),x(2,v.$nk),x(3,d.$Pi)],l);class s extends l{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.$tk=s}),define(te[82],ie([0,1,8,17,2,3,35,7,116,123,16,6,5,41,40,10,13,26]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(l){l.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",l.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class b extends Error{constructor(s,n){super(s),this.code=n}}e.$9o=b,e.$0o=(0,d.$nh)("IExtensionsProfileScannerService");let k=class extends r.$lb{constructor(s,n,i,a,m,P){super(),this.i=s,this.j=n,this.k=i,this.l=a,this.m=m,this.n=P,this.b=this.B(new M.$7c),this.onAddExtensions=this.b.event,this.c=this.B(new M.$7c),this.onDidAddExtensions=this.c.event,this.f=this.B(new M.$7c),this.onRemoveExtensions=this.f.event,this.g=this.B(new M.$7c),this.onDidRemoveExtensions=this.g.event,this.h=new R.$li}scanProfileExtensions(s,n){return this.p(s,void 0,n)}async addExtensionsToProfile(s,n){const i=[],a=[];try{return await this.p(n,m=>{const P=[];for(const I of m)s.some(([D])=>(0,u.$do)(D.identifier,I.identifier)&&D.manifest.version!==I.version)?i.push(I):P.push(I);for(const[I,D]of s)if(!P.some(O=>(0,u.$do)(O.identifier,I.identifier)&&O.version===I.manifest.version)){const O={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:D};a.push(O),P.push(O)}return a.length&&this.b.fire({extensions:a,profileLocation:n}),i.length&&this.f.fire({extensions:i,profileLocation:n}),P}),a.length&&this.c.fire({extensions:a,profileLocation:n}),i.length&&this.g.fire({extensions:i,profileLocation:n}),a}catch(m){throw a.length&&this.c.fire({extensions:a,error:m,profileLocation:n}),i.length&&this.g.fire({extensions:i,error:m,profileLocation:n}),m}}async updateMetadata(s,n){const i=[];return await this.p(n,a=>{const m=[];for(const P of a){const I=s.find(([D])=>(0,u.$do)(D.identifier,P.identifier)&&D.manifest.version===P.version);I&&(P.metadata={...P.metadata,...I[1]},i.push(P)),m.push(P)}return m}),i}async removeExtensionFromProfile(s,n){const i=[];this.f.fire({extensions:i,profileLocation:n});try{await this.p(n,a=>{const m=[];for(const P of a)(0,u.$do)(P.identifier,s.identifier)?i.push(P):m.push(P);return i.length&&this.f.fire({extensions:i,profileLocation:n}),m}),i.length&&this.g.fire({extensions:i,profileLocation:n})}catch(a){throw i.length&&this.g.fire({extensions:i,error:a,profileLocation:n}),a}}async p(s,n,i){return this.w(s).queue(async()=>{let a=[],m;try{const P=await this.j.readFile(s);m=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,$.$7j)(P)!==1)throw P;if(this.l.extUri.isEqual(s,this.k.defaultProfile.extensionsResource)&&(m=await this.v()),!m&&i?.bailOutWhenFileNotFound)throw new b((0,o.$9)(P),"ERROR_PROFILE_NOT_FOUND")}if(m){Array.isArray(m)||this.r(s);let P=!1;for(const I of m){w(I)||this.r(s);let D;if((0,y.$ie)(I.relativeLocation)&&I.relativeLocation)D=this.t(I.relativeLocation);else if((0,y.$ie)(I.location))D=this.t(I.location),P=!0,I.relativeLocation=I.location,I.location=D.toJSON();else{D=S.URI.revive(I.location);const O=this.s(D);O&&(P=!0,I.relativeLocation=O)}a.push({identifier:I.identifier,location:D,version:I.version,metadata:I.metadata})}P&&await this.j.writeFile(s,C.$Jb.fromString(JSON.stringify(m)))}if(n){a=n(a);const P=a.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.s(I.location),metadata:I.metadata}));await this.j.writeFile(s,C.$Jb.fromString(JSON.stringify(P)))}return a})}r(s){const n=new b(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(s){return this.l.extUri.isEqual(this.l.extUri.dirname(s),this.i)?this.l.extUri.basename(s):void 0}t(s){return this.l.extUri.joinPath(this.i,s)}async v(){return this.u||(this.u=(async()=>{const s=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let i;try{i=(await this.j.readFile(s)).value.toString()}catch(m){if((0,$.$7j)(m)===1)return;throw m}this.n.info("Migrating extensions from old default profile location",s.toString());let a;try{const m=JSON.parse(i);Array.isArray(m)&&m.every(P=>w(P))?a=m:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",m)}catch(m){this.n.error(m)}if(a)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,C.$Jb.fromString(JSON.stringify(a)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",s.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(m){if((0,$.$7j)(m)===3)this.n.info("Migration from old default profile location to new location is done by another window",s.toString(),this.k.defaultProfile.extensionsResource.toString());else throw m}try{await this.j.del(s)}catch(m){(0,$.$7j)(m)!==1&&this.n.error(m)}try{await this.j.del(n)}catch(m){(0,$.$7j)(m)!==1&&this.n.error(m)}return a})()),this.u}w(s){let n=this.h.get(s);return n||(n=new E.$Ag,this.h.set(s,n)),n}};e.$$o=k,e.$$o=k=pe([x(1,$.$Qj),x(2,h.$pk),x(3,v.$nk),x(4,g.$Tk),x(5,p.$Pi)],k);function w(l){return(0,y.$ke)(l)&&(0,f.$Mn)(l.identifier)&&(t(l.location)||(0,y.$ie)(l.location)&&l.location)&&((0,y.$pe)(l.relativeLocation)||(0,y.$ie)(l.relativeLocation))&&l.version&&(0,y.$ie)(l.version)}function t(l){return l?(0,y.$ie)(l.path)&&(0,y.$ie)(l.scheme):!1}}),define(te[129],ie([0,1,24,8,37,17,13,45,151,2,15,9,4,19,203,70,10,7,170,33,123,120,202,16,6,5,23,3,74,82,41,40,201]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.Translations=void 0;var L;(function(ue){function K(X,U){if(X===U)return!0;const W=Object.keys(X),T=new Set;for(const J of Object.keys(U))T.add(J);if(W.length!==T.size)return!1;for(const J of W){if(X[J]!==U[J])return!1;T.delete(J)}return T.size===0}ue.equals=K})(L||(e.Translations=L={})),e.$bp=(0,s.$nh)("IExtensionsScannerService");let N=class extends u.$lb{constructor(K,X,U,W,T,J,Z,ce,oe,j,A,F){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=X,this.l=U,this.m=W,this.n=T,this.r=J,this.s=Z,this.t=ce,this.u=oe,this.v=j,this.w=A,this.y=F,this.g=this.B(new a.$7c),this.onDidChangeCache=this.g.event,this.h=(0,h.$8f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ne,this.m,this.h)),this.j=this.B(this.y.createInstance(ne,this.m,this.h)),this.k=this.B(this.y.createInstance(re,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,k.$oo)(this.s,this.t)),this.z}async scanAllExtensions(K,X,U){const[W,T]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(X)]),J=U?await this.scanExtensionsUnderDevelopment(K,[...W,...T]):[];return this.G(W,T,J,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const X=[];X.push(this.H(!!K.useCache,K.language)),X.push(this.I(K.language,!!K.checkControlFile));const[U,W]=await Promise.all(X);return this.F([...U,...W],0,K,!1)}async scanUserExtensions(K){const X=K.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",X);const U=this.w.extUri.isEqual(K.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,W=await this.L(X,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,U),T=K.useCache&&!W.devMode&&W.excludeObsolete?this.j:this.k;let J;try{J=await T.scanExtensions(W)}catch(Z){if(Z instanceof P.$9o&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),J=await T.scanExtensions(W);else throw Z}return J=await this.F(J,1,K,!0),this.t.trace("Scanned user extensions:",J.length),J}async scanExtensionsUnderDevelopment(K,X){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const U=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(W=>W.scheme===$.Schemas.file).map(async W=>{const T=await this.L(W,!1,1,!0,K.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(T)).map(Z=>(Z.type=X.find(ce=>(0,k.$do)(ce.identifier,Z.identifier))?.type??Z.type,this.k.validate(Z,T)))}))).flat();return this.F(U,"development",K,!0)}return[]}async scanExistingExtension(K,X,U){const W=await this.L(K,!1,X,!0,U.language,!0,void 0),T=await this.k.scanExtension(W);return!T||!U.includeInvalid&&!T.isValid?null:T}async scanOneOrMultipleExtensions(K,X,U){const W=await this.L(K,!1,X,!0,U.language,!0,void 0),T=await this.k.scanOneOrMultipleExtensions(W);return this.F(T,X,U,!0)}async scanMetadata(K){const X=(0,h.$8f)(K,"package.json"),U=(await this.s.readFile(X)).value.toString();return JSON.parse(U).__metadata}async updateMetadata(K,X){const U=(0,h.$8f)(K,"package.json"),W=(await this.s.readFile(U)).value.toString(),T=JSON.parse(W);X.isMachineScoped=X.isMachineScoped||void 0,X.isBuiltin=X.isBuiltin||void 0,T.__metadata={...T.__metadata,...X},await this.s.writeFile((0,h.$8f)(K,"package.json"),M.$Jb.fromString(JSON.stringify(T,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof P.$9o&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw K}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.r.addExtensionsToProfile(K.map(X=>[X,X.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,M.$Jb.fromString(JSON.stringify([])))}catch(X){(0,l.$7j)(X)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.$9)(X))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.t.error(K)}finally{this.C=void 0}})()),this.C}async F(K,X,U,W){return U.includeAllVersions||(K=this.G(X===0?K:void 0,X===1?K:void 0,X==="development"?K:void 0,await this.getTargetPlatform(),W)),U.includeInvalid||(K=K.filter(T=>T.isValid)),K.sort((T,J)=>{const Z=d.$ec(T.location.fsPath),ce=d.$ec(J.location.fsPath);return Z<ce?-1:Z>ce?1:0})}G(K,X,U,W,T){const J=(ce,oe,j)=>{if(ce.isValid&&!oe.isValid)return!1;if(ce.isValid===oe.isValid){if(T&&v.gt(ce.manifest.version,oe.manifest.version))return this.t.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if(v.eq(ce.manifest.version,oe.manifest.version)){if(ce.type===0)return this.t.debug(`Skipping extension ${oe.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===W)return this.t.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return j?this.t.warn(`Overwriting user extension ${ce.location.path} with ${oe.location.path}.`):this.t.debug(`Overwriting user extension ${ce.location.path} with ${oe.location.path}.`),!0},Z=new w.$Hl;return K?.forEach(ce=>{const oe=Z.get(ce.identifier.id);(!oe||J(oe,ce,!1))&&Z.set(ce.identifier.id,ce)}),X?.forEach(ce=>{const oe=Z.get(ce.identifier.id);if(!oe&&K&&ce.type===0){this.t.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!oe||J(oe,ce,!1))&&Z.set(ce.identifier.id,ce)}),U?.forEach(ce=>{const oe=Z.get(ce.identifier.id);(!oe||J(oe,ce,!0))&&Z.set(ce.identifier.id,ce),Z.set(ce.identifier.id,ce)}),[...Z.values()]}async H(K,X){this.t.trace("Started scanning system extensions");const U=await this.L(this.systemExtensionsLocation,!1,0,!0,X,!0,void 0),T=await(K&&!U.devMode?this.i:this.k).scanExtensions(U);return this.t.trace("Scanned system extensions:",T.length),T}async I(K,X){const U=this.u.isBuilt?[]:this.v.builtInExtensions;if(!U?.length)return[];this.t.trace("Started scanning dev system extensions");const W=X?await this.J():{},T=[],J=g.URI.file(d.$$b(d.$ac($.$3e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of U){const oe=W[ce.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":T.push((0,h.$8f)(J,ce.name));break;default:T.push(g.URI.file(oe));break}}const Z=await Promise.all(T.map(async ce=>this.k.scanExtension(await this.L(ce,!1,0,!0,K,!0,void 0))));return this.t.trace("Scanned dev system extensions:",Z.length),(0,E.$lf)(Z)}async J(){try{const K=await this.s.readFile(this.l);return JSON.parse(K.value.toString())}catch{return{}}}async L(K,X,U,W,T,J,Z){const ce=await this.f(T??p.$v),oe=await this.M(K),j=X&&!this.w.extUri.isEqual(K,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,A=j?await this.M(j):void 0;return new q(K,oe,j,A,X,Z,U,W,J,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,T,ce)}async M(K){try{const X=await this.s.stat(K);if(typeof X.mtime=="number")return X.mtime}catch{}}};e.$cp=N,e.$cp=N=pe([x(4,I.$pk),x(5,P.$0o),x(6,l.$Qj),x(7,n.$Pi),x(8,b.$uh),x(9,i.$8i),x(10,D.$nk),x(11,s.$mh)],N);class q{constructor(K,X,U,W,T,J,Z,ce,oe,j,A,F,H,V,z){this.location=K,this.mtime=X,this.applicationExtensionslocation=U,this.applicationExtensionslocationMtime=W,this.profile=T,this.profileScanOptions=J,this.type=Z,this.excludeObsolete=ce,this.validate=oe,this.productVersion=j,this.productDate=A,this.productCommit=F,this.devMode=H,this.language=V,this.translations=z}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,X){return(0,h.$1f)(K.location,X.location)&&K.mtime===X.mtime&&(0,h.$1f)(K.applicationExtensionslocation,X.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===X.applicationExtensionslocationMtime&&K.profile===X.profile&&r.$Jm(K.profileScanOptions,X.profileScanOptions)&&K.type===X.type&&K.excludeObsolete===X.excludeObsolete&&K.validate===X.validate&&K.productVersion===X.productVersion&&K.productDate===X.productDate&&K.productCommit===X.productCommit&&K.devMode===X.devMode&&K.language===X.language&&L.equals(K.translations,X.translations)}}e.$dp=q;let re=class extends u.$lb{constructor(K,X,U,W,T){super(),this.f=K,this.g=X,this.h=U,this.i=W,this.j=T}async scanExtensions(K){const X=K.profile?await this.l(K):await this.k(K);let U={};if(K.excludeObsolete&&K.type===1)try{const W=(await this.i.readFile(this.f)).value.toString();U=JSON.parse(W)}catch{}return(0,o.$ve)(U)?X:X.filter(W=>!U[k.$eo.create(W).toString()])}async k(K){const X=await this.i.resolve(K.location);if(!X.children?.length)return[];const U=await Promise.all(X.children.map(async W=>{if(!W.isDirectory||K.type===1&&(0,h.$5f)(W.resource).indexOf(".")===0)return null;const T=new q(W.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(T)}));return(0,E.$lf)(U).sort((W,T)=>W.location.path<T.location.path?-1:1)}async l(K){let X=await this.m(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){X=X.filter(W=>!W.metadata?.isApplicationScoped);const U=await this.m(K.applicationExtensionslocation,W=>!!W.metadata?.isBuiltin||!!W.metadata?.isApplicationScoped,K);X.push(...U)}return X}async m(K,X,U){const W=await this.g.scanProfileExtensions(K,U.profileScanOptions);if(!W.length)return[];const T=await Promise.all(W.map(async J=>{if(X(J)){const Z=new q(J.location,U.mtime,U.applicationExtensionslocation,U.applicationExtensionslocationMtime,U.profile,U.profileScanOptions,U.type,U.excludeObsolete,U.validate,U.productVersion,U.productDate,U.productCommit,U.devMode,U.language,U.translations);return this.scanExtension(Z,J.metadata)}return null}));return(0,E.$lf)(T)}async scanOneOrMultipleExtensions(K){try{if(await this.i.exists((0,h.$8f)(K.location,"package.json"))){const X=await this.scanExtension(K);return X?[X]:[]}else return await this.scanExtensions(K)}catch(X){return this.j.error(`Error scanning extensions at ${K.location.path}:`,(0,R.$9)(X)),[]}}async scanExtension(K,X){try{let U=await this.scanExtensionManifest(K.location);if(U){U.publisher||(U.publisher=w.$Bl),X=X??U.__metadata,delete U.__metadata;const W=(0,k.$io)(U.publisher,U.name),T=X?.id?{id:W,uuid:X.id}:{id:W},J=X?.isSystem?0:K.type,Z=J===0||!!X?.isBuiltin;U=await this.n(K.location,U,q.createNlsConfiguration(K));const ce={type:J,identifier:T,manifest:U,location:K.location,isBuiltin:Z,targetPlatform:X?.targetPlatform??"undefined",metadata:X,isValid:!0,validations:[]};return K.validate?this.validate(ce,K):ce}}catch(U){K.type!==0&&this.j.error(U)}return null}validate(K,X){let U=!0;const W=(0,t.$to)(X.productVersion,X.productDate,X.location,K.manifest,K.isBuiltin);for(const[T,J]of W)T===y.default.Error&&(U=!1,this.j.error(this.u(X.location,J)));return K.isValid=U,K.validations=W,K}async scanExtensionManifest(K){const X=(0,h.$8f)(K,"package.json");let U;try{U=(await this.i.readFile(X)).value.toString()}catch(T){return(0,l.$7j)(T)!==1&&this.j.error(this.u(K,(0,c.localize)(0,null,X.path,T.message))),null}let W;try{W=JSON.parse(U)}catch{const J=[];(0,S.$vm)(U,J);for(const Z of J)this.j.error(this.u(K,(0,c.localize)(1,null,X.path,Z.offset,Z.length,(0,f.$_o)(Z.error))));return null}return(0,S.$Em)(W)!=="object"?(this.j.error(this.u(K,(0,c.localize)(2,null,X.path))),null):W}async n(K,X,U){const W=await this.r(K,X,U);if(W)try{const T=[],J=await this.s(W.default,T);if(T.length>0)return T.forEach(ce=>{this.j.error(this.u(K,(0,c.localize)(3,null,W.default?.path,(0,f.$_o)(ce.error))))}),X;if((0,S.$Em)(W)!=="object")return this.j.error(this.u(K,(0,c.localize)(4,null,W.default?.path))),X;const Z=W.values||Object.create(null);return(0,O.$ap)(X,Z,J)}catch{}return X}async r(K,X,U){const W=(0,h.$8f)(K,"package.nls.json"),T=(oe,j)=>{j.forEach(A=>{this.j.error(this.u(K,(0,c.localize)(5,null,oe?.path,(0,f.$_o)(A.error))))})},J=oe=>{this.j.error(this.u(K,(0,c.localize)(6,null,oe?.path)))},Z=`${X.publisher}.${X.name}`,ce=U.translations[Z];if(ce)try{const oe=g.URI.file(ce),j=(await this.i.readFile(oe)).value.toString(),A=[],F=(0,S.$vm)(j,A);return A.length>0?(T(oe,A),{values:void 0,default:W}):(0,S.$Em)(F)!=="object"?(J(oe),{values:void 0,default:W}):{values:F.contents?F.contents.package:void 0,default:W}}catch{return{values:void 0,default:W}}else{if(!await this.i.exists(W))return;let j;try{j=await this.t(K,U)}catch{return}if(!j.localized)return{values:void 0,default:j.original};try{const A=(await this.i.readFile(j.localized)).value.toString(),F=[],H=(0,S.$vm)(A,F);return F.length>0?(T(j.localized,F),{values:void 0,default:j.original}):(0,S.$Em)(H)!=="object"?(J(j.localized),{values:void 0,default:j.original}):{values:H,default:j.original}}catch{return{values:void 0,default:j.original}}}}async s(K,X){if(K)try{const U=(await this.i.readFile(K)).value.toString();return(0,S.$vm)(U,X)}catch{}}t(K,X){return new Promise((U,W)=>{const T=J=>{const Z=(0,h.$8f)(K,`package.nls.${J}.json`);this.i.exists(Z).then(ce=>{ce&&U({localized:Z,original:(0,h.$8f)(K,"package.nls.json")});const oe=J.lastIndexOf("-");oe===-1?U({localized:(0,h.$8f)(K,"package.nls.json"),original:null}):(J=J.substring(0,oe),T(J))})};if(X.devMode||X.pseudo||!X.language)return U({localized:(0,h.$8f)(K,"package.nls.json"),original:null});T(X.language)})}u(K,X){return`[${K.path}]: ${X}`}};re=pe([x(1,P.$0o),x(2,D.$nk),x(3,l.$Qj),x(4,n.$Pi)],re);let ne=class extends re{constructor(K,X,U,W,T,J,Z){super(X,W,T,J,Z),this.z=K,this.C=U,this.w=this.B(new C.$rg(3e3)),this.y=this.B(new a.$7c),this.onDidChangeCache=this.y.event}async scanExtensions(K){const X=this.H(K),U=await this.D(X);if(this.v=K,U&&U.input&&q.equals(U.input,this.v))return this.j.debug("Using cached extensions scan result",K.location.toString()),this.w.trigger(()=>this.G()),U.result.map(T=>(T.location=g.URI.revive(T.location),T));const W=await super.scanExtensions(K);return await this.F(X,{input:K,result:W}),W}async D(K){try{const X=await this.i.readFile(K),U=JSON.parse(X.value.toString());return{result:U.result,input:(0,m.$Wg)(U.input)}}catch(X){this.j.debug("Error while reading the extension cache file:",K.path,(0,R.$9)(X))}return null}async F(K,X){try{await this.i.writeFile(K,M.$Jb.fromString(JSON.stringify(X)))}catch(U){this.j.debug("Error while writing the extension cache file:",K.path,(0,R.$9)(U))}}async G(){if(!this.v)return;const K=this.H(this.v),X=await this.D(K);if(!X)return;const U=X.result,W=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!r.$Jm(W,U))try{this.j.info("Invalidating Cache",U,W),await this.i.del(K),this.y.fire()}catch(T){this.j.error(T)}}H(K){const X=this.I(K);return this.h.extUri.joinPath(X.cacheHome,K.type===0?w.$Al:w.$zl)}I(K){return K.type===0?this.C.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.z.extensionsResource)?this.z:this.C.profiles.find(X=>this.h.extUri.isEqual(K.location,X.extensionsResource))??this.z:this.C.defaultProfile}};ne=pe([x(2,I.$pk),x(3,P.$0o),x(4,D.$nk),x(5,l.$Qj),x(6,n.$Pi)],ne);function ee(ue,K){const X=(0,k.$go)(ue.manifest.publisher,ue.manifest.name);return{id:X,identifier:new w.$Fl(X),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:K,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$ep=ee;class ae extends N{constructor(K,X,U,W,T,J,Z,ce,oe,j,A,F){super(K,X,(0,h.$8f)(U,".vscode-oss-dev","extensions","control.json"),W,T,J,Z,ce,oe,j,A,F),this.N=(async()=>{if(p.$y)try{const H=await this.s.readFile(g.URI.file(p.$y));return JSON.parse(H.value.toString())}catch{}return Object.create(null)})()}f(K){return this.N}}e.$fp=ae}),define(te[278],ie([0,1,5,41,40,26,82,16,33,7]),function(G,e,E,C,r,M,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=void 0;let $=class extends R.$$o{constructor(p,h,v,y,o,g){super(u.URI.file(p.extensionsPath),h,v,y,o,g)}};e.$VM=$,e.$VM=$=pe([x(0,f.$vh),x(1,S.$Qj),x(2,C.$pk),x(3,r.$nk),x(4,M.$Tk),x(5,E.$Pi)],$)}),define(te[279],ie([0,1,7,33,82,129,16,6,5,23,40,41]),function(G,e,E,C,r,M,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J4b=void 0;let p=class extends M.$fp{constructor(v,y,o,g,c,b,k,w){super(E.URI.file(c.builtinExtensionsPath),E.URI.file(c.extensionsPath),c.userHome,v.defaultProfile,v,y,o,g,c,b,k,w)}};e.$J4b=p,e.$J4b=p=pe([x(0,d.$pk),x(1,r.$0o),x(2,R.$Qj),x(3,f.$Pi),x(4,C.$vh),x(5,u.$8i),x(6,$.$nk),x(7,S.$mh)],p)}),define(te[280],ie([0,1,14,2,15,9,4,58,7,31,38,33,5,41]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y4b=void 0;let v=class extends C.$lb{constructor(o,g,c){super(),this.c=o,this.f=c,this.a=S.$th.forPaths(!R.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(o.appRoot),this.addValidFileRoot(o.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(o.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:o}=E.session;o.protocol.registerFileProtocol(r.Schemas.vscodeFileResource,(g,c)=>this.i(g,c)),o.protocol.interceptFileProtocol(r.Schemas.file,(g,c)=>this.h(g,c)),this.B((0,C.$jb)(()=>{o.protocol.unregisterProtocol(r.Schemas.vscodeFileResource),o.protocol.uninterceptProtocol(r.Schemas.file)}))}addValidFileRoot(o){const g=(0,M.$$b)(o);return this.a.get(g)?C.$lb.None:(this.a.set(g,!0),(0,C.$jb)(()=>this.a.delete(g)))}h(o,g){const c=f.URI.parse(o.url);return this.f.error(`Refused to load resource ${c.fsPath} from ${r.Schemas.file}: protocol (original URL: ${o.url})`),g({error:-3})}i(o,g){const c=this.j(o);let b;return this.c.crossOriginIsolated&&((0,M.$ec)(c)==="workbench.html"||(0,M.$ec)(c)==="workbench-dev.html"?b=r.COI.CoopAndCoep:b=r.COI.getHeadersFromQuery(o.url)),this.a.findSubstr(c)?g({path:c,headers:b}):this.b.has((0,M.$fc)(c).toLowerCase())?g({path:c}):(this.f.error(`${r.Schemas.vscodeFileResource}: Refused to load resource ${c} from ${r.Schemas.vscodeFileResource}: protocol (original URL: ${o.url})`),g({error:-3}))}j(o){const g=f.URI.parse(o.url),c=r.$3e.uriToFileUri(g);return(0,M.$$b)(c.fsPath)}createIPCObjectUrl(){let o;const g=f.URI.from({scheme:"vscode",path:(0,u.$5e)()}),c=g.toString(),b=async()=>o;return $.$jS.handle(c,b),this.f.trace(`IPC Object URL: Registered new channel ${c}.`),{resource:g,update:k=>o=k,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${c}.`),$.$jS.removeHandler(c)}}}};e.$Y4b=v,e.$Y4b=v=pe([x(0,d.$vh),x(1,h.$pk),x(2,p.$Pi)],v)}),define(te[97],ie([0,1,8,3,2,65,10,111,6,41]),function(G,e,E,C,r,M,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Io=e.$Ho=e.$Go=void 0,e.$Go="__$__isNewStorageMarker",e.$Ho="__$__targetStorageMarker",e.$Io=(0,f.$nh)("storageService");var $;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})($||(e.WillSaveStateReason=$={}));var d;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(d||(e.StorageScope=d={}));var p;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function h(c){const b=c.get(e.$Ho);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.$Jo=h;class v extends r.$lb{static{this.a=60*1e3}constructor(b={flushInterval:v.a}){super(),this.j=b,this.b=this.B(new C.$0c),this.onDidChangeValue=this.b.event,this.c=this.B(new C.$0c),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$7c),this.onWillSaveState=this.f.event,this.h=this.B(new E.$Eg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new r.$mb),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.$Ig)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,r.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.J()}finally{(0,M.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(b,k){const{key:w,external:t}=k;if(w===e.$Ho){switch(b){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:w,target:this.F(b)[w],external:t})}r(b){this.f.fire({reason:b})}get(b,k,w){return this.L(k)?.get(b,w)}getBoolean(b,k,w){return this.L(k)?.getBoolean(b,w)}getNumber(b,k,w){return this.L(k)?.getNumber(b,w)}getObject(b,k,w){return this.L(k)?.getObject(b,w)}storeAll(b,k){this.t(()=>{for(const w of b)this.store(w.key,w.value,w.scope,w.target,k)})}store(b,k,w,t,l=!1){if((0,R.$re)(k)){this.remove(b,w,l);return}this.t(()=>{this.u(b,w,t),this.L(w)?.set(b,k,l)})}remove(b,k,w=!1){this.t(()=>{this.u(b,k,void 0),this.L(k)?.delete(b,w)})}t(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,k){const w=[],t=this.F(b);for(const l of Object.keys(t))t[l]===k&&w.push(l);return w}u(b,k,w,t=!1){const l=this.F(k);typeof w=="number"?l[b]!==w&&(l[b]=w,this.L(k)?.set(e.$Ho,JSON.stringify(l),t)):typeof l[b]=="number"&&(delete l[b],this.L(k)?.set(e.$Ho,JSON.stringify(l),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(b){switch(b){case-1:return this.D;case 0:return this.z;default:return this.w}}G(b){const k=this.L(b);return k?h(k):Object.create(null)}isNew(b){return this.getBoolean(e.$Go,b)===!0}async flush(b=$.NONE){this.f.fire({reason:b});const k=this.L(-1),w=this.L(0),t=this.L(1);switch(b){case $.NONE:await E.Promises.settled([k?.whenFlushed()??Promise.resolve(),w?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case $.SHUTDOWN:await E.Promises.settled([k?.flush(0)??Promise.resolve(),w?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.L(-1)?.items??new Map,k=this.L(0)?.items??new Map,w=this.L(1)?.items??new Map;return g(b,k,w,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(b,k){return this.r($.NONE),(0,u.$ok)(b)?this.N(b,k):this.O(b,k)}H(b,k){return!(b.id===k.id||y(k)&&y(b))}I(b,k,w){this.t(()=>{const t=new Set;for(const[l,s]of b)t.add(l),k.get(l)!==s&&this.n(w,{key:l,external:!0});for(const[l]of k.items)t.has(l)||this.n(w,{key:l,external:!0})})}}e.$Ko=v;function y(c){return c.isDefault||!!c.useDefaultFlags?.globalState}e.$Lo=y;class o extends v{constructor(){super(),this.p=this.B(new S.$Eo(new S.$Fo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new S.$Eo(new S.$Fo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new S.$Eo(new S.$Fo,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(b=>this.n(1,b))),this.B(this.P.onDidChangeStorage(b=>this.n(0,b))),this.B(this.p.onDidChangeStorage(b=>this.n(-1,b)))}L(b){switch(b){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(b){return!1}}e.$Mo=o;async function g(c,b,k,w,t,l){const s=L=>{try{return JSON.parse(L)}catch{return L}},n=new Map,i=new Map;c.forEach((L,N)=>{n.set(N,L),i.set(N,s(L))});const a=new Map,m=new Map;b.forEach((L,N)=>{a.set(N,L),m.set(N,s(L))});const P=new Map,I=new Map;k.forEach((L,N)=>{P.set(N,L),I.set(N,s(L))}),console.group(w!==t?`Storage: Application (path: ${w})`:`Storage: Application & Profile (path: ${w}, default profile)`);const D=[];if(n.forEach((L,N)=>{D.push({key:N,value:L})}),console.table(D),console.groupEnd(),console.log(i),w!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];a.forEach((N,q)=>{L.push({key:q,value:N})}),console.table(L),console.groupEnd(),console.log(m)}console.group(`Storage: Workspace (path: ${l})`);const O=[];P.forEach((L,N)=>{O.push({key:N,value:L})}),console.table(O),console.groupEnd(),console.log(I)}e.$No=g}),define(te[281],ie([0,1,24,8,3,2,9,69,7,22,111,159,5,97,26,30]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f3b=e.$e3b=e.$d3b=e.$c3b=void 0;class o extends M.$lb{static{this.a=2e3}get storage(){return this.f}constructor(l,s){super(),this.j=l,this.k=s,this.b=this.B(new r.$7c),this.onDidChangeStorage=this.b.event,this.c=this.B(new r.$7c),this.onDidCloseStorage=this.c.event,this.f=new $.$Eo(new $.$Fo,{hint:$.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new C.$Ng,this.whenInit=this.h.p,this.i=$.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===$.StorageState.None)try{const l=await this.n();this.f.dispose(),this.f=l,this.B(l.onDidChangeStorage(n=>this.b.fire(n))),await this.m(l);const s=l.getBoolean(h.$Go);s===void 0?l.set(h.$Go,!0):s&&l.set(h.$Go,!1)}catch(l){this.j.error(`[storage main] initialize(): Unable to init storage due to ${l}`)}finally{this.i=$.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===p.LogLevel.Trace?l=>this.j.trace(l):void 0,logError:l=>this.j.error(l)}}m(l){return l.init()}get items(){return this.f.items}get(l,s){return this.f.get(l,s)}set(l,s){return this.f.set(l,s)}delete(l){return this.f.delete(l)}async close(){const l=new S.$3c(!1);await this.s(),l.stop(),l.elapsed()>o.a&&await this.r(l),this.c.fire()}async r(l){if(this.path)try{const s=(0,E.top)(Array.from(this.f.items.entries()).map(([i,a])=>({key:i,length:a.length})),(i,a)=>a.length-i.length,5).map(i=>`${i.key}:${i.length}`).join(", "),n=(await this.k.stat(f.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${l.elapsed()}ms, DB size: ${n}b, Large Keys: ${s}`)}catch(s){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",s)}}async s(){this.g&&await this.g,this.i=$.StorageState.Closed,await this.f.close()}}class g extends o{static{this.t="state.vscdb"}get path(){if(!this.v.useInMemoryStorage)return(0,R.$ac)(this.u.globalStorageHome.fsPath,g.t)}constructor(l,s,n,i){super(n,i),this.u=l,this.v=s}async n(){return new $.$Eo(new d.$PS(this.path??d.$PS.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:$.StorageHint.STORAGE_IN_MEMORY})}}class c extends g{constructor(l,s,n,i){super(l,s,n,i)}}e.$c3b=c;class b extends g{constructor(l,s,n,i){super(s.defaultProfile,l,n,i)}async m(l){await super.m(l),this.z(l)}z(l){l.get(v.$Wk,void 0)===void 0&&l.set(v.$Wk,new Date().toUTCString());const n=l.get(v.$Vk,void 0),i=new Date().toUTCString();l.set(v.$Xk,typeof n>"u"?null:n),l.set(v.$Vk,i)}}e.$d3b=b;class k extends o{static{this.t="state.vscdb"}static{this.u="workspace.json"}get path(){if(!this.w.useInMemoryStorage)return(0,R.$ac)(this.y.workspaceStorageHome.fsPath,this.v.id,k.t)}constructor(l,s,n,i,a){super(n,a),this.v=l,this.w=s,this.y=i}async n(){const{storageFilePath:l,wasCreated:s}=await this.C();return new $.$Eo(new d.$PS(l,{logging:this.l()}),{hint:this.w.useInMemoryStorage?$.StorageHint.STORAGE_IN_MEMORY:s?$.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:d.$PS.IN_MEMORY_PATH,wasCreated:!0};const l=(0,R.$ac)(this.y.workspaceStorageHome.fsPath,this.v.id),s=(0,R.$ac)(l,k.t);return await u.Promises.exists(l)?{storageFilePath:s,wasCreated:!1}:(await u.Promises.mkdir(l,{recursive:!0}),this.D(l),{storageFilePath:s,wasCreated:!0})}async D(l){let s;if((0,y.$xh)(this.v)?s={folder:this.v.uri.toString()}:(0,y.$Ch)(this.v)&&(s={workspace:this.v.configPath.toString()}),s)try{const n=(0,R.$ac)(l,k.u);await u.Promises.exists(n)||await u.Promises.writeFile(n,JSON.stringify(s,void 0,2))}catch(n){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$e3b=k;class w extends o{get path(){}async n(){return new $.$Eo(new $.$Fo,{hint:$.StorageHint.STORAGE_IN_MEMORY})}}e.$f3b=w}),define(te[282],ie([0,1,3,2,97]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L4b=void 0;class M extends C.$lb{constructor(S,f,u){super(),this.b=S,this.c=f,this.f=u;const $=this.B(new C.$mb);this.a=this.B(new E.$7c({onWillAddFirstListener:()=>$.value=this.g(),onDidRemoveLastListener:()=>$.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new C.$kb;return S.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,u)=>(f?f.push(u.key):f=[u.key],f),100)(f=>this.h(f))),S.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(f,u)=>{f||(f=new Map);let $=f.get(u.profile.id);return $||f.set(u.profile.id,$={profile:u.profile,keys:[],storage:u.storage}),$.keys.push(u.key),f},100)(f=>this.i(f))),S}h(S){const f=S.includes(r.$Ho)?[this.c.defaultProfile]:[],u=[];if(S=S.filter($=>$!==r.$Ho),S.length){const $=(0,r.$Jo)(this.b.applicationStorage.storage);u.push({profile:this.c.defaultProfile,changes:S.map(d=>({key:d,scope:0,target:$[d]}))})}this.j(f,u)}i(S){const f=[],u=new Map;for(const[$,d]of S.entries()){d.keys.includes(r.$Ho)&&f.push(d.profile);const p=d.keys.filter(h=>h!==r.$Ho);if(p.length){const h=(0,r.$Jo)(d.storage.storage);u.set($,{profile:d.profile,changes:p.map(v=>({key:v,scope:0,target:h[v]}))})}}this.j(f,[...u.values()])}j(S,f){(S.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:S})}listen(S,f,u){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(S,f){throw new Error(`Call not found: ${f}`)}}e.$L4b=M}),define(te[283],ie([0,1,7,33,16,5,34,40,41,10,121]),function(G,e,E,C,r,M,R,S,f,u,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=void 0;let d=class ft extends f.$sk{static{this.a="profileAssociationsMigration"}constructor(y,o,g,c,b){super(g,c,o,b),this.P=y,this.Q=g}J(){return this.P.getItem(ft.b,[]).map(o=>({...o,location:(0,u.$ie)(o.location)?this.s.extUri.joinPath(this.profilesHome,o.location):E.URI.revive(o.location)}))}M(){const y=this.P.getItem(ft.c,{});return this.P.getItem(ft.a,!1)?y:this.I(y)}O(){return this.s.extUri.joinPath(E.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$SM=d,e.$SM=d=pe([x(0,R.$NM),x(1,S.$nk),x(2,C.$vh),x(3,r.$Qj),x(4,M.$Pi)],d);let p=class rt extends d{constructor(y,o,g,c,b){super(y,o,g,c,b),this.W=y}L(y){y.length?this.W.setItem(rt.b,y.map(o=>({...o,location:this.s.extUri.basename(o.location)}))):this.W.removeItem(rt.b)}J(){const y=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(y),this.W.setItem("userDataProfilesMigration",!0)),y}N(y){y.emptyWindows||y.workspaces?this.W.setItem(rt.c,y):this.W.removeItem(rt.c)}M(){const y="workspaceAndProfileInfo",o=this.W.getItem(y,void 0);if(o){this.W.removeItem(y);const c=o.reduce((b,{workspace:k,profile:w})=>(b[E.URI.revive(k).toString()]=E.URI.revive(w).toString(),b),{});this.W.setItem(rt.c,{workspaces:c})}const g=super.M();return this.W.getItem(rt.a,!1)||(this.N(g),this.W.setItem(rt.a,!0)),g}};e.$TM=p,e.$TM=p=pe([x(0,R.$OM),x(1,S.$nk),x(2,C.$vh),x(3,r.$Qj),x(4,M.$Pi)],p);let h=class extends p{constructor(y,o,g,c){super(new $.$RM(0,o,c,g),y,o,g,c)}async init(){return await this.W.init(),super.init()}};e.$UM=h,e.$UM=h=pe([x(0,S.$nk),x(1,C.$vh),x(2,r.$Qj),x(3,M.$Pi)],h)}),define(te[53],ie([0,1,33,16,6,5,40,41,283,34]),function(G,e,E,C,r,M,R,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h3b=e.$g3b=void 0,e.$g3b=(0,r.$oh)(S.$pk);let $=class extends f.$TM{constructor(p,h,v,y,o){super(p,h,v,y,o)}getAssociatedEmptyWindows(){const p=[];for(const h of this.v.emptyWindows.keys())p.push({id:h});return p}};e.$h3b=$,e.$h3b=$=pe([x(0,u.$OM),x(1,R.$nk),x(2,E.$vh),x(3,C.$Qj),x(4,M.$Pi)],$)}),define(te[130],ie([0,1,19,7,30]),function(G,e,E,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C3b=e.$B3b=e.$A3b=void 0;async function M(f,u,$){for(const p of f){const h=p.openedWorkspace;if((0,r.$Ch)(h)){const v=await $(h);if(v){if(v.folders.some(y=>E.$Yf.isEqualOrParent(u,y.uri)))return p}else if(E.$Yf.isEqualOrParent(u,h.configPath))return p}}const d=f.filter(p=>(0,r.$xh)(p.openedWorkspace)&&E.$Yf.isEqualOrParent(u,p.openedWorkspace.uri));if(d.length)return d.sort((p,h)=>-(p.openedWorkspace.uri.path.length-h.openedWorkspace.uri.path.length))[0]}e.$A3b=M;function R(f,u){for(const $ of f)if((0,r.$Ch)($.openedWorkspace)&&E.$Yf.isEqual($.openedWorkspace.configPath,u)||(0,r.$xh)($.openedWorkspace)&&E.$Yf.isEqual($.openedWorkspace.uri,u))return $}e.$B3b=R;function S(f,u){const $=d=>u.some(p=>E.$Yf.isEqual(C.URI.file(p),C.URI.file(d)));for(const d of f)if(d.config?.extensionDevelopmentPath?.some(p=>$(p)))return d}e.$C3b=S}),define(te[98],ie([0,1,32,45,137,46,15,9,4,19,7,6,60,30]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jab=e.$Iab=e.$Hab=e.$Gab=e.$Fab=e.$Eab=e.$Dab=e.$Cab=e.$Bab=e.$Aab=void 0,e.$Aab=(0,d.$nh)("workspacesService");function v(I){return I.hasOwnProperty("workspace")}e.$Bab=v;function y(I){return I.hasOwnProperty("folderUri")}e.$Cab=y;function o(I){return I.hasOwnProperty("fileUri")}e.$Dab=o;function g(I){return c(I)||b(I)}e.$Eab=g;function c(I){const D=I;return typeof D?.path=="string"&&(!D.name||typeof D.name=="string")}function b(I){const D=I;return typeof D?.uri=="string"&&(!D.name||typeof D.name=="string")}function k(I,D,O,L,N){if(I.scheme!==L.scheme)return{name:O,uri:I.toString(!0)};let q=D?void 0:N.relativePath(L,I);if(q!==void 0)q.length===0?q=".":f.$i&&(q=w(q));else if(I.scheme===R.Schemas.file)q=I.fsPath,f.$i&&(q=w(q));else if(N.isEqualAuthority(I.authority,L.authority))q=I.path;else return{name:O,uri:I.toString(!0)};return{name:O,path:q}}e.$Fab=k;function w(I){return I=(0,M.$Yz)(I),(0,E.$Ge)(I)||(I=(0,E.$De)(I)),I}function t(I,D,O){const L=[],N=new Set,q=O.dirname(D);for(const re of I){let ne;if(c(re))re.path&&(ne=O.resolvePath(q,re.path));else if(b(re))try{ne=$.URI.parse(re.uri),ne.path[0]!==S.$0b.sep&&(ne=ne.with({path:S.$0b.sep+ne.path}))}catch(ee){console.warn(ee)}if(ne){const ee=O.getComparisonKey(ne);if(!N.has(ee)){N.add(ee);const ae=re.name||O.basenameOrAuthority(ne);L.push(new h.$Hh({uri:ne,name:ae,index:L.length},re))}}}return L}e.$Gab=t;function l(I,D,O,L,N){const q=s(D,I),re=N.dirname(D),ne=N.dirname(L),ee=[];for(const X of q.folders){const U=c(X)?N.resolvePath(re,X.path):$.URI.parse(X.uri);let W;O?W=!1:W=!c(X)||(0,S.$_b)(X.path),ee.push(k(U,W,X.name,ne,N))}const ae={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},ue=r.$6R(I,["folders"],ee,ae);let K=r.$9R(I,ue);return(0,u.$ag)(q.remoteAuthority,(0,p.$zk)(L))&&(K=r.$9R(K,r.$5R(K,["remoteAuthority"],ae))),K}e.$Hab=l;function s(I,D){const O=C.$vm(D);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(L=>g(L));else throw new Error(`${I} looks like an invalid workspace file.`);return O}function n(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function i(I){return typeof I.folderUri=="string"}function a(I){return typeof I.fileUri=="string"}function m(I,D){const O={workspaces:[],files:[]};if(I){const L=function(q,re){for(let ne=0;ne<q.length;ne++)try{re(q[ne],ne)}catch(ee){D.warn(`Error restoring recent entry ${JSON.stringify(q[ne])}: ${ee.toString()}. Skip entry.`)}},N=I;Array.isArray(N.entries)&&L(N.entries,q=>{const re=q.label,ne=q.remoteAuthority;n(q)?O.workspaces.push({label:re,remoteAuthority:ne,workspace:{id:q.workspace.id,configPath:$.URI.parse(q.workspace.configPath)}}):i(q)?O.workspaces.push({label:re,remoteAuthority:ne,folderUri:$.URI.parse(q.folderUri)}):a(q)&&O.files.push({label:re,remoteAuthority:ne,fileUri:$.URI.parse(q.fileUri)})})}return O}e.$Iab=m;function P(I){const D={entries:[]};for(const O of I.workspaces)y(O)?D.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):D.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of I.files)D.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return D}e.$Jab=P}),define(te[99],ie([0,1,72,15,4,19]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v3b=e.$u3b=e.$t3b=e.$s3b=void 0,e.$s3b=128/4;function R(u){function $(){let d=u.scheme===C.Schemas.file?(0,M.$Vf)(u):u.toString();return r.$k||(d=d.toLowerCase()),(0,E.createHash)("md5").update(d).digest("hex")}return{id:$(),configPath:u}}e.$t3b=R;function S(u,$){function d(){if(u.scheme!==C.Schemas.file)return(0,E.createHash)("md5").update(u.toString()).digest("hex");if(!$)return;let h;return r.$k?h=$.ino:r.$j?h=$.birthtime.getTime():r.$i&&(typeof $.birthtimeMs=="number"?h=Math.floor($.birthtimeMs):h=$.birthtime.getTime()),(0,E.createHash)("md5").update(u.fsPath).update(h?String(h):"").digest("hex")}const p=d();if(typeof p=="string")return{id:p,uri:u}}e.$u3b=S;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$v3b=f}),define(te[131],ie([0,1,72,88,27,284,17,13,3,2,9,4,31,43,109]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0;class y{traceSocketEvent(D,O){v.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,D,O)}constructor(D,O=""){this.f=!0,this.debugLabel=O,this.socket=D,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,S.$Y)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(D){const O=L=>{this.traceSocketEvent("read",L),D(R.$Jb.wrap(L))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(D){const O=L=>{D({type:0,hadError:L,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(D){const O=()=>{D()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(D){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",D),this.socket.write(D.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,S.$Y)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,S.$Y)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((D,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),D();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),D()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$ch=y;var o;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(o||(o={}));var g;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})(g||(g={}));class c extends u.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(D,O){this.socket.traceSocketEvent(D,O)}constructor(D,O,L,N){super(),this.f=this.B(new f.$7c),this.g=this.B(new f.$7c),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=D,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:L?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new b(this,O,L,N,this.f,(q,re)=>this.k(q,re))),this.B(this.a.onError(q=>{console.error(q),(0,S.$Y)(q),this.g.fire({type:0,hadError:!0,error:q})})),this.b=new v.$0g,this.B(this.socket.onData(q=>this.l(q))),this.B(this.socket.onClose(async q=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(q)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(D){return this.f.event(D)}onClose(D){return this.g.event(D)}onEnd(D){return this.socket.onEnd(D)}write(D){let O=0;for(;O<D.byteLength;)this.a.writeMessage(D.slice(O,Math.min(O+262144,D.byteLength))),O+=262144}k(D,O){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",D);let L=2;D.byteLength<126?L+=0:D.byteLength<2**16?L+=2:L+=8;const N=R.$Jb.alloc(L);if(O?N.writeUInt8(194,0):N.writeUInt8(130,0),D.byteLength<126)N.writeUInt8(D.byteLength,1);else if(D.byteLength<2**16){N.writeUInt8(126,1);let q=1;N.writeUInt8(D.byteLength>>>8&255,++q),N.writeUInt8(D.byteLength>>>0&255,++q)}else{N.writeUInt8(127,1);let q=1;N.writeUInt8(0,++q),N.writeUInt8(0,++q),N.writeUInt8(0,++q),N.writeUInt8(0,++q),N.writeUInt8(D.byteLength>>>24&255,++q),N.writeUInt8(D.byteLength>>>16&255,++q),N.writeUInt8(D.byteLength>>>8&255,++q),N.writeUInt8(D.byteLength>>>0&255,++q)}this.socket.write(R.$Jb.concat([N,D]))}end(){this.h=!0,this.socket.end()}l(D){if(D.byteLength!==0){for(this.b.acceptChunk(D);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),L=O.readUInt8(0),N=(L&128)>>>7,q=(L&64)>>>6,re=O.readUInt8(1),ne=(re&128)>>>7,ee=re&127;this.j.state=2,this.j.readLen=2+(ne?4:0)+(ee===126?2:0)+(ee===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!q),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),L=O.readUInt8(1),N=(L&128)>>>7;let q=L&127,re=1;q===126?q=O.readUInt8(++re)*2**8+O.readUInt8(++re):q===127&&(q=O.readUInt8(++re)*0+O.readUInt8(++re)*0+O.readUInt8(++re)*0+O.readUInt8(++re)*0+O.readUInt8(++re)*2**24+O.readUInt8(++re)*2**16+O.readUInt8(++re)*2**8+O.readUInt8(++re));let ne=0;N&&(ne=O.readUInt8(++re)*2**24+O.readUInt8(++re)*2**16+O.readUInt8(++re)*2**8+O.readUInt8(++re)),this.j.state=3,this.j.readLen=q,this.j.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(O,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$dh=c;class b extends u.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$Jb.alloc(0)}constructor(D,O,L,N,q,re){super(),this.l=D,this.m=q,this.n=re,this.a=this.B(new f.$7c),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$7c),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new f.$7c),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,O?(this.b=this.B(new k(this.l,N,L,{windowBits:15})),this.f=this.B(new w(this.l,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(D){this.g.push(D),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const D=this.g.shift();if(this.f){const O=await this.s(this.f,D);this.n(O,!0)}else this.n(D,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(D,O){return new Promise((L,N)=>{D.write(O),D.flush(q=>L(q))})}acceptFrame(D,O,L){this.h.push({data:D,isCompressed:O,isLastFrameOfMessage:L}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const D=this.h.shift();if(this.b&&D.isCompressed){const O=await this.w(this.b,D.data,D.isLastFrameOfMessage);this.m.fire(O)}else this.m.fire(D.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(D,O,L){return new Promise((N,q)=>{D.write(O),L&&D.write(R.$Jb.fromByteArray([0,0,255,255])),D.flush(re=>N(re))})}}class k extends u.$lb{get recordedInflateBytes(){return this.j?R.$Jb.concat(this.f):R.$Jb.alloc(0)}constructor(D,O,L,N){super(),this.h=D,this.j=O,this.a=this.B(new f.$7c),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,M.createInflateRaw)(N),this.b.on("error",q=>{this.h.traceSocketEvent("zlibInflateError",{message:q?.message,code:q?.code}),this.a.fire(q)}),this.b.on("data",q=>{this.h.traceSocketEvent("zlibInflateData",q),this.g.push(R.$Jb.wrap(q))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(D){this.j&&this.f.push(D.clone()),this.h.traceSocketEvent("zlibInflateWrite",D),this.b.write(D.buffer)}flush(D){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=R.$Jb.concat(this.g);this.g.length=0,D(O)})}}class w extends u.$lb{constructor(D,O){super(),this.g=D,this.a=this.B(new f.$7c),this.onError=this.a.event,this.f=[],this.b=(0,M.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(R.$Jb.wrap(L))})}write(D){this.g.traceSocketEvent("zlibDeflateWrite",D.buffer),this.b.write(D.buffer)}flush(D){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=R.$Jb.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),D(O)})}}function t(I,D){if(D===0)return;const O=I.byteLength>>>2;for(let ee=0;ee<O;ee++){const ae=I.readUInt32BE(ee*4);I.writeUInt32BE(ae^D,ee*4)}const L=O*4,N=I.byteLength-L,q=D>>>24&255,re=D>>>16&255,ne=D>>>8&255;N>=1&&I.writeUInt8(I.readUInt8(L)^q,L),N>=2&&I.writeUInt8(I.readUInt8(L+1)^re,L+1),N>=3&&I.writeUInt8(I.readUInt8(L+2)^ne,L+2)}e.$eh=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const I=(0,p.$5e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const D=process.platform!=="darwin"&&e.$eh?e.$eh:(0,r.tmpdir)(),O=(0,$.$ac)(D,`vscode-ipc-${I}.sock`);return i(O),O}e.$fh=s;function n(I,D,O){const L=(0,E.createHash)("md5").update(I).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${L}-${O}-${D}-sock`;const N=O.substr(0,4),q=D.substr(0,6),re=L.substr(0,8);let ne;return process.platform!=="darwin"&&e.$eh&&!process.env.VSCODE_PORTABLE?ne=(0,$.$ac)(e.$eh,`vscode-${re}-${N}-${q}.sock`):ne=(0,$.$ac)(I,`${N}-${q}.sock`),i(ne),ne}e.$gh=n;function i(I){const D=l[d.$t];typeof D=="number"&&I.length>=D&&console.warn(`WARNING: IPC handle "${I}" is longer than ${D} chars, try a shorter --user-data-dir`)}class a extends h.$4g{static b(D){const O=f.Event.fromNodeEventEmitter(D,"connection");return f.Event.map(O,L=>({protocol:new v.$$g(new y(L,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(L,"close"))}))}constructor(D){super(a.b(D)),this.d=D}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$hh=a;function m(I){return new Promise((D,O)=>{const L=(0,C.createServer)();L.on("error",O),L.listen(I,()=>{L.removeListener("error",O),D(new a(L))})})}e.$ih=m;function P(I,D){return new Promise((O,L)=>{const N=(0,C.createConnection)(I,()=>{N.removeListener("error",L),O(v.$_g.fromSocket(new y(N,`ipc-client${D}`),D))});N.once("error",L)})}e.$jh=P}),define(te[28],ie([0,1,55,9,4,131,33,90,6]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_2b=e.$$2b=void 0,e.$$2b=(0,f.$oh)(R.$uh);class u extends S.$Vl{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,C.$ac)(this.userDataPath,"clp")}get backupHome(){return(0,C.$ac)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,M.$gh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,C.$ac)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(r.$k){for(const d in process.env)if(d.endsWith("_VSCODE_SNAP_ORIG")){const p=d.slice(0,-17);if(this.d[p])continue;process.env[p]&&(this.d[p]=process.env[p]),process.env[d]?process.env[p]=process.env[d]:delete process.env[p]}}}restoreSnapExportedVariables(){if(r.$k)for(const d in this.d)process.env[d]=this.d[d],delete this.d[d]}}e.$_2b=u,pe([E.$Rg],u.prototype,"cachedLanguagesPath",null),pe([E.$Rg],u.prototype,"backupHome",null),pe([E.$Rg],u.prototype,"mainIPCHandle",null),pe([E.$Rg],u.prototype,"mainLockfile",null),pe([E.$Rg],u.prototype,"disableUpdates",null),pe([E.$Rg],u.prototype,"disableKeytar",null),pe([E.$Rg],u.prototype,"crossOriginIsolated",null),pe([E.$Rg],u.prototype,"codeCachePath",null),pe([E.$Rg],u.prototype,"useCodeCache",null)}),define(te[285],ie([0,1,72,32,15,9,4,19,22,194,18,28,34,16,5,193,30,99]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w3b=void 0;let c=class yt{static{this.a="backupWorkspaces"}constructor(k,w,t,l){this.j=k,this.k=w,this.l=t,this.m=l,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$Yf,this.i={isEqual:(s,n)=>(0,C.$Ie)(s,n,!R.$k)}}async initialize(){const k=this.m.getItem(yt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(k.emptyWindows),this.d=await this.u((0,u.$p3b)(k)),this.e=await this.v((0,u.$q3b)(k)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==h.$ck.OFF}q(){return this.s()===h.$ck.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||h.$ck.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(k,w){this.d.some(l=>k.workspace.id===l.workspace.id)||(this.d.push(k),this.C());const t=(0,M.$ac)(this.c,k.workspace.id);return w?this.t(t,w).then(()=>t):t}async t(k,w){if(await f.Promises.exists(k)&&await this.z(k),await f.Promises.exists(w))try{await f.Promises.rename(w,k)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(k){return this.e.some(w=>this.h.isEqual(k.folderUri,w.folderUri))||(this.e.push(k),this.C()),(0,M.$ac)(this.c,this.D(k))}registerEmptyWindowBackup(k){return this.g.some(w=>!!w.backupFolder&&this.i.isEqual(w.backupFolder,k.backupFolder))||(this.g.push(k),this.C()),(0,M.$ac)(this.c,k.backupFolder)}async u(k){if(!Array.isArray(k))return[];const w=new Set,t=[];for(const l of k){const s=l.workspace;if(!(0,o.$Ch)(s))return[];if(!w.has(s.id)){w.add(s.id);const n=(0,M.$ac)(this.c,s.id);await this.B(n)?s.configPath.scheme!==r.Schemas.file||await f.Promises.exists(s.configPath.fsPath)?t.push(l):await this.z(n):await this.x(n)}}return t}async v(k){if(!Array.isArray(k))return[];const w=[],t=new Set;for(const l of k){const s=l.folderUri,n=this.h.getComparisonKey(s);if(!t.has(n)){t.add(n);const i=(0,M.$ac)(this.c,this.D(l));await this.B(i)?s.scheme!==r.Schemas.file||await f.Promises.exists(s.fsPath)?w.push(l):await this.z(i):await this.x(i)}}return w}async w(k){if(!Array.isArray(k))return[];const w=[],t=new Set;for(const l of k){const s=l.backupFolder;if(typeof s!="string")return[];if(!t.has(s)){t.add(s);const n=(0,M.$ac)(this.c,s);await this.B(n)?w.push(l):await this.x(n)}}return w}async x(k){try{await f.Promises.rm(k,f.RimRafMode.MOVE)}catch(w){this.l.error(`Backup: Could not delete stale backup: ${w.toString()}`)}}y(){let k=(0,g.$v3b)();for(;this.g.some(w=>!!w.backupFolder&&this.i.isEqual(w.backupFolder,k.id));)k=(0,g.$v3b)();return{backupFolder:k.id}}async z(k){const w=this.y(),t=(0,M.$ac)(this.c,w.backupFolder);try{await f.Promises.rename(k,t)}catch(l){return this.l.error(`Backup: Could not rename backup folder: ${l.toString()}`),!1}return this.g.push(w),!0}async getDirtyWorkspaces(){const k=[];for(const w of this.d)await this.A(w)&&k.push(w);for(const w of this.e)await this.A(w)&&k.push(w);return k}A(k){let w;return(0,u.$o3b)(k)?w=(0,M.$ac)(this.c,k.backupFolder):(0,y.$yab)(k)?w=(0,M.$ac)(this.c,this.D(k)):w=(0,M.$ac)(this.c,k.workspace.id),this.B(w)}async B(k){try{const w=await f.Promises.readdir(k);for(const t of w)try{if((await f.Promises.readdir((0,M.$ac)(k,t))).length>0)return!0}catch{}}catch{}return!1}C(){const k={workspaces:this.d.map(({workspace:w,remoteAuthority:t})=>{const l={id:w.id,configURIPath:w.configPath.toString()};return t&&(l.remoteAuthority=t),l}),folders:this.e.map(({folderUri:w,remoteAuthority:t})=>{const l={folderUri:w.toString()};return t&&(l.remoteAuthority=t),l}),emptyWindows:this.g.map(({backupFolder:w,remoteAuthority:t})=>{const l={backupFolder:w};return t&&(l.remoteAuthority=t),l})};this.m.setItem(yt.a,k)}D(k){const w=k.folderUri;let t;return w.scheme===r.Schemas.file?t=R.$k?w.fsPath:w.fsPath.toLowerCase():t=w.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};e.$w3b=c,e.$w3b=c=pe([x(0,d.$$2b),x(1,$.$Th),x(2,v.$Pi),x(3,p.$OM)],c)}),define(te[20],ie([0,1,14,38,8,3,2,4,36,10,6,5,34,28]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b3b=e.LifecycleMainPhase=e.ShutdownReason=e.$a3b=void 0,e.$a3b=(0,$.$nh)("lifecycleMainService");var v;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(v||(e.ShutdownReason=v={}));var y;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(y||(e.LifecycleMainPhase=y={}));let o=class dt extends R.$lb{static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(c,b,k){super(),this.v=c,this.w=b,this.y=k,this.c=this.B(new M.$7c),this.onBeforeShutdown=this.c.event,this.f=this.B(new M.$7c),this.onWillShutdown=this.f.event,this.g=this.B(new M.$7c),this.onWillLoadWindow=this.g.event,this.h=this.B(new M.$7c),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(dt.b),this.j&&this.w.removeItem(dt.b)}C(){const c=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.n===0&&this.D(1))};E.app.addListener("before-quit",c);const b=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!S.$j)&&E.app.quit()};E.app.addListener("window-all-closed",b),E.app.once("will-quit",k=>{this.L("Lifecycle#app.on(will-quit) - begin"),k.preventDefault(),this.D(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),E.app.removeListener("before-quit",c),E.app.removeListener("window-all-closed",b),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}D(c){if(this.s)return this.s;const b=this.v;this.L("Lifecycle#onWillShutdown.fire()");const k=[];return this.f.fire({reason:c,join(w,t){b.trace(`Lifecycle#onWillShutdown - begin '${w}'`),k.push(t.finally(()=>{b.trace(`Lifecycle#onWillShutdown - end '${w}'`)}))}}),this.s=(async()=>{try{await r.Promises.settled(k)}catch(w){this.v.error(w)}try{await this.w.close()}catch(w){this.v.error(w)}})(),this.s}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===c)return;this.L(`lifecycle (main): phase changed (value: ${c})`),this.k=c;const b=this.u.get(this.k);b&&(b.open(),this.u.delete(this.k))}async when(c){if(c<=this.k)return;let b=this.u.get(c);b||(b=new r.$sg,this.u.set(c,b)),await b.wait()}registerWindow(c){const b=new R.$kb;this.n++,b.add(c.onWillLoad(w=>this.g.fire({window:c,workspace:w.workspace,reason:w.reason})));const k=(0,u.$te)(c.win);k.on("close",w=>{const t=c.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${c.id}`),w.preventDefault(),this.unload(c,1).then(l=>{if(l){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(c),c.close()})}),k.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.n--,b.dispose(),this.n===0&&(!S.$j||this.i)&&this.D(1)})}async reload(c,b){await this.unload(c,3)||c.reload(b)}unload(c,b){const k=this.t.get(c.id);if(k)return k;const w=this.F(c,b).finally(()=>{this.t.delete(c.id)});return this.t.set(c.id,w),w}async F(c,b){if(!c.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${c.id}`);const k=this.i?2:b,w=await this.I(c,k);return w?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.G(w)):(await this.J(c,k),!1)}G(c){return c?(this.H(!0),this.i=!1,!0):!1}H(c){this.r&&(this.r(c),this.r=void 0,this.p=void 0)}I(c,b){return new Promise(k=>{const w=this.m++,t=`vscode:ok${w}`,l=`vscode:cancel${w}`;C.$jS.once(t,()=>{k(!1)}),C.$jS.once(l,()=>{k(!0)}),c.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:l,reason:b})})}J(c,b){return new Promise(k=>{const t=`vscode:reply${this.m++}`;C.$jS.once(t,()=>k()),c.send("vscode:onWillUnload",{replyChannel:t,reason:b})})}quit(c){return this.L(`Lifecycle#quit() - begin (willRestart: ${c})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(c&&this.w.setItem(dt.b,!0),this.p=new Promise(b=>{this.r=b,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(c){this.y.args["enable-smoke-test-driver"]?this.v.info(c):this.v.trace(c)}async relaunch(c){this.L("Lifecycle#relaunch()");const b=process.argv.slice(1);if(c?.addArgs&&b.push(...c.addArgs),c?.removeArgs)for(const t of c.removeArgs){const l=b.indexOf(t);l>=0&&b.splice(l,1)}const k=()=>{try{if(S.$i){const t=(0,f.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:b})};E.app.once("quit",k),await this.quit(!0)&&E.app.removeListener("quit",k)}async kill(c){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,r.$ug)(1e3),(async()=>{for(const b of E.BrowserWindow.getAllWindows())if(b&&!b.isDestroyed()){let k;b.webContents&&!b.webContents.isDestroyed()?k=new Promise(w=>b.once("closed",w)):k=Promise.resolve(),b.destroy(),await k}})()]),E.app.exit(c)}};e.$b3b=o,e.$b3b=o=pe([x(0,d.$Pi),x(1,p.$OM),x(2,h.$$2b)],o)}),define(te[286],ie([0,1,4,3,2,6,20]),function(G,e,E,C,r,M,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$43b=e.$33b=void 0,e.$33b=(0,M.$nh)("keyboardLayoutMainService");let S=class extends r.$lb{constructor($){super(),this.a=this.B(new C.$7c),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,$.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const $=await new Promise((d,p)=>{G(["native-keymap"],d,p)});this.c=f($),E.$s||$.onDidChangeKeyboardLayout(()=>{this.c=f($),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$43b=S,e.$43b=S=pe([x(0,R.$a3b)],S);function f(u){const $=u.getKeyMap(),d=u.getCurrentKeyboardLayout();return{keyboardMapping:$,keyboardLayoutInfo:d}}}),define(te[287],ie([0,1,245,8,17,13,10,18,33,95,5,51,244,284]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0;let v=class extends d.$xo{constructor(c,b,k,w){super(w),this.j=c,this.k=b,this.l=k,this.m(),this.B(c.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const c=this.j.getValue("http");this.f=c?.proxy,this.g=!!c?.proxyStrictSSL,this.h=c?.proxyAuthorization}async request(c,b){const{f:k,g:w}=this;let t;try{t=await(0,u.$wl)(this.j,this.l,this.k.args,process.env)}catch(n){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,M.$9)(n)))}const l={...process.env,...t},s=c.agent?c.agent:await(0,p.$Aq)(c.url||"",l,{proxyUrl:k,strictSSL:w});return c.agent=s,c.strictSSL=w,this.h&&(c.headers={...c.headers||{},"Proxy-Authorization":this.h}),this.c(c.isChromiumNetwork?"electron":"node",c,()=>o(c,b))}async resolveProxy(c){}};e.$Bq=v,e.$Bq=v=pe([x(0,S.$Th),x(1,f.$vh),x(2,$.$Pi),x(3,$.$Qi)],v);async function y(g){return((0,E.parse)(g.url).protocol==="https:"?await new Promise((k,w)=>{G(["https"],k,w)}):await new Promise((k,w)=>{G(["http"],k,w)})).request}async function o(g,c){return C.Promises.withAsyncBody(async(b,k)=>{const w=(0,E.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await y(g),l={hostname:w.hostname,port:w.port?parseInt(w.port):w.protocol==="https:"?443:80,protocol:w.protocol,path:w.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,R.$oe)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(l.auth=g.user+":"+g.password);const s=t(l,n=>{const i=(0,R.$me)(g.followRedirects)?g.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)o({...g,url:n.headers.location,followRedirects:i-1},c).then(b,k);else{let a=n;!g.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(a=n.pipe((0,h.createGunzip)())),b({res:n,stream:(0,r.$Yb)(a)})}});s.on("error",k),g.timeout&&s.setTimeout(g.timeout),g.isChromiumNetwork&&s.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&s.write(g.data),s.end(),c.onCancellationRequested(()=>{s.abort(),k(new M.$3)})})}e.$Cq=o}),define(te[288],ie([0,1,14,287]),function(G,e,E,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$34b=void 0;function r(R){return E.net.request}class M extends C.$Bq{request(S,f){return super.request({...S||{},getRawRequest:r,isChromiumNetwork:!0},f)}}e.$34b=M}),define(te[83],ie([0,1,7,49,3,2,33,16,6,20,5,97,281,41,53,40]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l3b=e.$k3b=e.$j3b=e.$i3b=void 0,e.$i3b=(0,f.$nh)("storageMainService");let o=class extends M.$lb{constructor(b,k,w,t,l,s){super(),this.c=b,this.f=k,this.g=w,this.h=t,this.i=l,this.j=s,this.a=void 0,this.b=this.B(new r.$7c),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this.B(this.h.onWillShutdown(b=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=b.reason,b.join("applicationStorage",this.applicationStorage.close());for(const[,k]of this.n)b.join("profileStorage",k.close());for(const[,k]of this.r)b.join("workspaceStorage",k.close())})),this.B(this.g.onWillCreateProfile(b=>{b.join((async()=>{await this.i.exists(b.profile.globalStorageHome)||await this.i.createFolder(b.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(b=>{const k=this.n.get(b.profile.id);k&&b.join(k.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const b=new p.$d3b(this.k(),this.g,this.c,this.i);return(0,C.$cb)(b.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,d.$Lo)(b))return this.applicationStorage;let k=this.n.get(b.id);if(!k){this.c.trace(`StorageMainService: creating profile storage (${b.name})`),k=this.p(b),this.n.set(b.id,k);const w=this.B(k.onDidChangeStorage(t=>this.b.fire({...t,storage:k,profile:b})));(0,C.$cb)(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${b.name})`),this.n.delete(b.id),w.dispose()})}return k}p(b){return this.a===2?new p.$f3b(this.c,this.i):new p.$c3b(b,this.k(),this.c,this.i)}workspaceStorage(b){let k=this.r.get(b.id);return k||(this.c.trace(`StorageMainService: creating workspace storage (${b.id})`),k=this.s(b),this.r.set(b.id,k),(0,C.$cb)(k.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${b.id})`),this.r.delete(b.id)})),k}s(b){return this.a===2?new p.$f3b(this.c,this.i):new p.$e3b(b,this.k(),this.c,this.f,this.i)}isUsed(b){const k=E.URI.file(b);for(const w of[this.applicationStorage,...this.n.values(),...this.r.values()])if(w.path&&this.j.extUri.isEqualOrParent(E.URI.file(w.path),k))return!0;return!1}};e.$j3b=o,e.$j3b=o=pe([x(0,$.$Pi),x(1,R.$uh),x(2,v.$g3b),x(3,u.$a3b),x(4,S.$Qj),x(5,y.$nk)],o),e.$k3b=(0,f.$nh)("applicationStorageMainService");let g=class extends d.$Ko{constructor(b,k){super(),this.p=b,this.s=k,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(b){if(b===-1)return this.s.applicationStorage.storage}M(b){if(b===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$l3b=g,e.$l3b=g=pe([x(0,h.$pk),x(1,e.$i3b)],g)}),define(te[289],ie([0,1,14,21,3,57,2,10,31,76,115,5,23,83,29]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n3b=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let o=class extends R.$lb{constructor(c,b,k,w,t,l){super(),this.h=c,this.i=b,this.j=k,this.k=w,this.l=t,this.m=l,this.a=`${this.m.urlProtocol}.proxy-credentials`,this.b="proxy-credentials://",this.c=void 0,this.f=y.Initial,this.g=void 0,this.n()}n(){const c=r.Event.fromNodeEventEmitter(E.app,"login",(b,k,w,t,l)=>({event:b,webContents:k,req:w,authInfo:t,callback:l}));this.B(c(this.p,this))}async p({event:c,authInfo:b,req:k,callback:w}){if(!b.isProxy)return;if(!this.c&&this.f===y.LoginDialogShown&&k.firstAuthAttempt){this.h.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}c.preventDefault();let t;if(this.c)this.h.trace("auth#onLogin (proxy) - pending proxy handling found"),t=await this.c;else{this.h.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.c=this.r(b);try{t=await this.c}finally{this.c=void 0}}w(t?.username,t?.password)}async r(c){this.h.trace("auth#resolveProxyCredentials (proxy) - enter");try{const b=await this.t(c);if(b)return this.h.trace("auth#resolveProxyCredentials (proxy) - got credentials"),b;this.h.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.h.trace("auth#resolveProxyCredentials (proxy) - exit")}}async s(c){try{let b=this.l.get(this.b+c,-1),k;if(b||(b=(0,S.$Ae)(await this.j.getPassword(this.a,c)),b&&(k=await this.k.decrypt(b),b=await this.k.encrypt(k),this.l.store(this.b+c,b,-1,1),await this.j.deletePassword(this.a,c))),b){const w=JSON.parse(k??await this.k.decrypt(b));return{storedUsername:w.username,storedPassword:w.password}}}catch(b){this.h.error(b)}return{storedUsername:void 0,storedPassword:void 0}}async t(c){this.h.trace("auth#doResolveProxyCredentials - enter",c);const b=String((0,M.$bi)({scheme:c.scheme,host:c.host,port:c.port})),{storedUsername:k,storedPassword:w}=await this.s(b);if(this.f!==y.StoredCredentialsUsed&&typeof k=="string"&&typeof w=="string")return this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.f=y.StoredCredentialsUsed,{username:k,password:w};const t=this.i.getFocusedWindow()||this.i.getLastActiveWindow();if(!t){this.h.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.h.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${t.id} to handle proxy login`);const l={authInfo:c,username:this.g?.username??k,password:this.g?.password??w,replyChannel:`vscode:proxyAuthResponse:${(0,f.$5e)()}`};t.sendWhenReady("vscode:openProxyAuthenticationDialog",C.CancellationToken.None,l),this.f=y.LoginDialogShown;const s=await new Promise(n=>{const i=async(a,m,P)=>{if(m===l.replyChannel)if(this.h.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${t.id}`),t.win?.webContents.off("ipc-message",i),P){const I={username:P.username,password:P.password};try{if(P.remember){const D=await this.k.encrypt(JSON.stringify(I));this.l.store(this.b+b,D,-1,1)}else this.l.remove(this.b+b,-1)}catch(D){this.h.error(D)}n({username:I.username,password:I.password})}else n(void 0)};t.win?.webContents.on("ipc-message",i)});return this.g=s,s}};e.$n3b=o,e.$n3b=o=pe([x(0,d.$Pi),x(1,v.$m3b),x(2,u.$ln),x(3,$.$hqb),x(4,h.$k3b),x(5,p.$8i)],o)}),define(te[100],ie([0,1,8,21,3,18,28,20,5,23,51,48]),function(G,e,E,C,r,M,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n4b=e.$m4b=void 0;function p(v,y,o){return`${o.updateUrl}/api/update/${v}/${y}/${o.commit}`}e.$m4b=p;let h=class{get state(){return this.b}d(y){this.j.info("update#setState",y.type),this.b=y,this.c.fire(y)}constructor(y,o,g,c,b,k){this.f=y,this.g=o,this.h=g,this.i=c,this.j=b,this.k=k,this.b=d.$yib.Uninitialized,this.c=new r.$7c,this.onStateChange=this.c.event,y.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(d.$yib.Disabled(0));return}if(this.h.disableUpdates){this.d(d.$yib.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(d.$yib.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.g.getValue("update.mode"),o=this.m(y);if(!o){this.d(d.$yib.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(o),!this.a){this.d(d.$yib.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(d.$yib.Idle(this.q())),y==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(y){return y==="none"?void 0:this.k.quality}n(y=60*60*1e3){return(0,E.$ug)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(y){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(y)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(y){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},C.CancellationToken.None)).res.statusCode===204}catch(o){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(o);return}}async _applySpecificUpdate(y){}q(){return 1}r(){}};e.$n4b=h,e.$n4b=h=pe([x(0,S.$a3b),x(1,M.$Th),x(2,R.$$2b),x(3,$.$wo),x(4,f.$Pi),x(5,u.$8i)],h)}),define(te[290],ie([0,1,14,55,3,2,18,28,20,5,23,51,26,48,100]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o4b=void 0;let y=class extends v.$n4b{get v(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"error",(g,c)=>c)}get w(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(g,c,b)=>({url:c,version:b,productVersion:b}))}get y(){return r.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(g,c,b,k)=>({releaseNotes:c,version:b,productVersion:b,date:k}))}constructor(g,c,b,k,w,t,l){super(g,c,k,w,t,l),this.z=b,this.u=new M.$kb}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.j.error("UpdateService error:",g);const c=this.state.type==="checking for updates"&&this.state.explicit?g:void 0;this.d(h.$yib.Idle(1,c))}s(g){let c;this.k.darwinUniversalAssetId?c=this.k.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const b=(0,v.$m4b)(c,g,this.k);try{E.autoUpdater.setFeedURL({url:b})}catch(k){this.j.error("Failed to set update feed URL",k);return}return b}t(g){this.d(h.$yib.CheckingForUpdates(g)),E.autoUpdater.checkForUpdates()}E(g){this.state.type==="checking for updates"&&this.d(h.$yib.Downloading(g))}F(g){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:g.version}),this.d(h.$yib.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(h.$yib.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$o4b=y,pe([C.$Rg],y.prototype,"v",null),pe([C.$Rg],y.prototype,"w",null),pe([C.$Rg],y.prototype,"x",null),pe([C.$Rg],y.prototype,"y",null),e.$o4b=y=pe([x(0,f.$a3b),x(1,R.$Th),x(2,p.$Tk),x(3,S.$$2b),x(4,d.$wo),x(5,u.$Pi),x(6,$.$8i)],y)}),define(te[291],ie([0,1,47,42,8,3,9,28,20,5,26,48]),function(G,e,E,C,r,M,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q4b=void 0;let p=class{get state(){return this.a}d(y){this.g.info("update#setState",y.type),this.a=y,this.b.fire(y)}constructor(y,o,g){if(this.f=y,this.g=g,this.a=d.$yib.Uninitialized,this.b=new M.$7c,this.onStateChange=this.b.event,o.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(d.$yib.Idle(this.k())),this.h(30*1e3).then(void 0,c=>this.g.error(c))}h(y=60*60*1e3){return(0,r.$ug)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(y){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(y)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(y){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(y){}};p=pe([x(0,f.$a3b),x(1,S.$$2b),x(2,u.$Pi)],p);let h=class extends p{constructor(y,o,g,c,b,k){super(g,c,b),this.o=y,this.p=o,this.q=k;const w=(0,C.watch)(R.$dc(this.o)),t=M.Event.fromNodeEventEmitter(w,"change",(i,a)=>a),l=M.Event.filter(t,i=>i==="current"),n=M.Event.debounce(l,(i,a)=>a,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{n.dispose(),w.close()})}m(){this.d(d.$yib.CheckingForUpdates(!1)),this.u().then(y=>{y?this.d(d.$yib.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$yib.Idle(2)))},y=>{this.g.error(y),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(d.$yib.Idle(2,y.message||y))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+R.$ec(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const y=await new Promise((g,c)=>(0,C.realpath)(`${R.$dc(this.o)}/current`,(b,k)=>b?c(b):g(k))),o=R.$ec(y);return this.p!==o}isLatestVersion(){return this.u().then(void 0,y=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$q4b=h,e.$q4b=h=pe([x(2,f.$a3b),x(3,S.$$2b),x(4,u.$Pi),x(5,$.$Tk)],h)}),define(te[292],ie([0,1,2,20,53,30,8,29]),function(G,e,E,C,r,M,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K4b=void 0;let f=class extends E.$lb{constructor($,d,p){super(),this.a=d,this.b=p,this.B($.onWillLoadWindow(h=>{h.reason===2&&this.c(h.window)})),this.B($.onBeforeCloseWindow(h=>this.c(h))),this.B(new R.$Eg(()=>this.g(),30*1e3)).schedule()}async c($){const d=this.f($),p=this.a.getProfileForWorkspace(d);p?.isTransient&&(this.a.unsetWorkspace(d,p.isTransient),p.isTransient&&await this.a.cleanUpTransientProfiles())}f($){return $.openedWorkspace??(0,M.$Bh)($.backupPath,$.isExtensionDevelopmentHost)}g(){const $=this.a.getAssociatedEmptyWindows();if($.length===0)return;const d=this.b.getWindows().map(p=>this.f(p));for(const p of $)d.some(h=>h.id===p.id)||this.a.unsetWorkspace(p,!1)}};e.$K4b=f,e.$K4b=f=pe([x(0,C.$a3b),x(1,r.$g3b),x(2,S.$m3b)],f)}),define(te[62],ie([0,1,14,2,3,5,311,8,15,29,70,26,20,73,37,4,132]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G3b=e.$F3b=void 0;function g(k){return typeof k.responseWindowId=="number"}let c=class ht extends C.$lb{static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(ht.b.values())}constructor(w,t,l){super(),this.n=w,this.p=t,this.r=l,this.c=String(++ht.a),this.f=this.B(new r.$7c),this.onStdout=this.f.event,this.g=this.B(new r.$7c),this.onStderr=this.g.event,this.h=this.B(new r.$7c),this.onMessage=this.h.event,this.i=this.B(new r.$7c),this.onExit=this.i.event,this.j=this.B(new r.$7c),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}s(w,t){let l;switch(this.m?.correlationId?l=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${w}`:l=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${w}`,t){case $.default.Error:this.n.error(l);break;case $.default.Warning:this.n.warn(l);break;case $.default.Info:this.n.trace(l);break}}t(){return this.k?(this.s("Cannot start utility process because it is already running...",$.default.Error),!1):!0}start(w){const t=this.u(w);return t&&w.payload&&this.postMessage(w.payload),t}u(w){if(!this.t())return!1;this.m=w;const t=`${this.m.type}-${this.c}`,l=f.$3e.asFileUri("bootstrap-fork.js").fsPath,s=this.m.args??[],n=this.m.execArgv??[],i=this.m.allowLoadingUnsignedLibraries,a=this.m.forceAllocationsToV8Sandbox,m="pipe",P=this.v(w);return this.s("creating new...",$.default.Info),this.k=E.utilityProcess.fork(l,s,{serviceName:t,env:P,execArgv:n,allowLoadingUnsignedLibraries:i,forceAllocationsToV8Sandbox:a,stdio:m}),this.w(this.k,this.m,t),!0}v(w){const t=w.env?{...w.env}:{...(0,v.$Fm)(process.env)};t.VSCODE_AMD_ENTRYPOINT=w.entryPoint,typeof w.parentLifecycleBound=="number"&&(t.VSCODE_PARENT_PID=String(w.parentLifecycleBound)),t.VSCODE_CRASH_REPORTER_PROCESS_TYPE=w.type,y.$i&&((0,o.isUNCAccessRestrictionsDisabled)()?t.NODE_DISABLE_UNC_ACCESS_CHECKS="1":t.NODE_UNC_HOST_ALLOWLIST=(0,o.getUNCHostAllowlist)().join("\\")),(0,h.$el)(t);for(const l of Object.keys(t))t[l]=String(t[l]);return t}w(w,t,l){if(w.stdout){const s=new R.StringDecoder("utf-8");this.B(r.Event.fromNodeEventEmitter(w.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:s.write(n))))}if(w.stderr){const s=new R.StringDecoder("utf-8");this.B(r.Event.fromNodeEventEmitter(w.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:s.write(n))))}this.B(r.Event.fromNodeEventEmitter(w,"message")(s=>this.h.fire(s))),this.B(r.Event.fromNodeEventEmitter(w,"spawn")(()=>{this.l=w.pid,typeof w.pid=="number"&&ht.b.set(w.pid,{pid:w.pid,name:g(t)?`${t.type} [${t.responseWindowId}]`:t.type}),this.s("successfully created",$.default.Info)})),this.B(r.Event.fromNodeEventEmitter(w,"exit")(s=>{this.s(`received exit event with code ${s}`,$.default.Info),this.i.fire({pid:this.l,code:s,signal:"unknown"}),this.y()})),this.B(r.Event.fromNodeEventEmitter(E.app,"child-process-gone",(s,n)=>({event:s,details:n}))(({details:s})=>{s.type==="Utility"&&s.name===l&&(this.s(`crashed with code ${s.exitCode} and reason '${s.reason}'`,$.default.Error),this.p.publicLog2("utilityprocesscrash",{type:t.type,reason:s.reason,code:s.exitCode}),this.j.fire({pid:this.l,code:s.exitCode,reason:s.reason}),this.y())}))}once(w,t){const l=this.B(this.h.event(s=>{s===w&&(l.dispose(),t())}))}postMessage(w,t){this.k&&this.k.postMessage(w,t)}connect(w){const{port1:t,port2:l}=new E.MessageChannelMain;return this.postMessage(w,[l]),t}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.s("enabling inspect port",$.default.Info);const w=process;return typeof w._debugProcess=="function"?(w._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.s("attempting to kill the process...",$.default.Info),this.k.kill()?(this.s("successfully killed the process",$.default.Info),this.y()):this.s("unable to kill the process",$.default.Warning)}y(){typeof this.l=="number"&&ht.b.delete(this.l),this.k=void 0}async waitForExit(w){this.k&&(this.s("waiting to exit...",$.default.Info),await Promise.race([r.Event.toPromise(this.onExit),(0,S.$ug)(w)]),this.k&&(this.s(`did not exit within ${w}ms, will kill it now...`,$.default.Info),this.kill()))}};e.$F3b=c,e.$F3b=c=pe([x(0,M.$Pi),x(1,d.$Tk),x(2,p.$a3b)],c);let b=class extends c{constructor(w,t,l,s){super(w,l,s),this.z=t}start(w){const t=this.z.getWindowById(w.responseWindowId);if(!t?.win||t.win.isDestroyed()||t.win.webContents.isDestroyed())return this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",$.default.Error),!0;if(!super.u(w))return!1;this.C(t.win,w);const s=this.connect(w.payload);return t.win.webContents.postMessage(w.responseChannel,w.responseNonce,[s]),!0}C(w,t){t.windowLifecycleBound&&(this.B(r.Event.filter(this.r.onWillLoadWindow,l=>l.window.win===w)(()=>this.kill())),this.B(r.Event.fromNodeEventEmitter(w,"closed")(()=>this.kill())))}};e.$G3b=b,e.$G3b=b=pe([x(0,M.$Pi),x(1,u.$m3b),x(2,d.$Tk),x(3,p.$a3b)],b)}),define(te[293],ie([0,1,13,5,20,8,62,29,26]),function(G,e,E,C,r,M,R,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O3b=void 0;let u=class Rt{static{this.a=0}constructor(d,p,h,v){this.d=d,this.f=p,this.g=h,this.h=v,this.b=new Map,this.c=!1,this.f.onWillShutdown(y=>{this.c=!0,y.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(d){const p=this.b.get(d);if(!p)throw new Error("Unknown extension host!");return p}onDynamicStdout(d){return this.i(d).onStdout}onDynamicStderr(d){return this.i(d).onStderr}onDynamicMessage(d){return this.i(d).onMessage}onDynamicExit(d){return this.i(d).onExit}async createExtensionHost(){if(this.c)throw(0,E.$4)();const d=String(++Rt.a),p=new R.$G3b(this.d,this.g,this.h,this.f);return this.b.set(d,p),p.onExit(({pid:h,code:v,signal:y})=>{this.d.info(`Extension host with pid ${h} exited with code: ${v}, signal: ${y}.`),setTimeout(()=>{p.dispose(),this.b.delete(d)})}),{id:d}}async start(d,p){if(this.c)throw(0,E.$4)();this.i(d).start({...p,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:p.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:d})}async enableInspectPort(d){if(this.c)throw(0,E.$4)();const p=this.b.get(d);return p?p.enableInspectPort():!1}async kill(d){if(this.c)throw(0,E.$4)();const p=this.b.get(d);p&&p.kill()}async _killAllNow(){for(const[,d]of this.b)d.kill()}async _waitForAllExit(d){const p=[];for(const[,h]of this.b)p.push(h.waitForExit(d));return M.Promises.settled(p).then(()=>{})}};e.$O3b=u,e.$O3b=u=pe([x(0,C.$Pi),x(1,r.$a3b),x(2,S.$m3b),x(3,f.$Tk)],u)}),define(te[294],ie([0,1,38,8,2,28,20,5,41,39,66,62,52,90,10]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g4b=void 0;let y=class extends r.$lb{constructor(g,c,b,k,w,t,l){super(),this.c=g,this.f=c,this.g=b,this.h=k,this.i=w,this.j=t,this.k=l,this.a=new C.$sg,this.b=void 0,this.r=void 0,this.s=void 0,this.l()}l(){E.$jS.on("vscode:createSharedProcessMessageChannel",(g,c)=>this.m(g,c)),this.B(this.h.onWillShutdown(()=>this.n()))}async m(g,c){this.i.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const b=await this.connect();if(g.sender.isDestroyed())return b.close();g.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[b])}n(){this.i.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage("vscode:electron-main->shared-process=exit"),this.b=void 0}whenReady(){return this.r||(this.r=(async()=>{await this.t;const g=new C.$Ng;this.b?this.b.once("vscode:shared-process->electron-main=init-done",()=>g.complete()):E.$jS.once("vscode:shared-process->electron-main=init-done",()=>g.complete()),await g.p,this.i.trace("[SharedProcess] Overall ready")})()),this.r}get t(){return this.s||(this.s=(async()=>{await this.a.wait(),this.u();const g=new C.$Ng;this.b?this.b.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()):E.$jS.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()),await g.p,this.i.trace("[SharedProcess] IPC ready")})()),this.s}u(){this.b=this.B(new d.$F3b(this.i,p.$2n,this.h));const g=(0,h.$Xl)(this.f.args,this.f.isBuilt);let c;g.port&&(c=["--nolazy"],g.break?c.push(`--inspect-brk=${g.port}`):c.push(`--inspect=${g.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.v(),execArgv:c})}v(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.j.getLogLevel(),loggers:this.j.getRegisteredLoggers(),policiesData:this.k.serialize()}}async connect(){return await this.t,(0,v.$te)(this.b).connect()}};e.$g4b=y,e.$g4b=y=pe([x(1,M.$$2b),x(2,f.$pk),x(3,R.$a3b),x(4,S.$Pi),x(5,$.$e4b),x(6,u.$Tm)],y)}),define(te[295],ie([0,1,28,90,20,5,52,62,110,38,2,3,37,18]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S4b=void 0;let v=class extends $.$lb{constructor(o,g,c,b,k){super(),this.f=o,this.g=g,this.h=c,this.i=b,this.j=k,this.a=void 0,this.b=new d.$7c,this.onRequestConnection=this.b.event,this.c=new d.$7c,this.onWillShutdown=this.c.event,this.i.onWillShutdown(()=>this.c.fire()),u.$jS.on("vscode:createPtyHostMessageChannel",(w,t)=>this.l(w,t)),this.B((0,$.$jb)(()=>{u.$jS.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$F3b(this.j,R.$2n,this.i);const o=(0,C.$Wl)(this.h.args,this.h.isBuilt),g=o.port?["--nolazy",`--inspect${o.break?"-brk":""}=${o.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:g,args:["--logsPath",this.h.logsHome.fsPath],env:this.k()});const c=this.a.connect(),b=new f.$rS(c,"ptyHost"),k=new $.$kb;return k.add(b),k.add((0,$.$jb)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:b,store:k,onDidProcessExit:this.a.onExit}}k(){this.h.unsetSnapExportedVariables();const o={...(0,p.$Fm)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},g=this.g.getValue("terminal.integrated.developer.ptyHost.latency");g&&typeof g=="number"&&(o.VSCODE_LATENCY=String(g));const c=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return c&&typeof c=="number"&&(o.VSCODE_STARTUP_DELAY=String(c)),this.h.restoreSnapExportedVariables(),o}l(o,g){this.b.fire();const c=this.a.connect();if(o.sender.isDestroyed()){c.close();return}o.sender.postMessage("vscode:createPtyHostMessageChannelResult",g,[c])}};e.$S4b=v,e.$S4b=v=pe([x(1,h.$Th),x(2,E.$$2b),x(3,r.$a3b),x(4,M.$Pi)],v)}),define(te[296],ie([0,1,2,6,5,29,62,26,57,3,8,20]),function(G,e,E,C,r,M,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R4b=e.$Q4b=void 0,e.$Q4b=(0,C.$nh)("utilityProcessWorker");let p=class extends E.$lb{constructor(y,o,g,c){super(),this.b=y,this.c=o,this.f=g,this.g=c,this.a=new Map}async createWorker(y){const o=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${o})`);const g=this.h(y);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${o})`),this.disposeWorker(y));const c=new h(this.b,this.c,this.f,this.g,y);if(!c.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,c);const b=new $.$Ng;return u.Event.once(c.onDidTerminate)(k=>{k.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${k.code}, signal: ${k.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${k.code}, signal: ${k.signal}`),this.a.delete(g),b.complete({reason:k})}),b.p}h(y){return(0,f.$bi)({moduleId:y.process.moduleId,windowId:y.reply.windowId})}async disposeWorker(y){const o=this.h(y),g=this.a.get(o);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),g.kill(),this.a.delete(o))}};e.$R4b=p,e.$R4b=p=pe([x(0,r.$Pi),x(1,M.$m3b),x(2,S.$Tk),x(3,d.$a3b)],p);let h=class extends E.$lb{constructor(y,o,g,c,b){super(),this.c=y,this.f=o,this.g=g,this.h=c,this.i=b,this.a=this.B(new u.$7c),this.onDidTerminate=this.a.event,this.b=new R.$G3b(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(y=>this.a.fire({code:y.code,signal:y.signal}))),this.B(this.b.onCrash(y=>this.a.fire({code:y.code,signal:"ECRASH"})))}spawn(){const o=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:o,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};h=pe([x(0,r.$Pi),x(1,M.$m3b),x(2,S.$Tk),x(3,d.$a3b)],h)}),define(te[297],ie([0,1,14,2,4,19,7,18,20,5,34,29,128,30]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C4b=e.$B4b=e.$A4b=void 0;let v=class vt extends C.$lb{static{this.a="windowsState"}get state(){return this.b}constructor(k,w,t,l,s){super(),this.g=k,this.h=w,this.i=t,this.j=l,this.k=s,this.b=y(this.h.getItem(vt.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(k=>this.p(k)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(k=>{k.newCount-k.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(k=>this.p(k))}m(){this.f=!0,this.n()}n(){const k=new Set,w={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!w.lastActiveWindow){let s=this.g.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),s&&(w.lastActiveWindow=this.r(s),w.lastActiveWindow.uiState.mode===3&&k.add(w.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);t&&(w.lastPluginDevelopmentHostWindow=this.r(t),w.lastPluginDevelopmentHostWindow.uiState.mode===3&&(k.has(w.lastPluginDevelopmentHostWindow.uiState.display)?r.$j&&!t.win?.isSimpleFullScreen()&&(w.lastPluginDevelopmentHostWindow.uiState.mode=1):k.add(w.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(w.openedWindows=this.g.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>{const n=this.r(s);return n.uiState.mode===3&&(k.has(n.uiState.display)?r.$j&&n.windowId!==w.lastActiveWindow?.windowId&&!s.win?.isSimpleFullScreen()&&(n.uiState.mode=1):k.add(n.uiState.display)),n}));const l=g(w);this.h.setItem(vt.a,l),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",l)}p(k){if(this.i.quitRequested)return;const w=this.r(k);k.isExtensionDevelopmentHost&&!k.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=w:!k.isExtensionDevelopmentHost&&k.openedWorkspace&&this.b.openedWindows.forEach(t=>{const l=(0,h.$Ch)(k.openedWorkspace)&&t.workspace?.id===k.openedWorkspace.id,s=(0,h.$xh)(k.openedWorkspace)&&t.folderUri&&M.$Yf.isEqual(t.folderUri,k.openedWorkspace.uri);(l||s)&&(t.uiState=w.uiState)}),this.g.getWindowCount()===1&&(this.c=w)}r(k){return{windowId:k.id,workspace:(0,h.$Ch)(k.openedWorkspace)?k.openedWorkspace:void 0,folderUri:(0,h.$xh)(k.openedWorkspace)?k.openedWorkspace.uri:void 0,backupPath:k.backupPath,remoteAuthority:k.remoteAuthority,uiState:k.serializeWindowState()}}getNewWindowState(k){const w=this.s(k),t=this.k.getValue("window");if(w.mode===3){let l;w.hasDefaultState?l=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):l=!!(this.i.wasRestarted||t?.restoreFullscreen),l||(w.mode=1)}return w}s(k){const w=this.g.getLastActiveWindow();if(!k.extensionTestsPath){if(k.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=k.workspace;if((0,h.$Ch)(a)){const P=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===a.id).map(I=>I.uiState);if(P.length)return P[0]}if((0,h.$xh)(a)){const P=this.state.openedWindows.filter(I=>I.folderUri&&M.$Yf.isEqual(I.folderUri,a.uri)).map(I=>I.uiState);if(P.length)return P[0]}else if(k.backupPath){const P=this.state.openedWindows.filter(I=>I.backupPath===k.backupPath).map(I=>I.uiState);if(P.length)return P[0]}const m=this.c||this.state.lastActiveWindow;if(!w&&m)return m.uiState}let t;const l=E.screen.getAllDisplays();if(l.length===1)t=l[0];else{if(r.$j){const a=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(a)}!t&&w&&(t=E.screen.getDisplayMatching(w.getBounds())),t||(t=E.screen.getPrimaryDisplay()||l[0])}let s=(0,p.$02b)();s.x=Math.round(t.bounds.x+t.bounds.width/2-s.width/2),s.y=Math.round(t.bounds.y+t.bounds.height/2-s.height/2);const n=this.k.getValue("window");let i=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")s.mode=0,i=!1;else if(n.newWindowDimensions==="fullscreen")s.mode=3,i=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&w){const a=w.serializeWindowState();a.mode===3?s.mode=3:s=a,i=s.mode!==3&&n.newWindowDimensions==="offset"}}return i&&(s=this.t(s)),s.hasDefaultState=!0,s}t(k){if(this.g.getWindows().length===0)return k;k.x=typeof k.x=="number"?k.x:0,k.y=typeof k.y=="number"?k.y:0;const w=this.g.getWindows().map(t=>t.getBounds());for(;w.some(t=>t.x===k.x||t.y===k.y);)k.x+=30,k.y+=30;return k}};e.$A4b=v,e.$A4b=v=pe([x(0,d.$m3b),x(1,$.$OM),x(2,f.$a3b),x(3,u.$Pi),x(4,S.$Th)],v);function y(b){const k={openedWindows:[]},w=b||{openedWindows:[]};return w.lastActiveWindow&&(k.lastActiveWindow=o(w.lastActiveWindow)),w.lastPluginDevelopmentHostWindow&&(k.lastPluginDevelopmentHostWindow=o(w.lastPluginDevelopmentHostWindow)),Array.isArray(w.openedWindows)&&(k.openedWindows=w.openedWindows.map(t=>o(t))),k}e.$B4b=y;function o(b){const k={uiState:b.uiState};return b.backupPath&&(k.backupPath=b.backupPath),b.remoteAuthority&&(k.remoteAuthority=b.remoteAuthority),b.folder&&(k.folderUri=R.URI.parse(b.folder)),b.workspaceIdentifier&&(k.workspace={id:b.workspaceIdentifier.id,configPath:R.URI.parse(b.workspaceIdentifier.configURIPath)}),k}function g(b){return{lastActiveWindow:b.lastActiveWindow&&c(b.lastActiveWindow),lastPluginDevelopmentHostWindow:b.lastPluginDevelopmentHostWindow&&c(b.lastPluginDevelopmentHostWindow),openedWindows:b.openedWindows.map(k=>c(k))}}e.$C4b=g;function c(b){return{workspaceIdentifier:b.workspace&&{id:b.workspace.id,configURIPath:b.workspace.configPath.toString()},folder:b.folderUri&&b.folderUri.toString(),backupPath:b.backupPath,remoteAuthority:b.remoteAuthority,uiState:b.uiState}}}),define(te[54],ie([0,1,14,3,45,2,15,9,19,10,22,192,64,61,28,6,5,53,130,30,98,99]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E3b=e.$D3b=void 0,e.$D3b=(0,y.$nh)("workspacesManagementMainService");let t=class extends M.$lb{constructor(s,n,i,a,m){super(),this.g=s,this.h=n,this.i=i,this.j=a,this.k=m,this.a=this.B(new C.$7c),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new C.$7c),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const s=(await $.Promises.readdir(this.c.fsPath)).map(n=>(0,f.$8f)(this.c,n,b.$Mh));for(const n of s){const i=(0,w.$t3b)(n),a=await this.resolveLocalWorkspace(n);a?this.f.push({workspace:i,remoteAuthority:a.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(s){s.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${s}).`)}}resolveLocalWorkspace(s){return this.l(s,n=>$.Promises.readFile(n,"utf8"))}l(s,n){if(this.m(s)&&s.scheme===R.Schemas.file)try{const i=n(s.fsPath);return i instanceof Promise?i.then(a=>this.n(s,a),a=>{}):this.n(s,i)}catch{return}}m(s){return(0,b.$Nh)(s,this.g)||(0,b.$Sh)(s)}n(s,n){try{const i=this.p(s,n),a=(0,w.$t3b)(s);return{id:a.id,configPath:a.configPath,folders:(0,k.$Gab)(i.folders,a.configPath,f.$Yf),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}p(s,n){const i=(0,r.$vm)(n);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(a=>(0,k.$Eab)(a));else throw new Error(`${s.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(s,n){const{workspace:i,storedWorkspace:a}=this.r(s,n),m=i.configPath.fsPath;return await $.Promises.mkdir((0,S.$dc)(m),{recursive:!0}),await $.Promises.writeFile(m,JSON.stringify(a,null,"	")),this.f.push({workspace:i,remoteAuthority:n}),i}r(s=[],n){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),a=(0,f.$8f)(this.c,i),m=(0,f.$8f)(a,b.$Mh),P=[];for(const I of s)P.push((0,k.$Fab)(I.uri,!0,I.name,a,f.$Yf));return{workspace:(0,w.$t3b)(m),storedWorkspace:{folders:P,remoteAuthority:n}}}async getWorkspaceIdentifier(s){return(0,w.$t3b)(s)}isUntitledWorkspace(s){return(0,b.$Nh)(s.configPath,this.g)}async deleteUntitledWorkspace(s){this.isUntitledWorkspace(s)&&(await this.s(s),this.i.isEnabled()&&this.i.unsetWorkspace(s),this.a.fire(s))}async s(s){const n=(0,f.$Vf)(s.configPath);try{await $.Promises.rm((0,S.$dc)(n));const i=(0,S.$ac)(this.g.workspaceStorageHome.fsPath,s.id);await $.Promises.exists(i)&&await $.Promises.writeFile((0,S.$ac)(i,"obsolete"),""),this.f=this.f.filter(a=>a.workspace.id!==s.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${n} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(s,n,i){if(!s||!s.win||!s.isReady||!await this.t(s,n,i))return;const m=await this.u(s,(0,w.$t3b)(i));if(m)return this.b.fire({window:s,workspace:m.workspace}),m}async t(s,n,i){return i?(0,b.$Ch)(s.openedWorkspace)&&f.$Yf.isEqual(s.openedWorkspace.configPath,i)?!1:(0,c.$B3b)(n,i)?(await this.k.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:(0,d.localize)(1,null,(0,f.$5f)(i)),detail:(0,d.localize)(2,null)},(0,u.$Ae)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(s,n){if(!s.config)return;s.focus();let i;return s.config.extensionDevelopmentPath||(s.config.backupPath?i=await this.j.registerWorkspaceBackup({workspace:n,remoteAuthority:s.remoteAuthority},s.config.backupPath):i=this.j.registerWorkspaceBackup({workspace:n,remoteAuthority:s.remoteAuthority})),(0,b.$Ch)(s.openedWorkspace)&&this.isUntitledWorkspace(s.openedWorkspace)&&await this.deleteUntitledWorkspace(s.openedWorkspace),s.config.workspace=n,s.config.backupPath=i,{workspace:n,backupPath:i}}};e.$E3b=t,e.$E3b=t=pe([x(0,v.$$2b),x(1,o.$Pi),x(2,g.$g3b),x(3,p.$r3b),x(4,h.$y3b)],t)}),define(te[133],ie([0,1,14,38,21,6,29,30,54,10,5,62]),function(G,e,E,C,r,M,R,S,f,u,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J3b=e.$I3b=e.ID=void 0,e.ID="diagnosticsMainService",e.$I3b=(0,M.$nh)(e.ID);let p=class{constructor(v,y,o){this.a=v,this.b=y,this.c=o}async getRemoteDiagnostics(v){const y=this.a.getWindows();return(await Promise.all(y.map(async g=>{const c=g.remoteAuthority;if(!c)return;const b=`vscode:getDiagnosticInfoResponse${g.id}`,k={includeProcesses:v.includeProcesses,folders:v.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(w=>{g.sendWhenReady("vscode:getDiagnosticInfo",r.CancellationToken.None,{replyChannel:b,args:k}),C.$jS.once(b,(t,l)=>{l||w({hostName:c,errorMessage:`Unable to resolve connection to '${c}'.`}),w(l)}),setTimeout(()=>{w({hostName:c,errorMessage:`Connection to '${c}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const v=[];for(const o of E.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(o.id);g?v.push(await this.d(g)):v.push(this.e(o))}const y=[];for(const{pid:o,name:g}of d.$F3b.getAll())y.push({pid:o,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:v,pidToNames:y,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(v){const y=await this.f(v),o=(0,u.$te)(v.win);return this.e(o,y,v.remoteAuthority)}e(v,y=[],o){return{id:v.id,pid:v.webContents.getOSProcessId(),title:v.getTitle(),folderURIs:y,remoteAuthority:o}}async f(v){const y=[],o=v.openedWorkspace;if((0,S.$xh)(o))y.push(o.uri);else if((0,S.$Ch)(o)){const g=await this.b.resolveLocalWorkspace(o.configPath);g&&g.folders.forEach(b=>{y.push(b.uri)})}return y}};e.$J3b=p,e.$J3b=p=pe([x(0,R.$m3b),x(1,f.$D3b),x(2,$.$Pi)],p)}),define(te[67],ie([0,1,47,14,27,155,55,3,2,15,9,4,7,105,87,22,103,180,61,28,6,20,5,23,80,29,30,54,17,242,234]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z3b=e.$Y3b=void 0,e.$Y3b=(0,k.$nh)("nativeHostMainService");let D=class extends f.$lb{constructor(L,N,q,re,ne,ee,ae,ue){super(),this.a=L,this.b=N,this.c=q,this.f=re,this.g=ne,this.h=ee,this.i=ae,this.j=ue,this.onDidOpenWindow=S.Event.map(this.a.onDidOpenWindow,K=>K.id),this.onDidTriggerSystemContextMenu=S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:K,x:X,y:U})=>({windowId:K.id,x:X,y:U})),({windowId:K})=>!!this.a.getWindowById(K)),this.onDidMaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-maximize",(K,X)=>X.id),K=>!!this.a.getWindowById(K)),this.onDidUnmaximizeWindow=S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-unmaximize",(K,X)=>X.id),K=>!!this.a.getWindowById(K)),this.onDidBlurWindow=S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(K,X)=>X.id),K=>!!this.a.getWindowById(K)),this.onDidFocusWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),K=>!!K),K=>K.id),S.Event.filter(S.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(K,X)=>X.id),K=>!!this.a.getWindowById(K))),this.onDidResumeOS=S.Event.fromNodeEventEmitter(C.powerMonitor,"resume"),this.onDidChangeColorScheme=this.i.onDidChangeColorScheme,this.k=this.B(new S.$7c),this.onDidChangePassword=this.k.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(C.screen,"display-metrics-changed",(K,X,U)=>U),K=>!(Array.isArray(K)&&K.length===1&&K[0]==="workArea")),S.Event.fromNodeEventEmitter(C.screen,"display-added"),S.Event.fromNodeEventEmitter(C.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(N=>({id:N.id,workspace:N.openedWorkspace??(0,i.$Bh)(N.backupPath,N.isExtensionDevelopmentHost),title:N.win?.getTitle()??"",filename:N.getRepresentedFilename(),dirty:N.isDocumentEdited()}))}async getWindowCount(L){return this.a.getWindowCount()}async getActiveWindowId(L){const N=C.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(N)return N.id}openWindow(L,N,q){return Array.isArray(N)?this.l(L,N,q):this.m(L,N)}async l(L,N,q=Object.create(null)){N.length>0&&await this.a.open({context:5,contextWindowId:L,urisToOpen:N,cli:this.f.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async m(L,N){await this.a.openEmptyWindow({context:5,contextWindowId:L},N)}async toggleFullScreen(L){this.t(L)?.toggleFullScreen()}async handleTitleDoubleClick(L){this.t(L)?.handleTitleDoubleClick()}async isMaximized(L){const N=this.t(L);return N?.win?N.win.isMaximized():!1}async maximizeWindow(L){const N=this.t(L);N?.win&&N.win.maximize()}async unmaximizeWindow(L){const N=this.t(L);N?.win&&N.win.unmaximize()}async minimizeWindow(L){const N=this.t(L);N?.win&&N.win.minimize()}async updateWindowControls(L,N){const q=this.t(L);q&&q.updateWindowControls(N)}async focusWindow(L,N){N&&typeof N.windowId=="number"&&(L=N.windowId),this.t(L)?.focus({force:N?.force??!1})}async setMinimumSize(L,N,q){const re=this.t(L);if(re?.win){const[ne,ee]=re.win.getSize(),[ae,ue]=re.win.getMinimumSize(),[K,X]=[N??ae,q??ue],[U,W]=[Math.max(ne,K),Math.max(ee,X)];(ae!==K||ue!==X)&&re.win.setMinimumSize(K,X),(ne!==U||ee!==W)&&re.win.setSize(U,W)}}async saveWindowSplash(L,N){this.i.saveWindowSplash(L,N)}async installShellCommand(L){const{source:N,target:q}=await this.n();try{const{symbolicLink:re}=await y.SymlinkSupport.stat(N);if(re&&!re.dangling){const ne=await(0,h.$Jp)(N);if(q===ne)return}await y.Promises.unlink(N)}catch(re){if(re.code!=="ENOENT")throw re}try{await y.Promises.symlink(q,N)}catch(re){if(re.code!=="EACCES"&&re.code!=="ENOENT")throw re;const{response:ne}=await this.showMessageBox(L,{type:"info",message:(0,g.localize)(0,null,this.h.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(ne===0)try{const ee=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${N}'\\" with administrator privileges"`;await(0,M.promisify)(E.exec)(ee)}catch{throw new Error((0,g.localize)(3,null,N))}}}async uninstallShellCommand(L){const{source:N}=await this.n();try{await y.Promises.unlink(N)}catch(q){switch(q.code){case"EACCES":{const{response:re}=await this.showMessageBox(L,{type:"info",message:(0,g.localize)(4,null,this.h.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(re===0)try{const ne=`osascript -e "do shell script \\"rm '${N}'\\" with administrator privileges"`;await(0,M.promisify)(E.exec)(ne)}catch{throw new Error((0,g.localize)(7,null,N))}break}case"ENOENT":break;default:throw q}}}async n(){const L=(0,$.$bc)(this.f.appRoot,"bin","code"),N=`/usr/local/bin/${this.h.applicationName}`;if(!await y.Promises.exists(L))throw new Error((0,g.localize)(8,null,L));return{source:N,target:L}}async showMessageBox(L,N){return this.b.showMessageBox(N,this.p(L))}async showSaveDialog(L,N){return this.b.showSaveDialog(N,this.p(L))}async showOpenDialog(L,N){return this.b.showOpenDialog(N,this.p(L))}p(L){const N=this.t(L);if(N?.win)return N.win}async pickFileFolderAndOpen(L,N){const q=await this.b.pickFileFolder(N);q&&await this.r(await Promise.all(q.map(async re=>await y.SymlinkSupport.existsDirectory(re)?{folderUri:p.URI.file(re)}:{fileUri:p.URI.file(re)})),N,L)}async pickFolderAndOpen(L,N){const q=await this.b.pickFolder(N);q&&await this.r(q.map(re=>({folderUri:p.URI.file(re)})),N,L)}async pickFileAndOpen(L,N){const q=await this.b.pickFile(N);q&&await this.r(q.map(re=>({fileUri:p.URI.file(re)})),N,L)}async pickWorkspaceAndOpen(L,N){const q=await this.b.pickWorkspace(N);q&&await this.r(q.map(re=>({workspaceUri:p.URI.file(re)})),N,L)}async r(L,N,q){await this.a.open({context:3,contextWindowId:q,cli:this.f.args,urisToOpen:L,forceNewWindow:N.forceNewWindow})}async showItemInFolder(L,N){C.shell.showItemInFolder(N)}async setRepresentedFilename(L,N){this.t(L)?.setRepresentedFilename(N)}async setDocumentEdited(L,N){this.t(L)?.setDocumentEdited(N)}async openExternal(L,N){return this.f.unsetSnapExportedVariables(),C.shell.openExternal(N),this.f.restoreSnapExportedVariables(),!0}moveItemToTrash(L,N){return C.shell.trashItem(N)}async isAdmin(){let L;return d.$i?L=(await new Promise((N,q)=>{G(["native-is-elevated"],N,q)}))():L=process.getuid()===0,L}async writeElevated(L,N,q,re){const ne=await new Promise((ee,ae)=>{G(["@vscode/sudo-prompt"],ee,ae)});return new Promise((ee,ae)=>{const ue=[`"${this.s}"`];re?.unlock&&ue.push("--file-chmod"),ue.push("--file-write",`"${N.fsPath}"`,`"${q.fsPath}"`);const K={name:this.h.nameLong.replace("-",""),icns:d.$j&&this.f.isBuilt?(0,$.$ac)((0,$.$dc)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};ne.exec(ue.join(" "),K,(X,U,W)=>{U&&this.g.trace(`[sudo-prompt] received stdout: ${U}`),W&&this.g.trace(`[sudo-prompt] received stderr: ${W}`),X?ae(X):ee(void 0)})})}async isRunningUnderARM64Translation(){return d.$k||d.$i?!1:C.app.runningUnderARM64Translation}get s(){return d.$i?this.f.isBuilt?(0,$.$ac)((0,$.$dc)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,$.$ac)(this.f.appRoot,"scripts","code-cli.bat"):d.$k?this.f.isBuilt?(0,$.$ac)((0,$.$dc)(process.execPath),"bin",`${this.h.applicationName}`):(0,$.$ac)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,$.$ac)(this.f.appRoot,"bin","code"):(0,$.$ac)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,r.totalmem)(),freemem:(0,r.freemem)(),loadavg:(0,r.loadavg)()}}async getOSProperties(){return{arch:(0,r.arch)(),platform:(0,r.platform)(),release:(0,r.release)(),type:(0,r.type)(),cpus:(0,r.cpus)()}}async getOSVirtualMachineHint(){return v.$rm.value()}async getOSColorScheme(){return this.i.getColorScheme()}async hasWSLFeatureInstalled(){return d.$i&&(0,P.$W3b)()}async killProcess(L,N,q){process.kill(N,q)}async readClipboardText(L,N){return C.clipboard.readText(N)}async writeClipboardText(L,N,q){return C.clipboard.writeText(N,q)}async readClipboardFindText(L){return C.clipboard.readFindText()}async writeClipboardFindText(L,N){return C.clipboard.writeFindText(N)}async writeClipboardBuffer(L,N,q,re){return C.clipboard.writeBuffer(N,Buffer.from(q.buffer),re)}async readClipboardBuffer(L,N){return m.$Jb.wrap(C.clipboard.readBuffer(N))}async hasClipboard(L,N,q){return C.clipboard.has(N,q)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){C.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){C.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){C.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){C.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){C.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(L,N){this.t(L)?.updateTouchBar(N)}async notifyReady(L){this.t(L)?.setReady()}async relaunch(L,N){return this.c.relaunch(N)}async reload(L,N){const q=this.t(L);if(q){if((0,i.$Ch)(q.openedWorkspace)){const re=q.openedWorkspace.configPath;if(re.scheme===u.Schemas.file&&(await this.j.resolveLocalWorkspace(re))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.c.reload(q,N?.disableExtensions!==void 0?{_:[],"disable-extensions":N.disableExtensions}:void 0)}}async closeWindow(L){this.closeWindowById(L,L)}async closeWindowById(L,N){const q=this.t(N);if(q?.win)return q.win.close()}async quit(L){const N=this.a.getLastActiveWindow();N?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&N.win?N.win.close():this.c.quit()}async exit(L,N){await this.c.kill(N)}async resolveProxy(L,N){return this.t(L)?.win?.webContents?.session?.resolveProxy(N)}findFreePort(L,N,q,re,ne=1){return(0,o.$7e)(N,q,re,ne)}async openDevTools(L,N){const q=this.t(L);q?.win&&q.win.webContents.openDevTools(N)}async toggleDevTools(L){const N=this.t(L);N?.win&&N.win.webContents.toggleDevTools()}async sendInputEvent(L,N){const q=this.t(L);q?.win&&(N.type==="mouseDown"||N.type==="mouseUp")&&q.win.webContents.sendInputEvent(N)}async profileRenderer(L,N,q){const re=this.t(L);if(!re||!re.win)throw new Error;return await new I.$X3b(re.win,N,this.g).inspect(q)}async windowsGetStringRegKey(L,N,q,re){if(!d.$i)return;const ne=await new Promise((ee,ae)=>{G(["@vscode/windows-registry"],ee,ae)});try{return ne.GetStringRegKey(N,q,re)}catch{return}}t(L){if(typeof L=="number")return this.a.getWindowById(L)}};e.$Z3b=D,pe([R.$Rg],D.prototype,"s",null),e.$Z3b=D=pe([x(0,n.$m3b),x(1,c.$y3b),x(2,w.$a3b),x(3,b.$$2b),x(4,t.$Pi),x(5,l.$8i),x(6,s.$U3b),x(7,a.$D3b)],D)}),define(te[298],ie([0,1,14,38,27,2,15,4,107,178,91,133,61,28,5,67,78,23,79,81,32,10,34,62,21,7,29,8]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$23b=void 0;const m="issue.processExplorerWindowState";let P=class At{static{this.a="#1E1E1E"}constructor(O,L,N,q,re,ne,ee,ae,ue,K,X){this.g=O,this.h=L,this.i=N,this.j=q,this.k=re,this.l=ne,this.m=ee,this.n=ae,this.o=ue,this.p=K,this.q=X,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){C.$jS.on("vscode:listProcesses",async O=>{const L=[];try{L.push({name:(0,u.localize)(0,null),rootProcess:await(0,f.$dr)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(q=>{(0,$.$4l)(q)?L.push({name:q.hostName,rootProcess:q}):q.processes&&L.push({name:q.hostName,rootProcess:q.processes})})}catch(N){this.i.error(`Listing processes failed: ${N}`)}this.t(O,"vscode:listProcessesResponse",L)}),C.$jS.on("vscode:workbenchCommand",(O,L)=>{const{id:N,from:q,args:re}=L;let ne;switch(q){case"processExplorer":ne=this.f;break;default:throw new Error(`Unexpected command source: ${q}`)}ne?.webContents.send("vscode:runAction",{id:N,from:q,args:re})}),C.$jS.on("vscode:closeProcessExplorer",O=>{this.d?.close()}),C.$jS.on("vscode:pidToNameRequest",async O=>{const L=await this.k.getMainDiagnostics(),N=[];for(const q of L.windows)N.push([q.pid,`window [${q.id}] (${q.title})`]);for(const{pid:q,name:re}of l.$F3b.getAll())N.push([q,re]);this.t(O,"vscode:pidToNameResponse",N)})}async openReporter(O){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const L=new M.$kb,N=L.add(this.n.createIPCObjectUrl()),q=this.v(this.c,700,800);this.b=this.u(q,N,{backgroundColor:O.styles.backgroundColor,title:(0,u.localize)(1,null),zoomLevel:O.zoomLevel,alwaysOnTop:!1},"issue-reporter"),N.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:O,disableExtensions:!!this.h.disableExtensions,os:{type:(0,r.type)(),arch:(0,r.arch)(),release:(0,r.release)()},product:o.default}),this.b.loadURL(R.$3e.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,L.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,L.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(O){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const L=new M.$kb,N=L.add(this.n.createIPCObjectUrl()),q=this.p.getItem(m,void 0),re=I(q)?q:this.v(this.f,800,500);this.d=this.u(re,N,{backgroundColor:O.styles.backgroundColor,title:(0,u.localize)(2,null),zoomLevel:O.zoomLevel,alwaysOnTop:!0},"process-explorer"),N.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:O,product:o.default}),this.d.loadURL(R.$3e.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,L.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,L.dispose())});const ne=()=>{if(!this.d)return;const ee=this.d.getSize(),ae=this.d.getPosition();if(!ee||!ae)return;const ue={width:ee[0],height:ee[1],x:ae[0],y:ae[1]};this.p.setItem(m,ue)};this.d.on("moved",ne),this.d.on("resized",ne)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const O=await E.contentTracing.stopRecording(`${(0,k.$Re)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null,O),buttons:[(0,u.localize)(5,null)]},(0,w.$Ae)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,O)}async getSystemStatus(){const[O,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(O,L)}async $getSystemInfo(){const[O,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(O,L)}async $getPerformanceInfo(){try{const[O,L]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(O,L)}catch(O){throw this.i.warn("issueService#getPerformanceInfo ",O.message),O}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(O){this.i.error(O)}}async $showConfirmCloseDialog(){if(this.b){const{response:O}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(6,null),buttons:[(0,u.localize)(7,null),(0,u.localize)(8,null)]},this.b);O===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:O}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(9,null),buttons:[(0,u.localize)(10,null),(0,u.localize)(11,null)]},this.b);return O===0}return!1}async $getIssueReporterUri(O){if(!this.c)throw new Error("Issue reporter window not available");const L=this.q.getWindowById(this.c.id);if(!L)throw new Error("Window not found");const N=`vscode:triggerIssueUriRequestHandlerResponse${L.id}`;return a.Promises.withAsyncBody(async(q,re)=>{const ne=new s.$dd;L.sendWhenReady("vscode:triggerIssueUriRequestHandler",ne.token,{replyChannel:N,extensionId:O}),C.$jS.once(N,(ee,ae)=>{q(n.URI.parse(ae))});try{await(0,a.$ug)(5e3),ne.cancel(),re(new Error("Timed out waiting for issue reporter URI"))}finally{C.$jS.removeHandler(N)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(O){O.isMinimized()&&O.restore(),O.focus()}t(O,L,...N){O.sender.isDestroyed()||O.sender.send(L,...N)}u(O,L,N,q){const re=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:O.width,height:O.height,minWidth:300,minHeight:200,x:O.x,y:O.y,title:N.title,backgroundColor:N.backgroundColor||At.a,webPreferences:{preload:R.$3e.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${L.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.$ED)(N.zoomLevel),sandbox:!0},alwaysOnTop:N.alwaysOnTop,experimentalDarkMode:!0});return re.setMenuBarVisibility(!1),re}v(O,L,N){let q;const re=E.screen.getAllDisplays();if(re.length===1)q=re[0];else{if(S.$j){const ae=E.screen.getCursorScreenPoint();q=E.screen.getDisplayNearestPoint(ae)}!q&&O&&(q=E.screen.getDisplayMatching(O.getBounds())),q||(q=E.screen.getPrimaryDisplay()||re[0])}const ne=q.bounds,ee={width:L,height:N,x:ne.x+ne.width/2-L/2,y:ne.y+ne.height/2-N/2};return ne.width>0&&ne.height>0&&(ee.x<ne.x&&(ee.x=ne.x),ee.y<ne.y&&(ee.y=ne.y),ee.x>ne.x+ne.width&&(ee.x=ne.x),ee.y>ne.y+ne.height&&(ee.y=ne.y),ee.width>ne.width&&(ee.width=ne.width),ee.height>ne.height&&(ee.height=ne.height)),ee}};e.$23b=P,e.$23b=P=pe([x(1,h.$$2b),x(2,v.$Pi),x(3,$.$3l),x(4,d.$I3b),x(5,p.$y3b),x(6,y.$Y3b),x(7,c.$13b),x(8,g.$8i),x(9,t.$OM),x(10,i.$m3b)],P);function I(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(te[299],ie([0,1,21,18,28,20,5,67,23,51,26,48,100]),function(G,e,E,C,r,M,R,S,f,u,$,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p4b=void 0;let h=class extends p.$n4b{constructor(y,o,g,c,b,k,w,t){super(y,o,c,b,k,t),this.e=g,this.u=w}s(y){return(0,p.$m4b)(`linux-${process.arch}`,y,this.k)}t(y){this.a&&(this.d(d.$yib.CheckingForUpdates(y)),this.i.request({url:this.a},E.CancellationToken.None).then(u.$Bo).then(o=>{!o||!o.url||!o.version||!o.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!y}),this.d(d.$yib.Idle(1))):this.d(d.$yib.AvailableForDownload(o))}).then(void 0,o=>{this.j.error(o),this.e.publicLog2("update:notAvailable",{explicit:!!y});const g=y?o.message||o:void 0;this.d(d.$yib.Idle(1,g))}))}async o(y){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):y.update.url&&this.u.openExternal(void 0,y.update.url),this.d(d.$yib.Idle(1))}};e.$p4b=h,e.$p4b=h=pe([x(0,M.$a3b),x(1,C.$Th),x(2,$.$Tk),x(3,r.$$2b),x(4,u.$wo),x(5,R.$Pi),x(6,S.$Y3b),x(7,f.$8i)],h)}),define(te[300],ie([0,1,47,42,27,8,21,55,9,7,142,22,18,28,16,20,5,67,23,51,26,48,100]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r4b=void 0;async function l(a,m=1e3){for(;!a();)await(0,M.$ug)(m)}let s;function n(){return typeof s>"u"&&(s=C.existsSync(f.$ac(f.$dc(process.execPath),"unins000.exe"))?0:1),s}let i=class extends t.$n4b{get cachePath(){const m=f.$ac((0,r.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return d.Promises.mkdir(m,{recursive:!0}).then(()=>m)}constructor(m,P,I,D,O,L,N,q,re){super(m,P,D,O,L,re),this.u=I,this.v=N,this.w=q}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(w.$yib.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(m){let P="win32";return process.arch!=="ia32"&&(P+=`-${process.arch}`),n()===1?P+="-archive":this.k.target==="user"&&(P+="-user"),(0,t.$m4b)(P,m,this.k)}t(m){this.a&&(this.d(w.$yib.CheckingForUpdates(m)),this.i.request({url:this.a},R.CancellationToken.None).then(b.$Bo).then(P=>{const I=n();return!P||!P.url||!P.version||!P.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!m}),this.d(w.$yib.Idle(I)),Promise.resolve(null)):I===1?(this.d(w.$yib.AvailableForDownload(P)),Promise.resolve(null)):(this.d(w.$yib.Downloading(P)),this.C(P.version).then(()=>this.B(P.version).then(D=>d.Promises.exists(D).then(O=>{if(O)return Promise.resolve(D);const L=P.url,N=P.hash,q=`${D}.tmp`;return this.i.request({url:L},R.CancellationToken.None).then(re=>this.v.writeFile(u.URI.file(q),re.stream)).then(N?()=>(0,$.$eS)(q,P.hash):()=>{}).then(()=>d.Promises.rename(q,D)).then(()=>D)})).then(D=>{const O=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:D},O?this.k.target==="user"?this.p():this.d(w.$yib.Downloaded(P)):this.d(w.$yib.Ready(P))})))}).then(void 0,P=>{this.j.error(P),this.u.publicLog2("update:notAvailable",{explicit:!!m});const I=m?P.message||P:void 0;this.d(w.$yib.Idle(n(),I))}))}async o(m){m.update.url&&this.w.openExternal(void 0,m.update.url),this.d(w.$yib.Idle(n()))}async B(m){const P=await this.cachePath;return f.$ac(P,`CodeSetup-${this.k.quality}-${m}.exe`)}async C(m=null){const P=m?L=>!new RegExp(`${this.k.quality}-${m}\\.exe$`).test(L):()=>!0,I=await this.cachePath,O=(await d.Promises.readdir(I)).filter(P).map(async L=>{try{await d.Promises.unlink(f.$ac(I,L))}catch{}});await Promise.all(O)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const m=this.state.update;this.d(w.$yib.Updating(m));const P=await this.cachePath;this.e.updateFilePath=f.$ac(P,`CodeSetup-${this.k.quality}-${m.version}.flag`),await d.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(w.$yib.Idle(n()))});const D=`${this.k.win32MutexName}-ready`,O=await new Promise((L,N)=>{G(["@vscode/windows-mutex"],L,N)});l(()=>O.isActive(D)).then(()=>this.d(w.$yib.Ready(m)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?C.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(m){if(this.state.type!=="idle")return;const P=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown"};this.d(w.$yib.Downloading(I)),this.e={packagePath:m},P?this.k.target==="user"?this.p():this.d(w.$yib.Downloaded(I)):this.d(w.$yib.Ready(I))}};e.$r4b=i,pe([S.$Rg],i.prototype,"cachePath",null),e.$r4b=i=pe([x(0,y.$a3b),x(1,p.$Th),x(2,k.$Tk),x(3,h.$$2b),x(4,b.$wo),x(5,o.$Pi),x(6,v.$Qj),x(7,g.$Y3b),x(8,c.$8i)],i)}),define(te[301],ie([0,1,14,8,21,50,3,2,15,9,65,4,7,188,64,18,61,28,63,16,20,5,23,79,250,83,26,102,80,81,29,30,54,128,134,39,34,53,66,24]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I,D,O,L,N,q,re,ne,ee,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z4b=void 0;var ue;(function(X){X[X.NONE=0]="NONE",X[X.NAVIGATING=1]="NAVIGATING",X[X.READY=2]="READY"})(ue||(ue={}));let K=class kt extends S.$lb{static{this.a="windowControlHeight"}get id(){return this.j}get win(){return this.k}get lastFocusTime(){return this.l}get backupPath(){return this.m?.backupPath}get openedWorkspace(){return this.m?.workspace}get profile(){if(!this.config)return;const U=this.O.profiles.find(W=>W.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&U?U:this.O.getProfileForWorkspace(this.config.workspace??(0,D.$Bh)(this.backupPath,this.isExtensionDevelopmentHost))??this.O.defaultProfile}get remoteAuthority(){return this.m?.remoteAuthority}get config(){return this.m}get isExtensionDevelopmentHost(){return!!this.m?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.m?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.m?.debugId}constructor(U,W,T,J,Z,ce,oe,j,A,F,H,V,z,B,Y,se,le,ge,Pe,Re){super(),this.J=W,this.L=T,this.M=J,this.N=Z,this.O=ce,this.P=oe,this.Q=j,this.R=A,this.S=F,this.U=H,this.W=V,this.X=z,this.Y=B,this.Z=Y,this.$=se,this.ab=le,this.bb=ge,this.db=Pe,this.eb=Re,this.b=this.B(new R.$7c),this.onWillLoad=this.b.event,this.c=this.B(new R.$7c),this.onDidSignalReady=this.c.event,this.f=this.B(new R.$7c),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new R.$7c),this.onDidClose=this.g.event,this.h=this.B(new R.$7c),this.onDidDestroy=this.h.event,this.l=-1,this.s=void 0,this.t=void 0,this.w=!1,this.z=[],this.C=[],this.D=void 0,this.F=void 0,this.G=this.B(this.bb.createIPCObjectUrl()),this.I=!1,this.fb=0;{const[Ae,Le]=this.pb(U.state);this.n=Ae,this.J.trace("window#ctor: using window state",Ae);const He=this.n.mode===0||this.n.mode===3,me=this.S.getValue("window"),be={width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y,backgroundColor:this.U.getBackgroundColor(),minWidth:P.$xD.WIDTH,minHeight:P.$xD.HEIGHT,show:!He,title:this.ab.nameLong,webPreferences:{preload:f.$3e.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.G.resource.toString()}`],v8CacheOptions:this.M.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,P.$ED)(me?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};d.$k?be.icon=(0,u.$ac)(this.M.appRoot,"resources/linux/code.png"):d.$i&&!this.M.isBuilt&&(be.icon=(0,u.$ac)(this.M.appRoot,"resources/win32/code_150x150.png")),d.$j&&!this.wb()&&(be.fullscreenable=!1),d.$j&&(be.acceptFirstMouse=!0,me?.clickThroughInactive===!1&&(be.acceptFirstMouse=!1));const _=d.$j&&me?.nativeTabs===!0;_&&(be.tabbingIdentifier=this.ab.nameShort);const he=(0,P.$CD)(this.S)==="custom";if(he&&(be.titleBarStyle="hidden",d.$j||(be.frame=!1),(0,P.$DD)(this.S))){const de=this.U.getWindowSplash()?.colorInfo.titleBarBackground??this.U.getBackgroundColor(),Se=N.$8r.fromHex(de).isDarker()?"#FFFFFF":"#000000";be.titleBarOverlay={height:29,color:de,symbolColor:Se},this.w=!0}if((0,$.mark)("code/willCreateCodeBrowserWindow"),this.k=new E.BrowserWindow(be),(0,$.mark)("code/didCreateCodeBrowserWindow"),this.j=this.k.id,d.$j&&he&&this.k.setSheetOffset(22),he&&(d.$i&&(0,P.$DD)(this.S)||d.$j)){const de=this.eb.getItem(kt.a);de&&this.updateWindowControls({height:de})}d.$i&&he&&this.k.hookWindowMessage(278,()=>{const[Se,Ce]=this.k.getPosition(),je=E.screen.getCursorScreenPoint(),Oe=je.x-Se,Te=je.y-Ce;return(()=>!(Oe>30&&Te>=0&&Te<=Math.max(this.k.getBounds().height*.15,35)))()||(this.k.setEnabled(!1),this.k.setEnabled(!0),this.f.fire({x:Oe,y:Te})),0}),(d.$j||d.$i)&&Le&&(!_||E.BrowserWindow.getAllWindows().length===1)&&[this.n.width,this.n.height,this.n.x,this.n.y].every(de=>typeof de=="number")&&this.k.setBounds({width:this.n.width,height:this.n.height,x:this.n.x,y:this.n.y}),He&&((0,$.mark)("code/willMaximizeCodeWindow"),this.k.maximize(),this.n.mode===3&&this.sb(!0),this.k.show(),(0,$.mark)("code/didMaximizeCodeWindow")),this.l=Date.now()}this.M.args["open-devtools"]===!0&&this.k.webContents.openDevTools(),this.mb(),this.Ab(),this.gb()}setRepresentedFilename(U){d.$j?this.k.setRepresentedFilename(U):this.u=U}getRepresentedFilename(){return d.$j?this.k.getRepresentedFilename():this.u}setDocumentEdited(U){d.$j&&this.k.setDocumentEdited(U),this.v=U}isDocumentEdited(){return d.$j?this.k.isDocumentEdited():!!this.v}focus(U){d.$j&&U?.force&&E.app.focus({steal:!0}),this.k&&(this.k.isMinimized()&&this.k.restore(),this.k.focus())}setReady(){for(this.J.trace(`window#load: window reported ready (id: ${this.j})`),this.fb=2;this.z.length;)this.z.pop()(this);this.c.fire()}ready(){return new Promise(U=>{if(this.isReady)return U(this);this.z.push(U)})}get isReady(){return this.fb===2}get whenClosedOrLoaded(){return new Promise(U=>{function W(){T.dispose(),J.dispose(),U()}const T=this.onDidClose(()=>W()),J=this.onWillLoad(()=>W())})}gb(){this.k.on("unresponsive",()=>this.jb(1)),this.k.webContents.on("render-process-gone",(W,T)=>this.jb(2,{...T})),this.k.webContents.on("did-fail-load",(W,T,J)=>this.jb(3,{reason:J,exitCode:T})),this.k.webContents.on("will-prevent-unload",W=>{W.preventDefault()}),this.k.on("closed",()=>{this.g.fire(),this.dispose()}),this.k.webContents.on("did-finish-load",()=>{this.H&&(this.m=this.H,this.H=void 0)}),this.k.on("focus",()=>{this.l=Date.now()}),this.k.on("maximize",W=>{this.m&&(this.m.maximized=!0),E.app.emit("browser-window-maximize",W,this.k)}),this.k.on("unmaximize",W=>{this.m&&(this.m.maximized=!1),E.app.emit("browser-window-unmaximize",W,this.k)}),this.k.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",r.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.k.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",r.CancellationToken.None),this.t?.complete(),this.t=void 0}),this.B(this.S.onDidChangeConfiguration(W=>this.mb(W))),this.B(this.W.onDidDeleteUntitledWorkspace(W=>this.lb(W)));const U=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.k.webContents.session.webRequest.onBeforeSendHeaders({urls:U},async(W,T)=>{const J=await this.ib();T({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,J)})})}ib(){return this.hb||(this.hb=(0,s.$Po)(this.ab.version,this.ab,this.M,this.S,this.P,this.Q,this.Y)),this.hb}async jb(U,W){switch(U){case 2:this.J.error(`CodeWindow: renderer process gone (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break;case 1:this.J.error("CodeWindow: detected unresponsive");break;case 3:this.J.error(`CodeWindow: failed to load (reason: ${W?.reason||"<unknown>"}, code: ${W?.exitCode||"<unknown>"})`);break}switch(this.Y.publicLog2("windowerror",{type:U,reason:W?.reason,code:W?.exitCode}),U){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.$.kill(1);return}if(this.M.args["enable-smoke-test-driver"]){await this.kb(!1,!1),this.$.quit();return}if(U===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.k&&this.k.webContents&&this.k.webContents.isDevToolsOpened())return;const{response:T,checkboxChecked:J}=await this.Z.showMessageBox({type:"warning",buttons:[(0,h.localize)(0,null),(0,h.localize)(1,null),(0,h.localize)(2,null)],message:(0,h.localize)(3,null),detail:(0,h.localize)(4,null),checkboxLabel:this.m?.workspace?(0,h.localize)(5,null):void 0},this.k);if(T!==2){const Z=T===0;await this.kb(Z,J)}}else if(U===2){let T;W?T=(0,h.localize)(7,null,W.reason,W.exitCode??"<unknown>"):T=(0,h.localize)(6,null);const{response:J,checkboxChecked:Z}=await this.Z.showMessageBox({type:"warning",buttons:[this.m?.workspace?(0,h.localize)(8,null):(0,h.localize)(9,null),(0,h.localize)(10,null)],message:T,detail:this.m?.workspace?(0,h.localize)(11,null):(0,h.localize)(12,null),checkboxLabel:this.m?.workspace?(0,h.localize)(13,null):void 0},this.k),ce=J===0;await this.kb(ce,Z)}break}}async kb(U,W){const T=this.m?.workspace;if(W&&T)try{const J=this.R.workspaceStorage(T);await J.init(),J.delete("memento/workbench.parts.editor"),await J.close()}catch(J){this.J.error(J)}if(this.h.fire(),this.k?.destroy(),U&&this.m){let J,Z;(0,D.$xh)(T)?J={folderUri:T.uri}:(0,D.$Ch)(T)?J={workspaceUri:T.configPath}:Z=!0,(0,ae.$uf)(await this.db.open({context:5,userEnv:this.m.userEnv,cli:{...this.M.args,_:[]},urisToOpen:J?[J]:void 0,forceEmpty:Z,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}lb(U){this.m?.workspace?.id===U.id&&(this.m.workspace=void 0)}mb(U){if(!U||U.affectsConfiguration("window.menuBarVisibility")){const W=this.xb();W!==this.r&&(this.r=W,this.yb(W))}if(!U||U.affectsConfiguration("http.proxy")){let W=(this.S.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;W?.endsWith("/")&&(W=W.substr(0,W.length-1));const T=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((W||"").indexOf("@")===-1&&(W!==this.D||T!==this.F)){this.D=W,this.F=T;const J=W||"",Z=T?`${T},<local>`:"<local>";this.J.trace(`Setting proxy to '${J}', bypassing '${Z}'`),this.k.webContents.session.setProxy({proxyRules:J,proxyBypassRules:Z,pacScript:""})}}}addTabbedWindow(U){d.$j&&U.win&&this.k.addTabbedWindow(U.win)}load(U,W=Object.create(null)){this.J.trace(`window#load: attempt to load window (id: ${this.j})`),this.isDocumentEdited()&&(!W.isReload||!this.X.isHotExitEnabled())&&this.setDocumentEdited(!1),W.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.k.setTitle(this.ab.nameLong)),this.nb(U,W),this.fb===0?this.m=U:this.H=U,this.fb=1,this.k.loadURL(f.$3e.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.M.isBuilt?"":"-dev"}.html`).toString(!0));const T=this.I;this.I=!0,!this.M.isBuilt&&!this.M.extensionTestsLocationURI&&this.B(new C.$Eg(()=>{this.k&&!this.k.isVisible()&&!this.k.isMinimized()&&(this.k.show(),this.focus({force:!0}),this.k.webContents.openDevTools())},1e4)).schedule(),this.b.fire({workspace:U.workspace,reason:W.isReload?3:T?2:1})}nb(U,W){const T=(this.m??this.H)?.userEnv;if(T){const J=(0,c.$ql)(T)&&!(0,c.$ql)(U.userEnv),Z=this.isExtensionDevelopmentHost;(J||Z)&&(U.userEnv={...T,...U.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(U.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),W.disableExtensions!==void 0&&(U["disable-extensions"]=W.disableExtensions),U.fullscreen=this.isFullScreen,U.maximized=this.k.isMaximized(),U.partsSplash=this.U.getWindowSplash(),(0,$.mark)("code/willOpenNewWindow"),U.perfMarks=(0,$.getMarks)(),this.G.update(U)}async reload(U){const W=Object.assign({},this.m);W.workspace=await this.ob(W),delete W.filesToOpenOrCreate,delete W.filesToDiff,delete W.filesToMerge,delete W.filesToWait,this.isExtensionDevelopmentHost&&U&&(W.verbose=U.verbose,W.debugId=U.debugId,W.extensionEnvironment=U.extensionEnvironment,W["inspect-extensions"]=U["inspect-extensions"],W["inspect-brk-extensions"]=U["inspect-brk-extensions"],W["extensions-dir"]=U["extensions-dir"]),W.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),W.isInitialStartup=!1,W.policiesData=this.N.serialize(),W.continueOn=this.M.continueOn,W.profiles={all:this.O.profiles,profile:this.profile||this.O.defaultProfile,home:this.O.profilesHome},W.logLevel=this.L.getLogLevel(),W.loggers={window:this.L.getRegisteredLoggers(this.id),global:this.L.getRegisteredLoggers()},this.load(W,{isReload:!0,disableExtensions:U?.["disable-extensions"]})}async ob(U){if((0,D.$Ch)(U.workspace)){const W=U.workspace.configPath;if(W.scheme===f.Schemas.file&&!await this.P.exists(W))return}else if((0,D.$xh)(U.workspace)){const W=U.workspace.uri;if(W.scheme===f.Schemas.file&&!await this.P.exists(W))return}return U.workspace}serializeWindowState(){if(!this.k)return(0,L.$02b)();if(this.isFullScreen){let T;try{T=E.screen.getDisplayMatching(this.getBounds())}catch{}const J=(0,L.$02b)();return{mode:3,display:T?T.id:void 0,width:this.n.width||J.width,height:this.n.height||J.height,x:this.n.x||0,y:this.n.y||0}}const U=Object.create(null);let W;if(!d.$j&&this.k.isMaximized()?W=0:W=1,W===0?U.mode=0:U.mode=1,W===1||W===0){let T;W===1?T=this.getBounds():T=this.k.getNormalBounds(),U.x=T.x,U.y=T.y,U.width=T.width,U.height=T.height}return U}updateWindowControls(U){if(U.height&&this.eb.setItem(kt.a,U.height),d.$i&&this.w)this.k.setTitleBarOverlay({color:U.backgroundColor?.trim()===""?void 0:U.backgroundColor,symbolColor:U.foregroundColor?.trim()===""?void 0:U.foregroundColor,height:U.height?U.height-1:void 0});else if(d.$j&&U.height!==void 0){const W=(U.height-15)/2;this.k.setTrafficLightPosition({x:W,y:W})}}pb(U){(0,$.mark)("code/willRestoreCodeWindowState");let W=!1;if(U)try{const T=E.screen.getAllDisplays();W=T.length>1,U=this.qb(U,T)}catch(T){this.J.warn(`Unexpected error validating window state: ${T}
${T.stack}`)}return(0,$.mark)("code/didRestoreCodeWindowState"),[U||(0,L.$02b)(),W]}qb(U,W){if(this.J.trace(`window#validateWindowState: validating window state on ${W.length} display(s)`,U),typeof U.x!="number"||typeof U.y!="number"||typeof U.width!="number"||typeof U.height!="number"){this.J.trace("window#validateWindowState: unexpected type of state values");return}if(U.width<=0||U.height<=0){this.J.trace("window#validateWindowState: unexpected negative values");return}if(W.length===1){const Z=this.rb(W[0]);if(Z){let ce=function(){!U||typeof U.x!="number"||typeof U.y!="number"||!Z||(U.x<Z.x&&(U.x=Z.x),U.y<Z.y&&(U.y=Z.y))};this.J.trace("window#validateWindowState: 1 monitor working area",Z),ce(),U.width>Z.width&&(U.width=Z.width),U.height>Z.height&&(U.height=Z.height),U.x>Z.x+Z.width-128&&(U.x=Z.x+Z.width-U.width),U.y>Z.y+Z.height-128&&(U.y=Z.y+Z.height-U.height),ce()}return U}if(U.display&&U.mode===3){const Z=W.find(ce=>ce.id===U.display);if(Z&&typeof Z.bounds?.x=="number"&&typeof Z.bounds?.y=="number"){this.J.trace("window#validateWindowState: restoring fullscreen to previous display");const ce=(0,L.$02b)(3);return ce.x=Z.bounds.x,ce.y=Z.bounds.y,ce}}let T,J;try{T=E.screen.getDisplayMatching({x:U.x,y:U.y,width:U.width,height:U.height}),J=this.rb(T)}catch{}if(T&&J&&U.x+U.width>J.x&&U.y+U.height>J.y&&U.x<J.x+J.width&&U.y<J.y+J.height)return this.J.trace("window#validateWindowState: multi-monitor working area",J),U}rb(U){if(U.workArea.width>0&&U.workArea.height>0)return U.workArea;if(U.bounds.width>0&&U.bounds.height>0)return U.bounds}getBounds(){const[U,W]=this.k.getPosition(),[T,J]=this.k.getSize();return{x:U,y:W,width:T,height:J}}toggleFullScreen(){this.sb(!this.isFullScreen)}sb(U){this.wb()?this.tb(U):this.vb(U),this.sendWhenReady(U?"vscode:enterFullScreen":"vscode:leaveFullScreen",r.CancellationToken.None),this.r&&this.yb(this.r,!1)}get isFullScreen(){return d.$j&&typeof this.s=="boolean"?this.s:this.k.isFullScreen()||this.k.isSimpleFullScreen()}tb(U){this.k.isSimpleFullScreen()&&this.k.setSimpleFullScreen(!1),this.ub(U)}ub(U){d.$j&&(this.s=U,this.t=new C.$Ng,Promise.race([this.t.p,(0,C.$ug)(1e3)]).finally(()=>this.s=void 0)),this.k.setFullScreen(U)}vb(U){this.k.isFullScreen()&&this.ub(!1),this.k.setSimpleFullScreen(U),this.k.webContents.focus()}wb(){const U=this.S.getValue("window");return!U||typeof U.nativeFullScreen!="boolean"||U.nativeTabs?!0:U.nativeFullScreen!==!1}isMinimized(){return this.k.isMinimized()}xb(){let U=(0,P.$BD)(this.S);return["visible","toggle","hidden"].indexOf(U)<0&&(U="classic"),U}yb(U,W=!0){d.$j||(U==="toggle"&&W&&this.send("vscode:showInfoMessage",(0,h.localize)(14,null)),U==="hidden"?setTimeout(()=>{this.zb(U)}):this.zb(U))}zb(U){const W=this.isFullScreen;switch(U){case"classic":this.k.setMenuBarVisibility(!W),this.k.autoHideMenuBar=W;break;case"visible":this.k.setMenuBarVisibility(!0),this.k.autoHideMenuBar=!1;break;case"toggle":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!0;break;case"hidden":this.k.setMenuBarVisibility(!1),this.k.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(d.$j)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.k.minimize();break;case"None":break;case"Maximize":default:this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}else this.k.isMaximized()?this.k.unmaximize():this.k.maximize()}close(){this.k?.close()}sendWhenReady(U,W,...T){this.isReady?this.send(U,...T):this.ready().then(()=>{W.isCancellationRequested||this.send(U,...T)})}send(U,...W){if(this.k){if(this.k.isDestroyed()||this.k.webContents.isDestroyed()){this.J.warn(`Sending IPC message to channel '${U}' for window that is destroyed`);return}try{this.k.webContents.send(U,...W)}catch(T){this.J.warn(`Error sending IPC message to channel '${U}' of window ${this.j}: ${(0,M.$$h)(T)}`)}}}updateTouchBar(U){d.$j&&this.C.forEach((W,T)=>{const J=U[T];W.segments=this.Cb(J)})}Ab(){if(d.$j){for(let U=0;U<10;U++){const W=this.Bb();this.C.push(W)}this.k.setTouchBar(new E.TouchBar({items:this.C}))}}Bb(U=[]){const W=this.Cb(U),T=new E.TouchBar.TouchBarSegmentedControl({segments:W,mode:"buttons",segmentStyle:"automatic",change:J=>{this.sendWhenReady("vscode:runAction",r.CancellationToken.None,{id:T.segments[J].id,from:"touchbar"})}});return T}Cb(U=[]){return U.map(T=>{let J;T.icon&&!a.ThemeIcon.isThemeIcon(T.icon)&&T.icon?.dark?.scheme===f.Schemas.file&&(J=E.nativeImage.createFromPath(p.URI.revive(T.icon.dark).fsPath),J.isEmpty()&&(J=void 0));let Z;return typeof T.title=="string"?Z=T.title:Z=T.title.value,{id:T.id,label:J?void 0:Z,icon:J}})}dispose(){super.dispose(),this.L.deregisterLoggers(this.id),this.k=null}};e.$z4b=K,e.$z4b=K=pe([x(1,w.$Pi),x(2,ee.$e4b),x(3,g.$$2b),x(4,q.$Tm),x(5,ne.$g3b),x(6,b.$Qj),x(7,n.$k3b),x(8,n.$i3b),x(9,y.$Th),x(10,m.$U3b),x(11,O.$D3b),x(12,v.$r3b),x(13,i.$Tk),x(14,o.$y3b),x(15,k.$a3b),x(16,t.$8i),x(17,l.$13b),x(18,I.$m3b),x(19,re.$OM)],K)}),define(te[84],ie([0,1,14,24,8,3,46,2,15,4,19,7,22,191,6,20,5,83,98,30,54,35]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a4b=e.$_3b=void 0,e.$_3b=(0,v.$nh)("workspacesHistoryMainService");let t=class nt extends S.$lb{static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(s,n,i,a){super(),this.f=s,this.g=n,this.h=i,this.j=a,this.c=this.B(new M.$7c),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new r.$rg(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}async addRecentlyOpened(s){let n=[],i=[];for(const m of s)if((0,c.$Bab)(m))!this.g.isUntitledWorkspace(m.workspace)&&!this.r(n,m.workspace)&&n.push(m);else if((0,c.$Cab)(m))this.s(n,m.folderUri)||n.push(m);else{const P=this.t(i,m.fileUri),I=m.fileUri.scheme===f.Schemas.file&&nt.y.indexOf((0,$.$5f)(m.fileUri))>=0;!P&&!I&&(i.push(m),u.$i&&m.fileUri.scheme===f.Schemas.file&&E.app.addRecentDocument(m.fileUri.fsPath))}const a=await this.l({workspaces:n,files:i});n=a.workspaces,i=a.files,n.length>nt.a&&(n.length=nt.a),i.length>nt.a&&(i.length=nt.a),await this.n({workspaces:n,files:i}),this.c.fire(),u.$j&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(s){const n=P=>{const I=this.p(P);for(const D of s)if($.$Yf.isEqual(D,I))return!1;return!0},i=await this.getRecentlyOpened(),a=i.workspaces.filter(n),m=i.files.filter(n);(a.length!==i.workspaces.length||m.length!==i.files.length)&&(await this.n({files:m,workspaces:a}),this.c.fire(),u.$j&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(s){const n=new w.$li(m=>$.$Yf.getComparisonKey(m));if(s?.workspaces)for(const m of s.workspaces)n.set(this.p(m),m);const i=new w.$li(m=>$.$Yf.getComparisonKey(m));if(s?.files)for(const m of s.files)i.set(this.p(m),m);const a=await this.m();for(const m of a.workspaces){const P=n.get(this.p(m));P?P.label=P.label??m.label:n.set(this.p(m),m)}for(const m of a.files){const P=i.get(this.p(m));P?P.label=P.label??m.label:i.set(this.p(m),m)}return{workspaces:[...n.values()],files:[...i.values()]}}async m(){await this.j.whenReady;let s;const n=this.j.get(nt.b,-1);if(typeof n=="string")try{s=JSON.parse(n)}catch(i){this.f.error("Unexpected error parsing opened paths list",i)}return(0,c.$Iab)(s,this.f)}async n(s){await this.j.whenReady,this.j.store(nt.b,JSON.stringify((0,c.$Jab)(s)),-1,1)}p(s){return(0,c.$Cab)(s)?s.folderUri:(0,c.$Dab)(s)?s.fileUri:s.workspace.configPath}r(s,n){return!!s.find(i=>(0,c.$Bab)(i)&&i.workspace.id===n.id)}s(s,n){return!!s.find(i=>(0,c.$Cab)(i)&&$.$Yf.isEqual(i.folderUri,n))}t(s,n){return!!s.find(i=>$.$Yf.isEqual(i.fileUri,n))}static{this.u=7}static{this.v=10}static{this.w=7}static{this.y=["COMMIT_EDITMSG","MERGE_MSG"]}async C(){u.$i&&(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!u.$i)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,h.localize)(0,null),description:(0,h.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const m of E.app.getJumpListSettings().removedItems){const P=m.args;if(P){const I=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(P);I&&n.push(d.URI.parse(I[2]))}}await this.removeRecentlyOpened(n);let i=!1;const a=(0,C.$lf)((await this.getRecentlyOpened()).workspaces.slice(0,nt.w).map(m=>{const P=(0,c.$Bab)(m)?m.workspace:m.folderUri,{title:I,description:D}=this.F(P,m.label);let O;return d.URI.isUri(P)?O=`--folder-uri "${P.toString()}"`:(i=!0,O=`--file-uri "${P.configPath.toString()}"`),{type:"task",title:I.substr(0,255),description:D.substr(0,255),program:process.execPath,args:O,iconPath:"explorer.exe",iconIndex:0}}));a.length>0&&s.push({type:"custom",name:i?(0,h.localize)(2,null):(0,h.localize)(3,null),items:a})}s.push({type:"recent"});try{const n=E.app.setJumpList(s);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}F(s,n){if(n)return{title:(0,R.$7z)(n).name,description:n};if(d.URI.isUri(s))return{title:(0,$.$5f)(s),description:this.G(s)};if(this.g.isUntitledWorkspace(s))return{title:(0,h.localize)(4,null),description:""};let i=(0,$.$5f)(s.configPath);return i.endsWith(b.$Jh)&&(i=i.substr(0,i.length-b.$Jh.length-1)),{title:(0,h.localize)(5,null,i),description:this.G(s.configPath)}}G(s){return s.scheme==="file"?(0,R.$Yz)(s.fsPath):s.toString()}async H(){if(!u.$j)return;E.app.clearRecentDocuments();const s=await this.getRecentlyOpened(),n=[];let i=0;for(let m=0;m<s.workspaces.length&&i<nt.u;m++){const P=this.p(s.workspaces[m]);if(P.scheme===f.Schemas.file){const I=(0,$.$Vf)(P);await p.Promises.exists(I)&&(n.push(I),i++)}}const a=[];for(let m=0;m<s.files.length&&i<nt.v;m++){const P=this.p(s.files[m]);if(P.scheme===f.Schemas.file){const I=(0,$.$Vf)(P);if(nt.y.includes((0,$.$5f)(P))||n.includes(I))continue;await p.Promises.exists(I)&&(a.push(I),i++)}}a.reverse().forEach(m=>E.app.addRecentDocument(m)),n.reverse().forEach(m=>E.app.addRecentDocument(m))}};e.$a4b=t,e.$a4b=t=pe([x(0,o.$Pi),x(1,k.$D3b),x(2,y.$a3b),x(3,g.$k3b)],t)}),define(te[302],ie([0,1,14,8,21,46,4,7,179,18,28,20,5,229,67,23,34,26,48,81,29,84]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b4b=void 0;const t="menu";let l=class Et{static{this.a="lastKnownMenubarData"}constructor(i,a,m,P,I,D,O,L,N,q,re){this.n=i,this.o=a,this.p=m,this.q=P,this.r=I,this.s=D,this.t=O,this.u=L,this.v=N,this.w=q,this.x=re,this.m=Object.create(null),this.g=new C.$Eg(()=>this.E(),0),this.h=new C.$Eg(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(R.$j||(0,b.$CD)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const i=this.t.getItem(Et.a);i&&(i.menus&&(this.k=i.menus),i.keybindings&&(this.l=i.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(D,O,L)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.newWindow"]=(D,O,L)=>this.p.openEmptyWindow({context:2,contextWindowId:O?.id}),this.m["workbench.action.files.openFileFolder"]=(D,O,L)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(L),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(D,O,L)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(L),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(D,O,L)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(L),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const i=this.x.twitterUrl;i&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(i,"openTwitterUrl"));const a=this.x.requestFeatureUrl;a&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(a,"openUserVoiceUrl"));const m=this.x.reportIssueUrl;m&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(m,"openReportIssues"));const P=this.x.licenseUrl;P&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(R.$v){const D=P.indexOf("?")>0?"&":"?";this.Z(`${P}${D}lang=${R.$v}`,"openLicenseUrl")}else this.Z(P,"openLicenseUrl")});const I=this.x.privacyStatementUrl;I&&P&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(I,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(i=>this.F(i)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const i=this.o.getValue("window.enableMenuBarMnemonics");return typeof i!="boolean"?!0:i}get C(){if(!R.$j)return!1;const i=this.o.getValue("window.nativeTabs");return typeof i!="boolean"?!1:i}updateMenu(i,a){this.k=i.menus,this.l=i.keybindings,this.t.setItem(Et.a,i),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(i){R.$j&&(i.oldCount===0&&i.newCount>0||i.oldCount>0&&i.newCount===0)&&(this.d=i.newCount===0,this.D())}G(){R.$j&&(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const i=E.Menu.getApplicationMenu();if(i&&this.j.push(i),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(R.$j?new E.Menu:null);return}const a=new E.Menu;let m;if(R.$j){const I=new E.Menu;m=new E.MenuItem({label:this.x.nameShort,submenu:I}),this.I(I),a.append(m)}if(R.$j&&!this.c){this.c=!0;const I=new E.Menu;I.append(new E.MenuItem({label:this.ab(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(I)}if(this.K("File")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(1,null)),submenu:I});this.M(I,"File"),a.append(D)}if(this.K("Edit")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(2,null)),submenu:I});this.M(I,"Edit"),a.append(D)}if(this.K("Selection")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(3,null)),submenu:I});this.M(I,"Selection"),a.append(D)}if(this.K("View")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(4,null)),submenu:I});this.M(I,"View"),a.append(D)}if(this.K("Go")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(5,null)),submenu:I});this.M(I,"Go"),a.append(D)}if(this.K("Run")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(6,null)),submenu:I});this.M(I,"Run"),a.append(D)}if(this.K("Terminal")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(7,null)),submenu:I});this.M(I,"Terminal"),a.append(D)}let P;if(this.K("Window")){const I=new E.Menu;P=new E.MenuItem({label:this.ab(f.localize(8,null)),submenu:I,role:"window"}),this.S(I)}if(P&&a.append(P),this.K("Help")){const I=new E.Menu,D=new E.MenuItem({label:this.ab(f.localize(9,null)),submenu:I,role:"help"});this.M(I,"Help"),a.append(D)}a.items&&a.items.length>0?E.Menu.setApplicationMenu(a):E.Menu.setApplicationMenu(null),this.h.schedule()}I(i){const a=this.U(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),m=this.T();let P;if(this.K("Preferences")){const ne=new E.Menu;this.M(ne,"Preferences"),P=new E.MenuItem({label:this.ab(f.localize(11,null)),submenu:ne})}const I=new E.Menu,D=new E.MenuItem({label:f.localize(12,null),role:"services",submenu:I}),O=new E.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),L=new E.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),N=new E.MenuItem({label:f.localize(15,null),role:"unhide"}),q=new E.MenuItem(this.Y("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(ne,ee,ae)=>{const ue=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||E.BrowserWindow.getFocusedWindow()||ue?.isMinimized())&&await this.J(ae)&&this.w.quit(void 0)}})),re=[a];re.push(...m),P&&re.push(s(),P),re.push(s(),D,s(),O,L,N,s(),q),re.forEach(ne=>i.append(ne))}async J(i){if(this.p.getWindowCount()===0)return!0;const a=this.o.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.Q(i)){const{response:m}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return m===0}return!0}K(i){if(!R.$j&&(0,b.$CD)(this.o)==="custom")return!1;switch(i){case"File":case"Help":if(R.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[i];case"Window":if(R.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[i]}}L(i,a){a.forEach(m=>{if((0,h.$93b)(m))i.append(s());else if((0,h.$83b)(m)){const P=new E.Menu,I=new E.MenuItem({label:this.ab(m.label),submenu:P});this.L(P,m.submenu.items),i.append(I)}else(0,h.$03b)(m)?i.append(this.O(m)):(0,h.$$3b)(m)&&(m.id==="workbench.action.showAboutDialog"&&this.N(i),R.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[m.id]?i.append(new E.MenuItem(this.Y(m.id,{label:this.ab(m.label),click:this.m[m.id]}))):i.append(this.U(m.label,m.id,!1,m.checked)):i.append(this.U(m.label,m.id,m.enabled!==!1,!!m.checked)):i.append(this.U(m.label,m.id,m.enabled!==!1,!!m.checked)))})}M(i,a){this.k&&this.k[a]&&this.L(i,this.k[a].items)}N(i){const a=this.T();a.length&&(a.forEach(m=>i.append(m)),i.append(s()))}O(i){const a=S.URI.revive(i.uri),m=i.id,P=m==="openRecentFile"?{fileUri:a}:m==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new E.MenuItem(this.Y(m,{label:i.label,click:async(I,D,O)=>{const L=this.P(O);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[P],forceNewWindow:L,gotoLineMode:!1,remoteAuthority:i.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([a])}},!1))}P(i){return!!(i&&(!R.$j&&(i.ctrlKey||i.shiftKey)||R.$j&&(i.metaKey||i.altKey)))}Q(i){return!!(i.triggeredByAccelerator||i.altKey||i.ctrlKey||i.metaKey||i.shiftKey)}R(i,a,m){const P={label:this.ab(i),role:m,enabled:!0};return new E.MenuItem(this.X(a,P))}S(i){const a=new E.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),m=new E.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),P=new E.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),I=this.U(f.localize(23,null),"workbench.action.switchWindow"),D=[];this.C&&(D.push(s()),D.push(this.U(f.localize(24,null),"workbench.action.newWindowTab")),D.push(this.R(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),D.push(this.R(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),D.push(this.R(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),D.push(this.R(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,m,s(),I,...D,s(),P].forEach(O=>i.append(O))}T(){switch(this.n.state.type){case"idle":return[new E.MenuItem({label:this.ab(f.localize(29,null)),click:()=>setTimeout(()=>{this.$("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.ab(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.ab(f.localize(33,null)),click:()=>{this.$("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.ab(f.localize(35,null)),click:()=>{this.$("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}U(i,a,m,P){const I=this.ab(i),D=typeof a=="function"?a:(re,ne,ee)=>{const ae=re?re.userSettingsLabel:null;let ue=a;Array.isArray(a)&&(ue=this.P(ee)?a[1]:a[0]),ae&&ee.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ae}):this.W({type:"commandId",commandId:ue})},O=typeof m=="boolean"?m:this.p.getWindowCount()>0,L=typeof P=="boolean"?P:!1,N={label:I,click:D,enabled:O};L&&(N.type="checkbox",N.checked=L);let q;return typeof a=="string"?q=a:Array.isArray(a)&&(q=a[0]),R.$j&&(q==="editor.action.clipboardCutAction"?N.role="cut":q==="editor.action.clipboardCopyAction"?N.role="copy":q==="editor.action.clipboardPasteAction"&&(N.role="paste"),q==="undo"?N.click=this.V(D,{inDevTools:re=>re.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?N.click=this.V(D,{inDevTools:re=>re.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&(N.click=this.V(D,{inDevTools:re=>re.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(q,N))}V(i,a){return(m,P,I)=>{const D=E.BrowserWindow.getFocusedWindow();if(!D)return a.inNoWindow();if(D.webContents.isDevToolsFocused()&&D.webContents.devToolsWebContents)return a.inDevTools(D.webContents.devToolsWebContents);i(m,P||D,I)}}W(i){let a=E.BrowserWindow.getFocusedWindow();if(!a){const P=this.p.getLastActiveWindow();P?.isMinimized()&&(a=P.win)}const m=a?this.p.getWindowById(a.id):void 0;if(m){if(this.v.trace("menubar#runActionInRenderer",i),R.$j&&!this.q.isBuilt&&!m.isReady&&(i.type==="commandId"&&i.commandId==="workbench.action.toggleDevTools"||i.type!=="commandId"&&i.userSettingsLabel==="alt+cmd+i"))return;if(i.type==="commandId"){const P={id:i.commandId,from:"menu"};m.sendWhenReady("vscode:runAction",r.CancellationToken.None,P)}else{const P={userSettingsLabel:i.userSettingsLabel};m.sendWhenReady("vscode:runKeybinding",r.CancellationToken.None,P)}}else this.v.trace("menubar#runActionInRenderer: no active window found",i)}X(i,a){const m=typeof i=="string"?this.l[i]:void 0;if(m?.label){if(m.isNative!==!1)a.accelerator=m.label,a.userSettingsLabel=m.userSettingsLabel;else if(typeof a.label=="string"){const P=a.label.indexOf("[");P>=0?a.label=`${a.label.substr(0,P)} [${m.label}]`:a.label=`${a.label} [${m.label}]`}}else a.accelerator=void 0;return a}Y(i,a,m=!a.accelerator){m&&(a=this.X(i,a));const P=a.click;return a.click=(I,D,O)=>{this.$(i),P?.(I,D,O)},a}Z(i,a){this.w.openExternal(void 0,i),this.$(a)}$(i){this.r.publicLog2("workbenchActionExecuted",{id:i,from:t})}ab(i){return(0,M.$4z)(i,!this.B)}};e.$b4b=l,e.$b4b=l=pe([x(0,c.$zib),x(1,u.$Th),x(2,k.$m3b),x(3,$.$$2b),x(4,g.$Tk),x(5,w.$_3b),x(6,o.$OM),x(7,d.$a3b),x(8,p.$Pi),x(9,v.$Y3b),x(10,y.$8i)],l);function s(){return new E.MenuItem({type:"separator"})}}),define(te[303],ie([0,1,6,20,5,302]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d4b=e.$c4b=void 0,e.$c4b=(0,E.$nh)("menubarMainService");let R=class{constructor(f,u,$){this.b=f,this.c=u,this.d=$,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(M.$b4b)}async updateMenubar(f,u){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(u,f)}};e.$d4b=R,e.$d4b=R=pe([x(0,E.$mh),x(1,C.$a3b),x(2,r.$Pi)],R)}),define(te[304],ie([0,1,14,22,132,27,24,21,3,32,49,46,2,15,9,65,4,36,19,10,7,189,64,18,61,28,16,6,20,5,78,79,60,34,81,301,130,297,30,99,84,54,80,39,53,66]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I,D,O,L,N,q,re,ne,ee,ae,ue,K,X,U,W,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D4b=void 0;function J(oe){return(0,ee.$Ch)(oe?.workspace)}function Z(oe){return(0,ee.$xh)(oe?.workspace)}let ce=class at extends p.$lb{static{this.a=[]}constructor(j,A,F,H,V,z,B,Y,se,le,ge,Pe,Re,Ae,Le,He,me,be){super(),this.k=j,this.l=A,this.m=F,this.n=H,this.r=V,this.s=z,this.t=B,this.u=Y,this.v=se,this.w=le,this.z=ge,this.C=Pe,this.D=Re,this.F=Ae,this.G=Le,this.H=He,this.I=me,this.J=be,this.b=this.B(new f.$7c),this.onDidOpenWindow=this.b.event,this.c=this.B(new f.$7c),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new f.$7c),this.onDidDestroyWindow=this.f.event,this.g=this.B(new f.$7c),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new f.$7c),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ne.$A4b(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(j=>this.c.fire(j.window))),this.B(this.onDidSignalReadyWindow(j=>{if(j.config?.extensionDevelopmentPath||j.config?.extensionTestsPath){const A=new p.$kb;if(A.add(f.Event.any(j.onDidClose,j.onDidDestroy)(()=>A.dispose())),j.config.extensionDevelopmentPath)for(const F of j.config.extensionDevelopmentPath)A.add(this.I.addValidFileRoot(F));j.config.extensionTestsPath&&A.add(this.I.addValidFileRoot(j.config.extensionTestsPath))}}))}openEmptyWindow(j,A){const F=this.t.args,H=A?.remoteAuthority||void 0,V=!0,z=A?.forceReuseWindow,B=!z;return this.open({...j,cli:F,forceEmpty:V,forceNewWindow:B,forceReuseWindow:z,remoteAuthority:H})}openExistingWindow(j,A){j.focus(),this.M(A,[j])}async open(j){this.m.trace("windowsManager#open"),j.addMode&&(j.initialStartup||!this.getLastActiveWindow())&&(j.addMode=!1);const A=[],F=[],H=[],V=[],z=[];let B,Y=0;const se=await this.S(j);this.m.trace("windowsManager#open pathsToOpen",se);for(const Ae of se)Z(Ae)?j.addMode?A.push(Ae):F.push(Ae):J(Ae)?H.push(Ae):Ae.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ae.remoteAuthority}),B.filesToOpenOrCreate.push(Ae)):Ae.backupPath?z.push({backupFolder:(0,v.$ec)(Ae.backupPath),remoteAuthority:Ae.remoteAuthority}):Y++;j.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),j.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&j.waitMarkerFileURI&&(B.filesToWait={paths:(0,R.$lf)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:j.waitMarkerFileURI}),j.initialStartup?(V.push(...this.D.getUntitledWorkspaces()),H.push(...V),z.push(...this.w.getEmptyWindowBackups())):z.length=0;const{windows:le,filesOpenedInWindow:ge}=await this.N(j,H,F,z,Y,B,A);if(this.m.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${H.length}, foldersToOpen: ${F.length}, emptyToRestore: ${z.length}, emptyToOpen: ${Y})`),le.length>1)if(ge)ge.focus();else{const Ae=this.j.state.lastActiveWindow&&!j.forceEmpty&&!j.cli._.length&&!j.cli["file-uri"]&&!j.cli["folder-uri"]&&!(j.urisToOpen&&j.urisToOpen.length);let Le=!0,He=!0;if(Ae){const me=le.filter(be=>this.j.state.lastActiveWindow&&be.backupPath===this.j.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),Le=!1,He=!1)}if(Le)for(let me=le.length-1;me>=0;me--){const be=le[me];if(!(be.openedWorkspace&&V.some(_=>be.openedWorkspace&&_.workspace.id===be.openedWorkspace.id)||be.backupPath&&z.some(_=>be.backupPath&&_.backupFolder===(0,v.$ec)(be.backupPath)))){be.focus(),He=!1;break}}He&&le[le.length-1].focus()}const Pe=B&&B.filesToDiff.length>0,Re=B&&B.filesToMerge.length>0;if(!le.some(Ae=>Ae.isExtensionDevelopmentHost)&&!Pe&&!Re&&!j.noRecentEntry){const Ae=[];for(const Le of se)J(Le)&&!Le.transient?Ae.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):Z(Le)?Ae.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Ae.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.C.addRecentlyOpened(Ae)}return this.M(j,le),le}M(j,A){const F=j.waitMarkerFileURI;j.context===0&&F&&A.length===1&&A[0]&&(async()=>{await A[0].whenClosedOrLoaded;try{await this.H.del(F)}catch{}})()}async N(j,A,F,H,V,z,B){const Y=[];let se;function le(me,be){Y.push(me),be&&(se=me,z=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Pe}=this.fb(j);if(!j.initialStartup&&B.length>0){const me=B[0].remoteAuthority,be=this.kb(me);be&&le(this.P(be,B.map(_=>_.workspace.uri)))}const Re=F.length+A.length+H.length;if(z&&Re===0){const me=z.filesToOpenOrCreate[0]||z.filesToDiff[0]||z.filesToMerge[3],be=this.getWindows().filter(he=>z&&(0,c.$ag)(he.remoteAuthority,z.remoteAuthority));let _;me?.fileUri&&!Pe&&((j.context===4||j.context===0||j.context===1)&&(_=await(0,re.$A3b)(be,me.fileUri,async he=>he.configPath.scheme===h.Schemas.file?this.D.resolveLocalWorkspace(he.configPath):void 0)),_||(_=this.lb(be))),_?(0,ee.$Ch)(_.openedWorkspace)?A.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):(0,ee.$xh)(_.openedWorkspace)?F.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):le(this.O(j,_,z),!0):le(await this.gb({userEnv:j.userEnv,cli:j.cli,initialStartup:j.initialStartup,filesToOpen:z,forceNewWindow:!0,remoteAuthority:z.remoteAuthority,forceNewTabbedWindow:j.forceNewTabbedWindow,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile}),!0)}const Ae=(0,R.$qf)(A,me=>me.workspace.id);if(Ae.length>0){const me=(0,R.$lf)(Ae.map(be=>(0,re.$B3b)(this.getWindows(),be.workspace.configPath)));if(me.length>0){const be=me[0],_=(0,c.$ag)(z?.remoteAuthority,be.remoteAuthority)?z:void 0;le(this.O(j,be,_),!!_),ge=!0}for(const be of Ae){if(me.some(de=>de.openedWorkspace&&de.openedWorkspace.id===be.workspace.id))continue;const _=be.remoteAuthority,he=(0,c.$ag)(z?.remoteAuthority,_)?z:void 0;le(await this.R(j,be,ge,he),!!he),ge=!0}}const Le=(0,R.$qf)(F,me=>c.$Yf.getComparisonKey(me.workspace.uri));if(Le.length>0){const me=(0,R.$lf)(Le.map(be=>(0,re.$B3b)(this.getWindows(),be.workspace.uri)));if(me.length>0){const be=me[0],_=(0,c.$ag)(z?.remoteAuthority,be.remoteAuthority)?z:void 0;le(this.O(j,be,_),!!_),ge=!0}for(const be of Le){if(me.some(de=>(0,ee.$xh)(de.openedWorkspace)&&c.$Yf.isEqual(de.openedWorkspace.uri,be.workspace.uri)))continue;const _=be.remoteAuthority,he=(0,c.$ag)(z?.remoteAuthority,_)?z:void 0;le(await this.R(j,be,ge,he),!!he),ge=!0}}const He=(0,R.$qf)(H,me=>me.backupFolder);if(He.length>0)for(const me of He){const be=me.remoteAuthority,_=(0,c.$ag)(z?.remoteAuthority,be)?z:void 0;le(await this.Q(j,!0,be,_,me),!!_),ge=!0}if(Y.length===0||z){z&&!V&&V++;const me=z?z.remoteAuthority:j.remoteAuthority;for(let be=0;be<V;be++)le(await this.Q(j,ge,me,z),!!z),ge=!0}return{windows:(0,R.$qf)(Y),filesOpenedInWindow:se}}O(j,A,F){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),A.focus();const H={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToMerge:F?.filesToMerge,filesToWait:F?.filesToWait,termProgram:j?.userEnv?.TERM_PROGRAM};return A.sendWhenReady("vscode:openFiles",S.CancellationToken.None,H),A}P(j,A){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:A}),j.focus();const F={foldersToAdd:A};return j.sendWhenReady("vscode:addFolders",S.CancellationToken.None,F),j}Q(j,A,F,H,V){this.m.trace("windowsManager#doOpenEmpty",{restore:!!V,remoteAuthority:F,filesToOpen:H,forceNewWindow:A});let z;return!A&&typeof j.contextWindowId=="number"&&(z=this.getWindowById(j.contextWindowId)),this.gb({userEnv:j.userEnv,cli:j.cli,initialStartup:j.initialStartup,remoteAuthority:F,forceNewWindow:A,forceNewTabbedWindow:j.forceNewTabbedWindow,filesToOpen:H,windowToUse:z,emptyWindowBackupInfo:V,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile})}R(j,A,F,H,V){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:A,filesToOpen:H}),!F&&!V&&typeof j.contextWindowId=="number"&&(V=this.getWindowById(j.contextWindowId)),this.gb({workspace:A.workspace,userEnv:j.userEnv,cli:j.cli,initialStartup:j.initialStartup,remoteAuthority:A.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:j.forceNewTabbedWindow,filesToOpen:H,windowToUse:V,forceProfile:j.forceProfile,forceTempProfile:j.forceTempProfile})}async S(j){let A,F=!1,H=!1;if(j.urisToOpen&&j.urisToOpen.length>0?(A=await this.U(j),F=!0):j.forceEmpty?A=[Object.create(null)]:j.cli._.length||j.cli["folder-uri"]||j.cli["file-uri"]?(A=await this.W(j.cli),A.length===0&&A.push(Object.create(null)),F=!0):(A=await this.Y(),A.length===0&&A.push(Object.create(null)),H=!0),!j.addMode&&F){const V=A.filter(z=>Z(z));if(V.length>1){const z=V[0].remoteAuthority;if(V.every(B=>(0,c.$ag)(B.remoteAuthority,z))){const B=await this.D.createUntitledWorkspace(V.map(Y=>({uri:Y.workspace.uri})));A.push({workspace:B,remoteAuthority:z}),A=A.filter(Y=>!Z(Y))}}}if(j.initialStartup&&!H&&this.z.getValue("window")?.restoreWindows==="preserve"){const V=await this.Y();A.unshift(...V.filter(z=>J(z)||Z(z)||z.backupPath))}return A}async U(j){const A={gotoLineMode:j.gotoLineMode,remoteAuthority:j.remoteAuthority},F=await Promise.all((0,R.$lf)(j.urisToOpen||[]).map(async H=>{const V=await this.$(H,A);if(V)return V.label=H.label,V;const z=this.bb(H);this.G.showMessageBox({type:"info",buttons:[(0,w.localize)(0,null)],message:z.scheme===h.Schemas.file?(0,w.localize)(1,null):(0,w.localize)(2,null),detail:z.scheme===h.Schemas.file?(0,w.localize)(3,null,(0,d.$Xz)(z,{os:o.OS,tildify:this.t})):(0,w.localize)(4,null,z.toString(!0))},(0,b.$Ae)(E.BrowserWindow.getFocusedWindow()))}));return(0,R.$lf)(F)}async W(j){const A=[],F={ignoreFileNotFound:!0,gotoLineMode:j.goto,remoteAuthority:j.remote||void 0,forceOpenWorkspaceAsFile:j.diff&&j._.length===2||j.merge&&j._.length===4},H=j["folder-uri"];if(H){const B=await Promise.all(H.map(Y=>{const se=this.X(Y);if(se)return this.$({folderUri:se},F)}));A.push(...(0,R.$lf)(B))}const V=j["file-uri"];if(V){const B=await Promise.all(V.map(Y=>{const se=this.X(Y);if(se)return this.$((0,ee.$Sh)(Y)?{workspaceUri:se}:{fileUri:se},F)}));A.push(...(0,R.$lf)(B))}const z=await Promise.all(j._.map(B=>F.remoteAuthority?this.eb(B,F):this.cb(B,F)));return A.push(...(0,R.$lf)(z)),A}X(j){try{const A=k.URI.parse(j);if(!A.scheme){this.m.error(`Invalid URI input string, scheme missing: ${j}`);return}return A.path?A:A.with({path:"/"})}catch(A){this.m.error(`Invalid URI input string: ${j}, ${A.message}`)}}async Y(){const j=this.Z();switch(j){case"none":return[];case"one":case"all":case"preserve":case"folders":{const A=[];j!=="one"&&A.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&A.push(this.j.state.lastActiveWindow);const F=await Promise.all(A.map(async H=>{if(H.workspace){const V=await this.$({workspaceUri:H.workspace.configPath},{remoteAuthority:H.remoteAuthority,rejectTransientWorkspaces:!0});if(J(V))return V}else if(H.folderUri){const V=await this.$({folderUri:H.folderUri},{remoteAuthority:H.remoteAuthority});if(Z(V))return V}else if(j!=="folders"&&H.backupPath)return{backupPath:H.backupPath,remoteAuthority:H.remoteAuthority}}));return(0,R.$lf)(F)}}}Z(){let j;return this.v.wasRestarted?j="all":(j=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(j)||(j="all")),j}async $(j,A=Object.create(null)){const F=this.bb(j);return F.scheme===h.Schemas.file?((0,N.$AD)(j)&&(A={...A,forceOpenWorkspaceAsFile:!0}),this.cb(F.fsPath,A)):this.ab(j,A)}ab(j,A){let F=this.bb(j);const H=(0,O.$zk)(F)||A.remoteAuthority;if(F=(0,c.$cg)((0,c.$9f)(F)),(0,N.$AD)(j)){if(A.gotoLineMode){const{path:V,line:z,column:B}=(0,u.$Qe)(F.path);return{fileUri:F.with({path:V}),options:{selection:z?{startLineNumber:z,startColumn:B||1}:void 0},remoteAuthority:H}}return{fileUri:F,remoteAuthority:H}}else if((0,N.$yD)(j))return{workspace:(0,ae.$t3b)(F),remoteAuthority:H};return{workspace:(0,ae.$u3b)(F),remoteAuthority:H}}bb(j){return(0,N.$yD)(j)?j.workspaceUri:(0,N.$zD)(j)?j.folderUri:j.fileUri}async cb(j,A,F){let H,V;A.gotoLineMode&&({path:j,line:H,column:V}=(0,u.$Qe)(j)),j=(0,u.$Le)((0,v.$$b)(j),(0,g.cwd)());try{const z=await C.Promises.stat(j);if(z.isFile()){if(!A.forceOpenWorkspaceAsFile){const B=await this.D.resolveLocalWorkspace(k.URI.file(j));if(B)return B.transient&&A.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:i.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:k.URI.file(j),type:i.FileType.File,exists:!0,options:{selection:H?{startLineNumber:H,startColumn:V||1}:void 0}}}else{if(z.isDirectory())return{workspace:(0,ae.$u3b)(k.URI.file(j),z),type:i.FileType.Directory,exists:!0};if(!o.$i&&j==="/dev/null")return{fileUri:k.URI.file(j),type:i.FileType.File,exists:!0}}}catch(z){if(z.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!F)return this.db(j,A);const B=k.URI.file(j);if(this.C.removeRecentlyOpened([B]),A.ignoreFileNotFound)return{fileUri:B,type:i.FileType.File,exists:!1}}}async db(j,A){const F=k.URI.file(j),{response:H,checkboxChecked:V}=await this.G.showMessageBox({type:"warning",buttons:[(0,w.localize)(5,null),(0,w.localize)(6,null),(0,w.localize)(7,null)],message:(0,w.localize)(8,null,F.authority),detail:(0,w.localize)(9,null,(0,d.$Xz)(F,{os:o.OS,tildify:this.t})),checkboxLabel:(0,w.localize)(10,null,F.authority),cancelId:1});if(H===0)return(0,r.addUNCHostToAllowlist)(F.authority),V&&this.B(f.Event.once(this.onDidOpenWindow)(z=>{z.sendWhenReady("vscode:configureAllowedUNCHost",S.CancellationToken.None,F.authority)})),this.cb(j,A,!0);if(H===2)return E.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.db(j,A)}eb(j,A){const F=j.charCodeAt(0),H=A.remoteAuthority;let V,z;A.gotoLineMode&&({path:j,line:V,column:z}=(0,u.$Qe)(j)),F!==47&&((0,u.$Ke)(F)&&j.charCodeAt(j.charCodeAt(1))===58&&(j=(0,u.$De)(j)),j=`/${j}`);const B=k.URI.from({scheme:h.Schemas.vscodeRemote,authority:H,path:j});if(j.charCodeAt(j.length-1)!==47){if((0,ee.$Sh)(j))return A.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:V?{startLineNumber:V,startColumn:z||1}:void 0},remoteAuthority:A.remoteAuthority}:{workspace:(0,ae.$t3b)(B),remoteAuthority:H};if(A.gotoLineMode||v.$0b.basename(j).indexOf(".")!==-1)return{fileUri:B,options:{selection:V?{startLineNumber:V,startColumn:z||1}:void 0},remoteAuthority:H}}return{workspace:(0,ae.$u3b)(B),remoteAuthority:H}}fb(j){const A=this.z.getValue("window"),F=A?.openFoldersInNewWindow||"default",H=A?.openFilesInNewWindow||"off";let V=(j.preferNewWindow||j.forceNewWindow)&&!j.forceReuseWindow;!j.forceNewWindow&&!j.forceReuseWindow&&(F==="on"||F==="off")&&(V=F==="on");let z=!1;return j.forceNewWindow||j.forceReuseWindow?z=!!j.forceNewWindow&&!j.forceReuseWindow:(o.$j?j.context===1&&(z=!0):j.context!==3&&j.context!==2&&!(j.userEnv&&j.userEnv.TERM_PROGRAM==="vscode")&&(z=!0),!j.cli.extensionDevelopmentPath&&(H==="on"||H==="off")&&(z=H==="on")),{openFolderInNewWindow:!!V,openFilesInNewWindow:z}}async openExtensionDevelopmentHostWindow(j,A){const F=(0,re.$C3b)(this.getWindows(),j);if(F)return this.v.reload(F,A.cli),F.focus(),[F];let H=A.cli["folder-uri"]||[],V=A.cli["file-uri"]||[],z=A.cli._;if(!z.length&&!H.length&&!V.length&&!A.cli.extensionTestsPath){const se=this.j.state.lastPluginDevelopmentHostWindow,le=se?.workspace??se?.folderUri;le&&(k.URI.isUri(le)?le.scheme===h.Schemas.file?z=[le.fsPath]:H=[le.toString()]:le.configPath.scheme===h.Schemas.file?z=[(0,c.$Vf)(le.configPath)]:V=[le.configPath.toString()])}let B=A.remoteAuthority;for(const se of j)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=k.URI.parse(se),ge=(0,O.$zk)(le);ge&&(B?(0,c.$ag)(ge,B)||this.m.error("more than one extension development path authority"):B=ge)}z=z.filter(se=>{const le=k.URI.file(se);return(0,re.$B3b)(this.getWindows(),le)?!1:(0,c.$ag)((0,O.$zk)(le),B)}),H=H.filter(se=>{const le=this.X(se);return le&&(0,re.$B3b)(this.getWindows(),le)?!1:le?(0,c.$ag)((0,O.$zk)(le),B):!1}),V=V.filter(se=>{const le=this.X(se);return le&&(0,re.$B3b)(this.getWindows(),le)?!1:le?(0,c.$ag)((0,O.$zk)(le),B):!1}),A.cli._=z,A.cli["folder-uri"]=H,A.cli["file-uri"]=V;const Y={context:A.context,cli:A.cli,forceNewWindow:!0,forceEmpty:!z.length&&!H.length&&!V.length,userEnv:A.userEnv,noRecentEntry:!0,waitMarkerFileURI:A.waitMarkerFileURI,remoteAuthority:B,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile};return this.open(Y)}async gb(j){const A=this.z.getValue("window"),F=this.getLastActiveWindow(),H=F?.profile??this.u.defaultProfile;let V;!j.forceNewWindow&&!j.forceNewTabbedWindow&&(V=j.windowToUse||F,V&&V.focus());const z={...this.t.args,...j.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:j.emptyWindowBackupInfo?(0,v.$ac)(this.t.backupHome,j.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:H},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:j.remoteAuthority,workspace:j.workspace,userEnv:{...this.l,...j.userEnv},filesToOpenOrCreate:j.filesToOpen?.filesToOpenOrCreate,filesToDiff:j.filesToOpen?.filesToDiff,filesToMerge:j.filesToOpen?.filesToMerge,filesToWait:j.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsHome.fsPath,product:I.default,isInitialStartup:j.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,M.release)(),hostname:(0,M.hostname)()},zoomLevel:typeof A?.zoomLevel=="number"?A.zoomLevel:void 0,autoDetectHighContrast:A?.autoDetectHighContrast??!0,autoDetectColorScheme:A?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(V){const B=V.config;!z.extensionDevelopmentPath&&B?.extensionDevelopmentPath&&(z.extensionDevelopmentPath=B.extensionDevelopmentPath,z.extensionDevelopmentKind=B.extensionDevelopmentKind,z["enable-proposed-api"]=B["enable-proposed-api"],z.verbose=B.verbose,z["inspect-extensions"]=B["inspect-extensions"],z["inspect-brk-extensions"]=B["inspect-brk-extensions"],z.debugId=B.debugId,z.extensionEnvironment=B.extensionEnvironment,z["extensions-dir"]=B["extensions-dir"],z["disable-extensions"]=B["disable-extensions"]),z.loggers={global:z.loggers.global,window:B?.loggers.window??z.loggers.window}}else{const B=this.j.getNewWindowState(z);(0,y.mark)("code/willCreateCodeWindow");const Y=V=this.F.createInstance(q.$z4b,{state:B,extensionDevelopmentPath:z.extensionDevelopmentPath,isExtensionTestHost:!!z.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),j.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(Y),at.a.push(Y),this.b.fire(Y),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,$.$cb)(Y.onDidSignalReady)(()=>this.c.fire(Y)),(0,$.$cb)(Y.onDidClose)(()=>this.jb(Y)),(0,$.$cb)(Y.onDidDestroy)(()=>this.f.fire(Y)),Y.onDidTriggerSystemContextMenu(({x:le,y:ge})=>this.h.fire({window:Y,x:le,y:ge}));const se=(0,b.$te)(Y.win?.webContents);se.removeAllListeners("devtools-reload-page"),se.on("devtools-reload-page",()=>this.v.reload(Y)),this.v.registerWindow(Y)}return z.windowId=V.id,V.isReady?this.v.unload(V,4).then(async B=>{B||await this.hb(V,z,j,H)}):await this.hb(V,z,j,H),V}async hb(j,A,F,H){if(A.extensionDevelopmentPath||((0,ee.$Ch)(A.workspace)?A.backupPath=this.w.registerWorkspaceBackup({workspace:A.workspace,remoteAuthority:A.remoteAuthority}):(0,ee.$xh)(A.workspace)?A.backupPath=this.w.registerFolderBackup({folderUri:A.workspace.uri,remoteAuthority:A.remoteAuthority}):A.backupPath=this.w.registerEmptyWindowBackup({backupFolder:F.emptyWindowBackupInfo?.backupFolder??(0,ae.$v3b)().id,remoteAuthority:A.remoteAuthority})),this.u.isEnabled()){const V=A.workspace??(0,ee.$Bh)(A.backupPath,!1),z=this.ib(F,V,H),B=z instanceof Promise?await z:z;A.profiles.profile=B,A.extensionDevelopmentPath||await this.u.setProfileForWorkspace(V,B)}j.load(A)}ib(j,A,F){return j.forceProfile?this.u.profiles.find(H=>H.name===j.forceProfile)??this.u.createNamedProfile(j.forceProfile):j.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(A)??F}jb(j){const A=at.a.indexOf(j);at.a.splice(A,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const j=E.BrowserWindow.getFocusedWindow();if(j)return this.getWindowById(j.id)}getLastActiveWindow(){return this.lb(this.getWindows())}kb(j){return this.lb(this.getWindows().filter(A=>(0,c.$ag)(A.remoteAuthority,j)))}lb(j){const A=Math.max.apply(Math,j.map(F=>F.lastFocusTime));return j.find(F=>F.lastFocusTime===A)}sendToFocused(j,...A){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(j,S.CancellationToken.None,...A)}sendToAll(j,A,F){for(const H of this.getWindows())F&&F.indexOf(H.id)>=0||H.sendWhenReady(j,S.CancellationToken.None,A)}getWindows(){return at.a}getWindowCount(){return at.a.length}getWindowById(j){const A=this.getWindows().filter(F=>F.id===j);return(0,R.$uf)(A)}getWindowByWebContents(j){const A=E.BrowserWindow.fromWebContents(j);if(A)return this.getWindowById(A.id)}};e.$D4b=ce,e.$D4b=ce=pe([x(2,P.$Pi),x(3,T.$e4b),x(4,L.$OM),x(5,U.$Tm),x(6,n.$$2b),x(7,W.$g3b),x(8,m.$a3b),x(9,t.$r3b),x(10,l.$Th),x(11,ue.$_3b),x(12,K.$D3b),x(13,a.$mh),x(14,s.$y3b),x(15,i.$Qj),x(16,D.$13b),x(17,X.$U3b)],ce)}),define(te[305],ie([0,1,64,29,84,54]),function(G,e,E,C,r,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F4b=void 0;let R=class{constructor(f,u,$,d){this.a=f,this.b=u,this.c=$,this.d=d,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,u){const $=this.b.getWindowById(f);if($)return this.a.enterWorkspace($,this.b.getWindows(),u)}createUntitledWorkspace(f,u,$){return this.a.createUntitledWorkspace(u,$)}deleteUntitledWorkspace(f,u){return this.a.deleteUntitledWorkspace(u)}getWorkspaceIdentifier(f,u){return this.a.getWorkspaceIdentifier(u)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,u){return this.c.addRecentlyOpened(u)}removeRecentlyOpened(f,u){return this.c.removeRecentlyOpened(u)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$F4b=R,e.$F4b=R=pe([x(0,M.$D3b),x(1,C.$m3b),x(2,r.$_3b),x(3,E.$r3b)],R)}),define(te[306],ie([0,1,14,132,38,27,17,50,13,32,49,45,46,2,15,9,4,10,7,31,146,43,157,110,289,160,64,285,18,76,198,91,133,61,115,218,28,63,95,207,233,208,293,117,209,210,16,222,94,75,6,93,216,298,286,274,20,5,303,67,23,60,294,96,34,277,83,122,26,249,251,52,48,264,290,299,291,300,127,266,267,268,271,275,29,304,276,30,98,84,305,54,273,39,231,53,243,51,82,129,279,292,282,8,253,278,226,66,92,296,270,24,125,295,261,238,85]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I,D,O,L,N,q,re,ne,ee,ae,ue,K,X,U,W,T,J,Z,ce,oe,j,A,F,H,V,z,B,Y,se,le,ge,Pe,Re,Ae,Le,He,me,be,_,he,de,Se,Ce,je,Oe,Te,We,qe,ze,Q,fe,$e,ve,ye,De,Fe,Be,Ge,xe,Xe,Ze,tt,ot,ct,Ct,gt,Ot,Mt,Lt,jt,Ft,Ut,Nt,$t,Wt,Tt,zt,Bt,qt,mt,Ht,St,bt,Vt,Gt,wt,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W4b=void 0;let pt=class extends h.$lb{constructor(Ee,ke,we,Me,Ie,Ne,Ke,Qe,Ue,Ve,Je,Ye){super(),this.c=Ee,this.f=ke,this.g=we,this.h=Me,this.i=Ie,this.j=Ne,this.k=Ke,this.l=Qe,this.m=Ue,this.n=Ve,this.p=Je,this.s=Ye,this.t(),this.u()}t(){const Ee=Ue=>Ue?.startsWith(`${v.Schemas.vscodeWebview}://`),ke=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ue,Ve,Je,Ye)=>Ee(Ye.requestingUrl)?Je(ke.has(Ve)):Je(!1)),E.session.defaultSession.setPermissionCheckHandler((Ue,Ve,Je,Ye)=>Ee(Ye.requestingUrl)?ke.has(Ve):!1);const we=new Set([v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemoteResource,v.Schemas.vscodeManagedRemoteResource,"devtools"]),Me=Ue=>{for(let Ve=Ue;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${v.Schemas.vscodeWebview}://`))return!0;return!1},Ie=Ue=>Ue.resourceType==="xhr"||Me(Ue.frame),Ne=Ue=>{const Ve=Ue.frame;if(!Ve||!this.a)return!1;const Je=E.BrowserWindow.getAllWindows();for(const Ye of Je)if(Ve.processId===Ye.webContents.mainFrame.processId)return!0;return!1},Ke=(Ue,Ve)=>{if(Ue.path!=="/index.html")return!0;const Je=Ve.frame;if(!Je||!this.a)return!1;for(const Ye of this.a.getWindows())if(Ye.win&&Je.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ue,Ve)=>{const Je=c.URI.parse(Ue.url);return Je.scheme===v.Schemas.vscodeWebview&&!Ke(Je,Ue)?(this.h.error("Blocked vscode-webview request",Ue.url),Ve({cancel:!0})):Je.scheme===v.Schemas.vscodeFileResource&&!Ne(Ue)?(this.h.error("Blocked vscode-file request",Ue.url),Ve({cancel:!0})):Je.path.endsWith(".svg")&&!we.has(Je.scheme)?Ve({cancel:!Ie(Ue)}):Ve({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ue,Ve)=>{const Je=Ue.responseHeaders,Ye=Je["content-type"]||Je["Content-Type"];if(Ye&&Array.isArray(Ye)){const _e=c.URI.parse(Ue.url);if(_e.path.endsWith(".svg")&&we.has(_e.scheme))return Je["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:Je});if(!_e.path.endsWith(v.Schemas.vscodeRemoteResource)&&Ye.some(st=>st.toLowerCase().includes("image/svg")))return Ve({cancel:!Ie(Ue)})}return Ve({cancel:!1})});const Qe=E.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.j.codeCachePath&&Qe.setCodeCachePath((0,y.$ac)(this.j.codeCachePath,"chrome")),o.$i&&(this.l.getValue("security.restrictUNCAccess")===!1?(0,C.disableUNCAccessRestrictions)():(0,C.addUNCHostToAllowlist)(this.l.getValue("security.allowedUNCHosts")))}u(){(0,f.setUnexpectedErrorHandler)(we=>this.w(we)),process.on("uncaughtException",we=>{(0,f.$X)(we)||(0,f.$Y)(we)}),process.on("unhandledRejection",we=>(0,f.$Y)(we)),this.k.onWillShutdown(()=>this.dispose()),(0,k.$kS)(),E.app.on("accessibility-support-changed",(we,Me)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Me)}),E.app.on("activate",async(we,Me)=>{this.h.trace("app#activate"),Me||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(we,Me)=>{Me.on("will-navigate",Ie=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),Me.setWindowOpenHandler(({url:Ie})=>(this.b?.openExternal(void 0,Ie),{action:"deny"}))});let Ee=[],ke;E.app.on("open-file",(we,Me)=>{this.h.trace("app#open-file: ",Me),we.preventDefault(),Ee.push((0,Ge.$Sh)(Me)?{workspaceUri:c.URI.file(Me)}:{fileUri:c.URI.file(Me)}),ke!==void 0&&(clearTimeout(ke),ke=void 0),ke=setTimeout(async()=>{await this.a?.open({context:1,cli:this.j.args,urisToOpen:Ee,gotoLineMode:!1,preferNewWindow:!0}),Ee=[],ke=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),r.$jS.handle("vscode:fetchShellEnv",we=>{const Me=this.a?.getWindowByWebContents(we.sender);let Ie,Ne;return Me?.config?(Ie=Me.config,Ne={...process.env,...Me.config.userEnv}):(Ie=this.j.args,Ne=process.env),this.O(Ie,Ne,!1)}),r.$jS.handle("vscode:writeNlsFile",(we,Me,Ie)=>{const Ne=this.v([Me]);if(!Ne||typeof Ie!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.n.writeFile(Ne,R.$Jb.fromString(Ie))}),r.$jS.handle("vscode:readNlsFile",async(we,...Me)=>{const Ie=this.v(Me);if(!Ie)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.n.readFile(Ie)).value.toString()}),r.$jS.on("vscode:toggleDevTools",we=>we.sender.toggleDevTools()),r.$jS.on("vscode:openDevTools",we=>we.sender.openDevTools()),r.$jS.on("vscode:reloadWindow",we=>we.sender.reload())}v(Ee){let ke;for(const we of Ee)typeof we=="string"&&(typeof ke!="string"?ke=we:ke=(0,y.$ac)(ke,we));if(!(typeof ke!="string"||!(0,y.$_b)(ke)||!(0,u.$Je)(ke,this.j.cachedLanguagesPath,!o.$k)))return c.URI.file(ke)}w(Ee){if(Ee){const ke={message:`[uncaught exception in main]: ${Ee.message}`,stack:Ee.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(ke))}this.h.error(`[uncaught exception in main]: ${Ee}`),Ee.stack&&this.h.error(Ee.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.j.appRoot}`),this.h.debug("args:",this.j.args);const Ee=this.p.win32AppUserModelId;o.$i&&Ee&&E.app.setAppUserModelId(Ee);try{o.$j&&this.l.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.h.error(Ue)}const ke=new t.$qS;this.k.onWillShutdown(Ue=>{Ue.reason===2&&ke.dispose()}),this.h.trace("Resolving machine identifier...");const we=await(0,Wt.$N4b)(this.m,this.h);this.h.trace(`Resolved machine identifier: ${we}`);const{sharedProcessReady:Me,sharedProcessClient:Ie}=this.H(we),Ne=await this.I(we,Me);this.B(Ne.createInstance(s.$n3b)),this.B(Ne.createInstance(Ut.$K4b)),Ne.invokeFunction(Ue=>this.J(Ue,ke,Ie));const Ke=Ne.invokeFunction(Ue=>this.y(Ue,ke));this.z(ke),this.k.phase=2,await Ne.invokeFunction(Ue=>this.L(Ue,Ke)),this.k.phase=3,this.M(),this.B(new $t.$Eg(()=>{this.B((0,$t.$Ig)(()=>this.k.phase=4,2500))},2500)).schedule()}y(Ee,ke){const we=this.a=Ee.get(De.$m3b),Me=Ee.get(ze.$kjb),Ie=this.b=Ee.get(le.$Y3b),Ne=this;Me.registerHandler({async handleURL(Ye,_e){return Ne.G(we,Me,Ye,_e)}});const Ke=this.B(new Be.$E4b({onDidOpenWindow:Ie.onDidOpenWindow,onDidFocusWindow:Ie.onDidFocusWindow,getActiveWindowId:()=>Ie.getActiveWindowId(-1)})),Qe=new w.$8g(Ye=>Ke.getActiveClientId().then(_e=>Ye===_e)),Ue=new Q.$u4b(Qe,this.h),Ve=ke.getChannel("urlHandler",Ue);Me.registerHandler(new Q.$t4b(Ve));const Je=this.C();return this.B(new $e.$v4b(Je?.urls,Me,we,this.j,this.p,this.h)),Je}z(Ee){const ke=()=>({statusCode:404,data:"Not found"}),we=new Jt.$T(()=>Ee.getChannel(wt.$U4b,new wt.$V4b));E.protocol.registerBufferProtocol(v.Schemas.vscodeManagedRemoteResource,(Me,Ie)=>{const Ne=c.URI.parse(Me.url);if(!Ne.authority.startsWith("window:"))return Ie(ke());we.value.call(wt.$T4b,[Ne]).then(Ke=>Ie({...Ke,data:Buffer.from(Ke.body,"base64")}),Ke=>{this.h.warn("error dispatching remote resource call",Ke),Ie({statusCode:500,data:String(Ke)})})})}C(){const Ee=this.j.args["open-url"]?this.j.args._urls||[]:[];Ee.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ee);const ke=global.getOpenUrls()||[];if(ke.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",ke),Ee.length+ke.length===0)return;const we=[];return{urls:[...Ee,...ke].map(Ie=>{try{return{uri:c.URI.parse(Ie),originalUrl:Ie}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ie);return}}).filter(Ie=>{if(!Ie)return!1;if(this.D(Ie.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ie.uri.toString(!0)),!1;const Ne=this.F(Ie.uri);return Ne?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ie.uri.toString(!0),Ne),we.push(Ne),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ie.uri.toString(!0)),!0)}),openables:we}}D(Ee){if(Ee.authority===v.Schemas.file&&o.$i){const{options:ke,buttonIndeces:we}=(0,qt.$_z)({type:"warning",buttons:[(0,n.localize)(0,null),(0,n.localize)(1,null)],message:(0,n.localize)(2,null,(0,p.$Xz)(Ee,{os:o.OS,tildify:this.j}),this.p.nameShort),detail:(0,n.localize)(3,null)},this.p);if(we[E.dialog.showMessageBoxSync(ke)]===1)return!0}return!1}F(Ee){if(Ee.path){if(Ee.authority===v.Schemas.file){const ke=c.URI.file(Ee.fsPath);return(0,Ge.$Sh)(ke)?{workspaceUri:ke}:{fileUri:ke}}else if(Ee.authority===v.Schemas.vscodeRemote){const ke=Ee.path.indexOf(y.$0b.sep,1);if(ke!==-1){const we=Ee.path.substring(1,ke),Me=Ee.path.substring(ke),Ie=c.URI.from({scheme:v.Schemas.vscodeRemote,authority:we,path:Me,query:Ee.query,fragment:Ee.fragment});return(0,Ge.$Sh)(Me)?{workspaceUri:Ie}:/:[\d]+$/.test(Me)?{fileUri:Ie}:{folderUri:Ie}}}}}async G(Ee,ke,we,Me){if(this.h.trace("app#handleProtocolUrl():",we.toString(!0),Me),we.scheme===this.p.urlProtocol&&we.path==="workspace"&&(we=we.with({authority:"file",path:c.URI.parse(we.query).path,query:""})),this.D(we))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",we.toString(!0)),!0;let Ie=!1;const Ne=new URLSearchParams(we.query);Ne.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",we.toString(!0)),Ne.delete("windowId"),we=we.with({query:Ne.toString()}),Ie=!0):o.$j&&Ee.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",we.toString(!0)),Ie=!0);const Ke=Ne.get("continueOn");Ke!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",we.toString(!0)),Ne.delete("continueOn"),we=we.with({query:Ne.toString()}),this.j.continueOn=Ke??void 0);const Qe=this.F(we);return Qe?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,we.toString(!0)),(0,St.$uf)(await Ee.open({context:5,cli:{...this.j.args},urisToOpen:[Qe],forceNewWindow:Ie,gotoLineMode:!0}))?.focus(),!0):Ie?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",we.toString(!0)),await(0,St.$uf)(await Ee.open({context:5,cli:{...this.j.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Pe.$zk)(we)}))?.ready(),ke.open(we,Me)):(this.h.trace("app#handleProtocolUrl(): not handled",we.toString(!0),Me),!1)}H(Ee){const ke=this.B(this.g.createInstance(Re.$g4b,Ee)),we=(async()=>{this.h.trace("Main->SharedProcess#connect");const Ie=await ke.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new l.$rS(Ie,"main")})();return{sharedProcessReady:(async()=>(await ke.whenReady(),we))(),sharedProcessClient:we}}async I(Ee,ke){const we=new A.$lh;switch(process.platform){case"win32":we.set(Ce.$zib,new oe.$kh(qe.$r4b));break;case"linux":o.$l?we.set(Ce.$zib,new oe.$kh(We.$q4b,[process.env.SNAP,process.env.SNAP_REVISION])):we.set(Ce.$zib,new oe.$kh(Te.$p4b));break;case"darwin":we.set(Ce.$zib,new oe.$kh(Oe.$o4b));break}we.set(De.$m3b,new oe.$kh(Fe.$D4b,[Ee,this.f],!1));const Me=new L.$z3b(this.h,this.p);we.set(L.$y3b,Me),we.set(z.$63b,new oe.$kh(z.$73b,void 0,!1)),we.set(O.$I3b,new oe.$kh(O.$J3b,void 0,!1)),we.set(D.$3l,w.ProxyChannel.toService((0,w.$6g)(ke.then(Ue=>Ue.getChannel("diagnostics"))))),we.set(F.$srb,new oe.$kh(H.$23b,[this.f])),we.set(N.$hqb,new oe.$kh(q.$K3b,[Ee])),we.set(V.$33b,new oe.$kh(V.$43b)),we.set(le.$Y3b,new oe.$kh(le.$Z3b,void 0,!1)),we.set(P.$ln,new oe.$kh(ot.$G4b)),we.set(ve.$w4b,new oe.$kh(ye.$y4b)),we.set(se.$c4b,new oe.$kh(se.$d4b)),we.set(ae.$ljb,new oe.$kh(ue.$L3b)),we.set(K.$M3b,new oe.$kh(X.$O3b)),we.set(me.$i3b,new oe.$kh(me.$j3b)),we.set(me.$k3b,new oe.$kh(me.$l3b));const Ie=new Vt.$S4b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.l.getValue("terminal.integrated.persistentSessionScrollback")??100},this.l,this.j,this.k,this.h),Ne=new Gt.$9q(Ie,this.l,this.h,this.i);we.set(bt.$Jq,Ne),o.$i?we.set(U.$hVb,new oe.$kh(W.$P3b)):o.$j?we.set(U.$hVb,new oe.$kh(W.$Q3b)):o.$k&&we.set(U.$hVb,new oe.$kh(W.$R3b));const Ke=new a.$w3b(this.j,this.l,this.h,this.m);we.set(i.$r3b,Ke);const Qe=new tt.$E3b(this.j,this.h,this.s,Ke,Me);if(we.set(tt.$D3b,Qe),we.set(xe.$Aab,new oe.$kh(Ze.$F4b,void 0,!1)),we.set(Xe.$_3b,new oe.$kh(Xe.$a4b,void 0,!1)),we.set(ze.$kjb,new oe.$kh(fe.$oqb,void 0,!1)),(0,Se.$8n)(this.p,this.j)){const Ue=(0,Se.$ao)(this.p,this.l),Ve=(0,w.$6g)(ke.then(it=>it.getChannel("telemetryAppender"))),Je=new he.$j4b(Ve),Ye=(0,be.$Xn)((0,M.release)(),(0,M.hostname)(),process.arch,this.p.commit,this.p.version,Ee,Ue),_e=(0,Se.$bo)(this.j),st={appenders:[Je],commonProperties:Ye,piiPaths:_e,sendErrorTelemetry:!0};we.set(_.$Tk,new oe.$kh(de.$Dq,[st],!1))}else we.set(_.$Tk,Se.$2n);return we.set(Lt.$0o,new oe.$kh(Tt.$VM,void 0,!0)),we.set(jt.$bp,new oe.$kh(Ft.$J4b,void 0,!0)),we.set(mt.$Q4b,new oe.$kh(mt.$R4b,void 0,!0)),await $t.Promises.settled([Ke.initialize(),Qe.initialize()]),this.g.createChild(we)}J(Ee,ke,we){const Me=w.ProxyChannel.fromService(Ee.get(z.$63b),{disableMarshalling:!0});this.c.registerChannel("launch",Me);const Ie=w.ProxyChannel.fromService(Ee.get(O.$I3b),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Ie);const Ne=new Ct.$H4b(Ee.get(ct.$Tm));ke.registerChannel("policy",Ne),we.then(et=>et.registerChannel("policy",Ne));const Ke=this.n.getProvider(v.Schemas.file);(0,g.$se)(Ke instanceof ce.$Pp);const Qe=new Z.$S3b(Ke,this.h,this.j);ke.registerChannel(T.$EM,Qe),we.then(et=>et.registerChannel(T.$EM,Qe));const Ue=w.ProxyChannel.fromService(Ee.get(gt.$g3b));ke.registerChannel("userDataProfiles",Ue),we.then(et=>et.registerChannel("userDataProfiles",Ue));const Ve=new Ot.$yq(Ee.get(Mt.$wo));we.then(et=>et.registerChannel("request",Ve));const Je=new je.$k4b(Ee.get(Ce.$zib));ke.registerChannel("update",Je);const Ye=w.ProxyChannel.fromService(Ee.get(F.$srb));ke.registerChannel("issue",Ye);const _e=w.ProxyChannel.fromService(Ee.get(N.$hqb));ke.registerChannel("encryption",_e);const st=w.ProxyChannel.fromService(Ee.get(P.$ln));ke.registerChannel("credentials",st);const it=w.ProxyChannel.fromService(Ee.get(Ae.$Hk));ke.registerChannel("sign",it);const lt=w.ProxyChannel.fromService(Ee.get(V.$33b));ke.registerChannel("keyboardLayout",lt),this.b=Ee.get(le.$Y3b);const Pt=w.ProxyChannel.fromService(this.b);ke.registerChannel("nativeHost",Pt),we.then(et=>et.registerChannel("nativeHost",Pt));const Kt=w.ProxyChannel.fromService(Ee.get(xe.$Aab));ke.registerChannel("workspaces",Kt);const Yt=w.ProxyChannel.fromService(Ee.get(se.$c4b));ke.registerChannel("menubar",Yt);const Xt=w.ProxyChannel.fromService(Ee.get(ze.$kjb));ke.registerChannel("url",Xt);const Qt=w.ProxyChannel.fromService(Ee.get(ae.$ljb));ke.registerChannel("extensionUrlTrust",Qt);const Zt=w.ProxyChannel.fromService(Ee.get(ve.$w4b));ke.registerChannel("webview",Zt);const It=this.B(new He.$h4b(this.h,Ee.get(me.$i3b)));ke.registerChannel("storage",It),we.then(et=>et.registerChannel("storage",It));const xt=this.B(new Nt.$L4b(Ee.get(me.$i3b),Ee.get(gt.$g3b),this.h));we.then(et=>et.registerChannel("profileStorageListener",xt));const _t=w.ProxyChannel.fromService(Ee.get(bt.$Jq));ke.registerChannel(bt.TerminalIpcChannels.LocalPty,_t);const ei=w.ProxyChannel.fromService(Ee.get(U.$hVb));ke.registerChannel("externalTerminal",ei);const Dt=new zt.$O4b(Ee.get(Bt.$e4b));ke.registerChannel("logger",Dt),we.then(et=>et.registerChannel("logger",Dt));const ti=new I.$x3b(Ee.get(De.$m3b));ke.registerChannel("extensionhostdebugservice",ti);const ii=w.ProxyChannel.fromService(Ee.get(K.$M3b));ke.registerChannel(K.$N3b,ii);const ni=w.ProxyChannel.fromService(Ee.get(mt.$Q4b));ke.registerChannel(Ht.$P4b,ni)}async L(Ee,ke){const we=this.a=Ee.get(De.$m3b),Me=(0,ne.$ql)(process.env)?0:4,Ie=this.j.args;if(ke){if(ke.openables.length>0)return we.open({context:Me,cli:Ie,urisToOpen:ke.openables,gotoLineMode:!0,initialStartup:!0});if(ke.urls.length>0)for(const it of ke.urls){const lt=new URLSearchParams(it.uri.query);if(lt.get("windowId")==="_blank")return lt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:lt.toString()}),we.open({context:Me,cli:Ie,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,Ke=Ie._.length,Qe=!!Ie["folder-uri"],Ue=!!Ie["file-uri"],Ve=Ie["skip-add-to-recently-opened"]===!0,Je=Ie.wait&&Ie.waitMarkerFilePath?c.URI.file(Ie.waitMarkerFilePath):void 0,Ye=Ie.remote||void 0,_e=Ie.profile,st=Ie["profile-temp"];if(!Ke&&!Qe&&!Ue){if(Ie["new-window"]||_e||st)return we.open({context:Me,cli:Ie,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:Je,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:st});if(Ne.length)return we.open({context:1,cli:Ie,urisToOpen:Ne.map(it=>(0,Ge.$Sh)(it)?{workspaceUri:c.URI.file(it)}:{fileUri:c.URI.file(it)}),noRecentEntry:Ve,waitMarkerFileURI:Je,initialStartup:!0})}return we.open({context:Me,cli:Ie,forceNewWindow:Ie["new-window"]||!Ke&&Ie["unity-launch"],diffMode:Ie.diff,mergeMode:Ie.merge,noRecentEntry:Ve,waitMarkerFileURI:Je,gotoLineMode:Ie.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:st})}M(){this.N(),E.protocol.registerHttpProtocol(v.Schemas.vscodeRemoteResource,(Ee,ke)=>{ke({url:Ee.url.replace(/^vscode-remote-resource:/,"http:"),method:Ee.method})}),this.O(this.j.args,process.env,!0),this.P(),o.$j&&E.app.runningUnderARM64Translation&&this.a?.sendToFocused("vscode:showTranslatedBuildWarning")}async N(){const Ee=this.p.win32MutexName;if(o.$i&&Ee)try{const ke=await new Promise((Me,Ie)=>{G(["@vscode/windows-mutex"],Me,Ie)}),we=new ke.Mutex(Ee);(0,$.$cb)(this.k.onWillShutdown)(()=>we.release())}catch(ke){this.h.error(ke)}}async O(Ee,ke,we){try{return await(0,ee.$wl)(this.l,this.h,Ee,ke)}catch(Me){const Ie=(0,S.$$h)(Me);we?this.a?.sendToFocused("vscode:showResolveShellEnvError",Ie):this.h.error(Ie)}return{}}async P(){try{const ke=(await this.n.readFile(this.j.argvResource)).value.toString(),we=JSON.parse((0,d.$Dm)(ke)),Ie=(0,Se.$0n)(this.l)>=1;if(we["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ie},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,b.$5e)()}"`,"}"],Ke=ke.substring(0,ke.length-2).concat(`,
`,Ne.join(`
`));await this.n.writeFile(this.j.argvResource,R.$Jb.fromString(Ke))}else{const Ne=ke.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ie},`);Ne!==ke&&await this.n.writeFile(this.j.argvResource,R.$Jb.fromString(Ne))}}catch(Ee){this.h.error(Ee)}}};e.$W4b=pt,e.$W4b=pt=pe([x(2,j.$mh),x(3,Y.$Pi),x(4,Y.$Qi),x(5,re.$$2b),x(6,B.$a3b),x(7,m.$Th),x(8,Le.$OM),x(9,J.$Qj),x(10,ge.$8i),x(11,gt.$g3b)],pt)}),define(te[312],ie([0,1,14,42,7,24,8,50,13,32,49,46,15,9,65,4,36,25,22,43,131,306,11,18,237,248,28,63,200,16,220,94,75,215,93,20,223,5,78,23,79,280,126,262,51,288,96,247,34,52,80,53,39,232,230,2,40,265,66,225,92,121,269,263]),function(G,e,E,C,r,M,R,S,f,u,$,d,p,h,v,y,o,g,c,b,k,w,t,l,s,n,i,a,m,P,I,D,O,L,N,q,re,ne,ee,ae,ue,K,X,U,W,T,J,Z,ce,oe,j,A,F,H,V,z,B,Y,se,le,ge,Pe,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ae{main(){try{this.a()}catch(me){console.error(me.message),E.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[me,be,_,he,de,Se,Ce,je]=this.b();try{try{await this.d(_,je,he,de,Ce)}catch(Oe){throw this.f(_,Ce,Oe),Oe}await me.invokeFunction(async Oe=>{const Te=Oe.get(ne.$Pi),We=Oe.get(q.$a3b),qe=Oe.get(P.$Qj),ze=Oe.get(ne.$Qi),Q=await this.e(Te,_,We,me,Ce,!0);return c.Promises.writeFile(_.mainLockfile,String(process.pid)).catch(fe=>{Te.warn(`app#startup(): Error writing main lockfile: ${fe.stack}`)}),Se.logger=ze.createLogger("main",{name:(0,t.localize)(0,null)}),(0,$.$cb)(We.onWillShutdown)(fe=>{qe.dispose(),he.dispose(),fe.join("instanceLockfile",c.Promises.unlink(_.mainLockfile).catch(()=>{}))}),me.createInstance(w.$W4b,Q,be).startup()})}catch(Oe){me.invokeFunction(this.i,Oe)}}b(){const me=new N.$lh,be=new z.$kb;process.once("exit",()=>be.dispose());const _={_serviceBrand:void 0,...ee.default};me.set(ae.$8i,_);const he=new i.$_2b(this.j(),_),de=this.c(he);me.set(i.$$2b,he);const Se=new se.$f4b((0,ne.$4i)(he),he.logsHome);me.set(se.$e4b,Se);const Ce=new re.$VZb(Se.getLogLevel()),je=be.add(new le.$WM(Ce,[new ne.$Wi(Se.getLogLevel())]));me.set(ne.$Pi,je);const Oe=new I.$qp(je);me.set(P.$Qj,Oe);const Te=new D.$Pp(je);Oe.registerProvider(p.Schemas.file,Te),Oe.registerProvider(p.Schemas.vscodeUserData,new Re.$74b(p.Schemas.file,Te,p.Schemas.vscodeUserData,je));const We=new Y.$ar(Oe);me.set(B.$nk,We);const qe=new Pe.$RM(1,he,je,Oe);me.set(ce.$NM,qe),me.set(ce.$OM,qe);const ze=new A.$h3b(qe,We,he,Oe,je);me.set(A.$g3b,ze);const Q=y.$i&&_.win32RegValueName?be.add(new H.$54b(je,_.win32RegValueName)):he.policyFile?be.add(new V.$64b(he.policyFile,Oe,je)):new F.$Vm;me.set(F.$Tm,Q);const fe=new s.$jn(ze.defaultProfile.settingsResource,Oe,Q,je);return me.set(l.$Th,fe),me.set(q.$a3b,new O.$kh(q.$b3b,void 0,!1)),me.set(W.$wo,new O.$kh(T.$34b,void 0,!0)),me.set(j.$U3b,new O.$kh(j.$V3b)),me.set(J.$Hk,new O.$kh(Z.$44b,void 0,!1)),me.set(X.$Dz,new O.$kh(U.$14b)),me.set(ue.$13b,new K.$Y4b(he,ze,je)),[new L.$Sp(me,!0),de,he,fe,qe,Ce,_,ze]}c(me){const be={VSCODE_IPC_HOOK:me.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(_=>{const he=process.env[_];typeof he=="string"&&(be[_]=he)}),Object.assign(process.env,be),be}async d(me,be,_,he,de){await R.Promises.settled([Promise.all([me.extensionsPath,me.codeCachePath,me.logsHome.fsPath,be.defaultProfile.globalStorageHome.fsPath,me.workspaceStorageHome.fsPath,me.localHistoryHome.fsPath,me.backupHome].map(Se=>Se?c.Promises.mkdir(Se,{recursive:!0}):void 0)),he.init(),_.initialize()]),be.init()}async e(me,be,_,he,de,Se){let Ce;try{(0,v.mark)("code/willStartMainServer"),Ce=await(0,k.$ih)(be.mainIPCHandle),(0,v.mark)("code/didStartMainServer"),(0,$.$cb)(_.onWillShutdown)(()=>Ce.dispose())}catch(je){if(je.code!=="EADDRINUSE")throw this.f(be,de,je),je;let Oe;try{Oe=await(0,k.$jh)(be.mainIPCHandle,"main")}catch(ze){if(!Se||y.$i||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.g((0,t.localize)(1,null,de.nameShort),(0,t.localize)(2,null),de),ze;try{(0,C.unlinkSync)(be.mainIPCHandle)}catch(Q){throw me.warn("Could not delete obsolete instance handle",Q),Q}return this.e(me,be,_,he,de,!1)}if(be.extensionTestsLocationURI&&!be.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${de.nameShort} is running.`;throw me.error(ze),Oe.dispose(),new Error(ze)}let Te;!be.args.wait&&!be.args.status&&(Te=setTimeout(()=>{this.g((0,t.localize)(3,null,de.nameShort),(0,t.localize)(4,null),de)},1e4));const We=b.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),qe=b.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(be.args.status)return he.invokeFunction(async()=>{const ze=new n.$hr(oe.$2n,de),Q=await qe.getMainDiagnostics(),fe=await qe.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),$e=await ze.getDiagnostics(Q,fe);throw console.log($e),new f.$_});throw y.$i&&await this.h(We,me),me.trace("Sending env to running instance..."),await We.start(be.args,process.env),Oe.dispose(),Te&&clearTimeout(Te),new f.$_("Sent env to running instance. Terminating...")}if(be.args.status)throw console.log((0,t.localize)(5,null,de.nameShort)),new f.$_("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ce}f(me,be,_){if(_.code==="EACCES"||_.code==="EPERM"){const he=(0,M.$lf)([me.userDataPath,me.extensionsPath,k.$eh]).map(de=>(0,d.$Xz)(r.URI.file(de),{os:y.OS,tildify:me}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$$h)(_),he.join(`
`)),be)}}g(me,be,_){E.dialog.showMessageBoxSync((0,ge.$_z)({type:"warning",buttons:[(0,t.localize)(8,null)],message:me,detail:be},_).options)}async h(me,be){if(y.$i){const _=await me.getMainProcessId();be.trace("Sending some foreground love to the running instance:",_);try{(await new Promise((he,de)=>{G(["windows-foreground-love"],he,de)})).allowSetForegroundWindow(_)}catch(he){be.error(he)}}}i(me,be){const _=me.get(ne.$Pi),he=me.get(q.$a3b);let de=0;be&&(be.isExpected?be.message&&_.trace(be.message):(de=1,be.stack?_.error(be.stack):_.error(`Startup error: ${be.toString()}`))),he.kill(de)}j(){const me=this.k((0,a.$nl)(process.argv));if(me.wait&&!me.waitMarkerFilePath){const be=(0,m.$X4b)(me.verbose);be&&((0,a.$pl)(process.argv,"--waitMarkerFilePath",be),me.waitMarkerFilePath=be)}return me}k(me){if(me["open-url"]&&(me._urls=me._,me._=[]),!me.remote){const be=this.l(me._,me.goto);me._=be}return me}l(me,be){const _=(0,o.cwd)(),he=me.map(Ce=>{let je=String(Ce),Oe;be&&(Oe=(0,u.$Qe)(je),je=Oe.path),je&&(je=this.m(_,je));const Te=(0,u.$Le)(je,_),We=(0,h.$ec)(Te);return We&&!(0,u.$He)(We)?null:be&&Oe?(Oe.path=Te,this.n(Oe)):Te}),de=y.$i||y.$j,Se=(0,M.$qf)(he,Ce=>Ce&&de?Ce.toLowerCase():Ce||"");return(0,M.$lf)(Se)}m(me,be){return y.$i&&(be=(0,g.$sd)(be,'"')),be=(0,g.$qd)((0,g.$qd)(be," "),"	"),y.$i&&(be=(0,h.$bc)(me,be),be=(0,g.$sd)(be,".")),be}n(me){const be=[me.path];return typeof me.line=="number"&&be.push(String(me.line)),typeof me.column=="number"&&be.push(String(me.column)),be.join(":")}}new Ae().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c3e3dba23e8fadc360aed75ce363ba185c49794/core/vs/code/electron-main/main.js.map
