/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/base/common/event","vs/nls!vs/code/node/cliProcessMain","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/strings","vs/base/common/uuid","vs/base/common/objects","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/policy/common/policy","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/json","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/id","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","@vscode/policy-watcher","vs/platform/environment/node/argvHelper","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],re=function(J){for(var e=[],M=0,A=J.length;M<A;M++)e[M]=ne[J[M]];return e};define(ne[70],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class M{static get(){const D=new Map,L=new Map,N=new Map,b=new Map;function u(h,O){h.has(O.detail)||h.set(O.detail,-O.timestamp)}function c(h,O){const y=h.get(O.detail);y&&(y>=0||h.set(O.detail,y+O.timestamp))}let w=[];typeof J=="function"&&typeof J.getStats=="function"&&(w=J.getStats().slice(0).sort((h,O)=>h.timestamp-O.timestamp));for(const h of w)switch(h.type){case 10:u(D,h);break;case 11:case 12:c(D,h);break;case 21:u(L,h);break;case 22:c(L,h);break;case 33:u(N,h);break;case 34:c(N,h);break;case 31:u(b,h);break;case 32:c(b,h);break}let R=0;N.forEach(h=>R+=h);function m(h){const O=[];return h.forEach((y,g)=>O.push([g,y])),O}return{amdLoad:m(D),amdInvoke:m(L),nodeRequire:m(N),nodeEval:m(b),nodeRequireTotal:R}}static toMarkdownTable(D,L){let N="";const b=[];return D.forEach((u,c)=>{b[c]=u.length}),L.forEach(u=>{u.forEach((c,w)=>{typeof c>"u"&&(c=u[w]="-");const R=c.toString().length;b[w]=Math.max(R,b[w])})}),D.forEach((u,c)=>{N+=`| ${u+" ".repeat(b[c]-u.toString().length)} `}),N+=`|
`,D.forEach((u,c)=>{N+=`| ${"-".repeat(b[c])} `}),N+=`|
`,L.forEach(u=>{u.forEach((c,w)=>{typeof c<"u"&&(N+=`| ${c+" ".repeat(b[w]-c.toString().length)} `)}),N+=`|
`}),N}}e.$S=M}),define(ne[52],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=e.$Sg=e.$Rg=void 0;function M(N){return(b,u,c)=>{let w=null,R=null;if(typeof c.value=="function"?(w="value",R=c.value):typeof c.get=="function"&&(w="get",R=c.get),!R)throw new Error("not supported");c[w]=N(R,u)}}function A(N,b,u){let c=null,w=null;if(typeof u.value=="function"?(c="value",w=u.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",w=u.get),!w)throw new Error("not supported");const R=`$memoize$${b}`;u[c]=function(...m){return this.hasOwnProperty(R)||Object.defineProperty(this,R,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,m)}),this[R]}}e.$Rg=A;function D(N,b,u){return M((c,w)=>{const R=`$debounce$${w}`,m=`$debounce$result$${w}`;return function(...h){this[m]||(this[m]=u?u():void 0),clearTimeout(this[R]),b&&(this[m]=b(this[m],...h),h=[this[m]]),this[R]=setTimeout(()=>{c.apply(this,h),this[m]=u?u():void 0},N)}})}e.$Sg=D;function L(N,b,u){return M((c,w)=>{const R=`$throttle$timer$${w}`,m=`$throttle$result$${w}`,h=`$throttle$lastRun$${w}`,O=`$throttle$pending$${w}`;return function(...y){if(this[m]||(this[m]=u?u():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...y)),this[O])return;const g=this[h]+N;g<=Date.now()?(this[h]=Date.now(),c.apply(this,[this[m]]),this[m]=u?u():void 0):(this[O]=!0,this[R]=setTimeout(()=>{this[O]=!1,this[h]=Date.now(),c.apply(this,[this[m]]),this[m]=u?u():void 0},g-Date.now()))}})}e.$Tg=L}),define(ne[71],re([0,1,9]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.ok=void 0;function A(u,c){if(!u)throw new Error(c?`Assertion failed (${c})`:"Assertion Failed")}e.ok=A;function D(u,c="Unreachable"){throw new Error(c)}e.$nc=D;function L(u){if(!u)throw new M.$bb("Assertion Failed")}e.$oc=L;function N(u){if(!u()){debugger;u(),(0,M.$Y)(new M.$bb("Assertion Failed"))}}e.$pc=N;function b(u,c){let w=0;for(;w<u.length-1;){const R=u[w],m=u[w+1];if(!c(R,m))return!1;w++}return!0}e.$qc=b}),define(ne[53],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var M;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(M||(e.ScanError=M={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A||(e.SyntaxKind=A={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function N(t,a=!1){let i=0;const s=t.length;let n="",o=0,l=16,P=0;function E(_){let ae=0,ce=0;for(;ae<_;){const te=t.charCodeAt(i);if(te>=48&&te<=57)ce=ce*16+te-48;else if(te>=65&&te<=70)ce=ce*16+te-65+10;else if(te>=97&&te<=102)ce=ce*16+te-97+10;else break;i++,ae++}return ae<_&&(ce=-1),ce}function S(_){i=_,n="",o=0,l=16,P=0}function j(){const _=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&c(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&c(t.charCodeAt(i)))for(i++;i<t.length&&c(t.charCodeAt(i));)i++;else return P=3,t.substring(_,i);let ae=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&c(t.charCodeAt(i))){for(i++;i<t.length&&c(t.charCodeAt(i));)i++;ae=i}else P=3;return t.substring(_,ae)}function B(){let _="",ae=i;for(;;){if(i>=s){_+=t.substring(ae,i),P=2;break}const ce=t.charCodeAt(i);if(ce===34){_+=t.substring(ae,i),i++;break}if(ce===92){if(_+=t.substring(ae,i),i++,i>=s){P=2;break}switch(t.charCodeAt(i++)){case 34:_+='"';break;case 92:_+="\\";break;case 47:_+="/";break;case 98:_+="\b";break;case 102:_+="\f";break;case 110:_+=`
`;break;case 114:_+="\r";break;case 116:_+="	";break;case 117:{const F=E(4);F>=0?_+=String.fromCharCode(F):P=4;break}default:P=5}ae=i;continue}if(ce>=0&&ce<=31)if(u(ce)){_+=t.substring(ae,i),P=2;break}else P=6;i++}return _}function ee(){if(n="",P=0,o=i,i>=s)return o=s,l=17;let _=t.charCodeAt(i);if(b(_)){do i++,n+=String.fromCharCode(_),_=t.charCodeAt(i);while(b(_));return l=15}if(u(_))return i++,n+=String.fromCharCode(_),_===13&&t.charCodeAt(i)===10&&(i++,n+=`
`),l=14;switch(_){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,n=B(),l=10;case 47:{const ae=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<s&&!u(t.charCodeAt(i));)i++;return n=t.substring(ae,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const ce=s-1;let te=!1;for(;i<ce;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,te=!0;break}i++}return te||(i++,P=1),n=t.substring(ae,i),l=13}return n+=String.fromCharCode(_),i++,l=16}case 45:if(n+=String.fromCharCode(_),i++,i===s||!c(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=j(),l=11;default:for(;i<s&&Z(_);)i++,_=t.charCodeAt(i);if(o!==i){switch(n=t.substring(o,i),n){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return n+=String.fromCharCode(_),i++,l=16}}function Z(_){if(b(_)||u(_))return!1;switch(_){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let _;do _=ee();while(_>=12&&_<=15);return _}return{setPosition:S,getPosition:()=>i,scan:a?le:ee,getToken:()=>l,getTokenValue:()=>n,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>P}}e.$tm=N;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var w;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(w||(w={}));function R(t,a){const i=[],s=new Object;let n;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function P(E,S,j,B){o.value=E,o.offset=S,o.length=j,o.type=B,o.colonOffset=void 0,n=o}try{I(t,{onObjectBegin:(E,S)=>{if(a<=E)throw s;n=void 0,l=a>E,i.push("")},onObjectProperty:(E,S,j)=>{if(a<S||(P(E,S,j,"property"),i[i.length-1]=E,a<=S+j))throw s},onObjectEnd:(E,S)=>{if(a<=E)throw s;n=void 0,i.pop()},onArrayBegin:(E,S)=>{if(a<=E)throw s;n=void 0,i.push(0)},onArrayEnd:(E,S)=>{if(a<=E)throw s;n=void 0,i.pop()},onLiteralValue:(E,S,j)=>{if(a<S||(P(E,S,j,v(E)),a<=S+j))throw s},onSeparator:(E,S,j)=>{if(a<=S)throw s;if(E===":"&&n&&n.type==="property")n.colonOffset=S,l=!1,n=void 0;else if(E===","){const B=i[i.length-1];typeof B=="number"?i[i.length-1]=B+1:(l=!0,i[i.length-1]=""),n=void 0}}})}catch(E){if(E!==s)throw E}return{path:i,previousNode:n,isAtPropertyKey:l,matches:E=>{let S=0;for(let j=0;S<E.length&&j<i.length;j++)if(E[S]===i[j]||E[S]==="*")S++;else if(E[S]!=="**")return!1;return S===E.length}}}e.$um=R;function m(t,a=[],i=L.DEFAULT){let s=null,n=[];const o=[];function l(E){Array.isArray(n)?n.push(E):s!==null&&(n[s]=E)}return I(t,{onObjectBegin:()=>{const E={};l(E),o.push(n),n=E,s=null},onObjectProperty:E=>{s=E},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{const E=[];l(E),o.push(n),n=E,s=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:l,onError:(E,S,j)=>{a.push({error:E,offset:S,length:j})}},i),n[0]}e.$vm=m;function h(t,a=[],i=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(E){s.type==="property"&&(s.length=E-s.offset,s=s.parent)}function o(E){return s.children.push(E),E}I(t,{onObjectBegin:E=>{s=o({type:"object",offset:E,length:-1,parent:s,children:[]})},onObjectProperty:(E,S,j)=>{s=o({type:"property",offset:S,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:E,offset:S,length:j,parent:s})},onObjectEnd:(E,S)=>{s.length=E+S-s.offset,s=s.parent,n(E+S)},onArrayBegin:(E,S)=>{s=o({type:"array",offset:E,length:-1,parent:s,children:[]})},onArrayEnd:(E,S)=>{s.length=E+S-s.offset,s=s.parent,n(E+S)},onLiteralValue:(E,S,j)=>{o({type:v(E),offset:S,length:j,parent:s,value:E}),n(S+j)},onSeparator:(E,S,j)=>{s.type==="property"&&(E===":"?s.colonOffset=S:E===","&&n(S))},onError:(E,S,j)=>{a.push({error:E,offset:S,length:j})}},i);const P=s.children[0];return P&&delete P.parent,P}e.$wm=h;function O(t,a){if(!t)return;let i=t;for(const s of a)if(typeof s=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let n=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===s){i=o.children[1],n=!0;break}if(!n)return}else{const n=s;if(i.type!=="array"||n<0||!Array.isArray(i.children)||n>=i.children.length)return;i=i.children[n]}return i}e.$xm=O;function y(t){if(!t.parent||!t.parent.children)return[];const a=y(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.$ym=y;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const a=Object.create(null);for(const i of t.children){const s=i.children[1];s&&(a[i.children[0].value]=g(s))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$zm=g;function d(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.$Am=d;function f(t,a,i=!1){if(d(t,a,i)){const s=t.children;if(Array.isArray(s))for(let n=0;n<s.length&&s[n].offset<=a;n++){const o=f(s[n],a,i);if(o)return o}return t}}e.$Bm=f;function I(t,a,i=L.DEFAULT){const s=N(t,!1);function n(X){return X?()=>X(s.getTokenOffset(),s.getTokenLength()):()=>!0}function o(X){return X?K=>X(K,s.getTokenOffset(),s.getTokenLength()):()=>!0}const l=n(a.onObjectBegin),P=o(a.onObjectProperty),E=n(a.onObjectEnd),S=n(a.onArrayBegin),j=n(a.onArrayEnd),B=o(a.onLiteralValue),ee=o(a.onSeparator),Z=n(a.onComment),le=o(a.onError),_=i&&i.disallowComments,ae=i&&i.allowTrailingComma;function ce(){for(;;){const X=s.scan();switch(s.getTokenError()){case 4:te(14);break;case 5:te(15);break;case 3:te(13);break;case 1:_||te(11);break;case 2:te(12);break;case 6:te(16);break}switch(X){case 12:case 13:_?te(10):Z();break;case 16:te(1);break;case 15:case 14:break;default:return X}}}function te(X,K=[],oe=[]){if(le(X),K.length+oe.length>0){let k=s.getToken();for(;k!==17;){if(K.indexOf(k)!==-1){ce();break}else if(oe.indexOf(k)!==-1)break;k=ce()}}}function F(X){const K=s.getTokenValue();return X?B(K):P(K),ce(),!0}function W(){switch(s.getToken()){case 11:{let X=0;try{X=JSON.parse(s.getTokenValue()),typeof X!="number"&&(te(2),X=0)}catch{te(2)}B(X);break}case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return ce(),!0}function T(){return s.getToken()!==10?(te(3,[],[2,5]),!1):(F(!1),s.getToken()===6?(ee(":"),ce(),G()||te(4,[],[2,5])):te(5,[],[2,5]),!0)}function U(){l(),ce();let X=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(X||te(4,[],[]),ee(","),ce(),s.getToken()===2&&ae)break}else X&&te(6,[],[]);T()||te(4,[],[2,5]),X=!0}return E(),s.getToken()!==2?te(7,[2],[]):ce(),!0}function V(){S(),ce();let X=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(X||te(4,[],[]),ee(","),ce(),s.getToken()===4&&ae)break}else X&&te(6,[],[]);G()||te(4,[],[4,5]),X=!0}return j(),s.getToken()!==4?te(8,[4],[]):ce(),!0}function G(){switch(s.getToken()){case 3:return V();case 1:return U();case 10:return F(!0);default:return W()}}return ce(),s.getToken()===17?i.allowEmptyContent?!0:(te(4,[],[]),!1):G()?(s.getToken()!==17&&te(9,[],[]),!0):(te(4,[],[]),!1)}e.$Cm=I;function $(t,a){const i=N(t),s=[];let n,o=0,l;do switch(l=i.getPosition(),n=i.scan(),n){case 12:case 13:case 17:o!==l&&s.push(t.substring(o,l)),a!==void 0&&s.push(i.getTokenValue().replace(/[^\r\n]/g,a)),o=i.getPosition();break}while(n!==17);return s.join("")}e.$Dm=$;function v(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Em=v}),define(ne[72],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=e.rot=e.$rl=void 0;function M(b,u,c){return Math.min(Math.max(b,u),c)}e.$rl=M;function A(b,u){return(u+b%u)%u}e.rot=A;class D{constructor(){this.a=0}getNext(){return this.a++}}e.$tl=D;class L{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ul=L;class N{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$vl=N}),function(){function J(D){const L=[];typeof D=="number"&&L.push("code/timeOrigin",D);function N(u){L.push(u,Date.now())}function b(){const u=[];for(let c=0;c<L.length;c+=2)u.push({name:L[c],startTime:L[c+1]});return u}return{mark:N,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const N of performance.getEntriesByType("mark"))L.push({name:N.name,startTime:Math.round(D+N.startTime)});return L}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function M(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return M(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=M(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=M(A))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var M=e();for(var A in M)(typeof exports=="object"?exports:J)[A]=M[A]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function M(A){if(e[A])return e[A].exports;var D=e[A]={i:A,l:!1,exports:{}};return J[A].call(D.exports,D,D.exports,M),D.l=!0,D.exports}return M.m=J,M.c=e,M.d=function(A,D,L){M.o(A,D)||Object.defineProperty(A,D,{enumerable:!0,get:L})},M.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},M.t=function(A,D){if(1&D&&(A=M(A)),8&D||4&D&&typeof A=="object"&&A&&A.__esModule)return A;var L=Object.create(null);if(M.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:A}),2&D&&typeof A!="string")for(var N in A)M.d(L,N,function(b){return A[b]}.bind(null,N));return L},M.n=function(A){var D=A&&A.__esModule?function(){return A.default}:function(){return A};return M.d(D,"a",D),D},M.o=function(A,D){return Object.prototype.hasOwnProperty.call(A,D)},M.p="",M(M.s=0)}([function(J,e,M){(function(A){var D;e=J.exports=oe,D=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],u=e.src=[],c=0,w=c++;u[w]="0|[1-9]\\d*";var R=c++;u[R]="[0-9]+";var m=c++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=c++;u[h]="("+u[w]+")\\.("+u[w]+")\\.("+u[w]+")";var O=c++;u[O]="("+u[R]+")\\.("+u[R]+")\\.("+u[R]+")";var y=c++;u[y]="(?:"+u[w]+"|"+u[m]+")";var g=c++;u[g]="(?:"+u[R]+"|"+u[m]+")";var d=c++;u[d]="(?:-("+u[y]+"(?:\\."+u[y]+")*))";var f=c++;u[f]="(?:-?("+u[g]+"(?:\\."+u[g]+")*))";var I=c++;u[I]="[0-9A-Za-z-]+";var $=c++;u[$]="(?:\\+("+u[I]+"(?:\\."+u[I]+")*))";var v=c++,t="v?"+u[h]+u[d]+"?"+u[$]+"?";u[v]="^"+t+"$";var a="[v=\\s]*"+u[O]+u[f]+"?"+u[$]+"?",i=c++;u[i]="^"+a+"$";var s=c++;u[s]="((?:<|>)?=?)";var n=c++;u[n]=u[R]+"|x|X|\\*";var o=c++;u[o]=u[w]+"|x|X|\\*";var l=c++;u[l]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[d]+")?"+u[$]+"?)?)?";var P=c++;u[P]="[v=\\s]*("+u[n]+")(?:\\.("+u[n]+")(?:\\.("+u[n]+")(?:"+u[f]+")?"+u[$]+"?)?)?";var E=c++;u[E]="^"+u[s]+"\\s*"+u[l]+"$";var S=c++;u[S]="^"+u[s]+"\\s*"+u[P]+"$";var j=c++;u[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=c++;u[B]="(?:~>?)";var ee=c++;u[ee]="(\\s*)"+u[B]+"\\s+",b[ee]=new RegExp(u[ee],"g");var Z=c++;u[Z]="^"+u[B]+u[l]+"$";var le=c++;u[le]="^"+u[B]+u[P]+"$";var _=c++;u[_]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[_]+"\\s+",b[ae]=new RegExp(u[ae],"g");var ce=c++;u[ce]="^"+u[_]+u[l]+"$";var te=c++;u[te]="^"+u[_]+u[P]+"$";var F=c++;u[F]="^"+u[s]+"\\s*("+a+")$|^$";var W=c++;u[W]="^"+u[s]+"\\s*("+t+")$|^$";var T=c++;u[T]="(\\s*)"+u[s]+"\\s*("+a+"|"+u[l]+")",b[T]=new RegExp(u[T],"g");var U=c++;u[U]="^\\s*("+u[l]+")\\s+-\\s+("+u[l]+")\\s*$";var V=c++;u[V]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var G=c++;u[G]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)D(X,u[X]),b[X]||(b[X]=new RegExp(u[X]));function K(q,Q){if(q instanceof oe)return q;if(typeof q!="string"||q.length>L||!(Q?b[i]:b[v]).test(q))return null;try{return new oe(q,Q)}catch{return null}}function oe(q,Q){if(q instanceof oe){if(q.loose===Q)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof oe))return new oe(q,Q);D("SemVer",q,Q),this.loose=Q;var x=q.trim().match(Q?b[i]:b[v]);if(!x)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+x[1],this.minor=+x[2],this.patch=+x[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");x[4]?this.prerelease=x[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var we=+$e;if(we>=0&&we<N)return we}return $e}):this.prerelease=[],this.build=x[5]?x[5].split("."):[],this.format()}e.parse=K,e.valid=function(q,Q){var x=K(q,Q);return x?x.version:null},e.clean=function(q,Q){var x=K(q.trim().replace(/^[=v]+/,""),Q);return x?x.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(q){return D("SemVer.compare",this.version,this.loose,q),q instanceof oe||(q=new oe(q,this.loose)),this.compareMain(q)||this.comparePre(q)},oe.prototype.compareMain=function(q){return q instanceof oe||(q=new oe(q,this.loose)),r(this.major,q.major)||r(this.minor,q.minor)||r(this.patch,q.patch)},oe.prototype.comparePre=function(q){if(q instanceof oe||(q=new oe(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var Q=0;do{var x=this.prerelease[Q],$e=q.prerelease[Q];if(D("prerelease compare",Q,x,$e),x===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(x===void 0)return-1;if(x!==$e)return r(x,$e)}while(++Q)},oe.prototype.inc=function(q,Q){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var x=this.prerelease.length;--x>=0;)typeof this.prerelease[x]=="number"&&(this.prerelease[x]++,x=-2);x===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,Q,x,$e){typeof x=="string"&&($e=x,x=void 0);try{return new oe(q,x).inc(Q,$e).version}catch{return null}},e.diff=function(q,Q){if(H(q,Q))return null;var x=K(q),$e=K(Q);if(x.prerelease.length||$e.prerelease.length){for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==$e[we])return"pre"+we;return"prerelease"}for(var we in x)if((we==="major"||we==="minor"||we==="patch")&&x[we]!==$e[we])return we},e.compareIdentifiers=r;var k=/^[0-9]+$/;function r(q,Q){var x=k.test(q),$e=k.test(Q);return x&&$e&&(q=+q,Q=+Q),x&&!$e?-1:$e&&!x?1:q<Q?-1:q>Q?1:0}function p(q,Q,x){return new oe(q,x).compare(new oe(Q,x))}function z(q,Q,x){return p(q,Q,x)>0}function C(q,Q,x){return p(q,Q,x)<0}function H(q,Q,x){return p(q,Q,x)===0}function Y(q,Q,x){return p(q,Q,x)!==0}function ie(q,Q,x){return p(q,Q,x)>=0}function de(q,Q,x){return p(q,Q,x)<=0}function fe(q,Q,x,$e){var we;switch(Q){case"===":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),we=q===x;break;case"!==":typeof q=="object"&&(q=q.version),typeof x=="object"&&(x=x.version),we=q!==x;break;case"":case"=":case"==":we=H(q,x,$e);break;case"!=":we=Y(q,x,$e);break;case">":we=z(q,x,$e);break;case">=":we=ie(q,x,$e);break;case"<":we=C(q,x,$e);break;case"<=":we=de(q,x,$e);break;default:throw new TypeError("Invalid operator: "+Q)}return we}function ue(q,Q){if(q instanceof ue){if(q.loose===Q)return q;q=q.value}if(!(this instanceof ue))return new ue(q,Q);D("comparator",q,Q),this.loose=Q,this.parse(q),this.semver===me?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(q,Q){return r(Q,q)},e.major=function(q,Q){return new oe(q,Q).major},e.minor=function(q,Q){return new oe(q,Q).minor},e.patch=function(q,Q){return new oe(q,Q).patch},e.compare=p,e.compareLoose=function(q,Q){return p(q,Q,!0)},e.rcompare=function(q,Q,x){return p(Q,q,x)},e.sort=function(q,Q){return q.sort(function(x,$e){return e.compare(x,$e,Q)})},e.rsort=function(q,Q){return q.sort(function(x,$e){return e.rcompare(x,$e,Q)})},e.gt=z,e.lt=C,e.eq=H,e.neq=Y,e.gte=ie,e.lte=de,e.cmp=fe,e.Comparator=ue;var me={};function ge(q,Q){if(q instanceof ge)return q.loose===Q?q:new ge(q.raw,Q);if(q instanceof ue)return new ge(q.value,Q);if(!(this instanceof ge))return new ge(q,Q);if(this.loose=Q,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(x){return this.parseRange(x.trim())},this).filter(function(x){return x.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function he(q){return!q||q.toLowerCase()==="x"||q==="*"}function ye(q,Q,x,$e,we,Re,ke,Le,Pe,Ne,ze,Ie,Ae){return((Q=he(x)?"":he($e)?">="+x+".0.0":he(we)?">="+x+"."+$e+".0":">="+Q)+" "+(Le=he(Pe)?"":he(Ne)?"<"+(+Pe+1)+".0.0":he(ze)?"<"+Pe+"."+(+Ne+1)+".0":Ie?"<="+Pe+"."+Ne+"."+ze+"-"+Ie:"<="+Le)).trim()}function Ee(q,Q){for(var x=0;x<q.length;x++)if(!q[x].test(Q))return!1;if(Q.prerelease.length){for(x=0;x<q.length;x++)if(D(q[x].semver),q[x].semver!==me&&q[x].semver.prerelease.length>0){var $e=q[x].semver;if($e.major===Q.major&&$e.minor===Q.minor&&$e.patch===Q.patch)return!0}return!1}return!0}function je(q,Q,x){try{Q=new ge(Q,x)}catch{return!1}return Q.test(q)}function Ue(q,Q,x,$e){var we,Re,ke,Le,Pe;switch(q=new oe(q,$e),Q=new ge(Q,$e),x){case">":we=z,Re=de,ke=C,Le=">",Pe=">=";break;case"<":we=C,Re=ie,ke=z,Le="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(q,Q,$e))return!1;for(var Ne=0;Ne<Q.set.length;++Ne){var ze=Q.set[Ne],Ie=null,Ae=null;if(ze.forEach(function(De){De.semver===me&&(De=new ue(">=0.0.0")),Ie=Ie||De,Ae=Ae||De,we(De.semver,Ie.semver,$e)?Ie=De:ke(De.semver,Ae.semver,$e)&&(Ae=De)}),Ie.operator===Le||Ie.operator===Pe||(!Ae.operator||Ae.operator===Le)&&Re(q,Ae.semver)||Ae.operator===Pe&&ke(q,Ae.semver))return!1}return!0}ue.prototype.parse=function(q){var Q=this.loose?b[F]:b[W],x=q.match(Q);if(!x)throw new TypeError("Invalid comparator: "+q);this.operator=x[1],this.operator==="="&&(this.operator=""),x[2]?this.semver=new oe(x[2],this.loose):this.semver=me},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(q){return D("Comparator.test",q,this.loose),this.semver===me||(typeof q=="string"&&(q=new oe(q,this.loose)),fe(q,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(q,Q){if(!(q instanceof ue))throw new TypeError("a Comparator is required");var x;if(this.operator==="")return x=new ge(q.value,Q),je(this.value,x,Q);if(q.operator==="")return x=new ge(this.value,Q),je(q.semver,x,Q);var $e=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),we=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),Re=this.semver.version===q.semver.version,ke=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),Le=fe(this.semver,"<",q.semver,Q)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),Pe=fe(this.semver,">",q.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return $e||we||Re&&ke||Le||Pe},e.Range=ge,ge.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},ge.prototype.toString=function(){return this.range},ge.prototype.parseRange=function(q){var Q=this.loose;q=q.trim(),D("range",q,Q);var x=Q?b[V]:b[U];q=q.replace(x,ye),D("hyphen replace",q),q=q.replace(b[T],"$1$2$3"),D("comparator trim",q,b[T]),q=(q=(q=q.replace(b[ee],"$1~")).replace(b[ae],"$1^")).split(/\s+/).join(" ");var $e=Q?b[F]:b[W],we=q.split(" ").map(function(Re){return function(ke,Le){return D("comp",ke),ke=function(Pe,Ne){return Pe.trim().split(/\s+/).map(function(ze){return function(Ie,Ae){D("caret",Ie,Ae);var De=Ae?b[te]:b[ce];return Ie.replace(De,function(Ce,be,ve,Se,Oe){var Me;return D("caret",Ie,Ce,be,ve,Se,Oe),he(be)?Me="":he(ve)?Me=">="+be+".0.0 <"+(+be+1)+".0.0":he(Se)?Me=be==="0"?">="+be+"."+ve+".0 <"+be+"."+(+ve+1)+".0":">="+be+"."+ve+".0 <"+(+be+1)+".0.0":Oe?(D("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=be==="0"?ve==="0"?">="+be+"."+ve+"."+Se+Oe+" <"+be+"."+ve+"."+(+Se+1):">="+be+"."+ve+"."+Se+Oe+" <"+be+"."+(+ve+1)+".0":">="+be+"."+ve+"."+Se+Oe+" <"+(+be+1)+".0.0"):(D("no pr"),Me=be==="0"?ve==="0"?">="+be+"."+ve+"."+Se+" <"+be+"."+ve+"."+(+Se+1):">="+be+"."+ve+"."+Se+" <"+be+"."+(+ve+1)+".0":">="+be+"."+ve+"."+Se+" <"+(+be+1)+".0.0"),D("caret return",Me),Me})}(ze,Ne)}).join(" ")}(ke,Le),D("caret",ke),ke=function(Pe,Ne){return Pe.trim().split(/\s+/).map(function(ze){return function(Ie,Ae){var De=Ae?b[le]:b[Z];return Ie.replace(De,function(Ce,be,ve,Se,Oe){var Me;return D("tilde",Ie,Ce,be,ve,Se,Oe),he(be)?Me="":he(ve)?Me=">="+be+".0.0 <"+(+be+1)+".0.0":he(Se)?Me=">="+be+"."+ve+".0 <"+be+"."+(+ve+1)+".0":Oe?(D("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Me=">="+be+"."+ve+"."+Se+Oe+" <"+be+"."+(+ve+1)+".0"):Me=">="+be+"."+ve+"."+Se+" <"+be+"."+(+ve+1)+".0",D("tilde return",Me),Me})}(ze,Ne)}).join(" ")}(ke,Le),D("tildes",ke),ke=function(Pe,Ne){return D("replaceXRanges",Pe,Ne),Pe.split(/\s+/).map(function(ze){return function(Ie,Ae){Ie=Ie.trim();var De=Ae?b[S]:b[E];return Ie.replace(De,function(Ce,be,ve,Se,Oe,Me){D("xRange",Ie,Ce,be,ve,Se,Oe,Me);var We=he(ve),Fe=We||he(Se),qe=Fe||he(Oe);return be==="="&&qe&&(be=""),We?Ce=be===">"||be==="<"?"<0.0.0":"*":be&&qe?(Fe&&(Se=0),qe&&(Oe=0),be===">"?(be=">=",Fe?(ve=+ve+1,Se=0,Oe=0):qe&&(Se=+Se+1,Oe=0)):be==="<="&&(be="<",Fe?ve=+ve+1:Se=+Se+1),Ce=be+ve+"."+Se+"."+Oe):Fe?Ce=">="+ve+".0.0 <"+(+ve+1)+".0.0":qe&&(Ce=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0"),D("xRange return",Ce),Ce})}(ze,Ne)}).join(" ")}(ke,Le),D("xrange",ke),ke=function(Pe,Ne){return D("replaceStars",Pe,Ne),Pe.trim().replace(b[G],"")}(ke,Le),D("stars",ke),ke}(Re,Q)}).join(" ").split(/\s+/);return this.loose&&(we=we.filter(function(Re){return!!Re.match($e)})),we=we.map(function(Re){return new ue(Re,Q)})},ge.prototype.intersects=function(q,Q){if(!(q instanceof ge))throw new TypeError("a Range is required");return this.set.some(function(x){return x.every(function($e){return q.set.some(function(we){return we.every(function(Re){return $e.intersects(Re,Q)})})})})},e.toComparators=function(q,Q){return new ge(q,Q).set.map(function(x){return x.map(function($e){return $e.value}).join(" ").trim().split(" ")})},ge.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new oe(q,this.loose));for(var Q=0;Q<this.set.length;Q++)if(Ee(this.set[Q],q))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(q,Q,x){var $e=null,we=null;try{var Re=new ge(Q,x)}catch{return null}return q.forEach(function(ke){Re.test(ke)&&($e&&we.compare(ke)!==-1||(we=new oe($e=ke,x)))}),$e},e.minSatisfying=function(q,Q,x){var $e=null,we=null;try{var Re=new ge(Q,x)}catch{return null}return q.forEach(function(ke){Re.test(ke)&&($e&&we.compare(ke)!==1||(we=new oe($e=ke,x)))}),$e},e.validRange=function(q,Q){try{return new ge(q,Q).range||"*"}catch{return null}},e.ltr=function(q,Q,x){return Ue(q,Q,"<",x)},e.gtr=function(q,Q,x){return Ue(q,Q,">",x)},e.outside=Ue,e.prerelease=function(q,Q){var x=K(q,Q);return x&&x.prerelease.length?x.prerelease:null},e.intersects=function(q,Q,x){return q=new ge(q,x),Q=new ge(Q,x),q.intersects(Q)},e.coerce=function(q){if(q instanceof oe)return q;if(typeof q!="string")return null;var Q=q.match(b[j]);return Q==null?null:K((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,M(1))},function(J,e){var M,A,D=J.exports={};function L(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function b(g){if(M===setTimeout)return setTimeout(g,0);if((M===L||!M)&&setTimeout)return M=setTimeout,setTimeout(g,0);try{return M(g,0)}catch{try{return M.call(null,g,0)}catch{return M.call(this,g,0)}}}(function(){try{M=typeof setTimeout=="function"?setTimeout:L}catch{M=L}try{A=typeof clearTimeout=="function"?clearTimeout:N}catch{A=N}})();var u,c=[],w=!1,R=-1;function m(){w&&u&&(w=!1,u.length?c=u.concat(c):R=-1,c.length&&h())}function h(){if(!w){var g=b(m);w=!0;for(var d=c.length;d;){for(u=c,c=[];++R<d;)u&&u[R].run();R=-1,d=c.length}u=null,w=!1,function(f){if(A===clearTimeout)return clearTimeout(f);if((A===N||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(f);try{A(f)}catch{try{return A.call(null,f)}catch{return A.call(this,f)}}}(g)}}function O(g,d){this.fun=g,this.array=d}function y(){}D.nextTick=function(g){var d=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)d[f-1]=arguments[f];c.push(new O(g,d)),c.length!==1||w||b(h)},O.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=y,D.addListener=y,D.once=y,D.off=y,D.removeListener=y,D.removeAllListeners=y,D.emit=y,D.prependListener=y,D.prependOnceListener=y,D.listeners=function(g){return[]},D.binding=function(g){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(g){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(ne[73],re([0,1]),function(J,e){"use strict";var M;Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class A{constructor(b,u,c){this.level=b,this.key=u,this.value=c,this.forward=[]}}const D=void 0;class L{constructor(b,u=2**16){this.comparator=b,this[M]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new A(this.c,D,D)}get size(){return this.f}clear(){this.e=new A(this.c,D,D)}has(b){return!!L.g(this,b,this.comparator)}get(b){return L.g(this,b,this.comparator)?.value}set(b,u){return L.h(this,b,u,this.comparator)&&(this.f+=1),this}delete(b){const u=L.k(this,b,this.comparator);return u&&(this.f-=1),u}forEach(b,u){let c=this.e.forward[0];for(;c;)b.call(u,c.value,c.key,this),c=c.forward[0]}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this.e.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this.e.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this.e.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",u=this.e.forward[0];for(;u;)b+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return b}static g(b,u,c){let w=b.e;for(let R=b.d-1;R>=0;R--)for(;w.forward[R]&&c(w.forward[R].key,u)<0;)w=w.forward[R];if(w=w.forward[0],w&&c(w.key,u)===0)return w}static h(b,u,c,w){const R=[];let m=b.e;for(let h=b.d-1;h>=0;h--){for(;m.forward[h]&&w(m.forward[h].key,u)<0;)m=m.forward[h];R[h]=m}if(m=m.forward[0],m&&w(m.key,u)===0)return m.value=c,!1;{const h=L.j(b);if(h>b.d){for(let O=b.d;O<h;O++)R[O]=b.e;b.d=h}m=new A(h,u,c);for(let O=0;O<h;O++)m.forward[O]=R[O].forward[O],R[O].forward[O]=m;return!0}}static j(b,u=.5){let c=1;for(;Math.random()<u&&c<b.c;)c+=1;return c}static k(b,u,c){const w=[];let R=b.e;for(let m=b.d-1;m>=0;m--){for(;R.forward[m]&&c(R.forward[m].key,u)<0;)R=R.forward[m];w[m]=R}if(R=R.forward[0],!R||c(R.key,u)!==0)return!1;for(let m=0;m<b.d&&w[m].forward[m]===R;m++)w[m].forward[m]=R.forward[m];for(;b.d>0&&b.e.forward[b.d-1]===D;)b.d-=1;return!0}}e.$_q=L}),define(ne[41],re([0,1,9,2]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function D($){const v=$;return v?typeof v.read=="function":!1}e.$ub=D;function L($){const v=$;return v?[v.on,v.pause,v.resume,v.destroy].every(t=>typeof t=="function"):!1}e.$vb=L;function N($){const v=$;return v?L(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$wb=N;function b($,v){return new u($,v)}e.$xb=b;class u{constructor(v,t){this.e=v,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(t=>t(v))}h(v){this.c.error.length===0?(0,M.$Y)(v):this.c.error.slice(0).forEach(t=>t(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,t){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(v,t){if(this.a.destroyed)return;let a;switch(v){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c($,v){const t=[];let a;for(;(a=$.read())!==null;)t.push(a);return v(t)}e.$yb=c;function w($,v,t){const a=[];let i;for(;(i=$.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?v(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const s=i;return i=void 0,s}return $.read()}}}e.$zb=w;function R($,v){return new Promise((t,a)=>{const i=[];m($,{onData:s=>{v&&i.push(s)},onError:s=>{v?a(s):t(void 0)},onEnd:()=>{t(v?v(i):void 0)}})})}e.$Ab=R;function m($,v){let t=!1;return $.on("error",a=>{t||v.onError(a)}),$.on("end",()=>{t||v.onEnd()}),$.on("data",a=>{t||v.onData(a)}),(0,A.$jb)(()=>t=!0)}e.$Bb=m;function h($,v){return new Promise((t,a)=>{const i=new A.$kb,s=[],n=P=>{if(s.push(P),s.length>v)return i.dispose(),$.pause(),t({stream:$,buffer:s,ended:!1})},o=P=>a(P),l=()=>t({stream:$,buffer:s,ended:!0});i.add((0,A.$jb)(()=>$.removeListener("error",o))),$.on("error",o),i.add((0,A.$jb)(()=>$.removeListener("end",l))),$.on("end",l),i.add((0,A.$jb)(()=>$.removeListener("data",n))),$.on("data",n)})}e.$Cb=h;function O($,v){const t=b(v);return t.end($),t}e.$Db=O;function y(){const $=b(()=>{throw new Error("not supported")});return $.end(),$}e.$Eb=y;function g($){let v=!1;return{read:()=>v?null:(v=!0,$)}}e.$Fb=g;function d($,v,t){const a=b(t);return m($,{onData:i=>a.write(v.data(i)),onError:i=>a.error(v.error?v.error(i):i),onEnd:()=>a.end()}),a}e.$Gb=d;function f($,v,t){let a=!1;return{read:()=>{const i=v.read();return a?i:(a=!0,i!==null?t([$,i]):$)}}}e.$Hb=f;function I($,v,t){let a=!1;const i=b(t);return m(v,{onData:s=>a?i.write(s):(a=!0,i.write(t([$,s]))),onError:s=>i.error(s),onEnd:()=>{a||(a=!0,i.write($)),i.end()}}),i}e.$Ib=I}),define(ne[14],re([0,1,164,41]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const D=typeof Buffer<"u",L=new M.$T(()=>new Uint8Array(256));let N,b;class u{static alloc(j){return D?new u(Buffer.allocUnsafe(j)):new u(new Uint8Array(j))}static wrap(j){return D&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new u(j)}static fromString(j,B){return!(B?.dontUseNodeBuffer||!1)&&D?new u(Buffer.from(j)):(N||(N=new TextEncoder),new u(N.encode(j)))}static fromByteArray(j){const B=u.alloc(j.length);for(let ee=0,Z=j.length;ee<Z;ee++)B.buffer[ee]=j[ee];return B}static concat(j,B){if(typeof B>"u"){B=0;for(let le=0,_=j.length;le<_;le++)B+=j[le].byteLength}const ee=u.alloc(B);let Z=0;for(let le=0,_=j.length;le<_;le++){const ae=j[le];ee.set(ae,Z),Z+=ae.byteLength}return ee}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=u.alloc(this.byteLength);return j.set(this),j}toString(){return D?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(j,B){return new u(this.buffer.subarray(j,B))}set(j,B){if(j instanceof u)this.buffer.set(j.buffer,B);else if(j instanceof Uint8Array)this.buffer.set(j,B);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),B);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return m(this.buffer,j)}writeUInt32BE(j,B){h(this.buffer,j,B)}readUInt32LE(j){return O(this.buffer,j)}writeUInt32LE(j,B){y(this.buffer,j,B)}readUInt8(j){return g(this.buffer,j)}writeUInt8(j,B){d(this.buffer,j,B)}indexOf(j,B=0){return c(this.buffer,j instanceof u?j.buffer:j,B)}}e.$Jb=u;function c(S,j,B=0){const ee=j.byteLength,Z=S.byteLength;if(ee===0)return 0;if(ee===1)return S.indexOf(j[0]);if(ee>Z-B)return-1;const le=L.value;le.fill(j.length);for(let te=0;te<j.length;te++)le[j[te]]=j.length-te-1;let _=B+j.length-1,ae=_,ce=-1;for(;_<Z;)if(S[_]===j[ae]){if(ae===0){ce=_;break}_--,ae--}else _+=Math.max(j.length-ae,le[S[_]]),ae=j.length-1;return ce}e.$Kb=c;function w(S,j){return S[j+0]<<0>>>0|S[j+1]<<8>>>0}e.$Lb=w;function R(S,j,B){S[B+0]=j&255,j=j>>>8,S[B+1]=j&255}e.$Mb=R;function m(S,j){return S[j]*2**24+S[j+1]*2**16+S[j+2]*2**8+S[j+3]}e.$Nb=m;function h(S,j,B){S[B+3]=j,j=j>>>8,S[B+2]=j,j=j>>>8,S[B+1]=j,j=j>>>8,S[B]=j}e.$Ob=h;function O(S,j){return S[j+0]<<0>>>0|S[j+1]<<8>>>0|S[j+2]<<16>>>0|S[j+3]<<24>>>0}e.$Pb=O;function y(S,j,B){S[B+0]=j&255,j=j>>>8,S[B+1]=j&255,j=j>>>8,S[B+2]=j&255,j=j>>>8,S[B+3]=j&255}e.$Qb=y;function g(S,j){return S[j]}e.$Rb=g;function d(S,j,B){S[B]=j}e.$Sb=d;function f(S){return A.$yb(S,j=>u.concat(j))}e.$Tb=f;function I(S){return A.$Fb(S)}e.$Ub=I;function $(S){return A.$Ab(S,j=>u.concat(j))}e.$Vb=$;async function v(S){return S.ended?u.concat(S.buffer):u.concat([...S.buffer,await $(S.stream)])}e.$Wb=v;function t(S){return A.$Db(S,j=>u.concat(j))}e.$Xb=t;function a(S){return A.$Gb(S,{data:j=>typeof j=="string"?u.fromString(j):u.wrap(j)},j=>u.concat(j))}e.$Yb=a;function i(S){return A.$xb(j=>u.concat(j),S)}e.$Zb=i;function s(S,j){return A.$Hb(S,j,B=>u.concat(B))}e.$1b=s;function n(S,j){return A.$Ib(S,j,B=>u.concat(B))}e.$2b=n;function o(S){let j=0,B=0,ee=0;const Z=new Uint8Array(Math.floor(S.length/4*3)),le=ae=>{switch(B){case 3:Z[ee++]=j|ae,B=0;break;case 2:Z[ee++]=j|ae>>>2,j=ae<<6,B=3;break;case 1:Z[ee++]=j|ae>>>4,j=ae<<4,B=2;break;default:j=ae<<2,B=1}};for(let ae=0;ae<S.length;ae++){const ce=S.charCodeAt(ae);if(ce>=65&&ce<=90)le(ce-65);else if(ce>=97&&ce<=122)le(ce-97+26);else if(ce>=48&&ce<=57)le(ce-48+52);else if(ce===43||ce===45)le(62);else if(ce===47||ce===95)le(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${S[ae]}`)}}const _=ee;for(;B>0;)le(0);return u.wrap(Z).slice(0,_)}e.$3b=o;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function E({buffer:S},j=!0,B=!1){const ee=B?P:l;let Z="";const le=S.byteLength%3;let _=0;for(;_<S.byteLength-le;_+=3){const ae=S[_+0],ce=S[_+1],te=S[_+2];Z+=ee[ae>>>2],Z+=ee[(ae<<4|ce>>>4)&63],Z+=ee[(ce<<2|te>>>6)&63],Z+=ee[te&63]}if(le===1){const ae=S[_+0];Z+=ee[ae>>>2],Z+=ee[ae<<4&63],j&&(Z+="==")}else if(le===2){const ae=S[_+0],ce=S[_+1];Z+=ee[ae>>>2],Z+=ee[(ae<<4|ce>>>4)&63],Z+=ee[ce<<2&63],j&&(Z+="=")}return Z}e.$4b=E}),define(ne[42],re([0,1,28]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=void 0;function A(d){return D(d,0)}e.$bi=A;function D(d,f){switch(typeof d){case"object":return d===null?L(349,f):Array.isArray(d)?u(d,f):c(d,f);case"string":return b(d,f);case"boolean":return N(d,f);case"number":return L(d,f);case"undefined":return L(937,f);default:return L(617,f)}}e.$ci=D;function L(d,f){return(f<<5)-f+d|0}e.$di=L;function N(d,f){return L(d?433:863,f)}function b(d,f){f=L(149417,f);for(let I=0,$=d.length;I<$;I++)f=L(d.charCodeAt(I),f);return f}e.$ei=b;function u(d,f){return f=L(104579,f),d.reduce((I,$)=>D($,I),f)}function c(d,f){return f=L(181387,f),Object.keys(d).sort().reduce((I,$)=>(I=b($,I),D(d[$],I)),f)}class w{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=D(f,this.g),this.g}}e.$fi=w;var R;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(R||(R={}));function m(d,f,I=32){const $=I-f,v=~((1<<$)-1);return(d<<f|(v&d)>>>$)>>>0}function h(d,f=0,I=d.byteLength,$=0){for(let v=0;v<I;v++)d[f+v]=$}function O(d,f,I="0"){for(;d.length<f;)d=I+d;return d}function y(d,f=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(I=>I.toString(16).padStart(2,"0")).join(""):O((d>>>0).toString(16),f/4)}e.$gi=y;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const I=f.length;if(I===0)return;const $=this.p;let v=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=f.charCodeAt(0),i=0);;){let s=a;if(M.$Pd(a))if(i+1<I){const n=f.charCodeAt(i+1);M.$Qd(n)?(i++,s=M.$Rd(a,n)):s=65533}else{t=a;break}else M.$Qd(a)&&(s=65533);if(v=this.w($,v,s),i++,i<I)a=f.charCodeAt(i);else break}this.r=v,this.u=t}w(f,I,$){return $<128?f[I++]=$:$<2048?(f[I++]=192|($&1984)>>>6,f[I++]=128|($&63)>>>0):$<65536?(f[I++]=224|($&61440)>>>12,f[I++]=128|($&4032)>>>6,f[I++]=128|($&63)>>>0):(f[I++]=240|($&1835008)>>>18,f[I++]=128|($&258048)>>>12,f[I++]=128|($&4032)>>>6,f[I++]=128|($&63)>>>0),I>=64&&(this.y(),I-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),I}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=g.g,I=this.q;for(let l=0;l<64;l+=4)f.setUint32(l,I.getUint32(l,!1),!1);for(let l=64;l<320;l+=4)f.setUint32(l,m(f.getUint32(l-12,!1)^f.getUint32(l-32,!1)^f.getUint32(l-56,!1)^f.getUint32(l-64,!1),1),!1);let $=this.h,v=this.l,t=this.m,a=this.n,i=this.o,s,n,o;for(let l=0;l<80;l++)l<20?(s=v&t|~v&a,n=1518500249):l<40?(s=v^t^a,n=1859775393):l<60?(s=v&t|v&a|t&a,n=2400959708):(s=v^t^a,n=3395469782),o=m($,5)+s+i+n+f.getUint32(l*4,!1)&4294967295,i=a,a=t,t=m(v,30),v=$,$=o;this.h=this.h+$&4294967295,this.l=this.l+v&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.$hi=g}),define(ne[54],re([0,1,28]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(A||(A={})),function(D){const L="error",N="warning",b="warn",u="info",c="ignore";function w(m){return m?M.$Ld(L,m)?D.Error:M.$Ld(N,m)||M.$Ld(b,m)?D.Warning:M.$Ld(u,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=w;function R(m){switch(m){case D.Error:return L;case D.Warning:return N;case D.Info:return u;default:return c}}D.toString=R}(A||(A={})),e.default=A}),define(ne[30],re([0,1,3]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0;function A(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const f=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([I,$])=>{f[I]=$&&typeof $=="object"?A($):$}),f}e.$Fm=A;function D(d){if(!d||typeof d!="object")return d;const f=[d];for(;f.length>0;){const I=f.shift();Object.freeze(I);for(const $ in I)if(L.call(I,$)){const v=I[$];typeof v=="object"&&!Object.isFrozen(v)&&!(0,M.$le)(v)&&f.push(v)}}return d}e.$Gm=D;const L=Object.prototype.hasOwnProperty;function N(d,f){return b(d,f,new Set)}e.$Hm=N;function b(d,f,I){if((0,M.$re)(d))return d;const $=f(d);if(typeof $<"u")return $;if(Array.isArray(d)){const v=[];for(const t of d)v.push(b(t,f,I));return v}if((0,M.$ke)(d)){if(I.has(d))throw new Error("Cannot clone recursive data-structure");I.add(d);const v={};for(const t in d)L.call(d,t)&&(v[t]=b(d[t],f,I));return I.delete(d),v}return d}function u(d,f,I=!0){return(0,M.$ke)(d)?((0,M.$ke)(f)&&Object.keys(f).forEach($=>{$ in d?I&&((0,M.$ke)(d[$])&&(0,M.$ke)(f[$])?u(d[$],f[$],I):d[$]=f[$]):d[$]=f[$]}),d):f}e.$Im=u;function c(d,f){if(d===f)return!0;if(d==null||f===null||f===void 0||typeof d!=typeof f||typeof d!="object"||Array.isArray(d)!==Array.isArray(f))return!1;let I,$;if(Array.isArray(d)){if(d.length!==f.length)return!1;for(I=0;I<d.length;I++)if(!c(d[I],f[I]))return!1}else{const v=[];for($ in d)v.push($);v.sort();const t=[];for($ in f)t.push($);if(t.sort(),!c(v,t))return!1;for(I=0;I<v.length;I++)if(!c(d[v[I]],f[v[I]]))return!1}return!0}e.$Jm=c;function w(d){const f=new Set;return JSON.stringify(d,(I,$)=>{if((0,M.$ke)($)||Array.isArray($)){if(f.has($))return"[Circular]";f.add($)}return $})}e.$Km=w;function R(d,f){const I=Object.create(null);return!d||!f||Object.keys(f).forEach(v=>{const t=d[v],a=f[v];c(t,a)||(I[v]=a)}),I}e.$Lm=R;function m(d,f){const I=f.toLowerCase(),$=Object.keys(d).find(v=>v.toLowerCase()===I);return $?d[$]:d[f]}e.$Mm=m;function h(d,f){const I=Object.create(null);for(const[$,v]of Object.entries(d))f($,v)&&(I[$]=v);return I}e.$Nm=h;function O(d){let f=[];for(;Object.prototype!==d;)f=f.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return f}e.$Om=O;function y(d){const f=[];for(const I of O(d))typeof d[I]=="function"&&f.push(I);return f}e.$Pm=y;function g(d,f){const I=v=>function(){const t=Array.prototype.slice.call(arguments,0);return f(v,t)},$={};for(const v of d)$[v]=I(v);return $}e.$Qm=g}),define(ne[29],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=void 0;const M=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(D){return M.test(D)}e.$4e=A,e.$5e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(b){for(let u=0;u<b.length;u++)b[u]=Math.floor(Math.random()*256);return b};const L=new Uint8Array(16),N=[];for(let b=0;b<256;b++)N.push(b.toString(16).padStart(2,"0"));return function(){D(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let u=0,c="";return c+=N[L[u++]],c+=N[L[u++]],c+=N[L[u++]],c+=N[L[u++]],c+="-",c+=N[L[u++]],c+=N[L[u++]],c+="-",c+=N[L[u++]],c+=N[L[u++]],c+="-",c+=N[L[u++]],c+=N[L[u++]],c+="-",c+=N[L[u++]],c+=N[L[u++]],c+=N[L[u++]],c+=N[L[u++]],c+=N[L[u++]],c+=N[L[u++]],c}}()}),define(ne[74],re([0,1,32]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(N){const b=N.replace(/\-/g,":").toLowerCase();return!A.has(b)}function L(){const N=(0,M.networkInterfaces)();for(const b in N){const u=N[b];if(u){for(const{mac:c}of u)if(D(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$qm=L}),define(ne[75],re([0,1,32,46,29,74]),function(J,e,M,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0,e.$rm=new class{c(c){return this.a||(this.a=A.$th.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(c)}value(){if(this.b===void 0){let c=0,w=0;const R=(0,M.networkInterfaces)();for(const m in R){const h=R[m];if(h)for(const{mac:O,internal:y}of h)y||(w+=1,this.c(O.toUpperCase())&&(c+=1))}this.b=w>0?c/w:0}return this.b}};let N;async function b(c){return N||(N=(async()=>await u(c)||D.$5e())()),N}e.$sm=b;async function u(c){try{const w=await new Promise((m,h)=>{J(["crypto"],m,h)}),R=(0,L.$qm)();return w.createHash("sha256").update(R,"utf8").digest("hex")}catch(w){c(w);return}}}),define(ne[76],re([7,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ne[77],re([0,1,76]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=void 0;const A=60,D=A*60,L=D*24,N=L*7,b=L*30,u=L*365;function c(R,m,h,O){typeof R!="number"&&(R=R.getTime());const y=Math.round((new Date().getTime()-R)/1e3);if(y<-30)return(0,M.localize)(0,null,c(new Date().getTime()+y*1e3,!1));if(!O&&y<30)return(0,M.localize)(1,null);let g;return y<A?(g=y,m?g===1?h?(0,M.localize)(2,null,g):(0,M.localize)(3,null,g):h?(0,M.localize)(4,null,g):(0,M.localize)(5,null,g):g===1?h?(0,M.localize)(6,null,g):(0,M.localize)(7,null,g):h?(0,M.localize)(8,null,g):(0,M.localize)(9,null,g)):y<D?(g=Math.floor(y/A),m?g===1?h?(0,M.localize)(10,null,g):(0,M.localize)(11,null,g):h?(0,M.localize)(12,null,g):(0,M.localize)(13,null,g):g===1?h?(0,M.localize)(14,null,g):(0,M.localize)(15,null,g):h?(0,M.localize)(16,null,g):(0,M.localize)(17,null,g)):y<L?(g=Math.floor(y/D),m?g===1?h?(0,M.localize)(18,null,g):(0,M.localize)(19,null,g):h?(0,M.localize)(20,null,g):(0,M.localize)(21,null,g):g===1?h?(0,M.localize)(22,null,g):(0,M.localize)(23,null,g):h?(0,M.localize)(24,null,g):(0,M.localize)(25,null,g)):y<N?(g=Math.floor(y/L),m?g===1?(0,M.localize)(26,null,g):(0,M.localize)(27,null,g):g===1?(0,M.localize)(28,null,g):(0,M.localize)(29,null,g)):y<b?(g=Math.floor(y/N),m?g===1?h?(0,M.localize)(30,null,g):(0,M.localize)(31,null,g):h?(0,M.localize)(32,null,g):(0,M.localize)(33,null,g):g===1?h?(0,M.localize)(34,null,g):(0,M.localize)(35,null,g):h?(0,M.localize)(36,null,g):(0,M.localize)(37,null,g)):y<u?(g=Math.floor(y/b),m?g===1?h?(0,M.localize)(38,null,g):(0,M.localize)(39,null,g):h?(0,M.localize)(40,null,g):(0,M.localize)(41,null,g):g===1?h?(0,M.localize)(42,null,g):(0,M.localize)(43,null,g):h?(0,M.localize)(44,null,g):(0,M.localize)(45,null,g)):(g=Math.floor(y/u),m?g===1?h?(0,M.localize)(46,null,g):(0,M.localize)(47,null,g):h?(0,M.localize)(48,null,g):(0,M.localize)(49,null,g):g===1?h?(0,M.localize)(50,null,g):(0,M.localize)(51,null,g):h?(0,M.localize)(52,null,g):(0,M.localize)(53,null,g))}e.$Pl=c;function w(R){return R.getFullYear()+"-"+String(R.getMonth()+1).padStart(2,"0")+"-"+String(R.getDate()).padStart(2,"0")+"T"+String(R.getHours()).padStart(2,"0")+":"+String(R.getMinutes()).padStart(2,"0")+":"+String(R.getSeconds()).padStart(2,"0")+"."+(R.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ql=w}),define(ne[78],re([7,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ne[33],re([0,1,19,3,78]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=void 0;function L(R,m){return m&&(R.stack||R.stacktrace)?D.localize(0,null,b(R),N(R.stack)||N(R.stacktrace)):b(R)}function N(R){return Array.isArray(R)?R.join(`
`):R}function b(R){return R.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${R.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof R.code=="string"&&typeof R.errno=="number"&&typeof R.syscall=="string"?D.localize(1,null,R.message):R.message||D.localize(2,null)}function u(R=null,m=!1){if(!R)return D.localize(3,null);if(Array.isArray(R)){const h=M.$lf(R),O=u(h[0],m);return h.length>1?D.localize(4,null,O,h.length):O}if(A.$ie(R))return R;if(R.detail){const h=R.detail;if(h.error)return L(h.error,m);if(h.exception)return L(h.exception,m)}return R.stack?L(R,m):R.message?R.message:D.localize(5,null)}e.$$h=u;function c(R){const m=R;return m instanceof Error&&Array.isArray(m.actions)}e.$_h=c;function w(R,m){let h;return typeof R=="string"?h=new Error(R):h=R,h.actions=m,h}e.$ai=w}),define(ne[79],re([7,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ne[80],re([0,1,79]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=void 0;function A(D){switch(D){case 1:return(0,M.localize)(0,null);case 2:return(0,M.localize)(1,null);case 3:return(0,M.localize)(2,null);case 4:return(0,M.localize)(3,null);case 5:return(0,M.localize)(4,null);case 6:return(0,M.localize)(5,null);case 7:return(0,M.localize)(6,null);case 8:return(0,M.localize)(7,null);case 9:return(0,M.localize)(8,null);default:return""}}e.$_o=A}),define(ne[55],re([0,1,12]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.TerminateResponseCode=e.Source=void 0;var A;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(A||(e.Source=A={}));var D;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function L(b,...u){const c=u.reduce((m,h)=>(m[h]=!0,m),{}),w=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!c[m]).forEach(m=>{for(let h=0;h<w.length;h++)if(m.search(w[h])!==-1){delete b[m];break}})}e.$dl=L;function N(b){b&&(delete b.DEBUG,M.$j&&delete b.DYLD_LIBRARY_PATH,M.$k&&delete b.LD_PRELOAD)}e.$el=N}),define(ne[81],re([0,1,11]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Cp=e.$Bp=e.$Ap=void 0;function A(c){const w=c;return w&&typeof w.type=="string"&&typeof w.severity=="string"}e.$Ap=A;function D(c){const w=[];let R;try{const m=JSON.parse(c.arguments),h=m[m.length-1];h&&h.__$stack&&(m.pop(),R=h.__$stack),w.push(...m)}catch{w.push("Unable to log remote console arguments",c.arguments)}return{args:w,stack:R}}e.$Bp=D;function L(c){if(typeof c!="string")return L(D(c).stack);const w=c;if(w){const R=N(w),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(R||"");if(m&&m.length===4)return{uri:M.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$Cp=L;function N(c){if(!c)return c;const w=c.indexOf(`
`);return w===-1?c:c.substring(0,w)}function b(c,w){const{args:R,stack:m}=D(c),h=typeof R[0]=="string"&&R.length===1;let O=N(m);O&&(O=`(${O.trim()})`);let y=[];if(typeof R[0]=="string"?O&&h?y=[`%c[${w}] %c${R[0]} %c${O}`,u("blue"),u(""),u("grey")]:y=[`%c[${w}] %c${R[0]}`,u("blue"),u(""),...R.slice(1)]:y=[`%c[${w}]%`,u("blue"),...R],O&&!h&&y.push(O),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}e.log=b;function u(c){return`color: ${c}`}}),define(ne[47],re([0,1,14,28,11]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=e.$Vg=e.$Ug=void 0;function L(c){return JSON.stringify(c,b)}e.$Ug=L;function N(c){let w=JSON.parse(c);return w=u(w),w}e.$Vg=N;function b(c,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:(0,A.$yd)(w)}:w}function u(c,w=0){if(!c||w>200)return c;if(typeof c=="object"){switch(c.$mid){case 1:return D.URI.revive(c);case 2:return new RegExp(c.source,c.flags);case 16:return new Date(c.source)}if(c instanceof M.$Jb||c instanceof Uint8Array)return c;if(Array.isArray(c))for(let R=0;R<c.length;++R)c[R]=u(c[R],w+1);else for(const R in c)Object.hasOwnProperty.call(c,R)&&(c[R]=u(c[R],w+1))}return c}e.$Wg=u}),define(ne[82],re([0,1,70,15,12,11]),function(J,e,M,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=void 0;class N{constructor(m,h,O){this.id=m,this.dependencies=h,this.callback=O}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,h,O)=>{typeof m!="string"&&(O=h,h=m,m=null),(typeof h!="object"||!Array.isArray(h))&&(O=h,h=null),this.c.push(new N(m,h,O))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const h=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!h)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(m){return new Promise((h,O)=>{const y=document.createElement("script");y.setAttribute("async","async"),y.setAttribute("type","text/javascript");const g=()=>{y.removeEventListener("load",d),y.removeEventListener("error",f)},d=I=>{g(),h(this.c.pop())},f=I=>{g(),O(I)};y.addEventListener("load",d),y.addEventListener("error",f),this.f&&(m=this.f.createScriptURL(m)),y.setAttribute("src",m),document.getElementsByTagName("head")[0].appendChild(y)})}i(m){return new Promise((h,O)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),h(this.c.pop())}catch(y){O(y)}})}async j(m){try{const h=globalThis._VSCODE_NODE_MODULES.fs,O=globalThis._VSCODE_NODE_MODULES.vm,y=globalThis._VSCODE_NODE_MODULES.module,g=L.URI.parse(m).fsPath,d=h.readFileSync(g).toString(),f=y.wrap(d.replace(/^#!.*/,""));return new O.Script(f).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const u=new Map;let c={};typeof globalThis.require=="object"&&(c=globalThis.require.paths??{});async function w(R,m,h){if(M.$R){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),c[R]&&(R=c[R]);const O=`${R}/${m}`;if(u.has(O))return u.get(O);let y;if(/^\w[\w\d+.-]*:\/\//.test(O))y=O;else{const I=`${h&&!D.$o?A.$1e:A.$Ze}/${O}`;y=A.$3e.asBrowserUri(I).toString(!0)}const g=b.INSTANCE.load(y);return u.set(O,g),g}else return await new Promise((O,y)=>{J([R],O,y)})}e.$UC=w}),define(ne[83],re([0,1,32,16,24]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cl=e.$bl=void 0;const L=/^\d+$/,N=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var u;(function($){$[$.x64=0]="x64",$[$.x86=1]="x86",$[$.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":case"x32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let w;process.env.PROCESSOR_ARCHITEW6432?w=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?w=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?w=1:w=0;class R{constructor(v,t,a){this.exePath=v,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await D.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:$=!1}={}){return $?c===0?process.env["ProgramFiles(x86)"]||null:w===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function h({useAlternateBitness:$=!1,findPreview:v=!1}={}){const t=m({useAlternateBitness:$});if(!t)return null;const a=A.$ac(t,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(a))return null;let i=-1,s=null;for(const l of await D.Promises.readdir(a)){let P=-1;if(v){const S=l.indexOf("-");if(S<0)continue;const j=l.substring(0,S);if(!L.test(j)||l.substring(S+1)!=="preview")continue;P=parseInt(j,10)}else{if(!L.test(l))continue;P=parseInt(l,10)}if(P<=i)continue;const E=A.$ac(a,l,"pwsh.exe");await D.SymlinkSupport.existsFile(E)&&(s=E,i=P)}if(!s)return null;const n=t.includes("x86")?" (x86)":"",o=v?" Preview":"";return new R(s,`PowerShell${o}${n}`,!0)}async function O({findPreview:$}={}){if(!process.env.LOCALAPPDATA)return null;const v=A.$ac(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(v))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=$?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await D.Promises.readdir(v))if(t.test(i)){const s=A.$ac(v,i,"pwsh.exe");return new R(s,a)}return null}function y(){const $=A.$ac(M.homedir(),".dotnet","tools","pwsh.exe");return new R($,".NET Core PowerShell Global Tool")}function g(){const $=A.$ac(process.env.windir,c===1&&w!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new R($,"Windows PowerShell",!0)}async function*d(){let $=await h();$&&(yield $),$=await h({useAlternateBitness:!0}),$&&(yield $),$=await O(),$&&(yield $),$=y(),$&&(yield $),$=await h({findPreview:!0}),$&&(yield $),$=await O({findPreview:!0}),$&&(yield $),$=await h({useAlternateBitness:!0,findPreview:!0}),$&&(yield $),$=g(),$&&(yield $)}async function*f(){for await(const $ of d())await $.exists()&&(yield $)}e.$bl=f;async function I(){for await(const $ of f())return $;return null}e.$cl=I}),define(ne[56],re([0,1,16,12,34,55,3,24]),function(J,e,M,A,D,L,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function u(R=D.env){return R.comspec||"cmd.exe"}e.$fl=u;function c(R){let m=[],h=!1;const O=function(y){if(h){m.push(y);return}(!R.send(y,d=>{if(d&&console.error(d),h=!1,m.length>0){const f=m.slice(0);m=[],f.forEach(I=>O(I))}})||A.$i)&&(h=!0)};return{send:O}}e.$gl=c;var w;(function(R){async function m(h,O,y){if(M.$_b(h))return h;if(O===void 0&&(O=D.cwd()),M.$dc(h)!=="."||(y===void 0&&N.$ie(D.env.PATH)&&(y=D.env.PATH.split(M.$kc)),y===void 0||y.length===0))return M.$ac(O,h);async function d(f){if(await b.Promises.exists(f)){let I;try{I=await b.Promises.stat(f)}catch($){$.message.startsWith("EACCES")&&(I=await b.Promises.lstat(f))}return I?!I.isDirectory():!1}return!1}for(const f of y){let I;if(M.$_b(f)?I=M.$ac(f,h):I=M.$ac(O,f,h),await d(I))return I;let $=I+".com";if(await d($)||($=I+".exe",await d($)))return $}return M.$ac(O,h)}R.findExecutable=m})(w||(e.win32=w={}))}),define(ne[84],re([0,1,32,12,83,56]),function(J,e,M,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hl=void 0;async function N(R,m){return R===1?A.$i?w():L.$fl(m):u(R,m)}e.$hl=N;let b=null;function u(R,m){if(A.$k&&R===2||A.$j&&R===3)return"/bin/bash";if(!b){let h;if(A.$i)h="/bin/bash";else{if(h=m.SHELL,!h)try{h=(0,M.userInfo)().shell}catch{}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}b=h}return b}let c=null;async function w(){return c||(c=(await(0,D.$cl)()).exePath),c}});var pe=this&&this.__decorate||function(J,e,M,A){var D=arguments.length,L=D<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,M):A,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(J,e,M,A);else for(var b=J.length-1;b>=0;b--)(N=J[b])&&(L=(D<3?N(L):D>3?N(e,M,L):N(e,M))||L);return D>3&&L&&Object.defineProperty(e,M,L),L};define(ne[57],re([0,1,19,8,14,20,52,9,4,2,47,28,3]),function(J,e,M,A,D,L,N,b,u,c,w,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.ProxyChannel=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.RequestInitiator=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=void 0;var h;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(h||(h={}));function O(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(y||(y={}));function g(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(d||(d={}));function f(T){let U=0;for(let V=0;;V+=7){const G=T.read(1);if(U|=(G.buffer[0]&127)<<V,!(G.buffer[0]&128))return U}}const I=i(0);function $(T,U){if(U===0){T.write(I);return}let V=0;for(let X=U;X!==0;X=X>>>7)V++;const G=D.$Jb.alloc(V);for(let X=0;U!==0;X++)G.buffer[X]=U&127,U=U>>>7,U>0&&(G.buffer[X]|=128);T.write(G)}class v{constructor(U){this.b=U,this.a=0}read(U){const V=this.b.slice(this.a,this.a+U);return this.a+=V.byteLength,V}}e.$Xg=v;class t{constructor(){this.a=[]}get buffer(){return D.$Jb.concat(this.a)}write(U){this.a.push(U)}}e.$Yg=t;var a;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object",T[T.Int=6]="Int"})(a||(a={}));function i(T){const U=D.$Jb.alloc(1);return U.writeUInt8(T,0),U}const s={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},n=typeof Buffer<"u";function o(T,U){if(typeof U>"u")T.write(s.Undefined);else if(typeof U=="string"){const V=D.$Jb.fromString(U);T.write(s.String),$(T,V.byteLength),T.write(V)}else if(n&&Buffer.isBuffer(U)){const V=D.$Jb.wrap(U);T.write(s.Buffer),$(T,V.byteLength),T.write(V)}else if(U instanceof D.$Jb)T.write(s.VSBuffer),$(T,U.byteLength),T.write(U);else if(Array.isArray(U)){T.write(s.Array),$(T,U.length);for(const V of U)o(T,V)}else if(typeof U=="number"&&(U|0)===U)T.write(s.Uint),$(T,U);else{const V=D.$Jb.fromString(JSON.stringify(U));T.write(s.Object),$(T,V.byteLength),T.write(V)}}e.$Zg=o;function l(T){switch(T.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return T.read(f(T)).toString();case a.Buffer:return T.read(f(T)).buffer;case a.VSBuffer:return T.read(f(T));case a.Array:{const V=f(T),G=[];for(let X=0;X<V;X++)G.push(l(T));return G}case a.Object:return JSON.parse(T.read(f(T)).toString());case a.Int:return f(T)}}e.$1g=l;class P{constructor(U,V,G=null,X=1e3){this.h=U,this.j=V,this.k=G,this.l=X,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(U,V){this.b.set(U,V),setTimeout(()=>this.w(U),0)}m(U){switch(U.type){case 200:{const V=this.o([U.type]);this.k?.logOutgoing(V,0,1,g(U.type));return}case 201:case 202:case 204:case 203:{const V=this.o([U.type,U.id],U.data);this.k?.logOutgoing(V,U.id,1,g(U.type),U.data);return}}}o(U,V=void 0){const G=new t;return o(G,U),o(G,V),this.p(G.buffer)}p(U){try{return this.h.send(U),U.byteLength}catch{return 0}}q(U){const V=new v(U),G=l(V),X=l(V),K=G[0];switch(K){case 100:return this.k?.logIncoming(U.byteLength,G[1],1,`${O(K)}: ${G[2]}.${G[3]}`,X),this.s({type:K,id:G[1],channelName:G[2],name:G[3],arg:X});case 102:return this.k?.logIncoming(U.byteLength,G[1],1,`${O(K)}: ${G[2]}.${G[3]}`,X),this.t({type:K,id:G[1],channelName:G[2],name:G[3],arg:X});case 101:return this.k?.logIncoming(U.byteLength,G[1],1,`${O(K)}`),this.u({type:K,id:G[1]});case 103:return this.k?.logIncoming(U.byteLength,G[1],1,`${O(K)}`),this.u({type:K,id:G[1]})}}s(U){const V=this.b.get(U.channelName);if(!V){this.v(U);return}const G=new L.$dd;let X;try{X=V.call(this.j,U.name,U.arg,G.token)}catch(k){X=Promise.reject(k)}const K=U.id;X.then(k=>{this.m({id:K,data:k,type:201}),this.d.delete(U.id)},k=>{k instanceof Error?this.m({id:K,data:{message:k.message,name:k.name,stack:k.stack?k.stack.split?k.stack.split(`
`):k.stack:void 0},type:202}):this.m({id:K,data:k,type:203}),this.d.delete(U.id)});const oe=(0,c.$jb)(()=>G.cancel());this.d.set(U.id,oe)}t(U){const V=this.b.get(U.channelName);if(!V){this.v(U);return}const G=U.id,K=V.listen(this.j,U.name,U.arg)(oe=>this.m({id:G,data:oe,type:204}));this.d.set(U.id,K)}u(U){const V=this.d.get(U.id);V&&(V.dispose(),this.d.delete(U.id))}v(U){let V=this.g.get(U.channelName);V||(V=[],this.g.set(U.channelName,V));const G=setTimeout(()=>{console.error(`Unknown channel: ${U.channelName}`),U.type===100&&this.m({id:U.id,data:{name:"Unknown channel",message:`Channel name '${U.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:U,timeoutTimer:G})}w(U){const V=this.g.get(U);if(V){for(const G of V)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.s(G.request);break;case 102:this.t(G.request);break}this.g.delete(U)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$gb)(this.d.values()),this.d.clear()}}e.$2g=P;var E;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(E||(e.RequestInitiator=E={}));class S{constructor(U,V=null){this.l=U,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$7c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(G=>this.s(G)),this.j=V}getChannel(U){const V=this;return{call(G,X,K){return V.a?Promise.reject(new b.$3):V.m(U,G,X,K)},listen(G,X){return V.a?u.Event.None:V.o(U,G,X)}}}m(U,V,G,X=L.CancellationToken.None){const K=this.g++,k={id:K,type:100,channelName:U,name:V,arg:G};if(X.isCancellationRequested)return Promise.reject(new b.$3);let r;return new Promise((z,C)=>{if(X.isCancellationRequested)return C(new b.$3);const H=()=>{const fe=ue=>{switch(ue.type){case 201:this.f.delete(K),z(ue.data);break;case 202:{this.f.delete(K);const me=new Error(ue.data.message);me.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,me.name=ue.data.name,C(me);break}case 203:this.f.delete(K),C(ue.data);break}};this.f.set(K,fe),this.p(k)};let Y=null;this.b===d.Idle?H():(Y=(0,A.$hg)(fe=>this.u()),Y.then(()=>{Y=null,H()}));const ie=()=>{Y?(Y.cancel(),Y=null):this.p({id:K,type:101}),C(new b.$3)},de=X.onCancellationRequested(ie);r=(0,c.$ib)((0,c.$jb)(ie),de),this.d.add(r)}).finally(()=>{this.d.delete(r)})}o(U,V,G){const X=this.g++,oe={id:X,type:102,channelName:U,name:V,arg:G};let k=null;const r=new u.$7c({onWillAddFirstListener:()=>{k=(0,A.$hg)(z=>this.u()),k.then(()=>{k=null,this.d.add(r),this.p(oe)})},onDidRemoveLastListener:()=>{k?(k.cancel(),k=null):(this.d.delete(r),this.p({id:X,type:103}))}}),p=z=>r.fire(z.data);return this.f.set(X,p),r.event}p(U){switch(U.type){case 100:case 102:{const V=this.q([U.type,U.id,U.channelName,U.name],U.arg);this.j?.logOutgoing(V,U.id,0,`${O(U.type)}: ${U.channelName}.${U.name}`,U.arg);return}case 101:case 103:{const V=this.q([U.type,U.id]);this.j?.logOutgoing(V,U.id,0,O(U.type));return}}}q(U,V=void 0){const G=new t;return o(G,U),o(G,V),this.r(G.buffer)}r(U){try{return this.l.send(U),U.byteLength}catch{return 0}}s(U){const V=new v(U),G=l(V),X=l(V),K=G[0];switch(K){case 200:return this.j?.logIncoming(U.byteLength,0,0,g(K)),this.t({type:G[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(U.byteLength,G[1],0,g(K),X),this.t({type:G[0],id:G[1],data:X})}}t(U){if(U.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(U.id)?.(U)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$gb)(this.d.values()),this.d.clear()}}e.$3g=S,pe([N.$Rg],S.prototype,"onDidInitializePromise",null);class j{get connections(){const U=[];return this.f.forEach(V=>U.push(V)),U}constructor(U){this.a=new Map,this.f=new Set,this.g=new u.$7c,this.onDidAddConnection=this.g.event,this.h=new u.$7c,this.onDidRemoveConnection=this.h.event,U(({protocol:V,onDidClientDisconnect:G})=>{u.Event.once(V.onMessage)(K=>{const oe=new v(K),k=l(oe),r=new P(V,k),p=new S(V);this.a.forEach((C,H)=>r.registerChannel(H,C));const z={channelServer:r,channelClient:p,ctx:k};this.f.add(z),this.g.fire(z),G(()=>{r.dispose(),p.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(U,V){const G=this;return{call(X,K,oe){let k;if((0,m.$we)(V)){const p=(0,M.$Jf)(G.connections.filter(V));k=p?Promise.resolve(p):u.Event.toPromise(u.Event.filter(G.onDidAddConnection,V))}else k=V.routeCall(G,X,K);const r=k.then(p=>p.channelClient.getChannel(U));return ee(r).call(X,K,oe)},listen(X,K){if((0,m.$we)(V))return G.j(U,V,X,K);const oe=V.routeEvent(G,X,K).then(k=>k.channelClient.getChannel(U));return ee(oe).listen(X,K)}}}j(U,V,G,X){const K=this;let oe=new c.$kb;const k=new u.$7c({onWillAddFirstListener:()=>{oe=new c.$kb;const r=new u.$ad,p=new Map,z=H=>{const ie=H.channelClient.getChannel(U).listen(G,X),de=r.add(ie);p.set(H,de)},C=H=>{const Y=p.get(H);Y&&(Y.dispose(),p.delete(H))};K.connections.filter(V).forEach(z),u.Event.filter(K.onDidAddConnection,V)(z,void 0,oe),K.onDidRemoveConnection(C,void 0,oe),r.event(k.fire,k,oe),oe.add(r)},onDidRemoveLastListener:()=>{oe.dispose()}});return k.event}registerChannel(U,V){this.a.set(U,V),this.f.forEach(G=>{G.channelServer.registerChannel(U,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$4g=j;class B{constructor(U,V,G=null){const X=new t;o(X,V),U.send(X.buffer),this.a=new S(U,G),this.d=new P(U,V,G)}getChannel(U){return this.a.getChannel(U)}registerChannel(U,V){this.d.registerChannel(U,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$5g=B;function ee(T){return{call(U,V,G){return T.then(X=>X.call(U,V,G))},listen(U,V){const G=new u.$cd;return T.then(X=>G.input=X.listen(U,V)),G.event}}}e.$6g=ee;function Z(T){let U=!1;return{call(V,G,X){return U?T.call(V,G,X):(0,A.$ug)(0).then(()=>U=!0).then(()=>T.call(V,G,X))},listen(V,G){if(U)return T.listen(V,G);const X=new u.$cd;return(0,A.$ug)(0).then(()=>U=!0).then(()=>X.input=T.listen(V,G)),X.event}}}e.$7g=Z;class le{constructor(U){this.a=U}routeCall(U){return this.b(U)}routeEvent(U){return this.b(U)}async b(U){for(const V of U.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await u.Event.toPromise(U.onDidAddConnection),await this.b(U)}}e.$8g=le;var _;(function(T){function U(K,oe){const k=K,r=oe&&oe.disableMarshalling,p=new Map;for(const z in k)G(z)&&p.set(z,u.Event.buffer(k[z],!0));return new class{listen(z,C,H){const Y=p.get(C);if(Y)return Y;if(X(C)){const ie=k[C];if(typeof ie=="function")return ie.call(k,H)}throw new b.$ab(`Event not found: ${C}`)}call(z,C,H){const Y=k[C];if(typeof Y=="function"){if(!r&&Array.isArray(H))for(let ie=0;ie<H.length;ie++)H[ie]=(0,w.$Wg)(H[ie]);return Y.apply(k,H)}throw new b.$ab(`Method not found: ${C}`)}}}T.fromService=U;function V(K,oe){const k=oe&&oe.disableMarshalling;return new Proxy({},{get(r,p){if(typeof p=="string")return oe?.properties?.has(p)?oe.properties.get(p):X(p)?function(z){return K.listen(p,z)}:G(p)?K.listen(p):async function(...z){let C;oe&&!(0,m.$re)(oe.context)?C=[oe.context,...z]:C=z;const H=await K.call(p,C);return k?H:(0,w.$Wg)(H)};throw new b.$ab(`Property not found: ${String(p)}`)}})}T.toService=V;function G(K){return K[0]==="o"&&K[1]==="n"&&R.$Kd(K.charCodeAt(2))}function X(K){return/^onDynamic/.test(K)&&R.$Kd(K.charCodeAt(9))}})(_||(e.ProxyChannel=_={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){const U=T.toString();if(U!=="[object Object]")return U}return T}function te(T){return Array.isArray(T)?T.map(ce):ce(T)}function F(T,U,V,G,X,K,oe){oe=te(oe);const k=ae[X],r=k[G%k.length];let p=[`%c[${T}]%c[${String(U).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${r}`];/\($/.test(K)?(p=p.concat(oe),p.push(")")):p.push(oe),console.log.apply(console,p)}class W{constructor(U,V){this.d=U,this.f=V,this.a=0,this.b=0}logOutgoing(U,V,G,X,K){this.b+=U,F(this.d,this.b,U,V,G,X,K)}logIncoming(U,V,G,X,K){this.a+=U,F(this.f,this.a,U,V,G,X,K)}}e.$9g=W}),define(ne[85],re([0,1,58,8,14,20,81,9,4,2,30,56,55,57]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=void 0;class O extends h.$2g{constructor(d){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>D.$Jb.wrap(Buffer.from(f,"base64")))},d),process.once("disconnect",()=>this.dispose())}}e.$Ep=O;class y{constructor(d,f){this.i=d,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$7c,this.onDidProcessExit=this.h.event;const I=f&&f.timeout?f.timeout:6e4;this.b=new A.$qg(I),this.d=null,this.f=null}getChannel(d){const f=this;return{call(I,$,v){return f.k(d,I,$,v)},listen(I,$){return f.l(d,I,$)}}}k(d,f,I,$=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if($.isCancellationRequested)return Promise.reject(b.$4());this.b.cancel();const v=this.n(d),t=(0,A.$hg)(s=>v.call(f,I,s)),a=$.onCancellationRequested(()=>t.cancel()),i=(0,c.$jb)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(d,f,I){if(!this.b)return u.Event.None;this.b.cancel();let $;const v=new u.$7c({onWillAddFirstListener:()=>{$=this.n(d).listen(f,I)(v.fire,v),this.c.add($)},onDidRemoveLastListener:()=>{this.c.delete($),$.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return v.event}get m(){if(!this.f){const d=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,w.$Fm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,m.$el)(f.env),this.d=(0,M.fork)(this.i,d,f);const I=new u.$7c;u.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,N.$Ap)(n)){(0,N.log)(n,`IPC Library: ${this.j.serverName}`);return}I.fire(D.$Jb.wrap(Buffer.from(n,"base64")))});const v=this.j.useQueue?(0,R.$gl)(this.d):this.d,t=n=>this.d&&this.d.connected&&v.send(n.buffer.toString("base64")),a=I.event,i={send:t,onMessage:a};this.f=new h.$3g(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,o)=>{process.removeListener("exit",s),this.c.forEach(l=>(0,c.$gb)(l)),this.c.clear(),n!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:o})})}return this.f}n(d){let f=this.g.get(d);return f||(f=this.m.getChannel(d),this.g.set(d,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Fp=y}),define(ne[86],re([0,1,8,4,2,47,3]),function(J,e,M,A,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.StorageState=e.$Do=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function u(m){const h=m;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Do=u;var c;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(c||(e.StorageState=c={}));class w extends D.$lb{static{this.a=100}constructor(h,O=Object.create(null)){super(),this.m=h,this.n=O,this.b=this.B(new A.$0c),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=new M.$rg(w.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){this.b.pause();try{h.changed?.forEach((O,y)=>this.s(y,O)),h.deleted?.forEach(O=>this.s(O,void 0))}finally{this.b.resume()}}s(h,O){if(this.c===c.Closed)return;let y=!1;(0,N.$re)(O)?y=this.f.delete(h):this.f.get(h)!==O&&(this.f.set(h,O),y=!0),y&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.n.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,O){const y=this.f.get(h);return(0,N.$re)(y)?O:y}getBoolean(h,O){const y=this.get(h);return(0,N.$re)(y)?O:y==="true"}getNumber(h,O){const y=this.get(h);return(0,N.$re)(y)?O:parseInt(y,10)}getObject(h,O){const y=this.get(h);return(0,N.$re)(y)?O:(0,L.$Vg)(y)}async set(h,O,y=!1){if(this.c===c.Closed)return;if((0,N.$re)(O))return this.delete(h,y);const g=(0,N.$ke)(O)||Array.isArray(O)?(0,L.$Ug)(O):String(O);if(this.f.get(h)!==g)return this.f.set(h,g),this.j.set(h,g),this.h.delete(h),this.b.fire({key:h,external:y}),this.w()}async delete(h,O=!1){if(!(this.c===c.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:O}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=c.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===b.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Eo=w;class R{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach((O,y)=>this.a.set(y,O)),h.delete?.forEach(O=>this.a.delete(O))}async close(){}}e.$Fo=R}),define(ne[87],re([7,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ne[88],re([7,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[89],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ne[90],re([7,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ne[91],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[92],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[93],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ne[94],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ne[95],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[96],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[97],re([7,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[98],re([7,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[99],re([7,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ne[100],re([7,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ne[101],re([7,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[102],re([7,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[103],re([7,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ne[104],re([7,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ne[105],re([7,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[106],re([7,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[107],re([7,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ne[108],re([0,1,9,90]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.TokenType=void 0;var D;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(D||(e.TokenType=D={}));function L(...c){switch(c.length){case 1:return(0,A.localize)(0,null,c[0]);case 2:return(0,A.localize)(1,null,c[0],c[1]);case 3:return(0,A.localize)(2,null,c[0],c[1],c[2]);default:return}}const N=(0,A.localize)(3,null),b=(0,A.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(w){switch(w.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return w.isTripleEq?"===":"==";case 4:return w.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return w.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return w.lexeme;case 18:return w.lexeme;case 19:return w.lexeme;case 20:return"EOF";default:throw(0,M.$6)(`unhandled token type: ${JSON.stringify(w)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(w){return this.c=w,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const R=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:R})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const R=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:R})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(w){return this.r()||this.c.charCodeAt(this.e)!==w?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(w){this.f.push({type:w,offset:this.d})}l(w){const R=this.d,m=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:m};this.g.push({offset:R,lexeme:m,additionalInfo:w}),this.f.push(h)}n(){this.m.lastIndex=this.d;const w=this.m.exec(this.c);if(w){this.e=this.d+w[0].length;const R=this.c.substring(this.d,this.e),m=u.b.get(R);m?this.k(m):this.f.push({type:17,lexeme:R,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let w=this.e,R=!1,m=!1;for(;;){if(w>=this.c.length){this.e=w,this.l(b);return}const O=this.c.charCodeAt(w);if(R)R=!1;else if(O===47&&!m){w++;break}else O===91?m=!0:O===92?R=!0:O===93&&(m=!1);w++}for(;w<this.c.length&&u.a.has(this.c.charCodeAt(w));)w++;this.e=w;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$qi=u}),define(ne[109],re([0,1,77,52,15,16,34,17,11]),function(J,e,M,A,D,L,N,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0,e.$Rl=/^([^.]+\..+):(.+)$/;class c{get appRoot(){return(0,L.$dc)(D.$3e.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,L.$ac)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,b.$8f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,b.$8f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,M.$Ql)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$ac)(this.userDataPath,"logs",h)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.$8f)(u.URI.file((0,L.$ac)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.$8f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.$8f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.$8f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=N.env.VSCODE_PORTABLE;return h?u.URI.file((0,L.$ac)(h,"argv.json")):(0,b.$8f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,L.$ac)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,L.$bc)(h):(0,L.$$b)((0,L.$ac)(D.$3e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?u.URI.file((0,L.$bc)(h)):u.URI.file((0,L.$ac)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,L.$bc)(h);const O=N.env.VSCODE_EXTENSIONS;if(O)return O;const y=N.env.VSCODE_PORTABLE;return y?(0,L.$ac)(y,"extensions"):(0,b.$8f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(O=>/^[^:/?#]+?:\/\//.test(O)?u.URI.parse(O):u.URI.file((0,L.$$b)(O)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?u.URI.parse(h):u.URI.file((0,L.$$b)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return w(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Rl.test(h))}get extensionLogLevel(){const h=[];for(const O of this.args.log||[]){const y=e.$Rl.exec(O);y&&y[1]&&y[2]&&h.push([y[1],y[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,b.$8f)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=N.env.VSCODE_PORTABLE;return h?u.URI.file((0,L.$ac)(h,"policy.json")):(0,b.$8f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,O,y){this.a=h,this.b=O,this.c=y,this.editSessionId=this.args.editSessionId}}e.$Sl=c,pe([A.$Rg],c.prototype,"appRoot",null),pe([A.$Rg],c.prototype,"userHome",null),pe([A.$Rg],c.prototype,"userDataPath",null),pe([A.$Rg],c.prototype,"appSettingsHome",null),pe([A.$Rg],c.prototype,"tmpDir",null),pe([A.$Rg],c.prototype,"cacheHome",null),pe([A.$Rg],c.prototype,"stateResource",null),pe([A.$Rg],c.prototype,"userRoamingDataHome",null),pe([A.$Rg],c.prototype,"userDataSyncHome",null),pe([A.$Rg],c.prototype,"sync",null),pe([A.$Rg],c.prototype,"machineSettingsResource",null),pe([A.$Rg],c.prototype,"workspaceStorageHome",null),pe([A.$Rg],c.prototype,"localHistoryHome",null),pe([A.$Rg],c.prototype,"keyboardLayoutResource",null),pe([A.$Rg],c.prototype,"argvResource",null),pe([A.$Rg],c.prototype,"isExtensionDevelopment",null),pe([A.$Rg],c.prototype,"untitledWorkspacesHome",null),pe([A.$Rg],c.prototype,"builtinExtensionsPath",null),pe([A.$Rg],c.prototype,"extensionsPath",null),pe([A.$Rg],c.prototype,"extensionDevelopmentLocationURI",null),pe([A.$Rg],c.prototype,"extensionDevelopmentKind",null),pe([A.$Rg],c.prototype,"extensionTestsLocationURI",null),pe([A.$Rg],c.prototype,"debugExtensionHost",null),pe([A.$Rg],c.prototype,"logLevel",null),pe([A.$Rg],c.prototype,"extensionLogLevel",null),pe([A.$Rg],c.prototype,"serviceMachineIdResource",null),pe([A.$Rg],c.prototype,"disableTelemetry",null),pe([A.$Rg],c.prototype,"disableWorkspaceTrust",null),pe([A.$Rg],c.prototype,"policyFile",null);function w(m,h){return R(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}e.$Tl=w;function R(m,h,O,y,g,d){const I=Number(h||m)||(y?null:O),$=I?!!h:!1;let v;if(d)try{v=JSON.parse(d)}catch{}return{port:I,break:$,debugId:g,env:v}}e.$Ul=R}),function(){"use strict";function J(e,M,A){function D(N,b){const u=L(N,b),c=[u];return e.isAbsolute(u)||c.unshift(A),e.resolve(...c)}function L(N,b){process.env.VSCODE_DEV&&(b="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,b);const w=N["user-data-dir"];if(w)return w;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const R=process.env.USERPROFILE;if(typeof R!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(R,"AppData","Roaming")}break;case"darwin":c=e.join(M.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(M.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,b)}return{getUserDataPath:D}}if(typeof define=="function")define(ne[110],re([165,32,34]),function(e,M,A){return J(e,M,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),M=require("os");module.exports=J(e,M,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[111],re([0,1,32,109,110]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=void 0;class L extends A.$Sl{constructor(c,w){super(c,{homeDir:(0,M.homedir)(),tmpDir:(0,M.tmpdir)(),userDataDir:(0,D.getUserDataPath)(c,w.nameShort)},w)}}e.$Vl=L;function N(u,c){return(0,A.$Ul)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}e.$Wl=N;function b(u,c){return(0,A.$Ul)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}e.$Xl=b}),define(ne[112],re([0,1,3,94]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;function D(N,b,u){try{L(N,b,u)}catch(c){console.error(c?.message??c)}return N}e.$ap=D;function L(N,b,u){const c=(w,R,m)=>{const h=w[R];if((0,M.$ie)(h)){const O=h,y=O.length;if(y>1&&O[0]==="%"&&O[y-1]==="%"){const g=O.substr(1,y-2);let d=b[g];d===void 0&&u&&(d=u[g]);const f=typeof d=="string"?d:d?.message,I=u?.[g],$=typeof I=="string"?I:I?.message;if(!f){$||console.warn(`[${N.name}]: ${(0,A.localize)(0,null,g)}`);return}if(m&&(R==="title"||R==="category")&&$&&$!==f){const v={value:f,original:$};w[R]=v}else w[R]=f}}else if((0,M.$ke)(h))for(const O in h)h.hasOwnProperty(O)&&(O==="commands"?c(h,O,!0):c(h,O,m));else if(Array.isArray(h))for(let O=0;O<h.length;O++)c(h,O,m)};for(const w in N)N.hasOwnProperty(w)&&c(N,w)}}),define(ne[48],re([0,1,17,54,98,43]),function(J,e,M,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function u(d){return d=d.trim(),d==="*"||N.test(d)}e.$po=u;function c(d){if(!u(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=d.match(N);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$qo=c;function w(d){if(!d)return null;const f=d.majorBase,I=d.majorMustEqual,$=d.minorBase;let v=d.minorMustEqual;const t=d.patchBase;let a=d.patchMustEqual;d.hasCaret&&(f===0||(v=!1),a=!1);let i=0;if(d.preRelease){const s=b.exec(d.preRelease);if(s){const[,n,o,l]=s;i=Date.UTC(Number(n),Number(o)-1,Number(l))}}return{majorBase:f,majorMustEqual:I,minorBase:$,minorMustEqual:v,patchBase:t,patchMustEqual:a,isMinimum:d.hasGreaterEquals,notBefore:i}}e.$ro=w;function R(d,f,I){let $;typeof d=="string"?$=w(c(d)):$=d;let v;f instanceof Date?v=f.getTime():typeof f=="string"&&(v=new Date(f).getTime());let t;if(typeof I=="string"?t=w(c(I)):t=I,!$||!t)return!1;const a=$.majorBase,i=$.minorBase,s=$.patchBase;let n=t.majorBase,o=t.minorBase,l=t.patchBase;const P=t.notBefore;let E=t.majorMustEqual,S=t.minorMustEqual,j=t.patchMustEqual;return t.isMinimum?a>n?!0:a<n?!1:i>o?!0:i<o||v&&v<P?!1:s>=l:(a===1&&n===0&&(!E||!S||!j)&&(n=1,o=0,l=0,E=!0,S=!1,j=!1),a<n?!1:a>n?!E:i<o?!1:i>o?!S:s<l?!1:s>l?!j:!(v&&v<P))}e.$so=R;function m(d,f,I,$,v){const t=[];if(typeof $.publisher<"u"&&typeof $.publisher!="string")return t.push([A.default.Error,D.localize(0,null)]),t;if(typeof $.name!="string")return t.push([A.default.Error,D.localize(1,null,"name")]),t;if(typeof $.version!="string")return t.push([A.default.Error,D.localize(2,null,"version")]),t;if(!$.engines)return t.push([A.default.Error,D.localize(3,null,"engines")]),t;if(typeof $.engines.vscode!="string")return t.push([A.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof $.extensionDependencies<"u"&&!g($.extensionDependencies))return t.push([A.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof $.activationEvents<"u"){if(!g($.activationEvents))return t.push([A.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof $.main>"u"&&typeof $.browser>"u")return t.push([A.default.Error,D.localize(7,null,"activationEvents","main","browser")]),t}if(typeof $.extensionKind<"u"&&typeof $.main>"u"&&t.push([A.default.Warning,D.localize(8,null,"extensionKind")]),typeof $.main<"u"){if(typeof $.main!="string")return t.push([A.default.Error,D.localize(9,null,"main")]),t;{const s=(0,M.$8f)(I,$.main);(0,M.$2f)(s,I)||t.push([A.default.Warning,D.localize(10,null,s.path,I.path)])}}if(typeof $.browser<"u"){if(typeof $.browser!="string")return t.push([A.default.Error,D.localize(11,null,"browser")]),t;{const s=(0,M.$8f)(I,$.browser);(0,M.$2f)(s,I)||t.push([A.default.Warning,D.localize(12,null,s.path,I.path)])}}if(!L.valid($.version))return t.push([A.default.Error,D.localize(13,null)]),t;const a=[];if(!h(d,f,$,v,a))for(const s of a)t.push([A.default.Error,s]);return t}e.$to=m;function h(d,f,I,$,v){return $||typeof I.main>"u"&&typeof I.browser>"u"?!0:y(d,f,I.engines.vscode,v)}e.$uo=h;function O(d,f,I){return d==="*"||y(f,I,d)}e.$vo=O;function y(d,f,I,$=[]){const v=w(c(I));if(!v)return $.push(D.localize(14,null,I)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return $.push(D.localize(15,null,I)),!1}else if(!v.majorMustEqual)return $.push(D.localize(16,null,I)),!1;return R(d,f,v)?!0:($.push(D.localize(17,null,d,I)),!1)}function g(d){if(!Array.isArray(d))return!1;for(let f=0,I=d.length;f<I;f++)if(typeof d[f]!="string")return!1;return!0}}),define(ne[113],re([0,1,14,29]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=void 0;async function D(L,N,b){let u=b&&b.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const w=(await N.readFile(L.serviceMachineIdResource)).value.toString();u=(0,A.$4e)(w)?w:null}catch{u=null}if(!u){u=(0,A.$5e)();try{await N.writeFile(L.serviceMachineIdResource,M.$Jb.fromString(u))}catch{}}return b?.store("storage.serviceMachineId",u,-1,1),u}e.$Oo=D}),define(ne[49],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=void 0;class M{constructor(D,L=[],N=!1){this.ctor=D,this.staticArguments=L,this.supportsDelayedInstantiation=N}}e.$kh=M}),define(ne[114],re([0,1,49]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.InstantiationType=void 0;const A=[];var D;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function L(b,u,c){u instanceof M.$kh||(u=new M.$kh(u,[],!!c)),A.push([b,u])}e.$0q=L;function N(){return A}e.$$q=N}),define(ne[115],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;class M{constructor(L,N){this.key=L,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$Qp=M;class A{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const N of this.a.values())N.outgoing.size===0&&L.push(N);return L}insertEdge(L,N){const b=this.lookupOrInsertNode(L),u=this.lookupOrInsertNode(N);b.outgoing.set(u.key,u),u.incoming.set(b.key,b)}removeNode(L){const N=this.b(L);this.a.delete(N);for(const b of this.a.values())b.outgoing.delete(N),b.incoming.delete(N)}lookupOrInsertNode(L){const N=this.b(L);let b=this.a.get(N);return b||(b=new M(N,L),this.a.set(N,b)),b}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[N,b]of this.a)L.push(`${N}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,N]of this.a){const b=new Set([L]),u=this.c(N,b);if(u)return u}}c(L,N){for(const[b,u]of L.outgoing){if(N.has(b))return[...N,b].join(" -> ");N.add(b);const c=this.c(u,N);if(c)return c;N.delete(b)}}}e.$Rp=A}),define(ne[25],re([0,1,3,11,10]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.ConfigurationTarget=e.$Vh=e.$Uh=e.$Th=void 0,e.$Th=(0,D.$nh)("configurationService");function L(d){return d&&typeof d=="object"&&(!d.overrideIdentifier||typeof d.overrideIdentifier=="string")&&(!d.resource||d.resource instanceof A.URI)}e.$Uh=L;function N(d){return d&&typeof d=="object"&&(!d.overrideIdentifiers||Array.isArray(d.overrideIdentifiers))&&!d.overrideIdentifier&&(!d.resource||d.resource instanceof A.URI)}e.$Vh=N;var b;(function(d){d[d.APPLICATION=1]="APPLICATION",d[d.USER=2]="USER",d[d.USER_LOCAL=3]="USER_LOCAL",d[d.USER_REMOTE=4]="USER_REMOTE",d[d.WORKSPACE=5]="WORKSPACE",d[d.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",d[d.DEFAULT=7]="DEFAULT",d[d.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function u(d){switch(d){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Wh=u;function c(d){return d.applicationValue!==void 0||d.userValue!==void 0||d.userLocalValue!==void 0||d.userRemoteValue!==void 0||d.workspaceValue!==void 0||d.workspaceFolderValue!==void 0}e.$Xh=c;function w(d,f){const I=Object.create(null);for(const $ in d)R(I,$,d[$],f);return I}e.$Yh=w;function R(d,f,I,$){const v=f.split("."),t=v.pop();let a=d;for(let i=0;i<v.length;i++){const s=v[i];let n=a[s];switch(typeof n){case"undefined":n=a[s]=Object.create(null);break;case"object":break;default:$(`Ignoring ${f} as ${v.slice(0,i+1).join(".")} is ${JSON.stringify(n)}`);return}a=n}if(typeof a=="object"&&a!==null)try{a[t]=I}catch{$(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(a)}`)}else $(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(a)}`)}e.$Zh=R;function m(d,f){const I=f.split(".");h(d,I)}e.$1h=m;function h(d,f){const I=f.shift();if(f.length===0){delete d[I];return}if(Object.keys(d).indexOf(I)!==-1){const $=d[I];typeof $=="object"&&!Array.isArray($)&&(h($,f),Object.keys($).length===0&&delete d[I])}}function O(d,f,I){function $(a,i){let s=a;for(const n of i){if(typeof s!="object"||s===null)return;s=s[n]}return s}const v=f.split("."),t=$(d,v);return typeof t>"u"?I:t}e.$2h=O;function y(d,f,I){Object.keys(f).forEach($=>{$!=="__proto__"&&($ in d?M.$ke(d[$])&&M.$ke(f[$])?y(d[$],f[$],I):I&&(d[$]=f[$]):d[$]=f[$])})}e.$3h=y;function g(d){return d.replace(/[\[\]]/g,"")}e.$4h=g}),define(ne[116],re([0,1,12,28,108,10,89,9]),function(J,e,M,A,D,L,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ContextKeyExprType=e.$ri=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",M.$j),u.set("isLinux",M.$k),u.set("isWindows",M.$i),u.set("isWeb",M.$o),u.set("isMacNative",M.$j&&!M.$o),u.set("isEdge",M.$G),u.set("isFirefox",M.$E),u.set("isChrome",M.$D),u.set("isSafari",M.$F);function c(k,r){if(u.get(k)!==void 0)throw(0,b.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(k,r)}e.$ri=c;const w=Object.prototype.hasOwnProperty;var R;(function(k){k[k.False=0]="False",k[k.True=1]="True",k[k.Defined=2]="Defined",k[k.Not=3]="Not",k[k.Equals=4]="Equals",k[k.NotEquals=5]="NotEquals",k[k.And=6]="And",k[k.Regex=7]="Regex",k[k.NotRegex=8]="NotRegex",k[k.Or=9]="Or",k[k.In=10]="In",k[k.NotIn=11]="NotIn",k[k.Greater=12]="Greater",k[k.GreaterEquals=13]="GreaterEquals",k[k.Smaller=14]="Smaller",k[k.SmallerEquals=15]="SmallerEquals"})(R||(e.ContextKeyExprType=R={}));const m={regexParsingWithErrorRecovery:!0},h=(0,N.localize)(0,null),O=(0,N.localize)(1,null),y=(0,N.localize)(2,null),g=(0,N.localize)(3,null),d=(0,N.localize)(4,null),f=(0,N.localize)(5,null),I=(0,N.localize)(6,null),$=(0,N.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(r=m){this.k=r,this.d=new D.$qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(r){if(r===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:O});return}this.f=this.d.reset(r).scan(),this.g=0,this.h=[];try{const p=this.l();if(!this.E()){const z=this.D(),C=z.type===17?f:void 0;throw this.h.push({message:d,offset:z.offset,lexeme:D.$qi.getLexeme(z),additionalInfo:C}),v.c}return p}catch(p){if(p!==v.c)throw p;return}}l(){return this.m()}m(){const r=[this.o()];for(;this.y(16);){const p=this.o();r.push(p)}return r.length===1?r[0]:t.or(...r)}o(){const r=[this.s()];for(;this.y(15);){const p=this.s();r.push(p)}return r.length===1?r[0]:t.and(...r)}s(){if(this.y(2)){const r=this.D();switch(r.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const p=this.l();return this.A(1,g),p?.negate()}case 17:return this.z(),B.create(r.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",r)}}return this.t()}t(){const r=this.D();switch(r.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const p=this.l();return this.A(1,g),p}case 17:{const p=r.lexeme;if(this.z(),this.y(9)){const C=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),C.type!==10)throw this.B("REGEX",C);const H=C.lexeme,Y=H.lastIndexOf("/"),ie=Y===H.length-1?void 0:this.w(H.substring(Y+1));let de;try{de=new RegExp(H.substring(1,Y),ie)}catch{throw this.B("REGEX",C)}return ce.create(p,de)}switch(C.type){case 10:case 19:{const H=[C.lexeme];this.z();let Y=this.D(),ie=0;for(let ge=0;ge<C.lexeme.length;ge++)C.lexeme.charCodeAt(ge)===40?ie++:C.lexeme.charCodeAt(ge)===41&&ie--;for(;!this.E()&&Y.type!==15&&Y.type!==16;){switch(Y.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let ge=0;ge<Y.lexeme.length;ge++)Y.lexeme.charCodeAt(ge)===40?ie++:C.lexeme.charCodeAt(ge)===41&&ie--}if(ie<0)break;H.push(D.$qi.getLexeme(Y)),this.z(),Y=this.D()}const de=H.join(""),fe=de.lastIndexOf("/"),ue=fe===de.length-1?void 0:this.w(de.substring(fe+1));let me;try{me=new RegExp(de.substring(1,fe),ue)}catch{throw this.B("REGEX",C)}return t.regex(p,me)}case 18:{const H=C.lexeme;this.z();let Y=null;if(!(0,A.$jd)(H)){const ie=H.indexOf("/"),de=H.lastIndexOf("/");if(ie!==de&&ie>=0){const fe=H.slice(ie+1,de),ue=H[de+1]==="i"?"i":"";try{Y=new RegExp(fe,ue)}catch{throw this.B("REGEX",C)}}}if(Y===null)throw this.B("REGEX",C);return ce.create(p,Y)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const C=this.u();return t.notIn(p,C)}switch(this.D().type){case 3:{this.z();const C=this.u();if(this.x().type===18)return t.equals(p,C);switch(C){case"true":return t.has(p);case"false":return t.not(p);default:return t.equals(p,C)}}case 4:{this.z();const C=this.u();if(this.x().type===18)return t.notEquals(p,C);switch(C){case"true":return t.not(p);case"false":return t.has(p);default:return t.notEquals(p,C)}}case 5:return this.z(),_.create(p,this.u());case 6:return this.z(),ae.create(p,this.u());case 7:return this.z(),Z.create(p,this.u());case 8:return this.z(),le.create(p,this.u());case 13:return this.z(),t.in(p,this.u());default:return t.has(p)}}case 20:throw this.h.push({message:I,offset:r.offset,lexeme:"",additionalInfo:$}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const r=this.D();switch(r.type){case 17:case 18:return this.z(),r.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(r){return r.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(r){return this.C(r)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(r,p){if(this.C(r))return this.z();throw this.B(p,this.D())}B(r,p,z){const C=(0,N.localize)(8,null,r,D.$qi.getLexeme(p)),H=p.offset,Y=D.$qi.getLexeme(p);return this.h.push({message:C,offset:H,lexeme:Y,additionalInfo:z}),v.c}C(r){return this.D().type===r}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$si=v;class t{static false(){return n.INSTANCE}static true(){return o.INSTANCE}static has(r){return l.create(r)}static equals(r,p){return P.create(r,p)}static notEquals(r,p){return j.create(r,p)}static regex(r,p){return ce.create(r,p)}static in(r,p){return E.create(r,p)}static notIn(r,p){return S.create(r,p)}static not(r){return B.create(r)}static and(...r){return W.create(r,null,!0)}static or(...r){return T.create(r,null,!0)}static greater(r,p){return Z.create(r,p)}static greaterEquals(r,p){return le.create(r,p)}static smaller(r,p){return _.create(r,p)}static smallerEquals(r,p){return ae.create(r,p)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(r){return r==null?void 0:this.c.parse(r)}}e.$ti=t;function a(k){const r=new v({regexParsingWithErrorRecovery:!1});return k.map(p=>(r.parse(p),r.lexingErrors.length>0?r.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,N.localize)(9,null,z.additionalInfo):(0,N.localize)(10,null),offset:z.offset,length:z.lexeme.length})):r.parsingErrors.length>0?r.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$ui=a;function i(k,r){const p=k?k.substituteConstants():void 0,z=r?r.substituteConstants():void 0;return!p&&!z?!0:!p||!z?!1:p.equals(z)}e.$vi=i;function s(k,r){return k.cmp(r)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}substituteConstants(){return this}evaluate(r){return!1}serialize(){return"false"}keys(){return[]}map(r){return this}negate(){return o.INSTANCE}}e.$wi=n;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(r){return this.type-r.type}equals(r){return r.type===this.type}substituteConstants(){return this}evaluate(r){return!0}serialize(){return"true"}keys(){return[]}map(r){return this}negate(){return n.INSTANCE}}e.$xi=o;class l{static create(r,p=null){const z=u.get(r);return typeof z=="boolean"?z?o.INSTANCE:n.INSTANCE:new l(r,p)}constructor(r,p){this.key=r,this.c=p,this.type=2}cmp(r){return r.type!==this.type?this.type-r.type:V(this.key,r.key)}equals(r){return r.type===this.type?this.key===r.key:!1}substituteConstants(){const r=u.get(this.key);return typeof r=="boolean"?r?o.INSTANCE:n.INSTANCE:this}evaluate(r){return!!r.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(r){return r.mapDefined(this.key)}negate(){return this.c||(this.c=B.create(this.key,this)),this.c}}e.$yi=l;class P{static create(r,p,z=null){if(typeof p=="boolean")return p?l.create(r,z):B.create(r,z);const C=u.get(r);return typeof C=="boolean"?p===(C?"true":"false")?o.INSTANCE:n.INSTANCE:new P(r,p,z)}constructor(r,p,z){this.c=r,this.d=p,this.f=z,this.type=4}cmp(r){return r.type!==this.type?this.type-r.type:G(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){const r=u.get(this.c);if(typeof r=="boolean"){const p=r?"true":"false";return this.d===p?o.INSTANCE:n.INSTANCE}return this}evaluate(r){return r.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(r){return r.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$zi=P;class E{static create(r,p){return new E(r,p)}constructor(r,p){this.d=r,this.f=p,this.type=10,this.c=null}cmp(r){return r.type!==this.type?this.type-r.type:G(this.d,this.f,r.d,r.f)}equals(r){return r.type===this.type?this.d===r.d&&this.f===r.f:!1}substituteConstants(){return this}evaluate(r){const p=r.getValue(this.f),z=r.getValue(this.d);return Array.isArray(p)?p.includes(z):typeof z=="string"&&typeof p=="object"&&p!==null?w.call(p,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(r){return r.mapIn(this.d,this.f)}negate(){return this.c||(this.c=S.create(this.d,this.f)),this.c}}e.$Ai=E;class S{static create(r,p){return new S(r,p)}constructor(r,p){this.d=r,this.f=p,this.type=11,this.c=E.create(r,p)}cmp(r){return r.type!==this.type?this.type-r.type:this.c.cmp(r.c)}equals(r){return r.type===this.type?this.c.equals(r.c):!1}substituteConstants(){return this}evaluate(r){return!this.c.evaluate(r)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(r){return r.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Bi=S;class j{static create(r,p,z=null){if(typeof p=="boolean")return p?B.create(r,z):l.create(r,z);const C=u.get(r);return typeof C=="boolean"?p===(C?"true":"false")?n.INSTANCE:o.INSTANCE:new j(r,p,z)}constructor(r,p,z){this.c=r,this.d=p,this.f=z,this.type=5}cmp(r){return r.type!==this.type?this.type-r.type:G(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){const r=u.get(this.c);if(typeof r=="boolean"){const p=r?"true":"false";return this.d===p?n.INSTANCE:o.INSTANCE}return this}evaluate(r){return r.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(r){return r.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Ci=j;class B{static create(r,p=null){const z=u.get(r);return typeof z=="boolean"?z?n.INSTANCE:o.INSTANCE:new B(r,p)}constructor(r,p){this.c=r,this.d=p,this.type=3}cmp(r){return r.type!==this.type?this.type-r.type:V(this.c,r.c)}equals(r){return r.type===this.type?this.c===r.c:!1}substituteConstants(){const r=u.get(this.c);return typeof r=="boolean"?r?n.INSTANCE:o.INSTANCE:this}evaluate(r){return!r.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(r){return r.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Di=B;function ee(k,r){if(typeof k=="string"){const p=parseFloat(k);isNaN(p)||(k=p)}return typeof k=="string"||typeof k=="number"?r(k):n.INSTANCE}class Z{static create(r,p,z=null){return ee(p,C=>new Z(r,C,z))}constructor(r,p,z){this.c=r,this.d=p,this.f=z,this.type=12}cmp(r){return r.type!==this.type?this.type-r.type:G(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(r){return r.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Ei=Z;class le{static create(r,p,z=null){return ee(p,C=>new le(r,C,z))}constructor(r,p,z){this.c=r,this.d=p,this.f=z,this.type=13}cmp(r){return r.type!==this.type?this.type-r.type:G(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(r){return r.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$Fi=le;class _{static create(r,p,z=null){return ee(p,C=>new _(r,C,z))}constructor(r,p,z){this.c=r,this.d=p,this.f=z,this.type=14}cmp(r){return r.type!==this.type?this.type-r.type:G(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(r){return r.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$Gi=_;class ae{static create(r,p,z=null){return ee(p,C=>new ae(r,C,z))}constructor(r,p,z){this.c=r,this.d=p,this.f=z,this.type=15}cmp(r){return r.type!==this.type?this.type-r.type:G(this.c,this.d,r.c,r.d)}equals(r){return r.type===this.type?this.c===r.c&&this.d===r.d:!1}substituteConstants(){return this}evaluate(r){return typeof this.d=="string"?!1:parseFloat(r.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(r){return r.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Hi=ae;class ce{static create(r,p){return new ce(r,p)}constructor(r,p){this.d=r,this.f=p,this.type=7,this.c=null}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.d<r.d)return-1;if(this.d>r.d)return 1;const p=this.f?this.f.source:"",z=r.f?r.f.source:"";return p<z?-1:p>z?1:0}equals(r){if(r.type===this.type){const p=this.f?this.f.source:"",z=r.f?r.f.source:"";return this.d===r.d&&p===z}return!1}substituteConstants(){return this}evaluate(r){const p=r.getValue(this.d);return this.f?this.f.test(p):!1}serialize(){const r=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${r}`}keys(){return[this.d]}map(r){return r.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=te.create(this)),this.c}}e.$Ii=ce;class te{static create(r){return new te(r)}constructor(r){this.c=r,this.type=8}cmp(r){return r.type!==this.type?this.type-r.type:this.c.cmp(r.c)}equals(r){return r.type===this.type?this.c.equals(r.c):!1}substituteConstants(){return this}evaluate(r){return!this.c.evaluate(r)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(r){return new te(this.c.map(r))}negate(){return this.c}}e.$Ji=te;function F(k){let r=null;for(let p=0,z=k.length;p<z;p++){const C=k[p].substituteConstants();if(k[p]!==C&&r===null){r=[];for(let H=0;H<p;H++)r[H]=k[H]}r!==null&&(r[p]=C)}return r===null?k:r}class W{static create(r,p,z){return W.d(r,p,z)}constructor(r,p){this.expr=r,this.c=p,this.type=6}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let p=0,z=this.expr.length;p<z;p++){const C=s(this.expr[p],r.expr[p]);if(C!==0)return C}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let p=0,z=this.expr.length;p<z;p++)if(!this.expr[p].equals(r.expr[p]))return!1;return!0}return!1}substituteConstants(){const r=F(this.expr);return r===this.expr?this:W.create(r,this.c,!1)}evaluate(r){for(let p=0,z=this.expr.length;p<z;p++)if(!this.expr[p].evaluate(r))return!1;return!0}static d(r,p,z){const C=[];let H=!1;for(const Y of r)if(Y){if(Y.type===1){H=!0;continue}if(Y.type===0)return n.INSTANCE;if(Y.type===6){C.push(...Y.expr);continue}C.push(Y)}if(C.length===0&&H)return o.INSTANCE;if(C.length!==0){if(C.length===1)return C[0];C.sort(s);for(let Y=1;Y<C.length;Y++)C[Y-1].equals(C[Y])&&(C.splice(Y,1),Y--);if(C.length===1)return C[0];for(;C.length>1;){const Y=C[C.length-1];if(Y.type!==9)break;C.pop();const ie=C.pop(),de=C.length===0,fe=T.create(Y.expr.map(ue=>W.create([ue,ie],null,z)),null,de);fe&&(C.push(fe),C.sort(s))}if(C.length===1)return C[0];if(z){for(let Y=0;Y<C.length;Y++)for(let ie=Y+1;ie<C.length;ie++)if(C[Y].negate().equals(C[ie]))return n.INSTANCE;if(C.length===1)return C[0]}return new W(C,p)}}serialize(){return this.expr.map(r=>r.serialize()).join(" && ")}keys(){const r=[];for(const p of this.expr)r.push(...p.keys());return r}map(r){return new W(this.expr.map(p=>p.map(r)),null)}negate(){if(!this.c){const r=[];for(const p of this.expr)r.push(p.negate());this.c=T.create(r,this,!0)}return this.c}}e.$Ki=W;class T{static create(r,p,z){return T.d(r,p,z)}constructor(r,p){this.expr=r,this.c=p,this.type=9}cmp(r){if(r.type!==this.type)return this.type-r.type;if(this.expr.length<r.expr.length)return-1;if(this.expr.length>r.expr.length)return 1;for(let p=0,z=this.expr.length;p<z;p++){const C=s(this.expr[p],r.expr[p]);if(C!==0)return C}return 0}equals(r){if(r.type===this.type){if(this.expr.length!==r.expr.length)return!1;for(let p=0,z=this.expr.length;p<z;p++)if(!this.expr[p].equals(r.expr[p]))return!1;return!0}return!1}substituteConstants(){const r=F(this.expr);return r===this.expr?this:T.create(r,this.c,!1)}evaluate(r){for(let p=0,z=this.expr.length;p<z;p++)if(this.expr[p].evaluate(r))return!0;return!1}static d(r,p,z){let C=[],H=!1;if(r){for(let Y=0,ie=r.length;Y<ie;Y++){const de=r[Y];if(de){if(de.type===0){H=!0;continue}if(de.type===1)return o.INSTANCE;if(de.type===9){C=C.concat(de.expr);continue}C.push(de)}}if(C.length===0&&H)return n.INSTANCE;C.sort(s)}if(C.length!==0){if(C.length===1)return C[0];for(let Y=1;Y<C.length;Y++)C[Y-1].equals(C[Y])&&(C.splice(Y,1),Y--);if(C.length===1)return C[0];if(z){for(let Y=0;Y<C.length;Y++)for(let ie=Y+1;ie<C.length;ie++)if(C[Y].negate().equals(C[ie]))return o.INSTANCE;if(C.length===1)return C[0]}return new T(C,p)}}serialize(){return this.expr.map(r=>r.serialize()).join(" || ")}keys(){const r=[];for(const p of this.expr)r.push(...p.keys());return r}map(r){return new T(this.expr.map(p=>p.map(r)),null)}negate(){if(!this.c){const r=[];for(const p of this.expr)r.push(p.negate());for(;r.length>1;){const p=r.shift(),z=r.shift(),C=[];for(const H of oe(p))for(const Y of oe(z))C.push(W.create([H,Y],null,!1));r.unshift(T.create(C,null,!1))}this.c=T.create(r,this,!0)}return this.c}}e.$Li=T;class U extends l{static{this.d=[]}static all(){return U.d.values()}constructor(r,p,z){super(r,null),this.f=p,typeof z=="object"?U.d.push({...z,key:r}):z!==!0&&U.d.push({key:r,description:z,type:p!=null?typeof p:void 0})}bindTo(r){return r.createKey(this.key,this.f)}getValue(r){return r.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(r){return P.create(this.key,r)}notEqualsTo(r){return j.create(this.key,r)}}e.$Mi=U,e.$Ni=(0,L.$nh)("contextKeyService");function V(k,r){return k<r?-1:k>r?1:0}function G(k,r,p,z){return k<p?-1:k>p?1:r<z?-1:r>z?1:0}function X(k,r){if(k.type===0||r.type===1)return!0;if(k.type===9)return r.type===9?K(k.expr,r.expr):!1;if(r.type===9){for(const p of r.expr)if(X(k,p))return!0;return!1}if(k.type===6){if(r.type===6)return K(r.expr,k.expr);for(const p of k.expr)if(X(p,r))return!0;return!1}return k.equals(r)}e.$Oi=X;function K(k,r){let p=0,z=0;for(;p<k.length&&z<r.length;){const C=k[p].cmp(r[z]);if(C<0)return!1;C===0&&p++,z++}return p===k.length}function oe(k){return k.type===9?k.expr:[k]}}),define(ne[59],re([0,1,10]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0,e.$sn=(0,M.$nh)("downloadService")}),define(ne[18],re([0,1,10]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=void 0,e.$uh=(0,M.$nh)("environmentService"),e.$vh=(0,M.$oh)(e.$uh)}),define(ne[21],re([0,1,92,10]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Nn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0,e.$Bn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Cn=new RegExp(e.$Bn),e.$Dn="__web_extension",e.$En="skipWalkthrough",e.$Fn="extensionsSync";function D(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Gn=D;function L(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Hn=L;function N(f,I){switch(f){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$In=N;function b(f,I){return I==="web"&&!f.includes("web")}e.$Jn=b;function u(f,I,$){return b(I,$)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===$?!0:c($).includes(f)}e.$Kn=u;function c(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Ln=c;function w(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.$Mn=w;var R;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var m;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var h;(function(f){f.Install="install",f.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var O;(function(f){f[f.None=1]="None",f[f.Install=2]="Install",f[f.Update=3]="Update",f[f.Migrate=4]="Migrate"})(O||(e.InstallOperation=O={})),e.$Nn=(0,A.$nh)("extensionGalleryService");var y;(function(f){f.Unsupported="Unsupported",f.Deprecated="Deprecated",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.ReleaseVersionNotFound="ReleaseVersionNotFound",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Signature="Signature",f.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var g;(function(f){f.UnknownError="UnknownError",f.PackageIsInvalidZip="PackageIsInvalidZip",f.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(g||(e.ExtensionSignaturetErrorCode=g={}));class d extends Error{constructor(I,$){super(I),this.code=$,this.name=$}}e.$On=d,e.$Pn=(0,A.$nh)("extensionManagementService"),e.$Qn="extensionsIdentifiers/disabled",e.$Rn="extensionsIdentifiers/enabled",e.$Sn=(0,A.$nh)("IGlobalExtensionEnablementService"),e.$Tn=(0,A.$nh)("IExtensionTipsService"),e.$Un=(0,M.localize)(0,null),e.$Vn={value:e.$Un,original:"Extensions"},e.$Wn={value:(0,M.localize)(1,null),original:"Preferences"}}),define(ne[60],re([0,1,10]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=void 0,e.$To=(0,M.$nh)("IExtensionSignatureVerificationService");class A{b(){return this.a||(this.a=new Promise((L,N)=>J(["node-vsce-sign"],async b=>L(b),N))),this.a}async verify(L,N,b){let u;try{u=await this.b()}catch{return!1}return u.verify(L,N,b)}}e.$Uo=A}),define(ne[61],re([0,1,14,9,100,13]),function(J,e,M,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;async function N(w,R,m,h,O,y){let g;try{await b(w,R,m,h,O,y)}catch(d){g=d}finally{g&&O.errorTransformer&&(g=O.errorTransformer(g)),typeof g<"u"&&m.error(g),m.end()}}e.$pp=N;async function b(w,R,m,h,O,y){u(y);const g=await w.open(R,{create:!1});try{u(y);let d=0,f=0,I=O&&typeof O.length=="number"?O.length:void 0,$=M.$Jb.alloc(Math.min(O.bufferSize,typeof I=="number"?I:O.bufferSize)),v=O&&typeof O.position=="number"?O.position:0,t=0;do f=await w.read(g,v,$.buffer,t,$.byteLength-t),v+=f,t+=f,d+=f,typeof I=="number"&&(I-=f),t===$.byteLength&&(await m.write(h($)),$=M.$Jb.alloc(Math.min(O.bufferSize,typeof I=="number"?I:O.bufferSize)),t=0);while(f>0&&(typeof I!="number"||I>0)&&u(y)&&c(d,O));if(t>0){let a=t;typeof I=="number"&&(a=Math.min(t,I)),m.write(h($.slice(0,a)))}}catch(d){throw(0,L.$4j)(d)}finally{await w.close(g)}}function u(w){if(w.isCancellationRequested)throw(0,A.$4)();return!0}function c(w,R){if(typeof R?.limits?.size=="number"&&w>R.limits.size)throw(0,L.$3j)((0,D.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ne[117],re([0,1,4,166,2,12,167]),function(J,e,M,A,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class b extends D.$lb{constructor(){super(...arguments),this.a=this.B(new M.$7c),this.onDidChangeFile=this.a.event,this.b=this.B(new M.$7c),this.onDidLogMessage=this.b.event,this.onDidError=M.Event.None,this.c=new Map,this.f=!1}async watch(c){const w=this.i(c),R=w.filter(h=>{const O=this.c.get(h.path);return O?!(0,A.$gj)(O.request.excludes,h.excludes)||!(0,A.$gj)(O.request.includes,h.includes):!0}),m=Array.from(this.c.values()).filter(({request:h})=>!w.find(O=>O.path===h.path&&(0,A.$gj)(O.excludes,h.excludes)&&(0,A.$gj)(O.includes,h.includes))).map(({request:h})=>h.path);R.length&&this.j(`Request to start watching: ${R.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const h of m)this.h(h);for(const h of R)this.g(h)}g(c){const w=new N.$Lp(c,m=>this.a.fire(m),m=>this.b.fire(m),this.f),R={request:c,instance:w};this.c.set(c.path,R)}async stop(){for(const[c]of this.c)this.h(c);this.c.clear()}h(c){const w=this.c.get(c);w&&(this.c.delete(c),w.instance.dispose())}i(c){const w=new Map;for(const R of c){const m=L.$k?R.path:R.path.toLowerCase();w.set(m,R)}return Array.from(w.values())}async setVerboseLogging(c){this.f=c;for(const[,w]of this.c)w.instance.setVerboseLogging(c)}j(c){this.f&&this.b.fire({type:"trace",message:this.k(c)})}k(c,w){return w?`[File Watcher (node.js)] ${c} (path: ${w.request.path})`:`[File Watcher (node.js)] ${c}`}}e.$Np=b}),define(ne[118],re([0,1,62,117]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;class D extends M.$tp{constructor(N,b,u){super(N,b,u),this.m()}l(){return new A.$Np}}e.$Op=D}),define(ne[119],re([0,1,15,57,85,62]),function(J,e,M,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;class N extends L.$up{constructor(u,c,w){super(u,c,w),this.m()}l(u){const c=u.add(new D.$Fp(M.$3e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:w,signal:R})=>this.n(`terminated by itself with code ${w}, signal: ${R}`))),A.ProxyChannel.toService((0,A.$7g)(c.getChannel("watcher")))}}e.$Gp=N}),define(ne[63],re([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=void 0;class M{constructor(...D){this.a=new Map;for(const[L,N]of D)this.set(L,N)}set(D,L){const N=this.a.get(D);return this.a.set(D,L),N}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$lh=M}),define(ne[120],re([0,1,8,9,2,49,115,10,63,168]),function(J,e,M,A,D,L,N,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;const w=!1;class R extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class m{constructor(g=new u.$lh,d=!1,f,I=w){this.f=g,this.g=d,this.h=f,this.i=I,this.o=new Set,this.f.set(b.$mh,this),this._globalGraph=I?f?._globalGraph??new N.$Rp($=>$):void 0}createChild(g){return new m(g,this.g,this,this.i)}invokeFunction(g,...d){const f=O.traceInvocation(this.i,g);let I=!1;try{return g({get:v=>{if(I)throw(0,A.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(v,f);if(!t)throw new Error(`[invokeFunction] unknown service '${v}'`);return t}},...d)}finally{I=!0,f.stop()}}createInstance(g,...d){let f,I;return g instanceof L.$kh?(f=O.traceCreation(this.i,g.ctor),I=this.j(g.ctor,g.staticArguments.concat(d),f)):(f=O.traceCreation(this.i,g),I=this.j(g,d,f)),f.stop(),I}j(g,d=[],f){const I=b._util.getServiceDependencies(g).sort((t,a)=>t.index-a.index),$=[];for(const t of I){const a=this.m(t.id,f);a||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),$.push(a)}const v=I.length>0?I[0].index:d.length;if(d.length!==v){console.trace(`[createInstance] First service dependency of ${g.name} at position ${v+1} conflicts with ${d.length} static arguments`);const t=v-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,v)}return Reflect.construct(g,d.concat($))}k(g,d){if(this.f.get(g)instanceof L.$kh)this.f.set(g,d);else if(this.h)this.h.k(g,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const d=this.f.get(g);return!d&&this.h?this.h.l(g):d}m(g,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const f=this.l(g);return f instanceof L.$kh?this.q(g,f,d.branch(g,!0)):(d.branch(g,!1),f)}q(g,d,f){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,d,f)}finally{this.o.delete(g)}}r(g,d,f){const I=new N.$Rp(t=>t.id.toString());let $=0;const v=[{id:g,desc:d,_trace:f}];for(;v.length;){const t=v.pop();if(I.lookupOrInsertNode(t),$++>1e3)throw new R(I);for(const a of b._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${g} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof L.$kh){const s={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};I.insertEdge(t,s),v.push(s)}}}for(;;){const t=I.roots();if(t.length===0){if(!I.isEmpty())throw new R(I);break}for(const{data:a}of t){if(this.l(a.id)instanceof L.$kh){const s=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,s)}I.removeNode(a)}}return this.l(g)}s(g,d,f=[],I,$){if(this.f.get(g)instanceof L.$kh)return this.t(g,d,f,I,$);if(this.h)return this.h.s(g,d,f,I,$);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(g,d,f=[],I,$){if(I){const v=new m(void 0,this.g,this,this.i);v.c=String(g);const t=new Map,a=new M.$Jg(()=>{const i=v.j(d,f,$);for(const[s,n]of t){const o=i[s];if(typeof o=="function")for(const l of n)o.apply(i,l)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let l=t.get(s);return l||(l=new c.$lc,t.set(s,l)),(E,S,j)=>{const B=l.push([E,S,j]);return(0,D.$jb)(B)}}if(s in i)return i[s];const n=a.value;let o=n[s];return typeof o!="function"||(o=o.bind(n),i[s]=o),o},set(i,s,n){return a.value[s]=n,!0},getPrototypeOf(i){return d.prototype}})}else return this.j(d,f,$)}u(g,d){if(d&&console.warn(g),this.g)throw new Error(g)}}e.$Sp=m;var h;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(h||(h={}));class O{static{this.all=new Set}static{this.c=new class extends O{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,d){return g?new O(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):O.c}static traceCreation(g,d){return g?new O(1,d.name):O.c}static{this.f=0}constructor(g,d){this.type=g,this.name=d,this.g=Date.now(),this.h=[]}branch(g,d){const f=new O(3,g.toString());return this.h.push([g,d,f]),f}stop(){const g=Date.now()-this.g;O.f+=g;let d=!1;function f($,v){const t=[],a=new Array($+1).join("	");for(const[i,s,n]of v.h)if(s&&n){d=!0,t.push(`${a}CREATES -> ${i}`);const o=f($+1,n);o&&t.push(o)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const I=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${O.f.toFixed(2)}ms)`];(g>2||d)&&O.all.add(I.join(`
`))}}e.$Tp=O});var se=this&&this.__param||function(J,e){return function(M,A){e(M,A,J)}};define(ne[64],re([0,1,20,2,12,102,21,10]),function(J,e,M,A,D,L,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=void 0;function u(w){return w.tags.find(R=>R.startsWith("lp-"))?.split("lp-")[1]}e.$uq=u,e.$vq=(0,b.$nh)("languagePackService");let c=class extends A.$lb{constructor(R){super(),this.c=R}async getAvailableLanguages(){const R=new M.$dd;setTimeout(()=>R.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},R.token)}catch{return[]}const O=m.firstPage.filter(y=>y.properties.localizedLanguages?.length&&y.tags.some(g=>g.startsWith("lp-"))).map(y=>{const g=y.properties.localizedLanguages?.[0],d=u(y);return{...this.f(d,g,y),extensionId:y.identifier.id,galleryExtension:y}});return O.push(this.f("en","English")),O}f(R,m,h){const O=m??R;let y;if(O!==R&&(y=`(${R})`),R.toLowerCase()===D.$v.toLowerCase()&&(y??="",y+=(0,L.localize)(0,null)),h?.installCount){y??="";const g=h.installCount;let d;g>1e6?d=`${Math.floor(g/1e5)/10}M`:g>1e3?d=`${Math.floor(g/1e3)}K`:d=String(g),y+=` $(cloud-download) ${d}`}return{id:R,label:O,description:y}}};e.$wq=c,e.$wq=c=pe([se(0,N.$Nn)],c)}),define(ne[6],re([0,1,33,4,42,2,35,12,17,3,11,116,10]),function(J,e,M,A,D,L,N,b,u,c,w,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.log=e.$Si=e.LogLevel=e.$Ri=e.$Qi=e.$Pi=void 0,e.$Pi=(0,m.$nh)("logService"),e.$Qi=(0,m.$nh)("loggerService");function h(){return new Date().toISOString()}function O(E){return(0,c.$me)(E)}e.$Ri=O;var y;(function(E){E[E.Off=0]="Off",E[E.Trace=1]="Trace",E[E.Debug=2]="Debug",E[E.Info=3]="Info",E[E.Warning=4]="Warning",E[E.Error=5]="Error"})(y||(e.LogLevel=y={})),e.$Si=y.Info;function g(E,S,j){switch(S){case y.Trace:E.trace(j);break;case y.Debug:E.debug(j);break;case y.Info:E.info(j);break;case y.Warning:E.warn(j);break;case y.Error:E.error(j);break;case y.Off:break;default:throw new Error(`Invalid log level ${S}`)}}e.log=g;function d(E,S=!1){let j="";for(let B=0;B<E.length;B++){let ee=E[B];if(ee instanceof Error&&(ee=(0,M.$$h)(ee,S)),typeof ee=="object")try{ee=JSON.stringify(ee)}catch{}j+=(B>0?" ":"")+ee}return j}class f extends L.$lb{constructor(){super(...arguments),this.b=e.$Si,this.c=this.B(new A.$7c),this.onDidChangeLogLevel=this.c.event}setLevel(S){this.b!==S&&(this.b=S,this.c.fire(this.b))}getLevel(){return this.b}f(S){return this.b!==y.Off&&this.b<=S}}e.$Ui=f;class I extends f{constructor(S){super(),this.h=S}f(S){return this.h||super.f(S)}trace(S,...j){this.f(y.Trace)&&this.g(y.Trace,d([S,...j],!0))}debug(S,...j){this.f(y.Debug)&&this.g(y.Debug,d([S,...j]))}info(S,...j){this.f(y.Info)&&this.g(y.Info,d([S,...j]))}warn(S,...j){this.f(y.Warning)&&this.g(y.Warning,d([S,...j]))}error(S,...j){if(this.f(y.Error))if(S instanceof Error){const B=Array.prototype.slice.call(arguments);B[0]=S.stack,this.g(y.Error,d(B))}else this.g(y.Error,d([S,...j]))}flush(){}}e.$Vi=I;class $ extends f{constructor(S=e.$Si){super(),this.setLevel(S),this.g=!b.$i}trace(S,...j){this.f(y.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...j):console.log(`[main ${h()}]`,S,...j))}debug(S,...j){this.f(y.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...j):console.log(`[main ${h()}]`,S,...j))}info(S,...j){this.f(y.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,S,...j):console.log(`[main ${h()}]`,S,...j))}warn(S,...j){this.f(y.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,S,...j):console.warn(`[main ${h()}]`,S,...j))}error(S,...j){this.f(y.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,S,...j):console.error(`[main ${h()}]`,S,...j))}dispose(){}flush(){}}e.$Wi=$;class v extends f{constructor(S=e.$Si,j=!0){super(),this.g=j,this.setLevel(S)}trace(S,...j){this.f(y.Trace)&&(this.g?console.log("%cTRACE","color: #888",S,...j):console.log(S,...j))}debug(S,...j){this.f(y.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",S,...j):console.log(S,...j))}info(S,...j){this.f(y.Info)&&(this.g?console.log("%c INFO","color: #33f",S,...j):console.log(S,...j))}warn(S,...j){this.f(y.Warning)&&(this.g?console.log("%c WARN","color: #993",S,...j):console.log(S,...j))}error(S,...j){this.f(y.Error)&&(this.g?console.log("%c  ERR","color: #f33",S,...j):console.error(S,...j))}dispose(){}flush(){}}e.$Xi=v;class t extends f{constructor(S,j=e.$Si){super(),this.g=S,this.setLevel(j)}trace(S,...j){this.f(y.Trace)&&this.g.log(y.Trace,[this.h(S),...j])}debug(S,...j){this.f(y.Debug)&&this.g.log(y.Debug,[this.h(S),...j])}info(S,...j){this.f(y.Info)&&this.g.log(y.Info,[this.h(S),...j])}warn(S,...j){this.f(y.Warning)&&this.g.log(y.Warning,[this.h(S),...j])}error(S,...j){this.f(y.Error)&&this.g.log(y.Error,[this.h(S),...j])}h(S){return typeof S=="string"?S:(0,M.$$h)(S,this.f(y.Trace))}dispose(){}flush(){}}e.$Yi=t;class a extends f{constructor(S){super(),this.g=S,S.length&&this.setLevel(S[0].getLevel())}setLevel(S){for(const j of this.g)j.setLevel(S);super.setLevel(S)}trace(S,...j){for(const B of this.g)B.trace(S,...j)}debug(S,...j){for(const B of this.g)B.debug(S,...j)}info(S,...j){for(const B of this.g)B.info(S,...j)}warn(S,...j){for(const B of this.g)B.warn(S,...j)}error(S,...j){for(const B of this.g)B.error(S,...j)}flush(){for(const S of this.g)S.flush()}dispose(){for(const S of this.g)S.dispose()}}e.$Zi=a;class i extends L.$lb{constructor(S,j,B){if(super(),this.h=S,this.j=j,this.b=new N.$li,this.c=this.B(new A.$7c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new A.$7c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new A.$7c),this.onDidChangeVisibility=this.g.event,B)for(const ee of B)this.b.set(ee.resource,{logger:void 0,info:ee})}k(S){return(0,c.$ie)(S)?[...this.b.values()].find(j=>j.info.id===S):this.b.get(S)}getLogger(S){return this.k(S)?.logger}createLogger(S,j){const B=this.l(S),ee=(0,c.$ie)(S)?S:j?.id??(0,D.$bi)(B.toString()).toString(16);let Z=this.b.get(B)?.logger;const le=j?.logLevel==="always"?y.Trace:j?.logLevel;Z||(Z=this.m(B,le??this.getLogLevel(B)??this.h,{...j,id:ee}));const _={logger:Z,info:{resource:B,id:ee,logLevel:le,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(_.info),this.b.set(B,_),Z}l(S){return(0,c.$ie)(S)?(0,u.$8f)(this.j,`${S}.log`):S}setLogLevel(S,j){if(w.URI.isUri(S)){const B=S,ee=j,Z=this.b.get(B);Z&&ee!==Z.info.logLevel&&(Z.info.logLevel=ee===this.h?void 0:ee,Z.logger?.setLevel(ee),this.b.set(Z.info.resource,Z),this.f.fire([B,ee]))}else{this.h=S;for(const[B,ee]of this.b.entries())this.b.get(B)?.info.logLevel===void 0&&ee.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(S,j){const B=this.k(S);B&&j!==!B.info.hidden&&(B.info.hidden=!j,this.b.set(B.info.resource,B),this.g.fire([B.info.resource,j]))}getLogLevel(S){let j;return S&&(j=this.b.get(S)?.info.logLevel),j??this.h}registerLogger(S){const j=this.b.get(S.resource);j?j.info.hidden!==S.hidden&&this.setVisibility(S.resource,!S.hidden):(this.b.set(S.resource,{info:S,logger:void 0}),this.c.fire({added:[S],removed:[]}))}deregisterLogger(S){const j=this.b.get(S);j&&(j.logger&&j.logger.dispose(),this.b.delete(S),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const S of this.b.values())yield S.info}getRegisteredLogger(S){return this.b.get(S)?.info}dispose(){this.b.forEach(S=>S.logger?.dispose()),this.b.clear(),super.dispose()}}e.$1i=i;class s{constructor(){this.onDidChangeLogLevel=new A.$7c().event}setLevel(S){}getLevel(){return y.Info}trace(S,...j){}debug(S,...j){}info(S,...j){}warn(S,...j){}error(S,...j){}critical(S,...j){}dispose(){}flush(){}}e.$2i=s;class n extends s{}e.$3i=n;function o(E){if(E.verbose)return y.Trace;if(typeof E.logLevel=="string"){const S=P(E.logLevel.toLowerCase());if(S!==void 0)return S}return e.$Si}e.$4i=o;function l(E){switch(E){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Off:return"off"}}e.$5i=l;function P(E){switch(E){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Error;case"off":return y.Off}}e.$6i=P,e.$7i=new R.$Mi("logLevel",l(y.Info))}),define(ne[121],re([0,1,19,8,9,4,2,16,62,6]),function(J,e,M,A,D,L,N,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;class w extends N.$lb{constructor(m,h){super(),this.a=m,this.b=h,this.c=this.B(new L.$7c),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$7c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new A.$rg(0)),this.s=[],this.t=this.B(new A.$rg(0))}watch(m,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(m,h):this.u(m,h)}l(m,h){const O={path:this.C(m),excludes:h.excludes,includes:h.includes,recursive:h.recursive},y=(0,M.$Af)(this.j,O);return this.m(),(0,N.$jb)(()=>{y(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,D.$Y)(m))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,u.$vp)(h)),h=>this.z(h),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const h of this.j)(0,u.$rp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const h of this.j)(0,u.$rp)(h)&&m.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,h){const O={path:this.C(m),excludes:h.excludes,includes:h.includes,recursive:!1},y=(0,M.$Af)(this.s,O);return this.v(),(0,N.$jb)(()=>{y(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,D.$Y)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,u.$vp)(m)),m=>this.z(m),this.a.getLevel()===c.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===c.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,b.$$b)(m.fsPath)}}e.$zp=w}),define(ne[122],re([0,1,19,8,14,20,4,42,65,2,46,15,123,17,41,99,13,61,6,9]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O,y,g,d,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=void 0;let $=class extends c.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new N.$7c),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$7c),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$7c),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new N.$7c),this.onDidRunOperation=this.m.event,this.R=this.B(new N.$7c),this.onDidFilesChange=this.R.event,this.S=this.B(new N.$7c),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new A.$Bg)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const i=new c.$kb;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(s=>this.R.fire(new g.$9j(s,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(s=>this.S.fire(new Error(s)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,c.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,c.$gb)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await A.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return u.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,h.$_f)(t))throw new g.$$j((0,y.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new I.$ab;throw i.message=(0,y.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,g.$Vj)(a)||(0,g.$Sj)(a)||(0,g.$Wj)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,g.$Vj)(a)||(0,g.$Sj)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,g.$6j)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.$$j((0,y.localize)(2,null,this.nb(t)),1):(0,g.$4j)(i)}}async n(t,a){const i=await this.j(t),s=this.O(i),n=a?.resolveTo,o=a?.resolveSingleChildDescendants,l=a?.resolveMetadata,P=await i.stat(t);let E;return this.p(i,t,P,void 0,!!l,(S,j)=>(E||(E=w.$th.forUris(()=>!s),E.set(t,!0),n&&E.fill(!0,n)),E.get(S.resource)||E.findSuperstr(S.resource.with({query:null,fragment:null}))?!0:S.isDirectory&&o?j===1:!1))}async p(t,a,i,s,n,o){const{providerExtUri:l}=this.N(t),P={resource:a,name:l.basename(a),isFile:(i.type&g.FileType.File)!==0,isDirectory:(i.type&g.FileType.Directory)!==0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&g.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((i.permissions??0)&g.FilePermission.Locked),etag:(0,g.$jk)({mtime:i.mtime,size:i.size}),children:void 0};if(P.isDirectory&&o(P,s)){try{const E=await t.readdir(a),S=await A.Promises.settled(E.map(async([j,B])=>{try{const ee=l.joinPath(a,j),Z=n?await t.stat(ee):{type:B};return await this.p(t,ee,Z,E.length,n,o)}catch(ee){return this.b.trace(ee),null}}));P.children=(0,M.$lf)(S)}catch(E){this.b.trace(E),P.children=[]}return P}return P}async resolveAll(t){return A.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new g.$$j((0,y.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=D.$Jb.fromString(""),i){await this.r(t,i);const s=await this.writeFile(t,a);return this.m.fire(new g.$8j(t,0,s)),s}async writeFile(t,a,i){const s=this.lb(await this.l(t),t),{providerExtUri:n}=this.N(s);try{await this.s(s,t,i)||await this.P(s,n.dirname(t));let l;if((0,g.$Sj)(s)&&!(a instanceof D.$Jb))if((0,O.$vb)(a)){const P=await(0,O.$Cb)(a,3);P.ended?l=D.$Jb.concat(P.buffer):l=P}else l=(0,O.$zb)(a,P=>D.$Jb.concat(P),3);else l=a;if(!(0,g.$Vj)(s)||(0,g.$Sj)(s)&&l instanceof D.$Jb)await this.cb(s,t,i,l);else{const P=l instanceof D.$Jb?(0,D.$Ub)(l):l;i?.atomic!==!1&&i?.atomic?.postfix?await this.Y(s,t,(0,h.$8f)((0,h.$7f)(t),`${(0,h.$5f)(t)}${i.atomic.postfix}`),i,P):await this.Z(s,t,i,P)}this.m.fire(new g.$8j(t,4))}catch(o){throw new g.$$j((0,y.localize)(4,null,this.nb(t),(0,g.$4j)(o).toString()),(0,g.$7j)(o),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){const s=!!i?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,y.localize)(5,null,this.nb(a)));if(!!i?.atomic){if(!(t.capabilities&32768))throw new Error((0,y.localize)(6,null,this.nb(a)));if(s)throw new Error((0,y.localize)(7,null,this.nb(a)))}let o;try{o=await t.stat(a)}catch{return}if(o.type&g.FileType.Directory)throw new g.$$j((0,y.localize)(8,null,this.nb(a)),0,i);if(this.mb(a,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.$ik&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,g.$jk)({mtime:i.mtime,size:o.size}))throw new g.$$j((0,y.localize)(9,null),3,i);return o}async readFile(t,a,i){const s=await this.k(t);return a?.atomic?this.t(s,t,a,i):this.u(s,t,a,i)}async t(t,a,i,s){return new Promise((n,o)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const l=await this.u(t,a,i,s);n(l)}catch(l){o(l)}})})}async u(t,a,i,s){const n=await this.v(t,a,{...i,preferUnbuffered:!0},s);return{...n,value:await(0,D.$Vb)(n.value)}}async readFileStream(t,a,i){const s=await this.k(t);return this.v(s,t,a,i)}async v(t,a,i,s){const n=new L.$dd(s),o=this.F(a,i).then(P=>P,P=>{throw n.cancel(),P});let l;try{return typeof i?.etag=="string"&&i.etag!==g.$ik&&await o,i?.atomic&&(0,g.$Xj)(t)||!((0,g.$Vj)(t)||(0,g.$Wj)(t))||(0,g.$Sj)(t)&&i?.preferUnbuffered?l=this.D(t,a,i):(0,g.$Wj)(t)?l=this.z(t,a,n.token,i):l=this.C(t,a,n.token,i),{...await o,value:l}}catch(P){throw l&&await(0,O.$Ab)(l),this.w(P,a,i)}}w(t,a,i){const s=(0,y.localize)(10,null,this.nb(a),(0,g.$4j)(t).toString());return t instanceof g.$ak?new g.$ak(s,t.stat,i):t instanceof g.$_j?new g.$_j(s,t.fileOperationResult,t.size,t.options):new g.$$j(s,(0,g.$7j)(t),i)}z(t,a,i,s=Object.create(null)){const n=t.readFileStream(a,s,i);return(0,O.$Gb)(n,{data:o=>o instanceof D.$Jb?o:D.$Jb.wrap(o),error:o=>this.w(o,a,s)},o=>D.$Jb.concat(o))}C(t,a,i,s=Object.create(null)){const n=(0,D.$Zb)();return(0,d.$pp)(t,a,n,o=>o,{...s,bufferSize:this.a,errorTransformer:o=>this.w(o,a,s)},i),n}D(t,a,i){const s=(0,O.$xb)(n=>D.$Jb.concat(n));return(async()=>{try{let n;i?.atomic&&(0,g.$Xj)(t)?n=await t.readFile(a,{atomic:!0}):n=await t.readFile(a),typeof i?.position=="number"&&(n=n.slice(i.position)),typeof i?.length=="number"&&(n=n.slice(0,i.length)),this.G(a,n.byteLength,i),s.end(D.$Jb.wrap(n))}catch(n){s.error(n),s.end()}})(),s}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new g.$$j((0,y.localize)(11,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==g.$ik&&a.etag===i.etag)throw new g.$ak((0,y.localize)(12,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new g.$_j((0,y.localize)(13,null,this.nb(t)),7,a,i)}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,s){if(t.toString()!==a.toString())try{const n=i==="move"?this.lb(await this.l(t),t):await this.k(t),o=this.lb(await this.l(a),a);await this.M(n,t,o,a,i,s)}catch(n){return n}return!0}async move(t,a,i){const s=this.lb(await this.l(t),t),n=this.lb(await this.l(a),a),o=await this.I(s,t,n,a,"move",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new g.$8j(t,o==="move"?2:3,l)),l}async copy(t,a,i){const s=await this.k(t),n=this.lb(await this.l(a),a),o=await this.I(s,t,n,a,"copy",!!i),l=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new g.$8j(t,o==="copy"?3:2,l)),l}async I(t,a,i,s,n,o){if(a.toString()===s.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:P}=await this.M(t,a,i,s,n,o);if(l&&!P&&o&&await this.del(s,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(s)),n==="copy"){if(t===i&&(0,g.$Tj)(t))await t.copy(a,s,{overwrite:o});else{const E=await this.resolve(a);E.isDirectory?await this.L(t,E,i,s):await this.J(t,a,i,s)}return n}else return t===i?(await t.rename(a,s,{overwrite:o}),n):(await this.I(t,a,i,s,"copy",o),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,s){if((0,g.$Vj)(t)&&(0,g.$Vj)(i))return this.eb(t,a,i,s);if((0,g.$Vj)(t)&&(0,g.$Sj)(i))return this.kb(t,a,i,s);if((0,g.$Sj)(t)&&(0,g.$Vj)(i))return this.ib(t,a,i,s);if((0,g.$Sj)(t)&&(0,g.$Sj)(i))return this.gb(t,a,i,s)}async L(t,a,i,s){await i.mkdir(s),Array.isArray(a.children)&&await A.Promises.settled(a.children.map(async n=>{const o=this.N(i).providerExtUri.joinPath(s,n.name);return n.isDirectory?this.L(t,await this.resolve(n.resource),i,o):this.J(t,n.resource,i,o)}))}async M(t,a,i,s,n,o){let l=!1;if(t===i){const{providerExtUri:E,isPathCaseSensitive:S}=this.N(t);if(S||(l=E.isEqual(a,s)),l&&n==="copy")throw new Error((0,y.localize)(14,null,this.nb(a),this.nb(s)));if(!l&&E.isEqualOrParent(s,a))throw new Error((0,y.localize)(15,null,this.nb(a),this.nb(s)))}const P=await this.exists(s);if(P&&!l){if(!o)throw new g.$$j((0,y.localize)(16,null,this.nb(a),this.nb(s)),4);if(t===i){const{providerExtUri:E}=this.N(t);if(E.isEqualOrParent(a,s))throw new Error((0,y.localize)(17,null,this.nb(a),this.nb(s)))}}return{exists:P,isSameResourceWithDifferentPathCase:l}}N(t){const a=this.O(t);return{providerExtUri:a?h.$Xf:h.$Zf,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new g.$8j(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:s}=this.N(t);for(;!s.isEqual(a,s.dirname(a));)try{if(!((await t.stat(a)).type&g.FileType.Directory))throw new Error((0,y.localize)(18,null,this.nb(a)));break}catch(n){if((0,g.$6j)(n)!==g.FileSystemProviderErrorCode.FileNotFound)throw n;i.push(s.basename(a)),a=s.dirname(a)}for(let n=i.length-1;n>=0;n--){a=s.joinPath(a,i[n]);try{await t.mkdir(a)}catch(o){if((0,g.$6j)(o)!==g.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t),s=!!a?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,y.localize)(19,null,this.nb(t)));const n=a?.atomic;if(n&&!(i.capabilities&65536))throw new Error((0,y.localize)(20,null,this.nb(t)));if(s&&n)throw new Error((0,y.localize)(21,null,this.nb(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.mb(t,o);else throw new g.$$j((0,y.localize)(22,null,this.nb(t)),1);if(!!!a?.recursive){const P=await this.resolve(t);if(P.isDirectory&&Array.isArray(P.children)&&P.children.length>0)throw new Error((0,y.localize)(23,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),s=!!a?.useTrash,n=!!a?.recursive,o=a?.atomic??!1;await i.delete(t,{recursive:n,useTrash:s,atomic:o}),this.m.fire(new g.$8j(t,1))}async cloneFile(t,a){const i=await this.j(t),s=this.lb(await this.l(a),a);if(i===s&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===s&&(0,g.$Uj)(i))return i.cloneFile(t,a);await this.P(s,this.N(s).providerExtUri.dirname(a));const n=this.X.queueFor(t,this.N(i).providerExtUri);return i===s&&(0,g.$Tj)(i)?n.queue(()=>i.copy(t,a,{overwrite:!0})):n.queue(()=>this.J(i,t,s,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new c.$kb;let s=!1,n=()=>{s=!0};return i.add((0,c.$jb)(()=>n())),(async()=>{try{const o=await this.W(t,a);s?(0,c.$gb)(o):n=()=>(0,c.$gb)(o)}catch(o){this.b.error(o)}})(),i}async W(t,a){const i=await this.j(t),s=(0,b.$bi)([this.N(i).providerExtUri.getComparisonKey(t),a]);let n=this.U.get(s);return n||(n={count:0,disposable:i.watch(t,a)},this.U.set(s,n)),n.count+=1,(0,c.$jb)(()=>{n&&(n.count--,n.count===0&&((0,c.$gb)(n.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,c.$gb)(t.disposable);this.U.clear()}async Y(t,a,i,s,n){await this.Z(t,i,s,n);try{await t.rename(i,a,{overwrite:!0})}catch(o){try{await t.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw o}}async Z(t,a,i,s){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const n=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,O.$vb)(s)||(0,O.$wb)(s)?await this.$(t,n,s):await this.ab(t,n,s)}catch(o){throw(0,g.$4j)(o)}finally{await t.close(n)}})}async $(t,a,i){let s=0,n;if((0,O.$wb)(i)){if(i.buffer.length>0){const o=D.$Jb.concat(i.buffer);await this.bb(t,a,o,o.byteLength,s,0),s+=o.byteLength}if(i.ended)return;n=i.stream}else n=i;return new Promise((o,l)=>{(0,O.$Bb)(n,{onData:async P=>{n.pause();try{await this.bb(t,a,P,P.byteLength,s,0)}catch(E){return l(E)}s+=P.byteLength,setTimeout(()=>n.resume())},onError:P=>l(P),onEnd:()=>o()})})}async ab(t,a,i){let s=0,n;for(;(n=i.read())!==null;)await this.bb(t,a,n,n.byteLength,s,0),s+=n.byteLength}async bb(t,a,i,s,n,o){let l=0;for(;l<s;){const P=await t.write(a,n+l,i.buffer,o+l,s-l);l+=P}}async cb(t,a,i,s){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,s))}async db(t,a,i,s){let n;s instanceof D.$Jb?n=s:(0,O.$vb)(s)?n=await(0,D.$Vb)(s):(0,O.$wb)(s)?n=await(0,D.$Wb)(s):n=(0,D.$Tb)(s),await t.writeFile(a,n.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async eb(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,s))}async fb(t,a,i,s){let n,o;try{n=await t.open(a,{create:!1}),o=await i.open(s,{create:!0,unlock:!1});const l=D.$Jb.alloc(this.a);let P=0,E=0,S=0;do S=await t.read(n,P,l.buffer,E,l.byteLength-E),await this.bb(i,o,l,S,P,E),P+=S,E+=S,E===l.byteLength&&(E=0);while(S>0)}catch(l){throw(0,g.$4j)(l)}finally{await A.Promises.settled([typeof n=="number"?t.close(n):Promise.resolve(),typeof o=="number"?i.close(o):Promise.resolve()])}}async gb(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,s))}async hb(t,a,i,s){return i.writeFile(s,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,a,i,s){return this.X.queueFor(s,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,s))}async jb(t,a,i,s){const n=await i.open(s,{create:!0,unlock:!1});try{const o=await t.readFile(a);await this.bb(i,n,D.$Jb.wrap(o),o.byteLength,0,0)}catch(o){throw(0,g.$4j)(o)}finally{await i.close(n)}}async kb(t,a,i,s){const n=await(0,D.$Vb)(this.C(t,a,L.CancellationToken.None));await this.cb(i,s,void 0,n)}lb(t,a){if(t.capabilities&2048)throw new g.$$j((0,y.localize)(24,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&g.FilePermission.Readonly)throw new g.$$j((0,y.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===R.Schemas.file?t.fsPath:t.toString(!0)}};e.$qp=$,e.$qp=$=pe([se(0,f.$Pi)],$)}),define(ne[124],re([0,1,125,169,8,35,14,4,170,2,16,12,17,41,24,101,13,61,121,33,119,118]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O,y,g,d,f,I,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0,(()=>{try{(0,A.gracefulify)(M)}catch(a){console.error(`Error enabling graceful-fs: ${(0,I.$$h)(a)}`)}})();class t extends f.$zp{static{this.D=!1}constructor(i,s){super(i,s),this.onDidChangeCapabilities=b.Event.None,this.I=new L.$li(n=>m.$Yf.getComparisonKey(n)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,R.$k&&(this.F|=1024)),this.F}async stat(i){try{const{stat:s,symbolicLink:n}=await O.SymlinkSupport.stat(this.C(i));return{type:this.H(s,n),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:g.FilePermission.Locked}}catch(s){throw this.ab(s)}}async G(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const s=await O.Promises.readdir(this.C(i),{withFileTypes:!0}),n=[];return await Promise.all(s.map(async o=>{try{let l;o.isSymbolicLink()?l=(await this.stat((0,m.$8f)(i,o.name))).type:l=this.H(o),n.push([o.name,l])}catch(l){this.a.trace(l)}})),n}catch(s){throw this.ab(s)}}H(i,s){let n;return s?.dangling?n=g.FileType.Unknown:i.isFile()?n=g.FileType.File:i.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,s&&(n|=g.FileType.SymbolicLink),n}async J(i){const s=this.C(i);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let n;for(;n=this.I.get(i);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await n.wait();const o=new D.$sg;return this.I.set(i,o),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,c.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.I.get(i)===o&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.I.delete(i)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),o.open()})}async readFile(i,s){let n;try{s?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),n=await this.J(i));const o=this.C(i);return await O.Promises.readFile(o)}catch(o){throw this.ab(o)}finally{n?.dispose()}}L(i){t.D&&this.a.trace(i)}readFileStream(i,s,n){const o=(0,h.$xb)(l=>N.$Jb.concat(l.map(P=>N.$Jb.wrap(P))).buffer);return(0,d.$pp)(this,i,o,l=>l.buffer,{...s,bufferSize:256*1024},n),o}async writeFile(i,s,n){return n?.atomic!==!1&&n?.atomic?.postfix?this.M(i,(0,m.$8f)((0,m.$7f)(i),`${(0,m.$5f)(i)}${n.atomic.postfix}`),s,n):this.N(i,s,n)}async M(i,s,n,o){await this.N(s,n,o);try{await this.rename(s,i,{overwrite:!0})}catch(l){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw l}}async N(i,s,n){let o;try{const l=this.C(i);if(!n.create||!n.overwrite){if(await O.Promises.exists(l)){if(!n.overwrite)throw(0,g.$3j)((0,y.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.$3j)((0,y.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(i,{create:!0,unlock:n.unlock}),await this.write(o,0,s,0,s.byteLength)}catch(l){throw await this.bb(i,l)}finally{typeof o=="number"&&await this.close(o)}}static{this.R=!0}static configureFlushOnWrite(i){t.R=i}async open(i,s){const n=this.C(i);let o;(0,g.$Rj)(s)&&(o=await this.J(i));let l;try{if((0,g.$Rj)(s)&&s.unlock)try{const{stat:E}=await O.SymlinkSupport.stat(n);E.mode&128||await O.Promises.chmod(n,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let P;if((0,g.$Rj)(s)){if(R.$i)try{await O.Promises.truncate(n,0),P="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}P||(P="w")}else P="r";l=await O.Promises.open(n,P)}catch(P){throw o?.dispose(),(0,g.$Rj)(s)?await this.bb(i,P):this.ab(P)}if(this.O.set(l,0),(0,g.$Rj)(s)&&this.Q.set(l,i),o){const P=this.P.get(l);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${l} (${n})`),this.P.set(l,o),P&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${l} (${n})`),P.dispose())}return l}async close(i){const s=this.P.get(i);try{if(this.O.delete(i),this.Q.delete(i)&&t.R)try{await O.Promises.fdatasync(i)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await O.Promises.close(i)}catch(n){throw this.ab(n)}finally{s&&(this.P.get(i)===s&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.P.delete(i)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),s.dispose())}}async read(i,s,n,o,l){const P=this.S(i,s);let E=null;try{E=(await O.Promises.read(i,n,o,l,P)).bytesRead}catch(S){throw this.ab(S)}finally{this.U(i,P,E)}return E}S(i,s){return s===this.O.get(i)?null:s}U(i,s,n){const o=this.O.get(i);typeof o=="number"&&(typeof s=="number"||(typeof n=="number"?this.O.set(i,o+n):this.O.delete(i)))}async write(i,s,n,o,l){return(0,D.$Kg)(()=>this.W(i,s,n,o,l),100,3)}async W(i,s,n,o,l){const P=this.S(i,s);let E=null;try{E=(await O.Promises.write(i,n,o,l,P)).bytesWritten}catch(S){throw await this.bb(this.Q.get(i),S)}finally{this.U(i,P,E)}return E}async mkdir(i){try{await O.Promises.mkdir(this.C(i))}catch(s){throw this.ab(s)}}async delete(i,s){try{const n=this.C(i);if(s.recursive){let o;s?.atomic!==!1&&s.atomic.postfix&&(o=(0,w.$ac)((0,w.$dc)(n),`${(0,w.$ec)(n)}${s.atomic.postfix}`)),await O.Promises.rm(n,O.RimRafMode.MOVE,o)}else try{await O.Promises.unlink(n)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let l=!1;try{const{stat:P,symbolicLink:E}=await O.SymlinkSupport.stat(n);l=P.isDirectory()&&!E}catch{}if(l)await O.Promises.rmdir(n);else throw o}else throw o}}catch(n){throw this.ab(n)}}async rename(i,s,n){const o=this.C(i),l=this.C(s);if(o!==l)try{await this.X(i,s,"move",n.overwrite),await O.Promises.move(o,l)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(2,null,(0,w.$ec)(o),(0,w.$ec)((0,w.$dc)(l)),P.toString()))),this.ab(P)}}async copy(i,s,n){const o=this.C(i),l=this.C(s);if(o!==l)try{await this.X(i,s,"copy",n.overwrite),await O.Promises.copy(o,l,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(3,null,(0,w.$ec)(o),(0,w.$ec)((0,w.$dc)(l)),P.toString()))),this.ab(P)}}async X(i,s,n,o){const l=this.C(i),P=this.C(s);let E=!1;if(!!(this.capabilities&1024)||(E=(0,u.$Ie)(l,P,!0)),E){if(n==="copy")throw(0,g.$3j)((0,y.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const j=await this.G(i);if(!j)throw(0,g.$3j)((0,y.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const B=await this.G(s);if(B){if(!o)throw(0,g.$3j)((0,y.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);j.type&g.FileType.File&&B.type&g.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,s){return this.Y(i,s,!1)}async Y(i,s,n){const o=this.C(i),l=this.C(s),P=!!(this.capabilities&1024);if((0,u.$Ie)(o,l,!P))return;const E=new c.$kb;try{const[S,j]=await Promise.all([this.J(i),this.J(s)]);E.add(S),E.add(j),n&&await O.Promises.mkdir((0,w.$dc)(l),{recursive:!0}),await O.Promises.copyFile(o,l)}catch(S){if(S.code==="ENOENT"&&!n)return this.Y(i,s,!0);throw this.ab(S)}finally{E.dispose()}}p(i,s,n){return new $.$Gp(o=>i(o),o=>s(o),n)}y(i,s,n){return new v.$Op(o=>i(o),o=>s(o),n)}ab(i){if(i instanceof g.$2j)return i;let s=i,n;switch(i.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.$3j)(s,n)}async bb(i,s){let n=this.ab(s);if(i&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await O.SymlinkSupport.stat(this.C(i));o.mode&128||(n=(0,g.$3j)(s,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return n}}e.$Pp=t}),define(ne[126],re([0,1,2,6]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;class D extends M.$lb{constructor(N,b=[]){super(),this.a=new A.$Zi([N,...b]),this.B(N.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...b){this.a.trace(N,...b)}debug(N,...b){this.a.debug(N,...b)}info(N,...b){this.a.info(N,...b)}warn(N,...b){this.a.warn(N,...b)}error(N,...b){this.a.error(N,...b)}flush(){this.a.flush()}}e.$WM=D}),define(ne[127],re([0,1,13,6]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=void 0;var D;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(D||(D={}));async function L(c,w,R,m,h){try{const O=await new Promise((g,d)=>{J(["@vscode/spdlog"],g,d)});O.setFlushOn(D.Trace);const y=await O.createAsyncRotatingLogger(c,w,R,m);return h?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(O){console.error(O)}return null}function N(c,w,R){switch(w){case A.LogLevel.Trace:c.trace(R);break;case A.LogLevel.Debug:c.debug(R);break;case A.LogLevel.Info:c.info(R);break;case A.LogLevel.Warning:c.warn(R);break;case A.LogLevel.Error:c.error(R);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${w}`)}}function b(c,w){switch(w){case A.LogLevel.Trace:c.setLevel(D.Trace);break;case A.LogLevel.Debug:c.setLevel(D.Debug);break;case A.LogLevel.Info:c.setLevel(D.Info);break;case A.LogLevel.Warning:c.setLevel(D.Warning);break;case A.LogLevel.Error:c.setLevel(D.Error);break;case A.LogLevel.Off:c.setLevel(D.Off);break;default:throw new Error(`Invalid log level ${w}`)}}class u extends A.$Vi{constructor(w,R,m,h,O){super(),this.k=[],this.setLevel(O),this.l=this.n(w,R,m,h),this.B(this.onDidChangeLogLevel(y=>{this.m&&b(this.m,y)}))}async n(w,R,m,h){const O=m?6:1,y=30/O*M.$lk.MB,g=await L(w,R,y,O,h);if(g){this.m=g,b(this.m,this.getLevel());for(const{level:d,message:f}of this.k)N(this.m,d,f);this.k=[]}}g(w,R){this.m?N(this.m,w,R):this.getLevel()<=w&&this.k.push({level:w,message:R})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$LM=u}),define(ne[128],re([0,1,29,6,127]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MM=void 0;class L extends A.$1i{m(b,u,c){return new D.$LM((0,M.$5e)(),b.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$MM=L}),define(ne[38],re([0,1,4,65,2,10]),function(J,e,M,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=void 0,e.$Tm=(0,L.$nh)("policy");class N extends D.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new M.$7c),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const w=Object.keys(this.f).length;return this.f={...c,...this.f},w!==Object.keys(this.f).length&&await this.i(c),A.Iterable.reduce(this.g.entries(),(R,[m,h])=>({...R,[m]:h}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(c,[w,R])=>({...c,[w]:{definition:R,value:this.g.get(w)}}),{})}}e.$Um=N;class b{constructor(){this.onDidChange=M.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Vm=b}),define(ne[129],re([0,1,8,4,65,3,13,6,38]),function(J,e,M,A,D,L,N,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$64b=void 0;function c(R,m){const h=[];for(const O of new Set(D.Iterable.concat(R.keys(),m.keys())))R.get(O)!==m.get(O)&&h.push(O);return h}let w=class extends u.$Um{constructor(m,h,O){super(),this.j=m,this.k=h,this.l=O,this.c=this.B(new M.$rg(500));const y=A.Event.filter(h.onDidFilesChange,g=>g.affects(m));this.B(h.watch(m)),this.B(y(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const m=new Map;try{const h=await this.k.readFile(this.j),O=JSON.parse(h.value.toString());if(!(0,L.$ke)(O))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(O))this.f[y]&&m.set(y,O[y])}catch(h){h.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",h)}return m}async p(){const m=await this.n(),h=c(this.g,m);this.g=m,h.length>0&&this.h.fire(h)}};e.$64b=w,e.$64b=w=pe([se(1,N.$Qj),se(2,b.$Pi)],w)}),define(ne[130],re([0,1,38,8,171,2,6]),function(J,e,M,A,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$54b=void 0;let b=class extends M.$Um{constructor(c,w){super(),this.j=c,this.k=w,this.a=new A.$ng,this.b=this.B(new L.$mb)}async i(c){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(c).length} policy definitions`),await this.a.queue(()=>new Promise((w,R)=>{try{this.b.value=(0,D.createWatcher)(this.k,c,m=>{this.m(m),w()})}catch(m){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),R(m)}}))}m(c){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(c)}`);for(const w in c){const R=c[w];R===void 0?this.g.delete(w):this.g.set(w,R)}this.h.fire(Object.keys(c))}};e.$54b=b,e.$54b=b=pe([se(0,N.$Pi)],b)}),define(ne[31],re([0,1,10]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=void 0,e.$8i=(0,M.$nh)("productService"),e.$9i="vscode://schemas/vscode-product"}),define(ne[36],re([0,1,71,3]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;class D{constructor(){this.a=new Map}add(N,b){M.ok(A.$ie(N)),M.ok(A.$ke(b)),M.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,b)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$Rm=new D}),define(ne[131],re([0,1,4,36]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=void 0,e.$Sm={JSONContribution:"base.contributions.json"};function D(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class L{constructor(){this.b=new M.$7c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[D(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const N=new L;A.$Rm.add(e.$Sm.JSONContribution,N)}),define(ne[44],re([0,1,19,4,3,88,25,131,36]),function(J,e,M,A,D,L,N,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.ConfigurationScope=e.$Wm=e.EditPresentationTypes=void 0;var c;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$Wm={Configuration:"base.contributions.configuration"};var w;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(w||(e.ConfigurationScope=w={})),e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m="vscode://schemas/settings/resourceLanguage",e.$5m="vscode://schemas/settings/configurationDefaults";const R=u.$Rm.as(b.$Sm.JSONContribution);class m{constructor(){this.h=new Set,this.i=new A.$7c,this.onDidSchemaChange=this.i.event,this.j=new A.$7c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},R.registerSchema(e.$4m,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),R.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),R.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),R.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:s,source:n}of t)for(const o in s)if(a.add(o),e.$7m.test(o)){const l=this.a.get(o),P=l?.valuesSources??new Map;if(n)for(const B of Object.keys(s[o]))P.set(B,n);const E={...l?.value||{},...s[o]};this.a.set(o,{source:n,value:E,valuesSources:P});const S=(0,N.$4h)(o),j={type:"object",default:E,description:L.localize(1,null,S),$ref:e.$4m,defaultDefaultValue:E,source:D.$ie(n)?void 0:n,defaultValueSource:n};i.push(...y(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:s[o],source:n});const l=this.d[o];l&&(this.w(o,l),this.r(o,l))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:s}of t)for(const n in i){const o=this.a.get(n),l=D.$ie(s)?s:s?.id,P=D.$ie(o?.source)?o?.source:o?.source?.id;if(l===P)if(a.add(n),this.a.delete(n),e.$7m.test(n))delete this.d[n],delete this.b.properties[n];else{const E=this.d[n];E&&(this.w(n,E),this.r(n,E))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(s=>{this.p(s,a,s.extensionInfo,s.restrictedProperties,void 0,i),this.c.push(s),this.q(s)})}o(t,a){const i=s=>{if(s.properties)for(const n in s.properties){a.add(n);const o=this.d[n];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[n],this.s(n,s.properties[n])}s.allOf?.forEach(n=>i(n))};for(const s of t){i(s);const n=this.c.indexOf(s);n!==-1&&this.c.splice(n,1)}}p(t,a=!0,i,s,n=3,o){n=D.$re(t.scope)?n:t.scope;const l=t.properties;if(l)for(const E in l){const S=l[E];if(a&&I(E,S)){delete l[E];continue}if(S.source=i,S.defaultDefaultValue=l[E].default,this.w(E,S),e.$7m.test(E)?S.scope=void 0:(S.scope=D.$re(S.scope)?n:S.scope,S.restricted=D.$re(S.restricted)?!!s?.includes(E):S.restricted),l[E].hasOwnProperty("included")&&!l[E].included){this.f[E]=l[E],delete l[E];continue}else this.d[E]=l[E],l[E].policy?.name&&this.e.set(l[E].policy.name,E);!l[E].deprecationMessage&&l[E].markdownDeprecationMessage&&(l[E].deprecationMessage=l[E].markdownDeprecationMessage),o.add(E)}const P=t.allOf;if(P)for(const E of P)this.p(E,a,i,s,n,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const s=i.properties;if(s)for(const o in s)this.r(o,s[o]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.$Xm.properties[t]=a,a.scope){case 1:e.$Ym.properties[t]=a;break;case 2:e.$Zm.properties[t]=a;break;case 6:e.$1m.properties[t]=a;break;case 3:e.$2m.properties[t]=a;break;case 4:e.$3m.properties[t]=a;break;case 5:e.$3m.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.$Xm.properties[t],a.scope){case 1:delete e.$Ym.properties[t];break;case 2:delete e.$Zm.properties[t];break;case 6:delete e.$1m.properties[t];break;case 3:delete e.$2m.properties[t];break;case 4:case 5:delete e.$3m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$4m};this.w(a,i),e.$Xm.properties[a]=i,e.$Ym.properties[a]=i,e.$Zm.properties[a]=i,e.$1m.properties[a]=i,e.$2m.properties[a]=i,e.$3m.properties[a]=i}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$4m};e.$Xm.patternProperties[e.$6m]=t,e.$Ym.patternProperties[e.$6m]=t,e.$Zm.patternProperties[e.$6m]=t,e.$1m.patternProperties[e.$6m]=t,e.$2m.patternProperties[e.$6m]=t,e.$3m.patternProperties[e.$6m]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let s=i?.value,n=i?.source;D.$pe(s)&&(s=a.defaultDefaultValue,n=void 0),D.$pe(s)&&(s=d(a.type)),a.default=s,a.defaultValueSource=n}}const h="\\[([^\\]]+)\\]",O=new RegExp(h,"g");e.$6m=`^(${h})+$`,e.$7m=new RegExp(e.$6m);function y(v){const t=[];if(e.$7m.test(v)){let a=O.exec(v);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=O.exec(v)}}return(0,M.$qf)(t)}e.$8m=y;function g(v){return v.reduce((t,a)=>`${t}[${a}]`,"")}e.$9m=g;function d(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$0m=d;const f=new m;u.$Rm.add(e.$Wm.Configuration,f);function I(v,t){return v.trim()?e.$7m.test(v)?L.localize(7,null,v):f.getConfigurationProperties()[v]!==void 0?L.localize(8,null,v):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,v,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.$$m=I;function $(){const v=[],t=f.getConfigurationProperties();for(const a of Object.keys(t))v.push([a,t[a].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$_m=$}),define(ne[66],re([0,1,19,4,53,2,35,30,3,11,25,44,36]),function(J,e,M,A,D,L,N,b,u,c,w,R,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function h(a){return Object.isFrozen(a)?a:b.$Gm(a)}class O{constructor(i={},s=[],n=[],o){this.b=i,this.c=s,this.d=n,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(s=>{if(s instanceof O)return s;const n=new y("");return n.parseRaw(s),n.configurationModel});this.f=i.reduce((s,n)=>n===s?n:s.merge(n),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,w.$2h)(this.contents,i):this.contents}inspect(i,s){const n=this.rawConfiguration.getValue(i),o=s?this.rawConfiguration.getOverrideValue(i,s):void 0,l=s?this.rawConfiguration.override(s).getValue(i):n;return{value:n,override:o,merged:l}}getOverrideValue(i,s){const n=this.i(s);return n?i?(0,w.$2h)(n,i):n:void 0}getKeysForOverrideIdentifier(i){const s=[];for(const n of this.overrides)n.identifiers.includes(i)&&s.push(...n.keys);return M.$qf(s)}getAllOverrideIdentifiers(){const i=[];for(const s of this.overrides)i.push(...s.identifiers);return M.$qf(i)}override(i){let s=this.a.get(i);return s||(s=this.g(i),this.a.set(i,s)),s}merge(...i){const s=b.$Fm(this.contents),n=b.$Fm(this.overrides),o=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const P of i)if(l.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(s,P.contents);for(const E of P.overrides){const[S]=n.filter(j=>M.$af(j.identifiers,E.identifiers));S?(this.h(S.contents,E.contents),S.keys.push(...E.keys),S.keys=M.$qf(S.keys)):n.push(b.$Fm(E))}for(const E of P.keys)o.indexOf(E)===-1&&o.push(E)}return new O(s,o,n,l.every(P=>P instanceof O)?void 0:l)}g(i){const s=this.i(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const n={};for(const o of M.$qf([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[o];const P=s[o];P&&(typeof l=="object"&&typeof P=="object"?(l=b.$Fm(l),this.h(l,P)):l=P),n[o]=l}return new O(n,this.keys,this.overrides)}h(i,s){for(const n of Object.keys(s)){if(n in i&&u.$ke(i[n])&&u.$ke(s[n])){this.h(i[n],s[n]);continue}i[n]=b.$Fm(s[n])}}i(i){let s=null,n=null;const o=l=>{l&&(n?this.h(n,l):n=b.$Fm(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===i?s=l.contents:l.identifiers.includes(i)&&o(l.contents);return o(s),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,s){this.j(i,s,!0)}setValue(i,s){this.j(i,s,!1)}removeValue(i){const s=this.keys.indexOf(i);s!==-1&&(this.keys.splice(s,1),(0,w.$1h)(this.contents,i),R.$7m.test(i)&&this.overrides.splice(this.overrides.findIndex(n=>M.$af(n.identifiers,(0,R.$8m)(i))),1))}j(i,s,n){(0,w.$Zh)(this.contents,i,s,o=>console.error(o)),n=n||this.keys.indexOf(i)===-1,n&&this.keys.push(i),R.$7m.test(i)&&this.overrides.push({identifiers:(0,R.$8m)(i),keys:Object.keys(this.contents[i]),contents:(0,w.$Yh)(this.contents[i],o=>console.error(o))})}}e.$an=O;class y{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new O}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,s){if(!u.$re(i)){const n=this.g(i);this.parseRaw(n,s)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,s){this.a=i;const{contents:n,keys:o,overrides:l,restricted:P,hasExcludedProperties:E}=this.h(i,s);this.b=new O(n,o,l,E?[i]:void 0),this.c=P||[]}g(i){let s={},n=null,o=[];const l=[],P=[];function E(j){Array.isArray(o)?o.push(j):n!==null&&(o[n]=j)}const S={onObjectBegin:()=>{const j={};E(j),l.push(o),o=j,n=null},onObjectProperty:j=>{n=j},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const j=[];E(j),l.push(o),o=j,n=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:E,onError:(j,B,ee)=>{P.push({error:j,offset:B,length:ee})}};if(i)try{D.$Cm(i,S),s=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return s}h(i,s){const n=m.$Rm.as(R.$Wm.Configuration).getConfigurationProperties(),o=this.i(i,n,!0,s);i=o.raw;const l=(0,w.$Yh)(i,S=>console.error(`Conflict in settings file ${this.f}: ${S}`)),P=Object.keys(i),E=this.j(i,S=>console.error(`Conflict in settings file ${this.f}: ${S}`));return{contents:l,keys:P,overrides:E,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(i,s,n,o){let l=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:l};const P={},E=[];for(const S in i)if(R.$7m.test(S)&&n){const j=this.i(i[S],s,!1,o);P[S]=j.raw,l=l||j.hasExcludedProperties,E.push(...j.restricted)}else{const j=s[S],B=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&E.push(S),!o.exclude?.includes(S)&&(o.include?.includes(S)||(B===void 0||o.scopes===void 0||o.scopes.includes(B))&&!(o.skipRestricted&&j?.restricted))?P[S]=i[S]:l=!0}return{raw:P,restricted:E,hasExcludedProperties:l}}j(i,s){const n=[];for(const o of Object.keys(i))if(R.$7m.test(o)){const l={};for(const P in i[o])l[P]=i[o][P];n.push({identifiers:(0,R.$8m)(o),keys:Object.keys(l),contents:(0,w.$Yh)(l,s)})}return n}}e.$bn=y;class g extends L.$lb{constructor(i,s,n,o){super(),this.c=i,this.f=s,this.g=o,this.b=this.B(new A.$7c),this.onDidChange=this.b.event,this.a=new y(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(A.Event.any(A.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),A.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&n.isEqual(l.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new O}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$cn=g;class d{constructor(i,s,n,o,l,P,E,S,j,B,ee,Z,le){this.a=i,this.b=s,this.c=n,this.overrideIdentifiers=o,this.d=l,this.f=P,this.g=E,this.h=S,this.i=j,this.j=B,this.k=ee,this.l=Z,this.m=le}get value(){return h(this.c)}n(i,s,n){const o=i.inspect(s,n);return{get value(){return h(o.value)},get override(){return h(o.override)},get merged(){return h(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(i,s,n,o,l=new O,P=new O,E=new N.$li,S=new O,j=new N.$li){this.c=i,this.d=s,this.f=n,this.g=o,this.h=l,this.i=P,this.j=E,this.l=S,this.m=j,this.a=null,this.b=new N.$li,this.n=null}getValue(i,s,n){return this.q(i,s,n).getValue(i)}updateValue(i,s,n={}){let o;n.resource?(o=this.m.get(n.resource),o||(o=new O,this.m.set(n.resource,o))):o=this.l,s===void 0?o.removeValue(i):o.setValue(i,s),n.resource||(this.a=null)}inspect(i,s,n){const o=this.q(i,s,n),l=this.u(s.resource,n),P=s.resource?this.m.get(s.resource)||this.l:this.l,E=new Set;for(const S of o.overrides)for(const j of S.identifiers)o.getOverrideValue(i,j)!==void 0&&E.add(j);return new d(i,s,o.getValue(i),E.size?[...E]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,l||void 0,P)}keys(i){const s=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,s){this.j.set(i,s),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const n=[];if(!s){const{added:o,updated:l,removed:P}=v(this.c,i);s=[...o,...l,...P]}for(const o of s)for(const l of(0,R.$8m)(o)){const P=this.c.getKeysForOverrideIdentifier(l),E=i.getKeysForOverrideIdentifier(l),S=[...E.filter(j=>P.indexOf(j)===-1),...P.filter(j=>E.indexOf(j)===-1),...P.filter(j=>!b.$Jm(this.c.override(l).getValue(j),i.override(l).getValue(j)))];n.push([l,S])}return this.updateDefaultConfiguration(i),{keys:s,overrides:n}}compareAndUpdatePolicyConfiguration(i){const{added:s,updated:n,removed:o}=v(this.d,i),l=[...s,...n,...o];return l.length&&this.updatePolicyConfiguration(i),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:s,updated:n,removed:o,overrides:l}=v(this.applicationConfiguration,i),P=[...s,...n,...o];return P.length&&this.updateApplicationConfiguration(i),{keys:P,overrides:l}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:n,removed:o,overrides:l}=v(this.localUserConfiguration,i),P=[...s,...n,...o];return P.length&&this.updateLocalUserConfiguration(i),{keys:P,overrides:l}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:n,removed:o,overrides:l}=v(this.remoteUserConfiguration,i),P=[...s,...n,...o];return P.length&&this.updateRemoteUserConfiguration(i),{keys:P,overrides:l}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:n,removed:o,overrides:l}=v(this.workspaceConfiguration,i),P=[...s,...n,...o];return P.length&&this.updateWorkspaceConfiguration(i),{keys:P,overrides:l}}compareAndUpdateFolderConfiguration(i,s){const n=this.p.get(i),{added:o,updated:l,removed:P,overrides:E}=v(n,s),S=[...o,...l,...P];return(S.length||!n)&&this.updateFolderConfiguration(i,s),{keys:S,overrides:E}}compareAndDeleteFolderConfiguration(i){const s=this.p.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:n,updated:o,removed:l,overrides:P}=v(s,void 0);return{keys:[...n,...o,...l],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,s,n){let o=this.r(s,n);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(o=o.merge(this.d)),o}r({resource:i},s){let n=this.s();if(s&&i){const o=s.getFolder(i);o&&(n=this.t(o.uri)||n);const l=this.m.get(i);l&&(n=n.merge(l))}return n}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let s=this.b.get(i);if(!s){const n=this.s(),o=this.j.get(i);o?(s=n.merge(o),this.b.set(i,s)):s=n}return s}u(i,s){if(s&&i){const n=s.getFolder(i);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,s)=>{const{contents:n,overrides:o,keys:l}=this.j.get(s);return i.push([s,{contents:n,overrides:o,keys:l}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(s=>i.add(s)),this.userConfiguration.keys.forEach(s=>i.add(s)),this.i.keys.forEach(s=>i.add(s)),this.j.forEach(s=>s.keys.forEach(n=>i.add(n))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>i.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(n=>i.add(n))),[...i.values()]}w(i){const s=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.i.getKeysForOverrideIdentifier(i).forEach(n=>s.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o))),[...s.values()]}static parse(i){const s=this.x(i.defaults),n=this.x(i.policy),o=this.x(i.application),l=this.x(i.user),P=this.x(i.workspace),E=i.folders.reduce((S,j)=>(S.set(c.URI.revive(j[0]),this.x(j[1])),S),new N.$li);return new f(s,n,o,l,new O,P,E,new O,new N.$li)}static x(i){return new O(i.contents,i.keys,i.overrides)}}e.$dn=f;function I(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,s=new Map;for(const o of a)o.keys.forEach(l=>i.add(l)),o.overrides.forEach(([l,P])=>{const E=(0,N.$ii)(s,l,new Set);P.forEach(S=>E.add(S))});const n=[];return s.forEach((o,l)=>n.push([l,[...o.values()]])),{keys:[...i.values()],overrides:n}}e.$en=I;class ${constructor(i,s,n,o){this.change=i,this.f=s,this.g=n,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of i.keys)this.affectedKeys.add(l);for(const[,l]of i.overrides)for(const P of l)this.affectedKeys.add(P);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(i,s){const n=this.a+i,o=this.d.indexOf(n);if(o<0)return!1;const l=o+n.length;if(l>=this.d.length)return!1;const P=this.d.charCodeAt(l);if(P!==this.b&&P!==this.c)return!1;if(s){const E=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.f?.workspace):void 0,S=this.g.getValue(i,s,this.h);return!b.$Jm(E,S)}return!0}}e.$fn=$;function v(a,i){const{added:s,removed:n,updated:o}=t(i?.rawConfiguration,a?.rawConfiguration),l=[],P=a?.getAllOverrideIdentifiers()||[],E=i?.getAllOverrideIdentifiers()||[];if(i){const S=E.filter(j=>!P.includes(j));for(const j of S)l.push([j,i.getKeysForOverrideIdentifier(j)])}if(a){const S=P.filter(j=>!E.includes(j));for(const j of S)l.push([j,a.getKeysForOverrideIdentifier(j)])}if(i&&a){for(const S of P)if(E.includes(S)){const j=t({contents:a.getOverrideValue(void 0,S)||{},keys:a.getKeysForOverrideIdentifier(S)},{contents:i.getOverrideValue(void 0,S)||{},keys:i.getKeysForOverrideIdentifier(S)});l.push([S,[...j.added,...j.removed,...j.updated]])}}return{added:s,removed:n,updated:o,overrides:l}}function t(a,i){const s=a?i?a.keys.filter(l=>i.keys.indexOf(l)===-1):[...a.keys]:[],n=i?a?i.keys.filter(l=>a.keys.indexOf(l)===-1):[...i.keys]:[],o=[];if(a&&i){for(const l of i.keys)if(a.keys.indexOf(l)!==-1){const P=(0,w.$2h)(i.contents,l),E=(0,w.$2h)(a.contents,l);b.$Jm(P,E)||o.push(l)}}return{added:s,removed:n,updated:o}}}),define(ne[132],re([0,1,19,4,2,30,3,66,44,6,38,36]),function(J,e,M,A,D,L,N,b,u,c,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=void 0;class m extends D.$lb{constructor(){super(...arguments),this.a=this.B(new A.$7c),this.onDidChangeConfiguration=this.a.event,this.b=new b.$an}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(R.$Rm.as(u.$Wm.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:d})=>this.c(Array.from(g),d))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,d){this.h(g,R.$Rm.as(u.$Wm.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new b.$an;const g=R.$Rm.as(u.$Wm.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,d){const f=this.f();for(const I of g){const $=f[I],v=d[I];$!==void 0?this.b.addValue(I,$):v?this.b.addValue(I,v.default):this.b.removeValue(I)}}}e.$gn=m;class h{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new b.$an}async initialize(){return this.configurationModel}}e.$hn=h;let O=class extends D.$lb{get configurationModel(){return this.b}constructor(g,d,f){super(),this.c=g,this.f=d,this.g=f,this.a=this.B(new A.$7c),this.onDidChangeConfiguration=this.a.event,this.b=new b.$an}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.i(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.j(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const d={},f=[],I=R.$Rm.as(u.$Wm.Configuration).getConfigurationProperties();for(const $ of g){const v=I[$];if(!v){f.push($);continue}if(v.policy){if(v.type!=="string"&&v.type!=="number"){this.g.warn(`Policy ${v.policy.name} has unsupported type ${v.type}`);continue}f.push($),d[v.policy.name]={type:v.type}}}return(0,N.$ve)(d)||await this.f.updatePolicyDefinitions(d),f}i(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const d=R.$Rm.as(u.$Wm.Configuration).getPolicyConfigurations(),f=(0,M.$lf)(g.map(I=>d.get(I)));this.j(f,!0)}j(g,d){this.g.trace("PolicyConfiguration#update",g);const f=R.$Rm.as(u.$Wm.Configuration).getConfigurationProperties(),I=[],$=this.b.isEmpty();for(const v of g){const t=f[v]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);($?a!==void 0:!(0,L.$Jm)(this.b.getValue(v),a))&&I.push([v,a])}else this.b.getValue(v)!==void 0&&I.push([v,void 0])}if(I.length){this.g.trace("PolicyConfiguration#changed",I);const v=this.b;this.b=new b.$an;for(const t of v.keys)this.b.setValue(t,v.getValue(t));for(const[t,a]of I)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);d&&this.a.fire(this.b)}}};e.$in=O,e.$in=O=pe([se(1,w.$Tm),se(2,c.$Pi)],O)}),define(ne[133],re([0,1,8,4,2,17,25,66,132,38]),function(J,e,M,A,D,L,N,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class w extends D.$lb{constructor(m,h,O,y){super(),this.i=m,this.h=this.B(new A.$7c),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new u.$gn),this.c=O instanceof c.$Vm?new u.$hn:this.B(new u.$in(this.b,O,y)),this.f=this.B(new b.$cn(this.i,{},L.$Yf,h)),this.a=new b.$dn(this.b.configurationModel,this.c.configurationModel,new b.$an,new b.$an),this.g=this.B(new M.$Eg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:g,properties:d})=>this.k(g,d))),this.B(this.c.onDidChangeConfiguration(g=>this.l(g))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,h,O]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new b.$dn(m,h,new b.$an,O)}getConfigurationData(){return this.a.toData()}getValue(m,h){const O=typeof m=="string"?m:void 0,y=(0,N.$Uh)(m)?m:(0,N.$Uh)(h)?h:{};return this.a.getValue(O,y,void 0)}updateValue(m,h,O,y){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const h=this.a.toData(),O=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(O,h,2)}k(m,h){const O=this.a.toData(),y=this.a.compareAndUpdateDefaultConfiguration(m,h);this.m(y,O,7)}l(m){const h=this.a.toData(),O=this.a.compareAndUpdatePolicyConfiguration(m);this.m(O,h,7)}m(m,h,O){const y=new b.$fn(m,{data:h},this.a);y.source=O,y.sourceConfig=this.n(O),this.h.fire(y)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$jn=w}),define(ne[67],re([0,1,15]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=void 0;function A(c){return c.scheme===M.Schemas.vscodeRemote?c.authority:void 0}e.$zk=A;function D(c){if(!c)return;const w=c.indexOf("+");return w<0?c:c.substr(0,w)}e.$Ak=D;function L(c){return`/${c.quality??"oss"}-${c.commit??"dev"}`}e.$Bk=L;function N(c){const{host:w,port:R}=u(c);if(typeof R>"u")throw new Error("Remote authority doesn't contain a port!");return{host:w,port:R}}e.$Ck=N;function b(c,w){let{host:R,port:m}=u(c);return typeof m>"u"&&(m=w),{host:R,port:m}}e.$Dk=b;function u(c){const w=c.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(w)return{host:w[1],port:parseInt(w[2],10)};const R=c.match(/^(\[[0-9a-z:]+\])$/);if(R)return{host:R[1],port:void 0};const m=c.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:c,port:void 0}}}),define(ne[37],re([0,1,28,10,67]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.TargetPlatform=e.ExtensionType=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=void 0,e.$zl="extensions.user.cache",e.$Al="extensions.builtin.cache",e.$Bl="undefined_publisher",e.$Cl=["ui","workspace","web"];function L(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Dl=L,e.$El=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var N;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(N||(e.ExtensionType=N={}));var b;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class u{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,d){if(typeof g>"u"||g===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof g=="string"||typeof d=="string"){const f=typeof g=="string"?g:g.value,I=typeof d=="string"?d:d.value;return M.$Ld(f,I)}return g._lower===d._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Fl=u;class c{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const d of g)this.add(d)}add(g){this.c.add(u.toKey(g))}delete(g){return this.c.delete(u.toKey(g))}has(g){return this.c.has(u.toKey(g))}}e.$Gl=c;class w{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(u.toKey(g))}get(g){return this.c.get(u.toKey(g))}has(g){return this.c.has(u.toKey(g))}set(g,d){this.c.set(u.toKey(g),d)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Hl=w;function R(y){return m(y)}e.$Il=R;function m(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.$Jl=m;function h(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.$Kl=h;function O(y,g){if(g){const d=`onResolveRemoteAuthority:${(0,D.$Ak)(g)}`;return!!y.activationEvents?.includes(d)}return!1}e.$Ll=O,e.$Ml=(0,A.$nh)("IBuiltinExtensionsScannerService")}),define(ne[134],re([0,1,2,37,13]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=void 0;class L extends M.$lb{constructor(b,u,c,w,R){super(),this.a=b,this.b=u,this.c=c,this.f=R,this.B(w.onDidInstallExtensions(m=>this.g(m))),this.B(w.onDidUninstallExtension(m=>this.h(m)))}g(b){for(const u of b)u.local&&this.invalidate(u.profileLocation)}h(b){b.error||this.invalidate(b.profileLocation)}async invalidate(b){if(b)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,b)&&await this.i(u);else await this.i(this.a.defaultProfile)}async i(b){try{await this.b.del(this.c.extUri.joinPath(b.cacheHome,A.$zl))}catch(u){(0,D.$7j)(u)!==1&&this.f.error(u)}}}e.$jp=L}),define(ne[45],re([0,1,14,9,2,103,44,10,6,36]),function(J,e,M,A,D,L,N,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$wo=(0,b.$nh)("requestService");class w{constructor(v){this.b=v}toJSON(){if(!this.a){const v=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?v[t]="*****":v[t]=this.b[t];this.a=v}return this.a}}class R extends D.$lb{constructor(v){super(),this.b=0,this.a=v.createLogger("network",{name:(0,L.localize)(0,null),when:u.$7i.isEqualTo((0,u.$5i)(u.LogLevel.Trace)).serialize()})}async c(v,t,a){const i=`${v} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new w(t.headers??{}));try{const s=await a();return this.a.trace(`${i} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${i} - error`,t.type,(0,A.$9)(s)),s}}}e.$xo=R;function m($){return $.res.statusCode&&$.res.statusCode>=200&&$.res.statusCode<300||$.res.statusCode===1223}e.$yo=m;function h($){return $.res.statusCode===204}async function O($){return h($)?null:(await(0,M.$Vb)($.stream)).toString()}e.$zo=O;async function y($){if(!m($))throw new Error("Server returned "+$.res.statusCode);return O($)}e.$Ao=y;async function g($){if(!m($))throw new Error("Server returned "+$.res.statusCode);if(h($))return null;const t=(await(0,M.$Vb)($.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.$Bo=g;function d($){I($)}e.$Co=d;let f;function I($){const v=c.$Rm.as(N.$Wm.Configuration),t=f;f={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:$,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0}}},v.updateConfigurations({add:[f],remove:t?[t]:[]})}I(1)}),define(ne[135],re([0,1,20,15,13,45]),function(J,e,M,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0;let N=class{constructor(u,c){this.a=u,this.b=c}async download(u,c,w=M.CancellationToken.None){if(u.scheme===A.Schemas.file||u.scheme===A.Schemas.vscodeRemote){await this.b.copy(u,c);return}const R={type:"GET",url:u.toString(!0)},m=await this.a.request(R,w);if(m.res.statusCode===200)await this.b.writeFile(c,m.stream);else{const h=await(0,L.$Ao)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${h}`)}}};e.$_M=N,e.$_M=N=pe([se(0,L.$wo),se(1,D.$Qj)],N)}),define(ne[136],re([0,1,137,3]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;function D(N,b){return N.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:N.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function L(N,b,u={}){const c=(0,M.parse)(N),w=u.proxyUrl||D(c,b);if(!w)return null;const R=(0,M.parse)(w);if(!/^https?:$/.test(R.protocol||""))return null;const m={host:R.hostname||"",port:R.port||(R.protocol==="https"?"443":"80"),auth:R.auth,rejectUnauthorized:(0,A.$oe)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((h,O)=>{J(["http-proxy-agent"],h,O)}))(m):new(await new Promise((h,O)=>{J(["https-proxy-agent"],h,O)}))(m)}e.$Aq=L}),define(ne[138],re([0,1,58,16,104,20,33,9,12,29,84,172,8,72]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wl=void 0;let O;async function y(d,f,I,$){return I["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,R.$ql)($)&&!I["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,R.$ql)($)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),O||(O=m.Promises.withAsyncBody(async(v,t)=>{const a=new L.$dd;let i=1e4;const s=d.getValue("application.shellEnvironmentResolutionTimeout");typeof s=="number"&&(i=(0,h.$rl)(s,1,120)*1e3);const n=setTimeout(()=>{a.dispose(!0),t(new Error((0,D.localize)(0,null)))},i);try{v(await g(f,a.token))}catch(o){!(0,b.$2)(o)&&!a.token.isCancellationRequested?t(new Error((0,D.localize)(1,null,(0,N.$$h)(o)))):v({})}finally{clearTimeout(n),a.dispose()}})),O)}e.$wl=y;async function g(d,f){const I=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",I);const $=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",$);const v=(0,c.$5e)().replace(/-/g,"").substr(0,12),t=new RegExp(v+"({.*})"+v),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};d.trace("getUnixShellEnvironment#env",a);const i=await(0,w.$hl)(u.OS,a);return d.trace("getUnixShellEnvironment#shell",i),new Promise((s,n)=>{if(f.isCancellationRequested)return n(new b.$3);const o=(0,A.$ec)(i);let l,P;const E=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(l=`& '${process.execPath}' ${E} -p '''${v}'' + JSON.stringify(process.env) + ''${v}'''`,P=["-Login","-Command"]):o==="nu"?(l=`^'${process.execPath}' ${E} -p '"${v}" + JSON.stringify(process.env) + "${v}"'`,P=["-i","-l","-c"]):(l=`'${process.execPath}' ${E} -p '"${v}" + JSON.stringify(process.env) + "${v}"'`,o==="tcsh"||o==="csh"?P=["-ic"]:P=["-i","-l","-c"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),l);const S=(0,M.spawn)(i,[...P,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});f.onCancellationRequested(()=>(S.kill(),n(new b.$3))),S.on("error",ee=>{d.error("getUnixShellEnvironment#errorChildProcess",(0,N.$$h)(ee)),n(ee)});const j=[];S.stdout.on("data",ee=>j.push(ee));const B=[];S.stderr.on("data",ee=>B.push(ee)),S.on("close",(ee,Z)=>{const le=Buffer.concat(j).toString("utf8");d.trace("getUnixShellEnvironment#raw",le);const _=Buffer.concat(B).toString("utf8");if(_.trim()&&d.trace("getUnixShellEnvironment#stderr",_),ee||Z)return n(new Error((0,D.localize)(2,null,ee,Z)));const ae=t.exec(le),ce=ae?ae[1]:"{}";try{const te=JSON.parse(ce);I?te.ELECTRON_RUN_AS_NODE=I:delete te.ELECTRON_RUN_AS_NODE,$?te.ELECTRON_NO_ATTACH_CONSOLE=$:delete te.ELECTRON_NO_ATTACH_CONSOLE,delete te.VSCODE_RESOLVING_ENVIRONMENT,delete te.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",te),s(te)}catch(te){d.error("getUnixShellEnvironment#errorCaught",(0,N.$$h)(te)),n(te)}})})}}),define(ne[139],re([0,1,10]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OM=e.$NM=void 0,e.$NM=(0,M.$nh)("stateReadService"),e.$OM=(0,M.$nh)("stateService")}),define(ne[68],re([0,1,8,14,3,18,13,6]),function(J,e,M,A,D,L,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RM=e.$QM=e.$PM=e.SaveStrategy=void 0;var u;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(u||(e.SaveStrategy=u={}));class c{constructor(h,O,y,g){this.f=h,this.g=y,this.h=g,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=O===0?void 0:new M.$rg(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(h){h.fileOperationResult!==1&&this.g.error(h)}}getItem(h,O){const y=this.a[h];return(0,D.$re)(y)?O:y}setItem(h,O){this.setItems([{key:h,data:O}])}setItems(h){let O=!1;for(const{key:y,data:g}of h)this.a[y]!==g&&((0,D.$re)(g)?(0,D.$pe)(this.a[y])||(this.a[y]=void 0,O=!0):(this.a[y]=g,O=!0));O&&this.j()}removeItem(h){(0,D.$pe)(this.a[h])||(this.a[h]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const h=JSON.stringify(this.a,null,4);if(h!==this.b)try{await this.h.writeFile(this.f,A.$Jb.fromString(h),{atomic:{postfix:".vsctmp"}}),this.b=h}catch(O){this.g.error(O)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.$PM=c;let w=class{constructor(h,O,y,g){this.a=new c(O.stateResource,h,y,g)}async init(){await this.a.init()}getItem(h,O){return this.a.getItem(h,O)}};e.$QM=w,e.$QM=w=pe([se(1,L.$uh),se(2,b.$Pi),se(3,N.$Qj)],w);class R extends w{setItem(h,O){this.a.setItem(h,O)}setItems(h){this.a.setItems(h)}removeItem(h){this.a.removeItem(h)}close(){return this.a.close()}}e.$RM=R}),define(ne[69],re([0,1,12,34,29]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=void 0;function L(u){if(M.$t===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function N(u,c,w,R,m,h,O,y){const g=Object.create(null);g["common.machineId"]=h,g.sessionID=(0,D.$5e)()+Date.now(),g.commitHash=R,g.version=m,g["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,M.$h)(M.$t),g["common.nodePlatform"]=A.$7b,g["common.nodeArch"]=w,g["common.product"]=y||"desktop",O&&(g["common.msftInternal"]=O);let d=0;const f=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-f,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),M.$l&&(g["common.snap"]="true");const I=L(c);return I&&(g["common.platformDetail"]=I),g}e.$Xn=N;function b(u){const c=A.env.USERDNSDOMAIN;if(!c)return!1;const w=c.toLowerCase();return u.some(R=>w===R)}e.$Yn=b}),define(ne[26],re([0,1,10]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=void 0,e.$Tk=(0,M.$nh)("telemetryService"),e.$Uk=(0,M.$nh)("customEndpointTelemetryService"),e.$Vk="telemetry.currentSessionDate",e.$Wk="telemetry.firstSessionDate",e.$Xk="telemetry.lastSessionDate",e.$Yk="telemetry.machineId",e.$Zk="telemetry",e.$1k="telemetry.telemetryLevel",e.$2k="telemetry.enableCrashReporter",e.$3k="telemetry.enableTelemetry";var A;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(A||(e.TelemetryLevel=A={}));var D;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(ne[39],re([0,1,30,3,4,25,67,69,26]),function(J,e,M,A,D,L,N,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=void 0;class c{constructor(n){this.value=n,this.isTrustedTelemetryValue=!0}}e.$Zn=c;class w{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$1n=w,e.$2n=new w;class R{async publicLog(n,o,l){}async publicLogError(n,o,l){}}e.$3n=R,e.$4n="telemetry",e.$5n="extensionTelemetryLog",e.$6n={log:()=>null,flush:()=>Promise.resolve(null)};function m(s,n){return D.Event.debounce(n.onDidChangeConfiguration,(l,P)=>{const E=l?new Set([...l.affectedKeys,...P.affectedKeys]):P.affectedKeys;return{...P,affectedKeys:E}},1e3,!0)(l=>{l.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,L.$Wh)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$7n=m;function h(s,n){return!n.isBuilt&&!n.disableTelemetry?!0:!(n.disableTelemetry||!s.enableTelemetry||n.extensionTestsLocationURI)}e.$8n=h;function O(s,n){return!(n.isBuilt||n.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$9n=O;function y(s){const n=s.getValue(u.$1k),o=s.getValue(u.$2k);if(s.getValue(u.$3k)===!1||o===!1)return 0;switch(n??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$0n=y;function g(s){const n={},o={},l={};I(s,l);for(let P in l){P=P.length>150?P.substr(P.length-149):P;const E=l[P];typeof E=="number"?o[P]=E:typeof E=="boolean"?o[P]=E?1:0:typeof E=="string"?(E.length>8192&&console.warn(`Telemetry property: ${P} has been trimmed to 8192, the original length is ${E.length}`),n[P]=E.substring(0,8191)):typeof E<"u"&&E!==null&&(n[P]=E)}return{properties:n,measurements:o}}e.$$n=g;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function f(s){if(!s)return"none";const n=(0,N.$Ak)(s);return d.has(n)?n:"other"}e.$_n=f;function I(s,n,o=0,l){if(s)for(const P of Object.getOwnPropertyNames(s)){const E=s[P],S=l?l+P:P;Array.isArray(E)?n[S]=(0,M.$Km)(E):E instanceof Date?n[S]=E.toISOString():(0,A.$ke)(E)?o<2?I(E,n,o+1,S+"."):n[S]=(0,M.$Km)(E):n[S]=E}}function $(s,n){const o=s.msftInternalDomains||[],l=n.getValue("telemetry.internalTesting");return(0,b.$Yn)(o)||l}e.$ao=$;function v(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$bo=v;function t(s,n){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let o=s;const l=[];for(const j of n)for(;;){const B=j.exec(s);if(!B)break;l.push([B.index,j.lastIndex])}const P=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,E=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let S=0;for(o="";;){const j=E.exec(s);if(!j)break;const B=l.some(([ee,Z])=>j.index<Z&&ee<E.lastIndex);!P.test(j[0])&&!B&&(o+=s.substring(S,j.index)+"<REDACTED: user-file-path>",S=E.lastIndex)}return S<s.length&&(o+=s.substr(S)),o}function a(s){if(!s)return s;const n=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of n)if(o.regex.test(s))return`<REDACTED: ${o.label}>`;return s}function i(s,n){return(0,M.$Hm)(s,o=>{if(o instanceof c||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let l=o.replaceAll("%20"," ");l=t(l,n);for(const P of n)l=l.replace(P,"");return l=a(l),l}})}e.$co=i}),define(ne[27],re([0,1,28,21,37,12,11,9,34,39]),function(J,e,M,A,D,L,N,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=void 0;function w(i,s){return i.uuid&&s.uuid?i.uuid===s.uuid:i.id===s.id?!0:(0,M.$Gd)(i.id,s.id)===0}e.$do=w;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const n=s.manifest?s.manifest.version:s.version,o=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,n,o)}static parse(s){const n=R.exec(s);return n&&n[1]&&n[2]?new m({id:n[1]},n[2],n[4]||void 0):null}constructor(s,n,o="undefined"){this.version=n,this.targetPlatform=o,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?w(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$eo=m;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function O(i){const s=h.exec(i);return s&&s[1]?[g(s[1]),s[2]]:[g(i),void 0]}e.$fo=O;function y(i,s){return`${i}.${s}`}e.$go=y;function g(i){return i.toLowerCase()}e.$ho=g;function d(i,s){return g(y(i??D.$Bl,s))}e.$io=d;function f(i,s){const n=[],o=l=>{for(const P of n)if(P.some(E=>w(s(E),s(l))))return P;return null};for(const l of i){const P=o(l);P?P.push(l):n.push([l])}return n}e.$jo=f;function I(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.$ko=I;function $(i){return{id:new c.$Zn(i.identifier.id),name:new c.$Zn(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$lo=$,e.$mo=new D.$Fl("pprice.better-merge");function v(i,s){const n=[],o=s.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&n.every(P=>!w(P.identifier,{id:l}))){const P=i.filter(E=>w(E.identifier,{id:l}));P.length===1&&(n.push(P[0]),o.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$no=v;async function t(i,s){if(!L.$k)return!1;let n;try{n=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){s.debug("Error while getting the os-release file.",(0,b.$9)(l))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,s){const n=await t(i,s),o=(0,A.$In)(n?"alpine":L.$t,u.$8b);return s.debug("ComputeTargetPlatform:",o),o}e.$oo=a}),define(ne[140],re([0,1,20,9,15,17,43,11,93,21,27,37]),function(J,e,M,A,D,L,N,b,u,c,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vo=void 0;const m=g=>(0,u.localize)(0,null,g),h=(0,u.localize)(1,null,"ms-dotnettools.csharp");function O(g,d){return d?`${g.publisher}.${g.name}@${g.version}`:`${g.publisher}.${g.name}`}let y=class{constructor(d,f,I){this.a=d,this.b=f,this.d=I}get f(){}async listExtensions(d,f,I){let $=await this.b.getInstalled(1,I);const v=R.$El.map(a=>a.toLowerCase());if(f&&f!==""){if(v.indexOf(f.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(a=>a.manifest.categories?a.manifest.categories.map(s=>s.toLowerCase()).indexOf(f.toLowerCase())>-1:!1)}else if(f===""){this.a.info("Possible Categories: "),v.forEach(a=>{this.a.info(a)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),$=$.sort((a,i)=>a.identifier.id.localeCompare(i.identifier.id));let t;for(const a of $)t!==a.identifier.id&&(t=a.identifier.id,this.a.info(O(a.manifest,d)))}async installExtensions(d,f,I,$){const v=[];try{const t=[];d.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const a=[];let i=[];const s=(o,l,P)=>{i.push({id:o,version:l!=="prerelease"?l:void 0,installOptions:{...I,isBuiltin:P,installPreReleaseVersion:l==="prerelease"||I.installPreReleaseVersion}})};for(const o of d)if(o instanceof b.URI)a.push({vsix:o,installOptions:I});else{const[l,P]=(0,w.$fo)(o);s(l,P,!1)}for(const o of f)if(o instanceof b.URI)a.push({vsix:o,installOptions:{...I,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[l,P]=(0,w.$fo)(o);s(l,P,!0)}const n=await this.b.getInstalled(1,I.profileLocation);if(a.length&&await Promise.all(a.map(async({vsix:o,installOptions:l})=>{try{const P=await this.g(o,l,$,n);P&&t.push(P)}catch(P){this.a.error(P),v.push(o.toString())}})),i.length&&(i=i.filter(({id:o,version:l})=>{const P=n.find(E=>(0,w.$do)(E.identifier,{id:o}));if(P){if(!$&&(!l||l==="prerelease"&&P.preRelease))return this.a.info((0,u.localize)(5,null,o,P.manifest.version,o)),!1;if(l&&P.manifest.version===l)return this.a.info((0,u.localize)(6,null,`${o}@${l}`)),!1}return!0}),i.length)){const o=await this.h(i);await Promise.all(i.map(async l=>{const P=o.get(l.id.toLowerCase());if(P)try{const E=await this.j(l,P,n);E&&t.push(E)}catch(E){this.a.error(E.message||E.stack||E),v.push(l.id)}else this.a.error(`${m(l.version?`${l.id}@${l.version}`:l.id)}
${h}`),v.push(l.id)}))}}catch(t){throw this.a.error((0,u.localize)(7,null,(0,A.$9)(t))),t}if(v.length)throw new Error((0,u.localize)(8,null,v.join(", ")))}async g(d,f,I,$){const v=await this.b.getManifest(d);if(!v)throw new Error("Invalid vsix");if(await this.l(v,I,f.profileLocation,$))try{return await this.b.install(d,f),this.a.info((0,u.localize)(9,null,(0,L.$5f)(d))),v}catch(a){if((0,A.$2)(a))return this.a.info((0,u.localize)(10,null,(0,L.$5f)(d))),null;throw a}return null}async h(d){const f=new Map,I=d.some(t=>t.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),v=[];for(const t of d)c.$Cn.test(t.id)&&v.push({...t,preRelease:I});if(v.length){const t=await this.d.getExtensions(v,{targetPlatform:$},M.CancellationToken.None);for(const a of t)f.set(a.identifier.id.toLowerCase(),a)}return f}async j({id:d,version:f,installOptions:I},$,v){const t=await this.d.getManifest($,M.CancellationToken.None);if(t&&!this.k(t))return null;const a=v.find(i=>(0,w.$do)(i.identifier,$.identifier));if(a){if($.version===a.manifest.version)return this.a.info((0,u.localize)(11,null,f?`${d}@${f}`:d)),null;this.a.info((0,u.localize)(12,null,d,$.version))}try{I.isBuiltin?this.a.info(f?(0,u.localize)(13,null,d,f):(0,u.localize)(14,null,d)):this.a.info(f?(0,u.localize)(15,null,d,f):(0,u.localize)(16,null,d));const i=await this.b.installFromGallery($,{...I,installGivenVersion:!!f});return this.a.info((0,u.localize)(17,null,d,i.manifest.version)),t}catch(i){if((0,A.$2)(i))return this.a.info((0,u.localize)(18,null,d)),null;throw i}}k(d){return!0}async l(d,f,I,$){if(!f){const v={id:(0,w.$io)(d.publisher,d.name)},t=$.find(a=>(0,w.$do)(v,a.identifier)&&(0,N.gt)(a.manifest.version,d.version));if(t)return this.a.info((0,u.localize)(19,null,t.identifier.id,t.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,f,I){const $=async t=>{if(t instanceof b.URI){const a=await this.b.getManifest(t);return O(a)}return t},v=[];for(const t of d){const a=await $(t),s=(await this.b.getInstalled(void 0,I)).filter(n=>(0,w.$do)(n.identifier,{id:a}));if(!s.length)throw new Error(`${this.m(a)}
${h}`);if(s.some(n=>n.type===0)){this.a.info((0,u.localize)(20,null,a));return}if(!f&&s.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(21,null,a));return}this.a.info((0,u.localize)(22,null,a));for(const n of s)await this.b.uninstall(n,{profileLocation:I}),v.push(n);this.f?this.a.info((0,u.localize)(23,null,a,this.f)):this.a.info((0,u.localize)(24,null,a))}}async locateExtension(d){const f=await this.b.getInstalled();d.forEach(I=>{f.forEach($=>{if($.identifier.id===I&&$.location.scheme===D.Schemas.file){this.a.info($.location.fsPath);return}})})}m(d){return this.f?(0,u.localize)(25,null,d,this.f):(0,u.localize)(26,null,d)}};e.$Vo=y,e.$Vo=y=pe([se(1,c.$Pn),se(2,c.$Nn)],y)}),define(ne[141],re([0,1,4,2,35,27,37]),function(J,e,M,A,D,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;class b extends A.$lb{constructor(c,w,R,m,h,O,y){super(),this.f=c,this.g=w,this.h=R,this.i=m,this.j=h,this.k=O,this.l=y,this.a=this.B(new M.$7c),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.$tb),this.m().then(null,g=>y.error(g))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(c=>this.p(c.added))),this.B(this.i.onAddExtensions(c=>this.r(c))),this.B(this.i.onDidAddExtensions(c=>this.s(c))),this.B(this.i.onRemoveExtensions(c=>this.t(c))),this.B(this.i.onDidRemoveExtensions(c=>this.u(c))),this.B(this.k.onDidFilesChange(c=>this.v(c)))}async p(c){try{c.length&&await Promise.all(c.map(w=>(this.c.set(w.id,(0,A.$ib)(this.k.watch(this.j.extUri.dirname(w.extensionsResource)),this.k.watch(w.extensionsResource))),this.y(w.extensionsResource))))}catch(w){throw this.l.error(w),w}}async r(c){for(const w of c.extensions)this.C(this.F(w.identifier,w.version),c.profileLocation)}async s(c){for(const w of c.extensions){const R=this.F(w.identifier,w.version);c.error?this.D(R,c.profileLocation):this.C(R,c.profileLocation)}}async t(c){for(const w of c.extensions)this.D(this.F(w.identifier,w.version),c.profileLocation)}async u(c){const w=[],R=[];for(const m of c.extensions){const h=this.F(m.identifier,m.version);c.error?this.C(h,c.profileLocation):(this.D(h,c.profileLocation),this.b.has(h)||(this.l.debug("Extension is removed from all profiles",m.identifier.id,m.version),R.push(this.f.scanInstalledExtensionAtLocation(m.location).then(O=>{O?w.push(O):this.l.info("Extension not found at the location",m.location.toString())},O=>this.l.error(O)))))}try{await Promise.all(R),w.length&&await this.z(w)}catch(m){this.l.error(m)}}v(c){for(const w of this.h.profiles)c.contains(w.extensionsResource,0,1)&&this.w(w.extensionsResource)}async w(c){const w=[],R=[],m=await this.i.scanProfileExtensions(c),h=new Set,O=new Set;for(const[y,g]of this.b)g.has(c)&&O.add(y);for(const y of m){const g=this.F(y.identifier,y.version);h.add(g),O.has(g)||(w.push(y.identifier),this.C(g,c))}for(const y of O)if(!h.has(y)){const g=this.G(y);g&&(R.push(g.identifier),this.D(y,c))}(w.length||R.length)&&this.a.fire({added:w.length?{extensions:w,profileLocation:c}:void 0,removed:R.length?{extensions:R,profileLocation:c}:void 0})}async y(c){const w=await this.i.scanProfileExtensions(c);for(const R of w)this.C(this.F(R.identifier,R.version),c)}async z(c){c||(c=(await this.f.scanAllUserInstalledExtensions()).filter(R=>!this.b.has(this.F(R.identifier,R.manifest.version)))),c.length&&await this.f.markAsUninstalled(...c)}C(c,w){let R=this.b.get(c);R||this.b.set(c,R=new D.$mi(m=>this.j.extUri.getComparisonKey(m))),R.add(w)}D(c,w){const R=this.b.get(c);R&&R.delete(w),R?.size||this.b.delete(c)}F(c,w){return`${N.$Fl.toKey(c.id)}@${w}`}G(c){const[w,R]=(0,L.$fo)(c);return R?{identifier:{id:w},version:R}:void 0}}e.$kp=b}),define(ne[142],re([0,1,113,39]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=void 0;async function D(L,N,b,u,c,w,R){const m={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${N.nameShort})`};if((0,A.$8n)(N,b)&&(0,A.$0n)(u)===3){const h=await(0,M.$Oo)(b,c,w);m["X-Market-User-Id"]=h,m["VSCode-SessionId"]=R.machineId||h}return m}e.$Po=D}),define(ne[143],re([0,1,173,19,8,2,15,16,24,18,21,27,6,64,11]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=void 0;let y=class extends h.$wq{constructor(I,$,v,t){super(v),this.h=I,this.i=t,this.g=this.B(new g($,t)),this.h.registerParticipant({postInstall:async a=>this.j(a),postUninstall:async a=>this.k(a)})}async getBuiltInExtensionTranslationsUri(I,$){const t=(await this.g.getLanguagePacks())[$];if(!t){this.i.warn(`No language pack found for ${$}`);return}const a=t.translations[I];return a?O.URI.file(a):void 0}async getInstalledLanguages(){const I=await this.g.getLanguagePacks(),$=Object.keys(I).map(v=>{const t=I[v];return{...this.f(v,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return $.push(this.f("en","English")),$.sort((v,t)=>v.label.localeCompare(t.label)),$}async j(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",I.identifier.id),await this.update())}async k(I){const $=await this.g.getLanguagePacks();Object.keys($).some(v=>$[v]&&$[v].extensions.some(t=>(0,R.$do)(t.extensionIdentifier,I.identifier)))&&(this.i.info("Removing language packs from the extension",I.identifier.id),await this.update())}async update(){const[I,$]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),v=await this.g.update($);return!(0,A.$af)(Object.keys(I),Object.keys(v))}};e.$xq=y,e.$xq=y=pe([se(0,w.$Pn),se(1,c.$vh),se(2,w.$Nn),se(3,m.$Pi)],y);let g=class extends L.$lb{constructor(I,$){super(),this.i=$,this.c={},this.f=(0,b.$ac)(I.userDataPath,"languagepacks.json"),this.g=new D.$Ag}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(I){return this.m($=>{Object.keys($).forEach(v=>delete $[v]),this.j($,...I)}).then(()=>this.c)}j(I,...$){for(const v of $)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.k(I,v);Object.keys(I).forEach(v=>this.l(I[v]))}k(I,$){const v=$.identifier,t=$.manifest.contributes&&$.manifest.contributes.localizations?$.manifest.contributes.localizations:[];for(const a of t)if($.location.scheme===N.Schemas.file&&d(a)){let i=I[a.languageId];i||(i={hash:"",extensions:[],translations:{},label:a.localizedLanguageName??a.languageName},I[a.languageId]=i);const s=i.extensions.filter(n=>(0,R.$do)(n.extensionIdentifier,v))[0];s?s.version=$.manifest.version:i.extensions.push({extensionIdentifier:v,version:$.manifest.version});for(const n of a.translations)i.translations[n.id]=(0,b.$ac)($.location.fsPath,n.path)}}l(I){if(I){const $=(0,M.createHash)("md5");for(const v of I.extensions)$.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);I.hash=$.digest("hex")}}m(I=()=>null){return this.g.queue(()=>{let $=null;return u.Promises.readFile(this.f,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch{return{}}}).then(v=>($=I(v),v)).then(v=>{for(const a of Object.keys(v))v[a]||delete v[a];this.c=v,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),u.Promises.writeFile(this.f,t)}).then(()=>$,v=>this.i.error(v))})}};g=pe([se(0,c.$vh),se(1,m.$Pi)],g);function d(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const I of f.translations)if(typeof I.id!="string"||typeof I.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(ne[144],re([0,1,82,9,30,39]),function(J,e,M,A,D,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",b="https://mobile.events.data.microsoft.com/ping";async function u(w,R,m){const h=await(0,M.$UC)("@microsoft/1ds-core-js","dist/ms.core.js"),O=await(0,M.$UC)("@microsoft/1ds-post-js","dist/ms.post.js"),y=new h.AppInsightsCore,g=new O.PostChannel,d={instrumentationKey:w,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(m){d.extensionConfig={};const f={alwaysUseXhrOverride:!0,httpXHROverride:m};d.extensionConfig[g.identifier]=f}return y.initialize(d,[]),y}class c{constructor(R,m,h,O,y){this.e=R,this.f=m,this.g=h,this.h=y,this.c=N,this.d=b,this.g||(this.g={}),typeof O=="function"?this.a=O():this.a=O,this.b=null}i(R){if(this.a){if(typeof this.a!="string"){R(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(m=>{R(m)},m=>{(0,A.$Y)(m),console.error(m)})}}log(R,m){if(!this.a)return;m=(0,D.$Im)(m,this.g),m=(0,L.$$n)(m);const h=this.f+"/"+R;try{this.i(O=>{O.pluginVersionString=m?.properties.version??"Unknown",O.track({name:h,baseData:{name:h,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(R=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,R(void 0)})})}):Promise.resolve(void 0)}}e.$JM=c}),define(ne[145],re([0,1,2,30,12,28,105,25,44,146,31,36,26,39]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;let O=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(d,f,I){this.k=f,this.l=I,this.d={},this.i=new M.$kb,this.j=[],this.b=d.appenders,this.c=d.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=d.piiPaths||[],this.g=3,this.h=!!d.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const $ of this.f)this.j.push(new RegExp((0,L.$nd)($),"gi")),$.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$nd)($.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration($=>{($.affectsConfiguration(m.$1k)||$.affectsConfiguration(m.$3k)||$.affectsConfiguration(m.$2k))&&this.m()}))}setExperimentProperty(d,f){this.d[d]=f}m(){let d=(0,h.$0n)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const I=f.usage?3:f.error?2:0;d=Math.min(d,I)}this.g=d}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(d,f,I){this.g<f||(I=(0,A.$Im)(I,this.d),I=(0,h.$co)(I,this.j),I=(0,A.$Im)(I,this.c),this.b.forEach($=>$.log(d,I)))}publicLog(d,f){this.n(d,3,f)}publicLog2(d,f){this.publicLog(d,f)}publicLogError(d,f){this.h&&this.n(d,2,f)}publicLogError2(d,f){this.publicLogError(d,f)}};e.$Dq=O,e.$Dq=O=pe([se(1,b.$Th),se(2,w.$8i)],O);function y(){const g=(0,N.localize)(0,null,c.default.nameLong),d=c.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=D.$o?"":(0,N.localize)(3,null),I=(0,N.localize)(4,null),$=(0,N.localize)(5,null),v=(0,N.localize)(6,null),t=(0,N.localize)(7,null),a=`
|       | ${I} | ${$} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${g} ${d} ${f}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}R.$Rm.as(u.$Wm.Configuration).registerConfiguration({id:m.$Zk,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[m.$1k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),R.$Rm.as(u.$Wm.Configuration).registerConfiguration({id:m.$Zk,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[m.$3k]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,N.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,N.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${m.$1k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[147],re([0,1,14,20,144]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=void 0;async function L(u,c){const w=await c.request(u,A.CancellationToken.None),R=(await(0,M.$Vb)(w.stream)).toString(),m=w.res.statusCode??200;return{headers:w.res.headers,statusCode:m,responseData:R}}function N(u,c){const w={method:u.type,headers:u.headers},R=c.request(u.url??"",w,m=>{m.on("data",function(h){return{headers:m.headers,statusCode:m.statusCode??200,responseData:h.toString()}}),m.on("error",function(h){throw h})});R.write(u.data),R.end()}class b extends D.$JM{constructor(c,w,R,m,h){let O;c||(O=J("https"));const y={sendPOST:(g,d)=>{const f=typeof g.data=="string"?g.data:new TextDecoder().decode(g.data),I={type:"POST",headers:{...g.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(g.data).toString()},url:g.urlString,data:f};try{if(c)L(I,c).then(({statusCode:$,headers:v,responseData:t})=>{d($,v,t)});else{if(!O)throw new Error("https module is undefined");N(I,O)}}catch{d(0,{})}}};super(w,R,m,h,y)}}e.$KM=b}),define(ne[148],re([0,1,16,24]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q5b=void 0;async function D(L,N){const b=Object.create(null),u=(w,R)=>{const m=JSON.parse(w);b[R]=m};if(N){const w=[],R=await A.Promises.readdir(N);for(const h of R)try{(await A.Promises.stat((0,M.$ac)(N,h))).isDirectory()&&w.push(h)}catch{}const m=[];for(const h of w)(await A.Promises.readdir((0,M.$ac)(N,h))).filter(y=>y==="telemetry.json").length===1&&m.push(h);for(const h of m){const O=(await A.Promises.readFile((0,M.$ac)(N,h,"telemetry.json"))).toString();u(O,h)}}let c=(await A.Promises.readFile((0,M.$ac)(L,"telemetry-core.json"))).toString();return u(c,"vscode-core"),c=(await A.Promises.readFile((0,M.$ac)(L,"telemetry-extensions.json"))).toString(),u(c,"vscode-extensions"),JSON.stringify(b,null,4)}e.$q5b=D}),define(ne[149],re([0,1,12,75,26]),function(J,e,M,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M4b=void 0;async function L(N,b){let u=N.getItem(D.$Yk);return(typeof u!="string"||M.$j&&u==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(u=await(0,A.$sm)(b.error.bind(b))),u}e.$M4b=L}),define(ne[22],re([0,1,10]),function(J,e,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=void 0,e.$nk=(0,M.$nh)("IUriIdentityService")}),define(ne[150],re([0,1,22,114,13,17,73,4,2]),function(J,e,M,A,D,L,N,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class c{static{this._clock=0}constructor(m){this.uri=m,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let w=class{constructor(m){this.g=m,this.c=new u.$kb,this.f=2**16;const h=new Map,O=y=>{let g=h.get(y.scheme);return g===void 0&&(g=m.hasProvider(y)&&!this.g.hasCapability(y,1024),h.set(y.scheme,g)),g};this.c.add(b.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(y=>{h.delete(y.scheme)})),this.extUri=new L.$Wf(O),this.d=new N.$_q((y,g)=>this.extUri.compare(y,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,L.$9f)(m));const h=this.d.get(m);return h?h.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new c(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((O,y)=>O[1].time<y[1].time?1:O[1].time>y[1].time?-1:0);c._clock=0,this.d.clear();const h=this.f*.5;for(let O=0;O<h;O++)this.d.set(m[O][0],m[O][1].touch())}};e.$ar=w,e.$ar=w=pe([se(0,D.$Qj)],w),(0,A.$0q)(M.$nk,w,1)}),define(ne[151],re([0,1,4,2,13,41,46,14]),function(J,e,M,A,D,L,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$74b=void 0;class u extends A.$lb{get capabilities(){return this.f.capabilities&-5}constructor(w,R,m,h){super(),this.c=w,this.f=R,this.g=m,this.h=h,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new M.$7c),this.onDidChangeFile=this.a.event,this.b=N.$th.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(O=>this.i(O)))}watch(w,R){this.b.set(w,w);const m=this.f.watch(this.j(w),R);return(0,A.$jb)(()=>{this.b.delete(w),m.dispose()})}stat(w){return this.f.stat(this.j(w))}mkdir(w){return this.f.mkdir(this.j(w))}rename(w,R,m){return this.f.rename(this.j(w),this.j(R),m)}readFile(w){return this.f.readFile(this.j(w),{atomic:!0})}readFileStream(w,R,m){const h=(0,L.$xb)(O=>b.$Jb.concat(O.map(y=>b.$Jb.wrap(y))).buffer);return(async()=>{try{const O=await this.readFile(w);h.end(O)}catch(O){h.error(O),h.end()}})(),h}readdir(w){return this.f.readdir(this.j(w))}writeFile(w,R,m){return this.f.writeFile(this.j(w),R,m)}delete(w,R){return this.f.delete(this.j(w),R)}copy(w,R,m){if((0,D.$Tj)(this.f))return this.f.copy(this.j(w),this.j(R),m);throw new Error("copy not supported")}i(w){const R=[];for(const m of w){if(m.resource.scheme!==this.c)continue;const h=this.k(m.resource);this.b.findSubstr(h)&&R.push({resource:h,type:m.type})}R.length&&(this.h.debug("User data changed"),this.a.fire(R))}j(w){return w.with({scheme:this.c})}k(w){return w.with({scheme:this.g})}}e.$74b=u}),define(ne[152],re([0,1,107,16,46,17,11,10,15]),function(J,e,M,A,D,L,N,b,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.WorkbenchState=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$wh=(0,b.$nh)("contextService");function c(s){const n=s;return typeof n?.id=="string"&&N.URI.isUri(n.uri)}e.$xh=c;function w(s){return typeof s?.id=="string"&&!c(s)&&!m(s)}e.$yh=w,e.$zh={id:"ext-dev"},e.$Ah={id:"empty-window"};function R(s,n){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,A.$ec)(s)}:n?e.$zh:e.$Ah;const o=s;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$Bh=R;function m(s){const n=s;return typeof n?.id=="string"&&N.URI.isUri(n.configPath)}e.$Ch=m;function h(s){const n=s;if(n?.uri)return{id:n.id,uri:N.URI.revive(n.uri)};const o=s;if(o?.configPath)return{id:o.id,configPath:N.URI.revive(o.configPath)};if(s?.id)return{id:s.id}}e.$Dh=h;var O;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(O||(e.WorkbenchState=O={}));function y(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$Eh=y;function g(s){const n=s;return!!(n&&typeof n=="object"&&N.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$Fh=g;class d{constructor(n,o,l,P,E){this.h=n,this.j=l,this.k=P,this.l=E,this.c=D.$th.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=D.$th.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gh=d;class f{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,L.$8f)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hh=f;function I(s){return new f({uri:s,index:0,name:(0,L.$4f)(s)},{uri:s.toString()})}e.$Ih=I,e.$Jh="code-workspace",e.$Kh=`.${e.$Jh}`,e.$Lh=[{name:(0,M.localize)(0,null),extensions:[e.$Jh]}],e.$Mh="workspace.json";function $(s,n){return L.$Yf.isEqualOrParent(s,n.untitledWorkspacesHome)}e.$Nh=$;function v(s){let n;return N.URI.isUri(s)?n=s:n=s.configuration,n?.scheme===u.Schemas.tmp}e.$Oh=v,e.$Ph="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Ph}e.$Qh=t;function a(s,n){return!$(s,n)&&!v(s)}e.$Rh=a;function i(s){return(typeof s=="string"?(0,A.$fc)(s):(0,L.$6f)(s))===e.$Kh}e.$Sh=i}),define(ne[23],re([0,1,42,4,2,17,11,106,18,13,10,6,152,35,22,8,29,28,3]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O,y,g,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.ProfileResourceType=void 0;var I;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(I||(e.ProfileResourceType=I={}));function $(s){const n=s;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&N.URI.isUri(n.location)&&N.URI.isUri(n.globalStorageHome)&&N.URI.isUri(n.settingsResource)&&N.URI.isUri(n.keybindingsResource)&&N.URI.isUri(n.tasksResource)&&N.URI.isUri(n.snippetsHome)&&N.URI.isUri(n.extensionsResource))}e.$ok=$,e.$pk=(0,w.$nh)("IUserDataProfilesService");function v(s,n){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:N.URI.revive(s.location).with({scheme:n}),globalStorageHome:N.URI.revive(s.globalStorageHome).with({scheme:n}),settingsResource:N.URI.revive(s.settingsResource).with({scheme:n}),keybindingsResource:N.URI.revive(s.keybindingsResource).with({scheme:n}),tasksResource:N.URI.revive(s.tasksResource).with({scheme:n}),snippetsHome:N.URI.revive(s.snippetsHome).with({scheme:n}),extensionsResource:N.URI.revive(s.extensionsResource).with({scheme:n}),cacheHome:N.URI.revive(s.cacheHome).with({scheme:n}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$qk=v;function t(s,n,o,l,P,E){return{id:s,name:n,location:o,isDefault:!1,shortName:P?.shortName,globalStorageHome:E&&P?.useDefaultFlags?.globalState?E.globalStorageHome:(0,L.$8f)(o,"globalStorage"),settingsResource:E&&P?.useDefaultFlags?.settings?E.settingsResource:(0,L.$8f)(o,"settings.json"),keybindingsResource:E&&P?.useDefaultFlags?.keybindings?E.keybindingsResource:(0,L.$8f)(o,"keybindings.json"),tasksResource:E&&P?.useDefaultFlags?.tasks?E.tasksResource:(0,L.$8f)(o,"tasks.json"),snippetsHome:E&&P?.useDefaultFlags?.snippets?E.snippetsHome:(0,L.$8f)(o,"snippets"),extensionsResource:E&&P?.useDefaultFlags?.extensions?E.extensionsResource:(0,L.$8f)(o,"extensions.json"),cacheHome:(0,L.$8f)(l,s),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}e.$rk=t;let a=class extends D.$lb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(n,o,l,P){super(),this.n=n,this.r=o,this.s=l,this.t=P,this.f=!0,this.h=this.B(new A.$7c),this.onDidChangeProfiles=this.h.event,this.i=this.B(new A.$7c),this.onWillCreateProfile=this.i.event,this.j=this.B(new A.$7c),this.onWillRemoveProfile=this.j.event,this.k=this.B(new A.$7c),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.$li,emptyWindows:new Map},this.profilesHome=(0,L.$8f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,L.$8f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(n){this.f!==n&&(this.u=void 0,this.f=n)}isEnabled(){return this.f}get v(){if(!this.u){const n=this.w(),o=[n];if(this.f)try{for(const E of this.J()){if(!E.name||!(0,f.$ie)(E.name)||!E.location){this.t.warn("Skipping the invalid stored profile",E.location||E.name);continue}o.push(t((0,L.$5f)(E.location),E.name,E.location,this.g,{shortName:E.shortName,useDefaultFlags:E.useDefaultFlags},n))}}catch(E){this.t.error(E)}const l=new h.$li,P=new Map;if(o.length)try{const E=this.M();if(E.workspaces)for(const[S,j]of Object.entries(E.workspaces)){const B=N.URI.parse(S),ee=o.find(Z=>Z.id===j);ee&&l.set(B,ee)}if(E.emptyWindows)for(const[S,j]of Object.entries(E.emptyWindows)){const B=o.find(ee=>ee.id===j);B&&P.set(S,B)}}catch(E){this.t.error(E)}this.u={profiles:o,workspaces:l,emptyWindows:P}}return this.u}w(){const n=t("__default__profile__",(0,b.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...n,extensionsResource:this.O()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const o="Temp",l=new RegExp(`${(0,d.$nd)(o)}\\s(\\d+)`);let P=0;for(const S of this.profiles){const j=l.exec(S.name),B=j?parseInt(j[1]):0;P=B>P?B:P}const E=`${o} ${P+1}`;return this.createProfile((0,M.$bi)((0,g.$5e)()).toString(16),E,{transient:!0},n)}async createNamedProfile(n,o,l){return this.createProfile((0,M.$bi)((0,g.$5e)()).toString(16),n,o,l)}async createProfile(n,o,l,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const E=await this.y(n,o,l);return P&&await this.setProfileForWorkspace(P,E),E}async y(n,o,l){if(!(0,f.$ie)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.l.get(o);return P||(P=(async()=>{try{const E=this.profiles.find(B=>B.name===o||B.id===n);if(E)return E;const S=t(n,o,(0,L.$8f)(this.profilesHome,n),this.g,l,this.defaultProfile);await this.r.createFolder(S.location);const j=[];return this.i.fire({profile:S,join(B){j.push(B)}}),await y.Promises.settled(j),this.D([S],[],[]),S}finally{this.l.delete(o)}})(),this.l.set(o,P)),P}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let l=this.profiles.find(P=>P.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);return l=t(l.id,o.name??l.name,l.location,this.g,{shortName:o.shortName??l.shortName,transient:o.transient??l.isTransient,useDefaultFlags:o.useDefaultFlags??l.useDefaultFlags},this.defaultProfile),this.D([],[],[l]),l}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(P=>P.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const l=[];this.j.fire({profile:o,join(P){l.push(P)}});try{await Promise.allSettled(l)}catch(P){this.t.error(P)}for(const P of[...this.v.emptyWindows.keys()])o.id===this.v.emptyWindows.get(P)?.id&&this.v.emptyWindows.delete(P);for(const P of[...this.v.workspaces.keys()])o.id===this.v.workspaces.get(P)?.id&&this.v.workspaces.delete(P);this.H(),this.D([],[o],[]);try{await this.r.del(o.cacheHome,{recursive:!0})}catch(P){(0,c.$7j)(P)!==1&&this.t.error(P)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const l=this.profiles.find(P=>P.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);this.G(n,l)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(n,void 0,o)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const n=await this.r.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(l=>!this.s.extUri.isEqual(l.location,o.resource))).map(o=>this.r.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.m.profiles.filter(o=>!this.C(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.z(n);return N.URI.isUri(o)?this.m.workspaces.get(o)??this.v.workspaces.get(o):this.m.emptyWindows.get(o)??this.v.emptyWindows.get(o)}z(n){return(0,m.$xh)(n)?n.uri:(0,m.$Ch)(n)?n.configPath:n.id}C(n){return!!([...this.m.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.m.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location)))}D(n,o,l){const P=[...this.profiles,...n],E=[];this.m.profiles=[];for(let S of P)S.isDefault||o.some(j=>S.id===j.id)||(S=l.find(j=>S.id===j.id)??S,S.isTransient?this.m.profiles.push(S):E.push({location:S.location,name:S.name,shortName:S.shortName,useDefaultFlags:S.useDefaultFlags}));this.L(E),this.u=void 0,this.F(n,o,l)}F(n,o,l){this.h.fire({added:n,removed:o,updated:l,all:this.profiles})}G(n,o,l){l=o?.isTransient?!0:l,l||this.G(n,void 0,!0);const P=this.z(n),E=l?this.m:this.v;N.URI.isUri(P)?(E.workspaces.delete(P),o&&E.workspaces.set(P,o)):(E.emptyWindows.delete(P),o&&E.emptyWindows.set(P,o)),l||this.H()}H(){const n={};for(const[l,P]of this.v.workspaces.entries())n[l.toString()]=P.id;const o={};for(const[l,P]of this.v.emptyWindows.entries())o[l.toString()]=P.id;this.N({workspaces:n,emptyWindows:o}),this.u=void 0}I(n){const o={},l=this.w();if(n.workspaces)for(const[E,S]of Object.entries(n.workspaces)){const j=N.URI.parse(S);o[E]=this.s.extUri.isEqual(j,l.location)?l.id:this.s.extUri.basename(j)}const P={};if(n.emptyWindows)for(const[E,S]of Object.entries(n.emptyWindows)){const j=N.URI.parse(S);P[E]=this.s.extUri.isEqual(j,l.location)?l.id:this.s.extUri.basename(j)}return{workspaces:o,emptyWindows:P}}J(){return[]}L(n){throw new Error("not implemented")}M(){return{}}N(n){throw new Error("not implemented")}O(){}};e.$sk=a,e.$sk=a=pe([se(0,u.$uh),se(1,c.$Qj),se(2,O.$nk),se(3,R.$Pi)],a);class i extends a{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(n){this.a=n}M(){return this.R}N(n){this.R=n}}e.$tk=i}),define(ne[153],re([0,1,19,8,20,9,4,2,12,3,11,91,21,27,37,6,31,26,22,23]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O,y,g,d,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=void 0;let $=class extends b.$lb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}get onDidUpdateExtensionMetadata(){return this.s.event}constructor(n,o,l,P,E,S){super(),this.u=n,this.v=o,this.w=l,this.y=P,this.z=E,this.C=S,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new N.$7c),this.m=this.B(new N.$7c),this.n=this.B(new N.$7c),this.p=this.B(new N.$7c),this.s=this.B(new N.$7c),this.t=[],this.B((0,b.$jb)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.k.forEach(j=>j.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(l=>(0,m.$Kn)(l,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{const P=(await this.installGalleryExtensions([{extension:n,options:o}])).find(({identifier:E})=>(0,h.$do)(E,n.identifier));if(P?.local)return P?.local;throw P?.error?P.error:t(new Error(`Unknown error while installing extension ${n.identifier.id}`))}catch(l){throw t(l)}}async installGalleryExtensions(n){if(!this.u.isEnabled())throw new m.$On(R.localize(0,null),m.ExtensionManagementErrorCode.Internal);const o=[],l=[];await Promise.allSettled(n.map(async({extension:P,options:E})=>{try{const S=await this.J(P,!!E?.installGivenVersion,!!E?.installPreReleaseVersion);l.push({...S,options:E})}catch(S){o.push({identifier:P.identifier,operation:2,source:P,error:S})}})),l.length&&o.push(...await this.D(l));for(const P of o)P.error&&(this.y.error("Failed to install extension.",P.identifier.id),this.y.error(P.error),P.source&&!w.URI.isUri(P.source)&&a(this.v,"extensionGallery:install",{extensionData:(0,h.$lo)(P.source),error:P.error}));return o}async uninstall(n,o={}){return this.y.trace("ExtensionManagementService#uninstall",n.identifier.id),this.M(n,o)}async toggleAppliationScope(n,o){if((0,O.$Il)(n.manifest))return n;if(n.isApplicationScoped){let l=await this.updateMetadata(n,{isApplicationScoped:!1},this.C.defaultProfile.extensionsResource);this.w.extUri.isEqual(o,this.C.defaultProfile.extensionsResource)||(l=await this.X(n,this.C.defaultProfile.extensionsResource,o));for(const P of this.C.profiles){const E=(await this.getInstalled(1,P.extensionsResource)).find(S=>(0,h.$do)(S.identifier,n.identifier));E?this.s.fire(E):this.p.fire({identifier:n.identifier,profileLocation:P.extensionsResource})}return l}else{const l=this.w.extUri.isEqual(o,this.C.defaultProfile.extensionsResource)?await this.updateMetadata(n,{isApplicationScoped:!0},this.C.defaultProfile.extensionsResource):await this.X(n,o,this.C.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.m.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.C.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.R(),this.h=n),this.g}registerParticipant(n){this.t.push(n)}async D(n){const o=[];return await Promise.allSettled(n.map(async l=>{try{const P=await this.F(l);o.push(...P)}catch(P){o.push({identifier:{id:(0,h.$io)(l.manifest.publisher,l.manifest.name)},operation:2,source:l.extension,error:P})}})),this.m.fire(o),o}async F({manifest:n,extension:o,options:l}){const P=l.isApplicationScoped||l.isBuiltin||(0,O.$Il)(n),E={...l,installOnlyNewlyAddedFromExtensionPack:w.URI.isUri(o)?l.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:P,profileLocation:P?this.C.defaultProfile.extensionsResource:l.profileLocation??this.S()},S=_=>`${h.$eo.create(_).toString()}${E.profileLocation?`-${E.profileLocation.toString()}`:""}`;if(!w.URI.isUri(o)){const _=this.j.get(S(o));if(_)return this.y.info("Extensions is already requested to install",o.identifier.id),await _.task.waitUntilTaskIsFinished(),[]}const j=[],B=[],ee=[],Z=this.U(n,o,E);w.URI.isUri(o)||this.j.set(S(o),{task:Z,waitingTasks:[]}),this.l.fire({identifier:Z.identifier,source:o,profileLocation:E.profileLocation}),this.y.info("Installing extension:",Z.identifier.id),j.push({task:Z,manifest:n});let le=!1;try{if(E.donotIncludePackAndDependencies)this.y.info("Installing the extension without checking dependencies and pack",Z.identifier.id);else try{const ae=await this.I(Z.identifier,n,!!E.installOnlyNewlyAddedFromExtensionPack,!!E.installPreReleaseVersion,E.profileLocation),ce=await this.getInstalled(void 0,E.profileLocation);for(const{gallery:te,manifest:F}of(0,M.$qf)(ae,({gallery:W})=>W.identifier.id)){le=le||!!F.extensionDependencies?.some(U=>(0,h.$do)({id:U},Z.identifier));const W=S(te),T=this.j.get(W);if(T){if(this.G(Z,T.task)){const U=T.task.identifier;this.y.info("Waiting for already requested installing extension",U.id,Z.identifier.id),T.waitingTasks.push(Z),B.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,V=>V.some(G=>(0,h.$do)(G.identifier,U)))).then(V=>{if(this.y.info("Finished waiting for already requested installing extension",U.id,Z.identifier.id),!V.find(X=>(0,h.$do)(X.identifier,U))?.local)throw new Error(`Extension ${U.id} is not installed`)}))}}else if(!ce.some(({identifier:U})=>(0,h.$do)(U,te.identifier))){const U=this.U(F,te,{...E,donotIncludePackAndDependencies:!0});this.j.set(W,{task:U,waitingTasks:[Z]}),this.l.fire({identifier:U.identifier,source:te,profileLocation:E.profileLocation}),this.y.info("Installing extension:",U.identifier.id,Z.identifier.id),j.push({task:U,manifest:F})}}}catch(ae){if(w.URI.isUri(Z.source))(0,M.$pf)(n.extensionDependencies)&&this.y.warn("Cannot install dependencies of extension:",Z.identifier.id,ae.message),(0,M.$pf)(n.extensionPack)&&this.y.warn("Cannot install packed extensions of extension:",Z.identifier.id,ae.message);else throw this.y.error("Error while preparing to install dependencies and extension packs of the extension:",Z.identifier.id),ae}const _=j.reduce((ae,{task:ce,manifest:te})=>(ae.set(ce.identifier.id.toLowerCase(),{task:ce,manifest:te}),ae),new Map);for(;_.size;){let ae;const ce=[..._.values()].filter(({manifest:te})=>!te.extensionDependencies?.some(F=>_.has(F.toLowerCase())));ce.length?ae=_.size===1?ce:ce.filter(({task:te})=>!(te===Z&&!le)):(this.y.info("Found extensions with circular dependencies",ce.map(({task:te})=>te.identifier.id)),ae=[..._.values()]),await this.H(ae.map(async({task:te})=>{const F=new Date().getTime();try{const W=await te.run();if(await this.H(this.t.map(T=>T.postInstall(W,te.source,E,D.CancellationToken.None))),!w.URI.isUri(te.source)){const T=te.operation===3,U=T?void 0:(new Date().getTime()-te.source.lastUpdated)/1e3;if(a(this.v,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$lo)(te.source),verificationStatus:te.verificationStatus,duration:new Date().getTime()-F,durationSinceUpdate:U}),u.$o&&te.operation!==3)try{await this.u.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}ee.push({local:W,identifier:te.identifier,operation:te.operation,source:te.source,context:E.context,profileLocation:te.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw w.URI.isUri(te.source)||a(this.v,te.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$lo)(te.source),verificationStatus:te.verificationStatus,duration:new Date().getTime()-F,error:W}),this.y.error("Error while installing the extension:",te.identifier.id),W}finally{_.delete(te.identifier.id.toLowerCase())}}))}return B.length&&await this.H(B),ee.forEach(({identifier:ae})=>this.y.info("Extension installed successfully:",ae.id)),ee}catch(_){if(j.forEach(({task:ae})=>ae.cancel()),ee.length)try{const ae=await Promise.allSettled(ee.map(({local:ce})=>this.W(ce,{versionOnly:!0,profileLocation:E.profileLocation}).run()));for(let ce=0;ce<ae.length;ce++){const te=ae[ce],{identifier:F}=ee[ce];te.status==="fulfilled"?this.y.info("Rollback: Uninstalled extension",F.id):this.y.warn("Rollback: Error while uninstalling extension",F.id,(0,L.$9)(te.reason))}}catch(ae){this.y.warn("Error while rolling back extensions",(0,L.$9)(ae),ee.map(({identifier:ce})=>ce.id))}return j.map(({task:ae})=>({identifier:ae.identifier,operation:2,source:ae.source,context:E.context,profileLocation:E.profileLocation,error:_}))}finally{for(const{task:_}of j)_.source&&!w.URI.isUri(_.source)&&this.j.delete(S(_.source))}}G(n,o){for(const[,{task:l,waitingTasks:P}]of this.j.entries())if(l===n&&(P.includes(o)||P.some(E=>this.G(E,o)))||l===o&&P[0]&&!this.G(n,P[0]))return!1;return!0}async H(n){const o=[],l=[],P=await Promise.allSettled(n);for(const E of P)E.status==="fulfilled"?o.push(E.value):l.push(E.reason);if(l.length)throw v(l);return o}async I(n,o,l,P,E){if(!this.u.isEnabled())return[];const S=await this.getInstalled(void 0,E),j=[],B=[],ee=async(Z,le)=>{j.push(Z);const _=le.extensionDependencies||[],ae=[..._];if(le.extensionPack){const ce=l?S.find(te=>(0,h.$do)(te.identifier,Z)):void 0;for(const te of le.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(F=>(0,h.$do)({id:F},{id:te}))||ae.every(F=>!(0,h.$do)({id:F},{id:te}))&&ae.push(te)}if(ae.length){const ce=ae.filter(te=>j.every(F=>!(0,h.$do)(F,{id:te})));if(ce.length){const te=await this.u.getExtensions(ce.map(F=>({id:F,preRelease:P})),D.CancellationToken.None);for(const F of te){if(j.find(U=>(0,h.$do)(U,F.identifier)))continue;const W=_.some(U=>(0,h.$do)({id:U},F.identifier));let T;try{T=await this.J(F,!1,P)}catch(U){if(W)throw U;this.y.info("Skipping the packed extension as it cannot be installed",F.identifier.id,(0,L.$9)(U));continue}B.push({gallery:T.extension,manifest:T.manifest}),await ee(T.extension.identifier,T.manifest)}}}};return await ee(n,o),B}async J(n,o,l){let P;const E=await this.getExtensionsControlManifest();if(E.malicious.some(B=>(0,h.$do)(n.identifier,B)))throw new m.$On(R.localize(1,null,n.identifier.id),m.ExtensionManagementErrorCode.Malicious);const S=E.deprecated[n.identifier.id.toLowerCase()];if(S?.extension?.autoMigrate){if(this.y.info(`The '${n.identifier.id}' extension is deprecated, fetching the compatible '${S.extension.id}' extension instead.`),P=(await this.u.getExtensions([{id:S.extension.id,preRelease:S.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0],!P)throw new m.$On(R.localize(2,null,n.identifier.id,S.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(n)){const B=await this.getTargetPlatform();throw new m.$On(R.localize(3,null,n.identifier.id,this.z.nameLong,(0,m.$Gn)(B)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(P=await this.L(n,o,l),!P)throw!l&&n.properties.isPreReleaseVersion&&(await this.u.getExtensions([n.identifier],D.CancellationToken.None))[0]?new m.$On(R.localize(4,null,n.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$On(R.localize(5,null,n.identifier.id,this.z.nameLong,this.z.version),m.ExtensionManagementErrorCode.Incompatible)}this.y.info("Getting Manifest...",P.identifier.id);const j=await this.u.getManifest(P,D.CancellationToken.None);if(j===null)throw new m.$On(`Missing manifest for extension ${P.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(j.version!==P.version)throw new m.$On(`Cannot install '${P.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:P,manifest:j}}async L(n,o,l){const P=await this.getTargetPlatform();let E=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==l&&(E=(await this.u.getExtensions([{...n.identifier,preRelease:l}],{targetPlatform:P,compatible:!0},D.CancellationToken.None))[0]||null),!E&&await this.u.isExtensionCompatible(n,l,P)&&(E=n),E||(o?E=(await this.u.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:P,compatible:!0},D.CancellationToken.None))[0]||null:E=await this.u.getCompatibleExtension(n,l,P)),E}async M(n,o){const l={...o,profileLocation:n.isApplicationScoped?this.C.defaultProfile.extensionsResource:o.profileLocation??this.S()},P=Z=>`${Z.id.toLowerCase()}${l.versionOnly?`-${n.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,E=this.k.get(P(n.identifier));if(E)return this.y.info("Extensions is already requested to uninstall",n.identifier.id),E.waitUntilTaskIsFinished();const S=Z=>{const le=this.W(Z,l);return this.k.set(P(le.extension.identifier),le),l.profileLocation?this.y.info("Uninstalling extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString()):this.y.info("Uninstalling extension:",`${Z.identifier.id}@${Z.manifest.version}`),this.n.fire({identifier:Z.identifier,profileLocation:l.profileLocation,applicationScoped:Z.isApplicationScoped}),le},j=(Z,le)=>{le?l.profileLocation?this.y.error("Failed to uninstall extension from the profile:",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString(),le.message):this.y.error("Failed to uninstall extension:",`${Z.identifier.id}@${Z.manifest.version}`,le.message):l.profileLocation?this.y.info("Successfully uninstalled extension from the profile",`${Z.identifier.id}@${Z.manifest.version}`,l.profileLocation.toString()):this.y.info("Successfully uninstalled extension:",`${Z.identifier.id}@${Z.manifest.version}`),a(this.v,"extensionGallery:uninstall",{extensionData:(0,h.$ko)(Z),error:le}),this.p.fire({identifier:Z.identifier,error:le?.code,profileLocation:l.profileLocation,applicationScoped:Z.isApplicationScoped})},B=[],ee=[];try{B.push(S(n));const Z=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.y.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const le=this.P(n,Z);for(const _ of le)this.k.has(P(_.identifier))?this.y.info("Extensions is already requested to uninstall",_.identifier.id):B.push(S(_))}l.donotCheckDependents?this.y.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.N(B.map(le=>le.extension),Z,n),await this.H(B.map(async le=>{try{if(await le.run(),await this.H(this.t.map(_=>_.postUninstall(le.extension,l,D.CancellationToken.None))),le.extension.identifier.uuid)try{await this.u.reportStatistic(le.extension.manifest.publisher,le.extension.manifest.name,le.extension.manifest.version,"uninstall")}catch{}j(le.extension)}catch(_){const ae=_ instanceof m.$On?_:new m.$On((0,L.$9)(_),m.ExtensionManagementErrorCode.Internal);throw j(le.extension,ae),ae}finally{ee.push(le)}}))}catch(Z){const le=Z instanceof m.$On?Z:new m.$On((0,L.$9)(Z),m.ExtensionManagementErrorCode.Internal);for(const _ of B){try{_.cancel()}catch{}ee.includes(_)||j(_.extension,le)}throw le}finally{for(const Z of B)this.k.delete(P(Z.extension.identifier))||this.y.warn("Uninstallation task is not found in the cache",Z.extension.identifier.id)}}N(n,o,l){for(const P of n){const E=this.Q(P,o);if(E.length){const S=E.filter(j=>!n.some(B=>(0,h.$do)(B.identifier,j.identifier)));if(S.length)throw new Error(this.O(P,S,l))}}}O(n,o,l){return l===n?o.length===1?R.localize(6,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?R.localize(7,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):R.localize(8,null,l.manifest.displayName||l.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?R.localize(9,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?R.localize(10,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):R.localize(11,null,l.manifest.displayName||l.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}P(n,o,l=[]){if(l.indexOf(n)!==-1)return[];l.push(n);const P=n.manifest.extensionPack?n.manifest.extensionPack:[];if(P.length){const E=o.filter(j=>!j.isBuiltin&&P.some(B=>(0,h.$do)({id:B},j.identifier))),S=[];for(const j of E)S.push(...this.P(j,o,l));return[...E,...S]}return[]}Q(n,o){return o.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some(P=>(0,h.$do)({id:P},n.identifier)))}async R(){try{this.y.trace("ExtensionManagementService.refreshReportedCache");const n=await this.u.getExtensionsControlManifest();return this.y.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.y.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$5o=$,e.$5o=$=pe([se(0,m.$Nn),se(1,d.$Tk),se(2,f.$nk),se(3,y.$Pi),se(4,g.$8i),se(5,I.$pk)],$);function v(s){const n=Array.isArray(s)?s:[s];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((o,l)=>new Error(`${o.message}${o.message?",":""}${l instanceof Error?l.message:l}`),new Error(""))}e.$6o=v;function t(s){if(s instanceof m.$On)return s;const n=new m.$On(s.message,m.ExtensionManagementErrorCode.Internal);return n.stack=s.stack,n}e.$7o=t;function a(s,n,{extensionData:o,verificationStatus:l,duration:P,error:E,durationSinceUpdate:S}){let j,B;(0,c.$qe)(l)&&(l===!0?l="Verified":(l===!1||(j=m.ExtensionManagementErrorCode.Signature,B=l),l="Unverified")),E&&(E instanceof m.$On?(j=E.code,E.code===m.ExtensionManagementErrorCode.Signature&&(B=E.message)):j=m.ExtensionManagementErrorCode.Internal),s.publicLog(n,{...o,verificationStatus:l,success:!E,duration:P,errorcode:j,errorcodeDetail:B,durationSinceUpdate:S})}class i{constructor(){this.d=new A.$sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.$hg)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.$hg)(n=>new Promise((o,l)=>{const P=n.onCancellationRequested(()=>{P.dispose(),l(new L.$3)})})),this.d.open()),this.g.cancel()}}e.$8o=i}),define(ne[40],re([0,1,8,14,2,4,35,11,21,27,13,10,6,23,22,3,9,26]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O,y,g,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class I extends Error{constructor(i,s){super(i),this.code=s}}e.$9o=I,e.$0o=(0,R.$nh)("IExtensionsProfileScannerService");let $=class extends D.$lb{constructor(i,s,n,o,l,P){super(),this.i=i,this.j=s,this.k=n,this.l=o,this.m=l,this.n=P,this.b=this.B(new L.$7c),this.onAddExtensions=this.b.event,this.c=this.B(new L.$7c),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$7c),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$7c),this.onDidRemoveExtensions=this.g.event,this.h=new N.$li}scanProfileExtensions(i,s){return this.p(i,void 0,s)}async addExtensionsToProfile(i,s){const n=[],o=[];try{return await this.p(s,l=>{const P=[];for(const E of l)i.some(([S])=>(0,c.$do)(S.identifier,E.identifier)&&S.manifest.version!==E.version)?n.push(E):P.push(E);for(const[E,S]of i)if(!P.some(j=>(0,c.$do)(j.identifier,E.identifier)&&j.version===E.manifest.version)){const j={identifier:E.identifier,version:E.manifest.version,location:E.location,metadata:S};o.push(j),P.push(j)}return o.length&&this.b.fire({extensions:o,profileLocation:s}),n.length&&this.f.fire({extensions:n,profileLocation:s}),P}),o.length&&this.c.fire({extensions:o,profileLocation:s}),n.length&&this.g.fire({extensions:n,profileLocation:s}),o}catch(l){throw o.length&&this.c.fire({extensions:o,error:l,profileLocation:s}),n.length&&this.g.fire({extensions:n,error:l,profileLocation:s}),l}}async updateMetadata(i,s){const n=[];return await this.p(s,o=>{const l=[];for(const P of o){const E=i.find(([S])=>(0,c.$do)(S.identifier,P.identifier)&&S.manifest.version===P.version);E&&(P.metadata={...P.metadata,...E[1]},n.push(P)),l.push(P)}return l}),n}async removeExtensionFromProfile(i,s){const n=[];this.f.fire({extensions:n,profileLocation:s});try{await this.p(s,o=>{const l=[];for(const P of o)(0,c.$do)(P.identifier,i.identifier)?n.push(P):l.push(P);return n.length&&this.f.fire({extensions:n,profileLocation:s}),l}),n.length&&this.g.fire({extensions:n,profileLocation:s})}catch(o){throw n.length&&this.g.fire({extensions:n,error:o,profileLocation:s}),o}}async p(i,s,n){return this.w(i).queue(async()=>{let o=[],l;try{const P=await this.j.readFile(i);l=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,w.$7j)(P)!==1)throw P;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(l=await this.v()),!l&&n?.bailOutWhenFileNotFound)throw new I((0,g.$9)(P),"ERROR_PROFILE_NOT_FOUND")}if(l){Array.isArray(l)||this.r(i);let P=!1;for(const E of l){v(E)||this.r(i);let S;if((0,y.$ie)(E.relativeLocation)&&E.relativeLocation)S=this.t(E.relativeLocation);else if((0,y.$ie)(E.location))S=this.t(E.location),P=!0,E.relativeLocation=E.location,E.location=S.toJSON();else{S=b.URI.revive(E.location);const j=this.s(S);j&&(P=!0,E.relativeLocation=j)}o.push({identifier:E.identifier,location:S,version:E.version,metadata:E.metadata})}P&&await this.j.writeFile(i,A.$Jb.fromString(JSON.stringify(l)))}if(s){o=s(o);const P=o.map(E=>({identifier:E.identifier,version:E.version,location:E.location.toJSON(),relativeLocation:this.s(E.location),metadata:E.metadata}));await this.j.writeFile(i,A.$Jb.fromString(JSON.stringify(P)))}return o})}r(i){const s=new I(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),s=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let n;try{n=(await this.j.readFile(i)).value.toString()}catch(l){if((0,w.$7j)(l)===1)return;throw l}this.n.info("Migrating extensions from old default profile location",i.toString());let o;try{const l=JSON.parse(n);Array.isArray(l)&&l.every(P=>v(P))?o=l:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",l)}catch(l){this.n.error(l)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,A.$Jb.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(l){if((0,w.$7j)(l)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw l}try{await this.j.del(i)}catch(l){(0,w.$7j)(l)!==1&&this.n.error(l)}try{await this.j.del(s)}catch(l){(0,w.$7j)(l)!==1&&this.n.error(l)}return o})()),this.u}w(i){let s=this.h.get(i);return s||(s=new M.$Ag,this.h.set(i,s)),s}};e.$$o=$,e.$$o=$=pe([se(1,w.$Qj),se(2,h.$pk),se(3,O.$nk),se(4,d.$Tk),se(5,m.$Pi)],$);function v(a){return(0,y.$ke)(a)&&(0,u.$Mn)(a.identifier)&&(t(a.location)||(0,y.$ie)(a.location)&&a.location)&&((0,y.$pe)(a.relativeLocation)||(0,y.$ie)(a.relativeLocation))&&a.version&&(0,y.$ie)(a.version)}function t(a){return a?(0,y.$ie)(a.path)&&(0,y.$ie)(a.scheme):!1}}),define(ne[50],re([0,1,19,8,30,14,9,53,80,2,15,16,12,17,43,54,3,11,95,18,27,37,48,13,10,6,31,4,47,40,23,22,112]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O,y,g,d,f,I,$,v,t,a,i,s,n,o,l,P,E,S,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.Translations=void 0;var B;(function(te){function F(W,T){if(W===T)return!0;const U=Object.keys(W),V=new Set;for(const G of Object.keys(T))V.add(G);if(U.length!==V.size)return!1;for(const G of U){if(W[G]!==T[G])return!1;V.delete(G)}return V.size===0}te.equals=F})(B||(e.Translations=B={})),e.$bp=(0,i.$nh)("IExtensionsScannerService");let ee=class extends c.$lb{constructor(F,W,T,U,V,G,X,K,oe,k,r,p){super(),this.systemExtensionsLocation=F,this.userExtensionsLocation=W,this.l=T,this.m=U,this.n=V,this.r=G,this.s=X,this.t=K,this.u=oe,this.v=k,this.w=r,this.y=p,this.g=this.B(new o.$7c),this.onDidChangeCache=this.g.event,this.h=(0,h.$8f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(_,this.m,this.h)),this.j=this.B(this.y.createInstance(_,this.m,this.h)),this.k=this.B(this.y.createInstance(le,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,$.$oo)(this.s,this.t)),this.z}async scanAllExtensions(F,W,T){const[U,V]=await Promise.all([this.scanSystemExtensions(F),this.scanUserExtensions(W)]),G=T?await this.scanExtensionsUnderDevelopment(F,[...U,...V]):[];return this.G(U,V,G,await this.getTargetPlatform(),!0)}async scanSystemExtensions(F){const W=[];W.push(this.H(!!F.useCache,F.language)),W.push(this.I(F.language,!!F.checkControlFile));const[T,U]=await Promise.all(W);return this.F([...T,...U],0,F,!1)}async scanUserExtensions(F){const W=F.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",W);const T=this.w.extUri.isEqual(F.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,U=await this.L(W,!!F.profileLocation,1,!F.includeUninstalled,F.language,!0,T),V=F.useCache&&!U.devMode&&U.excludeObsolete?this.j:this.k;let G;try{G=await V.scanExtensions(U)}catch(X){if(X instanceof P.$9o&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),G=await V.scanExtensions(U);else throw X}return G=await this.F(G,1,F,!0),this.t.trace("Scanned user extensions:",G.length),G}async scanExtensionsUnderDevelopment(F,W){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const T=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(U=>U.scheme===w.Schemas.file).map(async U=>{const V=await this.L(U,!1,1,!0,F.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(V)).map(X=>(X.type=W.find(K=>(0,$.$do)(K.identifier,X.identifier))?.type??X.type,this.k.validate(X,V)))}))).flat();return this.F(T,"development",F,!0)}return[]}async scanExistingExtension(F,W,T){const U=await this.L(F,!1,W,!0,T.language,!0,void 0),V=await this.k.scanExtension(U);return!V||!T.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(F,W,T){const U=await this.L(F,!1,W,!0,T.language,!0,void 0),V=await this.k.scanOneOrMultipleExtensions(U);return this.F(V,W,T,!0)}async scanMetadata(F){const W=(0,h.$8f)(F,"package.json"),T=(await this.s.readFile(W)).value.toString();return JSON.parse(T).__metadata}async updateMetadata(F,W){const T=(0,h.$8f)(F,"package.json"),U=(await this.s.readFile(T)).value.toString(),V=JSON.parse(U);W.isMachineScoped=W.isMachineScoped||void 0,W.isBuiltin=W.isBuiltin||void 0,V.__metadata={...V.__metadata,...W},await this.s.writeFile((0,h.$8f)(F,"package.json"),L.$Jb.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(F){if(F instanceof P.$9o&&F.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw F}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const F=await this.scanUserExtensions({includeInvalid:!0});if(F.length)await this.r.addExtensionsToProfile(F.map(W=>[W,W.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,L.$Jb.fromString(JSON.stringify([])))}catch(W){(0,a.$7j)(W)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$9)(W))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(F){this.t.error(F)}finally{this.C=void 0}})()),this.C}async F(F,W,T,U){return T.includeAllVersions||(F=this.G(W===0?F:void 0,W===1?F:void 0,W==="development"?F:void 0,await this.getTargetPlatform(),U)),T.includeInvalid||(F=F.filter(V=>V.isValid)),F.sort((V,G)=>{const X=R.$ec(V.location.fsPath),K=R.$ec(G.location.fsPath);return X<K?-1:X>K?1:0})}G(F,W,T,U,V){const G=(K,oe,k)=>{if(K.isValid&&!oe.isValid)return!1;if(K.isValid===oe.isValid){if(V&&O.gt(K.manifest.version,oe.manifest.version))return this.t.debug(`Skipping extension ${oe.location.path} with lower version ${oe.manifest.version} in favour of ${K.location.path} with version ${K.manifest.version}`),!1;if(O.eq(K.manifest.version,oe.manifest.version)){if(K.type===0)return this.t.debug(`Skipping extension ${oe.location.path} in favour of system extension ${K.location.path} with same version`),!1;if(K.targetPlatform===U)return this.t.debug(`Skipping extension ${oe.location.path} from different target platform ${oe.targetPlatform}`),!1}}return k?this.t.warn(`Overwriting user extension ${K.location.path} with ${oe.location.path}.`):this.t.debug(`Overwriting user extension ${K.location.path} with ${oe.location.path}.`),!0},X=new v.$Hl;return F?.forEach(K=>{const oe=X.get(K.identifier.id);(!oe||G(oe,K,!1))&&X.set(K.identifier.id,K)}),W?.forEach(K=>{const oe=X.get(K.identifier.id);if(!oe&&F&&K.type===0){this.t.debug(`Skipping obsolete system extension ${K.location.path}.`);return}(!oe||G(oe,K,!1))&&X.set(K.identifier.id,K)}),T?.forEach(K=>{const oe=X.get(K.identifier.id);(!oe||G(oe,K,!0))&&X.set(K.identifier.id,K),X.set(K.identifier.id,K)}),[...X.values()]}async H(F,W){this.t.trace("Started scanning system extensions");const T=await this.L(this.systemExtensionsLocation,!1,0,!0,W,!0,void 0),V=await(F&&!T.devMode?this.i:this.k).scanExtensions(T);return this.t.trace("Scanned system extensions:",V.length),V}async I(F,W){const T=this.u.isBuilt?[]:this.v.builtInExtensions;if(!T?.length)return[];this.t.trace("Started scanning dev system extensions");const U=W?await this.J():{},V=[],G=d.URI.file(R.$$b(R.$ac(w.$3e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const K of T){const oe=U[K.name]||"marketplace";switch(oe){case"disabled":break;case"marketplace":V.push((0,h.$8f)(G,K.name));break;default:V.push(d.URI.file(oe));break}}const X=await Promise.all(V.map(async K=>this.k.scanExtension(await this.L(K,!1,0,!0,F,!0,void 0))));return this.t.trace("Scanned dev system extensions:",X.length),(0,M.$lf)(X)}async J(){try{const F=await this.s.readFile(this.l);return JSON.parse(F.value.toString())}catch{return{}}}async L(F,W,T,U,V,G,X){const K=await this.f(V??m.$v),oe=await this.M(F),k=W&&!this.w.extUri.isEqual(F,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,r=k?await this.M(k):void 0;return new Z(F,oe,k,r,W,X,T,U,G,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,V,K)}async M(F){try{const W=await this.s.stat(F);if(typeof W.mtime=="number")return W.mtime}catch{}}};e.$cp=ee,e.$cp=ee=pe([se(4,E.$pk),se(5,P.$0o),se(6,a.$Qj),se(7,s.$Pi),se(8,I.$uh),se(9,n.$8i),se(10,S.$nk),se(11,i.$mh)],ee);class Z{constructor(F,W,T,U,V,G,X,K,oe,k,r,p,z,C,H){this.location=F,this.mtime=W,this.applicationExtensionslocation=T,this.applicationExtensionslocationMtime=U,this.profile=V,this.profileScanOptions=G,this.type=X,this.excludeObsolete=K,this.validate=oe,this.productVersion=k,this.productDate=r,this.productCommit=p,this.devMode=z,this.language=C,this.translations=H}static createNlsConfiguration(F){return{language:F.language,pseudo:F.language==="pseudo",devMode:F.devMode,translations:F.translations}}static equals(F,W){return(0,h.$1f)(F.location,W.location)&&F.mtime===W.mtime&&(0,h.$1f)(F.applicationExtensionslocation,W.applicationExtensionslocation)&&F.applicationExtensionslocationMtime===W.applicationExtensionslocationMtime&&F.profile===W.profile&&D.$Jm(F.profileScanOptions,W.profileScanOptions)&&F.type===W.type&&F.excludeObsolete===W.excludeObsolete&&F.validate===W.validate&&F.productVersion===W.productVersion&&F.productDate===W.productDate&&F.productCommit===W.productCommit&&F.devMode===W.devMode&&F.language===W.language&&B.equals(F.translations,W.translations)}}e.$dp=Z;let le=class extends c.$lb{constructor(F,W,T,U,V){super(),this.f=F,this.g=W,this.h=T,this.i=U,this.j=V}async scanExtensions(F){const W=F.profile?await this.l(F):await this.k(F);let T={};if(F.excludeObsolete&&F.type===1)try{const U=(await this.i.readFile(this.f)).value.toString();T=JSON.parse(U)}catch{}return(0,g.$ve)(T)?W:W.filter(U=>!T[$.$eo.create(U).toString()])}async k(F){const W=await this.i.resolve(F.location);if(!W.children?.length)return[];const T=await Promise.all(W.children.map(async U=>{if(!U.isDirectory||F.type===1&&(0,h.$5f)(U.resource).indexOf(".")===0)return null;const V=new Z(U.resource,F.mtime,F.applicationExtensionslocation,F.applicationExtensionslocationMtime,F.profile,F.profileScanOptions,F.type,F.excludeObsolete,F.validate,F.productVersion,F.productDate,F.productCommit,F.devMode,F.language,F.translations);return this.scanExtension(V)}));return(0,M.$lf)(T).sort((U,V)=>U.location.path<V.location.path?-1:1)}async l(F){let W=await this.m(F.location,()=>!0,F);if(F.applicationExtensionslocation&&!this.h.extUri.isEqual(F.location,F.applicationExtensionslocation)){W=W.filter(U=>!U.metadata?.isApplicationScoped);const T=await this.m(F.applicationExtensionslocation,U=>!!U.metadata?.isBuiltin||!!U.metadata?.isApplicationScoped,F);W.push(...T)}return W}async m(F,W,T){const U=await this.g.scanProfileExtensions(F,T.profileScanOptions);if(!U.length)return[];const V=await Promise.all(U.map(async G=>{if(W(G)){const X=new Z(G.location,T.mtime,T.applicationExtensionslocation,T.applicationExtensionslocationMtime,T.profile,T.profileScanOptions,T.type,T.excludeObsolete,T.validate,T.productVersion,T.productDate,T.productCommit,T.devMode,T.language,T.translations);return this.scanExtension(X,G.metadata)}return null}));return(0,M.$lf)(V)}async scanOneOrMultipleExtensions(F){try{if(await this.i.exists((0,h.$8f)(F.location,"package.json"))){const W=await this.scanExtension(F);return W?[W]:[]}else return await this.scanExtensions(F)}catch(W){return this.j.error(`Error scanning extensions at ${F.location.path}:`,(0,N.$9)(W)),[]}}async scanExtension(F,W){try{let T=await this.scanExtensionManifest(F.location);if(T){T.publisher||(T.publisher=v.$Bl),W=W??T.__metadata,delete T.__metadata;const U=(0,$.$io)(T.publisher,T.name),V=W?.id?{id:U,uuid:W.id}:{id:U},G=W?.isSystem?0:F.type,X=G===0||!!W?.isBuiltin;T=await this.n(F.location,T,Z.createNlsConfiguration(F));const K={type:G,identifier:V,manifest:T,location:F.location,isBuiltin:X,targetPlatform:W?.targetPlatform??"undefined",metadata:W,isValid:!0,validations:[]};return F.validate?this.validate(K,F):K}}catch(T){F.type!==0&&this.j.error(T)}return null}validate(F,W){let T=!0;const U=(0,t.$to)(W.productVersion,W.productDate,W.location,F.manifest,F.isBuiltin);for(const[V,G]of U)V===y.default.Error&&(T=!1,this.j.error(this.u(W.location,G)));return F.isValid=T,F.validations=U,F}async scanExtensionManifest(F){const W=(0,h.$8f)(F,"package.json");let T;try{T=(await this.i.readFile(W)).value.toString()}catch(V){return(0,a.$7j)(V)!==1&&this.j.error(this.u(F,(0,f.localize)(0,null,W.path,V.message))),null}let U;try{U=JSON.parse(T)}catch{const G=[];(0,b.$vm)(T,G);for(const X of G)this.j.error(this.u(F,(0,f.localize)(1,null,W.path,X.offset,X.length,(0,u.$_o)(X.error))));return null}return(0,b.$Em)(U)!=="object"?(this.j.error(this.u(F,(0,f.localize)(2,null,W.path))),null):U}async n(F,W,T){const U=await this.r(F,W,T);if(U)try{const V=[],G=await this.s(U.default,V);if(V.length>0)return V.forEach(K=>{this.j.error(this.u(F,(0,f.localize)(3,null,U.default?.path,(0,u.$_o)(K.error))))}),W;if((0,b.$Em)(U)!=="object")return this.j.error(this.u(F,(0,f.localize)(4,null,U.default?.path))),W;const X=U.values||Object.create(null);return(0,j.$ap)(W,X,G)}catch{}return W}async r(F,W,T){const U=(0,h.$8f)(F,"package.nls.json"),V=(oe,k)=>{k.forEach(r=>{this.j.error(this.u(F,(0,f.localize)(5,null,oe?.path,(0,u.$_o)(r.error))))})},G=oe=>{this.j.error(this.u(F,(0,f.localize)(6,null,oe?.path)))},X=`${W.publisher}.${W.name}`,K=T.translations[X];if(K)try{const oe=d.URI.file(K),k=(await this.i.readFile(oe)).value.toString(),r=[],p=(0,b.$vm)(k,r);return r.length>0?(V(oe,r),{values:void 0,default:U}):(0,b.$Em)(p)!=="object"?(G(oe),{values:void 0,default:U}):{values:p.contents?p.contents.package:void 0,default:U}}catch{return{values:void 0,default:U}}else{if(!await this.i.exists(U))return;let k;try{k=await this.t(F,T)}catch{return}if(!k.localized)return{values:void 0,default:k.original};try{const r=(await this.i.readFile(k.localized)).value.toString(),p=[],z=(0,b.$vm)(r,p);return p.length>0?(V(k.localized,p),{values:void 0,default:k.original}):(0,b.$Em)(z)!=="object"?(G(k.localized),{values:void 0,default:k.original}):{values:z,default:k.original}}catch{return{values:void 0,default:k.original}}}}async s(F,W){if(F)try{const T=(await this.i.readFile(F)).value.toString();return(0,b.$vm)(T,W)}catch{}}t(F,W){return new Promise((T,U)=>{const V=G=>{const X=(0,h.$8f)(F,`package.nls.${G}.json`);this.i.exists(X).then(K=>{K&&T({localized:X,original:(0,h.$8f)(F,"package.nls.json")});const oe=G.lastIndexOf("-");oe===-1?T({localized:(0,h.$8f)(F,"package.nls.json"),original:null}):(G=G.substring(0,oe),V(G))})};if(W.devMode||W.pseudo||!W.language)return T({localized:(0,h.$8f)(F,"package.nls.json"),original:null});V(W.language)})}u(F,W){return`[${F.path}]: ${W}`}};le=pe([se(1,P.$0o),se(2,S.$nk),se(3,a.$Qj),se(4,s.$Pi)],le);let _=class extends le{constructor(F,W,T,U,V,G,X){super(W,U,V,G,X),this.z=F,this.C=T,this.w=this.B(new A.$rg(3e3)),this.y=this.B(new o.$7c),this.onDidChangeCache=this.y.event}async scanExtensions(F){const W=this.H(F),T=await this.D(W);if(this.v=F,T&&T.input&&Z.equals(T.input,this.v))return this.j.debug("Using cached extensions scan result",F.location.toString()),this.w.trigger(()=>this.G()),T.result.map(V=>(V.location=d.URI.revive(V.location),V));const U=await super.scanExtensions(F);return await this.F(W,{input:F,result:U}),U}async D(F){try{const W=await this.i.readFile(F),T=JSON.parse(W.value.toString());return{result:T.result,input:(0,l.$Wg)(T.input)}}catch(W){this.j.debug("Error while reading the extension cache file:",F.path,(0,N.$9)(W))}return null}async F(F,W){try{await this.i.writeFile(F,L.$Jb.fromString(JSON.stringify(W)))}catch(T){this.j.debug("Error while writing the extension cache file:",F.path,(0,N.$9)(T))}}async G(){if(!this.v)return;const F=this.H(this.v),W=await this.D(F);if(!W)return;const T=W.result,U=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!D.$Jm(U,T))try{this.j.info("Invalidating Cache",T,U),await this.i.del(F),this.y.fire()}catch(V){this.j.error(V)}}H(F){const W=this.I(F);return this.h.extUri.joinPath(W.cacheHome,F.type===0?v.$Al:v.$zl)}I(F){return F.type===0?this.C.defaultProfile:F.profile?this.h.extUri.isEqual(F.location,this.z.extensionsResource)?this.z:this.C.profiles.find(W=>this.h.extUri.isEqual(F.location,W.extensionsResource))??this.z:this.C.defaultProfile}};_=pe([se(2,E.$pk),se(3,P.$0o),se(4,S.$nk),se(5,a.$Qj),se(6,s.$Pi)],_);function ae(te,F){const W=(0,$.$go)(te.manifest.publisher,te.manifest.name);return{id:W,identifier:new v.$Fl(W),isBuiltin:te.type===0,isUserBuiltin:te.type===1&&te.isBuiltin,isUnderDevelopment:F,extensionLocation:te.location,uuid:te.identifier.uuid,targetPlatform:te.targetPlatform,...te.manifest}}e.$ep=ae;class ce extends ee{constructor(F,W,T,U,V,G,X,K,oe,k,r,p){super(F,W,(0,h.$8f)(T,".vscode-oss-dev","extensions","control.json"),U,V,G,X,K,oe,k,r,p),this.N=(async()=>{if(m.$y)try{const z=await this.s.readFile(d.URI.file(m.$y));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(F){return this.N}}e.$fp=ce}),define(ne[154],re([0,1,58,8,33,4,2,15,16,24,6,23]),function(J,e,M,A,D,L,N,b,u,c,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=void 0;let m=class extends N.$lb{constructor(O,y){super(),this.b=O,this.f=y,this.a=new A.$zg(5)}async postUninstall(O){const y=this.g(O,"uninstall");y&&(this.f.info(O.identifier.id,O.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(y.script,"uninstall",y.args,!0,O),this.f.info("Finished running post uninstall script",O.identifier.id,O.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",O.identifier.id,O.manifest.version),this.f.error(g)}}));try{await c.Promises.rm(this.j(O))}catch(g){this.f.error("Error while removing extension storage path",O.identifier.id),this.f.error(g)}}g(O,y){const g=`vscode:${y}`;if(O.location.scheme===b.Schemas.file&&O.manifest&&O.manifest.scripts&&typeof O.manifest.scripts[g]=="string"){const d=O.manifest.scripts[g].split(" ");return d.length<2||d[0]!=="node"||!d[1]?(this.f.warn(O.identifier.id,O.manifest.version,`${g} should be a node script`),null):{script:(0,u.$ac)(O.location.fsPath,d[1]),args:d.slice(2)||[]}}return null}h(O,y,g,d,f){return new Promise((I,$)=>{const v=this.i(O,y,g,f);let t;const a=i=>{t&&(clearTimeout(t),t=null),i?$(i):I(void 0)};v.on("error",i=>{a((0,D.$$h)(i)||"Unknown")}),v.on("exit",(i,s)=>{a(i?`post-${y} process exited with code ${i}`:void 0)}),d&&(t=setTimeout(()=>{t=null,v.kill(),$("timed out")},5e3))})}i(O,y,g,d){const f={silent:!0,execArgv:void 0},I=(0,M.fork)(O,[`--type=extension-post-${y}`,...g],f);I.stdout.setEncoding("utf8"),I.stderr.setEncoding("utf8");const $=L.Event.fromNodeEventEmitter(I.stdout,"data"),v=L.Event.fromNodeEventEmitter(I.stderr,"data");$(i=>this.f.info(d.identifier.id,d.manifest.version,`post-${y}`,i)),v(i=>this.f.error(d.identifier.id,d.manifest.version,`post-${y}`,i));const t=L.Event.any(L.Event.map($,i=>({data:`%c${i}`,format:[""]})),L.Event.map(v,i=>({data:`%c${i}`,format:["color: red"]})));return L.Event.debounce(t,(i,s)=>i?{data:i.data+s.data,format:[...i.format,...s.format]}:{data:s.data,format:s.format},100)(i=>{console.group(d.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),I}j(O){return(0,u.$ac)(this.b.defaultProfile.globalStorageHome.fsPath,O.identifier.id.toLowerCase())}};e.$hp=m,e.$hp=m=pe([se(0,R.$pk),se(1,w.$Pi)],m)}),define(ne[155],re([0,1,6,23,22,26,40,13,18,11]),function(J,e,M,A,D,L,N,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=void 0;let w=class extends N.$$o{constructor(m,h,O,y,g,d){super(c.URI.file(m.extensionsPath),h,O,y,g,d)}};e.$VM=w,e.$VM=w=pe([se(0,u.$vh),se(1,b.$Qj),se(2,A.$pk),se(3,D.$nk),se(4,L.$Tk),se(5,M.$Pi)],w)}),define(ne[156],re([0,1,11,18,40,50,13,10,6,31,22,23]),function(J,e,M,A,D,L,N,b,u,c,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J4b=void 0;let m=class extends L.$fp{constructor(O,y,g,d,f,I,$,v){super(M.URI.file(f.builtinExtensionsPath),M.URI.file(f.extensionsPath),f.userHome,O.defaultProfile,O,y,g,d,f,I,$,v)}};e.$J4b=m,e.$J4b=m=pe([se(0,R.$pk),se(1,D.$0o),se(2,N.$Qj),se(3,u.$Pi),se(4,A.$vh),se(5,c.$8i),se(6,w.$nk),se(7,b.$mh)],m)}),define(ne[157],re([0,1,8,4,2,123,3,86,10,23]),function(J,e,M,A,D,L,N,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Io=e.$Ho=e.$Go=void 0,e.$Go="__$__isNewStorageMarker",e.$Ho="__$__targetStorageMarker",e.$Io=(0,u.$nh)("storageService");var w;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(w||(e.WillSaveStateReason=w={}));var R;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(R||(e.StorageScope=R={}));var m;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function h(f){const I=f.get(e.$Ho);if(I)try{return JSON.parse(I)}catch{}return Object.create(null)}e.$Jo=h;class O extends D.$lb{static{this.a=60*1e3}constructor(I={flushInterval:O.a}){super(),this.j=I,this.b=this.B(new A.$0c),this.onDidChangeValue=this.b.event,this.c=this.B(new A.$0c),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.$7c),this.onWillSaveState=this.f.event,this.h=this.B(new M.$Eg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.$mb),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,M.$Ig)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.J()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(I,$){const{key:v,external:t}=$;if(v===e.$Ho){switch(I){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:I})}else this.b.fire({scope:I,key:v,target:this.F(I)[v],external:t})}r(I){this.f.fire({reason:I})}get(I,$,v){return this.L($)?.get(I,v)}getBoolean(I,$,v){return this.L($)?.getBoolean(I,v)}getNumber(I,$,v){return this.L($)?.getNumber(I,v)}getObject(I,$,v){return this.L($)?.getObject(I,v)}storeAll(I,$){this.t(()=>{for(const v of I)this.store(v.key,v.value,v.scope,v.target,$)})}store(I,$,v,t,a=!1){if((0,N.$re)($)){this.remove(I,v,a);return}this.t(()=>{this.u(I,v,t),this.L(v)?.set(I,$,a)})}remove(I,$,v=!1){this.t(()=>{this.u(I,$,void 0),this.L($)?.delete(I,v)})}t(I){this.b.pause(),this.c.pause();try{I()}finally{this.b.resume(),this.c.resume()}}keys(I,$){const v=[],t=this.F(I);for(const a of Object.keys(t))t[a]===$&&v.push(a);return v}u(I,$,v,t=!1){const a=this.F($);typeof v=="number"?a[I]!==v&&(a[I]=v,this.L($)?.set(e.$Ho,JSON.stringify(a),t)):typeof a[I]=="number"&&(delete a[I],this.L($)?.set(e.$Ho,JSON.stringify(a),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(I){switch(I){case-1:return this.D;case 0:return this.z;default:return this.w}}G(I){const $=this.L(I);return $?h($):Object.create(null)}isNew(I){return this.getBoolean(e.$Go,I)===!0}async flush(I=w.NONE){this.f.fire({reason:I});const $=this.L(-1),v=this.L(0),t=this.L(1);switch(I){case w.NONE:await M.Promises.settled([$?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await M.Promises.settled([$?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const I=this.L(-1)?.items??new Map,$=this.L(0)?.items??new Map,v=this.L(1)?.items??new Map;return d(I,$,v,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(I,$){return this.r(w.NONE),(0,c.$ok)(I)?this.N(I,$):this.O(I,$)}H(I,$){return!(I.id===$.id||y($)&&y(I))}I(I,$,v){this.t(()=>{const t=new Set;for(const[a,i]of I)t.add(a),$.get(a)!==i&&this.n(v,{key:a,external:!0});for(const[a]of $.items)t.has(a)||this.n(v,{key:a,external:!0})})}}e.$Ko=O;function y(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$Lo=y;class g extends O{constructor(){super(),this.p=this.B(new b.$Eo(new b.$Fo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new b.$Eo(new b.$Fo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new b.$Eo(new b.$Fo,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(I=>this.n(1,I))),this.B(this.P.onDidChangeStorage(I=>this.n(0,I))),this.B(this.p.onDidChangeStorage(I=>this.n(-1,I)))}L(I){switch(I){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(I){switch(I){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(I){return!1}}e.$Mo=g;async function d(f,I,$,v,t,a){const i=B=>{try{return JSON.parse(B)}catch{return B}},s=new Map,n=new Map;f.forEach((B,ee)=>{s.set(ee,B),n.set(ee,i(B))});const o=new Map,l=new Map;I.forEach((B,ee)=>{o.set(ee,B),l.set(ee,i(B))});const P=new Map,E=new Map;$.forEach((B,ee)=>{P.set(ee,B),E.set(ee,i(B))}),console.group(v!==t?`Storage: Application (path: ${v})`:`Storage: Application & Profile (path: ${v}, default profile)`);const S=[];if(s.forEach((B,ee)=>{S.push({key:ee,value:B})}),console.table(S),console.groupEnd(),console.log(n),v!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const B=[];o.forEach((ee,Z)=>{B.push({key:Z,value:ee})}),console.table(B),console.groupEnd(),console.log(l)}console.group(`Storage: Workspace (path: ${a})`);const j=[];P.forEach((B,ee)=>{j.push({key:ee,value:B})}),console.table(j),console.groupEnd(),console.log(E)}e.$No=d}),define(ne[158],re([0,1,19,20,9,12,34,3,11,25,18,21,27,48,13,6,31,45,142,157,26]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O,y,g,d,f,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=void 0;const v=L.$o?"web":(0,R.$In)(L.$t,N.$8b),t="X-Market-Search-Activity-Id";var a;(function(k){k[k.None=0]="None",k[k.IncludeVersions=1]="IncludeVersions",k[k.IncludeFiles=2]="IncludeFiles",k[k.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",k[k.IncludeSharedAccounts=8]="IncludeSharedAccounts",k[k.IncludeVersionProperties=16]="IncludeVersionProperties",k[k.ExcludeNonValidated=32]="ExcludeNonValidated",k[k.IncludeInstallationTargets=64]="IncludeInstallationTargets",k[k.IncludeAssetUri=128]="IncludeAssetUri",k[k.IncludeStatistics=256]="IncludeStatistics",k[k.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",k[k.Unpublished=4096]="Unpublished",k[k.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(a||(a={}));function i(...k){return String(k.reduce((r,p)=>r|p,0))}var s;(function(k){k[k.Tag=1]="Tag",k[k.ExtensionId=4]="ExtensionId",k[k.Category=5]="Category",k[k.ExtensionName=7]="ExtensionName",k[k.Target=8]="Target",k[k.Featured=9]="Featured",k[k.SearchText=10]="SearchText",k[k.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const n={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},P={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:a.None,criteria:[],assetTypes:[]};class E{constructor(r=P){this.d=r}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(r,p=this.d.pageSize){return new E({...this.d,pageNumber:r,pageSize:p})}withFilter(r,...p){const z=[...this.d.criteria,...p.length?p.map(C=>({filterType:r,value:C})):[{filterType:r}]];return new E({...this.d,criteria:z})}withSortBy(r){return new E({...this.d,sortBy:r})}withSortOrder(r){return new E({...this.d,sortOrder:r})}withFlags(...r){return new E({...this.d,flags:r.reduce((p,z)=>p|z,0)})}withAssetTypes(...r){return new E({...this.d,assetTypes:r})}withSource(r){return new E({...this.d,source:r})}get raw(){const{criteria:r,pageNumber:p,pageSize:z,sortBy:C,sortOrder:H,flags:Y,assetTypes:ie}=this.d;return{filters:[{criteria:r,pageNumber:p,pageSize:z,sortBy:C,sortOrder:H}],assetTypes:ie,flags:Y}}get searchText(){const r=this.d.criteria.filter(p=>p.filterType===s.SearchText)[0];return r&&r.value?r.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(r=>String(r.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function S(k,r){const p=(k||[]).filter(z=>z.statisticName===r)[0];return p?p.value:0}function j(k){const r="Microsoft.VisualStudio.Code.Translation.";return k.files.filter(z=>z.assetType.indexOf(r)===0).reduce((z,C)=>{const H=Z(k,C.assetType);return H&&z.push([C.assetType.substring(r.length),H]),z},[])}function B(k){if(k.properties){const r=k.properties.filter(C=>C.key===n.Repository),p=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=r.filter(C=>p.test(C.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return Z(k,n.Repository)}function ee(k){return{uri:`${k.fallbackAssetUri}/${n.VSIX}?redirect=true${k.targetPlatform?`&targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${n.VSIX}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}}function Z(k,r){return k.files.filter(z=>z.assetType===r)[0]?{uri:`${k.assetUri}/${r}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`,fallbackUri:`${k.fallbackAssetUri}/${r}${k.targetPlatform?`?targetPlatform=${k.targetPlatform}`:""}`}:null}function le(k,r){const p=k.properties?k.properties.filter(C=>C.key===r):[],z=p.length>0&&p[0].value;return z?z.split(",").map(C=>(0,m.$ho)(C)):[]}function _(k){const r=k.properties?k.properties.filter(p=>p.key===o.Engine):[];return r.length>0&&r[0].value||""}function ae(k){const r=k.properties?k.properties.filter(p=>p.key===o.PreRelease):[];return r.length>0&&r[0].value==="true"}function ce(k){const r=k.properties?k.properties.filter(z=>z.key===o.LocalizedLanguages):[],p=r.length>0&&r[0].value||"";return p?p.split(","):[]}function te(k){return k.properties?.find(r=>r.key===o.SponsorLink)?.value}function F(k){return k.indexOf("preview")!==-1}function W(k){return k.targetPlatform?(0,R.$Hn)(k.targetPlatform):"undefined"}function T(k){const r=(0,M.$qf)(k.versions.map(W)),p=!!k.tags?.includes(R.$Dn),z=r.indexOf("web");return p?z===-1&&r.push("web"):z!==-1&&r.splice(z,1),r}function U(k,r){const p=(0,R.$Ln)(r);for(let z=0;z<k.length;z++){const C=k[z];if(C.version===k[z-1]?.version){let H=z;const Y=W(C);if(Y===r)for(;H>0&&k[H-1].version===C.version;)H--;else if(p.includes(Y))for(;H>0&&k[H-1].version===C.version&&W(k[H-1])!==r;)H--;H!==z&&(k.splice(z,1),k.splice(H,0,C))}}return k}e.$Qo=U;function V(k,r,p){k.telemetryData={index:r,querySource:p,queryActivityId:k.queryContext?.[t]}}function G(k,r,p,z){const C=k.versions[0],H={manifest:Z(r,n.Manifest),readme:Z(r,n.Details),changelog:Z(r,n.Changelog),license:Z(r,n.License),repository:B(r),download:ee(r),icon:Z(r,n.Icon),signature:Z(r,n.Signature),coreTranslations:j(r)};return{identifier:{id:(0,m.$io)(k.publisher.publisherName,k.extensionName),uuid:k.extensionId},name:k.extensionName,version:r.version,displayName:k.displayName,publisherId:k.publisher.publisherId,publisher:k.publisher.publisherName,publisherDisplayName:k.publisher.displayName,publisherDomain:k.publisher.domain?{link:k.publisher.domain,verified:!!k.publisher.isDomainVerified}:void 0,publisherSponsorLink:te(C),description:k.shortDescription||"",installCount:S(k.statistics,"install"),rating:S(k.statistics,"averagerating"),ratingCount:S(k.statistics,"ratingcount"),categories:k.categories||[],tags:k.tags||[],releaseDate:Date.parse(k.releaseDate),lastUpdated:Date.parse(k.lastUpdated),allTargetPlatforms:p,assets:H,properties:{dependencies:le(r,o.Dependency),extensionPack:le(r,o.ExtensionPack),engine:_(r),localizedLanguages:ce(r),targetPlatform:W(r),isPreReleaseVersion:ae(r)},hasPreReleaseVersion:ae(C),hasReleaseVersion:!0,preview:F(k.flags),isSigned:!!H.signature,queryContext:z}}let X=class{constructor(r,p,z,C,H,Y,ie,de){this.k=p,this.l=z,this.n=C,this.o=H,this.q=Y,this.u=ie,this.w=de;const fe=ie.extensionsGallery,ue=fe?.servicePPEUrl&&de.getValue("_extensionsGallery.enablePPE");this.d=ue?fe.servicePPEUrl:fe?.serviceUrl,this.g=ue?void 0:fe?.searchUrl,this.h=fe?.controlUrl,this.j=(0,f.$Po)(ie.version,ie,this.n,this.w,this.q,r,this.o)}x(r=""){return`${this.d}${r}`}isEnabled(){return!!this.d}async getExtensions(r,p,z){const C=A.CancellationToken.isCancellationToken(p)?{}:p,H=A.CancellationToken.isCancellationToken(p)?p:z,Y=[],ie=[],de=[],fe=[];let ue=!0;for(const he of r){he.uuid?ie.push(he.uuid):Y.push(he.id);const ye=!!(he.version||he.preRelease);de.push({id:he.id,uuid:he.uuid,includePreRelease:ye}),he.version&&fe.push({id:he.id,uuid:he.uuid,version:he.version}),ue=ue&&!!he.hasPreRelease&&!ye}if(!ie.length&&!Y.length)return[];let me=new E().withPage(1,r.length);ie.length&&(me=me.withFilter(s.ExtensionId,...ie)),Y.length&&(me=me.withFilter(s.ExtensionName,...Y)),(C.queryAllVersions||ue)&&(me=me.withFlags(me.flags,a.IncludeVersions)),C.source&&(me=me.withSource(C.source));const{extensions:ge}=await this.z(me,{targetPlatform:C.targetPlatform??v,includePreRelease:de,versions:fe,compatible:!!C.compatible},H);return C.source&&ge.forEach((he,ye)=>V(he,ye,C.source)),ge}async getCompatibleExtension(r,p,z){if((0,R.$Jn)(r.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(r,p,z))return r;const C=new E().withFlags(a.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,r.identifier.uuid),{extensions:H}=await this.z(C,{targetPlatform:z,compatible:!0,includePreRelease:p},A.CancellationToken.None);return H[0]||null}async isExtensionCompatible(r,p,z){if(!(0,R.$Kn)(r.properties.targetPlatform,r.allTargetPlatforms,z)||!p&&r.properties.isPreReleaseVersion)return!1;let C=r.properties.engine;if(!C){const H=await this.getManifest(r,A.CancellationToken.None);if(!H)throw new Error("Manifest was not found");C=H.engines.vscode}return(0,h.$vo)(C,this.u.version,this.u.date)}async y(r,p,z,C,H){if(!(0,R.$Kn)(W(r),C,H)||p!=="any"&&ae(r)!==(p==="prerelease"))return!1;if(z)try{const Y=await this.E(r);if(!(0,h.$vo)(Y,this.u.version,this.u.date))return!1}catch(Y){return this.l.error(`Error while getting the engine for the version ${r.version}.`,(0,D.$9)(Y)),!1}return!0}async query(r,p){let z=r.text||"";const C=r.pageSize??50;let H=new E().withPage(1,C);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,me,ge)=>(H=H.withFilter(s.Category,ge||me),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,me,ge)=>(H=H.withFilter(s.Tag,ge||me),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(H=H.withFilter(s.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),H=H.withFilter(s.SearchText,z)),H=H.withSortBy(0)):r.ids?H=H.withFilter(s.ExtensionId,...r.ids):r.names?H=H.withFilter(s.ExtensionName,...r.names):H=H.withSortBy(4),typeof r.sortBy=="number"&&(H=H.withSortBy(r.sortBy)),typeof r.sortOrder=="number"&&(H=H.withSortOrder(r.sortOrder)),r.source&&(H=H.withSource(r.source));const Y=async(ue,me)=>{const{extensions:ge,total:he}=await this.z(ue,{targetPlatform:v,compatible:!1,includePreRelease:!!r.includePreRelease},me);return ge.forEach((ye,Ee)=>V(ye,(ue.pageNumber-1)*ue.pageSize+Ee,r.source)),{extensions:ge,total:he}},{extensions:ie,total:de}=await Y(H,p),fe=async(ue,me)=>{if(me.isCancellationRequested)throw new D.$3;const{extensions:ge}=await Y(H.withPage(ue+1),me);return ge};return{firstPage:ie,total:de,pageSize:H.pageSize,getPage:fe}}async z(r,p,z){const C=r.flags;r.flags&a.IncludeLatestVersionOnly&&r.flags&a.IncludeVersions&&(r=r.withFlags(r.flags&~a.IncludeVersions,a.IncludeLatestVersionOnly)),!(r.flags&a.IncludeLatestVersionOnly)&&!(r.flags&a.IncludeVersions)&&(r=r.withFlags(r.flags,a.IncludeLatestVersionOnly)),p.versions?.length&&(r=r.withFlags(r.flags&~a.IncludeLatestVersionOnly,a.IncludeVersions)),r=r.withFlags(r.flags,a.IncludeAssetUri,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeStatistics,a.IncludeVersionProperties);const{galleryExtensions:H,total:Y,context:ie}=await this.B(r,z);if(!(r.flags&a.IncludeLatestVersionOnly)){const me=[];for(const ge of H){const he=await this.A(ge,p,ie);he&&me.push(he)}return{extensions:me,total:Y}}const fe=[],ue=new Map;for(let me=0;me<H.length;me++){const ge=H[me],he={id:(0,m.$io)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},ye=(0,b.$oe)(p.includePreRelease)?p.includePreRelease:!!p.includePreRelease.find(je=>(0,m.$do)(je,he))?.includePreRelease;if(p.compatible&&(0,R.$Jn)(T(ge),p.targetPlatform))continue;const Ee=await this.A(ge,p,ie);!Ee||Ee.properties.isPreReleaseVersion&&(!ye||!Ee.hasReleaseVersion)||!Ee.properties.isPreReleaseVersion&&Ee.properties.targetPlatform!==p.targetPlatform&&Ee.hasPreReleaseVersion?ue.set(ge.extensionId,me):fe.push([me,Ee])}if(ue.size){const me=new Date().getTime(),ge=new E().withFlags(C&~a.IncludeLatestVersionOnly,a.IncludeVersions).withPage(1,ue.size).withFilter(s.ExtensionId,...ue.keys()),{extensions:he}=await this.z(ge,p,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-me,count:ue.size});for(const ye of he){const Ee=ue.get(ye.identifier.uuid);fe.push([Ee,ye])}}return{extensions:fe.sort((me,ge)=>me[0]-ge[0]).map(([,me])=>me),total:Y}}async A(r,p,z){const C={id:(0,m.$io)(r.publisher.publisherName,r.extensionName),uuid:r.extensionId},H=p.versions?.find(fe=>(0,m.$do)(fe,C))?.version,Y=(0,b.$oe)(p.includePreRelease)?p.includePreRelease:!!p.includePreRelease.find(fe=>(0,m.$do)(fe,C))?.includePreRelease,ie=T(r),de=U(r.versions,p.targetPlatform);if(p.compatible&&(0,R.$Jn)(ie,p.targetPlatform))return null;for(let fe=0;fe<de.length;fe++){const ue=de[fe];if(!(H&&ue.version!==H)){if(await this.y(ue,Y?"any":"release",p.compatible,ie,p.targetPlatform))return G(r,ue,ie,z);if(H&&ue.version===H)return null}}return H||p.compatible?null:G(r,r.versions[0],ie)}async B(r,p){if(!this.isEnabled())throw new Error("No extension gallery service configured.");r=r.withFlags(r.flags,a.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(a.Unpublished));const z=await this.j,C=JSON.stringify(r.raw),H={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(C.length)},Y=new Date().getTime();let ie,de,fe=0;try{if(ie=await this.k.request({type:"POST",url:this.g&&r.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:C,headers:H},p),ie.res.statusCode&&ie.res.statusCode>=400&&ie.res.statusCode<500)return{galleryExtensions:[],total:fe};const ue=await(0,d.$Bo)(ie);if(ue){const me=ue.results[0],ge=me.extensions,he=me.resultMetadata&&me.resultMetadata.filter(ye=>ye.metadataType==="ResultCount")[0];return fe=he&&he.metadataItems.filter(ye=>ye.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:fe,context:{[t]:ie.res.headers.activityid}}}return{galleryExtensions:[],total:fe}}catch(ue){throw de=ue,ue}finally{this.o.publicLog2("galleryService:query",{...r.telemetryData,requestBodySize:String(C.length),duration:new Date().getTime()-Y,success:!!ie&&(0,d.$yo)(ie),responseBodySize:ie?.res.headers["Content-Length"],statusCode:ie?String(ie.res.statusCode):void 0,errorCode:de?(0,D.$2)(de)?"canceled":(0,D.$9)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(fe)})}}async reportStatistic(r,p,z,C){if(!this.isEnabled())return;const H=L.$o?this.x(`/itemName/${r}.${p}/version/${z}/statType/${C==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${r}/extensions/${p}/${z}/stats?statType=${C}`),Y=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",de={...await this.j,Accept:Y};try{await this.k.request({type:"POST",url:H,headers:de},A.CancellationToken.None)}catch{}}async download(r,p,z){this.l.trace("ExtensionGalleryService#download",r.identifier.id);const C=(0,m.$lo)(r),H=new Date().getTime(),Y=me=>this.o.publicLog("galleryService:downloadVSIX",{...C,duration:me}),ie=z===2?"install":z===3?"update":"",de=ie?{uri:`${r.assets.download.uri}${u.URI.parse(r.assets.download.uri).query?"&":"?"}${ie}=true`,fallbackUri:`${r.assets.download.fallbackUri}${u.URI.parse(r.assets.download.fallbackUri).query?"&":"?"}${ie}=true`}:r.assets.download,fe=r.queryContext?.[t]?{[t]:r.queryContext[t]}:void 0,ue=await this.D(de,fe?{headers:fe}:void 0);await this.q.writeFile(p,ue.stream),Y(new Date().getTime()-H)}async downloadSignatureArchive(r,p){if(!r.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",r.identifier.id);const z=await this.D(r.assets.signature);await this.q.writeFile(p,z.stream)}async getReadme(r,p){if(r.assets.readme){const z=await this.D(r.assets.readme,{},p);return await(0,d.$Ao)(z)||""}return""}async getManifest(r,p){if(r.assets.manifest){const z=await this.D(r.assets.manifest,{},p),C=await(0,d.$Ao)(z);return C?JSON.parse(C):null}return null}async C(r,p){const z=Z(r,n.Manifest);if(!z)throw new Error("Manifest was not found");const C={"Accept-Encoding":"gzip"},H=await this.D(z,{headers:C});return await(0,d.$Bo)(H)}async getCoreTranslation(r,p){const z=r.assets.coreTranslations.filter(C=>C[0]===p.toUpperCase())[0];if(z){const C=await this.D(z[1]),H=await(0,d.$Ao)(C);return H?JSON.parse(H):null}return null}async getChangelog(r,p){if(r.assets.changelog){const z=await this.D(r.assets.changelog,{},p);return await(0,d.$Ao)(z)||""}return""}async getAllCompatibleVersions(r,p,z){let C=new E().withFlags(a.IncludeVersions,a.IncludeCategoryAndTags,a.IncludeFiles,a.IncludeVersionProperties).withPage(1,1);r.identifier.uuid?C=C.withFilter(s.ExtensionId,r.identifier.uuid):C=C.withFilter(s.ExtensionName,r.identifier.id);const{galleryExtensions:H}=await this.B(C,A.CancellationToken.None);if(!H.length)return[];const Y=T(H[0]);if((0,R.$Jn)(Y,z))return[];const ie=[];await Promise.all(H[0].versions.map(async ue=>{try{await this.y(ue,p?"any":"release",!0,Y,z)&&ie.push(ue)}catch{}}));const de=[],fe=new Set;for(const ue of U(ie,z))fe.has(ue.version)||(fe.add(ue.version),de.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:ae(ue)}));return de}async D(r,p={},z=A.CancellationToken.None){const C=await this.j,H={type:"GET"},Y={...C,...p.headers||{}};p={...p,...H,headers:Y};const ie=r.uri,de=r.fallbackUri,fe={...p,url:ie};try{const ue=await this.k.request(fe,z);if(ue.res.statusCode===200)return ue;const me=await(0,d.$Ao)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${me}`)}catch(ue){if((0,D.$2)(ue))throw ue;const me=(0,D.$9)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:ie,message:me});const ge={...p,url:de};return this.k.request(ge,z)}}async E(r){let p=_(r);if(!p){const z=await this.C(r,A.CancellationToken.None);if(!z)throw new Error("Manifest was not found");p=z.engines.vscode}return p}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const r=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(r.res.statusCode!==200)throw new Error("Could not get extensions report.");const p=await(0,d.$Bo)(r),z=[],C={},H=[];if(p){for(const Y of p.malicious)z.push({id:Y});if(p.migrateToPreRelease)for(const[Y,ie]of Object.entries(p.migrateToPreRelease))(!ie.engine||(0,h.$vo)(ie.engine,this.u.version,this.u.date))&&(C[Y.toLowerCase()]={disallowInstall:!0,extension:{id:ie.id,displayName:ie.displayName,autoMigrate:{storage:!!ie.migrateStorage},preRelease:!0}});if(p.deprecated)for(const[Y,ie]of Object.entries(p.deprecated))ie&&(C[Y.toLowerCase()]=(0,b.$oe)(ie)?{}:ie);if(p.search)for(const Y of p.search)H.push(Y)}return{malicious:z,deprecated:C,search:H}}};X=pe([se(1,d.$wo),se(2,y.$Pi),se(3,w.$uh),se(4,$.$Tk),se(5,O.$Qj),se(6,g.$8i),se(7,c.$Th)],X);let K=class extends X{constructor(r,p,z,C,H,Y,ie,de){super(r,p,z,C,H,Y,ie,de)}};e.$Ro=K,e.$Ro=K=pe([se(0,I.$Io),se(1,d.$wo),se(2,y.$Pi),se(3,w.$uh),se(4,$.$Tk),se(5,O.$Qj),se(6,g.$8i),se(7,c.$Th)],K);let oe=class extends X{constructor(r,p,z,C,H,Y,ie){super(void 0,r,p,z,C,H,Y,ie)}};e.$So=oe,e.$So=oe=pe([se(0,d.$wo),se(1,y.$Pi),se(2,w.$uh),se(3,$.$Tk),se(4,O.$Qj),se(5,g.$8i),se(6,c.$Th)],oe)}),define(ne[159],re([0,1,11,18,13,6,139,22,23,3,68]),function(J,e,M,A,D,L,N,b,u,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UM=e.$TM=e.$SM=void 0;let R=class Ve extends u.$sk{static{this.a="profileAssociationsMigration"}constructor(y,g,d,f,I){super(d,f,g,I),this.P=y,this.Q=d}J(){return this.P.getItem(Ve.b,[]).map(g=>({...g,location:(0,c.$ie)(g.location)?this.s.extUri.joinPath(this.profilesHome,g.location):M.URI.revive(g.location)}))}M(){const y=this.P.getItem(Ve.c,{});return this.P.getItem(Ve.a,!1)?y:this.I(y)}O(){return this.s.extUri.joinPath(M.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$SM=R,e.$SM=R=pe([se(0,N.$NM),se(1,b.$nk),se(2,A.$vh),se(3,D.$Qj),se(4,L.$Pi)],R);let m=class Te extends R{constructor(y,g,d,f,I){super(y,g,d,f,I),this.W=y}L(y){y.length?this.W.setItem(Te.b,y.map(g=>({...g,location:this.s.extUri.basename(g.location)}))):this.W.removeItem(Te.b)}J(){const y=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(y),this.W.setItem("userDataProfilesMigration",!0)),y}N(y){y.emptyWindows||y.workspaces?this.W.setItem(Te.c,y):this.W.removeItem(Te.c)}M(){const y="workspaceAndProfileInfo",g=this.W.getItem(y,void 0);if(g){this.W.removeItem(y);const f=g.reduce((I,{workspace:$,profile:v})=>(I[M.URI.revive($).toString()]=M.URI.revive(v).toString(),I),{});this.W.setItem(Te.c,{workspaces:f})}const d=super.M();return this.W.getItem(Te.a,!1)||(this.N(d),this.W.setItem(Te.a,!0)),d}};e.$TM=m,e.$TM=m=pe([se(0,N.$OM),se(1,b.$nk),se(2,A.$vh),se(3,D.$Qj),se(4,L.$Pi)],m);let h=class extends m{constructor(y,g,d,f){super(new w.$RM(0,g,f,d),y,g,d,f)}async init(){return await this.W.init(),super.init()}};e.$UM=h,e.$UM=h=pe([se(0,b.$nk),se(1,A.$vh),se(2,D.$Qj),se(3,L.$Pi)],h)}),define(ne[51],re([0,1,125,8,16,3,24,87,174,175]),function(J,e,M,A,D,L,N,b,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.zip=e.$1o=e.$Zo=void 0,e.$Zo="end of central directory record signature not found";const w=new RegExp(e.$Zo);class R extends Error{constructor(a,i){let s=i.message;switch(a){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=a,this.cause=i}}e.$1o=R;function m(t){const a=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>a&i).reduce((i,s)=>i+s,a&61440)}function h(t){if(t instanceof R)return t;let a;return w.test(t.message)&&(a="CorruptZip"),new R(a,t)}function O(t,a,i,s,n,o){const l=D.$dc(a),P=D.$ac(s,l);if(!P.startsWith(s))return Promise.reject(new Error(b.localize(0,null,a)));const E=D.$ac(s,a);let S;return o.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(N.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((j,B)=>{if(!o.isCancellationRequested)try{S=(0,M.createWriteStream)(E,{mode:i}),S.once("close",()=>j()),S.once("error",B),t.once("error",B),t.pipe(S)}catch(ee){B(ee)}}))}function y(t,a,i,s){let n=(0,A.$hg)(()=>Promise.resolve()),o=0;return s.onCancellationRequested(()=>{n.cancel(),t.close()}),new Promise((l,P)=>{const E=new A.$og,S=j=>{j.isCancellationRequested||(o++,t.readEntry())};t.once("error",P),t.once("close",()=>n.then(()=>{s.isCancellationRequested||t.entryCount===o?l():P(new R("Incomplete",new Error(b.localize(1,null,o,t.entryCount))))},P)),t.readEntry(),t.on("entry",j=>{if(s.isCancellationRequested)return;if(!i.sourcePathRegex.test(j.fileName)){S(s);return}const B=j.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(B)){const le=D.$ac(a,B);n=(0,A.$hg)(_=>N.Promises.mkdir(le,{recursive:!0}).then(()=>S(_)).then(void 0,P));return}const ee=d(t,j),Z=m(j);n=(0,A.$hg)(le=>E.queue(()=>ee.then(_=>O(_,B,Z,a,i,le).then(()=>S(le)))).then(null,P))})})}function g(t,a=!1){return new Promise((i,s)=>{(0,u.open)(t,a?{lazyEntries:!0}:void 0,(n,o)=>{n?s(h(n)):i((0,L.$te)(o))})})}function d(t,a){return new Promise((i,s)=>{t.openReadStream(a,(n,o)=>{n?s(h(n)):i((0,L.$te)(o))})})}function f(t,a){return new Promise((i,s)=>{const n=new c.ZipFile;a.forEach(l=>{l.contents?n.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&n.addFile(l.localPath,l.path)}),n.end();const o=(0,M.createWriteStream)(t);n.outputStream.pipe(o),n.outputStream.once("error",s),o.once("error",s),o.once("finish",()=>i(t))})}e.zip=f;function I(t,a,i={},s){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let o=g(t,!0);return i.overwrite&&(o=o.then(l=>N.Promises.rm(a).then(()=>l))),o.then(l=>y(l,a,{sourcePathRegex:n},s))}e.$3o=I;function $(t,a){return g(t).then(i=>new Promise((s,n)=>{i.on("entry",o=>{o.fileName===a&&d(i,o).then(l=>s(l),l=>n(l))}),i.once("close",()=>n(new Error(b.localize(2,null,a))))}))}function v(t,a){return $(t,a).then(i=>new Promise((s,n)=>{const o=[];i.once("error",n),i.on("data",l=>o.push(l)),i.on("end",()=>s(Buffer.concat(o)))}))}e.$4o=v}),define(ne[160],re([0,1,8,9,2,15,12,17,43,3,29,24,51,25,18,21,27,60,13,6]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O,y,g,d,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=void 0;let $=class Be extends D.$lb{static{this.c=".sigzip"}constructor(t,a,i,s,n,o){super(),this.h=a,this.i=i,this.j=s,this.k=n,this.l=o,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,a,i){await this.g;const s=(0,b.$8f)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,s,o=>this.i.download(t,o,a))}catch(o){throw new y.$On(o.message,y.ExtensionManagementErrorCode.Download)}let n=!1;if(i&&this.m(t)){const o=await this.n(t);try{n=await this.k.verify(s.fsPath,o.fsPath,this.l.getLevel()===I.LogLevel.Trace)}catch(l){const P=l;if(n=P.code,P.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${P.output}`),n===y.ExtensionSignaturetErrorCode.PackageIsInvalidZip||n===y.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new y.$On(m.$Zo,y.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(l){this.l.error(l)}}}return n===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):n===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${n}': ${t.identifier.id}`),{location:s,verificationStatus:n}}m(t){if(!t.isSigned)return!1;const a=this.j.getValue("extensions.verifySignature");return(0,c.$oe)(a)?a:!0}async n(t){await this.g;const a=(0,b.$8f)(this.extensionsDownloadDir,`${this.v(t)}${Be.c}`);return await this.r(t,a,i=>this.i.downloadSignatureArchive(t,i)),a}async r(t,a,i){if(await this.h.exists(a))return;if(a.scheme!==L.Schemas.file){await i(a);return}const s=(0,b.$8f)(this.extensionsDownloadDir,`.${(0,w.$5e)()}`);await this.h.exists(s)||await i(s);try{await this.t(s,a,Date.now()+2*60*1e3)}catch(n){try{await this.h.del(s)}catch{}if(n.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,a.path);else throw this.l.info(`Rename failed because of ${(0,A.$9)(n)}. Deleted the file from downloaded location`,s.path),n}}async delete(t){await this.g,await this.h.del(t)}async t(t,a,i){try{await R.Promises.rename(t.fsPath,a.fsPath)}catch(s){if(N.$i&&s&&s.code==="EPERM"&&Date.now()<i)return this.l.info(`Failed renaming ${t} to ${a} with 'EPERM' error. Trying again...`),this.t(t,a,i);throw s}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const a=[],i=[],s=[];for(const l of t.children)if(l.name.endsWith(Be.c))s.push(l.resource);else{const P=g.$eo.parse(l.name);P&&i.push([P,l])}const n=(0,g.$jo)(i,([l])=>l),o=[];for(const l of n)l.sort((P,E)=>u.rcompare(P[0].version,E[0].version)),a.push(...l.slice(1).map(P=>P[1].resource)),o.push(l[0][1]);o.sort((l,P)=>l.mtime-P.mtime),a.push(...o.slice(0,Math.max(0,o.length-this.f)).map(l=>l.resource)),a.push(...s),await M.Promises.settled(a.map(l=>(this.l.trace("Deleting from cache",l.path),this.h.del(l))))}}catch(t){this.l.error(t)}}v(t){return this.f?g.$eo.create(t).toString().toLowerCase():(0,w.$5e)()}};e.$gp=$,e.$gp=$=pe([se(0,O.$vh),se(1,f.$Qj),se(2,y.$Nn),se(3,h.$Th),se(4,d.$To),se(5,I.$Pi)],$)}),define(ne[161],re([0,1,51,97]),function(J,e,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=void 0;function D(L){return(0,M.$4o)(L,"extension/package.json").then(N=>{try{return JSON.parse(N.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.$ip=D}),define(ne[162],re([0,1,8,14,20,33,9,4,42,2,35,15,16,12,17,43,3,11,29,24,51,96,59,18,153,21,27,40,50,160,154,161,134,141,48,13,10,6,31,26,22,23]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O,y,g,d,f,I,$,v,t,a,i,s,n,o,l,P,E,S,j,B,ee,Z,le,_,ae,ce,te,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=void 0,e.$lp=(0,le.$oh)(s.$Pn);const W=".vsctmp";let T=class extends i.$5o{constructor(k,r,p,z,C,H,Y,ie,de,fe,ue,me){super(k,r,ue,p,fe,me),this.bb=C,this.cb=H,this.db=Y,this.eb=de,this.ab=new Map,this.nb=new w.$mi;const ge=this.B(ie.createInstance(E.$hp));this.Y=this.B(ie.createInstance(U,ye=>ge.postUninstall(ye))),this.Z=this.B(new j.$jp(me,de,ue,this,this.y)),this.$=this.B(ie.createInstance(P.$gp));const he=this.B(new B.$kp(this,this.bb,me,H,ue,de,p));this.B(he.onDidChangeExtensionsByAnotherSource(ye=>this.mb(ye))),this.ob()}getTargetPlatform(){return this.fb||(this.fb=(0,n.$oo)(this.eb,this.y)),this.fb}async zip(k){this.y.trace("ExtensionManagementService#zip",k.identifier.id);const r=await this.lb(k),p=await(0,$.zip)((0,O.$8f)(this.$.extensionsDownloadDir,(0,f.$5e)()).fsPath,r);return d.URI.file(p)}async unzip(k){return this.y.trace("ExtensionManagementService#unzip",k.toString()),(await this.install(k)).identifier}async getManifest(k){const{location:r,cleanup:p}=await this.hb(k),z=m.$bc(r.fsPath);try{return await(0,S.$ip)(z)}finally{await p()}}getInstalled(k,r=this.C.defaultProfile.extensionsResource){return this.Y.scanExtensions(k??null,r)}scanAllUserInstalledExtensions(){return this.Y.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(k){return this.Y.scanUserExtensionAtLocation(k)}async install(k,r={}){this.y.trace("ExtensionManagementService#install",k.toString());const{location:p,cleanup:z}=await this.hb(k);try{const C=await(0,S.$ip)(m.$bc(p.fsPath)),H=(0,n.$io)(C.publisher,C.name);if(C.engines&&C.engines.vscode&&!(0,ee.$vo)(C.engines.vscode,this.z.version,this.z.date))throw new Error(v.localize(0,null,H,this.z.version));const Y=await this.D([{manifest:C,extension:p,options:r}]);if(Y[0]?.local)return Y[0]?.local;throw Y[0]?.error?Y[0].error:(0,i.$7o)(new Error(`Unknown error while installing extension ${H}`))}finally{await z()}}async installFromLocation(k,r){this.y.trace("ExtensionManagementService#installFromLocation",k.toString());const p=await this.Y.scanUserExtensionAtLocation(k);if(!p)throw new Error(`Cannot find a valid extension from the location ${k.toString()}`);return await this.qb([[p,void 0]],r),this.y.info("Successfully installed extension",p.identifier.id,r.toString()),p}async installExtensionsFromProfile(k,r,p){this.y.trace("ExtensionManagementService#installExtensionsFromProfile",k,r.toString(),p.toString());const z=(await this.Y.scanExtensions(1,r)).filter(C=>k.some(H=>(0,n.$do)(H,C.identifier)));if(z.length){const C=await Promise.all(z.map(H=>this.Y.scanMetadata(H,r)));await this.qb(z.map((H,Y)=>[H,C[Y]]),p),this.y.info("Successfully installed extensions",z.map(H=>H.identifier.id),p.toString())}return z}async updateMetadata(k,r,p=this.C.defaultProfile.extensionsResource){return this.y.trace("ExtensionManagementService#updateMetadata",k.identifier.id),r.isPreReleaseVersion&&(r.preRelease=!0),r.isMachineScoped=r.isMachineScoped||void 0,r.isBuiltin=r.isBuiltin||void 0,r.pinned=r.pinned||void 0,k=await this.Y.updateMetadata(k,r,p),this.Z.invalidate(p),this.s.fire(k),k}async reinstallFromGallery(k){if(this.y.trace("ExtensionManagementService#reinstallFromGallery",k.identifier.id),!this.u.isEnabled())throw new Error(v.localize(1,null));const r=await this.getTargetPlatform(),[p]=await this.u.getExtensions([{...k.identifier,preRelease:k.preRelease}],{targetPlatform:r,compatible:!0},D.CancellationToken.None);if(!p)throw new Error(v.localize(2,null));await this.Y.setUninstalled(k);try{await this.Y.removeUninstalledExtension(k)}catch(z){throw new Error(v.localize(3,null,(0,L.$$h)(z)))}return this.installFromGallery(p)}X(k,r,p,z){return this.Y.copyExtension(k,r,p,z)}copyExtensions(k,r){return this.Y.copyExtensions(k,r)}markAsUninstalled(...k){return this.Y.setUninstalled(...k)}async cleanUp(){this.y.trace("ExtensionManagementService#cleanUp");try{await this.Y.cleanUp()}catch(k){this.y.error(k)}}async download(k,r,p){const{location:z}=await this.$.download(k,r,!p);return z}async hb(k){if(k.scheme===R.Schemas.file)return{location:k,async cleanup(){}};this.y.trace("Downloading extension from",k.toString());const r=(0,O.$8f)(this.$.extensionsDownloadDir,(0,f.$5e)());return await this.db.download(k,r),this.y.info("Downloaded extension to",r.toString()),{location:r,cleanup:async()=>{try{await this.eb.del(r)}catch(z){this.y.error(z)}}}}S(){return this.C.defaultProfile.extensionsResource}U(k,r,p){if(d.URI.isUri(r))return new X(k,r,p,this.u,this.Y,this.w,this.C,this.bb,this.cb,this.y);const z=n.$eo.create(r).toString();let C=this.ab.get(z);return C||(this.ab.set(z,C=new G(k,r,p,this.$,this.Y,this.w,this.C,this.bb,this.cb,this.y)),C.waitUntilTaskIsFinished().finally(()=>this.ab.delete(z))),C}W(k,r){return new K(k,r.profileLocation,this.cb)}async lb(k){const r=async z=>{let C=await I.Promises.readdir(z);C=C.map(ie=>m.$ac(z,ie));const H=await Promise.all(C.map(ie=>I.Promises.stat(ie)));let Y=Promise.resolve([]);return H.forEach((ie,de)=>{const fe=C[de];ie.isFile()&&(Y=Y.then(ue=>[...ue,fe])),ie.isDirectory()&&(Y=Y.then(ue=>r(fe).then(me=>[...ue,...me])))}),Y};return(await r(k.location.fsPath)).map(z=>({path:`extension/${m.$cc(k.location.fsPath,z)}`,localPath:z}))}async mb({added:k,removed:r}){if(r)for(const p of r.extensions)this.y.info("Extensions removed from another source",p.id,r.profileLocation.toString()),this.p.fire({identifier:p,profileLocation:r.profileLocation});if(k){const z=(await this.Y.scanExtensions(1,k.profileLocation)).filter(C=>k.extensions.some(H=>(0,n.$do)(H,C.identifier)));this.m.fire(z.map(C=>(this.y.info("Extensions added from another source",C.identifier.id,k.profileLocation.toString()),{identifier:C.identifier,local:C,profileLocation:k.profileLocation,operation:1})))}}async ob(){this.B(this.Y.onExtract(r=>this.nb.add(r)));const k=await this.eb.resolve(this.bb.userExtensionsLocation);for(const r of k.children??[])r.isDirectory&&this.nb.add(r.resource);this.B(this.eb.watch(this.bb.userExtensionsLocation)),this.B(this.eb.onDidFilesChange(r=>this.pb(r)))}async pb(k){if(!k.affects(this.bb.userExtensionsLocation,1))return;const r=[];for(const p of k.rawAdded){if(this.nb.has(p)||!this.w.extUri.isEqual(this.w.extUri.dirname(p),this.bb.userExtensionsLocation)||this.w.extUri.isEqual(p,this.w.extUri.joinPath(this.bb.userExtensionsLocation,".obsolete"))||this.w.extUri.basename(p).startsWith(".")||!(await this.eb.stat(p)).isDirectory)continue;const z=await this.Y.scanUserExtensionAtLocation(p);z&&z.installedTimestamp===void 0&&(this.nb.add(p),r.push(z))}r.length&&(await this.qb(r.map(p=>[p,void 0]),this.C.defaultProfile.extensionsResource),this.y.info("Added extensions to default profile from external source",r.map(p=>p.identifier.id)))}async qb(k,r){const p=k.map(z=>z[0]);await this.rb(p),await this.cb.addExtensionsToProfile(k,r),this.m.fire(p.map(z=>({local:z,identifier:z.identifier,operation:1,profileLocation:r})))}async rb(k){const r=await this.Y.getUninstalledExtensions();for(const p of k){const z=n.$eo.create(p);r[z.toString()]&&(this.y.trace("Removing the extension from uninstalled list:",z.id),await this.Y.setInstalled(z),this.y.info("Removed the extension from uninstalled list:",z.id))}}};e.$mp=T,e.$mp=T=pe([se(0,s.$Nn),se(1,ce.$Tk),se(2,_.$Pi),se(3,a.$vh),se(4,l.$bp),se(5,o.$0o),se(6,t.$sn),se(7,le.$mh),se(8,Z.$Qj),se(9,ae.$8i),se(10,te.$nk),se(11,F.$pk)],T);let U=class extends c.$lb{constructor(k,r,p,z,C,H){super(),this.j=k,this.k=r,this.l=p,this.m=z,this.n=C,this.p=H,this.h=this.B(new b.$7c),this.onExtract=this.h.event,this.c=(0,O.$8f)(this.l.userExtensionsLocation,".obsolete"),this.g=new M.$Ag}async cleanUp(){await this.C(),await this.z()}async scanExtensions(k,r){const p={includeInvalid:!0,profileLocation:r};let z=[];return k===null||k===0?z.push(...await this.l.scanAllExtensions({includeInvalid:!0},p,!1)):k===1&&z.push(...await this.l.scanUserExtensions(p)),z=k!==null?z.filter(C=>C.type===k):z,Promise.all(z.map(C=>this.y(C)))}async scanAllUserExtensions(k){const r=await this.l.scanUserExtensions({includeAllVersions:!k,includeInvalid:!0});return Promise.all(r.map(p=>this.y(p)))}async scanUserExtensionAtLocation(k){try{const r=await this.l.scanExistingExtension(k,1,{includeInvalid:!0});if(r)return await this.y(r)}catch(r){this.p.error(r)}return null}async extractUserExtension(k,r,p,z,C){const H=k.toString(),Y=d.URI.file(m.$ac(this.l.userExtensionsLocation.fsPath,`.${(0,f.$5e)()}`)),ie=d.URI.file(m.$ac(this.l.userExtensionsLocation.fsPath,H));let de=await this.k.exists(ie);if(de&&z){try{await this.t(k.id,ie,"removeExisting")}catch{throw new s.$On(v.localize(4,null,ie.fsPath,k.id),s.ExtensionManagementErrorCode.Delete)}de=!1}if(!de)try{try{this.p.trace(`Started extracting the extension from ${r} to ${ie.fsPath}`),await(0,$.$3o)(r,Y.fsPath,{sourcePath:"extension",overwrite:!0},C),this.p.info(`Extracted extension to ${ie}:`,k.id)}catch(fe){let ue=s.ExtensionManagementErrorCode.Extract;throw fe instanceof $.$1o&&(fe.type==="CorruptZip"?ue=s.ExtensionManagementErrorCode.CorruptZip:fe.type==="Incomplete"&&(ue=s.ExtensionManagementErrorCode.IncompleteZip)),new s.$On(fe.message,ue)}await this.l.updateMetadata(Y,p);try{this.p.trace(`Started renaming the extension from ${Y.fsPath} to ${ie.fsPath}`),await this.v(k,Y.fsPath,ie.fsPath,Date.now()+2*60*1e3),this.p.info("Renamed to",ie.fsPath)}catch(fe){if(fe.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",k.id);else throw this.p.info(`Rename failed because of ${(0,N.$9)(fe)}. Deleted from extracted location`,Y),fe}this.h.fire(ie)}catch(fe){try{await this.k.del(Y,{recursive:!0})}catch{}throw fe}return this.w(ie,1)}async scanMetadata(k,r){return r?(await this.s(k,r))?.metadata:this.l.scanMetadata(k.location)}async s(k,r){return(await this.m.scanProfileExtensions(r)).find(z=>(0,n.$do)(z.identifier,k.identifier))}async updateMetadata(k,r,p){return p?await this.m.updateMetadata([[k,r]],p):await this.l.updateMetadata(k.location,r),this.w(k.location,k.type,p)}getUninstalledExtensions(){return this.u()}async setUninstalled(...k){const r=k.map(p=>n.$eo.create(p));await this.u(p=>r.forEach(z=>{p[z.toString()]=!0,this.p.info("Marked extension as uninstalled",z.toString())}))}async setInstalled(k){await this.u(r=>delete r[k.toString()])}async removeExtension(k,r){if(this.n.extUri.isEqualOrParent(k.location,this.l.userExtensionsLocation))return this.t(k.identifier.id,k.location,r)}async removeUninstalledExtension(k){await this.removeExtension(k,"uninstalled"),await this.u(r=>delete r[n.$eo.create(k).toString()])}async copyExtension(k,r,p,z){const C=await this.s(k,r),H=await this.s(k,p);return z={...C?.metadata,...z},H?await this.m.updateMetadata([[k,{...H.metadata,...z}]],p):await this.m.addExtensionsToProfile([[k,z]],p),this.w(k.location,k.type,p)}async copyExtensions(k,r){const p=await this.scanExtensions(1,k),z=await Promise.all(p.filter(C=>!C.isApplicationScoped).map(async C=>[C,await this.scanMetadata(C,k)]));await this.m.addExtensionsToProfile(z,r)}async t(k,r,p){this.p.trace(`Deleting ${p} extension from disk`,k,r.fsPath);const z=this.n.extUri.joinPath(this.n.extUri.dirname(r),`${this.n.extUri.basename(r)}.${(0,u.$bi)((0,f.$5e)()).toString(16)}${W}`);await this.v({id:k},r.fsPath,z.fsPath,Date.now()+2*60*1e3),await this.k.del(z,{recursive:!0}),this.p.info(`Deleted ${p} extension from disk`,k,r.fsPath)}async u(k){return this.g.queue(async()=>{let r;try{r=(await this.k.readFile(this.c,"utf8")).value.toString()}catch(z){if((0,Z.$7j)(z)!==1)throw z}let p={};if(r)try{p=JSON.parse(r)}catch{}return k&&(k(p),Object.keys(p).length?await this.k.writeFile(this.c,A.$Jb.fromString(JSON.stringify(p))):await this.k.del(this.c)),p})}async v(k,r,p,z){try{await I.Promises.rename(r,p)}catch(C){if(h.$i&&C&&C.code==="EPERM"&&Date.now()<z)return this.p.info(`Failed renaming ${r} to ${p} with 'EPERM' error. Trying again...`,k.id),this.v(k,r,p,z);throw new s.$On(C.message||v.localize(5,null,r,p),C.code||s.ExtensionManagementErrorCode.Rename)}}async w(k,r,p){if(p){const C=(await this.l.scanUserExtensions({profileLocation:p})).find(H=>this.n.extUri.isEqual(H.location,k));if(C)return this.y(C)}else{const z=await this.l.scanExistingExtension(k,r,{includeInvalid:!0});if(z)return this.y(z)}throw new Error(v.localize(6,null,k.path))}async y(k){const r=await this.k.resolve(k.location);let p,z;return r.children&&(p=r.children.find(({name:C})=>/^readme(\.txt|\.md|)$/i.test(C))?.resource,z=r.children.find(({name:C})=>/^changelog(\.txt|\.md|)$/i.test(C))?.resource),{identifier:k.identifier,type:k.type,isBuiltin:k.isBuiltin||!!k.metadata?.isBuiltin,location:k.location,manifest:k.manifest,targetPlatform:k.targetPlatform,validations:k.validations,isValid:k.isValid,readmeUrl:p,changelogUrl:z,publisherDisplayName:k.metadata?.publisherDisplayName||null,publisherId:k.metadata?.publisherId||null,isApplicationScoped:!!k.metadata?.isApplicationScoped,isMachineScoped:!!k.metadata?.isMachineScoped,isPreReleaseVersion:!!k.metadata?.isPreReleaseVersion,preRelease:!!k.metadata?.preRelease,installedTimestamp:k.metadata?.installedTimestamp,updated:!!k.metadata?.updated,pinned:!!k.metadata?.pinned}}async z(){const k=await this.getUninstalledExtensions();if(Object.keys(k).length===0){this.p.debug("No uninstalled extensions found.");return}this.p.debug("Removing uninstalled extensions:",Object.keys(k));const r=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),p=new Set;for(const C of r)k[n.$eo.create(C).toString()]||p.add(C.identifier.id.toLowerCase());try{const C=(0,n.$jo)(r,H=>H.identifier);await M.Promises.settled(C.map(async H=>{const Y=H.sort((ie,de)=>y.rcompare(ie.manifest.version,de.manifest.version))[0];p.has(Y.identifier.id.toLowerCase())||await this.j(await this.y(Y))}))}catch(C){this.p.error(C)}const z=r.filter(C=>C.metadata&&k[n.$eo.create(C).toString()]);await Promise.allSettled(z.map(C=>this.removeUninstalledExtension(C)))}async C(){this.p.trace("ExtensionManagementService#removeTempDeleteFolders");let k;try{k=await this.k.resolve(this.l.userExtensionsLocation)}catch(r){(0,Z.$7j)(r)!==1&&this.p.error(r);return}if(k?.children)try{await Promise.allSettled(k.children.map(async r=>{if(!(!r.isDirectory||!r.name.endsWith(W))){this.p.trace("Deleting the temporarily deleted folder",r.resource.toString());try{await this.k.del(r.resource,{recursive:!0}),this.p.trace("Deleted the temporarily deleted folder",r.resource.toString())}catch(p){(0,Z.$7j)(p)!==1&&this.p.error(p)}}}))}catch{}}};e.$np=U,e.$np=U=pe([se(1,Z.$Qj),se(2,l.$bp),se(3,o.$0o),se(4,te.$nk),se(5,_.$Pi)],U);class V extends i.$8o{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,g.$pe)(this.m.operation)?this.l:this.m.operation}constructor(k,r,p,z,C,H,Y,ie,de){super(),this.identifier=k,this.source=r,this.m=p,this.n=z,this.o=C,this.p=H,this.q=Y,this.s=ie,this.t=de,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(k){const[r,p]=await this.y(k);return this.j=r.isBuiltin||r.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[r,p]],this.j),r}async v({zipPath:k,key:r,metadata:p},z,C){let H=await this.w(r);return H||(this.t.trace("Extracting extension...",r.id),H=await this.n.extractUserExtension(r,k,p,z,C),this.t.info("Extracting extension completed.",r.id)),H}async w(k){return await this.x(k)?(this.t.trace("Removing the extension from uninstalled list:",k.id),await this.n.setInstalled(k),this.t.info("Removed the extension from uninstalled list:",k.id),(await this.n.scanAllUserExtensions(!0)).find(z=>n.$eo.create(z).equals(k))):void 0}async x(k){return!!(await this.n.getUninstalledExtensions())[k.toString()]}}class G extends V{constructor(k,r,p,z,C,H,Y,ie,de,fe){super(r.identifier,r,p,C,H,Y,ie,de,fe),this.z=r,this.A=z}async y(k){const p=(await this.n.scanExtensions(null,this.m.profileLocation)).find(Y=>(0,n.$do)(Y.identifier,this.z.identifier));p&&(this.l=3);const z={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||p?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||p?.isMachineScoped,isBuiltin:this.m.isBuiltin||p?.isBuiltin,isSystem:p?.type===0?!0:void 0,updated:!!p,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,g.$oe)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:p?.preRelease)};if(p?.manifest.version===this.z.version)return[await this.n.updateMetadata(p,z),z];const{location:C,verificationStatus:H}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=H,this.C(C.fsPath),[await this.v({zipPath:C.fsPath,key:n.$eo.create(this.z),metadata:z},!1,k),z]}catch(Y){try{await this.A.delete(C)}catch(ie){this.t.warn("Error while deleting the downloaded file",C.toString(),(0,N.$9)(ie))}throw Y}}async C(k){try{await(0,S.$ip)(k)}catch(r){throw new s.$On((0,i.$6o)(r).message,s.ExtensionManagementErrorCode.Invalid)}}}e.$op=G;class X extends V{constructor(k,r,p,z,C,H,Y,ie,de,fe){super({id:(0,n.$io)(k.publisher,k.name)},r,p,C,H,Y,ie,de,fe),this.z=k,this.A=r,this.B=z}async h(k){const r=await super.h(k);return this.E(r,k),r}async y(k){const r=new n.$eo(this.identifier,this.z.version),z=(await this.n.scanExtensions(1,this.m.profileLocation)).find(Y=>(0,n.$do)(this.identifier,Y.identifier)),C={isApplicationScoped:this.m.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||z?.isMachineScoped,isBuiltin:this.m.isBuiltin||z?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(z)if(this.l=3,r.equals(new n.$eo(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(v.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&y.gt(z.manifest.version,this.z.version)&&await this.n.setUninstalled(z);else{const Y=await this.w(r);if(Y)try{await this.n.removeExtension(Y,"existing")}catch{throw new Error(v.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:m.$bc(this.A.fsPath),key:r,metadata:C},!0,k),C]}async E(k,r){try{let[p]=await this.B.getExtensions([{id:k.identifier.id,version:k.manifest.version}],r);if(p||([p]=await this.B.getExtensions([{id:k.identifier.id}],r)),p){const z={id:p.identifier.uuid,publisherDisplayName:p.publisherDisplayName,publisherId:p.publisherId,isPreReleaseVersion:p.properties.isPreReleaseVersion,preRelease:p.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(k,z,this.m.profileLocation)}}catch{}}}class K extends i.$8o{constructor(k,r,p){super(),this.extension=k,this.j=r,this.k=p}async h(k){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ne[163],re([0,1,137,8,14,9,3,25,18,138,6,45,136,176]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=e.$Bq=void 0;let O=class extends R.$xo{constructor(f,I,$,v){super(v),this.j=f,this.k=I,this.l=$,this.m(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const f=this.j.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,I){const{f:$,g:v}=this;let t;try{t=await(0,c.$wl)(this.j,this.l,this.k.args,process.env)}catch(s){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,L.$9)(s)))}const a={...process.env,...t},i=f.agent?f.agent:await(0,m.$Aq)(f.url||"",a,{proxyUrl:$,strictSSL:v});return f.agent=i,f.strictSSL=v,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>g(f,I))}async resolveProxy(f){}};e.$Bq=O,e.$Bq=O=pe([se(0,b.$Th),se(1,u.$vh),se(2,w.$Pi),se(3,w.$Qi)],O);async function y(d){return((0,M.parse)(d.url).protocol==="https:"?await new Promise(($,v)=>{J(["https"],$,v)}):await new Promise(($,v)=>{J(["http"],$,v)})).request}async function g(d,f){return A.Promises.withAsyncBody(async(I,$)=>{const v=(0,M.parse)(d.url),t=d.getRawRequest?d.getRawRequest(d):await y(d),a={hostname:v.hostname,port:v.port?parseInt(v.port):v.protocol==="https:"?443:80,protocol:v.protocol,path:v.path,method:d.type||"GET",headers:d.headers,agent:d.agent,rejectUnauthorized:(0,N.$oe)(d.strictSSL)?d.strictSSL:!0};d.user&&d.password&&(a.auth=d.user+":"+d.password);const i=t(a,s=>{const n=(0,N.$me)(d.followRedirects)?d.followRedirects:3;if(s.statusCode&&s.statusCode>=300&&s.statusCode<400&&n>0&&s.headers.location)g({...d,url:s.headers.location,followRedirects:n-1},f).then(I,$);else{let o=s;!d.isChromiumNetwork&&s.headers["content-encoding"]==="gzip"&&(o=s.pipe((0,h.createGunzip)())),I({res:s,stream:(0,D.$Yb)(o)})}});i.on("error",$),d.timeout&&i.setTimeout(d.timeout),d.isChromiumNetwork&&i.removeHeader("Content-Length"),d.data&&typeof d.data=="string"&&i.write(d.data),i.end(),f.onCancellationRequested(()=>{i.abort(),$(new L.$3)})})}e.$Cq=g}),define(ne[177],re([0,1,32,8,33,9,2,15,16,12,34,11,24,25,133,59,135,18,111,158,21,60,140,40,50,162,156,13,122,124,49,120,63,64,143,6,129,38,130,146,31,45,163,68,69,26,145,39,147,148,22,150,23,159,149,155,126,128,5,151]),function(J,e,M,A,D,L,N,b,u,c,w,R,m,h,O,y,g,d,f,I,$,v,t,a,i,s,n,o,l,P,E,S,j,B,ee,Z,le,_,ae,ce,te,F,W,T,U,V,G,X,K,oe,k,r,p,z,C,H,Y,ie,de,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ue extends N.$lb{constructor(he){super(),this.b=he,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[he,ye]=await this.f();return he.invokeFunction(async Ee=>{const je=Ee.get(Z.$Pi),Ue=Ee.get(o.$Qj),q=Ee.get(d.$vh),Q=Ee.get(p.$pk);je.info("CLI main",this.b),this.g(je),await this.h(q,Ue,Q,he),await Promise.all(ye.map(x=>{(0,A.$lg)(x.flush(),1e3)}))})}async f(){const he=new j.$lh,ye={_serviceBrand:void 0,...ce.default};he.set(te.$8i,ye);const Ee=new f.$Vl(this.b,ye);he.set(d.$vh,Ee),await Promise.all([Ee.appSettingsHome.fsPath,Ee.extensionsPath].map(De=>De?m.Promises.mkdir(De,{recursive:!0}):void 0));const je=new ie.$MM((0,Z.$4i)(Ee),Ee.logsHome);he.set(Z.$Qi,je);const Ue=this.B(je.createLogger("cli",{name:(0,de.localize)(0,null)})),q=[];je.getLogLevel()===Z.LogLevel.Trace&&q.push(new Z.$Xi(je.getLogLevel()));const Q=this.B(new Y.$WM(Ue,q));he.set(Z.$Pi,Q);const x=this.B(new l.$qp(Q));he.set(o.$Qj,x);const $e=this.B(new P.$Pp(Q));x.registerProvider(b.Schemas.file,$e),x.registerProvider(b.Schemas.vscodeUserData,new fe.$74b(b.Schemas.file,$e,b.Schemas.vscodeUserData,Q));const we=new r.$ar(x);he.set(k.$nk,we);const Re=new T.$QM(1,Ee,Q,x),ke=new z.$SM(Re,we,Ee,x,Q);he.set(p.$pk,ke);const Le=c.$i&&ye.win32RegValueName?this.B(new ae.$54b(Q,ye.win32RegValueName)):Ee.policyFile?this.B(new le.$64b(Ee.policyFile,x,Q)):new _.$Vm;he.set(_.$Tm,Le);const Pe=this.B(new O.$jn(ke.defaultProfile.settingsResource,x,Le,Q));he.set(h.$Th,Pe),await Promise.all([Re.init(),Pe.initialize()]);let Ne;try{Ne=await(0,C.$M4b)(Re,Q)}catch(De){De.code!=="ENOENT"&&Q.error(De)}ke.init(),he.set(k.$nk,new r.$ar(x));const ze=new W.$Bq(Pe,Ee,Q,je);he.set(F.$wo,ze),he.set(y.$sn,new E.$kh(g.$_M,void 0,!0)),he.set(a.$0o,new E.$kh(H.$VM,void 0,!0)),he.set(i.$bp,new E.$kh(n.$J4b,void 0,!0)),he.set(v.$To,new E.$kh(v.$Uo,void 0,!0)),he.set(s.$lp,new E.$kh(s.$mp,void 0,!0)),he.set($.$Nn,new E.$kh(I.$So,void 0,!0)),he.set(B.$vq,new E.$kh(ee.$xq,void 0,!1));const Ie=[],Ae=(0,X.$ao)(ye,Pe);if((0,X.$8n)(ye,Ee)){ye.aiConfig&&ye.aiConfig.ariaKey&&Ie.push(new K.$KM(ze,Ae,"monacoworkbench",null,ye.aiConfig.ariaKey));const De={appenders:Ie,sendErrorTelemetry:!1,commonProperties:(0,U.$Xn)((0,M.release)(),(0,M.hostname)(),process.arch,ye.commit,ye.version,Ne,Ae),piiPaths:(0,X.$bo)(Ee)};he.set(V.$Tk,new E.$kh(G.$Dq,[De],!1))}else he.set(V.$Tk,X.$2n);return[new S.$Sp(he),Ie]}g(he){(0,L.setUnexpectedErrorHandler)(ye=>{const Ee=(0,D.$$h)(ye,!0);Ee&&he.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",ye=>{(0,L.$X)(ye)||(0,L.$Y)(ye)}),process.on("unhandledRejection",ye=>(0,L.$Y)(ye))}async h(he,ye,Ee,je){let Ue;if(he.args.profile&&(Ue=Ee.profiles.find(Q=>Q.name===he.args.profile),!Ue))throw new Error(`Profile '${he.args.profile}' not found.`);const q=(Ue??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return je.createInstance(t.$Vo,new Z.$Xi(Z.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,q);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Q={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:q};return je.createInstance(t.$Vo,new Z.$Xi(Z.LogLevel.Info,!1)).installExtensions(this.i(this.b["install-extension"]||[]),this.i(this.b["install-builtin-extension"]||[]),Q,!!this.b.force)}else{if(this.b["uninstall-extension"])return je.createInstance(t.$Vo,new Z.$Xi(Z.LogLevel.Info,!1)).uninstallExtensions(this.i(this.b["uninstall-extension"]),!!this.b.force,q);if(this.b["locate-extension"])return je.createInstance(t.$Vo,new Z.$Xi(Z.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,oe.$q5b)(he.appRoot,he.extensionsPath))}}i(he){return he.map(ye=>/\.vsix$/i.test(ye)?R.URI.file((0,u.$_b)(ye)?ye:(0,u.$ac)((0,w.cwd)(),ye)):ye)}}async function me(ge){const he=new ue(ge);try{await he.run()}finally{he.dispose()}}e.main=me})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c3e3dba23e8fadc360aed75ce363ba185c49794/core/vs/code/node/cliProcessMain.js.map
