/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/base/common/types","vs/nls","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/platform/userDataProfile/common/userDataProfile","vs/platform/configuration/common/configuration","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/network","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/common/ipc","vs/platform/externalServices/common/serviceMachineId","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/amd","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/id","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","stream","util","path","graceful-fs","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(te){for(var e=[],I=0,T=te.length;I<T;I++)e[I]=oe[te[I]];return e};define(oe[122],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class I{static get(){const D=new Map,j=new Map,L=new Map,R=new Map;function S(h,$){h.has($.detail)||h.set($.detail,-$.timestamp)}function b(h,$){const v=h.get($.detail);v&&(v>=0||h.set($.detail,v+$.timestamp))}let P=[];typeof te=="function"&&typeof te.getStats=="function"&&(P=te.getStats().slice(0).sort((h,$)=>h.timestamp-$.timestamp));for(const h of P)switch(h.type){case 10:S(D,h);break;case 11:case 12:b(D,h);break;case 21:S(j,h);break;case 22:b(j,h);break;case 33:S(L,h);break;case 34:b(L,h);break;case 31:S(R,h);break;case 32:b(R,h);break}let E=0;L.forEach(h=>E+=h);function m(h){const $=[];return h.forEach((v,c)=>$.push([c,v])),$}return{amdLoad:m(D),amdInvoke:m(j),nodeRequire:m(L),nodeEval:m(R),nodeRequireTotal:E}}static toMarkdownTable(D,j){let L="";const R=[];return D.forEach((S,b)=>{R[b]=S.length}),j.forEach(S=>{S.forEach((b,P)=>{typeof b>"u"&&(b=S[P]="-");const E=b.toString().length;R[P]=Math.max(E,R[P])})}),D.forEach((S,b)=>{L+=`| ${S+" ".repeat(R[b]-S.toString().length)} `}),L+=`|
`,D.forEach((S,b)=>{L+=`| ${"-".repeat(R[b])} `}),L+=`|
`,j.forEach(S=>{S.forEach((b,P)=>{typeof b<"u"&&(L+=`| ${b+" ".repeat(R[P]-b.toString().length)} `)}),L+=`|
`}),L}}e.$S=I}),define(oe[81],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=e.$Sg=e.$Rg=void 0;function I(L){return(R,S,b)=>{let P=null,E=null;if(typeof b.value=="function"?(P="value",E=b.value):typeof b.get=="function"&&(P="get",E=b.get),!E)throw new Error("not supported");b[P]=L(E,S)}}function T(L,R,S){let b=null,P=null;if(typeof S.value=="function"?(b="value",P=S.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(b="get",P=S.get),!P)throw new Error("not supported");const E=`$memoize$${R}`;S[b]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,m)}),this[E]}}e.$Rg=T;function D(L,R,S){return I((b,P)=>{const E=`$debounce$${P}`,m=`$debounce$result$${P}`;return function(...h){this[m]||(this[m]=S?S():void 0),clearTimeout(this[E]),R&&(this[m]=R(this[m],...h),h=[this[m]]),this[E]=setTimeout(()=>{b.apply(this,h),this[m]=S?S():void 0},L)}})}e.$Sg=D;function j(L,R,S){return I((b,P)=>{const E=`$throttle$timer$${P}`,m=`$throttle$result$${P}`,h=`$throttle$lastRun$${P}`,$=`$throttle$pending$${P}`;return function(...v){if(this[m]||(this[m]=S?S():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),R&&(this[m]=R(this[m],...v)),this[$])return;const c=this[h]+L;c<=Date.now()?(this[h]=Date.now(),b.apply(this,[this[m]]),this[m]=S?S():void 0):(this[$]=!0,this[E]=setTimeout(()=>{this[$]=!1,this[h]=Date.now(),b.apply(this,[this[m]]),this[m]=S?S():void 0},c-Date.now()))}})}e.$Tg=j}),define(oe[7],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class I{constructor(){this.b=[],this.a=function(o){setTimeout(()=>{throw o.stack?p.isErrorNoTelemetry(o)?new p(o.message+`

`+o.stack):new Error(o.message+`

`+o.stack):o},0)}}addListener(o){return this.b.push(o),()=>{this.d(o)}}c(o){this.b.forEach(n=>{n(o)})}d(o){this.b.splice(this.b.indexOf(o),1)}setUnexpectedErrorHandler(o){this.a=o}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(o){this.a(o),this.c(o)}onUnexpectedExternalError(o){this.a(o)}}e.$U=I,e.$V=new I;function T(t){e.$V.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=T;function D(t){if(!t||typeof t!="object")return!1;const o=t;return o.code==="EPIPE"&&o.syscall?.toUpperCase()==="WRITE"}e.$X=D;function j(t){b(t)||e.$V.onUnexpectedError(t)}e.$Y=j;function L(t){b(t)||e.$V.onUnexpectedExternalError(t)}e.$Z=L;function R(t){if(t instanceof Error){const{name:o,message:n}=t,s=t.stacktrace||t.stack;return{$isError:!0,name:o,message:n,stack:s,noTelemetry:p.isErrorNoTelemetry(t)}}return t}e.$1=R;const S="Canceled";function b(t){return t instanceof P?!0:t instanceof Error&&t.name===S&&t.message===S}e.$2=b;class P extends Error{constructor(){super(S),this.name=this.message}}e.$3=P;function E(){const t=new Error(S);return t.name=t.message,t}e.$4=E;function m(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$5=m;function h(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$6=h;function $(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=$;function v(t){const o=new Error(`${t} has been disposed`);return o.name="DISPOSED",o}e.$8=v;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$9=c;class l extends Error{constructor(o){super("NotImplemented"),o&&(this.message=o)}}e.$0=l;class u extends Error{constructor(o){super("NotSupported"),o&&(this.message=o)}}e.$$=u;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=y;class p extends Error{constructor(o){super(o),this.name="CodeExpectedError"}static fromError(o){if(o instanceof p)return o;const n=new p;return n.message=o.message,n.stack=o.stack,n}static isErrorNoTelemetry(o){return o.name==="CodeExpectedError"}}e.$ab=p;class C extends Error{constructor(o){super(o||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype)}}e.$bb=C}),define(oe[21],ae([0,1,7]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.CompareResult=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.top=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=void 0;function T(U,X=0){return U[U.length-(1+X)]}e.$$e=T;function D(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.$_e=D;function j(U,X,_=(se,he)=>se===he){if(U===X)return!0;if(!U||!X||U.length!==X.length)return!1;for(let se=0,he=U.length;se<he;se++)if(!_(U[se],X[se]))return!1;return!0}e.$af=j;function L(U,X){const _=U.length-1;X<_&&(U[X]=U[_]),U.pop()}e.$bf=L;function R(U,X,_){return S(U.length,se=>_(U[se],X))}e.$cf=R;function S(U,X){let _=0,se=U-1;for(;_<=se;){const he=(_+se)/2|0,ue=X(he);if(ue<0)_=he+1;else if(ue>0)se=he-1;else return he}return-(_+1)}e.$df=S;function b(U,X){let _=0,se=U.length;if(se===0)return 0;for(;_<se;){const he=Math.floor((_+se)/2);X(U[he])?se=he:_=he+1}return _}e.$ef=b;function P(U,X,_){if(U=U|0,U>=X.length)throw new TypeError("invalid index");const se=X[Math.floor(X.length*Math.random())],he=[],ue=[],me=[];for(const pe of X){const ke=_(pe,se);ke<0?he.push(pe):ke>0?ue.push(pe):me.push(pe)}return U<he.length?P(U,he,_):U<he.length+me.length?me[0]:P(U-(he.length+me.length),ue,_)}e.$ff=P;function E(U,X){const _=[];let se;for(const he of U.slice(0).sort(X))!se||X(se[0],he)!==0?(se=[he],_.push(se)):se.push(he);return _}e.$gf=E;function m(U,X,_){const se=[];function he(pe,ke,Re){if(ke===0&&Re.length===0)return;const Oe=se[se.length-1];Oe&&Oe.start+Oe.deleteCount===pe?(Oe.deleteCount+=ke,Oe.toInsert.push(...Re)):se.push({start:pe,deleteCount:ke,toInsert:Re})}let ue=0,me=0;for(;;){if(ue===U.length){he(ue,0,X.slice(me));break}if(me===X.length){he(ue,U.length-ue,[]);break}const pe=U[ue],ke=X[me],Re=_(pe,ke);Re===0?(ue+=1,me+=1):Re<0?(he(ue,1,[]),ue+=1):Re>0&&(he(ue,0,[ke]),me+=1)}return se}e.$hf=m;function h(U,X,_){const se=m(U,X,_),he=[],ue=[];for(const me of se)he.push(...U.slice(me.start,me.start+me.deleteCount)),ue.push(...me.toInsert);return{removed:he,added:ue}}e.$if=h;function $(U,X,_){if(_===0)return[];const se=U.slice(0,_).sort(X);return c(U,X,se,_,U.length),se}e.top=$;function v(U,X,_,se,he){return _===0?Promise.resolve([]):new Promise((ue,me)=>{(async()=>{const pe=U.length,ke=U.slice(0,_).sort(X);for(let Re=_,Oe=Math.min(_+se,pe);Re<pe;Re=Oe,Oe=Math.min(Oe+se,pe)){if(Re>_&&await new Promise(ze=>setTimeout(ze)),he&&he.isCancellationRequested)throw new I.$3;c(U,X,ke,Re,Oe)}return ke})().then(ue,me)})}e.$kf=v;function c(U,X,_,se,he){for(const ue=_.length;se<he;se++){const me=U[se];if(X(me,_[ue-1])<0){_.pop();const pe=b(_,ke=>X(me,ke)<0);_.splice(pe,0,me)}}}function l(U){return U.filter(X=>!!X)}e.$lf=l;function u(U){let X=0;for(let _=0;_<U.length;_++)U[_]&&(U[X]=U[_],X+=1);U.length=X}e.$mf=u;function y(U,X,_){U.splice(_,0,U.splice(X,1)[0])}e.$nf=y;function p(U){return!Array.isArray(U)||U.length===0}e.$of=p;function C(U){return Array.isArray(U)&&U.length>0}e.$pf=C;function t(U,X=_=>_){const _=new Set;return U.filter(se=>{const he=X(se);return _.has(he)?!1:(_.add(he),!0)})}e.$qf=t;function o(U){const X=new Set;return _=>{const se=U(_);return X.has(se)?!1:(X.add(se),!0)}}e.$rf=o;function n(U,X){const _=s(U,X);if(_!==-1)return U[_]}e.$sf=n;function s(U,X){for(let _=U.length-1;_>=0;_--){const se=U[_];if(X(se))return _}return-1}e.$tf=s;function i(U,X){return U.length>0?U[0]:X}e.$uf=i;function r(U,X){return U.length>0?U[U.length-1]:X}e.$vf=r;function a(U,X,_=(se,he)=>se===he){let se=0;for(let he=0,ue=Math.min(U.length,X.length);he<ue&&_(U[he],X[he]);he++)se++;return se}e.$wf=a;function w(U){return[].concat(...U)}e.$xf=w;function g(U,X){let _=typeof X=="number"?U:0;typeof X=="number"?_=U:(_=0,X=U);const se=[];if(_<=X)for(let he=_;he<X;he++)se.push(he);else for(let he=_;he>X;he--)se.push(he);return se}e.$yf=g;function f(U,X,_){return U.reduce((se,he)=>(se[X(he)]=_?_(he):he,se),Object.create(null))}e.$zf=f;function k(U,X){return U.push(X),()=>N(U,X)}e.$Af=k;function N(U,X){const _=U.indexOf(X);if(_>-1)return U.splice(_,1),X}e.$Bf=N;function M(U,X,_){const se=U.slice(0,X),he=U.slice(X);return se.concat(_,he)}e.$Cf=M;function F(U,X){let _;if(typeof X=="number"){let se=X;_=()=>{const he=Math.sin(se++)*179426549;return he-Math.floor(he)}}else _=Math.random;for(let se=U.length-1;se>0;se-=1){const he=Math.floor(_()*(se+1)),ue=U[se];U[se]=U[he],U[he]=ue}}e.$Df=F;function W(U,X){const _=U.indexOf(X);_>-1&&(U.splice(_,1),U.unshift(X))}e.$Ef=W;function q(U,X){const _=U.indexOf(X);_>-1&&(U.splice(_,1),U.push(X))}e.$Ff=q;function J(U,X){for(const _ of X)U.push(_)}e.$Gf=J;function Q(U,X){return Array.isArray(U)?U.map(X):X(U)}e.$Hf=Q;function Y(U){return Array.isArray(U)?U:[U]}e.$If=Y;function Z(U){return U[Math.floor(Math.random()*U.length)]}e.$Jf=Z;function x(U,X){for(const _ of U){const se=X(_);if(se!==void 0)return se}}e.$Kf=x;function H(U,X,_){const se=V(U,X),he=U.length,ue=_.length;U.length=he+ue;for(let me=he-1;me>=se;me--)U[me+ue]=U[me];for(let me=0;me<ue;me++)U[me+se]=_[me]}e.$Lf=H;function B(U,X,_,se){const he=V(U,X),ue=U.splice(he,_);return H(U,he,se),ue}e.$Mf=B;function V(U,X){return X<0?Math.max(X+U.length,0):Math.min(X,U.length)}var ee;(function(U){function X(he){return he<0}U.isLessThan=X;function _(he){return he>0}U.isGreaterThan=_;function se(he){return he===0}U.isNeitherLessOrGreaterThan=se,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function ne(U,X){return(_,se)=>X(U(_),U(se))}e.$Nf=ne;function ce(...U){return(X,_)=>{for(const se of U){const he=se(X,_);if(!ee.isNeitherLessOrGreaterThan(he))return he}return ee.neitherLessOrGreaterThan}}e.$Of=ce;const re=(U,X)=>U-X;e.$Pf=re;function A(U,X){if(U.length===0)return;let _=U[0];for(let se=1;se<U.length;se++){const he=U[se];X(he,_)>0&&(_=he)}return _}e.$Qf=A;function d(U,X){if(U.length===0)return;let _=U[0];for(let se=1;se<U.length;se++){const he=U[se];X(he,_)>=0&&(_=he)}return _}e.$Rf=d;function O(U,X){return A(U,(_,se)=>-X(_,se))}e.$Sf=O;class z{constructor(X){this.f=X,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(X){let _=this.c;for(;_<this.f.length&&X(this.f[_]);)_++;const se=_===this.c?null:this.f.slice(this.c,_);return this.c=_,se}takeFromEndWhile(X){let _=this.d;for(;_>=0&&X(this.f[_]);)_--;const se=_===this.d?null:this.f.slice(_+1,this.d+1);return this.d=_,se}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const X=this.f[this.c];return this.c++,X}removeLast(){const X=this.f[this.d];return this.d--,X}takeCount(X){const _=this.f.slice(this.c,this.c+X);return this.c+=X,_}}e.$Tf=z;class G{static{this.empty=new G(X=>{})}constructor(X){this.iterate=X}forEach(X){this.iterate(_=>(X(_),!0))}toArray(){const X=[];return this.iterate(_=>(X.push(_),!0)),X}filter(X){return new G(_=>this.iterate(se=>X(se)?_(se):!0))}map(X){return new G(_=>this.iterate(se=>_(X(se))))}some(X){let _=!1;return this.iterate(se=>(_=X(se),!_)),_}findFirst(X){let _;return this.iterate(se=>X(se)?(_=se,!1):!0),_}findLast(X){let _;return this.iterate(se=>(X(se)&&(_=se),!0)),_}findLastMaxBy(X){let _,se=!0;return this.iterate(he=>((se||ee.isGreaterThan(X(he,_)))&&(se=!1,_=he),!0)),_}}e.$Uf=G}),define(oe[123],ae([0,1,7]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.ok=void 0;function T(S,b){if(!S)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=T;function D(S,b="Unreachable"){throw new Error(b)}e.$nc=D;function j(S){if(!S)throw new I.$bb("Assertion Failed")}e.$oc=j;function L(S){if(!S()){debugger;S(),(0,I.$Y)(new I.$bb("Assertion Failed"))}}e.$pc=L;function R(S,b){let P=0;for(;P<S.length-1;){const E=S[P],m=S[P+1];if(!b(E,m))return!1;P++}return!0}e.$qc=R}),define(oe[82],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function I(T){const D=this;let j=!1,L;return function(){return j||(j=!0,L=T.apply(D,arguments)),L}}e.$cb=I}),define(oe[59],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var I;(function(T){function D(p){return p&&typeof p=="object"&&typeof p[Symbol.iterator]=="function"}T.is=D;const j=Object.freeze([]);function L(){return j}T.empty=L;function*R(p){yield p}T.single=R;function S(p){return D(p)?p:R(p)}T.wrap=S;function b(p){return p||j}T.from=b;function P(p){return!p||p[Symbol.iterator]().next().done===!0}T.isEmpty=P;function E(p){return p[Symbol.iterator]().next().value}T.first=E;function m(p,C){for(const t of p)if(C(t))return!0;return!1}T.some=m;function h(p,C){for(const t of p)if(C(t))return t}T.find=h;function*$(p,C){for(const t of p)C(t)&&(yield t)}T.filter=$;function*v(p,C){let t=0;for(const o of p)yield C(o,t++)}T.map=v;function*c(...p){for(const C of p)for(const t of C)yield t}T.concat=c;function l(p,C,t){let o=t;for(const n of p)o=C(o,n);return o}T.reduce=l;function*u(p,C,t=p.length){for(C<0&&(C+=p.length),t<0?t+=p.length:t>p.length&&(t=p.length);C<t;C++)yield p[C]}T.slice=u;function y(p,C=Number.POSITIVE_INFINITY){const t=[];if(C===0)return[t,p];const o=p[Symbol.iterator]();for(let n=0;n<C;n++){const s=o.next();if(s.done)return[t,T.empty()];t.push(s.value)}return[t,{[Symbol.iterator](){return o}}]}T.consume=y})(I||(e.Iterable=I={}))}),define(oe[34],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var I;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(I||(e.ScanError=I={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var j;(function(t){t.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function L(t,o=!1){let n=0;const s=t.length;let i="",r=0,a=16,w=0;function g(q){let J=0,Q=0;for(;J<q;){const Y=t.charCodeAt(n);if(Y>=48&&Y<=57)Q=Q*16+Y-48;else if(Y>=65&&Y<=70)Q=Q*16+Y-65+10;else if(Y>=97&&Y<=102)Q=Q*16+Y-97+10;else break;n++,J++}return J<q&&(Q=-1),Q}function f(q){n=q,i="",r=0,a=16,w=0}function k(){const q=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&b(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&b(t.charCodeAt(n)))for(n++;n<t.length&&b(t.charCodeAt(n));)n++;else return w=3,t.substring(q,n);let J=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&b(t.charCodeAt(n))){for(n++;n<t.length&&b(t.charCodeAt(n));)n++;J=n}else w=3;return t.substring(q,J)}function N(){let q="",J=n;for(;;){if(n>=s){q+=t.substring(J,n),w=2;break}const Q=t.charCodeAt(n);if(Q===34){q+=t.substring(J,n),n++;break}if(Q===92){if(q+=t.substring(J,n),n++,n>=s){w=2;break}switch(t.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const Z=g(4);Z>=0?q+=String.fromCharCode(Z):w=4;break}default:w=5}J=n;continue}if(Q>=0&&Q<=31)if(S(Q)){q+=t.substring(J,n),w=2;break}else w=6;n++}return q}function M(){if(i="",w=0,r=n,n>=s)return r=s,a=17;let q=t.charCodeAt(n);if(R(q)){do n++,i+=String.fromCharCode(q),q=t.charCodeAt(n);while(R(q));return a=15}if(S(q))return n++,i+=String.fromCharCode(q),q===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,i=N(),a=10;case 47:{const J=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!S(t.charCodeAt(n));)n++;return i=t.substring(J,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const Q=s-1;let Y=!1;for(;n<Q;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,Y=!0;break}n++}return Y||(n++,w=1),i=t.substring(J,n),a=13}return i+=String.fromCharCode(q),n++,a=16}case 45:if(i+=String.fromCharCode(q),n++,n===s||!b(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=k(),a=11;default:for(;n<s&&F(q);)n++,q=t.charCodeAt(n);if(r!==n){switch(i=t.substring(r,n),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(q),n++,a=16}}function F(q){if(R(q)||S(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=M();while(q>=12&&q<=15);return q}return{setPosition:f,getPosition:()=>n,scan:o?W:M,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>w}}e.$tm=L;function R(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var P;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(P||(P={}));function E(t,o){const n=[],s=new Object;let i;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function w(g,f,k,N){r.value=g,r.offset=f,r.length=k,r.type=N,r.colonOffset=void 0,i=r}try{y(t,{onObjectBegin:(g,f)=>{if(o<=g)throw s;i=void 0,a=o>g,n.push("")},onObjectProperty:(g,f,k)=>{if(o<f||(w(g,f,k,"property"),n[n.length-1]=g,o<=f+k))throw s},onObjectEnd:(g,f)=>{if(o<=g)throw s;i=void 0,n.pop()},onArrayBegin:(g,f)=>{if(o<=g)throw s;i=void 0,n.push(0)},onArrayEnd:(g,f)=>{if(o<=g)throw s;i=void 0,n.pop()},onLiteralValue:(g,f,k)=>{if(o<f||(w(g,f,k,C(g)),o<=f+k))throw s},onSeparator:(g,f,k)=>{if(o<=f)throw s;if(g===":"&&i&&i.type==="property")i.colonOffset=f,a=!1,i=void 0;else if(g===","){const N=n[n.length-1];typeof N=="number"?n[n.length-1]=N+1:(a=!0,n[n.length-1]=""),i=void 0}}})}catch(g){if(g!==s)throw g}return{path:n,previousNode:i,isAtPropertyKey:a,matches:g=>{let f=0;for(let k=0;f<g.length&&k<n.length;k++)if(g[f]===n[k]||g[f]==="*")f++;else if(g[f]!=="**")return!1;return f===g.length}}}e.$um=E;function m(t,o=[],n=j.DEFAULT){let s=null,i=[];const r=[];function a(g){Array.isArray(i)?i.push(g):s!==null&&(i[s]=g)}return y(t,{onObjectBegin:()=>{const g={};a(g),r.push(i),i=g,s=null},onObjectProperty:g=>{s=g},onObjectEnd:()=>{i=r.pop()},onArrayBegin:()=>{const g=[];a(g),r.push(i),i=g,s=null},onArrayEnd:()=>{i=r.pop()},onLiteralValue:a,onError:(g,f,k)=>{o.push({error:g,offset:f,length:k})}},n),i[0]}e.$vm=m;function h(t,o=[],n=j.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(g){s.type==="property"&&(s.length=g-s.offset,s=s.parent)}function r(g){return s.children.push(g),g}y(t,{onObjectBegin:g=>{s=r({type:"object",offset:g,length:-1,parent:s,children:[]})},onObjectProperty:(g,f,k)=>{s=r({type:"property",offset:f,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:g,offset:f,length:k,parent:s})},onObjectEnd:(g,f)=>{s.length=g+f-s.offset,s=s.parent,i(g+f)},onArrayBegin:(g,f)=>{s=r({type:"array",offset:g,length:-1,parent:s,children:[]})},onArrayEnd:(g,f)=>{s.length=g+f-s.offset,s=s.parent,i(g+f)},onLiteralValue:(g,f,k)=>{r({type:C(g),offset:f,length:k,parent:s,value:g}),i(f+k)},onSeparator:(g,f,k)=>{s.type==="property"&&(g===":"?s.colonOffset=f:g===","&&i(f))},onError:(g,f,k)=>{o.push({error:g,offset:f,length:k})}},n);const w=s.children[0];return w&&delete w.parent,w}e.$wm=h;function $(t,o){if(!t)return;let n=t;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}e.$xm=$;function v(t){if(!t.parent||!t.parent.children)return[];const o=v(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;o.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&o.push(n)}return o}e.$ym=v;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const o=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(o[n.children[0].value]=c(s))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$zm=c;function l(t,o,n=!1){return o>=t.offset&&o<t.offset+t.length||n&&o===t.offset+t.length}e.$Am=l;function u(t,o,n=!1){if(l(t,o,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=o;i++){const r=u(s[i],o,n);if(r)return r}return t}}e.$Bm=u;function y(t,o,n=j.DEFAULT){const s=L(t,!1);function i(ne){return ne?()=>ne(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ne){return ne?ce=>ne(ce,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=i(o.onObjectBegin),w=r(o.onObjectProperty),g=i(o.onObjectEnd),f=i(o.onArrayBegin),k=i(o.onArrayEnd),N=r(o.onLiteralValue),M=r(o.onSeparator),F=i(o.onComment),W=r(o.onError),q=n&&n.disallowComments,J=n&&n.allowTrailingComma;function Q(){for(;;){const ne=s.scan();switch(s.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:q||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(ne){case 12:case 13:q?Y(10):F();break;case 16:Y(1);break;case 15:case 14:break;default:return ne}}}function Y(ne,ce=[],re=[]){if(W(ne),ce.length+re.length>0){let A=s.getToken();for(;A!==17;){if(ce.indexOf(A)!==-1){Q();break}else if(re.indexOf(A)!==-1)break;A=Q()}}}function Z(ne){const ce=s.getTokenValue();return ne?N(ce):w(ce),Q(),!0}function x(){switch(s.getToken()){case 11:{let ne=0;try{ne=JSON.parse(s.getTokenValue()),typeof ne!="number"&&(Y(2),ne=0)}catch{Y(2)}N(ne);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return Q(),!0}function H(){return s.getToken()!==10?(Y(3,[],[2,5]),!1):(Z(!1),s.getToken()===6?(M(":"),Q(),ee()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function B(){a(),Q();let ne=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ne||Y(4,[],[]),M(","),Q(),s.getToken()===2&&J)break}else ne&&Y(6,[],[]);H()||Y(4,[],[2,5]),ne=!0}return g(),s.getToken()!==2?Y(7,[2],[]):Q(),!0}function V(){f(),Q();let ne=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ne||Y(4,[],[]),M(","),Q(),s.getToken()===4&&J)break}else ne&&Y(6,[],[]);ee()||Y(4,[],[4,5]),ne=!0}return k(),s.getToken()!==4?Y(8,[4],[]):Q(),!0}function ee(){switch(s.getToken()){case 3:return V();case 1:return B();case 10:return Z(!0);default:return x()}}return Q(),s.getToken()===17?n.allowEmptyContent?!0:(Y(4,[],[]),!1):ee()?(s.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}e.$Cm=y;function p(t,o){const n=L(t),s=[];let i,r=0,a;do switch(a=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:r!==a&&s.push(t.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(i!==17);return s.join("")}e.$Dm=p;function C(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$Em=C}),define(oe[41],ae([0,1,34]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4R=e.$3R=e.$2R=e.$1R=void 0;function T(b,P,E){let m,h,$,v,c;if(P){for(v=P.offset,c=v+P.length,$=v;$>0&&!S(b,$-1);)$--;let a=c;for(;a<b.length&&!S(b,a);)a++;h=b.substring($,a),m=L(h,E)}else h=b,m=0,$=0,v=0,c=b.length;const l=R(E,b);let u=!1,y=0,p;E.insertSpaces?p=j(" ",E.tabSize||4):p="	";const C=(0,I.$tm)(h,!1);let t=!1;function o(){return l+j(p,m+y)}function n(){let a=C.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=C.scan();return t=a===16||C.getTokenError()!==0,a}const s=[];function i(a,w,g){!t&&w<c&&g>v&&b.substring(w,g)!==a&&s.push({offset:w,length:g-w,content:a})}let r=n();if(r!==17){const a=C.getTokenOffset()+$,w=j(p,m);i(w,$,a)}for(;r!==17;){let a=C.getTokenOffset()+C.getTokenLength()+$,w=n(),g="";for(;!u&&(w===12||w===13);){const k=C.getTokenOffset()+$;i(" ",a,k),a=C.getTokenOffset()+C.getTokenLength()+$,g=w===12?o():"",w=n()}if(w===2)r!==1&&(y--,g=o());else if(w===4)r!==3&&(y--,g=o());else{switch(r){case 3:case 1:y++,g=o();break;case 5:case 12:g=o();break;case 13:u?g=o():g=" ";break;case 6:g=" ";break;case 10:if(w===6){g="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?g=" ":w!==5&&w!==17&&(t=!0);break;case 16:t=!0;break}u&&(w===12||w===13)&&(g=o())}const f=C.getTokenOffset()+$;i(g,a,f),r=w}return s}e.$1R=T;function D(b,P){const E=JSON.stringify(b,void 0,P.insertSpaces?P.tabSize||4:"	");return P.eol!==void 0?E.replace(/\r\n|\r|\n/g,P.eol):E}e.$2R=D;function j(b,P){let E="";for(let m=0;m<P;m++)E+=b;return E}function L(b,P){let E=0,m=0;const h=P.tabSize||4;for(;E<b.length;){const $=b.charAt(E);if($===" ")m++;else if($==="	")m+=h;else break;E++}return Math.floor(m/h)}function R(b,P){for(let E=0;E<P.length;E++){const m=P.charAt(E);if(m==="\r")return E+1<P.length&&P.charAt(E+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return b&&b.eol||`
`}e.$3R=R;function S(b,P){return`\r
`.indexOf(b.charAt(P))!==-1}e.$4R=S}),define(oe[83],ae([0,1,34,41]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9R=e.$8R=e.$7R=e.$6R=e.$5R=void 0;function D(b,P,E){return j(b,P,void 0,E)}e.$5R=D;function j(b,P,E,m,h){const $=P.slice(),v=[],c=(0,I.$wm)(b,v);let l,u;for(;$.length>0&&(u=$.pop(),l=(0,I.$xm)(c,$),l===void 0&&E!==void 0);)typeof u=="string"?E={[u]:E}:E=[E];if(l)if(l.type==="object"&&typeof u=="string"&&Array.isArray(l.children)){const y=(0,I.$xm)(l,[u]);if(y!==void 0)if(E===void 0){if(!y.parent)throw new Error("Malformed AST");const p=l.children.indexOf(y.parent);let C,t=y.parent.offset+y.parent.length;if(p>0){const o=l.children[p-1];C=o.offset+o.length}else C=l.offset+1,l.children.length>1&&(t=l.children[1].offset);return L(b,{offset:C,length:t-C,content:""},m)}else return L(b,{offset:y.offset,length:y.length,content:JSON.stringify(E)},m);else{if(E===void 0)return[];const p=`${JSON.stringify(u)}: ${JSON.stringify(E)}`,C=h?h(l.children.map(o=>o.children[0].value)):l.children.length;let t;if(C>0){const o=l.children[C-1];t={offset:o.offset+o.length,length:0,content:","+p}}else l.children.length===0?t={offset:l.offset+1,length:0,content:p}:t={offset:l.offset+1,length:0,content:p+","};return L(b,t,m)}}else if(l.type==="array"&&typeof u=="number"&&Array.isArray(l.children))if(E!==void 0){const y=`${JSON.stringify(E)}`;let p;if(l.children.length===0||u===0)p={offset:l.offset+1,length:0,content:l.children.length===0?y:y+","};else{const C=u===-1||u>l.children.length?l.children.length:u,t=l.children[C-1];p={offset:t.offset+t.length,length:0,content:","+y}}return L(b,p,m)}else{const y=u,p=l.children[y];let C;if(l.children.length===1)C={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===y){const t=l.children[y-1],o=t.offset+t.length,n=l.offset+l.length;C={offset:o,length:n-2-o,content:""}}else C={offset:p.offset,length:l.children[y+1].offset-p.offset,content:""};return L(b,C,m)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${l.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return L(b,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(E)},m)}}e.$6R=j;function L(b,P,E){let m=R(b,P),h=P.offset,$=P.offset+P.content.length;if(P.length===0||P.content.length===0){for(;h>0&&!(0,T.$4R)(m,h-1);)h--;for(;$<m.length&&!(0,T.$4R)(m,$);)$++}const v=(0,T.$1R)(m,{offset:h,length:$-h},E);for(let l=v.length-1;l>=0;l--){const u=v[l];m=R(m,u),h=Math.min(h,u.offset),$=Math.max($,u.offset+u.length),$+=u.content.length-u.length}const c=b.length-(m.length-$)-h;return[{offset:h,length:c,content:m.substring(h,$)}]}e.$7R=L;function R(b,P){return b.substring(0,P.offset)+P.content+b.substring(P.offset+P.length)}e.$8R=R;function S(b,P){const E=P.slice(0).sort((h,$)=>{const v=h.offset-$.offset;return v===0?h.length-$.length:v});let m=b.length;for(let h=E.length-1;h>=0;h--){const $=E[h];if($.offset+$.length<=m)b=R(b,$);else throw new Error("Overlapping edit");m=$.offset}return b}e.$9R=S}),define(oe[84],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class I{constructor(D){this.d=D,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=I}),define(oe[2],ae([0,1,82,59]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const D=!1;let j=null;function L(r){j=r}if(e.$db=L,D){const r="__is_disposable_tracked__";L(new class{trackDisposable(a){const w=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(w)},3e3)}setParent(a,w){if(a&&a!==u.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==u.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function R(r){return j?.trackDisposable(r),r}function S(r){j?.markAsDisposed(r)}function b(r,a){j?.setParent(r,a)}function P(r,a){if(j)for(const w of r)j.setParent(w,a)}function E(r){return j?.markAsSingleton(r),r}e.$eb=E;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.$fb=m;function h(r){if(T.Iterable.is(r)){const a=[];for(const w of r)if(w)try{w.dispose()}catch(g){a.push(g)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.$gb=h;function $(r){for(const a of r)m(a)&&a.dispose();return[]}e.$hb=$;function v(...r){const a=c(()=>h(r));return P(r,a),a}e.$ib=v;function c(r){const a=R({dispose:(0,I.$cb)(()=>{S(a),r()})});return a}e.$jb=c;class l{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,R(this)}dispose(){this.g||(S(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return b(a,this),this.g?l.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(a),a}}e.$kb=l;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new l,R(this),b(this.q,this)}dispose(){S(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}e.$lb=u;class y{constructor(){this.b=!1,R(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&b(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,S(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&b(a,null),a}}e.$mb=y;class p{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=p;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,R(this)}set(a){let w=a;return this.unset=()=>w=void 0,this.isset=()=>w!==void 0,this.dispose=()=>{w&&(w(),w=void 0,S(this))},this}}e.$ob=C;class t{constructor(){this.a=new Map}acquire(a,...w){let g=this.a.get(a);g||(g={counter:0,object:this.b(a,...w)},this.a.set(a,g));const{object:f}=g,k=(0,I.$cb)(()=>{--g.counter===0&&(this.c(a,g.object),this.a.delete(a))});return g.counter++,{object:f,dispose:k}}}e.$pb=t;class o{constructor(a){this.a=a}async acquire(a,...w){const g=this.a.acquire(a,...w);try{return{object:await g.object,dispose:()=>g.dispose()}}catch(f){throw g.dispose(),f}}}e.$qb=o;class n{constructor(a){this.object=a}dispose(){}}e.$rb=n;function s(r){const a=new l;try{r(a)}finally{a.dispose()}}e.$sb=s;class i{constructor(){this.a=new Map,this.b=!1,R(this)}dispose(){S(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,w,g=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),g||this.a.get(a)?.dispose(),this.a.set(a,w)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=i}),define(oe[85],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lc=void 0;class I{static{this.Undefined=new I(void 0)}constructor(j){this.element=j,this.next=I.Undefined,this.prev=I.Undefined}}class T{constructor(){this.a=I.Undefined,this.b=I.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===I.Undefined}clear(){let j=this.a;for(;j!==I.Undefined;){const L=j.next;j.prev=I.Undefined,j.next=I.Undefined,j=L}this.a=I.Undefined,this.b=I.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,L){const R=new I(j);if(this.a===I.Undefined)this.a=R,this.b=R;else if(L){const b=this.b;this.b=R,R.prev=b,b.next=R}else{const b=this.a;this.a=R,R.next=b,b.prev=R}this.c+=1;let S=!1;return()=>{S||(S=!0,this.e(R))}}shift(){if(this.a!==I.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==I.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==I.Undefined&&j.next!==I.Undefined){const L=j.prev;L.next=j.next,j.next.prev=L}else j.prev===I.Undefined&&j.next===I.Undefined?(this.a=I.Undefined,this.b=I.Undefined):j.next===I.Undefined?(this.b=this.b.prev,this.b.next=I.Undefined):j.prev===I.Undefined&&(this.a=this.a.next,this.a.prev=I.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==I.Undefined;)yield j.element,j=j.next}}e.$lc=T}),define(oe[35],ae([0,1]),function(te,e){"use strict";var I,T,D;Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.Touch=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;function j(v,c,l){let u=v.get(c);return u===void 0&&(u=l,v.set(c,u)),u}e.$ii=j;function L(v){const c=[];return v.forEach((l,u)=>{c.push(`${u} => ${l}`)}),`Map(${v.size}) {${c.join(", ")}}`}e.$ji=L;function R(v){const c=[];return v.forEach(l=>{c.push(l)}),`Set(${v.size}) {${c.join(", ")}}`}e.$ki=R;class S{constructor(c,l){this.uri=c,this.value=l}}class b{static{this.a=c=>c.toString()}constructor(c,l){this[I]="ResourceMap",c instanceof b?(this.b=new Map(c.b),this.c=l??b.a):(this.b=new Map,this.c=c??b.a)}set(c,l){return this.b.set(this.c(c),new S(c,l)),this}get(c){return this.b.get(this.c(c))?.value}has(c){return this.b.has(this.c(c))}get size(){return this.b.size}clear(){this.b.clear()}delete(c){return this.b.delete(this.c(c))}forEach(c,l){typeof l<"u"&&(c=c.bind(l));for(const[u,y]of this.b)c(y.value,y.uri,this)}*values(){for(const c of this.b.values())yield c.value}*keys(){for(const c of this.b.values())yield c.uri}*entries(){for(const c of this.b.values())yield[c.uri,c.value]}*[(I=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.b)yield[c.uri,c.value]}}e.$li=b;class P{constructor(c,l){this[T]="ResourceSet",!c||typeof c=="function"?this.a=new b(c):(this.a=new b(l),c.forEach(this.add,this))}get size(){return this.a.size}add(c){return this.a.set(c,c),this}clear(){this.a.clear()}delete(c){return this.a.delete(c)}forEach(c,l){this.a.forEach((u,y)=>c.call(l,y,y,this))}has(c){return this.a.has(c)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$mi=P;var E;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class m{constructor(){this[D]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(c){return this.a.has(c)}get(c,l=0){const u=this.a.get(c);if(u)return l!==0&&this.j(u,l),u.value}set(c,l,u=0){let y=this.a.get(c);if(y)y.value=l,u!==0&&this.j(y,u);else{switch(y={key:c,value:l,next:void 0,previous:void 0},u){case 0:this.h(y);break;case 1:this.g(y);break;case 2:this.h(y);break;default:this.h(y);break}this.a.set(c,y),this.d++}return this}delete(c){return!!this.remove(c)}remove(c){const l=this.a.get(c);if(l)return this.a.delete(c),this.i(l),this.d--,l.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const c=this.b;return this.a.delete(c.key),this.i(c),this.d--,c.value}forEach(c,l){const u=this.e;let y=this.b;for(;y;){if(l?c.bind(l)(y.value,y.key,this):c(y.value,y.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const c=this,l=this.e;let u=this.b;const y={[Symbol.iterator](){return y},next(){if(c.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.key,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return y}values(){const c=this,l=this.e;let u=this.b;const y={[Symbol.iterator](){return y},next(){if(c.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:u.value,done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return y}entries(){const c=this,l=this.e;let u=this.b;const y={[Symbol.iterator](){return y},next(){if(c.e!==l)throw new Error("LinkedMap got modified during iteration.");if(u){const p={value:[u.key,u.value],done:!1};return u=u.next,p}else return{value:void 0,done:!0}}};return y}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(c){if(c>=this.size)return;if(c===0){this.clear();return}let l=this.b,u=this.size;for(;l&&u>c;)this.a.delete(l.key),l=l.next,u--;this.b=l,this.d=u,l&&(l.previous=void 0),this.e++}g(c){if(!this.b&&!this.c)this.c=c;else if(this.b)c.next=this.b,this.b.previous=c;else throw new Error("Invalid list");this.b=c,this.e++}h(c){if(!this.b&&!this.c)this.b=c;else if(this.c)c.previous=this.c,this.c.next=c;else throw new Error("Invalid list");this.c=c,this.e++}i(c){if(c===this.b&&c===this.c)this.b=void 0,this.c=void 0;else if(c===this.b){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.b=c.next}else if(c===this.c){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.c=c.previous}else{const l=c.next,u=c.previous;if(!l||!u)throw new Error("Invalid list");l.previous=u,u.next=l}c.next=void 0,c.previous=void 0,this.e++}j(c,l){if(!this.b||!this.c)throw new Error("Invalid list");if(!(l!==1&&l!==2)){if(l===1){if(c===this.b)return;const u=c.next,y=c.previous;c===this.c?(y.next=void 0,this.c=y):(u.previous=y,y.next=u),c.previous=void 0,c.next=this.b,this.b.previous=c,this.b=c,this.e++}else if(l===2){if(c===this.c)return;const u=c.next,y=c.previous;c===this.b?(u.previous=void 0,this.b=u):(u.previous=y,y.next=u),c.next=void 0,c.previous=this.c,this.c.next=c,this.c=c,this.e++}}}toJSON(){const c=[];return this.forEach((l,u)=>{c.push([u,l])}),c}fromJSON(c){this.clear();for(const[l,u]of c)this.set(l,u)}}e.$ni=m;class h extends m{constructor(c,l=1){super(),this.k=c,this.l=Math.min(Math.max(0,l),1)}get limit(){return this.k}set limit(c){this.k=c,this.m()}get ratio(){return this.l}set ratio(c){this.l=Math.min(Math.max(0,c),1),this.m()}get(c,l=2){return super.get(c,l)}peek(c){return super.get(c,0)}set(c,l){return super.set(c,l,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$oi=h;class ${constructor(){this.a=new Map}add(c){return this.a.set(c,(this.a.get(c)||0)+1),this}delete(c){let l=this.a.get(c)||0;return l===0?!1:(l--,l===0?this.a.delete(c):this.a.set(c,l),!0)}has(c){return this.a.has(c)}}e.$pi=$}),define(oe[86],ae([0,1,35]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=void 0;const T=new I.$oi(1e4);function D(b){return S(b,"NFC",T)}e.$5k=D;const j=new I.$oi(1e4);function L(b){return S(b,"NFD",j)}e.$6k=L;const R=/[^\u0000-\u0080]/;function S(b,P,E){if(!b)return b;const m=E.get(b);if(m)return m;let h;return R.test(b)?h=b.normalize(P):h=b,E.set(b,h),h}e.$7k=function(){const b=/[\u0300-\u036f]/g;return function(P){return L(P).replace(b,"")}}()}),function(){function te(D){const j=[];typeof D=="number"&&j.push("code/timeOrigin",D);function L(S){j.push(S,Date.now())}function R(){const S=[];for(let b=0;b<j.length;b+=2)S.push({name:j[b],startTime:j[b+1]});return S}return{mark:L,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const L of performance.getEntriesByType("mark"))j.push({name:L.name,startTime:Math.round(D+L.startTime)});return j}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function I(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=I(T))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var I=e();for(var T in I)(typeof exports=="object"?exports:te)[T]=I[T]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function I(T){if(e[T])return e[T].exports;var D=e[T]={i:T,l:!1,exports:{}};return te[T].call(D.exports,D,D.exports,I),D.l=!0,D.exports}return I.m=te,I.c=e,I.d=function(T,D,j){I.o(T,D)||Object.defineProperty(T,D,{enumerable:!0,get:j})},I.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},I.t=function(T,D){if(1&D&&(T=I(T)),8&D||4&D&&typeof T=="object"&&T&&T.__esModule)return T;var j=Object.create(null);if(I.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:T}),2&D&&typeof T!="string")for(var L in T)I.d(j,L,function(R){return T[R]}.bind(null,L));return j},I.n=function(T){var D=T&&T.__esModule?function(){return T.default}:function(){return T};return I.d(D,"a",D),D},I.o=function(T,D){return Object.prototype.hasOwnProperty.call(T,D)},I.p="",I(I.s=0)}([function(te,e,I){(function(T){var D;e=te.exports=re,D=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],S=e.src=[],b=0,P=b++;S[P]="0|[1-9]\\d*";var E=b++;S[E]="[0-9]+";var m=b++;S[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var h=b++;S[h]="("+S[P]+")\\.("+S[P]+")\\.("+S[P]+")";var $=b++;S[$]="("+S[E]+")\\.("+S[E]+")\\.("+S[E]+")";var v=b++;S[v]="(?:"+S[P]+"|"+S[m]+")";var c=b++;S[c]="(?:"+S[E]+"|"+S[m]+")";var l=b++;S[l]="(?:-("+S[v]+"(?:\\."+S[v]+")*))";var u=b++;S[u]="(?:-?("+S[c]+"(?:\\."+S[c]+")*))";var y=b++;S[y]="[0-9A-Za-z-]+";var p=b++;S[p]="(?:\\+("+S[y]+"(?:\\."+S[y]+")*))";var C=b++,t="v?"+S[h]+S[l]+"?"+S[p]+"?";S[C]="^"+t+"$";var o="[v=\\s]*"+S[$]+S[u]+"?"+S[p]+"?",n=b++;S[n]="^"+o+"$";var s=b++;S[s]="((?:<|>)?=?)";var i=b++;S[i]=S[E]+"|x|X|\\*";var r=b++;S[r]=S[P]+"|x|X|\\*";var a=b++;S[a]="[v=\\s]*("+S[r]+")(?:\\.("+S[r]+")(?:\\.("+S[r]+")(?:"+S[l]+")?"+S[p]+"?)?)?";var w=b++;S[w]="[v=\\s]*("+S[i]+")(?:\\.("+S[i]+")(?:\\.("+S[i]+")(?:"+S[u]+")?"+S[p]+"?)?)?";var g=b++;S[g]="^"+S[s]+"\\s*"+S[a]+"$";var f=b++;S[f]="^"+S[s]+"\\s*"+S[w]+"$";var k=b++;S[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=b++;S[N]="(?:~>?)";var M=b++;S[M]="(\\s*)"+S[N]+"\\s+",R[M]=new RegExp(S[M],"g");var F=b++;S[F]="^"+S[N]+S[a]+"$";var W=b++;S[W]="^"+S[N]+S[w]+"$";var q=b++;S[q]="(?:\\^)";var J=b++;S[J]="(\\s*)"+S[q]+"\\s+",R[J]=new RegExp(S[J],"g");var Q=b++;S[Q]="^"+S[q]+S[a]+"$";var Y=b++;S[Y]="^"+S[q]+S[w]+"$";var Z=b++;S[Z]="^"+S[s]+"\\s*("+o+")$|^$";var x=b++;S[x]="^"+S[s]+"\\s*("+t+")$|^$";var H=b++;S[H]="(\\s*)"+S[s]+"\\s*("+o+"|"+S[a]+")",R[H]=new RegExp(S[H],"g");var B=b++;S[B]="^\\s*("+S[a]+")\\s+-\\s+("+S[a]+")\\s*$";var V=b++;S[V]="^\\s*("+S[w]+")\\s+-\\s+("+S[w]+")\\s*$";var ee=b++;S[ee]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)D(ne,S[ne]),R[ne]||(R[ne]=new RegExp(S[ne]));function ce(le,de){if(le instanceof re)return le;if(typeof le!="string"||le.length>j||!(de?R[n]:R[C]).test(le))return null;try{return new re(le,de)}catch{return null}}function re(le,de){if(le instanceof re){if(le.loose===de)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof re))return new re(le,de);D("SemVer",le,de),this.loose=de;var $e=le.trim().match(de?R[n]:R[C]);if(!$e)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Se){if(/^[0-9]+$/.test(Se)){var Pe=+Se;if(Pe>=0&&Pe<L)return Pe}return Se}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=ce,e.valid=function(le,de){var $e=ce(le,de);return $e?$e.version:null},e.clean=function(le,de){var $e=ce(le.trim().replace(/^[=v]+/,""),de);return $e?$e.version:null},e.SemVer=re,re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},re.prototype.toString=function(){return this.version},re.prototype.compare=function(le){return D("SemVer.compare",this.version,this.loose,le),le instanceof re||(le=new re(le,this.loose)),this.compareMain(le)||this.comparePre(le)},re.prototype.compareMain=function(le){return le instanceof re||(le=new re(le,this.loose)),d(this.major,le.major)||d(this.minor,le.minor)||d(this.patch,le.patch)},re.prototype.comparePre=function(le){if(le instanceof re||(le=new re(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var de=0;do{var $e=this.prerelease[de],Se=le.prerelease[de];if(D("prerelease compare",de,$e,Se),$e===void 0&&Se===void 0)return 0;if(Se===void 0)return 1;if($e===void 0)return-1;if($e!==Se)return d($e,Se)}while(++de)},re.prototype.inc=function(le,de){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,de,$e,Se){typeof $e=="string"&&(Se=$e,$e=void 0);try{return new re(le,$e).inc(de,Se).version}catch{return null}},e.diff=function(le,de){if(U(le,de))return null;var $e=ce(le),Se=ce(de);if($e.prerelease.length||Se.prerelease.length){for(var Pe in $e)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&$e[Pe]!==Se[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in $e)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&$e[Pe]!==Se[Pe])return Pe},e.compareIdentifiers=d;var A=/^[0-9]+$/;function d(le,de){var $e=A.test(le),Se=A.test(de);return $e&&Se&&(le=+le,de=+de),$e&&!Se?-1:Se&&!$e?1:le<de?-1:le>de?1:0}function O(le,de,$e){return new re(le,$e).compare(new re(de,$e))}function z(le,de,$e){return O(le,de,$e)>0}function G(le,de,$e){return O(le,de,$e)<0}function U(le,de,$e){return O(le,de,$e)===0}function X(le,de,$e){return O(le,de,$e)!==0}function _(le,de,$e){return O(le,de,$e)>=0}function se(le,de,$e){return O(le,de,$e)<=0}function he(le,de,$e,Se){var Pe;switch(de){case"===":typeof le=="object"&&(le=le.version),typeof $e=="object"&&($e=$e.version),Pe=le===$e;break;case"!==":typeof le=="object"&&(le=le.version),typeof $e=="object"&&($e=$e.version),Pe=le!==$e;break;case"":case"=":case"==":Pe=U(le,$e,Se);break;case"!=":Pe=X(le,$e,Se);break;case">":Pe=z(le,$e,Se);break;case">=":Pe=_(le,$e,Se);break;case"<":Pe=G(le,$e,Se);break;case"<=":Pe=se(le,$e,Se);break;default:throw new TypeError("Invalid operator: "+de)}return Pe}function ue(le,de){if(le instanceof ue){if(le.loose===de)return le;le=le.value}if(!(this instanceof ue))return new ue(le,de);D("comparator",le,de),this.loose=de,this.parse(le),this.semver===me?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(le,de){return d(de,le)},e.major=function(le,de){return new re(le,de).major},e.minor=function(le,de){return new re(le,de).minor},e.patch=function(le,de){return new re(le,de).patch},e.compare=O,e.compareLoose=function(le,de){return O(le,de,!0)},e.rcompare=function(le,de,$e){return O(de,le,$e)},e.sort=function(le,de){return le.sort(function($e,Se){return e.compare($e,Se,de)})},e.rsort=function(le,de){return le.sort(function($e,Se){return e.rcompare($e,Se,de)})},e.gt=z,e.lt=G,e.eq=U,e.neq=X,e.gte=_,e.lte=se,e.cmp=he,e.Comparator=ue;var me={};function pe(le,de){if(le instanceof pe)return le.loose===de?le:new pe(le.raw,de);if(le instanceof ue)return new pe(le.value,de);if(!(this instanceof pe))return new pe(le,de);if(this.loose=de,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function ke(le){return!le||le.toLowerCase()==="x"||le==="*"}function Re(le,de,$e,Se,Pe,Me,Le,Ue,De,Ae,Fe,ie,fe){return((de=ke($e)?"":ke(Se)?">="+$e+".0.0":ke(Pe)?">="+$e+"."+Se+".0":">="+de)+" "+(Ue=ke(De)?"":ke(Ae)?"<"+(+De+1)+".0.0":ke(Fe)?"<"+De+"."+(+Ae+1)+".0":ie?"<="+De+"."+Ae+"."+Fe+"-"+ie:"<="+Ue)).trim()}function Oe(le,de){for(var $e=0;$e<le.length;$e++)if(!le[$e].test(de))return!1;if(de.prerelease.length){for($e=0;$e<le.length;$e++)if(D(le[$e].semver),le[$e].semver!==me&&le[$e].semver.prerelease.length>0){var Se=le[$e].semver;if(Se.major===de.major&&Se.minor===de.minor&&Se.patch===de.patch)return!0}return!1}return!0}function ze(le,de,$e){try{de=new pe(de,$e)}catch{return!1}return de.test(le)}function Je(le,de,$e,Se){var Pe,Me,Le,Ue,De;switch(le=new re(le,Se),de=new pe(de,Se),$e){case">":Pe=z,Me=se,Le=G,Ue=">",De=">=";break;case"<":Pe=G,Me=_,Le=z,Ue="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(le,de,Se))return!1;for(var Ae=0;Ae<de.set.length;++Ae){var Fe=de.set[Ae],ie=null,fe=null;if(Fe.forEach(function(ge){ge.semver===me&&(ge=new ue(">=0.0.0")),ie=ie||ge,fe=fe||ge,Pe(ge.semver,ie.semver,Se)?ie=ge:Le(ge.semver,fe.semver,Se)&&(fe=ge)}),ie.operator===Ue||ie.operator===De||(!fe.operator||fe.operator===Ue)&&Me(le,fe.semver)||fe.operator===De&&Le(le,fe.semver))return!1}return!0}ue.prototype.parse=function(le){var de=this.loose?R[Z]:R[x],$e=le.match(de);if(!$e)throw new TypeError("Invalid comparator: "+le);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new re($e[2],this.loose):this.semver=me},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(le){return D("Comparator.test",le,this.loose),this.semver===me||(typeof le=="string"&&(le=new re(le,this.loose)),he(le,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(le,de){if(!(le instanceof ue))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new pe(le.value,de),ze(this.value,$e,de);if(le.operator==="")return $e=new pe(this.value,de),ze(le.semver,$e,de);var Se=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Me=this.semver.version===le.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Ue=he(this.semver,"<",le.semver,de)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),De=he(this.semver,">",le.semver,de)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Se||Pe||Me&&Le||Ue||De},e.Range=pe,pe.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},pe.prototype.toString=function(){return this.range},pe.prototype.parseRange=function(le){var de=this.loose;le=le.trim(),D("range",le,de);var $e=de?R[V]:R[B];le=le.replace($e,Re),D("hyphen replace",le),le=le.replace(R[H],"$1$2$3"),D("comparator trim",le,R[H]),le=(le=(le=le.replace(R[M],"$1~")).replace(R[J],"$1^")).split(/\s+/).join(" ");var Se=de?R[Z]:R[x],Pe=le.split(" ").map(function(Me){return function(Le,Ue){return D("comp",Le),Le=function(De,Ae){return De.trim().split(/\s+/).map(function(Fe){return function(ie,fe){D("caret",ie,fe);var ge=fe?R[Y]:R[Q];return ie.replace(ge,function(ye,we,Ee,Ce,Ie){var je;return D("caret",ie,ye,we,Ee,Ce,Ie),ke(we)?je="":ke(Ee)?je=">="+we+".0.0 <"+(+we+1)+".0.0":ke(Ce)?je=we==="0"?">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+".0 <"+(+we+1)+".0.0":Ie?(D("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),je=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+Ce+Ie+" <"+we+"."+Ee+"."+(+Ce+1):">="+we+"."+Ee+"."+Ce+Ie+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+Ce+Ie+" <"+(+we+1)+".0.0"):(D("no pr"),je=we==="0"?Ee==="0"?">="+we+"."+Ee+"."+Ce+" <"+we+"."+Ee+"."+(+Ce+1):">="+we+"."+Ee+"."+Ce+" <"+we+"."+(+Ee+1)+".0":">="+we+"."+Ee+"."+Ce+" <"+(+we+1)+".0.0"),D("caret return",je),je})}(Fe,Ae)}).join(" ")}(Le,Ue),D("caret",Le),Le=function(De,Ae){return De.trim().split(/\s+/).map(function(Fe){return function(ie,fe){var ge=fe?R[W]:R[F];return ie.replace(ge,function(ye,we,Ee,Ce,Ie){var je;return D("tilde",ie,ye,we,Ee,Ce,Ie),ke(we)?je="":ke(Ee)?je=">="+we+".0.0 <"+(+we+1)+".0.0":ke(Ce)?je=">="+we+"."+Ee+".0 <"+we+"."+(+Ee+1)+".0":Ie?(D("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),je=">="+we+"."+Ee+"."+Ce+Ie+" <"+we+"."+(+Ee+1)+".0"):je=">="+we+"."+Ee+"."+Ce+" <"+we+"."+(+Ee+1)+".0",D("tilde return",je),je})}(Fe,Ae)}).join(" ")}(Le,Ue),D("tildes",Le),Le=function(De,Ae){return D("replaceXRanges",De,Ae),De.split(/\s+/).map(function(Fe){return function(ie,fe){ie=ie.trim();var ge=fe?R[f]:R[g];return ie.replace(ge,function(ye,we,Ee,Ce,Ie,je){D("xRange",ie,ye,we,Ee,Ce,Ie,je);var Be=ke(Ee),Te=Be||ke(Ce),qe=Te||ke(Ie);return we==="="&&qe&&(we=""),Be?ye=we===">"||we==="<"?"<0.0.0":"*":we&&qe?(Te&&(Ce=0),qe&&(Ie=0),we===">"?(we=">=",Te?(Ee=+Ee+1,Ce=0,Ie=0):qe&&(Ce=+Ce+1,Ie=0)):we==="<="&&(we="<",Te?Ee=+Ee+1:Ce=+Ce+1),ye=we+Ee+"."+Ce+"."+Ie):Te?ye=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":qe&&(ye=">="+Ee+"."+Ce+".0 <"+Ee+"."+(+Ce+1)+".0"),D("xRange return",ye),ye})}(Fe,Ae)}).join(" ")}(Le,Ue),D("xrange",Le),Le=function(De,Ae){return D("replaceStars",De,Ae),De.trim().replace(R[ee],"")}(Le,Ue),D("stars",Le),Le}(Me,de)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Me){return!!Me.match(Se)})),Pe=Pe.map(function(Me){return new ue(Me,de)})},pe.prototype.intersects=function(le,de){if(!(le instanceof pe))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Se){return le.set.some(function(Pe){return Pe.every(function(Me){return Se.intersects(Me,de)})})})})},e.toComparators=function(le,de){return new pe(le,de).set.map(function($e){return $e.map(function(Se){return Se.value}).join(" ").trim().split(" ")})},pe.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new re(le,this.loose));for(var de=0;de<this.set.length;de++)if(Oe(this.set[de],le))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(le,de,$e){var Se=null,Pe=null;try{var Me=new pe(de,$e)}catch{return null}return le.forEach(function(Le){Me.test(Le)&&(Se&&Pe.compare(Le)!==-1||(Pe=new re(Se=Le,$e)))}),Se},e.minSatisfying=function(le,de,$e){var Se=null,Pe=null;try{var Me=new pe(de,$e)}catch{return null}return le.forEach(function(Le){Me.test(Le)&&(Se&&Pe.compare(Le)!==1||(Pe=new re(Se=Le,$e)))}),Se},e.validRange=function(le,de){try{return new pe(le,de).range||"*"}catch{return null}},e.ltr=function(le,de,$e){return Je(le,de,"<",$e)},e.gtr=function(le,de,$e){return Je(le,de,">",$e)},e.outside=Je,e.prerelease=function(le,de){var $e=ce(le,de);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(le,de,$e){return le=new pe(le,$e),de=new pe(de,$e),le.intersects(de)},e.coerce=function(le){if(le instanceof re)return le;if(typeof le!="string")return null;var de=le.match(R[k]);return de==null?null:ce((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,I(1))},function(te,e){var I,T,D=te.exports={};function j(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function R(c){if(I===setTimeout)return setTimeout(c,0);if((I===j||!I)&&setTimeout)return I=setTimeout,setTimeout(c,0);try{return I(c,0)}catch{try{return I.call(null,c,0)}catch{return I.call(this,c,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:j}catch{I=j}try{T=typeof clearTimeout=="function"?clearTimeout:L}catch{T=L}})();var S,b=[],P=!1,E=-1;function m(){P&&S&&(P=!1,S.length?b=S.concat(b):E=-1,b.length&&h())}function h(){if(!P){var c=R(m);P=!0;for(var l=b.length;l;){for(S=b,b=[];++E<l;)S&&S[E].run();E=-1,l=b.length}S=null,P=!1,function(u){if(T===clearTimeout)return clearTimeout(u);if((T===L||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(u);try{T(u)}catch{try{return T.call(null,u)}catch{return T.call(this,u)}}}(c)}}function $(c,l){this.fun=c,this.array=l}function v(){}D.nextTick=function(c){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];b.push(new $(c,l)),b.length!==1||P||R(h)},$.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=v,D.addListener=v,D.once=v,D.off=v,D.removeListener=v,D.removeAllListeners=v,D.emit=v,D.prependListener=v,D.prependOnceListener=v,D.listeners=function(c){return[]},D.binding=function(c){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(c){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(oe[124],ae([0,1]),function(te,e){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0;class T{constructor(R,S,b){this.level=R,this.key=S,this.value=b,this.forward=[]}}const D=void 0;class j{constructor(R,S=2**16){this.comparator=R,this[I]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(S)|0),this.e=new T(this.c,D,D)}get size(){return this.f}clear(){this.e=new T(this.c,D,D)}has(R){return!!j.g(this,R,this.comparator)}get(R){return j.g(this,R,this.comparator)?.value}set(R,S){return j.h(this,R,S,this.comparator)&&(this.f+=1),this}delete(R){const S=j.k(this,R,this.comparator);return S&&(this.f-=1),S}forEach(R,S){let b=this.e.forward[0];for(;b;)R.call(S,b.value,b.key,this),b=b.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this.e.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this.e.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this.e.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",S=this.e.forward[0];for(;S;)R+=`node(${S.key}, ${S.value}, lvl:${S.level})`,S=S.forward[0];return R}static g(R,S,b){let P=R.e;for(let E=R.d-1;E>=0;E--)for(;P.forward[E]&&b(P.forward[E].key,S)<0;)P=P.forward[E];if(P=P.forward[0],P&&b(P.key,S)===0)return P}static h(R,S,b,P){const E=[];let m=R.e;for(let h=R.d-1;h>=0;h--){for(;m.forward[h]&&P(m.forward[h].key,S)<0;)m=m.forward[h];E[h]=m}if(m=m.forward[0],m&&P(m.key,S)===0)return m.value=b,!1;{const h=j.j(R);if(h>R.d){for(let $=R.d;$<h;$++)E[$]=R.e;R.d=h}m=new T(h,S,b);for(let $=0;$<h;$++)m.forward[$]=E[$].forward[$],E[$].forward[$]=m;return!0}}static j(R,S=.5){let b=1;for(;Math.random()<S&&b<R.c;)b+=1;return b}static k(R,S,b){const P=[];let E=R.e;for(let m=R.d-1;m>=0;m--){for(;E.forward[m]&&b(E.forward[m].key,S)<0;)E=E.forward[m];P[m]=E}if(E=E.forward[0],!E||b(E.key,S)!==0)return!1;for(let m=0;m<R.d&&P[m].forward[m]===E;m++)P[m].forward[m]=E.forward[m];for(;R.d>0&&R.e.forward[R.d-1]===D;)R.d-=1;return!0}}e.$_q=j}),define(oe[87],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;const I=globalThis.performance&&typeof globalThis.performance.now=="function";class T{static create(j){return new T(j)}constructor(j){this.c=I&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3c=T}),define(oe[3],ae([0,1,7,82,2,85,87]),function(te,e,I,T,D,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.Event=void 0;const R=!1,S=!1;var b;(function(w){w.None=()=>D.$lb.None;function g(U){if(S){const{onDidAddListener:X}=U,_=$.create();let se=0;U.onDidAddListener=()=>{++se===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),_.print()),X?.()}}}function f(U,X){return Y(U,()=>{},0,void 0,!0,void 0,X)}w.defer=f;function k(U){return(X,_=null,se)=>{let he=!1,ue;return ue=U(me=>{if(!he)return ue?ue.dispose():he=!0,X.call(_,me)},null,se),he&&ue.dispose(),ue}}w.once=k;function N(U,X,_){return Q((se,he=null,ue)=>U(me=>se.call(he,X(me)),null,ue),_)}w.map=N;function M(U,X,_){return Q((se,he=null,ue)=>U(me=>{X(me),se.call(he,me)},null,ue),_)}w.forEach=M;function F(U,X,_){return Q((se,he=null,ue)=>U(me=>X(me)&&se.call(he,me),null,ue),_)}w.filter=F;function W(U){return U}w.signal=W;function q(...U){return(X,_=null,se)=>(0,D.$ib)(...U.map(he=>he(ue=>X.call(_,ue),null,se)))}w.any=q;function J(U,X,_,se){let he=_;return N(U,ue=>(he=X(he,ue),he),se)}w.reduce=J;function Q(U,X){let _;const se={onWillAddFirstListener(){_=U(he.fire,he)},onDidRemoveLastListener(){_?.dispose()}};X||g(se);const he=new y(se);return X?.add(he),he.event}function Y(U,X,_=100,se=!1,he=!1,ue,me){let pe,ke,Re,Oe=0,ze;const Je={leakWarningThreshold:ue,onWillAddFirstListener(){pe=U(de=>{Oe++,ke=X(ke,de),se&&!Re&&(le.fire(ke),ke=void 0),ze=()=>{const $e=ke;ke=void 0,Re=void 0,(!se||Oe>1)&&le.fire($e),Oe=0},typeof _=="number"?(clearTimeout(Re),Re=setTimeout(ze,_)):Re===void 0&&(Re=0,queueMicrotask(ze))})},onWillRemoveListener(){he&&Oe>0&&ze?.()},onDidRemoveLastListener(){ze=void 0,pe.dispose()}};me||g(Je);const le=new y(Je);return me?.add(le),le.event}w.debounce=Y;function Z(U,X=0,_){return w.debounce(U,(se,he)=>se?(se.push(he),se):[he],X,void 0,!0,void 0,_)}w.accumulate=Z;function x(U,X=(se,he)=>se===he,_){let se=!0,he;return F(U,ue=>{const me=se||!X(ue,he);return se=!1,he=ue,me},_)}w.latch=x;function H(U,X,_){return[w.filter(U,X,_),w.filter(U,se=>!X(se),_)]}w.split=H;function B(U,X=!1,_=[]){let se=_.slice(),he=U(pe=>{se?se.push(pe):me.fire(pe)});const ue=()=>{se?.forEach(pe=>me.fire(pe)),se=null},me=new y({onWillAddFirstListener(){he||(he=U(pe=>me.fire(pe)))},onDidAddFirstListener(){se&&(X?setTimeout(ue):ue())},onDidRemoveLastListener(){he&&he.dispose(),he=null}});return me.event}w.buffer=B;class V{constructor(X){this.event=X,this.d=new D.$kb}map(X){return new V(N(this.event,X,this.d))}forEach(X){return new V(M(this.event,X,this.d))}filter(X){return new V(F(this.event,X,this.d))}reduce(X,_){return new V(J(this.event,X,_,this.d))}latch(){return new V(x(this.event,void 0,this.d))}debounce(X,_=100,se=!1,he=!1,ue){return new V(Y(this.event,X,_,se,he,ue,this.d))}on(X,_,se){return this.event(X,_,se)}once(X,_,se){return k(this.event)(X,_,se)}dispose(){this.d.dispose()}}function ee(U){return new V(U)}w.chain=ee;function ne(U,X,_=se=>se){const se=(...pe)=>me.fire(_(...pe)),he=()=>U.on(X,se),ue=()=>U.removeListener(X,se),me=new y({onWillAddFirstListener:he,onDidRemoveLastListener:ue});return me.event}w.fromNodeEventEmitter=ne;function ce(U,X,_=se=>se){const se=(...pe)=>me.fire(_(...pe)),he=()=>U.addEventListener(X,se),ue=()=>U.removeEventListener(X,se),me=new y({onWillAddFirstListener:he,onDidRemoveLastListener:ue});return me.event}w.fromDOMEventEmitter=ce;function re(U){return new Promise(X=>k(U)(X))}w.toPromise=re;function A(U,X){return X(void 0),U(_=>X(_))}w.runAndSubscribe=A;function d(U,X){let _=null;function se(ue){_?.dispose(),_=new D.$kb,X(ue,_)}se(void 0);const he=U(ue=>se(ue));return(0,D.$jb)(()=>{he.dispose(),_?.dispose()})}w.runAndSubscribeWithStore=d;class O{constructor(X,_){this._observable=X,this.d=0,this.f=!1;const se={onWillAddFirstListener:()=>{X.addObserver(this)},onDidRemoveLastListener:()=>{X.removeObserver(this)}};_||g(se),this.emitter=new y(se),_&&_.add(this.emitter)}beginUpdate(X){this.d++}handlePossibleChange(X){}handleChange(X,_){this.f=!0}endUpdate(X){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function z(U,X){return new O(U,X).emitter.event}w.fromObservable=z;function G(U){return X=>{let _=0,se=!1;const he={beginUpdate(){_++},endUpdate(){_--,_===0&&(U.reportChanges(),se&&(se=!1,X()))},handlePossibleChange(){},handleChange(){se=!0}};return U.addObserver(he),U.reportChanges(),{dispose(){U.removeObserver(he)}}}}w.fromObservableLight=G})(b||(e.Event=b={}));class P{static{this.all=new Set}static{this.d=0}constructor(g){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${g}_${P.d++}`,P.all.add(this)}start(g){this.f=new L.$3c,this.listenerCount=g}stop(){if(this.f){const g=this.f.elapsed();this.durations.push(g),this.elapsedOverall+=g,this.invocationCount+=1,this.f=void 0}}}e.$5c=P;let E=-1;function m(w){const g=E;return E=w,{dispose(){E=g}}}e.$6c=m;class h{constructor(g,f=Math.random().toString(18).slice(2,5)){this.threshold=g,this.name=f,this.f=0}dispose(){this.d?.clear()}check(g,f){const k=this.threshold;if(k<=0||f<k)return;this.d||(this.d=new Map);const N=this.d.get(g.value)||0;if(this.d.set(g.value,N+1),this.f-=1,this.f<=0){this.f=k*.5;let M,F=0;for(const[W,q]of this.d)(!M||F<q)&&(M=W,F=q);console.warn(`[${this.name}] potential listener LEAK detected, having ${f} listeners already. MOST frequent listener (${F}):`),console.warn(M)}return()=>{const M=this.d.get(g.value)||0;this.d.set(g.value,M-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(g){this.value=g}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let v=0;class c{constructor(g){this.value=g,this.id=v++}}const l=2,u=(w,g)=>{if(w instanceof c)g(w);else for(let f=0;f<w.length;f++){const k=w[f];k&&g(k)}};class y{constructor(g){this.u=0,this.d=g,this.f=E>0||this.d?.leakWarningThreshold?new h(this.d?.leakWarningThreshold??E):void 0,this.g=this.d?._profName?new P(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(R){const g=this.q;queueMicrotask(()=>{u(g,f=>f.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(g,f,k)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.$lb.None;if(this.j)return D.$lb.None;f&&(g=g.bind(f));const N=new c(g);let M,F;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(N.stack=$.create(),M=this.f.check(N.stack,this.u+1)),R&&(N.stack=F??$.create()),this.q?this.q instanceof c?(this.t??=new C,this.q=[this.q,N]):this.q.push(N):(this.d?.onWillAddFirstListener?.(this),this.q=N,this.d?.onDidAddFirstListener?.(this)),this.u++;const W=(0,D.$jb)(()=>{M?.(),this.v(N)});return k instanceof D.$kb?k.add(W):Array.isArray(k)&&k.push(W),W},this.m}v(g){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const f=this.q,k=f.indexOf(g);if(k===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,f[k]=void 0;const N=this.t.current===this;if(this.u*l<=f.length){let M=0;for(let F=0;F<f.length;F++)f[F]?f[M++]=f[F]:N&&(this.t.end--,M<this.t.i&&this.t.i--);f.length=M}}w(g,f){if(!g)return;const k=this.d?.onListenerError||I.$Y;if(!k){g.value(f);return}try{g.value(f)}catch(N){k(N)}}x(g){const f=g.current.q;for(;g.i<g.end;)this.w(f[g.i++],g.value);g.reset()}fire(g){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof c)this.w(this.q,g);else{const f=this.t;f.enqueue(this,g,this.q.length),this.x(f)}this.g?.stop()}hasListeners(){return this.u>0}}e.$7c=y;const p=()=>new C;e.$8c=p;class C{constructor(){this.i=-1,this.end=0}enqueue(g,f,k){this.i=0,this.end=k,this.current=g,this.value=f}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends y{async fireAsync(g,f,k){if(this.q)for(this.h||(this.h=new j.$lc),u(this.q,N=>this.h.push([N.value,g]));this.h.size>0&&!f.isCancellationRequested;){const[N,M]=this.h.shift(),F=[],W={...M,token:f,waitUntil:q=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");k&&(q=k(q,N)),F.push(q)}};try{N(W)}catch(q){(0,I.$Y)(q);continue}Object.freeze(F),await Promise.allSettled(F).then(q=>{for(const J of q)J.status==="rejected"&&(0,I.$Y)(J.reason)})}}}e.$9c=t;class o extends y{get isPaused(){return this.h!==0}constructor(g){super(g),this.h=0,this.s=new j.$lc,this.y=g?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const g=Array.from(this.s);this.s.clear(),super.fire(this.y(g))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(g){this.u&&(this.h!==0?this.s.push(g):super.fire(g))}}e.$0c=o;class n extends o{constructor(g){super(g),this.k=g.delay??100}fire(g){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(g)}}e.$$c=n;class s extends y{constructor(g){super(g),this.h=[],this.k=g?.merge}fire(g){this.hasListeners()&&(this.h.push(g),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(f=>super.fire(f)),this.h=[]}))}}e.$_c=s;class i{constructor(){this.f=!1,this.g=[],this.d=new y({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(g){const f={event:g,listener:null};this.g.push(f),this.f&&this.k(f);const k=()=>{this.f&&this.m(f);const N=this.g.indexOf(f);this.g.splice(N,1)};return(0,D.$jb)((0,T.$cb)(k))}h(){this.f=!0,this.g.forEach(g=>this.k(g))}j(){this.f=!1,this.g.forEach(g=>this.m(g))}k(g){g.listener=g.event(f=>this.d.fire(f))}m(g){g.listener&&g.listener.dispose(),g.listener=null}dispose(){this.d.dispose()}}e.$ad=i;class r{constructor(){this.d=[]}wrapEvent(g){return(f,k,N)=>g(M=>{const F=this.d[this.d.length-1];F?F.push(()=>f.call(k,M)):f.call(k,M)},void 0,N)}bufferEvents(g){const f=[];this.d.push(f);const k=g();return this.d.pop(),f.forEach(N=>N()),k}}e.$bd=r;class a{constructor(){this.d=!1,this.f=b.None,this.g=D.$lb.None,this.h=new y({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(g){this.f=g,this.d&&(this.g.dispose(),this.g=g(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$cd=a}),define(oe[25],ae([0,1,3]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=e.CancellationToken=void 0;const T=Object.freeze(function(R,S){const b=setTimeout(R.bind(S),0);return{dispose(){clearTimeout(b)}}});var D;(function(R){function S(b){return b===R.None||b===R.Cancelled||b instanceof j?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}R.isCancellationToken=S,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:I.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(D||(e.CancellationToken=D={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?T:(this.b||(this.b=new I.$7c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor(S){this.a=void 0,this.b=void 0,this.b=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new j),this.a}cancel(){this.a?this.a instanceof j&&this.a.cancel():this.a=D.Cancelled}dispose(S=!1){S&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof j&&this.a.dispose():this.a=D.None}}e.$dd=L}),define(oe[125],ae([0,1,25]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gd=e.$fd=e.$ed=void 0;class T{constructor(R){this.b=R,this.a=null}get(){if(this.a)return this.a;const R=new I.$dd,S=this.b(R.token);return this.a={promise:S,dispose:()=>{this.a=null,R.cancel(),R.dispose()}},this.a}}e.$ed=T;class D{constructor(R){this.c=R,this.a=void 0,this.b=void 0}get(R){const S=JSON.stringify(R);return this.b!==S&&(this.b=S,this.a=this.c(R)),this.a}}e.$fd=D;class j{get cachedValues(){return this.a}constructor(R){this.b=R,this.a=new Map}get(R){if(this.a.has(R))return this.a.get(R);const S=this.b(R);return this.a.set(R,S),S}}e.$gd=j}),define(oe[42],ae([0,1,7,2]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function D(p){const C=p;return C?typeof C.read=="function":!1}e.$ub=D;function j(p){const C=p;return C?[C.on,C.pause,C.resume,C.destroy].every(t=>typeof t=="function"):!1}e.$vb=j;function L(p){const C=p;return C?j(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.$wb=L;function R(p,C){return new S(p,C)}e.$xb=R;class S{constructor(C,t){this.e=C,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(t=>t(C))}h(C){this.c.error.length===0?(0,I.$Y)(C):this.c.error.slice(0).forEach(t=>t(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,t){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(C,t){if(this.a.destroyed)return;let o;switch(C){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(t);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(p,C){const t=[];let o;for(;(o=p.read())!==null;)t.push(o);return C(t)}e.$yb=b;function P(p,C,t){const o=[];let n;for(;(n=p.read())!==null&&o.length<t;)o.push(n);return n===null&&o.length>0?C(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return p.read()}}}e.$zb=P;function E(p,C){return new Promise((t,o)=>{const n=[];m(p,{onData:s=>{C&&n.push(s)},onError:s=>{C?o(s):t(void 0)},onEnd:()=>{t(C?C(n):void 0)}})})}e.$Ab=E;function m(p,C){let t=!1;return p.on("error",o=>{t||C.onError(o)}),p.on("end",()=>{t||C.onEnd()}),p.on("data",o=>{t||C.onData(o)}),(0,T.$jb)(()=>t=!0)}e.$Bb=m;function h(p,C){return new Promise((t,o)=>{const n=new T.$kb,s=[],i=w=>{if(s.push(w),s.length>C)return n.dispose(),p.pause(),t({stream:p,buffer:s,ended:!1})},r=w=>o(w),a=()=>t({stream:p,buffer:s,ended:!0});n.add((0,T.$jb)(()=>p.removeListener("error",r))),p.on("error",r),n.add((0,T.$jb)(()=>p.removeListener("end",a))),p.on("end",a),n.add((0,T.$jb)(()=>p.removeListener("data",i))),p.on("data",i)})}e.$Cb=h;function $(p,C){const t=R(C);return t.end(p),t}e.$Db=$;function v(){const p=R(()=>{throw new Error("not supported")});return p.end(),p}e.$Eb=v;function c(p){let C=!1;return{read:()=>C?null:(C=!0,p)}}e.$Fb=c;function l(p,C,t){const o=R(t);return m(p,{onData:n=>o.write(C.data(n)),onError:n=>o.error(C.error?C.error(n):n),onEnd:()=>o.end()}),o}e.$Gb=l;function u(p,C,t){let o=!1;return{read:()=>{const n=C.read();return o?n:(o=!0,n!==null?t([p,n]):p)}}}e.$Hb=u;function y(p,C,t){let o=!1;const n=R(t);return m(C,{onData:s=>o?n.write(s):(o=!0,n.write(t([p,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(p)),n.end()}}),n}e.$Ib=y}),define(oe[14],ae([0,1,84,42]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const D=typeof Buffer<"u",j=new I.$T(()=>new Uint8Array(256));let L,R;class S{static alloc(k){return D?new S(Buffer.allocUnsafe(k)):new S(new Uint8Array(k))}static wrap(k){return D&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new S(k)}static fromString(k,N){return!(N?.dontUseNodeBuffer||!1)&&D?new S(Buffer.from(k)):(L||(L=new TextEncoder),new S(L.encode(k)))}static fromByteArray(k){const N=S.alloc(k.length);for(let M=0,F=k.length;M<F;M++)N.buffer[M]=k[M];return N}static concat(k,N){if(typeof N>"u"){N=0;for(let W=0,q=k.length;W<q;W++)N+=k[W].byteLength}const M=S.alloc(N);let F=0;for(let W=0,q=k.length;W<q;W++){const J=k[W];M.set(J,F),F+=J.byteLength}return M}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=S.alloc(this.byteLength);return k.set(this),k}toString(){return D?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(k,N){return new S(this.buffer.subarray(k,N))}set(k,N){if(k instanceof S)this.buffer.set(k.buffer,N);else if(k instanceof Uint8Array)this.buffer.set(k,N);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),N);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return m(this.buffer,k)}writeUInt32BE(k,N){h(this.buffer,k,N)}readUInt32LE(k){return $(this.buffer,k)}writeUInt32LE(k,N){v(this.buffer,k,N)}readUInt8(k){return c(this.buffer,k)}writeUInt8(k,N){l(this.buffer,k,N)}indexOf(k,N=0){return b(this.buffer,k instanceof S?k.buffer:k,N)}}e.$Jb=S;function b(f,k,N=0){const M=k.byteLength,F=f.byteLength;if(M===0)return 0;if(M===1)return f.indexOf(k[0]);if(M>F-N)return-1;const W=j.value;W.fill(k.length);for(let Y=0;Y<k.length;Y++)W[k[Y]]=k.length-Y-1;let q=N+k.length-1,J=q,Q=-1;for(;q<F;)if(f[q]===k[J]){if(J===0){Q=q;break}q--,J--}else q+=Math.max(k.length-J,W[f[q]]),J=k.length-1;return Q}e.$Kb=b;function P(f,k){return f[k+0]<<0>>>0|f[k+1]<<8>>>0}e.$Lb=P;function E(f,k,N){f[N+0]=k&255,k=k>>>8,f[N+1]=k&255}e.$Mb=E;function m(f,k){return f[k]*2**24+f[k+1]*2**16+f[k+2]*2**8+f[k+3]}e.$Nb=m;function h(f,k,N){f[N+3]=k,k=k>>>8,f[N+2]=k,k=k>>>8,f[N+1]=k,k=k>>>8,f[N]=k}e.$Ob=h;function $(f,k){return f[k+0]<<0>>>0|f[k+1]<<8>>>0|f[k+2]<<16>>>0|f[k+3]<<24>>>0}e.$Pb=$;function v(f,k,N){f[N+0]=k&255,k=k>>>8,f[N+1]=k&255,k=k>>>8,f[N+2]=k&255,k=k>>>8,f[N+3]=k&255}e.$Qb=v;function c(f,k){return f[k]}e.$Rb=c;function l(f,k,N){f[N]=k}e.$Sb=l;function u(f){return T.$yb(f,k=>S.concat(k))}e.$Tb=u;function y(f){return T.$Fb(f)}e.$Ub=y;function p(f){return T.$Ab(f,k=>S.concat(k))}e.$Vb=p;async function C(f){return f.ended?S.concat(f.buffer):S.concat([...f.buffer,await p(f.stream)])}e.$Wb=C;function t(f){return T.$Db(f,k=>S.concat(k))}e.$Xb=t;function o(f){return T.$Gb(f,{data:k=>typeof k=="string"?S.fromString(k):S.wrap(k)},k=>S.concat(k))}e.$Yb=o;function n(f){return T.$xb(k=>S.concat(k),f)}e.$Zb=n;function s(f,k){return T.$Hb(f,k,N=>S.concat(N))}e.$1b=s;function i(f,k){return T.$Ib(f,k,N=>S.concat(N))}e.$2b=i;function r(f){let k=0,N=0,M=0;const F=new Uint8Array(Math.floor(f.length/4*3)),W=J=>{switch(N){case 3:F[M++]=k|J,N=0;break;case 2:F[M++]=k|J>>>2,k=J<<6,N=3;break;case 1:F[M++]=k|J>>>4,k=J<<4,N=2;break;default:k=J<<2,N=1}};for(let J=0;J<f.length;J++){const Q=f.charCodeAt(J);if(Q>=65&&Q<=90)W(Q-65);else if(Q>=97&&Q<=122)W(Q-97+26);else if(Q>=48&&Q<=57)W(Q-48+52);else if(Q===43||Q===45)W(62);else if(Q===47||Q===95)W(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${f[J]}`)}}const q=M;for(;N>0;)W(0);return S.wrap(F).slice(0,q)}e.$3b=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:f},k=!0,N=!1){const M=N?w:a;let F="";const W=f.byteLength%3;let q=0;for(;q<f.byteLength-W;q+=3){const J=f[q+0],Q=f[q+1],Y=f[q+2];F+=M[J>>>2],F+=M[(J<<4|Q>>>4)&63],F+=M[(Q<<2|Y>>>6)&63],F+=M[Y&63]}if(W===1){const J=f[q+0];F+=M[J>>>2],F+=M[J<<4&63],k&&(F+="==")}else if(W===2){const J=f[q+0],Q=f[q+1];F+=M[J>>>2],F+=M[(J<<4|Q>>>4)&63],F+=M[Q<<2&63],k&&(F+="=")}return F}e.$4b=g}),define(oe[27],ae([0,1,125,84]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.GraphemeBreakType=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=void 0;function D(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$jd=D;const j=/{(\d+)}/g;function L(ie,...fe){return fe.length===0?ie:ie.replace(j,function(ge,ye){const we=parseInt(ye,10);return isNaN(we)||we<0||we>=fe.length?ge:fe[we]})}e.$kd=L;const R=/{([^}]+)}/g;function S(ie,fe){return ie.replace(R,(ge,ye)=>fe[ye]??ge)}e.$ld=S;function b(ie){return ie.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$md=b;function P(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$nd=P;function E(ie,fe){let ge=0;const ye=fe.charCodeAt(0);for(let we=ie.length-1;we>=0;we--)ie.charCodeAt(we)===ye&&ge++;return ge}e.$od=E;function m(ie,fe,ge="\u2026"){return ie.length<=fe?ie:`${ie.substr(0,fe)}${ge}`}e.$pd=m;function h(ie,fe=" "){const ge=$(ie,fe);return v(ge,fe)}e.$qd=h;function $(ie,fe){if(!ie||!fe)return ie;const ge=fe.length;if(ge===0||ie.length===0)return ie;let ye=0;for(;ie.indexOf(fe,ye)===ye;)ye=ye+ge;return ie.substring(ye)}e.$rd=$;function v(ie,fe){if(!ie||!fe)return ie;const ge=fe.length,ye=ie.length;if(ge===0||ye===0)return ie;let we=ye,Ee=-1;for(;Ee=ie.lastIndexOf(fe,we-1),!(Ee===-1||Ee+ge!==we);){if(Ee===0)return"";we=Ee}return ie.substring(0,we)}e.$sd=v;function c(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$td=c;function l(ie){return ie.replace(/\*/g,"")}e.$ud=l;function u(ie,fe,ge={}){if(!ie)throw new Error("Cannot create regex from empty string");fe||(ie=P(ie)),ge.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let ye="";return ge.global&&(ye+="g"),ge.matchCase||(ye+="i"),ge.multiline&&(ye+="m"),ge.unicode&&(ye+="u"),new RegExp(ie,ye)}e.$vd=u;function y(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$wd=y;function p(ie){return!!ie.match(/([^\\]|^)(\\\\)*\\\d+/)}e.$xd=p;function C(ie){return(ie.global?"g":"")+(ie.ignoreCase?"i":"")+(ie.multiline?"m":"")+(ie.unicode?"u":"")}e.$yd=C;function t(ie){return ie.split(/\r\n|\r|\n/)}e.$zd=t;function o(ie){for(let fe=0,ge=ie.length;fe<ge;fe++){const ye=ie.charCodeAt(fe);if(ye!==32&&ye!==9)return fe}return-1}e.$Ad=o;function n(ie,fe=0,ge=ie.length){for(let ye=fe;ye<ge;ye++){const we=ie.charCodeAt(ye);if(we!==32&&we!==9)return ie.substring(fe,ye)}return ie.substring(fe,ge)}e.$Bd=n;function s(ie,fe=ie.length-1){for(let ge=fe;ge>=0;ge--){const ye=ie.charCodeAt(ge);if(ye!==32&&ye!==9)return ge}return-1}e.$Cd=s;function i(ie,fe,ge){const ye=[];let we=0;for(const Ee of ie.matchAll(fe)){if(ye.push(ie.slice(we,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");we=Ee.index+Ee[0].length,ye.push(ge(Ee[0],...Ee.slice(1),Ee.index,ie,Ee.groups))}return ye.push(ie.slice(we)),Promise.all(ye).then(Ee=>Ee.join(""))}e.$Dd=i;function r(ie,fe){return ie<fe?-1:ie>fe?1:0}e.$Ed=r;function a(ie,fe,ge=0,ye=ie.length,we=0,Ee=fe.length){for(;ge<ye&&we<Ee;ge++,we++){const je=ie.charCodeAt(ge),Be=fe.charCodeAt(we);if(je<Be)return-1;if(je>Be)return 1}const Ce=ye-ge,Ie=Ee-we;return Ce<Ie?-1:Ce>Ie?1:0}e.$Fd=a;function w(ie,fe){return g(ie,fe,0,ie.length,0,fe.length)}e.$Gd=w;function g(ie,fe,ge=0,ye=ie.length,we=0,Ee=fe.length){for(;ge<ye&&we<Ee;ge++,we++){let je=ie.charCodeAt(ge),Be=fe.charCodeAt(we);if(je===Be)continue;if(je>=128||Be>=128)return a(ie.toLowerCase(),fe.toLowerCase(),ge,ye,we,Ee);k(je)&&(je-=32),k(Be)&&(Be-=32);const Te=je-Be;if(Te!==0)return Te}const Ce=ye-ge,Ie=Ee-we;return Ce<Ie?-1:Ce>Ie?1:0}e.$Hd=g;function f(ie){return ie>=48&&ie<=57}e.$Id=f;function k(ie){return ie>=97&&ie<=122}e.$Jd=k;function N(ie){return ie>=65&&ie<=90}e.$Kd=N;function M(ie,fe){return ie.length===fe.length&&g(ie,fe)===0}e.$Ld=M;function F(ie,fe){const ge=fe.length;return fe.length>ie.length?!1:g(ie,fe,0,ge)===0}e.$Md=F;function W(ie,fe){const ge=Math.min(ie.length,fe.length);let ye;for(ye=0;ye<ge;ye++)if(ie.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return ge}e.$Nd=W;function q(ie,fe){const ge=Math.min(ie.length,fe.length);let ye;const we=ie.length-1,Ee=fe.length-1;for(ye=0;ye<ge;ye++)if(ie.charCodeAt(we-ye)!==fe.charCodeAt(Ee-ye))return ye;return ge}e.$Od=q;function J(ie){return 55296<=ie&&ie<=56319}e.$Pd=J;function Q(ie){return 56320<=ie&&ie<=57343}e.$Qd=Q;function Y(ie,fe){return(ie-55296<<10)+(fe-56320)+65536}e.$Rd=Y;function Z(ie,fe,ge){const ye=ie.charCodeAt(ge);if(J(ye)&&ge+1<fe){const we=ie.charCodeAt(ge+1);if(Q(we))return Y(ye,we)}return ye}e.$Sd=Z;function x(ie,fe){const ge=ie.charCodeAt(fe-1);if(Q(ge)&&fe>1){const ye=ie.charCodeAt(fe-2);if(J(ye))return Y(ye,ge)}return ge}class H{get offset(){return this.e}constructor(fe,ge=0){this.c=fe,this.d=fe.length,this.e=ge}setOffset(fe){this.e=fe}prevCodePoint(){const fe=x(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=Z(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$Td=H;class B{get offset(){return this.c.offset}constructor(fe,ge=0){this.c=new H(fe,ge)}nextGraphemeLength(){const fe=Se.getInstance(),ge=this.c,ye=ge.offset;let we=fe.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ee=ge.offset,Ce=fe.getGraphemeBreakType(ge.nextCodePoint());if(de(we,Ce)){ge.setOffset(Ee);break}we=Ce}return ge.offset-ye}prevGraphemeLength(){const fe=Se.getInstance(),ge=this.c,ye=ge.offset;let we=fe.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ee=ge.offset,Ce=fe.getGraphemeBreakType(ge.prevCodePoint());if(de(Ce,we)){ge.setOffset(Ee);break}we=Ce}return ye-ge.offset}eol(){return this.c.eol()}}e.$Ud=B;function V(ie,fe){return new B(ie,fe).nextGraphemeLength()}e.$Vd=V;function ee(ie,fe){return new B(ie,fe).prevGraphemeLength()}e.$Wd=ee;function ne(ie,fe){fe>0&&Q(ie.charCodeAt(fe))&&fe--;const ge=fe+V(ie,fe);return[ge-ee(ie,ge),ge]}e.$Xd=ne;function ce(ie){const fe=new B(ie);let ge=0;for(;!fe.eol();)ge++,fe.nextGraphemeLength();return ge}e.$Yd=ce;let re;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function d(ie){return re||(re=A()),re.test(ie)}e.$Zd=d;const O=/^[\t\n\r\x20-\x7E]*$/;function z(ie){return O.test(ie)}e.$1d=z,e.$2d=/[\u2028\u2029]/;function G(ie){return e.$2d.test(ie)}e.$3d=G;function U(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$4d=U;function X(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$5d=X;function _(ie,fe){if(ie.length<fe)return ie;const ge=/\b/g;let ye=0;for(;ge.test(ie)&&!(ie.length-ge.lastIndex<fe);)ye=ge.lastIndex,ge.lastIndex+=1;return ie.substring(ye).replace(/^\s/,"")}e.$6d=_;const se=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,he=/\x1b\].*?\x07/g;function ue(ie){return ie&&(ie=ie.replace(se,"").replace(he,"")),ie}e.$7d=ue,e.$8d=String.fromCharCode(65279);function me(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$9d=me;function pe(ie){return me(ie)?ie.substr(1):ie}e.$0d=pe;function ke(ie,fe){if(!ie||!fe||ie.length<fe.length)return!1;const ge=fe.length,ye=ie.toLowerCase();let we=0,Ee=-1;for(;we<ge;){const Ce=ye.indexOf(fe[we],Ee+1);if(Ce<0)return!1;Ee=Ce,we++}return!0}e.$$d=ke;function Re(ie,fe=!1){return ie?(fe&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$_d=Re;function Oe(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$ae=Oe;function ze(ie,fe=1){if(fe===0)return"";let ge=-1;do ge=ie.indexOf(`
`,ge+1),fe--;while(fe>0&&ge>=0);return ge===-1?ie:(ie[ge-1]==="\r"&&ge--,ie.substr(0,ge))}e.$be=ze;function Je(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$ce=Je;function le(ie){return Se.getInstance().getGraphemeBreakType(ie)}e.$de=le;function de(ie,fe){return ie===0?fe!==5&&fe!==7:ie===2&&fe===3?!1:ie===4||ie===2||ie===3||fe===4||fe===2||fe===3?!0:!(ie===8&&(fe===8||fe===9||fe===11||fe===12)||(ie===11||ie===9)&&(fe===9||fe===10)||(ie===12||ie===10)&&fe===10||fe===5||fe===13||fe===7||ie===1||ie===13&&fe===14||ie===6&&fe===6)}var $e;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class Se{static{this.c=null}static getInstance(){return Se.c||(Se.c=new Se),Se.c}constructor(){this.d=Pe()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const ge=this.d,ye=ge.length/3;let we=1;for(;we<=ye;)if(fe<ge[3*we])we=2*we;else if(fe>ge[3*we+1])we=2*we+1;else return ge[3*we+2];return 0}}function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(ie,fe){if(ie===0)return 0;const ge=Le(ie,fe);if(ge!==void 0)return ge;const ye=new H(fe,ie);return ye.prevCodePoint(),ye.offset}e.$ee=Me;function Le(ie,fe){const ge=new H(fe,ie);let ye=ge.prevCodePoint();for(;Ue(ye)||ye===65039||ye===8419;){if(ge.offset===0)return;ye=ge.prevCodePoint()}if(!X(ye))return;let we=ge.offset;return we>0&&ge.prevCodePoint()===8205&&(we=ge.offset),we}function Ue(ie){return 127995<=ie&&ie<=127999}var De;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={})),e.$fe="\xA0";class Ae{static{this.c=new T.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new I.$fd(fe=>{function ge(Te){const qe=new Map;for(let We=0;We<Te.length;We+=2)qe.set(Te[We],Te[We+1]);return qe}function ye(Te,qe){const We=new Map(Te);for(const[_e,nt]of qe)We.set(_e,nt);return We}function we(Te,qe){if(!Te)return qe;const We=new Map;for(const[_e,nt]of Te)qe.has(_e)&&We.set(_e,nt);return We}const Ee=this.c.value;let Ce=fe.filter(Te=>!Te.startsWith("_")&&Te in Ee);Ce.length===0&&(Ce=["_default"]);let Ie;for(const Te of Ce){const qe=ge(Ee[Te]);Ie=we(Ie,qe)}const je=ge(Ee._common),Be=ye(je,Ie);return new Ae(Be)})}static getInstance(fe){return Ae.d.get(Array.from(fe))}static{this.e=new T.$T(()=>Object.keys(Ae.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ae.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ge=Ae;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(fe){return Fe.e().has(fe)}static get codePoints(){return Fe.e()}}e.$he=Fe}),define(oe[51],ae([0,1,27]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=void 0;function T(l){return D(l,0)}e.$bi=T;function D(l,u){switch(typeof l){case"object":return l===null?j(349,u):Array.isArray(l)?S(l,u):b(l,u);case"string":return R(l,u);case"boolean":return L(l,u);case"number":return j(l,u);case"undefined":return j(937,u);default:return j(617,u)}}e.$ci=D;function j(l,u){return(u<<5)-u+l|0}e.$di=j;function L(l,u){return j(l?433:863,u)}function R(l,u){u=j(149417,u);for(let y=0,p=l.length;y<p;y++)u=j(l.charCodeAt(y),u);return u}e.$ei=R;function S(l,u){return u=j(104579,u),l.reduce((y,p)=>D(p,y),u)}function b(l,u){return u=j(181387,u),Object.keys(l).sort().reduce((y,p)=>(y=R(p,y),D(l[p],y)),u)}class P{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=D(u,this.g),this.g}}e.$fi=P;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(l,u,y=32){const p=y-u,C=~((1<<p)-1);return(l<<u|(C&l)>>>p)>>>0}function h(l,u=0,y=l.byteLength,p=0){for(let C=0;C<y;C++)l[u+C]=p}function $(l,u,y="0"){for(;l.length<u;)l=y+l;return l}function v(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(y=>y.toString(16).padStart(2,"0")).join(""):$((l>>>0).toString(16),u/4)}e.$gi=v;class c{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const y=u.length;if(y===0)return;const p=this.p;let C=this.r,t=this.u,o,n;for(t!==0?(o=t,n=-1,t=0):(o=u.charCodeAt(0),n=0);;){let s=o;if(I.$Pd(o))if(n+1<y){const i=u.charCodeAt(n+1);I.$Qd(i)?(n++,s=I.$Rd(o,i)):s=65533}else{t=o;break}else I.$Qd(o)&&(s=65533);if(C=this.w(p,C,s),n++,n<y)o=u.charCodeAt(n);else break}this.r=C,this.u=t}w(u,y,p){return p<128?u[y++]=p:p<2048?(u[y++]=192|(p&1984)>>>6,u[y++]=128|(p&63)>>>0):p<65536?(u[y++]=224|(p&61440)>>>12,u[y++]=128|(p&4032)>>>6,u[y++]=128|(p&63)>>>0):(u[y++]=240|(p&1835008)>>>18,u[y++]=128|(p&258048)>>>12,u[y++]=128|(p&4032)>>>6,u[y++]=128|(p&63)>>>0),y>=64&&(this.y(),y-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),y}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=c.g,y=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,y.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,m(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let p=this.h,C=this.l,t=this.m,o=this.n,n=this.o,s,i,r;for(let a=0;a<80;a++)a<20?(s=C&t|~C&o,i=1518500249):a<40?(s=C^t^o,i=1859775393):a<60?(s=C&t|C&o|t&o,i=2400959708):(s=C^t^o,i=3395469782),r=m(p,5)+s+n+i+u.getUint32(a*4,!1)&4294967295,n=o,o=t,t=m(C,30),C=p,p=r;this.h=this.h+p&4294967295,this.l=this.l+C&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$hi=c}),define(oe[88],ae([0,1,27]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(T||(T={})),function(D){const j="error",L="warning",R="warn",S="info",b="ignore";function P(m){return m?I.$Ld(j,m)?D.Error:I.$Ld(L,m)||I.$Ld(R,m)?D.Warning:I.$Ld(S,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=P;function E(m){switch(m){case D.Error:return j;case D.Warning:return L;case D.Info:return S;default:return b}}D.toString=E}(T||(T={})),e.default=T}),define(oe[126],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0,e.$4c=Symbol("MicrotaskDelay")}),define(oe[47],ae([0,1,21,27]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0;class D{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const $=h.charCodeAt(0),v=this.b.charCodeAt(this.c);return $-v}value(){return this.b[this.c]}}e.$ph=D;class j{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,T.$Fd)(h,this.b,0,h.length,this.c,this.d):(0,T.$Hd)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$qh=j;class L{constructor(h=!0,$=!0){this.f=h,this.g=$}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let $=h.length-1;$>=0;$--,this.c--){const v=this.b.charCodeAt($);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,T.$Fd)(h,this.b,0,h.length,this.d,this.e):(0,T.$Hd)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$rh=L;var R;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(R||(R={}));class S{constructor(h,$){this.f=h,this.g=$,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,T.$Gd)(h,this.c.scheme);if(this.d[this.e]===2)return(0,T.$Gd)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,T.$Ed)(h,this.c.query);if(this.d[this.e]===5)return(0,T.$Ed)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$sh=S;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(P||(P={}));class E{static forUris(h=()=>!1,$=()=>!1){return new E(new S(h,$))}static forPaths(h=!1){return new E(new L(void 0,!h))}static forStrings(){return new E(new D)}static forConfigKeys(){return new E(new j)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,$){if($){const v=$.slice(0);(0,I.$Df)(v);for(const c of v)this.set(c,h)}else{const v=h.slice(0);(0,I.$Df)(v);for(const c of v)this.set(c[0],c[1])}}set(h,$){const v=this.b.reset(h);let c;this.c||(this.c=new b,this.c.segment=v.value());const l=[];for(c=this.c;;){const y=v.cmp(c.segment);if(y>0)c.left||(c.left=new b,c.left.segment=v.value()),l.push([-1,c]),c=c.left;else if(y<0)c.right||(c.right=new b,c.right.segment=v.value()),l.push([1,c]),c=c.right;else if(v.hasNext())v.next(),c.mid||(c.mid=new b,c.mid.segment=v.value()),l.push([0,c]),c=c.mid;else break}const u=c.value;c.value=$,c.key=h;for(let y=l.length-1;y>=0;y--){const p=l[y][1];p.updateHeight();const C=p.balanceFactor();if(C<-1||C>1){const t=l[y][0],o=l[y+1][0];if(t===1&&o===1)l[y][1]=p.rotateLeft();else if(t===-1&&o===-1)l[y][1]=p.rotateRight();else if(t===1&&o===-1)p.right=l[y+1][1]=l[y+1][1].rotateRight(),l[y][1]=p.rotateLeft();else if(t===-1&&o===1)p.left=l[y+1][1]=l[y+1][1].rotateLeft(),l[y][1]=p.rotateRight();else throw new Error;if(y>0)switch(l[y-1][0]){case-1:l[y-1][1].left=l[y][1];break;case 1:l[y-1][1].right=l[y][1];break;case 0:l[y-1][1].mid=l[y][1];break}else this.c=l[0][1]}}return u}get(h){return this.d(h)?.value}d(h){const $=this.b.reset(h);let v=this.c;for(;v;){const c=$.cmp(v.segment);if(c>0)v=v.left;else if(c<0)v=v.right;else if($.hasNext())$.next(),v=v.mid;else break}return v}has(h){const $=this.d(h);return!($?.value===void 0&&$?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,$){const v=this.b.reset(h),c=[];let l=this.c;for(;l;){const u=v.cmp(l.segment);if(u>0)c.push([-1,l]),l=l.left;else if(u<0)c.push([1,l]),l=l.right;else if(v.hasNext())v.next(),c.push([0,l]),l=l.mid;else break}if(l){if($?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const u=this.f(l.right);if(u.key){const{key:y,value:p,segment:C}=u;this.e(u.key,!1),l.key=y,l.value=p,l.segment=C}}else{const u=l.left??l.right;if(c.length>0){const[y,p]=c[c.length-1];switch(y){case-1:p.left=u;break;case 0:p.mid=u;break;case 1:p.right=u;break}}else this.c=u}for(let u=c.length-1;u>=0;u--){const y=c[u][1];y.updateHeight();const p=y.balanceFactor();if(p>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),c[u][1]=y.rotateLeft()):p<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),c[u][1]=y.rotateRight()),u>0)switch(c[u-1][0]){case-1:c[u-1][1].left=c[u][1];break;case 1:c[u-1][1].right=c[u][1];break;case 0:c[u-1][1].mid=c[u][1];break}else this.c=c[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const $=this.b.reset(h);let v=this.c,c;for(;v;){const l=$.cmp(v.segment);if(l>0)v=v.left;else if(l<0)v=v.right;else if($.hasNext())$.next(),c=v.value||c,v=v.mid;else break}return v&&v.value||c}findSuperstr(h){return this.g(h,!1)}g(h,$){const v=this.b.reset(h);let c=this.c;for(;c;){const l=v.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(v.hasNext())v.next(),c=c.mid;else return c.mid?this.h(c.mid):$?c.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[$,v]of this)h(v,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const $=[];return this.j(h,$),$[Symbol.iterator]()}j(h,$){h&&(h.left&&this.j(h.left,$),h.value&&$.push([h.key,h.value]),h.mid&&this.j(h.mid,$),h.right&&this.j(h.right,$))}_isBalanced(){const h=$=>{if(!$)return!0;const v=$.balanceFactor();return v<-1||v>1?!1:h($.left)&&h($.right)};return h(this.c)}}e.$th=E}),define(oe[11],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;function I(o){return typeof o=="string"}e.$ie=I;function T(o){return Array.isArray(o)&&o.every(n=>I(n))}e.$je=T;function D(o){return typeof o=="object"&&o!==null&&!Array.isArray(o)&&!(o instanceof RegExp)&&!(o instanceof Date)}e.$ke=D;function j(o){const n=Object.getPrototypeOf(Uint8Array);return typeof o=="object"&&o instanceof n}e.$le=j;function L(o){return typeof o=="number"&&!isNaN(o)}e.$me=L;function R(o){return!!o&&typeof o[Symbol.iterator]=="function"}e.$ne=R;function S(o){return o===!0||o===!1}e.$oe=S;function b(o){return typeof o>"u"}e.$pe=b;function P(o){return!E(o)}e.$qe=P;function E(o){return b(o)||o===null}e.$re=E;function m(o,n){if(!o)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.$se=m;function h(o){if(E(o))throw new Error("Assertion Failed: argument is undefined or null");return o}e.$te=h;function $(...o){const n=[];for(let s=0;s<o.length;s++){const i=o[s];if(E(i))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);n.push(i)}return n}e.$ue=$;const v=Object.prototype.hasOwnProperty;function c(o){if(!D(o))return!1;for(const n in o)if(v.call(o,n))return!1;return!0}e.$ve=c;function l(o){return typeof o=="function"}e.$we=l;function u(...o){return o.length>0&&o.every(l)}e.$xe=u;function y(o,n){const s=Math.min(o.length,n.length);for(let i=0;i<s;i++)p(o[i],n[i])}e.$ye=y;function p(o,n){if(I(n)){if(typeof o!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(l(n)){try{if(o instanceof n)return}catch{}if(!E(o)&&o.constructor===n||n.length===1&&n.call(void 0,o)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$ze=p;function C(o){return o===null?void 0:o}e.$Ae=C;function t(o){return typeof o>"u"?null:o}e.$Be=t}),define(oe[30],ae([0,1,11]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0;function T(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([y,p])=>{u[y]=p&&typeof p=="object"?T(p):p}),u}e.$Fm=T;function D(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const y=u.shift();Object.freeze(y);for(const p in y)if(j.call(y,p)){const C=y[p];typeof C=="object"&&!Object.isFrozen(C)&&!(0,I.$le)(C)&&u.push(C)}}return l}e.$Gm=D;const j=Object.prototype.hasOwnProperty;function L(l,u){return R(l,u,new Set)}e.$Hm=L;function R(l,u,y){if((0,I.$re)(l))return l;const p=u(l);if(typeof p<"u")return p;if(Array.isArray(l)){const C=[];for(const t of l)C.push(R(t,u,y));return C}if((0,I.$ke)(l)){if(y.has(l))throw new Error("Cannot clone recursive data-structure");y.add(l);const C={};for(const t in l)j.call(l,t)&&(C[t]=R(l[t],u,y));return y.delete(l),C}return l}function S(l,u,y=!0){return(0,I.$ke)(l)?((0,I.$ke)(u)&&Object.keys(u).forEach(p=>{p in l?y&&((0,I.$ke)(l[p])&&(0,I.$ke)(u[p])?S(l[p],u[p],y):l[p]=u[p]):l[p]=u[p]}),l):u}e.$Im=S;function b(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let y,p;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(y=0;y<l.length;y++)if(!b(l[y],u[y]))return!1}else{const C=[];for(p in l)C.push(p);C.sort();const t=[];for(p in u)t.push(p);if(t.sort(),!b(C,t))return!1;for(y=0;y<C.length;y++)if(!b(l[C[y]],u[C[y]]))return!1}return!0}e.$Jm=b;function P(l){const u=new Set;return JSON.stringify(l,(y,p)=>{if((0,I.$ke)(p)||Array.isArray(p)){if(u.has(p))return"[Circular]";u.add(p)}return p})}e.$Km=P;function E(l,u){const y=Object.create(null);return!l||!u||Object.keys(u).forEach(C=>{const t=l[C],o=u[C];b(t,o)||(y[C]=o)}),y}e.$Lm=E;function m(l,u){const y=u.toLowerCase(),p=Object.keys(l).find(C=>C.toLowerCase()===y);return p?l[p]:l[u]}e.$Mm=m;function h(l,u){const y=Object.create(null);for(const[p,C]of Object.entries(l))u(p,C)&&(y[p]=C);return y}e.$Nm=h;function $(l){let u=[];for(;Object.prototype!==l;)u=u.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return u}e.$Om=$;function v(l){const u=[];for(const y of $(l))typeof l[y]=="function"&&u.push(y);return u}e.$Pm=v;function c(l,u){const y=C=>function(){const t=Array.prototype.slice.call(arguments,0);return u(C,t)},p={};for(const C of l)p[C]=y(C);return p}e.$Qm=c}),define(oe[32],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(D){return I.test(D)}e.$4e=T,e.$5e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(R){for(let S=0;S<R.length;S++)R[S]=Math.floor(Math.random()*256);return R};const j=new Uint8Array(16),L=[];for(let R=0;R<256;R++)L.push(R.toString(16).padStart(2,"0"));return function(){D(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let S=0,b="";return b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b+="-",b+=L[j[S++]],b+=L[j[S++]],b+="-",b+=L[j[S++]],b+=L[j[S++]],b+="-",b+=L[j[S++]],b+=L[j[S++]],b+="-",b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b+=L[j[S++]],b}}()}),define(oe[127],ae([0,1,36]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=void 0;const T=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(L){const R=L.replace(/\-/g,":").toLowerCase();return!T.has(R)}function j(){const L=(0,I.networkInterfaces)();for(const R in L){const S=L[R];if(S){for(const{mac:b}of S)if(D(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$qm=j}),define(oe[128],ae([0,1,36,47,32,127]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0,e.$rm=new class{c(b){return this.a||(this.a=T.$th.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,P=0;const E=(0,I.networkInterfaces)();for(const m in E){const h=E[m];if(h)for(const{mac:$,internal:v}of h)v||(P+=1,this.c($.toUpperCase())&&(b+=1))}this.b=P>0?b/P:0}return this.b}};let L;async function R(b){return L||(L=(async()=>await S(b)||D.$5e())()),L}e.$sm=R;async function S(b){try{const P=await new Promise((m,h)=>{te(["crypto"],m,h)}),E=(0,j.$qm)();return P.createHash("sha256").update(E,"utf8").digest("hex")}catch(P){b(P);return}}}),define(oe[129],ae([0,1,263,14]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fS=void 0;class D extends I.Transform{constructor(L){if(super(),typeof L=="number")this.b=L,this.c=1;else{const R=Buffer.isBuffer(L)?L:Buffer.from(L);this.b=R.length===1?R[0]:R,this.c=R.length}}_transform(L,R,S){this.a?this.a=Buffer.concat([this.a,L]):this.a=L;let b=0;for(;b<this.a.length;){const P=typeof this.b=="number"?this.a.indexOf(this.b,b):(0,T.$Kb)(this.a,this.b,b);if(P===-1)break;this.push(this.a.slice(b,P+this.c)),b=P+this.c}this.a=b===this.a.length?void 0:this.a.slice(b),S()}_flush(L){this.a&&this.push(this.a),L()}}e.$fS=D}),define(oe[130],ae([0,1,60]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9e=e.$8e=e.$7e=void 0;function T(R,S,b,P=1){let E=!1;return new Promise(m=>{const h=setTimeout(()=>{if(!E)return E=!0,m(0)},b);D(R,S,P,$=>{if(!E)return E=!0,clearTimeout(h),m($)})})}e.$7e=T;function D(R,S,b,P){if(S===0)return P(0);const E=new I.Socket;E.once("connect",()=>(L(E),D(R+b,S-1,b,P))),E.once("data",()=>{}),E.once("error",m=>(L(E),m.code!=="ECONNREFUSED"?D(R+b,S-1,b,P):P(R))),E.connect(R,"127.0.0.1")}e.$8e={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(R,S,b,P="127.0.0.1"){let E=!1,m,h=1;const $=I.createServer({pauseOnConnect:!0});function v(c,l){E||(E=!0,$.removeAllListeners(),$.close(),m&&clearTimeout(m),l(c))}return new Promise(c=>{m=setTimeout(()=>{v(0,c)},b),$.on("listening",()=>{v(R,c)}),$.on("error",l=>{l&&(l.code==="EADDRINUSE"||l.code==="EACCES")&&h<S?(R++,h++,$.listen(R,P)):v(0,c)}),$.on("close",()=>{v(0,c)}),$.listen(R,P)})}e.$9e=j;function L(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(S){console.error(S)}}}),define(oe[131],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vS=void 0;function I(T){return!!T.parentPort}e.$vS=I}),define(oe[132],ae([12,9]),function(te,e){return te.create("vs/base/common/date",e)}),define(oe[61],ae([0,1,132]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=void 0;const T=60,D=T*60,j=D*24,L=j*7,R=j*30,S=j*365;function b(E,m,h,$){typeof E!="number"&&(E=E.getTime());const v=Math.round((new Date().getTime()-E)/1e3);if(v<-30)return(0,I.localize)(0,null,b(new Date().getTime()+v*1e3,!1));if(!$&&v<30)return(0,I.localize)(1,null);let c;return v<T?(c=v,m?c===1?h?(0,I.localize)(2,null,c):(0,I.localize)(3,null,c):h?(0,I.localize)(4,null,c):(0,I.localize)(5,null,c):c===1?h?(0,I.localize)(6,null,c):(0,I.localize)(7,null,c):h?(0,I.localize)(8,null,c):(0,I.localize)(9,null,c)):v<D?(c=Math.floor(v/T),m?c===1?h?(0,I.localize)(10,null,c):(0,I.localize)(11,null,c):h?(0,I.localize)(12,null,c):(0,I.localize)(13,null,c):c===1?h?(0,I.localize)(14,null,c):(0,I.localize)(15,null,c):h?(0,I.localize)(16,null,c):(0,I.localize)(17,null,c)):v<j?(c=Math.floor(v/D),m?c===1?h?(0,I.localize)(18,null,c):(0,I.localize)(19,null,c):h?(0,I.localize)(20,null,c):(0,I.localize)(21,null,c):c===1?h?(0,I.localize)(22,null,c):(0,I.localize)(23,null,c):h?(0,I.localize)(24,null,c):(0,I.localize)(25,null,c)):v<L?(c=Math.floor(v/j),m?c===1?(0,I.localize)(26,null,c):(0,I.localize)(27,null,c):c===1?(0,I.localize)(28,null,c):(0,I.localize)(29,null,c)):v<R?(c=Math.floor(v/L),m?c===1?h?(0,I.localize)(30,null,c):(0,I.localize)(31,null,c):h?(0,I.localize)(32,null,c):(0,I.localize)(33,null,c):c===1?h?(0,I.localize)(34,null,c):(0,I.localize)(35,null,c):h?(0,I.localize)(36,null,c):(0,I.localize)(37,null,c)):v<S?(c=Math.floor(v/R),m?c===1?h?(0,I.localize)(38,null,c):(0,I.localize)(39,null,c):h?(0,I.localize)(40,null,c):(0,I.localize)(41,null,c):c===1?h?(0,I.localize)(42,null,c):(0,I.localize)(43,null,c):h?(0,I.localize)(44,null,c):(0,I.localize)(45,null,c)):(c=Math.floor(v/S),m?c===1?h?(0,I.localize)(46,null,c):(0,I.localize)(47,null,c):h?(0,I.localize)(48,null,c):(0,I.localize)(49,null,c):c===1?h?(0,I.localize)(50,null,c):(0,I.localize)(51,null,c):h?(0,I.localize)(52,null,c):(0,I.localize)(53,null,c))}e.$Pl=b;function P(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ql=P}),define(oe[133],ae([12,9]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,11,133]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=void 0;function j(E,m){return m&&(E.stack||E.stacktrace)?D.localize(0,null,R(E),L(E.stack)||L(E.stacktrace)):R(E)}function L(E){return Array.isArray(E)?E.join(`
`):E}function R(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?D.localize(1,null,E.message):E.message||D.localize(2,null)}function S(E=null,m=!1){if(!E)return D.localize(3,null);if(Array.isArray(E)){const h=I.$lf(E),$=S(h[0],m);return h.length>1?D.localize(4,null,$,h.length):$}if(T.$ie(E))return E;if(E.detail){const h=E.detail;if(h.error)return j(h.error,m);if(h.exception)return j(h.exception,m)}return E.stack?j(E,m):E.message?E.message:D.localize(5,null)}e.$$h=S;function b(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.$_h=b;function P(E,m){let h;return typeof E=="string"?h=new Error(E):h=E,h.actions=m,h}e.$ai=P}),define(oe[134],ae([12,9]),function(te,e){return te.create("vs/base/common/jsonErrorMessages",e)}),define(oe[135],ae([0,1,134]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=void 0;function T(D){switch(D){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}e.$_o=T}),define(oe[136],ae([12,9]),function(te,e){return te.create("vs/base/common/platform",e)}),define(oe[5],ae([0,1,136]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let T=!1,D=!1,j=!1,L=!1,R=!1,S=!1,b=!1,P=!1,E=!1,m=!1,h,$=e.$f,v=e.$f,c,l;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?u=e.$g.vscode.process:typeof process<"u"&&(u=process);const y=typeof u?.versions?.electron=="string",p=y&&u?.type==="renderer";if(typeof navigator=="object"&&!p)l=navigator.userAgent,T=l.indexOf("Windows")>=0,D=l.indexOf("Macintosh")>=0,P=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=l.indexOf("Linux")>=0,m=l?.indexOf("Mobi")>=0,S=!0,h=I.getConfiguredDefaultLocale(I.localize(0,null))||e.$f,$=h,v=navigator.language;else if(typeof u=="object"){T=u.platform==="win32",D=u.platform==="darwin",j=u.platform==="linux",L=j&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,b=y,E=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=e.$f,$=e.$f;const w=u.env.VSCODE_NLS_CONFIG;if(w)try{const g=JSON.parse(w),f=g.availableLanguages["*"];h=g.locale,v=g.osLocale,$=f||e.$f,c=g._translationsConfigFile}catch{}R=!0}else console.error("Unable to resolve platform.");var C;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(C||(e.Platform=C={}));function t(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=t;let o=0;D?o=1:T?o=3:j&&(o=2),e.$i=T,e.$j=D,e.$k=j,e.$l=L,e.$m=R,e.$n=b,e.$o=S,e.$p=S&&typeof e.$g.importScripts=="function",e.$q=P,e.$r=m,e.$s=E,e.$t=o,e.$u=l,e.$v=$;var n;(function(w){function g(){return e.$v}w.value=g;function f(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}w.isDefaultVariant=f;function k(){return e.$v==="en"}w.isDefault=k})(n||(e.Language=n={})),e.$w=h,e.$x=v,e.$y=c,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const w=[];e.$g.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let k=0,N=w.length;k<N;k++){const M=w[k];if(M.id===f.data.vscodeScheduleAsyncWork){w.splice(k,1),M.callback();return}}});let g=0;return f=>{const k=++g;w.push({id:k,callback:f}),e.$g.postMessage({vscodeScheduleAsyncWork:k},"*")}}return w=>setTimeout(w)})();var s;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(s||(e.OperatingSystem=s={})),e.OS=D||P?2:T?1:3;let i=!0,r=!1;function a(){if(!r){r=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,i=new Uint16Array(w.buffer)[0]===(2<<8)+1}return i}e.$C=a,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(oe[37],ae([0,1,5]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8b=e.$7b=e.env=e.cwd=void 0;let T;if(typeof I.$g.vscode<"u"&&typeof I.$g.vscode.process<"u"){const D=I.$g.vscode.process;T={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?T={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:T={get platform(){return I.$i?"win32":I.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.$7b=T.platform,e.$8b=T.arch}),define(oe[16],ae([0,1,37]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kc=e.sep=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=void 0;const T=65,D=97,j=90,L=122,R=46,S=47,b=92,P=58,E=63;class m extends Error{constructor(o,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${i} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function h(t,o){if(t===null||typeof t!="object")throw new m(o,"Object",t)}function $(t,o){if(typeof t!="string")throw new m(o,"string",t)}const v=I.$7b==="win32";function c(t){return t===S||t===b}function l(t){return t===S}function u(t){return t>=T&&t<=j||t>=D&&t<=L}function y(t,o,n,s){let i="",r=0,a=-1,w=0,g=0;for(let f=0;f<=t.length;++f){if(f<t.length)g=t.charCodeAt(f);else{if(s(g))break;g=S}if(s(g)){if(!(a===f-1||w===1))if(w===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==R||i.charCodeAt(i.length-2)!==R){if(i.length>2){const k=i.lastIndexOf(n);k===-1?(i="",r=0):(i=i.slice(0,k),r=i.length-1-i.lastIndexOf(n)),a=f,w=0;continue}else if(i.length!==0){i="",r=0,a=f,w=0;continue}}o&&(i+=i.length>0?`${n}..`:"..",r=2)}else i.length>0?i+=`${n}${t.slice(a+1,f)}`:i=t.slice(a+1,f),r=f-a-1;a=f,w=0}else g===R&&w!==-1?++w:w=-1}return i}function p(t,o){h(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${t}${s}`:s}e.$9b={resolve(...t){let o="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let r;if(i>=0){if(r=t[i],$(r,"path"),r.length===0)continue}else o.length===0?r=I.cwd():(r=I.env[`=${o}`]||I.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===b)&&(r=`${o}\\`));const a=r.length;let w=0,g="",f=!1;const k=r.charCodeAt(0);if(a===1)c(k)&&(w=1,f=!0);else if(c(k))if(f=!0,c(r.charCodeAt(1))){let N=2,M=N;for(;N<a&&!c(r.charCodeAt(N));)N++;if(N<a&&N!==M){const F=r.slice(M,N);for(M=N;N<a&&c(r.charCodeAt(N));)N++;if(N<a&&N!==M){for(M=N;N<a&&!c(r.charCodeAt(N));)N++;(N===a||N!==M)&&(g=`\\\\${F}\\${r.slice(M,N)}`,w=N)}}}else w=1;else u(k)&&r.charCodeAt(1)===P&&(g=r.slice(0,2),w=2,a>2&&c(r.charCodeAt(2))&&(f=!0,w=3));if(g.length>0)if(o.length>0){if(g.toLowerCase()!==o.toLowerCase())continue}else o=g;if(s){if(o.length>0)break}else if(n=`${r.slice(w)}\\${n}`,s=f,f&&o.length>0)break}return n=y(n,!s,"\\",c),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(t){$(t,"path");const o=t.length;if(o===0)return".";let n=0,s,i=!1;const r=t.charCodeAt(0);if(o===1)return l(r)?"\\":t;if(c(r))if(i=!0,c(t.charCodeAt(1))){let w=2,g=w;for(;w<o&&!c(t.charCodeAt(w));)w++;if(w<o&&w!==g){const f=t.slice(g,w);for(g=w;w<o&&c(t.charCodeAt(w));)w++;if(w<o&&w!==g){for(g=w;w<o&&!c(t.charCodeAt(w));)w++;if(w===o)return`\\\\${f}\\${t.slice(g)}\\`;w!==g&&(s=`\\\\${f}\\${t.slice(g,w)}`,n=w)}}}else n=1;else u(r)&&t.charCodeAt(1)===P&&(s=t.slice(0,2),n=2,o>2&&c(t.charCodeAt(2))&&(i=!0,n=3));let a=n<o?y(t.slice(n),!i,"\\",c):"";return a.length===0&&!i&&(a="."),a.length>0&&c(t.charCodeAt(o-1))&&(a+="\\"),s===void 0?i?`\\${a}`:a:i?`${s}\\${a}`:`${s}${a}`},isAbsolute(t){$(t,"path");const o=t.length;if(o===0)return!1;const n=t.charCodeAt(0);return c(n)||o>2&&u(n)&&t.charCodeAt(1)===P&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,n;for(let r=0;r<t.length;++r){const a=t[r];$(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&c(n.charCodeAt(0))){++i;const r=n.length;r>1&&c(n.charCodeAt(1))&&(++i,r>2&&(c(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<o.length&&c(o.charCodeAt(i));)i++;i>=2&&(o=`\\${o.slice(i)}`)}return e.$9b.normalize(o)},relative(t,o){if($(t,"from"),$(o,"to"),t===o)return"";const n=e.$9b.resolve(t),s=e.$9b.resolve(o);if(n===s||(t=n.toLowerCase(),o=s.toLowerCase(),t===o))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===b;)i++;let r=t.length;for(;r-1>i&&t.charCodeAt(r-1)===b;)r--;const a=r-i;let w=0;for(;w<o.length&&o.charCodeAt(w)===b;)w++;let g=o.length;for(;g-1>w&&o.charCodeAt(g-1)===b;)g--;const f=g-w,k=a<f?a:f;let N=-1,M=0;for(;M<k;M++){const W=t.charCodeAt(i+M);if(W!==o.charCodeAt(w+M))break;W===b&&(N=M)}if(M!==k){if(N===-1)return s}else{if(f>k){if(o.charCodeAt(w+M)===b)return s.slice(w+M+1);if(M===2)return s.slice(w+M)}a>k&&(t.charCodeAt(i+M)===b?N=M:M===2&&(N=3)),N===-1&&(N=0)}let F="";for(M=i+N+1;M<=r;++M)(M===r||t.charCodeAt(M)===b)&&(F+=F.length===0?"..":"\\..");return w+=N,F.length>0?`${F}${s.slice(w,g)}`:(s.charCodeAt(w)===b&&++w,s.slice(w,g))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$9b.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===b){if(o.charCodeAt(1)===b){const n=o.charCodeAt(2);if(n!==E&&n!==R)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(u(o.charCodeAt(0))&&o.charCodeAt(1)===P&&o.charCodeAt(2)===b)return`\\\\?\\${o}`;return t},dirname(t){$(t,"path");const o=t.length;if(o===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(o===1)return c(i)?t:".";if(c(i)){if(n=s=1,c(t.charCodeAt(1))){let w=2,g=w;for(;w<o&&!c(t.charCodeAt(w));)w++;if(w<o&&w!==g){for(g=w;w<o&&c(t.charCodeAt(w));)w++;if(w<o&&w!==g){for(g=w;w<o&&!c(t.charCodeAt(w));)w++;if(w===o)return t;w!==g&&(n=s=w+1)}}}}else u(i)&&t.charCodeAt(1)===P&&(n=o>2&&c(t.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let w=o-1;w>=s;--w)if(c(t.charCodeAt(w))){if(!a){r=w;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return t.slice(0,r)},basename(t,o){o!==void 0&&$(o,"ext"),$(t,"path");let n=0,s=-1,i=!0,r;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===P&&(n=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let a=o.length-1,w=-1;for(r=t.length-1;r>=n;--r){const g=t.charCodeAt(r);if(c(g)){if(!i){n=r+1;break}}else w===-1&&(i=!1,w=r+1),a>=0&&(g===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=w))}return n===s?s=w:s===-1&&(s=t.length),t.slice(n,s)}for(r=t.length-1;r>=n;--r)if(c(t.charCodeAt(r))){if(!i){n=r+1;break}}else s===-1&&(i=!1,s=r+1);return s===-1?"":t.slice(n,s)},extname(t){$(t,"path");let o=0,n=-1,s=0,i=-1,r=!0,a=0;t.length>=2&&t.charCodeAt(1)===P&&u(t.charCodeAt(0))&&(o=s=2);for(let w=t.length-1;w>=o;--w){const g=t.charCodeAt(w);if(c(g)){if(!r){s=w+1;break}continue}i===-1&&(r=!1,i=w+1),g===R?n===-1?n=w:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||i===-1||a===0||a===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:p.bind(null,"\\"),parse(t){$(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return c(i)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(c(i)){if(s=1,c(t.charCodeAt(1))){let N=2,M=N;for(;N<n&&!c(t.charCodeAt(N));)N++;if(N<n&&N!==M){for(M=N;N<n&&c(t.charCodeAt(N));)N++;if(N<n&&N!==M){for(M=N;N<n&&!c(t.charCodeAt(N));)N++;N===n?s=N:N!==M&&(s=N+1)}}}}else if(u(i)&&t.charCodeAt(1)===P){if(n<=2)return o.root=o.dir=t,o;if(s=2,c(t.charCodeAt(2))){if(n===3)return o.root=o.dir=t,o;s=3}}s>0&&(o.root=t.slice(0,s));let r=-1,a=s,w=-1,g=!0,f=t.length-1,k=0;for(;f>=s;--f){if(i=t.charCodeAt(f),c(i)){if(!g){a=f+1;break}continue}w===-1&&(g=!1,w=f+1),i===R?r===-1?r=f:k!==1&&(k=1):r!==-1&&(k=-1)}return w!==-1&&(r===-1||k===0||k===1&&r===w-1&&r===a+1?o.base=o.name=t.slice(a,w):(o.name=t.slice(a,r),o.base=t.slice(a,w),o.ext=t.slice(r,w))),a>0&&a!==s?o.dir=t.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(v){const t=/\\/g;return()=>{const o=I.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>I.cwd()})();e.$0b={resolve(...t){let o="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:C();$(i,"path"),i.length!==0&&(o=`${i}/${o}`,n=i.charCodeAt(0)===S)}return o=y(o,!n,"/",l),n?`/${o}`:o.length>0?o:"."},normalize(t){if($(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S,n=t.charCodeAt(t.length-1)===S;return t=y(t,!o,"/",l),t.length===0?o?"/":n?"./":".":(n&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return $(t,"path"),t.length>0&&t.charCodeAt(0)===S},join(...t){if(t.length===0)return".";let o;for(let n=0;n<t.length;++n){const s=t[n];$(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$0b.normalize(o)},relative(t,o){if($(t,"from"),$(o,"to"),t===o||(t=e.$0b.resolve(t),o=e.$0b.resolve(o),t===o))return"";const n=1,s=t.length,i=s-n,r=1,a=o.length-r,w=i<a?i:a;let g=-1,f=0;for(;f<w;f++){const N=t.charCodeAt(n+f);if(N!==o.charCodeAt(r+f))break;N===S&&(g=f)}if(f===w)if(a>w){if(o.charCodeAt(r+f)===S)return o.slice(r+f+1);if(f===0)return o.slice(r+f)}else i>w&&(t.charCodeAt(n+f)===S?g=f:f===0&&(g=0));let k="";for(f=n+g+1;f<=s;++f)(f===s||t.charCodeAt(f)===S)&&(k+=k.length===0?"..":"/..");return`${k}${o.slice(r+g)}`},toNamespacedPath(t){return t},dirname(t){if($(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===S;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===S){if(!s){n=i;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":t.slice(0,n)},basename(t,o){o!==void 0&&$(o,"ext"),$(t,"path");let n=0,s=-1,i=!0,r;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let a=o.length-1,w=-1;for(r=t.length-1;r>=0;--r){const g=t.charCodeAt(r);if(g===S){if(!i){n=r+1;break}}else w===-1&&(i=!1,w=r+1),a>=0&&(g===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=w))}return n===s?s=w:s===-1&&(s=t.length),t.slice(n,s)}for(r=t.length-1;r>=0;--r)if(t.charCodeAt(r)===S){if(!i){n=r+1;break}}else s===-1&&(i=!1,s=r+1);return s===-1?"":t.slice(n,s)},extname(t){$(t,"path");let o=-1,n=0,s=-1,i=!0,r=0;for(let a=t.length-1;a>=0;--a){const w=t.charCodeAt(a);if(w===S){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),w===R?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":t.slice(o,s)},format:p.bind(null,"/"),parse(t){$(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const n=t.charCodeAt(0)===S;let s;n?(o.root="/",s=1):s=0;let i=-1,r=0,a=-1,w=!0,g=t.length-1,f=0;for(;g>=s;--g){const k=t.charCodeAt(g);if(k===S){if(!w){r=g+1;break}continue}a===-1&&(w=!1,a=g+1),k===R?i===-1?i=g:f!==1&&(f=1):i!==-1&&(f=-1)}if(a!==-1){const k=r===0&&n?1:r;i===-1||f===0||f===1&&i===a-1&&i===r+1?o.base=o.name=t.slice(k,a):(o.name=t.slice(k,i),o.base=t.slice(k,a),o.ext=t.slice(i,a))}return r>0?o.dir=t.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$0b.win32=e.$9b.win32=e.$9b,e.$0b.posix=e.$9b.posix=e.$0b,e.$$b=v?e.$9b.normalize:e.$0b.normalize,e.$_b=v?e.$9b.isAbsolute:e.$0b.isAbsolute,e.$ac=v?e.$9b.join:e.$0b.join,e.$bc=v?e.$9b.resolve:e.$0b.resolve,e.$cc=v?e.$9b.relative:e.$0b.relative,e.$dc=v?e.$9b.dirname:e.$0b.dirname,e.$ec=v?e.$9b.basename:e.$0b.basename,e.$fc=v?e.$9b.extname:e.$0b.extname,e.$gc=v?e.$9b.format:e.$0b.format,e.$hc=v?e.$9b.parse:e.$0b.parse,e.$ic=v?e.$9b.toNamespacedPath:e.$0b.toNamespacedPath,e.sep=v?e.$9b.sep:e.$0b.sep,e.$kc=v?e.$9b.delimiter:e.$0b.delimiter}),define(oe[48],ae([0,1,16,5,27,11]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function L(r){return r===47||r===92}e.$Ce=L;function R(r){return r.replace(/[\\/]/g,I.$0b.sep)}e.$De=R;function S(r){return r.indexOf("/")===-1&&(r=R(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$Ee=S;function b(r,a=I.$0b.sep){if(!r)return"";const w=r.length,g=r.charCodeAt(0);if(L(g)){if(L(r.charCodeAt(1))&&!L(r.charCodeAt(2))){let k=3;const N=k;for(;k<w&&!L(r.charCodeAt(k));k++);if(N!==k&&!L(r.charCodeAt(k+1))){for(k+=1;k<w;k++)if(L(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,a)}}return a}else if(l(g)&&r.charCodeAt(1)===58)return L(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<w;f++)if(L(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.$Fe=b;function P(r){if(!T.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let w=2;const g=w;for(;w<r.length&&(a=r.charCodeAt(w),a!==92);w++);return!(g===w||(a=r.charCodeAt(w+1),isNaN(a)||a===92))}e.$Ge=P;const E=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,a=T.$i){const w=a?E:m;return!(!r||r.length===0||/^\s+$/.test(r)||(w.lastIndex=0,w.test(r))||a&&h.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$He=$;function v(r,a,w){const g=r===a;return!w||g?g:!r||!a?!1:(0,D.$Ld)(r,a)}e.$Ie=v;function c(r,a,w,g=I.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(w){if(!(0,D.$Md)(r,a))return!1;if(a.length===r.length)return!0;let k=a.length;return a.charAt(a.length-1)===g&&k--,r.charAt(k)===g}return a.charAt(a.length-1)!==g&&(a+=g),r.indexOf(a)===0}e.$Je=c;function l(r){return r>=65&&r<=90||r>=97&&r<=122}e.$Ke=l;function u(r,a){return T.$i&&r.endsWith(":")&&(r+=I.sep),(0,I.$_b)(r)||(r=(0,I.$ac)(a,r)),r=(0,I.$$b)(r),T.$i?(r=(0,D.$sd)(r,I.sep),r.endsWith(":")&&(r+=I.sep)):(r=(0,D.$sd)(r,I.sep),r||(r=I.sep)),r}e.$Le=u;function y(r){const a=(0,I.$$b)(r);return T.$i?r.length>3?!1:p(a)&&(r.length===2||a.charCodeAt(2)===92):a===I.$0b.sep}e.$Me=y;function p(r,a=T.$i){return a?l(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$Ne=p;function C(r,a=T.$i){return p(r,a)?r[0]:void 0}e.$Oe=C;function t(r,a,w){return a.length>r.length?-1:r===a?0:(w&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$Pe=t;function o(r){const a=r.split(":");let w,g,f;for(const k of a){const N=Number(k);(0,j.$me)(N)?g===void 0?g=N:f===void 0&&(f=N):w=w?[w,k].join(":"):k}if(!w)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:w,line:g!==void 0?g:void 0,column:f!==void 0?f:g!==void 0?1:void 0}}e.$Qe=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function i(r,a,w=8){let g="";for(let k=0;k<w;k++){let N;k===0&&T.$i&&!a&&(w===3||w===4)?N=s:N=n,g+=N.charAt(Math.floor(Math.random()*N.length))}let f;return a?f=`${a}-${g}`:f=g,r?(0,I.$ac)(r,f):f}e.$Re=i}),define(oe[137],ae([0,1,16]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=e.$sr=void 0,e.$sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function j(P){const E=(0,I.$fc)(P),m=T[E.toLowerCase()];return m!==void 0?m:L(P)}e.$tr=j;function L(P){const E=(0,I.$fc)(P);return D[E.toLowerCase()]}e.$ur=L;function R(P){for(const E in D)if(D[E]===P)return E}e.$vr=R;const S=/^(.+)\/(.+?)(;.+)?$/;function b(P,E){const m=S.exec(P);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:E?void 0:P}e.$wr=b}),define(oe[89],ae([0,1,5]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.TerminateResponseCode=e.Source=void 0;var T;(function(R){R[R.stdout=0]="stdout",R[R.stderr=1]="stderr"})(T||(e.Source=T={}));var D;(function(R){R[R.Success=0]="Success",R[R.Unknown=1]="Unknown",R[R.AccessDenied=2]="AccessDenied",R[R.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function j(R,...S){const b=S.reduce((m,h)=>(m[h]=!0,m),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(R).filter(m=>!b[m]).forEach(m=>{for(let h=0;h<P.length;h++)if(m.search(P[h])!==-1){delete R[m];break}})}e.$dl=j;function L(R){R&&(delete R.DEBUG,I.$j&&delete R.DYLD_LIBRARY_PATH,I.$k&&delete R.LD_PRELOAD)}e.$el=L}),define(oe[10],ae([0,1,16,5]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ue=e.$Te=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,j=/^\//,L=/^\/\//;function R(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!j.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(s,i){return!s&&!i?"file":s}function b(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==E&&(i=E+i):i=E;break}return i}const P="",E="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,r,a,w,g,f=!1){typeof i=="object"?(this.scheme=i.scheme||P,this.authority=i.authority||P,this.path=i.path||P,this.query=i.query||P,this.fragment=i.fragment||P):(this.scheme=S(i,f),this.authority=r||P,this.path=b(this.scheme,a||P),this.query=w||P,this.fragment=g||P,R(this,f))}get fsPath(){return p(this,!1)}with(i){if(!i)return this;let{scheme:r,authority:a,path:w,query:g,fragment:f}=i;return r===void 0?r=this.scheme:r===null&&(r=P),a===void 0?a=this.authority:a===null&&(a=P),w===void 0?w=this.path:w===null&&(w=P),g===void 0?g=this.query:g===null&&(g=P),f===void 0?f=this.fragment:f===null&&(f=P),r===this.scheme&&a===this.authority&&w===this.path&&g===this.query&&f===this.fragment?this:new c(r,a,w,g,f)}static parse(i,r=!1){const a=m.exec(i);return a?new c(a[2]||P,n(a[4]||P),n(a[5]||P),n(a[7]||P),n(a[9]||P),r):new c(P,P,P,P,P)}static file(i){let r=P;if(T.$i&&(i=i.replace(/\\/g,E)),i[0]===E&&i[1]===E){const a=i.indexOf(E,2);a===-1?(r=i.substring(2),i=E):(r=i.substring(2,a),i=i.substring(a)||E)}return new c("file",r,i,P,P)}static from(i,r){return new c(i.scheme,i.authority,i.path,i.query,i.fragment,r)}static joinPath(i,...r){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return T.$i&&i.scheme==="file"?a=h.file(I.$9b.join(p(i,!0),...r)).path:a=I.$0b.join(i.path,...r),i.with({path:a})}toString(i=!1){return C(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const r=new c(i);return r._formatted=i.external??null,r._fsPath=i._sep===v?i.fsPath??null:null,r}}else return i}}e.URI=h;function $(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$Te=$;const v=T.$i?1:void 0;class c extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(i=!1){return i?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=v),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const l={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(s,i,r){let a,w=-1;for(let g=0;g<s.length;g++){const f=s.charCodeAt(g);if(f>=97&&f<=122||f>=65&&f<=90||f>=48&&f<=57||f===45||f===46||f===95||f===126||i&&f===47||r&&f===91||r&&f===93||r&&f===58)w!==-1&&(a+=encodeURIComponent(s.substring(w,g)),w=-1),a!==void 0&&(a+=s.charAt(g));else{a===void 0&&(a=s.substr(0,g));const k=l[f];k!==void 0?(w!==-1&&(a+=encodeURIComponent(s.substring(w,g)),w=-1),a+=k):w===-1&&(w=g)}}return w!==-1&&(a+=encodeURIComponent(s.substring(w))),a!==void 0?a:s}function y(s){let i;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(i===void 0&&(i=s.substr(0,r)),i+=l[a]):i!==void 0&&(i+=s[r])}return i!==void 0?i:s}function p(s,i){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,T.$i&&(r=r.replace(/\//g,"\\")),r}e.$Ue=p;function C(s,i){const r=i?y:u;let a="",{scheme:w,authority:g,path:f,query:k,fragment:N}=s;if(w&&(a+=w,a+=":"),(g||w==="file")&&(a+=E,a+=E),g){let M=g.indexOf("@");if(M!==-1){const F=g.substr(0,M);g=g.substr(M+1),M=F.lastIndexOf(":"),M===-1?a+=r(F,!1,!1):(a+=r(F.substr(0,M),!1,!1),a+=":",a+=r(F.substr(M+1),!1,!0)),a+="@"}g=g.toLowerCase(),M=g.lastIndexOf(":"),M===-1?a+=r(g,!1,!0):(a+=r(g.substr(0,M),!1,!0),a+=g.substr(M))}if(f){if(f.length>=3&&f.charCodeAt(0)===47&&f.charCodeAt(2)===58){const M=f.charCodeAt(1);M>=65&&M<=90&&(f=`/${String.fromCharCode(M+32)}:${f.substr(3)}`)}else if(f.length>=2&&f.charCodeAt(1)===58){const M=f.charCodeAt(0);M>=65&&M<=90&&(f=`${String.fromCharCode(M+32)}:${f.substr(2)}`)}a+=r(f,!0,!1)}return k&&(a+="?",a+=r(k,!1,!1)),N&&(a+="#",a+=i?N:u(N,!1,!1)),a}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,i=>t(i)):s}}),define(oe[138],ae([0,1,10]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Cp=e.$Bp=e.$Ap=void 0;function T(b){const P=b;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$Ap=T;function D(b){const P=[];let E;try{const m=JSON.parse(b.arguments),h=m[m.length-1];h&&h.__$stack&&(m.pop(),E=h.__$stack),P.push(...m)}catch{P.push("Unable to log remote console arguments",b.arguments)}return{args:P,stack:E}}e.$Bp=D;function j(b){if(typeof b!="string")return j(D(b).stack);const P=b;if(P){const E=L(P),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:I.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$Cp=j;function L(b){if(!b)return b;const P=b.indexOf(`
`);return P===-1?b:b.substring(0,P)}function R(b,P){const{args:E,stack:m}=D(b),h=typeof E[0]=="string"&&E.length===1;let $=L(m);$&&($=`(${$.trim()})`);let v=[];if(typeof E[0]=="string"?$&&h?v=[`%c[${P}] %c${E[0]} %c${$}`,S("blue"),S(""),S("grey")]:v=[`%c[${P}] %c${E[0]}`,S("blue"),S(""),...E.slice(1)]:v=[`%c[${P}]%`,S("blue"),...E],$&&!h&&v.push($),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,v)}e.log=R;function S(b){return`color: ${b}`}}),define(oe[62],ae([0,1,14,27,10]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=e.$Vg=e.$Ug=void 0;function j(b){return JSON.stringify(b,R)}e.$Ug=j;function L(b){let P=JSON.parse(b);return P=S(P),P}e.$Vg=L;function R(b,P){return P instanceof RegExp?{$mid:2,source:P.source,flags:(0,T.$yd)(P)}:P}function S(b,P=0){if(!b||P>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return D.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 16:return new Date(b.source)}if(b instanceof I.$Jb||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let E=0;E<b.length;++E)b[E]=S(b[E],P+1);else for(const E in b)Object.hasOwnProperty.call(b,E)&&(b[E]=S(b[E],P+1))}return b}e.$Wg=S}),define(oe[26],ae([0,1,7,5,10]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.Schemas=void 0;var j;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(j||(e.Schemas=j={})),e.$Ve="vscode-tkn",e.$We="tkn";class L{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${j.vscodeRemoteResource}`}setPreferredWebSchema(P){this.d=P}setDelegate(P){this.e=P}setServerRootPath(P){this.f=`${P}/${j.vscodeRemoteResource}`}set(P,E,m){this.a[P]=E,this.b[P]=m}setConnectionToken(P,E){this.c[P]=E}getPreferredWebSchema(){return this.d}rewrite(P){if(this.e)try{return this.e(P)}catch(c){return I.$Y(c),P}const E=P.authority;let m=this.a[E];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const h=this.b[E],$=this.c[E];let v=`path=${encodeURIComponent(P.path)}`;return typeof $=="string"&&(v+=`&${e.$We}=${encodeURIComponent($)}`),D.URI.from({scheme:T.$o?this.d:j.vscodeRemoteResource,authority:`${m}:${h}`,path:this.f,query:v})}}e.$Xe=new L,e.$Ye="vs/../../extensions",e.$Ze="vs/../../node_modules",e.$1e="vs/../../node_modules.asar",e.$2e="vs/../../node_modules.asar.unpacked";class R{static{this.a="vscode-app"}asBrowserUri(P){const E=this.b(P,te);return this.uriToBrowserUri(E)}uriToBrowserUri(P){return P.scheme===j.vscodeRemote?e.$Xe.rewrite(P):P.scheme===j.file&&(T.$m||T.$p&&T.$g.origin===`${j.vscodeFileResource}://${R.a}`)?P.with({scheme:j.vscodeFileResource,authority:P.authority||R.a,query:null,fragment:null}):P}asFileUri(P){const E=this.b(P,te);return this.uriToFileUri(E)}uriToFileUri(P){return P.scheme===j.vscodeFileResource?P.with({scheme:j.file,authority:P.authority!==R.a?P.authority:null,query:null,fragment:null}):P}b(P,E){return D.URI.isUri(P)?P:D.URI.parse(E.toUrl(P))}}e.$3e=new R;var S;(function(b){const P=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(P.get("3"));const E="vscode-coi";function m($){let v;typeof $=="string"?v=new URL($).searchParams:$ instanceof URL?v=$.searchParams:D.URI.isUri($)&&(v=new URL($.toString(!0)).searchParams);const c=v?.get(E);if(c)return P.get(c)}b.getHeadersFromQuery=m;function h($,v,c){if(!globalThis.crossOriginIsolated)return;const l=v&&c?"3":c?"2":"1";$ instanceof URLSearchParams?$.set(E,l):$[E]=l}b.addSearchParam=h})(S||(e.COI=S={}))}),define(oe[139],ae([0,1,122,26,5,10]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=void 0;class L{constructor(m,h,$){this.id=m,this.dependencies=h,this.callback=$}}class R{static{this.INSTANCE=new R}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,h,$)=>{typeof m!="string"&&($=h,h=m,m=null),(typeof h!="object"||!Array.isArray(h))&&($=h,h=null),this.c.push(new L(m,h,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const h=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!h)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(m){return new Promise((h,$)=>{const v=document.createElement("script");v.setAttribute("async","async"),v.setAttribute("type","text/javascript");const c=()=>{v.removeEventListener("load",l),v.removeEventListener("error",u)},l=y=>{c(),h(this.c.pop())},u=y=>{c(),$(y)};v.addEventListener("load",l),v.addEventListener("error",u),this.f&&(m=this.f.createScriptURL(m)),v.setAttribute("src",m),document.getElementsByTagName("head")[0].appendChild(v)})}i(m){return new Promise((h,$)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),h(this.c.pop())}catch(v){$(v)}})}async j(m){try{const h=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,v=globalThis._VSCODE_NODE_MODULES.module,c=j.URI.parse(m).fsPath,l=h.readFileSync(c).toString(),u=v.wrap(l.replace(/^#!.*/,""));return new $.Script(u).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const S=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function P(E,m,h){if(I.$R){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[E]&&(E=b[E]);const $=`${E}/${m}`;if(S.has($))return S.get($);let v;if(/^\w[\w\d+.-]*:\/\//.test($))v=$;else{const y=`${h&&!D.$o?T.$1e:T.$Ze}/${$}`;v=T.$3e.asBrowserUri(y).toString(!0)}const c=R.INSTANCE.load(v);return S.set($,c),c}else return await new Promise(($,v)=>{te([E],$,v)})}e.$UC=P}),define(oe[22],ae([0,1,48,26,16,5,27,10]),function(te,e,I,T,D,j,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.DataUri=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function S(h){return(0,R.$Ue)(h,!0)}e.$Vf=S;class b{constructor($){this.a=$}compare($,v,c=!1){return $===v?0:(0,L.$Ed)(this.getComparisonKey($,c),this.getComparisonKey(v,c))}isEqual($,v,c=!1){return $===v?!0:!$||!v?!1:this.getComparisonKey($,c)===this.getComparisonKey(v,c)}getComparisonKey($,v=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,v,c=!1){if($.scheme===v.scheme){if($.scheme===T.Schemas.file)return I.$Je(S($),S(v),this.a($))&&$.query===v.query&&(c||$.fragment===v.fragment);if((0,e.$ag)($.authority,v.authority))return I.$Je($.path,v.path,this.a($),"/")&&$.query===v.query&&(c||$.fragment===v.fragment)}return!1}joinPath($,...v){return R.URI.joinPath($,...v)}basenameOrAuthority($){return(0,e.$5f)($)||$.authority}basename($){return D.$0b.basename($.path)}extname($){return D.$0b.extname($.path)}dirname($){if($.path.length===0)return $;let v;return $.scheme===T.Schemas.file?v=R.URI.file(D.$dc(S($))).path:(v=D.$0b.dirname($.path),$.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),v="/")),$.with({path:v})}normalizePath($){if(!$.path.length)return $;let v;return $.scheme===T.Schemas.file?v=R.URI.file(D.$$b(S($))).path:v=D.$0b.normalize($.path),$.with({path:v})}relativePath($,v){if($.scheme!==v.scheme||!(0,e.$ag)($.authority,v.authority))return;if($.scheme===T.Schemas.file){const u=D.$cc(S($),S(v));return j.$i?I.$De(u):u}let c=$.path||"/";const l=v.path||"/";if(this.a($)){let u=0;for(const y=Math.min(c.length,l.length);u<y&&!(c.charCodeAt(u)!==l.charCodeAt(u)&&c.charAt(u).toLowerCase()!==l.charAt(u).toLowerCase());u++);c=l.substr(0,u)+c.substr(u)}return D.$0b.relative(c,l)}resolvePath($,v){if($.scheme===T.Schemas.file){const c=R.URI.file(D.$bc(S($),v));return $.with({authority:c.authority,path:c.path})}return v=I.$Ee(v),$.with({path:D.$0b.resolve($.path,v)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,v){return $===v||$!==void 0&&v!==void 0&&(0,L.$Ld)($,v)}hasTrailingPathSeparator($,v=D.sep){if($.scheme===T.Schemas.file){const c=S($);return c.length>I.$Fe(c).length&&c[c.length-1]===v}else{const c=$.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,v=D.sep){return(0,e.$bg)($,v)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,v=D.sep){let c=!1;if($.scheme===T.Schemas.file){const l=S($);c=l!==void 0&&l.length===I.$Fe(l).length&&l[l.length-1]===v}else{v="/";const l=$.path;c=l.length===1&&l.charCodeAt(l.length-1)===47}return!c&&!(0,e.$bg)($,v)?$.with({path:$.path+"/"}):$}}e.$Wf=b,e.$Xf=new b(()=>!1),e.$Yf=new b(h=>h.scheme===T.Schemas.file?!j.$k:!0),e.$Zf=new b(h=>!0),e.$1f=e.$Xf.isEqual.bind(e.$Xf),e.$2f=e.$Xf.isEqualOrParent.bind(e.$Xf),e.$3f=e.$Xf.getComparisonKey.bind(e.$Xf),e.$4f=e.$Xf.basenameOrAuthority.bind(e.$Xf),e.$5f=e.$Xf.basename.bind(e.$Xf),e.$6f=e.$Xf.extname.bind(e.$Xf),e.$7f=e.$Xf.dirname.bind(e.$Xf),e.$8f=e.$Xf.joinPath.bind(e.$Xf),e.$9f=e.$Xf.normalizePath.bind(e.$Xf),e.$0f=e.$Xf.relativePath.bind(e.$Xf),e.$$f=e.$Xf.resolvePath.bind(e.$Xf),e.$_f=e.$Xf.isAbsolutePath.bind(e.$Xf),e.$ag=e.$Xf.isEqualAuthority.bind(e.$Xf),e.$bg=e.$Xf.hasTrailingPathSeparator.bind(e.$Xf),e.$cg=e.$Xf.removeTrailingPathSeparator.bind(e.$Xf),e.$dg=e.$Xf.addTrailingPathSeparator.bind(e.$Xf);function P(h,$){const v=[];for(let c=0;c<h.length;c++){const l=$(h[c]);h.some((u,y)=>y===c?!1:(0,e.$2f)(l,$(u)))||v.push(h[c])}return v}e.$eg=P;var E;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function $(v){const c=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(y=>{const[p,C]=y.split(":");p&&C&&c.set(p,C)});const u=v.path.substring(0,v.path.indexOf(";"));return u&&c.set(h.META_DATA_MIME,u),c}h.parseMetaData=$})(E||(e.DataUri=E={}));function m(h,$,v){if($){let c=h.path;return c&&c[0]!==D.$0b.sep&&(c=D.$0b.sep+c),h.with({scheme:v,authority:$,path:c})}return h.with({scheme:v})}e.$fg=m}),define(oe[6],ae([0,1,25,7,3,2,22,5,126]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.$Pg=e.$Og=e.Promises=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function b(A){return!!A&&typeof A.then=="function"}e.$gg=b;function P(A){const d=new I.$dd,O=A(d.token),z=new Promise((G,U)=>{const X=d.token.onCancellationRequested(()=>{X.dispose(),d.dispose(),U(new T.$3)});Promise.resolve(O).then(_=>{X.dispose(),d.dispose(),G(_)},_=>{X.dispose(),d.dispose(),U(_)})});return new class{cancel(){d.cancel()}then(G,U){return z.then(G,U)}catch(G){return this.then(void 0,G)}finally(G){return z.finally(G)}}}e.$hg=P;function E(A,d,O){return new Promise((z,G)=>{const U=d.onCancellationRequested(()=>{U.dispose(),z(O)});A.then(z,G).finally(()=>U.dispose())})}e.$ig=E;function m(A,d){return new Promise((O,z)=>{const G=d.onCancellationRequested(()=>{G.dispose(),z(new T.$3)});A.then(O,z).finally(()=>G.dispose())})}e.$jg=m;async function h(A){let d=-1;const O=A.map((z,G)=>z.then(U=>(d=G,U)));try{return await Promise.race(O)}finally{A.forEach((z,G)=>{G!==d&&z.cancel()})}}e.$kg=h;function $(A,d,O){let z;const G=setTimeout(()=>{z?.(void 0),O?.()},d);return Promise.race([A.finally(()=>clearTimeout(G)),new Promise(U=>z=U)])}e.$lg=$;function v(A){return new Promise((d,O)=>{const z=A();b(z)?z.then(d,O):d(z)})}e.$mg=v;class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(d){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=d,!this.b){const O=()=>{if(this.b=null,this.f)return;const z=this.queue(this.d);return this.d=null,z};this.b=new Promise(z=>{this.a.then(O,O).then(z)})}return new Promise((O,z)=>{this.b.then(O,z)})}return this.a=d(),new Promise((O,z)=>{this.a.then(G=>{this.a=null,O(G)},G=>{this.a=null,z(G)})})}dispose(){this.f=!0}}e.$ng=c;class l{constructor(){this.a=Promise.resolve(null)}queue(d){return this.a=this.a.then(()=>d(),()=>d())}}e.$og=l;class u{constructor(){this.a=new Map}queue(d,O){const G=(this.a.get(d)??Promise.resolve()).catch(()=>{}).then(O).finally(()=>{this.a.get(d)===G&&this.a.delete(d)});return this.a.set(d,G),G}}e.$pg=u;const y=(A,d)=>{let O=!0;const z=setTimeout(()=>{O=!1,d()},A);return{isTriggered:()=>O,dispose:()=>{clearTimeout(z),O=!1}}},p=A=>{let d=!0;return queueMicrotask(()=>{d&&(d=!1,A())}),{isTriggered:()=>d,dispose:()=>{d=!1}}};class C{constructor(d){this.defaultDelay=d,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(d,O=this.defaultDelay){this.g=d,this.h(),this.b||(this.b=new Promise((G,U)=>{this.d=G,this.f=U}).then(()=>{if(this.b=null,this.d=null,this.g){const G=this.g;return this.g=null,G()}}));const z=()=>{this.a=null,this.d?.(null)};return this.a=O===S.$4c?p(z):y(O,z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$qg=C;class t{constructor(d){this.a=new C(d),this.b=new c}trigger(d,O){return this.a.trigger(()=>this.b.queue(d),O)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$rg=t;class o{constructor(){this.a=!1,this.b=new Promise((d,O)=>{this.d=d})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$sg=o;class n extends o{constructor(d){super(),this.f=setTimeout(()=>this.open(),d)}open(){clearTimeout(this.f),super.open()}}e.$tg=n;function s(A,d){return d?new Promise((O,z)=>{const G=setTimeout(()=>{U.dispose(),O()},A),U=d.onCancellationRequested(()=>{clearTimeout(G),U.dispose(),z(new T.$3)})}):P(O=>s(A,O))}e.$ug=s;function i(A,d=0){const O=setTimeout(A,d);return(0,j.$jb)(()=>clearTimeout(O))}e.$vg=i;function r(A){const d=[];let O=0;const z=A.length;function G(){return O<z?A[O++]():null}function U(X){X!=null&&d.push(X);const _=G();return _?_.then(U):Promise.resolve(d)}return Promise.resolve(null).then(U)}e.$wg=r;function a(A,d=z=>!!z,O=null){let z=0;const G=A.length,U=()=>{if(z>=G)return Promise.resolve(O);const X=A[z++];return Promise.resolve(X()).then(se=>d(se)?Promise.resolve(se):U())};return U()}e.$xg=a;function w(A,d=z=>!!z,O=null){if(A.length===0)return Promise.resolve(O);let z=A.length;const G=()=>{z=-1;for(const U of A)U.cancel?.()};return new Promise((U,X)=>{for(const _ of A)_.then(se=>{--z>=0&&d(se)?(G(),U(se)):z===0&&U(O)}).catch(se=>{--z>=0&&(G(),X(se))})})}e.$yg=w;class g{constructor(d){this.a=0,this.d=d,this.f=[],this.b=0,this.g=new D.$7c}get onDrained(){return this.g.event}get size(){return this.a}queue(d){return this.a++,new Promise((O,z)=>{this.f.push({factory:d,c:O,e:z}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const d=this.f.shift();this.b++;const O=d.factory();O.then(d.c,d.e),O.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$zg=g;class f extends g{constructor(){super(1)}}e.$Ag=f;class k{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const d=new B;return this.b.add(d),d.p}d(){for(const[,d]of this.a)if(d.size>0)return!1;return!0}queueFor(d,O=L.$Xf){const z=O.getComparisonKey(d);let G=this.a.get(z);return G||(G=new f,D.Event.once(G.onDrained)(()=>{G?.dispose(),this.a.delete(z),this.f()}),this.a.set(z,G)),G}f(){this.d()&&this.g()}g(){for(const d of this.b)d.complete();this.b.clear()}dispose(){for(const[,d]of this.a)d.dispose();this.a.clear(),this.g()}}e.$Bg=k;class N{constructor(d,O){this.a=-1,typeof d=="function"&&typeof O=="number"&&this.setIfNotSet(d,O)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(d,O){this.cancel(),this.a=setTimeout(()=>{this.a=-1,d()},O)}setIfNotSet(d,O){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,d()},O))}}e.$Cg=N;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(d,O){this.cancel(),this.a=setInterval(()=>{d()},O)}}e.$Dg=M;class F{constructor(d,O){this.b=-1,this.a=d,this.d=O,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(d=this.d){this.cancel(),this.b=setTimeout(this.f,d)}get delay(){return this.d}set delay(d){this.d=d}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Eg=F;class W{constructor(d,O){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.a=d,this.b=O,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(d=this.b){d%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${d}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(d/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Fg=W;class q extends F{constructor(d,O){super(d,O),this.j=[]}work(d){this.j.push(d),this.isScheduled()||this.schedule()}h(){const d=this.j;this.j=[],this.a?.(d)}dispose(){this.j=[],super.dispose()}}e.$Gg=q;class J extends j.$lb{constructor(d,O){super(),this.g=d,this.h=O,this.a=[],this.b=this.B(new j.$mb),this.f=!1}get pending(){return this.a.length}work(d){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+d.length>this.g.maxBufferedWork)return!1}else if(this.pending+d.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const O of d)this.a.push(O);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Hg=J,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ig=A=>{(0,R.$A)(()=>{if(d)return;const O=Date.now()+15;A(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,O-Date.now())}}))});let d=!1;return{dispose(){d||(d=!0)}}}:e.$Ig=(A,d)=>{const O=requestIdleCallback(A,typeof d=="number"?{timeout:d}:void 0);let z=!1;return{dispose(){z||(z=!0,cancelIdleCallback(O))}}}}();class Q{constructor(d){this.d=!1,this.a=()=>{try{this.f=d()}catch(O){this.g=O}finally{this.d=!0}},this.b=(0,e.$Ig)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Jg=Q;async function Y(A,d,O){let z;for(let G=0;G<O;G++)try{return await A()}catch(U){z=U,await s(d)}throw z}e.$Kg=Y;class Z{hasPending(d){return this.a?typeof d=="number"?this.a.taskId===d:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(d,O,z){return this.a={taskId:d,cancel:()=>z?.(),promise:O},O.then(()=>this.d(d),()=>this.d(d)),O}d(d){this.a&&d===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const d=this.b;this.b=void 0,d.run().then(d.promiseResolve,d.promiseReject)}}setNext(d){if(this.b)this.b.run=d;else{let O,z;const G=new Promise((U,X)=>{O=U,z=X});this.b={run:d,promise:G,promiseResolve:O,promiseReject:z}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lg=Z;class x{constructor(d,O=()=>Date.now()){this.d=d,this.f=O,this.a=0,this.b=0}increment(){const d=this.f();return d-this.a>this.d&&(this.a=d,this.b=0),this.b++,this.b}}e.$Mg=x;var H;(function(A){A[A.Resolved=0]="Resolved",A[A.Rejected=1]="Rejected"})(H||(H={}));class B{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((d,O)=>{this.a=d,this.b=O})}complete(d){return new Promise(O=>{this.a(d),this.d={outcome:0,value:d},O()})}error(d){return new Promise(O=>{this.b(d),this.d={outcome:1,value:d},O()})}cancel(){return this.error(new T.$3)}}e.$Ng=B;var V;(function(A){async function d(z){let G;const U=await Promise.all(z.map(X=>X.then(_=>_,_=>{G||(G=_)})));if(typeof G<"u")throw G;return U}A.settled=d;function O(z){return new Promise(async(G,U)=>{try{await z(G,U)}catch(X){U(X)}})}A.withAsyncBody=O})(V||(e.Promises=V={}));var ee;(function(A){A[A.Initial=0]="Initial",A[A.DoneOK=1]="DoneOK",A[A.DoneError=2]="DoneError"})(ee||(ee={}));class ne{static fromArray(d){return new ne(O=>{O.emitMany(d)})}static fromPromise(d){return new ne(async O=>{O.emitMany(await d)})}static fromPromises(d){return new ne(async O=>{await Promise.all(d.map(async z=>O.emitOne(await z)))})}static merge(d){return new ne(async O=>{await Promise.all(d.map(async z=>{for await(const G of z)O.emitOne(G)}))})}static{this.EMPTY=ne.fromArray([])}constructor(d){this.a=0,this.b=[],this.d=null,this.f=new D.$7c,queueMicrotask(async()=>{const O={emitOne:z=>this.g(z),emitMany:z=>this.h(z),reject:z=>this.k(z)};try{await Promise.resolve(d(O)),this.j()}catch(z){this.k(z)}finally{O.emitOne=void 0,O.emitMany=void 0,O.reject=void 0}})}[Symbol.asyncIterator](){let d=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(d<this.b.length)return{done:!1,value:this.b[d++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(d,O){return new ne(async z=>{for await(const G of d)z.emitOne(O(G))})}map(d){return ne.map(this,d)}static filter(d,O){return new ne(async z=>{for await(const G of d)O(G)&&z.emitOne(G)})}filter(d){return ne.filter(this,d)}static coalesce(d){return ne.filter(d,O=>!!O)}coalesce(){return ne.coalesce(this)}static async toPromise(d){const O=[];for await(const z of d)O.push(z);return O}toPromise(){return ne.toPromise(this)}g(d){this.a===0&&(this.b.push(d),this.f.fire())}h(d){this.a===0&&(this.b=this.b.concat(d),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(d){this.a===0&&(this.a=2,this.d=d,this.f.fire())}}e.$Og=ne;class ce extends ne{constructor(d,O){super(O),this.l=d}cancel(){this.l.cancel()}}e.$Pg=ce;function re(A){const d=new I.$dd,O=A(d.token);return new ce(d,async z=>{const G=d.token.onCancellationRequested(()=>{G.dispose(),d.dispose(),z.reject(new T.$3)});try{for await(const U of O){if(d.token.isCancellationRequested)return;z.emitOne(U)}G.dispose(),d.dispose()}catch(U){G.dispose(),d.dispose(),z.reject(U)}})}e.$Qg=re}),define(oe[90],ae([0,1,21,6,48,35,16,5,27]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=void 0;function b(){return Object.create(null)}e.$0i=b,e.$$i="**",e.$_i="/";const P="[/\\\\]",E="[^/\\\\]",m=/\//g;function h(x,H){switch(x){case 0:return"";case 1:return`${E}*?`;default:return`(?:${P}|${E}+${P}${H?`|${P}${E}+`:""})*?`}}function $(x,H){if(!x)return[];const B=[];let V=!1,ee=!1,ne="";for(const ce of x){switch(ce){case H:if(!V&&!ee){B.push(ne),ne="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}ne+=ce}return ne&&B.push(ne),B}e.$aj=$;function v(x){if(!x)return"";let H="";const B=$(x,e.$_i);if(B.every(V=>V===e.$$i))H=".*";else{let V=!1;B.forEach((ee,ne)=>{if(ee===e.$$i){if(V)return;H+=h(2,ne===B.length-1)}else{let ce=!1,re="",A=!1,d="";for(const O of ee){if(O!=="}"&&ce){re+=O;continue}if(A&&(O!=="]"||!d)){let z;O==="-"?z=O:(O==="^"||O==="!")&&!d?z="^":O===e.$_i?z="":z=(0,S.$nd)(O),d+=z;continue}switch(O){case"{":ce=!0;continue;case"[":A=!0;continue;case"}":{const G=`(?:${$(re,",").map(U=>v(U)).join("|")})`;H+=G,ce=!1,re="";break}case"]":{H+="["+d+"]",A=!1,d="";break}case"?":H+=E;continue;case"*":H+=h(1);continue;default:H+=(0,S.$nd)(O)}}ne<B.length-1&&(B[ne+1]!==e.$$i||ne+2<B.length)&&(H+=P)}V=ee===e.$$i})}return H}const c=/^\*\*\/\*\.[\w\.-]+$/,l=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,p=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new j.$oi(1e4),o=function(){return!1},n=function(){return null};function s(x,H){if(!x)return n;let B;typeof x!="string"?B=x.pattern:B=x,B=B.trim();const V=`${B}_${!!H.trimForExclusions}`;let ee=t.get(V);if(ee)return i(ee,x);let ne;return c.test(B)?ee=a(B.substr(4),B):(ne=l.exec(r(B,H)))?ee=w(ne[1],B):(H.trimForExclusions?y:u).test(B)?ee=g(B,H):(ne=p.exec(r(B,H)))?ee=f(ne[1].substr(1),B,!0):(ne=C.exec(r(B,H)))?ee=f(ne[1],B,!1):ee=k(B),t.set(V,ee),i(ee,x)}function i(x,H){if(typeof H=="string")return x;const B=function(V,ee){return(0,D.$Je)(V,H.base,!R.$k)?x((0,S.$rd)(V.substr(H.base.length),L.sep),ee):null};return B.allBasenames=x.allBasenames,B.allPaths=x.allPaths,B.basenames=x.basenames,B.patterns=x.patterns,B}function r(x,H){return H.trimForExclusions&&x.endsWith("/**")?x.substr(0,x.length-2):x}function a(x,H){return function(B,V){return typeof B=="string"&&B.endsWith(x)?H:null}}function w(x,H){const B=`/${x}`,V=`\\${x}`,ee=function(ce,re){return typeof ce!="string"?null:re?re===x?H:null:ce===x||ce.endsWith(B)||ce.endsWith(V)?H:null},ne=[x];return ee.basenames=ne,ee.patterns=[H],ee.allBasenames=ne,ee}function g(x,H){const B=Y(x.slice(1,-1).split(",").map(re=>s(re,H)).filter(re=>re!==n),x),V=B.length;if(!V)return n;if(V===1)return B[0];const ee=function(re,A){for(let d=0,O=B.length;d<O;d++)if(B[d](re,A))return x;return null},ne=B.find(re=>!!re.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const ce=B.reduce((re,A)=>A.allPaths?re.concat(A.allPaths):re,[]);return ce.length&&(ee.allPaths=ce),ee}function f(x,H,B){const V=L.sep===L.$0b.sep,ee=V?x:x.replace(m,L.sep),ne=L.sep+ee,ce=L.$0b.sep+x;let re;return B?re=function(A,d){return typeof A=="string"&&(A===ee||A.endsWith(ne)||!V&&(A===x||A.endsWith(ce)))?H:null}:re=function(A,d){return typeof A=="string"&&(A===ee||!V&&A===x)?H:null},re.allPaths=[(B?"*/":"./")+x],re}function k(x){try{const H=new RegExp(`^${v(x)}$`);return function(B){return H.lastIndex=0,typeof B=="string"&&H.test(B)?x:null}}catch{return n}}function N(x,H,B){return!x||typeof H!="string"?!1:M(x)(H,void 0,B)}e.$bj=N;function M(x,H={}){if(!x)return o;if(typeof x=="string"||F(x)){const B=s(x,H);if(B===n)return o;const V=function(ee,ne){return!!B(ee,ne)};return B.allBasenames&&(V.allBasenames=B.allBasenames),B.allPaths&&(V.allPaths=B.allPaths),V}return J(x,H)}e.$cj=M;function F(x){const H=x;return H?typeof H.base=="string"&&typeof H.pattern=="string":!1}e.$dj=F;function W(x){return x.allBasenames||[]}e.$ej=W;function q(x){return x.allPaths||[]}e.$fj=q;function J(x,H){const B=Y(Object.getOwnPropertyNames(x).map(re=>Q(re,x[re],H)).filter(re=>re!==n)),V=B.length;if(!V)return n;if(!B.some(re=>!!re.requiresSiblings)){if(V===1)return B[0];const re=function(O,z){let G;for(let U=0,X=B.length;U<X;U++){const _=B[U](O,z);if(typeof _=="string")return _;(0,T.$gg)(_)&&(G||(G=[]),G.push(_))}return G?(async()=>{for(const U of G){const X=await U;if(typeof X=="string")return X}return null})():null},A=B.find(O=>!!O.allBasenames);A&&(re.allBasenames=A.allBasenames);const d=B.reduce((O,z)=>z.allPaths?O.concat(z.allPaths):O,[]);return d.length&&(re.allPaths=d),re}const ee=function(re,A,d){let O,z;for(let G=0,U=B.length;G<U;G++){const X=B[G];X.requiresSiblings&&d&&(A||(A=(0,L.$ec)(re)),O||(O=A.substr(0,A.length-(0,L.$fc)(re).length)));const _=X(re,A,O,d);if(typeof _=="string")return _;(0,T.$gg)(_)&&(z||(z=[]),z.push(_))}return z?(async()=>{for(const G of z){const U=await G;if(typeof U=="string")return U}return null})():null},ne=B.find(re=>!!re.allBasenames);ne&&(ee.allBasenames=ne.allBasenames);const ce=B.reduce((re,A)=>A.allPaths?re.concat(A.allPaths):re,[]);return ce.length&&(ee.allPaths=ce),ee}function Q(x,H,B){if(H===!1)return n;const V=s(x,B);if(V===n)return n;if(typeof H=="boolean")return V;if(H){const ee=H.when;if(typeof ee=="string"){const ne=(ce,re,A,d)=>{if(!d||!V(ce,re))return null;const O=ee.replace("$(basename)",()=>A),z=d(O);return(0,T.$gg)(z)?z.then(G=>G?x:null):z?x:null};return ne.requiresSiblings=!0,ne}}return V}function Y(x,H){const B=x.filter(re=>!!re.basenames);if(B.length<2)return x;const V=B.reduce((re,A)=>{const d=A.basenames;return d?re.concat(d):re},[]);let ee;if(H){ee=[];for(let re=0,A=V.length;re<A;re++)ee.push(H)}else ee=B.reduce((re,A)=>{const d=A.patterns;return d?re.concat(d):re},[]);const ne=function(re,A){if(typeof re!="string")return null;if(!A){let O;for(O=re.length;O>0;O--){const z=re.charCodeAt(O-1);if(z===47||z===92)break}A=re.substr(O)}const d=V.indexOf(A);return d!==-1?ee[d]:null};ne.basenames=V,ne.patterns=ee,ne.allBasenames=V;const ce=x.filter(re=>!re.basenames);return ce.push(ne),ce}function Z(x,H){return(0,I.$af)(x,H,(B,V)=>typeof B=="string"&&typeof V=="string"?B===V:typeof B!="string"&&typeof V!="string"?B.base===V.base&&B.pattern===V.pattern:!1)}e.$gj=Z}),define(oe[91],ae([0,1,14,10]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.$mm=e.$lm=void 0;function D(E){return E.toJSON()}class j{constructor(m){this.a=m}transformIncoming(m){const h=this.a.transformIncoming(m);return h===m?m:D(T.URI.from(h))}transformOutgoing(m){const h=this.a.transformOutgoing(m);return h===m?m:D(T.URI.from(h))}transformOutgoingURI(m){const h=this.a.transformOutgoing(m);return h===m?m:T.URI.from(h)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$lm=j,e.$mm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function L(E,m,h){if(!E||h>200)return null;if(typeof E=="object"){if(E instanceof T.URI)return m.transformOutgoing(E);for(const $ in E)if(Object.hasOwnProperty.call(E,$)){const v=L(E[$],m,h+1);v!==null&&(E[$]=v)}}return null}function R(E,m){const h=L(E,m,0);return h===null?E:h}e.$nm=R;function S(E,m,h,$){if(!E||$>200)return null;if(typeof E=="object"){if(E.$mid===1)return h?T.URI.revive(m.transformIncoming(E)):m.transformIncoming(E);if(E instanceof I.$Jb)return null;for(const v in E)if(Object.hasOwnProperty.call(E,v)){const c=S(E[v],m,h,$+1);c!==null&&(E[v]=c)}}return null}function b(E,m){const h=S(E,m,!1,0);return h===null?E:h}e.$om=b;function P(E,m){const h=S(E,m,!0,0);return h===null?E:h}e.$pm=P}),define(oe[31],ae([0,1,52,36,264,6,48,86,16,5,22,10]),function(te,e,I,T,D,j,L,R,S,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(J){J[J.UNLINK=0]="UNLINK",J[J.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function h(J,Q=m.UNLINK,Y){if((0,L.$Me)(J))throw new Error("rimraf - will refuse to recursively delete root");return Q===m.UNLINK?v(J):$(J,Y)}async function $(J,Q=(0,L.$Re)((0,T.tmpdir)())){try{try{await I.promises.rename(J,Q)}catch(Y){return Y.code==="ENOENT"?void 0:v(J)}v(Q).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function v(J){return(0,D.promisify)(I.rm)(J,{recursive:!0,force:!0,maxRetries:3})}function c(J){if((0,L.$Me)(J))throw new Error("rimraf - will refuse to recursively delete root");I.rmSync(J,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function l(J,Q){return p(await(Q?u(J):(0,D.promisify)(I.readdir)(J)))}async function u(J){try{return await(0,D.promisify)(I.readdir)(J,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const Q=[],Y=await l(J);for(const Z of Y){let x=!1,H=!1,B=!1;try{const V=await e.Promises.lstat((0,S.$ac)(J,Z));x=V.isFile(),H=V.isDirectory(),B=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}Q.push({name:Z,isFile:()=>x,isDirectory:()=>H,isSymbolicLink:()=>B})}return Q}function y(J){return p(I.readdirSync(J))}e.readdirSync=y;function p(J){return J.map(Q=>typeof Q=="string"?b.$j?(0,R.$5k)(Q):Q:(Q.name=b.$j?(0,R.$5k)(Q.name):Q.name,Q))}async function C(J){const Q=await l(J),Y=[];for(const Z of Q)await o.existsDirectory((0,S.$ac)(J,Z))&&Y.push(Z);return Y}function t(J,Q=1e3){return new Promise(Y=>{let Z=!1;const x=setInterval(()=>{Z||(Z=!0,I.access(J,H=>{Z=!1,H&&(clearInterval(x),Y(void 0))}))},Q)})}e.whenDeleted=t;var o;(function(J){async function Q(x){let H;try{if(H=await e.Promises.lstat(x),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(x),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(b.$i&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(x)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw V}throw B}}J.stat=Q;async function Y(x){try{const{stat:H,symbolicLink:B}=await J.stat(x);return H.isFile()&&B?.dangling!==!0}catch{}return!1}J.existsFile=Y;async function Z(x){try{const{stat:H,symbolicLink:B}=await J.stat(x);return H.isDirectory()&&B?.dangling!==!0}catch{}return!1}J.existsDirectory=Z})(o||(e.SymlinkSupport=o={}));const n=new j.$Bg;function s(J,Q,Y){return n.queueFor(E.URI.file(J),P.$Yf).queue(()=>{const Z=g(Y);return new Promise((x,H)=>a(J,Q,Z,B=>B?H(B):x()))})}let i=!0;function r(J){i=J}e.configureFlushOnWrite=r;function a(J,Q,Y,Z){if(!i)return I.writeFile(J,Q,{mode:Y.mode,flag:Y.flag},Z);I.open(J,Y.flag,Y.mode,(x,H)=>{if(x)return Z(x);I.writeFile(H,Q,B=>{if(B)return I.close(H,()=>Z(B));I.fdatasync(H,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),r(!1)),I.close(H,ee=>Z(ee))))})})}function w(J,Q,Y){const Z=g(Y);if(!i)return I.writeFileSync(J,Q,{mode:Z.mode,flag:Z.flag});const x=I.openSync(J,Z.flag,Z.mode);try{I.writeFileSync(x,Q);try{I.fdatasyncSync(x)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),r(!1)}}finally{I.closeSync(x)}}e.writeFileSync=w;function g(J){return J?{mode:typeof J.mode=="number"?J.mode:438,flag:typeof J.flag=="string"?J.flag:"w"}:{mode:438,flag:"w"}}async function f(J,Q){if(J!==Q)try{await e.Promises.rename(J,Q)}catch(Y){if(J.toLowerCase()!==Q.toLowerCase()&&Y.code==="EXDEV"||J.endsWith("."))await k(J,Q,{preserveSymlinks:!1}),await h(J,m.MOVE);else throw Y}}async function k(J,Q,Y){return M(J,Q,{root:{source:J,target:Q},options:Y,handledSourcePaths:new Set})}const N=511;async function M(J,Q,Y){if(Y.handledSourcePaths.has(J))return;Y.handledSourcePaths.add(J);const{stat:Z,symbolicLink:x}=await o.stat(J);if(x){if(Y.options.preserveSymlinks)try{return await q(J,Q,Y)}catch(H){console.warn("[node.js fs] copy of symlink failed: ",H)}if(x.dangling)return}return Z.isDirectory()?F(J,Q,Z.mode&N,Y):W(J,Q,Z.mode&N)}async function F(J,Q,Y,Z){await e.Promises.mkdir(Q,{recursive:!0,mode:Y});const x=await l(J);for(const H of x)await M((0,S.$ac)(J,H),(0,S.$ac)(Q,H),Z)}async function W(J,Q,Y){await e.Promises.copyFile(J,Q),await e.Promises.chmod(Q,Y)}async function q(J,Q,Y){let Z=await e.Promises.readlink(J);(0,L.$Je)(Z,Y.root.source,!b.$k)&&(Z=(0,S.$ac)(Y.root.target,Z.substr(Y.root.source.length+1))),await e.Promises.symlink(Z,Q)}e.Promises=new class{get access(){return(0,D.promisify)(I.access)}get stat(){return(0,D.promisify)(I.stat)}get lstat(){return(0,D.promisify)(I.lstat)}get utimes(){return(0,D.promisify)(I.utimes)}get read(){return(J,Q,Y,Z,x)=>new Promise((H,B)=>{I.read(J,Q,Y,Z,x,(V,ee,ne)=>V?B(V):H({bytesRead:ee,buffer:ne}))})}get readFile(){return(0,D.promisify)(I.readFile)}get write(){return(J,Q,Y,Z,x)=>new Promise((H,B)=>{I.write(J,Q,Y,Z,x,(V,ee,ne)=>V?B(V):H({bytesWritten:ee,buffer:ne}))})}get appendFile(){return(0,D.promisify)(I.appendFile)}get fdatasync(){return(0,D.promisify)(I.fdatasync)}get truncate(){return(0,D.promisify)(I.truncate)}get rename(){return(0,D.promisify)(I.rename)}get copyFile(){return(0,D.promisify)(I.copyFile)}get open(){return(0,D.promisify)(I.open)}get close(){return(0,D.promisify)(I.close)}get symlink(){return(0,D.promisify)(I.symlink)}get readlink(){return(0,D.promisify)(I.readlink)}get chmod(){return(0,D.promisify)(I.chmod)}get mkdir(){return(0,D.promisify)(I.mkdir)}get unlink(){return(0,D.promisify)(I.unlink)}get rmdir(){return(0,D.promisify)(I.rmdir)}get realpath(){return(0,D.promisify)(I.realpath)}async exists(J){try{return await e.Promises.access(J),!0}catch{return!1}}get readdir(){return l}get readDirsInDir(){return C}get writeFile(){return s}get rm(){return h}get move(){return f}get copy(){return k}}}),define(oe[140],ae([0,1,52,16,5,27,31]),function(te,e,I,T,D,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.$Hp=void 0;function R(m){if(D.$k)return m;const h=(0,T.$dc)(m);if(m===h)return m;const $=((0,T.$ec)(m)||m).toLowerCase();try{const c=(0,L.readdirSync)(h).filter(l=>l.toLowerCase()===$);if(c.length===1){const l=R(h);if(l)return(0,T.$ac)(l,c[0])}else if(c.length>1){const l=c.indexOf($);if(l>=0){const u=R(h);if(u)return(0,T.$ac)(u,c[l])}}}catch{}return null}e.$Hp=R;async function S(m){if(D.$k)return m;const h=(0,T.$dc)(m);if(m===h)return m;const $=((0,T.$ec)(m)||m).toLowerCase();try{const c=(await L.Promises.readdir(h)).filter(l=>l.toLowerCase()===$);if(c.length===1){const l=await S(h);if(l)return(0,T.$ac)(l,c[0])}else if(c.length>1){const l=c.indexOf($);if(l>=0){const u=await S(h);if(u)return(0,T.$ac)(u,c[l])}}}catch{}return null}e.$Ip=S;async function b(m){try{return await L.Promises.realpath(m)}catch{const $=E(m);return await L.Promises.access($,I.constants.R_OK),$}}e.$Jp=b;function P(m){try{return I.realpathSync(m)}catch{const $=E(m);return I.accessSync($,I.constants.R_OK),$}}e.$Kp=P;function E(m){return(0,j.$sd)((0,T.$$b)(m),T.sep)}}),define(oe[141],ae([0,1,16,5,37,89,11,31]),function(te,e,I,T,D,j,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function S(E=D.env){return E.comspec||"cmd.exe"}e.$fl=S;function b(E){let m=[],h=!1;const $=function(v){if(h){m.push(v);return}(!E.send(v,l=>{if(l&&console.error(l),h=!1,m.length>0){const u=m.slice(0);m=[],u.forEach(y=>$(y))}})||T.$i)&&(h=!0)};return{send:$}}e.$gl=b;var P;(function(E){async function m(h,$,v){if(I.$_b(h))return h;if($===void 0&&($=D.cwd()),I.$dc(h)!=="."||(v===void 0&&L.$ie(D.env.PATH)&&(v=D.env.PATH.split(I.$kc)),v===void 0||v.length===0))return I.$ac($,h);async function l(u){if(await R.Promises.exists(u)){let y;try{y=await R.Promises.stat(u)}catch(p){p.message.startsWith("EACCES")&&(y=await R.Promises.lstat(u))}return y?!y.isDirectory():!1}return!1}for(const u of v){let y;if(I.$_b(u)?y=I.$ac(u,h):y=I.$ac($,u,h),await l(y))return y;let p=y+".com";if(await l(p)||(p=y+".exe",await l(p)))return p}return I.$ac($,h)}E.findExecutable=m})(P||(e.win32=P={}))}),define(oe[142],ae([0,1,63,26]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;function D(L){return new Promise((R,S)=>{let b;const P=new Map;function E(h,$,v,c,l){const u=P.get($);if(h===L||u){const y={name:m(v),cmd:v,pid:h,ppid:$,load:c,mem:l};P.set(h,y),h===L&&(b=y),u&&(u.children||(u.children=[]),u.children.push(y),u.children.length>1&&(u.children=u.children.sort((p,C)=>p.pid-C.pid)))}}function m(h){const $=/--utility-sub-type=network/i,v=/--ms-enable-electron-run-as-node/i,c=/--crashes-directory/i,l=/\\pipe\\winpty-control/i,u=/conhost\.exe.+--headless/i,y=/--type=([a-zA-Z-]+)/;if(c.exec(h))return"electron-crash-reporter";if(l.exec(h))return"winpty-agent";if(u.exec(h))return"conpty-agent";let p=y.exec(h);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?$.exec(h)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const C=/[a-zA-Z-]+\.js/g;let t="";do p=C.exec(h),p&&(t+=p+" ");while(p);return t&&h.indexOf("node ")<0&&h.indexOf("node.exe")<0?`electron-nodejs (${t})`:v.exec(h)?`electron-nodejs (${h})`:h}if(process.platform==="win32"){const h=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,v)=>{te(["@vscode/windows-process-tree"],$,v)}).then($=>{$.getProcessList(L,v=>{if(!v){S(new Error(`Root process ${L} not found`));return}$.getProcessCpuUsage(v,c=>{const l=new Map;c.forEach(u=>{const y=h(u.commandLine||"");l.set(u.pid,{name:m(y),cmd:y,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),b=l.get(L),b?(l.forEach(u=>{const y=l.get(u.ppid);y&&(y.children||(y.children=[]),y.children.push(u))}),l.forEach(u=>{u.children&&(u.children=u.children.sort((y,p)=>y.pid-p.pid))}),R(b)):S(new Error(`Root process ${L} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let h=function(){let $=[b];const v=[];for(;$.length;){const l=$.shift();l&&(v.push(l.pid),l.children&&($=$.concat(l.children)))}let c=JSON.stringify(T.$3e.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+v.join(" "),(0,I.exec)(c,{},(l,u,y)=>{if(l||y)S(l||new Error(y.toString()));else{const p=u.toString().split(`
`);for(let C=0;C<v.length;C++){const t=P.get(v[C]);t.load=parseFloat(p[C])}if(!b){S(new Error(`Root process ${L} not found`));return}R(b)}})};(0,I.exec)("which ps",{},($,v,c)=>{if($||c)if(process.platform!=="linux")S($||new Error(c.toString()));else{const l=JSON.stringify(T.$3e.asFileUri("vs/base/node/ps.sh").fsPath);(0,I.exec)(l,{},(u,y,p)=>{u||p?S(u||new Error(p.toString())):(j(y,E),h())})}else{const l=v.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,I.exec)(`${l} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(y,p,C)=>{y||C&&!C.includes("screen size is bogus")?S(y||new Error(C.toString())):(j(p,E),process.platform==="linux"?h():b?R(b):S(new Error(`Root process ${L} not found`)))})}})}})}e.$dr=D;function j(L,R){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=L.toString().split(`
`);for(const P of b){const E=S.exec(P.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}});var be=this&&this.__decorate||function(te,e,I,T){var D=arguments.length,j=D<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,I):T,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(te,e,I,T);else for(var R=te.length-1;R>=0;R--)(L=te[R])&&(j=(D<3?L(j):D>3?L(e,I,j):L(e,I))||j);return D>3&&j&&Object.defineProperty(e,I,j),j};define(oe[43],ae([0,1,21,6,14,25,81,7,3,2,62,27,11]),function(te,e,I,T,D,j,L,R,S,b,P,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.ProxyChannel=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.RequestInitiator=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=void 0;var h;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(h||(h={}));function $(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(v||(v={}));function c(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(l||(l={}));function u(H){let B=0;for(let V=0;;V+=7){const ee=H.read(1);if(B|=(ee.buffer[0]&127)<<V,!(ee.buffer[0]&128))return B}}const y=n(0);function p(H,B){if(B===0){H.write(y);return}let V=0;for(let ne=B;ne!==0;ne=ne>>>7)V++;const ee=D.$Jb.alloc(V);for(let ne=0;B!==0;ne++)ee.buffer[ne]=B&127,B=B>>>7,B>0&&(ee.buffer[ne]|=128);H.write(ee)}class C{constructor(B){this.b=B,this.a=0}read(B){const V=this.b.slice(this.a,this.a+B);return this.a+=V.byteLength,V}}e.$Xg=C;class t{constructor(){this.a=[]}get buffer(){return D.$Jb.concat(this.a)}write(B){this.a.push(B)}}e.$Yg=t;var o;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object",H[H.Int=6]="Int"})(o||(o={}));function n(H){const B=D.$Jb.alloc(1);return B.writeUInt8(H,0),B}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},i=typeof Buffer<"u";function r(H,B){if(typeof B>"u")H.write(s.Undefined);else if(typeof B=="string"){const V=D.$Jb.fromString(B);H.write(s.String),p(H,V.byteLength),H.write(V)}else if(i&&Buffer.isBuffer(B)){const V=D.$Jb.wrap(B);H.write(s.Buffer),p(H,V.byteLength),H.write(V)}else if(B instanceof D.$Jb)H.write(s.VSBuffer),p(H,B.byteLength),H.write(B);else if(Array.isArray(B)){H.write(s.Array),p(H,B.length);for(const V of B)r(H,V)}else if(typeof B=="number"&&(B|0)===B)H.write(s.Uint),p(H,B);else{const V=D.$Jb.fromString(JSON.stringify(B));H.write(s.Object),p(H,V.byteLength),H.write(V)}}e.$Zg=r;function a(H){switch(H.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return H.read(u(H)).toString();case o.Buffer:return H.read(u(H)).buffer;case o.VSBuffer:return H.read(u(H));case o.Array:{const V=u(H),ee=[];for(let ne=0;ne<V;ne++)ee.push(a(H));return ee}case o.Object:return JSON.parse(H.read(u(H)).toString());case o.Int:return u(H)}}e.$1g=a;class w{constructor(B,V,ee=null,ne=1e3){this.h=B,this.j=V,this.k=ee,this.l=ne,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ce=>this.q(ce)),this.m({type:200})}registerChannel(B,V){this.b.set(B,V),setTimeout(()=>this.w(B),0)}m(B){switch(B.type){case 200:{const V=this.o([B.type]);this.k?.logOutgoing(V,0,1,c(B.type));return}case 201:case 202:case 204:case 203:{const V=this.o([B.type,B.id],B.data);this.k?.logOutgoing(V,B.id,1,c(B.type),B.data);return}}}o(B,V=void 0){const ee=new t;return r(ee,B),r(ee,V),this.p(ee.buffer)}p(B){try{return this.h.send(B),B.byteLength}catch{return 0}}q(B){const V=new C(B),ee=a(V),ne=a(V),ce=ee[0];switch(ce){case 100:return this.k?.logIncoming(B.byteLength,ee[1],1,`${$(ce)}: ${ee[2]}.${ee[3]}`,ne),this.s({type:ce,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 102:return this.k?.logIncoming(B.byteLength,ee[1],1,`${$(ce)}: ${ee[2]}.${ee[3]}`,ne),this.t({type:ce,id:ee[1],channelName:ee[2],name:ee[3],arg:ne});case 101:return this.k?.logIncoming(B.byteLength,ee[1],1,`${$(ce)}`),this.u({type:ce,id:ee[1]});case 103:return this.k?.logIncoming(B.byteLength,ee[1],1,`${$(ce)}`),this.u({type:ce,id:ee[1]})}}s(B){const V=this.b.get(B.channelName);if(!V){this.v(B);return}const ee=new j.$dd;let ne;try{ne=V.call(this.j,B.name,B.arg,ee.token)}catch(A){ne=Promise.reject(A)}const ce=B.id;ne.then(A=>{this.m({id:ce,data:A,type:201}),this.d.delete(B.id)},A=>{A instanceof Error?this.m({id:ce,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.m({id:ce,data:A,type:203}),this.d.delete(B.id)});const re=(0,b.$jb)(()=>ee.cancel());this.d.set(B.id,re)}t(B){const V=this.b.get(B.channelName);if(!V){this.v(B);return}const ee=B.id,ce=V.listen(this.j,B.name,B.arg)(re=>this.m({id:ee,data:re,type:204}));this.d.set(B.id,ce)}u(B){const V=this.d.get(B.id);V&&(V.dispose(),this.d.delete(B.id))}v(B){let V=this.g.get(B.channelName);V||(V=[],this.g.set(B.channelName,V));const ee=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.m({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);V.push({request:B,timeoutTimer:ee})}w(B){const V=this.g.get(B);if(V){for(const ee of V)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(B)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$gb)(this.d.values()),this.d.clear()}}e.$2g=w;var g;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(g||(e.RequestInitiator=g={}));class f{constructor(B,V=null){this.l=B,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new S.$7c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=V}getChannel(B){const V=this;return{call(ee,ne,ce){return V.a?Promise.reject(new R.$3):V.m(B,ee,ne,ce)},listen(ee,ne){return V.a?S.Event.None:V.o(B,ee,ne)}}}m(B,V,ee,ne=j.CancellationToken.None){const ce=this.g++,A={id:ce,type:100,channelName:B,name:V,arg:ee};if(ne.isCancellationRequested)return Promise.reject(new R.$3);let d;return new Promise((z,G)=>{if(ne.isCancellationRequested)return G(new R.$3);const U=()=>{const he=ue=>{switch(ue.type){case 201:this.f.delete(ce),z(ue.data);break;case 202:{this.f.delete(ce);const me=new Error(ue.data.message);me.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,me.name=ue.data.name,G(me);break}case 203:this.f.delete(ce),G(ue.data);break}};this.f.set(ce,he),this.p(A)};let X=null;this.b===l.Idle?U():(X=(0,T.$hg)(he=>this.u()),X.then(()=>{X=null,U()}));const _=()=>{X?(X.cancel(),X=null):this.p({id:ce,type:101}),G(new R.$3)},se=ne.onCancellationRequested(_);d=(0,b.$ib)((0,b.$jb)(_),se),this.d.add(d)}).finally(()=>{this.d.delete(d)})}o(B,V,ee){const ne=this.g++,re={id:ne,type:102,channelName:B,name:V,arg:ee};let A=null;const d=new S.$7c({onWillAddFirstListener:()=>{A=(0,T.$hg)(z=>this.u()),A.then(()=>{A=null,this.d.add(d),this.p(re)})},onDidRemoveLastListener:()=>{A?(A.cancel(),A=null):(this.d.delete(d),this.p({id:ne,type:103}))}}),O=z=>d.fire(z.data);return this.f.set(ne,O),d.event}p(B){switch(B.type){case 100:case 102:{const V=this.q([B.type,B.id,B.channelName,B.name],B.arg);this.j?.logOutgoing(V,B.id,0,`${$(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const V=this.q([B.type,B.id]);this.j?.logOutgoing(V,B.id,0,$(B.type));return}}}q(B,V=void 0){const ee=new t;return r(ee,B),r(ee,V),this.r(ee.buffer)}r(B){try{return this.l.send(B),B.byteLength}catch{return 0}}s(B){const V=new C(B),ee=a(V),ne=a(V),ce=ee[0];switch(ce){case 200:return this.j?.logIncoming(B.byteLength,0,0,c(ce)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(B.byteLength,ee[1],0,c(ce),ne),this.t({type:ee[0],id:ee[1],data:ne})}}t(B){if(B.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(B.id)?.(B)}get onDidInitializePromise(){return S.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$gb)(this.d.values()),this.d.clear()}}e.$3g=f,be([L.$Rg],f.prototype,"onDidInitializePromise",null);class k{get connections(){const B=[];return this.f.forEach(V=>B.push(V)),B}constructor(B){this.a=new Map,this.f=new Set,this.g=new S.$7c,this.onDidAddConnection=this.g.event,this.h=new S.$7c,this.onDidRemoveConnection=this.h.event,B(({protocol:V,onDidClientDisconnect:ee})=>{S.Event.once(V.onMessage)(ce=>{const re=new C(ce),A=a(re),d=new w(V,A),O=new f(V);this.a.forEach((G,U)=>d.registerChannel(U,G));const z={channelServer:d,channelClient:O,ctx:A};this.f.add(z),this.g.fire(z),ee(()=>{d.dispose(),O.dispose(),this.f.delete(z),this.h.fire(z)})})})}getChannel(B,V){const ee=this;return{call(ne,ce,re){let A;if((0,m.$we)(V)){const O=(0,I.$Jf)(ee.connections.filter(V));A=O?Promise.resolve(O):S.Event.toPromise(S.Event.filter(ee.onDidAddConnection,V))}else A=V.routeCall(ee,ne,ce);const d=A.then(O=>O.channelClient.getChannel(B));return M(d).call(ne,ce,re)},listen(ne,ce){if((0,m.$we)(V))return ee.j(B,V,ne,ce);const re=V.routeEvent(ee,ne,ce).then(A=>A.channelClient.getChannel(B));return M(re).listen(ne,ce)}}}j(B,V,ee,ne){const ce=this;let re=new b.$kb;const A=new S.$7c({onWillAddFirstListener:()=>{re=new b.$kb;const d=new S.$ad,O=new Map,z=U=>{const _=U.channelClient.getChannel(B).listen(ee,ne),se=d.add(_);O.set(U,se)},G=U=>{const X=O.get(U);X&&(X.dispose(),O.delete(U))};ce.connections.filter(V).forEach(z),S.Event.filter(ce.onDidAddConnection,V)(z,void 0,re),ce.onDidRemoveConnection(G,void 0,re),d.event(A.fire,A,re),re.add(d)},onDidRemoveLastListener:()=>{re.dispose()}});return A.event}registerChannel(B,V){this.a.set(B,V),this.f.forEach(ee=>{ee.channelServer.registerChannel(B,V)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$4g=k;class N{constructor(B,V,ee=null){const ne=new t;r(ne,V),B.send(ne.buffer),this.a=new f(B,ee),this.d=new w(B,V,ee)}getChannel(B){return this.a.getChannel(B)}registerChannel(B,V){this.d.registerChannel(B,V)}dispose(){this.a.dispose(),this.d.dispose()}}e.$5g=N;function M(H){return{call(B,V,ee){return H.then(ne=>ne.call(B,V,ee))},listen(B,V){const ee=new S.$cd;return H.then(ne=>ee.input=ne.listen(B,V)),ee.event}}}e.$6g=M;function F(H){let B=!1;return{call(V,ee,ne){return B?H.call(V,ee,ne):(0,T.$ug)(0).then(()=>B=!0).then(()=>H.call(V,ee,ne))},listen(V,ee){if(B)return H.listen(V,ee);const ne=new S.$cd;return(0,T.$ug)(0).then(()=>B=!0).then(()=>ne.input=H.listen(V,ee)),ne.event}}}e.$7g=F;class W{constructor(B){this.a=B}routeCall(B){return this.b(B)}routeEvent(B){return this.b(B)}async b(B){for(const V of B.connections)if(await Promise.resolve(this.a(V.ctx)))return Promise.resolve(V);return await S.Event.toPromise(B.onDidAddConnection),await this.b(B)}}e.$8g=W;var q;(function(H){function B(ce,re){const A=ce,d=re&&re.disableMarshalling,O=new Map;for(const z in A)ee(z)&&O.set(z,S.Event.buffer(A[z],!0));return new class{listen(z,G,U){const X=O.get(G);if(X)return X;if(ne(G)){const _=A[G];if(typeof _=="function")return _.call(A,U)}throw new R.$ab(`Event not found: ${G}`)}call(z,G,U){const X=A[G];if(typeof X=="function"){if(!d&&Array.isArray(U))for(let _=0;_<U.length;_++)U[_]=(0,P.$Wg)(U[_]);return X.apply(A,U)}throw new R.$ab(`Method not found: ${G}`)}}}H.fromService=B;function V(ce,re){const A=re&&re.disableMarshalling;return new Proxy({},{get(d,O){if(typeof O=="string")return re?.properties?.has(O)?re.properties.get(O):ne(O)?function(z){return ce.listen(O,z)}:ee(O)?ce.listen(O):async function(...z){let G;re&&!(0,m.$re)(re.context)?G=[re.context,...z]:G=z;const U=await ce.call(O,G);return A?U:(0,P.$Wg)(U)};throw new R.$ab(`Property not found: ${String(O)}`)}})}H.toService=V;function ee(ce){return ce[0]==="o"&&ce[1]==="n"&&E.$Kd(ce.charCodeAt(2))}function ne(ce){return/^onDynamic/.test(ce)&&E.$Kd(ce.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const J=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const B=H.toString();if(B!=="[object Object]")return B}return H}function Y(H){return Array.isArray(H)?H.map(Q):Q(H)}function Z(H,B,V,ee,ne,ce,re){re=Y(re);const A=J[ne],d=A[ee%A.length];let O=[`%c[${H}]%c[${String(B).padStart(7," ")}]%c[len: ${String(V).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${ce}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(ce)?(O=O.concat(re),O.push(")")):O.push(re),console.log.apply(console,O)}class x{constructor(B,V){this.d=B,this.f=V,this.a=0,this.b=0}logOutgoing(B,V,ee,ne,ce){this.b+=B,Z(this.d,this.b,B,V,ee,ne,ce)}logIncoming(B,V,ee,ne,ce){this.a+=B,Z(this.f,this.a,B,V,ee,ne,ce)}}e.$9g=x}),define(oe[92],ae([0,1,14,3,2,43]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bh=e.$ah=e.$_g=e.$$g=e.ProtocolConstants=e.$0g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var R;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let r=0;function a(g,f){if(!i.has(g)){const k=String(++r);i.set(g,k)}return i.get(g)}function w(g,f,k,N){if(!s.enableDiagnostics)return;const M=a(g,f);if(N instanceof I.$Jb||N instanceof Uint8Array||N instanceof ArrayBuffer||ArrayBuffer.isView(N)){const F=I.$Jb.alloc(N.byteLength);F.set(N),s.records.push({timestamp:Date.now(),id:M,label:f,type:k,buff:F})}else s.records.push({timestamp:Date.now(),id:M,label:f,type:k,data:N})}s.traceSocketEvent=w})(R||(e.SocketDiagnostics=R={}));var S;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(S||(e.SocketCloseEventType=S={}));let b=null;function P(){return b||(b=I.$Jb.alloc(0)),b}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,r){if(i===0)return P();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const f=this.a[0];return r&&(this.a.shift(),this.b-=i),f}if(this.a[0].byteLength>i){const f=this.a[0].slice(0,i);return r&&(this.a[0]=this.a[0].slice(i),this.b-=i),f}const a=I.$Jb.alloc(i);let w=0,g=0;for(;i>0;){const f=this.a[g];if(f.byteLength>i){const k=f.slice(0,i);a.set(k,w),w+=i,r&&(this.a[g]=f.slice(i),this.b-=i),i-=i}else a.set(f,w),w+=f.byteLength,r?(this.a.shift(),this.b-=f.byteLength):g++,i-=f.byteLength}return a}}e.$0g=E;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function h(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class v{constructor(i,r,a,w){this.type=i,this.id=r,this.ack=a,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class c extends D.$lb{constructor(i){super(),this.f=this.B(new T.$7c),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new E,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:h(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,w=this.g.id,g=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new v(a,w,g,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class l{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=I.$Jb.alloc(13);r.writeUInt8(i.type,0),r.writeUInt32BE(i.id,1),r.writeUInt32BE(i.ack,5),r.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:h(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(r,i.data)}g(i,r){const a=this.f===0;return this.d.push(i,r),this.f+=i.byteLength+r.byteLength,a}h(){const i=I.$Jb.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,r){this.g(i,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class u extends D.$lb{constructor(i){super(),this.f=new T.$7c,this.onMessage=this.f.event,this.g=new T.$7c,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new l(this.a)),this.c=this.B(new c(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new v(1,0,0,i))}}e.$$g=u;class y extends j.$5g{static fromSocket(i,r){return new y(new u(i),r)}get onDidDispose(){return this.b.onDidDispose}constructor(i,r,a=null){super(i,r,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$_g=y;class p{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new T.$7c({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$ah=p;class C{constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,r=this.a;for(;r;)r=r.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let r=0,a=this.a;for(;a;)i[r++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const r=new C(i);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const i=Date.now();for(let r=0;r<o.a;r++)this.c[r]=i-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),r=(1+o.a)*1e3;let a=0;for(let w=0;w<o.a;w++)i-this.c[w]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new p,this.onControlMessage=this.u.event,this.v=new p,this.onMessage=this.v.event,this.w=new p,this.onDidDispose=this.w.event,this.x=new p,this.onSocketClose=this.x.event,this.y=new p,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??o.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new D.$kb,this.o=i.socket,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new v(5,0,0,P());this.p.write(i),this.p.flush()}sendPause(){const i=new v(7,0,0,P());this.p.write(i)}sendResume(){const i=new v(8,0,0,P());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,r){this.a=!0,this.r.dispose(),this.r=new D.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new l(this.o)),this.q=this.r.add(new c(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new v(3,0,this.h,P());this.p.write(i);const r=this.b.toArray();for(let a=0,w=r.length;a<w;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const r=this.b.peek();if(r&&r.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new v(6,0,0,P())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,w=r.length;a<w;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const r=++this.c;this.h=this.g;const a=new v(1,r,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const r=new v(2,0,0,i);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),r=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,w=Date.now()-this.n;if(r>=2e4&&a>=2e4&&w>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const g=Math.max(2e4-r,2e4-a,2e4-w,500);this.f=setTimeout(()=>{this.f=null,this.B()},g)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new v(3,0,this.h,P());this.p.write(i)}D(){this.h=this.g;const i=new v(9,0,this.h,P());this.p.write(i)}}e.$bh=n}),define(oe[93],ae([0,1,63,6,14,25,138,7,3,2,30,141,89,43]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=void 0;class $ extends h.$2g{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:S.Event.fromNodeEventEmitter(process,"message",u=>D.$Jb.wrap(Buffer.from(u,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$Ep=$;class v{constructor(l,u){this.i=l,this.j=u,this.c=new Set,this.g=new Map,this.h=new S.$7c,this.onDidProcessExit=this.h.event;const y=u&&u.timeout?u.timeout:6e4;this.b=new T.$qg(y),this.d=null,this.f=null}getChannel(l){const u=this;return{call(y,p,C){return u.k(l,y,p,C)},listen(y,p){return u.l(l,y,p)}}}k(l,u,y,p=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(p.isCancellationRequested)return Promise.reject(R.$4());this.b.cancel();const C=this.n(l),t=(0,T.$hg)(s=>C.call(u,y,s)),o=p.onCancellationRequested(()=>t.cancel()),n=(0,b.$jb)(()=>t.cancel());return this.c.add(n),t.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(l,u,y){if(!this.b)return S.Event.None;this.b.cancel();let p;const C=new S.$7c({onWillAddFirstListener:()=>{p=this.n(l).listen(u,y)(C.fire,C),this.c.add(p)},onDidRemoveLastListener:()=>{this.c.delete(p),p.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return C.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,P.$Fm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i)).filter(i=>!i.startsWith("--vscode-"))),(0,m.$el)(u.env),this.d=(0,I.fork)(this.i,l,u);const y=new S.$7c;S.Event.fromNodeEventEmitter(this.d,"message",i=>i)(i=>{if((0,L.$Ap)(i)){(0,L.log)(i,`IPC Library: ${this.j.serverName}`);return}y.fire(D.$Jb.wrap(Buffer.from(i,"base64")))});const C=this.j.useQueue?(0,E.$gl)(this.d):this.d,t=i=>this.d&&this.d.connected&&C.send(i.buffer.toString("base64")),o=y.event,n={send:t,onMessage:o};this.f=new h.$3g(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",i=>console.warn('IPC "'+this.j.serverName+'" errored with '+i)),this.d.on("exit",(i,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,b.$gb)(a)),this.c.clear(),i!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+i+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:i,signal:r})})}return this.f}n(l){let u=this.g.get(l);return u||(u=this.m.getChannel(l),this.g.set(l,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Fp=v}),define(oe[143],ae([0,1,131,14,43,3,11,21]),function(te,e,I,T,D,j,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xS=e.$wS=void 0;class S{constructor(m){this.a=m,this.onMessage=j.Event.fromNodeEventEmitter(this.a,"message",h=>T.$Jb.wrap(h.data)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class b extends D.$4g{static b(){(0,L.$se)((0,I.$vS)(process),"Electron Utility Process");const m=new j.$7c;return process.parentPort.on("message",h=>{const $=(0,R.$uf)(h.ports);$&&m.fire($)}),j.Event.map(m.event,h=>({protocol:new S(h),onDidClientDisconnect:j.Event.fromNodeEventEmitter(h,"close")}))}constructor(){super(b.b())}}e.$wS=b;function P(E,m,h){const $=v=>{v.data===m&&(E.removeListener("message",$),h())};E.on("message",$)}e.$xS=P}),define(oe[64],ae([0,1,6,3,2,62,11]),function(te,e,I,T,D,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.StorageState=e.$Do=e.StorageHint=void 0;var R;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function S(m){const h=m;return h?.changed instanceof Map||h?.deleted instanceof Set}e.$Do=S;var b;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(b||(e.StorageState=b={}));class P extends D.$lb{static{this.a=100}constructor(h,$=Object.create(null)){super(),this.m=h,this.n=$,this.b=this.B(new T.$0c),this.onDidChangeStorage=this.b.event,this.c=b.None,this.f=new Map,this.g=new I.$rg(P.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(h=>this.r(h)))}r(h){this.b.pause();try{h.changed?.forEach(($,v)=>this.s(v,$)),h.deleted?.forEach($=>this.s($,void 0))}finally{this.b.resume()}}s(h,$){if(this.c===b.Closed)return;let v=!1;(0,L.$re)($)?v=this.f.delete(h):this.f.get(h)!==$&&(this.f.set(h,$),v=!0),v&&this.b.fire({key:h,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===b.None&&(this.c=b.Initialized,this.n.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(h,$){const v=this.f.get(h);return(0,L.$re)(v)?$:v}getBoolean(h,$){const v=this.get(h);return(0,L.$re)(v)?$:v==="true"}getNumber(h,$){const v=this.get(h);return(0,L.$re)(v)?$:parseInt(v,10)}getObject(h,$){const v=this.get(h);return(0,L.$re)(v)?$:(0,j.$Vg)(v)}async set(h,$,v=!1){if(this.c===b.Closed)return;if((0,L.$re)($))return this.delete(h,v);const c=(0,L.$ke)($)||Array.isArray($)?(0,j.$Ug)($):String($);if(this.f.get(h)!==c)return this.f.set(h,c),this.j.set(h,c),this.h.delete(h),this.b.fire({key:h,external:v}),this.w()}async delete(h,$=!1){if(!(this.c===b.Closed||!this.f.delete(h)))return this.h.has(h)||this.h.add(h),this.j.delete(h),this.b.fire({key:h,external:$}),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=b.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const h={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(h).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(h){if(this.u)return this.w(h)}async w(h){return this.g.trigger(()=>this.v(),h)}async whenFlushed(){if(this.u)return new Promise(h=>this.l.push(h))}isInMemory(){return this.n.hint===R.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.$Eo=P;class E{constructor(){this.onDidChangeItemsExternal=T.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(h){h.insert?.forEach(($,v)=>this.a.set(v,$)),h.delete?.forEach($=>this.a.delete($))}async close(){}}e.$Fo=E}),define(oe[144],ae([12,9]),function(te,e){return te.create("vs/base/node/zip",e)}),define(oe[145],ae([12,9]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[146],ae([12,9]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[147],ae([12,9]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(oe[148],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[149],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[150],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[151],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[152],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[153],ae([12,9]),function(te,e){return te.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[154],ae([12,9]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[155],ae([12,9]),function(te,e){return te.create("vs/platform/files/common/fileService",e)}),define(oe[156],ae([12,9]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(oe[157],ae([12,9]),function(te,e){return te.create("vs/platform/files/common/io",e)}),define(oe[158],ae([12,9]),function(te,e){return te.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[159],ae([12,9]),function(te,e){return te.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[160],ae([12,9]),function(te,e){return te.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[161],ae([12,9]),function(te,e){return te.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[162],ae([12,9]),function(te,e){return te.create("vs/platform/request/common/request",e)}),define(oe[163],ae([12,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[164],ae([12,9]),function(te,e){return te.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[165],ae([12,9]),function(te,e){return te.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[166],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[167],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[168],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[169],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[170],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[171],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[172],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[173],ae([12,9]),function(te,e){return te.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[174],ae([12,9]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(oe[175],ae([0,1,7,147]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.TokenType=void 0;var D;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(D||(e.TokenType=D={}));function j(...b){switch(b.length){case 1:return(0,T.localize)(0,null,b[0]);case 2:return(0,T.localize)(1,null,b[0],b[1]);case 3:return(0,T.localize)(2,null,b[0],b[1],b[2]);default:return}}const L=(0,T.localize)(3,null),R=(0,T.localize)(4,null);class S{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,I.$6)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const E=this.d,m=this.c.substring(this.d,this.e),h={type:19,offset:this.d,lexeme:m};this.g.push({offset:E,lexeme:m,additionalInfo:P}),this.f.push(h)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const E=this.c.substring(this.d,this.e),m=S.b.get(E);m?this.k(m):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,E=!1,m=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(R);return}const $=this.c.charCodeAt(P);if(E)E=!1;else if($===47&&!m){P++;break}else $===91?m=!0:$===92?E=!0:$===93&&(m=!1);P++}for(;P<this.c.length&&S.a.has(this.c.charCodeAt(P));)P++;this.e=P;const h=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:h,offset:this.d})}r(){return this.e>=this.c.length}}e.$qi=S}),define(oe[176],ae([0,1,61,81,26,16,37,22,10]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ul=e.$Tl=e.$Sl=e.$Rl=void 0,e.$Rl=/^([^.]+\..+):(.+)$/;class b{get appRoot(){return(0,j.$dc)(D.$3e.asFileUri("").fsPath)}get userHome(){return S.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return S.URI.file((0,j.$ac)(this.userDataPath,"User"))}get tmpDir(){return S.URI.file(this.b.tmpDir)}get cacheHome(){return S.URI.file(this.userDataPath)}get stateResource(){return(0,R.$8f)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,R.$8f)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const h=(0,I.$Ql)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$ac)(this.userDataPath,"logs",h)}return S.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.$8f)(S.URI.file((0,j.$ac)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,R.$8f)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,R.$8f)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,R.$8f)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=L.env.VSCODE_PORTABLE;return h?S.URI.file((0,j.$ac)(h,"argv.json")):(0,R.$8f)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return S.URI.file((0,j.$ac)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,j.$bc)(h):(0,j.$$b)((0,j.$ac)(D.$3e.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const h=this.args["extensions-download-dir"];return h?S.URI.file((0,j.$bc)(h)):S.URI.file((0,j.$ac)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,j.$bc)(h);const $=L.env.VSCODE_EXTENSIONS;if($)return $;const v=L.env.VSCODE_PORTABLE;return v?(0,j.$ac)(v,"extensions"):(0,R.$8f)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map($=>/^[^:/?#]+?:\/\//.test($)?S.URI.parse($):S.URI.file((0,j.$$b)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?S.URI.parse(h):S.URI.file((0,j.$$b)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!L.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(h=>!e.$Rl.test(h))}get extensionLogLevel(){const h=[];for(const $ of this.args.log||[]){const v=e.$Rl.exec($);v&&v[1]&&v[2]&&h.push([v[1],v[2]])}return h.length?h:void 0}get serviceMachineIdResource(){return(0,R.$8f)(S.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const h=L.env.VSCODE_PORTABLE;return h?S.URI.file((0,j.$ac)(h,"policy.json")):(0,R.$8f)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(h){this.args.continueOn=h}get args(){return this.a}constructor(h,$,v){this.a=h,this.b=$,this.c=v,this.editSessionId=this.args.editSessionId}}e.$Sl=b,be([T.$Rg],b.prototype,"appRoot",null),be([T.$Rg],b.prototype,"userHome",null),be([T.$Rg],b.prototype,"userDataPath",null),be([T.$Rg],b.prototype,"appSettingsHome",null),be([T.$Rg],b.prototype,"tmpDir",null),be([T.$Rg],b.prototype,"cacheHome",null),be([T.$Rg],b.prototype,"stateResource",null),be([T.$Rg],b.prototype,"userRoamingDataHome",null),be([T.$Rg],b.prototype,"userDataSyncHome",null),be([T.$Rg],b.prototype,"sync",null),be([T.$Rg],b.prototype,"machineSettingsResource",null),be([T.$Rg],b.prototype,"workspaceStorageHome",null),be([T.$Rg],b.prototype,"localHistoryHome",null),be([T.$Rg],b.prototype,"keyboardLayoutResource",null),be([T.$Rg],b.prototype,"argvResource",null),be([T.$Rg],b.prototype,"isExtensionDevelopment",null),be([T.$Rg],b.prototype,"untitledWorkspacesHome",null),be([T.$Rg],b.prototype,"builtinExtensionsPath",null),be([T.$Rg],b.prototype,"extensionsPath",null),be([T.$Rg],b.prototype,"extensionDevelopmentLocationURI",null),be([T.$Rg],b.prototype,"extensionDevelopmentKind",null),be([T.$Rg],b.prototype,"extensionTestsLocationURI",null),be([T.$Rg],b.prototype,"debugExtensionHost",null),be([T.$Rg],b.prototype,"logLevel",null),be([T.$Rg],b.prototype,"extensionLogLevel",null),be([T.$Rg],b.prototype,"serviceMachineIdResource",null),be([T.$Rg],b.prototype,"disableTelemetry",null),be([T.$Rg],b.prototype,"disableWorkspaceTrust",null),be([T.$Rg],b.prototype,"policyFile",null);function P(m,h){return E(m["inspect-extensions"],m["inspect-brk-extensions"],5870,h,m.debugId,m.extensionEnvironment)}e.$Tl=P;function E(m,h,$,v,c,l){const y=Number(h||m)||(v?null:$),p=y?!!h:!1;let C;if(l)try{C=JSON.parse(l)}catch{}return{port:y,break:p,debugId:c,env:C}}e.$Ul=E}),function(){"use strict";function te(e,I,T){function D(L,R){const S=j(L,R),b=[S];return e.isAbsolute(S)||b.unshift(T),e.resolve(...b)}function j(L,R){process.env.VSCODE_DEV&&(R="code-oss-dev");const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,R);const P=L["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(E,"AppData","Roaming")}break;case"darwin":b=e.join(I.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,R)}return{getUserDataPath:D}}if(typeof define=="function")define(oe[177],ae([265,36,37]),function(e,I,T){return te(e,I,T.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),I=require("os");module.exports=te(e,I,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[178],ae([0,1,36,176,177]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xl=e.$Wl=e.$Vl=void 0;class j extends T.$Sl{constructor(b,P){super(b,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,D.getUserDataPath)(b,P.nameShort)},P)}}e.$Vl=j;function L(S,b){return(0,T.$Ul)(S["inspect-ptyhost"],S["inspect-brk-ptyhost"],5877,b,S.extensionEnvironment)}e.$Wl=L;function R(S,b){return(0,T.$Ul)(S["inspect-sharedprocess"],S["inspect-brk-sharedprocess"],5879,b,S.extensionEnvironment)}e.$Xl=R}),define(oe[179],ae([0,1,11,150]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=void 0;function D(L,R,S){try{j(L,R,S)}catch(b){console.error(b?.message??b)}return L}e.$ap=D;function j(L,R,S){const b=(P,E,m)=>{const h=P[E];if((0,I.$ie)(h)){const $=h,v=$.length;if(v>1&&$[0]==="%"&&$[v-1]==="%"){const c=$.substr(1,v-2);let l=R[c];l===void 0&&S&&(l=S[c]);const u=typeof l=="string"?l:l?.message,y=S?.[c],p=typeof y=="string"?y:y?.message;if(!u){p||console.warn(`[${L.name}]: ${(0,T.localize)(0,null,c)}`);return}if(m&&(E==="title"||E==="category")&&p&&p!==u){const C={value:u,original:p};P[E]=C}else P[E]=u}}else if((0,I.$ke)(h))for(const $ in h)h.hasOwnProperty($)&&($==="commands"?b(h,$,!0):b(h,$,m));else if(Array.isArray(h))for(let $=0;$<h.length;$++)b(h,$,m)};for(const P in L)L.hasOwnProperty(P)&&b(L,P)}}),define(oe[180],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$25b=e.$15b=void 0;class I{constructor(j){this.a=j}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(j){return this.a.call("promptImportantExtensionsInstallNotification",[j])}promptWorkspaceRecommendations(j){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$15b=I;class T{constructor(j){this.a=j}listen(j,L){throw new Error(`Event not found: ${L}`)}call(j,L,R){switch(L){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(R[0])}throw new Error(`Call not found: ${L}`)}}e.$25b=T}),define(oe[65],ae([0,1,22,88,154,53]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,R=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||L.test(l)}e.$po=S;function b(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(L);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.$qo=b;function P(l){if(!l)return null;const u=l.majorBase,y=l.majorMustEqual,p=l.minorBase;let C=l.minorMustEqual;const t=l.patchBase;let o=l.patchMustEqual;l.hasCaret&&(u===0||(C=!1),o=!1);let n=0;if(l.preRelease){const s=R.exec(l.preRelease);if(s){const[,i,r,a]=s;n=Date.UTC(Number(i),Number(r)-1,Number(a))}}return{majorBase:u,majorMustEqual:y,minorBase:p,minorMustEqual:C,patchBase:t,patchMustEqual:o,isMinimum:l.hasGreaterEquals,notBefore:n}}e.$ro=P;function E(l,u,y){let p;typeof l=="string"?p=P(b(l)):p=l;let C;u instanceof Date?C=u.getTime():typeof u=="string"&&(C=new Date(u).getTime());let t;if(typeof y=="string"?t=P(b(y)):t=y,!p||!t)return!1;const o=p.majorBase,n=p.minorBase,s=p.patchBase;let i=t.majorBase,r=t.minorBase,a=t.patchBase;const w=t.notBefore;let g=t.majorMustEqual,f=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?o>i?!0:o<i?!1:n>r?!0:n<r||C&&C<w?!1:s>=a:(o===1&&i===0&&(!g||!f||!k)&&(i=1,r=0,a=0,g=!0,f=!1,k=!1),o<i?!1:o>i?!g:n<r?!1:n>r?!f:s<a?!1:s>a?!k:!(C&&C<w))}e.$so=E;function m(l,u,y,p,C){const t=[];if(typeof p.publisher<"u"&&typeof p.publisher!="string")return t.push([T.default.Error,D.localize(0,null)]),t;if(typeof p.name!="string")return t.push([T.default.Error,D.localize(1,null,"name")]),t;if(typeof p.version!="string")return t.push([T.default.Error,D.localize(2,null,"version")]),t;if(!p.engines)return t.push([T.default.Error,D.localize(3,null,"engines")]),t;if(typeof p.engines.vscode!="string")return t.push([T.default.Error,D.localize(4,null,"engines.vscode")]),t;if(typeof p.extensionDependencies<"u"&&!c(p.extensionDependencies))return t.push([T.default.Error,D.localize(5,null,"extensionDependencies")]),t;if(typeof p.activationEvents<"u"){if(!c(p.activationEvents))return t.push([T.default.Error,D.localize(6,null,"activationEvents")]),t;if(typeof p.main>"u"&&typeof p.browser>"u")return t.push([T.default.Error,D.localize(7,null,"activationEvents","main","browser")]),t}if(typeof p.extensionKind<"u"&&typeof p.main>"u"&&t.push([T.default.Warning,D.localize(8,null,"extensionKind")]),typeof p.main<"u"){if(typeof p.main!="string")return t.push([T.default.Error,D.localize(9,null,"main")]),t;{const s=(0,I.$8f)(y,p.main);(0,I.$2f)(s,y)||t.push([T.default.Warning,D.localize(10,null,s.path,y.path)])}}if(typeof p.browser<"u"){if(typeof p.browser!="string")return t.push([T.default.Error,D.localize(11,null,"browser")]),t;{const s=(0,I.$8f)(y,p.browser);(0,I.$2f)(s,y)||t.push([T.default.Warning,D.localize(12,null,s.path,y.path)])}}if(!j.valid(p.version))return t.push([T.default.Error,D.localize(13,null)]),t;const o=[];if(!h(l,u,p,C,o))for(const s of o)t.push([T.default.Error,s]);return t}e.$to=m;function h(l,u,y,p,C){return p||typeof y.main>"u"&&typeof y.browser>"u"?!0:v(l,u,y.engines.vscode,C)}e.$uo=h;function $(l,u,y){return l==="*"||v(u,y,l)}e.$vo=$;function v(l,u,y,p=[]){const C=P(b(y));if(!C)return p.push(D.localize(14,null,y)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return p.push(D.localize(15,null,y)),!1}else if(!C.majorMustEqual)return p.push(D.localize(16,null,y)),!1;return E(l,u,C)?!0:(p.push(D.localize(17,null,l,y)),!1)}function c(l){if(!Array.isArray(l))return!1;for(let u=0,y=l.length;u<y;u++)if(typeof l[u]!="string")return!1;return!0}}),define(oe[44],ae([0,1,14,32]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oo=void 0;async function D(j,L,R){let S=R&&R.get("storage.serviceMachineId",-1)||null;if(S)return S;try{const P=(await L.readFile(j.serviceMachineIdResource)).value.toString();S=(0,T.$4e)(P)?P:null}catch{S=null}if(!S){S=(0,T.$5e)();try{await L.writeFile(j.serviceMachineIdResource,I.$Jb.fromString(S))}catch{}}return R?.store("storage.serviceMachineId",S,-1,1),S}e.$Oo=D}),define(oe[66],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=void 0;class I{constructor(D,j=[],L=!1){this.ctor=D,this.staticArguments=j,this.supportsDelayedInstantiation=L}}e.$kh=I}),define(oe[181],ae([0,1,66]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.InstantiationType=void 0;const T=[];var D;(function(R){R[R.Eager=0]="Eager",R[R.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function j(R,S,b){S instanceof I.$kh||(S=new I.$kh(S,[],!!b)),T.push([R,S])}e.$0q=j;function L(){return T}e.$$q=L}),define(oe[182],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;class I{constructor(j,L){this.key=j,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Qp=I;class T{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const L of this.a.values())L.outgoing.size===0&&j.push(L);return j}insertEdge(j,L){const R=this.lookupOrInsertNode(j),S=this.lookupOrInsertNode(L);R.outgoing.set(S.key,S),S.incoming.set(R.key,R)}removeNode(j){const L=this.b(j);this.a.delete(L);for(const R of this.a.values())R.outgoing.delete(L),R.incoming.delete(L)}lookupOrInsertNode(j){const L=this.b(j);let R=this.a.get(L);return R||(R=new I(L,j),this.a.set(L,R)),R}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[L,R]of this.a)j.push(`${L}
	(-> incoming)[${[...R.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...R.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,L]of this.a){const R=new Set([j]),S=this.c(L,R);if(S)return S}}c(j,L){for(const[R,S]of j.outgoing){if(L.has(R))return[...L,R].join(" -> ");L.add(R);const b=this.c(S,L);if(b)return b;L.delete(R)}}}e.$Rp=T}),define(oe[4],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e._util=void 0;var I;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function R(S){return S[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=R})(I||(e._util=I={})),e.$mh=D("instantiationService");function T(L,R,S){R[I.DI_TARGET]===R?R[I.DI_DEPENDENCIES].push({id:L,index:S}):(R[I.DI_DEPENDENCIES]=[{id:L,index:S}],R[I.DI_TARGET]=R)}function D(L){if(I.serviceIds.has(L))return I.serviceIds.get(L);const R=function(S,b,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(R,S,P)};return R.toString=()=>L,I.serviceIds.set(L,R),R}e.$nh=D;function j(L){return L}e.$oh=j}),define(oe[183],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x5b=void 0,e.$x5b=(0,I.$nh)("checksumService")}),define(oe[18],ae([0,1,11,10,4]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.ConfigurationTarget=e.$Vh=e.$Uh=e.$Th=void 0,e.$Th=(0,D.$nh)("configurationService");function j(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof T.URI)}e.$Uh=j;function L(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof T.URI)}e.$Vh=L;var R;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(R||(e.ConfigurationTarget=R={}));function S(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Wh=S;function b(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$Xh=b;function P(l,u){const y=Object.create(null);for(const p in l)E(y,p,l[p],u);return y}e.$Yh=P;function E(l,u,y,p){const C=u.split("."),t=C.pop();let o=l;for(let n=0;n<C.length;n++){const s=C[n];let i=o[s];switch(typeof i){case"undefined":i=o[s]=Object.create(null);break;case"object":break;default:p(`Ignoring ${u} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}o=i}if(typeof o=="object"&&o!==null)try{o[t]=y}catch{p(`Ignoring ${u} as ${C.join(".")} is ${JSON.stringify(o)}`)}else p(`Ignoring ${u} as ${C.join(".")} is ${JSON.stringify(o)}`)}e.$Zh=E;function m(l,u){const y=u.split(".");h(l,y)}e.$1h=m;function h(l,u){const y=u.shift();if(u.length===0){delete l[y];return}if(Object.keys(l).indexOf(y)!==-1){const p=l[y];typeof p=="object"&&!Array.isArray(p)&&(h(p,u),Object.keys(p).length===0&&delete l[y])}}function $(l,u,y){function p(o,n){let s=o;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const C=u.split("."),t=p(l,C);return typeof t>"u"?y:t}e.$2h=$;function v(l,u,y){Object.keys(u).forEach(p=>{p!=="__proto__"&&(p in l?I.$ke(l[p])&&I.$ke(u[p])?v(l[p],u[p],y):y&&(l[p]=u[p]):l[p]=u[p])})}e.$3h=v;function c(l){return l.replace(/[\[\]]/g,"")}e.$4h=c}),define(oe[94],ae([0,1,5,27,175,4,146,7]),function(te,e,I,T,D,j,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ContextKeyExprType=e.$ri=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",I.$j),S.set("isLinux",I.$k),S.set("isWindows",I.$i),S.set("isWeb",I.$o),S.set("isMacNative",I.$j&&!I.$o),S.set("isEdge",I.$G),S.set("isFirefox",I.$E),S.set("isChrome",I.$D),S.set("isSafari",I.$F);function b(A,d){if(S.get(A)!==void 0)throw(0,R.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");S.set(A,d)}e.$ri=b;const P=Object.prototype.hasOwnProperty;var E;(function(A){A[A.False=0]="False",A[A.True=1]="True",A[A.Defined=2]="Defined",A[A.Not=3]="Not",A[A.Equals=4]="Equals",A[A.NotEquals=5]="NotEquals",A[A.And=6]="And",A[A.Regex=7]="Regex",A[A.NotRegex=8]="NotRegex",A[A.Or=9]="Or",A[A.In=10]="In",A[A.NotIn=11]="NotIn",A[A.Greater=12]="Greater",A[A.GreaterEquals=13]="GreaterEquals",A[A.Smaller=14]="Smaller",A[A.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const m={regexParsingWithErrorRecovery:!0},h=(0,L.localize)(0,null),$=(0,L.localize)(1,null),v=(0,L.localize)(2,null),c=(0,L.localize)(3,null),l=(0,L.localize)(4,null),u=(0,L.localize)(5,null),y=(0,L.localize)(6,null),p=(0,L.localize)(7,null);class C{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(d=m){this.k=d,this.d=new D.$qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(d){if(d===""){this.h.push({message:h,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(d).scan(),this.g=0,this.h=[];try{const O=this.l();if(!this.E()){const z=this.D(),G=z.type===17?u:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:D.$qi.getLexeme(z),additionalInfo:G}),C.c}return O}catch(O){if(O!==C.c)throw O;return}}l(){return this.m()}m(){const d=[this.o()];for(;this.y(16);){const O=this.o();d.push(O)}return d.length===1?d[0]:t.or(...d)}o(){const d=[this.s()];for(;this.y(15);){const O=this.s();d.push(O)}return d.length===1?d[0]:t.and(...d)}s(){if(this.y(2)){const d=this.D();switch(d.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const O=this.l();return this.A(1,c),O?.negate()}case 17:return this.z(),N.create(d.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",d)}}return this.t()}t(){const d=this.D();switch(d.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const O=this.l();return this.A(1,c),O}case 17:{const O=d.lexeme;if(this.z(),this.y(9)){const G=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),G.type!==10)throw this.B("REGEX",G);const U=G.lexeme,X=U.lastIndexOf("/"),_=X===U.length-1?void 0:this.w(U.substring(X+1));let se;try{se=new RegExp(U.substring(1,X),_)}catch{throw this.B("REGEX",G)}return Q.create(O,se)}switch(G.type){case 10:case 19:{const U=[G.lexeme];this.z();let X=this.D(),_=0;for(let pe=0;pe<G.lexeme.length;pe++)G.lexeme.charCodeAt(pe)===40?_++:G.lexeme.charCodeAt(pe)===41&&_--;for(;!this.E()&&X.type!==15&&X.type!==16;){switch(X.type){case 0:_++;break;case 1:_--;break;case 10:case 18:for(let pe=0;pe<X.lexeme.length;pe++)X.lexeme.charCodeAt(pe)===40?_++:G.lexeme.charCodeAt(pe)===41&&_--}if(_<0)break;U.push(D.$qi.getLexeme(X)),this.z(),X=this.D()}const se=U.join(""),he=se.lastIndexOf("/"),ue=he===se.length-1?void 0:this.w(se.substring(he+1));let me;try{me=new RegExp(se.substring(1,he),ue)}catch{throw this.B("REGEX",G)}return t.regex(O,me)}case 18:{const U=G.lexeme;this.z();let X=null;if(!(0,T.$jd)(U)){const _=U.indexOf("/"),se=U.lastIndexOf("/");if(_!==se&&_>=0){const he=U.slice(_+1,se),ue=U[se+1]==="i"?"i":"";try{X=new RegExp(he,ue)}catch{throw this.B("REGEX",G)}}}if(X===null)throw this.B("REGEX",G);return Q.create(O,X)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const G=this.u();return t.notIn(O,G)}switch(this.D().type){case 3:{this.z();const G=this.u();if(this.x().type===18)return t.equals(O,G);switch(G){case"true":return t.has(O);case"false":return t.not(O);default:return t.equals(O,G)}}case 4:{this.z();const G=this.u();if(this.x().type===18)return t.notEquals(O,G);switch(G){case"true":return t.not(O);case"false":return t.has(O);default:return t.notEquals(O,G)}}case 5:return this.z(),q.create(O,this.u());case 6:return this.z(),J.create(O,this.u());case 7:return this.z(),F.create(O,this.u());case 8:return this.z(),W.create(O,this.u());case 13:return this.z(),t.in(O,this.u());default:return t.has(O)}}case 20:throw this.h.push({message:y,offset:d.offset,lexeme:"",additionalInfo:p}),C.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const d=this.D();switch(d.type){case 17:case 18:return this.z(),d.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(d){return d.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(d){return this.C(d)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(d,O){if(this.C(d))return this.z();throw this.B(O,this.D())}B(d,O,z){const G=(0,L.localize)(8,null,d,D.$qi.getLexeme(O)),U=O.offset,X=D.$qi.getLexeme(O);return this.h.push({message:G,offset:U,lexeme:X,additionalInfo:z}),C.c}C(d){return this.D().type===d}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$si=C;class t{static false(){return i.INSTANCE}static true(){return r.INSTANCE}static has(d){return a.create(d)}static equals(d,O){return w.create(d,O)}static notEquals(d,O){return k.create(d,O)}static regex(d,O){return Q.create(d,O)}static in(d,O){return g.create(d,O)}static notIn(d,O){return f.create(d,O)}static not(d){return N.create(d)}static and(...d){return x.create(d,null,!0)}static or(...d){return H.create(d,null,!0)}static greater(d,O){return F.create(d,O)}static greaterEquals(d,O){return W.create(d,O)}static smaller(d,O){return q.create(d,O)}static smallerEquals(d,O){return J.create(d,O)}static{this.c=new C({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this.c.parse(d)}}e.$ti=t;function o(A){const d=new C({regexParsingWithErrorRecovery:!1});return A.map(O=>(d.parse(O),d.lexingErrors.length>0?d.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,L.localize)(9,null,z.additionalInfo):(0,L.localize)(10,null),offset:z.offset,length:z.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$ui=o;function n(A,d){const O=A?A.substituteConstants():void 0,z=d?d.substituteConstants():void 0;return!O&&!z?!0:!O||!z?!1:O.equals(z)}e.$vi=n;function s(A,d){return A.cmp(d)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return r.INSTANCE}}e.$wi=i;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return i.INSTANCE}}e.$xi=r;class a{static create(d,O=null){const z=S.get(d);return typeof z=="boolean"?z?r.INSTANCE:i.INSTANCE:new a(d,O)}constructor(d,O){this.key=d,this.c=O,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:V(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=S.get(this.key);return typeof d=="boolean"?d?r.INSTANCE:i.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$yi=a;class w{static create(d,O,z=null){if(typeof O=="boolean")return O?a.create(d,z):N.create(d,z);const G=S.get(d);return typeof G=="boolean"?O===(G?"true":"false")?r.INSTANCE:i.INSTANCE:new w(d,O,z)}constructor(d,O,z){this.c=d,this.d=O,this.f=z,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=S.get(this.c);if(typeof d=="boolean"){const O=d?"true":"false";return this.d===O?r.INSTANCE:i.INSTANCE}return this}evaluate(d){return d.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(d){return d.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$zi=w;class g{static create(d,O){return new g(d,O)}constructor(d,O){this.d=d,this.f=O,this.type=10,this.c=null}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.d,this.f,d.d,d.f)}equals(d){return d.type===this.type?this.d===d.d&&this.f===d.f:!1}substituteConstants(){return this}evaluate(d){const O=d.getValue(this.f),z=d.getValue(this.d);return Array.isArray(O)?O.includes(z):typeof z=="string"&&typeof O=="object"&&O!==null?P.call(O,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(d){return d.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.$Ai=g;class f{static create(d,O){return new f(d,O)}constructor(d,O){this.d=d,this.f=O,this.type=11,this.c=g.create(d,O)}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(d){return d.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Bi=f;class k{static create(d,O,z=null){if(typeof O=="boolean")return O?N.create(d,z):a.create(d,z);const G=S.get(d);return typeof G=="boolean"?O===(G?"true":"false")?i.INSTANCE:r.INSTANCE:new k(d,O,z)}constructor(d,O,z){this.c=d,this.d=O,this.f=z,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=S.get(this.c);if(typeof d=="boolean"){const O=d?"true":"false";return this.d===O?i.INSTANCE:r.INSTANCE}return this}evaluate(d){return d.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(d){return d.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Ci=k;class N{static create(d,O=null){const z=S.get(d);return typeof z=="boolean"?z?i.INSTANCE:r.INSTANCE:new N(d,O)}constructor(d,O){this.c=d,this.d=O,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:V(this.c,d.c)}equals(d){return d.type===this.type?this.c===d.c:!1}substituteConstants(){const d=S.get(this.c);return typeof d=="boolean"?d?i.INSTANCE:r.INSTANCE:this}evaluate(d){return!d.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(d){return d.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Di=N;function M(A,d){if(typeof A=="string"){const O=parseFloat(A);isNaN(O)||(A=O)}return typeof A=="string"||typeof A=="number"?d(A):i.INSTANCE}class F{static create(d,O,z=null){return M(O,G=>new F(d,G,z))}constructor(d,O,z){this.c=d,this.d=O,this.f=z,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Ei=F;class W{static create(d,O,z=null){return M(O,G=>new W(d,G,z))}constructor(d,O,z){this.c=d,this.d=O,this.f=z,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Fi=W;class q{static create(d,O,z=null){return M(O,G=>new q(d,G,z))}constructor(d,O,z){this.c=d,this.d=O,this.f=z,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Gi=q;class J{static create(d,O,z=null){return M(O,G=>new J(d,G,z))}constructor(d,O,z){this.c=d,this.d=O,this.f=z,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:ee(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Hi=J;class Q{static create(d,O){return new Q(d,O)}constructor(d,O){this.d=d,this.f=O,this.type=7,this.c=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.d<d.d)return-1;if(this.d>d.d)return 1;const O=this.f?this.f.source:"",z=d.f?d.f.source:"";return O<z?-1:O>z?1:0}equals(d){if(d.type===this.type){const O=this.f?this.f.source:"",z=d.f?d.f.source:"";return this.d===d.d&&O===z}return!1}substituteConstants(){return this}evaluate(d){const O=d.getValue(this.d);return this.f?this.f.test(O):!1}serialize(){const d=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${d}`}keys(){return[this.d]}map(d){return d.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$Ii=Q;class Y{static create(d){return new Y(d)}constructor(d){this.c=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(d){return new Y(this.c.map(d))}negate(){return this.c}}e.$Ji=Y;function Z(A){let d=null;for(let O=0,z=A.length;O<z;O++){const G=A[O].substituteConstants();if(A[O]!==G&&d===null){d=[];for(let U=0;U<O;U++)d[U]=A[U]}d!==null&&(d[O]=G)}return d===null?A:d}class x{static create(d,O,z){return x.d(d,O,z)}constructor(d,O){this.expr=d,this.c=O,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const G=s(this.expr[O],d.expr[O]);if(G!==0)return G}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(d.expr[O]))return!1;return!0}return!1}substituteConstants(){const d=Z(this.expr);return d===this.expr?this:x.create(d,this.c,!1)}evaluate(d){for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].evaluate(d))return!1;return!0}static d(d,O,z){const G=[];let U=!1;for(const X of d)if(X){if(X.type===1){U=!0;continue}if(X.type===0)return i.INSTANCE;if(X.type===6){G.push(...X.expr);continue}G.push(X)}if(G.length===0&&U)return r.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(s);for(let X=1;X<G.length;X++)G[X-1].equals(G[X])&&(G.splice(X,1),X--);if(G.length===1)return G[0];for(;G.length>1;){const X=G[G.length-1];if(X.type!==9)break;G.pop();const _=G.pop(),se=G.length===0,he=H.create(X.expr.map(ue=>x.create([ue,_],null,z)),null,se);he&&(G.push(he),G.sort(s))}if(G.length===1)return G[0];if(z){for(let X=0;X<G.length;X++)for(let _=X+1;_<G.length;_++)if(G[X].negate().equals(G[_]))return i.INSTANCE;if(G.length===1)return G[0]}return new x(G,O)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const O of this.expr)d.push(...O.keys());return d}map(d){return new x(this.expr.map(O=>O.map(d)),null)}negate(){if(!this.c){const d=[];for(const O of this.expr)d.push(O.negate());this.c=H.create(d,this,!0)}return this.c}}e.$Ki=x;class H{static create(d,O,z){return H.d(d,O,z)}constructor(d,O){this.expr=d,this.c=O,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let O=0,z=this.expr.length;O<z;O++){const G=s(this.expr[O],d.expr[O]);if(G!==0)return G}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let O=0,z=this.expr.length;O<z;O++)if(!this.expr[O].equals(d.expr[O]))return!1;return!0}return!1}substituteConstants(){const d=Z(this.expr);return d===this.expr?this:H.create(d,this.c,!1)}evaluate(d){for(let O=0,z=this.expr.length;O<z;O++)if(this.expr[O].evaluate(d))return!0;return!1}static d(d,O,z){let G=[],U=!1;if(d){for(let X=0,_=d.length;X<_;X++){const se=d[X];if(se){if(se.type===0){U=!0;continue}if(se.type===1)return r.INSTANCE;if(se.type===9){G=G.concat(se.expr);continue}G.push(se)}}if(G.length===0&&U)return i.INSTANCE;G.sort(s)}if(G.length!==0){if(G.length===1)return G[0];for(let X=1;X<G.length;X++)G[X-1].equals(G[X])&&(G.splice(X,1),X--);if(G.length===1)return G[0];if(z){for(let X=0;X<G.length;X++)for(let _=X+1;_<G.length;_++)if(G[X].negate().equals(G[_]))return r.INSTANCE;if(G.length===1)return G[0]}return new H(G,O)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const O of this.expr)d.push(...O.keys());return d}map(d){return new H(this.expr.map(O=>O.map(d)),null)}negate(){if(!this.c){const d=[];for(const O of this.expr)d.push(O.negate());for(;d.length>1;){const O=d.shift(),z=d.shift(),G=[];for(const U of re(O))for(const X of re(z))G.push(x.create([U,X],null,!1));d.unshift(H.create(G,null,!1))}this.c=H.create(d,this,!0)}return this.c}}e.$Li=H;class B extends a{static{this.d=[]}static all(){return B.d.values()}constructor(d,O,z){super(d,null),this.f=O,typeof z=="object"?B.d.push({...z,key:d}):z!==!0&&B.d.push({key:d,description:z,type:O!=null?typeof O:void 0})}bindTo(d){return d.createKey(this.key,this.f)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return w.create(this.key,d)}notEqualsTo(d){return k.create(this.key,d)}}e.$Mi=B,e.$Ni=(0,j.$nh)("contextKeyService");function V(A,d){return A<d?-1:A>d?1:0}function ee(A,d,O,z){return A<O?-1:A>O?1:d<z?-1:d>z?1:0}function ne(A,d){if(A.type===0||d.type===1)return!0;if(A.type===9)return d.type===9?ce(A.expr,d.expr):!1;if(d.type===9){for(const O of d.expr)if(ne(A,O))return!0;return!1}if(A.type===6){if(d.type===6)return ce(d.expr,A.expr);for(const O of A.expr)if(ne(O,d))return!0;return!1}return A.equals(d)}e.$Oi=ne;function ce(A,d){let O=0,z=0;for(;O<A.length&&z<d.length;){const G=A[O].cmp(d[z]);if(G<0)return!1;G===0&&O++,z++}return O===A.length}function re(A){return A.type===9?A.expr:[A]}}),define(oe[95],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5l=e.$4l=e.$3l=e.ID=void 0,e.ID="diagnosticsService",e.$3l=(0,I.$nh)(e.ID);function T(j){return!!j.hostName&&!!j.errorMessage}e.$4l=T;class D{async getPerformanceInfo(L,R){return{}}async getSystemInfo(L,R){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(L,R){return""}async getWorkspaceFileExtensions(L){return{extensions:[]}}async reportWorkspaceStats(L){}}e.$5l=D}),define(oe[96],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sn=void 0,e.$sn=(0,I.$nh)("downloadService")}),define(oe[15],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=void 0,e.$uh=(0,I.$nh)("environmentService"),e.$vh=(0,I.$oh)(e.$uh)}),define(oe[29],ae([0,1,149,4]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Nn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0,e.$Bn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Cn=new RegExp(e.$Bn),e.$Dn="__web_extension",e.$En="skipWalkthrough",e.$Fn="extensionsSync";function D(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Gn=D;function j(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Hn=j;function L(u,y){switch(u){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$In=L;function R(u,y){return y==="web"&&!u.includes("web")}e.$Jn=R;function S(u,y,p){return R(y,p)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===p?!0:b(p).includes(u)}e.$Kn=S;function b(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Ln=b;function P(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.$Mn=P;var E;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var h;(function(u){u.Install="install",u.Uninstall="uninstall"})(h||(e.StatisticType=h={}));var $;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Nn=(0,T.$nh)("extensionGalleryService");var v;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var c;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class l extends Error{constructor(y,p){super(y),this.code=p,this.name=p}}e.$On=l,e.$Pn=(0,T.$nh)("extensionManagementService"),e.$Qn="extensionsIdentifiers/disabled",e.$Rn="extensionsIdentifiers/enabled",e.$Sn=(0,T.$nh)("IGlobalExtensionEnablementService"),e.$Tn=(0,T.$nh)("IExtensionTipsService"),e.$Un=(0,I.localize)(0,null),e.$Vn={value:e.$Un,original:"Extensions"},e.$Wn={value:(0,I.localize)(1,null),original:"Preferences"}}),define(oe[184],ae([0,1,3,2,30,10,91,29]),function(te,e,I,T,D,j,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yo=e.$Xo=e.$Wo=void 0;function S(c,l){return c?j.URI.revive(l?l.transformIncoming(c):c):void 0}function b(c,l){return l?l.transformOutgoingURI(c):c}function P(c,l){l=l||L.$mm;const u=c.manifest;return{...(0,L.$pm)({...c,manifest:void 0},l),manifest:u}}function E(c,l){return c?.profileLocation?(0,L.$pm)(c,l??L.$mm):c}function m(c,l){return l?(0,D.$Hm)(c,u=>u instanceof j.URI?l.transformOutgoingURI(u):void 0):c}class h{constructor(l,u){this.a=l,this.b=u,this.onInstallExtension=I.Event.buffer(l.onInstallExtension,!0),this.onDidInstallExtensions=I.Event.buffer(l.onDidInstallExtensions,!0),this.onUninstallExtension=I.Event.buffer(l.onUninstallExtension,!0),this.onDidUninstallExtension=I.Event.buffer(l.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=I.Event.buffer(l.onDidUpdateExtensionMetadata,!0)}listen(l,u){const y=this.b(l);switch(u){case"onInstallExtension":return I.Event.map(this.onInstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,y):p.profileLocation}));case"onDidInstallExtensions":return I.Event.map(this.onDidInstallExtensions,p=>p.map(C=>({...C,local:C.local?m(C.local,y):C.local,profileLocation:C.profileLocation?b(C.profileLocation,y):C.profileLocation})));case"onUninstallExtension":return I.Event.map(this.onUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,y):p.profileLocation}));case"onDidUninstallExtension":return I.Event.map(this.onDidUninstallExtension,p=>({...p,profileLocation:p.profileLocation?b(p.profileLocation,y):p.profileLocation}));case"onDidUpdateExtensionMetadata":return I.Event.map(this.onDidUpdateExtensionMetadata,p=>m(p,y))}throw new Error("Invalid listen")}async call(l,u,y){const p=this.b(l);switch(u){case"zip":{const C=P(y[0],p),t=await this.a.zip(C);return b(t,p)}case"unzip":return this.a.unzip(S(y[0],p));case"install":return this.a.install(S(y[0],p),E(y[1],p));case"installFromLocation":return this.a.installFromLocation(S(y[0],p),S(y[1],p));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(y[0],S(y[1],p),S(y[2],p));case"getManifest":return this.a.getManifest(S(y[0],p));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(y[0]);case"installFromGallery":return this.a.installFromGallery(y[0],E(y[1],p));case"installGalleryExtensions":{const C=y[0];return this.a.installGalleryExtensions(C.map(({extension:t,options:o})=>({extension:t,options:E(o,p)??{}})))}case"uninstall":return this.a.uninstall(P(y[0],p),E(y[1],p));case"reinstallFromGallery":return this.a.reinstallFromGallery(P(y[0],p));case"getInstalled":return(await this.a.getInstalled(y[0],S(y[1],p))).map(t=>m(t,p));case"toggleAppliationScope":{const C=await this.a.toggleAppliationScope(P(y[0],p),S(y[1],p));return m(C,p)}case"copyExtensions":return this.a.copyExtensions(S(y[0],p),S(y[1],p));case"updateMetadata":{const C=await this.a.updateMetadata(P(y[0],p),y[1],S(y[2],p));return m(C,p)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(y[0],y[1],y[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Wo=h;class $ extends T.$lb{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(l){super(),this.k=l,this.c=this.B(new I.$7c),this.f=this.B(new I.$7c),this.g=this.B(new I.$7c),this.h=this.B(new I.$7c),this.j=this.B(new I.$7c),this.B(this.k.listen("onInstallExtension")(u=>this.l(this.c,{...u,source:this.m(u.source)?j.URI.revive(u.source):u.source,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(u=>this.l(this.f,u.map(y=>({...y,local:y.local?P(y.local,null):y.local,source:this.m(y.source)?j.URI.revive(y.source):y.source,profileLocation:j.URI.revive(y.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(u=>this.l(this.g,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(u=>this.l(this.h,{...u,profileLocation:j.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(P(u,null))))}l(l,u){l.fire(u)}m(l){return l?typeof l.path=="string"&&typeof l.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(l){const u=await this.getTargetPlatform();return l.allTargetPlatforms.some(y=>(0,R.$Kn)(y,l.allTargetPlatforms,u))}zip(l){return Promise.resolve(this.k.call("zip",[l]).then(u=>j.URI.revive(u)))}unzip(l){return Promise.resolve(this.k.call("unzip",[l]))}install(l,u){return Promise.resolve(this.k.call("install",[l,u])).then(y=>P(y,null))}installFromLocation(l,u){return Promise.resolve(this.k.call("installFromLocation",[l,u])).then(y=>P(y,null))}async installExtensionsFromProfile(l,u,y){return(await this.k.call("installExtensionsFromProfile",[l,u,y])).map(C=>P(C,null))}getManifest(l){return Promise.resolve(this.k.call("getManifest",[l]))}installFromGallery(l,u){return Promise.resolve(this.k.call("installFromGallery",[l,u])).then(y=>P(y,null))}async installGalleryExtensions(l){return(await this.k.call("installGalleryExtensions",[l])).map(y=>({...y,local:y.local?P(y.local,null):y.local,source:this.m(y.source)?j.URI.revive(y.source):y.source,profileLocation:j.URI.revive(y.profileLocation)}))}uninstall(l,u){return Promise.resolve(this.k.call("uninstall",[l,u]))}reinstallFromGallery(l){return Promise.resolve(this.k.call("reinstallFromGallery",[l])).then(u=>P(u,null))}getInstalled(l=null,u){return Promise.resolve(this.k.call("getInstalled",[l,u])).then(y=>y.map(p=>P(p,null)))}updateMetadata(l,u,y){return Promise.resolve(this.k.call("updateMetadata",[l,u,y])).then(p=>P(p,null))}toggleAppliationScope(l,u){return this.k.call("toggleAppliationScope",[l,u]).then(y=>P(y,null))}copyExtensions(l,u){return this.k.call("copyExtensions",[l,u])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(l,u,y){const p=await this.k.call("download",[l,u,y]);return j.URI.revive(p)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Xo=$;class v{constructor(l){this.a=l}listen(l,u){throw new Error("Invalid listen")}call(l,u,y){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(j.URI.revive(y[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Yo=v}),define(oe[97],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=void 0,e.$To=(0,I.$nh)("IExtensionSignatureVerificationService");class T{b(){return this.a||(this.a=new Promise((j,L)=>te(["node-vsce-sign"],async R=>j(R),L))),this.a}async verify(j,L,R){let S;try{S=await this.b()}catch{return!1}return S.verify(j,L,R)}}e.$Uo=T}),define(oe[98],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RSb=e.RecommendationsNotificationResult=e.$QSb=e.RecommendationSource=void 0;var T;(function(L){L[L.FILE=1]="FILE",L[L.WORKSPACE=2]="WORKSPACE",L[L.EXE=3]="EXE"})(T||(e.RecommendationSource=T={}));function D(L){switch(L){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$QSb=D;var j;(function(L){L.Ignored="ignored",L.Cancelled="cancelled",L.TooMany="toomany",L.IncompatibleWindow="incompatibleWindow",L.Accepted="reacted"})(j||(e.RecommendationsNotificationResult=j={})),e.$RSb=(0,I.$nh)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,47,16,27,11,10,156,4,5,26]),function(te,e,I,T,D,j,L,R,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.FileKind=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileOperationResult=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileChangeType=e.$8j=e.FileOperation=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.FileSystemProviderErrorCode=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Rj=e.$Qj=void 0,e.$Qj=(0,S.$nh)("fileService");function E(V){return V.create===!0}e.$Rj=E;var m;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var h;(function(V){V[V.Readonly=1]="Readonly",V[V.Locked=2]="Locked"})(h||(e.FilePermission=h={}));var $;(function(V){V[V.None=0]="None",V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileAtomicWrite=32768]="FileAtomicWrite",V[V.FileAtomicDelete=65536]="FileAtomicDelete",V[V.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function v(V){return!!(V.capabilities&2)}e.$Sj=v;function c(V){return!!(V.capabilities&8)}e.$Tj=c;function l(V){return!!(V.capabilities&131072)}e.$Uj=l;function u(V){return!!(V.capabilities&4)}e.$Vj=u;function y(V){return!!(V.capabilities&16)}e.$Wj=y;function p(V){return v(V)?!!(V.capabilities&16384):!1}e.$Xj=p;function C(V){return v(V)?!!(V.capabilities&32768):!1}e.$Yj=C;function t(V){return!!(V.capabilities&65536)}e.$Zj=t;function o(V){return!!(V.capabilities&2048)}e.$1j=o;var n;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsStorageQuota="EntryExceedsStorageQuota",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(ee,ne){const ce=new s(ee.toString(),ne);return a(ce,ne),ce}constructor(ee,ne){super(ee),this.code=ne}}e.$2j=s;function i(V,ee){return s.create(V,ee)}e.$3j=i;function r(V){return V||i((0,R.localize)(0,null),n.Unknown)}e.$4j=r;function a(V,ee){return V.name=ee?`${ee} (FileSystemError)`:"FileSystemError",V}e.$5j=a;function w(V){if(!V)return n.Unknown;if(V instanceof s)return V.code;const ee=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!ee)return n.Unknown;switch(ee[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$6j=w;function g(V){if(V instanceof W)return V.fileOperationResult;switch(w(V)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$7j=g;var f;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(f||(e.FileOperation=f={}));class k{constructor(ee,ne,ce){this.resource=ee,this.operation=ne,this.target=ce}isOperation(ee){return this.operation===ee}}e.$8j=k;var N;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(N||(e.FileChangeType=N={}));class M{constructor(ee,ne){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ce=new Map;for(const re of ee){const A=ce.get(re.type);switch(A?A.push([re.resource,re]):ce.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,A]of ce)switch(re){case 1:this.a=I.$th.forUris(()=>ne),this.a.fill(A);break;case 0:this.b=I.$th.forUris(()=>ne),this.b.fill(A);break;case 2:this.c=I.$th.forUris(()=>ne),this.c.fill(A);break}}contains(ee,...ne){return this.d(ee,{includeChildren:!1},...ne)}affects(ee,...ne){return this.d(ee,{includeChildren:!0},...ne)}d(ee,ne,...ce){if(!ee)return!1;const re=ce.length>0;return!!((!re||ce.includes(1))&&(this.a?.get(ee)||ne.includeChildren&&this.a?.findSuperstr(ee))||(!re||ce.includes(0))&&(this.b?.get(ee)||ne.includeChildren&&this.b?.findSuperstr(ee))||(!re||ce.includes(2))&&(this.c?.findSubstr(ee)||ne.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$9j=M;function F(V,ee,ne){return!V||!ee||V===ee||ee.length>V.length?!1:(ee.charAt(ee.length-1)!==T.sep&&(ee+=T.sep),ne?(0,D.$Md)(V,ee):V.indexOf(ee)===0)}e.$0j=F;class W extends Error{constructor(ee,ne,ce){super(ee),this.fileOperationResult=ne,this.options=ce}}e.$$j=W;class q extends W{constructor(ee,ne,ce,re){super(ee,ne,re),this.fileOperationResult=ne,this.size=ce}}e.$_j=q;class J extends W{constructor(ee,ne,ce){super(ee,2,ce),this.stat=ne}}e.$ak=J;var Q;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$bk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ck={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$dk="files.associations",e.$ek="files.exclude",e.$fk="files.readonlyInclude",e.$gk="files.readonlyExclude",e.$hk="files.readonlyFromPermissions";var Y;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$ik="";function Z(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.$jk=Z;async function x(V,ee){if(!ee.hasProvider(L.URI.from({scheme:V.scheme})))return new Promise(ne=>{const ce=ee.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===V.scheme&&re.added&&(ce.dispose(),ne())})})}e.$kk=x;class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(ee){return(0,j.$me)(ee)||(ee=0),ee<H.KB?(0,R.localize)(1,null,ee.toFixed(0)):ee<H.MB?(0,R.localize)(2,null,(ee/H.KB).toFixed(2)):ee<H.GB?(0,R.localize)(3,null,(ee/H.MB).toFixed(2)):ee<H.TB?(0,R.localize)(4,null,(ee/H.GB).toFixed(2)):(0,R.localize)(5,null,(ee/H.TB).toFixed(2))}}e.$lk=H;function B(V){const ee=typeof V=="string"||V?.scheme===P.Schemas.vscodeRemote;return typeof V!="string"&&V?.scheme===P.Schemas.file?1024*H.MB:ee?10*H.MB:b.$o?50*H.MB:1024*H.MB}e.$mk=B});var K=this&&this.__param||function(te,e){return function(I,T){e(I,T,te)}};define(oe[185],ae([0,1,67,42,13]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y5b=void 0;let j=class{constructor(R){this.a=R}async checksum(R){const S=(await this.a.readFileStream(R)).value;return new Promise((b,P)=>{const E=(0,I.createHash)("md5");(0,T.$Bb)(S,{onData:m=>E.update(m.buffer),onError:m=>P(m),onEnd:()=>b(E.digest("base64").replace(/=+$/,""))})})}};e.$y5b=j,e.$y5b=j=be([K(0,D.$Qj)],j)}),define(oe[186],ae([0,1,14,38,7,3,2,42,10,32,13]),function(te,e,I,T,D,j,L,R,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FM=e.$EM=void 0,e.$EM="localFilesystem";class E extends L.$lb{constructor(h,$){super(),this.a=h,this.b=$,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$7c),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$7c),this.onDidWatchError=this.g.event,this.h=(0,b.$5e)(),this.i()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(h){return this.a.call("stat",[h])}readdir(h){return this.a.call("readdir",[h])}async readFile(h,$){const{buffer:v}=await this.a.call("readFile",[h,$]);return v}readFileStream(h,$,v){const c=(0,R.$xb)(u=>I.$Jb.concat(u.map(y=>I.$Jb.wrap(y))).buffer),l=this.a.listen("readFileStream",[h,$])(u=>{if(u instanceof I.$Jb)c.write(u.buffer);else{if(u==="end")c.end();else{let y;if(u instanceof Error)y=u;else{const p=u;y=(0,P.$3j)(p.message??(0,T.$$h)(p),p.code??P.FileSystemProviderErrorCode.Unknown)}c.error(y),c.end()}l.dispose()}});return v.onCancellationRequested(()=>{c.error((0,D.$4)()),c.end(),l.dispose()}),c}writeFile(h,$,v){return this.a.call("writeFile",[h,I.$Jb.wrap($),v])}open(h,$){return this.a.call("open",[h,$])}close(h){return this.a.call("close",[h])}async read(h,$,v,c,l){const[u,y]=await this.a.call("read",[h,$,l]);return v.set(u.buffer.slice(0,y),c),y}write(h,$,v,c,l){return this.a.call("write",[h,$,I.$Jb.wrap(v),c,l])}mkdir(h){return this.a.call("mkdir",[h])}delete(h,$){return this.a.call("delete",[h,$])}rename(h,$,v){return this.a.call("rename",[h,$,v])}copy(h,$,v){return this.a.call("copy",[h,$,v])}cloneFile(h,$){return this.a.call("cloneFile",[h,$])}i(){this.B(this.a.listen("fileChange",[this.h])(h=>{if(Array.isArray(h)){const $=h;this.f.fire($.map(v=>({resource:S.URI.revive(v.resource),type:v.type})))}else{const $=h;this.g.fire($)}}))}watch(h,$){const v=(0,b.$5e)();return this.a.call("watch",[this.h,v,h,$]),(0,L.$jb)(()=>this.a.call("unwatch",[this.h,v]))}}e.$FM=E}),define(oe[99],ae([0,1,14,7,157,13]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;async function L(P,E,m,h,$,v){let c;try{await R(P,E,m,h,$,v)}catch(l){c=l}finally{c&&$.errorTransformer&&(c=$.errorTransformer(c)),typeof c<"u"&&m.error(c),m.end()}}e.$pp=L;async function R(P,E,m,h,$,v){S(v);const c=await P.open(E,{create:!1});try{S(v);let l=0,u=0,y=$&&typeof $.length=="number"?$.length:void 0,p=I.$Jb.alloc(Math.min($.bufferSize,typeof y=="number"?y:$.bufferSize)),C=$&&typeof $.position=="number"?$.position:0,t=0;do u=await P.read(c,C,p.buffer,t,p.byteLength-t),C+=u,t+=u,l+=u,typeof y=="number"&&(y-=u),t===p.byteLength&&(await m.write(h(p)),p=I.$Jb.alloc(Math.min($.bufferSize,typeof y=="number"?y:$.bufferSize)),t=0);while(u>0&&(typeof y!="number"||y>0)&&S(v)&&b(l,$));if(t>0){let o=t;typeof y=="number"&&(o=Math.min(t,y)),m.write(h(p.slice(0,o)))}}catch(l){throw(0,j.$4j)(l)}finally{await P.close(c)}}function S(P){if(P.isCancellationRequested)throw(0,T.$4)();return!0}function b(P,E){if(typeof E?.limits?.size=="number"&&P>E.limits.size)throw(0,j.$3j)((0,D.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[54],ae([0,1,90,2,16,5,10,13]),function(te,e,I,T,D,j,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=void 0;function S(l){return l.recursive===!0}e.$rp=S;class b extends T.$lb{static{this.a=5}constructor(u,y,p,C){super(),this.h=u,this.i=y,this.j=p,this.k=C,this.c=this.B(new T.$mb),this.f=void 0,this.g=0}m(){const u=new T.$kb;this.c.value=u,this.b=this.l(u),this.b.setVerboseLogging(this.j),u.add(this.b.onDidChangeFile(y=>this.h(y))),u.add(this.b.onDidLogMessage(y=>this.i(y))),u.add(this.b.onDidError(y=>this.n(y)))}n(u){this.k.restartOnError?this.g<b.a&&this.f?(this.r(`restarting watcher after error: ${u}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${u}`):this.r(u)}p(u){this.g++,this.m(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.j=u,await this.b?.setVerboseLogging(u)}r(u){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${u}`})}s(u){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.$sp=b;class P extends b{constructor(u,y,p){super(u,y,p,{type:"node.js",restartOnError:!1})}}e.$tp=P;class E extends b{constructor(u,y,p){super(u,y,p,{type:"universal",restartOnError:!0})}}e.$up=E;function m(l){return l.map(u=>({type:u.type,resource:L.URI.file(u.path)}))}e.$vp=m;function h(l){const u=new c;for(const y of l)u.processEvent(y);return u.coalesce()}e.$wp=h;function $(l,u){return typeof u=="string"&&!u.startsWith(I.$$i)&&!(0,D.$_b)(u)?{base:l,pattern:u}:u}e.$xp=$;function v(l,u){const y=[];for(const p of u)y.push((0,I.$cj)($(l,p)));return y}e.$yp=v;class c{constructor(){this.a=new Set,this.b=new Map}c(u){return j.$k?u.path:u.path.toLowerCase()}processEvent(u){const y=this.b.get(this.c(u));let p=!1;if(y){const C=y.type,t=u.type;y.path!==u.path&&(u.type===2||u.type===1)?p=!0:C===1&&t===2?(this.b.delete(this.c(u)),this.a.delete(y)):C===2&&t===1?y.type=0:C===1&&t===0||(y.type=t)}else p=!0;p&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],y=[];return Array.from(this.a).filter(p=>p.type!==2?(u.push(p),!1):!0).sort((p,C)=>p.path.length-C.path.length).filter(p=>y.some(C=>(0,R.$0j)(p.path,C,!j.$k))?!1:(y.push(p.path),!0)).concat(u)}}}),define(oe[187],ae([0,1,52,6,25,48,2,86,16,5,140,31,54]),function(te,e,I,T,D,j,L,R,S,b,P,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=void 0;class h extends L.$lb{static{this.a=100}static{this.b=75}constructor(c,l,u,y){super(),this.j=c,this.k=l,this.l=u,this.m=y,this.c=this.B(new T.$Hg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},p=>this.k(p))),this.f=this.B(new T.$Gg(p=>this.u(p),h.b)),this.g=(0,m.$yp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,m.$yp)(this.j.path,this.j.includes):void 0,this.i=new D.$dd,this.ready=this.n()}async n(){try{const c=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const l=await E.Promises.stat(c);this.B(await this.s(c,l.isDirectory()))}catch(c){c.code!=="ENOENT"?this.w(c):this.z(c)}}async r(c){let l=c.path;try{l=await E.Promises.realpath(c.path),c.path===l&&(l=await(0,P.$Ip)(c.path)??c.path),c.path!==l&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${l})`)}catch{}return l}async s(c,l){if(b.$j&&(0,j.$Je)(c,"/Volumes/",!0))return this.w(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$lb.None;const u=new D.$dd(this.i.token),y=new L.$kb;try{const p=(0,S.$ec)(c),C=(0,I.watch)(c);y.add((0,L.$jb)(()=>{C.removeAllListeners(),C.close()})),this.z(`Started watching: '${c}'`);const t=new Set;if(l)try{for(const n of await E.Promises.readdir(c))t.add(n)}catch(n){this.w(n)}const o=new Map;y.add((0,L.$jb)(()=>{for(const[,n]of o)n.dispose();o.clear()})),C.on("error",(n,s)=>{this.w(`Failed to watch ${c} for changes using fs.watch() (${n}, ${s})`),this.dispose()}),C.on("change",(n,s)=>{if(u.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${s}`);let i="";if(s&&(i=s.toString(),b.$j&&(i=(0,R.$5k)(i))),!(!i||n!=="change"&&n!=="rename"))if(l)if(n==="rename"){o.get(i)?.dispose();const r=setTimeout(async()=>{if(o.delete(i),i===p&&!await E.Promises.exists(c)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,S.$ac)(c,i));if(u.token.isCancellationRequested)return;let w;a?t.has(i)?w=0:(w=1,t.add(i)):(t.delete(i),w=2),this.t({path:(0,S.$ac)(this.j.path,i),type:w})},h.a);o.set(i,(0,L.$jb)(()=>clearTimeout(r)))}else{let r;t.has(i)?r=0:(r=1,t.add(i)),this.t({path:(0,S.$ac)(this.j.path,i),type:r})}else if(n==="rename"||i!==p){const r=setTimeout(async()=>{const a=await E.Promises.exists(c);u.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),y.add(await this.s(c,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},h.a);y.clear(),y.add((0,L.$jb)(()=>clearTimeout(r)))}else this.t({path:this.j.path,type:0},!0)})}catch(p){await E.Promises.exists(c)&&!u.token.isCancellationRequested&&this.w(`Failed to watch ${c} for changes using fs.watch() (${p.toString()})`)}return(0,L.$jb)(()=>{u.dispose(!0),y.dispose()})}t(c,l=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!l&&this.g.some(u=>u(c.path))?this.m&&this.z(` >> ignored (excluded) ${c.path}`):!l&&this.h&&this.h.length>0&&!this.h.some(u=>u(c.path))?this.m&&this.z(` >> ignored (not included) ${c.path}`):this.f.work(c))}u(c){const l=(0,m.$wp)(c);if(l.length>0){if(this.m)for(const y of l)this.z(`>> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.path}`);this.c.work(l)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(c){if(b.$k)return E.Promises.exists(c);try{const l=(0,S.$ec)(c);return(await E.Promises.readdir((0,S.$dc)(c))).some(y=>y===l)}catch(l){return this.z(l),!1}}setVerboseLogging(c){this.m=c}w(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}y(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}z(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Lp=h;async function $(v,c,l,u,y=512){const p=await E.Promises.open(v,"r"),C=Buffer.allocUnsafe(y),t=new D.$dd(u);let o,n=!1;const s={path:v,excludes:[],recursive:!1},i=new h(s,r=>{(async()=>{for(const{type:a}of r)if(a===0){if(n)return;n=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:w}=await E.Promises.read(p,C,0,y,null);if(!w||t.token.isCancellationRequested)break;c(C.slice(0,w))}}catch(w){o=new Error(w),t.dispose(!0)}finally{n=!1}}})()});return await i.ready,l(),new Promise((r,a)=>{t.token.onCancellationRequested(async()=>{i.dispose();try{await E.Promises.close(p)}catch(w){o=new Error(w)}o?a(o):r()})})}e.$Mp=$}),define(oe[188],ae([0,1,3,90,2,5,187]),function(te,e,I,T,D,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class R extends D.$lb{constructor(){super(...arguments),this.a=this.B(new I.$7c),this.onDidChangeFile=this.a.event,this.b=this.B(new I.$7c),this.onDidLogMessage=this.b.event,this.onDidError=I.Event.None,this.c=new Map,this.f=!1}async watch(b){const P=this.i(b),E=P.filter(h=>{const $=this.c.get(h.path);return $?!(0,T.$gj)($.request.excludes,h.excludes)||!(0,T.$gj)($.request.includes,h.includes):!0}),m=Array.from(this.c.values()).filter(({request:h})=>!P.find($=>$.path===h.path&&(0,T.$gj)($.excludes,h.excludes)&&(0,T.$gj)($.includes,h.includes))).map(({request:h})=>h.path);E.length&&this.j(`Request to start watching: ${E.map(h=>`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const h of m)this.h(h);for(const h of E)this.g(h)}g(b){const P=new L.$Lp(b,m=>this.a.fire(m),m=>this.b.fire(m),this.f),E={request:b,instance:P};this.c.set(b.path,E)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const P=this.c.get(b);P&&(this.c.delete(b),P.instance.dispose())}i(b){const P=new Map;for(const E of b){const m=j.$k?E.path:E.path.toLowerCase();P.set(m,E)}return Array.from(P.values())}async setVerboseLogging(b){this.f=b;for(const[,P]of this.c)P.instance.setVerboseLogging(b)}j(b){this.f&&this.b.fire({type:"trace",message:this.k(b)})}k(b,P){return P?`[File Watcher (node.js)] ${b} (path: ${P.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$Np=R}),define(oe[189],ae([0,1,54,188]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;class D extends I.$tp{constructor(L,R,S){super(L,R,S),this.m()}l(){return new T.$Np}}e.$Op=D}),define(oe[190],ae([0,1,26,43,93,54]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;class L extends j.$up{constructor(S,b,P){super(S,b,P),this.m()}l(S){const b=S.add(new D.$Fp(I.$3e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return S.add(b.onDidProcessExit(({code:P,signal:E})=>this.n(`terminated by itself with code ${P}, signal: ${E}`))),T.ProxyChannel.toService((0,T.$7g)(b.getChannel("watcher")))}}e.$Gp=L}),define(oe[68],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=void 0;class I{constructor(...D){this.a=new Map;for(const[j,L]of D)this.set(j,L)}set(D,j){const L=this.a.get(D);return this.a.set(D,j),L}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$lh=I}),define(oe[191],ae([0,1,6,7,2,66,182,4,68,85]),function(te,e,I,T,D,j,L,R,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;const P=!1;class E extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class m{constructor(c=new S.$lh,l=!1,u,y=P){this.f=c,this.g=l,this.h=u,this.i=y,this.o=new Set,this.f.set(R.$mh,this),this._globalGraph=y?u?._globalGraph??new L.$Rp(p=>p):void 0}createChild(c){return new m(c,this.g,this,this.i)}invokeFunction(c,...l){const u=$.traceInvocation(this.i,c);let y=!1;try{return c({get:C=>{if(y)throw(0,T.$6)("service accessor is only valid during the invocation of its target method");const t=this.m(C,u);if(!t)throw new Error(`[invokeFunction] unknown service '${C}'`);return t}},...l)}finally{y=!0,u.stop()}}createInstance(c,...l){let u,y;return c instanceof j.$kh?(u=$.traceCreation(this.i,c.ctor),y=this.j(c.ctor,c.staticArguments.concat(l),u)):(u=$.traceCreation(this.i,c),y=this.j(c,l,u)),u.stop(),y}j(c,l=[],u){const y=R._util.getServiceDependencies(c).sort((t,o)=>t.index-o.index),p=[];for(const t of y){const o=this.m(t.id,u);o||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),p.push(o)}const C=y.length>0?y[0].index:l.length;if(l.length!==C){console.trace(`[createInstance] First service dependency of ${c.name} at position ${C+1} conflicts with ${l.length} static arguments`);const t=C-l.length;t>0?l=l.concat(new Array(t)):l=l.slice(0,C)}return Reflect.construct(c,l.concat(p))}k(c,l){if(this.f.get(c)instanceof j.$kh)this.f.set(c,l);else if(this.h)this.h.k(c,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const l=this.f.get(c);return!l&&this.h?this.h.l(c):l}m(c,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const u=this.l(c);return u instanceof j.$kh?this.q(c,u,l.branch(c,!0)):(l.branch(c,!1),u)}q(c,l,u){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,l,u)}finally{this.o.delete(c)}}r(c,l,u){const y=new L.$Rp(t=>t.id.toString());let p=0;const C=[{id:c,desc:l,_trace:u}];for(;C.length;){const t=C.pop();if(y.lookupOrInsertNode(t),p++>1e3)throw new E(y);for(const o of R._util.getServiceDependencies(t.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${c} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),n instanceof j.$kh){const s={id:o.id,desc:n,_trace:t._trace.branch(o.id,!0)};y.insertEdge(t,s),C.push(s)}}}for(;;){const t=y.roots();if(t.length===0){if(!y.isEmpty())throw new E(y);break}for(const{data:o}of t){if(this.l(o.id)instanceof j.$kh){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}y.removeNode(o)}}return this.l(c)}s(c,l,u=[],y,p){if(this.f.get(c)instanceof j.$kh)return this.t(c,l,u,y,p);if(this.h)return this.h.s(c,l,u,y,p);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t(c,l,u=[],y,p){if(y){const C=new m(void 0,this.g,this,this.i);C.c=String(c);const t=new Map,o=new I.$Jg(()=>{const n=C.j(l,u,p);for(const[s,i]of t){const r=n[s];if(typeof r=="function")for(const a of i)r.apply(n,a)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=t.get(s);return a||(a=new b.$lc,t.set(s,a)),(g,f,k)=>{const N=a.push([g,f,k]);return(0,D.$jb)(N)}}if(s in n)return n[s];const i=o.value;let r=i[s];return typeof r!="function"||(r=r.bind(i),n[s]=r),r},set(n,s,i){return o.value[s]=i,!0},getPrototypeOf(n){return l.prototype}})}else return this.j(l,u,p)}u(c,l){if(l&&console.warn(c),this.g)throw new Error(c)}}e.$Sp=m;var h;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(h||(h={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,l){return c?new $(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(c,l){return c?new $(1,l.name):$.c}static{this.f=0}constructor(c,l){this.type=c,this.name=l,this.g=Date.now(),this.h=[]}branch(c,l){const u=new $(3,c.toString());return this.h.push([c,l,u]),u}stop(){const c=Date.now()-this.g;$.f+=c;let l=!1;function u(p,C){const t=[],o=new Array(p+1).join("	");for(const[n,s,i]of C.h)if(s&&i){l=!0,t.push(`${o}CREATES -> ${n}`);const r=u(p+1,i);r&&t.push(r)}else t.push(`${o}uses -> ${n}`);return t.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(c>2||l)&&$.all.add(y.join(`
`))}}e.$Tp=$}),define(oe[69],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$94b=e.$84b=void 0,e.$84b=(0,I.$nh)("mainProcessService");class T{constructor(j,L){this.a=j,this.b=L}getChannel(j){return this.a.getChannel(j,this.b)}registerChannel(j,L){this.a.registerChannel(j,L)}}e.$94b=T}),define(oe[70],ae([0,1,25,2,5,159,29,4]),function(te,e,I,T,D,j,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=void 0;function S(P){return P.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$uq=S,e.$vq=(0,R.$nh)("languagePackService");let b=class extends T.$lb{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new I.$dd;setTimeout(()=>E.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const $=m.firstPage.filter(v=>v.properties.localizedLanguages?.length&&v.tags.some(c=>c.startsWith("lp-"))).map(v=>{const c=v.properties.localizedLanguages?.[0],l=S(v);return{...this.f(l,c,v),extensionId:v.identifier.id,galleryExtension:v}});return $.push(this.f("en","English")),$}f(E,m,h){const $=m??E;let v;if($!==E&&(v=`(${E})`),E.toLowerCase()===D.$v.toLowerCase()&&(v??="",v+=(0,j.localize)(0,null)),h?.installCount){v??="";const c=h.installCount;let l;c>1e6?l=`${Math.floor(c/1e5)/10}M`:c>1e3?l=`${Math.floor(c/1e3)}K`:l=String(c),v+=` $(cloud-download) ${l}`}return{id:E,label:$,description:v}}};e.$wq=b,e.$wq=b=be([K(0,L.$Nn)],b)}),define(oe[192],ae([0,1,2,70]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u5b=void 0;let D=class extends I.$lb{constructor(L){super(),this.a=L,this.b()}b(){this.a.update()}};e.$u5b=D,e.$u5b=D=be([K(0,T.$vq)],D)}),define(oe[8],ae([0,1,38,3,51,2,35,5,22,11,10,94,4]),function(te,e,I,T,D,j,L,R,S,b,P,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.log=e.$Si=e.LogLevel=e.$Ri=e.$Qi=e.$Pi=void 0,e.$Pi=(0,m.$nh)("logService"),e.$Qi=(0,m.$nh)("loggerService");function h(){return new Date().toISOString()}function $(g){return(0,b.$me)(g)}e.$Ri=$;var v;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(v||(e.LogLevel=v={})),e.$Si=v.Info;function c(g,f,k){switch(f){case v.Trace:g.trace(k);break;case v.Debug:g.debug(k);break;case v.Info:g.info(k);break;case v.Warning:g.warn(k);break;case v.Error:g.error(k);break;case v.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=c;function l(g,f=!1){let k="";for(let N=0;N<g.length;N++){let M=g[N];if(M instanceof Error&&(M=(0,I.$$h)(M,f)),typeof M=="object")try{M=JSON.stringify(M)}catch{}k+=(N>0?" ":"")+M}return k}class u extends j.$lb{constructor(){super(...arguments),this.b=e.$Si,this.c=this.B(new T.$7c),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==v.Off&&this.b<=f}}e.$Ui=u;class y extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...k){this.f(v.Trace)&&this.g(v.Trace,l([f,...k],!0))}debug(f,...k){this.f(v.Debug)&&this.g(v.Debug,l([f,...k]))}info(f,...k){this.f(v.Info)&&this.g(v.Info,l([f,...k]))}warn(f,...k){this.f(v.Warning)&&this.g(v.Warning,l([f,...k]))}error(f,...k){if(this.f(v.Error))if(f instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=f.stack,this.g(v.Error,l(N))}else this.g(v.Error,l([f,...k]))}flush(){}}e.$Vi=y;class p extends u{constructor(f=e.$Si){super(),this.setLevel(f),this.g=!R.$i}trace(f,...k){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...k):console.log(`[main ${h()}]`,f,...k))}debug(f,...k){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...k):console.log(`[main ${h()}]`,f,...k))}info(f,...k){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${h()}]\x1B[0m`,f,...k):console.log(`[main ${h()}]`,f,...k))}warn(f,...k){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${h()}]\x1B[0m`,f,...k):console.warn(`[main ${h()}]`,f,...k))}error(f,...k){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${h()}]\x1B[0m`,f,...k):console.error(`[main ${h()}]`,f,...k))}dispose(){}flush(){}}e.$Wi=p;class C extends u{constructor(f=e.$Si,k=!0){super(),this.g=k,this.setLevel(f)}trace(f,...k){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...k):console.log(f,...k))}debug(f,...k){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...k):console.log(f,...k))}info(f,...k){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...k):console.log(f,...k))}warn(f,...k){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...k):console.log(f,...k))}error(f,...k){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...k):console.error(f,...k))}dispose(){}flush(){}}e.$Xi=C;class t extends u{constructor(f,k=e.$Si){super(),this.g=f,this.setLevel(k)}trace(f,...k){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(f),...k])}debug(f,...k){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(f),...k])}info(f,...k){this.f(v.Info)&&this.g.log(v.Info,[this.h(f),...k])}warn(f,...k){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(f),...k])}error(f,...k){this.f(v.Error)&&this.g.log(v.Error,[this.h(f),...k])}h(f){return typeof f=="string"?f:(0,I.$$h)(f,this.f(v.Trace))}dispose(){}flush(){}}e.$Yi=t;class o extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const k of this.g)k.setLevel(f);super.setLevel(f)}trace(f,...k){for(const N of this.g)N.trace(f,...k)}debug(f,...k){for(const N of this.g)N.debug(f,...k)}info(f,...k){for(const N of this.g)N.info(f,...k)}warn(f,...k){for(const N of this.g)N.warn(f,...k)}error(f,...k){for(const N of this.g)N.error(f,...k)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.$Zi=o;class n extends j.$lb{constructor(f,k,N){if(super(),this.h=f,this.j=k,this.b=new L.$li,this.c=this.B(new T.$7c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$7c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$7c),this.onDidChangeVisibility=this.g.event,N)for(const M of N)this.b.set(M.resource,{logger:void 0,info:M})}k(f){return(0,b.$ie)(f)?[...this.b.values()].find(k=>k.info.id===f):this.b.get(f)}getLogger(f){return this.k(f)?.logger}createLogger(f,k){const N=this.l(f),M=(0,b.$ie)(f)?f:k?.id??(0,D.$bi)(N.toString()).toString(16);let F=this.b.get(N)?.logger;const W=k?.logLevel==="always"?v.Trace:k?.logLevel;F||(F=this.m(N,W??this.getLogLevel(N)??this.h,{...k,id:M}));const q={logger:F,info:{resource:N,id:M,logLevel:W,name:k?.name,hidden:k?.hidden,extensionId:k?.extensionId,when:k?.when}};return this.registerLogger(q.info),this.b.set(N,q),F}l(f){return(0,b.$ie)(f)?(0,S.$8f)(this.j,`${f}.log`):f}setLogLevel(f,k){if(P.URI.isUri(f)){const N=f,M=k,F=this.b.get(N);F&&M!==F.info.logLevel&&(F.info.logLevel=M===this.h?void 0:M,F.logger?.setLevel(M),this.b.set(F.info.resource,F),this.f.fire([N,M]))}else{this.h=f;for(const[N,M]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,k){const N=this.k(f);N&&k!==!N.info.hidden&&(N.info.hidden=!k,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,k]))}getLogLevel(f){let k;return f&&(k=this.b.get(f)?.info.logLevel),k??this.h}registerLogger(f){const k=this.b.get(f.resource);k?k.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const k=this.b.get(f);k&&(k.logger&&k.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[k.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.$1i=n;class s{constructor(){this.onDidChangeLogLevel=new T.$7c().event}setLevel(f){}getLevel(){return v.Info}trace(f,...k){}debug(f,...k){}info(f,...k){}warn(f,...k){}error(f,...k){}critical(f,...k){}dispose(){}flush(){}}e.$2i=s;class i extends s{}e.$3i=i;function r(g){if(g.verbose)return v.Trace;if(typeof g.logLevel=="string"){const f=w(g.logLevel.toLowerCase());if(f!==void 0)return f}return e.$Si}e.$4i=r;function a(g){switch(g){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.$5i=a;function w(g){switch(g){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.$6i=w,e.$7i=new E.$Mi("logLevel",a(v.Info))}),define(oe[193],ae([0,1,6,7,2,22,31,15,8]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v5b=void 0;let b=class extends D.$lb{constructor(E,m){super(),this.a=E,this.b=m,this.B(new I.$Eg(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,j.$5f)(this.a.logsHome),m=(0,j.$7f)(this.a.logsHome),v=(await L.Promises.readdir(m.fsPath)).filter(l=>/^\d{8}T\d{6}$/.test(l)).sort().filter(l=>l!==E),c=v.slice(0,Math.max(0,v.length-9));c.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${c.join(", ")}'`),await Promise.all(c.map(l=>L.Promises.rm((0,j.$8f)(m,l).fsPath))))}catch(E){(0,T.$Y)(E)}}};e.$v5b=b,e.$v5b=b=be([K(0,R.$uh),K(1,S.$Pi)],b)}),define(oe[194],ae([0,1,21,6,7,3,2,16,54,8]),function(te,e,I,T,D,j,L,R,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;class P extends L.$lb{constructor(m,h){super(),this.a=m,this.b=h,this.c=this.B(new j.$7c),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$7c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new T.$rg(0)),this.s=[],this.t=this.B(new T.$rg(0))}watch(m,h){return h.recursive||this.b?.watcher?.forceUniversal?this.l(m,h):this.u(m,h)}l(m,h){const $={path:this.C(m),excludes:h.excludes,includes:h.includes,recursive:h.recursive},v=(0,I.$Af)(this.j,$);return this.m(),(0,L.$jb)(()=>{v(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,D.$Y)(m))}n(){this.h||(this.h=this.B(this.p(h=>this.c.fire((0,S.$vp)(h)),h=>this.z(h),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const h of this.j)(0,S.$rp)(h)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const h of this.j)(0,S.$rp)(h)&&m.includes(h.path)&&(h.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,h){const $={path:this.C(m),excludes:h.excludes,includes:h.includes,recursive:!1},v=(0,I.$Af)(this.s,$);return this.v(),(0,L.$jb)(()=>{v(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,D.$Y)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,S.$vp)(m)),m=>this.z(m),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,R.$$b)(m.fsPath)}}e.$zp=P}),define(oe[195],ae([0,1,21,6,14,25,3,51,59,2,47,26,100,22,42,155,13,99,8,7]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qp=void 0;let p=class extends b.$lb{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new L.$7c),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new L.$7c),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new L.$7c),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new L.$7c),this.onDidRunOperation=this.m.event,this.R=this.B(new L.$7c),this.onDidFilesChange=this.R.event,this.S=this.B(new L.$7c),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new T.$Bg)}registerProvider(t,o){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${t}`);const n=new b.$kb;return this.h.set(t,o),this.c.fire({added:!0,scheme:t,provider:o}),n.add(o.onDidChangeFile(s=>this.R.fire(new c.$9j(s,!this.O(o))))),typeof o.onDidWatchError=="function"&&n.add(o.onDidWatchError(s=>this.S.fire(new Error(s)))),n.add(o.onDidChangeCapabilities(()=>this.g.fire({provider:o,scheme:t}))),(0,b.$jb)(()=>{this.c.fire({added:!1,scheme:t,provider:o}),this.h.delete(t),(0,b.$gb)(n)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const o=[];this.f.fire({scheme:t,join(n){o.push(n)}}),!this.h.has(t)&&await T.Promises.settled(o)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,o){const n=this.h.get(t.scheme);return!!(n&&n.capabilities&o)}listCapabilities(){return S.Iterable.map(this.h,([t,o])=>({scheme:t,capabilities:o.capabilities}))}async j(t){if(!(0,h.$_f)(t))throw new c.$$j((0,v.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const o=this.h.get(t.scheme);if(!o){const n=new y.$ab;throw n.message=(0,v.localize)(1,null,t.toString()),n}return o}async k(t){const o=await this.j(t);if((0,c.$Vj)(o)||(0,c.$Sj)(o)||(0,c.$Wj)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const o=await this.j(t);if((0,c.$Vj)(o)||(0,c.$Sj)(o))return o;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,o){try{return await this.n(t,o)}catch(n){throw(0,c.$6j)(n)===c.FileSystemProviderErrorCode.FileNotFound?new c.$$j((0,v.localize)(2,null,this.nb(t)),1):(0,c.$4j)(n)}}async n(t,o){const n=await this.j(t),s=this.O(n),i=o?.resolveTo,r=o?.resolveSingleChildDescendants,a=o?.resolveMetadata,w=await n.stat(t);let g;return this.p(n,t,w,void 0,!!a,(f,k)=>(g||(g=P.$th.forUris(()=>!s),g.set(t,!0),i&&g.fill(!0,i)),g.get(f.resource)||g.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&r?k===1:!1))}async p(t,o,n,s,i,r){const{providerExtUri:a}=this.N(t),w={resource:o,name:a.basename(o),isFile:(n.type&c.FileType.File)!==0,isDirectory:(n.type&c.FileType.Directory)!==0,isSymbolicLink:(n.type&c.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&c.FilePermission.Readonly)||!!(t.capabilities&2048),locked:!!((n.permissions??0)&c.FilePermission.Locked),etag:(0,c.$jk)({mtime:n.mtime,size:n.size}),children:void 0};if(w.isDirectory&&r(w,s)){try{const g=await t.readdir(o),f=await T.Promises.settled(g.map(async([k,N])=>{try{const M=a.joinPath(o,k),F=i?await t.stat(M):{type:N};return await this.p(t,M,F,g.length,i,r)}catch(M){return this.b.trace(M),null}}));w.children=(0,I.$lf)(f)}catch(g){this.b.trace(g),w.children=[]}return w}return w}async resolveAll(t){return T.Promises.settled(t.map(async o=>{try{return{stat:await this.n(o.resource,o.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(t){const o=await this.j(t),n=await o.stat(t);return this.p(o,t,n,void 0,!0,()=>!1)}async exists(t){const o=await this.j(t);try{return!!await o.stat(t)}catch{return!1}}async canCreateFile(t,o){try{await this.r(t,o)}catch(n){return n}return!0}async r(t,o){if(!o?.overwrite&&await this.exists(t))throw new c.$$j((0,v.localize)(3,null,this.nb(t)),3,o)}async createFile(t,o=D.$Jb.fromString(""),n){await this.r(t,n);const s=await this.writeFile(t,o);return this.m.fire(new c.$8j(t,0,s)),s}async writeFile(t,o,n){const s=this.lb(await this.l(t),t),{providerExtUri:i}=this.N(s);try{await this.s(s,t,n)||await this.P(s,i.dirname(t));let a;if((0,c.$Sj)(s)&&!(o instanceof D.$Jb))if((0,$.$vb)(o)){const w=await(0,$.$Cb)(o,3);w.ended?a=D.$Jb.concat(w.buffer):a=w}else a=(0,$.$zb)(o,w=>D.$Jb.concat(w),3);else a=o;if(!(0,c.$Vj)(s)||(0,c.$Sj)(s)&&a instanceof D.$Jb)await this.cb(s,t,n,a);else{const w=a instanceof D.$Jb?(0,D.$Ub)(a):a;n?.atomic!==!1&&n?.atomic?.postfix?await this.Y(s,t,(0,h.$8f)((0,h.$7f)(t),`${(0,h.$5f)(t)}${n.atomic.postfix}`),n,w):await this.Z(s,t,n,w)}this.m.fire(new c.$8j(t,4))}catch(r){throw new c.$$j((0,v.localize)(4,null,this.nb(t),(0,c.$4j)(r).toString()),(0,c.$7j)(r),n)}return this.resolve(t,{resolveMetadata:!0})}async s(t,o,n){const s=!!n?.unlock;if(s&&!(t.capabilities&8192))throw new Error((0,v.localize)(5,null,this.nb(o)));if(!!n?.atomic){if(!(t.capabilities&32768))throw new Error((0,v.localize)(6,null,this.nb(o)));if(s)throw new Error((0,v.localize)(7,null,this.nb(o)))}let r;try{r=await t.stat(o)}catch{return}if(r.type&c.FileType.Directory)throw new c.$$j((0,v.localize)(8,null,this.nb(o)),0,n);if(this.mb(o,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==c.$ik&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,c.$jk)({mtime:n.mtime,size:r.size}))throw new c.$$j((0,v.localize)(9,null),3,n);return r}async readFile(t,o,n){const s=await this.k(t);return o?.atomic?this.t(s,t,o,n):this.u(s,t,o,n)}async t(t,o,n,s){return new Promise((i,r)=>{this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,o,n,s);i(a)}catch(a){r(a)}})})}async u(t,o,n,s){const i=await this.v(t,o,{...n,preferUnbuffered:!0},s);return{...i,value:await(0,D.$Vb)(i.value)}}async readFileStream(t,o,n){const s=await this.k(t);return this.v(s,t,o,n)}async v(t,o,n,s){const i=new j.$dd(s),r=this.F(o,n).then(w=>w,w=>{throw i.cancel(),w});let a;try{return typeof n?.etag=="string"&&n.etag!==c.$ik&&await r,n?.atomic&&(0,c.$Xj)(t)||!((0,c.$Vj)(t)||(0,c.$Wj)(t))||(0,c.$Sj)(t)&&n?.preferUnbuffered?a=this.D(t,o,n):(0,c.$Wj)(t)?a=this.z(t,o,i.token,n):a=this.C(t,o,i.token,n),{...await r,value:a}}catch(w){throw a&&await(0,$.$Ab)(a),this.w(w,o,n)}}w(t,o,n){const s=(0,v.localize)(10,null,this.nb(o),(0,c.$4j)(t).toString());return t instanceof c.$ak?new c.$ak(s,t.stat,n):t instanceof c.$_j?new c.$_j(s,t.fileOperationResult,t.size,t.options):new c.$$j(s,(0,c.$7j)(t),n)}z(t,o,n,s=Object.create(null)){const i=t.readFileStream(o,s,n);return(0,$.$Gb)(i,{data:r=>r instanceof D.$Jb?r:D.$Jb.wrap(r),error:r=>this.w(r,o,s)},r=>D.$Jb.concat(r))}C(t,o,n,s=Object.create(null)){const i=(0,D.$Zb)();return(0,l.$pp)(t,o,i,r=>r,{...s,bufferSize:this.a,errorTransformer:r=>this.w(r,o,s)},n),i}D(t,o,n){const s=(0,$.$xb)(i=>D.$Jb.concat(i));return(async()=>{try{let i;n?.atomic&&(0,c.$Xj)(t)?i=await t.readFile(o,{atomic:!0}):i=await t.readFile(o),typeof n?.position=="number"&&(i=i.slice(n.position)),typeof n?.length=="number"&&(i=i.slice(0,n.length)),this.G(o,i.byteLength,n),s.end(D.$Jb.wrap(i))}catch(i){s.error(i),s.end()}})(),s}async F(t,o){const n=await this.resolve(t,{resolveMetadata:!0});if(n.isDirectory)throw new c.$$j((0,v.localize)(11,null,this.nb(t)),0,o);if(typeof o?.etag=="string"&&o.etag!==c.$ik&&o.etag===n.etag)throw new c.$ak((0,v.localize)(12,null),n,o);return this.G(t,n.size,o),n}G(t,o,n){if(typeof n?.limits?.size=="number"&&o>n.limits.size)throw new c.$_j((0,v.localize)(13,null,this.nb(t)),7,o,n)}async canMove(t,o,n){return this.H(t,o,"move",n)}async canCopy(t,o,n){return this.H(t,o,"copy",n)}async H(t,o,n,s){if(t.toString()!==o.toString())try{const i=n==="move"?this.lb(await this.l(t),t):await this.k(t),r=this.lb(await this.l(o),o);await this.M(i,t,r,o,n,s)}catch(i){return i}return!0}async move(t,o,n){const s=this.lb(await this.l(t),t),i=this.lb(await this.l(o),o),r=await this.I(s,t,i,o,"move",!!n),a=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new c.$8j(t,r==="move"?2:3,a)),a}async copy(t,o,n){const s=await this.k(t),i=this.lb(await this.l(o),o),r=await this.I(s,t,i,o,"copy",!!n),a=await this.resolve(o,{resolveMetadata:!0});return this.m.fire(new c.$8j(t,r==="copy"?3:2,a)),a}async I(t,o,n,s,i,r){if(o.toString()===s.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:w}=await this.M(t,o,n,s,i,r);if(a&&!w&&r&&await this.del(s,{recursive:!0}),await this.P(n,this.N(n).providerExtUri.dirname(s)),i==="copy"){if(t===n&&(0,c.$Tj)(t))await t.copy(o,s,{overwrite:r});else{const g=await this.resolve(o);g.isDirectory?await this.L(t,g,n,s):await this.J(t,o,n,s)}return i}else return t===n?(await t.rename(o,s,{overwrite:r}),i):(await this.I(t,o,n,s,"copy",r),await this.del(o,{recursive:!0}),"copy")}async J(t,o,n,s){if((0,c.$Vj)(t)&&(0,c.$Vj)(n))return this.eb(t,o,n,s);if((0,c.$Vj)(t)&&(0,c.$Sj)(n))return this.kb(t,o,n,s);if((0,c.$Sj)(t)&&(0,c.$Vj)(n))return this.ib(t,o,n,s);if((0,c.$Sj)(t)&&(0,c.$Sj)(n))return this.gb(t,o,n,s)}async L(t,o,n,s){await n.mkdir(s),Array.isArray(o.children)&&await T.Promises.settled(o.children.map(async i=>{const r=this.N(n).providerExtUri.joinPath(s,i.name);return i.isDirectory?this.L(t,await this.resolve(i.resource),n,r):this.J(t,i.resource,n,r)}))}async M(t,o,n,s,i,r){let a=!1;if(t===n){const{providerExtUri:g,isPathCaseSensitive:f}=this.N(t);if(f||(a=g.isEqual(o,s)),a&&i==="copy")throw new Error((0,v.localize)(14,null,this.nb(o),this.nb(s)));if(!a&&g.isEqualOrParent(s,o))throw new Error((0,v.localize)(15,null,this.nb(o),this.nb(s)))}const w=await this.exists(s);if(w&&!a){if(!r)throw new c.$$j((0,v.localize)(16,null,this.nb(o),this.nb(s)),4);if(t===n){const{providerExtUri:g}=this.N(t);if(g.isEqualOrParent(o,s))throw new Error((0,v.localize)(17,null,this.nb(o),this.nb(s)))}}return{exists:w,isSameResourceWithDifferentPathCase:a}}N(t){const o=this.O(t);return{providerExtUri:o?h.$Xf:h.$Zf,isPathCaseSensitive:o}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const o=this.lb(await this.j(t),t);await this.P(o,t);const n=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new c.$8j(t,0,n)),n}async P(t,o){const n=[],{providerExtUri:s}=this.N(t);for(;!s.isEqual(o,s.dirname(o));)try{if(!((await t.stat(o)).type&c.FileType.Directory))throw new Error((0,v.localize)(18,null,this.nb(o)));break}catch(i){if((0,c.$6j)(i)!==c.FileSystemProviderErrorCode.FileNotFound)throw i;n.push(s.basename(o)),o=s.dirname(o)}for(let i=n.length-1;i>=0;i--){o=s.joinPath(o,n[i]);try{await t.mkdir(o)}catch(r){if((0,c.$6j)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(t,o){try{await this.Q(t,o)}catch(n){return n}return!0}async Q(t,o){const n=this.lb(await this.j(t),t),s=!!o?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,v.localize)(19,null,this.nb(t)));const i=o?.atomic;if(i&&!(n.capabilities&65536))throw new Error((0,v.localize)(20,null,this.nb(t)));if(s&&i)throw new Error((0,v.localize)(21,null,this.nb(t)));let r;try{r=await n.stat(t)}catch{}if(r)this.mb(t,r);else throw new c.$$j((0,v.localize)(22,null,this.nb(t)),1);if(!!!o?.recursive){const w=await this.resolve(t);if(w.isDirectory&&Array.isArray(w.children)&&w.children.length>0)throw new Error((0,v.localize)(23,null,this.nb(t)))}return n}async del(t,o){const n=await this.Q(t,o),s=!!o?.useTrash,i=!!o?.recursive,r=o?.atomic??!1;await n.delete(t,{recursive:i,useTrash:s,atomic:r}),this.m.fire(new c.$8j(t,1))}async cloneFile(t,o){const n=await this.j(t),s=this.lb(await this.l(o),o);if(n===s&&this.N(n).providerExtUri.isEqual(t,o))return;if(n===s&&(0,c.$Uj)(n))return n.cloneFile(t,o);await this.P(s,this.N(s).providerExtUri.dirname(o));const i=this.X.queueFor(t,this.N(n).providerExtUri);return n===s&&(0,c.$Tj)(n)?i.queue(()=>n.copy(t,o,{overwrite:!0})):i.queue(()=>this.J(n,t,s,o))}watch(t,o={recursive:!1,excludes:[]}){const n=new b.$kb;let s=!1,i=()=>{s=!0};return n.add((0,b.$jb)(()=>i())),(async()=>{try{const r=await this.W(t,o);s?(0,b.$gb)(r):i=()=>(0,b.$gb)(r)}catch(r){this.b.error(r)}})(),n}async W(t,o){const n=await this.j(t),s=(0,R.$bi)([this.N(n).providerExtUri.getComparisonKey(t),o]);let i=this.U.get(s);return i||(i={count:0,disposable:n.watch(t,o)},this.U.set(s,i)),i.count+=1,(0,b.$jb)(()=>{i&&(i.count--,i.count===0&&((0,b.$gb)(i.disposable),this.U.delete(s)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,b.$gb)(t.disposable);this.U.clear()}async Y(t,o,n,s,i){await this.Z(t,n,s,i);try{await t.rename(n,o,{overwrite:!0})}catch(r){try{await t.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw r}}async Z(t,o,n,s){return this.X.queueFor(o,this.N(t).providerExtUri).queue(async()=>{const i=await t.open(o,{create:!0,unlock:n?.unlock??!1});try{(0,$.$vb)(s)||(0,$.$wb)(s)?await this.$(t,i,s):await this.ab(t,i,s)}catch(r){throw(0,c.$4j)(r)}finally{await t.close(i)}})}async $(t,o,n){let s=0,i;if((0,$.$wb)(n)){if(n.buffer.length>0){const r=D.$Jb.concat(n.buffer);await this.bb(t,o,r,r.byteLength,s,0),s+=r.byteLength}if(n.ended)return;i=n.stream}else i=n;return new Promise((r,a)=>{(0,$.$Bb)(i,{onData:async w=>{i.pause();try{await this.bb(t,o,w,w.byteLength,s,0)}catch(g){return a(g)}s+=w.byteLength,setTimeout(()=>i.resume())},onError:w=>a(w),onEnd:()=>r()})})}async ab(t,o,n){let s=0,i;for(;(i=n.read())!==null;)await this.bb(t,o,i,i.byteLength,s,0),s+=i.byteLength}async bb(t,o,n,s,i,r){let a=0;for(;a<s;){const w=await t.write(o,i+a,n.buffer,r+a,s-a);a+=w}}async cb(t,o,n,s){return this.X.queueFor(o,this.N(t).providerExtUri).queue(()=>this.db(t,o,n,s))}async db(t,o,n,s){let i;s instanceof D.$Jb?i=s:(0,$.$vb)(s)?i=await(0,D.$Vb)(s):(0,$.$wb)(s)?i=await(0,D.$Wb)(s):i=(0,D.$Tb)(s),await t.writeFile(o,i.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async eb(t,o,n,s){return this.X.queueFor(s,this.N(n).providerExtUri).queue(()=>this.fb(t,o,n,s))}async fb(t,o,n,s){let i,r;try{i=await t.open(o,{create:!1}),r=await n.open(s,{create:!0,unlock:!1});const a=D.$Jb.alloc(this.a);let w=0,g=0,f=0;do f=await t.read(i,w,a.buffer,g,a.byteLength-g),await this.bb(n,r,a,f,w,g),w+=f,g+=f,g===a.byteLength&&(g=0);while(f>0)}catch(a){throw(0,c.$4j)(a)}finally{await T.Promises.settled([typeof i=="number"?t.close(i):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async gb(t,o,n,s){return this.X.queueFor(s,this.N(n).providerExtUri).queue(()=>this.hb(t,o,n,s))}async hb(t,o,n,s){return n.writeFile(s,await t.readFile(o),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async ib(t,o,n,s){return this.X.queueFor(s,this.N(n).providerExtUri).queue(()=>this.jb(t,o,n,s))}async jb(t,o,n,s){const i=await n.open(s,{create:!0,unlock:!1});try{const r=await t.readFile(o);await this.bb(n,i,D.$Jb.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.$4j)(r)}finally{await n.close(i)}}async kb(t,o,n,s){const i=await(0,D.$Vb)(this.C(t,o,j.CancellationToken.None));await this.cb(n,s,void 0,i)}lb(t,o){if(t.capabilities&2048)throw new c.$$j((0,v.localize)(24,null,this.nb(o)),6);return t}mb(t,o){if((o.permissions??0)&c.FilePermission.Readonly)throw new c.$$j((0,v.localize)(25,null,this.nb(t)),6)}nb(t){return t.scheme===E.Schemas.file?t.fsPath:t.toString(!0)}};e.$qp=p,e.$qp=p=be([K(0,u.$Pi)],p)}),define(oe[196],ae([0,1,52,266,6,35,14,3,48,2,16,5,22,42,31,158,13,99,194,38,190,189]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0,(()=>{try{(0,T.gracefulify)(I)}catch(o){console.error(`Error enabling graceful-fs: ${(0,y.$$h)(o)}`)}})();class t extends u.$zp{static{this.D=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=R.Event.None,this.I=new j.$li(i=>m.$Yf.getComparisonKey(i)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,E.$k&&(this.F|=1024)),this.F}async stat(n){try{const{stat:s,symbolicLink:i}=await $.SymlinkSupport.stat(this.C(n));return{type:this.H(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:c.FilePermission.Locked}}catch(s){throw this.ab(s)}}async G(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await $.Promises.readdir(this.C(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.$8f)(n,r.name))).type:a=this.H(r),i.push([r.name,a])}catch(a){this.a.trace(a)}})),i}catch(s){throw this.ab(s)}}H(n,s){let i;return s?.dangling?i=c.FileType.Unknown:n.isFile()?i=c.FileType.File:n.isDirectory()?i=c.FileType.Directory:i=c.FileType.Unknown,s&&(i|=c.FileType.SymbolicLink),i}async J(n){const s=this.C(n);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.I.get(n);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const r=new D.$sg;return this.I.set(n,r),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,b.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.I.get(n)===r&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.I.delete(n)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),i=await this.J(n));const r=this.C(n);return await $.Promises.readFile(r)}catch(r){throw this.ab(r)}finally{i?.dispose()}}L(n){t.D&&this.a.trace(n)}readFileStream(n,s,i){const r=(0,h.$xb)(a=>L.$Jb.concat(a.map(w=>L.$Jb.wrap(w))).buffer);return(0,l.$pp)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},i),r}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix?this.M(n,(0,m.$8f)((0,m.$7f)(n),`${(0,m.$5f)(n)}${i.atomic.postfix}`),s,i):this.N(n,s,i)}async M(n,s,i,r){await this.N(s,i,r);try{await this.rename(s,n,{overwrite:!0})}catch(a){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw a}}async N(n,s,i){let r;try{const a=this.C(n);if(!i.create||!i.overwrite){if(await $.Promises.exists(a)){if(!i.overwrite)throw(0,c.$3j)((0,v.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,c.$3j)((0,v.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(n,{create:!0,unlock:i.unlock}),await this.write(r,0,s,0,s.byteLength)}catch(a){throw await this.bb(n,a)}finally{typeof r=="number"&&await this.close(r)}}static{this.R=!0}static configureFlushOnWrite(n){t.R=n}async open(n,s){const i=this.C(n);let r;(0,c.$Rj)(s)&&(r=await this.J(n));let a;try{if((0,c.$Rj)(s)&&s.unlock)try{const{stat:g}=await $.SymlinkSupport.stat(i);g.mode&128||await $.Promises.chmod(i,g.mode|128)}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}let w;if((0,c.$Rj)(s)){if(E.$i)try{await $.Promises.truncate(i,0),w="r+"}catch(g){g.code!=="ENOENT"&&this.a.trace(g)}w||(w="w")}else w="r";a=await $.Promises.open(i,w)}catch(w){throw r?.dispose(),(0,c.$Rj)(s)?await this.bb(n,w):this.ab(w)}if(this.O.set(a,0),(0,c.$Rj)(s)&&this.Q.set(a,n),r){const w=this.P.get(a);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${i})`),this.P.set(a,r),w&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${i})`),w.dispose())}return a}async close(n){const s=this.P.get(n);try{if(this.O.delete(n),this.Q.delete(n)&&t.R)try{await $.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await $.Promises.close(n)}catch(i){throw this.ab(i)}finally{s&&(this.P.get(n)===s&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.P.delete(n)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,r,a){const w=this.S(n,s);let g=null;try{g=(await $.Promises.read(n,i,r,a,w)).bytesRead}catch(f){throw this.ab(f)}finally{this.U(n,w,g)}return g}S(n,s){return s===this.O.get(n)?null:s}U(n,s,i){const r=this.O.get(n);typeof r=="number"&&(typeof s=="number"||(typeof i=="number"?this.O.set(n,r+i):this.O.delete(n)))}async write(n,s,i,r,a){return(0,D.$Kg)(()=>this.W(n,s,i,r,a),100,3)}async W(n,s,i,r,a){const w=this.S(n,s);let g=null;try{g=(await $.Promises.write(n,i,r,a,w)).bytesWritten}catch(f){throw await this.bb(this.Q.get(n),f)}finally{this.U(n,w,g)}return g}async mkdir(n){try{await $.Promises.mkdir(this.C(n))}catch(s){throw this.ab(s)}}async delete(n,s){try{const i=this.C(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,P.$ac)((0,P.$dc)(i),`${(0,P.$ec)(i)}${s.atomic.postfix}`)),await $.Promises.rm(i,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(i)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:w,symbolicLink:g}=await $.SymlinkSupport.stat(i);a=w.isDirectory()&&!g}catch{}if(a)await $.Promises.rmdir(i);else throw r}else throw r}}catch(i){throw this.ab(i)}}async rename(n,s,i){const r=this.C(n),a=this.C(s);if(r!==a)try{await this.X(n,s,"move",i.overwrite),await $.Promises.move(r,a)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,v.localize)(2,null,(0,P.$ec)(r),(0,P.$ec)((0,P.$dc)(a)),w.toString()))),this.ab(w)}}async copy(n,s,i){const r=this.C(n),a=this.C(s);if(r!==a)try{await this.X(n,s,"copy",i.overwrite),await $.Promises.copy(r,a,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,v.localize)(3,null,(0,P.$ec)(r),(0,P.$ec)((0,P.$dc)(a)),w.toString()))),this.ab(w)}}async X(n,s,i,r){const a=this.C(n),w=this.C(s);let g=!1;if(!!(this.capabilities&1024)||(g=(0,S.$Ie)(a,w,!0)),g){if(i==="copy")throw(0,c.$3j)((0,v.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const k=await this.G(n);if(!k)throw(0,c.$3j)((0,v.localize)(5,null),c.FileSystemProviderErrorCode.FileNotFound);const N=await this.G(s);if(N){if(!r)throw(0,c.$3j)((0,v.localize)(6,null),c.FileSystemProviderErrorCode.FileExists);k.type&c.FileType.File&&N.type&c.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.Y(n,s,!1)}async Y(n,s,i){const r=this.C(n),a=this.C(s),w=!!(this.capabilities&1024);if((0,S.$Ie)(r,a,!w))return;const g=new b.$kb;try{const[f,k]=await Promise.all([this.J(n),this.J(s)]);g.add(f),g.add(k),i&&await $.Promises.mkdir((0,P.$dc)(a),{recursive:!0}),await $.Promises.copyFile(r,a)}catch(f){if(f.code==="ENOENT"&&!i)return this.Y(n,s,!0);throw this.ab(f)}finally{g.dispose()}}p(n,s,i){return new p.$Gp(r=>n(r),r=>s(r),i)}y(n,s,i){return new C.$Op(r=>n(r),r=>s(r),i)}ab(n){if(n instanceof c.$2j)return n;let s=n,i;switch(n.code){case"ENOENT":i=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=c.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=c.FileSystemProviderErrorCode.Unknown;break;default:i=c.FileSystemProviderErrorCode.Unknown}return(0,c.$3j)(s,i)}async bb(n,s){let i=this.ab(s);if(n&&i.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.C(n));r.mode&128||(i=(0,c.$3j)(s,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return i}}e.$Pp=t}),define(oe[101],ae([0,1,3,2,4,8]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y5b=e.$X5b=void 0,e.$X5b=(0,D.$nh)("sharedProcessLifecycleService");let L=class extends T.$lb{constructor(S){super(),this.b=S,this.a=this.B(new I.$7c),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Y5b=L,e.$Y5b=L=be([K(0,j.$Pi)],L)}),define(oe[197],ae([0,1,10,3,8,2]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=void 0;class L extends D.$1i{constructor(E,m,h,$,v){super(m,h,$),this.n=E,this.p=v,this.B(v.listen("onDidChangeLogLevel",E)(c=>{(0,D.$Ri)(c)?super.setLogLevel(c):super.setLogLevel(I.URI.revive(c[0]),c[1])})),this.B(v.listen("onDidChangeVisibility",E)(([c,l])=>super.setVisibility(I.URI.revive(c),l))),this.B(v.listen("onDidChangeLoggers",E)(({added:c,removed:l})=>{for(const u of c)super.registerLogger({...u,resource:I.URI.revive(u.resource)});for(const u of l)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new D.$Yi({log:(E,m)=>{this.p.call("consoleLog",[E,m])}})}registerLogger(E){super.registerLogger(E),this.p.call("registerLogger",[E,this.n])}deregisterLogger(E){super.deregisterLogger(E),this.p.call("deregisterLogger",[E,this.n])}setLogLevel(E,m){super.setLogLevel(E,m),this.p.call("setLogLevel",[E,m])}setVisibility(E,m){super.setVisibility(E,m),this.p.call("setVisibility",[this.l(E),m])}m(E,m,h){return new R(this.p,E,m,h,this.n)}static setLogLevel(E,m,h){return E.call("setLogLevel",[m,h])}}e.$Lq=L;class R extends D.$Vi{constructor(E,m,h,$,v){super($?.logLevel==="always"),this.m=E,this.n=m,this.k=!1,this.l=[],this.setLevel(h),this.m.call("createLogger",[m,$,v]).then(()=>{this.r(this.l),this.k=!0})}g(E,m){const h=[[E,m]];this.k?this.r(h):this.l.push(...h)}r(E){this.m.call("log",[this.n,E])}}class S{constructor(E,m){this.a=E,this.b=m}listen(E,m){const h=this.b(E);switch(m){case"onDidChangeLoggers":return T.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(v=>this.c(v,h)),removed:[...$.removed].map(v=>this.c(v,h))}));case"onDidChangeVisibility":return T.Event.map(this.a.onDidChangeVisibility,$=>[h.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return T.Event.map(this.a.onDidChangeLogLevel,$=>(0,D.$Ri)($)?$:[h.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${m}`)}async call(E,m,h){const $=this.b(E);switch(m){case"setLogLevel":return(0,D.$Ri)(h[0])?this.a.setLogLevel(h[0]):this.a.setLogLevel(I.URI.revive($.transformIncoming(h[0][0])),h[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(v=>this.c(v,$)))}throw new Error(`Call not found: ${m}`)}c(E,m){return{...E,resource:m.transformOutgoingURI(E.resource)}}}e.$Mq=S;class b extends j.$lb{constructor(E,m){super(),m.call("setLogLevel",[E.getLogLevel()]),this.B(E.onDidChangeLogLevel(h=>m.call("setLogLevel",[h]))),m.call("getRegisteredLoggers").then(h=>{for(const $ of h)E.registerLogger({...$,resource:I.URI.revive($.resource)})}),this.B(m.listen("onDidChangeVisibility")(([h,$])=>E.setVisibility(I.URI.revive(h),$))),this.B(m.listen("onDidChangeLoggers")(({added:h,removed:$})=>{for(const v of h)E.registerLogger({...v,resource:I.URI.revive(v.resource)});for(const v of $)E.deregisterLogger(v.resource)}))}}e.$Nq=b}),define(oe[198],ae([0,1,2,8]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;class D extends I.$lb{constructor(L,R=[]){super(),this.a=new T.$Zi([L,...R]),this.B(L.onDidChangeLogLevel(S=>this.setLevel(S)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...R){this.a.trace(L,...R)}debug(L,...R){this.a.debug(L,...R)}info(L,...R){this.a.info(L,...R)}warn(L,...R){this.a.warn(L,...R)}error(L,...R){this.a.error(L,...R)}flush(){this.a.flush()}}e.$WM=D}),define(oe[55],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T3b=void 0,e.$T3b=(0,I.$nh)("nativeHostService")}),define(oe[56],ae([0,1,3,59,2,4]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vm=e.$Um=e.$Tm=void 0,e.$Tm=(0,j.$nh)("policy");class L extends D.$lb{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new I.$7c),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const P=Object.keys(this.f).length;return this.f={...b,...this.f},P!==Object.keys(this.f).length&&await this.i(b),T.Iterable.reduce(this.g.entries(),(E,[m,h])=>({...E,[m]:h}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return T.Iterable.reduce(Object.entries(this.f),(b,[P,E])=>({...b,[P]:{definition:E,value:this.g.get(P)}}),{})}}e.$Um=L;class R{constructor(){this.onDidChange=I.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Vm=R}),define(oe[199],ae([0,1,3,2,56]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I4b=e.$H4b=void 0;class j{constructor(S){this.b=S,this.a=new T.$kb}listen(S,b){switch(b){case"onDidChange":return I.Event.map(this.b.onDidChange,P=>P.reduce((E,m)=>({...E,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${b}`)}call(S,b,P){switch(b){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(P)}throw new Error(`Call not found: ${b}`)}dispose(){this.a.dispose()}}e.$H4b=j;class L extends D.$Um{constructor(S,b){super(),this.a=b;for(const P in S){const{definition:E,value:m}=S[P];this.f[P]=E,m!==void 0&&this.g.set(P,m)}this.a.listen("onDidChange")(P=>{for(const E in P){const m=P[E];m===null?this.g.delete(E):this.g.set(E,m)}this.h.fire(Object.keys(P))})}async i(S){const b=await this.a.call("updatePolicyDefinitions",S);for(const P in b)this.g.set(P,b[P])}}e.$I4b=L}),define(oe[102],ae([0,1,5,37]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let D;if(typeof I.$g.vscode<"u"&&typeof I.$g.vscode.context<"u"){const j=I.$g.vscode.context.configuration();if(j)D=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(D=globalThis._VSCODE_PRODUCT_JSON,T.env.VSCODE_DEV&&Object.assign(D,{nameShort:`${D.nameShort} Dev`,nameLong:`${D.nameLong} Dev`,dataFolderName:`${D.dataFolderName}-dev`,serverDataFolderName:D.serverDataFolderName?`${D.serverDataFolderName}-dev`:void 0}),!D.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(D,{version:j.version})}}else D={},Object.keys(D).length===0&&Object.assign(D,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=D}),define(oe[24],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=void 0,e.$8i=(0,I.$nh)("productService"),e.$9i="vscode://schemas/vscode-product"}),define(oe[200],ae([0,1,6,7,2,16,31,8,24]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s5b=void 0;let b=class extends D.$lb{constructor(E,m,h){super(),this.b=m,this.c=h,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this.B(new I.$Eg(()=>{this.f(E)},3e4)).schedule()}async f(E){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),h=(0,j.$dc)(E),$=(0,j.$ec)(E),v=await L.Promises.readdir(h);await Promise.all(v.map(async c=>{if(c===$)return;const l=(0,j.$ac)(h,c),u=await L.Promises.stat(l);if(u.isDirectory()&&m-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${c}.`),L.Promises.rm(l)}))}catch(m){(0,T.$Y)(m)}}};e.$s5b=b,e.$s5b=b=be([K(1,S.$8i),K(2,R.$Pi)],b)}),define(oe[201],ae([0,1,6,7,2,16,31,15,8,24]),function(te,e,I,T,D,j,L,R,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t5b=void 0;let P=class extends D.$lb{constructor(m,h,$){super(),this.b=m,this.c=h,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new I.$Eg(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),h=JSON.parse(await L.Promises.readFile((0,j.$ac)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(h)){const y=h[u];m[`${y.hash}.${u}`]=!0}const $=(0,j.$ac)(this.b.userDataPath,"clp");if(!await L.Promises.exists($))return;const c=await L.Promises.readdir($);for(const u of c){if(m[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await L.Promises.rm((0,j.$ac)($,u))}const l=Date.now();for(const u of Object.keys(m)){const y=(0,j.$ac)($,u),p=await L.Promises.readdir(y);for(const C of p){if(C==="tcf.json")continue;const t=(0,j.$ac)(y,C),o=await L.Promises.stat(t);o.isDirectory()&&l-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,j.$ac)(u,C)}`),await L.Promises.rm(t))}}}catch(m){(0,T.$Y)(m)}}};e.$t5b=P,e.$t5b=P=be([K(0,R.$vh),K(1,S.$Pi),K(2,b.$8i)],P)}),define(oe[202],ae([0,1,16,4]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$iF=void 0,e.$iF=(0,T.$nh)("IV8InspectProfilingService");var D;(function(j){function L(S){return!!(S.samples&&S.timeDeltas)}j.isValidProfile=L;function R(S,b="noAbsolutePaths"){for(const P of S.nodes)P.callFrame&&P.callFrame.url&&((0,I.$_b)(P.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(P.callFrame.url))&&(P.callFrame.url=(0,I.$ac)(b,(0,I.$ec)(P.callFrame.url)));return S}j.rewriteAbsolutePaths=R})(D||(e.Utils=D={}))}),define(oe[203],ae([0,1,32]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N5b=void 0;class T{constructor(){this.a=new Map}async startProfiling(j){const R=await(await new Promise((b,P)=>{te(["v8-inspect-profiler"],b,P)})).startProfiling({port:j.port,checkForPaused:!0}),S=(0,I.$5e)();return this.a.set(S,R),S}async stopProfiling(j){const L=this.a.get(j);if(!L)throw new Error(`UNKNOWN session '${j}'`);const R=await L.stop();return this.a.delete(j),R.profile}}e.$N5b=T}),define(oe[40],ae([0,1,123,11]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;class D{constructor(){this.a=new Map}add(L,R){I.ok(T.$ie(L)),I.ok(T.$ke(R)),I.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,R)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$Rm=new D}),define(oe[103],ae([0,1,3,40]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=void 0,e.$Sm={JSONContribution:"base.contributions.json"};function D(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class j{constructor(){this.b=new I.$7c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(S,b){this.a[D(S)]=b,this.b.fire(S)}notifySchemaChanged(S){this.b.fire(S)}getSchemaContributions(){return{schemas:this.a}}}const L=new j;T.$Rm.add(e.$Sm.JSONContribution,L)}),define(oe[49],ae([0,1,21,3,11,145,18,103,40]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.ConfigurationScope=e.$Wm=e.EditPresentationTypes=void 0;var b;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$Wm={Configuration:"base.contributions.configuration"};var P;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P||(e.ConfigurationScope=P={})),e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m="vscode://schemas/settings/resourceLanguage",e.$5m="vscode://schemas/settings/configurationDefaults";const E=S.$Rm.as(R.$Sm.JSONContribution);class m{constructor(){this.h=new Set,this.i=new T.$7c,this.onDidSchemaChange=this.i.event,this.j=new T.$7c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$4m,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const n=new Set;this.n(t,o,n),E.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const o=new Set;this.o(t,o),E.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const n=new Set;this.o(o,n),this.n(t,!1,n),E.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const n=[];for(const{overrides:s,source:i}of t)for(const r in s)if(o.add(r),e.$7m.test(r)){const a=this.a.get(r),w=a?.valuesSources??new Map;if(i)for(const N of Object.keys(s[r]))w.set(N,i);const g={...a?.value||{},...s[r]};this.a.set(r,{source:i,value:g,valuesSources:w});const f=(0,L.$4h)(r),k={type:"object",default:g,description:j.localize(1,null,f),$ref:e.$4m,defaultDefaultValue:g,source:D.$ie(i)?void 0:i,defaultValueSource:i};n.push(...v(r)),this.d[r]=k,this.b.properties[r]=k}else{this.a.set(r,{value:s[r],source:i});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:n,source:s}of t)for(const i in n){const r=this.a.get(i),a=D.$ie(s)?s:s?.id,w=D.$ie(r?.source)?r?.source:r?.source?.id;if(a===w)if(o.add(i),this.a.delete(i),e.$7m.test(i))delete this.d[i],delete this.b.properties[i];else{const g=this.d[i];g&&(this.w(i,g),this.r(i,g))}}this.u()}deltaConfiguration(t){let o=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,n){t.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(t,o){const n=s=>{if(s.properties)for(const i in s.properties){o.add(i);const r=this.d[i];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[i],this.s(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.c.indexOf(s);i!==-1&&this.c.splice(i,1)}}p(t,o=!0,n,s,i=3,r){i=D.$re(t.scope)?i:t.scope;const a=t.properties;if(a)for(const g in a){const f=a[g];if(o&&y(g,f)){delete a[g];continue}if(f.source=n,f.defaultDefaultValue=a[g].default,this.w(g,f),e.$7m.test(g)?f.scope=void 0:(f.scope=D.$re(f.scope)?i:f.scope,f.restricted=D.$re(f.restricted)?!!s?.includes(g):f.restricted),a[g].hasOwnProperty("included")&&!a[g].included){this.f[g]=a[g],delete a[g];continue}else this.d[g]=a[g],a[g].policy?.name&&this.e.set(a[g].policy.name,g);!a[g].deprecationMessage&&a[g].markdownDeprecationMessage&&(a[g].deprecationMessage=a[g].markdownDeprecationMessage),r.add(g)}const w=t.allOf;if(w)for(const g of w)this.p(g,o,n,s,i,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Xm.properties[t]=o,o.scope){case 1:e.$Ym.properties[t]=o;break;case 2:e.$Zm.properties[t]=o;break;case 6:e.$1m.properties[t]=o;break;case 3:e.$2m.properties[t]=o;break;case 4:e.$3m.properties[t]=o;break;case 5:e.$3m.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Xm.properties[t],o.scope){case 1:delete e.$Ym.properties[t];break;case 2:delete e.$Zm.properties[t];break;case 6:delete e.$1m.properties[t];break;case 3:delete e.$2m.properties[t];break;case 4:case 5:delete e.$3m.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,n={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$4m};this.w(o,n),e.$Xm.properties[o]=n,e.$Ym.properties[o]=n,e.$Zm.properties[o]=n,e.$1m.properties[o]=n,e.$2m.properties[o]=n,e.$3m.properties[o]=n}}v(){const t={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$4m};e.$Xm.patternProperties[e.$6m]=t,e.$Ym.patternProperties[e.$6m]=t,e.$Zm.patternProperties[e.$6m]=t,e.$1m.patternProperties[e.$6m]=t,e.$2m.patternProperties[e.$6m]=t,e.$3m.patternProperties[e.$6m]=t,this.i.fire()}w(t,o){const n=this.a.get(t);let s=n?.value,i=n?.source;D.$pe(s)&&(s=o.defaultDefaultValue,i=void 0),D.$pe(s)&&(s=l(o.type)),o.default=s,o.defaultValueSource=i}}const h="\\[([^\\]]+)\\]",$=new RegExp(h,"g");e.$6m=`^(${h})+$`,e.$7m=new RegExp(e.$6m);function v(C){const t=[];if(e.$7m.test(C)){let o=$.exec(C);for(;o?.length;){const n=o[1].trim();n&&t.push(n),o=$.exec(C)}}return(0,I.$qf)(t)}e.$8m=v;function c(C){return C.reduce((t,o)=>`${t}[${o}]`,"")}e.$9m=c;function l(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$0m=l;const u=new m;S.$Rm.add(e.$Wm.Configuration,u);function y(C,t){return C.trim()?e.$7m.test(C)?j.localize(7,null,C):u.getConfigurationProperties()[C]!==void 0?j.localize(8,null,C):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?j.localize(9,null,C,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:j.localize(6,null)}e.$$m=y;function p(){const C=[],t=u.getConfigurationProperties();for(const o of Object.keys(t))C.push([o,t[o].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.$_m=p}),define(oe[71],ae([0,1,21,3,34,2,35,30,11,10,18,49,40]),function(te,e,I,T,D,j,L,R,S,b,P,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function h(o){return Object.isFrozen(o)?o:R.$Gm(o)}class ${constructor(n={},s=[],i=[],r){this.b=n,this.c=s,this.d=i,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof $)return s;const i=new v("");return i.parseRaw(s),i.configurationModel});this.f=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,P.$2h)(this.contents,n):this.contents}inspect(n,s){const i=this.rawConfiguration.getValue(n),r=s?this.rawConfiguration.getOverrideValue(n,s):void 0,a=s?this.rawConfiguration.override(s).getValue(n):i;return{value:i,override:r,merged:a}}getOverrideValue(n,s){const i=this.i(s);return i?n?(0,P.$2h)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return I.$qf(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return I.$qf(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=R.$Fm(this.contents),i=R.$Fm(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const w of n)if(a.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.h(s,w.contents);for(const g of w.overrides){const[f]=i.filter(k=>I.$af(k.identifiers,g.identifiers));f?(this.h(f.contents,g.contents),f.keys.push(...g.keys),f.keys=I.$qf(f.keys)):i.push(R.$Fm(g))}for(const g of w.keys)r.indexOf(g)===-1&&r.push(g)}return new $(s,r,i,a.every(w=>w instanceof $)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const r of I.$qf([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const w=s[r];w&&(typeof a=="object"&&typeof w=="object"?(a=R.$Fm(a),this.h(a,w)):a=w),i[r]=a}return new $(i,this.keys,this.overrides)}h(n,s){for(const i of Object.keys(s)){if(i in n&&S.$ke(n[i])&&S.$ke(s[i])){this.h(n[i],s[i]);continue}n[i]=R.$Fm(s[i])}}i(n){let s=null,i=null;const r=a=>{a&&(i?this.h(i,a):i=R.$Fm(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,P.$1h)(this.contents,n),E.$7m.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>I.$af(i.identifiers,(0,E.$8m)(n))),1))}j(n,s,i){(0,P.$Zh)(this.contents,n,s,r=>console.error(r)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),E.$7m.test(n)&&this.overrides.push({identifiers:(0,E.$8m)(n),keys:Object.keys(this.contents[n]),contents:(0,P.$Yh)(this.contents[n],r=>console.error(r))})}}e.$an=$;class v{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!S.$re(n)){const i=this.g(n);this.parseRaw(i,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:i,keys:r,overrides:a,restricted:w,hasExcludedProperties:g}=this.h(n,s);this.b=new $(i,r,a,g?[n]:void 0),this.c=w||[]}g(n){let s={},i=null,r=[];const a=[],w=[];function g(k){Array.isArray(r)?r.push(k):i!==null&&(r[i]=k)}const f={onObjectBegin:()=>{const k={};g(k),a.push(r),r=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const k=[];g(k),a.push(r),r=k,i=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:g,onError:(k,N,M)=>{w.push({error:k,offset:N,length:M})}};if(n)try{D.$Cm(n,f),s=r[0]||{}}catch(k){console.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return s}h(n,s){const i=m.$Rm.as(E.$Wm.Configuration).getConfigurationProperties(),r=this.i(n,i,!0,s);n=r.raw;const a=(0,P.$Yh)(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),w=Object.keys(n),g=this.j(n,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:a,keys:w,overrides:g,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,i,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const w={},g=[];for(const f in n)if(E.$7m.test(f)&&i){const k=this.i(n[f],s,!1,r);w[f]=k.raw,a=a||k.hasExcludedProperties,g.push(...k.restricted)}else{const k=s[f],N=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&g.push(f),!r.exclude?.includes(f)&&(r.include?.includes(f)||(N===void 0||r.scopes===void 0||r.scopes.includes(N))&&!(r.skipRestricted&&k?.restricted))?w[f]=n[f]:a=!0}return{raw:w,restricted:g,hasExcludedProperties:a}}j(n,s){const i=[];for(const r of Object.keys(n))if(E.$7m.test(r)){const a={};for(const w in n[r])a[w]=n[r][w];i.push({identifiers:(0,E.$8m)(r),keys:Object.keys(a),contents:(0,P.$Yh)(a,s)})}return i}}e.$bn=v;class c extends j.$lb{constructor(n,s,i,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new T.$7c),this.onDidChange=this.b.event,this.a=new v(this.c.toString()),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$cn=c;class l{constructor(n,s,i,r,a,w,g,f,k,N,M,F,W){this.a=n,this.b=s,this.c=i,this.overrideIdentifiers=r,this.d=a,this.f=w,this.g=g,this.h=f,this.i=k,this.j=N,this.k=M,this.l=F,this.m=W}get value(){return h(this.c)}n(n,s,i){const r=n.inspect(s,i);return{get value(){return h(r.value)},get override(){return h(r.override)},get merged(){return h(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(n,s,i,r,a=new $,w=new $,g=new L.$li,f=new $,k=new L.$li){this.c=n,this.d=s,this.f=i,this.g=r,this.h=a,this.i=w,this.j=g,this.l=f,this.m=k,this.a=null,this.b=new L.$li,this.n=null}getValue(n,s,i){return this.q(n,s,i).getValue(n)}updateValue(n,s,i={}){let r;i.resource?(r=this.m.get(i.resource),r||(r=new $,this.m.set(i.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),i.resource||(this.a=null)}inspect(n,s,i){const r=this.q(n,s,i),a=this.u(s.resource,i),w=s.resource?this.m.get(s.resource)||this.l:this.l,g=new Set;for(const f of r.overrides)for(const k of f.identifiers)r.getOverrideValue(n,k)!==void 0&&g.add(k);return new l(n,s,r.getValue(n),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.i:void 0,a||void 0,w)}keys(n){const s=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:r,updated:a,removed:w}=C(this.c,n);s=[...r,...a,...w]}for(const r of s)for(const a of(0,E.$8m)(r)){const w=this.c.getKeysForOverrideIdentifier(a),g=n.getKeysForOverrideIdentifier(a),f=[...g.filter(k=>w.indexOf(k)===-1),...w.filter(k=>g.indexOf(k)===-1),...w.filter(k=>!R.$Jm(this.c.override(a).getValue(k),n.override(a).getValue(k)))];i.push([a,f])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:r}=C(this.d,n),a=[...s,...i,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=C(this.applicationConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateApplicationConfiguration(n),{keys:w,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=C(this.localUserConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateLocalUserConfiguration(n),{keys:w,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=C(this.remoteUserConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateRemoteUserConfiguration(n),{keys:w,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:r,overrides:a}=C(this.workspaceConfiguration,n),w=[...s,...i,...r];return w.length&&this.updateWorkspaceConfiguration(n),{keys:w,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const i=this.p.get(n),{added:r,updated:a,removed:w,overrides:g}=C(i,s),f=[...r,...a,...w];return(f.length||!i)&&this.updateFolderConfiguration(n,s),{keys:f,overrides:g}}compareAndDeleteFolderConfiguration(n){const s=this.p.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:r,removed:a,overrides:w}=C(s,void 0);return{keys:[...i,...r,...a],overrides:w}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,s,i){let r=this.r(s,i);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}r({resource:n},s){let i=this.s();if(s&&n){const r=s.getFolder(n);r&&(i=this.t(r.uri)||i);const a=this.m.get(n);a&&(i=i.merge(a))}return i}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let s=this.b.get(n);if(!s){const i=this.s(),r=this.j.get(n);r?(s=i.merge(r),this.b.set(n,s)):s=i}return s}u(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this.j.get(i.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:i,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:i,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}w(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.i.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.j.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.x(n.defaults),i=this.x(n.policy),r=this.x(n.application),a=this.x(n.user),w=this.x(n.workspace),g=n.folders.reduce((f,k)=>(f.set(b.URI.revive(k[0]),this.x(k[1])),f),new L.$li);return new u(s,i,r,a,new $,w,g,new $,new L.$li)}static x(n){return new $(n.contents,n.keys,n.overrides)}}e.$dn=u;function y(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,w])=>{const g=(0,L.$ii)(s,a,new Set);w.forEach(f=>g.add(f))});const i=[];return s.forEach((r,a)=>i.push([a,[...r.values()]])),{keys:[...n.values()],overrides:i}}e.$en=y;class p{constructor(n,s,i,r){this.change=n,this.f=s,this.g=i,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const w of a)this.affectedKeys.add(w);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(n,s){const i=this.a+n,r=this.d.indexOf(i);if(r<0)return!1;const a=r+i.length;if(a>=this.d.length)return!1;const w=this.d.charCodeAt(a);if(w!==this.b&&w!==this.c)return!1;if(s){const g=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,f=this.g.getValue(n,s,this.h);return!R.$Jm(g,f)}return!0}}e.$fn=p;function C(o,n){const{added:s,removed:i,updated:r}=t(n?.rawConfiguration,o?.rawConfiguration),a=[],w=o?.getAllOverrideIdentifiers()||[],g=n?.getAllOverrideIdentifiers()||[];if(n){const f=g.filter(k=>!w.includes(k));for(const k of f)a.push([k,n.getKeysForOverrideIdentifier(k)])}if(o){const f=w.filter(k=>!g.includes(k));for(const k of f)a.push([k,o.getKeysForOverrideIdentifier(k)])}if(n&&o){for(const f of w)if(g.includes(f)){const k=t({contents:o.getOverrideValue(void 0,f)||{},keys:o.getKeysForOverrideIdentifier(f)},{contents:n.getOverrideValue(void 0,f)||{},keys:n.getKeysForOverrideIdentifier(f)});a.push([f,[...k.added,...k.removed,...k.updated]])}}return{added:s,removed:i,updated:r,overrides:a}}function t(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],i=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const w=(0,P.$2h)(n.contents,a),g=(0,P.$2h)(o.contents,a);R.$Jm(w,g)||r.push(a)}}return{added:s,removed:i,updated:r}}}),define(oe[204],ae([0,1,21,3,2,30,11,71,49,8,56,40]),function(te,e,I,T,D,j,L,R,S,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$in=e.$hn=e.$gn=void 0;class m extends D.$lb{constructor(){super(...arguments),this.a=this.B(new T.$7c),this.onDidChangeConfiguration=this.a.event,this.b=new R.$an}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Rm.as(S.$Wm.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:l})=>this.c(Array.from(c),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,l){this.h(c,E.$Rm.as(S.$Wm.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new R.$an;const c=E.$Rm.as(S.$Wm.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,l){const u=this.f();for(const y of c){const p=u[y],C=l[y];p!==void 0?this.b.addValue(y,p):C?this.b.addValue(y,C.default):this.b.removeValue(y)}}}e.$gn=m;class h{constructor(){this.onDidChangeConfiguration=T.Event.None,this.configurationModel=new R.$an}async initialize(){return this.configurationModel}}e.$hn=h;let $=class extends D.$lb{get configurationModel(){return this.b}constructor(c,l,u){super(),this.c=c,this.f=l,this.g=u,this.a=this.B(new T.$7c),this.onDidChangeConfiguration=this.a.event,this.b=new R.$an}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const l={},u=[],y=E.$Rm.as(S.$Wm.Configuration).getConfigurationProperties();for(const p of c){const C=y[p];if(!C){u.push(p);continue}if(C.policy){if(C.type!=="string"&&C.type!=="number"){this.g.warn(`Policy ${C.policy.name} has unsupported type ${C.type}`);continue}u.push(p),l[C.policy.name]={type:C.type}}}return(0,L.$ve)(l)||await this.f.updatePolicyDefinitions(l),u}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const l=E.$Rm.as(S.$Wm.Configuration).getPolicyConfigurations(),u=(0,I.$lf)(c.map(y=>l.get(y)));this.j(u,!0)}j(c,l){this.g.trace("PolicyConfiguration#update",c);const u=E.$Rm.as(S.$Wm.Configuration).getConfigurationProperties(),y=[],p=this.b.isEmpty();for(const C of c){const t=u[C]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(p?o!==void 0:!(0,j.$Jm)(this.b.getValue(C),o))&&y.push([C,o])}else this.b.getValue(C)!==void 0&&y.push([C,void 0])}if(y.length){this.g.trace("PolicyConfiguration#changed",y);const C=this.b;this.b=new R.$an;for(const t of C.keys)this.b.setValue(t,C.getValue(t));for(const[t,o]of y)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);l&&this.a.fire(this.b)}}};e.$in=$,e.$in=$=be([K(1,P.$Tm),K(2,b.$Pi)],$)}),define(oe[205],ae([0,1,6,3,2,22,18,71,204,56]),function(te,e,I,T,D,j,L,R,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=void 0;class P extends D.$lb{constructor(m,h,$,v){super(),this.i=m,this.h=this.B(new T.$7c),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$gn),this.c=$ instanceof b.$Vm?new S.$hn:this.B(new S.$in(this.b,$,v)),this.f=this.B(new R.$cn(this.i,{},j.$Yf,h)),this.a=new R.$dn(this.b.configurationModel,this.c.configurationModel,new R.$an,new R.$an),this.g=this.B(new I.$Eg(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:l})=>this.k(c,l))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,h,$]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new R.$dn(m,h,new R.$an,$)}getConfigurationData(){return this.a.toData()}getValue(m,h){const $=typeof m=="string"?m:void 0,v=(0,L.$Uh)(m)?m:(0,L.$Uh)(h)?h:{};return this.a.getValue($,v,void 0)}updateValue(m,h,$,v){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const h=this.a.toData(),$=this.a.compareAndUpdateLocalUserConfiguration(m);this.m($,h,2)}k(m,h){const $=this.a.toData(),v=this.a.compareAndUpdateDefaultConfiguration(m,h);this.m(v,$,7)}l(m){const h=this.a.toData(),$=this.a.compareAndUpdatePolicyConfiguration(m);this.m($,h,7)}m(m,h,$){const v=new R.$fn(m,{data:h},this.a);v.source=$,v.sourceConfig=this.n($),this.h.fire(v)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.$jn=P}),define(oe[206],ae([0,1,14]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qib=e.$Pib=void 0;const T=(D,j,L)=>{const R=new Uint8Array(16);for(let P=0;P<16;P++)R[P]=Math.round(Math.random()*256);const S=(0,I.$4b)(I.$Jb.wrap(R));return[`GET ws://localhost${D}?${j}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${S}`].join(`\r
`)+`\r
\r
`};e.$Pib=T,e.$Qib=I.$Jb.fromString(`\r
\r
`)}),define(oe[207],ae([0,1,7,4]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=e.RemoteAuthorityResolverErrorCode=e.$wk=e.$vk=e.RemoteConnectionType=e.$uk=void 0,e.$uk=(0,T.$nh)("remoteAuthorityResolverService");var D;(function(P){P[P.WebSocket=0]="WebSocket",P[P.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class j{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$vk=j;class L{constructor(E,m){this.host=E,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$wk=L;var R;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound",P.InvalidAuthority="InvalidAuthority"})(R||(e.RemoteAuthorityResolverErrorCode=R={}));class S extends I.$ab{static isNotAvailable(E){return E instanceof S&&E._code===R.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof S&&E._code===R.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof S&&E._code===R.NoResolverFound}static isInvalidAuthority(E){return E instanceof S&&E._code===R.InvalidAuthority}static isHandled(E){return E instanceof S&&E.isHandled}constructor(E,m=R.Unknown,h){super(E),this._message=E,this._code=m,this._detail=h,this.isHandled=m===R.NotAvailable&&h===!0,Object.setPrototypeOf(this,S.prototype)}}e.$xk=S;function b(P){const E=P.indexOf("+");return E===-1?P:P.substring(0,E)}e.$yk=b}),define(oe[72],ae([0,1,26]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=void 0;function T(b){return b.scheme===I.Schemas.vscodeRemote?b.authority:void 0}e.$zk=T;function D(b){if(!b)return;const P=b.indexOf("+");return P<0?b:b.substr(0,P)}e.$Ak=D;function j(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$Bk=j;function L(b){const{host:P,port:E}=S(b);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:P,port:E}}e.$Ck=L;function R(b,P){let{host:E,port:m}=S(b);return typeof m>"u"&&(m=P),{host:E,port:m}}e.$Dk=R;function S(b){const P=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(P)return{host:P[1],port:parseInt(P[2],10)};const E=b.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const m=b.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:b,port:void 0}}}),define(oe[45],ae([0,1,27,4,72]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.TargetPlatform=e.ExtensionType=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=void 0,e.$zl="extensions.user.cache",e.$Al="extensions.builtin.cache",e.$Bl="undefined_publisher",e.$Cl=["ui","workspace","web"];function j(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.$Dl=j,e.$El=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(L||(e.ExtensionType=L={}));var R;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(R||(e.TargetPlatform=R={}));class S{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,l){if(typeof c>"u"||c===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof c=="string"||typeof l=="string"){const u=typeof c=="string"?c:c.value,y=typeof l=="string"?l:l.value;return I.$Ld(u,y)}return c._lower===l._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$Fl=S;class b{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const l of c)this.add(l)}add(c){this.c.add(S.toKey(c))}delete(c){return this.c.delete(S.toKey(c))}has(c){return this.c.has(S.toKey(c))}}e.$Gl=b;class P{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(S.toKey(c))}get(c){return this.c.get(S.toKey(c))}has(c){return this.c.has(S.toKey(c))}set(c,l){this.c.set(S.toKey(c),l)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Hl=P;function E(v){return m(v)}e.$Il=E;function m(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.$Jl=m;function h(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.$Kl=h;function $(v,c){if(c){const l=`onResolveRemoteAuthority:${(0,D.$Ak)(c)}`;return!!v.activationEvents?.includes(l)}return!1}e.$Ll=$,e.$Ml=(0,T.$nh)("IBuiltinExtensionsScannerService")}),define(oe[208],ae([0,1,2,45,13]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jp=void 0;class j extends I.$lb{constructor(R,S,b,P,E){super(),this.a=R,this.b=S,this.c=b,this.f=E,this.B(P.onDidInstallExtensions(m=>this.g(m))),this.B(P.onDidUninstallExtension(m=>this.h(m)))}g(R){for(const S of R)S.local&&this.invalidate(S.profileLocation)}h(R){R.error||this.invalidate(R.profileLocation)}async invalidate(R){if(R)for(const S of this.a.profiles)this.c.extUri.isEqual(S.extensionsResource,R)&&await this.i(S);else await this.i(this.a.defaultProfile)}async i(R){try{await this.b.del(this.c.extUri.joinPath(R.cacheHome,T.$zl))}catch(S){(0,D.$7j)(S)!==1&&this.f.error(S)}}}e.$jp=j}),define(oe[209],ae([0,1,6,14,25,7,3,2,100,87,32,92,207,72]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.PersistentConnectionEventType=e.$Kk=e.$Jk=e.$Ik=e.ConnectionType=void 0;const $=30*1e3;var v;(function(A){A[A.Management=1]="Management",A[A.ExtensionHost=2]="ExtensionHost",A[A.Tunnel=3]="Tunnel"})(v||(e.ConnectionType=v={}));function c(A){switch(A){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function l(A){const d=new D.$dd;return setTimeout(()=>d.cancel(),A),d.token}function u(A,d){if(A.isCancellationRequested||d.isCancellationRequested)return D.CancellationToken.Cancelled;const O=new D.$dd;return A.onCancellationRequested(()=>O.cancel()),d.onCancellationRequested(()=>O.cancel()),O.token}class y{get didTimeout(){return this.c==="timedout"}constructor(d){this.c="pending",this.d=new R.$kb,this.promise=new Promise((O,z)=>{this.f=O,this.g=z}),d.isCancellationRequested?this.h():this.d.add(d.onCancellationRequested(()=>this.h()))}registerDisposable(d){this.c==="pending"?this.d.add(d):d.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const d=new Error("Time limit reached");return d.code="ETIMEDOUT",d.syscall="connect",d}resolve(d){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(d))}reject(d){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(d))}}function p(A,d){const O=new y(d);return O.registerDisposable(A.onControlMessage(z=>{const G=JSON.parse(z.toString()),U=B(G);U?O.reject(U):O.resolve(G)})),O.promise}function C(A,d,O,z,G,U,X,_){const se=new y(_),he=b.$3c.create(!1);return A.info(`Creating a socket (${X})...`),S.mark(`code/willCreateSocket/${U}`),d.connect(O,z,G,X).then(ue=>{se.didTimeout?(S.mark(`code/didCreateSocketError/${U}`),A.info(`Creating a socket (${X}) finished after ${he.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(S.mark(`code/didCreateSocketOK/${U}`),A.info(`Creating a socket (${X}) was successful after ${he.elapsed()} ms.`),se.resolve(ue))},ue=>{S.mark(`code/didCreateSocketError/${U}`),A.info(`Creating a socket (${X}) returned an error after ${he.elapsed()} ms.`),A.error(ue),se.reject(ue)}),se.promise}function t(A,d){const O=new y(d);return A.then(z=>{O.didTimeout||O.resolve(z)},z=>{O.didTimeout||O.reject(z)}),O.promise}async function o(A,d,O,z){const G=ce(A,d);A.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let U;try{U=await C(A.logService,A.remoteSocketFactoryService,A.connectTo,(0,h.$Bk)(A),`reconnectionToken=${A.reconnectionToken}&reconnection=${A.reconnectionProtocol?"true":"false"}`,c(d),`renderer-${c(d)}-${A.reconnectionToken}`,z)}catch(ue){throw A.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),A.logService.error(ue),ue}A.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let X,_;A.reconnectionProtocol?(A.reconnectionProtocol.beginAcceptReconnection(U,null),X=A.reconnectionProtocol,_=!1):(X=new E.$bh({socket:U}),_=!0),A.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const se=await t(A.signService.createNewMessage((0,P.$5e)()),z),he={type:"auth",auth:A.connectionToken||"00000000000000000000",data:se.data};X.sendControl(T.$Jb.fromString(JSON.stringify(he)));try{const ue=await p(X,u(z,l(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if(A.logService.trace(`${G} 4/6. received SignRequest control message.`),!await t(A.signService.validate(se,ue.signedData),z)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const pe=await t(A.signService.sign(ue.data),z),ke={type:"connectionType",commit:A.commit,signedData:pe,desiredConnectionType:d};return O&&(ke.args=O),A.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),X.sendControl(T.$Jb.fromString(JSON.stringify(ke))),{protocol:X,ownsProtocol:_}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(A.logService.error(`${G} the handshake timed out. Error:`),A.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(A.logService.error(`${G} received error control message when negotiating connection. Error:`),A.logService.error(ue)),_&&H(X),ue}}async function n(A,d,O,z){const G=Date.now(),U=ce(A,d),{protocol:X,ownsProtocol:_}=await o(A,d,O,z),se=new y(z);return se.registerDisposable(X.onControlMessage(he=>{const ue=JSON.parse(he.toString()),me=B(ue);me?(A.logService.error(`${U} received error control message when negotiating connection. Error:`),A.logService.error(me),_&&H(X),se.reject(me)):(A.reconnectionProtocol?.endAcceptReconnection(),A.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${re(G)}!`),se.resolve({protocol:X,firstMessage:ue}))})),se.promise}async function s(A,d){const{protocol:O}=await n(A,1,void 0,d);return{protocol:O}}async function i(A,d,O){const{protocol:z,firstMessage:G}=await n(A,2,d,O),U=G&&G.debugPort;return{protocol:z,debugPort:U}}async function r(A,d,O){const z=Date.now(),G=ce(A,3),{protocol:U}=await o(A,3,d,O);return A.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${re(z)}!`),U}async function a(A,d,O){const{connectTo:z,connectionToken:G}=await A.addressProvider.getAddress();return{commit:A.commit,quality:A.quality,connectTo:z,connectionToken:G,reconnectionToken:d,reconnectionProtocol:O,remoteSocketFactoryService:A.remoteSocketFactoryService,signService:A.signService,logService:A.logService}}async function w(A,d,O){return f(A,async z=>{const{protocol:G}=await s(z,D.CancellationToken.None);return new Z(A,d,O,z.reconnectionToken,G)})}e.$Ik=w;async function g(A,d){return f(A,async O=>{const{protocol:z,debugPort:G}=await i(O,d,D.CancellationToken.None);return new x(A,d,O.reconnectionToken,z,G)})}e.$Jk=g;async function f(A,d){for(let z=1;;z++)try{const G=(0,P.$5e)(),U=await a(A,G,null);return await d(U)}catch(G){if(z<5)A.logService.error(`[remote-connection][attempt ${z}] An error occurred in initial connection! Will retry... Error:`),A.logService.error(G);else throw A.logService.error(`[remote-connection][attempt ${z}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),A.logService.error(G),Y.triggerPermanentFailure(0,0,m.$xk.isHandled(G)),G}}async function k(A,d,O){const z=await a(A,(0,P.$5e)(),null);return await r(z,{host:d,port:O},D.CancellationToken.None)}e.$Kk=k;function N(A){return(0,I.$hg)(d=>new Promise((O,z)=>{const G=setTimeout(O,A*1e3);d.onCancellationRequested(()=>{clearTimeout(G),O()})}))}var M;(function(A){A[A.ConnectionLost=0]="ConnectionLost",A[A.ReconnectionWait=1]="ReconnectionWait",A[A.ReconnectionRunning=2]="ReconnectionRunning",A[A.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",A[A.ConnectionGain=4]="ConnectionGain"})(M||(e.PersistentConnectionEventType=M={}));class F{constructor(d,O){this.reconnectionToken=d,this.millisSinceLastIncomingData=O,this.type=0}}e.$Lk=F;class W{constructor(d,O,z,G){this.reconnectionToken=d,this.millisSinceLastIncomingData=O,this.durationSeconds=z,this.c=G,this.type=1}skipWait(){this.c.cancel()}}e.$Mk=W;class q{constructor(d,O,z){this.reconnectionToken=d,this.millisSinceLastIncomingData=O,this.attempt=z,this.type=2}}e.$Nk=q;class J{constructor(d,O,z){this.reconnectionToken=d,this.millisSinceLastIncomingData=O,this.attempt=z,this.type=4}}e.$Ok=J;class Q{constructor(d,O,z,G){this.reconnectionToken=d,this.millisSinceLastIncomingData=O,this.attempt=z,this.handled=G,this.type=3}}e.$Pk=Q;class Y extends R.$lb{static triggerPermanentFailure(d,O,z){this._permanentFailure=!0,this.f=d,this.g=O,this.h=z,this.i.forEach(G=>G.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(d=>d.s())}static debugPauseSocketWriting(){this.i.forEach(d=>d.w())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.i=[]}get k(){return this.c||Y._permanentFailure}constructor(d,O,z,G,U){super(),this.n=d,this.p=O,this.reconnectionToken=z,this.protocol=G,this.r=U,this.j=this.B(new L.$7c),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new J(this.reconnectionToken,0,0)),this.B(G.onSocketClose(X=>{const _=ne(this.n,this.reconnectionToken,!0);X?X.type===0?(this.p.logService.info(`${_} received socket close event (hadError: ${X.hadError}).`),X.error&&this.p.logService.error(X.error)):(this.p.logService.info(`${_} received socket close event (wasClean: ${X.wasClean}, code: ${X.code}, reason: ${X.reason}).`),X.event&&this.p.logService.error(X.event)):this.p.logService.info(`${_} received socket close event.`),this.s()})),this.B(G.onSocketTimeout(X=>{const _=ne(this.n,this.reconnectionToken,!0);this.p.logService.info(`${_} received socket timeout event (unacknowledgedMsgCount: ${X.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${X.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${X.timeSinceLastReceivedSomeData}).`),this.s()})),Y.i.push(this),this.B((0,R.$jb)(()=>{const X=Y.i.indexOf(this);X>=0&&Y.i.splice(X,1)})),this.k&&this.v(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const d=ne(this.n,this.reconnectionToken,!0);this.p.logService.info(`${d} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const O=[0,5,5,10,10,10,10,10,30];let z=-1;do{z++;const G=z<O.length?O[z]:O[O.length-1];try{if(G>0){const X=N(G);this.j.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G,X)),this.p.logService.info(`${d} waiting for ${G} seconds before reconnecting...`);try{await X}catch{}}if(this.k){this.p.logService.error(`${d} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1)),this.p.logService.info(`${d} resolving connection...`);const U=await a(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${d} connecting to ${U.connectTo}...`),await this.y(U,l($)),this.p.logService.info(`${d} reconnected!`),this.j.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z+1));break}catch(U){if(U.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${d} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(U),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(z>360){this.p.logService.error(`${d} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(U),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}if(m.$xk.isTemporarilyNotAvailable(U)){this.p.logService.info(`${d} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(U);continue}if((U.code==="ETIMEDOUT"||U.code==="ENETUNREACH"||U.code==="ECONNREFUSED"||U.code==="ECONNRESET")&&U.syscall==="connect"){this.p.logService.info(`${d} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(U);continue}if((0,j.$2)(U)){this.p.logService.info(`${d} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(U);continue}if(U instanceof m.$xk){this.p.logService.error(`${d} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(U),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,m.$xk.isHandled(U));break}this.p.logService.error(`${d} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(U),this.u(this.protocol.getMillisSinceLastIncomingData(),z+1,!1);break}}while(!this.k&&!this.m)}u(d,O,z){this.r?Y.triggerPermanentFailure(d,O,z):this.v(d,O,z)}v(d,O,z){this.j.fire(new Q(this.reconnectionToken,d,O,z)),H(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.$Qk=Y;class Z extends Y{constructor(d,O,z,G,U){super(1,d,G,U,!0),this.client=this.B(new E.$_g(U,{remoteAuthority:O,clientId:z},d.ipcLogger))}async y(d,O){await s(d,O)}}e.$Rk=Z;class x extends Y{constructor(d,O,z,G,U){super(2,d,z,G,!1),this.z=O,this.debugPort=U}async y(d,O){await i(d,this.z,O)}}e.$Sk=x;function H(A){try{A.acceptDisconnect();const d=A.getSocket();A.dispose(),d.dispose()}catch(d){(0,j.$Y)(d)}}function B(A){if(A&&A.type==="error"){const d=new Error(`Connection error: ${A.reason}`);return d.code="VSCODE_CONNECTION_ERROR",d}return null}function V(A,d){for(;A.length<d;)A+=" ";return A}function ee(A,d){return`[remote-connection][${V(c(A),13)}][${d.substr(0,5)}\u2026]`}function ne(A,d,O){return`${ee(A,d)}[${O?"reconnect":"initial"}]`}function ce(A,d){return`${ne(d,A.reconnectionToken,!!A.reconnectionProtocol)}[${A.connectTo}]`}function re(A){return`${Date.now()-A} ms`}}),define(oe[104],ae([0,1,2,4]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fk=e.$Ek=void 0,e.$Ek=(0,T.$nh)("remoteSocketFactoryService");class D{constructor(){this.a={}}register(L,R){return this.a[L]??=[],this.a[L].push(R),(0,I.$jb)(()=>{const S=this.a[L]?.indexOf(R);typeof S=="number"&&S>=0&&this.a[L]?.splice(S,1)})}b(L){return(this.a[L.type]||[]).find(S=>S.supports(L))}connect(L,R,S,b){const P=this.b(L);if(!P)throw new Error(`No socket factory found for ${L}`);return P.connect(L,R,S,b)}}e.$Fk=D}),define(oe[210],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L5b=e.$K5b=void 0,e.$K5b=(0,I.$nh)("sharedProcessTunnelService"),e.$L5b="sharedProcessTunnel"}),define(oe[105],ae([0,1,4,160]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V5b=e.$U5b=e.$T5b=e.$S5b=e.$R5b=e.TunnelStates=e.$Q5b=e.$P5b=void 0,e.$P5b=(0,I.$nh)("IRemoteTunnelService"),e.$Q5b={active:!1};var D;(function(j){j.disconnected=L=>({type:"disconnected",onTokenFailed:L}),j.connected=(L,R)=>({type:"connected",info:L,serviceInstallFailed:R}),j.connecting=L=>({type:"connecting",progress:L}),j.uninitialized={type:"uninitialized"}})(D||(e.TunnelStates=D={})),e.$R5b="remote.tunnels.access",e.$S5b=e.$R5b+".hostNameOverride",e.$T5b=e.$R5b+".preventSleep",e.$U5b="remoteTunnelService",e.$V5b=(0,T.localize)(0,null)}),define(oe[57],ae([0,1,14,7,2,162,49,4,8,40]),function(te,e,I,T,D,j,L,R,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$wo=(0,R.$nh)("requestService");class P{constructor(C){this.b=C}toJSON(){if(!this.a){const C=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?C[t]="*****":C[t]=this.b[t];this.a=C}return this.a}}class E extends D.$lb{constructor(C){super(),this.b=0,this.a=C.createLogger("network",{name:(0,j.localize)(0,null),when:S.$7i.isEqualTo((0,S.$5i)(S.LogLevel.Trace)).serialize()})}async c(C,t,o){const n=`${C} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new P(t.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,t.type,(0,T.$9)(s)),s}}}e.$xo=E;function m(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.$yo=m;function h(p){return p.res.statusCode===204}async function $(p){return h(p)?null:(await(0,I.$Vb)(p.stream)).toString()}e.$zo=$;async function v(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);return $(p)}e.$Ao=v;async function c(p){if(!m(p))throw new Error("Server returned "+p.res.statusCode);if(h(p))return null;const t=(await(0,I.$Vb)(p.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$Bo=c;function l(p){y(p)}e.$Co=l;let u;function y(p){const C=b.$Rm.as(L.$Wm.Configuration),t=u;u={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0}}},C.updateConfigurations({add:[u],remove:t?[t]:[]})}y(1)}),define(oe[211],ae([0,1,25,26,13,57]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=void 0;let L=class{constructor(S,b){this.a=S,this.b=b}async download(S,b,P=I.CancellationToken.None){if(S.scheme===T.Schemas.file||S.scheme===T.Schemas.vscodeRemote){await this.b.copy(S,b);return}const E={type:"GET",url:S.toString(!0)},m=await this.a.request(E,P);if(m.res.statusCode===200)await this.b.writeFile(b,m.stream);else{const h=await(0,j.$Ao)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${h}`)}}};e.$_M=L,e.$_M=L=be([K(0,j.$wo),K(1,D.$Qj)],L)}),define(oe[212],ae([0,1,14,25]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=e.$yq=void 0;class D{constructor(R){this.a=R}listen(R,S){throw new Error("Invalid listen")}call(R,S,b,P=T.CancellationToken.None){switch(S){case"request":return this.a.request(b[0],P).then(async({res:E,stream:m})=>{const h=await(0,I.$Vb)(m);return[{statusCode:E.statusCode,headers:E.headers},h]});case"resolveProxy":return this.a.resolveProxy(b[0])}throw new Error("Invalid call")}}e.$yq=D;class j{constructor(R){this.a=R}async request(R,S){const[b,P]=await this.a.call("request",[R],S);return{res:b,stream:(0,I.$Xb)(P)}}async resolveProxy(R){return this.a.call("resolveProxy",[R])}}e.$zq=j}),define(oe[213],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jZb=void 0;class I{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(D){try{const j=await this.c();if(j){const L=String(I.a++);return this.b.set(L,j),{id:L,data:j.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,j){if(!D.id)return!0;const L=this.b.get(D.id);if(!L)return!1;this.b.delete(D.id);try{return L.validate(j)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(D){try{return await this.d(D)}catch{}return D}}e.$jZb=I}),define(oe[106],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hk=e.$Gk=void 0,e.$Gk="signService",e.$Hk=(0,I.$nh)(e.$Gk)}),define(oe[214],ae([0,1,213]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$44b=void 0;class T extends I.$jZb{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(L=>new L.signer().sign(j))}h(){return new Promise((j,L)=>te(["vsda"],j,L))}}e.$44b=T}),define(oe[73],ae([0,1,3,2]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yxb=e.$Xxb=e.$Wxb=e.$Vxb=void 0;class D extends T.$lb{constructor(E,m,h){super(),this.a=E,this.b=m,this.c=h}async getItems(){const E={profile:this.b,workspace:this.c},m=await this.a.call("getItems",E);return new Map(m)}updateItems(E){const m={profile:this.b,workspace:this.c};return E.insert&&(m.insert=Array.from(E.insert.entries())),E.delete&&(m.delete=Array.from(E.delete.values())),this.a.call("updateItems",m)}}class j extends D{constructor(E,m){super(E,m,void 0),this.f=this.B(new I.$7c),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(E=>this.h(E)))}h(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this.f.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class L extends j{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.$Vxb=L;class R extends j{constructor(E,m){super(E,m)}async close(){this.dispose()}}e.$Wxb=R;class S extends D{constructor(E,m){super(E,void 0,m),this.onDidChangeItemsExternal=I.Event.None}async close(){this.dispose()}}e.$Xxb=S;class b{constructor(E){this.a=E}isUsed(E){const m={payload:E,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$Yxb=b}),define(oe[107],ae([0,1,5,37,32]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=void 0;function j(S){if(I.$t===2&&/^penguin(\.|$)/i.test(S))return"chromebook"}function L(S,b,P,E,m,h,$,v){const c=Object.create(null);c["common.machineId"]=h,c.sessionID=(0,D.$5e)()+Date.now(),c.commitHash=E,c.version=m,c["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,I.$h)(I.$t),c["common.nodePlatform"]=T.$7b,c["common.nodeArch"]=P,c["common.product"]=v||"desktop",$&&(c["common.msftInternal"]=$);let l=0;const u=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>l++,enumerable:!0}}),I.$l&&(c["common.snap"]="true");const y=j(b);return y&&(c["common.platformDetail"]=y),c}e.$Xn=L;function R(S){const b=T.env.USERDNSDOMAIN;if(!b)return!1;const P=b.toLowerCase();return S.some(E=>P===E)}e.$Yn=R}),define(oe[20],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=void 0,e.$Tk=(0,I.$nh)("telemetryService"),e.$Uk=(0,I.$nh)("customEndpointTelemetryService"),e.$Vk="telemetry.currentSessionDate",e.$Wk="telemetry.firstSessionDate",e.$Xk="telemetry.lastSessionDate",e.$Yk="telemetry.machineId",e.$Zk="telemetry",e.$1k="telemetry.telemetryLevel",e.$2k="telemetry.enableCrashReporter",e.$3k="telemetry.enableTelemetry";var T;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var D;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(oe[215],ae([0,1,36,6,34,26,16,5,10,128,31,142,95,13,24,20]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=e.$fr=e.$er=void 0;const c=new Map;async function l(t,o){const n=`${t}::${o.join(":")}`,s=c.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,w=2e4;function g(k,N,M,F){const W=N.substring(k.length+1);return T.Promises.withAsyncBody(async q=>{let J;try{J=await P.Promises.readdir(N,{withFileTypes:!0})}catch{q();return}if(F.count>=w){F.count+=J.length,F.maxReached=!0,q();return}let Q=J.length;if(Q===0){q();return}let Y=J;F.count+J.length>w&&(F.maxReached=!0,Q=w-F.count,Y=J.slice(0,Q)),F.count+=J.length;for(const Z of Y)if(Z.isDirectory()){if(M.includes(Z.name)||await g(k,(0,L.$ac)(N,Z.name),M,F),--Q===0){q();return}}else{const x=Z.name.lastIndexOf(".");if(x>=0){const H=Z.name.substring(x+1);H&&r.set(H,(r.get(H)??0)+1)}for(const H of i)H.relativePathPattern?.test(W)!==!1&&H.filePattern.test(Z.name)&&a.set(H.tag,(a.get(H.tag)??0)+1);if(--Q===0){q();return}}})}const f=T.Promises.withAsyncBody(async k=>{const N={count:0,maxReached:!1};await g(t,t,o,N);const M=await p(t);k({configFiles:u(a),fileTypes:u(r),fileCount:N.count,maxFilesReached:N.maxReached,launchConfigFiles:M})});return c.set(n,f),f}e.$er=l;function u(t){return Array.from(t.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function y(){const t={os:`${I.type()} ${I.arch()} ${I.release()}`,memory:`${(I.totalmem()/h.$lk.GB).toFixed(2)}GB (${(I.freemem()/h.$lk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.$rm.value()*100)}%`},o=I.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$fr=y;async function p(t){try{const o=new Map,n=(0,L.$ac)(t,".vscode","launch.json"),s=await P.Promises.readFile(n),i=[],r=(0,D.$vm)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,D.$Em)(r)==="object"&&r.configurations)for(const a of r.configurations){const w=a.type;w&&(o.has(w)?o.set(w,o.get(w)+1):o.set(w,1))}return u(o)}catch{return[]}}e.$gr=p;let C=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${I.type()} ${I.arch()} ${I.release()}`);const s=I.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(I.totalmem()/h.$lk.GB).toFixed(2)}GB (${(I.freemem()/h.$lk.GB).toFixed(2)}GB free)`),R.$i||n.push(`Load (avg):       ${I.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(b.$rm.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,E.$dr)(o.mainPID),this.k(o)]).then(async s=>{let[i,r]=s,a=this.m(o,i);return n.forEach(w=>{if((0,m.$4l)(w))a+=`
${w.errorMessage}`,r+=`
${w.errorMessage}`;else if(a+=`

Remote: ${w.hostName}`,w.processes&&(a+=`
${this.m(o,w.processes)}`),w.workspaceMetadata){r+=`
|  Remote: ${w.hostName}`;for(const g of Object.keys(w.workspaceMetadata)){const f=w.workspaceMetadata[g];let k=`${f.fileCount} files`;f.maxFilesReached&&(k=`more than ${k}`),r+=`|    Folder (${g}): ${k}`,r+=this.h(f)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:i,os:r,cpus:a}=y(),w={os:r,memory:s,cpus:a,vmHint:i,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return R.$i||(w.load=`${I.loadavg().map(g=>Math.round(g)).join(", ")}`),R.$k&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(o,n){const s=[];return(0,E.$dr)(o.mainPID).then(async i=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,i)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,m.$4l)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const w=r.workspaceMetadata[a];let g=`${w.fileCount} files`;w.maxFilesReached&&(g=`more than ${g}`),s.push(`Folder (${a}): ${g}`),s.push(this.h(w))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let i=0;const r=(f,k)=>{const N=` ${f}(${k})`;i+N.length>60?(n.push(a),a="|                 ",i=a.length):i+=N.length,a+=N};let a="|      File types:";const w=10,g=o.fileTypes.length>w?w:o.fileTypes.length;for(let f=0;f<g;f++){const k=o.fileTypes[f];r(k.name,k.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",i=0,o.configFiles.forEach(f=>{r(f.name,f.count)}),n.push(a)),o.launchConfigFiles.length>0){let f="|      Launch Configs:";o.launchConfigFiles.forEach(k=>{const N=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;f+=N}),n.push(f)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(r=>{const a=S.URI.revive(r);if(a.scheme===j.Schemas.file){const w=a.fsPath;s.push(l(w,["node_modules",".git"]).then(g=>{let f=`${g.fileCount} files`;g.maxFilesReached&&(f=`more than ${f}`),n.push(`|    Folder (${(0,L.$ec)(w)}): ${f}`),n.push(this.h(g))}).catch(g=>{n.push(`|      Error: Unable to collect workspace stats for folder ${w} (${g.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,i,n,0),i.join(`
`)}n(o,n,s,i,r){const a=r===0;let w;a?w=i.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(i.pid)?w=n.get(i.pid):w=`${"  ".repeat(r)} ${i.name}`;const g=process.platform==="win32"?i.mem:I.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(g/h.$lk.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(i.children)&&i.children.forEach(f=>this.n(o,n,s,f,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const i=S.URI.revive(s);if(i.scheme!==j.Schemas.file)continue;const r=i.fsPath;try{(await l(r,["node_modules",".git"])).fileTypes.forEach(w=>n.add(w.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=S.URI.revive(n);if(s.scheme!==j.Schemas.file)continue;const i=s.fsPath;try{const r=await l(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$hr=C,e.$hr=C=be([K(0,v.$Tk),K(1,$.$8i)],C)}),define(oe[108],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j4b=e.$i4b=void 0;class I{constructor(j){this.b=j}listen(j,L){throw new Error(`Event not found: ${L}`)}call(j,L,{eventName:R,data:S}){return this.b.forEach(b=>b.log(R,S)),Promise.resolve(null)}}e.$i4b=I;class T{constructor(j){this.b=j}log(j,L){return this.b.call("log",{eventName:j,data:L}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$j4b=T}),define(oe[46],ae([0,1,30,11,3,18,72,107,20]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=void 0;class b{constructor(i){this.value=i,this.isTrustedTelemetryValue=!0}}e.$Zn=b;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$1n=P,e.$2n=new P;class E{async publicLog(i,r,a){}async publicLogError(i,r,a){}}e.$3n=E,e.$4n="telemetry",e.$5n="extensionTelemetryLog",e.$6n={log:()=>null,flush:()=>Promise.resolve(null)};function m(s,i){return D.Event.debounce(i.onDidChangeConfiguration,(a,w)=>{const g=a?new Set([...a.affectedKeys,...w.affectedKeys]):w.affectedKeys;return{...w,affectedKeys:g}},1e3,!0)(a=>{a.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,j.$Wh)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.$7n=m;function h(s,i){return!i.isBuilt&&!i.disableTelemetry?!0:!(i.disableTelemetry||!s.enableTelemetry||i.extensionTestsLocationURI)}e.$8n=h;function $(s,i){return!(i.isBuilt||i.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$9n=$;function v(s){const i=s.getValue(S.$1k),r=s.getValue(S.$2k);if(s.getValue(S.$3k)===!1||r===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$0n=v;function c(s){const i={},r={},a={};y(s,a);for(let w in a){w=w.length>150?w.substr(w.length-149):w;const g=a[w];typeof g=="number"?r[w]=g:typeof g=="boolean"?r[w]=g?1:0:typeof g=="string"?(g.length>8192&&console.warn(`Telemetry property: ${w} has been trimmed to 8192, the original length is ${g.length}`),i[w]=g.substring(0,8191)):typeof g<"u"&&g!==null&&(i[w]=g)}return{properties:i,measurements:r}}e.$$n=c;const l=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(s){if(!s)return"none";const i=(0,L.$Ak)(s);return l.has(i)?i:"other"}e.$_n=u;function y(s,i,r=0,a){if(s)for(const w of Object.getOwnPropertyNames(s)){const g=s[w],f=a?a+w:w;Array.isArray(g)?i[f]=(0,I.$Km)(g):g instanceof Date?i[f]=g.toISOString():(0,T.$ke)(g)?r<2?y(g,i,r+1,f+"."):i[f]=(0,I.$Km)(g):i[f]=g}}function p(s,i){const r=s.msftInternalDomains||[],a=i.getValue("telemetry.internalTesting");return(0,R.$Yn)(r)||a}e.$ao=p;function C(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$bo=C;function t(s,i){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let r=s;const a=[];for(const k of i)for(;;){const N=k.exec(s);if(!N)break;a.push([N.index,k.lastIndex])}const w=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(r="";;){const k=g.exec(s);if(!k)break;const N=a.some(([M,F])=>k.index<F&&M<g.lastIndex);!w.test(k[0])&&!N&&(r+=s.substring(f,k.index)+"<REDACTED: user-file-path>",f=g.lastIndex)}return f<s.length&&(r+=s.substr(f)),r}function o(s){if(!s)return s;const i=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of i)if(r.regex.test(s))return`<REDACTED: ${r.label}>`;return s}function n(s,i){return(0,I.$Hm)(s,r=>{if(r instanceof b||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let a=r.replaceAll("%20"," ");a=t(a,i);for(const w of i)a=a.replace(w,"");return a=o(a),a}})}e.$co=n}),define(oe[33],ae([0,1,27,29,45,5,10,7,37,46]),function(te,e,I,T,D,j,L,R,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=void 0;function P(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,I.$Gd)(n.id,s.id)===0}e.$do=P;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const i=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,i,r)}static parse(s){const i=E.exec(s);return i&&i[1]&&i[2]?new m({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?P(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$eo=m;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const s=h.exec(n);return s&&s[1]?[c(s[1]),s[2]]:[c(n),void 0]}e.$fo=$;function v(n,s){return`${n}.${s}`}e.$go=v;function c(n){return n.toLowerCase()}e.$ho=c;function l(n,s){return c(v(n??D.$Bl,s))}e.$io=l;function u(n,s){const i=[],r=a=>{for(const w of i)if(w.some(g=>P(s(g),s(a))))return w;return null};for(const a of n){const w=r(a);w?w.push(a):i.push([a])}return i}e.$jo=u;function y(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$ko=y;function p(n){return{id:new b.$Zn(n.identifier.id),name:new b.$Zn(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$lo=p,e.$mo=new D.$Fl("pprice.better-merge");function C(n,s){const i=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&i.every(w=>!P(w.identifier,{id:a}))){const w=n.filter(g=>P(g.identifier,{id:a}));w.length===1&&(i.push(w[0]),r.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.$no=C;async function t(n,s){if(!j.$k)return!1;let i;try{i=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,R.$9)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const i=await t(n,s),r=(0,T.$In)(i?"alpine":j.$t,S.$8b);return s.debug("ComputeTargetPlatform:",r),r}e.$oo=o}),define(oe[216],ae([0,1,21,2,22,10,13,24,6,3,16,5,37,33]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p2b=e.$o2b=void 0;let $=class extends T.$lb{constructor(y,p){super(),this.b=y,this.c=p,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,C])=>this.a.set(C.configPath,C))}getConfigBasedTips(y){return this.f(y)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(y){const p=[];for(const[C,t]of this.a)if(!(t.configScheme&&t.configScheme!==y.scheme))try{const o=(await this.b.readFile((0,D.$8f)(y,C))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&p.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return p}};e.$o2b=$,e.$o2b=$=be([K(0,L.$Qj),K(1,R.$8i)],$);const v="extensionTips/promptedExecutableTips",c="extensionTips/lastPromptedMediumImpExeTime";class l extends ${constructor(y,p,C,t,o,n,s,i){super(s,i),this.m=y,this.n=p,this.r=C,this.s=t,this.t=o,this.u=n,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([r,a])=>{const w=[],g=[],f=[];Object.entries(a.recommendations).forEach(([k,N])=>{N.important?a.important?w.push({extensionId:k,extensionName:N.name,isExtensionPack:!!N.isExtensionPack}):g.push({extensionId:k,extensionName:N.name,isExtensionPack:!!N.isExtensionPack}):f.push({extensionId:k,extensionName:N.name,isExtensionPack:!!N.isExtensionPack})}),w.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),g.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:g}),f.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:f})}),(0,S.$ug)(3e3).then(async()=>{await this.v(),this.z(),this.C()})}async getImportantExecutableBasedTips(){const y=await this.L(this.g),p=await this.L(this.h);return[...y,...p]}getOtherExecutableBasedTips(){return this.L(this.j)}async v(){const y=await this.L(this.g),p=await this.L(this.h),C=await this.s.getInstalled();this.k=this.w(y,C),this.l=this.w(p,C)}w(y,p){const C=new Map;y.forEach(i=>C.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:o}=this.J([...C.keys()],p);for(const i of t){const r=C.get(i);r&&this.r.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:r.exeName})}for(const i of o){const r=C.get(i);r&&this.r.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:r.exeName})}const n=this.H(),s=new Map;for(const i of o){const r=C.get(i);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}z(){if(this.k.size===0)return;const[y,p]=[...this.k.entries()][0];this.D(p).then(C=>{switch(C){case"reacted":this.I(p[0].exeName,p);break;case"ignored":this.k.delete(y);break;case"incompatibleWindow":{const t=b.Event.once(b.Event.latch(b.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(t(()=>this.z()));break}case"toomany":{const t=this.B((0,S.$vg)(()=>{t.dispose(),this.z()},36e5));break}}})}C(){if(this.l.size===0)return;const y=this.F(),p=Date.now()-y,C=7*24*60*60*1e3;if(p<C){const n=this.B((0,S.$vg)(()=>{n.dispose(),this.C()},C-p));return}const[t,o]=[...this.l.entries()][0];this.D(o).then(n=>{switch(n){case"reacted":{this.G(Date.now()),this.l.delete(t),this.I(o[0].exeName,o);const s=this.B((0,S.$vg)(()=>{s.dispose(),this.C()},C));break}case"ignored":this.l.delete(t),this.C();break;case"incompatibleWindow":{const s=b.Event.once(b.Event.latch(b.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(s(()=>this.C()));break}case"toomany":{const s=this.B((0,S.$vg)(()=>{s.dispose(),this.C()},36e5));break}}})}async D(y){const p=await this.s.getInstalled(1),C=y.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(o=>p.every(n=>!(0,h.$do)(n.identifier,{id:o})))).map(({extensionId:t})=>t.toLowerCase());return this.u.promptImportantExtensionsInstallNotification({extensions:C,source:3,name:y[0].exeFriendlyName,searchValue:`@exe:"${y[0].exeName}"`})}F(){let y=this.t.getNumber(c,-1);return y||(y=Date.now(),this.G(y)),y}G(y){this.t.store(c,y,-1,1)}H(){return JSON.parse(this.t.get(v,-1,"{}"))}I(y,p){const C=this.H();C[y]=p.map(({extensionId:t})=>t.toLowerCase()),this.t.store(v,JSON.stringify(C),-1,0)}J(y,p){const C=[],t=[],o=p.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return y.forEach(n=>{o.has(n.toLowerCase())?C.push(n):t.push(n)}),{installed:C,uninstalled:t}}async L(y){const p=[],C=new Map;for(const t of y.keys()){const o=y.get(t);if(!o||!(0,I.$pf)(o.recommendations))continue;const n=[];E.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,P.$ac)("/usr/local/bin",t)),n.push((0,P.$ac)("/usr/bin",t)),n.push((0,P.$ac)(this.m.fsPath,t)));for(const s of n){let i=C.get(s);if(i===void 0&&(i=await this.b.exists(j.URI.file(s)),C.set(s,i)),i)for(const{extensionId:r,extensionName:a,isExtensionPack:w,whenNotInstalled:g}of o.recommendations)p.push({extensionId:r,extensionName:a,isExtensionPack:w,exeName:t,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:g})}}return p}}e.$p2b=l}),define(oe[217],ae([0,1,25,33]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Sb=void 0;async function D(j,L,R,S,b){try{const P=await j.getExtensionsControlManifest();if(!P.deprecated)return;const E=await j.getInstalled(1);for(const[m,h]of Object.entries(P.deprecated)){if(!h?.extension)continue;const{id:$,autoMigrate:v,preRelease:c}=h.extension;if(!v)continue;const l=E.find(y=>(0,T.$do)(y.identifier,{id:m}));if(!l)continue;const u=(await L.getExtensions([{id:$,preRelease:c}],{targetPlatform:await j.getTargetPlatform(),compatible:!0},I.CancellationToken.None))[0];if(!u){b.info(`Skipping migrating '${l.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{b.info(`Migrating '${l.identifier.id}' extension to '${$}' extension...`);const y=!S.getDisabledExtensions().some(C=>(0,T.$do)(C,l.identifier));await j.uninstall(l),b.info(`Uninstalled the unsupported extension '${l.identifier.id}'`);let p=E.find(C=>(0,T.$do)(C.identifier,{id:$}));(!p||!p.isPreReleaseVersion&&y)&&(p=await j.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:l.isMachineScoped,operation:4}),b.info(`Installed the pre-release extension '${p.identifier.id}'`),y||(await S.disableExtension(p.identifier),b.info(`Disabled the pre-release extension '${p.identifier.id}' because the unsupported extension '${l.identifier.id}' is disabled`)),v.storage&&(R.addToMigrationList((0,T.$go)(l.manifest.publisher,l.manifest.name),(0,T.$go)(p.manifest.publisher,p.manifest.name)),b.info("Added pre-release extension to the storage migration list"))),b.info(`Migrated '${l.identifier.id}' extension to '${$}' extension.`)}catch(y){b.error(y)}}}catch(P){b.error(P)}}e.$8Sb=D}),define(oe[218],ae([0,1,3,2,35,33,45]),function(te,e,I,T,D,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=void 0;class R extends T.$lb{constructor(b,P,E,m,h,$,v){super(),this.f=b,this.g=P,this.h=E,this.i=m,this.j=h,this.k=$,this.l=v,this.a=this.B(new I.$7c),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new T.$tb),this.m().then(null,c=>v.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles),this.n(),await this.z()}n(){this.B(this.h.onDidChangeProfiles(b=>this.p(b.added))),this.B(this.i.onAddExtensions(b=>this.r(b))),this.B(this.i.onDidAddExtensions(b=>this.s(b))),this.B(this.i.onRemoveExtensions(b=>this.t(b))),this.B(this.i.onDidRemoveExtensions(b=>this.u(b))),this.B(this.k.onDidFilesChange(b=>this.v(b)))}async p(b){try{b.length&&await Promise.all(b.map(P=>(this.c.set(P.id,(0,T.$ib)(this.k.watch(this.j.extUri.dirname(P.extensionsResource)),this.k.watch(P.extensionsResource))),this.y(P.extensionsResource))))}catch(P){throw this.l.error(P),P}}async r(b){for(const P of b.extensions)this.C(this.F(P.identifier,P.version),b.profileLocation)}async s(b){for(const P of b.extensions){const E=this.F(P.identifier,P.version);b.error?this.D(E,b.profileLocation):this.C(E,b.profileLocation)}}async t(b){for(const P of b.extensions)this.D(this.F(P.identifier,P.version),b.profileLocation)}async u(b){const P=[],E=[];for(const m of b.extensions){const h=this.F(m.identifier,m.version);b.error?this.C(h,b.profileLocation):(this.D(h,b.profileLocation),this.b.has(h)||(this.l.debug("Extension is removed from all profiles",m.identifier.id,m.version),E.push(this.f.scanInstalledExtensionAtLocation(m.location).then($=>{$?P.push($):this.l.info("Extension not found at the location",m.location.toString())},$=>this.l.error($)))))}try{await Promise.all(E),P.length&&await this.z(P)}catch(m){this.l.error(m)}}v(b){for(const P of this.h.profiles)b.contains(P.extensionsResource,0,1)&&this.w(P.extensionsResource)}async w(b){const P=[],E=[],m=await this.i.scanProfileExtensions(b),h=new Set,$=new Set;for(const[v,c]of this.b)c.has(b)&&$.add(v);for(const v of m){const c=this.F(v.identifier,v.version);h.add(c),$.has(c)||(P.push(v.identifier),this.C(c,b))}for(const v of $)if(!h.has(v)){const c=this.G(v);c&&(E.push(c.identifier),this.D(v,b))}(P.length||E.length)&&this.a.fire({added:P.length?{extensions:P,profileLocation:b}:void 0,removed:E.length?{extensions:E,profileLocation:b}:void 0})}async y(b){const P=await this.i.scanProfileExtensions(b);for(const E of P)this.C(this.F(E.identifier,E.version),b)}async z(b){b||(b=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.F(E.identifier,E.manifest.version)))),b.length&&await this.f.markAsUninstalled(...b)}C(b,P){let E=this.b.get(b);E||this.b.set(b,E=new D.$mi(m=>this.j.extUri.getComparisonKey(m))),E.add(P)}D(b,P){const E=this.b.get(b);E&&E.delete(P),E?.size||this.b.delete(b)}F(b,P){return`${L.$Fl.toKey(b.id)}@${P}`}G(b){const[P,E]=(0,j.$fo)(b);return E?{identifier:{id:P},version:E}:void 0}}e.$kp=R}),define(oe[219],ae([0,1,44,46]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Po=void 0;async function D(j,L,R,S,b,P,E){const m={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${L.nameShort})`};if((0,T.$8n)(L,R)&&(0,T.$0n)(S)===3){const h=await(0,I.$Oo)(R,b,P);m["X-Market-User-Id"]=h,m["VSCode-SessionId"]=E.machineId||h}return m}e.$Po=D}),define(oe[220],ae([0,1,67,21,6,2,26,16,31,15,29,33,8,70,10]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=void 0;let v=class extends h.$wq{constructor(y,p,C,t){super(C),this.h=y,this.i=t,this.g=this.B(new c(p,t)),this.h.registerParticipant({postInstall:async o=>this.j(o),postUninstall:async o=>this.k(o)})}async getBuiltInExtensionTranslationsUri(y,p){const t=(await this.g.getLanguagePacks())[p];if(!t){this.i.warn(`No language pack found for ${p}`);return}const o=t.translations[y];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const y=await this.g.getLanguagePacks(),p=Object.keys(y).map(C=>{const t=y[C];return{...this.f(C,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return p.push(this.f("en","English")),p.sort((C,t)=>C.label.localeCompare(t.label)),p}async j(y){y&&y.manifest&&y.manifest.contributes&&y.manifest.contributes.localizations&&y.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",y.identifier.id),await this.update())}async k(y){const p=await this.g.getLanguagePacks();Object.keys(p).some(C=>p[C]&&p[C].extensions.some(t=>(0,E.$do)(t.extensionIdentifier,y.identifier)))&&(this.i.info("Removing language packs from the extension",y.identifier.id),await this.update())}async update(){const[y,p]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),C=await this.g.update(p);return!(0,T.$af)(Object.keys(y),Object.keys(C))}};e.$xq=v,e.$xq=v=be([K(0,P.$Pn),K(1,b.$vh),K(2,P.$Nn),K(3,m.$Pi)],v);let c=class extends j.$lb{constructor(y,p){super(),this.i=p,this.c={},this.f=(0,R.$ac)(y.userDataPath,"languagepacks.json"),this.g=new D.$Ag}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(y){return this.m(p=>{Object.keys(p).forEach(C=>delete p[C]),this.j(p,...y)}).then(()=>this.c)}j(y,...p){for(const C of p)C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&this.k(y,C);Object.keys(y).forEach(C=>this.l(y[C]))}k(y,p){const C=p.identifier,t=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const o of t)if(p.location.scheme===L.Schemas.file&&l(o)){let n=y[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},y[o.languageId]=n);const s=n.extensions.filter(i=>(0,E.$do)(i.extensionIdentifier,C))[0];s?s.version=p.manifest.version:n.extensions.push({extensionIdentifier:C,version:p.manifest.version});for(const i of o.translations)n.translations[i.id]=(0,R.$ac)(p.location.fsPath,i.path)}}l(y){if(y){const p=(0,I.createHash)("md5");for(const C of y.extensions)p.update(C.extensionIdentifier.uuid||C.extensionIdentifier.id).update(C.version);y.hash=p.digest("hex")}}m(y=()=>null){return this.g.queue(()=>{let p=null;return S.Promises.readFile(this.f,"utf8").then(void 0,C=>C.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(C)).then(C=>{try{return JSON.parse(C)}catch{return{}}}).then(C=>(p=y(C),C)).then(C=>{for(const o of Object.keys(C))C[o]||delete C[o];this.c=C,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),S.Promises.writeFile(this.f,t)}).then(()=>p,C=>this.i.error(C))})}};c=be([K(0,b.$vh),K(1,m.$Pi)],c);function l(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const y of u.translations)if(typeof y.id!="string"||typeof y.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(oe[221],ae([0,1,139,7,30,46]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JM=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0",R="https://mobile.events.data.microsoft.com/ping";async function S(P,E,m){const h=await(0,I.$UC)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,I.$UC)("@microsoft/1ds-post-js","dist/ms.post.js"),v=new h.AppInsightsCore,c=new $.PostChannel,l={instrumentationKey:P,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[c]]};if(m){l.extensionConfig={};const u={alwaysUseXhrOverride:!0,httpXHROverride:m};l.extensionConfig[c.identifier]=u}return v.initialize(l,[]),v}class b{constructor(E,m,h,$,v){this.e=E,this.f=m,this.g=h,this.h=v,this.c=L,this.d=R,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=S(this.a,this.e,this.h)),this.b.then(m=>{E(m)},m=>{(0,T.$Y)(m),console.error(m)})}}log(E,m){if(!this.a)return;m=(0,D.$Im)(m,this.g),m=(0,j.$$n)(m);const h=this.f+"/"+E;try{this.i($=>{$.pluginVersionString=m?.properties.version??"Unknown",$.track({name:h,baseData:{name:h,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$JM=b}),define(oe[109],ae([0,1,2,163,15,8,24,46]),function(te,e,I,T,D,j,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P1b=void 0;let S=class extends I.$lb{constructor(P,E,m,h,$=""){super(),this.b=$;const v=E.getLogger(R.$4n);if(v)this.a=this.B(v);else{const l=(0,R.$9n)(h,m)?" (Not Sent)":"",u=()=>(0,R.$8n)(h,m)&&P.getLevel()===j.LogLevel.Trace;this.a=this.B(E.createLogger(R.$4n,{name:(0,T.localize)(0,null,l),hidden:!u()})),this.B(P.onDidChangeLogLevel(()=>E.setVisibility(R.$4n,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(P,E){this.a.trace(`${this.b}telemetry/${P}`,(0,R.$$n)(E))}};e.$P1b=S,e.$P1b=S=be([K(0,j.$Pi),K(1,j.$Qi),K(2,D.$uh),K(3,L.$8i)],S)}),define(oe[110],ae([0,1,2,30,5,27,164,18,49,102,24,40,20,46]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,u,y){this.k=u,this.l=y,this.d={},this.i=new I.$kb,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const p of this.f)this.j.push(new RegExp((0,j.$nd)(p),"gi")),p.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$nd)(p.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(p=>{(p.affectsConfiguration(m.$1k)||p.affectsConfiguration(m.$3k)||p.affectsConfiguration(m.$2k))&&this.m()}))}setExperimentProperty(l,u){this.d[l]=u}m(){let l=(0,h.$0n)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const y=u.usage?3:u.error?2:0;l=Math.min(l,y)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,u,y){this.g<u||(y=(0,T.$Im)(y,this.d),y=(0,h.$co)(y,this.j),y=(0,T.$Im)(y,this.c),this.b.forEach(p=>p.log(l,y)))}publicLog(l,u){this.n(l,3,u)}publicLog2(l,u){this.publicLog(l,u)}publicLogError(l,u){this.h&&this.n(l,2,u)}publicLogError2(l,u){this.publicLogError(l,u)}};e.$Dq=$,e.$Dq=$=be([K(1,R.$Th),K(2,P.$8i)],$);function v(){const c=(0,L.localize)(0,null,b.default.nameLong),l=b.default.privacyStatementUrl?(0,L.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,L.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=D.$o?"":(0,L.localize)(3,null),y=(0,L.localize)(4,null),p=(0,L.localize)(5,null),C=(0,L.localize)(6,null),t=(0,L.localize)(7,null),o=`
|       | ${y} | ${p} | ${C} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,L.localize)(8,null);return`
${c} ${l} ${u}

&nbsp;

${t}
${o}

&nbsp;

${n}
`}E.$Rm.as(S.$Wm.Configuration).registerConfiguration({id:m.$Zk,order:1,type:"object",title:(0,L.localize)(9,null),properties:{[m.$1k]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,L.localize)(10,null),(0,L.localize)(11,null),(0,L.localize)(12,null),(0,L.localize)(13,null)],markdownDescription:v(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Rm.as(S.$Wm.Configuration).registerConfiguration({id:m.$Zk,order:110,type:"object",title:(0,L.localize)(14,null),properties:{[m.$3k]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,L.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,L.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,L.localize)(17,null,`\`#${m.$1k}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[222],ae([0,1,14,25,221]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KM=void 0;async function j(S,b){const P=await b.request(S,T.CancellationToken.None),E=(await(0,I.$Vb)(P.stream)).toString(),m=P.res.statusCode??200;return{headers:P.res.headers,statusCode:m,responseData:E}}function L(S,b){const P={method:S.type,headers:S.headers},E=b.request(S.url??"",P,m=>{m.on("data",function(h){return{headers:m.headers,statusCode:m.statusCode??200,responseData:h.toString()}}),m.on("error",function(h){throw h})});E.write(S.data),E.end()}class R extends D.$JM{constructor(b,P,E,m,h){let $;b||($=te("https"));const v={sendPOST:(c,l)=>{const u=typeof c.data=="string"?c.data:new TextDecoder().decode(c.data),y={type:"POST",headers:{...c.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(c.data).toString()},url:c.urlString,data:u};try{if(b)j(y,b).then(({statusCode:p,headers:C,responseData:t})=>{l(p,C,t)});else{if(!$)throw new Error("https module is undefined");L(y,$)}}catch{l(0,{})}}};super(P,E,m,h,v)}}e.$KM=R}),define(oe[223],ae([0,1,26,93,18,15,8,24,20,108,109,110]),function(te,e,I,T,D,j,L,R,S,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z5b=void 0;let m=class{constructor($,v,c,l,u,y){this.b=$,this.c=v,this.d=c,this.e=l,this.f=u,this.g=y,this.a=new Map}h($){if(!this.a.has($.id)){const v=Object.create(null);v["common.vscodemachineid"]=this.c.machineId,v["common.vscodesessionid"]=this.c.sessionId;const c=[$.id,JSON.stringify(v),$.aiKey],u=new T.$Fp(I.$3e.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:c,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),y=[new b.$j4b(u),new P.$P1b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new E.$Dq({appenders:y,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,v,c){this.h($).publicLog(v,c)}publicLogError($,v,c){this.h($).publicLogError(v,c)}};e.$z5b=m,e.$z5b=m=be([K(0,D.$Th),K(1,S.$Tk),K(2,L.$Pi),K(3,L.$Qi),K(4,j.$uh),K(5,R.$8i)],m)}),define(oe[74],ae([0,1,3,18,4,8]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nz=e.$Mz=e.$Lz=e.$Kz=e.$Jz=e.$Iz=e.$Hz=e.$Gz=e.ProvidedOnAutoForward=e.$Fz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ez=e.$Dz=void 0,e.$Dz=(0,D.$nh)("tunnelService"),e.$Ez=(0,D.$nh)("sharedTunnelsService");var L;(function(c){c.Http="http",c.Https="https"})(L||(e.TunnelProtocol=L={}));var R;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(R||(e.TunnelPrivacyId=R={}));function S(c){return!!c.forwardPort}e.$Fz=S;var b;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function P(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const l=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(l)return{address:l[1],port:+l[2]}}e.$Gz=P,e.$Hz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(c){return e.$Hz.indexOf(c)>=0}e.$Iz=E,e.$Jz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(c){return e.$Jz.indexOf(c)>=0}e.$Kz=m;function h(c,l,u,y){if(u===1)return!1;if(u===2&&m(l)){const p=/(\d+)\.(\d+)\.(\d+)/g.exec(y);if(p?.length===4&&parseInt(p[1])>=18)return!1}return c<1024}e.$Lz=h;class ${constructor(l,u,y){this.remoteAddress=l,this.localAddress=u,this.b=y,this.a=new I.$7c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Mz=$;let v=class{constructor(l,u){this.i=l,this.j=u,this.a=new I.$7c,this.onTunnelOpened=this.a.event,this.b=new I.$7c,this.onTunnelClosed=this.b.event,this.c=new I.$7c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const l=this.j.getValue("remote.localPortHost");return!l||l==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(l){return this.e=l,l?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(l){this.f=l.elevation,this.g=l.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const l=[],u=Array.from(this.d.values());for(const y of u){const p=Array.from(y.values());for(const C of p){const t=await C.value;t&&l.push(t)}}return l}async dispose(){for(const l of this.d.values()){for(const{value:u}of l.values())await u.then(y=>y?.dispose());l.clear()}this.d.clear()}setEnvironmentTunnel(l,u,y,p,C){this.o(l,u,Promise.resolve({tunnelRemoteHost:l,tunnelRemotePort:u,localAddress:y,privacy:p,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(l,u){(m(l)||E(l))&&(l=e.$Hz[0]);const y=this.q(l,u);if(y)return++y.refcount,y.value}openTunnel(l,u,y,p,C,t=!1,o,n){this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${u}:${y} on local port ${C}.`);const s=this.e??l;if(!s)return;if(u||(u="localhost"),p||(p=this.k),this.e&&this.h.has(y)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(s,u,y,p,C,t,o,n);return i?i.then(r=>{if(!r){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(u,y);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.m(r);return(r.tunnelRemoteHost!==u||r.tunnelRemotePort!==y)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(l){return{tunnelRemotePort:l.tunnelRemotePort,tunnelRemoteHost:l.tunnelRemoteHost,tunnelLocalPort:l.tunnelLocalPort,localAddress:l.localAddress,privacy:l.privacy,protocol:l.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${l.tunnelRemoteHost}:${l.tunnelRemotePort} `);const u=this.d.get(l.tunnelRemoteHost);if(u){const y=u.get(l.tunnelRemotePort);y&&(y.refcount--,await this.n(l.tunnelRemoteHost,l.tunnelRemotePort,y))}}}}async n(l,u,y){if(y.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${l}:${u}.`);const p=y.value.then(async C=>{C&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.d.has(l)&&this.d.get(l).delete(u),p}}async closeTunnel(l,u){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${l}:${u} `);const y=this.d.get(l);if(y&&y.has(u)){const p=y.get(u);p.refcount=0,await this.n(l,u,p)}}o(l,u,y){this.d.has(l)||this.d.set(l,new Map),this.d.get(l).set(u,{refcount:1,value:y})}async p(l,u){const y=this.d.get(l);if(y){const p=y.get(u);(p?await p.value:void 0)||y.delete(u),y.size===0&&this.d.delete(l)}}q(l,u){const y=[l];E(l)?(y.push(...e.$Hz),y.push(...e.$Jz)):m(l)&&y.push(...e.$Jz);const p=y.map(C=>this.d.get(C));for(const C of p){const t=C?.get(u);if(t)return t}}canTunnel(l){return!!P(l)}s(l,u,y,p,C,t,o){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${u}:${y} on local port ${p}.`);const n=y;this.h.add(n);const s=p===void 0?y:p,i={elevationRequired:C?this.isPortPrivileged(s):!1},r={remoteAddress:{host:u,port:y},localAddressPort:p,privacy:t,public:t?t!==R.Private:void 0,protocol:o},a=l.forwardPort(r,i);return a?(this.o(u,y,a),a.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(n)})):this.h.delete(n),a}};e.$Nz=v,e.$Nz=v=be([K(0,j.$Pi),K(1,T.$Th)],v)}),define(oe[224],ae([0,1,8,74,2,7,6]),function(te,e,I,T,D,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M5b=void 0;class R extends D.$lb{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new L.$Ng),this.b.p)}setAddress(P){this.a=P,this.b&&(this.b.complete(P),this.b=null)}setTunnel(P){this.B(P)}}let S=class kt extends D.$lb{static{this.a=0}constructor(P,E){super(),this.f=P,this.g=E,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(P=>P.dispose())}async createTunnel(){return{id:String(++kt.a)}}async startTunnel(P,E,m,h,$,v,c){const l=new R,u=await Promise.resolve(this.f.openTunnel(P,l,m,h,$,v,c));if(!u)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${h} (remote).`),l.dispose(),new Error("Could not create tunnel");if(this.c.has(E))throw this.c.delete(E),l.dispose(),await u.dispose(),(0,j.$4)();return l.setTunnel(u),this.b.set(E,l),this.g.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${u.localAddress} (local) to ${m}:${h} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(P,E){const m=this.b.get(P);m&&m.setAddress(E)}async destroyTunnel(P){const E=this.b.get(P);if(E){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${P}.`),this.b.delete(P),await E.dispose();return}this.c.add(P)}};e.$M5b=S,e.$M5b=S=be([K(0,T.$Ez),K(1,I.$Pi)],S)}),define(oe[225],ae([0,1,60,36,130,6,2,18,8,24,209,74,106,5,104]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$24b=e.$14b=e.$Z4b=void 0;async function v(p,C,t,o,n){let s;for(let i=3;i&&(s?.dispose(),s=await new c(p,C,t,o,n).waitForReady(),!(n&&D.$8e[n]||!D.$8e[s.tunnelLocalPort]));i--);return s}class c extends L.$lb{constructor(C,t,o,n,s){super(),this.j=t,this.k=s,this.privacy=E.TunnelPrivacyId.Private,this.i=new Map,this.a=C,this.b=I.createServer(),this.c=new j.$sg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=i=>this.l(i),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=o}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const C=this.k??this.tunnelRemotePort,t=(0,E.$Kz)(this.j)?"0.0.0.0":"127.0.0.1";let o=await(0,D.$9e)(C,2,1e3,t),n=null;return this.b.listen(o,this.j),await this.c.wait(),n=this.b.address(),n||(o=0,this.b.listen(o,this.j),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async l(C){C.pause();const t=(0,E.$Iz)(this.tunnelRemoteHost)||(0,E.$Kz)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,o=await(0,P.$Kk)(this.a,t,this.tunnelRemotePort),n=o.getSocket().socket,s=o.readEntireBuffer();o.dispose(),s.byteLength>0&&C.write(s.buffer),C.on("end",()=>{C.localAddress&&this.i.delete(C.localAddress),n.end()}),C.on("close",()=>n.end()),C.on("error",()=>{C.localAddress&&this.i.delete(C.localAddress),n.destroy()}),n.on("end",()=>C.end()),n.on("close",()=>C.end()),n.on("error",()=>{C.destroy()}),C.pipe(n),n.pipe(C),C.localAddress&&this.i.set(C.localAddress,()=>{C.end(),n.end()})}}let l=class extends E.$Nz{constructor(C,t,o,n,s){super(t,s),this.t=C,this.u=o,this.v=n}isPortPrivileged(C){return(0,E.$Lz)(C,this.k,h.OS,T.release())}r(C,t,o,n,s,i,r,a){const w=this.q(t,o);if(w)return++w.refcount,w.value;if((0,E.$Fz)(C))return this.s(C,t,o,s,i,r,a);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${o} on local port ${s}.`);const g={commit:this.v.commit,quality:this.v.quality,addressProvider:C,remoteSocketFactoryService:this.t,signService:this.u,logService:this.i,ipcLogger:null},f=v(g,n,t,o,s);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,o,f),f}}};e.$Z4b=l,e.$Z4b=l=be([K(0,$.$Ek),K(1,S.$Pi),K(2,m.$Hk),K(3,b.$8i),K(4,R.$Th)],l);let u=class extends l{constructor(C,t,o,n,s){super(C,t,o,n,s)}};e.$14b=u,e.$14b=u=be([K(0,$.$Ek),K(1,S.$Pi),K(2,m.$Hk),K(3,b.$8i),K(4,R.$Th)],u);let y=class extends L.$lb{constructor(C,t,o,n,s){super(),this.b=C,this.c=t,this.f=o,this.g=n,this.h=s,this.a=new Map}async openTunnel(C,t,o,n,s,i,r,a,w){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${o}:${n} on local port ${i}.`),!this.a.has(C)){const g=new u(this.b,this.c,this.g,this.f,this.h);this.B(g),this.a.set(C,g),g.onTunnelClosed(async()=>{(await g.tunnels).length===0&&(g.dispose(),this.a.delete(C))})}return this.a.get(C).openTunnel(t,o,n,s,i,r,a,w)}};e.$24b=y,e.$24b=y=be([K(0,$.$Ek),K(1,S.$Pi),K(2,b.$8i),K(3,m.$Hk),K(4,R.$Th)],y)}),define(oe[28],ae([0,1,4]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=void 0,e.$nk=(0,I.$nh)("IUriIdentityService")}),define(oe[226],ae([0,1,28,181,13,22,124,3,2]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=void 0;class b{static{this._clock=0}constructor(m){this.uri=m,this.time=b._clock++}touch(){return this.time=b._clock++,this}}let P=class{constructor(m){this.g=m,this.c=new S.$kb,this.f=2**16;const h=new Map,$=v=>{let c=h.get(v.scheme);return c===void 0&&(c=m.hasProvider(v)&&!this.g.hasCapability(v,1024),h.set(v.scheme,c)),c};this.c.add(R.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(v=>{h.delete(v.scheme)})),this.extUri=new j.$Wf($),this.d=new L.$_q((v,c)=>this.extUri.compare(v,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,j.$9f)(m));const h=this.d.get(m);return h?h.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new b(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort(($,v)=>$[1].time<v[1].time?1:$[1].time>v[1].time?-1:0);b._clock=0,this.d.clear();const h=this.f*.5;for(let $=0;$<h;$++)this.d.set(m[$][0],m[$][1].touch())}};e.$ar=P,e.$ar=P=be([K(0,D.$Qj)],P),(0,T.$0q)(I.$nk,P,1)}),define(oe[227],ae([0,1,3,2,13,42,47,14]),function(te,e,I,T,D,j,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$74b=void 0;class S extends T.$lb{get capabilities(){return this.f.capabilities&-5}constructor(P,E,m,h){super(),this.c=P,this.f=E,this.g=m,this.h=h,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new I.$7c),this.onDidChangeFile=this.a.event,this.b=L.$th.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile($=>this.i($)))}watch(P,E){this.b.set(P,P);const m=this.f.watch(this.j(P),E);return(0,T.$jb)(()=>{this.b.delete(P),m.dispose()})}stat(P){return this.f.stat(this.j(P))}mkdir(P){return this.f.mkdir(this.j(P))}rename(P,E,m){return this.f.rename(this.j(P),this.j(E),m)}readFile(P){return this.f.readFile(this.j(P),{atomic:!0})}readFileStream(P,E,m){const h=(0,j.$xb)($=>R.$Jb.concat($.map(v=>R.$Jb.wrap(v))).buffer);return(async()=>{try{const $=await this.readFile(P);h.end($)}catch($){h.error($),h.end()}})(),h}readdir(P){return this.f.readdir(this.j(P))}writeFile(P,E,m){return this.f.writeFile(this.j(P),E,m)}delete(P,E){return this.f.delete(this.j(P),E)}copy(P,E,m){if((0,D.$Tj)(this.f))return this.f.copy(this.j(P),this.j(E),m);throw new Error("copy not supported")}i(P){const E=[];for(const m of P){if(m.resource.scheme!==this.c)continue;const h=this.k(m.resource);this.b.findSubstr(h)&&E.push({resource:h,type:m.type})}E.length&&(this.h.debug("User data changed"),this.a.fire(E))}j(P){return P.with({scheme:this.c})}k(P){return P.with({scheme:this.g})}}e.$74b=S}),define(oe[75],ae([0,1,83]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cxb=e.$Bxb=e.edit=void 0;function T(L,R,S,b){const P=(0,I.$6R)(L,R,S,b)[0];return P&&(L=L.substring(0,P.offset)+P.content+L.substring(P.offset+P.length)),L}e.edit=T;function D(L,R,S){let b=S;for(;b>=0;){if(L.charAt(b)===R.charAt(R.length-1)&&R.length===1)return b+1;if(b--,R.length===2&&b>=0&&L.charAt(b)===R.charAt(0))return b+2}return 0}e.$Bxb=D;function j(L,R,S){let b=S;for(;b>=0;)if(L.charAt(b)===R.charAt(R.length-1)&&R.length===1||(b++,R.length===2&&b>=0&&L.charAt(b)===R.charAt(1)))return b;return L.length-1}e.$Cxb=j}),define(oe[228],ae([0,1,30,53,11]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yZb=void 0;function j(h,$,v,c,l,u){const y=[],p=[],C=[];if(!$){const q=h.filter(({identifier:J})=>l.every(Q=>Q.toLowerCase()!==J.id.toLowerCase()));return{local:{added:y,removed:p,updated:C},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}h=h.map(E),$=$.map(E),v=v?v.map(E):null;const t=new Map,o=q=>{q.uuid&&t.set(q.id.toLowerCase(),q.uuid)};h.forEach(({identifier:q})=>o(q)),$.forEach(({identifier:q})=>o(q)),v?.forEach(({identifier:q})=>o(q));const n=q=>{const J=q.identifier.uuid||t.get(q.identifier.id.toLowerCase());return J?`uuid:${J}`:`id:${q.identifier.id.toLowerCase()}`},s=(q,J)=>(q.set(n(J),J),q),i=h.reduce(s,new Map),r=$.reduce(s,new Map),a=$.reduce((q,J)=>s(q,(0,I.$Fm)(J)),new Map),w=v?v.reduce(s,new Map):null,g=c.reduce(s,new Map),f=l.reduce((q,J)=>{const Q=t.get(J.toLowerCase());return q.add(Q?`uuid:${Q}`:`id:${J.toLowerCase()}`)},new Set),k=u?u.reduce((q,{id:J,uuid:Q})=>(Q=Q??t.get(J.toLowerCase()),q.add(Q?`uuid:${Q}`:`id:${J.toLowerCase()}`)),new Set):null,N=L(i,r,f,!1);if(N.added.size>0||N.removed.size>0||N.updated.size>0){const q=L(w,i,f,!1),J=L(w,r,f,!0),Q=(Y,Z,x,H)=>{let B,V,ee;return Z.installed?(B=H.pinned,ee=H.preRelease,B&&(V=H.version)):(B=x.pinned,ee=x.preRelease,B&&(V=x.version)),B===void 0&&(B=Z.pinned,B&&(V=Z.version)),ee===void 0&&(ee=Z.preRelease),{...H,installed:Z.installed||x.installed,pinned:B,preRelease:ee,version:V??(x.version&&(!Z.installed||T.gt(x.version,Z.version))?x.version:Z.version),state:S(Z,x,w?.get(Y))}};for(const Y of J.removed.values()){const Z=i.get(Y);if(!Z)continue;const x=(0,D.$te)(w?.get(Y)),H=k&&!k.has(Y)&&x.installed;Z.installed&&H?p.push(Z.identifier):a.set(Y,Z)}for(const Y of J.added.values()){const Z=(0,D.$te)(r.get(Y)),x=i.get(Y);if(x){if(N.updated.has(Y)){const H=Q(Y,x,Z,Z);R(x,Z,!1,!1)||C.push(m(H,Y)),a.set(Y,H)}}else Z.installed&&y.push(m(Z,Y))}for(const Y of J.updated.values()){const Z=(0,D.$te)(r.get(Y)),x=(0,D.$te)(w?.get(Y)),H=i.get(Y);if(H)if(k&&!k.has(Y)&&x.installed&&H.installed&&!Z.installed)p.push(H.identifier);else{const V=Q(Y,H,Z,Z);C.push(m(V,Y)),a.set(Y,V)}else Z.installed&&y.push(m(Z,Y))}for(const Y of q.added.values())J.added.has(Y)||a.set(Y,(0,D.$te)(i.get(Y)));for(const Y of q.updated.values()){if(J.removed.has(Y)||J.updated.has(Y))continue;const Z=(0,D.$te)(i.get(Y)),x=(0,D.$te)(r.get(Y));a.set(Y,Q(Y,Z,x,Z))}for(const Y of q.removed.values())J.updated.has(Y)||J.removed.has(Y)||g.has(Y)||(0,D.$te)(r.get(Y)).installed&&k&&(k.has(Y)||!(0,D.$te)(w?.get(Y)).installed||a.delete(Y))}const M=[],F=L(r,a,new Set,!0),W=F.added.size>0||F.updated.size>0||F.removed.size>0;return W&&a.forEach((q,J)=>M.push(m(q,J))),{local:{added:y,removed:p,updated:C},remote:W?{added:[...F.added].map(q=>a.get(q)),updated:[...F.updated].map(q=>a.get(q)),removed:[...F.removed].map(q=>r.get(q)),all:M}:null}}e.$yZb=j;function L(h,$,v,c){const l=h?[...h.keys()].filter(t=>!v.has(t)):[],u=[...$.keys()].filter(t=>!v.has(t)),y=u.filter(t=>!l.includes(t)).reduce((t,o)=>(t.add(o),t),new Set),p=l.filter(t=>!u.includes(t)).reduce((t,o)=>(t.add(o),t),new Set),C=new Set;for(const t of l){if(p.has(t))continue;const o=h.get(t),n=$.get(t);(!n||!R(o,n,c,!0))&&C.add(t)}return{added:y,removed:p,updated:C}}function R(h,$,v,c){return!(h.disabled!==$.disabled||!!h.isApplicationScoped!=!!$.isApplicationScoped||c&&h.installed!==$.installed||h.installed&&$.installed&&(h.preRelease!==$.preRelease||h.pinned!==$.pinned||$.pinned&&h.version!==$.version)||!P(h.state,$.state)||v&&h.version!==$.version)}function S(h,$,v){const c=h.state,l=$.state,u=v?.state;if(!$.version||c&&T.gt(h.version,$.version))return c;if(l&&T.gt($.version,h.version)||!c)return l;if(!l)return c;const y=(0,I.$Fm)(c),p=u?b(u,l):{added:Object.keys(l).reduce((t,o)=>(t.add(o),t),new Set),removed:new Set,updated:new Set},C=u?b(u,c):{added:Object.keys(c).reduce((t,o)=>(t.add(o),t),new Set),removed:new Set,updated:new Set};for(const t of[...p.added.values(),...p.updated.values()])y[t]=l[t];for(const t of p.removed.values())C.updated.has(t)||delete y[t];return y}function b(h,$){const v=Object.keys(h),c=Object.keys($),l=c.filter(p=>!v.includes(p)).reduce((p,C)=>(p.add(C),p),new Set),u=v.filter(p=>!c.includes(p)).reduce((p,C)=>(p.add(C),p),new Set),y=new Set;for(const p of v){if(u.has(p))continue;const C=h[p],t=$[p];(0,I.$Jm)(C,t)||y.add(p)}return{added:l,removed:u,updated:y}}function P(h={},$={}){const{added:v,removed:c,updated:l}=b(h,$);return v.size===0&&c.size===0&&l.size===0}function E(h){return{...h,disabled:!!h.disabled,installed:!!h.installed}}function m(h,$){const v={...h,identifier:{id:h.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!h.preRelease,pinned:!!h.pinned};return h.disabled||delete v.disabled,h.installed||delete v.installed,h.state||delete v.state,h.isApplicationScoped||delete v.isApplicationScoped,v}}),define(oe[111],ae([0,1,21,18,4]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uzb=e.$tzb=void 0,e.$tzb=(0,D.$nh)("IIgnoredExtensionsManagementService");let j=class{constructor(R){this.a=R}hasToNeverSyncExtension(R){return this.b().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.b().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,S){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return b=b.filter(P=>P!==R&&P!==`-${R}`),S&&b.push(R.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}updateSynchronizedExtensions(R,S){let b=[...this.a.getValue("settingsSync.ignoredExtensions")].map(P=>P.toLowerCase());return b=b.filter(P=>P!==R&&P!==`-${R}`),S&&b.push(`-${R.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",b.length?b:void 0,2)}getIgnoredExtensions(R){const S=R.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),b=this.b().map(m=>m.toLowerCase()),P=[],E=[];if(Array.isArray(b))for(const m of b)m.startsWith("-")?E.push(m.substring(1)):P.push(m);return(0,I.$qf)([...S,...P].filter(m=>!E.includes(m)))}b(){let R=this.a.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.a.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};e.$uzb=j,e.$uzb=j=be([K(0,T.$Th)],j)}),define(oe[229],ae([0,1,21,34,30,94,75]),function(te,e,I,T,D,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EZb=void 0;function R(p){return(0,T.$vm)(p)||[]}async function S(p,C,t,o,n){const s=R(p),i=R(C),r=t?R(t):null,a=[...s,...i,...r||[]].map(Q=>Q.key),w=await n.resolveUserBindings(a),g=P(s,i,r,w);if(!g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:p,hasChanges:!1,hasConflicts:!1};if(!g.hasLocalForwarded&&g.hasRemoteForwarded)return{mergeContent:C,hasChanges:!0,hasConflicts:!1};if(g.hasLocalForwarded&&!g.hasRemoteForwarded)return{mergeContent:p,hasChanges:!0,hasConflicts:!1};const f=m(s),k=m(i),N=r?m(r):null,M=$(f,k,w),F=N?$(N,f,w):{added:[...f.keys()].reduce((Q,Y)=>(Q.add(Y),Q),new Set),removed:new Set,updated:new Set},W=N?$(N,k,w):{added:[...k.keys()].reduce((Q,Y)=>(Q.add(Y),Q),new Set),removed:new Set,updated:new Set},q=b(M,F,W);let J=p;for(const Q of q.removed.values())q.conflicts.has(Q)||(J=u(J,Q,o));for(const Q of q.added.values()){if(q.conflicts.has(Q))continue;const Y=k.get(Q);if(Y.some(Z=>Z.command!==`-${Q}`&&g.conflicts.has(w[Z.key]))){q.conflicts.add(Q);continue}J=l(J,Y,o)}for(const Q of q.updated.values()){if(q.conflicts.has(Q))continue;const Y=k.get(Q);if(Y.some(Z=>Z.command!==`-${Q}`&&g.conflicts.has(w[Z.key]))){q.conflicts.add(Q);continue}J=y(J,Q,Y,o)}return{mergeContent:J,hasChanges:!0,hasConflicts:q.conflicts.size>0}}e.$EZb=S;function b(p,C,t){const o=new Set,n=new Set,s=new Set,i=new Set;for(const r of C.removed.values())t.updated.has(r)&&i.add(r);for(const r of t.removed.values())i.has(r)||(C.updated.has(r)?i.add(r):n.add(r));for(const r of C.added.values())i.has(r)||t.added.has(r)&&p.updated.has(r)&&i.add(r);for(const r of t.added.values())i.has(r)||(C.added.has(r)?p.updated.has(r)&&i.add(r):o.add(r));for(const r of C.updated.values())i.has(r)||t.updated.has(r)&&p.updated.has(r)&&i.add(r);for(const r of t.updated.values())i.has(r)||(C.updated.has(r)?p.updated.has(r)&&i.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:i}}function P(p,C,t,o){const n=new Set,s=E(p,o),i=E(C,o),r=t?E(t,o):null,a=h(s,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const w=r?h(r,s):{added:[...s.keys()].reduce((F,W)=>(F.add(W),F),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const g=r?h(r,i):{added:[...i.keys()].reduce((F,W)=>(F.add(W),F),new Set),removed:new Set,updated:new Set};if(g.added.size===0&&g.removed.size===0&&g.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:f,removed:k,updated:N,conflicts:M}=b(a,w,g);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:k,updated:N,conflicts:M}}function E(p,C){const t=new Map;for(const o of p){const n=C[o.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(o)}return t}function m(p){const C=new Map;for(const t of p){const o=t.command[0]==="-"?t.command.substring(1):t.command;let n=C.get(o);n||(n=[],C.set(o,n)),n.push(t)}return C}function h(p,C){const t=[...p.keys()],o=[...C.keys()],n=o.filter(r=>!t.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=t.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),i=new Set;for(const r of t){if(s.has(r))continue;const a=p.get(r).map(g=>({...g,key:r})),w=C.get(r).map(g=>({...g,key:r}));(0,I.$af)(a,w,(g,f)=>c(g,f))||i.add(r)}return{added:n,removed:s,updated:i}}function $(p,C,t){const o=[...p.keys()],n=[...C.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),i=o.filter(a=>!n.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),r=new Set;for(const a of o){if(i.has(a))continue;const w=p.get(a).map(f=>({...f,key:t[f.key]})),g=C.get(a).map(f=>({...f,key:t[f.key]}));v(w,g)||r.add(a)}return{added:s,removed:i,updated:r}}function v(p,C){return!(!(0,I.$af)(p.filter(({command:t})=>t[0]!=="-"),C.filter(({command:t})=>t[0]!=="-"),(t,o)=>c(t,o))||!(0,I.$af)(p.filter(({command:t})=>t[0]==="-"),C.filter(({command:t})=>t[0]==="-"),(t,o)=>c(t,o)))}function c(p,C){if(p.command!==C.command||p.key!==C.key)return!1;const t=j.$ti.deserialize(p.when),o=j.$ti.deserialize(C.when);return!(t&&!o||!t&&o||t&&o&&!t.equals(o)||!D.$Jm(p.args,C.args))}function l(p,C,t){for(const o of C)p=L.edit(p,[-1],o,t);return p}function u(p,C,t){const o=R(p);for(let n=o.length-1;n>=0;n--)(o[n].command===C||o[n].command===`-${C}`)&&(p=L.edit(p,[n],void 0,t));return p}function y(p,C,t,o){const n=R(p),s=n.findIndex(i=>i.command===C||i.command===`-${C}`);for(let i=n.length-1;i>=0;i--)(n[i].command===C||n[i].command===`-${C}`)&&(p=L.edit(p,[i],void 0,o));for(let i=t.length-1;i>=0;i--)p=L.edit(p,[s],t[i],o);return p}}),define(oe[230],ae([0,1]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MZb=e.$LZb=void 0;function I(j,L,R){const S={},b={},P=new Set;if(!L)return{local:{added:S,updated:b,removed:[...P.values()]},remote:{added:j,updated:{},removed:[]},conflicts:[]};const E=T(j,L);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:S,updated:b,removed:[...P.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=T(R,j),h=T(R,L),$={},v={},c=new Set,l=new Set;for(const u of m.removed.values())h.updated.has(u)?S[u]=L[u]:c.add(u);for(const u of h.removed.values())l.has(u)||(m.updated.has(u)?l.add(u):P.add(u));for(const u of m.updated.values())l.has(u)||(h.updated.has(u)?E.updated.has(u)&&l.add(u):v[u]=j[u]);for(const u of h.updated.values())l.has(u)||(m.updated.has(u)?E.updated.has(u)&&l.add(u):j[u]!==void 0&&(b[u]=L[u]));for(const u of m.added.values())l.has(u)||(h.added.has(u)?E.updated.has(u)&&l.add(u):$[u]=j[u]);for(const u of h.added.values())l.has(u)||(m.added.has(u)?E.updated.has(u)&&l.add(u):S[u]=L[u]);return{local:{added:S,removed:[...P.values()],updated:b},remote:{added:$,removed:[...c.values()],updated:v},conflicts:[...l.values()]}}e.$LZb=I;function T(j,L){const R=j?Object.keys(j):[],S=L?Object.keys(L):[],b=S.filter(m=>!R.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),P=R.filter(m=>!S.includes(m)).reduce((m,h)=>(m.add(h),m),new Set),E=new Set;for(const m of R){if(P.has(m))continue;const h=j[m],$=L[m];h!==$&&E.add(m)}return{added:b,removed:P,updated:E}}function D(j,L){const{added:R,removed:S,updated:b}=T(j,L);return R.size===0&&S.size===0&&b.size===0}e.$MZb=D}),define(oe[231],ae([0,1,30]),function(te,e,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s2b=void 0;function T(j,L,R,S){const b={added:[],removed:[],updated:[]};let P={added:[],removed:[],updated:[]};if(!L){const m=j.filter(({id:h})=>!S.includes(h));return m.length?P.added=m:P=null,{local:b,remote:P}}const E=D(j,L,S);if(E.added.length>0||E.removed.length>0||E.updated.length>0){const m=D(R,j,S),h=D(R,L,S);for(const $ of h.removed){const v=j.find(c=>c.id===$);v&&b.removed.push(v)}for(const $ of h.added){const v=L.find(c=>c.id===$);m.added.includes($)?E.updated.includes($)&&b.updated.push(v):b.added.push(v)}for(const $ of h.updated)b.updated.push(L.find(v=>v.id===$));for(const $ of m.added)h.added.includes($)||P.added.push(j.find(v=>v.id===$));for(const $ of m.updated)h.removed.includes($)||h.updated.includes($)||P.updated.push(j.find(v=>v.id===$));for(const $ of m.removed){const v=L.find(c=>c.id===$);v&&P.removed.push(v)}}return P.added.length===0&&P.removed.length===0&&P.updated.length===0&&(P=null),{local:b,remote:P}}e.$s2b=T;function D(j,L,R){j=j?j.filter(({id:h})=>!R.includes(h)):[],L=L.filter(({id:h})=>!R.includes(h));const S=j.map(({id:h})=>h),b=L.map(({id:h})=>h),P=b.filter(h=>!S.includes(h)),E=S.filter(h=>!b.includes(h)),m=[];for(const{id:h,name:$,shortName:v,useDefaultFlags:c}of j){if(E.includes(h))continue;const l=L.find(u=>u.id===h);(!l||l.name!==$||l.shortName!==v||!(0,I.$Jm)(l.useDefaultFlags,c))&&m.push(h)}return{added:P,removed:E,updated:m}}}),define(oe[23],ae([0,1,21,11,170,49,29,4,103,40]),function(te,e,I,T,D,j,L,R,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$eb=e.$0eb=e.$9eb=e.$8eb=e.$7eb=e.$6eb=e.$5eb=e.$4eb=e.$3eb=e.$2eb=e.$1eb=e.MergeState=e.Change=e.SyncStatus=e.$Zeb=e.$Yeb=e.$Xeb=e.UserDataSyncErrorCode=e.$Web=e.$Veb=e.$Ueb=e.$Teb=e.$Seb=e.$Reb=e.$Qeb=e.$Peb=e.$Oeb=e.SyncResource=e.$Neb=e.$Meb=e.$Leb=e.$Keb=e.$Jeb=e.$Ieb=void 0;function P(){const i=b.$Rm.as(j.$Wm.Configuration).getConfigurationProperties();return Object.keys(i).filter(r=>!!i[r].disallowSyncIgnore)}e.$Ieb=P;function E(){const i=b.$Rm.as(j.$Wm.Configuration).getConfigurationProperties(),r=Object.keys(i).filter(g=>!!i[g].ignoreSync),a=Object.keys(i).filter(g=>i[g].scope===2||i[g].scope===6),w=P();return(0,I.$qf)([...r,...a,...w])}e.$Jeb=E,e.$Keb="settingsSync",e.$Leb="settingsSync.keybindingsPerPlatform";function m(){const i="vscode://schemas/ignoredSettings",r=b.$Rm.as(j.$Wm.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.$Leb]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:L.$Bn,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=b.$Rm.as(S.$Sm.JSONContribution),w=()=>{const g=P(),f=E(),k=Object.keys(j.$Xm.properties).filter(F=>!f.includes(F)),N=f.filter(F=>!g.includes(F)),M={items:{type:"string",enum:[...k,...N.map(F=>`-${F}`)]}};a.registerSchema(i,M)};return r.onDidUpdateConfiguration(()=>w())}e.$Meb=m;function h(i){return i&&(0,T.$ke)(i)&&(0,T.$ie)(i.id)&&Array.isArray(i.scopes)}e.$Neb=h;var $;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$Oeb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function v(i,...r){return i?[i,...r]:r}e.$Peb=v;function c(i,r,a,w){return w.joinPath(a.userDataSyncHome,...v(i,r,`lastSync${r}.json`))}e.$Qeb=c,e.$Reb=(0,R.$nh)("IUserDataSyncStoreManagementService"),e.$Seb=(0,R.$nh)("IUserDataSyncStoreService"),e.$Teb=(0,R.$nh)("IUserDataSyncBackupStoreService"),e.$Ueb="x-operation-id",e.$Veb="X-Execution-Id";function l(i){const r={};return r[e.$Veb]=i,r}e.$Web=l;var u;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class y extends Error{constructor(r,a,w,g){super(r),this.code=a,this.resource=w,this.operationId=g,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Xeb=y;class p extends y{constructor(r,a,w,g,f){super(r,w,void 0,f),this.url=a,this.serverCode=g}}e.$Yeb=p;class C extends y{constructor(r,a){super(r,a)}}e.$Zeb=C,function(i){function r(a){if(a instanceof i)return a;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(w&&w[1]){const g=w[2]==="unknown"?void 0:w[2],f=w[3]==="unknown"?void 0:w[3];return new i(a.message,w[1],g,f)}return new i(a.message,"Unknown")}i.toUserDataSyncError=r}(y||(e.$Xeb=y={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var o;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.$1eb="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.$2eb=s,e.$3eb=(0,R.$nh)("IUserDataSyncEnablementService"),e.$4eb=(0,R.$nh)("IUserDataSyncService"),e.$5eb=(0,R.$nh)("IUserDataSyncResourceProviderService"),e.$6eb=(0,R.$nh)("IUserDataAutoSyncService"),e.$7eb=(0,R.$nh)("IUserDataSyncUtilService"),e.$8eb=(0,R.$nh)("IUserDataSyncLogService"),e.$9eb="userDataSync",e.$0eb="vscode-userdata-sync",e.$$eb="preview"}),define(oe[232],ae([0,1,30,23]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pyb=void 0;function D(L,R,S,b,P){if(!R)return{remote:{added:Object.keys(L),removed:[],updated:[],all:Object.keys(L).length>0?L:null},local:{added:{},removed:[],updated:{}}};const E=j(L,R);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=S?j(S,R):{added:Object.keys(R).reduce((u,y)=>(u.add(y),u),new Set),removed:new Set,updated:new Set},h=S?j(S,L):{added:Object.keys(L).reduce((u,y)=>(u.add(y),u),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},v=I.$Fm(R),c=!S;for(const u of h.added.values())u!==T.$1eb&&c&&m.added.has(u)||(v[u]=L[u]);for(const u of h.updated.values())v[u]=L[u];for(const u of h.removed.values())b.unregistered.includes(u)||delete v[u];for(const u of m.added.values()){const y=R[u];if(b.machine.includes(u)){P.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(S&&h.added.has(u))continue;const p=L[u];p&&p.value===y.value||u===T.$1eb&&c&&h.added.has(u)||(p?$.updated[u]=y:$.added[u]=y)}for(const u of m.updated.values()){const y=R[u];if(b.machine.includes(u)){P.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(u)||h.removed.has(u))continue;const p=L[u];p&&p.value===y.value||($.updated[u]=y)}for(const u of m.removed.values()){if(b.machine.includes(u)){P.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}h.updated.has(u)||h.removed.has(u)||$.removed.push(u)}const l=j(R,v);return{local:$,remote:{added:[...l.added],updated:[...l.updated],removed:[...l.removed],all:l.added.size===0&&l.removed.size===0&&l.updated.size===0?null:v}}}e.$Pyb=D;function j(L,R){const S=Object.keys(L),b=Object.keys(R),P=b.filter(h=>!S.includes(h)).reduce((h,$)=>(h.add($),h),new Set),E=S.filter(h=>!b.includes(h)).reduce((h,$)=>(h.add($),h),new Set),m=new Set;for(const h of S){if(E.has(h))continue;const $=L[h],v=R[h];I.$Jm($,v)||m.add(h)}return{added:P,removed:E,updated:m}}}),define(oe[233],ae([0,1,21,34,83,41,30,75,23]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ixb=e.$Hxb=e.$Gxb=e.$Fxb=e.$Exb=e.$Dxb=void 0;function b(a,w,g){let f=[];g?f=E(g):f=P(w);const k=[],N=[...(0,S.$Ieb)()];if(Array.isArray(f))for(const M of f)M.startsWith("-")?N.push(M.substring(1)):k.push(M);return(0,I.$qf)([...a,...k].filter(M=>!N.includes(M)))}e.$Dxb=b;function P(a){let w=a.inspect("settingsSync.ignoredSettings").userValue;return w!==void 0||(w=a.inspect("sync.ignoredSettings").userValue,w!==void 0)?w:a.getValue("settingsSync.ignoredSettings")||[]}function E(a){const w=(0,T.$vm)(a);return w?w["settingsSync.ignoredSettings"]||w["sync.ignoredSettings"]||[]:[]}function m(a,w){const g=(0,T.$vm)(a)||{};let f="{}";for(const k of Object.keys(g)){const N=(0,D.$6R)(f,[k],g[k],w);f=(0,D.$9R)(f,N)}return f}e.$Exb=m;function h(a,w,g,f){if(g.length){const k=r(w),N=(0,T.$vm)(w)||{},M=(0,T.$vm)(a);if(!M)return a;const F=[];for(const W of g){const q=N[W],J=M[W];q===void 0?a=R.edit(a,[W],void 0,f):J!==void 0?a=R.edit(a,[W],q,f):F.push(t(W,k))}F.sort((W,q)=>W.startOffset-q.startOffset),F.forEach(W=>a=u(W.setting.key,w,a,f))}return a}e.$Fxb=h;function $(a,w,g,f,k,N){const M=h(a,w,f,N),F=g!==M,W=g!==w;if(!F&&!W)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(F&&!W)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(W&&!F)return{conflictsSettings:[],localContent:h(w,a,f,N),remoteContent:null,hasConflicts:!1};if(g===null&&c(a)){const O=v(a,w,f)?null:h(w,a,f,N);return{conflictsSettings:[],localContent:O,remoteContent:null,hasConflicts:!1}}let q=a,J=w;const Q=(0,T.$vm)(a),Y=(0,T.$vm)(w),Z=g?(0,T.$vm)(g):null,x=f.reduce((O,z)=>(O.add(z),O),new Set),H=l(Q,Y,x),B=l(Z,Q,x),V=l(Z,Y,x),ee=new Map,ne=new Set,ce=O=>{ne.add(O);const z=k.filter(({key:G})=>G===O)[0];z?(q=R.edit(q,[O],z.value,N),J=R.edit(J,[O],z.value,N)):ee.set(O,{key:O,localValue:Q[O],remoteValue:Y[O]})};for(const O of B.removed.values())V.updated.has(O)?ce(O):J=R.edit(J,[O],void 0,N);for(const O of V.removed.values())ne.has(O)||(B.updated.has(O)?ce(O):q=R.edit(q,[O],void 0,N));for(const O of B.updated.values())ne.has(O)||(V.updated.has(O)?H.updated.has(O)&&ce(O):J=R.edit(J,[O],Q[O],N));for(const O of V.updated.values())ne.has(O)||(B.updated.has(O)?H.updated.has(O)&&ce(O):q=R.edit(q,[O],Y[O],N));for(const O of B.added.values())ne.has(O)||(V.added.has(O)?H.updated.has(O)&&ce(O):J=u(O,q,J,N));for(const O of V.added.values())ne.has(O)||(B.added.has(O)?H.updated.has(O)&&ce(O):q=u(O,J,q,N));const re=ee.size>0||!v(q,J,f),A=re||!v(q,a,[]),d=re||!v(J,w,[]);return{localContent:A?q:null,remoteContent:d?J:null,conflictsSettings:[...ee.values()],hasConflicts:re}}e.$Gxb=$;function v(a,w,g){if(a===w)return!0;const f=(0,T.$vm)(a),k=(0,T.$vm)(w),N=g.reduce((W,q)=>(W.add(q),W),new Set),M=r(a).filter(W=>!(W.setting&&N.has(W.setting.key))),F=r(w).filter(W=>!(W.setting&&N.has(W.setting.key)));if(M.length!==F.length)return!1;for(let W=0;W<M.length;W++){const q=M[W],J=F[W];if(q.setting&&J.setting){if(q.setting.key!==J.setting.key||!L.$Jm(f[q.setting.key],k[q.setting.key]))return!1}else if(!q.setting&&!J.setting){if(q.value!==J.value)return!1}else return!1}return!0}function c(a){return a?r(a).length===0:!0}e.$Hxb=c;function l(a,w,g){const f=a?Object.keys(a).filter(W=>!g.has(W)):[],k=Object.keys(w).filter(W=>!g.has(W)),N=k.filter(W=>!f.includes(W)).reduce((W,q)=>(W.add(q),W),new Set),M=f.filter(W=>!k.includes(W)).reduce((W,q)=>(W.add(q),W),new Set),F=new Set;if(a)for(const W of f){if(M.has(W))continue;const q=a[W],J=w[W];L.$Jm(q,J)||F.add(W)}return{added:N,removed:M,updated:F}}function u(a,w,g,f){const k=(0,T.$vm)(w),N=r(w),M=r(g),F=y(a,N,M);return p(g,a,k[a],F,M,f)}e.$Ixb=u;function y(a,w,g){const f=w.findIndex(N=>N.setting?.key===a),k=w[f-1];if(k){if(k.setting){const M=t(k.setting.key,g);if(M)return{index:g.indexOf(M),insertAfter:!0}}else{const M=o(f,w);if(M){const F=t(M.setting.key,g);if(F){const W=n(g.indexOf(F),g),q=s(w,M,w[f]);if(W){const J=s(g,F,W),Q=i(q,J);return Q?{index:g.indexOf(Q),insertAfter:!0}:{index:g.indexOf(W),insertAfter:!1}}else{const J=s(g,F,g[g.length-1]),Q=i(q,J);return Q?{index:g.indexOf(Q),insertAfter:!0}:{index:g.length-1,insertAfter:!0}}}}}const N=w[f+1];if(N)if(N.setting){const M=t(N.setting.key,g);if(M)return{index:g.indexOf(M),insertAfter:!1}}else{const M=n(f,w);if(M){const F=t(M.setting.key,g);if(F){const W=o(g.indexOf(F),g),q=s(w,w[f],M);if(W){const J=s(g,W,F),Q=i(q.reverse(),J.reverse());return Q?{index:g.indexOf(Q),insertAfter:!1}:{index:g.indexOf(W),insertAfter:!0}}else{const J=s(g,g[0],F),Q=i(q.reverse(),J.reverse());return Q?{index:g.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:g.length-1,insertAfter:!0}}function p(a,w,g,f,k,N){let M;return f.index===-1?M=(0,D.$6R)(a,[w],g,N):M=C(a,w,g,f,k,N).map(F=>(0,D.$7R)(a,F,N)[0]),(0,D.$9R)(a,M)}function C(a,w,g,f,k,N){const M=`${JSON.stringify(w)}: ${JSON.stringify(g)}`,F=(0,j.$3R)(N,a),W=k[f.index];if(f.insertAfter){const q=[];if(W.setting)q.push({offset:W.endOffset,length:0,content:","+M});else{const J=n(f.index,k),Q=o(f.index,k),Y=Q?.setting?.commaOffset;Q&&Y===void 0&&q.push({offset:Q.endOffset,length:0,content:","});const Z=Y!==void 0&&Y>W.endOffset;q.push({offset:Z?Y+1:W.endOffset,length:0,content:J?F+M+",":F+M})}return q}else{if(W.setting)return[{offset:W.startOffset,length:0,content:M+","}];const q=(k[f.index-1]&&!k[f.index-1].setting?F:"")+M+(n(f.index,k)?",":"")+F;return[{offset:W.startOffset,length:0,content:q}]}}function t(a,w){return w.filter(g=>g.setting?.key===a)[0]}function o(a,w){for(let g=a-1;g>=0;g--)if(w[g].setting)return w[g]}function n(a,w){for(let g=a+1;g<w.length;g++)if(w[g].setting)return w[g]}function s(a,w,g){const f=a.indexOf(w),k=a.indexOf(g);return a.filter((N,M)=>f<M&&M<k)}function i(a,w){if(a.length&&w.length){let g=0;for(;g<w.length&&g<a.length;g++)if(a[g].value!==w[g].value)return w[g-1];return w[g-1]}}function r(a){const w=[];let g=-1,f,k;const N={onObjectBegin:M=>{g++},onObjectProperty:(M,F,W)=>{g===0&&(f=F,k=M)},onObjectEnd:(M,F)=>{g--,g===0&&w.push({startOffset:f,endOffset:M+F,value:a.substring(f,M+F),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(M,F)=>{g++},onArrayEnd:(M,F)=>{g--,g===0&&w.push({startOffset:f,endOffset:M+F,value:a.substring(f,M+F),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(M,F,W)=>{g===0&&w.push({startOffset:f,endOffset:F+W,value:a.substring(f,F+W),setting:{key:k,commaOffset:void 0}})},onSeparator:(M,F,W)=>{if(g===0&&M===","){let q=w.length-1;for(;q>=0&&!w[q].setting;q--);const J=w[q];J&&w.splice(q,1,{startOffset:J.startOffset,endOffset:J.endOffset,value:J.value,setting:{key:J.setting.key,commaOffset:F}})}},onComment:(M,F)=>{g===0&&w.push({startOffset:M,endOffset:M+F,value:a.substring(M,M+F)})}};return(0,T.$Cm)(a,N),w}}),define(oe[76],ae([0,1,3,2,4,23]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oxb=e.$nxb=void 0,e.$nxb=(0,D.$nh)("IUserDataSyncAccountService");let L=class extends T.$lb{get account(){return this.a}constructor(S,b){super(),this.g=S,this.h=b,this.b=this.B(new I.$7c),this.onDidChangeAccount=this.b.event,this.c=this.B(new I.$7c),this.onTokenFailed=this.c.event,this.f=!1,this.B(S.onTokenFailed(P=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,P),this.updateAccount(void 0),P==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(S.onTokenSucceed(()=>this.f=!1))}async updateAccount(S){(S&&this.a?S.token!==this.a.token||S.authenticationProviderId!==this.a.authenticationProviderId:S!==this.a)&&(this.a=S,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(S))}};e.$oxb=L,e.$oxb=L=be([K(0,j.$Seb),K(1,j.$8eb)],L)}),define(oe[234],ae([0,1,2,10]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G5b=e.$F5b=e.$E5b=e.$D5b=e.$C5b=e.$B5b=e.$A5b=void 0;class D{constructor(m){this.a=m}listen(m,h){switch(h){case"onError":return this.a.onError}throw new Error(`Event not found: ${h}`)}call(m,h,$){switch(h){case"triggerSync":return this.a.triggerSync($[0],$[1],$[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff($[0])}throw new Error("Invalid call")}}e.$A5b=D;class j{constructor(m){this.a=m}listen(m,h){throw new Error(`Event not found: ${h}`)}call(m,h,$){switch(h){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings($[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(T.URI.revive($[0]))}throw new Error("Invalid call")}}e.$B5b=j;class L{constructor(m){this.a=m}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.a.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.a.call("resolveFormattingOptions",[m])}}e.$C5b=L;class R{constructor(m){this.a=m}listen(m,h){switch(h){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${h}`)}async call(m,h,$){switch(h){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine($[0],$[1]);case"setEnablements":return this.a.setEnablements($)}throw new Error("Invalid call")}}e.$D5b=R;class S{constructor(m){this.a=m}listen(m,h){switch(h){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${h}`)}call(m,h,$){switch(h){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount($)}throw new Error("Invalid call")}}e.$E5b=S;class b{constructor(m){this.a=m}listen(m,h){switch(h){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${h}`)}call(m,h,$){switch(h){case"switch":return this.a.switch($[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$F5b=b;class P extends I.$lb{constructor(m){super(),this.a=m,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.a.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.a.call("getPreviousUserDataSyncStore");return this.b(m)}b(m){return{url:T.URI.revive(m.url),type:m.type,defaultUrl:T.URI.revive(m.defaultUrl),insidersUrl:T.URI.revive(m.insidersUrl),stableUrl:T.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.$G5b=P}),define(oe[235],ae([0,1,171,8,23]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vzb=void 0;let j=class extends T.$Ui{constructor(R){super(),this.g=this.B(R.createLogger(D.$9eb,{name:(0,I.localize)(0,null)}))}trace(R,...S){this.g.trace(R,...S)}debug(R,...S){this.g.debug(R,...S)}info(R,...S){this.g.info(R,...S)}warn(R,...S){this.g.warn(R,...S)}error(R,...S){this.g.error(R,...S)}flush(){this.g.flush()}};e.$vzb=j,e.$vzb=j=be([K(0,T.$Qi)],j)}),define(oe[236],ae([0,1,6,3,2]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E4b=void 0;class j extends D.$lb{constructor({onDidOpenWindow:R,onDidFocusWindow:S,getActiveWindowId:b}){super(),this.a=this.B(new D.$kb),T.Event.latch(T.Event.any(R,S))(this.f,this,this.a),this.b=(0,I.$hg)(()=>b()),(async()=>{try{const E=await this.b;this.c=typeof this.c=="number"?this.c:E}catch{}finally{this.b=void 0}})()}f(R){this.b&&(this.b.cancel(),this.b=void 0),this.c=R}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$E4b=j}),define(oe[112],ae([0,1,174,16,47,22,10,4,26]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.WorkbenchState=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$wh=(0,R.$nh)("contextService");function b(s){const i=s;return typeof i?.id=="string"&&L.URI.isUri(i.uri)}e.$xh=b;function P(s){return typeof s?.id=="string"&&!b(s)&&!m(s)}e.$yh=P,e.$zh={id:"ext-dev"},e.$Ah={id:"empty-window"};function E(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,T.$ec)(s)}:i?e.$zh:e.$Ah;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$Bh=E;function m(s){const i=s;return typeof i?.id=="string"&&L.URI.isUri(i.configPath)}e.$Ch=m;function h(s){const i=s;if(i?.uri)return{id:i.id,uri:L.URI.revive(i.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:L.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$Dh=h;var $;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function v(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.$Eh=v;function c(s){const i=s;return!!(i&&typeof i=="object"&&L.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.$Fh=c;class l{constructor(i,r,a,w,g){this.h=i,this.j=a,this.k=w,this.l=g,this.c=D.$th.forUris(this.l,()=>!0),this.folders=r}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=D.$th.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gh=l;class u{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,j.$8f)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hh=u;function y(s){return new u({uri:s,index:0,name:(0,j.$4f)(s)},{uri:s.toString()})}e.$Ih=y,e.$Jh="code-workspace",e.$Kh=`.${e.$Jh}`,e.$Lh=[{name:(0,I.localize)(0,null),extensions:[e.$Jh]}],e.$Mh="workspace.json";function p(s,i){return j.$Yf.isEqualOrParent(s,i.untitledWorkspacesHome)}e.$Nh=p;function C(s){let i;return L.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===S.Schemas.tmp}e.$Oh=C,e.$Ph="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$Ph}e.$Qh=t;function o(s,i){return!p(s,i)&&!C(s)}e.$Rh=o;function n(s){return(typeof s=="string"?(0,T.$fc)(s):(0,j.$6f)(s))===e.$Kh}e.$Sh=n}),define(oe[17],ae([0,1,51,3,2,22,10,165,15,13,4,8,112,35,28,6,32,27,11]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.ProfileResourceType=void 0;var y;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(y||(e.ProfileResourceType=y={}));function p(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&L.URI.isUri(i.location)&&L.URI.isUri(i.globalStorageHome)&&L.URI.isUri(i.settingsResource)&&L.URI.isUri(i.keybindingsResource)&&L.URI.isUri(i.tasksResource)&&L.URI.isUri(i.snippetsHome)&&L.URI.isUri(i.extensionsResource))}e.$ok=p,e.$pk=(0,P.$nh)("IUserDataProfilesService");function C(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,location:L.URI.revive(s.location).with({scheme:i}),globalStorageHome:L.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:L.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:L.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:L.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:L.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:L.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:L.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$qk=C;function t(s,i,r,a,w,g){return{id:s,name:i,location:r,isDefault:!1,shortName:w?.shortName,globalStorageHome:g&&w?.useDefaultFlags?.globalState?g.globalStorageHome:(0,j.$8f)(r,"globalStorage"),settingsResource:g&&w?.useDefaultFlags?.settings?g.settingsResource:(0,j.$8f)(r,"settings.json"),keybindingsResource:g&&w?.useDefaultFlags?.keybindings?g.keybindingsResource:(0,j.$8f)(r,"keybindings.json"),tasksResource:g&&w?.useDefaultFlags?.tasks?g.tasksResource:(0,j.$8f)(r,"tasks.json"),snippetsHome:g&&w?.useDefaultFlags?.snippets?g.snippetsHome:(0,j.$8f)(r,"snippets"),extensionsResource:g&&w?.useDefaultFlags?.extensions?g.extensionsResource:(0,j.$8f)(r,"extensions.json"),cacheHome:(0,j.$8f)(a,s),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}e.$rk=t;let o=class extends D.$lb{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,r,a,w){super(),this.n=i,this.r=r,this.s=a,this.t=w,this.f=!0,this.h=this.B(new T.$7c),this.onDidChangeProfiles=this.h.event,this.i=this.B(new T.$7c),this.onWillCreateProfile=this.i.event,this.j=this.B(new T.$7c),this.onWillRemoveProfile=this.j.event,this.k=this.B(new T.$7c),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new h.$li,emptyWindows:new Map},this.profilesHome=(0,j.$8f)(this.n.userRoamingDataHome,"profiles"),this.g=(0,j.$8f)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=this.w(),r=[i];if(this.f)try{for(const g of this.J()){if(!g.name||!(0,u.$ie)(g.name)||!g.location){this.t.warn("Skipping the invalid stored profile",g.location||g.name);continue}r.push(t((0,j.$5f)(g.location),g.name,g.location,this.g,{shortName:g.shortName,useDefaultFlags:g.useDefaultFlags},i))}}catch(g){this.t.error(g)}const a=new h.$li,w=new Map;if(r.length)try{const g=this.M();if(g.workspaces)for(const[f,k]of Object.entries(g.workspaces)){const N=L.URI.parse(f),M=r.find(F=>F.id===k);M&&a.set(N,M)}if(g.emptyWindows)for(const[f,k]of Object.entries(g.emptyWindows)){const N=r.find(M=>M.id===k);N&&w.set(f,N)}}catch(g){this.t.error(g)}this.u={profiles:r,workspaces:a,emptyWindows:w}}return this.u}w(){const i=t("__default__profile__",(0,R.localize)(0,null),this.n.userRoamingDataHome,this.g);return{...i,extensionsResource:this.O()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const r="Temp",a=new RegExp(`${(0,l.$nd)(r)}\\s(\\d+)`);let w=0;for(const f of this.profiles){const k=a.exec(f.name),N=k?parseInt(k[1]):0;w=N>w?N:w}const g=`${r} ${w+1}`;return this.createProfile((0,I.$bi)((0,c.$5e)()).toString(16),g,{transient:!0},i)}async createNamedProfile(i,r,a){return this.createProfile((0,I.$bi)((0,c.$5e)()).toString(16),i,r,a)}async createProfile(i,r,a,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=await this.y(i,r,a);return w&&await this.setProfileForWorkspace(w,g),g}async y(i,r,a){if(!(0,u.$ie)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.l.get(r);return w||(w=(async()=>{try{const g=this.profiles.find(N=>N.name===r||N.id===i);if(g)return g;const f=t(i,r,(0,j.$8f)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.r.createFolder(f.location);const k=[];return this.i.fire({profile:f,join(N){k.push(N)}}),await v.Promises.settled(k),this.D([f],[],[]),f}finally{this.l.delete(r)}})(),this.l.set(r,w)),w}async updateProfile(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(w=>w.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.D([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(w=>w.id===i.id);if(!r)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.j.fire({profile:r,join(w){a.push(w)}});try{await Promise.allSettled(a)}catch(w){this.t.error(w)}for(const w of[...this.v.emptyWindows.keys()])r.id===this.v.emptyWindows.get(w)?.id&&this.v.emptyWindows.delete(w);for(const w of[...this.v.workspaces.keys()])r.id===this.v.workspaces.get(w)?.id&&this.v.workspaces.delete(w);this.H(),this.D([],[r],[]);try{await this.r.del(r.cacheHome,{recursive:!0})}catch(w){(0,b.$7j)(w)!==1&&this.t.error(w)}}async setProfileForWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(w=>w.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.G(i,a)}unsetWorkspace(i,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,r)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.s.extUri.isEqual(a.location,r.resource))).map(r=>this.r.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(r=>!this.C(r));await Promise.allSettled(i.map(r=>this.removeProfile(r)))}getProfileForWorkspace(i){const r=this.z(i);return L.URI.isUri(r)?this.m.workspaces.get(r)??this.v.workspaces.get(r):this.m.emptyWindows.get(r)??this.v.emptyWindows.get(r)}z(i){return(0,m.$xh)(i)?i.uri:(0,m.$Ch)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.m.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.emptyWindows.values()].some(r=>this.s.extUri.isEqual(r.location,i.location))||[...this.v.workspaces.values()].some(r=>this.s.extUri.isEqual(r.location,i.location)))}D(i,r,a){const w=[...this.profiles,...i],g=[];this.m.profiles=[];for(let f of w)f.isDefault||r.some(k=>f.id===k.id)||(f=a.find(k=>f.id===k.id)??f,f.isTransient?this.m.profiles.push(f):g.push({location:f.location,name:f.name,shortName:f.shortName,useDefaultFlags:f.useDefaultFlags}));this.L(g),this.u=void 0,this.F(i,r,a)}F(i,r,a){this.h.fire({added:i,removed:r,updated:a,all:this.profiles})}G(i,r,a){a=r?.isTransient?!0:a,a||this.G(i,void 0,!0);const w=this.z(i),g=a?this.m:this.v;L.URI.isUri(w)?(g.workspaces.delete(w),r&&g.workspaces.set(w,r)):(g.emptyWindows.delete(w),r&&g.emptyWindows.set(w,r)),a||this.H()}H(){const i={};for(const[a,w]of this.v.workspaces.entries())i[a.toString()]=w.id;const r={};for(const[a,w]of this.v.emptyWindows.entries())r[a.toString()]=w.id;this.N({workspaces:i,emptyWindows:r}),this.u=void 0}I(i){const r={},a=this.w();if(i.workspaces)for(const[g,f]of Object.entries(i.workspaces)){const k=L.URI.parse(f);r[g]=this.s.extUri.isEqual(k,a.location)?a.id:this.s.extUri.basename(k)}const w={};if(i.emptyWindows)for(const[g,f]of Object.entries(i.emptyWindows)){const k=L.URI.parse(f);w[g]=this.s.extUri.isEqual(k,a.location)?a.id:this.s.extUri.basename(k)}return{workspaces:r,emptyWindows:w}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};e.$sk=o,e.$sk=o=be([K(0,S.$uh),K(1,b.$Qj),K(2,$.$nk),K(3,E.$Pi)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.$tk=n}),define(oe[237],ae([0,1,6,2,17]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O5b=void 0;let j=class extends T.$lb{constructor(R){super(),this.B(new I.$Eg(()=>{R.cleanUp()},10*1e3)).schedule()}};e.$O5b=j,e.$O5b=j=be([K(0,D.$pk)],j)}),define(oe[238],ae([0,1,21,6,25,7,3,2,5,11,10,148,29,33,45,8,24,20,28,17]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8o=e.$7o=e.$6o=e.$5o=void 0;let p=class extends R.$lb{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}get onDidUpdateExtensionMetadata(){return this.s.event}constructor(i,r,a,w,g,f){super(),this.u=i,this.v=r,this.w=a,this.y=w,this.z=g,this.C=f,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new L.$7c),this.m=this.B(new L.$7c),this.n=this.B(new L.$7c),this.p=this.B(new L.$7c),this.s=this.B(new L.$7c),this.t=[],this.B((0,R.$jb)(()=>{this.j.forEach(({task:k})=>k.cancel()),this.k.forEach(k=>k.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const r=await this.getTargetPlatform();return i.allTargetPlatforms.some(a=>(0,m.$Kn)(a,i.allTargetPlatforms,r))}async installFromGallery(i,r={}){try{const w=(await this.installGalleryExtensions([{extension:i,options:r}])).find(({identifier:g})=>(0,h.$do)(g,i.identifier));if(w?.local)return w?.local;throw w?.error?w.error:t(new Error(`Unknown error while installing extension ${i.identifier.id}`))}catch(a){throw t(a)}}async installGalleryExtensions(i){if(!this.u.isEnabled())throw new m.$On(E.localize(0,null),m.ExtensionManagementErrorCode.Internal);const r=[],a=[];await Promise.allSettled(i.map(async({extension:w,options:g})=>{try{const f=await this.J(w,!!g?.installGivenVersion,!!g?.installPreReleaseVersion);a.push({...f,options:g})}catch(f){r.push({identifier:w.identifier,operation:2,source:w,error:f})}})),a.length&&r.push(...await this.D(a));for(const w of r)w.error&&(this.y.error("Failed to install extension.",w.identifier.id),this.y.error(w.error),w.source&&!P.URI.isUri(w.source)&&o(this.v,"extensionGallery:install",{extensionData:(0,h.$lo)(w.source),error:w.error}));return r}async uninstall(i,r={}){return this.y.trace("ExtensionManagementService#uninstall",i.identifier.id),this.M(i,r)}async toggleAppliationScope(i,r){if((0,$.$Il)(i.manifest))return i;if(i.isApplicationScoped){let a=await this.updateMetadata(i,{isApplicationScoped:!1},this.C.defaultProfile.extensionsResource);this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)||(a=await this.X(i,this.C.defaultProfile.extensionsResource,r));for(const w of this.C.profiles){const g=(await this.getInstalled(1,w.extensionsResource)).find(f=>(0,h.$do)(f.identifier,i.identifier));g?this.s.fire(g):this.p.fire({identifier:i.identifier,profileLocation:w.extensionsResource})}return a}else{const a=this.w.extUri.isEqual(r,this.C.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.C.defaultProfile.extensionsResource):await this.X(i,r,this.C.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.m.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.C.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.R(),this.h=i),this.g}registerParticipant(i){this.t.push(i)}async D(i){const r=[];return await Promise.allSettled(i.map(async a=>{try{const w=await this.F(a);r.push(...w)}catch(w){r.push({identifier:{id:(0,h.$io)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:w})}})),this.m.fire(r),r}async F({manifest:i,extension:r,options:a}){const w=a.isApplicationScoped||a.isBuiltin||(0,$.$Il)(i),g={...a,installOnlyNewlyAddedFromExtensionPack:P.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:w,profileLocation:w?this.C.defaultProfile.extensionsResource:a.profileLocation??this.S()},f=q=>`${h.$eo.create(q).toString()}${g.profileLocation?`-${g.profileLocation.toString()}`:""}`;if(!P.URI.isUri(r)){const q=this.j.get(f(r));if(q)return this.y.info("Extensions is already requested to install",r.identifier.id),await q.task.waitUntilTaskIsFinished(),[]}const k=[],N=[],M=[],F=this.U(i,r,g);P.URI.isUri(r)||this.j.set(f(r),{task:F,waitingTasks:[]}),this.l.fire({identifier:F.identifier,source:r,profileLocation:g.profileLocation}),this.y.info("Installing extension:",F.identifier.id),k.push({task:F,manifest:i});let W=!1;try{if(g.donotIncludePackAndDependencies)this.y.info("Installing the extension without checking dependencies and pack",F.identifier.id);else try{const J=await this.I(F.identifier,i,!!g.installOnlyNewlyAddedFromExtensionPack,!!g.installPreReleaseVersion,g.profileLocation),Q=await this.getInstalled(void 0,g.profileLocation);for(const{gallery:Y,manifest:Z}of(0,I.$qf)(J,({gallery:x})=>x.identifier.id)){W=W||!!Z.extensionDependencies?.some(B=>(0,h.$do)({id:B},F.identifier));const x=f(Y),H=this.j.get(x);if(H){if(this.G(F,H.task)){const B=H.task.identifier;this.y.info("Waiting for already requested installing extension",B.id,F.identifier.id),H.waitingTasks.push(F),N.push(L.Event.toPromise(L.Event.filter(this.onDidInstallExtensions,V=>V.some(ee=>(0,h.$do)(ee.identifier,B)))).then(V=>{if(this.y.info("Finished waiting for already requested installing extension",B.id,F.identifier.id),!V.find(ne=>(0,h.$do)(ne.identifier,B))?.local)throw new Error(`Extension ${B.id} is not installed`)}))}}else if(!Q.some(({identifier:B})=>(0,h.$do)(B,Y.identifier))){const B=this.U(Z,Y,{...g,donotIncludePackAndDependencies:!0});this.j.set(x,{task:B,waitingTasks:[F]}),this.l.fire({identifier:B.identifier,source:Y,profileLocation:g.profileLocation}),this.y.info("Installing extension:",B.identifier.id,F.identifier.id),k.push({task:B,manifest:Z})}}}catch(J){if(P.URI.isUri(F.source))(0,I.$pf)(i.extensionDependencies)&&this.y.warn("Cannot install dependencies of extension:",F.identifier.id,J.message),(0,I.$pf)(i.extensionPack)&&this.y.warn("Cannot install packed extensions of extension:",F.identifier.id,J.message);else throw this.y.error("Error while preparing to install dependencies and extension packs of the extension:",F.identifier.id),J}const q=k.reduce((J,{task:Q,manifest:Y})=>(J.set(Q.identifier.id.toLowerCase(),{task:Q,manifest:Y}),J),new Map);for(;q.size;){let J;const Q=[...q.values()].filter(({manifest:Y})=>!Y.extensionDependencies?.some(Z=>q.has(Z.toLowerCase())));Q.length?J=q.size===1?Q:Q.filter(({task:Y})=>!(Y===F&&!W)):(this.y.info("Found extensions with circular dependencies",Q.map(({task:Y})=>Y.identifier.id)),J=[...q.values()]),await this.H(J.map(async({task:Y})=>{const Z=new Date().getTime();try{const x=await Y.run();if(await this.H(this.t.map(H=>H.postInstall(x,Y.source,g,D.CancellationToken.None))),!P.URI.isUri(Y.source)){const H=Y.operation===3,B=H?void 0:(new Date().getTime()-Y.source.lastUpdated)/1e3;if(o(this.v,H?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$lo)(Y.source),verificationStatus:Y.verificationStatus,duration:new Date().getTime()-Z,durationSinceUpdate:B}),S.$o&&Y.operation!==3)try{await this.u.reportStatistic(x.manifest.publisher,x.manifest.name,x.manifest.version,"install")}catch{}}M.push({local:x,identifier:Y.identifier,operation:Y.operation,source:Y.source,context:g.context,profileLocation:Y.profileLocation,applicationScoped:x.isApplicationScoped})}catch(x){throw P.URI.isUri(Y.source)||o(this.v,Y.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.$lo)(Y.source),verificationStatus:Y.verificationStatus,duration:new Date().getTime()-Z,error:x}),this.y.error("Error while installing the extension:",Y.identifier.id),x}finally{q.delete(Y.identifier.id.toLowerCase())}}))}return N.length&&await this.H(N),M.forEach(({identifier:J})=>this.y.info("Extension installed successfully:",J.id)),M}catch(q){if(k.forEach(({task:J})=>J.cancel()),M.length)try{const J=await Promise.allSettled(M.map(({local:Q})=>this.W(Q,{versionOnly:!0,profileLocation:g.profileLocation}).run()));for(let Q=0;Q<J.length;Q++){const Y=J[Q],{identifier:Z}=M[Q];Y.status==="fulfilled"?this.y.info("Rollback: Uninstalled extension",Z.id):this.y.warn("Rollback: Error while uninstalling extension",Z.id,(0,j.$9)(Y.reason))}}catch(J){this.y.warn("Error while rolling back extensions",(0,j.$9)(J),M.map(({identifier:Q})=>Q.id))}return k.map(({task:J})=>({identifier:J.identifier,operation:2,source:J.source,context:g.context,profileLocation:g.profileLocation,error:q}))}finally{for(const{task:q}of k)q.source&&!P.URI.isUri(q.source)&&this.j.delete(f(q.source))}}G(i,r){for(const[,{task:a,waitingTasks:w}]of this.j.entries())if(a===i&&(w.includes(r)||w.some(g=>this.G(g,r)))||a===r&&w[0]&&!this.G(i,w[0]))return!1;return!0}async H(i){const r=[],a=[],w=await Promise.allSettled(i);for(const g of w)g.status==="fulfilled"?r.push(g.value):a.push(g.reason);if(a.length)throw C(a);return r}async I(i,r,a,w,g){if(!this.u.isEnabled())return[];const f=await this.getInstalled(void 0,g),k=[],N=[],M=async(F,W)=>{k.push(F);const q=W.extensionDependencies||[],J=[...q];if(W.extensionPack){const Q=a?f.find(Y=>(0,h.$do)(Y.identifier,F)):void 0;for(const Y of W.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(Z=>(0,h.$do)({id:Z},{id:Y}))||J.every(Z=>!(0,h.$do)({id:Z},{id:Y}))&&J.push(Y)}if(J.length){const Q=J.filter(Y=>k.every(Z=>!(0,h.$do)(Z,{id:Y})));if(Q.length){const Y=await this.u.getExtensions(Q.map(Z=>({id:Z,preRelease:w})),D.CancellationToken.None);for(const Z of Y){if(k.find(B=>(0,h.$do)(B,Z.identifier)))continue;const x=q.some(B=>(0,h.$do)({id:B},Z.identifier));let H;try{H=await this.J(Z,!1,w)}catch(B){if(x)throw B;this.y.info("Skipping the packed extension as it cannot be installed",Z.identifier.id,(0,j.$9)(B));continue}N.push({gallery:H.extension,manifest:H.manifest}),await M(H.extension.identifier,H.manifest)}}}};return await M(i,r),N}async J(i,r,a){let w;const g=await this.getExtensionsControlManifest();if(g.malicious.some(N=>(0,h.$do)(i.identifier,N)))throw new m.$On(E.localize(1,null,i.identifier.id),m.ExtensionManagementErrorCode.Malicious);const f=g.deprecated[i.identifier.id.toLowerCase()];if(f?.extension?.autoMigrate){if(this.y.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${f.extension.id}' extension instead.`),w=(await this.u.getExtensions([{id:f.extension.id,preRelease:f.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0],!w)throw new m.$On(E.localize(2,null,i.identifier.id,f.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const N=await this.getTargetPlatform();throw new m.$On(E.localize(3,null,i.identifier.id,this.z.nameLong,(0,m.$Gn)(N)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(w=await this.L(i,r,a),!w)throw!a&&i.properties.isPreReleaseVersion&&(await this.u.getExtensions([i.identifier],D.CancellationToken.None))[0]?new m.$On(E.localize(4,null,i.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$On(E.localize(5,null,i.identifier.id,this.z.nameLong,this.z.version),m.ExtensionManagementErrorCode.Incompatible)}this.y.info("Getting Manifest...",w.identifier.id);const k=await this.u.getManifest(w,D.CancellationToken.None);if(k===null)throw new m.$On(`Missing manifest for extension ${w.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(k.version!==w.version)throw new m.$On(`Cannot install '${w.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:w,manifest:k}}async L(i,r,a){const w=await this.getTargetPlatform();let g=null;return!r&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==a&&(g=(await this.u.getExtensions([{...i.identifier,preRelease:a}],{targetPlatform:w,compatible:!0},D.CancellationToken.None))[0]||null),!g&&await this.u.isExtensionCompatible(i,a,w)&&(g=i),g||(r?g=(await this.u.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:w,compatible:!0},D.CancellationToken.None))[0]||null:g=await this.u.getCompatibleExtension(i,a,w)),g}async M(i,r){const a={...r,profileLocation:i.isApplicationScoped?this.C.defaultProfile.extensionsResource:r.profileLocation??this.S()},w=F=>`${F.id.toLowerCase()}${a.versionOnly?`-${i.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,g=this.k.get(w(i.identifier));if(g)return this.y.info("Extensions is already requested to uninstall",i.identifier.id),g.waitUntilTaskIsFinished();const f=F=>{const W=this.W(F,a);return this.k.set(w(W.extension.identifier),W),a.profileLocation?this.y.info("Uninstalling extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.y.info("Uninstalling extension:",`${F.identifier.id}@${F.manifest.version}`),this.n.fire({identifier:F.identifier,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped}),W},k=(F,W)=>{W?a.profileLocation?this.y.error("Failed to uninstall extension from the profile:",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString(),W.message):this.y.error("Failed to uninstall extension:",`${F.identifier.id}@${F.manifest.version}`,W.message):a.profileLocation?this.y.info("Successfully uninstalled extension from the profile",`${F.identifier.id}@${F.manifest.version}`,a.profileLocation.toString()):this.y.info("Successfully uninstalled extension:",`${F.identifier.id}@${F.manifest.version}`),o(this.v,"extensionGallery:uninstall",{extensionData:(0,h.$ko)(F),error:W}),this.p.fire({identifier:F.identifier,error:W?.code,profileLocation:a.profileLocation,applicationScoped:F.isApplicationScoped})},N=[],M=[];try{N.push(f(i));const F=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.y.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const W=this.P(i,F);for(const q of W)this.k.has(w(q.identifier))?this.y.info("Extensions is already requested to uninstall",q.identifier.id):N.push(f(q))}a.donotCheckDependents?this.y.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.N(N.map(W=>W.extension),F,i),await this.H(N.map(async W=>{try{if(await W.run(),await this.H(this.t.map(q=>q.postUninstall(W.extension,a,D.CancellationToken.None))),W.extension.identifier.uuid)try{await this.u.reportStatistic(W.extension.manifest.publisher,W.extension.manifest.name,W.extension.manifest.version,"uninstall")}catch{}k(W.extension)}catch(q){const J=q instanceof m.$On?q:new m.$On((0,j.$9)(q),m.ExtensionManagementErrorCode.Internal);throw k(W.extension,J),J}finally{M.push(W)}}))}catch(F){const W=F instanceof m.$On?F:new m.$On((0,j.$9)(F),m.ExtensionManagementErrorCode.Internal);for(const q of N){try{q.cancel()}catch{}M.includes(q)||k(q.extension,W)}throw W}finally{for(const F of N)this.k.delete(w(F.extension.identifier))||this.y.warn("Uninstallation task is not found in the cache",F.extension.identifier.id)}}N(i,r,a){for(const w of i){const g=this.Q(w,r);if(g.length){const f=g.filter(k=>!i.some(N=>(0,h.$do)(N.identifier,k.identifier)));if(f.length)throw new Error(this.O(w,f,a))}}}O(i,r,a){return a===i?r.length===1?E.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?E.localize(9,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?E.localize(10,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):E.localize(11,null,a.manifest.displayName||a.manifest.name,i.manifest.displayName||i.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}P(i,r,a=[]){if(a.indexOf(i)!==-1)return[];a.push(i);const w=i.manifest.extensionPack?i.manifest.extensionPack:[];if(w.length){const g=r.filter(k=>!k.isBuiltin&&w.some(N=>(0,h.$do)({id:N},k.identifier))),f=[];for(const k of g)f.push(...this.P(k,r,a));return[...g,...f]}return[]}Q(i,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(w=>(0,h.$do)({id:w},i.identifier)))}async R(){try{this.y.trace("ExtensionManagementService.refreshReportedCache");const i=await this.u.getExtensionsControlManifest();return this.y.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.y.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$5o=p,e.$5o=p=be([K(0,m.$Nn),K(1,l.$Tk),K(2,u.$nk),K(3,v.$Pi),K(4,c.$8i),K(5,y.$pk)],p);function C(s){const i=Array.isArray(s)?s:[s];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$6o=C;function t(s){if(s instanceof m.$On)return s;const i=new m.$On(s.message,m.ExtensionManagementErrorCode.Internal);return i.stack=s.stack,i}e.$7o=t;function o(s,i,{extensionData:r,verificationStatus:a,duration:w,error:g,durationSinceUpdate:f}){let k,N;(0,b.$qe)(a)&&(a===!0?a="Verified":(a===!1||(k=m.ExtensionManagementErrorCode.Signature,N=a),a="Unverified")),g&&(g instanceof m.$On?(k=g.code,g.code===m.ExtensionManagementErrorCode.Signature&&(N=g.message)):k=m.ExtensionManagementErrorCode.Internal),s.publicLog(i,{...r,verificationStatus:a,success:!g,duration:w,errorcode:k,errorcodeDetail:N,durationSinceUpdate:f})}class n{constructor(){this.d=new T.$sg}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,T.$hg)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,T.$hg)(i=>new Promise((r,a)=>{const w=i.onCancellationRequested(()=>{w.dispose(),a(new j.$3)})})),this.d.open()),this.g.cancel()}}e.$8o=n}),define(oe[50],ae([0,1,6,14,2,3,35,10,29,33,13,4,8,17,28,11,7,20]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$o=e.$0o=e.$9o=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class y extends Error{constructor(n,s){super(n),this.code=s}}e.$9o=y,e.$0o=(0,E.$nh)("IExtensionsProfileScannerService");let p=class extends D.$lb{constructor(n,s,i,r,a,w){super(),this.i=n,this.j=s,this.k=i,this.l=r,this.m=a,this.n=w,this.b=this.B(new j.$7c),this.onAddExtensions=this.b.event,this.c=this.B(new j.$7c),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$7c),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$7c),this.onDidRemoveExtensions=this.g.event,this.h=new L.$li}scanProfileExtensions(n,s){return this.p(n,void 0,s)}async addExtensionsToProfile(n,s){const i=[],r=[];try{return await this.p(s,a=>{const w=[];for(const g of a)n.some(([f])=>(0,b.$do)(f.identifier,g.identifier)&&f.manifest.version!==g.version)?i.push(g):w.push(g);for(const[g,f]of n)if(!w.some(k=>(0,b.$do)(k.identifier,g.identifier)&&k.version===g.manifest.version)){const k={identifier:g.identifier,version:g.manifest.version,location:g.location,metadata:f};r.push(k),w.push(k)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),i.length&&this.f.fire({extensions:i,profileLocation:s}),w}),r.length&&this.c.fire({extensions:r,profileLocation:s}),i.length&&this.g.fire({extensions:i,profileLocation:s}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:s}),i.length&&this.g.fire({extensions:i,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const i=[];return await this.p(s,r=>{const a=[];for(const w of r){const g=n.find(([f])=>(0,b.$do)(f.identifier,w.identifier)&&f.manifest.version===w.version);g&&(w.metadata={...w.metadata,...g[1]},i.push(w)),a.push(w)}return a}),i}async removeExtensionFromProfile(n,s){const i=[];this.f.fire({extensions:i,profileLocation:s});try{await this.p(s,r=>{const a=[];for(const w of r)(0,b.$do)(w.identifier,n.identifier)?i.push(w):a.push(w);return i.length&&this.f.fire({extensions:i,profileLocation:s}),a}),i.length&&this.g.fire({extensions:i,profileLocation:s})}catch(r){throw i.length&&this.g.fire({extensions:i,error:r,profileLocation:s}),r}}async p(n,s,i){return this.w(n).queue(async()=>{let r=[],a;try{const w=await this.j.readFile(n);a=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,P.$7j)(w)!==1)throw w;if(this.l.extUri.isEqual(n,this.k.defaultProfile.extensionsResource)&&(a=await this.v()),!a&&i?.bailOutWhenFileNotFound)throw new y((0,c.$9)(w),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.r(n);let w=!1;for(const g of a){C(g)||this.r(n);let f;if((0,v.$ie)(g.relativeLocation)&&g.relativeLocation)f=this.t(g.relativeLocation);else if((0,v.$ie)(g.location))f=this.t(g.location),w=!0,g.relativeLocation=g.location,g.location=f.toJSON();else{f=R.URI.revive(g.location);const k=this.s(f);k&&(w=!0,g.relativeLocation=k)}r.push({identifier:g.identifier,location:f,version:g.version,metadata:g.metadata})}w&&await this.j.writeFile(n,T.$Jb.fromString(JSON.stringify(a)))}if(s){r=s(r);const w=r.map(g=>({identifier:g.identifier,version:g.version,location:g.location.toJSON(),relativeLocation:this.s(g.location),metadata:g.metadata}));await this.j.writeFile(n,T.$Jb.fromString(JSON.stringify(w)))}return r})}r(n){const s=new y(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}s(n){return this.l.extUri.isEqual(this.l.extUri.dirname(n),this.i)?this.l.extUri.basename(n):void 0}t(n){return this.l.extUri.joinPath(this.i,n)}async v(){return this.u||(this.u=(async()=>{const n=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),s=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let i;try{i=(await this.j.readFile(n)).value.toString()}catch(a){if((0,P.$7j)(a)===1)return;throw a}this.n.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(w=>C(w))?r=a:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.n.error(a)}if(r)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,T.$Jb.fromString(JSON.stringify(r)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",n.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(a){if((0,P.$7j)(a)===3)this.n.info("Migration from old default profile location to new location is done by another window",n.toString(),this.k.defaultProfile.extensionsResource.toString());else throw a}try{await this.j.del(n)}catch(a){(0,P.$7j)(a)!==1&&this.n.error(a)}try{await this.j.del(s)}catch(a){(0,P.$7j)(a)!==1&&this.n.error(a)}return r})()),this.u}w(n){let s=this.h.get(n);return s||(s=new I.$Ag,this.h.set(n,s)),s}};e.$$o=p,e.$$o=p=be([K(1,P.$Qj),K(2,h.$pk),K(3,$.$nk),K(4,l.$Tk),K(5,m.$Pi)],p);function C(o){return(0,v.$ke)(o)&&(0,S.$Mn)(o.identifier)&&(t(o.location)||(0,v.$ie)(o.location)&&o.location)&&((0,v.$pe)(o.relativeLocation)||(0,v.$ie)(o.relativeLocation))&&o.version&&(0,v.$ie)(o.version)}function t(o){return o?(0,v.$ie)(o.path)&&(0,v.$ie)(o.scheme):!1}}),define(oe[77],ae([0,1,21,6,30,14,7,34,135,2,26,16,5,22,53,88,11,10,151,15,33,45,65,13,4,8,24,3,62,50,17,28,179]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p,C,t,o,n,s,i,r,a,w,g,f,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.Translations=void 0;var N;(function(Y){function Z(x,H){if(x===H)return!0;const B=Object.keys(x),V=new Set;for(const ee of Object.keys(H))V.add(ee);if(B.length!==V.size)return!1;for(const ee of B){if(x[ee]!==H[ee])return!1;V.delete(ee)}return V.size===0}Y.equals=Z})(N||(e.Translations=N={})),e.$bp=(0,n.$nh)("IExtensionsScannerService");let M=class extends b.$lb{constructor(Z,x,H,B,V,ee,ne,ce,re,A,d,O){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=x,this.l=H,this.m=B,this.n=V,this.r=ee,this.s=ne,this.t=ce,this.u=re,this.v=A,this.w=d,this.y=O,this.g=this.B(new r.$7c),this.onDidChangeCache=this.g.event,this.h=(0,h.$8f)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(q,this.m,this.h)),this.j=this.B(this.y.createInstance(q,this.m,this.h)),this.k=this.B(this.y.createInstance(W,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,p.$oo)(this.s,this.t)),this.z}async scanAllExtensions(Z,x,H){const[B,V]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(x)]),ee=H?await this.scanExtensionsUnderDevelopment(Z,[...B,...V]):[];return this.G(B,V,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const x=[];x.push(this.H(!!Z.useCache,Z.language)),x.push(this.I(Z.language,!!Z.checkControlFile));const[H,B]=await Promise.all(x);return this.F([...H,...B],0,Z,!1)}async scanUserExtensions(Z){const x=Z.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",x);const H=this.w.extUri.isEqual(Z.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,B=await this.L(x,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,H),V=Z.useCache&&!B.devMode&&B.excludeObsolete?this.j:this.k;let ee;try{ee=await V.scanExtensions(B)}catch(ne){if(ne instanceof w.$9o&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),ee=await V.scanExtensions(B);else throw ne}return ee=await this.F(ee,1,Z,!0),this.t.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(Z,x){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const H=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(B=>B.scheme===P.Schemas.file).map(async B=>{const V=await this.L(B,!1,1,!0,Z.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(V)).map(ne=>(ne.type=x.find(ce=>(0,p.$do)(ce.identifier,ne.identifier))?.type??ne.type,this.k.validate(ne,V)))}))).flat();return this.F(H,"development",Z,!0)}return[]}async scanExistingExtension(Z,x,H){const B=await this.L(Z,!1,x,!0,H.language,!0,void 0),V=await this.k.scanExtension(B);return!V||!H.includeInvalid&&!V.isValid?null:V}async scanOneOrMultipleExtensions(Z,x,H){const B=await this.L(Z,!1,x,!0,H.language,!0,void 0),V=await this.k.scanOneOrMultipleExtensions(B);return this.F(V,x,H,!0)}async scanMetadata(Z){const x=(0,h.$8f)(Z,"package.json"),H=(await this.s.readFile(x)).value.toString();return JSON.parse(H).__metadata}async updateMetadata(Z,x){const H=(0,h.$8f)(Z,"package.json"),B=(await this.s.readFile(H)).value.toString(),V=JSON.parse(B);x.isMachineScoped=x.isMachineScoped||void 0,x.isBuiltin=x.isBuiltin||void 0,V.__metadata={...V.__metadata,...x},await this.s.writeFile((0,h.$8f)(Z,"package.json"),j.$Jb.fromString(JSON.stringify(V,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof w.$9o&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw Z}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.r.addExtensionsToProfile(Z.map(x=>[x,x.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,j.$Jb.fromString(JSON.stringify([])))}catch(x){(0,o.$7j)(x)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,L.$9)(x))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.t.error(Z)}finally{this.C=void 0}})()),this.C}async F(Z,x,H,B){return H.includeAllVersions||(Z=this.G(x===0?Z:void 0,x===1?Z:void 0,x==="development"?Z:void 0,await this.getTargetPlatform(),B)),H.includeInvalid||(Z=Z.filter(V=>V.isValid)),Z.sort((V,ee)=>{const ne=E.$ec(V.location.fsPath),ce=E.$ec(ee.location.fsPath);return ne<ce?-1:ne>ce?1:0})}G(Z,x,H,B,V){const ee=(ce,re,A)=>{if(ce.isValid&&!re.isValid)return!1;if(ce.isValid===re.isValid){if(V&&$.gt(ce.manifest.version,re.manifest.version))return this.t.debug(`Skipping extension ${re.location.path} with lower version ${re.manifest.version} in favour of ${ce.location.path} with version ${ce.manifest.version}`),!1;if($.eq(ce.manifest.version,re.manifest.version)){if(ce.type===0)return this.t.debug(`Skipping extension ${re.location.path} in favour of system extension ${ce.location.path} with same version`),!1;if(ce.targetPlatform===B)return this.t.debug(`Skipping extension ${re.location.path} from different target platform ${re.targetPlatform}`),!1}}return A?this.t.warn(`Overwriting user extension ${ce.location.path} with ${re.location.path}.`):this.t.debug(`Overwriting user extension ${ce.location.path} with ${re.location.path}.`),!0},ne=new C.$Hl;return Z?.forEach(ce=>{const re=ne.get(ce.identifier.id);(!re||ee(re,ce,!1))&&ne.set(ce.identifier.id,ce)}),x?.forEach(ce=>{const re=ne.get(ce.identifier.id);if(!re&&Z&&ce.type===0){this.t.debug(`Skipping obsolete system extension ${ce.location.path}.`);return}(!re||ee(re,ce,!1))&&ne.set(ce.identifier.id,ce)}),H?.forEach(ce=>{const re=ne.get(ce.identifier.id);(!re||ee(re,ce,!0))&&ne.set(ce.identifier.id,ce),ne.set(ce.identifier.id,ce)}),[...ne.values()]}async H(Z,x){this.t.trace("Started scanning system extensions");const H=await this.L(this.systemExtensionsLocation,!1,0,!0,x,!0,void 0),V=await(Z&&!H.devMode?this.i:this.k).scanExtensions(H);return this.t.trace("Scanned system extensions:",V.length),V}async I(Z,x){const H=this.u.isBuilt?[]:this.v.builtInExtensions;if(!H?.length)return[];this.t.trace("Started scanning dev system extensions");const B=x?await this.J():{},V=[],ee=l.URI.file(E.$$b(E.$ac(P.$3e.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ce of H){const re=B[ce.name]||"marketplace";switch(re){case"disabled":break;case"marketplace":V.push((0,h.$8f)(ee,ce.name));break;default:V.push(l.URI.file(re));break}}const ne=await Promise.all(V.map(async ce=>this.k.scanExtension(await this.L(ce,!1,0,!0,Z,!0,void 0))));return this.t.trace("Scanned dev system extensions:",ne.length),(0,I.$lf)(ne)}async J(){try{const Z=await this.s.readFile(this.l);return JSON.parse(Z.value.toString())}catch{return{}}}async L(Z,x,H,B,V,ee,ne){const ce=await this.f(V??m.$v),re=await this.M(Z),A=x&&!this.w.extUri.isEqual(Z,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,d=A?await this.M(A):void 0;return new F(Z,re,A,d,x,ne,H,B,ee,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,V,ce)}async M(Z){try{const x=await this.s.stat(Z);if(typeof x.mtime=="number")return x.mtime}catch{}}};e.$cp=M,e.$cp=M=be([K(4,g.$pk),K(5,w.$0o),K(6,o.$Qj),K(7,s.$Pi),K(8,y.$uh),K(9,i.$8i),K(10,f.$nk),K(11,n.$mh)],M);class F{constructor(Z,x,H,B,V,ee,ne,ce,re,A,d,O,z,G,U){this.location=Z,this.mtime=x,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=B,this.profile=V,this.profileScanOptions=ee,this.type=ne,this.excludeObsolete=ce,this.validate=re,this.productVersion=A,this.productDate=d,this.productCommit=O,this.devMode=z,this.language=G,this.translations=U}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,x){return(0,h.$1f)(Z.location,x.location)&&Z.mtime===x.mtime&&(0,h.$1f)(Z.applicationExtensionslocation,x.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===x.applicationExtensionslocationMtime&&Z.profile===x.profile&&D.$Jm(Z.profileScanOptions,x.profileScanOptions)&&Z.type===x.type&&Z.excludeObsolete===x.excludeObsolete&&Z.validate===x.validate&&Z.productVersion===x.productVersion&&Z.productDate===x.productDate&&Z.productCommit===x.productCommit&&Z.devMode===x.devMode&&Z.language===x.language&&N.equals(Z.translations,x.translations)}}e.$dp=F;let W=class extends b.$lb{constructor(Z,x,H,B,V){super(),this.f=Z,this.g=x,this.h=H,this.i=B,this.j=V}async scanExtensions(Z){const x=Z.profile?await this.l(Z):await this.k(Z);let H={};if(Z.excludeObsolete&&Z.type===1)try{const B=(await this.i.readFile(this.f)).value.toString();H=JSON.parse(B)}catch{}return(0,c.$ve)(H)?x:x.filter(B=>!H[p.$eo.create(B).toString()])}async k(Z){const x=await this.i.resolve(Z.location);if(!x.children?.length)return[];const H=await Promise.all(x.children.map(async B=>{if(!B.isDirectory||Z.type===1&&(0,h.$5f)(B.resource).indexOf(".")===0)return null;const V=new F(B.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(V)}));return(0,I.$lf)(H).sort((B,V)=>B.location.path<V.location.path?-1:1)}async l(Z){let x=await this.m(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){x=x.filter(B=>!B.metadata?.isApplicationScoped);const H=await this.m(Z.applicationExtensionslocation,B=>!!B.metadata?.isBuiltin||!!B.metadata?.isApplicationScoped,Z);x.push(...H)}return x}async m(Z,x,H){const B=await this.g.scanProfileExtensions(Z,H.profileScanOptions);if(!B.length)return[];const V=await Promise.all(B.map(async ee=>{if(x(ee)){const ne=new F(ee.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ne,ee.metadata)}return null}));return(0,I.$lf)(V)}async scanOneOrMultipleExtensions(Z){try{if(await this.i.exists((0,h.$8f)(Z.location,"package.json"))){const x=await this.scanExtension(Z);return x?[x]:[]}else return await this.scanExtensions(Z)}catch(x){return this.j.error(`Error scanning extensions at ${Z.location.path}:`,(0,L.$9)(x)),[]}}async scanExtension(Z,x){try{let H=await this.scanExtensionManifest(Z.location);if(H){H.publisher||(H.publisher=C.$Bl),x=x??H.__metadata,delete H.__metadata;const B=(0,p.$io)(H.publisher,H.name),V=x?.id?{id:B,uuid:x.id}:{id:B},ee=x?.isSystem?0:Z.type,ne=ee===0||!!x?.isBuiltin;H=await this.n(Z.location,H,F.createNlsConfiguration(Z));const ce={type:ee,identifier:V,manifest:H,location:Z.location,isBuiltin:ne,targetPlatform:x?.targetPlatform??"undefined",metadata:x,isValid:!0,validations:[]};return Z.validate?this.validate(ce,Z):ce}}catch(H){Z.type!==0&&this.j.error(H)}return null}validate(Z,x){let H=!0;const B=(0,t.$to)(x.productVersion,x.productDate,x.location,Z.manifest,Z.isBuiltin);for(const[V,ee]of B)V===v.default.Error&&(H=!1,this.j.error(this.u(x.location,ee)));return Z.isValid=H,Z.validations=B,Z}async scanExtensionManifest(Z){const x=(0,h.$8f)(Z,"package.json");let H;try{H=(await this.i.readFile(x)).value.toString()}catch(V){return(0,o.$7j)(V)!==1&&this.j.error(this.u(Z,(0,u.localize)(0,null,x.path,V.message))),null}let B;try{B=JSON.parse(H)}catch{const ee=[];(0,R.$vm)(H,ee);for(const ne of ee)this.j.error(this.u(Z,(0,u.localize)(1,null,x.path,ne.offset,ne.length,(0,S.$_o)(ne.error))));return null}return(0,R.$Em)(B)!=="object"?(this.j.error(this.u(Z,(0,u.localize)(2,null,x.path))),null):B}async n(Z,x,H){const B=await this.r(Z,x,H);if(B)try{const V=[],ee=await this.s(B.default,V);if(V.length>0)return V.forEach(ce=>{this.j.error(this.u(Z,(0,u.localize)(3,null,B.default?.path,(0,S.$_o)(ce.error))))}),x;if((0,R.$Em)(B)!=="object")return this.j.error(this.u(Z,(0,u.localize)(4,null,B.default?.path))),x;const ne=B.values||Object.create(null);return(0,k.$ap)(x,ne,ee)}catch{}return x}async r(Z,x,H){const B=(0,h.$8f)(Z,"package.nls.json"),V=(re,A)=>{A.forEach(d=>{this.j.error(this.u(Z,(0,u.localize)(5,null,re?.path,(0,S.$_o)(d.error))))})},ee=re=>{this.j.error(this.u(Z,(0,u.localize)(6,null,re?.path)))},ne=`${x.publisher}.${x.name}`,ce=H.translations[ne];if(ce)try{const re=l.URI.file(ce),A=(await this.i.readFile(re)).value.toString(),d=[],O=(0,R.$vm)(A,d);return d.length>0?(V(re,d),{values:void 0,default:B}):(0,R.$Em)(O)!=="object"?(ee(re),{values:void 0,default:B}):{values:O.contents?O.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.i.exists(B))return;let A;try{A=await this.t(Z,H)}catch{return}if(!A.localized)return{values:void 0,default:A.original};try{const d=(await this.i.readFile(A.localized)).value.toString(),O=[],z=(0,R.$vm)(d,O);return O.length>0?(V(A.localized,O),{values:void 0,default:A.original}):(0,R.$Em)(z)!=="object"?(ee(A.localized),{values:void 0,default:A.original}):{values:z,default:A.original}}catch{return{values:void 0,default:A.original}}}}async s(Z,x){if(Z)try{const H=(await this.i.readFile(Z)).value.toString();return(0,R.$vm)(H,x)}catch{}}t(Z,x){return new Promise((H,B)=>{const V=ee=>{const ne=(0,h.$8f)(Z,`package.nls.${ee}.json`);this.i.exists(ne).then(ce=>{ce&&H({localized:ne,original:(0,h.$8f)(Z,"package.nls.json")});const re=ee.lastIndexOf("-");re===-1?H({localized:(0,h.$8f)(Z,"package.nls.json"),original:null}):(ee=ee.substring(0,re),V(ee))})};if(x.devMode||x.pseudo||!x.language)return H({localized:(0,h.$8f)(Z,"package.nls.json"),original:null});V(x.language)})}u(Z,x){return`[${Z.path}]: ${x}`}};W=be([K(1,w.$0o),K(2,f.$nk),K(3,o.$Qj),K(4,s.$Pi)],W);let q=class extends W{constructor(Z,x,H,B,V,ee,ne){super(x,B,V,ee,ne),this.z=Z,this.C=H,this.w=this.B(new T.$rg(3e3)),this.y=this.B(new r.$7c),this.onDidChangeCache=this.y.event}async scanExtensions(Z){const x=this.H(Z),H=await this.D(x);if(this.v=Z,H&&H.input&&F.equals(H.input,this.v))return this.j.debug("Using cached extensions scan result",Z.location.toString()),this.w.trigger(()=>this.G()),H.result.map(V=>(V.location=l.URI.revive(V.location),V));const B=await super.scanExtensions(Z);return await this.F(x,{input:Z,result:B}),B}async D(Z){try{const x=await this.i.readFile(Z),H=JSON.parse(x.value.toString());return{result:H.result,input:(0,a.$Wg)(H.input)}}catch(x){this.j.debug("Error while reading the extension cache file:",Z.path,(0,L.$9)(x))}return null}async F(Z,x){try{await this.i.writeFile(Z,j.$Jb.fromString(JSON.stringify(x)))}catch(H){this.j.debug("Error while writing the extension cache file:",Z.path,(0,L.$9)(H))}}async G(){if(!this.v)return;const Z=this.H(this.v),x=await this.D(Z);if(!x)return;const H=x.result,B=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!D.$Jm(B,H))try{this.j.info("Invalidating Cache",H,B),await this.i.del(Z),this.y.fire()}catch(V){this.j.error(V)}}H(Z){const x=this.I(Z);return this.h.extUri.joinPath(x.cacheHome,Z.type===0?C.$Al:C.$zl)}I(Z){return Z.type===0?this.C.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.z.extensionsResource)?this.z:this.C.profiles.find(x=>this.h.extUri.isEqual(Z.location,x.extensionsResource))??this.z:this.C.defaultProfile}};q=be([K(2,g.$pk),K(3,w.$0o),K(4,f.$nk),K(5,o.$Qj),K(6,s.$Pi)],q);function J(Y,Z){const x=(0,p.$go)(Y.manifest.publisher,Y.manifest.name);return{id:x,identifier:new C.$Fl(x),isBuiltin:Y.type===0,isUserBuiltin:Y.type===1&&Y.isBuiltin,isUnderDevelopment:Z,extensionLocation:Y.location,uuid:Y.identifier.uuid,targetPlatform:Y.targetPlatform,...Y.manifest}}e.$ep=J;class Q extends M{constructor(Z,x,H,B,V,ee,ne,ce,re,A,d,O){super(Z,x,(0,h.$8f)(H,".vscode-oss-dev","extensions","control.json"),B,V,ee,ne,ce,re,A,d,O),this.N=(async()=>{if(m.$y)try{const z=await this.s.readFile(l.URI.file(m.$y));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.N}}e.$fp=Q}),define(oe[239],ae([0,1,63,6,38,3,2,26,16,31,8,17]),function(te,e,I,T,D,j,L,R,S,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=void 0;let m=class extends L.$lb{constructor($,v){super(),this.b=$,this.f=v,this.a=new T.$zg(5)}async postUninstall($){const v=this.g($,"uninstall");v&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(v.script,"uninstall",v.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(c)}}));try{await b.Promises.rm(this.j($))}catch(c){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(c)}}g($,v){const c=`vscode:${v}`;if($.location.scheme===R.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[c]=="string"){const l=$.manifest.scripts[c].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn($.identifier.id,$.manifest.version,`${c} should be a node script`),null):{script:(0,S.$ac)($.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h($,v,c,l,u){return new Promise((y,p)=>{const C=this.i($,v,c,u);let t;const o=n=>{t&&(clearTimeout(t),t=null),n?p(n):y(void 0)};C.on("error",n=>{o((0,D.$$h)(n)||"Unknown")}),C.on("exit",(n,s)=>{o(n?`post-${v} process exited with code ${n}`:void 0)}),l&&(t=setTimeout(()=>{t=null,C.kill(),p("timed out")},5e3))})}i($,v,c,l){const u={silent:!0,execArgv:void 0},y=(0,I.fork)($,[`--type=extension-post-${v}`,...c],u);y.stdout.setEncoding("utf8"),y.stderr.setEncoding("utf8");const p=j.Event.fromNodeEventEmitter(y.stdout,"data"),C=j.Event.fromNodeEventEmitter(y.stderr,"data");p(n=>this.f.info(l.identifier.id,l.manifest.version,`post-${v}`,n)),C(n=>this.f.error(l.identifier.id,l.manifest.version,`post-${v}`,n));const t=j.Event.any(j.Event.map(p,n=>({data:`%c${n}`,format:[""]})),j.Event.map(C,n=>({data:`%c${n}`,format:["color: red"]})));return j.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(l.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),y}j($){return(0,S.$ac)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$hp=m,e.$hp=m=be([K(0,E.$pk),K(1,P.$Pi)],m)}),define(oe[240],ae([0,1,8,17,28,20,50,13,15,10]),function(te,e,I,T,D,j,L,R,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VM=void 0;let P=class extends L.$$o{constructor(m,h,$,v,c,l){super(b.URI.file(m.extensionsPath),h,$,v,c,l)}};e.$VM=P,e.$VM=P=be([K(0,S.$vh),K(1,R.$Qj),K(2,T.$pk),K(3,D.$nk),K(4,j.$Tk),K(5,I.$Pi)],P)}),define(oe[241],ae([0,1,10,15,50,77,13,4,8,24,28,17]),function(te,e,I,T,D,j,L,R,S,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J4b=void 0;let m=class extends j.$fp{constructor($,v,c,l,u,y,p,C){super(I.URI.file(u.builtinExtensionsPath),I.URI.file(u.extensionsPath),u.userHome,$.defaultProfile,$,v,c,l,u,y,p,C)}};e.$J4b=m,e.$J4b=m=be([K(0,E.$pk),K(1,D.$0o),K(2,L.$Qj),K(3,S.$Pi),K(4,T.$vh),K(5,b.$8i),K(6,P.$nk),K(7,R.$mh)],m)}),define(oe[19],ae([0,1,6,3,2,100,11,64,4,17]),function(te,e,I,T,D,j,L,R,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Io=e.$Ho=e.$Go=void 0,e.$Go="__$__isNewStorageMarker",e.$Ho="__$__targetStorageMarker",e.$Io=(0,S.$nh)("storageService");var P;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(P||(e.WillSaveStateReason=P={}));var E;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var m;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function h(u){const y=u.get(e.$Ho);if(y)try{return JSON.parse(y)}catch{}return Object.create(null)}e.$Jo=h;class $ extends D.$lb{static{this.a=60*1e3}constructor(y={flushInterval:$.a}){super(),this.j=y,this.b=this.B(new T.$0c),this.onDidChangeValue=this.b.event,this.c=this.B(new T.$0c),this.onDidChangeTarget=this.c.event,this.f=this.B(new T.$7c),this.onWillSaveState=this.f.event,this.h=this.B(new I.$Eg(()=>this.k(),this.j.flushInterval)),this.i=this.B(new D.$mb),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,I.$Ig)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,D.$gb)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.J()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(y,p){const{key:C,external:t}=p;if(C===e.$Ho){switch(y){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:y})}else this.b.fire({scope:y,key:C,target:this.F(y)[C],external:t})}r(y){this.f.fire({reason:y})}get(y,p,C){return this.L(p)?.get(y,C)}getBoolean(y,p,C){return this.L(p)?.getBoolean(y,C)}getNumber(y,p,C){return this.L(p)?.getNumber(y,C)}getObject(y,p,C){return this.L(p)?.getObject(y,C)}storeAll(y,p){this.t(()=>{for(const C of y)this.store(C.key,C.value,C.scope,C.target,p)})}store(y,p,C,t,o=!1){if((0,L.$re)(p)){this.remove(y,C,o);return}this.t(()=>{this.u(y,C,t),this.L(C)?.set(y,p,o)})}remove(y,p,C=!1){this.t(()=>{this.u(y,p,void 0),this.L(p)?.delete(y,C)})}t(y){this.b.pause(),this.c.pause();try{y()}finally{this.b.resume(),this.c.resume()}}keys(y,p){const C=[],t=this.F(y);for(const o of Object.keys(t))t[o]===p&&C.push(o);return C}u(y,p,C,t=!1){const o=this.F(p);typeof C=="number"?o[y]!==C&&(o[y]=C,this.L(p)?.set(e.$Ho,JSON.stringify(o),t)):typeof o[y]=="number"&&(delete o[y],this.L(p)?.set(e.$Ho,JSON.stringify(o),t))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(y){switch(y){case-1:return this.D;case 0:return this.z;default:return this.w}}G(y){const p=this.L(y);return p?h(p):Object.create(null)}isNew(y){return this.getBoolean(e.$Go,y)===!0}async flush(y=P.NONE){this.f.fire({reason:y});const p=this.L(-1),C=this.L(0),t=this.L(1);switch(y){case P.NONE:await I.Promises.settled([p?.whenFlushed()??Promise.resolve(),C?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await I.Promises.settled([p?.flush(0)??Promise.resolve(),C?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const y=this.L(-1)?.items??new Map,p=this.L(0)?.items??new Map,C=this.L(1)?.items??new Map;return l(y,p,C,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(y,p){return this.r(P.NONE),(0,b.$ok)(y)?this.N(y,p):this.O(y,p)}H(y,p){return!(y.id===p.id||v(p)&&v(y))}I(y,p,C){this.t(()=>{const t=new Set;for(const[o,n]of y)t.add(o),p.get(o)!==n&&this.n(C,{key:o,external:!0});for(const[o]of p.items)t.has(o)||this.n(C,{key:o,external:!0})})}}e.$Ko=$;function v(u){return u.isDefault||!!u.useDefaultFlags?.globalState}e.$Lo=v;class c extends ${constructor(){super(),this.p=this.B(new R.$Eo(new R.$Fo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new R.$Eo(new R.$Fo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new R.$Eo(new R.$Fo,{hint:R.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(y=>this.n(1,y))),this.B(this.P.onDidChangeStorage(y=>this.n(0,y))),this.B(this.p.onDidChangeStorage(y=>this.n(-1,y)))}L(y){switch(y){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(y){switch(y){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(y){return!1}}e.$Mo=c;async function l(u,y,p,C,t,o){const n=N=>{try{return JSON.parse(N)}catch{return N}},s=new Map,i=new Map;u.forEach((N,M)=>{s.set(M,N),i.set(M,n(N))});const r=new Map,a=new Map;y.forEach((N,M)=>{r.set(M,N),a.set(M,n(N))});const w=new Map,g=new Map;p.forEach((N,M)=>{w.set(M,N),g.set(M,n(N))}),console.group(C!==t?`Storage: Application (path: ${C})`:`Storage: Application & Profile (path: ${C}, default profile)`);const f=[];if(s.forEach((N,M)=>{f.push({key:M,value:N})}),console.table(f),console.groupEnd(),console.log(i),C!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const N=[];r.forEach((M,F)=>{N.push({key:F,value:M})}),console.table(N),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const k=[];w.forEach((N,M)=>{k.push({key:M,value:N})}),console.table(k),console.groupEnd(),console.log(g)}e.$No=l}),define(oe[113],ae([0,1,3,2,11,29,33,19]),function(te,e,I,T,D,j,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mxb=e.$lxb=void 0;let S=class extends T.$lb{constructor(E,m){super(),this.a=new I.$7c,this.onDidChangeEnablement=this.a.event,this.b=this.B(new b(E)),this.B(this.b.onDidChange(h=>this.a.fire({extensions:h,source:"storage"}))),this.B(m.onDidInstallExtensions(h=>h.forEach(({local:$,operation:v})=>{$&&v===4&&this.f($.identifier)})))}async enableExtension(E,m){return this.f(E)?(this.a.fire({extensions:[E],source:m}),!0):!1}async disableExtension(E,m){return this.c(E)?(this.a.fire({extensions:[E],source:m}),!0):!1}getDisabledExtensions(){return this.h(j.$Qn)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(E){const m=this.getDisabledExtensions();return m.every(h=>!(0,L.$do)(h,E))?(m.push(E),this.g(m),!0):!1}f(E){const m=this.getDisabledExtensions();for(let h=0;h<m.length;h++){const $=m[h];if((0,L.$do)($,E))return m.splice(h,1),this.g(m),!0}return!1}g(E){this.i(j.$Qn,E)}h(E){return this.b.get(E,0)}i(E,m){this.b.set(E,m,0)}};e.$lxb=S,e.$lxb=S=be([K(0,R.$Io),K(1,j.$Pn)],S);class b extends T.$lb{constructor(E){super(),this.c=E,this.a=Object.create(null),this.b=this.B(new I.$7c),this.onDidChange=this.b.event,this.B(E.onDidChangeValue(m=>this.f(m)))}get(E,m){let h;return m===0?((0,D.$re)(this.a[E])&&(this.a[E]=this.g(E,m)),h=this.a[E]):h=this.g(E,m),JSON.parse(h)}set(E,m,h){const $=JSON.stringify(m.map(({id:c,uuid:l})=>({id:c,uuid:l})));this.g(E,h)!==$&&(h===0&&(m.length?this.a[E]=$:delete this.a[E]),this.h(E,m.length?$:void 0,h))}f(E){if(E.scope===0&&!(0,D.$re)(this.a[E.key])&&this.g(E.key,E.scope)!==this.a[E.key]){const h=this.get(E.key,E.scope);delete this.a[E.key];const $=this.get(E.key,E.scope),v=h.filter(l=>!$.some(u=>(0,L.$do)(l,u))),c=$.filter(l=>!h.some(u=>(0,L.$do)(u,l)));(v.length||c.length)&&this.b.fire([...v,...c])}}g(E,m){return this.c.get(E,m,"[]")}h(E,m,h){m?this.c.store(E,m,h,1):this.c.remove(E,h)}}e.$mxb=b}),define(oe[242],ae([0,1,21,25,7,5,37,11,10,18,15,29,33,65,13,8,24,57,219,19,20]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$So=e.$Ro=e.$Qo=void 0;const C=j.$o?"web":(0,E.$In)(j.$t,L.$8b),t="X-Market-Search-Activity-Id";var o;(function(A){A[A.None=0]="None",A[A.IncludeVersions=1]="IncludeVersions",A[A.IncludeFiles=2]="IncludeFiles",A[A.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",A[A.IncludeSharedAccounts=8]="IncludeSharedAccounts",A[A.IncludeVersionProperties=16]="IncludeVersionProperties",A[A.ExcludeNonValidated=32]="ExcludeNonValidated",A[A.IncludeInstallationTargets=64]="IncludeInstallationTargets",A[A.IncludeAssetUri=128]="IncludeAssetUri",A[A.IncludeStatistics=256]="IncludeStatistics",A[A.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",A[A.Unpublished=4096]="Unpublished",A[A.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(o||(o={}));function n(...A){return String(A.reduce((d,O)=>d|O,0))}var s;(function(A){A[A.Tag=1]="Tag",A[A.ExtensionId=4]="ExtensionId",A[A.Category=5]="Category",A[A.ExtensionName=7]="ExtensionName",A[A.Target=8]="Target",A[A.Featured=9]="Featured",A[A.SearchText=10]="SearchText",A[A.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},w={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class g{constructor(d=w){this.d=d}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(d,O=this.d.pageSize){return new g({...this.d,pageNumber:d,pageSize:O})}withFilter(d,...O){const z=[...this.d.criteria,...O.length?O.map(G=>({filterType:d,value:G})):[{filterType:d}]];return new g({...this.d,criteria:z})}withSortBy(d){return new g({...this.d,sortBy:d})}withSortOrder(d){return new g({...this.d,sortOrder:d})}withFlags(...d){return new g({...this.d,flags:d.reduce((O,z)=>O|z,0)})}withAssetTypes(...d){return new g({...this.d,assetTypes:d})}withSource(d){return new g({...this.d,source:d})}get raw(){const{criteria:d,pageNumber:O,pageSize:z,sortBy:G,sortOrder:U,flags:X,assetTypes:_}=this.d;return{filters:[{criteria:d,pageNumber:O,pageSize:z,sortBy:G,sortOrder:U}],assetTypes:_,flags:X}}get searchText(){const d=this.d.criteria.filter(O=>O.filterType===s.SearchText)[0];return d&&d.value?d.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(d=>String(d.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function f(A,d){const O=(A||[]).filter(z=>z.statisticName===d)[0];return O?O.value:0}function k(A){const d="Microsoft.VisualStudio.Code.Translation.";return A.files.filter(z=>z.assetType.indexOf(d)===0).reduce((z,G)=>{const U=F(A,G.assetType);return U&&z.push([G.assetType.substring(d.length),U]),z},[])}function N(A){if(A.properties){const d=A.properties.filter(G=>G.key===i.Repository),O=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),z=d.filter(G=>O.test(G.value))[0];return z?{uri:z.value,fallbackUri:z.value}:null}return F(A,i.Repository)}function M(A){return{uri:`${A.fallbackAssetUri}/${i.VSIX}?redirect=true${A.targetPlatform?`&targetPlatform=${A.targetPlatform}`:""}`,fallbackUri:`${A.fallbackAssetUri}/${i.VSIX}${A.targetPlatform?`?targetPlatform=${A.targetPlatform}`:""}`}}function F(A,d){return A.files.filter(z=>z.assetType===d)[0]?{uri:`${A.assetUri}/${d}${A.targetPlatform?`?targetPlatform=${A.targetPlatform}`:""}`,fallbackUri:`${A.fallbackAssetUri}/${d}${A.targetPlatform?`?targetPlatform=${A.targetPlatform}`:""}`}:null}function W(A,d){const O=A.properties?A.properties.filter(G=>G.key===d):[],z=O.length>0&&O[0].value;return z?z.split(",").map(G=>(0,m.$ho)(G)):[]}function q(A){const d=A.properties?A.properties.filter(O=>O.key===r.Engine):[];return d.length>0&&d[0].value||""}function J(A){const d=A.properties?A.properties.filter(O=>O.key===r.PreRelease):[];return d.length>0&&d[0].value==="true"}function Q(A){const d=A.properties?A.properties.filter(z=>z.key===r.LocalizedLanguages):[],O=d.length>0&&d[0].value||"";return O?O.split(","):[]}function Y(A){return A.properties?.find(d=>d.key===r.SponsorLink)?.value}function Z(A){return A.indexOf("preview")!==-1}function x(A){return A.targetPlatform?(0,E.$Hn)(A.targetPlatform):"undefined"}function H(A){const d=(0,I.$qf)(A.versions.map(x)),O=!!A.tags?.includes(E.$Dn),z=d.indexOf("web");return O?z===-1&&d.push("web"):z!==-1&&d.splice(z,1),d}function B(A,d){const O=(0,E.$Ln)(d);for(let z=0;z<A.length;z++){const G=A[z];if(G.version===A[z-1]?.version){let U=z;const X=x(G);if(X===d)for(;U>0&&A[U-1].version===G.version;)U--;else if(O.includes(X))for(;U>0&&A[U-1].version===G.version&&x(A[U-1])!==d;)U--;U!==z&&(A.splice(z,1),A.splice(U,0,G))}}return A}e.$Qo=B;function V(A,d,O){A.telemetryData={index:d,querySource:O,queryActivityId:A.queryContext?.[t]}}function ee(A,d,O,z){const G=A.versions[0],U={manifest:F(d,i.Manifest),readme:F(d,i.Details),changelog:F(d,i.Changelog),license:F(d,i.License),repository:N(d),download:M(d),icon:F(d,i.Icon),signature:F(d,i.Signature),coreTranslations:k(d)};return{identifier:{id:(0,m.$io)(A.publisher.publisherName,A.extensionName),uuid:A.extensionId},name:A.extensionName,version:d.version,displayName:A.displayName,publisherId:A.publisher.publisherId,publisher:A.publisher.publisherName,publisherDisplayName:A.publisher.displayName,publisherDomain:A.publisher.domain?{link:A.publisher.domain,verified:!!A.publisher.isDomainVerified}:void 0,publisherSponsorLink:Y(G),description:A.shortDescription||"",installCount:f(A.statistics,"install"),rating:f(A.statistics,"averagerating"),ratingCount:f(A.statistics,"ratingcount"),categories:A.categories||[],tags:A.tags||[],releaseDate:Date.parse(A.releaseDate),lastUpdated:Date.parse(A.lastUpdated),allTargetPlatforms:O,assets:U,properties:{dependencies:W(d,r.Dependency),extensionPack:W(d,r.ExtensionPack),engine:q(d),localizedLanguages:Q(d),targetPlatform:x(d),isPreReleaseVersion:J(d)},hasPreReleaseVersion:J(G),hasReleaseVersion:!0,preview:Z(A.flags),isSigned:!!U.signature,queryContext:z}}let ne=class{constructor(d,O,z,G,U,X,_,se){this.k=O,this.l=z,this.n=G,this.o=U,this.q=X,this.u=_,this.w=se;const he=_.extensionsGallery,ue=he?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=ue?he.servicePPEUrl:he?.serviceUrl,this.g=ue?void 0:he?.searchUrl,this.h=he?.controlUrl,this.j=(0,u.$Po)(_.version,_,this.n,this.w,this.q,d,this.o)}x(d=""){return`${this.d}${d}`}isEnabled(){return!!this.d}async getExtensions(d,O,z){const G=T.CancellationToken.isCancellationToken(O)?{}:O,U=T.CancellationToken.isCancellationToken(O)?O:z,X=[],_=[],se=[],he=[];let ue=!0;for(const ke of d){ke.uuid?_.push(ke.uuid):X.push(ke.id);const Re=!!(ke.version||ke.preRelease);se.push({id:ke.id,uuid:ke.uuid,includePreRelease:Re}),ke.version&&he.push({id:ke.id,uuid:ke.uuid,version:ke.version}),ue=ue&&!!ke.hasPreRelease&&!Re}if(!_.length&&!X.length)return[];let me=new g().withPage(1,d.length);_.length&&(me=me.withFilter(s.ExtensionId,..._)),X.length&&(me=me.withFilter(s.ExtensionName,...X)),(G.queryAllVersions||ue)&&(me=me.withFlags(me.flags,o.IncludeVersions)),G.source&&(me=me.withSource(G.source));const{extensions:pe}=await this.z(me,{targetPlatform:G.targetPlatform??C,includePreRelease:se,versions:he,compatible:!!G.compatible},U);return G.source&&pe.forEach((ke,Re)=>V(ke,Re,G.source)),pe}async getCompatibleExtension(d,O,z){if((0,E.$Jn)(d.allTargetPlatforms,z))return null;if(await this.isExtensionCompatible(d,O,z))return d;const G=new g().withFlags(o.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,d.identifier.uuid),{extensions:U}=await this.z(G,{targetPlatform:z,compatible:!0,includePreRelease:O},T.CancellationToken.None);return U[0]||null}async isExtensionCompatible(d,O,z){if(!(0,E.$Kn)(d.properties.targetPlatform,d.allTargetPlatforms,z)||!O&&d.properties.isPreReleaseVersion)return!1;let G=d.properties.engine;if(!G){const U=await this.getManifest(d,T.CancellationToken.None);if(!U)throw new Error("Manifest was not found");G=U.engines.vscode}return(0,h.$vo)(G,this.u.version,this.u.date)}async y(d,O,z,G,U){if(!(0,E.$Kn)(x(d),G,U)||O!=="any"&&J(d)!==(O==="prerelease"))return!1;if(z)try{const X=await this.E(d);if(!(0,h.$vo)(X,this.u.version,this.u.date))return!1}catch(X){return this.l.error(`Error while getting the engine for the version ${d.version}.`,(0,D.$9)(X)),!1}return!0}async query(d,O){let z=d.text||"";const G=d.pageSize??50;let U=new g().withPage(1,G);z?(z=z.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,me,pe)=>(U=U.withFilter(s.Category,pe||me),"")),z=z.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ue,me,pe)=>(U=U.withFilter(s.Tag,pe||me),"")),z=z.replace(/\bfeatured(\s+|\b|$)/g,()=>(U=U.withFilter(s.Featured),"")),z=z.trim(),z&&(z=z.length<200?z:z.substring(0,200),U=U.withFilter(s.SearchText,z)),U=U.withSortBy(0)):d.ids?U=U.withFilter(s.ExtensionId,...d.ids):d.names?U=U.withFilter(s.ExtensionName,...d.names):U=U.withSortBy(4),typeof d.sortBy=="number"&&(U=U.withSortBy(d.sortBy)),typeof d.sortOrder=="number"&&(U=U.withSortOrder(d.sortOrder)),d.source&&(U=U.withSource(d.source));const X=async(ue,me)=>{const{extensions:pe,total:ke}=await this.z(ue,{targetPlatform:C,compatible:!1,includePreRelease:!!d.includePreRelease},me);return pe.forEach((Re,Oe)=>V(Re,(ue.pageNumber-1)*ue.pageSize+Oe,d.source)),{extensions:pe,total:ke}},{extensions:_,total:se}=await X(U,O),he=async(ue,me)=>{if(me.isCancellationRequested)throw new D.$3;const{extensions:pe}=await X(U.withPage(ue+1),me);return pe};return{firstPage:_,total:se,pageSize:U.pageSize,getPage:he}}async z(d,O,z){const G=d.flags;d.flags&o.IncludeLatestVersionOnly&&d.flags&o.IncludeVersions&&(d=d.withFlags(d.flags&~o.IncludeVersions,o.IncludeLatestVersionOnly)),!(d.flags&o.IncludeLatestVersionOnly)&&!(d.flags&o.IncludeVersions)&&(d=d.withFlags(d.flags,o.IncludeLatestVersionOnly)),O.versions?.length&&(d=d.withFlags(d.flags&~o.IncludeLatestVersionOnly,o.IncludeVersions)),d=d.withFlags(d.flags,o.IncludeAssetUri,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeStatistics,o.IncludeVersionProperties);const{galleryExtensions:U,total:X,context:_}=await this.B(d,z);if(!(d.flags&o.IncludeLatestVersionOnly)){const me=[];for(const pe of U){const ke=await this.A(pe,O,_);ke&&me.push(ke)}return{extensions:me,total:X}}const he=[],ue=new Map;for(let me=0;me<U.length;me++){const pe=U[me],ke={id:(0,m.$io)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Re=(0,R.$oe)(O.includePreRelease)?O.includePreRelease:!!O.includePreRelease.find(ze=>(0,m.$do)(ze,ke))?.includePreRelease;if(O.compatible&&(0,E.$Jn)(H(pe),O.targetPlatform))continue;const Oe=await this.A(pe,O,_);!Oe||Oe.properties.isPreReleaseVersion&&(!Re||!Oe.hasReleaseVersion)||!Oe.properties.isPreReleaseVersion&&Oe.properties.targetPlatform!==O.targetPlatform&&Oe.hasPreReleaseVersion?ue.set(pe.extensionId,me):he.push([me,Oe])}if(ue.size){const me=new Date().getTime(),pe=new g().withFlags(G&~o.IncludeLatestVersionOnly,o.IncludeVersions).withPage(1,ue.size).withFilter(s.ExtensionId,...ue.keys()),{extensions:ke}=await this.z(pe,O,z);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-me,count:ue.size});for(const Re of ke){const Oe=ue.get(Re.identifier.uuid);he.push([Oe,Re])}}return{extensions:he.sort((me,pe)=>me[0]-pe[0]).map(([,me])=>me),total:X}}async A(d,O,z){const G={id:(0,m.$io)(d.publisher.publisherName,d.extensionName),uuid:d.extensionId},U=O.versions?.find(he=>(0,m.$do)(he,G))?.version,X=(0,R.$oe)(O.includePreRelease)?O.includePreRelease:!!O.includePreRelease.find(he=>(0,m.$do)(he,G))?.includePreRelease,_=H(d),se=B(d.versions,O.targetPlatform);if(O.compatible&&(0,E.$Jn)(_,O.targetPlatform))return null;for(let he=0;he<se.length;he++){const ue=se[he];if(!(U&&ue.version!==U)){if(await this.y(ue,X?"any":"release",O.compatible,_,O.targetPlatform))return ee(d,ue,_,z);if(U&&ue.version===U)return null}}return U||O.compatible?null:ee(d,d.versions[0],_)}async B(d,O){if(!this.isEnabled())throw new Error("No extension gallery service configured.");d=d.withFlags(d.flags,o.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(o.Unpublished));const z=await this.j,G=JSON.stringify(d.raw),U={...z,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},X=new Date().getTime();let _,se,he=0;try{if(_=await this.k.request({type:"POST",url:this.g&&d.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:U},O),_.res.statusCode&&_.res.statusCode>=400&&_.res.statusCode<500)return{galleryExtensions:[],total:he};const ue=await(0,l.$Bo)(_);if(ue){const me=ue.results[0],pe=me.extensions,ke=me.resultMetadata&&me.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return he=ke&&ke.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:he,context:{[t]:_.res.headers.activityid}}}return{galleryExtensions:[],total:he}}catch(ue){throw se=ue,ue}finally{this.o.publicLog2("galleryService:query",{...d.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-X,success:!!_&&(0,l.$yo)(_),responseBodySize:_?.res.headers["Content-Length"],statusCode:_?String(_.res.statusCode):void 0,errorCode:se?(0,D.$2)(se)?"canceled":(0,D.$9)(se).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(d,O,z,G){if(!this.isEnabled())return;const U=j.$o?this.x(`/itemName/${d}.${O}/version/${z}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${d}/extensions/${O}/${z}/stats?statType=${G}`),X=j.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:X};try{await this.k.request({type:"POST",url:U,headers:se},T.CancellationToken.None)}catch{}}async download(d,O,z){this.l.trace("ExtensionGalleryService#download",d.identifier.id);const G=(0,m.$lo)(d),U=new Date().getTime(),X=me=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:me}),_=z===2?"install":z===3?"update":"",se=_?{uri:`${d.assets.download.uri}${S.URI.parse(d.assets.download.uri).query?"&":"?"}${_}=true`,fallbackUri:`${d.assets.download.fallbackUri}${S.URI.parse(d.assets.download.fallbackUri).query?"&":"?"}${_}=true`}:d.assets.download,he=d.queryContext?.[t]?{[t]:d.queryContext[t]}:void 0,ue=await this.D(se,he?{headers:he}:void 0);await this.q.writeFile(O,ue.stream),X(new Date().getTime()-U)}async downloadSignatureArchive(d,O){if(!d.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",d.identifier.id);const z=await this.D(d.assets.signature);await this.q.writeFile(O,z.stream)}async getReadme(d,O){if(d.assets.readme){const z=await this.D(d.assets.readme,{},O);return await(0,l.$Ao)(z)||""}return""}async getManifest(d,O){if(d.assets.manifest){const z=await this.D(d.assets.manifest,{},O),G=await(0,l.$Ao)(z);return G?JSON.parse(G):null}return null}async C(d,O){const z=F(d,i.Manifest);if(!z)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},U=await this.D(z,{headers:G});return await(0,l.$Bo)(U)}async getCoreTranslation(d,O){const z=d.assets.coreTranslations.filter(G=>G[0]===O.toUpperCase())[0];if(z){const G=await this.D(z[1]),U=await(0,l.$Ao)(G);return U?JSON.parse(U):null}return null}async getChangelog(d,O){if(d.assets.changelog){const z=await this.D(d.assets.changelog,{},O);return await(0,l.$Ao)(z)||""}return""}async getAllCompatibleVersions(d,O,z){let G=new g().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1);d.identifier.uuid?G=G.withFilter(s.ExtensionId,d.identifier.uuid):G=G.withFilter(s.ExtensionName,d.identifier.id);const{galleryExtensions:U}=await this.B(G,T.CancellationToken.None);if(!U.length)return[];const X=H(U[0]);if((0,E.$Jn)(X,z))return[];const _=[];await Promise.all(U[0].versions.map(async ue=>{try{await this.y(ue,O?"any":"release",!0,X,z)&&_.push(ue)}catch{}}));const se=[],he=new Set;for(const ue of B(_,z))he.has(ue.version)||(he.add(ue.version),se.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:J(ue)}));return se}async D(d,O={},z=T.CancellationToken.None){const G=await this.j,U={type:"GET"},X={...G,...O.headers||{}};O={...O,...U,headers:X};const _=d.uri,se=d.fallbackUri,he={...O,url:_};try{const ue=await this.k.request(he,z);if(ue.res.statusCode===200)return ue;const me=await(0,l.$Ao)(ue);throw new Error(`Expected 200, got back ${ue.res.statusCode} instead.

${me}`)}catch(ue){if((0,D.$2)(ue))throw ue;const me=(0,D.$9)(ue);this.o.publicLog2("galleryService:cdnFallback",{url:_,message:me});const pe={...O,url:se};return this.k.request(pe,z)}}async E(d){let O=q(d);if(!O){const z=await this.C(d,T.CancellationToken.None);if(!z)throw new Error("Manifest was not found");O=z.engines.vscode}return O}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const d=await this.k.request({type:"GET",url:this.h},T.CancellationToken.None);if(d.res.statusCode!==200)throw new Error("Could not get extensions report.");const O=await(0,l.$Bo)(d),z=[],G={},U=[];if(O){for(const X of O.malicious)z.push({id:X});if(O.migrateToPreRelease)for(const[X,_]of Object.entries(O.migrateToPreRelease))(!_.engine||(0,h.$vo)(_.engine,this.u.version,this.u.date))&&(G[X.toLowerCase()]={disallowInstall:!0,extension:{id:_.id,displayName:_.displayName,autoMigrate:{storage:!!_.migrateStorage},preRelease:!0}});if(O.deprecated)for(const[X,_]of Object.entries(O.deprecated))_&&(G[X.toLowerCase()]=(0,R.$oe)(_)?{}:_);if(O.search)for(const X of O.search)U.push(X)}return{malicious:z,deprecated:G,search:U}}};ne=be([K(1,l.$wo),K(2,v.$Pi),K(3,P.$uh),K(4,p.$Tk),K(5,$.$Qj),K(6,c.$8i),K(7,b.$Th)],ne);let ce=class extends ne{constructor(d,O,z,G,U,X,_,se){super(d,O,z,G,U,X,_,se)}};e.$Ro=ce,e.$Ro=ce=be([K(0,y.$Io),K(1,l.$wo),K(2,v.$Pi),K(3,P.$uh),K(4,p.$Tk),K(5,$.$Qj),K(6,c.$8i),K(7,b.$Th)],ce);let re=class extends ne{constructor(d,O,z,G,U,X,_){super(void 0,d,O,z,G,U,X,_)}};e.$So=re,e.$So=re=be([K(0,l.$wo),K(1,v.$Pi),K(2,P.$uh),K(3,p.$Tk),K(4,$.$Qj),K(5,c.$8i),K(6,b.$Th)],re)}),define(oe[78],ae([0,1,4,3,2,19,33,24,21,8,11]),function(te,e,I,T,D,j,L,R,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bz=e.$Az=void 0,e.$Az=(0,I.$nh)("IExtensionStorageService");const E=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=class Ye extends D.$lb{static{this.a=512*1024}static b($){return`extensionKeys/${(0,L.$ho)($.id)}@${$.version}`}static c($){const v=E.exec($);if(v&&v[1])return{id:v[1],version:v[2]}}static async removeOutdatedExtensionVersions($,v){const c=await $.getInstalled(),l=[];for(const[u,y]of Ye.f(v)){const p=c.find(C=>(0,L.$do)(C.identifier,{id:u}))?.manifest.version;for(const C of y)p!==C&&l.push(Ye.b({id:u,version:C}))}for(const u of l)v.remove(u,0)}static f($){const v=new Map,c=$.keys(0,1);for(const l of c){const u=Ye.c(l);if(u){let y=v.get(u.id.toLowerCase());y||v.set(u.id.toLowerCase(),y=[]),y.push(u.version)}}return v}constructor($,v,c){super(),this.i=$,this.j=v,this.k=c,this.g=this.B(new T.$7c),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Ye.f($),this.B(this.i.onDidChangeValue(l=>this.l(l)))}l($){if($.scope!==0)return;if(this.h.has($.key.toLowerCase())){this.g.fire();return}const v=Ye.c($.key);if(v){if(this.i.get($.key,0)===void 0)this.h.delete(v.id.toLowerCase());else{let c=this.h.get(v.id.toLowerCase());c||this.h.set(v.id.toLowerCase(),c=[]),c.push(v.version),this.g.fire()}return}}m($){if((0,P.$ie)($))return $;const v=$.manifest?$.manifest.publisher:$.publisher,c=$.manifest?$.manifest.name:$.name;return(0,L.$go)(v,c)}getExtensionState($,v){const c=this.m($),l=this.getExtensionStateRaw($,v);if(l)try{return JSON.parse(l)}catch(u){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${c}, global: ${v}): ${u}`)}}getExtensionStateRaw($,v){const c=this.m($),l=this.i.get(c,v?0:1);return l&&l?.length>Ye.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${c}, global: ${v}): ${l.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),l}setExtensionState($,v,c){const l=this.m($);v===void 0?this.i.remove(l,c?0:1):this.i.store(l,JSON.stringify(v),c?0:1,1)}setKeysForSync($,v){this.i.store(Ye.b($),JSON.stringify(v),0,1)}getKeysForSync($){const v=this.j.extensionSyncedKeys?.[$.id.toLowerCase()],c=this.i.get(Ye.b($),0),l=c?JSON.parse(c):void 0;return l&&v?(0,S.$qf)([...l,...v]):l||v}addToMigrationList($,v){if($!==v){const c=this.n.filter(l=>!l.includes($)&&!l.includes(v));c.push([$,v]),this.n=c}}getSourceExtensionToMigrate($){const v=this.n.find(([,c])=>$===c);return v?v[0]:void 0}get n(){const $=this.i.get("extensionStorage.migrationList",-1,"[]");try{const v=JSON.parse($);if(Array.isArray(v))return v}catch{}return[]}set n($){$.length?this.i.store("extensionStorage.migrationList",JSON.stringify($),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};e.$Bz=m,e.$Bz=m=be([K(0,j.$Io),K(1,R.$8i),K(2,b.$Pi)],m)}),define(oe[243],ae([0,1,29,13,24,15,98,55,19,20,216]),function(te,e,I,T,D,j,L,R,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$45b=void 0;let E=class extends P.$p2b{constructor(h,$,v,c,l,u,y,p){super(h.userHome,l,$,v,c,u,y,p)}};e.$45b=E,e.$45b=E=be([K(0,j.$vh),K(1,b.$Tk),K(2,I.$Pn),K(3,S.$Io),K(4,R.$T3b),K(5,L.$RSb),K(6,T.$Qj),K(7,D.$8i)],E)}),define(oe[244],ae([0,1,105,3,20,15,2,8,16,63,24,5,6,101,18,161,36,19,11,129]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z5b=void 0;const p=[I.$S5b,I.$T5b],C="remoteTunnelSession",t="remoteTunnelIsService";let o=class extends L.$lb{constructor(r,a,w,g,f,k,N){super(),this.t=r,this.u=a,this.v=w,this.w=k,this.y=N,this.f=new T.$7c,this.onDidTokenFailed=this.f.event,this.g=new T.$7c,this.onDidChangeTunnelStatus=this.g.event,this.h=new T.$7c,this.onDidChangeMode=this.h.event,this.j=I.$Q5b,this.s=!1,this.D=(M,F)=>{F?this.i.error(M):this.i.info(M)},this.i=this.B(g.createLogger(I.$U5b,{name:I.$V5b})),this.p=new m.$qg(100),this.B(this.i.onDidChangeLogLevel(M=>this.i.info("Log level changed to "+(0,R.$5i)(M)))),this.B(f.onWillShutdown(()=>{this.k?.cancel(),this.k=void 0,this.dispose()})),this.B(k.onDidChangeConfiguration(M=>{p.some(F=>M.affectsConfiguration(F))&&this.p.trigger(()=>this.G())})),this.j=this.N(),this.n=I.TunnelStates.uninitialized}async getTunnelStatus(){return this.n}z(r){this.n=r,this.g.fire(r)}C(r){s(this.j,r)||(this.j=r,this.O(r),this.h.fire(this.j),r.active?(this.i.info(`Session updated: ${r.session.accountLabel} (${r.session.providerId}) (service=${r.asService})`),r.session.token&&this.i.info(`Session token updated: ${r.session.accountLabel} (${r.session.providerId})`)):this.i.info("Session reset"))}getMode(){return Promise.resolve(this.j)}async initialize(r){if(this.s)return this.n;this.s=!0,this.C(r);try{await this.p.trigger(()=>this.G())}catch(a){this.i.error(a)}return this.n}F(){if(!this.r){let r;E.$j?r=this.v.appRoot:r=(0,S.$dc)((0,S.$dc)(this.v.appRoot)),this.r=(0,S.$ac)(r,"bin",`${this.u.tunnelApplicationName}${E.$i?".exe":""}`)}return this.r}async startTunnel(r){if(s(this.j,r)&&this.n.type!=="disconnected")return this.n;this.C(r);try{await this.p.trigger(()=>this.G())}catch(a){this.i.error(a)}return this.n}async stopTunnel(){if(this.k&&(this.k.cancel(),this.k=void 0),!this.j.active)return;const r=this.j.asService;this.C(I.$Q5b);try{r&&this.J("uninstallService",["service","uninstall"])}catch(a){this.i.error(a)}try{await this.J("stop",["kill"])}catch(a){this.i.error(a)}this.z(I.TunnelStates.disconnected())}async G(){this.t.publicLog2("remoteTunnel.enablement",{enabled:this.j.active,service:this.j.active&&this.j.asService}),this.k&&(this.k.cancel(),this.k=void 0);let r="",a=!1;const w=(F,W)=>{W?this.i.error(F):r+=F,!this.v.isBuilt&&F.startsWith("   Compiling")&&this.z(I.TunnelStates.connecting((0,v.localize)(0,null)))},g=this.J("status",["status"],w);this.k=g;try{if(await g,this.k!==g)return;const F=JSON.parse(r.trim().split(`
`).find(W=>W.startsWith("{")));if(a=F.service_installed,this.i.info(F.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!F.tunnel&&!this.j.active){this.z(I.TunnelStates.disconnected());return}}catch(F){this.i.error(F),this.z(I.TunnelStates.disconnected());return}finally{this.k===g&&(this.k=void 0)}const f=this.j.active?this.j.session:void 0;if(f&&f.token){const F=f.token;this.z(I.TunnelStates.connecting((0,v.localize)(1,null,f.accountLabel,f.providerId)));const W=(J,Q)=>{J=J.replaceAll(F,"*".repeat(4)),w(J,Q)},q=this.J("login",["user","login","--provider",f.providerId,"--access-token",F,"--log",(0,R.$5i)(this.i.getLevel())],W);this.k=q;try{if(await q,this.k!==q)return}catch(J){this.i.error(J),this.k=void 0,this.f.fire(f),this.z(I.TunnelStates.disconnected(f));return}}const k=this.M();k?this.z(I.TunnelStates.connecting((0,v.localize)(2,null,k))):this.z(I.TunnelStates.connecting((0,v.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,R.$5i)(this.i.getLevel())];k?N.push("--name",k):N.push("--random-name");let M=!1;return this.j.active&&this.j.asService&&!a&&(M=await this.H(N)===!1),this.I(f,N,M)}async H(r){let a;try{a=await this.J("serviceInstall",["service","install",...r])}catch(w){this.i.error(w),a=1}if(a!==0){const w=(0,v.localize)(4,null);return this.i.warn(w),this.z(I.TunnelStates.connecting(w)),!1}return!0}async I(r,a,w){a.push("--parent-process-id",String(process.pid)),this.L()&&a.push("--no-sleep");let g=!1;const f=this.J("tunnel",a,(k,N)=>{N?this.i.error(k):this.i.info(k),k.includes("Connected to an existing tunnel process")&&(g=!0);const M=k.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const F={link:M[1],domain:M[2],tunnelName:M[4],isAttached:g};this.z(I.TunnelStates.connected(F,w))}else k.match(/error refreshing token/)&&(f.cancel(),this.f.fire(r),this.z(I.TunnelStates.disconnected(r)))});this.k=f,f.finally(()=>{f===this.k&&(this.i.info("tunnel process terminated"),this.k=void 0,this.j=I.$Q5b,this.z(I.TunnelStates.disconnected()))})}J(r,a,w=this.D){return(0,m.$hg)(g=>new Promise((f,k)=>{g.isCancellationRequested&&f(-1);let N;const M=["ignore","pipe","pipe"];if(g.onCancellationRequested(()=>{N&&(this.i.info(`${r} terminating(${N.pid})`),N.kill())}),!this.v.isBuilt)w(`Building tunnel CLI from sources and run
`,!1),w(`${r} Spawning: cargo run -- tunnel ${a.join(" ")}
`,!1),N=(0,b.spawn)("cargo",["run","--","tunnel",...a],{cwd:(0,S.$ac)(this.v.appRoot,"cli"),stdio:M});else{w(`Running tunnel CLI
`,!1);const F=this.F();w(`${r} Spawning: ${F} tunnel ${a.join(" ")}
`,!1),N=(0,b.spawn)(F,["tunnel",...a],{cwd:(0,c.homedir)(),stdio:M})}N.stdout.pipe(new y.$fS(`
`)).on("data",F=>{if(N){const W=F.toString();w(W,!1)}}),N.stderr.pipe(new y.$fS(`
`)).on("data",F=>{if(N){const W=F.toString();w(W,!0)}}),N.on("exit",F=>{N&&(w(`${r} exit(${N.pid}): + ${F} `,!1),N=void 0,f(F||0))}),N.on("error",F=>{N&&(w(`${r} error(${N.pid}): + ${F} `,!0),N=void 0,k())})}))}async getTunnelName(){return this.M()}L(){return!!this.w.getValue(I.$T5b)}M(){let r=this.w.getValue(I.$S5b)||(0,c.hostname)();return r=r.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),r||void 0}N(){try{const r=this.y.get(C,-1),a=this.y.getBoolean(t,-1,!1);if(r){const w=JSON.parse(r);if(w&&(0,u.$ie)(w.accountLabel)&&(0,u.$ie)(w.sessionId)&&(0,u.$ie)(w.providerId))return{active:!0,session:w,asService:a};this.i.error("Problems restoring session from storage, invalid format",w)}}catch(r){this.i.error("Problems restoring session from storage",r)}return I.$Q5b}O(r){if(r.active){const a={providerId:r.session.providerId,sessionId:r.session.sessionId,accountLabel:r.session.accountLabel};this.y.store(C,JSON.stringify(a),-1,1),this.y.store(t,r.asService,-1,1)}else this.y.remove(C,-1),this.y.remove(t,-1)}};e.$Z5b=o,e.$Z5b=o=be([K(0,D.$Tk),K(1,P.$8i),K(2,j.$vh),K(3,R.$Qi),K(4,h.$X5b),K(5,$.$Th),K(6,l.$Io)],o);function n(i,r){return i&&r?i.sessionId===r.sessionId&&i.providerId===r.providerId&&i.token===r.token:i===r}const s=(i,r)=>i.active!==r.active?!1:i.active&&r.active?i.asService===r.asService&&n(i.session,r.session):!0}),define(oe[245],ae([0,1,6,2,22,64,19,73,17]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$55b=void 0;class b extends L.$Ko{constructor(E,m,h,$){super(),this.X=E,this.Y=m,this.Z=h,this.$=$,this.p=this.Y.defaultProfile,this.s=this.ab(),this.P=this.Y.currentProfile,this.Q=this.B(new T.$kb),this.R=this.bb(this.P),this.S=this.X?.id,this.U=this.B(new T.$kb),this.W=this.cb(this.X)}ab(){const E=this.B(new R.$Vxb(this.Z.getChannel("storage"))),m=this.B(new j.$Eo(E));return this.B(m.onDidChangeStorage(h=>this.n(-1,h))),m}bb(E){this.Q.clear(),this.P=E;let m;if((0,L.$Lo)(E))m=this.s;else{const h=this.Q.add(new R.$Wxb(this.Z.getChannel("storage"),E));m=this.Q.add(new j.$Eo(h))}return this.Q.add(m.onDidChangeStorage(h=>this.n(0,h))),m}cb(E){this.U.clear(),this.S=E?.id;let m;if(E){const h=this.U.add(new R.$Xxb(this.Z.getChannel("storage"),E));m=this.U.add(new j.$Eo(h)),this.U.add(m.onDidChangeStorage($=>this.n(1,$)))}return m}async J(){await I.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(E){switch(E){case-1:return this.s;case 0:return this.R;default:return this.W}}M(E){switch(E){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,D.$8f)(this.$.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(L.WillSaveStateReason.SHUTDOWN),await I.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(E){if(!this.H(this.P,E))return;const m=this.R,h=m.items;m!==this.s&&await m.close(),this.R=this.bb(E),await this.R.init(),this.I(h,this.R,0)}async O(E,m){const h=this.W,$=h?.items??new Map;await h?.close(),this.W=this.cb(E),await this.W.init(),this.I($,this.W,1)}hasScope(E){return(0,S.$ok)(E)?this.P.id===E.id:this.S===E.id}}e.$55b=b}),define(oe[246],ae([0,1,3,2,17,91]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4M=e.$3M=void 0;class L{constructor(b,P){this.a=b,this.b=P}listen(b,P){const E=this.b(b);switch(P){case"onDidChangeProfiles":return I.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(h=>(0,j.$nm)({...h},E)),added:m.added.map(h=>(0,j.$nm)({...h},E)),removed:m.removed.map(h=>(0,j.$nm)({...h},E)),updated:m.updated.map(h=>(0,j.$nm)({...h},E))}))}throw new Error(`Invalid listen ${P}`)}async call(b,P,E){const m=this.b(b);switch(P){case"createProfile":{const h=await this.a.createProfile(E[0],E[1],E[2]);return(0,j.$nm)({...h},m)}case"updateProfile":{let h=(0,D.$qk)((0,j.$om)(E[0],m),this.a.profilesHome.scheme);return h=await this.a.updateProfile(h,E[1]),(0,j.$nm)({...h},m)}case"removeProfile":{const h=(0,D.$qk)((0,j.$om)(E[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(h)}}throw new Error(`Invalid call ${P}`)}}e.$3M=L;class R extends T.$lb{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,P,E){super(),this.profilesHome=P,this.f=E,this.a=[],this.b=this.B(new I.$7c),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(m=>(0,D.$qk)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const h=m.added.map(c=>(0,D.$qk)(c,this.profilesHome.scheme)),$=m.removed.map(c=>(0,D.$qk)(c,this.profilesHome.scheme)),v=m.updated.map(c=>(0,D.$qk)(c,this.profilesHome.scheme));this.a=m.all.map(c=>(0,D.$qk)(c,this.profilesHome.scheme)),this.b.fire({added:h,removed:$,updated:v,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,P,E){const m=await this.f.call("createNamedProfile",[b,P,E]);return(0,D.$qk)(m,this.profilesHome.scheme)}async createProfile(b,P,E,m){const h=await this.f.call("createProfile",[b,P,E,m]);return(0,D.$qk)(h,this.profilesHome.scheme)}async createTransientProfile(b){const P=await this.f.call("createTransientProfile",[b]);return(0,D.$qk)(P,this.profilesHome.scheme)}async setProfileForWorkspace(b,P){await this.f.call("setProfileForWorkspace",[b,P])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,P){const E=await this.f.call("updateProfile",[b,P]);return(0,D.$qk)(E,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$4M=R}),define(oe[58],ae([0,1,2,64,4,19,3,73,17]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2xb=e.$1xb=e.$Zxb=void 0,e.$Zxb=(0,D.$nh)("IUserDataProfileStorageService");let b=class extends I.$lb{constructor(h){super(),this.a=h}async readStorageData(h){return this.withProfileScopedStorageService(h,async $=>this.b($))}async updateStorageData(h,$,v){return this.withProfileScopedStorageService(h,async c=>this.c(c,$,v))}async withProfileScopedStorageService(h,$){if(this.a.hasScope(h))return $(this.a);const v=await this.g(h),c=new E(v);try{await c.initialize();const l=await $(c);return await c.flush(),l}finally{c.dispose(),await this.f(v)}}b(h){const $=new Map,v=c=>{for(const l of h.keys(0,c))$.set(l,{value:h.get(l,0),target:c})};return v(0),v(1),$}c(h,$,v){h.storeAll(Array.from($.entries()).map(([c,l])=>({key:c,value:l,scope:0,target:v})),!0)}async f(h){try{await h.close()}finally{(0,I.$fb)(h)&&h.dispose()}}};e.$1xb=b,e.$1xb=b=be([K(0,j.$Io)],b);class P extends b{constructor(h,$,v,c){super(v),this.i=h;const l=h.getChannel("profileStorageListener"),u=this.B(new I.$mb);this.h=this.B(new L.$7c({onWillAddFirstListener:()=>{u.value=l.listen("onDidChange")(y=>{c.trace("profile storage changes",y),this.h.fire({targetChanges:y.targetChanges.map(p=>(0,S.$qk)(p,$.profilesHome.scheme)),valueChanges:y.valueChanges.map(p=>({...p,profile:(0,S.$qk)(p.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(h){const $=this.i.getChannel("storage");return(0,j.$Lo)(h)?new R.$Vxb($):new R.$Wxb($,h)}}e.$2xb=P;class E extends j.$Ko{constructor(h){super({flushInterval:100}),this.p=this.B(new T.$Eo(h))}J(){return this.p.init()}L(h){return h===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[247],ae([0,1,19,8,17,69,58]),function(te,e,I,T,D,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J5b=void 0;let R=class extends L.$2xb{constructor(b,P,E,m){super(b,P,E,m)}};e.$J5b=R,e.$J5b=R=be([K(0,j.$84b),K(1,D.$pk),K(2,I.$Io),K(3,T.$Pi)],R)}),define(oe[39],ae([0,1,21,6,14,25,3,34,2,27,11,166,18,15,13,8,44,19,20,28,23,17]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oyb=e.$Nyb=e.$Myb=e.$Lyb=e.$Kyb=e.$Jyb=e.$Iyb=void 0;function t(w){return!!(w&&w.ref!==void 0&&typeof w.ref=="string"&&w.ref!==""&&w.syncData!==void 0&&(w.syncData===null||o(w.syncData)))}e.$Iyb=t;function o(w){return!!(w&&w.version!==void 0&&typeof w.version=="number"&&w.content!==void 0&&typeof w.content=="string"&&(Object.keys(w).length===2||Object.keys(w).length===3&&w.machineId!==void 0&&typeof w.machineId=="string"))}e.$Jyb=o;function n(w,g){return`${(0,b.$ae)(w)}${g.isDefault?"":` (${g.name})`}`}e.$Kyb=n;let s=class extends S.$lb{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(g,f,k,N,M,F,W,q,J,Q,Y,Z){super(),this.syncResource=g,this.collection=f,this.C=k,this.D=N,this.F=M,this.G=F,this.H=W,this.I=q,this.J=J,this.L=Q,this.M=Y,this.c=null,this.k="idle",this.l=this.B(new L.$7c),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new L.$7c),this.onDidChangeConflicts=this.n.event,this.s=new T.$rg(50),this.t=this.B(new L.$7c),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=n(g.syncResource,g.profile),this.h=Z.extUri,this.f=this.h.joinPath(N.userDataSyncHome,...(0,p.$Peb)(g.profile.isDefault?void 0:g.profile.id,g.syncResource)),this.g=this.h.joinPath(this.f,p.$$eb),this.u=(0,p.$Qeb)(g.profile.isDefault?void 0:g.profile.id,g.syncResource,N,this.h),this.j=(0,c.$Oo)(N,k,M)}N(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const g=await this.c;this.c=null;const f=await this.U(g.remoteUserData,g.lastSyncUserData,!0,this.lb());this.P(f)}else{this.L.trace(`${this.y}: Checking for local changes...`);const g=await this.getLastSyncUserData();(g?await this.rb(g):!0)&&this.t.fire()}}P(g){this.k!==g&&(this.k=g,this.l.fire(g))}async sync(g,f={}){await this.Q(g,!0,this.lb(),f)}async preview(g,f,k={}){return this.Q(g,!1,f,k)}async apply(g,f={}){try{this.z={...f};const k=await this.Y(g);return this.P(k),this.c}finally{this.z={}}}async Q(g,f,k,N){try{if(this.z={...N},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let M="idle";try{const F=await this.getLastSyncUserData(),W=await this.S(g,F);return M=await this.U(W,F,f,k),M==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(M)}}finally{this.z={}}}async replace(g){const f=this.hb(g);if(!f)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const k=await this.getLastSyncUserData(),N=await this.S(null,k),M=await this.R(N),F=await this.nb({ref:N.ref,syncData:f},k,M,this.lb(),j.CancellationToken.None),W=[];for(const q of F){const J=await this.pb(q,q.remoteResource,void 0,j.CancellationToken.None),{remoteChange:Q}=await this.pb(q,q.previewResource,q.remoteContent,j.CancellationToken.None);W.push([q,{...J,remoteChange:Q!==0?Q:2}])}await this.qb(N,k,W,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(g){const f=await this.j;return!!g.syncData?.machineId&&g.syncData.machineId===f}async S(g,f){if(f){const k=g?g[this.resource]:void 0;if(f.ref===k||k===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async U(g,f,k,N){if(g.syncData&&g.syncData.version>this.mb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new p.$Xeb((0,E.localize)(0,null,this.resource,this.mb,g.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(g,f,k,N)}catch(M){if(M instanceof p.$Xeb)switch(M.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(g,f,k,N);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),g=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.U(g,f,k,N)}throw M}}async W(g,f,k,N){try{const M=await this.R(g),F=!M&&f===null&&this.db()!==void 0,W=k&&!F;this.c||(this.c=(0,T.$hg)(J=>this.bb(g,f,M,W,N,J)));let q=await this.c;if(k&&F){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const J of q.resourcePreviews)q=await this.accept(J.remoteResource)||q}return this.$(q.resourcePreviews),q.resourcePreviews.some(({mergeState:J})=>J==="conflict")?"hasConflicts":k?await this.Y(!1):"syncing"}catch(M){throw this.c=null,M}}async merge(g){return await this.X(g,async f=>{const k=await this.ob(f,j.CancellationToken.None);await this.C.writeFile(f.previewResource,D.$Jb.fromString(k?.content||""));const N=k&&!k.hasConflicts?await this.pb(f,f.previewResource,void 0,j.CancellationToken.None):void 0;return f.acceptResult=N,f.mergeState=k.hasConflicts?"conflict":N?"accepted":"preview",f.localChange=N?N.localChange:k.localChange,f.remoteChange=N?N.remoteChange:k.remoteChange,f}),this.c}async accept(g,f){return await this.X(g,async k=>{const N=await this.pb(k,g,f,j.CancellationToken.None);return k.acceptResult=N,k.mergeState="accepted",k.localChange=N.localChange,k.remoteChange=N.remoteChange,k}),this.c}async discard(g){return await this.X(g,async f=>{const k=await this.ob(f,j.CancellationToken.None);return await this.C.writeFile(f.previewResource,D.$Jb.fromString(k.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=k.localChange,f.remoteChange=k.remoteChange,f}),this.c}async X(g,f){if(!this.c)return;let k=await this.c;const N=k.resourcePreviews.findIndex(({localResource:M,remoteResource:F,previewResource:W})=>this.h.isEqual(M,g)||this.h.isEqual(F,g)||this.h.isEqual(W,g));N!==-1&&(this.c=(0,T.$hg)(async M=>{const F=[...k.resourcePreviews];return F[N]=await f(F[N]),{...k,resourcePreviews:F}}),k=await this.c,this.$(k.resourcePreviews),k.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(g){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:k})=>k!=="accepted")?"syncing":(await this.qb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(k=>[k,k.acceptResult]),g),this.c=null,await this.Z(),"idle")}async Z(){try{await this.C.del(this.g,{recursive:!0})}catch{}}$(g){const f=g.filter(({mergeState:k})=>k==="conflict");(0,I.$af)(this.m,f,(k,N)=>this.h.isEqual(k.previewResource,N.previewResource))||(this.m=f,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const g=await this.getLastSyncUserData();return!!g&&g.syncData!==null}async ab(g){const f=this.c?await this.c:null;if(f)for(const k of f.resourcePreviews){if(this.h.isEqual(k.acceptedResource,g))return k.acceptResult?k.acceptResult.content:null;if(this.h.isEqual(k.remoteResource,g))return k.remoteContent;if(this.h.isEqual(k.localResource,g))return k.localContent;if(this.h.isEqual(k.baseResource,g))return k.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(g){(0,$.$7j)(g)!==1&&this.L.error(g)}}async bb(g,f,k,N,M,F){const W=await this.nb(g,f,k,M,F),q=[];for(const J of W){const Q=J.previewResource.with({scheme:p.$0eb,authority:"accepted"});if(J.localChange===0&&J.remoteChange===0)q.push({...J,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Y=N?await this.ob(J,F):void 0;if(F.isCancellationRequested)break;await this.C.writeFile(J.previewResource,D.$Jb.fromString(Y?.content||""));const Z=Y&&!Y.hasConflicts?await this.pb(J,J.previewResource,void 0,F):void 0;q.push({...J,acceptResult:Z,mergeState:Y?.hasConflicts?"conflict":Z?"accepted":"preview",localChange:Z?Z.localChange:Y?Y.localChange:J.localChange,remoteChange:Z?Z.remoteChange:Y?Y.remoteChange:J.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:g,lastSyncUserData:f,resourcePreviews:q,isLastSyncFromCurrentMachine:k}}async getLastSyncUserData(){let g=this.db();if(g||(g=await this.gb()),!g)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const f=JSON.parse(g),k=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!f.version&&!!k&&f.version!==k,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${k}.`),await this.resetLocal(),null;let N,M=1;for(;N===void 0&&M++<6;)try{const F=await this.eb();F&&(F.ref===f.ref?N=F.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(F){if(F instanceof $.$$j&&F.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(F instanceof p.$Xeb)throw F;this.L.error(F,M)}}if(N===void 0)try{const F=await this.G.resolveResourceContent(this.resource,f.ref,this.collection,this.z);N=F===null?null:this.hb(F),await this.fb({ref:f.ref,syncData:N})}catch(F){if(F instanceof p.$Xeb&&F.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw F}return N===void 0?null:{...f,syncData:N}}async cb(g,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const k=this.I.getResourceSyncStateVersion(this.resource),N={ref:g.ref,version:k,...f};this.F.store(this.v,JSON.stringify(N),-1,1),await this.fb(g)}db(){return this.F.get(this.v,-1)}async eb(){const g=(await this.C.readFile(this.u)).value.toString();try{const f=g?JSON.parse(g):void 0;if(t(f))return f}catch(f){this.L.error(f)}}async fb(g){await this.C.writeFile(this.u,D.$Jb.fromString(JSON.stringify(g)))}async gb(){try{const g=await this.C.readFile(this.u),f=JSON.parse(g.value.toString());await this.C.del(this.u),f.ref&&f.content!==void 0?(this.F.store(this.v,JSON.stringify({...f,content:void 0}),-1,1),await this.fb({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.L.info(`${this.y}: Migrating last sync user data. Invalid data.`,f)}catch(g){g instanceof $.$$j&&g.fileOperationResult===1?this.L.info(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(g)}return this.F.get(this.v,-1)}async getRemoteUserData(g){const{ref:f,content:k}=await this.ib(g);let N=null;return k!==null&&(N=this.hb(k)),{ref:f,syncData:N}}hb(g){try{const f=JSON.parse(g);if(o(f))return f}catch(f){this.L.error(f)}throw new p.$Xeb((0,E.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async ib(g){const f=g?{ref:g.ref,content:g.syncData?JSON.stringify(g.syncData):null}:null;return this.G.readResource(this.resource,f,this.collection,this.z)}async jb(g,f){const k=await this.j,N={version:this.mb,machineId:k,content:g};try{return f=await this.G.writeResource(this.resource,JSON.stringify(N),f,this.collection,this.z),{ref:f,syncData:N}}catch(M){throw M instanceof p.$Xeb&&M.code==="TooLarge"&&(M=new p.$Xeb(M.message,M.code,this.resource)),M}}async kb(g){const f={version:this.mb,content:g};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.$([]),await this.Z(),this.P("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}lb(){return this.M.getValue(p.$Keb)}};e.$Lyb=s,e.$Lyb=s=be([K(2,$.$Qj),K(3,h.$uh),K(4,l.$Io),K(5,p.$Seb),K(6,p.$Teb),K(7,p.$3eb),K(8,u.$Tk),K(9,p.$8eb),K(10,m.$Th),K(11,y.$nk)],s);let i=class extends s{constructor(g,f,k,N,M,F,W,q,J,Q,Y,Z,x){super(f,k,N,M,F,W,q,J,Q,Y,Z,x),this.i=g,this.B(this.C.watch(this.h.dirname(g))),this.B(this.C.onDidFilesChange(H=>this.tb(H)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(g,f,k){try{f?await this.C.writeFile(this.i,D.$Jb.fromString(g),k?void 0:f):await this.C.createFile(this.i,D.$Jb.fromString(g),{overwrite:k})}catch(N){throw N instanceof $.$$j&&N.fileOperationResult===1||N instanceof $.$$j&&N.fileOperationResult===3?new p.$Xeb(N.message,"LocalPreconditionFailed"):N}}async sb(){try{await this.C.del(this.i)}catch(g){if(!(g instanceof $.$$j&&g.fileOperationResult===1))throw g}}tb(g){g.contains(this.i)&&this.N()}};e.$Myb=i,e.$Myb=i=be([K(3,$.$Qj),K(4,h.$uh),K(5,l.$Io),K(6,p.$Seb),K(7,p.$Teb),K(8,p.$3eb),K(9,u.$Tk),K(10,p.$8eb),K(11,m.$Th),K(12,y.$nk)],i);let r=class extends i{constructor(g,f,k,N,M,F,W,q,J,Q,Y,Z,x,H){super(g,f,k,N,M,F,W,q,J,Q,Y,x,H),this.ub=Z,this.wb=void 0}vb(g,f){const k=[],N=(0,R.$vm)(g,k,{allowEmptyContent:!0,allowTrailingComma:!0});return k.length>0||!(0,P.$pe)(N)&&f!==Array.isArray(N)}xb(){return this.wb||(this.wb=this.ub.resolveFormattingOptions(this.i)),this.wb}};e.$Nyb=r,e.$Nyb=r=be([K(3,$.$Qj),K(4,h.$uh),K(5,l.$Io),K(6,p.$Seb),K(7,p.$Teb),K(8,p.$3eb),K(9,u.$Tk),K(10,p.$8eb),K(11,p.$7eb),K(12,m.$Th),K(13,y.$nk)],r);let a=class{constructor(g,f,k,N,M,F,W){this.resource=g,this.g=f,this.h=k,this.j=N,this.k=M,this.l=F,this.d=W.extUri,this.f=(0,p.$Qeb)(void 0,this.resource,k,this.d)}async initialize({ref:g,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const k=this.m(f);if(k)try{await this.o({ref:g,syncData:k})}catch(N){this.j.error(N)}}m(g){try{const f=JSON.parse(g);if(o(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(g,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const k={ref:g.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(k),-1,1),await this.k.writeFile(this.f,D.$Jb.fromString(JSON.stringify(g)))}};e.$Oyb=a,e.$Oyb=a=be([K(1,C.$pk),K(2,h.$uh),K(3,v.$Pi),K(4,$.$Qj),K(5,l.$Io),K(6,y.$nk)],a)}),define(oe[114],ae([0,1,6,25,7,3,41,2,27,18,15,113,29,33,78,45,13,4,68,8,19,20,28,17,39,228,111,23,58]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p,C,t,o,n,s,i,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DZb=e.$CZb=e.$BZb=e.$AZb=e.$zZb=void 0;async function w(F,W){const q=JSON.parse(F.content);if(F.version===1||F.version===2){const J=(await W.getInstalled(0)).filter(Q=>Q.isBuiltin);for(const Q of q)F.version===1&&(Q.enabled===!1&&(Q.disabled=!0),delete Q.enabled),F.version===2&&J.every(Y=>!(0,h.$do)(Y.identifier,Q.identifier))&&(Q.installed=!0)}return q}function g(F){return JSON.parse(F.content)}e.$zZb=g;function f(F,W){return F.sort((q,J)=>!q.identifier.uuid&&J.identifier.uuid?-1:q.identifier.uuid&&!J.identifier.uuid?1:(0,S.$Ed)(q.identifier.id,J.identifier.id)),W?(0,L.$2R)(F,{}):JSON.stringify(F)}e.$AZb=f;let k=class extends n.$Lyb{constructor(W,q,J,Q,Y,Z,x,H,B,V,ee,ne,ce,re,A,d,O){super({syncResource:"extensions",profile:W},q,Q,J,Y,Z,x,ne,ce,V,ee,A),this.yb=H,this.zb=B,this.Ab=O,this.mb=6,this.sb=this.h.joinPath(this.g,"extensions.json"),this.tb=this.sb.with({scheme:r.$0eb,authority:"base"}),this.ub=this.sb.with({scheme:r.$0eb,authority:"local"}),this.vb=this.sb.with({scheme:r.$0eb,authority:"remote"}),this.wb=this.sb.with({scheme:r.$0eb,authority:"accepted"}),this.xb=this.Ab.createInstance(N),this.B(j.Event.any(j.Event.filter(this.yb.onDidInstallExtensions,z=>z.some(({local:G})=>!!G)),j.Event.filter(this.yb.onDidUninstallExtension,z=>!z.error),j.Event.filter(d.onDidChange,z=>z.valueChanges.some(({profile:G,changes:U})=>this.syncResource.profile.id===G.id&&U.some(X=>X.key===m.$Qn))),re.onDidChangeExtensionStorageToSync)(()=>this.N()))}async nb(W,q){const J=W.syncData?await w(W.syncData,this.yb):null,Q=q?.skippedExtensions??[],Y=q?.builtinExtensions??null,Z=q?.syncData?await w(q.syncData,this.yb):null,{localExtensions:x,ignoredExtensions:H}=await this.xb.getLocalExtensions(this.syncResource.profile);J?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:B,remote:V}=(0,s.$yZb)(x,J,Z,Q,H,Y),ee={local:B,remote:V,content:this.Db(x,B.added,B.updated,B.removed),localChange:B.added.length>0||B.removed.length>0||B.updated.length>0?2:0,remoteChange:V!==null?2:0},ne=this.Kb(x,!1);return[{skippedExtensions:Q,builtinExtensions:Y,baseResource:this.tb,baseContent:Z?this.Kb(Z,!1):ne,localResource:this.ub,localContent:ne,localExtensions:x,remoteResource:this.vb,remoteExtensions:J,remoteContent:J?this.Kb(J,!1):null,previewResource:this.sb,previewResult:ee,localChange:ee.localChange,remoteChange:ee.remoteChange,acceptedResource:this.wb}]}async rb(W){const q=W.syncData?await w(W.syncData,this.yb):null,{localExtensions:J,ignoredExtensions:Q}=await this.xb.getLocalExtensions(this.syncResource.profile),{remote:Y}=(0,s.$yZb)(J,q,q,W.skippedExtensions||[],Q,W.builtinExtensions||[]);return Y!==null}Db(W,q,J,Q){const Y=[...q,...J],Z=new Set,x=H=>{Z.add(H.id.toLowerCase()),H.uuid&&Z.add(H.uuid)};Y.forEach(({identifier:H})=>x(H)),Q.forEach(x);for(const H of W)Z.has(H.identifier.id.toLowerCase())||H.identifier.uuid&&Z.has(H.identifier.uuid)||Y.push(H);return this.Kb(Y,!1)}async ob(W,q){return{...W.previewResult,hasConflicts:!1}}async pb(W,q,J,Q){if(this.h.isEqual(q,this.ub))return this.Gb(W);if(this.h.isEqual(q,this.vb))return this.Hb(W);if(this.h.isEqual(q,this.sb))return W.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Gb(W){const q=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),J=this.zb.getIgnoredExtensions(q),Q=(0,s.$yZb)(W.localExtensions,null,null,W.skippedExtensions,J,W.builtinExtensions),{local:Y,remote:Z}=Q;return{content:W.localContent,local:Y,remote:Z,localChange:Y.added.length>0||Y.removed.length>0||Y.updated.length>0?2:0,remoteChange:Z!==null?2:0}}async Hb(W){const q=await this.yb.getInstalled(void 0,this.syncResource.profile.extensionsResource),J=this.zb.getIgnoredExtensions(q),Q=W.remoteContent?JSON.parse(W.remoteContent):null;if(Q!==null){const Y=(0,s.$yZb)(W.localExtensions,Q,W.localExtensions,[],J,W.builtinExtensions),{local:Z,remote:x}=Y;return{content:W.remoteContent,local:Z,remote:x,localChange:Z.added.length>0||Z.removed.length>0||Z.updated.length>0?2:0,remoteChange:x!==null?2:0}}else return{content:W.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(W,q,J,Q){let{skippedExtensions:Y,builtinExtensions:Z,localExtensions:x}=J[0][0];const{local:H,remote:B,localChange:V,remoteChange:ee}=J[0][1];if(V===0&&ee===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),V!==0&&(await this.kb(JSON.stringify(x)),Y=await this.xb.updateLocalExtensions(H.added,H.removed,H.updated,Y,this.syncResource.profile)),B){this.L.trace(`${this.y}: Updating remote extensions...`);const ne=JSON.stringify(B.all);W=await this.jb(ne,Q?null:W.ref),this.L.info(`${this.y}: Updated remote extensions.${B.added.length?` Added: ${JSON.stringify(B.added.map(ce=>ce.identifier.id))}.`:""}${B.updated.length?` Updated: ${JSON.stringify(B.updated.map(ce=>ce.identifier.id))}.`:""}${B.removed.length?` Removed: ${JSON.stringify(B.removed.map(ce=>ce.identifier.id))}.`:""}`)}q?.ref!==W.ref&&(this.L.trace(`${this.y}: Updating last synchronized extensions...`),Z=this.Jb(x,Z),await this.cb(W,{skippedExtensions:Y,builtinExtensions:Z}),this.L.info(`${this.y}: Updated last synchronized extensions.${Y.length?` Skipped: ${JSON.stringify(Y.map(ne=>ne.identifier.id))}.`:""}`))}Jb(W,q){const J=new Set,Q=[];for(const Y of W)J.add(Y.identifier.id.toLowerCase()),Y.installed||Q.push(Y.identifier);if(q)for(const Y of q)J.has(Y.id.toLowerCase())||Q.push(Y);return Q}async resolveContent(W){if(this.h.isEqual(this.vb,W)||this.h.isEqual(this.tb,W)||this.h.isEqual(this.ub,W)||this.h.isEqual(this.wb,W)){const q=await this.ab(W);return q&&this.Kb(JSON.parse(q),!0)}return null}Kb(W,q){return f(W,q)}async hasLocalData(){try{const{localExtensions:W}=await this.xb.getLocalExtensions(this.syncResource.profile);if(W.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$BZb=k,e.$BZb=k=be([K(2,P.$uh),K(3,c.$Qj),K(4,p.$Io),K(5,r.$Seb),K(6,r.$Teb),K(7,m.$Pn),K(8,i.$tzb),K(9,r.$8eb),K(10,b.$Th),K(11,r.$3eb),K(12,C.$Tk),K(13,$.$Az),K(14,t.$nk),K(15,a.$Zxb),K(16,l.$mh)],k);let N=class{constructor(W,q,J,Q,Y,Z){this.a=W,this.b=q,this.c=J,this.d=Q,this.f=Y,this.g=Z}async getLocalExtensions(W){const q=await this.a.getInstalled(void 0,W.extensionsResource),J=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(W,async(Y,Z)=>{const x=Y.getDisabledExtensions();return q.map(H=>{const{identifier:B,isBuiltin:V,manifest:ee,preRelease:ne,pinned:ce,isApplicationScoped:re}=H,A={identifier:B,preRelease:ne,version:ee.version,pinned:!!ce};re&&!(0,v.$Il)(ee)&&(A.isApplicationScoped=re),x.some(d=>(0,h.$do)(d,B))&&(A.disabled=!0),V||(A.installed=!0);try{const d=Z.getKeysForSync({id:B.id,version:ee.version});if(d){const O=Z.getExtensionState(H,!0)||{};A.state=Object.keys(O).reduce((z,G)=>(d.includes(G)&&(z[G]=O[G]),z),{})}}catch(d){this.g.info(`${(0,n.$Kyb)("extensions",W)}: Error while parsing extension state`,(0,D.$9)(d))}return A})}),ignoredExtensions:J}}async updateLocalExtensions(W,q,J,Q,Y){const Z=(0,n.$Kyb)("extensions",Y),x=[],H=new Map,B=[],V=[],ee=await this.a.getInstalled(void 0,Y.extensionsResource);if((W.length||J.length)&&await this.j(Y,async(re,A)=>{await I.Promises.settled([...W,...J].map(async d=>{const O=ee.find(U=>(0,h.$do)(U.identifier,d.identifier));if(O&&O.isBuiltin){d.state&&O.manifest.version===d.version&&this.h(d.state,O,O.manifest.version,A),re.getDisabledExtensions().some(X=>(0,h.$do)(X,d.identifier))!==!!d.disabled&&(d.disabled?(this.g.trace(`${Z}: Disabling extension...`,d.identifier.id),await re.disableExtension(d.identifier),this.g.info(`${Z}: Disabled extension`,d.identifier.id)):(this.g.trace(`${Z}: Enabling extension...`,d.identifier.id),await re.enableExtension(d.identifier),this.g.info(`${Z}: Enabled extension`,d.identifier.id))),B.push(d.identifier);return}const z=d.pinned?d.version:void 0,G=(await this.c.getExtensions([{...d.identifier,version:z,preRelease:z?void 0:d.preRelease}],T.CancellationToken.None))[0];if(d.state&&(O?O.manifest.version===d.version:G)&&this.h(d.state,O||G,O?.manifest.version,A),G)try{re.getDisabledExtensions().some(X=>(0,h.$do)(X,d.identifier))!==!!d.disabled&&(d.disabled?(this.g.trace(`${Z}: Disabling extension...`,d.identifier.id,G.version),await re.disableExtension(G.identifier),this.g.info(`${Z}: Disabled extension`,d.identifier.id,G.version)):(this.g.trace(`${Z}: Enabling extension...`,d.identifier.id,G.version),await re.enableExtension(G.identifier),this.g.info(`${Z}: Enabled extension`,d.identifier.id,G.version))),(!O||O.preRelease!==d.preRelease||O.pinned!==d.pinned||z&&O.manifest.version!==z)&&(await this.a.canInstall(G)?(x.push({extension:G,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:d.pinned&&!!d.version,installPreReleaseVersion:d.preRelease,profileLocation:Y.extensionsResource,isApplicationScoped:d.isApplicationScoped,context:{[m.$En]:!0,[m.$Fn]:!0}}}),H.set(G.identifier.id.toLowerCase(),d)):(this.g.info(`${Z}: Skipped synchronizing extension because it cannot be installed.`,G.displayName||G.identifier.id),V.push(d)))}catch(U){V.push(d),this.g.error(U),this.g.info(`${Z}: Skipped synchronizing extension`,G.displayName||G.identifier.id)}else V.push(d),this.g.info(`${Z}: Skipped synchronizing extension because the extension is not found.`,d.identifier.id)}))}),q.length){const re=ee.filter(({identifier:A,isBuiltin:d})=>!d&&q.some(O=>(0,h.$do)(A,O)));await I.Promises.settled(re.map(async A=>{this.g.trace(`${Z}: Uninstalling local extension...`,A.identifier.id),await this.a.uninstall(A,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Y.extensionsResource}),this.g.info(`${Z}: Uninstalled local extension.`,A.identifier.id),B.push(A.identifier)}))}const ne=await this.a.installGalleryExtensions(x);for(const{identifier:re,local:A,error:d,source:O}of ne){const z=O;if(A)this.g.info(`${Z}: Installed extension.`,re.id,z.version),B.push(re);else{const G=H.get(re.id.toLowerCase());G&&(V.push(G),this.g.info(`${Z}: Skipped synchronizing extension`,z.displayName||z.identifier.id)),d instanceof m.$On&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(d.code)?this.g.info(`${Z}: Skipped synchronizing extension because the compatible extension is not found.`,z.displayName||z.identifier.id):d&&this.g.error(d)}}const ce=[];for(const re of Q)B.some(A=>(0,h.$do)(A,re.identifier))||ce.push(re);for(const re of V)ce.some(A=>(0,h.$do)(A.identifier,re.identifier))||ce.push(re);return ce}h(W,q,J,Q){const Y=Q.getExtensionState(q,!0)||{},Z=J?Q.getKeysForSync({id:q.identifier.id,version:J}):void 0;Z?Z.forEach(x=>{Y[x]=W[x]}):Object.keys(W).forEach(x=>Y[x]=W[x]),Q.setExtensionState(q,Y,!0)}async j(W,q){return this.b.withProfileScopedStorageService(W,async J=>{const Q=new R.$kb,Y=this.f.createChild(new u.$lh([p.$Io,J])),Z=Q.add(Y.createInstance(E.$lxb)),x=Q.add(Y.createInstance($.$Bz));try{return await q(Z,x)}finally{Q.dispose()}})}};e.$CZb=N,e.$CZb=N=be([K(0,m.$Pn),K(1,a.$Zxb),K(2,m.$Nn),K(3,i.$tzb),K(4,l.$mh),K(5,r.$8eb)],N);let M=class extends n.$Oyb{constructor(W,q,J,Q,Y,Z,x,H){super("extensions",Q,Y,Z,J,x,H),this.p=W,this.q=q}async t(W){return W.syncData?await w(W.syncData,this.p):null}u(W,q){const J=[],Q=[],Y=[];for(const Z of W){if(this.q.hasToNeverSyncExtension(Z.identifier.id))continue;const x=q.find(H=>(0,h.$do)(H.identifier,Z.identifier));x?(J.push(x),Z.disabled&&Y.push(Z.identifier)):Z.installed&&(Q.push({...Z.identifier,preRelease:!!Z.preRelease}),Z.disabled&&Y.push(Z.identifier))}return{installedExtensions:J,newExtensions:Q,disabledExtensions:Y,remoteExtensions:W}}};e.$DZb=M,e.$DZb=M=be([K(0,m.$Pn),K(1,i.$tzb),K(2,c.$Qj),K(3,o.$pk),K(4,P.$uh),K(5,y.$Pi),K(6,p.$Io),K(7,t.$nk)],M)}),define(oe[115],ae([0,1,14,7,3,34,41,5,32,18,15,13,8,44,19,20,28,39,75,232,23,17,58,4]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p,C,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uyb=e.$Tyb=e.$Syb=e.$Ryb=e.$Qyb=void 0;const n="globalState.argv.",s=["locale"];function i(k,N){const M=k.storage?Object.keys(k.storage).sort():[],F={};return M.forEach(W=>F[W]=k.storage[W]),k.storage=F,N?(0,L.$2R)(k,{}):JSON.stringify(k)}e.$Qyb=i;const r=1;let a=class extends l.$Lyb{constructor(N,M,F,W,q,J,Q,Y,Z,x,H,B,V,ee){super({syncResource:"globalState",profile:N},M,W,Y,B,q,J,Z,x,Q,H,V),this.wb=F,this.mb=r,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:p.$0eb,authority:"base"}),this.sb=this.p.with({scheme:p.$0eb,authority:"local"}),this.tb=this.p.with({scheme:p.$0eb,authority:"remote"}),this.ub=this.p.with({scheme:p.$0eb,authority:"accepted"}),this.vb=ee.createInstance(w),this.B(W.watch(this.h.dirname(this.D.argvResource))),this.B(D.Event.any(D.Event.filter(W.onDidFilesChange,ne=>ne.contains(this.D.argvResource)),D.Event.filter(F.onDidChange,ne=>!!(ne.targetChanges.some(ce=>this.syncResource.profile.id===ce.id)||ne.valueChanges.some(({profile:ce,changes:re})=>this.syncResource.profile.id===ce.id&&re.some(A=>A.target===0)))))(()=>this.N()))}async nb(N,M,F){const W=N.syncData?JSON.parse(N.syncData.content):null;M=M===null&&F?N:M;const q=M&&M.syncData?JSON.parse(M.syncData.content):null,J=await this.vb.getLocalGlobalState(this.syncResource.profile);W?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.Eb(q),{local:Y,remote:Z}=(0,y.$Pyb)(J.storage,W?W.storage:null,q?q.storage:null,Q,this.L),x={content:null,local:Y,remote:Z,localChange:Object.keys(Y.added).length>0||Object.keys(Y.updated).length>0||Y.removed.length>0?2:0,remoteChange:Z.all!==null?2:0},H=i(J,!1);return[{baseResource:this.r,baseContent:q?i(q,!1):H,localResource:this.sb,localContent:H,localUserData:J,remoteResource:this.tb,remoteContent:W?i(W,!1):null,previewResource:this.p,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.ub,storageKeys:Q}]}async rb(N){const M=N.syncData?JSON.parse(N.syncData.content):null;if(M===null)return!0;const F=await this.vb.getLocalGlobalState(this.syncResource.profile),W=await this.Eb(M),{remote:q}=(0,y.$Pyb)(F.storage,M.storage,M.storage,W,this.L);return q.all!==null}async ob(N,M){return{...N.previewResult,hasConflicts:!1}}async pb(N,M,F,W){if(this.h.isEqual(M,this.sb))return this.Bb(N);if(this.h.isEqual(M,this.tb))return this.Cb(N);if(this.h.isEqual(M,this.p))return N.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Bb(N){return{content:N.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(N.localUserData.storage),removed:[],updated:[],all:N.localUserData.storage},localChange:0,remoteChange:2}}async Cb(N){if(N.remoteContent!==null){const M=JSON.parse(N.remoteContent),{local:F,remote:W}=(0,y.$Pyb)(N.localUserData.storage,M.storage,null,N.storageKeys,this.L);return{content:N.remoteContent,local:F,remote:W,localChange:Object.keys(F.added).length>0||Object.keys(F.updated).length>0||F.removed.length>0?2:0,remoteChange:W!==null?2:0}}else return{content:N.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async qb(N,M,F,W){const{localUserData:q}=F[0][0],{local:J,remote:Q,localChange:Y,remoteChange:Z}=F[0][1];if(Y===0&&Z===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),Y!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.kb(JSON.stringify(q)),await this.vb.writeLocalGlobalState(J,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),Z!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const x=JSON.stringify({storage:Q.all});N=await this.jb(x,W?null:N.ref),this.L.info(`${this.y}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}M?.ref!==N.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.cb(N),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(N){if(this.h.isEqual(this.tb,N)||this.h.isEqual(this.r,N)||this.h.isEqual(this.sb,N)||this.h.isEqual(this.ub,N)){const M=await this.ab(N);return M&&i(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:N}=await this.vb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(N).length>1||N[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Eb(N){const M=await this.wb.readStorageData(this.syncResource.profile),F=[],W=[];for(const[Q,Y]of M)Y.target===0?F.push(Q):Y.target===1&&W.push(Q);const q=[...F,...W],J=N?.storage?Object.keys(N.storage).filter(Q=>!Q.startsWith(n)&&!q.includes(Q)&&M.get(Q)!==void 0):[];if(!R.$o){const Q=[...p.$Oeb.map(Y=>(0,p.$2eb)(Y)),p.$1eb];J.push(...Q),W.push(...Q)}return{user:F,machine:W,unregistered:J}}};e.$Ryb=a,e.$Ryb=a=be([K(2,t.$Zxb),K(3,E.$Qj),K(4,p.$Seb),K(5,p.$Teb),K(6,p.$8eb),K(7,P.$uh),K(8,p.$3eb),K(9,v.$Tk),K(10,b.$Th),K(11,$.$Io),K(12,c.$nk),K(13,o.$mh)],a);let w=class{constructor(N,M,F,W){this.a=N,this.b=M,this.c=F,this.d=W}async getLocalGlobalState(N){const M={};if(N.isDefault){const W=await this.f(),q=(0,j.$vm)(W);for(const J of s)q[J]!==void 0&&(M[`${n}${J}`]={version:1,value:q[J]})}const F=await this.c.readStorageData(N);for(const[W,q]of F)q.value&&q.target===0&&(M[W]={version:1,value:q.value});return{storage:M}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const N=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),N.value.toString()}catch(N){this.d.debug((0,T.$9)(N))}return"{}"}async writeLocalGlobalState({added:N,removed:M,updated:F},W){const q=(0,l.$Kyb)("globalState",W),J={},Q=new Map,Y=await this.c.readStorageData(W),Z=(x,H)=>{for(const B of x){if(B.startsWith(n)){J[B.substring(n.length)]=H?H[B].value:void 0;continue}if(H){const V=H[B];V.value!==Y.get(B)?.value&&Q.set(B,V.value)}else Y.get(B)!==void 0&&Q.set(B,void 0)}};if(Z(Object.keys(N),N),Z(Object.keys(F),F),Z(M),Object.keys(J).length){this.d.trace(`${q}: Updating locale...`);const x=await this.f();let H=x;for(const B of Object.keys(J))H=(0,u.edit)(H,[B],J[B],{});x!==H&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,I.$Jb.fromString(H)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}Q.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(W,Q,0),this.d.info(`${q}: Updated global state`,[...Q.keys()]))}};e.$Syb=w,e.$Syb=w=be([K(0,E.$Qj),K(1,P.$uh),K(2,t.$Zxb),K(3,p.$8eb)],w);let g=class extends l.$Oyb{constructor(N,M,F,W,q,J){super("globalState",F,W,q,M,N,J)}async o(N){const M=N.syncData?JSON.parse(N.syncData.content):null;if(!M){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const F={},W={};for(const q of Object.keys(M.storage))q.startsWith(n)?F[q.substring(n.length)]=M.storage[q].value:this.l.get(q,0)===void 0&&(W[q]=M.storage[q].value);if(Object.keys(F).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const J of Object.keys(F))q=(0,u.edit)(q,[J],F[J],{});await this.k.writeFile(this.h.argvResource,I.$Jb.fromString(q))}if(Object.keys(W).length){const q=[];for(const J of Object.keys(W))q.push({key:J,value:W[J],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$Tyb=g,e.$Tyb=g=be([K(0,$.$Io),K(1,E.$Qj),K(2,C.$pk),K(3,P.$uh),K(4,p.$8eb),K(5,c.$nk)],g);let f=class{constructor(N,M,F,W,q){this.a=N,this.b=M,this.c=F,this.d=W,this.f=q}getSyncStoreType(N){return this.h(N)?.storage[p.$1eb]?.value}async sync(N){const M=(0,p.$Web)((0,S.$5e)());try{return await this.g(N,M)}catch(F){if(F instanceof p.$Xeb)switch(F.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(N,M)}throw F}}async g(N,M){const F=await this.a.readResource("globalState",null,void 0,M),W=this.h(F)||{storage:{}};W.storage[p.$1eb]={value:N,version:r};const q=await(0,h.$Oo)(this.c,this.d,this.b),J={version:r,machineId:q,content:i(W,!1)};await this.a.writeResource("globalState",JSON.stringify(J),F.ref,void 0,M)}h({content:N}){if(!N)return null;const M=JSON.parse(N);if((0,l.$Jyb)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};e.$Uyb=f,e.$Uyb=f=be([K(1,$.$Io),K(2,P.$uh),K(3,E.$Qj),K(4,m.$Pi)],f)}),define(oe[116],ae([0,1,21,14,3,34,5,11,167,18,15,13,19,20,28,17,39,229,23]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HZb=e.$GZb=e.$FZb=void 0;function y(t,o,n){try{const s=JSON.parse(t);if(!o)return(0,R.$pe)(s.all)?null:s.all;switch(L.OS){case 2:return(0,R.$pe)(s.mac)?null:s.mac;case 3:return(0,R.$pe)(s.linux)?null:s.linux;case 1:return(0,R.$pe)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.$FZb=y;let p=class extends c.$Nyb{constructor(o,n,s,i,r,a,w,g,f,k,N,M,F){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,g,f,k,s,i,w,M,r,N,a,F),this.mb=2,this.zb=this.h.joinPath(this.g,"keybindings.json"),this.Ab=this.zb.with({scheme:u.$0eb,authority:"base"}),this.Bb=this.zb.with({scheme:u.$0eb,authority:"local"}),this.Cb=this.zb.with({scheme:u.$0eb,authority:"remote"}),this.Db=this.zb.with({scheme:u.$0eb,authority:"accepted"}),this.B(D.Event.filter(a.onDidChangeConfiguration,W=>W.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async nb(o,n,s,i){const r=o.syncData?y(o.syncData.content,i.keybindingsPerPlatform??this.Lb(),this.L):null;n=n===null&&s?o:n;const a=n?this.Jb(n):null,w=await this.p(),g=await this.xb();let f=null,k=!1,N=!1,M=!1;if(r){let q=w?w.value.toString():"[]";if(q=q||"[]",this.vb(q,!0))throw new u.$Xeb((0,S.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==r){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const J=await(0,l.$EZb)(q,r,a,g,this.ub);J.hasChanges&&(f=J.mergeContent,M=J.hasConflicts,k=M||J.mergeContent!==q,N=M||J.mergeContent!==r)}}else w&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=w.value.toString(),N=!0);const F={content:M?a:f,localChange:k?w?2:1:0,remoteChange:N?2:0,hasConflicts:M},W=w?w.value.toString():null;return[{fileContent:w,baseResource:this.Ab,baseContent:a,localResource:this.Bb,localContent:W,localChange:F.localChange,remoteResource:this.Cb,remoteContent:r,remoteChange:F.remoteChange,previewResource:this.zb,previewResult:F,acceptedResource:this.Db}]}async rb(o){const n=this.Jb(o);if(n===null)return!0;const s=await this.p(),i=s?s.value.toString():"",r=await this.xb(),a=await(0,l.$EZb)(i||"[]",n,n,r,this.ub);return a.hasConflicts||a.mergeContent!==n}async ob(o,n){return o.previewResult}async pb(o,n,s,i){if(this.h.isEqual(n,this.Bb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Cb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.zb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async qb(o,n,s,i){const{fileContent:r}=s[0][0];let{content:a,localChange:w,remoteChange:g}=s[0][1];if(w===0&&g===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.vb(a,!0)))throw new u.$Xeb((0,S.localize)(1,null),"LocalInvalidContent",this.resource);if(w!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),r&&await this.kb(this.Kb(r.value.toString())),await this.r(a||"[]",r,i),this.L.info(`${this.y}: Updated local keybindings`)),g!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const f=this.Kb(a||"[]",o.syncData?.content);o=await this.jb(f,i?null:o.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.zb)}catch{}n?.ref!==o.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.cb(o,{platformSpecific:this.Lb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.p();if(o){const n=(0,j.$vm)(o.value.toString());if((0,I.$pf)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Cb,o)||this.h.isEqual(this.Ab,o)||this.h.isEqual(this.Bb,o)||this.h.isEqual(this.Db,o)?this.ab(o):null}Jb(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Lb()?null:y(o.syncData.content,this.Lb(),this.L)}Kb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.L.error(i)}switch(this.Lb()?delete s.all:s.all=o,L.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Lb(){return!!this.M.getValue(u.$Leb)}};e.$GZb=p,e.$GZb=p=be([K(2,u.$Seb),K(3,u.$Teb),K(4,u.$8eb),K(5,b.$Th),K(6,u.$3eb),K(7,E.$Qj),K(8,P.$uh),K(9,m.$Io),K(10,u.$7eb),K(11,h.$Tk),K(12,$.$nk)],p);let C=class extends c.$Oyb{constructor(o,n,s,i,r,a){super("keybindings",n,s,i,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,T.$Jb.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,j.$vm)(o.value.toString());return!(0,I.$pf)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return y(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$HZb=C,e.$HZb=C=be([K(0,E.$Qj),K(1,v.$pk),K(2,P.$uh),K(3,u.$8eb),K(4,m.$Io),K(5,$.$nk)],C)}),define(oe[117],ae([0,1,14,3,168,18,71,15,29,13,19,20,28,17,39,233,23]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KZb=e.$JZb=e.$IZb=void 0;function l(C){return C&&C.settings&&typeof C.settings=="string"&&Object.keys(C).length===1}function u(C){const t=JSON.parse(C);return l(t)?t:{settings:C}}e.$IZb=u;let y=class extends $.$Nyb{constructor(t,o,n,s,i,r,a,w,g,f,k,N,M,F){super(t.settingsResource,{syncResource:"settings",profile:t},o,n,s,i,r,a,k,N,w,g,f,F),this.zb=M,this.mb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:c.$0eb,authority:"base"}),this.localResource=this.previewResource.with({scheme:c.$0eb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:c.$0eb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:c.$0eb,authority:"accepted"}),this.Jb=void 0}async getRemoteUserDataSyncConfiguration(t){const o=await this.getLastSyncUserData(),n=await this.S(t,o),s=this.Gb(n),i=new L.$bn(c.$Keb);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(c.$Keb)||{}}async nb(t,o,n){const s=await this.p(),i=await this.xb(),r=this.Gb(t);o=o===null&&n?t:o;const a=o?this.Gb(o):null,w=await this.Kb();let g=null,f=!1,k=!1,N=!1;if(r){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.Lb(q),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const J=(0,v.$Gxb)(q,r.settings,a?a.settings:null,w,[],i);g=J.localContent||J.remoteContent,f=J.localContent!==null,k=J.remoteContent!==null,N=J.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),g=s.value.toString().trim()||"{}",this.Lb(g),k=!0);const M=s?s.value.toString():null,F=a?.settings??null,W={content:N?F:g,localChange:f?2:0,remoteChange:k?2:0,hasConflicts:N};return[{fileContent:s,baseResource:this.baseResource,baseContent:F,localResource:this.localResource,localContent:M,localChange:W.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:W.remoteChange,previewResource:this.previewResource,previewResult:W,acceptedResource:this.acceptedResource}]}async rb(t){const o=this.Gb(t);if(o===null)return!0;const n=await this.p(),s=n?n.value.toString().trim():"",i=await this.Kb(),r=await this.xb();return(0,v.$Gxb)(s||"{}",o.settings,o.settings,i,[],r).remoteContent!==null}async ob(t,o){const n=await this.xb(),s=await this.Kb();return{...t.previewResult,content:t.previewResult.content?(0,v.$Fxb)(t.previewResult.content,"{}",s,n):null}}async pb(t,o,n,s){const i=await this.xb(),r=await this.Kb();if(this.h.isEqual(o,this.localResource))return{content:t.fileContent?(0,v.$Fxb)(t.fileContent.value.toString(),"{}",r,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:t.remoteContent!==null?(0,v.$Fxb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,v.$Fxb)(n,t.fileContent?t.fileContent.value.toString():"{}",r,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async qb(t,o,n,s){const{fileContent:i}=n[0][0];let{content:r,localChange:a,remoteChange:w}=n[0][1];if(a===0&&w===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Lb(r),a!==0&&(this.L.trace(`${this.y}: Updating local settings...`),i&&await this.kb(JSON.stringify(this.Ib(i.value.toString()))),await this.r(r,i,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),w!==0){const g=await this.xb(),f=this.Gb(t),k=await this.Kb(r);r=(0,v.$Fxb)(r,f?f.settings:"{}",k,g),this.L.trace(`${this.y}: Updating remote settings...`),t=await this.jb(JSON.stringify(this.Ib(r)),s?null:t.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}o?.ref!==t.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.cb(t),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.p();if(t)return!(0,v.$Hxb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.ab(t):null}async ab(t){let o=await super.ab(t);if(o){const n=await this.xb(),s=await this.Kb();o=(0,v.$Fxb)(o,"{}",s,n)}return o}Gb(t){return t.syncData?this.Hb(t.syncData.content):null}Hb(t){try{return u(t)}catch(o){this.L.error(o)}return null}Ib(t){return{settings:t}}async Kb(t){if(!this.Jb){this.Jb=this.ub.resolveDefaultIgnoredSettings();const n=T.Event.any(T.Event.filter(this.zb.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),T.Event.filter(this.zb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Jb=void 0})}const o=await this.Jb;return(0,v.$Dxb)(o,this.M,t)}Lb(t){if(this.vb(t,!1))throw new c.$Xeb((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$JZb=y,e.$JZb=y=be([K(2,b.$Qj),K(3,R.$uh),K(4,P.$Io),K(5,c.$Seb),K(6,c.$Teb),K(7,c.$8eb),K(8,c.$7eb),K(9,j.$Th),K(10,c.$3eb),K(11,E.$Tk),K(12,S.$Pn),K(13,m.$nk)],y);let p=class extends $.$Oyb{constructor(t,o,n,s,i,r){super("settings",o,n,s,t,i,r)}async o(t){const o=t.syncData?this.p(t.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,I.$Jb.fromString(o.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,v.$Hxb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return u(t)}catch(o){this.j.error(o)}return null}};e.$KZb=p,e.$KZb=p=be([K(0,b.$Qj),K(1,h.$pk),K(2,R.$uh),K(3,c.$8eb),K(4,P.$Io),K(5,m.$nk)],p)}),define(oe[118],ae([0,1,14,3,30,18,15,13,19,20,28,17,39,230,23]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PZb=e.$OZb=e.$NZb=void 0;function v(u){return JSON.parse(u.content)}e.$NZb=v;let c=class extends m.$Lyb{constructor(y,p,C,t,o,n,s,i,r,a,w,g){super({syncResource:"snippets",profile:y},p,t,C,o,n,s,a,w,i,r,g),this.mb=1,this.p=y.snippetsHome,this.B(this.C.watch(C.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(T.Event.filter(this.C.onDidFilesChange,f=>f.affects(this.p))(()=>this.N()))}async nb(y,p,C){const t=await this.Cb(),o=this.Bb(t),n=y.syncData?this.Ab(y.syncData):null;p=p===null&&C?y:p;const s=p&&p.syncData?this.Ab(p.syncData):null;n?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,h.$LZb)(o,n,s);return this.wb(i,t,n||{},s||{})}async rb(y){const p=y.syncData?this.Ab(y.syncData):null;if(p===null)return!0;const C=await this.Cb(),t=this.Bb(C),o=(0,h.$LZb)(t,p,p);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async ob(y,p){return y.previewResult}async pb(y,p,C,t){if(this.h.isEqualOrParent(p,this.g.with({scheme:$.$0eb,authority:"local"})))return{content:y.fileContent?y.fileContent.value.toString():null,localChange:0,remoteChange:y.fileContent?y.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(p,this.g.with({scheme:$.$0eb,authority:"remote"})))return{content:y.remoteContent,localChange:y.remoteContent!==null?y.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(p,this.g))return C===void 0?{content:y.previewResult.content,localChange:y.previewResult.localChange,remoteChange:y.previewResult.remoteChange}:{content:C,localChange:C===null?y.fileContent!==null?3:0:2,remoteChange:C===null?y.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${p.toString()}`)}async qb(y,p,C,t){const o=C.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.xb(o),await this.yb(o,t)),o.some(({remoteChange:n})=>n!==0)&&(y=await this.zb(o,y,t)),p?.ref!==y.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.cb(y),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.C.del(n)}catch{}}wb(y,p,C,t){const o=new Map;for(const n of Object.keys(y.local.added)){const s={content:y.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"accepted"})})}for(const n of Object.keys(y.local.updated)){const s={content:y.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"accepted"})})}for(const n of y.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"accepted"})})}for(const n of Object.keys(y.remote.added)){const s={content:y.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"accepted"})})}for(const n of Object.keys(y.remote.updated)){const s={content:y.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"local"}),fileContent:p[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"accepted"})})}for(const n of y.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"remote"}),remoteContent:C[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"accepted"})})}for(const n of y.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:p[n]?2:1,remoteChange:C[n]?2:1},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"local"}),fileContent:p[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"remote"}),remoteContent:C[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"accepted"})})}for(const n of Object.keys(p))if(!o.has(n)){const s={content:p[n]?p[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=p[n]?p[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"local"}),fileContent:p[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"remote"}),remoteContent:C[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$0eb,authority:"accepted"})})}return[...o.values()]}async resolveContent(y){return this.h.isEqualOrParent(y,this.g.with({scheme:$.$0eb,authority:"remote"}))||this.h.isEqualOrParent(y,this.g.with({scheme:$.$0eb,authority:"local"}))||this.h.isEqualOrParent(y,this.g.with({scheme:$.$0eb,authority:"base"}))||this.h.isEqualOrParent(y,this.g.with({scheme:$.$0eb,authority:"accepted"}))?this.ab(y):null}async hasLocalData(){try{const y=await this.Cb();if(Object.keys(y).length)return!0}catch{}return!1}async xb(y){const p={};for(const C of y)C.fileContent&&(p[this.h.basename(C.localResource)]=C.fileContent);await this.kb(JSON.stringify(this.Bb(p)))}async yb(y,p){for(const{fileContent:C,acceptResult:t,localResource:o,remoteResource:n,localChange:s}of y)if(s!==0){const i=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.p,i);s===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(r)),await this.C.del(r),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(r))):s===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(r)),await this.C.createFile(r,I.$Jb.fromString(t.content),{overwrite:p}),this.L.info(`${this.y}: Created snippet`,this.h.basename(r))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(r)),await this.C.writeFile(r,I.$Jb.fromString(t.content),p?void 0:C),this.L.info(`${this.y}: Updated snippet`,this.h.basename(r)))}}async zb(y,p,C){const t=p.syncData?this.Ab(p.syncData):{},o=(0,D.$Fm)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:r}of y)if(r!==0){const a=s?this.h.basename(s):this.h.basename(i);r===3?delete o[a]:o[a]=n.content}return(0,h.$MZb)(t,o)||(this.L.trace(`${this.y}: Updating remote snippets...`),p=await this.jb(JSON.stringify(o),C?null:p.ref),this.L.info(`${this.y}: Updated remote snippets`)),p}Ab(y){return v(y)}Bb(y){const p={};for(const C of Object.keys(y))p[C]=y[C].value.toString();return p}async Cb(){const y={};let p;try{p=await this.C.resolve(this.p)}catch(C){if(C instanceof R.$$j&&C.fileOperationResult===1)return y;throw C}for(const C of p.children||[]){const t=C.resource,o=this.h.extname(t);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.p,t),s=await this.C.readFile(t);y[n]=s}}return y}};e.$OZb=c,e.$OZb=c=be([K(2,L.$uh),K(3,R.$Qj),K(4,S.$Io),K(5,$.$Seb),K(6,$.$Teb),K(7,$.$8eb),K(8,j.$Th),K(9,$.$3eb),K(10,b.$Tk),K(11,P.$nk)],c);let l=class extends m.$Oyb{constructor(y,p,C,t,o,n){super("snippets",p,C,t,y,o,n)}async o(y){const p=y.syncData?JSON.parse(y.syncData.content):null;if(!p){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(p)){const o=p[t];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(n,I.$Jb.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(y)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(y){return y.fileOperationResult===1}}};e.$PZb=l,e.$PZb=l=be([K(0,R.$Qj),K(1,E.$pk),K(2,L.$uh),K(3,$.$8eb),K(4,S.$Io),K(5,P.$nk)],l)}),define(oe[119],ae([0,1,14,18,15,13,19,20,28,17,39,23]),function(te,e,I,T,D,j,L,R,S,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SZb=e.$RZb=e.$QZb=void 0;function m(c,l){try{return JSON.parse(c).tasks??null}catch(u){return l.error(u),null}}e.$QZb=m;let h=class extends P.$Myb{constructor(l,u,y,p,C,t,o,n,s,i,r,a){super(l.tasksResource,{syncResource:"tasks",profile:l},u,n,s,i,y,p,o,r,C,t,a),this.mb=1,this.vb=this.h.joinPath(this.g,"tasks.json"),this.wb=this.vb.with({scheme:E.$0eb,authority:"base"}),this.xb=this.vb.with({scheme:E.$0eb,authority:"local"}),this.yb=this.vb.with({scheme:E.$0eb,authority:"remote"}),this.zb=this.vb.with({scheme:E.$0eb,authority:"accepted"})}async nb(l,u,y,p){const C=l.syncData?m(l.syncData.content,this.L):null;u=u===null&&y?l:u;const t=u?.syncData?m(u.syncData.content,this.L):null,o=await this.p();let n=null,s=!1,i=!1,r=!1;if(l.syncData){const g=o?o.value.toString():null;if(!t||t!==g||t!==C){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const f=v(g,C,t);n=f.content,r=f.hasConflicts,s=f.hasLocalChanged,i=f.hasRemoteChanged}}else o&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),i=!0);const a={content:r?t:n,localChange:s?o?2:1:0,remoteChange:i?2:0,hasConflicts:r},w=o?o.value.toString():null;return[{fileContent:o,baseResource:this.wb,baseContent:t,localResource:this.xb,localContent:w,localChange:a.localChange,remoteResource:this.yb,remoteContent:C,remoteChange:a.remoteChange,previewResource:this.vb,previewResult:a,acceptedResource:this.zb}]}async rb(l){const u=l?.syncData?m(l.syncData.content,this.L):null;if(u===null)return!0;const y=await this.p(),p=y?y.value.toString():null,C=v(p,u,u);return C.hasLocalChanged||C.hasRemoteChanged}async ob(l,u){return l.previewResult}async pb(l,u,y,p){if(this.h.isEqual(u,this.xb))return{content:l.fileContent?l.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.yb))return{content:l.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.vb))return y===void 0?{content:l.previewResult.content,localChange:l.previewResult.localChange,remoteChange:l.previewResult.remoteChange}:{content:y,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async qb(l,u,y,p){const{fileContent:C}=y[0][0],{content:t,localChange:o,remoteChange:n}=y[0][1];if(o===0&&n===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),o!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),C&&await this.kb(JSON.stringify(this.Fb(C.value.toString()))),t?await this.r(t,C,p):await this.sb(),this.L.info(`${this.y}: Updated local tasks`)),n!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const s=JSON.stringify(this.Fb(t));l=await this.jb(s,p?null:l.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.vb)}catch{}u?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(l){return this.h.isEqual(this.yb,l)||this.h.isEqual(this.wb,l)||this.h.isEqual(this.xb,l)||this.h.isEqual(this.zb,l)?this.ab(l):null}Fb(l){return l?{tasks:l}:{}}};e.$RZb=h,e.$RZb=h=be([K(2,E.$Seb),K(3,E.$Teb),K(4,E.$8eb),K(5,T.$Th),K(6,E.$3eb),K(7,j.$Qj),K(8,D.$uh),K(9,L.$Io),K(10,R.$Tk),K(11,S.$nk)],h);let $=class extends P.$Oyb{constructor(l,u,y,p,C,t){super("tasks",u,y,p,l,C,t),this.c=this.g.defaultProfile.tasksResource}async o(l){const u=l.syncData?m(l.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,I.$Jb.fromString(u)),await this.n(l)}async p(){return this.k.exists(this.c)}};e.$SZb=$,e.$SZb=$=be([K(0,j.$Qj),K(1,b.$pk),K(2,D.$uh),K(3,E.$8eb),K(4,L.$Io),K(5,S.$nk)],$);function v(c,l,u){if(c===null&&l===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(c===l)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const y=u!==c,p=u!==l;return!y&&!p?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:y&&!p?{content:c,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:p&&!y?{content:l,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:c,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[120],ae([0,1,41,18,15,13,19,20,28,17,39,231,23]),function(te,e,I,T,D,j,L,R,S,b,P,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v2b=e.$u2b=e.$t2b=void 0;let h=class extends P.$Lyb{constructor(l,u,y,p,C,t,o,n,s,i,r,a,w){super({syncResource:"profiles",profile:l},u,p,C,t,o,n,r,a,s,i,w),this.r=y,this.mb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$0eb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$0eb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$0eb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$0eb,authority:"accepted"}),this.B(y.onDidChangeProfiles(()=>this.N()))}async getLastSyncedProfiles(){const l=await this.getLastSyncUserData();return l?.syncData?v(l.syncData):null}async getRemoteSyncedProfiles(l){const u=await this.getLastSyncUserData(),y=await this.S(l,u);return y?.syncData?v(y.syncData):null}async nb(l,u,y){if(!this.r.isEnabled())throw new m.$Xeb("Cannot sync profiles because they are disabled","LocalError");const p=l.syncData?v(l.syncData):null,C=u?.syncData?v(u.syncData):null,t=this.zb(),{local:o,remote:n}=(0,E.$s2b)(t,p,C,[]),s={local:o,remote:n,content:C?this.Ab(C):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},i=$(t,!1);return[{baseResource:this.baseResource,baseContent:C?this.Ab(C):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:p?this.Ab(p):null,remoteProfiles:p,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async rb(l){const u=l?.syncData?v(l.syncData):null,y=this.zb(),{remote:p}=(0,E.$s2b)(y,u,u,[]);return!!p?.added.length||!!p?.removed.length||!!p?.updated.length}async ob(l,u){return{...l.previewResult,hasConflicts:!1}}async pb(l,u,y,p){if(this.h.isEqual(u,this.localResource))return this.wb(l);if(this.h.isEqual(u,this.remoteResource))return this.xb(l);if(this.h.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async wb(l){const u=this.zb(),y=(0,E.$s2b)(u,null,null,[]),{local:p,remote:C}=y;return{content:l.localContent,local:p,remote:C,localChange:p.added.length>0||p.removed.length>0||p.updated.length>0?2:0,remoteChange:C!==null?2:0}}async xb(l){const u=l.remoteContent?JSON.parse(l.remoteContent):null,y=[],p=[];for(const C of this.zb()){const t=u?.find(o=>o.id===C.id);t&&(y.push({id:C.id,name:C.name,collection:t.collection}),p.push(C))}if(u!==null){const C=(0,E.$s2b)(p,u,y,[]),{local:t,remote:o}=C;return{content:l.remoteContent,local:t,remote:o,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:l.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async qb(l,u,y,p){const{local:C,remote:t,localChange:o,remoteChange:n}=y[0][1];o===0&&n===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const s=y[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new m.$Xeb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.kb($(this.zb(),!1));const i=[];for(const r of C.added)i.push((async()=>{this.L.trace(`${this.y}: Creating '${r.name}' profile...`),await this.r.createProfile(r.id,r.name,{shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.L.info(`${this.y}: Created profile '${r.name}'.`)})());for(const r of C.removed)i.push((async()=>{this.L.trace(`${this.y}: Removing '${r.name}' profile...`),await this.r.removeProfile(r),this.L.info(`${this.y}: Removed profile '${r.name}'.`)})());for(const r of C.updated){const a=this.r.profiles.find(w=>w.id===r.id);a?i.push((async()=>{this.L.trace(`${this.y}: Updating '${r.name}' profile...`),await this.r.updateProfile(a,{name:r.name,shortName:r.shortName,useDefaultFlags:r.useDefaultFlags}),this.L.info(`${this.y}: Updated profile '${r.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(i)}if(n!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const i=[],r=s.length+(t?.added.length??0)<=20;if(r)for(const a of t?.added||[]){const w=await this.G.createCollection(this.z);i.push(w),s.push({id:a.id,name:a.name,collection:w,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])s.splice(s.findIndex(({id:w})=>a.id===w),1);for(const a of t?.updated||[]){const w=s.find(({id:g})=>a.id===g);w&&s.splice(s.indexOf(w),1,{...w,id:a.id,name:a.name,shortName:a.shortName,useDefaultFlags:a.useDefaultFlags})}try{l=await this.updateRemoteProfiles(s,p?null:l.ref),this.L.info(`${this.y}: Updated remote profiles.${r&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const w of i)await this.G.deleteCollection(w,this.z)}throw a}for(const a of t?.removed||[])await this.G.deleteCollection(a.collection,this.z)}u?.ref!==l.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.cb(l),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(l,u){return this.jb(this.Ab(l),u)}async hasLocalData(){return this.zb().length>0}async resolveContent(l){if(this.h.isEqual(this.remoteResource,l)||this.h.isEqual(this.baseResource,l)||this.h.isEqual(this.localResource,l)||this.h.isEqual(this.acceptedResource,l)){const u=await this.ab(l);return u&&(0,I.$2R)(JSON.parse(u),{})}return null}zb(){return this.r.profiles.filter(l=>!l.isDefault&&!l.isTransient)}Ab(l){return JSON.stringify([...l].sort((u,y)=>u.name.localeCompare(y.name)))}};e.$t2b=h,e.$t2b=h=be([K(2,b.$pk),K(3,j.$Qj),K(4,D.$uh),K(5,L.$Io),K(6,m.$Seb),K(7,m.$Teb),K(8,m.$8eb),K(9,T.$Th),K(10,m.$3eb),K(11,R.$Tk),K(12,S.$nk)],h);function $(c,l){const u=[...c].sort((y,p)=>y.name.localeCompare(p.name)).map(y=>({id:y.id,name:y.name}));return l?(0,I.$2R)(u,{}):JSON.stringify(u)}e.$u2b=$;function v(c){return JSON.parse(c.content)}e.$v2b=v}),define(oe[248],ae([0,1,6,14,61,2,22,18,15,13,17,23]),function(te,e,I,T,D,j,L,R,S,b,P,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r2b=void 0;let m=class extends j.$lb{constructor($,v,c,l,u){super(),this.a=$,this.b=v,this.c=c,this.f=l,this.g=u,this.h()}async h(){for(const v of this.g.profiles)for(const c of E.$Oeb)try{await this.j(this.i(v,c))}catch(l){this.f.error(l)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(v){(0,b.$7j)(v)!==1&&this.f.error(v);return}if($.children){for(const v of $.children)if(v.isDirectory&&!this.g.profiles.some(c=>c.id===v.name))try{this.f.info("Deleting non existing profile from backup",v.resource.path),await this.b.del(v.resource,{recursive:!0})}catch(c){this.f.error(c)}}}async getAllRefs($,v){const c=this.i($,v);try{const l=await this.b.resolve(c);if(l.children)return l.children.filter(y=>y.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(y.name)).sort().reverse().map(y=>({ref:y.name,created:this.k(y)}))}catch(l){if((0,b.$7j)(l)!==1)throw l}return[]}async resolveContent($,v,c){const l=this.i($,v),u=(0,L.$8f)(l,c);try{return(await this.b.readFile(u)).value.toString()}catch(y){return this.f.error(y),null}}async backup($,v,c){const l=this.i($,v),u=(0,L.$8f)(l,`${(0,D.$Ql)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(u,T.$Jb.fromString(c))}catch(y){this.f.error(y)}try{this.j(l)}catch{}}i($,v){return(0,L.$8f)(this.a.userDataSyncHome,...$.isDefault?[v]:[$.id,v])}async j($){try{try{if(!await this.b.exists($))return}catch{return}const v=await this.b.resolve($);if(v.children){const c=v.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort(),l=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=c.filter(p=>Date.now()-this.k(p)>l);const y=c.length-u.length;y<10&&(u=u.slice(10-y)),await I.Promises.settled(u.map(async p=>{this.f.info("Deleting from backup",p.resource.path),await this.b.del(p.resource)}))}}catch(v){this.f.error(v)}}k($){return $.ctime||new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$r2b=m,e.$r2b=m=be([K(0,S.$uh),K(1,b.$Qj),K(2,R.$Th),K(3,E.$8eb),K(4,P.$pk)],m)}),define(oe[249],ae([0,1,3,2,5,15,19,20,23]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g2b=void 0;const b="sync.enable";let P=class extends T.$lb{constructor(m,h,$,v){super(),this.c=m,this.f=h,this.g=$,this.h=v,this.a=new I.$7c,this.onDidChangeEnablement=this.a.event,this.b=new I.$7c,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(c=>this.j(c)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(b,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(b,{enabled:m}),this.c.store(b,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,S.$2eb)(m),-1,!0)}setResourceEnablement(m,h){if(this.isResourceEnabled(m)!==h){const $=(0,S.$2eb)(m);this.i($,h)}}getResourceSyncStateVersion(m){}i(m,h){this.c.store(m,h,-1,D.$o?0:1)}j(m){if(m.scope!==-1)return;if(b===m.key){this.a.fire(this.isEnabled());return}const h=S.$Oeb.filter($=>(0,S.$2eb)($)===m.key)[0];if(h){this.b.fire([h,this.isResourceEnabled(h)]);return}}};e.$g2b=P,e.$g2b=P=be([K(0,L.$Io),K(1,R.$Tk),K(2,j.$uh),K(3,S.$Reb)],P)}),define(oe[79],ae([0,1,3,2,5,27,172,15,13,4,24,44,19,23]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uXb=e.$tXb=e.$sXb=void 0,e.$sXb=(0,b.$nh)("IUserDataSyncMachinesService");const $="sync.currentMachineName",v="Safari",c="Chrome",l="Edge",u="Firefox",y="Android";function p(o){switch(o){case v:case c:case l:case u:case y:case(0,D.$h)(0):return!0}return!1}e.$tXb=p;function C(){return D.$F?v:D.$D?c:D.$G?l:D.$E?u:D.$H?y:(0,D.$h)(D.$o?0:D.$t)}let t=class it extends T.$lb{static{this.a=1}static{this.b="machines"}constructor(n,s,i,r,a,w){super(),this.h=i,this.i=r,this.j=a,this.k=w,this.c=this.B(new I.$7c),this.onDidChange=this.c.event,this.g=null,this.f=(0,E.$Oo)(n,s,i)}async getMachines(n){const s=await this.f;return(await this.m(n)).machines.map(r=>({...r,isCurrent:r.id===s}))}async addCurrentMachine(n){const s=await this.f,i=await this.m(n);i.machines.some(({id:r})=>r===s)||(i.machines.push({id:s,name:this.l(i.machines),platform:C()}),await this.n(i))}async removeCurrentMachine(n){const s=await this.f,i=await this.m(n),r=i.machines.filter(({id:a})=>a!==s);r.length!==i.machines.length&&(i.machines=r,await this.n(i))}async renameMachine(n,s,i){const r=await this.m(i),a=r.machines.find(({id:w})=>w===n);if(a){a.name=s,await this.n(r);const w=await this.f;n===w&&this.h.store($,s,-1,1)}}async setEnablements(n){const s=await this.m();for(const[i,r]of n){const a=s.machines.find(w=>w.id===i);a&&(a.disabled=r?void 0:!0)}await this.n(s)}l(n){const s=this.h.get($,-1);if(s)return s;const i=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${C()} (${this.k.nameShort})`,r=new RegExp(`${(0,j.$nd)(i)}\\s#(\\d+)`);let a=0;for(const w of n){const g=r.exec(w.name),f=g?parseInt(g[1]):0;a=f>a?f:a}return`${i} #${a+1}`}async m(n){this.g=await this.p(n);const s=this.r(this.g);if(s.version!==it.a)throw new Error((0,L.localize)(0,null,this.k.nameLong));return s}async n(n){const s=JSON.stringify(n),i=await this.i.writeResource(it.b,s,this.g?.ref||null);this.g={ref:i,content:s},this.c.fire()}async p(n){if(this.g){const s=n&&n.latest?n.latest[it.b]:void 0;if(this.g.ref===s)return this.g;if(s===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}r(n){if(n.content!==null)try{return JSON.parse(n.content)}catch(s){this.j.error(s)}return{version:it.a,machines:[]}}};e.$uXb=t,e.$uXb=t=be([K(0,R.$uh),K(1,S.$Qj),K(2,m.$Io),K(3,h.$Seb),K(4,h.$8eb),K(5,P.$8i)],t)}),define(oe[250],ae([0,1,6,61,38,7,3,2,5,22,10,169,24,19,20,23,76,79]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x2b=void 0;const u="sync.disableMachineEventually",y="sync.sessionId",p="sync.storeUrl",C="sync.productQuality";let t=class extends R.$lb{get j(){const s=this.z.get(p,-1);return s?P.URI.parse(s):void 0}set j(s){s?this.z.store(p,s.toString(),-1,1):this.z.remove(p,-1)}get l(){return this.z.get(C,-1)}set l(s){s?this.z.store(C,s,-1,1):this.z.remove(C,-1)}constructor(s,i,r,a,w,g,f,k,N,M){super(),this.n=i,this.p=r,this.r=a,this.s=w,this.u=g,this.v=f,this.w=k,this.y=N,this.z=M,this.a=this.B(new R.$mb),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new L.$7c),this.onError=this.h.event,this.N=[],this.f=this.B(new I.$rg(this.O())),this.i=this.j,this.j=i.userDataSyncStore?.url,this.k=this.l,this.l=s.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,b.$1f)(this.j,i.userDataSyncStore?.url)||(this.i=this.j,this.j=i.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(f.onDidChangeAccount(()=>this.C())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(w.onDidChangeLocal(F=>this.triggerSync([F],!1,!1))),this.B(L.Event.filter(this.r.onDidChangeResourceEnablement,([,F])=>F)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:s,message:i}=this.F();s?this.a.value===void 0&&(this.a.value=new o(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.w,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.I(r))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.u.info(i),this.a.clear()):i&&this.r.isEnabled()&&this.u.info(i))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,T.$Ql)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(s,i,r){try{this.v.account&&!r&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(y,-1),s?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(a){if(this.u.error(a),i)this.G(!1);else throw a}}G(s){this.r.isEnabled()!==s&&(this.r.setEnablement(s),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(s){if(!s){this.b=0;return}const i=v.$Xeb.toUserDataSyncError(s);i instanceof v.$Zeb&&this.w.publicLog2("autosync/error",{code:i.code,service:this.n.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?S.$o&&i.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(i),this.b++),this.h.fire(i)}async J(){this.z.store(u,!0,-1,1),await(0,I.$ug)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(u,-1,!1)}M(){this.z.remove(u,-1)}async triggerSync(s,i,r){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...s),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const a=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:a}),this.N=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};e.$x2b=t,e.$x2b=t=be([K(0,m.$8i),K(1,v.$Reb),K(2,v.$Seb),K(3,v.$3eb),K(4,v.$4eb),K(5,v.$8eb),K(6,c.$nxb),K(7,$.$Tk),K(8,l.$sXb),K(9,h.$Io)],t);class o extends R.$lb{static{this.a="Interval"}constructor(s,i,r,a,w,g,f,k,N){super(),this.j=s,this.k=i,this.l=r,this.m=a,this.n=w,this.p=g,this.r=f,this.s=k,this.u=N,this.b=this.B(new R.$mb),this.c=this.B(new L.$7c),this.onDidStartSync=this.c.event,this.f=this.B(new L.$7c),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.v())),this.B((0,R.$jb)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}v(){this.b.value=(0,I.$vg)(()=>this.sync(o.a,!1),this.k)}sync(s,i){const r=(0,I.$hg)(async a=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(w){if((0,j.$2)(w))return}return this.z(s,i,a)});return this.i=r,this.i.finally(()=>this.i=void 0),this.i}w(){return this.j!==void 0&&!(0,b.$1f)(this.j,this.l.userDataSyncStore?.url)}async y(){const s=await this.l.getPreviousUserDataSyncStore(),i=this.l.userDataSyncStore;return!!i&&!!s&&(!(0,b.$1f)(i.defaultUrl,s.defaultUrl)||!(0,b.$1f)(i.insidersUrl,s.insidersUrl)||!(0,b.$1f)(i.stableUrl,s.stableUrl))}async z(s,i,r){this.r.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.C(i,r)}catch(w){if(this.r.error(w),a=w,v.$Xeb.toUserDataSyncError(w).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.C(i,r),a=void 0}catch(g){this.r.error(g),a=g}}this.f.fire(a)}async C(s,i){if(this.h=await this.n.createSyncTask(this.g,s),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.w()?await this.y()?new v.$Zeb((0,E.localize)(0,null),"DefaultServiceChanged"):new v.$Zeb((0,E.localize)(1,null),"ServiceChanged"):new v.$Zeb((0,E.localize)(2,null),"TurnedOff");const r=this.u.get(y,-1);if(r&&this.g&&r!==this.g.session)throw this.w()?await this.y()?new v.$Zeb((0,E.localize)(3,null),"DefaultServiceChanged"):new v.$Zeb((0,E.localize)(4,null),"ServiceChanged"):new v.$Zeb((0,E.localize)(5,null),"SessionExpired");const a=await this.p.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const w=a.find(f=>f.isCurrent);if(w?.disabled)throw new v.$Zeb((0,E.localize)(6,null),"TurnedOff");const g=new Date().getTime();if(await this.h.run(),this.s.publicLog2("settingsSync:sync",{duration:new Date().getTime()-g}),this.g===null)try{this.g=await this.m.manifest(null)}catch(f){throw new v.$Zeb((0,D.$$h)(f),f instanceof v.$Xeb?f.code:"Unknown")}this.g&&this.g.session!==r&&this.u.store(y,this.g.session,-1,1),!i.isCancellationRequested&&(w||await this.p.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(oe[251],ae([0,1,10,173,15,13,44,19,28,23,17,39,118,117,116,18,119,114,115,4,120,41]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$92b=void 0;let t=class Ve{static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(n,s,i,r,a,w,g,f,k,N){this.e=n,this.f=s,this.g=i,this.h=a,this.i=w,this.j=g,this.k=f,this.l=k,this.m=N,this.d=r.extUri}async getRemoteSyncedProfiles(){const n=await this.e.readResource("profiles",null,void 0);if(n.content){const s=this.K(n.content,"profiles");return(0,p.$v2b)(s)}return[]}async getRemoteSyncResourceHandles(n,s){return(await this.e.getAllResourceRefs(n,s?.collection)).map(({created:r,ref:a})=>({created:r,uri:this.I({remote:!0,syncResource:n,profile:s?.id??this.k.defaultProfile.id,collection:s?.collection,ref:a,node:void 0})}))}async getLocalSyncResourceHandles(n,s){return(await this.f.getAllRefs(s,n)).map(({created:r,ref:a})=>({created:r,uri:this.I({remote:!1,syncResource:n,profile:s.id,collection:void 0,ref:a,node:void 0})}))}resolveUserDataSyncResource({uri:n}){const s=this.J(n),i=s?this.k.profiles.find(r=>r.id===s.profile):void 0;return s&&i?{profile:i,syncResource:s?.syncResource}:void 0}async getAssociatedResources({uri:n}){const s=this.J(n);if(!s)return[];const i=this.k.profiles.find(r=>r.id===s.profile);switch(s.syncResource){case"settings":return this.r(n,i);case"keybindings":return this.t(n,i);case"tasks":return this.v(n,i);case"snippets":return this.x(n,i);case"globalState":return this.C(n,i);case"extensions":return this.z(n,i);case"profiles":return this.F(n,i);case"workspaceState":return[]}}async getMachineId({uri:n}){const s=this.J(n);if(s){if(s.remote){if(s.ref){const{content:i}=await this.L(s.syncResource,s.ref,s.collection);if(i)return this.K(i,s.syncResource)?.machineId}return}return(0,L.$Oo)(this.h,this.j,this.i)}}async resolveContent(n){const s=this.J(n);if(!s||s.node===Ve.a)return null;if(s.ref){const i=await this.n(s.remote,s.syncResource,s.profile,s.collection,s.ref);return s.node&&i?this.o(s.syncResource,i,s.node):i}return!s.remote&&!s.node?this.q(s.syncResource,s.profile):null}async n(n,s,i,r,a){if(n){const{content:g}=await this.L(s,a,r);return g}const w=this.k.profiles.find(g=>g.id===i);return w?this.f.resolveContent(w,s,a):null}o(n,s,i){const r=this.K(s,n);switch(n){case"settings":return this.s(r,i);case"keybindings":return this.u(r,i);case"tasks":return this.w(r,i);case"snippets":return this.y(r,i);case"globalState":return this.D(r,i);case"extensions":return this.A(r,i);case"profiles":return this.G(r,i);case"workspaceState":return null}}async q(n,s){const i=this.k.profiles.find(r=>r.id===s);if(!i)return null;switch(n){case"globalState":return this.E(i);case"extensions":return this.B(i);case"profiles":return this.H(i);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}r(n,s){const i=this.d.joinPath(n,"settings.json"),r=s?s.settingsResource:this.d.joinPath(n,Ve.a);return[{resource:i,comparableResource:r}]}s(n,s){switch(s){case"settings.json":return(0,h.$IZb)(n.content).settings}return null}t(n,s){const i=this.d.joinPath(n,"keybindings.json"),r=s?s.keybindingsResource:this.d.joinPath(n,Ve.a);return[{resource:i,comparableResource:r}]}u(n,s){switch(s){case"keybindings.json":return(0,$.$FZb)(n.content,!!this.l.getValue(b.$Leb),this.g)}return null}v(n,s){const i=this.d.joinPath(n,"tasks.json"),r=s?s.tasksResource:this.d.joinPath(n,Ve.a);return[{resource:i,comparableResource:r}]}w(n,s){switch(s){case"tasks.json":return(0,c.$QZb)(n.content,this.g)}return null}async x(n,s){const i=await this.resolveContent(n);if(i){const r=this.K(i,"snippets");if(r){const a=(0,m.$NZb)(r),w=[];for(const g of Object.keys(a)){const f=this.d.joinPath(n,g),k=s?this.d.joinPath(s.snippetsHome,g):this.d.joinPath(n,Ve.a);w.push({resource:f,comparableResource:k})}return w}}return[]}y(n,s){return(0,m.$NZb)(n)[s]||null}z(n,s){const i=this.d.joinPath(n,"extensions.json"),r=s?this.I({remote:!1,syncResource:"extensions",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,Ve.a);return[{resource:i,comparableResource:r}]}A(n,s){switch(s){case"extensions.json":return(0,l.$AZb)((0,l.$zZb)(n),!0)}return null}async B(n){const{localExtensions:s}=await this.m.createInstance(l.$CZb).getLocalExtensions(n);return(0,l.$AZb)(s,!0)}C(n,s){const i=this.d.joinPath(n,"globalState.json"),r=s?this.I({remote:!1,syncResource:"globalState",profile:s.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(n,Ve.a);return[{resource:i,comparableResource:r}]}D(n,s){switch(s){case"globalState.json":return(0,u.$Qyb)(JSON.parse(n.content),!0)}return null}async E(n){const s=await this.m.createInstance(u.$Syb).getLocalGlobalState(n);return(0,u.$Qyb)(s,!0)}F(n,s){const i=this.d.joinPath(n,"profiles.json"),r=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:i,comparableResource:r}]}G(n,s){switch(s){case"profiles.json":return(0,C.$2R)(JSON.parse(n.content),{})}return null}async H(n){return(0,p.$u2b)(this.k.profiles.filter(s=>!s.isDefault&&!s.isTransient),!0)}I(n){const s=n.remote?Ve.b:Ve.c,i=[n.syncResource,n.profile];return n.collection&&i.push(`collection:${n.collection}`),n.ref&&i.push(`ref:${n.ref}`),n.node&&i.push(n.node),this.d.joinPath(I.URI.from({scheme:b.$0eb,authority:s,path:"/"}),...i)}J(n){if(n.scheme!==b.$0eb||n.authority!==Ve.c&&n.authority!==Ve.b)return;const s=[];for(;n.path!=="/";)s.unshift(this.d.basename(n)),n=this.d.dirname(n);if(s.length<2)return;const i=n.authority===Ve.b,r=s.shift(),a=s.shift();let w,g,f;for(;s.length;){const k=s.shift();k.startsWith("collection:")?w=k.substring(11):k.startsWith("ref:")?g=k.substring(4):f=k}return{remote:i,syncResource:r,profile:a,collection:w,ref:g,node:f}}K(n,s){try{const i=JSON.parse(n);if((0,E.$Jyb)(i))return i}catch(i){this.g.error(i)}throw new b.$Xeb((0,T.localize)(0,null),"IncompatibleRemoteContent",s)}async L(n,s,i){const r=await this.e.resolveResourceContent(n,s,i);return{ref:s,content:r}}};e.$92b=t,e.$92b=t=be([K(0,b.$Seb),K(1,b.$Teb),K(2,b.$8eb),K(3,S.$nk),K(4,D.$uh),K(5,R.$Io),K(6,j.$Qj),K(7,P.$pk),K(8,v.$Th),K(9,y.$mh)],t)}),define(oe[252],ae([0,1,21,6,25,38,3,2,22,11,32,18,29,4,19,20,17,114,115,116,117,118,119,120,23]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p,C,t,o,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w2b=void 0;const s="sync.lastSyncTime";let i=class extends R.$lb{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(f,k,N,M,F,W,q,J,Q){super(),this.v=f,this.w=k,this.y=N,this.z=M,this.C=F,this.D=W,this.F=q,this.G=J,this.H=Q,this.f="uninitialized",this.g=this.B(new L.$7c),this.onDidChangeStatus=this.g.event,this.h=this.B(new L.$7c),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new L.$7c),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new L.$7c),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new L.$7c),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new L.$7c),this.onDidResetLocal=this.r.event,this.t=this.B(new L.$7c),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=k.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(s,-1,void 0),this.B((0,R.$jb)(()=>this.W()))}async createSyncTask(f,k){this.X(),this.z.info("Sync started.");const N=new Date().getTime(),M=(0,P.$5e)();try{const J=(0,n.$Web)(M);k&&(J["Cache-Control"]="no-cache"),f=await this.v.manifest(f,J)}catch(J){const Q=n.$Xeb.toUserDataSyncError(J);throw w(Q,M,this.w,this.C),Q}const F=!1,W=this;let q;return{manifest:f,async run(){if(F)throw new Error("Can run a task only once");q=(0,T.$hg)(J=>W.I(f,!1,M,J)),await q.finally(()=>q=void 0),W.z.info(`Sync done. Took ${new Date().getTime()-N}ms`),W.S()},stop(){return q?.cancel(),W.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new n.$Xeb("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const f=new Date().getTime(),k=(0,P.$5e)(),N=(0,n.$Web)(k);let M;try{M=await this.v.manifest(null,N)}catch(q){const J=n.$Xeb.toUserDataSyncError(q);throw w(J,k,this.w,this.C),J}await this.resetLocal();const F=this,W=new D.$dd;return{id:k,async merge(){return F.I(M,!0,k,W.token)},async apply(){try{try{await F.L(M,k,W.token)}catch(q){if(n.$Xeb.toUserDataSyncError(q).code==="MethodNotFound")F.z.info("Client is making invalid requests. Cleaning up data..."),await F.cleanUpRemoteData(),F.z.info("Applying manual sync again..."),await F.L(M,k,W.token);else throw q}}catch(q){throw F.z.error(q),q}F.z.info(`Sync done. Took ${new Date().getTime()-f}ms`),F.S()},async stop(){W.cancel(),await F.N(),await F.resetLocal()}}}async I(f,k,N,M){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const F=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(F,f,k,N,M));const W=F.enabled.find(q=>q.resource==="profiles");if(W){const q=await W.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.J(q,f,k,N,M)}}finally{this.l.fire(this.k)}}async J(f,k,N,M,F){for(const W of f){if(F.isCancellationRequested)return;const q=this.G.profiles.find(Q=>Q.id===W.id);if(!q){this.z.error(`Profile with id:${W.id} and name: ${W.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",W.name);const J=this.getOrCreateActiveProfileSynchronizer(q,W);this.k.push(...await this.M(J,k,N,M,F))}for(const[W,q]of this.u.entries())this.G.profiles.some(J=>J.id===q[0].profile.id)||(q[1].dispose(),this.u.delete(W))}async L(f,k,N){const M=this.U();for(const Q of M){if(N.isCancellationRequested)return;await Q.apply(k,N)}const F=M.find(Q=>Q.profile.isDefault);if(!F)return;const W=F.enabled.find(Q=>Q.resource==="profiles");if(!W)return;const J=(await W.getRemoteSyncedProfiles(f?.latest??null)||[]).filter(Q=>M.every(Y=>Y.profile.id!==Q.id));J.length&&await this.J(J,f,!1,k,N)}async M(f,k,N,M,F){return(await f.sync(k,N,M,F)).map(([q,J])=>({profile:f.profile,syncResource:q,error:J}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(f=>f.stop()))}async resolveContent(f){const k=await this.H.resolveContent(f);if(k)return k;for(const N of this.U())for(const M of N.enabled){const F=await M.resolveContent(f);if(F)return F}return null}async replace(f){this.X();const k=this.H.resolveUserDataSyncResource(f);if(!k)return;const N=await this.resolveContent(f.uri);N&&await this.O(k.profile,async M=>{if(k.syncResource===M.resource)return await M.replace(N),!0})}async accept(f,k,N,M){this.X(),await this.O(f.profile,async F=>{if(f.syncResource===F.resource)return await F.accept(k,N),M&&await F.apply((0,b.$oe)(M)?!1:M.force,(0,n.$Web)((0,P.$5e)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(f,k){return this.H.getRemoteSyncResourceHandles(f,k)}async getLocalSyncResourceHandles(f,k){return this.H.getLocalSyncResourceHandles(f,k??this.G.defaultProfile)}async getAssociatedResources(f){return this.H.getAssociatedResources(f)}async getMachineId(f){return this.H.getMachineId(f)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async k=>{if(k.resource!=="globalState"&&await k.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async k=>{if(await k.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(f){this.z.error(f)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(s,-1);for(const[f]of this.u.values())try{await f.resetLocal()}catch(k){this.z.error(k)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const f=await this.H.getRemoteSyncedProfiles(),k=f.map(W=>W.collection),N=await this.v.getAllCollections(),M=N.filter(W=>!k.includes(W));M.length&&(this.z.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(W=>this.v.deleteCollection(W))),this.z.info("Deleted redundant collections on server"));const F=f.filter(W=>N.includes(W.collection));if(F.length!==f.length){const W=this.y.createInstance(o.$t2b,this.G.defaultProfile,void 0);try{this.z.info("Resetting the last synced state of profiles"),await W.resetLocal(),this.z.info("Did reset the last synced state of profiles"),this.z.info("Updating remote profiles with invalid collections on server"),await W.updateRemoteProfiles(F,null),this.z.info("Updated remote profiles on server")}finally{W.dispose()}}}async O(f,k){const N=new R.$kb;try{const M=this.u.get(f.id);if(M){const Q=await this.P(M[0],k,N);return(0,b.$pe)(Q)?null:Q}if(f.isDefault){const Q=N.add(this.y.createInstance(r,f,void 0)),Y=await this.P(Q,k,N);return(0,b.$pe)(Y)?null:Y}if(this.G.isEnabled())return null;const F=N.add(this.y.createInstance(o.$t2b,f,void 0)),W=await this.v.manifest(null),J=(await F.getRemoteSyncedProfiles(W?.latest??null)||[]).find(Q=>Q.id===f.id);if(J){const Q=N.add(this.y.createInstance(r,f,J.collection)),Y=await this.P(Q,k,N);return(0,b.$pe)(Y)?null:Y}return null}finally{N.dispose()}}async P(f,k,N){const M=[...f.enabled,...f.disabled.reduce((F,W)=>(W!=="workspaceState"&&F.push(N.add(f.createSynchronizer(W))),F),[])];for(const F of M){const W=await k(F);if(!(0,b.$pe)(W))return W}}Q(f){const k=this.f;this.f!==f&&(this.f=f,this.g.fire(f),k==="hasConflicts"&&this.S())}R(){const f=this.U().map(k=>k.conflicts).flat();(0,I.$af)(this.i,f,(k,N)=>k.profile.id===N.profile.id&&k.syncResource===N.syncResource&&(0,I.$af)(k.conflicts,N.conflicts,(M,F)=>(0,S.$1f)(M.previewResource,F.previewResource)))||(this.i=f,this.j.fire(f))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(s,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(f,k){let N=this.u.get(f.id);if(N&&N[0].collection!==k?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.u.delete(f.id)),!N){const M=new R.$kb,F=M.add(this.y.createInstance(r,f,k?.collection));M.add(F.onDidChangeStatus(W=>this.Q(W))),M.add(F.onDidChangeConflicts(W=>this.R())),M.add(F.onDidChangeLocal(W=>this.h.fire(W))),this.u.set(f.id,N=[F,M])}return N[0]}U(){const f=[];for(const[k]of this.u.values())f.push(k);return f}W(){this.u.forEach(([,f])=>f.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};e.$w2b=i,e.$w2b=i=be([K(0,n.$Seb),K(1,n.$Reb),K(2,h.$mh),K(3,n.$8eb),K(4,v.$Tk),K(5,$.$Io),K(6,n.$3eb),K(7,c.$pk),K(8,n.$5eb)],i);let r=class extends R.$lb{get enabled(){return this.f.sort((f,k)=>f[1]-k[1]).map(([f])=>f)}get disabled(){return n.$Oeb.filter(f=>!this.l.isResourceEnabled(f))}get status(){return this.g}get conflicts(){return this.j}constructor(f,k,N,M,F,W,q,J,Q,Y){super(),this.profile=f,this.collection=k,this.l=N,this.m=M,this.n=F,this.r=W,this.t=q,this.u=J,this.v=Q,this.w=Y,this.f=[],this.g="idle",this.h=this.B(new L.$7c),this.onDidChangeStatus=this.h.event,this.i=this.B(new L.$7c),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new L.$7c),this.onDidChangeConflicts=this.k.event,this.B(N.onDidChangeResourceEnablement(([Z,x])=>this.y(Z,x))),this.B((0,R.$jb)(()=>this.f.splice(0,this.f.length).forEach(([,,Z])=>Z.dispose())));for(const Z of n.$Oeb)N.isResourceEnabled(Z)&&this.z(Z)}y(f,k){k?this.z(f):this.C(f)}z(f){if(this.f.some(([F])=>F.resource===f))return;if(f==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(f==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled())||f==="workspaceState")return;if(f!=="profiles"&&this.profile.useDefaultFlags?.[f]){this.u.debug(`Skipping syncing ${f} in ${this.profile.name} because it is already synced by default profile`);return}const k=new R.$kb,N=k.add(this.createSynchronizer(f));k.add(N.onDidChangeStatus(()=>this.G())),k.add(N.onDidChangeConflicts(()=>this.H())),k.add(N.onDidChangeLocal(()=>this.i.fire(f)));const M=this.I(f);this.f.push([N,M,k])}C(f){const k=this.f.findIndex(([N])=>N.resource===f);if(k!==-1){const[[N,,M]]=this.f.splice(k,1);M.dispose(),this.G(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,F=>this.u.error(F))}}createSynchronizer(f){switch(f){case"settings":return this.m.createInstance(p.$JZb,this.profile,this.collection);case"keybindings":return this.m.createInstance(y.$GZb,this.profile,this.collection);case"snippets":return this.m.createInstance(C.$OZb,this.profile,this.collection);case"tasks":return this.m.createInstance(t.$RZb,this.profile,this.collection);case"globalState":return this.m.createInstance(u.$Ryb,this.profile,this.collection);case"extensions":return this.m.createInstance(l.$BZb,this.profile,this.collection);case"profiles":return this.m.createInstance(o.$t2b,this.profile,this.collection)}}async sync(f,k,N,M){if(M.isCancellationRequested)return[];const F=this.enabled;if(!F.length)return[];try{const W=[],q=(0,n.$Web)(N),J=(this.collection?f?.collections?.[this.collection]?.latest:f?.latest)??null,Q=k?await this.D(J):{};for(const Y of F){if(M.isCancellationRequested)return[];if(!this.l.isResourceEnabled(Y.resource))return[];try{if(k){const Z=await Y.preview(J,Q,q);if(Z)for(const x of Z.resourcePreviews)(x.localChange!==0||x.remoteChange!==0)&&x.mergeState==="preview"&&await Y.merge(x.previewResource)}else await Y.sync(J,q)}catch(Z){const x=n.$Xeb.toUserDataSyncError(Z);if(w(x,N,this.r,this.t),a(Z))throw x;this.u.error(Z),this.u.error(`${Y.resource}: ${(0,j.$$h)(Z)}`),W.push([Y.resource,x])}}return W}finally{this.G()}}async apply(f,k){const N=(0,n.$Web)(f);for(const M of this.enabled){if(k.isCancellationRequested)return;try{await M.apply(!1,N)}catch(F){const W=n.$Xeb.toUserDataSyncError(F);if(w(W,f,this.r,this.t),a(F))throw W;this.u.error(F),this.u.error(`${M.resource}: ${(0,j.$$h)(F)}`)}}}async stop(){for(const f of this.enabled)try{f.status!=="idle"&&await f.stop()}catch(k){this.u.error(k)}}async resetLocal(){for(const f of this.enabled)try{await f.resetLocal()}catch(k){this.u.error(`${f.resource}: ${(0,j.$$h)(k)}`),this.u.error(k)}}async D(f){if(!this.profile.isDefault)return{};const k=this.w.getValue(n.$Keb),N=this.enabled.find(M=>M instanceof p.$JZb);if(N){const M=await N.getRemoteUserDataSyncConfiguration(f);return{...k,...M}}return k}F(f){this.g!==f&&(this.g=f,this.h.fire(f))}G(){return this.H(),this.enabled.some(f=>f.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(f=>f.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const f=this.enabled.filter(k=>k.status==="hasConflicts").filter(k=>k.conflicts.conflicts.length>0).map(k=>k.conflicts);(0,I.$af)(this.j,f,(k,N)=>k.syncResource===N.syncResource&&(0,I.$af)(k.conflicts,N.conflicts,(M,F)=>(0,S.$1f)(M.previewResource,F.previewResource)))||(this.j=f,this.k.fire(f))}I(f){switch(f){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};r=be([K(2,n.$3eb),K(3,h.$mh),K(4,m.$Nn),K(5,n.$Reb),K(6,v.$Tk),K(7,n.$8eb),K(8,c.$pk),K(9,E.$Th)],r);function a(g){if(g instanceof n.$Xeb)switch(g.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function w(g,f,k,N){N.publicLog2("sync/error",{code:g.code,serverCode:g instanceof n.$Yeb?String(g.serverCode):void 0,url:g instanceof n.$Yeb?g.url:void 0,resource:g.resource,executionId:f,service:k.userDataSyncStore.url.toString()})}}),define(oe[253],ae([0,1,3,2,10,17,23]),function(te,e,I,T,D,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I5b=e.$H5b=void 0;function R(m,h){return{...m,profile:(0,j.$qk)(m.profile,h.profilesHome.scheme)}}function S(m){return{created:m.created,uri:D.URI.revive(m.uri)}}class b{constructor(h,$,v){this.c=h,this.d=$,this.f=v,this.a=new Map,this.b=new I.$7c}listen(h,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${$}`)}async call(h,$,v){try{return await this.g(h,$,v)}catch(c){throw this.f.error(c),c}}async g(h,$,v){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(v[0]));case"accept":return this.c.accept(R(v[0],this.d),D.URI.revive(v[1]),v[2],v[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(v[0],v[1]?(0,j.$qk)(v[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(v[0],v[1]);case"replace":return this.c.replace(S(v[0]));case"getAssociatedResources":return this.c.getAssociatedResources(S(v[0]));case"getMachineId":return this.c.getMachineId(S(v[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const c=$.substring(11),l=v[0],u=this.h(l);switch(v=v.slice(1),c){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(h){const $=this.a.get(this.j(h));if(!$)throw new Error(`Manual sync taks not found: ${h}`);return $}async i(){const h=await this.c.createManualSyncTask();return this.a.set(this.j(h.id),h),h.id}j(h){return`manualSyncTask-${h}`}}e.$H5b=b;let P=class extends T.$lb{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(h,$){super(),this.k=$,this.b="uninitialized",this.c=this.B(new I.$7c),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new I.$7c),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new I.$7c),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new I.$7c),this.onSyncErrors=this.j.event,this.a={call(v,c,l){return h.call(v,c,l).then(null,u=>{throw L.$Xeb.toUserDataSyncError(u)})},listen(v,c){return h.listen(v,c)}},this.a.call("_getInitialData").then(([v,c,l])=>{this.l(v),this.m(c),l&&this.n(l),this.B(this.a.listen("onDidChangeStatus")(u=>this.l(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.n(u)))}),this.B(this.a.listen("onDidChangeConflicts")(v=>this.m(v))),this.B(this.a.listen("onSyncErrors")(v=>this.j.fire(v.map(c=>({...c,error:L.$Xeb.toUserDataSyncError(c.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const h=await this.a.call("createManualSyncTask"),$=this;return new E(h,{async call(c,l,u){return $.a.call(`manualSync/${c}`,[h,...Array.isArray(l)?l:[l]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(h,$,v,c){return this.a.call("accept",[h,$,v,c])}resolveContent(h){return this.a.call("resolveContent",[h])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(h,$){return(await this.a.call("getLocalSyncResourceHandles",[h,$])).map(({created:c,uri:l})=>({created:c,uri:D.URI.revive(l)}))}async getRemoteSyncResourceHandles(h,$){return(await this.a.call("getRemoteSyncResourceHandles",[h,$])).map(({created:c,uri:l})=>({created:c,uri:D.URI.revive(l)}))}async getAssociatedResources(h){return(await this.a.call("getAssociatedResources",[h])).map(({resource:v,comparableResource:c})=>({resource:D.URI.revive(v),comparableResource:D.URI.revive(c)}))}getMachineId(h){return this.a.call("getMachineId",[h])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(h){return this.a.call("replace",[h])}async l(h){this.b=h,this.c.fire(h)}async m(h){this.f=h.map($=>({syncResource:$.syncResource,profile:(0,j.$qk)($.profile,this.k.profilesHome.scheme),conflicts:$.conflicts.map(v=>({...v,baseResource:D.URI.revive(v.baseResource),localResource:D.URI.revive(v.localResource),remoteResource:D.URI.revive(v.remoteResource),previewResource:D.URI.revive(v.previewResource)}))})),this.g.fire(this.f)}n(h){this.h!==h&&(this.h=h,this.i.fire(h))}};e.$I5b=P,e.$I5b=P=be([K(1,j.$pk)],P);class E extends T.$lb{constructor(h,$){super(),this.id=h,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[254],ae([0,1,6,25,7,3,2,137,5,22,11,10,32,18,15,13,24,57,44,19,23]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hyb=e.$Gyb=e.$Fyb=e.$Eyb=e.$Dyb=void 0;const C="configurationSync.store",t="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,r=1e3*60*5;let a=class extends L.$lb{get userDataSyncStore(){return this.b}get c(){return this.h.get(p.$1eb,-1)}set c(M){this.h.store(p.$1eb,M,-1,S.$o?0:1)}constructor(M,F,W){super(),this.f=M,this.g=F,this.h=W,this.a=this.B(new j.$7c),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(j.Event.filter(W.onDidChangeValue,q=>q.key===p.$1eb&&q.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[C]),this.a.fire()}j(M){if(M&&(M=S.$o&&M.web?{...M,...M.web}:M,(0,P.$ie)(M.url)&&(0,P.$ke)(M.authenticationProviders)&&Object.keys(M.authenticationProviders).every(F=>Array.isArray(M.authenticationProviders[F].scopes)))){const F=M,W=!!F.canSwitch,q=F.url===F.insidersUrl?"insiders":"stable",J=(W?this.c:void 0)||q,Q=J==="insiders"?F.insidersUrl:J==="stable"?F.stableUrl:F.url;return{url:E.URI.parse(Q),type:J,defaultType:q,defaultUrl:E.URI.parse(F.url),stableUrl:E.URI.parse(F.stableUrl),insidersUrl:E.URI.parse(F.insidersUrl),canSwitch:W,authenticationProviders:Object.keys(F.authenticationProviders).reduce((Y,Z)=>(Y.push({id:Z,scopes:F.authenticationProviders[Z].scopes}),Y),[])}}}};e.$Dyb=a,e.$Dyb=a=be([K(0,c.$8i),K(1,h.$Th),K(2,y.$Io)],a);let w=class extends a{constructor(M,F,W){super(M,F,W);const q=this.h.get(t,-1);q&&(this.k=JSON.parse(q));const J=this.f[C];J?this.h.store(t,JSON.stringify(J),-1,1):this.h.remove(t,-1)}async switch(M){M!==this.c&&(this.c=M,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};e.$Eyb=w,e.$Eyb=w=be([K(0,c.$8i),K(1,h.$Th),K(2,y.$Io)],w);let g=class extends L.$lb{get donotMakeRequestsUntil(){return this.i}constructor(M,F,W,q,J,Q,Y){super(),this.k=W,this.l=q,this.m=Y,this.g=this.B(new j.$7c),this.onTokenFailed=this.g.event,this.h=this.B(new j.$7c),this.onTokenSucceed=this.h.event,this.i=void 0,this.j=this.B(new j.$7c),this.onDidChangeDonotMakeRequestsUntil=this.j.event,this.r=void 0,this.n(M),this.c=(0,u.$Oo)(J,Q,Y).then(Z=>{const x={"X-Client-Name":`${F.applicationName}${S.$o?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(x["X-Client-Commit"]=F.commit),x}),this.f=new k(i,r,this.k,this.l),this.p(),this.B((0,L.$jb)(()=>{this.r&&(this.r.cancel(),this.r=void 0)}))}setAuthToken(M,F){this.b={token:M,type:F}}n(M){this.a=M?(0,b.$8f)(M,"v1"):void 0}p(){const M=this.m.getNumber(o,-1);M&&Date.now()<M&&this.s(new Date(M))}s(M){this.i?.getTime()!==M?.getTime()&&(this.i=M,this.r&&(this.r.cancel(),this.r=void 0),this.i?(this.m.store(o,this.i.getTime(),-1,1),this.r=(0,I.$hg)(F=>(0,I.$ug)(this.i.getTime()-Date.now(),F).then(()=>this.s(void 0))),this.r.then(null,F=>null)):this.m.remove(o,-1),this.j.fire())}async getAllCollections(M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$8f)(this.a,"collection").toString();M={...M},M["Content-Type"]="application/json";const W=await this.v(F,{type:"GET",headers:M},[],T.CancellationToken.None);return(await(0,l.$Bo)(W))?.map(({id:q})=>q)||[]}async createCollection(M={}){if(!this.a)throw new Error("No settings sync store url configured.");const F=(0,b.$8f)(this.a,"collection").toString();M={...M},M["Content-Type"]=R.$sr.text;const W=await this.v(F,{type:"POST",headers:M},[],T.CancellationToken.None),q=await(0,l.$Ao)(W);if(!q)throw new p.$Yeb("Server did not return the collection id",F,"NoCollection",W.res.statusCode,W.res.headers[p.$Ueb]);return q}async deleteCollection(M,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=M?(0,b.$8f)(this.a,"collection",M).toString():(0,b.$8f)(this.a,"collection").toString();F={...F},await this.v(W,{type:"DELETE",headers:F},[],T.CancellationToken.None)}async getAllResourceRefs(M,F){if(!this.a)throw new Error("No settings sync store url configured.");const W=this.t(this.a,F,M),q={},J=await this.v(W.toString(),{type:"GET",headers:q},[],T.CancellationToken.None);return(await(0,l.$Bo)(J)||[]).map(({url:Y,created:Z})=>({ref:(0,b.$0f)(W,W.with({path:Y})),created:Z*1e3}))}async resolveResourceContent(M,F,W,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=(0,b.$8f)(this.t(this.a,W,M),F).toString();q={...q},q["Cache-Control"]="no-cache";const Q=await this.v(J,{type:"GET",headers:q},[],T.CancellationToken.None);return await(0,l.$Ao)(Q)}async deleteResource(M,F,W){if(!this.a)throw new Error("No settings sync store url configured.");const q=F!==null?(0,b.$8f)(this.t(this.a,W,M),F).toString():this.t(this.a,W,M).toString(),J={};await this.v(q,{type:"DELETE",headers:J},[],T.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,b.$8f)(this.a,"resource").toString(),F={"Content-Type":R.$sr.text};await this.v(M,{type:"DELETE",headers:F},[],T.CancellationToken.None)}async readResource(M,F,W,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const J=(0,b.$8f)(this.t(this.a,W,M),"latest").toString();q={...q},q["Cache-Control"]="no-cache",F&&(q["If-None-Match"]=F.ref);const Q=await this.v(J,{type:"GET",headers:q},[304],T.CancellationToken.None);let Y=null;if(Q.res.statusCode===304&&(Y=F),Y===null){const Z=Q.res.headers.etag;if(!Z)throw new p.$Yeb("Server did not return the ref",J,"NoRef",Q.res.statusCode,Q.res.headers[p.$Ueb]);const x=await(0,l.$Ao)(Q);if(!x&&Q.res.statusCode===304)throw new p.$Yeb("Empty response",J,"EmptyResponse",Q.res.statusCode,Q.res.headers[p.$Ueb]);Y={ref:Z,content:x}}return Y}async writeResource(M,F,W,q,J={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=this.t(this.a,q,M).toString();J={...J},J["Content-Type"]=R.$sr.text,W&&(J["If-Match"]=W);const Y=await this.v(Q,{type:"POST",data:F,headers:J},[],T.CancellationToken.None),Z=Y.res.headers.etag;if(!Z)throw new p.$Yeb("Server did not return the ref",Q,"NoRef",Y.res.statusCode,Y.res.headers[p.$Ueb]);return Z}async manifest(M,F={}){if(!this.a)throw new Error("No settings sync store url configured.");const W=(0,b.$8f)(this.a,"manifest").toString();F={...F},F["Content-Type"]="application/json",M&&(F["If-None-Match"]=M.ref);const q=await this.v(W,{type:"GET",headers:F},[304],T.CancellationToken.None);let J=null;if(q.res.statusCode===304&&(J=M),!J){const Y=q.res.headers.etag;if(!Y)throw new p.$Yeb("Server did not return the ref",W,"NoRef",q.res.statusCode,q.res.headers[p.$Ueb]);const Z=await(0,l.$Ao)(q);if(!Z&&q.res.statusCode===304)throw new p.$Yeb("Empty response",W,"EmptyResponse",q.res.statusCode,q.res.headers[p.$Ueb]);Z&&(J={...JSON.parse(Z),ref:Y})}const Q=this.m.get(n,-1);return Q&&J&&Q!==J.session&&this.u(),J===null&&Q&&this.u(),J&&this.m.store(n,J.session,-1,1),J}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.u()}t(M,F,W){return F?(0,b.$8f)(M,"collection",F,"resource",W):(0,b.$8f)(M,"resource",W)}u(){this.m.remove(n,-1),this.m.remove(s,-1)}async v(M,F,W,q){if(!this.b)throw new p.$Yeb("No Auth Token Available",M,"Unauthorized",void 0,void 0);if(this.i&&Date.now()<this.i.getTime())throw new p.$Yeb(`${F.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",void 0,void 0);this.s(void 0);const J=await this.c;F.headers={...F.headers||{},...J,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.w(F.headers),this.l.trace("Sending request to server",{url:M,type:F.type,headers:{...F.headers,authorization:void 0}});let Q;try{Q=await this.f.request(M,F,q)}catch(B){if(!(B instanceof p.$Yeb)){let V="RequestFailed";const ee=(0,D.$9)(B).toLowerCase();ee.includes("xhr timeout")?V="RequestTimeout":ee.includes("protocol")&&ee.includes("not supported")?V="RequestProtocolNotSupported":ee.includes("request path contains unescaped characters")?V="RequestPathNotEscaped":ee.includes("headers must be an object")?V="RequestHeadersNotObject":(0,D.$2)(B)&&(V="RequestCanceled"),B=new p.$Yeb(`Connection refused for the request '${M}'.`,M,V,void 0,void 0)}throw this.l.info("Request failed",M),B}const Y=Q.res.headers[p.$Ueb],Z={url:M,status:Q.res.statusCode,"execution-id":F.headers[p.$Veb],"operation-id":Y},x=(0,l.$yo)(Q)||Q.res.statusCode&&W.includes(Q.res.statusCode);let H="";if(x?this.l.trace("Request succeeded",Z):(H=await(0,l.$zo)(Q)||"",this.l.info("Request failed",Z,H)),Q.res.statusCode===401||Q.res.statusCode===403){if(this.b=void 0,Q.res.statusCode===401)throw this.g.fire("Unauthorized"),new p.$Yeb(`${F.type} request '${M}' failed because of Unauthorized (401).`,M,"Unauthorized",Q.res.statusCode,Y);if(Q.res.statusCode===403)throw this.g.fire("Forbidden"),new p.$Yeb(`${F.type} request '${M}' failed because the access is forbidden (403).`,M,"Forbidden",Q.res.statusCode,Y)}if(this.h.fire(),Q.res.statusCode===404)throw new p.$Yeb(`${F.type} request '${M}' failed because the requested resource is not found (404).`,M,"NotFound",Q.res.statusCode,Y);if(Q.res.statusCode===405)throw new p.$Yeb(`${F.type} request '${M}' failed because the requested endpoint is not found (405). ${H}`,M,"MethodNotFound",Q.res.statusCode,Y);if(Q.res.statusCode===409)throw new p.$Yeb(`${F.type} request '${M}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,M,"Conflict",Q.res.statusCode,Y);if(Q.res.statusCode===410)throw new p.$Yeb(`${F.type} request '${M}' failed because the requested resource is not longer available (410).`,M,"Gone",Q.res.statusCode,Y);if(Q.res.statusCode===412)throw new p.$Yeb(`${F.type} request '${M}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,M,"PreconditionFailed",Q.res.statusCode,Y);if(Q.res.statusCode===413)throw new p.$Yeb(`${F.type} request '${M}' failed because of too large payload (413).`,M,"TooLarge",Q.res.statusCode,Y);if(Q.res.statusCode===426)throw new p.$Yeb(`${F.type} request '${M}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,M,"UpgradeRequired",Q.res.statusCode,Y);if(Q.res.statusCode===429){const B=Q.res.headers["retry-after"];throw B?(this.s(new Date(Date.now()+parseInt(B)*1e3)),new p.$Yeb(`${F.type} request '${M}' failed because of too many requests (429).`,M,"TooManyRequestsAndRetryAfter",Q.res.statusCode,Y)):new p.$Yeb(`${F.type} request '${M}' failed because of too many requests (429).`,M,"RemoteTooManyRequests",Q.res.statusCode,Y)}if(!x)throw new p.$Yeb("Server returned "+Q.res.statusCode,M,"Unknown",Q.res.statusCode,Y);return Q}w(M){let F=this.m.get(s,-1);F===void 0&&(F=(0,m.$5e)(),this.m.store(s,F,-1,1)),M["X-Machine-Session-Id"]=F;const W=this.m.get(n,-1);W!==void 0&&(M["X-User-Session-Id"]=W)}};e.$Fyb=g,e.$Fyb=g=be([K(1,c.$8i),K(2,l.$wo),K(3,p.$8eb),K(4,$.$uh),K(5,v.$Qj),K(6,y.$Io)],g);let f=class extends g{constructor(M,F,W,q,J,Q,Y){super(M.userDataSyncStore?.url,F,W,q,J,Q,Y),this.B(M.onDidChangeUserDataSyncStore(()=>this.n(M.userDataSyncStore?.url)))}};e.$Gyb=f,e.$Gyb=f=be([K(0,p.$Reb),K(1,c.$8i),K(2,l.$wo),K(3,p.$8eb),K(4,$.$uh),K(5,v.$Qj),K(6,y.$Io)],f);class k{constructor(M,F,W,q){this.c=M,this.d=F,this.f=W,this.g=q,this.a=[],this.b=void 0}request(M,F,W){if(this.h()&&this.i(),F.url=M,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new p.$Yeb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,M,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(M),this.f.request(F,W)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$Hyb=k}),define(oe[255],ae([0,1,3,55,24,19,20,250,23,76,79]),function(te,e,I,T,D,j,L,R,S,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$35b=void 0;let E=class extends R.$x2b{constructor(h,$,v,c,l,u,y,p,C,t,o){super(h,$,v,c,l,y,p,C,t,o),this.B(I.Event.debounce(I.Event.any(I.Event.map(u.onDidFocusWindow,()=>"windowFocus"),I.Event.map(u.onDidOpenWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$35b=E,e.$35b=E=be([K(0,D.$8i),K(1,S.$Reb),K(2,S.$Seb),K(3,S.$3eb),K(4,S.$4eb),K(5,T.$T3b),K(6,S.$8eb),K(7,b.$nxb),K(8,L.$Tk),K(9,P.$sXb),K(10,j.$Io)],E)}),define(oe[256],ae([0,1,67,26,5,22]),function(te,e,I,T,D,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v3b=e.$u3b=e.$t3b=e.$s3b=void 0,e.$s3b=128/4;function L(b){function P(){let E=b.scheme===T.Schemas.file?(0,j.$Vf)(b):b.toString();return D.$k||(E=E.toLowerCase()),(0,I.createHash)("md5").update(E).digest("hex")}return{id:P(),configPath:b}}e.$t3b=L;function R(b,P){function E(){if(b.scheme!==T.Schemas.file)return(0,I.createHash)("md5").update(b.toString()).digest("hex");if(!P)return;let h;return D.$k?h=P.ino:D.$j?h=P.birthtime.getTime():D.$i&&(typeof P.birthtimeMs=="number"?h=Math.floor(P.birthtimeMs):h=P.birthtime.getTime()),(0,I.createHash)("md5").update(b.fsPath).update(h?String(h):"").digest("hex")}const m=E();if(typeof m=="string")return{id:m,uri:b}}e.$u3b=R;function S(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$v3b=S}),define(oe[257],ae([0,1,6,7,2,16,31,15,8,73,112,256,55,69]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w5b=void 0;let $=class extends D.$lb{constructor(c,l,u,y){super(),this.a=c,this.b=l,this.c=u,this.f=y,this.B(new I.$Eg(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const c=await L.Promises.readdir(this.a.workspaceStorageHome.fsPath),l=new b.$Yxb(this.f.getChannel("storage"));await Promise.all(c.map(async u=>{const y=(0,j.$ac)(this.a.workspaceStorageHome.fsPath,u);u.length===E.$s3b||u===P.$zh.id||(await this.c.getWindows()).some(t=>t.workspace?.id===u)||await l.isUsed(y)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${u} as it seems to be an unused empty workspace.`),await L.Promises.rm(y))}))}catch(c){(0,T.$Y)(c)}}};e.$w5b=$,e.$w5b=$=be([K(0,R.$vh),K(1,S.$Pi),K(2,m.$T3b),K(3,h.$84b)],$)}),define(oe[80],ae([0,1,52,6,16,11,31,144,267,268]),function(te,e,I,T,D,j,L,R,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4o=e.$3o=e.zip=e.$1o=e.$Zo=void 0,e.$Zo="end of central directory record signature not found";const P=new RegExp(e.$Zo);class E extends Error{constructor(o,n){let s=n.message;switch(o){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=o,this.cause=n}}e.$1o=E;function m(t){const o=t.externalFileAttributes>>16||33188;return[448,56,7].map(n=>o&n).reduce((n,s)=>n+s,o&61440)}function h(t){if(t instanceof E)return t;let o;return P.test(t.message)&&(o="CorruptZip"),new E(o,t)}function $(t,o,n,s,i,r){const a=D.$dc(o),w=D.$ac(s,a);if(!w.startsWith(s))return Promise.reject(new Error(R.localize(0,null,o)));const g=D.$ac(s,o);let f;return r.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(L.Promises.mkdir(w,{recursive:!0})).then(()=>new Promise((k,N)=>{if(!r.isCancellationRequested)try{f=(0,I.createWriteStream)(g,{mode:n}),f.once("close",()=>k()),f.once("error",N),t.once("error",N),t.pipe(f)}catch(M){N(M)}}))}function v(t,o,n,s){let i=(0,T.$hg)(()=>Promise.resolve()),r=0;return s.onCancellationRequested(()=>{i.cancel(),t.close()}),new Promise((a,w)=>{const g=new T.$og,f=k=>{k.isCancellationRequested||(r++,t.readEntry())};t.once("error",w),t.once("close",()=>i.then(()=>{s.isCancellationRequested||t.entryCount===r?a():w(new E("Incomplete",new Error(R.localize(1,null,r,t.entryCount))))},w)),t.readEntry(),t.on("entry",k=>{if(s.isCancellationRequested)return;if(!n.sourcePathRegex.test(k.fileName)){f(s);return}const N=k.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(N)){const W=D.$ac(o,N);i=(0,T.$hg)(q=>L.Promises.mkdir(W,{recursive:!0}).then(()=>f(q)).then(void 0,w));return}const M=l(t,k),F=m(k);i=(0,T.$hg)(W=>g.queue(()=>M.then(q=>$(q,N,F,o,n,W).then(()=>f(W)))).then(null,w))})})}function c(t,o=!1){return new Promise((n,s)=>{(0,S.open)(t,o?{lazyEntries:!0}:void 0,(i,r)=>{i?s(h(i)):n((0,j.$te)(r))})})}function l(t,o){return new Promise((n,s)=>{t.openReadStream(o,(i,r)=>{i?s(h(i)):n((0,j.$te)(r))})})}function u(t,o){return new Promise((n,s)=>{const i=new b.ZipFile;o.forEach(a=>{a.contents?i.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&i.addFile(a.localPath,a.path)}),i.end();const r=(0,I.createWriteStream)(t);i.outputStream.pipe(r),i.outputStream.once("error",s),r.once("error",s),r.once("finish",()=>n(t))})}e.zip=u;function y(t,o,n={},s){const i=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let r=c(t,!0);return n.overwrite&&(r=r.then(a=>L.Promises.rm(o).then(()=>a))),r.then(a=>v(a,o,{sourcePathRegex:i},s))}e.$3o=y;function p(t,o){return c(t).then(n=>new Promise((s,i)=>{n.on("entry",r=>{r.fileName===o&&l(n,r).then(a=>s(a),a=>i(a))}),n.once("close",()=>i(new Error(R.localize(2,null,o))))}))}function C(t,o){return p(t,o).then(n=>new Promise((s,i)=>{const r=[];n.once("error",i),n.on("data",a=>r.push(a)),n.on("end",()=>s(Buffer.concat(r)))}))}e.$4o=C}),define(oe[258],ae([0,1,6,7,2,26,5,22,53,11,32,31,80,18,15,29,33,97,13,8]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=void 0;let p=class $t extends D.$lb{static{this.c=".sigzip"}constructor(t,o,n,s,i,r){super(),this.h=o,this.i=n,this.j=s,this.k=i,this.l=r,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,o,n){await this.g;const s=(0,R.$8f)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,s,r=>this.i.download(t,r,o))}catch(r){throw new v.$On(r.message,v.ExtensionManagementErrorCode.Download)}let i=!1;if(n&&this.m(t)){const r=await this.n(t);try{i=await this.k.verify(s.fsPath,r.fsPath,this.l.getLevel()===y.LogLevel.Trace)}catch(a){const w=a;if(i=w.code,w.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${w.output}`),i===v.ExtensionSignaturetErrorCode.PackageIsInvalidZip||i===v.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new v.$On(m.$Zo,v.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(r)}catch(a){this.l.error(a)}}}return i===!0?this.l.info(`Extension signature is verified: ${t.identifier.id}`):i===!1?this.l.info(`Extension signature verification is not done: ${t.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${i}': ${t.identifier.id}`),{location:s,verificationStatus:i}}m(t){if(!t.isSigned)return!1;const o=this.j.getValue("extensions.verifySignature");return(0,b.$oe)(o)?o:!0}async n(t){await this.g;const o=(0,R.$8f)(this.extensionsDownloadDir,`${this.v(t)}${$t.c}`);return await this.r(t,o,n=>this.i.downloadSignatureArchive(t,n)),o}async r(t,o,n){if(await this.h.exists(o))return;if(o.scheme!==j.Schemas.file){await n(o);return}const s=(0,R.$8f)(this.extensionsDownloadDir,`.${(0,P.$5e)()}`);await this.h.exists(s)||await n(s);try{await this.t(s,o,Date.now()+2*60*1e3)}catch(i){try{await this.h.del(s)}catch{}if(i.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,o.path);else throw this.l.info(`Rename failed because of ${(0,T.$9)(i)}. Deleted the file from downloaded location`,s.path),i}}async delete(t){await this.g,await this.h.del(t)}async t(t,o,n){try{await E.Promises.rename(t.fsPath,o.fsPath)}catch(s){if(L.$i&&s&&s.code==="EPERM"&&Date.now()<n)return this.l.info(`Failed renaming ${t} to ${o} with 'EPERM' error. Trying again...`),this.t(t,o,n);throw s}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const o=[],n=[],s=[];for(const a of t.children)if(a.name.endsWith($t.c))s.push(a.resource);else{const w=c.$eo.parse(a.name);w&&n.push([w,a])}const i=(0,c.$jo)(n,([a])=>a),r=[];for(const a of i)a.sort((w,g)=>S.rcompare(w[0].version,g[0].version)),o.push(...a.slice(1).map(w=>w[1].resource)),r.push(a[0][1]);r.sort((a,w)=>a.mtime-w.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await I.Promises.settled(o.map(a=>(this.l.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.l.error(t)}}v(t){return this.f?c.$eo.create(t).toString().toLowerCase():(0,P.$5e)()}};e.$gp=p,e.$gp=p=be([K(0,$.$vh),K(1,u.$Qj),K(2,v.$Nn),K(3,h.$Th),K(4,l.$To),K(5,y.$Pi)],p)}),define(oe[259],ae([0,1,80,153]),function(te,e,I,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=void 0;function D(j){return(0,I.$4o)(j,"extension/package.json").then(L=>{try{return JSON.parse(L.toString("utf8"))}catch{throw new Error((0,T.localize)(0,null))}})}e.$ip=D}),define(oe[121],ae([0,1,6,14,25,38,7,3,51,2,35,26,16,5,22,53,11,10,32,31,80,152,96,15,238,29,33,50,77,258,239,259,208,218,65,13,4,8,24,20,28,17]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p,C,t,o,n,s,i,r,a,w,g,f,k,N,M,F,W,q,J,Q,Y,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=void 0,e.$lp=(0,W.$oh)(s.$Pn);const x=".vsctmp";let H=class extends n.$5o{constructor(A,d,O,z,G,U,X,_,se,he,ue,me){super(A,d,ue,O,he,me),this.bb=G,this.cb=U,this.db=X,this.eb=se,this.ab=new Map,this.nb=new P.$mi;const pe=this.B(_.createInstance(g.$hp));this.Y=this.B(_.createInstance(B,Re=>pe.postUninstall(Re))),this.Z=this.B(new k.$jp(me,se,ue,this,this.y)),this.$=this.B(_.createInstance(w.$gp));const ke=this.B(new N.$kp(this,this.bb,me,U,ue,se,O));this.B(ke.onDidChangeExtensionsByAnotherSource(Re=>this.mb(Re))),this.ob()}getTargetPlatform(){return this.fb||(this.fb=(0,i.$oo)(this.eb,this.y)),this.fb}async zip(A){this.y.trace("ExtensionManagementService#zip",A.identifier.id);const d=await this.lb(A),O=await(0,p.zip)((0,$.$8f)(this.$.extensionsDownloadDir,(0,u.$5e)()).fsPath,d);return l.URI.file(O)}async unzip(A){return this.y.trace("ExtensionManagementService#unzip",A.toString()),(await this.install(A)).identifier}async getManifest(A){const{location:d,cleanup:O}=await this.hb(A),z=m.$bc(d.fsPath);try{return await(0,f.$ip)(z)}finally{await O()}}getInstalled(A,d=this.C.defaultProfile.extensionsResource){return this.Y.scanExtensions(A??null,d)}scanAllUserInstalledExtensions(){return this.Y.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(A){return this.Y.scanUserExtensionAtLocation(A)}async install(A,d={}){this.y.trace("ExtensionManagementService#install",A.toString());const{location:O,cleanup:z}=await this.hb(A);try{const G=await(0,f.$ip)(m.$bc(O.fsPath)),U=(0,i.$io)(G.publisher,G.name);if(G.engines&&G.engines.vscode&&!(0,M.$vo)(G.engines.vscode,this.z.version,this.z.date))throw new Error(C.localize(0,null,U,this.z.version));const X=await this.D([{manifest:G,extension:O,options:d}]);if(X[0]?.local)return X[0]?.local;throw X[0]?.error?X[0].error:(0,n.$7o)(new Error(`Unknown error while installing extension ${U}`))}finally{await z()}}async installFromLocation(A,d){this.y.trace("ExtensionManagementService#installFromLocation",A.toString());const O=await this.Y.scanUserExtensionAtLocation(A);if(!O)throw new Error(`Cannot find a valid extension from the location ${A.toString()}`);return await this.qb([[O,void 0]],d),this.y.info("Successfully installed extension",O.identifier.id,d.toString()),O}async installExtensionsFromProfile(A,d,O){this.y.trace("ExtensionManagementService#installExtensionsFromProfile",A,d.toString(),O.toString());const z=(await this.Y.scanExtensions(1,d)).filter(G=>A.some(U=>(0,i.$do)(U,G.identifier)));if(z.length){const G=await Promise.all(z.map(U=>this.Y.scanMetadata(U,d)));await this.qb(z.map((U,X)=>[U,G[X]]),O),this.y.info("Successfully installed extensions",z.map(U=>U.identifier.id),O.toString())}return z}async updateMetadata(A,d,O=this.C.defaultProfile.extensionsResource){return this.y.trace("ExtensionManagementService#updateMetadata",A.identifier.id),d.isPreReleaseVersion&&(d.preRelease=!0),d.isMachineScoped=d.isMachineScoped||void 0,d.isBuiltin=d.isBuiltin||void 0,d.pinned=d.pinned||void 0,A=await this.Y.updateMetadata(A,d,O),this.Z.invalidate(O),this.s.fire(A),A}async reinstallFromGallery(A){if(this.y.trace("ExtensionManagementService#reinstallFromGallery",A.identifier.id),!this.u.isEnabled())throw new Error(C.localize(1,null));const d=await this.getTargetPlatform(),[O]=await this.u.getExtensions([{...A.identifier,preRelease:A.preRelease}],{targetPlatform:d,compatible:!0},D.CancellationToken.None);if(!O)throw new Error(C.localize(2,null));await this.Y.setUninstalled(A);try{await this.Y.removeUninstalledExtension(A)}catch(z){throw new Error(C.localize(3,null,(0,j.$$h)(z)))}return this.installFromGallery(O)}X(A,d,O,z){return this.Y.copyExtension(A,d,O,z)}copyExtensions(A,d){return this.Y.copyExtensions(A,d)}markAsUninstalled(...A){return this.Y.setUninstalled(...A)}async cleanUp(){this.y.trace("ExtensionManagementService#cleanUp");try{await this.Y.cleanUp()}catch(A){this.y.error(A)}}async download(A,d,O){const{location:z}=await this.$.download(A,d,!O);return z}async hb(A){if(A.scheme===E.Schemas.file)return{location:A,async cleanup(){}};this.y.trace("Downloading extension from",A.toString());const d=(0,$.$8f)(this.$.extensionsDownloadDir,(0,u.$5e)());return await this.db.download(A,d),this.y.info("Downloaded extension to",d.toString()),{location:d,cleanup:async()=>{try{await this.eb.del(d)}catch(z){this.y.error(z)}}}}S(){return this.C.defaultProfile.extensionsResource}U(A,d,O){if(l.URI.isUri(d))return new ne(A,d,O,this.u,this.Y,this.w,this.C,this.bb,this.cb,this.y);const z=i.$eo.create(d).toString();let G=this.ab.get(z);return G||(this.ab.set(z,G=new ee(A,d,O,this.$,this.Y,this.w,this.C,this.bb,this.cb,this.y)),G.waitUntilTaskIsFinished().finally(()=>this.ab.delete(z))),G}W(A,d){return new ce(A,d.profileLocation,this.cb)}async lb(A){const d=async z=>{let G=await y.Promises.readdir(z);G=G.map(_=>m.$ac(z,_));const U=await Promise.all(G.map(_=>y.Promises.stat(_)));let X=Promise.resolve([]);return U.forEach((_,se)=>{const he=G[se];_.isFile()&&(X=X.then(ue=>[...ue,he])),_.isDirectory()&&(X=X.then(ue=>d(he).then(me=>[...ue,...me])))}),X};return(await d(A.location.fsPath)).map(z=>({path:`extension/${m.$cc(A.location.fsPath,z)}`,localPath:z}))}async mb({added:A,removed:d}){if(d)for(const O of d.extensions)this.y.info("Extensions removed from another source",O.id,d.profileLocation.toString()),this.p.fire({identifier:O,profileLocation:d.profileLocation});if(A){const z=(await this.Y.scanExtensions(1,A.profileLocation)).filter(G=>A.extensions.some(U=>(0,i.$do)(U,G.identifier)));this.m.fire(z.map(G=>(this.y.info("Extensions added from another source",G.identifier.id,A.profileLocation.toString()),{identifier:G.identifier,local:G,profileLocation:A.profileLocation,operation:1})))}}async ob(){this.B(this.Y.onExtract(d=>this.nb.add(d)));const A=await this.eb.resolve(this.bb.userExtensionsLocation);for(const d of A.children??[])d.isDirectory&&this.nb.add(d.resource);this.B(this.eb.watch(this.bb.userExtensionsLocation)),this.B(this.eb.onDidFilesChange(d=>this.pb(d)))}async pb(A){if(!A.affects(this.bb.userExtensionsLocation,1))return;const d=[];for(const O of A.rawAdded){if(this.nb.has(O)||!this.w.extUri.isEqual(this.w.extUri.dirname(O),this.bb.userExtensionsLocation)||this.w.extUri.isEqual(O,this.w.extUri.joinPath(this.bb.userExtensionsLocation,".obsolete"))||this.w.extUri.basename(O).startsWith(".")||!(await this.eb.stat(O)).isDirectory)continue;const z=await this.Y.scanUserExtensionAtLocation(O);z&&z.installedTimestamp===void 0&&(this.nb.add(O),d.push(z))}d.length&&(await this.qb(d.map(O=>[O,void 0]),this.C.defaultProfile.extensionsResource),this.y.info("Added extensions to default profile from external source",d.map(O=>O.identifier.id)))}async qb(A,d){const O=A.map(z=>z[0]);await this.rb(O),await this.cb.addExtensionsToProfile(A,d),this.m.fire(O.map(z=>({local:z,identifier:z.identifier,operation:1,profileLocation:d})))}async rb(A){const d=await this.Y.getUninstalledExtensions();for(const O of A){const z=i.$eo.create(O);d[z.toString()]&&(this.y.trace("Removing the extension from uninstalled list:",z.id),await this.Y.setInstalled(z),this.y.info("Removed the extension from uninstalled list:",z.id))}}};e.$mp=H,e.$mp=H=be([K(0,s.$Nn),K(1,Q.$Tk),K(2,q.$Pi),K(3,o.$vh),K(4,a.$bp),K(5,r.$0o),K(6,t.$sn),K(7,W.$mh),K(8,F.$Qj),K(9,J.$8i),K(10,Y.$nk),K(11,Z.$pk)],H);let B=class extends b.$lb{constructor(A,d,O,z,G,U){super(),this.j=A,this.k=d,this.l=O,this.m=z,this.n=G,this.p=U,this.h=this.B(new R.$7c),this.onExtract=this.h.event,this.c=(0,$.$8f)(this.l.userExtensionsLocation,".obsolete"),this.g=new I.$Ag}async cleanUp(){await this.C(),await this.z()}async scanExtensions(A,d){const O={includeInvalid:!0,profileLocation:d};let z=[];return A===null||A===0?z.push(...await this.l.scanAllExtensions({includeInvalid:!0},O,!1)):A===1&&z.push(...await this.l.scanUserExtensions(O)),z=A!==null?z.filter(G=>G.type===A):z,Promise.all(z.map(G=>this.y(G)))}async scanAllUserExtensions(A){const d=await this.l.scanUserExtensions({includeAllVersions:!A,includeInvalid:!0});return Promise.all(d.map(O=>this.y(O)))}async scanUserExtensionAtLocation(A){try{const d=await this.l.scanExistingExtension(A,1,{includeInvalid:!0});if(d)return await this.y(d)}catch(d){this.p.error(d)}return null}async extractUserExtension(A,d,O,z,G){const U=A.toString(),X=l.URI.file(m.$ac(this.l.userExtensionsLocation.fsPath,`.${(0,u.$5e)()}`)),_=l.URI.file(m.$ac(this.l.userExtensionsLocation.fsPath,U));let se=await this.k.exists(_);if(se&&z){try{await this.t(A.id,_,"removeExisting")}catch{throw new s.$On(C.localize(4,null,_.fsPath,A.id),s.ExtensionManagementErrorCode.Delete)}se=!1}if(!se)try{try{this.p.trace(`Started extracting the extension from ${d} to ${_.fsPath}`),await(0,p.$3o)(d,X.fsPath,{sourcePath:"extension",overwrite:!0},G),this.p.info(`Extracted extension to ${_}:`,A.id)}catch(he){let ue=s.ExtensionManagementErrorCode.Extract;throw he instanceof p.$1o&&(he.type==="CorruptZip"?ue=s.ExtensionManagementErrorCode.CorruptZip:he.type==="Incomplete"&&(ue=s.ExtensionManagementErrorCode.IncompleteZip)),new s.$On(he.message,ue)}await this.l.updateMetadata(X,O);try{this.p.trace(`Started renaming the extension from ${X.fsPath} to ${_.fsPath}`),await this.v(A,X.fsPath,_.fsPath,Date.now()+2*60*1e3),this.p.info("Renamed to",_.fsPath)}catch(he){if(he.code==="ENOTEMPTY")this.p.info("Rename failed because extension was installed by another source. So ignoring renaming.",A.id);else throw this.p.info(`Rename failed because of ${(0,L.$9)(he)}. Deleted from extracted location`,X),he}this.h.fire(_)}catch(he){try{await this.k.del(X,{recursive:!0})}catch{}throw he}return this.w(_,1)}async scanMetadata(A,d){return d?(await this.s(A,d))?.metadata:this.l.scanMetadata(A.location)}async s(A,d){return(await this.m.scanProfileExtensions(d)).find(z=>(0,i.$do)(z.identifier,A.identifier))}async updateMetadata(A,d,O){return O?await this.m.updateMetadata([[A,d]],O):await this.l.updateMetadata(A.location,d),this.w(A.location,A.type,O)}getUninstalledExtensions(){return this.u()}async setUninstalled(...A){const d=A.map(O=>i.$eo.create(O));await this.u(O=>d.forEach(z=>{O[z.toString()]=!0,this.p.info("Marked extension as uninstalled",z.toString())}))}async setInstalled(A){await this.u(d=>delete d[A.toString()])}async removeExtension(A,d){if(this.n.extUri.isEqualOrParent(A.location,this.l.userExtensionsLocation))return this.t(A.identifier.id,A.location,d)}async removeUninstalledExtension(A){await this.removeExtension(A,"uninstalled"),await this.u(d=>delete d[i.$eo.create(A).toString()])}async copyExtension(A,d,O,z){const G=await this.s(A,d),U=await this.s(A,O);return z={...G?.metadata,...z},U?await this.m.updateMetadata([[A,{...U.metadata,...z}]],O):await this.m.addExtensionsToProfile([[A,z]],O),this.w(A.location,A.type,O)}async copyExtensions(A,d){const O=await this.scanExtensions(1,A),z=await Promise.all(O.filter(G=>!G.isApplicationScoped).map(async G=>[G,await this.scanMetadata(G,A)]));await this.m.addExtensionsToProfile(z,d)}async t(A,d,O){this.p.trace(`Deleting ${O} extension from disk`,A,d.fsPath);const z=this.n.extUri.joinPath(this.n.extUri.dirname(d),`${this.n.extUri.basename(d)}.${(0,S.$bi)((0,u.$5e)()).toString(16)}${x}`);await this.v({id:A},d.fsPath,z.fsPath,Date.now()+2*60*1e3),await this.k.del(z,{recursive:!0}),this.p.info(`Deleted ${O} extension from disk`,A,d.fsPath)}async u(A){return this.g.queue(async()=>{let d;try{d=(await this.k.readFile(this.c,"utf8")).value.toString()}catch(z){if((0,F.$7j)(z)!==1)throw z}let O={};if(d)try{O=JSON.parse(d)}catch{}return A&&(A(O),Object.keys(O).length?await this.k.writeFile(this.c,T.$Jb.fromString(JSON.stringify(O))):await this.k.del(this.c)),O})}async v(A,d,O,z){try{await y.Promises.rename(d,O)}catch(G){if(h.$i&&G&&G.code==="EPERM"&&Date.now()<z)return this.p.info(`Failed renaming ${d} to ${O} with 'EPERM' error. Trying again...`,A.id),this.v(A,d,O,z);throw new s.$On(G.message||C.localize(5,null,d,O),G.code||s.ExtensionManagementErrorCode.Rename)}}async w(A,d,O){if(O){const G=(await this.l.scanUserExtensions({profileLocation:O})).find(U=>this.n.extUri.isEqual(U.location,A));if(G)return this.y(G)}else{const z=await this.l.scanExistingExtension(A,d,{includeInvalid:!0});if(z)return this.y(z)}throw new Error(C.localize(6,null,A.path))}async y(A){const d=await this.k.resolve(A.location);let O,z;return d.children&&(O=d.children.find(({name:G})=>/^readme(\.txt|\.md|)$/i.test(G))?.resource,z=d.children.find(({name:G})=>/^changelog(\.txt|\.md|)$/i.test(G))?.resource),{identifier:A.identifier,type:A.type,isBuiltin:A.isBuiltin||!!A.metadata?.isBuiltin,location:A.location,manifest:A.manifest,targetPlatform:A.targetPlatform,validations:A.validations,isValid:A.isValid,readmeUrl:O,changelogUrl:z,publisherDisplayName:A.metadata?.publisherDisplayName||null,publisherId:A.metadata?.publisherId||null,isApplicationScoped:!!A.metadata?.isApplicationScoped,isMachineScoped:!!A.metadata?.isMachineScoped,isPreReleaseVersion:!!A.metadata?.isPreReleaseVersion,preRelease:!!A.metadata?.preRelease,installedTimestamp:A.metadata?.installedTimestamp,updated:!!A.metadata?.updated,pinned:!!A.metadata?.pinned}}async z(){const A=await this.getUninstalledExtensions();if(Object.keys(A).length===0){this.p.debug("No uninstalled extensions found.");return}this.p.debug("Removing uninstalled extensions:",Object.keys(A));const d=await this.l.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),O=new Set;for(const G of d)A[i.$eo.create(G).toString()]||O.add(G.identifier.id.toLowerCase());try{const G=(0,i.$jo)(d,U=>U.identifier);await I.Promises.settled(G.map(async U=>{const X=U.sort((_,se)=>v.rcompare(_.manifest.version,se.manifest.version))[0];O.has(X.identifier.id.toLowerCase())||await this.j(await this.y(X))}))}catch(G){this.p.error(G)}const z=d.filter(G=>G.metadata&&A[i.$eo.create(G).toString()]);await Promise.allSettled(z.map(G=>this.removeUninstalledExtension(G)))}async C(){this.p.trace("ExtensionManagementService#removeTempDeleteFolders");let A;try{A=await this.k.resolve(this.l.userExtensionsLocation)}catch(d){(0,F.$7j)(d)!==1&&this.p.error(d);return}if(A?.children)try{await Promise.allSettled(A.children.map(async d=>{if(!(!d.isDirectory||!d.name.endsWith(x))){this.p.trace("Deleting the temporarily deleted folder",d.resource.toString());try{await this.k.del(d.resource,{recursive:!0}),this.p.trace("Deleted the temporarily deleted folder",d.resource.toString())}catch(O){(0,F.$7j)(O)!==1&&this.p.error(O)}}}))}catch{}}};e.$np=B,e.$np=B=be([K(1,F.$Qj),K(2,a.$bp),K(3,r.$0o),K(4,Y.$nk),K(5,q.$Pi)],B);class V extends n.$8o{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,c.$pe)(this.m.operation)?this.l:this.m.operation}constructor(A,d,O,z,G,U,X,_,se){super(),this.identifier=A,this.source=d,this.m=O,this.n=z,this.o=G,this.p=U,this.q=X,this.s=_,this.t=se,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(A){const[d,O]=await this.y(A);return this.j=d.isBuiltin||d.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[d,O]],this.j),d}async v({zipPath:A,key:d,metadata:O},z,G){let U=await this.w(d);return U||(this.t.trace("Extracting extension...",d.id),U=await this.n.extractUserExtension(d,A,O,z,G),this.t.info("Extracting extension completed.",d.id)),U}async w(A){return await this.x(A)?(this.t.trace("Removing the extension from uninstalled list:",A.id),await this.n.setInstalled(A),this.t.info("Removed the extension from uninstalled list:",A.id),(await this.n.scanAllUserExtensions(!0)).find(z=>i.$eo.create(z).equals(A))):void 0}async x(A){return!!(await this.n.getUninstalledExtensions())[A.toString()]}}class ee extends V{constructor(A,d,O,z,G,U,X,_,se,he){super(d.identifier,d,O,G,U,X,_,se,he),this.z=d,this.A=z}async y(A){const O=(await this.n.scanExtensions(null,this.m.profileLocation)).find(X=>(0,i.$do)(X.identifier,this.z.identifier));O&&(this.l=3);const z={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||O?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||O?.isMachineScoped,isBuiltin:this.m.isBuiltin||O?.isBuiltin,isSystem:O?.type===0?!0:void 0,updated:!!O,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,c.$oe)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:O?.preRelease)};if(O?.manifest.version===this.z.version)return[await this.n.updateMetadata(O,z),z];const{location:G,verificationStatus:U}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=U,this.C(G.fsPath),[await this.v({zipPath:G.fsPath,key:i.$eo.create(this.z),metadata:z},!1,A),z]}catch(X){try{await this.A.delete(G)}catch(_){this.t.warn("Error while deleting the downloaded file",G.toString(),(0,L.$9)(_))}throw X}}async C(A){try{await(0,f.$ip)(A)}catch(d){throw new s.$On((0,n.$6o)(d).message,s.ExtensionManagementErrorCode.Invalid)}}}e.$op=ee;class ne extends V{constructor(A,d,O,z,G,U,X,_,se,he){super({id:(0,i.$io)(A.publisher,A.name)},d,O,G,U,X,_,se,he),this.z=A,this.A=d,this.B=z}async h(A){const d=await super.h(A);return this.E(d,A),d}async y(A){const d=new i.$eo(this.identifier,this.z.version),z=(await this.n.scanExtensions(1,this.m.profileLocation)).find(X=>(0,i.$do)(this.identifier,X.identifier)),G={isApplicationScoped:this.m.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||z?.isMachineScoped,isBuiltin:this.m.isBuiltin||z?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(z)if(this.l=3,d.equals(new i.$eo(z.identifier,z.manifest.version)))try{await this.n.removeExtension(z,"existing")}catch{throw new Error(C.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&v.gt(z.manifest.version,this.z.version)&&await this.n.setUninstalled(z);else{const X=await this.w(d);if(X)try{await this.n.removeExtension(X,"existing")}catch{throw new Error(C.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:m.$bc(this.A.fsPath),key:d,metadata:G},!0,A),G]}async E(A,d){try{let[O]=await this.B.getExtensions([{id:A.identifier.id,version:A.manifest.version}],d);if(O||([O]=await this.B.getExtensions([{id:A.identifier.id}],d)),O){const z={id:O.identifier.uuid,publisherDisplayName:O.publisherDisplayName,publisherId:O.publisherId,isPreReleaseVersion:O.properties.isPreReleaseVersion,preRelease:O.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(A,z,this.m.profileLocation)}}catch{}}}class ce extends n.$8o{constructor(A,d,O){super(),this.extension=A,this.j=d,this.k=O}async h(A){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[260],ae([0,1,2,29,78,217,121,8,19]),function(te,e,I,T,D,j,L,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W5b=void 0;let b=class extends I.$lb{constructor(E,m,h,$,v,c){super(),E.cleanUp(),(0,j.$8Sb)(E,m,h,$,c),D.$Bz.removeOutdatedExtensionVersions(E,v)}};e.$W5b=b,e.$W5b=b=be([K(0,L.$lp),K(1,T.$Nn),K(2,D.$Az),K(3,T.$Sn),K(4,S.$Io),K(5,R.$Pi)],b)}),define(oe[261],ae([0,1,67,60,36,269,14,7,3,2,16,5,32,43,92]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0;class v{traceSocketEvent(f,k){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,k)}constructor(f,k=""){this.f=!0,this.debugLabel=k,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=N=>{if(this.traceSocketEvent("error",{code:N?.code,message:N?.message}),N){if(N.code==="EPIPE")return;(0,R.$Y)(N)}},this.socket.on("error",this.a),this.b=N=>{this.traceSocketEvent("close",{hadError:N}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const k=N=>{this.traceSocketEvent("read",N),f(L.$Jb.wrap(N))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(f){const k=N=>{f({type:0,hadError:N,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(f){const k=()=>{f()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,R.$Y)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,R.$Y)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const N=()=>{this.socket.off("close",N),this.socket.off("end",N),this.socket.off("error",N),this.socket.off("timeout",N),this.socket.off("drain",N),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",N),this.socket.on("end",N),this.socket.on("error",N),this.socket.on("timeout",N),this.socket.on("drain",N)})}}e.$ch=v;var c;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize",g[g.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(c||(c={}));var l;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(l||(l={}));class u extends b.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,k){this.socket.traceSocketEvent(f,k)}constructor(f,k,N,M){super(),this.f=this.B(new S.$7c),this.g=this.B(new S.$7c),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:N?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new y(this,k,N,M,this.f,(F,W)=>this.k(F,W))),this.B(this.a.onError(F=>{console.error(F),(0,R.$Y)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new $.$0g,this.B(this.socket.onData(F=>this.l(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let k=0;for(;k<f.byteLength;)this.a.writeMessage(f.slice(k,Math.min(k+262144,f.byteLength))),k+=262144}k(f,k){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let N=2;f.byteLength<126?N+=0:f.byteLength<2**16?N+=2:N+=8;const M=L.$Jb.alloc(N);if(k?M.writeUInt8(194,0):M.writeUInt8(130,0),f.byteLength<126)M.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){M.writeUInt8(126,1);let F=1;M.writeUInt8(f.byteLength>>>8&255,++F),M.writeUInt8(f.byteLength>>>0&255,++F)}else{M.writeUInt8(127,1);let F=1;M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(0,++F),M.writeUInt8(f.byteLength>>>24&255,++F),M.writeUInt8(f.byteLength>>>16&255,++F),M.writeUInt8(f.byteLength>>>8&255,++F),M.writeUInt8(f.byteLength>>>0&255,++F)}this.socket.write(L.$Jb.concat([M,f]))}end(){this.h=!0,this.socket.end()}l(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),N=k.readUInt8(0),M=(N&128)>>>7,F=(N&64)>>>6,W=k.readUInt8(1),q=(W&128)>>>7,J=W&127;this.j.state=2,this.j.readLen=2+(q?4:0)+(J===126?2:0)+(J===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!M,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),N=k.readUInt8(1),M=(N&128)>>>7;let F=N&127,W=1;F===126?F=k.readUInt8(++W)*2**8+k.readUInt8(++W):F===127&&(F=k.readUInt8(++W)*0+k.readUInt8(++W)*0+k.readUInt8(++W)*0+k.readUInt8(++W)*0+k.readUInt8(++W)*2**24+k.readUInt8(++W)*2**16+k.readUInt8(++W)*2**8+k.readUInt8(++W));let q=0;M&&(q=k.readUInt8(++W)*2**24+k.readUInt8(++W)*2**16+k.readUInt8(++W)*2**8+k.readUInt8(++W)),this.j.state=3,this.j.readLen=F,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(k,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await S.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$dh=u;class y extends b.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$Jb.alloc(0)}constructor(f,k,N,M,F,W){super(),this.l=f,this.m=F,this.n=W,this.a=this.B(new S.$7c),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new S.$7c),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new S.$7c),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,k?(this.b=this.B(new p(this.l,M,N,{windowBits:15})),this.f=this.B(new C(this.l,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(f){this.g.push(f),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const f=this.g.shift();if(this.f){const k=await this.s(this.f,f);this.n(k,!0)}else this.n(f,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(f,k){return new Promise((N,M)=>{f.write(k),f.flush(F=>N(F))})}acceptFrame(f,k,N){this.h.push({data:f,isCompressed:k,isLastFrameOfMessage:N}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const k=await this.w(this.b,f.data,f.isLastFrameOfMessage);this.m.fire(k)}else this.m.fire(f.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(f,k,N){return new Promise((M,F)=>{f.write(k),N&&f.write(L.$Jb.fromByteArray([0,0,255,255])),f.flush(W=>M(W))})}}class p extends b.$lb{get recordedInflateBytes(){return this.j?L.$Jb.concat(this.f):L.$Jb.alloc(0)}constructor(f,k,N,M){super(),this.h=f,this.j=k,this.a=this.B(new S.$7c),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(M),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(L.$Jb.wrap(F))}),N&&(this.h.traceSocketEvent("zlibInflateInitialWrite",N.buffer),this.b.write(N.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=L.$Jb.concat(this.g);this.g.length=0,f(k)})}}class C extends b.$lb{constructor(f,k){super(),this.g=f,this.a=this.B(new S.$7c),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",N=>{this.g.traceSocketEvent("zlibDeflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.g.traceSocketEvent("zlibDeflateData",N),this.f.push(L.$Jb.wrap(N))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=L.$Jb.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),f(k)})}}function t(g,f){if(f===0)return;const k=g.byteLength>>>2;for(let J=0;J<k;J++){const Q=g.readUInt32BE(J*4);g.writeUInt32BE(Q^f,J*4)}const N=k*4,M=g.byteLength-N,F=f>>>24&255,W=f>>>16&255,q=f>>>8&255;M>=1&&g.writeUInt8(g.readUInt8(N)^F,N),M>=2&&g.writeUInt8(g.readUInt8(N+1)^W,N+1),M>=3&&g.writeUInt8(g.readUInt8(N+2)^q,N+2)}e.$eh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const g=(0,m.$5e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;const f=process.platform!=="darwin"&&e.$eh?e.$eh:(0,D.tmpdir)(),k=(0,P.$ac)(f,`vscode-ipc-${g}.sock`);return i(k),k}e.$fh=n;function s(g,f,k){const N=(0,I.createHash)("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${k}-${f}-sock`;const M=k.substr(0,4),F=f.substr(0,6),W=N.substr(0,8);let q;return process.platform!=="darwin"&&e.$eh&&!process.env.VSCODE_PORTABLE?q=(0,P.$ac)(e.$eh,`vscode-${W}-${M}-${F}.sock`):q=(0,P.$ac)(g,`${M}-${F}.sock`),i(q),q}e.$gh=s;function i(g){const f=o[E.$t];typeof f=="number"&&g.length>=f&&console.warn(`WARNING: IPC handle "${g}" is longer than ${f} chars, try a shorter --user-data-dir`)}class r extends h.$4g{static b(f){const k=S.Event.fromNodeEventEmitter(f,"connection");return S.Event.map(k,N=>({protocol:new $.$$g(new v(N,"ipc-server-connection")),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(N,"close"))}))}constructor(f){super(r.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$hh=r;function a(g){return new Promise((f,k)=>{const N=(0,T.createServer)();N.on("error",k),N.listen(g,()=>{N.removeListener("error",k),f(new r(N))})})}e.$ih=a;function w(g,f){return new Promise((k,N)=>{const M=(0,T.createConnection)(g,()=>{M.removeListener("error",N),k($.$_g.fromSocket(new v(M,`ipc-client${f}`),f))});M.once("error",N)})}e.$jh=w}),define(oe[262],ae([0,1,60,261,206]),function(te,e,I,T,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$65b=void 0,e.$65b=new class{supports(j){return!0}connect({host:j,port:L},R,S,b){return new Promise((P,E)=>{const m=I.createConnection({host:j,port:L},()=>{m.removeListener("error",E),m.write((0,D.$Pib)(R,S,b));const h=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",h),P(new T.$ch(m,b)))};m.on("data",h)});m.setNoDelay(!0),m.once("error",E)})}}}),define(oe[270],ae([0,1,36,38,7,2,26,10,43,143,200,201,192,193,257,183,185,18,205,95,215,96,211,15,113,242,29,97,184,121,98,13,195,196,66,4,191,68,70,220,8,197,102,24,57,19,107,20,108,109,110,46,223,78,111,23,76,248,234,235,79,249,252,253,254,58,247,236,106,214,74,225,210,224,28,226,5,227,186,203,202,77,241,17,50,199,56,246,222,237,105,251,260,9,198,101,244,240,212,180,55,255,243,69,245,104,262,178]),function(te,e,I,T,D,j,L,R,S,b,P,E,m,h,$,v,c,l,u,y,p,C,t,o,n,s,i,r,a,w,g,f,k,N,M,F,W,q,J,Q,Y,Z,x,H,B,V,ee,ne,ce,re,A,d,O,z,G,U,X,_,se,he,ue,me,pe,ke,Re,Oe,ze,Je,le,de,$e,Se,Pe,Me,Le,Ue,De,Ae,Fe,ie,fe,ge,ye,we,Ee,Ce,Ie,je,Be,Te,qe,We,_e,nt,St,gt,Pt,Rt,Ct,It,Lt,Ot,jt,mt,Dt,bt,At,Nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Tt extends j.$lb{constructor(ve){super(),this.c=ve,this.a=this.B(new b.$wS),this.b=void 0,this.f()}f(){let ve=!1;const Ne=()=>{ve||(ve=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ne),(0,b.$xS)(process.parentPort,"vscode:electron-main->shared-process=exit",Ne)}async init(){const ve=await this.g();(0,U.$Meb)(),ve.invokeFunction(Ne=>{const Ke=Ne.get(Y.$Pi);Ke.trace("sharedProcess configuration",JSON.stringify(this.c)),this.h(Ne),this.i(Ke)}),this.B((0,j.$ib)(ve.createInstance(P.$s5b,this.c.codeCachePath),ve.createInstance(E.$t5b),ve.createInstance($.$w5b),ve.createInstance(h.$v5b),ve.createInstance(m.$u5b),ve.createInstance(_e.$W5b),ve.createInstance(Te.$O5b)))}async g(){const ve=new q.$lh,Ne={_serviceBrand:void 0,...x.default};ve.set(H.$8i,Ne);const Ke=new S.$8g(He=>He==="main"),Ge=new mt.$94b(this.a,Ke);ve.set(mt.$84b,Ge);const at=this.c.policiesData?new Ce.$I4b(this.c.policiesData,Ge.getChannel("policy")):new Ie.$Vm;ve.set(Ie.$Tm,at);const Ze=new Nt.$Vl(this.c.args,Ne);ve.set(o.$vh,Ze);const et=new Z.$Lq(void 0,this.c.logLevel,Ze.logsHome,this.c.loggers.map(He=>({...He,resource:R.URI.revive(He.resource)})),Ge.getChannel("logger"));ve.set(Y.$Qi,et);const ct=this.B(et.createLogger("sharedprocess",{name:(0,nt.localize)(0,null)})),ut=this.B(new Y.$Xi(ct.getLevel())),Xe=this.B(new St.$WM(ct,[ut]));ve.set(Y.$Pi,Xe),this.b=this.B(new gt.$Y5b(Xe)),ve.set(gt.$X5b,this.b);const Qe=this.B(new k.$qp(Xe));ve.set(f.$Qj,Qe);const ft=this.B(new N.$Pp(Xe));Qe.registerProvider(L.Schemas.file,ft);const dt=this.B(new Ae.$74b(L.Schemas.file,this.B(new Fe.$FM(Ge.getChannel(Fe.$EM),{pathCaseSensitive:De.$k})),L.Schemas.vscodeUserData,Xe));Qe.registerProvider(L.Schemas.vscodeUserData,dt);const tt=this.B(new je.$4M(this.c.profiles.all,R.URI.revive(this.c.profiles.home).with({scheme:Ze.userRoamingDataHome.scheme}),Ge.getChannel("userDataProfiles")));ve.set(we.$pk,tt);const xe=this.B(new u.$jn(tt.defaultProfile.settingsResource,Qe,at,Xe));ve.set(l.$Th,xe);const st=new Dt.$55b(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Ge,Ze);ve.set(V.$Io,st),this.B((0,j.$jb)(()=>st.flush())),await Promise.all([xe.initialize(),st.initialize()]);const Mt=new Ue.$ar(Qe);ve.set(Le.$nk,Mt);const yt=new Ct.$zq(Ge.getChannel("request"));ve.set(B.$wo,yt),ve.set(v.$x5b,new M.$kh(c.$y5b,void 0,!1)),ve.set(fe.$iF,new M.$kh(ie.$N5b,void 0,!1));const pt=S.ProxyChannel.toService(Ge.getChannel("nativeHost"));ve.set(Lt.$T3b,pt),ve.set(C.$sn,new M.$kh(t.$_M,void 0,!0));const Ft=this.B(new Je.$E4b(pt)),zt=new S.$8g(He=>Ft.getActiveClientId().then(ht=>He===ht));ve.set(g.$RSb,new It.$15b(this.a.getChannel("extensionRecommendationNotification",zt)));let lt;const rt=[],vt=(0,d.$ao)(Ne,xe);if((0,d.$8n)(Ne,Ze)){const He=new re.$P1b(Xe,et,Ze,Ne);if(rt.push(He),Ne.aiConfig?.ariaKey){const ht=new Be.$KM(yt,vt,"monacoworkbench",null,Ne.aiConfig.ariaKey);this.B((0,j.$jb)(()=>ht.flush())),rt.push(ht)}lt=new A.$Dq({appenders:rt,commonProperties:(0,ee.$Xn)((0,I.release)(),(0,I.hostname)(),process.arch,Ne.commit,Ne.version,this.c.machineId,vt),sendErrorTelemetry:!0,piiPaths:(0,d.$bo)(Ze)},xe,Ne)}else{lt=d.$2n;const He=d.$6n;rt.push(He)}this.a.registerChannel("telemetryAppender",new ce.$i4b(rt)),ve.set(ne.$Tk,lt);const Ut=new O.$z5b(xe,lt,Xe,et,Ze,Ne);ve.set(ne.$Uk,Ut),ve.set(Ee.$0o,new M.$kh(Rt.$VM,void 0,!0)),ve.set(ge.$bp,new M.$kh(ye.$J4b,void 0,!0)),ve.set(r.$To,new M.$kh(r.$Uo,void 0,!0)),ve.set(w.$lp,new M.$kh(w.$mp,void 0,!0)),ve.set(i.$Nn,new M.$kh(s.$Ro,void 0,!0)),ve.set(i.$Tn,new M.$kh(jt.$45b,void 0,!1)),ve.set(J.$vq,new M.$kh(Q.$xq,void 0,!1)),ve.set(y.$3l,new M.$kh(p.$hr,void 0,!1)),ve.set(X.$nxb,new M.$kh(X.$oxb,void 0,!0)),ve.set(U.$8eb,new M.$kh(he.$vzb,void 0,!0)),ve.set(U.$7eb,new se.$C5b(this.a.getChannel("userDataSyncUtil",He=>He.ctx!=="main"))),ve.set(i.$Sn,new M.$kh(n.$lxb,void 0,!1)),ve.set(G.$tzb,new M.$kh(G.$uzb,void 0,!0)),ve.set(z.$Az,new M.$kh(z.$Bz)),ve.set(U.$Reb,new M.$kh(Re.$Eyb,void 0,!0)),ve.set(U.$Seb,new M.$kh(Re.$Gyb,void 0,!0)),ve.set(ue.$sXb,new M.$kh(ue.$uXb,void 0,!0)),ve.set(U.$Teb,new M.$kh(_.$r2b,void 0,!1)),ve.set(U.$3eb,new M.$kh(me.$g2b,void 0,!0)),ve.set(U.$4eb,new M.$kh(pe.$w2b,void 0,!1)),ve.set(Oe.$Zxb,new M.$kh(ze.$J5b,void 0,!0)),ve.set(U.$5eb,new M.$kh(We.$92b,void 0,!0)),ve.set(le.$Hk,new M.$kh(de.$44b,void 0,!1));const Et=new bt.$Fk;return ve.set(bt.$Ek,Et),Et.register(0,At.$65b),ve.set($e.$Ez,new M.$kh(Se.$24b)),ve.set(Pe.$K5b,new M.$kh(Me.$M5b)),ve.set(qe.$P5b,new M.$kh(Pt.$Z5b)),new W.$Sp(ve)}h(ve){const Ne=new a.$Wo(ve.get(i.$Pn),()=>null);this.a.registerChannel("extensions",Ne);const Ke=S.ProxyChannel.fromService(ve.get(J.$vq));this.a.registerChannel("languagePacks",Ke);const Ge=S.ProxyChannel.fromService(ve.get(y.$3l));this.a.registerChannel("diagnostics",Ge);const at=new a.$Yo(ve.get(i.$Tn));this.a.registerChannel("extensionTipsService",at);const Ze=S.ProxyChannel.fromService(ve.get(v.$x5b));this.a.registerChannel("checksum",Ze);const et=S.ProxyChannel.fromService(ve.get(fe.$iF));this.a.registerChannel("v8InspectProfiling",et);const ct=new se.$D5b(ve.get(ue.$sXb));this.a.registerChannel("userDataSyncMachines",ct);const ut=S.ProxyChannel.fromService(ve.get(ne.$Uk));this.a.registerChannel("customEndpointTelemetry",ut);const Xe=new se.$E5b(ve.get(X.$nxb));this.a.registerChannel("userDataSyncAccount",Xe);const Qe=new se.$F5b(ve.get(U.$Reb));this.a.registerChannel("userDataSyncStoreManagement",Qe);const ft=new ke.$H5b(ve.get(U.$4eb),ve.get(we.$pk),ve.get(Y.$Pi));this.a.registerChannel("userDataSync",ft);const dt=this.B(ve.get(F.$mh).createInstance(Ot.$35b)),tt=new se.$A5b(dt);this.a.registerChannel("userDataAutoSync",tt);const xe=S.ProxyChannel.fromService(ve.get(Pe.$K5b));this.a.registerChannel(Pe.$L5b,xe);const st=S.ProxyChannel.fromService(ve.get(qe.$P5b));this.a.registerChannel("remoteTunnel",st)}i(ve){process.on("uncaughtException",Ne=>(0,D.$Y)(Ne)),process.on("unhandledRejection",Ne=>(0,D.$Y)(Ne)),(0,D.setUnexpectedErrorHandler)(Ne=>{const Ke=(0,T.$$h)(Ne,!0);Ke&&ve.error(`[uncaught exception in sharedProcess]: ${Ke}`)})}}async function wt(ot){const ve=new Tt(ot);process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"),await ve.init(),process.parentPort.postMessage("vscode:shared-process->electron-main=init-done")}e.main=wt,process.parentPort.once("message",ot=>{wt(ot.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c3e3dba23e8fadc360aed75ce363ba185c49794/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
