/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/base/common/event","vs/base/common/lifecycle","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/platform/log/common/log","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/uuid","vs/editor/common/core/range","vs/base/common/glob","vs/workbench/services/search/common/search","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/process","vs/platform/registry/common/platform","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/errorMessage","child_process","vs/platform/contextkey/common/contextkey","vs/base/common/iterator","fs","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/htmlContent","os","vs/base/parts/ipc/common/ipc","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/base/common/mime","vs/base/common/processes","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","net","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/labels","vs/base/common/uriIpc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Ce=function(me){for(var e=[],k=0,F=me.length;k<F;k++)e[k]=De[me[k]];return e};define(De[150],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class k{static get(){const h=new Map,L=new Map,A=new Map,m=new Map;function E(S,D){S.has(D.detail)||S.set(D.detail,-D.timestamp)}function b(S,D){const p=S.get(D.detail);p&&(p>=0||S.set(D.detail,p+D.timestamp))}let R=[];typeof me=="function"&&typeof me.getStats=="function"&&(R=me.getStats().slice(0).sort((S,D)=>S.timestamp-D.timestamp));for(const S of R)switch(S.type){case 10:E(h,S);break;case 11:case 12:b(h,S);break;case 21:E(L,S);break;case 22:b(L,S);break;case 33:E(A,S);break;case 34:b(A,S);break;case 31:E(m,S);break;case 32:b(m,S);break}let I=0;A.forEach(S=>I+=S);function $(S){const D=[];return S.forEach((p,r)=>D.push([r,p])),D}return{amdLoad:$(h),amdInvoke:$(L),nodeRequire:$(A),nodeEval:$(m),nodeRequireTotal:I}}static toMarkdownTable(h,L){let A="";const m=[];return h.forEach((E,b)=>{m[b]=E.length}),L.forEach(E=>{E.forEach((b,R)=>{typeof b>"u"&&(b=E[R]="-");const I=b.toString().length;m[R]=Math.max(I,m[R])})}),h.forEach((E,b)=>{A+=`| ${E+" ".repeat(m[b]-E.toString().length)} `}),A+=`|
`,h.forEach((E,b)=>{A+=`| ${"-".repeat(m[b])} `}),A+=`|
`,L.forEach(E=>{E.forEach((b,R)=>{typeof b<"u"&&(A+=`| ${b+" ".repeat(m[R]-b.toString().length)} `)}),A+=`|
`}),A}}e.$S=k}),define(De[65],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function k(A,m){const E=Object.create(null);for(const b of A){const R=m(b);let I=E[R];I||(I=E[R]=[]),I.push(b)}return E}e.$I=k;function F(A,m){const E=[],b=[];for(const R of A)m.has(R)||E.push(R);for(const R of m)A.has(R)||b.push(R);return{removed:E,added:b}}e.$J=F;function h(A,m){const E=[],b=[];for(const[R,I]of A)m.has(R)||E.push(I);for(const[R,I]of m)A.has(R)||b.push(I);return{removed:E,added:b}}e.$K=h;class L{constructor(){this.a=new Map}add(m,E){let b=this.a.get(m);b||(b=new Set,this.a.set(m,b)),b.add(E)}delete(m,E){const b=this.a.get(m);b&&(b.delete(E),b.size===0&&this.a.delete(m))}forEach(m,E){const b=this.a.get(m);b&&b.forEach(E)}get(m){const E=this.a.get(m);return E?new Set(E):new Set}}e.$L=L}),define(De[66],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=e.$Sg=e.$Rg=void 0;function k(A){return(m,E,b)=>{let R=null,I=null;if(typeof b.value=="function"?(R="value",I=b.value):typeof b.get=="function"&&(R="get",I=b.get),!I)throw new Error("not supported");b[R]=A(I,E)}}function F(A,m,E){let b=null,R=null;if(typeof E.value=="function"?(b="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(b="get",R=E.get),!R)throw new Error("not supported");const I=`$memoize$${m}`;E[b]=function(...$){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,$)}),this[I]}}e.$Rg=F;function h(A,m,E){return k((b,R)=>{const I=`$debounce$${R}`,$=`$debounce$result$${R}`;return function(...S){this[$]||(this[$]=E?E():void 0),clearTimeout(this[I]),m&&(this[$]=m(this[$],...S),S=[this[$]]),this[I]=setTimeout(()=>{b.apply(this,S),this[$]=E?E():void 0},A)}})}e.$Sg=h;function L(A,m,E){return k((b,R)=>{const I=`$throttle$timer$${R}`,$=`$throttle$result$${R}`,S=`$throttle$lastRun$${R}`,D=`$throttle$pending$${R}`;return function(...p){if(this[$]||(this[$]=E?E():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),m&&(this[$]=m(this[$],...p)),this[D])return;const r=this[S]+A;r<=Date.now()?(this[S]=Date.now(),b.apply(this,[this[$]]),this[$]=E?E():void 0):(this[D]=!0,this[I]=setTimeout(()=>{this[D]=!1,this[S]=Date.now(),b.apply(this,[this[$]]),this[$]=E?E():void 0},r-Date.now()))}})}e.$Tg=L}),define(De[8],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.$X=e.setUnexpectedErrorHandler=e.$V=e.$U=void 0;class k{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?y.isErrorNoTelemetry(a)?new y(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(n=>{n(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.$U=k,e.$V=new k;function F(i){e.$V.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=F;function h(i){if(!i||typeof i!="object")return!1;const a=i;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.$X=h;function L(i){b(i)||e.$V.onUnexpectedError(i)}e.$Y=L;function A(i){b(i)||e.$V.onUnexpectedExternalError(i)}e.$Z=A;function m(i){if(i instanceof Error){const{name:a,message:n}=i,t=i.stacktrace||i.stack;return{$isError:!0,name:a,message:n,stack:t,noTelemetry:y.isErrorNoTelemetry(i)}}return i}e.$1=m;const E="Canceled";function b(i){return i instanceof R?!0:i instanceof Error&&i.name===E&&i.message===E}e.$2=b;class R extends Error{constructor(){super(E),this.name=this.message}}e.$3=R;function I(){const i=new Error(E);return i.name=i.message,i}e.$4=I;function $(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.$5=$;function S(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.$6=S;function D(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.$7=D;function p(i){const a=new Error(`${i} has been disposed`);return a.name="DISPOSED",a}e.$8=p;function r(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.$9=r;class s extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.$0=s;class c extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.$$=c;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=f;class y extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof y)return a;const n=new y;return n.message=a.message,n.stack=a.stack,n}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.$ab=y;class C extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,C.prototype)}}e.$bb=C}),define(De[19],Ce([1,0,8]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.CompareResult=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.top=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=void 0;function F(ne,ee=0){return ne[ne.length-(1+ee)]}e.$$e=F;function h(ne){if(ne.length===0)throw new Error("Invalid tail call");return[ne.slice(0,ne.length-1),ne[ne.length-1]]}e.$_e=h;function L(ne,ee,he=(X,ue)=>X===ue){if(ne===ee)return!0;if(!ne||!ee||ne.length!==ee.length)return!1;for(let X=0,ue=ne.length;X<ue;X++)if(!he(ne[X],ee[X]))return!1;return!0}e.$af=L;function A(ne,ee){const he=ne.length-1;ee<he&&(ne[ee]=ne[he]),ne.pop()}e.$bf=A;function m(ne,ee,he){return E(ne.length,X=>he(ne[X],ee))}e.$cf=m;function E(ne,ee){let he=0,X=ne-1;for(;he<=X;){const ue=(he+X)/2|0,oe=ee(ue);if(oe<0)he=ue+1;else if(oe>0)X=ue-1;else return ue}return-(he+1)}e.$df=E;function b(ne,ee){let he=0,X=ne.length;if(X===0)return 0;for(;he<X;){const ue=Math.floor((he+X)/2);ee(ne[ue])?X=ue:he=ue+1}return he}e.$ef=b;function R(ne,ee,he){if(ne=ne|0,ne>=ee.length)throw new TypeError("invalid index");const X=ee[Math.floor(ee.length*Math.random())],ue=[],oe=[],le=[];for(const we of ee){const O=he(we,X);O<0?ue.push(we):O>0?oe.push(we):le.push(we)}return ne<ue.length?R(ne,ue,he):ne<ue.length+le.length?le[0]:R(ne-(ue.length+le.length),oe,he)}e.$ff=R;function I(ne,ee){const he=[];let X;for(const ue of ne.slice(0).sort(ee))!X||ee(X[0],ue)!==0?(X=[ue],he.push(X)):X.push(ue);return he}e.$gf=I;function $(ne,ee,he){const X=[];function ue(we,O,K){if(O===0&&K.length===0)return;const G=X[X.length-1];G&&G.start+G.deleteCount===we?(G.deleteCount+=O,G.toInsert.push(...K)):X.push({start:we,deleteCount:O,toInsert:K})}let oe=0,le=0;for(;;){if(oe===ne.length){ue(oe,0,ee.slice(le));break}if(le===ee.length){ue(oe,ne.length-oe,[]);break}const we=ne[oe],O=ee[le],K=he(we,O);K===0?(oe+=1,le+=1):K<0?(ue(oe,1,[]),oe+=1):K>0&&(ue(oe,0,[O]),le+=1)}return X}e.$hf=$;function S(ne,ee,he){const X=$(ne,ee,he),ue=[],oe=[];for(const le of X)ue.push(...ne.slice(le.start,le.start+le.deleteCount)),oe.push(...le.toInsert);return{removed:ue,added:oe}}e.$if=S;function D(ne,ee,he){if(he===0)return[];const X=ne.slice(0,he).sort(ee);return r(ne,ee,X,he,ne.length),X}e.top=D;function p(ne,ee,he,X,ue){return he===0?Promise.resolve([]):new Promise((oe,le)=>{(async()=>{const we=ne.length,O=ne.slice(0,he).sort(ee);for(let K=he,G=Math.min(he+X,we);K<we;K=G,G=Math.min(G+X,we)){if(K>he&&await new Promise(x=>setTimeout(x)),ue&&ue.isCancellationRequested)throw new k.$3;r(ne,ee,O,K,G)}return O})().then(oe,le)})}e.$kf=p;function r(ne,ee,he,X,ue){for(const oe=he.length;X<ue;X++){const le=ne[X];if(ee(le,he[oe-1])<0){he.pop();const we=b(he,O=>ee(le,O)<0);he.splice(we,0,le)}}}function s(ne){return ne.filter(ee=>!!ee)}e.$lf=s;function c(ne){let ee=0;for(let he=0;he<ne.length;he++)ne[he]&&(ne[ee]=ne[he],ee+=1);ne.length=ee}e.$mf=c;function f(ne,ee,he){ne.splice(he,0,ne.splice(ee,1)[0])}e.$nf=f;function y(ne){return!Array.isArray(ne)||ne.length===0}e.$of=y;function C(ne){return Array.isArray(ne)&&ne.length>0}e.$pf=C;function i(ne,ee=he=>he){const he=new Set;return ne.filter(X=>{const ue=ee(X);return he.has(ue)?!1:(he.add(ue),!0)})}e.$qf=i;function a(ne){const ee=new Set;return he=>{const X=ne(he);return ee.has(X)?!1:(ee.add(X),!0)}}e.$rf=a;function n(ne,ee){const he=t(ne,ee);if(he!==-1)return ne[he]}e.$sf=n;function t(ne,ee){for(let he=ne.length-1;he>=0;he--){const X=ne[he];if(ee(X))return he}return-1}e.$tf=t;function o(ne,ee){return ne.length>0?ne[0]:ee}e.$uf=o;function g(ne,ee){return ne.length>0?ne[ne.length-1]:ee}e.$vf=g;function u(ne,ee,he=(X,ue)=>X===ue){let X=0;for(let ue=0,oe=Math.min(ne.length,ee.length);ue<oe&&he(ne[ue],ee[ue]);ue++)X++;return X}e.$wf=u;function d(ne){return[].concat(...ne)}e.$xf=d;function v(ne,ee){let he=typeof ee=="number"?ne:0;typeof ee=="number"?he=ne:(he=0,ee=ne);const X=[];if(he<=ee)for(let ue=he;ue<ee;ue++)X.push(ue);else for(let ue=he;ue>ee;ue--)X.push(ue);return X}e.$yf=v;function l(ne,ee,he){return ne.reduce((X,ue)=>(X[ee(ue)]=he?he(ue):ue,X),Object.create(null))}e.$zf=l;function w(ne,ee){return ne.push(ee),()=>P(ne,ee)}e.$Af=w;function P(ne,ee){const he=ne.indexOf(ee);if(he>-1)return ne.splice(he,1),ee}e.$Bf=P;function M(ne,ee,he){const X=ne.slice(0,ee),ue=ne.slice(ee);return X.concat(he,ue)}e.$Cf=M;function N(ne,ee){let he;if(typeof ee=="number"){let X=ee;he=()=>{const ue=Math.sin(X++)*179426549;return ue-Math.floor(ue)}}else he=Math.random;for(let X=ne.length-1;X>0;X-=1){const ue=Math.floor(he()*(X+1)),oe=ne[X];ne[X]=ne[ue],ne[ue]=oe}}e.$Df=N;function T(ne,ee){const he=ne.indexOf(ee);he>-1&&(ne.splice(he,1),ne.unshift(ee))}e.$Ef=T;function z(ne,ee){const he=ne.indexOf(ee);he>-1&&(ne.splice(he,1),ne.push(ee))}e.$Ff=z;function j(ne,ee){for(const he of ee)ne.push(he)}e.$Gf=j;function U(ne,ee){return Array.isArray(ne)?ne.map(ee):ee(ne)}e.$Hf=U;function Y(ne){return Array.isArray(ne)?ne:[ne]}e.$If=Y;function H(ne){return ne[Math.floor(Math.random()*ne.length)]}e.$Jf=H;function ge(ne,ee){for(const he of ne){const X=ee(he);if(X!==void 0)return X}}e.$Kf=ge;function ie(ne,ee,he){const X=q(ne,ee),ue=ne.length,oe=he.length;ne.length=ue+oe;for(let le=ue-1;le>=X;le--)ne[le+oe]=ne[le];for(let le=0;le<oe;le++)ne[le+X]=he[le]}e.$Lf=ie;function te(ne,ee,he,X){const ue=q(ne,ee),oe=ne.splice(ue,he);return ie(ne,ue,X),oe}e.$Mf=te;function q(ne,ee){return ee<0?Math.max(ee+ne.length,0):Math.min(ee,ne.length)}var V;(function(ne){function ee(ue){return ue<0}ne.isLessThan=ee;function he(ue){return ue>0}ne.isGreaterThan=he;function X(ue){return ue===0}ne.isNeitherLessOrGreaterThan=X,ne.greaterThan=1,ne.lessThan=-1,ne.neitherLessOrGreaterThan=0})(V||(e.CompareResult=V={}));function ce(ne,ee){return(he,X)=>ee(ne(he),ne(X))}e.$Nf=ce;function re(...ne){return(ee,he)=>{for(const X of ne){const ue=X(ee,he);if(!V.isNeitherLessOrGreaterThan(ue))return ue}return V.neitherLessOrGreaterThan}}e.$Of=re;const fe=(ne,ee)=>ne-ee;e.$Pf=fe;function de(ne,ee){if(ne.length===0)return;let he=ne[0];for(let X=1;X<ne.length;X++){const ue=ne[X];ee(ue,he)>0&&(he=ue)}return he}e.$Qf=de;function B(ne,ee){if(ne.length===0)return;let he=ne[0];for(let X=1;X<ne.length;X++){const ue=ne[X];ee(ue,he)>=0&&(he=ue)}return he}e.$Rf=B;function _(ne,ee){return de(ne,(he,X)=>-ee(he,X))}e.$Sf=_;class Ee{constructor(ee){this.f=ee,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ee){let he=this.c;for(;he<this.f.length&&ee(this.f[he]);)he++;const X=he===this.c?null:this.f.slice(this.c,he);return this.c=he,X}takeFromEndWhile(ee){let he=this.d;for(;he>=0&&ee(this.f[he]);)he--;const X=he===this.d?null:this.f.slice(he+1,this.d+1);return this.d=he,X}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ee=this.f[this.c];return this.c++,ee}removeLast(){const ee=this.f[this.d];return this.d--,ee}takeCount(ee){const he=this.f.slice(this.c,this.c+ee);return this.c+=ee,he}}e.$Tf=Ee;class Re{static{this.empty=new Re(ee=>{})}constructor(ee){this.iterate=ee}forEach(ee){this.iterate(he=>(ee(he),!0))}toArray(){const ee=[];return this.iterate(he=>(ee.push(he),!0)),ee}filter(ee){return new Re(he=>this.iterate(X=>ee(X)?he(X):!0))}map(ee){return new Re(he=>this.iterate(X=>he(ee(X))))}some(ee){let he=!1;return this.iterate(X=>(he=ee(X),!he)),he}findFirst(ee){let he;return this.iterate(X=>ee(X)?(he=X,!1):!0),he}findLast(ee){let he;return this.iterate(X=>(ee(X)&&(he=X),!0)),he}findLastMaxBy(ee){let he,X=!0;return this.iterate(ue=>((X||V.isGreaterThan(ee(ue,he)))&&(X=!1,he=ue),!0)),he}}e.$Uf=Re}),define(De[53],Ce([1,0,8]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qc=e.$pc=e.$oc=e.$nc=e.ok=void 0;function F(E,b){if(!E)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=F;function h(E,b="Unreachable"){throw new Error(b)}e.$nc=h;function L(E){if(!E)throw new k.$bb("Assertion Failed")}e.$oc=L;function A(E){if(!E()){debugger;E(),(0,k.$Y)(new k.$bb("Assertion Failed"))}}e.$pc=A;function m(E,b){let R=0;for(;R<E.length-1;){const I=E[R],$=E[R+1];if(!b(I,$))return!1;R++}return!0}e.$qc=m}),define(De[67],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function k(F){const h=this;let L=!1,A;return function(){return L||(L=!0,A=F.apply(h,arguments)),A}}e.$cb=k}),define(De[111],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.$EL=void 0;class k{constructor(h){this.a=h,this.b=0}nextId(){return this.a+ ++this.b}}e.$EL=k,e.$FL=new k("id#")}),define(De[48],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var k;(function(F){function h(y){return y&&typeof y=="object"&&typeof y[Symbol.iterator]=="function"}F.is=h;const L=Object.freeze([]);function A(){return L}F.empty=A;function*m(y){yield y}F.single=m;function E(y){return h(y)?y:m(y)}F.wrap=E;function b(y){return y||L}F.from=b;function R(y){return!y||y[Symbol.iterator]().next().done===!0}F.isEmpty=R;function I(y){return y[Symbol.iterator]().next().value}F.first=I;function $(y,C){for(const i of y)if(C(i))return!0;return!1}F.some=$;function S(y,C){for(const i of y)if(C(i))return i}F.find=S;function*D(y,C){for(const i of y)C(i)&&(yield i)}F.filter=D;function*p(y,C){let i=0;for(const a of y)yield C(a,i++)}F.map=p;function*r(...y){for(const C of y)for(const i of C)yield i}F.concat=r;function s(y,C,i){let a=i;for(const n of y)a=C(a,n);return a}F.reduce=s;function*c(y,C,i=y.length){for(C<0&&(C+=y.length),i<0?i+=y.length:i>y.length&&(i=y.length);C<i;C++)yield y[C]}F.slice=c;function f(y,C=Number.POSITIVE_INFINITY){const i=[];if(C===0)return[i,y];const a=y[Symbol.iterator]();for(let n=0;n<C;n++){const t=a.next();if(t.done)return[i,F.empty()];i.push(t.value)}return[i,{[Symbol.iterator](){return a}}]}F.consume=f})(k||(e.Iterable=k={}))}),define(De[151],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var k;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(k||(e.ScanError=k={}));var F;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(F||(e.SyntaxKind=F={}));var h;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(h||(e.ParseErrorCode=h={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(i,a=!1){let n=0;const t=i.length;let o="",g=0,u=16,d=0;function v(z){let j=0,U=0;for(;j<z;){const Y=i.charCodeAt(n);if(Y>=48&&Y<=57)U=U*16+Y-48;else if(Y>=65&&Y<=70)U=U*16+Y-65+10;else if(Y>=97&&Y<=102)U=U*16+Y-97+10;else break;n++,j++}return j<z&&(U=-1),U}function l(z){n=z,o="",g=0,u=16,d=0}function w(){const z=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&b(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&b(i.charCodeAt(n)))for(n++;n<i.length&&b(i.charCodeAt(n));)n++;else return d=3,i.substring(z,n);let j=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&b(i.charCodeAt(n))){for(n++;n<i.length&&b(i.charCodeAt(n));)n++;j=n}else d=3;return i.substring(z,j)}function P(){let z="",j=n;for(;;){if(n>=t){z+=i.substring(j,n),d=2;break}const U=i.charCodeAt(n);if(U===34){z+=i.substring(j,n),n++;break}if(U===92){if(z+=i.substring(j,n),n++,n>=t){d=2;break}switch(i.charCodeAt(n++)){case 34:z+='"';break;case 92:z+="\\";break;case 47:z+="/";break;case 98:z+="\b";break;case 102:z+="\f";break;case 110:z+=`
`;break;case 114:z+="\r";break;case 116:z+="	";break;case 117:{const H=v(4);H>=0?z+=String.fromCharCode(H):d=4;break}default:d=5}j=n;continue}if(U>=0&&U<=31)if(E(U)){z+=i.substring(j,n),d=2;break}else d=6;n++}return z}function M(){if(o="",d=0,g=n,n>=t)return g=t,u=17;let z=i.charCodeAt(n);if(m(z)){do n++,o+=String.fromCharCode(z),z=i.charCodeAt(n);while(m(z));return u=15}if(E(z))return n++,o+=String.fromCharCode(z),z===13&&i.charCodeAt(n)===10&&(n++,o+=`
`),u=14;switch(z){case 123:return n++,u=1;case 125:return n++,u=2;case 91:return n++,u=3;case 93:return n++,u=4;case 58:return n++,u=6;case 44:return n++,u=5;case 34:return n++,o=P(),u=10;case 47:{const j=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<t&&!E(i.charCodeAt(n));)n++;return o=i.substring(j,n),u=12}if(i.charCodeAt(n+1)===42){n+=2;const U=t-1;let Y=!1;for(;n<U;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,Y=!0;break}n++}return Y||(n++,d=1),o=i.substring(j,n),u=13}return o+=String.fromCharCode(z),n++,u=16}case 45:if(o+=String.fromCharCode(z),n++,n===t||!b(i.charCodeAt(n)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=w(),u=11;default:for(;n<t&&N(z);)n++,z=i.charCodeAt(n);if(g!==n){switch(o=i.substring(g,n),o){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return o+=String.fromCharCode(z),n++,u=16}}function N(z){if(m(z)||E(z))return!1;switch(z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let z;do z=M();while(z>=12&&z<=15);return z}return{setPosition:l,getPosition:()=>n,scan:a?T:M,getToken:()=>u,getTokenValue:()=>o,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>d}}e.$tm=A;function m(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function E(i){return i===10||i===13||i===8232||i===8233}function b(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function I(i,a){const n=[],t=new Object;let o;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function d(v,l,w,P){g.value=v,g.offset=l,g.length=w,g.type=P,g.colonOffset=void 0,o=g}try{f(i,{onObjectBegin:(v,l)=>{if(a<=v)throw t;o=void 0,u=a>v,n.push("")},onObjectProperty:(v,l,w)=>{if(a<l||(d(v,l,w,"property"),n[n.length-1]=v,a<=l+w))throw t},onObjectEnd:(v,l)=>{if(a<=v)throw t;o=void 0,n.pop()},onArrayBegin:(v,l)=>{if(a<=v)throw t;o=void 0,n.push(0)},onArrayEnd:(v,l)=>{if(a<=v)throw t;o=void 0,n.pop()},onLiteralValue:(v,l,w)=>{if(a<l||(d(v,l,w,C(v)),a<=l+w))throw t},onSeparator:(v,l,w)=>{if(a<=l)throw t;if(v===":"&&o&&o.type==="property")o.colonOffset=l,u=!1,o=void 0;else if(v===","){const P=n[n.length-1];typeof P=="number"?n[n.length-1]=P+1:(u=!0,n[n.length-1]=""),o=void 0}}})}catch(v){if(v!==t)throw v}return{path:n,previousNode:o,isAtPropertyKey:u,matches:v=>{let l=0;for(let w=0;l<v.length&&w<n.length;w++)if(v[l]===n[w]||v[l]==="*")l++;else if(v[l]!=="**")return!1;return l===v.length}}}e.$um=I;function $(i,a=[],n=L.DEFAULT){let t=null,o=[];const g=[];function u(v){Array.isArray(o)?o.push(v):t!==null&&(o[t]=v)}return f(i,{onObjectBegin:()=>{const v={};u(v),g.push(o),o=v,t=null},onObjectProperty:v=>{t=v},onObjectEnd:()=>{o=g.pop()},onArrayBegin:()=>{const v=[];u(v),g.push(o),o=v,t=null},onArrayEnd:()=>{o=g.pop()},onLiteralValue:u,onError:(v,l,w)=>{a.push({error:v,offset:l,length:w})}},n),o[0]}e.$vm=$;function S(i,a=[],n=L.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(v){t.type==="property"&&(t.length=v-t.offset,t=t.parent)}function g(v){return t.children.push(v),v}f(i,{onObjectBegin:v=>{t=g({type:"object",offset:v,length:-1,parent:t,children:[]})},onObjectProperty:(v,l,w)=>{t=g({type:"property",offset:l,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:v,offset:l,length:w,parent:t})},onObjectEnd:(v,l)=>{t.length=v+l-t.offset,t=t.parent,o(v+l)},onArrayBegin:(v,l)=>{t=g({type:"array",offset:v,length:-1,parent:t,children:[]})},onArrayEnd:(v,l)=>{t.length=v+l-t.offset,t=t.parent,o(v+l)},onLiteralValue:(v,l,w)=>{g({type:C(v),offset:l,length:w,parent:t,value:v}),o(l+w)},onSeparator:(v,l,w)=>{t.type==="property"&&(v===":"?t.colonOffset=l:v===","&&o(l))},onError:(v,l,w)=>{a.push({error:v,offset:l,length:w})}},n);const d=t.children[0];return d&&delete d.parent,d}e.$wm=S;function D(i,a){if(!i)return;let n=i;for(const t of a)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===t){n=g.children[1],o=!0;break}if(!o)return}else{const o=t;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.$xm=D;function p(i){if(!i.parent||!i.parent.children)return[];const a=p(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;a.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&a.push(n)}return a}e.$ym=p;function r(i){switch(i.type){case"array":return i.children.map(r);case"object":{const a=Object.create(null);for(const n of i.children){const t=n.children[1];t&&(a[n.children[0].value]=r(t))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$zm=r;function s(i,a,n=!1){return a>=i.offset&&a<i.offset+i.length||n&&a===i.offset+i.length}e.$Am=s;function c(i,a,n=!1){if(s(i,a,n)){const t=i.children;if(Array.isArray(t))for(let o=0;o<t.length&&t[o].offset<=a;o++){const g=c(t[o],a,n);if(g)return g}return i}}e.$Bm=c;function f(i,a,n=L.DEFAULT){const t=A(i,!1);function o(ce){return ce?()=>ce(t.getTokenOffset(),t.getTokenLength()):()=>!0}function g(ce){return ce?re=>ce(re,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=o(a.onObjectBegin),d=g(a.onObjectProperty),v=o(a.onObjectEnd),l=o(a.onArrayBegin),w=o(a.onArrayEnd),P=g(a.onLiteralValue),M=g(a.onSeparator),N=o(a.onComment),T=g(a.onError),z=n&&n.disallowComments,j=n&&n.allowTrailingComma;function U(){for(;;){const ce=t.scan();switch(t.getTokenError()){case 4:Y(14);break;case 5:Y(15);break;case 3:Y(13);break;case 1:z||Y(11);break;case 2:Y(12);break;case 6:Y(16);break}switch(ce){case 12:case 13:z?Y(10):N();break;case 16:Y(1);break;case 15:case 14:break;default:return ce}}}function Y(ce,re=[],fe=[]){if(T(ce),re.length+fe.length>0){let de=t.getToken();for(;de!==17;){if(re.indexOf(de)!==-1){U();break}else if(fe.indexOf(de)!==-1)break;de=U()}}}function H(ce){const re=t.getTokenValue();return ce?P(re):d(re),U(),!0}function ge(){switch(t.getToken()){case 11:{let ce=0;try{ce=JSON.parse(t.getTokenValue()),typeof ce!="number"&&(Y(2),ce=0)}catch{Y(2)}P(ce);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return U(),!0}function ie(){return t.getToken()!==10?(Y(3,[],[2,5]),!1):(H(!1),t.getToken()===6?(M(":"),U(),V()||Y(4,[],[2,5])):Y(5,[],[2,5]),!0)}function te(){u(),U();let ce=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(ce||Y(4,[],[]),M(","),U(),t.getToken()===2&&j)break}else ce&&Y(6,[],[]);ie()||Y(4,[],[2,5]),ce=!0}return v(),t.getToken()!==2?Y(7,[2],[]):U(),!0}function q(){l(),U();let ce=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(ce||Y(4,[],[]),M(","),U(),t.getToken()===4&&j)break}else ce&&Y(6,[],[]);V()||Y(4,[],[4,5]),ce=!0}return w(),t.getToken()!==4?Y(8,[4],[]):U(),!0}function V(){switch(t.getToken()){case 3:return q();case 1:return te();case 10:return H(!0);default:return ge()}}return U(),t.getToken()===17?n.allowEmptyContent?!0:(Y(4,[],[]),!1):V()?(t.getToken()!==17&&Y(9,[],[]),!0):(Y(4,[],[]),!1)}e.$Cm=f;function y(i,a){const n=A(i),t=[];let o,g=0,u;do switch(u=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:g!==u&&t.push(i.substring(g,u)),a!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,a)),g=n.getPosition();break}while(o!==17);return t.join("")}e.$Dm=y;function C(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$Em=C}),define(De[54],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=void 0;class k{constructor(h){this.d=h,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(h){this.c=h}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$T=k}),define(De[4],Ce([1,0,67,48]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tb=e.$sb=e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=e.$db=void 0;const h=!1;let L=null;function A(g){L=g}if(e.$db=A,h){const g="__is_disposable_tracked__";A(new class{trackDisposable(u){const d=new Error("Potentially leaked disposable").stack;setTimeout(()=>{u[g]||console.log(d)},3e3)}setParent(u,d){if(u&&u!==c.None)try{u[g]=!0}catch{}}markAsDisposed(u){if(u&&u!==c.None)try{u[g]=!0}catch{}}markAsSingleton(u){}})}function m(g){return L?.trackDisposable(g),g}function E(g){L?.markAsDisposed(g)}function b(g,u){L?.setParent(g,u)}function R(g,u){if(L)for(const d of g)L.setParent(d,u)}function I(g){return L?.markAsSingleton(g),g}e.$eb=I;function $(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.$fb=$;function S(g){if(F.Iterable.is(g)){const u=[];for(const d of g)if(d)try{d.dispose()}catch(v){u.push(v)}if(u.length===1)throw u[0];if(u.length>1)throw new AggregateError(u,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}e.$gb=S;function D(g){for(const u of g)$(u)&&u.dispose();return[]}e.$hb=D;function p(...g){const u=r(()=>S(g));return R(g,u),u}e.$ib=p;function r(g){const u=m({dispose:(0,k.$cb)(()=>{E(u),g()})});return u}e.$jb=r;class s{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(E(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{S(this.f)}finally{this.f.clear()}}add(u){if(!u)return u;if(u===this)throw new Error("Cannot register a disposable on itself!");return b(u,this),this.g?s.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(u),u}}e.$kb=s;class c{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new s,m(this),b(this.q,this)}dispose(){E(this),this.q.dispose()}B(u){if(u===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(u)}}e.$lb=c;class f{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(u){this.b||u===this.a||(this.a?.dispose(),u&&b(u,this),this.a=u)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const u=this.a;return this.a=void 0,u&&b(u,null),u}}e.$mb=f;class y{constructor(u){this.b=u,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$nb=y;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(u){let d=u;return this.unset=()=>d=void 0,this.isset=()=>d!==void 0,this.dispose=()=>{d&&(d(),d=void 0,E(this))},this}}e.$ob=C;class i{constructor(){this.a=new Map}acquire(u,...d){let v=this.a.get(u);v||(v={counter:0,object:this.b(u,...d)},this.a.set(u,v));const{object:l}=v,w=(0,k.$cb)(()=>{--v.counter===0&&(this.c(u,v.object),this.a.delete(u))});return v.counter++,{object:l,dispose:w}}}e.$pb=i;class a{constructor(u){this.a=u}async acquire(u,...d){const v=this.a.acquire(u,...d);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(l){throw v.dispose(),l}}}e.$qb=a;class n{constructor(u){this.object=u}dispose(){}}e.$rb=n;function t(g){const u=new s;try{g(u)}finally{u.dispose()}}e.$sb=t;class o{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{S(this.a.values())}finally{this.a.clear()}}has(u){return this.a.has(u)}get(u){return this.a.get(u)}set(u,d,v=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),v||this.a.get(u)?.dispose(),this.a.set(u,d)}deleteAndDispose(u){this.a.get(u)?.dispose(),this.a.delete(u)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$tb=o}),define(De[68],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lc=void 0;class k{static{this.Undefined=new k(void 0)}constructor(L){this.element=L,this.next=k.Undefined,this.prev=k.Undefined}}class F{constructor(){this.a=k.Undefined,this.b=k.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===k.Undefined}clear(){let L=this.a;for(;L!==k.Undefined;){const A=L.next;L.prev=k.Undefined,L.next=k.Undefined,L=A}this.a=k.Undefined,this.b=k.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,A){const m=new k(L);if(this.a===k.Undefined)this.a=m,this.b=m;else if(A){const b=this.b;this.b=m,m.prev=b,b.next=m}else{const b=this.a;this.a=m,m.next=b,b.prev=m}this.c+=1;let E=!1;return()=>{E||(E=!0,this.e(m))}}shift(){if(this.a!==k.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==k.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==k.Undefined&&L.next!==k.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===k.Undefined&&L.next===k.Undefined?(this.a=k.Undefined,this.b=k.Undefined):L.next===k.Undefined?(this.b=this.b.prev,this.b.next=k.Undefined):L.prev===k.Undefined&&(this.a=this.a.next,this.a.prev=k.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==k.Undefined;)yield L.element,L=L.next}}e.$lc=F}),define(De[28],Ce([1,0]),function(me,e){"use strict";var k,F,h;Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.Touch=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;function L(p,r,s){let c=p.get(r);return c===void 0&&(c=s,p.set(r,c)),c}e.$ii=L;function A(p){const r=[];return p.forEach((s,c)=>{r.push(`${c} => ${s}`)}),`Map(${p.size}) {${r.join(", ")}}`}e.$ji=A;function m(p){const r=[];return p.forEach(s=>{r.push(s)}),`Set(${p.size}) {${r.join(", ")}}`}e.$ki=m;class E{constructor(r,s){this.uri=r,this.value=s}}class b{static{this.a=r=>r.toString()}constructor(r,s){this[k]="ResourceMap",r instanceof b?(this.b=new Map(r.b),this.c=s??b.a):(this.b=new Map,this.c=r??b.a)}set(r,s){return this.b.set(this.c(r),new E(r,s)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,s){typeof s<"u"&&(r=r.bind(s));for(const[c,f]of this.b)r(f.value,f.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}e.$li=b;class R{constructor(r,s){this[F]="ResourceSet",!r||typeof r=="function"?this.a=new b(r):(this.a=new b(s),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,s){this.a.forEach((c,f)=>r.call(s,f,f,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(F=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$mi=R;var I;(function(p){p[p.None=0]="None",p[p.AsOld=1]="AsOld",p[p.AsNew=2]="AsNew"})(I||(e.Touch=I={}));class ${constructor(){this[h]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,s=0){const c=this.a.get(r);if(c)return s!==0&&this.j(c,s),c.value}set(r,s,c=0){let f=this.a.get(r);if(f)f.value=s,c!==0&&this.j(f,c);else{switch(f={key:r,value:s,next:void 0,previous:void 0},c){case 0:this.h(f);break;case 1:this.g(f);break;case 2:this.h(f);break;default:this.h(f);break}this.a.set(r,f),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this.a.get(r);if(s)return this.a.delete(r),this.i(s),this.d--,s.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,s){const c=this.e;let f=this.b;for(;f;){if(s?r.bind(s)(f.value,f.key,this):r(f.value,f.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const r=this,s=this.e;let c=this.b;const f={[Symbol.iterator](){return f},next(){if(r.e!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const y={value:c.key,done:!1};return c=c.next,y}else return{value:void 0,done:!0}}};return f}values(){const r=this,s=this.e;let c=this.b;const f={[Symbol.iterator](){return f},next(){if(r.e!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const y={value:c.value,done:!1};return c=c.next,y}else return{value:void 0,done:!0}}};return f}entries(){const r=this,s=this.e;let c=this.b;const f={[Symbol.iterator](){return f},next(){if(r.e!==s)throw new Error("LinkedMap got modified during iteration.");if(c){const y={value:[c.key,c.value],done:!1};return c=c.next,y}else return{value:void 0,done:!0}}};return f}[(h=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this.b,c=this.size;for(;s&&c>r;)this.a.delete(s.key),s=s.next,c--;this.b=s,this.d=c,s&&(s.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const s=r.next,c=r.previous;if(!s||!c)throw new Error("Invalid list");s.previous=c,c.next=s}r.next=void 0,r.previous=void 0,this.e++}j(r,s){if(!this.b||!this.c)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this.b)return;const c=r.next,f=r.previous;r===this.c?(f.next=void 0,this.c=f):(c.previous=f,f.next=c),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(s===2){if(r===this.c)return;const c=r.next,f=r.previous;r===this.b?(c.previous=void 0,this.b=c):(c.previous=f,f.next=c),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((s,c)=>{r.push([c,s])}),r}fromJSON(r){this.clear();for(const[s,c]of r)this.set(s,c)}}e.$ni=$;class S extends ${constructor(r,s=1){super(),this.k=r,this.l=Math.min(Math.max(0,s),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$oi=S;class D{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let s=this.a.get(r)||0;return s===0?!1:(s--,s===0?this.a.delete(r):this.a.set(r,s),!0)}has(r){return this.a.has(r)}}e.$pi=D}),function(me,e){typeof define=="function"&&define.amd?define(De[152],Ce([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(ne,ee){for(var he=0;he<ee.length;he++){var X=ee[he];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(ne,X.key,X)}}function k(ne,ee,he){return ee&&e(ne.prototype,ee),he&&e(ne,he),Object.defineProperty(ne,"prototype",{writable:!1}),ne}function F(ne,ee){if(ne){if(typeof ne=="string")return h(ne,ee);var he=Object.prototype.toString.call(ne).slice(8,-1);if(he==="Object"&&ne.constructor&&(he=ne.constructor.name),he==="Map"||he==="Set")return Array.from(ne);if(he==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(he))return h(ne,ee)}}function h(ne,ee){(ee==null||ee>ne.length)&&(ee=ne.length);for(var he=0,X=new Array(ee);he<ee;he++)X[he]=ne[he];return X}function L(ne,ee){var he=typeof Symbol<"u"&&ne[Symbol.iterator]||ne["@@iterator"];if(he)return(he=he.call(ne)).next.bind(he);if(Array.isArray(ne)||(he=F(ne))||ee&&ne&&typeof ne.length=="number"){he&&(ne=he);var X=0;return function(){return X>=ne.length?{done:!0}:{done:!1,value:ne[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=A();function m(ne){me.defaults=ne}var E=/[&<>"']/,b=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,$={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(ee){return $[ee]};function D(ne,ee){if(ee){if(E.test(ne))return ne.replace(b,S)}else if(R.test(ne))return ne.replace(I,S);return ne}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(ne){return ne.replace(p,function(ee,he){return he=he.toLowerCase(),he==="colon"?":":he.charAt(0)==="#"?he.charAt(1)==="x"?String.fromCharCode(parseInt(he.substring(2),16)):String.fromCharCode(+he.substring(1)):""})}var s=/(^|[^\[])\^/g;function c(ne,ee){ne=typeof ne=="string"?ne:ne.source,ee=ee||"";var he={replace:function(ue,oe){return oe=oe.source||oe,oe=oe.replace(s,"$1"),ne=ne.replace(ue,oe),he},getRegex:function(){return new RegExp(ne,ee)}};return he}var f=/[^\w:]/g,y=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(ne,ee,he){if(ne){var X;try{X=decodeURIComponent(r(he)).replace(f,"").toLowerCase()}catch{return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}ee&&!y.test(he)&&(he=o(ee,he));try{he=encodeURI(he).replace(/%25/g,"%")}catch{return null}return he}var i={},a=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,t=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(ne,ee){i[" "+ne]||(a.test(ne)?i[" "+ne]=ne+"/":i[" "+ne]=v(ne,"/",!0)),ne=i[" "+ne];var he=ne.indexOf(":")===-1;return ee.substring(0,2)==="//"?he?ee:ne.replace(n,"$1")+ee:ee.charAt(0)==="/"?he?ee:ne.replace(t,"$1")+ee:ne+ee}var g={exec:function(){}};function u(ne){for(var ee=1,he,X;ee<arguments.length;ee++){he=arguments[ee];for(X in he)Object.prototype.hasOwnProperty.call(he,X)&&(ne[X]=he[X])}return ne}function d(ne,ee){var he=ne.replace(/\|/g,function(oe,le,we){for(var O=!1,K=le;--K>=0&&we[K]==="\\";)O=!O;return O?"|":" |"}),X=he.split(/ \|/),ue=0;if(X[0].trim()||X.shift(),X.length>0&&!X[X.length-1].trim()&&X.pop(),X.length>ee)X.splice(ee);else for(;X.length<ee;)X.push("");for(;ue<X.length;ue++)X[ue]=X[ue].trim().replace(/\\\|/g,"|");return X}function v(ne,ee,he){var X=ne.length;if(X===0)return"";for(var ue=0;ue<X;){var oe=ne.charAt(X-ue-1);if(oe===ee&&!he)ue++;else if(oe!==ee&&he)ue++;else break}return ne.slice(0,X-ue)}function l(ne,ee){if(ne.indexOf(ee[1])===-1)return-1;for(var he=ne.length,X=0,ue=0;ue<he;ue++)if(ne[ue]==="\\")ue++;else if(ne[ue]===ee[0])X++;else if(ne[ue]===ee[1]&&(X--,X<0))return ue;return-1}function w(ne){ne&&ne.sanitize&&!ne.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(ne,ee){if(ee<1)return"";for(var he="";ee>1;)ee&1&&(he+=ne),ee>>=1,ne+=ne;return he+ne}function M(ne,ee,he,X){var ue=ee.href,oe=ee.title?D(ee.title):null,le=ne[1].replace(/\\([\[\]])/g,"$1");if(ne[0].charAt(0)!=="!"){X.state.inLink=!0;var we={type:"link",raw:he,href:ue,title:oe,text:le,tokens:X.inlineTokens(le)};return X.state.inLink=!1,we}return{type:"image",raw:he,href:ue,title:oe,text:D(le)}}function N(ne,ee){var he=ne.match(/^(\s+)(?:```)/);if(he===null)return ee;var X=he[1];return ee.split(`
`).map(function(ue){var oe=ue.match(/^\s+/);if(oe===null)return ue;var le=oe[0];return le.length>=X.length?ue.slice(X.length):ue}).join(`
`)}var T=function(){function ne(he){this.options=he||me.defaults}var ee=ne.prototype;return ee.space=function(X){var ue=this.rules.block.newline.exec(X);if(ue&&ue[0].length>0)return{type:"space",raw:ue[0]}},ee.code=function(X){var ue=this.rules.block.code.exec(X);if(ue){var oe=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:v(oe,`
`)}}},ee.fences=function(X){var ue=this.rules.block.fences.exec(X);if(ue){var oe=ue[0],le=N(oe,ue[3]||"");return{type:"code",raw:oe,lang:ue[2]?ue[2].trim():ue[2],text:le}}},ee.heading=function(X){var ue=this.rules.block.heading.exec(X);if(ue){var oe=ue[2].trim();if(/#$/.test(oe)){var le=v(oe,"#");(this.options.pedantic||!le||/ $/.test(le))&&(oe=le.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:oe,tokens:this.lexer.inline(oe)}}},ee.hr=function(X){var ue=this.rules.block.hr.exec(X);if(ue)return{type:"hr",raw:ue[0]}},ee.blockquote=function(X){var ue=this.rules.block.blockquote.exec(X);if(ue){var oe=ue[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},ee.list=function(X){var ue=this.rules.block.list.exec(X);if(ue){var oe,le,we,O,K,G,x,pe,se,ve,Ie,Ue,Ve=ue[1].trim(),xe=Ve.length>1,Ge={type:"list",raw:"",ordered:xe,start:xe?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=xe?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=xe?Ve:"[*+-]");for(var et=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");X&&(Ue=!1,!(!(ue=et.exec(X))||this.rules.block.hr.test(X)));){if(oe=ue[0],X=X.substring(oe.length),pe=ue[2].split(`
`,1)[0],se=X.split(`
`,1)[0],this.options.pedantic?(O=2,Ie=pe.trimLeft()):(O=ue[2].search(/[^ ]/),O=O>4?1:O,Ie=pe.slice(O),O+=ue[1].length),G=!1,!pe&&/^ *$/.test(se)&&(oe+=se+`
`,X=X.substring(se.length+1),Ue=!0),!Ue)for(var Ze=new RegExp("^ {0,"+Math.min(3,O-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,O-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,O-1)+"}(?:```|~~~)"),Pe=new RegExp("^ {0,"+Math.min(3,O-1)+"}#");X&&(ve=X.split(`
`,1)[0],pe=ve,this.options.pedantic&&(pe=pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(pe)||Pe.test(pe)||Ze.test(pe)||st.test(X)));){if(pe.search(/[^ ]/)>=O||!pe.trim())Ie+=`
`+pe.slice(O);else if(!G)Ie+=`
`+pe;else break;!G&&!pe.trim()&&(G=!0),oe+=ve+`
`,X=X.substring(ve.length+1)}Ge.loose||(x?Ge.loose=!0:/\n *\n *$/.test(oe)&&(x=!0)),this.options.gfm&&(le=/^\[[ xX]\] /.exec(Ie),le&&(we=le[0]!=="[ ] ",Ie=Ie.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:oe,task:!!le,checked:we,loose:!1,text:Ie}),Ge.raw+=oe}Ge.items[Ge.items.length-1].raw=oe.trimRight(),Ge.items[Ge.items.length-1].text=Ie.trimRight(),Ge.raw=Ge.raw.trimRight();var ke=Ge.items.length;for(K=0;K<ke;K++){this.lexer.state.top=!1,Ge.items[K].tokens=this.lexer.blockTokens(Ge.items[K].text,[]);var Be=Ge.items[K].tokens.filter(function(Z){return Z.type==="space"}),Q=Be.every(function(Z){for(var ye=Z.raw.split(""),je=0,Oe=L(ye),Ye;!(Ye=Oe()).done;){var _e=Ye.value;if(_e===`
`&&(je+=1),je>1)return!0}return!1});!Ge.loose&&Be.length&&Q&&(Ge.loose=!0,Ge.items[K].loose=!0)}return Ge}},ee.html=function(X){var ue=this.rules.block.html.exec(X);if(ue){var oe={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};if(this.options.sanitize){var le=this.options.sanitizer?this.options.sanitizer(ue[0]):D(ue[0]);oe.type="paragraph",oe.text=le,oe.tokens=this.lexer.inline(le)}return oe}},ee.def=function(X){var ue=this.rules.block.def.exec(X);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var oe=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:ue[0],href:ue[2],title:ue[3]}}},ee.table=function(X){var ue=this.rules.block.table.exec(X);if(ue){var oe={type:"table",header:d(ue[1]).map(function(x){return{text:x}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]&&ue[3].trim()?ue[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=ue[0];var le=oe.align.length,we,O,K,G;for(we=0;we<le;we++)/^ *-+: *$/.test(oe.align[we])?oe.align[we]="right":/^ *:-+: *$/.test(oe.align[we])?oe.align[we]="center":/^ *:-+ *$/.test(oe.align[we])?oe.align[we]="left":oe.align[we]=null;for(le=oe.rows.length,we=0;we<le;we++)oe.rows[we]=d(oe.rows[we],oe.header.length).map(function(x){return{text:x}});for(le=oe.header.length,O=0;O<le;O++)oe.header[O].tokens=this.lexer.inline(oe.header[O].text);for(le=oe.rows.length,O=0;O<le;O++)for(G=oe.rows[O],K=0;K<G.length;K++)G[K].tokens=this.lexer.inline(G[K].text);return oe}}},ee.lheading=function(X){var ue=this.rules.block.lheading.exec(X);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:this.lexer.inline(ue[1])}},ee.paragraph=function(X){var ue=this.rules.block.paragraph.exec(X);if(ue){var oe=ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1];return{type:"paragraph",raw:ue[0],text:oe,tokens:this.lexer.inline(oe)}}},ee.text=function(X){var ue=this.rules.block.text.exec(X);if(ue)return{type:"text",raw:ue[0],text:ue[0],tokens:this.lexer.inline(ue[0])}},ee.escape=function(X){var ue=this.rules.inline.escape.exec(X);if(ue)return{type:"escape",raw:ue[0],text:D(ue[1])}},ee.tag=function(X){var ue=this.rules.inline.tag.exec(X);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):D(ue[0]):ue[0]}},ee.link=function(X){var ue=this.rules.inline.link.exec(X);if(ue){var oe=ue[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var le=v(oe.slice(0,-1),"\\");if((oe.length-le.length)%2===0)return}else{var we=l(ue[2],"()");if(we>-1){var O=ue[0].indexOf("!")===0?5:4,K=O+ue[1].length+we;ue[2]=ue[2].substring(0,we),ue[0]=ue[0].substring(0,K).trim(),ue[3]=""}}var G=ue[2],x="";if(this.options.pedantic){var pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(G);pe&&(G=pe[1],x=pe[3])}else x=ue[3]?ue[3].slice(1,-1):"";return G=G.trim(),/^</.test(G)&&(this.options.pedantic&&!/>$/.test(oe)?G=G.slice(1):G=G.slice(1,-1)),M(ue,{href:G&&G.replace(this.rules.inline._escapes,"$1"),title:x&&x.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ee.reflink=function(X,ue){var oe;if((oe=this.rules.inline.reflink.exec(X))||(oe=this.rules.inline.nolink.exec(X))){var le=(oe[2]||oe[1]).replace(/\s+/g," ");if(le=ue[le.toLowerCase()],!le||!le.href){var we=oe[0].charAt(0);return{type:"text",raw:we,text:we}}return M(oe,le,oe[0],this.lexer)}},ee.emStrong=function(X,ue,oe){oe===void 0&&(oe="");var le=this.rules.inline.emStrong.lDelim.exec(X);if(le&&!(le[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var we=le[1]||le[2]||"";if(!we||we&&(oe===""||this.rules.inline.punctuation.exec(oe))){var O=le[0].length-1,K,G,x=O,pe=0,se=le[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(se.lastIndex=0,ue=ue.slice(-1*X.length+O);(le=se.exec(ue))!=null;)if(K=le[1]||le[2]||le[3]||le[4]||le[5]||le[6],!!K){if(G=K.length,le[3]||le[4]){x+=G;continue}else if((le[5]||le[6])&&O%3&&!((O+G)%3)){pe+=G;continue}if(x-=G,!(x>0)){if(G=Math.min(G,G+x+pe),Math.min(O,G)%2){var ve=X.slice(1,O+le.index+G);return{type:"em",raw:X.slice(0,O+le.index+G+1),text:ve,tokens:this.lexer.inlineTokens(ve)}}var Ie=X.slice(2,O+le.index+G-1);return{type:"strong",raw:X.slice(0,O+le.index+G+1),text:Ie,tokens:this.lexer.inlineTokens(Ie)}}}}}},ee.codespan=function(X){var ue=this.rules.inline.code.exec(X);if(ue){var oe=ue[2].replace(/\n/g," "),le=/[^ ]/.test(oe),we=/^ /.test(oe)&&/ $/.test(oe);return le&&we&&(oe=oe.substring(1,oe.length-1)),oe=D(oe,!0),{type:"codespan",raw:ue[0],text:oe}}},ee.br=function(X){var ue=this.rules.inline.br.exec(X);if(ue)return{type:"br",raw:ue[0]}},ee.del=function(X){var ue=this.rules.inline.del.exec(X);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2])}},ee.autolink=function(X,ue){var oe=this.rules.inline.autolink.exec(X);if(oe){var le,we;return oe[2]==="@"?(le=D(this.options.mangle?ue(oe[1]):oe[1]),we="mailto:"+le):(le=D(oe[1]),we=le),{type:"link",raw:oe[0],text:le,href:we,tokens:[{type:"text",raw:le,text:le}]}}},ee.url=function(X,ue){var oe;if(oe=this.rules.inline.url.exec(X)){var le,we;if(oe[2]==="@")le=D(this.options.mangle?ue(oe[0]):oe[0]),we="mailto:"+le;else{var O;do O=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(O!==oe[0]);le=D(oe[0]),oe[1]==="www."?we="http://"+le:we=le}return{type:"link",raw:oe[0],text:le,href:we,tokens:[{type:"text",raw:le,text:le}]}}},ee.inlineText=function(X,ue){var oe=this.rules.inline.text.exec(X);if(oe){var le;return this.lexer.state.inRawBlock?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):D(oe[0]):oe[0]:le=D(this.options.smartypants?ue(oe[0]):oe[0]),{type:"text",raw:oe[0],text:le}}},ne}(),z={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};z._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,z._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,z.def=c(z.def).replace("label",z._label).replace("title",z._title).getRegex(),z.bullet=/(?:[*+-]|\d{1,9}[.)])/,z.listItemStart=c(/^( *)(bull) */).replace("bull",z.bullet).getRegex(),z.list=c(z.list).replace(/bull/g,z.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+z.def.source+")").getRegex(),z._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",z._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,z.html=c(z.html,"i").replace("comment",z._comment).replace("tag",z._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),z.paragraph=c(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.blockquote=c(z.blockquote).replace("paragraph",z.paragraph).getRegex(),z.normal=u({},z),z.gfm=u({},z.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),z.gfm.table=c(z.gfm.table).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.gfm.paragraph=c(z._paragraph).replace("hr",z.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",z.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",z._tag).getRegex(),z.pedantic=u({},z.normal,{html:c(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",z._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:c(z.normal._paragraph).replace("hr",z.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",z.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var j={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};j._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",j.punctuation=c(j.punctuation).replace(/punctuation/g,j._punctuation).getRegex(),j.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,j.escapedEmSt=/\\\*|\\_/g,j._comment=c(z._comment).replace("(?:-->|$)","-->").getRegex(),j.emStrong.lDelim=c(j.emStrong.lDelim).replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimAst=c(j.emStrong.rDelimAst,"g").replace(/punct/g,j._punctuation).getRegex(),j.emStrong.rDelimUnd=c(j.emStrong.rDelimUnd,"g").replace(/punct/g,j._punctuation).getRegex(),j._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,j._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,j._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,j.autolink=c(j.autolink).replace("scheme",j._scheme).replace("email",j._email).getRegex(),j._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,j.tag=c(j.tag).replace("comment",j._comment).replace("attribute",j._attribute).getRegex(),j._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,j._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,j._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,j.link=c(j.link).replace("label",j._label).replace("href",j._href).replace("title",j._title).getRegex(),j.reflink=c(j.reflink).replace("label",j._label).replace("ref",z._label).getRegex(),j.nolink=c(j.nolink).replace("ref",z._label).getRegex(),j.reflinkSearch=c(j.reflinkSearch,"g").replace("reflink",j.reflink).replace("nolink",j.nolink).getRegex(),j.normal=u({},j),j.pedantic=u({},j.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:c(/^!?\[(label)\]\((.*?)\)/).replace("label",j._label).getRegex(),reflink:c(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",j._label).getRegex()}),j.gfm=u({},j.normal,{escape:c(j.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),j.gfm.url=c(j.gfm.url,"i").replace("email",j.gfm._extended_email).getRegex(),j.breaks=u({},j.gfm,{br:c(j.br).replace("{2,}","*").getRegex(),text:c(j.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function U(ne){return ne.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Y(ne){var ee="",he,X,ue=ne.length;for(he=0;he<ue;he++)X=ne.charCodeAt(he),Math.random()>.5&&(X="x"+X.toString(16)),ee+="&#"+X+";";return ee}var H=function(){function ne(he){this.tokens=[],this.tokens.links=Object.create(null),this.options=he||me.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:z.normal,inline:j.normal};this.options.pedantic?(X.block=z.pedantic,X.inline=j.pedantic):this.options.gfm&&(X.block=z.gfm,this.options.breaks?X.inline=j.breaks:X.inline=j.gfm),this.tokenizer.rules=X}ne.lex=function(X,ue){var oe=new ne(ue);return oe.lex(X)},ne.lexInline=function(X,ue){var oe=new ne(ue);return oe.inlineTokens(X)};var ee=ne.prototype;return ee.lex=function(X){X=X.replace(/\r\n|\r/g,`
`),this.blockTokens(X,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ee.blockTokens=function(X,ue){var oe=this;ue===void 0&&(ue=[]),this.options.pedantic?X=X.replace(/\t/g,"    ").replace(/^ +$/gm,""):X=X.replace(/^( *)(\t+)/gm,function(x,pe,se){return pe+"    ".repeat(se.length)});for(var le,we,O,K;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(x){return(le=x.call({lexer:oe},X,ue))?(X=X.substring(le.raw.length),ue.push(le),!0):!1}))){if(le=this.tokenizer.space(X)){X=X.substring(le.raw.length),le.raw.length===1&&ue.length>0?ue[ue.length-1].raw+=`
`:ue.push(le);continue}if(le=this.tokenizer.code(X)){X=X.substring(le.raw.length),we=ue[ue.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+le.raw,we.text+=`
`+le.text,this.inlineQueue[this.inlineQueue.length-1].src=we.text):ue.push(le);continue}if(le=this.tokenizer.fences(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.heading(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.hr(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.blockquote(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.list(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.html(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.def(X)){X=X.substring(le.raw.length),we=ue[ue.length-1],we&&(we.type==="paragraph"||we.type==="text")?(we.raw+=`
`+le.raw,we.text+=`
`+le.raw,this.inlineQueue[this.inlineQueue.length-1].src=we.text):this.tokens.links[le.tag]||(this.tokens.links[le.tag]={href:le.href,title:le.title});continue}if(le=this.tokenizer.table(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.lheading(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(O=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var x=1/0,pe=X.slice(1),se=void 0;oe.options.extensions.startBlock.forEach(function(ve){se=ve.call({lexer:this},pe),typeof se=="number"&&se>=0&&(x=Math.min(x,se))}),x<1/0&&x>=0&&(O=X.substring(0,x+1))}(),this.state.top&&(le=this.tokenizer.paragraph(O))){we=ue[ue.length-1],K&&we.type==="paragraph"?(we.raw+=`
`+le.raw,we.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):ue.push(le),K=O.length!==X.length,X=X.substring(le.raw.length);continue}if(le=this.tokenizer.text(X)){X=X.substring(le.raw.length),we=ue[ue.length-1],we&&we.type==="text"?(we.raw+=`
`+le.raw,we.text+=`
`+le.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=we.text):ue.push(le);continue}if(X){var G="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(G);break}else throw new Error(G)}}return this.state.top=!0,ue},ee.inline=function(X,ue){return ue===void 0&&(ue=[]),this.inlineQueue.push({src:X,tokens:ue}),ue},ee.inlineTokens=function(X,ue){var oe=this;ue===void 0&&(ue=[]);var le,we,O,K=X,G,x,pe;if(this.tokens.links){var se=Object.keys(this.tokens.links);if(se.length>0)for(;(G=this.tokenizer.rules.inline.reflinkSearch.exec(K))!=null;)se.includes(G[0].slice(G[0].lastIndexOf("[")+1,-1))&&(K=K.slice(0,G.index)+"["+P("a",G[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(G=this.tokenizer.rules.inline.blockSkip.exec(K))!=null;)K=K.slice(0,G.index)+"["+P("a",G[0].length-2)+"]"+K.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(G=this.tokenizer.rules.inline.escapedEmSt.exec(K))!=null;)K=K.slice(0,G.index)+"++"+K.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(x||(pe=""),x=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ie){return(le=Ie.call({lexer:oe},X,ue))?(X=X.substring(le.raw.length),ue.push(le),!0):!1}))){if(le=this.tokenizer.escape(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.tag(X)){X=X.substring(le.raw.length),we=ue[ue.length-1],we&&le.type==="text"&&we.type==="text"?(we.raw+=le.raw,we.text+=le.text):ue.push(le);continue}if(le=this.tokenizer.link(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(le.raw.length),we=ue[ue.length-1],we&&le.type==="text"&&we.type==="text"?(we.raw+=le.raw,we.text+=le.text):ue.push(le);continue}if(le=this.tokenizer.emStrong(X,K,pe)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.codespan(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.br(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.del(X)){X=X.substring(le.raw.length),ue.push(le);continue}if(le=this.tokenizer.autolink(X,Y)){X=X.substring(le.raw.length),ue.push(le);continue}if(!this.state.inLink&&(le=this.tokenizer.url(X,Y))){X=X.substring(le.raw.length),ue.push(le);continue}if(O=X,this.options.extensions&&this.options.extensions.startInline&&function(){var Ie=1/0,Ue=X.slice(1),Ve=void 0;oe.options.extensions.startInline.forEach(function(xe){Ve=xe.call({lexer:this},Ue),typeof Ve=="number"&&Ve>=0&&(Ie=Math.min(Ie,Ve))}),Ie<1/0&&Ie>=0&&(O=X.substring(0,Ie+1))}(),le=this.tokenizer.inlineText(O,U)){X=X.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(pe=le.raw.slice(-1)),x=!0,we=ue[ue.length-1],we&&we.type==="text"?(we.raw+=le.raw,we.text+=le.text):ue.push(le);continue}if(X){var ve="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(ve);break}else throw new Error(ve)}}return ue},k(ne,null,[{key:"rules",get:function(){return{block:z,inline:j}}}]),ne}(),ge=function(){function ne(he){this.options=he||me.defaults}var ee=ne.prototype;return ee.code=function(X,ue,oe){var le=(ue||"").match(/\S*/)[0];if(this.options.highlight){var we=this.options.highlight(X,le);we!=null&&we!==X&&(oe=!0,X=we)}return X=X.replace(/\n$/,"")+`
`,le?'<pre><code class="'+this.options.langPrefix+D(le,!0)+'">'+(oe?X:D(X,!0))+`</code></pre>
`:"<pre><code>"+(oe?X:D(X,!0))+`</code></pre>
`},ee.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},ee.html=function(X){return X},ee.heading=function(X,ue,oe,le){if(this.options.headerIds){var we=this.options.headerPrefix+le.slug(oe);return"<h"+ue+' id="'+we+'">'+X+"</h"+ue+`>
`}return"<h"+ue+">"+X+"</h"+ue+`>
`},ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ee.list=function(X,ue,oe){var le=ue?"ol":"ul",we=ue&&oe!==1?' start="'+oe+'"':"";return"<"+le+we+`>
`+X+"</"+le+`>
`},ee.listitem=function(X){return"<li>"+X+`</li>
`},ee.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ee.paragraph=function(X){return"<p>"+X+`</p>
`},ee.table=function(X,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+ue+`</table>
`},ee.tablerow=function(X){return`<tr>
`+X+`</tr>
`},ee.tablecell=function(X,ue){var oe=ue.header?"th":"td",le=ue.align?"<"+oe+' align="'+ue.align+'">':"<"+oe+">";return le+X+("</"+oe+`>
`)},ee.strong=function(X){return"<strong>"+X+"</strong>"},ee.em=function(X){return"<em>"+X+"</em>"},ee.codespan=function(X){return"<code>"+X+"</code>"},ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},ee.del=function(X){return"<del>"+X+"</del>"},ee.link=function(X,ue,oe){if(X=C(this.options.sanitize,this.options.baseUrl,X),X===null)return oe;var le='<a href="'+D(X)+'"';return ue&&(le+=' title="'+ue+'"'),le+=">"+oe+"</a>",le},ee.image=function(X,ue,oe){if(X=C(this.options.sanitize,this.options.baseUrl,X),X===null)return oe;var le='<img src="'+X+'" alt="'+oe+'"';return ue&&(le+=' title="'+ue+'"'),le+=this.options.xhtml?"/>":">",le},ee.text=function(X){return X},ne}(),ie=function(){function ne(){}var ee=ne.prototype;return ee.strong=function(X){return X},ee.em=function(X){return X},ee.codespan=function(X){return X},ee.del=function(X){return X},ee.html=function(X){return X},ee.text=function(X){return X},ee.link=function(X,ue,oe){return""+oe},ee.image=function(X,ue,oe){return""+oe},ee.br=function(){return""},ne}(),te=function(){function ne(){this.seen={}}var ee=ne.prototype;return ee.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ee.getNextSafeSlug=function(X,ue){var oe=X,le=0;if(this.seen.hasOwnProperty(oe)){le=this.seen[X];do le++,oe=X+"-"+le;while(this.seen.hasOwnProperty(oe))}return ue||(this.seen[X]=le,this.seen[oe]=0),oe},ee.slug=function(X,ue){ue===void 0&&(ue={});var oe=this.serialize(X);return this.getNextSafeSlug(oe,ue.dryrun)},ne}(),q=function(){function ne(he){this.options=he||me.defaults,this.options.renderer=this.options.renderer||new ge,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ie,this.slugger=new te}ne.parse=function(X,ue){var oe=new ne(ue);return oe.parse(X)},ne.parseInline=function(X,ue){var oe=new ne(ue);return oe.parseInline(X)};var ee=ne.prototype;return ee.parse=function(X,ue){ue===void 0&&(ue=!0);var oe="",le,we,O,K,G,x,pe,se,ve,Ie,Ue,Ve,xe,Ge,et,Ze,st,tt,Pe,ke=X.length;for(le=0;le<ke;le++){if(Ie=X[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Pe=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ie.type))){oe+=Pe||"";continue}switch(Ie.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(Ie.tokens),Ie.depth,r(this.parseInline(Ie.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(Ie.text,Ie.lang,Ie.escaped);continue}case"table":{for(se="",pe="",K=Ie.header.length,we=0;we<K;we++)pe+=this.renderer.tablecell(this.parseInline(Ie.header[we].tokens),{header:!0,align:Ie.align[we]});for(se+=this.renderer.tablerow(pe),ve="",K=Ie.rows.length,we=0;we<K;we++){for(x=Ie.rows[we],pe="",G=x.length,O=0;O<G;O++)pe+=this.renderer.tablecell(this.parseInline(x[O].tokens),{header:!1,align:Ie.align[O]});ve+=this.renderer.tablerow(pe)}oe+=this.renderer.table(se,ve);continue}case"blockquote":{ve=this.parse(Ie.tokens),oe+=this.renderer.blockquote(ve);continue}case"list":{for(Ue=Ie.ordered,Ve=Ie.start,xe=Ie.loose,K=Ie.items.length,ve="",we=0;we<K;we++)et=Ie.items[we],Ze=et.checked,st=et.task,Ge="",et.task&&(tt=this.renderer.checkbox(Ze),xe?et.tokens.length>0&&et.tokens[0].type==="paragraph"?(et.tokens[0].text=tt+" "+et.tokens[0].text,et.tokens[0].tokens&&et.tokens[0].tokens.length>0&&et.tokens[0].tokens[0].type==="text"&&(et.tokens[0].tokens[0].text=tt+" "+et.tokens[0].tokens[0].text)):et.tokens.unshift({type:"text",text:tt}):Ge+=tt),Ge+=this.parse(et.tokens,xe),ve+=this.renderer.listitem(Ge,st,Ze);oe+=this.renderer.list(ve,Ue,Ve);continue}case"html":{oe+=this.renderer.html(Ie.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(Ie.tokens));continue}case"text":{for(ve=Ie.tokens?this.parseInline(Ie.tokens):Ie.text;le+1<ke&&X[le+1].type==="text";)Ie=X[++le],ve+=`
`+(Ie.tokens?this.parseInline(Ie.tokens):Ie.text);oe+=ue?this.renderer.paragraph(ve):ve;continue}default:{var Be='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(Be);return}else throw new Error(Be)}}}return oe},ee.parseInline=function(X,ue){ue=ue||this.renderer;var oe="",le,we,O,K=X.length;for(le=0;le<K;le++){if(we=X[le],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(O=this.options.extensions.renderers[we.type].call({parser:this},we),O!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(we.type))){oe+=O||"";continue}switch(we.type){case"escape":{oe+=ue.text(we.text);break}case"html":{oe+=ue.html(we.text);break}case"link":{oe+=ue.link(we.href,we.title,this.parseInline(we.tokens,ue));break}case"image":{oe+=ue.image(we.href,we.title,we.text);break}case"strong":{oe+=ue.strong(this.parseInline(we.tokens,ue));break}case"em":{oe+=ue.em(this.parseInline(we.tokens,ue));break}case"codespan":{oe+=ue.codespan(we.text);break}case"br":{oe+=ue.br();break}case"del":{oe+=ue.del(this.parseInline(we.tokens,ue));break}case"text":{oe+=ue.text(we.text);break}default:{var G='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(G);return}else throw new Error(G)}}}return oe},ne}();function V(ne,ee,he){if(typeof ne>"u"||ne===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");if(typeof ee=="function"&&(he=ee,ee=null),ee=u({},V.defaults,ee||{}),w(ee),he){var X=ee.highlight,ue;try{ue=H.lex(ne,ee)}catch(K){return he(K)}var oe=function(G){var x;if(!G)try{ee.walkTokens&&V.walkTokens(ue,ee.walkTokens),x=q.parse(ue,ee)}catch(pe){G=pe}return ee.highlight=X,G?he(G):he(null,x)};if(!X||X.length<3||(delete ee.highlight,!ue.length))return oe();var le=0;V.walkTokens(ue,function(K){K.type==="code"&&(le++,setTimeout(function(){X(K.text,K.lang,function(G,x){if(G)return oe(G);x!=null&&x!==K.text&&(K.text=x,K.escaped=!0),le--,le===0&&oe()})},0))}),le===0&&oe();return}function we(K){if(K.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+D(K.message+"",!0)+"</pre>";throw K}try{var O=H.lex(ne,ee);if(ee.walkTokens){if(ee.async)return Promise.all(V.walkTokens(O,ee.walkTokens)).then(function(){return q.parse(O,ee)}).catch(we);V.walkTokens(O,ee.walkTokens)}return q.parse(O,ee)}catch(K){we(K)}}V.options=V.setOptions=function(ne){return u(V.defaults,ne),m(V.defaults),V},V.getDefaults=A,V.defaults=me.defaults,V.use=function(){for(var ne=arguments.length,ee=new Array(ne),he=0;he<ne;he++)ee[he]=arguments[he];var X=u.apply(void 0,[{}].concat(ee)),ue=V.defaults.extensions||{renderers:{},childTokens:{}},oe;ee.forEach(function(le){if(le.extensions&&(oe=!0,le.extensions.forEach(function(O){if(!O.name)throw new Error("extension name required");if(O.renderer){var K=ue.renderers?ue.renderers[O.name]:null;K?ue.renderers[O.name]=function(){for(var G=arguments.length,x=new Array(G),pe=0;pe<G;pe++)x[pe]=arguments[pe];var se=O.renderer.apply(this,x);return se===!1&&(se=K.apply(this,x)),se}:ue.renderers[O.name]=O.renderer}if(O.tokenizer){if(!O.level||O.level!=="block"&&O.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ue[O.level]?ue[O.level].unshift(O.tokenizer):ue[O.level]=[O.tokenizer],O.start&&(O.level==="block"?ue.startBlock?ue.startBlock.push(O.start):ue.startBlock=[O.start]:O.level==="inline"&&(ue.startInline?ue.startInline.push(O.start):ue.startInline=[O.start]))}O.childTokens&&(ue.childTokens[O.name]=O.childTokens)})),le.renderer&&function(){var O=V.defaults.renderer||new ge,K=function(pe){var se=O[pe];O[pe]=function(){for(var ve=arguments.length,Ie=new Array(ve),Ue=0;Ue<ve;Ue++)Ie[Ue]=arguments[Ue];var Ve=le.renderer[pe].apply(O,Ie);return Ve===!1&&(Ve=se.apply(O,Ie)),Ve}};for(var G in le.renderer)K(G);X.renderer=O}(),le.tokenizer&&function(){var O=V.defaults.tokenizer||new T,K=function(pe){var se=O[pe];O[pe]=function(){for(var ve=arguments.length,Ie=new Array(ve),Ue=0;Ue<ve;Ue++)Ie[Ue]=arguments[Ue];var Ve=le.tokenizer[pe].apply(O,Ie);return Ve===!1&&(Ve=se.apply(O,Ie)),Ve}};for(var G in le.tokenizer)K(G);X.tokenizer=O}(),le.walkTokens){var we=V.defaults.walkTokens;X.walkTokens=function(O){var K=[];return K.push(le.walkTokens.call(this,O)),we&&(K=K.concat(we.call(this,O))),K}}oe&&(X.extensions=ue),V.setOptions(X)})},V.walkTokens=function(ne,ee){for(var he=[],X=function(){var we=oe.value;switch(he=he.concat(ee.call(V,we)),we.type){case"table":{for(var O=L(we.header),K;!(K=O()).done;){var G=K.value;he=he.concat(V.walkTokens(G.tokens,ee))}for(var x=L(we.rows),pe;!(pe=x()).done;)for(var se=pe.value,ve=L(se),Ie;!(Ie=ve()).done;){var Ue=Ie.value;he=he.concat(V.walkTokens(Ue.tokens,ee))}break}case"list":{he=he.concat(V.walkTokens(we.items,ee));break}default:V.defaults.extensions&&V.defaults.extensions.childTokens&&V.defaults.extensions.childTokens[we.type]?V.defaults.extensions.childTokens[we.type].forEach(function(Ve){he=he.concat(V.walkTokens(we[Ve],ee))}):we.tokens&&(he=he.concat(V.walkTokens(we.tokens,ee)))}},ue=L(ne),oe;!(oe=ue()).done;)X();return he},V.parseInline=function(ne,ee){if(typeof ne>"u"||ne===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ne!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ne)+", string expected");ee=u({},V.defaults,ee||{}),w(ee);try{var he=H.lexInline(ne,ee);return ee.walkTokens&&V.walkTokens(he,ee.walkTokens),q.parseInline(he,ee)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+D(X.message+"",!0)+"</pre>";throw X}},V.Parser=q,V.parser=q.parse,V.Renderer=ge,V.TextRenderer=ie,V.Lexer=H,V.lexer=H.lex,V.Tokenizer=T,V.Slugger=te,V.parse=V;var ce=V.options,re=V.setOptions,fe=V.use,de=V.walkTokens,B=V.parseInline,_=V,Ee=q.parse,Re=H.lex;me.Lexer=H,me.Parser=q,me.Renderer=ge,me.Slugger=te,me.TextRenderer=ie,me.Tokenizer=T,me.getDefaults=A,me.lexer=Re,me.marked=V,me.options=ce,me.parse=_,me.parseInline=B,me.parser=Ee,me.setOptions=re,me.use=fe,me.walkTokens=de,Object.defineProperty(me,"__esModule",{value:!0})}),define(De[69],Ce([1,0,28]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=void 0;const F=new k.$oi(1e4);function h(b){return E(b,"NFC",F)}e.$5k=h;const L=new k.$oi(1e4);function A(b){return E(b,"NFD",L)}e.$6k=A;const m=/[^\u0000-\u0080]/;function E(b,R,I){if(!b)return b;const $=I.get(b);if($)return $;let S;return m.test(b)?S=b.normalize(R):S=b,I.set(b,S),S}e.$7k=function(){const b=/[\u0300-\u036f]/g;return function(R){return A(R).replace(b,"")}}()}),define(De[112],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=e.rot=e.$rl=void 0;function k(m,E,b){return Math.min(Math.max(m,E),b)}e.$rl=k;function F(m,E){return(E+m%E)%E}e.rot=F;class h{constructor(){this.a=0}getNext(){return this.a++}}e.$tl=h;class L{constructor(){this.a=1,this.b=0}update(E){return this.b=this.b+(E-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ul=L;class A{constructor(E){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(E),this.c.fill(0,0,E)}update(E){const b=this.c[this.d];return this.c[this.d]=E,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=E,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$vl=A}),function(){function me(h){const L=[];typeof h=="number"&&L.push("code/timeOrigin",h);function A(E){L.push(E,Date.now())}function m(){const E=[];for(let b=0;b<L.length;b+=2)E.push({name:L[b],startTime:L[b+1]});return E}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(h){performance.mark(h)},getMarks(){let h=performance.timeOrigin;typeof h!="number"&&(h=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(h)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(h+A.startTime)});return L}};if(typeof process=="object"){const h=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(h)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function k(h){return h.MonacoPerformanceMarks||(h.MonacoPerformanceMarks=e()),h.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return k(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=k(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=k(F))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var k=e();for(var F in k)(typeof exports=="object"?exports:me)[F]=k[F]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function k(F){if(e[F])return e[F].exports;var h=e[F]={i:F,l:!1,exports:{}};return me[F].call(h.exports,h,h.exports,k),h.l=!0,h.exports}return k.m=me,k.c=e,k.d=function(F,h,L){k.o(F,h)||Object.defineProperty(F,h,{enumerable:!0,get:L})},k.r=function(F){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(F,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(F,"__esModule",{value:!0})},k.t=function(F,h){if(1&h&&(F=k(F)),8&h||4&h&&typeof F=="object"&&F&&F.__esModule)return F;var L=Object.create(null);if(k.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:F}),2&h&&typeof F!="string")for(var A in F)k.d(L,A,function(m){return F[m]}.bind(null,A));return L},k.n=function(F){var h=F&&F.__esModule?function(){return F.default}:function(){return F};return k.d(h,"a",h),h},k.o=function(F,h){return Object.prototype.hasOwnProperty.call(F,h)},k.p="",k(k.s=0)}([function(me,e,k){(function(F){var h;e=me.exports=fe,h=typeof F=="object"&&F.env&&F.env.NODE_DEBUG&&/\bsemver\b/i.test(F.env.NODE_DEBUG)?function(){var se=Array.prototype.slice.call(arguments,0);se.unshift("SEMVER"),console.log.apply(console,se)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],E=e.src=[],b=0,R=b++;E[R]="0|[1-9]\\d*";var I=b++;E[I]="[0-9]+";var $=b++;E[$]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=b++;E[S]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var D=b++;E[D]="("+E[I]+")\\.("+E[I]+")\\.("+E[I]+")";var p=b++;E[p]="(?:"+E[R]+"|"+E[$]+")";var r=b++;E[r]="(?:"+E[I]+"|"+E[$]+")";var s=b++;E[s]="(?:-("+E[p]+"(?:\\."+E[p]+")*))";var c=b++;E[c]="(?:-?("+E[r]+"(?:\\."+E[r]+")*))";var f=b++;E[f]="[0-9A-Za-z-]+";var y=b++;E[y]="(?:\\+("+E[f]+"(?:\\."+E[f]+")*))";var C=b++,i="v?"+E[S]+E[s]+"?"+E[y]+"?";E[C]="^"+i+"$";var a="[v=\\s]*"+E[D]+E[c]+"?"+E[y]+"?",n=b++;E[n]="^"+a+"$";var t=b++;E[t]="((?:<|>)?=?)";var o=b++;E[o]=E[I]+"|x|X|\\*";var g=b++;E[g]=E[R]+"|x|X|\\*";var u=b++;E[u]="[v=\\s]*("+E[g]+")(?:\\.("+E[g]+")(?:\\.("+E[g]+")(?:"+E[s]+")?"+E[y]+"?)?)?";var d=b++;E[d]="[v=\\s]*("+E[o]+")(?:\\.("+E[o]+")(?:\\.("+E[o]+")(?:"+E[c]+")?"+E[y]+"?)?)?";var v=b++;E[v]="^"+E[t]+"\\s*"+E[u]+"$";var l=b++;E[l]="^"+E[t]+"\\s*"+E[d]+"$";var w=b++;E[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=b++;E[P]="(?:~>?)";var M=b++;E[M]="(\\s*)"+E[P]+"\\s+",m[M]=new RegExp(E[M],"g");var N=b++;E[N]="^"+E[P]+E[u]+"$";var T=b++;E[T]="^"+E[P]+E[d]+"$";var z=b++;E[z]="(?:\\^)";var j=b++;E[j]="(\\s*)"+E[z]+"\\s+",m[j]=new RegExp(E[j],"g");var U=b++;E[U]="^"+E[z]+E[u]+"$";var Y=b++;E[Y]="^"+E[z]+E[d]+"$";var H=b++;E[H]="^"+E[t]+"\\s*("+a+")$|^$";var ge=b++;E[ge]="^"+E[t]+"\\s*("+i+")$|^$";var ie=b++;E[ie]="(\\s*)"+E[t]+"\\s*("+a+"|"+E[u]+")",m[ie]=new RegExp(E[ie],"g");var te=b++;E[te]="^\\s*("+E[u]+")\\s+-\\s+("+E[u]+")\\s*$";var q=b++;E[q]="^\\s*("+E[d]+")\\s+-\\s+("+E[d]+")\\s*$";var V=b++;E[V]="(<|>)?=?\\s*\\*";for(var ce=0;ce<35;ce++)h(ce,E[ce]),m[ce]||(m[ce]=new RegExp(E[ce]));function re(se,ve){if(se instanceof fe)return se;if(typeof se!="string"||se.length>L||!(ve?m[n]:m[C]).test(se))return null;try{return new fe(se,ve)}catch{return null}}function fe(se,ve){if(se instanceof fe){if(se.loose===ve)return se;se=se.version}else if(typeof se!="string")throw new TypeError("Invalid Version: "+se);if(se.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof fe))return new fe(se,ve);h("SemVer",se,ve),this.loose=ve;var Ie=se.trim().match(ve?m[n]:m[C]);if(!Ie)throw new TypeError("Invalid Version: "+se);if(this.raw=se,this.major=+Ie[1],this.minor=+Ie[2],this.patch=+Ie[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Ie[4]?this.prerelease=Ie[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var Ve=+Ue;if(Ve>=0&&Ve<A)return Ve}return Ue}):this.prerelease=[],this.build=Ie[5]?Ie[5].split("."):[],this.format()}e.parse=re,e.valid=function(se,ve){var Ie=re(se,ve);return Ie?Ie.version:null},e.clean=function(se,ve){var Ie=re(se.trim().replace(/^[=v]+/,""),ve);return Ie?Ie.version:null},e.SemVer=fe,fe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},fe.prototype.toString=function(){return this.version},fe.prototype.compare=function(se){return h("SemVer.compare",this.version,this.loose,se),se instanceof fe||(se=new fe(se,this.loose)),this.compareMain(se)||this.comparePre(se)},fe.prototype.compareMain=function(se){return se instanceof fe||(se=new fe(se,this.loose)),B(this.major,se.major)||B(this.minor,se.minor)||B(this.patch,se.patch)},fe.prototype.comparePre=function(se){if(se instanceof fe||(se=new fe(se,this.loose)),this.prerelease.length&&!se.prerelease.length)return-1;if(!this.prerelease.length&&se.prerelease.length)return 1;if(!this.prerelease.length&&!se.prerelease.length)return 0;var ve=0;do{var Ie=this.prerelease[ve],Ue=se.prerelease[ve];if(h("prerelease compare",ve,Ie,Ue),Ie===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(Ie===void 0)return-1;if(Ie!==Ue)return B(Ie,Ue)}while(++ve)},fe.prototype.inc=function(se,ve){switch(se){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Ie=this.prerelease.length;--Ie>=0;)typeof this.prerelease[Ie]=="number"&&(this.prerelease[Ie]++,Ie=-2);Ie===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+se)}return this.format(),this.raw=this.version,this},e.inc=function(se,ve,Ie,Ue){typeof Ie=="string"&&(Ue=Ie,Ie=void 0);try{return new fe(se,Ie).inc(ve,Ue).version}catch{return null}},e.diff=function(se,ve){if(ne(se,ve))return null;var Ie=re(se),Ue=re(ve);if(Ie.prerelease.length||Ue.prerelease.length){for(var Ve in Ie)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Ie[Ve]!==Ue[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in Ie)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Ie[Ve]!==Ue[Ve])return Ve},e.compareIdentifiers=B;var de=/^[0-9]+$/;function B(se,ve){var Ie=de.test(se),Ue=de.test(ve);return Ie&&Ue&&(se=+se,ve=+ve),Ie&&!Ue?-1:Ue&&!Ie?1:se<ve?-1:se>ve?1:0}function _(se,ve,Ie){return new fe(se,Ie).compare(new fe(ve,Ie))}function Ee(se,ve,Ie){return _(se,ve,Ie)>0}function Re(se,ve,Ie){return _(se,ve,Ie)<0}function ne(se,ve,Ie){return _(se,ve,Ie)===0}function ee(se,ve,Ie){return _(se,ve,Ie)!==0}function he(se,ve,Ie){return _(se,ve,Ie)>=0}function X(se,ve,Ie){return _(se,ve,Ie)<=0}function ue(se,ve,Ie,Ue){var Ve;switch(ve){case"===":typeof se=="object"&&(se=se.version),typeof Ie=="object"&&(Ie=Ie.version),Ve=se===Ie;break;case"!==":typeof se=="object"&&(se=se.version),typeof Ie=="object"&&(Ie=Ie.version),Ve=se!==Ie;break;case"":case"=":case"==":Ve=ne(se,Ie,Ue);break;case"!=":Ve=ee(se,Ie,Ue);break;case">":Ve=Ee(se,Ie,Ue);break;case">=":Ve=he(se,Ie,Ue);break;case"<":Ve=Re(se,Ie,Ue);break;case"<=":Ve=X(se,Ie,Ue);break;default:throw new TypeError("Invalid operator: "+ve)}return Ve}function oe(se,ve){if(se instanceof oe){if(se.loose===ve)return se;se=se.value}if(!(this instanceof oe))return new oe(se,ve);h("comparator",se,ve),this.loose=ve,this.parse(se),this.semver===le?this.value="":this.value=this.operator+this.semver.version,h("comp",this)}e.rcompareIdentifiers=function(se,ve){return B(ve,se)},e.major=function(se,ve){return new fe(se,ve).major},e.minor=function(se,ve){return new fe(se,ve).minor},e.patch=function(se,ve){return new fe(se,ve).patch},e.compare=_,e.compareLoose=function(se,ve){return _(se,ve,!0)},e.rcompare=function(se,ve,Ie){return _(ve,se,Ie)},e.sort=function(se,ve){return se.sort(function(Ie,Ue){return e.compare(Ie,Ue,ve)})},e.rsort=function(se,ve){return se.sort(function(Ie,Ue){return e.rcompare(Ie,Ue,ve)})},e.gt=Ee,e.lt=Re,e.eq=ne,e.neq=ee,e.gte=he,e.lte=X,e.cmp=ue,e.Comparator=oe;var le={};function we(se,ve){if(se instanceof we)return se.loose===ve?se:new we(se.raw,ve);if(se instanceof oe)return new we(se.value,ve);if(!(this instanceof we))return new we(se,ve);if(this.loose=ve,this.raw=se,this.set=se.split(/\s*\|\|\s*/).map(function(Ie){return this.parseRange(Ie.trim())},this).filter(function(Ie){return Ie.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+se);this.format()}function O(se){return!se||se.toLowerCase()==="x"||se==="*"}function K(se,ve,Ie,Ue,Ve,xe,Ge,et,Ze,st,tt,Pe,ke){return((ve=O(Ie)?"":O(Ue)?">="+Ie+".0.0":O(Ve)?">="+Ie+"."+Ue+".0":">="+ve)+" "+(et=O(Ze)?"":O(st)?"<"+(+Ze+1)+".0.0":O(tt)?"<"+Ze+"."+(+st+1)+".0":Pe?"<="+Ze+"."+st+"."+tt+"-"+Pe:"<="+et)).trim()}function G(se,ve){for(var Ie=0;Ie<se.length;Ie++)if(!se[Ie].test(ve))return!1;if(ve.prerelease.length){for(Ie=0;Ie<se.length;Ie++)if(h(se[Ie].semver),se[Ie].semver!==le&&se[Ie].semver.prerelease.length>0){var Ue=se[Ie].semver;if(Ue.major===ve.major&&Ue.minor===ve.minor&&Ue.patch===ve.patch)return!0}return!1}return!0}function x(se,ve,Ie){try{ve=new we(ve,Ie)}catch{return!1}return ve.test(se)}function pe(se,ve,Ie,Ue){var Ve,xe,Ge,et,Ze;switch(se=new fe(se,Ue),ve=new we(ve,Ue),Ie){case">":Ve=Ee,xe=X,Ge=Re,et=">",Ze=">=";break;case"<":Ve=Re,xe=he,Ge=Ee,et="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(x(se,ve,Ue))return!1;for(var st=0;st<ve.set.length;++st){var tt=ve.set[st],Pe=null,ke=null;if(tt.forEach(function(Be){Be.semver===le&&(Be=new oe(">=0.0.0")),Pe=Pe||Be,ke=ke||Be,Ve(Be.semver,Pe.semver,Ue)?Pe=Be:Ge(Be.semver,ke.semver,Ue)&&(ke=Be)}),Pe.operator===et||Pe.operator===Ze||(!ke.operator||ke.operator===et)&&xe(se,ke.semver)||ke.operator===Ze&&Ge(se,ke.semver))return!1}return!0}oe.prototype.parse=function(se){var ve=this.loose?m[H]:m[ge],Ie=se.match(ve);if(!Ie)throw new TypeError("Invalid comparator: "+se);this.operator=Ie[1],this.operator==="="&&(this.operator=""),Ie[2]?this.semver=new fe(Ie[2],this.loose):this.semver=le},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(se){return h("Comparator.test",se,this.loose),this.semver===le||(typeof se=="string"&&(se=new fe(se,this.loose)),ue(se,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(se,ve){if(!(se instanceof oe))throw new TypeError("a Comparator is required");var Ie;if(this.operator==="")return Ie=new we(se.value,ve),x(this.value,Ie,ve);if(se.operator==="")return Ie=new we(this.value,ve),x(se.semver,Ie,ve);var Ue=!(this.operator!==">="&&this.operator!==">"||se.operator!==">="&&se.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||se.operator!=="<="&&se.operator!=="<"),xe=this.semver.version===se.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||se.operator!==">="&&se.operator!=="<="),et=ue(this.semver,"<",se.semver,ve)&&(this.operator===">="||this.operator===">")&&(se.operator==="<="||se.operator==="<"),Ze=ue(this.semver,">",se.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(se.operator===">="||se.operator===">");return Ue||Ve||xe&&Ge||et||Ze},e.Range=we,we.prototype.format=function(){return this.range=this.set.map(function(se){return se.join(" ").trim()}).join("||").trim(),this.range},we.prototype.toString=function(){return this.range},we.prototype.parseRange=function(se){var ve=this.loose;se=se.trim(),h("range",se,ve);var Ie=ve?m[q]:m[te];se=se.replace(Ie,K),h("hyphen replace",se),se=se.replace(m[ie],"$1$2$3"),h("comparator trim",se,m[ie]),se=(se=(se=se.replace(m[M],"$1~")).replace(m[j],"$1^")).split(/\s+/).join(" ");var Ue=ve?m[H]:m[ge],Ve=se.split(" ").map(function(xe){return function(Ge,et){return h("comp",Ge),Ge=function(Ze,st){return Ze.trim().split(/\s+/).map(function(tt){return function(Pe,ke){h("caret",Pe,ke);var Be=ke?m[Y]:m[U];return Pe.replace(Be,function(Q,Z,ye,je,Oe){var Ye;return h("caret",Pe,Q,Z,ye,je,Oe),O(Z)?Ye="":O(ye)?Ye=">="+Z+".0.0 <"+(+Z+1)+".0.0":O(je)?Ye=Z==="0"?">="+Z+"."+ye+".0 <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+".0 <"+(+Z+1)+".0.0":Oe?(h("replaceCaret pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ye=Z==="0"?ye==="0"?">="+Z+"."+ye+"."+je+Oe+" <"+Z+"."+ye+"."+(+je+1):">="+Z+"."+ye+"."+je+Oe+" <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+"."+je+Oe+" <"+(+Z+1)+".0.0"):(h("no pr"),Ye=Z==="0"?ye==="0"?">="+Z+"."+ye+"."+je+" <"+Z+"."+ye+"."+(+je+1):">="+Z+"."+ye+"."+je+" <"+Z+"."+(+ye+1)+".0":">="+Z+"."+ye+"."+je+" <"+(+Z+1)+".0.0"),h("caret return",Ye),Ye})}(tt,st)}).join(" ")}(Ge,et),h("caret",Ge),Ge=function(Ze,st){return Ze.trim().split(/\s+/).map(function(tt){return function(Pe,ke){var Be=ke?m[T]:m[N];return Pe.replace(Be,function(Q,Z,ye,je,Oe){var Ye;return h("tilde",Pe,Q,Z,ye,je,Oe),O(Z)?Ye="":O(ye)?Ye=">="+Z+".0.0 <"+(+Z+1)+".0.0":O(je)?Ye=">="+Z+"."+ye+".0 <"+Z+"."+(+ye+1)+".0":Oe?(h("replaceTilde pr",Oe),Oe.charAt(0)!=="-"&&(Oe="-"+Oe),Ye=">="+Z+"."+ye+"."+je+Oe+" <"+Z+"."+(+ye+1)+".0"):Ye=">="+Z+"."+ye+"."+je+" <"+Z+"."+(+ye+1)+".0",h("tilde return",Ye),Ye})}(tt,st)}).join(" ")}(Ge,et),h("tildes",Ge),Ge=function(Ze,st){return h("replaceXRanges",Ze,st),Ze.split(/\s+/).map(function(tt){return function(Pe,ke){Pe=Pe.trim();var Be=ke?m[l]:m[v];return Pe.replace(Be,function(Q,Z,ye,je,Oe,Ye){h("xRange",Pe,Q,Z,ye,je,Oe,Ye);var _e=O(ye),rt=_e||O(je),ft=rt||O(Oe);return Z==="="&&ft&&(Z=""),_e?Q=Z===">"||Z==="<"?"<0.0.0":"*":Z&&ft?(rt&&(je=0),ft&&(Oe=0),Z===">"?(Z=">=",rt?(ye=+ye+1,je=0,Oe=0):ft&&(je=+je+1,Oe=0)):Z==="<="&&(Z="<",rt?ye=+ye+1:je=+je+1),Q=Z+ye+"."+je+"."+Oe):rt?Q=">="+ye+".0.0 <"+(+ye+1)+".0.0":ft&&(Q=">="+ye+"."+je+".0 <"+ye+"."+(+je+1)+".0"),h("xRange return",Q),Q})}(tt,st)}).join(" ")}(Ge,et),h("xrange",Ge),Ge=function(Ze,st){return h("replaceStars",Ze,st),Ze.trim().replace(m[V],"")}(Ge,et),h("stars",Ge),Ge}(xe,ve)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(xe){return!!xe.match(Ue)})),Ve=Ve.map(function(xe){return new oe(xe,ve)})},we.prototype.intersects=function(se,ve){if(!(se instanceof we))throw new TypeError("a Range is required");return this.set.some(function(Ie){return Ie.every(function(Ue){return se.set.some(function(Ve){return Ve.every(function(xe){return Ue.intersects(xe,ve)})})})})},e.toComparators=function(se,ve){return new we(se,ve).set.map(function(Ie){return Ie.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},we.prototype.test=function(se){if(!se)return!1;typeof se=="string"&&(se=new fe(se,this.loose));for(var ve=0;ve<this.set.length;ve++)if(G(this.set[ve],se))return!0;return!1},e.satisfies=x,e.maxSatisfying=function(se,ve,Ie){var Ue=null,Ve=null;try{var xe=new we(ve,Ie)}catch{return null}return se.forEach(function(Ge){xe.test(Ge)&&(Ue&&Ve.compare(Ge)!==-1||(Ve=new fe(Ue=Ge,Ie)))}),Ue},e.minSatisfying=function(se,ve,Ie){var Ue=null,Ve=null;try{var xe=new we(ve,Ie)}catch{return null}return se.forEach(function(Ge){xe.test(Ge)&&(Ue&&Ve.compare(Ge)!==1||(Ve=new fe(Ue=Ge,Ie)))}),Ue},e.validRange=function(se,ve){try{return new we(se,ve).range||"*"}catch{return null}},e.ltr=function(se,ve,Ie){return pe(se,ve,"<",Ie)},e.gtr=function(se,ve,Ie){return pe(se,ve,">",Ie)},e.outside=pe,e.prerelease=function(se,ve){var Ie=re(se,ve);return Ie&&Ie.prerelease.length?Ie.prerelease:null},e.intersects=function(se,ve,Ie){return se=new we(se,Ie),ve=new we(ve,Ie),se.intersects(ve)},e.coerce=function(se){if(se instanceof fe)return se;if(typeof se!="string")return null;var ve=se.match(m[w]);return ve==null?null:re((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,k(1))},function(me,e){var k,F,h=me.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(r){if(k===setTimeout)return setTimeout(r,0);if((k===L||!k)&&setTimeout)return k=setTimeout,setTimeout(r,0);try{return k(r,0)}catch{try{return k.call(null,r,0)}catch{return k.call(this,r,0)}}}(function(){try{k=typeof setTimeout=="function"?setTimeout:L}catch{k=L}try{F=typeof clearTimeout=="function"?clearTimeout:A}catch{F=A}})();var E,b=[],R=!1,I=-1;function $(){R&&E&&(R=!1,E.length?b=E.concat(b):I=-1,b.length&&S())}function S(){if(!R){var r=m($);R=!0;for(var s=b.length;s;){for(E=b,b=[];++I<s;)E&&E[I].run();I=-1,s=b.length}E=null,R=!1,function(c){if(F===clearTimeout)return clearTimeout(c);if((F===A||!F)&&clearTimeout)return F=clearTimeout,clearTimeout(c);try{F(c)}catch{try{return F.call(null,c)}catch{return F.call(this,c)}}}(r)}}function D(r,s){this.fun=r,this.array=s}function p(){}h.nextTick=function(r){var s=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)s[c-1]=arguments[c];b.push(new D(r,s)),b.length!==1||R||m(S)},D.prototype.run=function(){this.fun.apply(null,this.array)},h.title="browser",h.browser=!0,h.env={},h.argv=[],h.version="",h.versions={},h.on=p,h.addListener=p,h.once=p,h.off=p,h.removeListener=p,h.removeAllListeners=p,h.emit=p,h.prependListener=p,h.prependOnceListener=p,h.listeners=function(r){return[]},h.binding=function(r){throw new Error("process.binding is not supported")},h.cwd=function(){return"/"},h.chdir=function(r){throw new Error("process.chdir is not supported")},h.umask=function(){return 0}}])}),define(De[39],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=void 0;const k=globalThis.performance&&typeof globalThis.performance.now=="function";class F{static create(L){return new F(L)}constructor(L){this.c=k&&L===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$3c=F}),define(De[3],Ce([1,0,8,67,4,68,39]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=e.$9c=e.$8c=e.$7c=e.$6c=e.$5c=e.Event=void 0;const m=!1,E=!1;var b;(function(d){d.None=()=>h.$lb.None;function v(ne){if(E){const{onDidAddListener:ee}=ne,he=D.create();let X=0;ne.onDidAddListener=()=>{++X===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),he.print()),ee?.()}}}function l(ne,ee){return Y(ne,()=>{},0,void 0,!0,void 0,ee)}d.defer=l;function w(ne){return(ee,he=null,X)=>{let ue=!1,oe;return oe=ne(le=>{if(!ue)return oe?oe.dispose():ue=!0,ee.call(he,le)},null,X),ue&&oe.dispose(),oe}}d.once=w;function P(ne,ee,he){return U((X,ue=null,oe)=>ne(le=>X.call(ue,ee(le)),null,oe),he)}d.map=P;function M(ne,ee,he){return U((X,ue=null,oe)=>ne(le=>{ee(le),X.call(ue,le)},null,oe),he)}d.forEach=M;function N(ne,ee,he){return U((X,ue=null,oe)=>ne(le=>ee(le)&&X.call(ue,le),null,oe),he)}d.filter=N;function T(ne){return ne}d.signal=T;function z(...ne){return(ee,he=null,X)=>(0,h.$ib)(...ne.map(ue=>ue(oe=>ee.call(he,oe),null,X)))}d.any=z;function j(ne,ee,he,X){let ue=he;return P(ne,oe=>(ue=ee(ue,oe),ue),X)}d.reduce=j;function U(ne,ee){let he;const X={onWillAddFirstListener(){he=ne(ue.fire,ue)},onDidRemoveLastListener(){he?.dispose()}};ee||v(X);const ue=new f(X);return ee?.add(ue),ue.event}function Y(ne,ee,he=100,X=!1,ue=!1,oe,le){let we,O,K,G=0,x;const pe={leakWarningThreshold:oe,onWillAddFirstListener(){we=ne(ve=>{G++,O=ee(O,ve),X&&!K&&(se.fire(O),O=void 0),x=()=>{const Ie=O;O=void 0,K=void 0,(!X||G>1)&&se.fire(Ie),G=0},typeof he=="number"?(clearTimeout(K),K=setTimeout(x,he)):K===void 0&&(K=0,queueMicrotask(x))})},onWillRemoveListener(){ue&&G>0&&x?.()},onDidRemoveLastListener(){x=void 0,we.dispose()}};le||v(pe);const se=new f(pe);return le?.add(se),se.event}d.debounce=Y;function H(ne,ee=0,he){return d.debounce(ne,(X,ue)=>X?(X.push(ue),X):[ue],ee,void 0,!0,void 0,he)}d.accumulate=H;function ge(ne,ee=(X,ue)=>X===ue,he){let X=!0,ue;return N(ne,oe=>{const le=X||!ee(oe,ue);return X=!1,ue=oe,le},he)}d.latch=ge;function ie(ne,ee,he){return[d.filter(ne,ee,he),d.filter(ne,X=>!ee(X),he)]}d.split=ie;function te(ne,ee=!1,he=[]){let X=he.slice(),ue=ne(we=>{X?X.push(we):le.fire(we)});const oe=()=>{X?.forEach(we=>le.fire(we)),X=null},le=new f({onWillAddFirstListener(){ue||(ue=ne(we=>le.fire(we)))},onDidAddFirstListener(){X&&(ee?setTimeout(oe):oe())},onDidRemoveLastListener(){ue&&ue.dispose(),ue=null}});return le.event}d.buffer=te;class q{constructor(ee){this.event=ee,this.d=new h.$kb}map(ee){return new q(P(this.event,ee,this.d))}forEach(ee){return new q(M(this.event,ee,this.d))}filter(ee){return new q(N(this.event,ee,this.d))}reduce(ee,he){return new q(j(this.event,ee,he,this.d))}latch(){return new q(ge(this.event,void 0,this.d))}debounce(ee,he=100,X=!1,ue=!1,oe){return new q(Y(this.event,ee,he,X,ue,oe,this.d))}on(ee,he,X){return this.event(ee,he,X)}once(ee,he,X){return w(this.event)(ee,he,X)}dispose(){this.d.dispose()}}function V(ne){return new q(ne)}d.chain=V;function ce(ne,ee,he=X=>X){const X=(...we)=>le.fire(he(...we)),ue=()=>ne.on(ee,X),oe=()=>ne.removeListener(ee,X),le=new f({onWillAddFirstListener:ue,onDidRemoveLastListener:oe});return le.event}d.fromNodeEventEmitter=ce;function re(ne,ee,he=X=>X){const X=(...we)=>le.fire(he(...we)),ue=()=>ne.addEventListener(ee,X),oe=()=>ne.removeEventListener(ee,X),le=new f({onWillAddFirstListener:ue,onDidRemoveLastListener:oe});return le.event}d.fromDOMEventEmitter=re;function fe(ne){return new Promise(ee=>w(ne)(ee))}d.toPromise=fe;function de(ne,ee){return ee(void 0),ne(he=>ee(he))}d.runAndSubscribe=de;function B(ne,ee){let he=null;function X(oe){he?.dispose(),he=new h.$kb,ee(oe,he)}X(void 0);const ue=ne(oe=>X(oe));return(0,h.$jb)(()=>{ue.dispose(),he?.dispose()})}d.runAndSubscribeWithStore=B;class _{constructor(ee,he){this._observable=ee,this.d=0,this.f=!1;const X={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};he||v(X),this.emitter=new f(X),he&&he.add(this.emitter)}beginUpdate(ee){this.d++}handlePossibleChange(ee){}handleChange(ee,he){this.f=!0}endUpdate(ee){this.d--,this.d===0&&(this._observable.reportChanges(),this.f&&(this.f=!1,this.emitter.fire(this._observable.get())))}}function Ee(ne,ee){return new _(ne,ee).emitter.event}d.fromObservable=Ee;function Re(ne){return ee=>{let he=0,X=!1;const ue={beginUpdate(){he++},endUpdate(){he--,he===0&&(ne.reportChanges(),X&&(X=!1,ee()))},handlePossibleChange(){},handleChange(){X=!0}};return ne.addObserver(ue),ne.reportChanges(),{dispose(){ne.removeObserver(ue)}}}}d.fromObservableLight=Re})(b||(e.Event=b={}));class R{static{this.all=new Set}static{this.d=0}constructor(v){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${v}_${R.d++}`,R.all.add(this)}start(v){this.f=new A.$3c,this.listenerCount=v}stop(){if(this.f){const v=this.f.elapsed();this.durations.push(v),this.elapsedOverall+=v,this.invocationCount+=1,this.f=void 0}}}e.$5c=R;let I=-1;function $(d){const v=I;return I=d,{dispose(){I=v}}}e.$6c=$;class S{constructor(v,l=Math.random().toString(18).slice(2,5)){this.threshold=v,this.name=l,this.f=0}dispose(){this.d?.clear()}check(v,l){const w=this.threshold;if(w<=0||l<w)return;this.d||(this.d=new Map);const P=this.d.get(v.value)||0;if(this.d.set(v.value,P+1),this.f-=1,this.f<=0){this.f=w*.5;let M,N=0;for(const[T,z]of this.d)(!M||N<z)&&(M=T,N=z);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${N}):`),console.warn(M)}return()=>{const M=this.d.get(v.value)||0;this.d.set(v.value,M-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(v){this.value=v}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class r{constructor(v){this.value=v,this.id=p++}}const s=2,c=(d,v)=>{if(d instanceof r)v(d);else for(let l=0;l<d.length;l++){const w=d[l];w&&v(w)}};class f{constructor(v){this.u=0,this.d=v,this.f=I>0||this.d?.leakWarningThreshold?new S(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new R(this.d._profName):void 0,this.t=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.t?.current===this&&this.t.reset(),this.q){if(m){const v=this.q;queueMicrotask(()=>{c(v,l=>l.stack?.print())})}this.q=void 0,this.u=0}this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.m??=(v,l,w)=>{if(this.f&&this.u>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),h.$lb.None;if(this.j)return h.$lb.None;l&&(v=v.bind(l));const P=new r(v);let M,N;this.f&&this.u>=Math.ceil(this.f.threshold*.2)&&(P.stack=D.create(),M=this.f.check(P.stack,this.u+1)),m&&(P.stack=N??D.create()),this.q?this.q instanceof r?(this.t??=new C,this.q=[this.q,P]):this.q.push(P):(this.d?.onWillAddFirstListener?.(this),this.q=P,this.d?.onDidAddFirstListener?.(this)),this.u++;const T=(0,h.$jb)(()=>{M?.(),this.v(P)});return w instanceof h.$kb?w.add(T):Array.isArray(w)&&w.push(T),T},this.m}v(v){if(this.d?.onWillRemoveListener?.(this),!this.q)return;if(this.u===1){this.q=void 0,this.d?.onDidRemoveLastListener?.(this),this.u=0;return}const l=this.q,w=l.indexOf(v);if(w===-1)throw console.log("disposed?",this.j),console.log("size?",this.u),console.log("arr?",JSON.stringify(this.q)),new Error("Attempted to dispose unknown listener");this.u--,l[w]=void 0;const P=this.t.current===this;if(this.u*s<=l.length){let M=0;for(let N=0;N<l.length;N++)l[N]?l[M++]=l[N]:P&&(this.t.end--,M<this.t.i&&this.t.i--);l.length=M}}w(v,l){if(!v)return;const w=this.d?.onListenerError||k.$Y;if(!w){v.value(l);return}try{v.value(l)}catch(P){w(P)}}x(v){const l=v.current.q;for(;v.i<v.end;)this.w(l[v.i++],v.value);v.reset()}fire(v){if(this.t?.current&&(this.x(this.t),this.g?.stop()),this.g?.start(this.u),this.q)if(this.q instanceof r)this.w(this.q,v);else{const l=this.t;l.enqueue(this,v,this.q.length),this.x(l)}this.g?.stop()}hasListeners(){return this.u>0}}e.$7c=f;const y=()=>new C;e.$8c=y;class C{constructor(){this.i=-1,this.end=0}enqueue(v,l,w){this.i=0,this.end=w,this.current=v,this.value=l}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends f{async fireAsync(v,l,w){if(this.q)for(this.h||(this.h=new L.$lc),c(this.q,P=>this.h.push([P.value,v]));this.h.size>0&&!l.isCancellationRequested;){const[P,M]=this.h.shift(),N=[],T={...M,token:l,waitUntil:z=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");w&&(z=w(z,P)),N.push(z)}};try{P(T)}catch(z){(0,k.$Y)(z);continue}Object.freeze(N),await Promise.allSettled(N).then(z=>{for(const j of z)j.status==="rejected"&&(0,k.$Y)(j.reason)})}}}e.$9c=i;class a extends f{get isPaused(){return this.h!==0}constructor(v){super(v),this.h=0,this.s=new L.$lc,this.y=v?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.y){if(this.s.size>0){const v=Array.from(this.s);this.s.clear(),super.fire(this.y(v))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(v){this.u&&(this.h!==0?this.s.push(v):super.fire(v))}}e.$0c=a;class n extends a{constructor(v){super(v),this.k=v.delay??100}fire(v){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(v)}}e.$$c=n;class t extends f{constructor(v){super(v),this.h=[],this.k=v?.merge}fire(v){this.hasListeners()&&(this.h.push(v),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(l=>super.fire(l)),this.h=[]}))}}e.$_c=t;class o{constructor(){this.f=!1,this.g=[],this.d=new f({onWillAddFirstListener:()=>this.h(),onDidRemoveLastListener:()=>this.j()})}get event(){return this.d.event}add(v){const l={event:v,listener:null};this.g.push(l),this.f&&this.k(l);const w=()=>{this.f&&this.m(l);const P=this.g.indexOf(l);this.g.splice(P,1)};return(0,h.$jb)((0,F.$cb)(w))}h(){this.f=!0,this.g.forEach(v=>this.k(v))}j(){this.f=!1,this.g.forEach(v=>this.m(v))}k(v){v.listener=v.event(l=>this.d.fire(l))}m(v){v.listener&&v.listener.dispose(),v.listener=null}dispose(){this.d.dispose()}}e.$ad=o;class g{constructor(){this.d=[]}wrapEvent(v){return(l,w,P)=>v(M=>{const N=this.d[this.d.length-1];N?N.push(()=>l.call(w,M)):l.call(w,M)},void 0,P)}bufferEvents(v){const l=[];this.d.push(l);const w=v();return this.d.pop(),l.forEach(P=>P()),w}}e.$bd=g;class u{constructor(){this.d=!1,this.f=b.None,this.g=h.$lb.None,this.h=new f({onDidAddFirstListener:()=>{this.d=!0,this.g=this.f(this.h.fire,this.h)},onDidRemoveLastListener:()=>{this.d=!1,this.g.dispose()}}),this.event=this.h.event}set input(v){this.f=v,this.d&&(this.g.dispose(),this.g=v(this.h.fire,this.h))}dispose(){this.g.dispose(),this.h.dispose()}}e.$cd=u}),define(De[21],Ce([1,0,3]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=e.CancellationToken=void 0;const F=Object.freeze(function(m,E){const b=setTimeout(m.bind(E),0);return{dispose(){clearTimeout(b)}}});var h;(function(m){function E(b){return b===m.None||b===m.Cancelled||b instanceof L?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}m.isCancellationToken=E,m.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:k.Event.None}),m.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:F})})(h||(e.CancellationToken=h={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?F:(this.b||(this.b=new k.$7c),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(E){this.a=void 0,this.b=void 0,this.b=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new L),this.a}cancel(){this.a?this.a instanceof L&&this.a.cancel():this.a=h.Cancelled}dispose(E=!1){E&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof L&&this.a.dispose():this.a=h.None}}e.$dd=A}),define(De[153],Ce([1,0,21]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gd=e.$fd=e.$ed=void 0;class F{constructor(m){this.b=m,this.a=null}get(){if(this.a)return this.a;const m=new k.$dd,E=this.b(m.token);return this.a={promise:E,dispose:()=>{this.a=null,m.cancel(),m.dispose()}},this.a}}e.$ed=F;class h{constructor(m){this.c=m,this.a=void 0,this.b=void 0}get(m){const E=JSON.stringify(m);return this.b!==E&&(this.b=E,this.a=this.c(m)),this.a}}e.$fd=h;class L{get cachedValues(){return this.a}constructor(m){this.b=m,this.a=new Map}get(m){if(this.a.has(m))return this.a.get(m);const E=this.b(m);return this.a.set(m,E),E}}e.$gd=L}),define(De[92],Ce([1,0,8,4]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function h(y){const C=y;return C?typeof C.read=="function":!1}e.$ub=h;function L(y){const C=y;return C?[C.on,C.pause,C.resume,C.destroy].every(i=>typeof i=="function"):!1}e.$vb=L;function A(y){const C=y;return C?L(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.$wb=A;function m(y,C){return new E(y,C)}e.$xb=m;class E{constructor(C,i){this.e=C,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(i=>i(C))}h(C){this.c.error.length===0?(0,k.$Y)(C):this.c.error.slice(0).forEach(i=>i(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,i){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(C,i){if(this.a.destroyed)return;let a;switch(C){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const n=a.indexOf(i);n>=0&&a.splice(n,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(y,C){const i=[];let a;for(;(a=y.read())!==null;)i.push(a);return C(i)}e.$yb=b;function R(y,C,i){const a=[];let n;for(;(n=y.read())!==null&&a.length<i;)a.push(n);return n===null&&a.length>0?C(a):{read:()=>{if(a.length>0)return a.shift();if(typeof n<"u"){const t=n;return n=void 0,t}return y.read()}}}e.$zb=R;function I(y,C){return new Promise((i,a)=>{const n=[];$(y,{onData:t=>{C&&n.push(t)},onError:t=>{C?a(t):i(void 0)},onEnd:()=>{i(C?C(n):void 0)}})})}e.$Ab=I;function $(y,C){let i=!1;return y.on("error",a=>{i||C.onError(a)}),y.on("end",()=>{i||C.onEnd()}),y.on("data",a=>{i||C.onData(a)}),(0,F.$jb)(()=>i=!0)}e.$Bb=$;function S(y,C){return new Promise((i,a)=>{const n=new F.$kb,t=[],o=d=>{if(t.push(d),t.length>C)return n.dispose(),y.pause(),i({stream:y,buffer:t,ended:!1})},g=d=>a(d),u=()=>i({stream:y,buffer:t,ended:!0});n.add((0,F.$jb)(()=>y.removeListener("error",g))),y.on("error",g),n.add((0,F.$jb)(()=>y.removeListener("end",u))),y.on("end",u),n.add((0,F.$jb)(()=>y.removeListener("data",o))),y.on("data",o)})}e.$Cb=S;function D(y,C){const i=m(C);return i.end(y),i}e.$Db=D;function p(){const y=m(()=>{throw new Error("not supported")});return y.end(),y}e.$Eb=p;function r(y){let C=!1;return{read:()=>C?null:(C=!0,y)}}e.$Fb=r;function s(y,C,i){const a=m(i);return $(y,{onData:n=>a.write(C.data(n)),onError:n=>a.error(C.error?C.error(n):n),onEnd:()=>a.end()}),a}e.$Gb=s;function c(y,C,i){let a=!1;return{read:()=>{const n=C.read();return a?n:(a=!0,n!==null?i([y,n]):y)}}}e.$Hb=c;function f(y,C,i){let a=!1;const n=m(i);return $(C,{onData:t=>a?n.write(t):(a=!0,n.write(i([y,t]))),onError:t=>n.error(t),onEnd:()=>{a||(a=!0,n.write(y)),n.end()}}),n}e.$Ib=f}),define(De[22],Ce([1,0,54,92]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const h=typeof Buffer<"u",L=new k.$T(()=>new Uint8Array(256));let A,m;class E{static alloc(w){return h?new E(Buffer.allocUnsafe(w)):new E(new Uint8Array(w))}static wrap(w){return h&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new E(w)}static fromString(w,P){return!(P?.dontUseNodeBuffer||!1)&&h?new E(Buffer.from(w)):(A||(A=new TextEncoder),new E(A.encode(w)))}static fromByteArray(w){const P=E.alloc(w.length);for(let M=0,N=w.length;M<N;M++)P.buffer[M]=w[M];return P}static concat(w,P){if(typeof P>"u"){P=0;for(let T=0,z=w.length;T<z;T++)P+=w[T].byteLength}const M=E.alloc(P);let N=0;for(let T=0,z=w.length;T<z;T++){const j=w[T];M.set(j,N),N+=j.byteLength}return M}constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}clone(){const w=E.alloc(this.byteLength);return w.set(this),w}toString(){return h?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(w,P){return new E(this.buffer.subarray(w,P))}set(w,P){if(w instanceof E)this.buffer.set(w.buffer,P);else if(w instanceof Uint8Array)this.buffer.set(w,P);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),P);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return $(this.buffer,w)}writeUInt32BE(w,P){S(this.buffer,w,P)}readUInt32LE(w){return D(this.buffer,w)}writeUInt32LE(w,P){p(this.buffer,w,P)}readUInt8(w){return r(this.buffer,w)}writeUInt8(w,P){s(this.buffer,w,P)}indexOf(w,P=0){return b(this.buffer,w instanceof E?w.buffer:w,P)}}e.$Jb=E;function b(l,w,P=0){const M=w.byteLength,N=l.byteLength;if(M===0)return 0;if(M===1)return l.indexOf(w[0]);if(M>N-P)return-1;const T=L.value;T.fill(w.length);for(let Y=0;Y<w.length;Y++)T[w[Y]]=w.length-Y-1;let z=P+w.length-1,j=z,U=-1;for(;z<N;)if(l[z]===w[j]){if(j===0){U=z;break}z--,j--}else z+=Math.max(w.length-j,T[l[z]]),j=w.length-1;return U}e.$Kb=b;function R(l,w){return l[w+0]<<0>>>0|l[w+1]<<8>>>0}e.$Lb=R;function I(l,w,P){l[P+0]=w&255,w=w>>>8,l[P+1]=w&255}e.$Mb=I;function $(l,w){return l[w]*2**24+l[w+1]*2**16+l[w+2]*2**8+l[w+3]}e.$Nb=$;function S(l,w,P){l[P+3]=w,w=w>>>8,l[P+2]=w,w=w>>>8,l[P+1]=w,w=w>>>8,l[P]=w}e.$Ob=S;function D(l,w){return l[w+0]<<0>>>0|l[w+1]<<8>>>0|l[w+2]<<16>>>0|l[w+3]<<24>>>0}e.$Pb=D;function p(l,w,P){l[P+0]=w&255,w=w>>>8,l[P+1]=w&255,w=w>>>8,l[P+2]=w&255,w=w>>>8,l[P+3]=w&255}e.$Qb=p;function r(l,w){return l[w]}e.$Rb=r;function s(l,w,P){l[P]=w}e.$Sb=s;function c(l){return F.$yb(l,w=>E.concat(w))}e.$Tb=c;function f(l){return F.$Fb(l)}e.$Ub=f;function y(l){return F.$Ab(l,w=>E.concat(w))}e.$Vb=y;async function C(l){return l.ended?E.concat(l.buffer):E.concat([...l.buffer,await y(l.stream)])}e.$Wb=C;function i(l){return F.$Db(l,w=>E.concat(w))}e.$Xb=i;function a(l){return F.$Gb(l,{data:w=>typeof w=="string"?E.fromString(w):E.wrap(w)},w=>E.concat(w))}e.$Yb=a;function n(l){return F.$xb(w=>E.concat(w),l)}e.$Zb=n;function t(l,w){return F.$Hb(l,w,P=>E.concat(P))}e.$1b=t;function o(l,w){return F.$Ib(l,w,P=>E.concat(P))}e.$2b=o;function g(l){let w=0,P=0,M=0;const N=new Uint8Array(Math.floor(l.length/4*3)),T=j=>{switch(P){case 3:N[M++]=w|j,P=0;break;case 2:N[M++]=w|j>>>2,w=j<<6,P=3;break;case 1:N[M++]=w|j>>>4,w=j<<4,P=2;break;default:w=j<<2,P=1}};for(let j=0;j<l.length;j++){const U=l.charCodeAt(j);if(U>=65&&U<=90)T(U-65);else if(U>=97&&U<=122)T(U-97+26);else if(U>=48&&U<=57)T(U-48+52);else if(U===43||U===45)T(62);else if(U===47||U===95)T(63);else{if(U===61)break;throw new SyntaxError(`Unexpected base64 character ${l[j]}`)}}const z=M;for(;P>0;)T(0);return E.wrap(N).slice(0,z)}e.$3b=g;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",d="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:l},w=!0,P=!1){const M=P?d:u;let N="";const T=l.byteLength%3;let z=0;for(;z<l.byteLength-T;z+=3){const j=l[z+0],U=l[z+1],Y=l[z+2];N+=M[j>>>2],N+=M[(j<<4|U>>>4)&63],N+=M[(U<<2|Y>>>6)&63],N+=M[Y&63]}if(T===1){const j=l[z+0];N+=M[j>>>2],N+=M[j<<4&63],w&&(N+="==")}else if(T===2){const j=l[z+0],U=l[z+1];N+=M[j>>>2],N+=M[(j<<4|U>>>4)&63],N+=M[U<<2&63],w&&(N+="=")}return N}e.$4b=v}),define(De[12],Ce([1,0,153,54]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$he=e.$ge=e.$fe=e.$ee=e.GraphemeBreakType=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=e.$ud=e.$td=e.$sd=e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=void 0;function h(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.$jd=h;const L=/{(\d+)}/g;function A(Pe,...ke){return ke.length===0?Pe:Pe.replace(L,function(Be,Q){const Z=parseInt(Q,10);return isNaN(Z)||Z<0||Z>=ke.length?Be:ke[Z]})}e.$kd=A;const m=/{([^}]+)}/g;function E(Pe,ke){return Pe.replace(m,(Be,Q)=>ke[Q]??Be)}e.$ld=E;function b(Pe){return Pe.replace(/[<>&]/g,function(ke){switch(ke){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ke}})}e.$md=b;function R(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$nd=R;function I(Pe,ke){let Be=0;const Q=ke.charCodeAt(0);for(let Z=Pe.length-1;Z>=0;Z--)Pe.charCodeAt(Z)===Q&&Be++;return Be}e.$od=I;function $(Pe,ke,Be="\u2026"){return Pe.length<=ke?Pe:`${Pe.substr(0,ke)}${Be}`}e.$pd=$;function S(Pe,ke=" "){const Be=D(Pe,ke);return p(Be,ke)}e.$qd=S;function D(Pe,ke){if(!Pe||!ke)return Pe;const Be=ke.length;if(Be===0||Pe.length===0)return Pe;let Q=0;for(;Pe.indexOf(ke,Q)===Q;)Q=Q+Be;return Pe.substring(Q)}e.$rd=D;function p(Pe,ke){if(!Pe||!ke)return Pe;const Be=ke.length,Q=Pe.length;if(Be===0||Q===0)return Pe;let Z=Q,ye=-1;for(;ye=Pe.lastIndexOf(ke,Z-1),!(ye===-1||ye+Be!==Z);){if(ye===0)return"";Z=ye}return Pe.substring(0,Z)}e.$sd=p;function r(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$td=r;function s(Pe){return Pe.replace(/\*/g,"")}e.$ud=s;function c(Pe,ke,Be={}){if(!Pe)throw new Error("Cannot create regex from empty string");ke||(Pe=R(Pe)),Be.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Q="";return Be.global&&(Q+="g"),Be.matchCase||(Q+="i"),Be.multiline&&(Q+="m"),Be.unicode&&(Q+="u"),new RegExp(Pe,Q)}e.$vd=c;function f(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.$wd=f;function y(Pe){return!!Pe.match(/([^\\]|^)(\\\\)*\\\d+/)}e.$xd=y;function C(Pe){return(Pe.global?"g":"")+(Pe.ignoreCase?"i":"")+(Pe.multiline?"m":"")+(Pe.unicode?"u":"")}e.$yd=C;function i(Pe){return Pe.split(/\r\n|\r|\n/)}e.$zd=i;function a(Pe){for(let ke=0,Be=Pe.length;ke<Be;ke++){const Q=Pe.charCodeAt(ke);if(Q!==32&&Q!==9)return ke}return-1}e.$Ad=a;function n(Pe,ke=0,Be=Pe.length){for(let Q=ke;Q<Be;Q++){const Z=Pe.charCodeAt(Q);if(Z!==32&&Z!==9)return Pe.substring(ke,Q)}return Pe.substring(ke,Be)}e.$Bd=n;function t(Pe,ke=Pe.length-1){for(let Be=ke;Be>=0;Be--){const Q=Pe.charCodeAt(Be);if(Q!==32&&Q!==9)return Be}return-1}e.$Cd=t;function o(Pe,ke,Be){const Q=[];let Z=0;for(const ye of Pe.matchAll(ke)){if(Q.push(Pe.slice(Z,ye.index)),ye.index===void 0)throw new Error("match.index should be defined");Z=ye.index+ye[0].length,Q.push(Be(ye[0],...ye.slice(1),ye.index,Pe,ye.groups))}return Q.push(Pe.slice(Z)),Promise.all(Q).then(ye=>ye.join(""))}e.$Dd=o;function g(Pe,ke){return Pe<ke?-1:Pe>ke?1:0}e.$Ed=g;function u(Pe,ke,Be=0,Q=Pe.length,Z=0,ye=ke.length){for(;Be<Q&&Z<ye;Be++,Z++){const Ye=Pe.charCodeAt(Be),_e=ke.charCodeAt(Z);if(Ye<_e)return-1;if(Ye>_e)return 1}const je=Q-Be,Oe=ye-Z;return je<Oe?-1:je>Oe?1:0}e.$Fd=u;function d(Pe,ke){return v(Pe,ke,0,Pe.length,0,ke.length)}e.$Gd=d;function v(Pe,ke,Be=0,Q=Pe.length,Z=0,ye=ke.length){for(;Be<Q&&Z<ye;Be++,Z++){let Ye=Pe.charCodeAt(Be),_e=ke.charCodeAt(Z);if(Ye===_e)continue;if(Ye>=128||_e>=128)return u(Pe.toLowerCase(),ke.toLowerCase(),Be,Q,Z,ye);w(Ye)&&(Ye-=32),w(_e)&&(_e-=32);const rt=Ye-_e;if(rt!==0)return rt}const je=Q-Be,Oe=ye-Z;return je<Oe?-1:je>Oe?1:0}e.$Hd=v;function l(Pe){return Pe>=48&&Pe<=57}e.$Id=l;function w(Pe){return Pe>=97&&Pe<=122}e.$Jd=w;function P(Pe){return Pe>=65&&Pe<=90}e.$Kd=P;function M(Pe,ke){return Pe.length===ke.length&&v(Pe,ke)===0}e.$Ld=M;function N(Pe,ke){const Be=ke.length;return ke.length>Pe.length?!1:v(Pe,ke,0,Be)===0}e.$Md=N;function T(Pe,ke){const Be=Math.min(Pe.length,ke.length);let Q;for(Q=0;Q<Be;Q++)if(Pe.charCodeAt(Q)!==ke.charCodeAt(Q))return Q;return Be}e.$Nd=T;function z(Pe,ke){const Be=Math.min(Pe.length,ke.length);let Q;const Z=Pe.length-1,ye=ke.length-1;for(Q=0;Q<Be;Q++)if(Pe.charCodeAt(Z-Q)!==ke.charCodeAt(ye-Q))return Q;return Be}e.$Od=z;function j(Pe){return 55296<=Pe&&Pe<=56319}e.$Pd=j;function U(Pe){return 56320<=Pe&&Pe<=57343}e.$Qd=U;function Y(Pe,ke){return(Pe-55296<<10)+(ke-56320)+65536}e.$Rd=Y;function H(Pe,ke,Be){const Q=Pe.charCodeAt(Be);if(j(Q)&&Be+1<ke){const Z=Pe.charCodeAt(Be+1);if(U(Z))return Y(Q,Z)}return Q}e.$Sd=H;function ge(Pe,ke){const Be=Pe.charCodeAt(ke-1);if(U(Be)&&ke>1){const Q=Pe.charCodeAt(ke-2);if(j(Q))return Y(Q,Be)}return Be}class ie{get offset(){return this.e}constructor(ke,Be=0){this.c=ke,this.d=ke.length,this.e=Be}setOffset(ke){this.e=ke}prevCodePoint(){const ke=ge(this.c,this.e);return this.e-=ke>=65536?2:1,ke}nextCodePoint(){const ke=H(this.c,this.d,this.e);return this.e+=ke>=65536?2:1,ke}eol(){return this.e>=this.d}}e.$Td=ie;class te{get offset(){return this.c.offset}constructor(ke,Be=0){this.c=new ie(ke,Be)}nextGraphemeLength(){const ke=Ue.getInstance(),Be=this.c,Q=Be.offset;let Z=ke.getGraphemeBreakType(Be.nextCodePoint());for(;!Be.eol();){const ye=Be.offset,je=ke.getGraphemeBreakType(Be.nextCodePoint());if(ve(Z,je)){Be.setOffset(ye);break}Z=je}return Be.offset-Q}prevGraphemeLength(){const ke=Ue.getInstance(),Be=this.c,Q=Be.offset;let Z=ke.getGraphemeBreakType(Be.prevCodePoint());for(;Be.offset>0;){const ye=Be.offset,je=ke.getGraphemeBreakType(Be.prevCodePoint());if(ve(je,Z)){Be.setOffset(ye);break}Z=je}return Q-Be.offset}eol(){return this.c.eol()}}e.$Ud=te;function q(Pe,ke){return new te(Pe,ke).nextGraphemeLength()}e.$Vd=q;function V(Pe,ke){return new te(Pe,ke).prevGraphemeLength()}e.$Wd=V;function ce(Pe,ke){ke>0&&U(Pe.charCodeAt(ke))&&ke--;const Be=ke+q(Pe,ke);return[Be-V(Pe,Be),Be]}e.$Xd=ce;function re(Pe){const ke=new te(Pe);let Be=0;for(;!ke.eol();)Be++,ke.nextGraphemeLength();return Be}e.$Yd=re;let fe;function de(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function B(Pe){return fe||(fe=de()),fe.test(Pe)}e.$Zd=B;const _=/^[\t\n\r\x20-\x7E]*$/;function Ee(Pe){return _.test(Pe)}e.$1d=Ee,e.$2d=/[\u2028\u2029]/;function Re(Pe){return e.$2d.test(Pe)}e.$3d=Re;function ne(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.$4d=ne;function ee(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.$5d=ee;function he(Pe,ke){if(Pe.length<ke)return Pe;const Be=/\b/g;let Q=0;for(;Be.test(Pe)&&!(Pe.length-Be.lastIndex<ke);)Q=Be.lastIndex,Be.lastIndex+=1;return Pe.substring(Q).replace(/^\s/,"")}e.$6d=he;const X=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ue=/\x1b\].*?\x07/g;function oe(Pe){return Pe&&(Pe=Pe.replace(X,"").replace(ue,"")),Pe}e.$7d=oe,e.$8d=String.fromCharCode(65279);function le(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.$9d=le;function we(Pe){return le(Pe)?Pe.substr(1):Pe}e.$0d=we;function O(Pe,ke){if(!Pe||!ke||Pe.length<ke.length)return!1;const Be=ke.length,Q=Pe.toLowerCase();let Z=0,ye=-1;for(;Z<Be;){const je=Q.indexOf(ke[Z],ye+1);if(je<0)return!1;ye=je,Z++}return!0}e.$$d=O;function K(Pe,ke=!1){return Pe?(ke&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.$_d=K;function G(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.$ae=G;function x(Pe,ke=1){if(ke===0)return"";let Be=-1;do Be=Pe.indexOf(`
`,Be+1),ke--;while(ke>0&&Be>=0);return Be===-1?Pe:(Pe[Be-1]==="\r"&&Be--,Pe.substr(0,Be))}e.$be=x;function pe(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.$ce=pe;function se(Pe){return Ue.getInstance().getGraphemeBreakType(Pe)}e.$de=se;function ve(Pe,ke){return Pe===0?ke!==5&&ke!==7:Pe===2&&ke===3?!1:Pe===4||Pe===2||Pe===3||ke===4||ke===2||ke===3?!0:!(Pe===8&&(ke===8||ke===9||ke===11||ke===12)||(Pe===11||Pe===9)&&(ke===9||ke===10)||(Pe===12||Pe===10)&&ke===10||ke===5||ke===13||ke===7||Pe===1||Pe===13&&ke===14||Pe===6&&ke===6)}var Ie;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(Ie||(e.GraphemeBreakType=Ie={}));class Ue{static{this.c=null}static getInstance(){return Ue.c||(Ue.c=new Ue),Ue.c}constructor(){this.d=Ve()}getGraphemeBreakType(ke){if(ke<32)return ke===10?3:ke===13?2:4;if(ke<127)return 0;const Be=this.d,Q=Be.length/3;let Z=1;for(;Z<=Q;)if(ke<Be[3*Z])Z=2*Z;else if(ke>Be[3*Z+1])Z=2*Z+1;else return Be[3*Z+2];return 0}}function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function xe(Pe,ke){if(Pe===0)return 0;const Be=Ge(Pe,ke);if(Be!==void 0)return Be;const Q=new ie(ke,Pe);return Q.prevCodePoint(),Q.offset}e.$ee=xe;function Ge(Pe,ke){const Be=new ie(ke,Pe);let Q=Be.prevCodePoint();for(;et(Q)||Q===65039||Q===8419;){if(Be.offset===0)return;Q=Be.prevCodePoint()}if(!ee(Q))return;let Z=Be.offset;return Z>0&&Be.prevCodePoint()===8205&&(Z=Be.offset),Z}function et(Pe){return 127995<=Pe&&Pe<=127999}var Ze;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.$fe="\xA0";class st{static{this.c=new F.$T(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new k.$fd(ke=>{function Be(rt){const ft=new Map;for(let vt=0;vt<rt.length;vt+=2)ft.set(rt[vt],rt[vt+1]);return ft}function Q(rt,ft){const vt=new Map(rt);for(const[Ft,Lt]of ft)vt.set(Ft,Lt);return vt}function Z(rt,ft){if(!rt)return ft;const vt=new Map;for(const[Ft,Lt]of rt)ft.has(Ft)&&vt.set(Ft,Lt);return vt}const ye=this.c.value;let je=ke.filter(rt=>!rt.startsWith("_")&&rt in ye);je.length===0&&(je=["_default"]);let Oe;for(const rt of je){const ft=Be(ye[rt]);Oe=Z(Oe,ft)}const Ye=Be(ye._common),_e=Q(Ye,Oe);return new st(_e)})}static getInstance(ke){return st.d.get(Array.from(ke))}static{this.e=new F.$T(()=>Object.keys(st.c.value).filter(ke=>!ke.startsWith("_")))}static getLocales(){return st.e.value}constructor(ke){this.f=ke}isAmbiguous(ke){return this.f.has(ke)}getPrimaryConfusable(ke){return this.f.get(ke)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$ge=st;class tt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(tt.c())),this.d}static isInvisibleCharacter(ke){return tt.e().has(ke)}static get codePoints(){return tt.e()}}e.$he=tt}),define(De[113],Ce([1,0,28,12]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.FuzzyScore=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.or=void 0;function h(...oe){return function(le,we){for(let O=0,K=oe.length;O<K;O++){const G=oe[O](le,we);if(G)return G}return null}}e.or=h,e.$ij=L.bind(void 0,!1),e.$jj=L.bind(void 0,!0);function L(oe,le,we){if(!we||we.length<le.length)return null;let O;return oe?O=F.$Md(we,le):O=we.indexOf(le)===0,O?le.length>0?[{start:0,end:le.length}]:[]:null}function A(oe,le){const we=le.toLowerCase().indexOf(oe.toLowerCase());return we===-1?null:[{start:we,end:we+oe.length}]}e.$kj=A;function m(oe,le){return E(oe.toLowerCase(),le.toLowerCase(),0,0)}e.$lj=m;function E(oe,le,we,O){if(we===oe.length)return[];if(O===le.length)return null;if(oe[we]===le[O]){let K=null;return(K=E(oe,le,we+1,O+1))?s({start:O,end:O+1},K):null}return E(oe,le,we,O+1)}function b(oe){return 97<=oe&&oe<=122}function R(oe){return 65<=oe&&oe<=90}e.$mj=R;function I(oe){return 48<=oe&&oe<=57}function $(oe){return oe===32||oe===9||oe===10||oe===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(oe=>S.add(oe.charCodeAt(0)));function D(oe){return $(oe)||S.has(oe)}function p(oe,le){return oe===le||D(oe)&&D(le)}function r(oe){return b(oe)||R(oe)||I(oe)}function s(oe,le){return le.length===0?le=[oe]:oe.end===le[0].start?le[0].start=oe.start:le.unshift(oe),le}function c(oe,le){for(let we=le;we<oe.length;we++){const O=oe.charCodeAt(we);if(R(O)||I(O)||we>0&&!r(oe.charCodeAt(we-1)))return we}return oe.length}function f(oe,le,we,O){if(we===oe.length)return[];if(O===le.length)return null;if(oe[we]!==le[O].toLowerCase())return null;{let K=null,G=O+1;for(K=f(oe,le,we+1,O+1);!K&&(G=c(le,G))<le.length;)K=f(oe,le,we+1,G),G++;return K===null?null:s({start:O,end:O+1},K)}}function y(oe){let le=0,we=0,O=0,K=0,G=0;for(let Ie=0;Ie<oe.length;Ie++)G=oe.charCodeAt(Ie),R(G)&&le++,b(G)&&we++,r(G)&&O++,I(G)&&K++;const x=le/oe.length,pe=we/oe.length,se=O/oe.length,ve=K/oe.length;return{upperPercent:x,lowerPercent:pe,alphaPercent:se,numericPercent:ve}}function C(oe){const{upperPercent:le,lowerPercent:we}=oe;return we===0&&le>.6}function i(oe){const{upperPercent:le,lowerPercent:we,alphaPercent:O,numericPercent:K}=oe;return we>.2&&le<.8&&O>.6&&K<.2}function a(oe){let le=0,we=0,O=0,K=0;for(let G=0;G<oe.length;G++)O=oe.charCodeAt(G),R(O)&&le++,b(O)&&we++,$(O)&&K++;return(le===0||we===0)&&K===0?oe.length<=30:le<=5}function n(oe,le){if(!le||(le=le.trim(),le.length===0)||!a(oe)||le.length>60)return null;const we=y(le);if(!i(we)){if(!C(we))return null;le=le.toLowerCase()}let O=null,K=0;for(oe=oe.toLowerCase();K<le.length&&(O=f(oe,le,0,K))===null;)K=c(le,K+1);return O}e.$nj=n;function t(oe,le,we=!1){if(!le||le.length===0)return null;let O=null,K=0;for(oe=oe.toLowerCase(),le=le.toLowerCase();K<le.length&&(O=o(oe,le,0,K,we))===null;)K=g(le,K+1);return O}e.$oj=t;function o(oe,le,we,O,K){if(we===oe.length)return[];if(O===le.length)return null;if(p(oe.charCodeAt(we),le.charCodeAt(O))){let G=null,x=O+1;if(G=o(oe,le,we+1,O+1,K),!K)for(;!G&&(x=g(le,x))<le.length;)G=o(oe,le,we+1,x,K),x++;return G?oe.charCodeAt(we)!==le.charCodeAt(O)?G:s({start:O,end:O+1},G):null}else return null}function g(oe,le){for(let we=le;we<oe.length;we++)if(D(oe.charCodeAt(we))||we>0&&D(oe.charCodeAt(we-1)))return we;return oe.length}const u=h(e.$jj,n,A),d=h(e.$jj,n,m),v=new k.$oi(1e4);function l(oe,le,we=!1){if(typeof oe!="string"||typeof le!="string")return null;let O=v.get(oe);O||(O=new RegExp(F.$td(oe),"i"),v.set(oe,O));const K=O.exec(le);return K?[{start:K.index,end:K.index+K[0].length}]:we?d(oe,le):u(oe,le)}e.$pj=l;function w(oe,le){const we=Ee(oe,oe.toLowerCase(),0,le,le.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return we?M(we):null}e.$qj=w;function P(oe,le,we,O,K,G){const x=Math.min(13,oe.length);for(;we<x;we++){const pe=Ee(oe,le,we,O,K,G,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(pe)return pe}return[0,G]}e.$rj=P;function M(oe){if(typeof oe>"u")return[];const le=[],we=oe[1];for(let O=oe.length-1;O>1;O--){const K=oe[O]+we,G=le[le.length-1];G&&G.end===K?G.end=K+1:le.push({start:K,end:K+1})}return le}e.$sj=M;const N=128;function T(){const oe=[],le=[];for(let we=0;we<=N;we++)le[we]=0;for(let we=0;we<=N;we++)oe.push(le.slice(0));return oe}function z(oe){const le=[];for(let we=0;we<=oe;we++)le[we]=0;return le}const j=z(2*N),U=z(2*N),Y=T(),H=T(),ge=T(),ie=!1;function te(oe,le,we,O,K){function G(pe,se,ve=" "){for(;pe.length<se;)pe=ve+pe;return pe}let x=` |   |${O.split("").map(pe=>G(pe,3)).join("|")}
`;for(let pe=0;pe<=we;pe++)pe===0?x+=" |":x+=`${le[pe-1]}|`,x+=oe[pe].slice(0,K+1).map(se=>G(se.toString(),3)).join("|")+`
`;return x}function q(oe,le,we,O){oe=oe.substr(le),we=we.substr(O),console.log(te(H,oe,oe.length,we,we.length)),console.log(te(ge,oe,oe.length,we,we.length)),console.log(te(Y,oe,oe.length,we,we.length))}function V(oe,le){if(le<0||le>=oe.length)return!1;const we=oe.codePointAt(le);switch(we){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!F.$5d(we)}}function ce(oe,le){if(le<0||le>=oe.length)return!1;switch(oe.charCodeAt(le)){case 32:case 9:return!0;default:return!1}}function re(oe,le,we){return le[oe]!==we[oe]}function fe(oe,le,we,O,K,G,x=!1){for(;le<we&&K<G;)oe[le]===O[K]&&(x&&(j[le]=K),le+=1),K+=1;return le===we}e.$tj=fe;var de;(function(oe){oe[oe.Diag=1]="Diag",oe[oe.Left=2]="Left",oe[oe.LeftLeft=3]="LeftLeft"})(de||(de={}));var B;(function(oe){oe.Default=[-100,0];function le(we){return!we||we.length===2&&we[0]===-100&&we[1]===0}oe.isDefault=le})(B||(e.FuzzyScore=B={}));class _{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(le,we){this.firstMatchCanBeWeak=le,this.boostFullMatch=we}}e.$uj=_;function Ee(oe,le,we,O,K,G,x=_.default){const pe=oe.length>N?N:oe.length,se=O.length>N?N:O.length;if(we>=pe||G>=se||pe-we>se-G||!fe(le,we,pe,K,G,se,!0))return;Re(pe,se,we,G,le,K);let ve=1,Ie=1,Ue=we,Ve=G;const xe=[!1];for(ve=1,Ue=we;Ue<pe;ve++,Ue++){const tt=j[Ue],Pe=U[Ue],ke=Ue+1<pe?U[Ue+1]:se;for(Ie=tt-G+1,Ve=tt;Ve<ke;Ie++,Ve++){let Be=Number.MIN_SAFE_INTEGER,Q=!1;Ve<=Pe&&(Be=ne(oe,le,Ue,we,O,K,Ve,se,G,Y[ve-1][Ie-1]===0,xe));let Z=0;Be!==Number.MAX_SAFE_INTEGER&&(Q=!0,Z=Be+H[ve-1][Ie-1]);const ye=Ve>tt,je=ye?H[ve][Ie-1]+(Y[ve][Ie-1]>0?-5:0):0,Oe=Ve>tt+1&&Y[ve][Ie-1]>0,Ye=Oe?H[ve][Ie-2]+(Y[ve][Ie-2]>0?-5:0):0;if(Oe&&(!ye||Ye>=je)&&(!Q||Ye>=Z))H[ve][Ie]=Ye,ge[ve][Ie]=3,Y[ve][Ie]=0;else if(ye&&(!Q||je>=Z))H[ve][Ie]=je,ge[ve][Ie]=2,Y[ve][Ie]=0;else if(Q)H[ve][Ie]=Z,ge[ve][Ie]=1,Y[ve][Ie]=Y[ve-1][Ie-1]+1;else throw new Error("not possible")}}if(ie&&q(oe,we,O,G),!xe[0]&&!x.firstMatchCanBeWeak)return;ve--,Ie--;const Ge=[H[ve][Ie],G];let et=0,Ze=0;for(;ve>=1;){let tt=Ie;do{const Pe=ge[ve][tt];if(Pe===3)tt=tt-2;else if(Pe===2)tt=tt-1;else break}while(tt>=1);et>1&&le[we+ve-1]===K[G+Ie-1]&&!re(tt+G-1,O,K)&&et+1>Y[ve][tt]&&(tt=Ie),tt===Ie?et++:et=1,Ze||(Ze=tt),ve--,Ie=tt-1,Ge.push(Ie)}se===pe&&x.boostFullMatch&&(Ge[0]+=2);const st=Ze-pe;return Ge[0]-=st,Ge}e.$vj=Ee;function Re(oe,le,we,O,K,G){let x=oe-1,pe=le-1;for(;x>=we&&pe>=O;)K[x]===G[pe]&&(U[x]=pe,x--),pe--}function ne(oe,le,we,O,K,G,x,pe,se,ve,Ie){if(le[we]!==G[x])return Number.MIN_SAFE_INTEGER;let Ue=1,Ve=!1;return x===we-O?Ue=oe[we]===K[x]?7:5:re(x,K,G)&&(x===0||!re(x-1,K,G))?(Ue=oe[we]===K[x]?7:5,Ve=!0):V(G,x)&&(x===0||!V(G,x-1))?Ue=5:(V(G,x-1)||ce(G,x-1))&&(Ue=5,Ve=!0),Ue>1&&we===O&&(Ie[0]=!0),Ve||(Ve=re(x,K,G)||V(G,x-1)||ce(G,x-1)),we===O?x>se&&(Ue-=Ve?3:5):ve?Ue+=Ve?2:0:Ue+=Ve?0:1,x+1===pe&&(Ue-=Ve?3:5),Ue}function ee(oe,le,we,O,K,G,x){return X(oe,le,we,O,K,G,!0,x)}e.$wj=ee;function he(oe,le,we,O,K,G,x){return X(oe,le,we,O,K,G,!1,x)}e.$xj=he;function X(oe,le,we,O,K,G,x,pe){let se=Ee(oe,le,we,O,K,G,pe);if(se&&!x)return se;if(oe.length>=3){const ve=Math.min(7,oe.length-1);for(let Ie=we+1;Ie<ve;Ie++){const Ue=ue(oe,Ie);if(Ue){const Ve=Ee(Ue,Ue.toLowerCase(),we,O,K,G,pe);Ve&&(Ve[0]-=3,(!se||Ve[0]>se[0])&&(se=Ve))}}}return se}function ue(oe,le){if(le+1>=oe.length)return;const we=oe[le],O=oe[le+1];if(we!==O)return oe.slice(0,le)+O+we+oe.slice(le+2)}}),define(De[70],Ce([1,0,12]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=e.$bi=void 0;function F(s){return h(s,0)}e.$bi=F;function h(s,c){switch(typeof s){case"object":return s===null?L(349,c):Array.isArray(s)?E(s,c):b(s,c);case"string":return m(s,c);case"boolean":return A(s,c);case"number":return L(s,c);case"undefined":return L(937,c);default:return L(617,c)}}e.$ci=h;function L(s,c){return(c<<5)-c+s|0}e.$di=L;function A(s,c){return L(s?433:863,c)}function m(s,c){c=L(149417,c);for(let f=0,y=s.length;f<y;f++)c=L(s.charCodeAt(f),c);return c}e.$ei=m;function E(s,c){return c=L(104579,c),s.reduce((f,y)=>h(y,f),c)}function b(s,c){return c=L(181387,c),Object.keys(s).sort().reduce((f,y)=>(f=m(y,f),h(s[y],f)),c)}class R{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=h(c,this.g),this.g}}e.$fi=R;var I;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function $(s,c,f=32){const y=f-c,C=~((1<<y)-1);return(s<<c|(C&s)>>>y)>>>0}function S(s,c=0,f=s.byteLength,y=0){for(let C=0;C<f;C++)s[c+C]=y}function D(s,c,f="0"){for(;s.length<c;)s=f+s;return s}function p(s,c=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(f=>f.toString(16).padStart(2,"0")).join(""):D((s>>>0).toString(16),c/4)}e.$gi=p;class r{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const f=c.length;if(f===0)return;const y=this.p;let C=this.r,i=this.u,a,n;for(i!==0?(a=i,n=-1,i=0):(a=c.charCodeAt(0),n=0);;){let t=a;if(k.$Pd(a))if(n+1<f){const o=c.charCodeAt(n+1);k.$Qd(o)?(n++,t=k.$Rd(a,o)):t=65533}else{i=a;break}else k.$Qd(a)&&(t=65533);if(C=this.w(y,C,t),n++,n<f)a=c.charCodeAt(n);else break}this.r=C,this.u=i}w(c,f,y){return y<128?c[f++]=y:y<2048?(c[f++]=192|(y&1984)>>>6,c[f++]=128|(y&63)>>>0):y<65536?(c[f++]=224|(y&61440)>>>12,c[f++]=128|(y&4032)>>>6,c[f++]=128|(y&63)>>>0):(c[f++]=240|(y&1835008)>>>18,c[f++]=128|(y&258048)>>>12,c[f++]=128|(y&4032)>>>6,c[f++]=128|(y&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,S(this.p,this.r),this.r>56&&(this.y(),S(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=r.g,f=this.q;for(let u=0;u<64;u+=4)c.setUint32(u,f.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)c.setUint32(u,$(c.getUint32(u-12,!1)^c.getUint32(u-32,!1)^c.getUint32(u-56,!1)^c.getUint32(u-64,!1),1),!1);let y=this.h,C=this.l,i=this.m,a=this.n,n=this.o,t,o,g;for(let u=0;u<80;u++)u<20?(t=C&i|~C&a,o=1518500249):u<40?(t=C^i^a,o=1859775393):u<60?(t=C&i|C&a|i&a,o=2400959708):(t=C^i^a,o=3395469782),g=$(y,5)+t+n+o+c.getUint32(u*4,!1)&4294967295,n=a,a=i,i=$(C,30),C=y,y=g;this.h=this.h+y&4294967295,this.l=this.l+C&4294967295,this.m=this.m+i&4294967295,this.n=this.n+a&4294967295,this.o=this.o+n&4294967295}}e.$hi=r}),define(De[40],Ce([1,0,12]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(h){h[h.Ignore=0]="Ignore",h[h.Info=1]="Info",h[h.Warning=2]="Warning",h[h.Error=3]="Error"})(F||(F={})),function(h){const L="error",A="warning",m="warn",E="info",b="ignore";function R($){return $?k.$Ld(L,$)?h.Error:k.$Ld(A,$)||k.$Ld(m,$)?h.Warning:k.$Ld(E,$)?h.Info:h.Ignore:h.Ignore}h.fromValue=R;function I($){switch($){case h.Error:return L;case h.Warning:return A;case h.Info:return E;default:return b}}h.toString=I}(F||(F={})),e.default=F}),define(De[154],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0,e.$4c=Symbol("MicrotaskDelay")}),define(De[71],Ce([1,0,19,12]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0;class h{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const D=S.charCodeAt(0),p=this.b.charCodeAt(this.c);return D-p}value(){return this.b[this.c]}}e.$ph=h;class L{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,F.$Fd)(S,this.b,0,S.length,this.c,this.d):(0,F.$Hd)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$qh=L;class A{constructor(S=!0,D=!0){this.f=S,this.g=D}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let D=S.length-1;D>=0;D--,this.c--){const p=this.b.charCodeAt(D);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,F.$Fd)(S,this.b,0,S.length,this.d,this.e):(0,F.$Hd)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$rh=A;var m;(function($){$[$.Scheme=1]="Scheme",$[$.Authority=2]="Authority",$[$.Path=3]="Path",$[$.Query=4]="Query",$[$.Fragment=5]="Fragment"})(m||(m={}));class E{constructor(S,D){this.f=S,this.g=D,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,F.$Gd)(S,this.c.scheme);if(this.d[this.e]===2)return(0,F.$Gd)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,F.$Ed)(S,this.c.query);if(this.d[this.e]===5)return(0,F.$Ed)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$sh=E;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function($){$[$.Left=-1]="Left",$[$.Mid=0]="Mid",$[$.Right=1]="Right"})(R||(R={}));class I{static forUris(S=()=>!1,D=()=>!1){return new I(new E(S,D))}static forPaths(S=!1){return new I(new A(void 0,!S))}static forStrings(){return new I(new h)}static forConfigKeys(){return new I(new L)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,D){if(D){const p=D.slice(0);(0,k.$Df)(p);for(const r of p)this.set(r,S)}else{const p=S.slice(0);(0,k.$Df)(p);for(const r of p)this.set(r[0],r[1])}}set(S,D){const p=this.b.reset(S);let r;this.c||(this.c=new b,this.c.segment=p.value());const s=[];for(r=this.c;;){const f=p.cmp(r.segment);if(f>0)r.left||(r.left=new b,r.left.segment=p.value()),s.push([-1,r]),r=r.left;else if(f<0)r.right||(r.right=new b,r.right.segment=p.value()),s.push([1,r]),r=r.right;else if(p.hasNext())p.next(),r.mid||(r.mid=new b,r.mid.segment=p.value()),s.push([0,r]),r=r.mid;else break}const c=r.value;r.value=D,r.key=S;for(let f=s.length-1;f>=0;f--){const y=s[f][1];y.updateHeight();const C=y.balanceFactor();if(C<-1||C>1){const i=s[f][0],a=s[f+1][0];if(i===1&&a===1)s[f][1]=y.rotateLeft();else if(i===-1&&a===-1)s[f][1]=y.rotateRight();else if(i===1&&a===-1)y.right=s[f+1][1]=s[f+1][1].rotateRight(),s[f][1]=y.rotateLeft();else if(i===-1&&a===1)y.left=s[f+1][1]=s[f+1][1].rotateLeft(),s[f][1]=y.rotateRight();else throw new Error;if(f>0)switch(s[f-1][0]){case-1:s[f-1][1].left=s[f][1];break;case 1:s[f-1][1].right=s[f][1];break;case 0:s[f-1][1].mid=s[f][1];break}else this.c=s[0][1]}}return c}get(S){return this.d(S)?.value}d(S){const D=this.b.reset(S);let p=this.c;for(;p;){const r=D.cmp(p.segment);if(r>0)p=p.left;else if(r<0)p=p.right;else if(D.hasNext())D.next(),p=p.mid;else break}return p}has(S){const D=this.d(S);return!(D?.value===void 0&&D?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,D){const p=this.b.reset(S),r=[];let s=this.c;for(;s;){const c=p.cmp(s.segment);if(c>0)r.push([-1,s]),s=s.left;else if(c<0)r.push([1,s]),s=s.right;else if(p.hasNext())p.next(),r.push([0,s]),s=s.mid;else break}if(s){if(D?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const c=this.f(s.right);if(c.key){const{key:f,value:y,segment:C}=c;this.e(c.key,!1),s.key=f,s.value=y,s.segment=C}}else{const c=s.left??s.right;if(r.length>0){const[f,y]=r[r.length-1];switch(f){case-1:y.left=c;break;case 0:y.mid=c;break;case 1:y.right=c;break}}else this.c=c}for(let c=r.length-1;c>=0;c--){const f=r[c][1];f.updateHeight();const y=f.balanceFactor();if(y>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),r[c][1]=f.rotateLeft()):y<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),r[c][1]=f.rotateRight()),c>0)switch(r[c-1][0]){case-1:r[c-1][1].left=r[c][1];break;case 1:r[c-1][1].right=r[c][1];break;case 0:r[c-1][1].mid=r[c][1];break}else this.c=r[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const D=this.b.reset(S);let p=this.c,r;for(;p;){const s=D.cmp(p.segment);if(s>0)p=p.left;else if(s<0)p=p.right;else if(D.hasNext())D.next(),r=p.value||r,p=p.mid;else break}return p&&p.value||r}findSuperstr(S){return this.g(S,!1)}g(S,D){const p=this.b.reset(S);let r=this.c;for(;r;){const s=p.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(p.hasNext())p.next(),r=r.mid;else return r.mid?this.h(r.mid):D?r.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[D,p]of this)S(p,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const D=[];return this.j(S,D),D[Symbol.iterator]()}j(S,D){S&&(S.left&&this.j(S.left,D),S.value&&D.push([S.key,S.value]),S.mid&&this.j(S.mid,D),S.right&&this.j(S.right,D))}_isBalanced(){const S=D=>{if(!D)return!0;const p=D.balanceFactor();return p<-1||p>1?!1:S(D.left)&&S(D.right)};return S(this.c)}}e.$th=I}),define(De[14],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=void 0;function k(a){return typeof a=="string"}e.$ie=k;function F(a){return Array.isArray(a)&&a.every(n=>k(n))}e.$je=F;function h(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$ke=h;function L(a){const n=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof n}e.$le=L;function A(a){return typeof a=="number"&&!isNaN(a)}e.$me=A;function m(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$ne=m;function E(a){return a===!0||a===!1}e.$oe=E;function b(a){return typeof a>"u"}e.$pe=b;function R(a){return!I(a)}e.$qe=R;function I(a){return b(a)||a===null}e.$re=I;function $(a,n){if(!a)throw new Error(n?`Unexpected type, expected '${n}'`:"Unexpected type")}e.$se=$;function S(a){if(I(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$te=S;function D(...a){const n=[];for(let t=0;t<a.length;t++){const o=a[t];if(I(o))throw new Error(`Assertion Failed: argument at index ${t} is undefined or null`);n.push(o)}return n}e.$ue=D;const p=Object.prototype.hasOwnProperty;function r(a){if(!h(a))return!1;for(const n in a)if(p.call(a,n))return!1;return!0}e.$ve=r;function s(a){return typeof a=="function"}e.$we=s;function c(...a){return a.length>0&&a.every(s)}e.$xe=c;function f(a,n){const t=Math.min(a.length,n.length);for(let o=0;o<t;o++)y(a[o],n[o])}e.$ye=f;function y(a,n){if(k(n)){if(typeof a!==n)throw new Error(`argument does not match constraint: typeof ${n}`)}else if(s(n)){try{if(a instanceof n)return}catch{}if(!I(a)&&a.constructor===n||n.length===1&&n.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$ze=y;function C(a){return a===null?void 0:a}e.$Ae=C;function i(a){return typeof a>"u"?null:a}e.$Be=i}),define(De[72],Ce([1,0,14]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=e.$yj=void 0;const F=Object.create(null);function h(m,E){if((0,k.$ie)(E)){const b=F[E];if(b===void 0)throw new Error(`${m} references an unknown codicon: ${E}`);E=b}return F[m]=E,{id:m}}function L(){return F}e.$yj=L;function A(){return Object.values(e.$Aj)}e.$zj=A,e.$Aj={add:h("add",6e4),plus:h("plus",6e4),gistNew:h("gist-new",6e4),repoCreate:h("repo-create",6e4),lightbulb:h("lightbulb",60001),lightBulb:h("light-bulb",60001),repo:h("repo",60002),repoDelete:h("repo-delete",60002),gistFork:h("gist-fork",60003),repoForked:h("repo-forked",60003),gitPullRequest:h("git-pull-request",60004),gitPullRequestAbandoned:h("git-pull-request-abandoned",60004),recordKeys:h("record-keys",60005),keyboard:h("keyboard",60005),tag:h("tag",60006),tagAdd:h("tag-add",60006),tagRemove:h("tag-remove",60006),person:h("person",60007),personFollow:h("person-follow",60007),personOutline:h("person-outline",60007),personFilled:h("person-filled",60007),gitBranch:h("git-branch",60008),gitBranchCreate:h("git-branch-create",60008),gitBranchDelete:h("git-branch-delete",60008),sourceControl:h("source-control",60008),mirror:h("mirror",60009),mirrorPublic:h("mirror-public",60009),star:h("star",60010),starAdd:h("star-add",60010),starDelete:h("star-delete",60010),starEmpty:h("star-empty",60010),comment:h("comment",60011),commentAdd:h("comment-add",60011),alert:h("alert",60012),warning:h("warning",60012),search:h("search",60013),searchSave:h("search-save",60013),logOut:h("log-out",60014),signOut:h("sign-out",60014),logIn:h("log-in",60015),signIn:h("sign-in",60015),eye:h("eye",60016),eyeUnwatch:h("eye-unwatch",60016),eyeWatch:h("eye-watch",60016),circleFilled:h("circle-filled",60017),primitiveDot:h("primitive-dot",60017),closeDirty:h("close-dirty",60017),debugBreakpoint:h("debug-breakpoint",60017),debugBreakpointDisabled:h("debug-breakpoint-disabled",60017),debugHint:h("debug-hint",60017),primitiveSquare:h("primitive-square",60018),edit:h("edit",60019),pencil:h("pencil",60019),info:h("info",60020),issueOpened:h("issue-opened",60020),gistPrivate:h("gist-private",60021),gitForkPrivate:h("git-fork-private",60021),lock:h("lock",60021),mirrorPrivate:h("mirror-private",60021),close:h("close",60022),removeClose:h("remove-close",60022),x:h("x",60022),repoSync:h("repo-sync",60023),sync:h("sync",60023),clone:h("clone",60024),desktopDownload:h("desktop-download",60024),beaker:h("beaker",60025),microscope:h("microscope",60025),vm:h("vm",60026),deviceDesktop:h("device-desktop",60026),file:h("file",60027),fileText:h("file-text",60027),more:h("more",60028),ellipsis:h("ellipsis",60028),kebabHorizontal:h("kebab-horizontal",60028),mailReply:h("mail-reply",60029),reply:h("reply",60029),organization:h("organization",60030),organizationFilled:h("organization-filled",60030),organizationOutline:h("organization-outline",60030),newFile:h("new-file",60031),fileAdd:h("file-add",60031),newFolder:h("new-folder",60032),fileDirectoryCreate:h("file-directory-create",60032),trash:h("trash",60033),trashcan:h("trashcan",60033),history:h("history",60034),clock:h("clock",60034),folder:h("folder",60035),fileDirectory:h("file-directory",60035),symbolFolder:h("symbol-folder",60035),logoGithub:h("logo-github",60036),markGithub:h("mark-github",60036),github:h("github",60036),terminal:h("terminal",60037),console:h("console",60037),repl:h("repl",60037),zap:h("zap",60038),symbolEvent:h("symbol-event",60038),error:h("error",60039),stop:h("stop",60039),variable:h("variable",60040),symbolVariable:h("symbol-variable",60040),array:h("array",60042),symbolArray:h("symbol-array",60042),symbolModule:h("symbol-module",60043),symbolPackage:h("symbol-package",60043),symbolNamespace:h("symbol-namespace",60043),symbolObject:h("symbol-object",60043),symbolMethod:h("symbol-method",60044),symbolFunction:h("symbol-function",60044),symbolConstructor:h("symbol-constructor",60044),symbolBoolean:h("symbol-boolean",60047),symbolNull:h("symbol-null",60047),symbolNumeric:h("symbol-numeric",60048),symbolNumber:h("symbol-number",60048),symbolStructure:h("symbol-structure",60049),symbolStruct:h("symbol-struct",60049),symbolParameter:h("symbol-parameter",60050),symbolTypeParameter:h("symbol-type-parameter",60050),symbolKey:h("symbol-key",60051),symbolText:h("symbol-text",60051),symbolReference:h("symbol-reference",60052),goToFile:h("go-to-file",60052),symbolEnum:h("symbol-enum",60053),symbolValue:h("symbol-value",60053),symbolRuler:h("symbol-ruler",60054),symbolUnit:h("symbol-unit",60054),activateBreakpoints:h("activate-breakpoints",60055),archive:h("archive",60056),arrowBoth:h("arrow-both",60057),arrowDown:h("arrow-down",60058),arrowLeft:h("arrow-left",60059),arrowRight:h("arrow-right",60060),arrowSmallDown:h("arrow-small-down",60061),arrowSmallLeft:h("arrow-small-left",60062),arrowSmallRight:h("arrow-small-right",60063),arrowSmallUp:h("arrow-small-up",60064),arrowUp:h("arrow-up",60065),bell:h("bell",60066),bold:h("bold",60067),book:h("book",60068),bookmark:h("bookmark",60069),debugBreakpointConditionalUnverified:h("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:h("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:h("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:h("debug-breakpoint-data-unverified",60072),debugBreakpointData:h("debug-breakpoint-data",60073),debugBreakpointDataDisabled:h("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:h("debug-breakpoint-log-unverified",60074),debugBreakpointLog:h("debug-breakpoint-log",60075),debugBreakpointLogDisabled:h("debug-breakpoint-log-disabled",60075),briefcase:h("briefcase",60076),broadcast:h("broadcast",60077),browser:h("browser",60078),bug:h("bug",60079),calendar:h("calendar",60080),caseSensitive:h("case-sensitive",60081),check:h("check",60082),checklist:h("checklist",60083),chevronDown:h("chevron-down",60084),dropDownButton:h("drop-down-button",60084),chevronLeft:h("chevron-left",60085),chevronRight:h("chevron-right",60086),chevronUp:h("chevron-up",60087),chromeClose:h("chrome-close",60088),chromeMaximize:h("chrome-maximize",60089),chromeMinimize:h("chrome-minimize",60090),chromeRestore:h("chrome-restore",60091),circle:h("circle",60092),circleOutline:h("circle-outline",60092),debugBreakpointUnverified:h("debug-breakpoint-unverified",60092),circleSlash:h("circle-slash",60093),circuitBoard:h("circuit-board",60094),clearAll:h("clear-all",60095),clippy:h("clippy",60096),closeAll:h("close-all",60097),cloudDownload:h("cloud-download",60098),cloudUpload:h("cloud-upload",60099),code:h("code",60100),collapseAll:h("collapse-all",60101),colorMode:h("color-mode",60102),commentDiscussion:h("comment-discussion",60103),compareChanges:h("compare-changes",60157),creditCard:h("credit-card",60105),dash:h("dash",60108),dashboard:h("dashboard",60109),database:h("database",60110),debugContinue:h("debug-continue",60111),debugDisconnect:h("debug-disconnect",60112),debugPause:h("debug-pause",60113),debugRestart:h("debug-restart",60114),debugStart:h("debug-start",60115),debugStepInto:h("debug-step-into",60116),debugStepOut:h("debug-step-out",60117),debugStepOver:h("debug-step-over",60118),debugStop:h("debug-stop",60119),debug:h("debug",60120),deviceCameraVideo:h("device-camera-video",60121),deviceCamera:h("device-camera",60122),deviceMobile:h("device-mobile",60123),diffAdded:h("diff-added",60124),diffIgnored:h("diff-ignored",60125),diffModified:h("diff-modified",60126),diffRemoved:h("diff-removed",60127),diffRenamed:h("diff-renamed",60128),diff:h("diff",60129),discard:h("discard",60130),editorLayout:h("editor-layout",60131),emptyWindow:h("empty-window",60132),exclude:h("exclude",60133),extensions:h("extensions",60134),eyeClosed:h("eye-closed",60135),fileBinary:h("file-binary",60136),fileCode:h("file-code",60137),fileMedia:h("file-media",60138),filePdf:h("file-pdf",60139),fileSubmodule:h("file-submodule",60140),fileSymlinkDirectory:h("file-symlink-directory",60141),fileSymlinkFile:h("file-symlink-file",60142),fileZip:h("file-zip",60143),files:h("files",60144),filter:h("filter",60145),flame:h("flame",60146),foldDown:h("fold-down",60147),foldUp:h("fold-up",60148),fold:h("fold",60149),folderActive:h("folder-active",60150),folderOpened:h("folder-opened",60151),gear:h("gear",60152),gift:h("gift",60153),gistSecret:h("gist-secret",60154),gist:h("gist",60155),gitCommit:h("git-commit",60156),gitCompare:h("git-compare",60157),gitMerge:h("git-merge",60158),githubAction:h("github-action",60159),githubAlt:h("github-alt",60160),globe:h("globe",60161),grabber:h("grabber",60162),graph:h("graph",60163),gripper:h("gripper",60164),heart:h("heart",60165),home:h("home",60166),horizontalRule:h("horizontal-rule",60167),hubot:h("hubot",60168),inbox:h("inbox",60169),issueClosed:h("issue-closed",60324),issueReopened:h("issue-reopened",60171),issues:h("issues",60172),italic:h("italic",60173),jersey:h("jersey",60174),json:h("json",60175),bracket:h("bracket",60175),kebabVertical:h("kebab-vertical",60176),key:h("key",60177),law:h("law",60178),lightbulbAutofix:h("lightbulb-autofix",60179),linkExternal:h("link-external",60180),link:h("link",60181),listOrdered:h("list-ordered",60182),listUnordered:h("list-unordered",60183),liveShare:h("live-share",60184),loading:h("loading",60185),location:h("location",60186),mailRead:h("mail-read",60187),mail:h("mail",60188),markdown:h("markdown",60189),megaphone:h("megaphone",60190),mention:h("mention",60191),milestone:h("milestone",60192),mortarBoard:h("mortar-board",60193),move:h("move",60194),multipleWindows:h("multiple-windows",60195),mute:h("mute",60196),noNewline:h("no-newline",60197),note:h("note",60198),octoface:h("octoface",60199),openPreview:h("open-preview",60200),package_:h("package",60201),paintcan:h("paintcan",60202),pin:h("pin",60203),play:h("play",60204),run:h("run",60204),plug:h("plug",60205),preserveCase:h("preserve-case",60206),preview:h("preview",60207),project:h("project",60208),pulse:h("pulse",60209),question:h("question",60210),quote:h("quote",60211),radioTower:h("radio-tower",60212),reactions:h("reactions",60213),references:h("references",60214),refresh:h("refresh",60215),regex:h("regex",60216),remoteExplorer:h("remote-explorer",60217),remote:h("remote",60218),remove:h("remove",60219),replaceAll:h("replace-all",60220),replace:h("replace",60221),repoClone:h("repo-clone",60222),repoForcePush:h("repo-force-push",60223),repoPull:h("repo-pull",60224),repoPush:h("repo-push",60225),report:h("report",60226),requestChanges:h("request-changes",60227),rocket:h("rocket",60228),rootFolderOpened:h("root-folder-opened",60229),rootFolder:h("root-folder",60230),rss:h("rss",60231),ruby:h("ruby",60232),saveAll:h("save-all",60233),saveAs:h("save-as",60234),save:h("save",60235),screenFull:h("screen-full",60236),screenNormal:h("screen-normal",60237),searchStop:h("search-stop",60238),server:h("server",60240),settingsGear:h("settings-gear",60241),settings:h("settings",60242),shield:h("shield",60243),smiley:h("smiley",60244),sortPrecedence:h("sort-precedence",60245),splitHorizontal:h("split-horizontal",60246),splitVertical:h("split-vertical",60247),squirrel:h("squirrel",60248),starFull:h("star-full",60249),starHalf:h("star-half",60250),symbolClass:h("symbol-class",60251),symbolColor:h("symbol-color",60252),symbolCustomColor:h("symbol-customcolor",60252),symbolConstant:h("symbol-constant",60253),symbolEnumMember:h("symbol-enum-member",60254),symbolField:h("symbol-field",60255),symbolFile:h("symbol-file",60256),symbolInterface:h("symbol-interface",60257),symbolKeyword:h("symbol-keyword",60258),symbolMisc:h("symbol-misc",60259),symbolOperator:h("symbol-operator",60260),symbolProperty:h("symbol-property",60261),wrench:h("wrench",60261),wrenchSubaction:h("wrench-subaction",60261),symbolSnippet:h("symbol-snippet",60262),tasklist:h("tasklist",60263),telescope:h("telescope",60264),textSize:h("text-size",60265),threeBars:h("three-bars",60266),thumbsdown:h("thumbsdown",60267),thumbsup:h("thumbsup",60268),tools:h("tools",60269),triangleDown:h("triangle-down",60270),triangleLeft:h("triangle-left",60271),triangleRight:h("triangle-right",60272),triangleUp:h("triangle-up",60273),twitter:h("twitter",60274),unfold:h("unfold",60275),unlock:h("unlock",60276),unmute:h("unmute",60277),unverified:h("unverified",60278),verified:h("verified",60279),versions:h("versions",60280),vmActive:h("vm-active",60281),vmOutline:h("vm-outline",60282),vmRunning:h("vm-running",60283),watch:h("watch",60284),whitespace:h("whitespace",60285),wholeWord:h("whole-word",60286),window:h("window",60287),wordWrap:h("word-wrap",60288),zoomIn:h("zoom-in",60289),zoomOut:h("zoom-out",60290),listFilter:h("list-filter",60291),listFlat:h("list-flat",60292),listSelection:h("list-selection",60293),selection:h("selection",60293),listTree:h("list-tree",60294),debugBreakpointFunctionUnverified:h("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:h("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:h("debug-breakpoint-function-disabled",60296),debugStackframeActive:h("debug-stackframe-active",60297),circleSmallFilled:h("circle-small-filled",60298),debugStackframeDot:h("debug-stackframe-dot",60298),debugStackframe:h("debug-stackframe",60299),debugStackframeFocused:h("debug-stackframe-focused",60299),debugBreakpointUnsupported:h("debug-breakpoint-unsupported",60300),symbolString:h("symbol-string",60301),debugReverseContinue:h("debug-reverse-continue",60302),debugStepBack:h("debug-step-back",60303),debugRestartFrame:h("debug-restart-frame",60304),callIncoming:h("call-incoming",60306),callOutgoing:h("call-outgoing",60307),menu:h("menu",60308),expandAll:h("expand-all",60309),feedback:h("feedback",60310),groupByRefType:h("group-by-ref-type",60311),ungroupByRefType:h("ungroup-by-ref-type",60312),account:h("account",60313),bellDot:h("bell-dot",60314),debugConsole:h("debug-console",60315),library:h("library",60316),output:h("output",60317),runAll:h("run-all",60318),syncIgnored:h("sync-ignored",60319),pinned:h("pinned",60320),githubInverted:h("github-inverted",60321),debugAlt:h("debug-alt",60305),serverProcess:h("server-process",60322),serverEnvironment:h("server-environment",60323),pass:h("pass",60324),stopCircle:h("stop-circle",60325),playCircle:h("play-circle",60326),record:h("record",60327),debugAltSmall:h("debug-alt-small",60328),vmConnect:h("vm-connect",60329),cloud:h("cloud",60330),merge:h("merge",60331),exportIcon:h("export",60332),graphLeft:h("graph-left",60333),magnet:h("magnet",60334),notebook:h("notebook",60335),redo:h("redo",60336),checkAll:h("check-all",60337),pinnedDirty:h("pinned-dirty",60338),passFilled:h("pass-filled",60339),circleLargeFilled:h("circle-large-filled",60340),circleLarge:h("circle-large",60341),circleLargeOutline:h("circle-large-outline",60341),combine:h("combine",60342),gather:h("gather",60342),table:h("table",60343),variableGroup:h("variable-group",60344),typeHierarchy:h("type-hierarchy",60345),typeHierarchySub:h("type-hierarchy-sub",60346),typeHierarchySuper:h("type-hierarchy-super",60347),gitPullRequestCreate:h("git-pull-request-create",60348),runAbove:h("run-above",60349),runBelow:h("run-below",60350),notebookTemplate:h("notebook-template",60351),debugRerun:h("debug-rerun",60352),workspaceTrusted:h("workspace-trusted",60353),workspaceUntrusted:h("workspace-untrusted",60354),workspaceUnspecified:h("workspace-unspecified",60355),terminalCmd:h("terminal-cmd",60356),terminalDebian:h("terminal-debian",60357),terminalLinux:h("terminal-linux",60358),terminalPowershell:h("terminal-powershell",60359),terminalTmux:h("terminal-tmux",60360),terminalUbuntu:h("terminal-ubuntu",60361),terminalBash:h("terminal-bash",60362),arrowSwap:h("arrow-swap",60363),copy:h("copy",60364),personAdd:h("person-add",60365),filterFilled:h("filter-filled",60366),wand:h("wand",60367),debugLineByLine:h("debug-line-by-line",60368),inspect:h("inspect",60369),layers:h("layers",60370),layersDot:h("layers-dot",60371),layersActive:h("layers-active",60372),compass:h("compass",60373),compassDot:h("compass-dot",60374),compassActive:h("compass-active",60375),azure:h("azure",60376),issueDraft:h("issue-draft",60377),gitPullRequestClosed:h("git-pull-request-closed",60378),gitPullRequestDraft:h("git-pull-request-draft",60379),debugAll:h("debug-all",60380),debugCoverage:h("debug-coverage",60381),runErrors:h("run-errors",60382),folderLibrary:h("folder-library",60383),debugContinueSmall:h("debug-continue-small",60384),beakerStop:h("beaker-stop",60385),graphLine:h("graph-line",60386),graphScatter:h("graph-scatter",60387),pieChart:h("pie-chart",60388),bracketDot:h("bracket-dot",60389),bracketError:h("bracket-error",60390),lockSmall:h("lock-small",60391),azureDevops:h("azure-devops",60392),verifiedFilled:h("verified-filled",60393),newLine:h("newline",60394),layout:h("layout",60395),layoutActivitybarLeft:h("layout-activitybar-left",60396),layoutActivitybarRight:h("layout-activitybar-right",60397),layoutPanelLeft:h("layout-panel-left",60398),layoutPanelCenter:h("layout-panel-center",60399),layoutPanelJustify:h("layout-panel-justify",60400),layoutPanelRight:h("layout-panel-right",60401),layoutPanel:h("layout-panel",60402),layoutSidebarLeft:h("layout-sidebar-left",60403),layoutSidebarRight:h("layout-sidebar-right",60404),layoutStatusbar:h("layout-statusbar",60405),layoutMenubar:h("layout-menubar",60406),layoutCentered:h("layout-centered",60407),layoutSidebarRightOff:h("layout-sidebar-right-off",60416),layoutPanelOff:h("layout-panel-off",60417),layoutSidebarLeftOff:h("layout-sidebar-left-off",60418),target:h("target",60408),indent:h("indent",60409),recordSmall:h("record-small",60410),errorSmall:h("error-small",60411),arrowCircleDown:h("arrow-circle-down",60412),arrowCircleLeft:h("arrow-circle-left",60413),arrowCircleRight:h("arrow-circle-right",60414),arrowCircleUp:h("arrow-circle-up",60415),heartFilled:h("heart-filled",60420),map:h("map",60421),mapFilled:h("map-filled",60422),circleSmall:h("circle-small",60423),bellSlash:h("bell-slash",60424),bellSlashDot:h("bell-slash-dot",60425),commentUnresolved:h("comment-unresolved",60426),gitPullRequestGoToChanges:h("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:h("git-pull-request-new-changes",60428),searchFuzzy:h("search-fuzzy",60429),commentDraft:h("comment-draft",60430),send:h("send",60431),sparkle:h("sparkle",60432),insert:h("insert",60433),dialogError:h("dialog-error","error"),dialogWarning:h("dialog-warning","warning"),dialogInfo:h("dialog-info","info"),dialogClose:h("dialog-close","close"),treeItemExpanded:h("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:h("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:h("tree-filter-on-type-off","list-selection"),treeFilterClear:h("tree-filter-clear","close"),treeItemLoading:h("tree-item-loading","loading"),menuSelection:h("menu-selection","check"),menuSubmenu:h("menu-submenu","chevron-right"),menuBarMore:h("menubar-more","more"),scrollbarButtonLeft:h("scrollbar-button-left","triangle-left"),scrollbarButtonRight:h("scrollbar-button-right","triangle-right"),scrollbarButtonUp:h("scrollbar-button-up","triangle-up"),scrollbarButtonDown:h("scrollbar-button-down","triangle-down"),toolBarMore:h("toolbar-more","more"),quickInputBack:h("quick-input-back","arrow-left")}}),define(De[23],Ce([1,0,14]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qm=e.$Pm=e.$Om=e.$Nm=e.$Mm=e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.$Gm=e.$Fm=void 0;function F(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const c=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([f,y])=>{c[f]=y&&typeof y=="object"?F(y):y}),c}e.$Fm=F;function h(s){if(!s||typeof s!="object")return s;const c=[s];for(;c.length>0;){const f=c.shift();Object.freeze(f);for(const y in f)if(L.call(f,y)){const C=f[y];typeof C=="object"&&!Object.isFrozen(C)&&!(0,k.$le)(C)&&c.push(C)}}return s}e.$Gm=h;const L=Object.prototype.hasOwnProperty;function A(s,c){return m(s,c,new Set)}e.$Hm=A;function m(s,c,f){if((0,k.$re)(s))return s;const y=c(s);if(typeof y<"u")return y;if(Array.isArray(s)){const C=[];for(const i of s)C.push(m(i,c,f));return C}if((0,k.$ke)(s)){if(f.has(s))throw new Error("Cannot clone recursive data-structure");f.add(s);const C={};for(const i in s)L.call(s,i)&&(C[i]=m(s[i],c,f));return f.delete(s),C}return s}function E(s,c,f=!0){return(0,k.$ke)(s)?((0,k.$ke)(c)&&Object.keys(c).forEach(y=>{y in s?f&&((0,k.$ke)(s[y])&&(0,k.$ke)(c[y])?E(s[y],c[y],f):s[y]=c[y]):s[y]=c[y]}),s):c}e.$Im=E;function b(s,c){if(s===c)return!0;if(s==null||c===null||c===void 0||typeof s!=typeof c||typeof s!="object"||Array.isArray(s)!==Array.isArray(c))return!1;let f,y;if(Array.isArray(s)){if(s.length!==c.length)return!1;for(f=0;f<s.length;f++)if(!b(s[f],c[f]))return!1}else{const C=[];for(y in s)C.push(y);C.sort();const i=[];for(y in c)i.push(y);if(i.sort(),!b(C,i))return!1;for(f=0;f<C.length;f++)if(!b(s[C[f]],c[C[f]]))return!1}return!0}e.$Jm=b;function R(s){const c=new Set;return JSON.stringify(s,(f,y)=>{if((0,k.$ke)(y)||Array.isArray(y)){if(c.has(y))return"[Circular]";c.add(y)}return y})}e.$Km=R;function I(s,c){const f=Object.create(null);return!s||!c||Object.keys(c).forEach(C=>{const i=s[C],a=c[C];b(i,a)||(f[C]=a)}),f}e.$Lm=I;function $(s,c){const f=c.toLowerCase(),y=Object.keys(s).find(C=>C.toLowerCase()===f);return y?s[y]:s[c]}e.$Mm=$;function S(s,c){const f=Object.create(null);for(const[y,C]of Object.entries(s))c(y,C)&&(f[y]=C);return f}e.$Nm=S;function D(s){let c=[];for(;Object.prototype!==s;)c=c.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return c}e.$Om=D;function p(s){const c=[];for(const f of D(s))typeof s[f]=="function"&&c.push(f);return c}e.$Pm=p;function r(s,c){const f=C=>function(){const i=Array.prototype.slice.call(arguments,0);return c(C,i)},y={};for(const C of s)y[C]=f(C);return y}e.$Qm=r}),define(De[55],Ce([1,0,72]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Bj=e.ThemeColor=void 0;var F;(function(A){function m(E){return E&&typeof E=="object"&&typeof E.id=="string"}A.isThemeColor=m})(F||(e.ThemeColor=F={}));function h(A){return{id:A}}e.$Bj=h;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function E(c){const f=m.exec(c.id);if(!f)return E(k.$Aj.error);const[,y,C]=f,i=["codicon","codicon-"+y];return C&&i.push("codicon-modifier-"+C.substring(1)),i}A.asClassNameArray=E;function b(c){return E(c).join(" ")}A.asClassName=b;function R(c){return"."+E(c).join(".")}A.asCSSSelector=R;function I(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||F.isThemeColor(c.color))}A.isThemeIcon=I;const $=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function S(c){const f=$.exec(c);if(!f)return;const[,y]=f;return{id:y}}A.fromString=S;function D(c){return{id:c}}A.fromId=D;function p(c,f){let y=c.id;const C=y.lastIndexOf("~");return C!==-1&&(y=y.substring(0,C)),f&&(y=`${y}~${f}`),{id:y}}A.modify=p;function r(c){const f=c.id.lastIndexOf("~");if(f!==-1)return c.id.substring(f+1)}A.getModifier=r;function s(c,f){return c.id===f.id&&c.color?.id===f.color?.id}A.isEqual=s})(L||(e.ThemeIcon=L={}))}),define(De[155],Ce([1,0,113,12,55]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=void 0;const L="$(",A=new RegExp(`\\$\\(${h.ThemeIcon.iconNameExpression}(?:${h.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function E(s){return s.replace(m,(c,f)=>f?c:`\\${c}`)}e.$Cj=E;const b=new RegExp(`\\\\${A.source}`,"g");function R(s){return s.replace(b,c=>`\\${c}`)}e.$Dj=R;const I=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function $(s){return s.indexOf(L)===-1?s:s.replace(I,(c,f,y,C)=>y?c:f||C||"")}e.$Ej=$;function S(s){return s?s.replace(/\$\((.*?)\)/g,(c,f)=>` ${f} `).trim():""}e.$Fj=S;const D=new RegExp(`\\$\\(${h.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(s){D.lastIndex=0;let c="";const f=[];let y=0;for(;;){const C=D.lastIndex,i=D.exec(s),a=s.substring(C,i?.index);if(a.length>0){c+=a;for(let n=0;n<a.length;n++)f.push(y)}if(!i)break;y+=i[0].length}return{text:c,iconOffsets:f}}e.$Gj=p;function r(s,c,f=!1){const{text:y,iconOffsets:C}=c;if(!C||C.length===0)return(0,k.$pj)(s,y,f);const i=(0,F.$rd)(y," "),a=y.length-i.length,n=(0,k.$pj)(s,i,f);if(n)for(const t of n){const o=C[t.start+a]+a;t.start+=o,t.end+=o}return n}e.$Hj=r}),define(De[114],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$id=e.$hd=e.Constants=void 0;var k;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(k||(e.Constants=k={}));function F(L){return L<0?0:L>255?255:L|0}e.$hd=F;function h(L){return L<0?0:L>4294967295?4294967295:L|0}e.$id=h}),define(De[32],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=void 0;const k=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(h){return k.test(h)}e.$4e=F,e.$5e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let h;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?h=crypto.getRandomValues.bind(crypto):h=function(m){for(let E=0;E<m.length;E++)m[E]=Math.floor(Math.random()*256);return m};const L=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){h(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,b="";return b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b+="-",b+=A[L[E++]],b+=A[L[E++]],b+="-",b+=A[L[E++]],b+=A[L[E++]],b+="-",b+=A[L[E++]],b+=A[L[E++]],b+="-",b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b+=A[L[E++]],b}}()}),define(De[156],Ce([1,0,19,48,32]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=e.$$r=e.$0r=e.$9r=void 0;function L(I){return{asString:async()=>I,asFile:()=>{},value:typeof I=="string"?I:void 0}}e.$9r=L;function A(I,$,S){const D={id:(0,h.$5e)(),name:I,uri:$,data:S};return{asString:async()=>"",asFile:()=>D,value:void 0}}e.$0r=A;class m{constructor(){this.a=new Map}get size(){let $=0;for(const S of this.a)$++;return $}has($){return this.a.has(this.b($))}matches($){const S=[...this.a.keys()];return F.Iterable.some(this,([D,p])=>p.asFile())&&S.push("files"),R(E($),S)}get($){return this.a.get(this.b($))?.[0]}append($,S){const D=this.a.get($);D?D.push(S):this.a.set(this.b($),[S])}replace($,S){this.a.set(this.b($),[S])}delete($){this.a.delete(this.b($))}*[Symbol.iterator](){for(const[$,S]of this.a)for(const D of S)yield[$,D]}b($){return E($)}}e.$$r=m;function E(I){return I.toLowerCase()}function b(I,$){return R(E(I),$.map(E))}e.$_r=b;function R(I,$){if(I==="*/*")return $.length>0;if($.includes(I))return!0;const S=I.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!S)return!1;const[D,p,r]=S;return r==="*"?$.some(s=>s.startsWith(p+"/")):!1}e.$as=Object.freeze({create:I=>(0,k.$qf)(I.map($=>$.toString())).join(`\r
`),split:I=>I.split(`\r
`),parse:I=>e.$as.split(I).filter($=>!$.startsWith("#"))})}),define(De[115],Ce([1,0,114]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=void 0;class F{constructor(m){const E=(0,k.$hd)(m);this.c=E,this.a=F.d(E),this.b=new Map}static d(m){const E=new Uint8Array(256);return E.fill(m),E}set(m,E){const b=(0,k.$hd)(E);m>=0&&m<256?this.a[m]=b:this.b.set(m,b)}get(m){return m>=0&&m<256?this.a[m]:this.b.get(m)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$1r=F;var h;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(h||(h={}));class L{constructor(){this.a=new F(0)}add(m){this.a.set(m,1)}has(m){return this.a.get(m)===1}clear(){return this.a.clear()}}e.$2r=L}),define(De[56],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=void 0;class k{constructor(h,L){this.lineNumber=h,this.column=L}with(h=this.lineNumber,L=this.column){return h===this.lineNumber&&L===this.column?this:new k(h,L)}delta(h=0,L=0){return this.with(this.lineNumber+h,this.column+L)}equals(h){return k.equals(this,h)}static equals(h,L){return!h&&!L?!0:!!h&&!!L&&h.lineNumber===L.lineNumber&&h.column===L.column}isBefore(h){return k.isBefore(this,h)}static isBefore(h,L){return h.lineNumber<L.lineNumber?!0:L.lineNumber<h.lineNumber?!1:h.column<L.column}isBeforeOrEqual(h){return k.isBeforeOrEqual(this,h)}static isBeforeOrEqual(h,L){return h.lineNumber<L.lineNumber?!0:L.lineNumber<h.lineNumber?!1:h.column<=L.column}static compare(h,L){const A=h.lineNumber|0,m=L.lineNumber|0;if(A===m){const E=h.column|0,b=L.column|0;return E-b}return A-m}clone(){return new k(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(h){return new k(h.lineNumber,h.column)}static isIPosition(h){return h&&typeof h.lineNumber=="number"&&typeof h.column=="number"}}e.$Lr=k}),define(De[33],Ce([1,0,56]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mr=void 0;class F{constructor(L,A,m,E){L>m||L===m&&A>E?(this.startLineNumber=m,this.startColumn=E,this.endLineNumber=L,this.endColumn=A):(this.startLineNumber=L,this.startColumn=A,this.endLineNumber=m,this.endColumn=E)}isEmpty(){return F.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return F.containsPosition(this,L)}static containsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<L.startColumn||A.lineNumber===L.endLineNumber&&A.column>L.endColumn)}static strictContainsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<=L.startColumn||A.lineNumber===L.endLineNumber&&A.column>=L.endColumn)}containsRange(L){return F.containsRange(this,L)}static containsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>L.endColumn)}strictContainsRange(L){return F.strictContainsRange(this,L)}static strictContainsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<=L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>=L.endColumn)}plusRange(L){return F.plusRange(this,L)}static plusRange(L,A){let m,E,b,R;return A.startLineNumber<L.startLineNumber?(m=A.startLineNumber,E=A.startColumn):A.startLineNumber===L.startLineNumber?(m=A.startLineNumber,E=Math.min(A.startColumn,L.startColumn)):(m=L.startLineNumber,E=L.startColumn),A.endLineNumber>L.endLineNumber?(b=A.endLineNumber,R=A.endColumn):A.endLineNumber===L.endLineNumber?(b=A.endLineNumber,R=Math.max(A.endColumn,L.endColumn)):(b=L.endLineNumber,R=L.endColumn),new F(m,E,b,R)}intersectRanges(L){return F.intersectRanges(this,L)}static intersectRanges(L,A){let m=L.startLineNumber,E=L.startColumn,b=L.endLineNumber,R=L.endColumn;const I=A.startLineNumber,$=A.startColumn,S=A.endLineNumber,D=A.endColumn;return m<I?(m=I,E=$):m===I&&(E=Math.max(E,$)),b>S?(b=S,R=D):b===S&&(R=Math.min(R,D)),m>b||m===b&&E>R?null:new F(m,E,b,R)}equalsRange(L){return F.equalsRange(this,L)}static equalsRange(L,A){return!L&&!A?!0:!!L&&!!A&&L.startLineNumber===A.startLineNumber&&L.startColumn===A.startColumn&&L.endLineNumber===A.endLineNumber&&L.endColumn===A.endColumn}getEndPosition(){return F.getEndPosition(this)}static getEndPosition(L){return new k.$Lr(L.endLineNumber,L.endColumn)}getStartPosition(){return F.getStartPosition(this)}static getStartPosition(L){return new k.$Lr(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,A){return new F(this.startLineNumber,this.startColumn,L,A)}setStartPosition(L,A){return new F(L,A,this.endLineNumber,this.endColumn)}collapseToStart(){return F.collapseToStart(this)}static collapseToStart(L){return new F(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return F.collapseToEnd(this)}static collapseToEnd(L){return new F(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new F(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,A=L){return new F(L.lineNumber,L.column,A.lineNumber,A.column)}static lift(L){return L?new F(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<L.startColumn)}static areIntersecting(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<=A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,A){if(L&&A){const b=L.startLineNumber|0,R=A.startLineNumber|0;if(b===R){const I=L.startColumn|0,$=A.startColumn|0;if(I===$){const S=L.endLineNumber|0,D=A.endLineNumber|0;if(S===D){const p=L.endColumn|0,r=A.endColumn|0;return p-r}return S-D}return I-$}return b-R}return(L?1:0)-(A?1:0)}static compareRangesUsingEnds(L,A){return L.endLineNumber===A.endLineNumber?L.endColumn===A.endColumn?L.startLineNumber===A.startLineNumber?L.startColumn-A.startColumn:L.startLineNumber-A.startLineNumber:L.endColumn-A.endColumn:L.endLineNumber-A.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.$Mr=F}),define(De[157],Ce([1,0,33]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;class F{static insert(L,A){return{range:new k.$Mr(L.lineNumber,L.column,L.lineNumber,L.column),text:A,forceMoveMarkers:!0}}static delete(L){return{range:L,text:null}}static replace(L,A){return{range:L,text:A}}static replaceMove(L,A){return{range:L,text:A,forceMoveMarkers:!0}}}e.$Tr=F}),define(De[158],Ce([1,0,56,33]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.SelectionDirection=void 0;var h;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(h||(e.SelectionDirection=h={}));class L extends F.$Mr{constructor(m,E,b,R){super(m,E,b,R),this.selectionStartLineNumber=m,this.selectionStartColumn=E,this.positionLineNumber=b,this.positionColumn=R}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(m){return L.selectionsEqual(this,m)}static selectionsEqual(m,E){return m.selectionStartLineNumber===E.selectionStartLineNumber&&m.selectionStartColumn===E.selectionStartColumn&&m.positionLineNumber===E.positionLineNumber&&m.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(m,E){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,m,E):new L(m,E,this.startLineNumber,this.startColumn)}getPosition(){return new k.$Lr(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new k.$Lr(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(m,E){return this.getDirection()===0?new L(m,E,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,m,E)}static fromPositions(m,E=m){return new L(m.lineNumber,m.column,E.lineNumber,E.column)}static fromRange(m,E){return E===0?new L(m.startLineNumber,m.startColumn,m.endLineNumber,m.endColumn):new L(m.endLineNumber,m.endColumn,m.startLineNumber,m.startColumn)}static liftSelection(m){return new L(m.selectionStartLineNumber,m.selectionStartColumn,m.positionLineNumber,m.positionColumn)}static selectionsArrEqual(m,E){if(m&&!E||!m&&E)return!1;if(!m&&!E)return!0;if(m.length!==E.length)return!1;for(let b=0,R=m.length;b<R;b++)if(!this.selectionsEqual(m[b],E[b]))return!1;return!0}static isISelection(m){return m&&typeof m.selectionStartLineNumber=="number"&&typeof m.selectionStartColumn=="number"&&typeof m.positionLineNumber=="number"&&typeof m.positionColumn=="number"}static createWithDirection(m,E,b,R,I){return I===0?new L(m,E,b,R):new L(b,R,m,E)}}e.$Ur=L}),define(De[159],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0,e.$Fr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[160],Ce([1,0,115]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=e.WordCharacterClass=void 0;var F;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(F||(e.WordCharacterClass=F={}));class h extends k.$1r{constructor(m){super(0);for(let E=0,b=m.length;E<b;E++)this.set(m.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.$3r=h;function L(A){const m={};return E=>(m.hasOwnProperty(E)||(m[E]=A(E)),m[E])}e.$4r=L(A=>new h(A))}),define(De[116],Ce([1,0,48,4,68]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=e.$Jr=e.$Ir=e.$Hr=e.$Gr=void 0,e.$Gr="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(I=""){let $="(-?\\d*\\.\\d\\w*)|([^";for(const S of e.$Gr)I.indexOf(S)>=0||($+="\\"+S);return $+="\\s]+)",new RegExp($,"g")}e.$Hr=L();function A(I){let $=e.$Hr;if(I&&I instanceof RegExp)if(I.global)$=I;else{let S="g";I.ignoreCase&&(S+="i"),I.multiline&&(S+="m"),I.unicode&&(S+="u"),$=new RegExp(I.source,S)}return $.lastIndex=0,$}e.$Ir=A;const m=new h.$lc;m.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function E(I){const $=m.unshift(I);return(0,F.$jb)($)}e.$Jr=E;function b(I,$,S,D,p){if(p||(p=k.Iterable.first(m)),S.length>p.maxLen){let y=I-p.maxLen/2;return y<0?y=0:D+=y,S=S.substring(y,I+p.maxLen/2),b(I,$,S,D,p)}const r=Date.now(),s=I-1-D;let c=-1,f=null;for(let y=1;!(Date.now()-r>=p.timeBudget);y++){const C=s-p.windowSize*y;$.lastIndex=Math.max(0,C);const i=R($,S,s,c);if(!i&&f||(f=i,C<=0))break;c=C}if(f){const y={word:f[0],startColumn:D+1+f.index,endColumn:D+1+f.index+f[0].length};return $.lastIndex=0,y}return null}e.$Kr=b;function R(I,$,S,D){let p;for(;p=I.exec($);){const r=p.index||0;if(r<=S&&I.lastIndex>=S)return p;if(D>0&&r>D)return null}return null}}),define(De[161],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=e.IndentAction=void 0;var k;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(k||(e.IndentAction=k={}));class F{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let E=0,b=m.notIn.length;E<b;E++)switch(m.notIn[E]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,E){if(m.getTokenCount()===0)return!0;const b=m.findTokenIndexAtOffset(E-2),R=m.getStandardTokenType(b);return this.isOK(R)}g(m,E){for(let b=m;b<=E;b++){const R=String.fromCharCode(b);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$zs=F;class h{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of m)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.$As=h;function L(A,m,E){A.has(m)?A.get(m).push(E):A.set(m,[E])}}),define(De[162],Ce([1,0,115]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8W=e.$7W=e.$6W=e.State=void 0;var F;(function(S){S[S.Invalid=0]="Invalid",S[S.Start=1]="Start",S[S.H=2]="H",S[S.HT=3]="HT",S[S.HTT=4]="HTT",S[S.HTTP=5]="HTTP",S[S.F=6]="F",S[S.FI=7]="FI",S[S.FIL=8]="FIL",S[S.BeforeColon=9]="BeforeColon",S[S.AfterColon=10]="AfterColon",S[S.AlmostThere=11]="AlmostThere",S[S.End=12]="End",S[S.Accept=13]="Accept",S[S.LastKnownState=14]="LastKnownState"})(F||(e.State=F={}));class h{constructor(D,p,r){const s=new Uint8Array(D*p);for(let c=0,f=D*p;c<f;c++)s[c]=r;this.a=s,this.rows=D,this.cols=p}get(D,p){return this.a[D*this.cols+p]}set(D,p,r){this.a[D*this.cols+p]=r}}class L{constructor(D){let p=0,r=0;for(let c=0,f=D.length;c<f;c++){const[y,C,i]=D[c];C>p&&(p=C),y>r&&(r=y),i>r&&(r=i)}p++,r++;const s=new h(r,p,0);for(let c=0,f=D.length;c<f;c++){const[y,C,i]=D[c];s.set(y,C,i)}this.a=s,this.b=p}nextState(D,p){return p<0||p>=this.b?0:this.a.get(D,p)}}e.$6W=L;let A=null;function m(){return A===null&&(A=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var E;(function(S){S[S.None=0]="None",S[S.ForceTermination=1]="ForceTermination",S[S.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let b=null;function R(){if(b===null){b=new k.$1r(0);const S=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let p=0;p<S.length;p++)b.set(S.charCodeAt(p),1);const D=".,;:";for(let p=0;p<D.length;p++)b.set(D.charCodeAt(p),2)}return b}class I{static a(D,p,r,s,c){let f=c-1;do{const y=p.charCodeAt(f);if(D.get(y)!==2)break;f--}while(f>s);if(s>0){const y=p.charCodeAt(s-1),C=p.charCodeAt(f);(y===40&&C===41||y===91&&C===93||y===123&&C===125)&&f--}return{range:{startLineNumber:r,startColumn:s+1,endLineNumber:r,endColumn:f+2},url:p.substring(s,f+1)}}static computeLinks(D,p=m()){const r=R(),s=[];for(let c=1,f=D.getLineCount();c<=f;c++){const y=D.getLineContent(c),C=y.length;let i=0,a=0,n=0,t=1,o=!1,g=!1,u=!1,d=!1;for(;i<C;){let v=!1;const l=y.charCodeAt(i);if(t===13){let w;switch(l){case 40:o=!0,w=0;break;case 41:w=o?0:1;break;case 91:u=!0,g=!0,w=0;break;case 93:u=!1,w=g?0:1;break;case 123:d=!0,w=0;break;case 125:w=d?0:1;break;case 39:case 34:case 96:n===l?w=1:n===39||n===34||n===96?w=0:w=1;break;case 42:w=n===42?1:0;break;case 124:w=n===124?1:0;break;case 32:w=u?0:1;break;default:w=r.get(l)}w===1&&(s.push(I.a(r,y,c,a,i)),v=!0)}else if(t===12){let w;l===91?(g=!0,w=0):w=r.get(l),w===1?v=!0:t=13}else t=p.nextState(t,l),t===0&&(v=!0);v&&(t=1,o=!1,g=!1,d=!1,a=i+1,n=l),i++}t===13&&s.push(I.a(r,y,c,a,C))}return s}}e.$7W=I;function $(S){return!S||typeof S.getLineCount!="function"||typeof S.getLineContent!="function"?[]:I.computeLinks(S)}e.$8W=$}),define(De[117],Ce([1,0,23]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=e.$Yt=e.$Xt=e.$Wt=e.ModelConstants=e.PositionAffinity=e.$Vt=e.TrackedRangeStickiness=e.$Ut=e.$Tt=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var F;(function(y){y[y.Left=1]="Left",y[y.Center=2]="Center",y[y.Right=4]="Right",y[y.Full=7]="Full"})(F||(e.OverviewRulerLane=F={}));var h;(function(y){y[y.Left=1]="Left",y[y.Right=2]="Right"})(h||(e.GlyphMarginLane=h={}));var L;(function(y){y[y.Inline=1]="Inline",y[y.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var A;(function(y){y[y.Both=0]="Both",y[y.Right=1]="Right",y[y.Left=2]="Left",y[y.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var m;(function(y){y[y.TextDefined=0]="TextDefined",y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(m||(e.EndOfLinePreference=m={}));var E;(function(y){y[y.LF=1]="LF",y[y.CRLF=2]="CRLF"})(E||(e.DefaultEndOfLine=E={}));var b;(function(y){y[y.LF=0]="LF",y[y.CRLF=1]="CRLF"})(b||(e.EndOfLineSequence=b={}));class R{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(C){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,C.tabSize|0),C.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,C.indentSize|0),this.a=!1),this.insertSpaces=!!C.insertSpaces,this.defaultEOL=C.defaultEOL|0,this.trimAutoWhitespace=!!C.trimAutoWhitespace,this.bracketPairColorizationOptions=C.bracketPairColorizationOptions}equals(C){return this.tabSize===C.tabSize&&this.a===C.a&&this.indentSize===C.indentSize&&this.insertSpaces===C.insertSpaces&&this.defaultEOL===C.defaultEOL&&this.trimAutoWhitespace===C.trimAutoWhitespace&&(0,k.$Jm)(this.bracketPairColorizationOptions,C.bracketPairColorizationOptions)}createChangeEvent(C){return{tabSize:this.tabSize!==C.tabSize,indentSize:this.indentSize!==C.indentSize,insertSpaces:this.insertSpaces!==C.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==C.trimAutoWhitespace}}}e.$Tt=R;class I{constructor(C,i){this._findMatchBrand=void 0,this.range=C,this.matches=i}}e.$Ut=I;var $;(function(y){y[y.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",y[y.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",y[y.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",y[y.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})($||(e.TrackedRangeStickiness=$={}));function S(y){return y&&typeof y.read=="function"}e.$Vt=S;var D;(function(y){y[y.Left=0]="Left",y[y.Right=1]="Right",y[y.None=2]="None",y[y.LeftOfInjectedText=3]="LeftOfInjectedText",y[y.RightOfInjectedText=4]="RightOfInjectedText"})(D||(e.PositionAffinity=D={}));var p;(function(y){y[y.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(p||(e.ModelConstants=p={}));class r{constructor(C,i,a,n,t,o){this.identifier=C,this.range=i,this.text=a,this.forceMoveMarkers=n,this.isAutoWhitespaceEdit=t,this._isTracked=o}}e.$Wt=r;class s{constructor(C,i,a){this.regex=C,this.wordSeparators=i,this.simpleSearch=a}}e.$Xt=s;class c{constructor(C,i,a){this.reverseEdits=C,this.changes=i,this.trimAutoWhitespaceLineNumbers=a}}e.$Yt=c;function f(y){return!y.isTooLargeForSyncing()&&!y.isForSimpleWidget}e.$Zt=f}),define(De[163],Ce([1,0,19,114]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tu=e.$su=e.$ru=void 0;class h{constructor(E){this.a=E,this.b=new Uint32Array(E.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(E,b){E=(0,F.$id)(E);const R=this.a,I=this.b,$=b.length;return $===0?!1:(this.a=new Uint32Array(R.length+$),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E),E+$),this.a.set(b,E),E-1<this.c[0]&&(this.c[0]=E-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}setValue(E,b){return E=(0,F.$id)(E),b=(0,F.$id)(b),this.a[E]===b?!1:(this.a[E]=b,E-1<this.c[0]&&(this.c[0]=E-1),!0)}removeValues(E,b){E=(0,F.$id)(E),b=(0,F.$id)(b);const R=this.a,I=this.b;if(E>=R.length)return!1;const $=R.length-E;return b>=$&&(b=$),b===0?!1:(this.a=new Uint32Array(R.length-b),this.a.set(R.subarray(0,E),0),this.a.set(R.subarray(E+b),E),this.b=new Uint32Array(this.a.length),E-1<this.c[0]&&(this.c[0]=E-1),this.c[0]>=0&&this.b.set(I.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(E){return E<0?0:(E=(0,F.$id)(E),this.d(E))}d(E){if(E<=this.c[0])return this.b[E];let b=this.c[0]+1;b===0&&(this.b[0]=this.a[0],b++),E>=this.a.length&&(E=this.a.length-1);for(let R=b;R<=E;R++)this.b[R]=this.b[R-1]+this.a[R];return this.c[0]=Math.max(this.c[0],E),this.b[E]}getIndexOf(E){E=Math.floor(E),this.getTotalSum();let b=0,R=this.a.length-1,I=0,$=0,S=0;for(;b<=R;)if(I=b+(R-b)/2|0,$=this.b[I],S=$-this.a[I],E<S)R=I-1;else if(E>=$)b=I+1;else break;return new A(I,E-S)}}e.$ru=h;class L{constructor(E){this.a=E,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(E){return this.g(),E===0?0:this.d[E-1]}getIndexOf(E){this.g();const b=this.e[E],R=b>0?this.d[b-1]:0;return new A(b,E-R)}removeValues(E,b){this.a.splice(E,b),this.f(E)}insertValues(E,b){this.a=(0,k.$Cf)(this.a,E,b),this.f(E)}f(E){this.b=!1,this.c=Math.min(this.c,E-1)}g(){if(!this.b){for(let E=this.c+1,b=this.a.length;E<b;E++){const R=this.a[E],I=E>0?this.d[E-1]:0;this.d[E]=I+R;for(let $=0;$<R;$++)this.e[I+$]=E}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(E,b){this.a[E]!==b&&(this.a[E]=b,this.f(E))}}e.$su=L;class A{constructor(E,b){this.index=E,this.remainder=b,this._prefixSumIndexOfResultBrand=void 0,this.index=E,this.remainder=b}}e.$tu=A}),define(De[164],Ce([1,0,12,56,163]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uu=void 0;class L{constructor(m,E,b,R){this.d=m,this.f=E,this.g=b,this.h=R,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(m){m.eol&&m.eol!==this.g&&(this.g=m.eol,this.j=null);const E=m.changes;for(const b of E)this.o(b.range),this.p(new F.$Lr(b.range.startLineNumber,b.range.startColumn),b.text);this.h=m.versionId,this.k=null}l(){if(!this.j){const m=this.g.length,E=this.f.length,b=new Uint32Array(E);for(let R=0;R<E;R++)b[R]=this.f[R].length+m;this.j=new h.$ru(b)}}n(m,E){this.f[m]=E,this.j&&this.j.setValue(m,this.f[m].length+this.g.length)}o(m){if(m.startLineNumber===m.endLineNumber){if(m.startColumn===m.endColumn)return;this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.startLineNumber-1].substring(m.endColumn-1));return}this.n(m.startLineNumber-1,this.f[m.startLineNumber-1].substring(0,m.startColumn-1)+this.f[m.endLineNumber-1].substring(m.endColumn-1)),this.f.splice(m.startLineNumber,m.endLineNumber-m.startLineNumber),this.j&&this.j.removeValues(m.startLineNumber,m.endLineNumber-m.startLineNumber)}p(m,E){if(E.length===0)return;const b=(0,k.$zd)(E);if(b.length===1){this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]+this.f[m.lineNumber-1].substring(m.column-1));return}b[b.length-1]+=this.f[m.lineNumber-1].substring(m.column-1),this.n(m.lineNumber-1,this.f[m.lineNumber-1].substring(0,m.column-1)+b[0]);const R=new Uint32Array(b.length-1);for(let I=1;I<b.length;I++)this.f.splice(m.lineNumber+I-1,0,b[I]),R[I-1]=b[I].length+this.g.length;this.j&&this.j.insertValues(m.lineNumber,R)}}e.$uu=L}),define(De[165],Ce([1,0,12,160,56,33,117]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6B=e.$5B=e.$4B=e.$3B=e.$2B=e.$1B=void 0;const m=999;class E{constructor(c,f,y,C){this.searchString=c,this.isRegex=f,this.matchCase=y,this.wordSeparators=C}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=b(this.searchString):c=this.searchString.indexOf(`
`)>=0;let f=null;try{f=k.$vd(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch{return null}if(!f)return null;let y=!this.isRegex&&!c;return y&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(y=this.matchCase),new A.$Xt(f,this.wordSeparators?(0,F.$4r)(this.wordSeparators):null,y?this.searchString:null)}}e.$1B=E;function b(s){if(!s||s.length===0)return!1;for(let c=0,f=s.length;c<f;c++){const y=s.charCodeAt(c);if(y===10)return!0;if(y===92){if(c++,c>=f)break;const C=s.charCodeAt(c);if(C===110||C===114||C===87)return!0}}return!1}e.$2B=b;function R(s,c,f){if(!f)return new A.$Ut(s,null);const y=[];for(let C=0,i=c.length;C<i;C++)y[C]=c[C];return new A.$Ut(s,y)}e.$3B=R;class I{constructor(c){const f=[];let y=0;for(let C=0,i=c.length;C<i;C++)c.charCodeAt(C)===10&&(f[y++]=C);this.a=f}findLineFeedCountBeforeOffset(c){const f=this.a;let y=0,C=f.length-1;if(C===-1||c<=f[0])return 0;for(;y<C;){const i=y+((C-y)/2>>0);f[i]>=c?C=i-1:f[i+1]>=c?(y=i,C=i):y=i+1}return y+1}}class ${static findMatches(c,f,y,C,i){const a=f.parseSearchRequest();return a?a.regex.multiline?this.b(c,y,new r(a.wordSeparators,a.regex),C,i):this.c(c,y,a,C,i):[]}static a(c,f,y,C,i,a){let n,t=0;C?(t=C.findLineFeedCountBeforeOffset(i),n=f+i+t):n=f+i;let o;if(C){const v=C.findLineFeedCountBeforeOffset(i+a.length)-t;o=n+a.length+v}else o=n+a.length;const g=c.getPositionAt(n),u=c.getPositionAt(o);return new L.$Mr(g.lineNumber,g.column,u.lineNumber,u.column)}static b(c,f,y,C,i){const a=c.getOffsetAt(f.getStartPosition()),n=c.getValueInRange(f,1),t=c.getEOL()===`\r
`?new I(n):null,o=[];let g=0,u;for(y.reset(0);u=y.next(n);)if(o[g++]=R(this.a(c,a,n,t,u.index,u[0]),u,C),g>=i)return o;return o}static c(c,f,y,C,i){const a=[];let n=0;if(f.startLineNumber===f.endLineNumber){const o=c.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return n=this.d(y,o,f.startLineNumber,f.startColumn-1,n,a,C,i),a}const t=c.getLineContent(f.startLineNumber).substring(f.startColumn-1);n=this.d(y,t,f.startLineNumber,f.startColumn-1,n,a,C,i);for(let o=f.startLineNumber+1;o<f.endLineNumber&&n<i;o++)n=this.d(y,c.getLineContent(o),o,0,n,a,C,i);if(n<i){const o=c.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);n=this.d(y,o,f.endLineNumber,0,n,a,C,i)}return a}static d(c,f,y,C,i,a,n,t){const o=c.wordSeparators;if(!n&&c.simpleSearch){const d=c.simpleSearch,v=d.length,l=f.length;let w=-v;for(;(w=f.indexOf(d,w+v))!==-1;)if((!o||p(o,f,l,w,v))&&(a[i++]=new A.$Ut(new L.$Mr(y,w+1+C,y,w+1+v+C),null),i>=t))return i;return i}const g=new r(c.wordSeparators,c.regex);let u;g.reset(0);do if(u=g.next(f),u&&(a[i++]=R(new L.$Mr(y,u.index+1+C,y,u.index+1+u[0].length+C),u,n),i>=t))return i;while(u);return i}static findNextMatch(c,f,y,C){const i=f.parseSearchRequest();if(!i)return null;const a=new r(i.wordSeparators,i.regex);return i.regex.multiline?this.e(c,y,a,C):this.f(c,y,a,C)}static e(c,f,y,C){const i=new h.$Lr(f.lineNumber,1),a=c.getOffsetAt(i),n=c.getLineCount(),t=c.getValueInRange(new L.$Mr(i.lineNumber,i.column,n,c.getLineMaxColumn(n)),1),o=c.getEOL()===`\r
`?new I(t):null;y.reset(f.column-1);const g=y.next(t);return g?R(this.a(c,a,t,o,g.index,g[0]),g,C):f.lineNumber!==1||f.column!==1?this.e(c,new h.$Lr(1,1),y,C):null}static f(c,f,y,C){const i=c.getLineCount(),a=f.lineNumber,n=c.getLineContent(a),t=this.g(y,n,a,f.column,C);if(t)return t;for(let o=1;o<=i;o++){const g=(a+o-1)%i,u=c.getLineContent(g+1),d=this.g(y,u,g+1,1,C);if(d)return d}return null}static g(c,f,y,C,i){c.reset(C-1);const a=c.next(f);return a?R(new L.$Mr(y,a.index+1,y,a.index+1+a[0].length),a,i):null}static findPreviousMatch(c,f,y,C){const i=f.parseSearchRequest();if(!i)return null;const a=new r(i.wordSeparators,i.regex);return i.regex.multiline?this.h(c,y,a,C):this.j(c,y,a,C)}static h(c,f,y,C){const i=this.b(c,new L.$Mr(1,1,f.lineNumber,f.column),y,C,10*m);if(i.length>0)return i[i.length-1];const a=c.getLineCount();return f.lineNumber!==a||f.column!==c.getLineMaxColumn(a)?this.h(c,new h.$Lr(a,c.getLineMaxColumn(a)),y,C):null}static j(c,f,y,C){const i=c.getLineCount(),a=f.lineNumber,n=c.getLineContent(a).substring(0,f.column-1),t=this.k(y,n,a,C);if(t)return t;for(let o=1;o<=i;o++){const g=(i+a-o-1)%i,u=c.getLineContent(g+1),d=this.k(y,u,g+1,C);if(d)return d}return null}static k(c,f,y,C){let i=null,a;for(c.reset(0);a=c.next(f);)i=R(new L.$Mr(y,a.index+1,y,a.index+1+a[0].length),a,C);return i}}e.$4B=$;function S(s,c,f,y,C){if(y===0)return!0;const i=c.charCodeAt(y-1);if(s.get(i)!==0||i===13||i===10)return!0;if(C>0){const a=c.charCodeAt(y);if(s.get(a)!==0)return!0}return!1}function D(s,c,f,y,C){if(y+C===f)return!0;const i=c.charCodeAt(y+C);if(s.get(i)!==0||i===13||i===10)return!0;if(C>0){const a=c.charCodeAt(y+C-1);if(s.get(a)!==0)return!0}return!1}function p(s,c,f,y,C){return S(s,c,f,y,C)&&D(s,c,f,y,C)}e.$5B=p;class r{constructor(c,f){this._wordSeparators=c,this.a=f,this.b=-1,this.c=0}reset(c){this.a.lastIndex=c,this.b=-1,this.c=0}next(c){const f=c.length;let y;do{if(this.b+this.c===f||(y=this.a.exec(c),!y))return null;const C=y.index,i=y[0].length;if(C===this.b&&i===this.c){if(i===0){k.$Sd(c,f,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=C,this.c=i,!this._wordSeparators||p(this._wordSeparators,c,f,C,i))return y}while(y);return null}}e.$6B=r}),define(De[166],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t5=e.$s5=void 0;class k{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.$s5=k;class F{constructor(L){this.identifier=L}}e.$t5=F}),define(De[167],Ce([1,0,3,4]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;class h{constructor(){this.a=new Map,this.b=new Map,this.c=new k.$7c,this.onDidChange=this.c.event,this.d=null}handleChange(m){this.c.fire({changedLanguages:m,changedColorMap:!1})}register(m,E){return this.a.set(m,E),this.handleChange([m]),(0,F.$jb)(()=>{this.a.get(m)===E&&(this.a.delete(m),this.handleChange([m]))})}get(m){return this.a.get(m)||null}registerFactory(m,E){this.b.get(m)?.dispose();const b=new L(this,m,E);return this.b.set(m,b),(0,F.$jb)(()=>{const R=this.b.get(m);!R||R!==b||(this.b.delete(m),R.dispose())})}async getOrCreate(m){const E=this.get(m);if(E)return E;const b=this.b.get(m);return!b||b.isResolved?null:(await b.resolve(),this.get(m))}isResolved(m){if(this.get(m))return!0;const b=this.b.get(m);return!!(!b||b.isResolved)}setColorMap(m){this.d=m,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$cs=h;class L extends F.$lb{get isResolved(){return this.c}constructor(m,E,b){super(),this.f=m,this.g=E,this.h=b,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const m=await this.h.tokenizationSupport;this.c=!0,m&&!this.a&&this.B(this.f.register(this.g,m))}}}),define(De[168],Ce([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(De[169],Ce([1,0,3,4,168]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0;class L extends F.$lb{constructor($,S="",D="",p=!0,r){super(),this.h=this.B(new k.$7c),this.onDidChange=this.h.event,this.w=!0,this.j=$,this.m=S,this.u=D,this.w=p,this.C=r}get id(){return this.j}get label(){return this.m}set label($){this.D($)}D($){this.m!==$&&(this.m=$,this.h.fire({label:$}))}get tooltip(){return this.n||""}set tooltip($){this.F($)}F($){this.n!==$&&(this.n=$,this.h.fire({tooltip:$}))}get class(){return this.u}set class($){this.G($)}G($){this.u!==$&&(this.u=$,this.h.fire({class:$}))}get enabled(){return this.w}set enabled($){this.H($)}H($){this.w!==$&&(this.w=$,this.h.fire({enabled:$}))}get checked(){return this.z}set checked($){this.I($)}I($){this.z!==$&&(this.z=$,this.h.fire({checked:$}))}async run($,S){this.C&&await this.C($)}}e.$5h=L;class A extends F.$lb{constructor(){super(...arguments),this.f=this.B(new k.$7c),this.onWillRun=this.f.event,this.h=this.B(new k.$7c),this.onDidRun=this.h.event}async run($,S){if(!$.enabled)return;this.f.fire({action:$});let D;try{await this.k($,S)}catch(p){D=p}this.h.fire({action:$,error:D})}async k($,S){await $.run(S)}}e.$6h=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...$){let S=[];for(const D of $)D.length&&(S.length?S=[...S,new m,...D]:S=D);return S}static{this.ID="vs.actions.separator"}async run(){}}e.$7h=m;class E{get actions(){return this.a}constructor($,S,D,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=$,this.label=S,this.class=p,this.a=D}async run(){}}e.$8h=E;class b extends L{static{this.ID="vs.actions.empty"}constructor(){super(b.ID,h.localize(0,null),void 0,!1)}}e.$9h=b;function R(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.$0h=R}),define(De[170],Ce([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(De[171],Ce([1,0,170]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=void 0;const F=60,h=F*60,L=h*24,A=L*7,m=L*30,E=L*365;function b(I,$,S,D){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,k.localize)(0,null,b(new Date().getTime()+p*1e3,!1));if(!D&&p<30)return(0,k.localize)(1,null);let r;return p<F?(r=p,$?r===1?S?(0,k.localize)(2,null,r):(0,k.localize)(3,null,r):S?(0,k.localize)(4,null,r):(0,k.localize)(5,null,r):r===1?S?(0,k.localize)(6,null,r):(0,k.localize)(7,null,r):S?(0,k.localize)(8,null,r):(0,k.localize)(9,null,r)):p<h?(r=Math.floor(p/F),$?r===1?S?(0,k.localize)(10,null,r):(0,k.localize)(11,null,r):S?(0,k.localize)(12,null,r):(0,k.localize)(13,null,r):r===1?S?(0,k.localize)(14,null,r):(0,k.localize)(15,null,r):S?(0,k.localize)(16,null,r):(0,k.localize)(17,null,r)):p<L?(r=Math.floor(p/h),$?r===1?S?(0,k.localize)(18,null,r):(0,k.localize)(19,null,r):S?(0,k.localize)(20,null,r):(0,k.localize)(21,null,r):r===1?S?(0,k.localize)(22,null,r):(0,k.localize)(23,null,r):S?(0,k.localize)(24,null,r):(0,k.localize)(25,null,r)):p<A?(r=Math.floor(p/L),$?r===1?(0,k.localize)(26,null,r):(0,k.localize)(27,null,r):r===1?(0,k.localize)(28,null,r):(0,k.localize)(29,null,r)):p<m?(r=Math.floor(p/A),$?r===1?S?(0,k.localize)(30,null,r):(0,k.localize)(31,null,r):S?(0,k.localize)(32,null,r):(0,k.localize)(33,null,r):r===1?S?(0,k.localize)(34,null,r):(0,k.localize)(35,null,r):S?(0,k.localize)(36,null,r):(0,k.localize)(37,null,r)):p<E?(r=Math.floor(p/m),$?r===1?S?(0,k.localize)(38,null,r):(0,k.localize)(39,null,r):S?(0,k.localize)(40,null,r):(0,k.localize)(41,null,r):r===1?S?(0,k.localize)(42,null,r):(0,k.localize)(43,null,r):S?(0,k.localize)(44,null,r):(0,k.localize)(45,null,r)):(r=Math.floor(p/E),$?r===1?S?(0,k.localize)(46,null,r):(0,k.localize)(47,null,r):S?(0,k.localize)(48,null,r):(0,k.localize)(49,null,r):r===1?S?(0,k.localize)(50,null,r):(0,k.localize)(51,null,r):S?(0,k.localize)(52,null,r):(0,k.localize)(53,null,r))}e.$Pl=b;function R(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ql=R}),define(De[172],Ce([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(De[45],Ce([1,0,19,14,172]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=void 0;function L(I,$){return $&&(I.stack||I.stacktrace)?h.localize(0,null,m(I),A(I.stack)||A(I.stacktrace)):m(I)}function A(I){return Array.isArray(I)?I.join(`
`):I}function m(I){return I.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${I.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?h.localize(1,null,I.message):I.message||h.localize(2,null)}function E(I=null,$=!1){if(!I)return h.localize(3,null);if(Array.isArray(I)){const S=k.$lf(I),D=E(S[0],$);return S.length>1?h.localize(4,null,D,S.length):D}if(F.$ie(I))return I;if(I.detail){const S=I.detail;if(S.error)return L(S.error,$);if(S.exception)return L(S.exception,$)}return I.stack?L(I,$):I.message?I.message:h.localize(5,null)}e.$$h=E;function b(I){const $=I;return $ instanceof Error&&Array.isArray($.actions)}e.$_h=b;function R(I,$){let S;return typeof I=="string"?S=new Error(I):S=I,S.actions=$,S}e.$ai=R}),define(De[173],Ce([9,10]),function(me,e){return me.create("vs/base/common/platform",e)}),define(De[11],Ce([1,0,173]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H=e.$G=e.$F=e.$E=e.$D=e.$C=e.OS=e.OperatingSystem=e.$A=e.$z=e.$y=e.$x=e.$w=e.Language=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=e.$f=void 0,e.$f="en";let F=!1,h=!1,L=!1,A=!1,m=!1,E=!1,b=!1,R=!1,I=!1,$=!1,S,D=e.$f,p=e.$f,r,s;e.$g=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.$g.vscode<"u"&&typeof e.$g.vscode.process<"u"?c=e.$g.vscode.process:typeof process<"u"&&(c=process);const f=typeof c?.versions?.electron=="string",y=f&&c?.type==="renderer";if(typeof navigator=="object"&&!y)s=navigator.userAgent,F=s.indexOf("Windows")>=0,h=s.indexOf("Macintosh")>=0,R=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=s.indexOf("Linux")>=0,$=s?.indexOf("Mobi")>=0,E=!0,S=k.getConfiguredDefaultLocale(k.localize(0,null))||e.$f,D=S,p=navigator.language;else if(typeof c=="object"){F=c.platform==="win32",h=c.platform==="darwin",L=c.platform==="linux",A=L&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,b=f,I=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,S=e.$f,D=e.$f;const d=c.env.VSCODE_NLS_CONFIG;if(d)try{const v=JSON.parse(d),l=v.availableLanguages["*"];S=v.locale,p=v.osLocale,D=l||e.$f,r=v._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var C;(function(d){d[d.Web=0]="Web",d[d.Mac=1]="Mac",d[d.Linux=2]="Linux",d[d.Windows=3]="Windows"})(C||(e.Platform=C={}));function i(d){switch(d){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=i;let a=0;h?a=1:F?a=3:L&&(a=2),e.$i=F,e.$j=h,e.$k=L,e.$l=A,e.$m=m,e.$n=b,e.$o=E,e.$p=E&&typeof e.$g.importScripts=="function",e.$q=R,e.$r=$,e.$s=I,e.$t=a,e.$u=s,e.$v=D;var n;(function(d){function v(){return e.$v}d.value=v;function l(){return e.$v.length===2?e.$v==="en":e.$v.length>=3?e.$v[0]==="e"&&e.$v[1]==="n"&&e.$v[2]==="-":!1}d.isDefaultVariant=l;function w(){return e.$v==="en"}d.isDefault=w})(n||(e.Language=n={})),e.$w=S,e.$x=p,e.$y=r,e.$z=typeof e.$g.postMessage=="function"&&!e.$g.importScripts,e.$A=(()=>{if(e.$z){const d=[];e.$g.addEventListener("message",l=>{if(l.data&&l.data.vscodeScheduleAsyncWork)for(let w=0,P=d.length;w<P;w++){const M=d[w];if(M.id===l.data.vscodeScheduleAsyncWork){d.splice(w,1),M.callback();return}}});let v=0;return l=>{const w=++v;d.push({id:w,callback:l}),e.$g.postMessage({vscodeScheduleAsyncWork:w},"*")}}return d=>setTimeout(d)})();var t;(function(d){d[d.Windows=1]="Windows",d[d.Macintosh=2]="Macintosh",d[d.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=h||R?2:F?1:3;let o=!0,g=!1;function u(){if(!g){g=!0;const d=new Uint8Array(2);d[0]=1,d[1]=2,o=new Uint16Array(d.buffer)[0]===(2<<8)+1}return o}e.$C=u,e.$D=!!(e.$u&&e.$u.indexOf("Chrome")>=0),e.$E=!!(e.$u&&e.$u.indexOf("Firefox")>=0),e.$F=!!(!e.$D&&e.$u&&e.$u.indexOf("Safari")>=0),e.$G=!!(e.$u&&e.$u.indexOf("Edg/")>=0),e.$H=!!(e.$u&&e.$u.indexOf("Android")>=0)}),define(De[41],Ce([1,0,11]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8b=e.$7b=e.env=e.cwd=void 0;let F;if(typeof k.$g.vscode<"u"&&typeof k.$g.vscode.process<"u"){const h=k.$g.vscode.process;F={get platform(){return h.platform},get arch(){return h.arch},get env(){return h.env},cwd(){return h.cwd()}}}else typeof process<"u"?F={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:F={get platform(){return k.$i?"win32":k.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=F.cwd,e.env=F.env,e.$7b=F.platform,e.$8b=F.arch}),define(De[13],Ce([1,0,41]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kc=e.sep=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=e.$dc=e.$cc=e.$bc=e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=void 0;const F=65,h=97,L=90,A=122,m=46,E=47,b=92,R=58,I=63;class $ extends Error{constructor(a,n,t){let o;typeof n=="string"&&n.indexOf("not ")===0?(o="must not be",n=n.replace(/^not /,"")):o="must be";const g=a.indexOf(".")!==-1?"property":"argument";let u=`The "${a}" ${g} ${o} of type ${n}`;u+=`. Received type ${typeof t}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function S(i,a){if(i===null||typeof i!="object")throw new $(a,"Object",i)}function D(i,a){if(typeof i!="string")throw new $(a,"string",i)}const p=k.$7b==="win32";function r(i){return i===E||i===b}function s(i){return i===E}function c(i){return i>=F&&i<=L||i>=h&&i<=A}function f(i,a,n,t){let o="",g=0,u=-1,d=0,v=0;for(let l=0;l<=i.length;++l){if(l<i.length)v=i.charCodeAt(l);else{if(t(v))break;v=E}if(t(v)){if(!(u===l-1||d===1))if(d===2){if(o.length<2||g!==2||o.charCodeAt(o.length-1)!==m||o.charCodeAt(o.length-2)!==m){if(o.length>2){const w=o.lastIndexOf(n);w===-1?(o="",g=0):(o=o.slice(0,w),g=o.length-1-o.lastIndexOf(n)),u=l,d=0;continue}else if(o.length!==0){o="",g=0,u=l,d=0;continue}}a&&(o+=o.length>0?`${n}..`:"..",g=2)}else o.length>0?o+=`${n}${i.slice(u+1,l)}`:o=i.slice(u+1,l),g=l-u-1;u=l,d=0}else v===m&&d!==-1?++d:d=-1}return o}function y(i,a){S(a,"pathObject");const n=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return n?n===a.root?`${n}${t}`:`${n}${i}${t}`:t}e.$9b={resolve(...i){let a="",n="",t=!1;for(let o=i.length-1;o>=-1;o--){let g;if(o>=0){if(g=i[o],D(g,"path"),g.length===0)continue}else a.length===0?g=k.cwd():(g=k.env[`=${a}`]||k.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==a.toLowerCase()&&g.charCodeAt(2)===b)&&(g=`${a}\\`));const u=g.length;let d=0,v="",l=!1;const w=g.charCodeAt(0);if(u===1)r(w)&&(d=1,l=!0);else if(r(w))if(l=!0,r(g.charCodeAt(1))){let P=2,M=P;for(;P<u&&!r(g.charCodeAt(P));)P++;if(P<u&&P!==M){const N=g.slice(M,P);for(M=P;P<u&&r(g.charCodeAt(P));)P++;if(P<u&&P!==M){for(M=P;P<u&&!r(g.charCodeAt(P));)P++;(P===u||P!==M)&&(v=`\\\\${N}\\${g.slice(M,P)}`,d=P)}}}else d=1;else c(w)&&g.charCodeAt(1)===R&&(v=g.slice(0,2),d=2,u>2&&r(g.charCodeAt(2))&&(l=!0,d=3));if(v.length>0)if(a.length>0){if(v.toLowerCase()!==a.toLowerCase())continue}else a=v;if(t){if(a.length>0)break}else if(n=`${g.slice(d)}\\${n}`,t=l,l&&a.length>0)break}return n=f(n,!t,"\\",r),t?`${a}\\${n}`:`${a}${n}`||"."},normalize(i){D(i,"path");const a=i.length;if(a===0)return".";let n=0,t,o=!1;const g=i.charCodeAt(0);if(a===1)return s(g)?"\\":i;if(r(g))if(o=!0,r(i.charCodeAt(1))){let d=2,v=d;for(;d<a&&!r(i.charCodeAt(d));)d++;if(d<a&&d!==v){const l=i.slice(v,d);for(v=d;d<a&&r(i.charCodeAt(d));)d++;if(d<a&&d!==v){for(v=d;d<a&&!r(i.charCodeAt(d));)d++;if(d===a)return`\\\\${l}\\${i.slice(v)}\\`;d!==v&&(t=`\\\\${l}\\${i.slice(v,d)}`,n=d)}}}else n=1;else c(g)&&i.charCodeAt(1)===R&&(t=i.slice(0,2),n=2,a>2&&r(i.charCodeAt(2))&&(o=!0,n=3));let u=n<a?f(i.slice(n),!o,"\\",r):"";return u.length===0&&!o&&(u="."),u.length>0&&r(i.charCodeAt(a-1))&&(u+="\\"),t===void 0?o?`\\${u}`:u:o?`${t}\\${u}`:`${t}${u}`},isAbsolute(i){D(i,"path");const a=i.length;if(a===0)return!1;const n=i.charCodeAt(0);return r(n)||a>2&&c(n)&&i.charCodeAt(1)===R&&r(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let a,n;for(let g=0;g<i.length;++g){const u=i[g];D(u,"path"),u.length>0&&(a===void 0?a=n=u:a+=`\\${u}`)}if(a===void 0)return".";let t=!0,o=0;if(typeof n=="string"&&r(n.charCodeAt(0))){++o;const g=n.length;g>1&&r(n.charCodeAt(1))&&(++o,g>2&&(r(n.charCodeAt(2))?++o:t=!1))}if(t){for(;o<a.length&&r(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return e.$9b.normalize(a)},relative(i,a){if(D(i,"from"),D(a,"to"),i===a)return"";const n=e.$9b.resolve(i),t=e.$9b.resolve(a);if(n===t||(i=n.toLowerCase(),a=t.toLowerCase(),i===a))return"";let o=0;for(;o<i.length&&i.charCodeAt(o)===b;)o++;let g=i.length;for(;g-1>o&&i.charCodeAt(g-1)===b;)g--;const u=g-o;let d=0;for(;d<a.length&&a.charCodeAt(d)===b;)d++;let v=a.length;for(;v-1>d&&a.charCodeAt(v-1)===b;)v--;const l=v-d,w=u<l?u:l;let P=-1,M=0;for(;M<w;M++){const T=i.charCodeAt(o+M);if(T!==a.charCodeAt(d+M))break;T===b&&(P=M)}if(M!==w){if(P===-1)return t}else{if(l>w){if(a.charCodeAt(d+M)===b)return t.slice(d+M+1);if(M===2)return t.slice(d+M)}u>w&&(i.charCodeAt(o+M)===b?P=M:M===2&&(P=3)),P===-1&&(P=0)}let N="";for(M=o+P+1;M<=g;++M)(M===g||i.charCodeAt(M)===b)&&(N+=N.length===0?"..":"\\..");return d+=P,N.length>0?`${N}${t.slice(d,v)}`:(t.charCodeAt(d)===b&&++d,t.slice(d,v))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const a=e.$9b.resolve(i);if(a.length<=2)return i;if(a.charCodeAt(0)===b){if(a.charCodeAt(1)===b){const n=a.charCodeAt(2);if(n!==I&&n!==m)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(c(a.charCodeAt(0))&&a.charCodeAt(1)===R&&a.charCodeAt(2)===b)return`\\\\?\\${a}`;return i},dirname(i){D(i,"path");const a=i.length;if(a===0)return".";let n=-1,t=0;const o=i.charCodeAt(0);if(a===1)return r(o)?i:".";if(r(o)){if(n=t=1,r(i.charCodeAt(1))){let d=2,v=d;for(;d<a&&!r(i.charCodeAt(d));)d++;if(d<a&&d!==v){for(v=d;d<a&&r(i.charCodeAt(d));)d++;if(d<a&&d!==v){for(v=d;d<a&&!r(i.charCodeAt(d));)d++;if(d===a)return i;d!==v&&(n=t=d+1)}}}}else c(o)&&i.charCodeAt(1)===R&&(n=a>2&&r(i.charCodeAt(2))?3:2,t=n);let g=-1,u=!0;for(let d=a-1;d>=t;--d)if(r(i.charCodeAt(d))){if(!u){g=d;break}}else u=!1;if(g===-1){if(n===-1)return".";g=n}return i.slice(0,g)},basename(i,a){a!==void 0&&D(a,"ext"),D(i,"path");let n=0,t=-1,o=!0,g;if(i.length>=2&&c(i.charCodeAt(0))&&i.charCodeAt(1)===R&&(n=2),a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let u=a.length-1,d=-1;for(g=i.length-1;g>=n;--g){const v=i.charCodeAt(g);if(r(v)){if(!o){n=g+1;break}}else d===-1&&(o=!1,d=g+1),u>=0&&(v===a.charCodeAt(u)?--u===-1&&(t=g):(u=-1,t=d))}return n===t?t=d:t===-1&&(t=i.length),i.slice(n,t)}for(g=i.length-1;g>=n;--g)if(r(i.charCodeAt(g))){if(!o){n=g+1;break}}else t===-1&&(o=!1,t=g+1);return t===-1?"":i.slice(n,t)},extname(i){D(i,"path");let a=0,n=-1,t=0,o=-1,g=!0,u=0;i.length>=2&&i.charCodeAt(1)===R&&c(i.charCodeAt(0))&&(a=t=2);for(let d=i.length-1;d>=a;--d){const v=i.charCodeAt(d);if(r(v)){if(!g){t=d+1;break}continue}o===-1&&(g=!1,o=d+1),v===m?n===-1?n=d:u!==1&&(u=1):n!==-1&&(u=-1)}return n===-1||o===-1||u===0||u===1&&n===o-1&&n===t+1?"":i.slice(n,o)},format:y.bind(null,"\\"),parse(i){D(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const n=i.length;let t=0,o=i.charCodeAt(0);if(n===1)return r(o)?(a.root=a.dir=i,a):(a.base=a.name=i,a);if(r(o)){if(t=1,r(i.charCodeAt(1))){let P=2,M=P;for(;P<n&&!r(i.charCodeAt(P));)P++;if(P<n&&P!==M){for(M=P;P<n&&r(i.charCodeAt(P));)P++;if(P<n&&P!==M){for(M=P;P<n&&!r(i.charCodeAt(P));)P++;P===n?t=P:P!==M&&(t=P+1)}}}}else if(c(o)&&i.charCodeAt(1)===R){if(n<=2)return a.root=a.dir=i,a;if(t=2,r(i.charCodeAt(2))){if(n===3)return a.root=a.dir=i,a;t=3}}t>0&&(a.root=i.slice(0,t));let g=-1,u=t,d=-1,v=!0,l=i.length-1,w=0;for(;l>=t;--l){if(o=i.charCodeAt(l),r(o)){if(!v){u=l+1;break}continue}d===-1&&(v=!1,d=l+1),o===m?g===-1?g=l:w!==1&&(w=1):g!==-1&&(w=-1)}return d!==-1&&(g===-1||w===0||w===1&&g===d-1&&g===u+1?a.base=a.name=i.slice(u,d):(a.name=i.slice(u,g),a.base=i.slice(u,d),a.ext=i.slice(g,d))),u>0&&u!==t?a.dir=i.slice(0,u-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const C=(()=>{if(p){const i=/\\/g;return()=>{const a=k.cwd().replace(i,"/");return a.slice(a.indexOf("/"))}}return()=>k.cwd()})();e.$0b={resolve(...i){let a="",n=!1;for(let t=i.length-1;t>=-1&&!n;t--){const o=t>=0?i[t]:C();D(o,"path"),o.length!==0&&(a=`${o}/${a}`,n=o.charCodeAt(0)===E)}return a=f(a,!n,"/",s),n?`/${a}`:a.length>0?a:"."},normalize(i){if(D(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===E,n=i.charCodeAt(i.length-1)===E;return i=f(i,!a,"/",s),i.length===0?a?"/":n?"./":".":(n&&(i+="/"),a?`/${i}`:i)},isAbsolute(i){return D(i,"path"),i.length>0&&i.charCodeAt(0)===E},join(...i){if(i.length===0)return".";let a;for(let n=0;n<i.length;++n){const t=i[n];D(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.$0b.normalize(a)},relative(i,a){if(D(i,"from"),D(a,"to"),i===a||(i=e.$0b.resolve(i),a=e.$0b.resolve(a),i===a))return"";const n=1,t=i.length,o=t-n,g=1,u=a.length-g,d=o<u?o:u;let v=-1,l=0;for(;l<d;l++){const P=i.charCodeAt(n+l);if(P!==a.charCodeAt(g+l))break;P===E&&(v=l)}if(l===d)if(u>d){if(a.charCodeAt(g+l)===E)return a.slice(g+l+1);if(l===0)return a.slice(g+l)}else o>d&&(i.charCodeAt(n+l)===E?v=l:l===0&&(v=0));let w="";for(l=n+v+1;l<=t;++l)(l===t||i.charCodeAt(l)===E)&&(w+=w.length===0?"..":"/..");return`${w}${a.slice(g+v)}`},toNamespacedPath(i){return i},dirname(i){if(D(i,"path"),i.length===0)return".";const a=i.charCodeAt(0)===E;let n=-1,t=!0;for(let o=i.length-1;o>=1;--o)if(i.charCodeAt(o)===E){if(!t){n=o;break}}else t=!1;return n===-1?a?"/":".":a&&n===1?"//":i.slice(0,n)},basename(i,a){a!==void 0&&D(a,"ext"),D(i,"path");let n=0,t=-1,o=!0,g;if(a!==void 0&&a.length>0&&a.length<=i.length){if(a===i)return"";let u=a.length-1,d=-1;for(g=i.length-1;g>=0;--g){const v=i.charCodeAt(g);if(v===E){if(!o){n=g+1;break}}else d===-1&&(o=!1,d=g+1),u>=0&&(v===a.charCodeAt(u)?--u===-1&&(t=g):(u=-1,t=d))}return n===t?t=d:t===-1&&(t=i.length),i.slice(n,t)}for(g=i.length-1;g>=0;--g)if(i.charCodeAt(g)===E){if(!o){n=g+1;break}}else t===-1&&(o=!1,t=g+1);return t===-1?"":i.slice(n,t)},extname(i){D(i,"path");let a=-1,n=0,t=-1,o=!0,g=0;for(let u=i.length-1;u>=0;--u){const d=i.charCodeAt(u);if(d===E){if(!o){n=u+1;break}continue}t===-1&&(o=!1,t=u+1),d===m?a===-1?a=u:g!==1&&(g=1):a!==-1&&(g=-1)}return a===-1||t===-1||g===0||g===1&&a===t-1&&a===n+1?"":i.slice(a,t)},format:y.bind(null,"/"),parse(i){D(i,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return a;const n=i.charCodeAt(0)===E;let t;n?(a.root="/",t=1):t=0;let o=-1,g=0,u=-1,d=!0,v=i.length-1,l=0;for(;v>=t;--v){const w=i.charCodeAt(v);if(w===E){if(!d){g=v+1;break}continue}u===-1&&(d=!1,u=v+1),w===m?o===-1?o=v:l!==1&&(l=1):o!==-1&&(l=-1)}if(u!==-1){const w=g===0&&n?1:g;o===-1||l===0||l===1&&o===u-1&&o===g+1?a.base=a.name=i.slice(w,u):(a.name=i.slice(w,o),a.base=i.slice(w,u),a.ext=i.slice(o,u))}return g>0?a.dir=i.slice(0,g-1):n&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.$0b.win32=e.$9b.win32=e.$9b,e.$0b.posix=e.$9b.posix=e.$0b,e.$$b=p?e.$9b.normalize:e.$0b.normalize,e.$_b=p?e.$9b.isAbsolute:e.$0b.isAbsolute,e.$ac=p?e.$9b.join:e.$0b.join,e.$bc=p?e.$9b.resolve:e.$0b.resolve,e.$cc=p?e.$9b.relative:e.$0b.relative,e.$dc=p?e.$9b.dirname:e.$0b.dirname,e.$ec=p?e.$9b.basename:e.$0b.basename,e.$fc=p?e.$9b.extname:e.$0b.extname,e.$gc=p?e.$9b.format:e.$0b.format,e.$hc=p?e.$9b.parse:e.$0b.parse,e.$ic=p?e.$9b.toNamespacedPath:e.$0b.toNamespacedPath,e.sep=p?e.$9b.sep:e.$0b.sep,e.$kc=p?e.$9b.delimiter:e.$0b.delimiter}),define(De[118],Ce([1,0,54,13]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=void 0;const h=new k.$T(()=>{const d=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:d,collatorIsNumeric:d.resolvedOptions().numeric}}),L=new k.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new k.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(d,v,l=!1){const w=d||"",P=v||"",M=h.value.collator.compare(w,P);return h.value.collatorIsNumeric&&M===0&&w!==P?w<P?-1:1:M}e.$Wp=m;function E(d,v){const l=L.value.collator;return d=d||"",v=v||"",y(l,d,v)}e.$Xp=E;function b(d,v){const l=L.value.collator;return d=d||"",v=v||"",n(d,v)||y(l,d,v)}e.$Yp=b;function R(d,v){const l=L.value.collator;return d=d||"",v=v||"",a(d,v)||y(l,d,v)}e.$Zp=R;function I(d,v){return d=d||"",v=v||"",d===v?0:d<v?-1:1}e.$1p=I;function $(d,v){const[l,w]=c(d),[P,M]=c(v);let N=h.value.collator.compare(w,M);if(N===0){if(h.value.collatorIsNumeric&&w!==M)return w<M?-1:1;if(N=h.value.collator.compare(l,P),h.value.collatorIsNumeric&&N===0&&l!==P)return l<P?-1:1}return N}e.$2p=$;function S(d,v){d=d||"",v=v||"";const l=f(d),w=f(v),P=L.value.collator,M=A.value.collator;return y(M,l,w)||y(P,d,v)}e.$3p=S;function D(d,v){d=d||"",v=v||"";const l=f(d),w=f(v),P=L.value.collator,M=A.value.collator;return y(M,l,w)||n(d,v)||y(P,d,v)}e.$4p=D;function p(d,v){d=d||"",v=v||"";const l=f(d),w=f(v),P=L.value.collator,M=A.value.collator;return y(M,l,w)||a(d,v)||y(P,d,v)}e.$5p=p;function r(d,v){d=d||"",v=v||"";const l=f(d).toLowerCase(),w=f(v).toLowerCase();return l!==w?l<w?-1:1:d!==v?d<v?-1:1:0}e.$6p=r;const s=/^(.*?)(\.([^.]*))?$/;function c(d,v=!1){const l=d?s.exec(d):[];let w=[l&&l[1]||"",l&&l[3]||""];return v&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function f(d){const v=d?s.exec(d):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function y(d,v,l){const w=d.compare(v,l);return w!==0?w:v.length!==l.length?v.length<l.length?-1:1:0}function C(d){const v=d.charAt(0);return v.toLocaleUpperCase()!==v}function i(d){const v=d.charAt(0);return v.toLocaleLowerCase()!==v}function a(d,v){return C(d)&&i(v)?-1:i(d)&&C(v)?1:0}function n(d,v){return i(d)&&C(v)?-1:C(d)&&i(v)?1:0}function t(d,v,l=!1){return l||(d=d&&d.toLowerCase(),v=v&&v.toLowerCase()),d===v?0:d<v?-1:1}function o(d,v,l=!1){const w=d.split(F.sep),P=v.split(F.sep),M=w.length-1,N=P.length-1;let T,z;for(let j=0;;j++){if(T=M===j,z=N===j,T&&z)return m(w[j],P[j],l);if(T)return-1;if(z)return 1;const U=t(w[j],P[j],l);if(U!==0)return U}}e.$7p=o;function g(d,v,l){const w=d.toLowerCase(),P=v.toLowerCase(),M=u(d,v,l);if(M)return M;const N=w.endsWith(l),T=P.endsWith(l);if(N!==T)return N?-1:1;const z=m(w,P);return z!==0?z:w.localeCompare(P)}e.$8p=g;function u(d,v,l){const w=d.toLowerCase(),P=v.toLowerCase(),M=w.startsWith(l),N=P.startsWith(l);if(M!==N)return M?-1:1;if(M&&N){if(w.length<P.length)return-1;if(w.length>P.length)return 1}return 0}e.$9p=u}),define(De[31],Ce([1,0,13,11,12,14]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function A(g){return g===47||g===92}e.$Ce=A;function m(g){return g.replace(/[\\/]/g,k.$0b.sep)}e.$De=m;function E(g){return g.indexOf("/")===-1&&(g=m(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.$Ee=E;function b(g,u=k.$0b.sep){if(!g)return"";const d=g.length,v=g.charCodeAt(0);if(A(v)){if(A(g.charCodeAt(1))&&!A(g.charCodeAt(2))){let w=3;const P=w;for(;w<d&&!A(g.charCodeAt(w));w++);if(P!==w&&!A(g.charCodeAt(w+1))){for(w+=1;w<d;w++)if(A(g.charCodeAt(w)))return g.slice(0,w+1).replace(/[\\/]/g,u)}}return u}else if(s(v)&&g.charCodeAt(1)===58)return A(g.charCodeAt(2))?g.slice(0,2)+u:g.slice(0,2);let l=g.indexOf("://");if(l!==-1){for(l+=3;l<d;l++)if(A(g.charCodeAt(l)))return g.slice(0,l+1)}return""}e.$Fe=b;function R(g){if(!F.$i||!g||g.length<5)return!1;let u=g.charCodeAt(0);if(u!==92||(u=g.charCodeAt(1),u!==92))return!1;let d=2;const v=d;for(;d<g.length&&(u=g.charCodeAt(d),u!==92);d++);return!(v===d||(u=g.charCodeAt(d+1),isNaN(u)||u===92))}e.$Ge=R;const I=/[\\/:\*\?"<>\|]/g,$=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(g,u=F.$i){const d=u?I:$;return!(!g||g.length===0||/^\s+$/.test(g)||(d.lastIndex=0,d.test(g))||u&&S.test(g)||g==="."||g===".."||u&&g[g.length-1]==="."||u&&g.length!==g.trim().length||g.length>255)}e.$He=D;function p(g,u,d){const v=g===u;return!d||v?v:!g||!u?!1:(0,h.$Ld)(g,u)}e.$Ie=p;function r(g,u,d,v=k.sep){if(g===u)return!0;if(!g||!u||u.length>g.length)return!1;if(d){if(!(0,h.$Md)(g,u))return!1;if(u.length===g.length)return!0;let w=u.length;return u.charAt(u.length-1)===v&&w--,g.charAt(w)===v}return u.charAt(u.length-1)!==v&&(u+=v),g.indexOf(u)===0}e.$Je=r;function s(g){return g>=65&&g<=90||g>=97&&g<=122}e.$Ke=s;function c(g,u){return F.$i&&g.endsWith(":")&&(g+=k.sep),(0,k.$_b)(g)||(g=(0,k.$ac)(u,g)),g=(0,k.$$b)(g),F.$i?(g=(0,h.$sd)(g,k.sep),g.endsWith(":")&&(g+=k.sep)):(g=(0,h.$sd)(g,k.sep),g||(g=k.sep)),g}e.$Le=c;function f(g){const u=(0,k.$$b)(g);return F.$i?g.length>3?!1:y(u)&&(g.length===2||u.charCodeAt(2)===92):u===k.$0b.sep}e.$Me=f;function y(g,u=F.$i){return u?s(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.$Ne=y;function C(g,u=F.$i){return y(g,u)?g[0]:void 0}e.$Oe=C;function i(g,u,d){return u.length>g.length?-1:g===u?0:(d&&(g=g.toLowerCase(),u=u.toLowerCase()),g.indexOf(u))}e.$Pe=i;function a(g){const u=g.split(":");let d,v,l;for(const w of u){const P=Number(w);(0,L.$me)(P)?v===void 0?v=P:l===void 0&&(l=P):d=d?[d,w].join(":"):w}if(!d)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:d,line:v!==void 0?v:void 0,column:l!==void 0?l:v!==void 0?1:void 0}}e.$Qe=a;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",t="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(g,u,d=8){let v="";for(let w=0;w<d;w++){let P;w===0&&F.$i&&!u&&(d===3||d===4)?P=t:P=n,v+=P.charAt(Math.floor(Math.random()*P.length))}let l;return u?l=`${u}-${v}`:l=v,g?(0,k.$ac)(g,l):l}e.$Re=o}),define(De[119],Ce([1,0,118,113,70,13,11,12]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=e.$aq=e.$_p=e.$$p=e.$0p=void 0;const E=0,b=[E,[]];function R(Y,H,ge,ie){if(!Y||!H)return b;const te=Y.length,q=H.length;if(te<q)return b;const V=Y.toLowerCase();return I(H,ge,q,Y,V,te,ie)}e.$0p=R;function I(Y,H,ge,ie,te,q,V){const ce=[],re=[];for(let _=0;_<ge;_++){const Ee=_*q,Re=Ee-q,ne=_>0,ee=Y[_],he=H[_];for(let X=0;X<q;X++){const ue=X>0,oe=Ee+X,le=oe-1,we=Re+X-1,O=ue?ce[le]:0,K=ne&&ue?ce[we]:0,G=ne&&ue?re[we]:0;let x;!K&&ne?x=0:x=$(ee,he,ie,te,X,G),x&&K+x>=O&&(V||ne||te.startsWith(H,X))?(re[oe]=G+1,ce[oe]=K+x):(re[oe]=E,ce[oe]=O)}}const fe=[];let de=ge-1,B=q-1;for(;de>=0&&B>=0;){const _=de*q+B;re[_]===E||(fe.push(B),de--),B--}return[ce[ge*q-1],fe.reverse()]}function $(Y,H,ge,ie,te,q){let V=0;if(!S(H,ie[te]))return V;if(V+=1,q>0&&(V+=q*5),Y===ge[te]&&(V+=1),te===0)V+=8;else{const ce=D(ge.charCodeAt(te-1));ce?V+=ce:(0,F.$mj)(ge.charCodeAt(te))&&q===0&&(V+=2)}return V}function S(Y,H){return Y===H?!0:Y==="/"||Y==="\\"?H==="/"||H==="\\":!1}function D(Y){switch(Y){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const p=[void 0,[]];function r(Y,H,ge=0,ie=0){const te=H;return te.values&&te.values.length>1?s(Y,te.values,ge,ie):c(Y,H,ge,ie)}e.$$p=r;function s(Y,H,ge,ie){let te=0;const q=[];for(const V of H){const[ce,re]=c(Y,V,ge,ie);if(typeof ce!="number")return p;te+=ce,q.push(...re)}return[te,d(q)]}function c(Y,H,ge,ie){const te=(0,F.$vj)(H.original,H.originalLowercase,ge,Y,Y.toLowerCase(),ie,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return te?[te[0],(0,F.$sj)(te)]:p}const f=Object.freeze({score:0}),y=1<<18,C=1<<17,i=1<<16;function a(Y,H,ge,ie){const te=ie.values?ie.values:[ie];return(0,h.$bi)({[ie.normalized]:{values:te.map(V=>({value:V.normalized,expectContiguousMatch:V.expectContiguousMatch})),label:Y,description:H,allowNonContiguousMatches:ge}})}function n(Y,H,ge,ie,te){if(!Y||!H.normalized)return f;const q=ie.getItemLabel(Y);if(!q)return f;const V=ie.getItemDescription(Y),ce=a(q,V,ge,H),re=te[ce];if(re)return re;const fe=t(q,V,ie.getItemPath(Y),H,ge);return te[ce]=fe,fe}e.$_p=n;function t(Y,H,ge,ie,te){const q=!ge||!ie.containsPathSeparator;return ge&&(A.$k?ie.pathNormalized===ge:(0,m.$Ld)(ie.pathNormalized,ge))?{score:y,labelMatch:[{start:0,end:Y.length}],descriptionMatch:H?[{start:0,end:H.length}]:void 0}:ie.values&&ie.values.length>1?o(Y,H,ge,ie.values,q,te):g(Y,H,ge,ie,q,te)}function o(Y,H,ge,ie,te,q){let V=0;const ce=[],re=[];for(const fe of ie){const{score:de,labelMatch:B,descriptionMatch:_}=g(Y,H,ge,fe,te,q);if(de===E)return f;V+=de,B&&ce.push(...B),_&&re.push(..._)}return{score:V,labelMatch:d(ce),descriptionMatch:d(re)}}function g(Y,H,ge,ie,te,q){if(te||!H){const[V,ce]=R(Y,ie.normalized,ie.normalizedLowercase,q&&!ie.expectContiguousMatch);if(V){const re=(0,F.$jj)(ie.normalized,Y);let fe;if(re){fe=C;const de=Math.round(ie.normalized.length/Y.length*100);fe+=de}else fe=i;return{score:fe+V,labelMatch:re||u(ce)}}}if(H){let V=H;ge&&(V=`${H}${L.sep}`);const ce=V.length,re=`${V}${Y}`,[fe,de]=R(re,ie.normalized,ie.normalizedLowercase,q&&!ie.expectContiguousMatch);if(fe){const B=u(de),_=[],Ee=[];return B.forEach(Re=>{Re.start<ce&&Re.end>ce?(_.push({start:0,end:Re.end-ce}),Ee.push({start:Re.start,end:ce})):Re.start>=ce?_.push({start:Re.start-ce,end:Re.end-ce}):Ee.push(Re)}),{score:fe,labelMatch:_,descriptionMatch:Ee}}}return f}function u(Y){const H=[];if(!Y)return H;let ge;for(const ie of Y)ge&&ge.end===ie?ge.end+=1:(ge={start:ie,end:ie+1},H.push(ge));return H}function d(Y){const H=Y.sort((te,q)=>te.start-q.start),ge=[];let ie;for(const te of H)!ie||!v(ie,te)?(ie=te,ge.push(te)):(ie.start=Math.min(ie.start,te.start),ie.end=Math.max(ie.end,te.end));return ge}function v(Y,H){return!(Y.end<H.start||H.end<Y.start)}function l(Y,H,ge,ie,te,q){const V=n(Y,ge,ie,te,q),ce=n(H,ge,ie,te,q),re=V.score,fe=ce.score;if((re===y||fe===y)&&re!==fe)return re===y?-1:1;if(re>i||fe>i){if(re!==fe)return re>fe?-1:1;if(re<C&&fe<C){const ee=P(V.labelMatch,ce.labelMatch);if(ee!==0)return ee}const Re=te.getItemLabel(Y)||"",ne=te.getItemLabel(H)||"";if(Re.length!==ne.length)return Re.length-ne.length}if(re!==fe)return re>fe?-1:1;const de=Array.isArray(V.labelMatch)&&V.labelMatch.length>0,B=Array.isArray(ce.labelMatch)&&ce.labelMatch.length>0;if(de&&!B)return-1;if(B&&!de)return 1;const _=w(Y,V,te),Ee=w(H,ce,te);return _&&Ee&&_!==Ee?Ee>_?-1:1:M(Y,H,ge,te)}e.$aq=l;function w(Y,H,ge){let ie=-1,te=-1;if(H.descriptionMatch&&H.descriptionMatch.length?ie=H.descriptionMatch[0].start:H.labelMatch&&H.labelMatch.length&&(ie=H.labelMatch[0].start),H.labelMatch&&H.labelMatch.length){if(te=H.labelMatch[H.labelMatch.length-1].end,H.descriptionMatch&&H.descriptionMatch.length){const q=ge.getItemDescription(Y);q&&(te+=q.length)}}else H.descriptionMatch&&H.descriptionMatch.length&&(te=H.descriptionMatch[H.descriptionMatch.length-1].end);return te-ie}function P(Y,H){if(!Y&&!H||(!Y||!Y.length)&&(!H||!H.length))return 0;if(!H||!H.length)return-1;if(!Y||!Y.length)return 1;const ge=Y[0].start,te=Y[Y.length-1].end-ge,q=H[0].start,ce=H[H.length-1].end-q;return te===ce?0:ce<te?1:-1}function M(Y,H,ge,ie){const te=ie.getItemLabel(Y)||"",q=ie.getItemLabel(H)||"",V=ie.getItemDescription(Y),ce=ie.getItemDescription(H),re=te.length+(V?V.length:0),fe=q.length+(ce?ce.length:0);if(re!==fe)return re-fe;const de=ie.getItemPath(Y),B=ie.getItemPath(H);return de&&B&&de.length!==B.length?de.length-B.length:te!==q?(0,k.$8p)(te,q,ge.normalized):V&&ce&&V!==ce?(0,k.$8p)(V,ce,ge.normalized):de&&B&&de!==B?(0,k.$8p)(de,B,ge.normalized):0}function N(Y){return Y.startsWith('"')&&Y.endsWith('"')}const T=" ";function z(Y){typeof Y!="string"&&(Y="");const H=Y.toLowerCase(),{pathNormalized:ge,normalized:ie,normalizedLowercase:te}=j(Y),q=ge.indexOf(L.sep)>=0,V=N(Y);let ce;const re=Y.split(T);if(re.length>1)for(const fe of re){const de=N(fe),{pathNormalized:B,normalized:_,normalizedLowercase:Ee}=j(fe);_&&(ce||(ce=[]),ce.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:B,normalized:_,normalizedLowercase:Ee,expectContiguousMatch:de}))}return{original:Y,originalLowercase:H,pathNormalized:ge,normalized:ie,normalizedLowercase:te,values:ce,containsPathSeparator:q,expectContiguousMatch:V}}e.$bq=z;function j(Y){let H;A.$i?H=Y.replace(/\//g,L.sep):H=Y.replace(/\\/g,L.sep);const ge=(0,m.$ud)(H).replace(/\s|"/g,"");return{pathNormalized:H,normalized:ge,normalizedLowercase:ge.toLowerCase()}}function U(Y){return Array.isArray(Y)?z(Y.map(H=>H.original).join(T)):z(Y.original)}e.$cq=U}),define(De[93],Ce([1,0,13]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=e.$sr=void 0,e.$sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const F={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},h={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const I=(0,k.$fc)(R),$=F[I.toLowerCase()];return $!==void 0?$:A(R)}e.$tr=L;function A(R){const I=(0,k.$fc)(R);return h[I.toLowerCase()]}e.$ur=A;function m(R){for(const I in h)if(h[I]===R)return I}e.$vr=m;const E=/^(.+)\/(.+?)(;.+)?$/;function b(R,I){const $=E.exec(R);return $?`${$[1].toLowerCase()}/${$[2].toLowerCase()}${$[3]??""}`:I?void 0:R}e.$wr=b}),define(De[94],Ce([1,0,11]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.TerminateResponseCode=e.Source=void 0;var F;(function(m){m[m.stdout=0]="stdout",m[m.stderr=1]="stderr"})(F||(e.Source=F={}));var h;(function(m){m[m.Success=0]="Success",m[m.Unknown=1]="Unknown",m[m.AccessDenied=2]="AccessDenied",m[m.ProcessNotFound=3]="ProcessNotFound"})(h||(e.TerminateResponseCode=h={}));function L(m,...E){const b=E.reduce(($,S)=>($[S]=!0,$),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(m).filter($=>!b[$]).forEach($=>{for(let S=0;S<R.length;S++)if($.search(R[S])!==-1){delete m[$];break}})}e.$dl=L;function A(m){m&&(delete m.DEBUG,k.$j&&delete m.DYLD_LIBRARY_PATH,k.$k&&delete m.LD_PRELOAD)}e.$el=A}),define(De[2],Ce([1,0,13,11]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ue=e.$Te=e.URI=void 0;const h=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function m(t,o){if(!t.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!h.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!L.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(t,o){return!t&&!o?"file":t}function b(t,o){switch(t){case"https":case"http":case"file":o?o[0]!==I&&(o=I+o):o=I;break}return o}const R="",I="/",$=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{static isUri(o){return o instanceof S?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,g,u,d,v,l=!1){typeof o=="object"?(this.scheme=o.scheme||R,this.authority=o.authority||R,this.path=o.path||R,this.query=o.query||R,this.fragment=o.fragment||R):(this.scheme=E(o,l),this.authority=g||R,this.path=b(this.scheme,u||R),this.query=d||R,this.fragment=v||R,m(this,l))}get fsPath(){return y(this,!1)}with(o){if(!o)return this;let{scheme:g,authority:u,path:d,query:v,fragment:l}=o;return g===void 0?g=this.scheme:g===null&&(g=R),u===void 0?u=this.authority:u===null&&(u=R),d===void 0?d=this.path:d===null&&(d=R),v===void 0?v=this.query:v===null&&(v=R),l===void 0?l=this.fragment:l===null&&(l=R),g===this.scheme&&u===this.authority&&d===this.path&&v===this.query&&l===this.fragment?this:new r(g,u,d,v,l)}static parse(o,g=!1){const u=$.exec(o);return u?new r(u[2]||R,n(u[4]||R),n(u[5]||R),n(u[7]||R),n(u[9]||R),g):new r(R,R,R,R,R)}static file(o){let g=R;if(F.$i&&(o=o.replace(/\\/g,I)),o[0]===I&&o[1]===I){const u=o.indexOf(I,2);u===-1?(g=o.substring(2),o=I):(g=o.substring(2,u),o=o.substring(u)||I)}return new r("file",g,o,R,R)}static from(o,g){return new r(o.scheme,o.authority,o.path,o.query,o.fragment,g)}static joinPath(o,...g){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return F.$i&&o.scheme==="file"?u=S.file(k.$9b.join(y(o,!0),...g)).path:u=k.$0b.join(o.path,...g),o.with({path:u})}toString(o=!1){return C(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof S)return o;{const g=new r(o);return g._formatted=o.external??null,g._fsPath=o._sep===p?o.fsPath??null:null,g}}else return o}}e.URI=S;function D(t){return!t||typeof t!="object"?!1:typeof t.scheme=="string"&&(typeof t.authority=="string"||typeof t.authority>"u")&&(typeof t.path=="string"||typeof t.path>"u")&&(typeof t.query=="string"||typeof t.query>"u")&&(typeof t.fragment=="string"||typeof t.fragment>"u")}e.$Te=D;const p=F.$i?1:void 0;class r extends S{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(o=!1){return o?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=p),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function c(t,o,g){let u,d=-1;for(let v=0;v<t.length;v++){const l=t.charCodeAt(v);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||o&&l===47||g&&l===91||g&&l===93||g&&l===58)d!==-1&&(u+=encodeURIComponent(t.substring(d,v)),d=-1),u!==void 0&&(u+=t.charAt(v));else{u===void 0&&(u=t.substr(0,v));const w=s[l];w!==void 0?(d!==-1&&(u+=encodeURIComponent(t.substring(d,v)),d=-1),u+=w):d===-1&&(d=v)}}return d!==-1&&(u+=encodeURIComponent(t.substring(d))),u!==void 0?u:t}function f(t){let o;for(let g=0;g<t.length;g++){const u=t.charCodeAt(g);u===35||u===63?(o===void 0&&(o=t.substr(0,g)),o+=s[u]):o!==void 0&&(o+=t[g])}return o!==void 0?o:t}function y(t,o){let g;return t.authority&&t.path.length>1&&t.scheme==="file"?g=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?o?g=t.path.substr(1):g=t.path[1].toLowerCase()+t.path.substr(2):g=t.path,F.$i&&(g=g.replace(/\//g,"\\")),g}e.$Ue=y;function C(t,o){const g=o?f:c;let u="",{scheme:d,authority:v,path:l,query:w,fragment:P}=t;if(d&&(u+=d,u+=":"),(v||d==="file")&&(u+=I,u+=I),v){let M=v.indexOf("@");if(M!==-1){const N=v.substr(0,M);v=v.substr(M+1),M=N.lastIndexOf(":"),M===-1?u+=g(N,!1,!1):(u+=g(N.substr(0,M),!1,!1),u+=":",u+=g(N.substr(M+1),!1,!0)),u+="@"}v=v.toLowerCase(),M=v.lastIndexOf(":"),M===-1?u+=g(v,!1,!0):(u+=g(v.substr(0,M),!1,!0),u+=v.substr(M))}if(l){if(l.length>=3&&l.charCodeAt(0)===47&&l.charCodeAt(2)===58){const M=l.charCodeAt(1);M>=65&&M<=90&&(l=`/${String.fromCharCode(M+32)}:${l.substr(3)}`)}else if(l.length>=2&&l.charCodeAt(1)===58){const M=l.charCodeAt(0);M>=65&&M<=90&&(l=`${String.fromCharCode(M+32)}:${l.substr(2)}`)}u+=g(l,!0,!1)}return w&&(u+="?",u+=g(w,!1,!1)),P&&(u+="#",u+=o?P:c(P,!1,!1)),u}function i(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+i(t.substr(3)):t}}const a=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(t){return t.match(a)?t.replace(a,o=>i(o)):t}}),define(De[174],Ce([1,0,2]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$Cp=e.$Bp=e.$Ap=void 0;function F(b){const R=b;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.$Ap=F;function h(b){const R=[];let I;try{const $=JSON.parse(b.arguments),S=$[$.length-1];S&&S.__$stack&&($.pop(),I=S.__$stack),R.push(...$)}catch{R.push("Unable to log remote console arguments",b.arguments)}return{args:R,stack:I}}e.$Bp=h;function L(b){if(typeof b!="string")return L(h(b).stack);const R=b;if(R){const I=A(R),$=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if($&&$.length===4)return{uri:k.URI.file($[1]),line:Number($[2]),column:Number($[3])}}}e.$Cp=L;function A(b){if(!b)return b;const R=b.indexOf(`
`);return R===-1?b:b.substring(0,R)}function m(b,R){const{args:I,stack:$}=h(b),S=typeof I[0]=="string"&&I.length===1;let D=A($);D&&(D=`(${D.trim()})`);let p=[];if(typeof I[0]=="string"?D&&S?p=[`%c[${R}] %c${I[0]} %c${D}`,E("blue"),E(""),E("grey")]:p=[`%c[${R}] %c${I[0]}`,E("blue"),E(""),...I.slice(1)]:p=[`%c[${R}]%`,E("blue"),...I],D&&!S&&p.push(D),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,p)}e.log=m;function E(b){return`color: ${b}`}}),define(De[73],Ce([1,0,22,12,2]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=e.$Vg=e.$Ug=void 0;function L(b){return JSON.stringify(b,m)}e.$Ug=L;function A(b){let R=JSON.parse(b);return R=E(R),R}e.$Vg=A;function m(b,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,F.$yd)(R)}:R}function E(b,R=0){if(!b||R>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return h.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 16:return new Date(b.source)}if(b instanceof k.$Jb||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let I=0;I<b.length;++I)b[I]=E(b[I],R+1);else for(const I in b)Object.hasOwnProperty.call(b,I)&&(b[I]=E(b[I],R+1))}return b}e.$Wg=E}),define(De[15],Ce([1,0,8,11,2]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.Schemas=void 0;var L;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeManagedRemoteResource="vscode-managed-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.vscodeChatSesssion="vscode-chat-editor",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.$Ve="vscode-tkn",e.$We="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${L.vscodeRemoteResource}`}set(R,I,$){this.a[R]=I,this.b[R]=$}setConnectionToken(R,I){this.c[R]=I}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(r){return k.$Y(r),R}const I=R.authority;let $=this.a[I];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const S=this.b[I],D=this.c[I];let p=`path=${encodeURIComponent(R.path)}`;return typeof D=="string"&&(p+=`&${e.$We}=${encodeURIComponent(D)}`),h.URI.from({scheme:F.$o?this.d:L.vscodeRemoteResource,authority:`${$}:${S}`,path:this.f,query:p})}}e.$Xe=new A,e.$Ye="vs/../../extensions",e.$Ze="vs/../../node_modules",e.$1e="vs/../../node_modules.asar",e.$2e="vs/../../node_modules.asar.unpacked";class m{static{this.a="vscode-app"}asBrowserUri(R){const I=this.b(R,me);return this.uriToBrowserUri(I)}uriToBrowserUri(R){return R.scheme===L.vscodeRemote?e.$Xe.rewrite(R):R.scheme===L.file&&(F.$m||F.$p&&F.$g.origin===`${L.vscodeFileResource}://${m.a}`)?R.with({scheme:L.vscodeFileResource,authority:R.authority||m.a,query:null,fragment:null}):R}asFileUri(R){const I=this.b(R,me);return this.uriToFileUri(I)}uriToFileUri(R){return R.scheme===L.vscodeFileResource?R.with({scheme:L.file,authority:R.authority!==m.a?R.authority:null,query:null,fragment:null}):R}b(R,I){return h.URI.isUri(R)?R:h.URI.parse(I.toUrl(R))}}e.$3e=new m;var E;(function(b){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(R.get("3"));const I="vscode-coi";function $(D){let p;typeof D=="string"?p=new URL(D).searchParams:D instanceof URL?p=D.searchParams:h.URI.isUri(D)&&(p=new URL(D.toString(!0)).searchParams);const r=p?.get(I);if(r)return R.get(r)}b.getHeadersFromQuery=$;function S(D,p,r){if(!globalThis.crossOriginIsolated)return;const s=p&&r?"3":r?"2":"1";D instanceof URLSearchParams?D.set(I,s):D[I]=s}b.addSearchParam=S})(E||(e.COI=E={}))}),define(De[175],Ce([1,0,150,15,11,2]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=void 0;class A{constructor($,S,D){this.id=$,this.dependencies=S,this.callback=D}}class m{static{this.INSTANCE=new m}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=($,S,D)=>{typeof $!="string"&&(D=S,S=$,$=null),(typeof S!="object"||!Array.isArray(S))&&(D=S,S=null),this.c.push(new A($,S,D))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){if($.startsWith(window.location.origin)||$.startsWith("vscode-file://vscode-app"))return $;throw new Error(`[trusted_script_src] Invalid script url: ${$}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL($){return $}})))}async load($){this.g();const S=await(this.a?this.i($):this.b?this.h($):this.j($));if(!S)throw new Error(`Did not receive a define call from script ${$}`);if(Array.isArray(S.dependencies)&&S.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${$}. The dependencies are: ${S.dependencies.join(", ")}`);return typeof S.callback=="function"?S.callback([]):S.callback}h($){return new Promise((S,D)=>{const p=document.createElement("script");p.setAttribute("async","async"),p.setAttribute("type","text/javascript");const r=()=>{p.removeEventListener("load",s),p.removeEventListener("error",c)},s=f=>{r(),S(this.c.pop())},c=f=>{r(),D(f)};p.addEventListener("load",s),p.addEventListener("error",c),this.f&&($=this.f.createScriptURL($)),p.setAttribute("src",$),document.getElementsByTagName("head")[0].appendChild(p)})}i($){return new Promise((S,D)=>{try{this.f&&($=this.f.createScriptURL($)),importScripts($),S(this.c.pop())}catch(p){D(p)}})}async j($){try{const S=globalThis._VSCODE_NODE_MODULES.fs,D=globalThis._VSCODE_NODE_MODULES.vm,p=globalThis._VSCODE_NODE_MODULES.module,r=L.URI.parse($).fsPath,s=S.readFileSync(r).toString(),c=p.wrap(s.replace(/^#!.*/,""));return new D.Script(c).runInThisContext().apply(),this.c.pop()}catch(S){throw S}}}const E=new Map;let b={};typeof globalThis.require=="object"&&(b=globalThis.require.paths??{});async function R(I,$,S){if(k.$R){S===void 0&&(S=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),b[I]&&(I=b[I]);const D=`${I}/${$}`;if(E.has(D))return E.get(D);let p;if(/^\w[\w\d+.-]*:\/\//.test(D))p=D;else{const f=`${S&&!h.$o?F.$1e:F.$Ze}/${D}`;p=F.$3e.asBrowserUri(f).toString(!0)}const r=m.INSTANCE.load(p);return E.set(D,r),r}else return await new Promise((D,p)=>{me([I],D,p)})}e.$UC=R}),define(De[24],Ce([1,0,31,15,13,11,12,2]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.DataUri=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function E(S){return(0,m.$Ue)(S,!0)}e.$Vf=E;class b{constructor(D){this.a=D}compare(D,p,r=!1){return D===p?0:(0,A.$Ed)(this.getComparisonKey(D,r),this.getComparisonKey(p,r))}isEqual(D,p,r=!1){return D===p?!0:!D||!p?!1:this.getComparisonKey(D,r)===this.getComparisonKey(p,r)}getComparisonKey(D,p=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,p,r=!1){if(D.scheme===p.scheme){if(D.scheme===F.Schemas.file)return k.$Je(E(D),E(p),this.a(D))&&D.query===p.query&&(r||D.fragment===p.fragment);if((0,e.$ag)(D.authority,p.authority))return k.$Je(D.path,p.path,this.a(D),"/")&&D.query===p.query&&(r||D.fragment===p.fragment)}return!1}joinPath(D,...p){return m.URI.joinPath(D,...p)}basenameOrAuthority(D){return(0,e.$5f)(D)||D.authority}basename(D){return h.$0b.basename(D.path)}extname(D){return h.$0b.extname(D.path)}dirname(D){if(D.path.length===0)return D;let p;return D.scheme===F.Schemas.file?p=m.URI.file(h.$dc(E(D))).path:(p=h.$0b.dirname(D.path),D.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),p="/")),D.with({path:p})}normalizePath(D){if(!D.path.length)return D;let p;return D.scheme===F.Schemas.file?p=m.URI.file(h.$$b(E(D))).path:p=h.$0b.normalize(D.path),D.with({path:p})}relativePath(D,p){if(D.scheme!==p.scheme||!(0,e.$ag)(D.authority,p.authority))return;if(D.scheme===F.Schemas.file){const c=h.$cc(E(D),E(p));return L.$i?k.$De(c):c}let r=D.path||"/";const s=p.path||"/";if(this.a(D)){let c=0;for(const f=Math.min(r.length,s.length);c<f&&!(r.charCodeAt(c)!==s.charCodeAt(c)&&r.charAt(c).toLowerCase()!==s.charAt(c).toLowerCase());c++);r=s.substr(0,c)+r.substr(c)}return h.$0b.relative(r,s)}resolvePath(D,p){if(D.scheme===F.Schemas.file){const r=m.URI.file(h.$bc(E(D),p));return D.with({authority:r.authority,path:r.path})}return p=k.$Ee(p),D.with({path:h.$0b.resolve(D.path,p)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,p){return D===p||D!==void 0&&p!==void 0&&(0,A.$Ld)(D,p)}hasTrailingPathSeparator(D,p=h.sep){if(D.scheme===F.Schemas.file){const r=E(D);return r.length>k.$Fe(r).length&&r[r.length-1]===p}else{const r=D.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,p=h.sep){return(0,e.$bg)(D,p)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,p=h.sep){let r=!1;if(D.scheme===F.Schemas.file){const s=E(D);r=s!==void 0&&s.length===k.$Fe(s).length&&s[s.length-1]===p}else{p="/";const s=D.path;r=s.length===1&&s.charCodeAt(s.length-1)===47}return!r&&!(0,e.$bg)(D,p)?D.with({path:D.path+"/"}):D}}e.$Wf=b,e.$Xf=new b(()=>!1),e.$Yf=new b(S=>S.scheme===F.Schemas.file?!L.$k:!0),e.$Zf=new b(S=>!0),e.$1f=e.$Xf.isEqual.bind(e.$Xf),e.$2f=e.$Xf.isEqualOrParent.bind(e.$Xf),e.$3f=e.$Xf.getComparisonKey.bind(e.$Xf),e.$4f=e.$Xf.basenameOrAuthority.bind(e.$Xf),e.$5f=e.$Xf.basename.bind(e.$Xf),e.$6f=e.$Xf.extname.bind(e.$Xf),e.$7f=e.$Xf.dirname.bind(e.$Xf),e.$8f=e.$Xf.joinPath.bind(e.$Xf),e.$9f=e.$Xf.normalizePath.bind(e.$Xf),e.$0f=e.$Xf.relativePath.bind(e.$Xf),e.$$f=e.$Xf.resolvePath.bind(e.$Xf),e.$_f=e.$Xf.isAbsolutePath.bind(e.$Xf),e.$ag=e.$Xf.isEqualAuthority.bind(e.$Xf),e.$bg=e.$Xf.hasTrailingPathSeparator.bind(e.$Xf),e.$cg=e.$Xf.removeTrailingPathSeparator.bind(e.$Xf),e.$dg=e.$Xf.addTrailingPathSeparator.bind(e.$Xf);function R(S,D){const p=[];for(let r=0;r<S.length;r++){const s=D(S[r]);S.some((c,f)=>f===r?!1:(0,e.$2f)(s,D(c)))||p.push(S[r])}return p}e.$eg=R;var I;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function D(p){const r=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(f=>{const[y,C]=f.split(":");y&&C&&r.set(y,C)});const c=p.path.substring(0,p.path.indexOf(";"));return c&&r.set(S.META_DATA_MIME,c),r}S.parseMetaData=D})(I||(e.DataUri=I={}));function $(S,D,p){if(D){let r=S.path;return r&&r[0]!==h.$0b.sep&&(r=h.$0b.sep+r),S.with({scheme:p,authority:D,path:r})}return S.with({scheme:p})}e.$fg=$}),define(De[17],Ce([1,0,21,8,3,4,24,11,154]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.$Pg=e.$Og=e.Promises=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function b(de){return!!de&&typeof de.then=="function"}e.$gg=b;function R(de){const B=new k.$dd,_=de(B.token),Ee=new Promise((Re,ne)=>{const ee=B.token.onCancellationRequested(()=>{ee.dispose(),B.dispose(),ne(new F.$3)});Promise.resolve(_).then(he=>{ee.dispose(),B.dispose(),Re(he)},he=>{ee.dispose(),B.dispose(),ne(he)})});return new class{cancel(){B.cancel()}then(Re,ne){return Ee.then(Re,ne)}catch(Re){return this.then(void 0,Re)}finally(Re){return Ee.finally(Re)}}}e.$hg=R;function I(de,B,_){return new Promise((Ee,Re)=>{const ne=B.onCancellationRequested(()=>{ne.dispose(),Ee(_)});de.then(Ee,Re).finally(()=>ne.dispose())})}e.$ig=I;function $(de,B){return new Promise((_,Ee)=>{const Re=B.onCancellationRequested(()=>{Re.dispose(),Ee(new F.$3)});de.then(_,Ee).finally(()=>Re.dispose())})}e.$jg=$;async function S(de){let B=-1;const _=de.map((Ee,Re)=>Ee.then(ne=>(B=Re,ne)));try{return await Promise.race(_)}finally{de.forEach((Ee,Re)=>{Re!==B&&Ee.cancel()})}}e.$kg=S;function D(de,B,_){let Ee;const Re=setTimeout(()=>{Ee?.(void 0),_?.()},B);return Promise.race([de.finally(()=>clearTimeout(Re)),new Promise(ne=>Ee=ne)])}e.$lg=D;function p(de){return new Promise((B,_)=>{const Ee=de();b(Ee)?Ee.then(B,_):B(Ee)})}e.$mg=p;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=B,!this.b){const _=()=>{if(this.b=null,this.f)return;const Ee=this.queue(this.d);return this.d=null,Ee};this.b=new Promise(Ee=>{this.a.then(_,_).then(Ee)})}return new Promise((_,Ee)=>{this.b.then(_,Ee)})}return this.a=B(),new Promise((_,Ee)=>{this.a.then(Re=>{this.a=null,_(Re)},Re=>{this.a=null,Ee(Re)})})}dispose(){this.f=!0}}e.$ng=r;class s{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$og=s;class c{constructor(){this.a=new Map}queue(B,_){const Re=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(B)===Re&&this.a.delete(B)});return this.a.set(B,Re),Re}}e.$pg=c;const f=(de,B)=>{let _=!0;const Ee=setTimeout(()=>{_=!1,B()},de);return{isTriggered:()=>_,dispose:()=>{clearTimeout(Ee),_=!1}}},y=de=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,de())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class C{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,_=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((Re,ne)=>{this.d=Re,this.f=ne}).then(()=>{if(this.b=null,this.d=null,this.g){const Re=this.g;return this.g=null,Re()}}));const Ee=()=>{this.a=null,this.d?.(null)};return this.a=_===E.$4c?y(Ee):f(_,Ee),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new F.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$qg=C;class i{constructor(B){this.a=new C(B),this.b=new r}trigger(B,_){return this.a.trigger(()=>this.b.queue(B),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$rg=i;class a{constructor(){this.a=!1,this.b=new Promise((B,_)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$sg=a;class n extends a{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$tg=n;function t(de,B){return B?new Promise((_,Ee)=>{const Re=setTimeout(()=>{ne.dispose(),_()},de),ne=B.onCancellationRequested(()=>{clearTimeout(Re),ne.dispose(),Ee(new F.$3)})}):R(_=>t(de,_))}e.$ug=t;function o(de,B=0){const _=setTimeout(de,B);return(0,L.$jb)(()=>clearTimeout(_))}e.$vg=o;function g(de){const B=[];let _=0;const Ee=de.length;function Re(){return _<Ee?de[_++]():null}function ne(ee){ee!=null&&B.push(ee);const he=Re();return he?he.then(ne):Promise.resolve(B)}return Promise.resolve(null).then(ne)}e.$wg=g;function u(de,B=Ee=>!!Ee,_=null){let Ee=0;const Re=de.length,ne=()=>{if(Ee>=Re)return Promise.resolve(_);const ee=de[Ee++];return Promise.resolve(ee()).then(X=>B(X)?Promise.resolve(X):ne())};return ne()}e.$xg=u;function d(de,B=Ee=>!!Ee,_=null){if(de.length===0)return Promise.resolve(_);let Ee=de.length;const Re=()=>{Ee=-1;for(const ne of de)ne.cancel?.()};return new Promise((ne,ee)=>{for(const he of de)he.then(X=>{--Ee>=0&&B(X)?(Re(),ne(X)):Ee===0&&ne(_)}).catch(X=>{--Ee>=0&&(Re(),ee(X))})})}e.$yg=d;class v{constructor(B){this.a=0,this.d=B,this.f=[],this.b=0,this.g=new h.$7c}get onDrained(){return this.g.event}get size(){return this.a}queue(B){return this.a++,new Promise((_,Ee)=>{this.f.push({factory:B,c:_,e:Ee}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const B=this.f.shift();this.b++;const _=B.factory();_.then(B.c,B.e),_.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$zg=v;class l extends v{constructor(){super(1)}}e.$Ag=l;class w{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const B=new te;return this.b.add(B),B.p}d(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueFor(B,_=A.$Xf){const Ee=_.getComparisonKey(B);let Re=this.a.get(Ee);return Re||(Re=new l,h.Event.once(Re.onDrained)(()=>{Re?.dispose(),this.a.delete(Ee),this.f()}),this.a.set(Ee,Re)),Re}f(){this.d()&&this.g()}g(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.g()}}e.$Bg=w;class P{constructor(B,_){this.a=-1,typeof B=="function"&&typeof _=="number"&&this.setIfNotSet(B,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},_)}setIfNotSet(B,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},_))}}e.$Cg=P;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(B,_){this.cancel(),this.a=setInterval(()=>{B()},_)}}e.$Dg=M;class N{constructor(B,_){this.b=-1,this.a=B,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Eg=N;class T{constructor(B,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=B,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Fg=T;class z extends N{constructor(B,_){super(B,_),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$Gg=z;class j extends L.$lb{constructor(B,_){super(),this.g=B,this.h=_,this.a=[],this.b=this.B(new L.$mb),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of B)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new N(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Hg=j,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ig=de=>{(0,m.$A)(()=>{if(B)return;const _=Date.now()+15;de(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:e.$Ig=(de,B)=>{const _=requestIdleCallback(de,typeof B=="number"?{timeout:B}:void 0);let Ee=!1;return{dispose(){Ee||(Ee=!0,cancelIdleCallback(_))}}}}();class U{constructor(B){this.d=!1,this.a=()=>{try{this.f=B()}catch(_){this.g=_}finally{this.d=!0}},this.b=(0,e.$Ig)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Jg=U;async function Y(de,B,_){let Ee;for(let Re=0;Re<_;Re++)try{return await de()}catch(ne){Ee=ne,await t(B)}throw Ee}e.$Kg=Y;class H{hasPending(B){return this.a?typeof B=="number"?this.a.taskId===B:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(B,_,Ee){return this.a={taskId:B,cancel:()=>Ee?.(),promise:_},_.then(()=>this.d(B),()=>this.d(B)),_}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this.b)this.b.run=B;else{let _,Ee;const Re=new Promise((ne,ee)=>{_=ne,Ee=ee});this.b={run:B,promise:Re,promiseResolve:_,promiseReject:Ee}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lg=H;class ge{constructor(B,_=()=>Date.now()){this.d=B,this.f=_,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$Mg=ge;var ie;(function(de){de[de.Resolved=0]="Resolved",de[de.Rejected=1]="Rejected"})(ie||(ie={}));class te{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((B,_)=>{this.a=B,this.b=_})}complete(B){return new Promise(_=>{this.a(B),this.d={outcome:0,value:B},_()})}error(B){return new Promise(_=>{this.b(B),this.d={outcome:1,value:B},_()})}cancel(){return this.error(new F.$3)}}e.$Ng=te;var q;(function(de){async function B(Ee){let Re;const ne=await Promise.all(Ee.map(ee=>ee.then(he=>he,he=>{Re||(Re=he)})));if(typeof Re<"u")throw Re;return ne}de.settled=B;function _(Ee){return new Promise(async(Re,ne)=>{try{await Ee(Re,ne)}catch(ee){ne(ee)}})}de.withAsyncBody=_})(q||(e.Promises=q={}));var V;(function(de){de[de.Initial=0]="Initial",de[de.DoneOK=1]="DoneOK",de[de.DoneError=2]="DoneError"})(V||(V={}));class ce{static fromArray(B){return new ce(_=>{_.emitMany(B)})}static fromPromise(B){return new ce(async _=>{_.emitMany(await B)})}static fromPromises(B){return new ce(async _=>{await Promise.all(B.map(async Ee=>_.emitOne(await Ee)))})}static merge(B){return new ce(async _=>{await Promise.all(B.map(async Ee=>{for await(const Re of Ee)_.emitOne(Re)}))})}static{this.EMPTY=ce.fromArray([])}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new h.$7c,queueMicrotask(async()=>{const _={emitOne:Ee=>this.g(Ee),emitMany:Ee=>this.h(Ee),reject:Ee=>this.k(Ee)};try{await Promise.resolve(B(_)),this.j()}catch(Ee){this.k(Ee)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await h.Event.toPromise(this.f.event)}while(!0)}}}static map(B,_){return new ce(async Ee=>{for await(const Re of B)Ee.emitOne(_(Re))})}map(B){return ce.map(this,B)}static filter(B,_){return new ce(async Ee=>{for await(const Re of B)_(Re)&&Ee.emitOne(Re)})}filter(B){return ce.filter(this,B)}static coalesce(B){return ce.filter(B,_=>!!_)}coalesce(){return ce.coalesce(this)}static async toPromise(B){const _=[];for await(const Ee of B)_.push(Ee);return _}toPromise(){return ce.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}e.$Og=ce;class re extends ce{constructor(B,_){super(_),this.l=B}cancel(){this.l.cancel()}}e.$Pg=re;function fe(de){const B=new k.$dd,_=de(B.token);return new re(B,async Ee=>{const Re=B.token.onCancellationRequested(()=>{Re.dispose(),B.dispose(),Ee.reject(new F.$3)});try{for await(const ne of _){if(B.token.isCancellationRequested)return;Ee.emitOne(ne)}Re.dispose(),B.dispose()}catch(ne){Re.dispose(),B.dispose(),Ee.reject(ne)}})}e.$Qg=fe}),define(De[34],Ce([1,0,19,17,31,28,13,11,12]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=void 0;function b(){return Object.create(null)}e.$0i=b,e.$$i="**",e.$_i="/";const R="[/\\\\]",I="[^/\\\\]",$=/\//g;function S(ge,ie){switch(ge){case 0:return"";case 1:return`${I}*?`;default:return`(?:${R}|${I}+${R}${ie?`|${R}${I}+`:""})*?`}}function D(ge,ie){if(!ge)return[];const te=[];let q=!1,V=!1,ce="";for(const re of ge){switch(re){case ie:if(!q&&!V){te.push(ce),ce="";continue}break;case"{":q=!0;break;case"}":q=!1;break;case"[":V=!0;break;case"]":V=!1;break}ce+=re}return ce&&te.push(ce),te}e.$aj=D;function p(ge){if(!ge)return"";let ie="";const te=D(ge,e.$_i);if(te.every(q=>q===e.$$i))ie=".*";else{let q=!1;te.forEach((V,ce)=>{if(V===e.$$i){if(q)return;ie+=S(2,ce===te.length-1)}else{let re=!1,fe="",de=!1,B="";for(const _ of V){if(_!=="}"&&re){fe+=_;continue}if(de&&(_!=="]"||!B)){let Ee;_==="-"?Ee=_:(_==="^"||_==="!")&&!B?Ee="^":_===e.$_i?Ee="":Ee=(0,E.$nd)(_),B+=Ee;continue}switch(_){case"{":re=!0;continue;case"[":de=!0;continue;case"}":{const Re=`(?:${D(fe,",").map(ne=>p(ne)).join("|")})`;ie+=Re,re=!1,fe="";break}case"]":{ie+="["+B+"]",de=!1,B="";break}case"?":ie+=I;continue;case"*":ie+=S(1);continue;default:ie+=(0,E.$nd)(_)}}ce<te.length-1&&(te[ce+1]!==e.$$i||ce+2<te.length)&&(ie+=R)}q=V===e.$$i})}return ie}const r=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.$oi(1e4),a=function(){return!1},n=function(){return null};function t(ge,ie){if(!ge)return n;let te;typeof ge!="string"?te=ge.pattern:te=ge,te=te.trim();const q=`${te}_${!!ie.trimForExclusions}`;let V=i.get(q);if(V)return o(V,ge);let ce;return r.test(te)?V=u(te.substr(4),te):(ce=s.exec(g(te,ie)))?V=d(ce[1],te):(ie.trimForExclusions?f:c).test(te)?V=v(te,ie):(ce=y.exec(g(te,ie)))?V=l(ce[1].substr(1),te,!0):(ce=C.exec(g(te,ie)))?V=l(ce[1],te,!1):V=w(te),i.set(q,V),o(V,ge)}function o(ge,ie){if(typeof ie=="string")return ge;const te=function(q,V){return(0,h.$Je)(q,ie.base,!m.$k)?ge((0,E.$rd)(q.substr(ie.base.length),A.sep),V):null};return te.allBasenames=ge.allBasenames,te.allPaths=ge.allPaths,te.basenames=ge.basenames,te.patterns=ge.patterns,te}function g(ge,ie){return ie.trimForExclusions&&ge.endsWith("/**")?ge.substr(0,ge.length-2):ge}function u(ge,ie){return function(te,q){return typeof te=="string"&&te.endsWith(ge)?ie:null}}function d(ge,ie){const te=`/${ge}`,q=`\\${ge}`,V=function(re,fe){return typeof re!="string"?null:fe?fe===ge?ie:null:re===ge||re.endsWith(te)||re.endsWith(q)?ie:null},ce=[ge];return V.basenames=ce,V.patterns=[ie],V.allBasenames=ce,V}function v(ge,ie){const te=Y(ge.slice(1,-1).split(",").map(fe=>t(fe,ie)).filter(fe=>fe!==n),ge),q=te.length;if(!q)return n;if(q===1)return te[0];const V=function(fe,de){for(let B=0,_=te.length;B<_;B++)if(te[B](fe,de))return ge;return null},ce=te.find(fe=>!!fe.allBasenames);ce&&(V.allBasenames=ce.allBasenames);const re=te.reduce((fe,de)=>de.allPaths?fe.concat(de.allPaths):fe,[]);return re.length&&(V.allPaths=re),V}function l(ge,ie,te){const q=A.sep===A.$0b.sep,V=q?ge:ge.replace($,A.sep),ce=A.sep+V,re=A.$0b.sep+ge;let fe;return te?fe=function(de,B){return typeof de=="string"&&(de===V||de.endsWith(ce)||!q&&(de===ge||de.endsWith(re)))?ie:null}:fe=function(de,B){return typeof de=="string"&&(de===V||!q&&de===ge)?ie:null},fe.allPaths=[(te?"*/":"./")+ge],fe}function w(ge){try{const ie=new RegExp(`^${p(ge)}$`);return function(te){return ie.lastIndex=0,typeof te=="string"&&ie.test(te)?ge:null}}catch{return n}}function P(ge,ie,te){return!ge||typeof ie!="string"?!1:M(ge)(ie,void 0,te)}e.$bj=P;function M(ge,ie={}){if(!ge)return a;if(typeof ge=="string"||N(ge)){const te=t(ge,ie);if(te===n)return a;const q=function(V,ce){return!!te(V,ce)};return te.allBasenames&&(q.allBasenames=te.allBasenames),te.allPaths&&(q.allPaths=te.allPaths),q}return j(ge,ie)}e.$cj=M;function N(ge){const ie=ge;return ie?typeof ie.base=="string"&&typeof ie.pattern=="string":!1}e.$dj=N;function T(ge){return ge.allBasenames||[]}e.$ej=T;function z(ge){return ge.allPaths||[]}e.$fj=z;function j(ge,ie){const te=Y(Object.getOwnPropertyNames(ge).map(fe=>U(fe,ge[fe],ie)).filter(fe=>fe!==n)),q=te.length;if(!q)return n;if(!te.some(fe=>!!fe.requiresSiblings)){if(q===1)return te[0];const fe=function(_,Ee){let Re;for(let ne=0,ee=te.length;ne<ee;ne++){const he=te[ne](_,Ee);if(typeof he=="string")return he;(0,F.$gg)(he)&&(Re||(Re=[]),Re.push(he))}return Re?(async()=>{for(const ne of Re){const ee=await ne;if(typeof ee=="string")return ee}return null})():null},de=te.find(_=>!!_.allBasenames);de&&(fe.allBasenames=de.allBasenames);const B=te.reduce((_,Ee)=>Ee.allPaths?_.concat(Ee.allPaths):_,[]);return B.length&&(fe.allPaths=B),fe}const V=function(fe,de,B){let _,Ee;for(let Re=0,ne=te.length;Re<ne;Re++){const ee=te[Re];ee.requiresSiblings&&B&&(de||(de=(0,A.$ec)(fe)),_||(_=de.substr(0,de.length-(0,A.$fc)(fe).length)));const he=ee(fe,de,_,B);if(typeof he=="string")return he;(0,F.$gg)(he)&&(Ee||(Ee=[]),Ee.push(he))}return Ee?(async()=>{for(const Re of Ee){const ne=await Re;if(typeof ne=="string")return ne}return null})():null},ce=te.find(fe=>!!fe.allBasenames);ce&&(V.allBasenames=ce.allBasenames);const re=te.reduce((fe,de)=>de.allPaths?fe.concat(de.allPaths):fe,[]);return re.length&&(V.allPaths=re),V}function U(ge,ie,te){if(ie===!1)return n;const q=t(ge,te);if(q===n)return n;if(typeof ie=="boolean")return q;if(ie){const V=ie.when;if(typeof V=="string"){const ce=(re,fe,de,B)=>{if(!B||!q(re,fe))return null;const _=V.replace("$(basename)",()=>de),Ee=B(_);return(0,F.$gg)(Ee)?Ee.then(Re=>Re?ge:null):Ee?ge:null};return ce.requiresSiblings=!0,ce}}return q}function Y(ge,ie){const te=ge.filter(fe=>!!fe.basenames);if(te.length<2)return ge;const q=te.reduce((fe,de)=>{const B=de.basenames;return B?fe.concat(B):fe},[]);let V;if(ie){V=[];for(let fe=0,de=q.length;fe<de;fe++)V.push(ie)}else V=te.reduce((fe,de)=>{const B=de.patterns;return B?fe.concat(B):fe},[]);const ce=function(fe,de){if(typeof fe!="string")return null;if(!de){let _;for(_=fe.length;_>0;_--){const Ee=fe.charCodeAt(_-1);if(Ee===47||Ee===92)break}de=fe.substr(_)}const B=q.indexOf(de);return B!==-1?V[B]:null};ce.basenames=q,ce.patterns=V,ce.allBasenames=q;const re=ge.filter(fe=>!fe.basenames);return re.push(ce),re}function H(ge,ie){return(0,k.$af)(ge,ie,(te,q)=>typeof te=="string"&&typeof q=="string"?te===q:typeof te!="string"&&typeof q!="string"?te.base===q.base&&te.pattern===q.pattern:!1)}e.$gj=H}),define(De[74],Ce([1,0,8,155,24,12,2]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class E{constructor(s="",c=!1){if(this.value=s,typeof this.value!="string")throw(0,k.$5)("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=c.isTrusted??void 0,this.supportThemeIcons=c.supportThemeIcons??!1,this.supportHtml=c.supportHtml??!1)}appendText(s,c=0){return this.value+=$(this.supportThemeIcons?(0,F.$Cj)(s):s).replace(/([ \t]+)/g,(f,y)=>"&nbsp;".repeat(y.length)).replace(/\>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,c){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}appendLink(s,c,f){return this.value+="[",this.value+=this.c(c,"]"),this.value+="](",this.value+=this.c(String(s),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(s,c){const f=new RegExp((0,L.$nd)(c),"g");return s.replace(f,(y,C)=>s.charAt(C-1)!=="\\"?`\\${y}`:y)}}e.$Ij=E;function b(r){return R(r)?!r.value:Array.isArray(r)?r.every(b):!0}e.$Jj=b;function R(r){return r instanceof E?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.$Kj=R;function I(r,s){return r===s?!0:!r||!s?!1:r.value===s.value&&r.isTrusted===s.isTrusted&&r.supportThemeIcons===s.supportThemeIcons&&r.supportHtml===s.supportHtml&&(r.baseUri===s.baseUri||!!r.baseUri&&!!s.baseUri&&(0,h.$1f)(A.URI.from(r.baseUri),A.URI.from(s.baseUri)))}e.$Lj=I;function $(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Mj=$;function S(r){return r.replace(/"/g,"&quot;")}e.$Nj=S;function D(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Oj=D;function p(r){const s=[],c=r.split("|").map(y=>y.trim());r=c[0];const f=c[1];if(f){const y=/height=(\d+)/.exec(f),C=/width=(\d+)/.exec(f),i=y?y[1]:"",a=C?C[1]:"",n=isFinite(parseInt(a)),t=isFinite(parseInt(i));n&&s.push(`width="${a}"`),t&&s.push(`height="${i}"`)}return{href:r,dimensions:s}}e.$Pj=p}),define(De[120],Ce([1,0,19,31,13,11,24,12]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7z=e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=void 0;function E(t,o){const{os:g,tildify:u,relative:d}=o;if(d){const w=b(t,d,g);if(typeof w=="string")return w}let v=t.fsPath;if(g===1&&!L.$i?v=v.replace(/\//g,"\\"):g!==1&&L.$i&&(v=v.replace(/\\/g,"/")),g!==1&&u?.userHome){const w=u.userHome.fsPath;let P;t.scheme!==u.userHome.scheme&&t.path.startsWith(h.$0b.sep)?P=u.userHome.with({path:t.path}).fsPath:P=t.fsPath,v=$(P,w,g)}return(g===1?h.$9b:h.$0b).normalize(R(v,g===1))}e.$Xz=E;function b(t,o,g){const u=g===1?h.$9b:h.$0b,d=g===3?A.$Xf:A.$Zf,v=o.getWorkspace(),l=(0,k.$uf)(v.folders);if(!l)return;t.scheme!==l.uri.scheme&&t.path.startsWith(h.$0b.sep)&&(t=l.uri.with({path:t.path}));const w=o.getWorkspaceFolder(t);if(!w)return;let P;if(d.isEqual(w.uri,t)?P="":P=d.relativePath(w.uri,t)??"",P&&(P=u.normalize(P)),v.folders.length>1&&!o.noPrefix){const M=w.name?w.name:d.basenameOrAuthority(w.uri);P=P?`${M} \u2022 ${P}`:M}return P}function R(t,o=L.$i){return(0,F.$Ne)(t,o)?t.charAt(0).toUpperCase()+t.slice(1):t}e.$Yz=R;let I=Object.create(null);function $(t,o,g=L.OS){if(g===1||!t||!o)return t;let u=I.original===o?I.normalized:void 0;u||(u=o,L.$i&&(u=(0,F.$De)(u)),u=`${(0,m.$sd)(u,h.$0b.sep)}${h.$0b.sep}`,I={original:o,normalized:u});let d=t;return L.$i&&(d=(0,F.$De)(d)),(g===3?d.startsWith(u):(0,m.$Md)(d,u))?`~/${d.substr(u.length)}`:t}e.$Zz=$;function S(t,o){return t.replace(/^~($|\/|\\)/,`${o}$1`)}e.$1z=S;const D="\u2026",p="\\\\",r="~";function s(t,o=h.sep){const g=new Array(t.length);let u=!1;for(let d=0;d<t.length;d++){const v=t[d];if(v===""){g[d]=`.${o}`;continue}if(!v){g[d]=v;continue}u=!0;let l="",w=v;w.indexOf(p)===0?(l=w.substr(0,w.indexOf(p)+p.length),w=w.substr(w.indexOf(p)+p.length)):w.indexOf(o)===0?(l=w.substr(0,w.indexOf(o)+o.length),w=w.substr(w.indexOf(o)+o.length)):w.indexOf(r)===0&&(l=w.substr(0,w.indexOf(r)+r.length),w=w.substr(w.indexOf(r)+r.length));const P=w.split(o);for(let M=1;u&&M<=P.length;M++)for(let N=P.length-M;u&&N>=0;N--){u=!1;let T=P.slice(N,N+M).join(o);for(let z=0;!u&&z<t.length;z++)if(z!==d&&t[z]&&t[z].indexOf(T)>-1){const j=N+M===P.length,U=N>0&&t[z].indexOf(o)>-1?o+T:T,Y=t[z].endsWith(U);u=!j||Y}if(!u){let z="";(P[0].endsWith(":")||l!=="")&&(N===1&&(N=0,M++,T=P[0]+o+T),N>0&&(z=P[0]+o),z=l+z),N>0&&(z=z+D+o),z=z+T,N+M<P.length&&(z=z+o+D),g[d]=z}}u&&(g[d]=v)}return g}e.$2z=s;var c;(function(t){t[t.TEXT=0]="TEXT",t[t.VARIABLE=1]="VARIABLE",t[t.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function f(t,o=Object.create(null)){const g=[];let u=!1,d="";for(const v of t)if(v==="$"||u&&v==="{")d&&g.push({value:d,type:c.TEXT}),d="",u=!0;else if(v==="}"&&u){const l=o[d];if(typeof l=="string")l.length&&g.push({value:l,type:c.VARIABLE});else if(l){const w=g[g.length-1];(!w||w.type!==c.SEPARATOR)&&g.push({value:l.label,type:c.SEPARATOR})}d="",u=!1}else d+=v;return d&&!u&&g.push({value:d,type:c.TEXT}),g.filter((v,l)=>{if(v.type===c.SEPARATOR){const w=g[l-1],P=g[l+1];return[w,P].every(M=>M&&(M.type===c.VARIABLE||M.type===c.TEXT)&&M.value.length>0)}return!0}).map(v=>v.value).join("")}e.$3z=f;function y(t,o){return L.$j||o?t.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.$j?"&":"&&"):t.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.$4z=y;function C(t,o){return L.$j||o?t.replace(/\(&&\w\)|&&/g,""):L.$i?t.replace(/&&|&/g,g=>g==="&"?"&&":"&"):t.replace(/&&/g,"_")}e.$5z=C;function i(t){return t.replace(/&/g,"&&")}e.$6z=i;function a(t){if(t.endsWith("]")){const o=t.lastIndexOf(" [",t.length-2);if(o!==-1){const g=n(t.substring(0,o));return{name:g.name,parentPath:g.parentPath+t.substring(o)}}}return n(t)}e.$7z=a;function n(t){const o=t.indexOf("/")!==-1?h.$0b:h.$9b,g=o.basename(t),u=o.dirname(t);return g.length?{name:g,parentPath:u}:{name:u,parentPath:""}}}),define(De[121],Ce([1,0,22,2]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.$mm=e.$lm=void 0;function h(I){return I.toJSON()}class L{constructor($){this.a=$}transformIncoming($){const S=this.a.transformIncoming($);return S===$?$:h(F.URI.from(S))}transformOutgoing($){const S=this.a.transformOutgoing($);return S===$?$:h(F.URI.from(S))}transformOutgoingURI($){const S=this.a.transformOutgoing($);return S===$?$:F.URI.from(S)}transformOutgoingScheme($){return this.a.transformOutgoingScheme($)}}e.$lm=L,e.$mm=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function A(I,$,S){if(!I||S>200)return null;if(typeof I=="object"){if(I instanceof F.URI)return $.transformOutgoing(I);for(const D in I)if(Object.hasOwnProperty.call(I,D)){const p=A(I[D],$,S+1);p!==null&&(I[D]=p)}}return null}function m(I,$){const S=A(I,$,0);return S===null?I:S}e.$nm=m;function E(I,$,S,D){if(!I||D>200)return null;if(typeof I=="object"){if(I.$mid===1)return S?F.URI.revive($.transformIncoming(I)):$.transformIncoming(I);if(I instanceof k.$Jb)return null;for(const p in I)if(Object.hasOwnProperty.call(I,p)){const r=E(I[p],$,S,D+1);r!==null&&(I[p]=r)}}return null}function b(I,$){const S=E(I,$,!1,0);return S===null?I:S}e.$om=b;function R(I,$){const S=E(I,$,!0,0);return S===null?I:S}e.$pm=R}),define(De[29],Ce([1,0,49,75,350,17,31,69,13,11,24,2]),function(me,e,k,F,h,L,A,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var $;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})($||(e.RimRafMode=$={}));async function S(j,U=$.UNLINK,Y){if((0,A.$Me)(j))throw new Error("rimraf - will refuse to recursively delete root");return U===$.UNLINK?p(j):D(j,Y)}async function D(j,U=(0,A.$Re)((0,F.tmpdir)())){try{try{await k.promises.rename(j,U)}catch(Y){return Y.code==="ENOENT"?void 0:p(j)}p(U).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function p(j){return(0,h.promisify)(k.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function r(j){if((0,A.$Me)(j))throw new Error("rimraf - will refuse to recursively delete root");k.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function s(j,U){return y(await(U?c(j):(0,h.promisify)(k.readdir)(j)))}async function c(j){try{return await(0,h.promisify)(k.readdir)(j,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const U=[],Y=await s(j);for(const H of Y){let ge=!1,ie=!1,te=!1;try{const q=await e.Promises.lstat((0,E.$ac)(j,H));ge=q.isFile(),ie=q.isDirectory(),te=q.isSymbolicLink()}catch(q){console.warn("[node.js fs] unexpected error from lstat after readdir: ",q)}U.push({name:H,isFile:()=>ge,isDirectory:()=>ie,isSymbolicLink:()=>te})}return U}function f(j){return y(k.readdirSync(j))}e.readdirSync=f;function y(j){return j.map(U=>typeof U=="string"?b.$j?(0,m.$5k)(U):U:(U.name=b.$j?(0,m.$5k)(U.name):U.name,U))}async function C(j){const U=await s(j),Y=[];for(const H of U)await a.existsDirectory((0,E.$ac)(j,H))&&Y.push(H);return Y}function i(j,U=1e3){return new Promise(Y=>{let H=!1;const ge=setInterval(()=>{H||(H=!0,k.access(j,ie=>{H=!1,ie&&(clearInterval(ge),Y(void 0))}))},U)})}e.whenDeleted=i;var a;(function(j){async function U(ge){let ie;try{if(ie=await e.Promises.lstat(ge),!ie.isSymbolicLink())return{stat:ie}}catch{}try{return{stat:await e.Promises.stat(ge),symbolicLink:ie?.isSymbolicLink()?{dangling:!1}:void 0}}catch(te){if(te.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};if(b.$i&&te.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(ge)),symbolicLink:{dangling:!1}}}catch(q){if(q.code==="ENOENT"&&ie)return{stat:ie,symbolicLink:{dangling:!0}};throw q}throw te}}j.stat=U;async function Y(ge){try{const{stat:ie,symbolicLink:te}=await j.stat(ge);return ie.isFile()&&te?.dangling!==!0}catch{}return!1}j.existsFile=Y;async function H(ge){try{const{stat:ie,symbolicLink:te}=await j.stat(ge);return ie.isDirectory()&&te?.dangling!==!0}catch{}return!1}j.existsDirectory=H})(a||(e.SymlinkSupport=a={}));const n=new L.$Bg;function t(j,U,Y){return n.queueFor(I.URI.file(j),R.$Yf).queue(()=>{const H=v(Y);return new Promise((ge,ie)=>u(j,U,H,te=>te?ie(te):ge()))})}let o=!0;function g(j){o=j}e.configureFlushOnWrite=g;function u(j,U,Y,H){if(!o)return k.writeFile(j,U,{mode:Y.mode,flag:Y.flag},H);k.open(j,Y.flag,Y.mode,(ge,ie)=>{if(ge)return H(ge);k.writeFile(ie,U,te=>{if(te)return k.close(ie,()=>H(te));k.fdatasync(ie,q=>(q&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",q),g(!1)),k.close(ie,V=>H(V))))})})}function d(j,U,Y){const H=v(Y);if(!o)return k.writeFileSync(j,U,{mode:H.mode,flag:H.flag});const ge=k.openSync(j,H.flag,H.mode);try{k.writeFileSync(ge,U);try{k.fdatasyncSync(ge)}catch(ie){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",ie),g(!1)}}finally{k.closeSync(ge)}}e.writeFileSync=d;function v(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function l(j,U){if(j!==U)try{await e.Promises.rename(j,U)}catch(Y){if(j.toLowerCase()!==U.toLowerCase()&&Y.code==="EXDEV"||j.endsWith("."))await w(j,U,{preserveSymlinks:!1}),await S(j,$.MOVE);else throw Y}}async function w(j,U,Y){return M(j,U,{root:{source:j,target:U},options:Y,handledSourcePaths:new Set})}const P=511;async function M(j,U,Y){if(Y.handledSourcePaths.has(j))return;Y.handledSourcePaths.add(j);const{stat:H,symbolicLink:ge}=await a.stat(j);if(ge){if(Y.options.preserveSymlinks)try{return await z(j,U,Y)}catch(ie){console.warn("[node.js fs] copy of symlink failed: ",ie)}if(ge.dangling)return}return H.isDirectory()?N(j,U,H.mode&P,Y):T(j,U,H.mode&P)}async function N(j,U,Y,H){await e.Promises.mkdir(U,{recursive:!0,mode:Y});const ge=await s(j);for(const ie of ge)await M((0,E.$ac)(j,ie),(0,E.$ac)(U,ie),H)}async function T(j,U,Y){await e.Promises.copyFile(j,U),await e.Promises.chmod(U,Y)}async function z(j,U,Y){let H=await e.Promises.readlink(j);(0,A.$Je)(H,Y.root.source,!b.$k)&&(H=(0,E.$ac)(Y.root.target,H.substr(Y.root.source.length+1))),await e.Promises.symlink(H,U)}e.Promises=new class{get access(){return(0,h.promisify)(k.access)}get stat(){return(0,h.promisify)(k.stat)}get lstat(){return(0,h.promisify)(k.lstat)}get utimes(){return(0,h.promisify)(k.utimes)}get read(){return(j,U,Y,H,ge)=>new Promise((ie,te)=>{k.read(j,U,Y,H,ge,(q,V,ce)=>q?te(q):ie({bytesRead:V,buffer:ce}))})}get readFile(){return(0,h.promisify)(k.readFile)}get write(){return(j,U,Y,H,ge)=>new Promise((ie,te)=>{k.write(j,U,Y,H,ge,(q,V,ce)=>q?te(q):ie({bytesWritten:V,buffer:ce}))})}get appendFile(){return(0,h.promisify)(k.appendFile)}get fdatasync(){return(0,h.promisify)(k.fdatasync)}get truncate(){return(0,h.promisify)(k.truncate)}get rename(){return(0,h.promisify)(k.rename)}get copyFile(){return(0,h.promisify)(k.copyFile)}get open(){return(0,h.promisify)(k.open)}get close(){return(0,h.promisify)(k.close)}get symlink(){return(0,h.promisify)(k.symlink)}get readlink(){return(0,h.promisify)(k.readlink)}get chmod(){return(0,h.promisify)(k.chmod)}get mkdir(){return(0,h.promisify)(k.mkdir)}get unlink(){return(0,h.promisify)(k.unlink)}get rmdir(){return(0,h.promisify)(k.rmdir)}get realpath(){return(0,h.promisify)(k.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return C}get writeFile(){return t}get rm(){return S}get move(){return l}get copy(){return w}}}),define(De[95],Ce([1,0,49,13,11,12,29]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=e.$Hp=void 0;function m($){if(h.$k)return $;const S=(0,F.$dc)($);if($===S)return $;const D=((0,F.$ec)($)||$).toLowerCase();try{const r=(0,A.readdirSync)(S).filter(s=>s.toLowerCase()===D);if(r.length===1){const s=m(S);if(s)return(0,F.$ac)(s,r[0])}else if(r.length>1){const s=r.indexOf(D);if(s>=0){const c=m(S);if(c)return(0,F.$ac)(c,r[s])}}}catch{}return null}e.$Hp=m;async function E($){if(h.$k)return $;const S=(0,F.$dc)($);if($===S)return $;const D=((0,F.$ec)($)||$).toLowerCase();try{const r=(await A.Promises.readdir(S)).filter(s=>s.toLowerCase()===D);if(r.length===1){const s=await E(S);if(s)return(0,F.$ac)(s,r[0])}else if(r.length>1){const s=r.indexOf(D);if(s>=0){const c=await E(S);if(c)return(0,F.$ac)(c,r[s])}}}catch{}return null}e.$Ip=E;async function b($){try{return await A.Promises.realpath($)}catch{const D=I($);return await A.Promises.access(D,k.constants.R_OK),D}}e.$Jp=b;function R($){try{return k.realpathSync($)}catch{const D=I($);return k.accessSync(D,k.constants.R_OK),D}}e.$Kp=R;function I($){return(0,L.$sd)((0,F.$$b)($),F.sep)}}),define(De[96],Ce([1,0,13,11,41,94,14,29]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$gl=e.$fl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function E(I=h.env){return I.comspec||"cmd.exe"}e.$fl=E;function b(I){let $=[],S=!1;const D=function(p){if(S){$.push(p);return}(!I.send(p,s=>{if(s&&console.error(s),S=!1,$.length>0){const c=$.slice(0);$=[],c.forEach(f=>D(f))}})||F.$i)&&(S=!0)};return{send:D}}e.$gl=b;var R;(function(I){async function $(S,D,p){if(k.$_b(S))return S;if(D===void 0&&(D=h.cwd()),k.$dc(S)!=="."||(p===void 0&&A.$ie(h.env.PATH)&&(p=h.env.PATH.split(k.$kc)),p===void 0||p.length===0))return k.$ac(D,S);async function s(c){if(await m.Promises.exists(c)){let f;try{f=await m.Promises.stat(c)}catch(y){y.message.startsWith("EACCES")&&(f=await m.Promises.lstat(c))}return f?!f.isDirectory():!1}return!1}for(const c of p){let f;if(k.$_b(c)?f=k.$ac(c,S):f=k.$ac(D,c,S),await s(f))return f;let y=f+".com";if(await s(y)||(y=f+".exe",await s(y)))return y}return k.$ac(D,S)}I.findExecutable=$})(R||(e.win32=R={}))});var Je=this&&this.__decorate||function(me,e,k,F){var h=arguments.length,L=h<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,k):F,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(me,e,k,F);else for(var m=me.length-1;m>=0;m--)(A=me[m])&&(L=(h<3?A(L):h>3?A(e,k,L):A(e,k))||L);return h>3&&L&&Object.defineProperty(e,k,L),L};define(De[76],Ce([1,0,19,17,22,21,66,8,3,4,73,12,14]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9g=e.ProxyChannel=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.RequestInitiator=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=void 0;var S;(function(ie){ie[ie.Promise=100]="Promise",ie[ie.PromiseCancel=101]="PromiseCancel",ie[ie.EventListen=102]="EventListen",ie[ie.EventDispose=103]="EventDispose"})(S||(S={}));function D(ie){switch(ie){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(ie){ie[ie.Initialize=200]="Initialize",ie[ie.PromiseSuccess=201]="PromiseSuccess",ie[ie.PromiseError=202]="PromiseError",ie[ie.PromiseErrorObj=203]="PromiseErrorObj",ie[ie.EventFire=204]="EventFire"})(p||(p={}));function r(ie){switch(ie){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(ie){ie[ie.Uninitialized=0]="Uninitialized",ie[ie.Idle=1]="Idle"})(s||(s={}));function c(ie){let te=0;for(let q=0;;q+=7){const V=ie.read(1);if(te|=(V.buffer[0]&127)<<q,!(V.buffer[0]&128))return te}}const f=n(0);function y(ie,te){if(te===0){ie.write(f);return}let q=0;for(let ce=te;ce!==0;ce=ce>>>7)q++;const V=h.$Jb.alloc(q);for(let ce=0;te!==0;ce++)V.buffer[ce]=te&127,te=te>>>7,te>0&&(V.buffer[ce]|=128);ie.write(V)}class C{constructor(te){this.b=te,this.a=0}read(te){const q=this.b.slice(this.a,this.a+te);return this.a+=q.byteLength,q}}e.$Xg=C;class i{constructor(){this.a=[]}get buffer(){return h.$Jb.concat(this.a)}write(te){this.a.push(te)}}e.$Yg=i;var a;(function(ie){ie[ie.Undefined=0]="Undefined",ie[ie.String=1]="String",ie[ie.Buffer=2]="Buffer",ie[ie.VSBuffer=3]="VSBuffer",ie[ie.Array=4]="Array",ie[ie.Object=5]="Object",ie[ie.Int=6]="Int"})(a||(a={}));function n(ie){const te=h.$Jb.alloc(1);return te.writeUInt8(ie,0),te}const t={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object),Uint:n(a.Int)},o=typeof Buffer<"u";function g(ie,te){if(typeof te>"u")ie.write(t.Undefined);else if(typeof te=="string"){const q=h.$Jb.fromString(te);ie.write(t.String),y(ie,q.byteLength),ie.write(q)}else if(o&&Buffer.isBuffer(te)){const q=h.$Jb.wrap(te);ie.write(t.Buffer),y(ie,q.byteLength),ie.write(q)}else if(te instanceof h.$Jb)ie.write(t.VSBuffer),y(ie,te.byteLength),ie.write(te);else if(Array.isArray(te)){ie.write(t.Array),y(ie,te.length);for(const q of te)g(ie,q)}else if(typeof te=="number"&&(te|0)===te)ie.write(t.Uint),y(ie,te);else{const q=h.$Jb.fromString(JSON.stringify(te));ie.write(t.Object),y(ie,q.byteLength),ie.write(q)}}e.$Zg=g;function u(ie){switch(ie.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return ie.read(c(ie)).toString();case a.Buffer:return ie.read(c(ie)).buffer;case a.VSBuffer:return ie.read(c(ie));case a.Array:{const q=c(ie),V=[];for(let ce=0;ce<q;ce++)V.push(u(ie));return V}case a.Object:return JSON.parse(ie.read(c(ie)).toString());case a.Int:return c(ie)}}e.$1g=u;class d{constructor(te,q,V=null,ce=1e3){this.h=te,this.j=q,this.k=V,this.l=ce,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(te,q){this.b.set(te,q),setTimeout(()=>this.w(te),0)}m(te){switch(te.type){case 200:{const q=this.o([te.type]);this.k?.logOutgoing(q,0,1,r(te.type));return}case 201:case 202:case 204:case 203:{const q=this.o([te.type,te.id],te.data);this.k?.logOutgoing(q,te.id,1,r(te.type),te.data);return}}}o(te,q=void 0){const V=new i;return g(V,te),g(V,q),this.p(V.buffer)}p(te){try{return this.h.send(te),te.byteLength}catch{return 0}}q(te){const q=new C(te),V=u(q),ce=u(q),re=V[0];switch(re){case 100:return this.k?.logIncoming(te.byteLength,V[1],1,`${D(re)}: ${V[2]}.${V[3]}`,ce),this.s({type:re,id:V[1],channelName:V[2],name:V[3],arg:ce});case 102:return this.k?.logIncoming(te.byteLength,V[1],1,`${D(re)}: ${V[2]}.${V[3]}`,ce),this.t({type:re,id:V[1],channelName:V[2],name:V[3],arg:ce});case 101:return this.k?.logIncoming(te.byteLength,V[1],1,`${D(re)}`),this.u({type:re,id:V[1]});case 103:return this.k?.logIncoming(te.byteLength,V[1],1,`${D(re)}`),this.u({type:re,id:V[1]})}}s(te){const q=this.b.get(te.channelName);if(!q){this.v(te);return}const V=new L.$dd;let ce;try{ce=q.call(this.j,te.name,te.arg,V.token)}catch(de){ce=Promise.reject(de)}const re=te.id;ce.then(de=>{this.m({id:re,data:de,type:201}),this.d.delete(te.id)},de=>{de instanceof Error?this.m({id:re,data:{message:de.message,name:de.name,stack:de.stack?de.stack.split?de.stack.split(`
`):de.stack:void 0},type:202}):this.m({id:re,data:de,type:203}),this.d.delete(te.id)});const fe=(0,b.$jb)(()=>V.cancel());this.d.set(te.id,fe)}t(te){const q=this.b.get(te.channelName);if(!q){this.v(te);return}const V=te.id,re=q.listen(this.j,te.name,te.arg)(fe=>this.m({id:V,data:fe,type:204}));this.d.set(te.id,re)}u(te){const q=this.d.get(te.id);q&&(q.dispose(),this.d.delete(te.id))}v(te){let q=this.g.get(te.channelName);q||(q=[],this.g.set(te.channelName,q));const V=setTimeout(()=>{console.error(`Unknown channel: ${te.channelName}`),te.type===100&&this.m({id:te.id,data:{name:"Unknown channel",message:`Channel name '${te.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);q.push({request:te,timeoutTimer:V})}w(te){const q=this.g.get(te);if(q){for(const V of q)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.s(V.request);break;case 102:this.t(V.request);break}this.g.delete(te)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.$gb)(this.d.values()),this.d.clear()}}e.$2g=d;var v;(function(ie){ie[ie.LocalSide=0]="LocalSide",ie[ie.OtherSide=1]="OtherSide"})(v||(e.RequestInitiator=v={}));class l{constructor(te,q=null){this.l=te,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new E.$7c,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(V=>this.s(V)),this.j=q}getChannel(te){const q=this;return{call(V,ce,re){return q.a?Promise.reject(new m.$3):q.m(te,V,ce,re)},listen(V,ce){return q.a?E.Event.None:q.o(te,V,ce)}}}m(te,q,V,ce=L.CancellationToken.None){const re=this.g++,de={id:re,type:100,channelName:te,name:q,arg:V};if(ce.isCancellationRequested)return Promise.reject(new m.$3);let B;return new Promise((Ee,Re)=>{if(ce.isCancellationRequested)return Re(new m.$3);const ne=()=>{const ue=oe=>{switch(oe.type){case 201:this.f.delete(re),Ee(oe.data);break;case 202:{this.f.delete(re);const le=new Error(oe.data.message);le.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,le.name=oe.data.name,Re(le);break}case 203:this.f.delete(re),Re(oe.data);break}};this.f.set(re,ue),this.p(de)};let ee=null;this.b===s.Idle?ne():(ee=(0,F.$hg)(ue=>this.u()),ee.then(()=>{ee=null,ne()}));const he=()=>{ee?(ee.cancel(),ee=null):this.p({id:re,type:101}),Re(new m.$3)},X=ce.onCancellationRequested(he);B=(0,b.$ib)((0,b.$jb)(he),X),this.d.add(B)}).finally(()=>{this.d.delete(B)})}o(te,q,V){const ce=this.g++,fe={id:ce,type:102,channelName:te,name:q,arg:V};let de=null;const B=new E.$7c({onWillAddFirstListener:()=>{de=(0,F.$hg)(Ee=>this.u()),de.then(()=>{de=null,this.d.add(B),this.p(fe)})},onDidRemoveLastListener:()=>{de?(de.cancel(),de=null):(this.d.delete(B),this.p({id:ce,type:103}))}}),_=Ee=>B.fire(Ee.data);return this.f.set(ce,_),B.event}p(te){switch(te.type){case 100:case 102:{const q=this.q([te.type,te.id,te.channelName,te.name],te.arg);this.j?.logOutgoing(q,te.id,0,`${D(te.type)}: ${te.channelName}.${te.name}`,te.arg);return}case 101:case 103:{const q=this.q([te.type,te.id]);this.j?.logOutgoing(q,te.id,0,D(te.type));return}}}q(te,q=void 0){const V=new i;return g(V,te),g(V,q),this.r(V.buffer)}r(te){try{return this.l.send(te),te.byteLength}catch{return 0}}s(te){const q=new C(te),V=u(q),ce=u(q),re=V[0];switch(re){case 200:return this.j?.logIncoming(te.byteLength,0,0,r(re)),this.t({type:V[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(te.byteLength,V[1],0,r(re),ce),this.t({type:V[0],id:V[1],data:ce})}}t(te){if(te.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(te.id)?.(te)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.$gb)(this.d.values()),this.d.clear()}}e.$3g=l,Je([A.$Rg],l.prototype,"onDidInitializePromise",null);class w{get connections(){const te=[];return this.f.forEach(q=>te.push(q)),te}constructor(te){this.a=new Map,this.f=new Set,this.g=new E.$7c,this.onDidAddConnection=this.g.event,this.h=new E.$7c,this.onDidRemoveConnection=this.h.event,te(({protocol:q,onDidClientDisconnect:V})=>{E.Event.once(q.onMessage)(re=>{const fe=new C(re),de=u(fe),B=new d(q,de),_=new l(q);this.a.forEach((Re,ne)=>B.registerChannel(ne,Re));const Ee={channelServer:B,channelClient:_,ctx:de};this.f.add(Ee),this.g.fire(Ee),V(()=>{B.dispose(),_.dispose(),this.f.delete(Ee),this.h.fire(Ee)})})})}getChannel(te,q){const V=this;return{call(ce,re,fe){let de;if((0,$.$we)(q)){const _=(0,k.$Jf)(V.connections.filter(q));de=_?Promise.resolve(_):E.Event.toPromise(E.Event.filter(V.onDidAddConnection,q))}else de=q.routeCall(V,ce,re);const B=de.then(_=>_.channelClient.getChannel(te));return M(B).call(ce,re,fe)},listen(ce,re){if((0,$.$we)(q))return V.j(te,q,ce,re);const fe=q.routeEvent(V,ce,re).then(de=>de.channelClient.getChannel(te));return M(fe).listen(ce,re)}}}j(te,q,V,ce){const re=this;let fe=new b.$kb;const de=new E.$7c({onWillAddFirstListener:()=>{fe=new b.$kb;const B=new E.$ad,_=new Map,Ee=ne=>{const he=ne.channelClient.getChannel(te).listen(V,ce),X=B.add(he);_.set(ne,X)},Re=ne=>{const ee=_.get(ne);ee&&(ee.dispose(),_.delete(ne))};re.connections.filter(q).forEach(Ee),E.Event.filter(re.onDidAddConnection,q)(Ee,void 0,fe),re.onDidRemoveConnection(Re,void 0,fe),B.event(de.fire,de,fe),fe.add(B)},onDidRemoveLastListener:()=>{fe.dispose()}});return de.event}registerChannel(te,q){this.a.set(te,q),this.f.forEach(V=>{V.channelServer.registerChannel(te,q)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.$4g=w;class P{constructor(te,q,V=null){const ce=new i;g(ce,q),te.send(ce.buffer),this.a=new l(te,V),this.d=new d(te,q,V)}getChannel(te){return this.a.getChannel(te)}registerChannel(te,q){this.d.registerChannel(te,q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$5g=P;function M(ie){return{call(te,q,V){return ie.then(ce=>ce.call(te,q,V))},listen(te,q){const V=new E.$cd;return ie.then(ce=>V.input=ce.listen(te,q)),V.event}}}e.$6g=M;function N(ie){let te=!1;return{call(q,V,ce){return te?ie.call(q,V,ce):(0,F.$ug)(0).then(()=>te=!0).then(()=>ie.call(q,V,ce))},listen(q,V){if(te)return ie.listen(q,V);const ce=new E.$cd;return(0,F.$ug)(0).then(()=>te=!0).then(()=>ce.input=ie.listen(q,V)),ce.event}}}e.$7g=N;class T{constructor(te){this.a=te}routeCall(te){return this.b(te)}routeEvent(te){return this.b(te)}async b(te){for(const q of te.connections)if(await Promise.resolve(this.a(q.ctx)))return Promise.resolve(q);return await E.Event.toPromise(te.onDidAddConnection),await this.b(te)}}e.$8g=T;var z;(function(ie){function te(re,fe){const de=re,B=fe&&fe.disableMarshalling,_=new Map;for(const Ee in de)V(Ee)&&_.set(Ee,E.Event.buffer(de[Ee],!0));return new class{listen(Ee,Re,ne){const ee=_.get(Re);if(ee)return ee;if(ce(Re)){const he=de[Re];if(typeof he=="function")return he.call(de,ne)}throw new m.$ab(`Event not found: ${Re}`)}call(Ee,Re,ne){const ee=de[Re];if(typeof ee=="function"){if(!B&&Array.isArray(ne))for(let he=0;he<ne.length;he++)ne[he]=(0,R.$Wg)(ne[he]);return ee.apply(de,ne)}throw new m.$ab(`Method not found: ${Re}`)}}}ie.fromService=te;function q(re,fe){const de=fe&&fe.disableMarshalling;return new Proxy({},{get(B,_){if(typeof _=="string")return fe?.properties?.has(_)?fe.properties.get(_):ce(_)?function(Ee){return re.listen(_,Ee)}:V(_)?re.listen(_):async function(...Ee){let Re;fe&&!(0,$.$re)(fe.context)?Re=[fe.context,...Ee]:Re=Ee;const ne=await re.call(_,Re);return de?ne:(0,R.$Wg)(ne)};throw new m.$ab(`Property not found: ${String(_)}`)}})}ie.toService=q;function V(re){return re[0]==="o"&&re[1]==="n"&&I.$Kd(re.charCodeAt(2))}function ce(re){return/^onDynamic/.test(re)&&I.$Kd(re.charCodeAt(9))}})(z||(e.ProxyChannel=z={}));const j=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function U(ie){if(Array.isArray(ie))return ie;if(ie&&typeof ie=="object"&&typeof ie.toString=="function"){const te=ie.toString();if(te!=="[object Object]")return te}return ie}function Y(ie){return Array.isArray(ie)?ie.map(U):U(ie)}function H(ie,te,q,V,ce,re,fe){fe=Y(fe);const de=j[ce],B=de[V%de.length];let _=[`%c[${ie}]%c[${String(te).padStart(7," ")}]%c[len: ${String(q).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(re)?(_=_.concat(fe),_.push(")")):_.push(fe),console.log.apply(console,_)}class ge{constructor(te,q){this.d=te,this.f=q,this.a=0,this.b=0}logOutgoing(te,q,V,ce,re){this.b+=te,H(this.d,this.b,te,q,V,ce,re)}logIncoming(te,q,V,ce,re){this.a+=te,H(this.f,this.a,te,q,V,ce,re)}}e.$9g=ge}),define(De[122],Ce([1,0,22,3,4,76]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bh=e.$ah=e.$_g=e.$$g=e.ProtocolConstants=e.$0g=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(A||(e.SocketDiagnosticsEventType=A={}));var m;(function(t){t.enableDiagnostics=!1,t.records=[];const o=new WeakMap;let g=0;function u(v,l){if(!o.has(v)){const w=String(++g);o.set(v,w)}return o.get(v)}function d(v,l,w,P){if(!t.enableDiagnostics)return;const M=u(v,l);if(P instanceof k.$Jb||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const N=k.$Jb.alloc(P.byteLength);N.set(P),t.records.push({timestamp:Date.now(),id:M,label:l,type:w,buff:N})}else t.records.push({timestamp:Date.now(),id:M,label:l,type:w,data:P})}t.traceSocketEvent=d})(m||(e.SocketDiagnostics=m={}));var E;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(E||(e.SocketCloseEventType=E={}));let b=null;function R(){return b||(b=k.$Jb.alloc(0)),b}class I{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,g){if(o===0)return R();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const l=this.a[0];return g&&(this.a.shift(),this.b-=o),l}if(this.a[0].byteLength>o){const l=this.a[0].slice(0,o);return g&&(this.a[0]=this.a[0].slice(o),this.b-=o),l}const u=k.$Jb.alloc(o);let d=0,v=0;for(;o>0;){const l=this.a[v];if(l.byteLength>o){const w=l.slice(0,o);u.set(w,d),d+=o,g&&(this.a[v]=l.slice(o),this.b-=o),o-=o}else u.set(l,d),d+=l.byteLength,g?(this.a.shift(),this.b-=l.byteLength):v++,o-=l.byteLength}return u}}e.$0g=I;var $;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume",t[t.KeepAlive=9]="KeepAlive"})($||($={}));function S(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var D;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",t[t.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(D||(e.ProtocolConstants=D={}));class p{constructor(o,g,u,d){this.type=o,this.id=g,this.ack=u,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class r extends h.$lb{constructor(o){super(),this.f=this.B(new F.$7c),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new I,this.B(this.a.onData(g=>this.acceptChunk(g))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const g=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=g.readUInt32BE(9),this.g.messageType=g.readUInt8(0),this.g.id=g.readUInt32BE(1),this.g.ack=g.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:S(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const u=this.g.messageType,d=this.g.id,v=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",g),this.f.fire(new p(u,d,v,g)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const g=k.$Jb.alloc(13);g.writeUInt8(o.type,0),g.writeUInt32BE(o.id,1),g.writeUInt32BE(o.ack,5),g.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:S(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(g,o.data)}g(o,g){const u=this.f===0;return this.d.push(o,g),this.f+=o.byteLength+g.byteLength,u}h(){const o=k.$Jb.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,g){this.g(o,g)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class c extends h.$lb{constructor(o){super(),this.f=new F.$7c,this.onMessage=this.f.event,this.g=new F.$7c,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new s(this.a)),this.c=this.B(new r(this.a)),this.B(this.c.onMessage(g=>{g.type===1&&this.f.fire(g.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new p(1,0,0,o))}}e.$$g=c;class f extends L.$5g{static fromSocket(o,g){return new f(new c(o),g)}get onDidDispose(){return this.b.onDidDispose}constructor(o,g,u=null){super(o,g,u),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.$_g=f;class y{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new F.$7c({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.$ah=y;class C{constructor(o){this.data=o,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let o=0,g=this.a;for(;g;)g=g.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let g=0,u=this.a;for(;u;)o[g++]=u.data,u=u.next;return o}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const g=new C(o);if(!this.a){this.a=g,this.b=g;return}this.b.next=g,this.b=g}}class a{static{this.a=10}static{this.b=null}static getInstance(){return a.b||(a.b=new a),a.b}constructor(){this.c=[];const o=Date.now();for(let g=0;g<a.a;g++)this.c[g]=o-1e3*g;setInterval(()=>{for(let g=a.a;g>=1;g--)this.c[g]=this.c[g-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),g=(1+a.a)*1e3;let u=0;for(let d=0;d<a.a;d++)o-this.c[d]<=g&&u++;return 1-u/a.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(o){this.u=new y,this.onControlMessage=this.u.event,this.v=new y,this.onMessage=this.v.event,this.w=new y,this.onDidDispose=this.w.event,this.x=new y,this.onSocketClose=this.x.event,this.y=new y,this.onSocketTimeout=this.y.event,this.s=o.loadEstimator??a.getInstance(),this.t=o.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new h.$kb,this.o=o.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new r(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),o.initialChunk&&this.q.acceptChunk(o.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const o=new p(5,0,0,R());this.p.write(o),this.p.flush()}sendPause(){const o=new p(7,0,0,R());this.p.write(o)}sendResume(){const o=new p(8,0,0,R());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,g){this.a=!0,this.r.dispose(),this.r=new h.$kb,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new r(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),this.q.acceptChunk(g)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new p(3,0,this.h,R());this.p.write(o);const g=this.b.toArray();for(let u=0,d=g.length;u<d;u++)this.p.write(g[u]);this.B()}acceptDisconnect(){this.w.fire()}z(o){if(o.ack>this.d){this.d=o.ack;do{const g=this.b.peek();if(g&&g.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const g=Date.now();g-this.m>1e4&&(this.m=g,this.p.write(new p(6,0,0,R())))}else this.g=o.id,this.j=Date.now(),this.A(),this.v.fire(o.data);break}case 2:{this.u.fire(o.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const g=this.b.toArray();for(let u=0,d=g.length;u<d;u++)this.p.write(g[u]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const g=++this.c;this.h=this.g;const u=new p(1,g,this.h,o);this.b.push(u),this.a||(this.p.write(u),this.B())}sendControl(o){const g=new p(2,0,0,o);this.p.write(g)}A(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-o+5)}B(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),g=Date.now()-o.writtenTime,u=Date.now()-this.q.lastReadTime,d=Date.now()-this.n;if(g>=2e4&&u>=2e4&&d>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:g,timeSinceLastReceivedSomeData:u});return}const v=Math.max(2e4-g,2e4-u,2e4-d,500);this.f=setTimeout(()=>{this.f=null,this.B()},v)}C(){if(this.g<=this.h)return;this.h=this.g;const o=new p(3,0,this.h,R());this.p.write(o)}D(){this.h=this.g;const o=new p(9,0,this.h,R());this.p.write(o)}}e.$bh=n}),define(De[176],Ce([1,0,46,17,22,21,174,8,3,4,23,96,94,76]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=e.$Ep=void 0;class D extends S.$2g{constructor(s){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:E.Event.fromNodeEventEmitter(process,"message",c=>h.$Jb.wrap(Buffer.from(c,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$Ep=D;class p{constructor(s,c){this.i=s,this.j=c,this.c=new Set,this.g=new Map,this.h=new E.$7c,this.onDidProcessExit=this.h.event;const f=c&&c.timeout?c.timeout:6e4;this.b=new F.$qg(f),this.d=null,this.f=null}getChannel(s){const c=this;return{call(f,y,C){return c.k(s,f,y,C)},listen(f,y){return c.l(s,f,y)}}}k(s,c,f,y=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(y.isCancellationRequested)return Promise.reject(m.$4());this.b.cancel();const C=this.n(s),i=(0,F.$hg)(t=>C.call(c,f,t)),a=y.onCancellationRequested(()=>i.cancel()),n=(0,b.$jb)(()=>i.cancel());return this.c.add(n),i.finally(()=>{a.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(s,c,f){if(!this.b)return E.Event.None;this.b.cancel();let y;const C=new E.$7c({onWillAddFirstListener:()=>{y=this.n(s).listen(c,f)(C.fire,C),this.c.add(y)},onDidRemoveLastListener:()=>{this.c.delete(y),y.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return C.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,R.$Fm)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,$.$el)(c.env),this.d=(0,k.fork)(this.i,s,c);const f=new E.$7c;E.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$Ap)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}f.fire(h.$Jb.wrap(Buffer.from(o,"base64")))});const C=this.j.useQueue?(0,I.$gl)(this.d):this.d,i=o=>this.d&&this.d.connected&&C.send(o.buffer.toString("base64")),a=f.event,n={send:i,onMessage:a};this.f=new S.$3g(n);const t=()=>this.o();process.once("exit",t),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,g)=>{process.removeListener("exit",t),this.c.forEach(u=>(0,b.$gb)(u)),this.c.clear(),o!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:g})})}return this.f}n(s){let c=this.g.get(s);return c||(c=this.m.getChannel(s),this.g.set(s,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Fp=p}),define(De[177],Ce([1,0,34,13]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=void 0;function h(L,A,m,E,b,R){if(Array.isArray(L)){let I=0;for(const $ of L){const S=h($,A,m,E,b,R);if(S===10)return S;S>I&&(I=S)}return I}else{if(typeof L=="string")return E?L==="*"?5:L===m?10:0:0;if(L){const{language:I,pattern:$,scheme:S,hasAccessToAllModels:D,notebookType:p}=L;if(!E&&!D)return 0;p&&b&&(A=b);let r=0;if(S)if(S===A.scheme)r=10;else if(S==="*")r=5;else return 0;if(I)if(I===m)r=10;else if(I==="*")r=Math.max(r,5);else return 0;if(p)if(p===R)r=10;else if(p==="*"&&R!==void 0)r=Math.max(r,5);else return 0;if($){let s;if(typeof $=="string"?s=$:s={...$,base:(0,F.$$b)($.base)},s===A.fsPath||(0,k.$bj)(s,A.fsPath))r=10;else return 0}return r}else return 0}}e.$VE=h}),define(De[123],Ce([1,0,22,11]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8=e.$z8=void 0;var h;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(h||(h={}));function L(I){for(let $=0,S=I.length;$<S;$+=4){const D=I[$+0],p=I[$+1],r=I[$+2],s=I[$+3];I[$+0]=s,I[$+1]=r,I[$+2]=p,I[$+3]=D}}function A(I){const $=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return F.$C()||L($),k.$Jb.wrap($)}function m(I){const $=I.buffer;if(F.$C()||L($),$.byteOffset%4===0)return new Uint32Array($.buffer,$.byteOffset,$.length/4);{const S=new Uint8Array($.byteLength);return S.set($),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function E(I){const $=new Uint32Array(b(I));let S=0;if($[S++]=I.id,I.type==="full")$[S++]=1,$[S++]=I.data.length,$.set(I.data,S),S+=I.data.length;else{$[S++]=2,$[S++]=I.deltas.length;for(const D of I.deltas)$[S++]=D.start,$[S++]=D.deleteCount,D.data?($[S++]=D.data.length,$.set(D.data,S),S+=D.data.length):$[S++]=0}return A($)}e.$z8=E;function b(I){let $=0;if($+=1+1,I.type==="full")$+=1+I.data.length;else{$+=1,$+=(1+1+1)*I.deltas.length;for(const S of I.deltas)S.data&&($+=S.data.length)}return $}function R(I){const $=m(I);let S=0;const D=$[S++];if($[S++]===1){const c=$[S++],f=$.subarray(S,S+c);return S+=c,{id:D,type:"full",data:f}}const r=$[S++],s=[];for(let c=0;c<r;c++){const f=$[S++],y=$[S++],C=$[S++];let i;C>0&&(i=$.subarray(S,S+C),S+=C),s[c]={start:f,deleteCount:y,data:i}}return{id:D,type:"delta",deltas:s}}e.$A8=R}),define(De[178],Ce([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(De[124],Ce([1,0,19,23,11,159,116,178]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(E||(e.EditorAutoIndentStrategy=E={})),e.MINIMAP_GUTTER_WIDTH=8;class b{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=b;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class I{constructor(Z,ye,je,Oe){this.id=Z,this.name=ye,this.defaultValue=je,this.schema=Oe}applyUpdate(Z,ye){return S(Z,ye)}compute(Z,ye,je){return je}}class ${constructor(Z,ye){this.newValue=Z,this.didChange=ye}}e.ApplyUpdateResult=$;function S(Q,Z){if(typeof Q!="object"||typeof Z!="object"||!Q||!Z)return new $(Z,Q!==Z);if(Array.isArray(Q)||Array.isArray(Z)){const je=Array.isArray(Q)&&Array.isArray(Z)&&k.$af(Q,Z);return new $(Z,!je)}let ye=!1;for(const je in Z)if(Z.hasOwnProperty(je)){const Oe=S(Q[je],Z[je]);Oe.didChange&&(Q[je]=Oe.newValue,ye=!0)}return new $(Q,ye)}class D{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,ye){return S(Z,ye)}validate(Z){return this.defaultValue}}class p{constructor(Z,ye,je,Oe){this.id=Z,this.name=ye,this.defaultValue=je,this.schema=Oe}applyUpdate(Z,ye){return S(Z,ye)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,ye,je){return je}}function r(Q,Z){return typeof Q>"u"?Z:Q==="false"?!1:!!Q}e.boolean=r;class s extends p{constructor(Z,ye,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="boolean",Oe.default=je),super(Z,ye,je,Oe)}validate(Z){return r(Z,this.defaultValue)}}function c(Q,Z,ye,je){if(typeof Q>"u")return Z;let Oe=parseInt(Q,10);return isNaN(Oe)?Z:(Oe=Math.max(ye,Oe),Oe=Math.min(je,Oe),Oe|0)}e.clampedInt=c;class f extends p{static clampedInt(Z,ye,je,Oe){return c(Z,ye,je,Oe)}constructor(Z,ye,je,Oe,Ye,_e=void 0){typeof _e<"u"&&(_e.type="integer",_e.default=je,_e.minimum=Oe,_e.maximum=Ye),super(Z,ye,je,_e),this.minimum=Oe,this.maximum=Ye}validate(Z){return f.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function y(Q,Z,ye,je){if(typeof Q>"u")return Z;const Oe=C.float(Q,Z);return C.clamp(Oe,ye,je)}e.clampedFloat=y;class C extends p{static clamp(Z,ye,je){return Z<ye?ye:Z>je?je:Z}static float(Z,ye){if(typeof Z=="number")return Z;if(typeof Z>"u")return ye;const je=parseFloat(Z);return isNaN(je)?ye:je}constructor(Z,ye,je,Oe,Ye){typeof Ye<"u"&&(Ye.type="number",Ye.default=je),super(Z,ye,je,Ye),this.validationFn=Oe}validate(Z){return this.validationFn(C.float(Z,this.defaultValue))}}class i extends p{static string(Z,ye){return typeof Z!="string"?ye:Z}constructor(Z,ye,je,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.default=je),super(Z,ye,je,Oe)}validate(Z){return i.string(Z,this.defaultValue)}}function a(Q,Z,ye,je){return typeof Q!="string"?Z:je&&Q in je?je[Q]:ye.indexOf(Q)===-1?Z:Q}e.stringSet=a;class n extends p{constructor(Z,ye,je,Oe,Ye=void 0){typeof Ye<"u"&&(Ye.type="string",Ye.enum=Oe,Ye.default=je),super(Z,ye,je,Ye),this.c=Oe}validate(Z){return a(Z,this.defaultValue,this.c)}}class t extends I{constructor(Z,ye,je,Oe,Ye,_e,rt=void 0){typeof rt<"u"&&(rt.type="string",rt.enum=Ye,rt.default=Oe),super(Z,ye,je,rt),this.c=Ye,this.d=_e}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function o(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends I{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ye,je){return je===0?Z.accessibilitySupport:je}}class u extends I{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{insertSpace:r(ye.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(ye.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var d;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(d||(e.TextEditorCursorBlinkingStyle=d={}));function v(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var l;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(l||(e.TextEditorCursorStyle=l={}));function w(Q){switch(Q){case l.Line:return"line";case l.Block:return"block";case l.Underline:return"underline";case l.LineThin:return"line-thin";case l.BlockOutline:return"block-outline";case l.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=w;function P(Q){switch(Q){case"line":return l.Line;case"block":return l.Block;case"underline":return l.Underline;case"line-thin":return l.LineThin;case"block-outline":return l.BlockOutline;case"underline-thin":return l.UnderlineThin}}class M extends D{constructor(){super(139)}compute(Z,ye,je){const Oe=["monaco-editor"];return ye.get(38)&&Oe.push(ye.get(38)),Z.extraEditorClassName&&Oe.push(Z.extraEditorClassName),ye.get(72)==="default"?Oe.push("mouse-default"):ye.get(72)==="copy"&&Oe.push("mouse-copy"),ye.get(109)&&Oe.push("showUnused"),ye.get(137)&&Oe.push("showDeprecated"),Oe.join(" ")}}class N extends s{constructor(){super(36,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Z,ye,je){return je&&Z.emptySelectionClipboard}}class T extends I{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:m.localize(16,null),included:h.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:m.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{cursorMoveOnType:r(ye.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":a(ye.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":a(ye.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(ye.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(ye.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(ye.loop,this.defaultValue.loop)}}}class z extends I{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(50,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?z.OFF:Z==="true"?z.ON:Z:Z?z.ON:z.OFF}}e.EditorFontLigatures=z;class j extends I{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(53,"fontVariations",j.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?j.OFF:Z==="true"?j.TRANSLATE:Z:Z?j.TRANSLATE:j.OFF}compute(Z,ye,je){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=j;class U extends D{constructor(){super(49)}compute(Z,ye,je){return Z.fontInfo}}class Y extends p{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Z){const ye=C.float(Z,this.defaultValue);return ye===0?e.EDITOR_FONT_DEFAULTS.fontSize:C.clamp(ye,6,100)}compute(Z,ye,je){return Z.fontInfo.fontSize}}class H extends I{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.d,maximum:H.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(f.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,H.d,H.e))}}class ge extends I{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ye={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...ye},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...ye},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...ye},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...ye},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...ye},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:je,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:je,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:je,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:je,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:je,description:m.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{multiple:a(ye.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ye.multipleDefinitions??a(ye.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ye.multipleTypeDefinitions??a(ye.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ye.multipleDeclarations??a(ye.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ye.multipleImplementations??a(ye.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ye.multipleReferences??a(ye.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ye.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ye.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ye.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ye.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ye.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ie extends I{constructor(){const Z={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:m.localize(44,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:m.localize(45,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:r(ye.enabled,this.defaultValue.enabled),delay:f.clampedInt(ye.delay,this.defaultValue.delay,0,1e4),sticky:r(ye.sticky,this.defaultValue.sticky),above:r(ye.above,this.defaultValue.above)}}}var te;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(te||(e.RenderMinimap=te={}));class q extends D{constructor(){super(142)}compute(Z,ye,je){return q.computeLayout(ye,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const ye=Z.height/Z.lineHeight,je=Math.floor(Z.paddingTop/Z.lineHeight);let Oe=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Oe=Math.max(Oe,ye-1));const Ye=(je+Z.viewLineCount+Oe)/(Z.pixelRatio*Z.height),_e=Math.floor(Z.viewLineCount/Ye);return{typicalViewportLineCount:ye,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:Oe,desiredRatio:Ye,minimapLineCount:_e}}static c(Z,ye){const je=Z.outerWidth,Oe=Z.outerHeight,Ye=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Oe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Oe};const _e=ye.stableMinimapLayoutInput,rt=_e&&Z.outerHeight===_e.outerHeight&&Z.lineHeight===_e.lineHeight&&Z.typicalHalfwidthCharacterWidth===_e.typicalHalfwidthCharacterWidth&&Z.pixelRatio===_e.pixelRatio&&Z.scrollBeyondLastLine===_e.scrollBeyondLastLine&&Z.paddingTop===_e.paddingTop&&Z.paddingBottom===_e.paddingBottom&&Z.minimap.enabled===_e.minimap.enabled&&Z.minimap.side===_e.minimap.side&&Z.minimap.size===_e.minimap.size&&Z.minimap.showSlider===_e.minimap.showSlider&&Z.minimap.renderCharacters===_e.minimap.renderCharacters&&Z.minimap.maxColumn===_e.minimap.maxColumn&&Z.minimap.scale===_e.minimap.scale&&Z.verticalScrollbarWidth===_e.verticalScrollbarWidth&&Z.isViewportWrapping===_e.isViewportWrapping,ft=Z.lineHeight,vt=Z.typicalHalfwidthCharacterWidth,Ft=Z.scrollBeyondLastLine,Lt=Z.minimap.renderCharacters;let Et=Ye>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Tt=Z.minimap.maxColumn,Mt=Z.minimap.size,zt=Z.minimap.side,Bt=Z.verticalScrollbarWidth,Nt=Z.viewLineCount,at=Z.remainingWidth,dt=Z.isViewportWrapping,Wt=Lt?2:3;let Ot=Math.floor(Ye*Oe);const St=Ot/Ye;let ct=!1,At=!1,Ut=Wt*Et,Te=Et/Ye,Le=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:it,extraLinesBeforeFirstLine:wt,extraLinesBeyondLastLine:Dt,desiredRatio:Ct,minimapLineCount:pt}=q.computeContainedMinimapLineCount({viewLineCount:Nt,scrollBeyondLastLine:Ft,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Oe,lineHeight:ft,pixelRatio:Ye});if(Nt/pt>1)ct=!0,At=!0,Et=1,Ut=1,Te=Et/Ye;else{let ht=!1,bt=Et+1;if(Mt==="fit"){const gt=Math.ceil((wt+Nt+Dt)*Ut);dt&&rt&&at<=ye.stableFitRemainingWidth?(ht=!0,bt=ye.stableFitMaxMinimapScale):ht=gt>Ot}if(Mt==="fill"||ht){ct=!0;const gt=Et;Ut=Math.min(ft*Ye,Math.max(1,Math.floor(1/Ct))),dt&&rt&&at<=ye.stableFitRemainingWidth&&(bt=ye.stableFitMaxMinimapScale),Et=Math.min(bt,Math.max(1,Math.floor(Ut/Wt))),Et>gt&&(Le=Math.min(2,Et/gt)),Te=Et/Ye/Le,Ot=Math.ceil(Math.max(it,wt+Nt+Dt)*Ut),dt?(ye.stableMinimapLayoutInput=Z,ye.stableFitRemainingWidth=at,ye.stableFitMaxMinimapScale=Et):(ye.stableMinimapLayoutInput=null,ye.stableFitRemainingWidth=0)}}}const Ae=Math.floor(Tt*Te),ae=Math.min(Ae,Math.max(0,Math.floor((at-Bt-2)*Te/(vt+Te)))+e.MINIMAP_GUTTER_WIDTH);let Me=Math.floor(Ye*ae);const We=Me/Ye;Me=Math.floor(Me*Le);const Xe=Lt?1:2,He=zt==="left"?0:je-ae-Bt;return{renderMinimap:Xe,minimapLeft:He,minimapWidth:ae,minimapHeightIsEditorHeight:ct,minimapIsSampling:At,minimapScale:Et,minimapLineHeight:Ut,minimapCanvasInnerWidth:Me,minimapCanvasInnerHeight:Ot,minimapCanvasOuterWidth:We,minimapCanvasOuterHeight:St}}static computeLayout(Z,ye){const je=ye.outerWidth|0,Oe=ye.outerHeight|0,Ye=ye.lineHeight|0,_e=ye.lineNumbersDigitCount|0,rt=ye.typicalHalfwidthCharacterWidth,ft=ye.maxDigitWidth,vt=ye.pixelRatio,Ft=ye.viewLineCount,Lt=Z.get(134),Et=Lt==="inherit"?Z.get(133):Lt,Tt=Et==="inherit"?Z.get(129):Et,Mt=Z.get(132),zt=ye.isDominatedByLongLines,Bt=Z.get(56),Nt=Z.get(66).renderType!==0,at=Z.get(67),dt=Z.get(103),Wt=Z.get(82),Ot=Z.get(71),St=Z.get(101),ct=St.verticalScrollbarSize,At=St.verticalHasArrows,Ut=St.arrowSize,Te=St.horizontalScrollbarSize,Le=Z.get(42),Ae=Z.get(108)!=="never";let ae=Z.get(64);Le&&Ae&&(ae+=16);let Me=0;if(Nt){const qt=Math.max(_e,at);Me=Math.round(qt*ft)}let We=0;Bt&&(We=Ye*ye.glyphMarginDecorationLaneCount);let Xe=0,He=Xe+We,it=He+Me,wt=it+ae;const Dt=je-We-Me-ae;let Ct=!1,pt=!1,$t=-1;Et==="inherit"&&zt?(Ct=!0,pt=!0):Tt==="on"||Tt==="bounded"?pt=!0:Tt==="wordWrapColumn"&&($t=Mt);const ht=q.c({outerWidth:je,outerHeight:Oe,lineHeight:Ye,typicalHalfwidthCharacterWidth:rt,pixelRatio:vt,scrollBeyondLastLine:dt,paddingTop:Wt.top,paddingBottom:Wt.bottom,minimap:Ot,verticalScrollbarWidth:ct,viewLineCount:Ft,remainingWidth:Dt,isViewportWrapping:pt},ye.memory||new R);ht.renderMinimap!==0&&ht.minimapLeft===0&&(Xe+=ht.minimapWidth,He+=ht.minimapWidth,it+=ht.minimapWidth,wt+=ht.minimapWidth);const bt=Dt-ht.minimapWidth,gt=Math.max(1,Math.floor((bt-ct-2)/rt)),Zt=At?Ut:0;return pt&&($t=Math.max(1,gt),Tt==="bounded"&&($t=Math.min($t,Mt))),{width:je,height:Oe,glyphMarginLeft:Xe,glyphMarginWidth:We,glyphMarginDecorationLaneCount:ye.glyphMarginDecorationLaneCount,lineNumbersLeft:He,lineNumbersWidth:Me,decorationsLeft:it,decorationsWidth:ae,contentLeft:wt,contentWidth:bt,minimap:ht,viewportColumn:gt,isWordWrapMinified:Ct,isViewportWrapping:pt,wrappingColumn:$t,verticalScrollbarWidth:ct,horizontalScrollbarHeight:Te,overviewRuler:{top:Zt,width:ct,height:Oe-2*Zt,right:0}}}}e.EditorLayoutInfoComputer=q;class V extends I{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(46,null),m.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(48,null)}})}validate(Z){return a(Z,"simple",["simple","advanced"])}compute(Z,ye,je){return ye.get(2)===2?"advanced":je}}class ce extends I{constructor(){const Z={enabled:!0};super(63,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:m.localize(49,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:r(Z.enabled,this.defaultValue.enabled)}}}class re extends I{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(113,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:m.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:m.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:m.localize(52,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:r(ye.enabled,this.defaultValue.enabled),maxLineCount:f.clampedInt(ye.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(ye.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class fe extends I{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:m.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(54,null),m.localize(55,null,h.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(56,null,h.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:m.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:m.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:m.localize(60,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return typeof ye.enabled=="boolean"&&(ye.enabled=ye.enabled?"on":"off"),{enabled:a(ye.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:f.clampedInt(ye.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ye.fontFamily,this.defaultValue.fontFamily),padding:r(ye.padding,this.defaultValue.padding)}}}class de extends I{constructor(){super(64,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):f.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,ye,je){return je<0?f.clampedInt(-je*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class B extends C{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>C.clamp(Z,0,150),{markdownDescription:m.localize(61,null)})}compute(Z,ye,je){return Z.fontInfo.lineHeight}}class _ extends I{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:m.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:m.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(64,null),m.localize(65,null),m.localize(66,null)],default:Z.size,description:m.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:m.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:m.localize(69,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:m.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:m.localize(72,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:r(ye.enabled,this.defaultValue.enabled),autohide:r(ye.autohide,this.defaultValue.autohide),size:a(ye.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(ye.side,this.defaultValue.side,["right","left"]),showSlider:a(ye.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(ye.renderCharacters,this.defaultValue.renderCharacters),scale:f.clampedInt(ye.scale,1,1,3),maxColumn:f.clampedInt(ye.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ee(Q){return Q==="ctrlCmd"?h.$j?"metaKey":"ctrlKey":"altKey"}class Re extends I{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{top:f.clampedInt(ye.top,0,0,1e3),bottom:f.clampedInt(ye.bottom,0,0,1e3)}}}class ne extends I{constructor(){const Z={enabled:!0,cycle:!0};super(84,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:m.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:m.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:r(ye.enabled,this.defaultValue.enabled),cycle:r(ye.cycle,this.defaultValue.cycle)}}}class ee extends D{constructor(){super(140)}compute(Z,ye,je){return Z.pixelRatio}}class he extends I{constructor(){const Z={other:"on",comments:"off",strings:"off"},ye=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(77,null),m.localize(78,null),m.localize(79,null)]}];super(87,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ye,default:Z.strings,description:m.localize(80,null)},comments:{anyOf:ye,default:Z.comments,description:m.localize(81,null)},other:{anyOf:ye,default:Z.other,description:m.localize(82,null)}},default:Z,markdownDescription:m.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const vt=Z?"on":"off";return{comments:vt,strings:vt,other:vt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:ye,comments:je,strings:Oe}=Z,Ye=["on","inline","off"];let _e,rt,ft;return typeof ye=="boolean"?_e=ye?"on":"off":_e=a(ye,this.defaultValue.other,Ye),typeof je=="boolean"?rt=je?"on":"off":rt=a(je,this.defaultValue.comments,Ye),typeof Oe=="boolean"?ft=Oe?"on":"off":ft=a(Oe,this.defaultValue.strings,Ye),{other:_e,comments:rt,strings:ft}}}var X;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(X||(e.RenderLineNumbersType=X={}));class ue extends I{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(84,null),m.localize(85,null),m.localize(86,null),m.localize(87,null)],default:"on",description:m.localize(88,null)})}validate(Z){let ye=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(ye=4,je=Z):Z==="interval"?ye=3:Z==="relative"?ye=2:Z==="on"?ye=1:ye=0),{renderType:ye,renderFn:je}}}function oe(Q){const Z=Q.get(96);return Z==="editable"?Q.get(89):Z!=="on"}e.filterValidationDecorations=oe;class le extends I{constructor(){const Z=[],ye={type:"number",description:m.localize(89,null)};super(100,"rulers",Z,{type:"array",items:{anyOf:[ye,{type:["object"],properties:{column:ye,color:{type:"string",description:m.localize(90,null),format:"color-hex"}}}]},default:Z,description:m.localize(91,null)})}validate(Z){if(Array.isArray(Z)){const ye=[];for(const je of Z)if(typeof je=="number")ye.push({column:f.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const Oe=je;ye.push({column:f.clampedInt(Oe.column,0,0,1e4),color:Oe.color})}return ye.sort((je,Oe)=>je.column-Oe.column),ye}return this.defaultValue}}class we extends I{constructor(){super(90,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function O(Q,Z){if(typeof Q!="string")return Z;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class K extends I{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(92,null),m.localize(93,null),m.localize(94,null)],default:"auto",description:m.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(96,null),m.localize(97,null),m.localize(98,null)],default:"auto",description:m.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:m.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:m.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:m.localize(102,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z,je=f.clampedInt(ye.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Oe=f.clampedInt(ye.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:f.clampedInt(ye.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:O(ye.vertical,this.defaultValue.vertical),horizontal:O(ye.horizontal,this.defaultValue.horizontal),useShadows:r(ye.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(ye.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(ye.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(ye.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(ye.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:f.clampedInt(ye.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:Oe,verticalSliderSize:f.clampedInt(ye.verticalSliderSize,Oe,0,1e3),scrollByPage:r(ye.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends I{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:m.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:m.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:m.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:m.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:m.localize(109,null)}})}applyUpdate(Z,ye){let je=!1;ye.allowedCharacters&&Z&&(F.$Jm(Z.allowedCharacters,ye.allowedCharacters)||(Z={...Z,allowedCharacters:ye.allowedCharacters},je=!0)),ye.allowedLocales&&Z&&(F.$Jm(Z.allowedLocales,ye.allowedLocales)||(Z={...Z,allowedLocales:ye.allowedLocales},je=!0));const Oe=super.applyUpdate(Z,ye);return je?new $(Oe.newValue,!0):Oe}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{nonBasicASCII:ve(ye.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r(ye.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r(ye.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ve(ye.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ve(ye.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,ye){if(typeof Z!="object"||!Z)return ye;const je={};for(const[Oe,Ye]of Object.entries(Z))Ye===!0&&(je[Oe]=!0);return je}}class x extends I{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:m.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover"],enumDescriptions:[m.localize(111,null),m.localize(112,null)],description:m.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:m.localize(114,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:r(ye.enabled,this.defaultValue.enabled),mode:a(ye.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(ye.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:r(ye.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:r(ye.keepOnBlur,this.defaultValue.keepOnBlur)}}}class pe extends I{constructor(){const Z={enabled:L.$Fr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:L.$Fr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:m.localize(116,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:r(ye.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r(ye.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class se extends I{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],default:Z.bracketPairs,description:m.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(121,null),m.localize(122,null),m.localize(123,null)],default:Z.bracketPairsHorizontal,description:m.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:m.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:m.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(127,null),m.localize(128,null),m.localize(129,null)],default:Z.highlightActiveIndentation,description:m.localize(130,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{bracketPairs:ve(ye.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ve(ye.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r(ye.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r(ye.indentation,this.defaultValue.indentation),highlightActiveIndentation:ve(ye.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ve(Q,Z,ye){const je=ye.indexOf(Q);return je===-1?Z:ye[je]}class Ie extends I{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(131,null),m.localize(132,null)],default:Z.insertMode,description:m.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:m.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:m.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:m.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(137,null),m.localize(138,null),m.localize(139,null),m.localize(140,null)],default:Z.selectionMode,markdownDescription:m.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:m.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:m.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:m.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:m.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:m.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{insertMode:a(ye.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(ye.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(ye.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(ye.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(ye.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(ye.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r(ye.showIcons,this.defaultValue.showIcons),showStatusBar:r(ye.showStatusBar,this.defaultValue.showStatusBar),preview:r(ye.preview,this.defaultValue.preview),previewMode:a(ye.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(ye.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(ye.showMethods,this.defaultValue.showMethods),showFunctions:r(ye.showFunctions,this.defaultValue.showFunctions),showConstructors:r(ye.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(ye.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r(ye.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r(ye.showFields,this.defaultValue.showFields),showVariables:r(ye.showVariables,this.defaultValue.showVariables),showClasses:r(ye.showClasses,this.defaultValue.showClasses),showStructs:r(ye.showStructs,this.defaultValue.showStructs),showInterfaces:r(ye.showInterfaces,this.defaultValue.showInterfaces),showModules:r(ye.showModules,this.defaultValue.showModules),showProperties:r(ye.showProperties,this.defaultValue.showProperties),showEvents:r(ye.showEvents,this.defaultValue.showEvents),showOperators:r(ye.showOperators,this.defaultValue.showOperators),showUnits:r(ye.showUnits,this.defaultValue.showUnits),showValues:r(ye.showValues,this.defaultValue.showValues),showConstants:r(ye.showConstants,this.defaultValue.showConstants),showEnums:r(ye.showEnums,this.defaultValue.showEnums),showEnumMembers:r(ye.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(ye.showKeywords,this.defaultValue.showKeywords),showWords:r(ye.showWords,this.defaultValue.showWords),showColors:r(ye.showColors,this.defaultValue.showColors),showFiles:r(ye.showFiles,this.defaultValue.showFiles),showReferences:r(ye.showReferences,this.defaultValue.showReferences),showFolders:r(ye.showFolders,this.defaultValue.showFolders),showTypeParameters:r(ye.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(ye.showSnippets,this.defaultValue.showSnippets),showUsers:r(ye.showUsers,this.defaultValue.showUsers),showIssues:r(ye.showIssues,this.defaultValue.showIssues)}}}class Ue extends I{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(179,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(180,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:r(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var Ve;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(Ve||(e.WrappingIndent=Ve={}));class xe extends I{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(181,null),m.localize(182,null),m.localize(183,null),m.localize(184,null)],description:m.localize(185,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,ye,je){return ye.get(2)===2?0:je}}class Ge extends D{constructor(){super(143)}compute(Z,ye,je){const Oe=ye.get(142);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Oe.isWordWrapMinified,isViewportWrapping:Oe.isViewportWrapping,wrappingColumn:Oe.wrappingColumn}}}class et extends I{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(186,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(187,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(188,null),m.localize(189,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:r(ye.enabled,this.defaultValue.enabled),showDropSelector:a(ye.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ze extends I{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(190,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(191,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(192,null),m.localize(193,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ye=Z;return{enabled:r(ye.enabled,this.defaultValue.enabled),showPasteSelector:a(ye.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const st="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",Pe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:h.$j?tt:h.$k?Pe:st,fontWeight:"normal",fontSize:h.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var Be;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.ariaRequired=5]="ariaRequired",Q[Q.autoClosingBrackets=6]="autoClosingBrackets",Q[Q.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",Q[Q.autoClosingDelete=8]="autoClosingDelete",Q[Q.autoClosingOvertype=9]="autoClosingOvertype",Q[Q.autoClosingQuotes=10]="autoClosingQuotes",Q[Q.autoIndent=11]="autoIndent",Q[Q.automaticLayout=12]="automaticLayout",Q[Q.autoSurround=13]="autoSurround",Q[Q.bracketPairColorization=14]="bracketPairColorization",Q[Q.guides=15]="guides",Q[Q.codeLens=16]="codeLens",Q[Q.codeLensFontFamily=17]="codeLensFontFamily",Q[Q.codeLensFontSize=18]="codeLensFontSize",Q[Q.colorDecorators=19]="colorDecorators",Q[Q.colorDecoratorsLimit=20]="colorDecoratorsLimit",Q[Q.columnSelection=21]="columnSelection",Q[Q.comments=22]="comments",Q[Q.contextmenu=23]="contextmenu",Q[Q.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=25]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=27]="cursorStyle",Q[Q.cursorSurroundingLines=28]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=30]="cursorWidth",Q[Q.disableLayerHinting=31]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",Q[Q.domReadOnly=33]="domReadOnly",Q[Q.dragAndDrop=34]="dragAndDrop",Q[Q.dropIntoEditor=35]="dropIntoEditor",Q[Q.emptySelectionClipboard=36]="emptySelectionClipboard",Q[Q.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",Q[Q.extraEditorClassName=38]="extraEditorClassName",Q[Q.fastScrollSensitivity=39]="fastScrollSensitivity",Q[Q.find=40]="find",Q[Q.fixedOverflowWidgets=41]="fixedOverflowWidgets",Q[Q.folding=42]="folding",Q[Q.foldingStrategy=43]="foldingStrategy",Q[Q.foldingHighlight=44]="foldingHighlight",Q[Q.foldingImportsByDefault=45]="foldingImportsByDefault",Q[Q.foldingMaximumRegions=46]="foldingMaximumRegions",Q[Q.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=48]="fontFamily",Q[Q.fontInfo=49]="fontInfo",Q[Q.fontLigatures=50]="fontLigatures",Q[Q.fontSize=51]="fontSize",Q[Q.fontWeight=52]="fontWeight",Q[Q.fontVariations=53]="fontVariations",Q[Q.formatOnPaste=54]="formatOnPaste",Q[Q.formatOnType=55]="formatOnType",Q[Q.glyphMargin=56]="glyphMargin",Q[Q.gotoLocation=57]="gotoLocation",Q[Q.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",Q[Q.hover=59]="hover",Q[Q.inDiffEditor=60]="inDiffEditor",Q[Q.inlineSuggest=61]="inlineSuggest",Q[Q.letterSpacing=62]="letterSpacing",Q[Q.lightbulb=63]="lightbulb",Q[Q.lineDecorationsWidth=64]="lineDecorationsWidth",Q[Q.lineHeight=65]="lineHeight",Q[Q.lineNumbers=66]="lineNumbers",Q[Q.lineNumbersMinChars=67]="lineNumbersMinChars",Q[Q.linkedEditing=68]="linkedEditing",Q[Q.links=69]="links",Q[Q.matchBrackets=70]="matchBrackets",Q[Q.minimap=71]="minimap",Q[Q.mouseStyle=72]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=74]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=76]="multiCursorModifier",Q[Q.multiCursorPaste=77]="multiCursorPaste",Q[Q.multiCursorLimit=78]="multiCursorLimit",Q[Q.occurrencesHighlight=79]="occurrencesHighlight",Q[Q.overviewRulerBorder=80]="overviewRulerBorder",Q[Q.overviewRulerLanes=81]="overviewRulerLanes",Q[Q.padding=82]="padding",Q[Q.pasteAs=83]="pasteAs",Q[Q.parameterHints=84]="parameterHints",Q[Q.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=87]="quickSuggestions",Q[Q.quickSuggestionsDelay=88]="quickSuggestionsDelay",Q[Q.readOnly=89]="readOnly",Q[Q.readOnlyMessage=90]="readOnlyMessage",Q[Q.renameOnType=91]="renameOnType",Q[Q.renderControlCharacters=92]="renderControlCharacters",Q[Q.renderFinalNewline=93]="renderFinalNewline",Q[Q.renderLineHighlight=94]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=96]="renderValidationDecorations",Q[Q.renderWhitespace=97]="renderWhitespace",Q[Q.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",Q[Q.roundedSelection=99]="roundedSelection",Q[Q.rulers=100]="rulers",Q[Q.scrollbar=101]="scrollbar",Q[Q.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=103]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=104]="scrollPredominantAxis",Q[Q.selectionClipboard=105]="selectionClipboard",Q[Q.selectionHighlight=106]="selectionHighlight",Q[Q.selectOnLineNumbers=107]="selectOnLineNumbers",Q[Q.showFoldingControls=108]="showFoldingControls",Q[Q.showUnused=109]="showUnused",Q[Q.snippetSuggestions=110]="snippetSuggestions",Q[Q.smartSelect=111]="smartSelect",Q[Q.smoothScrolling=112]="smoothScrolling",Q[Q.stickyScroll=113]="stickyScroll",Q[Q.stickyTabStops=114]="stickyTabStops",Q[Q.stopRenderingLineAfter=115]="stopRenderingLineAfter",Q[Q.suggest=116]="suggest",Q[Q.suggestFontSize=117]="suggestFontSize",Q[Q.suggestLineHeight=118]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",Q[Q.suggestSelection=120]="suggestSelection",Q[Q.tabCompletion=121]="tabCompletion",Q[Q.tabIndex=122]="tabIndex",Q[Q.unicodeHighlighting=123]="unicodeHighlighting",Q[Q.unusualLineTerminators=124]="unusualLineTerminators",Q[Q.useShadowDOM=125]="useShadowDOM",Q[Q.useTabStops=126]="useTabStops",Q[Q.wordBreak=127]="wordBreak",Q[Q.wordSeparators=128]="wordSeparators",Q[Q.wordWrap=129]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=132]="wordWrapColumn",Q[Q.wordWrapOverride1=133]="wordWrapOverride1",Q[Q.wordWrapOverride2=134]="wordWrapOverride2",Q[Q.wrappingIndent=135]="wrappingIndent",Q[Q.wrappingStrategy=136]="wrappingStrategy",Q[Q.showDeprecated=137]="showDeprecated",Q[Q.inlayHints=138]="inlayHints",Q[Q.editorClassName=139]="editorClassName",Q[Q.pixelRatio=140]="pixelRatio",Q[Q.tabFocusMode=141]="tabFocusMode",Q[Q.layoutInfo=142]="layoutInfo",Q[Q.wrappingInfo=143]="wrappingInfo",Q[Q.defaultColorDecorators=144]="defaultColorDecorators",Q[Q.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(Be||(e.EditorOption=Be={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(194,null)})),acceptSuggestionOnEnter:ke(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(195,null),""],markdownDescription:m.localize(196,null)})),accessibilitySupport:ke(new g),accessibilityPageSize:ke(new f(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(197,null),tags:["accessibility"]})),ariaLabel:ke(new i(4,"ariaLabel",m.localize(198,null))),ariaRequired:ke(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:ke(new s(7,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(199,null),tags:["accessibility"]})),autoClosingBrackets:ke(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(200,null),m.localize(201,null),""],description:m.localize(202,null)})),autoClosingDelete:ke(new n(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(203,null),""],description:m.localize(204,null)})),autoClosingOvertype:ke(new n(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(205,null),""],description:m.localize(206,null)})),autoClosingQuotes:ke(new n(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(207,null),m.localize(208,null),""],description:m.localize(209,null)})),autoIndent:ke(new t(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[m.localize(210,null),m.localize(211,null),m.localize(212,null),m.localize(213,null),m.localize(214,null)],description:m.localize(215,null)})),automaticLayout:ke(new s(12,"automaticLayout",!1)),autoSurround:ke(new n(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(216,null),m.localize(217,null),m.localize(218,null),""],description:m.localize(219,null)})),bracketPairColorization:ke(new pe),bracketPairGuides:ke(new se),stickyTabStops:ke(new s(114,"stickyTabStops",!1,{description:m.localize(220,null)})),codeLens:ke(new s(16,"codeLens",!0,{description:m.localize(221,null)})),codeLensFontFamily:ke(new i(17,"codeLensFontFamily","",{description:m.localize(222,null)})),codeLensFontSize:ke(new f(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(223,null)})),colorDecorators:ke(new s(19,"colorDecorators",!0,{description:m.localize(224,null)})),colorDecoratorActivatedOn:ke(new n(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(225,null),m.localize(226,null),m.localize(227,null)],description:m.localize(228,null)})),colorDecoratorsLimit:ke(new f(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(229,null)})),columnSelection:ke(new s(21,"columnSelection",!1,{description:m.localize(230,null)})),comments:ke(new u),contextmenu:ke(new s(23,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new s(24,"copyWithSyntaxHighlighting",!0,{description:m.localize(231,null)})),cursorBlinking:ke(new t(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:m.localize(232,null)})),cursorSmoothCaretAnimation:ke(new n(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(233,null),m.localize(234,null),m.localize(235,null)],description:m.localize(236,null)})),cursorStyle:ke(new t(27,"cursorStyle",l.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:m.localize(237,null)})),cursorSurroundingLines:ke(new f(28,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(238,null)})),cursorSurroundingLinesStyle:ke(new n(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(239,null),m.localize(240,null)],description:m.localize(241,null)})),cursorWidth:ke(new f(30,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(242,null)})),disableLayerHinting:ke(new s(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new s(32,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new s(33,"domReadOnly",!1)),dragAndDrop:ke(new s(34,"dragAndDrop",!0,{description:m.localize(243,null)})),emptySelectionClipboard:ke(new N),dropIntoEditor:ke(new et),stickyScroll:ke(new re),experimentalWhitespaceRendering:ke(new n(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),extraEditorClassName:ke(new i(38,"extraEditorClassName","")),fastScrollSensitivity:ke(new C(39,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:m.localize(248,null)})),find:ke(new T),fixedOverflowWidgets:ke(new s(41,"fixedOverflowWidgets",!1)),folding:ke(new s(42,"folding",!0,{description:m.localize(249,null)})),foldingStrategy:ke(new n(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],description:m.localize(252,null)})),foldingHighlight:ke(new s(44,"foldingHighlight",!0,{description:m.localize(253,null)})),foldingImportsByDefault:ke(new s(45,"foldingImportsByDefault",!1,{description:m.localize(254,null)})),foldingMaximumRegions:ke(new f(46,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(255,null)})),unfoldOnClickAfterEndOfLine:ke(new s(47,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(256,null)})),fontFamily:ke(new i(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(257,null)})),fontInfo:ke(new U),fontLigatures2:ke(new z),fontSize:ke(new Y),fontWeight:ke(new H),fontVariations:ke(new j),formatOnPaste:ke(new s(54,"formatOnPaste",!1,{description:m.localize(258,null)})),formatOnType:ke(new s(55,"formatOnType",!1,{description:m.localize(259,null)})),glyphMargin:ke(new s(56,"glyphMargin",!0,{description:m.localize(260,null)})),gotoLocation:ke(new ge),hideCursorInOverviewRuler:ke(new s(58,"hideCursorInOverviewRuler",!1,{description:m.localize(261,null)})),hover:ke(new ie),inDiffEditor:ke(new s(60,"inDiffEditor",!1)),letterSpacing:ke(new C(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>C.clamp(Q,-5,20),{description:m.localize(262,null)})),lightbulb:ke(new ce),lineDecorationsWidth:ke(new de),lineHeight:ke(new B),lineNumbers:ke(new ue),lineNumbersMinChars:ke(new f(67,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new s(68,"linkedEditing",!1,{description:m.localize(263,null)})),links:ke(new s(69,"links",!0,{description:m.localize(264,null)})),matchBrackets:ke(new n(70,"matchBrackets","always",["always","near","never"],{description:m.localize(265,null)})),minimap:ke(new _),mouseStyle:ke(new n(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new C(73,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:m.localize(266,null)})),mouseWheelZoom:ke(new s(74,"mouseWheelZoom",!1,{markdownDescription:m.localize(267,null)})),multiCursorMergeOverlapping:ke(new s(75,"multiCursorMergeOverlapping",!0,{description:m.localize(268,null)})),multiCursorModifier:ke(new t(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ee,{markdownEnumDescriptions:[m.localize(269,null),m.localize(270,null)],markdownDescription:m.localize(271,null)})),multiCursorPaste:ke(new n(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(272,null),m.localize(273,null)],markdownDescription:m.localize(274,null)})),multiCursorLimit:ke(new f(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(275,null)})),occurrencesHighlight:ke(new s(79,"occurrencesHighlight",!0,{description:m.localize(276,null)})),overviewRulerBorder:ke(new s(80,"overviewRulerBorder",!0,{description:m.localize(277,null)})),overviewRulerLanes:ke(new f(81,"overviewRulerLanes",3,0,3)),padding:ke(new Re),pasteAs:ke(new Ze),parameterHints:ke(new ne),peekWidgetDefaultFocus:ke(new n(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(278,null),m.localize(279,null)],description:m.localize(280,null)})),definitionLinkOpensInPeek:ke(new s(86,"definitionLinkOpensInPeek",!1,{description:m.localize(281,null)})),quickSuggestions:ke(new he),quickSuggestionsDelay:ke(new f(88,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(282,null)})),readOnly:ke(new s(89,"readOnly",!1)),readOnlyMessage:ke(new we),renameOnType:ke(new s(91,"renameOnType",!1,{description:m.localize(283,null),markdownDeprecationMessage:m.localize(284,null)})),renderControlCharacters:ke(new s(92,"renderControlCharacters",!0,{description:m.localize(285,null),restricted:!0})),renderFinalNewline:ke(new n(93,"renderFinalNewline",h.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(286,null)})),renderLineHighlight:ke(new n(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(287,null)],description:m.localize(288,null)})),renderLineHighlightOnlyWhenFocus:ke(new s(95,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(289,null)})),renderValidationDecorations:ke(new n(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new n(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(290,null),m.localize(291,null),m.localize(292,null),""],description:m.localize(293,null)})),revealHorizontalRightPadding:ke(new f(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:ke(new s(99,"roundedSelection",!0,{description:m.localize(294,null)})),rulers:ke(new le),scrollbar:ke(new K),scrollBeyondLastColumn:ke(new f(102,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(295,null)})),scrollBeyondLastLine:ke(new s(103,"scrollBeyondLastLine",!0,{description:m.localize(296,null)})),scrollPredominantAxis:ke(new s(104,"scrollPredominantAxis",!0,{description:m.localize(297,null)})),selectionClipboard:ke(new s(105,"selectionClipboard",!0,{description:m.localize(298,null),included:h.$k})),selectionHighlight:ke(new s(106,"selectionHighlight",!0,{description:m.localize(299,null)})),selectOnLineNumbers:ke(new s(107,"selectOnLineNumbers",!0)),showFoldingControls:ke(new n(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(300,null),m.localize(301,null),m.localize(302,null)],description:m.localize(303,null)})),showUnused:ke(new s(109,"showUnused",!0,{description:m.localize(304,null)})),showDeprecated:ke(new s(137,"showDeprecated",!0,{description:m.localize(305,null)})),inlayHints:ke(new fe),snippetSuggestions:ke(new n(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(306,null),m.localize(307,null),m.localize(308,null),m.localize(309,null)],description:m.localize(310,null)})),smartSelect:ke(new Ue),smoothScrolling:ke(new s(112,"smoothScrolling",!1,{description:m.localize(311,null)})),stopRenderingLineAfter:ke(new f(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new Ie),inlineSuggest:ke(new x),suggestFontSize:ke(new f(117,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(312,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new f(118,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(313,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new s(119,"suggestOnTriggerCharacters",!0,{description:m.localize(314,null)})),suggestSelection:ke(new n(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(315,null),m.localize(316,null),m.localize(317,null)],description:m.localize(318,null)})),tabCompletion:ke(new n(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(319,null),m.localize(320,null),m.localize(321,null)],description:m.localize(322,null)})),tabIndex:ke(new f(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new G),unusualLineTerminators:ke(new n(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(323,null),m.localize(324,null),m.localize(325,null)],description:m.localize(326,null)})),useShadowDOM:ke(new s(125,"useShadowDOM",!0)),useTabStops:ke(new s(126,"useTabStops",!0,{description:m.localize(327,null)})),wordBreak:ke(new n(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(328,null),m.localize(329,null)],description:m.localize(330,null)})),wordSeparators:ke(new i(128,"wordSeparators",A.$Gr,{description:m.localize(331,null)})),wordWrap:ke(new n(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(332,null),m.localize(333,null),m.localize(334,null),m.localize(335,null)],description:m.localize(336,null)})),wordWrapBreakAfterCharacters:ke(new i(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new i(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new f(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(337,null)})),wordWrapOverride1:ke(new n(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new n(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:ke(new M),defaultColorDecorators:ke(new s(144,"defaultColorDecorators",!1,{markdownDescription:m.localize(338,null)})),pixelRatio:ke(new ee),tabFocusMode:ke(new s(141,"tabFocusMode",!1,{markdownDescription:m.localize(339,null)})),layoutInfo:ke(new q),wrappingInfo:ke(new Ge),wrappingIndent:ke(new xe),wrappingStrategy:ke(new V)}}),define(De[179],Ce([9,10]),function(me,e){return me.create("vs/editor/common/languages",e)}),define(De[77],Ce([1,0,72,2,157,33,167,179]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$us=e.$ts=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$ss=e.$rs=e.SymbolKinds=e.SymbolTag=e.$qs=e.$ps=e.SymbolKind=e.$os=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$ns=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$ms=e.$ls=e.$ks=void 0;class E{constructor(z,j,U){this.offset=z,this.type=j,this.language=U,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$ks=E;class b{constructor(z,j){this.tokens=z,this.endState=j,this._tokenizationResultBrand=void 0}}e.$ls=b;class R{constructor(z,j){this.tokens=z,this.endState=j,this._encodedTokenizationResultBrand=void 0}}e.$ms=R;var I;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(I||(e.CompletionItemKind=I={}));var $;(function(T){const z=new Map;z.set(0,k.$Aj.symbolMethod),z.set(1,k.$Aj.symbolFunction),z.set(2,k.$Aj.symbolConstructor),z.set(3,k.$Aj.symbolField),z.set(4,k.$Aj.symbolVariable),z.set(5,k.$Aj.symbolClass),z.set(6,k.$Aj.symbolStruct),z.set(7,k.$Aj.symbolInterface),z.set(8,k.$Aj.symbolModule),z.set(9,k.$Aj.symbolProperty),z.set(10,k.$Aj.symbolEvent),z.set(11,k.$Aj.symbolOperator),z.set(12,k.$Aj.symbolUnit),z.set(13,k.$Aj.symbolValue),z.set(15,k.$Aj.symbolEnum),z.set(14,k.$Aj.symbolConstant),z.set(15,k.$Aj.symbolEnum),z.set(16,k.$Aj.symbolEnumMember),z.set(17,k.$Aj.symbolKeyword),z.set(27,k.$Aj.symbolSnippet),z.set(18,k.$Aj.symbolText),z.set(19,k.$Aj.symbolColor),z.set(20,k.$Aj.symbolFile),z.set(21,k.$Aj.symbolReference),z.set(22,k.$Aj.symbolCustomColor),z.set(23,k.$Aj.symbolFolder),z.set(24,k.$Aj.symbolTypeParameter),z.set(25,k.$Aj.account),z.set(26,k.$Aj.issues);function j(H){let ge=z.get(H);return ge||(console.info("No codicon found for CompletionItemKind "+H),ge=k.$Aj.symbolProperty),ge}T.toIcon=j;const U=new Map;U.set("method",0),U.set("function",1),U.set("constructor",2),U.set("field",3),U.set("variable",4),U.set("class",5),U.set("struct",6),U.set("interface",7),U.set("module",8),U.set("property",9),U.set("event",10),U.set("operator",11),U.set("unit",12),U.set("value",13),U.set("constant",14),U.set("enum",15),U.set("enum-member",16),U.set("enumMember",16),U.set("keyword",17),U.set("snippet",27),U.set("text",18),U.set("color",19),U.set("file",20),U.set("reference",21),U.set("customcolor",22),U.set("folder",23),U.set("type-parameter",24),U.set("typeParameter",24),U.set("account",25),U.set("issue",26);function Y(H,ge){let ie=U.get(H);return typeof ie>"u"&&!ge&&(ie=9),ie}T.fromString=Y})($||(e.CompletionItemKinds=$={}));var S;(function(T){T[T.Deprecated=1]="Deprecated"})(S||(e.CompletionItemTag=S={}));var D;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(D||(e.CompletionItemInsertTextRule=D={}));var p;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(p||(e.CompletionTriggerKind=p={}));var r;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(r||(e.InlineCompletionTriggerKind=r={}));class s{constructor(z,j,U,Y){this.range=z,this.text=j,this.completionKind=U,this.isSnippetText=Y}equals(z){return L.$Mr.lift(this.range).equalsRange(z.range)&&this.text===z.text&&this.completionKind===z.completionKind&&this.isSnippetText===z.isSnippetText}}e.$ns=s;var c;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(c||(e.CodeActionTriggerType=c={}));var f;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(f||(e.SignatureHelpTriggerKind=f={}));var y;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(y||(e.DocumentHighlightKind=y={}));function C(T){return T&&F.URI.isUri(T.uri)&&L.$Mr.isIRange(T.range)&&(L.$Mr.isIRange(T.originSelectionRange)||L.$Mr.isIRange(T.targetSelectionRange))}e.$os=C;var i;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(i||(e.SymbolKind=i={})),e.$ps={[17]:(0,m.localize)(0,null),[16]:(0,m.localize)(1,null),[4]:(0,m.localize)(2,null),[13]:(0,m.localize)(3,null),[8]:(0,m.localize)(4,null),[9]:(0,m.localize)(5,null),[21]:(0,m.localize)(6,null),[23]:(0,m.localize)(7,null),[7]:(0,m.localize)(8,null),[0]:(0,m.localize)(9,null),[11]:(0,m.localize)(10,null),[10]:(0,m.localize)(11,null),[19]:(0,m.localize)(12,null),[5]:(0,m.localize)(13,null),[1]:(0,m.localize)(14,null),[2]:(0,m.localize)(15,null),[20]:(0,m.localize)(16,null),[15]:(0,m.localize)(17,null),[18]:(0,m.localize)(18,null),[24]:(0,m.localize)(19,null),[3]:(0,m.localize)(20,null),[6]:(0,m.localize)(21,null),[14]:(0,m.localize)(22,null),[22]:(0,m.localize)(23,null),[25]:(0,m.localize)(24,null),[12]:(0,m.localize)(25,null)};function a(T,z){return(0,m.localize)(26,null,T,e.$ps[z])}e.$qs=a;var n;(function(T){T[T.Deprecated=1]="Deprecated"})(n||(e.SymbolTag=n={}));var t;(function(T){const z=new Map;z.set(0,k.$Aj.symbolFile),z.set(1,k.$Aj.symbolModule),z.set(2,k.$Aj.symbolNamespace),z.set(3,k.$Aj.symbolPackage),z.set(4,k.$Aj.symbolClass),z.set(5,k.$Aj.symbolMethod),z.set(6,k.$Aj.symbolProperty),z.set(7,k.$Aj.symbolField),z.set(8,k.$Aj.symbolConstructor),z.set(9,k.$Aj.symbolEnum),z.set(10,k.$Aj.symbolInterface),z.set(11,k.$Aj.symbolFunction),z.set(12,k.$Aj.symbolVariable),z.set(13,k.$Aj.symbolConstant),z.set(14,k.$Aj.symbolString),z.set(15,k.$Aj.symbolNumber),z.set(16,k.$Aj.symbolBoolean),z.set(17,k.$Aj.symbolArray),z.set(18,k.$Aj.symbolObject),z.set(19,k.$Aj.symbolKey),z.set(20,k.$Aj.symbolNull),z.set(21,k.$Aj.symbolEnumMember),z.set(22,k.$Aj.symbolStruct),z.set(23,k.$Aj.symbolEvent),z.set(24,k.$Aj.symbolOperator),z.set(25,k.$Aj.symbolTypeParameter);function j(U){let Y=z.get(U);return Y||(console.info("No codicon found for SymbolKind "+U),Y=k.$Aj.symbolProperty),Y}T.toIcon=j})(t||(e.SymbolKinds=t={}));class o{static asEditOperation(z){return h.$Tr.replace(L.$Mr.lift(z.range),z.text)}}e.$rs=o;class g{static{this.Comment=new g("comment")}static{this.Imports=new g("imports")}static{this.Region=new g("region")}static fromValue(z){switch(z){case"comment":return g.Comment;case"imports":return g.Imports;case"region":return g.Region}return new g(z)}constructor(z){this.value=z}}e.$ss=g;var u;(function(T){function z(j){return!j||typeof j!="object"?!1:typeof j.id=="string"&&typeof j.title=="string"}T.is=z})(u||(e.Command=u={}));var d;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(d||(e.CommentThreadCollapsibleState=d={}));var v;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(v||(e.CommentThreadState=v={}));var l;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(l||(e.CommentMode=l={}));var w;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(w||(e.CommentState=w={}));var P;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class M{constructor(z){this.b=z,this.a=null}dispose(){this.a&&this.a.then(z=>{z&&z.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$ts=M,e.$us=new A.$cs;var N;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(N||(e.ExternalUriOpenerPriority=N={}))}),define(De[180],Ce([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[181],Ce([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(De[182],Ce([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(De[183],Ce([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[184],Ce([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[185],Ce([9,10]),function(me,e){return me.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(De[186],Ce([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(De[187],Ce([9,10]),function(me,e){return me.create("vs/platform/files/common/io",e)}),define(De[188],Ce([9,10]),function(me,e){return me.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(De[189],Ce([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(De[190],Ce([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(De[191],Ce([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(De[192],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChat",e)}),define(De[193],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[194],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[195],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(De[196],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(De[197],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(De[198],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostProgress",e)}),define(De[199],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[200],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(De[201],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[202],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[203],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(De[204],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[205],Ce([9,10]),function(me,e){return me.create("vs/workbench/api/node/extHostDebugService",e)}),define(De[206],Ce([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(De[207],Ce([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(De[208],Ce([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[209],Ce([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[210],Ce([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(De[211],Ce([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[212],Ce([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[213],Ce([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[214],Ce([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[215],Ce([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[216],Ce([1,0,8,182]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.TokenType=void 0;var h;(function(b){b[b.LParen=0]="LParen",b[b.RParen=1]="RParen",b[b.Neg=2]="Neg",b[b.Eq=3]="Eq",b[b.NotEq=4]="NotEq",b[b.Lt=5]="Lt",b[b.LtEq=6]="LtEq",b[b.Gt=7]="Gt",b[b.GtEq=8]="GtEq",b[b.RegexOp=9]="RegexOp",b[b.RegexStr=10]="RegexStr",b[b.True=11]="True",b[b.False=12]="False",b[b.In=13]="In",b[b.Not=14]="Not",b[b.And=15]="And",b[b.Or=16]="Or",b[b.Str=17]="Str",b[b.QuotedStr=18]="QuotedStr",b[b.Error=19]="Error",b[b.EOF=20]="EOF"})(h||(e.TokenType=h={}));function L(...b){switch(b.length){case 1:return(0,F.localize)(0,null,b[0]);case 2:return(0,F.localize)(1,null,b[0],b[1]);case 3:return(0,F.localize)(2,null,b[0],b[1],b[2]);default:return}}const A=(0,F.localize)(3,null),m=(0,F.localize)(4,null);class E{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,k.$6)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const I=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:I})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const I=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:I})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const I=this.d,$=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:$};this.g.push({offset:I,lexeme:$,additionalInfo:R}),this.f.push(S)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const I=this.c.substring(this.d,this.e),$=E.b.get(I);$?this.k($):this.f.push({type:17,lexeme:I,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,I=!1,$=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(m);return}const D=this.c.charCodeAt(R);if(I)I=!1;else if(D===47&&!$){R++;break}else D===91?$=!0:D===92?I=!0:D===93&&($=!1);R++}for(;R<this.c.length&&E.a.has(this.c.charCodeAt(R));)R++;this.e=R;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.$qi=E}),define(De[217],Ce([1,0,24,40,184,351]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function E(s){return s=s.trim(),s==="*"||A.test(s)}e.$po=E;function b(s){if(!E(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=s.match(A);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.$qo=b;function R(s){if(!s)return null;const c=s.majorBase,f=s.majorMustEqual,y=s.minorBase;let C=s.minorMustEqual;const i=s.patchBase;let a=s.patchMustEqual;s.hasCaret&&(c===0||(C=!1),a=!1);let n=0;if(s.preRelease){const t=m.exec(s.preRelease);if(t){const[,o,g,u]=t;n=Date.UTC(Number(o),Number(g)-1,Number(u))}}return{majorBase:c,majorMustEqual:f,minorBase:y,minorMustEqual:C,patchBase:i,patchMustEqual:a,isMinimum:s.hasGreaterEquals,notBefore:n}}e.$ro=R;function I(s,c,f){let y;typeof s=="string"?y=R(b(s)):y=s;let C;c instanceof Date?C=c.getTime():typeof c=="string"&&(C=new Date(c).getTime());let i;if(typeof f=="string"?i=R(b(f)):i=f,!y||!i)return!1;const a=y.majorBase,n=y.minorBase,t=y.patchBase;let o=i.majorBase,g=i.minorBase,u=i.patchBase;const d=i.notBefore;let v=i.majorMustEqual,l=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?a>o?!0:a<o?!1:n>g?!0:n<g||C&&C<d?!1:t>=u:(a===1&&o===0&&(!v||!l||!w)&&(o=1,g=0,u=0,v=!0,l=!1,w=!1),a<o?!1:a>o?!v:n<g?!1:n>g?!l:t<u?!1:t>u?!w:!(C&&C<d))}e.$so=I;function $(s,c,f,y,C){const i=[];if(typeof y.publisher<"u"&&typeof y.publisher!="string")return i.push([F.default.Error,h.localize(0,null)]),i;if(typeof y.name!="string")return i.push([F.default.Error,h.localize(1,null,"name")]),i;if(typeof y.version!="string")return i.push([F.default.Error,h.localize(2,null,"version")]),i;if(!y.engines)return i.push([F.default.Error,h.localize(3,null,"engines")]),i;if(typeof y.engines.vscode!="string")return i.push([F.default.Error,h.localize(4,null,"engines.vscode")]),i;if(typeof y.extensionDependencies<"u"&&!r(y.extensionDependencies))return i.push([F.default.Error,h.localize(5,null,"extensionDependencies")]),i;if(typeof y.activationEvents<"u"){if(!r(y.activationEvents))return i.push([F.default.Error,h.localize(6,null,"activationEvents")]),i;if(typeof y.main>"u"&&typeof y.browser>"u")return i.push([F.default.Error,h.localize(7,null,"activationEvents","main","browser")]),i}if(typeof y.extensionKind<"u"&&typeof y.main>"u"&&i.push([F.default.Warning,h.localize(8,null,"extensionKind")]),typeof y.main<"u"){if(typeof y.main!="string")return i.push([F.default.Error,h.localize(9,null,"main")]),i;{const t=(0,k.$8f)(f,y.main);(0,k.$2f)(t,f)||i.push([F.default.Warning,h.localize(10,null,t.path,f.path)])}}if(typeof y.browser<"u"){if(typeof y.browser!="string")return i.push([F.default.Error,h.localize(11,null,"browser")]),i;{const t=(0,k.$8f)(f,y.browser);(0,k.$2f)(t,f)||i.push([F.default.Warning,h.localize(12,null,t.path,f.path)])}}if(!L.valid(y.version))return i.push([F.default.Error,h.localize(13,null)]),i;const a=[];if(!S(s,c,y,C,a))for(const t of a)i.push([F.default.Error,t]);return i}e.$to=$;function S(s,c,f,y,C){return y||typeof f.main>"u"&&typeof f.browser>"u"?!0:p(s,c,f.engines.vscode,C)}e.$uo=S;function D(s,c,f){return s==="*"||p(c,f,s)}e.$vo=D;function p(s,c,f,y=[]){const C=R(b(f));if(!C)return y.push(h.localize(14,null,f)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return y.push(h.localize(15,null,f)),!1}else if(!C.majorMustEqual)return y.push(h.localize(16,null,f)),!1;return I(s,c,C)?!0:(y.push(h.localize(17,null,s,f)),!1)}function r(s){if(!Array.isArray(s))return!1;for(let c=0,f=s.length;c<f;c++)if(typeof s[c]!="string")return!1;return!0}}),define(De[97],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=void 0;class k{constructor(h,L=[],A=!1){this.ctor=h,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.$kh=k}),define(De[98],Ce([1,0,97]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.InstantiationType=void 0;const F=[];var h;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(h||(e.InstantiationType=h={}));function L(m,E,b){E instanceof k.$kh||(E=new k.$kh(E,[],!!b)),F.push([m,E])}e.$0q=L;function A(){return F}e.$$q=A}),define(De[218],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;class k{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Qp=k;class F{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const m=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(A);m.outgoing.set(E.key,E),E.incoming.set(m.key,m)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let m=this.a.get(A);return m||(m=new k(A,L),this.a.set(A,m)),m}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,m]of this.a)L.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const m=new Set([L]),E=this.c(A,m);if(E)return E}}c(L,A){for(const[m,E]of L.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const b=this.c(E,A);if(b)return b;A.delete(m)}}}e.$Rp=F}),define(De[5],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e._util=void 0;var k;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(E){return E[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(k||(e._util=k={})),e.$mh=h("instantiationService");function F(A,m,E){m[k.DI_TARGET]===m?m[k.DI_DEPENDENCIES].push({id:A,index:E}):(m[k.DI_DEPENDENCIES]=[{id:A,index:E}],m[k.DI_TARGET]=m)}function h(A){if(k.serviceIds.has(A))return k.serviceIds.get(A);const m=function(E,b,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(m,E,R)};return m.toString=()=>A,k.serviceIds.set(A,m),m}e.$nh=h;function L(A){return A}e.$oh=L}),define(De[57],Ce([1,0,14,2,5]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.ConfigurationTarget=e.$Vh=e.$Uh=e.$Th=void 0,e.$Th=(0,h.$nh)("configurationService");function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof F.URI)}e.$Uh=L;function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof F.URI)}e.$Vh=A;var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function E(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Wh=E;function b(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$Xh=b;function R(s,c){const f=Object.create(null);for(const y in s)I(f,y,s[y],c);return f}e.$Yh=R;function I(s,c,f,y){const C=c.split("."),i=C.pop();let a=s;for(let n=0;n<C.length;n++){const t=C[n];let o=a[t];switch(typeof o){case"undefined":o=a[t]=Object.create(null);break;case"object":break;default:y(`Ignoring ${c} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(o)}`);return}a=o}if(typeof a=="object"&&a!==null)try{a[i]=f}catch{y(`Ignoring ${c} as ${C.join(".")} is ${JSON.stringify(a)}`)}else y(`Ignoring ${c} as ${C.join(".")} is ${JSON.stringify(a)}`)}e.$Zh=I;function $(s,c){const f=c.split(".");S(s,f)}e.$1h=$;function S(s,c){const f=c.shift();if(c.length===0){delete s[f];return}if(Object.keys(s).indexOf(f)!==-1){const y=s[f];typeof y=="object"&&!Array.isArray(y)&&(S(y,c),Object.keys(y).length===0&&delete s[f])}}function D(s,c,f){function y(a,n){let t=a;for(const o of n){if(typeof t!="object"||t===null)return;t=t[o]}return t}const C=c.split("."),i=y(s,C);return typeof i>"u"?f:i}e.$2h=D;function p(s,c,f){Object.keys(c).forEach(y=>{y!=="__proto__"&&(y in s?k.$ke(s[y])&&k.$ke(c[y])?p(s[y],c[y],f):f&&(s[y]=c[y]):s[y]=c[y])})}e.$3h=p;function r(s){return s.replace(/[\[\]]/g,"")}e.$4h=r}),define(De[47],Ce([1,0,11,12,216,5,181,8]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ContextKeyExprType=e.$ri=void 0;const E=new Map;E.set("false",!1),E.set("true",!0),E.set("isMac",k.$j),E.set("isLinux",k.$k),E.set("isWindows",k.$i),E.set("isWeb",k.$o),E.set("isMacNative",k.$j&&!k.$o),E.set("isEdge",k.$G),E.set("isFirefox",k.$E),E.set("isChrome",k.$D),E.set("isSafari",k.$F);function b(de,B){if(E.get(de)!==void 0)throw(0,m.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");E.set(de,B)}e.$ri=b;const R=Object.prototype.hasOwnProperty;var I;(function(de){de[de.False=0]="False",de[de.True=1]="True",de[de.Defined=2]="Defined",de[de.Not=3]="Not",de[de.Equals=4]="Equals",de[de.NotEquals=5]="NotEquals",de[de.And=6]="And",de[de.Regex=7]="Regex",de[de.NotRegex=8]="NotRegex",de[de.Or=9]="Or",de[de.In=10]="In",de[de.NotIn=11]="NotIn",de[de.Greater=12]="Greater",de[de.GreaterEquals=13]="GreaterEquals",de[de.Smaller=14]="Smaller",de[de.SmallerEquals=15]="SmallerEquals"})(I||(e.ContextKeyExprType=I={}));const $={regexParsingWithErrorRecovery:!0},S=(0,A.localize)(0,null),D=(0,A.localize)(1,null),p=(0,A.localize)(2,null),r=(0,A.localize)(3,null),s=(0,A.localize)(4,null),c=(0,A.localize)(5,null),f=(0,A.localize)(6,null),y=(0,A.localize)(7,null);class C{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=$){this.k=B,this.d=new h.$qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:D});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const Ee=this.D(),Re=Ee.type===17?c:void 0;throw this.h.push({message:s,offset:Ee.offset,lexeme:h.$qi.getLexeme(Ee),additionalInfo:Re}),C.c}return _}catch(_){if(_!==C.c)throw _;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const _=this.o();B.push(_)}return B.length===1?B[0]:i.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const _=this.s();B.push(_)}return B.length===1?B[0]:i.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),g.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,r),_?.negate()}case 17:return this.z(),P.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const _=this.l();return this.A(1,r),_}case 17:{const _=B.lexeme;if(this.z(),this.y(9)){const Re=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Re.type!==10)throw this.B("REGEX",Re);const ne=Re.lexeme,ee=ne.lastIndexOf("/"),he=ee===ne.length-1?void 0:this.w(ne.substring(ee+1));let X;try{X=new RegExp(ne.substring(1,ee),he)}catch{throw this.B("REGEX",Re)}return U.create(_,X)}switch(Re.type){case 10:case 19:{const ne=[Re.lexeme];this.z();let ee=this.D(),he=0;for(let we=0;we<Re.lexeme.length;we++)Re.lexeme.charCodeAt(we)===40?he++:Re.lexeme.charCodeAt(we)===41&&he--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:he++;break;case 1:he--;break;case 10:case 18:for(let we=0;we<ee.lexeme.length;we++)ee.lexeme.charCodeAt(we)===40?he++:Re.lexeme.charCodeAt(we)===41&&he--}if(he<0)break;ne.push(h.$qi.getLexeme(ee)),this.z(),ee=this.D()}const X=ne.join(""),ue=X.lastIndexOf("/"),oe=ue===X.length-1?void 0:this.w(X.substring(ue+1));let le;try{le=new RegExp(X.substring(1,ue),oe)}catch{throw this.B("REGEX",Re)}return i.regex(_,le)}case 18:{const ne=Re.lexeme;this.z();let ee=null;if(!(0,F.$jd)(ne)){const he=ne.indexOf("/"),X=ne.lastIndexOf("/");if(he!==X&&he>=0){const ue=ne.slice(he+1,X),oe=ne[X+1]==="i"?"i":"";try{ee=new RegExp(ue,oe)}catch{throw this.B("REGEX",Re)}}}if(ee===null)throw this.B("REGEX",Re);return U.create(_,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,p);const Re=this.u();return i.notIn(_,Re)}switch(this.D().type){case 3:{this.z();const Re=this.u();if(this.x().type===18)return i.equals(_,Re);switch(Re){case"true":return i.has(_);case"false":return i.not(_);default:return i.equals(_,Re)}}case 4:{this.z();const Re=this.u();if(this.x().type===18)return i.notEquals(_,Re);switch(Re){case"true":return i.not(_);case"false":return i.has(_);default:return i.notEquals(_,Re)}}case 5:return this.z(),z.create(_,this.u());case 6:return this.z(),j.create(_,this.u());case 7:return this.z(),N.create(_,this.u());case 8:return this.z(),T.create(_,this.u());case 13:return this.z(),i.in(_,this.u());default:return i.has(_)}}case 20:throw this.h.push({message:f,offset:B.offset,lexeme:"",additionalInfo:y}),C.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,_){if(this.C(B))return this.z();throw this.B(_,this.D())}B(B,_,Ee){const Re=(0,A.localize)(8,null,B,h.$qi.getLexeme(_)),ne=_.offset,ee=h.$qi.getLexeme(_);return this.h.push({message:Re,offset:ne,lexeme:ee,additionalInfo:Ee}),C.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$si=C;class i{static false(){return o.INSTANCE}static true(){return g.INSTANCE}static has(B){return u.create(B)}static equals(B,_){return d.create(B,_)}static notEquals(B,_){return w.create(B,_)}static regex(B,_){return U.create(B,_)}static in(B,_){return v.create(B,_)}static notIn(B,_){return l.create(B,_)}static not(B){return P.create(B)}static and(...B){return ge.create(B,null,!0)}static or(...B){return ie.create(B,null,!0)}static greater(B,_){return N.create(B,_)}static greaterEquals(B,_){return T.create(B,_)}static smaller(B,_){return z.create(B,_)}static smallerEquals(B,_){return j.create(B,_)}static{this.c=new C({regexParsingWithErrorRecovery:!1})}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.$ti=i;function a(de){const B=new C({regexParsingWithErrorRecovery:!1});return de.map(_=>(B.parse(_),B.lexingErrors.length>0?B.lexingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?(0,A.localize)(9,null,Ee.additionalInfo):(0,A.localize)(10,null),offset:Ee.offset,length:Ee.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(Ee=>({errorMessage:Ee.additionalInfo?`${Ee.message}. ${Ee.additionalInfo}`:Ee.message,offset:Ee.offset,length:Ee.lexeme.length})):[]))}e.$ui=a;function n(de,B){const _=de?de.substituteConstants():void 0,Ee=B?B.substituteConstants():void 0;return!_&&!Ee?!0:!_||!Ee?!1:_.equals(Ee)}e.$vi=n;function t(de,B){return de.cmp(B)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return g.INSTANCE}}e.$wi=o;class g{static{this.INSTANCE=new g}constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return o.INSTANCE}}e.$xi=g;class u{static create(B,_=null){const Ee=E.get(B);return typeof Ee=="boolean"?Ee?g.INSTANCE:o.INSTANCE:new u(B,_)}constructor(B,_){this.key=B,this.c=_,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:q(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=E.get(this.key);return typeof B=="boolean"?B?g.INSTANCE:o.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$yi=u;class d{static create(B,_,Ee=null){if(typeof _=="boolean")return _?u.create(B,Ee):P.create(B,Ee);const Re=E.get(B);return typeof Re=="boolean"?_===(Re?"true":"false")?g.INSTANCE:o.INSTANCE:new d(B,_,Ee)}constructor(B,_,Ee){this.c=B,this.d=_,this.f=Ee,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:V(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?g.INSTANCE:o.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$zi=d;class v{static create(B,_){return new v(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:V(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.f),Ee=B.getValue(this.d);return Array.isArray(_)?_.includes(Ee):typeof Ee=="string"&&typeof _=="object"&&_!==null?R.call(_,Ee):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=l.create(this.d,this.f)),this.c}}e.$Ai=v;class l{static create(B,_){return new l(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=11,this.c=v.create(B,_)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Bi=l;class w{static create(B,_,Ee=null){if(typeof _=="boolean")return _?P.create(B,Ee):u.create(B,Ee);const Re=E.get(B);return typeof Re=="boolean"?_===(Re?"true":"false")?o.INSTANCE:g.INSTANCE:new w(B,_,Ee)}constructor(B,_,Ee){this.c=B,this.d=_,this.f=Ee,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:V(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=E.get(this.c);if(typeof B=="boolean"){const _=B?"true":"false";return this.d===_?o.INSTANCE:g.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=d.create(this.c,this.d,this)),this.f}}e.$Ci=w;class P{static create(B,_=null){const Ee=E.get(B);return typeof Ee=="boolean"?Ee?o.INSTANCE:g.INSTANCE:new P(B,_)}constructor(B,_){this.c=B,this.d=_,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:q(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=E.get(this.c);return typeof B=="boolean"?B?o.INSTANCE:g.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Di=P;function M(de,B){if(typeof de=="string"){const _=parseFloat(de);isNaN(_)||(de=_)}return typeof de=="string"||typeof de=="number"?B(de):o.INSTANCE}class N{static create(B,_,Ee=null){return M(_,Re=>new N(B,Re,Ee))}constructor(B,_,Ee){this.c=B,this.d=_,this.f=Ee,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:V(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$Ei=N;class T{static create(B,_,Ee=null){return M(_,Re=>new T(B,Re,Ee))}constructor(B,_,Ee){this.c=B,this.d=_,this.f=Ee,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:V(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Fi=T;class z{static create(B,_,Ee=null){return M(_,Re=>new z(B,Re,Ee))}constructor(B,_,Ee){this.c=B,this.d=_,this.f=Ee,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:V(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Gi=z;class j{static create(B,_,Ee=null){return M(_,Re=>new j(B,Re,Ee))}constructor(B,_,Ee){this.c=B,this.d=_,this.f=Ee,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:V(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=N.create(this.c,this.d,this)),this.f}}e.$Hi=j;class U{static create(B,_){return new U(B,_)}constructor(B,_){this.d=B,this.f=_,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const _=this.f?this.f.source:"",Ee=B.f?B.f.source:"";return _<Ee?-1:_>Ee?1:0}equals(B){if(B.type===this.type){const _=this.f?this.f.source:"",Ee=B.f?B.f.source:"";return this.d===B.d&&_===Ee}return!1}substituteConstants(){return this}evaluate(B){const _=B.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Y.create(this)),this.c}}e.$Ii=U;class Y{static create(B){return new Y(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new Y(this.c.map(B))}negate(){return this.c}}e.$Ji=Y;function H(de){let B=null;for(let _=0,Ee=de.length;_<Ee;_++){const Re=de[_].substituteConstants();if(de[_]!==Re&&B===null){B=[];for(let ne=0;ne<_;ne++)B[ne]=de[ne]}B!==null&&(B[_]=Re)}return B===null?de:B}class ge{static create(B,_,Ee){return ge.d(B,_,Ee)}constructor(B,_){this.expr=B,this.c=_,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,Ee=this.expr.length;_<Ee;_++){const Re=t(this.expr[_],B.expr[_]);if(Re!==0)return Re}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,Ee=this.expr.length;_<Ee;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=H(this.expr);return B===this.expr?this:ge.create(B,this.c,!1)}evaluate(B){for(let _=0,Ee=this.expr.length;_<Ee;_++)if(!this.expr[_].evaluate(B))return!1;return!0}static d(B,_,Ee){const Re=[];let ne=!1;for(const ee of B)if(ee){if(ee.type===1){ne=!0;continue}if(ee.type===0)return o.INSTANCE;if(ee.type===6){Re.push(...ee.expr);continue}Re.push(ee)}if(Re.length===0&&ne)return g.INSTANCE;if(Re.length!==0){if(Re.length===1)return Re[0];Re.sort(t);for(let ee=1;ee<Re.length;ee++)Re[ee-1].equals(Re[ee])&&(Re.splice(ee,1),ee--);if(Re.length===1)return Re[0];for(;Re.length>1;){const ee=Re[Re.length-1];if(ee.type!==9)break;Re.pop();const he=Re.pop(),X=Re.length===0,ue=ie.create(ee.expr.map(oe=>ge.create([oe,he],null,Ee)),null,X);ue&&(Re.push(ue),Re.sort(t))}if(Re.length===1)return Re[0];if(Ee){for(let ee=0;ee<Re.length;ee++)for(let he=ee+1;he<Re.length;he++)if(Re[ee].negate().equals(Re[he]))return o.INSTANCE;if(Re.length===1)return Re[0]}return new ge(Re,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new ge(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());this.c=ie.create(B,this,!0)}return this.c}}e.$Ki=ge;class ie{static create(B,_,Ee){return ie.d(B,_,Ee)}constructor(B,_){this.expr=B,this.c=_,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let _=0,Ee=this.expr.length;_<Ee;_++){const Re=t(this.expr[_],B.expr[_]);if(Re!==0)return Re}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let _=0,Ee=this.expr.length;_<Ee;_++)if(!this.expr[_].equals(B.expr[_]))return!1;return!0}return!1}substituteConstants(){const B=H(this.expr);return B===this.expr?this:ie.create(B,this.c,!1)}evaluate(B){for(let _=0,Ee=this.expr.length;_<Ee;_++)if(this.expr[_].evaluate(B))return!0;return!1}static d(B,_,Ee){let Re=[],ne=!1;if(B){for(let ee=0,he=B.length;ee<he;ee++){const X=B[ee];if(X){if(X.type===0){ne=!0;continue}if(X.type===1)return g.INSTANCE;if(X.type===9){Re=Re.concat(X.expr);continue}Re.push(X)}}if(Re.length===0&&ne)return o.INSTANCE;Re.sort(t)}if(Re.length!==0){if(Re.length===1)return Re[0];for(let ee=1;ee<Re.length;ee++)Re[ee-1].equals(Re[ee])&&(Re.splice(ee,1),ee--);if(Re.length===1)return Re[0];if(Ee){for(let ee=0;ee<Re.length;ee++)for(let he=ee+1;he<Re.length;he++)if(Re[ee].negate().equals(Re[he]))return g.INSTANCE;if(Re.length===1)return Re[0]}return new ie(Re,_)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const _ of this.expr)B.push(..._.keys());return B}map(B){return new ie(this.expr.map(_=>_.map(B)),null)}negate(){if(!this.c){const B=[];for(const _ of this.expr)B.push(_.negate());for(;B.length>1;){const _=B.shift(),Ee=B.shift(),Re=[];for(const ne of fe(_))for(const ee of fe(Ee))Re.push(ge.create([ne,ee],null,!1));B.unshift(ie.create(Re,null,!1))}this.c=ie.create(B,this,!0)}return this.c}}e.$Li=ie;class te extends u{static{this.d=[]}static all(){return te.d.values()}constructor(B,_,Ee){super(B,null),this.f=_,typeof Ee=="object"?te.d.push({...Ee,key:B}):Ee!==!0&&te.d.push({key:B,description:Ee,type:_!=null?typeof _:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return d.create(this.key,B)}notEqualsTo(B){return w.create(this.key,B)}}e.$Mi=te,e.$Ni=(0,L.$nh)("contextKeyService");function q(de,B){return de<B?-1:de>B?1:0}function V(de,B,_,Ee){return de<_?-1:de>_?1:B<Ee?-1:B>Ee?1:0}function ce(de,B){if(de.type===0||B.type===1)return!0;if(de.type===9)return B.type===9?re(de.expr,B.expr):!1;if(B.type===9){for(const _ of B.expr)if(ce(de,_))return!0;return!1}if(de.type===6){if(B.type===6)return re(B.expr,de.expr);for(const _ of de.expr)if(ce(_,B))return!0;return!1}return de.equals(B)}e.$Oi=ce;function re(de,B){let _=0,Ee=0;for(;_<de.length&&Ee<B.length;){const Re=de[_].cmp(B[Ee]);if(Re<0)return!1;Re===0&&_++,Ee++}return _===de.length}function fe(de){return de.type===9?de.expr:[de]}}),define(De[219],Ce([1,0,5]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=void 0,e.$uh=(0,k.$nh)("environmentService"),e.$vh=(0,k.$oh)(e.$uh)}),define(De[125],Ce([1,0,183,5]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Nn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0,e.$Bn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Cn=new RegExp(e.$Bn),e.$Dn="__web_extension",e.$En="skipWalkthrough",e.$Fn="extensionsSync";function h(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Gn=h;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Hn=L;function A(c,f){switch(c){case 3:return f==="x64"?"win32-x64":f==="ia32"?"win32-ia32":f==="arm64"?"win32-arm64":"unknown";case 2:return f==="x64"?"linux-x64":f==="arm64"?"linux-arm64":f==="arm"?"linux-armhf":"unknown";case"alpine":return f==="x64"?"alpine-x64":f==="arm64"?"alpine-arm64":"unknown";case 1:return f==="x64"?"darwin-x64":f==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$In=A;function m(c,f){return f==="web"&&!c.includes("web")}e.$Jn=m;function E(c,f,y){return m(f,y)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===y?!0:b(y).includes(c)}e.$Kn=E;function b(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Ln=b;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.$Mn=R;var I;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(I||(e.SortBy=I={}));var $;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})($||(e.SortOrder=$={}));var S;(function(c){c.Install="install",c.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var D;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(D||(e.InstallOperation=D={})),e.$Nn=(0,F.$nh)("extensionGalleryService");var p;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var r;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class s extends Error{constructor(f,y){super(f),this.code=y,this.name=y}}e.$On=s,e.$Pn=(0,F.$nh)("extensionManagementService"),e.$Qn="extensionsIdentifiers/disabled",e.$Rn="extensionsIdentifiers/enabled",e.$Sn=(0,F.$nh)("IGlobalExtensionEnablementService"),e.$Tn=(0,F.$nh)("IExtensionTipsService"),e.$Un=(0,k.localize)(0,null),e.$Vn={value:e.$Un,original:"Extensions"},e.$Wn={value:(0,k.localize)(1,null),original:"Preferences"}}),define(De[220],Ce([1,0,5]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hVb=e.$gVb=e.$fVb=void 0,e.$fVb=(0,k.$nh)("externalTerminal"),e.$gVb="Terminal.app",e.$hVb=(0,k.$nh)("externalTerminal")}),define(De[221],Ce([1,0,46,15,13,11,94,29,96,185,220]),function(me,e,k,F,h,L,A,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R3b=e.$Q3b=e.$P3b=void 0;const I=b.localize(0,null);class ${async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends ${static{this.b="cmd.exe"}openTerminal(y,C){return this.spawnTerminal(k,y,E.$fl(),C)}spawnTerminal(y,C,i,a){const n=C.windowsExec||S.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const t=h.$ec(n,".exe").toLowerCase();if(t==="cmder")return y.spawn(n,a?[a]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return n.indexOf(" ")>=0&&o.push('""'),o.push(n),t==="wt"&&o.push("-d ."),new Promise((g,u)=>{const d=r(process),v=y.spawn(i,o,{cwd:a,env:d});v.on("error",u),v.on("exit",()=>g())})}runInTerminal(y,C,i,a,n){const t="windowsExec"in n&&n.windowsExec?n.windowsExec:S.getDefaultTerminalWindows();return new Promise((o,g)=>{const u=`"${C} - ${I}"`,d=`""${i.join('" "')}" & pause"`,v=Object.assign({},r(process),a);Object.keys(v).filter(N=>v[N]===null).forEach(N=>delete v[N]);const l={cwd:C,env:v,windowsVerbatimArguments:!0};let w,P;h.$ec(t,".exe")==="wt"?(w=t,P=["-d",".",S.b,"/c",d]):(w=S.b,P=["/c","start",u,"/wait",t,"/c",d]),k.spawn(w,P,l).on("error",N=>{g(s(N))}),o(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const y=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${y?"Sysnative":"System32"}\\cmd.exe`}return S.d}}e.$P3b=S;class D extends ${static{this.b="/usr/bin/osascript"}openTerminal(y,C){return this.spawnTerminal(k,y,C)}runInTerminal(y,C,i,a,n){const t=n.osxExec||R.$gVb;return new Promise((o,g)=>{if(t===R.$gVb||t==="iTerm.app"){const u=t===R.$gVb?"TerminalHelper":"iTermHelper",v=[F.$3e.asFileUri(`vs/workbench/contrib/externalTerminal/node/${u}.scpt`).fsPath,"-t",y||I,"-w",C];for(const P of i)v.push("-a"),v.push(P);if(a){const P=Object.assign({},r(process),a);for(const M in P){const N=P[M];N===null?(v.push("-u"),v.push(M)):(v.push("-e"),v.push(`${M}=${N}`))}}let l="";const w=k.spawn(D.b,v);w.on("error",P=>{g(s(P))}),w.stderr.on("data",P=>{l+=P.toString()}),w.on("exit",P=>{if(P===0)o(void 0);else if(l){const M=l.split(`
`,1);g(new Error(M[0]))}else g(new Error(b.localize(1,null,u,P)))})}else g(new Error(b.localize(2,null,t)))})}spawnTerminal(y,C,i){const a=C.osxExec||R.$gVb;return new Promise((n,t)=>{const o=["-a",a];i&&o.push(i);const g=r(process),u=y.spawn("/usr/bin/open",o,{cwd:i,env:g});u.on("error",t),u.on("exit",()=>n())})}}e.$Q3b=D;class p extends ${static{this.b=b.localize(3,null)}openTerminal(y,C){return this.spawnTerminal(k,y,C)}runInTerminal(y,C,i,a,n){const t=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,g)=>{const u=[];t.then(d=>{d.indexOf("gnome-terminal")>=0?u.push("-x"):u.push("-e"),u.push("bash"),u.push("-c");const v=`${c(i)}; echo; read -p "${p.b}" -n1;`;u.push(`''${v}''`);const l=Object.assign({},r(process),a);Object.keys(l).filter(N=>l[N]===null).forEach(N=>delete l[N]);const w={cwd:C,env:l};let P="";const M=k.spawn(d,u,w);M.on("error",N=>{g(s(N))}),M.stderr.on("data",N=>{P+=N.toString()}),M.on("exit",N=>{if(N===0)o(void 0);else if(P){const T=P.split(`
`,1);g(new Error(T[0]))}else g(new Error(b.localize(4,null,d,N)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!L.$k)p.d=Promise.resolve("xterm");else{const y=await m.Promises.exists("/etc/debian_version");p.d=new Promise(C=>{y?C("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?C("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?C("konsole"):process.env.COLORTERM?C(process.env.COLORTERM):process.env.TERM?C(process.env.TERM):C("xterm")})}return p.d}spawnTerminal(y,C,i){const a=C.linuxExec?Promise.resolve(C.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,t)=>{a.then(o=>{const g=r(process),u=y.spawn(o,[],{cwd:i,env:g});u.on("error",t),u.on("exit",()=>n())})})}}e.$R3b=p;function r(f){const y={...f.env};return(0,A.$dl)(y),y}function s(f){return"errno"in f&&f.errno==="ENOENT"&&"path"in f&&typeof f.path=="string"?new Error(b.localize(5,null,f.path)):f}function c(f){let y="";for(const C of f)C.indexOf(" ")>=0?y+='"'+C+'"':y+=C,y+=" ";return y}}),define(De[30],Ce([1,0,71,13,12,14,2,186,5,11,15]),function(me,e,k,F,h,L,A,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.FileKind=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileOperationResult=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileChangeType=e.$8j=e.FileOperation=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.FileSystemProviderErrorCode=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Rj=e.$Qj=void 0,e.$Qj=(0,E.$nh)("fileService");function I(q){return q.create===!0}e.$Rj=I;var $;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var S;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(S||(e.FilePermission=S={}));var D;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(D||(e.FileSystemProviderCapabilities=D={}));function p(q){return!!(q.capabilities&2)}e.$Sj=p;function r(q){return!!(q.capabilities&8)}e.$Tj=r;function s(q){return!!(q.capabilities&131072)}e.$Uj=s;function c(q){return!!(q.capabilities&4)}e.$Vj=c;function f(q){return!!(q.capabilities&16)}e.$Wj=f;function y(q){return p(q)?!!(q.capabilities&16384):!1}e.$Xj=y;function C(q){return p(q)?!!(q.capabilities&32768):!1}e.$Yj=C;function i(q){return!!(q.capabilities&65536)}e.$Zj=i;function a(q){return!!(q.capabilities&2048)}e.$1j=a;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class t extends Error{static create(V,ce){const re=new t(V.toString(),ce);return u(re,ce),re}constructor(V,ce){super(V),this.code=ce}}e.$2j=t;function o(q,V){return t.create(q,V)}e.$3j=o;function g(q){return q||o((0,m.localize)(0,null),n.Unknown)}e.$4j=g;function u(q,V){return q.name=V?`${V} (FileSystemError)`:"FileSystemError",q}e.$5j=u;function d(q){if(!q)return n.Unknown;if(q instanceof t)return q.code;const V=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!V)return n.Unknown;switch(V[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$6j=d;function v(q){if(q instanceof T)return q.fileOperationResult;switch(d(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$7j=v;var l;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(l||(e.FileOperation=l={}));class w{constructor(V,ce,re){this.resource=V,this.operation=ce,this.target=re}isOperation(V){return this.operation===V}}e.$8j=w;var P;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(P||(e.FileChangeType=P={}));class M{constructor(V,ce){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const re=new Map;for(const fe of V){const de=re.get(fe.type);switch(de?de.push([fe.resource,fe]):re.set(fe.type,[[fe.resource,fe]]),fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}}for(const[fe,de]of re)switch(fe){case 1:this.a=k.$th.forUris(()=>ce),this.a.fill(de);break;case 0:this.b=k.$th.forUris(()=>ce),this.b.fill(de);break;case 2:this.c=k.$th.forUris(()=>ce),this.c.fill(de);break}}contains(V,...ce){return this.d(V,{includeChildren:!1},...ce)}affects(V,...ce){return this.d(V,{includeChildren:!0},...ce)}d(V,ce,...re){if(!V)return!1;const fe=re.length>0;return!!((!fe||re.includes(1))&&(this.a?.get(V)||ce.includeChildren&&this.a?.findSuperstr(V))||(!fe||re.includes(0))&&(this.b?.get(V)||ce.includeChildren&&this.b?.findSuperstr(V))||(!fe||re.includes(2))&&(this.c?.findSubstr(V)||ce.includeChildren&&this.c?.findSuperstr(V)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$9j=M;function N(q,V,ce){return!q||!V||q===V||V.length>q.length?!1:(V.charAt(V.length-1)!==F.sep&&(V+=F.sep),ce?(0,h.$Md)(q,V):q.indexOf(V)===0)}e.$0j=N;class T extends Error{constructor(V,ce,re){super(V),this.fileOperationResult=ce,this.options=re}}e.$$j=T;class z extends T{constructor(V,ce,re,fe){super(V,ce,fe),this.fileOperationResult=ce,this.size=re}}e.$_j=z;class j extends T{constructor(V,ce,re){super(V,2,re),this.stat=ce}}e.$ak=j;var U;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(U||(e.FileOperationResult=U={})),e.$bk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ck={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$dk="files.associations",e.$ek="files.exclude",e.$fk="files.readonlyInclude",e.$gk="files.readonlyExclude",e.$hk="files.readonlyFromPermissions";var Y;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$ik="";function H(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$jk=H;async function ge(q,V){if(!V.hasProvider(A.URI.from({scheme:q.scheme})))return new Promise(ce=>{const re=V.onDidChangeFileSystemProviderRegistrations(fe=>{fe.scheme===q.scheme&&fe.added&&(re.dispose(),ce())})})}e.$kk=ge;class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(V){return(0,L.$me)(V)||(V=0),V<ie.KB?(0,m.localize)(1,null,V.toFixed(0)):V<ie.MB?(0,m.localize)(2,null,(V/ie.KB).toFixed(2)):V<ie.GB?(0,m.localize)(3,null,(V/ie.MB).toFixed(2)):V<ie.TB?(0,m.localize)(4,null,(V/ie.GB).toFixed(2)):(0,m.localize)(5,null,(V/ie.TB).toFixed(2))}}e.$lk=ie;function te(q){const V=typeof q=="string"||q?.scheme===R.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===R.Schemas.file?1024*ie.MB:V?10*ie.MB:b.$o?50*ie.MB:1024*ie.MB}e.$mk=te}),define(De[222],Ce([1,0,22,8,187,30]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=void 0;async function A(R,I,$,S,D,p){let r;try{await m(R,I,$,S,D,p)}catch(s){r=s}finally{r&&D.errorTransformer&&(r=D.errorTransformer(r)),typeof r<"u"&&$.error(r),$.end()}}e.$pp=A;async function m(R,I,$,S,D,p){E(p);const r=await R.open(I,{create:!1});try{E(p);let s=0,c=0,f=D&&typeof D.length=="number"?D.length:void 0,y=k.$Jb.alloc(Math.min(D.bufferSize,typeof f=="number"?f:D.bufferSize)),C=D&&typeof D.position=="number"?D.position:0,i=0;do c=await R.read(r,C,y.buffer,i,y.byteLength-i),C+=c,i+=c,s+=c,typeof f=="number"&&(f-=c),i===y.byteLength&&(await $.write(S(y)),y=k.$Jb.alloc(Math.min(D.bufferSize,typeof f=="number"?f:D.bufferSize)),i=0);while(c>0&&(typeof f!="number"||f>0)&&E(p)&&b(s,D));if(i>0){let a=i;typeof f=="number"&&(a=Math.min(i,f)),$.write(S(y.slice(0,a)))}}catch(s){throw(0,L.$4j)(s)}finally{await R.close(r)}}function E(R){if(R.isCancellationRequested)throw(0,F.$4)();return!0}function b(R,I){if(typeof I?.limits?.size=="number"&&R>I.limits.size)throw(0,L.$3j)((0,h.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(De[78],Ce([1,0,34,4,13,11,2,30]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yp=e.$xp=e.$wp=e.$vp=e.$up=e.$tp=e.$sp=e.$rp=void 0;function E(s){return s.recursive===!0}e.$rp=E;class b extends F.$lb{static{this.a=5}constructor(c,f,y,C){super(),this.h=c,this.i=f,this.j=y,this.k=C,this.c=this.B(new F.$mb),this.f=void 0,this.g=0}m(){const c=new F.$kb;this.c.value=c,this.b=this.l(c),this.b.setVerboseLogging(this.j),c.add(this.b.onDidChangeFile(f=>this.h(f))),c.add(this.b.onDidLogMessage(f=>this.i(f))),c.add(this.b.onDidError(f=>this.n(f)))}n(c){this.k.restartOnError?this.g<b.a&&this.f?(this.r(`restarting watcher after error: ${c}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${c}`):this.r(c)}p(c){this.g++,this.m(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.j=c,await this.b?.setVerboseLogging(c)}r(c){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${c}`})}s(c){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.$sp=b;class R extends b{constructor(c,f,y){super(c,f,y,{type:"node.js",restartOnError:!1})}}e.$tp=R;class I extends b{constructor(c,f,y){super(c,f,y,{type:"universal",restartOnError:!0})}}e.$up=I;function $(s){return s.map(c=>({type:c.type,resource:A.URI.file(c.path)}))}e.$vp=$;function S(s){const c=new r;for(const f of s)c.processEvent(f);return c.coalesce()}e.$wp=S;function D(s,c){return typeof c=="string"&&!c.startsWith(k.$$i)&&!(0,h.$_b)(c)?{base:s,pattern:c}:c}e.$xp=D;function p(s,c){const f=[];for(const y of c)f.push((0,k.$cj)(D(s,y)));return f}e.$yp=p;class r{constructor(){this.a=new Set,this.b=new Map}c(c){return L.$k?c.path:c.path.toLowerCase()}processEvent(c){const f=this.b.get(this.c(c));let y=!1;if(f){const C=f.type,i=c.type;f.path!==c.path&&(c.type===2||c.type===1)?y=!0:C===1&&i===2?(this.b.delete(this.c(c)),this.a.delete(f)):C===2&&i===1?f.type=0:C===1&&i===0||(f.type=i)}else y=!0;y&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],f=[];return Array.from(this.a).filter(y=>y.type!==2?(c.push(y),!1):!0).sort((y,C)=>y.path.length-C.path.length).filter(y=>f.some(C=>(0,m.$0j)(y.path,C,!L.$k))?!1:(f.push(y.path),!0)).concat(c)}}}),define(De[223],Ce([1,0,49,17,21,31,4,69,13,11,95,29,78]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mp=e.$Lp=void 0;class S extends A.$lb{static{this.a=100}static{this.b=75}constructor(r,s,c,f){super(),this.j=r,this.k=s,this.l=c,this.m=f,this.c=this.B(new F.$Hg({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},y=>this.k(y))),this.f=this.B(new F.$Gg(y=>this.u(y),S.b)),this.g=(0,$.$yp)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,$.$yp)(this.j.path,this.j.includes):void 0,this.i=new h.$dd,this.ready=this.n()}async n(){try{const r=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const s=await I.Promises.stat(r);this.B(await this.s(r,s.isDirectory()))}catch(r){r.code!=="ENOENT"?this.w(r):this.z(r)}}async r(r){let s=r.path;try{s=await I.Promises.realpath(r.path),r.path===s&&(s=await(0,R.$Ip)(r.path)??r.path),r.path!==s&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${s})`)}catch{}return s}async s(r,s){if(b.$j&&(0,L.$Je)(r,"/Volumes/",!0))return this.w(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.$lb.None;const c=new h.$dd(this.i.token),f=new A.$kb;try{const y=(0,E.$ec)(r),C=(0,k.watch)(r);f.add((0,A.$jb)(()=>{C.removeAllListeners(),C.close()})),this.z(`Started watching: '${r}'`);const i=new Set;if(s)try{for(const n of await I.Promises.readdir(r))i.add(n)}catch(n){this.w(n)}const a=new Map;f.add((0,A.$jb)(()=>{for(const[,n]of a)n.dispose();a.clear()})),C.on("error",(n,t)=>{this.w(`Failed to watch ${r} for changes using fs.watch() (${n}, ${t})`),this.dispose()}),C.on("change",(n,t)=>{if(c.token.isCancellationRequested)return;this.z(`[raw] ["${n}"] ${t}`);let o="";if(t&&(o=t.toString(),b.$j&&(o=(0,m.$5k)(o))),!(!o||n!=="change"&&n!=="rename"))if(s)if(n==="rename"){a.get(o)?.dispose();const g=setTimeout(async()=>{if(a.delete(o),o===y&&!await I.Promises.exists(r)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.v((0,E.$ac)(r,o));if(c.token.isCancellationRequested)return;let d;u?i.has(o)?d=0:(d=1,i.add(o)):(i.delete(o),d=2),this.t({path:(0,E.$ac)(this.j.path,o),type:d})},S.a);a.set(o,(0,A.$jb)(()=>clearTimeout(g)))}else{let g;i.has(o)?g=0:(g=1,i.add(o)),this.t({path:(0,E.$ac)(this.j.path,o),type:g})}else if(n==="rename"||o!==y){const g=setTimeout(async()=>{const u=await I.Promises.exists(r);c.token.isCancellationRequested||(u?(this.t({path:this.j.path,type:0},!0),f.add(await this.s(r,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},S.a);f.clear(),f.add((0,A.$jb)(()=>clearTimeout(g)))}else this.t({path:this.j.path,type:0},!0)})}catch(y){await I.Promises.exists(r)&&!c.token.isCancellationRequested&&this.w(`Failed to watch ${r} for changes using fs.watch() (${y.toString()})`)}return(0,A.$jb)(()=>{c.dispose(!0),f.dispose()})}t(r,s=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!s&&this.g.some(c=>c(r.path))?this.m&&this.z(` >> ignored (excluded) ${r.path}`):!s&&this.h&&this.h.length>0&&!this.h.some(c=>c(r.path))?this.m&&this.z(` >> ignored (not included) ${r.path}`):this.f.work(r))}u(r){const s=(0,$.$wp)(r);if(s.length>0){if(this.m)for(const f of s)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(s)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(r){if(b.$k)return I.Promises.exists(r);try{const s=(0,E.$ec)(r);return(await I.Promises.readdir((0,E.$dc)(r))).some(f=>f===s)}catch(s){return this.z(s),!1}}setVerboseLogging(r){this.m=r}w(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}y(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}z(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.$Lp=S;async function D(p,r,s,c,f=512){const y=await I.Promises.open(p,"r"),C=Buffer.allocUnsafe(f),i=new h.$dd(c);let a,n=!1;const t={path:p,excludes:[],recursive:!1},o=new S(t,g=>{(async()=>{for(const{type:u}of g)if(u===0){if(n)return;n=!0;try{for(;!i.token.isCancellationRequested;){const{bytesRead:d}=await I.Promises.read(y,C,0,f,null);if(!d||i.token.isCancellationRequested)break;r(C.slice(0,d))}}catch(d){a=new Error(d),i.dispose(!0)}finally{n=!1}}})()});return await o.ready,s(),new Promise((g,u)=>{i.token.onCancellationRequested(async()=>{o.dispose();try{await I.Promises.close(y)}catch(d){a=new Error(d)}a?u(a):g()})})}e.$Mp=D}),define(De[224],Ce([1,0,3,34,4,11,223]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=void 0;class m extends h.$lb{constructor(){super(...arguments),this.a=this.B(new k.$7c),this.onDidChangeFile=this.a.event,this.b=this.B(new k.$7c),this.onDidLogMessage=this.b.event,this.onDidError=k.Event.None,this.c=new Map,this.f=!1}async watch(b){const R=this.i(b),I=R.filter(S=>{const D=this.c.get(S.path);return D?!(0,F.$gj)(D.request.excludes,S.excludes)||!(0,F.$gj)(D.request.includes,S.includes):!0}),$=Array.from(this.c.values()).filter(({request:S})=>!R.find(D=>D.path===S.path&&(0,F.$gj)(D.excludes,S.excludes)&&(0,F.$gj)(D.includes,S.includes))).map(({request:S})=>S.path);I.length&&this.j(`Request to start watching: ${I.map(S=>`${S.path} (excludes: ${S.excludes.length>0?S.excludes:"<none>"}, includes: ${S.includes&&S.includes.length>0?JSON.stringify(S.includes):"<all>"})`).join(",")}`),$.length&&this.j(`Request to stop watching: ${$.join(",")}`);for(const S of $)this.h(S);for(const S of I)this.g(S)}g(b){const R=new A.$Lp(b,$=>this.a.fire($),$=>this.b.fire($),this.f),I={request:b,instance:R};this.c.set(b.path,I)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const R=this.c.get(b);R&&(this.c.delete(b),R.instance.dispose())}i(b){const R=new Map;for(const I of b){const $=L.$k?I.path:I.path.toLowerCase();R.set($,I)}return Array.from(R.values())}async setVerboseLogging(b){this.f=b;for(const[,R]of this.c)R.instance.setVerboseLogging(b)}j(b){this.f&&this.b.fire({type:"trace",message:this.k(b)})}k(b,R){return R?`[File Watcher (node.js)] ${b} (path: ${R.request.path})`:`[File Watcher (node.js)] ${b}`}}e.$Np=m}),define(De[225],Ce([1,0,78,224]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=void 0;class h extends k.$tp{constructor(A,m,E){super(A,m,E),this.m()}l(){return new F.$Np}}e.$Op=h}),define(De[226],Ce([1,0,15,76,176,78]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=void 0;class A extends L.$up{constructor(E,b,R){super(E,b,R),this.m()}l(E){const b=E.add(new h.$Fp(k.$3e.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return E.add(b.onDidProcessExit(({code:R,signal:I})=>this.n(`terminated by itself with code ${R}, signal: ${I}`))),F.ProxyChannel.toService((0,F.$7g)(b.getChannel("watcher")))}}e.$Gp=A}),define(De[99],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=void 0;class k{constructor(...h){this.a=new Map;for(const[L,A]of h)this.set(L,A)}set(h,L){const A=this.a.get(h);return this.a.set(h,L),A}has(h){return this.a.has(h)}get(h){return this.a.get(h)}}e.$lh=k}),define(De[227],Ce([1,0,17,8,4,97,218,5,99,68]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;const R=!1;class I extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class ${constructor(r=new E.$lh,s=!1,c,f=R){this.f=r,this.g=s,this.h=c,this.i=f,this.o=new Set,this.f.set(m.$mh,this),this._globalGraph=f?c?._globalGraph??new A.$Rp(y=>y):void 0}createChild(r){return new $(r,this.g,this,this.i)}invokeFunction(r,...s){const c=D.traceInvocation(this.i,r);let f=!1;try{return r({get:C=>{if(f)throw(0,F.$6)("service accessor is only valid during the invocation of its target method");const i=this.m(C,c);if(!i)throw new Error(`[invokeFunction] unknown service '${C}'`);return i}},...s)}finally{f=!0,c.stop()}}createInstance(r,...s){let c,f;return r instanceof L.$kh?(c=D.traceCreation(this.i,r.ctor),f=this.j(r.ctor,r.staticArguments.concat(s),c)):(c=D.traceCreation(this.i,r),f=this.j(r,s,c)),c.stop(),f}j(r,s=[],c){const f=m._util.getServiceDependencies(r).sort((i,a)=>i.index-a.index),y=[];for(const i of f){const a=this.m(i.id,c);a||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${i.id}.`,!1),y.push(a)}const C=f.length>0?f[0].index:s.length;if(s.length!==C){console.trace(`[createInstance] First service dependency of ${r.name} at position ${C+1} conflicts with ${s.length} static arguments`);const i=C-s.length;i>0?s=s.concat(new Array(i)):s=s.slice(0,C)}return Reflect.construct(r,s.concat(y))}k(r,s){if(this.f.get(r)instanceof L.$kh)this.f.set(r,s);else if(this.h)this.h.k(r,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const s=this.f.get(r);return!s&&this.h?this.h.l(r):s}m(r,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const c=this.l(r);return c instanceof L.$kh?this.q(r,c,s.branch(r,!0)):(s.branch(r,!1),c)}q(r,s,c){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,s,c)}finally{this.o.delete(r)}}r(r,s,c){const f=new A.$Rp(i=>i.id.toString());let y=0;const C=[{id:r,desc:s,_trace:c}];for(;C.length;){const i=C.pop();if(f.lookupOrInsertNode(i),y++>1e3)throw new I(f);for(const a of m._util.getServiceDependencies(i.desc.ctor)){const n=this.l(a.id);if(n||this.u(`[createInstance] ${r} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(a.id)),n instanceof L.$kh){const t={id:a.id,desc:n,_trace:i._trace.branch(a.id,!0)};f.insertEdge(i,t),C.push(t)}}}for(;;){const i=f.roots();if(i.length===0){if(!f.isEmpty())throw new I(f);break}for(const{data:a}of i){if(this.l(a.id)instanceof L.$kh){const t=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,t)}f.removeNode(a)}}return this.l(r)}s(r,s,c=[],f,y){if(this.f.get(r)instanceof L.$kh)return this.t(r,s,c,f,y);if(this.h)return this.h.s(r,s,c,f,y);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(r,s,c=[],f,y){if(f){const C=new $(void 0,this.g,this,this.i);C.c=String(r);const i=new Map,a=new k.$Jg(()=>{const n=C.j(s,c,y);for(const[t,o]of i){const g=n[t];if(typeof g=="function")for(const u of o)g.apply(n,u)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,t){if(!a.isInitialized&&typeof t=="string"&&(t.startsWith("onDid")||t.startsWith("onWill"))){let u=i.get(t);return u||(u=new b.$lc,i.set(t,u)),(v,l,w)=>{const P=u.push([v,l,w]);return(0,h.$jb)(P)}}if(t in n)return n[t];const o=a.value;let g=o[t];return typeof g!="function"||(g=g.bind(o),n[t]=g),g},set(n,t,o){return a.value[t]=o,!0},getPrototypeOf(n){return s.prototype}})}else return this.j(s,c,y)}u(r,s){if(s&&console.warn(r),this.g)throw new Error(r)}}e.$Sp=$;var S;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(S||(S={}));class D{static{this.all=new Set}static{this.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(r,s){return r?new D(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(r,s){return r?new D(1,s.name):D.c}static{this.f=0}constructor(r,s){this.type=r,this.name=s,this.g=Date.now(),this.h=[]}branch(r,s){const c=new D(3,r.toString());return this.h.push([r,s,c]),c}stop(){const r=Date.now()-this.g;D.f+=r;let s=!1;function c(y,C){const i=[],a=new Array(y+1).join("	");for(const[n,t,o]of C.h)if(t&&o){s=!0,i.push(`${a}CREATES -> ${n}`);const g=c(y+1,o);g&&i.push(g)}else i.push(`${a}uses -> ${n}`);return i.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(r>2||s)&&D.all.add(f.join(`
`))}}e.$Tp=D}),define(De[18],Ce([1,0,45,3,70,4,28,11,24,14,2,47,5]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.log=e.$Si=e.LogLevel=e.$Ri=e.$Qi=e.$Pi=void 0,e.$Pi=(0,$.$nh)("logService"),e.$Qi=(0,$.$nh)("loggerService");function S(){return new Date().toISOString()}function D(v){return(0,b.$me)(v)}e.$Ri=D;var p;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$Si=p.Info;function r(v,l,w){switch(l){case p.Trace:v.trace(w);break;case p.Debug:v.debug(w);break;case p.Info:v.info(w);break;case p.Warning:v.warn(w);break;case p.Error:v.error(w);break;case p.Off:break;default:throw new Error(`Invalid log level ${l}`)}}e.log=r;function s(v,l=!1){let w="";for(let P=0;P<v.length;P++){let M=v[P];if(M instanceof Error&&(M=(0,k.$$h)(M,l)),typeof M=="object")try{M=JSON.stringify(M)}catch{}w+=(P>0?" ":"")+M}return w}class c extends L.$lb{constructor(){super(...arguments),this.b=e.$Si,this.c=this.B(new F.$7c),this.onDidChangeLogLevel=this.c.event}setLevel(l){this.b!==l&&(this.b=l,this.c.fire(this.b))}getLevel(){return this.b}f(l){return this.b!==p.Off&&this.b<=l}}e.$Ui=c;class f extends c{constructor(l){super(),this.h=l}f(l){return this.h||super.f(l)}trace(l,...w){this.f(p.Trace)&&this.g(p.Trace,s([l,...w],!0))}debug(l,...w){this.f(p.Debug)&&this.g(p.Debug,s([l,...w]))}info(l,...w){this.f(p.Info)&&this.g(p.Info,s([l,...w]))}warn(l,...w){this.f(p.Warning)&&this.g(p.Warning,s([l,...w]))}error(l,...w){if(this.f(p.Error))if(l instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=l.stack,this.g(p.Error,s(P))}else this.g(p.Error,s([l,...w]))}flush(){}}e.$Vi=f;class y extends c{constructor(l=e.$Si){super(),this.setLevel(l),this.g=!m.$i}trace(l,...w){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...w):console.log(`[main ${S()}]`,l,...w))}debug(l,...w){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...w):console.log(`[main ${S()}]`,l,...w))}info(l,...w){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,l,...w):console.log(`[main ${S()}]`,l,...w))}warn(l,...w){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,l,...w):console.warn(`[main ${S()}]`,l,...w))}error(l,...w){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,l,...w):console.error(`[main ${S()}]`,l,...w))}dispose(){}flush(){}}e.$Wi=y;class C extends c{constructor(l=e.$Si,w=!0){super(),this.g=w,this.setLevel(l)}trace(l,...w){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",l,...w):console.log(l,...w))}debug(l,...w){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",l,...w):console.log(l,...w))}info(l,...w){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",l,...w):console.log(l,...w))}warn(l,...w){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",l,...w):console.log(l,...w))}error(l,...w){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",l,...w):console.error(l,...w))}dispose(){}flush(){}}e.$Xi=C;class i extends c{constructor(l,w=e.$Si){super(),this.g=l,this.setLevel(w)}trace(l,...w){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(l),...w])}debug(l,...w){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(l),...w])}info(l,...w){this.f(p.Info)&&this.g.log(p.Info,[this.h(l),...w])}warn(l,...w){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(l),...w])}error(l,...w){this.f(p.Error)&&this.g.log(p.Error,[this.h(l),...w])}h(l){return typeof l=="string"?l:(0,k.$$h)(l,this.f(p.Trace))}dispose(){}flush(){}}e.$Yi=i;class a extends c{constructor(l){super(),this.g=l,l.length&&this.setLevel(l[0].getLevel())}setLevel(l){for(const w of this.g)w.setLevel(l);super.setLevel(l)}trace(l,...w){for(const P of this.g)P.trace(l,...w)}debug(l,...w){for(const P of this.g)P.debug(l,...w)}info(l,...w){for(const P of this.g)P.info(l,...w)}warn(l,...w){for(const P of this.g)P.warn(l,...w)}error(l,...w){for(const P of this.g)P.error(l,...w)}flush(){for(const l of this.g)l.flush()}dispose(){for(const l of this.g)l.dispose()}}e.$Zi=a;class n extends L.$lb{constructor(l,w,P){if(super(),this.h=l,this.j=w,this.b=new A.$li,this.c=this.B(new F.$7c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new F.$7c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new F.$7c),this.onDidChangeVisibility=this.g.event,P)for(const M of P)this.b.set(M.resource,{logger:void 0,info:M})}k(l){return(0,b.$ie)(l)?[...this.b.values()].find(w=>w.info.id===l):this.b.get(l)}getLogger(l){return this.k(l)?.logger}createLogger(l,w){const P=this.l(l),M=(0,b.$ie)(l)?l:w?.id??(0,h.$bi)(P.toString()).toString(16);let N=this.b.get(P)?.logger;const T=w?.logLevel==="always"?p.Trace:w?.logLevel;N||(N=this.m(P,T??this.getLogLevel(P)??this.h,{...w,id:M}));const z={logger:N,info:{resource:P,id:M,logLevel:T,name:w?.name,hidden:w?.hidden,extensionId:w?.extensionId,when:w?.when}};return this.registerLogger(z.info),this.b.set(P,z),N}l(l){return(0,b.$ie)(l)?(0,E.$8f)(this.j,`${l}.log`):l}setLogLevel(l,w){if(R.URI.isUri(l)){const P=l,M=w,N=this.b.get(P);N&&M!==N.info.logLevel&&(N.info.logLevel=M===this.h?void 0:M,N.logger?.setLevel(M),this.b.set(N.info.resource,N),this.f.fire([P,M]))}else{this.h=l;for(const[P,M]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(l,w){const P=this.k(l);P&&w!==!P.info.hidden&&(P.info.hidden=!w,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,w]))}getLogLevel(l){let w;return l&&(w=this.b.get(l)?.info.logLevel),w??this.h}registerLogger(l){const w=this.b.get(l.resource);w?w.info.hidden!==l.hidden&&this.setVisibility(l.resource,!l.hidden):(this.b.set(l.resource,{info:l,logger:void 0}),this.c.fire({added:[l],removed:[]}))}deregisterLogger(l){const w=this.b.get(l);w&&(w.logger&&w.logger.dispose(),this.b.delete(l),this.c.fire({added:[],removed:[w.info]}))}*getRegisteredLoggers(){for(const l of this.b.values())yield l.info}getRegisteredLogger(l){return this.b.get(l)?.info}dispose(){this.b.forEach(l=>l.logger?.dispose()),this.b.clear(),super.dispose()}}e.$1i=n;class t{constructor(){this.onDidChangeLogLevel=new F.$7c().event}setLevel(l){}getLevel(){return p.Info}trace(l,...w){}debug(l,...w){}info(l,...w){}warn(l,...w){}error(l,...w){}critical(l,...w){}dispose(){}flush(){}}e.$2i=t;class o extends t{}e.$3i=o;function g(v){if(v.verbose)return p.Trace;if(typeof v.logLevel=="string"){const l=d(v.logLevel.toLowerCase());if(l!==void 0)return l}return e.$Si}e.$4i=g;function u(v){switch(v){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}e.$5i=u;function d(v){switch(v){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$6i=d,e.$7i=new I.$Mi("logLevel",u(p.Info))}),define(De[228],Ce([1,0,19,17,8,3,4,13,78,18]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=void 0;class R extends A.$lb{constructor($,S){super(),this.a=$,this.b=S,this.c=this.B(new L.$7c),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$7c),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new F.$rg(0)),this.s=[],this.t=this.B(new F.$rg(0))}watch($,S){return S.recursive||this.b?.watcher?.forceUniversal?this.l($,S):this.u($,S)}l($,S){const D={path:this.C($),excludes:S.excludes,includes:S.includes,recursive:S.recursive},p=(0,k.$Af)(this.j,D);return this.m(),(0,A.$jb)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch($=>(0,h.$Y)($))}n(){this.h||(this.h=this.B(this.p(S=>this.c.fire((0,E.$vp)(S)),S=>this.z(S),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const $=this.b?.watcher?.recursive?.usePolling;if($===!0)for(const S of this.j)(0,E.$rp)(S)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray($))for(const S of this.j)(0,E.$rp)(S)&&$.includes(S.path)&&(S.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u($,S){const D={path:this.C($),excludes:S.excludes,includes:S.includes,recursive:!1},p=(0,k.$Af)(this.s,D);return this.v(),(0,A.$jb)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch($=>(0,h.$Y)($))}w(){return this.r||(this.r=this.B(this.y($=>this.c.fire((0,E.$vp)($)),$=>this.z($),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.r.watch(this.s)}z($){$.type==="error"&&this.g.fire($.message),this.a[$.type]($.message)}C($){return(0,m.$$b)($.fsPath)}}e.$zp=R}),define(De[229],Ce([1,0,49,352,17,28,22,3,31,4,13,11,24,92,29,188,30,222,228,45,226,225]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=void 0,(()=>{try{(0,F.gracefulify)(k)}catch(a){console.error(`Error enabling graceful-fs: ${(0,f.$$h)(a)}`)}})();class i extends c.$zp{static{this.D=!1}constructor(n,t){super(n,t),this.onDidChangeCapabilities=m.Event.None,this.I=new L.$li(o=>$.$Yf.getComparisonKey(o)),this.O=new Map,this.P=new Map,this.Q=new Map}get capabilities(){return this.F||(this.F=253982,I.$k&&(this.F|=1024)),this.F}async stat(n){try{const{stat:t,symbolicLink:o}=await D.SymlinkSupport.stat(this.C(n));return{type:this.H(t,o),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:r.FilePermission.Locked}}catch(t){throw this.ab(t)}}async G(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const t=await D.Promises.readdir(this.C(n),{withFileTypes:!0}),o=[];return await Promise.all(t.map(async g=>{try{let u;g.isSymbolicLink()?u=(await this.stat((0,$.$8f)(n,g.name))).type:u=this.H(g),o.push([g.name,u])}catch(u){this.a.trace(u)}})),o}catch(t){throw this.ab(t)}}H(n,t){let o;return t?.dangling?o=r.FileType.Unknown:n.isFile()?o=r.FileType.File:n.isDirectory()?o=r.FileType.Directory:o=r.FileType.Unknown,t&&(o|=r.FileType.SymbolicLink),o}async J(n){const t=this.C(n);this.L(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let o;for(;o=this.I.get(n);)this.L(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await o.wait();const g=new h.$sg;return this.I.set(n,g),this.L(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,b.$jb)(()=>{this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.I.get(n)===g&&(this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.I.delete(n)),this.L(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),g.open()})}async readFile(n,t){let o;try{t?.atomic&&(this.L(`[Disk FileSystemProvider]: atomic read operation started (${this.C(n)})`),o=await this.J(n));const g=this.C(n);return await D.Promises.readFile(g)}catch(g){throw this.ab(g)}finally{o?.dispose()}}L(n){i.D&&this.a.trace(n)}readFileStream(n,t,o){const g=(0,S.$xb)(u=>A.$Jb.concat(u.map(d=>A.$Jb.wrap(d))).buffer);return(0,s.$pp)(this,n,g,u=>u.buffer,{...t,bufferSize:256*1024},o),g}async writeFile(n,t,o){return o?.atomic!==!1&&o?.atomic?.postfix?this.M(n,(0,$.$8f)((0,$.$7f)(n),`${(0,$.$5f)(n)}${o.atomic.postfix}`),t,o):this.N(n,t,o)}async M(n,t,o,g){await this.N(t,o,g);try{await this.rename(t,n,{overwrite:!0})}catch(u){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw u}}async N(n,t,o){let g;try{const u=this.C(n);if(!o.create||!o.overwrite){if(await D.Promises.exists(u)){if(!o.overwrite)throw(0,r.$3j)((0,p.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,r.$3j)((0,p.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(n,{create:!0,unlock:o.unlock}),await this.write(g,0,t,0,t.byteLength)}catch(u){throw await this.bb(n,u)}finally{typeof g=="number"&&await this.close(g)}}static{this.R=!0}static configureFlushOnWrite(n){i.R=n}async open(n,t){const o=this.C(n);let g;(0,r.$Rj)(t)&&(g=await this.J(n));let u;try{if((0,r.$Rj)(t)&&t.unlock)try{const{stat:v}=await D.SymlinkSupport.stat(o);v.mode&128||await D.Promises.chmod(o,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let d;if((0,r.$Rj)(t)){if(I.$i)try{await D.Promises.truncate(o,0),d="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}d||(d="w")}else d="r";u=await D.Promises.open(o,d)}catch(d){throw g?.dispose(),(0,r.$Rj)(t)?await this.bb(n,d):this.ab(d)}if(this.O.set(u,0),(0,r.$Rj)(t)&&this.Q.set(u,n),g){const d=this.P.get(u);this.L(`[Disk FileSystemProvider]: open() - storing lock for handle ${u} (${o})`),this.P.set(u,g),d&&(this.L(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${u} (${o})`),d.dispose())}return u}async close(n){const t=this.P.get(n);try{if(this.O.delete(n),this.Q.delete(n)&&i.R)try{await D.Promises.fdatasync(n)}catch(o){i.configureFlushOnWrite(!1),this.a.error(o)}return await D.Promises.close(n)}catch(o){throw this.ab(o)}finally{t&&(this.P.get(n)===t&&(this.L(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.P.delete(n)),this.L(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),t.dispose())}}async read(n,t,o,g,u){const d=this.S(n,t);let v=null;try{v=(await D.Promises.read(n,o,g,u,d)).bytesRead}catch(l){throw this.ab(l)}finally{this.U(n,d,v)}return v}S(n,t){return t===this.O.get(n)?null:t}U(n,t,o){const g=this.O.get(n);typeof g=="number"&&(typeof t=="number"||(typeof o=="number"?this.O.set(n,g+o):this.O.delete(n)))}async write(n,t,o,g,u){return(0,h.$Kg)(()=>this.W(n,t,o,g,u),100,3)}async W(n,t,o,g,u){const d=this.S(n,t);let v=null;try{v=(await D.Promises.write(n,o,g,u,d)).bytesWritten}catch(l){throw await this.bb(this.Q.get(n),l)}finally{this.U(n,d,v)}return v}async mkdir(n){try{await D.Promises.mkdir(this.C(n))}catch(t){throw this.ab(t)}}async delete(n,t){try{const o=this.C(n);if(t.recursive){let g;t?.atomic!==!1&&t.atomic.postfix&&(g=(0,R.$ac)((0,R.$dc)(o),`${(0,R.$ec)(o)}${t.atomic.postfix}`)),await D.Promises.rm(o,D.RimRafMode.MOVE,g)}else try{await D.Promises.unlink(o)}catch(g){if(g.code==="EPERM"||g.code==="EISDIR"){let u=!1;try{const{stat:d,symbolicLink:v}=await D.SymlinkSupport.stat(o);u=d.isDirectory()&&!v}catch{}if(u)await D.Promises.rmdir(o);else throw g}else throw g}}catch(o){throw this.ab(o)}}async rename(n,t,o){const g=this.C(n),u=this.C(t);if(g!==u)try{await this.X(n,t,"move",o.overwrite),await D.Promises.move(g,u)}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,p.localize)(2,null,(0,R.$ec)(g),(0,R.$ec)((0,R.$dc)(u)),d.toString()))),this.ab(d)}}async copy(n,t,o){const g=this.C(n),u=this.C(t);if(g!==u)try{await this.X(n,t,"copy",o.overwrite),await D.Promises.copy(g,u,{preserveSymlinks:!0})}catch(d){throw(d.code==="EINVAL"||d.code==="EBUSY"||d.code==="ENAMETOOLONG")&&(d=new Error((0,p.localize)(3,null,(0,R.$ec)(g),(0,R.$ec)((0,R.$dc)(u)),d.toString()))),this.ab(d)}}async X(n,t,o,g){const u=this.C(n),d=this.C(t);let v=!1;if(!!(this.capabilities&1024)||(v=(0,E.$Ie)(u,d,!0)),v){if(o==="copy")throw(0,r.$3j)((0,p.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const w=await this.G(n);if(!w)throw(0,r.$3j)((0,p.localize)(5,null),r.FileSystemProviderErrorCode.FileNotFound);const P=await this.G(t);if(P){if(!g)throw(0,r.$3j)((0,p.localize)(6,null),r.FileSystemProviderErrorCode.FileExists);w.type&r.FileType.File&&P.type&r.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,t){return this.Y(n,t,!1)}async Y(n,t,o){const g=this.C(n),u=this.C(t),d=!!(this.capabilities&1024);if((0,E.$Ie)(g,u,!d))return;const v=new b.$kb;try{const[l,w]=await Promise.all([this.J(n),this.J(t)]);v.add(l),v.add(w),o&&await D.Promises.mkdir((0,R.$dc)(u),{recursive:!0}),await D.Promises.copyFile(g,u)}catch(l){if(l.code==="ENOENT"&&!o)return this.Y(n,t,!0);throw this.ab(l)}finally{v.dispose()}}p(n,t,o){return new y.$Gp(g=>n(g),g=>t(g),o)}y(n,t,o){return new C.$Op(g=>n(g),g=>t(g),o)}ab(n){if(n instanceof r.$2j)return n;let t=n,o;switch(n.code){case"ENOENT":o=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=r.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=r.FileSystemProviderErrorCode.Unknown;break;default:o=r.FileSystemProviderErrorCode.Unknown}return(0,r.$3j)(t,o)}async bb(n,t){let o=this.ab(t);if(n&&o.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await D.SymlinkSupport.stat(this.C(n));g.mode&128||(o=(0,r.$3j)(t,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.a.trace(g)}return o}}e.$Pp=i}),define(De[230],Ce([1,0,4,18]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;class h extends k.$lb{constructor(A,m=[]){super(),this.a=new F.$Zi([A,...m]),this.B(A.onDidChangeLogLevel(E=>this.setLevel(E)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$WM=h}),define(De[231],Ce([1,0,30,18]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=void 0;var h;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(h||(h={}));async function L(b,R,I,$,S){try{const D=await new Promise((r,s)=>{me(["@vscode/spdlog"],r,s)});D.setFlushOn(h.Trace);const p=await D.createAsyncRotatingLogger(b,R,I,$);return S?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(D){console.error(D)}return null}function A(b,R,I){switch(R){case F.LogLevel.Trace:b.trace(I);break;case F.LogLevel.Debug:b.debug(I);break;case F.LogLevel.Info:b.info(I);break;case F.LogLevel.Warning:b.warn(I);break;case F.LogLevel.Error:b.error(I);break;case F.LogLevel.Off:break;default:throw new Error(`Invalid log level ${R}`)}}function m(b,R){switch(R){case F.LogLevel.Trace:b.setLevel(h.Trace);break;case F.LogLevel.Debug:b.setLevel(h.Debug);break;case F.LogLevel.Info:b.setLevel(h.Info);break;case F.LogLevel.Warning:b.setLevel(h.Warning);break;case F.LogLevel.Error:b.setLevel(h.Error);break;case F.LogLevel.Off:b.setLevel(h.Off);break;default:throw new Error(`Invalid log level ${R}`)}}class E extends F.$Vi{constructor(R,I,$,S,D){super(),this.k=[],this.setLevel(D),this.l=this.n(R,I,$,S),this.B(this.onDidChangeLogLevel(p=>{this.m&&m(this.m,p)}))}async n(R,I,$,S){const D=$?6:1,p=30/D*k.$lk.MB,r=await L(R,I,p,D,S);if(r){this.m=r,m(this.m,this.getLevel());for(const{level:s,message:c}of this.k)A(this.m,s,c);this.k=[]}}g(R,I){this.m?A(this.m,R,I):this.getLevel()<=R&&this.k.push({level:R,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.$LM=E}),define(De[126],Ce([1,0,40,189,5]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(E){function b(D,p){return p-D}E.compare=b;const R=Object.create(null);R[E.Error]=(0,F.localize)(0,null),R[E.Warning]=(0,F.localize)(1,null),R[E.Info]=(0,F.localize)(2,null);function I(D){return R[D]||""}E.toString=I;function $(D){switch(D){case k.default.Error:return E.Error;case k.default.Warning:return E.Warning;case k.default.Info:return E.Info;case k.default.Ignore:return E.Hint}}E.fromSeverity=$;function S(D){switch(D){case E.Error:return k.default.Error;case E.Warning:return k.default.Warning;case E.Info:return k.default.Info;case E.Hint:return k.default.Ignore}}E.toSeverity=S}(A||(e.MarkerSeverity=A={}));var m;(function(E){const b="";function R($){return I($,!0)}E.makeKey=R;function I($,S){const D=[b];return $.source?D.push($.source.replace("\xA6","\\\xA6")):D.push(b),$.code?typeof $.code=="string"?D.push($.code.replace("\xA6","\\\xA6")):D.push($.code.value.replace("\xA6","\\\xA6")):D.push(b),$.severity!==void 0&&$.severity!==null?D.push(A.toString($.severity)):D.push(b),$.message&&S?D.push($.message.replace("\xA6","\\\xA6")):D.push(b),$.startLineNumber!==void 0&&$.startLineNumber!==null?D.push($.startLineNumber.toString()):D.push(b),$.startColumn!==void 0&&$.startColumn!==null?D.push($.startColumn.toString()):D.push(b),$.endLineNumber!==void 0&&$.endLineNumber!==null?D.push($.endLineNumber.toString()):D.push(b),$.endColumn!==void 0&&$.endColumn!==null?D.push($.endColumn.toString()):D.push(b),D.push(b),D.join("\xA6")}E.makeKeyOptionalMessage=I})(m||(e.IMarkerData=m={})),e.$js=(0,h.$nh)("markerService")}),define(De[232],Ce([1,0,3,40,5]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iu=e.$Hu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Gu=e.Severity=void 0,e.Severity=F.default,e.$Gu=(0,h.$nh)("notificationService");var L;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var m;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class E{constructor(){this.progress=new b,this.onDidClose=k.Event.None,this.onDidChangeVisibility=k.Event.None}updateSeverity(I){}updateMessage(I){}updateActions(I){}close(){}}e.$Hu=E;class b{infinite(){}done(){}total(I){}worked(I){}}e.$Iu=b}),define(De[127],Ce([1,0,12,2,5]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Y=e.$8Y=e.$7Y=e.$6Y=e.$5Y=void 0,e.$5Y=(0,h.$nh)("openerService");function L(b,R){return F.URI.isUri(b)?(0,k.$Ld)(b.scheme,R):(0,k.$Md)(b,R+":")}e.$6Y=L;function A(b,...R){return R.some(I=>L(b,I))}e.$7Y=A;function m(b,R){return b.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$8Y=m;function E(b){let R;const I=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(b.fragment);return I&&(R={startLineNumber:parseInt(I[1]),startColumn:I[2]?parseInt(I[2]):1,endLineNumber:I[4]?parseInt(I[4]):void 0,endColumn:I[4]?I[5]?parseInt(I[5]):1:void 0},b=b.with({fragment:""})),{selection:R,uri:b}}e.$9Y=E}),define(De[233],Ce([1,0,11,41]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let h;if(typeof k.$g.vscode<"u"&&typeof k.$g.vscode.context<"u"){const L=k.$g.vscode.context.configuration();if(L)h=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(h=globalThis._VSCODE_PRODUCT_JSON,F.env.VSCODE_DEV&&Object.assign(h,{nameShort:`${h.nameShort} Dev`,nameLong:`${h.nameLong} Dev`,dataFolderName:`${h.dataFolderName}-dev`,serverDataFolderName:h.serverDataFolderName?`${h.serverDataFolderName}-dev`:void 0}),!h.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(h,{version:L.version})}}else h={},Object.keys(h).length===0&&Object.assign(h,{version:"1.80.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=h}),define(De[234],Ce([1,0,5]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=void 0,e.$8i=(0,k.$nh)("productService"),e.$9i="vscode://schemas/vscode-product"});var qe=this&&this.__param||function(me,e){return function(k,F){e(k,F,me)}};define(De[128],Ce([1,0,17,21,4,5]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ou=e.$Nu=e.$Mu=e.$Lu=e.$Ku=e.ProgressLocation=e.$Ju=void 0,e.$Ju=(0,L.$nh)("progressService");var A;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$Ku=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(I,$){this.c=I,this.report=$?.async?this.e.bind(this):this.d.bind(this)}d(I){this.a=I,this.c(this.a)}e(I){Promise.resolve(this.b).finally(()=>{this.a=I;const $=this.c(this.a);this.b=Promise.resolve($).finally(()=>this.b=void 0)})}}e.$Lu=m;let E=class extends h.$lb{constructor(I,$){super(),this.a=new k.$Ng,$.withProgress(I,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,h.$jb)(()=>this.a.complete()))}report(I){this.b?this.b.report(I):this.c=I}};e.$Mu=E,e.$Mu=E=Je([qe(1,e.$Ju)],E);class b extends h.$lb{constructor(I){super(),this.g=I,this.a=0,this.b=this.B(new h.$kb)}start(I){this.stop();const $=++this.a,S=new F.$dd;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},I),this.b.add((0,h.$jb)(()=>clearTimeout(this.f))),this.b.add((0,h.$jb)(()=>S.cancel())),this.b.add((0,h.$jb)(()=>this.c?this.c.done():void 0)),{id:$,token:S.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(I){this.a===I&&this.b.clear()}}e.$Nu=b,e.$Ou=(0,L.$nh)("editorProgressService")}),define(De[42],Ce([1,0,53,14]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;class h{constructor(){this.a=new Map}add(A,m){k.ok(F.$ie(A)),k.ok(F.$ke(m)),k.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Rm=new h}),define(De[100],Ce([1,0,3,42]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=void 0,e.$Sm={JSONContribution:"base.contributions.json"};function h(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class L{constructor(){this.b=new k.$7c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(E,b){this.a[h(E)]=b,this.b.fire(E)}notifySchemaChanged(E){this.b.fire(E)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;F.$Rm.add(e.$Sm.JSONContribution,A)}),define(De[129],Ce([1,0,19,3,14,180,57,100,42]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.ConfigurationScope=e.$Wm=e.EditPresentationTypes=void 0;var b;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})(b||(e.EditPresentationTypes=b={})),e.$Wm={Configuration:"base.contributions.configuration"};var R;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m="vscode://schemas/settings/resourceLanguage",e.$5m="vscode://schemas/settings/configurationDefaults";const I=E.$Rm.as(m.$Sm.JSONContribution);class ${constructor(){this.h=new Set,this.i=new F.$7c,this.onDidSchemaChange=this.i.event,this.j=new F.$7c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.$4m,this.g),this.v()}registerConfiguration(i,a=!0){this.registerConfigurations([i],a)}registerConfigurations(i,a=!0){const n=new Set;this.n(i,a,n),I.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const a=new Set;this.o(i,a),I.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:i,remove:a}){const n=new Set;this.o(a,n),this.n(i,!1,n),I.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const a=new Set;this.k(i,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(i,a){const n=[];for(const{overrides:t,source:o}of i)for(const g in t)if(a.add(g),e.$7m.test(g)){const u=this.a.get(g),d=u?.valuesSources??new Map;if(o)for(const P of Object.keys(t[g]))d.set(P,o);const v={...u?.value||{},...t[g]};this.a.set(g,{source:o,value:v,valuesSources:d});const l=(0,A.$4h)(g),w={type:"object",default:v,description:L.localize(1,null,l),$ref:e.$4m,defaultDefaultValue:v,source:h.$ie(o)?void 0:o,defaultValueSource:o};n.push(...p(g)),this.d[g]=w,this.b.properties[g]=w}else{this.a.set(g,{value:t[g],source:o});const u=this.d[g];u&&(this.w(g,u),this.r(g,u))}this.m(n)}deregisterDefaultConfigurations(i){const a=new Set;this.l(i,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(i,a){for(const{overrides:n,source:t}of i)for(const o in n){const g=this.a.get(o),u=h.$ie(t)?t:t?.id,d=h.$ie(g?.source)?g?.source:g?.source?.id;if(u===d)if(a.add(o),this.a.delete(o),e.$7m.test(o))delete this.d[o],delete this.b.properties[o];else{const v=this.d[o];v&&(this.w(o,v),this.r(o,v))}}this.u()}deltaConfiguration(i){let a=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),a=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),a=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const a of i)this.h.add(a);this.u()}n(i,a,n){i.forEach(t=>{this.p(t,a,t.extensionInfo,t.restrictedProperties,void 0,n),this.c.push(t),this.q(t)})}o(i,a){const n=t=>{if(t.properties)for(const o in t.properties){a.add(o);const g=this.d[o];g?.policy?.name&&this.e.delete(g.policy.name),delete this.d[o],this.s(o,t.properties[o])}t.allOf?.forEach(o=>n(o))};for(const t of i){n(t);const o=this.c.indexOf(t);o!==-1&&this.c.splice(o,1)}}p(i,a=!0,n,t,o=3,g){o=h.$re(i.scope)?o:i.scope;const u=i.properties;if(u)for(const v in u){const l=u[v];if(a&&f(v,l)){delete u[v];continue}if(l.source=n,l.defaultDefaultValue=u[v].default,this.w(v,l),e.$7m.test(v)?l.scope=void 0:(l.scope=h.$re(l.scope)?o:l.scope,l.restricted=h.$re(l.restricted)?!!t?.includes(v):l.restricted),u[v].hasOwnProperty("included")&&!u[v].included){this.f[v]=u[v],delete u[v];continue}else this.d[v]=u[v],u[v].policy?.name&&this.e.set(u[v].policy.name,v);!u[v].deprecationMessage&&u[v].markdownDeprecationMessage&&(u[v].deprecationMessage=u[v].markdownDeprecationMessage),g.add(v)}const d=i.allOf;if(d)for(const v of d)this.p(v,a,n,t,o,g)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const a=n=>{const t=n.properties;if(t)for(const g in t)this.r(g,t[g]);n.allOf?.forEach(a)};a(i)}r(i,a){switch(e.$Xm.properties[i]=a,a.scope){case 1:e.$Ym.properties[i]=a;break;case 2:e.$Zm.properties[i]=a;break;case 6:e.$1m.properties[i]=a;break;case 3:e.$2m.properties[i]=a;break;case 4:e.$3m.properties[i]=a;break;case 5:e.$3m.properties[i]=a,this.g.properties[i]=a;break}}s(i,a){switch(delete e.$Xm.properties[i],a.scope){case 1:delete e.$Ym.properties[i];break;case 2:delete e.$Zm.properties[i];break;case 6:delete e.$1m.properties[i];break;case 3:delete e.$2m.properties[i];break;case 4:case 5:delete e.$3m.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const a=`[${i}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$4m};this.w(a,n),e.$Xm.properties[a]=n,e.$Ym.properties[a]=n,e.$Zm.properties[a]=n,e.$1m.properties[a]=n,e.$2m.properties[a]=n,e.$3m.properties[a]=n}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$4m};e.$Xm.patternProperties[e.$6m]=i,e.$Ym.patternProperties[e.$6m]=i,e.$Zm.patternProperties[e.$6m]=i,e.$1m.patternProperties[e.$6m]=i,e.$2m.patternProperties[e.$6m]=i,e.$3m.patternProperties[e.$6m]=i,this.i.fire()}w(i,a){const n=this.a.get(i);let t=n?.value,o=n?.source;h.$pe(t)&&(t=a.defaultDefaultValue,o=void 0),h.$pe(t)&&(t=s(a.type)),a.default=t,a.defaultValueSource=o}}const S="\\[([^\\]]+)\\]",D=new RegExp(S,"g");e.$6m=`^(${S})+$`,e.$7m=new RegExp(e.$6m);function p(C){const i=[];if(e.$7m.test(C)){let a=D.exec(C);for(;a?.length;){const n=a[1].trim();n&&i.push(n),a=D.exec(C)}}return(0,k.$qf)(i)}e.$8m=p;function r(C){return C.reduce((i,a)=>`${i}[${a}]`,"")}e.$9m=r;function s(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$0m=s;const c=new $;E.$Rm.add(e.$Wm.Configuration,c);function f(C,i){return C.trim()?e.$7m.test(C)?L.localize(7,null,C):c.getConfigurationProperties()[C]!==void 0?L.localize(8,null,C):i.policy?.name&&c.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,C,i.policy?.name,c.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.$$m=f;function y(){const C=[],i=c.getConfigurationProperties();for(const a of Object.keys(i))C.push([a,i[a].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.$_m=y}),define(De[235],Ce([1,0,19,3,151,4,28,23,14,2,57,129,42]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function S(a){return Object.isFrozen(a)?a:m.$Gm(a)}class D{constructor(n={},t=[],o=[],g){this.b=n,this.c=t,this.d=o,this.raw=g,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(t=>{if(t instanceof D)return t;const o=new p("");return o.parseRaw(t),o.configurationModel});this.f=n.reduce((t,o)=>o===t?o:t.merge(o),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,R.$2h)(this.contents,n):this.contents}inspect(n,t){const o=this.rawConfiguration.getValue(n),g=t?this.rawConfiguration.getOverrideValue(n,t):void 0,u=t?this.rawConfiguration.override(t).getValue(n):o;return{value:o,override:g,merged:u}}getOverrideValue(n,t){const o=this.i(t);return o?n?(0,R.$2h)(o,n):o:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const o of this.overrides)o.identifiers.includes(n)&&t.push(...o.keys);return k.$qf(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return k.$qf(n)}override(n){let t=this.a.get(n);return t||(t=this.g(n),this.a.set(n,t)),t}merge(...n){const t=m.$Fm(this.contents),o=m.$Fm(this.overrides),g=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const d of n)if(u.push(...d.raw?.length?d.raw:[d]),!d.isEmpty()){this.h(t,d.contents);for(const v of d.overrides){const[l]=o.filter(w=>k.$af(w.identifiers,v.identifiers));l?(this.h(l.contents,v.contents),l.keys.push(...v.keys),l.keys=k.$qf(l.keys)):o.push(m.$Fm(v))}for(const v of d.keys)g.indexOf(v)===-1&&g.push(v)}return new D(t,g,o,u.every(d=>d instanceof D)?void 0:u)}g(n){const t=this.i(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const o={};for(const g of k.$qf([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[g];const d=t[g];d&&(typeof u=="object"&&typeof d=="object"?(u=m.$Fm(u),this.h(u,d)):u=d),o[g]=u}return new D(o,this.keys,this.overrides)}h(n,t){for(const o of Object.keys(t)){if(o in n&&E.$ke(n[o])&&E.$ke(t[o])){this.h(n[o],t[o]);continue}n[o]=m.$Fm(t[o])}}i(n){let t=null,o=null;const g=u=>{u&&(o?this.h(o,u):o=m.$Fm(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===n?t=u.contents:u.identifiers.includes(n)&&g(u.contents);return g(t),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,t){this.j(n,t,!0)}setValue(n,t){this.j(n,t,!1)}removeValue(n){const t=this.keys.indexOf(n);t!==-1&&(this.keys.splice(t,1),(0,R.$1h)(this.contents,n),I.$7m.test(n)&&this.overrides.splice(this.overrides.findIndex(o=>k.$af(o.identifiers,(0,I.$8m)(n))),1))}j(n,t,o){(0,R.$Zh)(this.contents,n,t,g=>console.error(g)),o=o||this.keys.indexOf(n)===-1,o&&this.keys.push(n),I.$7m.test(n)&&this.overrides.push({identifiers:(0,I.$8m)(n),keys:Object.keys(this.contents[n]),contents:(0,R.$Yh)(this.contents[n],g=>console.error(g))})}}e.$an=D;class p{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,t){if(!E.$re(n)){const o=this.g(n);this.parseRaw(o,t)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,t){this.a=n;const{contents:o,keys:g,overrides:u,restricted:d,hasExcludedProperties:v}=this.h(n,t);this.b=new D(o,g,u,v?[n]:void 0),this.c=d||[]}g(n){let t={},o=null,g=[];const u=[],d=[];function v(w){Array.isArray(g)?g.push(w):o!==null&&(g[o]=w)}const l={onObjectBegin:()=>{const w={};v(w),u.push(g),g=w,o=null},onObjectProperty:w=>{o=w},onObjectEnd:()=>{g=u.pop()},onArrayBegin:()=>{const w=[];v(w),u.push(g),g=w,o=null},onArrayEnd:()=>{g=u.pop()},onLiteralValue:v,onError:(w,P,M)=>{d.push({error:w,offset:P,length:M})}};if(n)try{h.$Cm(n,l),t=g[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return t}h(n,t){const o=$.$Rm.as(I.$Wm.Configuration).getConfigurationProperties(),g=this.i(n,o,!0,t);n=g.raw;const u=(0,R.$Yh)(n,l=>console.error(`Conflict in settings file ${this.f}: ${l}`)),d=Object.keys(n),v=this.j(n,l=>console.error(`Conflict in settings file ${this.f}: ${l}`));return{contents:u,keys:d,overrides:v,restricted:g.restricted,hasExcludedProperties:g.hasExcludedProperties}}i(n,t,o,g){let u=!1;if(!g?.scopes&&!g?.skipRestricted&&!g?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:u};const d={},v=[];for(const l in n)if(I.$7m.test(l)&&o){const w=this.i(n[l],t,!1,g);d[l]=w.raw,u=u||w.hasExcludedProperties,v.push(...w.restricted)}else{const w=t[l],P=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&v.push(l),!g.exclude?.includes(l)&&(g.include?.includes(l)||(P===void 0||g.scopes===void 0||g.scopes.includes(P))&&!(g.skipRestricted&&w?.restricted))?d[l]=n[l]:u=!0}return{raw:d,restricted:v,hasExcludedProperties:u}}j(n,t){const o=[];for(const g of Object.keys(n))if(I.$7m.test(g)){const u={};for(const d in n[g])u[d]=n[g][d];o.push({identifiers:(0,I.$8m)(g),keys:Object.keys(u),contents:(0,R.$Yh)(u,t)})}return o}}e.$bn=p;class r extends L.$lb{constructor(n,t,o,g){super(),this.c=n,this.f=t,this.g=g,this.b=this.B(new F.$7c),this.onDidChange=this.b.event,this.a=new p(this.c.toString()),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(F.Event.any(F.Event.filter(this.g.onDidFilesChange,u=>u.contains(this.c)),F.Event.filter(this.g.onDidRunOperation,u=>(u.isOperation(0)||u.isOperation(3)||u.isOperation(1)||u.isOperation(4))&&o.isEqual(u.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new D}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$cn=r;class s{constructor(n,t,o,g,u,d,v,l,w,P,M,N,T){this.a=n,this.b=t,this.c=o,this.overrideIdentifiers=g,this.d=u,this.f=d,this.g=v,this.h=l,this.i=w,this.j=P,this.k=M,this.l=N,this.m=T}get value(){return S(this.c)}n(n,t,o){const g=n.inspect(t,o);return{get value(){return S(g.value)},get override(){return S(g.override)},get merged(){return S(g.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(n,t,o,g,u=new D,d=new D,v=new A.$li,l=new D,w=new A.$li){this.c=n,this.d=t,this.f=o,this.g=g,this.h=u,this.i=d,this.j=v,this.l=l,this.m=w,this.a=null,this.b=new A.$li,this.n=null}getValue(n,t,o){return this.q(n,t,o).getValue(n)}updateValue(n,t,o={}){let g;o.resource?(g=this.m.get(o.resource),g||(g=new D,this.m.set(o.resource,g))):g=this.l,t===void 0?g.removeValue(n):g.setValue(n,t),o.resource||(this.a=null)}inspect(n,t,o){const g=this.q(n,t,o),u=this.u(t.resource,o),d=t.resource?this.m.get(t.resource)||this.l:this.l,v=new Set;for(const l of g.overrides)for(const w of l.identifiers)g.getOverrideValue(n,w)!==void 0&&v.add(w);return new s(n,t,g.getValue(n),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,u||void 0,d)}keys(n){const t=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,t){this.j.set(n,t),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const o=[];if(!t){const{added:g,updated:u,removed:d}=C(this.c,n);t=[...g,...u,...d]}for(const g of t)for(const u of(0,I.$8m)(g)){const d=this.c.getKeysForOverrideIdentifier(u),v=n.getKeysForOverrideIdentifier(u),l=[...v.filter(w=>d.indexOf(w)===-1),...d.filter(w=>v.indexOf(w)===-1),...d.filter(w=>!m.$Jm(this.c.override(u).getValue(w),n.override(u).getValue(w)))];o.push([u,l])}return this.updateDefaultConfiguration(n),{keys:t,overrides:o}}compareAndUpdatePolicyConfiguration(n){const{added:t,updated:o,removed:g}=C(this.d,n),u=[...t,...o,...g];return u.length&&this.updatePolicyConfiguration(n),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:t,updated:o,removed:g,overrides:u}=C(this.applicationConfiguration,n),d=[...t,...o,...g];return d.length&&this.updateApplicationConfiguration(n),{keys:d,overrides:u}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:o,removed:g,overrides:u}=C(this.localUserConfiguration,n),d=[...t,...o,...g];return d.length&&this.updateLocalUserConfiguration(n),{keys:d,overrides:u}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:o,removed:g,overrides:u}=C(this.remoteUserConfiguration,n),d=[...t,...o,...g];return d.length&&this.updateRemoteUserConfiguration(n),{keys:d,overrides:u}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:o,removed:g,overrides:u}=C(this.workspaceConfiguration,n),d=[...t,...o,...g];return d.length&&this.updateWorkspaceConfiguration(n),{keys:d,overrides:u}}compareAndUpdateFolderConfiguration(n,t){const o=this.p.get(n),{added:g,updated:u,removed:d,overrides:v}=C(o,t),l=[...g,...u,...d];return(l.length||!o)&&this.updateFolderConfiguration(n,t),{keys:l,overrides:v}}compareAndDeleteFolderConfiguration(n){const t=this.p.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:o,updated:g,removed:u,overrides:d}=C(t,void 0);return{keys:[...o,...g,...u],overrides:d}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,t,o){let g=this.r(t,o);return t.overrideIdentifier&&(g=g.override(t.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(g=g.merge(this.d)),g}r({resource:n},t){let o=this.s();if(t&&n){const g=t.getFolder(n);g&&(o=this.t(g.uri)||o);const u=this.m.get(n);u&&(o=o.merge(u))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let t=this.b.get(n);if(!t){const o=this.s(),g=this.j.get(n);g?(t=o.merge(g),this.b.set(n,t)):t=o}return t}u(n,t){if(t&&n){const o=t.getFolder(n);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,t)=>{const{contents:o,overrides:g,keys:u}=this.j.get(t);return n.push([t,{contents:o,overrides:g,keys:u}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(t=>n.add(t)),this.userConfiguration.keys.forEach(t=>n.add(t)),this.i.keys.forEach(t=>n.add(t)),this.j.forEach(t=>t.keys.forEach(o=>n.add(o))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.i.getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.j.forEach(t=>t.getAllOverrideIdentifiers().forEach(o=>n.add(o))),[...n.values()]}w(n){const t=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this.i.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(n).forEach(g=>t.add(g))),[...t.values()]}static parse(n){const t=this.x(n.defaults),o=this.x(n.policy),g=this.x(n.application),u=this.x(n.user),d=this.x(n.workspace),v=n.folders.reduce((l,w)=>(l.set(b.URI.revive(w[0]),this.x(w[1])),l),new A.$li);return new c(t,o,g,u,new D,d,v,new D,new A.$li)}static x(n){return new D(n.contents,n.keys,n.overrides)}}e.$dn=c;function f(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,t=new Map;for(const g of a)g.keys.forEach(u=>n.add(u)),g.overrides.forEach(([u,d])=>{const v=(0,A.$ii)(t,u,new Set);d.forEach(l=>v.add(l))});const o=[];return t.forEach((g,u)=>o.push([u,[...g.values()]])),{keys:[...n.values()],overrides:o}}e.$en=f;class y{constructor(n,t,o,g){this.change=n,this.f=t,this.g=o,this.h=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const u of n.keys)this.affectedKeys.add(u);for(const[,u]of n.overrides)for(const d of u)this.affectedKeys.add(d);this.d=this.a;for(const u of this.affectedKeys)this.d+=u+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(n,t){const o=this.a+n,g=this.d.indexOf(o);if(g<0)return!1;const u=g+o.length;if(u>=this.d.length)return!1;const d=this.d.charCodeAt(u);if(d!==this.b&&d!==this.c)return!1;if(t){const v=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.f?.workspace):void 0,l=this.g.getValue(n,t,this.h);return!m.$Jm(v,l)}return!0}}e.$fn=y;function C(a,n){const{added:t,removed:o,updated:g}=i(n?.rawConfiguration,a?.rawConfiguration),u=[],d=a?.getAllOverrideIdentifiers()||[],v=n?.getAllOverrideIdentifiers()||[];if(n){const l=v.filter(w=>!d.includes(w));for(const w of l)u.push([w,n.getKeysForOverrideIdentifier(w)])}if(a){const l=d.filter(w=>!v.includes(w));for(const w of l)u.push([w,a.getKeysForOverrideIdentifier(w)])}if(n&&a){for(const l of d)if(v.includes(l)){const w=i({contents:a.getOverrideValue(void 0,l)||{},keys:a.getKeysForOverrideIdentifier(l)},{contents:n.getOverrideValue(void 0,l)||{},keys:n.getKeysForOverrideIdentifier(l)});u.push([l,[...w.added,...w.removed,...w.updated]])}}return{added:t,removed:o,updated:g,overrides:u}}function i(a,n){const t=a?n?a.keys.filter(u=>n.keys.indexOf(u)===-1):[...a.keys]:[],o=n?a?n.keys.filter(u=>a.keys.indexOf(u)===-1):[...n.keys]:[],g=[];if(a&&n){for(const u of n.keys)if(a.keys.indexOf(u)!==-1){const d=(0,R.$2h)(n.contents,u),v=(0,R.$2h)(a.contents,u);m.$Jm(d,v)||g.push(u)}}return{added:t,removed:o,updated:g}}}),define(De[130],Ce([1,0,8,5]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=e.RemoteAuthorityResolverErrorCode=e.$wk=e.$vk=e.RemoteConnectionType=e.$uk=void 0,e.$uk=(0,F.$nh)("remoteAuthorityResolverService");var h;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(h||(e.RemoteConnectionType=h={}));class L{constructor(I){this.id=I,this.type=1}toString(){return`Managed(${this.id})`}}e.$vk=L;class A{constructor(I,$){this.host=I,this.port=$,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$wk=A;var m;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class E extends k.$ab{static isNotAvailable(I){return I instanceof E&&I._code===m.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof E&&I._code===m.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof E&&I._code===m.NoResolverFound}static isInvalidAuthority(I){return I instanceof E&&I._code===m.InvalidAuthority}static isHandled(I){return I instanceof E&&I.isHandled}constructor(I,$=m.Unknown,S){super(I),this._message=I,this._code=$,this._detail=S,this.isHandled=$===m.NotAvailable&&S===!0,Object.setPrototypeOf(this,E.prototype)}}e.$xk=E;function b(R){const I=R.indexOf("+");return I===-1?R:R.substring(0,I)}e.$yk=b}),define(De[79],Ce([1,0,15]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=void 0;function F(b){return b.scheme===k.Schemas.vscodeRemote?b.authority:void 0}e.$zk=F;function h(b){if(!b)return;const R=b.indexOf("+");return R<0?b:b.substr(0,R)}e.$Ak=h;function L(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.$Bk=L;function A(b){const{host:R,port:I}=E(b);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:I}}e.$Ck=A;function m(b,R){let{host:I,port:$}=E(b);return typeof $>"u"&&($=R),{host:I,port:$}}e.$Dk=m;function E(b){const R=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const I=b.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const $=b.match(/(.*):(\d+)$/);return $?{host:$[1],port:parseInt($[2],10)}:{host:b,port:void 0}}}),define(De[25],Ce([1,0,12,5,79]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.TargetPlatform=e.ExtensionType=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=void 0,e.$zl="extensions.user.cache",e.$Al="extensions.builtin.cache",e.$Bl="undefined_publisher",e.$Cl=["ui","workspace","web"];function L(p){if(typeof p=="object"&&p!==null&&p.supported!==!0)return p.description}e.$Dl=L,e.$El=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(p){p[p.System=0]="System",p[p.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(p){p.WIN32_X64="win32-x64",p.WIN32_IA32="win32-ia32",p.WIN32_ARM64="win32-arm64",p.LINUX_X64="linux-x64",p.LINUX_ARM64="linux-arm64",p.LINUX_ARMHF="linux-armhf",p.ALPINE_X64="alpine-x64",p.ALPINE_ARM64="alpine-arm64",p.DARWIN_X64="darwin-x64",p.DARWIN_ARM64="darwin-arm64",p.WEB="web",p.UNIVERSAL="universal",p.UNKNOWN="unknown",p.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class E{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,s){if(typeof r>"u"||r===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof r=="string"||typeof s=="string"){const c=typeof r=="string"?r:r.value,f=typeof s=="string"?s:s.value;return k.$Ld(c,f)}return r._lower===s._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.$Fl=E;class b{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const s of r)this.add(s)}add(r){this.c.add(E.toKey(r))}delete(r){return this.c.delete(E.toKey(r))}has(r){return this.c.has(E.toKey(r))}}e.$Gl=b;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(E.toKey(r))}get(r){return this.c.get(E.toKey(r))}has(r){return this.c.has(E.toKey(r))}set(r,s){this.c.set(E.toKey(r),s)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Hl=R;function I(p){return $(p)}e.$Il=I;function $(p){return p.contributes&&p.contributes.localizations?p.contributes.localizations.length>0:!1}e.$Jl=$;function S(p){return p.contributes&&p.contributes.authentication?p.contributes.authentication.length>0:!1}e.$Kl=S;function D(p,r){if(r){const s=`onResolveRemoteAuthority:${(0,h.$Ak)(r)}`;return!!p.activationEvents?.includes(s)}return!1}e.$Ll=D,e.$Ml=(0,F.$nh)("IBuiltinExtensionsScannerService")}),define(De[131],Ce([1,0,8,25]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=void 0;class h{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const E of A){const b=this.readActivationEvents(E);b.length>0&&(m[F.$Fl.toKey(E.identifier)]=b)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return m;for(const E in A.contributes){const b=this.a.get(E);if(!b)continue;const R=A.contributes[E],I=Array.isArray(R)?R:[R];try{b(I,m)}catch($){(0,k.$Y)($)}}return m}}e.$gF=h,e.$hF=new h}),define(De[236],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jZb=void 0;class k{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(h){try{const L=await this.c();if(L){const A=String(k.a++);return this.b.set(A,L),{id:A,data:L.createNewMessage(h)}}}catch{}return{id:"",data:h}}async validate(h,L){if(!h.id)return!0;const A=this.b.get(h.id);if(!A)return!1;this.b.delete(h.id);try{return A.validate(L)==="ok"}catch{return!1}finally{A.dispose?.()}}async sign(h){try{return await this.d(h)}catch{}return h}}e.$jZb=k}),define(De[237],Ce([1,0,236]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$44b=void 0;class F extends k.$jZb{c(){return this.h().then(L=>new L.validator)}d(L){return this.h().then(A=>new A.signer().sign(L))}h(){return new Promise((L,A)=>me(["vsda"],L,A))}}e.$44b=F}),define(De[238],Ce([1,0,11,41,32]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=void 0;function L(E){if(k.$t===2&&/^penguin(\.|$)/i.test(E))return"chromebook"}function A(E,b,R,I,$,S,D,p){const r=Object.create(null);r["common.machineId"]=S,r.sessionID=(0,h.$5e)()+Date.now(),r.commitHash=I,r.version=$,r["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,k.$h)(k.$t),r["common.nodePlatform"]=F.$7b,r["common.nodeArch"]=R,r["common.product"]=p||"desktop",D&&(r["common.msftInternal"]=D);let s=0;const c=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),k.$l&&(r["common.snap"]="true");const f=L(b);return f&&(r["common.platformDetail"]=f),r}e.$Xn=A;function m(E){const b=F.env.USERDNSDOMAIN;if(!b)return!1;const R=b.toLowerCase();return E.some(I=>R===I)}e.$Yn=m}),define(De[239],Ce([1,0,5]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=void 0,e.$Tk=(0,k.$nh)("telemetryService"),e.$Uk=(0,k.$nh)("customEndpointTelemetryService"),e.$Vk="telemetry.currentSessionDate",e.$Wk="telemetry.firstSessionDate",e.$Xk="telemetry.lastSessionDate",e.$Yk="telemetry.machineId",e.$Zk="telemetry",e.$1k="telemetry.telemetryLevel",e.$2k="telemetry.enableCrashReporter",e.$3k="telemetry.enableTelemetry";var F;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(F||(e.TelemetryLevel=F={}));var h;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(h||(e.TelemetryConfiguration=h={}))}),define(De[80],Ce([1,0,23,14,3,57,79,238,239]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=void 0;class b{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$Zn=b;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$1n=R,e.$2n=new R;class I{async publicLog(o,g,u){}async publicLogError(o,g,u){}}e.$3n=I,e.$4n="telemetry",e.$5n="extensionTelemetryLog",e.$6n={log:()=>null,flush:()=>Promise.resolve(null)};function $(t,o){return h.Event.debounce(o.onDidChangeConfiguration,(u,d)=>{const v=u?new Set([...u.affectedKeys,...d.affectedKeys]):d.affectedKeys;return{...d,affectedKeys:v}},1e3,!0)(u=>{u.source!==7&&t.publicLog2("updateConfiguration",{configurationSource:(0,L.$Wh)(u.source),configurationKeys:Array.from(u.affectedKeys)})})}e.$7n=$;function S(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry||o.extensionTestsLocationURI)}e.$8n=S;function D(t,o){return!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$9n=D;function p(t){const o=t.getValue(E.$1k),g=t.getValue(E.$2k);if(t.getValue(E.$3k)===!1||g===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$0n=p;function r(t){const o={},g={},u={};f(t,u);for(let d in u){d=d.length>150?d.substr(d.length-149):d;const v=u[d];typeof v=="number"?g[d]=v:typeof v=="boolean"?g[d]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${v.length}`),o[d]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(o[d]=v)}return{properties:o,measurements:g}}e.$$n=r;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const o=(0,A.$Ak)(t);return s.has(o)?o:"other"}e.$_n=c;function f(t,o,g=0,u){if(t)for(const d of Object.getOwnPropertyNames(t)){const v=t[d],l=u?u+d:d;Array.isArray(v)?o[l]=(0,k.$Km)(v):v instanceof Date?o[l]=v.toISOString():(0,F.$ke)(v)?g<2?f(v,o,g+1,l+"."):o[l]=(0,k.$Km)(v):o[l]=v}}function y(t,o){const g=t.msftInternalDomains||[],u=o.getValue("telemetry.internalTesting");return(0,m.$Yn)(g)||u}e.$ao=y;function C(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$bo=C;function i(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let g=t;const u=[];for(const w of o)for(;;){const P=w.exec(t);if(!P)break;u.push([P.index,w.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(g="";;){const w=v.exec(t);if(!w)break;const P=u.some(([M,N])=>w.index<N&&M<v.lastIndex);!d.test(w[0])&&!P&&(g+=t.substring(l,w.index)+"<REDACTED: user-file-path>",l=v.lastIndex)}return l<t.length&&(g+=t.substr(l)),g}function a(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const g of o)if(g.regex.test(t))return`<REDACTED: ${g.label}>`;return t}function n(t,o){return(0,k.$Hm)(t,g=>{if(g instanceof b||Object.hasOwnProperty.call(g,"isTrustedTelemetryValue"))return g.value;if(typeof g=="string"){let u=g.replaceAll("%20"," ");u=i(u,o);for(const d of o)u=u.replace(d,"");return u=a(u),u}})}e.$co=n}),define(De[240],Ce([1,0,12,125,25,11,2,8,41,80]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=void 0;function R(n,t){return n.uuid&&t.uuid?n.uuid===t.uuid:n.id===t.id?!0:(0,k.$Gd)(n.id,t.id)===0}e.$do=R;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class ${static create(t){const o=t.manifest?t.manifest.version:t.version,g=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new $(t.identifier,o,g)}static parse(t){const o=I.exec(t);return o&&o[1]&&o[2]?new $({id:o[1]},o[2],o[4]||void 0):null}constructor(t,o,g="undefined"){this.version=o,this.targetPlatform=g,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof $?R(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$eo=$;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(n){const t=S.exec(n);return t&&t[1]?[r(t[1]),t[2]]:[r(n),void 0]}e.$fo=D;function p(n,t){return`${n}.${t}`}e.$go=p;function r(n){return n.toLowerCase()}e.$ho=r;function s(n,t){return r(p(n??h.$Bl,t))}e.$io=s;function c(n,t){const o=[],g=u=>{for(const d of o)if(d.some(v=>R(t(v),t(u))))return d;return null};for(const u of n){const d=g(u);d?d.push(u):o.push([u])}return o}e.$jo=c;function f(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$ko=f;function y(n){return{id:new b.$Zn(n.identifier.id),name:new b.$Zn(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$lo=y,e.$mo=new h.$Fl("pprice.better-merge");function C(n,t){const o=[],g=t.manifest.extensionDependencies?.slice(0)??[];for(;g.length;){const u=g.shift();if(u&&o.every(d=>!R(d.identifier,{id:u}))){const d=n.filter(v=>R(v.identifier,{id:u}));d.length===1&&(o.push(d[0]),g.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.$no=C;async function i(n,t){if(!L.$k)return!1;let o;try{o=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,m.$9)(u))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(n,t){const o=await i(n,t),g=(0,F.$In)(o?"alpine":L.$t,E.$8b);return t.debug("ComputeTargetPlatform:",g),g}e.$oo=a}),define(De[241],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=void 0;function k(E){return[...E.entries()]}e.$Xq=k;function F(E){return E?[...E.entries()]:[]}e.$Yq=F;function h(E){return new Map(E)}e.$Zq=h;function L(E){return new Map(E??[])}e.$1q=L;function A(E){return Array.from(E.entries()).map(b=>[b[0],k(b[1].map),F(b[1].descriptionMap)])}e.$2q=A;function m(E){return new Map(E.map(b=>[b[0],{map:h(b[1]),descriptionMap:L(b[2])}]))}e.$3q=m}),define(De[242],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ib=void 0;class k{constructor(h){this.b=h,this.a=new Map}dispose(){for(const h of this.a.values())h.dispose()}startBuffering(h,L,A=5){const m=L(E=>{const b=typeof E=="string"?E:E.data;let R=this.a.get(h);if(R){R.data.push(b);return}const I=setTimeout(()=>this.flushBuffer(h),A);R={data:[b],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(h),m.dispose()}},this.a.set(h,R)});return m}stopBuffering(h){this.a.get(h)?.dispose()}flushBuffer(h){const L=this.a.get(h);L&&(this.a.delete(h),this.b(h,L.data.join("")))}}e.$7ib=k}),define(De[243],Ce([1,0,17,72,55,3,14,2,190,100,42]),function(me,e,k,F,h,L,A,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.$Vu=e.$Uu=e.$Tu=e.$Su=e.$Ru=e.$Qu=e.IconFontDefinition=e.IconContribution=e.$Pu=void 0,e.$Pu={IconContribution:"base.contributions.icons"};var I;(function(y){function C(i,a){let n=i.defaults;for(;h.ThemeIcon.isThemeIcon(n);){const t=D.getIcon(n.id);if(!t)return;n=t.defaults}return n}y.getDefinition=C})(I||(e.IconContribution=I={}));var $;(function(y){function C(a){return{weight:a.weight,style:a.style,src:a.src.map(n=>({format:n.format,location:n.location.toString()}))}}y.toJSONObject=C;function i(a){const n=t=>(0,A.$ie)(t)?t:void 0;if(a&&Array.isArray(a.src)&&a.src.every(t=>(0,A.$ie)(t.format)&&(0,A.$ie)(t.location)))return{weight:n(a.weight),style:n(a.style),src:a.src.map(t=>({format:t.format,location:m.URI.parse(t.location)}))}}y.fromJSONObject=i})($||(e.IconFontDefinition=$={}));class S{constructor(){this.a=new L.$7c,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${h.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(C,i,a,n){const t=this.b[C];if(t){if(a&&!t.description){t.description=a,this.d.properties[C].markdownDescription=`${a} $(${C})`;const u=this.e.enum.indexOf(C);u!==-1&&(this.e.enumDescriptions[u]=a),this.a.fire()}return t}const o={id:C,description:a,defaults:i,deprecationMessage:n};this.b[C]=o;const g={$ref:"#/definitions/icons"};return n&&(g.deprecationMessage=n),a&&(g.markdownDescription=`${a}: $(${C})`),this.d.properties[C]=g,this.e.enum.push(C),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:C}}deregisterIcon(C){delete this.b[C],delete this.d.properties[C];const i=this.e.enum.indexOf(C);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(C=>this.b[C])}getIcon(C){return this.b[C]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(C,i){const a=this.f[C];return a||(this.f[C]=i,this.a.fire(),i)}deregisterIconFont(C){delete this.f[C]}getIconFont(C){return this.f[C]}toString(){const C=(t,o)=>t.id.localeCompare(o.id),i=t=>{for(;h.ThemeIcon.isThemeIcon(t.defaults);)t=this.b[t.defaults.id];return`codicon codicon-${t?t.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(t=>this.b[t]);for(const t of n.filter(o=>!!o.description).sort(C))a.push(`|<i class="${i(t)}"></i>|${t.id}|${h.ThemeIcon.isThemeIcon(t.defaults)?t.defaults.id:t.id}|${t.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const t of n.filter(o=>!h.ThemeIcon.isThemeIcon(o.defaults)).sort(C))a.push(`|<i class="${i(t)}"></i>|${t.id}|`);return a.join(`
`)}}const D=new S;R.$Rm.add(e.$Pu.IconContribution,D);function p(y,C,i,a){return D.registerIcon(y,C,i,a)}e.$Qu=p;function r(){return D}e.$Ru=r;function s(){const y=(0,F.$yj)();for(const C in y){const i="\\"+y[C].toString(16);D.registerIcon(C,{fontCharacter:i})}}s(),e.$Su="vscode://schemas/icons";const c=R.$Rm.as(b.$Sm.JSONContribution);c.registerSchema(e.$Su,D.getIconSchema());const f=new k.$Eg(()=>c.notifySchemaChanged(e.$Su),200);D.onDidChange(()=>{f.isScheduled()||f.schedule()}),e.$Tu=p("widget-close",F.$Aj.close,(0,E.localize)(2,null)),e.$Uu=p("goto-previous-location",F.$Aj.arrowUp,(0,E.localize)(3,null)),e.$Vu=p("goto-next-location",F.$Aj.arrowDown,(0,E.localize)(4,null)),e.$Wu=h.ThemeIcon.modify(F.$Aj.sync,"spin"),e.$Xu=h.ThemeIcon.modify(F.$Aj.loading,"spin")}),define(De[132],Ce([1,0,3,57,5,18]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nz=e.$Mz=e.$Lz=e.$Kz=e.$Jz=e.$Iz=e.$Hz=e.$Gz=e.ProvidedOnAutoForward=e.$Fz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ez=e.$Dz=void 0,e.$Dz=(0,h.$nh)("tunnelService"),e.$Ez=(0,h.$nh)("sharedTunnelsService");var A;(function(r){r.Http="http",r.Https="https"})(A||(e.TunnelProtocol=A={}));var m;(function(r){r.ConstantPrivate="constantPrivate",r.Private="private",r.Public="public"})(m||(e.TunnelPrivacyId=m={}));function E(r){return!!r.forwardPort}e.$Fz=E;var b;(function(r){r[r.Notify=1]="Notify",r[r.OpenBrowser=2]="OpenBrowser",r[r.OpenPreview=3]="OpenPreview",r[r.Silent=4]="Silent",r[r.Ignore=5]="Ignore",r[r.OpenBrowserOnce=6]="OpenBrowserOnce"})(b||(e.ProvidedOnAutoForward=b={}));function R(r){if(r.scheme!=="http"&&r.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(r.authority);if(s)return{address:s[1],port:+s[2]}}e.$Gz=R,e.$Hz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(r){return e.$Hz.indexOf(r)>=0}e.$Iz=I,e.$Jz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(r){return e.$Jz.indexOf(r)>=0}e.$Kz=$;function S(r,s,c,f){if(c===1)return!1;if(c===2&&$(s)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(f);if(y?.length===4&&parseInt(y[1])>=18)return!1}return r<1024}e.$Lz=S;class D{constructor(s,c,f){this.remoteAddress=s,this.localAddress=c,this.b=f,this.a=new k.$7c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Mz=D;let p=class{constructor(s,c){this.i=s,this.j=c,this.a=new k.$7c,this.onTunnelOpened=this.a.event,this.b=new k.$7c,this.onTunnelClosed=this.b.event,this.c=new k.$7c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const s=this.j.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.e=s,s?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.f=s.elevation,this.g=s.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const s=[],c=Array.from(this.d.values());for(const f of c){const y=Array.from(f.values());for(const C of y){const i=await C.value;i&&s.push(i)}}return s}async dispose(){for(const s of this.d.values()){for(const{value:c}of s.values())await c.then(f=>f?.dispose());s.clear()}this.d.clear()}setEnvironmentTunnel(s,c,f,y,C){this.o(s,c,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:c,localAddress:f,privacy:y,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,c){($(s)||I(s))&&(s=e.$Hz[0]);const f=this.q(s,c);if(f)return++f.refcount,f.value}openTunnel(s,c,f,y,C,i=!1,a,n){this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${f} on local port ${C}.`);const t=this.e??s;if(!t)return;if(c||(c="localhost"),y||(y=this.k),this.e&&this.h.has(f)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const o=this.r(t,c,f,y,C,i,a,n);return o?o.then(g=>{if(!g){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(c,f);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const u=this.m(g);return(g.tunnelRemoteHost!==c||g.tunnelRemotePort!==f)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),a&&g.privacy!==a&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(u),u}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),o)}m(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const c=this.d.get(s.tunnelRemoteHost);if(c){const f=c.get(s.tunnelRemotePort);f&&(f.refcount--,await this.n(s.tunnelRemoteHost,s.tunnelRemotePort,f))}}}}async n(s,c,f){if(f.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${c}.`);const y=f.value.then(async C=>{C&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.d.has(s)&&this.d.get(s).delete(c),y}}async closeTunnel(s,c){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${c} `);const f=this.d.get(s);if(f&&f.has(c)){const y=f.get(c);y.refcount=0,await this.n(s,c,y)}}o(s,c,f){this.d.has(s)||this.d.set(s,new Map),this.d.get(s).set(c,{refcount:1,value:f})}async p(s,c){const f=this.d.get(s);if(f){const y=f.get(c);(y?await y.value:void 0)||f.delete(c),f.size===0&&this.d.delete(s)}}q(s,c){const f=[s];I(s)?(f.push(...e.$Hz),f.push(...e.$Jz)):$(s)&&f.push(...e.$Jz);const y=f.map(C=>this.d.get(C));for(const C of y){const i=C?.get(c);if(i)return i}}canTunnel(s){return!!R(s)}s(s,c,f,y,C,i,a){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${f} on local port ${y}.`);const n=f;this.h.add(n);const t=y===void 0?f:y,o={elevationRequired:C?this.isPortPrivileged(t):!1},g={remoteAddress:{host:c,port:f},localAddressPort:y,privacy:i,public:i?i!==m.Private:void 0,protocol:a},u=s.forwardPort(g,o);return u?(this.o(c,f,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(n)})):this.h.delete(n),u}};e.$Nz=p,e.$Nz=p=Je([qe(0,L.$Pi),qe(1,F.$Th)],p)}),define(De[244],Ce([1,0,5]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Oz=void 0,e.$Oz=(0,k.$nh)("editSessionIdentityService");var F;(function(h){h[h.Complete=100]="Complete",h[h.Partial=50]="Partial",h[h.None=0]="None"})(F||(e.EditSessionIdentityMatch=F={}))}),define(De[245],Ce([1,0,15]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=void 0;function F(E){return E.scheme!==k.Schemas.file&&E.scheme!==k.Schemas.vscodeRemote}e.$7I=F;function h(E){if(E.folders.length)return E.folders.every(b=>F(b.uri))?E.folders[0].uri:void 0;if(E.configuration&&F(E.configuration))return E.configuration}e.$8I=h;function L(E){return h(E)?.scheme}e.$9I=L;function A(E){return h(E)?.authority}e.$0I=A;function m(E){return h(E)!==void 0}e.$$I=m}),define(De[50],Ce([1,0,191,13,71,24,2,5,15]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.WorkbenchState=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$wh=(0,m.$nh)("contextService");function b(t){const o=t;return typeof o?.id=="string"&&A.URI.isUri(o.uri)}e.$xh=b;function R(t){return typeof t?.id=="string"&&!b(t)&&!$(t)}e.$yh=R,e.$zh={id:"ext-dev"},e.$Ah={id:"empty-window"};function I(t,o){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,F.$ec)(t)}:o?e.$zh:e.$Ah;const g=t;return g.configuration?{id:g.id,configPath:g.configuration}:g.folders.length===1?{id:g.id,uri:g.folders[0].uri}:{id:g.id}}e.$Bh=I;function $(t){const o=t;return typeof o?.id=="string"&&A.URI.isUri(o.configPath)}e.$Ch=$;function S(t){const o=t;if(o?.uri)return{id:o.id,uri:A.URI.revive(o.uri)};const g=t;if(g?.configPath)return{id:g.id,configPath:A.URI.revive(g.configPath)};if(t?.id)return{id:t.id}}e.$Dh=S;var D;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(D||(e.WorkbenchState=D={}));function p(t){const o=t;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.$Eh=p;function r(t){const o=t;return!!(o&&typeof o=="object"&&A.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.$Fh=r;class s{constructor(o,g,u,d,v){this.h=o,this.j=u,this.k=d,this.l=v,this.c=h.$th.forUris(this.l,()=>!0),this.folders=g}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=h.$th.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gh=s;class c{constructor(o,g){this.raw=g,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,L.$8f)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hh=c;function f(t){return new c({uri:t,index:0,name:(0,L.$4f)(t)},{uri:t.toString()})}e.$Ih=f,e.$Jh="code-workspace",e.$Kh=`.${e.$Jh}`,e.$Lh=[{name:(0,k.localize)(0,null),extensions:[e.$Jh]}],e.$Mh="workspace.json";function y(t,o){return L.$Yf.isEqualOrParent(t,o.untitledWorkspacesHome)}e.$Nh=y;function C(t){let o;return A.URI.isUri(t)?o=t:o=t.configuration,o?.scheme===E.Schemas.tmp}e.$Oh=C,e.$Ph="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(t){return t.id===e.$Ph}e.$Qh=i;function a(t,o){return!y(t,o)&&!C(t)}e.$Rh=a;function n(t){return(typeof t=="string"?(0,F.$fc)(t):(0,L.$6f)(t))===e.$Kh}e.$Sh=n}),define(De[81],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=void 0;class k{static{this.a=!1}constructor(h){this.d=h,this.b=new Map,this.c=1}add(h){const L=this.c++;return this.b.set(L,h),this.e(),L}get(h,L){return this.b.has(h)?this.b.get(h)[L]:void 0}delete(h){this.b.delete(h),this.e()}e(){k.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$H$b=k}),define(De[51],Ce([1,0,15,24,5]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.$J$b=void 0;class L{constructor(){this.a=new Set(Object.keys(k.Schemas)),this.b=new Map,this.extUri=new F.$Wf(m=>{const E=this.b.get(m.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(m,E){E===null?this.b.delete(m.scheme):this.b.set(m.scheme,E)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$J$b=L,e.$K$b=(0,h.$nh)("IExtHostFileSystemInfo")}),define(De[26],Ce([1,0,5]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=void 0,e.$PL=(0,k.$nh)("IExtHostInitDataService")}),define(De[246],Ce([1,0,196,18,230,26]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=void 0;let A=class extends h.$WM{constructor(E,b,R){const I=R.remote.isRemote?"remoteexthost":E?"workerexthost":"exthost",$=R.remote.isRemote?(0,k.localize)(0,null):E?(0,k.localize)(1,null):(0,k.localize)(2,null);super(b.createLogger(I,{name:$}))}};e.$Mac=A,e.$Mac=A=Je([qe(1,F.$Qi),qe(2,L.$PL)],A)}),define(De[247],Ce([1,0,17]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_b=e.$a_b=void 0;class F{constructor(A,m,E){this.h=new Map,this.a=A,this.b=m,this.c=E,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(b=>(this.f=b,this)),this.g=this.c.onDidChangeStorage(b=>{b.shared===this.b&&b.key===this.a&&(this.f=b.value)}),this.i=new k.$Eg(()=>{const b=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of b.values())R.complete()}catch(R){for(const I of b.values())I.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let E=this.f[A];return typeof E>"u"&&(E=m),E}update(A,m){this.f[A]=m;const E=this.h.get(A);if(E!==void 0)return E.p;const b=new k.$Ng;return this.h.set(A,b),this.i.isScheduled()||this.i.schedule(),b.p}dispose(){this.g.dispose()}}e.$a_b=F;class h extends F{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$b_b=h}),define(De[248],Ce([1,0,3,2]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=void 0;class h{constructor(A){this.c=A,this.a=new k.$7c,this.onDidSaveNotebookDocument=this.a.event,this.b=new k.$7c,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,E,b){const I=this.c.getNotebookDocument(F.URI.revive(A)).acceptModelChanged(m.value,E,b);this.b.fire(I)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(F.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(F.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$zac=h}),define(De[20],Ce([1,0,5]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=e.$zL=void 0,e.$zL=(0,k.$nh)("IExtHostRpcService");class F{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.$AL=F}),define(De[249],Ce([1,0,25,3]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=void 0;class h{#e;constructor(A,m){this.b=new F.$7c,this.onDidChange=this.b.event,this.a=k.$Fl.toKey(A.identifier),this.#e=m,this.#e.onDidChangePassword(E=>{E.extensionId===this.a&&this.b.fire({key:E.key})})}get(A){return this.#e.get(this.a,A)}store(A,m){return this.#e.store(this.a,A,m)}delete(A){return this.#e.delete(this.a,A)}}e.$m_b=h}),define(De[58],Ce([1,0,5]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=e.$U$b=void 0,e.$U$b=(0,k.$nh)("IURITransformerService");class F{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$V$b=F}),define(De[250],Ce([1,0,22]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30=e.$20=void 0;class F{constructor(){this.buffers=[]}add(E){let b=this.buffers.indexOf(E);return b<0&&(b=this.buffers.length,this.buffers.push(E)),b}}function h(m,E){if(E.serializeBuffersForPostMessage){const b=new F,I=JSON.stringify(m,(S,D)=>{if(D instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:b.add(D)};if(ArrayBuffer.isView(D)){const p=L(D);if(p)return{$$vscode_array_buffer_reference$$:!0,index:b.add(D.buffer),view:{type:p,byteLength:D.byteLength,byteOffset:D.byteOffset}}}return D}),$=b.buffers.map(S=>{const D=new Uint8Array(S);return k.$Jb.wrap(D)});return{message:I,buffers:$}}else return{message:JSON.stringify(m),buffers:[]}}e.$20=h;function L(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,E){const b=E.map($=>{const S=new ArrayBuffer($.byteLength);return new Uint8Array(S).set($.buffer),S}),R=E.length?($,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const D=S,{index:p}=D,r=b[p];if(D.view)switch(D.view.type){case 1:return new Int8Array(r,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return S}:void 0;return{message:JSON.parse(m,R),arrayBuffers:b}}e.$30=A}),define(De[251],Ce([1,0,252,353,354,101,2,355]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ibc=void 0;const E=!1;function b(c,f,y,C,i,a){const n=a.environment.useHostProxy,t=typeof n=="boolean"?n:!a.remote.isRemote,o={resolveProxy:d=>c.resolveProxy(d),lookupProxyAuthorization:p.bind(void 0,C,i,f,{},a.remote.isRemote),getProxyURL:()=>f.getConfiguration("http").get("proxy"),getProxySupport:()=>f.getConfiguration("http").get("proxySupport")||"off",getSystemCertificatesV1:()=>I(f),getSystemCertificatesV2:()=>$(f),log:(d,v,...l)=>{switch(d){case m.LogLevel.Trace:C.trace(v,...l);break;case m.LogLevel.Debug:C.debug(v,...l);break;case m.LogLevel.Info:C.info(v,...l);break;case m.LogLevel.Warning:C.warn(v,...l);break;case m.LogLevel.Error:C.error(v,...l);break;case m.LogLevel.Critical:C.error(v,...l);break;case m.LogLevel.Off:break;default:w(d,v,l);break}function w(P,M,...N){C.error("Unknown log level",P),C.error(M,...N)}},getLogLevel:()=>C.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:t,addCertificates:[],env:process.env},g=(0,m.createProxyResolver)(o),u=R(o,g);return D(y,u)}e.$ibc=b;function R(c,f){return{http:Object.assign(k,(0,m.createHttpPatch)(c,k,f)),https:Object.assign(F,(0,m.createHttpPatch)(c,F,f)),net:Object.assign(L,(0,m.createNetPatch)(c,L)),tls:Object.assign(h,(0,m.createTlsPatch)(c,h))}}function I(c){const f=c.getConfiguration("http");return!f.get("experimental.systemCertificatesV2",E)&&!!f.get("systemCertificates")}function $(c){const f=c.getConfiguration("http");return!!f.get("experimental.systemCertificatesV2",E)&&!!f.get("systemCertificates")}const S=new Map;function D(c,f){return c.getExtensionPathIndex().then(y=>{const C=globalThis._VSCODE_NODE_MODULES.module,i=C._load;C._load=function(n,t,o){if(n==="net")return f.net;if(n==="tls")return f.tls;if(n!=="http"&&n!=="https")return i.apply(this,arguments);const g=y.findSubstr(A.URI.file(t.filename));let u=S.get(g);if(u||S.set(g,u={}),!u[n]){const d=f[n];u[n]={...d}}return u[n]}})}async function p(c,f,y,C,i,a,n,t){const o=C[a];n&&(C[a]=n),c.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${a}`,`proxyAuthenticate:${n}`,`proxyAuthenticateCache:${o}`);const g=n||o,u=Array.isArray(g)?g:typeof g=="string"?[g]:[];if(s(f,u,i),u.some(d=>/^(Negotiate|Kerberos)( |$)/i.test(d))&&!t.kerberosRequested)try{t.kerberosRequested=!0;const d=await new Promise((M,N)=>{me(["kerberos"],M,N)}),v=new URL(a),l=y.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${v.hostname}`:`HTTP@${v.hostname}`);return c.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${a}`,`spn:${l}`),"Negotiate "+await(await d.initializeClient(l)).step("")}catch(d){c.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",d)}}let r=!1;function s(c,f,y){r||!f.length||(r=!0,c.$publicLog2("proxyAuthenticationRequest",{authenticationType:f.map(C=>C.split(" ")[0]).join(","),extensionHostType:y?"remote":"local"}))}}),define(De[253],Ce([1,0,121]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;function F(L){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:L,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function h(L){return new k.$lm(F(L))}e.$br=h}),define(De[133],Ce([1,0,206,14,2,4,5,42,30,15,45,169,40]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NE=e.$ME=e.$LE=e.EditorsOrder=e.$KE=e.CloseDirection=e.$JE=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.EditorInputCapabilities=e.$AE=e.SaveReason=e.Verbosity=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=void 0,e.$oE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$pE={id:"default",displayName:(0,k.localize)(0,null),providerDisplayName:(0,k.localize)(1,null)},e.$qE="workbench.editor.sidebysideEditor",e.$rE="workbench.editors.textDiffEditor",e.$sE="workbench.editors.binaryResourceDiffEditor";var S;(function(V){V[V.PROGRAMMATIC=1]="PROGRAMMATIC",V[V.USER=2]="USER",V[V.EDIT=3]="EDIT",V[V.NAVIGATION=4]="NAVIGATION",V[V.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var D;(function(V){V[V.IDENTICAL=1]="IDENTICAL",V[V.SIMILAR=2]="SIMILAR",V[V.DIFFERENT=3]="DIFFERENT"})(D||(e.EditorPaneSelectionCompareResult=D={}));function p(V){const ce=V;return!!ce&&typeof ce.getSelection=="function"&&!!ce.onDidChangeSelection}e.$tE=p;function r(V,ce,re){for(const fe of re.visibleEditorPanes)if(fe.group.id===ce&&V.matches(fe.input))return fe.getViewState()}e.$uE=r;function s(V){if(g(V))return!1;const ce=V;return h.URI.isUri(ce?.resource)}e.$vE=s;function c(V){if(g(V))return!1;const ce=V;return ce?.original!==void 0&&ce.modified!==void 0}e.$wE=c;function f(V){if(g(V)||c(V))return!1;const ce=V;return ce?.primary!==void 0&&ce.secondary!==void 0}e.$xE=f;function y(V){if(g(V))return!1;const ce=V;return ce?ce.resource===void 0||ce.resource.scheme===b.Schemas.untitled||ce.forceUntitled===!0:!1}e.$yE=y;function C(V){if(g(V))return!1;const ce=V;return h.URI.isUri(ce?.base?.resource)&&h.URI.isUri(ce?.input1?.resource)&&h.URI.isUri(ce?.input2?.resource)&&h.URI.isUri(ce?.result?.resource)}e.$zE=C;var i;(function(V){V[V.SHORT=0]="SHORT",V[V.MEDIUM=1]="MEDIUM",V[V.LONG=2]="LONG"})(i||(e.Verbosity=i={}));var a;(function(V){V[V.EXPLICIT=1]="EXPLICIT",V[V.AUTO=2]="AUTO",V[V.FOCUS_CHANGE=3]="FOCUS_CHANGE",V[V.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class n{constructor(){this.a=new Map}registerSource(ce,re){let fe=this.a.get(ce);return fe||(fe={source:ce,label:re},this.a.set(ce,fe)),fe.source}getSourceLabel(ce){return this.a.get(ce)?.label??ce}}e.$AE=new n;var t;(function(V){V[V.None=0]="None",V[V.Readonly=2]="Readonly",V[V.Untitled=4]="Untitled",V[V.Singleton=8]="Singleton",V[V.RequiresTrust=16]="RequiresTrust",V[V.CanSplitInGroup=32]="CanSplitInGroup",V[V.ForceDescription=64]="ForceDescription",V[V.CanDropIntoEditor=128]="CanDropIntoEditor",V[V.MultipleEditors=256]="MultipleEditors",V[V.Scratchpad=512]="Scratchpad"})(t||(e.EditorInputCapabilities=t={}));class o extends L.$lb{}e.$BE=o;function g(V){return V instanceof o}e.$CE=g;function u(V){const ce=V;return h.URI.isUri(ce?.preferredResource)}function d(V){const ce=V;return g(ce?.primary)&&g(ce?.secondary)}e.$DE=d;function v(V){const ce=V;return g(ce?.modified)&&g(ce?.original)}e.$EE=v;function l(V,ce,re,fe,de){return q(fe,[(0,I.$0h)({id:"workbench.action.openLargeFile",label:(0,k.localize)(2,null),run:()=>{const B={...re,limits:{size:Number.MAX_VALUE}};V.openEditor(ce,B)}}),(0,I.$0h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,k.localize)(3,null),run:()=>de.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:$.default.Warning})}e.$FE=l;function w(V){return g(V?.editor)}e.$GE=w;function P(V){const ce=V;return w(V)&&ce?.group!==void 0}e.$HE=P;function M(V){const ce=V;return typeof ce?.groupId=="number"&&g(ce.editor)}e.$IE=M;var N;(function(V){V[V.UNKNOWN=0]="UNKNOWN",V[V.REPLACE=1]="REPLACE",V[V.MOVE=2]="MOVE",V[V.UNPIN=3]="UNPIN"})(N||(e.EditorCloseContext=N={}));var T;(function(V){V[V.GROUP_ACTIVE=0]="GROUP_ACTIVE",V[V.GROUP_INDEX=1]="GROUP_INDEX",V[V.GROUP_LOCKED=2]="GROUP_LOCKED",V[V.EDITOR_OPEN=3]="EDITOR_OPEN",V[V.EDITOR_CLOSE=4]="EDITOR_CLOSE",V[V.EDITOR_MOVE=5]="EDITOR_MOVE",V[V.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",V[V.EDITOR_LABEL=7]="EDITOR_LABEL",V[V.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",V[V.EDITOR_PIN=9]="EDITOR_PIN",V[V.EDITOR_STICKY=10]="EDITOR_STICKY",V[V.EDITOR_DIRTY=11]="EDITOR_DIRTY",V[V.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(T||(e.GroupModelChangeKind=T={}));var z;(function(V){V[V.PRIMARY=1]="PRIMARY",V[V.SECONDARY=2]="SECONDARY",V[V.BOTH=3]="BOTH",V[V.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class j{getOriginalUri(ce,re){if(!ce)return;if(C(ce))return e.$JE.getOriginalUri(ce.result,re);if(re?.supportSideBySide){const{primary:de,secondary:B}=this.a(ce);if(de&&B){if(re?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:re.filterByScheme}),secondary:this.getOriginalUri(B,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===z.ANY)return this.getOriginalUri(de,{filterByScheme:re.filterByScheme})??this.getOriginalUri(B,{filterByScheme:re.filterByScheme});ce=re.supportSideBySide===z.PRIMARY?de:B}}if(c(ce)||f(ce)||C(ce))return;const fe=u(ce)?ce.preferredResource:ce.resource;return!fe||!re||!re.filterByScheme?fe:this.b(fe,re.filterByScheme)}a(ce){return d(ce)||f(ce)?{primary:ce.primary,secondary:ce.secondary}:v(ce)||c(ce)?{primary:ce.modified,secondary:ce.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ce,re){if(!ce)return;if(C(ce))return e.$JE.getCanonicalUri(ce.result,re);if(re?.supportSideBySide){const{primary:de,secondary:B}=this.a(ce);if(de&&B){if(re?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:re.filterByScheme}),secondary:this.getCanonicalUri(B,{filterByScheme:re.filterByScheme})};if(re?.supportSideBySide===z.ANY)return this.getCanonicalUri(de,{filterByScheme:re.filterByScheme})??this.getCanonicalUri(B,{filterByScheme:re.filterByScheme});ce=re.supportSideBySide===z.PRIMARY?de:B}}if(c(ce)||f(ce)||C(ce))return;const fe=ce.resource;return!fe||!re||!re.filterByScheme?fe:this.b(fe,re.filterByScheme)}b(ce,re){if(Array.isArray(re)){if(re.some(fe=>ce.scheme===fe))return ce}else if(re===ce.scheme)return ce}}e.$JE=new j;var U;(function(V){V[V.LEFT=0]="LEFT",V[V.RIGHT=1]="RIGHT"})(U||(e.CloseDirection=U={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(ce){const re=this.a=ce.get(A.$mh);for(const[fe,de]of this.c)this.e(fe,de,re);this.c.clear()}e(ce,re,fe){const de=fe.createInstance(re);this.d.set(ce,de)}registerFileEditorFactory(ce){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ce}getFileEditorFactory(){return(0,F.$te)(this.b)}registerEditorSerializer(ce,re){if(this.c.has(ce)||this.d.has(ce))throw new Error(`A editor serializer with type ID '${ce}' was already registered.`);return this.a?this.e(ce,re,this.a):this.c.set(ce,re),(0,L.$jb)(()=>{this.c.delete(ce),this.d.delete(ce)})}getEditorSerializer(ce){return this.d.get(typeof ce=="string"?ce:ce.typeId)}}m.$Rm.add(e.$oE.EditorFactory,new Y);async function H(V,ce,re){return!V||!V.length?[]:await Promise.all(V.map(async fe=>{const de=h.URI.revive(fe.fileUri);if(!de){re.info("Cannot resolve the path because it is not valid.",fe);return}if(!await ce.canHandleResource(de)){re.info("Cannot resolve the path because it cannot be handled",fe);return}let _=fe.exists,Ee=fe.type;if(typeof _!="boolean"||typeof Ee!="number")try{Ee=(await ce.stat(de)).isDirectory?E.FileType.Directory:E.FileType.Unknown,_=!0}catch(ne){re.error(ne),_=!1}if(!_&&fe.openOnlyIfExists){re.info("Cannot resolve the path because it does not exist",fe);return}if(Ee===E.FileType.Directory){re.info("Cannot resolve the path because it is a directory",fe);return}const Re={...fe.options,pinned:!0};return _?{resource:de,options:Re}:{resource:de,options:Re,forceUntitled:!0}}))}e.$KE=H;var ge;(function(V){V[V.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",V[V.SEQUENTIAL=1]="SEQUENTIAL"})(ge||(e.EditorsOrder=ge={}));function ie(V){const ce=V;if(!ce)return!1;const re=ce;if(re.modified)return ie(re.modified);const fe=ce;return!!(fe.contributionsState&&fe.viewState&&Array.isArray(fe.cursorState))}e.$LE=ie;function te(V){return(0,R.$_h)(V)}e.$ME=te;function q(V,ce,re){const fe=(0,R.$ai)(V,ce);return fe.forceMessage=re?.forceMessage,fe.forceSeverity=re?.forceSeverity,fe.allowDialog=re?.allowDialog,fe}e.$NE=q}),define(De[254],Ce([1,0,3,207,5,4,28,42,19,65,23,72,243]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UE=e.$TE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$SE=e.$RE=e.ViewContentGroups=e.$QE=e.$PE=e.ViewContainerLocation=e.Extensions=e.$OE=void 0,e.$OE=(0,$.$Qu)("default-view-icon",I.$Aj.window,(0,F.localize)(0,null));var S;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var D;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(D||(e.ViewContainerLocation=D={})),e.$PE=[0,1,2];function p(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$QE=p;class r extends L.$lb{constructor(){super(...arguments),this.c=this.B(new k.$7c),this.onDidRegister=this.c.event,this.f=this.B(new k.$7c),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,E.$xf)([...this.g.values()])}registerViewContainer(t,o,g){const u=this.get(t.id);if(u)return u;const d=t;return d.openCommandActionDescriptor=g?.doNotRegisterOpenCommand?void 0:d.openCommandActionDescriptor??{id:d.id},(0,A.$ii)(this.g,o,[]).push(d),g?.isDefault&&this.h.push(d),this.c.fire({viewContainer:d,viewContainerLocation:o}),d}deregisterViewContainer(t){for(const o of this.g.keys()){const g=this.g.get(o),u=g?.indexOf(t);if(u!==-1){g?.splice(u,1),g.length===0&&this.g.delete(o),this.f.fire({viewContainer:t,viewContainerLocation:o});return}}}get(t){return this.all.filter(o=>o.id===t)[0]}getViewContainers(t){return[...this.g.get(t)||[]]}getViewContainerLocation(t){return[...this.g.keys()].filter(o=>this.getViewContainers(o).filter(g=>g?.id===t.id).length>0)[0]}getDefaultViewContainer(t){return this.h.find(o=>this.getViewContainerLocation(o)===t)}}m.$Rm.add(S.ViewContainersRegistry,new r);var s;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(s||(e.ViewContentGroups=s={}));function c(n,t){const o=n.group??s.More,g=t.group??s.More;return o!==g?o.localeCompare(g):(n.order??5)-(t.order??5)}class f extends L.$lb{constructor(){super(...arguments),this.c=this.B(new k.$7c),this.onViewsRegistered=this.c.event,this.f=this.B(new k.$7c),this.onViewsDeregistered=this.f.event,this.g=this.B(new k.$7c),this.onDidChangeContainer=this.g.event,this.h=this.B(new k.$7c),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new b.$L}registerViews(t,o){this.registerViews2([{views:t,viewContainer:o}])}registerViews2(t){t.forEach(({views:o,viewContainer:g})=>this.l(o,g)),this.c.fire(t)}deregisterViews(t,o){const g=this.m(t,o);g.length&&this.f.fire({views:g,viewContainer:o})}moveViews(t,o){for(const g of this.j.keys())if(g!==o){const u=this.m(t,g);u.length&&(this.l(u,o),this.g.fire({views:u,from:g,to:o}))}}getViews(t){return this.j.get(t)||[]}getView(t){for(const o of this.i){const g=(this.j.get(o)||[]).filter(u=>u.id===t)[0];if(g)return g}return null}getViewContainer(t){for(const o of this.i)if((this.j.get(o)||[]).filter(u=>u.id===t)[0])return o;return null}registerViewWelcomeContent(t,o){return this.k.add(t,o),this.h.fire(t),(0,L.$jb)(()=>{this.k.delete(t,o),this.h.fire(t)})}registerViewWelcomeContent2(t,o){const g=new Map;for(const[u,d]of o)this.k.add(t,d),g.set(u,(0,L.$jb)(()=>{this.k.delete(t,d),this.h.fire(t)}));return this.h.fire(t),g}getViewWelcomeContent(t){const o=[];return this.k.forEach(t,g=>o.push(g)),o.sort(c)}l(t,o){let g=this.j.get(o);g||(g=[],this.j.set(o,g),this.i.push(o));for(const u of t){if(this.getView(u.id)!==null)throw new Error((0,F.localize)(1,null,u.id));g.push(u)}}m(t,o){const g=this.j.get(o);if(!g)return[];const u=[],d=[];for(const v of g)t.includes(v)?u.push(v):d.push(v);return u.length&&(d.length?this.j.set(o,d):(this.j.delete(o),this.i.splice(this.i.indexOf(o),1))),u}}m.$Rm.add(S.ViewsRegistry,new f),e.$RE=(0,h.$nh)("viewsService"),e.$SE=(0,h.$nh)("viewDescriptorService");var y;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(y||(e.ViewVisibilityState=y={}));var C;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(C||(e.TreeItemCollapsibleState=C={}));class i{constructor(t,o){this.c=!1,this.d=!1,(0,R.$Im)(this,t),this.d=!!o,this.resolve=async g=>{if(o&&!this.c){const u=await o(g);u&&(this.tooltip=this.tooltip??u.tooltip,this.command=this.command??u.command)}g.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$TE=i;class a extends Error{constructor(t){super((0,F.localize)(2,null,t)),this.name="NoTreeViewError"}static is(t){return t.name==="NoTreeViewError"}}e.$UE=a}),define(De[134],Ce([1,0,3,17,208]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v$=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new k.$7c,this.n=new k.$7c,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,E,b,R){const I={command:m};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.s("request",I),typeof R=="number"){const $=setTimeout(()=>{clearTimeout($);const S=this.f.get(I.seq);if(S){this.f.delete(I.seq);const D={type:"response",seq:0,request_seq:I.seq,success:!1,command:m,message:(0,h.localize)(0,null,R,m)};S(D)}},R)}return b&&this.f.set(I.seq,b),I.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,E){return m.type!=="event"||E.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,F.$ug)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const E=m,b=this.f.get(E.request_seq);b&&(this.f.delete(E.request_seq),b(E));break}}}}s(m,E){E.type=m,E.seq=this.d++,this.sendMessage(E)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((E,b)=>m.set(b,E)),await(0,F.$ug)(500),m.forEach((E,b)=>{E({type:"response",seq:0,request_seq:b,success:!1,command:"canceled",message:"canceled"}),this.f.delete(b)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$v$=L}),define(De[255],Ce([1,0,209,47,5]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$6G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$5G=e.MemoryRangeType=e.$4G=e.State=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=void 0,e.$2F="workbench.view.debug",e.$3F="workbench.debug.variablesView",e.$4F="workbench.debug.watchExpressionsView",e.$5F="workbench.debug.callStackView",e.$6F="workbench.debug.loadedScriptsView",e.$7F="workbench.debug.breakPointsView",e.$8F="workbench.debug.disassemblyView",e.$9F="workbench.panel.repl",e.$0F="workbench.panel.repl.view",e.$$F=new F.$Mi("debugType",void 0,{type:"string",description:k.localize(0,null)}),e.$_F=new F.$Mi("debugConfigurationType",void 0,{type:"string",description:k.localize(1,null)}),e.$aG=new F.$Mi("debugState","inactive",{type:"string",description:k.localize(2,null)}),e.$bG="debugUx",e.$cG=new F.$Mi(e.$bG,"default",{type:"string",description:k.localize(3,null)}),e.$dG=new F.$Mi("hasDebugged",!1,{type:"boolean",description:k.localize(4,null)}),e.$eG=new F.$Mi("inDebugMode",!1,{type:"boolean",description:k.localize(5,null)}),e.$fG=new F.$Mi("inDebugRepl",!1,{type:"boolean",description:k.localize(6,null)}),e.$gG=new F.$Mi("breakpointWidgetVisible",!1,{type:"boolean",description:k.localize(7,null)}),e.$hG=new F.$Mi("inBreakpointWidget",!1,{type:"boolean",description:k.localize(8,null)}),e.$iG=new F.$Mi("breakpointsFocused",!0,{type:"boolean",description:k.localize(9,null)}),e.$jG=new F.$Mi("watchExpressionsFocused",!0,{type:"boolean",description:k.localize(10,null)}),e.$kG=new F.$Mi("watchExpressionsExist",!1,{type:"boolean",description:k.localize(11,null)}),e.$lG=new F.$Mi("variablesFocused",!0,{type:"boolean",description:k.localize(12,null)}),e.$mG=new F.$Mi("expressionSelected",!1,{type:"boolean",description:k.localize(13,null)}),e.$nG=new F.$Mi("breakpointInputFocused",!1,{type:"boolean",description:k.localize(14,null)}),e.$oG=new F.$Mi("callStackItemType",void 0,{type:"string",description:k.localize(15,null)}),e.$pG=new F.$Mi("callStackSessionIsAttach",!1,{type:"boolean",description:k.localize(16,null)}),e.$qG=new F.$Mi("callStackItemStopped",!1,{type:"boolean",description:k.localize(17,null)}),e.$rG=new F.$Mi("callStackSessionHasOneThread",!1,{type:"boolean",description:k.localize(18,null)}),e.$sG=new F.$Mi("watchItemType",void 0,{type:"string",description:k.localize(19,null)}),e.$tG=new F.$Mi("canViewMemory",void 0,{type:"boolean",description:k.localize(20,null)}),e.$uG=new F.$Mi("breakpointItemType",void 0,{type:"string",description:k.localize(21,null)}),e.$vG=new F.$Mi("breakpointSupportsCondition",!1,{type:"boolean",description:k.localize(22,null)}),e.$wG=new F.$Mi("loadedScriptsSupported",!1,{type:"boolean",description:k.localize(23,null)}),e.$xG=new F.$Mi("loadedScriptsItemType",void 0,{type:"string",description:k.localize(24,null)}),e.$yG=new F.$Mi("focusedSessionIsAttach",!1,{type:"boolean",description:k.localize(25,null)}),e.$zG=new F.$Mi("stepBackSupported",!1,{type:"boolean",description:k.localize(26,null)}),e.$AG=new F.$Mi("restartFrameSupported",!1,{type:"boolean",description:k.localize(27,null)}),e.$BG=new F.$Mi("stackFrameSupportsRestart",!1,{type:"boolean",description:k.localize(28,null)}),e.$CG=new F.$Mi("jumpToCursorSupported",!1,{type:"boolean",description:k.localize(29,null)}),e.$DG=new F.$Mi("stepIntoTargetsSupported",!1,{type:"boolean",description:k.localize(30,null)}),e.$EG=new F.$Mi("breakpointsExist",!1,{type:"boolean",description:k.localize(31,null)}),e.$FG=new F.$Mi("debuggersAvailable",!1,{type:"boolean",description:k.localize(32,null)}),e.$GG=new F.$Mi("debugExtensionAvailable",!0,{type:"boolean",description:k.localize(33,null)}),e.$HG=new F.$Mi("debugProtocolVariableMenuContext",void 0,{type:"string",description:k.localize(34,null)}),e.$IG=new F.$Mi("debugSetVariableSupported",!1,{type:"boolean",description:k.localize(35,null)}),e.$JG=new F.$Mi("debugSetExpressionSupported",!1,{type:"boolean",description:k.localize(36,null)}),e.$KG=new F.$Mi("breakWhenValueChangesSupported",!1,{type:"boolean",description:k.localize(37,null)}),e.$LG=new F.$Mi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:k.localize(38,null)}),e.$MG=new F.$Mi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:k.localize(39,null)}),e.$NG=new F.$Mi("terminateDebuggeeSupported",!1,{type:"boolean",description:k.localize(40,null)}),e.$OG=new F.$Mi("suspendDebuggeeSupported",!1,{type:"boolean",description:k.localize(41,null)}),e.$PG=new F.$Mi("variableEvaluateNamePresent",!1,{type:"boolean",description:k.localize(42,null)}),e.$QG=new F.$Mi("variableIsReadonly",!1,{type:"boolean",description:k.localize(43,null)}),e.$RG=new F.$Mi("exceptionWidgetVisible",!1,{type:"boolean",description:k.localize(44,null)}),e.$SG=new F.$Mi("multiSessionRepl",!1,{type:"boolean",description:k.localize(45,null)}),e.$TG=new F.$Mi("multiSessionDebug",!1,{type:"boolean",description:k.localize(46,null)}),e.$UG=new F.$Mi("disassembleRequestSupported",!1,{type:"boolean",description:k.localize(47,null)}),e.$VG=new F.$Mi("disassemblyViewFocus",!1,{type:"boolean",description:k.localize(48,null)}),e.$WG=new F.$Mi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:k.localize(49,null)}),e.$XG=new F.$Mi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:k.localize(50,null)});const L=$=>k.localize(51,null,$);e.$YG=L,e.$ZG="editor.contrib.debug",e.$1G="editor.contrib.breakpoint",e.$2G="debug",e.$3G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:k.localize(52,null)};var A;(function($){$[$.Inactive=0]="Inactive",$[$.Initializing=1]="Initializing",$[$.Stopped=2]="Stopped",$[$.Running=3]="Running"})(A||(e.State=A={}));function m($){switch($){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$4G=m;var E;(function($){$[$.Valid=0]="Valid",$[$.Unreadable=1]="Unreadable",$[$.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$5G="vscode-debug-memory";var b;(function($){$[$.Initial=1]="Initial",$[$.Dynamic=2]="Dynamic"})(b||(e.DebugConfigurationProviderTriggerKind=b={}));var R;(function($){$.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$6G=(0,h.$nh)("debugService");var I;(function($){$[$.CONDITION=0]="CONDITION",$[$.HIT_COUNT=1]="HIT_COUNT",$[$.LOG_MESSAGE=2]="LOG_MESSAGE"})(I||(e.BreakpointWidgetContext=I={}))}),define(De[256],Ce([1,0,12,2,13,23,15,33,21,19]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=void 0;const R=/{([^}]+)}/g;function I(u,d,v){return u.replace(R,function(l,w){return d&&w.length>0&&w[0]!=="_"?l:v&&v.hasOwnProperty(w)?v[w]:l})}e.$2E=I;function $(u){const d={};for(const v of Object.keys(u))v.startsWith("!")||(d[v]=u[v]);return d}e.$3E=$;function S(u){return u.configuration.request==="attach"&&!D(u)&&(!u.parentSession||S(u.parentSession))}e.$4E=S;function D(u){let d=u.configuration.type;if(d)return d==="vslsShare"&&(d=u.configuration.adapterProxy.configuration.type),(0,k.$Ld)(d,"extensionhost")||(0,k.$Ld)(d,"pwa-extensionhost")?u:u.parentSession?D(u.parentSession):void 0}e.$5E=D;function p(u){return u.type&&(u.label||u.program||u.runtime)}e.$6E=p;function r(u,d,v){let l,w=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let M=null;for(;M=P.exec(u);){const N=M.index+1,T=N+M[0].length;if(N<=d&&T>=v){l=M[0],w=N;break}}if(l){const N=/\w+/g;let T=null;for(;(T=N.exec(l))&&!(T.index+1+w+T[0].length>=v););T&&(l=l.substring(0,N.lastIndex))}return l?{start:w,end:w+l.length-1}:{start:0,end:0}}e.$7E=r;async function s(u,d,v,l){if(u.evaluatableExpressionProvider.has(d)){const w=u.evaluatableExpressionProvider.ordered(d),P=(0,b.$lf)(await Promise.all(w.map(async M=>{try{return await M.provideEvaluatableExpression(d,v,l??E.CancellationToken.None)}catch{return}})));if(P.length>0){let M=P[0].expression;const N=P[0].range;return M||(M=d.getLineContent(v.lineNumber).substring(N.startColumn-1,N.endColumn-1)),{range:N,matchingExpression:M}}}else{const w=d.getLineContent(v.lineNumber),{start:P,end:M}=r(w,v.column,v.column),N=w.substring(P-1,M);return{matchingExpression:N,range:new m.$Mr(v.lineNumber,P,v.lineNumber,P+N.length)}}return null}e.$8E=s;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(u){return!!(u&&u.match(c))}e.$9E=f;function y(u){if(typeof u.path=="string"&&!(typeof u.sourceReference=="number"&&u.sourceReference>0)){if(f(u.path))return F.URI.parse(u.path);if((0,h.$_b)(u.path))return F.URI.file(u.path)}return u.path}function C(u){if(typeof u.path=="object"){const d=F.URI.revive(u.path);if(d)return d.scheme===A.Schemas.file?d.fsPath:d.toString()}return u.path}function i(u,d){const v=d?y:C,l=(0,L.$Fm)(u);return n(l,(w,P)=>{w&&P&&(P.path=v(P))}),l}e.$0E=i;function a(u,d){const v=d?y:C,l=(0,L.$Fm)(u);return n(l,(w,P)=>{!w&&P&&(P.path=v(P))}),l}e.$$E=a;function n(u,d){switch(u.type){case"event":{const v=u;switch(v.event){case"output":d(!1,v.body.source);break;case"loadedSource":d(!1,v.body.source);break;case"breakpoint":d(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=u;switch(v.command){case"setBreakpoints":d(!0,v.arguments.source);break;case"breakpointLocations":d(!0,v.arguments.source);break;case"source":d(!0,v.arguments.source);break;case"gotoTargets":d(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(l=>d(!1,l));break;default:break}break}case"response":{const v=u;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(l=>d(!1,l.source));break;case"loadedSources":v.body.sources.forEach(l=>d(!1,l));break;case"scopes":v.body.scopes.forEach(l=>d(!1,l.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(l=>d(!1,l.source));break;case"setBreakpoints":v.body.breakpoints.forEach(l=>d(!1,l.source));break;case"disassemble":v.body?.instructions.forEach(w=>d(!1,w.location));break;default:break}break}}}function t(u){return u.filter(d=>!d.presentation?.hidden).sort((d,v)=>d.presentation?v.presentation?d.presentation.group?v.presentation.group?d.presentation.group!==v.presentation.group?d.presentation.group.localeCompare(v.presentation.group):o(d.presentation.order,v.presentation.order):-1:v.presentation.group?1:o(d.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.$_E=t;function o(u,d){return typeof u!="number"?typeof d!="number"?0:1:typeof d!="number"?-1:u-d}async function g(u,d){const v=u.getValue("debug.saveBeforeStart",{overrideIdentifier:d.activeTextEditorLanguageId});if(v!=="none"&&(await d.saveAll(),v==="allEditorsInActiveGroup")){const l=d.activeEditorPane;l&&l.input.resource?.scheme===A.Schemas.untitled&&await d.save({editor:l.input,groupId:l.group.id})}await u.reloadConfiguration()}e.$aF=g}),define(De[257],Ce([1,0,46,101,23,13,11,12,29,210,134]),function(me,e,k,F,h,L,A,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wac=e.$Vac=e.$Uac=e.$Tac=e.$Sac=void 0;class I extends R.$v${static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,c){this.p=c,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",f=>this.w(f))}sendMessage(s){if(this.p){const c=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(c,"utf8")}${I.a}${c}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const c=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,c.length>0)try{this.acceptMessage(JSON.parse(c))}catch(f){this.m.fire(new Error((f.message||f)+`
`+c))}continue}}else{const c=this.r.indexOf(I.a);if(c!==-1){const y=this.r.toString("utf8",0,c).split(I.b);for(const C of y){const i=C.split(I.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(c+I.a.length);continue}}break}}}e.$Sac=I;class $ extends I{startSession(){return new Promise((s,c)=>{let f=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),f=!0}),this.x.on("close",()=>{f?this.m.fire(new Error("connection closed")):c(new Error("connection closed"))}),this.x.on("error",y=>{f?this.m.fire(y):c(y)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Tac=$;class S extends ${constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$Uac=S;class D extends ${constructor(s){super(),this.z=s}y(s){return F.createConnection(this.z.path,s)}}e.$Vac=D;class p extends I{constructor(s,c){super(),this.y=s,this.z=c}async startSession(){const s=this.y.command,c=this.y.args,f=this.y.options||{};try{if(s)if(L.$_b(s)){if(!await E.Promises.exists(s))throw new Error(b.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(b.localize(1,null,this.z));let y=process.env;if(f.env&&Object.keys(f.env).length>0&&(y=h.$Im(h.$Fm(process.env),f.env)),s==="node")if(Array.isArray(c)&&c.length>0){const C=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:y,execArgv:C?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};f.cwd&&(i.cwd=f.cwd);const a=k.fork(c[0],c.slice(1),i);if(!a.pid)throw new Error(b.localize(2,null,c[0]));this.x=a}else throw new Error(b.localize(3,null));else{const C={env:y};f.cwd&&(C.cwd=f.cwd),this.x=k.spawn(s,c,C)}this.x.on("error",C=>{this.m.fire(C)}),this.x.on("exit",(C,i)=>{this.n.fire(C)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",C=>{this.m.fire(C)}),this.x.stdin.on("error",C=>{this.m.fire(C)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(y){this.m.fire(y)}}async stopSession(){return this.x?(await this.u(),A.$i?new Promise((s,c)=>{const f=k.exec(`taskkill /F /T /PID ${this.x.pid}`,function(y,C,i){if(y)return c(y)});f.on("exit",s),f.on("error",c)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,c){if(!s)return;const f=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?f.runtime=L.$ac(c,s.runtime):f.runtime=s.runtime),s.runtimeArgs&&(f.runtimeArgs=s.runtimeArgs),s.program&&(L.$_b(s.program)?f.program=s.program:f.program=L.$ac(c,s.program)),s.args&&(f.args=s.args);const y=s;return y.win&&(f.win=p.A(y.win,c)),y.winx86&&(f.winx86=p.A(y.winx86,c)),y.windows&&(f.windows=p.A(y.windows,c)),y.osx&&(f.osx=p.A(y.osx,c)),y.linux&&(f.linux=p.A(y.linux,c)),f}static platformAdapterExecutable(s,c){let f=Object.create(null);c=c.toLowerCase();for(const t of s)if(t.contributes){const o=t.contributes.debuggers;o&&o.length>0&&o.filter(g=>typeof g.type=="string"&&m.$Ld(g.type,c)).forEach(g=>{const u=p.A(g,t.extensionLocation.fsPath);f=h.$Im(f,u,t.isBuiltin)})}let y;A.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?y=f.winx86||f.win||f.windows:A.$i?y=f.win||f.windows:A.$j?y=f.osx:A.$k&&(y=f.linux),y=y||f;const C=y.program||f.program,i=y.args||f.args,a=y.runtime||f.runtime,n=y.runtimeArgs||f.runtimeArgs;if(a)return{type:"executable",command:a,args:(n||[]).concat(typeof C=="string"?[C]:[]).concat(i||[])};if(C)return{type:"executable",command:C,args:i||[]}}}e.$Wac=p}),define(De[258],Ce([1,0,46,31,11]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yac=e.$Xac=void 0;function L(b,R){return new Promise((I,$)=>{let S="";const D=k.spawn(b,R);D.pid&&D.stdout.on("data",p=>{S+=p.toString()}),D.on("error",p=>{$(p)}),D.on("close",p=>{I(S)})})}async function A(b){if(b)if(h.$i){const R=await new Promise((I,$)=>{me(["@vscode/windows-process-tree"],I,$)});return new Promise(I=>{R.getProcessTree(b,$=>{I(!!$&&$.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(b)]).then(R=>{const I=R.trim();return!(I.length===0||I.indexOf(" tmux")>=0)},R=>!0);return Promise.resolve(!0)}e.$Xac=A;var m;(function(b){b[b.cmd=0]="cmd",b[b.powershell=1]="powershell",b[b.bash=2]="bash"})(m||(m={}));function E(b,R,I,$,S){b=b.trim().toLowerCase();let D;b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0?D=1:b.indexOf("cmd.exe")>=0?D=0:b.indexOf("bash")>=0?D=2:h.$i?D=0:D=2;let p,r=" ";switch(D){case 1:if(p=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),$){const s=(0,F.$Oe)($);s&&(r+=`${s}:; `),r+=`cd ${p($)}; `}if(S)for(const s in S){const c=S[s];c===null?r+=`Remove-Item env:${s}; `:r+=`\${env:${s}}='${c}'; `}if(R.length>0){const s=R.shift(),c=I?s:p(s);r+=c[0]==="'"?`& ${c} `:`${c} `;for(const f of R)r+=f==="<"||f===">"||I?f:p(f),r+=" "}break;case 0:if(p=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(c=>s.includes(c))||s.length===0?`"${s}"`:s),$){const s=(0,F.$Oe)($);s&&(r+=`${s}: && `),r+=`cd ${p($)} && `}if(S){r+='cmd /C "';for(const s in S){let c=S[s];c===null?r+=`set "${s}=" && `:(c=c.replace(/[&^|<>]/g,f=>`^${f}`),r+=`set "${s}=${c}" && `)}}for(const s of R)r+=s==="<"||s===">"||I?s:p(s),r+=" ";S&&(r+='"');break;case 2:{p=c=>(c=c.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),c.length===0?'""':c);const s=c=>/[^\w@%\/+=,.:^-]/.test(c)?`'${c.replace(/'/g,"'\\''")}'`:c;if($&&(r+=`cd ${p($)} ; `),S){r+="/usr/bin/env";for(const c in S){const f=S[c];f===null?r+=` -u ${s(c)}`:r+=` ${s(`${c}=${f}`)}`}r+=" "}for(const c of R)r+=c==="<"||c===">"||I?c:p(c),r+=" ";break}}return r}e.$Yac=E}),define(De[102],Ce([1,0,22,34,48,93,15,13,11,47]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GH=e.$FH=e.$EH=e.$DH=e.CellStatusbarAlignment=e.$CH=e.$BH=e.$AH=e.NotebookEditorPriority=e.$zH=e.$yH=e.$xH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$wH=e.$vH=e.$uH=e.$tH=e.CellKind=e.$sH=e.$rH=e.$qH=void 0,e.$qH="workbench.editor.notebook",e.$rH="workbench.editor.notebookTextDiffEditor",e.$sH="workbench.editor.interactive";var R;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(R||(e.CellKind=R={})),e.$tH=["application/json","application/javascript","text/html","image/svg+xml",L.$sr.latex,L.$sr.markdown,"image/png","image/jpeg",L.$sr.text],e.$uH=[L.$sr.latex,L.$sr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.$sr.text],e.$vH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$wH="_notAvailable";var I;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(I||(e.NotebookRunState=I={}));var $;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var S;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var D;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(D||(e.NotebookRendererMatch=D={}));var p;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(p||(e.RendererMessagingSpec=p={}));var r;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var s;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var c;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(c||(e.CellEditType=c={}));var f;(function(U){U.scheme=A.Schemas.vscodeNotebookCell;const Y=["W","X","Y","Z","a","b","c","d","e","f"],H=new RegExp(`^[${Y.join("")}]+`),ge=7;function ie(fe,de){const B=de.toString(ge),Ee=`${B.length<Y.length?Y[B.length-1]:"z"}${B}s${(0,k.$4b)(k.$Jb.fromString(fe.scheme),!0,!0)}`;return fe.with({scheme:U.scheme,fragment:Ee})}U.generate=ie;function te(fe){if(fe.scheme!==U.scheme)return;const de=fe.fragment.indexOf("s");if(de<0)return;const B=parseInt(fe.fragment.substring(0,de).replace(H,""),ge),_=(0,k.$3b)(fe.fragment.substring(de+1)).toString();if(!isNaN(B))return{handle:B,notebook:fe.with({scheme:_,fragment:null})}}U.parse=te;function q(fe,de){return fe.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${de??""},${fe.scheme!==A.Schemas.file?fe.scheme:""}`})}U.generateCellOutputUri=q;function V(fe){if(fe.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const de=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(fe.fragment);if(!de)return;const B=de[1]&&de[1]!==""?de[1]:void 0,_=de[2];return{outputId:B,notebook:fe.with({scheme:_||A.Schemas.file,fragment:null})}}U.parseCellOutputUri=V;function ce(fe,de,B){return U.generate(fe,de).with({scheme:B})}U.generateCellPropertyUri=ce;function re(fe,de){if(fe.scheme===de)return U.parse(fe.with({scheme:U.scheme}))}U.parseCellPropertyUri=re})(f||(e.CellUri=f={}));const y=U=>E.$i?U.replace(/\//g,"\\"):U;class C{constructor(Y=[],H=e.$tH){this.e=H,this.d=[...new Set(Y)].map(ge=>({pattern:ge,matches:F.$cj(y(ge))}))}sort(Y){const H=new Map(h.Iterable.map(Y,ie=>[ie,y(ie)]));let ge=[];for(const{matches:ie}of this.d)for(const[te,q]of H)if(ie(q)){ge.push(te),H.delete(te);break}return H.size&&(ge=ge.concat([...H.keys()].sort((ie,te)=>this.e.indexOf(ie)-this.e.indexOf(te)))),ge}prioritize(Y,H){const ge=this.f(Y);if(ge===-1){this.d.unshift({pattern:Y,matches:F.$cj(y(Y))});return}const ie=new Set(H.map(q=>this.f(q,ge)));ie.delete(-1);const te=Array.from(ie).sort();this.d.splice(ge+1,0,...te.map(q=>this.d[q]));for(let q=te.length-1;q>=0;q--)this.d.splice(te[q],1)}toArray(){return this.d.map(Y=>Y.pattern)}f(Y,H=this.d.length){const ge=y(Y);for(let ie=0;ie<H;ie++)if(this.d[ie].matches(ge))return ie;return-1}}e.$xH=C;function i(U,Y,H,ge=(ie,te)=>ie===te){const ie=[];function te(ce,re,fe){if(re===0&&fe.length===0)return;const de=ie[ie.length-1];de&&de.start+de.deleteCount===ce?(de.deleteCount+=re,de.toInsert.push(...fe)):ie.push({start:ce,deleteCount:re,toInsert:fe})}let q=0,V=0;for(;;){if(q===U.length){te(q,0,Y.slice(V));break}if(V===Y.length){te(q,U.length-q,[]);break}const ce=U[q],re=Y[V];if(ge(ce,re)){q+=1,V+=1;continue}H(re)?(te(q,1,[]),q+=1):(te(q,0,[re]),V+=1)}return ie}e.$yH=i,e.$zH=new b.$Mi("notebookEditorCursorAtBoundary","none");var a;(function(U){U.default="default",U.option="option"})(a||(e.NotebookEditorPriority=a={}));function n(U){const Y=U;return!!((typeof Y.include=="string"||F.$dj(Y.include))&&(typeof Y.exclude=="string"||F.$dj(Y.exclude)))}e.$AH=n;function t(U,Y,H){if(Array.isArray(U.viewType)&&U.viewType.indexOf(Y)>=0||U.viewType===Y)return!0;if(U.filenamePattern){const ge=n(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,ie=n(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(F.$bj(ge,(0,m.$ec)(H.fsPath).toLowerCase()))return!(ie&&F.$bj(ie,(0,m.$ec)(H.fsPath).toLowerCase()))}return!1}e.$BH=t,e.$CH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var o;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(o||(e.CellStatusbarAlignment=o={}));class g{static{this.d="notebook/"}static create(Y){return`${g.d}${Y}`}static parse(Y){if(Y.startsWith(g.d))return Y.substring(g.d.length)}}e.$DH=g;function u(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.$EH=u;const d=new TextDecoder;function v(U){const Y=[];let H=!1;for(const q of U)(Y.length===0||H)&&(Y.push(q),H=!0);let ge=P(Y);const ie=k.$Jb.concat(Y.map(q=>k.$Jb.wrap(q))),te=j(ie);return ge=ge||te.byteLength!==ie.byteLength,{data:te,didCompression:ge}}e.$FH=v,e.$GH=`${String.fromCharCode(27)}[A`;const l=e.$GH.split("").map(U=>U.charCodeAt(0)),w=10;function P(U){let Y=!1;return U.forEach((H,ge)=>{if(ge===0||H.length<e.$GH.length)return;const ie=U[ge-1],te=H.subarray(0,e.$GH.length);if(te[0]===l[0]&&te[1]===l[1]&&te[2]===l[2]){const q=ie.lastIndexOf(w);if(q===-1)return;Y=!0,U[ge-1]=ie.subarray(0,q),U[ge]=H.subarray(e.$GH.length)}}),Y}function M(U){let Y=U;do U=Y,Y=U.replace(/[^\n]\x08/gm,"");while(Y.length<U.length);return U}function N(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const Y=U.match(/^(.*)\r+/m)[1];let H=U.match(/\r+(.*)$/m)[1];H=H+Y.slice(H.length,Y.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,H)}return U}const T="\b".charCodeAt(0),z="\r".charCodeAt(0);function j(U){return!U.buffer.includes(T)&&!U.buffer.includes(z)?U:k.$Jb.fromString(N(M(d.decode(U.buffer))))}}),define(De[7],Ce([1,0,19,8,74,28,93,12,14,2,32,25,30,130,102]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D){"use strict";var p,r,s,c,f,y,C,i,a,n,t,o,g,u,d,v,l,w;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.TestRunProfileKind=e.TestResultState=e.$8K=e.$7K=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$6K=e.$5K=e.$4K=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$3K=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.ColorThemeKind=e.$WK=e.$VK=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$UK=e.DebugConsoleMode=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OK=e.$NK=e.FileChangeType=e.$MK=e.$LK=e.$KK=e.$JK=e.InlineCompletionTriggerKind=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.ConfigurationTarget=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$mK=e.ViewBadge=e.ProgressLocation=e.$lK=e.$kK=e.TaskScope=e.ShellQuoting=e.$jK=e.$iK=e.$hK=e.TaskPanelKind=e.TaskRevealKind=e.$gK=e.TerminalLocation=e.$fK=e.$eK=e.$dK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$cK=e.$bK=e.$aK=e.$_J=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$$J=e.StatusBarAlignment=e.ViewColumn=e.$0J=e.$9J=e.$8J=e.$7J=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$6J=e.$5J=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.LanguageStatusSeverity=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.CodeActionTriggerKind=e.$RJ=e.$QJ=e.SymbolTag=e.SymbolKind=e.$PJ=e.DocumentHighlightKind=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$KJ=e.$JJ=e.FileEditType=e.$IJ=e.$HJ=e.$GJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function P(J){return Object.assign(J,{apply:function(){const be=arguments.length===1?[]:arguments[1];return Reflect.construct(J,be,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(J,[]);{const[be,...Fe]=arguments;return Reflect.construct(J,Fe,be.constructor)}}})}var M;(function(J){J[J.Top=0]="Top",J[J.Bottom=1]="Bottom"})(M||(e.TerminalOutputAnchor=M={}));var N;(function(J){J[J.Command=0]="Command",J[J.Opener=1]="Opener"})(N||(e.TerminalQuickFixType=N={}));let T=p=class{static from(...W){let be=W;return new p(function(){if(be){for(const Fe of be)Fe&&typeof Fe.dispose=="function"&&Fe.dispose();be=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$zJ=T,e.$zJ=T=p=Je([P],T);let z=r=class{static Min(...W){if(W.length===0)throw new TypeError;let be=W[0];for(let Fe=1;Fe<W.length;Fe++){const Ke=W[Fe];Ke.isBefore(be)&&(be=Ke)}return be}static Max(...W){if(W.length===0)throw new TypeError;let be=W[0];for(let Fe=1;Fe<W.length;Fe++){const Ke=W[Fe];Ke.isAfter(be)&&(be=Ke)}return be}static isPosition(W){if(!W)return!1;if(W instanceof r)return!0;const{line:be,character:Fe}=W;return typeof be=="number"&&typeof Fe=="number"}static of(W){if(W instanceof r)return W;if(this.isPosition(W))return new r(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,be){if(W<0)throw(0,F.$5)("line must be non-negative");if(be<0)throw(0,F.$5)("character must be non-negative");this.c=W,this.e=be}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,be=0){if(W===null||be===null)throw(0,F.$5)();let Fe;return typeof W>"u"?Fe=0:typeof W=="number"?Fe=W:(Fe=typeof W.lineDelta=="number"?W.lineDelta:0,be=typeof W.characterDelta=="number"?W.characterDelta:0),Fe===0&&be===0?this:new r(this.line+Fe,this.character+be)}with(W,be=this.character){if(W===null||be===null)throw(0,F.$5)();let Fe;return typeof W>"u"?Fe=this.line:typeof W=="number"?Fe=W:(Fe=typeof W.line=="number"?W.line:this.line,be=typeof W.character=="number"?W.character:this.character),Fe===this.line&&be===this.character?this:new r(Fe,be)}toJSON(){return{line:this.line,character:this.character}}};e.$AJ=z,e.$AJ=z=r=Je([P],z);let j=s=class{static isRange(W){return W instanceof s?!0:W?z.isPosition(W.start)&&z.isPosition(W.end):!1}static of(W){if(W instanceof s)return W;if(this.isRange(W))return new s(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,be,Fe,Ke){let Qe,ot;if(typeof W=="number"&&typeof be=="number"&&typeof Fe=="number"&&typeof Ke=="number"?(Qe=new z(W,be),ot=new z(Fe,Ke)):z.isPosition(W)&&z.isPosition(be)&&(Qe=z.of(W),ot=z.of(be)),!Qe||!ot)throw new Error("Invalid arguments");Qe.isBefore(ot)?(this.c=Qe,this.e=ot):(this.c=ot,this.e=Qe)}contains(W){return s.isRange(W)?this.contains(W.start)&&this.contains(W.end):z.isPosition(W)?!(z.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const be=z.Max(W.start,this.c),Fe=z.Min(W.end,this.e);if(!be.isAfter(Fe))return new s(be,Fe)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const be=z.Min(W.start,this.c),Fe=z.Max(W.end,this.end);return new s(be,Fe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,be=this.end){if(W===null||be===null)throw(0,F.$5)();let Fe;return W?z.isPosition(W)?Fe=W:(Fe=W.start||this.start,be=W.end||this.end):Fe=this.start,Fe.isEqual(this.c)&&be.isEqual(this.end)?this:new s(Fe,be)}toJSON(){return[this.start,this.end]}};e.$BJ=j,e.$BJ=j=s=Je([P],j);let U=c=class extends j{static isSelection(W){return W instanceof c?!0:W?j.isRange(W)&&z.isPosition(W.anchor)&&z.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,be,Fe,Ke){let Qe,ot;if(typeof W=="number"&&typeof be=="number"&&typeof Fe=="number"&&typeof Ke=="number"?(Qe=new z(W,be),ot=new z(Fe,Ke)):z.isPosition(W)&&z.isPosition(be)&&(Qe=z.of(W),ot=z.of(be)),!Qe||!ot)throw new Error("Invalid arguments");super(Qe,ot),this.f=Qe,this.g=ot}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$CJ=U,e.$CJ=U=c=Je([P],U);const Y=J=>{if(typeof J!="string"||J.length===0||!/^[0-9A-Za-z_\-]+$/.test(J))throw(0,F.$5)("connectionToken")};class H{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,be,Fe){if(typeof W!="string"||W.length===0)throw(0,F.$5)("host");if(typeof be!="number"||be===0||Math.round(be)!==be)throw(0,F.$5)("port");typeof Fe<"u"&&Y(Fe),this.host=W,this.port=Math.round(be),this.connectionToken=Fe}}e.$DJ=H;class ge{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,be){this.makeConnection=W,this.connectionToken=be,typeof be<"u"&&Y(be)}}e.$EJ=ge;class ie extends Error{static NotAvailable(W,be){return new ie(W,S.RemoteAuthorityResolverErrorCode.NotAvailable,be)}static TemporarilyNotAvailable(W){return new ie(W,S.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,be=S.RemoteAuthorityResolverErrorCode.Unknown,Fe){super(W),this._message=W,this._code=be,this._detail=Fe,Object.setPrototypeOf(this,ie.prototype)}}e.$FJ=ie;var te;(function(J){J[J.LF=1]="LF",J[J.CRLF=2]="CRLF"})(te||(e.EndOfLine=te={}));var q;(function(J){J[J.Replace=1]="Replace",J[J.Append=2]="Append",J[J.Prepend=3]="Prepend"})(q||(e.EnvironmentVariableMutatorType=q={}));let V=f=class{static isTextEdit(W){return W instanceof f?!0:W?j.isRange(W)&&typeof W.newText=="string":!1}static replace(W,be){return new f(W,be)}static insert(W,be){return f.replace(new j(W,W),be)}static delete(W){return f.replace(W,"")}static setEndOfLine(W){const be=new f(new j(new z(0,0),new z(0,0)),"");return be.newEol=W,be}get range(){return this.c}set range(W){if(W&&!j.isRange(W))throw(0,F.$5)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,F.$5)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,F.$5)("newEol");this.f=W}constructor(W,be){this.c=W,this.e=be}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$GJ=V,e.$GJ=V=f=Je([P],V);let ce=y=class{static isNotebookCellEdit(W){return W instanceof y?!0:W?Xt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,be){return new y(W,be)}static insertCells(W,be){return new y(new Xt(W,W),be)}static deleteCells(W){return new y(W,[])}static updateCellMetadata(W,be){const Fe=new y(new Xt(W,W),[]);return Fe.newCellMetadata=be,Fe}static updateNotebookMetadata(W){const be=new y(new Xt(0,0),[]);return be.newNotebookMetadata=W,be}constructor(W,be){this.range=W,this.newCells=be}};e.$HJ=ce,e.$HJ=ce=y=Je([P],ce);class re{static isSnippetTextEdit(W){return W instanceof re?!0:W?j.isRange(W.range)&&B.isSnippetString(W.snippet):!1}static replace(W,be){return new re(W,be)}static insert(W,be){return re.replace(new j(W,W),be)}constructor(W,be){this.range=W,this.snippet=be}}e.$IJ=re;var fe;(function(J){J[J.File=1]="File",J[J.Text=2]="Text",J[J.Cell=3]="Cell",J[J.CellReplace=5]="CellReplace",J[J.Snippet=6]="Snippet"})(fe||(e.FileEditType=fe={}));let de=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,be,Fe,Ke){this.c.push({_type:1,from:W,to:be,options:Fe,metadata:Ke})}createFile(W,be,Fe){this.c.push({_type:1,from:void 0,to:W,options:be,metadata:Fe})}deleteFile(W,be,Fe){this.c.push({_type:1,from:W,to:void 0,options:be,metadata:Fe})}e(W,be,Fe){this.c.push({_type:3,metadata:Fe,uri:W,edit:{editType:5,metadata:be},notebookMetadata:be})}f(W,be,Fe,Ke){const Qe=be.start,ot=be.end;(Qe!==ot||Fe.length>0)&&this.c.push({_type:5,uri:W,index:Qe,count:ot-Qe,cells:Fe,metadata:Ke})}g(W,be,Fe,Ke){this.c.push({_type:3,metadata:Ke,uri:W,edit:{editType:3,index:be,metadata:Fe}})}replace(W,be,Fe,Ke){this.c.push({_type:2,uri:W,edit:new V(be,Fe),metadata:Ke})}insert(W,be,Fe,Ke){this.replace(W,new j(be,be),Fe,Ke)}delete(W,be,Fe){this.replace(W,be,"",Fe)}has(W){return this.c.some(be=>be._type===2&&be.uri.toString()===W.toString())}set(W,be){if(be)for(const Fe of be){if(!Fe)continue;let Ke,Qe;Array.isArray(Fe)?(Ke=Fe[0],Qe=Fe[1]):Ke=Fe,ce.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(W,Ke.range.start,Ke.newCellMetadata,Qe):Ke.newNotebookMetadata?this.e(W,Ke.newNotebookMetadata,Qe):this.f(W,Ke.range,Ke.newCells,Qe):re.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:Qe}):this.c.push({_type:2,uri:W,edit:Ke,metadata:Qe})}else{for(let Fe=0;Fe<this.c.length;Fe++){const Ke=this.c[Fe];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this.c[Fe]=void 0);break}}(0,k.$mf)(this.c)}}get(W){const be=[];for(const Fe of this.c)Fe._type===2&&Fe.uri.toString()===W.toString()&&be.push(Fe.edit);return be}entries(){const W=new L.$li;for(const be of this.c)if(be._type===2){let Fe=W.get(be.uri);Fe||(Fe=[be.uri,[]],W.set(be.uri,Fe)),Fe[1].push(be.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$JJ=de,e.$JJ=de=Je([P],de);let B=C=class{static isSnippetString(W){return W instanceof C?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=C.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,be=this.e++){if(typeof W=="function"){const Fe=new C;Fe.e=this.e,W(Fe),this.e=Fe.e,W=Fe.value}else W=C.c(W);return this.value+="${",this.value+=be,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,be=this.e++){const Fe=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=be,this.value+="|",this.value+=Fe,this.value+="|}",this}appendVariable(W,be){if(typeof be=="function"){const Fe=new C;Fe.e=this.e,be(Fe),this.e=Fe.e,be=Fe.value}else typeof be=="string"&&(be=be.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,be&&(this.value+=":",this.value+=be),this.value+="}",this}};e.$KJ=B,e.$KJ=B=C=Je([P],B);var _;(function(J){J[J.Unnecessary=1]="Unnecessary",J[J.Deprecated=2]="Deprecated"})(_||(e.DiagnosticTag=_={}));var Ee;(function(J){J[J.Hint=3]="Hint",J[J.Information=2]="Information",J[J.Warning=1]="Warning",J[J.Error=0]="Error"})(Ee||(e.DiagnosticSeverity=Ee={}));let Re=i=class{static isLocation(W){return W instanceof i?!0:W?j.isRange(W.range)&&b.URI.isUri(W.uri):!1}constructor(W,be){if(this.uri=W,be)if(j.isRange(be))this.range=j.of(be);else if(z.isPosition(be))this.range=new j(be,be);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$LJ=Re,e.$LJ=Re=i=Je([P],Re);let ne=class{static is(W){return W?typeof W.message=="string"&&W.location&&j.isRange(W.location.range)&&b.URI.isUri(W.location.uri):!1}constructor(W,be){this.location=W,this.message=be}static isEqual(W,be){return W===be?!0:!W||!be?!1:W.message===be.message&&W.location.range.isEqual(be.location.range)&&W.location.uri.toString()===be.location.uri.toString()}};e.$MJ=ne,e.$MJ=ne=Je([P],ne);let ee=class{constructor(W,be,Fe=Ee.Error){if(!j.isRange(W))throw new TypeError("range must be set");if(!be)throw new TypeError("message must be set");this.range=W,this.message=be,this.severity=Fe}toJSON(){return{severity:Ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,be){return W===be?!0:!W||!be?!1:W.message===be.message&&W.severity===be.severity&&W.code===be.code&&W.severity===be.severity&&W.source===be.source&&W.range.isEqual(be.range)&&(0,k.$af)(W.tags,be.tags)&&(0,k.$af)(W.relatedInformation,be.relatedInformation,ne.isEqual)}};e.$NJ=ee,e.$NJ=ee=Je([P],ee);let he=class{constructor(W,be){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=be}};e.$OJ=he,e.$OJ=he=Je([P],he);var X;(function(J){J[J.Text=0]="Text",J[J.Read=1]="Read",J[J.Write=2]="Write"})(X||(e.DocumentHighlightKind=X={}));let ue=class{constructor(W,be=X.Text){this.range=W,this.kind=be}toJSON(){return{range:this.range,kind:X[this.kind]}}};e.$PJ=ue,e.$PJ=ue=Je([P],ue);var oe;(function(J){J[J.File=0]="File",J[J.Module=1]="Module",J[J.Namespace=2]="Namespace",J[J.Package=3]="Package",J[J.Class=4]="Class",J[J.Method=5]="Method",J[J.Property=6]="Property",J[J.Field=7]="Field",J[J.Constructor=8]="Constructor",J[J.Enum=9]="Enum",J[J.Interface=10]="Interface",J[J.Function=11]="Function",J[J.Variable=12]="Variable",J[J.Constant=13]="Constant",J[J.String=14]="String",J[J.Number=15]="Number",J[J.Boolean=16]="Boolean",J[J.Array=17]="Array",J[J.Object=18]="Object",J[J.Key=19]="Key",J[J.Null=20]="Null",J[J.EnumMember=21]="EnumMember",J[J.Struct=22]="Struct",J[J.Event=23]="Event",J[J.Operator=24]="Operator",J[J.TypeParameter=25]="TypeParameter"})(oe||(e.SymbolKind=oe={}));var le;(function(J){J[J.Deprecated=1]="Deprecated"})(le||(e.SymbolTag=le={}));let we=a=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,be,Fe,Ke,Qe){this.name=W,this.kind=be,this.containerName=Qe,typeof Fe=="string"&&(this.containerName=Fe),Ke instanceof Re?this.location=Ke:Fe instanceof j&&(this.location=new Re(Ke,Fe)),a.validate(this)}toJSON(){return{name:this.name,kind:oe[this.kind],location:this.location,containerName:this.containerName}}};e.$QJ=we,e.$QJ=we=a=Je([P],we);let O=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(n.validate)}constructor(W,be,Fe,Ke,Qe){this.name=W,this.detail=be,this.kind=Fe,this.range=Ke,this.selectionRange=Qe,this.children=[],n.validate(this)}};e.$RJ=O,e.$RJ=O=n=Je([P],O);var K;(function(J){J[J.Invoke=1]="Invoke",J[J.Automatic=2]="Automatic"})(K||(e.CodeActionTriggerKind=K={}));let G=class{constructor(W,be){this.title=W,this.kind=be}};e.$SJ=G,e.$SJ=G=Je([P],G);let x=class{static{t=this}static{this.c="."}constructor(W){this.value=W}append(W){return new t(this.value?this.value+t.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+t.c)}};e.$TJ=x,e.$TJ=x=t=Je([P],x);class pe extends x{constructor(W){super(W),this.value=W}}e.$UJ=pe,x.Empty=new x(""),x.QuickFix=x.Empty.append("quickfix"),x.Refactor=x.Empty.append("refactor"),x.RefactorExtract=x.Refactor.append("extract"),x.RefactorInline=x.Refactor.append("inline"),x.RefactorMove=x.Refactor.append("move"),x.RefactorRewrite=x.Refactor.append("rewrite"),x.Source=x.Empty.append("source"),x.SourceOrganizeImports=x.Source.append("organizeImports"),x.SourceFixAll=x.Source.append("fixAll"),x.Notebook=x.Empty.append("notebook");let se=class{constructor(W,be){if(this.range=W,this.parent=be,be&&!be.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$VJ=se,e.$VJ=se=Je([P],se);class ve{constructor(W,be,Fe,Ke,Qe,ot){this.kind=W,this.name=be,this.detail=Fe,this.uri=Ke,this.range=Qe,this.selectionRange=ot}}e.$WJ=ve;class Ie{constructor(W,be){this.fromRanges=be,this.from=W}}e.$XJ=Ie;class Ue{constructor(W,be){this.fromRanges=be,this.to=W}}e.$YJ=Ue;var Ve;(function(J){J[J.Information=0]="Information",J[J.Warning=1]="Warning",J[J.Error=2]="Error"})(Ve||(e.LanguageStatusSeverity=Ve={}));let xe=class{constructor(W,be){this.range=W,this.command=be}get isResolved(){return!!this.command}};e.$ZJ=xe,e.$ZJ=xe=Je([P],xe);let Ge=o=class{#e;static isMarkdownString(W){return W instanceof o?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,be=!1){this.#e=new h.$Ij(W,{supportThemeIcons:be})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,be){return this.#e.appendCodeblock(be??"",W),this}};e.$1J=Ge,e.$1J=Ge=o=Je([P],Ge);let et=class{constructor(W,be){this.label=W,this.documentation=be}};e.$2J=et,e.$2J=et=Je([P],et);let Ze=class{constructor(W,be){this.label=W,this.documentation=be,this.parameters=[]}};e.$3J=Ze,e.$3J=Ze=Je([P],Ze);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$4J=st,e.$4J=st=Je([P],st);var tt;(function(J){J[J.Invoke=1]="Invoke",J[J.TriggerCharacter=2]="TriggerCharacter",J[J.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var Pe;(function(J){J[J.Type=1]="Type",J[J.Parameter=2]="Parameter"})(Pe||(e.InlayHintKind=Pe={}));let ke=class{constructor(W){this.value=W}};e.$5J=ke,e.$5J=ke=Je([P],ke);let Be=class{constructor(W,be,Fe){this.position=W,this.label=be,this.kind=Fe}};e.$6J=Be,e.$6J=Be=Je([P],Be);var Q;(function(J){J[J.Invoke=0]="Invoke",J[J.TriggerCharacter=1]="TriggerCharacter",J[J.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Q||(e.CompletionTriggerKind=Q={}));var Z;(function(J){J[J.Text=0]="Text",J[J.Method=1]="Method",J[J.Function=2]="Function",J[J.Constructor=3]="Constructor",J[J.Field=4]="Field",J[J.Variable=5]="Variable",J[J.Class=6]="Class",J[J.Interface=7]="Interface",J[J.Module=8]="Module",J[J.Property=9]="Property",J[J.Unit=10]="Unit",J[J.Value=11]="Value",J[J.Enum=12]="Enum",J[J.Keyword=13]="Keyword",J[J.Snippet=14]="Snippet",J[J.Color=15]="Color",J[J.File=16]="File",J[J.Reference=17]="Reference",J[J.Folder=18]="Folder",J[J.EnumMember=19]="EnumMember",J[J.Constant=20]="Constant",J[J.Struct=21]="Struct",J[J.Event=22]="Event",J[J.Operator=23]="Operator",J[J.TypeParameter=24]="TypeParameter",J[J.User=25]="User",J[J.Issue=26]="Issue"})(Z||(e.CompletionItemKind=Z={}));var ye;(function(J){J[J.Deprecated=1]="Deprecated"})(ye||(e.CompletionItemTag=ye={}));let je=class{constructor(W,be){this.label=W,this.kind=be}toJSON(){return{label:this.label,kind:this.kind&&Z[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$7J=je,e.$7J=je=Je([P],je);let Oe=class{constructor(W=[],be=!1){this.items=W,this.isIncomplete=be}};e.$8J=Oe,e.$8J=Oe=Je([P],Oe);let Ye=class{constructor(W,be,Fe){this.insertText=W,this.range=be,this.command=Fe}};e.$9J=Ye,e.$9J=Ye=Je([P],Ye);let _e=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$0J=_e,e.$0J=_e=Je([P],_e);var rt;(function(J){J[J.Active=-1]="Active",J[J.Beside=-2]="Beside",J[J.One=1]="One",J[J.Two=2]="Two",J[J.Three=3]="Three",J[J.Four=4]="Four",J[J.Five=5]="Five",J[J.Six=6]="Six",J[J.Seven=7]="Seven",J[J.Eight=8]="Eight",J[J.Nine=9]="Nine"})(rt||(e.ViewColumn=rt={}));var ft;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(ft||(e.StatusBarAlignment=ft={}));function vt(J,W){return`${I.$Fl.toKey(J)}.${W}`}e.$$J=vt;var Ft;(function(J){J[J.Off=0]="Off",J[J.On=1]="On",J[J.Relative=2]="Relative"})(Ft||(e.TextEditorLineNumbersStyle=Ft={}));var Lt;(function(J){J[J.Manual=1]="Manual",J[J.AfterDelay=2]="AfterDelay",J[J.FocusOut=3]="FocusOut"})(Lt||(e.TextDocumentSaveReason=Lt={}));var Et;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Et||(e.TextEditorRevealType=Et={}));var Tt;(function(J){J[J.Keyboard=1]="Keyboard",J[J.Mouse=2]="Mouse",J[J.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Mt;(function(J){J[J.Undo=1]="Undo",J[J.Redo=2]="Redo"})(Mt||(e.TextDocumentChangeReason=Mt={}));var zt;(function(J){J[J.OpenOpen=0]="OpenOpen",J[J.ClosedClosed=1]="ClosedClosed",J[J.OpenClosed=2]="OpenClosed",J[J.ClosedOpen=3]="ClosedOpen"})(zt||(e.DecorationRangeBehavior=zt={})),function(J){function W(be){switch(be){case"keyboard":return J.Keyboard;case"mouse":return J.Mouse;case"api":return J.Command}}J.fromValue=W}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));let Bt=class{constructor(W,be){if(be&&!b.URI.isUri(be))throw(0,F.$5)("target");if(!j.isRange(W)||W.isEmpty)throw(0,F.$5)("range");this.range=W,this.target=be}};e.$_J=Bt,e.$_J=Bt=Je([P],Bt);let Nt=class{constructor(W,be,Fe,Ke){this.red=W,this.green=be,this.blue=Fe,this.alpha=Ke}};e.$aK=Nt,e.$aK=Nt=Je([P],Nt);let at=class{constructor(W,be){if(be&&!(be instanceof Nt))throw(0,F.$5)("color");if(!j.isRange(W)||W.isEmpty)throw(0,F.$5)("range");this.range=W,this.color=be}};e.$bK=at,e.$bK=at=Je([P],at);let dt=class{constructor(W){if(!W||typeof W!="string")throw(0,F.$5)("label");this.label=W}};e.$cK=dt,e.$cK=dt=Je([P],dt);var Wt;(function(J){J[J.RGB=0]="RGB",J[J.HEX=1]="HEX",J[J.HSL=2]="HSL"})(Wt||(e.ColorFormat=Wt={}));var Ot;(function(J){J[J.Error=0]="Error",J[J.Warning=1]="Warning",J[J.Information=2]="Information"})(Ot||(e.SourceControlInputBoxValidationType=Ot={}));var St;(function(J){J[J.Unknown=0]="Unknown",J[J.Shutdown=1]="Shutdown",J[J.Process=2]="Process",J[J.User=3]="User",J[J.Extension=4]="Extension"})(St||(e.TerminalExitReason=St={}));class ct{constructor(W,be,Fe){if(this.startIndex=W,this.length=be,this.tooltip=Fe,typeof W!="number"||W<0)throw(0,F.$5)("startIndex");if(typeof be!="number"||be<1)throw(0,F.$5)("length");if(Fe!==void 0&&typeof Fe!="string")throw(0,F.$5)("tooltip")}}e.$dK=ct;class At{constructor(W){this.uri=W}}e.$eK=At;class Ut{constructor(W){this.terminalCommand=W}}e.$fK=Ut;var Te;(function(J){J[J.Panel=1]="Panel",J[J.Editor=2]="Editor"})(Te||(e.TerminalLocation=Te={}));class Le{constructor(W){if(this.options=W,typeof W!="object")throw(0,F.$5)("options")}}e.$gK=Le;var Ae;(function(J){J[J.Always=1]="Always",J[J.Silent=2]="Silent",J[J.Never=3]="Never"})(Ae||(e.TaskRevealKind=Ae={}));var ae;(function(J){J[J.Shared=1]="Shared",J[J.Dedicated=2]="Dedicated",J[J.New=3]="New"})(ae||(e.TaskPanelKind=ae={}));let Me=class{static{g=this}static{this.Clean=new g("clean","Clean")}static{this.Build=new g("build","Build")}static{this.Rebuild=new g("rebuild","Rebuild")}static{this.Test=new g("test","Test")}static from(W){switch(W){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}constructor(W,be){if(this.label=be,typeof W!="string"||typeof be!="string")throw(0,F.$5)("name");this.c=W}get id(){return this.c}};e.$hK=Me,e.$hK=Me=g=Je([P],Me);function We(J){let W="";for(let be=0;be<J.length;be++)W+=J[be].replace(/,/g,",,")+",";return W}let Xe=class{constructor(W,be,Fe){if(typeof W!="string")throw(0,F.$5)("process");this.e=[],this.c=W,be!==void 0&&(Array.isArray(be)?(this.e=be,this.f=Fe):this.f=be)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,F.$5)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const be of this.e)W.push(be);return We(W)}};e.$iK=Xe,e.$iK=Xe=Je([P],Xe);let He=class{constructor(W,be,Fe){if(this.f=[],Array.isArray(be)){if(!W)throw(0,F.$5)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$5)("command");this.e=W,this.f=be,this.g=Fe}else{if(typeof W!="string")throw(0,F.$5)("commandLine");this.c=W,this.g=be}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,F.$5)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,F.$5)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const be of this.f)W.push(typeof be=="string"?be:be.value);return We(W)}};e.$jK=He,e.$jK=He=Je([P],He);var it;(function(J){J[J.Escape=1]="Escape",J[J.Strong=2]="Strong",J[J.Weak=3]="Weak"})(it||(e.ShellQuoting=it={}));var wt;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace"})(wt||(e.TaskScope=wt={}));class Dt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,R.$5e)()}set callback(W){this.c=W}get callback(){return this.c}}e.$kK=Dt;let Ct=class{static{u=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,be,Fe,Ke,Qe,ot){this.j=!1,this.k=this.definition=W;let lt;typeof be=="string"?(this.m=this.name=be,this.t=this.source=Fe,this.execution=Ke,lt=Qe,this.j=!0):be===wt.Global||be===wt.Workspace?(this.target=be,this.m=this.name=Fe,this.t=this.source=Ke,this.execution=Qe,lt=ot):(this.target=be,this.m=this.name=Fe,this.t=this.source=Ke,this.execution=Qe,lt=ot),typeof lt=="string"?(this.o=[lt],this.q=!0):Array.isArray(lt)?(this.o=lt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof Xe?this.k={type:u.e,id:this.n.computeId()}:this.n instanceof He?this.k={type:u.f,id:this.n.computeId()}:this.n instanceof Dt?this.k={type:u.c,id:this.n.computeId()}:this.k={type:u.g,id:(0,R.$5e)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,F.$5)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,F.$5)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const be=this.k.type;(u.g===be||u.e===be||u.f===be||u.c===be)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,F.$5)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};e.$lK=Ct,e.$lK=Ct=u=Je([P],Ct);var pt;(function(J){J[J.SourceControl=1]="SourceControl",J[J.Window=10]="Window",J[J.Notification=15]="Notification"})(pt||(e.ProgressLocation=pt={}));var $t;(function(J){function W(be){const Fe=be;return(0,E.$me)(Fe.value)?Fe.tooltip&&!(0,E.$ie)(Fe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Fe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Fe.value),!1)}J.isViewBadge=W})($t||(e.ViewBadge=$t={}));let ht=d=class{static isTreeItem(W,be){const Fe=W;if(Fe.checkboxState!==void 0){const Ke=(0,E.$me)(Fe.checkboxState)?Fe.checkboxState:(0,E.$ke)(Fe.checkboxState)&&(0,E.$me)(Fe.checkboxState.state)?Fe.checkboxState.state:void 0,Qe=!(0,E.$me)(Fe.checkboxState)&&(0,E.$ke)(Fe.checkboxState)?Fe.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==gt.Checked&&Ke!==gt.Unchecked||Qe!==void 0&&!(0,E.$ie)(Qe))return console.log("INVALID tree item, invalid checkboxState",Fe.checkboxState),!1}if(W instanceof d)return!0;if(Fe.label!==void 0&&!(0,E.$ie)(Fe.label)&&!Fe.label?.label)return console.log("INVALID tree item, invalid label",Fe.label),!1;if(Fe.id!==void 0&&!(0,E.$ie)(Fe.id))return console.log("INVALID tree item, invalid id",Fe.id),!1;if(Fe.iconPath!==void 0&&!(0,E.$ie)(Fe.iconPath)&&!b.URI.isUri(Fe.iconPath)&&(!Fe.iconPath||!(0,E.$ie)(Fe.iconPath.id))){const Ke=Fe.iconPath;if(!Ke||!(0,E.$ie)(Ke.light)&&!b.URI.isUri(Ke.light)&&!(0,E.$ie)(Ke.dark)&&!b.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Fe.iconPath),!1}return Fe.description!==void 0&&!(0,E.$ie)(Fe.description)&&typeof Fe.description!="boolean"?(console.log("INVALID tree item, invalid description",Fe.description),!1):Fe.resourceUri!==void 0&&!b.URI.isUri(Fe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Fe.resourceUri),!1):Fe.tooltip!==void 0&&!(0,E.$ie)(Fe.tooltip)&&!(Fe.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Fe.tooltip),!1):Fe.command!==void 0&&!Fe.command.command?(console.log("INVALID tree item, invalid command",Fe.command),!1):Fe.collapsibleState!==void 0&&Fe.collapsibleState<bt.None&&Fe.collapsibleState>bt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Fe.collapsibleState),!1):Fe.contextValue!==void 0&&!(0,E.$ie)(Fe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Fe.contextValue),!1):Fe.accessibilityInformation!==void 0&&!Fe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Fe.accessibilityInformation),!1):!0}constructor(W,be=bt.None){this.collapsibleState=be,b.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$mK=ht,e.$mK=ht=d=Je([P],ht);var bt;(function(J){J[J.None=0]="None",J[J.Collapsed=1]="Collapsed",J[J.Expanded=2]="Expanded"})(bt||(e.TreeItemCollapsibleState=bt={}));var gt;(function(J){J[J.Unchecked=0]="Unchecked",J[J.Checked=1]="Checked"})(gt||(e.TreeItemCheckboxState=gt={}));let Zt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$nK=Zt,e.$nK=Zt=Je([P],Zt);class qt extends Zt{}e.$oK=qt;class Qi extends qt{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$pK=Qi;class hi{constructor(W,be,Fe,Ke){this.name=W,this.uri=be,this._itemId=Fe,this.c=Ke}data(){return this.c()}}e.$qK=hi;let di=class{#e=new Map;constructor(W){for(const[be,Fe]of W??[]){const Ke=this.#e.get(this.#t(be));Ke?Ke.push(Fe):this.#e.set(this.#t(be),[Fe])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,be){this.#e.set(this.#t(W),[be])}forEach(W,be){for(const[Fe,Ke]of this.#e)for(const Qe of Ke)W.call(be,Qe,Fe,this)}*[Symbol.iterator](){for(const[W,be]of this.#e)for(const Fe of be)yield[W,Fe]}#t(W){return W.toLowerCase()}};e.$rK=di,e.$rK=di=Je([P],di);let It=class{constructor(W){this.insertText=W}};e.$sK=It,e.$sK=It=Je([P],It);let yi=class{constructor(W,be,Fe){this.id=be,this.label=Fe,this.insertText=W}};e.$tK=yi,e.$tK=yi=Je([P],yi);let Ht=class{constructor(W,be){this.id=W,this.color=be}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$uK=Ht,e.$uK=Ht=Je([P],Ht),Ht.File=new Ht("file"),Ht.Folder=new Ht("folder");let kt=class{constructor(W){this.id=W}};e.$vK=kt,e.$vK=kt=Je([P],kt);var Ei;(function(J){J[J.Global=1]="Global",J[J.Workspace=2]="Workspace",J[J.WorkspaceFolder=3]="WorkspaceFolder"})(Ei||(e.ConfigurationTarget=Ei={}));let fi=class{get base(){return this.c}set base(W){this.c=W,this.e=b.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,be){if(typeof W!="string"&&(!W||!b.URI.isUri(W)&&!b.URI.isUri(W.uri)))throw(0,F.$5)("base");if(typeof be!="string")throw(0,F.$5)("pattern");typeof W=="string"?this.baseUri=b.URI.file(W):b.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=be}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wK=fi,e.$wK=fi=Je([P],fi);const ai=new WeakMap;function xi(J,W){ai.set(J,W)}e.$xK=xi;let ni=class{constructor(W,be,Fe,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof be=="string"&&(this.condition=be),typeof Fe=="string"&&(this.hitCondition=Fe),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=ai.get(this)??(0,R.$5e)()),this.c}};e.$yK=ni,e.$yK=ni=Je([P],ni);let Rt=class extends ni{constructor(W,be,Fe,Ke,Qe){if(super(be,Fe,Ke,Qe),W===null)throw(0,F.$5)("location");this.location=W}};e.$zK=Rt,e.$zK=Rt=Je([P],Rt);let mi=class extends ni{constructor(W,be,Fe,Ke,Qe){super(be,Fe,Ke,Qe),this.functionName=W}};e.$AK=mi,e.$AK=mi=Je([P],mi);let ki=class extends ni{constructor(W,be,Fe,Ke,Qe,ot,lt){if(super(Ke,Qe,ot,lt),!be)throw(0,F.$5)("dataId");this.label=W,this.dataId=be,this.canPersist=Fe}};e.$BK=ki,e.$BK=ki=Je([P],ki);let ri=class{constructor(W,be,Fe){this.command=W,this.args=be||[],this.options=Fe}};e.$CK=ri,e.$CK=ri=Je([P],ri);let si=class{constructor(W,be){this.port=W,this.host=be}};e.$DK=si,e.$DK=si=Je([P],si);let ut=class{constructor(W){this.path=W}};e.$EK=ut,e.$EK=ut=Je([P],ut);let Si=class{constructor(W){this.implementation=W}};e.$FK=Si,e.$FK=Si=Je([P],Si);let Kt=class{constructor(W,be,Fe){this.session=W,this.threadId=be,this.frameId=Fe}};e.$GK=Kt,e.$GK=Kt=Je([P],Kt);let _t=class{constructor(W,be){this.session=W,this.threadId=be}};e.$HK=_t,e.$HK=_t=Je([P],_t);let gi=class{constructor(W,be){this.range=W,this.expression=be}};e.$IK=gi,e.$IK=gi=Je([P],gi);var zi;(function(J){J[J.Invoke=0]="Invoke",J[J.Automatic=1]="Automatic"})(zi||(e.InlineCompletionTriggerKind=zi={}));let Di=class{constructor(W,be){this.range=W,this.text=be}};e.$JK=Di,e.$JK=Di=Je([P],Di);let Ci=class{constructor(W,be,Fe=!0){this.range=W,this.variableName=be,this.caseSensitiveLookup=Fe}};e.$KK=Ci,e.$KK=Ci=Je([P],Ci);let $i=class{constructor(W,be){this.range=W,this.expression=be}};e.$LK=$i,e.$LK=$i=Je([P],$i);let Ii=class{constructor(W,be){this.frameId=W,this.stoppedLocation=be}};e.$MK=Ii,e.$MK=Ii=Je([P],Ii);var Pi;(function(J){J[J.Changed=1]="Changed",J[J.Created=2]="Created",J[J.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let ei=v=class extends Error{static FileExists(W){return new v(W,$.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(W){return new v(W,$.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(W){return new v(W,$.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(W){return new v(W,$.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(W){return new v(W,$.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(W){return new v(W,$.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(W,be=$.FileSystemProviderErrorCode.Unknown,Fe){super(b.URI.isUri(W)?W.toString(!0):W),this.code=Fe?.name??"Unknown",(0,$.$5j)(this,be),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof Fe=="function"&&Error.captureStackTrace(this,Fe)}};e.$NK=ei,e.$NK=ei=v=Je([P],ei);let Ai=class{constructor(W,be,Fe){this.start=W,this.end=be,this.kind=Fe}};e.$OK=Ai,e.$OK=Ai=Je([P],Ai);var bi;(function(J){J[J.Comment=1]="Comment",J[J.Imports=2]="Imports",J[J.Region=3]="Region"})(bi||(e.FoldingRangeKind=bi={}));var pi;(function(J){J[J.Collapsed=0]="Collapsed",J[J.Expanded=1]="Expanded"})(pi||(e.CommentThreadCollapsibleState=pi={}));var Ui;(function(J){J[J.Editing=0]="Editing",J[J.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var ji;(function(J){J[J.Published=0]="Published",J[J.Draft=1]="Draft"})(ji||(e.CommentState=ji={}));var oi;(function(J){J[J.Unresolved=0]="Unresolved",J[J.Resolved=1]="Resolved"})(oi||(e.CommentThreadState=oi={}));class _i{constructor(W,be=[]){this.tokenTypes=W,this.tokenModifiers=be}}e.$PK=_i;function en(J){return typeof J>"u"||(0,E.$je)(J)}class Li{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let be=0,Fe=W.tokenTypes.length;be<Fe;be++)this.j.set(W.tokenTypes[be],be);for(let be=0,Fe=W.tokenModifiers.length;be<Fe;be++)this.k.set(W.tokenModifiers[be],be)}}push(W,be,Fe,Ke,Qe){if(typeof W=="number"&&typeof be=="number"&&typeof Fe=="number"&&typeof Ke=="number"&&(typeof Qe=="number"||typeof Qe>"u"))return typeof Qe>"u"&&(Qe=0),this.n(W,be,Fe,Ke,Qe);if(j.isRange(W)&&typeof be=="string"&&en(Fe))return this.m(W,be,Fe);throw(0,F.$5)()}m(W,be,Fe){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(be))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,Qe=W.start.character,ot=W.end.character-W.start.character,lt=this.j.get(be);let jt=0;if(Fe)for(const Jt of Fe){if(!this.k.has(Jt))throw new Error("`tokenModifier` is not in the provided legend");const Yt=this.k.get(Jt);jt|=1<<Yt>>>0}this.n(Ke,Qe,ot,lt,jt)}n(W,be,Fe,Ke,Qe){if(this.f&&(W<this.c||W===this.c&&be<this.e)){this.f=!1;const jt=this.g.length/5|0;let Jt=0,Yt=0;for(let xt=0;xt<jt;xt++){let ti=this.g[5*xt],Ni=this.g[5*xt+1];ti===0?(ti=Jt,Ni+=Yt):ti+=Jt,this.g[5*xt]=ti,this.g[5*xt+1]=Ni,Jt=ti,Yt=Ni}}let ot=W,lt=be;this.f&&this.h>0&&(ot-=this.c,ot===0&&(lt-=this.e)),this.g[this.h++]=ot,this.g[this.h++]=lt,this.g[this.h++]=Fe,this.g[this.h++]=Ke,this.g[this.h++]=Qe,this.c=W,this.e=be}static o(W){const be=[],Fe=W.length/5|0;for(let lt=0;lt<Fe;lt++)be[lt]=lt;be.sort((lt,jt)=>{const Jt=W[5*lt],Yt=W[5*jt];if(Jt===Yt){const xt=W[5*lt+1],ti=W[5*jt+1];return xt-ti}return Jt-Yt});const Ke=new Uint32Array(W.length);let Qe=0,ot=0;for(let lt=0;lt<Fe;lt++){const jt=5*be[lt],Jt=W[jt+0],Yt=W[jt+1],xt=W[jt+2],ti=W[jt+3],Ni=W[jt+4],yn=Jt-Qe,On=yn===0?Yt-ot:Yt,Oi=5*lt;Ke[Oi+0]=yn,Ke[Oi+1]=On,Ke[Oi+2]=xt,Ke[Oi+3]=ti,Ke[Oi+4]=Ni,Qe=Jt,ot=Yt}return Ke}build(W){return this.f?new Qt(new Uint32Array(this.g),W):new Qt(Li.o(this.g),W)}}e.$QK=Li;class Qt{constructor(W,be){this.resultId=be,this.data=W}}e.$RK=Qt;class tn{constructor(W,be,Fe){this.start=W,this.deleteCount=be,this.data=Fe}}e.$SK=tn;class nn{constructor(W,be){this.resultId=be,this.edits=W}}e.$TK=nn;var Ri;(function(J){J[J.Separate=0]="Separate",J[J.MergeWithParent=1]="MergeWithParent"})(Ri||(e.DebugConsoleMode=Ri={}));let Fi=class{static{this.Back={iconPath:new Ht("arrow-left")}}constructor(){}};e.$UK=Fi,e.$UK=Fi=Je([P],Fi);var Bi;(function(J){J[J.Separator=-1]="Separator",J[J.Default=0]="Default"})(Bi||(e.QuickPickItemKind=Bi={}));var Wi;(function(J){J[J.Info=1]="Info",J[J.Warning=2]="Warning",J[J.Error=3]="Error"})(Wi||(e.InputBoxValidationSeverity=Wi={}));var wi;(function(J){J[J.UI=1]="UI",J[J.Workspace=2]="Workspace"})(wi||(e.ExtensionKind=wi={}));class qi{static validate(W){if(typeof W.badge=="string"){let be=(0,m.$Vd)(W.badge,0);if(be<W.badge.length&&(be+=(0,m.$Vd)(W.badge,be)),W.badge.length>be)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!Ht.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,be,Fe){this.badge=W,this.tooltip=be,this.color=Fe}}e.$VK=qi;let ze=class{constructor(W){this.kind=W}};e.$WK=ze,e.$WK=ze=Je([P],ze);var Gt;(function(J){J[J.Light=1]="Light",J[J.Dark=2]="Dark",J[J.HighContrast=3]="HighContrast",J[J.HighContrastLight=4]="HighContrastLight"})(Gt||(e.ColorThemeKind=Gt={}));class Xt{static isNotebookRange(W){return W instanceof Xt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,be){if(W<0)throw(0,F.$5)("start must be positive");if(be<0)throw(0,F.$5)("end must be positive");W<=be?(this.c=W,this.e=be):(this.c=be,this.e=W)}with(W){let be=this.c,Fe=this.e;return W.start!==void 0&&(be=W.start),W.end!==void 0&&(Fe=W.end),be===this.c&&Fe===this.e?this:new Xt(be,Fe)}}e.$XK=Xt;class mt{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(be=>mt.isNotebookCellData(be))}static isNotebookCellData(W){return!0}constructor(W,be,Fe,Ke,Qe,ot,lt){this.kind=W,this.value=be,this.languageId=Fe,this.mime=Ke,this.outputs=Qe??[],this.metadata=ot,this.executionSummary=lt,mt.validate(this)}}e.$YK=mt;class rn{constructor(W){this.cells=W}}e.$ZK=rn;class Vt{static isNotebookCellOutputItem(W){return W instanceof Vt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const be={name:W.name,message:W.message,stack:W.stack};return Vt.json(be,"application/vnd.code.notebook.error")}static stdout(W){return Vt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Vt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,be="application/octet-stream"){return new Vt(W,be)}static#e=new TextEncoder;static text(W,be=A.$sr.text){const Fe=Vt.#e.encode(String(W));return new Vt(Fe,be)}static json(W,be="text/x-json"){const Fe=JSON.stringify(W,void 0,"	");return Vt.text(Fe,be)}constructor(W,be){this.data=W,this.mime=be;const Fe=(0,A.$wr)(be,!0);if(!Fe)throw new Error(`INVALID mime type: ${be}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Fe}}e.$1K=Vt;class ci{static isNotebookCellOutput(W){return W instanceof ci?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,be=!1){const Fe=new Set,Ke=new Set;for(let Qe=0;Qe<W.length;Qe++){const ot=W[Qe],lt=(0,A.$wr)(ot.mime);if(!Fe.has(lt)||(0,D.$EH)(lt)){Fe.add(lt);continue}Ke.add(Qe),be&&console.warn(`DUPLICATED mime type '${ot.mime}' will be dropped`)}return Ke.size===0?W:W.filter((Qe,ot)=>!Ke.has(ot))}constructor(W,be,Fe){this.items=ci.ensureUniqueMimeTypes(W,!0),typeof be=="string"?(this.id=be,this.metadata=Fe):(this.id=(0,R.$5e)(),this.metadata=be??Fe)}}e.$2K=ci;var Vi;(function(J){J[J.Markup=1]="Markup",J[J.Code=2]="Code"})(Vi||(e.NotebookCellKind=Vi={}));var ui;(function(J){J[J.Idle=1]="Idle",J[J.Pending=2]="Pending",J[J.Executing=3]="Executing"})(ui||(e.NotebookCellExecutionState=ui={}));var Ji;(function(J){J[J.Left=1]="Left",J[J.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var Hi;(function(J){J[J.Default=0]="Default",J[J.InCenter=1]="InCenter",J[J.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",J[J.AtTop=3]="AtTop"})(Hi||(e.NotebookEditorRevealType=Hi={}));class sn{constructor(W,be){this.text=W,this.alignment=be}}e.$3K=sn;var Ti;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred"})(Ti||(e.NotebookControllerAffinity=Ti={}));var Ki;(function(J){J[J.Default=1]="Default",J[J.Preferred=2]="Preferred",J[J.Hidden=-1]="Hidden"})(Ki||(e.NotebookControllerAffinity2=Ki={}));class on{constructor(W,be=[]){this.uri=W,this.provides=(0,k.$If)(be)}}e.$4K=on;class an{constructor(W){this.label=W}}e.$5K=an;let Mi=class{constructor(W,be){this.label=W,this.timestamp=be}};e.$6K=Mi,e.$6K=Mi=Je([P],Mi);var Gi;(function(J){J[J.Production=1]="Production",J[J.Development=2]="Development",J[J.Test=3]="Test"})(Gi||(e.ExtensionMode=Gi={}));var Xi;(function(J){J[J.Node=1]="Node",J[J.Webworker=2]="Webworker"})(Xi||(e.ExtensionRuntime=Xi={}));var Yi;(function(J){J[J.Other=0]="Other",J[J.Comment=1]="Comment",J[J.String=2]="String",J[J.RegEx=3]="RegEx"})(Yi||(e.StandardTokenType=Yi={}));class cn{constructor(W,be){this.ranges=W,this.wordPattern=be}}e.$7K=cn;class un{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$8K=un;var $e;(function(J){J[J.Queued=1]="Queued",J[J.Running=2]="Running",J[J.Passed=3]="Passed",J[J.Failed=4]="Failed",J[J.Skipped=5]="Skipped",J[J.Errored=6]="Errored"})($e||(e.TestResultState=$e={}));var Se;(function(J){J[J.Run=1]="Run",J[J.Debug=2]="Debug",J[J.Coverage=3]="Coverage"})(Se||(e.TestRunProfileKind=Se={}));let Ne=class{constructor(W=void 0,be=void 0,Fe=void 0,Ke=!1){this.include=W,this.exclude=be,this.profile=Fe,this.continuous=Ke}};e.$9K=Ne,e.$9K=Ne=Je([P],Ne);let nt=class extends Ne{};e.$0K=nt,e.$0K=nt=Je([P],nt);let yt=l=class{static diff(W,be,Fe){const Ke=new l(W);return Ke.expectedOutput=be,Ke.actualOutput=Fe,Ke}constructor(W){this.message=W}};e.$$K=yt,e.$$K=yt=l=Je([P],yt);let Pt=class{constructor(W){this.id=W}};e.$_K=Pt,e.$_K=Pt=Je([P],Pt);let vi=class{constructor(W,be){this.covered=W,this.total=be}};e.$aL=vi,e.$aL=vi=Je([P],vi);let ln=w=class{static fromDetails(W,be){const Fe=new vi(0,0),Ke=new vi(0,0),Qe=new vi(0,0);for(const lt of be)if("branches"in lt){Fe.total+=1,Fe.covered+=lt.executionCount>0?1:0;for(const jt of lt.branches)Ke.total+=1,Ke.covered+=jt.executionCount>0?1:0}else Qe.total+=1,Qe.covered+=lt.executionCount>0?1:0;const ot=new w(W,Fe,Ke.total>0?Ke:void 0,Qe.total>0?Qe:void 0);return ot.detailedCoverage=be,ot}constructor(W,be,Fe,Ke){this.uri=W,this.statementCoverage=be,this.branchCoverage=Fe,this.functionCoverage=Ke}};e.$bL=ln,e.$bL=ln=w=Je([P],ln);let hn=class{constructor(W,be,Fe=[]){this.executionCount=W,this.location=be,this.branches=Fe}};e.$cL=hn,e.$cL=hn=Je([P],hn);let dn=class{constructor(W,be){this.executionCount=W,this.location=be}};e.$dL=dn,e.$dL=dn=Je([P],dn);let fn=class{constructor(W,be){this.executionCount=W,this.location=be}};e.$eL=fn,e.$eL=fn=Je([P],fn);var gn;(function(J){J[J.None=0]="None",J[J.Option=1]="Option",J[J.Default=2]="Default",J[J.Preferred=3]="Preferred"})(gn||(e.ExternalUriOpenerPriority=gn={}));var $n;(function(J){J[J.Untrusted=0]="Untrusted",J[J.Trusted=1]="Trusted",J[J.Unspecified=2]="Unspecified"})($n||(e.WorkspaceTrustState=$n={}));var bn;(function(J){J[J.Notify=1]="Notify",J[J.OpenBrowser=2]="OpenBrowser",J[J.OpenPreview=3]="OpenPreview",J[J.Silent=4]="Silent",J[J.Ignore=5]="Ignore",J[J.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn||(e.PortAutoForwardAction=bn={}));class Cn{constructor(W,be,Fe,Ke,Qe,ot){this.kind=W,this.name=be,this.detail=Fe,this.uri=Ke,this.range=Qe,this.selectionRange=ot}}e.$fL=Cn;class In{constructor(W){this.uri=W}}e.$gL=In;class Pn{constructor(W,be){this.original=W,this.modified=be}}e.$hL=Pn;class An{constructor(W,be,Fe,Ke){this.base=W,this.input1=be,this.input2=Fe,this.result=Ke}}e.$iL=An;class Ln{constructor(W,be){this.uri=W,this.viewType=be}}e.$jL=Ln;class Rn{constructor(W){this.viewType=W}}e.$kL=Rn;class Fn{constructor(W,be){this.uri=W,this.notebookType=be}}e.$lL=Fn;class Tn{constructor(W,be,Fe){this.original=W,this.modified=be,this.notebookType=Fe}}e.$mL=Tn;class Mn{constructor(){}}e.$nL=Mn;class Nn{constructor(W,be){this.uri=W,this.inputBoxUri=be}}e.$oL=Nn;var pn;(function(J){J[J.Up=1]="Up",J[J.Down=2]="Down"})(pn||(e.InteractiveSessionVoteDirection=pn={}));var wn;(function(J){J[J.Action=1]="Action",J[J.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var vn;(function(J){J[J.Unhelpful=0]="Unhelpful",J[J.Helpful=1]="Helpful",J[J.Undone=2]="Undone",J[J.Accepted=3]="Accepted"})(vn||(e.InteractiveEditorResponseFeedbackKind=vn={}))}),define(De[135],Ce([1,0,53,15,12,164,116,7,19]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=e.$CL=e.$BL=void 0;const b=new Map;function R(D,p){p?b.set(D,p):b.delete(D)}e.$BL=R;function I(D){return b.get(D)}class $ extends L.$uu{constructor(p,r,s,c,f,y,C,i){super(r,s,c,f),this.c=p,this.m=y,this.q=C,this.notebook=i,this.b=!1}dispose(){(0,k.ok)(!this.b),this.b=!0,this.q=!1}equalLines(p){return(0,E.$af)(this.f,p)}get document(){if(!this.a){const p=this;this.a={get uri(){return p.d},get fileName(){return p.d.fsPath},get isUntitled(){return p.d.scheme===F.Schemas.untitled},get languageId(){return p.m},get version(){return p.h},get isClosed(){return p.b},get isDirty(){return p.q},save(){return p.r()},getText(r){return r?p.s(r):p.getText()},get eol(){return p.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return p.f.length},lineAt(r){return p.t(r)},offsetAt(r){return p.u(r)},positionAt(r){return p.v(r)},validateRange(r){return p.w(r)},validatePosition(r){return p.x(r)},getWordRangeAtPosition(r,s){return p.y(r,s)}}}return Object.freeze(this.a)}_acceptLanguageId(p){(0,k.ok)(!this.b),this.m=p}_acceptIsDirty(p){(0,k.ok)(!this.b),this.q=p}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(p){const r=this.w(p);if(r.isEmpty)return"";if(r.isSingleLine)return this.f[r.start.line].substring(r.start.character,r.end.character);const s=this.g,c=r.start.line,f=r.end.line,y=[];y.push(this.f[c].substring(r.start.character));for(let C=c+1;C<f;C++)y.push(this.f[C]);return y.push(this.f[f].substring(0,r.end.character)),y.join(s)}t(p){let r;if(p instanceof m.$AJ?r=p.line:typeof p=="number"&&(r=p),typeof r!="number"||r<0||r>=this.f.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new S(r,this.f[r],r===this.f.length-1)}u(p){return p=this.x(p),this.l(),this.j.getPrefixSum(p.line-1)+p.character}v(p){p=Math.floor(p),p=Math.max(0,p),this.l();const r=this.j.getIndexOf(p),s=this.f[r.index].length;return new m.$AJ(r.index,Math.min(r.remainder,s))}w(p){if(!(p instanceof m.$BJ))throw new Error("Invalid argument");const r=this.x(p.start),s=this.x(p.end);return r===p.start&&s===p.end?p:new m.$BJ(r.line,r.character,s.line,s.character)}x(p){if(!(p instanceof m.$AJ))throw new Error("Invalid argument");if(this.f.length===0)return p.with(0,0);let{line:r,character:s}=p,c=!1;if(r<0)r=0,s=0,c=!0;else if(r>=this.f.length)r=this.f.length-1,s=this.f[r].length,c=!0;else{const f=this.f[r].length;s<0?(s=0,c=!0):s>f&&(s=f,c=!0)}return c?new m.$AJ(r,s):p}y(p,r){const s=this.x(p);if(!r)r=I(this.m);else if((0,h.$wd)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const c=(0,A.$Kr)(s.character+1,(0,A.$Ir)(r),this.f[s.line],0);if(c)return new m.$BJ(s.line,c.startColumn-1,s.line,c.endColumn-1)}}e.$CL=$;class S{constructor(p,r,s){this.a=p,this.b=r,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$BJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$BJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$DL=S}),define(De[259],Ce([1,0,7,20,3]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iac=void 0;let L=class{constructor(m){this.a=new k.$WK(k.ColorThemeKind.Dark),this.b=new h.$7c}get activeColorTheme(){return this.a}$onColorThemeChange(m){let E;switch(m){case"light":E=k.ColorThemeKind.Light;break;case"hcDark":E=k.ColorThemeKind.HighContrast;break;case"hcLight":E=k.ColorThemeKind.HighContrastLight;break;default:E=k.ColorThemeKind.Dark}this.a=new k.$WK(E),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$iac=L,e.$iac=L=Je([qe(0,F.$zL)],L)}),define(De[260],Ce([1,0,5]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IH=e.CellExecutionUpdateType=void 0;var F;(function(h){h[h.Output=1]="Output",h[h.OutputItems=2]="OutputItems",h[h.ExecutionState=3]="ExecutionState"})(F||(e.CellExecutionUpdateType=F={})),e.$IH=(0,k.$nh)("INotebookExecutionService")}),define(De[59],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jI=e.TestPosition=e.TestIdPathParts=void 0;var k;(function(L){L.Delimiter="\0"})(k||(e.TestIdPathParts=k={}));var F;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(F||(e.TestPosition=F={}));class h{static fromExtHostTestItem(A,m,E=A.parent){if(A._isRoot)return new h([m]);const b=[A.id];for(let R=E;R&&R.id!==m;R=R.parent)b.push(R.id);return b.push(m),new h(b.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new h(A.split("\0"))}static join(A,m){return new h([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:h.isChild(A,m)?2:h.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new h(this.path,1)}get parentId(){return this.d>1?new h(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new h(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new h(this.path,A)}compare(A){if(typeof A=="string")return h.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$jI=h}),define(De[82],Ce([1,0,2,33,59]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$pI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$oI=e.$nI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$mI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$lI=e.$kI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(d){d[d.Unset=0]="Unset",d[d.Queued=1]="Queued",d[d.Running=2]="Running",d[d.Passed=3]="Passed",d[d.Failed=4]="Failed",d[d.Skipped=5]="Skipped",d[d.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(d){d[d.Run=1]="Run",d[d.Debug=2]="Debug",d[d.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var m;(function(d){d[d.Run=2]="Run",d[d.Debug=4]="Debug",d[d.Coverage=8]="Coverage",d[d.HasNonDefaultProfile=16]="HasNonDefaultProfile",d[d.HasConfigurable=32]="HasConfigurable",d[d.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$kI=[2,4,8,16,32,64];const E=d=>"runId"in d;e.$lI=E;var b;(function(d){d.serialize=v=>({range:v.range.toJSON(),uri:v.uri.toJSON()}),d.deserialize=v=>({range:F.$Mr.lift(v.range),uri:k.URI.revive(v.uri)})})(b||(e.IRichLocation=b={}));var R;(function(d){d[d.Error=0]="Error",d[d.Output=1]="Output"})(R||(e.TestMessageType=R={}));var I;(function(d){d.serialize=v=>({message:v.message,type:0,expected:v.expected,actual:v.actual,location:v.location&&b.serialize(v.location)}),d.deserialize=v=>({message:v.message,type:0,expected:v.expected,actual:v.actual,location:v.location&&b.deserialize(v.location)})})(I||(e.ITestErrorMessage=I={}));const $=(d,v)=>`${v?"s":"e"}${d}`;e.$mI=$;var S;(function(d){d.serialize=v=>({message:v.message,type:1,offset:v.offset,length:v.length,location:v.location&&b.serialize(v.location)}),d.deserialize=v=>({message:v.message,type:1,offset:v.offset,length:v.length,location:v.location&&b.deserialize(v.location)})})(S||(e.ITestOutputMessage=S={}));var D;(function(d){d.serialize=v=>v.type===0?I.serialize(v):S.serialize(v),d.deserialize=v=>v.type===0?I.deserialize(v):S.deserialize(v)})(D||(e.ITestMessage=D={}));var p;(function(d){d.serializeWithoutMessages=v=>({state:v.state,duration:v.duration,messages:[]}),d.serialize=v=>({state:v.state,duration:v.duration,messages:v.messages.map(D.serialize)}),d.deserialize=v=>({state:v.state,duration:v.duration,messages:v.messages.map(D.deserialize)})})(p||(e.ITestTaskState=p={}));const r="\0",s=(d,v)=>d+r+v;e.$nI=s;const c=d=>{const v=d.indexOf(r);return{ctrlId:d.slice(0,v),tagId:d.slice(v+1)}};e.$oI=c;var f;(function(d){d.serialize=v=>({extId:v.extId,label:v.label,tags:v.tags,busy:v.busy,children:void 0,uri:v.uri?.toJSON(),range:v.range?.toJSON()||null,description:v.description,error:v.error,sortText:v.sortText}),d.deserialize=v=>({extId:v.extId,label:v.label,tags:v.tags,busy:v.busy,children:void 0,uri:v.uri?k.URI.revive(v.uri):void 0,range:v.range?F.$Mr.lift(v.range):null,description:v.description,error:v.error,sortText:v.sortText})})(f||(e.ITestItem=f={}));var y;(function(d){d[d.NotExpandable=0]="NotExpandable",d[d.Expandable=1]="Expandable",d[d.BusyExpanding=2]="BusyExpanding",d[d.Expanded=3]="Expanded"})(y||(e.TestItemExpandState=y={}));var C;(function(d){d.serialize=v=>({expand:v.expand,item:f.serialize(v.item)}),d.deserialize=v=>({controllerId:h.$jI.root(v.item.extId),expand:v.expand,item:f.deserialize(v.item)})})(C||(e.InternalTestItem=C={}));var i;(function(d){d.serialize=v=>{let l;return v.item&&(l={},v.item.label!==void 0&&(l.label=v.item.label),v.item.tags!==void 0&&(l.tags=v.item.tags),v.item.busy!==void 0&&(l.busy=v.item.busy),v.item.uri!==void 0&&(l.uri=v.item.uri?.toJSON()),v.item.range!==void 0&&(l.range=v.item.range?.toJSON()),v.item.description!==void 0&&(l.description=v.item.description),v.item.error!==void 0&&(l.error=v.item.error),v.item.sortText!==void 0&&(l.sortText=v.item.sortText)),{extId:v.extId,expand:v.expand,item:l}},d.deserialize=v=>{let l;return v.item&&(l={},v.item.label!==void 0&&(l.label=v.item.label),v.item.tags!==void 0&&(l.tags=v.item.tags),v.item.busy!==void 0&&(l.busy=v.item.busy),v.item.range!==void 0&&(l.range=v.item.range?F.$Mr.lift(v.item.range):null),v.item.description!==void 0&&(l.description=v.item.description),v.item.error!==void 0&&(l.error=v.item.error),v.item.sortText!==void 0&&(l.sortText=v.item.sortText)),{extId:v.extId,expand:v.expand,item:l}}})(i||(e.ITestItemUpdate=i={}));const a=(d,v)=>{v.expand!==void 0&&(d.expand=v.expand),v.item!==void 0&&(d.item=d.item?Object.assign(d.item,v.item):v.item)};e.$pI=a;var n;(function(d){d.serializeWithoutMessages=v=>({...C.serialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(p.serializeWithoutMessages)}),d.serialize=v=>({...C.serialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(p.serialize)}),d.deserialize=v=>({...C.deserialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(p.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var t;(function(d){d[d.Function=0]="Function",d[d.Statement=1]="Statement"})(t||(e.DetailType=t={}));var o;(function(d){d[d.Add=0]="Add",d[d.Update=1]="Update",d[d.DocumentSynced=2]="DocumentSynced",d[d.Remove=3]="Remove",d[d.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",d[d.Retire=5]="Retire",d[d.AddTag=6]="AddTag",d[d.RemoveTag=7]="RemoveTag"})(o||(e.TestDiffOpType=o={}));var g;(function(d){d.deserialize=v=>v.op===0?{op:v.op,item:C.deserialize(v.item)}:v.op===1?{op:v.op,item:i.deserialize(v.item)}:v.op===2?{op:v.op,uri:k.URI.revive(v.uri),docv:v.docv}:v,d.serialize=v=>v.op===0?{op:v.op,item:C.serialize(v.item)}:v.op===1?{op:v.op,item:i.serialize(v.item)}:v})(g||(e.TestsDiffOp=g={}));class u{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(v){const l=this.o();for(const w of v)switch(w.op){case 0:this.j(C.deserialize(w.item),l);break;case 1:this.k(i.deserialize(w.item),l);break;case 3:this.l(w.itemId,l);break;case 5:this.m(w.itemId);break;case 4:this.updatePendingRoots(w.amount);break;case 6:this.c.set(w.tag.id,w.tag);break;case 7:this.c.delete(w.id);break}l.complete?.()}j(v,l){const w=h.$jI.parentId(v.item.extId)?.toString();let P;if(!w)P=this.p(v),this.f.add(P),this.d.set(v.item.extId,P);else if(this.d.has(w)){const M=this.d.get(w);M.children.add(v.item.extId),P=this.p(v,M),this.d.set(v.item.extId,P)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(v)}`);return}return l.add?.(P),v.expand===2&&this.g++,P}k(v,l){const w=this.d.get(v.extId);if(w)return v.expand!==void 0&&(w.expand===2&&this.g--,v.expand===2&&this.g++),(0,e.$pI)(w,v),l.update?.(w),w}l(v,l){const w=this.d.get(v);if(!w)return;const P=h.$jI.parentId(w.item.extId)?.toString();P?this.d.get(P).children.delete(w.item.extId):this.f.delete(w);const M=[[v]];for(;M.length;)for(const N of M.pop()){const T=this.d.get(N);T&&(M.push(T.children),this.d.delete(N),l.remove?.(T,T!==w),T.expand===2&&this.g--)}}m(v){}updatePendingRoots(v){this.h+=v}o(){return{}}}e.$qI=u}),define(De[103],Ce([1,0,17,3,4,53,82,59]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.TestItemEventOp=void 0;var E;(function(c){c[c.Upsert=0]="Upsert",c[c.SetTags=1]="SetTags",c[c.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",c[c.RemoveChild=3]="RemoveChild",c[c.SetProp=4]="SetProp",c[c.Bulk=5]="Bulk",c[c.DocumentSynced=6]="DocumentSynced"})(E||(e.TestItemEventOp=E={}));const b=(c,f)=>c===f,I=Object.entries({range:(c,f)=>c===f?!0:!c||!f?!1:c.equalsRange(f),busy:b,label:b,description:b,error:b,sortText:b,tags:(c,f)=>!(c.length!==f.length||c.some(y=>!f.includes(y)))}),$=(c,f)=>{let y;for(const[C,i]of I)i(c[C],f[C])||(y?y[C]=f[C]:y={[C]:f[C]});return y};class S extends h.$lb{get root(){return this.m.root}constructor(f){super(),this.m=f,this.f=this.B(new k.$Eg(()=>this.flushDiff(),200)),this.g=this.B(new F.$7c),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(f){this.h=f;for(const y of this.tree.values())this.G(y)}get resolveHandler(){return this.h}collectDiff(){const f=this.k;return this.k=[],f}pushDiff(f){switch(f.op){case 2:{for(const y of this.k)if(y.op===2&&y.uri===f.uri){y.docv=f.docv;return}break}case 1:{const y=this.k[this.k.length-1];if(y){if(y.op===1&&y.item.extId===f.item.extId){(0,A.$pI)(y.item,f.item);return}if(y.op===0&&y.item.item.extId===f.item.extId){(0,A.$pI)(y.item,f.item);return}}break}}this.k.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,y){const C=this.tree.get(f);if(C){if((C.expandLevels===void 0||y>C.expandLevels)&&(C.expandLevels=y),C.expand===1){const i=this.I(C);return i.isOpen()?this.H(C,y-1):i.wait().then(()=>this.H(C,y-1))}else if(C.expand===3)return C.resolveBarrier?.isOpen()===!1?C.resolveBarrier.wait().then(()=>this.H(C,y-1)):this.H(C,y-1)}}dispose(){for(const f of this.tree.values())this.m.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(f,y){switch(y.op){case 3:this.L(m.$jI.joinToString(f.fullId,y.id));break;case 0:this.u(y.item,f);break;case 5:for(const C of y.ops)this.p(f,C);break;case 1:this.w(y.new,y.old,f.fullId.toString());break;case 2:this.G(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:y.update}});break;case 6:this.s(f.actual.uri);break;default:(0,L.$nc)(y)}}s(f){f&&this.pushDiff({op:2,uri:f,docv:this.m.getDocumentVersion(f)})}u(f,y){const C=m.$jI.fromExtHostTestItem(f,this.root.id,y?.actual),i=this.m.getApiFor(f);i.parent&&i.parent!==y?.actual&&this.m.getChildren(i.parent).delete(f.id);let a=this.tree.get(C.toString());if(!a){a={fullId:C,actual:f,expandLevels:y?.expandLevels?y.expandLevels-1:void 0,expand:0},f.tags.forEach(this.y,this),this.tree.set(a.fullId.toString(),a),this.C(f,y),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:a.expand,item:this.m.toITestItem(f)}}),this.F(f,a,y);return}if(a.actual===f){this.D(f,a,y);return}if(a.actual.uri?.toString()!==f.uri?.toString())return this.L(C.toString()),this.u(f,y);const n=this.m.getChildren(a.actual),t=a.actual,o=$(this.m.toITestItem(t),this.m.toITestItem(f));this.m.getApiFor(t).listener=void 0,a.actual=f,a.expand=0,o&&(o.hasOwnProperty("tags")&&(this.w(f.tags,t.tags,C.toString()),delete o.tags),this.p(a,{op:4,update:o})),this.F(f,a,y);for(const[g,u]of n)this.m.getChildren(f).get(u.id)||this.L(m.$jI.joinToString(C,u.id));this.s(a.actual.uri)}w(f,y,C){const i=new Set(y.map(a=>a.id));for(const a of f)i.delete(a.id)||this.y(a);this.pushDiff({op:1,item:{extId:C,item:{tags:f.map(a=>(0,A.$nI)(this.m.controllerId,a.id))}}}),i.forEach(this.z,this)}y(f){const y=this.j.get(f.id);y?y.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$nI)(this.m.controllerId,f.id)}}))}z(f){const y=this.j.get(f);y&&!--y.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,A.$nI)(this.m.controllerId,f)}))}C(f,y){this.m.getApiFor(f).parent=y&&y.actual!==this.root?y.actual:void 0}D(f,y,C){this.C(f,C);const i=this.m.getApiFor(f);i.parent=C?.actual,i.listener=a=>this.p(y,a),this.G(y)}F(f,y,C){this.D(f,y,C);for(const[i,a]of this.m.getChildren(f))this.u(a,y)}G(f){let y;this.h?f.resolveBarrier?y=f.resolveBarrier.isOpen()?3:2:y=f.actual.canResolveChildren?1:0:y=0,y!==f.expand&&(f.expand=y,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:y}}),y===1&&f.expandLevels!==void 0&&this.I(f))}H(f,y){if(y<0)return;const C=[];for(const[i,a]of this.m.getChildren(f.actual)){const n=this.expand(m.$jI.joinToString(f.fullId,a.id),y);(0,k.$gg)(n)&&C.push(n)}if(C.length)return Promise.all(C).then(()=>{})}I(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const a=new k.$sg;return a.open(),a}f.expand=2,this.J(f);const y=f.resolveBarrier=new k.$sg,C=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,a)};let i;try{i=this.h(f.actual===this.root?void 0:f.actual)}catch(a){C(a)}return(0,k.$gg)(i)?i.catch(C).then(()=>{y.open(),this.G(f)}):(y.open(),this.G(f)),f.resolveBarrier}J(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}L(f){const y=this.tree.get(f);if(!y)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const C=[y];for(;C.length;){const i=C.pop();if(i){this.m.getApiFor(i.actual).listener=void 0;for(const a of i.actual.tags)this.z(a.id);this.tree.delete(i.fullId.toString());for(const[a,n]of this.m.getChildren(i.actual))C.push(this.tree.get(m.$jI.joinToString(i.fullId,n.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.$pL=S;class D extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.$qL=D;class p extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$rL=p;class r extends Error{constructor(f,y,C){super(`TestItem with ID "${f}" is from controller "${y}" and cannot be added as a child of an item from controller "${C}".`)}}e.$sL=r;const s=(c,f,y)=>{let C=new Map;return{get size(){return C.size},forEach(i,a){for(const n of C.values())i.call(a,n,this)},[Symbol.iterator](){return C.entries()},replace(i){const a=new Map,n=new Set(C.keys()),t={op:5,ops:[]};for(const o of i){if(!(o instanceof y))throw new p(o.id);const g=f(o).controllerId;if(g!==c.controllerId)throw new r(o.id,g,c.controllerId);if(a.has(o.id))throw new D(o.id);a.set(o.id,o),n.delete(o.id),t.ops.push({op:0,item:o})}for(const o of n.keys())t.ops.push({op:3,id:o});c.listener?.(t),C=a},add(i){if(!(i instanceof y))throw new p(i.id);C.set(i.id,i),c.listener?.({op:0,item:i})},delete(i){C.delete(i)&&c.listener?.({op:3,id:i})},get(i){return C.get(i)},toJSON(){return Array.from(C.values())}}};e.$tL=s}),define(De[136],Ce([1,0,103]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vL=e.$uL=void 0;const F=new WeakMap,h=(A,m)=>{const E={controllerId:m};return F.set(A,E),E};e.$uL=h;const L=A=>{const m=F.get(A);if(!m)throw new k.$rL(A?.id||"<unknown>");return m};e.$vL=L}),define(De[104],Ce([1,0,15,2]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enb=e.$dnb=e.$cnb=e.$bnb=e.$anb=void 0,e.$anb="vscode-cdn.net",e.$bnb=`vscode-resource.${e.$anb}`,e.$cnb=`'self' https://*.${e.$anb}`;function h(m,E){return m.scheme===k.Schemas.http||m.scheme===k.Schemas.https?m:(E&&E.authority&&E.isRemote&&m.scheme===k.Schemas.file&&(m=F.URI.from({scheme:k.Schemas.vscodeRemote,authority:E.authority,path:m.path})),F.URI.from({scheme:k.Schemas.https,authority:`${m.scheme}+${L(m.authority)}.${e.$bnb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$dnb=h;function L(m){return m.replace(/./g,E=>{const b=E.charCodeAt(0);return b>=97&&b<=122||b>=65&&b<=90||b>=48&&b<=57?E:"-"+b.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(E,b)=>String.fromCharCode(parseInt(b,16)))}e.$enb=A}),define(De[261],Ce([1,0,3,4,104]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S_b=void 0;class L{constructor(m,E,b){this.d=m,this.e=E,this.f=b,this.a=0,this.b=new F.$kb,this.c=new Map,this.b.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const I of this.c.values())R.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,E,b,R,I){let $;for(const f of this.e.getVisibleTextEditors(!0))if(f.value===m){$=f;break}if(!$)throw new Error("not a visible editor");const S=this,D=this.a++,p=new k.$7c,r=new k.$7c,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(f){return(0,h.$dnb)(f,S.f)}get cspSource(){return h.$cnb}set options(f){this.b=f,S.d.$setOptions(D,f)}get options(){return this.b}set html(f){this.a=f,S.d.$setHtml(D,f)}get html(){return this.a}get onDidReceiveMessage(){return p.event}postMessage(f){return S.d.$postMessage(D,f)}},c=new class{constructor(){this.editor=m,this.line=E,this.height=b,this.webview=s,this.onDidDispose=r.event}dispose(){S.c.has(D)&&(S.c.delete(D),S.d.$disposeEditorInset(D),r.fire(),r.dispose(),p.dispose())}};return this.d.$createEditorInset(D,$.id,$.value.document.uri,E+1,b,R||{},I.identifier,I.extensionLocation),this.c.set(D,{editor:m,inset:c,onDidReceiveMessage:p}),c}$onDidDispose(m){const E=this.c.get(m);E&&E.inset.dispose()}$onDidReceiveMessage(m,E){this.c.get(m)?.onDidReceiveMessage.fire(E)}}e.$S_b=L}),define(De[262],Ce([1,0,5]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.VariableKind=e.$lM=void 0,e.$lM=(0,k.$nh)("configurationResolverService");var F;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(F||(e.VariableKind=F={}));class h extends Error{constructor(A,m){super(m),this.variable=A}}e.$mM=h}),define(De[263],Ce([1,0,13,41,14,23,11,120,213,262,12]),function(me,e,k,F,h,L,A,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=void 0;class I{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(S,D,p,r){this.h=new Map,this.a=S,this.b=D,this.g=p,r&&(this.c=r.then(s=>this.i(s)))}i(S){if(A.$i){const D=Object.create(null);return Object.keys(S).forEach(p=>{D[p.toLowerCase()]=S[p]}),D}return S}resolveWithEnvironment(S,D,p){return this.l({env:this.i(S),userHome:void 0},D?D.uri:void 0,p)}async resolveAsync(S,D){const p={env:await this.c,userHome:await this.g};return this.l(p,S?S.uri:void 0,D)}async j(S,D,p,r){const s=L.$Fm(D);A.$i&&s.windows?Object.keys(s.windows).forEach(f=>s[f]=s.windows[f]):A.$j&&s.osx?Object.keys(s.osx).forEach(f=>s[f]=s.osx[f]):A.$k&&s.linux&&Object.keys(s.linux).forEach(f=>s[f]=s.linux[f]),delete s.windows,delete s.osx,delete s.linux;const c={env:await this.c,userHome:await this.g};return this.l(c,S?S.uri:void 0,s,p,r)}async resolveAnyAsync(S,D,p){return this.j(S,D,p)}async resolveAnyMap(S,D,p){const r=new Map;return{newConfig:await this.j(S,D,p,r),resolvedVariables:r}}resolveWithInteractionReplace(S,D,p,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,D,p,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,D){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,D)}async l(S,D,p,r,s){if(h.$ie(p))return this.m(S,D,p,r,s);if(Array.isArray(p))return Promise.all(p.map(c=>this.l(S,D,c,r,s)));if(h.$ke(p)){const c=Object.create(null),f=await Promise.all(Object.keys(p).map(async y=>[await this.m(S,D,y,r,s),await this.l(S,D,p[y],r,s)]));for(const[y,C]of f)c[y]=C;return c}return p}m(S,D,p,r,s){return(0,R.$Dd)(p,I.VARIABLE_REGEXP,async(c,f)=>{if(f.includes(I.VARIABLE_LHS))return c;let y=await this.o(S,c,f,D,r);return s?.set(f,y),y!==c&&h.$ie(y)&&y.match(I.VARIABLE_REGEXP)&&(y=await this.m(S,D,y,r,s)),y})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,D,p,r,s){let c;const f=p.split(":");f.length>1&&(p=f[0],c=f[1]);const y=a=>{const n=this.a.getFilePath();if(n)return(0,m.$Yz)(n);throw new b.$mM(a,(0,E.localize)(0,null,D))},C=a=>{const n=y(a);if(this.a.getWorkspaceFolderPathForFile){const t=this.a.getWorkspaceFolderPathForFile();if(t)return(0,m.$Yz)(t)}throw new b.$mM(a,(0,E.localize)(1,null,D,k.$ec(n)))},i=a=>{if(c){const n=this.a.getFolderUri(c);if(n)return n;throw new b.$mM(a,(0,E.localize)(2,null,D,c))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new b.$mM(a,(0,E.localize)(3,null,D)):new b.$mM(a,(0,E.localize)(4,null,D))};switch(p){case"env":if(c){if(S.env){const a=S.env[A.$i?c.toLowerCase():c];if(h.$ie(a))return a}return""}throw new b.$mM(b.VariableKind.Env,(0,E.localize)(5,null,D));case"config":if(c){const a=this.a.getConfigurationValue(r,c);if(h.$re(a))throw new b.$mM(b.VariableKind.Config,(0,E.localize)(6,null,D,c));if(h.$ke(a))throw new b.$mM(b.VariableKind.Config,(0,E.localize)(7,null,D,c));return a}throw new b.$mM(b.VariableKind.Config,(0,E.localize)(8,null,D));case"command":return this.p(b.VariableKind.Command,D,c,s,"command");case"input":return this.p(b.VariableKind.Input,D,c,s,"input");case"extensionInstallFolder":if(c){const a=await this.a.getExtension(c);if(!a)throw new b.$mM(b.VariableKind.ExtensionInstallFolder,(0,E.localize)(9,null,D,c));return this.n(a.extensionLocation)}throw new b.$mM(b.VariableKind.ExtensionInstallFolder,(0,E.localize)(10,null,D));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,m.$Yz)(this.n(i(b.VariableKind.WorkspaceFolder)));case"cwd":return r||c?(0,m.$Yz)(this.n(i(b.VariableKind.Cwd))):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Yz)(k.$ec(this.n(i(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new b.$mM(b.VariableKind.UserHome,(0,E.localize)(11,null,D))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new b.$mM(b.VariableKind.LineNumber,(0,E.localize)(12,null,D))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new b.$mM(b.VariableKind.SelectedText,(0,E.localize)(13,null,D))}case"file":return y(b.VariableKind.File);case"fileWorkspaceFolder":return C(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return r||c?k.$cc(this.n(i(b.VariableKind.RelativeFile)),y(b.VariableKind.RelativeFile)):y(b.VariableKind.RelativeFile);case"relativeFileDirname":{const a=k.$dc(y(b.VariableKind.RelativeFileDirname));if(r||c){const n=k.$cc(this.n(i(b.VariableKind.RelativeFileDirname)),a);return n.length===0?".":n}return a}case"fileDirname":return k.$dc(y(b.VariableKind.FileDirname));case"fileExtname":return k.$fc(y(b.VariableKind.FileExtname));case"fileBasename":return k.$ec(y(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=k.$ec(y(b.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-k.$fc(a).length)}case"fileDirnameBasename":return k.$ec(k.$dc(y(b.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||D}case"execInstallFolder":{const a=this.a.getAppRoot();return a||D}case"pathSeparator":return k.sep;default:try{const a=c?`${p}:${c}`:p;return this.p(b.VariableKind.Unknown,D,a,s,void 0)}catch{return D}}}}p(S,D,p,r,s){if(p&&r){const c=s===void 0?r[p]:r[s+":"+p];if(typeof c=="string")return c;throw new b.$mM(S,(0,E.localize)(14,null,D))}return D}}e.$AM=I}),define(De[137],Ce([1,0,5,133]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PC=e.$OC=e.OpenEditorContext=e.GroupsOrder=e.$NC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$MC=void 0,e.$MC=(0,k.$nh)("editorGroupsService");var h;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(h||(e.GroupDirection=h={}));var L;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})(m||(e.GroupsArrangement=m={}));var E;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(E||(e.MergeGroupMode=E={}));function b(D){const p=D;return(0,F.$CE)(p?.editor)&&(0,F.$CE)(p?.replacement)}e.$NC=b;var R;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var I;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(I||(e.OpenEditorContext=I={}));function $(D){const p=D;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.$OC=$;function S(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$PC=S}),define(De[264],Ce([1,0,5,137]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=e.$SC=e.$RC=e.$QC=void 0,e.$QC=(0,k.$nh)("editorService"),e.$RC=-1,e.$SC=-2;function h(L){const A=L;return typeof L=="number"||(0,F.$OC)(A)}e.$TC=h}),define(De[16],Ce([1,0,19,22,156,67,74,28,152,73,93,23,14,2,33,77,126,136,133,102,59,82,264,7]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y,C,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$yL=e.$xL=e.MarkdownString=e.$wL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Te){function Le(ae){const{selectionStartLineNumber:Me,selectionStartColumn:We,positionLineNumber:Xe,positionColumn:He}=ae,it=new a.$AJ(Me-1,We-1),wt=new a.$AJ(Xe-1,He-1);return new a.$CJ(it,wt)}Te.to=Le;function Ae(ae){const{anchor:Me,active:We}=ae;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Te.from=Ae})(n||(e.Selection=n={}));var t;(function(Te){function Le(ae){if(!ae)return;const{start:Me,end:We}=ae;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Te.from=Le;function Ae(ae){if(!ae)return;const{startLineNumber:Me,startColumn:We,endLineNumber:Xe,endColumn:He}=ae;return new a.$BJ(Me-1,We-1,Xe-1,He-1)}Te.to=Ae})(t||(e.Range=t={}));var o;(function(Te){function Le(Ae){switch(Ae){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Te.to=Le})(o||(e.TokenType=o={}));var g;(function(Te){function Le(ae){return new a.$AJ(ae.lineNumber-1,ae.column-1)}Te.to=Le;function Ae(ae){return{lineNumber:ae.line+1,column:ae.character+1}}Te.from=Ae})(g||(e.Position=g={}));var u;(function(Te){function Le(Me,We,Xe){return(0,k.$lf)((0,k.$If)(Me).map(He=>Ae(He,We,Xe)))}Te.from=Le;function Ae(Me,We,Xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:ae(Me.scheme,We),pattern:Be.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Xe?.isBuiltin}}function ae(Me,We){return We&&typeof Me=="string"?We.transformOutgoingScheme(Me):Me}})(u||(e.DocumentSelector=u={}));var d;(function(Te){function Le(ae){switch(ae){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Te.from=Le;function Ae(ae){switch(ae){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Te.to=Ae})(d||(e.DiagnosticTag=d={}));var v;(function(Te){function Le(ae){let Me;return ae.code&&((0,$.$ie)(ae.code)||(0,$.$me)(ae.code)?Me=String(ae.code):Me={value:String(ae.code.value),target:ae.code.target}),{...t.from(ae.range),message:ae.message,source:ae.source,code:Me,severity:w.from(ae.severity),relatedInformation:ae.relatedInformation&&ae.relatedInformation.map(l.from),tags:Array.isArray(ae.tags)?(0,k.$lf)(ae.tags.map(d.from)):void 0}}Te.from=Le;function Ae(ae){const Me=new a.$NJ(t.to(ae),ae.message,w.to(ae.severity));return Me.source=ae.source,Me.code=(0,$.$ie)(ae.code)?ae.code:ae.code?.value,Me.relatedInformation=ae.relatedInformation&&ae.relatedInformation.map(l.to),Me.tags=ae.tags&&(0,k.$lf)(ae.tags.map(d.to)),Me}Te.to=Ae})(v||(e.Diagnostic=v={}));var l;(function(Te){function Le(ae){return{...t.from(ae.location.range),message:ae.message,resource:ae.location.uri}}Te.from=Le;function Ae(ae){return new a.$MJ(new a.$LJ(ae.resource,t.to(ae)),ae.message)}Te.to=Ae})(l||(e.DiagnosticRelatedInformation=l={}));var w;(function(Te){function Le(ae){switch(ae){case a.DiagnosticSeverity.Error:return r.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return r.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return r.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return r.MarkerSeverity.Hint}return r.MarkerSeverity.Error}Te.from=Le;function Ae(ae){switch(ae){case r.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case r.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case r.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case r.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Te.to=Ae})(w||(e.DiagnosticSeverity=w={}));var P;(function(Te){function Le(ae){return typeof ae=="number"&&ae>=a.ViewColumn.One?ae-1:ae===a.ViewColumn.Beside?i.$SC:i.$RC}Te.from=Le;function Ae(ae){if(typeof ae=="number"&&ae>=0)return ae+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=Ae})(P||(e.ViewColumn=P={}));function M(Te){return typeof Te.range<"u"}function N(Te){return Te.length===0?!0:!!M(Te[0])}e.$wL=N;var T;(function(Te){function Le(He){return He.map(Te.from)}Te.fromMany=Le;function Ae(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function ae(He){let it;if(Ae(He)){const{language:pt,value:$t}=He;it={value:"```"+pt+`
`+$t+"\n```\n"}}else a.$1J.isMarkdownString(He)?it={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?it={value:He}:it={value:""};const wt=Object.create(null);it.uris=wt;const Dt=pt=>{try{let $t=S.URI.parse(pt,!0);$t=$t.with({query:Me($t.query,wt)}),wt[pt]=$t}catch{}return""},Ct=new E.marked.Renderer;return Ct.link=Dt,Ct.image=pt=>typeof pt=="string"?Dt(A.$Pj(pt).href):"",(0,E.marked)(it.value,{renderer:Ct}),it}Te.from=ae;function Me(He,it){if(!He)return He;let wt;try{wt=(0,b.$Vg)(He)}catch{}if(!wt)return He;let Dt=!1;return wt=(0,I.$Hm)(wt,Ct=>{if(S.URI.isUri(Ct)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[pt]=Ct,Dt=!0,pt}else return}),Dt?JSON.stringify(wt):He}function We(He){const it=new a.$1J(He.value,He.supportThemeIcons);return it.isTrusted=He.isTrusted,it.supportHtml=He.supportHtml,it.baseUri=He.baseUri?S.URI.from(He.baseUri):void 0,it}Te.to=We;function Xe(He){if(He)return typeof He=="string"?He:Te.from(He)}Te.fromStrict=Xe})(T||(e.MarkdownString=T={}));function z(Te){return N(Te)?Te.map(Le=>({range:t.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?T.fromMany(Le.hoverMessage):Le.hoverMessage?T.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):Te.map(Le=>({range:t.from(Le)}))}e.$xL=z;function j(Te){return typeof Te>"u"?Te:typeof Te=="string"?S.URI.file(Te):Te}e.$yL=j;var U;(function(Te){function Le(Ae){return typeof Ae>"u"?Ae:{contentText:Ae.contentText,contentIconPath:Ae.contentIconPath?j(Ae.contentIconPath):void 0,border:Ae.border,borderColor:Ae.borderColor,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,color:Ae.color,backgroundColor:Ae.backgroundColor,margin:Ae.margin,width:Ae.width,height:Ae.height}}Te.from=Le})(U||(e.ThemableDecorationAttachmentRenderOptions=U={}));var Y;(function(Te){function Le(Ae){return typeof Ae>"u"?Ae:{backgroundColor:Ae.backgroundColor,outline:Ae.outline,outlineColor:Ae.outlineColor,outlineStyle:Ae.outlineStyle,outlineWidth:Ae.outlineWidth,border:Ae.border,borderColor:Ae.borderColor,borderRadius:Ae.borderRadius,borderSpacing:Ae.borderSpacing,borderStyle:Ae.borderStyle,borderWidth:Ae.borderWidth,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,cursor:Ae.cursor,color:Ae.color,opacity:Ae.opacity,letterSpacing:Ae.letterSpacing,gutterIconPath:Ae.gutterIconPath?j(Ae.gutterIconPath):void 0,gutterIconSize:Ae.gutterIconSize,overviewRulerColor:Ae.overviewRulerColor,before:Ae.before?U.from(Ae.before):void 0,after:Ae.after?U.from(Ae.after):void 0}}Te.from=Le})(Y||(e.ThemableDecorationRenderOptions=Y={}));var H;(function(Te){function Le(Ae){if(typeof Ae>"u")return Ae;switch(Ae){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=Le})(H||(e.DecorationRangeBehavior=H={}));var ge;(function(Te){function Le(Ae){return{isWholeLine:Ae.isWholeLine,rangeBehavior:Ae.rangeBehavior?H.from(Ae.rangeBehavior):void 0,overviewRulerLane:Ae.overviewRulerLane,light:Ae.light?Y.from(Ae.light):void 0,dark:Ae.dark?Y.from(Ae.dark):void 0,backgroundColor:Ae.backgroundColor,outline:Ae.outline,outlineColor:Ae.outlineColor,outlineStyle:Ae.outlineStyle,outlineWidth:Ae.outlineWidth,border:Ae.border,borderColor:Ae.borderColor,borderRadius:Ae.borderRadius,borderSpacing:Ae.borderSpacing,borderStyle:Ae.borderStyle,borderWidth:Ae.borderWidth,fontStyle:Ae.fontStyle,fontWeight:Ae.fontWeight,textDecoration:Ae.textDecoration,cursor:Ae.cursor,color:Ae.color,opacity:Ae.opacity,letterSpacing:Ae.letterSpacing,gutterIconPath:Ae.gutterIconPath?j(Ae.gutterIconPath):void 0,gutterIconSize:Ae.gutterIconSize,overviewRulerColor:Ae.overviewRulerColor,before:Ae.before?U.from(Ae.before):void 0,after:Ae.after?U.from(Ae.after):void 0}}Te.from=Le})(ge||(e.DecorationRenderOptions=ge={}));var ie;(function(Te){function Le(ae){return{text:ae.newText,eol:ae.newEol&&Ze.from(ae.newEol),range:t.from(ae.range)}}Te.from=Le;function Ae(ae){const Me=new a.$GJ(t.to(ae.range),ae.text);return Me.newEol=typeof ae.eol>"u"?void 0:Ze.to(ae.eol),Me}Te.to=Ae})(ie||(e.TextEdit=ie={}));var te;(function(Te){function Le(ae,Me){const We={edits:[]};if(ae instanceof a.$JJ){const Xe=new m.$mi;for(const He of ae._allEntries())He._type===1&&S.URI.isUri(He.to)&&He.from===void 0&&Xe.add(He.to);for(const He of ae._allEntries())if(He._type===1){let it;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?it={type:"base64",value:(0,F.$4b)(F.$Jb.wrap(He.options.contents))}:it={type:"dataTransferItem",id:He.options.contents._itemId}),We.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:it},metadata:He.metadata})}else He._type===2?We.edits.push({resource:He.uri,textEdit:ie.from(He.edit),versionId:Xe.has(He.uri)?void 0:Me?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?We.edits.push({resource:He.uri,textEdit:{range:t.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Xe.has(He.uri)?void 0:Me?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?We.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(He.uri)}):He._type===5&&We.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Me?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(_e.from)}})}return We}Te.from=Le;function Ae(ae){const Me=new a.$JJ,We=new m.$li;for(const Xe of ae.edits)if(Xe.textEdit){const He=Xe,it=S.URI.revive(He.resource),wt=t.to(He.textEdit.range),Dt=He.textEdit.text,Ct=He.textEdit.insertAsSnippet;let pt;Ct?pt=a.$IJ.replace(wt,new a.$KJ(Dt)):pt=a.$GJ.replace(wt,Dt);const $t=We.get(it);$t?$t.push(pt):We.set(it,[pt])}else Me.renameFile(S.URI.revive(Xe.oldResource),S.URI.revive(Xe.newResource),Xe.options);for(const[Xe,He]of We)Me.set(Xe,He);return Me}Te.to=Ae})(te||(e.WorkspaceEdit=te={}));var q;(function(Te){const Le=Object.create(null);Le[a.SymbolKind.File]=0,Le[a.SymbolKind.Module]=1,Le[a.SymbolKind.Namespace]=2,Le[a.SymbolKind.Package]=3,Le[a.SymbolKind.Class]=4,Le[a.SymbolKind.Method]=5,Le[a.SymbolKind.Property]=6,Le[a.SymbolKind.Field]=7,Le[a.SymbolKind.Constructor]=8,Le[a.SymbolKind.Enum]=9,Le[a.SymbolKind.Interface]=10,Le[a.SymbolKind.Function]=11,Le[a.SymbolKind.Variable]=12,Le[a.SymbolKind.Constant]=13,Le[a.SymbolKind.String]=14,Le[a.SymbolKind.Number]=15,Le[a.SymbolKind.Boolean]=16,Le[a.SymbolKind.Array]=17,Le[a.SymbolKind.Object]=18,Le[a.SymbolKind.Key]=19,Le[a.SymbolKind.Null]=20,Le[a.SymbolKind.EnumMember]=21,Le[a.SymbolKind.Struct]=22,Le[a.SymbolKind.Event]=23,Le[a.SymbolKind.Operator]=24,Le[a.SymbolKind.TypeParameter]=25;function Ae(Me){return typeof Le[Me]=="number"?Le[Me]:6}Te.from=Ae;function ae(Me){for(const We in Le)if(Le[We]===Me)return Number(We);return a.SymbolKind.Property}Te.to=ae})(q||(e.SymbolKind=q={}));var V;(function(Te){function Le(ae){switch(ae){case a.SymbolTag.Deprecated:return 1}}Te.from=Le;function Ae(ae){switch(ae){case 1:return a.SymbolTag.Deprecated}}Te.to=Ae})(V||(e.SymbolTag=V={}));var ce;(function(Te){function Le(ae){return{name:ae.name,kind:q.from(ae.kind),tags:ae.tags&&ae.tags.map(V.from),containerName:ae.containerName,location:_.from(ae.location)}}Te.from=Le;function Ae(ae){const Me=new a.$QJ(ae.name,q.to(ae.kind),ae.containerName,_.to(ae.location));return Me.tags=ae.tags&&ae.tags.map(V.to),Me}Te.to=Ae})(ce||(e.WorkspaceSymbol=ce={}));var re;(function(Te){function Le(ae){const Me={name:ae.name||"!!MISSING: name!!",detail:ae.detail,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),kind:q.from(ae.kind),tags:ae.tags?.map(V.from)??[]};return ae.children&&(Me.children=ae.children.map(Le)),Me}Te.from=Le;function Ae(ae){const Me=new a.$RJ(ae.name,ae.detail,q.to(ae.kind),t.to(ae.range),t.to(ae.selectionRange));return(0,k.$pf)(ae.tags)&&(Me.tags=ae.tags.map(V.to)),ae.children&&(Me.children=ae.children.map(Ae)),Me}Te.to=Ae})(re||(e.DocumentSymbol=re={}));var fe;(function(Te){function Le(ae){const Me=new a.$WJ(q.to(ae.kind),ae.name,ae.detail||"",S.URI.revive(ae.uri),t.to(ae.range),t.to(ae.selectionRange));return Me._sessionId=ae._sessionId,Me._itemId=ae._itemId,Me}Te.to=Le;function Ae(ae,Me,We){if(Me=Me??ae._sessionId,We=We??ae._itemId,Me===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:We,name:ae.name,detail:ae.detail,kind:q.from(ae.kind),uri:ae.uri,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),tags:ae.tags?.map(V.from)}}Te.from=Ae})(fe||(e.CallHierarchyItem=fe={}));var de;(function(Te){function Le(Ae){return new a.$XJ(fe.to(Ae.from),Ae.fromRanges.map(ae=>t.to(ae)))}Te.to=Le})(de||(e.CallHierarchyIncomingCall=de={}));var B;(function(Te){function Le(Ae){return new a.$YJ(fe.to(Ae.to),Ae.fromRanges.map(ae=>t.to(ae)))}Te.to=Le})(B||(e.CallHierarchyOutgoingCall=B={}));var _;(function(Te){function Le(ae){return{range:ae.range&&t.from(ae.range),uri:ae.uri}}Te.from=Le;function Ae(ae){return new a.$LJ(S.URI.revive(ae.uri),t.to(ae.range))}Te.to=Ae})(_||(e.location=_={}));var Ee;(function(Te){function Le(ae){const Me=ae,We=ae;return{originSelectionRange:Me.originSelectionRange?t.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:We.uri,range:t.from(Me.targetRange?Me.targetRange:We.range),targetSelectionRange:Me.targetSelectionRange?t.from(Me.targetSelectionRange):void 0}}Te.from=Le;function Ae(ae){return{targetUri:S.URI.revive(ae.uri),targetRange:t.to(ae.range),targetSelectionRange:ae.targetSelectionRange?t.to(ae.targetSelectionRange):void 0,originSelectionRange:ae.originSelectionRange?t.to(ae.originSelectionRange):void 0}}Te.to=Ae})(Ee||(e.DefinitionLink=Ee={}));var Re;(function(Te){function Le(ae){return{range:t.from(ae.range),contents:T.fromMany(ae.contents)}}Te.from=Le;function Ae(ae){return new a.$OJ(ae.contents.map(T.to),t.to(ae.range))}Te.to=Ae})(Re||(e.Hover=Re={}));var ne;(function(Te){function Le(ae){return{range:t.from(ae.range),expression:ae.expression}}Te.from=Le;function Ae(ae){return new a.$IK(t.to(ae.range),ae.expression)}Te.to=Ae})(ne||(e.EvaluatableExpression=ne={}));var ee;(function(Te){function Le(ae){if(ae instanceof a.$JK)return{type:"text",range:t.from(ae.range),text:ae.text};if(ae instanceof a.$KK)return{type:"variable",range:t.from(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};if(ae instanceof a.$LK)return{type:"expression",range:t.from(ae.range),expression:ae.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Le;function Ae(ae){switch(ae.type){case"text":return{range:t.to(ae.range),text:ae.text};case"variable":return{range:t.to(ae.range),variableName:ae.variableName,caseSensitiveLookup:ae.caseSensitiveLookup};case"expression":return{range:t.to(ae.range),expression:ae.expression}}}Te.to=Ae})(ee||(e.InlineValue=ee={}));var he;(function(Te){function Le(ae){return{frameId:ae.frameId,stoppedLocation:t.from(ae.stoppedLocation)}}Te.from=Le;function Ae(ae){return new a.$MK(ae.frameId,t.to(ae.stoppedLocation))}Te.to=Ae})(he||(e.InlineValueContext=he={}));var X;(function(Te){function Le(ae){return{range:t.from(ae.range),kind:ae.kind}}Te.from=Le;function Ae(ae){return new a.$PJ(t.to(ae.range),ae.kind)}Te.to=Ae})(X||(e.DocumentHighlight=X={}));var ue;(function(Te){function Le(Ae){switch(Ae){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Te.to=Le})(ue||(e.CompletionTriggerKind=ue={}));var oe;(function(Te){function Le(Ae){return{triggerKind:ue.to(Ae.triggerKind),triggerCharacter:Ae.triggerCharacter}}Te.to=Le})(oe||(e.CompletionContext=oe={}));var le;(function(Te){function Le(ae){switch(ae){case a.CompletionItemTag.Deprecated:return 1}}Te.from=Le;function Ae(ae){switch(ae){case 1:return a.CompletionItemTag.Deprecated}}Te.to=Ae})(le||(e.CompletionItemTag=le={}));var we;(function(Te){const Le=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function Ae(We){return Le.get(We)??9}Te.from=Ae;const ae=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Me(We){return ae.get(We)??a.CompletionItemKind.Property}Te.to=Me})(we||(e.CompletionItemKind=we={}));var O;(function(Te){function Le(Ae,ae){const Me=new a.$7J(Ae.label);return Me.insertText=Ae.insertText,Me.kind=we.to(Ae.kind),Me.tags=Ae.tags?.map(le.to),Me.detail=Ae.detail,Me.documentation=A.$Kj(Ae.documentation)?T.to(Ae.documentation):Ae.documentation,Me.sortText=Ae.sortText,Me.filterText=Ae.filterText,Me.preselect=Ae.preselect,Me.commitCharacters=Ae.commitCharacters,D.$Mr.isIRange(Ae.range)?Me.range=t.to(Ae.range):typeof Ae.range=="object"&&(Me.range={inserting:t.to(Ae.range.insert),replacing:t.to(Ae.range.replace)}),Me.keepWhitespace=typeof Ae.insertTextRules>"u"?!1:!!(Ae.insertTextRules&1),typeof Ae.insertTextRules<"u"&&Ae.insertTextRules&4?Me.insertText=new a.$KJ(Ae.insertText):(Me.insertText=Ae.insertText,Me.textEdit=Me.range instanceof a.$BJ?new a.$GJ(Me.range,Me.insertText):void 0),Ae.additionalTextEdits&&Ae.additionalTextEdits.length>0&&(Me.additionalTextEdits=Ae.additionalTextEdits.map(We=>ie.to(We))),Me.command=ae&&Ae.command?ae.fromInternal(Ae.command):void 0,Me}Te.to=Le})(O||(e.CompletionItem=O={}));var K;(function(Te){function Le(ae){if(typeof ae.label!="string"&&!Array.isArray(ae.label))throw new TypeError("Invalid label");return{label:ae.label,documentation:T.fromStrict(ae.documentation)}}Te.from=Le;function Ae(ae){return{label:ae.label,documentation:A.$Kj(ae.documentation)?T.to(ae.documentation):ae.documentation}}Te.to=Ae})(K||(e.ParameterInformation=K={}));var G;(function(Te){function Le(ae){return{label:ae.label,documentation:T.fromStrict(ae.documentation),parameters:Array.isArray(ae.parameters)?ae.parameters.map(K.from):[],activeParameter:ae.activeParameter}}Te.from=Le;function Ae(ae){return{label:ae.label,documentation:A.$Kj(ae.documentation)?T.to(ae.documentation):ae.documentation,parameters:Array.isArray(ae.parameters)?ae.parameters.map(K.to):[],activeParameter:ae.activeParameter}}Te.to=Ae})(G||(e.SignatureInformation=G={}));var x;(function(Te){function Le(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(G.from):[]}}Te.from=Le;function Ae(ae){return{activeSignature:ae.activeSignature,activeParameter:ae.activeParameter,signatures:Array.isArray(ae.signatures)?ae.signatures.map(G.to):[]}}Te.to=Ae})(x||(e.SignatureHelp=x={}));var pe;(function(Te){function Le(Ae,ae){const Me=new a.$6J(g.to(ae.position),typeof ae.label=="string"?ae.label:ae.label.map(se.to.bind(void 0,Ae)),ae.kind&&ve.to(ae.kind));return Me.textEdits=ae.textEdits&&ae.textEdits.map(ie.to),Me.tooltip=A.$Kj(ae.tooltip)?T.to(ae.tooltip):ae.tooltip,Me.paddingLeft=ae.paddingLeft,Me.paddingRight=ae.paddingRight,Me}Te.to=Le})(pe||(e.InlayHint=pe={}));var se;(function(Te){function Le(Ae,ae){const Me=new a.$5J(ae.label);return Me.tooltip=A.$Kj(ae.tooltip)?T.to(ae.tooltip):ae.tooltip,p.Command.is(ae.command)&&(Me.command=Ae.fromInternal(ae.command)),ae.location&&(Me.location=_.to(ae.location)),Me}Te.to=Le})(se||(e.InlayHintLabelPart=se={}));var ve;(function(Te){function Le(ae){return ae}Te.from=Le;function Ae(ae){return ae}Te.to=Ae})(ve||(e.InlayHintKind=ve={}));var Ie;(function(Te){function Le(ae){return{range:t.from(ae.range),url:ae.target,tooltip:ae.tooltip}}Te.from=Le;function Ae(ae){let Me;if(ae.url)try{Me=typeof ae.url=="string"?S.URI.parse(ae.url,!0):S.URI.revive(ae.url)}catch{}return new a.$_J(t.to(ae.range),Me)}Te.to=Ae})(Ie||(e.DocumentLink=Ie={}));var Ue;(function(Te){function Le(ae){const Me=new a.$cK(ae.label);return ae.textEdit&&(Me.textEdit=ie.to(ae.textEdit)),ae.additionalTextEdits&&(Me.additionalTextEdits=ae.additionalTextEdits.map(We=>ie.to(We))),Me}Te.to=Le;function Ae(ae){return{label:ae.label,textEdit:ae.textEdit?ie.from(ae.textEdit):void 0,additionalTextEdits:ae.additionalTextEdits?ae.additionalTextEdits.map(Me=>ie.from(Me)):void 0}}Te.from=Ae})(Ue||(e.ColorPresentation=Ue={}));var Ve;(function(Te){function Le(ae){return new a.$aK(ae[0],ae[1],ae[2],ae[3])}Te.to=Le;function Ae(ae){return[ae.red,ae.green,ae.blue,ae.alpha]}Te.from=Ae})(Ve||(e.Color=Ve={}));var xe;(function(Te){function Le(ae){return{range:t.from(ae.range)}}Te.from=Le;function Ae(ae){return new a.$VJ(t.to(ae.range))}Te.to=Ae})(xe||(e.SelectionRange=xe={}));var Ge;(function(Te){function Le(Ae){switch(Ae){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Te.to=Le})(Ge||(e.TextDocumentSaveReason=Ge={}));var et;(function(Te){function Le(ae){switch(ae){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=Le;function Ae(ae){switch(ae){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Te.to=Ae})(et||(e.TextEditorLineNumbersStyle=et={}));var Ze;(function(Te){function Le(ae){if(ae===a.EndOfLine.CRLF)return 1;if(ae===a.EndOfLine.LF)return 0}Te.from=Le;function Ae(ae){if(ae===1)return a.EndOfLine.CRLF;if(ae===0)return a.EndOfLine.LF}Te.to=Ae})(Ze||(e.EndOfLine=Ze={}));var st;(function(Te){function Le(Ae){if(typeof Ae=="object")return Ae.viewId;switch(Ae){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=Le})(st||(e.ProgressLocation=st={}));var tt;(function(Te){function Le(ae){const Me={start:ae.start+1,end:ae.end+1};return ae.kind&&(Me.kind=Pe.from(ae.kind)),Me}Te.from=Le;function Ae(ae){const Me={start:ae.start-1,end:ae.end-1};return ae.kind&&(Me.kind=Pe.to(ae.kind)),Me}Te.to=Ae})(tt||(e.FoldingRange=tt={}));var Pe;(function(Te){function Le(ae){if(ae)switch(ae){case a.FoldingRangeKind.Comment:return p.$ss.Comment;case a.FoldingRangeKind.Imports:return p.$ss.Imports;case a.FoldingRangeKind.Region:return p.$ss.Region}}Te.from=Le;function Ae(ae){if(ae)switch(ae.value){case p.$ss.Comment.value:return a.FoldingRangeKind.Comment;case p.$ss.Imports.value:return a.FoldingRangeKind.Imports;case p.$ss.Region.value:return a.FoldingRangeKind.Region}}Te.to=Ae})(Pe||(e.FoldingRangeKind=Pe={}));var ke;(function(Te){function Le(Ae){if(Ae)return{pinned:typeof Ae.preview=="boolean"?!Ae.preview:void 0,inactive:Ae.background,preserveFocus:Ae.preserveFocus,selection:typeof Ae.selection=="object"?t.from(Ae.selection):void 0,override:typeof Ae.override=="boolean"?c.$pE.id:void 0}}Te.from=Le})(ke||(e.TextEditorOpenOptions=ke={}));var Be;(function(Te){function Le(We){return We instanceof a.$wK?We.toJSON():typeof We=="string"?We:Ae(We)||ae(We)?new a.$wK(We.baseUri??We.base,We.pattern).toJSON():We}Te.from=Le;function Ae(We){const Xe=We;return Xe?S.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function ae(We){const Xe=We;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Me(We){return typeof We=="string"?We:new a.$wK(S.URI.revive(We.baseUri),We.pattern)}Te.to=Me})(Be||(e.GlobPattern=Be={}));var Q;(function(Te){function Le(Ae){if(Ae){if(Array.isArray(Ae))return Ae.map(Le);if(typeof Ae=="string")return Ae;{const ae=Ae;return{language:ae.language,scheme:ae.scheme,pattern:Be.from(ae.pattern),exclusive:ae.exclusive,notebookType:ae.notebookType}}}else return}Te.from=Le})(Q||(e.LanguageSelector=Q={}));var Z;(function(Te){function Le(ae){return{start:ae.start,end:ae.end}}Te.from=Le;function Ae(ae){return new a.$XK(ae.start,ae.end)}Te.to=Ae})(Z||(e.NotebookRange=Z={}));var ye;(function(Te){function Le(ae){return{timing:typeof ae.runStartTime=="number"&&typeof ae.runEndTime=="number"?{startTime:ae.runStartTime,endTime:ae.runEndTime}:void 0,executionOrder:ae.executionOrder,success:ae.lastRunSuccess}}Te.to=Le;function Ae(ae){return{lastRunSuccess:ae.success,runStartTime:ae.timing?.startTime,runEndTime:ae.timing?.endTime,executionOrder:ae.executionOrder}}Te.from=Ae})(ye||(e.NotebookCellExecutionSummary=ye={}));var je;(function(Te){function Le(Ae){if(Ae===f.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(Ae===f.NotebookCellExecutionState.Pending)return;if(Ae===f.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ae}`)}Te.to=Le})(je||(e.NotebookCellExecutionState=je={}));var Oe;(function(Te){function Le(ae){switch(ae){case a.NotebookCellKind.Markup:return f.CellKind.Markup;case a.NotebookCellKind.Code:default:return f.CellKind.Code}}Te.from=Le;function Ae(ae){switch(ae){case f.CellKind.Markup:return a.NotebookCellKind.Markup;case f.CellKind.Code:default:return a.NotebookCellKind.Code}}Te.to=Ae})(Oe||(e.NotebookCellKind=Oe={}));var Ye;(function(Te){function Le(ae){const Me={metadata:ae.metadata??Object.create(null),cells:[]};for(const We of ae.cells)a.$YK.validate(We),Me.cells.push(_e.from(We));return Me}Te.from=Le;function Ae(ae){const Me=new a.$ZK(ae.cells.map(_e.to));return(0,$.$ve)(ae.metadata)||(Me.metadata=ae.metadata),Me}Te.to=Ae})(Ye||(e.NotebookData=Ye={}));var _e;(function(Te){function Le(ae){return{cellKind:Oe.from(ae.kind),language:ae.languageId,mime:ae.mime,source:ae.value,metadata:ae.metadata,internalMetadata:ye.from(ae.executionSummary??{}),outputs:ae.outputs?ae.outputs.map(ft.from):[]}}Te.from=Le;function Ae(ae){return new a.$YK(Oe.to(ae.cellKind),ae.source,ae.language,ae.mime,ae.outputs?ae.outputs.map(ft.to):void 0,ae.metadata,ae.internalMetadata?ye.to(ae.internalMetadata):void 0)}Te.to=Ae})(_e||(e.NotebookCellData=_e={}));var rt;(function(Te){function Le(ae){return{mime:ae.mime,valueBytes:F.$Jb.wrap(ae.data)}}Te.from=Le;function Ae(ae){return new a.$1K(ae.valueBytes.buffer,ae.mime)}Te.to=Ae})(rt||(e.NotebookCellOutputItem=rt={}));var ft;(function(Te){function Le(ae){return{outputId:ae.id,items:ae.items.map(rt.from),metadata:ae.metadata}}Te.from=Le;function Ae(ae){const Me=ae.items.map(rt.to);return new a.$2K(Me,ae.outputId,ae.metadata)}Te.to=Ae})(ft||(e.NotebookCellOutput=ft={}));var vt;(function(Te){function Le(Me){return ae(Me)?{include:(0,$.$Ae)(Be.from(Me.include)),exclude:(0,$.$Ae)(Be.from(Me.exclude))}:(0,$.$Ae)(Be.from(Me))}Te.from=Le;function Ae(Me){return ae(Me)?{include:Be.to(Me.include),exclude:Be.to(Me.exclude)}:Be.to(Me)}Te.to=Ae;function ae(Me){const We=Me;return We?!(0,$.$re)(We.include)&&!(0,$.$re)(We.exclude):!1}})(vt||(e.NotebookExclusiveDocumentPattern=vt={}));var Ft;(function(Te){function Le(Ae,ae,Me){const We=typeof Ae.command=="string"?{title:"",command:Ae.command}:Ae.command;return{alignment:Ae.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:ae.toInternal(We,Me),text:Ae.text,tooltip:Ae.tooltip,accessibilityInformation:Ae.accessibilityInformation,priority:Ae.priority}}Te.from=Le})(Ft||(e.NotebookStatusBarItem=Ft={}));var Lt;(function(Te){function Le(Ae,ae,Me){const We=typeof Ae.command=="string"?{title:"",command:Ae.command}:Ae.command;return{command:ae.toInternal(We,Me),label:Ae.label,description:Ae.description,detail:Ae.detail,documentation:Ae.documentation}}Te.from=Le})(Lt||(e.NotebookKernelSourceAction=Lt={}));var Et;(function(Te){function Le(Ae){return{transientOutputs:Ae?.transientOutputs??!1,transientCellMetadata:Ae?.transientCellMetadata??{},transientDocumentMetadata:Ae?.transientDocumentMetadata??{},cellContentMetadata:Ae?.cellContentMetadata??{}}}Te.from=Le})(Et||(e.NotebookDocumentContentOptions=Et={}));var Tt;(function(Te){function Le(ae){return{uri:ae.uri,provides:ae.provides}}Te.from=Le;function Ae(ae){return new a.$4K(S.URI.revive(ae.uri),ae.provides)}Te.to=Ae})(Tt||(e.NotebookRendererScript=Tt={}));var Mt;(function(Te){function Le(ae){return{message:T.fromStrict(ae.message)||"",type:0,expected:ae.expectedOutput,actual:ae.actualOutput,location:ae.location&&{range:t.from(ae.location.range),uri:ae.location.uri}}}Te.from=Le;function Ae(ae){const Me=new a.$$K(typeof ae.message=="string"?ae.message:T.to(ae.message));return Me.actualOutput=ae.actual,Me.expectedOutput=ae.expected,Me.location=ae.location?_.to(ae.location):void 0,Me}Te.to=Ae})(Mt||(e.TestMessage=Mt={}));var zt;(function(Te){Te.namespace=C.$nI,Te.denamespace=C.$oI})(zt||(e.TestTag=zt={}));var Bt;(function(Te){function Le(ae){const Me=(0,s.$vL)(ae).controllerId;return{extId:y.$jI.fromExtHostTestItem(ae,Me).toString(),label:ae.label,uri:S.URI.revive(ae.uri),busy:ae.busy,tags:ae.tags.map(We=>zt.namespace(Me,We.id)),range:D.$Mr.lift(t.from(ae.range)),description:ae.description||null,sortText:ae.sortText||null,error:ae.error&&T.fromStrict(ae.error)||null}}Te.from=Le;function Ae(ae){return{parent:void 0,error:void 0,id:y.$jI.fromString(ae.extId).localId,label:ae.label,uri:S.URI.revive(ae.uri),tags:(ae.tags||[]).map(Me=>{const{tagId:We}=zt.denamespace(Me);return new a.$_K(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:t.to(ae.range||void 0),canResolveChildren:!1,busy:ae.busy,description:ae.description||void 0,sortText:ae.sortText||void 0}}Te.toPlain=Ae})(Bt||(e.TestItem=Bt={})),function(Te){function Le(ae){return{id:ae.id}}Te.from=Le;function Ae(ae){return new a.$_K(ae.id)}Te.to=Ae}(zt||(e.TestTag=zt={}));var Nt;(function(Te){const Le=(ae,Me)=>{const We=[];for(const[He,it]of Me)y.$jI.compare(it.item.extId,He)===2&&(Me.delete(He),We.push(it));const Xe={...Bt.toPlain(ae.item),parent:void 0,taskStates:ae.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(it=>it.type===0).map(Mt.to)})),children:We.map(He=>Le(He,Me))};for(const He of Xe.children)He.parent=Xe;return Xe};function Ae(ae){const Me=[],We=new Map;for(const Xe of ae.items){We.set(Xe.item.extId,Xe);const He=y.$jI.root(Xe.item.extId);ae.request.targets.some(it=>it.controllerId===He&&it.testIds.includes(Xe.item.extId))&&Me.push(Xe)}return{completedAt:ae.completedAt,results:Me.map(Xe=>Le(Xe,We))}}Te.to=Ae})(Nt||(e.TestResults=Nt={}));var at;(function(Te){function Le(We){return{covered:We.covered,total:We.covered}}function Ae(We){return"line"in We?g.from(We):t.from(We)}function ae(We){return"branches"in We?{count:We.executionCount,location:Ae(We.location),type:1,branches:We.branches.length?We.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&Ae(Xe.location)})):void 0}:{type:0,count:We.executionCount,location:Ae(We.location)}}Te.fromDetailed=ae;function Me(We){return{uri:We.uri,statement:Le(We.statementCoverage),branch:We.branchCoverage&&Le(We.branchCoverage),function:We.functionCoverage&&Le(We.functionCoverage),details:We.detailedCoverage?.map(ae)}}Te.fromFile=Me})(at||(e.TestCoverage=at={}));var dt;(function(Te){function Le(Ae){switch(Ae){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Te.to=Le})(dt||(e.CodeActionTriggerKind=dt={}));var Wt;(function(Te){function Le(ae){const Me=new a.$fL(q.to(ae.kind),ae.name,ae.detail||"",S.URI.revive(ae.uri),t.to(ae.range),t.to(ae.selectionRange));return Me._sessionId=ae._sessionId,Me._itemId=ae._itemId,Me}Te.to=Le;function Ae(ae,Me,We){if(Me=Me??ae._sessionId,We=We??ae._itemId,Me===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:We,kind:q.from(ae.kind),name:ae.name,detail:ae.detail??"",uri:ae.uri,range:t.from(ae.range),selectionRange:t.from(ae.selectionRange),tags:ae.tags?.map(V.from)}}Te.from=Ae})(Wt||(e.TypeHierarchyItem=Wt={}));var Ot;(function(Te){function Le(Ae){if(Ae)return{value:Ae.value,tooltip:Ae.tooltip}}Te.from=Le})(Ot||(e.ViewBadge=Ot={}));var St;(function(Te){function Le(We,Xe,He){const it=Xe.fileData;return it?new a.$pK(new a.$qK(it.name,S.URI.revive(it.uri),it.id,(0,L.$cb)(()=>He(it.id)))):We===R.$sr.uriList&&Xe.uriListData?new a.$oK(Me(Xe.uriListData)):new a.$oK(Xe.asString)}Te.to=Le;async function Ae(We,Xe){const He=await Xe.asString();if(We===R.$sr.uriList)return{asString:He,fileData:void 0,uriListData:ae(He)};const it=Xe.asFile();return{asString:He,fileData:it?{name:it.name,uri:it.uri,id:it._itemId??it.id}:void 0}}Te.from=Ae;function ae(We){return h.$as.split(We).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return S.URI.parse(Xe)}catch{}return Xe})}function Me(We){return h.$as.create(We.map(Xe=>typeof Xe=="string"?Xe:S.URI.revive(Xe)))}})(St||(e.DataTransferItem=St={}));var ct;(function(Te){function Le(ae,Me){const We=ae.items.map(([Xe,He])=>[Xe,St.to(Xe,He,Me)]);return new a.$rK(We)}Te.toDataTransfer=Le;async function Ae(ae){const Me={items:[]},We=[];for(const[Xe,He]of ae)We.push((async()=>{Me.items.push([Xe,await St.from(Xe,He)])})());return await Promise.all(We),Me}Te.from=Ae})(ct||(e.DataTransfer=ct={}));var At;(function(Te){function Le(ae){return{message:ae.message,metadata:ae.metadata,title:ae.title,tooltip:ae.tooltip}}Te.to=Le;function Ae(ae){return{kind:"reply",message:ae.message,metadata:ae.metadata,title:ae.title,tooltip:ae.tooltip}}Te.from=Ae})(At||(e.ChatReplyFollowup=At={}));var Ut;(function(Te){function Le(Ae){return typeof Ae=="string"?{title:Ae,message:Ae,kind:"reply"}:"commandId"in Ae?{kind:"command",title:Ae.title??"",commandId:Ae.commandId??"",args:Ae.args}:At.from(Ae)}Te.from=Le})(Ut||(e.ChatFollowup=Ut={}))}),define(De[265],Ce([1,0,2,8,7,16,68]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=void 0;class m{constructor(b,R,I,$={timeout:1500,errors:3}){this.c=b,this.d=R,this.f=I,this.g=$,this.a=new A.$lc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(b){return(R,I,$)=>{const D={dispose:this.a.push([R,I,b])};return Array.isArray($)&&$.push(D),D}}async $participateInSave(b,R){const I=k.URI.revive(b);let $=!1;const S=setTimeout(()=>$=!0,this.g.timeout),D=[];try{for(const p of[...this.a]){if($)break;const r=this.d.getDocument(I),s=await this.h(p,{document:r,reason:L.TextDocumentSaveReason.to(R)});D.push(s)}}finally{clearTimeout(S)}return D}h([b,R,I],$){const S=this.b.get(b);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(I,b,R,$).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const p=this.b.get(b);this.b.set(b,p?p+1:1),typeof p=="number"&&p>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(b,R,I,$){const S=[],D=Date.now(),{document:p,reason:r}=$,{version:s}=p,c=Object.freeze({document:p,reason:r,waitUntil(f){if(Object.isFrozen(S))throw(0,F.$6)("waitUntil can not be called async");S.push(Promise.resolve(f))}});try{R.apply(I,[c])}catch(f){return Promise.reject(f)}return Object.freeze(S),new Promise((f,y)=>{const C=setTimeout(()=>y(new Error("timeout")),this.g.timeout);return Promise.all(S).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(C),f(i)}).catch(i=>{clearTimeout(C),y(i)})}).then(f=>{const y={edits:[]};for(const C of f)if(Array.isArray(C)&&C.every(i=>i instanceof h.$GJ))for(const{newText:i,newEol:a,range:n}of C)y.edits.push({resource:p.uri,versionId:void 0,textEdit:{range:n&&L.Range.from(n),text:i,eol:a&&L.EndOfLine.from(a)}});if(y.edits.length!==0)return s===p.version?this.f.$tryApplyWorkspaceEdit(y):Promise.reject(new Error("concurrent_edits"))})}}e.$4$b=m}),define(De[266],Ce([1,0,15,2,16,7,102]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fac=e.$eac=void 0;class m{constructor(I,$,S,D){this.start=I,this.deletedCount=$,this.deletedItems=S,this.items=D}asApiEvent(){return{range:new L.$XK(this.start,this.start+this.deletedCount),addedCells:this.items.map(I=>I.apiCell),removedCells:this.deletedItems}}}class E{static asModelAddData(I,$){return{EOL:$.eol,lines:$.source,languageId:$.language,uri:$.uri,isDirty:!1,versionId:1,notebook:I}}constructor(I,$,S){this.notebook=I,this.h=$,this.j=S,this.handle=S.handle,this.uri=F.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(h.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(h.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const I=this,$=this.h.getDocument(this.uri);if(!$)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return I.notebook.getCellIndex(I)},notebook:I.notebook.apiNotebook,kind:h.NotebookCellKind.to(this.j.cellKind),document:$.document,get mime(){return I.g},set mime(D){I.g=D},get outputs(){return I.a.slice(0)},get metadata(){return I.b},get executionSummary(){return I.d}};this.f=Object.freeze(S)}return this.f}setOutputs(I){this.a=I.map(h.NotebookCellOutput.to)}setOutputItems(I,$,S){const D=S.map(h.NotebookCellOutputItem.to),p=this.a.find(r=>r.id===I);if(p&&($||(p.items.length=0),p.items.push(...D),p.items.length>1&&p.items.every(r=>A.$EH(r.mime)))){const r=new Map,s=[];p.items.forEach(c=>{let f;r.has(c.mime)?f=r.get(c.mime):(f=[],r.set(c.mime,f),s.push(c.mime)),f.push(c.data)}),p.items.length=0,s.forEach(c=>{const f=A.$FH(r.get(c));p.items.push({mime:c,data:f.data.buffer})})}}setMetadata(I){this.b=Object.freeze(I)}setInternalMetadata(I){this.e=I,this.d=Object.freeze(h.NotebookCellExecutionSummary.to(I))}setMime(I){}}e.$eac=E;class b{static{this.a=0}constructor(I,$,S,D,p){this.k=I,this.l=$,this.m=S,this.uri=D,this.handle=b.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=p.viewType,this.f=Object.freeze(p.metadata??Object.create(null)),this.r([[0,0,p.cells]],!0,void 0),this.g=p.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const I=this,$={get uri(){return I.uri},get version(){return I.g},get notebookType(){return I.d},get isDirty(){return I.h},get isUntitled(){return I.uri.scheme===k.Schemas.untitled},get isClosed(){return I.j},get metadata(){return I.f},get cellCount(){return I.b.length},cellAt(S){return S=I.n(S),I.b[S].apiCell},getCells(S){return(S?I.p(S):I.b).map(p=>p.apiCell)},save(){return I.q()}};this.e=Object.freeze($)}return this.e}acceptDocumentPropertiesChanged(I){I.metadata&&(this.f=Object.freeze({...this.f,...I.metadata}))}acceptDirty(I){this.h=I}acceptModelChanged(I,$,S){this.g=I.versionId,this.h=$,this.acceptDocumentPropertiesChanged({metadata:S});const D={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},p=[];for(const s of I.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,D.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,D.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),p.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),p.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),p.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?p.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),p.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),p.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const r=new Map;for(let s=0;s<p.length;s++){const c=p[s],f=r.get(c.cell);if(f===void 0){const y=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...c});r.set(c.cell,y-1)}else D.cellChanges[f]={...D.cellChanges[f],...c}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(I){return I=I|0,I<0?0:I>=this.b.length?this.b.length-1:I}o(I){let $=I.start|0,S=I.end|0;return $<0&&($=0),S>this.b.length&&(S=this.b.length),I.with({start:$,end:S})}p(I){I=this.o(I);const $=[];for(let S=I.start;S<I.end;S++)$.push(this.b[S]);return $}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(I,$,S){if(this.j)return;const D=[],p=[],r=[];if(I.reverse().forEach(s=>{const f=s[2].map(i=>{const a=new E(this,this.l,i);return $||p.push(E.asModelAddData(this.apiNotebook,i)),a}),y=new m(s[0],s[1],[],f),C=this.b.splice(s[0],s[1],...f);for(const i of C)r.push(i.uri),y.deletedItems.push(i.apiCell);D.push(y)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:p,removedDocuments:r}),S)for(const s of D)S.push(s.asApiEvent())}s(I,$,S,D){const p=this.b.splice(I,$);this.b.splice(S,0,...p);const r=[new m(I,$,p.map(s=>s.apiCell),[]),new m(S,0,[],p)];for(const s of r)D.push(s.asApiEvent())}t(I,$){this.b[I].setOutputs($)}u(I,$,S,D){this.b[I].setOutputItems($,S,D)}v(I,$){const S=this.b[I];S.apiCell.document.languageId!==$&&this.m.$acceptModelLanguageChanged(S.uri,$)}w(I,$){const S=this.b[I];S.apiCell.mime=$}x(I,$){this.b[I].setMetadata($)}y(I,$){this.b[I].setInternalMetadata($)}getCellFromApiCell(I){return this.b.find($=>$.apiCell===I)}getCellFromIndex(I){return this.b[I]}getCell(I){return this.b.find($=>$.handle===I)}getCellIndex(I){return this.b.indexOf(I)}}e.$fac=b}),define(De[267],Ce([1,0,3,2,16,7]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=void 0;class A{constructor(E,b,R,I={timeout:1500,errors:3}){this.b=E,this.c=b,this.d=R,this.f=I,this.a=new k.$9c}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(b,R,I)=>{const $=function(D){b.call(R,D)};return $.extension=E,this.a.event($,void 0,I)}}async $participateInSave(E,b,R){const I=F.URI.revive(E),$=this.c.getNotebookDocument(I);if(!$)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:$.apiNotebook,reason:h.TextDocumentSaveReason.to(b)},R,async(p,r)=>{const s=Date.now(),c=await await Promise.resolve(p);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!R.isCancellationRequested&&c&&(c instanceof L.$JJ?S.push(c):this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(S.length===0)return!0;const D={edits:[]};for(const p of S){const{edits:r}=h.WorkspaceEdit.from(p);D.edits=D.edits.concat(r)}return this.d.$tryApplyWorkspaceEdit(D)}}e.$Fac=A}),define(De[138],Ce([1,0,8,16,7]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=void 0;class L{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,E,b,R,I,$){this.id=m,this.f=E,this.notebookData=b,this.a=[],this.b=[],this.d=!1,this.a=I,this.b=R,this.c=$}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(E){this.selections=[E]},get selections(){return m.a},set selections(E){if(!Array.isArray(E)||!E.every(h.$XK.isNotebookRange))throw(0,k.$5)("selections");m.a=E,m.g(E)},get visibleRanges(){return m.b},revealRange(E,b){m.f.$tryRevealRange(m.id,F.NotebookRange.from(E),b??h.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(F.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$gac=L}),define(De[268],Ce([1,0,8,3,18,16]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=void 0;let A=class{constructor(E,b){this.c=E,this.d=b,this.a=new F.$7c({onListenerError:k.$Z}),this.b=new F.$7c({onListenerError:k.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(E,b){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",E,b);const R=this.d.getEditorById(E);b.visibleRanges&&R._acceptVisibleRanges(b.visibleRanges.ranges.map(L.NotebookRange.to)),b.selections&&R._acceptSelections(b.selections.selections.map(L.NotebookRange.to)),b.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),b.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(E){for(const b in E)this.d.getEditorById(b)._acceptViewColumn(L.ViewColumn.to(E[b]))}};e.$yac=A,e.$yac=A=Je([qe(0,h.$Pi)],A)}),define(De[269],Ce([1,0,16,128,198,21,66,8]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C_b=void 0;class E{constructor($){this.b=0,this.c=new Map,this.a=$}async withProgress($,S,D){const p=this.b++,{title:r,location:s,cancellable:c}=S,f={label:(0,h.localize)(0,null,$.displayName||$.name),id:$.identifier.value};return this.a.$startProgress(p,{location:k.ProgressLocation.from(s),title:r,source:f,cancellable:c},$.isUnderDevelopment?void 0:$.identifier.value).catch(m.$Z),this.d(p,D,!!c)}d($,S,D){let p;D&&(p=new L.$dd,this.c.set($,p));const r=c=>{this.a.$progressEnd(c),this.c.delete(c),p?.dispose()};let s;try{s=S(new R(this.a,$),D&&p?p.token:L.CancellationToken.None)}catch(c){throw r($),c}return s.then(c=>r($),c=>r($)),s}$acceptProgressCanceled($){const S=this.c.get($);S&&(S.cancel(),this.c.delete($))}}e.$C_b=E;function b(I,$){return I.message=$.message,typeof $.increment=="number"&&(typeof I.increment=="number"?I.increment+=$.increment:I.increment=$.increment),I}class R extends F.$Lu{constructor($,S){super(D=>this.throttledReport(D)),this.f=$,this.g=S}throttledReport($){this.f.$progressReport(this.g,$)}}Je([(0,A.$Tg)(100,(I,$)=>b(I,$),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[139],Ce([1,0,33,136,59,103,82,16,2]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=e.$ML=e.$LL=void 0;const b=(f,y,C,i)=>{let a=y;return{enumerable:!0,configurable:!1,get(){return a},set(n){if(!C(a,n)){const t=a;a=n,f.listener?.(i(n,t))}}}},R=(f,y)=>f===y,I={range:(f,y)=>f===y?!0:!f||!y?!1:f.isEqual(y),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(f,y)=>!(f.length!==y.length||f.some(C=>!y.find(i=>C.id===i.id)))},$=f=>y=>({op:4,update:f(y)}),S=(f,y)=>({range:(()=>{let C;const i=$(a=>({range:k.$Mr.lift(m.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return C},set(a){f.listener?.({op:6}),I.range(C,a)||(C=a,f.listener?.(i(a)))}}})(),label:b(f,y,I.label,$(C=>({label:C}))),description:b(f,void 0,I.description,$(C=>({description:C}))),sortText:b(f,void 0,I.sortText,$(C=>({sortText:C}))),canResolveChildren:b(f,!1,I.canResolveChildren,C=>({op:2,state:C})),busy:b(f,!1,I.busy,$(C=>({busy:C}))),error:b(f,void 0,I.error,$(C=>({error:m.MarkdownString.fromStrict(C)||null}))),tags:b(f,[],I.tags,(C,i)=>({op:1,new:C.map(m.TestTag.from),old:i.map(m.TestTag.from)}))}),D=f=>{const y=h.$jI.fromString(f.extId),C=new r(y.controllerId,y.localId,f.label,E.URI.revive(f.uri)||void 0);return C.range=m.Range.to(f.range||void 0),C.description=f.description||void 0,C.sortText=f.sortText||void 0,C.tags=f.tags.map(i=>m.TestTag.to({id:(0,A.$oI)(i).tagId})),C},p=f=>{let y;for(const C of f.tests){const i=D(C.item);(0,F.$vL)(i).parent=y,y=i}return y};e.$LL=p;class r{constructor(y,C,i,a){if(C.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(C)} symbol`);const n=(0,F.$uL)(this,y);Object.defineProperties(this,{id:{value:C,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof s?void 0:n.parent}},children:{value:(0,L.$tL)(n,F.$vL,r),enumerable:!0,writable:!1},...S(n,i)})}}e.$ML=r;class s extends r{constructor(y,C){super(y,y,C,void 0),this._isRoot=!0}}e.$NL=s;class c extends L.$pL{constructor(y,C,i){super({controllerId:y,getDocumentVersion:a=>a&&i.getDocument(a)?.version,getApiFor:F.$vL,getChildren:a=>a.children,root:new s(y,C),toITestItem:m.TestItem.from})}}e.$OL=c}),define(De[140],Ce([1,0,53,8,111,16,7]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IL=e.$HL=e.$GL=void 0;class m{static{this.c=new h.$EL("TextEditorDecorationType")}constructor($,S,D){const p=m.c.nextId();$.$registerTextEditorDecorationType(S.identifier,p,L.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:p,dispose(){$.$removeTextEditorDecorationType(p)}})}}e.$GL=m;class E{constructor($,S){this.g=[],this.h=void 0,this.j=!1,this.c=$,this.d=$.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace($,S){this.k();let D=null;if($ instanceof A.$AJ)D=new A.$BJ($,$);else if($ instanceof A.$BJ)D=$;else throw new Error("Unrecognized location");this.l(D,S,!1)}insert($,S){this.k(),this.l(new A.$BJ($,$),S,!0)}delete($){this.k();let S=null;if($ instanceof A.$BJ)S=$;else throw new Error("Unrecognized location");this.l(S,null,!0)}l($,S,D){const p=this.c.validateRange($);this.g.push({range:p,text:S,forceMoveMarkers:D})}setEndOfLine($){if(this.k(),$!==A.EndOfLine.LF&&$!==A.EndOfLine.CRLF)throw(0,F.$5)("endOfLine");this.h=$}}class b{constructor($,S,D,p){this.c=$,this.d=S,this._accept(D),this.e=p;const r=this;this.value={get tabSize(){return r.f},set tabSize(s){r.m(s)},get indentSize(){return r.g},set indentSize(s){r.o(s)},get insertSpaces(){return r.h},set insertSpaces(s){r.q(s)},get cursorStyle(){return r.j},set cursorStyle(s){r.s(s)},get lineNumbers(){return r.k},set lineNumbers(s){r.t(s)}}}_accept($){this.f=$.tabSize,this.g=$.indentSize,this.h=$.insertSpaces,this.j=$.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to($.lineNumbers)}l($){if($==="auto")return"auto";if(typeof $=="number"){const S=Math.floor($);return S>0?S:null}if(typeof $=="string"){const S=parseInt($,10);return isNaN(S)?null:S>0?S:null}return null}m($){const S=this.l($);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}n($){if($==="tabSize")return"tabSize";if(typeof $=="number"){const S=Math.floor($);return S>0?S:null}if(typeof $=="string"){const S=parseInt($,10);return isNaN(S)?null:S>0?S:null}return null}o($){const S=this.n($);if(S!==null){if(typeof S=="number"){if(this.g===S)return;this.g=S}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}p($){return $==="auto"?"auto":$==="false"?!1:!!$}q($){const S=this.p($);if(typeof S=="boolean"){if(this.h===S)return;this.h=S}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}s($){this.j!==$&&(this.j=$,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:$})))}t($){this.k!==$&&(this.k=$,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from($)})))}assign($){const S={};let D=!1;if(typeof $.tabSize<"u"){const p=this.l($.tabSize);p==="auto"?(D=!0,S.tabSize=p):typeof p=="number"&&this.f!==p&&(this.f=p,D=!0,S.tabSize=p)}if(typeof $.indentSize<"u"){const p=this.n($.indentSize);p==="tabSize"?(D=!0,S.indentSize=p):typeof p=="number"&&this.g!==p&&(this.g=p,D=!0,S.indentSize=p)}if(typeof $.insertSpaces<"u"){const p=this.p($.insertSpaces);p==="auto"?(D=!0,S.insertSpaces=p):this.h!==p&&(this.h=p,D=!0,S.insertSpaces=p)}typeof $.cursorStyle<"u"&&this.j!==$.cursorStyle&&(this.j=$.cursorStyle,D=!0,S.cursorStyle=$.cursorStyle),typeof $.lineNumbers<"u"&&this.k!==$.lineNumbers&&(this.k=$.lineNumbers,D=!0,S.lineNumbers=L.TextEditorLineNumbersStyle.from($.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,S))}u($,S){S.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${$}' failed:'`),this.e.warn(D)})}}e.$HL=b;class R{constructor($,S,D,p,r,s,c,f){this.id=$,this.j=S,this.k=D,this.g=!1,this.h=new Set,this.c=r,this.d=new b(this.j,this.id,s,D),this.e=c,this.f=f;const y=this;this.value=Object.freeze({get document(){return p.value},set document(C){throw(0,F.$7)("document")},get selection(){return y.c&&y.c[0]},set selection(C){if(!(C instanceof A.$CJ))throw(0,F.$5)("selection");y.c=[C],y.l()},get selections(){return y.c},set selections(C){if(!Array.isArray(C)||C.some(i=>!(i instanceof A.$CJ)))throw(0,F.$5)("selections");y.c=C,y.l()},get visibleRanges(){return y.e},set visibleRanges(C){throw(0,F.$7)("visibleRanges")},get options(){return y.d.value},set options(C){y.g||y.d.assign(C)},get viewColumn(){return y.f},set viewColumn(C){throw(0,F.$7)("viewColumn")},edit(C,i={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new E(p.value,i);return C(a),y.m(a)},insertSnippet(C,i,a={undoStopBefore:!0,undoStopAfter:!0}){if(y.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!i||Array.isArray(i)&&i.length===0)n=y.c.map(t=>L.Range.from(t));else if(i instanceof A.$AJ){const{lineNumber:t,column:o}=L.Position.from(i);n=[{startLineNumber:t,startColumn:o,endLineNumber:t,endColumn:o}]}else if(i instanceof A.$BJ)n=[L.Range.from(i)];else{n=[];for(const t of i)if(t instanceof A.$BJ)n.push(L.Range.from(t));else{const{lineNumber:o,column:g}=L.Position.from(t);n.push({startLineNumber:o,startColumn:g,endLineNumber:o,endColumn:g})}}return S.$tryInsertSnippet($,p.value.version,C.value,n,a)},setDecorations(C,i){const a=i.length===0;a&&!y.h.has(C.key)||(a?y.h.delete(C.key):y.h.add(C.key),y.n(()=>{if(L.$wL(i))return S.$trySetDecorations($,C.key,L.$xL(i));{const n=new Array(4*i.length);for(let t=0,o=i.length;t<o;t++){const g=i[t];n[4*t]=g.start.line+1,n[4*t+1]=g.start.character+1,n[4*t+2]=g.end.line+1,n[4*t+3]=g.end.character+1}return S.$trySetDecorationsFast($,C.key,n)}}))},revealRange(C,i){y.n(()=>S.$tryRevealRange($,L.Range.from(C),i||A.TextEditorRevealType.Default))},show(C){S.$tryShowEditor($,L.ViewColumn.from(C))},hide(){S.$tryHideEditor($)}})}dispose(){(0,k.ok)(!this.g),this.g=!0}_acceptOptions($){(0,k.ok)(!this.g),this.d._accept($)}_acceptVisibleRanges($){(0,k.ok)(!this.g),this.e=$}_acceptViewColumn($){(0,k.ok)(!this.g),this.f=$}_acceptSelections($){(0,k.ok)(!this.g),this.c=$}async l(){const $=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,$)),this.value}m($){const S=$.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const D=S.edits.map(r=>r.range);D.sort((r,s)=>r.end.line===s.end.line?r.end.character===s.end.character?r.start.line===s.start.line?r.start.character-s.start.character:r.start.line-s.start.line:r.end.character-s.end.character:r.end.line-s.end.line);for(let r=0,s=D.length-1;r<s;r++){const c=D[r].end;if(D[r+1].start.isBefore(c))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const p=S.edits.map(r=>({range:L.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,p,{setEndOfLine:typeof S.setEndOfLine=="number"?L.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n($){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):$().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.$IL=R}),define(De[270],Ce([1,0,5,219]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=void 0,e.$NI=(0,k.$oh)(F.$uh)}),define(De[141],Ce([1,0,25,3,13,4]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o1b=e.$n1b=e.$m1b=e.$l1b=e.$k1b=void 0;class A{constructor(r){this.removedDueToLooping=r}}e.$k1b=A;class m{static isHostExtension(r,s,c){if(s.getExtensionDescription(r))return!1;const f=c.getExtensionDescription(r);return f?!!((f.main||f.browser)&&f.api==="none"):!1}constructor(r,s){this.h=r,this.c=new F.$7c,this.onDidChange=this.c.event,this.d=s,this.j()}j(){this.d.sort(S),this.e=new k.$Hl,this.f=[],this.g=new Map;for(const r of this.d){if(this.e.has(r.identifier)){console.error("Extension `"+r.identifier.value+"` is already registered");continue}this.e.set(r.identifier,r),this.f.push(r);const s=this.h.readActivationEvents(r);if(Array.isArray(s))for(let c of s)c==="onUri"&&(c=`onUri:${k.$Fl.toKey(r.identifier)}`),this.g.has(c)||this.g.set(c,[]),this.g.get(c).push(r)}}set(r){this.d=r,this.j(),this.c.fire(void 0)}deltaExtensions(r,s){this.d=D(this.d,s),this.d=this.d.concat(r);const c=m.k(this.d);return this.d=D(this.d,c.map(f=>f.identifier)),this.j(),this.c.fire(void 0),new A(c)}static k(r){const s=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,a){this.addNode(i),this.addNode(a),this.c.has(i)?this.c.get(i).push(a):this.c.set(i,[a])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,a){const n=s.getArcs(i);for(let t=0;t<n.length;t++)if(!a.has(n[t]))return!1;return!0}getNodes(){return this.e}},c=new k.$Hl;for(const i of r)if(c.set(i.identifier,i),i.extensionDependencies)for(const a of i.extensionDependencies)s.addArc(k.$Fl.toKey(i.identifier),k.$Fl.toKey(a));const f=new Set;s.getNodes().filter(i=>s.getArcs(i).length===0).forEach(i=>f.add(i));const y=s.getNodes().filter(i=>!f.has(i));let C;do{C=!1;for(let i=0;i<y.length;i++){const a=y[i];s.hasOnlyGoodArcs(a,f)&&(y.splice(i,1),i--,f.add(a),C=!0)}}while(C);return y.map(i=>c.get(i))}containsActivationEvent(r){return this.g.has(r)}containsExtension(r){return this.e.has(r)}getExtensionDescriptionsForActivationEvent(r){const s=this.g.get(r);return s?s.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(r){const s=this.e.get(r);return s||void 0}getExtensionDescriptionByUUID(r){for(const s of this.f)if(s.uuid===r)return s}getExtensionDescriptionByIdOrUUID(r,s){return this.getExtensionDescription(r)??(s?this.getExtensionDescriptionByUUID(s):void 0)}}e.$l1b=m,e.$m1b={readActivationEvents:p=>p.activationEvents};class E{constructor(r){this.d=new I,this.c=new m(r,[])}async acquireLock(r){const s=await this.d.acquire(r);return new b(this,s)}deltaExtensions(r,s,c){if(!r.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(s,c)}containsActivationEvent(r){return this.c.containsActivationEvent(r)}containsExtension(r){return this.c.containsExtension(r)}getExtensionDescriptionsForActivationEvent(r){return this.c.getExtensionDescriptionsForActivationEvent(r)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(r){return this.c.getExtensionDescription(r)}getExtensionDescriptionByUUID(r){return this.c.getExtensionDescriptionByUUID(r)}getExtensionDescriptionByIdOrUUID(r,s){return this.c.getExtensionDescriptionByIdOrUUID(r,s)}}e.$n1b=E;class b extends L.$lb{constructor(r,s){super(),this.f=r,this.c=!1,this.B(s)}isAcquiredFor(r){return!this.c&&this.f===r}}e.$o1b=b;class R{constructor(r){this.name=r,this.promise=new Promise((s,c)=>{this.c=s})}resolve(r){this.c(r)}}class I{constructor(){this.c=[],this.d=!1}async acquire(r){const s=new R(r);return this.c.push(s),this.e(),s.promise}e(){if(this.d||this.c.length===0)return;const r=this.c.shift();this.d=!0;let s=!0;const c=setTimeout(()=>{s&&console.warn(`The customer named ${r.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),f=()=>{s&&(clearTimeout(c),s=!1,this.d=!1,this.e())};r.resolve((0,L.$jb)(f))}}var $;(function(p){p[p.Builtin=0]="Builtin",p[p.User=1]="User",p[p.Dev=2]="Dev"})($||($={}));function S(p,r){const s=p.isBuiltin?0:p.isUnderDevelopment?2:1,c=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(s!==c)return s-c;const f=h.$0b.basename(p.extensionLocation.path),y=h.$0b.basename(r.extensionLocation.path);return f<y?-1:f>y?1:0}function D(p,r){const s=new k.$Gl(r);return p.filter(c=>!s.has(c.identifier))}}),define(De[271],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.ExtHostConnectionType=void 0;var k;(function(R){R[R.IPC=1]="IPC",R[R.Socket=2]="Socket",R[R.MessagePort=3]="MessagePort"})(k||(e.ExtHostConnectionType=k={}));class F{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(I){this.pipeName=I,this.type=1}serialize(I){I[F.ENV_KEY]=this.pipeName}}e.$0l=F;class h{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(I){I[h.ENV_KEY]="1"}}e.$$l=h;class L{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(I){I[L.ENV_KEY]="1"}}e.$_l=L;function A(R){delete R[F.ENV_KEY],delete R[h.ENV_KEY],delete R[L.ENV_KEY]}function m(R,I){A(I),R.serialize(I)}e.$am=m;function E(R){if(R[F.ENV_KEY])return b(R,new F(R[F.ENV_KEY]));if(R[h.ENV_KEY])return b(R,new h);if(R[L.ENV_KEY])return b(R,new L);throw new Error("No connection information defined in environment!")}e.$bm=E;function b(R,I){return A(R),I}}),define(De[105],Ce([1,0,22]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Ol=e.$Nl=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var F;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(F||(e.UIKind=F={}));var h;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(h||(e.ExtensionHostExitCode=h={}));var L;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(b){const R=k.$Jb.alloc(1);switch(b){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$Nl=A;function m(b,R){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$Ol=m;var E;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(E||(e.NativeLogMarkers=E={}))}),define(De[83],Ce([1,0,5,3,18,26,105,79,80,23,2,4,200]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.$RL=e.$QL=void 0;let S=class extends I.$lb{constructor(s,c){super(),this.n=s,this.p=c,this.a=this.B(new F.$7c),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new F.$7c),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=R.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=c.createLogger(this.j,{id:E.$5n,name:(0,$.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(c.onDidChangeLogLevel(f=>{(0,h.$Ri)(f)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===h.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,c,f){const y=this.getTelemetryDetails(),C=new D(c,f,s,this.k,this.i,this.getBuiltInCommonProperties(s),{isUsageEnabled:y.isUsageEnabled,isErrorsEnabled:y.isErrorsEnabled}),i=this.m.get(s.identifier.value)??[];return this.m.set(s.identifier.value,[...i,C]),C.apiTelemetryLogger}$initializeTelemetryLevel(s,c,f){this.f=s,this.g=c,this.c=f??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(s){const c=Object.create(null);switch(c["common.extname"]=`${s.publisher}.${s.name}`,c["common.extversion"]=s.version,c["common.vscodemachineid"]=this.n.telemetryInfo.machineId,c["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,c["common.vscodeversion"]=this.n.version,c["common.isnewappinstall"]=p(this.n.telemetryInfo.firstSessionDate),c["common.product"]=this.n.environment.appHost,this.n.uiKind){case A.UIKind.Web:c["common.uikind"]="web";break;case A.UIKind.Desktop:c["common.uikind"]="desktop";break;default:c["common.uikind"]="unknown"}return c["common.remotename"]=(0,m.$Ak)((0,E.$_n)(this.n.remote.authority)),c}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const c=this.getTelemetryDetails();this.m.forEach((f,y)=>{const C=f.filter(i=>!i.isDisposed);C.length===0?this.m.delete(y):this.m.set(y,C)}),this.m.forEach(f=>{for(const y of f)y.updateTelemetryEnablements(c.isUsageEnabled,c.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(s,c){const y=this.m.get(s.value)?.filter(i=>!i.isDisposed);if(!y)return this.m.delete(s.value),!1;let C=!1;for(const i of y)i.ignoreUnhandledExtHostErrors||(i.logError(c),C=!0);return C}};e.$QL=S,e.$QL=S=Je([qe(0,L.$PL),qe(1,h.$Qi)],S);class D{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,c,f,y,C,i,a){this.g=f,this.h=y,this.i=C,this.j=i,this.a=new F.$7c,this.ignoreUnhandledExtHostErrors=c?.ignoreUnhandledErrors??!1,this.b=c?.ignoreBuiltInCommonProperties??!1,this.c=c?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(s,c){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:c},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let c="properties"in s?s.properties??{}:s;return c=(0,E.$co)(c,[]),this.c&&(c=(0,b.$Im)(c,this.c)),this.b||(c=(0,b.$Im)(c,this.j)),"properties"in s?s.properties=c:s=c,s}k(s,c){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,c=this.mixInCommonPropsAndCleanData(c||{}),this.i||this.f?.sendEventData(s,c),this.h.trace(s,c))}logUsage(s,c){this.d.isUsageEnabled&&this.k(s,c)}logError(s,c){!this.d.isErrorsEnabled||!this.f||(typeof s=="string"?this.k(s,c):this.f.sendErrorData(s,c))}get apiTelemetryLogger(){if(!this.e){const s=this,c={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(c)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$RL=D;function p(r){const s=Date.now()-new Date(r).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$SL=p,e.$TL=(0,k.$nh)("IExtHostTelemetry")}),define(De[27],Ce([1,0,3,2,240,131,25,5]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=e.$zF=e.ActivationKind=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.ExtensionHostStartup=e.$tF=e.$sF=e.$rF=e.$qF=void 0,e.$qF=Object.freeze({identifier:new A.$Fl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$rF="extensions.webWorker",e.$sF=(0,m.$nh)("extensionService");class E{constructor(C){this.dependency=C}}e.$tF=E;var b;(function(y){y[y.EagerAutoStart=1]="EagerAutoStart",y[y.EagerManualStart=2]="EagerManualStart",y[y.Lazy=3]="Lazy"})(b||(e.ExtensionHostStartup=b={}));class R{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:L.$hF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(C,i){const a=[],n=[],t=[],o=[],g=I(this.c),u=I(C),d=(M,N)=>M.extensionLocation.toString()===N.extensionLocation.toString()||M.isBuiltin===N.isBuiltin||M.isUserBuiltin===N.isUserBuiltin||M.isUnderDevelopment===N.isUnderDevelopment;for(const M of this.c){const N=u.get(M.identifier);if(!N){a.push(M.identifier),g.delete(M.identifier);continue}if(!d(M,N)){a.push(M.identifier),g.delete(M.identifier);continue}}for(const M of C){const N=g.get(M.identifier);if(!N){n.push(M);continue}if(!d(N,M)){a.push(N.identifier),g.delete(N.identifier);continue}}const v=new A.$Gl(this.d),l=new A.$Gl(i);for(const M of this.d)l.has(M)||t.push(M);for(const M of i)v.has(M)||o.push(M);const w=L.$hF.createActivationEventsMap(n),P={toRemove:a,toAdd:n,addActivationEvents:w,myToRemove:t,myToAdd:o};return this.delta(P),P}delta(C){const{toRemove:i,toAdd:a,myToRemove:n,myToAdd:t}=C,o=new A.$Gl(i),g=new A.$Gl(n);for(let u=0;u<this.c.length;u++)o.has(this.c[u].identifier)&&(this.c.splice(u,1),u--);for(let u=0;u<this.d.length;u++)g.has(this.d[u])&&(this.d.splice(u,1),u--);for(const u of a)this.c.push(u);for(const u of t)this.d.push(u)}containsExtension(C){for(const i of this.d)if(A.$Fl.equals(i,C))return!0;return!1}}e.$uF=R;function I(y){const C=new A.$Hl;for(const i of y)C.set(i.identifier,i);return C}function $(y,C){return y.enabledApiProposals?y.enabledApiProposals.includes(C):!1}e.$vF=$;function S(y,C){if(!$(y,C))throw new Error(`Extension '${y.identifier.value}' CANNOT use API proposal: ${C}.
Its package.json#enabledApiProposals-property declares: ${y.enabledApiProposals?.join(", ")??"[]"} but NOT ${C}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${y.identifier.value}`)}e.$wF=S;class D{constructor(C,i,a,n){this.codeLoadingTime=C,this.activateCallTime=i,this.activateResolvedTime=a,this.activationReason=n}}e.$xF=D;class p{constructor(C,i){this.description=C,this.value=i}}e.$yF=p;var r;(function(y){y[y.Normal=0]="Normal",y[y.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function s(y){return{type:y.isBuiltin?0:1,isBuiltin:y.isBuiltin||y.isUserBuiltin,identifier:{id:(0,h.$io)(y.publisher,y.name),uuid:y.uuid},manifest:y,location:y.extensionLocation,targetPlatform:y.targetPlatform,validations:[],isValid:!0}}e.$zF=s;function c(y,C){return{identifier:new A.$Fl((0,h.$go)(y.manifest.publisher,y.manifest.name)),isBuiltin:y.type===0,isUserBuiltin:y.type===1&&y.isBuiltin,isUnderDevelopment:!!C,extensionLocation:y.location,...y.manifest,uuid:y.identifier.uuid,targetPlatform:y.targetPlatform}}e.$AF=c;class f{constructor(){this.onDidRegisterExtensions=k.Event.None,this.onDidChangeExtensionsStatus=k.Event.None,this.onDidChangeExtensions=k.Event.None,this.onWillActivateByEvent=k.Event.None,this.onDidChangeResponsiveChange=k.Event.None,this.onWillStop=k.Event.None,this.extensions=[]}activateByEvent(C){return Promise.resolve(void 0)}activationEventIsDone(C){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(C){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(C,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(C){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$BF=f}),define(De[272],Ce([1,0,8,141,25,27,18,17]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=e.$9$b=e.$8$b=e.$7$b=e.$6$b=e.$5$b=void 0;class E{static{this.NONE=new E(!1,-1,-1,-1)}constructor(s,c,f,y){this.startup=s,this.codeLoadingTime=c,this.activateCallTime=f,this.activateResolvedTime=y}}e.$5$b=E;class b{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,c){return s===-1||c===-1?-1:c-s}build(){return new E(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$6$b=b;class R{constructor(s,c,f,y,C,i){this.activationFailed=s,this.activationFailedError=c,this.activationTimes=f,this.module=y,this.exports=C,this.subscriptions=i}}e.$7$b=R;class I extends R{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$8$b=I;class $ extends R{constructor(){super(!1,null,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9$b=$;class S extends R{constructor(s){super(!0,s,E.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(s,c,f,y){this.g=y,this.a=s,this.b=c,this.c=f,this.d=new h.$Hl,this.f=Object.create(null)}dispose(){for(const[s,c]of this.d)c.dispose()}async waitForActivatingExtensions(){const s=[];for(const[c,f]of this.d)s.push(f.wait());await Promise.all(s)}isActivated(s){const c=this.d.get(s);return!!(c&&c.value)}getActivatedExtension(s){const c=this.d.get(s);if(!c||!c.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return c.value}async activateByEvent(s,c){if(this.f[s])return;const f=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(f.map(y=>({id:y.identifier,reason:{startup:c,extensionId:y.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,c){const f=this.a.getExtensionDescription(s);if(!f)throw new Error(`Extension '${s}' is not known`);return this.h([{id:f.identifier,reason:c}])}async h(s){const c=s.filter(f=>!this.isActivated(f.id)).map(f=>this.j(f));await Promise.all(c.map(f=>f.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const c=this.a.getExtensionDescription(s.id);if(!c){const C=new Error(`Cannot activate unknown extension '${s.id.value}'`),i=this.k(s,null,[],new S(C));return this.c.onExtensionActivationError(s.id,C,new L.$tF(s.id.value)),i}const f=[],y=typeof c.extensionDependencies>"u"?[]:c.extensionDependencies;for(const C of y){if(this.m(C))continue;const i=this.d.get(C);if(i){f.push(i);continue}if(this.l(C)){f.push(this.j({id:this.b.getExtensionDescription(C).identifier,reason:s.reason}));continue}const a=this.a.getExtensionDescription(C);if(a){if(!a.main&&!a.browser)continue;f.push(this.j({id:a.identifier,reason:s.reason}));continue}const n=c.displayName||c.identifier.value,t=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${C}'`),o=this.k(s,c.displayName,[],new S(t));return this.c.onExtensionActivationError(c.identifier,t,new L.$tF(C)),o}return this.k(s,c.displayName,f,null)}k(s,c,f,y){const C=new p(s.id,c,s.reason,f,y,this.c,this.g);return this.d.set(s.id,C),C}l(s){return F.$l1b.isHostExtension(s,this.a,this.b)}m(s){const c=this.b.getExtensionDescription(s);return c?!c.main&&!c.browser:!1}};e.$0$b=D,e.$0$b=D=Je([qe(3,A.$Pi)],D);let p=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,c,f,y,C,i,a){this.c=s,this.d=c,this.f=f,this.g=y,this.h=C,this.j=i,this.k=a,this.a=new m.$sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const c=this.g[s];if(c.value&&!c.value.activationFailed){this.g.splice(s,1),s--;continue}if(c.value&&c.value.activationFailed){const f=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${c.friendlyName}' failed to activate`);f.detail=c.value.activationFailedError,this.h=new S(f),this.j.onExtensionActivationError(this.c,f,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const c=new Error;if(s&&s.name&&(c.name=s.name),s&&s.message?c.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:c.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(c.stack=s.stack),this.h=new S(c),this.b&&k.$2(s))return;this.j.onExtensionActivationError(this.c,c,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};p=Je([qe(6,A.$Pi)],p)}),define(De[273],Ce([1,0,202,7,24,2,3,4,254,17,7,14,19,16,74,21,166,27]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=void 0;function c(C,i){if((0,I.$ie)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let a;return Array.isArray(C.highlights)&&(a=C.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),a=a.length?a:void 0),{label:C.label,highlights:a}}}class f{constructor(i,a,n){this.d=i,this.e=a,this.f=n,this.a=new Map,this.b=new r.$s5;function t(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}a.registerArgumentProcessor({processArgument:o=>t(o)?this.i(o):Array.isArray(o)&&o.length>0?o.map(g=>t(g)?this.i(g):g):o})}registerTreeDataProvider(i,a,n){const t=this.createTreeView(i,{treeDataProvider:a},n);return{dispose:()=>t.dispose()}}createTreeView(i,a,n){if(!a||!a.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const t=a.dragAndDropController?.dropMimeTypes??[],o=a.dragAndDropController?.dragMimeTypes??[],g=!!a.dragAndDropController?.handleDrag,u=!!a.dragAndDropController?.handleDrop,d=this.h(i,a,n),v={showCollapseAll:!!a.showCollapseAll,canSelectMany:!!a.canSelectMany,dropMimeTypes:t,dragMimeTypes:o,hasHandleDrag:g,hasHandleDrop:u,manuallyManageCheckboxes:!!a.manageCheckboxStateManually},l=this.d.$registerTreeViewDataProvider(i,v);return{get onDidCollapseElement(){return d.onDidCollapseElement},get onDidExpandElement(){return d.onDidExpandElement},get selection(){return d.selectedElements},get onDidChangeSelection(){return d.onDidChangeSelection},get activeItem(){return(0,s.$wF)(n,"treeViewActiveItem"),d.focusedElement},get onDidChangeActiveItem(){return(0,s.$wF)(n,"treeViewActiveItem"),d.onDidChangeActiveItem},get visible(){return d.visible},get onDidChangeVisibility(){return d.onDidChangeVisibility},get onDidChangeCheckboxState(){return d.onDidChangeCheckboxState},get message(){return d.message},set message(P){(0,D.$Kj)(P)&&(0,s.$wF)(n,"treeViewMarkdownMessage"),d.message=P},get title(){return d.title},set title(P){d.title=P},get description(){return d.description},set description(P){d.description=P},get badge(){return d.badge},set badge(P){P!==void 0&&R.ViewBadge.isViewBadge(P)?d.badge={value:Math.floor(Math.abs(P.value)),tooltip:P.tooltip}:P===void 0&&(d.badge=void 0)},reveal:(P,M)=>d.reveal(P,M),dispose:async()=>{await l,this.a.delete(i),d.dispose()}}}$getChildren(i,a){const n=this.a.get(i);return n?n.getChildren(a):Promise.reject(new E.$UE(i))}async $handleDrop(i,a,n,t,o,g,u,d){const v=this.a.get(i);if(!v)return Promise.reject(new E.$UE(i));const l=S.DataTransfer.toDataTransfer(n,async w=>(await this.d.$resolveDropFileData(i,a,w)).buffer);return u===i&&d&&await this.g(l,v,d,o,g),v.onDrop(l,t,o)}async g(i,a,n,t,o){const g=this.b.removeDragOperationTransfer(o);if(g)(await g)?.forEach((u,d)=>{u&&i.set(d,u)});else if(o&&a.handleDrag){const u=a.handleDrag(n,i,t);this.b.addDragOperationTransfer(o,u),await u}return i}async $handleDrag(i,a,n,t){const o=this.a.get(i);if(!o)return Promise.reject(new E.$UE(i));const g=await this.g(new F.$rK,o,a,t,n);if(!(!g||t.isCancellationRequested))return S.DataTransfer.from(g)}async $hasResolve(i){const a=this.a.get(i);if(!a)throw new E.$UE(i);return a.hasResolve}$resolve(i,a,n){const t=this.a.get(i);if(!t)throw new E.$UE(i);return t.resolveTreeItem(a,n)}$setExpanded(i,a,n){const t=this.a.get(i);if(!t)throw new E.$UE(i);t.setExpanded(a,n)}$setSelectionAndFocus(i,a,n){const t=this.a.get(i);if(!t)throw new E.$UE(i);t.setSelectionAndFocus(a,n)}$setVisible(i,a){const n=this.a.get(i);if(!n)throw new E.$UE(i);n.setVisible(a)}$changeCheckboxState(i,a){const n=this.a.get(i);if(!n)throw new E.$UE(i);n.setCheckboxState(a)}h(i,a,n){const t=new y(i,a,this.d,this.e.converter,this.f,n);return this.a.set(i,t),t}i(i){const a=this.a.get(i.$treeViewId);return a&&"$treeItemHandle"in i?a.getExtensionElement(i.$treeItemHandle):a&&"$focusedTreeItem"in i&&i.$focusedTreeItem?a.focusedElement:null}}e.$J_b=f;class y extends m.$lb{static{this.a="0"}static{this.b="1"}get visible(){return this.k}get selectedElements(){return this.l.map(i=>this.getExtensionElement(i)).filter(i=>!(0,I.$re)(i))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(i,a,n,t,o,g){if(super(),this.D=i,this.F=n,this.G=t,this.H=o,this.I=g,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new A.$7c),this.onDidExpandElement=this.r.event,this.s=this.B(new A.$7c),this.onDidCollapseElement=this.s.event,this.t=this.B(new A.$7c),this.onDidChangeSelection=this.t.event,this.u=this.B(new A.$7c),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new A.$7c),this.onDidChangeVisibility=this.v.event,this.w=this.B(new A.$7c),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new A.$7c),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new p.$dd,g.contributes&&g.contributes.views)for(const v in g.contributes.views)for(const l of g.contributes.views[v])l.id===i&&(this.L=l.name);this.f=a.treeDataProvider,this.g=a.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.y.fire({message:!1,element:v})));let u,d;this.B(A.Event.debounce(this.y.event,(v,l)=>(v||(v={message:!1,elements:[]}),l.element!==!1&&(u||(u=new Promise(w=>d=w),this.z=this.z.then(()=>u)),Array.isArray(l.element)?v.elements.push(...l.element):v.elements.push(l.element)),l.message&&(v.message=!0),v),200,!0)(({message:v,elements:l})=>{l.length&&(this.C=this.C.then(()=>{const w=d;return u=null,this.W(l).then(()=>w())})),v&&this.F.$setMessage(this.D,S.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(i){const a=i?this.getExtensionElement(i):void 0;if(i&&!a)return this.H.error(`No tree item with id '${i}' found.`),Promise.resolve([]);let n=this.R(i);return n||(n=await this.S(a)),n?n.map(t=>t.item):void 0}getExtensionElement(i){return this.i.get(i)}reveal(i,a){a=a||{select:!0,focus:!1};const n=(0,I.$re)(a.select)?!0:a.select,t=(0,I.$re)(a.focus)?!1:a.focus,o=(0,I.$re)(a.expand)?!1:a.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):i?this.z.then(()=>this.O(i)).then(g=>this.Q(i,g[g.length-1]).then(u=>this.F.$reveal(this.D,{item:u.item,parentChain:g.map(d=>d.item)},{select:n,focus:t,expand:o})),g=>this.H.error(g)):this.F.$reveal(this.D,void 0,{select:n,focus:t,expand:o})}get message(){return this.J}set message(i){this.J=i,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(i){this.L=i,this.F.$setTitle(this.D,i,this.M)}get description(){return this.M}set description(i){this.M=i,this.F.$setTitle(this.D,this.L,i)}get badge(){return this.N}set badge(i){this.N?.value===i?.value&&this.N?.tooltip===i?.tooltip||(this.N=S.ViewBadge.from(i),this.F.$setBadge(this.D,i))}setExpanded(i,a){const n=this.getExtensionElement(i);n&&(a?this.r.fire(Object.freeze({element:n})):this.s.fire(Object.freeze({element:n})))}setSelectionAndFocus(i,a){const n=!(0,$.$af)(this.l,i);this.l=i;const t=this.m!==a;this.m=a,n&&this.t.fire(Object.freeze({selection:this.selectedElements})),t&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(i){i!==this.k&&(this.k=i,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(i){const a=(await Promise.all(i.map(async n=>{const t=this.getExtensionElement(n.treeItemHandle);return t?{extensionItem:t,treeItem:await this.f.getTreeItem(t),newState:n.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);a.forEach(n=>{n.treeItem.checkboxState=n.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}),this.w.fire({items:a.map(n=>[n.extensionItem,n.newState])})}async handleDrag(i,a,n){const t=[];for(const o of i){const g=this.getExtensionElement(o);g&&t.push(g)}if(!(!this.g?.handleDrag||t.length===0))return await this.g.handleDrag(t,a,n),a}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(i,a,n){const t=a?this.getExtensionElement(a):void 0;if(!(!t&&a||!this.g?.handleDrop))return(0,b.$mg)(()=>this.g?.handleDrop?this.g.handleDrop(t,i,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(i,a){if(!this.f.resolveTreeItem)return;const n=this.i.get(i);if(n){const t=this.j.get(n);if(t){const o=await this.f.resolveTreeItem(t.extensionItem,n,a)??t.extensionItem;return this.db(o),t.item.tooltip=this.ab(o.tooltip),t.item.command=this.bb(t.disposableStore,o.command),t.item}}}O(i){return this.P(i).then(a=>a?this.O(a).then(n=>this.Q(a,n[n.length-1]).then(t=>(n.push(t),n))):Promise.resolve([]))}P(i){const a=this.j.get(i);return a?Promise.resolve(a.parent?this.i.get(a.parent.item.handle):void 0):(0,b.$mg)(()=>this.f.getParent(i))}Q(i,a){const n=this.j.get(i);return n?Promise.resolve(n):(0,b.$mg)(()=>this.f.getTreeItem(i)).then(t=>this.gb(i,t,a,!0)).then(t=>this.getChildren(a?a.item.handle:void 0).then(()=>{const o=this.getExtensionElement(t);if(o){const g=this.j.get(o);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${t} from extension ${this.I.identifier.value}`)}))}R(i){if(i){let a;if(typeof i=="string"){const n=this.getExtensionElement(i);a=n?this.j.get(n):void 0}else a=i;return a&&a.children||void 0}return this.h}async S(i){this.nb(i);const a=new p.$dd(this.U.token);try{const n=i?this.j.get(i):void 0,t=await this.f.getChildren(i);if(a.token.isCancellationRequested)return;const o=await Promise.all((0,$.$lf)(t||[]).map(async g=>{const u=await this.f.getTreeItem(g);return u&&!a.token.isCancellationRequested?this.$(g,u,n):null}));return a.token.isCancellationRequested?void 0:(0,$.$lf)(o)}finally{a.dispose()}}W(i){if(i.some(n=>!n))return this.U.dispose(!0),this.U=new p.$dd,this.pb(),this.F.$refresh(this.D);{const n=this.X(i);if(n.length)return this.Y(n)}return Promise.resolve(void 0)}X(i){const a=new Set,n=i.map(o=>this.j.get(o));for(const o of n)if(o&&!a.has(o.item.handle)){let g=o;for(;g&&g.parent&&n.findIndex(u=>g&&g.parent&&u&&u.item.handle===g.parent.item.handle)===-1;){const u=this.i.get(g.parent.item.handle);g=u?this.j.get(u):void 0}g&&!g.parent&&a.add(o.item.handle)}const t=[];return a.forEach(o=>{const g=this.i.get(o);if(g){const u=this.j.get(g);u&&(!u.parent||!a.has(u.parent.item.handle))&&t.push(o)}}),t}Y(i){const a={};return Promise.all(i.map(n=>this.Z(n).then(t=>{t&&(a[n]=t.item)}))).then(()=>Object.keys(a).length?this.F.$refresh(this.D,a):void 0)}Z(i){const a=this.getExtensionElement(i);if(a){const n=this.j.get(a);if(n)return this.nb(a),(0,b.$mg)(()=>this.f.getTreeItem(a)).then(t=>{if(t){const o=this.eb(a,t,n.parent);return this.lb(a,o,n,n.parent),n.dispose(),o}return null})}return Promise.resolve(null)}$(i,a,n){const t=this.eb(i,a,n);if(a.id&&this.i.has(t.item.handle))throw new Error((0,k.localize)(0,null,a.id));return this.kb(i,t),this.mb(t,n),t}ab(i){return R.$1J.isMarkdownString(i)?S.MarkdownString.from(i):i}bb(i,a){return a?{...this.G.toInternal(a,i),originalId:a.command}:void 0}cb(i){if(i.checkboxState===void 0)return;let a,n,t;return typeof i.checkboxState=="number"?a=i.checkboxState:(a=i.checkboxState.state,n=i.checkboxState.tooltip,t=i.checkboxState.accessibilityInformation),{isChecked:a===R.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:t}}db(i){if(!R.$mK.isTreeItem(i,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(i,a,n){this.db(a);const t=new m.$kb,o=this.gb(i,a,n),g=this.hb(a);return{item:{handle:o,parentHandle:n?n.item.handle:void 0,label:c(a.label,this.I),description:a.description,resourceUri:a.resourceUri,tooltip:this.ab(a.tooltip),command:this.bb(t,a.command),contextValue:a.contextValue,icon:g,iconDark:this.ib(a)||g,themeIcon:this.fb(a),collapsibleState:(0,I.$re)(a.collapsibleState)?R.TreeItemCollapsibleState.None:a.collapsibleState,accessibilityInformation:a.accessibilityInformation,checkbox:this.cb(a)},extensionItem:a,parent:n,children:void 0,disposableStore:t,dispose(){t.dispose()}}}fb(i){return i.iconPath instanceof R.$uK?i.iconPath:void 0}gb(i,{id:a,label:n,resourceUri:t},o,g){if(a)return`${y.b}/${a}`;const u=c(n,this.I),d=o?o.item.handle:y.a;let v=u?u.label:t?(0,h.$5f)(t):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const l=this.j.has(i)?this.j.get(i).item.handle:void 0,w=this.R(o)||[];let P,M=0;do{if(P=`${d}/${M}:${v}`,g||!this.i.has(P)||l===P)break;M++}while(M<=w.length);return P}hb(i){if(i.iconPath&&!(i.iconPath instanceof R.$uK))return typeof i.iconPath=="string"||L.URI.isUri(i.iconPath)?this.jb(i.iconPath):this.jb(i.iconPath.light)}ib(i){if(i.iconPath&&!(i.iconPath instanceof R.$uK)&&i.iconPath.dark)return this.jb(i.iconPath.dark)}jb(i){return L.URI.isUri(i)?i:L.URI.file(i)}kb(i,a){this.i.set(a.item.handle,i),this.j.set(i,a)}lb(i,a,n,t){this.i.delete(a.item.handle),this.j.delete(i),a.item.handle!==n.item.handle&&this.i.delete(n.item.handle),this.kb(i,a);const o=this.R(t)||[],g=o.filter(u=>u.item.handle===n.item.handle)[0];g&&o.splice(o.indexOf(g),1,a)}mb(i,a){a?(a.children||(a.children=[]),a.children.push(i)):(this.h||(this.h=[]),this.h.push(i))}nb(i){if(i){const a=this.j.get(i);if(a){if(a.children)for(const n of a.children){const t=this.i.get(n.item.handle);t&&this.ob(t)}a.children=void 0}}else this.pb()}ob(i){const a=this.j.get(i);if(a){if(a.children)for(const n of a.children){const t=this.i.get(n.item.handle);t&&this.ob(t)}this.j.delete(i),this.i.delete(a.item.handle),a.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(i=>i.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}}),define(De[274],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[275],Ce([1,0,214,8,40,125,100,42,25,274,234,131]),function(me,e,k,F,h,L,A,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=void 0;const $=m.$Rm.as(A.$Sm.JSONContribution);class S{constructor(C,i,a){this.a=C,this.b=i,this.c=a}d(C,i){this.a({type:C,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(C){this.d(h.default.Error,C)}warn(C){this.d(h.default.Warning,C)}info(C){this.d(h.default.Info,C)}}e.$CF=S;class D{static a(C){const i=new E.$Gl;for(let a=0,n=C.length;a<n;a++)i.add(C[a].description.identifier);return i}static compute(C,i){if(!C||!C.length)return new D(i,[]);if(!i||!i.length)return new D([],C);const a=this.a(C),n=this.a(i),t=i.filter(g=>!a.has(g.description.identifier)),o=C.filter(g=>!n.has(g.description.identifier));return new D(t,o)}constructor(C,i){this.added=C,this.removed=i}}e.$DF=D;class p{constructor(C,i){this.name=C,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(C){if(this.a!==null)throw new Error("Handler already set!");this.a=C,this.d()}acceptUsers(C){this.c=D.compute(this.b,C),this.b=C,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(C){(0,F.$Y)(C)}}}e.$EF=p;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[k.localize(0,null),k.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$FF={properties:{engines:{type:"object",description:k.localize(2,null),properties:{vscode:{type:"string",description:k.localize(3,null),default:"^1.22.0"}}},publisher:{description:k.localize(4,null),type:"string"},displayName:{description:k.localize(5,null),type:"string"},categories:{description:k.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.$El},{type:"string",const:"Languages",deprecationMessage:k.localize(7,null)}]}},galleryBanner:{type:"object",description:k.localize(8,null),properties:{color:{description:k.localize(9,null),type:"string"},theme:{description:k.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:k.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:k.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:k.localize(13,null)},enabledApiProposals:{markdownDescription:k.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}},api:{markdownDescription:k.localize(15,null),type:"string",enum:["none"],enumDescriptions:[k.localize(16,null)]},activationEvents:{description:k.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:k.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:k.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:k.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:k.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:k.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:k.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:k.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:k.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:k.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:k.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:k.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:k.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:k.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:k.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:k.localize(32,null)},{label:"onUri",body:"onUri",description:k.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:k.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:k.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:k.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:k.localize(37,null)},{label:"onRenderer",description:k.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:k.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:k.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:k.localize(41,null)},{label:"*",description:k.localize(42,null),body:"*"}]}},badges:{type:"array",description:k.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:k.localize(44,null)},href:{type:"string",description:k.localize(45,null)},description:{type:"string",description:k.localize(46,null)}}}},markdown:{type:"string",description:k.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:k.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:k.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Bn}},extensionPack:{description:k.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.$Bn}},extensionKind:{description:k.localize(51,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:k.localize(52,null)},{body:["workspace"],description:k.localize(53,null)},{body:["ui","workspace"],description:k.localize(54,null)},{body:["workspace","ui"],description:k.localize(55,null)},{body:[],description:k.localize(56,null)}]},capabilities:{description:k.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:k.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:k.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[k.localize(60,null),k.localize(61,null),k.localize(62,null)]},description:{type:"string",markdownDescription:k.localize(63,null)}}},untrustedWorkspaces:{description:k.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:k.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[k.localize(66,null),k.localize(67,null),k.localize(68,null)]},restrictedConfigurations:{description:k.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:k.localize(70,null)}}}}},sponsor:{description:k.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:k.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:k.localize(73,null),type:"string"},"vscode:uninstall":{description:k.localize(74,null),type:"string"}}},icon:{type:"string",description:k.localize(75,null)},l10n:{type:"string",description:k.localize(76,null)}}};class c{constructor(){this.a=new Map}registerExtensionPoint(C){if(this.a.has(C.extensionPoint))throw new Error("Duplicate extension point: "+C.extensionPoint);const i=new p(C.extensionPoint,C.defaultExtensionKind);return this.a.set(C.extensionPoint,i),C.activationEventsGenerator&&I.$hF.register(C.extensionPoint,C.activationEventsGenerator),e.$FF.properties.contributes.properties[C.extensionPoint]=C.jsonSchema,$.registerSchema(s,e.$FF),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$GF=c;const f={ExtensionsRegistry:"ExtensionsRegistry"};m.$Rm.add(f.ExtensionsRegistry,new c),e.$HF=m.$Rm.as(f.ExtensionsRegistry),$.registerSchema(s,e.$FF),$.registerSchema(R.$9i,{properties:{extensionEnabledApiProposals:{description:k.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(b.allApiProposals),markdownEnumDescriptions:Object.values(b.allApiProposals)}}]}}}})}),define(De[276],Ce([1,0,211,14,23,275,47,3]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:k.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:k.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:k.localize(2,null),default:""}}};var b;(function($){function S(D,p,r){if(!D)return;const s=F.$ie(D.type)?D.type:void 0;if(!s||s.length===0){r.error(k.localize(3,null));return}const c=[];if(Array.isArray(D.required))for(const f of D.required)F.$ie(f)&&c.push(f);return{extensionId:p.value,taskType:s,required:c,properties:D.properties?h.$Fm(D.properties):{},when:D.when?A.$ti.deserialize(D.when):void 0}}$.from=S})(b||(b={}));const R=L.$HF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:($,S)=>{for(const D of $)D.type&&S.push(`onTaskType:${D.type}`)},jsonSchema:{description:k.localize(4,null),type:"array",items:E}});class I{constructor(){this.d=new m.$7c,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,D)=>{R.setHandler((p,r)=>{this.c=void 0;try{for(const s of r.removed){const c=s.value;for(const f of c)this.a&&f.type&&this.a[f.type]&&delete this.a[f.type]}for(const s of r.added){const c=s.value;for(const f of c){const y=b.from(f,s.description.identifier,s.collector);y&&(this.a[y.taskType]=y)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const D of this.all()){const p={type:"object",additionalProperties:!1};D.required.length>0&&(p.required=D.required.slice(0)),D.properties!==void 0?p.properties=h.$Fm(D.properties):p.properties=Object.create(null),p.properties.type={type:"string",enum:[D.taskType]},S.push(p)}this.c={oneOf:S}}return this.c}}e.$QF=new I}),define(De[277],Ce([1,0,212,14,24,23,47,276]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$1F=e.JsonSchemaVersion=e.ExecutionEngine=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$UF=e.ShellQuoting=e.$TF=e.$SF=e.$RF=void 0,e.$RF="settings",e.$SF=new A.$Mi("taskRunning",!1,k.localize(0,null)),e.$TF={value:k.localize(1,null),original:"Tasks"};var E;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(E||(e.ShellQuoting=E={})),e.$UF="$customized",function(j){function U(Y){if(!Y)return j.Strong;switch(Y.toLowerCase()){case"escape":return j.Escape;case"strong":return j.Strong;case"weak":return j.Weak;default:return j.Strong}}j.from=U}(E||(e.ShellQuoting=E={}));var b;(function(j){j.defaults={cwd:"${workspaceFolder}"}})(b||(e.CommandOptions=b={}));var R;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(R||(e.RevealKind=R={})),function(j){function U(Y){switch(Y.toLowerCase()){case"always":return j.Always;case"silent":return j.Silent;case"never":return j.Never;default:return j.Always}}j.fromString=U}(R||(e.RevealKind=R={}));var I;(function(j){j[j.Never=1]="Never",j[j.OnProblem=2]="OnProblem",j[j.Always=3]="Always"})(I||(e.RevealProblemKind=I={})),function(j){function U(Y){switch(Y.toLowerCase()){case"always":return j.Always;case"never":return j.Never;case"onproblem":return j.OnProblem;default:return j.OnProblem}}j.fromString=U}(I||(e.RevealProblemKind=I={}));var $;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})($||(e.PanelKind=$={})),function(j){function U(Y){switch(Y.toLowerCase()){case"shared":return j.Shared;case"dedicated":return j.Dedicated;case"new":return j.New;default:return j.Shared}}j.fromString=U}($||(e.PanelKind=$={}));var S;(function(j){j.defaults={echo:!0,reveal:R.Always,revealProblems:I.Never,focus:!1,panel:$.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var D;(function(j){j[j.Shell=1]="Shell",j[j.Process=2]="Process",j[j.CustomExecution=3]="CustomExecution"})(D||(e.RuntimeType=D={})),function(j){function U(H){switch(H.toLowerCase()){case"shell":return j.Shell;case"process":return j.Process;case"customExecution":return j.CustomExecution;default:return j.Process}}j.fromString=U;function Y(H){switch(H){case j.Shell:return"shell";case j.Process:return"process";case j.CustomExecution:return"customExecution";default:return"process"}}j.toString=Y}(D||(e.RuntimeType=D={}));var p;(function(j){function U(Y){return F.$ie(Y)?Y:Y.value}j.value=U})(p||(e.CommandString=p={}));var r;(function(j){j.Clean={_id:"clean",isDefault:!1},j.Build={_id:"build",isDefault:!1},j.Rebuild={_id:"rebuild",isDefault:!1},j.Test={_id:"test",isDefault:!1};function U(H){return H===j.Clean._id||H===j.Build._id||H===j.Rebuild._id||H===j.Test._id}j.is=U;function Y(H){if(H!==void 0)return F.$ie(H)?U(H)?{_id:H,isDefault:!1}:void 0:H}j.from=Y})(r||(e.TaskGroup=r={}));var s;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var c;(function(j){j.Workspace="workspace",j.Extension="extension",j.InMemory="inMemory",j.WorkspaceFile="workspaceFile",j.User="user";function U(Y){switch(Y){case j.User:return 2;case j.WorkspaceFile:return 5;default:return 6}}j.toConfigurationTarget=U})(c||(e.TaskSourceKind=c={}));var f;(function(j){j.parallel="parallel",j.sequence="sequence"})(f||(e.DependsOrder=f={}));var y;(function(j){j[j.default=1]="default",j[j.folderOpen=2]="folderOpen"})(y||(e.RunOnOptions=y={}));var C;(function(j){j.defaults={reevaluateOnRerun:!0,runOn:y.default,instanceLimit:1}})(C||(e.RunOptions=C={}));class i{constructor(U,Y,H,ge,ie,te){this._label="",this._id=U,Y&&(this._label=Y),H&&(this.type=H),this.runOptions=ge,this.configurationProperties=ie,this._source=te}getDefinition(U){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const U={folder:this.d(),id:this._id};return JSON.stringify(U)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(U,Y=!1){if(U===void 0)return!1;if(F.$ie(U))return U===this._label||U===this.configurationProperties.identifier||Y&&U===this._id;const H=this.getDefinition(!0);return H!==void 0&&H._key===U._key}getQualifiedLabel(){const U=this.getWorkspaceFolder();return U?`${this._label} (${U.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(U){this.c===void 0&&(this.c=[]),U&&(this.c=this.c.concat(U))}get taskLoadMessages(){return this.c}}e.$VF=i;class a extends i{constructor(U,Y,H,ge,ie,te,q,V){super(U,H,void 0,q,V,Y),this.command={},this._source=Y,this.hasDefinedMatchers=te,ie&&(this.command=ie)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(U=!1){if(U&&this._source.customizes!==void 0)return this._source.customizes;{let Y;switch(this.command?this.command.runtime:void 0){case D.Shell:Y="shell";break;case D.Process:Y="process";break;case D.CustomExecution:Y="customExecution";break;case void 0:Y="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:Y,_key:this._id,id:this._id}}}static is(U){return U instanceof a}getMapKey(){const U=this._source.config.workspaceFolder;return U?`${U.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===c.User?e.$RF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let Y=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(Y+=this._source.kind);const H={type:e.$UF,folder:U,id:Y};return JSON.stringify(H)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$5f(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(U){return new a(U._id,U._source,U._label,U.type,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$WF=a;class n extends i{constructor(U,Y,H,ge,ie,te,q){super(U,H,ge,te,q,Y),this._source=Y,this.configures=ie}static is(U){return U instanceof n}f(U){return U}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?h.$5f(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===c.User?e.$RF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const U=this.d();if(!U)return;let Y=this.configurationProperties.identifier;this._source.kind!==c.Workspace&&(Y+=this._source.kind);const H={type:e.$UF,folder:U,id:Y};return JSON.stringify(H)}}e.$XF=n;class t extends i{constructor(U,Y,H,ge,ie,te,q,V,ce){super(U,H,ge,V,ce,Y),this.defines=ie,this.hasDefinedMatchers=q,this.command=te,this.icon=ce.icon,this.hide=ce.hide}clone(){return new t(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(U){return U instanceof t}getMapKey(){const U=this._source.workspaceFolder;return U?`${this._source.scope.toString()}|${U.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const U={type:"contributed",scope:this._source.scope,id:this._id};return U.folder=this.d(),JSON.stringify(U)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(U){return new t(U._id,U._source,U._label,U.type,U.defines,U.command,U.hasDefinedMatchers,U.runOptions,U.configurationProperties)}}e.$YF=t;class o extends i{constructor(U,Y,H,ge,ie,te){super(U,H,ge,ie,te,Y),this._source=Y}clone(){return new o(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(U){return U instanceof o}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(U){return new o(U._id,U._source,U._label,U.type,U.runOptions,U.configurationProperties)}}e.$ZF=o;var g;(function(j){j[j.Process=1]="Process",j[j.Terminal=2]="Terminal"})(g||(e.ExecutionEngine=g={})),function(j){j._default=j.Terminal}(g||(e.ExecutionEngine=g={}));var u;(function(j){j[j.V0_1_0=1]="V0_1_0",j[j.V2_0_0=2]="V2_0_0"})(u||(e.JsonSchemaVersion=u={}));class d{constructor(U){this.c=new Map;for(let Y=0;Y<U.length;Y++)this.c.set(U[Y].uri.toString(),Y)}compare(U,Y){const H=U.getWorkspaceFolder(),ge=Y.getWorkspaceFolder();if(H&&ge){let ie=this.c.get(H.uri.toString());ie=ie===void 0?0:ie+1;let te=this.c.get(ge.uri.toString());return te=te===void 0?0:te+1,ie===te?U._label.localeCompare(Y._label):ie-te}else return!H&&ge?-1:H&&!ge?1:0}}e.$1F=d;var v;(function(j){j.DependsOnStarted="dependsOnStarted",j.AcquiredInput="acquiredInput",j.Start="start",j.ProcessStarted="processStarted",j.Active="active",j.Inactive="inactive",j.Changed="changed",j.Terminated="terminated",j.ProcessEnded="processEnded",j.End="end"})(v||(e.TaskEventKind=v={}));var l;(function(j){j.SingleRun="singleRun",j.Background="background"})(l||(e.TaskRunType=l={}));var w;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.FolderOpen=2]="FolderOpen",j[j.ConfigurationChange=3]="ConfigurationChange",j[j.Reconnect=4]="Reconnect"})(w||(e.TaskRunSource=w={}));var P;(function(j){function U(Y,H,ge,ie){if(H){const te={kind:Y,taskId:H._id,taskName:H.configurationProperties.name,runType:H.configurationProperties.isBackground?"background":"singleRun",group:H.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:ge,__task:H};return Y==="start"?te.resolvedVariables=ie:Y==="processStarted"?te.processId=ie:Y==="processEnded"&&(te.exitCode=ie),Object.freeze(te)}else return Object.freeze({kind:"changed"})}j.create=U})(P||(e.TaskEvent=P={}));var M;(function(j){function U(H){const ge=Object.keys(H).sort();let ie="";for(const te of ge){let q=H[te];q instanceof Object?q=U(q):typeof q=="string"&&(q=q.replace(/,/g,",,")),ie+=te+","+q+","}return ie}function Y(H){const ie={_key:U(H),type:H.taskType};return Object.assign(ie,H),ie}j.create=Y})(M||(e.KeyedTaskIdentifier=M={}));var N;(function(j){j.AutoDetect="task.autoDetect",j.SaveBeforeRun="task.saveBeforeRun",j.ShowDecorations="task.showDecorations",j.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",j.SlowProviderWarning="task.slowProviderWarning",j.QuickOpenHistory="task.quickOpen.history",j.QuickOpenDetail="task.quickOpen.detail",j.QuickOpenSkip="task.quickOpen.skip",j.QuickOpenShowAll="task.quickOpen.showAll",j.AllowAutomaticTasks="task.allowAutomaticTasks",j.Reconnection="task.reconnection"})(N||(e.TaskSettingId=N={}));var T;(function(j){j.Tasks="tasks",j.SuppressTaskName="tasks.suppressTaskName",j.Windows="tasks.windows",j.Osx="tasks.osx",j.Linux="tasks.linux",j.ShowOutput="tasks.showOutput",j.IsShellCommand="tasks.isShellCommand",j.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var z;(function(j){function U(Y,H){const ge=m.$QF.get(Y.type);if(ge===void 0){const V=L.$Fm(Y);return delete V._key,M.create(V)}const ie=Object.create(null);ie.type=ge.taskType;const te=new Set;ge.required.forEach(V=>te.add(V));const q=ge.properties;for(const V of Object.keys(q)){const ce=Y[V];if(ce!=null)ie[V]=ce;else if(te.has(V)){const re=q[V];if(re.default!==void 0)ie[V]=L.$Fm(re.default);else switch(re.type){case"boolean":ie[V]=!1;break;case"number":case"integer":ie[V]=0;break;case"string":ie[V]="";break;default:H.error(k.localize(2,null,JSON.stringify(Y,void 0,0),V));return}}}return M.create(ie)}j.createTaskIdentifier=U})(z||(e.TaskDefinition=z={}))}),define(De[278],Ce([1,0,8]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q1b=e.$p1b=void 0;class F{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,k.$Y)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$p1b=F;class h extends F{constructor(){super(),this.h=!0,this.i=new k.$3}}e.$q1b=h}),define(De[60],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wz=e.$Vz=e.$Uz=e.$Tz=void 0;class k{static{this.count=0}constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++k.count}}e.$Tz=k;const F=[];function h(m){const E=new k(m);return F[E.nid]=E,E}e.$Uz=h;function L(m){return F[m].sid}e.$Vz=L;class A{constructor(E){this.value=E}}e.$Wz=A}),define(De[6],Ce([1,0,60]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.$xJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$wJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var F;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(F||(e.TextEditorRevealType=F={}));var h;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(h||(e.TabInputKind=h={}));var L;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var E;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(E||(e.CellOutputKind=E={}));var b;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(b||(e.NotebookEditorRevealType=b={}));var R;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class I{static{this.a=0}static mixin(r){return r._id=I.a++,r}}e.$wJ=I;var $;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})($||(e.ISuggestDataDtoField=$={}));var S;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var D;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(D||(e.ExtHostTestingResource=D={})),e.$xJ={MainThreadAuthentication:(0,k.$Uz)("MainThreadAuthentication"),MainThreadBulkEdits:(0,k.$Uz)("MainThreadBulkEdits"),MainThreadClipboard:(0,k.$Uz)("MainThreadClipboard"),MainThreadCommands:(0,k.$Uz)("MainThreadCommands"),MainThreadComments:(0,k.$Uz)("MainThreadComments"),MainThreadConfiguration:(0,k.$Uz)("MainThreadConfiguration"),MainThreadConsole:(0,k.$Uz)("MainThreadConsole"),MainThreadDebugService:(0,k.$Uz)("MainThreadDebugService"),MainThreadDecorations:(0,k.$Uz)("MainThreadDecorations"),MainThreadDiagnostics:(0,k.$Uz)("MainThreadDiagnostics"),MainThreadDialogs:(0,k.$Uz)("MainThreadDiaglogs"),MainThreadDocuments:(0,k.$Uz)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,k.$Uz)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,k.$Uz)("MainThreadTextEditors"),MainThreadEditorInsets:(0,k.$Uz)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,k.$Uz)("MainThreadEditorTabs"),MainThreadErrors:(0,k.$Uz)("MainThreadErrors"),MainThreadTreeViews:(0,k.$Uz)("MainThreadTreeViews"),MainThreadDownloadService:(0,k.$Uz)("MainThreadDownloadService"),MainThreadKeytar:(0,k.$Uz)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,k.$Uz)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,k.$Uz)("MainThreadLanguages"),MainThreadLogger:(0,k.$Uz)("MainThreadLogger"),MainThreadMessageService:(0,k.$Uz)("MainThreadMessageService"),MainThreadOutputService:(0,k.$Uz)("MainThreadOutputService"),MainThreadProgress:(0,k.$Uz)("MainThreadProgress"),MainThreadQuickDiff:(0,k.$Uz)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,k.$Uz)("MainThreadQuickOpen"),MainThreadStatusBar:(0,k.$Uz)("MainThreadStatusBar"),MainThreadSecretState:(0,k.$Uz)("MainThreadSecretState"),MainThreadStorage:(0,k.$Uz)("MainThreadStorage"),MainThreadTelemetry:(0,k.$Uz)("MainThreadTelemetry"),MainThreadTerminalService:(0,k.$Uz)("MainThreadTerminalService"),MainThreadWebviews:(0,k.$Uz)("MainThreadWebviews"),MainThreadWebviewPanels:(0,k.$Uz)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,k.$Uz)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,k.$Uz)("MainThreadCustomEditors"),MainThreadUrls:(0,k.$Uz)("MainThreadUrls"),MainThreadUriOpeners:(0,k.$Uz)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,k.$Uz)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,k.$Uz)("MainThreadWorkspace"),MainThreadFileSystem:(0,k.$Uz)("MainThreadFileSystem"),MainThreadExtensionService:(0,k.$Uz)("MainThreadExtensionService"),MainThreadSCM:(0,k.$Uz)("MainThreadSCM"),MainThreadSearch:(0,k.$Uz)("MainThreadSearch"),MainThreadShare:(0,k.$Uz)("MainThreadShare"),MainThreadTask:(0,k.$Uz)("MainThreadTask"),MainThreadWindow:(0,k.$Uz)("MainThreadWindow"),MainThreadLabelService:(0,k.$Uz)("MainThreadLabelService"),MainThreadNotebook:(0,k.$Uz)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,k.$Uz)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,k.$Uz)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,k.$Uz)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,k.$Uz)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,k.$Uz)("MainThreadInteractive"),MainThreadChat:(0,k.$Uz)("MainThreadChat"),MainThreadInlineChat:(0,k.$Uz)("MainThreadInlineChatShape"),MainThreadTheming:(0,k.$Uz)("MainThreadTheming"),MainThreadTunnelService:(0,k.$Uz)("MainThreadTunnelService"),MainThreadManagedSockets:(0,k.$Uz)("MainThreadManagedSockets"),MainThreadTimeline:(0,k.$Uz)("MainThreadTimeline"),MainThreadTesting:(0,k.$Uz)("MainThreadTesting"),MainThreadLocalization:(0,k.$Uz)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,k.$Uz)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,k.$Uz)("MainThreadIssueReporter")},e.$yJ={ExtHostCommands:(0,k.$Uz)("ExtHostCommands"),ExtHostConfiguration:(0,k.$Uz)("ExtHostConfiguration"),ExtHostDiagnostics:(0,k.$Uz)("ExtHostDiagnostics"),ExtHostDebugService:(0,k.$Uz)("ExtHostDebugService"),ExtHostDecorations:(0,k.$Uz)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,k.$Uz)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,k.$Uz)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,k.$Uz)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,k.$Uz)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,k.$Uz)("ExtHostEditors"),ExtHostTreeViews:(0,k.$Uz)("ExtHostTreeViews"),ExtHostFileSystem:(0,k.$Uz)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,k.$Uz)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,k.$Uz)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,k.$Uz)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,k.$Uz)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,k.$Uz)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,k.$Uz)("ExtHostQuickDiff"),ExtHostStatusBar:(0,k.$Uz)("ExtHostStatusBar"),ExtHostShare:(0,k.$Uz)("ExtHostShare"),ExtHostExtensionService:(0,k.$Uz)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,k.$Uz)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,k.$Uz)("ExtHostTerminalService"),ExtHostSCM:(0,k.$Uz)("ExtHostSCM"),ExtHostSearch:(0,k.$Uz)("ExtHostSearch"),ExtHostTask:(0,k.$Uz)("ExtHostTask"),ExtHostWorkspace:(0,k.$Uz)("ExtHostWorkspace"),ExtHostWindow:(0,k.$Uz)("ExtHostWindow"),ExtHostWebviews:(0,k.$Uz)("ExtHostWebviews"),ExtHostWebviewPanels:(0,k.$Uz)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,k.$Uz)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,k.$Uz)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,k.$Uz)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,k.$Uz)("ExtHostEditorTabs"),ExtHostProgress:(0,k.$Uz)("ExtHostProgress"),ExtHostComments:(0,k.$Uz)("ExtHostComments"),ExtHostSecretState:(0,k.$Uz)("ExtHostSecretState"),ExtHostStorage:(0,k.$Uz)("ExtHostStorage"),ExtHostUrls:(0,k.$Uz)("ExtHostUrls"),ExtHostUriOpeners:(0,k.$Uz)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,k.$Uz)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,k.$Uz)("ExtHostOutputService"),ExtHosLabelService:(0,k.$Uz)("ExtHostLabelService"),ExtHostNotebook:(0,k.$Uz)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,k.$Uz)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,k.$Uz)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,k.$Uz)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,k.$Uz)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,k.$Uz)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,k.$Uz)("ExtHostInteractive"),ExtHostInlineChat:(0,k.$Uz)("ExtHostInlineChatShape"),ExtHostChat:(0,k.$Uz)("ExtHostChat"),ExtHostSemanticSimilarity:(0,k.$Uz)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,k.$Uz)("ExtHostTheming"),ExtHostTunnelService:(0,k.$Uz)("ExtHostTunnelService"),ExtHostManagedSockets:(0,k.$Uz)("ExtHostManagedSockets"),ExtHostAuthentication:(0,k.$Uz)("ExtHostAuthentication"),ExtHostTimeline:(0,k.$Uz)("ExtHostTimeline"),ExtHostTesting:(0,k.$Uz)("ExtHostTesting"),ExtHostTelemetry:(0,k.$Uz)("ExtHostTelemetry"),ExtHostLocalization:(0,k.$Uz)("ExtHostLocalization"),ExtHostIssueReporter:(0,k.$Uz)("ExtHostIssueReporter")}}),define(De[84],Ce([1,0,5,18,6,20]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P$b=e.$O$b=e.$N$b=void 0,e.$N$b=(0,k.$nh)("IExtHostApiDeprecationService");let A=class{constructor(E,b){this.c=b,this.a=new Set,this.b=E.getProxy(h.$xJ.MainThreadTelemetry)}report(E,b,R){const I=this.d(E,b);this.a.has(I)||(this.a.add(I),b.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:b.identifier.value,apiId:E}))}d(E,b){return`${E}-${b.identifier.value}`}};e.$O$b=A,e.$O$b=A=Je([qe(0,L.$zL),qe(1,F.$Pi)],A),e.$P$b=Object.freeze(new class{report(m,E,b){}})}),define(De[279],Ce([1,0,3,6,7,25]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=void 0;class A{constructor(b){this.b=new Map,this.c=[],this.d=new k.$7c,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=b.getProxy(F.$xJ.MainThreadAuthentication)}$setProviders(b){return this.c=b,Promise.resolve()}async getSession(b,R,I,$={}){const S=L.$Fl.toKey(b.identifier),D=[...I].sort().join(" ");return await this.f.getOrCreate(`${S} ${R} ${D}`,async()=>{await this.a.$ensureProvider(R);const p=b.displayName||b.name;return this.a.$getSession(R,I,S,p,$)})}async getSessions(b,R,I){const $=L.$Fl.toKey(b.identifier),S=[...I].sort().join(" ");return await this.g.getOrCreate(`${$} ${S}`,async()=>{await this.a.$ensureProvider(R);const D=b.displayName||b.name;return this.a.$getSessions(R,I,$,D)})}async removeSession(b,R){const I=this.b.get(b);return I?I.provider.removeSession(R):this.a.$removeSession(b,R)}registerAuthenticationProvider(b,R,I,$){if(this.b.get(b))throw new Error(`An authentication provider with id '${b}' is already registered.`);this.b.set(b,{label:R,provider:I,options:$??{supportsMultipleAccounts:!1}}),this.c.find(D=>D.id===b)||this.c.push({id:b,label:R});const S=I.onDidChangeSessions(D=>{this.a.$sendDidChangeSessions(b,{added:D.added??[],changed:D.changed??[],removed:D.removed??[]})});return this.a.$registerAuthenticationProvider(b,R,$?.supportsMultipleAccounts??!1),new h.$zJ(()=>{S.dispose(),this.b.delete(b);const D=this.c.findIndex(p=>p.id===b);D>-1&&this.c.splice(D),this.a.$unregisterAuthenticationProvider(b)})}$createSession(b,R,I){const $=this.b.get(b);if($)return Promise.resolve($.provider.createSession(R,I));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$removeSession(b,R){const I=this.b.get(b);if(I)return Promise.resolve(I.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$getSessions(b,R){const I=this.b.get(b);if(I)return Promise.resolve(I.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${b}`)}$onDidChangeAuthenticationSessions(b,R){return this.d.fire({provider:{id:b,label:R}}),Promise.resolve()}}e.$jac=A;class m{constructor(){this.a=new Map}getOrCreate(b,R){const I=this.a.get(b);if(I)return I;const $=R().finally(()=>this.a.delete(b));return this.a.set(b,$),$}}}),define(De[280],Ce([1,0,6,20,16]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0;let L=class{constructor(m,E){this.a=m.getProxy(k.$xJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:b=>E.getDocument(b)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,E,b){const R=h.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,b?.isRefactoring??!1)}};e.$pac=L,e.$pac=L=Je([qe(0,F.$zL)],L)}),define(De[281],Ce([1,0,17,3,48,4,39,14,192,6,16]),function(me,e,k,F,h,L,A,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=void 0;class I{static{this.a=0}constructor(D,p){this.extension=D,this.provider=p,this.handle=I.a++}}class ${static{this.a=0}constructor(D,p){this.i=p,this.b=new Map,this.d=new Map,this.e=new Map,this.g=new F.$7c,this.onDidPerformUserAction=this.g.event,this.h=D.getProxy(b.$xJ.MainThreadChat)}registerChatProvider(D,p,r){const s=new I(D,r);return this.b.set(s.handle,s),this.h.$registerChatProvider(s.handle,p),(0,L.$jb)(()=>{this.h.$unregisterChatProvider(s.handle),this.b.delete(s.handle)})}transferChatSession(D,p){const r=h.Iterable.find(this.e.keys(),s=>this.e.get(s)===D)??0;typeof r=="number"&&this.h.$transferChatSession(r,p)}addChatRequest(D){this.h.$addRequest(D)}sendInteractiveRequestToProvider(D,p){this.h.$sendRequestToProvider(D,p)}async $prepareChat(D,p,r){const s=this.b.get(D);if(!s)return;const c=await s.provider.prepareSession(p,r);if(!c)return;const f=$.a++;return this.e.set(f,c),{id:f,requesterUsername:c.requester?.name,requesterAvatarIconUri:c.requester?.icon,responderUsername:c.responder?.name,responderAvatarIconUri:c.responder?.icon,inputPlaceholder:c.inputPlaceholder}}async $resolveRequest(D,p,r,s){const c=this.b.get(D);if(!c)return;const f=this.e.get(p);if(!f||!c.provider.resolveRequest)return;const y=await c.provider.resolveRequest(f,r,s);if(y)return{message:typeof y.message=="string"?y.message:R.ChatReplyFollowup.from(y.message)}}async $provideWelcomeMessage(D,p){const r=this.b.get(D);if(!r||!r.provider.provideWelcomeMessage)return;const s=await r.provider.provideWelcomeMessage(p);if(s)return s.map(c=>typeof c=="string"?c:c.map(f=>R.ChatReplyFollowup.from(f)))}async $provideFollowups(D,p,r){const s=this.b.get(D);if(!s)return;const c=this.e.get(p);return!c||!s.provider.provideFollowups?void 0:(await s.provider.provideFollowups(c,r))?.map(y=>R.ChatFollowup.from(y))}$removeRequest(D,p,r){const s=this.b.get(D);if(!s)return;const c=this.e.get(p);c&&s.provider.removeRequest&&s.provider.removeRequest(c,r)}async $provideReply(D,p,r,s){const c=this.b.get(D);if(!c)return;const f=this.e.get(p);if(!f)return;const y={session:f,message:typeof r.message=="string"?r.message:R.ChatReplyFollowup.to(r.message)},C=A.$3c.create(!1);let i;const a={report:o=>{if(!s.isCancellationRequested)if(typeof i>"u"&&(i=C.elapsed()),"responseId"in o)this.h.$acceptResponseProgress(D,p,{requestId:o.responseId});else if("placeholder"in o&&"resolvedContent"in o){const g=Promise.all([this.h.$acceptResponseProgress(D,p,{placeholder:o.placeholder}),o.resolvedContent]);(0,k.$ig)(g,s).then(u=>{if(!u)return;const[d,v]=u;this.h.$acceptResponseProgress(D,p,v,d??void 0)})}else this.h.$acceptResponseProgress(D,p,o)}};let n;try{n=await c.provider.provideResponseWithProgress(y,a,s),n||(n={errorDetails:{message:(0,E.localize)(0,null)}})}catch(o){n={errorDetails:{message:(0,E.localize)(1,null,o.message),responseIsIncomplete:!0}},this.i.error(o)}try{if(f.saveState&&this.e.has(p)){const o=f.saveState();this.h.$acceptChatState(p,o)}}catch(o){this.i.warn(o)}const t={firstProgress:i??0,totalElapsed:C.elapsed()};return{errorDetails:n.errorDetails,timings:t}}async $provideSlashCommands(D,p,r){const s=this.b.get(D);if(!s)return;const c=this.e.get(p);return!c||!s.provider.provideSlashCommands?void 0:(await s.provider.provideSlashCommands(c,r))?.map(y=>({...y,kind:R.CompletionItemKind.from(y.kind)}))}$releaseSession(D){this.e.delete(D)}async $onDidPerformUserAction(D){this.g.fire(D)}registerSlashCommandProvider(D,p,r){const s=new I(D,r);return this.d.set(s.handle,s),this.h.$registerSlashCommandProvider(s.handle,p),(0,L.$jb)(()=>{this.h.$unregisterSlashCommandProvider(s.handle),this.d.delete(s.handle)})}async $provideProviderSlashCommands(D,p){const r=this.d.get(D);return r?(await r.provider.provideSlashCommands(p))?.map(c=>({...c,kind:R.CompletionItemKind.from(c.kind)})):void 0}async $resolveSlashCommand(D,p,r){const s=this.d.get(D);if(!s)return;const c=await s.provider.resolveSlashCommand(p,r);return(0,m.$Ae)(c)}}e.$Dac=$}),define(De[282],Ce([1,0,6]),function(me,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S$b=void 0;class F{constructor(L){const A=L.getProxy(k.$xJ.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$S$b=F}),define(De[36],Ce([1,0,14,7,16,23,6,19,18,73,33,56,2,4,5,20,139,22,60,45,39,80,83]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=void 0;let a=class{#e;#t;#i;constructor(d,v,l){this.b=new Map,this.c=new Map,this.#e=d.getProxy(A.$xJ.MainThreadCommands),this.d=v,this.#i=l,this.#t=d.getProxy(A.$xJ.MainThreadTelemetry),this.converter=new n(this,w=>{const P=this.c.get(w);return P?.result===o.Void?P:void 0},v),this.f=[{processArgument(w){return(0,b.$Wg)(w)}},{processArgument(w){return(0,L.$Hm)(w,function(P){if(R.$Mr.isIRange(P))return h.Range.to(P);if(I.$Lr.isIPosition(P))return h.Position.to(P);if(R.$Mr.isIRange(P.range)&&$.URI.isUri(P.uri))return h.location.to(P);if(P instanceof s.$Jb)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(d){this.f.push(d)}registerApiCommand(d){const v=this.registerCommand(!1,d.id,async(...l)=>{const w=d.args.map((M,N)=>{if(!M.validate(l[N]))throw new Error(`Invalid argument '${M.name}' when running '${d.id}', received: ${l[N]}`);return M.convert(l[N])}),P=await this.executeCommand(d.internalId,...w);return d.result.convert(P,l,this.converter)},void 0,{description:d.description,args:d.args,returns:d.result.description});return this.c.set(d.id,d),new F.$zJ(()=>{v.dispose(),this.c.delete(d.id)})}registerCommand(d,v,l,w,P,M){if(this.d.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this.b.has(v))throw new Error(`command '${v}' already exists`);return this.b.set(v,{callback:l,thisArg:w,description:P,extension:M}),d&&this.#e.$registerCommand(v),new F.$zJ(()=>{this.b.delete(v)&&d&&this.#e.$unregisterCommand(v)})}executeCommand(d,...v){return this.d.trace("ExtHostCommands#executeCommand",d),this.g(d,v,!0)}async g(d,v,l){if(this.b.has(d))return this.#e.$fireCommandActivationEvent(d),this.h(d,v,!1);{let w=!1;const P=(0,L.$Hm)(v,function(M){if(M instanceof F.$AJ)return h.Position.from(M);if(M instanceof F.$BJ)return h.Range.from(M);if(M instanceof F.$LJ)return h.location.from(M);if(F.$XK.isNotebookRange(M))return h.NotebookRange.from(M);if(M instanceof ArrayBuffer)return w=!0,s.$Jb.wrap(new Uint8Array(M));if(M instanceof Uint8Array)return w=!0,s.$Jb.wrap(M);if(M instanceof s.$Jb)return w=!0,M;if(!Array.isArray(M))return M});try{const M=await this.#e.$executeCommand(d,w?new c.$Wz(P):P,l);return(0,b.$Wg)(M)}catch(M){if(M instanceof Error&&M.message==="$executeCommand:retry")return this.g(d,v,!1);throw M}}}async h(d,v,l){const w=this.b.get(d);if(!w)throw new Error("Unknown command");const{callback:P,thisArg:M,description:N}=w;if(N)for(let z=0;z<N.args.length;z++)try{(0,k.$ze)(v[z],N.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${d}' failed. Illegal argument '${N.args[z].name}' - ${N.args[z].description}`)}const T=y.$3c.create();try{return await P.apply(M,v)}catch(z){if(d===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...v);j&&(d=j.command)}if(this.d.error(z,d,w.extension?.identifier),!l)throw z;if(w.extension?.identifier){const j=this.#i.onExtensionError(w.extension.identifier,z);this.d.trace("forwarded error to extension?",j,w.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.$$h)(z)),this.id=d,this.source=w.extension?.displayName??w.extension?.name}}}finally{this.j(w,d,T.elapsed())}}j(d,v,l){d.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:d.extension.identifier.value,id:new C.$Zn(v),duration:l})}$executeContributedCommand(d,...v){this.d.trace("ExtHostCommands#$executeContributedCommand",d);const l=this.b.get(d);return l?(v=v.map(w=>this.f.reduce((P,M)=>M.processArgument(P,l.extension?.identifier),w)),this.h(d,v,!0)):Promise.reject(new Error(`Contributed command '${d}' does not exist.`))}getCommands(d=!1){return this.d.trace("ExtHostCommands#getCommands",d),this.#e.$getCommands().then(v=>(d&&(v=v.filter(l=>l[0]!=="_")),v))}$getContributedCommandHandlerDescriptions(){const d=Object.create(null);for(const[v,l]of this.b){const{description:w}=l;w&&(d[v]=w)}return Promise.resolve(d)}};e.$UL=a,e.$UL=a=Je([qe(0,p.$zL),qe(1,E.$Pi),qe(2,i.$TL)],a),e.$VL=(0,D.$nh)("IExtHostCommands");class n{constructor(d,v,l){this.d=d,this.f=v,this.g=l,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(d,v){if(!d)return;const l={$ident:void 0,id:d.command,title:d.title,tooltip:d.tooltip};if(!d.command)return l;const w=this.f(d.command);if(w)l.id=w.internalId,l.arguments=w.args.map((P,M)=>P.convert(d.arguments&&d.arguments[M]));else if((0,m.$pf)(d.arguments)){const P=`${d.command}/${++this.c}`;this.b.set(P,d),v.add((0,S.$jb)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),l.$ident=P,l.id=this.delegatingCommandId,l.arguments=[P],this.g.trace("CommandsConverter#CREATE",d.command,P)}return l}fromInternal(d){return typeof d.$ident=="string"?this.b.get(d.$ident):{command:d.id,title:d.title,arguments:d.arguments}}getActualCommand(...d){return this.b.get(d[0])}h(...d){const v=this.getActualCommand(...d);return this.g.trace("CommandsConverter#EXECUTE",d[0],v?v.command:"MISSING"),v?this.d.executeCommand(v.command,...v.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${d[0]}`)}}e.$WL=n;class t{static{this.Uri=new t("uri","Uri of a text document",d=>$.URI.isUri(d),d=>d)}static{this.Position=new t("position","A position in a text document",d=>F.$AJ.isPosition(d),h.Position.from)}static{this.Range=new t("range","A range in a text document",d=>F.$BJ.isRange(d),h.Range.from)}static{this.Selection=new t("selection","A selection in a text document",d=>F.$CJ.isSelection(d),h.Selection.from)}static{this.Number=new t("number","",d=>typeof d=="number",d=>d)}static{this.String=new t("string","",d=>typeof d=="string",d=>d)}static{this.CallHierarchyItem=new t("item","A call hierarchy item",d=>d instanceof F.$WJ,h.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new t("item","A type hierarchy item",d=>d instanceof F.$fL,h.TypeHierarchyItem.from)}static{this.TestItem=new t("testItem","A VS Code TestItem",d=>d instanceof r.$ML,h.TestItem.from)}constructor(d,v,l,w){this.name=d,this.description=v,this.validate=l,this.convert=w}optional(){return new t(this.name,`(optional) ${this.description}`,d=>d==null||this.validate(d),d=>d===void 0?void 0:d===null?null:this.convert(d))}with(d,v){return new t(d??this.name,v??this.description,this.validate,this.convert)}}e.$XL=t;class o{static{this.Void=new o("no result",d=>d)}constructor(d,v){this.description=d,this.convert=v}}e.$YL=o;class g{constructor(d,v,l,w,P){this.id=d,this.internalId=v,this.description=l,this.args=w,this.result=P}}e.$ZL=g}),define(De[283],Ce([1,0,19,15,2,77,123,47,127,36,16,7]),function(me,e,k,F,h,L,A,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R$b=void 0;const $=[new b.$ZL("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[b.$XL.Uri,b.$XL.Position],new b.$YL("A promise that resolves to an array of DocumentHighlight-instances.",D(R.DocumentHighlight.to))),new b.$ZL("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[b.$XL.Uri],new b.$YL("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,s)=>{if((0,k.$of)(r))return;class c extends I.$QJ{static to(y){const C=new c(y.name,R.SymbolKind.to(y.kind),y.containerName||"",new I.$LJ(s[0],R.Range.to(y.range)));return C.detail=y.detail,C.range=C.location.range,C.selectionRange=R.Range.to(y.selectionRange),C.children=y.children?y.children.map(c.to):[],C}}return r.map(c.to)})),new b.$ZL("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[b.$XL.Uri,new b.$XL("options","Formatting options",r=>!0,r=>r)],new b.$YL("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new b.$ZL("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[b.$XL.Uri,b.$XL.Range,new b.$XL("options","Formatting options",r=>!0,r=>r)],new b.$YL("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new b.$ZL("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[b.$XL.Uri,b.$XL.Position,new b.$XL("ch","Trigger character",r=>typeof r=="string",r=>r),new b.$XL("options","Formatting options",r=>!0,r=>r)],new b.$YL("A promise that resolves to an array of TextEdits.",D(R.TextEdit.to))),new b.$ZL("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[b.$XL.Uri,b.$XL.Position],new b.$YL("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$ZL("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[b.$XL.Uri,b.$XL.Position],new b.$YL("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$ZL("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[b.$XL.Uri,b.$XL.Position],new b.$YL("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$ZL("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[b.$XL.Uri,b.$XL.Position],new b.$YL("A promise that resolves to an array of Location or LocationLink instances.",p)),new b.$ZL("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[b.$XL.Uri,b.$XL.Position],new b.$YL("A promise that resolves to an array of Location-instances.",D(R.location.to))),new b.$ZL("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[b.$XL.Uri,b.$XL.Position],new b.$YL("A promise that resolves to an array of Hover-instances.",D(R.Hover.to))),new b.$ZL("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[b.$XL.Uri,new b.$XL("position","A position in a text document",r=>Array.isArray(r)&&r.every(s=>I.$AJ.isPosition(s)),r=>r.map(R.Position.from))],new b.$YL("A promise that resolves to an array of ranges.",r=>r.map(s=>{let c;for(const f of s.reverse())c=new I.$VJ(R.Range.to(f),c);return c}))),new b.$ZL("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[b.$XL.String.with("query","Search string")],new b.$YL("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(R.WorkspaceSymbol.to))),new b.$ZL("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[b.$XL.Uri,b.$XL.Position],new b.$YL("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(R.CallHierarchyItem.to))),new b.$ZL("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[b.$XL.CallHierarchyItem],new b.$YL("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(R.CallHierarchyIncomingCall.to))),new b.$ZL("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[b.$XL.CallHierarchyItem],new b.$YL("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(R.CallHierarchyOutgoingCall.to))),new b.$ZL("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[b.$XL.Uri,b.$XL.Position],new b.$YL("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:R.Range.to(r.range),placeholder:r.text}})),new b.$ZL("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[b.$XL.Uri,b.$XL.Position,b.$XL.String.with("newName","The new symbol name")],new b.$YL("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return R.WorkspaceEdit.to(r)}})),new b.$ZL("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[b.$XL.Uri,b.$XL.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new b.$YL("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(R.DocumentLink.to))),new b.$ZL("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[b.$XL.Uri],new b.$YL("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$PK(r.tokenTypes,r.tokenModifiers)})),new b.$ZL("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[b.$XL.Uri],new b.$YL("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$A8)(r);if(s.type==="full")return new I.$RK(s.data,void 0)})),new b.$ZL("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[b.$XL.Uri,b.$XL.Range.optional()],new b.$YL("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new I.$PK(r.tokenTypes,r.tokenModifiers)})),new b.$ZL("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[b.$XL.Uri,b.$XL.Range],new b.$YL("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const s=(0,A.$A8)(r);if(s.type==="full")return new I.$RK(s.data,void 0)})),new b.$ZL("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[b.$XL.Uri,b.$XL.Position,b.$XL.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),b.$XL.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new b.$YL("A promise that resolves to a CompletionList-instance.",(r,s,c)=>{if(!r)return new I.$8J([]);const f=r.suggestions.map(y=>R.CompletionItem.to(y,c));return new I.$8J(f,r.incomplete)})),new b.$ZL("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[b.$XL.Uri,b.$XL.Position,b.$XL.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new b.$YL("A promise that resolves to SignatureHelp.",r=>{if(r)return R.SignatureHelp.to(r)})),new b.$ZL("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[b.$XL.Uri,b.$XL.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new b.$YL("A promise that resolves to an array of CodeLens-instances.",(r,s,c)=>D(f=>new I.$ZJ(R.Range.to(f.range),f.command&&c.fromInternal(f.command)))(r))),new b.$ZL("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[b.$XL.Uri,new b.$XL("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>I.$BJ.isRange(r),r=>I.$CJ.isSelection(r)?R.Selection.from(r):R.Range.from(r)),b.$XL.String.with("kind","Code action kind to return code actions for").optional(),b.$XL.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new b.$YL("A promise that resolves to an array of Command-instances.",(r,s,c)=>D(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(f.command)}else{const y=new I.$SJ(f.title,f.kind?new I.$TJ(f.kind):void 0);return f.edit&&(y.edit=R.WorkspaceEdit.to(f.edit)),f.command&&(y.command=c.fromInternal(f.command)),y.isPreferred=f.isPreferred,y}})(r))),new b.$ZL("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[b.$XL.Uri],new b.$YL("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(s=>new I.$bK(R.Range.to(s.range),R.Color.to(s.color))):[])),new b.$ZL("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new b.$XL("color","The color to show and insert",r=>r instanceof I.$aK,R.Color.from),new b.$XL("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:R.Range.from(r.range)}))],new b.$YL("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(R.ColorPresentation.to):[])),new b.$ZL("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[b.$XL.Uri,b.$XL.Range],new b.$YL("A promise that resolves to an array of Inlay objects",(r,s,c)=>r.map(R.InlayHint.to.bind(void 0,c)))),new b.$ZL("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[b.$XL.Uri],new b.$YL("A promise that resolves to an array of FoldingRange objects",(r,s)=>{if(r)return r.map(R.FoldingRange.to)})),new b.$ZL("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new b.$YL("A promise that resolves to an array of NotebookContentProvider static info objects.",D(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(s=>R.NotebookExclusiveDocumentPattern.to(s))})))),new b.$ZL("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[b.$XL.Uri,b.$XL.Range],new b.$YL("A promise that resolves to an array of InlineValue objects",r=>r.map(R.InlineValue.to))),new b.$ZL("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new b.$XL("uriOrString","Uri-instance or string (only http/https)",r=>h.URI.isUri(r)||typeof r=="string"&&(0,E.$7Y)(r,F.Schemas.http,F.Schemas.https),r=>r),new b.$XL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[R.ViewColumn.from(r),void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional(),b.$XL.String.with("label","").optional()],b.$YL.Void),new b.$ZL("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[b.$XL.Uri.with("resource","Resource to open"),b.$XL.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new b.$XL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[R.ViewColumn.from(r),void 0]:[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)])).optional()],b.$YL.Void),new b.$ZL("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[b.$XL.Uri.with("left","Left-hand side resource of the diff editor"),b.$XL.Uri.with("right","Right-hand side resource of the diff editor"),b.$XL.String.with("title","Human readable title for the diff editor").optional(),new b.$XL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[R.ViewColumn.from(r.viewColumn),R.TextEditorOpenOptions.from(r)]).optional()],b.$YL.Void),new b.$ZL("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[b.$XL.Uri,b.$XL.Position],new b.$YL("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(R.TypeHierarchyItem.to))),new b.$ZL("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[b.$XL.TypeHierarchyItem],new b.$YL("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(R.TypeHierarchyItem.to))),new b.$ZL("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[b.$XL.TypeHierarchyItem],new b.$YL("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(R.TypeHierarchyItem.to))),new b.$ZL("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[b.$XL.TestItem],b.$YL.Void),new b.$ZL("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[b.$XL.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],b.$YL.Void),new b.$ZL("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[b.$XL.String.with("name","The context key name"),new b.$XL("value","The context key value",()=>!0,r=>r)],b.$YL.Void)];class S{static register(s){$.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",m.$ui)}}e.$R$b=S;function D(r){return s=>{if(Array.isArray(s))return s.map(r)}}function p(r){if(!Array.isArray(r))return;const s=[];for(const c of r)L.$os(c)?s.push(R.DefinitionLink.to(c)):s.push(R.location.to(c));return s}}),define(De[284],Ce([1,0,17,66,3,4,2,77,25,16,7,6,27,14]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=void 0;function D(p,r,s){const c=p.getProxy(I.$xJ.MainThreadComments);class f{static{this.a=0}constructor(){this.b=new Map,this.c=new E.$Hl,r.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const d=this.b.get(u.handle);return d?d.value:u}else if(u&&u.$mid===7){const d=this.b.get(u.commentControlHandle);if(!d)return u;const v=d.getCommentThread(u.commentThreadHandle);return v?v.value:u}else if(u&&(u.$mid===9||u.$mid===8)){const d=this.b.get(u.thread.commentControlHandle);if(!d)return u;const v=d.getCommentThread(u.thread.commentThreadHandle);return v?u.$mid===8?v.value:{thread:v.value,text:u.text}:u}else if(u&&u.$mid===10){const d=this.b.get(u.thread.commentControlHandle);if(!d)return u;const v=d.getCommentThread(u.thread.commentThreadHandle);if(!v)return u;const l=u.commentUniqueId,w=v.getCommentByUniqueId(l);return w||u}else if(u&&u.$mid===11){const d=this.b.get(u.thread.commentControlHandle);if(!d)return u;const v=d.getCommentThread(u.thread.commentThreadHandle);if(!v)return u;const l=u.text,w=u.commentUniqueId,P=v.getCommentByUniqueId(w);return P?(typeof P.body=="string"?P.body=l:P.body=new R.$1J(l),P):u}return u}})}createCommentController(u,d,v){const l=f.a++,w=new C(u,l,d,v);this.b.set(w.handle,w);const P=this.c.get(u.identifier)||[];return P.push(w),this.c.set(u.identifier,P),w.value}$createCommentThreadTemplate(u,d,v){const l=this.b.get(u);l&&l.$createCommentThreadTemplate(d,v)}async $updateCommentThreadTemplate(u,d,v){const l=this.b.get(u);l&&l.$updateCommentThreadTemplate(d,v)}$deleteCommentThread(u,d){this.b.get(u)?.$deleteCommentThread(d)}$provideCommentingRanges(u,d,v){const l=this.b.get(u);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const w=s.getDocument(A.URI.revive(d));return(0,k.$mg)(async()=>{const P=await l.commentingRangeProvider.provideCommentingRanges(w,v);let M;return Array.isArray(P)?M={ranges:P,fileComments:!1}:P?M={ranges:P.ranges||[],fileComments:P.fileComments||!1}:M=(0,S.$Ae)(P),M}).then(P=>{let M;return P&&(M={ranges:P.ranges.map(N=>b.Range.from(N)),fileComments:P.fileComments}),M})}$toggleReaction(u,d,v,l,w){const P=this.b.get(u);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,k.$mg)(()=>{const M=P.getCommentThread(d);if(M){const N=M.getCommentByUniqueId(l.uniqueIdInThread);if(P!==void 0&&N&&P.reactionHandler)return P.reactionHandler(N,n(w))}return Promise.resolve(void 0)})}}class y{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,d,v,l,w,P,M,N){this.m=d,this.n=v,this.o=l,this.p=w,this.q=P,this.extensionDescription=M,this.r=N,this.handle=y.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new h.$7c,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.$mb,this.l.value=new L.$kb,this.n===void 0&&(this.n=`${u}.${this.handle}`),c.$createCommentThread(d,this.handle,this.n,this.o,b.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{c.$deleteCommentThread(d,this.handle)}});const T=this;this.value={get uri(){return T.uri},get range(){return T.range},set range(z){T.range=z},get comments(){return T.comments},set comments(z){T.comments=z},get collapsibleState(){return T.collapsibleState},set collapsibleState(z){T.collapsibleState=z},get canReply(){return T.canReply},set canReply(z){T.canReply=z},get contextValue(){return T.contextValue},set contextValue(z){T.contextValue=z},get label(){return T.label},set label(z){T.label=z},get state(){return T.state},set state(z){T.state=z},dispose:()=>{T.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.$kb);const u=v=>Object.prototype.hasOwnProperty.call(this.b,v),d={};u("range")&&(d.range=b.Range.from(this.p)),u("label")&&(d.label=this.label),u("contextValue")&&(d.contextValue=this.contextValue??null),u("comments")&&(d.comments=this.q.map(v=>i(this,v,this.k,this.extensionDescription))),u("collapsibleState")&&(d.collapseState=t(this.g)),u("canReply")&&(d.canReply=this.canReply),u("state")&&(d.state=o(this.h)),u("isTemplate")&&(d.isTemplate=this.r),this.b={},c.$updateCommentThread(this.m,this.handle,this.n,this.o,d)}getCommentByUniqueId(u){for(const d of this.k){const v=d[0],l=d[1];if(u===l)return v}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}Je([(0,F.$Sg)(100)],y.prototype,"eventuallyUpdateCommentThread",null);class C{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,c.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,c.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,c.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(u,d,v,l){this.f=u,this.g=d,this.h=v,this.i=l,this.a=new Map,c.$registerCommentController(this.handle,v,l);const w=this;this.value=Object.freeze({id:w.id,label:w.label,get options(){return w.options},set options(P){w.options=P},get commentingRangeProvider(){return w.commentingRangeProvider},set commentingRangeProvider(P){w.commentingRangeProvider=P},get reactionHandler(){return w.reactionHandler},set reactionHandler(P){w.reactionHandler=P},createCommentThread(P,M,N){return w.createCommentThread(P,M,N).value},dispose:()=>{w.dispose()}}),this.e=[],this.e.push({dispose:()=>{c.$unregisterCommentController(this.handle)}})}createCommentThread(u,d,v){d===void 0&&(0,$.$wF)(this.f,"fileComments");const l=new y(this.id,this.handle,void 0,u,d,v,this.f,!1);return this.a.set(l.handle,l),l}$createCommentThreadTemplate(u,d){const v=new y(this.id,this.handle,void 0,A.URI.revive(u),b.Range.to(d),[],this.f,!0);return v.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(v.handle,v),v}$updateCommentThreadTemplate(u,d){const v=this.a.get(u);v&&(v.range=b.Range.to(d))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.e.forEach(u=>u.dispose())}}function i(g,u,d,v){let l=d.get(u);return l||(l=++g.commentHandle,d.set(u,l)),u.state!==void 0&&(0,$.$wF)(v,"commentsDraftState"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:l,body:typeof u.body=="string"?u.body:b.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(w=>a(w)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function a(g){return{label:g.label,iconPath:g.iconPath?b.$yL(g.iconPath):void 0,count:g.count,hasReacted:g.authorHasReacted}}function n(g){return{label:g.label||"",count:g.count||0,iconPath:g.iconPath?A.URI.revive(g.iconPath):"",authorHasReacted:g.hasReacted||!1}}function t(g){if(g!==void 0)switch(g){case R.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function o(g){if(g!==void 0)switch(g){case R.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new f}e.$T$b=D}),define(De[285],Ce([1,0,23,6,26,20]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;let A=class{constructor(R,I){this.a=R.getProxy(F.$xJ.MainThreadConsole),this.b=I.consoleForward.includeStack,this.c=I.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,I){const $=this,S=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){$.e(R,I,S,arguments)}})}e(R,I,$,S){this.a.$logExtensionHostMessage({type:"__$console",severity:I,arguments:E(S,this.b)}),this.c&&this.f(R,$,S)}};e.$Lac=A,e.$Lac=A=Je([qe(0,L.$zL),qe(1,h.$PL)],A);const m=1e5;function E(b,R){const I=[];if(b.length)for(let $=0;$<b.length;$++){let S=b[$];if(typeof S>"u")S="undefined";else if(S instanceof Error){const D=S;D.stack?S=D.stack:S=D.toString()}I.push(S)}if(R){const $=new Error().stack;$&&I.push({__$stack:$.split(`
`).slice(3).join(`
`)})}try{const $=(0,k.$Km)(I);return $.length>m?"Output omitted for a large object that exceeds the limits":$}catch($){return`Output omitted for an object that cannot be inspected ('${$.toString()}')`}}}),define(De[142],Ce([1,0,2,6,7,5,20,18,19,12,13,27]),function(me,e,k,F,h,L,A,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=e.$U_b=void 0;let $=class Zi{static{this.c=0}static{this.d=250}constructor(D,p){this.h=p,this.f=new Map,this.g=D.getProxy(F.$xJ.MainThreadDecorations)}registerFileDecorationProvider(D,p){const r=Zi.c++;this.f.set(r,{provider:D,extensionDescription:p}),this.g.$registerDecorationProvider(r,p.identifier.value);const s=D.onDidChangeFileDecorations&&D.onDidChangeFileDecorations(c=>{if(!c){this.g.$onDidChange(r,null);return}const f=(0,E.$If)(c);if(f.length<=Zi.d){this.g.$onDidChange(r,f);return}this.h.warn("[Decorations] CAPPING events from decorations provider",p.identifier.value,f.length);const y=f.map(a=>({uri:a,rank:(0,b.$od)(a.path,"/")})),C=(0,E.$gf)(y,(a,n)=>a.rank-n.rank||(0,b.$Ed)(a.uri.path,n.uri.path)),i=[];e:for(const a of C){let n;for(const t of a){const o=(0,R.$dc)(t.uri.path);if(n!==o&&(n=o,i.push(t.uri)>=Zi.d))break e}}this.g.$onDidChange(r,i)});return new h.$zJ(()=>{s?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(D,p,r){if(!this.f.has(D))return Object.create(null);const s=Object.create(null),{provider:c,extensionDescription:f}=this.f.get(D);return await Promise.all(p.map(async y=>{try{const{uri:C,id:i}=y,a=await Promise.resolve(c.provideFileDecoration(k.URI.revive(C),r));if(!a)return;try{h.$VK.validate(a),a.badge&&typeof a.badge!="string"&&(0,I.$wF)(f,"codiconDecoration"),s[i]=[a.propagate,a.tooltip,a.badge,a.color]}catch(n){this.h.warn(`INVALID decoration from extension '${f.identifier.value}': ${n}`)}}catch(C){this.h.error(C)}})),s}};e.$U_b=$,e.$U_b=$=Je([qe(0,A.$zL),qe(1,m.$Pi)],$),e.$V_b=(0,L.$nh)("IExtHostDecorations")}),define(De[286],Ce([1,0,193,126,2,6,7,16,3,18,28,51]),function(me,e,k,F,h,L,A,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M$b=e.$L$b=void 0;class ${#e;#t;#i;constructor(p,r,s,c,f,y,C,i){this.d=p,this.e=r,this.f=s,this.g=c,this.h=f,this.c=!1,this.f=Math.max(c,s),this.#i=new R.$li(a=>y.getComparisonKey(a)),this.#e=C,this.#t=i}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(p,r){if(!p){this.clear();return}this.j();let s=[];if(h.URI.isUri(p)){if(!r){this.delete(p);return}this.#i.set(p,r.slice()),s=[p]}else if(Array.isArray(p)){s=[];let y;p=[...p].sort($.k);for(const C of p){const[i,a]=C;if((!y||i.toString()!==y.toString())&&(y&&this.#i.get(y).length===0&&this.#i.delete(y),y=i,s.push(i),this.#i.set(i,[])),a)this.#i.get(i)?.push(...a);else{const n=this.#i.get(i);n&&(n.length=0)}}}if(this.#t.fire(s),!this.#e)return;const c=[];let f=0;for(const y of s){let C=[];const i=this.#i.get(y);if(i)if(i.length>this.g){C=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const t of i)if(t.severity===a[n]&&C.push({...m.Diagnostic.from(t),modelVersionId:this.h(y)})===this.g)break e;C.push({severity:F.MarkerSeverity.Info,message:(0,k.localize)(0,null,i.length-this.g),startLineNumber:C[C.length-1].startLineNumber,startColumn:C[C.length-1].startColumn,endLineNumber:C[C.length-1].endLineNumber,endColumn:C[C.length-1].endColumn})}else C=i.map(a=>({...m.Diagnostic.from(a),modelVersionId:this.h(y)}));if(c.push([y,C]),f+=C.length,f>this.f)break}this.#e.$changeMany(this.e,c)}delete(p){this.j(),this.#t.fire([p]),this.#i.delete(p),this.#e?.$changeMany(this.e,[[p,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(p,r){this.j();for(const[s,c]of this)p.call(r,s,c,this)}*[Symbol.iterator](){this.j();for(const p of this.#i.keys())yield[p,this.get(p)]}get(p){this.j();const r=this.#i.get(p);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(p){return this.j(),Array.isArray(this.#i.get(p))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(p,r){return p[0].toString()<r[0].toString()?-1:p[0].toString()>r[0].toString()?1:0}}e.$L$b=$;let S=class li{static{this.c=0}static{this.d=1e3}static{this.e=1.1*li.d}static _mapper(p){const r=new R.$li;for(const s of p)r.set(s,s);return{uris:Object.freeze(Array.from(r.values()))}}constructor(p,r,s,c){this.j=r,this.k=s,this.l=c,this.g=new Map,this.h=new E.$$c({merge:f=>f.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this.h.event,li._mapper),this.f=p.getProxy(L.$xJ.MainThreadDiagnostics)}createDiagnosticCollection(p,r){const{g:s,f:c,h:f,j:y,k:C,l:i}=this,a=new class{$changeMany(o,g){c.$changeMany(o,g),y.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,o,g.length===0?"CLEARING":g)}$clear(o){c.$clear(o),y.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,o)}dispose(){c.dispose()}};let n;if(!r)r="_generated_diagnostic_collection_name_#"+li.c++,n=r;else if(!s.has(r))n=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do n=r+li.c++;while(s.has(n))}return new class extends ${constructor(){super(r,n,li.e,li.d,o=>i.getDocument(o)?.version,C.extUri,a,f),s.set(n,this)}dispose(){super.dispose(),s.delete(n)}}}getDiagnostics(p){if(p)return this.m(p);{const r=new Map,s=[];for(const c of this.g.values())c.forEach((f,y)=>{let C=r.get(f.toString());typeof C>"u"&&(C=s.length,r.set(f.toString(),C),s.push([f,[]])),s[C][1]=s[C][1].concat(...y)});return s}}m(p){let r=[];for(const s of this.g.values())s.has(p)&&(r=r.concat(s.get(p)));return r}$acceptMarkersChange(p){if(!this.n){const r="_generated_mirror",s=new $(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,c=>{},this.k.extUri,void 0,this.h);this.g.set(r,s),this.n=s}for(const[r,s]of p)this.n.set(h.URI.revive(r),s.map(m.Diagnostic.to))}};e.$M$b=S,e.$M$b=S=Je([qe(1,b.$Pi),qe(2,I.$K$b)],S)}),define(De[287],Ce([1,0,2,6,27]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=void 0;class L{constructor(m){this.a=m.getProxy(F.$xJ.MainThreadDialogs)}showOpenDialog(m,E){return E?.allowUIResources&&(0,h.$wF)(m,"showLocal"),this.a.$showOpenDialog(E).then(b=>b?b.map(R=>k.URI.revive(R)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(E=>E?k.URI.revive(E):void 0)}}e.$2$b=L}),define(De[288],Ce([1,0,8,2,7,6,15,21,12]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=void 0;class b{static{this.a=0}constructor(I,$,S){this.d=$,this.e=S,this.b=new Map,this.c=I.getProxy(L.$xJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,$){if(Object.keys(A.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const S=b.a++;this.b.set(S,$),this.c.$registerTextContentProvider(S,I);let D;return typeof $.onDidChange=="function"&&(D=$.onDidChange(p=>{if(p.scheme!==I){this.e.warn(`Provider for scheme '${I}' is firing event for schema '${p.scheme}' which will be IGNORED`);return}this.d.getDocument(p)&&this.$provideTextDocumentContent(S,p).then(r=>{if(!r&&typeof r!="string")return;const s=this.d.getDocument(p);if(!s)return;const c=(0,E.$zd)(r);if(!s.equalLines(c))return this.c.$onVirtualDocumentChange(p,r)},k.$Y)})),new h.$zJ(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(I,$){const S=this.b.get(I);return S?Promise.resolve(S.provideTextDocumentContent(F.URI.revive($),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${$.scheme}`))}}e.$3$b=b}),define(De[289],Ce([1,0,3,4,2,6,135,16,14,23,7,8]),function(me,e,k,F,h,L,A,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=void 0;class ${constructor(D,p){this.a=new k.$7c({onListenerError:I.$Z}),this.b=new k.$7c({onListenerError:I.$Z}),this.c=new k.$7c({onListenerError:I.$Z}),this.d=new k.$7c({onListenerError:I.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new F.$kb,this.h=new Map,this.f=D.getProxy(L.$xJ.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(r=>{for(const s of r)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const s of r)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(D){if(!D)return;const p=this.g.getDocument(D);if(p)return p}getDocument(D){const p=this.getDocumentData(D);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${D}'`);return p.document}ensureDocumentData(D){const p=this.g.getDocument(D);if(p)return Promise.resolve(p);let r=this.h.get(D.toString());return r||(r=this.f.$tryOpenDocument(D).then(s=>{this.h.delete(D.toString());const c=h.URI.revive(s);return(0,E.$te)(this.g.getDocument(c))},s=>(this.h.delete(D.toString()),Promise.reject(s))),this.h.set(D.toString(),r)),r}createDocumentData(D){return this.f.$tryCreateDocument(D).then(p=>h.URI.revive(p))}$acceptModelLanguageChanged(D,p){const r=h.URI.revive(D),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(p),this.a.fire(s.document)}$acceptModelSaved(D){const p=h.URI.revive(D),r=this.g.getDocument(p);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged(D,!1),this.d.fire(r.document)}$acceptDirtyStateChanged(D,p){const r=h.URI.revive(D),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(p),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(D,p,r){const s=h.URI.revive(D),c=this.g.getDocument(s);if(!c)throw new Error("unknown document");c._acceptIsDirty(r),c.onEvents(p);let f;p.isUndoing?f=R.TextDocumentChangeReason.Undo:p.isRedoing&&(f=R.TextDocumentChangeReason.Redo),this.c.fire((0,b.$Gm)({document:c.document,contentChanges:p.changes.map(y=>({range:m.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:f}))}setWordDefinitionFor(D,p){(0,A.$BL)(D,p)}}e.$I$b=$}),define(De[61],Ce([1,0,53,3,4,2,5,6,135,20,140,16,18,28,15,48,54]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.$JL=void 0;class s{constructor(y){this.value=y,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let c=class{constructor(y,C){this.h=y,this.i=C,this.a=null,this.b=new Map,this.c=new S.$li,this.d=new F.$7c,this.e=new F.$7c,this.f=new F.$7c,this.g=new F.$7c,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(y){this.acceptDocumentsAndEditorsDelta(y)}acceptDocumentsAndEditorsDelta(y){const C=[],i=[],a=[];if(y.removedDocuments)for(const n of y.removedDocuments){const t=L.URI.revive(n),o=this.c.get(t);o?.unref()&&(this.c.delete(t),C.push(o.value))}if(y.addedDocuments)for(const n of y.addedDocuments){const t=L.URI.revive(n.uri);let o=this.c.get(t);if(o&&t.scheme!==D.Schemas.vscodeNotebookCell&&t.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${t} already exists!'`);o||(o=new s(new E.$CL(this.h.getProxy(m.$xJ.MainThreadDocuments),t,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(t,o),i.push(o.value)),o.ref()}if(y.removedEditors)for(const n of y.removedEditors){const t=this.b.get(n);this.b.delete(n),t&&a.push(t)}if(y.addedEditors)for(const n of y.addedEditors){const t=L.URI.revive(n.documentUri);k.ok(this.c.has(t),`document '${t}' does not exist`),k.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const o=this.c.get(t).value,g=new R.$IL(n.id,this.h.getProxy(m.$xJ.MainThreadTextEditors),this.i,new r.$T(()=>o.document),n.selections.map(I.Selection.to),n.options,n.visibleRanges.map(u=>I.Range.to(u)),typeof n.editorPosition=="number"?I.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,g)}y.newActiveEditor!==void 0&&(k.ok(y.newActiveEditor===null||this.b.has(y.newActiveEditor),`active editor '${y.newActiveEditor}' does not exist`),this.a=y.newActiveEditor),(0,h.$gb)(C),(0,h.$gb)(a),y.removedDocuments&&this.e.fire(C),y.addedDocuments&&this.d.fire(i),(y.removedEditors||y.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),y.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(y){return this.c.get(y)?.value}allDocuments(){return p.Iterable.map(this.c.values(),y=>y.value)}getEditor(y){return this.b.get(y)}activeEditor(y){if(!this.a)return;const C=this.b.get(this.a);return y?C:C?.value}allEditors(){return[...this.b.values()]}};e.$JL=c,e.$JL=c=Je([qe(0,b.$zL),qe(1,$.$Pi)],c),e.$KL=(0,A.$nh)("IExtHostDocumentsAndEditors")}),define(De[62],Ce([1,0,16,6,2,3,5,7,20,14,65]),function(me,e,k,F,h,L,A,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=e.$Z_b=void 0,e.$Z_b=(0,A.$nh)("IExtHostEditorTabs");class I{constructor(r,s,c){this.e=c,this.d=s,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,s={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new m.$gL(h.URI.revive(this.b.input.uri));case 2:return new m.$hL(h.URI.revive(this.b.input.original),h.URI.revive(this.b.input.modified));case 3:return new m.$iL(h.URI.revive(this.b.input.base),h.URI.revive(this.b.input.input1),h.URI.revive(this.b.input.input2),h.URI.revive(this.b.input.result));case 6:return new m.$jL(h.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new m.$kL(this.b.input.viewType);case 4:return new m.$lL(h.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new m.$mL(h.URI.revive(this.b.input.original),h.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new m.$nL;case 9:return new m.$oL(h.URI.revive(this.b.input.uri),h.URI.revive(this.b.input.inputBoxUri));default:return}}}class ${constructor(r,s){this.c=[],this.d="",this.b=r,this.e=s;for(const c of r.tabs)c.isActive&&(this.d=c.id),this.c.push(new I(c,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,s={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return k.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(c=>c.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(c=>c.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const c=new I(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,c),r.tabDto.isActive&&(this.d=c.tabId),c}else if(r.kind===1){const c=this.c.splice(r.index,1)[0];if(!c)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return c.tabId===this.d&&(this.d=""),c}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const c=this.c.splice(r.oldIndex,1)[0];if(!c)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,c),c}const s=this.c.find(c=>c.tabId===r.tabDto.id);if(!s)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(r.tabDto),s}activeTabId(){return this.d}}let S=class{constructor(r){this.b=new L.$7c,this.c=new L.$7c,this.e=[],this.a=r.getProxy(F.$xJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,s={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(c=>c.apiObject))},get activeTabGroup(){const c=r.d;return(0,b.$te)(r.e.find(y=>y.groupId===c)?.apiObject)},close:async(c,f)=>{const y=Array.isArray(c)?c:[c];return y.length?D(y[0])?this.j(y,f):this.i(y,f):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(r){const s=new Set(this.e.map(n=>n.groupId)),c=new Set(r.map(n=>n.groupId)),f=(0,R.$J)(s,c),y=this.e.filter(n=>f.removed.includes(n.groupId)).map(n=>n.apiObject),C=[],i=[];this.e=r.map(n=>{const t=new $(n,()=>this.d);return f.added.includes(t.groupId)?C.push(t.apiObject):i.push(t.apiObject),t});const a=(0,b.$te)(r.find(n=>n.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:C,closed:y,changed:i}))}$acceptTabGroupUpdate(r){const s=this.e.find(c=>c.groupId===r.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const s=this.e.find(f=>f.groupId===r.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const c=s.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[c.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[c.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[c.apiObject]}));return}}g(r){for(const s of this.e)for(const c of s.tabs)if(c.apiObject===r)return c}h(r){return this.e.find(s=>s.apiObject===r)}async i(r,s){const c=[];for(const f of r){const y=this.g(f);if(!y)throw new Error("Tab close: Invalid tab not found!");c.push(y.tabId)}return this.a.$closeTab(c,s)}async j(r,s){const c=[];for(const f of r){const y=this.h(f);if(!y)throw new Error("Group close: Invalid group not found!");c.push(y.groupId)}return this.a.$closeGroup(c,s)}};e.$1_b=S,e.$1_b=S=Je([qe(0,E.$zL)],S);function D(p){return p.tabs!==void 0}}),define(De[290],Ce([1,0,2,6,4,7,16,162,12,22,27,74]),function(me,e,k,F,h,L,A,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=void 0;class ${constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const r=this.a.indexOf(p);r>=0&&(this.a.splice(r,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),r=[];let s,c,f=14,y=14;for(const C of p){let i=s?(0,E.$Nd)(s,C):0;for(i===0?c=1:c=y;i<C.length;i++)i+1===C.length?(f=y,y=9):y+=1,r.push([c,C.toUpperCase().charCodeAt(i),y]),r.push([c,C.toLowerCase().charCodeAt(i),y]),c=y;s=C,y=f}r.push([9,58,10]),r.push([10,47,12]),this.b=new m.$6W(r)}}provideDocumentLinks(p){this.c();const r=[],s=m.$7W.computeLinks({getLineContent(c){return p.lineAt(c-1).text},getLineCount(){return p.lineCount}},this.b);for(const c of s){const f=A.DocumentLink.to(c);f.target&&r.push(f)}return r}}class S{constructor(p,r){this.i=r,this.b=new $,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(F.$xJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,r,s,c={}){if(S.j(s),this.d.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const f=this.h++;this.b.add(r),this.d.add(r),this.c.set(f,s);let y=2;c.isCaseSensitive&&(y+=1024),c.isReadonly&&(y+=2048),typeof s.copy=="function"&&(y+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,R.$wF)(p,"fsChunks"),y+=4);let C;c.isReadonly&&(0,I.$Kj)(c.isReadonly)&&((0,R.$wF)(p,"readonlyMessage"),C={value:c.isReadonly.value,isTrusted:c.isReadonly.isTrusted,supportThemeIcons:c.isReadonly.supportThemeIcons,supportHtml:c.isReadonly.supportHtml,baseUri:c.isReadonly.baseUri,uris:c.isReadonly.uris}),this.a.$registerFileSystemProvider(f,r,y,C).catch(a=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${r}`),console.error(a)});const i=s.onDidChangeFile(a=>{const n=[];for(const t of a){const{uri:o,type:g}=t;if(o.scheme!==r)continue;let u;switch(g){case L.FileChangeType.Changed:u=0;break;case L.FileChangeType.Created:u=1;break;case L.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:o,type:u})}this.a.$onFileSystemChange(f,n)});return(0,h.$jb)(()=>{i.dispose(),this.b.delete(r),this.d.delete(r),this.c.delete(f),this.a.$unregisterProvider(f)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:r,ctime:s,mtime:c,size:f,permissions:y}=p;return{type:r,ctime:s,mtime:c,size:f,permissions:y}}$stat(p,r){return Promise.resolve(this.l(p).stat(k.URI.revive(r))).then(s=>S.k(s))}$readdir(p,r){return Promise.resolve(this.l(p).readDirectory(k.URI.revive(r)))}$readFile(p,r){return Promise.resolve(this.l(p).readFile(k.URI.revive(r))).then(s=>b.$Jb.wrap(s))}$writeFile(p,r,s,c){return Promise.resolve(this.l(p).writeFile(k.URI.revive(r),s.buffer,c))}$delete(p,r,s){return Promise.resolve(this.l(p).delete(k.URI.revive(r),s))}$rename(p,r,s,c){return Promise.resolve(this.l(p).rename(k.URI.revive(r),k.URI.revive(s),c))}$copy(p,r,s,c){const f=this.l(p);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(k.URI.revive(r),k.URI.revive(s),c))}$mkdir(p,r){return Promise.resolve(this.l(p).createDirectory(k.URI.revive(r)))}$watch(p,r,s,c){const f=this.l(p).watch(k.URI.revive(s),c);this.f.set(r,f)}$unwatch(p,r){const s=this.f.get(r);s&&(s.dispose(),this.f.delete(r))}$open(p,r,s){const c=this.l(p);if(!c.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(c.open(k.URI.revive(r),s))}$close(p,r){const s=this.l(p);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(r))}$read(p,r,s,c){const f=this.l(p);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const y=b.$Jb.alloc(c);return Promise.resolve(f.read(r,s,y.buffer,0,c)).then(C=>y.slice(0,C))}$write(p,r,s,c){const f=this.l(p);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(r,s,c.buffer,0,c.byteLength))}l(p){const r=this.c.get(p);if(!r){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return r}}e.$w_b=S}),define(De[63],Ce([1,0,6,30,7,22,5,20,51,4,17,24,15]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=e.$c_b=void 0;let S=class ii{constructor(p,r){this.b=new Map,this.c=new R.$Bg,this.a=p.getProxy(k.$xJ.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(c){try{let f;const y=s.b.get(c.scheme);return y?(await s.a.$ensureActivation(c.scheme),f=await y.impl.stat(c)):f=await s.a.$stat(c),{type:f.type,ctime:f.ctime,mtime:f.mtime,size:f.size,permissions:f.permissions===F.FilePermission.Readonly?1:void 0}}catch(f){ii.e(f)}},async readDirectory(c){try{const f=s.b.get(c.scheme);return f?(await s.a.$ensureActivation(c.scheme),(await f.impl.readDirectory(c)).slice()):await s.a.$readdir(c)}catch(f){return ii.e(f)}},async createDirectory(c){try{const f=s.b.get(c.scheme);return f&&!f.isReadonly?(await s.a.$ensureActivation(c.scheme),await s.d(f.impl,f.extUri,c)):await s.a.$mkdir(c)}catch(f){return ii.e(f)}},async readFile(c){try{const f=s.b.get(c.scheme);return f?(await s.a.$ensureActivation(c.scheme),(await f.impl.readFile(c)).slice()):(await s.a.$readFile(c)).buffer}catch(f){return ii.e(f)}},async writeFile(c,f){try{const y=s.b.get(c.scheme);return y&&!y.isReadonly?(await s.a.$ensureActivation(c.scheme),await s.d(y.impl,y.extUri,y.extUri.dirname(c)),await s.c.queueFor(c).queue(()=>Promise.resolve(y.impl.writeFile(c,f,{create:!0,overwrite:!0})))):await s.a.$writeFile(c,L.$Jb.wrap(f))}catch(y){return ii.e(y)}},async delete(c,f){try{const y=s.b.get(c.scheme);return y&&!y.isReadonly?(await s.a.$ensureActivation(c.scheme),await y.impl.delete(c,{recursive:!1,...f})):await s.a.$delete(c,{recursive:!1,useTrash:!1,atomic:!1,...f})}catch(y){return ii.e(y)}},async rename(c,f,y){try{return await s.a.$rename(c,f,{overwrite:!1,...y})}catch(C){return ii.e(C)}},async copy(c,f,y){try{return await s.a.$copy(c,f,{overwrite:!1,...y})}catch(C){return ii.e(C)}},isWritableFileSystem(c){const f=r.getCapabilities(c);if(typeof f=="number")return!(f&2048)}})}async d(p,r,s){const c=[];for(;!r.isEqual(s,r.dirname(s));)try{if(!((await p.stat(s)).type&F.FileType.Directory))throw h.$NK.FileExists(`Unable to create folder '${s.scheme===$.Schemas.file?s.fsPath:s.toString(!0)}' that already exists but is not a directory`);break}catch(f){if(F.$6j(f)!==F.FileSystemProviderErrorCode.FileNotFound)throw f;c.push(r.basename(s)),s=r.dirname(s)}for(let f=c.length-1;f>=0;f--){s=r.joinPath(s,c[f]);try{await p.createDirectory(s)}catch(y){if(F.$6j(y)!==F.FileSystemProviderErrorCode.FileExists)throw y}}}static e(p){if(p instanceof h.$NK)throw p;if(p instanceof F.$2j)switch(p.code){case F.FileSystemProviderErrorCode.FileExists:throw h.$NK.FileExists(p.message);case F.FileSystemProviderErrorCode.FileNotFound:throw h.$NK.FileNotFound(p.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw h.$NK.FileNotADirectory(p.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw h.$NK.FileIsADirectory(p.message);case F.FileSystemProviderErrorCode.NoPermissions:throw h.$NK.NoPermissions(p.message);case F.FileSystemProviderErrorCode.Unavailable:throw h.$NK.Unavailable(p.message);default:throw new h.$NK(p.message,p.name)}if(!(p instanceof Error))throw new h.$NK(String(p));if(p.name==="ENOPRO"||p.message.includes("ENOPRO"))throw h.$NK.Unavailable(p.message);switch(p.name){case F.FileSystemProviderErrorCode.FileExists:throw h.$NK.FileExists(p.message);case F.FileSystemProviderErrorCode.FileNotFound:throw h.$NK.FileNotFound(p.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw h.$NK.FileNotADirectory(p.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw h.$NK.FileIsADirectory(p.message);case F.FileSystemProviderErrorCode.NoPermissions:throw h.$NK.NoPermissions(p.message);case F.FileSystemProviderErrorCode.Unavailable:throw h.$NK.Unavailable(p.message);default:throw new h.$NK(p.message,p.name)}}addFileSystemProvider(p,r,s){return this.b.set(p,{impl:r,extUri:s?.isCaseSensitive?I.$Xf:I.$Zf,isReadonly:!!s?.isReadonly}),(0,b.$jb)(()=>this.b.delete(p))}getFileSystemProviderExtUri(p){return this.b.get(p)?.extUri??I.$Xf}};e.$c_b=S,e.$c_b=S=Je([qe(0,m.$zL),qe(1,E.$K$b)],S),e.$d_b=(0,A.$nh)("IExtHostConsumerFileSystem")}),define(De[291],Ce([1,0,3,34,2,6,16,7]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x_b=void 0;class E{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(I,$,S,D,p,r,s,c){this.a=new k.$7c,this.b=new k.$7c,this.c=new k.$7c;const f=this.h(I,S,p);this.g=0,r&&(this.g+=1),s&&(this.g+=2),c&&(this.g+=4);const y=(0,F.$cj)(p),C=typeof p=="string",i=D(a=>{if(!r)for(const n of a.created){const t=h.URI.revive(n);y(t.fsPath)&&(!C||$.getWorkspaceFolder(t))&&this.a.fire(t)}if(!s)for(const n of a.changed){const t=h.URI.revive(n);y(t.fsPath)&&(!C||$.getWorkspaceFolder(t))&&this.b.fire(t)}if(!c)for(const n of a.deleted){const t=h.URI.revive(n);y(t.fsPath)&&(!C||$.getWorkspaceFolder(t))&&this.c.fire(t)}});this.d=m.$zJ.from(f,this.a,this.b,this.c,i)}h(I,$,S){const D=m.$zJ.from();if(typeof S=="string")return D;const p=I.getProxy(L.$xJ.MainThreadFileSystem);let r=!1;(S.pattern.includes(F.$$i)||S.pattern.includes(F.$_i))&&(r=!0);const s=Math.random();return p.$watch($.identifier.value,s,S.baseUri,{recursive:r,excludes:[]}),m.$zJ.from({dispose:()=>p.$unwatch(s)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class b{constructor(I,$,S){this.j=I,this.k=$,this.l=S,this.a=new k.$7c,this.b=new k.$7c,this.c=new k.$7c,this.d=new k.$7c,this.g=new k.$9c,this.h=new k.$9c,this.i=new k.$9c,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(I,$,S,D,p,r){return new E(this.j,I,$,this.a.event,A.GlobPattern.from(S),D,p,r)}$onFileEvent(I){this.a.fire(I)}$onDidRunFileOperation(I,$){switch(I){case 2:this.b.fire(Object.freeze({files:$.map(S=>({oldUri:h.URI.revive(S.source),newUri:h.URI.revive(S.target)}))}));break;case 1:this.d.fire(Object.freeze({files:$.map(S=>h.URI.revive(S.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:$.map(S=>h.URI.revive(S.target))}));break;default:}}getOnWillRenameFileEvent(I){return this.m(I,this.g)}getOnWillCreateFileEvent(I){return this.m(I,this.h)}getOnWillDeleteFileEvent(I){return this.m(I,this.i)}m(I,$){return(S,D,p)=>{const r=function(c){S.call(D,c)};return r.extension=I,$.event(r,void 0,p)}}async $onWillRunFileOperation(I,$,S,D){switch(I){case 2:return await this.n(this.g,{files:$.map(p=>({oldUri:h.URI.revive(p.source),newUri:h.URI.revive(p.target)}))},S,D);case 1:return await this.n(this.i,{files:$.map(p=>h.URI.revive(p.target))},S,D);case 0:case 3:return await this.n(this.h,{files:$.map(p=>h.URI.revive(p.target))},S,D)}}async n(I,$,S,D){const p=new Set,r=[];if(await I.fireAsync($,D,async(c,f)=>{const y=Date.now(),C=await Promise.resolve(c);C instanceof m.$JJ&&(r.push([f.extension,C]),p.add(f.extension.displayName??f.extension.identifier.value)),Date.now()-y>S&&this.k.warn("SLOW file-participant",f.extension.identifier)}),D.isCancellationRequested||r.length===0)return;const s={edits:[]};for(const[,c]of r){const{edits:f}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:y=>this.l.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}});s.edits=s.edits.concat(f)}return{edit:s,extensionNames:Array.from(p)}}}e.$x_b=b}),define(De[292],Ce([1,0,4,2,6,16,7,36]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;class E{static{this.a=0}constructor($,S){this.extension=$,this.provider=S,this.handle=E.a++}}class b{constructor($){this.session=$,this.responses=[]}}class R{static{this.a=0}constructor($,S,D,p){this.f=D,this.g=p,this.b=new Map,this.d=new Map,this.e=$.getProxy(h.$xJ.MainThreadInlineChat),S.registerApiCommand(new m.$ZL("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$XL("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?L.Range.from(r.initialRange):void 0,message:r.message,autoSend:r.autoSend,position:r.position?L.Position.from(r.position):void 0}})],m.$YL.Void))}registerProvider($,S){const D=new E($,S);return this.b.set(D.handle,D),this.e.$registerInteractiveEditorProvider(D.handle,$.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function"),(0,k.$jb)(()=>{this.e.$unregisterInteractiveEditorProvider(D.handle),this.b.delete(D.handle)})}async $prepareSession($,S,D,p){const r=this.b.get($);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const s=this.f.getDocument(F.URI.revive(S)),c=L.Selection.to(D),f=await r.provider.prepareInteractiveEditorSession({document:s,selection:c},p);if(!f)return;if(f.wholeRange&&!f.wholeRange.contains(c))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const y=R.a++;return this.d.set(y,new b(f)),{id:y,placeholder:f.placeholder,slashCommands:f.slashCommands?.map(C=>({command:C.command,detail:C.detail,refer:C.refer,executeImmediately:C.executeImmediately})),wholeRange:L.Range.from(f.wholeRange),message:f.message}}async $provideResponse($,S,D,p){const r=this.b.get($);if(!r)return;const s=this.d.get(S.id);if(!s)return;const c={session:s.session,prompt:D.prompt,selection:L.Selection.to(D.selection),wholeRange:L.Range.to(D.wholeRange),attempt:D.attempt,live:D.live};let f=!1;const y={report:a=>{if(!D.live)throw new Error("Progress reporting is only supported for live sessions");f||p.isCancellationRequested||!a.message&&!a.edits||this.e.$handleProgressChunk(D.requestId,{message:a.message,edits:a.edits?.map(L.TextEdit.from)})}},C=typeof r.provider.provideInteractiveEditorResponse2=="function"?r.provider.provideInteractiveEditorResponse2(c,y,p):r.provider.provideInteractiveEditorResponse(c,p);Promise.resolve(C).finally(()=>f=!0);const i=await C;if(i){const a=s.responses.push(i)-1,n={wholeRange:L.Range.from(i.wholeRange),placeholder:i.placeholder};if(R.h(i))return{...n,id:a,type:"message",message:L.MarkdownString.from(i.contents)};const{edits:t}=i;if(t instanceof A.$JJ)return{...n,id:a,type:"bulkEdit",edits:L.WorkspaceEdit.from(t)};if(Array.isArray(t))return{...n,id:a,type:"editorEdit",edits:t.map(L.TextEdit.from)}}}$handleFeedback($,S,D,p){const r=this.b.get($),s=this.d.get(S),c=s?.responses[D];if(r&&c){let f;switch(p){case 1:f=A.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:f=A.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:f=A.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:f=A.InteractiveEditorResponseFeedbackKind.Accepted;break}r.provider.handleInteractiveEditorResponseFeedback?.(s.session,c,f)}}$releaseSession($,S){const D=this.d.get(S),p=this.b.get($);D&&p&&p.provider.releaseInteractiveEditorSession?.(D.session),this.d.delete(S)}static h($){return typeof $=="object"&&typeof $.contents=="object"}}e.$Eac=R}),define(De[293],Ce([1,0,2,36]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=void 0;class h{constructor(A,m,E,b,R){this.a=m,this.b=E,this.c=b;const I=new F.$ZL("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.$XL("showOptions","Show Options",$=>!0,$=>$),new F.$XL("resource","Interactive resource Uri",$=>!0,$=>$),new F.$XL("controllerId","Notebook controller Id",$=>!0,$=>$),new F.$XL("title","Interactive editor title",$=>!0,$=>$)],new F.$YL("Notebook and input URI",$=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",$.notebookEditorId),$.notebookEditorId!==void 0){const S=this.a.getEditorById($.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:k.URI.revive($.notebookUri),inputUri:k.URI.revive($.inputUri),notebookEditor:S.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",$.notebookUri,$.inputUri),{notebookUri:k.URI.revive($.notebookUri),inputUri:k.URI.revive($.inputUri)}}));this.c.registerApiCommand(I)}$willAddInteractiveDocument(A,m,E,b){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:E,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(k.URI.revive(b))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Aac=h}),define(De[294],Ce([1,0,6,7]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=void 0;class h{constructor(A){this.a=new Map,this.b=A.getProxy(k.$xJ.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const E=this.a.get(A);if(!E)throw new Error("Issue request handler not found");const b=await E.handleIssueUrlRequest();if(!b)throw new Error("Issue request handler returned no result");return b}registerIssueUriRequestHandler(A,m){const E=A.identifier.value;return this.a.set(E,m),this.b.$registerIssueUriRequestHandler(E),new F.$zJ(()=>{this.b.$unregisterIssueUriRequestHandler(E),this.a.delete(E)})}}e.$Hac=h}),define(De[295],Ce([1,0,4,6]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=void 0;class h{constructor(A){this.b=0,this.a=A.getProxy(F.$xJ.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,k.$jb)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$T_b=h}),define(De[296],Ce([1,0,2,23,16,7,77,6,12,33,19,14,158,21,25,4,123,111,81,39,8,17,27,195]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y,C,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=void 0;class n{constructor(O,K){this.d=O,this.e=K}async provideDocumentSymbols(O,K){const G=this.d.getDocument(O),x=await this.e.provideDocumentSymbols(G,K);if(!(0,R.$of)(x))return x[0]instanceof L.$RJ?x.map(h.DocumentSymbol.from):n.f(x)}static f(O){O=O.slice(0).sort((x,pe)=>{let se=x.location.range.start.compareTo(pe.location.range.start);return se===0&&(se=pe.location.range.end.compareTo(x.location.range.end)),se});const K=[],G=[];for(const x of O){const pe={name:x.name||"!!MISSING: name!!",kind:h.SymbolKind.from(x.kind),tags:x.tags?.map(h.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:h.Range.from(x.location.range),selectionRange:h.Range.from(x.location.range),children:[]};for(;;){if(G.length===0){G.push(pe),K.push(pe);break}const se=G[G.length-1];if(b.$Mr.containsRange(se.range,pe.range)&&!b.$Mr.equalsRange(se.range,pe.range)){se.children?.push(pe),G.push(pe);break}G.pop()}}return K}}class t{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(O,K,G){this.g=O,this.h=K,this.j=G,this.e=new c.$H$b("CodeLens"),this.f=new Map}async provideCodeLenses(O,K){const G=this.g.getDocument(O),x=await this.j.provideCodeLenses(G,K);if(!x||K.isCancellationRequested)return;const pe=this.e.add(x),se=new p.$kb;this.f.set(pe,se);const ve={cacheId:pe,lenses:[]};for(let Ie=0;Ie<x.length;Ie++)ve.lenses.push({cacheId:[pe,Ie],range:h.Range.from(x[Ie].range),command:this.h.toInternal(x[Ie].command,se)});return ve}async resolveCodeLens(O,K){const G=O.cacheId&&this.e.get(...O.cacheId);if(!G)return;let x;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?x=G:x=await this.j.resolveCodeLens(G,K),x||(x=G),K.isCancellationRequested)return;const pe=O.cacheId&&this.f.get(O.cacheId[0]);if(pe)return O.command=this.h.toInternal(x.command??t.d,pe),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}function o(we){return Array.isArray(we)?we.map(h.DefinitionLink.from):we?[h.DefinitionLink.from(we)]:[]}class g{constructor(O,K){this.d=O,this.e=K}async provideDefinition(O,K,G){const x=this.d.getDocument(O),pe=h.Position.to(K),se=await this.e.provideDefinition(x,pe,G);return o(se)}}class u{constructor(O,K){this.d=O,this.e=K}async provideDeclaration(O,K,G){const x=this.d.getDocument(O),pe=h.Position.to(K),se=await this.e.provideDeclaration(x,pe,G);return o(se)}}class d{constructor(O,K){this.d=O,this.e=K}async provideImplementation(O,K,G){const x=this.d.getDocument(O),pe=h.Position.to(K),se=await this.e.provideImplementation(x,pe,G);return o(se)}}class v{constructor(O,K){this.d=O,this.e=K}async provideTypeDefinition(O,K,G){const x=this.d.getDocument(O),pe=h.Position.to(K),se=await this.e.provideTypeDefinition(x,pe,G);return o(se)}}class l{constructor(O,K){this.d=O,this.e=K}async provideHover(O,K,G){const x=this.d.getDocument(O),pe=h.Position.to(K),se=await this.e.provideHover(x,pe,G);if(!(!se||(0,R.$of)(se.contents)))return se.range||(se.range=x.getWordRangeAtPosition(pe)),se.range||(se.range=new L.$BJ(pe,pe)),h.Hover.from(se)}}class w{constructor(O,K){this.d=O,this.e=K}async provideEvaluatableExpression(O,K,G){const x=this.d.getDocument(O),pe=h.Position.to(K),se=await this.e.provideEvaluatableExpression(x,pe,G);if(se)return h.EvaluatableExpression.from(se)}}class P{constructor(O,K){this.d=O,this.e=K}async provideInlineValues(O,K,G,x){const pe=this.d.getDocument(O),se=await this.e.provideInlineValues(pe,h.Range.to(K),h.InlineValueContext.to(G),x);if(Array.isArray(se))return se.map(ve=>h.InlineValue.from(ve))}}class M{constructor(O,K){this.d=O,this.e=K}async provideDocumentHighlights(O,K,G){const x=this.d.getDocument(O),pe=h.Position.to(K),se=await this.e.provideDocumentHighlights(x,pe,G);if(Array.isArray(se))return se.map(h.DocumentHighlight.from)}}class N{constructor(O,K){this.d=O,this.e=K}async provideLinkedEditingRanges(O,K,G){const x=this.d.getDocument(O),pe=h.Position.to(K),se=await this.e.provideLinkedEditingRanges(x,pe,G);if(se&&Array.isArray(se.ranges))return{ranges:(0,R.$lf)(se.ranges.map(h.Range.from)),wordPattern:se.wordPattern}}}class T{constructor(O,K){this.d=O,this.e=K}async provideReferences(O,K,G,x){const pe=this.d.getDocument(O),se=h.Position.to(K),ve=await this.e.provideReferences(pe,se,G,x);if(Array.isArray(ve))return ve.map(h.location.from)}}class z{static{this.d=1e3}constructor(O,K,G,x,pe,se,ve){this.h=O,this.j=K,this.k=G,this.l=x,this.m=pe,this.n=se,this.o=ve,this.e=new c.$H$b("CodeAction"),this.f=new Map,this.g=new L.$TJ("notebook")}async provideCodeActions(O,K,G,x){const pe=this.h.getDocument(O),se=$.$Ur.isISelection(K)?h.Selection.to(K):h.Range.to(K),ve=[];for(const et of this.k.getDiagnostics(O))if(se.intersection(et.range)&&ve.push(et)>z.d)break;const Ie={diagnostics:ve,only:G.only?new L.$TJ(G.only):void 0,triggerKind:h.CodeActionTriggerKind.to(G.trigger)},Ue=await this.l.provideCodeActions(pe,se,Ie,x);if(!(0,R.$pf)(Ue)||x.isCancellationRequested)return;const Ve=this.e.add(Ue),xe=new p.$kb;this.f.set(Ve,xe);const Ge=[];for(let et=0;et<Ue.length;et++){const Ze=Ue[et];if(Ze)if(z.p(Ze))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Ze.title,command:this.j.toInternal(Ze,xe)});else{if(Ie.triggerKind!==L.CodeActionTriggerKind.Invoke&&Ze.kind&&this.g.contains(Ze.kind))continue;Ie.only&&(Ze.kind?Ie.only.contains(Ze.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action is of kind '${Ze.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${Ie.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[Ve,et],title:Ze.title,command:Ze.command&&this.j.toInternal(Ze.command,xe),diagnostics:Ze.diagnostics&&Ze.diagnostics.map(h.Diagnostic.from),edit:Ze.edit&&h.WorkspaceEdit.from(Ze.edit,void 0),kind:Ze.kind&&Ze.kind.value,isPreferred:Ze.isPreferred,disabled:Ze.disabled?.reason})}}return{cacheId:Ve,actions:Ge}}async resolveCodeAction(O,K){const[G,x]=O,pe=this.e.get(G,x);if(!pe||z.p(pe))return{};if(!this.l.resolveCodeAction)return{};const se=await this.l.resolveCodeAction(pe,K)??pe;let ve;se.edit&&(ve=h.WorkspaceEdit.from(se.edit,void 0));let Ie;if(se.command){const Ue=this.f.get(G);Ue&&(Ie=this.j.toInternal(se.command,Ue))}return{edit:ve,command:Ie}}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static p(O){return typeof O.command=="string"&&typeof O.title=="string"}}class j{constructor(O,K,G,x,pe){this.d=O,this.e=K,this.f=G,this.g=x,this.h=pe}async prepareDocumentPaste(O,K,G,x){if(!this.f.prepareDocumentPaste)return;const pe=this.e.getDocument(O),se=K.map(Ue=>h.Range.to(Ue)),ve=h.DataTransfer.toDataTransfer(G,()=>{throw new y.$0});if(await this.f.prepareDocumentPaste(pe,se,ve,x),x.isCancellationRequested)return;const Ie=Array.from(ve).filter(([,Ue])=>!(Ue instanceof L.$oK));return h.DataTransfer.from(Ie)}async providePasteEdits(O,K,G,x,pe){if(!this.f.provideDocumentPasteEdits)return;const se=this.e.getDocument(K),ve=G.map(Ve=>h.Range.to(Ve)),Ie=h.DataTransfer.toDataTransfer(x,async Ve=>(await this.d.$resolvePasteFileData(this.g,O,Ve)).buffer),Ue=await this.f.provideDocumentPasteEdits(se,ve,Ie,pe);if(Ue)return{id:Ue.id?this.h.identifier.value+"."+Ue.id:this.h.identifier.value,label:Ue.label??(0,a.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,priority:Ue.priority??0,insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?h.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class U{constructor(O,K){this.d=O,this.e=K}async provideDocumentFormattingEdits(O,K,G){const x=this.d.getDocument(O),pe=await this.e.provideDocumentFormattingEdits(x,K,G);if(Array.isArray(pe))return pe.map(h.TextEdit.from)}}class Y{constructor(O,K){this.d=O,this.e=K}async provideDocumentRangeFormattingEdits(O,K,G,x){const pe=this.d.getDocument(O),se=h.Range.to(K),ve=await this.e.provideDocumentRangeFormattingEdits(pe,se,G,x);if(Array.isArray(ve))return ve.map(h.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,K,G,x){(0,I.$se)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const pe=this.d.getDocument(O),se=K.map(h.Range.to),ve=await this.e.provideDocumentRangesFormattingEdits(pe,se,G,x);if(Array.isArray(ve))return ve.map(h.TextEdit.from)}}class H{constructor(O,K){this.d=O,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,K,G,x,pe){const se=this.d.getDocument(O),ve=h.Position.to(K),Ie=await this.e.provideOnTypeFormattingEdits(se,ve,G,x,pe);if(Array.isArray(Ie))return Ie.map(h.TextEdit.from)}}class ge{constructor(O,K){this.e=O,this.f=K,this.d=new c.$H$b("WorkspaceSymbols")}async provideWorkspaceSymbols(O,K){const G=await this.e.provideWorkspaceSymbols(O,K);if(!(0,R.$pf)(G))return{symbols:[]};const x=this.d.add(G),pe={cacheId:x,symbols:[]};for(let se=0;se<G.length;se++){const ve=G[se];if(!ve||!ve.name){this.f.warn("INVALID SymbolInformation",ve);continue}pe.symbols.push({...h.WorkspaceSymbol.from(ve),cacheId:[x,se]})}return pe}async resolveWorkspaceSymbol(O,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const G=this.d.get(...O.cacheId);if(G){const x=await this.e.resolveWorkspaceSymbol(G,K);return x&&(0,F.$Im)(O,h.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class ie{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,K,G){this.d=O,this.e=K,this.f=G}async provideRenameEdits(O,K,G,x){const pe=this.d.getDocument(O),se=h.Position.to(K);try{const ve=await this.e.provideRenameEdits(pe,se,G,x);return ve?h.WorkspaceEdit.from(ve):void 0}catch(ve){const Ie=ie.g(ve);return Ie?{rejectReason:Ie,edits:void 0}:Promise.reject(ve)}}async resolveRenameLocation(O,K,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(O),pe=h.Position.to(K);try{const se=await this.e.prepareRename(x,pe,G);let ve,Ie;if(L.$BJ.isRange(se)?(ve=se,Ie=x.getText(se)):(0,I.$ke)(se)&&(ve=se.range,Ie=se.placeholder),!ve||!Ie)return;if(ve.start.line>pe.line||ve.end.line<pe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:h.Range.from(ve),text:Ie}}catch(se){const ve=ie.g(se);return ve?{rejectReason:ve,range:void 0,text:void 0}:Promise.reject(se)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class te{constructor(O,K){this.resultId=O,this.tokens=K}}class q{constructor(O,K){this.f=O,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,K,G){const x=this.f.getDocument(O),pe=K!==0?this.d.get(K):null;let se=typeof pe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,pe.resultId,G):await this.g.provideDocumentSemanticTokens(x,G);return pe&&this.d.delete(K),se?(se=q.h(se),this.o(q.n(pe,se),se)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return q.j(O)?q.k(O)?O:new L.$RK(new Uint32Array(O.data),O.resultId):q.l(O)?q.m(O)?O:new L.$TK(O.edits.map(K=>new L.$SK(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const K of O.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(O,K){if(!q.j(K)||!O||!O.tokens)return K;const G=O.tokens,x=G.length,pe=K.data,se=pe.length;let ve=0;const Ie=Math.min(x,se);for(;ve<Ie&&G[ve]===pe[ve];)ve++;if(ve===x&&ve===se)return new L.$TK([],K.resultId);let Ue=0;const Ve=Ie-ve;for(;Ue<Ve&&G[x-Ue-1]===pe[se-Ue-1];)Ue++;return new L.$TK([{start:ve,deleteCount:x-ve-Ue,data:pe.subarray(ve,se-Ue)}],K.resultId)}o(O,K){if(q.j(O)){const G=this.e++;return this.d.set(G,new te(O.resultId,O.data)),(0,r.$z8)({id:G,type:"full",data:O.data})}if(q.l(O)){const G=this.e++;return q.j(K)?this.d.set(G,new te(K.resultId,K.data)):this.d.set(G,new te(O.resultId)),(0,r.$z8)({id:G,type:"delta",deltas:(O.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class V{constructor(O,K){this.d=O,this.e=K}async provideDocumentRangeSemanticTokens(O,K,G){const x=this.d.getDocument(O),pe=await this.e.provideDocumentRangeSemanticTokens(x,h.Range.to(K),G);return pe?this.f(pe):null}f(O){return(0,r.$z8)({id:0,type:"full",data:O.data})}}class ce{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,K,G,x,pe){this.f=O,this.g=K,this.h=G,this.j=x,this.k=pe,this.d=new c.$H$b("CompletionItem"),this.e=new Map}async provideCompletionItems(O,K,G,x){const pe=this.f.getDocument(O),se=h.Position.to(K),ve=pe.getWordRangeAtPosition(se)||new L.$BJ(se,se),Ie=ve.with({end:se}),Ue=new f.$3c,Ve=await this.h.provideCompletionItems(pe,se,x,h.CompletionContext.to(G));if(!Ve||x.isCancellationRequested)return;const xe=Array.isArray(Ve)?new L.$8J(Ve):Ve,Ge=ce.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),et=new p.$kb;this.e.set(Ge,et);const Ze=[],st={x:Ge,b:Ze,a:{replace:h.Range.from(ve),insert:h.Range.from(Ie)},c:xe.isIncomplete||void 0,d:Ue.elapsed()};for(let tt=0;tt<xe.items.length;tt++){const Pe=xe.items[tt],ke=this.l(Pe,[Ge,tt],Ie,ve);Ze.push(ke)}return st}async resolveCompletionItem(O,K){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...O);if(!G)return;const x=this.l(G,O),pe=await this.h.resolveCompletionItem(G,K);if(!pe)return;const se=this.l(pe,O);return(x.h!==se.h||x.i!==se.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(x.n!==se.n||x.o!==se.o||!(0,F.$Jm)(x.p,se.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...x,d:se.d,c:se.c,l:se.l,h:se.h,i:se.i,n:se.n,o:se.o,p:se.p}}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,K,G,x){const pe=this.e.get(K[0]);if(!pe)throw Error("DisposableStore is missing...");const se=this.g.toInternal(O.command,pe),ve={x:K,a:O.label,b:O.kind!==void 0?h.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(h.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:h.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(h.TextEdit.from),n:se?.$ident,o:se?.id,p:se?.$ident?void 0:se?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ve.h=O.textEdit.newText):typeof O.insertText=="string"?ve.h=O.insertText:O.insertText instanceof L.$KJ&&(ve.h=O.insertText.value,ve.i|=4);let Ie;return O.textEdit?Ie=O.textEdit.range:O.range&&(Ie=O.range),L.$BJ.isRange(Ie)?ve.j=h.Range.from(Ie):Ie&&(!G?.isEqual(Ie.inserting)||!x?.isEqual(Ie.replacing))&&(ve.j={insert:h.Range.from(Ie.inserting),replace:h.Range.from(Ie.replacing)}),ve}}class re{async provideInlineCompletions(O,K,G,x){}disposeCompletions(O){}handleDidShowCompletionItem(O,K,G){}handlePartialAccept(O,K,G){}}class fe extends re{constructor(O,K,G,x){super(),this.f=O,this.g=K,this.h=G,this.j=x,this.d=new de,this.e=(0,i.$vF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$vF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,K,G,x){const pe=this.g.getDocument(O),se=h.Position.to(K),ve=await this.h.provideInlineCompletionItems(pe,se,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:h.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},x);if(!ve||x.isCancellationRequested)return;const Ie=Array.isArray(ve)?ve:ve.items,Ue=this.e?Array.isArray(ve)?[]:ve.commands||[]:[],Ve=this.e&&!Array.isArray(ve)?ve.suppressSuggestions:void 0,xe=this.e&&!Array.isArray(ve)?ve.enableForwardStability:void 0;let Ge;return{pid:this.d.createReferenceId({dispose(){Ge?.dispose()},items:Ie}),items:Ie.map((Ze,st)=>{let tt;Ze.command&&(Ge||(Ge=new p.$kb),tt=this.j.toInternal(Ze.command,Ge));const Pe=Ze.insertText;return{insertText:typeof Pe=="string"?Pe:{snippet:Pe.value},filterText:Ze.filterText,range:Ze.range?h.Range.from(Ze.range):void 0,command:tt,idx:st,completeBracketPairs:this.e?Ze.completeBracketPairs:!1}}),commands:Ue.map(Ze=>(Ge||(Ge=new p.$kb),this.j.toInternal(Ze,Ge))),suppressSuggestions:Ve,enableForwardStability:xe}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,K,G){const x=this.d.get(O)?.items[K];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,G)}handlePartialAccept(O,K,G){const x=this.d.get(O)?.items[K];x&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(x,G)}}class de{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const K=this.e++;return this.d.set(K,O),K}disposeReferenceId(O){const K=this.d.get(O);return this.d.delete(O),K}get(O){return this.d.get(O)}}class B{constructor(O,K){this.e=O,this.f=K,this.d=new c.$H$b("SignatureHelp")}async provideSignatureHelp(O,K,G,x){const pe=this.e.getDocument(O),se=h.Position.to(K),ve=this.g(G),Ie=await this.f.provideSignatureHelp(pe,se,x,ve);if(Ie){const Ue=this.d.add([Ie]);return{...h.SignatureHelp.from(Ie),id:Ue}}}g(O){let K;if(O.activeSignatureHelp){const G=h.SignatureHelp.to(O.activeSignatureHelp),x=this.d.get(O.activeSignatureHelp.id,0);x?(K=x,K.activeSignature=G.activeSignature,K.activeParameter=G.activeParameter):K=G}return{...O,activeSignatureHelp:K}}releaseSignatureHelp(O){this.d.delete(O)}}class _{constructor(O,K,G,x,pe){this.f=O,this.g=K,this.h=G,this.j=x,this.k=pe,this.d=new c.$H$b("InlayHints"),this.e=new Map}async provideInlayHints(O,K,G){const x=this.f.getDocument(O),pe=h.Range.to(K),se=await this.h.provideInlayHints(x,pe,G);if(!Array.isArray(se)||se.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${K}`);return}if(G.isCancellationRequested)return;const ve=this.d.add(se);this.e.set(ve,new p.$kb);const Ie={hints:[],cacheId:ve};for(let Ue=0;Ue<se.length;Ue++)this.l(se[Ue],pe)&&Ie.hints.push(this.m(se[Ue],[ve,Ue]));return this.j.trace(`[InlayHints] ${Ie.hints.length} inlay hints from '${this.k.identifier.value}' for ${K}`),Ie}async resolveInlayHint(O,K){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...O);if(!G)return;const x=await this.h.resolveInlayHint(G,K);if(x&&this.l(x))return this.m(x,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,K){return O.label.length===0||Array.isArray(O.label)&&O.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(K&&!K.contains(O.position))}m(O,K){const G=this.e.get(K[0]);if(!G)throw Error("DisposableStore is missing...");const x={label:"",cacheId:K,tooltip:h.MarkdownString.fromStrict(O.tooltip),position:h.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(h.TextEdit.from),kind:O.kind&&h.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?x.label=O.label:x.label=O.label.map(pe=>{const se={label:pe.value};return se.tooltip=h.MarkdownString.fromStrict(pe.tooltip),L.$LJ.isLocation(pe.location)&&(se.location=h.location.from(pe.location)),pe.command&&(se.command=this.g.toInternal(pe.command,G)),se}),x}}class Ee{constructor(O,K){this.e=O,this.f=K,this.d=new c.$H$b("DocumentLink")}async provideLinks(O,K){const G=this.e.getDocument(O),x=await this.f.provideDocumentLinks(G,K);if(!(!Array.isArray(x)||x.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(Ee.g).map(h.DocumentLink.from)};{const pe=this.d.add(x),se={links:[],cacheId:pe};for(let ve=0;ve<x.length;ve++){if(!Ee.g(x[ve]))continue;const Ie=h.DocumentLink.from(x[ve]);Ie.cacheId=[pe,ve],se.links.push(Ie)}return se}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,K){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...O);if(!G)return;const x=await this.f.resolveDocumentLink(G,K);if(!(!x||!Ee.g(x)))return h.DocumentLink.from(x)}releaseLinks(O){this.d.delete(O)}}class Re{constructor(O,K){this.d=O,this.e=K}async provideColors(O,K){const G=this.d.getDocument(O),x=await this.e.provideDocumentColors(G,K);return Array.isArray(x)?x.map(se=>({color:h.Color.from(se.color),range:h.Range.from(se.range)})):[]}async provideColorPresentations(O,K,G){const x=this.d.getDocument(O),pe=h.Range.to(K.range),se=h.Color.to(K.color),ve=await this.e.provideColorPresentations(se,{document:x,range:pe},G);if(Array.isArray(ve))return ve.map(h.ColorPresentation.from)}}class ne{constructor(O,K){this.d=O,this.e=K}async provideFoldingRanges(O,K,G){const x=this.d.getDocument(O),pe=await this.e.provideFoldingRanges(x,K,G);if(Array.isArray(pe))return pe.map(h.FoldingRange.from)}}class ee{constructor(O,K,G){this.d=O,this.e=K,this.f=G}async provideSelectionRanges(O,K,G){const x=this.d.getDocument(O),pe=K.map(h.Position.to),se=await this.e.provideSelectionRanges(x,pe,G);if(!(0,R.$pf)(se))return[];if(se.length!==pe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ve=[];for(let Ie=0;Ie<pe.length;Ie++){const Ue=[];ve.push(Ue);let Ve=pe[Ie],xe=se[Ie];for(;;){if(!xe.range.contains(Ve))throw new Error("INVALID selection range, must contain the previous range");if(Ue.push(h.SelectionRange.from(xe)),!xe.parent)break;Ve=xe.range,xe=xe.parent}}return ve}}class he{constructor(O,K){this.f=O,this.g=K,this.d=new s.$EL(""),this.e=new Map}async prepareSession(O,K,G){const x=this.f.getDocument(O),pe=h.Position.to(K),se=await this.g.prepareCallHierarchy(x,pe,G);if(!se)return;const ve=this.d.nextId();return this.e.set(ve,new Map),Array.isArray(se)?se.map(Ie=>this.h(ve,Ie)):[this.h(ve,se)]}async provideCallsTo(O,K,G){const x=this.j(O,K);if(!x)throw new Error("missing call hierarchy item");const pe=await this.g.provideCallHierarchyIncomingCalls(x,G);if(pe)return pe.map(se=>({from:this.h(O,se.from),fromRanges:se.fromRanges.map(ve=>h.Range.from(ve))}))}async provideCallsFrom(O,K,G){const x=this.j(O,K);if(!x)throw new Error("missing call hierarchy item");const pe=await this.g.provideCallHierarchyOutgoingCalls(x,G);if(pe)return pe.map(se=>({to:this.h(O,se.to),fromRanges:se.fromRanges.map(ve=>h.Range.from(ve))}))}releaseSession(O){this.e.delete(O)}h(O,K){const G=this.e.get(O),x=h.CallHierarchyItem.from(K,O,G.size.toString(36));return G.set(x._itemId,K),x}j(O,K){return this.e.get(O)?.get(K)}}class X{constructor(O,K){this.f=O,this.g=K,this.d=new s.$EL(""),this.e=new Map}async prepareSession(O,K,G){const x=this.f.getDocument(O),pe=h.Position.to(K),se=await this.g.prepareTypeHierarchy(x,pe,G);if(!se)return;const ve=this.d.nextId();return this.e.set(ve,new Map),Array.isArray(se)?se.map(Ie=>this.h(ve,Ie)):[this.h(ve,se)]}async provideSupertypes(O,K,G){const x=this.j(O,K);if(!x)throw new Error("missing type hierarchy item");const pe=await this.g.provideTypeHierarchySupertypes(x,G);if(pe)return pe.map(se=>this.h(O,se))}async provideSubtypes(O,K,G){const x=this.j(O,K);if(!x)throw new Error("missing type hierarchy item");const pe=await this.g.provideTypeHierarchySubtypes(x,G);if(pe)return pe.map(se=>this.h(O,se))}releaseSession(O){this.e.delete(O)}h(O,K){const G=this.e.get(O),x=h.TypeHierarchyItem.from(K,O,G.size.toString(36));return G.set(x._itemId,K),x}j(O,K){return this.e.get(O)?.get(K)}}class ue{constructor(O,K,G,x,pe){this.d=O,this.e=K,this.f=G,this.g=x,this.h=pe}async provideDocumentOnDropEdits(O,K,G,x,pe){const se=this.e.getDocument(K),ve=h.Position.to(G),Ie=h.DataTransfer.toDataTransfer(x,async Ve=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,Ve)).buffer),Ue=await this.f.provideDocumentDropEdits(se,ve,Ie,pe);if(Ue)return{id:Ue.id?this.h.identifier.value+"."+Ue.id:this.h.identifier.value,label:Ue.label??(0,a.localize)(1,null,this.h.displayName||this.h.name),priority:Ue.priority??0,insertText:typeof Ue.insertText=="string"?Ue.insertText:{snippet:Ue.insertText.value},additionalEdit:Ue.additionalEdit?h.WorkspaceEdit.from(Ue.additionalEdit,void 0):void 0}}}class oe{constructor(O,K){this.adapter=O,this.extension=K}}class le{static{this.d=0}constructor(O,K,G,x,pe,se,ve,Ie){this.g=K,this.h=G,this.j=x,this.k=pe,this.l=se,this.m=ve,this.n=Ie,this.f=new Map,this.e=O.getProxy(m.$xJ.MainThreadLanguageFeatures)}o(O,K){return h.DocumentSelector.from(O,this.g,K)}p(O){return new L.$zJ(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return le.d++}async s(O,K,G,x,pe,se=!1){const ve=this.f.get(O);if(!ve||!(ve.adapter instanceof K))return x;const Ie=Date.now();se||this.l.trace(`[${ve.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ue=G(ve.adapter,ve.extension);return Promise.resolve(Ue).catch(Ve=>{(0,y.$2)(Ve)||(this.l.error(`[${ve.extension.identifier.value}] provider FAILED`),this.l.error(Ve),this.n.onExtensionError(ve.extension.identifier,Ve))}).finally(()=>{se||this.l.trace(`[${ve.extension.identifier.value}] provider DONE after ${Date.now()-Ie}ms`)}),S.CancellationToken.isCancellationToken(pe)?(0,C.$jg)(Ue,pe):Ue}t(O,K){const G=this.q();return this.f.set(G,new oe(O,K)),G}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,K,G,x){const pe=this.t(new n(this.h,G),O),se=x&&x.label||le.u(O);return this.e.$registerDocumentSymbolProvider(pe,this.o(K,O),se),this.p(pe)}$provideDocumentSymbols(O,K,G){return this.s(O,n,x=>x.provideDocumentSymbols(k.URI.revive(K),G),void 0,G)}registerCodeLensProvider(O,K,G){const x=this.q(),pe=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new oe(new t(this.h,this.j.converter,G),O)),this.e.$registerCodeLensSupport(x,this.o(K,O),pe);let se=this.p(x);if(pe!==void 0){const ve=G.onDidChangeCodeLenses(Ie=>this.e.$emitCodeLensEvent(pe));se=L.$zJ.from(se,ve)}return se}$provideCodeLenses(O,K,G){return this.s(O,t,x=>x.provideCodeLenses(k.URI.revive(K),G),void 0,G)}$resolveCodeLens(O,K,G){return this.s(O,t,x=>x.resolveCodeLens(K,G),void 0,void 0)}$releaseCodeLenses(O,K){this.s(O,t,G=>Promise.resolve(G.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(O,K,G){const x=this.t(new g(this.h,G),O);return this.e.$registerDefinitionSupport(x,this.o(K,O)),this.p(x)}$provideDefinition(O,K,G,x){return this.s(O,g,pe=>pe.provideDefinition(k.URI.revive(K),G,x),[],x)}registerDeclarationProvider(O,K,G){const x=this.t(new u(this.h,G),O);return this.e.$registerDeclarationSupport(x,this.o(K,O)),this.p(x)}$provideDeclaration(O,K,G,x){return this.s(O,u,pe=>pe.provideDeclaration(k.URI.revive(K),G,x),[],x)}registerImplementationProvider(O,K,G){const x=this.t(new d(this.h,G),O);return this.e.$registerImplementationSupport(x,this.o(K,O)),this.p(x)}$provideImplementation(O,K,G,x){return this.s(O,d,pe=>pe.provideImplementation(k.URI.revive(K),G,x),[],x)}registerTypeDefinitionProvider(O,K,G){const x=this.t(new v(this.h,G),O);return this.e.$registerTypeDefinitionSupport(x,this.o(K,O)),this.p(x)}$provideTypeDefinition(O,K,G,x){return this.s(O,v,pe=>pe.provideTypeDefinition(k.URI.revive(K),G,x),[],x)}registerHoverProvider(O,K,G,x){const pe=this.t(new l(this.h,G),O);return this.e.$registerHoverProvider(pe,this.o(K,O)),this.p(pe)}$provideHover(O,K,G,x){return this.s(O,l,pe=>pe.provideHover(k.URI.revive(K),G,x),void 0,x)}registerEvaluatableExpressionProvider(O,K,G,x){const pe=this.t(new w(this.h,G),O);return this.e.$registerEvaluatableExpressionProvider(pe,this.o(K,O)),this.p(pe)}$provideEvaluatableExpression(O,K,G,x){return this.s(O,w,pe=>pe.provideEvaluatableExpression(k.URI.revive(K),G,x),void 0,x)}registerInlineValuesProvider(O,K,G,x){const pe=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,se=this.t(new P(this.h,G),O);this.e.$registerInlineValuesProvider(se,this.o(K,O),pe);let ve=this.p(se);if(pe!==void 0){const Ie=G.onDidChangeInlineValues(Ue=>this.e.$emitInlineValuesEvent(pe));ve=L.$zJ.from(ve,Ie)}return ve}$provideInlineValues(O,K,G,x,pe){return this.s(O,P,se=>se.provideInlineValues(k.URI.revive(K),G,x,pe),void 0,pe)}registerDocumentHighlightProvider(O,K,G){const x=this.t(new M(this.h,G),O);return this.e.$registerDocumentHighlightProvider(x,this.o(K,O)),this.p(x)}$provideDocumentHighlights(O,K,G,x){return this.s(O,M,pe=>pe.provideDocumentHighlights(k.URI.revive(K),G,x),void 0,x)}registerLinkedEditingRangeProvider(O,K,G){const x=this.t(new N(this.h,G),O);return this.e.$registerLinkedEditingRangeProvider(x,this.o(K,O)),this.p(x)}$provideLinkedEditingRanges(O,K,G,x){return this.s(O,N,async pe=>{const se=await pe.provideLinkedEditingRanges(k.URI.revive(K),G,x);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?le.w(se.wordPattern):void 0}},void 0,x)}registerReferenceProvider(O,K,G){const x=this.t(new T(this.h,G),O);return this.e.$registerReferenceSupport(x,this.o(K,O)),this.p(x)}$provideReferences(O,K,G,x,pe){return this.s(O,T,se=>se.provideReferences(k.URI.revive(K),G,x,pe),void 0,pe)}registerCodeActionProvider(O,K,G,x){const pe=new p.$kb,se=this.t(new z(this.h,this.j.converter,this.k,G,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(se,this.o(K,O),{providedKinds:x?.providedCodeActionKinds?.map(ve=>ve.value),documentation:x?.documentation?.map(ve=>({kind:ve.kind.value,command:this.j.converter.toInternal(ve.command,pe)}))},le.u(O),!!G.resolveCodeAction),pe.add(this.p(se)),pe}$provideCodeActions(O,K,G,x,pe){return this.s(O,z,se=>se.provideCodeActions(k.URI.revive(K),G,x,pe),void 0,pe)}$resolveCodeAction(O,K,G){return this.s(O,z,x=>x.resolveCodeAction(K,G),{},void 0)}$releaseCodeActions(O,K){this.s(O,z,G=>Promise.resolve(G.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(O,K,G){const x=this.t(new U(this.h,G),O);return this.e.$registerDocumentFormattingSupport(x,this.o(K,O),O.identifier,O.displayName||O.name),this.p(x)}$provideDocumentFormattingEdits(O,K,G,x){return this.s(O,U,pe=>pe.provideDocumentFormattingEdits(k.URI.revive(K),G,x),void 0,x)}registerDocumentRangeFormattingEditProvider(O,K,G){const x=typeof G.provideDocumentRangesFormattingEdits=="function";x&&(0,i.$wF)(O,"formatMultipleRanges");const pe=this.t(new Y(this.h,G),O);return this.e.$registerRangeFormattingSupport(pe,this.o(K,O),O.identifier,O.displayName||O.name,x),this.p(pe)}$provideDocumentRangeFormattingEdits(O,K,G,x,pe){return this.s(O,Y,se=>se.provideDocumentRangeFormattingEdits(k.URI.revive(K),G,x,pe),void 0,pe)}$provideDocumentRangesFormattingEdits(O,K,G,x,pe){return this.s(O,Y,se=>se.provideDocumentRangesFormattingEdits(k.URI.revive(K),G,x,pe),void 0,pe)}registerOnTypeFormattingEditProvider(O,K,G,x){const pe=this.t(new H(this.h,G),O);return this.e.$registerOnTypeFormattingSupport(pe,this.o(K,O),x,O.identifier),this.p(pe)}$provideOnTypeFormattingEdits(O,K,G,x,pe,se){return this.s(O,H,ve=>ve.provideOnTypeFormattingEdits(k.URI.revive(K),G,x,pe,se),void 0,se)}registerWorkspaceSymbolProvider(O,K){const G=this.t(new ge(K,this.l),O);return this.e.$registerNavigateTypeSupport(G,typeof K.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(O,K,G){return this.s(O,ge,x=>x.provideWorkspaceSymbols(K,G),{symbols:[]},G)}$resolveWorkspaceSymbol(O,K,G){return this.s(O,ge,x=>x.resolveWorkspaceSymbol(K,G),void 0,void 0)}$releaseWorkspaceSymbols(O,K){this.s(O,ge,G=>G.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(O,K,G){const x=this.t(new ie(this.h,G,this.l),O);return this.e.$registerRenameSupport(x,this.o(K,O),ie.supportsResolving(G)),this.p(x)}$provideRenameEdits(O,K,G,x,pe){return this.s(O,ie,se=>se.provideRenameEdits(k.URI.revive(K),G,x,pe),void 0,pe)}$resolveRenameLocation(O,K,G,x){return this.s(O,ie,pe=>pe.resolveRenameLocation(k.URI.revive(K),G,x),void 0,x)}registerDocumentSemanticTokensProvider(O,K,G,x){const pe=this.t(new q(this.h,G),O),se=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(pe,this.o(K,O),x,se);let ve=this.p(pe);if(se){const Ie=G.onDidChangeSemanticTokens(Ue=>this.e.$emitDocumentSemanticTokensEvent(se));ve=L.$zJ.from(ve,Ie)}return ve}$provideDocumentSemanticTokens(O,K,G,x){return this.s(O,q,pe=>pe.provideDocumentSemanticTokens(k.URI.revive(K),G,x),null,x)}$releaseDocumentSemanticTokens(O,K){this.s(O,q,G=>G.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,K,G,x){const pe=this.t(new V(this.h,G),O);return this.e.$registerDocumentRangeSemanticTokensProvider(pe,this.o(K,O),x),this.p(pe)}$provideDocumentRangeSemanticTokens(O,K,G,x){return this.s(O,V,pe=>pe.provideDocumentRangeSemanticTokens(k.URI.revive(K),G,x),null,x)}registerCompletionItemProvider(O,K,G,x){const pe=this.t(new ce(this.h,this.j.converter,G,this.m,O),O);return this.e.$registerCompletionsProvider(pe,this.o(K,O),x,ce.supportsResolving(G),O.identifier),this.p(pe)}$provideCompletionItems(O,K,G,x,pe){return this.s(O,ce,se=>se.provideCompletionItems(k.URI.revive(K),G,x,pe),void 0,pe)}$resolveCompletionItem(O,K,G){return this.s(O,ce,x=>x.resolveCompletionItem(K,G),void 0,G)}$releaseCompletionItems(O,K){this.s(O,ce,G=>G.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(O,K,G,x){const pe=new fe(O,this.h,G,this.j.converter),se=this.t(pe,O);return this.e.$registerInlineCompletionsSupport(se,this.o(K,O),pe.supportsHandleEvents,D.$Fl.toKey(O.identifier.value),x?.yieldTo?.map(ve=>D.$Fl.toKey(ve))||[]),this.p(se)}$provideInlineCompletions(O,K,G,x,pe){return this.s(O,re,se=>se.provideInlineCompletions(k.URI.revive(K),G,x,pe),void 0,pe)}$handleInlineCompletionDidShow(O,K,G,x){this.s(O,re,async pe=>{pe.handleDidShowCompletionItem(K,G,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,K,G,x){this.s(O,re,async pe=>{pe.handlePartialAccept(K,G,x)},void 0,void 0)}$freeInlineCompletionsList(O,K){this.s(O,re,async G=>{G.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(O,K,G,x){const pe=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,se=this.t(new B(this.h,G),O);return this.e.$registerSignatureHelpProvider(se,this.o(K,O),pe),this.p(se)}$provideSignatureHelp(O,K,G,x,pe){return this.s(O,B,se=>se.provideSignatureHelp(k.URI.revive(K),G,x,pe),void 0,pe)}$releaseSignatureHelp(O,K){this.s(O,B,G=>G.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(O,K,G){const x=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,pe=this.t(new _(this.h,this.j.converter,G,this.l,O),O);this.e.$registerInlayHintsProvider(pe,this.o(K,O),typeof G.resolveInlayHint=="function",x,le.u(O));let se=this.p(pe);if(x!==void 0){const ve=G.onDidChangeInlayHints(Ie=>this.e.$emitInlayHintsEvent(x));se=L.$zJ.from(se,ve)}return se}$provideInlayHints(O,K,G,x){return this.s(O,_,pe=>pe.provideInlayHints(k.URI.revive(K),G,x),void 0,x)}$resolveInlayHint(O,K,G){return this.s(O,_,x=>x.resolveInlayHint(K,G),void 0,G)}$releaseInlayHints(O,K){this.s(O,_,G=>G.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(O,K,G){const x=this.t(new Ee(this.h,G),O);return this.e.$registerDocumentLinkProvider(x,this.o(K,O),typeof G.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(O,K,G){return this.s(O,Ee,x=>x.provideLinks(k.URI.revive(K),G),void 0,G,K.scheme==="output")}$resolveDocumentLink(O,K,G){return this.s(O,Ee,x=>x.resolveLink(K,G),void 0,void 0,!0)}$releaseDocumentLinks(O,K){this.s(O,Ee,G=>G.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(O,K,G){const x=this.t(new Re(this.h,G),O);return this.e.$registerDocumentColorProvider(x,this.o(K,O)),this.p(x)}$provideDocumentColors(O,K,G){return this.s(O,Re,x=>x.provideColors(k.URI.revive(K),G),[],G)}$provideColorPresentations(O,K,G,x){return this.s(O,Re,pe=>pe.provideColorPresentations(k.URI.revive(K),G,x),void 0,x)}registerFoldingRangeProvider(O,K,G){const x=this.q(),pe=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new oe(new ne(this.h,G),O)),this.e.$registerFoldingRangeProvider(x,this.o(K,O),O.identifier,pe);let se=this.p(x);if(pe!==void 0){const ve=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(pe));se=L.$zJ.from(se,ve)}return se}$provideFoldingRanges(O,K,G,x){return this.s(O,ne,pe=>pe.provideFoldingRanges(k.URI.revive(K),G,x),void 0,x)}registerSelectionRangeProvider(O,K,G){const x=this.t(new ee(this.h,G,this.l),O);return this.e.$registerSelectionRangeProvider(x,this.o(K,O)),this.p(x)}$provideSelectionRanges(O,K,G,x){return this.s(O,ee,pe=>pe.provideSelectionRanges(k.URI.revive(K),G,x),[],x)}registerCallHierarchyProvider(O,K,G){const x=this.t(new he(this.h,G),O);return this.e.$registerCallHierarchyProvider(x,this.o(K,O)),this.p(x)}$prepareCallHierarchy(O,K,G,x){return this.s(O,he,pe=>Promise.resolve(pe.prepareSession(k.URI.revive(K),G,x)),void 0,x)}$provideCallHierarchyIncomingCalls(O,K,G,x){return this.s(O,he,pe=>pe.provideCallsTo(K,G,x),void 0,x)}$provideCallHierarchyOutgoingCalls(O,K,G,x){return this.s(O,he,pe=>pe.provideCallsFrom(K,G,x),void 0,x)}$releaseCallHierarchy(O,K){this.s(O,he,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(O,K,G){const x=this.t(new X(this.h,G),O);return this.e.$registerTypeHierarchyProvider(x,this.o(K,O)),this.p(x)}$prepareTypeHierarchy(O,K,G,x){return this.s(O,X,pe=>Promise.resolve(pe.prepareSession(k.URI.revive(K),G,x)),void 0,x)}$provideTypeHierarchySupertypes(O,K,G,x){return this.s(O,X,pe=>pe.provideSupertypes(K,G,x),void 0,x)}$provideTypeHierarchySubtypes(O,K,G,x){return this.s(O,X,pe=>pe.provideSubtypes(K,G,x),void 0,x)}$releaseTypeHierarchy(O,K){this.s(O,X,G=>Promise.resolve(G.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(O,K,G,x){const pe=this.q();return this.f.set(pe,new oe(new ue(this.e,this.h,G,pe,O),O)),this.e.$registerDocumentOnDropEditProvider(pe,this.o(K,O),(0,i.$vF)(O,"dropMetadata")?x:void 0),this.p(pe)}$provideDocumentOnDropEdits(O,K,G,x,pe,se){return this.s(O,ue,ve=>Promise.resolve(ve.provideDocumentOnDropEdits(K,k.URI.revive(G),x,pe,se)),void 0,void 0)}registerDocumentPasteEditProvider(O,K,G,x){const pe=this.q();return this.f.set(pe,new oe(new j(this.e,this.h,G,pe,O),O)),this.e.$registerPasteEditProvider(pe,this.o(K,O),{supportsCopy:!!G.prepareDocumentPaste,supportsPaste:!!G.provideDocumentPasteEdits,copyMimeTypes:x.copyMimeTypes,pasteMimeTypes:x.pasteMimeTypes}),this.p(pe)}$prepareDocumentPaste(O,K,G,x,pe){return this.s(O,j,se=>se.prepareDocumentPaste(k.URI.revive(K),G,x,pe),void 0,pe)}$providePasteEdits(O,K,G,x,pe,se){return this.s(O,j,ve=>ve.providePasteEdits(K,k.URI.revive(G),x,pe,se),void 0,se)}static w(O){return{pattern:O.source,flags:(0,E.$yd)(O)}}static y(O){return{decreaseIndentPattern:le.w(O.decreaseIndentPattern),increaseIndentPattern:le.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?le.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?le.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:le.w(O.beforeText),afterText:O.afterText?le.w(O.afterText):void 0,previousLineText:O.previousLineText?le.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(le.z)}setLanguageConfiguration(O,K,G){const{wordPattern:x}=G;if(x&&(0,E.$wd)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(K,x):this.h.setWordDefinitionFor(K,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use."),G.autoClosingPairs&&(0,i.$wF)(O,"languageConfigurationAutoClosingPairs");const pe=this.q(),se={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?le.w(G.wordPattern):void 0,indentationRules:G.indentationRules?le.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?le.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport,autoClosingPairs:G.autoClosingPairs};return this.e.$setLanguageConfiguration(pe,K,se),this.p(pe)}$setWordDefinitions(O){for(const K of O)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Q$b=le}),define(De[297],Ce([1,0,6,16,7,40,17,4]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=void 0;class E{constructor(R,I,$,S){this.c=I,this.d=$,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=R.getProxy(k.$xJ.MainThreadLanguages)}$acceptLanguageIds(R){this.b=R}async getLanguages(){return this.b.slice(0)}async changeLanguage(R,I){await this.a.$changeLanguage(R,I);const $=this.c.getDocumentData(R);if(!$)throw new Error(`document '${R.toString()}' NOT found`);return $.document}async tokenAtPosition(R,I){const $=R.version,S=F.Position.from(I),D=await this.a.$tokensAtPosition(R.uri,S),p={type:h.StandardTokenType.Other,range:R.getWordRangeAtPosition(I)??new h.$BJ(I.line,I.character,I.line,I.character)};if(!D)return p;const r={range:F.Range.to(D.range),type:F.TokenType.to(D.type)};return!r.range.contains(I)||$!==R.version?p:r}createLanguageStatusItem(R,I,$){const S=this.f++,D=this.a,p=this.g,r=`${R.identifier.value}/${I}`;if(p.has(r))throw new Error(`LanguageStatusItem with id '${I}' ALREADY exists`);p.add(r);const s={selector:$,id:I,name:R.displayName??R.name,severity:h.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let c;const f=new m.$kb,y=()=>{if(c?.dispose(),!p.has(r)){console.warn(`LanguageStatusItem (${I}) from ${R.identifier.value} has been disposed and CANNOT be updated anymore`);return}c=(0,A.$vg)(()=>{f.clear(),this.a.$setLanguageStatus(S,{id:r,name:s.name??R.displayName??R.name,source:R.displayName??R.name,selector:F.DocumentSelector.from(s.selector,this.e),label:s.text,detail:s.detail??"",severity:s.severity===h.LanguageStatusSeverity.Error?L.default.Error:s.severity===h.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:s.command&&this.d.toInternal(s.command,f),accessibilityInfo:s.accessibilityInformation,busy:s.busy})},0)},C={dispose(){f.dispose(),c?.dispose(),D.$removeLanguageStatus(S),p.delete(r)},get id(){return s.id},get name(){return s.name},set name(i){s.name=i,y()},get selector(){return s.selector},set selector(i){s.selector=i,y()},get text(){return s.text},set text(i){s.text=i,y()},get detail(){return s.detail},set detail(i){s.detail=i,y()},get severity(){return s.severity},set severity(i){s.severity=i,y()},get accessibilityInformation(){return s.accessibilityInformation},set accessibilityInformation(i){s.accessibilityInformation=i,y()},get command(){return s.command},set command(i){s.command=i,y()},get busy(){return s.busy},set busy(i){s.busy=i,y()}};return y(),C}}e.$y_b=E}),define(De[106],Ce([1,0,11,12,2,5,18,6,26,20]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o_b=e.$n_b=void 0;let R=class{constructor($,S,D){this.f=D,this.d=new Map,this.a=S.getProxy(m.$xJ.MainThreadLocalization),this.b=$.environment.appLanguage,this.c=this.b===k.$f}getMessage($,S){const{message:D,args:p,comment:r}=S;if(this.c)return(0,F.$ld)(D,p??{});let s=D;r&&r.length>0&&(s+=`/${Array.isArray(r)?r.join(""):r}`);const c=this.d.get($)?.contents[s];return c||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,F.$ld)(c??D,p??{})}getBundle($){return this.d.get($)?.contents}getBundleUri($){return this.d.get($)?.uri}async initializeLocalizedMessages($){if(this.c||!$.l10n&&!$.isBuiltin||this.d.has($.identifier.value))return;let S;const D=await this.g($);if(!D){this.f.error(`No bundle location found for extension ${$.identifier.value}`);return}try{const p=await this.a.$fetchBundleContents(D),r=JSON.parse(p);S=$.isBuiltin?r.contents?.bundle:r}catch(p){this.f.error(`Failed to load translations for ${$.identifier.value} from ${D}: ${p.message}`);return}S&&this.d.set($.identifier.value,{contents:S,uri:D})}async g($){if($.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri($.identifier.value,this.b);return h.URI.revive(S)}return $.l10n?h.URI.joinPath($.extensionLocation,$.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$n_b=R,e.$n_b=R=Je([qe(0,E.$PL),qe(1,b.$zL),qe(2,A.$Pi)],R),e.$o_b=(0,L.$nh)("IExtHostLocalizationService")}),define(De[143],Ce([1,0,18,6,26,20,2,73]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0;let E=class extends k.$1i{constructor(I,$){super($.logLevel,$.logsLocation,$.loggers.map(S=>(0,m.$Wg)(S))),this.n=I.getProxy(F.$xJ.MainThreadLogger)}$setLogLevel(I,$){$?this.setLogLevel(A.URI.revive($),I):this.setLogLevel(I)}setVisibility(I,$){super.setVisibility(I,$),this.n.$setVisibility(I,$)}m(I,$,S){return new b(this.n,I,$,S)}};e.$Kac=E,e.$Kac=E=Je([qe(0,L.$zL),qe(1,h.$PL)],E);class b extends k.$Vi{constructor(I,$,S,D){super(D?.logLevel==="always"),this.m=I,this.n=$,this.k=!1,this.l=[],this.setLevel(S),this.m.$createLogger($,D).then(()=>{this.r(this.l),this.k=!0})}g(I,$){const S=[[I,$]];this.k?this.r(S):this.l.push(...S)}r(I){this.m.$log(this.n,I)}flush(){this.m.$flush(this.n)}}}),define(De[107],Ce([1,0,6,5,4,20,22]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=e.$p_b=void 0,e.$p_b=(0,F.$nh)("IExtHostManagedSockets");let m=class{constructor(I){this.b=0,this.c=null,this.d=new Map,this.a=I.getProxy(k.$xJ.MainThreadManagedSockets)}setFactory(I,$){for(const S of this.d.values())S.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new E(I,$),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(I){if(!this.c||this.c.socketFactoryId!==I)throw new Error(`No socket factory with id ${I}`);const $=++this.b,S=await this.c.makeConnection(),D=new h.$kb;return this.d.set($,new b($,S,D)),D.add((0,h.$jb)(()=>this.d.delete($))),D.add(S.onDidEnd(()=>{this.a.$onDidManagedSocketEnd($),D.dispose()})),D.add(S.onDidClose(p=>{this.a.$onDidManagedSocketClose($,p?.stack??p?.message),D.dispose()})),D.add(S.onDidReceiveMessage(p=>this.a.$onDidManagedSocketHaveData($,A.$Jb.wrap(p)))),$}$remoteSocketWrite(I,$){this.d.get(I)?.actual.send($.buffer)}$remoteSocketEnd(I){const $=this.d.get(I);$&&($.actual.end(),$.dispose())}async $remoteSocketDrain(I){await this.d.get(I)?.actual.drain?.()}};e.$q_b=m,e.$q_b=m=Je([qe(0,L.$zL)],m);class E{constructor(I,$){this.socketFactoryId=I,this.makeConnection=$}}class b extends h.$lb{constructor(I,$,S){super(),this.socketId=I,this.actual=$,this.B(S)}}}),define(De[298],Ce([1,0,6,18,27]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z_b=void 0;function L(m){return m&&m.title}let A=class{constructor(E,b){this.b=b,this.a=E.getProxy(k.$xJ.MainThreadMessageService)}showMessage(E,b,R,I,$){const S={source:{identifier:E.identifier,label:E.displayName||E.name}};let D;typeof I=="string"||L(I)?D=[I,...$]:(S.modal=I?.modal,S.useCustom=I?.useCustom,S.detail=I?.detail,D=$),S.useCustom&&(0,h.$wF)(E,"resolvers");const p=[];for(let r=0;r<D.length;r++){const s=D[r];if(typeof s=="string")p.push({title:s,handle:r,isCloseAffordance:!1});else if(typeof s=="object"){const{title:c,isCloseAffordance:f}=s;p.push({title:c,isCloseAffordance:!!f,handle:r})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(b,R,S,p).then(r=>{if(typeof r=="number")return D[r]})}};e.$z_b=A,e.$z_b=A=Je([qe(1,F.$Pi)],A)}),define(De[299],Ce([1,0,197,22,3,4,28,12,14,2,30,81,6,36,16,7,60,266,138,8,23,15]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hac=void 0;class i{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,t,o,g,u){this.q=o,this.r=g,this.s=u,this.f=new Map,this.g=new A.$li,this.h=new Map,this.j=new h.$7c({onListenerError:f.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new h.$7c({onListenerError:f.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new h.$7c({onListenerError:f.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new h.$7c({onListenerError:f.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.$H$b("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy($.$xJ.MainThreadNotebook),this.c=n.getProxy($.$xJ.MainThreadNotebookDocuments),this.d=n.getProxy($.$xJ.MainThreadNotebookEditors),this.i=t.converter,t.registerArgumentProcessor({processArgument:d=>{if(d&&d.$mid===13){const v=d.notebookEditor?.notebookUri,l=d.cell.handle,P=this.g.get(v)?.getCell(l);if(P)return P.apiCell}if(d&&d.$mid===14){const v=d.uri,l=this.g.get(v);if(l)return l.apiNotebook}return d}}),i.A(t)}getEditorById(n){const t=this.h.get(n);if(!t)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return t}getIdByEditor(n){for(const[t,o]of this.h)if(o.apiEditor===n)return t}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,t){const o=this.g.get(n);if(!o&&!t)throw new Error(`NO notebook document for '${n}'`);return o}static t(n,t){if(!t)return;const o=t.filenamePattern.map(g=>D.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(t.filenamePattern&&!o){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:t.displayName,filenamePattern:o,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,t,o){const g=i.a++,u=typeof o.onDidChangeCellStatusBarItems=="function"?i.a++:void 0;this.f.set(g,o),this.b.$registerNotebookCellStatusBarItemProvider(g,u,t);let d;return u!==void 0&&(d=o.onDidChangeCellStatusBarItems(v=>this.b.$emitCellStatusBarEvent(u))),new p.$zJ(()=>{this.f.delete(g),this.b.$unregisterNotebookCellStatusBarItemProvider(g,u),d?.dispose()})}async createNotebookDocument(n){const t=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&D.NotebookData.from(n.content)});return b.URI.revive(t)}async openNotebookDocument(n){const t=this.g.get(n);if(t)return t.apiNotebook;const o=await this.c.$tryOpenNotebook(n),g=this.g.get(b.URI.revive(o));return(0,E.$te)(g?.apiNotebook)}async showNotebookDocument(n,t){b.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let o;typeof t=="object"?o={position:D.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(D.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:o={preserveFocus:!1};const g=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,o),u=g&&this.h.get(g)?.apiEditor;if(u)return u;throw g?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,t,o,g){const u=this.f.get(n),d=b.URI.revive(t),v=this.g.get(d);if(!v||!u)return;const l=v.getCellFromIndex(o);if(!l)return;const w=await u.provideCellStatusBarItems(l.apiCell,g);if(!w)return;const P=new L.$kb,M=this.p.add([P]),T=(Array.isArray(w)?w:[w]).map(z=>D.NotebookStatusBarItem.from(z,this.i,P));return{cacheId:M,items:T}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,t,o,g,u){if((0,m.$jd)(t))throw new Error("viewType cannot be empty or just whitespace");const d=this.u++;return this.w.set(d,{viewType:t,serializer:o,options:g}),this.b.$registerNotebookSerializer(d,{id:n.identifier,location:n.extensionLocation},t,D.NotebookDocumentContentOptions.from(g),i.t(n,u)),(0,L.$jb)(()=>{this.b.$unregisterNotebookSerializer(d)})}async $dataToNotebook(n,t,o){const g=this.w.get(n);if(!g)throw new Error("NO serializer found");const u=await g.serializer.deserializeNotebook(t.buffer,o);return new r.$Wz(D.NotebookData.from(u))}async $notebookToData(n,t,o){const g=this.w.get(n);if(!g)throw new Error("NO serializer found");const u=await g.serializer.serializeNotebook(D.NotebookData.to(t.value),o);return F.$Jb.wrap(u)}async $saveNotebook(n,t,o,g,u){const d=b.URI.revive(t),v=this.w.get(n);if(!v)throw new Error("NO serializer found");const l=this.g.get(d);if(!l)throw new Error("Document NOT found");if(l.versionId!==o)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(d.scheme))throw new R.$$j((0,k.localize)(0,null,this.y(d)),6);await this.x(d,g);const w={metadata:(0,y.$Nm)(l.apiNotebook.metadata,z=>!(v.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of l.apiNotebook.getCells()){const j=new p.$YK(z.kind,z.document.getText(),z.document.languageId,z.mime,v.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);j.metadata=(0,y.$Nm)(z.metadata,U=>!(v.options?.transientCellMetadata??{})[U]),w.cells.push(j)}const P=await v.serializer.serializeNotebook(w,u);await this.s.value.writeFile(d,P);const M=this.s.getFileSystemProviderExtUri(d.scheme),N=await this.s.value.stat(d);return{name:M.basename(d),isFile:(N.type&R.FileType.File)!==0,isDirectory:(N.type&R.FileType.Directory)!==0,isSymbolicLink:(N.type&R.FileType.SymbolicLink)!==0,mtime:N.mtime,ctime:N.ctime,size:N.size,readonly:!!((N.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(d.scheme),locked:!!((N.permissions??0)&R.FilePermission.Locked),etag:R.$jk({mtime:N.mtime,size:N.size}),children:void 0}}async x(n,t){const o=await this.s.value.stat(n);if(typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==R.$ik&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==R.$jk({mtime:t.mtime,size:o.size}))throw new R.$$j((0,k.localize)(1,null),3,t)}y(n){return n.scheme===C.Schemas.file?n.fsPath:n.toString()}z(n,t,o){if(this.h.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const g=new c.$gac(t,this.d,n,o.visibleRanges.map(D.NotebookRange.to),o.selections.map(D.NotebookRange.to),typeof o.viewColumn=="number"?D.ViewColumn.to(o.viewColumn):void 0);this.h.set(t,g)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const o of n.value.removedDocuments){const g=b.URI.revive(o),u=this.g.get(g);u&&(u.dispose(),this.g.delete(g),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:u.apiNotebook.getCells().map(d=>d.document.uri)}),this.n.fire(u.apiNotebook));for(const d of this.h.values())d.notebookData.uri.toString()===g.toString()&&this.h.delete(d.id)}if(n.value.addedDocuments){const o=[];for(const g of n.value.addedDocuments){const u=b.URI.revive(g.uri);if(this.g.has(u))throw new Error(`adding EXISTING notebook ${u} `);const d=new s.$fac(this.c,this.q,this.r,u,g);o.push(...g.cells.map(v=>s.$eac.asModelAddData(d.apiNotebook,v))),this.g.get(u)?.dispose(),this.g.set(u,d),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:o}),this.m.fire(d.apiNotebook)}}if(n.value.addedEditors)for(const o of n.value.addedEditors){if(this.h.has(o.id))return;const g=b.URI.revive(o.documentUri),u=this.g.get(g);u&&this.z(u,o.id,o)}const t=[];if(n.value.removedEditors)for(const o of n.value.removedEditors){const g=this.h.get(o);g&&(this.h.delete(o),this.k?.id===g.id&&(this.k=void 0),t.push(g))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(g=>this.h.get(g)).filter(g=>!!g);const o=new Set;this.l.forEach(g=>o.add(g.id));for(const g of this.h.values()){const u=o.has(g.id);g._acceptVisibility(u)}this.l=[...this.h.values()].map(g=>g).filter(g=>g.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const t=S.$XL.String.with("notebookType","A notebook type"),o=new S.$ZL("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[t,new S.$XL("data","Bytes to convert to data",u=>u instanceof Uint8Array,u=>F.$Jb.wrap(u))],new S.$YL("Notebook Data",u=>D.NotebookData.to(u.value))),g=new S.$ZL("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[t,new S.$XL("NotebookData","Notebook data to convert to bytes",u=>!0,u=>new r.$Wz(D.NotebookData.from(u)))],new S.$YL("Bytes",u=>u.buffer));n.registerApiCommand(o),n.registerApiCommand(g)}}e.$hac=i}),define(De[300],Ce([1,0,19,17,21,3,4,28,2,25,18,81,6,36,16,7,104,260,27,60]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=e.$vac=void 0;let y=class{constructor(u,d,v,l,w){this.m=d,this.n=v,this.o=l,this.q=w,this.b=new m.$li,this.c=new m.$li,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new I.$H$b("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.$7c,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=u.getProxy($.$xJ.MainThreadNotebookKernels);const P=new S.$ZL("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.$XL("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const N=this.n.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:N}}else if(M&&"notebookEditor"in M){const N=this.n.getIdByEditor(M.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return M})],S.$YL.Void);this.o.registerApiCommand(P)}createNotebookController(u,d,v,l,w,P){for(const re of this.j.values())if(re.controller.id===d&&b.$Fl.equals(u.identifier,re.extensionId))throw new Error(`notebook controller with id '${d}' ALREADY exist`);const M=this.k++,N=this;this.q.trace(`NotebookController[${M}], CREATED by ${u.identifier.value}, ${d}`);const T=()=>console.warn(`NO execute handler from notebook controller '${H.id}' of extension: '${u.identifier}'`);let z=!1;const j=new A.$kb,U=new L.$7c,Y=new L.$7c,H={id:o(u.identifier,d),notebookType:v,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:l||u.identifier.value,preloads:P?P.map(D.NotebookRendererScript.from):[]};let ge=w??T,ie;this.a.$addKernel(M,H).catch(re=>{console.log(re),z=!0});let te=0;const q=()=>{if(z)return;const re=++te;Promise.resolve().then(()=>{re===te&&this.a.$updateKernel(M,H)})},V=new m.$li,ce={get id(){return d},get notebookType(){return H.notebookType},onDidChangeSelectedNotebooks:U.event,get label(){return H.label},set label(re){H.label=re??u.displayName??u.name,q()},get detail(){return H.detail??""},set detail(re){H.detail=re,q()},get description(){return H.description??""},set description(re){H.description=re,q()},get supportedLanguages(){return H.supportedLanguages},set supportedLanguages(re){H.supportedLanguages=re,q()},get supportsExecutionOrder(){return H.supportsExecutionOrder??!1},set supportsExecutionOrder(re){H.supportsExecutionOrder=re,q()},get rendererScripts(){return H.preloads?H.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return ge},set executeHandler(re){ge=re??T},get interruptHandler(){return ie},set interruptHandler(re){ie=re,H.supportsInterrupt=!!re,q()},createNotebookCellExecution(re){if(z)throw new Error("notebook controller is DISPOSED");if(!V.has(re.notebook.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(fe=>fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.notebook.uri.toString()}`);return N._createNotebookCellExecution(re,o(u.identifier,this.id))},createNotebookExecution(re){if((0,c.$wF)(u,"notebookExecution"),z)throw new Error("notebook controller is DISPOSED");if(!V.has(re.uri))throw N.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(V.keys()).map(fe=>fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${re.uri.toString()}`);return N._createNotebookExecution(re,o(u.identifier,this.id))},dispose:()=>{z||(this.q.trace(`NotebookController[${M}], DISPOSED`),z=!0,this.j.delete(M),j.dispose(),U.dispose(),Y.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(re,fe){fe===p.NotebookControllerAffinity2.Hidden&&(0,c.$wF)(u,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(M,re.uri,fe)},onDidReceiveMessage:Y.event,postMessage(re,fe){return(0,c.$wF)(u,"notebookMessaging"),N.a.$postMessage(M,fe&&N.n.getIdByEditor(fe),re)},asWebviewUri(re){return(0,c.$wF)(u,"notebookMessaging"),(0,r.$dnb)(re,N.m.remote)}};return this.j.set(M,{extensionId:u.identifier,controller:ce,onDidReceiveMessage:Y,onDidChangeSelection:U,associatedNotebooks:V}),ce}getIdByController(u){for(const[d,v]of this.j)if(v.controller===u)return o(v.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,d){const v=this.f++,l=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${u.identifier.value}`),this.a.$addKernelDetectionTask(v,d);const w={dispose:()=>{this.e.delete(v),l.a.$removeKernelDetectionTask(v)}};return this.e.set(v,w),w}registerKernelSourceActionProvider(u,d,v){const l=this.h++,w=typeof v.onDidChangeNotebookKernelSourceActions=="function"?l:void 0,P=this;this.g.set(l,v),this.q.trace(`NotebookKernelSourceActionProvider[${l}], CREATED by ${u.identifier.value}`),this.a.$addKernelSourceActionProvider(l,l,d);let M;return w!==void 0&&(M=v.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(w))),{dispose:()=>{this.g.delete(l),P.a.$removeKernelSourceActionProvider(l,l),M?.dispose()}}}async $provideKernelSourceActions(u,d){const v=this.g.get(u);if(v){const l=new A.$kb;return this.i.add([l]),(await v.provideNotebookKernelSourceActions(d)??[]).map(P=>D.NotebookKernelSourceAction.from(P,this.o.converter,l))}return[]}$acceptNotebookAssociation(u,d,v){const l=this.j.get(u);if(l){const w=this.n.getNotebookDocument(E.URI.revive(d));v?l.associatedNotebooks.set(w.uri,!0):l.associatedNotebooks.delete(w.uri),this.q.trace(`NotebookController[${u}] ASSOCIATE notebook`,w.uri.toString(),v),l.onDidChangeSelection.fire({selected:v,notebook:w.apiNotebook})}}async $executeCells(u,d,v){const l=this.j.get(u);if(!l)return;const w=this.n.getNotebookDocument(E.URI.revive(d)),P=[];for(const M of v){const N=w.getCell(M);N&&P.push(N.apiCell)}try{this.q.trace(`NotebookController[${u}] EXECUTE cells`,w.uri.toString(),P.length),await l.controller.executeHandler.call(l.controller,P,w.apiNotebook,l.controller)}catch(M){this.q.error(`NotebookController[${u}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(u,d,v){const l=this.j.get(u);if(!l)return;const w=this.n.getNotebookDocument(E.URI.revive(d));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,w.apiNotebook);else for(const P of v){const M=w.getCell(P);M&&this.b.get(M.uri)?.cancel()}if(l.controller.interruptHandler){const P=this.c.get(w.uri);v.length&&Array.isArray(P)&&P.length&&P.forEach(M=>M.dispose())}}$acceptKernelMessageFromRenderer(u,d,v){const l=this.j.get(u);if(!l)return;const w=this.n.getEditorById(d);l.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:v}))}$cellExecutionChanged(u,d,v){const w=this.n.getNotebookDocument(E.URI.revive(u)).getCell(d);if(w){const P=v?D.NotebookCellExecutionState.to(v):p.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:w.apiCell,state:P})}}_createNotebookCellExecution(u,d){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this.n.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!l)throw new Error("invalid cell");if(this.b.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const w=new i(d,l,this.a);this.b.set(l.uri,w);const P=w.onDidChangeState(()=>{w.state===C.Resolved&&(w.dispose(),P.dispose(),this.b.delete(l.uri))});return w.asApiObject()}_createNotebookExecution(u,d){const v=this.n.getNotebookDocument(u.uri),l=u.getCells().find(M=>{const N=v.getCellFromApiCell(M);return N&&this.b.has(N.uri)});if(l)throw new Error(`duplicate cell execution for ${l.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const w=new n(d,v,this.a),P=w.onDidChangeState(()=>{w.state===a.Resolved&&(w.dispose(),P.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[w,P]),w.asApiObject()}};e.$vac=y,e.$vac=y=Je([qe(4,R.$Pi)],y);var C;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(C||(C={}));class i extends A.$lb{static{this.a=0}get state(){return this.f}constructor(u,d,v){super(),this.j=d,this.k=v,this.b=i.a++,this.c=new L.$7c,this.onDidChangeState=this.c.event,this.f=C.Init,this.g=this.B(new h.$dd),this.h=new t(10,l=>this.m(l)),this.i=d.internalMetadata.executionOrder,this.k.$createExecution(this.b,u,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(u){await this.h.addItem(u)}async m(u){const d=Array.isArray(u)?u:[u];return this.k.$updateExecution(this.b,new f.$Wz(d))}n(){if(this.f===C.Init)throw new Error("Must call start before modifying cell output");if(this.f===C.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(u){let d=this.j;if(u&&(d=this.j.notebook.getCellFromApiCell(u)),!d)throw new Error("INVALID cell");return d.handle}s(u){return u.map(d=>{const v=p.$2K.ensureUniqueMimeTypes(d.items,!0);return v===d.items?D.NotebookCellOutput.from(d):D.NotebookCellOutput.from({items:v,id:d.id,metadata:d.metadata})})}async t(u,d,v){const l=this.r(d),w=this.s((0,k.$If)(u));return this.l({editType:s.CellExecutionUpdateType.Output,cellHandle:l,append:v,outputs:w})}async w(u,d,v){return u=p.$2K.ensureUniqueMimeTypes((0,k.$If)(u),!0),this.l({editType:s.CellExecutionUpdateType.OutputItems,items:u.map(D.NotebookCellOutputItem.from),outputId:d.id,append:v})}asApiObject(){const u=this;return Object.freeze({get token(){return u.g.token},get cell(){return u.j.apiCell},get executionOrder(){return u.i},set executionOrder(v){u.i=v,u.m([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:u.i}])},start(v){if(u.f===C.Resolved||u.f===C.Started)throw new Error("Cannot call start again");u.f=C.Started,u.c.fire(),u.m({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,l){if(u.f===C.Resolved)throw new Error("Cannot call resolve twice");u.f=C.Resolved,u.c.fire(),u.h.flush(),u.k.$completeExecution(u.b,new f.$Wz({runEndTime:l,lastRunSuccess:v}))},clearOutput(v){return u.n(),u.t([],v,!1)},appendOutput(v,l){return u.n(),u.t(v,l,!0)},replaceOutput(v,l){return u.n(),u.t(v,l,!1)},appendOutputItems(v,l){return u.n(),u.w(v,l,!0)},replaceOutputItems(v,l){return u.n(),u.w(v,l,!1)}})}}var a;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(a||(a={}));class n extends A.$lb{static{this.a=0}get state(){return this.f}constructor(u,d,v){super(),this.h=d,this.i=v,this.b=n.a++,this.c=new L.$7c,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new h.$dd),this.i.$createNotebookExecution(this.b,u,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}class t{constructor(u,d){this.e=u,this.f=d,this.a=[],this.b=Date.now()}addItem(u){return this.a.push(u),this.c||(this.c=new F.$Ng,this.b=Date.now(),(0,F.$ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const u=this.c;this.c=void 0;const d=this.a;return this.a=[],this.f(d).finally(()=>u.complete())}}function o(g,u){return`${g.value}/${u}`}e.$wac=o}),define(De[301],Ce([1,0,3,6,138]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=void 0;class L{constructor(m,E){this.c=E,this.a=new Map,this.b=m.getProxy(F.$xJ.MainThreadNotebookRenderers)}$postRendererMessage(m,E,b){const R=this.c.getEditorById(m);this.a.get(E)?.fire({editor:R.apiEditor,message:b})}createRendererMessaging(m,E){if(!m.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,I,$)=>this.d(E).event(R,I,$),postMessage:(R,I)=>{h.$gac.apiEditorsToExtHost.has(R)&&([R,I]=[I,R]);const $=I&&h.$gac.apiEditorsToExtHost.get(I);return this.b.$postMessage($?.id,E,R)}}}d(m){let E=this.a.get(m);return E||(E=new k.$7c({onDidRemoveLastListener:()=>{E?.dispose(),this.a.delete(m)}}),this.a.set(m,E),E)}}e.$xac=L}),define(De[302],Ce([1,0,4,14,2,27,6]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=void 0;class m{constructor(b){this.b=new Map,this.a=b.getProxy(A.$xJ.MainThreadProfileContentHandlers)}registrProfileContentHandler(b,R,I){if((0,L.$wF)(b,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,I),this.a.$registerProfileContentHandler(R,I.name,I.description,b.identifier.value),(0,k.$jb)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(b,R,I,$){const S=this.b.get(b);if(!S)throw new Error(`Unknown handler with id: ${b}`);return S.saveProfile(R,I,$)}async $readProfile(b,R,I){const $=this.b.get(b);if(!$)throw new Error(`Unknown handler with id: ${b}`);return $.readProfile((0,F.$ie)(R)?R:h.URI.revive(R),I)}}e.$Bac=m}),define(De[303],Ce([1,0,2,6,17,16]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=void 0;class A{static{this.a=0}constructor(E,b){this.d=b,this.c=new Map,this.b=E.getProxy(F.$xJ.MainThreadQuickDiff)}$provideOriginalResource(E,b,R){const I=k.URI.revive(b),$=this.c.get(E);return $?(0,h.$mg)(()=>$.provideOriginalResource(I,R)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(E,b,R,I){const $=A.a++;return this.c.set($,b),this.b.$registerQuickDiffProvider($,L.DocumentSelector.from(E,this.d),R,I),{dispose:()=>{this.b.$unregisterQuickDiffProvider($),this.c.delete($)}}}}e.$Cac=A}),define(De[304],Ce([1,0,21,3,4,6,2,7,8,19,40,55,27,16]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=void 0;function D(p,r,s){const c=p.getProxy(L.$xJ.MainThreadQuickOpen);class f{constructor(u,d){this.e=new Map,this.f=0,this.a=u,this.b=d}showQuickPick(u,d,v,l=k.CancellationToken.None){this.c=void 0;const w=Promise.resolve(d),P=++this.f,M=c.$show(P,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},l),N={},T=M.then(()=>N);return Promise.race([T,w]).then(z=>{if(z===N)return;const j=(0,$.$vF)(u,"quickPickItemTooltip");return w.then(U=>{const Y=[];for(let H=0;H<U.length;H++){const ge=U[H];if(typeof ge=="string")Y.push({label:ge,handle:H});else if(ge.kind===m.QuickPickItemKind.Separator)Y.push({type:"separator",label:ge.label});else{ge.tooltip&&!j&&console.warn(`Extension '${u.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${u.identifier.value}`);const ie=ge.iconPath?n(ge.iconPath):void 0;Y.push({label:ge.label,iconPath:ie?.iconPath,iconClass:ie?.iconClass,description:ge.description,detail:ge.detail,picked:ge.picked,alwaysShow:ge.alwaysShow,tooltip:j?S.MarkdownString.fromStrict(ge.tooltip):void 0,handle:H})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=H=>{v.onDidSelectItem(U[H])}),c.$setItems(P,Y),M.then(H=>{if(typeof H=="number")return U[H];if(Array.isArray(H))return H.map(ge=>U[ge])})})}).then(void 0,z=>{if(!(0,E.$2)(z))return c.$setError(P,z),Promise.reject(z)})}$onItemSelected(u){this.c?.(u)}showInput(u,d=k.CancellationToken.None){return this.d=u?.validateInput,c.$input(u,typeof this.d=="function",d).then(void 0,v=>{if(!(0,E.$2)(v))return Promise.reject(v)})}async $validateInput(u){if(!this.d)return;const d=await this.d(u);if(!d||typeof d=="string")return d;let v;switch(d.severity){case m.InputBoxValidationSeverity.Info:v=R.default.Info;break;case m.InputBoxValidationSeverity.Warning:v=R.default.Warning;break;case m.InputBoxValidationSeverity.Error:v=R.default.Error;break;default:v=d.message?R.default.Error:R.default.Ignore;break}return{content:d.message,severity:v}}async showWorkspaceFolderPick(u,d=k.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!v)return;const l=await this.a.getWorkspaceFolders2();if(l)return l.find(w=>w.uri.toString()===v.uri.toString())}createQuickPick(u){const d=new t(u,()=>this.e.delete(d._id));return this.e.set(d._id,d),d}createInputBox(u){const d=new o(u,()=>this.e.delete(d._id));return this.e.set(d._id,d),d}$onDidChangeValue(u,d){this.e.get(u)?._fireDidChangeValue(d)}$onDidAccept(u){this.e.get(u)?._fireDidAccept()}$onDidChangeActive(u,d){const v=this.e.get(u);v instanceof t&&v._fireDidChangeActive(d)}$onDidChangeSelection(u,d){const v=this.e.get(u);v instanceof t&&v._fireDidChangeSelection(d)}$onDidTriggerButton(u,d){this.e.get(u)?._fireDidTriggerButton(d)}$onDidTriggerItemButton(u,d,v){const l=this.e.get(u);l instanceof t&&l._fireDidTriggerItemButton(d,v)}$onDidHide(u){this.e.get(u)?._fireDidHide()}}class y{static{this.a=1}constructor(u,d){this.x=u,this.y=d,this._id=t.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new F.$7c,this.q=new F.$7c,this.r=new F.$7c,this.s=new F.$7c,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(u){this.b=u,this.z({title:u})}get step(){return this.c}set step(u){this.c=u,this.z({step:u})}get totalSteps(){return this.d}set totalSteps(u){this.d=u,this.z({totalSteps:u})}get enabled(){return this.g}set enabled(u){this.g=u,this.z({enabled:u})}get busy(){return this.j}set busy(u){this.j=u,this.z({busy:u})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(u){this.k=u,this.z({ignoreFocusOut:u})}get value(){return this.l}set value(u){this.l=u,this.z({value:u})}get placeholder(){return this.m}set placeholder(u){this.m=u,this.z({placeholder:u})}get buttons(){return this.n}set buttons(u){this.n=u.slice(),this.o.clear(),u.forEach((d,v)=>{const l=d===m.$UK.Back?-1:v;this.o.set(l,d)}),this.z({buttons:u.map((d,v)=>({...n(d.iconPath),tooltip:d.tooltip,handle:d===m.$UK.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(u){this.l=u,this.q.fire(u)}_fireDidTriggerButton(u){const d=this.o.get(u);d&&this.r.fire(d)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,h.$gb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),c.$dispose(this._id))}z(u){if(!this.v){for(const d of Object.keys(u)){const v=u[d];this.u[d]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){c.$createOrUpdate(this.u),this.u={id:this._id}}}function C(g){if(g instanceof m.$uK)return{id:g.id};const u=a(g),d=i(g);return{dark:typeof u=="string"?A.URI.file(u):u,light:typeof d=="string"?A.URI.file(d):d}}function i(g){return typeof g=="object"&&"light"in g?g.light:g}function a(g){return typeof g=="object"&&"dark"in g?g.dark:g}function n(g){const u=C(g);let d,v;return"id"in u?v=I.ThemeIcon.asClassName(u):d=u,{iconPath:d,iconClass:v}}class t extends y{constructor(u,d){super(u.identifier,d),this.O=u,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new F.$7c,this.L=[],this.M=new F.$7c,this.N=new F.$7c,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(u){this.B=u.slice(),this.C.clear(),this.D.clear(),u.forEach((l,w)=>{this.C.set(w,l),this.D.set(l,w)});const d=(0,$.$vF)(this.O,"quickPickItemTooltip"),v=[];for(let l=0;l<u.length;l++){const w=u[l];if(w.kind===m.QuickPickItemKind.Separator)v.push({type:"separator",label:w.label});else{w.tooltip&&!d&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=w.iconPath?n(w.iconPath):void 0;v.push({handle:l,label:w.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:d?S.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((M,N)=>({...n(M.iconPath),tooltip:M.tooltip,handle:N}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(u){this.E=u,this.z({canSelectMany:u})}get matchOnDescription(){return this.F}set matchOnDescription(u){this.F=u,this.z({matchOnDescription:u})}get matchOnDetail(){return this.G}set matchOnDetail(u){this.G=u,this.z({matchOnDetail:u})}get sortByLabel(){return this.H}set sortByLabel(u){this.H=u,this.z({sortByLabel:u})}get keepScrollPosition(){return this.I}set keepScrollPosition(u){this.I=u,this.z({keepScrollPosition:u})}get activeItems(){return this.J}set activeItems(u){this.J=u.filter(d=>this.D.has(d)),this.z({activeItems:this.J.map(d=>this.D.get(d))})}get selectedItems(){return this.L}set selectedItems(u){this.L=u.filter(d=>this.D.has(d)),this.z({selectedItems:this.L.map(d=>this.D.get(d))})}_fireDidChangeActive(u){const d=(0,b.$lf)(u.map(v=>this.C.get(v)));this.J=d,this.K.fire(d)}_fireDidChangeSelection(u){const d=(0,b.$lf)(u.map(v=>this.C.get(v)));this.L=d,this.M.fire(d)}_fireDidTriggerItemButton(u,d){const v=this.C.get(u);if(!v||!v.buttons||!v.buttons.length)return;const l=v.buttons[d];l&&this.N.fire({button:l,item:v})}}class o extends y{constructor(u,d){super(u.identifier,d),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(u){this.B=u,this.z({password:u})}get prompt(){return this.C}set prompt(u){this.C=u,this.z({prompt:u})}get valueSelection(){return this.D}set valueSelection(u){this.D=u,this.z({valueSelection:u})}get validationMessage(){return this.E}set validationMessage(u){this.E=u,u?typeof u=="string"?this.z({validationMessage:u,severity:R.default.Error}):this.z({validationMessage:u.message,severity:u.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new f(r,s)}e.$D_b=D}),define(De[305],Ce([1,0,2,3,66,4,17,6,19,118,18,25,55,16,27,15]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=e.$E_b=void 0;function r(u){if(u)return typeof u.iconPath=="string"?k.URI.file(u.iconPath):k.URI.isUri(u.iconPath)||$.ThemeIcon.isThemeIcon(u.iconPath)?u.iconPath:void 0}function s(u,d){if(!u.iconPath&&!d.iconPath)return 0;if(u.iconPath){if(!d.iconPath)return 1}else return-1;const v=typeof u.iconPath=="string"?u.iconPath:k.URI.isUri(u.iconPath)?u.iconPath.fsPath:u.iconPath.id,l=typeof d.iconPath=="string"?d.iconPath:k.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,b.$7p)(v,l)}function c(u,d){let v=0;if(u.strikeThrough!==d.strikeThrough)return u.strikeThrough?1:-1;if(u.faded!==d.faded)return u.faded?1:-1;if(u.tooltip!==d.tooltip)return(u.tooltip||"").localeCompare(d.tooltip||"");if(v=s(u,d),v!==0)return v;if(u.light&&d.light)v=s(u.light,d.light);else{if(u.light)return 1;if(d.light)return-1}if(v!==0)return v;if(u.dark&&d.dark)v=s(u.dark,d.dark);else{if(u.dark)return 1;if(d.dark)return-1}return v}function f(u,d){if(u.command!==d.command)return u.command<d.command?-1:1;if(u.title!==d.title)return u.title<d.title?-1:1;if(u.tooltip!==d.tooltip){if(u.tooltip!==void 0&&d.tooltip!==void 0)return u.tooltip<d.tooltip?-1:1;if(u.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(u.arguments===d.arguments)return 0;if(u.arguments)if(d.arguments){if(u.arguments.length!==d.arguments.length)return u.arguments.length-d.arguments.length}else return 1;else return-1;for(let v=0;v<u.arguments.length;v++){const l=u.arguments[v],w=d.arguments[v];if(l!==w)return l<w?-1:1}return 0}function y(u,d){let v=(0,b.$7p)(u.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(v!==0)return v;if(u.command&&d.command)v=f(u.command,d.command);else{if(u.command)return 1;if(d.command)return-1}if(v!==0)return v;if(u.decorations&&d.decorations)v=c(u.decorations,d.decorations);else{if(u.decorations)return 1;if(d.decorations)return-1}return v}function C(u,d){for(let v=0;v<u.length;v++)if(u[v]!==d[v])return!1;return!0}function i(u,d){return u.command===d.command&&u.title===d.title&&u.tooltip===d.tooltip&&(u.arguments&&d.arguments?C(u.arguments,d.arguments):u.arguments===d.arguments)}function a(u,d){return(0,E.$af)(u,d,i)}class n{#e;#t;get value(){return this.d}set value(d){d=d??"",this.#e.$setInputBoxValue(this.l,d),this.n(d)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(d){this.#e.$setInputBoxPlaceholder(this.l,d),this.f=d}get validateInput(){return(0,D.$wF)(this.k,"scmValidation"),this.g}set validateInput(d){if((0,D.$wF)(this.k,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=d,this.#e.$setValidationProviderIsEnabled(this.l,!!d)}get enabled(){return this.h}set enabled(d){d=!!d,this.h!==d&&(this.h=d,this.#e.$setInputBoxEnablement(this.l,d))}get visible(){return this.j}set visible(d){d=!!d,this.j!==d&&(this.j=d,this.#e.$setInputBoxVisibility(this.l,d))}get document(){return(0,D.$wF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(d,v,l,w,P){this.k=d,this.l=w,this.m=P,this.d="",this.e=new F.$7c,this.f="",this.h=!0,this.j=!0,this.#t=v,this.#e=l}showValidationMessage(d,v){(0,D.$wF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,d,v)}$onInputBoxValueChange(d){this.n(d)}n(d){this.d=d,this.e.fire(d)}}e.$E_b=n;class t{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(d){this.v=d,this.q.$updateGroupLabel(this.t,this.handle,d)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(d){this.p=d,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(d){this.f=[...d],this.k.fire()}constructor(d,v,l,w,P){this.q=d,this.s=v,this.t=l,this.u=w,this.v=P,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new F.$7c,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new F.$7c,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=t.d++}getResourceState(d){return this.g.get(d)}$executeResourceCommand(d,v){const l=this.h.get(d);return l?(0,A.$mg)(()=>this.s.executeCommand(l.command,...l.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this.f].sort(y),l=(0,E.$hf)(this.o,d,y).map(M=>{const N=M.toInsert.map(T=>{const z=this.e++;this.g.set(z,T);const j=T.resourceUri;let U;if(T.command)if(T.command.command==="vscode.open"||T.command.command==="vscode.diff"){const fe=new L.$kb;U=this.s.converter.toInternal(T.command,fe),this.j.set(z,fe)}else this.h.set(z,T.command);const Y=r(T.decorations),H=T.decorations&&r(T.decorations.light)||Y,ge=T.decorations&&r(T.decorations.dark)||Y,ie=[H,ge],te=T.decorations&&T.decorations.tooltip||"",q=T.decorations&&!!T.decorations.strikeThrough,V=T.decorations&&!!T.decorations.faded,ce=T.contextValue||"";return{rawResource:[z,j,ie,te,q,V,ce,U],handle:z}});return{start:M.start,deleteCount:M.deleteCount,toInsert:N}}),w=l.map(({start:M,deleteCount:N,toInsert:T})=>[M,N,T.map(z=>z.rawResource)]),P=l.reverse();for(const{start:M,deleteCount:N,toInsert:T}of P){const z=T.map(U=>U.handle),j=this.n.splice(M,N,...z);for(const U of j)this.g.delete(U),this.h.delete(U),this.j.get(U)?.dispose(),this.j.delete(U)}return this.o=d,w}dispose(){this.l=!0,this.m.fire()}}class o{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(d){this.g!==d&&(this.g=d,this.#e.$updateSourceControl(this.t,{count:d}))}get quickDiffProvider(){return this.h}set quickDiffProvider(d){this.h=d;let v;(0,D.$vF)(this.u,"quickDiffProvider")&&(v=d?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!d,quickDiffLabel:v})}get commitTemplate(){return this.j}set commitTemplate(d){d!==this.j&&(this.j=d,this.#e.$updateSourceControl(this.t,{commitTemplate:d}))}get acceptInputCommand(){return this.l}set acceptInputCommand(d){this.k.value=new L.$kb,this.l=d;const v=this.v.converter.toInternal(d,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:v})}get actionButton(){return(0,D.$wF)(this.u,"scmActionButton"),this.n}set actionButton(d){(0,D.$wF)(this.u,"scmActionButton"),this.m.value=new L.$kb,this.n=d;const v=d!==void 0?{command:this.v.converter.toInternal(d.command,this.m.value),secondaryCommands:d.secondaryCommands?.map(l=>l.map(w=>this.v.converter.toInternal(w,this.m.value))),description:d.description,enabled:d.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:v??null})}get statusBarCommands(){return this.p}set statusBarCommands(d){if(this.p&&d&&a(this.p,d))return;this.o.value=new L.$kb,this.p=d;const v=(d||[]).map(l=>this.v.converter.toInternal(l,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:v})}get selected(){return this.q}constructor(d,v,l,w,P,M,N){this.u=d,this.v=w,this.w=P,this.x=M,this.y=N,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.$mb,this.l=void 0,this.m=new L.$mb,this.o=new L.$mb,this.p=void 0,this.q=!1,this.s=new F.$7c,this.onDidChangeSelection=this.s.event,this.t=o.d++,this.z=new Map,this.A=new Set,this.#e=l;const T=k.URI.from({scheme:p.Schemas.vscodeSourceControl,path:`${P}/scm${this.t}/input`,query:N?`rootUri=${encodeURIComponent(N.toString())}`:void 0});this.f=new n(d,v,this.#e,this.t,T),this.#e.$registerSourceControl(this.t,P,M,N,T)}createResourceGroup(d,v){const l=new t(this.#e,this.v,this.t,d,v),w=F.Event.once(l.onDidDispose)(()=>this.z.delete(l));return this.z.set(l,w),this.eventuallyAddResourceGroups(),l}eventuallyAddResourceGroups(){const d=[],v=[];for(const[l,w]of this.z){w.dispose();const P=l.onDidUpdateResourceStates(()=>{this.A.add(l),this.eventuallyUpdateResourceStates()});F.Event.once(l.onDidDispose)(()=>{this.A.delete(l),P.dispose(),this.e.delete(l.handle),this.#e.$unregisterGroup(this.t,l.handle)}),d.push([l.handle,l.id,l.label,l.features]);const M=l._takeResourceStateSnapshot();M.length>0&&v.push([l.handle,M]),this.e.set(l.handle,l)}this.#e.$registerGroups(this.t,d,v),this.z.clear()}eventuallyUpdateResourceStates(){const d=[];this.A.forEach(v=>{const l=v._takeResourceStateSnapshot();l.length!==0&&d.push([v.handle,l])}),d.length>0&&this.#e.$spliceResourceStates(this.t,d),this.A.clear()}getResourceGroup(d){return this.e.get(d)}setSelectionState(d){this.q=d,this.s.fire(d)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(d=>d.dispose()),this.#e.$unregisterSourceControl(this.t)}}Je([(0,h.$Sg)(100)],o.prototype,"eventuallyAddResourceGroups",null),Je([(0,h.$Sg)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let g=class En{static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(d,v,l,w){this.l=v,this.m=l,this.n=w,this.g=new Map,this.h=new I.$Hl,this.j=new F.$7c,this.e=d.getProxy(m.$xJ.MainThreadSCM),this.f=d.getProxy(m.$xJ.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const M=this.g.get(P.sourceControlHandle);if(!M)return P;const N=M.getResourceGroup(P.groupHandle);return N?N.getResourceState(P.handle):P}else if(P&&P.$mid===4){const M=this.g.get(P.sourceControlHandle);return M?M.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const M=this.g.get(P.handle);return M||P}return P}})}createSourceControl(d,v,l,w){this.n.trace("ExtHostSCM#createSourceControl",d.identifier.value,v,l,w),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const P=En.d++,M=new o(d,this.m,this.e,this.l,v,l,w);this.g.set(P,M);const N=this.h.get(d.identifier)||[];return N.push(M),this.h.set(d.identifier,N),M}getLastInputBox(d){this.n.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const v=this.h.get(d.identifier),l=v&&v[v.length-1];return l&&l.inputBox}$provideOriginalResource(d,v,l){const w=k.URI.revive(v);this.n.trace("ExtHostSCM#$provideOriginalResource",d,w.toString());const P=this.g.get(d);return!P||!P.quickDiffProvider||!P.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$mg)(()=>P.quickDiffProvider.provideOriginalResource(w,l)).then(M=>M||null)}$onInputBoxValueChange(d,v){this.n.trace("ExtHostSCM#$onInputBoxValueChange",d);const l=this.g.get(d);return l&&l.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(d,v,l,w){this.n.trace("ExtHostSCM#$executeResourceCommand",d,v,l);const P=this.g.get(d);if(!P)return Promise.resolve(void 0);const M=P.getResourceGroup(v);return M?M.$executeResourceCommand(l,w):Promise.resolve(void 0)}$validateInput(d,v,l){this.n.trace("ExtHostSCM#$validateInput",d);const w=this.g.get(d);return!w||!w.inputBox.validateInput?Promise.resolve(void 0):(0,A.$mg)(()=>w.inputBox.validateInput(v,l)).then(P=>{if(!P)return Promise.resolve(void 0);const M=S.MarkdownString.fromStrict(P.message);return M?Promise.resolve([M,P.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this.g.get(d)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=d,Promise.resolve(void 0)}};e.$F_b=g,e.$F_b=g=Je([qe(3,R.$Pi)],g)}),define(De[108],Ce([1,0,6,3,5]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=e.$k_b=void 0;class L{constructor(m){this.b=new F.$7c,this.onDidChangePassword=this.b.event,this.a=m.getProxy(k.$xJ.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,E){return this.a.$getPassword(m,E)}store(m,E,b){return this.a.$setPassword(m,E,b)}delete(m,E){return this.a.$deletePassword(m,E)}}e.$k_b=L,e.$l_b=(0,h.$nh)("IExtHostSecretState")}),define(De[306],Ce([1,0,6,7]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=void 0;class h{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(k.$xJ.MainThreadSemanticSimilarity)}async $provideSimilarityScore(A,m,E,b){if(this.a.size===0)throw new Error("No semantic similarity providers registered");const R=this.a.get(A);if(!R)throw new Error("Semantic similarity provider not found");return await R.provideSimilarityScore(m,E,b)}registerSemanticSimilarityProvider(A,m){const E=this.b;return this.b++,this.a.set(E,m),this.c.$registerSemanticSimilarityProvider(E),new F.$zJ(()=>{this.c.$unregisterSemanticSimilarityProvider(E),this.a.delete(E)})}}e.$Gac=h}),define(De[307],Ce([1,0,6,16,2]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class L{static{this.a=0}constructor(m,E){this.d=E,this.c=new Map,this.b=m.getProxy(k.$xJ.MainThreadShare)}async $provideShare(m,E,b){return await this.c.get(m)?.provideShare({selection:F.Range.to(E.selection),resourceUri:h.URI.revive(E.resourceUri)},b)??void 0}registerShareProvider(m,E){const b=L.a++;return this.c.set(b,E),this.b.$registerShareProvider(b,F.DocumentSelector.from(m,this.d),E.id,E.label,E.priority),{dispose:()=>{this.b.$unregisterShareProvider(b),this.c.delete(b)}}}}e.$Iac=L}),define(De[308],Ce([1,0,7,6,199,4,16,14]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=e.$G_b=void 0;class E{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new k.$vK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new k.$vK("statusBarItem.warningForeground")]])}#e;#t;constructor($,S,D,p,r,s=k.StatusBarAlignment.Left,c){if(this.i=!1,this.k="",this.q=new L.$kb,this.#e=$,this.#t=S,r&&p){this.c=(0,k.$$J)(p.identifier,r);const f=D.get(this.c);f&&(s=f.alignLeft?k.StatusBarAlignment.Left:k.StatusBarAlignment.Right,c=f.priority,this.j=!0,this.name=f.name,this.text=f.text,this.tooltip=f.tooltip,this.command=f.command,this.accessibilityInformation=f.accessibilityInformation)}else this.c=String(E.a++);this.e=p,this.f=r,this.g=s,this.h=this.u(c)}u($){if((0,m.$me)($))return $===Number.POSITIVE_INFINITY?Number.MAX_VALUE:$===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:$}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text($){this.k=$,this.v()}set name($){this.m=$,this.v()}set tooltip($){this.l=$,this.v()}set color($){this.n=$,this.v()}set backgroundColor($){$&&!E.b.has($.id)&&($=void 0),this.o=$,this.v()}set command($){this.r?.fromApi!==$&&(this.p&&this.q.add(this.p),this.p=new L.$kb,typeof $=="string"?this.r={fromApi:$,internal:this.#t.toInternal({title:"",command:$},this.p)}:$?this.r={fromApi:$,internal:this.#t.toInternal($,this.p)}:this.r=void 0,this.v())}set accessibilityInformation($){this.t=$,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let $;this.e?this.f?$=`${this.e.identifier.value}.${this.f}`:$=this.e.identifier.value:$=this.f;let S;this.m?S=this.m:S=(0,h.localize)(0,null,this.e.displayName||this.e.name);let D=this.n;this.o&&(D=E.b.get(this.o.id));const p=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,$,this.e?.identifier.value,S,this.k,p,this.r?.internal,D,this.o,this.g===k.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$G_b=E;class b{constructor($){this.b=[],this.a=$.createStatusBarEntry(void 0,"status.extensionMessage",k.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,h.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage($){const S={message:$};return this.b.unshift(S),this.c(),new k.$zJ(()=>{const D=this.b.indexOf(S);D>=0&&(this.b.splice(D,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor($,S){this.e=new Map,this.a=$.getProxy(F.$xJ.MainThreadStatusBar),this.b=S,this.c=new b(this)}$acceptStaticEntries($){for(const S of $)this.e.set(S.entryId,S)}createStatusBarEntry($,S,D,p){return new E(this.a,this.b,this.e,$,S,D,p)}setStatusBarMessage($,S){const D=this.c.setMessage($);let p;return typeof S=="number"?p=setTimeout(()=>D.dispose(),S):typeof S<"u"&&S.then(()=>D.dispose(),()=>D.dispose()),new k.$zJ(()=>{D.dispose(),clearTimeout(p)})}}e.$H_b=R}),define(De[109],Ce([1,0,6,3,5]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=e.$$$b=void 0;class L{constructor(m,E){this.c=E,this.b=new F.$7c,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(k.$xJ.MainThreadStorage)}registerExtensionStorageKeysToSync(m,E){this.a.$registerExtensionStorageKeysToSync(m,E)}async initializeExtensionStorage(m,E,b){const R=await this.a.$initializeExtensionStorage(m,E);let I;return R&&(I=this.d(m,E,R)),I||b}setValue(m,E,b){return this.a.$setValue(m,E,b)}$acceptValue(m,E,b){const R=this.d(m,E,b);R&&this.b.fire({shared:m,key:E,value:R})}d(m,E,b){try{return JSON.parse(b)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${E}, global: ${m}): ${R}`)}}}e.$$$b=L,e.$_$b=(0,h.$nh)("IExtHostStorage")}),define(De[85],Ce([1,0,5,26,18,63,2]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f_b=e.$e_b=void 0,e.$e_b=(0,k.$nh)("IExtensionStoragePaths");let m=class{constructor(b,R,I){this.d=R,this.f=I,this.a=b.workspace??void 0,this.b=b.environment,this.whenReady=this.h().then($=>this.c=$)}async g(b){return A.URI.joinPath(this.b.workspaceStorageHome,b)}async h(){if(!this.a)return Promise.resolve(void 0);const b=this.a.id,R=await this.g(b);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(I){this.d.error("[ExtHostStorage]",I);return}}workspaceValue(b){if(this.c)return A.URI.joinPath(this.c,b.identifier.value)}globalValue(b){return A.URI.joinPath(this.b.globalStorageHome,b.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$f_b=m,e.$f_b=m=Je([qe(0,F.$PL),qe(1,h.$Pi),qe(2,L.$d_b)],m)}),define(De[43],Ce([1,0,3,6,5,2,20,4,7,201,8,241,21,32,242,55,14,17,16,27]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.$i_b=e.$h_b=e.$g_b=void 0,e.$g_b=(0,h.$nh)("IExtHostTerminalService");class y{constructor(l,w,P,M){this.k=l,this._id=w,this.l=P,this.m=M,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(T=>this.f=T);const N=this;this.value={get name(){return N.m||""},get processId(){return N.b},get creationOptions(){return N.l},get exitStatus(){return N.h},get state(){return N.i},get selection(){return N.j},sendText(T,z=!0){N.o(),N.k.$sendText(N._id,T,z)},show(T){N.o(),N.k.$show(N._id,T)},hide(){N.o(),N.k.$hide(N._id)},dispose(){N.a||(N.a=!0,N.k.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(l,w){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:l.name,shellPath:(0,r.$Ae)(l.shellPath),shellArgs:(0,r.$Ae)(l.shellArgs),cwd:(0,r.$Ae)(l.cwd),env:(0,r.$Ae)(l.env),icon:(0,r.$Ae)(g(l.iconPath)),color:p.ThemeColor.isThemeColor(l.color)?l.color.id:void 0,initialText:(0,r.$Ae)(l.message),strictEnv:(0,r.$Ae)(l.strictEnv),hideFromUser:(0,r.$Ae)(l.hideFromUser),isFeatureTerminal:(0,r.$Ae)(w?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,r.$Ae)(w?.useShellEnvironment),location:w?.location||this.n(l.location,w?.resolvedExtHostIdentifier),isTransient:(0,r.$Ae)(l.isTransient)})}async createExtensionTerminal(l,w,P,M){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:P,color:p.ThemeColor.isThemeColor(M)?M.id:void 0,location:this.n(l,w),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(l,w){return typeof l=="object"?"parentTerminal"in l&&l.parentTerminal&&w?{parentTerminal:w}:"viewColumn"in l?{viewColumn:c.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus}:void 0:l}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(l){this.m=l}setExitStatus(l,w){this.h=Object.freeze({code:l,reason:w})}setDimensions(l,w){return l===this.d&&w===this.g||l===0||w===0?!1:(this.d=l,this.g=w,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(l){this.j=l}_setProcessId(l){this.f?(this.f(l),this.f=void 0):this.b.then(w=>{w!==l&&(this.b=Promise.resolve(l))})}}e.$h_b=y;class C{get onProcessReady(){return this.b.event}constructor(l){this.g=l,this.id=0,this.shouldPersist=!1,this.a=new k.$7c,this.onProcessData=this.a.event,this.b=new k.$7c,this.d=new k.$7c,this.onDidChangeProperty=this.d.event,this.f=new k.$7c,this.onProcessExit=this.f.event}refreshProperty(l){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${l}`)}updateProperty(l,w){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${l}, value: ${w}`)}async start(){}shutdown(){this.g.close()}input(l){this.g.handleInput?.(l)}resize(l,w){this.g.setDimensions?.({columns:l,rows:w})}clearBuffer(){}async processBinary(l){}acknowledgeDataEvent(l){}async setUnicodeVersion(l){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(l){this.g.onDidWrite(w=>this.a.fire(w)),this.g.onDidClose?.((w=void 0)=>{this.f.fire(w===void 0?void 0:w)}),this.g.onDidOverrideDimensions?.(w=>{w&&this.d.fire({type:"overrideDimensions",value:{cols:w.columns,rows:w.rows}})}),this.g.onDidChangeName?.(w=>{this.d.fire({type:"title",value:w})}),this.g.open(l||void 0),l&&this.g.setDimensions?.(l),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let i=1,a=class extends m.$lb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(l=>l.value)}get onDidWriteTerminalData(){return this.H.event}constructor(l,w){super(),this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new k.$7c,this.onDidCloseTerminal=this.z.event,this.C=new k.$7c,this.onDidOpenTerminal=this.C.event,this.D=new k.$7c,this.onDidChangeActiveTerminal=this.D.event,this.F=new k.$7c,this.onDidChangeTerminalDimensions=this.F.event,this.G=new k.$7c,this.onDidChangeTerminalState=this.G.event,this.I=new k.$7c,this.onDidChangeShell=this.I.event,this.a=w.getProxy(F.$xJ.MainThreadTerminalService),this.n=new D.$7ib(this.a.$sendProcessData),this.H=new k.$7c({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(l),this.B({dispose:()=>{for(const[P,M]of this.g)M.shutdown(!0)}})}getDefaultShell(l){return(l?this.m:this.l)?.path||""}getDefaultShellArgs(l){return(l?this.m:this.l)?.args||[]}createExtensionTerminal(l,w){const P=new y(this.a,(0,S.$5e)(),l,l.name),M=new C(l.pty);return P.createExtensionTerminal(l.location,this.J(l,w).resolvedExtHostIdentifier,g(l.iconPath),u(l.color)).then(N=>{const T=this.L(N,M);this.h[N]=T}),this.f.push(P),P.value}J(l,w){if(w=w||{},l.location&&typeof l.location=="object"&&"parentTerminal"in l.location){const P=l.location.parentTerminal;if(P){const M=this.f.find(N=>N.value===P);M&&(w.resolvedExtHostIdentifier=M._id)}}else l.location&&typeof l.location!="object"?w.location=l.location:w.location&&typeof w.location=="object"&&"splitActiveTerminal"in w.location&&(w.location={splitActiveTerminal:!0});return w}attachPtyToTerminal(l,w){if(!this.N(l))throw new Error(`Cannot resolve terminal with id ${l} for virtual process`);const M=new C(w),N=this.L(l,M);this.h[l]=N}async $acceptActiveTerminalChanged(l){const w=this.b;if(l===null){this.b=void 0,w!==this.b&&this.D.fire(this.b);return}const P=this.N(l);P&&(this.b=P,w!==this.b&&this.D.fire(this.b.value))}async $acceptTerminalProcessData(l,w){const P=this.N(l);P&&this.H.fire({terminal:P.value,data:w})}async $acceptTerminalDimensions(l,w,P){const M=this.N(l);M&&M.setDimensions(w,P)&&this.F.fire({terminal:M.value,dimensions:M.value.dimensions})}async $acceptTerminalMaximumDimensions(l,w,P){this.g.get(l)?.resize(w,P)}async $acceptTerminalTitleChange(l,w){const P=this.N(l);P&&(P.name=w)}async $acceptTerminalClosed(l,w,P){const M=this.P(this.f,l);if(M!==null){const N=this.f.splice(M,1)[0];N.setExitStatus(w,P),this.z.fire(N.value)}}$acceptTerminalOpened(l,w,P,M){if(w){const z=this.P(this.f,w);if(z!==null){this.f[z]._id=l,this.C.fire(this.terminals[z]),this.f[z].isOpen=!0;return}}const N={name:M.name,shellPath:M.executable,shellArgs:M.args,cwd:typeof M.cwd=="string"?M.cwd:L.URI.revive(M.cwd),env:M.env,hideFromUser:M.hideFromUser},T=new y(this.a,l,N,P);this.f.push(T),this.C.fire(T.value),T.isOpen=!0}async $acceptTerminalProcessId(l,w){this.N(l)?._setProcessId(w)}async $startExtensionTerminal(l,w){const P=this.N(l);if(!P)return{message:(0,b.localize)(0,null,l)};P.isOpen||await new Promise(N=>{const T=this.onDidOpenTerminal(async z=>{z===P.value&&(T.dispose(),N())})});const M=this.g.get(l);M?M.startSendingEvents(w):this.i[l]={initialDimensions:w}}L(l,w){const P=new m.$kb;P.add(w.onProcessReady(N=>this.a.$sendProcessReady(l,N.pid,N.cwd,N.windowsPty))),P.add(w.onDidChangeProperty(N=>this.a.$sendProcessProperty(l,N))),this.n.startBuffering(l,w.onProcessData),P.add(w.onProcessExit(N=>this.M(l,N))),this.g.set(l,w);const M=this.i[l];return M&&w instanceof C&&(w.startSendingEvents(M.initialDimensions),delete this.i[l]),P}$acceptProcessAckDataEvent(l,w){this.g.get(l)?.acknowledgeDataEvent(w)}$acceptProcessInput(l,w){this.g.get(l)?.input(w)}$acceptTerminalInteraction(l){const w=this.N(l);w?.setInteractedWith()&&this.G.fire(w.value)}$acceptTerminalSelection(l,w){this.N(l)?.setSelection(w)}$acceptProcessResize(l,w,P){try{this.g.get(l)?.resize(w,P)}catch(M){if(M.code!=="EPIPE"&&M.code!=="ERR_IPC_CHANNEL_CLOSED")throw M}}$acceptProcessShutdown(l,w){this.g.get(l)?.shutdown(w)}$acceptProcessRequestInitialCwd(l){this.g.get(l)?.getInitialCwd().then(w=>this.a.$sendProcessProperty(l,{type:"initialCwd",value:w}))}$acceptProcessRequestCwd(l){this.g.get(l)?.getCwd().then(w=>this.a.$sendProcessProperty(l,{type:"cwd",value:w}))}$acceptProcessRequestLatency(l){return Promise.resolve(l)}registerLinkProvider(l){return this.s.add(l),this.s.size===1&&this.a.$startLinkProvider(),new E.$zJ(()=>{this.s.delete(l),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(l,w,P){if(this.u.has(w))throw new Error(`Terminal profile provider "${w}" already registered`);return this.u.set(w,P),this.a.$registerProfileProvider(w,l.identifier.value),new E.$zJ(()=>{this.u.delete(w),this.a.$unregisterProfileProvider(w)})}registerTerminalQuickFixProvider(l,w,P){if(this.v.has(l))throw new Error(`Terminal quick fix provider "${l}" is already registered`);return this.v.set(l,P),this.a.$registerQuickFixProvider(l,w),new E.$zJ(()=>{this.v.delete(l),this.a.$unregisterQuickFixProvider(l)})}async $provideTerminalQuickFixes(l,w){const P=new $.$dd().token;if(P.isCancellationRequested)return;const M=this.v.get(l);if(!M)return;const N=await M.provideTerminalQuickFixes(w,P);if(N!==null)return N}async $createContributedProfileTerminal(l,w){const P=new $.$dd().token;let M=await this.u.get(l)?.provideTerminalProfile(P);if(!P.isCancellationRequested){if(M&&!("options"in M)&&(M={options:M}),!M||!("options"in M))throw new Error(`No terminal profile options provided for id "${l}"`);if("pty"in M.options){this.createExtensionTerminal(M.options,w);return}this.createTerminalFromOptions(M.options,w)}}async $provideLinks(l,w){const P=this.N(l);if(!P)return[];this.w.delete(l),this.y.get(l)?.dispose(!0);const N=new $.$dd;this.y.set(l,N);const T=[],z={terminal:P.value,line:w},j=[];for(const H of this.s)j.push(s.Promises.withAsyncBody(async ge=>{N.token.onCancellationRequested(()=>ge({provider:H,links:[]}));const ie=await H.provideTerminalLinks(z,N.token)||[];N.token.isCancellationRequested||ge({provider:H,links:ie})}));const U=await Promise.all(j);if(N.token.isCancellationRequested)return[];const Y=new Map;for(const H of U)H&&H.links.length>0&&T.push(...H.links.map(ge=>{const ie={id:i++,startIndex:ge.startIndex,length:ge.length,label:ge.tooltip};return Y.set(ie.id,{provider:H.provider,link:ge}),ie}));return this.w.set(l,Y),T}$activateLink(l,w){const P=this.w.get(l)?.get(w);P&&P.provider.handleTerminalLink(P.link)}M(l,w){this.n.stopBuffering(l),this.g.delete(l),delete this.i[l];const P=this.h[l];P&&(P.dispose(),delete this.h[l]),this.a.$sendProcessExit(l,w)}N(l){return this.O(this.f,l)}O(l,w){const P=this.P(l,w);return P!==null?l[P]:null}P(l,w){const P=l.findIndex(M=>M._id===w);return P===-1?null:P}getEnvironmentVariableCollection(l){let w=this.k.get(l.identifier.value);return w||(w=new n(l),this.R(l.identifier.value,w)),w.getScopedEnvironmentVariableCollection(void 0)}Q(l,w){const P=(0,I.$Xq)(w.map),M=(0,I.$Yq)(w.descriptionMap);this.a.$setEnvironmentVariableCollection(l,w.persistent,P.length===0?void 0:P,M)}$initEnvironmentVariableCollections(l){l.forEach(w=>{const P=w[0],M=new n(void 0,w[1]);this.R(P,M)})}$acceptDefaultProfile(l,w){const P=this.l;this.l=l,this.m=w,P?.path!==l.path&&this.I.fire(l.path)}R(l,w){this.k.set(l,w),w.onDidChangeCollection(()=>{this.Q(l,w)})}};e.$i_b=a,e.$i_b=a=Je([qe(1,A.$zL)],a);class n{get persistent(){return this.b}set persistent(l){this.b=l,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(l,w){this.f=l,this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new k.$7c,this.map=new Map(w)}getScopedEnvironmentVariableCollection(l){this.f&&l&&(0,f.$wF)(this.f,"envCollectionWorkspace");const w=this.i(l);let P=this.a.get(w);return P||(P=new t(this,l),this.a.set(w,P),P.onDidChangeCollection(()=>this.d.fire())),P}replace(l,w,P,M){this.f&&P&&(0,f.$wF)(this.f,"envCollectionOptions"),this.g(l,{value:w,type:E.EnvironmentVariableMutatorType.Replace,options:P??{},scope:M})}append(l,w,P,M){this.f&&P&&(0,f.$wF)(this.f,"envCollectionOptions"),this.g(l,{value:w,type:E.EnvironmentVariableMutatorType.Append,options:P??{},scope:M})}prepend(l,w,P,M){this.f&&P&&(0,f.$wF)(this.f,"envCollectionOptions"),this.g(l,{value:w,type:E.EnvironmentVariableMutatorType.Prepend,options:P??{},scope:M})}g(l,w){if(w.options&&w.options.applyAtProcessCreation===!1&&!w.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const P=this.h(l,w.scope),M=this.map.get(P);if(!M||M.value!==w.value||M.type!==w.type||M.options?.applyAtProcessCreation!==(w.options.applyAtProcessCreation??!0)||M.options?.applyAtShellIntegration!==(w.options.applyAtShellIntegration??!1)||M.scope?.workspaceFolder?.index!==w.scope?.workspaceFolder?.index){const N=this.h(l,w.scope),T={variable:l,...w,options:{applyAtProcessCreation:w.options.applyAtProcessCreation??!0,applyAtShellIntegration:w.options.applyAtShellIntegration??!1}};this.map.set(N,T),this.d.fire()}}get(l,w){const P=this.h(l,w),M=this.map.get(P);return M?d(M):void 0}h(l,w){const P=this.i(w);return P.length?`${l}:::${P}`:l}i(l){return this.j(l?.workspaceFolder)??""}j(l){return l?l.uri.toString():void 0}getVariableMap(l){const w=new Map;for(const[P,M]of this.map)this.i(M.scope)===this.i(l)&&w.set(M.variable,d(M));return w}delete(l,w){const P=this.h(l,w);this.map.delete(P),this.d.fire()}clear(l){if(l?.workspaceFolder){for(const[w,P]of this.map)P.scope?.workspaceFolder?.index===l.workspaceFolder.index&&this.map.delete(w);this.k(l)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(l,w){const P=this.i(w),M=this.descriptionMap.get(P);if(!M||M.description!==l){let N;typeof l=="string"?N=l:N=l?.value.split(`

`)[0];const T={description:N,scope:w};this.descriptionMap.set(P,T),this.d.fire()}}getDescription(l){const w=this.i(l);return this.descriptionMap.get(w)?.description}k(l){const w=this.i(l);this.descriptionMap.delete(w)}}class t{get persistent(){return this.b.persistent}set persistent(l){this.b.persistent=l}get onDidChangeCollection(){return this.a&&this.a.event}constructor(l,w){this.b=l,this.d=w,this.a=new k.$7c}getScopedEnvironmentVariableCollection(l){return this.b.getScopedEnvironmentVariableCollection(l)}replace(l,w,P){this.b.replace(l,w,P,this.d)}append(l,w,P){this.b.append(l,w,P,this.d)}prepend(l,w,P){this.b.prepend(l,w,P,this.d)}get(l){return this.b.get(l,this.d)}forEach(l,w){this.b.getVariableMap(this.d).forEach((P,M)=>l.call(w,M,P,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(l){this.b.delete(l,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(l){this.b.setDescription(l,this.d)}get description(){return this.b.getDescription(this.d)}}let o=class extends a{constructor(l){super(!1,l)}createTerminal(l,w,P){throw new R.$$}createTerminalFromOptions(l,w){throw new R.$$}};e.$j_b=o,e.$j_b=o=Je([qe(0,A.$zL)],o);function g(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function u(v){return p.ThemeColor.isThemeColor(v)?v:void 0}function d(v){const l={...v};return delete l.scope,l.options=l.options??void 0,delete l.variable,l}}),define(De[309],Ce([1,0,19,17,22,21,3,67,70,4,23,14,32,6,20,139,16,7,59,103,82]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=e.$sac=e.$rac=e.$qac=void 0;let C=class{constructor(N,T,z){this.j=z,this.c=new A.$7c,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=N.getProxy(S.$xJ.MainThreadTesting),this.h=new l(this.f),this.g=new t(this.f),T.registerArgumentProcessor({processArgument:j=>{if(j?.$mid!==15)return j;const U=j,Y=U.tests[U.tests.length-1].item.extId;return this.d.get(c.$jI.root(Y))?.collection.tree.get(Y)?.actual??(0,p.$LL)(j)}}),T.registerCommand(!1,"testing.getExplorerSelection",async()=>{const j=await T.executeCommand("_testing.getExplorerSelection"),U=Y=>{const H=this.d.get(c.$jI.root(Y));if(H)return c.$jI.isRoot(Y)?H.controller:H.collection.tree.get(Y)?.actual};return{include:j?.include.map(U).filter(I.$qe)||[],exclude:j?.exclude.map(U).filter(I.$qe)||[]}})}createTestController(N,T,z,j){if(this.d.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const U=new b.$kb,Y=U.add(new p.$OL(T,z,this.j));Y.root.label=z;const H=new Map,ge=this.f,ie={items:Y.root.children,get label(){return z},set label(q){z=q,Y.root.label=q,ge.$updateController(T,{label:z})},get refreshHandler(){return j},set refreshHandler(q){j=q,ge.$updateController(T,{canRefresh:!!q})},get id(){return T},createRunProfile:(q,V,ce,re,fe,de)=>{let B=(0,E.$bi)(q);for(;H.has(B);)B++;return new w(this.f,H,T,B,q,V,ce,re,fe,de)},createTestItem(q,V,ce){return new p.$ML(T,q,V,ce)},createTestRun:(q,V,ce=!0)=>this.g.createTestRun(T,Y,q,V,ce),invalidateTestResults:q=>{if(q===void 0)this.f.$markTestRetired(void 0);else{const V=q instanceof Array?q:[q];this.f.$markTestRetired(V.map(ce=>c.$jI.fromExtHostTestItem(ce,T).toString()))}},set resolveHandler(q){Y.resolveHandler=q},get resolveHandler(){return Y.resolveHandler},dispose:()=>{U.dispose()}};ge.$registerTestController(T,z,!!j),U.add((0,b.$jb)(()=>ge.$unregisterTestController(T)));const te={controller:ie,collection:Y,profiles:H};return this.d.set(T,te),U.add((0,b.$jb)(()=>this.d.delete(T))),U.add(Y.onDidGenerateDiff(q=>ge.$publishDiff(T,q.map(y.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.h.checkout()}async runTests(N,T=L.CancellationToken.None){const z=o(N);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const j=this.d.get(z.controllerId);if(!j)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:N.include?.map(U=>c.$jI.fromExtHostTestItem(U,j.collection.root.id).toString())??[j.collection.root.id],profileGroup:P[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:N.exclude?.map(U=>U.id)},T)}$syncTests(){for(const{collection:N}of this.d.values())N.flushDiff();return Promise.resolve()}$provideFileCoverage(N,T,z){return(0,k.$Kf)(this.g.trackers,U=>U.id===N?U.getCoverage(T):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(N,T,z,j){return(0,k.$Kf)(this.g.trackers,Y=>Y.id===N?Y.getCoverage(T):void 0)?.resolveFileCoverage(z,j)??Promise.resolve([])}$configureRunProfile(N,T){this.d.get(N)?.profiles.get(T)?.configureHandler?.()}async $refreshTests(N,T){await this.d.get(N)?.controller.refreshHandler?.(T)}$publishTestResults(N){this.results=Object.freeze(N.map(T=>(0,R.$Gm)(r.TestResults.to(T))).concat(this.results).sort((T,z)=>z.completedAt-T.completedAt).slice(0,32)),this.c.fire()}async $expandTest(N,T){const z=this.d.get(c.$jI.fromString(N).controllerId)?.collection;z&&(await z.expand(N,T<0?1/0:T),z.flushDiff())}$acceptDiff(N){this.h.applyDiff(N.map(y.TestsDiffOp.deserialize))}async $runControllerTests(N,T){return Promise.all(N.map(z=>this.k(z,!1,T)))}async $startContinuousRun(N,T){const z=new L.$dd(T),j=await Promise.all(N.map(U=>this.k(U,!0,z.token)));return!T.isCancellationRequested&&!j.some(U=>U.error)&&await new Promise(U=>T.onCancellationRequested(U)),z.dispose(!0),j}async k(N,T,z){const j=this.d.get(N.controllerId);if(!j)return{};const{collection:U,profiles:Y}=j,H=Y.get(N.profileId);if(!H)return{};const ge=N.testIds.map(V=>U.tree.get(V)).filter(I.$qe),ie=N.excludeExtIds.map(V=>j.collection.tree.get(V)).filter(I.$qe).filter(V=>ge.some(ce=>ce.fullId.compare(V.fullId)===2));if(!ge.length)return{};const te=new s.$9K(ge.some(V=>V.actual instanceof p.$NL)?void 0:ge.map(V=>V.actual),ie.map(V=>V.actual),H,T),q=(0,y.$lI)(N)&&this.g.prepareForMainThreadTestRun(te,g.fromInternal(N,j.collection),z);try{return await H.runHandler(te,z),{}}catch(V){return{error:String(V)}}finally{q&&(q.hasRunningTasks&&!z.isCancellationRequested&&await A.Event.toPromise(q.onEnd),q.dispose())}}$cancelExtensionTestRun(N){N===void 0?this.g.cancelAllRuns():this.g.cancelRunById(N)}};e.$qac=C,e.$qac=C=Je([qe(0,D.$zL)],C);const i=1e4;var a;(function(M){M[M.Running=0]="Running",M[M.Cancelling=1]="Cancelling",M[M.Ended=2]="Ended"})(a||(a={}));class n extends b.$lb{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(N,T,z){super(),this.k=N,this.l=T,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.$7c),this.onEnd=this.j.event,this.h=this.B(new L.$dd(z));const j=this.B(new F.$Eg(()=>this.m(),i));this.B(this.h.token.onCancellationRequested(()=>j.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(N){return this.f.get(N)?.coverage}createRun(N){const T=this.k.id,z=this.k.controllerId,j=(0,$.$5e)(),U=new u(this.l,T,j),Y=te=>(q,...V)=>{if(ge){console.warn(`Setting the state of test "${q.id}" is a no-op after the run ends.`);return}this.k.isIncluded(q)&&(this.s(q),te(q,...V))},H=(te,q)=>{const V=q instanceof Array?q.map(r.TestMessage.from):[r.TestMessage.from(q)];if(te.uri&&te.range){const ce={range:r.Range.from(te.range),uri:te.uri};for(const re of V)re.location=re.location||ce}this.l.$appendTestMessagesInRun(T,j,c.$jI.fromExtHostTestItem(te,z).toString(),V)};let ge=!1;const ie={isPersisted:this.k.isPersisted,token:this.h.token,name:N,get coverageProvider(){return U.coverageProvider},set coverageProvider(te){U.coverageProvider=te},enqueued:Y(te=>{this.l.$updateTestStateInRun(T,j,c.$jI.fromExtHostTestItem(te,z).toString(),1)}),skipped:Y(te=>{this.l.$updateTestStateInRun(T,j,c.$jI.fromExtHostTestItem(te,z).toString(),5)}),started:Y(te=>{this.l.$updateTestStateInRun(T,j,c.$jI.fromExtHostTestItem(te,z).toString(),2)}),errored:Y((te,q,V)=>{H(te,q),this.l.$updateTestStateInRun(T,j,c.$jI.fromExtHostTestItem(te,z).toString(),6,V)}),failed:Y((te,q,V)=>{H(te,q),this.l.$updateTestStateInRun(T,j,c.$jI.fromExtHostTestItem(te,z).toString(),4,V)}),passed:Y((te,q)=>{this.l.$updateTestStateInRun(T,j,c.$jI.fromExtHostTestItem(te,this.k.controllerId).toString(),3,q)}),appendOutput:(te,q,V)=>{ge||(V&&(this.k.isIncluded(V)?this.s(V):V=void 0),this.l.$appendOutputToRun(T,j,h.$Jb.fromString(te),q&&r.location.from(q),V&&c.$jI.fromExtHostTestItem(V,z).toString()))},end:()=>{ge||(ge=!0,this.l.$finishedTestRunTask(T,j),this.f.delete(j),this.f.size||this.p())}};return this.f.set(j,{run:ie,coverage:U}),this.l.$startedTestRunTask(T,{id:j,name:N,running:!0}),ie}m(){for(const{run:N}of this.f.values())N.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(N){if(!(N instanceof p.$ML))throw new f.$rL(N.id);if(this.g.has(c.$jI.fromExtHostTestItem(N,this.k.controllerId).toString()))return;const T=[],z=this.k.colllection.root;for(;;){const j=r.TestItem.from(N);if(T.unshift(j),this.g.has(j.extId)||(this.g.add(j.extId),N===z))break;N=N.parent||z}this.l.$addTestsToRun(this.k.controllerId,this.k.id,T)}}class t{get trackers(){return this.c.values()}constructor(N){this.d=N,this.c=new Map}prepareForMainThreadTestRun(N,T,z){return this.f(N,T,z)}cancelRunById(N){for(const T of this.c.values())if(T.id===N){T.cancel();return}}cancelAllRuns(){for(const N of this.c.values())N.cancel()}createTestRun(N,T,z,j,U){const Y=this.c.get(z);if(Y)return Y.createRun(j);const H=g.fromPublic(N,T,z,U),ge=o(z);this.d.$startedExtensionTestRun({controllerId:N,continuous:!!z.continuous,profile:ge&&{group:P[ge.kind],id:ge.profileId},exclude:z.exclude?.map(te=>c.$jI.fromExtHostTestItem(te,T.root.id).toString())??[],id:H.id,include:z.include?.map(te=>c.$jI.fromExtHostTestItem(te,T.root.id).toString())??[T.root.id],persist:U});const ie=this.f(z,H);return ie.onEnd(()=>{this.d.$finishedExtensionTestRun(H.id),ie.dispose()}),ie.createRun(j)}f(N,T,z){const j=new n(T,this.d,z);return this.c.set(N,j),j.onEnd(()=>this.c.delete(N)),j}}e.$rac=t;const o=M=>{if(M.profile){if(!(M.profile instanceof w))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return M.profile}};class g{static fromPublic(N,T,z,j){return new g(N,(0,$.$5e)(),z.include?.map(U=>c.$jI.fromExtHostTestItem(U,N).toString())??[N],z.exclude?.map(U=>c.$jI.fromExtHostTestItem(U,N).toString())??[],j,T)}static fromInternal(N,T){return new g(N.controllerId,N.runId,N.testIds,N.excludeExtIds,!0,T)}constructor(N,T,z,j,U,Y){this.controllerId=N,this.id=T,this.isPersisted=U,this.colllection=Y,this.c=z.map(H=>H+"\0"),this.d=j.map(H=>H+"\0")}isIncluded(N){const T=c.$jI.fromExtHostTestItem(N,this.controllerId).toString()+"\0";for(const z of this.d)if(T===z||T.startsWith(z))return!1;for(const z of this.c)if(T===z||T.startsWith(z))return!0;return!1}}e.$sac=g;class u{set coverageProvider(N){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");N&&(this.c=N,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(N,T,z){this.f=N,this.g=T,this.h=z}async provideFileCoverage(N){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(N))());try{return(await this.d)?.map(r.TestCoverage.fromFile)??[]}catch(T){throw this.d=void 0,T}}async resolveFileCoverage(N,T){const z=await this.d;let j=z?.[N];return!this.c||!z||!j?[]:(j.detailedCoverage||(j=z[N]=await this.c.resolveFileCoverage?.(j,T)??j),j.detailedCoverage?.map(r.TestCoverage.fromDetailed)??[])}}class d{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(N){this.h=N,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(N){this.c.add(N)}update(N){Object.assign(N.revived,r.TestItem.toPlain(N.item)),this.c.has(N)||this.d.add(N)}remove(N){if(this.c.has(N)){this.c.delete(N);return}this.d.delete(N);const T=c.$jI.parentId(N.item.extId);if(T&&this.g.has(T.toString())){this.g.add(N.item.extId);return}this.f.add(N)}getChangeEvent(){const{c:N,d:T,f:z}=this;return{get added(){return[...N].map(j=>j.revived)},get updated(){return[...T].map(j=>j.revived)},get removed(){return[...z].map(j=>j.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class v extends y.$qI{constructor(){super(...arguments),this.q=new A.$7c,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(N){return this.d.get(N)}getMirroredTestDataByReference(N){return this.d.get(N.id)}p(N,T){return{...N,revived:r.TestItem.toPlain(N.item),depth:T?T.depth+1:0,children:new Set}}o(){return new d(this.q)}}class l{constructor(N){this.d=N}checkout(){this.c||(this.c=this.f());const N=this.c;return N.observers++,{onDidChangeTest:N.tests.onDidChangeTests,get tests(){return[...N.tests.rootTests].map(T=>T.revived)},dispose:(0,m.$cb)(()=>{--N.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(N){return this.c?.tests.getMirroredTestDataByReference(N)}applyDiff(N){this.c?.tests.apply(N)}f(){const N=new v;return this.d.$subscribeToDiffs(),{observers:0,tests:N}}}class w{#e;#t;get label(){return this.d}set label(N){N!==this.d&&(this.d=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:N}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(N){N!==this.g&&(this.g=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:N}))}get isDefault(){return this.f}set isDefault(N){N!==this.f&&(this.f=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:N}))}get tag(){return this._tag}set tag(N){N?.id!==this._tag?.id&&(this._tag=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:N?r.TestTag.namespace(this.controllerId,N.id):null}))}get configureHandler(){return this.c}set configureHandler(N){N!==this.c&&(this.c=N,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!N}))}constructor(N,T,z,j,U,Y,H,ge=!1,ie=void 0,te=!1){this.controllerId=z,this.profileId=j,this.d=U,this.kind=Y,this.runHandler=H,this.f=ge,this._tag=ie,this.g=te,this.#e=N,this.#t=T,T.set(j,this);const q=P[Y];if(typeof q!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);this.#e.$publishTestRunProfile({profileId:j,controllerId:z,tag:ie?r.TestTag.namespace(this.controllerId,ie.id):null,label:U,group:q,isDefault:ge,hasConfigurationHandler:!1,supportsContinuousRun:te})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$tac=w;const P={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(De[310],Ce([1,0,19,8,3,6,140,16,7]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=void 0;class b{constructor(I,$){this.i=$,this.a=new h.$7c({onListenerError:F.$Z}),this.b=new h.$7c({onListenerError:F.$Z}),this.c=new h.$7c({onListenerError:F.$Z}),this.d=new h.$7c({onListenerError:F.$Z}),this.f=new h.$7c({onListenerError:F.$Z}),this.g=new h.$7c({onListenerError:F.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=I.getProxy(L.$xJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(S=>this.g.fire(S)),this.i.onDidChangeActiveTextEditor(S=>this.f.fire(S))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(I){const $=this.i.allEditors();return I?$:$.map(S=>S.value)}async showTextDocument(I,$,S){let D;typeof $=="number"?D={position:m.ViewColumn.from($),preserveFocus:S}:typeof $=="object"?D={position:m.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selection:typeof $.selection=="object"?m.Range.from($.selection):void 0,pinned:typeof $.preview=="boolean"?!$.preview:void 0}:D={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(I.uri,D),r=p&&this.i.getEditor(p);if(r)return r.value;throw p?new Error(`Could NOT open editor for "${I.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${I.uri.toString()}".`)}createTextEditorDecorationType(I,$){return new A.$GL(this.h,I,$).value}$acceptEditorPropertiesChanged(I,$){const S=this.i.getEditor(I);if(!S)throw new Error("unknown text editor");if($.options&&S._acceptOptions($.options),$.selections){const D=$.selections.selections.map(m.Selection.to);S._acceptSelections(D)}if($.visibleRanges){const D=k.$lf($.visibleRanges.map(m.Range.to));S._acceptVisibleRanges(D)}if($.options&&this.b.fire({textEditor:S.value,options:{...$.options,lineNumbers:m.TextEditorLineNumbersStyle.to($.options.lineNumbers)}}),$.selections){const D=E.TextEditorSelectionChangeKind.fromValue($.selections.source),p=$.selections.selections.map(m.Selection.to);this.a.fire({textEditor:S.value,selections:p,kind:D})}if($.visibleRanges){const D=k.$lf($.visibleRanges.map(m.Range.to));this.c.fire({textEditor:S.value,visibleRanges:D})}}$acceptEditorPositionData(I){for(const $ in I){const S=this.i.getEditor($);if(!S)throw new Error("Unknown text editor");const D=m.ViewColumn.to(I[$]);S.value.viewColumn!==D&&(S._acceptViewColumn(D),this.d.fire({textEditor:S.value,viewColumn:D}))}}getDiffInformation(I){return Promise.resolve(this.h.$getDiffInformation(I))}}e.$I_b=b}),define(De[311],Ce([1,0,2,5,6,4,7,16,25,14]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=e.$kac=void 0,e.$kac=(0,F.$nh)("IExtHostTimeline");class R{constructor(S,D){this.b=new Map,this.c=new Map,this.a=S.getProxy(h.$xJ.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(p,r)=>{if(p&&p.$mid===12)if(this.b.get(p.source)&&E.$Fl.equals(r,this.b.get(p.source)?.extension)){const s=p.uri===void 0?void 0:k.URI.revive(p.uri);return this.c.get(p.source)?.get(I(s))?.get(p.handle)}else return;return p}})}async $getTimeline(S,D,p,r){return this.b.get(S)?.provider.provideTimeline(k.URI.revive(D),p,r)}registerTimelineProvider(S,D,p,r){const s=new L.$kb,c=this.d(D.id,r,s).bind(this);let f;D.onDidChange&&(f=D.onDidChange(C=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...C,id:D.id}),this));const y=this.c;return this.f({...D,scheme:S,onDidChange:void 0,async provideTimeline(C,i,a){i?.resetCache&&(s.clear(),y.get(D.id)?.clear());const n=await D.provideTimeline(C,i,a);if(n==null)return;const t=c(C,i);return{...n,source:D.id,items:n.items.map(t)}},dispose(){for(const C of y.values())C.get(D.id)?.clear();f?.dispose(),s.dispose()}},p)}d(S,D,p){return(r,s)=>{let c;if(s?.cacheResults){let f=this.c.get(S);f===void 0&&(f=new Map,this.c.set(S,f));const y=I(r);c=f.get(y),c===void 0&&(c=new Map,f.set(y,c))}return f=>{const{iconPath:y,...C}=f,i=`${S}|${f.id??f.timestamp}`;c?.set(i,f);let a,n,t;f.iconPath&&(y instanceof A.$uK?t={id:y.id,color:y.color}:k.URI.isUri(y)?(a=y,n=y):{light:a,dark:n}=y);let o;return A.$1J.isMarkdownString(C.tooltip)?o=m.MarkdownString.from(C.tooltip):(0,b.$ie)(C.tooltip)?o=C.tooltip:A.$1J.isMarkdownString(C.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=m.MarkdownString.from(C.detail)):(0,b.$ie)(C.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),o=C.detail),{...C,id:C.id??void 0,handle:i,source:S,command:f.command?D.toInternal(f.command,p):void 0,icon:a,iconDark:n,themeIcon:t,tooltip:o,accessibilityInformation:f.accessibilityInformation}}}}f(S,D){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:D}),(0,L.$jb)(()=>{for(const r of this.c.values())r.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.$lac=R;function I($){return $?.toString()}}),define(De[64],Ce([1,0,21,3,4,203,5,18,132,6,26,20,7]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upb=e.$Tpb=e.TunnelDtoConverter=void 0;class S extends E.$Mz{}var D;(function(r){function s(f){return{remoteAddress:f.remoteAddress,localAddress:f.localAddress,public:!!f.public,privacy:f.privacy??(f.public?E.TunnelPrivacyId.Public:E.TunnelPrivacyId.Private),protocol:f.protocol}}r.fromApiTunnel=s;function c(f){return{remoteAddress:{host:f.tunnelRemoteHost,port:f.tunnelRemotePort},localAddress:f.localAddress,public:f.privacy!==E.TunnelPrivacyId.ConstantPrivate&&f.privacy!==E.TunnelPrivacyId.ConstantPrivate,privacy:f.privacy,protocol:f.protocol}}r.fromServiceTunnel=c})(D||(e.TunnelDtoConverter=D={})),e.$Tpb=(0,A.$nh)("IExtHostTunnelService");let p=class extends h.$lb{constructor(s,c,f){super(),this.n=f,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new F.$7c,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=s.getProxy(b.$xJ.MainThreadTunnelService)}async openTunnel(s,c){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${c.remoteAddress.host}:${c.remoteAddress.port}.`);const f=await this.a.$openTunnel(c,s.displayName);if(f){const y=new S(f.remoteAddress,f.localAddress,()=>this.a.$closeTunnel(f.remoteAddress));return this.B(y),y}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(s,c){const f=this.p();return this.l.set(f,{selector:s,provider:c}),this.a.$registerPortsAttributesProvider(s,f),new $.$zJ(()=>{this.l.delete(f),this.a.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(s,c,f,y,C){const i=[];for(const n of s){const t=this.l.get(n);if(!t)return[];i.push(...await Promise.all(c.map(async o=>({providedAttributes:await t.provider.providePortAttributes(o,f,y,C),port:o}))))}const a=i.filter(n=>!!n.providedAttributes);return a.length>0?a.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,c){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(y,C)=>await s.provideTunnel(y,C,new k.$dd().token)??void 0;const f=c.tunnelFeatures?{elevation:!!c.tunnelFeatures?.elevation,privacyOptions:c.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(f),Promise.resolve((0,h.$jb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s){if(s){if(s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter()),s.tunnelFactory){this.b=s.tunnelFactory;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:L.localize(0,null),themeIcon:"lock"},{id:"public",label:L.localize(1,null),themeIcon:"eye"}]);const f=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(f)}}else this.b=void 0;return(0,h.$jb)(()=>{this.b=void 0})}async $closeTunnel(s,c){if(this.g.has(s.host)){const f=this.g.get(s.host);f.has(s.port)&&(c&&f.get(s.port).disposeListener.dispose(),await f.get(s.port).tunnel.dispose(),f.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,c){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this.b(s,c);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const y=await f;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),y===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const C=this.B(y.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(y.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:y,disposeListener:C}),D.fromApiTunnel(y)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(s){const c=await Promise.all(s.map(y=>this.f(y.host,y.port,y.detail??""))),f=s.filter((y,C)=>c[C]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(y=>y.port).join(", ")} to ${f.map(y=>y.port).join(", ")}`),f}};e.$Upb=p,e.$Upb=p=Je([qe(0,I.$zL),qe(1,R.$PL),qe(2,m.$Pi)],p)}),define(De[312],Ce([1,0,4,15,2,6]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;class A{static{this.a=new Set([F.Schemas.http,F.Schemas.https])}constructor(E){this.c=new Map,this.b=E.getProxy(L.$xJ.MainThreadUriOpeners)}registerExternalUriOpener(E,b,R,I){if(this.c.has(b))throw new Error(`Opener with id '${b}' already registered`);const $=I.schemes.find(S=>!A.a.has(S));if($)throw new Error(`Scheme '${$}' is not supported. Only http and https are currently supported.`);return this.c.set(b,R),this.b.$registerUriOpener(b,I.schemes,E,I.label),(0,k.$jb)(()=>{this.c.delete(b),this.b.$unregisterUriOpener(b)})}async $canOpenUri(E,b,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const $=h.URI.revive(b);return I.canOpenExternalUri($,R)}async $openUri(E,b,R){const I=this.c.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(h.URI.revive(b.resolvedUri),{sourceUri:h.URI.revive(b.sourceUri)},R)}}e.$uac=A}),define(De[313],Ce([1,0,6,2,4,8,25]),function(me,e,k,F,h,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K_b=void 0;class m{static{this.a=0}constructor(b){this.c=new A.$Gl,this.d=new Map,this.b=b.getProxy(k.$xJ.MainThreadUrls)}registerUriHandler(b,R){const I=b.identifier;if(this.c.has(I))throw new Error(`Protocol handler already registered for extension ${I}`);const $=m.a++;return this.c.add(I),this.d.set($,R),this.b.$registerUriHandler($,I,b.displayName||b.name),(0,h.$jb)(()=>{this.c.delete(I),this.d.delete($),this.b.$unregisterUriHandler($)})}$handleExternalUri(b,R){const I=this.d.get(b);if(!I)return Promise.resolve(void 0);try{I.handleUri(F.URI.revive(R))}catch($){(0,L.$Y)($)}return Promise.resolve(void 0)}async createAppUri(b){return F.URI.revive(await this.b.$createAppUri(b))}}e.$K_b=m}),define(De[86],Ce([1,0,3,15,23,2,217,250,104,6]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=e.$O_b=e.$N_b=e.$M_b=e.$L_b=void 0;class R{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(f,y,C,i,a,n,t){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new k.$7c,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new k.$7c,this._onDidDispose=this.#h.event,this.#e=f,this.#t=y,this.#r=C,this.#l=i,this.#u=a,this.#n=n,this.#c=I(n),this.#d=$(n),this.#i=t}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return this.#a=!0,(0,E.$dnb)(f,this.#l)}get cspSource(){const f=this.#n.extensionLocation;if(f.scheme===F.Schemas.https||f.scheme===F.Schemas.http){let y=f.toString();return y.endsWith("/")||(y+="/"),y+" "+E.$cnb}return E.$cnb}get html(){return this.a(),this.#s}set html(f){this.a(),this.#s!==f&&(this.#s=f,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(f)))}get options(){return this.a(),this.#r}set options(f){this.a(),h.$Jm(this.#r,f)||this.#t.$setOptions(this.#e,p(this.#n,this.#u,f)),this.#r=f}async postMessage(f){if(this.#o)return!1;const y=(0,m.$20)(f,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,y.message,...y.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(f){if(!this.#d)return f;const y=this.#n.extensionLocation?.scheme===F.Schemas.vscodeRemote,C=this.#n.extensionLocation.scheme===F.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return f.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,a,n,t,o,g)=>{const u=L.URI.from({scheme:t||"file",path:decodeURIComponent(o)}),d=(0,E.$dnb)(u,{isRemote:y,authority:C}).toString();return`${a}${d}${g}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(i,a,n,t,o,g)=>{const u=L.URI.from({scheme:t||"file",path:decodeURIComponent(o)}),d=(0,E.$dnb)(u,{isRemote:y,authority:C}).toString();return`${a}${d}${g}`})}}e.$L_b=R;function I(c){try{const f=(0,A.$ro)((0,A.$qo)(c.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.$M_b=I;function $(c){try{const f=(0,A.$ro)((0,A.$qo)(c.engines.vscode));return f?f.majorBase<1||f.majorBase===1&&f.minorBase<60:!1}catch{return!1}}class S{constructor(f,y,C,i,a){this.c=y,this.d=C,this.e=i,this.f=a,this.b=new Map,this.a=f.getProxy(b.$xJ.MainThreadWebviews)}$onMessage(f,y,C){const i=this.g(f);if(i){const{message:a}=(0,m.$30)(y,C.value);i._onMessageEmitter.fire(a)}}$onMissingCsp(f,y){this.e.warn(`${y} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,y,C){const i=new R(f,this.a,r(y),this.c,this.d,C,this.f);return this.b.set(f,i),i._onDidDispose(()=>{this.b.delete(f)}),i}deleteWebview(f){this.b.delete(f)}g(f){return this.b.get(f)}}e.$N_b=S;function D(c){return{id:c.identifier,location:c.extensionLocation}}e.$O_b=D;function p(c,f,y){return{enableCommandUris:y.enableCommandUris,enableScripts:y.enableScripts,enableForms:y.enableForms,portMapping:y.portMapping,localResourceRoots:y.localResourceRoots||s(c,f)}}e.$P_b=p;function r(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(f=>L.URI.from(f))}}function s(c,f){return[...(f?.getWorkspaceFolders()||[]).map(y=>y.uri),c.extensionLocation]}}),define(De[314],Ce([1,0,21,70,4,15,24,2,16,86,81,6,7]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;class S{constructor(a,n){this.document=a,this.b=n,this.a=1,this.c=new R.$H$b("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,n){await this.f(a).undo(),n||this.disposeBackup()}async redo(a,n){await this.f(a).redo(),n||this.disposeBackup()}disposeEdits(a){for(const n of a)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=C(this.document.uri)+this.a++;return(0,A.$8f)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const n=this.c.get(a,0);if(!n)throw new Error("No edit found");return n}}class D{constructor(){this.a=new Map}get(a,n){return this.a.get(this.b(a,n))}add(a,n,t){const o=this.b(a,n.uri);if(this.a.has(o))throw new Error(`Document already exists for viewType:${a} resource:${n.uri}`);const g=new S(n,t);return this.a.set(o,g),g}delete(a,n){const t=this.b(a,n.uri);this.a.delete(t)}b(a,n){return`${a}@@@${n}`}}var p;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(p||(p={}));class r{constructor(){this.a=new Map}addTextProvider(a,n,t){return this.b(0,a,n,t)}addCustomProvider(a,n,t){return this.b(1,a,n,t)}get(a){return this.a.get(a)}b(a,n,t,o){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:a,extension:t,provider:o}),new $.$zJ(()=>this.a.delete(n))}}class s{constructor(a,n,t,o,g){this.d=n,this.f=t,this.g=o,this.h=g,this.b=new r,this.c=new D,this.a=a.getProxy(I.$xJ.MainThreadCustomEditors)}registerCustomEditorProvider(a,n,t,o){const g=new h.$kb;return f(t)?(g.add(this.b.addTextProvider(n,a,t)),this.a.$registerTextEditorProvider((0,b.$O_b)(a),n,o.webviewOptions||{},{supportsMove:!!t.moveCustomTextEditor},(0,b.$M_b)(a))):(g.add(this.b.addCustomProvider(n,a,t)),c(t)&&g.add(t.onDidChangeCustomDocument(u=>{const d=this.i(n,u.document.uri);if(y(u)){const v=d.addEdit(u);this.a.$onDidEdit(u.document.uri,n,v,u.label)}else this.a.$onContentChange(u.document.uri,n)})),this.a.$registerCustomEditorProvider((0,b.$O_b)(a),n,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,b.$M_b)(a))),$.$zJ.from(g,new $.$zJ(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(a,n,t,o,g){const u=this.b.get(n);if(!u)throw new Error(`No provider found for '${n}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${n}'`);const d=m.URI.revive(a),v=await u.provider.openCustomDocument(d,{backupId:t,untitledDocumentData:o?.buffer},g);let l;return c(u.provider)&&this.f&&(l=this.f.workspaceValue(u.extension)??this.f.globalValue(u.extension)),this.c.add(n,v,l),{editable:c(u.provider)}}async $disposeCustomDocument(a,n){const t=this.b.get(n);if(!t)throw new Error(`No provider found for '${n}'`);if(t.type!==1)throw new Error(`Invalid provider type for '${n}'`);const o=m.URI.revive(a),{document:g}=this.i(n,o);this.c.delete(n,g),g.dispose()}async $resolveCustomEditor(a,n,t,o,g,u){const d=this.b.get(t);if(!d)throw new Error(`No provider found for '${t}'`);const v=E.ViewColumn.to(g),l=this.g.createNewWebview(n,o.contentOptions,d.extension),w=this.h.createNewWebviewPanel(n,t,o.title,v,o.options,l,o.active),P=m.URI.revive(a);switch(d.type){case 1:{const{document:M}=this.i(t,P);return d.provider.resolveCustomEditor(M,w,u)}case 0:{const M=this.d.getDocument(P);return d.provider.resolveCustomTextEditor(M,w,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,n,t){this.i(n,a).disposeEdits(t)}async $onMoveCustomEditor(a,n,t){const o=this.b.get(t);if(!o)throw new Error(`No provider found for '${t}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${t}'`);const g=this.h.getWebviewPanel(a);if(!g)throw new Error("No webview found");const u=m.URI.revive(n),d=this.d.getDocument(u);await o.provider.moveCustomTextEditor(d,g,k.CancellationToken.None)}async $undo(a,n,t,o){return this.i(n,a).undo(t,o)}async $redo(a,n,t,o){return this.i(n,a).redo(t,o)}async $revert(a,n,t){const o=this.i(n,a);await this.j(n).revertCustomDocument(o.document,t),o.disposeBackup()}async $onSave(a,n,t){const o=this.i(n,a);await this.j(n).saveCustomDocument(o.document,t),o.disposeBackup()}async $onSaveAs(a,n,t,o){const g=this.i(n,a);return this.j(n).saveCustomDocumentAs(g.document,m.URI.revive(t),o)}async $backup(a,n,t){const o=this.i(n,a),u=await this.j(n).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},t);return o.updateBackup(u),u.id}i(a,n){const t=this.c.get(a,m.URI.revive(n));if(!t)throw new Error("No custom document found");return t}j(a){const t=this.b.get(a)?.provider;if(!t||!c(t))throw new Error("Custom document is not editable");return t}}e.$oac=s;function c(i){return!!i.onDidChangeCustomDocument}function f(i){return typeof i.resolveCustomTextEditor=="function"}function y(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function C(i){const a=i.scheme===L.Schemas.file||i.scheme===L.Schemas.untitled?i.fsPath:i.toString();return(0,F.$bi)(a)+""}}),define(De[315],Ce([1,0,3,4,2,32,16,86,6,7]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=void 0;class R extends F.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(D,p,r,s){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new k.$7c),this.onDidDispose=this.#d.event,this.#h=this.B(new k.$7c),this.onDidChangeViewState=this.#h.event,this.#e=D,this.#t=p,this.#l=r,this.#i=s.viewType,this.#u=s.panelOptions,this.#r=s.viewColumn,this.#n=s.title,this.#a=s.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(D){this.c(),this.#n!==D&&(this.#n=D,this.#t.$setTitle(this.#e,D))}get iconPath(){return this.c(),this.#s}set iconPath(D){this.c(),this.#s!==D&&(this.#s=D,this.#t.$setIconPath(this.#e,h.URI.isUri(D)?{light:D,dark:D}:D))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(D){this.#c||(this.active!==D.active||this.visible!==D.visible||this.viewColumn!==D.viewColumn)&&(this.#a=D.active,this.#o=D.visible,this.#r=D.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(D,p){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof D>"u"?void 0:A.ViewColumn.from(D),preserveFocus:!!p})}c(){if(this.#c)throw new Error("Webview is disposed")}}class I{static c(){return(0,L.$5e)()}constructor(D,p,r){this.g=p,this.h=r,this.e=new Map,this.f=new Map,this.d=D.getProxy(E.$xJ.MainThreadWebviewPanels)}createWebviewPanel(D,p,r,s,c={}){const f=typeof s=="object"?s.viewColumn:s,y={viewColumn:A.ViewColumn.from(f),preserveFocus:typeof s=="object"&&!!s.preserveFocus},C=(0,m.$M_b)(D),i=I.c();this.d.$createWebviewPanel((0,m.$O_b)(D),i,p,{title:r,panelOptions:$(c),webviewOptions:(0,m.$P_b)(D,this.h,c),serializeBuffersForPostMessage:C},y);const a=this.g.createNewWebview(i,c,D);return this.createNewWebviewPanel(i,p,r,f,c,a,!0)}$onDidChangeWebviewPanelViewStates(D){const p=Object.keys(D);p.sort((r,s)=>{const c=D[r],f=D[s];return c.active?1:f.active?-1:+c.visible-+f.visible});for(const r of p){const s=this.getWebviewPanel(r);if(!s)continue;const c=D[r];s._updateViewState({active:c.active,visible:c.visible,viewColumn:A.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(D){this.getWebviewPanel(D)?.dispose(),this.e.delete(D),this.g.deleteWebview(D)}registerWebviewPanelSerializer(D,p,r){if(this.f.has(p))throw new Error(`Serializer for '${p}' already registered`);return this.f.set(p,{serializer:r,extension:D}),this.d.$registerSerializer(p,{serializeBuffersForPostMessage:(0,m.$M_b)(D)}),new b.$zJ(()=>{this.f.delete(p),this.d.$unregisterSerializer(p)})}async $deserializeWebviewPanel(D,p,r,s){const c=this.f.get(p);if(!c)throw new Error(`No serializer found for '${p}'`);const{serializer:f,extension:y}=c,C=this.g.createNewWebview(D,r.webviewOptions,y),i=this.createNewWebviewPanel(D,p,r.title,s,r.panelOptions,C,r.active);await f.deserializeWebviewPanel(i,r.state)}createNewWebviewPanel(D,p,r,s,c,f,y){const C=new R(D,this.d,f,{viewType:p,title:r,viewColumn:s,panelOptions:c,active:y});return this.e.set(D,C),C}getWebviewPanel(D){return this.e.get(D)}}e.$nac=I;function $(S){return{enableFindWidget:S.enableFindWidget,retainContextWhenHidden:S.retainContextWhenHidden}}}),define(De[316],Ce([1,0,3,4,86,16,6,7]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mac=void 0;class E extends F.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(I,$,S,D,p,r){super(),this.#u=!1,this.#a=this.B(new k.$7c),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new k.$7c),this.onDidDispose=this.#c.event,this.#i=S,this.#s=D,this.#e=I,this.#t=$,this.#l=p,this.#n=r}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(I){this.a(),this.#s!==I&&(this.#s=I,this.#t.$setWebviewViewTitle(this.#e,I))}get description(){return this.a(),this.#r}set description(I){this.a(),this.#r!==I&&(this.#r=I,this.#t.$setWebviewViewDescription(this.#e,I))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(I){I===this.#n||this.#u||(this.#n=I,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(I){this.a(),!(I?.value===this.#o?.value&&I?.tooltip===this.#o?.tooltip)&&(this.#o=L.ViewBadge.from(I),this.#t.$setWebviewViewBadge(this.#e,I))}show(I){this.a(),this.#t.$show(this.#e,!!I)}a(){if(this.#u)throw new Error("Webview is disposed")}}class b{constructor(I,$){this.d=$,this.b=new Map,this.c=new Map,this.a=I.getProxy(A.$xJ.MainThreadWebviewViews)}registerWebviewViewProvider(I,$,S,D){if(this.b.has($))throw new Error(`View provider for '${$}' already registered`);return this.b.set($,{provider:S,extension:I}),this.a.$registerWebviewViewProvider((0,h.$O_b)(I),$,{retainContextWhenHidden:D?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,h.$M_b)(I)}),new m.$zJ(()=>{this.b.delete($),this.a.$unregisterWebviewViewProvider($)})}async $resolveWebviewView(I,$,S,D,p){const r=this.b.get($);if(!r)throw new Error(`No view provider found for '${$}'`);const{provider:s,extension:c}=r,f=this.d.createNewWebview(I,{},c),y=new E(I,this.a,$,S,f,!0);this.c.set(I,y),await s.resolveWebviewView(y,{state:D},p)}async $onDidChangeWebviewViewVisibility(I,$){this.e(I)._setVisible($)}async $disposeWebviewView(I){const $=this.e(I);this.c.delete(I),$.dispose(),this.d.deleteWebview(I)}e(I){const $=this.c.get(I);if(!$)throw new Error("No webview found");return $}}e.$mac=b}),define(De[144],Ce([1,0,3,6,2,15,12,5,20,27]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=e.$Q_b=void 0;let R=class kn{static{this.a={focused:!0,active:!0}}getState($){const S=this.d;return{get focused(){return S.focused},get active(){return(0,b.$wF)($,"windowActivity"),S.active}}}constructor($){this.c=new k.$7c,this.onDidChangeWindowState=this.c.event,this.d=kn.a,this.b=$.getProxy(F.$xJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:D})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",D)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,S){S!==this.d[$]&&(this.d={...this.d,[$]:S},this.c.fire(this.d))}openUri($,S){let D;if(typeof $=="string"){D=$;try{$=h.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,A.$jd)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,D,S)}async asExternalUri($,S){if((0,A.$jd)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const D=await this.b.$asExternalUri($,S);return h.URI.from(D)}};e.$Q_b=R,e.$Q_b=R=Je([qe(0,E.$zL)],R),e.$R_b=(0,m.$nh)("IExtHostWindow")}),define(De[317],Ce([1,0,285,26,20]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kbc=void 0;const L=1024*1024;let A=class extends k.$Lac{constructor(E,b){super(E,b),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(E,b,R){const I=E==="error"||E==="warn"?process.stderr:process.stdout;this.g=!0,I.write(`
START_NATIVE_LOG
`),b.apply(console,R),I.write(`
END_NATIVE_LOG
`),this.g=!1}j(E,b){const R=process[E],I=R.write;let $="";Object.defineProperty(R,"write",{set:()=>{},get:()=>(S,D,p)=>{if(!this.g){$+=S.toString(D);const r=$.length>L?$.length:$.lastIndexOf(`
`);r!==-1&&(console[b]($.slice(0,r)),$=$.slice(r+1))}I.call(R,S,D,p)}})}};e.$kbc=A,e.$kbc=A=Je([qe(0,h.$zL),qe(1,F.$PL)],A)}),define(De[318],Ce([1,0,63,15,18,229,30,11]),function(me,e,k,F,h,L,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lbc=void 0;let E=class{constructor(I,$){I.addFileSystemProvider(F.Schemas.file,new b($),{isCaseSensitive:m.$k})}};e.$lbc=E,e.$lbc=E=Je([qe(0,k.$d_b),qe(1,h.$Pi)],E);class b{constructor(I){this.b=I,this.a=new L.$Pp(this.b)}async stat(I){const $=await this.a.stat(I);return{type:$.type,ctime:$.ctime,mtime:$.mtime,size:$.size,permissions:$.permissions===A.FilePermission.Readonly?1:void 0}}readDirectory(I){return this.a.readdir(I)}createDirectory(I){return this.a.mkdir(I)}readFile(I){return this.a.readFile(I)}writeFile(I,$,S){return this.a.writeFile(I,$,{...S,unlock:!1,atomic:!1})}delete(I,$){return this.a.delete(I,{...$,useTrash:!1,atomic:!1})}rename(I,$,S){return this.a.rename(I,$,S)}copy(I,$,S){return this.a.copy(I,$,S)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(I,$){throw new Error("Method not implemented.")}}}),define(De[319],Ce([1,0,13,75,32,36,4,6,2,20]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jbc=void 0;let R=class extends A.$lb{constructor($,S){super();const D=$.getProxy(m.$xJ.MainThreadDownloadService);S.registerCommand(!1,"_workbench.downloadResource",async p=>{const r=E.URI.file((0,k.$ac)((0,F.tmpdir)(),(0,h.$5e)()));return await D.$download(p,r),r})}};e.$jbc=R,e.$jbc=R=Je([qe(0,b.$zL),qe(1,L.$VL)],R)}),define(De[320],Ce([1,0,143,15,231,32]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wbc=void 0;class A extends k.$Kac{m(E,b,R){return E.scheme===F.Schemas.file?new h.$LM(R?.name||(0,L.$5e)(),E.fsPath,!R?.donotRotate,!!R?.donotUseFormatters,b):super.m(E,b,R)}registerLogger(E){super.registerLogger(E),this.n.$registerLogger(E)}deregisterLogger(E){super.deregisterLogger(E),this.n.$deregisterLogger(E)}}e.$wbc=A}),define(De[321],Ce([1,0,49,13,2,85,4,15,17,29]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=void 0;class R extends L.$f_b{constructor(){super(...arguments),this.i=null}async g(i){const a=await super.g(i);if(a.scheme!==m.Schemas.file)return a;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${a.fsPath}.`),a;const n=a.fsPath;let t=0;do{let o;t===0?o=n:o=/[/\\]$/.test(n)?`${n.substr(0,n.length-1)}-${t}`:`${n}-${t}`,await I(o);const g=F.$ac(o,"vscode.lock"),u=await p(this.d,g,!1);if(u)return this.i=u,process.on("exit",()=>{u.dispose()}),h.URI.file(o);t++}while(t<10);return a}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$vbc=R;async function I(C){try{await b.Promises.stat(C);return}catch{}try{await b.Promises.mkdir(C,{recursive:!0})}catch{}}const $=1e3,S=10*60*1e3;class D extends A.$lb{constructor(i,a){super(),this.b=i,this.c=a,this.a=this.B(new E.$Dg),this.a.cancelAndSet(async()=>{const n=await r(i,a);(!n||n.pid!==process.pid)&&(i.info(`Lock '${a}': The lock was lost unexpectedly.`),this.a.cancel());try{await b.Promises.utimes(a,new Date,new Date)}catch(t){i.error(t),i.info(`Lock '${a}': Could not update mtime.`)}},$)}dispose(){super.dispose();try{k.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const a={pid:process.pid,willReleaseAt:Date.now()+i};await b.Promises.writeFile(this.c,JSON.stringify(a),{flag:"w"})}catch(a){this.b.error(a)}}}async function p(C,i,a){try{const t={pid:process.pid,willReleaseAt:0};await b.Promises.writeFile(i,JSON.stringify(t),{flag:"wx"})}catch(t){C.error(t)}const n=await r(C,i);return!n||n.pid!==process.pid?a?(C.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(C.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),f(C,i)):(C.info(`Lock '${i}': Lock acquired.`),new D(C,i))}async function r(C,i){let a;try{a=await b.Promises.readFile(i)}catch(n){return C.error(n),null}try{return JSON.parse(String(a))}catch(n){return C.error(n),null}}async function s(C,i){let a;try{a=await b.Promises.stat(i)}catch(n){return C.error(n),0}return a.mtime.getTime()}function c(C){try{return process.kill(C,0),!0}catch{return!1}}async function f(C,i){const a=await r(C,i);if(!a)return C.info(`Lock '${i}': Could not read pid of lock holder.`),y(C,i);if(a.willReleaseAt){let u=a.willReleaseAt-Date.now();if(u<5e3){for(u>0?C.info(`Lock '${i}': The lockfile is scheduled to be released in ${u} ms.`):C.info(`Lock '${i}': The lockfile is scheduled to have been released.`);u>0;){if(await(0,E.$ug)(Math.min(100,u)),await s(C,i)===0)return y(C,i);u=a.willReleaseAt-Date.now()}return y(C,i)}}if(!c(a.pid))return C.info(`Lock '${i}': The pid ${a.pid} appears to be gone.`),y(C,i);const n=await s(C,i),t=Date.now()-n;if(t<=S)return C.info(`Lock '${i}': The lock does not look stale, elapsed: ${t} ms, giving up.`),null;C.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,E.$ug)(2e3);const o=await s(C,i),g=Date.now()-o;return g<=S?(C.info(`Lock '${i}': The lock does not look stale, elapsed: ${g} ms, giving up.`),null):(C.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),y(C,i))}async function y(C,i){C.info(`Lock '${i}': Deleting a stale lock.`);try{await b.Promises.unlink(i)}catch{}return p(C,i,!0)}}),define(De[322],Ce([1,0,32,20,43]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qac=void 0;let L=class extends h.$i_b{constructor(m){super(!0,m)}createTerminal(m,E,b){return this.createTerminalFromOptions({name:m,shellPath:E,shellArgs:b})}createTerminalFromOptions(m,E){const b=new h.$h_b(this.a,(0,k.$5e)(),m,m.name);return this.f.push(b),b.create(m,this.J(m,E)),b.value}};e.$Qac=L,e.$Qac=L=Je([qe(0,F.$zL)],L)}),define(De[323],Ce([1,0,46,112,11,24,2,29,18,132,26,20,64]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ubc=e.$tbc=e.$sbc=e.$rbc=e.$qbc=e.$pbc=e.$obc=e.$nbc=void 0;function S(i){const a=i.trim().split(`
`),n=[];return a.forEach(o=>{const g=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(o);g&&g.length>=3&&n.push({pid:parseInt(g[1],10),socket:parseInt(g[2],10)})}),n.reduce((o,g)=>(o[g.socket]=g,o),{})}e.$nbc=S;function D(...i){const a=[].concat(...i.map(r));return[...new Map(a.filter(n=>n.st==="0A").map(n=>{const t=n.local_address.split(":");return{socket:parseInt(n.inode,10),ip:p(t[0]),port:parseInt(t[1],16)}}).map(n=>[n.ip+":"+n.port,n])).values()]}e.$obc=D;function p(i){let a="";if(i.length===8)for(let n=i.length-2;n>=0;n-=2)a+=parseInt(i.substr(n,2),16),n!==0&&(a+=".");else for(let n=0;n<i.length;n+=8){const t=i.substring(n,n+8);let o="";for(let g=8;g>=2;g-=2)o+=t.substring(g-2,g),(g===6||g===2)&&(o=parseInt(o,16).toString(16),a+=`${o}`,o="",n+g!==i.length-6&&(a+=":"))}return a}e.$pbc=p;function r(i){const a=i.trim().split(`
`),n=a.shift().trim().split(/\s+/).filter(o=>o!=="rx_queue"&&o!=="tm->when");return a.map(o=>o.trim().split(/\s+/).reduce((g,u,d)=>(g[n[d]||d]=u,g),{}))}e.$qbc=r;function s(i){return!!i.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||i.indexOf("out/server-main.js")!==-1||i.indexOf("_productName=VSCode")!==-1}function c(i){const a=i.trim().split(`
`),n=[];return a.forEach(t=>{const o=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(t);o&&o.length>=4&&n.push({pid:parseInt(o[1],10),ppid:parseInt(o[2]),cmd:o[3]})}),n}e.$rbc=c;async function f(i,a,n){const t=n.reduce((g,u)=>(g[u.pid]=u,g),{}),o=[];return i.forEach(({socket:g,ip:u,port:d})=>{const v=a[g]?a[g].pid:void 0,l=v?t[v]?.cmd:void 0;v&&l&&!s(l)&&o.push({host:u,port:d,detail:l,pid:v})}),o}e.$sbc=f;function y(i,a,n){const t=new Map,o=c(a);for(const g of i){const u=n.get(g.port);if(u){t.set(g.port,u);continue}const d=o.find(v=>v.cmd.includes(`${g.port}`));if(d){let v=d,l;do l=o.find(w=>w.ppid===v.pid),l&&(v=l);while(l);t.set(g.port,{host:g.ip,port:g.port,pid:v.pid,detail:v.cmd,ppid:v.ppid})}else t.set(g.port,{host:g.ip,port:g.port,ppid:Number.MAX_VALUE})}return t}e.$tbc=y;let C=class extends $.$Upb{constructor(a,n,t){super(a,n,t),this.r=void 0,this.s=new Map,this.t=!1,h.$k&&n.remote.isRemote&&n.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.v())}async $registerCandidateFinder(a){if(a&&this.t)return;this.t=a;let n;this.r&&(n=this.r,await this.a.$onFoundNewCandidates(this.r));const t=new F.$ul;let o=0;for(;this.t;){const g=new Date().getTime(),u=(await this.w()).filter(l=>(0,b.$Iz)(l.host)||(0,b.$Kz)(l.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${u.map(l=>l.port).join(", ")}`);const d=new Date().getTime()-g;this.n.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${d} ms.`),o++>3&&t.update(d),(!n||JSON.stringify(n)!==JSON.stringify(u))&&(n=u,await this.a.$onFoundNewCandidates(n));const v=this.u(t.value);this.n.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${v} ms.`),await new Promise(l=>setTimeout(()=>l(),v))}}u(a){return Math.max(a*20,2e3)}async v(){this.r=await this.w(),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.r.map(a=>a.port).join(", ")}`)}async w(){let a="",n="";try{a=await m.Promises.readFile("/proc/net/tcp","utf8"),n=await m.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const t=D(a,n),o=await new Promise(M=>{(0,k.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,T,z)=>{M(T)})}),g=S(o),u=await m.Promises.readdir("/proc"),d=[];for(const M of u)try{const N=Number(M),T=L.$8f(A.URI.file("/proc"),M);if((await m.Promises.stat(T.fsPath)).isDirectory()&&!isNaN(N)){const j=await m.Promises.readlink(L.$8f(T,"cwd").fsPath),U=await m.Promises.readFile(L.$8f(T,"cmdline").fsPath,"utf8");d.push({pid:N,cwd:j,cmd:U})}}catch{}const v=[],l=t.filter(M=>{const N=g[M.socket];return N||v.push(M),N}),w=f(l,g,d);let P;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${v.length}`),v.length>0){const M=await new Promise(N=>{(0,k.exec)("ps -F -A -l | grep root",(T,z,j)=>{N(z)})});this.s=y(v,M,this.s),P=Array.from(this.s.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${P.map(N=>N.port).join(", ")}`)}return w.then(M=>P?M.concat(P):M)}};e.$ubc=C,e.$ubc=C=Je([qe(0,I.$zL),qe(1,R.$PL),qe(2,E.$Pi)],C)}),define(De[324],Ce([1,0,17,22,21,8,3,4,121,278,60]),function(me,e,k,F,h,L,A,m,E,b,R){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$t1b=e.ResponsiveState=e.RequestInitiator=e.$s1b=e.$r1b=void 0;function $(l,w){try{return JSON.stringify(l,w)}catch{return"null"}}const S="$$ref$$",D={[S]:-1};class p{constructor(w,P){this.jsonString=w,this.referencedBuffers=P}}function r(l,w=null,P=!1){const M=[];return{jsonString:(P?$:JSON.stringify)(l,(T,z)=>{if(typeof z>"u")return D;if(typeof z=="object"){if(z instanceof F.$Jb){const j=M.push(z)-1;return{[S]:j}}if(w)return w(T,z)}return z}),referencedBuffers:M}}e.$r1b=r;function s(l,w,P){return JSON.parse(l,(M,N)=>{if(N){const T=N[S];if(typeof T=="number")return w[T];if(P&&N.$mid===1)return P.transformIncoming(N)}return N})}e.$s1b=s;function c(l,w){return JSON.stringify(l,w)}function f(l){return l?(w,P)=>P&&P.$mid===1?l.transformOutgoing(P):P:null}var y;(function(l){l[l.LocalSide=0]="LocalSide",l[l.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));var C;(function(l){l[l.Responsive=0]="Responsive",l[l.Unresponsive=1]="Unresponsive"})(C||(e.ResponsiveState=C={}));const i=()=>{},a=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class t extends m.$lb{static{I=a}static{this.a=3*1e3}constructor(w,P=null,M=null){super(),this[I]=!0,this.b=this.B(new A.$7c),this.onDidChangeResponsiveState=this.b.event,this.c=w,this.f=P,this.g=M,this.h=f(this.g),this.j=!1,this.k=[],this.l=[];for(let N=0,T=R.$Tz.count;N<T;N++)this.k[N]=null,this.l[N]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new k.$Eg(()=>this.C(),1e3)),this.c.onMessage(N=>this.G(N))}dispose(){this.j=!0,Object.keys(this.s).forEach(w=>{this.s[w].resolveErr(L.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(w){this.u===0&&(this.v=Date.now()+t.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(w){this.v=Date.now()+t.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(w){this.t!==w&&(this.t=w,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(w){return this.g?(0,E.$om)(w,this.g):w}getProxy(w){const{nid:P,sid:M}=w;return this.l[P]||(this.l[P]=this.F(P,M)),this.l[P]}F(w,P){const M={get:(N,T)=>(typeof T=="string"&&!N[T]&&T.charCodeAt(0)===36&&(N[T]=(...z)=>this.O(w,T,z)),T===n?P:N[T])};return new Proxy(Object.create(null),M)}set(w,P){return this.k[w.nid]=P,P}assertRegistered(w){for(let P=0,M=w.length;P<M;P++){const N=w[P];if(!this.k[N.nid])throw new Error(`Missing proxy instance ${N.sid}`)}}G(w){if(this.j)return;const P=w.byteLength,M=o.read(w,0),N=M.readUInt8(),T=M.readUInt32();switch(N){case 1:case 2:{let{rpcId:z,method:j,args:U}=u.deserializeRequestJSONArgs(M);this.g&&(U=(0,E.$om)(U,this.g)),this.H(P,T,z,j,U,N===2);break}case 3:case 4:{let{rpcId:z,method:j,args:U}=u.deserializeRequestMixedArgs(M);this.g&&(U=(0,E.$om)(U,this.g)),this.H(P,T,z,j,U,N===4);break}case 5:{this.f?.logIncoming(P,T,0,"ack"),this.z(T);break}case 6:{this.I(P,T);break}case 7:{this.J(P,T,void 0);break}case 9:{let z=u.deserializeReplyOKJSON(M);this.g&&(z=(0,E.$om)(z,this.g)),this.J(P,T,z);break}case 10:{const z=u.deserializeReplyOKJSONWithBuffers(M,this.g);this.J(P,T,z);break}case 8:{const z=u.deserializeReplyOKVSBuffer(M);this.J(P,T,z);break}case 11:{let z=u.deserializeReplyErrError(M);this.g&&(z=(0,E.$om)(z,this.g)),this.L(P,T,z);break}case 12:{this.L(P,T,void 0);break}default:console.error("received unexpected message"),console.error(w)}}H(w,P,M,N,T,z){this.f?.logIncoming(w,P,1,`receiveRequest ${(0,R.$Vz)(M)}.${N}(`,T);const j=String(P);let U,Y;if(z){const ge=new h.$dd;T.push(ge.token),U=this.M(M,N,T),Y=()=>ge.cancel()}else U=this.M(M,N,T),Y=i;this.p[j]=Y;const H=u.serializeAcknowledged(P);this.f?.logOutgoing(H.byteLength,P,1,"ack"),this.c.send(H),U.then(ge=>{delete this.p[j];const ie=u.serializeReplyOK(P,ge,this.h);this.f?.logOutgoing(ie.byteLength,P,1,"reply:",ge),this.c.send(ie)},ge=>{delete this.p[j];const ie=u.serializeReplyErr(P,ge);this.f?.logOutgoing(ie.byteLength,P,1,"replyErr:",ge),this.c.send(ie)})}I(w,P){this.f?.logIncoming(w,P,1,"receiveCancel");const M=String(P);this.p[M]?.()}J(w,P,M){this.f?.logIncoming(w,P,0,"receiveReply:",M);const N=String(P);if(!this.s.hasOwnProperty(N))return;const T=this.s[N];delete this.s[N],T.resolveOk(M)}L(w,P,M){this.f?.logIncoming(w,P,0,"receiveReplyErr:",M);const N=String(P);if(!this.s.hasOwnProperty(N))return;const T=this.s[N];delete this.s[N];let z;M&&(M.$isError?(z=new Error,z.name=M.name,z.message=M.message,z.stack=M.stack):z=M),T.resolveErr(z)}M(w,P,M){try{return Promise.resolve(this.N(w,P,M))}catch(N){return Promise.reject(N)}}N(w,P,M){const N=this.k[w];if(!N)throw new Error("Unknown actor "+(0,R.$Vz)(w));const T=N[P];if(typeof T!="function")throw new Error("Unknown method "+P+" on actor "+(0,R.$Vz)(w));return T.apply(N,M)}O(w,P,M){if(this.j)return new b.$q1b;let N=null;if(M.length>0&&h.CancellationToken.isCancellationToken(M[M.length-1])&&(N=M.pop()),N&&N.isCancellationRequested)return Promise.reject(L.$4());const T=u.serializeRequestArguments(M,this.h),z=++this.m,j=String(z),U=new b.$p1b;N&&N.onCancellationRequested(()=>{const H=u.serializeCancel(z);this.f?.logOutgoing(H.byteLength,z,0,"cancel"),this.c.send(u.serializeCancel(z))}),this.s[j]=U,this.y(z);const Y=u.serializeRequest(z,w,P,T,!!N);return this.f?.logOutgoing(Y.byteLength,z,0,`request: ${(0,R.$Vz)(w)}.${P}(`,M),this.c.send(Y),U}}e.$t1b=t;class o{static alloc(w,P,M){const N=new o(F.$Jb.alloc(M+1+4),0);return N.writeUInt8(w),N.writeUInt32(P),N}static read(w,P){return new o(w,P)}get buffer(){return this.a}constructor(w,P){this.a=w,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(w){this.a.writeUInt8(w,this.b),this.b+=1}readUInt8(){const w=this.a.readUInt8(this.b);return this.b+=1,w}writeUInt32(w){this.a.writeUInt32BE(w,this.b),this.b+=4}readUInt32(){const w=this.a.readUInt32BE(this.b);return this.b+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this.a.writeUInt8(w.byteLength,this.b),this.b+=1,this.a.set(w,this.b),this.b+=w.byteLength}readShortString(){const w=this.a.readUInt8(this.b);this.b+=1;const M=this.a.slice(this.b,this.b+w).toString();return this.b+=w,M}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readLongString(){const w=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+w).toString();return this.b+=w,M}writeBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readVSBuffer(){const w=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+w);return this.b+=w,P}static sizeMixedArray(w){let P=0;P+=1;for(let M=0,N=w.length;M<N;M++){const T=w[M];switch(P+=1,T.type){case 1:P+=this.sizeLongString(T.value);break;case 2:P+=this.sizeVSBuffer(T.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(T.value);for(let z=0;z<T.buffers.length;++z)P+=this.sizeVSBuffer(T.buffers[z]);break;case 4:break}}return P}writeMixedArray(w){this.a.writeUInt8(w.length,this.b),this.b+=1;for(let P=0,M=w.length;P<M;P++){const N=w[P];switch(N.type){case 1:this.writeUInt8(1),this.writeLongString(N.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(N.value);break;case 3:this.writeUInt8(3),this.writeUInt32(N.buffers.length),this.writeLongString(N.value);for(let T=0;T<N.buffers.length;++T)this.writeBuffer(N.buffers[T]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this.a.readUInt8(this.b);this.b+=1;const P=new Array(w);for(let M=0;M<w;M++)switch(this.readUInt8()){case 1:P[M]=this.readLongString();break;case 2:P[M]=this.readVSBuffer();break;case 3:{const T=this.readUInt32(),z=this.readLongString(),j=[];for(let U=0;U<T;++U)j.push(this.readVSBuffer());P[M]=new R.$Wz(s(z,j,null));break}case 4:P[M]=void 0;break}return P}}var g;(function(l){l[l.Simple=0]="Simple",l[l.Mixed=1]="Mixed"})(g||(g={}));class u{static a(w){for(let P=0,M=w.length;P<M;P++)if(w[P]instanceof F.$Jb||w[P]instanceof R.$Wz||typeof w[P]>"u")return!0;return!1}static serializeRequestArguments(w,P){if(this.a(w)){const M=[];for(let N=0,T=w.length;N<T;N++){const z=w[N];if(z instanceof F.$Jb)M[N]={type:2,value:z};else if(typeof z>"u")M[N]={type:4};else if(z instanceof R.$Wz){const{jsonString:j,referencedBuffers:U}=r(z.value,P);M[N]={type:3,value:F.$Jb.fromString(j),buffers:U}}else M[N]={type:1,value:F.$Jb.fromString(c(z,P))}}return{type:1,args:M}}return{type:0,args:c(w,P)}}static serializeRequest(w,P,M,N,T){switch(N.type){case 0:return this.b(w,P,M,N.args,T);case 1:return this.c(w,P,M,N.args,T)}}static b(w,P,M,N,T){const z=F.$Jb.fromString(M),j=F.$Jb.fromString(N);let U=0;U+=o.sizeUInt8(),U+=o.sizeShortString(z),U+=o.sizeLongString(j);const Y=o.alloc(T?2:1,w,U);return Y.writeUInt8(P),Y.writeShortString(z),Y.writeLongString(j),Y.buffer}static deserializeRequestJSONArgs(w){const P=w.readUInt8(),M=w.readShortString(),N=w.readLongString();return{rpcId:P,method:M,args:JSON.parse(N)}}static c(w,P,M,N,T){const z=F.$Jb.fromString(M);let j=0;j+=o.sizeUInt8(),j+=o.sizeShortString(z),j+=o.sizeMixedArray(N);const U=o.alloc(T?4:3,w,j);return U.writeUInt8(P),U.writeShortString(z),U.writeMixedArray(N),U.buffer}static deserializeRequestMixedArgs(w){const P=w.readUInt8(),M=w.readShortString(),N=w.readMixedArray(),T=new Array(N.length);for(let z=0,j=N.length;z<j;z++){const U=N[z];typeof U=="string"?T[z]=JSON.parse(U):T[z]=U}return{rpcId:P,method:M,args:T}}static serializeAcknowledged(w){return o.alloc(5,w,0).buffer}static serializeCancel(w){return o.alloc(6,w,0).buffer}static serializeReplyOK(w,P,M){if(typeof P>"u")return this.d(w);if(P instanceof F.$Jb)return this.e(w,P);if(P instanceof R.$Wz){const{jsonString:N,referencedBuffers:T}=r(P.value,M,!0);return this.g(w,N,T)}else return this.f(w,$(P,M))}static d(w){return o.alloc(7,w,0).buffer}static e(w,P){let M=0;M+=o.sizeVSBuffer(P);const N=o.alloc(8,w,M);return N.writeVSBuffer(P),N.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static f(w,P){const M=F.$Jb.fromString(P);let N=0;N+=o.sizeLongString(M);const T=o.alloc(9,w,N);return T.writeLongString(M),T.buffer}static g(w,P,M){const N=F.$Jb.fromString(P);let T=0;T+=o.sizeUInt32,T+=o.sizeLongString(N);for(const j of M)T+=o.sizeVSBuffer(j);const z=o.alloc(10,w,T);z.writeUInt32(M.length),z.writeLongString(N);for(const j of M)z.writeBuffer(j);return z.buffer}static deserializeReplyOKJSON(w){const P=w.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(w,P){const M=w.readUInt32(),N=w.readLongString(),T=[];for(let z=0;z<M;++z)T.push(w.readVSBuffer());return new R.$Wz(s(N,T,P))}static serializeReplyErr(w,P){const M=P?$(L.$1(P),null):void 0;if(typeof M!="string")return this.h(w);const N=F.$Jb.fromString(M);let T=0;T+=o.sizeLongString(N);const z=o.alloc(11,w,T);return z.writeLongString(N),z.buffer}static deserializeReplyErrError(w){const P=w.readLongString();return JSON.parse(P)}static h(w){return o.alloc(12,w,0).buffer}}var d;(function(l){l[l.RequestJSONArgs=1]="RequestJSONArgs",l[l.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",l[l.RequestMixedArgs=3]="RequestMixedArgs",l[l.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",l[l.Acknowledged=5]="Acknowledged",l[l.Cancel=6]="Cancel",l[l.ReplyOKEmpty=7]="ReplyOKEmpty",l[l.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",l[l.ReplyOKJSON=9]="ReplyOKJSON",l[l.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",l[l.ReplyErrError=11]="ReplyErrError",l[l.ReplyErrEmpty=12]="ReplyErrEmpty"})(d||(d={}));var v;(function(l){l[l.String=1]="String",l[l.VSBuffer=2]="VSBuffer",l[l.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",l[l.Undefined=4]="Undefined"})(v||(v={}))}),define(De[325],Ce([1,0,3,42,47,5]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.$LI=e.OutputChannelUpdateMode=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=void 0,e.$AI="text/x-code-output",e.$BI="output",e.$CI="Log",e.$DI="text/x-code-log-output",e.$EI="log",e.$FI="log",e.$GI="workbench.panel.output",e.$HI=new h.$Mi("inOutput",!1),e.$II=new h.$Mi("activeLogOutput",!1),e.$JI=new h.$Mi("outputView.scrollLock",!1),e.$KI=(0,L.$nh)("outputService");var A;(function(E){E[E.Append=1]="Append",E[E.Replace=2]="Replace",E[E.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$LI={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new k.$7c,this.onDidRegisterChannel=this.b.event,this.c=new k.$7c,this.onDidRemoveChannel=this.c.event}registerChannel(b){this.a.has(b.id)||(this.a.set(b.id,b),this.b.fire(b.id))}getChannels(){const b=[];return this.a.forEach(R=>b.push(R)),b}getChannel(b){return this.a.get(b)}removeChannel(b){this.a.delete(b),this.c.fire(b)}}F.$Rm.add(e.$LI.OutputChannels,new m),e.$MI=new h.$Mi("activeOutputChannel","")}),define(De[145],Ce([1,0,6,5,20,25,18,325,63,26,51,171,22,14,30,3,4]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=e.$A_b=void 0;class s extends A.$Vi{get disposed(){return this.l}constructor(C,i,a,n,t){super(),this.id=C,this.name=i,this.m=a,this.n=n,this.extension=t,this.k=0,this.l=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(o=>this.setLevel(o)))}get logLevel(){return this.getLevel()}appendLine(C){this.append(C+`
`)}append(C){this.info(C)}clear(){const C=this.k;this.m.flush(),this.n.$update(this.id,m.OutputChannelUpdateMode.Clear,C)}replace(C){const i=this.k;this.info(C),this.n.$update(this.id,m.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(C,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof C=="boolean"?C:i))}hide(){this.n.$close(this.id)}g(C,i){this.k+=$.$Jb.fromString(i).byteLength,(0,A.log)(this.m,C,i),this.visible&&(this.m.flush(),this.n.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class c extends s{appendLine(C){this.append(C)}}let f=class{constructor(C,i,a,n,t,o){this.i=i,this.j=a,this.k=n,this.l=t,this.m=o,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=C.getProxy(k.$xJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,I.$Ql)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(C){this.h=C;for(const[i,a]of this.g)a.visible=i===this.h}createOutputChannel(C,i,a){if(C=C.trim(),!C)throw new Error("illegal argument `name`. must not be falsy");const n=typeof i=="object"&&i.log,t=(0,S.$ie)(i)?i:void 0;if((0,S.$ie)(t)&&!t.trim())throw new Error("illegal argument `languageId`. must not be empty");let o;const g=this.i.environment.extensionLogLevel?.find(([d])=>L.$Fl.equals(a.identifier,d))?.[1];g&&(o=(0,A.$6i)(g));const u=n?this.o(C,o,a):this.n(C,t,a);return u.then(d=>{this.g.set(d.id,d),d.visible=d.id===this.h}),n?this.r(C,o??this.m.getLevel(),u):this.q(C,u)}async n(C,i,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,t=this.k.extUri.joinPath(n,`${this.f++}-${C.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),o=this.l.createLogger(t,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),g=await this.a.$register(C,t,i,a.identifier.value);return new s(g,C,o,this.a,a)}async o(C,i,a){const n=await this.p(a),t=C.replace(/[\\/:\*\?"<>\|]/g,""),o=this.k.extUri.joinPath(n,`${t}.log`),g=`${a.identifier.value}.${t}`,u=this.l.createLogger(o,{id:g,name:C,logLevel:i,extensionId:a.identifier.value});return new c(g,C,u,this.a,a)}p(C){let i=this.d.get(C.identifier.value);if(!i){const a=this.k.extUri.joinPath(this.i.logsLocation,C.identifier.value);this.d.set(C.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(a)}catch(n){if((0,D.$6j)(n)!==D.FileSystemProviderErrorCode.FileExists)throw n}return a})())}return i}q(C,i){let a=!1;const n=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return C},append(t){n(),i.then(o=>o.append(t))},appendLine(t){n(),i.then(o=>o.appendLine(t))},clear(){n(),i.then(t=>t.clear())},replace(t){n(),i.then(o=>o.replace(t))},show(t,o){n(),i.then(g=>g.show(t,o))},hide(){n(),i.then(t=>t.hide())},dispose(){a=!0,i.then(t=>t.dispose())}}}r(C,i,a){const n=new r.$kb,t=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},o=n.add(new p.$7c);function g(u){i=u,o.fire(u)}return a.then(u=>{n.add(u),u.logLevel!==i&&g(u.logLevel),n.add(u.onDidChangeLogLevel(d=>g(d)))}),{...this.q(C,a),get logLevel(){return i},onDidChangeLogLevel:o.event,trace(u,...d){t(),a.then(v=>v.trace(u,...d))},debug(u,...d){t(),a.then(v=>v.debug(u,...d))},info(u,...d){t(),a.then(v=>v.info(u,...d))},warn(u,...d){t(),a.then(v=>v.warn(u,...d))},error(u,...d){t(),a.then(v=>v.error(u,...d))},dispose(){n.dispose()}}}};e.$A_b=f,e.$A_b=f=Je([qe(0,h.$zL),qe(1,b.$PL),qe(2,E.$d_b),qe(3,R.$K$b),qe(4,A.$Qi),qe(5,A.$Pi)],f),e.$B_b=(0,F.$nh)("IExtHostOutputService")}),define(De[326],Ce([1,0,5,17]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0,e.$6l=(0,k.$nh)("remoteAgentService"),e.$7l=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(h){let L=1/0;for(let m=0;m<this.maxSampleCount;m++){const E=await h.getRoundTripTime();if(E===void 0)return;L=Math.min(L,E/2),await(0,F.$ug)(this.sampleDelay)}this.average.push(L),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(L):A=this.initial.reduce((m,E)=>m+E,0)/this.initial.length,this.lastMeasurement={initial:A,current:L,average:this.average.reduce((m,E)=>m+E,0)/this.average.length,high:(()=>typeof A>"u"?!1:L>this.highLatencyMaxThreshold||L>this.highLatencyMinThreshold&&L>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(De[327],Ce([1,0,31,15,13,11,24,2,5,245,50,270,326]),function(me,e,k,F,h,L,A,m,E,b,R,I,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.$_I=void 0,e.$_I=(0,E.$nh)("pathService");let S=class Sn{constructor(p,r,s,c){this.d=p,this.e=r,this.f=s,this.g=c,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const f=await this.e.getEnvironment();return this.c=f?.userHome??p})()}hasValidBasename(p,r,s){return typeof r=="string"||typeof r>"u"?this.a.then(c=>this.h(p,c,r)):this.h(p,r,s)}h(p,r,s){return p.scheme===F.Schemas.file||p.scheme===F.Schemas.vscodeRemote?(0,k.$He)(s??(0,A.$5f)(p),r===1):!0}get defaultUriScheme(){return Sn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(p,r){if(p.remoteAuthority)return F.Schemas.vscodeRemote;const s=(0,b.$9I)(r.getWorkspace());if(s)return s;const c=r.getWorkspace().folders[0];if(c)return c.uri.scheme;const f=r.getWorkspace().configuration;return f?f.scheme:F.Schemas.file}userHome(p){return p?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(p=>p===1?h.$9b:h.$0b)}async fileURI(p){let r="";if(await this.a===1&&(p=p.replace(/\\/g,"/")),p[0]==="/"&&p[1]==="/"){const c=p.indexOf("/",2);c===-1?(r=p.substring(2),p="/"):(r=p.substring(2,c),p=p.substring(c)||"/")}return m.URI.from({scheme:F.Schemas.file,authority:r,path:p,query:"",fragment:""})}};e.$aJ=S,e.$aJ=S=Je([qe(1,$.$6l),qe(2,I.$NI),qe(3,R.$wh)],S)}),define(De[87],Ce([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$PH=e.$OH=void 0;class k{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new k(0,0)}with(A){return new k(0,0)}}e.$OH=k;class F{constructor(A,m,E,b){this.isEmpty=!1,this.isSingleLine=!1,this.start=new k(A,m),this.end=new k(E,b)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new F(0,0,0,0)}with(A){return new F(0,0,0,0)}}e.$PH=F;var h;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(h||(e.TextSearchCompleteMessageType=h={}))}),define(De[35],Ce([1,0,19,34,23,31,12,5,13,8,87,17]),function(me,e,k,F,h,L,A,m,E,b,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.SearchErrorCode=e.$4H=e.$3H=e.SearchSortOrder=e.ViewMode=e.$2H=e.$1H=e.$ZH=e.$YH=e.SearchCompletionExitCode=e.$XH=e.$WH=e.$VH=e.QueryType=e.SearchProviderType=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$QH="workbench.view.search",e.$RH="workbench.panel.search",e.$SH="workbench.view.search",e.$TH="search.exclude";const $="\u27EA ",S=" characters skipped \u27EB",D=($.length+S.length+5)*2;e.$UH=(0,m.$nh)("searchService");var p;(function(q){q[q.file=0]="file",q[q.text=1]="text"})(p||(e.SearchProviderType=p={}));var r;(function(q){q[q.File=1]="File",q[q.Text=2]="Text"})(r||(e.QueryType=r={}));function s(q){return!!q.preview}e.$VH=s;function c(q){return!!q.resource}e.$WH=c;function f(q){return!!q.message}e.$XH=f;var y;(function(q){q[q.Normal=0]="Normal",q[q.NewSearchStarted=1]="NewSearchStarted"})(y||(e.SearchCompletionExitCode=y={}));class C{constructor(V){this.resource=V,this.results=[]}}e.$YH=C;class i{constructor(V,ce,re,fe){this.ranges=ce,this.webviewIndex=fe;const de=Array.isArray(ce)?ce:[ce];if(re&&re.matchLines===1&&a(de)){V=(0,A.$be)(V,re.matchLines);let B="",_=0,Ee=0;const Re=Math.floor(re.charsPerLine/5),ne=[];for(const ee of de){const he=Math.max(ee.startColumn-Re,0),X=ee.startColumn+re.charsPerLine;if(he>Ee+Re+D){const ue=$+(he-Ee)+S;B+=ue+V.slice(he,X),_+=he-(Ee+ue.length)}else B+=V.slice(Ee,X);ne.push(new t(0,ee.startColumn-_,ee.endColumn-_)),Ee=X}this.preview={text:B,matches:Array.isArray(this.ranges)?ne:ne[0]}}else{const B=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:V,matches:(0,k.$Hf)(ce,_=>new n(_.startLineNumber-B,_.startColumn,_.endLineNumber-B,_.endColumn))}}}}e.$ZH=i;function a(q){const V=q[0].startLineNumber;for(const ce of q)if(ce.startLineNumber!==V||ce.endLineNumber!==V)return!1;return!0}class n{constructor(V,ce,re,fe){this.startLineNumber=V,this.startColumn=ce,this.endLineNumber=re,this.endColumn=fe}}e.$1H=n;class t extends n{constructor(V,ce,re){super(V,ce,V,re)}}e.$2H=t;var o;(function(q){q.List="list",q.Tree="tree"})(o||(e.ViewMode=o={}));var g;(function(q){q.Default="default",q.FileNames="fileNames",q.Type="type",q.Modified="modified",q.CountDescending="countDescending",q.CountAscending="countAscending"})(g||(e.SearchSortOrder=g={}));function u(q,V=!0){const ce=q&&q.files&&q.files.exclude,re=V&&q&&q.search&&q.search.exclude;if(!ce&&!re)return;if(!ce||!re)return ce||re;let fe=Object.create(null);return fe=h.$Im(fe,h.$Fm(ce)),fe=h.$Im(fe,h.$Fm(re),!0),fe}e.$3H=u;function d(q,V){return q.excludePattern&&F.$bj(q.excludePattern,V)?!1:q.includePattern||q.usingSearchPaths?q.includePattern&&F.$bj(q.includePattern,V)?!0:q.usingSearchPaths?!!q.folderQueries&&q.folderQueries.some(ce=>{const re=ce.folder.fsPath;if(L.$Je(V,re)){const fe=E.$cc(re,V);return!ce.includePattern||!!F.$bj(ce.includePattern,fe)}else return!1}):!1:!0}e.$4H=d;var v;(function(q){q[q.unknownEncoding=1]="unknownEncoding",q[q.regexParseError=2]="regexParseError",q[q.globParseError=3]="globParseError",q[q.invalidLiteral=4]="invalidLiteral",q[q.rgProcessError=5]="rgProcessError",q[q.other=6]="other",q[q.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class l extends Error{constructor(V,ce){super(V),this.code=ce}}e.$5H=l;function w(q){const V=q.message;if((0,b.$2)(q))return new l(V,v.canceled);try{const ce=JSON.parse(V);return new l(ce.message,ce.code)}catch{return new l(V,v.other)}}e.$6H=w;function P(q){const V={message:q.message,code:q.code};return new Error(JSON.stringify(V))}e.$7H=P;function M(q){return q.type==="error"?!0:q.type==="success"}e.$8H=M;function N(q){return q.type==="success"}e.$9H=N;function T(q){return!!q.path}e.$0H=T;function z(q,V){const ce=q.searchPath?q.searchPath:q.relativePath;return(0,A.$$d)(ce,V)}e.$$H=z;class j{constructor(V){this.path=V,this.results=[]}addMatch(V){this.results.push(V)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$_H=j;function U(q,V){const ce={...q||{},...V||{}};return Object.keys(ce).filter(re=>{const fe=ce[re];return typeof fe=="boolean"&&fe})}e.$aI=U;class Y{constructor(V,ce){this.c=null,this.a={...V.excludePattern||{},...ce.excludePattern||{}},this.b=F.$cj(this.a);let re=V.includePattern;ce.includePattern&&(re?re={...re,...ce.includePattern}:re=ce.includePattern),re&&(this.c=F.$cj(re))}matchesExcludesSync(V,ce,re){return!!(this.b&&this.b(V,ce,re))}includedInQuerySync(V,ce,re){return!(this.b&&this.b(V,ce,re)||this.c&&!this.c(V,ce,re))}includedInQuery(V,ce,re){const fe=this.b(V,ce,re),de=()=>this.c?!!this.c(V,ce,re):!0;return(0,I.$gg)(fe)?fe.then(B=>B?!1:de()):de()}hasSiblingExcludeClauses(){return H(this.a)}}e.$bI=Y;function H(q){for(const V in q)if(typeof q[V]!="boolean")return!0;return!1}function ge(q){if(!q)return;let V;return ce=>(V||(V=(q()||Promise.resolve([])).then(re=>re?te(re):{})),V.then(re=>!!re[ce]))}e.$cI=ge;function ie(q){if(!q)return;let V;return ce=>{if(!V){const re=q();V=re?te(re):{}}return!!V[ce]}}e.$dI=ie;function te(q){const V={};for(const ce of q)V[ce]=!0;return V}}),define(De[37],Ce([1,0,19,17,21,3,4,71,15,112,24,12,14,2,204,5,18,232,50,51,26,20,16,7,58,35,6]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y,C,i,a,n,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X$b=e.$W$b=void 0;function g(N,T,z){return new R.$Wf(j=>l(j,z)).isEqual(N,T)}function u(N,T,z){return g(N.uri,T.uri,z)?0:(0,I.$Ed)(N.uri.toString(),T.uri.toString())}function d(N,T,z){return N.index!==T.index?N.index<T.index?-1:1:g(N.uri,T.uri,z)?(0,I.$Ed)(N.name,T.name):(0,I.$Ed)(N.uri.toString(),T.uri.toString())}function v(N,T,z,j){const U=N.slice(0).sort((H,ge)=>z(H,ge,j)),Y=T.slice(0).sort((H,ge)=>z(H,ge,j));return(0,k.$if)(U,Y,(H,ge)=>z(H,ge,j))}function l(N,T){const z=T.getCapabilities(N.scheme);return!(z&&z&1024)}class w extends c.$Gh{static toExtHostWorkspace(T,z,j,U){if(!T)return{workspace:null,added:[],removed:[]};const{id:Y,name:H,folders:ge,configuration:ie,transient:te,isUntitled:q}=T,V=[],ce=z;z?ge.forEach((B,_)=>{const Ee=S.URI.revive(B.uri),Re=w.o(j||z,Ee,U);Re?(Re.name=B.name,Re.index=B.index,V.push(Re)):V.push({uri:Ee,name:B.name,index:_})}):V.push(...ge.map(({uri:B,name:_,index:Ee})=>({uri:S.URI.revive(B),name:_,index:Ee}))),V.sort((B,_)=>B.index<_.index?-1:1);const re=new w(Y,H,V,!!te,ie?S.URI.revive(ie):null,!!q,B=>l(B,U)),{added:fe,removed:de}=v(ce?ce.workspaceFolders:[],re.workspaceFolders,u,U);return{workspace:re,added:fe,removed:de}}static o(T,z,j){for(let U=0;U<T.folders.length;U++){const Y=T.workspaceFolders[U];if(g(Y.uri,z,j))return Y}}constructor(T,z,j,U,Y,H,ge){super(T,j.map(ie=>new c.$Hh(ie)),U,Y,ge),this.t=z,this.u=H,this.q=[],this.s=m.$th.forUris(ge),j.forEach(ie=>{this.q.push(ie),this.s.set(ie.uri,ie)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,z){return z&&this.s.get(T)&&(T=(0,R.$7f)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let P=class{constructor(T,z,j,U,Y){this.c=new L.$7c,this.onDidChangeWorkspace=this.c.event,this.g=new L.$7c,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.$9c,this.B=new Map,this.h=U,this.s=j,this.t=Y,this.j=new b.$tl,this.k=new F.$sg,this.o=T.getProxy(o.$xJ.MainThreadWorkspace),this.q=T.getProxy(o.$xJ.MainThreadMessageService);const H=z.workspace;this.l=H?new w(H.id,H.name,[],!!H.transient,H.configuration?S.URI.revive(H.configuration):null,!!H.isUntitled,ge=>l(ge,j)):void 0}$initializeWorkspace(T,z){this.v=z,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?S.URI.from({scheme:E.Schemas.untitled,path:(0,R.$5f)((0,R.$7f)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,z,j,...U){const Y=[];if(Array.isArray(U)&&U.forEach(q=>{S.URI.isUri(q.uri)&&!Y.some(V=>g(V.uri,q.uri,this.s))&&Y.push({uri:q.uri,name:q.name||(0,R.$4f)(q.uri)})}),this.n||[z,j].some(q=>typeof q!="number"||q<0)||j===0&&Y.length===0)return!1;const H=this.x?this.x.workspaceFolders:[];if(z+j>H.length)return!1;const ge=H.slice(0);ge.splice(z,j,...Y.map(q=>({uri:q.uri,name:q.name||(0,R.$4f)(q.uri),index:void 0})));for(let q=0;q<ge.length;q++){const V=ge[q];if(ge.some((ce,re)=>re!==q&&g(V.uri,ce.uri,this.s)))return!1}ge.forEach((q,V)=>q.index=V);const{added:ie,removed:te}=v(H,ge,d,this.s);if(ie.length===0&&te.length===0)return!1;if(this.o){const q=T.displayName||T.name;this.o.$updateWorkspaceFolders(q,z,j,Y).then(void 0,V=>{this.n=void 0;const ce={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(s.Severity.Error,(0,D.localize)(0,null,q,V.toString()),ce,[])})}return this.y(ge),!0}getWorkspaceFolder(T,z){if(this.x)return this.x.getWorkspaceFolder(T,z)}async getWorkspaceFolder2(T,z){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,z)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,z){let j,U="";if(typeof T=="string"?(j=S.URI.file(T),U=T):typeof T<"u"&&(j=T,U=T.fsPath),!j)return U;const Y=this.getWorkspaceFolder(j,!0);if(!Y)return U;typeof z>"u"&&this.x&&(z=this.x.folders.length>1);let H=(0,R.$0f)(Y.uri,j);return z&&Y.name&&(H=`${Y.name}/${H}`),H}y(T){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:z,added:j,removed:U}=w.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=z||void 0,this.n=void 0,this.c.fire(Object.freeze({added:j,removed:U}))}findFiles(T,z,j,U,Y=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${U.value}, entryPoint: findFiles`);let H;if(z===null?H=!1:z&&(typeof z=="string"?H=z:H=z.pattern),Y&&Y.isCancellationRequested)return Promise.resolve([]);const{includePattern:ge,folder:ie}=M(i.GlobPattern.from(T));return this.o.$startFileSearch((0,$.$Be)(ge),(0,$.$Be)(ie),(0,$.$Be)(H),(0,$.$Be)(j),Y).then(te=>Array.isArray(te)?te.map(q=>S.URI.revive(q)):[])}async findTextInFiles(T,z,j,U,Y=h.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${U.value}, entryPoint: findTextInFiles`);const H=this.j.getNext(),ge=typeof z.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:ie,folder:te}=M(i.GlobPattern.from(z.include)),q=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,V={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof z.useParentIgnoreFiles=="boolean"?!z.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:ge,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:ie,excludePattern:q},ce=!1;if(this.u[H]=re=>{if(ce)return;const fe=S.URI.revive(re.resource);re.results.forEach(de=>{(0,t.$VH)(de)?j({uri:fe,preview:{text:de.preview.text,matches:(0,k.$Hf)(de.preview.matches,B=>new a.$BJ(B.startLineNumber,B.startColumn,B.endLineNumber,B.endColumn))},ranges:(0,k.$Hf)(de.ranges,B=>new a.$BJ(B.startLineNumber,B.startColumn,B.endLineNumber,B.endColumn))}):j({uri:fe,text:de.text,lineNumber:de.lineNumber})})},Y.isCancellationRequested)return{};try{const re=await this.o.$startTextSearch(T,(0,$.$Be)(te),V,H,Y);return delete this.u[H],re||{}}catch(re){throw delete this.u[H],re}}$handleTextSearchResult(T,z){this.u[z]?.(T)}async save(T){const z=await this.o.$save(T,{saveAs:!1});return S.URI.revive(z)}async saveAs(T){const z=await this.o.$save(T,{saveAs:!0});return S.URI.revive(z)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,z){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,z);const j=this.t.transformOutgoingScheme(T),U=this.z++;return this.o.$registerEditSessionIdentityProvider(U,j),(0,A.$jb)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(U)})}async $getEditSessionIdentifier(T,z){this.h.info("Getting edit session identifier for workspaceFolder",T);const j=await this.resolveWorkspaceFolder(S.URI.revive(T));if(!j){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",j);const U=this.w.get(j.uri.scheme);if(this.h.info(`Provider for scheme ${j.uri.scheme} is defined: `,!!U),!U)return;const Y=await U.provideEditSessionIdentity(j,z);if(this.h.info("Provider returned edit session identifier: ",Y),!!Y)return Y}async $provideEditSessionIdentityMatch(T,z,j,U){this.h.info("Getting edit session identifier for workspaceFolder",T);const Y=await this.resolveWorkspaceFolder(S.URI.revive(T));if(!Y){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",Y);const H=this.w.get(Y.uri.scheme);if(this.h.info(`Provider for scheme ${Y.uri.scheme} is defined: `,!!H),!H)return;const ge=await H.provideEditSessionIdentityMatch?.(z,j,U);if(this.h.info("Provider returned edit session identifier match result: ",ge),!!ge)return ge}getOnWillCreateEditSessionIdentityEvent(T){return(z,j,U)=>{const Y=function(ge){z.call(j,ge)};return Y.extension=T,this.A.event(Y,void 0,U)}}async $onWillCreateEditSessionIdentity(T,z,j){const U=await this.resolveWorkspaceFolder(S.URI.revive(T));if(U===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:U},z,async(Y,H)=>{const ge=Date.now();await Promise.resolve(Y),Date.now()-ge>j&&this.h.warn("SLOW edit session create-participant",H.extension.identifier)}),z.isCancellationRequested}registerCanonicalUriProvider(T,z){if(this.B.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.B.set(T,z);const j=this.t.transformOutgoingScheme(T),U=this.z++;return this.o.$registerCanonicalUriProvider(U,j),(0,A.$jb)(()=>{this.B.delete(T),this.o.$unregisterCanonicalUriProvider(U)})}async provideCanonicalUri(T,z,j){const U=this.B.get(T.scheme);if(!U)return;const Y=await U.provideCanonicalUri?.(S.URI.revive(T),z,j);if(Y)return Y}async $provideCanonicalUri(T,z,j){return this.provideCanonicalUri(S.URI.revive(T),{targetScheme:z},j)}};e.$W$b=P,e.$W$b=P=Je([qe(0,C.$zL),qe(1,y.$PL),qe(2,f.$K$b),qe(3,r.$Pi),qe(4,n.$U$b)],P),e.$X$b=(0,p.$nh)("IExtHostWorkspace");function M(N){let T,z;return N&&(typeof N=="string"?T=N:(T=N.pattern,z=S.URI.revive(N.baseUri))),{includePattern:T,folder:z}}}),define(De[38],Ce([1,0,23,3,37,6,7,235,129,14,17,5,20,18,2]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=e.$Z$b=e.$Y$b=void 0;function p(a,n){if(n){const t=n.split(".");let o=a;for(let g=0;o&&g<t.length;g++)o=o[t[g]];return o}}function r(a){return a instanceof D.URI}function s(a){return a&&a.uri instanceof D.URI&&a.languageId&&typeof a.languageId=="string"}function c(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function f(a){return a&&a.uri instanceof D.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function y(a){if(r(a))return{resource:a};if(s(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(c(a))return{overrideIdentifier:a.languageId};if(f(a))return{resource:a.uri};if(a===null)return{resource:null}}let C=class{constructor(n,t,o){this.a=n.getProxy(L.$xJ.MainThreadConfiguration),this.c=t,this.b=o,this.d=new R.$sg,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new i(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,t){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(n,t))}};e.$Y$b=C,e.$Y$b=C=Je([qe(0,$.$zL),qe(1,h.$X$b),qe(2,S.$Pi)],C);class i{constructor(n,t,o,g){this.a=new F.$7c,this.b=n,this.f=g,this.c=t,this.e=m.$dn.parse(o),this.d=this.k(o.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,t){const o={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$dn.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(t,o))}getConfiguration(n,t,o){const g=y(t)||{},u=this.g(n?p(this.e.getValue(void 0,g,this.c.workspace),n):this.e.getValue(void 0,g,this.c.workspace));n&&this.h(n,g,o?.identifier);function d(l){if(l==null)return null;if(typeof l=="boolean")return l?2:5;switch(l){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(l){return typeof p(u,l)<"u"},get:(l,w)=>{this.h(n?`${n}.${l}`:l,g,o?.identifier);let P=p(u,l);if(typeof P>"u")P=w;else{let M;const N=(T,z)=>{if((0,b.$ke)(T)){let j;const U=()=>{M=M||(0,k.$Fm)(u),j=j||p(M,z)};return new Proxy(T,{get:(Y,H)=>{if(typeof H=="string"&&H.toLowerCase()==="tojson")return U(),()=>j;if(M)return j=j||p(M,z),j[H];const ge=Y[H];return typeof H=="string"?N(ge,`${z}.${H}`):ge},set:(Y,H,ge)=>(U(),j&&(j[H]=ge),!0),deleteProperty:(Y,H)=>(U(),j&&delete j[H],!0),defineProperty:(Y,H,ge)=>(U(),j&&Object.defineProperty(j,H,ge),!0)})}return Array.isArray(T)?(0,k.$Fm)(T):T};P=N(P,l)}return P},update:(l,w,P,M)=>{l=n?`${n}.${l}`:l;const N=d(P);return w!==void 0?this.b.$updateConfigurationOption(N,l,w,g,M):this.b.$removeConfigurationOption(N,l,g,M)},inspect:l=>{l=n?`${n}.${l}`:l;const w=this.e.inspect(l,g,this.c.workspace);if(w)return{key:l,defaultValue:(0,k.$Fm)(w.policy?.value??w.default?.value),globalValue:(0,k.$Fm)(w.user?.value??w.application?.value),workspaceValue:(0,k.$Fm)(w.workspace?.value),workspaceFolderValue:(0,k.$Fm)(w.workspaceFolder?.value),defaultLanguageValue:(0,k.$Fm)(w.default?.override),globalLanguageValue:(0,k.$Fm)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,k.$Fm)(w.workspace?.override),workspaceFolderLanguageValue:(0,k.$Fm)(w.workspaceFolder?.override),languageIds:(0,k.$Fm)(w.overrideIdentifiers)}}};return typeof u=="object"&&(0,k.$Im)(v,u,!1),Object.freeze(v)}g(n){const t=o=>(0,b.$ke)(o)?new Proxy(o,{get:(g,u)=>t(g[u]),set:(g,u,d)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(g,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(g,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:g=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return t(n)}h(n,t,o){const g=E.$7m.test(n)?4:this.d.get(n),u=o?`[${o.value}] `:"";if(g===4){typeof t?.resource>"u"&&this.f.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(g===3){t?.resource&&this.f.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,t){const o=new m.$fn(n,t,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(g,u)=>o.affectsConfiguration(g,y(u))})}k(n){return n.reduce((t,o)=>(t.set(o[0],o[1]),t),new Map)}}e.$Z$b=i,e.$1$b=(0,I.$nh)("IExtHostConfiguration")}),define(De[88],Ce([1,0,2,17,3,6,7,37,61,38,21,43,20,26,5,15,11,18,84,277,8]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=e.$X_b=e.$W_b=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var C;(function(N){function T(j){if(j!=null)return j}N.from=T;function z(j){if(j!=null)return j}N.to=z})(C||(C={}));var i;(function(N){function T(j){if(j!=null)return j}N.from=T;function z(j){if(j!=null)return j}N.to=z})(i||(i={}));var a;(function(N){function T(j){if(j!=null)return j}N.from=T;function z(j){if(j!=null)return j}N.to=z})(a||(a={}));var n;(function(N){function T(U){if(U){const Y=U;return Y&&!!Y.process}else return!1}N.is=T;function z(U){if(U==null)return;const Y={process:U.process,args:U.args};return U.options&&(Y.options=a.from(U.options)),Y}N.from=z;function j(U){if(U!=null)return new A.$iK(U.process,U.args,U.options)}N.to=j})(n||(n={}));var t;(function(N){function T(j){if(j!=null)return j}N.from=T;function z(j){if(j!=null)return j}N.to=z})(t||(t={}));var o;(function(N){function T(U){if(U){const Y=U;return Y&&(!!Y.commandLine||!!Y.command)}else return!1}N.is=T;function z(U){if(U==null)return;const Y={};return U.commandLine!==void 0?Y.commandLine=U.commandLine:(Y.command=U.command,Y.args=U.args),U.options&&(Y.options=t.from(U.options)),Y}N.from=z;function j(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new A.$jK(U.commandLine,U.options):new A.$jK(U.command,U.args?U.args:[],U.options)}N.to=j})(o||(o={}));var g;(function(N){function T(U){if(U){const Y=U;return Y&&Y.customExecution==="customExecution"}else return!1}N.is=T;function z(U){return{customExecution:"customExecution"}}N.from=z;function j(U,Y){return Y.get(U)}N.to=j})(g||(e.CustomExecutionDTO=g={}));var u;(function(N){function T(z,j){let U;return z.scope!==void 0&&typeof z.scope!="number"?U=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&j&&j.workspaceFile?U=j.workspaceFile:U=f.$RF),{id:z._id,workspaceFolder:U}}N.from=T})(u||(e.TaskHandleDTO=u={}));var d;(function(N){function T(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}N.from=T})(d||(d={}));var v;(function(N){function T(U,Y){if(U==null)return[];const H=[];for(const ge of U){const ie=z(ge,Y);ie&&H.push(ie)}return H}N.fromMany=T;function z(U,Y){if(U==null)return;let H;U.execution instanceof A.$iK?H=n.from(U.execution):U.execution instanceof A.$jK?H=o.from(U.execution):U.execution&&U.execution instanceof A.$kK&&(H=g.from(U.execution));const ge=C.from(U.definition);let ie;return U.scope?typeof U.scope=="number"?ie=U.scope:ie=U.scope.uri:ie=A.TaskScope.Workspace,!ge||!ie?void 0:{_id:U._id,definition:ge,name:U.name,source:{extensionId:Y.identifier.value,label:U.source,scope:ie},execution:H,isBackground:U.isBackground,group:d.from(U.group),presentationOptions:i.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}N.from=z;async function j(U,Y,H){if(U==null)return;let ge;n.is(U.execution)?ge=n.to(U.execution):o.is(U.execution)?ge=o.to(U.execution):g.is(U.execution)&&(ge=g.to(U._id,H));const ie=C.to(U.definition);let te;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?te=U.source.scope:te=await Y.resolveWorkspaceFolder(k.URI.revive(U.source.scope)):te=A.TaskScope.Workspace),!ie||!te)return;const q=new A.$lK(ie,te,U.name,U.source.label,ge,U.problemMatchers);return U.isBackground!==void 0&&(q.isBackground=U.isBackground),U.group!==void 0&&(q.group=A.$hK.from(U.group._id),q.group&&U.group.isDefault&&(q.group=new A.$hK(q.group.id,q.group.label),U.group.isDefault===!0&&(q.group.isDefault=U.group.isDefault))),U.presentationOptions&&(q.presentationOptions=i.to(U.presentationOptions)),U._id&&(q._id=U._id),U.detail&&(q.detail=U.detail),q}N.to=j})(v||(e.TaskDTO=v={}));var l;(function(N){function T(j){return j}N.from=T;function z(j){if(j)return Object.assign(Object.create(null),j)}N.to=z})(l||(l={}));class w{#e;constructor(T,z,j){this._id=z,this.a=j,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let P=class{constructor(T,z,j,U,Y,H,ge,ie){this.q=new h.$7c,this.r=new h.$7c,this.s=new h.$7c,this.t=new h.$7c,this.a=T.getProxy(L.$xJ.MainThreadTask),this.b=j,this.c=U,this.d=Y,this.e=H,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ge,this.g=ie,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,z,j){if(!j)return new A.$zJ(()=>{});const U=this.w();return this.j.set(U,{type:z,provider:j,extension:T}),this.a.$registerTaskProvider(U,z),new A.$zJ(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem(T,z){this.a.$registerTaskSystem(T,z)}fetchTasks(T){return this.a.$fetchTasks(l.from(T)).then(async z=>{const j=[];for(const U of z){const Y=await v.to(U,this.b,this.m);Y&&j.push(Y)}return j})}get taskExecutions(){const T=[];return this.k.forEach(z=>T.push(z)),T}terminateTask(T){if(!(T instanceof w))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,z,j){const U=this.m.get(T.id);U&&(this.o.set(T.id,U),this.e.attachPtyToTerminal(z,await U.callback(j))),this.p=T.id,this.q.fire({execution:await this.y(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){const z=await this.y(T);this.l.delete(T.id),this.k.delete(T.id),this.A(T),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const z=await this.y(T.id);this.s.fire({execution:z,processId:T.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(T){const z=await this.y(T.id);this.t.fire({execution:z,exitCode:T.exitCode})}$provideTasks(T,z){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));const U=[],Y=(0,F.$mg)(()=>j.provider.provideTasks(R.CancellationToken.None)).then(H=>this.u(z,U,j,H));return new Promise(H=>{Y.then(ge=>{Promise.all(U).then(()=>{H(ge)})})})}async $resolveTask(T,z){const j=this.j.get(T);if(!j)return Promise.reject(new Error("no handler found"));if(z.definition.type!==j.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${j.type}].`);const U=await v.to(z,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const Y=await j.provider.resolveTask(U,R.CancellationToken.None);if(!Y)return;this.z(Y,j);const H=v.from(Y,j.extension);if(!H)throw new Error("Unexpected: Task cannot be resolved.");if(Y.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return g.is(H.execution)&&await this.x(H,Y,!0),await this.v(H)}w(){return this.h++}async x(T,z,j){const U=await this.a.$createTaskId(T);!j&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,z.execution)),this.m.set(U,z.execution)}async y(T,z){if(typeof T=="string"){const Y=this.l.get(T);if(!Y)throw new y.$ab("Unexpected: The specified task is missing an execution");return Y}const j=this.l.get(T.id);if(j)return j;const U=new Promise((Y,H)=>{function ge(ie,te,q){q?Y(new w(ie,te.id,q)):H("Unexpected: Task does not exist.")}z?ge(this,T,z):v.to(T.task,this.b,this.m).then(ie=>ge(this,T,ie))});return this.l.set(T.id,U),U.then(Y=>(this.k.set(T.id,Y),Y),Y=>Promise.reject(Y))}z(T,z){T._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const j=this.n.values();let U=j.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=j.next()}};e.$W_b=P,e.$W_b=P=Je([qe(0,$.$zL),qe(1,S.$PL),qe(2,m.$X$b),qe(3,E.$KL),qe(4,b.$1$b),qe(5,I.$g_b),qe(6,s.$Pi),qe(7,c.$N$b)],P);let M=class extends P{constructor(T,z,j,U,Y,H,ge,ie){super(T,z,j,U,Y,H,ge,ie),this.registerTaskSystem(p.Schemas.vscodeRemote,{scheme:p.Schemas.vscodeRemote,authority:"",platform:r.$h(0)})}async executeTask(T,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const j=v.from(z,T);if(j===void 0)throw new Error("Task is not valid");if(g.is(j.execution))await this.x(j,z,!1);else throw new y.$$;const U=await this.y(await this.a.$getTaskExecution(j),z);return this.a.$executeTask(j).catch(Y=>{throw new Error(Y)}),U}u(T,z,j,U){const Y=[];if(U)for(const H of U){this.z(H,j),(!H.definition||!T[H.definition.type])&&this.f.warn(`The task [${H.source}, ${H.name}] uses an undefined task type. The task will be ignored in the future.`);const ge=v.from(H,j.extension);ge&&g.is(ge.execution)?(Y.push(ge),z.push(this.x(ge,H,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:Y,extension:j.extension}}async v(T){if(g.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,z,j){}};e.$X_b=M,e.$X_b=M=Je([qe(0,$.$zL),qe(1,S.$PL),qe(2,m.$X$b),qe(3,E.$KL),qe(4,b.$1$b),qe(5,I.$g_b),qe(6,s.$Pi),qe(7,c.$N$b)],M),e.$Y_b=(0,D.$nh)("IExtHostTask")}),define(De[328],Ce([1,0,13,21,45,34,24,39,35]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9_b=void 0;class b{constructor($,S,D){this.k=$,this.l=S,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=$.filePattern,this.b=$.includePattern&&L.$cj($.includePattern),this.c=$.maxResults||void 0,this.d=$.exists,this.h=new Set,this.j=$.excludePattern&&L.$cj($.excludePattern)}cancel(){this.g=!0,this.h.forEach($=>$.cancel()),this.h=new Set}search($){const S=this.k.folderQueries||[];return new Promise((D,p)=>{const r=s=>{this.f++,$(s)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const c=s.toString(),f=k.$ec(c);this.j&&this.j(c,f)||this.v(r,{base:s,basename:f})}),Promise.all(S.map(s=>this.p(s,r))).then(s=>{D({limitHit:this.e,stats:s[0]||void 0})},s=>{p(new Error((0,h.$$h)(s)))})})}async p($,S){const D=new F.$dd,p=this.q($),r=this.r(),s=new E.$bI(this.k,$),c=!s.hasSiblingExcludeClauses();let f;try{this.h.add(D),f=m.$3c.create();const y=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},p,D.token),C=f.elapsed(),i=m.$3c.create();return this.g&&!this.e||(y&&y.forEach(a=>{const n=k.$0b.relative($.folder.path,a.path);if(c){const t=k.$ec(a.path);this.v(S,{base:$.folder,relativePath:n,basename:t});return}this.s(r,$.folder,n,S)}),this.g&&!this.e)?null:(this.u(r,s,S),{providerTime:C,postProcessTime:i.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q($){const S=(0,E.$aI)(this.k.includePattern,$.includePattern),D=(0,E.$aI)(this.k.excludePattern,$.excludePattern);return{folder:$.folder,excludes:D,includes:S,useIgnoreFiles:!$.disregardIgnoreFiles,useGlobalIgnoreFiles:!$.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!$.disregardParentIgnoreFiles,followSymlinks:!$.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const $={rootEntries:[],pathToEntries:Object.create(null)};return $.pathToEntries["."]=$.rootEntries,$}s({pathToEntries:$},S,D,p){if(D===this.a){const s=k.$ec(this.a);this.v(p,{base:S,relativePath:this.a,basename:s})}function r(s){const c=k.$ec(s),f=k.$dc(s);let y=$[f];y||(y=$[f]=[],r(f)),y.push({base:S,relativePath:s,basename:c})}r(D)}u({rootEntries:$,pathToEntries:S},D,p){const r=this,s=this.a;function c(f){const y=(0,E.$dI)(()=>f.map(C=>C.basename));for(let C=0,i=f.length;C<i;C++){const a=f[C],{relativePath:n,basename:t}=a;if(D.matchesExcludesSync(n,t,s!==t?y:void 0))continue;const o=S[n];if(o)c(o);else{if(n===s)continue;r.v(p,a)}if(r.e)break}}c($)}v($,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||$(S))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch($,S,D,p){const r=this.c($.cacheKey),s=new b($,S,r&&r.token);let c=0;const f=y=>{c+=y.length,D(y.map(C=>this.d(C)))};return this.e(s,R.a,f,p).then(y=>({limitHit:y.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:c,detailStats:y.stats}}))}clearCache($){this.c($)?.cancel()}c($){if($)return this.b.has($)||this.b.set($,new F.$dd),this.b.get($)}d($){return $.relativePath?{resource:A.$8f($.base,$.relativePath)}:{resource:$.base}}e($,S,D,p){p.onCancellationRequested(()=>{$.cancel()});const r=c=>{c&&(s.push(c),S>0&&s.length>=S&&(D(s),s=[]))};let s=[];return $.search(r).then(c=>(s.length&&D(s),c),c=>(s.length&&D(s),Promise.reject(c)))}}e.$9_b=R}),define(De[329],Ce([1,0,19,65,34,120,28,15,13,24,12,14,2,165,215,57,18,50,137,327,35]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cJ=e.$bJ=void 0;let C=class{constructor(l,w,P,M,N){this.a=l,this.b=w,this.c=P,this.d=M,this.e=N}text(l,w,P={}){l=this.f(l,P);const M=this.a.getValue(),N=w&&w.some(z=>!this.a.getValue({resource:z}).search.useRipgrep);return{...this.h(w?.map(s.$Ih),P),type:2,contentPattern:l,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:M.search.usePCRE2||N||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(l,w){const P=this.a.getValue();l.isRegExp&&(l.pattern=l.pattern.replace(/\r?\n/g,"\\n"));const M={...l,wordSeparators:P.editor.wordSeparators};return this.j(l,w)&&(M.isCaseSensitive=!0),this.k(l)&&(M.isMultiline=!0),w.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=w.notebookSearchConfig.includeMarkupInput),w.notebookSearchConfig?.includeMarkupPreview&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownPreview=w.notebookSearchConfig.includeMarkupPreview),w.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=w.notebookSearchConfig.includeCodeInput),w.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=w.notebookSearchConfig.includeOutput),M}file(l,w={}){return{...this.h(l,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(l,w){return l?(l=Array.isArray(l)?l.map(o):o(l),w?this.parseSearchPaths(l):{pattern:a(...Array.isArray(l)?l:[l])}):{}}h(l=[],w={}){const P=this.g(w.includePattern,w.expandPatterns),M=this.g(w.excludePattern,w.expandPatterns),N=l.length>1,T=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(U=>this.q(U,w,M)):l.map(U=>this.r(U,w,M,N))).filter(U=>!!U),z={_reason:w._reason,folderQueries:T,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:M.pattern,includePattern:P.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const U=k.$lf(k.$xf(this.c.groups.map(ge=>ge.editors.map(ie=>ie.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(U));const Y=U.filter(ge=>(0,y.$4H)(z,ge.fsPath)),H=this.i(Y);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(H)),{...z,...H}}const j=w.extraFileResources&&w.extraFileResources.filter(U=>(0,y.$4H)(z,U.fsPath));return z.extraFileResources=j&&j.length?j:void 0,z}i(l){const w=[],P=new A.$li,M={};let N=!1;return l.forEach(T=>{if(T.scheme===m.Schemas.walkThrough)return;if((0,b.$_f)(T)){const j=this.b.getWorkspaceFolder(T)?.uri??T.with({path:E.$dc(T.fsPath)});let U=P.get(j);U||(N=!0,U={folder:j,includePattern:{}},w.push(U),P.set(j,U));const Y=E.$cc(j.fsPath,T.fsPath);(0,I.$te)(U.includePattern)[Y.replace(/\\/g,"/")]=!0}else T.fsPath&&(N=!0,M[T.fsPath]=!0)}),{folderQueries:w,includePattern:M,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}j(l,w){if(w.isSmartCase){if(l.isRegExp){if(R.$_d(l.pattern,!0))return!0}else if(R.$_d(l.pattern))return!0}return!!l.isCaseSensitive}k(l){return l.isMultiline||l.isRegExp&&(0,S.$2B)(l.pattern)||l.pattern.indexOf(`
`)>=0?!0:!!l.isMultiline}parseSearchPaths(l){const w=H=>E.$_b(H)||/^\.\.?([\/\\]|$)/.test(H),M=(Array.isArray(l)?l:n(l)).map(H=>{const ge=this.e.resolvedUserHome;return ge?(0,L.$1z)(H,ge.scheme===m.Schemas.file?ge.fsPath:ge.path):H}),N=F.$I(M,H=>w(H)?"searchPaths":"exprSegments"),T=(N.exprSegments||[]).map(H=>R.$sd(H,"/")).map(H=>R.$sd(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),t(H))),z={},j=this.m(N.searchPaths||[]);j&&j.length&&(z.searchPaths=j);const U=k.$xf(T),Y=a(...U);return Y&&(z.pattern=Y),z}l(l,w){return w.disregardExcludeSettings?void 0:(0,y.$3H)(l,!w.disregardSearchExcludeSettings)}m(l){if(!l||!l.length)return[];const w=l.flatMap(M=>{let{pathPortion:N,globPortion:T}=i(M);return T&&(T=g(T)),this.n(N).flatMap(j=>this.o(j,T))}),P=new Map;return w.forEach(M=>{const N=M.searchPath.toString(),T=P.get(N);T?M.pattern&&(T.pattern=T.pattern||{},T.pattern[M.pattern]=!0):P.set(N,{searchPath:M.searchPath,pattern:M.pattern?a(M.pattern):void 0})}),Array.from(P.values())}n(l){if(E.$_b(l)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==m.Schemas.file?[{searchPath:w[0].uri.with({path:l})}]:[{searchPath:$.URI.file(E.$$b(l))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(l=o(l),l.startsWith("../")||l===".."){const M=E.$0b.resolve(w.path,l);return[{searchPath:w.with({path:M})}]}const P=g(l);return[{searchPath:w,pattern:P}]}else{if(l==="./"||l===".\\")return[];{const w=l.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(N=>{const T=w.match(new RegExp(`^${R.$nd(N.name)}(?:/(.*)|$)`));return T?{match:T,folder:N}:null}).filter(I.$qe);if(M.length)return M.map(N=>{const T=N.match[1];return{searchPath:N.folder.uri,pattern:T&&g(T)}});{const N=l.match(/\.[\/\\](.+)[\/\\]?/),T=N?N[1]:l,z=D.localize(0,null,T);throw new Error(z)}}}}o(l,w){const P=l.pattern&&w?`${l.pattern}/${w}`:l.pattern||w,M=[{searchPath:l.searchPath,pattern:P}];return P&&!P.endsWith("**")&&M.push({searchPath:l.searchPath,pattern:P+"/**"}),M}q(l,w,P){const M=this.r((0,s.$Ih)(l.searchPath),w,P,!1);return M?{...M,includePattern:l.pattern}:null}r(l,w,P,M){let N;const T=$.URI.isUri(l)?l:l.uri;if(P.searchPaths){const H=P.searchPaths.filter(ge=>(0,b.$1f)(ge.searchPath,T))[0];if(H&&!H.pattern)return null;H&&(N=H.pattern)}const z=this.a.getValue({resource:T}),U={...this.l(z,w)||{},...N||{}},Y=$.URI.isUri(l)?(0,b.$5f)(l):l.name;return{folder:T,folderName:M?Y:void 0,excludePattern:Object.keys(U).length>0?U:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!z.search.followSymlinks}}};e.$bJ=C,e.$bJ=C=Je([qe(0,p.$Th),qe(1,s.$wh),qe(2,c.$MC),qe(3,r.$Pi),qe(4,f.$_I)],C);function i(v){const l=v.match(/[\*\{\}\(\)\[\]\?]/);if(l){const w=l.index,P=v.substr(0,w).match(/[/|\\][^/\\]*$/);if(P){let M=v.substr(0,P.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:v.substr((P.index||0)+1)}}}return{pathPortion:v}}function a(...v){return v.length?v.reduce((l,w)=>(l[w]=!0,l),Object.create(null)):void 0}function n(v){return h.$aj(v,",").map(l=>l.trim()).filter(l=>!!l.length)}function t(v){return[`**/${v}/**`,`**/${v}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function o(v){return v.replace(/\\/g,"/")}function g(v){return o(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(v){return v.replace(/([?*[\]])/g,"[$1]")}function d(v,l){v=k.$qf(v,M=>M.toString());const w=[],P=l.getWorkspace();return v&&v.forEach(M=>{let N;if(l.getWorkbenchState()===2)N=(0,b.$0f)(P.folders[0].uri,M),N&&N!=="."&&(N="./"+N);else{const T=l.getWorkspaceFolder(M);if(T){const z=T.name;if(P.folders.filter(U=>U.name===z).length===1){const U=(0,b.$0f)(T.uri,M);U===""?N=`./${T.name}`:N=`./${T.name}/${U}`}else N=M.fsPath}}N&&w.push(u(N))}),w}e.$cJ=d}),define(De[330],Ce([1,0,24,2,21,8,5,329,35,50]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjb=e.$Ojb=void 0;const R=7e3;function I(p,r){const s=r.activationEvents;if(!s)return Promise.resolve(void 0);const c=[],f=[];for(const t of s)if(/^workspaceContains:/.test(t)){const o=t.substr(18);o.indexOf("*")>=0||o.indexOf("?")>=0||p.forceUsingSearch?f.push(o):c.push(o)}if(c.length===0&&f.length===0)return Promise.resolve(void 0);let y;const C=new Promise((t,o)=>{y=t}),i=t=>y({activationEvent:t}),a=Promise.all(c.map(t=>$(p,t,i))).then(()=>{}),n=S(p,r.identifier,f,i);return Promise.all([a,n]).then(()=>{y(void 0)}),C}e.$Ojb=I;async function $(p,r,s){for(const c of p.folders)if(await p.exists(k.$8f(F.URI.revive(c),r))){s(`workspaceContains:${r}`);return}}async function S(p,r,s,c){if(s.length===0)return Promise.resolve(void 0);const f=new h.$dd,y=p.checkExists(p.folders,s,f.token),C=setTimeout(async()=>{f.cancel(),p.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},R);let i=!1;try{i=await y}catch(a){L.$2(a)||L.$Y(a)}f.dispose(),clearTimeout(C),i&&c(`workspaceContains:${s.join(",")}`)}function D(p,r,s,c){const f=p.get(A.$mh),y=p.get(E.$UH),i=f.createInstance(m.$bJ).file(r.map(a=>(0,b.$Ih)(F.URI.revive(a))),{_reason:"checkExists",includePattern:s,exists:!0});return y.fileSearch(i,c).then(a=>!!a.limitHit,a=>L.$2(a)?!1:Promise.reject(a))}e.$Pjb=D}),define(De[44],Ce([1,0,194,13,89,24,17,4,71,2,18,6,38,272,109,37,27,141,8,25,22,247,7,130,5,26,85,20,99,64,43,3,330,108,249,15,106,39,11,107]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y,C,i,a,n,t,o,g,u,d,v,l,w,P,M,N,T,z,j,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=e.$u_b=e.$t_b=e.$s_b=e.$r_b=void 0,e.$r_b=(0,n.$nh)("IHostUtils");let Y=class Dn extends m.$lb{constructor(re,fe,de,B,_,Ee,Re,ne,ee,he,X,ue){super(),this.R=ue,this.a=this.B(new l.$7c),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=fe,this.g=de,this.f=Re,this.j=B,this.k=_,this.l=Ee,this.m=ee,this.p=he,this.s=X,this.t=this.g.getProxy(I.$xJ.MainThreadWorkspace),this.u=this.g.getProxy(I.$xJ.MainThreadTelemetry),this.v=this.g.getProxy(I.$xJ.MainThreadExtensionService),this.w=new A.$sg,this.y=new A.$sg,this.z=new A.$sg,this.C=new A.$sg,this.D=new V(this.f.activationEvents),this.G=new s.$l1b(this.D,this.f.allExtensions);const oe=new f.$Gl(this.f.myExtensions);this.F=new s.$l1b(this.D,te(this.G,oe)),this.H=new D.$$$b(this.g,this.l),this.I=new P.$k_b(this.g),this.J=ne,this.h=re.createChild(new u.$lh([D.$_$b,this.H],[P.$l_b,this.I])),this.L=this.B(new S.$0$b(this.F,this.G,{onExtensionActivationError:(le,we,O)=>{this.v.$onExtensionActivationError(le,c.$1(we),O)},actualActivateExtension:async(le,we)=>{if(s.$l1b.isHostExtension(le,this.F,this.G))return await this.v.$activateExtension(le,we),new S.$9$b;const O=this.F.getExtensionDescription(le);return this.$(O,we)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),h.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(re){c.$Y(re)}}async S(){this.J.onWillDeactivateAll();let re=[];try{re=this.F.getAllExtensionDescriptions().map(_=>_.identifier).filter(_=>this.isActivated(_)).map(_=>this.Z(_))}catch{}await Promise.all(re)}terminate(re,fe=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${re}`),this.l.flush(),this.p.dispose(),this.L.dispose(),c.setUnexpectedErrorHandler(B=>{this.l.error(B)}),this.g.dispose();const de=this.S();Promise.race([(0,A.$ug)(5e3),de]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${fe}`):this.l.info(`Extension host exiting with code ${fe}`),this.l.flush(),this.l.dispose(),this.c.exit(fe)})}isActivated(re){return this.z.isOpen()?this.L.isActivated(re):!1}async getExtension(re){const fe=await this.v.$getExtension(re);return fe&&{...fe,identifier:new f.$Fl(fe.identifier.value),extensionLocation:b.URI.revive(fe.extensionLocation)}}U(re,fe){return this.L.activateByEvent(re,fe)}W(re,fe){return this.L.activateById(re,fe)}activateByIdWithErrors(re,fe){return this.W(re,fe).then(()=>{const de=this.L.getActivatedExtension(re);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(re=>this.F)}getExtensionExports(re){if(this.z.isOpen())return this.L.getActivatedExtension(re).exports;try{return this.L.getActivatedExtension(re).exports}catch{return null}}async X(re){if(re.scheme===N.Schemas.file&&this.c.fsRealpath){const fe=await this.c.fsRealpath(re.fsPath);return b.URI.file(fe)}return re}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(re=>new q(re))),this.M}async Y(re){const fe=E.$th.forUris(de=>L.$Yf.ignorePathCasing(de));return await Promise.all(re.map(async de=>{if(this.qb(de)){const B=await this.X(de.extensionLocation);fe.set(B,de)}})),fe}Z(re){let fe=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(re))return fe;const de=this.L.getActivatedExtension(re);if(!de)return fe;try{typeof de.module.deactivate=="function"&&(fe=Promise.resolve(de.module.deactivate()).then(void 0,B=>(this.l.error(B),Promise.resolve(void 0))))}catch(B){this.l.error(`An error occurred when deactivating the extension '${re.value}':`),this.l.error(B)}try{(0,m.$gb)(de.subscriptions)}catch(B){this.l.error(`An error occurred when deactivating the subscriptions for extension '${re.value}':`),this.l.error(B)}return fe}async $(re,fe){return this.f.remote.isRemote?this.v.$onWillActivateExtension(re.identifier):await this.v.$onWillActivateExtension(re.identifier),this.bb(re,fe).then(de=>{const B=de.activationTimes;return this.v.$onDidActivateExtension(re.identifier,B.codeLoadingTime,B.activateCallTime,B.activateResolvedTime,fe),this.ab(re,fe,"success",B),de},de=>{throw this.ab(re,fe,"failure"),de})}ab(re,fe,de,B){const _=ge(re,fe);this.u.$publicLog2("extensionActivationTimes",{..._,...B||{},outcome:de})}bb(re,fe){const de=ge(re,fe);this.u.$publicLog2("activatePlugin",de);const B=this.qb(re);if(!B)return Promise.resolve(new S.$8$b(S.$5$b.NONE));this.l.info(`ExtensionService#_doActivateExtension ${re.identifier.value}, startup: ${fe.startup}, activationEvent: '${fe.activationEvent}'${re.identifier.value!==fe.extensionId.value?`, root cause: ${fe.extensionId.value}`:""}`),this.l.flush();const _=new S.$6$b(fe.startup);return Promise.all([this.rb(re,(0,L.$8f)(re.extensionLocation,B),_),this.cb(re)]).then(Ee=>(h.mark(`code/extHost/willActivateExtension/${re.identifier.value}`),Dn.db(this.l,re.identifier,Ee[0],Ee[1],_))).then(Ee=>(h.mark(`code/extHost/didActivateExtension/${re.identifier.value}`),Ee))}cb(re){const fe=new C.$b_b(re,this.H),de=new C.$a_b(re.identifier.value,!1,this.H),B=new M.$m_b(re,this.I),_=re.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ee=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${re.identifier.value}`),Promise.all([fe.whenReady,de.whenReady,this.J.whenReady]).then(()=>{const Re=this;let ne,ee;const he=(0,r.$vF)(re,"ipc")?this.f.messagePorts?.get(f.$Fl.toKey(re.identifier)):void 0;return Object.freeze({globalState:fe,workspaceState:de,secrets:B,subscriptions:[],get extensionUri(){return re.extensionLocation},get extensionPath(){return re.extensionLocation.fsPath},asAbsolutePath(X){return F.$ac(re.extensionLocation.fsPath,X)},get storagePath(){return Re.J.workspaceValue(re)?.fsPath},get globalStoragePath(){return Re.J.globalValue(re).fsPath},get logPath(){return F.$ac(Re.f.logsLocation.fsPath,re.identifier.value)},get logUri(){return b.URI.joinPath(Re.f.logsLocation,re.identifier.value)},get storageUri(){return Re.J.workspaceValue(re)},get globalStorageUri(){return Re.J.globalValue(re)},get extensionMode(){return _},get extension(){return ne===void 0&&(ne=new ie(Re,re.identifier,re,Ee,!1)),ne},get extensionRuntime(){return(0,r.$wF)(re,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(re)},get messagePassingProtocol(){if(!ee){if(!he)return;const X=l.Event.buffer(l.Event.fromDOMEventEmitter(he,"message",ue=>ue.data));he.start(),ee={onDidReceiveMessage:X,postMessage:he.postMessage.bind(he)}}return ee}})})}static db(re,fe,de,B,_){return de=de||{activate:void 0,deactivate:void 0},this.eb(re,fe,de,B,_).then(Ee=>new S.$7$b(!1,null,_.build(),de,Ee,B.subscriptions))}static eb(re,fe,de,B,_){if(typeof de.activate=="function")try{_.activateCallStart(),re.trace(`ExtensionService#_callActivateOptional ${fe.value}`);const Ee=typeof global=="object"?global:self,Re=de.activate.apply(Ee,[B]);return _.activateCallStop(),_.activateResolveStart(),Promise.resolve(Re).then(ne=>(_.activateResolveStop(),ne))}catch(Ee){return Promise.reject(Ee)}else return Promise.resolve(de)}fb(re,fe){this.W(re.identifier,{startup:!1,extensionId:re.identifier,activationEvent:fe}).then(void 0,de=>{this.l.error(de)})}gb(re,fe=0){const B=Date.now();(0,j.$A)(()=>{for(let _=fe;_<re.length;_+=1){const Ee=re[_];for(const Re of Ee.activationEvents??[])if(Re==="onStartupFinished")if(Date.now()-B>50){this.gb(re,_);break}else this.fb(Ee,Re)}})}hb(){this.v.$setPerformanceMarks(h.getMarks()),this.k.getConfigProvider().then(re=>{const fe=re.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),de=this.F.getAllExtensionDescriptions();if(fe)this.gb(de);else for(const B of de)if(B.activationEvents)for(const _ of B.activationEvents)_==="onStartupFinished"&&this.fb(B,_)})}ib(){const re=this.U("*",!0).then(void 0,Ee=>{this.l.error(Ee)});this.B(this.j.onDidChangeWorkspace(Ee=>this.jb(Ee.added)));const fe=this.j.workspace?this.j.workspace.folders:[],de=this.jb(fe),B=this.lb(),_=Promise.all([B,re,de]).then(()=>{});return Promise.race([_,(0,A.$ug)(1e4)]).then(()=>{this.hb()}),_}jb(re){return re.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(fe=>this.kb(re,fe))).then(()=>{})}async kb(re,fe){if(this.isActivated(fe.identifier))return;const de=!this.f.remote.isRemote&&!!this.f.remote.authority,B={logService:this.l,folders:re.map(Ee=>Ee.uri),forceUsingSearch:de||!this.c.fsExists,exists:Ee=>this.c.fsExists(Ee.fsPath),checkExists:(Ee,Re,ne)=>this.t.$checkExists(Ee,Re,ne)},_=await(0,w.$Ojb)(B,fe);if(_)return this.W(fe.identifier,{startup:!0,extensionId:fe.identifier,activationEvent:_.activationEvent}).then(void 0,Ee=>this.l.error(Ee))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(re){throw console.error(re),re}}async mb(){const{extensionDevelopmentLocationURI:re,extensionTestsLocationURI:fe}=this.f.environment;if(!re||!fe)throw new Error(k.localize(0,null));const de=await this.rb(null,fe,new S.$6$b(!1));if(!de||typeof de.run!="function")throw new Error(k.localize(1,null,fe.toString()));return new Promise((B,_)=>{const Ee=(ee,he)=>{ee?_(ee):B(typeof he=="number"&&he>0?1:0)},Re=(0,L.$Vf)(fe),ne=de.run(Re,Ee);ne&&ne.then&&ne.then(()=>{B(0)}).catch(ee=>{_(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,A.$ug)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(re,fe){return this.N[re]=fe,(0,m.$jb)(()=>{delete this.N[re]})}async getRemoteExecServer(re){const{resolver:fe}=await this.ob(re);return fe?.resolveExecServer?.(re,{resolveAttempt:0})}async ob(re){const fe=re.indexOf("+");if(fe===-1)throw new i.$FJ("Not an authority that can be resolved!",a.RemoteAuthorityResolverErrorCode.InvalidAuthority);const de=re.substr(0,fe);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this.N[de]}}async $resolveAuthority(re,fe){const de=z.$3c.create(!1),B=()=>`[resolveAuthority(${(0,a.$yk)(re)},${fe})][${de.elapsed()}ms] `,_=G=>this.l.info(`${B()}${G}`),Ee=G=>this.l.warn(`${B()}${G}`),Re=(G,x=void 0)=>this.l.error(`${B()}${G}`,x),ne=G=>{if(G instanceof i.$FJ)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G},ee=async G=>{_(`activating resolver for ${G}...`);const{resolver:x,authorityPrefix:pe}=await this.ob(G);if(!x)throw Re(`no resolver for ${pe}`),new i.$FJ(`No remote extension installed to resolve ${pe}.`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:x,authorityPrefix:pe,remoteAuthority:G}},he=re.split(/@|%40/g).reverse();_(`activating remote resolvers ${he.join(" -> ")}`);let X;try{X=await Promise.all(he.map(ee)).catch(async G=>{if(!(G instanceof i.$FJ)||G._code!==a.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw G;return Ee(`resolving nested authorities failed: ${G.message}`),[await ee(re)]})}catch(G){return ne(G)}const ue=new A.$Dg;ue.cancelAndSet(()=>_("waiting..."),1e3);let oe,le;for(const[G,{authorityPrefix:x,resolver:pe,remoteAuthority:se}]of X.entries())try{if(G===X.length-1)_("invoking final resolve()..."),h.mark(`code/extHost/willResolveAuthority/${x}`),oe=await pe.resolve(se,{resolveAttempt:fe,execServer:le}),h.mark(`code/extHost/didResolveAuthorityOK/${x}`),_("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(pe));else{if(_(`invoking resolveExecServer() for ${se}`),h.mark(`code/extHost/willResolveExecServer/${x}`),le=await pe.resolveExecServer?.(se,{resolveAttempt:fe,execServer:le}),!le)throw new i.$FJ(`Exec server was not available for ${se}`,a.RemoteAuthorityResolverErrorCode.NoResolverFound);h.mark(`code/extHost/didResolveExecServerOK/${x}`)}}catch(ve){return h.mark(`code/extHost/didResolveAuthorityError/${x}`),Re("returned an error",ve),ue.dispose(),ne(ve)}ue.dispose();const we={environmentTunnels:oe.environmentTunnels,features:oe.tunnelFeatures},O={extensionHostEnv:oe.extensionHostEnv,isTrusted:oe.isTrusted,authenticationSession:oe.authenticationSessionForInitializingExtensions?{id:oe.authenticationSessionForInitializingExtensions.id,providerId:oe.authenticationSessionForInitializingExtensions.providerId}:void 0};_(`returned ${i.$EJ.isManagedResolvedAuthority(oe)?"managed authority":`${oe.host}:${oe.port}`}`);let K;if(i.$EJ.isManagedResolvedAuthority(oe)){const G=fe;this.R.setFactory(G,oe.makeConnection),K={authority:re,connectTo:new a.$vk(G),connectionToken:oe.connectionToken}}else K={authority:re,connectTo:new a.$wk(oe.host,oe.port),connectionToken:oe.connectionToken};return{type:"ok",value:{authority:K,options:O,tunnelInformation:we}}}async $getCanonicalURI(re,fe){this.l.info(`$getCanonicalURI invoked for authority (${(0,a.$yk)(re)})`);const{resolver:de}=await this.ob(re);if(!de)return null;const B=b.URI.revive(fe);if(typeof de.getCanonicalURI>"u")return B;const _=await(0,A.$mg)(()=>de.getCanonicalURI(B));return _||B}$startExtensionHost(re){re.toAdd.forEach(B=>B.extensionLocation=b.URI.revive(B.extensionLocation));const{globalRegistry:fe,myExtensions:de}=H(this.D,this.G,this.F,re);return this.G.set(fe.getAllExtensionDescriptions()),this.F.set(de),this.nb()}$activateByEvent(re,fe){return fe===1?this.w.wait().then(de=>this.U(re,!1)):this.z.wait().then(de=>this.U(re,!1))}async $activate(re,fe){return await this.z.wait(),this.F.getExtensionDescription(re)?(await this.W(re,fe),!0):!1}async $deltaExtensions(re){re.toAdd.forEach(Ee=>Ee.extensionLocation=b.URI.revive(Ee.extensionLocation));const{globalRegistry:fe,myExtensions:de}=H(this.D,this.G,this.F,re),B=await this.Y(de);return(await this.getExtensionPathIndex()).setSearchTree(B),this.G.set(fe.getAllExtensionDescriptions()),this.F.set(de),Promise.resolve(void 0)}async $test_latency(re){return re}async $test_up(re){return re.byteLength}async $test_down(re){const fe=y.$Jb.alloc(re),de=Math.random()%256;for(let B=0;B<re;B++)fe.writeUInt8(de,B);return fe}async $updateRemoteConnectionData(re){this.Q=re,this.a.fire()}};e.$s_b=Y,e.$s_b=Y=Je([qe(0,n.$mh),qe(1,e.$r_b),qe(2,g.$zL),qe(3,p.$X$b),qe(4,$.$1$b),qe(5,R.$Pi),qe(6,t.$PL),qe(7,o.$e_b),qe(8,d.$Tpb),qe(9,v.$g_b),qe(10,T.$o_b),qe(11,U.$p_b)],Y);function H(ce,re,fe,de){ce.addActivationEvents(de.addActivationEvents);const B=new s.$l1b(ce,re.getAllExtensionDescriptions());B.deltaExtensions(de.toAdd,de.toRemove);const _=new f.$Gl(fe.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of de.myToRemove)_.delete(Re);for(const Re of de.myToAdd)_.add(Re);const Ee=te(B,_);return{globalRegistry:B,myExtensions:Ee}}function ge(ce,re){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:re.activationEvent,reasonId:re.extensionId.value}}e.$t_b=(0,n.$nh)("IExtHostExtensionService");class ie{#e;#t;#i;constructor(re,fe,de,B,_){this.#e=re,this.#t=fe,this.#i=de.identifier,this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=F.$$b((0,L.$Vf)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=B,this.isFromDifferentExtensionHost=_}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$u_b=ie;function te(ce,re){return ce.getAllExtensionDescriptions().filter(fe=>re.has(fe.identifier))}class q{constructor(re){this.a=re}setSearchTree(re){this.a=re}findSubstr(re){return this.a.findSubstr(re)}forEach(re){return this.a.forEach(re)}}e.$v_b=q;class V{constructor(re){this.a=new f.$Hl,this.addActivationEvents(re)}readActivationEvents(re){return this.a.get(re.identifier)}addActivationEvents(re){for(const fe of Object.keys(re))this.a.set(fe,re[fe])}}}),define(De[331],Ce([1,0,89,2,6,38,27,25,20,26,5,44,41,18,12]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=void 0;let p=class{constructor(C,i,a,n,t,o,g){this.c=C,this.d=i,this.e=a,this.f=n,this.g=t,this.h=o,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),k.mark("code/extHost/willWaitForConfig");const C=await this.f.getConfigProvider();k.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new s(this.c,i,this.d,C,this.i)),this.register(this.e.createInstance(c,i)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(f,i,this.h.environment.appUriScheme))}register(C){if("nodeModuleName"in C)if(Array.isArray(C.nodeModuleName))for(const i of C.nodeModuleName)this.a.set(i,C);else this.a.set(C.nodeModuleName,C);typeof C.alternativeModuleName=="function"&&this.b.push(i=>C.alternativeModuleName(i))}};e.$Nac=p,e.$Nac=p=Je([qe(2,R.$mh),qe(3,L.$1$b),qe(4,I.$t_b),qe(5,b.$PL),qe(6,S.$Pi)],p);let r=class mn{static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(C){if(C.environment.appRoot&&mn.a.size){const i=(0,D.$nd)(this.c(C.environment.appRoot.fsPath)),a="[a-z0-9_.-]",n=`@${a}+\\/${a}+|${a}+`,t="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${t}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(C){if(!this.b)return;const i=this.b.exec(this.c(C));if(!i)return;const[,a,n,t]=i,o=mn.a.get(n);if(o!==void 0)return console.warn(`${n} as been renamed to ${o}, please update your imports`),a+o+t}c(C){return C.replace(/\\/g,"/")}};r=Je([qe(0,b.$PL)],r);class s{constructor(C,i,a,n,t){this.c=C,this.d=i,this.e=a,this.f=n,this.g=t,this.nodeModuleName="vscode",this.a=new m.$Hl}load(C,i){const a=this.d.findSubstr(i);if(a){let n=this.a.get(a.identifier);return n||(n=this.c(a,this.e,this.f),this.a.set(a.identifier,n)),n}if(!this.b){let n="";this.d.forEach((t,o)=>n+=`	${o} -> ${t.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${n}`),this.b=this.c(A.$qF,this.e,this.f)}return this.b}}let c=class{constructor(C,i,a){this.d=C,this.nodeModuleName="keytar",this.a=i.getProxy(h.$xJ.MainThreadTelemetry);const{environment:n}=a,t=i.getProxy(h.$xJ.MainThreadKeytar);if(n.appRoot){let o=n.appRoot.fsPath;$.$7b==="win32"&&(o=o.replace(/\\/g,"/")),o[o.length-1]==="/"&&(o=o.substr(0,o.length-1)),this.b=new Set,this.b.add(`${o}/node_modules.asar/keytar`),this.b.add(`${o}/node_modules/keytar`)}this.c={getPassword:(o,g)=>t.$getPassword(o,g),setPassword:(o,g,u)=>t.$setPassword(o,g,u),deletePassword:(o,g)=>t.$deletePassword(o,g),findPassword:o=>t.$findPassword(o),findCredentials(o){return t.$findCredentials(o)}}}load(C,i){const a=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:a?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(C){const i=C.length;if(i<=7||!this.b)return;const a=i-7;if((C.charAt(a)==="/"||C.charAt(a)==="\\")&&C.endsWith("keytar")&&(C=C.replace(/\\/g,"/"),this.b.has(C)))return"keytar"}};c=Je([qe(1,E.$zL),qe(2,b.$PL)],c);let f=class{constructor(C,i,a){this.e=C,this.f=i,this.nodeModuleName=["open","opn"],this.d=a.getProxy(h.$xJ.MainThreadTelemetry);const n=a.getProxy(h.$xJ.MainThreadWindow);this.c=(t,o)=>{const g=F.URI.parse(t);return o?this.g(t,o):g.scheme==="http"||g.scheme==="https"?n.$openUri(g,t,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?n.$openUri(g,t,{}):this.g(t,o)}}load(C,i,a){const n=this.e.findSubstr(i);return n&&(this.a=n.identifier.value,this.h()),this.b=a(C),this.c}g(C,i){return this.i(),this.b(C,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};f=Je([qe(2,E.$zL)],f)}),define(De[52],Ce([1,0,54,4,13,41,5,61,62,44,7,37,263,38]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.$2_b=void 0,e.$2_b=(0,A.$nh)("IExtHostVariableResolverProvider");class D extends $.$AM{constructor(s,c,f,y,C,i,a){function n(){if(f){const t=f.activeEditor();if(t)return t.document.uri;const o=y.tabGroups.all.find(g=>g.isActive)?.activeTab;if(o!==void 0){if(o.input instanceof R.$hL||o.input instanceof R.$mL)return o.input.modified;if(o.input instanceof R.$gL||o.input instanceof R.$lL||o.input instanceof R.$jL)return o.input.uri}}}super({getFolderUri:t=>{const o=i.folders.filter(g=>g.name===t);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(t,o)=>C.getConfiguration(void 0,t).get(o),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const t=n();if(t)return h.$$b(t.fsPath)},getWorkspaceFolderPathForFile:()=>{if(c){const t=n();if(t){const o=c.getWorkspaceFolder(t);if(o)return h.$$b(o.uri.fsPath)}}},getSelectedText:()=>{if(f){const t=f.activeEditor();if(t&&!t.selection.isEmpty)return t.document.getText(t.selection)}},getLineNumber:()=>{if(f){const t=f.activeEditor();if(t)return String(t.selection.end.line+1)}},getExtension:t=>s.getExtension(t)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(L.env))}}let p=class extends F.$lb{constructor(s,c,f,y,C){super(),this.b=s,this.c=c,this.g=f,this.h=y,this.i=C,this.a=new k.$T(async()=>{const i=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async t=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.i,i,n,this.j())})}getResolver(){return this.a.value}j(){}};e.$3_b=p,e.$3_b=p=Je([qe(0,b.$t_b),qe(1,I.$X$b),qe(2,m.$KL),qe(3,S.$1$b),qe(4,E.$Z_b)],p)}),define(De[90],Ce([1,0,17,3,14,2,5,6,62,44,20,7,37,134,256,38,52]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=e.$7_b=e.$6_b=e.$5_b=e.$4_b=void 0,e.$4_b=(0,A.$nh)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,t,o,g,u,d){this.E=t,this.F=o,this.G=g,this.H=u,this.I=d,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new F.$7c,this.n=new F.$7c,this.o=new F.$7c,this.u=new F.$7c,this.k=n.getProxy(m.$xJ.MainThreadDebugService),this.y=new F.$7c,this.A=new F.$7c,this.v=new f(this.k),this.w=new Map,this.F.getExtensionRegistry().then(v=>{v.onDidChange(l=>{this.J(v)}),this.J(v)})}asDebugSourceUri(n,t){const o=n;if(typeof o.sourceReference=="number"&&o.sourceReference>0){let g=`debug:${encodeURIComponent(o.path||"")}`,u="?";return t&&(g+=`${u}session=${encodeURIComponent(t.id)}`,u="&"),g+=`${u}ref=${o.sourceReference}`,L.URI.parse(g)}else{if(o.path)return L.URI.file(o.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const t=[];for(const o of n.getAllExtensionDescriptions())if(o.contributes){const g=o.contributes.debuggers;if(g&&g.length>0)for(const u of g)(0,D.$6E)(u)&&t.push(u.type)}this.k.$registerDebugTypes(t)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(t=>n.push(t)),n}addBreakpoints(n){const t=n.filter(u=>{const d=u.id;return this.w.has(d)?!1:(this.w.set(d,u),!0)});this.U(t,[],[]);const o=[],g=new Map;for(const u of t)if(u instanceof I.$zK){let d=g.get(u.location.uri.toString());d||(d={type:"sourceMulti",uri:u.location.uri,lines:[]},g.set(u.location.uri.toString(),d),o.push(d)),d.lines.push({id:u.id,enabled:u.enabled,condition:u.condition,hitCondition:u.hitCondition,logMessage:u.logMessage,line:u.location.range.start.line,character:u.location.range.start.character})}else u instanceof I.$AK&&o.push({type:"function",id:u.id,enabled:u.enabled,hitCondition:u.hitCondition,logMessage:u.logMessage,condition:u.condition,functionName:u.functionName});return this.k.$registerBreakpoints(o)}removeBreakpoints(n){const t=n.filter(d=>this.w.delete(d.id));this.U([],t,[]);const o=t.filter(d=>d instanceof I.$zK).map(d=>d.id),g=t.filter(d=>d instanceof I.$AK).map(d=>d.id),u=t.filter(d=>d instanceof I.$BK).map(d=>d.id);return this.k.$unregisterBreakpoints(o,g,u)}startDebugging(n,t,o){return this.k.$startDebugging(n?n.uri:void 0,t,{parentSessionID:o.parentSession?o.parentSession.id:void 0,lifecycleManagedByParent:o.lifecycleManagedByParent,repl:o.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:o.noDebug,compact:o.compact,suppressSaveBeforeStart:o.suppressSaveBeforeStart,suppressDebugStatusbar:o.suppressDebugStatusbar??o.debugUI?.simple,suppressDebugToolbar:o.suppressDebugToolbar??o.debugUI?.simple,suppressDebugView:o.suppressDebugView??o.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,t,o){if(!t)return new I.$zJ(()=>{});const g=this.d++;return this.f.push({type:n,handle:g,provider:t}),this.k.$registerDebugConfigurationProvider(n,o,!!t.provideDebugConfigurations,!!t.resolveDebugConfiguration,!!t.resolveDebugConfigurationWithSubstitutedVariables,g),new I.$zJ(()=>{this.f=this.f.filter(u=>u.provider!==t),this.k.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(n,t,o){if(!o)return new I.$zJ(()=>{});if(!this.Q(n,t))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${t}' debugger.`);if(this.N(t))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:t,handle:g,factory:o}),this.k.$registerDebugAdapterDescriptorFactory(t,g),new I.$zJ(()=>{this.h=this.h.filter(u=>u.factory!==o),this.k.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(n,t){if(!t)return new I.$zJ(()=>{});const o=this.i++;return this.j.push({type:n,handle:o,factory:t}),new I.$zJ(()=>{this.j=this.j.filter(g=>g.factory!==t)})}async $runInTerminal(n,t){return Promise.resolve(void 0)}async $substituteVariables(n,t){let o;const g=await this.W(n);return g&&(o={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(o,t)}K(n,t){if(n.type==="implementation")return new C(n.implementation)}L(){}async $startDASession(n,t){const o=this,g=await this.V(t);return this.S(this.N(g.type),g).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const d=this.M(u),v=this.K(d,g);if(!v)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const l=v;return this.B.set(n,l),this.R(g).then(w=>(w&&this.C.set(n,w),l.onMessage(async P=>{if(P.type==="request"&&P.command==="handshake"){const M=P,N={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const T=await this.D.sign(M.arguments.value);N.body={signature:T},l.sendResponse(N)}else throw new Error("no signer")}catch(T){N.success=!1,N.message=T.message,l.sendResponse(N)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(P),P=(0,D.$$E)(P,!0),o.k.$acceptDAMessage(n,P)}),l.onError(P=>{w&&w.onError&&w.onError(P),this.k.$acceptDAError(n,P.name,P.message,P.stack)}),l.onExit(P=>{w&&w.onExit&&w.onExit((0,h.$Ae)(P),void 0),this.k.$acceptDAExit(n,(0,h.$Ae)(P),void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),l.startSession()))})}$sendDAMessage(n,t){t=(0,D.$0E)(t,!1);const o=this.C.get(n);o&&o.onWillReceiveMessage&&o.onWillReceiveMessage(t),this.B.get(n)?.sendMessage(t)}$stopDASession(n){const t=this.C.get(n);this.C.delete(n),t&&t.onWillStopSession&&t.onWillStopSession();const o=this.B.get(n);return this.B.delete(n),o?o.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const t=[],o=[],g=[];if(n.added)for(const u of n.added){const d=u.id;if(d&&!this.w.has(d)){let v;if(u.type==="function")v=new I.$AK(u.functionName,u.enabled,u.condition,u.hitCondition,u.logMessage);else if(u.type==="data")v=new I.$BK(u.label,u.dataId,u.canPersist,u.enabled,u.hitCondition,u.condition,u.logMessage);else{const l=L.URI.revive(u.uri);v=new I.$zK(new I.$LJ(l,new I.$AJ(u.line,u.character)),u.enabled,u.condition,u.hitCondition,u.logMessage)}(0,I.$xK)(v,d),this.w.set(d,v),t.push(v)}}if(n.removed)for(const u of n.removed){const d=this.w.get(u);d&&(this.w.delete(u),o.push(d))}if(n.changed){for(const u of n.changed)if(u.id){const d=this.w.get(u.id);if(d){if(d instanceof I.$AK&&u.type==="function"){const v=d;v.enabled=u.enabled,v.condition=u.condition,v.hitCondition=u.hitCondition,v.logMessage=u.logMessage,v.functionName=u.functionName}else if(d instanceof I.$zK&&u.type==="source"){const v=d;v.enabled=u.enabled,v.condition=u.condition,v.hitCondition=u.hitCondition,v.logMessage=u.logMessage,v.location=new I.$LJ(L.URI.revive(u.uri),new I.$AJ(u.line,u.character))}g.push(d)}}}this.U(t,o,g)}async $acceptStackFrameFocus(n){let t;const o=n.sessionId?await this.V(n.sessionId):void 0;if(!o)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?t=new I.$HK(o,n.threadId):t=new I.$GK(o,n.threadId,n.frameId),this.z=t,this.A.fire(this.z)}$provideDebugConfigurations(n,t,o){return(0,k.$mg)(async()=>{const g=this.P(n);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const u=await this.W(t);return g.provideDebugConfigurations(u,o)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(n,t,o,g){return(0,k.$mg)(async()=>{const u=this.P(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const d=await this.W(t);return u.resolveDebugConfiguration(d,o,g)})}$resolveDebugConfigurationWithSubstitutedVariables(n,t,o,g){return(0,k.$mg)(async()=>{const u=this.P(n);if(!u)throw new Error("no DebugConfigurationProvider found");if(!u.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const d=await this.W(t);return u.resolveDebugConfigurationWithSubstitutedVariables(d,o,g)})}async $provideDebugAdapter(n,t){const o=this.O(n);if(!o)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.V(t);return this.S(o,g).then(u=>{if(!u)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.M(u)})}async $acceptDebugSessionStarted(n){const t=await this.V(n);this.m.fire(t)}async $acceptDebugSessionTerminated(n){const t=await this.V(n);t&&(this.n.fire(t),this.l.delete(t.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,t){(await this.V(n))?._acceptNameChanged(t)}async $acceptDebugSessionCustomEvent(n,t){const g={session:await this.V(n),event:t.event,body:t.body};this.u.fire(g)}M(n){if(n instanceof I.$CK)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof I.$DK)return{type:"server",port:n.port,host:n.host};if(n instanceof I.$EK)return{type:"pipeServer",path:n.path};if(n instanceof I.$FK)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const t=this.h.filter(o=>o.type===n);if(t.length>0)return t[0].factory}O(n){const t=this.h.filter(o=>o.handle===n);if(t.length>0)return t[0].factory}P(n){const t=this.f.filter(o=>o.handle===n);if(t.length>0)return t[0].provider}Q(n,t){if(n.contributes){const o=n.contributes.debuggers;if(o&&o.length>0){for(const g of o)if(g.label&&g.type&&g.type===t)return!0}}return!1}R(n){const o=n.configuration.type,g=this.j.filter(u=>u.type===o||u.type==="*").map(u=>(0,k.$mg)(()=>u.factory.createDebugAdapterTracker(n)).then(d=>d,d=>null));return Promise.race([Promise.all(g).then(u=>{const d=u.filter(v=>!!v);if(d.length>0)return new y(d)}),new Promise(u=>setTimeout(()=>u(void 0),1e3))]).catch(u=>{})}async S(n,t){const o=t.configuration.debugServer;if(typeof o=="number")return Promise.resolve(new I.$DK(o));if(n){const u=await this.F.getExtensionRegistry();return(0,k.$mg)(()=>n.createDebugAdapterDescriptor(t,this.T(t,u))).then(d=>{if(d)return d})}const g=await this.F.getExtensionRegistry();return Promise.resolve(this.T(t,g))}T(n,t){}U(n,t,o){(n.length>0||t.length>0||o.length>0)&&this.y.fire(Object.freeze({added:n,removed:t,changed:o}))}async V(n){if(n)if(typeof n=="string"){const t=this.l.get(n);if(t)return t}else{let t=this.l.get(n.id);if(!t){const o=await this.W(n.folderUri),g=n.parent?this.l.get(n.parent):void 0;t=new c(this.k,n.id,n.type,n.name,o,n.configuration,g),this.l.set(t.id,t),this.k.$sessionCached(t.id)}return t}throw new Error("cannot find session")}W(n){if(n){const t=L.URI.revive(n);return this.E.resolveWorkspaceFolder(t)}return Promise.resolve(void 0)}};e.$5_b=s,e.$5_b=s=Je([qe(0,R.$zL),qe(1,$.$X$b),qe(2,b.$t_b),qe(3,p.$1$b),qe(4,E.$Z_b),qe(5,r.$2_b)],s);class c{constructor(n,t,o,g,u,d,v){this.d=n,this.f=t,this.g=o,this.h=g,this.i=u,this.j=d,this.k=v}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,t){return this.d.$customDebugAdapterRequest(this.f,n,t)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$6_b=c;class f{constructor(n){this.value=Object.freeze({append(t){n.$appendDebugConsole(t)},appendLine(t){this.append(t+`
`)}})}}e.$7_b=f;class y{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(t=>t.onWillReceiveMessage?t.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(t=>t.onDidSendMessage?t.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(t=>t.onError?t.onError(n):void 0)}onExit(n,t){this.d.forEach(o=>o.onExit?o.onExit(n,t):void 0)}}class C extends S.$v${constructor(n){super(),this.h=n,n.onDidSendMessage(t=>{this.acceptMessage(t)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends s{constructor(n,t,o,g,u,d){super(n,t,o,g,u,d)}};e.$8_b=i,e.$8_b=i=Je([qe(0,R.$zL),qe(1,$.$X$b),qe(2,b.$t_b),qe(3,p.$1$b),qe(4,E.$Z_b),qe(5,r.$2_b)],i)}),define(De[332],Ce([1,0,8,89,2,6,324,18,98,99,26,227,20,58,44,83]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=e.$Oac=void 0;class r{static async installEarlyHandler(f){Error.stackTraceLimit=100;const y=f.get(m.$Pi),i=f.get($.$zL).getProxy(L.$xJ.MainThreadErrors);k.setUnexpectedErrorHandler(a=>{y.error(a);const n=k.$1(a);i.$onUnexpectedError(n)})}static async installFullHandler(f){const y=f.get(m.$Pi),C=f.get($.$zL),i=f.get(D.$t_b),a=f.get(p.$TL),n=C.getProxy(L.$xJ.MainThreadExtensionService),t=C.getProxy(L.$xJ.MainThreadErrors),o=await i.getExtensionPathIndex(),g=new WeakMap;function u(l,w){if(g.has(l))return g.get(l).stack;let P="",M,N;for(const z of w)P+=`
	at ${z.toString()}`,N=z.getFileName(),!M&&N&&(M=o.findSubstr(h.URI.file(N)));const T=`${l.name||"Error"}: ${l.message||""}${P}`;return g.set(l,{extensionIdentifier:M?.identifier,stack:T}),T}const d=Symbol("prepareStackTrace wrapped");let v=u;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(l){if(l===u||l[d]){v=l;return}v=function(w,P){return u(w,P),l.call(Error,w,P)},Object.assign(v,{[d]:!0})}}),k.setUnexpectedErrorHandler(l=>{y.error(l);const w=k.$1(l),P=g.get(l);if(!P?.extensionIdentifier){t.$onUnexpectedError(w);return}n.$onExtensionRuntimeError(P.extensionIdentifier,w);const M=a.onExtensionError(P.extensionIdentifier,l);y.trace("forwarded error to extension?",M,P)})}}e.$Oac=r;class s{constructor(f,y,C,i,a){this.a=C,this.b=new A.$t1b(f,null,i),y=s.e(y,this.b);const n=new b.$lh(...(0,E.$$q)());n.set(R.$PL,{_serviceBrand:void 0,...y,messagePorts:a}),n.set($.$zL,new $.$AL(this.b)),n.set(S.$U$b,new S.$V$b(i)),n.set(D.$r_b,C);const t=new I.$Sp(n,!0);t.invokeFunction(r.installEarlyHandler),this.d=t.invokeFunction(o=>o.get(m.$Pi)),F.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",y),this.c=t.invokeFunction(o=>o.get(D.$t_b)),this.c.initialize(),t.invokeFunction(r.installFullHandler)}async asBrowserUri(f){const y=this.b.getProxy(L.$xJ.MainThreadExtensionService);return h.URI.revive(await y.$asBrowserUri(f))}terminate(f){this.c.terminate(f)}static e(f,y){f.allExtensions.forEach(i=>{i.extensionLocation=h.URI.revive(y.transformIncomingURIs(i.extensionLocation))}),f.environment.appRoot=h.URI.revive(y.transformIncomingURIs(f.environment.appRoot));const C=f.environment.extensionDevelopmentLocationURI;return C&&(f.environment.extensionDevelopmentLocationURI=C.map(i=>h.URI.revive(y.transformIncomingURIs(i)))),f.environment.extensionTestsLocationURI=h.URI.revive(y.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=h.URI.revive(y.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=h.URI.revive(y.transformIncomingURIs(f.environment.workspaceStorageHome)),f.environment.extensionTelemetryLogResource=h.URI.revive(y.transformIncomingURIs(f.environment.extensionTelemetryLogResource)),f.nlsBaseUrl=h.URI.revive(y.transformIncomingURIs(f.nlsBaseUrl)),f.logsLocation=h.URI.revive(y.transformIncomingURIs(f.logsLocation)),f.workspace=y.transformIncomingURIs(f.workspace),f}}e.$Pac=s}),define(De[333],Ce([1,0,17,11,205,221,237,90,62,44,20,43,7,52,37,257,258,38]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zac=void 0;let c=class extends m.$5_b{constructor(a,n,t,o,g,u,d){super(a,n,t,o,u,d),this.Z=g,this.X=new C}K(a,n){switch(a.type){case"server":return new p.$Uac(a);case"pipeServer":return new p.$Vac(a);case"executable":return new p.$Wac(a,n.type)}return super.K(a,n)}T(a,n){const t=p.$Wac.platformAdapterExecutable(n.getAllExtensionDescriptions(),a.type);if(t)return new $.$CK(t.command,t.args,t.options)}L(){return new A.$44b}async $runInTerminal(a,n){if(a.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(T=>{this.X.onTerminalClosed(T)}));const t=await this.G.getConfigProvider(),o=this.Z.getDefaultShell(!0),g=this.Z.getDefaultShellArgs(!0),u=a.title||h.localize(0,null),d=JSON.stringify({shell:o,shellArgs:g});let v=await this.X.checkout(d,u),l,w=!1;if(v)l=a.cwd;else{const T={shellPath:o,shellArgs:g,cwd:a.cwd,name:u,iconPath:new $.$uK("debug")};w=!0,v=this.Z.createTerminalFromOptions(T,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(v,d)}v.show(!0);const P=await v.processId;w?await new Promise(T=>setTimeout(T,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(o.indexOf("powershell")>=0||o.indexOf("pwsh")>=0||o.indexOf("cmd.exe")>=0?v.sendText("cls"):o.indexOf("bash")>=0?v.sendText("clear"):F.$i?v.sendText("cls"):v.sendText("clear"));const M=(0,r.$Yac)(o,a.args,!!a.argsCanBeInterpretedByShell,l,a.env);v.sendText(M);const N=this.onDidTerminateDebugSession(T=>{T.id===n&&(this.X.free(v),N.dispose())});return P}else if(a.kind==="external")return y(a,await this.G.getConfigProvider());return super.$runInTerminal(a,n)}};e.$Zac=c,e.$Zac=c=Je([qe(0,R.$zL),qe(1,D.$X$b),qe(2,b.$t_b),qe(3,s.$1$b),qe(4,I.$g_b),qe(5,E.$Z_b),qe(6,S.$2_b)],c);let f;function y(i,a){if(!f)if(F.$i)f=new L.$P3b;else if(F.$j)f=new L.$Q3b;else if(F.$k)f=new L.$R3b;else throw new Error("external terminals not supported on this platform");const n=a.getConfiguration("terminal");return f.runInTerminal(i.title,i.cwd,i.args,i.env||{},n.external||{})}class C{constructor(){this.b=new Map}static{this.a=1e3}async checkout(a,n){const o=[...this.b.entries()].map(([g,u])=>(0,k.$hg)(async d=>{if(g.name!==n||u.lastUsedAt!==-1&&await(0,r.$Xac)(await g.processId))return null;const v=Date.now();return u.lastUsedAt+C.a>v||d.isCancellationRequested||u.config!==a?null:(u.lastUsedAt=v,g)}));return await(0,k.$yg)(o,g=>!!g)}insert(a,n){this.b.set(a,{lastUsedAt:Date.now(),config:n})}free(a){const n=this.b.get(a);n&&(n.lastUsedAt=-1)}onTerminalClosed(a){this.b.delete(a)}}}),define(De[334],Ce([1,0,13,2,96,37,61,38,50,43,20,26,88,15,18,84,24,75,52]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rac=void 0;let f=class extends $.$W_b{constructor(C,i,a,n,t,o,g,u,d){super(C,i,a,n,t,o,g,u),this.B=a,this.C=d,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(S.Schemas.vscodeRemote,{scheme:S.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(S.Schemas.file,{scheme:S.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(C,i){const a=i;if(!i.execution&&a._id===void 0)throw new Error("Tasks to execute must include an execution");if(a._id!==void 0){const n=$.TaskHandleDTO.from(a,this.B),t=await this.a.$getTaskExecution(n);if(t.task===void 0)throw new Error("Task from execution DTO is undefined");const o=await this.y(t,i);return this.a.$executeTask(n).catch(()=>{}),o}else{const n=$.TaskDTO.from(i,C);if(n===void 0)return Promise.reject(new Error("Task is not valid"));$.CustomExecutionDTO.is(n.execution)&&await this.x(n,i,!1);const t=await this.y(await this.a.$getTaskExecution(n),i);return this.a.$executeTask(n).catch(()=>{}),t}}u(C,i,a,n){const t=[];if(n)for(const o of n){this.z(o,a),(!o.definition||!C[o.definition.type])&&this.f.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const g=$.TaskDTO.from(o,a.extension);g&&(t.push(g),$.CustomExecutionDTO.is(g.execution)&&i.push(this.x(g,o,!0)))}return{tasks:t,extension:a.extension}}async v(C){return C}async F(C){let i=C&&C.length>0?C[0]:void 0;if(!i){const a=F.URI.file((0,s.homedir)());i=new E.$Hh({uri:a,name:r.$5f(a),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(C,i){const a=F.URI.revive(C),n={process:void 0,variables:Object.create(null)},t=await this.b.resolveWorkspaceFolder(a),o=await this.b.getWorkspaceFolders2()??[],g=await this.C.getResolver(),u=t?{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(o);for(const d of i.variables)n.variables[d]=await g.resolveAsync(u,d);if(i.process!==void 0){let d;if(i.process.path!==void 0){d=i.process.path.split(k.$kc);for(let v=0;v<d.length;v++)d[v]=await g.resolveAsync(u,d[v])}n.process=await h.win32.findExecutable(await g.resolveAsync(u,i.process.name),i.process.cwd!==void 0?await g.resolveAsync(u,i.process.cwd):void 0,d)}return n}async $jsonTasksSupported(){return!0}async $findExecutable(C,i,a){return h.win32.findExecutable(C,i,a)}};e.$Rac=f,e.$Rac=f=Je([qe(0,R.$zL),qe(1,I.$PL),qe(2,L.$X$b),qe(3,A.$KL),qe(4,m.$1$b),qe(5,b.$g_b),qe(6,D.$Pi),qe(7,p.$N$b),qe(8,c.$2_b)],f)}),define(De[335],Ce([1,0,75,52]),function(me,e,k,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xbc=void 0;class h extends F.$3_b{j(){return(0,k.homedir)()}}e.$xbc=h}),define(De[146],Ce([1,0,19,17,21,45,15,13,24,2,35]),function(me,e,k,F,h,L,A,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aac=e.$__b=e.$$_b=e.$0_b=void 0;class I{constructor(c,f,y,C){this.d=c,this.e=f,this.f=y,this.g=C,this.a=null,this.b=!1,this.c=0}search(c,f){const y=this.d.folderQueries||[],C=new h.$dd;return f.onCancellationRequested(()=>C.cancel()),new Promise((i,a)=>{this.a=new S(c);let n=!1;const t=(o,g)=>{if(!n&&!this.b){const u=this.h(o);p(o)&&typeof this.d.maxResults=="number"&&this.c+u>this.d.maxResults&&(this.b=!0,n=!0,C.cancel(),o=this.j(o,this.d.maxResults-this.c));const d=this.h(o);this.c+=d,(d>0||!p(o))&&this.a.add(o,g)}};Promise.all(y.map((o,g)=>this.k(o,u=>t(u,g),C.token))).then(o=>{C.dispose(),this.a.flush();const g=o.some(u=>!!u&&!!u.limitHit);i({limitHit:this.b||g,messages:(0,k.$xf)(o.map(u=>u?.message?Array.isArray(u.message)?u.message:[u.message]:[])),stats:{type:this.g}})},o=>{C.dispose();const g=(0,L.$$h)(o);a(new Error(g))})})}h(c){return p(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}j(c,f){const y=Array.isArray(c.ranges)?c.ranges:[c.ranges],C=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:y.slice(0,f),preview:{matches:C.slice(0,f),text:c.preview.text},uri:c.uri}}async k(c,f,y){const C=new R.$bI(this.d,c),i=[],a={report:o=>{if(!this.l(o))return;const g=c.folder.scheme===A.Schemas.file?(0,R.$cI)(()=>this.f.readdir(E.$7f(o.uri))):void 0,u=E.$0f(c.folder,o.uri);if(u){const d=C.includedInQuery(u,m.$ec(u),g);(0,F.$gg)(d)?i.push(d.then(v=>{v&&f(o)})):d&&f(o)}}},n=this.n(c),t=await this.e.provideTextSearchResults($(this.d.contentPattern),n,a,y);return i.length&&await Promise.all(i),t}l(c){if(p(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(c){const f=(0,R.$aI)(this.d.includePattern,c.includePattern),y=(0,R.$aI)(this.d.excludePattern,c.excludePattern),C={folder:b.URI.from(c.folder),excludes:y,includes:f,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.f.toCanonicalName(c.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return C.usePCRE2=this.d.usePCRE2,C}}e.$0_b=I;function $(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class S{constructor(c){this.e=c,this.b=-1,this.d=null,this.a=new r(512,f=>this.g(f))}add(c,f){this.d&&(this.b!==f||!E.$1f(this.c,c.uri))&&(this.f(),this.d=null),this.d||(this.b=f,this.d={resource:c.uri,results:[]}),this.d.results.push(D(c))}f(){const c=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,c)}flush(){this.f(),this.a.flush()}g(c){this.e(c)}}e.$$_b=S;function D(s){return p(s)?{preview:{matches:(0,k.$Hf)(s.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:s.preview.text},ranges:(0,k.$Hf)(s.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function p(s){return!!s.preview}e.$__b=p;class r{static{this.a=4e3}static{this.b=50}constructor(c,f){this.g=c,this.h=f,this.c=0,this.d=[],this.e=0}addItem(c,f){c&&this.j(c,f)}addItems(c,f){c&&this.k(c,f)}j(c,f){this.d.push(c),this.e+=f,this.l()}k(c,f){this.d=this.d.concat(c),this.e+=f,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$aac=r}),define(De[91],Ce([1,0,4,6,5,328,20,58,18,2,146]),function(me,e,k,F,h,L,A,m,E,b,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dac=e.$cac=e.$bac=void 0,e.$bac=(0,h.$nh)("IExtHostSearch");let I=class{constructor(p,r,s){this.k=p,this.l=r,this.n=s,this.c=this.k.getProxy(F.$xJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.$9_b}o(p){return this.l.transformOutgoingScheme(p)}registerTextSearchProvider(p,r){if(this.g.has(p))throw new Error(`a text search provider for the scheme '${p}' is already registered`);this.g.add(p);const s=this.d++;return this.e.set(s,r),this.c.$registerTextSearchProvider(s,this.o(p)),(0,k.$jb)(()=>{this.g.delete(p),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(p,r){if(this.i.has(p))throw new Error(`a file search provider for the scheme '${p}' is already registered`);this.i.add(p);const s=this.d++;return this.h.set(s,r),this.c.$registerFileSearchProvider(s,this.o(p)),(0,k.$jb)(()=>{this.i.delete(p),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(p,r,s,c){const f=$(s),y=this.h.get(p);if(y)return this.j.fileSearch(f,y,C=>{this.c.$handleFileMatch(p,r,C.map(i=>i.resource))},c);throw new Error("unknown provider: "+p)}$clearCache(p){return this.j.clearCache(p),Promise.resolve(void 0)}$provideTextSearchResults(p,r,s,c){const f=this.e.get(p);if(!f||!f.provideTextSearchResults)throw new Error(`Unknown provider ${p}`);const y=$(s);return this.q(y,f).search(i=>this.c.$handleTextMatch(p,r,i),c)}$enableExtensionHostSearch(){}q(p,r){return new R.$0_b(p,r,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$cac=I,e.$cac=I=Je([qe(0,A.$zL),qe(1,m.$U$b),qe(2,E.$Pi)],I);function $(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(S),extraFileResources:D.extraFileResources&&D.extraFileResources.map(p=>b.URI.revive(p))}}e.$dac=$;function S(D){return{...D,folder:b.URI.revive(D.folder)}}}),define(De[336],Ce([1,0,21,8,3,40,2,124,117,161,177,30,6,105,283,282,36,284,38,286,287,288,265,289,61,44,290,291,296,297,298,145,269,304,305,308,109,43,310,273,16,7,80,313,86,144,37,25,261,295,79,142,88,90,91,18,58,20,26,299,259,64,84,279,311,85,63,316,314,315,280,51,309,312,108,62,83,300,87,301,15,127,268,248,293,4,27,255,106,244,302,303,281,292,267,306,294,107,307]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y,C,i,a,n,t,o,g,u,d,v,l,w,P,M,N,T,z,j,U,Y,H,ge,ie,te,q,V,ce,re,fe,de,B,_,Ee,Re,ne,ee,he,X,ue,oe,le,we,O,K,G,x,pe,se,ve,Ie,Ue,Ve,xe,Ge,et,Ze,st,tt,Pe,ke,Be,Q,Z,ye,je,Oe,Ye,_e,rt,ft,vt,Ft,Lt,Et,Tt,Mt,zt,Bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;function Nt(at){const dt=at.get(X.$PL),Wt=at.get(Ue.$K$b),Ot=at.get(x.$d_b),St=at.get(t.$t_b),ct=at.get(V.$X$b),At=at.get(Ze.$TL),Ut=at.get(c.$1$b),Te=at.get(ee.$U$b),Le=at.get(he.$zL),Ae=at.get(T.$_$b),ae=at.get(G.$e_b),Me=at.get(ne.$Qi),We=at.get(ne.$Pi),Xe=at.get(le.$Tpb),He=at.get(we.$N$b),it=at.get(q.$R_b),wt=at.get(Ge.$l_b),Dt=at.get(et.$Z_b),Ct=at.get(zt.$p_b);Le.set($.$yJ.ExtHostFileSystemInfo,Wt),Le.set($.$yJ.ExtHostLogLevelServiceShape,Me),Le.set($.$yJ.ExtHostWorkspace,ct),Le.set($.$yJ.ExtHostConfiguration,Ut),Le.set($.$yJ.ExtHostExtensionService,St),Le.set($.$yJ.ExtHostStorage,Ae),Le.set($.$yJ.ExtHostTunnelService,Xe),Le.set($.$yJ.ExtHostWindow,it),Le.set($.$yJ.ExtHostSecretState,wt),Le.set($.$yJ.ExtHostTelemetry,At),Le.set($.$yJ.ExtHostEditorTabs,Dt),Le.set($.$yJ.ExtHostManagedSockets,Ct);const pt=Le.set($.$yJ.ExtHostDecorations,at.get(B.$V_b)),$t=Le.set($.$yJ.ExtHostDocumentsAndEditors,at.get(n.$KL)),ht=Le.set($.$yJ.ExtHostCommands,at.get(r.$VL)),bt=Le.set($.$yJ.ExtHostTerminalService,at.get(z.$g_b)),gt=Le.set($.$yJ.ExtHostDebugService,at.get(Ee.$4_b)),Zt=Le.set($.$yJ.ExtHostSearch,at.get(Re.$bac)),qt=Le.set($.$yJ.ExtHostTask,at.get(_.$Y_b)),Qi=Le.set($.$yJ.ExtHostOutputService,at.get(l.$B_b)),hi=Le.set($.$yJ.ExtHostLocalization,at.get(_e.$o_b)),di=Le.set($.$yJ.ExtHostUrls,new ie.$K_b(Le)),It=Le.set($.$yJ.ExtHostDocuments,new a.$I$b(Le,$t)),yi=Le.set($.$yJ.ExtHostDocumentContentProviders,new C.$3$b(Le,$t,We)),Ht=Le.set($.$yJ.ExtHostDocumentSaveParticipant,new i.$4$b(We,It,Le.getProxy($.$xJ.MainThreadBulkEdits))),kt=Le.set($.$yJ.ExtHostNotebook,new ue.$hac(Le,ht,$t,It,Ot)),Ei=Le.set($.$yJ.ExtHostNotebookDocuments,new Z.$zac(kt)),fi=Le.set($.$yJ.ExtHostNotebookEditors,new Q.$yac(We,kt)),ai=Le.set($.$yJ.ExtHostNotebookKernels,new st.$vac(Le,dt,kt,ht,We)),xi=Le.set($.$yJ.ExtHostNotebookRenderers,new Pe.$xac(Le,kt)),ni=Le.set($.$yJ.ExtHostNotebookDocumentSaveParticipant,new Et.$Fac(We,kt,Le.getProxy($.$xJ.MainThreadBulkEdits))),Rt=Le.set($.$yJ.ExtHostEditors,new j.$I_b(Le,$t)),mi=Le.set($.$yJ.ExtHostTreeViews,new U.$J_b(Le.getProxy($.$xJ.MainThreadTreeViews),ht,We)),ki=Le.set($.$yJ.ExtHostEditorInsets,new re.$S_b(Le.getProxy($.$xJ.MainThreadEditorInsets),Rt,dt.remote)),ri=Le.set($.$yJ.ExtHostDiagnostics,new f.$M$b(Le,We,Wt,$t)),si=Le.set($.$yJ.ExtHostLanguages,new d.$y_b(Le,It,ht.converter,Te)),ut=Le.set($.$yJ.ExtHostLanguageFeatures,new u.$Q$b(Le,Te,It,ht,ri,We,He,At)),Si=Le.set($.$yJ.ExtHostFileSystem,new o.$w_b(Le,ut)),Kt=Le.set($.$yJ.ExtHostFileSystemEventService,new g.$x_b(Le,We,$t)),_t=Le.set($.$yJ.ExtHostQuickOpen,(0,P.$D_b)(Le,ct,ht)),gi=Le.set($.$yJ.ExtHostSCM,new M.$F_b(Le,ht,It,We)),zi=Le.set($.$yJ.ExtHostQuickDiff,new vt.$Cac(Le,Te)),Di=Le.set($.$yJ.ExtHostShare,new Bt.$Iac(Le,Te)),Ci=Le.set($.$yJ.ExtHostComments,(0,s.$T$b)(Le,ht,It)),$i=Le.set($.$yJ.ExtHostProgress,new w.$C_b(Le.getProxy($.$xJ.MainThreadProgress))),Ii=Le.set($.$yJ.ExtHosLabelService,new fe.$T_b(Le)),Pi=Le.set($.$yJ.ExtHostTheming,new oe.$iac(Le)),ei=Le.set($.$yJ.ExtHostAuthentication,new O.$jac(Le)),Ai=Le.set($.$yJ.ExtHostTimeline,new K.$lac(Le,ht)),bi=Le.set($.$yJ.ExtHostWebviews,new te.$N_b(Le,dt.remote,ct,We,He)),pi=Le.set($.$yJ.ExtHostWebviewPanels,new ve.$nac(Le,bi,ct)),Ui=Le.set($.$yJ.ExtHostCustomEditors,new se.$oac(Le,It,ae,bi,pi)),ji=Le.set($.$yJ.ExtHostWebviewViews,new pe.$mac(Le,bi)),oi=Le.set($.$yJ.ExtHostTesting,new Ve.$qac(Le,ht,$t)),_i=Le.set($.$yJ.ExtHostUriOpeners,new xe.$uac(Le)),en=Le.set($.$yJ.ExtHostProfileContentHandlers,new ft.$Bac(Le));Le.set($.$yJ.ExtHostInteractive,new ye.$Aac(Le,kt,$t,ht,We));const Li=Le.set($.$yJ.ExtHostInlineChat,new Lt.$Eac(Le,ht,It,We)),Qt=Le.set($.$yJ.ExtHostChat,new Ft.$Dac(Le,We)),tn=Le.set($.$yJ.ExtHostSemanticSimilarity,new Tt.$Gac(Le)),nn=Le.set($.$yJ.ExtHostIssueReporter,new Mt.$Hac(Le)),Ri=Le.set($.$yJ.ExtHostStatusBar,new N.$H_b(Le,ht.converter)),Fi=Object.values($.$yJ);Le.assertRegistered(Fi);const Bi=new Ie.$pac(Le,$t),Wi=new p.$S$b(Le),wi=new v.$z_b(Le,We),qi=new y.$2$b(Le);return D.$R$b.register(ht),function(ze,Gt,Xt){const mt=function(){let $e=!ze.isUnderDevelopment;function Se(){$e||(We.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),$e=!0)}return function Ne(nt){if(Array.isArray(nt))nt.forEach(Ne);else if(typeof nt=="string")Se();else{const yt=nt;typeof yt.scheme>"u"&&Se(),typeof yt.exclusive=="boolean"&&(0,Oe.$wF)(ze,"documentFiltersExclusive")}return nt}}(),rn={getSession($e,Se,Ne){return ei.getSession(ze,$e,Se,Ne)},getSessions($e,Se){return(0,Oe.$wF)(ze,"authGetSessions"),ei.getSessions(ze,$e,Se)},async hasSession($e,Se){return(0,Oe.$wF)(ze,"authSession"),!!await ei.getSession(ze,$e,Se,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider($e,Se,Ne,nt){return ei.registerAuthenticationProvider($e,Se,Ne,nt)}},Vt={registerCommand($e,Se,Ne){return ht.registerCommand(!0,$e,Se,Ne,void 0,ze)},registerTextEditorCommand($e,Se,Ne){return ht.registerCommand(!0,$e,(...nt)=>{const yt=Rt.getActiveTextEditor();if(!yt){We.warn("Cannot execute "+$e+" because there is no active text editor.");return}return yt.edit(Pt=>{Se.apply(Ne,[yt,Pt,...nt])}).then(Pt=>{Pt||We.warn("Edits from command "+$e+" were not applied.")},Pt=>{We.warn("An error occurred while running command "+$e,Pt)})},void 0,void 0,ze)},registerDiffInformationCommand:($e,Se,Ne)=>((0,Oe.$wF)(ze,"diffCommand"),ht.registerCommand(!0,$e,async(...nt)=>{const yt=$t.activeEditor(!0);if(!yt){We.warn("Cannot execute "+$e+" because there is no active text editor.");return}const Pt=await Rt.getDiffInformation(yt.id);Se.apply(Ne,[Pt,...nt])},void 0,void 0,ze)),executeCommand($e,...Se){return ht.executeCommand($e,...Se)},getCommands($e=!1){return ht.getCommands($e)}},ci={get machineId(){return dt.telemetryInfo.machineId},get sessionId(){return dt.telemetryInfo.sessionId},get language(){return dt.environment.appLanguage},get appName(){return dt.environment.appName},get appRoot(){return dt.environment.appRoot?.fsPath??""},get appHost(){return dt.environment.appHost},get uriScheme(){return dt.environment.appUriScheme},get clipboard(){return Wi.value},get shell(){return bt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Oe.$wF)(ze,"envShellEvent"),bt.onDidChangeShell},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return At.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Oe.$wF)(ze,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Oe.$wF)(ze,"telemetry"),At.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ze.$SL)(dt.telemetryInfo.firstSessionDate)},createTelemetryLogger($e,Se){return Ze.$RL.validateSender($e),At.instantiateLogger(ze,$e,Se)},openExternal($e,Se){return it.openUri($e,{allowTunneling:!!dt.remote.authority,allowContributedOpeners:Se?.allowContributedOpeners})},async asExternalUri($e){if($e.scheme===dt.environment.appUriScheme)return di.createAppUri($e);try{return await it.asExternalUri($e,{allowTunneling:!!dt.remote.authority})}catch(Se){if((0,Be.$6Y)($e,ke.Schemas.http)||(0,Be.$6Y)($e,ke.Schemas.https))return $e;throw Se}},get remoteName(){return(0,de.$Ak)(dt.remote.authority)},get remoteAuthority(){return(0,Oe.$wF)(ze,"resolvers"),dt.remote.authority},get uiKind(){return dt.uiKind},get logLevel(){return We.getLevel()},get onDidChangeLogLevel(){return We.onDidChangeLogLevel},registerIssueUriRequestHandler($e){return(0,Oe.$wF)(ze,"handleIssueUri"),nn.registerIssueUriRequestHandler(ze,$e)},get appQuality(){return(0,Oe.$wF)(ze,"resolvers"),dt.quality},get appCommit(){return(0,Oe.$wF)(ze,"resolvers"),dt.commit}};dt.environment.extensionTestsLocationURI||Object.freeze(ci);const Vi={createTestController($e,Se,Ne){return oi.createTestController(ze,$e,Se,Ne)},createTestObserver(){return(0,Oe.$wF)(ze,"testObserver"),oi.createTestObserver()},runTests($e){return(0,Oe.$wF)(ze,"testObserver"),oi.runTests($e)},get onDidChangeTestResults(){return(0,Oe.$wF)(ze,"testObserver"),oi.onResultsChanged},get testResults(){return(0,Oe.$wF)(ze,"testObserver"),oi.results}},ui=dt.remote.isRemote?H.ExtensionKind.Workspace:H.ExtensionKind.UI,Ji={getExtension($e,Se){(0,Oe.$vF)(ze,"extensionsAny")||(Se=!1);const Ne=Gt.mine.getExtensionDescription($e);if(Ne)return new t.$u_b(St,ze.identifier,Ne,ui,!1);if(Se){const nt=Gt.all.getExtensionDescription($e);if(nt)return new t.$u_b(St,ze.identifier,nt,ui,!0)}},get all(){const $e=[];for(const Se of Gt.mine.getAllExtensionDescriptions())$e.push(new t.$u_b(St,ze.identifier,Se,ui,!1));return $e},get allAcrossExtensionHosts(){(0,Oe.$wF)(ze,"extensionsAny");const $e=new ce.$Gl(Gt.mine.getAllExtensionDescriptions().map(Ne=>Ne.identifier)),Se=[];for(const Ne of Gt.all.getAllExtensionDescriptions()){const nt=!$e.has(Ne.identifier);Se.push(new t.$u_b(St,ze.identifier,Ne,ui,nt))}return Se},get onDidChange(){return(0,Oe.$vF)(ze,"extensionsAny")?h.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},Hi={createDiagnosticCollection($e){return ri.createDiagnosticCollection(ze.identifier,$e)},get onDidChangeDiagnostics(){return ri.onDidChangeDiagnostics},getDiagnostics:$e=>ri.getDiagnostics($e),getLanguages(){return si.getLanguages()},setTextDocumentLanguage($e,Se){return si.changeLanguage($e.uri,Se)},match($e,Se){const Ne=It.getDocumentData(Se.uri)?.notebook;return(0,R.$VE)(Y.LanguageSelector.from($e),Se.uri,Se.languageId,!0,Ne?.uri,Ne?.notebookType)},registerCodeActionsProvider($e,Se,Ne){return ut.registerCodeActionProvider(ze,mt($e),Se,Ne)},registerDocumentPasteEditProvider($e,Se,Ne){return(0,Oe.$wF)(ze,"documentPaste"),ut.registerDocumentPasteEditProvider(ze,mt($e),Se,Ne)},registerCodeLensProvider($e,Se){return ut.registerCodeLensProvider(ze,mt($e),Se)},registerDefinitionProvider($e,Se){return ut.registerDefinitionProvider(ze,mt($e),Se)},registerDeclarationProvider($e,Se){return ut.registerDeclarationProvider(ze,mt($e),Se)},registerImplementationProvider($e,Se){return ut.registerImplementationProvider(ze,mt($e),Se)},registerTypeDefinitionProvider($e,Se){return ut.registerTypeDefinitionProvider(ze,mt($e),Se)},registerHoverProvider($e,Se){return ut.registerHoverProvider(ze,mt($e),Se,ze.identifier)},registerEvaluatableExpressionProvider($e,Se){return ut.registerEvaluatableExpressionProvider(ze,mt($e),Se,ze.identifier)},registerInlineValuesProvider($e,Se){return ut.registerInlineValuesProvider(ze,mt($e),Se,ze.identifier)},registerDocumentHighlightProvider($e,Se){return ut.registerDocumentHighlightProvider(ze,mt($e),Se)},registerLinkedEditingRangeProvider($e,Se){return ut.registerLinkedEditingRangeProvider(ze,mt($e),Se)},registerReferenceProvider($e,Se){return ut.registerReferenceProvider(ze,mt($e),Se)},registerRenameProvider($e,Se){return ut.registerRenameProvider(ze,mt($e),Se)},registerDocumentSymbolProvider($e,Se,Ne){return ut.registerDocumentSymbolProvider(ze,mt($e),Se,Ne)},registerWorkspaceSymbolProvider($e){return ut.registerWorkspaceSymbolProvider(ze,$e)},registerDocumentFormattingEditProvider($e,Se){return ut.registerDocumentFormattingEditProvider(ze,mt($e),Se)},registerDocumentRangeFormattingEditProvider($e,Se){return ut.registerDocumentRangeFormattingEditProvider(ze,mt($e),Se)},registerOnTypeFormattingEditProvider($e,Se,Ne,...nt){return ut.registerOnTypeFormattingEditProvider(ze,mt($e),Se,[Ne].concat(nt))},registerDocumentSemanticTokensProvider($e,Se,Ne){return ut.registerDocumentSemanticTokensProvider(ze,mt($e),Se,Ne)},registerDocumentRangeSemanticTokensProvider($e,Se,Ne){return ut.registerDocumentRangeSemanticTokensProvider(ze,mt($e),Se,Ne)},registerSignatureHelpProvider($e,Se,Ne,...nt){return typeof Ne=="object"?ut.registerSignatureHelpProvider(ze,mt($e),Se,Ne):ut.registerSignatureHelpProvider(ze,mt($e),Se,typeof Ne>"u"?[]:[Ne,...nt])},registerCompletionItemProvider($e,Se,...Ne){return ut.registerCompletionItemProvider(ze,mt($e),Se,Ne)},registerInlineCompletionItemProvider($e,Se,Ne){return Se.handleDidShowCompletionItem&&(0,Oe.$wF)(ze,"inlineCompletionsAdditions"),Se.handleDidPartiallyAcceptCompletionItem&&(0,Oe.$wF)(ze,"inlineCompletionsAdditions"),Ne&&(0,Oe.$wF)(ze,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(ze,mt($e),Se,Ne)},registerDocumentLinkProvider($e,Se){return ut.registerDocumentLinkProvider(ze,mt($e),Se)},registerColorProvider($e,Se){return ut.registerColorProvider(ze,mt($e),Se)},registerFoldingRangeProvider($e,Se){return ut.registerFoldingRangeProvider(ze,mt($e),Se)},registerSelectionRangeProvider($e,Se){return ut.registerSelectionRangeProvider(ze,$e,Se)},registerCallHierarchyProvider($e,Se){return ut.registerCallHierarchyProvider(ze,$e,Se)},registerTypeHierarchyProvider($e,Se){return ut.registerTypeHierarchyProvider(ze,$e,Se)},setLanguageConfiguration:($e,Se)=>ut.setLanguageConfiguration(ze,$e,Se),getTokenInformationAtPosition($e,Se){return(0,Oe.$wF)(ze,"tokenInformation"),si.tokenAtPosition($e,Se)},registerInlayHintsProvider($e,Se){return ut.registerInlayHintsProvider(ze,$e,Se)},createLanguageStatusItem($e,Se){return si.createLanguageStatusItem(ze,$e,Se)},registerDocumentDropEditProvider($e,Se,Ne){return ut.registerDocumentOnDropEditProvider(ze,$e,Se,(0,Oe.$vF)(ze,"dropMetadata")?Ne:void 0)}},sn={get activeTextEditor(){return Rt.getActiveTextEditor()},get visibleTextEditors(){return Rt.getVisibleTextEditors()},get activeTerminal(){return bt.activeTerminal},get terminals(){return bt.terminals},async showTextDocument($e,Se,Ne){const nt=await(A.URI.isUri($e)?Promise.resolve(Ti.openTextDocument($e)):Promise.resolve($e));return Rt.showTextDocument(nt,Se,Ne)},createTextEditorDecorationType($e){return Rt.createTextEditorDecorationType(ze,$e)},onDidChangeActiveTextEditor($e,Se,Ne){return Rt.onDidChangeActiveTextEditor($e,Se,Ne)},onDidChangeVisibleTextEditors($e,Se,Ne){return Rt.onDidChangeVisibleTextEditors($e,Se,Ne)},onDidChangeTextEditorSelection($e,Se,Ne){return Rt.onDidChangeTextEditorSelection($e,Se,Ne)},onDidChangeTextEditorOptions($e,Se,Ne){return Rt.onDidChangeTextEditorOptions($e,Se,Ne)},onDidChangeTextEditorVisibleRanges($e,Se,Ne){return Rt.onDidChangeTextEditorVisibleRanges($e,Se,Ne)},onDidChangeTextEditorViewColumn($e,Se,Ne){return Rt.onDidChangeTextEditorViewColumn($e,Se,Ne)},onDidCloseTerminal($e,Se,Ne){return bt.onDidCloseTerminal($e,Se,Ne)},onDidOpenTerminal($e,Se,Ne){return bt.onDidOpenTerminal($e,Se,Ne)},onDidChangeActiveTerminal($e,Se,Ne){return bt.onDidChangeActiveTerminal($e,Se,Ne)},onDidChangeTerminalDimensions($e,Se,Ne){return(0,Oe.$wF)(ze,"terminalDimensions"),bt.onDidChangeTerminalDimensions($e,Se,Ne)},onDidChangeTerminalState($e,Se,Ne){return bt.onDidChangeTerminalState($e,Se,Ne)},onDidWriteTerminalData($e,Se,Ne){return(0,Oe.$wF)(ze,"terminalDataWriteEvent"),bt.onDidWriteTerminalData($e,Se,Ne)},get state(){return it.getState(ze)},onDidChangeWindowState($e,Se,Ne){return it.onDidChangeWindowState($e,Se,Ne)},showInformationMessage($e,...Se){return wi.showMessage(ze,L.default.Info,$e,Se[0],Se.slice(1))},showWarningMessage($e,...Se){return wi.showMessage(ze,L.default.Warning,$e,Se[0],Se.slice(1))},showErrorMessage($e,...Se){return wi.showMessage(ze,L.default.Error,$e,Se[0],Se.slice(1))},showQuickPick($e,Se,Ne){return _t.showQuickPick(ze,$e,Se,Ne)},showWorkspaceFolderPick($e){return _t.showWorkspaceFolderPick($e)},showInputBox($e,Se){return _t.showInput($e,Se)},showOpenDialog($e){return qi.showOpenDialog(ze,$e)},showSaveDialog($e){return qi.showSaveDialog($e)},createStatusBarItem($e,Se,Ne){let nt,yt,Pt;return typeof $e=="string"?(nt=$e,yt=Se,Pt=Ne):(yt=$e,Pt=Se),Ri.createStatusBarEntry(ze,nt,yt,Pt)},setStatusBarMessage($e,Se){return Ri.setStatusBarMessage($e,Se)},withScmProgress($e){return He.report("window.withScmProgress",ze,"Use 'withProgress' instead."),$i.withProgress(ze,{location:H.ProgressLocation.SourceControl},(Se,Ne)=>$e({report(nt){}}))},withProgress($e,Se){return $i.withProgress(ze,$e,Se)},createOutputChannel($e,Se){return Qi.createOutputChannel($e,Se,ze)},createWebviewPanel($e,Se,Ne,nt){return pi.createWebviewPanel(ze,$e,Se,Ne,nt)},createWebviewTextEditorInset($e,Se,Ne,nt){return(0,Oe.$wF)(ze,"editorInsets"),ki.createWebviewEditorInset($e,Se,Ne,nt,ze)},createTerminal($e,Se,Ne){return typeof $e=="object"?"pty"in $e?bt.createExtensionTerminal($e):bt.createTerminalFromOptions($e):bt.createTerminal($e,Se,Ne)},registerTerminalLinkProvider($e){return bt.registerLinkProvider($e)},registerTerminalProfileProvider($e,Se){return bt.registerProfileProvider(ze,$e,Se)},registerTerminalQuickFixProvider($e,Se){return(0,Oe.$wF)(ze,"terminalQuickFixProvider"),bt.registerTerminalQuickFixProvider($e,ze.identifier.value,Se)},registerTreeDataProvider($e,Se){return mi.registerTreeDataProvider($e,Se,ze)},createTreeView($e,Se){return mi.createTreeView($e,Se,ze)},registerWebviewPanelSerializer:($e,Se)=>pi.registerWebviewPanelSerializer(ze,$e,Se),registerCustomEditorProvider:($e,Se,Ne={})=>Ui.registerCustomEditorProvider(ze,$e,Se,Ne),registerFileDecorationProvider($e){return pt.registerFileDecorationProvider($e,ze)},registerUriHandler($e){return di.registerUriHandler(ze,$e)},createQuickPick(){return _t.createQuickPick(ze)},createInputBox(){return _t.createInputBox(ze)},get activeColorTheme(){return Pi.activeColorTheme},onDidChangeActiveColorTheme($e,Se,Ne){return Pi.onDidChangeActiveColorTheme($e,Se,Ne)},registerWebviewViewProvider($e,Se,Ne){return ji.registerWebviewViewProvider(ze,$e,Se,Ne?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor($e,Se,Ne){return kt.onDidChangeActiveNotebookEditor($e,Se,Ne)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection($e,Se,Ne){return fi.onDidChangeNotebookEditorSelection($e,Se,Ne)},onDidChangeNotebookEditorVisibleRanges($e,Se,Ne){return fi.onDidChangeNotebookEditorVisibleRanges($e,Se,Ne)},showNotebookDocument($e,Se){return kt.showNotebookDocument($e,Se)},registerExternalUriOpener($e,Se,Ne){return(0,Oe.$wF)(ze,"externalUriOpener"),_i.registerExternalUriOpener(ze.identifier,$e,Se,Ne)},registerProfileContentHandler($e,Se){return(0,Oe.$wF)(ze,"profileContentHandlers"),en.registrProfileContentHandler(ze,$e,Se)},registerQuickDiffProvider($e,Se,Ne,nt){return(0,Oe.$wF)(ze,"quickDiffProvider"),zi.registerQuickDiffProvider(mt($e),Se,Ne,nt)},get tabGroups(){return Dt.tabGroups},registerShareProvider($e,Se){return(0,Oe.$wF)(ze,"shareProvider"),Di.registerShareProvider(mt($e),Se)}},Ti={get rootPath(){return He.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ct.getPath()},set rootPath($e){throw F.$7()},getWorkspaceFolder($e){return ct.getWorkspaceFolder($e)},get workspaceFolders(){return ct.getWorkspaceFolders()},get name(){return ct.name},set name($e){throw F.$7()},get workspaceFile(){return ct.workspaceFile},set workspaceFile($e){throw F.$7()},updateWorkspaceFolders:($e,Se,...Ne)=>ct.updateWorkspaceFolders(ze,$e,Se||0,...Ne),onDidChangeWorkspaceFolders:function($e,Se,Ne){return ct.onDidChangeWorkspace($e,Se,Ne)},asRelativePath:($e,Se)=>ct.getRelativePath($e,Se),findFiles:($e,Se,Ne,nt)=>ct.findFiles($e,Se,Ne,ze.identifier,nt),findTextInFiles:($e,Se,Ne,nt)=>{(0,Oe.$wF)(ze,"findTextInFiles");let yt,Pt;return typeof Se=="object"?(yt=Se,Pt=Ne):(yt={},Pt=Se,nt=Ne),ct.findTextInFiles($e,yt||{},Pt,ze.identifier,nt)},save:$e=>((0,Oe.$wF)(ze,"saveEditor"),ct.save($e)),saveAs:$e=>((0,Oe.$wF)(ze,"saveEditor"),ct.saveAs($e)),saveAll:$e=>ct.saveAll($e),applyEdit($e,Se){return Bi.applyWorkspaceEdit($e,ze,Se)},createFileSystemWatcher:($e,Se,Ne,nt)=>Kt.createFileSystemWatcher(ct,ze,$e,Se,Ne,nt),get textDocuments(){return It.getAllDocumentData().map($e=>$e.document)},set textDocuments($e){throw F.$7()},openTextDocument($e){let Se;const Ne=$e;if(typeof $e=="string")Se=Promise.resolve(A.URI.file($e));else if(A.URI.isUri($e))Se=Promise.resolve($e);else if(!Ne||typeof Ne=="object")Se=It.createDocumentData(Ne);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Se.then(nt=>It.ensureDocumentData(nt).then(yt=>yt.document))},onDidOpenTextDocument:($e,Se,Ne)=>It.onDidAddDocument($e,Se,Ne),onDidCloseTextDocument:($e,Se,Ne)=>It.onDidRemoveDocument($e,Se,Ne),onDidChangeTextDocument:($e,Se,Ne)=>It.onDidChangeDocument($e,Se,Ne),onDidSaveTextDocument:($e,Se,Ne)=>It.onDidSaveDocument($e,Se,Ne),onWillSaveTextDocument:($e,Se,Ne)=>Ht.getOnWillSaveTextDocumentEvent(ze)($e,Se,Ne),get notebookDocuments(){return kt.notebookDocuments.map($e=>$e.apiNotebook)},async openNotebookDocument($e,Se){let Ne;if(A.URI.isUri($e))Ne=$e,await kt.openNotebookDocument($e);else if(typeof $e=="string")Ne=A.URI.revive(await kt.createNotebookDocument({viewType:$e,content:Se}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Ne).apiNotebook},onDidSaveNotebookDocument($e,Se,Ne){return Ei.onDidSaveNotebookDocument($e,Se,Ne)},onDidChangeNotebookDocument($e,Se,Ne){return Ei.onDidChangeNotebookDocument($e,Se,Ne)},onWillSaveNotebookDocument($e,Se,Ne){return ni.getOnWillSaveNotebookDocumentEvent(ze)($e,Se,Ne)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer($e,Se,Ne,nt){return kt.registerNotebookSerializer(ze,$e,Se,Ne,(0,Oe.$vF)(ze,"notebookLiveShare")?nt:void 0)},onDidChangeConfiguration:($e,Se,Ne)=>Xt.onDidChangeConfiguration($e,Se,Ne),getConfiguration($e,Se){return Se=arguments.length===1?void 0:Se,Xt.getConfiguration($e,Se,ze)},registerTextDocumentContentProvider($e,Se){return yi.registerTextDocumentContentProvider($e,Se)},registerTaskProvider:($e,Se)=>(He.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),qt.registerTaskProvider(ze,$e,Se)),registerFileSystemProvider($e,Se,Ne){return(0,je.$ib)(Si.registerFileSystemProvider(ze,$e,Se,Ne),Ot.addFileSystemProvider($e,Se,Ne))},get fs(){return Ot.value},registerFileSearchProvider:($e,Se)=>((0,Oe.$wF)(ze,"fileSearchProvider"),Zt.registerFileSearchProvider($e,Se)),registerTextSearchProvider:($e,Se)=>((0,Oe.$wF)(ze,"textSearchProvider"),Zt.registerTextSearchProvider($e,Se)),registerRemoteAuthorityResolver:($e,Se)=>((0,Oe.$wF)(ze,"resolvers"),St.registerRemoteAuthorityResolver($e,Se)),registerResourceLabelFormatter:$e=>((0,Oe.$wF)(ze,"resolvers"),Ii.$registerResourceLabelFormatter($e)),getRemoteExecServer:$e=>((0,Oe.$wF)(ze,"resolvers"),St.getRemoteExecServer($e)),onDidCreateFiles:($e,Se,Ne)=>Kt.onDidCreateFile($e,Se,Ne),onDidDeleteFiles:($e,Se,Ne)=>Kt.onDidDeleteFile($e,Se,Ne),onDidRenameFiles:($e,Se,Ne)=>Kt.onDidRenameFile($e,Se,Ne),onWillCreateFiles:($e,Se,Ne)=>Kt.getOnWillCreateFileEvent(ze)($e,Se,Ne),onWillDeleteFiles:($e,Se,Ne)=>Kt.getOnWillDeleteFileEvent(ze)($e,Se,Ne),onWillRenameFiles:($e,Se,Ne)=>Kt.getOnWillRenameFileEvent(ze)($e,Se,Ne),openTunnel:$e=>((0,Oe.$wF)(ze,"tunnels"),Xe.openTunnel(ze,$e).then(Se=>{if(!Se)throw new Error("cannot open tunnel");return Se})),get tunnels(){return(0,Oe.$wF)(ze,"tunnels"),Xe.getTunnels()},onDidChangeTunnels:($e,Se,Ne)=>((0,Oe.$wF)(ze,"tunnels"),Xe.onDidChangeTunnels($e,Se,Ne)),registerPortAttributesProvider:($e,Se)=>((0,Oe.$wF)(ze,"portsAttributes"),Xe.registerPortsAttributesProvider($e,Se)),registerTunnelProvider:($e,Se)=>((0,Oe.$wF)(ze,"tunnelFactory"),Xe.registerTunnelProvider($e,Se)),registerTimelineProvider:($e,Se)=>((0,Oe.$wF)(ze,"timeline"),Ai.registerTimelineProvider($e,Se,ze.identifier,ht.converter)),get isTrusted(){return ct.trusted},requestWorkspaceTrust:$e=>((0,Oe.$wF)(ze,"workspaceTrust"),ct.requestWorkspaceTrust($e)),onDidGrantWorkspaceTrust:($e,Se,Ne)=>ct.onDidGrantWorkspaceTrust($e,Se,Ne),registerEditSessionIdentityProvider:($e,Se)=>((0,Oe.$wF)(ze,"editSessionIdentityProvider"),ct.registerEditSessionIdentityProvider($e,Se)),onWillCreateEditSessionIdentity:($e,Se,Ne)=>((0,Oe.$wF)(ze,"editSessionIdentityProvider"),ct.getOnWillCreateEditSessionIdentityEvent(ze)($e,Se,Ne)),registerCanonicalUriProvider:($e,Se)=>((0,Oe.$wF)(ze,"canonicalUriProvider"),ct.registerCanonicalUriProvider($e,Se)),getCanonicalUri:($e,Se,Ne)=>((0,Oe.$wF)(ze,"canonicalUriProvider"),ct.provideCanonicalUri($e,Se,Ne))},Ki={get inputBox(){return He.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),gi.getLastInputBox(ze)},createSourceControl($e,Se,Ne){return gi.createSourceControl(ze,$e,Se,Ne)}},on={createCommentController($e,Se){return Ci.createCommentController(ze,$e,Se)}},an={get activeDebugSession(){return gt.activeDebugSession},get activeDebugConsole(){return gt.activeDebugConsole},get breakpoints(){return gt.breakpoints},get stackFrameFocus(){return gt.stackFrameFocus},onDidStartDebugSession($e,Se,Ne){return gt.onDidStartDebugSession($e,Se,Ne)},onDidTerminateDebugSession($e,Se,Ne){return gt.onDidTerminateDebugSession($e,Se,Ne)},onDidChangeActiveDebugSession($e,Se,Ne){return gt.onDidChangeActiveDebugSession($e,Se,Ne)},onDidReceiveDebugSessionCustomEvent($e,Se,Ne){return gt.onDidReceiveDebugSessionCustomEvent($e,Se,Ne)},onDidChangeBreakpoints($e,Se,Ne){return gt.onDidChangeBreakpoints($e,Se,Ne)},onDidChangeStackFrameFocus($e,Se,Ne){return(0,Oe.$wF)(ze,"debugFocus"),gt.onDidChangeStackFrameFocus($e,Se,Ne)},registerDebugConfigurationProvider($e,Se,Ne){return gt.registerDebugConfigurationProvider($e,Se,Ne||Ye.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory($e,Se){return gt.registerDebugAdapterDescriptorFactory(ze,$e,Se)},registerDebugAdapterTrackerFactory($e,Se){return gt.registerDebugAdapterTrackerFactory($e,Se)},startDebugging($e,Se,Ne){return!Ne||typeof Ne=="object"&&"configuration"in Ne?gt.startDebugging($e,Se,{parentSession:Ne}):gt.startDebugging($e,Se,Ne||{})},stopDebugging($e){return gt.stopDebugging($e)},addBreakpoints($e){return gt.addBreakpoints($e)},removeBreakpoints($e){return gt.removeBreakpoints($e)},asDebugSourceUri($e,Se){return gt.asDebugSourceUri($e,Se)}},Mi={registerTaskProvider:($e,Se)=>qt.registerTaskProvider(ze,$e,Se),fetchTasks:$e=>qt.fetchTasks($e),executeTask:$e=>qt.executeTask(ze,$e),get taskExecutions(){return qt.taskExecutions},onDidStartTask:($e,Se,Ne)=>qt.onDidStartTask($e,Se,Ne),onDidEndTask:($e,Se,Ne)=>qt.onDidEndTask($e,Se,Ne),onDidStartTaskProcess:($e,Se,Ne)=>qt.onDidStartTaskProcess($e,Se,Ne),onDidEndTaskProcess:($e,Se,Ne)=>qt.onDidEndTaskProcess($e,Se,Ne)},Gi={createNotebookController($e,Se,Ne,nt,yt){return ai.createNotebookController(ze,$e,Se,Ne,nt,(0,Oe.$vF)(ze,"notebookMessaging")?yt:void 0)},registerNotebookCellStatusBarItemProvider:($e,Se)=>kt.registerNotebookCellStatusBarItemProvider(ze,$e,Se),createRendererMessaging($e){return xi.createRendererMessaging(ze,$e)},createNotebookControllerDetectionTask($e){return(0,Oe.$wF)(ze,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(ze,$e)},registerKernelSourceActionProvider($e,Se){return(0,Oe.$wF)(ze,"notebookKernelSource"),ai.registerKernelSourceActionProvider(ze,$e,Se)},onDidChangeNotebookCellExecutionState($e,Se,Ne){return(0,Oe.$wF)(ze,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState($e,Se,Ne)}},Xi={t(...$e){if(typeof $e[0]=="string"){const Se=$e.shift(),Ne=!$e||typeof $e[0]!="object"?$e:$e[0];return hi.getMessage(ze.identifier.value,{message:Se,args:Ne})}return hi.getMessage(ze.identifier.value,$e[0])},get bundle(){return hi.getBundle(ze.identifier.value)},get uri(){return hi.getBundleUri(ze.identifier.value)}},Yi={_version:1,registerInteractiveEditorSessionProvider($e){return(0,Oe.$wF)(ze,"interactive"),Li.registerProvider(ze,$e)},registerInteractiveSessionProvider($e,Se){return(0,Oe.$wF)(ze,"interactive"),Qt.registerChatProvider(ze,$e,Se)},addInteractiveRequest($e){return(0,Oe.$wF)(ze,"interactive"),Qt.addChatRequest($e)},sendInteractiveRequestToProvider($e,Se){return(0,Oe.$wF)(ze,"interactive"),Qt.sendInteractiveRequestToProvider($e,Se)},get onDidPerformUserAction(){return(0,Oe.$wF)(ze,"interactiveUserActions"),Qt.onDidPerformUserAction},transferChatSession($e,Se){return(0,Oe.$wF)(ze,"interactive"),Qt.transferChatSession($e,Se)}},cn={registerSlashCommandProvider($e,Se){return(0,Oe.$wF)(ze,"interactiveSlashCommands"),Qt.registerSlashCommandProvider(ze,$e,Se)}},un={registerSemanticSimilarityProvider($e){return(0,Oe.$wF)(ze,"semanticSimilarity"),tn.registerSemanticSimilarityProvider(ze,$e)}};return{version:dt.version,ai:un,authentication:rn,commands:Vt,comments:on,debug:an,env:ci,extensions:Ji,interactive:Yi,interactiveSlashCommands:cn,l10n:Xi,languages:Hi,notebooks:Gi,scm:Ki,tasks:Mi,tests:Vi,window:sn,workspace:Ti,Breakpoint:H.$yK,TerminalOutputAnchor:H.TerminalOutputAnchor,CallHierarchyIncomingCall:H.$XJ,CallHierarchyItem:H.$WJ,CallHierarchyOutgoingCall:H.$YJ,CancellationError:F.$3,CancellationTokenSource:k.$dd,CandidatePortSource:$.CandidatePortSource,CodeAction:H.$SJ,CodeActionKind:H.$TJ,CodeActionTriggerKind:H.CodeActionTriggerKind,CodeLens:H.$ZJ,Color:H.$aK,ColorInformation:H.$bK,ColorPresentation:H.$cK,ColorThemeKind:H.ColorThemeKind,CommentMode:H.CommentMode,CommentState:H.CommentState,CommentThreadCollapsibleState:H.CommentThreadCollapsibleState,CommentThreadState:H.CommentThreadState,CompletionItem:H.$7J,CompletionItemKind:H.CompletionItemKind,CompletionItemTag:H.CompletionItemTag,CompletionList:H.$8J,CompletionTriggerKind:H.CompletionTriggerKind,ConfigurationTarget:H.ConfigurationTarget,CustomExecution:H.$kK,DebugAdapterExecutable:H.$CK,DebugAdapterInlineImplementation:H.$FK,DebugAdapterNamedPipeServer:H.$EK,DebugAdapterServer:H.$DK,DebugConfigurationProviderTriggerKind:Ye.DebugConfigurationProviderTriggerKind,DebugConsoleMode:H.DebugConsoleMode,DecorationRangeBehavior:H.DecorationRangeBehavior,Diagnostic:H.$NJ,DiagnosticRelatedInformation:H.$MJ,DiagnosticSeverity:H.DiagnosticSeverity,DiagnosticTag:H.DiagnosticTag,Disposable:H.$zJ,DocumentHighlight:H.$PJ,DocumentHighlightKind:H.DocumentHighlightKind,DocumentLink:H.$_J,DocumentSymbol:H.$RJ,EndOfLine:H.EndOfLine,EnvironmentVariableMutatorType:H.EnvironmentVariableMutatorType,EvaluatableExpression:H.$IK,InlineValueText:H.$JK,InlineValueVariableLookup:H.$KK,InlineValueEvaluatableExpression:H.$LK,InlineCompletionTriggerKind:H.InlineCompletionTriggerKind,EventEmitter:h.$7c,ExtensionKind:H.ExtensionKind,ExtensionMode:H.ExtensionMode,ExternalUriOpenerPriority:H.ExternalUriOpenerPriority,FileChangeType:H.FileChangeType,FileDecoration:H.$VK,FileDecoration2:H.$VK,FileSystemError:H.$NK,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:H.$OK,FoldingRangeKind:H.FoldingRangeKind,FunctionBreakpoint:H.$AK,InlineCompletionItem:H.$9J,InlineCompletionList:H.$0J,Hover:H.$OJ,IndentAction:b.IndentAction,Location:H.$LJ,MarkdownString:H.$1J,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:H.$2J,PortAutoForwardAction:H.PortAutoForwardAction,Position:H.$AJ,ProcessExecution:H.$iK,ProgressLocation:H.ProgressLocation,QuickInputButtons:H.$UK,Range:H.$BJ,RelativePattern:H.$wK,Selection:H.$CJ,SelectionRange:H.$VJ,SemanticTokens:H.$RK,SemanticTokensBuilder:H.$QK,SemanticTokensEdit:H.$SK,SemanticTokensEdits:H.$TK,SemanticTokensLegend:H.$PK,ShellExecution:H.$jK,ShellQuoting:H.ShellQuoting,SignatureHelp:H.$4J,SignatureHelpTriggerKind:H.SignatureHelpTriggerKind,SignatureInformation:H.$3J,SnippetString:H.$KJ,SourceBreakpoint:H.$zK,StandardTokenType:H.StandardTokenType,StatusBarAlignment:H.StatusBarAlignment,SymbolInformation:H.$QJ,SymbolKind:H.SymbolKind,SymbolTag:H.SymbolTag,Task:H.$lK,TaskGroup:H.$hK,TaskPanelKind:H.TaskPanelKind,TaskRevealKind:H.TaskRevealKind,TaskScope:H.TaskScope,TerminalLink:H.$dK,TerminalQuickFixCommand:H.$fK,TerminalQuickFixOpener:H.$eK,TerminalLocation:H.TerminalLocation,TerminalProfile:H.$gK,TerminalExitReason:H.TerminalExitReason,TerminalQuickFixType:H.TerminalQuickFixType,TextDocumentSaveReason:H.TextDocumentSaveReason,TextEdit:H.$GJ,SnippetTextEdit:H.$IJ,TextEditorCursorStyle:m.TextEditorCursorStyle,TextEditorLineNumbersStyle:H.TextEditorLineNumbersStyle,TextEditorRevealType:H.TextEditorRevealType,TextEditorSelectionChangeKind:H.TextEditorSelectionChangeKind,TextDocumentChangeReason:H.TextDocumentChangeReason,ThemeColor:H.$vK,ThemeIcon:H.$uK,TreeItem:H.$mK,TreeItemCheckboxState:H.TreeItemCheckboxState,TreeItemCollapsibleState:H.TreeItemCollapsibleState,TypeHierarchyItem:H.$fL,UIKind:S.UIKind,Uri:A.URI,ViewColumn:H.ViewColumn,WorkspaceEdit:H.$JJ,DocumentDropEdit:H.$sK,DocumentPasteEdit:H.$tK,InlayHint:H.$6J,InlayHintLabelPart:H.$5J,InlayHintKind:H.InlayHintKind,RemoteAuthorityResolverError:H.$FJ,ResolvedAuthority:H.$DJ,ManagedResolvedAuthority:H.$EJ,SourceControlInputBoxValidationType:H.SourceControlInputBoxValidationType,ExtensionRuntime:H.ExtensionRuntime,TimelineItem:H.$6K,NotebookRange:H.$XK,NotebookCellKind:H.NotebookCellKind,NotebookCellExecutionState:H.NotebookCellExecutionState,NotebookCellData:H.$YK,NotebookData:H.$ZK,NotebookRendererScript:H.$4K,NotebookCellStatusBarAlignment:H.NotebookCellStatusBarAlignment,NotebookEditorRevealType:H.NotebookEditorRevealType,NotebookCellOutput:H.$2K,NotebookCellOutputItem:H.$1K,NotebookCellStatusBarItem:H.$3K,NotebookControllerAffinity:H.NotebookControllerAffinity,NotebookControllerAffinity2:H.NotebookControllerAffinity2,NotebookEdit:H.$HJ,NotebookKernelSourceAction:H.$5K,PortAttributes:H.$8K,LinkedEditingRanges:H.$7K,TestResultState:H.TestResultState,TestRunRequest:H.$9K,TestRunRequest2:H.$0K,TestMessage:H.$$K,TestTag:H.$_K,TestRunProfileKind:H.TestRunProfileKind,TextSearchCompleteMessageType:tt.TextSearchCompleteMessageType,DataTransfer:H.$rK,DataTransferItem:H.$nK,CoveredCount:H.$aL,FileCoverage:H.$bL,StatementCoverage:H.$cL,BranchCoverage:H.$dL,FunctionCoverage:H.$eL,WorkspaceTrustState:H.WorkspaceTrustState,LanguageStatusSeverity:H.LanguageStatusSeverity,QuickPickItemKind:H.QuickPickItemKind,InputBoxValidationSeverity:H.InputBoxValidationSeverity,TabInputText:H.$gL,TabInputTextDiff:H.$hL,TabInputTextMerge:H.$iL,TabInputCustom:H.$jL,TabInputNotebook:H.$lL,TabInputNotebookDiff:H.$mL,TabInputWebview:H.$kL,TabInputTerminal:H.$nL,TabInputInteractiveWindow:H.$oL,TelemetryTrustedValue:ge.$Zn,LogLevel:ne.LogLevel,EditSessionIdentityMatch:rt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:H.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:H.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:H.InteractiveEditorResponseFeedbackKind,StackFrameFocus:H.$GK,ThreadFocus:H.$HK,NotebookCodeActionKind:H.$UJ}}}e.$Jac=Nt}),define(De[337],Ce([1,0,98,145,37,142,38,36,61,43,88,90,91,109,64,84,144,63,51,108,83,62,143,18,52,106,107]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y,C,i,a,n,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.$0q)(t.$o_b,t.$n_b,1),(0,k.$0q)(a.$Qi,i.$Kac,1),(0,k.$0q)(p.$N$b,p.$O$b,1),(0,k.$0q)(m.$VL,m.$UL,0),(0,k.$0q)(A.$1$b,A.$Y$b,0),(0,k.$0q)(s.$d_b,s.$c_b,0),(0,k.$0q)(I.$4_b,I.$8_b,0),(0,k.$0q)(L.$V_b,L.$U_b,0),(0,k.$0q)(E.$KL,E.$JL,0),(0,k.$0q)(o.$p_b,o.$q_b,0),(0,k.$0q)(c.$K$b,c.$J$b,0),(0,k.$0q)(F.$B_b,F.$A_b,1),(0,k.$0q)($.$bac,$.$cac,0),(0,k.$0q)(S.$_$b,S.$$$b,0),(0,k.$0q)(R.$Y_b,R.$X_b,0),(0,k.$0q)(b.$g_b,b.$j_b,0),(0,k.$0q)(D.$Tpb,D.$Upb,0),(0,k.$0q)(r.$R_b,r.$Q_b,0),(0,k.$0q)(h.$X$b,h.$W$b,0),(0,k.$0q)(f.$l_b,f.$k_b,0),(0,k.$0q)(y.$TL,y.$QL,0),(0,k.$0q)(C.$Z_b,C.$1_b,0),(0,k.$0q)(n.$2_b,n.$3_b,0)}),define(De[110],Ce([1,0,19,18,35,87]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ac=e.$2ac=e.$1ac=void 0;function A(I){return I.startsWith("**")||I.startsWith("/")?I:`/${I}`}e.$1ac=A;function m(I,$,S,D){const p=(0,k.$Hf)(S,E),r=new h.$ZH($,p,D),s=r.preview.matches;return{ranges:(0,k.$Hf)(p,b),uri:I,preview:{text:r.preview.text,matches:(0,k.$Hf)(s,b)}}}e.$2ac=m;function E(I){return new h.$1H(I.start.line,I.start.character,I.end.line,I.end.character)}function b(I){return new L.$PH(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn)}let R=class{constructor($,S){this.a=$,this.b=S}appendLine($){this.b.debug(`${this.a}#search`,$)}};e.$3ac=R,e.$3ac=R=Je([qe(1,F.$Pi)],R)}),define(De[338],Ce([1,0,46,13,69,31,11,12,110,339]),function(me,e,k,F,h,L,A,m,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ac=e.$5ac=e.$4ac=void 0;const R=b.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function I(f,y,C,i){const a=$(f,y,C,i),n=y.folder.fsPath;return{cmd:k.spawn(R,a.args,{cwd:n}),rgDiskPath:R,siblingClauses:a.siblingClauses,rgArgs:a,cwd:n}}e.$4ac=I;function $(f,y,C,i){const a=["--files","--hidden","--case-sensitive","--no-require-git"];D([y],C,!1).forEach(t=>{const o=(0,E.$1ac)(t);if(a.push("-g",o),A.$j){const g=(0,h.$6k)(o);g!==o&&a.push("-g",g)}});const n=S([y],i,void 0,!1);return n.globArgs.forEach(t=>{const o=`!${(0,E.$1ac)(t)}`;if(a.push("-g",o),A.$j){const g=(0,h.$6k)(o);g!==o&&a.push("-g",g)}}),y.disregardIgnoreFiles!==!1?a.push("--no-ignore"):y.disregardParentIgnoreFiles!==!1&&a.push("--no-ignore-parent"),y.ignoreSymlinks||a.push("--follow"),f.exists&&a.push("--quiet"),a.push("--no-config"),y.disregardGlobalIgnoreFiles&&a.push("--no-ignore-global"),{args:a,siblingClauses:n.siblingClauses}}function S(f,y,C,i=!0){const a=[];let n={};return f.forEach(t=>{const o=Object.assign({},t.excludePattern||{},y||{}),g=p(o,i?t.folder.fsPath:void 0,C);a.push(...g.globArgs),g.siblingClauses&&(n=Object.assign(n,g.siblingClauses))}),{globArgs:a,siblingClauses:n}}function D(f,y,C=!0){const i=[];return f.forEach(a=>{const n=Object.assign({},y||{},a.includePattern||{}),t=p(n,C?a.folder.fsPath:void 0);i.push(...t.globArgs)}),i}function p(f,y,C){const i=[],a={};return Object.keys(f).forEach(n=>{if(C&&C.has(n)||!n)return;const t=f[n];n=s(y?r(y,n):n),n.startsWith("\\\\")?n="\\\\"+n.substr(2).replace(/\\/g,"/"):n=n.replace(/\\/g,"/"),typeof t=="boolean"&&t?(n.startsWith("\\\\")&&(n+="**"),i.push(c(n))):t&&t.when&&(a[n]=t)}),{globArgs:i,siblingClauses:a}}function r(f,y){return F.$_b(y)?y:F.$ac(f,y)}e.$5ac=r;function s(f){return f=m.$sd(f,"\\"),m.$sd(f,"/")}function c(f){return L.$Fe(f).toLowerCase()==="c:/"?f.replace(/^c:[/\\]/i,"/"):f}e.$6ac=c}),define(De[340],Ce([1,0,46,49,13,341,19,45,34,69,31,11,39,12,14,29,35,338,119]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ac=e.$7ac=void 0;const f=new Set;process.on("exit",()=>{f.forEach(n=>n())});class y{constructor(t){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=t,this.b=t.filePattern||"",this.d=t.includePattern&&E.$cj(t.includePattern),this.f=t.maxResults||null,this.g=!!t.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,c.$bq)(this.b).normalizedLowercase),this.u=t.excludePattern&&E.$cj(t.excludePattern),this.t=new Map,t.folderQueries.forEach(o=>{const g=Object.assign({},o.excludePattern||{},this.a.excludePattern||{}),u=o.folder.fsPath;t.folderQueries.map(d=>d.folder.fsPath).filter(d=>d!==u).forEach(d=>{(0,R.$Je)(d,u)&&(g[h.$cc(u,d)]=!0)}),this.t.set(u,new i(g,u))})}cancel(){this.l=!0,f.forEach(t=>t())}walk(t,o,g,u,d){if(this.m=$.$3c.create(!1),this.l)return d(null,this.j);o.forEach(v=>{const l=h.$ec(v.fsPath);this.u&&this.u(v.fsPath,l)||this.J(g,{relativePath:v.fsPath,searchPath:void 0})}),this.r=$.$3c.create(!1),this.w(t,(v,l)=>{this.x(this.y,this,v,g,u,w=>{if(w){const P=(0,m.$$h)(w);console.error(P),this.q.push(P),l(w,void 0)}else l(null,void 0)})},(v,l)=>{this.m.stop();const w=v?A.$lf(v)[0]:null;d(w,this.j)})}w(t,o,g){const u=new Array(t.length),d=new Array(t.length);let v=!1,l=0;if(t.length===0)return g(null,[]);t.forEach((w,P)=>{o(w,(M,N)=>{if(M?(v=!0,u[P]=null,d[P]=M):(u[P]=N,d[P]=null),++l===t.length)return g(v?d:null,u)})})}x(t,o,...g){try{t.apply(o,g)}catch(u){g[g.length-1](u)}}y(t,o,g,u){const d=t.folder.fsPath,v=I.$j,l=()=>T&&T.kill();f.add(l);let w=Y=>{f.delete(l),w=()=>{},u(Y)},P="";const M=this.D(),N=(0,s.$4ac)(this.a,t,this.a.includePattern,this.t.get(t.folder.fsPath).expression),T=N.cmd,z=!Object.keys(N.siblingClauses).length,j=N.rgArgs.args.map(Y=>Y.match(/^-/)?Y:`'${Y}'`).join(" ");let U=`${N.rgDiskPath} ${j}
 - cwd: ${N.cwd}`;N.rgArgs.siblingClauses&&(U+=`
 - Sibling clauses: ${JSON.stringify(N.rgArgs.siblingClauses)}`),g({message:U}),this.s=0,this.z(T,"utf8",g,(Y,H,ge)=>{if(Y){w(Y);return}if(this.j){w();return}const te=(P+(v?b.$5k(H||""):H)).split(`
`);if(ge){const q=te.length;te[q-1]=te[q-1].trim(),te[q-1]||te.pop()}else P=te.pop()||"";if(te.length&&te[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=te.length,z){for(const q of te)if(this.J(o,{base:d,relativePath:q,searchPath:this.N(t,q)}),this.j){l();break}(ge||this.j)&&w();return}this.G(t,M,d,te,o),ge&&(this.H(M,d,o),w())})}spawnFindCmd(t){const o=this.t.get(t.folder.fsPath),g=o.getBasenameTerms(),u=o.getPathTerms(),d=["-L","."];if(g.length||u.length){d.push("-not","(","(");for(const v of g)d.push("-name",v),d.push("-o");for(const v of u)d.push("-path",v),d.push("-o");d.pop(),d.push(")","-prune",")")}return d.push("-type","f"),k.spawn("find",d,{cwd:t.folder.fsPath})}readStdout(t,o,g){let u="";this.z(t,o,()=>{},(d,v,l)=>{if(d){g(d);return}u+=v,l&&g(null,u)})}z(t,o,g,u){let d=(w,P,M)=>{(w||M)&&(d=()=>{},this.r?.stop()),u(w,P,M)},v=!1;t.stdout?(this.A(t.stdout,o,d),t.stdout.once("data",()=>v=!0)):g({message:"stdout is null"});let l;t.stderr?l=this.B(t.stderr):g({message:"stderr is null"}),t.on("error",w=>{d(w)}),t.on("close",w=>{let P;!v&&(P=this.C(l,o))&&a(P)?d(new Error(`command failed with error code ${w}: ${this.C(l,o)}`)):(this.g&&w===0&&(this.j=!0),d(null,"",!0))})}A(t,o,g){const u=new L.StringDecoder(o);return t.on("data",d=>{g(null,u.write(d))}),u}B(t){const o=[];return t.on("data",g=>{o.push(g)}),o}C(t,o){const g=new L.StringDecoder(o);return t.map(u=>g.write(u)).join("")}D(){const t={rootEntries:[],pathToEntries:Object.create(null)};return t.pathToEntries["."]=t.rootEntries,t}G(t,{pathToEntries:o},g,u,d){u.indexOf(this.b)!==-1&&this.J(d,{base:g,relativePath:this.b,searchPath:this.N(t,this.b)});const v=l=>{const w=h.$ec(l),P=h.$dc(l);let M=o[P];M||(M=o[P]=[],v(P)),M.push({base:g,relativePath:l,basename:w,searchPath:this.N(t,l)})};u.forEach(v)}H({rootEntries:t,pathToEntries:o},g,u){const d=this,v=this.t.get(g),l=this.b;function w(P){d.o++;const M=(0,r.$dI)(()=>P.map(N=>N.basename));for(let N=0,T=P.length;N<T;N++){const z=P[N],{relativePath:j,basename:U}=z;if(v.test(j,U,l!==U?M:void 0))continue;const Y=o[j];if(Y)w(Y);else{if(d.p++,j===l)continue;d.J(u,z)}if(d.j)break}}w(t)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(t,o,g,u,d){const v=t.folder,l=(0,r.$dI)(()=>g);this.w(g,(w,P)=>{if(this.l||this.j)return P(null);const M=o?[o,w].join(h.sep):w;if(this.t.get(t.folder.fsPath).test(M,w,this.a.filePattern!==w?l:void 0))return P(null);const N=[v.fsPath,M].join(h.sep);F.lstat(N,(T,z)=>{if(T||this.l||this.j)return P(null);this.L(N,z,(j,U)=>j||this.l||this.j?P(null):U.isDirectory()?(this.o++,this.M(N,z,(Y,H)=>Y||this.l||this.j||(H=H||"",this.v[H])?P(null):(this.v[H]=!0,p.Promises.readdir(N).then(ge=>{if(this.l||this.j)return P(null);this.I(t,M,ge,u,ie=>P(ie||null))},ge=>{P(null)})))):(this.p++,M===this.b||this.h&&D.$me(U.size)&&U.size>this.h||this.J(u,{base:v.fsPath,relativePath:M,searchPath:this.N(t,M)}),P(null,void 0)))})},w=>{const P=w&&A.$lf(w);return d(P&&P.length>0?P[0]:void 0)})}J(t,o){this.K(o)&&(!this.d||this.d(o.relativePath,h.$ec(o.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||t(o))}K(t){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,r.$$H)(t,this.c)}return!0}L(t,o,g){return o.isSymbolicLink()?F.stat(t,g):g(null,o)}M(t,o,g){return o.isSymbolicLink()?F.realpath(t,(u,d)=>u?g(u):g(null,d)):g(null,t)}N(t,o){return t.folderName?h.$ac(t.folderName,o):o}}e.$7ac=y;class C{constructor(t){this.a=t.folderQueries,this.b=t.extraFileResources||[],this.c=new y(t)}search(t,o,g){this.c.walk(this.a,this.b,t,o,(u,d)=>{g(u,{limitHit:d,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$8ac=C;class i{constructor(t,o){this.expression=t,this.c=o,this.d(t)}d(t){let o,g;Object.keys(t).filter(u=>t[u]).forEach(u=>{h.$_b(u)?(o=o||E.$0i(),o[u]=t[u]):(g=g||E.$0i(),g[u]=t[u])}),this.a=o&&E.$cj(o,{trimForExclusions:!0}),this.b=g&&E.$cj(g,{trimForExclusions:!0})}test(t,o,g){return this.b&&this.b(t,o,g)||this.a&&this.a(h.$ac(this.c,t),o,g)}getBasenameTerms(){const t=[];return this.a&&t.push(...E.$ej(this.a)),this.b&&t.push(...E.$ej(this.b)),t}getPathTerms(){const t=[];return this.a&&t.push(...E.$fj(this.a)),this.b&&t.push(...E.$fj(this.b)),t}}function a(n){const t=n.trim().split(`
`),o=t[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return S.$ae(t[t.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}}),define(De[342],Ce([1,0,92,22,175]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=e.DecodeStreamErrorKind=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=void 0,e.$VC="utf8",e.$WC="utf8bom",e.$XC="utf16be",e.$YC="utf16le";function L(t){return[e.$VC,e.$WC,e.$XC,e.$YC].some(o=>o===t)}e.$ZC=L,e.$1C=[254,255],e.$2C=[255,254],e.$3C=[239,187,191];const A=512,m=512,E=512*8,b=512*128;var R;(function(t){t[t.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(R||(e.DecodeStreamErrorKind=R={}));class I extends Error{constructor(o,g){super(o),this.decodeStreamErrorKind=g}}e.$4C=I;class ${static async create(o){let g;if(o!==e.$VC)g=(await(0,h.$UC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(r(o));else{const u=new TextDecoder;g={write(d){return u.decode(d,{stream:!0})},end(){return u.decode()}}}return new $(g)}constructor(o){this.a=o}write(o){return this.a.write(o)}end(){return this.a.end()}}function S(t,o){const g=o.minBytesRequiredForDetection??o.guessEncoding?E:m;return new Promise((u,d)=>{const v=(0,k.$xb)(T=>T.join("")),l=[];let w=0,P;const M=async()=>{try{const T=await n({buffer:F.$Jb.concat(l),bytesRead:w},o.guessEncoding);if(T.seemsBinary&&o.acceptTextOnly)throw new I("Stream is binary but only text is accepted for decoding",1);T.encoding=await o.overwriteEncoding(T.encoding),P=await $.create(T.encoding);const z=P.write(F.$Jb.concat(l).buffer);v.write(z),l.length=0,w=0,u({stream:v,detected:T})}catch(T){N?.dispose(),v.destroy(),d(T)}},N=(0,k.$Bb)(t,{onData:async T=>{P?v.write(P.write(T.buffer)):(l.push(T),w+=T.byteLength,w>=g&&(t.pause(),await M(),setTimeout(()=>t.resume())))},onError:T=>v.error(T),onEnd:async()=>{P||await M(),v.end(P?.end())}})})}e.$5C=S;async function D(t,o,g){const d=(await(0,h.$UC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(r(o),g);let v=!1,l=!1;return{read(){if(l)return null;const w=t.read();if(typeof w!="string"){if(l=!0,!v&&g?.addBOM)switch(o){case e.$VC:case e.$WC:return F.$Jb.wrap(Uint8Array.from(e.$3C));case e.$XC:return F.$Jb.wrap(Uint8Array.from(e.$1C));case e.$YC:return F.$Jb.wrap(Uint8Array.from(e.$2C))}const P=d.end();return P&&P.length>0?(v=!0,F.$Jb.wrap(P)):null}return v=!0,F.$Jb.wrap(d.write(w))}}}e.$6C=D;async function p(t){return(await(0,h.$UC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(r(t))}e.$7C=p;function r(t){return t===e.$WC||t===null?e.$VC:t}e.$8C=r;function s(t,o){if(!t||o<e.$1C.length)return null;const g=t.readUInt8(0),u=t.readUInt8(1);if(g===e.$1C[0]&&u===e.$1C[1])return e.$XC;if(g===e.$2C[0]&&u===e.$2C[1])return e.$YC;if(o<e.$3C.length)return null;const d=t.readUInt8(2);return g===e.$3C[0]&&u===e.$3C[1]&&d===e.$3C[2]?e.$WC:null}e.$9C=s;const c=["ascii","utf-16","utf-32"];async function f(t){const o=await(0,h.$UC)("jschardet","dist/jschardet.min.js"),g=t.slice(0,b),u=i(g.buffer),d=o.detect(u);if(!d||!d.encoding)return null;const v=d.encoding.toLowerCase();return 0<=c.indexOf(v)?null:C(d.encoding)}const y={ibm866:"cp866",big5:"cp950"};function C(t){const o=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return y[o]||o}function i(t){let o="";for(let g=0;g<t.length;g++)o+=String.fromCharCode(t[g]);return o}function a(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const o=t.match(/windows(\d+)/);return o?"windows-"+o[1]:t}}}e.$0C=a;function n({buffer:t,bytesRead:o},g){let u=s(t,o),d=!1;if(u!==e.$XC&&u!==e.$YC&&t){let v=!0,l=!0,w=!1;for(let P=0;P<o&&P<A;P++){const M=P%2===1,N=t.readUInt8(P)===0;if(N&&(w=!0),v&&(M&&!N||!M&&N)&&(v=!1),l&&(M&&N||!M&&!N)&&(l=!1),N&&!v&&!l)break}w&&(v?u=e.$YC:l?u=e.$XC:d=!0)}return g&&!d&&!u&&t?f(t.slice(0,o)).then(v=>({seemsBinary:!1,encoding:v})):{seemsBinary:d,encoding:u}}e.$$C=n,e.$_C={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(De[147],Ce([1,0,342,29,146]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dbc=void 0;class L extends h.$0_b{constructor(m,E,b=F,R="searchProcess"){super(m,E,{readdir:I=>b.Promises.readdir(I.fsPath),toCanonicalName:I=>(0,k.$0C)(I)},R)}}e.$dbc=L}),define(De[148],Ce([1,0,46,356,341,19,65,34,13,12,2,35,87,357,339,110]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cbc=e.$bbc=e.$abc=e.$_ac=e.$$ac=e.$0ac=e.$9ac=void 0;const r=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(w){this.a=w}provideTextSearchResults(w,P,M,N){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((T,z)=>{N.onCancellationRequested(()=>q());const j=a(w,P),U=P.folder.fsPath,Y=j.map(de=>de.match(/^-/)?de:`'${de}'`).join(" ");this.a.appendLine(`${r} ${Y}
 - cwd: ${U}`);let H=k.spawn(r,j,{cwd:U});H.on("error",de=>{console.error(de),this.a.appendLine("Error: "+(de&&de.message)),z((0,I.$7H)(new I.$5H(de&&de.message,I.SearchErrorCode.rgProcessError)))});let ge=!1;const ie=new y(P.maxResults,U,P.previewOptions);ie.on("result",de=>{ge=!0,ce="",M.report(de)});let te=!1;const q=()=>{te=!0,H?.kill(),ie?.cancel()};let V=!1;ie.on("hitLimit",()=>{V=!0,q()});let ce="";H.stdout.on("data",de=>{ie.handleData(de),ge||(ce+=de)});let re=!1;H.stdout.once("data",()=>re=!0);let fe="";H.stderr.on("data",de=>{const B=de.toString();this.a.appendLine(B),fe.length+B.length<1e6&&(fe+=B)}),H.on("close",()=>{if(this.a.appendLine(re?"Got data from stdout":"No data from stdout"),this.a.appendLine(ge?"Got result from parser":"No result from parser"),ce&&this.a.appendLine(`Got data without result: ${ce}`),this.a.appendLine(""),te)T({limitHit:V});else{ie.flush(),H=null;let de;fe&&!re&&(de=c(fe))?z((0,I.$7H)(new I.$5H(de.message,de.code))):T({limitHit:V})}})})}}e.$9ac=s;function c(l){const w=l.split(`
`),P=w[0].trim();if(w.some(N=>N.startsWith("regex parse error")))return new I.$5H(f(w),I.SearchErrorCode.regexParseError);const M=P.match(/grep config error: unknown encoding: (.*)/);if(M)return new I.$5H(`Unknown encoding: ${M[1]}`,I.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new I.$5H(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new I.$5H(P.charAt(0).toUpperCase()+P.substr(1),I.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new I.$5H(P,I.SearchErrorCode.regexParseError)}function f(l){const w=["Regex parse error"],P=l.filter(M=>M.startsWith("PCRE2:"));if(P.length>=1){const M=P[0].replace("PCRE2:","");if(M.indexOf(":")!==-1&&M.split(":").length>=2){const N=M.split(":")[1];w.push(":"+N)}}return w.join("")}class y extends F.EventEmitter{constructor(w,P,M){super(),this.g=w,this.h=P,this.j=M,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new h.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,P){return super.on(w,P),this}handleData(w){if(this.b)return;const P=typeof w=="string"?w:this.d.write(w);this.k(P)}k(w){let P=w.indexOf(`
`);const M=this.a+w;if(P>=0)P+=this.a.length;else{this.a=M;return}let N=0;for(;P>=0;)this.m(M.substring(N,P).trim()),N=P+1,P=M.indexOf(`
`,N);this.a=M.substring(N)}m(w){if(this.b||!w)return;let P;try{P=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(P.type==="match"){const M=C(P.data.path),N=R.URI.file(E.$ac(this.h,M)),T=this.n(P.data,N);this.p(T),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const M=C(P.data.path),N=R.URI.file(E.$ac(this.h,M));this.o(P.data,N).forEach(z=>this.p(z))}}n(w,P){const M=w.line_number-1,N=C(w.lines),T=Buffer.from(N);let z=0,j=0,U=M;w.submatches.length===0&&w.submatches.push(N.length?{start:0,end:1,match:{text:N[0]}}:{start:0,end:0,match:{text:""}});const Y=(0,L.$lf)(w.submatches.map((H,ge)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ie=C(H.match),te=T.slice(z,H.start).toString(),q=i(te),V=q.numLines>0?q.lastLineLength:q.lastLineLength+j,ce=i(ie),re=q.numLines+U,fe=ce.numLines+re,de=ce.numLines>0?ce.lastLineLength:ce.lastLineLength+V;return z=H.end,j=de,U=fe,new $.$PH(re,V,fe,de)}));return(0,p.$2ac)(P,N,Y,this.j)}o(w,P){const M=C(w.lines),N=w.line_number;return M.replace(/\r?\n$/,"").split(`
`).map((T,z)=>({text:T,uri:P,lineNumber:N+z}))}p(w){this.emit("result",w)}}e.$0ac=y;function C(l){return l.bytes?Buffer.from(l.bytes,"base64").toString():l.text}function i(l){const w=/\n/g;let P=0,M=-1,N;for(;N=w.exec(l);)P++,M=N.index;const T=M>=0?l.length-M-1:l.length;return{numLines:P,lastLineLength:T}}function a(l,w){const P=["--hidden","--no-require-git"];P.push(l.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:M,otherIncludes:N}=(0,A.$I)(w.includes,z=>z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(N&&N.length){const z=new Set;N.forEach(j=>{z.add(j)}),P.push("-g","!*"),z.forEach(j=>{n(j).map(p.$1ac).forEach(U=>{P.push("-g",U)})})}M&&M.length&&M.forEach(z=>{P.push("-g",z)}),w.excludes.map(p.$1ac).forEach(z=>P.push("-g",`!${z}`)),w.maxFileSize&&P.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),w.followSymlinks&&P.push("--follow"),w.encoding&&w.encoding!=="utf8"&&P.push("--encoding",w.encoding),l.pattern==="--"&&(l.isRegExp=!0,l.pattern="\\-\\-"),l.isMultiline&&!l.isRegExp&&(l.pattern=(0,b.$nd)(l.pattern),l.isRegExp=!0),w.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),l.isRegExp&&(l.pattern=t(l.pattern),P.push("--engine","auto"));let T;if(l.isWordMatch){const j=(0,b.$vd)(l.pattern,!!l.isRegExp,{wholeWord:l.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",j)}else if(l.isRegExp){let z=g(l.pattern);z=u(z),P.push("--regexp",z)}else T=l.pattern,P.push("--fixed-strings");return P.push("--no-config"),w.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),l.isMultiline&&P.push("--multiline"),w.beforeContext&&P.push("--before-context",w.beforeContext+""),w.afterContext&&P.push("--after-context",w.afterContext+""),P.push("--"),T&&P.push(T),P.push("."),P}e.$$ac=a;function n(l){return v(l).flatMap(P=>{const M=(0,m.$aj)(P,"/");return M.map((N,T)=>M.slice(0,T+1).join("/"))})}function t(l){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;l.match(w);)l=l.replace(w,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;l.match(P);)l=l.replace(P,"$1\\x{$2}");return l}e.$_ac=t;const o=l=>l.type==="Assertion"&&l.kind==="lookbehind";function g(l){let w;try{w=new S.RegExpParser().parsePattern(l)}catch{return l}let P="",M=0;const N=(j,U,Y)=>{P+=l.slice(M,j)+Y,M=U},T=[];return new S.RegExpVisitor({onCharacterEnter(j){if(j.raw!=="\\n")return;const U=T[0];if(!U)N(j.start,j.end,"\\r?\\n");else if(!T.some(o))if(U.type==="CharacterClass")if(U.negate){const Y=l.slice(U.start+2,j.start)+l.slice(j.end,U.end-1);U.parent?.type==="Quantifier"?N(U.start,U.end,Y?`[^${Y}]`:"."):N(U.start,U.end,"(?!\\r?\\n"+(Y?`|[${Y}]`:"")+")")}else{const Y=l.slice(U.start+1,j.start)+l.slice(j.end,U.end-1);N(U.start,U.end,Y===""?"\\r?\\n":`(?:[${Y}]|\\r?\\n)`)}else U.type==="Quantifier"&&N(j.start,j.end,"(?:\\r?\\n)")},onQuantifierEnter(j){T.unshift(j)},onQuantifierLeave(){T.shift()},onCharacterClassRangeEnter(j){T.unshift(j)},onCharacterClassRangeLeave(){T.shift()},onCharacterClassEnter(j){T.unshift(j)},onCharacterClassLeave(){T.shift()},onAssertionEnter(j){o(j)&&T.push(j)},onAssertionLeave(j){T[0]===j&&T.shift()}}).visit(w),P+=l.slice(M),P}e.$abc=g;function u(l){return l.replace(/\n/g,"\\r?\\n")}e.$bbc=u;function d(l){let w=!1,P=!1,M="",N="";for(let T=0;T<l.length;T++){const z=l[T];switch(z){case"\\":P?(w?N+="\\"+z:M+="\\"+z,P=!1):P=!0;break;case"{":if(P)w?N+=z:M+=z,P=!1;else{if(w)return{strInBraces:M+"{"+N+"{"+l.substring(T+1)};w=!0}break;case"}":if(P)w?N+=z:M+=z,P=!1;else{if(w)return{fixedStart:M,strInBraces:N,fixedEnd:l.substring(T+1)};M+=z}break;default:w?N+=(P?"\\":"")+z:M+=(P?"\\":"")+z,P=!1;break}}return{strInBraces:M+(w?"{"+N:"")}}function v(l){const{fixedStart:w,strInBraces:P,fixedEnd:M}=d(l);if(w===void 0||M===void 0)return[P];let N=(0,m.$aj)(P,",");N.length||(N=[""]);const T=v(M);return N.flatMap(z=>{const j=w+z;return T.map(U=>j+U)})}e.$cbc=v}),define(De[343],Ce([1,0,21,148,128,15]),function(me,e,k,F,h,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gbc=void 0;class A{constructor(b){this.b=b,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(b,R,I,$){const S=new F.$9ac(this.b);if(R.folder.scheme===L.Schemas.vscodeUserData){const D={...R,folder:R.folder.with({scheme:L.Schemas.file})},p=new h.$Lu(r=>I.report({...r,uri:r.uri.with({scheme:R.folder.scheme})}));return this.c($,r=>S.provideTextSearchResults(b,D,p,r))}else return this.c($,D=>S.provideTextSearchResults(b,R,I,D))}async c(b,R){const I=m(b);this.a.add(I);const $=await R(I.token);return this.a.delete(I),$}d(){this.a.forEach(b=>b.cancel())}}e.$gbc=A;function m(E){const b=new k.$dd;return E.onCancellationRequested(()=>b.cancel()),b}}),define(De[344],Ce([1,0,29,148,147]),function(me,e,k,F,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ebc=void 0;class L{constructor(E){this.a=E}search(E,b,R){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const I={appendLine(S){R({message:S})}},$=new h.$dbc(this.a,new F.$9ac(I),k);return new Promise((S,D)=>$.search(p=>{b(p.map(A))},E).then(p=>S({limitHit:p.limitHit,type:"success",stats:p.stats}),D))}}e.$ebc=L;function A(m){return{path:m.resource&&m.resource.fsPath,results:m.results,numMatches:(m.results||[]).reduce((E,b)=>{if(b.ranges){const R=b;return E+(Array.isArray(R.ranges)?R.ranges.length:1)}else return E+1},0)}}}),define(De[345],Ce([1,0,19,17,8,3,119,13,39,2,30,35,340,344]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fbc=void 0;class D{static{this.a=512}constructor(y="searchProcess"){this.d=y,this.b=Object.create(null)}fileSearch(y){let C;const i=s(y),a=new L.$7c({onDidAddFirstListener:()=>{C=(0,F.$hg)(n=>this.doFileSearchWithEngine($.$8ac,i,t=>a.fire(t),n)),C.then(n=>a.fire(n),n=>a.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onDidRemoveLastListener:()=>{C.cancel()}});return a.event}textSearch(y){let C;const i=s(y),a=new L.$7c({onDidAddFirstListener:()=>{C=(0,F.$hg)(n=>this.f(i,t=>a.fire(t),n)),C.then(n=>a.fire(n),n=>a.fire({type:"error",error:{message:n.message,stack:n.stack}}))},onDidRemoveLastListener:()=>{C.cancel()}});return a.event}f(y,C,i){return y.maxFileSize=this.g().maxFileSize,new S.$ebc(y).search(i,C,C)}g(){return{maxFileSize:process.arch==="ia32"?300*R.$lk.MB:16*R.$lk.GB}}doFileSearch(y,C,i){return this.doFileSearchWithEngine($.$8ac,y,C,i)}doFileSearchWithEngine(y,C,i,a,n=D.a){let t=0;const o=u=>{Array.isArray(u)?(t+=u.length,i(u.map(d=>this.h(d)))):u.relativePath?(t++,i(this.h(u))):i(u)};if(C.sortByScore){let u=this.l(C,o,a);if(!u){const d=C.maxResults?Object.assign({},C,{maxResults:null}):C,v=new y(d);u=this.j(v,C,i,o,a)}return new Promise((d,v)=>{u.then(([l,w])=>{const P=w.map(M=>this.h(M));this.o(P,i,n),d(l)},v)})}const g=new y(C);return this.r(g,o,n,a).then(u=>({limitHit:u.limitHit,type:"success",stats:{detailStats:u.stats,type:this.d,fromCache:!1,resultCount:t,sortingTime:void 0}}))}h(y){return{path:y.base?(0,m.$ac)(y.base,y.relativePath):y.relativePath}}j(y,C,i,a,n){const t=new L.$7c;let o=(0,F.$hg)(u=>{let d=[];const v=l=>{Array.isArray(l)?d=l:(a(l),t.fire(l))};return this.r(y,v,-1,u).then(l=>[l,d])}),g;if(C.cacheKey){g=this.k(C.cacheKey);const u={promise:o,event:t.event,resolved:!1};g.resultsToSearchCache[C.filePattern||""]=u,o.then(()=>{u.resolved=!0},d=>{delete g.resultsToSearchCache[C.filePattern||""]}),o=this.s(o)}return o.then(([u,d])=>{const v=g?g.scorerCache:Object.create(null),l=(typeof C.maxResults!="number"||C.maxResults>0)&&E.$3c.create(!1);return this.n(C,d,v,n).then(w=>{const P=l?l.elapsed():-1;return[{type:"success",stats:{detailStats:u.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:C.folderQueries.length,resultCount:w.length},messages:u.messages,limitHit:u.limitHit||typeof C.maxResults=="number"&&d.length>C.maxResults},w]})})}k(y){const C=this.b[y];return C||(this.b[y]=new p)}l(y,C,i){const a=y.cacheKey&&this.b[y.cacheKey];if(!a)return;const n=this.q(a,y.filePattern||"",C,i);if(n)return n.then(([t,o,g])=>{const u=E.$3c.create(!1);return this.n(y,o,a.scorerCache,i).then(d=>{const v=u.elapsed(),l={fromCache:!0,detailStats:g,type:this.d,resultCount:o.length,sortingTime:v};return[{type:"success",limitHit:t.limitHit||typeof y.maxResults=="number"&&o.length>y.maxResults,stats:l},d]})})}n(y,C,i,a){const n=(0,A.$bq)(y.filePattern||""),t=(g,u)=>(0,A.$aq)(g,u,n,!0,r,i),o=typeof y.maxResults=="number"?y.maxResults:Number.MAX_VALUE;return k.$kf(C,t,o,1e4,a)}o(y,C,i){if(i&&i>0)for(let a=0;a<y.length;a+=i)C(y.slice(a,a+i));else C(y)}q(y,C,i,a){const n=E.$3c.create(!1),t=C.indexOf(m.sep)>=0;let o;for(const v in y.resultsToSearchCache)if(C.startsWith(v)){if(t&&v.indexOf(m.sep)<0&&v!=="")continue;const l=y.resultsToSearchCache[v];o={promise:this.s(l.promise),event:l.event,resolved:l.resolved};break}if(!o)return null;const g=n.elapsed(),u=E.$3c.create(!1),d=o.event(i);return a&&a.onCancellationRequested(()=>{d.dispose()}),o.promise.then(([v,l])=>{if(a&&a.isCancellationRequested)throw(0,h.$4)();const w=[],P=(0,A.$bq)(C).normalizedLowercase;for(const M of l)(0,I.$$H)(M,P)&&w.push(M);return[v,w,{cacheWasResolved:o.resolved,cacheLookupTime:g,cacheFilterTime:u.elapsed(),cacheEntryCount:l.length}]})}r(y,C,i,a){return new Promise((n,t)=>{let o=[];a?.onCancellationRequested(()=>y.cancel()),y.search(g=>{g&&(i?(o.push(g),i>0&&o.length>=i&&(C(o),o=[])):C(g))},g=>{C(g)},(g,u)=>{o.length&&C(o),g?t(g):n(u)})})}clearCache(y){return delete this.b[y],Promise.resolve(void 0)}s(y){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(C,i){return y.then(C,i)}catch(C){return this.then(void 0,C)}finally(C){return y.finally(C)}}}}e.$fbc=D;class p{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const r=new class{getItemLabel(f){return(0,m.$ec)(f.relativePath)}getItemDescription(f){return(0,m.$dc)(f.relativePath)}getItemPath(f){return f.relativePath}};function s(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(c),extraFileResources:f.extraFileResources&&f.extraFileResources.map(y=>b.URI.revive(y))}}function c(f){return{...f,folder:b.URI.revive(f.folder)}}}),define(De[346],Ce([1,0,4,15,2,29,18,26,20,91,58,35,345,343,110,147]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hbc=void 0;let r=class extends b.$cac{constructor(c,f,y,C){super(c,y,C),this.s=L,this.t=-1,this.v=null,this.w=!1;const i=new D.$3ac("RipgrepSearchUD",this.n);this.registerTextSearchProvider(F.Schemas.vscodeUserData,new S.$gbc(i)),f.remote.isRemote&&f.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const c=new D.$3ac("RipgrepSearchEH",this.n);this.registerTextSearchProvider(F.Schemas.file,new S.$gbc(c)),this.y(F.Schemas.file,new $.$fbc("fileSearchProvider"))}y(c,f){const y=this.d++;return this.v=f,this.t=y,this.c.$registerFileSearchProvider(y,this.o(c)),(0,k.$jb)(()=>{this.v=null,this.c.$unregisterProvider(y)})}$provideFileSearchResults(c,f,y,C){const i=(0,b.$dac)(y);return c===this.t?this.z(c,f,i,C):super.$provideFileSearchResults(c,f,y,C)}z(c,f,y,C){const i=a=>{if((0,I.$0H)(a)&&(a=[a]),Array.isArray(a)){this.c.$handleFileMatch(c,f,a.map(n=>h.URI.file(n.path)));return}a.message&&this.n.debug("ExtHostSearch",a.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(y,i,C)}$clearCache(c){return this.v?.clearCache(c),super.$clearCache(c)}q(c,f){return new p.$dbc(c,f,void 0,"textSearchProvider")}};e.$hbc=r,e.$hbc=r=Je([qe(0,E.$zL),qe(1,m.$PL),qe(2,R.$U$b),qe(3,A.$Pi)],r)}),define(De[149],Ce([1,0,358,101,75,359,22,8,3,4,13,11,32,76,122]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=void 0;class p{traceSocketEvent(l,w){D.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,l,w)}constructor(l,w=""){this.f=!0,this.debugLabel=w,this.socket=l,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,m.$Y)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(l){const w=P=>{this.traceSocketEvent("read",P),l(A.$Jb.wrap(P))};return this.socket.on("data",w),{dispose:()=>this.socket.off("data",w)}}onClose(l){const w=P=>{l({type:0,hadError:P,error:void 0})};return this.socket.on("close",w),{dispose:()=>this.socket.off("close",w)}}onEnd(l){const w=()=>{l()};return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(l){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",l),this.socket.write(l.buffer,w=>{if(w){if(w.code==="EPIPE")return;(0,m.$Y)(w)}})}catch(w){if(w.code==="EPIPE")return;(0,m.$Y)(w)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((l,w)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),l();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),l()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$ch=p;var r;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize",v[v.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var s;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(s||(s={}));class c extends b.$lb{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(l,w){this.socket.traceSocketEvent(l,w)}constructor(l,w,P,M){super(),this.f=this.B(new E.$7c),this.g=this.B(new E.$7c),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=l,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:w,inflateBytesLength:P?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new f(this,w,P,M,this.f,(N,T)=>this.k(N,T))),this.B(this.a.onError(N=>{console.error(N),(0,m.$Y)(N),this.g.fire({type:0,hadError:!0,error:N})})),this.b=new D.$0g,this.B(this.socket.onData(N=>this.l(N))),this.B(this.socket.onClose(async N=>{this.a.isProcessingReadQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(N)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(l){return this.f.event(l)}onClose(l){return this.g.event(l)}onEnd(l){return this.socket.onEnd(l)}write(l){let w=0;for(;w<l.byteLength;)this.a.writeMessage(l.slice(w,Math.min(w+262144,l.byteLength))),w+=262144}k(l,w){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",l);let P=2;l.byteLength<126?P+=0:l.byteLength<2**16?P+=2:P+=8;const M=A.$Jb.alloc(P);if(w?M.writeUInt8(194,0):M.writeUInt8(130,0),l.byteLength<126)M.writeUInt8(l.byteLength,1);else if(l.byteLength<2**16){M.writeUInt8(126,1);let N=1;M.writeUInt8(l.byteLength>>>8&255,++N),M.writeUInt8(l.byteLength>>>0&255,++N)}else{M.writeUInt8(127,1);let N=1;M.writeUInt8(0,++N),M.writeUInt8(0,++N),M.writeUInt8(0,++N),M.writeUInt8(0,++N),M.writeUInt8(l.byteLength>>>24&255,++N),M.writeUInt8(l.byteLength>>>16&255,++N),M.writeUInt8(l.byteLength>>>8&255,++N),M.writeUInt8(l.byteLength>>>0&255,++N)}this.socket.write(A.$Jb.concat([M,l]))}end(){this.h=!0,this.socket.end()}l(l){if(l.byteLength!==0){for(this.b.acceptChunk(l);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const w=this.b.peek(this.j.readLen),P=w.readUInt8(0),M=(P&128)>>>7,N=(P&64)>>>6,T=w.readUInt8(1),z=(T&128)>>>7,j=T&127;this.j.state=2,this.j.readLen=2+(z?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=!!N),this.j.firstFrameOfMessage=!!M,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const w=this.b.read(this.j.readLen),P=w.readUInt8(1),M=(P&128)>>>7;let N=P&127,T=1;N===126?N=w.readUInt8(++T)*2**8+w.readUInt8(++T):N===127&&(N=w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*0+w.readUInt8(++T)*2**24+w.readUInt8(++T)*2**16+w.readUInt8(++T)*2**8+w.readUInt8(++T));let z=0;M&&(z=w.readUInt8(++T)*2**24+w.readUInt8(++T)*2**16+w.readUInt8(++T)*2**8+w.readUInt8(++T)),this.j.state=3,this.j.readLen=N,this.j.mask=z,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const w=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",w),i(w,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",w),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(w,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await E.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$dh=c;class f extends b.$lb{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.$Jb.alloc(0)}constructor(l,w,P,M,N,T){super(),this.l=l,this.m=N,this.n=T,this.a=this.B(new E.$7c),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new E.$7c),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new E.$7c),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,w?(this.b=this.B(new y(this.l,M,P,{windowBits:15})),this.f=this.B(new C(this.l,{windowBits:15})),this.B(this.b.onError(z=>this.a.fire(z))),this.B(this.f.onError(z=>this.a.fire(z)))):(this.b=null,this.f=null)}writeMessage(l){this.g.push(l),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const l=this.g.shift();if(this.f){const w=await this.s(this.f,l);this.n(w,!0)}else this.n(l,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(l,w){return new Promise((P,M)=>{l.write(w),l.flush(N=>P(N))})}acceptFrame(l,w,P){this.h.push({data:l,isCompressed:w,isLastFrameOfMessage:P}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const l=this.h.shift();if(this.b&&l.isCompressed){const w=await this.w(this.b,l.data,l.isLastFrameOfMessage);this.m.fire(w)}else this.m.fire(l.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(l,w,P){return new Promise((M,N)=>{l.write(w),P&&l.write(A.$Jb.fromByteArray([0,0,255,255])),l.flush(T=>M(T))})}}class y extends b.$lb{get recordedInflateBytes(){return this.j?A.$Jb.concat(this.f):A.$Jb.alloc(0)}constructor(l,w,P,M){super(),this.h=l,this.j=w,this.a=this.B(new E.$7c),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(M),this.b.on("error",N=>{this.h.traceSocketEvent("zlibInflateError",{message:N?.message,code:N?.code}),this.a.fire(N)}),this.b.on("data",N=>{this.h.traceSocketEvent("zlibInflateData",N),this.g.push(A.$Jb.wrap(N))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(l){this.j&&this.f.push(l.clone()),this.h.traceSocketEvent("zlibInflateWrite",l),this.b.write(l.buffer)}flush(l){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const w=A.$Jb.concat(this.g);this.g.length=0,l(w)})}}class C extends b.$lb{constructor(l,w){super(),this.g=l,this.a=this.B(new E.$7c),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(A.$Jb.wrap(P))})}write(l){this.g.traceSocketEvent("zlibDeflateWrite",l.buffer),this.b.write(l.buffer)}flush(l){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let w=A.$Jb.concat(this.f);this.f.length=0,w=w.slice(0,w.byteLength-4),l(w)})}}function i(v,l){if(l===0)return;const w=v.byteLength>>>2;for(let j=0;j<w;j++){const U=v.readUInt32BE(j*4);v.writeUInt32BE(U^l,j*4)}const P=w*4,M=v.byteLength-P,N=l>>>24&255,T=l>>>16&255,z=l>>>8&255;M>=1&&v.writeUInt8(v.readUInt8(P)^N,P),M>=2&&v.writeUInt8(v.readUInt8(P+1)^T,P+1),M>=3&&v.writeUInt8(v.readUInt8(P+2)^z,P+2)}e.$eh=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const v=(0,$.$5e)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;const l=process.platform!=="darwin"&&e.$eh?e.$eh:(0,h.tmpdir)(),w=(0,R.$ac)(l,`vscode-ipc-${v}.sock`);return o(w),w}e.$fh=n;function t(v,l,w){const P=(0,k.createHash)("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${w}-${l}-sock`;const M=w.substr(0,4),N=l.substr(0,6),T=P.substr(0,8);let z;return process.platform!=="darwin"&&e.$eh&&!process.env.VSCODE_PORTABLE?z=(0,R.$ac)(e.$eh,`vscode-${T}-${M}-${N}.sock`):z=(0,R.$ac)(v,`${M}-${N}.sock`),o(z),z}e.$gh=t;function o(v){const l=a[I.$t];typeof l=="number"&&v.length>=l&&console.warn(`WARNING: IPC handle "${v}" is longer than ${l} chars, try a shorter --user-data-dir`)}class g extends S.$4g{static b(l){const w=E.Event.fromNodeEventEmitter(l,"connection");return E.Event.map(w,P=>({protocol:new D.$$g(new p(P,"ipc-server-connection")),onDidClientDisconnect:E.Event.once(E.Event.fromNodeEventEmitter(P,"close"))}))}constructor(l){super(g.b(l)),this.d=l}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$hh=g;function u(v){return new Promise((l,w)=>{const P=(0,F.createServer)();P.on("error",w),P.listen(v,()=>{P.removeListener("error",w),l(new g(P))})})}e.$ih=u;function d(v,l){return new Promise((w,P)=>{const M=(0,F.createConnection)(v,()=>{M.removeListener("error",P),w(D.$_g.fromSocket(new p(M,`ipc-client${l}`),l))});M.once("error",P)})}e.$jh=d}),define(De[347],Ce([1,0,149,252,49,36,2,18,50]),function(me,e,k,F,h,L,A,m,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=e.$1L=void 0;class b{constructor($,S,D){this.b=$,this.c=S,this.f=D,this.a=F.createServer((p,r)=>this.h(p,r)),this.g().catch(p=>(S.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",$=>this.c.error($))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h($,S){const D=(r,s)=>{S.writeHead(r,{"content-type":"application/json"}),S.end(JSON.stringify(s||null),c=>c&&this.c.error(c))},p=[];$.setEncoding("utf8"),$.on("data",r=>p.push(r)),$.on("end",async()=>{try{const r=JSON.parse(p.join(""));let s;switch(r.type){case"open":s=await this.i(r);break;case"openExternal":s=await this.j(r);break;case"status":s=await this.l(r);break;case"extensionManagement":s=await this.k(r);break;default:D(404,`Unknown message type: ${r.type}`);break}D(200,s)}catch(r){const s=r instanceof Error?r.message:JSON.stringify(r);D(500,s),this.c.error("Error while processing pipe request",r)}})}async i($){const{fileURIs:S,folderURIs:D,forceNewWindow:p,diffMode:r,mergeMode:s,addMode:c,forceReuseWindow:f,gotoLineMode:y,waitMarkerFilePath:C,remoteAuthority:i}=$,a=[];if(Array.isArray(D))for(const g of D)try{a.push({folderUri:A.URI.parse(g)})}catch{}if(Array.isArray(S))for(const g of S)try{(0,E.$Sh)(g)?a.push({workspaceUri:A.URI.parse(g)}):a.push({fileUri:A.URI.parse(g)})}catch{}const n=C?A.URI.file(C):void 0,o={forceNewWindow:p,diffMode:r,mergeMode:s,addMode:c,gotoLineMode:y,forceReuseWindow:f,preferNewWindow:!f&&!n&&!c,waitMarkerFileURI:n,remoteAuthority:i};this.b.executeCommand("_remoteCLI.windowOpen",a,o)}async j($){for(const S of $.uris){const D=A.URI.parse(S),p=D.scheme==="file"?D:S;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k($){const S=p=>p?.map(r=>/\.vsix$/i.test(r)?A.URI.parse(r):r),D={list:$.list,install:S($.install),uninstall:S($.uninstall),force:$.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l($){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&h.existsSync(this.f)&&h.unlinkSync(this.f)}}e.$1L=b;let R=class extends b{constructor($,S){super($,S,(0,k.$fh)())}};e.$2L=R,e.$2L=R=Je([qe(0,L.$VL),qe(1,m.$Pi)],R)}),define(De[348],Ce([1,0,89,336,331,251,44,319,2,15,7,347,95,317,318]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=void 0;class p extends h.$Nac{j(){const c=this,f=globalThis._VSCODE_NODE_MODULES.module,y=f._load;f._load=function(n,t,o){return n=i(n),c.a.has(n)?c.a.get(n).load(n,E.URI.file((0,$.$Kp)(t.filename)),g=>y.apply(this,[g,t,o])):y.apply(this,arguments)};const C=f._resolveLookupPaths;f._resolveLookupPaths=(a,n)=>C.call(this,i(a),n);const i=a=>{for(const n of c.b){const t=n(a);if(t){a=t;break}}return a}}}class r extends A.$s_b{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Node}async pb(){this.h.createInstance(S.$kbc);const c=this.h.invokeFunction(F.$Jac);if(this.h.createInstance(m.$jbc),this.f.remote.isRemote&&this.f.remote.authority){const C=this.h.createInstance(I.$2L);process.env.VSCODE_IPC_HOOK_CLI=C.ipcHandlePath}this.h.createInstance(D.$lbc),await this.h.createInstance(p,c,{mine:this.F,all:this.G}).install(),k.mark("code/extHost/didInitAPI");const y=await this.k.getConfigProvider();await(0,L.$ibc)(this.j,y,this,this.l,this.u,this.f),k.mark("code/extHost/didInitProxyResolver")}qb(c){return c.main}async rb(c,f,y){if(f.scheme!==b.Schemas.file)throw new Error(`Cannot load URI: '${f}', must be of file-scheme`);let C=null;y.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${f.toString(!0)}`),this.l.flush();const i=c?.identifier.value;c&&await this.s.initializeLocalizedMessages(c);try{i&&k.mark(`code/extHost/willLoadExtensionCode/${i}`),C=me.__$__nodeRequire(f.fsPath)}finally{i&&k.mark(`code/extHost/didLoadExtensionCode/${i}`),y.codeLoadingStop()}return C}async $setRemoteEnvironment(c){if(this.f.remote.isRemote)for(const f in c){const y=c[f];y===null?delete process.env[f]:process.env[f]=y}}}e.$mbc=r}),define(De[349],Ce([1,0,98,322,334,333,346,348,323,90,44,91,88,43,64,85,321,320,18,335,52,246,97]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s,c,f,y,C,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,k.$0q)(R.$t_b,m.$mbc,0),(0,k.$0q)(c.$Qi,s.$wbc,1),(0,k.$0q)(c.$Pi,new i.$kh(C.$Mac,[!1],!0)),(0,k.$0q)(p.$e_b,r.$vbc,0),(0,k.$0q)(b.$4_b,L.$Zac,0),(0,k.$0q)(I.$bac,A.$hbc,0),(0,k.$0q)($.$Y_b,h.$Rac,0),(0,k.$0q)(S.$g_b,F.$Qac,0),(0,k.$0q)(D.$Tpb,E.$ubc,0),(0,k.$0q)(y.$2_b,f.$xbc,0)}),define(De[360],Ce([1,0,101,361,89,8,122,149,233,105,332,22,29,95,17,124,253,271,337,349]),function(me,e,k,F,h,L,A,m,E,b,R,I,$,S,D,p,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let g=0;g<process.execArgv.length;g++)process.execArgv[g]==="--inspect-port=0"&&(process.execArgv.splice(g,1),g--)}();const c=F(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const o=globalThis._VSCODE_NODE_MODULES.module,g=o._load;o._load=function(u){if(u==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return g.apply(this,arguments)}})();const f=process.exit.bind(process);function y(o){process.exit=function(g){if(o)f(g);else{const u=new Error("An extension called process.exit() and this was prevented.");console.warn(u.stack)}},process.crash=function(){const g=new Error("An extension called process.crash() and this was prevented.");console.warn(g.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let C=function(o){f()};function i(){const o=(0,s.$bm)(process.env);if(o.type===3)return new Promise((g,u)=>{const d=v=>{const l=v[0],w=new A.$ah;l.on("message",P=>w.fire(I.$Jb.wrap(P.data))),l.on("close",()=>{C("renderer closed the MessagePort")}),l.start(),g({onMessage:w.event,send:P=>l.postMessage(P.buffer)})};process.parentPort.on("message",v=>d(v.ports))});if(o.type===2)return new Promise((g,u)=>{let d=null;const v=setTimeout(()=>{C("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),l=108e5,w=3e5,P=new D.$Fg(()=>C("renderer disconnected for too long (1)"),l),M=new D.$Fg(()=>C("renderer disconnected for too long (2)"),w);process.on("message",(T,z)=>{if(T&&T.type==="VSCODE_EXTHOST_IPC_SOCKET"){z.setNoDelay(!0);const j=I.$Jb.wrap(Buffer.from(T.initialDataChunk,"base64"));let U;if(T.skipWebSocketFrames)U=new m.$ch(z,"extHost-socket");else{const Y=I.$Jb.wrap(Buffer.from(T.inflateBytes,"base64"));U=new m.$dh(new m.$ch(z,"extHost-socket"),T.permessageDeflate,Y,!1)}d?(P.cancel(),M.cancel(),d.beginAcceptReconnection(U,j),d.endAcceptReconnection(),d.sendResume()):(clearTimeout(v),d=new A.$bh({socket:U,initialChunk:j}),d.sendResume(),d.onDidDispose(()=>C("renderer disconnected")),g(d),d.onSocketClose(()=>{P.schedule()}))}if(T&&T.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;P.isScheduled()&&M.schedule()}});const N={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(N)});{const g=o.pipeName;return new Promise((u,d)=>{const v=k.createConnection(g,()=>{v.removeListener("error",d);const l=new A.$bh({socket:new m.$ch(v,"extHost-renderer")});l.sendResume(),u(l)});v.once("error",d),v.on("close",()=>{C("renderer closed the socket")})})}}async function a(){const o=await i();return new class{constructor(){this.a=new A.$ah,this.onMessage=this.a.event,this.b=!1,o.onMessage(g=>{(0,b.$Ol)(g,2)?(this.b=!0,C("received terminate message from renderer")):this.a.fire(g)})}send(g){this.b||o.send(g)}async drain(){if(o.drain)return o.drain()}}}function n(o){return new Promise(g=>{const u=o.onMessage(d=>{u.dispose();const v=JSON.parse(d.toString()),l=v.commit,w=E.default.commit;if(l&&w&&l!==w&&f(55),v.parentPid){let P=0;setInterval(function(){try{process.kill(v.parentPid,0),P=0}catch(N){N&&N.code==="EPERM"?(P++,P>=3&&C(`parent process ${v.parentPid} does not exist anymore (3 x EPERM): ${N.message} (code: ${N.code}) (errno: ${N.errno})`)):C(`parent process ${v.parentPid} does not exist anymore: ${N.message} (code: ${N.code}) (errno: ${N.errno})`)}},1e3);let M;try{M=globalThis._VSCODE_NODE_MODULES["native-watchdog"],M.start(v.parentPid)}catch(N){(0,L.$Y)(N)}}o.send((0,b.$Nl)(0)),g({protocol:o,initData:v})});o.send((0,b.$Nl)(1))})}async function t(){const o=[];process.on("unhandledRejection",(P,M)=>{o.push(M),setTimeout(()=>{const N=o.indexOf(M);N>=0&&M.catch(T=>{o.splice(N,1),(0,L.$2)(T)||(console.warn(`rejected promise not handled within 1 second: ${T}`),T&&T.stack&&console.warn(`stack trace: ${T.stack}`),P&&(0,L.$Y)(P))})},1e3)}),process.on("rejectionHandled",P=>{const M=o.indexOf(P);M>=0&&o.splice(M,1)}),process.on("uncaughtException",function(P){(0,L.$X)(P)||(0,L.$Y)(P)}),h.mark("code/extHost/willConnectToRenderer");const g=await a();h.mark("code/extHost/didConnectToRenderer");const u=await n(g);h.mark("code/extHost/didWaitForInitData");const{initData:d}=u;y(!!d.environment.extensionTestsLocationURI),d.environment.useHostProxy=c.useHostProxy!==void 0?c.useHostProxy!=="false":void 0,d.environment.skipWorkspaceStorageLock=(0,p.boolean)(c.skipWorkspaceStorageLock,!1);const v=new class{constructor(){this.pid=process.pid}exit(M){f(M)}fsExists(M){return $.Promises.exists(M)}fsRealpath(M){return(0,S.$Jp)(M)}};let l=null;d.remote.authority&&c.transformURIs&&(l=(0,r.$br)(d.remote.authority));const w=new R.$Pac(u.protocol,d,v,l);C=P=>w.terminate(P)}t().catch(o=>console.log(o))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c3e3dba23e8fadc360aed75ce363ba185c49794/core/vs/workbench/api/node/extensionHostProcess.js.map
