/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ae=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/lazy","vs/base/common/iterator","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/editor/common/languages","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChat","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Re=function($e){for(var e=[],w=0,L=$e.length;w<L;w++)e[w]=Ae[$e[w]];return e};define(Ae[65],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L=e.$K=e.$J=e.$I=void 0;function w(P,d){const k=Object.create(null);for(const $ of P){const R=d($);let E=k[R];E||(E=k[R]=[]),E.push($)}return k}e.$I=w;function L(P,d){const k=[],$=[];for(const R of P)d.has(R)||k.push(R);for(const R of d)P.has(R)||$.push(R);return{removed:k,added:$}}e.$J=L;function I(P,d){const k=[],$=[];for(const[R,E]of P)d.has(R)||k.push(E);for(const[R,E]of d)P.has(R)||$.push(E);return{removed:k,added:$}}e.$K=I;class z{constructor(){this.a=new Map}add(d,k){let $=this.a.get(d);$||($=new Set,this.a.set(d,$)),$.add(k)}delete(d,k){const $=this.a.get(d);$&&($.delete(k),$.size===0&&this.a.delete(d))}forEach(d,k){const $=this.a.get(d);$&&$.forEach(k)}get(d){const k=this.a.get(d);return k?new Set(k):new Set}}e.$L=z}),define(Ae[66],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=e.$Sg=e.$Rg=void 0;function w(P){return(d,k,$)=>{let R=null,E=null;if(typeof $.value=="function"?(R="value",E=$.value):typeof $.get=="function"&&(R="get",E=$.get),!E)throw new Error("not supported");$[R]=P(E,k)}}function L(P,d,k){let $=null,R=null;if(typeof k.value=="function"?($="value",R=k.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&($="get",R=k.get),!R)throw new Error("not supported");const E=`$memoize$${d}`;k[$]=function(...c){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,c)}),this[E]}}e.$Rg=L;function I(P,d,k){return w(($,R)=>{const E=`$debounce$${R}`,c=`$debounce$result$${R}`;return function(...y){this[c]||(this[c]=k?k():void 0),clearTimeout(this[E]),d&&(this[c]=d(this[c],...y),y=[this[c]]),this[E]=setTimeout(()=>{$.apply(this,y),this[c]=k?k():void 0},P)}})}e.$Sg=I;function z(P,d,k){return w(($,R)=>{const E=`$throttle$timer$${R}`,c=`$throttle$result$${R}`,y=`$throttle$lastRun$${R}`,b=`$throttle$pending$${R}`;return function(...o){if(this[c]||(this[c]=k?k():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),d&&(this[c]=d(this[c],...o)),this[b])return;const t=this[y]+P;t<=Date.now()?(this[y]=Date.now(),$.apply(this,[this[c]]),this[c]=k?k():void 0):(this[b]=!0,this[E]=setTimeout(()=>{this[b]=!1,this[y]=Date.now(),$.apply(this,[this[c]]),this[c]=k?k():void 0},t-Date.now()))}})}e.$Tg=z}),define(Ae[88],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FL=e.$EL=void 0;class w{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$EL=w,e.$FL=new w("id#")}),define(Ae[115],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=e.$Bm=e.$Am=e.$zm=e.$ym=e.$xm=e.$wm=e.$vm=e.$um=e.$tm=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var w;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(w||(e.ScanError=w={}));var L;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var I;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var z;(function(r){r.DEFAULT={allowTrailingComma:!0}})(z||(e.ParseOptions=z={}));function P(r,h=!1){let n=0;const s=r.length;let p="",D=0,l=16,g=0;function v(U){let O=0,N=0;for(;O<U;){const ae=r.charCodeAt(n);if(ae>=48&&ae<=57)N=N*16+ae-48;else if(ae>=65&&ae<=70)N=N*16+ae-65+10;else if(ae>=97&&ae<=102)N=N*16+ae-97+10;else break;n++,O++}return O<U&&(N=-1),N}function u(U){n=U,p="",D=0,l=16,g=0}function f(){const U=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&$(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&$(r.charCodeAt(n)))for(n++;n<r.length&&$(r.charCodeAt(n));)n++;else return g=3,r.substring(U,n);let O=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&$(r.charCodeAt(n))){for(n++;n<r.length&&$(r.charCodeAt(n));)n++;O=n}else g=3;return r.substring(U,O)}function A(){let U="",O=n;for(;;){if(n>=s){U+=r.substring(O,n),g=2;break}const N=r.charCodeAt(n);if(N===34){U+=r.substring(O,n),n++;break}if(N===92){if(U+=r.substring(O,n),n++,n>=s){g=2;break}switch(r.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const Q=v(4);Q>=0?U+=String.fromCharCode(Q):g=4;break}default:g=5}O=n;continue}if(N>=0&&N<=31)if(k(N)){U+=r.substring(O,n),g=2;break}else g=6;n++}return U}function W(){if(p="",g=0,D=n,n>=s)return D=s,l=17;let U=r.charCodeAt(n);if(d(U)){do n++,p+=String.fromCharCode(U),U=r.charCodeAt(n);while(d(U));return l=15}if(k(U))return n++,p+=String.fromCharCode(U),U===13&&r.charCodeAt(n)===10&&(n++,p+=`
`),l=14;switch(U){case 123:return n++,l=1;case 125:return n++,l=2;case 91:return n++,l=3;case 93:return n++,l=4;case 58:return n++,l=6;case 44:return n++,l=5;case 34:return n++,p=A(),l=10;case 47:{const O=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<s&&!k(r.charCodeAt(n));)n++;return p=r.substring(O,n),l=12}if(r.charCodeAt(n+1)===42){n+=2;const N=s-1;let ae=!1;for(;n<N;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,ae=!0;break}n++}return ae||(n++,g=1),p=r.substring(O,n),l=13}return p+=String.fromCharCode(U),n++,l=16}case 45:if(p+=String.fromCharCode(U),n++,n===s||!$(r.charCodeAt(n)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return p+=f(),l=11;default:for(;n<s&&B(U);)n++,U=r.charCodeAt(n);if(D!==n){switch(p=r.substring(D,n),p){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return p+=String.fromCharCode(U),n++,l=16}}function B(U){if(d(U)||k(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let U;do U=W();while(U>=12&&U<=15);return U}return{setPosition:u,getPosition:()=>n,scan:h?V:W,getToken:()=>l,getTokenValue:()=>p,getTokenOffset:()=>D,getTokenLength:()=>n-D,getTokenError:()=>g}}e.$tm=P;function d(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function k(r){return r===10||r===13||r===8232||r===8233}function $(r){return r>=48&&r<=57}var R;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(R||(R={}));function E(r,h){const n=[],s=new Object;let p;const D={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function g(v,u,f,A){D.value=v,D.offset=u,D.length=f,D.type=A,D.colonOffset=void 0,p=D}try{m(r,{onObjectBegin:(v,u)=>{if(h<=v)throw s;p=void 0,l=h>v,n.push("")},onObjectProperty:(v,u,f)=>{if(h<u||(g(v,u,f,"property"),n[n.length-1]=v,h<=u+f))throw s},onObjectEnd:(v,u)=>{if(h<=v)throw s;p=void 0,n.pop()},onArrayBegin:(v,u)=>{if(h<=v)throw s;p=void 0,n.push(0)},onArrayEnd:(v,u)=>{if(h<=v)throw s;p=void 0,n.pop()},onLiteralValue:(v,u,f)=>{if(h<u||(g(v,u,f,C(v)),h<=u+f))throw s},onSeparator:(v,u,f)=>{if(h<=u)throw s;if(v===":"&&p&&p.type==="property")p.colonOffset=u,l=!1,p=void 0;else if(v===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(l=!0,n[n.length-1]=""),p=void 0}}})}catch(v){if(v!==s)throw v}return{path:n,previousNode:p,isAtPropertyKey:l,matches:v=>{let u=0;for(let f=0;u<v.length&&f<n.length;f++)if(v[u]===n[f]||v[u]==="*")u++;else if(v[u]!=="**")return!1;return u===v.length}}}e.$um=E;function c(r,h=[],n=z.DEFAULT){let s=null,p=[];const D=[];function l(v){Array.isArray(p)?p.push(v):s!==null&&(p[s]=v)}return m(r,{onObjectBegin:()=>{const v={};l(v),D.push(p),p=v,s=null},onObjectProperty:v=>{s=v},onObjectEnd:()=>{p=D.pop()},onArrayBegin:()=>{const v=[];l(v),D.push(p),p=v,s=null},onArrayEnd:()=>{p=D.pop()},onLiteralValue:l,onError:(v,u,f)=>{h.push({error:v,offset:u,length:f})}},n),p[0]}e.$vm=c;function y(r,h=[],n=z.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function p(v){s.type==="property"&&(s.length=v-s.offset,s=s.parent)}function D(v){return s.children.push(v),v}m(r,{onObjectBegin:v=>{s=D({type:"object",offset:v,length:-1,parent:s,children:[]})},onObjectProperty:(v,u,f)=>{s=D({type:"property",offset:u,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:v,offset:u,length:f,parent:s})},onObjectEnd:(v,u)=>{s.length=v+u-s.offset,s=s.parent,p(v+u)},onArrayBegin:(v,u)=>{s=D({type:"array",offset:v,length:-1,parent:s,children:[]})},onArrayEnd:(v,u)=>{s.length=v+u-s.offset,s=s.parent,p(v+u)},onLiteralValue:(v,u,f)=>{D({type:C(v),offset:u,length:f,parent:s,value:v}),p(u+f)},onSeparator:(v,u,f)=>{s.type==="property"&&(v===":"?s.colonOffset=u:v===","&&p(u))},onError:(v,u,f)=>{h.push({error:v,offset:u,length:f})}},n);const g=s.children[0];return g&&delete g.parent,g}e.$wm=y;function b(r,h){if(!r)return;let n=r;for(const s of h)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let p=!1;for(const D of n.children)if(Array.isArray(D.children)&&D.children[0].value===s){n=D.children[1],p=!0;break}if(!p)return}else{const p=s;if(n.type!=="array"||p<0||!Array.isArray(n.children)||p>=n.children.length)return;n=n.children[p]}return n}e.$xm=b;function o(r){if(!r.parent||!r.parent.children)return[];const h=o(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;h.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&h.push(n)}return h}e.$ym=o;function t(r){switch(r.type){case"array":return r.children.map(t);case"object":{const h=Object.create(null);for(const n of r.children){const s=n.children[1];s&&(h[n.children[0].value]=t(s))}return h}case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.$zm=t;function i(r,h,n=!1){return h>=r.offset&&h<r.offset+r.length||n&&h===r.offset+r.length}e.$Am=i;function a(r,h,n=!1){if(i(r,h,n)){const s=r.children;if(Array.isArray(s))for(let p=0;p<s.length&&s[p].offset<=h;p++){const D=a(s[p],h,n);if(D)return D}return r}}e.$Bm=a;function m(r,h,n=z.DEFAULT){const s=P(r,!1);function p(le){return le?()=>le(s.getTokenOffset(),s.getTokenLength()):()=>!0}function D(le){return le?ne=>le(ne,s.getTokenOffset(),s.getTokenLength()):()=>!0}const l=p(h.onObjectBegin),g=D(h.onObjectProperty),v=p(h.onObjectEnd),u=p(h.onArrayBegin),f=p(h.onArrayEnd),A=D(h.onLiteralValue),W=D(h.onSeparator),B=p(h.onComment),V=D(h.onError),U=n&&n.disallowComments,O=n&&n.allowTrailingComma;function N(){for(;;){const le=s.scan();switch(s.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:U||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(le){case 12:case 13:U?ae(10):B();break;case 16:ae(1);break;case 15:case 14:break;default:return le}}}function ae(le,ne=[],de=[]){if(V(le),ne.length+de.length>0){let ue=s.getToken();for(;ue!==17;){if(ne.indexOf(ue)!==-1){N();break}else if(de.indexOf(ue)!==-1)break;ue=N()}}}function Q(le){const ne=s.getTokenValue();return le?A(ne):g(ne),N(),!0}function be(){switch(s.getToken()){case 11:{let le=0;try{le=JSON.parse(s.getTokenValue()),typeof le!="number"&&(ae(2),le=0)}catch{ae(2)}A(le);break}case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return N(),!0}function ke(){return s.getToken()!==10?(ae(3,[],[2,5]),!1):(Q(!1),s.getToken()===6?(W(":"),N(),Z()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function Fe(){l(),N();let le=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(le||ae(4,[],[]),W(","),N(),s.getToken()===2&&O)break}else le&&ae(6,[],[]);ke()||ae(4,[],[2,5]),le=!0}return v(),s.getToken()!==2?ae(7,[2],[]):N(),!0}function G(){u(),N();let le=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(le||ae(4,[],[]),W(","),N(),s.getToken()===4&&O)break}else le&&ae(6,[],[]);Z()||ae(4,[],[4,5]),le=!0}return f(),s.getToken()!==4?ae(8,[4],[]):N(),!0}function Z(){switch(s.getToken()){case 3:return G();case 1:return Fe();case 10:return Q(!0);default:return be()}}return N(),s.getToken()===17?n.allowEmptyContent?!0:(ae(4,[],[]),!1):Z()?(s.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$Cm=m;function S(r,h){const n=P(r),s=[];let p,D=0,l;do switch(l=n.getPosition(),p=n.scan(),p){case 12:case 13:case 17:D!==l&&s.push(r.substring(D,l)),h!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,h)),D=n.getPosition();break}while(p!==17);return s.join("")}e.$Dm=S;function C(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.$Em=C}),define(Ae[28],Re([1,0]),function($e,e){"use strict";var w,L,I;Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$oi=e.$ni=e.Touch=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=void 0;function z(o,t,i){let a=o.get(t);return a===void 0&&(a=i,o.set(t,a)),a}e.$ii=z;function P(o){const t=[];return o.forEach((i,a)=>{t.push(`${a} => ${i}`)}),`Map(${o.size}) {${t.join(", ")}}`}e.$ji=P;function d(o){const t=[];return o.forEach(i=>{t.push(i)}),`Set(${o.size}) {${t.join(", ")}}`}e.$ki=d;class k{constructor(t,i){this.uri=t,this.value=i}}class ${static{this.a=t=>t.toString()}constructor(t,i){this[w]="ResourceMap",t instanceof $?(this.b=new Map(t.b),this.c=i??$.a):(this.b=new Map,this.c=t??$.a)}set(t,i){return this.b.set(this.c(t),new k(t,i)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,i){typeof i<"u"&&(t=t.bind(i));for(const[a,m]of this.b)t(m.value,m.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.$li=$;class R{constructor(t,i){this[L]="ResourceSet",!t||typeof t=="function"?this.a=new $(t):(this.a=new $(i),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,i){this.a.forEach((a,m)=>t.call(i,m,m,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$mi=R;var E;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class c{constructor(){this[I]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,i=0){const a=this.a.get(t);if(a)return i!==0&&this.j(a,i),a.value}set(t,i,a=0){let m=this.a.get(t);if(m)m.value=i,a!==0&&this.j(m,a);else{switch(m={key:t,value:i,next:void 0,previous:void 0},a){case 0:this.h(m);break;case 1:this.g(m);break;case 2:this.h(m);break;default:this.h(m);break}this.a.set(t,m),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const i=this.a.get(t);if(i)return this.a.delete(t),this.i(i),this.d--,i.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,i){const a=this.e;let m=this.b;for(;m;){if(i?t.bind(i)(m.value,m.key,this):t(m.value,m.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");m=m.next}}keys(){const t=this,i=this.e;let a=this.b;const m={[Symbol.iterator](){return m},next(){if(t.e!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:a.key,done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return m}values(){const t=this,i=this.e;let a=this.b;const m={[Symbol.iterator](){return m},next(){if(t.e!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:a.value,done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return m}entries(){const t=this,i=this.e;let a=this.b;const m={[Symbol.iterator](){return m},next(){if(t.e!==i)throw new Error("LinkedMap got modified during iteration.");if(a){const S={value:[a.key,a.value],done:!1};return a=a.next,S}else return{value:void 0,done:!0}}};return m}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let i=this.b,a=this.size;for(;i&&a>t;)this.a.delete(i.key),i=i.next,a--;this.b=i,this.d=a,i&&(i.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const i=t.next,a=t.previous;if(!i||!a)throw new Error("Invalid list");i.previous=a,a.next=i}t.next=void 0,t.previous=void 0,this.e++}j(t,i){if(!this.b||!this.c)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(t===this.b)return;const a=t.next,m=t.previous;t===this.c?(m.next=void 0,this.c=m):(a.previous=m,m.next=a),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(i===2){if(t===this.c)return;const a=t.next,m=t.previous;t===this.b?(a.previous=void 0,this.b=a):(a.previous=m,m.next=a),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((i,a)=>{t.push([a,i])}),t}fromJSON(t){this.clear();for(const[i,a]of t)this.set(i,a)}}e.$ni=c;class y extends c{constructor(t,i=1){super(),this.k=t,this.l=Math.min(Math.max(0,i),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,i=2){return super.get(t,i)}peek(t){return super.get(t,0)}set(t,i){return super.set(t,i,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$oi=y;class b{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let i=this.a.get(t)||0;return i===0?!1:(i--,i===0?this.a.delete(t):this.a.set(t,i),!0)}has(t){return this.a.has(t)}}e.$pi=b}),function($e,e){typeof define=="function"&&define.amd?define(Ae[116],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(Se,Ee){for(var Ie=0;Ie<Ee.length;Ie++){var se=Ee[Ie];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Se,se.key,se)}}function w(Se,Ee,Ie){return Ee&&e(Se.prototype,Ee),Ie&&e(Se,Ie),Object.defineProperty(Se,"prototype",{writable:!1}),Se}function L(Se,Ee){if(Se){if(typeof Se=="string")return I(Se,Ee);var Ie=Object.prototype.toString.call(Se).slice(8,-1);if(Ie==="Object"&&Se.constructor&&(Ie=Se.constructor.name),Ie==="Map"||Ie==="Set")return Array.from(Se);if(Ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ie))return I(Se,Ee)}}function I(Se,Ee){(Ee==null||Ee>Se.length)&&(Ee=Se.length);for(var Ie=0,se=new Array(Ee);Ie<Ee;Ie++)se[Ie]=Se[Ie];return se}function z(Se,Ee){var Ie=typeof Symbol<"u"&&Se[Symbol.iterator]||Se["@@iterator"];if(Ie)return(Ie=Ie.call(Se)).next.bind(Ie);if(Array.isArray(Se)||(Ie=L(Se))||Ee&&Se&&typeof Se.length=="number"){Ie&&(Se=Ie);var se=0;return function(){return se>=Se.length?{done:!0}:{done:!1,value:Se[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function P(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=P();function d(Se){$e.defaults=Se}var k=/[&<>"']/,$=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,E=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},y=function(Ee){return c[Ee]};function b(Se,Ee){if(Ee){if(k.test(Se))return Se.replace($,y)}else if(R.test(Se))return Se.replace(E,y);return Se}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(Se){return Se.replace(o,function(Ee,Ie){return Ie=Ie.toLowerCase(),Ie==="colon"?":":Ie.charAt(0)==="#"?Ie.charAt(1)==="x"?String.fromCharCode(parseInt(Ie.substring(2),16)):String.fromCharCode(+Ie.substring(1)):""})}var i=/(^|[^\[])\^/g;function a(Se,Ee){Se=typeof Se=="string"?Se:Se.source,Ee=Ee||"";var Ie={replace:function(fe,ee){return ee=ee.source||ee,ee=ee.replace(i,"$1"),Se=Se.replace(fe,ee),Ie},getRegex:function(){return new RegExp(Se,Ee)}};return Ie}var m=/[^\w:]/g,S=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function C(Se,Ee,Ie){if(Se){var se;try{se=decodeURIComponent(t(Ie)).replace(m,"").toLowerCase()}catch{return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}Ee&&!S.test(Ie)&&(Ie=p(Ee,Ie));try{Ie=encodeURI(Ie).replace(/%25/g,"%")}catch{return null}return Ie}var r={},h=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function p(Se,Ee){r[" "+Se]||(h.test(Se)?r[" "+Se]=Se+"/":r[" "+Se]=v(Se,"/",!0)),Se=r[" "+Se];var Ie=Se.indexOf(":")===-1;return Ee.substring(0,2)==="//"?Ie?Ee:Se.replace(n,"$1")+Ee:Ee.charAt(0)==="/"?Ie?Ee:Se.replace(s,"$1")+Ee:Se+Ee}var D={exec:function(){}};function l(Se){for(var Ee=1,Ie,se;Ee<arguments.length;Ee++){Ie=arguments[Ee];for(se in Ie)Object.prototype.hasOwnProperty.call(Ie,se)&&(Se[se]=Ie[se])}return Se}function g(Se,Ee){var Ie=Se.replace(/\|/g,function(ee,ie,he){for(var F=!1,q=ie;--q>=0&&he[q]==="\\";)F=!F;return F?"|":" |"}),se=Ie.split(/ \|/),fe=0;if(se[0].trim()||se.shift(),se.length>0&&!se[se.length-1].trim()&&se.pop(),se.length>Ee)se.splice(Ee);else for(;se.length<Ee;)se.push("");for(;fe<se.length;fe++)se[fe]=se[fe].trim().replace(/\\\|/g,"|");return se}function v(Se,Ee,Ie){var se=Se.length;if(se===0)return"";for(var fe=0;fe<se;){var ee=Se.charAt(se-fe-1);if(ee===Ee&&!Ie)fe++;else if(ee!==Ee&&Ie)fe++;else break}return Se.slice(0,se-fe)}function u(Se,Ee){if(Se.indexOf(Ee[1])===-1)return-1;for(var Ie=Se.length,se=0,fe=0;fe<Ie;fe++)if(Se[fe]==="\\")fe++;else if(Se[fe]===Ee[0])se++;else if(Se[fe]===Ee[1]&&(se--,se<0))return fe;return-1}function f(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function A(Se,Ee){if(Ee<1)return"";for(var Ie="";Ee>1;)Ee&1&&(Ie+=Se),Ee>>=1,Se+=Se;return Ie+Se}function W(Se,Ee,Ie,se){var fe=Ee.href,ee=Ee.title?b(Ee.title):null,ie=Se[1].replace(/\\([\[\]])/g,"$1");if(Se[0].charAt(0)!=="!"){se.state.inLink=!0;var he={type:"link",raw:Ie,href:fe,title:ee,text:ie,tokens:se.inlineTokens(ie)};return se.state.inLink=!1,he}return{type:"image",raw:Ie,href:fe,title:ee,text:b(ie)}}function B(Se,Ee){var Ie=Se.match(/^(\s+)(?:```)/);if(Ie===null)return Ee;var se=Ie[1];return Ee.split(`
`).map(function(fe){var ee=fe.match(/^\s+/);if(ee===null)return fe;var ie=ee[0];return ie.length>=se.length?fe.slice(se.length):fe}).join(`
`)}var V=function(){function Se(Ie){this.options=Ie||$e.defaults}var Ee=Se.prototype;return Ee.space=function(se){var fe=this.rules.block.newline.exec(se);if(fe&&fe[0].length>0)return{type:"space",raw:fe[0]}},Ee.code=function(se){var fe=this.rules.block.code.exec(se);if(fe){var ee=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?ee:v(ee,`
`)}}},Ee.fences=function(se){var fe=this.rules.block.fences.exec(se);if(fe){var ee=fe[0],ie=B(ee,fe[3]||"");return{type:"code",raw:ee,lang:fe[2]?fe[2].trim():fe[2],text:ie}}},Ee.heading=function(se){var fe=this.rules.block.heading.exec(se);if(fe){var ee=fe[2].trim();if(/#$/.test(ee)){var ie=v(ee,"#");(this.options.pedantic||!ie||/ $/.test(ie))&&(ee=ie.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:ee,tokens:this.lexer.inline(ee)}}},Ee.hr=function(se){var fe=this.rules.block.hr.exec(se);if(fe)return{type:"hr",raw:fe[0]}},Ee.blockquote=function(se){var fe=this.rules.block.blockquote.exec(se);if(fe){var ee=fe[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:fe[0],tokens:this.lexer.blockTokens(ee,[]),text:ee}}},Ee.list=function(se){var fe=this.rules.block.list.exec(se);if(fe){var ee,ie,he,F,q,J,K,oe,H,ce,pe,Oe,Be=fe[1].trim(),Ze=Be.length>1,Ke={type:"list",raw:"",ordered:Ze,start:Ze?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ze?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ze?Be:"[*+-]");for(var Qe=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");se&&(Oe=!1,!(!(fe=Qe.exec(se))||this.rules.block.hr.test(se)));){if(ee=fe[0],se=se.substring(ee.length),oe=fe[2].split(`
`,1)[0],H=se.split(`
`,1)[0],this.options.pedantic?(F=2,pe=oe.trimLeft()):(F=fe[2].search(/[^ ]/),F=F>4?1:F,pe=oe.slice(F),F+=fe[1].length),J=!1,!oe&&/^ *$/.test(H)&&(ee+=H+`
`,se=se.substring(H.length+1),Oe=!0),!Oe)for(var Ge=new RegExp("^ {0,"+Math.min(3,F-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,F-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),xe=new RegExp("^ {0,"+Math.min(3,F-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,F-1)+"}#");se&&(ce=se.split(`
`,1)[0],oe=ce,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(xe.test(oe)||tt.test(oe)||Ge.test(oe)||ct.test(se)));){if(oe.search(/[^ ]/)>=F||!oe.trim())pe+=`
`+oe.slice(F);else if(!J)pe+=`
`+oe;else break;!J&&!oe.trim()&&(J=!0),ee+=ce+`
`,se=se.substring(ce.length+1)}Ke.loose||(K?Ke.loose=!0:/\n *\n *$/.test(ee)&&(K=!0)),this.options.gfm&&(ie=/^\[[ xX]\] /.exec(pe),ie&&(he=ie[0]!=="[ ] ",pe=pe.replace(/^\[[ xX]\] +/,""))),Ke.items.push({type:"list_item",raw:ee,task:!!ie,checked:he,loose:!1,text:pe}),Ke.raw+=ee}Ke.items[Ke.items.length-1].raw=ee.trimRight(),Ke.items[Ke.items.length-1].text=pe.trimRight(),Ke.raw=Ke.raw.trimRight();var Ne=Ke.items.length;for(q=0;q<Ne;q++){this.lexer.state.top=!1,Ke.items[q].tokens=this.lexer.blockTokens(Ke.items[q].text,[]);var nt=Ke.items[q].tokens.filter(function(Y){return Y.type==="space"}),x=nt.every(function(Y){for(var me=Y.raw.split(""),je=0,ze=z(me),Xe;!(Xe=ze()).done;){var et=Xe.value;if(et===`
`&&(je+=1),je>1)return!0}return!1});!Ke.loose&&nt.length&&x&&(Ke.loose=!0,Ke.items[q].loose=!0)}return Ke}},Ee.html=function(se){var fe=this.rules.block.html.exec(se);if(fe){var ee={type:"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:fe[0]};if(this.options.sanitize){var ie=this.options.sanitizer?this.options.sanitizer(fe[0]):b(fe[0]);ee.type="paragraph",ee.text=ie,ee.tokens=this.lexer.inline(ie)}return ee}},Ee.def=function(se){var fe=this.rules.block.def.exec(se);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var ee=fe[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ee,raw:fe[0],href:fe[2],title:fe[3]}}},Ee.table=function(se){var fe=this.rules.block.table.exec(se);if(fe){var ee={type:"table",header:g(fe[1]).map(function(K){return{text:K}}),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:fe[3]&&fe[3].trim()?fe[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ee.header.length===ee.align.length){ee.raw=fe[0];var ie=ee.align.length,he,F,q,J;for(he=0;he<ie;he++)/^ *-+: *$/.test(ee.align[he])?ee.align[he]="right":/^ *:-+: *$/.test(ee.align[he])?ee.align[he]="center":/^ *:-+ *$/.test(ee.align[he])?ee.align[he]="left":ee.align[he]=null;for(ie=ee.rows.length,he=0;he<ie;he++)ee.rows[he]=g(ee.rows[he],ee.header.length).map(function(K){return{text:K}});for(ie=ee.header.length,F=0;F<ie;F++)ee.header[F].tokens=this.lexer.inline(ee.header[F].text);for(ie=ee.rows.length,F=0;F<ie;F++)for(J=ee.rows[F],q=0;q<J.length;q++)J[q].tokens=this.lexer.inline(J[q].text);return ee}}},Ee.lheading=function(se){var fe=this.rules.block.lheading.exec(se);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1],tokens:this.lexer.inline(fe[1])}},Ee.paragraph=function(se){var fe=this.rules.block.paragraph.exec(se);if(fe){var ee=fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1];return{type:"paragraph",raw:fe[0],text:ee,tokens:this.lexer.inline(ee)}}},Ee.text=function(se){var fe=this.rules.block.text.exec(se);if(fe)return{type:"text",raw:fe[0],text:fe[0],tokens:this.lexer.inline(fe[0])}},Ee.escape=function(se){var fe=this.rules.inline.escape.exec(se);if(fe)return{type:"escape",raw:fe[0],text:b(fe[1])}},Ee.tag=function(se){var fe=this.rules.inline.tag.exec(se);if(fe)return!this.lexer.state.inLink&&/^<a /i.test(fe[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(fe[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(fe[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(fe[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:fe[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):b(fe[0]):fe[0]}},Ee.link=function(se){var fe=this.rules.inline.link.exec(se);if(fe){var ee=fe[2].trim();if(!this.options.pedantic&&/^</.test(ee)){if(!/>$/.test(ee))return;var ie=v(ee.slice(0,-1),"\\");if((ee.length-ie.length)%2===0)return}else{var he=u(fe[2],"()");if(he>-1){var F=fe[0].indexOf("!")===0?5:4,q=F+fe[1].length+he;fe[2]=fe[2].substring(0,he),fe[0]=fe[0].substring(0,q).trim(),fe[3]=""}}var J=fe[2],K="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(J);oe&&(J=oe[1],K=oe[3])}else K=fe[3]?fe[3].slice(1,-1):"";return J=J.trim(),/^</.test(J)&&(this.options.pedantic&&!/>$/.test(ee)?J=J.slice(1):J=J.slice(1,-1)),W(fe,{href:J&&J.replace(this.rules.inline._escapes,"$1"),title:K&&K.replace(this.rules.inline._escapes,"$1")},fe[0],this.lexer)}},Ee.reflink=function(se,fe){var ee;if((ee=this.rules.inline.reflink.exec(se))||(ee=this.rules.inline.nolink.exec(se))){var ie=(ee[2]||ee[1]).replace(/\s+/g," ");if(ie=fe[ie.toLowerCase()],!ie||!ie.href){var he=ee[0].charAt(0);return{type:"text",raw:he,text:he}}return W(ee,ie,ee[0],this.lexer)}},Ee.emStrong=function(se,fe,ee){ee===void 0&&(ee="");var ie=this.rules.inline.emStrong.lDelim.exec(se);if(ie&&!(ie[3]&&ee.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var he=ie[1]||ie[2]||"";if(!he||he&&(ee===""||this.rules.inline.punctuation.exec(ee))){var F=ie[0].length-1,q,J,K=F,oe=0,H=ie[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(H.lastIndex=0,fe=fe.slice(-1*se.length+F);(ie=H.exec(fe))!=null;)if(q=ie[1]||ie[2]||ie[3]||ie[4]||ie[5]||ie[6],!!q){if(J=q.length,ie[3]||ie[4]){K+=J;continue}else if((ie[5]||ie[6])&&F%3&&!((F+J)%3)){oe+=J;continue}if(K-=J,!(K>0)){if(J=Math.min(J,J+K+oe),Math.min(F,J)%2){var ce=se.slice(1,F+ie.index+J);return{type:"em",raw:se.slice(0,F+ie.index+J+1),text:ce,tokens:this.lexer.inlineTokens(ce)}}var pe=se.slice(2,F+ie.index+J-1);return{type:"strong",raw:se.slice(0,F+ie.index+J+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}}}}},Ee.codespan=function(se){var fe=this.rules.inline.code.exec(se);if(fe){var ee=fe[2].replace(/\n/g," "),ie=/[^ ]/.test(ee),he=/^ /.test(ee)&&/ $/.test(ee);return ie&&he&&(ee=ee.substring(1,ee.length-1)),ee=b(ee,!0),{type:"codespan",raw:fe[0],text:ee}}},Ee.br=function(se){var fe=this.rules.inline.br.exec(se);if(fe)return{type:"br",raw:fe[0]}},Ee.del=function(se){var fe=this.rules.inline.del.exec(se);if(fe)return{type:"del",raw:fe[0],text:fe[2],tokens:this.lexer.inlineTokens(fe[2])}},Ee.autolink=function(se,fe){var ee=this.rules.inline.autolink.exec(se);if(ee){var ie,he;return ee[2]==="@"?(ie=b(this.options.mangle?fe(ee[1]):ee[1]),he="mailto:"+ie):(ie=b(ee[1]),he=ie),{type:"link",raw:ee[0],text:ie,href:he,tokens:[{type:"text",raw:ie,text:ie}]}}},Ee.url=function(se,fe){var ee;if(ee=this.rules.inline.url.exec(se)){var ie,he;if(ee[2]==="@")ie=b(this.options.mangle?fe(ee[0]):ee[0]),he="mailto:"+ie;else{var F;do F=ee[0],ee[0]=this.rules.inline._backpedal.exec(ee[0])[0];while(F!==ee[0]);ie=b(ee[0]),ee[1]==="www."?he="http://"+ie:he=ie}return{type:"link",raw:ee[0],text:ie,href:he,tokens:[{type:"text",raw:ie,text:ie}]}}},Ee.inlineText=function(se,fe){var ee=this.rules.inline.text.exec(se);if(ee){var ie;return this.lexer.state.inRawBlock?ie=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):b(ee[0]):ee[0]:ie=b(this.options.smartypants?fe(ee[0]):ee[0]),{type:"text",raw:ee[0],text:ie}}},Se}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:D,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=a(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=a(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=a(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=a(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=a(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=a(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=l({},U),U.gfm=l({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=a(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=a(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=l({},U.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:D,paragraph:a(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var O={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:D,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:D,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};O._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",O.punctuation=a(O.punctuation).replace(/punctuation/g,O._punctuation).getRegex(),O.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,O.escapedEmSt=/\\\*|\\_/g,O._comment=a(U._comment).replace("(?:-->|$)","-->").getRegex(),O.emStrong.lDelim=a(O.emStrong.lDelim).replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimAst=a(O.emStrong.rDelimAst,"g").replace(/punct/g,O._punctuation).getRegex(),O.emStrong.rDelimUnd=a(O.emStrong.rDelimUnd,"g").replace(/punct/g,O._punctuation).getRegex(),O._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,O._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,O._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,O.autolink=a(O.autolink).replace("scheme",O._scheme).replace("email",O._email).getRegex(),O._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,O.tag=a(O.tag).replace("comment",O._comment).replace("attribute",O._attribute).getRegex(),O._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,O._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,O._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,O.link=a(O.link).replace("label",O._label).replace("href",O._href).replace("title",O._title).getRegex(),O.reflink=a(O.reflink).replace("label",O._label).replace("ref",U._label).getRegex(),O.nolink=a(O.nolink).replace("ref",U._label).getRegex(),O.reflinkSearch=a(O.reflinkSearch,"g").replace("reflink",O.reflink).replace("nolink",O.nolink).getRegex(),O.normal=l({},O),O.pedantic=l({},O.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",O._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",O._label).getRegex()}),O.gfm=l({},O.normal,{escape:a(O.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),O.gfm.url=a(O.gfm.url,"i").replace("email",O.gfm._extended_email).getRegex(),O.breaks=l({},O.gfm,{br:a(O.br).replace("{2,}","*").getRegex(),text:a(O.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function N(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ae(Se){var Ee="",Ie,se,fe=Se.length;for(Ie=0;Ie<fe;Ie++)se=Se.charCodeAt(Ie),Math.random()>.5&&(se="x"+se.toString(16)),Ee+="&#"+se+";";return Ee}var Q=function(){function Se(Ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ie||$e.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var se={block:U.normal,inline:O.normal};this.options.pedantic?(se.block=U.pedantic,se.inline=O.pedantic):this.options.gfm&&(se.block=U.gfm,this.options.breaks?se.inline=O.breaks:se.inline=O.gfm),this.tokenizer.rules=se}Se.lex=function(se,fe){var ee=new Se(fe);return ee.lex(se)},Se.lexInline=function(se,fe){var ee=new Se(fe);return ee.inlineTokens(se)};var Ee=Se.prototype;return Ee.lex=function(se){se=se.replace(/\r\n|\r/g,`
`),this.blockTokens(se,this.tokens);for(var fe;fe=this.inlineQueue.shift();)this.inlineTokens(fe.src,fe.tokens);return this.tokens},Ee.blockTokens=function(se,fe){var ee=this;fe===void 0&&(fe=[]),this.options.pedantic?se=se.replace(/\t/g,"    ").replace(/^ +$/gm,""):se=se.replace(/^( *)(\t+)/gm,function(K,oe,H){return oe+"    ".repeat(H.length)});for(var ie,he,F,q;se;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(K){return(ie=K.call({lexer:ee},se,fe))?(se=se.substring(ie.raw.length),fe.push(ie),!0):!1}))){if(ie=this.tokenizer.space(se)){se=se.substring(ie.raw.length),ie.raw.length===1&&fe.length>0?fe[fe.length-1].raw+=`
`:fe.push(ie);continue}if(ie=this.tokenizer.code(se)){se=se.substring(ie.raw.length),he=fe[fe.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+ie.raw,he.text+=`
`+ie.text,this.inlineQueue[this.inlineQueue.length-1].src=he.text):fe.push(ie);continue}if(ie=this.tokenizer.fences(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.heading(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.hr(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.blockquote(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.list(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.html(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.def(se)){se=se.substring(ie.raw.length),he=fe[fe.length-1],he&&(he.type==="paragraph"||he.type==="text")?(he.raw+=`
`+ie.raw,he.text+=`
`+ie.raw,this.inlineQueue[this.inlineQueue.length-1].src=he.text):this.tokens.links[ie.tag]||(this.tokens.links[ie.tag]={href:ie.href,title:ie.title});continue}if(ie=this.tokenizer.table(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.lheading(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(F=se,this.options.extensions&&this.options.extensions.startBlock&&function(){var K=1/0,oe=se.slice(1),H=void 0;ee.options.extensions.startBlock.forEach(function(ce){H=ce.call({lexer:this},oe),typeof H=="number"&&H>=0&&(K=Math.min(K,H))}),K<1/0&&K>=0&&(F=se.substring(0,K+1))}(),this.state.top&&(ie=this.tokenizer.paragraph(F))){he=fe[fe.length-1],q&&he.type==="paragraph"?(he.raw+=`
`+ie.raw,he.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):fe.push(ie),q=F.length!==se.length,se=se.substring(ie.raw.length);continue}if(ie=this.tokenizer.text(se)){se=se.substring(ie.raw.length),he=fe[fe.length-1],he&&he.type==="text"?(he.raw+=`
`+ie.raw,he.text+=`
`+ie.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=he.text):fe.push(ie);continue}if(se){var J="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(J);break}else throw new Error(J)}}return this.state.top=!0,fe},Ee.inline=function(se,fe){return fe===void 0&&(fe=[]),this.inlineQueue.push({src:se,tokens:fe}),fe},Ee.inlineTokens=function(se,fe){var ee=this;fe===void 0&&(fe=[]);var ie,he,F,q=se,J,K,oe;if(this.tokens.links){var H=Object.keys(this.tokens.links);if(H.length>0)for(;(J=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)H.includes(J[0].slice(J[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,J.index)+"["+A("a",J[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(J=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,J.index)+"["+A("a",J[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(J=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,J.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;)if(K||(oe=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(pe){return(ie=pe.call({lexer:ee},se,fe))?(se=se.substring(ie.raw.length),fe.push(ie),!0):!1}))){if(ie=this.tokenizer.escape(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.tag(se)){se=se.substring(ie.raw.length),he=fe[fe.length-1],he&&ie.type==="text"&&he.type==="text"?(he.raw+=ie.raw,he.text+=ie.text):fe.push(ie);continue}if(ie=this.tokenizer.link(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(ie.raw.length),he=fe[fe.length-1],he&&ie.type==="text"&&he.type==="text"?(he.raw+=ie.raw,he.text+=ie.text):fe.push(ie);continue}if(ie=this.tokenizer.emStrong(se,q,oe)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.codespan(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.br(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.del(se)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(ie=this.tokenizer.autolink(se,ae)){se=se.substring(ie.raw.length),fe.push(ie);continue}if(!this.state.inLink&&(ie=this.tokenizer.url(se,ae))){se=se.substring(ie.raw.length),fe.push(ie);continue}if(F=se,this.options.extensions&&this.options.extensions.startInline&&function(){var pe=1/0,Oe=se.slice(1),Be=void 0;ee.options.extensions.startInline.forEach(function(Ze){Be=Ze.call({lexer:this},Oe),typeof Be=="number"&&Be>=0&&(pe=Math.min(pe,Be))}),pe<1/0&&pe>=0&&(F=se.substring(0,pe+1))}(),ie=this.tokenizer.inlineText(F,N)){se=se.substring(ie.raw.length),ie.raw.slice(-1)!=="_"&&(oe=ie.raw.slice(-1)),K=!0,he=fe[fe.length-1],he&&he.type==="text"?(he.raw+=ie.raw,he.text+=ie.text):fe.push(ie);continue}if(se){var ce="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ce);break}else throw new Error(ce)}}return fe},w(Se,null,[{key:"rules",get:function(){return{block:U,inline:O}}}]),Se}(),be=function(){function Se(Ie){this.options=Ie||$e.defaults}var Ee=Se.prototype;return Ee.code=function(se,fe,ee){var ie=(fe||"").match(/\S*/)[0];if(this.options.highlight){var he=this.options.highlight(se,ie);he!=null&&he!==se&&(ee=!0,se=he)}return se=se.replace(/\n$/,"")+`
`,ie?'<pre><code class="'+this.options.langPrefix+b(ie,!0)+'">'+(ee?se:b(se,!0))+`</code></pre>
`:"<pre><code>"+(ee?se:b(se,!0))+`</code></pre>
`},Ee.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},Ee.html=function(se){return se},Ee.heading=function(se,fe,ee,ie){if(this.options.headerIds){var he=this.options.headerPrefix+ie.slug(ee);return"<h"+fe+' id="'+he+'">'+se+"</h"+fe+`>
`}return"<h"+fe+">"+se+"</h"+fe+`>
`},Ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Ee.list=function(se,fe,ee){var ie=fe?"ol":"ul",he=fe&&ee!==1?' start="'+ee+'"':"";return"<"+ie+he+`>
`+se+"</"+ie+`>
`},Ee.listitem=function(se){return"<li>"+se+`</li>
`},Ee.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Ee.paragraph=function(se){return"<p>"+se+`</p>
`},Ee.table=function(se,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+fe+`</table>
`},Ee.tablerow=function(se){return`<tr>
`+se+`</tr>
`},Ee.tablecell=function(se,fe){var ee=fe.header?"th":"td",ie=fe.align?"<"+ee+' align="'+fe.align+'">':"<"+ee+">";return ie+se+("</"+ee+`>
`)},Ee.strong=function(se){return"<strong>"+se+"</strong>"},Ee.em=function(se){return"<em>"+se+"</em>"},Ee.codespan=function(se){return"<code>"+se+"</code>"},Ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},Ee.del=function(se){return"<del>"+se+"</del>"},Ee.link=function(se,fe,ee){if(se=C(this.options.sanitize,this.options.baseUrl,se),se===null)return ee;var ie='<a href="'+b(se)+'"';return fe&&(ie+=' title="'+fe+'"'),ie+=">"+ee+"</a>",ie},Ee.image=function(se,fe,ee){if(se=C(this.options.sanitize,this.options.baseUrl,se),se===null)return ee;var ie='<img src="'+se+'" alt="'+ee+'"';return fe&&(ie+=' title="'+fe+'"'),ie+=this.options.xhtml?"/>":">",ie},Ee.text=function(se){return se},Se}(),ke=function(){function Se(){}var Ee=Se.prototype;return Ee.strong=function(se){return se},Ee.em=function(se){return se},Ee.codespan=function(se){return se},Ee.del=function(se){return se},Ee.html=function(se){return se},Ee.text=function(se){return se},Ee.link=function(se,fe,ee){return""+ee},Ee.image=function(se,fe,ee){return""+ee},Ee.br=function(){return""},Se}(),Fe=function(){function Se(){this.seen={}}var Ee=Se.prototype;return Ee.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Ee.getNextSafeSlug=function(se,fe){var ee=se,ie=0;if(this.seen.hasOwnProperty(ee)){ie=this.seen[se];do ie++,ee=se+"-"+ie;while(this.seen.hasOwnProperty(ee))}return fe||(this.seen[se]=ie,this.seen[ee]=0),ee},Ee.slug=function(se,fe){fe===void 0&&(fe={});var ee=this.serialize(se);return this.getNextSafeSlug(ee,fe.dryrun)},Se}(),G=function(){function Se(Ie){this.options=Ie||$e.defaults,this.options.renderer=this.options.renderer||new be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ke,this.slugger=new Fe}Se.parse=function(se,fe){var ee=new Se(fe);return ee.parse(se)},Se.parseInline=function(se,fe){var ee=new Se(fe);return ee.parseInline(se)};var Ee=Se.prototype;return Ee.parse=function(se,fe){fe===void 0&&(fe=!0);var ee="",ie,he,F,q,J,K,oe,H,ce,pe,Oe,Be,Ze,Ke,Qe,Ge,ct,xe,tt,Ne=se.length;for(ie=0;ie<Ne;ie++){if(pe=se[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[pe.type]&&(tt=this.options.extensions.renderers[pe.type].call({parser:this},pe),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(pe.type))){ee+=tt||"";continue}switch(pe.type){case"space":continue;case"hr":{ee+=this.renderer.hr();continue}case"heading":{ee+=this.renderer.heading(this.parseInline(pe.tokens),pe.depth,t(this.parseInline(pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{ee+=this.renderer.code(pe.text,pe.lang,pe.escaped);continue}case"table":{for(H="",oe="",q=pe.header.length,he=0;he<q;he++)oe+=this.renderer.tablecell(this.parseInline(pe.header[he].tokens),{header:!0,align:pe.align[he]});for(H+=this.renderer.tablerow(oe),ce="",q=pe.rows.length,he=0;he<q;he++){for(K=pe.rows[he],oe="",J=K.length,F=0;F<J;F++)oe+=this.renderer.tablecell(this.parseInline(K[F].tokens),{header:!1,align:pe.align[F]});ce+=this.renderer.tablerow(oe)}ee+=this.renderer.table(H,ce);continue}case"blockquote":{ce=this.parse(pe.tokens),ee+=this.renderer.blockquote(ce);continue}case"list":{for(Oe=pe.ordered,Be=pe.start,Ze=pe.loose,q=pe.items.length,ce="",he=0;he<q;he++)Qe=pe.items[he],Ge=Qe.checked,ct=Qe.task,Ke="",Qe.task&&(xe=this.renderer.checkbox(Ge),Ze?Qe.tokens.length>0&&Qe.tokens[0].type==="paragraph"?(Qe.tokens[0].text=xe+" "+Qe.tokens[0].text,Qe.tokens[0].tokens&&Qe.tokens[0].tokens.length>0&&Qe.tokens[0].tokens[0].type==="text"&&(Qe.tokens[0].tokens[0].text=xe+" "+Qe.tokens[0].tokens[0].text)):Qe.tokens.unshift({type:"text",text:xe}):Ke+=xe),Ke+=this.parse(Qe.tokens,Ze),ce+=this.renderer.listitem(Ke,ct,Ge);ee+=this.renderer.list(ce,Oe,Be);continue}case"html":{ee+=this.renderer.html(pe.text);continue}case"paragraph":{ee+=this.renderer.paragraph(this.parseInline(pe.tokens));continue}case"text":{for(ce=pe.tokens?this.parseInline(pe.tokens):pe.text;ie+1<Ne&&se[ie+1].type==="text";)pe=se[++ie],ce+=`
`+(pe.tokens?this.parseInline(pe.tokens):pe.text);ee+=fe?this.renderer.paragraph(ce):ce;continue}default:{var nt='Token with "'+pe.type+'" type was not found.';if(this.options.silent){console.error(nt);return}else throw new Error(nt)}}}return ee},Ee.parseInline=function(se,fe){fe=fe||this.renderer;var ee="",ie,he,F,q=se.length;for(ie=0;ie<q;ie++){if(he=se[ie],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(F=this.options.extensions.renderers[he.type].call({parser:this},he),F!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(he.type))){ee+=F||"";continue}switch(he.type){case"escape":{ee+=fe.text(he.text);break}case"html":{ee+=fe.html(he.text);break}case"link":{ee+=fe.link(he.href,he.title,this.parseInline(he.tokens,fe));break}case"image":{ee+=fe.image(he.href,he.title,he.text);break}case"strong":{ee+=fe.strong(this.parseInline(he.tokens,fe));break}case"em":{ee+=fe.em(this.parseInline(he.tokens,fe));break}case"codespan":{ee+=fe.codespan(he.text);break}case"br":{ee+=fe.br();break}case"del":{ee+=fe.del(this.parseInline(he.tokens,fe));break}case"text":{ee+=fe.text(he.text);break}default:{var J='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return ee},Se}();function Z(Se,Ee,Ie){if(typeof Se>"u"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof Ee=="function"&&(Ie=Ee,Ee=null),Ee=l({},Z.defaults,Ee||{}),f(Ee),Ie){var se=Ee.highlight,fe;try{fe=Q.lex(Se,Ee)}catch(q){return Ie(q)}var ee=function(J){var K;if(!J)try{Ee.walkTokens&&Z.walkTokens(fe,Ee.walkTokens),K=G.parse(fe,Ee)}catch(oe){J=oe}return Ee.highlight=se,J?Ie(J):Ie(null,K)};if(!se||se.length<3||(delete Ee.highlight,!fe.length))return ee();var ie=0;Z.walkTokens(fe,function(q){q.type==="code"&&(ie++,setTimeout(function(){se(q.text,q.lang,function(J,K){if(J)return ee(J);K!=null&&K!==q.text&&(q.text=K,q.escaped=!0),ie--,ie===0&&ee()})},0))}),ie===0&&ee();return}function he(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+b(q.message+"",!0)+"</pre>";throw q}try{var F=Q.lex(Se,Ee);if(Ee.walkTokens){if(Ee.async)return Promise.all(Z.walkTokens(F,Ee.walkTokens)).then(function(){return G.parse(F,Ee)}).catch(he);Z.walkTokens(F,Ee.walkTokens)}return G.parse(F,Ee)}catch(q){he(q)}}Z.options=Z.setOptions=function(Se){return l(Z.defaults,Se),d(Z.defaults),Z},Z.getDefaults=P,Z.defaults=$e.defaults,Z.use=function(){for(var Se=arguments.length,Ee=new Array(Se),Ie=0;Ie<Se;Ie++)Ee[Ie]=arguments[Ie];var se=l.apply(void 0,[{}].concat(Ee)),fe=Z.defaults.extensions||{renderers:{},childTokens:{}},ee;Ee.forEach(function(ie){if(ie.extensions&&(ee=!0,ie.extensions.forEach(function(F){if(!F.name)throw new Error("extension name required");if(F.renderer){var q=fe.renderers?fe.renderers[F.name]:null;q?fe.renderers[F.name]=function(){for(var J=arguments.length,K=new Array(J),oe=0;oe<J;oe++)K[oe]=arguments[oe];var H=F.renderer.apply(this,K);return H===!1&&(H=q.apply(this,K)),H}:fe.renderers[F.name]=F.renderer}if(F.tokenizer){if(!F.level||F.level!=="block"&&F.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");fe[F.level]?fe[F.level].unshift(F.tokenizer):fe[F.level]=[F.tokenizer],F.start&&(F.level==="block"?fe.startBlock?fe.startBlock.push(F.start):fe.startBlock=[F.start]:F.level==="inline"&&(fe.startInline?fe.startInline.push(F.start):fe.startInline=[F.start]))}F.childTokens&&(fe.childTokens[F.name]=F.childTokens)})),ie.renderer&&function(){var F=Z.defaults.renderer||new be,q=function(oe){var H=F[oe];F[oe]=function(){for(var ce=arguments.length,pe=new Array(ce),Oe=0;Oe<ce;Oe++)pe[Oe]=arguments[Oe];var Be=ie.renderer[oe].apply(F,pe);return Be===!1&&(Be=H.apply(F,pe)),Be}};for(var J in ie.renderer)q(J);se.renderer=F}(),ie.tokenizer&&function(){var F=Z.defaults.tokenizer||new V,q=function(oe){var H=F[oe];F[oe]=function(){for(var ce=arguments.length,pe=new Array(ce),Oe=0;Oe<ce;Oe++)pe[Oe]=arguments[Oe];var Be=ie.tokenizer[oe].apply(F,pe);return Be===!1&&(Be=H.apply(F,pe)),Be}};for(var J in ie.tokenizer)q(J);se.tokenizer=F}(),ie.walkTokens){var he=Z.defaults.walkTokens;se.walkTokens=function(F){var q=[];return q.push(ie.walkTokens.call(this,F)),he&&(q=q.concat(he.call(this,F))),q}}ee&&(se.extensions=fe),Z.setOptions(se)})},Z.walkTokens=function(Se,Ee){for(var Ie=[],se=function(){var he=ee.value;switch(Ie=Ie.concat(Ee.call(Z,he)),he.type){case"table":{for(var F=z(he.header),q;!(q=F()).done;){var J=q.value;Ie=Ie.concat(Z.walkTokens(J.tokens,Ee))}for(var K=z(he.rows),oe;!(oe=K()).done;)for(var H=oe.value,ce=z(H),pe;!(pe=ce()).done;){var Oe=pe.value;Ie=Ie.concat(Z.walkTokens(Oe.tokens,Ee))}break}case"list":{Ie=Ie.concat(Z.walkTokens(he.items,Ee));break}default:Z.defaults.extensions&&Z.defaults.extensions.childTokens&&Z.defaults.extensions.childTokens[he.type]?Z.defaults.extensions.childTokens[he.type].forEach(function(Be){Ie=Ie.concat(Z.walkTokens(he[Be],Ee))}):he.tokens&&(Ie=Ie.concat(Z.walkTokens(he.tokens,Ee)))}},fe=z(Se),ee;!(ee=fe()).done;)se();return Ie},Z.parseInline=function(Se,Ee){if(typeof Se>"u"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");Ee=l({},Z.defaults,Ee||{}),f(Ee);try{var Ie=Q.lexInline(Se,Ee);return Ee.walkTokens&&Z.walkTokens(Ie,Ee.walkTokens),G.parseInline(Ie,Ee)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,Ee.silent)return"<p>An error occurred:</p><pre>"+b(se.message+"",!0)+"</pre>";throw se}},Z.Parser=G,Z.parser=G.parse,Z.Renderer=be,Z.TextRenderer=ke,Z.Lexer=Q,Z.lexer=Q.lex,Z.Tokenizer=V,Z.Slugger=Fe,Z.parse=Z;var le=Z.options,ne=Z.setOptions,de=Z.use,ue=Z.walkTokens,T=Z.parseInline,_=Z,ye=G.parse,Ce=Q.lex;$e.Lexer=Q,$e.Parser=G,$e.Renderer=be,$e.Slugger=Fe,$e.TextRenderer=ke,$e.Tokenizer=V,$e.getDefaults=P,$e.lexer=Ce,$e.marked=Z,$e.options=le,$e.parse=_,$e.parseInline=T,$e.parser=ye,$e.setOptions=ne,$e.use=de,$e.walkTokens=ue,Object.defineProperty($e,"__esModule",{value:!0})}),define(Ae[117],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vl=e.$ul=e.$tl=e.rot=e.$rl=void 0;function w(d,k,$){return Math.min(Math.max(d,k),$)}e.$rl=w;function L(d,k){return(k+d%k)%k}e.rot=L;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$tl=I;class z{constructor(){this.a=1,this.b=0}update(k){return this.b=this.b+(k-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$ul=z;class P{constructor(k){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(k),this.c.fill(0,0,k)}update(k){const $=this.c[this.d];return this.c[this.d]=k,this.d=(this.d+1)%this.c.length,this.e-=$,this.e+=k,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$vl=P}),function(){function $e(I){const z=[];typeof I=="number"&&z.push("code/timeOrigin",I);function P(k){z.push(k,Date.now())}function d(){const k=[];for(let $=0;$<z.length;$+=2)k.push({name:z[$],startTime:z[$+1]});return k}return{mark:P,getMarks:d}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const z=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const P of performance.getEntriesByType("mark"))z.push({name:P.name,startTime:Math.round(I+P.startTime)});return z}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function w(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=w(L))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var w=e();for(var L in w)(typeof exports=="object"?exports:$e)[L]=w[L]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function w(L){if(e[L])return e[L].exports;var I=e[L]={i:L,l:!1,exports:{}};return $e[L].call(I.exports,I,I.exports,w),I.l=!0,I.exports}return w.m=$e,w.c=e,w.d=function(L,I,z){w.o(L,I)||Object.defineProperty(L,I,{enumerable:!0,get:z})},w.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},w.t=function(L,I){if(1&I&&(L=w(L)),8&I||4&I&&typeof L=="object"&&L&&L.__esModule)return L;var z=Object.create(null);if(w.r(z),Object.defineProperty(z,"default",{enumerable:!0,value:L}),2&I&&typeof L!="string")for(var P in L)w.d(z,P,function(d){return L[d]}.bind(null,P));return z},w.n=function(L){var I=L&&L.__esModule?function(){return L.default}:function(){return L};return w.d(I,"a",I),I},w.o=function(L,I){return Object.prototype.hasOwnProperty.call(L,I)},w.p="",w(w.s=0)}([function($e,e,w){(function(L){var I;e=$e.exports=de,I=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var H=Array.prototype.slice.call(arguments,0);H.unshift("SEMVER"),console.log.apply(console,H)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var z=256,P=Number.MAX_SAFE_INTEGER||9007199254740991,d=e.re=[],k=e.src=[],$=0,R=$++;k[R]="0|[1-9]\\d*";var E=$++;k[E]="[0-9]+";var c=$++;k[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=$++;k[y]="("+k[R]+")\\.("+k[R]+")\\.("+k[R]+")";var b=$++;k[b]="("+k[E]+")\\.("+k[E]+")\\.("+k[E]+")";var o=$++;k[o]="(?:"+k[R]+"|"+k[c]+")";var t=$++;k[t]="(?:"+k[E]+"|"+k[c]+")";var i=$++;k[i]="(?:-("+k[o]+"(?:\\."+k[o]+")*))";var a=$++;k[a]="(?:-?("+k[t]+"(?:\\."+k[t]+")*))";var m=$++;k[m]="[0-9A-Za-z-]+";var S=$++;k[S]="(?:\\+("+k[m]+"(?:\\."+k[m]+")*))";var C=$++,r="v?"+k[y]+k[i]+"?"+k[S]+"?";k[C]="^"+r+"$";var h="[v=\\s]*"+k[b]+k[a]+"?"+k[S]+"?",n=$++;k[n]="^"+h+"$";var s=$++;k[s]="((?:<|>)?=?)";var p=$++;k[p]=k[E]+"|x|X|\\*";var D=$++;k[D]=k[R]+"|x|X|\\*";var l=$++;k[l]="[v=\\s]*("+k[D]+")(?:\\.("+k[D]+")(?:\\.("+k[D]+")(?:"+k[i]+")?"+k[S]+"?)?)?";var g=$++;k[g]="[v=\\s]*("+k[p]+")(?:\\.("+k[p]+")(?:\\.("+k[p]+")(?:"+k[a]+")?"+k[S]+"?)?)?";var v=$++;k[v]="^"+k[s]+"\\s*"+k[l]+"$";var u=$++;k[u]="^"+k[s]+"\\s*"+k[g]+"$";var f=$++;k[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=$++;k[A]="(?:~>?)";var W=$++;k[W]="(\\s*)"+k[A]+"\\s+",d[W]=new RegExp(k[W],"g");var B=$++;k[B]="^"+k[A]+k[l]+"$";var V=$++;k[V]="^"+k[A]+k[g]+"$";var U=$++;k[U]="(?:\\^)";var O=$++;k[O]="(\\s*)"+k[U]+"\\s+",d[O]=new RegExp(k[O],"g");var N=$++;k[N]="^"+k[U]+k[l]+"$";var ae=$++;k[ae]="^"+k[U]+k[g]+"$";var Q=$++;k[Q]="^"+k[s]+"\\s*("+h+")$|^$";var be=$++;k[be]="^"+k[s]+"\\s*("+r+")$|^$";var ke=$++;k[ke]="(\\s*)"+k[s]+"\\s*("+h+"|"+k[l]+")",d[ke]=new RegExp(k[ke],"g");var Fe=$++;k[Fe]="^\\s*("+k[l]+")\\s+-\\s+("+k[l]+")\\s*$";var G=$++;k[G]="^\\s*("+k[g]+")\\s+-\\s+("+k[g]+")\\s*$";var Z=$++;k[Z]="(<|>)?=?\\s*\\*";for(var le=0;le<35;le++)I(le,k[le]),d[le]||(d[le]=new RegExp(k[le]));function ne(H,ce){if(H instanceof de)return H;if(typeof H!="string"||H.length>z||!(ce?d[n]:d[C]).test(H))return null;try{return new de(H,ce)}catch{return null}}function de(H,ce){if(H instanceof de){if(H.loose===ce)return H;H=H.version}else if(typeof H!="string")throw new TypeError("Invalid Version: "+H);if(H.length>z)throw new TypeError("version is longer than "+z+" characters");if(!(this instanceof de))return new de(H,ce);I("SemVer",H,ce),this.loose=ce;var pe=H.trim().match(ce?d[n]:d[C]);if(!pe)throw new TypeError("Invalid Version: "+H);if(this.raw=H,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>P||this.major<0)throw new TypeError("Invalid major version");if(this.minor>P||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>P||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Oe){if(/^[0-9]+$/.test(Oe)){var Be=+Oe;if(Be>=0&&Be<P)return Be}return Oe}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=ne,e.valid=function(H,ce){var pe=ne(H,ce);return pe?pe.version:null},e.clean=function(H,ce){var pe=ne(H.trim().replace(/^[=v]+/,""),ce);return pe?pe.version:null},e.SemVer=de,de.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},de.prototype.toString=function(){return this.version},de.prototype.compare=function(H){return I("SemVer.compare",this.version,this.loose,H),H instanceof de||(H=new de(H,this.loose)),this.compareMain(H)||this.comparePre(H)},de.prototype.compareMain=function(H){return H instanceof de||(H=new de(H,this.loose)),T(this.major,H.major)||T(this.minor,H.minor)||T(this.patch,H.patch)},de.prototype.comparePre=function(H){if(H instanceof de||(H=new de(H,this.loose)),this.prerelease.length&&!H.prerelease.length)return-1;if(!this.prerelease.length&&H.prerelease.length)return 1;if(!this.prerelease.length&&!H.prerelease.length)return 0;var ce=0;do{var pe=this.prerelease[ce],Oe=H.prerelease[ce];if(I("prerelease compare",ce,pe,Oe),pe===void 0&&Oe===void 0)return 0;if(Oe===void 0)return 1;if(pe===void 0)return-1;if(pe!==Oe)return T(pe,Oe)}while(++ce)},de.prototype.inc=function(H,ce){switch(H){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ce),this.inc("pre",ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ce),this.inc("pre",ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}ce&&(this.prerelease[0]===ce?isNaN(this.prerelease[1])&&(this.prerelease=[ce,0]):this.prerelease=[ce,0]);break;default:throw new Error("invalid increment argument: "+H)}return this.format(),this.raw=this.version,this},e.inc=function(H,ce,pe,Oe){typeof pe=="string"&&(Oe=pe,pe=void 0);try{return new de(H,pe).inc(ce,Oe).version}catch{return null}},e.diff=function(H,ce){if(Se(H,ce))return null;var pe=ne(H),Oe=ne(ce);if(pe.prerelease.length||Oe.prerelease.length){for(var Be in pe)if((Be==="major"||Be==="minor"||Be==="patch")&&pe[Be]!==Oe[Be])return"pre"+Be;return"prerelease"}for(var Be in pe)if((Be==="major"||Be==="minor"||Be==="patch")&&pe[Be]!==Oe[Be])return Be},e.compareIdentifiers=T;var ue=/^[0-9]+$/;function T(H,ce){var pe=ue.test(H),Oe=ue.test(ce);return pe&&Oe&&(H=+H,ce=+ce),pe&&!Oe?-1:Oe&&!pe?1:H<ce?-1:H>ce?1:0}function _(H,ce,pe){return new de(H,pe).compare(new de(ce,pe))}function ye(H,ce,pe){return _(H,ce,pe)>0}function Ce(H,ce,pe){return _(H,ce,pe)<0}function Se(H,ce,pe){return _(H,ce,pe)===0}function Ee(H,ce,pe){return _(H,ce,pe)!==0}function Ie(H,ce,pe){return _(H,ce,pe)>=0}function se(H,ce,pe){return _(H,ce,pe)<=0}function fe(H,ce,pe,Oe){var Be;switch(ce){case"===":typeof H=="object"&&(H=H.version),typeof pe=="object"&&(pe=pe.version),Be=H===pe;break;case"!==":typeof H=="object"&&(H=H.version),typeof pe=="object"&&(pe=pe.version),Be=H!==pe;break;case"":case"=":case"==":Be=Se(H,pe,Oe);break;case"!=":Be=Ee(H,pe,Oe);break;case">":Be=ye(H,pe,Oe);break;case">=":Be=Ie(H,pe,Oe);break;case"<":Be=Ce(H,pe,Oe);break;case"<=":Be=se(H,pe,Oe);break;default:throw new TypeError("Invalid operator: "+ce)}return Be}function ee(H,ce){if(H instanceof ee){if(H.loose===ce)return H;H=H.value}if(!(this instanceof ee))return new ee(H,ce);I("comparator",H,ce),this.loose=ce,this.parse(H),this.semver===ie?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(H,ce){return T(ce,H)},e.major=function(H,ce){return new de(H,ce).major},e.minor=function(H,ce){return new de(H,ce).minor},e.patch=function(H,ce){return new de(H,ce).patch},e.compare=_,e.compareLoose=function(H,ce){return _(H,ce,!0)},e.rcompare=function(H,ce,pe){return _(ce,H,pe)},e.sort=function(H,ce){return H.sort(function(pe,Oe){return e.compare(pe,Oe,ce)})},e.rsort=function(H,ce){return H.sort(function(pe,Oe){return e.rcompare(pe,Oe,ce)})},e.gt=ye,e.lt=Ce,e.eq=Se,e.neq=Ee,e.gte=Ie,e.lte=se,e.cmp=fe,e.Comparator=ee;var ie={};function he(H,ce){if(H instanceof he)return H.loose===ce?H:new he(H.raw,ce);if(H instanceof ee)return new he(H.value,ce);if(!(this instanceof he))return new he(H,ce);if(this.loose=ce,this.raw=H,this.set=H.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+H);this.format()}function F(H){return!H||H.toLowerCase()==="x"||H==="*"}function q(H,ce,pe,Oe,Be,Ze,Ke,Qe,Ge,ct,xe,tt,Ne){return((ce=F(pe)?"":F(Oe)?">="+pe+".0.0":F(Be)?">="+pe+"."+Oe+".0":">="+ce)+" "+(Qe=F(Ge)?"":F(ct)?"<"+(+Ge+1)+".0.0":F(xe)?"<"+Ge+"."+(+ct+1)+".0":tt?"<="+Ge+"."+ct+"."+xe+"-"+tt:"<="+Qe)).trim()}function J(H,ce){for(var pe=0;pe<H.length;pe++)if(!H[pe].test(ce))return!1;if(ce.prerelease.length){for(pe=0;pe<H.length;pe++)if(I(H[pe].semver),H[pe].semver!==ie&&H[pe].semver.prerelease.length>0){var Oe=H[pe].semver;if(Oe.major===ce.major&&Oe.minor===ce.minor&&Oe.patch===ce.patch)return!0}return!1}return!0}function K(H,ce,pe){try{ce=new he(ce,pe)}catch{return!1}return ce.test(H)}function oe(H,ce,pe,Oe){var Be,Ze,Ke,Qe,Ge;switch(H=new de(H,Oe),ce=new he(ce,Oe),pe){case">":Be=ye,Ze=se,Ke=Ce,Qe=">",Ge=">=";break;case"<":Be=Ce,Ze=Ie,Ke=ye,Qe="<",Ge="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(K(H,ce,Oe))return!1;for(var ct=0;ct<ce.set.length;++ct){var xe=ce.set[ct],tt=null,Ne=null;if(xe.forEach(function(nt){nt.semver===ie&&(nt=new ee(">=0.0.0")),tt=tt||nt,Ne=Ne||nt,Be(nt.semver,tt.semver,Oe)?tt=nt:Ke(nt.semver,Ne.semver,Oe)&&(Ne=nt)}),tt.operator===Qe||tt.operator===Ge||(!Ne.operator||Ne.operator===Qe)&&Ze(H,Ne.semver)||Ne.operator===Ge&&Ke(H,Ne.semver))return!1}return!0}ee.prototype.parse=function(H){var ce=this.loose?d[Q]:d[be],pe=H.match(ce);if(!pe)throw new TypeError("Invalid comparator: "+H);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new de(pe[2],this.loose):this.semver=ie},ee.prototype.toString=function(){return this.value},ee.prototype.test=function(H){return I("Comparator.test",H,this.loose),this.semver===ie||(typeof H=="string"&&(H=new de(H,this.loose)),fe(H,this.operator,this.semver,this.loose))},ee.prototype.intersects=function(H,ce){if(!(H instanceof ee))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new he(H.value,ce),K(this.value,pe,ce);if(H.operator==="")return pe=new he(this.value,ce),K(H.semver,pe,ce);var Oe=!(this.operator!==">="&&this.operator!==">"||H.operator!==">="&&H.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||H.operator!=="<="&&H.operator!=="<"),Ze=this.semver.version===H.semver.version,Ke=!(this.operator!==">="&&this.operator!=="<="||H.operator!==">="&&H.operator!=="<="),Qe=fe(this.semver,"<",H.semver,ce)&&(this.operator===">="||this.operator===">")&&(H.operator==="<="||H.operator==="<"),Ge=fe(this.semver,">",H.semver,ce)&&(this.operator==="<="||this.operator==="<")&&(H.operator===">="||H.operator===">");return Oe||Be||Ze&&Ke||Qe||Ge},e.Range=he,he.prototype.format=function(){return this.range=this.set.map(function(H){return H.join(" ").trim()}).join("||").trim(),this.range},he.prototype.toString=function(){return this.range},he.prototype.parseRange=function(H){var ce=this.loose;H=H.trim(),I("range",H,ce);var pe=ce?d[G]:d[Fe];H=H.replace(pe,q),I("hyphen replace",H),H=H.replace(d[ke],"$1$2$3"),I("comparator trim",H,d[ke]),H=(H=(H=H.replace(d[W],"$1~")).replace(d[O],"$1^")).split(/\s+/).join(" ");var Oe=ce?d[Q]:d[be],Be=H.split(" ").map(function(Ze){return function(Ke,Qe){return I("comp",Ke),Ke=function(Ge,ct){return Ge.trim().split(/\s+/).map(function(xe){return function(tt,Ne){I("caret",tt,Ne);var nt=Ne?d[ae]:d[N];return tt.replace(nt,function(x,Y,me,je,ze){var Xe;return I("caret",tt,x,Y,me,je,ze),F(Y)?Xe="":F(me)?Xe=">="+Y+".0.0 <"+(+Y+1)+".0.0":F(je)?Xe=Y==="0"?">="+Y+"."+me+".0 <"+Y+"."+(+me+1)+".0":">="+Y+"."+me+".0 <"+(+Y+1)+".0.0":ze?(I("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Xe=Y==="0"?me==="0"?">="+Y+"."+me+"."+je+ze+" <"+Y+"."+me+"."+(+je+1):">="+Y+"."+me+"."+je+ze+" <"+Y+"."+(+me+1)+".0":">="+Y+"."+me+"."+je+ze+" <"+(+Y+1)+".0.0"):(I("no pr"),Xe=Y==="0"?me==="0"?">="+Y+"."+me+"."+je+" <"+Y+"."+me+"."+(+je+1):">="+Y+"."+me+"."+je+" <"+Y+"."+(+me+1)+".0":">="+Y+"."+me+"."+je+" <"+(+Y+1)+".0.0"),I("caret return",Xe),Xe})}(xe,ct)}).join(" ")}(Ke,Qe),I("caret",Ke),Ke=function(Ge,ct){return Ge.trim().split(/\s+/).map(function(xe){return function(tt,Ne){var nt=Ne?d[V]:d[B];return tt.replace(nt,function(x,Y,me,je,ze){var Xe;return I("tilde",tt,x,Y,me,je,ze),F(Y)?Xe="":F(me)?Xe=">="+Y+".0.0 <"+(+Y+1)+".0.0":F(je)?Xe=">="+Y+"."+me+".0 <"+Y+"."+(+me+1)+".0":ze?(I("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Xe=">="+Y+"."+me+"."+je+ze+" <"+Y+"."+(+me+1)+".0"):Xe=">="+Y+"."+me+"."+je+" <"+Y+"."+(+me+1)+".0",I("tilde return",Xe),Xe})}(xe,ct)}).join(" ")}(Ke,Qe),I("tildes",Ke),Ke=function(Ge,ct){return I("replaceXRanges",Ge,ct),Ge.split(/\s+/).map(function(xe){return function(tt,Ne){tt=tt.trim();var nt=Ne?d[u]:d[v];return tt.replace(nt,function(x,Y,me,je,ze,Xe){I("xRange",tt,x,Y,me,je,ze,Xe);var et=F(me),gt=et||F(je),wt=gt||F(ze);return Y==="="&&wt&&(Y=""),et?x=Y===">"||Y==="<"?"<0.0.0":"*":Y&&wt?(gt&&(je=0),wt&&(ze=0),Y===">"?(Y=">=",gt?(me=+me+1,je=0,ze=0):wt&&(je=+je+1,ze=0)):Y==="<="&&(Y="<",gt?me=+me+1:je=+je+1),x=Y+me+"."+je+"."+ze):gt?x=">="+me+".0.0 <"+(+me+1)+".0.0":wt&&(x=">="+me+"."+je+".0 <"+me+"."+(+je+1)+".0"),I("xRange return",x),x})}(xe,ct)}).join(" ")}(Ke,Qe),I("xrange",Ke),Ke=function(Ge,ct){return I("replaceStars",Ge,ct),Ge.trim().replace(d[Z],"")}(Ke,Qe),I("stars",Ke),Ke}(Ze,ce)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ze){return!!Ze.match(Oe)})),Be=Be.map(function(Ze){return new ee(Ze,ce)})},he.prototype.intersects=function(H,ce){if(!(H instanceof he))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Oe){return H.set.some(function(Be){return Be.every(function(Ze){return Oe.intersects(Ze,ce)})})})})},e.toComparators=function(H,ce){return new he(H,ce).set.map(function(pe){return pe.map(function(Oe){return Oe.value}).join(" ").trim().split(" ")})},he.prototype.test=function(H){if(!H)return!1;typeof H=="string"&&(H=new de(H,this.loose));for(var ce=0;ce<this.set.length;ce++)if(J(this.set[ce],H))return!0;return!1},e.satisfies=K,e.maxSatisfying=function(H,ce,pe){var Oe=null,Be=null;try{var Ze=new he(ce,pe)}catch{return null}return H.forEach(function(Ke){Ze.test(Ke)&&(Oe&&Be.compare(Ke)!==-1||(Be=new de(Oe=Ke,pe)))}),Oe},e.minSatisfying=function(H,ce,pe){var Oe=null,Be=null;try{var Ze=new he(ce,pe)}catch{return null}return H.forEach(function(Ke){Ze.test(Ke)&&(Oe&&Be.compare(Ke)!==1||(Be=new de(Oe=Ke,pe)))}),Oe},e.validRange=function(H,ce){try{return new he(H,ce).range||"*"}catch{return null}},e.ltr=function(H,ce,pe){return oe(H,ce,"<",pe)},e.gtr=function(H,ce,pe){return oe(H,ce,">",pe)},e.outside=oe,e.prerelease=function(H,ce){var pe=ne(H,ce);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(H,ce,pe){return H=new he(H,pe),ce=new he(ce,pe),H.intersects(ce)},e.coerce=function(H){if(H instanceof de)return H;if(typeof H!="string")return null;var ce=H.match(d[f]);return ce==null?null:ne((ce[1]||"0")+"."+(ce[2]||"0")+"."+(ce[3]||"0"))}}).call(this,w(1))},function($e,e){var w,L,I=$e.exports={};function z(){throw new Error("setTimeout has not been defined")}function P(){throw new Error("clearTimeout has not been defined")}function d(t){if(w===setTimeout)return setTimeout(t,0);if((w===z||!w)&&setTimeout)return w=setTimeout,setTimeout(t,0);try{return w(t,0)}catch{try{return w.call(null,t,0)}catch{return w.call(this,t,0)}}}(function(){try{w=typeof setTimeout=="function"?setTimeout:z}catch{w=z}try{L=typeof clearTimeout=="function"?clearTimeout:P}catch{L=P}})();var k,$=[],R=!1,E=-1;function c(){R&&k&&(R=!1,k.length?$=k.concat($):E=-1,$.length&&y())}function y(){if(!R){var t=d(c);R=!0;for(var i=$.length;i;){for(k=$,$=[];++E<i;)k&&k[E].run();E=-1,i=$.length}k=null,R=!1,function(a){if(L===clearTimeout)return clearTimeout(a);if((L===P||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(a);try{L(a)}catch{try{return L.call(null,a)}catch{return L.call(this,a)}}}(t)}}function b(t,i){this.fun=t,this.array=i}function o(){}I.nextTick=function(t){var i=new Array(arguments.length-1);if(arguments.length>1)for(var a=1;a<arguments.length;a++)i[a-1]=arguments[a];$.push(new b(t,i)),$.length!==1||R||d(y)},b.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=o,I.addListener=o,I.once=o,I.off=o,I.removeListener=o,I.removeAllListeners=o,I.emit=o,I.prependListener=o,I.prependOnceListener=o,I.listeners=function(t){return[]},I.binding=function(t){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(t){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Ae[118],Re([1,0,11,6]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function I(S){const C=S;return C?typeof C.read=="function":!1}e.$ub=I;function z(S){const C=S;return C?[C.on,C.pause,C.resume,C.destroy].every(r=>typeof r=="function"):!1}e.$vb=z;function P(S){const C=S;return C?z(C.stream)&&Array.isArray(C.buffer)&&typeof C.ended=="boolean":!1}e.$wb=P;function d(S,C){return new k(S,C)}e.$xb=d;class k{constructor(C,r){this.e=C,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(C){if(!this.a.destroyed){if(this.a.flowing)this.g(C);else if(this.b.data.push(C),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(C){this.a.destroyed||(this.a.flowing?this.h(C):this.b.error.push(C))}end(C){this.a.destroyed||(typeof C<"u"&&this.write(C),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(C){this.c.data.slice(0).forEach(r=>r(C))}h(C){this.c.error.length===0?(0,w.$Y)(C):this.c.error.slice(0).forEach(r=>r(C))}i(){this.c.end.slice(0).forEach(C=>C())}on(C,r){if(!this.a.destroyed)switch(C){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(C,r){if(this.a.destroyed)return;let h;switch(C){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const n=h.indexOf(r);n>=0&&h.splice(n,1)}}j(){if(this.b.data.length>0){const C=this.e(this.b.data);this.g(C),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const C of this.b.error)this.h(C);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function $(S,C){const r=[];let h;for(;(h=S.read())!==null;)r.push(h);return C(r)}e.$yb=$;function R(S,C,r){const h=[];let n;for(;(n=S.read())!==null&&h.length<r;)h.push(n);return n===null&&h.length>0?C(h):{read:()=>{if(h.length>0)return h.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return S.read()}}}e.$zb=R;function E(S,C){return new Promise((r,h)=>{const n=[];c(S,{onData:s=>{C&&n.push(s)},onError:s=>{C?h(s):r(void 0)},onEnd:()=>{r(C?C(n):void 0)}})})}e.$Ab=E;function c(S,C){let r=!1;return S.on("error",h=>{r||C.onError(h)}),S.on("end",()=>{r||C.onEnd()}),S.on("data",h=>{r||C.onData(h)}),(0,L.$jb)(()=>r=!0)}e.$Bb=c;function y(S,C){return new Promise((r,h)=>{const n=new L.$kb,s=[],p=g=>{if(s.push(g),s.length>C)return n.dispose(),S.pause(),r({stream:S,buffer:s,ended:!1})},D=g=>h(g),l=()=>r({stream:S,buffer:s,ended:!0});n.add((0,L.$jb)(()=>S.removeListener("error",D))),S.on("error",D),n.add((0,L.$jb)(()=>S.removeListener("end",l))),S.on("end",l),n.add((0,L.$jb)(()=>S.removeListener("data",p))),S.on("data",p)})}e.$Cb=y;function b(S,C){const r=d(C);return r.end(S),r}e.$Db=b;function o(){const S=d(()=>{throw new Error("not supported")});return S.end(),S}e.$Eb=o;function t(S){let C=!1;return{read:()=>C?null:(C=!0,S)}}e.$Fb=t;function i(S,C,r){const h=d(r);return c(S,{onData:n=>h.write(C.data(n)),onError:n=>h.error(C.error?C.error(n):n),onEnd:()=>h.end()}),h}e.$Gb=i;function a(S,C,r){let h=!1;return{read:()=>{const n=C.read();return h?n:(h=!0,n!==null?r([S,n]):S)}}}e.$Hb=a;function m(S,C,r){let h=!1;const n=d(r);return c(C,{onData:s=>h?n.write(s):(h=!0,n.write(r([S,s]))),onError:s=>n.error(s),onEnd:()=>{h||(h=!0,n.write(S)),n.end()}}),n}e.$Ib=m}),define(Ae[25],Re([1,0,67,118]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const I=typeof Buffer<"u",z=new w.$T(()=>new Uint8Array(256));let P,d;class k{static alloc(f){return I?new k(Buffer.allocUnsafe(f)):new k(new Uint8Array(f))}static wrap(f){return I&&!Buffer.isBuffer(f)&&(f=Buffer.from(f.buffer,f.byteOffset,f.byteLength)),new k(f)}static fromString(f,A){return!(A?.dontUseNodeBuffer||!1)&&I?new k(Buffer.from(f)):(P||(P=new TextEncoder),new k(P.encode(f)))}static fromByteArray(f){const A=k.alloc(f.length);for(let W=0,B=f.length;W<B;W++)A.buffer[W]=f[W];return A}static concat(f,A){if(typeof A>"u"){A=0;for(let V=0,U=f.length;V<U;V++)A+=f[V].byteLength}const W=k.alloc(A);let B=0;for(let V=0,U=f.length;V<U;V++){const O=f[V];W.set(O,B),B+=O.byteLength}return W}constructor(f){this.buffer=f,this.byteLength=this.buffer.byteLength}clone(){const f=k.alloc(this.byteLength);return f.set(this),f}toString(){return I?this.buffer.toString():(d||(d=new TextDecoder),d.decode(this.buffer))}slice(f,A){return new k(this.buffer.subarray(f,A))}set(f,A){if(f instanceof k)this.buffer.set(f.buffer,A);else if(f instanceof Uint8Array)this.buffer.set(f,A);else if(f instanceof ArrayBuffer)this.buffer.set(new Uint8Array(f),A);else if(ArrayBuffer.isView(f))this.buffer.set(new Uint8Array(f.buffer,f.byteOffset,f.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(f){return c(this.buffer,f)}writeUInt32BE(f,A){y(this.buffer,f,A)}readUInt32LE(f){return b(this.buffer,f)}writeUInt32LE(f,A){o(this.buffer,f,A)}readUInt8(f){return t(this.buffer,f)}writeUInt8(f,A){i(this.buffer,f,A)}indexOf(f,A=0){return $(this.buffer,f instanceof k?f.buffer:f,A)}}e.$Jb=k;function $(u,f,A=0){const W=f.byteLength,B=u.byteLength;if(W===0)return 0;if(W===1)return u.indexOf(f[0]);if(W>B-A)return-1;const V=z.value;V.fill(f.length);for(let ae=0;ae<f.length;ae++)V[f[ae]]=f.length-ae-1;let U=A+f.length-1,O=U,N=-1;for(;U<B;)if(u[U]===f[O]){if(O===0){N=U;break}U--,O--}else U+=Math.max(f.length-O,V[u[U]]),O=f.length-1;return N}e.$Kb=$;function R(u,f){return u[f+0]<<0>>>0|u[f+1]<<8>>>0}e.$Lb=R;function E(u,f,A){u[A+0]=f&255,f=f>>>8,u[A+1]=f&255}e.$Mb=E;function c(u,f){return u[f]*2**24+u[f+1]*2**16+u[f+2]*2**8+u[f+3]}e.$Nb=c;function y(u,f,A){u[A+3]=f,f=f>>>8,u[A+2]=f,f=f>>>8,u[A+1]=f,f=f>>>8,u[A]=f}e.$Ob=y;function b(u,f){return u[f+0]<<0>>>0|u[f+1]<<8>>>0|u[f+2]<<16>>>0|u[f+3]<<24>>>0}e.$Pb=b;function o(u,f,A){u[A+0]=f&255,f=f>>>8,u[A+1]=f&255,f=f>>>8,u[A+2]=f&255,f=f>>>8,u[A+3]=f&255}e.$Qb=o;function t(u,f){return u[f]}e.$Rb=t;function i(u,f,A){u[A]=f}e.$Sb=i;function a(u){return L.$yb(u,f=>k.concat(f))}e.$Tb=a;function m(u){return L.$Fb(u)}e.$Ub=m;function S(u){return L.$Ab(u,f=>k.concat(f))}e.$Vb=S;async function C(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await S(u.stream)])}e.$Wb=C;function r(u){return L.$Db(u,f=>k.concat(f))}e.$Xb=r;function h(u){return L.$Gb(u,{data:f=>typeof f=="string"?k.fromString(f):k.wrap(f)},f=>k.concat(f))}e.$Yb=h;function n(u){return L.$xb(f=>k.concat(f),u)}e.$Zb=n;function s(u,f){return L.$Hb(u,f,A=>k.concat(A))}e.$1b=s;function p(u,f){return L.$Ib(u,f,A=>k.concat(A))}e.$2b=p;function D(u){let f=0,A=0,W=0;const B=new Uint8Array(Math.floor(u.length/4*3)),V=O=>{switch(A){case 3:B[W++]=f|O,A=0;break;case 2:B[W++]=f|O>>>2,f=O<<6,A=3;break;case 1:B[W++]=f|O>>>4,f=O<<4,A=2;break;default:f=O<<2,A=1}};for(let O=0;O<u.length;O++){const N=u.charCodeAt(O);if(N>=65&&N<=90)V(N-65);else if(N>=97&&N<=122)V(N-97+26);else if(N>=48&&N<=57)V(N-48+52);else if(N===43||N===45)V(62);else if(N===47||N===95)V(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${u[O]}`)}}const U=W;for(;A>0;)V(0);return k.wrap(B).slice(0,U)}e.$3b=D;const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function v({buffer:u},f=!0,A=!1){const W=A?g:l;let B="";const V=u.byteLength%3;let U=0;for(;U<u.byteLength-V;U+=3){const O=u[U+0],N=u[U+1],ae=u[U+2];B+=W[O>>>2],B+=W[(O<<4|N>>>4)&63],B+=W[(N<<2|ae>>>6)&63],B+=W[ae&63]}if(V===1){const O=u[U+0];B+=W[O>>>2],B+=W[O<<4&63],f&&(B+="==")}else if(V===2){const O=u[U+0],N=u[U+1];B+=W[O>>>2],B+=W[(O<<4|N>>>4)&63],B+=W[N<<2&63],f&&(B+="=")}return B}e.$4b=v}),define(Ae[119],Re([1,0,28,15]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xj=e.$wj=e.$vj=e.$uj=e.FuzzyScore=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.or=void 0;function I(...ee){return function(ie,he){for(let F=0,q=ee.length;F<q;F++){const J=ee[F](ie,he);if(J)return J}return null}}e.or=I,e.$ij=z.bind(void 0,!1),e.$jj=z.bind(void 0,!0);function z(ee,ie,he){if(!he||he.length<ie.length)return null;let F;return ee?F=L.$Md(he,ie):F=he.indexOf(ie)===0,F?ie.length>0?[{start:0,end:ie.length}]:[]:null}function P(ee,ie){const he=ie.toLowerCase().indexOf(ee.toLowerCase());return he===-1?null:[{start:he,end:he+ee.length}]}e.$kj=P;function d(ee,ie){return k(ee.toLowerCase(),ie.toLowerCase(),0,0)}e.$lj=d;function k(ee,ie,he,F){if(he===ee.length)return[];if(F===ie.length)return null;if(ee[he]===ie[F]){let q=null;return(q=k(ee,ie,he+1,F+1))?i({start:F,end:F+1},q):null}return k(ee,ie,he,F+1)}function $(ee){return 97<=ee&&ee<=122}function R(ee){return 65<=ee&&ee<=90}e.$mj=R;function E(ee){return 48<=ee&&ee<=57}function c(ee){return ee===32||ee===9||ee===10||ee===13}const y=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>y.add(ee.charCodeAt(0)));function b(ee){return c(ee)||y.has(ee)}function o(ee,ie){return ee===ie||b(ee)&&b(ie)}function t(ee){return $(ee)||R(ee)||E(ee)}function i(ee,ie){return ie.length===0?ie=[ee]:ee.end===ie[0].start?ie[0].start=ee.start:ie.unshift(ee),ie}function a(ee,ie){for(let he=ie;he<ee.length;he++){const F=ee.charCodeAt(he);if(R(F)||E(F)||he>0&&!t(ee.charCodeAt(he-1)))return he}return ee.length}function m(ee,ie,he,F){if(he===ee.length)return[];if(F===ie.length)return null;if(ee[he]!==ie[F].toLowerCase())return null;{let q=null,J=F+1;for(q=m(ee,ie,he+1,F+1);!q&&(J=a(ie,J))<ie.length;)q=m(ee,ie,he+1,J),J++;return q===null?null:i({start:F,end:F+1},q)}}function S(ee){let ie=0,he=0,F=0,q=0,J=0;for(let pe=0;pe<ee.length;pe++)J=ee.charCodeAt(pe),R(J)&&ie++,$(J)&&he++,t(J)&&F++,E(J)&&q++;const K=ie/ee.length,oe=he/ee.length,H=F/ee.length,ce=q/ee.length;return{upperPercent:K,lowerPercent:oe,alphaPercent:H,numericPercent:ce}}function C(ee){const{upperPercent:ie,lowerPercent:he}=ee;return he===0&&ie>.6}function r(ee){const{upperPercent:ie,lowerPercent:he,alphaPercent:F,numericPercent:q}=ee;return he>.2&&ie<.8&&F>.6&&q<.2}function h(ee){let ie=0,he=0,F=0,q=0;for(let J=0;J<ee.length;J++)F=ee.charCodeAt(J),R(F)&&ie++,$(F)&&he++,c(F)&&q++;return(ie===0||he===0)&&q===0?ee.length<=30:ie<=5}function n(ee,ie){if(!ie||(ie=ie.trim(),ie.length===0)||!h(ee)||ie.length>60)return null;const he=S(ie);if(!r(he)){if(!C(he))return null;ie=ie.toLowerCase()}let F=null,q=0;for(ee=ee.toLowerCase();q<ie.length&&(F=m(ee,ie,0,q))===null;)q=a(ie,q+1);return F}e.$nj=n;function s(ee,ie,he=!1){if(!ie||ie.length===0)return null;let F=null,q=0;for(ee=ee.toLowerCase(),ie=ie.toLowerCase();q<ie.length&&(F=p(ee,ie,0,q,he))===null;)q=D(ie,q+1);return F}e.$oj=s;function p(ee,ie,he,F,q){if(he===ee.length)return[];if(F===ie.length)return null;if(o(ee.charCodeAt(he),ie.charCodeAt(F))){let J=null,K=F+1;if(J=p(ee,ie,he+1,F+1,q),!q)for(;!J&&(K=D(ie,K))<ie.length;)J=p(ee,ie,he+1,K,q),K++;return J?ee.charCodeAt(he)!==ie.charCodeAt(F)?J:i({start:F,end:F+1},J):null}else return null}function D(ee,ie){for(let he=ie;he<ee.length;he++)if(b(ee.charCodeAt(he))||he>0&&b(ee.charCodeAt(he-1)))return he;return ee.length}const l=I(e.$jj,n,P),g=I(e.$jj,n,d),v=new w.$oi(1e4);function u(ee,ie,he=!1){if(typeof ee!="string"||typeof ie!="string")return null;let F=v.get(ee);F||(F=new RegExp(L.$td(ee),"i"),v.set(ee,F));const q=F.exec(ie);return q?[{start:q.index,end:q.index+q[0].length}]:he?g(ee,ie):l(ee,ie)}e.$pj=u;function f(ee,ie){const he=ye(ee,ee.toLowerCase(),0,ie,ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return he?W(he):null}e.$qj=f;function A(ee,ie,he,F,q,J){const K=Math.min(13,ee.length);for(;he<K;he++){const oe=ye(ee,ie,he,F,q,J,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return oe}return[0,J]}e.$rj=A;function W(ee){if(typeof ee>"u")return[];const ie=[],he=ee[1];for(let F=ee.length-1;F>1;F--){const q=ee[F]+he,J=ie[ie.length-1];J&&J.end===q?J.end=q+1:ie.push({start:q,end:q+1})}return ie}e.$sj=W;const B=128;function V(){const ee=[],ie=[];for(let he=0;he<=B;he++)ie[he]=0;for(let he=0;he<=B;he++)ee.push(ie.slice(0));return ee}function U(ee){const ie=[];for(let he=0;he<=ee;he++)ie[he]=0;return ie}const O=U(2*B),N=U(2*B),ae=V(),Q=V(),be=V(),ke=!1;function Fe(ee,ie,he,F,q){function J(oe,H,ce=" "){for(;oe.length<H;)oe=ce+oe;return oe}let K=` |   |${F.split("").map(oe=>J(oe,3)).join("|")}
`;for(let oe=0;oe<=he;oe++)oe===0?K+=" |":K+=`${ie[oe-1]}|`,K+=ee[oe].slice(0,q+1).map(H=>J(H.toString(),3)).join("|")+`
`;return K}function G(ee,ie,he,F){ee=ee.substr(ie),he=he.substr(F),console.log(Fe(Q,ee,ee.length,he,he.length)),console.log(Fe(be,ee,ee.length,he,he.length)),console.log(Fe(ae,ee,ee.length,he,he.length))}function Z(ee,ie){if(ie<0||ie>=ee.length)return!1;const he=ee.codePointAt(ie);switch(he){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.$5d(he)}}function le(ee,ie){if(ie<0||ie>=ee.length)return!1;switch(ee.charCodeAt(ie)){case 32:case 9:return!0;default:return!1}}function ne(ee,ie,he){return ie[ee]!==he[ee]}function de(ee,ie,he,F,q,J,K=!1){for(;ie<he&&q<J;)ee[ie]===F[q]&&(K&&(O[ie]=q),ie+=1),q+=1;return ie===he}e.$tj=de;var ue;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(ue||(ue={}));var T;(function(ee){ee.Default=[-100,0];function ie(he){return!he||he.length===2&&he[0]===-100&&he[1]===0}ee.isDefault=ie})(T||(e.FuzzyScore=T={}));class _{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ie,he){this.firstMatchCanBeWeak=ie,this.boostFullMatch=he}}e.$uj=_;function ye(ee,ie,he,F,q,J,K=_.default){const oe=ee.length>B?B:ee.length,H=F.length>B?B:F.length;if(he>=oe||J>=H||oe-he>H-J||!de(ie,he,oe,q,J,H,!0))return;Ce(oe,H,he,J,ie,q);let ce=1,pe=1,Oe=he,Be=J;const Ze=[!1];for(ce=1,Oe=he;Oe<oe;ce++,Oe++){const xe=O[Oe],tt=N[Oe],Ne=Oe+1<oe?N[Oe+1]:H;for(pe=xe-J+1,Be=xe;Be<Ne;pe++,Be++){let nt=Number.MIN_SAFE_INTEGER,x=!1;Be<=tt&&(nt=Se(ee,ie,Oe,he,F,q,Be,H,J,ae[ce-1][pe-1]===0,Ze));let Y=0;nt!==Number.MAX_SAFE_INTEGER&&(x=!0,Y=nt+Q[ce-1][pe-1]);const me=Be>xe,je=me?Q[ce][pe-1]+(ae[ce][pe-1]>0?-5:0):0,ze=Be>xe+1&&ae[ce][pe-1]>0,Xe=ze?Q[ce][pe-2]+(ae[ce][pe-2]>0?-5:0):0;if(ze&&(!me||Xe>=je)&&(!x||Xe>=Y))Q[ce][pe]=Xe,be[ce][pe]=3,ae[ce][pe]=0;else if(me&&(!x||je>=Y))Q[ce][pe]=je,be[ce][pe]=2,ae[ce][pe]=0;else if(x)Q[ce][pe]=Y,be[ce][pe]=1,ae[ce][pe]=ae[ce-1][pe-1]+1;else throw new Error("not possible")}}if(ke&&G(ee,he,F,J),!Ze[0]&&!K.firstMatchCanBeWeak)return;ce--,pe--;const Ke=[Q[ce][pe],J];let Qe=0,Ge=0;for(;ce>=1;){let xe=pe;do{const tt=be[ce][xe];if(tt===3)xe=xe-2;else if(tt===2)xe=xe-1;else break}while(xe>=1);Qe>1&&ie[he+ce-1]===q[J+pe-1]&&!ne(xe+J-1,F,q)&&Qe+1>ae[ce][xe]&&(xe=pe),xe===pe?Qe++:Qe=1,Ge||(Ge=xe),ce--,pe=xe-1,Ke.push(pe)}H===oe&&K.boostFullMatch&&(Ke[0]+=2);const ct=Ge-oe;return Ke[0]-=ct,Ke}e.$vj=ye;function Ce(ee,ie,he,F,q,J){let K=ee-1,oe=ie-1;for(;K>=he&&oe>=F;)q[K]===J[oe]&&(N[K]=oe,K--),oe--}function Se(ee,ie,he,F,q,J,K,oe,H,ce,pe){if(ie[he]!==J[K])return Number.MIN_SAFE_INTEGER;let Oe=1,Be=!1;return K===he-F?Oe=ee[he]===q[K]?7:5:ne(K,q,J)&&(K===0||!ne(K-1,q,J))?(Oe=ee[he]===q[K]?7:5,Be=!0):Z(J,K)&&(K===0||!Z(J,K-1))?Oe=5:(Z(J,K-1)||le(J,K-1))&&(Oe=5,Be=!0),Oe>1&&he===F&&(pe[0]=!0),Be||(Be=ne(K,q,J)||Z(J,K-1)||le(J,K-1)),he===F?K>H&&(Oe-=Be?3:5):ce?Oe+=Be?2:0:Oe+=Be?0:1,K+1===oe&&(Oe-=Be?3:5),Oe}function Ee(ee,ie,he,F,q,J,K){return se(ee,ie,he,F,q,J,!0,K)}e.$wj=Ee;function Ie(ee,ie,he,F,q,J,K){return se(ee,ie,he,F,q,J,!1,K)}e.$xj=Ie;function se(ee,ie,he,F,q,J,K,oe){let H=ye(ee,ie,he,F,q,J,oe);if(H&&!K)return H;if(ee.length>=3){const ce=Math.min(7,ee.length-1);for(let pe=he+1;pe<ce;pe++){const Oe=fe(ee,pe);if(Oe){const Be=ye(Oe,Oe.toLowerCase(),he,F,q,J,oe);Be&&(Be[0]-=3,(!H||Be[0]>H[0])&&(H=Be))}}}return H}function fe(ee,ie){if(ie+1>=ee.length)return;const he=ee[ie],F=ee[ie+1];if(he!==F)return ee.slice(0,ie)+F+he+ee.slice(ie+2)}}),define(Ae[29],Re([1,0,15]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(L||(L={})),function(I){const z="error",P="warning",d="warn",k="info",$="ignore";function R(c){return c?w.$Ld(z,c)?I.Error:w.$Ld(P,c)||w.$Ld(d,c)?I.Warning:w.$Ld(k,c)?I.Info:I.Ignore:I.Ignore}I.fromValue=R;function E(c){switch(c){case I.Error:return z;case I.Warning:return P;case I.Info:return k;default:return $}}I.toString=E}(L||(L={})),e.default=L}),define(Ae[120],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0,e.$4c=Symbol("MicrotaskDelay")}),define(Ae[48],Re([1,0,18,15]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0;class I{constructor(){this.b="",this.c=0}reset(y){return this.b=y,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(y){const b=y.charCodeAt(0),o=this.b.charCodeAt(this.c);return b-o}value(){return this.b[this.c]}}e.$ph=I;class z{constructor(y=!0){this.e=y}reset(y){return this.b=y,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let y=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(y)this.c++;else break;else y=!1;return this}cmp(y){return this.e?(0,L.$Fd)(y,this.b,0,y.length,this.c,this.d):(0,L.$Hd)(y,this.b,0,y.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$qh=z;class P{constructor(y=!0,b=!0){this.f=y,this.g=b}reset(y){this.d=0,this.e=0,this.b=y,this.c=y.length;for(let b=y.length-1;b>=0;b--,this.c--){const o=this.b.charCodeAt(b);if(!(o===47||this.f&&o===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let y=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if(y)this.d++;else break;else y=!1}return this}cmp(y){return this.g?(0,L.$Fd)(y,this.b,0,y.length,this.d,this.e):(0,L.$Hd)(y,this.b,0,y.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$rh=P;var d;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(d||(d={}));class k{constructor(y,b){this.f=y,this.g=b,this.d=[],this.e=0}reset(y){return this.c=y,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new P(!1,!this.f(y)),this.b.reset(y.path),this.b.value()&&this.d.push(3)),this.g(y)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(y){if(this.d[this.e]===1)return(0,L.$Gd)(y,this.c.scheme);if(this.d[this.e]===2)return(0,L.$Gd)(y,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(y);if(this.d[this.e]===4)return(0,L.$Ed)(y,this.c.query);if(this.d[this.e]===5)return(0,L.$Ed)(y,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$sh=k;class ${constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const y=this.right;return this.right=y.left,y.left=this,this.updateHeight(),y.updateHeight(),y}rotateRight(){const y=this.left;return this.left=y.right,y.right=this,this.updateHeight(),y.updateHeight(),y}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(R||(R={}));class E{static forUris(y=()=>!1,b=()=>!1){return new E(new k(y,b))}static forPaths(y=!1){return new E(new P(void 0,!y))}static forStrings(){return new E(new I)}static forConfigKeys(){return new E(new z)}constructor(y){this.b=y}clear(){this.c=void 0}fill(y,b){if(b){const o=b.slice(0);(0,w.$Df)(o);for(const t of o)this.set(t,y)}else{const o=y.slice(0);(0,w.$Df)(o);for(const t of o)this.set(t[0],t[1])}}set(y,b){const o=this.b.reset(y);let t;this.c||(this.c=new $,this.c.segment=o.value());const i=[];for(t=this.c;;){const m=o.cmp(t.segment);if(m>0)t.left||(t.left=new $,t.left.segment=o.value()),i.push([-1,t]),t=t.left;else if(m<0)t.right||(t.right=new $,t.right.segment=o.value()),i.push([1,t]),t=t.right;else if(o.hasNext())o.next(),t.mid||(t.mid=new $,t.mid.segment=o.value()),i.push([0,t]),t=t.mid;else break}const a=t.value;t.value=b,t.key=y;for(let m=i.length-1;m>=0;m--){const S=i[m][1];S.updateHeight();const C=S.balanceFactor();if(C<-1||C>1){const r=i[m][0],h=i[m+1][0];if(r===1&&h===1)i[m][1]=S.rotateLeft();else if(r===-1&&h===-1)i[m][1]=S.rotateRight();else if(r===1&&h===-1)S.right=i[m+1][1]=i[m+1][1].rotateRight(),i[m][1]=S.rotateLeft();else if(r===-1&&h===1)S.left=i[m+1][1]=i[m+1][1].rotateLeft(),i[m][1]=S.rotateRight();else throw new Error;if(m>0)switch(i[m-1][0]){case-1:i[m-1][1].left=i[m][1];break;case 1:i[m-1][1].right=i[m][1];break;case 0:i[m-1][1].mid=i[m][1];break}else this.c=i[0][1]}}return a}get(y){return this.d(y)?.value}d(y){const b=this.b.reset(y);let o=this.c;for(;o;){const t=b.cmp(o.segment);if(t>0)o=o.left;else if(t<0)o=o.right;else if(b.hasNext())b.next(),o=o.mid;else break}return o}has(y){const b=this.d(y);return!(b?.value===void 0&&b?.mid===void 0)}delete(y){return this.e(y,!1)}deleteSuperstr(y){return this.e(y,!0)}e(y,b){const o=this.b.reset(y),t=[];let i=this.c;for(;i;){const a=o.cmp(i.segment);if(a>0)t.push([-1,i]),i=i.left;else if(a<0)t.push([1,i]),i=i.right;else if(o.hasNext())o.next(),t.push([0,i]),i=i.mid;else break}if(i){if(b?(i.left=void 0,i.mid=void 0,i.right=void 0,i.height=1):(i.key=void 0,i.value=void 0),!i.mid&&!i.value)if(i.left&&i.right){const a=this.f(i.right);if(a.key){const{key:m,value:S,segment:C}=a;this.e(a.key,!1),i.key=m,i.value=S,i.segment=C}}else{const a=i.left??i.right;if(t.length>0){const[m,S]=t[t.length-1];switch(m){case-1:S.left=a;break;case 0:S.mid=a;break;case 1:S.right=a;break}}else this.c=a}for(let a=t.length-1;a>=0;a--){const m=t[a][1];m.updateHeight();const S=m.balanceFactor();if(S>1?(m.right.balanceFactor()>=0||(m.right=m.right.rotateRight()),t[a][1]=m.rotateLeft()):S<-1&&(m.left.balanceFactor()<=0||(m.left=m.left.rotateLeft()),t[a][1]=m.rotateRight()),a>0)switch(t[a-1][0]){case-1:t[a-1][1].left=t[a][1];break;case 1:t[a-1][1].right=t[a][1];break;case 0:t[a-1][1].mid=t[a][1];break}else this.c=t[0][1]}}}f(y){for(;y.left;)y=y.left;return y}findSubstr(y){const b=this.b.reset(y);let o=this.c,t;for(;o;){const i=b.cmp(o.segment);if(i>0)o=o.left;else if(i<0)o=o.right;else if(b.hasNext())b.next(),t=o.value||t,o=o.mid;else break}return o&&o.value||t}findSuperstr(y){return this.g(y,!1)}g(y,b){const o=this.b.reset(y);let t=this.c;for(;t;){const i=o.cmp(t.segment);if(i>0)t=t.left;else if(i<0)t=t.right;else if(o.hasNext())o.next(),t=t.mid;else return t.mid?this.h(t.mid):b?t.value:void 0}}hasElementOrSubtree(y){return this.g(y,!0)!==void 0}forEach(y){for(const[b,o]of this)y(o,b)}*[Symbol.iterator](){yield*this.h(this.c)}h(y){const b=[];return this.j(y,b),b[Symbol.iterator]()}j(y,b){y&&(y.left&&this.j(y.left,b),y.value&&b.push([y.key,y.value]),y.mid&&this.j(y.mid,b),y.right&&this.j(y.right,b))}_isBalanced(){const y=b=>{if(!b)return!0;const o=b.balanceFactor();return o<-1||o>1?!1:y(b.left)&&y(b.right)};return y(this.c)}}e.$th=E}),define(Ae[40],Re([1,0,89]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$Bj=e.ThemeColor=void 0;var L;(function(P){function d(k){return k&&typeof k=="object"&&typeof k.id=="string"}P.isThemeColor=d})(L||(e.ThemeColor=L={}));function I(P){return{id:P}}e.$Bj=I;var z;(function(P){P.iconNameSegment="[A-Za-z0-9]+",P.iconNameExpression="[A-Za-z0-9-]+",P.iconModifierExpression="~[A-Za-z]+",P.iconNameCharacter="[A-Za-z0-9~-]";const d=new RegExp(`^(${P.iconNameExpression})(${P.iconModifierExpression})?$`);function k(a){const m=d.exec(a.id);if(!m)return k(w.$Aj.error);const[,S,C]=m,r=["codicon","codicon-"+S];return C&&r.push("codicon-modifier-"+C.substring(1)),r}P.asClassNameArray=k;function $(a){return k(a).join(" ")}P.asClassName=$;function R(a){return"."+k(a).join(".")}P.asCSSSelector=R;function E(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||L.isThemeColor(a.color))}P.isThemeIcon=E;const c=new RegExp(`^\\$\\((${P.iconNameExpression}(?:${P.iconModifierExpression})?)\\)$`);function y(a){const m=c.exec(a);if(!m)return;const[,S]=m;return{id:S}}P.fromString=y;function b(a){return{id:a}}P.fromId=b;function o(a,m){let S=a.id;const C=S.lastIndexOf("~");return C!==-1&&(S=S.substring(0,C)),m&&(S=`${S}~${m}`),{id:S}}P.modify=o;function t(a){const m=a.id.lastIndexOf("~");if(m!==-1)return a.id.substring(m+1)}P.getModifier=t;function i(a,m){return a.id===m.id&&a.color?.id===m.color?.id}P.isEqual=i})(z||(e.ThemeIcon=z={}))}),define(Ae[121],Re([1,0,119,15,40]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=void 0;const z="$(",P=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),d=new RegExp(`(\\\\)?${P.source}`,"g");function k(i){return i.replace(d,(a,m)=>m?a:`\\${a}`)}e.$Cj=k;const $=new RegExp(`\\\\${P.source}`,"g");function R(i){return i.replace($,a=>`\\${a}`)}e.$Dj=R;const E=new RegExp(`(\\s)?(\\\\)?${P.source}(\\s)?`,"g");function c(i){return i.indexOf(z)===-1?i:i.replace(E,(a,m,S,C)=>S?a:m||C||"")}e.$Ej=c;function y(i){return i?i.replace(/\$\((.*?)\)/g,(a,m)=>` ${m} `).trim():""}e.$Fj=y;const b=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(i){b.lastIndex=0;let a="";const m=[];let S=0;for(;;){const C=b.lastIndex,r=b.exec(i),h=i.substring(C,r?.index);if(h.length>0){a+=h;for(let n=0;n<h.length;n++)m.push(S)}if(!r)break;S+=r[0].length}return{text:a,iconOffsets:m}}e.$Gj=o;function t(i,a,m=!1){const{text:S,iconOffsets:C}=a;if(!C||C.length===0)return(0,w.$pj)(i,S,m);const r=(0,L.$rd)(S," "),h=S.length-r.length,n=(0,w.$pj)(i,r,m);if(n)for(const s of n){const p=C[s.start+h]+h;s.start+=p,s.end+=p}return n}e.$Hj=t}),define(Ae[36],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=void 0;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(I){return w.test(I)}e.$4e=L,e.$5e=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(d){for(let k=0;k<d.length;k++)d[k]=Math.floor(Math.random()*256);return d};const z=new Uint8Array(16),P=[];for(let d=0;d<256;d++)P.push(d.toString(16).padStart(2,"0"));return function(){I(z),z[6]=z[6]&15|64,z[8]=z[8]&63|128;let k=0,$="";return $+=P[z[k++]],$+=P[z[k++]],$+=P[z[k++]],$+=P[z[k++]],$+="-",$+=P[z[k++]],$+=P[z[k++]],$+="-",$+=P[z[k++]],$+=P[z[k++]],$+="-",$+=P[z[k++]],$+=P[z[k++]],$+="-",$+=P[z[k++]],$+=P[z[k++]],$+=P[z[k++]],$+=P[z[k++]],$+=P[z[k++]],$+=P[z[k++]],$}}()}),define(Ae[122],Re([1,0,18,68,36]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=e.$$r=e.$0r=e.$9r=void 0;function z(E){return{asString:async()=>E,asFile:()=>{},value:typeof E=="string"?E:void 0}}e.$9r=z;function P(E,c,y){const b={id:(0,I.$5e)(),name:E,uri:c,data:y};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$0r=P;class d{constructor(){this.a=new Map}get size(){let c=0;for(const y of this.a)c++;return c}has(c){return this.a.has(this.b(c))}matches(c){const y=[...this.a.keys()];return L.Iterable.some(this,([b,o])=>o.asFile())&&y.push("files"),R(k(c),y)}get(c){return this.a.get(this.b(c))?.[0]}append(c,y){const b=this.a.get(c);b?b.push(y):this.a.set(this.b(c),[y])}replace(c,y){this.a.set(this.b(c),[y])}delete(c){this.a.delete(this.b(c))}*[Symbol.iterator](){for(const[c,y]of this.a)for(const b of y)yield[c,b]}b(c){return k(c)}}e.$$r=d;function k(E){return E.toLowerCase()}function $(E,c){return R(k(E),c.map(k))}e.$_r=$;function R(E,c){if(E==="*/*")return c.length>0;if(c.includes(E))return!0;const y=E.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!y)return!1;const[b,o,t]=y;return t==="*"?c.some(i=>i.startsWith(o+"/")):!1}e.$as=Object.freeze({create:E=>(0,w.$qf)(E.map(c=>c.toString())).join(`\r
`),split:E=>E.split(`\r
`),parse:E=>e.$as.split(E).filter(c=>!c.startsWith("#"))})}),define(Ae[123],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fr=void 0,e.$Fr={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ae[124],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=e.$zs=e.IndentAction=void 0;var w;(function(P){P[P.None=0]="None",P[P.Indent=1]="Indent",P[P.IndentOutdent=2]="IndentOutdent",P[P.Outdent=3]="Outdent"})(w||(e.IndentAction=w={}));class L{constructor(d){if(this.e=null,this.f=!1,this.open=d.open,this.close=d.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(d.notIn))for(let k=0,$=d.notIn.length;k<$;k++)switch(d.notIn[k]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(d){switch(d){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(d,k){if(d.getTokenCount()===0)return!0;const $=d.findTokenIndexAtOffset(k-2),R=d.getStandardTokenType($);return this.isOK(R)}g(d,k){for(let $=d;$<=k;$++){const R=String.fromCharCode($);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$zs=L;class I{constructor(d){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const k of d)z(this.autoClosingPairsOpenByStart,k.open.charAt(0),k),z(this.autoClosingPairsOpenByEnd,k.open.charAt(k.open.length-1),k),z(this.autoClosingPairsCloseByStart,k.close.charAt(0),k),z(this.autoClosingPairsCloseByEnd,k.close.charAt(k.close.length-1),k),k.close.length===1&&k.open.length===1&&z(this.autoClosingPairsCloseSingleChar,k.close,k)}}e.$As=I;function z(P,d,k){P.has(d)?P.get(d).push(k):P.set(d,[k])}}),define(Ae[125],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t5=e.$s5=void 0;class w{constructor(){this.a=new Map}removeDragOperationTransfer(z){if(z&&this.a.has(z)){const P=this.a.get(z);return this.a.delete(z),P}}addDragOperationTransfer(z,P){this.a.set(z,P)}}e.$s5=w;class L{constructor(z){this.identifier=z}}e.$t5=L}),define(Ae[126],Re([9,10]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(Ae[127],Re([1,0,5,6,126]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0h=e.$9h=e.$8h=e.$7h=e.$6h=e.$5h=void 0;class z extends L.$lb{constructor(c,y="",b="",o=!0,t){super(),this.h=this.B(new w.$7c),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=y,this.u=b,this.w=o,this.C=t}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,y){this.C&&await this.C(c)}}e.$5h=z;class P extends L.$lb{constructor(){super(...arguments),this.f=this.B(new w.$7c),this.onWillRun=this.f.event,this.h=this.B(new w.$7c),this.onDidRun=this.h.event}async run(c,y){if(!c.enabled)return;this.f.fire({action:c});let b;try{await this.k(c,y)}catch(o){b=o}this.h.fire({action:c,error:b})}async k(c,y){await c.run(y)}}e.$6h=P;class d{constructor(){this.id=d.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let y=[];for(const b of c)b.length&&(y.length?y=[...y,new d,...b]:y=b);return y}static{this.ID="vs.actions.separator"}async run(){}}e.$7h=d;class k{get actions(){return this.a}constructor(c,y,b,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=y,this.class=o,this.a=b}async run(){}}e.$8h=k;class $ extends z{static{this.ID="vs.actions.empty"}constructor(){super($.ID,I.localize(0,null),void 0,!1)}}e.$9h=$;function R(E){return{id:E.id,label:E.label,class:void 0,enabled:E.enabled??!0,checked:E.checked??!1,run:async()=>E.run(),tooltip:E.label}}e.$0h=R}),define(Ae[128],Re([9,10]),function($e,e){return $e.create("vs/base/common/date",e)}),define(Ae[129],Re([1,0,128]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=void 0;const L=60,I=L*60,z=I*24,P=z*7,d=z*30,k=z*365;function $(E,c,y,b){typeof E!="number"&&(E=E.getTime());const o=Math.round((new Date().getTime()-E)/1e3);if(o<-30)return(0,w.localize)(0,null,$(new Date().getTime()+o*1e3,!1));if(!b&&o<30)return(0,w.localize)(1,null);let t;return o<L?(t=o,c?t===1?y?(0,w.localize)(2,null,t):(0,w.localize)(3,null,t):y?(0,w.localize)(4,null,t):(0,w.localize)(5,null,t):t===1?y?(0,w.localize)(6,null,t):(0,w.localize)(7,null,t):y?(0,w.localize)(8,null,t):(0,w.localize)(9,null,t)):o<I?(t=Math.floor(o/L),c?t===1?y?(0,w.localize)(10,null,t):(0,w.localize)(11,null,t):y?(0,w.localize)(12,null,t):(0,w.localize)(13,null,t):t===1?y?(0,w.localize)(14,null,t):(0,w.localize)(15,null,t):y?(0,w.localize)(16,null,t):(0,w.localize)(17,null,t)):o<z?(t=Math.floor(o/I),c?t===1?y?(0,w.localize)(18,null,t):(0,w.localize)(19,null,t):y?(0,w.localize)(20,null,t):(0,w.localize)(21,null,t):t===1?y?(0,w.localize)(22,null,t):(0,w.localize)(23,null,t):y?(0,w.localize)(24,null,t):(0,w.localize)(25,null,t)):o<P?(t=Math.floor(o/z),c?t===1?(0,w.localize)(26,null,t):(0,w.localize)(27,null,t):t===1?(0,w.localize)(28,null,t):(0,w.localize)(29,null,t)):o<d?(t=Math.floor(o/P),c?t===1?y?(0,w.localize)(30,null,t):(0,w.localize)(31,null,t):y?(0,w.localize)(32,null,t):(0,w.localize)(33,null,t):t===1?y?(0,w.localize)(34,null,t):(0,w.localize)(35,null,t):y?(0,w.localize)(36,null,t):(0,w.localize)(37,null,t)):o<k?(t=Math.floor(o/d),c?t===1?y?(0,w.localize)(38,null,t):(0,w.localize)(39,null,t):y?(0,w.localize)(40,null,t):(0,w.localize)(41,null,t):t===1?y?(0,w.localize)(42,null,t):(0,w.localize)(43,null,t):y?(0,w.localize)(44,null,t):(0,w.localize)(45,null,t)):(t=Math.floor(o/k),c?t===1?y?(0,w.localize)(46,null,t):(0,w.localize)(47,null,t):y?(0,w.localize)(48,null,t):(0,w.localize)(49,null,t):t===1?y?(0,w.localize)(50,null,t):(0,w.localize)(51,null,t):y?(0,w.localize)(52,null,t):(0,w.localize)(53,null,t))}e.$Pl=$;function R(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$Ql=R}),define(Ae[130],Re([9,10]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(Ae[41],Re([1,0,18,12,130]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ai=e.$_h=e.$$h=void 0;function z(E,c){return c&&(E.stack||E.stacktrace)?I.localize(0,null,d(E),P(E.stack)||P(E.stacktrace)):d(E)}function P(E){return Array.isArray(E)?E.join(`
`):E}function d(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?I.localize(1,null,E.message):E.message||I.localize(2,null)}function k(E=null,c=!1){if(!E)return I.localize(3,null);if(Array.isArray(E)){const y=w.$lf(E),b=k(y[0],c);return y.length>1?I.localize(4,null,b,y.length):b}if(L.$ie(E))return E;if(E.detail){const y=E.detail;if(y.error)return z(y.error,c);if(y.exception)return z(y.exception,c)}return E.stack?z(E,c):E.message?E.message:I.localize(5,null)}e.$$h=k;function $(E){const c=E;return c instanceof Error&&Array.isArray(c.actions)}e.$_h=$;function R(E,c){let y;return typeof E=="string"?y=new Error(E):y=E,y.actions=c,y}e.$ai=R}),define(Ae[131],Re([1,0,67,19]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$8p=e.$7p=e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=e.$Xp=e.$Wp=void 0;const I=new w.$T(()=>{const g=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:g,collatorIsNumeric:g.resolvedOptions().numeric}}),z=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),P=new w.$T(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function d(g,v,u=!1){const f=g||"",A=v||"",W=I.value.collator.compare(f,A);return I.value.collatorIsNumeric&&W===0&&f!==A?f<A?-1:1:W}e.$Wp=d;function k(g,v){const u=z.value.collator;return g=g||"",v=v||"",S(u,g,v)}e.$Xp=k;function $(g,v){const u=z.value.collator;return g=g||"",v=v||"",n(g,v)||S(u,g,v)}e.$Yp=$;function R(g,v){const u=z.value.collator;return g=g||"",v=v||"",h(g,v)||S(u,g,v)}e.$Zp=R;function E(g,v){return g=g||"",v=v||"",g===v?0:g<v?-1:1}e.$1p=E;function c(g,v){const[u,f]=a(g),[A,W]=a(v);let B=I.value.collator.compare(f,W);if(B===0){if(I.value.collatorIsNumeric&&f!==W)return f<W?-1:1;if(B=I.value.collator.compare(u,A),I.value.collatorIsNumeric&&B===0&&u!==A)return u<A?-1:1}return B}e.$2p=c;function y(g,v){g=g||"",v=v||"";const u=m(g),f=m(v),A=z.value.collator,W=P.value.collator;return S(W,u,f)||S(A,g,v)}e.$3p=y;function b(g,v){g=g||"",v=v||"";const u=m(g),f=m(v),A=z.value.collator,W=P.value.collator;return S(W,u,f)||n(g,v)||S(A,g,v)}e.$4p=b;function o(g,v){g=g||"",v=v||"";const u=m(g),f=m(v),A=z.value.collator,W=P.value.collator;return S(W,u,f)||h(g,v)||S(A,g,v)}e.$5p=o;function t(g,v){g=g||"",v=v||"";const u=m(g).toLowerCase(),f=m(v).toLowerCase();return u!==f?u<f?-1:1:g!==v?g<v?-1:1:0}e.$6p=t;const i=/^(.*?)(\.([^.]*))?$/;function a(g,v=!1){const u=g?i.exec(g):[];let f=[u&&u[1]||"",u&&u[3]||""];return v&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function m(g){const v=g?i.exec(g):[];return v&&v[1]&&v[1].charAt(0)!=="."&&v[3]||""}function S(g,v,u){const f=g.compare(v,u);return f!==0?f:v.length!==u.length?v.length<u.length?-1:1:0}function C(g){const v=g.charAt(0);return v.toLocaleUpperCase()!==v}function r(g){const v=g.charAt(0);return v.toLocaleLowerCase()!==v}function h(g,v){return C(g)&&r(v)?-1:r(g)&&C(v)?1:0}function n(g,v){return r(g)&&C(v)?-1:C(g)&&r(v)?1:0}function s(g,v,u=!1){return u||(g=g&&g.toLowerCase(),v=v&&v.toLowerCase()),g===v?0:g<v?-1:1}function p(g,v,u=!1){const f=g.split(L.sep),A=v.split(L.sep),W=f.length-1,B=A.length-1;let V,U;for(let O=0;;O++){if(V=W===O,U=B===O,V&&U)return d(f[O],A[O],u);if(V)return-1;if(U)return 1;const N=s(f[O],A[O],u);if(N!==0)return N}}e.$7p=p;function D(g,v,u){const f=g.toLowerCase(),A=v.toLowerCase(),W=l(g,v,u);if(W)return W;const B=f.endsWith(u),V=A.endsWith(u);if(B!==V)return B?-1:1;const U=d(f,A);return U!==0?U:f.localeCompare(A)}e.$8p=D;function l(g,v,u){const f=g.toLowerCase(),A=v.toLowerCase(),W=f.startsWith(u),B=A.startsWith(u);if(W!==B)return W?-1:1;if(W&&B){if(f.length<A.length)return-1;if(f.length>A.length)return 1}return 0}e.$9p=l}),define(Ae[42],Re([1,0,19,22,15,12]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function P(D){return D===47||D===92}e.$Ce=P;function d(D){return D.replace(/[\\/]/g,w.$0b.sep)}e.$De=d;function k(D){return D.indexOf("/")===-1&&(D=d(D)),/^[a-zA-Z]:(\/|$)/.test(D)&&(D="/"+D),D}e.$Ee=k;function $(D,l=w.$0b.sep){if(!D)return"";const g=D.length,v=D.charCodeAt(0);if(P(v)){if(P(D.charCodeAt(1))&&!P(D.charCodeAt(2))){let f=3;const A=f;for(;f<g&&!P(D.charCodeAt(f));f++);if(A!==f&&!P(D.charCodeAt(f+1))){for(f+=1;f<g;f++)if(P(D.charCodeAt(f)))return D.slice(0,f+1).replace(/[\\/]/g,l)}}return l}else if(i(v)&&D.charCodeAt(1)===58)return P(D.charCodeAt(2))?D.slice(0,2)+l:D.slice(0,2);let u=D.indexOf("://");if(u!==-1){for(u+=3;u<g;u++)if(P(D.charCodeAt(u)))return D.slice(0,u+1)}return""}e.$Fe=$;function R(D){if(!L.$i||!D||D.length<5)return!1;let l=D.charCodeAt(0);if(l!==92||(l=D.charCodeAt(1),l!==92))return!1;let g=2;const v=g;for(;g<D.length&&(l=D.charCodeAt(g),l!==92);g++);return!(v===g||(l=D.charCodeAt(g+1),isNaN(l)||l===92))}e.$Ge=R;const E=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(D,l=L.$i){const g=l?E:c;return!(!D||D.length===0||/^\s+$/.test(D)||(g.lastIndex=0,g.test(D))||l&&y.test(D)||D==="."||D===".."||l&&D[D.length-1]==="."||l&&D.length!==D.trim().length||D.length>255)}e.$He=b;function o(D,l,g){const v=D===l;return!g||v?v:!D||!l?!1:(0,I.$Ld)(D,l)}e.$Ie=o;function t(D,l,g,v=w.sep){if(D===l)return!0;if(!D||!l||l.length>D.length)return!1;if(g){if(!(0,I.$Md)(D,l))return!1;if(l.length===D.length)return!0;let f=l.length;return l.charAt(l.length-1)===v&&f--,D.charAt(f)===v}return l.charAt(l.length-1)!==v&&(l+=v),D.indexOf(l)===0}e.$Je=t;function i(D){return D>=65&&D<=90||D>=97&&D<=122}e.$Ke=i;function a(D,l){return L.$i&&D.endsWith(":")&&(D+=w.sep),(0,w.$_b)(D)||(D=(0,w.$ac)(l,D)),D=(0,w.$$b)(D),L.$i?(D=(0,I.$sd)(D,w.sep),D.endsWith(":")&&(D+=w.sep)):(D=(0,I.$sd)(D,w.sep),D||(D=w.sep)),D}e.$Le=a;function m(D){const l=(0,w.$$b)(D);return L.$i?D.length>3?!1:S(l)&&(D.length===2||l.charCodeAt(2)===92):l===w.$0b.sep}e.$Me=m;function S(D,l=L.$i){return l?i(D.charCodeAt(0))&&D.charCodeAt(1)===58:!1}e.$Ne=S;function C(D,l=L.$i){return S(D,l)?D[0]:void 0}e.$Oe=C;function r(D,l,g){return l.length>D.length?-1:D===l?0:(g&&(D=D.toLowerCase(),l=l.toLowerCase()),D.indexOf(l))}e.$Pe=r;function h(D){const l=D.split(":");let g,v,u;for(const f of l){const A=Number(f);(0,z.$me)(A)?v===void 0?v=A:u===void 0&&(u=A):g=g?[g,f].join(":"):f}if(!g)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:g,line:v!==void 0?v:void 0,column:u!==void 0?u:v!==void 0?1:void 0}}e.$Qe=h;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function p(D,l,g=8){let v="";for(let f=0;f<g;f++){let A;f===0&&L.$i&&!l&&(g===3||g===4)?A=s:A=n,v+=A.charAt(Math.floor(Math.random()*A.length))}let u;return l?u=`${l}-${v}`:u=v,D?(0,w.$ac)(D,u):u}e.$Re=p}),define(Ae[69],Re([1,0,19]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wr=e.$vr=e.$ur=e.$tr=e.$sr=void 0,e.$sr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function z(R){const E=(0,w.$fc)(R),c=L[E.toLowerCase()];return c!==void 0?c:P(R)}e.$tr=z;function P(R){const E=(0,w.$fc)(R);return I[E.toLowerCase()]}e.$ur=P;function d(R){for(const E in I)if(I[E]===R)return E}e.$vr=d;const k=/^(.+)\/(.+?)(;.+)?$/;function $(R,E){const c=k.exec(R);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:E?void 0:R}e.$wr=$}),define(Ae[70],Re([1,0,25,15,2]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wg=e.$Vg=e.$Ug=void 0;function z($){return JSON.stringify($,d)}e.$Ug=z;function P($){let R=JSON.parse($);return R=k(R),R}e.$Vg=P;function d($,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,L.$yd)(R)}:R}function k($,R=0){if(!$||R>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return I.URI.revive($);case 2:return new RegExp($.source,$.flags);case 16:return new Date($.source)}if($ instanceof w.$Jb||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let E=0;E<$.length;++E)$[E]=k($[E],R+1);else for(const E in $)Object.hasOwnProperty.call($,E)&&($[E]=k($[E],R+1))}return $}e.$Wg=k}),define(Ae[13],Re([1,0,11,22,2]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.Schemas=void 0;var z;(function($){$.inMemory="inmemory",$.vscode="vscode",$.internal="private",$.walkThrough="walkThrough",$.walkThroughSnippet="walkThroughSnippet",$.http="http",$.https="https",$.file="file",$.mailto="mailto",$.untitled="untitled",$.data="data",$.command="command",$.vscodeRemote="vscode-remote",$.vscodeRemoteResource="vscode-remote-resource",$.vscodeManagedRemoteResource="vscode-managed-remote-resource",$.vscodeUserData="vscode-userdata",$.vscodeCustomEditor="vscode-custom-editor",$.vscodeNotebookCell="vscode-notebook-cell",$.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",$.vscodeNotebookCellOutput="vscode-notebook-cell-output",$.vscodeInteractiveInput="vscode-interactive-input",$.vscodeSettings="vscode-settings",$.vscodeWorkspaceTrust="vscode-workspace-trust",$.vscodeTerminal="vscode-terminal",$.vscodeChatSesssion="vscode-chat-editor",$.webviewPanel="webview-panel",$.vscodeWebview="vscode-webview",$.extension="extension",$.vscodeFileResource="vscode-file",$.tmp="tmp",$.vsls="vsls",$.vscodeSourceControl="vscode-scm"})(z||(e.Schemas=z={})),e.$Ve="vscode-tkn",e.$We="tkn";class P{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${z.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${z.vscodeRemoteResource}`}set(R,E,c){this.a[R]=E,this.b[R]=c}setConnectionToken(R,E){this.c[R]=E}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(t){return w.$Y(t),R}const E=R.authority;let c=this.a[E];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const y=this.b[E],b=this.c[E];let o=`path=${encodeURIComponent(R.path)}`;return typeof b=="string"&&(o+=`&${e.$We}=${encodeURIComponent(b)}`),I.URI.from({scheme:L.$o?this.d:z.vscodeRemoteResource,authority:`${c}:${y}`,path:this.f,query:o})}}e.$Xe=new P,e.$Ye="vs/../../extensions",e.$Ze="vs/../../node_modules",e.$1e="vs/../../node_modules.asar",e.$2e="vs/../../node_modules.asar.unpacked";class d{static{this.a="vscode-app"}asBrowserUri(R){const E=this.b(R,$e);return this.uriToBrowserUri(E)}uriToBrowserUri(R){return R.scheme===z.vscodeRemote?e.$Xe.rewrite(R):R.scheme===z.file&&(L.$m||L.$p&&L.$g.origin===`${z.vscodeFileResource}://${d.a}`)?R.with({scheme:z.vscodeFileResource,authority:R.authority||d.a,query:null,fragment:null}):R}asFileUri(R){const E=this.b(R,$e);return this.uriToFileUri(E)}uriToFileUri(R){return R.scheme===z.vscodeFileResource?R.with({scheme:z.file,authority:R.authority!==d.a?R.authority:null,query:null,fragment:null}):R}b(R,E){return I.URI.isUri(R)?R:I.URI.parse(E.toUrl(R))}}e.$3e=new d;var k;(function($){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);$.CoopAndCoep=Object.freeze(R.get("3"));const E="vscode-coi";function c(b){let o;typeof b=="string"?o=new URL(b).searchParams:b instanceof URL?o=b.searchParams:I.URI.isUri(b)&&(o=new URL(b.toString(!0)).searchParams);const t=o?.get(E);if(t)return R.get(t)}$.getHeadersFromQuery=c;function y(b,o,t){if(!globalThis.crossOriginIsolated)return;const i=o&&t?"3":t?"2":"1";b instanceof URLSearchParams?b.set(E,i):b[E]=i}$.addSearchParam=y})(k||(e.COI=k={}))}),define(Ae[23],Re([1,0,42,13,19,22,15,2]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.DataUri=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function k(y){return(0,d.$Ue)(y,!0)}e.$Vf=k;class ${constructor(b){this.a=b}compare(b,o,t=!1){return b===o?0:(0,P.$Ed)(this.getComparisonKey(b,t),this.getComparisonKey(o,t))}isEqual(b,o,t=!1){return b===o?!0:!b||!o?!1:this.getComparisonKey(b,t)===this.getComparisonKey(o,t)}getComparisonKey(b,o=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,o,t=!1){if(b.scheme===o.scheme){if(b.scheme===L.Schemas.file)return w.$Je(k(b),k(o),this.a(b))&&b.query===o.query&&(t||b.fragment===o.fragment);if((0,e.$ag)(b.authority,o.authority))return w.$Je(b.path,o.path,this.a(b),"/")&&b.query===o.query&&(t||b.fragment===o.fragment)}return!1}joinPath(b,...o){return d.URI.joinPath(b,...o)}basenameOrAuthority(b){return(0,e.$5f)(b)||b.authority}basename(b){return I.$0b.basename(b.path)}extname(b){return I.$0b.extname(b.path)}dirname(b){if(b.path.length===0)return b;let o;return b.scheme===L.Schemas.file?o=d.URI.file(I.$dc(k(b))).path:(o=I.$0b.dirname(b.path),b.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),o="/")),b.with({path:o})}normalizePath(b){if(!b.path.length)return b;let o;return b.scheme===L.Schemas.file?o=d.URI.file(I.$$b(k(b))).path:o=I.$0b.normalize(b.path),b.with({path:o})}relativePath(b,o){if(b.scheme!==o.scheme||!(0,e.$ag)(b.authority,o.authority))return;if(b.scheme===L.Schemas.file){const a=I.$cc(k(b),k(o));return z.$i?w.$De(a):a}let t=b.path||"/";const i=o.path||"/";if(this.a(b)){let a=0;for(const m=Math.min(t.length,i.length);a<m&&!(t.charCodeAt(a)!==i.charCodeAt(a)&&t.charAt(a).toLowerCase()!==i.charAt(a).toLowerCase());a++);t=i.substr(0,a)+t.substr(a)}return I.$0b.relative(t,i)}resolvePath(b,o){if(b.scheme===L.Schemas.file){const t=d.URI.file(I.$bc(k(b),o));return b.with({authority:t.authority,path:t.path})}return o=w.$Ee(o),b.with({path:I.$0b.resolve(b.path,o)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,o){return b===o||b!==void 0&&o!==void 0&&(0,P.$Ld)(b,o)}hasTrailingPathSeparator(b,o=I.sep){if(b.scheme===L.Schemas.file){const t=k(b);return t.length>w.$Fe(t).length&&t[t.length-1]===o}else{const t=b.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,o=I.sep){return(0,e.$bg)(b,o)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,o=I.sep){let t=!1;if(b.scheme===L.Schemas.file){const i=k(b);t=i!==void 0&&i.length===w.$Fe(i).length&&i[i.length-1]===o}else{o="/";const i=b.path;t=i.length===1&&i.charCodeAt(i.length-1)===47}return!t&&!(0,e.$bg)(b,o)?b.with({path:b.path+"/"}):b}}e.$Wf=$,e.$Xf=new $(()=>!1),e.$Yf=new $(y=>y.scheme===L.Schemas.file?!z.$k:!0),e.$Zf=new $(y=>!0),e.$1f=e.$Xf.isEqual.bind(e.$Xf),e.$2f=e.$Xf.isEqualOrParent.bind(e.$Xf),e.$3f=e.$Xf.getComparisonKey.bind(e.$Xf),e.$4f=e.$Xf.basenameOrAuthority.bind(e.$Xf),e.$5f=e.$Xf.basename.bind(e.$Xf),e.$6f=e.$Xf.extname.bind(e.$Xf),e.$7f=e.$Xf.dirname.bind(e.$Xf),e.$8f=e.$Xf.joinPath.bind(e.$Xf),e.$9f=e.$Xf.normalizePath.bind(e.$Xf),e.$0f=e.$Xf.relativePath.bind(e.$Xf),e.$$f=e.$Xf.resolvePath.bind(e.$Xf),e.$_f=e.$Xf.isAbsolutePath.bind(e.$Xf),e.$ag=e.$Xf.isEqualAuthority.bind(e.$Xf),e.$bg=e.$Xf.hasTrailingPathSeparator.bind(e.$Xf),e.$cg=e.$Xf.removeTrailingPathSeparator.bind(e.$Xf),e.$dg=e.$Xf.addTrailingPathSeparator.bind(e.$Xf);function R(y,b){const o=[];for(let t=0;t<y.length;t++){const i=b(y[t]);y.some((a,m)=>m===t?!1:(0,e.$2f)(i,b(a)))||o.push(y[t])}return o}e.$eg=R;var E;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function b(o){const t=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(m=>{const[S,C]=m.split(":");S&&C&&t.set(S,C)});const a=o.path.substring(0,o.path.indexOf(";"));return a&&t.set(y.META_DATA_MIME,a),t}y.parseMetaData=b})(E||(e.DataUri=E={}));function c(y,b,o){if(b){let t=y.path;return t&&t[0]!==I.$0b.sep&&(t=I.$0b.sep+t),y.with({scheme:o,authority:b,path:t})}return y.with({scheme:o})}e.$fg=c}),define(Ae[16],Re([1,0,20,11,5,6,23,22,120]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.$Pg=e.$Og=e.Promises=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function $(ue){return!!ue&&typeof ue.then=="function"}e.$gg=$;function R(ue){const T=new w.$dd,_=ue(T.token),ye=new Promise((Ce,Se)=>{const Ee=T.token.onCancellationRequested(()=>{Ee.dispose(),T.dispose(),Se(new L.$3)});Promise.resolve(_).then(Ie=>{Ee.dispose(),T.dispose(),Ce(Ie)},Ie=>{Ee.dispose(),T.dispose(),Se(Ie)})});return new class{cancel(){T.cancel()}then(Ce,Se){return ye.then(Ce,Se)}catch(Ce){return this.then(void 0,Ce)}finally(Ce){return ye.finally(Ce)}}}e.$hg=R;function E(ue,T,_){return new Promise((ye,Ce)=>{const Se=T.onCancellationRequested(()=>{Se.dispose(),ye(_)});ue.then(ye,Ce).finally(()=>Se.dispose())})}e.$ig=E;function c(ue,T){return new Promise((_,ye)=>{const Ce=T.onCancellationRequested(()=>{Ce.dispose(),ye(new L.$3)});ue.then(_,ye).finally(()=>Ce.dispose())})}e.$jg=c;async function y(ue){let T=-1;const _=ue.map((ye,Ce)=>ye.then(Se=>(T=Ce,Se)));try{return await Promise.race(_)}finally{ue.forEach((ye,Ce)=>{Ce!==T&&ye.cancel()})}}e.$kg=y;function b(ue,T,_){let ye;const Ce=setTimeout(()=>{ye?.(void 0),_?.()},T);return Promise.race([ue.finally(()=>clearTimeout(Ce)),new Promise(Se=>ye=Se)])}e.$lg=b;function o(ue){return new Promise((T,_)=>{const ye=ue();$(ye)?ye.then(T,_):T(ye)})}e.$mg=o;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=T,!this.b){const _=()=>{if(this.b=null,this.f)return;const ye=this.queue(this.d);return this.d=null,ye};this.b=new Promise(ye=>{this.a.then(_,_).then(ye)})}return new Promise((_,ye)=>{this.b.then(_,ye)})}return this.a=T(),new Promise((_,ye)=>{this.a.then(Ce=>{this.a=null,_(Ce)},Ce=>{this.a=null,ye(Ce)})})}dispose(){this.f=!0}}e.$ng=t;class i{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$og=i;class a{constructor(){this.a=new Map}queue(T,_){const Ce=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(T)===Ce&&this.a.delete(T)});return this.a.set(T,Ce),Ce}}e.$pg=a;const m=(ue,T)=>{let _=!0;const ye=setTimeout(()=>{_=!1,T()},ue);return{isTriggered:()=>_,dispose:()=>{clearTimeout(ye),_=!1}}},S=ue=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,ue())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class C{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,_=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((Ce,Se)=>{this.d=Ce,this.f=Se}).then(()=>{if(this.b=null,this.d=null,this.g){const Ce=this.g;return this.g=null,Ce()}}));const ye=()=>{this.a=null,this.d?.(null)};return this.a=_===k.$4c?S(ye):m(_,ye),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$qg=C;class r{constructor(T){this.a=new C(T),this.b=new t}trigger(T,_){return this.a.trigger(()=>this.b.queue(T),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$rg=r;class h{constructor(){this.a=!1,this.b=new Promise((T,_)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$sg=h;class n extends h{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$tg=n;function s(ue,T){return T?new Promise((_,ye)=>{const Ce=setTimeout(()=>{Se.dispose(),_()},ue),Se=T.onCancellationRequested(()=>{clearTimeout(Ce),Se.dispose(),ye(new L.$3)})}):R(_=>s(ue,_))}e.$ug=s;function p(ue,T=0){const _=setTimeout(ue,T);return(0,z.$jb)(()=>clearTimeout(_))}e.$vg=p;function D(ue){const T=[];let _=0;const ye=ue.length;function Ce(){return _<ye?ue[_++]():null}function Se(Ee){Ee!=null&&T.push(Ee);const Ie=Ce();return Ie?Ie.then(Se):Promise.resolve(T)}return Promise.resolve(null).then(Se)}e.$wg=D;function l(ue,T=ye=>!!ye,_=null){let ye=0;const Ce=ue.length,Se=()=>{if(ye>=Ce)return Promise.resolve(_);const Ee=ue[ye++];return Promise.resolve(Ee()).then(se=>T(se)?Promise.resolve(se):Se())};return Se()}e.$xg=l;function g(ue,T=ye=>!!ye,_=null){if(ue.length===0)return Promise.resolve(_);let ye=ue.length;const Ce=()=>{ye=-1;for(const Se of ue)Se.cancel?.()};return new Promise((Se,Ee)=>{for(const Ie of ue)Ie.then(se=>{--ye>=0&&T(se)?(Ce(),Se(se)):ye===0&&Se(_)}).catch(se=>{--ye>=0&&(Ce(),Ee(se))})})}e.$yg=g;class v{constructor(T){this.a=0,this.d=T,this.f=[],this.b=0,this.g=new I.$7c}get onDrained(){return this.g.event}get size(){return this.a}queue(T){return this.a++,new Promise((_,ye)=>{this.f.push({factory:T,c:_,e:ye}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const T=this.f.shift();this.b++;const _=T.factory();_.then(T.c,T.e),_.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$zg=v;class u extends v{constructor(){super(1)}}e.$Ag=u;class f{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const T=new Fe;return this.b.add(T),T.p}d(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueFor(T,_=P.$Xf){const ye=_.getComparisonKey(T);let Ce=this.a.get(ye);return Ce||(Ce=new u,I.Event.once(Ce.onDrained)(()=>{Ce?.dispose(),this.a.delete(ye),this.f()}),this.a.set(ye,Ce)),Ce}f(){this.d()&&this.g()}g(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.g()}}e.$Bg=f;class A{constructor(T,_){this.a=-1,typeof T=="function"&&typeof _=="number"&&this.setIfNotSet(T,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},_)}setIfNotSet(T,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},_))}}e.$Cg=A;class W{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(T,_){this.cancel(),this.a=setInterval(()=>{T()},_)}}e.$Dg=W;class B{constructor(T,_){this.b=-1,this.a=T,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Eg=B;class V{constructor(T,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=T,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Fg=V;class U extends B{constructor(T,_){super(T,_),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$Gg=U;class O extends z.$lb{constructor(T,_){super(),this.g=T,this.h=_,this.a=[],this.b=this.B(new z.$mb),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of T)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new B(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Hg=O,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ig=ue=>{(0,d.$A)(()=>{if(T)return;const _=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,_-Date.now())}}))});let T=!1;return{dispose(){T||(T=!0)}}}:e.$Ig=(ue,T)=>{const _=requestIdleCallback(ue,typeof T=="number"?{timeout:T}:void 0);let ye=!1;return{dispose(){ye||(ye=!0,cancelIdleCallback(_))}}}}();class N{constructor(T){this.d=!1,this.a=()=>{try{this.f=T()}catch(_){this.g=_}finally{this.d=!0}},this.b=(0,e.$Ig)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Jg=N;async function ae(ue,T,_){let ye;for(let Ce=0;Ce<_;Ce++)try{return await ue()}catch(Se){ye=Se,await s(T)}throw ye}e.$Kg=ae;class Q{hasPending(T){return this.a?typeof T=="number"?this.a.taskId===T:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(T,_,ye){return this.a={taskId:T,cancel:()=>ye?.(),promise:_},_.then(()=>this.d(T),()=>this.d(T)),_}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this.b)this.b.run=T;else{let _,ye;const Ce=new Promise((Se,Ee)=>{_=Se,ye=Ee});this.b={run:T,promise:Ce,promiseResolve:_,promiseReject:ye}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lg=Q;class be{constructor(T,_=()=>Date.now()){this.d=T,this.f=_,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$Mg=be;var ke;(function(ue){ue[ue.Resolved=0]="Resolved",ue[ue.Rejected=1]="Rejected"})(ke||(ke={}));class Fe{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,_)=>{this.a=T,this.b=_})}complete(T){return new Promise(_=>{this.a(T),this.d={outcome:0,value:T},_()})}error(T){return new Promise(_=>{this.b(T),this.d={outcome:1,value:T},_()})}cancel(){return this.error(new L.$3)}}e.$Ng=Fe;var G;(function(ue){async function T(ye){let Ce;const Se=await Promise.all(ye.map(Ee=>Ee.then(Ie=>Ie,Ie=>{Ce||(Ce=Ie)})));if(typeof Ce<"u")throw Ce;return Se}ue.settled=T;function _(ye){return new Promise(async(Ce,Se)=>{try{await ye(Ce,Se)}catch(Ee){Se(Ee)}})}ue.withAsyncBody=_})(G||(e.Promises=G={}));var Z;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(Z||(Z={}));class le{static fromArray(T){return new le(_=>{_.emitMany(T)})}static fromPromise(T){return new le(async _=>{_.emitMany(await T)})}static fromPromises(T){return new le(async _=>{await Promise.all(T.map(async ye=>_.emitOne(await ye)))})}static merge(T){return new le(async _=>{await Promise.all(T.map(async ye=>{for await(const Ce of ye)_.emitOne(Ce)}))})}static{this.EMPTY=le.fromArray([])}constructor(T){this.a=0,this.b=[],this.d=null,this.f=new I.$7c,queueMicrotask(async()=>{const _={emitOne:ye=>this.g(ye),emitMany:ye=>this.h(ye),reject:ye=>this.k(ye)};try{await Promise.resolve(T(_)),this.j()}catch(ye){this.k(ye)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(T,_){return new le(async ye=>{for await(const Ce of T)ye.emitOne(_(Ce))})}map(T){return le.map(this,T)}static filter(T,_){return new le(async ye=>{for await(const Ce of T)_(Ce)&&ye.emitOne(Ce)})}filter(T){return le.filter(this,T)}static coalesce(T){return le.filter(T,_=>!!_)}coalesce(){return le.coalesce(this)}static async toPromise(T){const _=[];for await(const ye of T)_.push(ye);return _}toPromise(){return le.toPromise(this)}g(T){this.a===0&&(this.b.push(T),this.f.fire())}h(T){this.a===0&&(this.b=this.b.concat(T),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(T){this.a===0&&(this.a=2,this.d=T,this.f.fire())}}e.$Og=le;class ne extends le{constructor(T,_){super(_),this.l=T}cancel(){this.l.cancel()}}e.$Pg=ne;function de(ue){const T=new w.$dd,_=ue(T.token);return new ne(T,async ye=>{const Ce=T.token.onCancellationRequested(()=>{Ce.dispose(),T.dispose(),ye.reject(new L.$3)});try{for await(const Se of _){if(T.token.isCancellationRequested)return;ye.emitOne(Se)}Ce.dispose(),T.dispose()}catch(Se){Ce.dispose(),T.dispose(),ye.reject(Se)}})}e.$Qg=de}),define(Ae[37],Re([1,0,18,16,42,28,19,22,15]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=void 0;function $(){return Object.create(null)}e.$0i=$,e.$$i="**",e.$_i="/";const R="[/\\\\]",E="[^/\\\\]",c=/\//g;function y(be,ke){switch(be){case 0:return"";case 1:return`${E}*?`;default:return`(?:${R}|${E}+${R}${ke?`|${R}${E}+`:""})*?`}}function b(be,ke){if(!be)return[];const Fe=[];let G=!1,Z=!1,le="";for(const ne of be){switch(ne){case ke:if(!G&&!Z){Fe.push(le),le="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":Z=!0;break;case"]":Z=!1;break}le+=ne}return le&&Fe.push(le),Fe}e.$aj=b;function o(be){if(!be)return"";let ke="";const Fe=b(be,e.$_i);if(Fe.every(G=>G===e.$$i))ke=".*";else{let G=!1;Fe.forEach((Z,le)=>{if(Z===e.$$i){if(G)return;ke+=y(2,le===Fe.length-1)}else{let ne=!1,de="",ue=!1,T="";for(const _ of Z){if(_!=="}"&&ne){de+=_;continue}if(ue&&(_!=="]"||!T)){let ye;_==="-"?ye=_:(_==="^"||_==="!")&&!T?ye="^":_===e.$_i?ye="":ye=(0,k.$nd)(_),T+=ye;continue}switch(_){case"{":ne=!0;continue;case"[":ue=!0;continue;case"}":{const Ce=`(?:${b(de,",").map(Se=>o(Se)).join("|")})`;ke+=Ce,ne=!1,de="";break}case"]":{ke+="["+T+"]",ue=!1,T="";break}case"?":ke+=E;continue;case"*":ke+=y(1);continue;default:ke+=(0,k.$nd)(_)}}le<Fe.length-1&&(Fe[le+1]!==e.$$i||le+2<Fe.length)&&(ke+=R)}G=Z===e.$$i})}return ke}const t=/^\*\*\/\*\.[\w\.-]+$/,i=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,m=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,C=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new z.$oi(1e4),h=function(){return!1},n=function(){return null};function s(be,ke){if(!be)return n;let Fe;typeof be!="string"?Fe=be.pattern:Fe=be,Fe=Fe.trim();const G=`${Fe}_${!!ke.trimForExclusions}`;let Z=r.get(G);if(Z)return p(Z,be);let le;return t.test(Fe)?Z=l(Fe.substr(4),Fe):(le=i.exec(D(Fe,ke)))?Z=g(le[1],Fe):(ke.trimForExclusions?m:a).test(Fe)?Z=v(Fe,ke):(le=S.exec(D(Fe,ke)))?Z=u(le[1].substr(1),Fe,!0):(le=C.exec(D(Fe,ke)))?Z=u(le[1],Fe,!1):Z=f(Fe),r.set(G,Z),p(Z,be)}function p(be,ke){if(typeof ke=="string")return be;const Fe=function(G,Z){return(0,I.$Je)(G,ke.base,!d.$k)?be((0,k.$rd)(G.substr(ke.base.length),P.sep),Z):null};return Fe.allBasenames=be.allBasenames,Fe.allPaths=be.allPaths,Fe.basenames=be.basenames,Fe.patterns=be.patterns,Fe}function D(be,ke){return ke.trimForExclusions&&be.endsWith("/**")?be.substr(0,be.length-2):be}function l(be,ke){return function(Fe,G){return typeof Fe=="string"&&Fe.endsWith(be)?ke:null}}function g(be,ke){const Fe=`/${be}`,G=`\\${be}`,Z=function(ne,de){return typeof ne!="string"?null:de?de===be?ke:null:ne===be||ne.endsWith(Fe)||ne.endsWith(G)?ke:null},le=[be];return Z.basenames=le,Z.patterns=[ke],Z.allBasenames=le,Z}function v(be,ke){const Fe=ae(be.slice(1,-1).split(",").map(de=>s(de,ke)).filter(de=>de!==n),be),G=Fe.length;if(!G)return n;if(G===1)return Fe[0];const Z=function(de,ue){for(let T=0,_=Fe.length;T<_;T++)if(Fe[T](de,ue))return be;return null},le=Fe.find(de=>!!de.allBasenames);le&&(Z.allBasenames=le.allBasenames);const ne=Fe.reduce((de,ue)=>ue.allPaths?de.concat(ue.allPaths):de,[]);return ne.length&&(Z.allPaths=ne),Z}function u(be,ke,Fe){const G=P.sep===P.$0b.sep,Z=G?be:be.replace(c,P.sep),le=P.sep+Z,ne=P.$0b.sep+be;let de;return Fe?de=function(ue,T){return typeof ue=="string"&&(ue===Z||ue.endsWith(le)||!G&&(ue===be||ue.endsWith(ne)))?ke:null}:de=function(ue,T){return typeof ue=="string"&&(ue===Z||!G&&ue===be)?ke:null},de.allPaths=[(Fe?"*/":"./")+be],de}function f(be){try{const ke=new RegExp(`^${o(be)}$`);return function(Fe){return ke.lastIndex=0,typeof Fe=="string"&&ke.test(Fe)?be:null}}catch{return n}}function A(be,ke,Fe){return!be||typeof ke!="string"?!1:W(be)(ke,void 0,Fe)}e.$bj=A;function W(be,ke={}){if(!be)return h;if(typeof be=="string"||B(be)){const Fe=s(be,ke);if(Fe===n)return h;const G=function(Z,le){return!!Fe(Z,le)};return Fe.allBasenames&&(G.allBasenames=Fe.allBasenames),Fe.allPaths&&(G.allPaths=Fe.allPaths),G}return O(be,ke)}e.$cj=W;function B(be){const ke=be;return ke?typeof ke.base=="string"&&typeof ke.pattern=="string":!1}e.$dj=B;function V(be){return be.allBasenames||[]}e.$ej=V;function U(be){return be.allPaths||[]}e.$fj=U;function O(be,ke){const Fe=ae(Object.getOwnPropertyNames(be).map(de=>N(de,be[de],ke)).filter(de=>de!==n)),G=Fe.length;if(!G)return n;if(!Fe.some(de=>!!de.requiresSiblings)){if(G===1)return Fe[0];const de=function(_,ye){let Ce;for(let Se=0,Ee=Fe.length;Se<Ee;Se++){const Ie=Fe[Se](_,ye);if(typeof Ie=="string")return Ie;(0,L.$gg)(Ie)&&(Ce||(Ce=[]),Ce.push(Ie))}return Ce?(async()=>{for(const Se of Ce){const Ee=await Se;if(typeof Ee=="string")return Ee}return null})():null},ue=Fe.find(_=>!!_.allBasenames);ue&&(de.allBasenames=ue.allBasenames);const T=Fe.reduce((_,ye)=>ye.allPaths?_.concat(ye.allPaths):_,[]);return T.length&&(de.allPaths=T),de}const Z=function(de,ue,T){let _,ye;for(let Ce=0,Se=Fe.length;Ce<Se;Ce++){const Ee=Fe[Ce];Ee.requiresSiblings&&T&&(ue||(ue=(0,P.$ec)(de)),_||(_=ue.substr(0,ue.length-(0,P.$fc)(de).length)));const Ie=Ee(de,ue,_,T);if(typeof Ie=="string")return Ie;(0,L.$gg)(Ie)&&(ye||(ye=[]),ye.push(Ie))}return ye?(async()=>{for(const Ce of ye){const Se=await Ce;if(typeof Se=="string")return Se}return null})():null},le=Fe.find(de=>!!de.allBasenames);le&&(Z.allBasenames=le.allBasenames);const ne=Fe.reduce((de,ue)=>ue.allPaths?de.concat(ue.allPaths):de,[]);return ne.length&&(Z.allPaths=ne),Z}function N(be,ke,Fe){if(ke===!1)return n;const G=s(be,Fe);if(G===n)return n;if(typeof ke=="boolean")return G;if(ke){const Z=ke.when;if(typeof Z=="string"){const le=(ne,de,ue,T)=>{if(!T||!G(ne,de))return null;const _=Z.replace("$(basename)",()=>ue),ye=T(_);return(0,L.$gg)(ye)?ye.then(Ce=>Ce?be:null):ye?be:null};return le.requiresSiblings=!0,le}}return G}function ae(be,ke){const Fe=be.filter(de=>!!de.basenames);if(Fe.length<2)return be;const G=Fe.reduce((de,ue)=>{const T=ue.basenames;return T?de.concat(T):de},[]);let Z;if(ke){Z=[];for(let de=0,ue=G.length;de<ue;de++)Z.push(ke)}else Z=Fe.reduce((de,ue)=>{const T=ue.patterns;return T?de.concat(T):de},[]);const le=function(de,ue){if(typeof de!="string")return null;if(!ue){let _;for(_=de.length;_>0;_--){const ye=de.charCodeAt(_-1);if(ye===47||ye===92)break}ue=de.substr(_)}const T=G.indexOf(ue);return T!==-1?Z[T]:null};le.basenames=G,le.patterns=Z,le.allBasenames=G;const ne=be.filter(de=>!de.basenames);return ne.push(le),ne}function Q(be,ke){return(0,w.$af)(be,ke,(Fe,G)=>typeof Fe=="string"&&typeof G=="string"?Fe===G:typeof Fe!="string"&&typeof G!="string"?Fe.base===G.base&&Fe.pattern===G.pattern:!1)}e.$gj=Q}),define(Ae[49],Re([1,0,11,121,23,15,2]),function($e,e,w,L,I,z,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.MarkdownStringTextNewlineStyle=void 0;var d;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(d||(e.MarkdownStringTextNewlineStyle=d={}));class k{constructor(i="",a=!1){if(this.value=i,typeof this.value!="string")throw(0,w.$5)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1,this.supportHtml=a.supportHtml??!1)}appendText(i,a=0){return this.value+=c(this.supportThemeIcons?(0,L.$Cj)(i):i).replace(/([ \t]+)/g,(m,S)=>"&nbsp;".repeat(S.length)).replace(/\>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,a){return this.value+="\n```",this.value+=i,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}appendLink(i,a,m){return this.value+="[",this.value+=this.c(a,"]"),this.value+="](",this.value+=this.c(String(i),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(i,a){const m=new RegExp((0,z.$nd)(a),"g");return i.replace(m,(S,C)=>i.charAt(C-1)!=="\\"?`\\${S}`:S)}}e.$Ij=k;function $(t){return R(t)?!t.value:Array.isArray(t)?t.every($):!0}e.$Jj=$;function R(t){return t instanceof k?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.$Kj=R;function E(t,i){return t===i?!0:!t||!i?!1:t.value===i.value&&t.isTrusted===i.isTrusted&&t.supportThemeIcons===i.supportThemeIcons&&t.supportHtml===i.supportHtml&&(t.baseUri===i.baseUri||!!t.baseUri&&!!i.baseUri&&(0,I.$1f)(P.URI.from(t.baseUri),P.URI.from(i.baseUri)))}e.$Lj=E;function c(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$Mj=c;function y(t){return t.replace(/"/g,"&quot;")}e.$Nj=y;function b(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$Oj=b;function o(t){const i=[],a=t.split("|").map(S=>S.trim());t=a[0];const m=a[1];if(m){const S=/height=(\d+)/.exec(m),C=/width=(\d+)/.exec(m),r=S?S[1]:"",h=C?C[1]:"",n=isFinite(parseInt(h)),s=isFinite(parseInt(r));n&&i.push(`width="${h}"`),s&&i.push(`height="${r}"`)}return{href:t,dimensions:i}}e.$Pj=o}),define(Ae[90],Re([1,0,18,42,19,22,23,15]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7z=e.$6z=e.$5z=e.$4z=e.$3z=e.$2z=e.$1z=e.$Zz=e.$Yz=e.$Xz=void 0;function k(s,p){const{os:D,tildify:l,relative:g}=p;if(g){const f=$(s,g,D);if(typeof f=="string")return f}let v=s.fsPath;if(D===1&&!z.$i?v=v.replace(/\//g,"\\"):D!==1&&z.$i&&(v=v.replace(/\\/g,"/")),D!==1&&l?.userHome){const f=l.userHome.fsPath;let A;s.scheme!==l.userHome.scheme&&s.path.startsWith(I.$0b.sep)?A=l.userHome.with({path:s.path}).fsPath:A=s.fsPath,v=c(A,f,D)}return(D===1?I.$9b:I.$0b).normalize(R(v,D===1))}e.$Xz=k;function $(s,p,D){const l=D===1?I.$9b:I.$0b,g=D===3?P.$Xf:P.$Zf,v=p.getWorkspace(),u=(0,w.$uf)(v.folders);if(!u)return;s.scheme!==u.uri.scheme&&s.path.startsWith(I.$0b.sep)&&(s=u.uri.with({path:s.path}));const f=p.getWorkspaceFolder(s);if(!f)return;let A;if(g.isEqual(f.uri,s)?A="":A=g.relativePath(f.uri,s)??"",A&&(A=l.normalize(A)),v.folders.length>1&&!p.noPrefix){const W=f.name?f.name:g.basenameOrAuthority(f.uri);A=A?`${W} \u2022 ${A}`:W}return A}function R(s,p=z.$i){return(0,L.$Ne)(s,p)?s.charAt(0).toUpperCase()+s.slice(1):s}e.$Yz=R;let E=Object.create(null);function c(s,p,D=z.OS){if(D===1||!s||!p)return s;let l=E.original===p?E.normalized:void 0;l||(l=p,z.$i&&(l=(0,L.$De)(l)),l=`${(0,d.$sd)(l,I.$0b.sep)}${I.$0b.sep}`,E={original:p,normalized:l});let g=s;return z.$i&&(g=(0,L.$De)(g)),(D===3?g.startsWith(l):(0,d.$Md)(g,l))?`~/${g.substr(l.length)}`:s}e.$Zz=c;function y(s,p){return s.replace(/^~($|\/|\\)/,`${p}$1`)}e.$1z=y;const b="\u2026",o="\\\\",t="~";function i(s,p=I.sep){const D=new Array(s.length);let l=!1;for(let g=0;g<s.length;g++){const v=s[g];if(v===""){D[g]=`.${p}`;continue}if(!v){D[g]=v;continue}l=!0;let u="",f=v;f.indexOf(o)===0?(u=f.substr(0,f.indexOf(o)+o.length),f=f.substr(f.indexOf(o)+o.length)):f.indexOf(p)===0?(u=f.substr(0,f.indexOf(p)+p.length),f=f.substr(f.indexOf(p)+p.length)):f.indexOf(t)===0&&(u=f.substr(0,f.indexOf(t)+t.length),f=f.substr(f.indexOf(t)+t.length));const A=f.split(p);for(let W=1;l&&W<=A.length;W++)for(let B=A.length-W;l&&B>=0;B--){l=!1;let V=A.slice(B,B+W).join(p);for(let U=0;!l&&U<s.length;U++)if(U!==g&&s[U]&&s[U].indexOf(V)>-1){const O=B+W===A.length,N=B>0&&s[U].indexOf(p)>-1?p+V:V,ae=s[U].endsWith(N);l=!O||ae}if(!l){let U="";(A[0].endsWith(":")||u!=="")&&(B===1&&(B=0,W++,V=A[0]+p+V),B>0&&(U=A[0]+p),U=u+U),B>0&&(U=U+b+p),U=U+V,B+W<A.length&&(U=U+p+b),D[g]=U}}l&&(D[g]=v)}return D}e.$2z=i;var a;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(a||(a={}));function m(s,p=Object.create(null)){const D=[];let l=!1,g="";for(const v of s)if(v==="$"||l&&v==="{")g&&D.push({value:g,type:a.TEXT}),g="",l=!0;else if(v==="}"&&l){const u=p[g];if(typeof u=="string")u.length&&D.push({value:u,type:a.VARIABLE});else if(u){const f=D[D.length-1];(!f||f.type!==a.SEPARATOR)&&D.push({value:u.label,type:a.SEPARATOR})}g="",l=!1}else g+=v;return g&&!l&&D.push({value:g,type:a.TEXT}),D.filter((v,u)=>{if(v.type===a.SEPARATOR){const f=D[u-1],A=D[u+1];return[f,A].every(W=>W&&(W.type===a.VARIABLE||W.type===a.TEXT)&&W.value.length>0)}return!0}).map(v=>v.value).join("")}e.$3z=m;function S(s,p){return z.$j||p?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,z.$j?"&":"&&"):s.replace(/&&|&/g,D=>D==="&"?"&&":"&")}e.$4z=S;function C(s,p){return z.$j||p?s.replace(/\(&&\w\)|&&/g,""):z.$i?s.replace(/&&|&/g,D=>D==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.$5z=C;function r(s){return s.replace(/&/g,"&&")}e.$6z=r;function h(s){if(s.endsWith("]")){const p=s.lastIndexOf(" [",s.length-2);if(p!==-1){const D=n(s.substring(0,p));return{name:D.name,parentPath:D.parentPath+s.substring(p)}}}return n(s)}e.$7z=h;function n(s){const p=s.indexOf("/")!==-1?I.$0b:I.$9b,D=p.basename(s),l=p.dirname(s);return D.length?{name:D,parentPath:l}:{name:l,parentPath:""}}}),define(Ae[132],Re([1,0,25,2]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=e.$om=e.$nm=e.$mm=e.$lm=void 0;function I(E){return E.toJSON()}class z{constructor(c){this.a=c}transformIncoming(c){const y=this.a.transformIncoming(c);return y===c?c:I(L.URI.from(y))}transformOutgoing(c){const y=this.a.transformOutgoing(c);return y===c?c:I(L.URI.from(y))}transformOutgoingURI(c){const y=this.a.transformOutgoing(c);return y===c?c:L.URI.from(y)}transformOutgoingScheme(c){return this.a.transformOutgoingScheme(c)}}e.$lm=z,e.$mm=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function P(E,c,y){if(!E||y>200)return null;if(typeof E=="object"){if(E instanceof L.URI)return c.transformOutgoing(E);for(const b in E)if(Object.hasOwnProperty.call(E,b)){const o=P(E[b],c,y+1);o!==null&&(E[b]=o)}}return null}function d(E,c){const y=P(E,c,0);return y===null?E:y}e.$nm=d;function k(E,c,y,b){if(!E||b>200)return null;if(typeof E=="object"){if(E.$mid===1)return y?L.URI.revive(c.transformIncoming(E)):c.transformIncoming(E);if(E instanceof w.$Jb)return null;for(const o in E)if(Object.hasOwnProperty.call(E,o)){const t=k(E[o],c,y,b+1);t!==null&&(E[o]=t)}}return null}function $(E,c){const y=k(E,c,!1,0);return y===null?E:y}e.$om=$;function R(E,c){const y=k(E,c,!0,0);return y===null?E:y}e.$pm=R}),define(Ae[133],Re([1,0,37,19]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VE=void 0;function I(z,P,d,k,$,R){if(Array.isArray(z)){let E=0;for(const c of z){const y=I(c,P,d,k,$,R);if(y===10)return y;y>E&&(E=y)}return E}else{if(typeof z=="string")return k?z==="*"?5:z===d?10:0:0;if(z){const{language:E,pattern:c,scheme:y,hasAccessToAllModels:b,notebookType:o}=z;if(!k&&!b)return 0;o&&$&&(P=$);let t=0;if(y)if(y===P.scheme)t=10;else if(y==="*")t=5;else return 0;if(E)if(E===d)t=10;else if(E==="*")t=Math.max(t,5);else return 0;if(o)if(o===R)t=10;else if(o==="*"&&R!==void 0)t=Math.max(t,5);else return 0;if(c){let i;if(typeof c=="string"?i=c:i={...c,base:(0,L.$$b)(c.base)},i===P.fsPath||(0,w.$bj)(i,P.fsPath))t=10;else return 0}return t}else return 0}}e.$VE=I}),define(Ae[91],Re([1,0,25,22]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A8=e.$z8=void 0;var I;(function(E){E[E.Full=1]="Full",E[E.Delta=2]="Delta"})(I||(I={}));function z(E){for(let c=0,y=E.length;c<y;c+=4){const b=E[c+0],o=E[c+1],t=E[c+2],i=E[c+3];E[c+0]=i,E[c+1]=t,E[c+2]=o,E[c+3]=b}}function P(E){const c=new Uint8Array(E.buffer,E.byteOffset,E.length*4);return L.$C()||z(c),w.$Jb.wrap(c)}function d(E){const c=E.buffer;if(L.$C()||z(c),c.byteOffset%4===0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const y=new Uint8Array(c.byteLength);return y.set(c),new Uint32Array(y.buffer,y.byteOffset,y.length/4)}}function k(E){const c=new Uint32Array($(E));let y=0;if(c[y++]=E.id,E.type==="full")c[y++]=1,c[y++]=E.data.length,c.set(E.data,y),y+=E.data.length;else{c[y++]=2,c[y++]=E.deltas.length;for(const b of E.deltas)c[y++]=b.start,c[y++]=b.deleteCount,b.data?(c[y++]=b.data.length,c.set(b.data,y),y+=b.data.length):c[y++]=0}return P(c)}e.$z8=k;function $(E){let c=0;if(c+=1+1,E.type==="full")c+=1+E.data.length;else{c+=1,c+=(1+1+1)*E.deltas.length;for(const y of E.deltas)y.data&&(c+=y.data.length)}return c}function R(E){const c=d(E);let y=0;const b=c[y++];if(c[y++]===1){const a=c[y++],m=c.subarray(y,y+a);return y+=a,{id:b,type:"full",data:m}}const t=c[y++],i=[];for(let a=0;a<t;a++){const m=c[y++],S=c[y++],C=c[y++];let r;C>0&&(r=c.subarray(y,y+C),y+=C),i[a]={start:m,deleteCount:S,data:r}}return{id:b,type:"delta",deltas:i}}e.$A8=R}),define(Ae[134],Re([9,10]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(Ae[135],Re([1,0,18,24,22,123,136,134]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var k;(function(x){x[x.None=0]="None",x[x.Keep=1]="Keep",x[x.Brackets=2]="Brackets",x[x.Advanced=3]="Advanced",x[x.Full=4]="Full"})(k||(e.EditorAutoIndentStrategy=k={})),e.MINIMAP_GUTTER_WIDTH=8;class ${constructor(Y){this.c=Y}hasChanged(Y){return this.c[Y]}}e.ConfigurationChangedEvent=$;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class E{constructor(Y,me,je,ze){this.id=Y,this.name=me,this.defaultValue=je,this.schema=ze}applyUpdate(Y,me){return y(Y,me)}compute(Y,me,je){return je}}class c{constructor(Y,me){this.newValue=Y,this.didChange=me}}e.ApplyUpdateResult=c;function y(x,Y){if(typeof x!="object"||typeof Y!="object"||!x||!Y)return new c(Y,x!==Y);if(Array.isArray(x)||Array.isArray(Y)){const je=Array.isArray(x)&&Array.isArray(Y)&&w.$af(x,Y);return new c(Y,!je)}let me=!1;for(const je in Y)if(Y.hasOwnProperty(je)){const ze=y(x[je],Y[je]);ze.didChange&&(x[je]=ze.newValue,me=!0)}return new c(x,me)}class b{constructor(Y){this.schema=void 0,this.id=Y,this.name="_never_",this.defaultValue=void 0}applyUpdate(Y,me){return y(Y,me)}validate(Y){return this.defaultValue}}class o{constructor(Y,me,je,ze){this.id=Y,this.name=me,this.defaultValue=je,this.schema=ze}applyUpdate(Y,me){return y(Y,me)}validate(Y){return typeof Y>"u"?this.defaultValue:Y}compute(Y,me,je){return je}}function t(x,Y){return typeof x>"u"?Y:x==="false"?!1:!!x}e.boolean=t;class i extends o{constructor(Y,me,je,ze=void 0){typeof ze<"u"&&(ze.type="boolean",ze.default=je),super(Y,me,je,ze)}validate(Y){return t(Y,this.defaultValue)}}function a(x,Y,me,je){if(typeof x>"u")return Y;let ze=parseInt(x,10);return isNaN(ze)?Y:(ze=Math.max(me,ze),ze=Math.min(je,ze),ze|0)}e.clampedInt=a;class m extends o{static clampedInt(Y,me,je,ze){return a(Y,me,je,ze)}constructor(Y,me,je,ze,Xe,et=void 0){typeof et<"u"&&(et.type="integer",et.default=je,et.minimum=ze,et.maximum=Xe),super(Y,me,je,et),this.minimum=ze,this.maximum=Xe}validate(Y){return m.clampedInt(Y,this.defaultValue,this.minimum,this.maximum)}}function S(x,Y,me,je){if(typeof x>"u")return Y;const ze=C.float(x,Y);return C.clamp(ze,me,je)}e.clampedFloat=S;class C extends o{static clamp(Y,me,je){return Y<me?me:Y>je?je:Y}static float(Y,me){if(typeof Y=="number")return Y;if(typeof Y>"u")return me;const je=parseFloat(Y);return isNaN(je)?me:je}constructor(Y,me,je,ze,Xe){typeof Xe<"u"&&(Xe.type="number",Xe.default=je),super(Y,me,je,Xe),this.validationFn=ze}validate(Y){return this.validationFn(C.float(Y,this.defaultValue))}}class r extends o{static string(Y,me){return typeof Y!="string"?me:Y}constructor(Y,me,je,ze=void 0){typeof ze<"u"&&(ze.type="string",ze.default=je),super(Y,me,je,ze)}validate(Y){return r.string(Y,this.defaultValue)}}function h(x,Y,me,je){return typeof x!="string"?Y:je&&x in je?je[x]:me.indexOf(x)===-1?Y:x}e.stringSet=h;class n extends o{constructor(Y,me,je,ze,Xe=void 0){typeof Xe<"u"&&(Xe.type="string",Xe.enum=ze,Xe.default=je),super(Y,me,je,Xe),this.c=ze}validate(Y){return h(Y,this.defaultValue,this.c)}}class s extends E{constructor(Y,me,je,ze,Xe,et,gt=void 0){typeof gt<"u"&&(gt.type="string",gt.enum=Xe,gt.default=ze),super(Y,me,je,gt),this.c=Xe,this.d=et}validate(Y){return typeof Y!="string"?this.defaultValue:this.c.indexOf(Y)===-1?this.defaultValue:this.d(Y)}}function p(x){switch(x){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class D extends E{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[d.localize(0,null),d.localize(1,null),d.localize(2,null)],default:"auto",tags:["accessibility"],description:d.localize(3,null)})}validate(Y){switch(Y){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Y,me,je){return je===0?Y.accessibilitySupport:je}}class l extends E{constructor(){const Y={insertSpace:!0,ignoreEmptyLines:!0};super(22,"comments",Y,{"editor.comments.insertSpace":{type:"boolean",default:Y.insertSpace,description:d.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Y.ignoreEmptyLines,description:d.localize(5,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertSpace:t(me.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(me.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var g;(function(x){x[x.Hidden=0]="Hidden",x[x.Blink=1]="Blink",x[x.Smooth=2]="Smooth",x[x.Phase=3]="Phase",x[x.Expand=4]="Expand",x[x.Solid=5]="Solid"})(g||(e.TextEditorCursorBlinkingStyle=g={}));function v(x){switch(x){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var u;(function(x){x[x.Line=1]="Line",x[x.Block=2]="Block",x[x.Underline=3]="Underline",x[x.LineThin=4]="LineThin",x[x.BlockOutline=5]="BlockOutline",x[x.UnderlineThin=6]="UnderlineThin"})(u||(e.TextEditorCursorStyle=u={}));function f(x){switch(x){case u.Line:return"line";case u.Block:return"block";case u.Underline:return"underline";case u.LineThin:return"line-thin";case u.BlockOutline:return"block-outline";case u.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function A(x){switch(x){case"line":return u.Line;case"block":return u.Block;case"underline":return u.Underline;case"line-thin":return u.LineThin;case"block-outline":return u.BlockOutline;case"underline-thin":return u.UnderlineThin}}class W extends b{constructor(){super(139)}compute(Y,me,je){const ze=["monaco-editor"];return me.get(38)&&ze.push(me.get(38)),Y.extraEditorClassName&&ze.push(Y.extraEditorClassName),me.get(72)==="default"?ze.push("mouse-default"):me.get(72)==="copy"&&ze.push("mouse-copy"),me.get(109)&&ze.push("showUnused"),me.get(137)&&ze.push("showDeprecated"),ze.join(" ")}}class B extends i{constructor(){super(36,"emptySelectionClipboard",!0,{description:d.localize(6,null)})}compute(Y,me,je){return je&&Y.emptySelectionClipboard}}class V extends E{constructor(){const Y={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(40,"find",Y,{"editor.find.cursorMoveOnType":{type:"boolean",default:Y.cursorMoveOnType,description:d.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Y.seedSearchStringFromSelection,enumDescriptions:[d.localize(8,null),d.localize(9,null),d.localize(10,null)],description:d.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Y.autoFindInSelection,enumDescriptions:[d.localize(12,null),d.localize(13,null),d.localize(14,null)],description:d.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Y.globalFindClipboard,description:d.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Y.addExtraSpaceOnTop,description:d.localize(17,null)},"editor.find.loop":{type:"boolean",default:Y.loop,description:d.localize(18,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{cursorMoveOnType:t(me.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Y.seedSearchStringFromSelection=="boolean"?Y.seedSearchStringFromSelection?"always":"never":h(me.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Y.autoFindInSelection=="boolean"?Y.autoFindInSelection?"always":"never":h(me.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(me.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(me.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(me.loop,this.defaultValue.loop)}}}class U extends E{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(50,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:d.localize(19,null)},{type:"string",description:d.localize(20,null)}],description:d.localize(21,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?U.OFF:Y==="true"?U.ON:Y:Y?U.ON:U.OFF}}e.EditorFontLigatures=U;class O extends E{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(53,"fontVariations",O.OFF,{anyOf:[{type:"boolean",description:d.localize(22,null)},{type:"string",description:d.localize(23,null)}],description:d.localize(24,null),default:!1})}validate(Y){return typeof Y>"u"?this.defaultValue:typeof Y=="string"?Y==="false"?O.OFF:Y==="true"?O.TRANSLATE:Y:Y?O.TRANSLATE:O.OFF}compute(Y,me,je){return Y.fontInfo.fontVariationSettings}}e.EditorFontVariations=O;class N extends b{constructor(){super(49)}compute(Y,me,je){return Y.fontInfo}}class ae extends o{constructor(){super(51,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:d.localize(25,null)})}validate(Y){const me=C.float(Y,this.defaultValue);return me===0?e.EDITOR_FONT_DEFAULTS.fontSize:C.clamp(me,6,100)}compute(Y,me,je){return Y.fontInfo.fontSize}}class Q extends E{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(52,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Q.d,maximum:Q.e,errorMessage:d.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Q.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:d.localize(27,null)})}validate(Y){return Y==="normal"||Y==="bold"?Y:String(m.clampedInt(Y,e.EDITOR_FONT_DEFAULTS.fontWeight,Q.d,Q.e))}}class be extends E{constructor(){const Y={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},me={type:"string",enum:["peek","gotoAndPeek","goto"],default:Y.multiple,enumDescriptions:[d.localize(28,null),d.localize(29,null),d.localize(30,null)]},je=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(57,"gotoLocation",Y,{"editor.gotoLocation.multiple":{deprecationMessage:d.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:d.localize(32,null),...me},"editor.gotoLocation.multipleTypeDefinitions":{description:d.localize(33,null),...me},"editor.gotoLocation.multipleDeclarations":{description:d.localize(34,null),...me},"editor.gotoLocation.multipleImplementations":{description:d.localize(35,null),...me},"editor.gotoLocation.multipleReferences":{description:d.localize(36,null),...me},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Y.alternativeDefinitionCommand,enum:je,description:d.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Y.alternativeTypeDefinitionCommand,enum:je,description:d.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Y.alternativeDeclarationCommand,enum:je,description:d.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Y.alternativeImplementationCommand,enum:je,description:d.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Y.alternativeReferenceCommand,enum:je,description:d.localize(41,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{multiple:h(me.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:me.multipleDefinitions??h(me.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:me.multipleTypeDefinitions??h(me.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:me.multipleDeclarations??h(me.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:me.multipleImplementations??h(me.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:me.multipleReferences??h(me.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:r.string(me.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:r.string(me.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:r.string(me.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:r.string(me.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:r.string(me.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ke extends E{constructor(){const Y={enabled:!0,delay:300,sticky:!0,above:!0};super(59,"hover",Y,{"editor.hover.enabled":{type:"boolean",default:Y.enabled,description:d.localize(42,null)},"editor.hover.delay":{type:"number",default:Y.delay,minimum:0,maximum:1e4,description:d.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Y.sticky,description:d.localize(44,null)},"editor.hover.above":{type:"boolean",default:Y.above,description:d.localize(45,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),delay:m.clampedInt(me.delay,this.defaultValue.delay,0,1e4),sticky:t(me.sticky,this.defaultValue.sticky),above:t(me.above,this.defaultValue.above)}}}var Fe;(function(x){x[x.None=0]="None",x[x.Text=1]="Text",x[x.Blocks=2]="Blocks"})(Fe||(e.RenderMinimap=Fe={}));class G extends b{constructor(){super(142)}compute(Y,me,je){return G.computeLayout(me,{memory:Y.memory,outerWidth:Y.outerWidth,outerHeight:Y.outerHeight,isDominatedByLongLines:Y.isDominatedByLongLines,lineHeight:Y.fontInfo.lineHeight,viewLineCount:Y.viewLineCount,lineNumbersDigitCount:Y.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Y.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Y.fontInfo.maxDigitWidth,pixelRatio:Y.pixelRatio,glyphMarginDecorationLaneCount:Y.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Y){const me=Y.height/Y.lineHeight,je=Math.floor(Y.paddingTop/Y.lineHeight);let ze=Math.floor(Y.paddingBottom/Y.lineHeight);Y.scrollBeyondLastLine&&(ze=Math.max(ze,me-1));const Xe=(je+Y.viewLineCount+ze)/(Y.pixelRatio*Y.height),et=Math.floor(Y.viewLineCount/Xe);return{typicalViewportLineCount:me,extraLinesBeforeFirstLine:je,extraLinesBeyondLastLine:ze,desiredRatio:Xe,minimapLineCount:et}}static c(Y,me){const je=Y.outerWidth,ze=Y.outerHeight,Xe=Y.pixelRatio;if(!Y.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Xe*ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ze};const et=me.stableMinimapLayoutInput,gt=et&&Y.outerHeight===et.outerHeight&&Y.lineHeight===et.lineHeight&&Y.typicalHalfwidthCharacterWidth===et.typicalHalfwidthCharacterWidth&&Y.pixelRatio===et.pixelRatio&&Y.scrollBeyondLastLine===et.scrollBeyondLastLine&&Y.paddingTop===et.paddingTop&&Y.paddingBottom===et.paddingBottom&&Y.minimap.enabled===et.minimap.enabled&&Y.minimap.side===et.minimap.side&&Y.minimap.size===et.minimap.size&&Y.minimap.showSlider===et.minimap.showSlider&&Y.minimap.renderCharacters===et.minimap.renderCharacters&&Y.minimap.maxColumn===et.minimap.maxColumn&&Y.minimap.scale===et.minimap.scale&&Y.verticalScrollbarWidth===et.verticalScrollbarWidth&&Y.isViewportWrapping===et.isViewportWrapping,wt=Y.lineHeight,Ot=Y.typicalHalfwidthCharacterWidth,Jt=Y.scrollBeyondLastLine,Wt=Y.minimap.renderCharacters;let yt=Xe>=2?Math.round(Y.minimap.scale*2):Y.minimap.scale;const Rt=Y.minimap.maxColumn,Ft=Y.minimap.size,Mt=Y.minimap.side,Ut=Y.verticalScrollbarWidth,Lt=Y.viewLineCount,st=Y.remainingWidth,ht=Y.isViewportWrapping,jt=Wt?2:3;let Tt=Math.floor(Xe*ze);const kt=Tt/Xe;let ot=!1,Pt=!1,zt=jt*yt,Pe=yt/Xe,we=1;if(Ft==="fill"||Ft==="fit"){const{typicalViewportLineCount:_e,extraLinesBeforeFirstLine:bt,extraLinesBeyondLastLine:Dt,desiredRatio:St,minimapLineCount:pt}=G.computeContainedMinimapLineCount({viewLineCount:Lt,scrollBeyondLastLine:Jt,paddingTop:Y.paddingTop,paddingBottom:Y.paddingBottom,height:ze,lineHeight:wt,pixelRatio:Xe});if(Lt/pt>1)ot=!0,Pt=!0,yt=1,zt=1,Pe=yt/Xe;else{let lt=!1,$t=yt+1;if(Ft==="fit"){const ft=Math.ceil((bt+Lt+Dt)*zt);ht&&gt&&st<=me.stableFitRemainingWidth?(lt=!0,$t=me.stableFitMaxMinimapScale):lt=ft>Tt}if(Ft==="fill"||lt){ot=!0;const ft=yt;zt=Math.min(wt*Xe,Math.max(1,Math.floor(1/St))),ht&&gt&&st<=me.stableFitRemainingWidth&&($t=me.stableFitMaxMinimapScale),yt=Math.min($t,Math.max(1,Math.floor(zt/jt))),yt>ft&&(we=Math.min(2,yt/ft)),Pe=yt/Xe/we,Tt=Math.ceil(Math.max(_e,bt+Lt+Dt)*zt),ht?(me.stableMinimapLayoutInput=Y,me.stableFitRemainingWidth=st,me.stableFitMaxMinimapScale=yt):(me.stableMinimapLayoutInput=null,me.stableFitRemainingWidth=0)}}}const ve=Math.floor(Rt*Pe),X=Math.min(ve,Math.max(0,Math.floor((st-Ut-2)*Pe/(Ot+Pe)))+e.MINIMAP_GUTTER_WIDTH);let Le=Math.floor(Xe*X);const Ue=Le/Xe;Le=Math.floor(Le*we);const He=Wt?1:2,We=Mt==="left"?0:je-X-Ut;return{renderMinimap:He,minimapLeft:We,minimapWidth:X,minimapHeightIsEditorHeight:ot,minimapIsSampling:Pt,minimapScale:yt,minimapLineHeight:zt,minimapCanvasInnerWidth:Le,minimapCanvasInnerHeight:Tt,minimapCanvasOuterWidth:Ue,minimapCanvasOuterHeight:kt}}static computeLayout(Y,me){const je=me.outerWidth|0,ze=me.outerHeight|0,Xe=me.lineHeight|0,et=me.lineNumbersDigitCount|0,gt=me.typicalHalfwidthCharacterWidth,wt=me.maxDigitWidth,Ot=me.pixelRatio,Jt=me.viewLineCount,Wt=Y.get(134),yt=Wt==="inherit"?Y.get(133):Wt,Rt=yt==="inherit"?Y.get(129):yt,Ft=Y.get(132),Mt=me.isDominatedByLongLines,Ut=Y.get(56),Lt=Y.get(66).renderType!==0,st=Y.get(67),ht=Y.get(103),jt=Y.get(82),Tt=Y.get(71),kt=Y.get(101),ot=kt.verticalScrollbarSize,Pt=kt.verticalHasArrows,zt=kt.arrowSize,Pe=kt.horizontalScrollbarSize,we=Y.get(42),ve=Y.get(108)!=="never";let X=Y.get(64);we&&ve&&(X+=16);let Le=0;if(Lt){const Bt=Math.max(et,st);Le=Math.round(Bt*wt)}let Ue=0;Ut&&(Ue=Xe*me.glyphMarginDecorationLaneCount);let He=0,We=He+Ue,_e=We+Le,bt=_e+X;const Dt=je-Ue-Le-X;let St=!1,pt=!1,mt=-1;yt==="inherit"&&Mt?(St=!0,pt=!0):Rt==="on"||Rt==="bounded"?pt=!0:Rt==="wordWrapColumn"&&(mt=Ft);const lt=G.c({outerWidth:je,outerHeight:ze,lineHeight:Xe,typicalHalfwidthCharacterWidth:gt,pixelRatio:Ot,scrollBeyondLastLine:ht,paddingTop:jt.top,paddingBottom:jt.bottom,minimap:Tt,verticalScrollbarWidth:ot,viewLineCount:Jt,remainingWidth:Dt,isViewportWrapping:pt},me.memory||new R);lt.renderMinimap!==0&&lt.minimapLeft===0&&(He+=lt.minimapWidth,We+=lt.minimapWidth,_e+=lt.minimapWidth,bt+=lt.minimapWidth);const $t=Dt-lt.minimapWidth,ft=Math.max(1,Math.floor(($t-ot-2)/gt)),Zt=Pt?zt:0;return pt&&(mt=Math.max(1,ft),Rt==="bounded"&&(mt=Math.min(mt,Ft))),{width:je,height:ze,glyphMarginLeft:He,glyphMarginWidth:Ue,glyphMarginDecorationLaneCount:me.glyphMarginDecorationLaneCount,lineNumbersLeft:We,lineNumbersWidth:Le,decorationsLeft:_e,decorationsWidth:X,contentLeft:bt,contentWidth:$t,minimap:lt,viewportColumn:ft,isWordWrapMinified:St,isViewportWrapping:pt,wrappingColumn:mt,verticalScrollbarWidth:ot,horizontalScrollbarHeight:Pe,overviewRuler:{top:Zt,width:ot,height:ze-2*Zt,right:0}}}}e.EditorLayoutInfoComputer=G;class Z extends E{constructor(){super(136,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[d.localize(46,null),d.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:d.localize(48,null)}})}validate(Y){return h(Y,"simple",["simple","advanced"])}compute(Y,me,je){return me.get(2)===2?"advanced":je}}class le extends E{constructor(){const Y={enabled:!0};super(63,"lightbulb",Y,{"editor.lightbulb.enabled":{type:"boolean",default:Y.enabled,description:d.localize(49,null)}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{enabled:t(Y.enabled,this.defaultValue.enabled)}}}class ne extends E{constructor(){const Y={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(113,"stickyScroll",Y,{"editor.stickyScroll.enabled":{type:"boolean",default:Y.enabled,description:d.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Y.maxLineCount,minimum:1,maximum:10,description:d.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Y.defaultModel,description:d.localize(52,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),maxLineCount:m.clampedInt(me.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:h(me.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class de extends E{constructor(){const Y={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(138,"inlayHints",Y,{"editor.inlayHints.enabled":{type:"string",default:Y.enabled,description:d.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[d.localize(54,null),d.localize(55,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),d.localize(56,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),d.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:Y.fontSize,markdownDescription:d.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Y.fontFamily,markdownDescription:d.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Y.padding,description:d.localize(60,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return typeof me.enabled=="boolean"&&(me.enabled=me.enabled?"on":"off"),{enabled:h(me.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:m.clampedInt(me.fontSize,this.defaultValue.fontSize,0,100),fontFamily:r.string(me.fontFamily,this.defaultValue.fontFamily),padding:t(me.padding,this.defaultValue.padding)}}}class ue extends E{constructor(){super(64,"lineDecorationsWidth",10)}validate(Y){return typeof Y=="string"&&/^\d+(\.\d+)?ch$/.test(Y)?-parseFloat(Y.substring(0,Y.length-2)):m.clampedInt(Y,this.defaultValue,0,1e3)}compute(Y,me,je){return je<0?m.clampedInt(-je*Y.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):je}}class T extends C{constructor(){super(65,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Y=>C.clamp(Y,0,150),{markdownDescription:d.localize(61,null)})}compute(Y,me,je){return Y.fontInfo.lineHeight}}class _ extends E{constructor(){const Y={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(71,"minimap",Y,{"editor.minimap.enabled":{type:"boolean",default:Y.enabled,description:d.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:Y.autohide,description:d.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[d.localize(64,null),d.localize(65,null),d.localize(66,null)],default:Y.size,description:d.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Y.side,description:d.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Y.showSlider,description:d.localize(69,null)},"editor.minimap.scale":{type:"number",default:Y.scale,minimum:1,maximum:3,enum:[1,2,3],description:d.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Y.renderCharacters,description:d.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:Y.maxColumn,description:d.localize(72,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),autohide:t(me.autohide,this.defaultValue.autohide),size:h(me.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(me.side,this.defaultValue.side,["right","left"]),showSlider:h(me.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(me.renderCharacters,this.defaultValue.renderCharacters),scale:m.clampedInt(me.scale,1,1,3),maxColumn:m.clampedInt(me.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ye(x){return x==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Ce extends E{constructor(){super(82,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:d.localize(74,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{top:m.clampedInt(me.top,0,0,1e3),bottom:m.clampedInt(me.bottom,0,0,1e3)}}}class Se extends E{constructor(){const Y={enabled:!0,cycle:!0};super(84,"parameterHints",Y,{"editor.parameterHints.enabled":{type:"boolean",default:Y.enabled,description:d.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:Y.cycle,description:d.localize(76,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),cycle:t(me.cycle,this.defaultValue.cycle)}}}class Ee extends b{constructor(){super(140)}compute(Y,me,je){return Y.pixelRatio}}class Ie extends E{constructor(){const Y={other:"on",comments:"off",strings:"off"},me=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[d.localize(77,null),d.localize(78,null),d.localize(79,null)]}];super(87,"quickSuggestions",Y,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:me,default:Y.strings,description:d.localize(80,null)},comments:{anyOf:me,default:Y.comments,description:d.localize(81,null)},other:{anyOf:me,default:Y.other,description:d.localize(82,null)}},default:Y,markdownDescription:d.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Y}validate(Y){if(typeof Y=="boolean"){const Ot=Y?"on":"off";return{comments:Ot,strings:Ot,other:Ot}}if(!Y||typeof Y!="object")return this.defaultValue;const{other:me,comments:je,strings:ze}=Y,Xe=["on","inline","off"];let et,gt,wt;return typeof me=="boolean"?et=me?"on":"off":et=h(me,this.defaultValue.other,Xe),typeof je=="boolean"?gt=je?"on":"off":gt=h(je,this.defaultValue.comments,Xe),typeof ze=="boolean"?wt=ze?"on":"off":wt=h(ze,this.defaultValue.strings,Xe),{other:et,comments:gt,strings:wt}}}var se;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative",x[x.Interval=3]="Interval",x[x.Custom=4]="Custom"})(se||(e.RenderLineNumbersType=se={}));class fe extends E{constructor(){super(66,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[d.localize(84,null),d.localize(85,null),d.localize(86,null),d.localize(87,null)],default:"on",description:d.localize(88,null)})}validate(Y){let me=this.defaultValue.renderType,je=this.defaultValue.renderFn;return typeof Y<"u"&&(typeof Y=="function"?(me=4,je=Y):Y==="interval"?me=3:Y==="relative"?me=2:Y==="on"?me=1:me=0),{renderType:me,renderFn:je}}}function ee(x){const Y=x.get(96);return Y==="editable"?x.get(89):Y!=="on"}e.filterValidationDecorations=ee;class ie extends E{constructor(){const Y=[],me={type:"number",description:d.localize(89,null)};super(100,"rulers",Y,{type:"array",items:{anyOf:[me,{type:["object"],properties:{column:me,color:{type:"string",description:d.localize(90,null),format:"color-hex"}}}]},default:Y,description:d.localize(91,null)})}validate(Y){if(Array.isArray(Y)){const me=[];for(const je of Y)if(typeof je=="number")me.push({column:m.clampedInt(je,0,0,1e4),color:null});else if(je&&typeof je=="object"){const ze=je;me.push({column:m.clampedInt(ze.column,0,0,1e4),color:ze.color})}return me.sort((je,ze)=>je.column-ze.column),me}return this.defaultValue}}class he extends E{constructor(){super(90,"readOnlyMessage",void 0)}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:Y}}function F(x,Y){if(typeof x!="string")return Y;switch(x){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends E{constructor(){const Y={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(101,"scrollbar",Y,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(92,null),d.localize(93,null),d.localize(94,null)],default:"auto",description:d.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[d.localize(96,null),d.localize(97,null),d.localize(98,null)],default:"auto",description:d.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Y.verticalScrollbarSize,description:d.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Y.horizontalScrollbarSize,description:d.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Y.scrollByPage,description:d.localize(102,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y,je=m.clampedInt(me.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ze=m.clampedInt(me.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:m.clampedInt(me.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:F(me.vertical,this.defaultValue.vertical),horizontal:F(me.horizontal,this.defaultValue.horizontal),useShadows:t(me.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(me.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(me.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(me.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(me.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:je,horizontalSliderSize:m.clampedInt(me.horizontalSliderSize,je,0,1e3),verticalScrollbarSize:ze,verticalSliderSize:m.clampedInt(me.verticalSliderSize,ze,0,1e3),scrollByPage:t(me.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends E{constructor(){const Y={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(123,"unicodeHighlight",Y,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.nonBasicASCII,description:d.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Y.invisibleCharacters,description:d.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Y.ambiguousCharacters,description:d.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeComments,description:d.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Y.includeStrings,description:d.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Y.allowedCharacters,description:d.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Y.allowedLocales,description:d.localize(109,null)}})}applyUpdate(Y,me){let je=!1;me.allowedCharacters&&Y&&(L.$Jm(Y.allowedCharacters,me.allowedCharacters)||(Y={...Y,allowedCharacters:me.allowedCharacters},je=!0)),me.allowedLocales&&Y&&(L.$Jm(Y.allowedLocales,me.allowedLocales)||(Y={...Y,allowedLocales:me.allowedLocales},je=!0));const ze=super.applyUpdate(Y,me);return je?new c(ze.newValue,!0):ze}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{nonBasicASCII:ce(me.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(me.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(me.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ce(me.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ce(me.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Y.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Y.allowedLocales,this.defaultValue.allowedLocales)}}c(Y,me){if(typeof Y!="object"||!Y)return me;const je={};for(const[ze,Xe]of Object.entries(Y))Xe===!0&&(je[ze]=!0);return je}}class K extends E{constructor(){const Y={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(61,"inlineSuggest",Y,{"editor.inlineSuggest.enabled":{type:"boolean",default:Y.enabled,description:d.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Y.showToolbar,enum:["always","onHover"],enumDescriptions:[d.localize(111,null),d.localize(112,null)],description:d.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Y.suppressSuggestions,description:d.localize(114,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),mode:h(me.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(me.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(me.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(me.keepOnBlur,this.defaultValue.keepOnBlur)}}}class oe extends E{constructor(){const Y={enabled:z.$Fr.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:z.$Fr.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(14,"bracketPairColorization",Y,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Y.enabled,markdownDescription:d.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Y.independentColorPoolPerBracketType,description:d.localize(116,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(me.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends E{constructor(){const Y={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(15,"guides",Y,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(117,null),d.localize(118,null),d.localize(119,null)],default:Y.bracketPairs,description:d.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[d.localize(121,null),d.localize(122,null),d.localize(123,null)],default:Y.bracketPairsHorizontal,description:d.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Y.highlightActiveBracketPair,description:d.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:Y.indentation,description:d.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[d.localize(127,null),d.localize(128,null),d.localize(129,null)],default:Y.highlightActiveIndentation,description:d.localize(130,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{bracketPairs:ce(me.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ce(me.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(me.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(me.indentation,this.defaultValue.indentation),highlightActiveIndentation:ce(me.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ce(x,Y,me){const je=me.indexOf(x);return je===-1?Y:me[je]}class pe extends E{constructor(){const Y={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(116,"suggest",Y,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[d.localize(131,null),d.localize(132,null)],default:Y.insertMode,description:d.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Y.filterGraceful,description:d.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:Y.localityBonus,description:d.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Y.shareSuggestSelections,markdownDescription:d.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[d.localize(137,null),d.localize(138,null),d.localize(139,null),d.localize(140,null)],default:Y.selectionMode,markdownDescription:d.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Y.snippetsPreventQuickSuggestions,description:d.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:Y.showIcons,description:d.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Y.showStatusBar,description:d.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:Y.preview,description:d.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Y.showInlineDetails,description:d.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:d.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:d.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:d.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:d.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:d.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:d.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:d.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:d.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:d.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:d.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:d.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:d.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:d.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:d.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:d.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:d.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:d.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:d.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:d.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:d.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:d.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:d.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:d.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:d.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:d.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:d.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:d.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:d.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:d.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:d.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:d.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:d.localize(178,null)}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{insertMode:h(me.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(me.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(me.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(me.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(me.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(me.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(me.showIcons,this.defaultValue.showIcons),showStatusBar:t(me.showStatusBar,this.defaultValue.showStatusBar),preview:t(me.preview,this.defaultValue.preview),previewMode:h(me.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(me.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(me.showMethods,this.defaultValue.showMethods),showFunctions:t(me.showFunctions,this.defaultValue.showFunctions),showConstructors:t(me.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(me.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(me.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(me.showFields,this.defaultValue.showFields),showVariables:t(me.showVariables,this.defaultValue.showVariables),showClasses:t(me.showClasses,this.defaultValue.showClasses),showStructs:t(me.showStructs,this.defaultValue.showStructs),showInterfaces:t(me.showInterfaces,this.defaultValue.showInterfaces),showModules:t(me.showModules,this.defaultValue.showModules),showProperties:t(me.showProperties,this.defaultValue.showProperties),showEvents:t(me.showEvents,this.defaultValue.showEvents),showOperators:t(me.showOperators,this.defaultValue.showOperators),showUnits:t(me.showUnits,this.defaultValue.showUnits),showValues:t(me.showValues,this.defaultValue.showValues),showConstants:t(me.showConstants,this.defaultValue.showConstants),showEnums:t(me.showEnums,this.defaultValue.showEnums),showEnumMembers:t(me.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(me.showKeywords,this.defaultValue.showKeywords),showWords:t(me.showWords,this.defaultValue.showWords),showColors:t(me.showColors,this.defaultValue.showColors),showFiles:t(me.showFiles,this.defaultValue.showFiles),showReferences:t(me.showReferences,this.defaultValue.showReferences),showFolders:t(me.showFolders,this.defaultValue.showFolders),showTypeParameters:t(me.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(me.showSnippets,this.defaultValue.showSnippets),showUsers:t(me.showUsers,this.defaultValue.showUsers),showIssues:t(me.showIssues,this.defaultValue.showIssues)}}}class Oe extends E{constructor(){super(111,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:d.localize(179,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:d.localize(180,null),default:!0,type:"boolean"}})}validate(Y){return!Y||typeof Y!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(Y.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:t(Y.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(x){x[x.None=0]="None",x[x.Same=1]="Same",x[x.Indent=2]="Indent",x[x.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class Ze extends E{constructor(){super(135,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[d.localize(181,null),d.localize(182,null),d.localize(183,null),d.localize(184,null)],description:d.localize(185,null),default:"same"}})}validate(Y){switch(Y){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Y,me,je){return me.get(2)===2?0:je}}class Ke extends b{constructor(){super(143)}compute(Y,me,je){const ze=me.get(142);return{isDominatedByLongLines:Y.isDominatedByLongLines,isWordWrapMinified:ze.isWordWrapMinified,isViewportWrapping:ze.isViewportWrapping,wrappingColumn:ze.wrappingColumn}}}class Qe extends E{constructor(){const Y={enabled:!0,showDropSelector:"afterDrop"};super(35,"dropIntoEditor",Y,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Y.enabled,markdownDescription:d.localize(186,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:d.localize(187,null),enum:["afterDrop","never"],enumDescriptions:[d.localize(188,null),d.localize(189,null)],default:"afterDrop"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),showDropSelector:h(me.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class Ge extends E{constructor(){const Y={enabled:!0,showPasteSelector:"afterPaste"};super(83,"pasteAs",Y,{"editor.pasteAs.enabled":{type:"boolean",default:Y.enabled,markdownDescription:d.localize(190,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:d.localize(191,null),enum:["afterPaste","never"],enumDescriptions:[d.localize(192,null),d.localize(193,null)],default:"afterPaste"}})}validate(Y){if(!Y||typeof Y!="object")return this.defaultValue;const me=Y;return{enabled:t(me.enabled,this.defaultValue.enabled),showPasteSelector:h(me.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const ct="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?xe:I.$k?tt:ct,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ne(x){return e.editorOptionsRegistry[x.id]=x,x}var nt;(function(x){x[x.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",x[x.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",x[x.accessibilitySupport=2]="accessibilitySupport",x[x.accessibilityPageSize=3]="accessibilityPageSize",x[x.ariaLabel=4]="ariaLabel",x[x.ariaRequired=5]="ariaRequired",x[x.autoClosingBrackets=6]="autoClosingBrackets",x[x.screenReaderAnnounceInlineSuggestion=7]="screenReaderAnnounceInlineSuggestion",x[x.autoClosingDelete=8]="autoClosingDelete",x[x.autoClosingOvertype=9]="autoClosingOvertype",x[x.autoClosingQuotes=10]="autoClosingQuotes",x[x.autoIndent=11]="autoIndent",x[x.automaticLayout=12]="automaticLayout",x[x.autoSurround=13]="autoSurround",x[x.bracketPairColorization=14]="bracketPairColorization",x[x.guides=15]="guides",x[x.codeLens=16]="codeLens",x[x.codeLensFontFamily=17]="codeLensFontFamily",x[x.codeLensFontSize=18]="codeLensFontSize",x[x.colorDecorators=19]="colorDecorators",x[x.colorDecoratorsLimit=20]="colorDecoratorsLimit",x[x.columnSelection=21]="columnSelection",x[x.comments=22]="comments",x[x.contextmenu=23]="contextmenu",x[x.copyWithSyntaxHighlighting=24]="copyWithSyntaxHighlighting",x[x.cursorBlinking=25]="cursorBlinking",x[x.cursorSmoothCaretAnimation=26]="cursorSmoothCaretAnimation",x[x.cursorStyle=27]="cursorStyle",x[x.cursorSurroundingLines=28]="cursorSurroundingLines",x[x.cursorSurroundingLinesStyle=29]="cursorSurroundingLinesStyle",x[x.cursorWidth=30]="cursorWidth",x[x.disableLayerHinting=31]="disableLayerHinting",x[x.disableMonospaceOptimizations=32]="disableMonospaceOptimizations",x[x.domReadOnly=33]="domReadOnly",x[x.dragAndDrop=34]="dragAndDrop",x[x.dropIntoEditor=35]="dropIntoEditor",x[x.emptySelectionClipboard=36]="emptySelectionClipboard",x[x.experimentalWhitespaceRendering=37]="experimentalWhitespaceRendering",x[x.extraEditorClassName=38]="extraEditorClassName",x[x.fastScrollSensitivity=39]="fastScrollSensitivity",x[x.find=40]="find",x[x.fixedOverflowWidgets=41]="fixedOverflowWidgets",x[x.folding=42]="folding",x[x.foldingStrategy=43]="foldingStrategy",x[x.foldingHighlight=44]="foldingHighlight",x[x.foldingImportsByDefault=45]="foldingImportsByDefault",x[x.foldingMaximumRegions=46]="foldingMaximumRegions",x[x.unfoldOnClickAfterEndOfLine=47]="unfoldOnClickAfterEndOfLine",x[x.fontFamily=48]="fontFamily",x[x.fontInfo=49]="fontInfo",x[x.fontLigatures=50]="fontLigatures",x[x.fontSize=51]="fontSize",x[x.fontWeight=52]="fontWeight",x[x.fontVariations=53]="fontVariations",x[x.formatOnPaste=54]="formatOnPaste",x[x.formatOnType=55]="formatOnType",x[x.glyphMargin=56]="glyphMargin",x[x.gotoLocation=57]="gotoLocation",x[x.hideCursorInOverviewRuler=58]="hideCursorInOverviewRuler",x[x.hover=59]="hover",x[x.inDiffEditor=60]="inDiffEditor",x[x.inlineSuggest=61]="inlineSuggest",x[x.letterSpacing=62]="letterSpacing",x[x.lightbulb=63]="lightbulb",x[x.lineDecorationsWidth=64]="lineDecorationsWidth",x[x.lineHeight=65]="lineHeight",x[x.lineNumbers=66]="lineNumbers",x[x.lineNumbersMinChars=67]="lineNumbersMinChars",x[x.linkedEditing=68]="linkedEditing",x[x.links=69]="links",x[x.matchBrackets=70]="matchBrackets",x[x.minimap=71]="minimap",x[x.mouseStyle=72]="mouseStyle",x[x.mouseWheelScrollSensitivity=73]="mouseWheelScrollSensitivity",x[x.mouseWheelZoom=74]="mouseWheelZoom",x[x.multiCursorMergeOverlapping=75]="multiCursorMergeOverlapping",x[x.multiCursorModifier=76]="multiCursorModifier",x[x.multiCursorPaste=77]="multiCursorPaste",x[x.multiCursorLimit=78]="multiCursorLimit",x[x.occurrencesHighlight=79]="occurrencesHighlight",x[x.overviewRulerBorder=80]="overviewRulerBorder",x[x.overviewRulerLanes=81]="overviewRulerLanes",x[x.padding=82]="padding",x[x.pasteAs=83]="pasteAs",x[x.parameterHints=84]="parameterHints",x[x.peekWidgetDefaultFocus=85]="peekWidgetDefaultFocus",x[x.definitionLinkOpensInPeek=86]="definitionLinkOpensInPeek",x[x.quickSuggestions=87]="quickSuggestions",x[x.quickSuggestionsDelay=88]="quickSuggestionsDelay",x[x.readOnly=89]="readOnly",x[x.readOnlyMessage=90]="readOnlyMessage",x[x.renameOnType=91]="renameOnType",x[x.renderControlCharacters=92]="renderControlCharacters",x[x.renderFinalNewline=93]="renderFinalNewline",x[x.renderLineHighlight=94]="renderLineHighlight",x[x.renderLineHighlightOnlyWhenFocus=95]="renderLineHighlightOnlyWhenFocus",x[x.renderValidationDecorations=96]="renderValidationDecorations",x[x.renderWhitespace=97]="renderWhitespace",x[x.revealHorizontalRightPadding=98]="revealHorizontalRightPadding",x[x.roundedSelection=99]="roundedSelection",x[x.rulers=100]="rulers",x[x.scrollbar=101]="scrollbar",x[x.scrollBeyondLastColumn=102]="scrollBeyondLastColumn",x[x.scrollBeyondLastLine=103]="scrollBeyondLastLine",x[x.scrollPredominantAxis=104]="scrollPredominantAxis",x[x.selectionClipboard=105]="selectionClipboard",x[x.selectionHighlight=106]="selectionHighlight",x[x.selectOnLineNumbers=107]="selectOnLineNumbers",x[x.showFoldingControls=108]="showFoldingControls",x[x.showUnused=109]="showUnused",x[x.snippetSuggestions=110]="snippetSuggestions",x[x.smartSelect=111]="smartSelect",x[x.smoothScrolling=112]="smoothScrolling",x[x.stickyScroll=113]="stickyScroll",x[x.stickyTabStops=114]="stickyTabStops",x[x.stopRenderingLineAfter=115]="stopRenderingLineAfter",x[x.suggest=116]="suggest",x[x.suggestFontSize=117]="suggestFontSize",x[x.suggestLineHeight=118]="suggestLineHeight",x[x.suggestOnTriggerCharacters=119]="suggestOnTriggerCharacters",x[x.suggestSelection=120]="suggestSelection",x[x.tabCompletion=121]="tabCompletion",x[x.tabIndex=122]="tabIndex",x[x.unicodeHighlighting=123]="unicodeHighlighting",x[x.unusualLineTerminators=124]="unusualLineTerminators",x[x.useShadowDOM=125]="useShadowDOM",x[x.useTabStops=126]="useTabStops",x[x.wordBreak=127]="wordBreak",x[x.wordSeparators=128]="wordSeparators",x[x.wordWrap=129]="wordWrap",x[x.wordWrapBreakAfterCharacters=130]="wordWrapBreakAfterCharacters",x[x.wordWrapBreakBeforeCharacters=131]="wordWrapBreakBeforeCharacters",x[x.wordWrapColumn=132]="wordWrapColumn",x[x.wordWrapOverride1=133]="wordWrapOverride1",x[x.wordWrapOverride2=134]="wordWrapOverride2",x[x.wrappingIndent=135]="wrappingIndent",x[x.wrappingStrategy=136]="wrappingStrategy",x[x.showDeprecated=137]="showDeprecated",x[x.inlayHints=138]="inlayHints",x[x.editorClassName=139]="editorClassName",x[x.pixelRatio=140]="pixelRatio",x[x.tabFocusMode=141]="tabFocusMode",x[x.layoutInfo=142]="layoutInfo",x[x.wrappingInfo=143]="wrappingInfo",x[x.defaultColorDecorators=144]="defaultColorDecorators",x[x.colorDecoratorsActivatedOn=145]="colorDecoratorsActivatedOn"})(nt||(e.EditorOption=nt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ne(new i(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:d.localize(194,null)})),acceptSuggestionOnEnter:Ne(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",d.localize(195,null),""],markdownDescription:d.localize(196,null)})),accessibilitySupport:Ne(new D),accessibilityPageSize:Ne(new m(3,"accessibilityPageSize",10,1,1073741824,{description:d.localize(197,null),tags:["accessibility"]})),ariaLabel:Ne(new r(4,"ariaLabel",d.localize(198,null))),ariaRequired:Ne(new i(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ne(new i(7,"screenReaderAnnounceInlineSuggestion",!0,{description:d.localize(199,null),tags:["accessibility"]})),autoClosingBrackets:Ne(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(200,null),d.localize(201,null),""],description:d.localize(202,null)})),autoClosingDelete:Ne(new n(8,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",d.localize(203,null),""],description:d.localize(204,null)})),autoClosingOvertype:Ne(new n(9,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",d.localize(205,null),""],description:d.localize(206,null)})),autoClosingQuotes:Ne(new n(10,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",d.localize(207,null),d.localize(208,null),""],description:d.localize(209,null)})),autoIndent:Ne(new s(11,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],p,{enumDescriptions:[d.localize(210,null),d.localize(211,null),d.localize(212,null),d.localize(213,null),d.localize(214,null)],description:d.localize(215,null)})),automaticLayout:Ne(new i(12,"automaticLayout",!1)),autoSurround:Ne(new n(13,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[d.localize(216,null),d.localize(217,null),d.localize(218,null),""],description:d.localize(219,null)})),bracketPairColorization:Ne(new oe),bracketPairGuides:Ne(new H),stickyTabStops:Ne(new i(114,"stickyTabStops",!1,{description:d.localize(220,null)})),codeLens:Ne(new i(16,"codeLens",!0,{description:d.localize(221,null)})),codeLensFontFamily:Ne(new r(17,"codeLensFontFamily","",{description:d.localize(222,null)})),codeLensFontSize:Ne(new m(18,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:d.localize(223,null)})),colorDecorators:Ne(new i(19,"colorDecorators",!0,{description:d.localize(224,null)})),colorDecoratorActivatedOn:Ne(new n(145,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[d.localize(225,null),d.localize(226,null),d.localize(227,null)],description:d.localize(228,null)})),colorDecoratorsLimit:Ne(new m(20,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:d.localize(229,null)})),columnSelection:Ne(new i(21,"columnSelection",!1,{description:d.localize(230,null)})),comments:Ne(new l),contextmenu:Ne(new i(23,"contextmenu",!0)),copyWithSyntaxHighlighting:Ne(new i(24,"copyWithSyntaxHighlighting",!0,{description:d.localize(231,null)})),cursorBlinking:Ne(new s(25,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],v,{description:d.localize(232,null)})),cursorSmoothCaretAnimation:Ne(new n(26,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[d.localize(233,null),d.localize(234,null),d.localize(235,null)],description:d.localize(236,null)})),cursorStyle:Ne(new s(27,"cursorStyle",u.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],A,{description:d.localize(237,null)})),cursorSurroundingLines:Ne(new m(28,"cursorSurroundingLines",0,0,1073741824,{description:d.localize(238,null)})),cursorSurroundingLinesStyle:Ne(new n(29,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[d.localize(239,null),d.localize(240,null)],description:d.localize(241,null)})),cursorWidth:Ne(new m(30,"cursorWidth",0,0,1073741824,{markdownDescription:d.localize(242,null)})),disableLayerHinting:Ne(new i(31,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ne(new i(32,"disableMonospaceOptimizations",!1)),domReadOnly:Ne(new i(33,"domReadOnly",!1)),dragAndDrop:Ne(new i(34,"dragAndDrop",!0,{description:d.localize(243,null)})),emptySelectionClipboard:Ne(new B),dropIntoEditor:Ne(new Qe),stickyScroll:Ne(new ne),experimentalWhitespaceRendering:Ne(new n(37,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[d.localize(244,null),d.localize(245,null),d.localize(246,null)],description:d.localize(247,null)})),extraEditorClassName:Ne(new r(38,"extraEditorClassName","")),fastScrollSensitivity:Ne(new C(39,"fastScrollSensitivity",5,x=>x<=0?5:x,{markdownDescription:d.localize(248,null)})),find:Ne(new V),fixedOverflowWidgets:Ne(new i(41,"fixedOverflowWidgets",!1)),folding:Ne(new i(42,"folding",!0,{description:d.localize(249,null)})),foldingStrategy:Ne(new n(43,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[d.localize(250,null),d.localize(251,null)],description:d.localize(252,null)})),foldingHighlight:Ne(new i(44,"foldingHighlight",!0,{description:d.localize(253,null)})),foldingImportsByDefault:Ne(new i(45,"foldingImportsByDefault",!1,{description:d.localize(254,null)})),foldingMaximumRegions:Ne(new m(46,"foldingMaximumRegions",5e3,10,65e3,{description:d.localize(255,null)})),unfoldOnClickAfterEndOfLine:Ne(new i(47,"unfoldOnClickAfterEndOfLine",!1,{description:d.localize(256,null)})),fontFamily:Ne(new r(48,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:d.localize(257,null)})),fontInfo:Ne(new N),fontLigatures2:Ne(new U),fontSize:Ne(new ae),fontWeight:Ne(new Q),fontVariations:Ne(new O),formatOnPaste:Ne(new i(54,"formatOnPaste",!1,{description:d.localize(258,null)})),formatOnType:Ne(new i(55,"formatOnType",!1,{description:d.localize(259,null)})),glyphMargin:Ne(new i(56,"glyphMargin",!0,{description:d.localize(260,null)})),gotoLocation:Ne(new be),hideCursorInOverviewRuler:Ne(new i(58,"hideCursorInOverviewRuler",!1,{description:d.localize(261,null)})),hover:Ne(new ke),inDiffEditor:Ne(new i(60,"inDiffEditor",!1)),letterSpacing:Ne(new C(62,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,x=>C.clamp(x,-5,20),{description:d.localize(262,null)})),lightbulb:Ne(new le),lineDecorationsWidth:Ne(new ue),lineHeight:Ne(new T),lineNumbers:Ne(new fe),lineNumbersMinChars:Ne(new m(67,"lineNumbersMinChars",5,1,300)),linkedEditing:Ne(new i(68,"linkedEditing",!1,{description:d.localize(263,null)})),links:Ne(new i(69,"links",!0,{description:d.localize(264,null)})),matchBrackets:Ne(new n(70,"matchBrackets","always",["always","near","never"],{description:d.localize(265,null)})),minimap:Ne(new _),mouseStyle:Ne(new n(72,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ne(new C(73,"mouseWheelScrollSensitivity",1,x=>x===0?1:x,{markdownDescription:d.localize(266,null)})),mouseWheelZoom:Ne(new i(74,"mouseWheelZoom",!1,{markdownDescription:d.localize(267,null)})),multiCursorMergeOverlapping:Ne(new i(75,"multiCursorMergeOverlapping",!0,{description:d.localize(268,null)})),multiCursorModifier:Ne(new s(76,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ye,{markdownEnumDescriptions:[d.localize(269,null),d.localize(270,null)],markdownDescription:d.localize(271,null)})),multiCursorPaste:Ne(new n(77,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[d.localize(272,null),d.localize(273,null)],markdownDescription:d.localize(274,null)})),multiCursorLimit:Ne(new m(78,"multiCursorLimit",1e4,1,1e5,{markdownDescription:d.localize(275,null)})),occurrencesHighlight:Ne(new i(79,"occurrencesHighlight",!0,{description:d.localize(276,null)})),overviewRulerBorder:Ne(new i(80,"overviewRulerBorder",!0,{description:d.localize(277,null)})),overviewRulerLanes:Ne(new m(81,"overviewRulerLanes",3,0,3)),padding:Ne(new Ce),pasteAs:Ne(new Ge),parameterHints:Ne(new Se),peekWidgetDefaultFocus:Ne(new n(85,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[d.localize(278,null),d.localize(279,null)],description:d.localize(280,null)})),definitionLinkOpensInPeek:Ne(new i(86,"definitionLinkOpensInPeek",!1,{description:d.localize(281,null)})),quickSuggestions:Ne(new Ie),quickSuggestionsDelay:Ne(new m(88,"quickSuggestionsDelay",10,0,1073741824,{description:d.localize(282,null)})),readOnly:Ne(new i(89,"readOnly",!1)),readOnlyMessage:Ne(new he),renameOnType:Ne(new i(91,"renameOnType",!1,{description:d.localize(283,null),markdownDeprecationMessage:d.localize(284,null)})),renderControlCharacters:Ne(new i(92,"renderControlCharacters",!0,{description:d.localize(285,null),restricted:!0})),renderFinalNewline:Ne(new n(93,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:d.localize(286,null)})),renderLineHighlight:Ne(new n(94,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",d.localize(287,null)],description:d.localize(288,null)})),renderLineHighlightOnlyWhenFocus:Ne(new i(95,"renderLineHighlightOnlyWhenFocus",!1,{description:d.localize(289,null)})),renderValidationDecorations:Ne(new n(96,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ne(new n(97,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",d.localize(290,null),d.localize(291,null),d.localize(292,null),""],description:d.localize(293,null)})),revealHorizontalRightPadding:Ne(new m(98,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ne(new i(99,"roundedSelection",!0,{description:d.localize(294,null)})),rulers:Ne(new ie),scrollbar:Ne(new q),scrollBeyondLastColumn:Ne(new m(102,"scrollBeyondLastColumn",4,0,1073741824,{description:d.localize(295,null)})),scrollBeyondLastLine:Ne(new i(103,"scrollBeyondLastLine",!0,{description:d.localize(296,null)})),scrollPredominantAxis:Ne(new i(104,"scrollPredominantAxis",!0,{description:d.localize(297,null)})),selectionClipboard:Ne(new i(105,"selectionClipboard",!0,{description:d.localize(298,null),included:I.$k})),selectionHighlight:Ne(new i(106,"selectionHighlight",!0,{description:d.localize(299,null)})),selectOnLineNumbers:Ne(new i(107,"selectOnLineNumbers",!0)),showFoldingControls:Ne(new n(108,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[d.localize(300,null),d.localize(301,null),d.localize(302,null)],description:d.localize(303,null)})),showUnused:Ne(new i(109,"showUnused",!0,{description:d.localize(304,null)})),showDeprecated:Ne(new i(137,"showDeprecated",!0,{description:d.localize(305,null)})),inlayHints:Ne(new de),snippetSuggestions:Ne(new n(110,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[d.localize(306,null),d.localize(307,null),d.localize(308,null),d.localize(309,null)],description:d.localize(310,null)})),smartSelect:Ne(new Oe),smoothScrolling:Ne(new i(112,"smoothScrolling",!1,{description:d.localize(311,null)})),stopRenderingLineAfter:Ne(new m(115,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ne(new pe),inlineSuggest:Ne(new K),suggestFontSize:Ne(new m(117,"suggestFontSize",0,0,1e3,{markdownDescription:d.localize(312,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ne(new m(118,"suggestLineHeight",0,0,1e3,{markdownDescription:d.localize(313,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ne(new i(119,"suggestOnTriggerCharacters",!0,{description:d.localize(314,null)})),suggestSelection:Ne(new n(120,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[d.localize(315,null),d.localize(316,null),d.localize(317,null)],description:d.localize(318,null)})),tabCompletion:Ne(new n(121,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[d.localize(319,null),d.localize(320,null),d.localize(321,null)],description:d.localize(322,null)})),tabIndex:Ne(new m(122,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ne(new J),unusualLineTerminators:Ne(new n(124,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[d.localize(323,null),d.localize(324,null),d.localize(325,null)],description:d.localize(326,null)})),useShadowDOM:Ne(new i(125,"useShadowDOM",!0)),useTabStops:Ne(new i(126,"useTabStops",!0,{description:d.localize(327,null)})),wordBreak:Ne(new n(127,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[d.localize(328,null),d.localize(329,null)],description:d.localize(330,null)})),wordSeparators:Ne(new r(128,"wordSeparators",P.$Gr,{description:d.localize(331,null)})),wordWrap:Ne(new n(129,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[d.localize(332,null),d.localize(333,null),d.localize(334,null),d.localize(335,null)],description:d.localize(336,null)})),wordWrapBreakAfterCharacters:Ne(new r(130,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ne(new r(131,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ne(new m(132,"wordWrapColumn",80,1,1073741824,{markdownDescription:d.localize(337,null)})),wordWrapOverride1:Ne(new n(133,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ne(new n(134,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ne(new W),defaultColorDecorators:Ne(new i(144,"defaultColorDecorators",!1,{markdownDescription:d.localize(338,null)})),pixelRatio:Ne(new Ee),tabFocusMode:Ne(new i(141,"tabFocusMode",!1,{markdownDescription:d.localize(339,null)})),layoutInfo:Ne(new G),wrappingInfo:Ne(new Ke),wrappingIndent:Ne(new Ze),wrappingStrategy:Ne(new Z)}}),define(Ae[137],Re([9,10]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ae[138],Re([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(Ae[139],Re([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(Ae[140],Re([9,10]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ae[141],Re([9,10]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ae[142],Re([9,10]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(Ae[143],Re([9,10]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(Ae[144],Re([9,10]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(Ae[145],Re([9,10]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(Ae[146],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostChat",e)}),define(Ae[147],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ae[148],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ae[149],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ae[150],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(Ae[151],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ae[152],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(Ae[153],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ae[154],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ae[155],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ae[156],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ae[157],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ae[158],Re([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ae[159],Re([9,10]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(Ae[160],Re([9,10]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(Ae[161],Re([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ae[162],Re([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ae[163],Re([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ae[164],Re([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ae[165],Re([9,10]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ae[166],Re([9,10]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ae[167],Re([9,10]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ae[168],Re([1,0,11,139]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.TokenType=void 0;var I;(function($){$[$.LParen=0]="LParen",$[$.RParen=1]="RParen",$[$.Neg=2]="Neg",$[$.Eq=3]="Eq",$[$.NotEq=4]="NotEq",$[$.Lt=5]="Lt",$[$.LtEq=6]="LtEq",$[$.Gt=7]="Gt",$[$.GtEq=8]="GtEq",$[$.RegexOp=9]="RegexOp",$[$.RegexStr=10]="RegexStr",$[$.True=11]="True",$[$.False=12]="False",$[$.In=13]="In",$[$.Not=14]="Not",$[$.And=15]="And",$[$.Or=16]="Or",$[$.Str=17]="Str",$[$.QuotedStr=18]="QuotedStr",$[$.Error=19]="Error",$[$.EOF=20]="EOF"})(I||(e.TokenType=I={}));function z(...$){switch($.length){case 1:return(0,L.localize)(0,null,$[0]);case 2:return(0,L.localize)(1,null,$[0],$[1]);case 3:return(0,L.localize)(2,null,$[0],$[1],$[2]);default:return}}const P=(0,L.localize)(3,null),d=(0,L.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,w.$6)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(z("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(z("&&"));break;case 124:this.h(124)?this.k(16):this.l(z("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const E=this.d,c=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:c};this.g.push({offset:E,lexeme:c,additionalInfo:R}),this.f.push(y)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const E=this.c.substring(this.d,this.e),c=k.b.get(E);c?this.k(c):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(P);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,E=!1,c=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(d);return}const b=this.c.charCodeAt(R);if(E)E=!1;else if(b===47&&!c){R++;break}else b===91?c=!0:b===92?E=!0:b===93&&(c=!1);R++}for(;R<this.c.length&&k.a.has(this.c.charCodeAt(R));)R++;this.e=R;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$qi=k}),define(Ae[169],Re([1,0,23,29,141,272]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,d=/^-(\d{4})(\d{2})(\d{2})$/;function k(i){return i=i.trim(),i==="*"||P.test(i)}e.$po=k;function $(i){if(!k(i))return null;if(i=i.trim(),i==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const a=i.match(P);return a?{hasCaret:a[1]==="^",hasGreaterEquals:a[1]===">=",majorBase:a[2]==="x"?0:parseInt(a[2],10),majorMustEqual:a[2]!=="x",minorBase:a[4]==="x"?0:parseInt(a[4],10),minorMustEqual:a[4]!=="x",patchBase:a[6]==="x"?0:parseInt(a[6],10),patchMustEqual:a[6]!=="x",preRelease:a[8]||null}:null}e.$qo=$;function R(i){if(!i)return null;const a=i.majorBase,m=i.majorMustEqual,S=i.minorBase;let C=i.minorMustEqual;const r=i.patchBase;let h=i.patchMustEqual;i.hasCaret&&(a===0||(C=!1),h=!1);let n=0;if(i.preRelease){const s=d.exec(i.preRelease);if(s){const[,p,D,l]=s;n=Date.UTC(Number(p),Number(D)-1,Number(l))}}return{majorBase:a,majorMustEqual:m,minorBase:S,minorMustEqual:C,patchBase:r,patchMustEqual:h,isMinimum:i.hasGreaterEquals,notBefore:n}}e.$ro=R;function E(i,a,m){let S;typeof i=="string"?S=R($(i)):S=i;let C;a instanceof Date?C=a.getTime():typeof a=="string"&&(C=new Date(a).getTime());let r;if(typeof m=="string"?r=R($(m)):r=m,!S||!r)return!1;const h=S.majorBase,n=S.minorBase,s=S.patchBase;let p=r.majorBase,D=r.minorBase,l=r.patchBase;const g=r.notBefore;let v=r.majorMustEqual,u=r.minorMustEqual,f=r.patchMustEqual;return r.isMinimum?h>p?!0:h<p?!1:n>D?!0:n<D||C&&C<g?!1:s>=l:(h===1&&p===0&&(!v||!u||!f)&&(p=1,D=0,l=0,v=!0,u=!1,f=!1),h<p?!1:h>p?!v:n<D?!1:n>D?!u:s<l?!1:s>l?!f:!(C&&C<g))}e.$so=E;function c(i,a,m,S,C){const r=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return r.push([L.default.Error,I.localize(0,null)]),r;if(typeof S.name!="string")return r.push([L.default.Error,I.localize(1,null,"name")]),r;if(typeof S.version!="string")return r.push([L.default.Error,I.localize(2,null,"version")]),r;if(!S.engines)return r.push([L.default.Error,I.localize(3,null,"engines")]),r;if(typeof S.engines.vscode!="string")return r.push([L.default.Error,I.localize(4,null,"engines.vscode")]),r;if(typeof S.extensionDependencies<"u"&&!t(S.extensionDependencies))return r.push([L.default.Error,I.localize(5,null,"extensionDependencies")]),r;if(typeof S.activationEvents<"u"){if(!t(S.activationEvents))return r.push([L.default.Error,I.localize(6,null,"activationEvents")]),r;if(typeof S.main>"u"&&typeof S.browser>"u")return r.push([L.default.Error,I.localize(7,null,"activationEvents","main","browser")]),r}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&r.push([L.default.Warning,I.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return r.push([L.default.Error,I.localize(9,null,"main")]),r;{const s=(0,w.$8f)(m,S.main);(0,w.$2f)(s,m)||r.push([L.default.Warning,I.localize(10,null,s.path,m.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return r.push([L.default.Error,I.localize(11,null,"browser")]),r;{const s=(0,w.$8f)(m,S.browser);(0,w.$2f)(s,m)||r.push([L.default.Warning,I.localize(12,null,s.path,m.path)])}}if(!z.valid(S.version))return r.push([L.default.Error,I.localize(13,null)]),r;const h=[];if(!y(i,a,S,C,h))for(const s of h)r.push([L.default.Error,s]);return r}e.$to=c;function y(i,a,m,S,C){return S||typeof m.main>"u"&&typeof m.browser>"u"?!0:o(i,a,m.engines.vscode,C)}e.$uo=y;function b(i,a,m){return i==="*"||o(a,m,i)}e.$vo=b;function o(i,a,m,S=[]){const C=R($(m));if(!C)return S.push(I.localize(14,null,m)),!1;if(C.majorBase===0){if(!C.majorMustEqual||!C.minorMustEqual)return S.push(I.localize(15,null,m)),!1}else if(!C.majorMustEqual)return S.push(I.localize(16,null,m)),!1;return E(i,a,C)?!0:(S.push(I.localize(17,null,i,m)),!1)}function t(i){if(!Array.isArray(i))return!1;for(let a=0,m=i.length;a<m;a++)if(typeof i[a]!="string")return!1;return!0}}),define(Ae[71],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kh=void 0;class w{constructor(I,z=[],P=!1){this.ctor=I,this.staticArguments=z,this.supportsDelayedInstantiation=P}}e.$kh=w}),define(Ae[72],Re([1,0,71]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=e.$0q=e.InstantiationType=void 0;const L=[];var I;(function(d){d[d.Eager=0]="Eager",d[d.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function z(d,k,$){k instanceof w.$kh||(k=new w.$kh(k,[],!!$)),L.push([d,k])}e.$0q=z;function P(){return L}e.$$q=P}),define(Ae[170],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rp=e.$Qp=void 0;class w{constructor(z,P){this.key=z,this.data=P,this.incoming=new Map,this.outgoing=new Map}}e.$Qp=w;class L{constructor(z){this.b=z,this.a=new Map}roots(){const z=[];for(const P of this.a.values())P.outgoing.size===0&&z.push(P);return z}insertEdge(z,P){const d=this.lookupOrInsertNode(z),k=this.lookupOrInsertNode(P);d.outgoing.set(k.key,k),k.incoming.set(d.key,d)}removeNode(z){const P=this.b(z);this.a.delete(P);for(const d of this.a.values())d.outgoing.delete(P),d.incoming.delete(P)}lookupOrInsertNode(z){const P=this.b(z);let d=this.a.get(P);return d||(d=new w(P,z),this.a.set(P,d)),d}lookup(z){return this.a.get(this.b(z))}isEmpty(){return this.a.size===0}toString(){const z=[];for(const[P,d]of this.a)z.push(`${P}
	(-> incoming)[${[...d.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...d.outgoing.keys()].join(",")}]
`);return z.join(`
`)}findCycleSlow(){for(const[z,P]of this.a){const d=new Set([z]),k=this.c(P,d);if(k)return k}}c(z,P){for(const[d,k]of z.outgoing){if(P.has(d))return[...P,d].join(" -> ");P.add(d);const $=this.c(k,P);if($)return $;P.delete(d)}}}e.$Rp=L}),define(Ae[3],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oh=e.$nh=e.$mh=e._util=void 0;var w;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function d(k){return k[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=d})(w||(e._util=w={})),e.$mh=I("instantiationService");function L(P,d,k){d[w.DI_TARGET]===d?d[w.DI_DEPENDENCIES].push({id:P,index:k}):(d[w.DI_DEPENDENCIES]=[{id:P,index:k}],d[w.DI_TARGET]=d)}function I(P){if(w.serviceIds.has(P))return w.serviceIds.get(P);const d=function(k,$,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(d,k,R)};return d.toString=()=>P,w.serviceIds.set(P,d),d}e.$nh=I;function z(P){return P}e.$oh=z}),define(Ae[43],Re([1,0,12,2,3]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=e.$3h=e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.ConfigurationTarget=e.$Vh=e.$Uh=e.$Th=void 0,e.$Th=(0,I.$nh)("configurationService");function z(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof L.URI)}e.$Uh=z;function P(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof L.URI)}e.$Vh=P;var d;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(d||(e.ConfigurationTarget=d={}));function k(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Wh=k;function $(i){return i.applicationValue!==void 0||i.userValue!==void 0||i.userLocalValue!==void 0||i.userRemoteValue!==void 0||i.workspaceValue!==void 0||i.workspaceFolderValue!==void 0}e.$Xh=$;function R(i,a){const m=Object.create(null);for(const S in i)E(m,S,i[S],a);return m}e.$Yh=R;function E(i,a,m,S){const C=a.split("."),r=C.pop();let h=i;for(let n=0;n<C.length;n++){const s=C[n];let p=h[s];switch(typeof p){case"undefined":p=h[s]=Object.create(null);break;case"object":break;default:S(`Ignoring ${a} as ${C.slice(0,n+1).join(".")} is ${JSON.stringify(p)}`);return}h=p}if(typeof h=="object"&&h!==null)try{h[r]=m}catch{S(`Ignoring ${a} as ${C.join(".")} is ${JSON.stringify(h)}`)}else S(`Ignoring ${a} as ${C.join(".")} is ${JSON.stringify(h)}`)}e.$Zh=E;function c(i,a){const m=a.split(".");y(i,m)}e.$1h=c;function y(i,a){const m=a.shift();if(a.length===0){delete i[m];return}if(Object.keys(i).indexOf(m)!==-1){const S=i[m];typeof S=="object"&&!Array.isArray(S)&&(y(S,a),Object.keys(S).length===0&&delete i[m])}}function b(i,a,m){function S(h,n){let s=h;for(const p of n){if(typeof s!="object"||s===null)return;s=s[p]}return s}const C=a.split("."),r=S(i,C);return typeof r>"u"?m:r}e.$2h=b;function o(i,a,m){Object.keys(a).forEach(S=>{S!=="__proto__"&&(S in i?w.$ke(i[S])&&w.$ke(a[S])?o(i[S],a[S],m):m&&(i[S]=a[S]):i[S]=a[S])})}e.$3h=o;function t(i){return i.replace(/[\[\]]/g,"")}e.$4h=t}),define(Ae[31],Re([1,0,22,15,168,3,138,11]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.ContextKeyExprType=e.$ri=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",w.$j),k.set("isLinux",w.$k),k.set("isWindows",w.$i),k.set("isWeb",w.$o),k.set("isMacNative",w.$j&&!w.$o),k.set("isEdge",w.$G),k.set("isFirefox",w.$E),k.set("isChrome",w.$D),k.set("isSafari",w.$F);function $(ue,T){if(k.get(ue)!==void 0)throw(0,d.$5)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(ue,T)}e.$ri=$;const R=Object.prototype.hasOwnProperty;var E;(function(ue){ue[ue.False=0]="False",ue[ue.True=1]="True",ue[ue.Defined=2]="Defined",ue[ue.Not=3]="Not",ue[ue.Equals=4]="Equals",ue[ue.NotEquals=5]="NotEquals",ue[ue.And=6]="And",ue[ue.Regex=7]="Regex",ue[ue.NotRegex=8]="NotRegex",ue[ue.Or=9]="Or",ue[ue.In=10]="In",ue[ue.NotIn=11]="NotIn",ue[ue.Greater=12]="Greater",ue[ue.GreaterEquals=13]="GreaterEquals",ue[ue.Smaller=14]="Smaller",ue[ue.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const c={regexParsingWithErrorRecovery:!0},y=(0,P.localize)(0,null),b=(0,P.localize)(1,null),o=(0,P.localize)(2,null),t=(0,P.localize)(3,null),i=(0,P.localize)(4,null),a=(0,P.localize)(5,null),m=(0,P.localize)(6,null),S=(0,P.localize)(7,null);class C{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(T=c){this.k=T,this.d=new I.$qi,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(T){if(T===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(T).scan(),this.g=0,this.h=[];try{const _=this.l();if(!this.E()){const ye=this.D(),Ce=ye.type===17?a:void 0;throw this.h.push({message:i,offset:ye.offset,lexeme:I.$qi.getLexeme(ye),additionalInfo:Ce}),C.c}return _}catch(_){if(_!==C.c)throw _;return}}l(){return this.m()}m(){const T=[this.o()];for(;this.y(16);){const _=this.o();T.push(_)}return T.length===1?T[0]:r.or(...T)}o(){const T=[this.s()];for(;this.y(15);){const _=this.s();T.push(_)}return T.length===1?T[0]:r.and(...T)}s(){if(this.y(2)){const T=this.D();switch(T.type){case 11:return this.z(),p.INSTANCE;case 12:return this.z(),D.INSTANCE;case 0:{this.z();const _=this.l();return this.A(1,t),_?.negate()}case 17:return this.z(),A.create(T.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",T)}}return this.t()}t(){const T=this.D();switch(T.type){case 11:return this.z(),r.true();case 12:return this.z(),r.false();case 0:{this.z();const _=this.l();return this.A(1,t),_}case 17:{const _=T.lexeme;if(this.z(),this.y(9)){const Ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ce.type!==10)throw this.B("REGEX",Ce);const Se=Ce.lexeme,Ee=Se.lastIndexOf("/"),Ie=Ee===Se.length-1?void 0:this.w(Se.substring(Ee+1));let se;try{se=new RegExp(Se.substring(1,Ee),Ie)}catch{throw this.B("REGEX",Ce)}return N.create(_,se)}switch(Ce.type){case 10:case 19:{const Se=[Ce.lexeme];this.z();let Ee=this.D(),Ie=0;for(let he=0;he<Ce.lexeme.length;he++)Ce.lexeme.charCodeAt(he)===40?Ie++:Ce.lexeme.charCodeAt(he)===41&&Ie--;for(;!this.E()&&Ee.type!==15&&Ee.type!==16;){switch(Ee.type){case 0:Ie++;break;case 1:Ie--;break;case 10:case 18:for(let he=0;he<Ee.lexeme.length;he++)Ee.lexeme.charCodeAt(he)===40?Ie++:Ce.lexeme.charCodeAt(he)===41&&Ie--}if(Ie<0)break;Se.push(I.$qi.getLexeme(Ee)),this.z(),Ee=this.D()}const se=Se.join(""),fe=se.lastIndexOf("/"),ee=fe===se.length-1?void 0:this.w(se.substring(fe+1));let ie;try{ie=new RegExp(se.substring(1,fe),ee)}catch{throw this.B("REGEX",Ce)}return r.regex(_,ie)}case 18:{const Se=Ce.lexeme;this.z();let Ee=null;if(!(0,L.$jd)(Se)){const Ie=Se.indexOf("/"),se=Se.lastIndexOf("/");if(Ie!==se&&Ie>=0){const fe=Se.slice(Ie+1,se),ee=Se[se+1]==="i"?"i":"";try{Ee=new RegExp(fe,ee)}catch{throw this.B("REGEX",Ce)}}}if(Ee===null)throw this.B("REGEX",Ce);return N.create(_,Ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,o);const Ce=this.u();return r.notIn(_,Ce)}switch(this.D().type){case 3:{this.z();const Ce=this.u();if(this.x().type===18)return r.equals(_,Ce);switch(Ce){case"true":return r.has(_);case"false":return r.not(_);default:return r.equals(_,Ce)}}case 4:{this.z();const Ce=this.u();if(this.x().type===18)return r.notEquals(_,Ce);switch(Ce){case"true":return r.not(_);case"false":return r.has(_);default:return r.notEquals(_,Ce)}}case 5:return this.z(),U.create(_,this.u());case 6:return this.z(),O.create(_,this.u());case 7:return this.z(),B.create(_,this.u());case 8:return this.z(),V.create(_,this.u());case 13:return this.z(),r.in(_,this.u());default:return r.has(_)}}case 20:throw this.h.push({message:m,offset:T.offset,lexeme:"",additionalInfo:S}),C.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const T=this.D();switch(T.type){case 17:case 18:return this.z(),T.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(T){return T.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(T){return this.C(T)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(T,_){if(this.C(T))return this.z();throw this.B(_,this.D())}B(T,_,ye){const Ce=(0,P.localize)(8,null,T,I.$qi.getLexeme(_)),Se=_.offset,Ee=I.$qi.getLexeme(_);return this.h.push({message:Ce,offset:Se,lexeme:Ee,additionalInfo:ye}),C.c}C(T){return this.D().type===T}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$si=C;class r{static false(){return p.INSTANCE}static true(){return D.INSTANCE}static has(T){return l.create(T)}static equals(T,_){return g.create(T,_)}static notEquals(T,_){return f.create(T,_)}static regex(T,_){return N.create(T,_)}static in(T,_){return v.create(T,_)}static notIn(T,_){return u.create(T,_)}static not(T){return A.create(T)}static and(...T){return be.create(T,null,!0)}static or(...T){return ke.create(T,null,!0)}static greater(T,_){return B.create(T,_)}static greaterEquals(T,_){return V.create(T,_)}static smaller(T,_){return U.create(T,_)}static smallerEquals(T,_){return O.create(T,_)}static{this.c=new C({regexParsingWithErrorRecovery:!1})}static deserialize(T){return T==null?void 0:this.c.parse(T)}}e.$ti=r;function h(ue){const T=new C({regexParsingWithErrorRecovery:!1});return ue.map(_=>(T.parse(_),T.lexingErrors.length>0?T.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,P.localize)(9,null,ye.additionalInfo):(0,P.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):T.parsingErrors.length>0?T.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$ui=h;function n(ue,T){const _=ue?ue.substituteConstants():void 0,ye=T?T.substituteConstants():void 0;return!_&&!ye?!0:!_||!ye?!1:_.equals(ye)}e.$vi=n;function s(ue,T){return ue.cmp(T)}class p{static{this.INSTANCE=new p}constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return D.INSTANCE}}e.$wi=p;class D{static{this.INSTANCE=new D}constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return p.INSTANCE}}e.$xi=D;class l{static create(T,_=null){const ye=k.get(T);return typeof ye=="boolean"?ye?D.INSTANCE:p.INSTANCE:new l(T,_)}constructor(T,_){this.key=T,this.c=_,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:G(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=k.get(this.key);return typeof T=="boolean"?T?D.INSTANCE:p.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.c||(this.c=A.create(this.key,this)),this.c}}e.$yi=l;class g{static create(T,_,ye=null){if(typeof _=="boolean")return _?l.create(T,ye):A.create(T,ye);const Ce=k.get(T);return typeof Ce=="boolean"?_===(Ce?"true":"false")?D.INSTANCE:p.INSTANCE:new g(T,_,ye)}constructor(T,_,ye){this.c=T,this.d=_,this.f=ye,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:Z(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=k.get(this.c);if(typeof T=="boolean"){const _=T?"true":"false";return this.d===_?D.INSTANCE:p.INSTANCE}return this}evaluate(T){return T.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(T){return T.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.$zi=g;class v{static create(T,_){return new v(T,_)}constructor(T,_){this.d=T,this.f=_,this.type=10,this.c=null}cmp(T){return T.type!==this.type?this.type-T.type:Z(this.d,this.f,T.d,T.f)}equals(T){return T.type===this.type?this.d===T.d&&this.f===T.f:!1}substituteConstants(){return this}evaluate(T){const _=T.getValue(this.f),ye=T.getValue(this.d);return Array.isArray(_)?_.includes(ye):typeof ye=="string"&&typeof _=="object"&&_!==null?R.call(_,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(T){return T.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$Ai=v;class u{static create(T,_){return new u(T,_)}constructor(T,_){this.d=T,this.f=_,this.type=11,this.c=v.create(T,_)}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(T){return T.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Bi=u;class f{static create(T,_,ye=null){if(typeof _=="boolean")return _?A.create(T,ye):l.create(T,ye);const Ce=k.get(T);return typeof Ce=="boolean"?_===(Ce?"true":"false")?p.INSTANCE:D.INSTANCE:new f(T,_,ye)}constructor(T,_,ye){this.c=T,this.d=_,this.f=ye,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:Z(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=k.get(this.c);if(typeof T=="boolean"){const _=T?"true":"false";return this.d===_?p.INSTANCE:D.INSTANCE}return this}evaluate(T){return T.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(T){return T.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=g.create(this.c,this.d,this)),this.f}}e.$Ci=f;class A{static create(T,_=null){const ye=k.get(T);return typeof ye=="boolean"?ye?p.INSTANCE:D.INSTANCE:new A(T,_)}constructor(T,_){this.c=T,this.d=_,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:G(this.c,T.c)}equals(T){return T.type===this.type?this.c===T.c:!1}substituteConstants(){const T=k.get(this.c);return typeof T=="boolean"?T?p.INSTANCE:D.INSTANCE:this}evaluate(T){return!T.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(T){return T.mapNot(this.c)}negate(){return this.d||(this.d=l.create(this.c,this)),this.d}}e.$Di=A;function W(ue,T){if(typeof ue=="string"){const _=parseFloat(ue);isNaN(_)||(ue=_)}return typeof ue=="string"||typeof ue=="number"?T(ue):p.INSTANCE}class B{static create(T,_,ye=null){return W(_,Ce=>new B(T,Ce,ye))}constructor(T,_,ye){this.c=T,this.d=_,this.f=ye,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:Z(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Ei=B;class V{static create(T,_,ye=null){return W(_,Ce=>new V(T,Ce,ye))}constructor(T,_,ye){this.c=T,this.d=_,this.f=ye,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:Z(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Fi=V;class U{static create(T,_,ye=null){return W(_,Ce=>new U(T,Ce,ye))}constructor(T,_,ye){this.c=T,this.d=_,this.f=ye,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:Z(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Gi=U;class O{static create(T,_,ye=null){return W(_,Ce=>new O(T,Ce,ye))}constructor(T,_,ye){this.c=T,this.d=_,this.f=ye,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:Z(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.$Hi=O;class N{static create(T,_){return new N(T,_)}constructor(T,_){this.d=T,this.f=_,this.type=7,this.c=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.d<T.d)return-1;if(this.d>T.d)return 1;const _=this.f?this.f.source:"",ye=T.f?T.f.source:"";return _<ye?-1:_>ye?1:0}equals(T){if(T.type===this.type){const _=this.f?this.f.source:"",ye=T.f?T.f.source:"";return this.d===T.d&&_===ye}return!1}substituteConstants(){return this}evaluate(T){const _=T.getValue(this.d);return this.f?this.f.test(_):!1}serialize(){const T=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${T}`}keys(){return[this.d]}map(T){return T.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$Ii=N;class ae{static create(T){return new ae(T)}constructor(T){this.c=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(T){return new ae(this.c.map(T))}negate(){return this.c}}e.$Ji=ae;function Q(ue){let T=null;for(let _=0,ye=ue.length;_<ye;_++){const Ce=ue[_].substituteConstants();if(ue[_]!==Ce&&T===null){T=[];for(let Se=0;Se<_;Se++)T[Se]=ue[Se]}T!==null&&(T[_]=Ce)}return T===null?ue:T}class be{static create(T,_,ye){return be.d(T,_,ye)}constructor(T,_){this.expr=T,this.c=_,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let _=0,ye=this.expr.length;_<ye;_++){const Ce=s(this.expr[_],T.expr[_]);if(Ce!==0)return Ce}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let _=0,ye=this.expr.length;_<ye;_++)if(!this.expr[_].equals(T.expr[_]))return!1;return!0}return!1}substituteConstants(){const T=Q(this.expr);return T===this.expr?this:be.create(T,this.c,!1)}evaluate(T){for(let _=0,ye=this.expr.length;_<ye;_++)if(!this.expr[_].evaluate(T))return!1;return!0}static d(T,_,ye){const Ce=[];let Se=!1;for(const Ee of T)if(Ee){if(Ee.type===1){Se=!0;continue}if(Ee.type===0)return p.INSTANCE;if(Ee.type===6){Ce.push(...Ee.expr);continue}Ce.push(Ee)}if(Ce.length===0&&Se)return D.INSTANCE;if(Ce.length!==0){if(Ce.length===1)return Ce[0];Ce.sort(s);for(let Ee=1;Ee<Ce.length;Ee++)Ce[Ee-1].equals(Ce[Ee])&&(Ce.splice(Ee,1),Ee--);if(Ce.length===1)return Ce[0];for(;Ce.length>1;){const Ee=Ce[Ce.length-1];if(Ee.type!==9)break;Ce.pop();const Ie=Ce.pop(),se=Ce.length===0,fe=ke.create(Ee.expr.map(ee=>be.create([ee,Ie],null,ye)),null,se);fe&&(Ce.push(fe),Ce.sort(s))}if(Ce.length===1)return Ce[0];if(ye){for(let Ee=0;Ee<Ce.length;Ee++)for(let Ie=Ee+1;Ie<Ce.length;Ie++)if(Ce[Ee].negate().equals(Ce[Ie]))return p.INSTANCE;if(Ce.length===1)return Ce[0]}return new be(Ce,_)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const _ of this.expr)T.push(..._.keys());return T}map(T){return new be(this.expr.map(_=>_.map(T)),null)}negate(){if(!this.c){const T=[];for(const _ of this.expr)T.push(_.negate());this.c=ke.create(T,this,!0)}return this.c}}e.$Ki=be;class ke{static create(T,_,ye){return ke.d(T,_,ye)}constructor(T,_){this.expr=T,this.c=_,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let _=0,ye=this.expr.length;_<ye;_++){const Ce=s(this.expr[_],T.expr[_]);if(Ce!==0)return Ce}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let _=0,ye=this.expr.length;_<ye;_++)if(!this.expr[_].equals(T.expr[_]))return!1;return!0}return!1}substituteConstants(){const T=Q(this.expr);return T===this.expr?this:ke.create(T,this.c,!1)}evaluate(T){for(let _=0,ye=this.expr.length;_<ye;_++)if(this.expr[_].evaluate(T))return!0;return!1}static d(T,_,ye){let Ce=[],Se=!1;if(T){for(let Ee=0,Ie=T.length;Ee<Ie;Ee++){const se=T[Ee];if(se){if(se.type===0){Se=!0;continue}if(se.type===1)return D.INSTANCE;if(se.type===9){Ce=Ce.concat(se.expr);continue}Ce.push(se)}}if(Ce.length===0&&Se)return p.INSTANCE;Ce.sort(s)}if(Ce.length!==0){if(Ce.length===1)return Ce[0];for(let Ee=1;Ee<Ce.length;Ee++)Ce[Ee-1].equals(Ce[Ee])&&(Ce.splice(Ee,1),Ee--);if(Ce.length===1)return Ce[0];if(ye){for(let Ee=0;Ee<Ce.length;Ee++)for(let Ie=Ee+1;Ie<Ce.length;Ie++)if(Ce[Ee].negate().equals(Ce[Ie]))return D.INSTANCE;if(Ce.length===1)return Ce[0]}return new ke(Ce,_)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const _ of this.expr)T.push(..._.keys());return T}map(T){return new ke(this.expr.map(_=>_.map(T)),null)}negate(){if(!this.c){const T=[];for(const _ of this.expr)T.push(_.negate());for(;T.length>1;){const _=T.shift(),ye=T.shift(),Ce=[];for(const Se of de(_))for(const Ee of de(ye))Ce.push(be.create([Se,Ee],null,!1));T.unshift(ke.create(Ce,null,!1))}this.c=ke.create(T,this,!0)}return this.c}}e.$Li=ke;class Fe extends l{static{this.d=[]}static all(){return Fe.d.values()}constructor(T,_,ye){super(T,null),this.f=_,typeof ye=="object"?Fe.d.push({...ye,key:T}):ye!==!0&&Fe.d.push({key:T,description:ye,type:_!=null?typeof _:void 0})}bindTo(T){return T.createKey(this.key,this.f)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return g.create(this.key,T)}notEqualsTo(T){return f.create(this.key,T)}}e.$Mi=Fe,e.$Ni=(0,z.$nh)("contextKeyService");function G(ue,T){return ue<T?-1:ue>T?1:0}function Z(ue,T,_,ye){return ue<_?-1:ue>_?1:T<ye?-1:T>ye?1:0}function le(ue,T){if(ue.type===0||T.type===1)return!0;if(ue.type===9)return T.type===9?ne(ue.expr,T.expr):!1;if(T.type===9){for(const _ of T.expr)if(le(ue,_))return!0;return!1}if(ue.type===6){if(T.type===6)return ne(T.expr,ue.expr);for(const _ of ue.expr)if(le(_,T))return!0;return!1}return ue.equals(T)}e.$Oi=le;function ne(ue,T){let _=0,ye=0;for(;_<ue.length&&ye<T.length;){const Ce=ue[_].cmp(T[ye]);if(Ce<0)return!1;Ce===0&&_++,ye++}return _===ue.length}function de(ue){return ue.type===9?ue.expr:[ue]}}),define(Ae[171],Re([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vh=e.$uh=void 0,e.$uh=(0,w.$nh)("environmentService"),e.$vh=(0,w.$oh)(e.$uh)}),define(Ae[92],Re([1,0,140,3]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Nn=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Mn=e.$Ln=e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=void 0,e.$Bn="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Cn=new RegExp(e.$Bn),e.$Dn="__web_extension",e.$En="skipWalkthrough",e.$Fn="extensionsSync";function I(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$Gn=I;function z(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$Hn=z;function P(a,m){switch(a){case 3:return m==="x64"?"win32-x64":m==="ia32"?"win32-ia32":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$In=P;function d(a,m){return m==="web"&&!a.includes("web")}e.$Jn=d;function k(a,m,S){return d(m,S)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===S?!0:$(S).includes(a)}e.$Kn=k;function $(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.$Ln=$;function R(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.$Mn=R;var E;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(E||(e.SortBy=E={}));var c;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(c||(e.SortOrder=c={}));var y;(function(a){a.Install="install",a.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var b;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(b||(e.InstallOperation=b={})),e.$Nn=(0,L.$nh)("extensionGalleryService");var o;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Signature="Signature",a.Internal="Internal"})(o||(e.ExtensionManagementErrorCode=o={}));var t;(function(a){a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class i extends Error{constructor(m,S){super(m),this.code=S,this.name=S}}e.$On=i,e.$Pn=(0,L.$nh)("extensionManagementService"),e.$Qn="extensionsIdentifiers/disabled",e.$Rn="extensionsIdentifiers/enabled",e.$Sn=(0,L.$nh)("IGlobalExtensionEnablementService"),e.$Tn=(0,L.$nh)("IExtensionTipsService"),e.$Un=(0,w.localize)(0,null),e.$Vn={value:e.$Un,original:"Extensions"},e.$Wn={value:(0,w.localize)(1,null),original:"Preferences"}}),define(Ae[38],Re([1,0,48,19,15,12,2,142,3,22,13]),function($e,e,w,L,I,z,P,d,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.FileKind=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.FileOperationResult=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.FileChangeType=e.$8j=e.FileOperation=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.FileSystemProviderErrorCode=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.$Rj=e.$Qj=void 0,e.$Qj=(0,k.$nh)("fileService");function E(G){return G.create===!0}e.$Rj=E;var c;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(c||(e.FileType=c={}));var y;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(y||(e.FilePermission=y={}));var b;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function o(G){return!!(G.capabilities&2)}e.$Sj=o;function t(G){return!!(G.capabilities&8)}e.$Tj=t;function i(G){return!!(G.capabilities&131072)}e.$Uj=i;function a(G){return!!(G.capabilities&4)}e.$Vj=a;function m(G){return!!(G.capabilities&16)}e.$Wj=m;function S(G){return o(G)?!!(G.capabilities&16384):!1}e.$Xj=S;function C(G){return o(G)?!!(G.capabilities&32768):!1}e.$Yj=C;function r(G){return!!(G.capabilities&65536)}e.$Zj=r;function h(G){return!!(G.capabilities&2048)}e.$1j=h;var n;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class s extends Error{static create(Z,le){const ne=new s(Z.toString(),le);return l(ne,le),ne}constructor(Z,le){super(Z),this.code=le}}e.$2j=s;function p(G,Z){return s.create(G,Z)}e.$3j=p;function D(G){return G||p((0,d.localize)(0,null),n.Unknown)}e.$4j=D;function l(G,Z){return G.name=Z?`${Z} (FileSystemError)`:"FileSystemError",G}e.$5j=l;function g(G){if(!G)return n.Unknown;if(G instanceof s)return G.code;const Z=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!Z)return n.Unknown;switch(Z[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$6j=g;function v(G){if(G instanceof V)return G.fileOperationResult;switch(g(G)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$7j=v;var u;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(u||(e.FileOperation=u={}));class f{constructor(Z,le,ne){this.resource=Z,this.operation=le,this.target=ne}isOperation(Z){return this.operation===Z}}e.$8j=f;var A;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class W{constructor(Z,le){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ne=new Map;for(const de of Z){const ue=ne.get(de.type);switch(ue?ue.push([de.resource,de]):ne.set(de.type,[[de.resource,de]]),de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}}for(const[de,ue]of ne)switch(de){case 1:this.a=w.$th.forUris(()=>le),this.a.fill(ue);break;case 0:this.b=w.$th.forUris(()=>le),this.b.fill(ue);break;case 2:this.c=w.$th.forUris(()=>le),this.c.fill(ue);break}}contains(Z,...le){return this.d(Z,{includeChildren:!1},...le)}affects(Z,...le){return this.d(Z,{includeChildren:!0},...le)}d(Z,le,...ne){if(!Z)return!1;const de=ne.length>0;return!!((!de||ne.includes(1))&&(this.a?.get(Z)||le.includeChildren&&this.a?.findSuperstr(Z))||(!de||ne.includes(0))&&(this.b?.get(Z)||le.includeChildren&&this.b?.findSuperstr(Z))||(!de||ne.includes(2))&&(this.c?.findSubstr(Z)||le.includeChildren&&this.c?.findSuperstr(Z)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.$9j=W;function B(G,Z,le){return!G||!Z||G===Z||Z.length>G.length?!1:(Z.charAt(Z.length-1)!==L.sep&&(Z+=L.sep),le?(0,I.$Md)(G,Z):G.indexOf(Z)===0)}e.$0j=B;class V extends Error{constructor(Z,le,ne){super(Z),this.fileOperationResult=le,this.options=ne}}e.$$j=V;class U extends V{constructor(Z,le,ne,de){super(Z,le,de),this.fileOperationResult=le,this.size=ne}}e.$_j=U;class O extends V{constructor(Z,le,ne){super(Z,2,ne),this.stat=le}}e.$ak=O;var N;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(N||(e.FileOperationResult=N={})),e.$bk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ck={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$dk="files.associations",e.$ek="files.exclude",e.$fk="files.readonlyInclude",e.$gk="files.readonlyExclude",e.$hk="files.readonlyFromPermissions";var ae;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(ae||(e.FileKind=ae={})),e.$ik="";function Q(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}e.$jk=Q;async function be(G,Z){if(!Z.hasProvider(P.URI.from({scheme:G.scheme})))return new Promise(le=>{const ne=Z.onDidChangeFileSystemProviderRegistrations(de=>{de.scheme===G.scheme&&de.added&&(ne.dispose(),le())})})}e.$kk=be;class ke{static{this.KB=1024}static{this.MB=ke.KB*ke.KB}static{this.GB=ke.MB*ke.KB}static{this.TB=ke.GB*ke.KB}static formatSize(Z){return(0,z.$me)(Z)||(Z=0),Z<ke.KB?(0,d.localize)(1,null,Z.toFixed(0)):Z<ke.MB?(0,d.localize)(2,null,(Z/ke.KB).toFixed(2)):Z<ke.GB?(0,d.localize)(3,null,(Z/ke.MB).toFixed(2)):Z<ke.TB?(0,d.localize)(4,null,(Z/ke.GB).toFixed(2)):(0,d.localize)(5,null,(Z/ke.TB).toFixed(2))}}e.$lk=ke;function Fe(G){const Z=typeof G=="string"||G?.scheme===R.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===R.Schemas.file?1024*ke.MB:Z?10*ke.MB:$.$o?50*ke.MB:1024*ke.MB}e.$mk=Fe}),define(Ae[73],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lh=void 0;class w{constructor(...I){this.a=new Map;for(const[z,P]of I)this.set(z,P)}set(I,z){const P=this.a.get(I);return this.a.set(I,z),P}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$lh=w}),define(Ae[172],Re([1,0,16,11,6,71,170,3,73,173]),function($e,e,w,L,I,z,P,d,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=void 0;const R=!1;class E extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class c{constructor(t=new k.$lh,i=!1,a,m=R){this.f=t,this.g=i,this.h=a,this.i=m,this.o=new Set,this.f.set(d.$mh,this),this._globalGraph=m?a?._globalGraph??new P.$Rp(S=>S):void 0}createChild(t){return new c(t,this.g,this,this.i)}invokeFunction(t,...i){const a=b.traceInvocation(this.i,t);let m=!1;try{return t({get:C=>{if(m)throw(0,L.$6)("service accessor is only valid during the invocation of its target method");const r=this.m(C,a);if(!r)throw new Error(`[invokeFunction] unknown service '${C}'`);return r}},...i)}finally{m=!0,a.stop()}}createInstance(t,...i){let a,m;return t instanceof z.$kh?(a=b.traceCreation(this.i,t.ctor),m=this.j(t.ctor,t.staticArguments.concat(i),a)):(a=b.traceCreation(this.i,t),m=this.j(t,i,a)),a.stop(),m}j(t,i=[],a){const m=d._util.getServiceDependencies(t).sort((r,h)=>r.index-h.index),S=[];for(const r of m){const h=this.m(r.id,a);h||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${r.id}.`,!1),S.push(h)}const C=m.length>0?m[0].index:i.length;if(i.length!==C){console.trace(`[createInstance] First service dependency of ${t.name} at position ${C+1} conflicts with ${i.length} static arguments`);const r=C-i.length;r>0?i=i.concat(new Array(r)):i=i.slice(0,C)}return Reflect.construct(t,i.concat(S))}k(t,i){if(this.f.get(t)instanceof z.$kh)this.f.set(t,i);else if(this.h)this.h.k(t,i);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const i=this.f.get(t);return!i&&this.h?this.h.l(t):i}m(t,i){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const a=this.l(t);return a instanceof z.$kh?this.q(t,a,i.branch(t,!0)):(i.branch(t,!1),a)}q(t,i,a){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,i,a)}finally{this.o.delete(t)}}r(t,i,a){const m=new P.$Rp(r=>r.id.toString());let S=0;const C=[{id:t,desc:i,_trace:a}];for(;C.length;){const r=C.pop();if(m.lookupOrInsertNode(r),S++>1e3)throw new E(m);for(const h of d._util.getServiceDependencies(r.desc.ctor)){const n=this.l(h.id);if(n||this.u(`[createInstance] ${t} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(r.id),String(h.id)),n instanceof z.$kh){const s={id:h.id,desc:n,_trace:r._trace.branch(h.id,!0)};m.insertEdge(r,s),C.push(s)}}}for(;;){const r=m.roots();if(r.length===0){if(!m.isEmpty())throw new E(m);break}for(const{data:h}of r){if(this.l(h.id)instanceof z.$kh){const s=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,s)}m.removeNode(h)}}return this.l(t)}s(t,i,a=[],m,S){if(this.f.get(t)instanceof z.$kh)return this.t(t,i,a,m,S);if(this.h)return this.h.s(t,i,a,m,S);throw new Error(`illegalState - creating UNKNOWN service instance ${i.name}`)}t(t,i,a=[],m,S){if(m){const C=new c(void 0,this.g,this,this.i);C.c=String(t);const r=new Map,h=new w.$Jg(()=>{const n=C.j(i,a,S);for(const[s,p]of r){const D=n[s];if(typeof D=="function")for(const l of p)D.apply(n,l)}return r.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!h.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let l=r.get(s);return l||(l=new $.$lc,r.set(s,l)),(v,u,f)=>{const A=l.push([v,u,f]);return(0,I.$jb)(A)}}if(s in n)return n[s];const p=h.value;let D=p[s];return typeof D!="function"||(D=D.bind(p),n[s]=D),D},set(n,s,p){return h.value[s]=p,!0},getPrototypeOf(n){return i.prototype}})}else return this.j(i,a,S)}u(t,i){if(i&&console.warn(t),this.g)throw new Error(t)}}e.$Sp=c;var y;(function(o){o[o.None=0]="None",o[o.Creation=1]="Creation",o[o.Invocation=2]="Invocation",o[o.Branch=3]="Branch"})(y||(y={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(t,i){return t?new b(2,i.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(t,i){return t?new b(1,i.name):b.c}static{this.f=0}constructor(t,i){this.type=t,this.name=i,this.g=Date.now(),this.h=[]}branch(t,i){const a=new b(3,t.toString());return this.h.push([t,i,a]),a}stop(){const t=Date.now()-this.g;b.f+=t;let i=!1;function a(S,C){const r=[],h=new Array(S+1).join("	");for(const[n,s,p]of C.h)if(s&&p){i=!0,r.push(`${h}CREATES -> ${n}`);const D=a(S+1,p);D&&r.push(D)}else r.push(`${h}uses -> ${n}`);return r.join(`
`)}const m=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${a(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(t>2||i)&&b.all.add(m.join(`
`))}}e.$Tp=b}),define(Ae[14],Re([1,0,41,5,93,6,28,22,23,12,2,31,3]),function($e,e,w,L,I,z,P,d,k,$,R,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.log=e.$Si=e.LogLevel=e.$Ri=e.$Qi=e.$Pi=void 0,e.$Pi=(0,c.$nh)("logService"),e.$Qi=(0,c.$nh)("loggerService");function y(){return new Date().toISOString()}function b(v){return(0,$.$me)(v)}e.$Ri=b;var o;(function(v){v[v.Off=0]="Off",v[v.Trace=1]="Trace",v[v.Debug=2]="Debug",v[v.Info=3]="Info",v[v.Warning=4]="Warning",v[v.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$Si=o.Info;function t(v,u,f){switch(u){case o.Trace:v.trace(f);break;case o.Debug:v.debug(f);break;case o.Info:v.info(f);break;case o.Warning:v.warn(f);break;case o.Error:v.error(f);break;case o.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=t;function i(v,u=!1){let f="";for(let A=0;A<v.length;A++){let W=v[A];if(W instanceof Error&&(W=(0,w.$$h)(W,u)),typeof W=="object")try{W=JSON.stringify(W)}catch{}f+=(A>0?" ":"")+W}return f}class a extends z.$lb{constructor(){super(...arguments),this.b=e.$Si,this.c=this.B(new L.$7c),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==o.Off&&this.b<=u}}e.$Ui=a;class m extends a{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...f){this.f(o.Trace)&&this.g(o.Trace,i([u,...f],!0))}debug(u,...f){this.f(o.Debug)&&this.g(o.Debug,i([u,...f]))}info(u,...f){this.f(o.Info)&&this.g(o.Info,i([u,...f]))}warn(u,...f){this.f(o.Warning)&&this.g(o.Warning,i([u,...f]))}error(u,...f){if(this.f(o.Error))if(u instanceof Error){const A=Array.prototype.slice.call(arguments);A[0]=u.stack,this.g(o.Error,i(A))}else this.g(o.Error,i([u,...f]))}flush(){}}e.$Vi=m;class S extends a{constructor(u=e.$Si){super(),this.setLevel(u),this.g=!d.$i}trace(u,...f){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,u,...f):console.log(`[main ${y()}]`,u,...f))}debug(u,...f){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,u,...f):console.log(`[main ${y()}]`,u,...f))}info(u,...f){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${y()}]\x1B[0m`,u,...f):console.log(`[main ${y()}]`,u,...f))}warn(u,...f){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${y()}]\x1B[0m`,u,...f):console.warn(`[main ${y()}]`,u,...f))}error(u,...f){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${y()}]\x1B[0m`,u,...f):console.error(`[main ${y()}]`,u,...f))}dispose(){}flush(){}}e.$Wi=S;class C extends a{constructor(u=e.$Si,f=!0){super(),this.g=f,this.setLevel(u)}trace(u,...f){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...f):console.log(u,...f))}debug(u,...f){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...f):console.log(u,...f))}info(u,...f){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...f):console.log(u,...f))}warn(u,...f){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...f):console.log(u,...f))}error(u,...f){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...f):console.error(u,...f))}dispose(){}flush(){}}e.$Xi=C;class r extends a{constructor(u,f=e.$Si){super(),this.g=u,this.setLevel(f)}trace(u,...f){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(u),...f])}debug(u,...f){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(u),...f])}info(u,...f){this.f(o.Info)&&this.g.log(o.Info,[this.h(u),...f])}warn(u,...f){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(u),...f])}error(u,...f){this.f(o.Error)&&this.g.log(o.Error,[this.h(u),...f])}h(u){return typeof u=="string"?u:(0,w.$$h)(u,this.f(o.Trace))}dispose(){}flush(){}}e.$Yi=r;class h extends a{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const f of this.g)f.setLevel(u);super.setLevel(u)}trace(u,...f){for(const A of this.g)A.trace(u,...f)}debug(u,...f){for(const A of this.g)A.debug(u,...f)}info(u,...f){for(const A of this.g)A.info(u,...f)}warn(u,...f){for(const A of this.g)A.warn(u,...f)}error(u,...f){for(const A of this.g)A.error(u,...f)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose()}}e.$Zi=h;class n extends z.$lb{constructor(u,f,A){if(super(),this.h=u,this.j=f,this.b=new P.$li,this.c=this.B(new L.$7c),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$7c),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$7c),this.onDidChangeVisibility=this.g.event,A)for(const W of A)this.b.set(W.resource,{logger:void 0,info:W})}k(u){return(0,$.$ie)(u)?[...this.b.values()].find(f=>f.info.id===u):this.b.get(u)}getLogger(u){return this.k(u)?.logger}createLogger(u,f){const A=this.l(u),W=(0,$.$ie)(u)?u:f?.id??(0,I.$bi)(A.toString()).toString(16);let B=this.b.get(A)?.logger;const V=f?.logLevel==="always"?o.Trace:f?.logLevel;B||(B=this.m(A,V??this.getLogLevel(A)??this.h,{...f,id:W}));const U={logger:B,info:{resource:A,id:W,logLevel:V,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId,when:f?.when}};return this.registerLogger(U.info),this.b.set(A,U),B}l(u){return(0,$.$ie)(u)?(0,k.$8f)(this.j,`${u}.log`):u}setLogLevel(u,f){if(R.URI.isUri(u)){const A=u,W=f,B=this.b.get(A);B&&W!==B.info.logLevel&&(B.info.logLevel=W===this.h?void 0:W,B.logger?.setLevel(W),this.b.set(B.info.resource,B),this.f.fire([A,W]))}else{this.h=u;for(const[A,W]of this.b.entries())this.b.get(A)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,f){const A=this.k(u);A&&f!==!A.info.hidden&&(A.info.hidden=!f,this.b.set(A.info.resource,A),this.g.fire([A.info.resource,f]))}getLogLevel(u){let f;return u&&(f=this.b.get(u)?.info.logLevel),f??this.h}registerLogger(u){const f=this.b.get(u.resource);f?f.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const f=this.b.get(u);f&&(f.logger&&f.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[f.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$1i=n;class s{constructor(){this.onDidChangeLogLevel=new L.$7c().event}setLevel(u){}getLevel(){return o.Info}trace(u,...f){}debug(u,...f){}info(u,...f){}warn(u,...f){}error(u,...f){}critical(u,...f){}dispose(){}flush(){}}e.$2i=s;class p extends s{}e.$3i=p;function D(v){if(v.verbose)return o.Trace;if(typeof v.logLevel=="string"){const u=g(v.logLevel.toLowerCase());if(u!==void 0)return u}return e.$Si}e.$4i=D;function l(v){switch(v){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}e.$5i=l;function g(v){switch(v){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$6i=g,e.$7i=new E.$Mi("logLevel",l(o.Info))}),define(Ae[174],Re([1,0,6,14]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=void 0;class I extends w.$lb{constructor(P,d=[]){super(),this.a=new L.$Zi([P,...d]),this.B(P.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(P){this.a.setLevel(P)}getLevel(){return this.a.getLevel()}trace(P,...d){this.a.trace(P,...d)}debug(P,...d){this.a.debug(P,...d)}info(P,...d){this.a.info(P,...d)}warn(P,...d){this.a.warn(P,...d)}error(P,...d){this.a.error(P,...d)}flush(){this.a.flush()}}e.$WM=I}),define(Ae[94],Re([1,0,29,143,3]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var z;(function(k){k[k.Unnecessary=1]="Unnecessary",k[k.Deprecated=2]="Deprecated"})(z||(e.MarkerTag=z={}));var P;(function(k){k[k.Hint=1]="Hint",k[k.Info=2]="Info",k[k.Warning=4]="Warning",k[k.Error=8]="Error"})(P||(e.MarkerSeverity=P={})),function(k){function $(b,o){return o-b}k.compare=$;const R=Object.create(null);R[k.Error]=(0,L.localize)(0,null),R[k.Warning]=(0,L.localize)(1,null),R[k.Info]=(0,L.localize)(2,null);function E(b){return R[b]||""}k.toString=E;function c(b){switch(b){case w.default.Error:return k.Error;case w.default.Warning:return k.Warning;case w.default.Info:return k.Info;case w.default.Ignore:return k.Hint}}k.fromSeverity=c;function y(b){switch(b){case k.Error:return w.default.Error;case k.Warning:return w.default.Warning;case k.Info:return w.default.Info;case k.Hint:return w.default.Ignore}}k.toSeverity=y}(P||(e.MarkerSeverity=P={}));var d;(function(k){const $="";function R(c){return E(c,!0)}k.makeKey=R;function E(c,y){const b=[$];return c.source?b.push(c.source.replace("\xA6","\\\xA6")):b.push($),c.code?typeof c.code=="string"?b.push(c.code.replace("\xA6","\\\xA6")):b.push(c.code.value.replace("\xA6","\\\xA6")):b.push($),c.severity!==void 0&&c.severity!==null?b.push(P.toString(c.severity)):b.push($),c.message&&y?b.push(c.message.replace("\xA6","\\\xA6")):b.push($),c.startLineNumber!==void 0&&c.startLineNumber!==null?b.push(c.startLineNumber.toString()):b.push($),c.startColumn!==void 0&&c.startColumn!==null?b.push(c.startColumn.toString()):b.push($),c.endLineNumber!==void 0&&c.endLineNumber!==null?b.push(c.endLineNumber.toString()):b.push($),c.endColumn!==void 0&&c.endColumn!==null?b.push(c.endColumn.toString()):b.push($),b.push($),b.join("\xA6")}k.makeKeyOptionalMessage=E})(d||(e.IMarkerData=d={})),e.$js=(0,I.$nh)("markerService")}),define(Ae[175],Re([1,0,5,29,3]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iu=e.$Hu=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$Gu=e.Severity=void 0,e.Severity=L.default,e.$Gu=(0,I.$nh)("notificationService");var z;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(z||(e.NotificationPriority=z={}));var P;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(P||(e.NeverShowAgainScope=P={}));var d;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(d||(e.NotificationsFilter=d={}));class k{constructor(){this.progress=new $,this.onDidClose=w.Event.None,this.onDidChangeVisibility=w.Event.None}updateSeverity(E){}updateMessage(E){}updateActions(E){}close(){}}e.$Hu=k;class ${infinite(){}done(){}total(E){}worked(E){}}e.$Iu=$}),define(Ae[95],Re([1,0,15,2,3]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Y=e.$8Y=e.$7Y=e.$6Y=e.$5Y=void 0,e.$5Y=(0,I.$nh)("openerService");function z($,R){return L.URI.isUri($)?(0,w.$Ld)($.scheme,R):(0,w.$Md)($,R+":")}e.$6Y=z;function P($,...R){return R.some(E=>z($,E))}e.$7Y=P;function d($,R){return $.with({fragment:`${R.startLineNumber},${R.startColumn}${R.endLineNumber?`-${R.endLineNumber}${R.endColumn?`,${R.endColumn}`:""}`:""}`})}e.$8Y=d;function k($){let R;const E=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec($.fragment);return E&&(R={startLineNumber:parseInt(E[1]),startColumn:E[2]?parseInt(E[2]):1,endLineNumber:E[4]?parseInt(E[4]):void 0,endColumn:E[4]?E[5]?parseInt(E[5]):1:void 0},$=$.with({fragment:""})),{selection:R,uri:$}}e.$9Y=k}),define(Ae[176],Re([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9i=e.$8i=void 0,e.$8i=(0,w.$nh)("productService"),e.$9i="vscode://schemas/vscode-product"});var qe=this&&this.__decorate||function($e,e,w,L){var I=arguments.length,z=I<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,w):L,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")z=Reflect.decorate($e,e,w,L);else for(var d=$e.length-1;d>=0;d--)(P=$e[d])&&(z=(I<3?P(z):I>3?P(e,w,z):P(e,w))||z);return I>3&&z&&Object.defineProperty(e,w,z),z},Ve=this&&this.__param||function($e,e){return function(w,L){e(w,L,$e)}};define(Ae[177],Re([1,0,16,20,6,3]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ou=e.$Nu=e.$Mu=e.$Lu=e.$Ku=e.ProgressLocation=e.$Ju=void 0,e.$Ju=(0,z.$nh)("progressService");var P;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(P||(e.ProgressLocation=P={})),e.$Ku=Object.freeze({total(){},worked(){},done(){}});class d{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(E,c){this.c=E,this.report=c?.async?this.e.bind(this):this.d.bind(this)}d(E){this.a=E,this.c(this.a)}e(E){Promise.resolve(this.b).finally(()=>{this.a=E;const c=this.c(this.a);this.b=Promise.resolve(c).finally(()=>this.b=void 0)})}}e.$Lu=d;let k=class extends I.$lb{constructor(E,c){super(),this.a=new w.$Ng,c.withProgress(E,y=>(this.b=y,this.c&&y.report(this.c),this.a.p)),this.B((0,I.$jb)(()=>this.a.complete()))}report(E){this.b?this.b.report(E):this.c=E}};e.$Mu=k,e.$Mu=k=qe([Ve(1,e.$Ju)],k);class $ extends I.$lb{constructor(E){super(),this.g=E,this.a=0,this.b=this.B(new I.$kb)}start(E){this.stop();const c=++this.a,y=new L.$dd;return this.f=setTimeout(()=>{c===this.a&&(this.c=this.g.show(!0))},E),this.b.add((0,I.$jb)(()=>clearTimeout(this.f))),this.b.add((0,I.$jb)(()=>y.cancel())),this.b.add((0,I.$jb)(()=>this.c?this.c.done():void 0)),{id:c,token:y.token,stop:()=>this.h(c),isCurrent:()=>this.a===c}}stop(){this.h(this.a)}h(E){this.a===E&&this.b.clear()}}e.$Nu=$,e.$Ou=(0,z.$nh)("editorProgressService")}),define(Ae[30],Re([1,0,50,12]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rm=void 0;class I{constructor(){this.a=new Map}add(P,d){w.ok(L.$ie(P)),w.ok(L.$ke(d)),w.ok(!this.a.has(P),"There is already an extension with this id"),this.a.set(P,d)}knows(P){return this.a.has(P)}as(P){return this.a.get(P)||null}}e.$Rm=new I}),define(Ae[74],Re([1,0,5,30]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sm=void 0,e.$Sm={JSONContribution:"base.contributions.json"};function I(d){return d.length>0&&d.charAt(d.length-1)==="#"?d.substring(0,d.length-1):d}class z{constructor(){this.b=new w.$7c,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,$){this.a[I(k)]=$,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const P=new z;L.$Rm.add(e.$Sm.JSONContribution,P)}),define(Ae[96],Re([1,0,18,5,12,137,43,74,30]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=e.$3m=e.$2m=e.$1m=e.$Zm=e.$Ym=e.$Xm=e.ConfigurationScope=e.$Wm=e.EditPresentationTypes=void 0;var $;(function(C){C.Multiline="multilineText",C.Singleline="singlelineText"})($||(e.EditPresentationTypes=$={})),e.$Wm={Configuration:"base.contributions.configuration"};var R;(function(C){C[C.APPLICATION=1]="APPLICATION",C[C.MACHINE=2]="MACHINE",C[C.WINDOW=3]="WINDOW",C[C.RESOURCE=4]="RESOURCE",C[C.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",C[C.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$Xm={properties:{},patternProperties:{}},e.$Ym={properties:{},patternProperties:{}},e.$Zm={properties:{},patternProperties:{}},e.$1m={properties:{},patternProperties:{}},e.$2m={properties:{},patternProperties:{}},e.$3m={properties:{},patternProperties:{}},e.$4m="vscode://schemas/settings/resourceLanguage",e.$5m="vscode://schemas/settings/configurationDefaults";const E=k.$Rm.as(d.$Sm.JSONContribution);class c{constructor(){this.h=new Set,this.i=new L.$7c,this.onDidSchemaChange=this.i.event,this.j=new L.$7c,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:z.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$4m,this.g),this.v()}registerConfiguration(r,h=!0){this.registerConfigurations([r],h)}registerConfigurations(r,h=!0){const n=new Set;this.n(r,h,n),E.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(r){const h=new Set;this.o(r,h),E.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:r,remove:h}){const n=new Set;this.o(h,n),this.n(r,!1,n),E.registerSchema(e.$4m,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(r){const h=new Set;this.k(r,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(r,h){const n=[];for(const{overrides:s,source:p}of r)for(const D in s)if(h.add(D),e.$7m.test(D)){const l=this.a.get(D),g=l?.valuesSources??new Map;if(p)for(const A of Object.keys(s[D]))g.set(A,p);const v={...l?.value||{},...s[D]};this.a.set(D,{source:p,value:v,valuesSources:g});const u=(0,P.$4h)(D),f={type:"object",default:v,description:z.localize(1,null,u),$ref:e.$4m,defaultDefaultValue:v,source:I.$ie(p)?void 0:p,defaultValueSource:p};n.push(...o(D)),this.d[D]=f,this.b.properties[D]=f}else{this.a.set(D,{value:s[D],source:p});const l=this.d[D];l&&(this.w(D,l),this.r(D,l))}this.m(n)}deregisterDefaultConfigurations(r){const h=new Set;this.l(r,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(r,h){for(const{overrides:n,source:s}of r)for(const p in n){const D=this.a.get(p),l=I.$ie(s)?s:s?.id,g=I.$ie(D?.source)?D?.source:D?.source?.id;if(l===g)if(h.add(p),this.a.delete(p),e.$7m.test(p))delete this.d[p],delete this.b.properties[p];else{const v=this.d[p];v&&(this.w(p,v),this.r(p,v))}}this.u()}deltaConfiguration(r){let h=!1;const n=new Set;r.removedDefaults&&(this.l(r.removedDefaults,n),h=!0),r.addedDefaults&&(this.k(r.addedDefaults,n),h=!0),r.removedConfigurations&&this.o(r.removedConfigurations,n),r.addedConfigurations&&this.n(r.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...r){this.i.fire()}registerOverrideIdentifiers(r){this.m(r),this.i.fire()}m(r){for(const h of r)this.h.add(h);this.u()}n(r,h,n){r.forEach(s=>{this.p(s,h,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(r,h){const n=s=>{if(s.properties)for(const p in s.properties){h.add(p);const D=this.d[p];D?.policy?.name&&this.e.delete(D.policy.name),delete this.d[p],this.s(p,s.properties[p])}s.allOf?.forEach(p=>n(p))};for(const s of r){n(s);const p=this.c.indexOf(s);p!==-1&&this.c.splice(p,1)}}p(r,h=!0,n,s,p=3,D){p=I.$re(r.scope)?p:r.scope;const l=r.properties;if(l)for(const v in l){const u=l[v];if(h&&m(v,u)){delete l[v];continue}if(u.source=n,u.defaultDefaultValue=l[v].default,this.w(v,u),e.$7m.test(v)?u.scope=void 0:(u.scope=I.$re(u.scope)?p:u.scope,u.restricted=I.$re(u.restricted)?!!s?.includes(v):u.restricted),l[v].hasOwnProperty("included")&&!l[v].included){this.f[v]=l[v],delete l[v];continue}else this.d[v]=l[v],l[v].policy?.name&&this.e.set(l[v].policy.name,v);!l[v].deprecationMessage&&l[v].markdownDeprecationMessage&&(l[v].deprecationMessage=l[v].markdownDeprecationMessage),D.add(v)}const g=r.allOf;if(g)for(const v of g)this.p(v,h,n,s,p,D)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(r){const h=n=>{const s=n.properties;if(s)for(const D in s)this.r(D,s[D]);n.allOf?.forEach(h)};h(r)}r(r,h){switch(e.$Xm.properties[r]=h,h.scope){case 1:e.$Ym.properties[r]=h;break;case 2:e.$Zm.properties[r]=h;break;case 6:e.$1m.properties[r]=h;break;case 3:e.$2m.properties[r]=h;break;case 4:e.$3m.properties[r]=h;break;case 5:e.$3m.properties[r]=h,this.g.properties[r]=h;break}}s(r,h){switch(delete e.$Xm.properties[r],h.scope){case 1:delete e.$Ym.properties[r];break;case 2:delete e.$Zm.properties[r];break;case 6:delete e.$1m.properties[r];break;case 3:delete e.$2m.properties[r];break;case 4:case 5:delete e.$3m.properties[r],delete this.g.properties[r];break}}u(){for(const r of this.h.values()){const h=`[${r}]`,n={type:"object",description:z.localize(2,null),errorMessage:z.localize(3,null),$ref:e.$4m};this.w(h,n),e.$Xm.properties[h]=n,e.$Ym.properties[h]=n,e.$Zm.properties[h]=n,e.$1m.properties[h]=n,e.$2m.properties[h]=n,e.$3m.properties[h]=n}}v(){const r={type:"object",description:z.localize(4,null),errorMessage:z.localize(5,null),$ref:e.$4m};e.$Xm.patternProperties[e.$6m]=r,e.$Ym.patternProperties[e.$6m]=r,e.$Zm.patternProperties[e.$6m]=r,e.$1m.patternProperties[e.$6m]=r,e.$2m.patternProperties[e.$6m]=r,e.$3m.patternProperties[e.$6m]=r,this.i.fire()}w(r,h){const n=this.a.get(r);let s=n?.value,p=n?.source;I.$pe(s)&&(s=h.defaultDefaultValue,p=void 0),I.$pe(s)&&(s=i(h.type)),h.default=s,h.defaultValueSource=p}}const y="\\[([^\\]]+)\\]",b=new RegExp(y,"g");e.$6m=`^(${y})+$`,e.$7m=new RegExp(e.$6m);function o(C){const r=[];if(e.$7m.test(C)){let h=b.exec(C);for(;h?.length;){const n=h[1].trim();n&&r.push(n),h=b.exec(C)}}return(0,w.$qf)(r)}e.$8m=o;function t(C){return C.reduce((r,h)=>`${r}[${h}]`,"")}e.$9m=t;function i(C){switch(Array.isArray(C)?C[0]:C){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$0m=i;const a=new c;k.$Rm.add(e.$Wm.Configuration,a);function m(C,r){return C.trim()?e.$7m.test(C)?z.localize(7,null,C):a.getConfigurationProperties()[C]!==void 0?z.localize(8,null,C):r.policy?.name&&a.getPolicyConfigurations().get(r.policy?.name)!==void 0?z.localize(9,null,C,r.policy?.name,a.getPolicyConfigurations().get(r.policy?.name)):null:z.localize(6,null)}e.$$m=m;function S(){const C=[],r=a.getConfigurationProperties();for(const h of Object.keys(r))C.push([h,r[h].scope]);return C.push(["launch",4]),C.push(["task",4]),C}e.$_m=S}),define(Ae[178],Re([1,0,18,5,115,6,28,24,12,2,43,96,30]),function($e,e,w,L,I,z,P,d,k,$,R,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=void 0;function y(h){return Object.isFrozen(h)?h:d.$Gm(h)}class b{constructor(n={},s=[],p=[],D){this.b=n,this.c=s,this.d=p,this.raw=D,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof b)return s;const p=new o("");return p.parseRaw(s),p.configurationModel});this.f=n.reduce((s,p)=>p===s?p:s.merge(p),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,R.$2h)(this.contents,n):this.contents}inspect(n,s){const p=this.rawConfiguration.getValue(n),D=s?this.rawConfiguration.getOverrideValue(n,s):void 0,l=s?this.rawConfiguration.override(s).getValue(n):p;return{value:p,override:D,merged:l}}getOverrideValue(n,s){const p=this.i(s);return p?n?(0,R.$2h)(p,n):p:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const p of this.overrides)p.identifiers.includes(n)&&s.push(...p.keys);return w.$qf(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return w.$qf(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=d.$Fm(this.contents),p=d.$Fm(this.overrides),D=[...this.keys],l=this.raw?.length?[...this.raw]:[this];for(const g of n)if(l.push(...g.raw?.length?g.raw:[g]),!g.isEmpty()){this.h(s,g.contents);for(const v of g.overrides){const[u]=p.filter(f=>w.$af(f.identifiers,v.identifiers));u?(this.h(u.contents,v.contents),u.keys.push(...v.keys),u.keys=w.$qf(u.keys)):p.push(d.$Fm(v))}for(const v of g.keys)D.indexOf(v)===-1&&D.push(v)}return new b(s,D,p,l.every(g=>g instanceof b)?void 0:l)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const p={};for(const D of w.$qf([...Object.keys(this.contents),...Object.keys(s)])){let l=this.contents[D];const g=s[D];g&&(typeof l=="object"&&typeof g=="object"?(l=d.$Fm(l),this.h(l,g)):l=g),p[D]=l}return new b(p,this.keys,this.overrides)}h(n,s){for(const p of Object.keys(s)){if(p in n&&k.$ke(n[p])&&k.$ke(s[p])){this.h(n[p],s[p]);continue}n[p]=d.$Fm(s[p])}}i(n){let s=null,p=null;const D=l=>{l&&(p?this.h(p,l):p=d.$Fm(l))};for(const l of this.overrides)l.identifiers.length===1&&l.identifiers[0]===n?s=l.contents:l.identifiers.includes(n)&&D(l.contents);return D(s),p}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,R.$1h)(this.contents,n),E.$7m.test(n)&&this.overrides.splice(this.overrides.findIndex(p=>w.$af(p.identifiers,(0,E.$8m)(n))),1))}j(n,s,p){(0,R.$Zh)(this.contents,n,s,D=>console.error(D)),p=p||this.keys.indexOf(n)===-1,p&&this.keys.push(n),E.$7m.test(n)&&this.overrides.push({identifiers:(0,E.$8m)(n),keys:Object.keys(this.contents[n]),contents:(0,R.$Yh)(this.contents[n],D=>console.error(D))})}}e.$an=b;class o{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!k.$re(n)){const p=this.g(n);this.parseRaw(p,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:p,keys:D,overrides:l,restricted:g,hasExcludedProperties:v}=this.h(n,s);this.b=new b(p,D,l,v?[n]:void 0),this.c=g||[]}g(n){let s={},p=null,D=[];const l=[],g=[];function v(f){Array.isArray(D)?D.push(f):p!==null&&(D[p]=f)}const u={onObjectBegin:()=>{const f={};v(f),l.push(D),D=f,p=null},onObjectProperty:f=>{p=f},onObjectEnd:()=>{D=l.pop()},onArrayBegin:()=>{const f=[];v(f),l.push(D),D=f,p=null},onArrayEnd:()=>{D=l.pop()},onLiteralValue:v,onError:(f,A,W)=>{g.push({error:f,offset:A,length:W})}};if(n)try{I.$Cm(n,u),s=D[0]||{}}catch(f){console.error(`Error while parsing settings file ${this.f}: ${f}`),this.d=[f]}return s}h(n,s){const p=c.$Rm.as(E.$Wm.Configuration).getConfigurationProperties(),D=this.i(n,p,!0,s);n=D.raw;const l=(0,R.$Yh)(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),g=Object.keys(n),v=this.j(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:l,keys:g,overrides:v,restricted:D.restricted,hasExcludedProperties:D.hasExcludedProperties}}i(n,s,p,D){let l=!1;if(!D?.scopes&&!D?.skipRestricted&&!D?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:l};const g={},v=[];for(const u in n)if(E.$7m.test(u)&&p){const f=this.i(n[u],s,!1,D);g[u]=f.raw,l=l||f.hasExcludedProperties,v.push(...f.restricted)}else{const f=s[u],A=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&v.push(u),!D.exclude?.includes(u)&&(D.include?.includes(u)||(A===void 0||D.scopes===void 0||D.scopes.includes(A))&&!(D.skipRestricted&&f?.restricted))?g[u]=n[u]:l=!0}return{raw:g,restricted:v,hasExcludedProperties:l}}j(n,s){const p=[];for(const D of Object.keys(n))if(E.$7m.test(D)){const l={};for(const g in n[D])l[g]=n[D][g];p.push({identifiers:(0,E.$8m)(D),keys:Object.keys(l),contents:(0,R.$Yh)(l,s)})}return p}}e.$bn=o;class t extends z.$lb{constructor(n,s,p,D){super(),this.c=n,this.f=s,this.g=D,this.b=this.B(new L.$7c),this.onDidChange=this.b.event,this.a=new o(this.c.toString()),this.B(this.g.watch(p.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,l=>l.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&p.isEqual(l.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$cn=t;class i{constructor(n,s,p,D,l,g,v,u,f,A,W,B,V){this.a=n,this.b=s,this.c=p,this.overrideIdentifiers=D,this.d=l,this.f=g,this.g=v,this.h=u,this.i=f,this.j=A,this.k=W,this.l=B,this.m=V}get value(){return y(this.c)}n(n,s,p){const D=n.inspect(s,p);return{get value(){return y(D.value)},get override(){return y(D.override)},get merged(){return y(D.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class a{constructor(n,s,p,D,l=new b,g=new b,v=new P.$li,u=new b,f=new P.$li){this.c=n,this.d=s,this.f=p,this.g=D,this.h=l,this.i=g,this.j=v,this.l=u,this.m=f,this.a=null,this.b=new P.$li,this.n=null}getValue(n,s,p){return this.q(n,s,p).getValue(n)}updateValue(n,s,p={}){let D;p.resource?(D=this.m.get(p.resource),D||(D=new b,this.m.set(p.resource,D))):D=this.l,s===void 0?D.removeValue(n):D.setValue(n,s),p.resource||(this.a=null)}inspect(n,s,p){const D=this.q(n,s,p),l=this.u(s.resource,p),g=s.resource?this.m.get(s.resource)||this.l:this.l,v=new Set;for(const u of D.overrides)for(const f of u.identifiers)D.getOverrideValue(n,f)!==void 0&&v.add(f);return new i(n,s,D.getValue(n),v.size?[...v]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,p?this.i:void 0,l||void 0,g)}keys(n){const s=this.u(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.p.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const p=[];if(!s){const{added:D,updated:l,removed:g}=C(this.c,n);s=[...D,...l,...g]}for(const D of s)for(const l of(0,E.$8m)(D)){const g=this.c.getKeysForOverrideIdentifier(l),v=n.getKeysForOverrideIdentifier(l),u=[...v.filter(f=>g.indexOf(f)===-1),...g.filter(f=>v.indexOf(f)===-1),...g.filter(f=>!d.$Jm(this.c.override(l).getValue(f),n.override(l).getValue(f)))];p.push([l,u])}return this.updateDefaultConfiguration(n),{keys:s,overrides:p}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:p,removed:D}=C(this.d,n),l=[...s,...p,...D];return l.length&&this.updatePolicyConfiguration(n),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:p,removed:D,overrides:l}=C(this.applicationConfiguration,n),g=[...s,...p,...D];return g.length&&this.updateApplicationConfiguration(n),{keys:g,overrides:l}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:p,removed:D,overrides:l}=C(this.localUserConfiguration,n),g=[...s,...p,...D];return g.length&&this.updateLocalUserConfiguration(n),{keys:g,overrides:l}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:p,removed:D,overrides:l}=C(this.remoteUserConfiguration,n),g=[...s,...p,...D];return g.length&&this.updateRemoteUserConfiguration(n),{keys:g,overrides:l}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:p,removed:D,overrides:l}=C(this.workspaceConfiguration,n),g=[...s,...p,...D];return g.length&&this.updateWorkspaceConfiguration(n),{keys:g,overrides:l}}compareAndUpdateFolderConfiguration(n,s){const p=this.p.get(n),{added:D,updated:l,removed:g,overrides:v}=C(p,s),u=[...D,...l,...g];return(u.length||!p)&&this.updateFolderConfiguration(n,s),{keys:u,overrides:v}}compareAndDeleteFolderConfiguration(n){const s=this.p.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:p,updated:D,removed:l,overrides:g}=C(s,void 0);return{keys:[...p,...D,...l],overrides:g}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(n,s,p){let D=this.r(s,p);return s.overrideIdentifier&&(D=D.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(D=D.merge(this.d)),D}r({resource:n},s){let p=this.s();if(s&&n){const D=s.getFolder(n);D&&(p=this.t(D.uri)||p);const l=this.m.get(n);l&&(p=p.merge(l))}return p}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(n){let s=this.b.get(n);if(!s){const p=this.s(),D=this.j.get(n);D?(s=p.merge(D),this.b.set(n,s)):s=p}return s}u(n,s){if(s&&n){const p=s.getFolder(n);if(p)return this.j.get(p.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:p,overrides:D,keys:l}=this.j.get(s);return n.push([s,{contents:p,overrides:D,keys:l}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(p=>n.add(p))),[...n.values()]}v(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(p=>n.add(p))),[...n.values()]}w(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(p=>s.add(p)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(p=>s.add(p)),this.i.getKeysForOverrideIdentifier(n).forEach(p=>s.add(p)),this.j.forEach(p=>p.getKeysForOverrideIdentifier(n).forEach(D=>s.add(D))),[...s.values()]}static parse(n){const s=this.x(n.defaults),p=this.x(n.policy),D=this.x(n.application),l=this.x(n.user),g=this.x(n.workspace),v=n.folders.reduce((u,f)=>(u.set($.URI.revive(f[0]),this.x(f[1])),u),new P.$li);return new a(s,p,D,l,new b,g,v,new b,new P.$li)}static x(n){return new b(n.contents,n.keys,n.overrides)}}e.$dn=a;function m(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const n=new Set,s=new Map;for(const D of h)D.keys.forEach(l=>n.add(l)),D.overrides.forEach(([l,g])=>{const v=(0,P.$ii)(s,l,new Set);g.forEach(u=>v.add(u))});const p=[];return s.forEach((D,l)=>p.push([l,[...D.values()]])),{keys:[...n.values()],overrides:p}}e.$en=m;class S{constructor(n,s,p,D){this.change=n,this.f=s,this.g=p,this.h=D,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const l of n.keys)this.affectedKeys.add(l);for(const[,l]of n.overrides)for(const g of l)this.affectedKeys.add(g);this.d=this.a;for(const l of this.affectedKeys)this.d+=l+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=a.parse(this.f.data)),this.i}affectsConfiguration(n,s){const p=this.a+n,D=this.d.indexOf(p);if(D<0)return!1;const l=D+p.length;if(l>=this.d.length)return!1;const g=this.d.charCodeAt(l);if(g!==this.b&&g!==this.c)return!1;if(s){const v=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,u=this.g.getValue(n,s,this.h);return!d.$Jm(v,u)}return!0}}e.$fn=S;function C(h,n){const{added:s,removed:p,updated:D}=r(n?.rawConfiguration,h?.rawConfiguration),l=[],g=h?.getAllOverrideIdentifiers()||[],v=n?.getAllOverrideIdentifiers()||[];if(n){const u=v.filter(f=>!g.includes(f));for(const f of u)l.push([f,n.getKeysForOverrideIdentifier(f)])}if(h){const u=g.filter(f=>!v.includes(f));for(const f of u)l.push([f,h.getKeysForOverrideIdentifier(f)])}if(n&&h){for(const u of g)if(v.includes(u)){const f=r({contents:h.getOverrideValue(void 0,u)||{},keys:h.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});l.push([u,[...f.added,...f.removed,...f.updated]])}}return{added:s,removed:p,updated:D,overrides:l}}function r(h,n){const s=h?n?h.keys.filter(l=>n.keys.indexOf(l)===-1):[...h.keys]:[],p=n?h?n.keys.filter(l=>h.keys.indexOf(l)===-1):[...n.keys]:[],D=[];if(h&&n){for(const l of n.keys)if(h.keys.indexOf(l)!==-1){const g=(0,R.$2h)(n.contents,l),v=(0,R.$2h)(h.contents,l);d.$Jm(g,v)||D.push(l)}}return{added:s,removed:p,updated:D}}}),define(Ae[97],Re([1,0,11,3]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yk=e.$xk=e.RemoteAuthorityResolverErrorCode=e.$wk=e.$vk=e.RemoteConnectionType=e.$uk=void 0,e.$uk=(0,L.$nh)("remoteAuthorityResolverService");var I;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class z{constructor(E){this.id=E,this.type=1}toString(){return`Managed(${this.id})`}}e.$vk=z;class P{constructor(E,c){this.host=E,this.port=c,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$wk=P;var d;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(d||(e.RemoteAuthorityResolverErrorCode=d={}));class k extends w.$ab{static isNotAvailable(E){return E instanceof k&&E._code===d.NotAvailable}static isTemporarilyNotAvailable(E){return E instanceof k&&E._code===d.TemporarilyNotAvailable}static isNoResolverFound(E){return E instanceof k&&E._code===d.NoResolverFound}static isInvalidAuthority(E){return E instanceof k&&E._code===d.InvalidAuthority}static isHandled(E){return E instanceof k&&E.isHandled}constructor(E,c=d.Unknown,y){super(E),this._message=E,this._code=c,this._detail=y,this.isHandled=c===d.NotAvailable&&y===!0,Object.setPrototypeOf(this,k.prototype)}}e.$xk=k;function $(R){const E=R.indexOf("+");return E===-1?R:R.substring(0,E)}e.$yk=$}),define(Ae[51],Re([1,0,13]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=void 0;function L($){return $.scheme===w.Schemas.vscodeRemote?$.authority:void 0}e.$zk=L;function I($){if(!$)return;const R=$.indexOf("+");return R<0?$:$.substr(0,R)}e.$Ak=I;function z($){return`/${$.quality??"oss"}-${$.commit??"dev"}`}e.$Bk=z;function P($){const{host:R,port:E}=k($);if(typeof E>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:E}}e.$Ck=P;function d($,R){let{host:E,port:c}=k($);return typeof c>"u"&&(c=R),{host:E,port:c}}e.$Dk=d;function k($){const R=$.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const E=$.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const c=$.match(/(.*):(\d+)$/);return c?{host:c[1],port:parseInt(c[2],10)}:{host:$,port:void 0}}}),define(Ae[21],Re([1,0,15,3,51]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=e.$Kl=e.$Jl=e.$Il=e.$Hl=e.$Gl=e.$Fl=e.TargetPlatform=e.ExtensionType=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=void 0,e.$zl="extensions.user.cache",e.$Al="extensions.builtin.cache",e.$Bl="undefined_publisher",e.$Cl=["ui","workspace","web"];function z(o){if(typeof o=="object"&&o!==null&&o.supported!==!0)return o.description}e.$Dl=z,e.$El=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var P;(function(o){o[o.System=0]="System",o[o.User=1]="User"})(P||(e.ExtensionType=P={}));var d;(function(o){o.WIN32_X64="win32-x64",o.WIN32_IA32="win32-ia32",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(d||(e.TargetPlatform=d={}));class k{constructor(t){this.value=t,this._lower=t.toLowerCase()}static equals(t,i){if(typeof t>"u"||t===null)return typeof i>"u"||i===null;if(typeof i>"u"||i===null)return!1;if(typeof t=="string"||typeof i=="string"){const a=typeof t=="string"?t:t.value,m=typeof i=="string"?i:i.value;return w.$Ld(a,m)}return t._lower===i._lower}static toKey(t){return typeof t=="string"?t.toLowerCase():t._lower}}e.$Fl=k;class ${get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const i of t)this.add(i)}add(t){this.c.add(k.toKey(t))}delete(t){return this.c.delete(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}}e.$Gl=$;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(k.toKey(t))}get(t){return this.c.get(k.toKey(t))}has(t){return this.c.has(k.toKey(t))}set(t,i){this.c.set(k.toKey(t),i)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Hl=R;function E(o){return c(o)}e.$Il=E;function c(o){return o.contributes&&o.contributes.localizations?o.contributes.localizations.length>0:!1}e.$Jl=c;function y(o){return o.contributes&&o.contributes.authentication?o.contributes.authentication.length>0:!1}e.$Kl=y;function b(o,t){if(t){const i=`onResolveRemoteAuthority:${(0,I.$Ak)(t)}`;return!!o.activationEvents?.includes(i)}return!1}e.$Ll=b,e.$Ml=(0,L.$nh)("IBuiltinExtensionsScannerService")}),define(Ae[98],Re([1,0,11,21]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hF=e.$gF=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(P,d){this.a.set(P,d)}readActivationEvents(P){return this.b.has(P)||this.b.set(P,this.c(P)),this.b.get(P)}createActivationEventsMap(P){const d=Object.create(null);for(const k of P){const $=this.readActivationEvents(k);$.length>0&&(d[L.$Fl.toKey(k.identifier)]=$)}return d}c(P){if(typeof P.main>"u"&&typeof P.browser>"u")return[];const d=Array.isArray(P.activationEvents)?P.activationEvents.slice(0):[];if(!P.contributes)return d;for(const k in P.contributes){const $=this.a.get(k);if(!$)continue;const R=P.contributes[k],E=Array.isArray(R)?R:[R];try{$(E,d)}catch(c){(0,w.$Y)(c)}}return d}}e.$gF=I,e.$hF=new I}),define(Ae[179],Re([1,0,22,52,36]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yn=e.$Xn=void 0;function z(k){if(w.$t===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function P(k,$,R,E,c,y,b,o){const t=Object.create(null);t["common.machineId"]=y,t.sessionID=(0,I.$5e)()+Date.now(),t.commitHash=E,t.version=c,t["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,w.$h)(w.$t),t["common.nodePlatform"]=L.$7b,t["common.nodeArch"]=R,t["common.product"]=o||"desktop",b&&(t["common.msftInternal"]=b);let i=0;const a=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-a,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),w.$l&&(t["common.snap"]="true");const m=z($);return m&&(t["common.platformDetail"]=m),t}e.$Xn=P;function d(k){const $=L.env.USERDNSDOMAIN;if(!$)return!1;const R=$.toLowerCase();return k.some(E=>R===E)}e.$Yn=d}),define(Ae[180],Re([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$3k=e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=void 0,e.$Tk=(0,w.$nh)("telemetryService"),e.$Uk=(0,w.$nh)("customEndpointTelemetryService"),e.$Vk="telemetry.currentSessionDate",e.$Wk="telemetry.firstSessionDate",e.$Xk="telemetry.lastSessionDate",e.$Yk="telemetry.machineId",e.$Zk="telemetry",e.$1k="telemetry.telemetryLevel",e.$2k="telemetry.enableCrashReporter",e.$3k="telemetry.enableTelemetry";var L;(function(z){z[z.NONE=0]="NONE",z[z.CRASH=1]="CRASH",z[z.ERROR=2]="ERROR",z[z.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var I;(function(z){z.OFF="off",z.CRASH="crash",z.ERROR="error",z.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Ae[53],Re([1,0,24,12,5,43,51,179,180]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=void 0;class ${constructor(p){this.value=p,this.isTrustedTelemetryValue=!0}}e.$Zn=$;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$1n=R,e.$2n=new R;class E{async publicLog(p,D,l){}async publicLogError(p,D,l){}}e.$3n=E,e.$4n="telemetry",e.$5n="extensionTelemetryLog",e.$6n={log:()=>null,flush:()=>Promise.resolve(null)};function c(s,p){return I.Event.debounce(p.onDidChangeConfiguration,(l,g)=>{const v=l?new Set([...l.affectedKeys,...g.affectedKeys]):g.affectedKeys;return{...g,affectedKeys:v}},1e3,!0)(l=>{l.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,z.$Wh)(l.source),configurationKeys:Array.from(l.affectedKeys)})})}e.$7n=c;function y(s,p){return!p.isBuilt&&!p.disableTelemetry?!0:!(p.disableTelemetry||!s.enableTelemetry||p.extensionTestsLocationURI)}e.$8n=y;function b(s,p){return!(p.isBuilt||p.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.$9n=b;function o(s){const p=s.getValue(k.$1k),D=s.getValue(k.$2k);if(s.getValue(k.$3k)===!1||D===!1)return 0;switch(p??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$0n=o;function t(s){const p={},D={},l={};m(s,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const v=l[g];typeof v=="number"?D[g]=v:typeof v=="boolean"?D[g]=v?1:0:typeof v=="string"?(v.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${v.length}`),p[g]=v.substring(0,8191)):typeof v<"u"&&v!==null&&(p[g]=v)}return{properties:p,measurements:D}}e.$$n=t;const i=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(s){if(!s)return"none";const p=(0,P.$Ak)(s);return i.has(p)?p:"other"}e.$_n=a;function m(s,p,D=0,l){if(s)for(const g of Object.getOwnPropertyNames(s)){const v=s[g],u=l?l+g:g;Array.isArray(v)?p[u]=(0,w.$Km)(v):v instanceof Date?p[u]=v.toISOString():(0,L.$ke)(v)?D<2?m(v,p,D+1,u+"."):p[u]=(0,w.$Km)(v):p[u]=v}}function S(s,p){const D=s.msftInternalDomains||[],l=p.getValue("telemetry.internalTesting");return(0,d.$Yn)(D)||l}e.$ao=S;function C(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.$bo=C;function r(s,p){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let D=s;const l=[];for(const f of p)for(;;){const A=f.exec(s);if(!A)break;l.push([A.index,f.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,v=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(D="";;){const f=v.exec(s);if(!f)break;const A=l.some(([W,B])=>f.index<B&&W<v.lastIndex);!g.test(f[0])&&!A&&(D+=s.substring(u,f.index)+"<REDACTED: user-file-path>",u=v.lastIndex)}return u<s.length&&(D+=s.substr(u)),D}function h(s){if(!s)return s;const p=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const D of p)if(D.regex.test(s))return`<REDACTED: ${D.label}>`;return s}function n(s,p){return(0,w.$Hm)(s,D=>{if(D instanceof $||Object.hasOwnProperty.call(D,"isTrustedTelemetryValue"))return D.value;if(typeof D=="string"){let l=D.replaceAll("%20"," ");l=r(l,p);for(const g of p)l=l.replace(g,"");return l=h(l),l}})}e.$co=n}),define(Ae[181],Re([1,0,15,92,21,22,2,11,52,53]),function($e,e,w,L,I,z,P,d,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.$go=e.$fo=e.$eo=e.$do=void 0;function R(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,w.$Gd)(n.id,s.id)===0}e.$do=R;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class c{static create(s){const p=s.manifest?s.manifest.version:s.version,D=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new c(s.identifier,p,D)}static parse(s){const p=E.exec(s);return p&&p[1]&&p[2]?new c({id:p[1]},p[2],p[4]||void 0):null}constructor(s,p,D="undefined"){this.version=p,this.targetPlatform=D,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof c?R(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$eo=c;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(n){const s=y.exec(n);return s&&s[1]?[t(s[1]),s[2]]:[t(n),void 0]}e.$fo=b;function o(n,s){return`${n}.${s}`}e.$go=o;function t(n){return n.toLowerCase()}e.$ho=t;function i(n,s){return t(o(n??I.$Bl,s))}e.$io=i;function a(n,s){const p=[],D=l=>{for(const g of p)if(g.some(v=>R(s(v),s(l))))return g;return null};for(const l of n){const g=D(l);g?g.push(l):p.push([l])}return p}e.$jo=a;function m(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$ko=m;function S(n){return{id:new $.$Zn(n.identifier.id),name:new $.$Zn(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$lo=S,e.$mo=new I.$Fl("pprice.better-merge");function C(n,s){const p=[],D=s.manifest.extensionDependencies?.slice(0)??[];for(;D.length;){const l=D.shift();if(l&&p.every(g=>!R(g.identifier,{id:l}))){const g=n.filter(v=>R(v.identifier,{id:l}));g.length===1&&(p.push(g[0]),D.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return p}e.$no=C;async function r(n,s){if(!z.$k)return!1;let p;try{p=(await n.readFile(P.URI.file("/etc/os-release"))).value.toString()}catch{try{p=(await n.readFile(P.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){s.debug("Error while getting the os-release file.",(0,d.$9)(l))}}return!!p&&(p.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function h(n,s){const p=await r(n,s),D=(0,L.$In)(p?"alpine":z.$t,k.$8b);return s.debug("ComputeTargetPlatform:",D),D}e.$oo=h}),define(Ae[182],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=e.$2q=e.$1q=e.$Zq=e.$Yq=e.$Xq=void 0;function w(k){return[...k.entries()]}e.$Xq=w;function L(k){return k?[...k.entries()]:[]}e.$Yq=L;function I(k){return new Map(k)}e.$Zq=I;function z(k){return new Map(k??[])}e.$1q=z;function P(k){return Array.from(k.entries()).map($=>[$[0],w($[1].map),L($[1].descriptionMap)])}e.$2q=P;function d(k){return new Map(k.map($=>[$[0],{map:I($[1]),descriptionMap:z($[2])}]))}e.$3q=d}),define(Ae[183],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ib=void 0;class w{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,z,P=5){const d=z(k=>{const $=typeof k=="string"?k:k.data;let R=this.a.get(I);if(R){R.data.push($);return}const E=setTimeout(()=>this.flushBuffer(I),P);R={data:[$],timeoutId:E,dispose:()=>{clearTimeout(E),this.flushBuffer(I),d.dispose()}},this.a.set(I,R)});return d}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const z=this.a.get(I);z&&(this.a.delete(I),this.b(I,z.data.join("")))}}e.$7ib=w}),define(Ae[184],Re([1,0,16,89,40,5,12,2,144,74,30]),function($e,e,w,L,I,z,P,d,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xu=e.$Wu=e.$Vu=e.$Uu=e.$Tu=e.$Su=e.$Ru=e.$Qu=e.IconFontDefinition=e.IconContribution=e.$Pu=void 0,e.$Pu={IconContribution:"base.contributions.icons"};var E;(function(S){function C(r,h){let n=r.defaults;for(;I.ThemeIcon.isThemeIcon(n);){const s=b.getIcon(n.id);if(!s)return;n=s.defaults}return n}S.getDefinition=C})(E||(e.IconContribution=E={}));var c;(function(S){function C(h){return{weight:h.weight,style:h.style,src:h.src.map(n=>({format:n.format,location:n.location.toString()}))}}S.toJSONObject=C;function r(h){const n=s=>(0,P.$ie)(s)?s:void 0;if(h&&Array.isArray(h.src)&&h.src.every(s=>(0,P.$ie)(s.format)&&(0,P.$ie)(s.location)))return{weight:n(h.weight),style:n(h.style),src:h.src.map(s=>({format:s.format,location:d.URI.parse(s.location)}))}}S.fromJSONObject=r})(c||(e.IconFontDefinition=c={}));class y{constructor(){this.a=new z.$7c,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,k.localize)(0,null)},fontCharacter:{type:"string",description:(0,k.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(C,r,h,n){const s=this.b[C];if(s){if(h&&!s.description){s.description=h,this.d.properties[C].markdownDescription=`${h} $(${C})`;const l=this.e.enum.indexOf(C);l!==-1&&(this.e.enumDescriptions[l]=h),this.a.fire()}return s}const p={id:C,description:h,defaults:r,deprecationMessage:n};this.b[C]=p;const D={$ref:"#/definitions/icons"};return n&&(D.deprecationMessage=n),h&&(D.markdownDescription=`${h}: $(${C})`),this.d.properties[C]=D,this.e.enum.push(C),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:C}}deregisterIcon(C){delete this.b[C],delete this.d.properties[C];const r=this.e.enum.indexOf(C);r!==-1&&(this.e.enum.splice(r,1),this.e.enumDescriptions.splice(r,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(C=>this.b[C])}getIcon(C){return this.b[C]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(C,r){const h=this.f[C];return h||(this.f[C]=r,this.a.fire(),r)}deregisterIconFont(C){delete this.f[C]}getIconFont(C){return this.f[C]}toString(){const C=(s,p)=>s.id.localeCompare(p.id),r=s=>{for(;I.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(s=>this.b[s]);for(const s of n.filter(p=>!!p.description).sort(C))h.push(`|<i class="${r(s)}"></i>|${s.id}|${I.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const s of n.filter(p=>!I.ThemeIcon.isThemeIcon(p.defaults)).sort(C))h.push(`|<i class="${r(s)}"></i>|${s.id}|`);return h.join(`
`)}}const b=new y;R.$Rm.add(e.$Pu.IconContribution,b);function o(S,C,r,h){return b.registerIcon(S,C,r,h)}e.$Qu=o;function t(){return b}e.$Ru=t;function i(){const S=(0,L.$yj)();for(const C in S){const r="\\"+S[C].toString(16);b.registerIcon(C,{fontCharacter:r})}}i(),e.$Su="vscode://schemas/icons";const a=R.$Rm.as($.$Sm.JSONContribution);a.registerSchema(e.$Su,b.getIconSchema());const m=new w.$Eg(()=>a.notifySchemaChanged(e.$Su),200);b.onDidChange(()=>{m.isScheduled()||m.schedule()}),e.$Tu=o("widget-close",L.$Aj.close,(0,k.localize)(2,null)),e.$Uu=o("goto-previous-location",L.$Aj.arrowUp,(0,k.localize)(3,null)),e.$Vu=o("goto-next-location",L.$Aj.arrowDown,(0,k.localize)(4,null)),e.$Wu=I.ThemeIcon.modify(L.$Aj.sync,"spin"),e.$Xu=I.ThemeIcon.modify(L.$Aj.loading,"spin")}),define(Ae[185],Re([1,0,5,43,3,14]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nz=e.$Mz=e.$Lz=e.$Kz=e.$Jz=e.$Iz=e.$Hz=e.$Gz=e.ProvidedOnAutoForward=e.$Fz=e.TunnelPrivacyId=e.TunnelProtocol=e.$Ez=e.$Dz=void 0,e.$Dz=(0,I.$nh)("tunnelService"),e.$Ez=(0,I.$nh)("sharedTunnelsService");var P;(function(t){t.Http="http",t.Https="https"})(P||(e.TunnelProtocol=P={}));var d;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(d||(e.TunnelPrivacyId=d={}));function k(t){return!!t.forwardPort}e.$Fz=k;var $;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})($||(e.ProvidedOnAutoForward=$={}));function R(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(i)return{address:i[1],port:+i[2]}}e.$Gz=R,e.$Hz=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(t){return e.$Hz.indexOf(t)>=0}e.$Iz=E,e.$Jz=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(t){return e.$Jz.indexOf(t)>=0}e.$Kz=c;function y(t,i,a,m){if(a===1)return!1;if(a===2&&c(i)){const S=/(\d+)\.(\d+)\.(\d+)/g.exec(m);if(S?.length===4&&parseInt(S[1])>=18)return!1}return t<1024}e.$Lz=y;class b{constructor(i,a,m){this.remoteAddress=i,this.localAddress=a,this.b=m,this.a=new w.$7c,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Mz=b;let o=class{constructor(i,a){this.i=i,this.j=a,this.a=new w.$7c,this.onTunnelOpened=this.a.event,this.b=new w.$7c,this.onTunnelClosed=this.b.event,this.c=new w.$7c,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const i=this.j.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.e=i,i?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.f=i.elevation,this.g=i.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const i=[],a=Array.from(this.d.values());for(const m of a){const S=Array.from(m.values());for(const C of S){const r=await C.value;r&&i.push(r)}}return i}async dispose(){for(const i of this.d.values()){for(const{value:a}of i.values())await a.then(m=>m?.dispose());i.clear()}this.d.clear()}setEnvironmentTunnel(i,a,m,S,C){this.o(i,a,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:a,localAddress:m,privacy:S,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,a){(c(i)||E(i))&&(i=e.$Hz[0]);const m=this.q(i,a);if(m)return++m.refcount,m.value}openTunnel(i,a,m,S,C,r=!1,h,n){this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${m} on local port ${C}.`);const s=this.e??i;if(!s)return;if(a||(a="localhost"),S||(S=this.k),this.e&&this.h.has(m)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const p=this.r(s,a,m,S,C,r,h,n);return p?p.then(D=>{if(!D){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(a,m);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const l=this.m(D);return(D.tunnelRemoteHost!==a||D.tunnelRemotePort!==m)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&D.privacy!==h&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(l),l}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),p)}m(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const a=this.d.get(i.tunnelRemoteHost);if(a){const m=a.get(i.tunnelRemotePort);m&&(m.refcount--,await this.n(i.tunnelRemoteHost,i.tunnelRemotePort,m))}}}}async n(i,a,m){if(m.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${a}.`);const S=m.value.then(async C=>{C&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.d.has(i)&&this.d.get(i).delete(a),S}}async closeTunnel(i,a){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${a} `);const m=this.d.get(i);if(m&&m.has(a)){const S=m.get(a);S.refcount=0,await this.n(i,a,S)}}o(i,a,m){this.d.has(i)||this.d.set(i,new Map),this.d.get(i).set(a,{refcount:1,value:m})}async p(i,a){const m=this.d.get(i);if(m){const S=m.get(a);(S?await S.value:void 0)||m.delete(a),m.size===0&&this.d.delete(i)}}q(i,a){const m=[i];E(i)?(m.push(...e.$Hz),m.push(...e.$Jz)):c(i)&&m.push(...e.$Jz);const S=m.map(C=>this.d.get(C));for(const C of S){const r=C?.get(a);if(r)return r}}canTunnel(i){return!!R(i)}s(i,a,m,S,C,r,h){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${m} on local port ${S}.`);const n=m;this.h.add(n);const s=S===void 0?m:S,p={elevationRequired:C?this.isPortPrivileged(s):!1},D={remoteAddress:{host:a,port:m},localAddressPort:S,privacy:r,public:r?r!==d.Private:void 0,protocol:h},l=i.forwardPort(D,p);return l?(this.o(a,m,l),l.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(n)})):this.h.delete(n),l}};e.$Nz=o,e.$Nz=o=qe([Ve(0,z.$Pi),Ve(1,L.$Th)],o)}),define(Ae[186],Re([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Oz=void 0,e.$Oz=(0,w.$nh)("editSessionIdentityService");var L;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(L||(e.EditSessionIdentityMatch=L={}))}),define(Ae[187],Re([1,0,13]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=void 0;function L(k){return k.scheme!==w.Schemas.file&&k.scheme!==w.Schemas.vscodeRemote}e.$7I=L;function I(k){if(k.folders.length)return k.folders.every($=>L($.uri))?k.folders[0].uri:void 0;if(k.configuration&&L(k.configuration))return k.configuration}e.$8I=I;function z(k){return I(k)?.scheme}e.$9I=z;function P(k){return I(k)?.authority}e.$0I=P;function d(k){return I(k)!==void 0}e.$$I=d}),define(Ae[54],Re([1,0,145,19,48,23,2,3,13]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.WorkbenchState=e.$Dh=e.$Ch=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=e.$wh=void 0,e.$wh=(0,d.$nh)("contextService");function $(s){const p=s;return typeof p?.id=="string"&&P.URI.isUri(p.uri)}e.$xh=$;function R(s){return typeof s?.id=="string"&&!$(s)&&!c(s)}e.$yh=R,e.$zh={id:"ext-dev"},e.$Ah={id:"empty-window"};function E(s,p){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,L.$ec)(s)}:p?e.$zh:e.$Ah;const D=s;return D.configuration?{id:D.id,configPath:D.configuration}:D.folders.length===1?{id:D.id,uri:D.folders[0].uri}:{id:D.id}}e.$Bh=E;function c(s){const p=s;return typeof p?.id=="string"&&P.URI.isUri(p.configPath)}e.$Ch=c;function y(s){const p=s;if(p?.uri)return{id:p.id,uri:P.URI.revive(p.uri)};const D=s;if(D?.configPath)return{id:D.id,configPath:P.URI.revive(D.configPath)};if(s?.id)return{id:s.id}}e.$Dh=y;var b;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function o(s){const p=s;return!!(p&&typeof p=="object"&&typeof p.id=="string"&&Array.isArray(p.folders))}e.$Eh=o;function t(s){const p=s;return!!(p&&typeof p=="object"&&P.URI.isUri(p.uri)&&typeof p.name=="string"&&typeof p.toResource=="function")}e.$Fh=t;class i{constructor(p,D,l,g,v){this.h=p,this.j=l,this.k=g,this.l=v,this.c=I.$th.forUris(this.l,()=>!0),this.folders=D}update(p){this.h=p.id,this.k=p.configuration,this.j=p.transient,this.l=p.l,this.folders=p.folders}get folders(){return this.g}set folders(p){this.g=p,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(p){this.k=p}getFolder(p){return p&&this.c.findSubstr(p)||null}n(){this.c=I.$th.forUris(this.l,()=>!0);for(const p of this.folders)this.c.set(p.uri,p)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Gh=i;class a{constructor(p,D){this.raw=D,this.uri=p.uri,this.index=p.index,this.name=p.name}toResource(p){return(0,z.$8f)(this.uri,p)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Hh=a;function m(s){return new a({uri:s,index:0,name:(0,z.$4f)(s)},{uri:s.toString()})}e.$Ih=m,e.$Jh="code-workspace",e.$Kh=`.${e.$Jh}`,e.$Lh=[{name:(0,w.localize)(0,null),extensions:[e.$Jh]}],e.$Mh="workspace.json";function S(s,p){return z.$Yf.isEqualOrParent(s,p.untitledWorkspacesHome)}e.$Nh=S;function C(s){let p;return P.URI.isUri(s)?p=s:p=s.configuration,p?.scheme===k.Schemas.tmp}e.$Oh=C,e.$Ph="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function r(s){return s.id===e.$Ph}e.$Qh=r;function h(s,p){return!S(s,p)&&!C(s)}e.$Rh=h;function n(s){return(typeof s=="string"?(0,L.$fc)(s):(0,z.$6f)(s))===e.$Kh}e.$Sh=n}),define(Ae[55],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H$b=void 0;class w{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const z=this.c++;return this.b.set(z,I),this.e(),z}get(I,z){return this.b.has(I)?this.b.get(I)[z]:void 0}delete(I){this.b.delete(I),this.e()}e(){w.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$H$b=w}),define(Ae[39],Re([1,0,13,23,3]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.$J$b=void 0;class z{constructor(){this.a=new Set(Object.keys(w.Schemas)),this.b=new Map,this.extUri=new L.$Wf(d=>{const k=this.b.get(d.scheme);return!(k===void 0||k&1024)})}$acceptProviderInfos(d,k){k===null?this.b.delete(d.scheme):this.b.set(d.scheme,k)}isFreeScheme(d){return!this.b.has(d)&&!this.a.has(d)}getCapabilities(d){return this.b.get(d)}}e.$J$b=z,e.$K$b=(0,I.$nh)("IExtHostFileSystemInfo")}),define(Ae[27],Re([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PL=void 0,e.$PL=(0,w.$nh)("IExtHostInitDataService")}),define(Ae[188],Re([1,0,150,14,174,27]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mac=void 0;let P=class extends I.$WM{constructor(k,$,R){const E=R.remote.isRemote?"remoteexthost":k?"workerexthost":"exthost",c=R.remote.isRemote?(0,w.localize)(0,null):k?(0,w.localize)(1,null):(0,w.localize)(2,null);super($.createLogger(E,{name:c}))}};e.$Mac=P,e.$Mac=P=qe([Ve(1,L.$Qi),Ve(2,z.$PL)],P)}),define(Ae[189],Re([1,0,16]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$b_b=e.$a_b=void 0;class L{constructor(P,d,k){this.h=new Map,this.a=P,this.b=d,this.c=k,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then($=>(this.f=$,this)),this.g=this.c.onDidChangeStorage($=>{$.shared===this.b&&$.key===this.a&&(this.f=$.value)}),this.i=new w.$Eg(()=>{const $=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of $.values())R.complete()}catch(R){for(const E of $.values())E.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this.d}get(P,d){let k=this.f[P];return typeof k>"u"&&(k=d),k}update(P,d){this.f[P]=d;const k=this.h.get(P);if(k!==void 0)return k.p;const $=new w.$Ng;return this.h.set(P,$),this.i.isScheduled()||this.i.schedule(),$.p}dispose(){this.g.dispose()}}e.$a_b=L;class I extends L{setKeysForSync(P){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},P)}constructor(P,d){super(P.identifier.value,!0,d),this.j=P}}e.$b_b=I}),define(Ae[190],Re([1,0,5,2]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zac=void 0;class I{constructor(P){this.c=P,this.a=new w.$7c,this.onDidSaveNotebookDocument=this.a.event,this.b=new w.$7c,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(P,d,k,$){const E=this.c.getNotebookDocument(L.URI.revive(P)).acceptModelChanged(d.value,k,$);this.b.fire(E)}$acceptDirtyStateChanged(P,d){this.c.getNotebookDocument(L.URI.revive(P)).acceptDirty(d)}$acceptModelSaved(P){const d=this.c.getNotebookDocument(L.URI.revive(P));this.a.fire(d.apiNotebook)}}e.$zac=I}),define(Ae[17],Re([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AL=e.$zL=void 0,e.$zL=(0,w.$nh)("IExtHostRpcService");class L{constructor(z){this.getProxy=z.getProxy.bind(z),this.set=z.set.bind(z),this.dispose=z.dispose.bind(z),this.assertRegistered=z.assertRegistered.bind(z),this.drain=z.drain.bind(z)}}e.$AL=L}),define(Ae[191],Re([1,0,21,5]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=void 0;class I{#e;constructor(P,d){this.b=new L.$7c,this.onDidChange=this.b.event,this.a=w.$Fl.toKey(P.identifier),this.#e=d,this.#e.onDidChangePassword(k=>{k.extensionId===this.a&&this.b.fire({key:k.key})})}get(P){return this.#e.get(this.a,P)}store(P,d){return this.#e.store(this.a,P,d)}delete(P){return this.#e.delete(this.a,P)}}e.$m_b=I}),define(Ae[56],Re([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V$b=e.$U$b=void 0,e.$U$b=(0,w.$nh)("IURITransformerService");class L{constructor(z){z?(this.transformIncoming=z.transformIncoming.bind(z),this.transformOutgoing=z.transformOutgoing.bind(z),this.transformOutgoingURI=z.transformOutgoingURI.bind(z),this.transformOutgoingScheme=z.transformOutgoingScheme.bind(z)):(this.transformIncoming=P=>P,this.transformOutgoing=P=>P,this.transformOutgoingURI=P=>P,this.transformOutgoingScheme=P=>P)}}e.$V$b=L}),define(Ae[192],Re([1,0,25]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$30=e.$20=void 0;class L{constructor(){this.buffers=[]}add(k){let $=this.buffers.indexOf(k);return $<0&&($=this.buffers.length,this.buffers.push(k)),$}}function I(d,k){if(k.serializeBuffersForPostMessage){const $=new L,E=JSON.stringify(d,(y,b)=>{if(b instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:$.add(b)};if(ArrayBuffer.isView(b)){const o=z(b);if(o)return{$$vscode_array_buffer_reference$$:!0,index:$.add(b.buffer),view:{type:o,byteLength:b.byteLength,byteOffset:b.byteOffset}}}return b}),c=$.buffers.map(y=>{const b=new Uint8Array(y);return w.$Jb.wrap(b)});return{message:E,buffers:c}}else return{message:JSON.stringify(d),buffers:[]}}e.$20=I;function z(d){switch(d.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function P(d,k){const $=k.map(c=>{const y=new ArrayBuffer(c.byteLength);return new Uint8Array(y).set(c.buffer),y}),R=k.length?(c,y)=>{if(y&&typeof y=="object"&&y.$$vscode_array_buffer_reference$$){const b=y,{index:o}=b,t=$[o];if(b.view)switch(b.view.type){case 1:return new Int8Array(t,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return y}:void 0;return{message:JSON.parse(d,R),arrayBuffers:$}}e.$30=P}),define(Ae[99],Re([1,0,159,12,2,6,3,30,38,13,41,127,29]),function($e,e,w,L,I,z,P,d,k,$,R,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NE=e.$ME=e.$LE=e.EditorsOrder=e.$KE=e.CloseDirection=e.$JE=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$IE=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=e.$CE=e.$BE=e.EditorInputCapabilities=e.$AE=e.SaveReason=e.Verbosity=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.$tE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=void 0,e.$oE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$pE={id:"default",displayName:(0,w.localize)(0,null),providerDisplayName:(0,w.localize)(1,null)},e.$qE="workbench.editor.sidebysideEditor",e.$rE="workbench.editors.textDiffEditor",e.$sE="workbench.editors.binaryResourceDiffEditor";var y;(function(Z){Z[Z.PROGRAMMATIC=1]="PROGRAMMATIC",Z[Z.USER=2]="USER",Z[Z.EDIT=3]="EDIT",Z[Z.NAVIGATION=4]="NAVIGATION",Z[Z.JUMP=5]="JUMP"})(y||(e.EditorPaneSelectionChangeReason=y={}));var b;(function(Z){Z[Z.IDENTICAL=1]="IDENTICAL",Z[Z.SIMILAR=2]="SIMILAR",Z[Z.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function o(Z){const le=Z;return!!le&&typeof le.getSelection=="function"&&!!le.onDidChangeSelection}e.$tE=o;function t(Z,le,ne){for(const de of ne.visibleEditorPanes)if(de.group.id===le&&Z.matches(de.input))return de.getViewState()}e.$uE=t;function i(Z){if(D(Z))return!1;const le=Z;return I.URI.isUri(le?.resource)}e.$vE=i;function a(Z){if(D(Z))return!1;const le=Z;return le?.original!==void 0&&le.modified!==void 0}e.$wE=a;function m(Z){if(D(Z)||a(Z))return!1;const le=Z;return le?.primary!==void 0&&le.secondary!==void 0}e.$xE=m;function S(Z){if(D(Z))return!1;const le=Z;return le?le.resource===void 0||le.resource.scheme===$.Schemas.untitled||le.forceUntitled===!0:!1}e.$yE=S;function C(Z){if(D(Z))return!1;const le=Z;return I.URI.isUri(le?.base?.resource)&&I.URI.isUri(le?.input1?.resource)&&I.URI.isUri(le?.input2?.resource)&&I.URI.isUri(le?.result?.resource)}e.$zE=C;var r;(function(Z){Z[Z.SHORT=0]="SHORT",Z[Z.MEDIUM=1]="MEDIUM",Z[Z.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var h;(function(Z){Z[Z.EXPLICIT=1]="EXPLICIT",Z[Z.AUTO=2]="AUTO",Z[Z.FOCUS_CHANGE=3]="FOCUS_CHANGE",Z[Z.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class n{constructor(){this.a=new Map}registerSource(le,ne){let de=this.a.get(le);return de||(de={source:le,label:ne},this.a.set(le,de)),de.source}getSourceLabel(le){return this.a.get(le)?.label??le}}e.$AE=new n;var s;(function(Z){Z[Z.None=0]="None",Z[Z.Readonly=2]="Readonly",Z[Z.Untitled=4]="Untitled",Z[Z.Singleton=8]="Singleton",Z[Z.RequiresTrust=16]="RequiresTrust",Z[Z.CanSplitInGroup=32]="CanSplitInGroup",Z[Z.ForceDescription=64]="ForceDescription",Z[Z.CanDropIntoEditor=128]="CanDropIntoEditor",Z[Z.MultipleEditors=256]="MultipleEditors",Z[Z.Scratchpad=512]="Scratchpad"})(s||(e.EditorInputCapabilities=s={}));class p extends z.$lb{}e.$BE=p;function D(Z){return Z instanceof p}e.$CE=D;function l(Z){const le=Z;return I.URI.isUri(le?.preferredResource)}function g(Z){const le=Z;return D(le?.primary)&&D(le?.secondary)}e.$DE=g;function v(Z){const le=Z;return D(le?.modified)&&D(le?.original)}e.$EE=v;function u(Z,le,ne,de,ue){return G(de,[(0,E.$0h)({id:"workbench.action.openLargeFile",label:(0,w.localize)(2,null),run:()=>{const T={...ne,limits:{size:Number.MAX_VALUE}};Z.openEditor(le,T)}}),(0,E.$0h)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,w.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:c.default.Warning})}e.$FE=u;function f(Z){return D(Z?.editor)}e.$GE=f;function A(Z){const le=Z;return f(Z)&&le?.group!==void 0}e.$HE=A;function W(Z){const le=Z;return typeof le?.groupId=="number"&&D(le.editor)}e.$IE=W;var B;(function(Z){Z[Z.UNKNOWN=0]="UNKNOWN",Z[Z.REPLACE=1]="REPLACE",Z[Z.MOVE=2]="MOVE",Z[Z.UNPIN=3]="UNPIN"})(B||(e.EditorCloseContext=B={}));var V;(function(Z){Z[Z.GROUP_ACTIVE=0]="GROUP_ACTIVE",Z[Z.GROUP_INDEX=1]="GROUP_INDEX",Z[Z.GROUP_LOCKED=2]="GROUP_LOCKED",Z[Z.EDITOR_OPEN=3]="EDITOR_OPEN",Z[Z.EDITOR_CLOSE=4]="EDITOR_CLOSE",Z[Z.EDITOR_MOVE=5]="EDITOR_MOVE",Z[Z.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",Z[Z.EDITOR_LABEL=7]="EDITOR_LABEL",Z[Z.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",Z[Z.EDITOR_PIN=9]="EDITOR_PIN",Z[Z.EDITOR_STICKY=10]="EDITOR_STICKY",Z[Z.EDITOR_DIRTY=11]="EDITOR_DIRTY",Z[Z.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(V||(e.GroupModelChangeKind=V={}));var U;(function(Z){Z[Z.PRIMARY=1]="PRIMARY",Z[Z.SECONDARY=2]="SECONDARY",Z[Z.BOTH=3]="BOTH",Z[Z.ANY=4]="ANY"})(U||(e.SideBySideEditor=U={}));class O{getOriginalUri(le,ne){if(!le)return;if(C(le))return e.$JE.getOriginalUri(le.result,ne);if(ne?.supportSideBySide){const{primary:ue,secondary:T}=this.a(le);if(ue&&T){if(ne?.supportSideBySide===U.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:ne.filterByScheme}),secondary:this.getOriginalUri(T,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===U.ANY)return this.getOriginalUri(ue,{filterByScheme:ne.filterByScheme})??this.getOriginalUri(T,{filterByScheme:ne.filterByScheme});le=ne.supportSideBySide===U.PRIMARY?ue:T}}if(a(le)||m(le)||C(le))return;const de=l(le)?le.preferredResource:le.resource;return!de||!ne||!ne.filterByScheme?de:this.b(de,ne.filterByScheme)}a(le){return g(le)||m(le)?{primary:le.primary,secondary:le.secondary}:v(le)||a(le)?{primary:le.modified,secondary:le.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(le,ne){if(!le)return;if(C(le))return e.$JE.getCanonicalUri(le.result,ne);if(ne?.supportSideBySide){const{primary:ue,secondary:T}=this.a(le);if(ue&&T){if(ne?.supportSideBySide===U.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:ne.filterByScheme}),secondary:this.getCanonicalUri(T,{filterByScheme:ne.filterByScheme})};if(ne?.supportSideBySide===U.ANY)return this.getCanonicalUri(ue,{filterByScheme:ne.filterByScheme})??this.getCanonicalUri(T,{filterByScheme:ne.filterByScheme});le=ne.supportSideBySide===U.PRIMARY?ue:T}}if(a(le)||m(le)||C(le))return;const de=le.resource;return!de||!ne||!ne.filterByScheme?de:this.b(de,ne.filterByScheme)}b(le,ne){if(Array.isArray(ne)){if(ne.some(de=>le.scheme===de))return le}else if(ne===le.scheme)return le}}e.$JE=new O;var N;(function(Z){Z[Z.LEFT=0]="LEFT",Z[Z.RIGHT=1]="RIGHT"})(N||(e.CloseDirection=N={}));class ae{constructor(){this.c=new Map,this.d=new Map}start(le){const ne=this.a=le.get(P.$mh);for(const[de,ue]of this.c)this.e(de,ue,ne);this.c.clear()}e(le,ne,de){const ue=de.createInstance(ne);this.d.set(le,ue)}registerFileEditorFactory(le){if(this.b)throw new Error("Can only register one file editor factory.");this.b=le}getFileEditorFactory(){return(0,L.$te)(this.b)}registerEditorSerializer(le,ne){if(this.c.has(le)||this.d.has(le))throw new Error(`A editor serializer with type ID '${le}' was already registered.`);return this.a?this.e(le,ne,this.a):this.c.set(le,ne),(0,z.$jb)(()=>{this.c.delete(le),this.d.delete(le)})}getEditorSerializer(le){return this.d.get(typeof le=="string"?le:le.typeId)}}d.$Rm.add(e.$oE.EditorFactory,new ae);async function Q(Z,le,ne){return!Z||!Z.length?[]:await Promise.all(Z.map(async de=>{const ue=I.URI.revive(de.fileUri);if(!ue){ne.info("Cannot resolve the path because it is not valid.",de);return}if(!await le.canHandleResource(ue)){ne.info("Cannot resolve the path because it cannot be handled",de);return}let _=de.exists,ye=de.type;if(typeof _!="boolean"||typeof ye!="number")try{ye=(await le.stat(ue)).isDirectory?k.FileType.Directory:k.FileType.Unknown,_=!0}catch(Se){ne.error(Se),_=!1}if(!_&&de.openOnlyIfExists){ne.info("Cannot resolve the path because it does not exist",de);return}if(ye===k.FileType.Directory){ne.info("Cannot resolve the path because it is a directory",de);return}const Ce={...de.options,pinned:!0};return _?{resource:ue,options:Ce}:{resource:ue,options:Ce,forceUntitled:!0}}))}e.$KE=Q;var be;(function(Z){Z[Z.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",Z[Z.SEQUENTIAL=1]="SEQUENTIAL"})(be||(e.EditorsOrder=be={}));function ke(Z){const le=Z;if(!le)return!1;const ne=le;if(ne.modified)return ke(ne.modified);const de=le;return!!(de.contributionsState&&de.viewState&&Array.isArray(de.cursorState))}e.$LE=ke;function Fe(Z){return(0,R.$_h)(Z)}e.$ME=Fe;function G(Z,le,ne){const de=(0,R.$ai)(Z,le);return de.forceMessage=ne?.forceMessage,de.forceSeverity=ne?.forceSeverity,de.allowDialog=ne?.allowDialog,de}e.$NE=G}),define(Ae[193],Re([1,0,5,160,3,6,28,30,18,65,24,89,184]),function($e,e,w,L,I,z,P,d,k,$,R,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UE=e.$TE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$SE=e.$RE=e.ViewContentGroups=e.$QE=e.$PE=e.ViewContainerLocation=e.Extensions=e.$OE=void 0,e.$OE=(0,c.$Qu)("default-view-icon",E.$Aj.window,(0,L.localize)(0,null));var y;(function(n){n.ViewContainersRegistry="workbench.registry.view.containers",n.ViewsRegistry="workbench.registry.view"})(y||(e.Extensions=y={}));var b;(function(n){n[n.Sidebar=0]="Sidebar",n[n.Panel=1]="Panel",n[n.AuxiliaryBar=2]="AuxiliaryBar"})(b||(e.ViewContainerLocation=b={})),e.$PE=[0,1,2];function o(n){switch(n){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$QE=o;class t extends z.$lb{constructor(){super(...arguments),this.c=this.B(new w.$7c),this.onDidRegister=this.c.event,this.f=this.B(new w.$7c),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,k.$xf)([...this.g.values()])}registerViewContainer(s,p,D){const l=this.get(s.id);if(l)return l;const g=s;return g.openCommandActionDescriptor=D?.doNotRegisterOpenCommand?void 0:g.openCommandActionDescriptor??{id:g.id},(0,P.$ii)(this.g,p,[]).push(g),D?.isDefault&&this.h.push(g),this.c.fire({viewContainer:g,viewContainerLocation:p}),g}deregisterViewContainer(s){for(const p of this.g.keys()){const D=this.g.get(p),l=D?.indexOf(s);if(l!==-1){D?.splice(l,1),D.length===0&&this.g.delete(p),this.f.fire({viewContainer:s,viewContainerLocation:p});return}}}get(s){return this.all.filter(p=>p.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(p=>this.getViewContainers(p).filter(D=>D?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(p=>this.getViewContainerLocation(p)===s)}}d.$Rm.add(y.ViewContainersRegistry,new t);var i;(function(n){n.Open="2_open",n.Debug="4_debug",n.SCM="5_scm",n.More="9_more"})(i||(e.ViewContentGroups=i={}));function a(n,s){const p=n.group??i.More,D=s.group??i.More;return p!==D?p.localeCompare(D):(n.order??5)-(s.order??5)}class m extends z.$lb{constructor(){super(...arguments),this.c=this.B(new w.$7c),this.onViewsRegistered=this.c.event,this.f=this.B(new w.$7c),this.onViewsDeregistered=this.f.event,this.g=this.B(new w.$7c),this.onDidChangeContainer=this.g.event,this.h=this.B(new w.$7c),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new $.$L}registerViews(s,p){this.registerViews2([{views:s,viewContainer:p}])}registerViews2(s){s.forEach(({views:p,viewContainer:D})=>this.l(p,D)),this.c.fire(s)}deregisterViews(s,p){const D=this.m(s,p);D.length&&this.f.fire({views:D,viewContainer:p})}moveViews(s,p){for(const D of this.j.keys())if(D!==p){const l=this.m(s,D);l.length&&(this.l(l,p),this.g.fire({views:l,from:D,to:p}))}}getViews(s){return this.j.get(s)||[]}getView(s){for(const p of this.i){const D=(this.j.get(p)||[]).filter(l=>l.id===s)[0];if(D)return D}return null}getViewContainer(s){for(const p of this.i)if((this.j.get(p)||[]).filter(l=>l.id===s)[0])return p;return null}registerViewWelcomeContent(s,p){return this.k.add(s,p),this.h.fire(s),(0,z.$jb)(()=>{this.k.delete(s,p),this.h.fire(s)})}registerViewWelcomeContent2(s,p){const D=new Map;for(const[l,g]of p)this.k.add(s,g),D.set(l,(0,z.$jb)(()=>{this.k.delete(s,g),this.h.fire(s)}));return this.h.fire(s),D}getViewWelcomeContent(s){const p=[];return this.k.forEach(s,D=>p.push(D)),p.sort(a)}l(s,p){let D=this.j.get(p);D||(D=[],this.j.set(p,D),this.i.push(p));for(const l of s){if(this.getView(l.id)!==null)throw new Error((0,L.localize)(1,null,l.id));D.push(l)}}m(s,p){const D=this.j.get(p);if(!D)return[];const l=[],g=[];for(const v of D)s.includes(v)?l.push(v):g.push(v);return l.length&&(g.length?this.j.set(p,g):(this.j.delete(p),this.i.splice(this.i.indexOf(p),1))),l}}d.$Rm.add(y.ViewsRegistry,new m),e.$RE=(0,I.$nh)("viewsService"),e.$SE=(0,I.$nh)("viewDescriptorService");var S;(function(n){n[n.Default=0]="Default",n[n.Expand=1]="Expand"})(S||(e.ViewVisibilityState=S={}));var C;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(C||(e.TreeItemCollapsibleState=C={}));class r{constructor(s,p){this.c=!1,this.d=!1,(0,R.$Im)(this,s),this.d=!!p,this.resolve=async D=>{if(p&&!this.c){const l=await p(D);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}D.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$TE=r;class h extends Error{constructor(s){super((0,L.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$UE=h}),define(Ae[194],Re([1,0,5,16,161]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v$=void 0;class z{constructor(){this.f=new Map,this.k=[],this.m=new w.$7c,this.n=new w.$7c,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(d){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=d}onEvent(d){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=d}onRequest(d){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=d}sendResponse(d){d.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${d.command}`)):this.s("response",d)}sendRequest(d,k,$,R){const E={command:d};if(k&&Object.keys(k).length>0&&(E.arguments=k),this.s("request",E),typeof R=="number"){const c=setTimeout(()=>{clearTimeout(c);const y=this.f.get(E.seq);if(y){this.f.delete(E.seq);const b={type:"response",seq:0,request_seq:E.seq,success:!1,command:d,message:(0,I.localize)(0,null,R,d)};y(b)}},R)}return $&&this.f.set(E.seq,$),E.seq}acceptMessage(d){this.j?this.j(d):(this.k.push(d),this.k.length===1&&this.q())}o(d,k){return d.type!=="event"||k.type!=="event"}async q(){let d;for(;this.k.length;){if((!d||this.o(this.k[0],d))&&await(0,L.$ug)(0),d=this.k.shift(),!d)return;switch(d.type){case"event":this.i?.(d);break;case"request":this.g?.(d);break;case"response":{const k=d,$=this.f.get(k.request_seq);$&&(this.f.delete(k.request_seq),$(k));break}}}}s(d,k){k.type=d,k.seq=this.d++,this.sendMessage(k)}async u(){if(this.f.size===0)return Promise.resolve();const d=new Map;this.f.forEach((k,$)=>d.set($,k)),await(0,L.$ug)(500),d.forEach((k,$)=>{k({type:"response",seq:0,request_seq:$,success:!1,command:"canceled",message:"canceled"}),this.f.delete($)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$v$=z}),define(Ae[195],Re([1,0,162,31,3]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$6G=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$5G=e.MemoryRangeType=e.$4G=e.State=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=void 0,e.$2F="workbench.view.debug",e.$3F="workbench.debug.variablesView",e.$4F="workbench.debug.watchExpressionsView",e.$5F="workbench.debug.callStackView",e.$6F="workbench.debug.loadedScriptsView",e.$7F="workbench.debug.breakPointsView",e.$8F="workbench.debug.disassemblyView",e.$9F="workbench.panel.repl",e.$0F="workbench.panel.repl.view",e.$$F=new L.$Mi("debugType",void 0,{type:"string",description:w.localize(0,null)}),e.$_F=new L.$Mi("debugConfigurationType",void 0,{type:"string",description:w.localize(1,null)}),e.$aG=new L.$Mi("debugState","inactive",{type:"string",description:w.localize(2,null)}),e.$bG="debugUx",e.$cG=new L.$Mi(e.$bG,"default",{type:"string",description:w.localize(3,null)}),e.$dG=new L.$Mi("hasDebugged",!1,{type:"boolean",description:w.localize(4,null)}),e.$eG=new L.$Mi("inDebugMode",!1,{type:"boolean",description:w.localize(5,null)}),e.$fG=new L.$Mi("inDebugRepl",!1,{type:"boolean",description:w.localize(6,null)}),e.$gG=new L.$Mi("breakpointWidgetVisible",!1,{type:"boolean",description:w.localize(7,null)}),e.$hG=new L.$Mi("inBreakpointWidget",!1,{type:"boolean",description:w.localize(8,null)}),e.$iG=new L.$Mi("breakpointsFocused",!0,{type:"boolean",description:w.localize(9,null)}),e.$jG=new L.$Mi("watchExpressionsFocused",!0,{type:"boolean",description:w.localize(10,null)}),e.$kG=new L.$Mi("watchExpressionsExist",!1,{type:"boolean",description:w.localize(11,null)}),e.$lG=new L.$Mi("variablesFocused",!0,{type:"boolean",description:w.localize(12,null)}),e.$mG=new L.$Mi("expressionSelected",!1,{type:"boolean",description:w.localize(13,null)}),e.$nG=new L.$Mi("breakpointInputFocused",!1,{type:"boolean",description:w.localize(14,null)}),e.$oG=new L.$Mi("callStackItemType",void 0,{type:"string",description:w.localize(15,null)}),e.$pG=new L.$Mi("callStackSessionIsAttach",!1,{type:"boolean",description:w.localize(16,null)}),e.$qG=new L.$Mi("callStackItemStopped",!1,{type:"boolean",description:w.localize(17,null)}),e.$rG=new L.$Mi("callStackSessionHasOneThread",!1,{type:"boolean",description:w.localize(18,null)}),e.$sG=new L.$Mi("watchItemType",void 0,{type:"string",description:w.localize(19,null)}),e.$tG=new L.$Mi("canViewMemory",void 0,{type:"boolean",description:w.localize(20,null)}),e.$uG=new L.$Mi("breakpointItemType",void 0,{type:"string",description:w.localize(21,null)}),e.$vG=new L.$Mi("breakpointSupportsCondition",!1,{type:"boolean",description:w.localize(22,null)}),e.$wG=new L.$Mi("loadedScriptsSupported",!1,{type:"boolean",description:w.localize(23,null)}),e.$xG=new L.$Mi("loadedScriptsItemType",void 0,{type:"string",description:w.localize(24,null)}),e.$yG=new L.$Mi("focusedSessionIsAttach",!1,{type:"boolean",description:w.localize(25,null)}),e.$zG=new L.$Mi("stepBackSupported",!1,{type:"boolean",description:w.localize(26,null)}),e.$AG=new L.$Mi("restartFrameSupported",!1,{type:"boolean",description:w.localize(27,null)}),e.$BG=new L.$Mi("stackFrameSupportsRestart",!1,{type:"boolean",description:w.localize(28,null)}),e.$CG=new L.$Mi("jumpToCursorSupported",!1,{type:"boolean",description:w.localize(29,null)}),e.$DG=new L.$Mi("stepIntoTargetsSupported",!1,{type:"boolean",description:w.localize(30,null)}),e.$EG=new L.$Mi("breakpointsExist",!1,{type:"boolean",description:w.localize(31,null)}),e.$FG=new L.$Mi("debuggersAvailable",!1,{type:"boolean",description:w.localize(32,null)}),e.$GG=new L.$Mi("debugExtensionAvailable",!0,{type:"boolean",description:w.localize(33,null)}),e.$HG=new L.$Mi("debugProtocolVariableMenuContext",void 0,{type:"string",description:w.localize(34,null)}),e.$IG=new L.$Mi("debugSetVariableSupported",!1,{type:"boolean",description:w.localize(35,null)}),e.$JG=new L.$Mi("debugSetExpressionSupported",!1,{type:"boolean",description:w.localize(36,null)}),e.$KG=new L.$Mi("breakWhenValueChangesSupported",!1,{type:"boolean",description:w.localize(37,null)}),e.$LG=new L.$Mi("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:w.localize(38,null)}),e.$MG=new L.$Mi("breakWhenValueIsReadSupported",!1,{type:"boolean",description:w.localize(39,null)}),e.$NG=new L.$Mi("terminateDebuggeeSupported",!1,{type:"boolean",description:w.localize(40,null)}),e.$OG=new L.$Mi("suspendDebuggeeSupported",!1,{type:"boolean",description:w.localize(41,null)}),e.$PG=new L.$Mi("variableEvaluateNamePresent",!1,{type:"boolean",description:w.localize(42,null)}),e.$QG=new L.$Mi("variableIsReadonly",!1,{type:"boolean",description:w.localize(43,null)}),e.$RG=new L.$Mi("exceptionWidgetVisible",!1,{type:"boolean",description:w.localize(44,null)}),e.$SG=new L.$Mi("multiSessionRepl",!1,{type:"boolean",description:w.localize(45,null)}),e.$TG=new L.$Mi("multiSessionDebug",!1,{type:"boolean",description:w.localize(46,null)}),e.$UG=new L.$Mi("disassembleRequestSupported",!1,{type:"boolean",description:w.localize(47,null)}),e.$VG=new L.$Mi("disassemblyViewFocus",!1,{type:"boolean",description:w.localize(48,null)}),e.$WG=new L.$Mi("languageSupportsDisassembleRequest",!1,{type:"boolean",description:w.localize(49,null)}),e.$XG=new L.$Mi("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:w.localize(50,null)});const z=c=>w.localize(51,null,c);e.$YG=z,e.$ZG="editor.contrib.debug",e.$1G="editor.contrib.breakpoint",e.$2G="debug",e.$3G={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:w.localize(52,null)};var P;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(P||(e.State=P={}));function d(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$4G=d;var k;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$5G="vscode-debug-memory";var $;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})($||(e.DebugConfigurationProviderTriggerKind=$={}));var R;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$6G=(0,I.$nh)("debugService");var E;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE"})(E||(e.BreakpointWidgetContext=E={}))}),define(Ae[196],Re([1,0,15,2,19,24,13,44,20,18]),function($e,e,w,L,I,z,P,d,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=void 0;const R=/{([^}]+)}/g;function E(l,g,v){return l.replace(R,function(u,f){return g&&f.length>0&&f[0]!=="_"?u:v&&v.hasOwnProperty(f)?v[f]:u})}e.$2E=E;function c(l){const g={};for(const v of Object.keys(l))v.startsWith("!")||(g[v]=l[v]);return g}e.$3E=c;function y(l){return l.configuration.request==="attach"&&!b(l)&&(!l.parentSession||y(l.parentSession))}e.$4E=y;function b(l){let g=l.configuration.type;if(g)return g==="vslsShare"&&(g=l.configuration.adapterProxy.configuration.type),(0,w.$Ld)(g,"extensionhost")||(0,w.$Ld)(g,"pwa-extensionhost")?l:l.parentSession?b(l.parentSession):void 0}e.$5E=b;function o(l){return l.type&&(l.label||l.program||l.runtime)}e.$6E=o;function t(l,g,v){let u,f=0;const A=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=A.exec(l);){const B=W.index+1,V=B+W[0].length;if(B<=g&&V>=v){u=W[0],f=B;break}}if(u){const B=/\w+/g;let V=null;for(;(V=B.exec(u))&&!(V.index+1+f+V[0].length>=v););V&&(u=u.substring(0,B.lastIndex))}return u?{start:f,end:f+u.length-1}:{start:0,end:0}}e.$7E=t;async function i(l,g,v,u){if(l.evaluatableExpressionProvider.has(g)){const f=l.evaluatableExpressionProvider.ordered(g),A=(0,$.$lf)(await Promise.all(f.map(async W=>{try{return await W.provideEvaluatableExpression(g,v,u??k.CancellationToken.None)}catch{return}})));if(A.length>0){let W=A[0].expression;const B=A[0].range;return W||(W=g.getLineContent(v.lineNumber).substring(B.startColumn-1,B.endColumn-1)),{range:B,matchingExpression:W}}}else{const f=g.getLineContent(v.lineNumber),{start:A,end:W}=t(f,v.column,v.column),B=f.substring(A-1,W);return{matchingExpression:B,range:new d.$Mr(v.lineNumber,A,v.lineNumber,A+B.length)}}return null}e.$8E=i;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function m(l){return!!(l&&l.match(a))}e.$9E=m;function S(l){if(typeof l.path=="string"&&!(typeof l.sourceReference=="number"&&l.sourceReference>0)){if(m(l.path))return L.URI.parse(l.path);if((0,I.$_b)(l.path))return L.URI.file(l.path)}return l.path}function C(l){if(typeof l.path=="object"){const g=L.URI.revive(l.path);if(g)return g.scheme===P.Schemas.file?g.fsPath:g.toString()}return l.path}function r(l,g){const v=g?S:C,u=(0,z.$Fm)(l);return n(u,(f,A)=>{f&&A&&(A.path=v(A))}),u}e.$0E=r;function h(l,g){const v=g?S:C,u=(0,z.$Fm)(l);return n(u,(f,A)=>{!f&&A&&(A.path=v(A))}),u}e.$$E=h;function n(l,g){switch(l.type){case"event":{const v=l;switch(v.event){case"output":g(!1,v.body.source);break;case"loadedSource":g(!1,v.body.source);break;case"breakpoint":g(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=l;switch(v.command){case"setBreakpoints":g(!0,v.arguments.source);break;case"breakpointLocations":g(!0,v.arguments.source);break;case"source":g(!0,v.arguments.source);break;case"gotoTargets":g(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(u=>g(!1,u));break;default:break}break}case"response":{const v=l;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(u=>g(!1,u.source));break;case"loadedSources":v.body.sources.forEach(u=>g(!1,u));break;case"scopes":v.body.scopes.forEach(u=>g(!1,u.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(u=>g(!1,u.source));break;case"setBreakpoints":v.body.breakpoints.forEach(u=>g(!1,u.source));break;case"disassemble":v.body?.instructions.forEach(f=>g(!1,f.location));break;default:break}break}}}function s(l){return l.filter(g=>!g.presentation?.hidden).sort((g,v)=>g.presentation?v.presentation?g.presentation.group?v.presentation.group?g.presentation.group!==v.presentation.group?g.presentation.group.localeCompare(v.presentation.group):p(g.presentation.order,v.presentation.order):-1:v.presentation.group?1:p(g.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.$_E=s;function p(l,g){return typeof l!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:l-g}async function D(l,g){const v=l.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(v!=="none"&&(await g.saveAll(),v==="allEditorsInActiveGroup")){const u=g.activeEditorPane;u&&u.input.resource?.scheme===P.Schemas.untitled&&await g.save({editor:u.input,groupId:u.group.id})}await l.reloadConfiguration()}e.$aF=D}),define(Ae[75],Re([1,0,25,37,68,69,13,19,22,31]),function($e,e,w,L,I,z,P,d,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GH=e.$FH=e.$EH=e.$DH=e.CellStatusbarAlignment=e.$CH=e.$BH=e.$AH=e.NotebookEditorPriority=e.$zH=e.$yH=e.$xH=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$wH=e.$vH=e.$uH=e.$tH=e.CellKind=e.$sH=e.$rH=e.$qH=void 0,e.$qH="workbench.editor.notebook",e.$rH="workbench.editor.notebookTextDiffEditor",e.$sH="workbench.editor.interactive";var R;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(R||(e.CellKind=R={})),e.$tH=["application/json","application/javascript","text/html","image/svg+xml",z.$sr.latex,z.$sr.markdown,"image/png","image/jpeg",z.$sr.text],e.$uH=[z.$sr.latex,z.$sr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",z.$sr.text],e.$vH=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$wH="_notAvailable";var E;(function(N){N[N.Running=1]="Running",N[N.Idle=2]="Idle"})(E||(e.NotebookRunState=E={}));var c;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(c||(e.NotebookCellExecutionState=c={}));var y;(function(N){N[N.Unconfirmed=1]="Unconfirmed",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(y||(e.NotebookExecutionState=y={}));var b;(function(N){N[N.WithHardKernelDependency=0]="WithHardKernelDependency",N[N.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",N[N.Pure=2]="Pure",N[N.Never=3]="Never"})(b||(e.NotebookRendererMatch=b={}));var o;(function(N){N.Always="always",N.Never="never",N.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var t;(function(N){N[N.ModelChange=1]="ModelChange",N[N.Move=2]="Move",N[N.ChangeCellLanguage=5]="ChangeCellLanguage",N[N.Initialize=6]="Initialize",N[N.ChangeCellMetadata=7]="ChangeCellMetadata",N[N.Output=8]="Output",N[N.OutputItem=9]="OutputItem",N[N.ChangeCellContent=10]="ChangeCellContent",N[N.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",N[N.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",N[N.ChangeCellMime=13]="ChangeCellMime",N[N.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var i;(function(N){N[N.Handle=0]="Handle",N[N.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var a;(function(N){N[N.Replace=1]="Replace",N[N.Output=2]="Output",N[N.Metadata=3]="Metadata",N[N.CellLanguage=4]="CellLanguage",N[N.DocumentMetadata=5]="DocumentMetadata",N[N.Move=6]="Move",N[N.OutputItems=7]="OutputItems",N[N.PartialMetadata=8]="PartialMetadata",N[N.PartialInternalMetadata=9]="PartialInternalMetadata"})(a||(e.CellEditType=a={}));var m;(function(N){N.scheme=P.Schemas.vscodeNotebookCell;const ae=["W","X","Y","Z","a","b","c","d","e","f"],Q=new RegExp(`^[${ae.join("")}]+`),be=7;function ke(de,ue){const T=ue.toString(be),ye=`${T.length<ae.length?ae[T.length-1]:"z"}${T}s${(0,w.$4b)(w.$Jb.fromString(de.scheme),!0,!0)}`;return de.with({scheme:N.scheme,fragment:ye})}N.generate=ke;function Fe(de){if(de.scheme!==N.scheme)return;const ue=de.fragment.indexOf("s");if(ue<0)return;const T=parseInt(de.fragment.substring(0,ue).replace(Q,""),be),_=(0,w.$3b)(de.fragment.substring(ue+1)).toString();if(!isNaN(T))return{handle:T,notebook:de.with({scheme:_,fragment:null})}}N.parse=Fe;function G(de,ue){return de.with({scheme:P.Schemas.vscodeNotebookCellOutput,fragment:`op${ue??""},${de.scheme!==P.Schemas.file?de.scheme:""}`})}N.generateCellOutputUri=G;function Z(de){if(de.scheme!==P.Schemas.vscodeNotebookCellOutput)return;const ue=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(de.fragment);if(!ue)return;const T=ue[1]&&ue[1]!==""?ue[1]:void 0,_=ue[2];return{outputId:T,notebook:de.with({scheme:_||P.Schemas.file,fragment:null})}}N.parseCellOutputUri=Z;function le(de,ue,T){return N.generate(de,ue).with({scheme:T})}N.generateCellPropertyUri=le;function ne(de,ue){if(de.scheme===ue)return N.parse(de.with({scheme:N.scheme}))}N.parseCellPropertyUri=ne})(m||(e.CellUri=m={}));const S=N=>k.$i?N.replace(/\//g,"\\"):N;class C{constructor(ae=[],Q=e.$tH){this.e=Q,this.d=[...new Set(ae)].map(be=>({pattern:be,matches:L.$cj(S(be))}))}sort(ae){const Q=new Map(I.Iterable.map(ae,ke=>[ke,S(ke)]));let be=[];for(const{matches:ke}of this.d)for(const[Fe,G]of Q)if(ke(G)){be.push(Fe),Q.delete(Fe);break}return Q.size&&(be=be.concat([...Q.keys()].sort((ke,Fe)=>this.e.indexOf(ke)-this.e.indexOf(Fe)))),be}prioritize(ae,Q){const be=this.f(ae);if(be===-1){this.d.unshift({pattern:ae,matches:L.$cj(S(ae))});return}const ke=new Set(Q.map(G=>this.f(G,be)));ke.delete(-1);const Fe=Array.from(ke).sort();this.d.splice(be+1,0,...Fe.map(G=>this.d[G]));for(let G=Fe.length-1;G>=0;G--)this.d.splice(Fe[G],1)}toArray(){return this.d.map(ae=>ae.pattern)}f(ae,Q=this.d.length){const be=S(ae);for(let ke=0;ke<Q;ke++)if(this.d[ke].matches(be))return ke;return-1}}e.$xH=C;function r(N,ae,Q,be=(ke,Fe)=>ke===Fe){const ke=[];function Fe(le,ne,de){if(ne===0&&de.length===0)return;const ue=ke[ke.length-1];ue&&ue.start+ue.deleteCount===le?(ue.deleteCount+=ne,ue.toInsert.push(...de)):ke.push({start:le,deleteCount:ne,toInsert:de})}let G=0,Z=0;for(;;){if(G===N.length){Fe(G,0,ae.slice(Z));break}if(Z===ae.length){Fe(G,N.length-G,[]);break}const le=N[G],ne=ae[Z];if(be(le,ne)){G+=1,Z+=1;continue}Q(ne)?(Fe(G,1,[]),G+=1):(Fe(G,0,[ne]),Z+=1)}return ke}e.$yH=r,e.$zH=new $.$Mi("notebookEditorCursorAtBoundary","none");var h;(function(N){N.default="default",N.option="option"})(h||(e.NotebookEditorPriority=h={}));function n(N){const ae=N;return!!((typeof ae.include=="string"||L.$dj(ae.include))&&(typeof ae.exclude=="string"||L.$dj(ae.exclude)))}e.$AH=n;function s(N,ae,Q){if(Array.isArray(N.viewType)&&N.viewType.indexOf(ae)>=0||N.viewType===ae)return!0;if(N.filenamePattern){const be=n(N.filenamePattern)?N.filenamePattern.include:N.filenamePattern,ke=n(N.filenamePattern)?N.filenamePattern.exclude:void 0;if(L.$bj(be,(0,d.$ec)(Q.fsPath).toLowerCase()))return!(ke&&L.$bj(ke,(0,d.$ec)(Q.fsPath).toLowerCase()))}return!1}e.$BH=s,e.$CH={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave"};var p;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(p||(e.CellStatusbarAlignment=p={}));class D{static{this.d="notebook/"}static create(ae){return`${D.d}${ae}`}static parse(ae){if(ae.startsWith(D.d))return ae.substring(D.d.length)}}e.$DH=D;function l(N){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(N)}e.$EH=l;const g=new TextDecoder;function v(N){const ae=[];let Q=!1;for(const G of N)(ae.length===0||Q)&&(ae.push(G),Q=!0);let be=A(ae);const ke=w.$Jb.concat(ae.map(G=>w.$Jb.wrap(G))),Fe=O(ke);return be=be||Fe.byteLength!==ke.byteLength,{data:Fe,didCompression:be}}e.$FH=v,e.$GH=`${String.fromCharCode(27)}[A`;const u=e.$GH.split("").map(N=>N.charCodeAt(0)),f=10;function A(N){let ae=!1;return N.forEach((Q,be)=>{if(be===0||Q.length<e.$GH.length)return;const ke=N[be-1],Fe=Q.subarray(0,e.$GH.length);if(Fe[0]===u[0]&&Fe[1]===u[1]&&Fe[2]===u[2]){const G=ke.lastIndexOf(f);if(G===-1)return;ae=!0,N[be-1]=ke.subarray(0,G),N[be]=Q.subarray(e.$GH.length)}}),ae}function W(N){let ae=N;do N=ae,ae=N.replace(/[^\n]\x08/gm,"");while(ae.length<N.length);return N}function B(N){for(N=N.replace(/\r+\n/gm,`
`);N.search(/\r[^$]/g)>-1;){const ae=N.match(/^(.*)\r+/m)[1];let Q=N.match(/\r+(.*)$/m)[1];Q=Q+ae.slice(Q.length,ae.length),N=N.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Q)}return N}const V="\b".charCodeAt(0),U="\r".charCodeAt(0);function O(N){return!N.buffer.includes(V)&&!N.buffer.includes(U)?N:w.$Jb.fromString(B(W(g.decode(N.buffer))))}}),define(Ae[7],Re([1,0,18,11,49,28,69,15,12,2,36,21,38,97,75]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b){"use strict";var o,t,i,a,m,S,C,r,h,n,s,p,D,l,g,v,u,f;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$oL=e.$nL=e.$mL=e.$lL=e.$kL=e.$jL=e.$iL=e.$hL=e.$gL=e.$fL=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$eL=e.$dL=e.$cL=e.$bL=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.TestRunProfileKind=e.TestResultState=e.$8K=e.$7K=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$6K=e.$5K=e.$4K=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$3K=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$2K=e.$1K=e.$ZK=e.$YK=e.$XK=e.ColorThemeKind=e.$WK=e.$VK=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$UK=e.DebugConsoleMode=e.$TK=e.$SK=e.$RK=e.$QK=e.$PK=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$OK=e.$NK=e.FileChangeType=e.$MK=e.$LK=e.$KK=e.$JK=e.InlineCompletionTriggerKind=e.$IK=e.$HK=e.$GK=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=e.ConfigurationTarget=e.$vK=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$mK=e.ViewBadge=e.ProgressLocation=e.$lK=e.$kK=e.TaskScope=e.ShellQuoting=e.$jK=e.$iK=e.$hK=e.TaskPanelKind=e.TaskRevealKind=e.$gK=e.TerminalLocation=e.$fK=e.$eK=e.$dK=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$cK=e.$bK=e.$aK=e.$_J=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$$J=e.StatusBarAlignment=e.ViewColumn=e.$0J=e.$9J=e.$8J=e.$7J=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$6J=e.$5J=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$4J=e.$3J=e.$2J=e.$1J=e.$ZJ=e.LanguageStatusSeverity=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.CodeActionTriggerKind=e.$RJ=e.$QJ=e.SymbolTag=e.SymbolKind=e.$PJ=e.DocumentHighlightKind=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.DiagnosticSeverity=e.DiagnosticTag=e.$KJ=e.$JJ=e.FileEditType=e.$IJ=e.$HJ=e.$GJ=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function A(j){return Object.assign(j,{apply:function(){const re=arguments.length===1?[]:arguments[1];return Reflect.construct(j,re,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(j,[]);{const[re,...De]=arguments;return Reflect.construct(j,De,re.constructor)}}})}var W;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(W||(e.TerminalOutputAnchor=W={}));var B;(function(j){j[j.Command=0]="Command",j[j.Opener=1]="Opener"})(B||(e.TerminalQuickFixType=B={}));let V=o=class{static from(...M){let re=M;return new o(function(){if(re){for(const De of re)De&&typeof De.dispose=="function"&&De.dispose();re=void 0}})}#e;constructor(M){this.#e=M}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$zJ=V,e.$zJ=V=o=qe([A],V);let U=t=class{static Min(...M){if(M.length===0)throw new TypeError;let re=M[0];for(let De=1;De<M.length;De++){const Je=M[De];Je.isBefore(re)&&(re=Je)}return re}static Max(...M){if(M.length===0)throw new TypeError;let re=M[0];for(let De=1;De<M.length;De++){const Je=M[De];Je.isAfter(re)&&(re=Je)}return re}static isPosition(M){if(!M)return!1;if(M instanceof t)return!0;const{line:re,character:De}=M;return typeof re=="number"&&typeof De=="number"}static of(M){if(M instanceof t)return M;if(this.isPosition(M))return new t(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,re){if(M<0)throw(0,L.$5)("line must be non-negative");if(re<0)throw(0,L.$5)("character must be non-negative");this.c=M,this.e=re}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,re=0){if(M===null||re===null)throw(0,L.$5)();let De;return typeof M>"u"?De=0:typeof M=="number"?De=M:(De=typeof M.lineDelta=="number"?M.lineDelta:0,re=typeof M.characterDelta=="number"?M.characterDelta:0),De===0&&re===0?this:new t(this.line+De,this.character+re)}with(M,re=this.character){if(M===null||re===null)throw(0,L.$5)();let De;return typeof M>"u"?De=this.line:typeof M=="number"?De=M:(De=typeof M.line=="number"?M.line:this.line,re=typeof M.character=="number"?M.character:this.character),De===this.line&&re===this.character?this:new t(De,re)}toJSON(){return{line:this.line,character:this.character}}};e.$AJ=U,e.$AJ=U=t=qe([A],U);let O=i=class{static isRange(M){return M instanceof i?!0:M?U.isPosition(M.start)&&U.isPosition(M.end):!1}static of(M){if(M instanceof i)return M;if(this.isRange(M))return new i(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,re,De,Je){let Ye,rt;if(typeof M=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Je=="number"?(Ye=new U(M,re),rt=new U(De,Je)):U.isPosition(M)&&U.isPosition(re)&&(Ye=U.of(M),rt=U.of(re)),!Ye||!rt)throw new Error("Invalid arguments");Ye.isBefore(rt)?(this.c=Ye,this.e=rt):(this.c=rt,this.e=Ye)}contains(M){return i.isRange(M)?this.contains(M.start)&&this.contains(M.end):U.isPosition(M)?!(U.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const re=U.Max(M.start,this.c),De=U.Min(M.end,this.e);if(!re.isAfter(De))return new i(re,De)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const re=U.Min(M.start,this.c),De=U.Max(M.end,this.end);return new i(re,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,re=this.end){if(M===null||re===null)throw(0,L.$5)();let De;return M?U.isPosition(M)?De=M:(De=M.start||this.start,re=M.end||this.end):De=this.start,De.isEqual(this.c)&&re.isEqual(this.end)?this:new i(De,re)}toJSON(){return[this.start,this.end]}};e.$BJ=O,e.$BJ=O=i=qe([A],O);let N=a=class extends O{static isSelection(M){return M instanceof a?!0:M?O.isRange(M)&&U.isPosition(M.anchor)&&U.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,re,De,Je){let Ye,rt;if(typeof M=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Je=="number"?(Ye=new U(M,re),rt=new U(De,Je)):U.isPosition(M)&&U.isPosition(re)&&(Ye=U.of(M),rt=U.of(re)),!Ye||!rt)throw new Error("Invalid arguments");super(Ye,rt),this.f=Ye,this.g=rt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$CJ=N,e.$CJ=N=a=qe([A],N);const ae=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,L.$5)("connectionToken")};class Q{static isResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.host=="string"&&typeof M.port=="number"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,re,De){if(typeof M!="string"||M.length===0)throw(0,L.$5)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,L.$5)("port");typeof De<"u"&&ae(De),this.host=M,this.port=Math.round(re),this.connectionToken=De}}e.$DJ=Q;class be{static isManagedResolvedAuthority(M){return M&&typeof M=="object"&&typeof M.makeConnection=="function"&&(M.connectionToken===void 0||typeof M.connectionToken=="string")}constructor(M,re){this.makeConnection=M,this.connectionToken=re,typeof re<"u"&&ae(re)}}e.$EJ=be;class ke extends Error{static NotAvailable(M,re){return new ke(M,y.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(M){return new ke(M,y.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,re=y.RemoteAuthorityResolverErrorCode.Unknown,De){super(M),this._message=M,this._code=re,this._detail=De,Object.setPrototypeOf(this,ke.prototype)}}e.$FJ=ke;var Fe;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(Fe||(e.EndOfLine=Fe={}));var G;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(G||(e.EnvironmentVariableMutatorType=G={}));let Z=m=class{static isTextEdit(M){return M instanceof m?!0:M?O.isRange(M)&&typeof M.newText=="string":!1}static replace(M,re){return new m(M,re)}static insert(M,re){return m.replace(new O(M,M),re)}static delete(M){return m.replace(M,"")}static setEndOfLine(M){const re=new m(new O(new U(0,0),new U(0,0)),"");return re.newEol=M,re}get range(){return this.c}set range(M){if(M&&!O.isRange(M))throw(0,L.$5)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,L.$5)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,L.$5)("newEol");this.f=M}constructor(M,re){this.c=M,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$GJ=Z,e.$GJ=Z=m=qe([A],Z);let le=S=class{static isNotebookCellEdit(M){return M instanceof S?!0:M?Xt.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,re){return new S(M,re)}static insertCells(M,re){return new S(new Xt(M,M),re)}static deleteCells(M){return new S(M,[])}static updateCellMetadata(M,re){const De=new S(new Xt(M,M),[]);return De.newCellMetadata=re,De}static updateNotebookMetadata(M){const re=new S(new Xt(0,0),[]);return re.newNotebookMetadata=M,re}constructor(M,re){this.range=M,this.newCells=re}};e.$HJ=le,e.$HJ=le=S=qe([A],le);class ne{static isSnippetTextEdit(M){return M instanceof ne?!0:M?O.isRange(M.range)&&T.isSnippetString(M.snippet):!1}static replace(M,re){return new ne(M,re)}static insert(M,re){return ne.replace(new O(M,M),re)}constructor(M,re){this.range=M,this.snippet=re}}e.$IJ=ne;var de;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(de||(e.FileEditType=de={}));let ue=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,re,De,Je){this.c.push({_type:1,from:M,to:re,options:De,metadata:Je})}createFile(M,re,De){this.c.push({_type:1,from:void 0,to:M,options:re,metadata:De})}deleteFile(M,re,De){this.c.push({_type:1,from:M,to:void 0,options:re,metadata:De})}e(M,re,De){this.c.push({_type:3,metadata:De,uri:M,edit:{editType:5,metadata:re},notebookMetadata:re})}f(M,re,De,Je){const Ye=re.start,rt=re.end;(Ye!==rt||De.length>0)&&this.c.push({_type:5,uri:M,index:Ye,count:rt-Ye,cells:De,metadata:Je})}g(M,re,De,Je){this.c.push({_type:3,metadata:Je,uri:M,edit:{editType:3,index:re,metadata:De}})}replace(M,re,De,Je){this.c.push({_type:2,uri:M,edit:new Z(re,De),metadata:Je})}insert(M,re,De,Je){this.replace(M,new O(re,re),De,Je)}delete(M,re,De){this.replace(M,re,"",De)}has(M){return this.c.some(re=>re._type===2&&re.uri.toString()===M.toString())}set(M,re){if(re)for(const De of re){if(!De)continue;let Je,Ye;Array.isArray(De)?(Je=De[0],Ye=De[1]):Je=De,le.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(M,Je.range.start,Je.newCellMetadata,Ye):Je.newNotebookMetadata?this.e(M,Je.newNotebookMetadata,Ye):this.f(M,Je.range,Je.newCells,Ye):ne.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:M,range:Je.range,edit:Je.snippet,metadata:Ye}):this.c.push({_type:2,uri:M,edit:Je,metadata:Ye})}else{for(let De=0;De<this.c.length;De++){const Je=this.c[De];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===M.toString()&&(this.c[De]=void 0);break}}(0,w.$mf)(this.c)}}get(M){const re=[];for(const De of this.c)De._type===2&&De.uri.toString()===M.toString()&&re.push(De.edit);return re}entries(){const M=new z.$li;for(const re of this.c)if(re._type===2){let De=M.get(re.uri);De||(De=[re.uri,[]],M.set(re.uri,De)),De[1].push(re.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$JJ=ue,e.$JJ=ue=qe([A],ue);let T=C=class{static isSnippetString(M){return M instanceof C?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=C.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,re=this.e++){if(typeof M=="function"){const De=new C;De.e=this.e,M(De),this.e=De.e,M=De.value}else M=C.c(M);return this.value+="${",this.value+=re,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,re=this.e++){const De=M.map(Je=>Je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(M,re){if(typeof re=="function"){const De=new C;De.e=this.e,re(De),this.e=De.e,re=De.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,re&&(this.value+=":",this.value+=re),this.value+="}",this}};e.$KJ=T,e.$KJ=T=C=qe([A],T);var _;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(_||(e.DiagnosticTag=_={}));var ye;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(ye||(e.DiagnosticSeverity=ye={}));let Ce=r=class{static isLocation(M){return M instanceof r?!0:M?O.isRange(M.range)&&$.URI.isUri(M.uri):!1}constructor(M,re){if(this.uri=M,re)if(O.isRange(re))this.range=O.of(re);else if(U.isPosition(re))this.range=new O(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$LJ=Ce,e.$LJ=Ce=r=qe([A],Ce);let Se=class{static is(M){return M?typeof M.message=="string"&&M.location&&O.isRange(M.location.range)&&$.URI.isUri(M.location.uri):!1}constructor(M,re){this.location=M,this.message=re}static isEqual(M,re){return M===re?!0:!M||!re?!1:M.message===re.message&&M.location.range.isEqual(re.location.range)&&M.location.uri.toString()===re.location.uri.toString()}};e.$MJ=Se,e.$MJ=Se=qe([A],Se);let Ee=class{constructor(M,re,De=ye.Error){if(!O.isRange(M))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=M,this.message=re,this.severity=De}toJSON(){return{severity:ye[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,re){return M===re?!0:!M||!re?!1:M.message===re.message&&M.severity===re.severity&&M.code===re.code&&M.severity===re.severity&&M.source===re.source&&M.range.isEqual(re.range)&&(0,w.$af)(M.tags,re.tags)&&(0,w.$af)(M.relatedInformation,re.relatedInformation,Se.isEqual)}};e.$NJ=Ee,e.$NJ=Ee=qe([A],Ee);let Ie=class{constructor(M,re){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=re}};e.$OJ=Ie,e.$OJ=Ie=qe([A],Ie);var se;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(se||(e.DocumentHighlightKind=se={}));let fe=class{constructor(M,re=se.Text){this.range=M,this.kind=re}toJSON(){return{range:this.range,kind:se[this.kind]}}};e.$PJ=fe,e.$PJ=fe=qe([A],fe);var ee;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(ee||(e.SymbolKind=ee={}));var ie;(function(j){j[j.Deprecated=1]="Deprecated"})(ie||(e.SymbolTag=ie={}));let he=h=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,re,De,Je,Ye){this.name=M,this.kind=re,this.containerName=Ye,typeof De=="string"&&(this.containerName=De),Je instanceof Ce?this.location=Je:De instanceof O&&(this.location=new Ce(Je,De)),h.validate(this)}toJSON(){return{name:this.name,kind:ee[this.kind],location:this.location,containerName:this.containerName}}};e.$QJ=he,e.$QJ=he=h=qe([A],he);let F=n=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(n.validate)}constructor(M,re,De,Je,Ye){this.name=M,this.detail=re,this.kind=De,this.range=Je,this.selectionRange=Ye,this.children=[],n.validate(this)}};e.$RJ=F,e.$RJ=F=n=qe([A],F);var q;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(q||(e.CodeActionTriggerKind=q={}));let J=class{constructor(M,re){this.title=M,this.kind=re}};e.$SJ=J,e.$SJ=J=qe([A],J);let K=class{static{s=this}static{this.c="."}constructor(M){this.value=M}append(M){return new s(this.value?this.value+s.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+s.c)}};e.$TJ=K,e.$TJ=K=s=qe([A],K);class oe extends K{constructor(M){super(M),this.value=M}}e.$UJ=oe,K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let H=class{constructor(M,re){if(this.range=M,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$VJ=H,e.$VJ=H=qe([A],H);class ce{constructor(M,re,De,Je,Ye,rt){this.kind=M,this.name=re,this.detail=De,this.uri=Je,this.range=Ye,this.selectionRange=rt}}e.$WJ=ce;class pe{constructor(M,re){this.fromRanges=re,this.from=M}}e.$XJ=pe;class Oe{constructor(M,re){this.fromRanges=re,this.to=M}}e.$YJ=Oe;var Be;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Be||(e.LanguageStatusSeverity=Be={}));let Ze=class{constructor(M,re){this.range=M,this.command=re}get isResolved(){return!!this.command}};e.$ZJ=Ze,e.$ZJ=Ze=qe([A],Ze);let Ke=p=class{#e;static isMarkdownString(M){return M instanceof p?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,re=!1){this.#e=new I.$Ij(M,{supportThemeIcons:re})}get value(){return this.#e.value}set value(M){this.#e.value=M}get isTrusted(){return this.#e.isTrusted}set isTrusted(M){this.#e.isTrusted=M}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(M){this.#e.supportThemeIcons=M}get supportHtml(){return this.#e.supportHtml}set supportHtml(M){this.#e.supportHtml=M}get baseUri(){return this.#e.baseUri}set baseUri(M){this.#e.baseUri=M}appendText(M){return this.#e.appendText(M),this}appendMarkdown(M){return this.#e.appendMarkdown(M),this}appendCodeblock(M,re){return this.#e.appendCodeblock(re??"",M),this}};e.$1J=Ke,e.$1J=Ke=p=qe([A],Ke);let Qe=class{constructor(M,re){this.label=M,this.documentation=re}};e.$2J=Qe,e.$2J=Qe=qe([A],Qe);let Ge=class{constructor(M,re){this.label=M,this.documentation=re,this.parameters=[]}};e.$3J=Ge,e.$3J=Ge=qe([A],Ge);let ct=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$4J=ct,e.$4J=ct=qe([A],ct);var xe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var tt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let Ne=class{constructor(M){this.value=M}};e.$5J=Ne,e.$5J=Ne=qe([A],Ne);let nt=class{constructor(M,re,De){this.position=M,this.label=re,this.kind=De}};e.$6J=nt,e.$6J=nt=qe([A],nt);var x;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(x||(e.CompletionTriggerKind=x={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(Y||(e.CompletionItemKind=Y={}));var me;(function(j){j[j.Deprecated=1]="Deprecated"})(me||(e.CompletionItemTag=me={}));let je=class{constructor(M,re){this.label=M,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&Y[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$7J=je,e.$7J=je=qe([A],je);let ze=class{constructor(M=[],re=!1){this.items=M,this.isIncomplete=re}};e.$8J=ze,e.$8J=ze=qe([A],ze);let Xe=class{constructor(M,re,De){this.insertText=M,this.range=re,this.command=De}};e.$9J=Xe,e.$9J=Xe=qe([A],Xe);let et=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.$0J=et,e.$0J=et=qe([A],et);var gt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(gt||(e.ViewColumn=gt={}));var wt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(wt||(e.StatusBarAlignment=wt={}));function Ot(j,M){return`${E.$Fl.toKey(j)}.${M}`}e.$$J=Ot;var Jt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Jt||(e.TextEditorLineNumbersStyle=Jt={}));var Wt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Wt||(e.TextDocumentSaveReason=Wt={}));var yt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(yt||(e.TextEditorRevealType=yt={}));var Rt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Rt||(e.TextEditorSelectionChangeKind=Rt={}));var Ft;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Ft||(e.TextDocumentChangeReason=Ft={}));var Mt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Mt||(e.DecorationRangeBehavior=Mt={})),function(j){function M(re){switch(re){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=M}(Rt||(e.TextEditorSelectionChangeKind=Rt={}));let Ut=class{constructor(M,re){if(re&&!$.URI.isUri(re))throw(0,L.$5)("target");if(!O.isRange(M)||M.isEmpty)throw(0,L.$5)("range");this.range=M,this.target=re}};e.$_J=Ut,e.$_J=Ut=qe([A],Ut);let Lt=class{constructor(M,re,De,Je){this.red=M,this.green=re,this.blue=De,this.alpha=Je}};e.$aK=Lt,e.$aK=Lt=qe([A],Lt);let st=class{constructor(M,re){if(re&&!(re instanceof Lt))throw(0,L.$5)("color");if(!O.isRange(M)||M.isEmpty)throw(0,L.$5)("range");this.range=M,this.color=re}};e.$bK=st,e.$bK=st=qe([A],st);let ht=class{constructor(M){if(!M||typeof M!="string")throw(0,L.$5)("label");this.label=M}};e.$cK=ht,e.$cK=ht=qe([A],ht);var jt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(jt||(e.ColorFormat=jt={}));var Tt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Tt||(e.SourceControlInputBoxValidationType=Tt={}));var kt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(kt||(e.TerminalExitReason=kt={}));class ot{constructor(M,re,De){if(this.startIndex=M,this.length=re,this.tooltip=De,typeof M!="number"||M<0)throw(0,L.$5)("startIndex");if(typeof re!="number"||re<1)throw(0,L.$5)("length");if(De!==void 0&&typeof De!="string")throw(0,L.$5)("tooltip")}}e.$dK=ot;class Pt{constructor(M){this.uri=M}}e.$eK=Pt;class zt{constructor(M){this.terminalCommand=M}}e.$fK=zt;var Pe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Pe||(e.TerminalLocation=Pe={}));class we{constructor(M){if(this.options=M,typeof M!="object")throw(0,L.$5)("options")}}e.$gK=we;var ve;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(ve||(e.TaskRevealKind=ve={}));var X;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(X||(e.TaskPanelKind=X={}));let Le=class{static{D=this}static{this.Clean=new D("clean","Clean")}static{this.Build=new D("build","Build")}static{this.Rebuild=new D("rebuild","Rebuild")}static{this.Test=new D("test","Test")}static from(M){switch(M){case"clean":return D.Clean;case"build":return D.Build;case"rebuild":return D.Rebuild;case"test":return D.Test;default:return}}constructor(M,re){if(this.label=re,typeof M!="string"||typeof re!="string")throw(0,L.$5)("name");this.c=M}get id(){return this.c}};e.$hK=Le,e.$hK=Le=D=qe([A],Le);function Ue(j){let M="";for(let re=0;re<j.length;re++)M+=j[re].replace(/,/g,",,")+",";return M}let He=class{constructor(M,re,De){if(typeof M!="string")throw(0,L.$5)("process");this.e=[],this.c=M,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=De):this.f=re)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,L.$5)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const re of this.e)M.push(re);return Ue(M)}};e.$iK=He,e.$iK=He=qe([A],He);let We=class{constructor(M,re,De){if(this.f=[],Array.isArray(re)){if(!M)throw(0,L.$5)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,L.$5)("command");this.e=M,this.f=re,this.g=De}else{if(typeof M!="string")throw(0,L.$5)("commandLine");this.c=M,this.g=re}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,L.$5)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,L.$5)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)M.push(typeof re=="string"?re:re.value);return Ue(M)}};e.$jK=We,e.$jK=We=qe([A],We);var _e;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(_e||(e.ShellQuoting=_e={}));var bt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(bt||(e.TaskScope=bt={}));class Dt{constructor(M){this.c=M}computeId(){return"customExecution"+(0,R.$5e)()}set callback(M){this.c=M}get callback(){return this.c}}e.$kK=Dt;let St=class{static{l=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(M,re,De,Je,Ye,rt){this.j=!1,this.k=this.definition=M;let ut;typeof re=="string"?(this.m=this.name=re,this.t=this.source=De,this.execution=Je,ut=Ye,this.j=!0):re===bt.Global||re===bt.Workspace?(this.target=re,this.m=this.name=De,this.t=this.source=Je,this.execution=Ye,ut=rt):(this.target=re,this.m=this.name=De,this.t=this.source=Je,this.execution=Ye,ut=rt),typeof ut=="string"?(this.o=[ut],this.q=!0):Array.isArray(ut)?(this.o=ut,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(M){this.h=M}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof He?this.k={type:l.e,id:this.n.computeId()}:this.n instanceof We?this.k={type:l.f,id:this.n.computeId()}:this.n instanceof Dt?this.k={type:l.c,id:this.n.computeId()}:this.k={type:l.g,id:(0,R.$5e)()}}get definition(){return this.k}set definition(M){if(M==null)throw(0,L.$5)("Kind can't be undefined or null");this.y(),this.k=M}get scope(){return this.l}set target(M){this.y(),this.l=M}get name(){return this.m}set name(M){if(typeof M!="string")throw(0,L.$5)("name");this.y(),this.m=M}get execution(){return this.n}set execution(M){M===null&&(M=void 0),this.y(),this.n=M;const re=this.k.type;(l.g===re||l.e===re||l.f===re||l.c===re)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(M){if(Array.isArray(M))this.y(),this.o=M,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.y(),this.r=M}get source(){return this.t}set source(M){if(typeof M!="string"||M.length===0)throw(0,L.$5)("source must be a string of length > 0");this.y(),this.t=M}get group(){return this.u}set group(M){M===null&&(M=void 0),this.y(),this.u=M}get detail(){return this.x}set detail(M){M===null&&(M=void 0),this.x=M}get presentationOptions(){return this.v}set presentationOptions(M){M==null&&(M=Object.create(null)),this.y(),this.v=M}get runOptions(){return this.w}set runOptions(M){M==null&&(M=Object.create(null)),this.y(),this.w=M}};e.$lK=St,e.$lK=St=l=qe([A],St);var pt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(pt||(e.ProgressLocation=pt={}));var mt;(function(j){function M(re){const De=re;return(0,k.$me)(De.value)?De.tooltip&&!(0,k.$ie)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}j.isViewBadge=M})(mt||(e.ViewBadge=mt={}));let lt=g=class{static isTreeItem(M,re){const De=M;if(De.checkboxState!==void 0){const Je=(0,k.$me)(De.checkboxState)?De.checkboxState:(0,k.$ke)(De.checkboxState)&&(0,k.$me)(De.checkboxState.state)?De.checkboxState.state:void 0,Ye=!(0,k.$me)(De.checkboxState)&&(0,k.$ke)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Je===void 0||Je!==ft.Checked&&Je!==ft.Unchecked||Ye!==void 0&&!(0,k.$ie)(Ye))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(M instanceof g)return!0;if(De.label!==void 0&&!(0,k.$ie)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,k.$ie)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,k.$ie)(De.iconPath)&&!$.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,k.$ie)(De.iconPath.id))){const Je=De.iconPath;if(!Je||!(0,k.$ie)(Je.light)&&!$.URI.isUri(Je.light)&&!(0,k.$ie)(Je.dark)&&!$.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,k.$ie)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!$.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,k.$ie)(De.tooltip)&&!(De.tooltip instanceof Ke)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<$t.None&&De.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,k.$ie)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(M,re=$t.None){this.collapsibleState=re,$.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.$mK=lt,e.$mK=lt=g=qe([A],lt);var $t;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var ft;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(ft||(e.TreeItemCheckboxState=ft={}));let Zt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M){this.value=M}};e.$nK=Zt,e.$nK=Zt=qe([A],Zt);class Bt extends Zt{}e.$oK=Bt;class Qi extends Bt{#e;constructor(M){super(""),this.#e=M}asFile(){return this.#e}}e.$pK=Qi;class hi{constructor(M,re,De,Je){this.name=M,this.uri=re,this._itemId=De,this.c=Je}data(){return this.c()}}e.$qK=hi;let di=class{#e=new Map;constructor(M){for(const[re,De]of M??[]){const Je=this.#e.get(this.#t(re));Je?Je.push(De):this.#e.set(this.#t(re),[De])}}get(M){return this.#e.get(this.#t(M))?.[0]}set(M,re){this.#e.set(this.#t(M),[re])}forEach(M,re){for(const[De,Je]of this.#e)for(const Ye of Je)M.call(re,Ye,De,this)}*[Symbol.iterator](){for(const[M,re]of this.#e)for(const De of re)yield[M,De]}#t(M){return M.toLowerCase()}};e.$rK=di,e.$rK=di=qe([A],di);let It=class{constructor(M){this.insertText=M}};e.$sK=It,e.$sK=It=qe([A],It);let yi=class{constructor(M,re,De){this.id=re,this.label=De,this.insertText=M}};e.$tK=yi,e.$tK=yi=qe([A],yi);let Kt=class{constructor(M,re){this.id=M,this.color=re}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.$uK=Kt,e.$uK=Kt=qe([A],Kt),Kt.File=new Kt("file"),Kt.Folder=new Kt("folder");let Et=class{constructor(M){this.id=M}};e.$vK=Et,e.$vK=Et=qe([A],Et);var Ei;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ei||(e.ConfigurationTarget=Ei={}));let fi=class{get base(){return this.c}set base(M){this.c=M,this.e=$.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,re){if(typeof M!="string"&&(!M||!$.URI.isUri(M)&&!$.URI.isUri(M.uri)))throw(0,L.$5)("base");if(typeof re!="string")throw(0,L.$5)("pattern");typeof M=="string"?this.baseUri=$.URI.file(M):$.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$wK=fi,e.$wK=fi=qe([A],fi);const ai=new WeakMap;function _i(j,M){ai.set(j,M)}e.$xK=_i;let ni=class{constructor(M,re,De,Je){this.enabled=typeof M=="boolean"?M:!0,typeof re=="string"&&(this.condition=re),typeof De=="string"&&(this.hitCondition=De),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=ai.get(this)??(0,R.$5e)()),this.c}};e.$yK=ni,e.$yK=ni=qe([A],ni);let At=class extends ni{constructor(M,re,De,Je,Ye){if(super(re,De,Je,Ye),M===null)throw(0,L.$5)("location");this.location=M}};e.$zK=At,e.$zK=At=qe([A],At);let gi=class extends ni{constructor(M,re,De,Je,Ye){super(re,De,Je,Ye),this.functionName=M}};e.$AK=gi,e.$AK=gi=qe([A],gi);let ki=class extends ni{constructor(M,re,De,Je,Ye,rt,ut){if(super(Je,Ye,rt,ut),!re)throw(0,L.$5)("dataId");this.label=M,this.dataId=re,this.canPersist=De}};e.$BK=ki,e.$BK=ki=qe([A],ki);let ri=class{constructor(M,re,De){this.command=M,this.args=re||[],this.options=De}};e.$CK=ri,e.$CK=ri=qe([A],ri);let si=class{constructor(M,re){this.port=M,this.host=re}};e.$DK=si,e.$DK=si=qe([A],si);let at=class{constructor(M){this.path=M}};e.$EK=at,e.$EK=at=qe([A],at);let Di=class{constructor(M){this.implementation=M}};e.$FK=Di,e.$FK=Di=qe([A],Di);let Ht=class{constructor(M,re,De){this.session=M,this.threadId=re,this.frameId=De}};e.$GK=Ht,e.$GK=Ht=qe([A],Ht);let xt=class{constructor(M,re){this.session=M,this.threadId=re}};e.$HK=xt,e.$HK=xt=qe([A],xt);let mi=class{constructor(M,re){this.range=M,this.expression=re}};e.$IK=mi,e.$IK=mi=qe([A],mi);var Oi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Oi||(e.InlineCompletionTriggerKind=Oi={}));let Si=class{constructor(M,re){this.range=M,this.text=re}};e.$JK=Si,e.$JK=Si=qe([A],Si);let Ii=class{constructor(M,re,De=!0){this.range=M,this.variableName=re,this.caseSensitiveLookup=De}};e.$KK=Ii,e.$KK=Ii=qe([A],Ii);let $i=class{constructor(M,re){this.range=M,this.expression=re}};e.$LK=$i,e.$LK=$i=qe([A],$i);let Ci=class{constructor(M,re){this.frameId=M,this.stoppedLocation=re}};e.$MK=Ci,e.$MK=Ci=qe([A],Ci);var Pi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let ei=v=class extends Error{static FileExists(M){return new v(M,c.FileSystemProviderErrorCode.FileExists,v.FileExists)}static FileNotFound(M){return new v(M,c.FileSystemProviderErrorCode.FileNotFound,v.FileNotFound)}static FileNotADirectory(M){return new v(M,c.FileSystemProviderErrorCode.FileNotADirectory,v.FileNotADirectory)}static FileIsADirectory(M){return new v(M,c.FileSystemProviderErrorCode.FileIsADirectory,v.FileIsADirectory)}static NoPermissions(M){return new v(M,c.FileSystemProviderErrorCode.NoPermissions,v.NoPermissions)}static Unavailable(M){return new v(M,c.FileSystemProviderErrorCode.Unavailable,v.Unavailable)}constructor(M,re=c.FileSystemProviderErrorCode.Unknown,De){super($.URI.isUri(M)?M.toString(!0):M),this.code=De?.name??"Unknown",(0,c.$5j)(this,re),Object.setPrototypeOf(this,v.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$NK=ei,e.$NK=ei=v=qe([A],ei);let Ai=class{constructor(M,re,De){this.start=M,this.end=re,this.kind=De}};e.$OK=Ai,e.$OK=Ai=qe([A],Ai);var pi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(pi||(e.FoldingRangeKind=pi={}));var bi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(bi||(e.CommentThreadCollapsibleState=bi={}));var Ui;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Ui||(e.CommentMode=Ui={}));var ji;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(ji||(e.CommentState=ji={}));var oi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(oi||(e.CommentThreadState=oi={}));class xi{constructor(M,re=[]){this.tokenTypes=M,this.tokenModifiers=re}}e.$PK=xi;function en(j){return typeof j>"u"||(0,k.$je)(j)}class Ri{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,M){this.l=!0;for(let re=0,De=M.tokenTypes.length;re<De;re++)this.j.set(M.tokenTypes[re],re);for(let re=0,De=M.tokenModifiers.length;re<De;re++)this.k.set(M.tokenModifiers[re],re)}}push(M,re,De,Je,Ye){if(typeof M=="number"&&typeof re=="number"&&typeof De=="number"&&typeof Je=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.n(M,re,De,Je,Ye);if(O.isRange(M)&&typeof re=="string"&&en(De))return this.m(M,re,De);throw(0,L.$5)()}m(M,re,De){if(!this.l)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const Je=M.start.line,Ye=M.start.character,rt=M.end.character-M.start.character,ut=this.j.get(re);let Nt=0;if(De)for(const qt of De){if(!this.k.has(qt))throw new Error("`tokenModifier` is not in the provided legend");const Yt=this.k.get(qt);Nt|=1<<Yt>>>0}this.n(Je,Ye,rt,ut,Nt)}n(M,re,De,Je,Ye){if(this.f&&(M<this.c||M===this.c&&re<this.e)){this.f=!1;const Nt=this.g.length/5|0;let qt=0,Yt=0;for(let _t=0;_t<Nt;_t++){let ti=this.g[5*_t],zi=this.g[5*_t+1];ti===0?(ti=qt,zi+=Yt):ti+=qt,this.g[5*_t]=ti,this.g[5*_t+1]=zi,qt=ti,Yt=zi}}let rt=M,ut=re;this.f&&this.h>0&&(rt-=this.c,rt===0&&(ut-=this.e)),this.g[this.h++]=rt,this.g[this.h++]=ut,this.g[this.h++]=De,this.g[this.h++]=Je,this.g[this.h++]=Ye,this.c=M,this.e=re}static o(M){const re=[],De=M.length/5|0;for(let ut=0;ut<De;ut++)re[ut]=ut;re.sort((ut,Nt)=>{const qt=M[5*ut],Yt=M[5*Nt];if(qt===Yt){const _t=M[5*ut+1],ti=M[5*Nt+1];return _t-ti}return qt-Yt});const Je=new Uint32Array(M.length);let Ye=0,rt=0;for(let ut=0;ut<De;ut++){const Nt=5*re[ut],qt=M[Nt+0],Yt=M[Nt+1],_t=M[Nt+2],ti=M[Nt+3],zi=M[Nt+4],yn=qt-Ye,Nn=yn===0?Yt-rt:Yt,Ni=5*ut;Je[Ni+0]=yn,Je[Ni+1]=Nn,Je[Ni+2]=_t,Je[Ni+3]=ti,Je[Ni+4]=zi,Ye=qt,rt=Yt}return Je}build(M){return this.f?new Qt(new Uint32Array(this.g),M):new Qt(Ri.o(this.g),M)}}e.$QK=Ri;class Qt{constructor(M,re){this.resultId=re,this.data=M}}e.$RK=Qt;class tn{constructor(M,re,De){this.start=M,this.deleteCount=re,this.data=De}}e.$SK=tn;class nn{constructor(M,re){this.resultId=re,this.edits=M}}e.$TK=nn;var Fi;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Fi||(e.DebugConsoleMode=Fi={}));let Li=class{static{this.Back={iconPath:new Kt("arrow-left")}}constructor(){}};e.$UK=Li,e.$UK=Li=qe([A],Li);var Bi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Bi||(e.QuickPickItemKind=Bi={}));var Wi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Wi||(e.InputBoxValidationSeverity=Wi={}));var vi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(vi||(e.ExtensionKind=vi={}));class Vi{static validate(M){if(typeof M.badge=="string"){let re=(0,d.$Vd)(M.badge,0);if(re<M.badge.length&&(re+=(0,d.$Vd)(M.badge,re)),M.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!Kt.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,re,De){this.badge=M,this.tooltip=re,this.color=De}}e.$VK=Vi;let Me=class{constructor(M){this.kind=M}};e.$WK=Me,e.$WK=Me=qe([A],Me);var Gt;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Gt||(e.ColorThemeKind=Gt={}));class Xt{static isNotebookRange(M){return M instanceof Xt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,re){if(M<0)throw(0,L.$5)("start must be positive");if(re<0)throw(0,L.$5)("end must be positive");M<=re?(this.c=M,this.e=re):(this.c=re,this.e=M)}with(M){let re=this.c,De=this.e;return M.start!==void 0&&(re=M.start),M.end!==void 0&&(De=M.end),re===this.c&&De===this.e?this:new Xt(re,De)}}e.$XK=Xt;class dt{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(re=>dt.isNotebookCellData(re))}static isNotebookCellData(M){return!0}constructor(M,re,De,Je,Ye,rt,ut){this.kind=M,this.value=re,this.languageId=De,this.mime=Je,this.outputs=Ye??[],this.metadata=rt,this.executionSummary=ut,dt.validate(this)}}e.$YK=dt;class rn{constructor(M){this.cells=M}}e.$ZK=rn;class Vt{static isNotebookCellOutputItem(M){return M instanceof Vt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const re={name:M.name,message:M.message,stack:M.stack};return Vt.json(re,"application/vnd.code.notebook.error")}static stdout(M){return Vt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Vt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,re="application/octet-stream"){return new Vt(M,re)}static#e=new TextEncoder;static text(M,re=P.$sr.text){const De=Vt.#e.encode(String(M));return new Vt(De,re)}static json(M,re="text/x-json"){const De=JSON.stringify(M,void 0,"	");return Vt.text(De,re)}constructor(M,re){this.data=M,this.mime=re;const De=(0,P.$wr)(re,!0);if(!De)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$1K=Vt;class ci{static isNotebookCellOutput(M){return M instanceof ci?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,re=!1){const De=new Set,Je=new Set;for(let Ye=0;Ye<M.length;Ye++){const rt=M[Ye],ut=(0,P.$wr)(rt.mime);if(!De.has(ut)||(0,b.$EH)(ut)){De.add(ut);continue}Je.add(Ye),re&&console.warn(`DUPLICATED mime type '${rt.mime}' will be dropped`)}return Je.size===0?M:M.filter((Ye,rt)=>!Je.has(rt))}constructor(M,re,De){this.items=ci.ensureUniqueMimeTypes(M,!0),typeof re=="string"?(this.id=re,this.metadata=De):(this.id=(0,R.$5e)(),this.metadata=re??De)}}e.$2K=ci;var qi;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(qi||(e.NotebookCellKind=qi={}));var ui;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(ui||(e.NotebookCellExecutionState=ui={}));var Ji;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ji||(e.NotebookCellStatusBarAlignment=Ji={}));var Ki;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ki||(e.NotebookEditorRevealType=Ki={}));class sn{constructor(M,re){this.text=M,this.alignment=re}}e.$3K=sn;var Ti;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Ti||(e.NotebookControllerAffinity=Ti={}));var Hi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(Hi||(e.NotebookControllerAffinity2=Hi={}));class on{constructor(M,re=[]){this.uri=M,this.provides=(0,w.$If)(re)}}e.$4K=on;class an{constructor(M){this.label=M}}e.$5K=an;let Mi=class{constructor(M,re){this.label=M,this.timestamp=re}};e.$6K=Mi,e.$6K=Mi=qe([A],Mi);var Gi;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Gi||(e.ExtensionMode=Gi={}));var Xi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Xi||(e.ExtensionRuntime=Xi={}));var Yi;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Yi||(e.StandardTokenType=Yi={}));class cn{constructor(M,re){this.ranges=M,this.wordPattern=re}}e.$7K=cn;class un{constructor(M){this.c=M}get autoForwardAction(){return this.c}}e.$8K=un;var te;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(te||(e.TestResultState=te={}));var ge;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ge||(e.TestRunProfileKind=ge={}));let Te=class{constructor(M=void 0,re=void 0,De=void 0,Je=!1){this.include=M,this.exclude=re,this.profile=De,this.continuous=Je}};e.$9K=Te,e.$9K=Te=qe([A],Te);let it=class extends Te{};e.$0K=it,e.$0K=it=qe([A],it);let vt=u=class{static diff(M,re,De){const Je=new u(M);return Je.expectedOutput=re,Je.actualOutput=De,Je}constructor(M){this.message=M}};e.$$K=vt,e.$$K=vt=u=qe([A],vt);let Ct=class{constructor(M){this.id=M}};e.$_K=Ct,e.$_K=Ct=qe([A],Ct);let wi=class{constructor(M,re){this.covered=M,this.total=re}};e.$aL=wi,e.$aL=wi=qe([A],wi);let ln=f=class{static fromDetails(M,re){const De=new wi(0,0),Je=new wi(0,0),Ye=new wi(0,0);for(const ut of re)if("branches"in ut){De.total+=1,De.covered+=ut.executionCount>0?1:0;for(const Nt of ut.branches)Je.total+=1,Je.covered+=Nt.executionCount>0?1:0}else Ye.total+=1,Ye.covered+=ut.executionCount>0?1:0;const rt=new f(M,De,Je.total>0?Je:void 0,Ye.total>0?Ye:void 0);return rt.detailedCoverage=re,rt}constructor(M,re,De,Je){this.uri=M,this.statementCoverage=re,this.branchCoverage=De,this.functionCoverage=Je}};e.$bL=ln,e.$bL=ln=f=qe([A],ln);let hn=class{constructor(M,re,De=[]){this.executionCount=M,this.location=re,this.branches=De}};e.$cL=hn,e.$cL=hn=qe([A],hn);let dn=class{constructor(M,re){this.executionCount=M,this.location=re}};e.$dL=dn,e.$dL=dn=qe([A],dn);let fn=class{constructor(M,re){this.executionCount=M,this.location=re}};e.$eL=fn,e.$eL=fn=qe([A],fn);var mn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(mn||(e.ExternalUriOpenerPriority=mn={}));var $n;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})($n||(e.WorkspaceTrustState=$n={}));var pn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(pn||(e.PortAutoForwardAction=pn={}));class In{constructor(M,re,De,Je,Ye,rt){this.kind=M,this.name=re,this.detail=De,this.uri=Je,this.range=Ye,this.selectionRange=rt}}e.$fL=In;class Cn{constructor(M){this.uri=M}}e.$gL=Cn;class Pn{constructor(M,re){this.original=M,this.modified=re}}e.$hL=Pn;class An{constructor(M,re,De,Je){this.base=M,this.input1=re,this.input2=De,this.result=Je}}e.$iL=An;class Rn{constructor(M,re){this.uri=M,this.viewType=re}}e.$jL=Rn;class Fn{constructor(M){this.viewType=M}}e.$kL=Fn;class Ln{constructor(M,re){this.uri=M,this.notebookType=re}}e.$lL=Ln;class Tn{constructor(M,re,De){this.original=M,this.modified=re,this.notebookType=De}}e.$mL=Tn;class Mn{constructor(){}}e.$nL=Mn;class zn{constructor(M,re){this.uri=M,this.inputBoxUri=re}}e.$oL=zn;var bn;(function(j){j[j.Up=1]="Up",j[j.Down=2]="Down"})(bn||(e.InteractiveSessionVoteDirection=bn={}));var vn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(vn||(e.InteractiveSessionCopyKind=vn={}));var wn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted"})(wn||(e.InteractiveEditorResponseFeedbackKind=wn={}))}),define(Ae[100],Re([1,0,50,13,15,273,136,7,18]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DL=e.$CL=e.$BL=void 0;const $=new Map;function R(b,o){o?$.set(b,o):$.delete(b)}e.$BL=R;function E(b){return $.get(b)}class c extends z.$uu{constructor(o,t,i,a,m,S,C,r){super(t,i,a,m),this.c=o,this.m=S,this.q=C,this.notebook=r,this.b=!1}dispose(){(0,w.ok)(!this.b),this.b=!0,this.q=!1}equalLines(o){return(0,k.$af)(this.f,o)}get document(){if(!this.a){const o=this;this.a={get uri(){return o.d},get fileName(){return o.d.fsPath},get isUntitled(){return o.d.scheme===L.Schemas.untitled},get languageId(){return o.m},get version(){return o.h},get isClosed(){return o.b},get isDirty(){return o.q},save(){return o.r()},getText(t){return t?o.s(t):o.getText()},get eol(){return o.g===`
`?d.EndOfLine.LF:d.EndOfLine.CRLF},get lineCount(){return o.f.length},lineAt(t){return o.t(t)},offsetAt(t){return o.u(t)},positionAt(t){return o.v(t)},validateRange(t){return o.w(t)},validatePosition(t){return o.x(t)},getWordRangeAtPosition(t,i){return o.y(t,i)}}}return Object.freeze(this.a)}_acceptLanguageId(o){(0,w.ok)(!this.b),this.m=o}_acceptIsDirty(o){(0,w.ok)(!this.b),this.q=o}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(o){const t=this.w(o);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const i=this.g,a=t.start.line,m=t.end.line,S=[];S.push(this.f[a].substring(t.start.character));for(let C=a+1;C<m;C++)S.push(this.f[C]);return S.push(this.f[m].substring(0,t.end.character)),S.join(i)}t(o){let t;if(o instanceof d.$AJ?t=o.line:typeof o=="number"&&(t=o),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new y(t,this.f[t],t===this.f.length-1)}u(o){return o=this.x(o),this.l(),this.j.getPrefixSum(o.line-1)+o.character}v(o){o=Math.floor(o),o=Math.max(0,o),this.l();const t=this.j.getIndexOf(o),i=this.f[t.index].length;return new d.$AJ(t.index,Math.min(t.remainder,i))}w(o){if(!(o instanceof d.$BJ))throw new Error("Invalid argument");const t=this.x(o.start),i=this.x(o.end);return t===o.start&&i===o.end?o:new d.$BJ(t.line,t.character,i.line,i.character)}x(o){if(!(o instanceof d.$AJ))throw new Error("Invalid argument");if(this.f.length===0)return o.with(0,0);let{line:t,character:i}=o,a=!1;if(t<0)t=0,i=0,a=!0;else if(t>=this.f.length)t=this.f.length-1,i=this.f[t].length,a=!0;else{const m=this.f[t].length;i<0?(i=0,a=!0):i>m&&(i=m,a=!0)}return a?new d.$AJ(t,i):o}y(o,t){const i=this.x(o);if(!t)t=E(this.m);else if((0,I.$wd)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const a=(0,P.$Kr)(i.character+1,(0,P.$Ir)(t),this.f[i.line],0);if(a)return new d.$BJ(i.line,a.startColumn-1,i.line,a.endColumn-1)}}e.$CL=c;class y{constructor(o,t,i){this.a=o,this.b=t,this.c=i}get lineNumber(){return this.a}get text(){return this.b}get range(){return new d.$BJ(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new d.$BJ(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$DL=y}),define(Ae[197],Re([1,0,7,17,5]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iac=void 0;let z=class{constructor(d){this.a=new w.$WK(w.ColorThemeKind.Dark),this.b=new I.$7c}get activeColorTheme(){return this.a}$onColorThemeChange(d){let k;switch(d){case"light":k=w.ColorThemeKind.Light;break;case"hcDark":k=w.ColorThemeKind.HighContrast;break;case"hcLight":k=w.ColorThemeKind.HighContrastLight;break;default:k=w.ColorThemeKind.Dark}this.a=new w.$WK(k),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$iac=z,e.$iac=z=qe([Ve(0,L.$zL)],z)}),define(Ae[198],Re([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IH=e.CellExecutionUpdateType=void 0;var L;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(L||(e.CellExecutionUpdateType=L={})),e.$IH=(0,w.$nh)("INotebookExecutionService")}),define(Ae[45],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jI=e.TestPosition=e.TestIdPathParts=void 0;var w;(function(z){z.Delimiter="\0"})(w||(e.TestIdPathParts=w={}));var L;(function(z){z[z.IsSame=0]="IsSame",z[z.Disconnected=1]="Disconnected",z[z.IsChild=2]="IsChild",z[z.IsParent=3]="IsParent"})(L||(e.TestPosition=L={}));class I{static fromExtHostTestItem(P,d,k=P.parent){if(P._isRoot)return new I([d]);const $=[P.id];for(let R=k;R&&R.id!==d;R=R.parent)$.push(R.id);return $.push(d),new I($.reverse())}static isRoot(P){return!P.includes("\0")}static root(P){const d=P.indexOf("\0");return d===-1?P:P.slice(0,d)}static fromString(P){return new I(P.split("\0"))}static join(P,d){return new I([...P.path,d])}static joinToString(P,d){return P.toString()+"\0"+d}static parentId(P){const d=P.lastIndexOf("\0");return d===-1?void 0:P.slice(0,d)}static localId(P){const d=P.lastIndexOf("\0");return d===-1?P:P.slice(d+1)}static isChild(P,d){return d.startsWith(P)&&d[P.length]==="\0"}static compare(P,d){return P===d?0:I.isChild(P,d)?2:I.isChild(d,P)?3:1}constructor(P,d=P.length){if(this.path=P,this.d=d,P.length===0||d<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let P=1;P<=this.d;P++)yield new I(this.path,P)}*idsToRoot(){for(let P=this.d;P>0;P--)yield new I(this.path,P)}compare(P){if(typeof P=="string")return I.compare(this.toString(),P);for(let d=0;d<P.d&&d<this.d;d++)if(P.path[d]!==this.path[d])return 1;return P.d>this.d?2:P.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let P=1;P<this.d;P++)this.c+="\0",this.c+=this.path[P]}return this.c}}e.$jI=I}),define(Ae[57],Re([1,0,2,44,45]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qI=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.$pI=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$oI=e.$nI=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$mI=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$lI=e.$kI=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var z;(function(g){g[g.Unset=0]="Unset",g[g.Queued=1]="Queued",g[g.Running=2]="Running",g[g.Passed=3]="Passed",g[g.Failed=4]="Failed",g[g.Skipped=5]="Skipped",g[g.Errored=6]="Errored"})(z||(e.TestResultState=z={}));var P;(function(g){g[g.Run=1]="Run",g[g.Debug=2]="Debug",g[g.Coverage=3]="Coverage"})(P||(e.ExtTestRunProfileKind=P={}));var d;(function(g){g[g.Run=2]="Run",g[g.Debug=4]="Debug",g[g.Coverage=8]="Coverage",g[g.HasNonDefaultProfile=16]="HasNonDefaultProfile",g[g.HasConfigurable=32]="HasConfigurable",g[g.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.$kI=[2,4,8,16,32,64];const k=g=>"runId"in g;e.$lI=k;var $;(function(g){g.serialize=v=>({range:v.range.toJSON(),uri:v.uri.toJSON()}),g.deserialize=v=>({range:L.$Mr.lift(v.range),uri:w.URI.revive(v.uri)})})($||(e.IRichLocation=$={}));var R;(function(g){g[g.Error=0]="Error",g[g.Output=1]="Output"})(R||(e.TestMessageType=R={}));var E;(function(g){g.serialize=v=>({message:v.message,type:0,expected:v.expected,actual:v.actual,location:v.location&&$.serialize(v.location)}),g.deserialize=v=>({message:v.message,type:0,expected:v.expected,actual:v.actual,location:v.location&&$.deserialize(v.location)})})(E||(e.ITestErrorMessage=E={}));const c=(g,v)=>`${v?"s":"e"}${g}`;e.$mI=c;var y;(function(g){g.serialize=v=>({message:v.message,type:1,offset:v.offset,length:v.length,location:v.location&&$.serialize(v.location)}),g.deserialize=v=>({message:v.message,type:1,offset:v.offset,length:v.length,location:v.location&&$.deserialize(v.location)})})(y||(e.ITestOutputMessage=y={}));var b;(function(g){g.serialize=v=>v.type===0?E.serialize(v):y.serialize(v),g.deserialize=v=>v.type===0?E.deserialize(v):y.deserialize(v)})(b||(e.ITestMessage=b={}));var o;(function(g){g.serializeWithoutMessages=v=>({state:v.state,duration:v.duration,messages:[]}),g.serialize=v=>({state:v.state,duration:v.duration,messages:v.messages.map(b.serialize)}),g.deserialize=v=>({state:v.state,duration:v.duration,messages:v.messages.map(b.deserialize)})})(o||(e.ITestTaskState=o={}));const t="\0",i=(g,v)=>g+t+v;e.$nI=i;const a=g=>{const v=g.indexOf(t);return{ctrlId:g.slice(0,v),tagId:g.slice(v+1)}};e.$oI=a;var m;(function(g){g.serialize=v=>({extId:v.extId,label:v.label,tags:v.tags,busy:v.busy,children:void 0,uri:v.uri?.toJSON(),range:v.range?.toJSON()||null,description:v.description,error:v.error,sortText:v.sortText}),g.deserialize=v=>({extId:v.extId,label:v.label,tags:v.tags,busy:v.busy,children:void 0,uri:v.uri?w.URI.revive(v.uri):void 0,range:v.range?L.$Mr.lift(v.range):null,description:v.description,error:v.error,sortText:v.sortText})})(m||(e.ITestItem=m={}));var S;(function(g){g[g.NotExpandable=0]="NotExpandable",g[g.Expandable=1]="Expandable",g[g.BusyExpanding=2]="BusyExpanding",g[g.Expanded=3]="Expanded"})(S||(e.TestItemExpandState=S={}));var C;(function(g){g.serialize=v=>({expand:v.expand,item:m.serialize(v.item)}),g.deserialize=v=>({controllerId:I.$jI.root(v.item.extId),expand:v.expand,item:m.deserialize(v.item)})})(C||(e.InternalTestItem=C={}));var r;(function(g){g.serialize=v=>{let u;return v.item&&(u={},v.item.label!==void 0&&(u.label=v.item.label),v.item.tags!==void 0&&(u.tags=v.item.tags),v.item.busy!==void 0&&(u.busy=v.item.busy),v.item.uri!==void 0&&(u.uri=v.item.uri?.toJSON()),v.item.range!==void 0&&(u.range=v.item.range?.toJSON()),v.item.description!==void 0&&(u.description=v.item.description),v.item.error!==void 0&&(u.error=v.item.error),v.item.sortText!==void 0&&(u.sortText=v.item.sortText)),{extId:v.extId,expand:v.expand,item:u}},g.deserialize=v=>{let u;return v.item&&(u={},v.item.label!==void 0&&(u.label=v.item.label),v.item.tags!==void 0&&(u.tags=v.item.tags),v.item.busy!==void 0&&(u.busy=v.item.busy),v.item.range!==void 0&&(u.range=v.item.range?L.$Mr.lift(v.item.range):null),v.item.description!==void 0&&(u.description=v.item.description),v.item.error!==void 0&&(u.error=v.item.error),v.item.sortText!==void 0&&(u.sortText=v.item.sortText)),{extId:v.extId,expand:v.expand,item:u}}})(r||(e.ITestItemUpdate=r={}));const h=(g,v)=>{v.expand!==void 0&&(g.expand=v.expand),v.item!==void 0&&(g.item=g.item?Object.assign(g.item,v.item):v.item)};e.$pI=h;var n;(function(g){g.serializeWithoutMessages=v=>({...C.serialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(o.serializeWithoutMessages)}),g.serialize=v=>({...C.serialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(o.serialize)}),g.deserialize=v=>({...C.deserialize(v),ownComputedState:v.ownComputedState,computedState:v.computedState,tasks:v.tasks.map(o.deserialize),retired:!0})})(n||(e.TestResultItem=n={}));var s;(function(g){g[g.Function=0]="Function",g[g.Statement=1]="Statement"})(s||(e.DetailType=s={}));var p;(function(g){g[g.Add=0]="Add",g[g.Update=1]="Update",g[g.DocumentSynced=2]="DocumentSynced",g[g.Remove=3]="Remove",g[g.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",g[g.Retire=5]="Retire",g[g.AddTag=6]="AddTag",g[g.RemoveTag=7]="RemoveTag"})(p||(e.TestDiffOpType=p={}));var D;(function(g){g.deserialize=v=>v.op===0?{op:v.op,item:C.deserialize(v.item)}:v.op===1?{op:v.op,item:r.deserialize(v.item)}:v.op===2?{op:v.op,uri:w.URI.revive(v.uri),docv:v.docv}:v,g.serialize=v=>v.op===0?{op:v.op,item:C.serialize(v.item)}:v.op===1?{op:v.op,item:r.serialize(v.item)}:v})(D||(e.TestsDiffOp=D={}));class l{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(v){const u=this.o();for(const f of v)switch(f.op){case 0:this.j(C.deserialize(f.item),u);break;case 1:this.k(r.deserialize(f.item),u);break;case 3:this.l(f.itemId,u);break;case 5:this.m(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this.c.set(f.tag.id,f.tag);break;case 7:this.c.delete(f.id);break}u.complete?.()}j(v,u){const f=I.$jI.parentId(v.item.extId)?.toString();let A;if(!f)A=this.p(v),this.f.add(A),this.d.set(v.item.extId,A);else if(this.d.has(f)){const W=this.d.get(f);W.children.add(v.item.extId),A=this.p(v,W),this.d.set(v.item.extId,A)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(v)}`);return}return u.add?.(A),v.expand===2&&this.g++,A}k(v,u){const f=this.d.get(v.extId);if(f)return v.expand!==void 0&&(f.expand===2&&this.g--,v.expand===2&&this.g++),(0,e.$pI)(f,v),u.update?.(f),f}l(v,u){const f=this.d.get(v);if(!f)return;const A=I.$jI.parentId(f.item.extId)?.toString();A?this.d.get(A).children.delete(f.item.extId):this.f.delete(f);const W=[[v]];for(;W.length;)for(const B of W.pop()){const V=this.d.get(B);V&&(W.push(V.children),this.d.delete(B),u.remove?.(V,V!==f),V.expand===2&&this.g--)}}m(v){}updatePendingRoots(v){this.h+=v}o(){return{}}}e.$qI=l}),define(Ae[76],Re([1,0,16,5,6,50,57,45]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.TestItemEventOp=void 0;var k;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk",a[a.DocumentSynced=6]="DocumentSynced"})(k||(e.TestItemEventOp=k={}));const $=(a,m)=>a===m,E=Object.entries({range:(a,m)=>a===m?!0:!a||!m?!1:a.equalsRange(m),busy:$,label:$,description:$,error:$,sortText:$,tags:(a,m)=>!(a.length!==m.length||a.some(S=>!m.includes(S)))}),c=(a,m)=>{let S;for(const[C,r]of E)r(a[C],m[C])||(S?S[C]=m[C]:S={[C]:m[C]});return S};class y extends I.$lb{get root(){return this.m.root}constructor(m){super(),this.m=m,this.f=this.B(new w.$Eg(()=>this.flushDiff(),200)),this.g=this.B(new L.$7c),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(m){this.h=m;for(const S of this.tree.values())this.G(S)}get resolveHandler(){return this.h}collectDiff(){const m=this.k;return this.k=[],m}pushDiff(m){switch(m.op){case 2:{for(const S of this.k)if(S.op===2&&S.uri===m.uri){S.docv=m.docv;return}break}case 1:{const S=this.k[this.k.length-1];if(S){if(S.op===1&&S.item.extId===m.item.extId){(0,P.$pI)(S.item,m.item);return}if(S.op===0&&S.item.item.extId===m.item.extId){(0,P.$pI)(S.item,m.item);return}}break}}this.k.push(m),this.f.isScheduled()||this.f.schedule()}expand(m,S){const C=this.tree.get(m);if(C){if((C.expandLevels===void 0||S>C.expandLevels)&&(C.expandLevels=S),C.expand===1){const r=this.I(C);return r.isOpen()?this.H(C,S-1):r.wait().then(()=>this.H(C,S-1))}else if(C.expand===3)return C.resolveBarrier?.isOpen()===!1?C.resolveBarrier.wait().then(()=>this.H(C,S-1)):this.H(C,S-1)}}dispose(){for(const m of this.tree.values())this.m.getApiFor(m.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(m,S){switch(S.op){case 3:this.L(d.$jI.joinToString(m.fullId,S.id));break;case 0:this.u(S.item,m);break;case 5:for(const C of S.ops)this.p(m,C);break;case 1:this.w(S.new,S.old,m.fullId.toString());break;case 2:this.G(m);break;case 4:this.pushDiff({op:1,item:{extId:m.fullId.toString(),item:S.update}});break;case 6:this.s(m.actual.uri);break;default:(0,z.$nc)(S)}}s(m){m&&this.pushDiff({op:2,uri:m,docv:this.m.getDocumentVersion(m)})}u(m,S){const C=d.$jI.fromExtHostTestItem(m,this.root.id,S?.actual),r=this.m.getApiFor(m);r.parent&&r.parent!==S?.actual&&this.m.getChildren(r.parent).delete(m.id);let h=this.tree.get(C.toString());if(!h){h={fullId:C,actual:m,expandLevels:S?.expandLevels?S.expandLevels-1:void 0,expand:0},m.tags.forEach(this.y,this),this.tree.set(h.fullId.toString(),h),this.C(m,S),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:h.expand,item:this.m.toITestItem(m)}}),this.F(m,h,S);return}if(h.actual===m){this.D(m,h,S);return}if(h.actual.uri?.toString()!==m.uri?.toString())return this.L(C.toString()),this.u(m,S);const n=this.m.getChildren(h.actual),s=h.actual,p=c(this.m.toITestItem(s),this.m.toITestItem(m));this.m.getApiFor(s).listener=void 0,h.actual=m,h.expand=0,p&&(p.hasOwnProperty("tags")&&(this.w(m.tags,s.tags,C.toString()),delete p.tags),this.p(h,{op:4,update:p})),this.F(m,h,S);for(const[D,l]of n)this.m.getChildren(m).get(l.id)||this.L(d.$jI.joinToString(C,l.id));this.s(h.actual.uri)}w(m,S,C){const r=new Set(S.map(h=>h.id));for(const h of m)r.delete(h.id)||this.y(h);this.pushDiff({op:1,item:{extId:C,item:{tags:m.map(h=>(0,P.$nI)(this.m.controllerId,h.id))}}}),r.forEach(this.z,this)}y(m){const S=this.j.get(m.id);S?S.refCount++:(this.j.set(m.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,P.$nI)(this.m.controllerId,m.id)}}))}z(m){const S=this.j.get(m);S&&!--S.refCount&&(this.j.delete(m),this.pushDiff({op:7,id:(0,P.$nI)(this.m.controllerId,m)}))}C(m,S){this.m.getApiFor(m).parent=S&&S.actual!==this.root?S.actual:void 0}D(m,S,C){this.C(m,C);const r=this.m.getApiFor(m);r.parent=C?.actual,r.listener=h=>this.p(S,h),this.G(S)}F(m,S,C){this.D(m,S,C);for(const[r,h]of this.m.getChildren(m))this.u(h,S)}G(m){let S;this.h?m.resolveBarrier?S=m.resolveBarrier.isOpen()?3:2:S=m.actual.canResolveChildren?1:0:S=0,S!==m.expand&&(m.expand=S,this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:S}}),S===1&&m.expandLevels!==void 0&&this.I(m))}H(m,S){if(S<0)return;const C=[];for(const[r,h]of this.m.getChildren(m.actual)){const n=this.expand(d.$jI.joinToString(m.fullId,h.id),S);(0,w.$gg)(n)&&C.push(n)}if(C.length)return Promise.all(C).then(()=>{})}I(m){if(m.resolveBarrier)return m.resolveBarrier;if(!this.h){const h=new w.$sg;return h.open(),h}m.expand=2,this.J(m);const S=m.resolveBarrier=new w.$sg,C=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,h)};let r;try{r=this.h(m.actual===this.root?void 0:m.actual)}catch(h){C(h)}return(0,w.$gg)(r)?r.catch(C).then(()=>{S.open(),this.G(m)}):(S.open(),this.G(m)),m.resolveBarrier}J(m){this.pushDiff({op:1,item:{extId:m.fullId.toString(),expand:m.expand}})}L(m){const S=this.tree.get(m);if(!S)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:m});const C=[S];for(;C.length;){const r=C.pop();if(r){this.m.getApiFor(r.actual).listener=void 0;for(const h of r.actual.tags)this.z(h.id);this.tree.delete(r.fullId.toString());for(const[h,n]of this.m.getChildren(r.actual))C.push(this.tree.get(d.$jI.joinToString(r.fullId,n.id)))}}}flushDiff(){const m=this.collectDiff();m.length&&this.g.fire(m)}}e.$pL=y;class b extends Error{constructor(m){super(`Attempted to insert a duplicate test item ID ${m}`)}}e.$qL=b;class o extends Error{constructor(m){super(`TestItem with ID "${m}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$rL=o;class t extends Error{constructor(m,S,C){super(`TestItem with ID "${m}" is from controller "${S}" and cannot be added as a child of an item from controller "${C}".`)}}e.$sL=t;const i=(a,m,S)=>{let C=new Map;return{get size(){return C.size},forEach(r,h){for(const n of C.values())r.call(h,n,this)},[Symbol.iterator](){return C.entries()},replace(r){const h=new Map,n=new Set(C.keys()),s={op:5,ops:[]};for(const p of r){if(!(p instanceof S))throw new o(p.id);const D=m(p).controllerId;if(D!==a.controllerId)throw new t(p.id,D,a.controllerId);if(h.has(p.id))throw new b(p.id);h.set(p.id,p),n.delete(p.id),s.ops.push({op:0,item:p})}for(const p of n.keys())s.ops.push({op:3,id:p});a.listener?.(s),C=h},add(r){if(!(r instanceof S))throw new o(r.id);C.set(r.id,r),a.listener?.({op:0,item:r})},delete(r){C.delete(r)&&a.listener?.({op:3,id:r})},get(r){return C.get(r)},toJSON(){return Array.from(C.values())}}};e.$tL=i}),define(Ae[101],Re([1,0,76]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vL=e.$uL=void 0;const L=new WeakMap,I=(P,d)=>{const k={controllerId:d};return L.set(P,k),k};e.$uL=I;const z=P=>{const d=L.get(P);if(!d)throw new w.$rL(P?.id||"<unknown>");return d};e.$vL=z}),define(Ae[77],Re([1,0,13,2]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enb=e.$dnb=e.$cnb=e.$bnb=e.$anb=void 0,e.$anb="vscode-cdn.net",e.$bnb=`vscode-resource.${e.$anb}`,e.$cnb=`'self' https://*.${e.$anb}`;function I(d,k){return d.scheme===w.Schemas.http||d.scheme===w.Schemas.https?d:(k&&k.authority&&k.isRemote&&d.scheme===w.Schemas.file&&(d=L.URI.from({scheme:w.Schemas.vscodeRemote,authority:k.authority,path:d.path})),L.URI.from({scheme:w.Schemas.https,authority:`${d.scheme}+${z(d.authority)}.${e.$bnb}`,path:d.path,fragment:d.fragment,query:d.query}))}e.$dnb=I;function z(d){return d.replace(/./g,k=>{const $=k.charCodeAt(0);return $>=97&&$<=122||$>=65&&$<=90||$>=48&&$<=57?k:"-"+$.toString(16).padStart(4,"0")})}function P(d){return d.replace(/-([0-9a-f]{4})/g,(k,$)=>String.fromCharCode(parseInt($,16)))}e.$enb=P}),define(Ae[199],Re([1,0,5,6,77]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S_b=void 0;class z{constructor(d,k,$){this.d=d,this.e=k,this.f=$,this.a=0,this.b=new L.$kb,this.c=new Map,this.b.add(k.onDidChangeVisibleTextEditors(()=>{const R=k.getVisibleTextEditors();for(const E of this.c.values())R.indexOf(E.editor)<0&&E.inset.dispose()}))}dispose(){this.c.forEach(d=>d.inset.dispose()),this.b.dispose()}createWebviewEditorInset(d,k,$,R,E){let c;for(const m of this.e.getVisibleTextEditors(!0))if(m.value===d){c=m;break}if(!c)throw new Error("not a visible editor");const y=this,b=this.a++,o=new w.$7c,t=new w.$7c,i=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(m){return(0,I.$dnb)(m,y.f)}get cspSource(){return I.$cnb}set options(m){this.b=m,y.d.$setOptions(b,m)}get options(){return this.b}set html(m){this.a=m,y.d.$setHtml(b,m)}get html(){return this.a}get onDidReceiveMessage(){return o.event}postMessage(m){return y.d.$postMessage(b,m)}},a=new class{constructor(){this.editor=d,this.line=k,this.height=$,this.webview=i,this.onDidDispose=t.event}dispose(){y.c.has(b)&&(y.c.delete(b),y.d.$disposeEditorInset(b),t.fire(),t.dispose(),o.dispose())}};return this.d.$createEditorInset(b,c.id,c.value.document.uri,k+1,$,R||{},E.identifier,E.extensionLocation),this.c.set(b,{editor:d,inset:a,onDidReceiveMessage:o}),a}$onDidDispose(d){const k=this.c.get(d);k&&k.inset.dispose()}$onDidReceiveMessage(d,k){this.c.get(d)?.onDidReceiveMessage.fire(k)}}e.$S_b=z}),define(Ae[200],Re([1,0,3]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.VariableKind=e.$lM=void 0,e.$lM=(0,w.$nh)("configurationResolverService");var L;(function(z){z.Unknown="unknown",z.Env="env",z.Config="config",z.Command="command",z.Input="input",z.ExtensionInstallFolder="extensionInstallFolder",z.WorkspaceFolder="workspaceFolder",z.Cwd="cwd",z.WorkspaceFolderBasename="workspaceFolderBasename",z.UserHome="userHome",z.LineNumber="lineNumber",z.SelectedText="selectedText",z.File="file",z.FileWorkspaceFolder="fileWorkspaceFolder",z.RelativeFile="relativeFile",z.RelativeFileDirname="relativeFileDirname",z.FileDirname="fileDirname",z.FileExtname="fileExtname",z.FileBasename="fileBasename",z.FileBasenameNoExtension="fileBasenameNoExtension",z.FileDirnameBasename="fileDirnameBasename",z.ExecPath="execPath",z.ExecInstallFolder="execInstallFolder",z.PathSeparator="pathSeparator"})(L||(e.VariableKind=L={}));class I extends Error{constructor(P,d){super(d),this.variable=P}}e.$mM=I}),define(Ae[201],Re([1,0,19,52,12,24,22,90,165,200,15]),function($e,e,w,L,I,z,P,d,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AM=void 0;class E{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(y,b,o,t){this.h=new Map,this.a=y,this.b=b,this.g=o,t&&(this.c=t.then(i=>this.i(i)))}i(y){if(P.$i){const b=Object.create(null);return Object.keys(y).forEach(o=>{b[o.toLowerCase()]=y[o]}),b}return y}resolveWithEnvironment(y,b,o){return this.l({env:this.i(y),userHome:void 0},b?b.uri:void 0,o)}async resolveAsync(y,b){const o={env:await this.c,userHome:await this.g};return this.l(o,y?y.uri:void 0,b)}async j(y,b,o,t){const i=z.$Fm(b);P.$i&&i.windows?Object.keys(i.windows).forEach(m=>i[m]=i.windows[m]):P.$j&&i.osx?Object.keys(i.osx).forEach(m=>i[m]=i.osx[m]):P.$k&&i.linux&&Object.keys(i.linux).forEach(m=>i[m]=i.linux[m]),delete i.windows,delete i.osx,delete i.linux;const a={env:await this.c,userHome:await this.g};return this.l(a,y?y.uri:void 0,i,o,t)}async resolveAnyAsync(y,b,o){return this.j(y,b,o)}async resolveAnyMap(y,b,o){const t=new Map;return{newConfig:await this.j(y,b,o,t),resolvedVariables:t}}resolveWithInteractionReplace(y,b,o,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(y,b,o,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(y,b){if(this.h.has(y))throw new Error("Variable "+y+" is contributed twice.");this.h.set(y,b)}async l(y,b,o,t,i){if(I.$ie(o))return this.m(y,b,o,t,i);if(Array.isArray(o))return Promise.all(o.map(a=>this.l(y,b,a,t,i)));if(I.$ke(o)){const a=Object.create(null),m=await Promise.all(Object.keys(o).map(async S=>[await this.m(y,b,S,t,i),await this.l(y,b,o[S],t,i)]));for(const[S,C]of m)a[S]=C;return a}return o}m(y,b,o,t,i){return(0,R.$Dd)(o,E.VARIABLE_REGEXP,async(a,m)=>{if(m.includes(E.VARIABLE_LHS))return a;let S=await this.o(y,a,m,b,t);return i?.set(m,S),S!==a&&I.$ie(S)&&S.match(E.VARIABLE_REGEXP)&&(S=await this.m(y,b,S,t,i)),S})}n(y){return this.b?this.b.getUriLabel(y,{noPrefix:!0}):y.fsPath}async o(y,b,o,t,i){let a;const m=o.split(":");m.length>1&&(o=m[0],a=m[1]);const S=h=>{const n=this.a.getFilePath();if(n)return(0,d.$Yz)(n);throw new $.$mM(h,(0,k.localize)(0,null,b))},C=h=>{const n=S(h);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,d.$Yz)(s)}throw new $.$mM(h,(0,k.localize)(1,null,b,w.$ec(n)))},r=h=>{if(a){const n=this.a.getFolderUri(a);if(n)return n;throw new $.$mM(h,(0,k.localize)(2,null,b,a))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new $.$mM(h,(0,k.localize)(3,null,b)):new $.$mM(h,(0,k.localize)(4,null,b))};switch(o){case"env":if(a){if(y.env){const h=y.env[P.$i?a.toLowerCase():a];if(I.$ie(h))return h}return""}throw new $.$mM($.VariableKind.Env,(0,k.localize)(5,null,b));case"config":if(a){const h=this.a.getConfigurationValue(t,a);if(I.$re(h))throw new $.$mM($.VariableKind.Config,(0,k.localize)(6,null,b,a));if(I.$ke(h))throw new $.$mM($.VariableKind.Config,(0,k.localize)(7,null,b,a));return h}throw new $.$mM($.VariableKind.Config,(0,k.localize)(8,null,b));case"command":return this.p($.VariableKind.Command,b,a,i,"command");case"input":return this.p($.VariableKind.Input,b,a,i,"input");case"extensionInstallFolder":if(a){const h=await this.a.getExtension(a);if(!h)throw new $.$mM($.VariableKind.ExtensionInstallFolder,(0,k.localize)(9,null,b,a));return this.n(h.extensionLocation)}throw new $.$mM($.VariableKind.ExtensionInstallFolder,(0,k.localize)(10,null,b));default:switch(o){case"workspaceRoot":case"workspaceFolder":return(0,d.$Yz)(this.n(r($.VariableKind.WorkspaceFolder)));case"cwd":return t||a?(0,d.$Yz)(this.n(r($.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,d.$Yz)(w.$ec(this.n(r($.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(y.userHome)return y.userHome;throw new $.$mM($.VariableKind.UserHome,(0,k.localize)(11,null,b))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new $.$mM($.VariableKind.LineNumber,(0,k.localize)(12,null,b))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new $.$mM($.VariableKind.SelectedText,(0,k.localize)(13,null,b))}case"file":return S($.VariableKind.File);case"fileWorkspaceFolder":return C($.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||a?w.$cc(this.n(r($.VariableKind.RelativeFile)),S($.VariableKind.RelativeFile)):S($.VariableKind.RelativeFile);case"relativeFileDirname":{const h=w.$dc(S($.VariableKind.RelativeFileDirname));if(t||a){const n=w.$cc(this.n(r($.VariableKind.RelativeFileDirname)),h);return n.length===0?".":n}return h}case"fileDirname":return w.$dc(S($.VariableKind.FileDirname));case"fileExtname":return w.$fc(S($.VariableKind.FileExtname));case"fileBasename":return w.$ec(S($.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=w.$ec(S($.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-w.$fc(h).length)}case"fileDirnameBasename":return w.$ec(w.$dc(S($.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||b}case"execInstallFolder":{const h=this.a.getAppRoot();return h||b}case"pathSeparator":return w.sep;default:try{const h=a?`${o}:${a}`:o;return this.p($.VariableKind.Unknown,b,h,i,void 0)}catch{return b}}}}p(y,b,o,t,i){if(o&&t){const a=i===void 0?t[o]:t[i+":"+o];if(typeof a=="string")return a;throw new $.$mM(y,(0,k.localize)(14,null,b))}return b}}e.$AM=E}),define(Ae[102],Re([1,0,3,99]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PC=e.$OC=e.OpenEditorContext=e.GroupsOrder=e.$NC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$MC=void 0,e.$MC=(0,w.$nh)("editorGroupsService");var I;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var z;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(z||(e.GroupOrientation=z={}));var P;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(P||(e.GroupLocation=P={}));var d;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EVEN=1]="EVEN",b[b.TOGGLE=2]="TOGGLE"})(d||(e.GroupsArrangement=d={}));var k;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(k||(e.MergeGroupMode=k={}));function $(b){const o=b;return(0,L.$CE)(o?.editor)&&(0,L.$CE)(o?.replacement)}e.$NC=$;var R;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var E;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(E||(e.OpenEditorContext=E={}));function c(b){const o=b;return!!o&&typeof o.id=="number"&&Array.isArray(o.editors)}e.$OC=c;function y(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$PC=y}),define(Ae[202],Re([1,0,3,102]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=e.$SC=e.$RC=e.$QC=void 0,e.$QC=(0,w.$nh)("editorService"),e.$RC=-1,e.$SC=-2;function I(z){const P=z;return typeof z=="number"||(0,L.$OC)(P)}e.$TC=I}),define(Ae[8],Re([1,0,18,25,122,203,49,28,116,70,69,24,12,2,44,78,94,101,99,75,45,57,202,7]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S,C,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$yL=e.$xL=e.MarkdownString=e.$wL=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var n;(function(Pe){function we(X){const{selectionStartLineNumber:Le,selectionStartColumn:Ue,positionLineNumber:He,positionColumn:We}=X,_e=new h.$AJ(Le-1,Ue-1),bt=new h.$AJ(He-1,We-1);return new h.$CJ(_e,bt)}Pe.to=we;function ve(X){const{anchor:Le,active:Ue}=X;return{selectionStartLineNumber:Le.line+1,selectionStartColumn:Le.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}Pe.from=ve})(n||(e.Selection=n={}));var s;(function(Pe){function we(X){if(!X)return;const{start:Le,end:Ue}=X;return{startLineNumber:Le.line+1,startColumn:Le.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}Pe.from=we;function ve(X){if(!X)return;const{startLineNumber:Le,startColumn:Ue,endLineNumber:He,endColumn:We}=X;return new h.$BJ(Le-1,Ue-1,He-1,We-1)}Pe.to=ve})(s||(e.Range=s={}));var p;(function(Pe){function we(ve){switch(ve){case 1:return h.StandardTokenType.Comment;case 0:return h.StandardTokenType.Other;case 3:return h.StandardTokenType.RegEx;case 2:return h.StandardTokenType.String}}Pe.to=we})(p||(e.TokenType=p={}));var D;(function(Pe){function we(X){return new h.$AJ(X.lineNumber-1,X.column-1)}Pe.to=we;function ve(X){return{lineNumber:X.line+1,column:X.character+1}}Pe.from=ve})(D||(e.Position=D={}));var l;(function(Pe){function we(Le,Ue,He){return(0,w.$lf)((0,w.$If)(Le).map(We=>ve(We,Ue,He)))}Pe.from=we;function ve(Le,Ue,He){if(typeof Le=="string")return{$serialized:!0,language:Le,isBuiltin:He?.isBuiltin};if(Le)return{$serialized:!0,language:Le.language,scheme:X(Le.scheme,Ue),pattern:nt.from(Le.pattern)??void 0,exclusive:Le.exclusive,notebookType:Le.notebookType,isBuiltin:He?.isBuiltin}}function X(Le,Ue){return Ue&&typeof Le=="string"?Ue.transformOutgoingScheme(Le):Le}})(l||(e.DocumentSelector=l={}));var g;(function(Pe){function we(X){switch(X){case h.DiagnosticTag.Unnecessary:return 1;case h.DiagnosticTag.Deprecated:return 2}}Pe.from=we;function ve(X){switch(X){case 1:return h.DiagnosticTag.Unnecessary;case 2:return h.DiagnosticTag.Deprecated;default:return}}Pe.to=ve})(g||(e.DiagnosticTag=g={}));var v;(function(Pe){function we(X){let Le;return X.code&&((0,c.$ie)(X.code)||(0,c.$me)(X.code)?Le=String(X.code):Le={value:String(X.code.value),target:X.code.target}),{...s.from(X.range),message:X.message,source:X.source,code:Le,severity:f.from(X.severity),relatedInformation:X.relatedInformation&&X.relatedInformation.map(u.from),tags:Array.isArray(X.tags)?(0,w.$lf)(X.tags.map(g.from)):void 0}}Pe.from=we;function ve(X){const Le=new h.$NJ(s.to(X),X.message,f.to(X.severity));return Le.source=X.source,Le.code=(0,c.$ie)(X.code)?X.code:X.code?.value,Le.relatedInformation=X.relatedInformation&&X.relatedInformation.map(u.to),Le.tags=X.tags&&(0,w.$lf)(X.tags.map(g.to)),Le}Pe.to=ve})(v||(e.Diagnostic=v={}));var u;(function(Pe){function we(X){return{...s.from(X.location.range),message:X.message,resource:X.location.uri}}Pe.from=we;function ve(X){return new h.$MJ(new h.$LJ(X.resource,s.to(X)),X.message)}Pe.to=ve})(u||(e.DiagnosticRelatedInformation=u={}));var f;(function(Pe){function we(X){switch(X){case h.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case h.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case h.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case h.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Pe.from=we;function ve(X){switch(X){case t.MarkerSeverity.Info:return h.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return h.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return h.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return h.DiagnosticSeverity.Hint;default:return h.DiagnosticSeverity.Error}}Pe.to=ve})(f||(e.DiagnosticSeverity=f={}));var A;(function(Pe){function we(X){return typeof X=="number"&&X>=h.ViewColumn.One?X-1:X===h.ViewColumn.Beside?r.$SC:r.$RC}Pe.from=we;function ve(X){if(typeof X=="number"&&X>=0)return X+1;throw new Error("invalid 'EditorGroupColumn'")}Pe.to=ve})(A||(e.ViewColumn=A={}));function W(Pe){return typeof Pe.range<"u"}function B(Pe){return Pe.length===0?!0:!!W(Pe[0])}e.$wL=B;var V;(function(Pe){function we(We){return We.map(Pe.from)}Pe.fromMany=we;function ve(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function X(We){let _e;if(ve(We)){const{language:pt,value:mt}=We;_e={value:"```"+pt+`
`+mt+"\n```\n"}}else h.$1J.isMarkdownString(We)?_e={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons,supportHtml:We.supportHtml,baseUri:We.baseUri}:typeof We=="string"?_e={value:We}:_e={value:""};const bt=Object.create(null);_e.uris=bt;const Dt=pt=>{try{let mt=y.URI.parse(pt,!0);mt=mt.with({query:Le(mt.query,bt)}),bt[pt]=mt}catch{}return""},St=new k.marked.Renderer;return St.link=Dt,St.image=pt=>typeof pt=="string"?Dt(P.$Pj(pt).href):"",(0,k.marked)(_e.value,{renderer:St}),_e}Pe.from=X;function Le(We,_e){if(!We)return We;let bt;try{bt=(0,$.$Vg)(We)}catch{}if(!bt)return We;let Dt=!1;return bt=(0,E.$Hm)(bt,St=>{if(y.URI.isUri(St)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return _e[pt]=St,Dt=!0,pt}else return}),Dt?JSON.stringify(bt):We}function Ue(We){const _e=new h.$1J(We.value,We.supportThemeIcons);return _e.isTrusted=We.isTrusted,_e.supportHtml=We.supportHtml,_e.baseUri=We.baseUri?y.URI.from(We.baseUri):void 0,_e}Pe.to=Ue;function He(We){if(We)return typeof We=="string"?We:Pe.from(We)}Pe.fromStrict=He})(V||(e.MarkdownString=V={}));function U(Pe){return B(Pe)?Pe.map(we=>({range:s.from(we.range),hoverMessage:Array.isArray(we.hoverMessage)?V.fromMany(we.hoverMessage):we.hoverMessage?V.from(we.hoverMessage):void 0,renderOptions:we.renderOptions})):Pe.map(we=>({range:s.from(we)}))}e.$xL=U;function O(Pe){return typeof Pe>"u"?Pe:typeof Pe=="string"?y.URI.file(Pe):Pe}e.$yL=O;var N;(function(Pe){function we(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?O(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Pe.from=we})(N||(e.ThemableDecorationAttachmentRenderOptions=N={}));var ae;(function(Pe){function we(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?O(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?N.from(ve.before):void 0,after:ve.after?N.from(ve.after):void 0}}Pe.from=we})(ae||(e.ThemableDecorationRenderOptions=ae={}));var Q;(function(Pe){function we(ve){if(typeof ve>"u")return ve;switch(ve){case h.DecorationRangeBehavior.OpenOpen:return 0;case h.DecorationRangeBehavior.ClosedClosed:return 1;case h.DecorationRangeBehavior.OpenClosed:return 2;case h.DecorationRangeBehavior.ClosedOpen:return 3}}Pe.from=we})(Q||(e.DecorationRangeBehavior=Q={}));var be;(function(Pe){function we(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?Q.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?ae.from(ve.light):void 0,dark:ve.dark?ae.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?O(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?N.from(ve.before):void 0,after:ve.after?N.from(ve.after):void 0}}Pe.from=we})(be||(e.DecorationRenderOptions=be={}));var ke;(function(Pe){function we(X){return{text:X.newText,eol:X.newEol&&Ge.from(X.newEol),range:s.from(X.range)}}Pe.from=we;function ve(X){const Le=new h.$GJ(s.to(X.range),X.text);return Le.newEol=typeof X.eol>"u"?void 0:Ge.to(X.eol),Le}Pe.to=ve})(ke||(e.TextEdit=ke={}));var Fe;(function(Pe){function we(X,Le){const Ue={edits:[]};if(X instanceof h.$JJ){const He=new d.$mi;for(const We of X._allEntries())We._type===1&&y.URI.isUri(We.to)&&We.from===void 0&&He.add(We.to);for(const We of X._allEntries())if(We._type===1){let _e;We.options?.contents&&(ArrayBuffer.isView(We.options.contents)?_e={type:"base64",value:(0,L.$4b)(L.$Jb.wrap(We.options.contents))}:_e={type:"dataTransferItem",id:We.options.contents._itemId}),Ue.edits.push({oldResource:We.from,newResource:We.to,options:{...We.options,contents:_e},metadata:We.metadata})}else We._type===2?Ue.edits.push({resource:We.uri,textEdit:ke.from(We.edit),versionId:He.has(We.uri)?void 0:Le?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===6?Ue.edits.push({resource:We.uri,textEdit:{range:s.from(We.range),text:We.edit.value,insertAsSnippet:!0},versionId:He.has(We.uri)?void 0:Le?.getTextDocumentVersion(We.uri),metadata:We.metadata}):We._type===3?Ue.edits.push({metadata:We.metadata,resource:We.uri,cellEdit:We.edit,notebookMetadata:We.notebookMetadata,notebookVersionId:Le?.getNotebookDocumentVersion(We.uri)}):We._type===5&&Ue.edits.push({metadata:We.metadata,resource:We.uri,notebookVersionId:Le?.getNotebookDocumentVersion(We.uri),cellEdit:{editType:1,index:We.index,count:We.count,cells:We.cells.map(et.from)}})}return Ue}Pe.from=we;function ve(X){const Le=new h.$JJ,Ue=new d.$li;for(const He of X.edits)if(He.textEdit){const We=He,_e=y.URI.revive(We.resource),bt=s.to(We.textEdit.range),Dt=We.textEdit.text,St=We.textEdit.insertAsSnippet;let pt;St?pt=h.$IJ.replace(bt,new h.$KJ(Dt)):pt=h.$GJ.replace(bt,Dt);const mt=Ue.get(_e);mt?mt.push(pt):Ue.set(_e,[pt])}else Le.renameFile(y.URI.revive(He.oldResource),y.URI.revive(He.newResource),He.options);for(const[He,We]of Ue)Le.set(He,We);return Le}Pe.to=ve})(Fe||(e.WorkspaceEdit=Fe={}));var G;(function(Pe){const we=Object.create(null);we[h.SymbolKind.File]=0,we[h.SymbolKind.Module]=1,we[h.SymbolKind.Namespace]=2,we[h.SymbolKind.Package]=3,we[h.SymbolKind.Class]=4,we[h.SymbolKind.Method]=5,we[h.SymbolKind.Property]=6,we[h.SymbolKind.Field]=7,we[h.SymbolKind.Constructor]=8,we[h.SymbolKind.Enum]=9,we[h.SymbolKind.Interface]=10,we[h.SymbolKind.Function]=11,we[h.SymbolKind.Variable]=12,we[h.SymbolKind.Constant]=13,we[h.SymbolKind.String]=14,we[h.SymbolKind.Number]=15,we[h.SymbolKind.Boolean]=16,we[h.SymbolKind.Array]=17,we[h.SymbolKind.Object]=18,we[h.SymbolKind.Key]=19,we[h.SymbolKind.Null]=20,we[h.SymbolKind.EnumMember]=21,we[h.SymbolKind.Struct]=22,we[h.SymbolKind.Event]=23,we[h.SymbolKind.Operator]=24,we[h.SymbolKind.TypeParameter]=25;function ve(Le){return typeof we[Le]=="number"?we[Le]:6}Pe.from=ve;function X(Le){for(const Ue in we)if(we[Ue]===Le)return Number(Ue);return h.SymbolKind.Property}Pe.to=X})(G||(e.SymbolKind=G={}));var Z;(function(Pe){function we(X){switch(X){case h.SymbolTag.Deprecated:return 1}}Pe.from=we;function ve(X){switch(X){case 1:return h.SymbolTag.Deprecated}}Pe.to=ve})(Z||(e.SymbolTag=Z={}));var le;(function(Pe){function we(X){return{name:X.name,kind:G.from(X.kind),tags:X.tags&&X.tags.map(Z.from),containerName:X.containerName,location:_.from(X.location)}}Pe.from=we;function ve(X){const Le=new h.$QJ(X.name,G.to(X.kind),X.containerName,_.to(X.location));return Le.tags=X.tags&&X.tags.map(Z.to),Le}Pe.to=ve})(le||(e.WorkspaceSymbol=le={}));var ne;(function(Pe){function we(X){const Le={name:X.name||"!!MISSING: name!!",detail:X.detail,range:s.from(X.range),selectionRange:s.from(X.selectionRange),kind:G.from(X.kind),tags:X.tags?.map(Z.from)??[]};return X.children&&(Le.children=X.children.map(we)),Le}Pe.from=we;function ve(X){const Le=new h.$RJ(X.name,X.detail,G.to(X.kind),s.to(X.range),s.to(X.selectionRange));return(0,w.$pf)(X.tags)&&(Le.tags=X.tags.map(Z.to)),X.children&&(Le.children=X.children.map(ve)),Le}Pe.to=ve})(ne||(e.DocumentSymbol=ne={}));var de;(function(Pe){function we(X){const Le=new h.$WJ(G.to(X.kind),X.name,X.detail||"",y.URI.revive(X.uri),s.to(X.range),s.to(X.selectionRange));return Le._sessionId=X._sessionId,Le._itemId=X._itemId,Le}Pe.to=we;function ve(X,Le,Ue){if(Le=Le??X._sessionId,Ue=Ue??X._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,name:X.name,detail:X.detail,kind:G.from(X.kind),uri:X.uri,range:s.from(X.range),selectionRange:s.from(X.selectionRange),tags:X.tags?.map(Z.from)}}Pe.from=ve})(de||(e.CallHierarchyItem=de={}));var ue;(function(Pe){function we(ve){return new h.$XJ(de.to(ve.from),ve.fromRanges.map(X=>s.to(X)))}Pe.to=we})(ue||(e.CallHierarchyIncomingCall=ue={}));var T;(function(Pe){function we(ve){return new h.$YJ(de.to(ve.to),ve.fromRanges.map(X=>s.to(X)))}Pe.to=we})(T||(e.CallHierarchyOutgoingCall=T={}));var _;(function(Pe){function we(X){return{range:X.range&&s.from(X.range),uri:X.uri}}Pe.from=we;function ve(X){return new h.$LJ(y.URI.revive(X.uri),s.to(X.range))}Pe.to=ve})(_||(e.location=_={}));var ye;(function(Pe){function we(X){const Le=X,Ue=X;return{originSelectionRange:Le.originSelectionRange?s.from(Le.originSelectionRange):void 0,uri:Le.targetUri?Le.targetUri:Ue.uri,range:s.from(Le.targetRange?Le.targetRange:Ue.range),targetSelectionRange:Le.targetSelectionRange?s.from(Le.targetSelectionRange):void 0}}Pe.from=we;function ve(X){return{targetUri:y.URI.revive(X.uri),targetRange:s.to(X.range),targetSelectionRange:X.targetSelectionRange?s.to(X.targetSelectionRange):void 0,originSelectionRange:X.originSelectionRange?s.to(X.originSelectionRange):void 0}}Pe.to=ve})(ye||(e.DefinitionLink=ye={}));var Ce;(function(Pe){function we(X){return{range:s.from(X.range),contents:V.fromMany(X.contents)}}Pe.from=we;function ve(X){return new h.$OJ(X.contents.map(V.to),s.to(X.range))}Pe.to=ve})(Ce||(e.Hover=Ce={}));var Se;(function(Pe){function we(X){return{range:s.from(X.range),expression:X.expression}}Pe.from=we;function ve(X){return new h.$IK(s.to(X.range),X.expression)}Pe.to=ve})(Se||(e.EvaluatableExpression=Se={}));var Ee;(function(Pe){function we(X){if(X instanceof h.$JK)return{type:"text",range:s.from(X.range),text:X.text};if(X instanceof h.$KK)return{type:"variable",range:s.from(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};if(X instanceof h.$LK)return{type:"expression",range:s.from(X.range),expression:X.expression};throw new Error("Unknown 'InlineValue' type")}Pe.from=we;function ve(X){switch(X.type){case"text":return{range:s.to(X.range),text:X.text};case"variable":return{range:s.to(X.range),variableName:X.variableName,caseSensitiveLookup:X.caseSensitiveLookup};case"expression":return{range:s.to(X.range),expression:X.expression}}}Pe.to=ve})(Ee||(e.InlineValue=Ee={}));var Ie;(function(Pe){function we(X){return{frameId:X.frameId,stoppedLocation:s.from(X.stoppedLocation)}}Pe.from=we;function ve(X){return new h.$MK(X.frameId,s.to(X.stoppedLocation))}Pe.to=ve})(Ie||(e.InlineValueContext=Ie={}));var se;(function(Pe){function we(X){return{range:s.from(X.range),kind:X.kind}}Pe.from=we;function ve(X){return new h.$PJ(s.to(X.range),X.kind)}Pe.to=ve})(se||(e.DocumentHighlight=se={}));var fe;(function(Pe){function we(ve){switch(ve){case 1:return h.CompletionTriggerKind.TriggerCharacter;case 2:return h.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return h.CompletionTriggerKind.Invoke}}Pe.to=we})(fe||(e.CompletionTriggerKind=fe={}));var ee;(function(Pe){function we(ve){return{triggerKind:fe.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Pe.to=we})(ee||(e.CompletionContext=ee={}));var ie;(function(Pe){function we(X){switch(X){case h.CompletionItemTag.Deprecated:return 1}}Pe.from=we;function ve(X){switch(X){case 1:return h.CompletionItemTag.Deprecated}}Pe.to=ve})(ie||(e.CompletionItemTag=ie={}));var he;(function(Pe){const we=new Map([[h.CompletionItemKind.Method,0],[h.CompletionItemKind.Function,1],[h.CompletionItemKind.Constructor,2],[h.CompletionItemKind.Field,3],[h.CompletionItemKind.Variable,4],[h.CompletionItemKind.Class,5],[h.CompletionItemKind.Interface,7],[h.CompletionItemKind.Struct,6],[h.CompletionItemKind.Module,8],[h.CompletionItemKind.Property,9],[h.CompletionItemKind.Unit,12],[h.CompletionItemKind.Value,13],[h.CompletionItemKind.Constant,14],[h.CompletionItemKind.Enum,15],[h.CompletionItemKind.EnumMember,16],[h.CompletionItemKind.Keyword,17],[h.CompletionItemKind.Snippet,27],[h.CompletionItemKind.Text,18],[h.CompletionItemKind.Color,19],[h.CompletionItemKind.File,20],[h.CompletionItemKind.Reference,21],[h.CompletionItemKind.Folder,23],[h.CompletionItemKind.Event,10],[h.CompletionItemKind.Operator,11],[h.CompletionItemKind.TypeParameter,24],[h.CompletionItemKind.Issue,26],[h.CompletionItemKind.User,25]]);function ve(Ue){return we.get(Ue)??9}Pe.from=ve;const X=new Map([[0,h.CompletionItemKind.Method],[1,h.CompletionItemKind.Function],[2,h.CompletionItemKind.Constructor],[3,h.CompletionItemKind.Field],[4,h.CompletionItemKind.Variable],[5,h.CompletionItemKind.Class],[7,h.CompletionItemKind.Interface],[6,h.CompletionItemKind.Struct],[8,h.CompletionItemKind.Module],[9,h.CompletionItemKind.Property],[12,h.CompletionItemKind.Unit],[13,h.CompletionItemKind.Value],[14,h.CompletionItemKind.Constant],[15,h.CompletionItemKind.Enum],[16,h.CompletionItemKind.EnumMember],[17,h.CompletionItemKind.Keyword],[27,h.CompletionItemKind.Snippet],[18,h.CompletionItemKind.Text],[19,h.CompletionItemKind.Color],[20,h.CompletionItemKind.File],[21,h.CompletionItemKind.Reference],[23,h.CompletionItemKind.Folder],[10,h.CompletionItemKind.Event],[11,h.CompletionItemKind.Operator],[24,h.CompletionItemKind.TypeParameter],[25,h.CompletionItemKind.User],[26,h.CompletionItemKind.Issue]]);function Le(Ue){return X.get(Ue)??h.CompletionItemKind.Property}Pe.to=Le})(he||(e.CompletionItemKind=he={}));var F;(function(Pe){function we(ve,X){const Le=new h.$7J(ve.label);return Le.insertText=ve.insertText,Le.kind=he.to(ve.kind),Le.tags=ve.tags?.map(ie.to),Le.detail=ve.detail,Le.documentation=P.$Kj(ve.documentation)?V.to(ve.documentation):ve.documentation,Le.sortText=ve.sortText,Le.filterText=ve.filterText,Le.preselect=ve.preselect,Le.commitCharacters=ve.commitCharacters,b.$Mr.isIRange(ve.range)?Le.range=s.to(ve.range):typeof ve.range=="object"&&(Le.range={inserting:s.to(ve.range.insert),replacing:s.to(ve.range.replace)}),Le.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Le.insertText=new h.$KJ(ve.insertText):(Le.insertText=ve.insertText,Le.textEdit=Le.range instanceof h.$BJ?new h.$GJ(Le.range,Le.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Le.additionalTextEdits=ve.additionalTextEdits.map(Ue=>ke.to(Ue))),Le.command=X&&ve.command?X.fromInternal(ve.command):void 0,Le}Pe.to=we})(F||(e.CompletionItem=F={}));var q;(function(Pe){function we(X){if(typeof X.label!="string"&&!Array.isArray(X.label))throw new TypeError("Invalid label");return{label:X.label,documentation:V.fromStrict(X.documentation)}}Pe.from=we;function ve(X){return{label:X.label,documentation:P.$Kj(X.documentation)?V.to(X.documentation):X.documentation}}Pe.to=ve})(q||(e.ParameterInformation=q={}));var J;(function(Pe){function we(X){return{label:X.label,documentation:V.fromStrict(X.documentation),parameters:Array.isArray(X.parameters)?X.parameters.map(q.from):[],activeParameter:X.activeParameter}}Pe.from=we;function ve(X){return{label:X.label,documentation:P.$Kj(X.documentation)?V.to(X.documentation):X.documentation,parameters:Array.isArray(X.parameters)?X.parameters.map(q.to):[],activeParameter:X.activeParameter}}Pe.to=ve})(J||(e.SignatureInformation=J={}));var K;(function(Pe){function we(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(J.from):[]}}Pe.from=we;function ve(X){return{activeSignature:X.activeSignature,activeParameter:X.activeParameter,signatures:Array.isArray(X.signatures)?X.signatures.map(J.to):[]}}Pe.to=ve})(K||(e.SignatureHelp=K={}));var oe;(function(Pe){function we(ve,X){const Le=new h.$6J(D.to(X.position),typeof X.label=="string"?X.label:X.label.map(H.to.bind(void 0,ve)),X.kind&&ce.to(X.kind));return Le.textEdits=X.textEdits&&X.textEdits.map(ke.to),Le.tooltip=P.$Kj(X.tooltip)?V.to(X.tooltip):X.tooltip,Le.paddingLeft=X.paddingLeft,Le.paddingRight=X.paddingRight,Le}Pe.to=we})(oe||(e.InlayHint=oe={}));var H;(function(Pe){function we(ve,X){const Le=new h.$5J(X.label);return Le.tooltip=P.$Kj(X.tooltip)?V.to(X.tooltip):X.tooltip,o.Command.is(X.command)&&(Le.command=ve.fromInternal(X.command)),X.location&&(Le.location=_.to(X.location)),Le}Pe.to=we})(H||(e.InlayHintLabelPart=H={}));var ce;(function(Pe){function we(X){return X}Pe.from=we;function ve(X){return X}Pe.to=ve})(ce||(e.InlayHintKind=ce={}));var pe;(function(Pe){function we(X){return{range:s.from(X.range),url:X.target,tooltip:X.tooltip}}Pe.from=we;function ve(X){let Le;if(X.url)try{Le=typeof X.url=="string"?y.URI.parse(X.url,!0):y.URI.revive(X.url)}catch{}return new h.$_J(s.to(X.range),Le)}Pe.to=ve})(pe||(e.DocumentLink=pe={}));var Oe;(function(Pe){function we(X){const Le=new h.$cK(X.label);return X.textEdit&&(Le.textEdit=ke.to(X.textEdit)),X.additionalTextEdits&&(Le.additionalTextEdits=X.additionalTextEdits.map(Ue=>ke.to(Ue))),Le}Pe.to=we;function ve(X){return{label:X.label,textEdit:X.textEdit?ke.from(X.textEdit):void 0,additionalTextEdits:X.additionalTextEdits?X.additionalTextEdits.map(Le=>ke.from(Le)):void 0}}Pe.from=ve})(Oe||(e.ColorPresentation=Oe={}));var Be;(function(Pe){function we(X){return new h.$aK(X[0],X[1],X[2],X[3])}Pe.to=we;function ve(X){return[X.red,X.green,X.blue,X.alpha]}Pe.from=ve})(Be||(e.Color=Be={}));var Ze;(function(Pe){function we(X){return{range:s.from(X.range)}}Pe.from=we;function ve(X){return new h.$VJ(s.to(X.range))}Pe.to=ve})(Ze||(e.SelectionRange=Ze={}));var Ke;(function(Pe){function we(ve){switch(ve){case 2:return h.TextDocumentSaveReason.AfterDelay;case 1:return h.TextDocumentSaveReason.Manual;case 3:case 4:return h.TextDocumentSaveReason.FocusOut}}Pe.to=we})(Ke||(e.TextDocumentSaveReason=Ke={}));var Qe;(function(Pe){function we(X){switch(X){case h.TextEditorLineNumbersStyle.Off:return 0;case h.TextEditorLineNumbersStyle.Relative:return 2;case h.TextEditorLineNumbersStyle.On:default:return 1}}Pe.from=we;function ve(X){switch(X){case 0:return h.TextEditorLineNumbersStyle.Off;case 2:return h.TextEditorLineNumbersStyle.Relative;case 1:default:return h.TextEditorLineNumbersStyle.On}}Pe.to=ve})(Qe||(e.TextEditorLineNumbersStyle=Qe={}));var Ge;(function(Pe){function we(X){if(X===h.EndOfLine.CRLF)return 1;if(X===h.EndOfLine.LF)return 0}Pe.from=we;function ve(X){if(X===1)return h.EndOfLine.CRLF;if(X===0)return h.EndOfLine.LF}Pe.to=ve})(Ge||(e.EndOfLine=Ge={}));var ct;(function(Pe){function we(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case h.ProgressLocation.SourceControl:return 3;case h.ProgressLocation.Window:return 10;case h.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Pe.from=we})(ct||(e.ProgressLocation=ct={}));var xe;(function(Pe){function we(X){const Le={start:X.start+1,end:X.end+1};return X.kind&&(Le.kind=tt.from(X.kind)),Le}Pe.from=we;function ve(X){const Le={start:X.start-1,end:X.end-1};return X.kind&&(Le.kind=tt.to(X.kind)),Le}Pe.to=ve})(xe||(e.FoldingRange=xe={}));var tt;(function(Pe){function we(X){if(X)switch(X){case h.FoldingRangeKind.Comment:return o.$ss.Comment;case h.FoldingRangeKind.Imports:return o.$ss.Imports;case h.FoldingRangeKind.Region:return o.$ss.Region}}Pe.from=we;function ve(X){if(X)switch(X.value){case o.$ss.Comment.value:return h.FoldingRangeKind.Comment;case o.$ss.Imports.value:return h.FoldingRangeKind.Imports;case o.$ss.Region.value:return h.FoldingRangeKind.Region}}Pe.to=ve})(tt||(e.FoldingRangeKind=tt={}));var Ne;(function(Pe){function we(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?s.from(ve.selection):void 0,override:typeof ve.override=="boolean"?a.$pE.id:void 0}}Pe.from=we})(Ne||(e.TextEditorOpenOptions=Ne={}));var nt;(function(Pe){function we(Ue){return Ue instanceof h.$wK?Ue.toJSON():typeof Ue=="string"?Ue:ve(Ue)||X(Ue)?new h.$wK(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}Pe.from=we;function ve(Ue){const He=Ue;return He?y.URI.isUri(He.baseUri)&&typeof He.pattern=="string":!1}function X(Ue){const He=Ue;return He?typeof He.base=="string"&&typeof He.pattern=="string":!1}function Le(Ue){return typeof Ue=="string"?Ue:new h.$wK(y.URI.revive(Ue.baseUri),Ue.pattern)}Pe.to=Le})(nt||(e.GlobPattern=nt={}));var x;(function(Pe){function we(ve){if(ve){if(Array.isArray(ve))return ve.map(we);if(typeof ve=="string")return ve;{const X=ve;return{language:X.language,scheme:X.scheme,pattern:nt.from(X.pattern),exclusive:X.exclusive,notebookType:X.notebookType}}}else return}Pe.from=we})(x||(e.LanguageSelector=x={}));var Y;(function(Pe){function we(X){return{start:X.start,end:X.end}}Pe.from=we;function ve(X){return new h.$XK(X.start,X.end)}Pe.to=ve})(Y||(e.NotebookRange=Y={}));var me;(function(Pe){function we(X){return{timing:typeof X.runStartTime=="number"&&typeof X.runEndTime=="number"?{startTime:X.runStartTime,endTime:X.runEndTime}:void 0,executionOrder:X.executionOrder,success:X.lastRunSuccess}}Pe.to=we;function ve(X){return{lastRunSuccess:X.success,runStartTime:X.timing?.startTime,runEndTime:X.timing?.endTime,executionOrder:X.executionOrder}}Pe.from=ve})(me||(e.NotebookCellExecutionSummary=me={}));var je;(function(Pe){function we(ve){if(ve===m.NotebookCellExecutionState.Unconfirmed)return h.NotebookCellExecutionState.Pending;if(ve===m.NotebookCellExecutionState.Pending)return;if(ve===m.NotebookCellExecutionState.Executing)return h.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Pe.to=we})(je||(e.NotebookCellExecutionState=je={}));var ze;(function(Pe){function we(X){switch(X){case h.NotebookCellKind.Markup:return m.CellKind.Markup;case h.NotebookCellKind.Code:default:return m.CellKind.Code}}Pe.from=we;function ve(X){switch(X){case m.CellKind.Markup:return h.NotebookCellKind.Markup;case m.CellKind.Code:default:return h.NotebookCellKind.Code}}Pe.to=ve})(ze||(e.NotebookCellKind=ze={}));var Xe;(function(Pe){function we(X){const Le={metadata:X.metadata??Object.create(null),cells:[]};for(const Ue of X.cells)h.$YK.validate(Ue),Le.cells.push(et.from(Ue));return Le}Pe.from=we;function ve(X){const Le=new h.$ZK(X.cells.map(et.to));return(0,c.$ve)(X.metadata)||(Le.metadata=X.metadata),Le}Pe.to=ve})(Xe||(e.NotebookData=Xe={}));var et;(function(Pe){function we(X){return{cellKind:ze.from(X.kind),language:X.languageId,mime:X.mime,source:X.value,metadata:X.metadata,internalMetadata:me.from(X.executionSummary??{}),outputs:X.outputs?X.outputs.map(wt.from):[]}}Pe.from=we;function ve(X){return new h.$YK(ze.to(X.cellKind),X.source,X.language,X.mime,X.outputs?X.outputs.map(wt.to):void 0,X.metadata,X.internalMetadata?me.to(X.internalMetadata):void 0)}Pe.to=ve})(et||(e.NotebookCellData=et={}));var gt;(function(Pe){function we(X){return{mime:X.mime,valueBytes:L.$Jb.wrap(X.data)}}Pe.from=we;function ve(X){return new h.$1K(X.valueBytes.buffer,X.mime)}Pe.to=ve})(gt||(e.NotebookCellOutputItem=gt={}));var wt;(function(Pe){function we(X){return{outputId:X.id,items:X.items.map(gt.from),metadata:X.metadata}}Pe.from=we;function ve(X){const Le=X.items.map(gt.to);return new h.$2K(Le,X.outputId,X.metadata)}Pe.to=ve})(wt||(e.NotebookCellOutput=wt={}));var Ot;(function(Pe){function we(Le){return X(Le)?{include:(0,c.$Ae)(nt.from(Le.include)),exclude:(0,c.$Ae)(nt.from(Le.exclude))}:(0,c.$Ae)(nt.from(Le))}Pe.from=we;function ve(Le){return X(Le)?{include:nt.to(Le.include),exclude:nt.to(Le.exclude)}:nt.to(Le)}Pe.to=ve;function X(Le){const Ue=Le;return Ue?!(0,c.$re)(Ue.include)&&!(0,c.$re)(Ue.exclude):!1}})(Ot||(e.NotebookExclusiveDocumentPattern=Ot={}));var Jt;(function(Pe){function we(ve,X,Le){const Ue=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===h.NotebookCellStatusBarAlignment.Left?1:2,command:X.toInternal(Ue,Le),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Pe.from=we})(Jt||(e.NotebookStatusBarItem=Jt={}));var Wt;(function(Pe){function we(ve,X,Le){const Ue=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:X.toInternal(Ue,Le),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Pe.from=we})(Wt||(e.NotebookKernelSourceAction=Wt={}));var yt;(function(Pe){function we(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Pe.from=we})(yt||(e.NotebookDocumentContentOptions=yt={}));var Rt;(function(Pe){function we(X){return{uri:X.uri,provides:X.provides}}Pe.from=we;function ve(X){return new h.$4K(y.URI.revive(X.uri),X.provides)}Pe.to=ve})(Rt||(e.NotebookRendererScript=Rt={}));var Ft;(function(Pe){function we(X){return{message:V.fromStrict(X.message)||"",type:0,expected:X.expectedOutput,actual:X.actualOutput,location:X.location&&{range:s.from(X.location.range),uri:X.location.uri}}}Pe.from=we;function ve(X){const Le=new h.$$K(typeof X.message=="string"?X.message:V.to(X.message));return Le.actualOutput=X.actual,Le.expectedOutput=X.expected,Le.location=X.location?_.to(X.location):void 0,Le}Pe.to=ve})(Ft||(e.TestMessage=Ft={}));var Mt;(function(Pe){Pe.namespace=C.$nI,Pe.denamespace=C.$oI})(Mt||(e.TestTag=Mt={}));var Ut;(function(Pe){function we(X){const Le=(0,i.$vL)(X).controllerId;return{extId:S.$jI.fromExtHostTestItem(X,Le).toString(),label:X.label,uri:y.URI.revive(X.uri),busy:X.busy,tags:X.tags.map(Ue=>Mt.namespace(Le,Ue.id)),range:b.$Mr.lift(s.from(X.range)),description:X.description||null,sortText:X.sortText||null,error:X.error&&V.fromStrict(X.error)||null}}Pe.from=we;function ve(X){return{parent:void 0,error:void 0,id:S.$jI.fromString(X.extId).localId,label:X.label,uri:y.URI.revive(X.uri),tags:(X.tags||[]).map(Le=>{const{tagId:Ue}=Mt.denamespace(Le);return new h.$_K(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(X.range||void 0),canResolveChildren:!1,busy:X.busy,description:X.description||void 0,sortText:X.sortText||void 0}}Pe.toPlain=ve})(Ut||(e.TestItem=Ut={})),function(Pe){function we(X){return{id:X.id}}Pe.from=we;function ve(X){return new h.$_K(X.id)}Pe.to=ve}(Mt||(e.TestTag=Mt={}));var Lt;(function(Pe){const we=(X,Le)=>{const Ue=[];for(const[We,_e]of Le)S.$jI.compare(_e.item.extId,We)===2&&(Le.delete(We),Ue.push(_e));const He={...Ut.toPlain(X.item),parent:void 0,taskStates:X.tasks.map(We=>({state:We.state,duration:We.duration,messages:We.messages.filter(_e=>_e.type===0).map(Ft.to)})),children:Ue.map(We=>we(We,Le))};for(const We of He.children)We.parent=He;return He};function ve(X){const Le=[],Ue=new Map;for(const He of X.items){Ue.set(He.item.extId,He);const We=S.$jI.root(He.item.extId);X.request.targets.some(_e=>_e.controllerId===We&&_e.testIds.includes(He.item.extId))&&Le.push(He)}return{completedAt:X.completedAt,results:Le.map(He=>we(He,Ue))}}Pe.to=ve})(Lt||(e.TestResults=Lt={}));var st;(function(Pe){function we(Ue){return{covered:Ue.covered,total:Ue.covered}}function ve(Ue){return"line"in Ue?D.from(Ue):s.from(Ue)}function X(Ue){return"branches"in Ue?{count:Ue.executionCount,location:ve(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(He=>({count:He.executionCount,location:He.location&&ve(He.location)})):void 0}:{type:0,count:Ue.executionCount,location:ve(Ue.location)}}Pe.fromDetailed=X;function Le(Ue){return{uri:Ue.uri,statement:we(Ue.statementCoverage),branch:Ue.branchCoverage&&we(Ue.branchCoverage),function:Ue.functionCoverage&&we(Ue.functionCoverage),details:Ue.detailedCoverage?.map(X)}}Pe.fromFile=Le})(st||(e.TestCoverage=st={}));var ht;(function(Pe){function we(ve){switch(ve){case 1:return h.CodeActionTriggerKind.Invoke;case 2:return h.CodeActionTriggerKind.Automatic}}Pe.to=we})(ht||(e.CodeActionTriggerKind=ht={}));var jt;(function(Pe){function we(X){const Le=new h.$fL(G.to(X.kind),X.name,X.detail||"",y.URI.revive(X.uri),s.to(X.range),s.to(X.selectionRange));return Le._sessionId=X._sessionId,Le._itemId=X._itemId,Le}Pe.to=we;function ve(X,Le,Ue){if(Le=Le??X._sessionId,Ue=Ue??X._itemId,Le===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Le,_itemId:Ue,kind:G.from(X.kind),name:X.name,detail:X.detail??"",uri:X.uri,range:s.from(X.range),selectionRange:s.from(X.selectionRange),tags:X.tags?.map(Z.from)}}Pe.from=ve})(jt||(e.TypeHierarchyItem=jt={}));var Tt;(function(Pe){function we(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Pe.from=we})(Tt||(e.ViewBadge=Tt={}));var kt;(function(Pe){function we(Ue,He,We){const _e=He.fileData;return _e?new h.$pK(new h.$qK(_e.name,y.URI.revive(_e.uri),_e.id,(0,z.$cb)(()=>We(_e.id)))):Ue===R.$sr.uriList&&He.uriListData?new h.$oK(Le(He.uriListData)):new h.$oK(He.asString)}Pe.to=we;async function ve(Ue,He){const We=await He.asString();if(Ue===R.$sr.uriList)return{asString:We,fileData:void 0,uriListData:X(We)};const _e=He.asFile();return{asString:We,fileData:_e?{name:_e.name,uri:_e.uri,id:_e._itemId??_e.id}:void 0}}Pe.from=ve;function X(Ue){return I.$as.split(Ue).map(He=>{if(He.startsWith("#"))return He;try{return y.URI.parse(He)}catch{}return He})}function Le(Ue){return I.$as.create(Ue.map(He=>typeof He=="string"?He:y.URI.revive(He)))}})(kt||(e.DataTransferItem=kt={}));var ot;(function(Pe){function we(X,Le){const Ue=X.items.map(([He,We])=>[He,kt.to(He,We,Le)]);return new h.$rK(Ue)}Pe.toDataTransfer=we;async function ve(X){const Le={items:[]},Ue=[];for(const[He,We]of X)Ue.push((async()=>{Le.items.push([He,await kt.from(He,We)])})());return await Promise.all(Ue),Le}Pe.from=ve})(ot||(e.DataTransfer=ot={}));var Pt;(function(Pe){function we(X){return{message:X.message,metadata:X.metadata,title:X.title,tooltip:X.tooltip}}Pe.to=we;function ve(X){return{kind:"reply",message:X.message,metadata:X.metadata,title:X.title,tooltip:X.tooltip}}Pe.from=ve})(Pt||(e.ChatReplyFollowup=Pt={}));var zt;(function(Pe){function we(ve){return typeof ve=="string"?{title:ve,message:ve,kind:"reply"}:"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",args:ve.args}:Pt.from(ve)}Pe.from=we})(zt||(e.ChatFollowup=zt={}))}),define(Ae[204],Re([1,0,2,11,7,8,173]),function($e,e,w,L,I,z,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=void 0;class d{constructor($,R,E,c={timeout:1500,errors:3}){this.c=$,this.d=R,this.f=E,this.g=c,this.a=new P.$lc,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent($){return(R,E,c)=>{const b={dispose:this.a.push([R,E,$])};return Array.isArray(c)&&c.push(b),b}}async $participateInSave($,R){const E=w.URI.revive($);let c=!1;const y=setTimeout(()=>c=!0,this.g.timeout),b=[];try{for(const o of[...this.a]){if(c)break;const t=this.d.getDocument(E),i=await this.h(o,{document:t,reason:z.TextDocumentSaveReason.to(R)});b.push(i)}}finally{clearTimeout(y)}return b}h([$,R,E],c){const y=this.b.get($);return typeof y=="number"&&y>this.g.errors?Promise.resolve(!1):this.i(E,$,R,c).then(()=>!0,b=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' threw ERROR`),this.c.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const o=this.b.get($);this.b.set($,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${E.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i($,R,E,c){const y=[],b=Date.now(),{document:o,reason:t}=c,{version:i}=o,a=Object.freeze({document:o,reason:t,waitUntil(m){if(Object.isFrozen(y))throw(0,L.$6)("waitUntil can not be called async");y.push(Promise.resolve(m))}});try{R.apply(E,[a])}catch(m){return Promise.reject(m)}return Object.freeze(y),new Promise((m,S)=>{const C=setTimeout(()=>S(new Error("timeout")),this.g.timeout);return Promise.all(y).then(r=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${$.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(C),m(r)}).catch(r=>{clearTimeout(C),S(r)})}).then(m=>{const S={edits:[]};for(const C of m)if(Array.isArray(C)&&C.every(r=>r instanceof I.$GJ))for(const{newText:r,newEol:h,range:n}of C)S.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:n&&z.Range.from(n),text:r,eol:h&&z.EndOfLine.from(h)}});if(S.edits.length!==0)return i===o.version?this.f.$tryApplyWorkspaceEdit(S):Promise.reject(new Error("concurrent_edits"))})}}e.$4$b=d}),define(Ae[205],Re([1,0,13,2,8,7,75]),function($e,e,w,L,I,z,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fac=e.$eac=void 0;class d{constructor(E,c,y,b){this.start=E,this.deletedCount=c,this.deletedItems=y,this.items=b}asApiEvent(){return{range:new z.$XK(this.start,this.start+this.deletedCount),addedCells:this.items.map(E=>E.apiCell),removedCells:this.deletedItems}}}class k{static asModelAddData(E,c){return{EOL:c.eol,lines:c.source,languageId:c.language,uri:c.uri,isDirty:!1,versionId:1,notebook:E}}constructor(E,c,y){this.notebook=E,this.h=c,this.j=y,this.handle=y.handle,this.uri=L.URI.revive(y.uri),this.cellKind=y.cellKind,this.a=y.outputs.map(I.NotebookCellOutput.to),this.e=y.internalMetadata??{},this.b=Object.freeze(y.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(y.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const E=this,c=this.h.getDocument(this.uri);if(!c)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const y={get index(){return E.notebook.getCellIndex(E)},notebook:E.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:c.document,get mime(){return E.g},set mime(b){E.g=b},get outputs(){return E.a.slice(0)},get metadata(){return E.b},get executionSummary(){return E.d}};this.f=Object.freeze(y)}return this.f}setOutputs(E){this.a=E.map(I.NotebookCellOutput.to)}setOutputItems(E,c,y){const b=y.map(I.NotebookCellOutputItem.to),o=this.a.find(t=>t.id===E);if(o&&(c||(o.items.length=0),o.items.push(...b),o.items.length>1&&o.items.every(t=>P.$EH(t.mime)))){const t=new Map,i=[];o.items.forEach(a=>{let m;t.has(a.mime)?m=t.get(a.mime):(m=[],t.set(a.mime,m),i.push(a.mime)),m.push(a.data)}),o.items.length=0,i.forEach(a=>{const m=P.$FH(t.get(a));o.items.push({mime:a,data:m.data.buffer})})}}setMetadata(E){this.b=Object.freeze(E)}setInternalMetadata(E){this.e=E,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(E))}setMime(E){}}e.$eac=k;class ${static{this.a=0}constructor(E,c,y,b,o){this.k=E,this.l=c,this.m=y,this.uri=b,this.handle=$.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=o.viewType,this.f=Object.freeze(o.metadata??Object.create(null)),this.r([[0,0,o.cells]],!0,void 0),this.g=o.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const E=this,c={get uri(){return E.uri},get version(){return E.g},get notebookType(){return E.d},get isDirty(){return E.h},get isUntitled(){return E.uri.scheme===w.Schemas.untitled},get isClosed(){return E.j},get metadata(){return E.f},get cellCount(){return E.b.length},cellAt(y){return y=E.n(y),E.b[y].apiCell},getCells(y){return(y?E.p(y):E.b).map(o=>o.apiCell)},save(){return E.q()}};this.e=Object.freeze(c)}return this.e}acceptDocumentPropertiesChanged(E){E.metadata&&(this.f=Object.freeze({...this.f,...E.metadata}))}acceptDirty(E){this.h=E}acceptModelChanged(E,c,y){this.g=E.versionId,this.h=c,this.acceptDocumentPropertiesChanged({metadata:y});const b={notebook:this.apiNotebook,metadata:y,cellChanges:[],contentChanges:[]},o=[];for(const i of E.rawEvents)i.kind===P.NotebookCellsChangeType.ModelChange?this.r(i.changes,!1,b.contentChanges):i.kind===P.NotebookCellsChangeType.Move?this.s(i.index,i.length,i.newIdx,b.contentChanges):i.kind===P.NotebookCellsChangeType.Output?(this.t(i.index,i.outputs),o.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===P.NotebookCellsChangeType.OutputItem?(this.u(i.index,i.outputId,i.append,i.outputItems),o.push({cell:this.b[i.index].apiCell,outputs:this.b[i.index].apiCell.outputs})):i.kind===P.NotebookCellsChangeType.ChangeCellLanguage?(this.v(i.index,i.language),o.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document})):i.kind===P.NotebookCellsChangeType.ChangeCellContent?o.push({cell:this.b[i.index].apiCell,document:this.b[i.index].apiCell.document}):i.kind===P.NotebookCellsChangeType.ChangeCellMime?this.w(i.index,i.mime):i.kind===P.NotebookCellsChangeType.ChangeCellMetadata?(this.x(i.index,i.metadata),o.push({cell:this.b[i.index].apiCell,metadata:this.b[i.index].apiCell.metadata})):i.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(i.index,i.internalMetadata),o.push({cell:this.b[i.index].apiCell,executionSummary:this.b[i.index].apiCell.executionSummary}));const t=new Map;for(let i=0;i<o.length;i++){const a=o[i],m=t.get(a.cell);if(m===void 0){const S=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...a});t.set(a.cell,S-1)}else b.cellChanges[m]={...b.cellChanges[m],...a}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(E){return E=E|0,E<0?0:E>=this.b.length?this.b.length-1:E}o(E){let c=E.start|0,y=E.end|0;return c<0&&(c=0),y>this.b.length&&(y=this.b.length),E.with({start:c,end:y})}p(E){E=this.o(E);const c=[];for(let y=E.start;y<E.end;y++)c.push(this.b[y]);return c}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(E,c,y){if(this.j)return;const b=[],o=[],t=[];if(E.reverse().forEach(i=>{const m=i[2].map(r=>{const h=new k(this,this.l,r);return c||o.push(k.asModelAddData(this.apiNotebook,r)),h}),S=new d(i[0],i[1],[],m),C=this.b.splice(i[0],i[1],...m);for(const r of C)t.push(r.uri),S.deletedItems.push(r.apiCell);b.push(S)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:t}),y)for(const i of b)y.push(i.asApiEvent())}s(E,c,y,b){const o=this.b.splice(E,c);this.b.splice(y,0,...o);const t=[new d(E,c,o.map(i=>i.apiCell),[]),new d(y,0,[],o)];for(const i of t)b.push(i.asApiEvent())}t(E,c){this.b[E].setOutputs(c)}u(E,c,y,b){this.b[E].setOutputItems(c,y,b)}v(E,c){const y=this.b[E];y.apiCell.document.languageId!==c&&this.m.$acceptModelLanguageChanged(y.uri,c)}w(E,c){const y=this.b[E];y.apiCell.mime=c}x(E,c){this.b[E].setMetadata(c)}y(E,c){this.b[E].setInternalMetadata(c)}getCellFromApiCell(E){return this.b.find(c=>c.apiCell===E)}getCellFromIndex(E){return this.b[E]}getCell(E){return this.b.find(c=>c.handle===E)}getCellIndex(E){return this.b.indexOf(E)}}e.$fac=$}),define(Ae[206],Re([1,0,5,2,8,7]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=void 0;class P{constructor(k,$,R,E={timeout:1500,errors:3}){this.b=k,this.c=$,this.d=R,this.f=E,this.a=new w.$9c}dispose(){}getOnWillSaveNotebookDocumentEvent(k){return($,R,E)=>{const c=function(b){$.call(R,b)};return c.extension=k,this.a.event(c,void 0,E)}}async $participateInSave(k,$,R){const E=L.URI.revive(k),c=this.c.getNotebookDocument(E);if(!c)throw new Error("Unable to resolve notebook document");const y=[];if(await this.a.fireAsync({notebook:c.apiNotebook,reason:I.TextDocumentSaveReason.to($)},R,async(o,t)=>{const i=Date.now(),a=await await Promise.resolve(o);Date.now()-i>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!R.isCancellationRequested&&a&&(a instanceof z.$JJ?y.push(a):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if(y.length===0)return!0;const b={edits:[]};for(const o of y){const{edits:t}=I.WorkspaceEdit.from(o);b.edits=b.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(b)}}e.$Fac=P}),define(Ae[103],Re([1,0,11,8,7]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gac=void 0;class z{static{this.apiEditorsToExtHost=new WeakMap}constructor(d,k,$,R,E,c){this.id=d,this.f=k,this.notebookData=$,this.a=[],this.b=[],this.d=!1,this.a=E,this.b=R,this.c=c}get apiEditor(){if(!this.e){const d=this;this.e={get notebook(){return d.notebookData.apiNotebook},get selection(){return d.a[0]},set selection(k){this.selections=[k]},get selections(){return d.a},set selections(k){if(!Array.isArray(k)||!k.every(I.$XK.isNotebookRange))throw(0,w.$5)("selections");d.a=k,d.g(k)},get visibleRanges(){return d.b},revealRange(k,$){d.f.$tryRevealRange(d.id,L.NotebookRange.from(k),$??I.NotebookEditorRevealType.Default)},get viewColumn(){return d.c}},z.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(d){this.d=d}_acceptVisibleRanges(d){this.b=d}_acceptSelections(d){this.a=d}g(d){this.f.$trySetSelections(this.id,d.map(L.NotebookRange.from))}_acceptViewColumn(d){this.c=d}}e.$gac=z}),define(Ae[207],Re([1,0,11,5,14,8]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=void 0;let P=class{constructor(k,$){this.c=k,this.d=$,this.a=new L.$7c({onListenerError:w.$Z}),this.b=new L.$7c({onListenerError:w.$Z}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(k,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,$);const R=this.d.getEditorById(k);$.visibleRanges&&R._acceptVisibleRanges($.visibleRanges.ranges.map(z.NotebookRange.to)),$.selections&&R._acceptSelections($.selections.selections.map(z.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const $ in k)this.d.getEditorById($)._acceptViewColumn(z.ViewColumn.to(k[$]))}};e.$yac=P,e.$yac=P=qe([Ve(0,I.$Pi)],P)}),define(Ae[208],Re([1,0,8,177,152,20,66,11]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C_b=void 0;class k{constructor(c){this.b=0,this.c=new Map,this.a=c}async withProgress(c,y,b){const o=this.b++,{title:t,location:i,cancellable:a}=y,m={label:(0,I.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this.a.$startProgress(o,{location:w.ProgressLocation.from(i),title:t,source:m,cancellable:a},c.isUnderDevelopment?void 0:c.identifier.value).catch(d.$Z),this.d(o,b,!!a)}d(c,y,b){let o;b&&(o=new z.$dd,this.c.set(c,o));const t=a=>{this.a.$progressEnd(a),this.c.delete(a),o?.dispose()};let i;try{i=y(new R(this.a,c),b&&o?o.token:z.CancellationToken.None)}catch(a){throw t(c),a}return i.then(a=>t(c),a=>t(c)),i}$acceptProgressCanceled(c){const y=this.c.get(c);y&&(y.cancel(),this.c.delete(c))}}e.$C_b=k;function $(E,c){return E.message=c.message,typeof c.increment=="number"&&(typeof E.increment=="number"?E.increment+=c.increment:E.increment=c.increment),E}class R extends L.$Lu{constructor(c,y){super(b=>this.throttledReport(b)),this.f=c,this.g=y}throttledReport(c){this.f.$progressReport(this.g,c)}}qe([(0,P.$Tg)(100,(E,c)=>$(E,c),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Ae[104],Re([1,0,44,101,45,76,57,8,2]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OL=e.$NL=e.$ML=e.$LL=void 0;const $=(m,S,C,r)=>{let h=S;return{enumerable:!0,configurable:!1,get(){return h},set(n){if(!C(h,n)){const s=h;h=n,m.listener?.(r(n,s))}}}},R=(m,S)=>m===S,E={range:(m,S)=>m===S?!0:!m||!S?!1:m.isEqual(S),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(m,S)=>!(m.length!==S.length||m.some(C=>!S.find(r=>C.id===r.id)))},c=m=>S=>({op:4,update:m(S)}),y=(m,S)=>({range:(()=>{let C;const r=c(h=>({range:w.$Mr.lift(d.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return C},set(h){m.listener?.({op:6}),E.range(C,h)||(C=h,m.listener?.(r(h)))}}})(),label:$(m,S,E.label,c(C=>({label:C}))),description:$(m,void 0,E.description,c(C=>({description:C}))),sortText:$(m,void 0,E.sortText,c(C=>({sortText:C}))),canResolveChildren:$(m,!1,E.canResolveChildren,C=>({op:2,state:C})),busy:$(m,!1,E.busy,c(C=>({busy:C}))),error:$(m,void 0,E.error,c(C=>({error:d.MarkdownString.fromStrict(C)||null}))),tags:$(m,[],E.tags,(C,r)=>({op:1,new:C.map(d.TestTag.from),old:r.map(d.TestTag.from)}))}),b=m=>{const S=I.$jI.fromString(m.extId),C=new t(S.controllerId,S.localId,m.label,k.URI.revive(m.uri)||void 0);return C.range=d.Range.to(m.range||void 0),C.description=m.description||void 0,C.sortText=m.sortText||void 0,C.tags=m.tags.map(r=>d.TestTag.to({id:(0,P.$oI)(r).tagId})),C},o=m=>{let S;for(const C of m.tests){const r=b(C.item);(0,L.$vL)(r).parent=S,S=r}return S};e.$LL=o;class t{constructor(S,C,r,h){if(C.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(C)} symbol`);const n=(0,L.$uL)(this,S);Object.defineProperties(this,{id:{value:C,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof i?void 0:n.parent}},children:{value:(0,z.$tL)(n,L.$vL,t),enumerable:!0,writable:!1},...y(n,r)})}}e.$ML=t;class i extends t{constructor(S,C){super(S,S,C,void 0),this._isRoot=!0}}e.$NL=i;class a extends z.$pL{constructor(S,C,r){super({controllerId:S,getDocumentVersion:h=>h&&r.getDocument(h)?.version,getApiFor:L.$vL,getChildren:h=>h.children,root:new i(S,C),toITestItem:d.TestItem.from})}}e.$OL=a}),define(Ae[105],Re([1,0,50,11,88,8,7]),function($e,e,w,L,I,z,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IL=e.$HL=e.$GL=void 0;class d{static{this.c=new I.$EL("TextEditorDecorationType")}constructor(c,y,b){const o=d.c.nextId();c.$registerTextEditorDecorationType(y.identifier,o,z.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:o,dispose(){c.$removeTextEditorDecorationType(o)}})}}e.$GL=d;class k{constructor(c,y){this.g=[],this.h=void 0,this.j=!1,this.c=c,this.d=c.version,this.e=y.undoStopBefore,this.f=y.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(c,y){this.k();let b=null;if(c instanceof P.$AJ)b=new P.$BJ(c,c);else if(c instanceof P.$BJ)b=c;else throw new Error("Unrecognized location");this.l(b,y,!1)}insert(c,y){this.k(),this.l(new P.$BJ(c,c),y,!0)}delete(c){this.k();let y=null;if(c instanceof P.$BJ)y=c;else throw new Error("Unrecognized location");this.l(y,null,!0)}l(c,y,b){const o=this.c.validateRange(c);this.g.push({range:o,text:y,forceMoveMarkers:b})}setEndOfLine(c){if(this.k(),c!==P.EndOfLine.LF&&c!==P.EndOfLine.CRLF)throw(0,L.$5)("endOfLine");this.h=c}}class ${constructor(c,y,b,o){this.c=c,this.d=y,this._accept(b),this.e=o;const t=this;this.value={get tabSize(){return t.f},set tabSize(i){t.m(i)},get indentSize(){return t.g},set indentSize(i){t.o(i)},get insertSpaces(){return t.h},set insertSpaces(i){t.q(i)},get cursorStyle(){return t.j},set cursorStyle(i){t.s(i)},get lineNumbers(){return t.k},set lineNumbers(i){t.t(i)}}}_accept(c){this.f=c.tabSize,this.g=c.indentSize,this.h=c.insertSpaces,this.j=c.cursorStyle,this.k=z.TextEditorLineNumbersStyle.to(c.lineNumbers)}l(c){if(c==="auto")return"auto";if(typeof c=="number"){const y=Math.floor(c);return y>0?y:null}if(typeof c=="string"){const y=parseInt(c,10);return isNaN(y)?null:y>0?y:null}return null}m(c){const y=this.l(c);if(y!==null){if(typeof y=="number"){if(this.f===y)return;this.f=y}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:y}))}}n(c){if(c==="tabSize")return"tabSize";if(typeof c=="number"){const y=Math.floor(c);return y>0?y:null}if(typeof c=="string"){const y=parseInt(c,10);return isNaN(y)?null:y>0?y:null}return null}o(c){const y=this.n(c);if(y!==null){if(typeof y=="number"){if(this.g===y)return;this.g=y}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:y}))}}p(c){return c==="auto"?"auto":c==="false"?!1:!!c}q(c){const y=this.p(c);if(typeof y=="boolean"){if(this.h===y)return;this.h=y}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:y}))}s(c){this.j!==c&&(this.j=c,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:c})))}t(c){this.k!==c&&(this.k=c,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:z.TextEditorLineNumbersStyle.from(c)})))}assign(c){const y={};let b=!1;if(typeof c.tabSize<"u"){const o=this.l(c.tabSize);o==="auto"?(b=!0,y.tabSize=o):typeof o=="number"&&this.f!==o&&(this.f=o,b=!0,y.tabSize=o)}if(typeof c.indentSize<"u"){const o=this.n(c.indentSize);o==="tabSize"?(b=!0,y.indentSize=o):typeof o=="number"&&this.g!==o&&(this.g=o,b=!0,y.indentSize=o)}if(typeof c.insertSpaces<"u"){const o=this.p(c.insertSpaces);o==="auto"?(b=!0,y.insertSpaces=o):this.h!==o&&(this.h=o,b=!0,y.insertSpaces=o)}typeof c.cursorStyle<"u"&&this.j!==c.cursorStyle&&(this.j=c.cursorStyle,b=!0,y.cursorStyle=c.cursorStyle),typeof c.lineNumbers<"u"&&this.k!==c.lineNumbers&&(this.k=c.lineNumbers,b=!0,y.lineNumbers=z.TextEditorLineNumbersStyle.from(c.lineNumbers)),b&&this.u("setOptions",this.c.$trySetOptions(this.d,y))}u(c,y){y.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this.e.warn(b)})}}e.$HL=$;class R{constructor(c,y,b,o,t,i,a,m){this.id=c,this.j=y,this.k=b,this.g=!1,this.h=new Set,this.c=t,this.d=new $(this.j,this.id,i,b),this.e=a,this.f=m;const S=this;this.value=Object.freeze({get document(){return o.value},set document(C){throw(0,L.$7)("document")},get selection(){return S.c&&S.c[0]},set selection(C){if(!(C instanceof P.$CJ))throw(0,L.$5)("selection");S.c=[C],S.l()},get selections(){return S.c},set selections(C){if(!Array.isArray(C)||C.some(r=>!(r instanceof P.$CJ)))throw(0,L.$5)("selections");S.c=C,S.l()},get visibleRanges(){return S.e},set visibleRanges(C){throw(0,L.$7)("visibleRanges")},get options(){return S.d.value},set options(C){S.g||S.d.assign(C)},get viewColumn(){return S.f},set viewColumn(C){throw(0,L.$7)("viewColumn")},edit(C,r={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new k(o.value,r);return C(h),S.m(h)},insertSnippet(C,r,h={undoStopBefore:!0,undoStopAfter:!0}){if(S.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!r||Array.isArray(r)&&r.length===0)n=S.c.map(s=>z.Range.from(s));else if(r instanceof P.$AJ){const{lineNumber:s,column:p}=z.Position.from(r);n=[{startLineNumber:s,startColumn:p,endLineNumber:s,endColumn:p}]}else if(r instanceof P.$BJ)n=[z.Range.from(r)];else{n=[];for(const s of r)if(s instanceof P.$BJ)n.push(z.Range.from(s));else{const{lineNumber:p,column:D}=z.Position.from(s);n.push({startLineNumber:p,startColumn:D,endLineNumber:p,endColumn:D})}}return y.$tryInsertSnippet(c,o.value.version,C.value,n,h)},setDecorations(C,r){const h=r.length===0;h&&!S.h.has(C.key)||(h?S.h.delete(C.key):S.h.add(C.key),S.n(()=>{if(z.$wL(r))return y.$trySetDecorations(c,C.key,z.$xL(r));{const n=new Array(4*r.length);for(let s=0,p=r.length;s<p;s++){const D=r[s];n[4*s]=D.start.line+1,n[4*s+1]=D.start.character+1,n[4*s+2]=D.end.line+1,n[4*s+3]=D.end.character+1}return y.$trySetDecorationsFast(c,C.key,n)}}))},revealRange(C,r){S.n(()=>y.$tryRevealRange(c,z.Range.from(C),r||P.TextEditorRevealType.Default))},show(C){y.$tryShowEditor(c,z.ViewColumn.from(C))},hide(){y.$tryHideEditor(c)}})}dispose(){(0,w.ok)(!this.g),this.g=!0}_acceptOptions(c){(0,w.ok)(!this.g),this.d._accept(c)}_acceptVisibleRanges(c){(0,w.ok)(!this.g),this.e=c}_acceptViewColumn(c){(0,w.ok)(!this.g),this.f=c}_acceptSelections(c){(0,w.ok)(!this.g),this.c=c}async l(){const c=this.c.map(z.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,c)),this.value}m(c){const y=c.finalize();if(y.edits.length===0&&!y.setEndOfLine)return Promise.resolve(!0);const b=y.edits.map(t=>t.range);b.sort((t,i)=>t.end.line===i.end.line?t.end.character===i.end.character?t.start.line===i.start.line?t.start.character-i.start.character:t.start.line-i.start.line:t.end.character-i.end.character:t.end.line-i.end.line);for(let t=0,i=b.length-1;t<i;t++){const a=b[t].end;if(b[t+1].start.isBefore(a))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=y.edits.map(t=>({range:z.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,y.documentVersionId,o,{setEndOfLine:typeof y.setEndOfLine=="number"?z.EndOfLine.from(y.setEndOfLine):void 0,undoStopBefore:y.undoStopBefore,undoStopAfter:y.undoStopAfter})}n(c){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,y=>(y instanceof Error&&y.name==="DISPOSED"||this.k.warn(y),null))}}e.$IL=R}),define(Ae[209],Re([1,0,3,171]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NI=void 0,e.$NI=(0,w.$oh)(L.$uh)}),define(Ae[106],Re([1,0,21,5,19,6]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o1b=e.$n1b=e.$m1b=e.$l1b=e.$k1b=void 0;class P{constructor(t){this.removedDueToLooping=t}}e.$k1b=P;class d{static isHostExtension(t,i,a){if(i.getExtensionDescription(t))return!1;const m=a.getExtensionDescription(t);return m?!!((m.main||m.browser)&&m.api==="none"):!1}constructor(t,i){this.h=t,this.c=new L.$7c,this.onDidChange=this.c.event,this.d=i,this.j()}j(){this.d.sort(y),this.e=new w.$Hl,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const i=this.h.readActivationEvents(t);if(Array.isArray(i))for(let a of i)a==="onUri"&&(a=`onUri:${w.$Fl.toKey(t.identifier)}`),this.g.has(a)||this.g.set(a,[]),this.g.get(a).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,i){this.d=b(this.d,i),this.d=this.d.concat(t);const a=d.k(this.d);return this.d=b(this.d,a.map(m=>m.identifier)),this.j(),this.c.fire(void 0),new P(a)}static k(t){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,h){this.addNode(r),this.addNode(h),this.c.has(r)?this.c.get(r).push(h):this.c.set(r,[h])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,h){const n=i.getArcs(r);for(let s=0;s<n.length;s++)if(!h.has(n[s]))return!1;return!0}getNodes(){return this.e}},a=new w.$Hl;for(const r of t)if(a.set(r.identifier,r),r.extensionDependencies)for(const h of r.extensionDependencies)i.addArc(w.$Fl.toKey(r.identifier),w.$Fl.toKey(h));const m=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>m.add(r));const S=i.getNodes().filter(r=>!m.has(r));let C;do{C=!1;for(let r=0;r<S.length;r++){const h=S[r];i.hasOnlyGoodArcs(h,m)&&(S.splice(r,1),r--,m.add(h),C=!0)}}while(C);return S.map(r=>a.get(r))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const i=this.g.get(t);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const i=this.e.get(t);return i||void 0}getExtensionDescriptionByUUID(t){for(const i of this.f)if(i.uuid===t)return i}getExtensionDescriptionByIdOrUUID(t,i){return this.getExtensionDescription(t)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$l1b=d,e.$m1b={readActivationEvents:o=>o.activationEvents};class k{constructor(t){this.d=new E,this.c=new d(t,[])}async acquireLock(t){const i=await this.d.acquire(t);return new $(this,i)}deltaExtensions(t,i,a){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,a)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,i){return this.c.getExtensionDescriptionByIdOrUUID(t,i)}}e.$n1b=k;class $ extends z.$lb{constructor(t,i){super(),this.f=t,this.c=!1,this.B(i)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$o1b=$;class R{constructor(t){this.name=t,this.promise=new Promise((i,a)=>{this.c=i})}resolve(t){this.c(t)}}class E{constructor(){this.c=[],this.d=!1}async acquire(t){const i=new R(t);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let i=!0;const a=setTimeout(()=>{i&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),m=()=>{i&&(clearTimeout(a),i=!1,this.d=!1,this.e())};t.resolve((0,z.$jb)(m))}}var c;(function(o){o[o.Builtin=0]="Builtin",o[o.User=1]="User",o[o.Dev=2]="Dev"})(c||(c={}));function y(o,t){const i=o.isBuiltin?0:o.isUnderDevelopment?2:1,a=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(i!==a)return i-a;const m=I.$0b.basename(o.extensionLocation.path),S=I.$0b.basename(t.extensionLocation.path);return m<S?-1:m>S?1:0}function b(o,t){const i=new w.$Gl(t);return o.filter(a=>!i.has(a.identifier))}}),define(Ae[79],Re([1,0,25]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$Ol=e.$Nl=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function($){$[$.Desktop=1]="Desktop",$[$.Web=2]="Web"})(L||(e.UIKind=L={}));var I;(function($){$[$.VersionMismatch=55]="VersionMismatch",$[$.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var z;(function($){$[$.Initialized=0]="Initialized",$[$.Ready=1]="Ready",$[$.Terminate=2]="Terminate"})(z||(e.MessageType=z={}));function P($){const R=w.$Jb.alloc(1);switch($){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$Nl=P;function d($,R){if($.byteLength!==1)return!1;switch($.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$Ol=d;var k;(function($){$.Start="START_NATIVE_LOG",$.End="END_NATIVE_LOG"})(k||(e.NativeLogMarkers=k={}))}),define(Ae[58],Re([1,0,3,5,14,27,79,51,53,24,2,6,154]),function($e,e,w,L,I,z,P,d,k,$,R,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.$SL=e.$RL=e.$QL=void 0;let y=class extends E.$lb{constructor(i,a){super(),this.n=i,this.p=a,this.a=this.B(new L.$7c),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.$7c),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=R.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=a.createLogger(this.j,{id:k.$5n,name:(0,c.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(a.onDidChangeLogLevel(m=>{(0,I.$Ri)(m)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(i,a,m){const S=this.getTelemetryDetails(),C=new b(a,m,i,this.k,this.i,this.getBuiltInCommonProperties(i),{isUsageEnabled:S.isUsageEnabled,isErrorsEnabled:S.isErrorsEnabled}),r=this.m.get(i.identifier.value)??[];return this.m.set(i.identifier.value,[...r,C]),C.apiTelemetryLogger}$initializeTelemetryLevel(i,a,m){this.f=i,this.g=a,this.c=m??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(i){const a=Object.create(null);switch(a["common.extname"]=`${i.publisher}.${i.name}`,a["common.extversion"]=i.version,a["common.vscodemachineid"]=this.n.telemetryInfo.machineId,a["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,a["common.vscodeversion"]=this.n.version,a["common.isnewappinstall"]=o(this.n.telemetryInfo.firstSessionDate),a["common.product"]=this.n.environment.appHost,this.n.uiKind){case P.UIKind.Web:a["common.uikind"]="web";break;case P.UIKind.Desktop:a["common.uikind"]="desktop";break;default:a["common.uikind"]="unknown"}return a["common.remotename"]=(0,d.$Ak)((0,k.$_n)(this.n.remote.authority)),a}$onDidChangeTelemetryLevel(i){this.h=this.getTelemetryConfiguration(),this.f=i;const a=this.getTelemetryDetails();this.m.forEach((m,S)=>{const C=m.filter(r=>!r.isDisposed);C.length===0?this.m.delete(S):this.m.set(S,C)}),this.m.forEach(m=>{for(const S of m)S.updateTelemetryEnablements(a.isUsageEnabled,a.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(i,a){const S=this.m.get(i.value)?.filter(r=>!r.isDisposed);if(!S)return this.m.delete(i.value),!1;let C=!1;for(const r of S)r.ignoreUnhandledExtHostErrors||(r.logError(a),C=!0);return C}};e.$QL=y,e.$QL=y=qe([Ve(0,z.$PL),Ve(1,I.$Qi)],y);class b{static validateSender(i){if(typeof i!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof i.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof i.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof i.flush<"u"&&typeof i.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(i,a,m,S,C,r,h){this.g=m,this.h=S,this.i=C,this.j=r,this.a=new L.$7c,this.ignoreUnhandledExtHostErrors=a?.ignoreUnhandledErrors??!1,this.b=a?.ignoreBuiltInCommonProperties??!1,this.c=a?.additionalCommonProperties,this.f=i,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(i,a){this.e&&(this.d={isUsageEnabled:i,isErrorsEnabled:a},this.a.fire(this.e))}mixInCommonPropsAndCleanData(i){let a="properties"in i?i.properties??{}:i;return a=(0,k.$co)(a,[]),this.c&&(a=(0,$.$Im)(a,this.c)),this.b||(a=(0,$.$Im)(a,this.j)),"properties"in i?i.properties=a:i=a,i}k(i,a){this.f&&(this.g.publisher==="vscode"?i=this.g.name+"/"+i:i=this.g.identifier.value+"/"+i,a=this.mixInCommonPropsAndCleanData(a||{}),this.i||this.f?.sendEventData(i,a),this.h.trace(i,a))}logUsage(i,a){this.d.isUsageEnabled&&this.k(i,a)}logError(i,a){!this.d.isErrorsEnabled||!this.f||(typeof i=="string"?this.k(i,a):this.f.sendErrorData(i,a))}get apiTelemetryLogger(){if(!this.e){const i=this,a={logUsage:i.logUsage.bind(i),get isUsageEnabled(){return i.d.isUsageEnabled},get isErrorsEnabled(){return i.d.isErrorsEnabled},logError:i.logError.bind(i),dispose:i.dispose.bind(i),onDidChangeEnableStates:i.a.event.bind(i)};this.e=Object.freeze(a)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let i=this.f;this.f=void 0,Promise.resolve(i.flush()).then(i=void 0),this.e=void 0}else this.f=void 0}}e.$RL=b;function o(t){const i=Date.now()-new Date(t).getTime();return isNaN(i)?!1:i<1e3*60*60*24}e.$SL=o,e.$TL=(0,w.$nh)("IExtHostTelemetry")}),define(Ae[26],Re([1,0,5,2,181,98,21,3]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BF=e.$AF=e.$zF=e.ActivationKind=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=e.ExtensionHostStartup=e.$tF=e.$sF=e.$rF=e.$qF=void 0,e.$qF=Object.freeze({identifier:new P.$Fl("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$rF="extensions.webWorker",e.$sF=(0,d.$nh)("extensionService");class k{constructor(C){this.dependency=C}}e.$tF=k;var $;(function(S){S[S.EagerAutoStart=1]="EagerAutoStart",S[S.EagerManualStart=2]="EagerManualStart",S[S.Lazy=3]="Lazy"})($||(e.ExtensionHostStartup=$={}));class R{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:z.$hF.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(C,r){const h=[],n=[],s=[],p=[],D=E(this.c),l=E(C),g=(W,B)=>W.extensionLocation.toString()===B.extensionLocation.toString()||W.isBuiltin===B.isBuiltin||W.isUserBuiltin===B.isUserBuiltin||W.isUnderDevelopment===B.isUnderDevelopment;for(const W of this.c){const B=l.get(W.identifier);if(!B){h.push(W.identifier),D.delete(W.identifier);continue}if(!g(W,B)){h.push(W.identifier),D.delete(W.identifier);continue}}for(const W of C){const B=D.get(W.identifier);if(!B){n.push(W);continue}if(!g(B,W)){h.push(B.identifier),D.delete(B.identifier);continue}}const v=new P.$Gl(this.d),u=new P.$Gl(r);for(const W of this.d)u.has(W)||s.push(W);for(const W of r)v.has(W)||p.push(W);const f=z.$hF.createActivationEventsMap(n),A={toRemove:h,toAdd:n,addActivationEvents:f,myToRemove:s,myToAdd:p};return this.delta(A),A}delta(C){const{toRemove:r,toAdd:h,myToRemove:n,myToAdd:s}=C,p=new P.$Gl(r),D=new P.$Gl(n);for(let l=0;l<this.c.length;l++)p.has(this.c[l].identifier)&&(this.c.splice(l,1),l--);for(let l=0;l<this.d.length;l++)D.has(this.d[l])&&(this.d.splice(l,1),l--);for(const l of h)this.c.push(l);for(const l of s)this.d.push(l)}containsExtension(C){for(const r of this.d)if(P.$Fl.equals(r,C))return!0;return!1}}e.$uF=R;function E(S){const C=new P.$Hl;for(const r of S)C.set(r.identifier,r);return C}function c(S,C){return S.enabledApiProposals?S.enabledApiProposals.includes(C):!1}e.$vF=c;function y(S,C){if(!c(S,C))throw new Error(`Extension '${S.identifier.value}' CANNOT use API proposal: ${C}.
Its package.json#enabledApiProposals-property declares: ${S.enabledApiProposals?.join(", ")??"[]"} but NOT ${C}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${S.identifier.value}`)}e.$wF=y;class b{constructor(C,r,h,n){this.codeLoadingTime=C,this.activateCallTime=r,this.activateResolvedTime=h,this.activationReason=n}}e.$xF=b;class o{constructor(C,r){this.description=C,this.value=r}}e.$yF=o;var t;(function(S){S[S.Normal=0]="Normal",S[S.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function i(S){return{type:S.isBuiltin?0:1,isBuiltin:S.isBuiltin||S.isUserBuiltin,identifier:{id:(0,I.$io)(S.publisher,S.name),uuid:S.uuid},manifest:S,location:S.extensionLocation,targetPlatform:S.targetPlatform,validations:[],isValid:!0}}e.$zF=i;function a(S,C){return{identifier:new P.$Fl((0,I.$go)(S.manifest.publisher,S.manifest.name)),isBuiltin:S.type===0,isUserBuiltin:S.type===1&&S.isBuiltin,isUnderDevelopment:!!C,extensionLocation:S.location,...S.manifest,uuid:S.identifier.uuid,targetPlatform:S.targetPlatform}}e.$AF=a;class m{constructor(){this.onDidRegisterExtensions=w.Event.None,this.onDidChangeExtensionsStatus=w.Event.None,this.onDidChangeExtensions=w.Event.None,this.onWillActivateByEvent=w.Event.None,this.onDidChangeResponsiveChange=w.Event.None,this.onWillStop=w.Event.None,this.extensions=[]}activateByEvent(C){return Promise.resolve(void 0)}activationEventIsDone(C){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(C){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(C,r){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(C){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$BF=m}),define(Ae[210],Re([1,0,11,106,21,26,14,16]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=e.$9$b=e.$8$b=e.$7$b=e.$6$b=e.$5$b=void 0;class k{static{this.NONE=new k(!1,-1,-1,-1)}constructor(i,a,m,S){this.startup=i,this.codeLoadingTime=a,this.activateCallTime=m,this.activateResolvedTime=S}}e.$5$b=k;class ${constructor(i){this.a=i,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(i,a){return i===-1||a===-1?-1:a-i}build(){return new k(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$6$b=$;class R{constructor(i,a,m,S,C,r){this.activationFailed=i,this.activationFailedError=a,this.activationTimes=m,this.module=S,this.exports=C,this.subscriptions=r}}e.$7$b=R;class E extends R{constructor(i){super(!1,null,i,{activate:void 0,deactivate:void 0},void 0,[])}}e.$8$b=E;class c extends R{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$9$b=c;class y extends R{constructor(i){super(!0,i,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(i,a,m,S){this.g=S,this.a=i,this.b=a,this.c=m,this.d=new I.$Hl,this.f=Object.create(null)}dispose(){for(const[i,a]of this.d)a.dispose()}async waitForActivatingExtensions(){const i=[];for(const[a,m]of this.d)i.push(m.wait());await Promise.all(i)}isActivated(i){const a=this.d.get(i);return!!(a&&a.value)}getActivatedExtension(i){const a=this.d.get(i);if(!a||!a.value)throw new Error(`Extension '${i.value}' is not known or not activated`);return a.value}async activateByEvent(i,a){if(this.f[i])return;const m=this.a.getExtensionDescriptionsForActivationEvent(i);await this.h(m.map(S=>({id:S.identifier,reason:{startup:a,extensionId:S.identifier,activationEvent:i}}))),this.f[i]=!0}activateById(i,a){const m=this.a.getExtensionDescription(i);if(!m)throw new Error(`Extension '${i}' is not known`);return this.h([{id:m.identifier,reason:a}])}async h(i){const a=i.filter(m=>!this.isActivated(m.id)).map(m=>this.j(m));await Promise.all(a.map(m=>m.wait()))}j(i){if(this.d.has(i.id))return this.d.get(i.id);if(this.l(i.id))return this.k(i,null,[],null);const a=this.a.getExtensionDescription(i.id);if(!a){const C=new Error(`Cannot activate unknown extension '${i.id.value}'`),r=this.k(i,null,[],new y(C));return this.c.onExtensionActivationError(i.id,C,new z.$tF(i.id.value)),r}const m=[],S=typeof a.extensionDependencies>"u"?[]:a.extensionDependencies;for(const C of S){if(this.m(C))continue;const r=this.d.get(C);if(r){m.push(r);continue}if(this.l(C)){m.push(this.j({id:this.b.getExtensionDescription(C).identifier,reason:i.reason}));continue}const h=this.a.getExtensionDescription(C);if(h){if(!h.main&&!h.browser)continue;m.push(this.j({id:h.identifier,reason:i.reason}));continue}const n=a.displayName||a.identifier.value,s=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${C}'`),p=this.k(i,a.displayName,[],new y(s));return this.c.onExtensionActivationError(a.identifier,s,new z.$tF(C)),p}return this.k(i,a.displayName,m,null)}k(i,a,m,S){const C=new o(i.id,a,i.reason,m,S,this.c,this.g);return this.d.set(i.id,C),C}l(i){return L.$l1b.isHostExtension(i,this.a,this.b)}m(i){const a=this.b.getExtensionDescription(i);return a?!a.main&&!a.browser:!1}};e.$0$b=b,e.$0$b=b=qe([Ve(3,P.$Pi)],b);let o=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(i,a,m,S,C,r,h){this.c=i,this.d=a,this.f=m,this.g=S,this.h=C,this.j=r,this.k=h,this.a=new d.$sg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let i=0;i<this.g.length;i++){const a=this.g[i];if(a.value&&!a.value.activationFailed){this.g.splice(i,1),i--;continue}if(a.value&&a.value.activationFailed){const m=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);m.detail=a.value.activationFailedError,this.h=new y(m),this.j.onExtensionActivationError(this.c,m,null);return}}this.g.length>0&&await Promise.race(this.g.map(i=>i.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(i){const a=new Error;if(i&&i.name&&(a.name=i.name),i&&i.message?a.message=`Activating extension '${this.c.value}' failed: ${i.message}.`:a.message=`Activating extension '${this.c.value}' failed: ${i}.`,i&&i.stack&&(a.stack=i.stack),this.h=new y(a),this.b&&w.$2(i))return;this.j.onExtensionActivationError(this.c,a,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(i)}}};o=qe([Ve(6,P.$Pi)],o)}),define(Ae[211],Re([1,0,156,7,23,2,5,6,193,16,7,12,18,8,49,20,125,26]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=void 0;function a(C,r){if((0,E.$ie)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let h;return Array.isArray(C.highlights)&&(h=C.highlights.filter(n=>n.length===2&&typeof n[0]=="number"&&typeof n[1]=="number"),h=h.length?h:void 0),{label:C.label,highlights:h}}}class m{constructor(r,h,n){this.d=r,this.e=h,this.f=n,this.a=new Map,this.b=new t.$s5;function s(p){return p&&p.$treeViewId&&(p.$treeItemHandle||p.$selectedTreeItems||p.$focusedTreeItem)}h.registerArgumentProcessor({processArgument:p=>s(p)?this.i(p):Array.isArray(p)&&p.length>0?p.map(D=>s(D)?this.i(D):D):p})}registerTreeDataProvider(r,h,n){const s=this.createTreeView(r,{treeDataProvider:h},n);return{dispose:()=>s.dispose()}}createTreeView(r,h,n){if(!h||!h.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=h.dragAndDropController?.dropMimeTypes??[],p=h.dragAndDropController?.dragMimeTypes??[],D=!!h.dragAndDropController?.handleDrag,l=!!h.dragAndDropController?.handleDrop,g=this.h(r,h,n),v={showCollapseAll:!!h.showCollapseAll,canSelectMany:!!h.canSelectMany,dropMimeTypes:s,dragMimeTypes:p,hasHandleDrag:D,hasHandleDrop:l,manuallyManageCheckboxes:!!h.manageCheckboxStateManually},u=this.d.$registerTreeViewDataProvider(r,v);return{get onDidCollapseElement(){return g.onDidCollapseElement},get onDidExpandElement(){return g.onDidExpandElement},get selection(){return g.selectedElements},get onDidChangeSelection(){return g.onDidChangeSelection},get activeItem(){return(0,i.$wF)(n,"treeViewActiveItem"),g.focusedElement},get onDidChangeActiveItem(){return(0,i.$wF)(n,"treeViewActiveItem"),g.onDidChangeActiveItem},get visible(){return g.visible},get onDidChangeVisibility(){return g.onDidChangeVisibility},get onDidChangeCheckboxState(){return g.onDidChangeCheckboxState},get message(){return g.message},set message(A){(0,b.$Kj)(A)&&(0,i.$wF)(n,"treeViewMarkdownMessage"),g.message=A},get title(){return g.title},set title(A){g.title=A},get description(){return g.description},set description(A){g.description=A},get badge(){return g.badge},set badge(A){A!==void 0&&R.ViewBadge.isViewBadge(A)?g.badge={value:Math.floor(Math.abs(A.value)),tooltip:A.tooltip}:A===void 0&&(g.badge=void 0)},reveal:(A,W)=>g.reveal(A,W),dispose:async()=>{await u,this.a.delete(r),g.dispose()}}}$getChildren(r,h){const n=this.a.get(r);return n?n.getChildren(h):Promise.reject(new k.$UE(r))}async $handleDrop(r,h,n,s,p,D,l,g){const v=this.a.get(r);if(!v)return Promise.reject(new k.$UE(r));const u=y.DataTransfer.toDataTransfer(n,async f=>(await this.d.$resolveDropFileData(r,h,f)).buffer);return l===r&&g&&await this.g(u,v,g,p,D),v.onDrop(u,s,p)}async g(r,h,n,s,p){const D=this.b.removeDragOperationTransfer(p);if(D)(await D)?.forEach((l,g)=>{l&&r.set(g,l)});else if(p&&h.handleDrag){const l=h.handleDrag(n,r,s);this.b.addDragOperationTransfer(p,l),await l}return r}async $handleDrag(r,h,n,s){const p=this.a.get(r);if(!p)return Promise.reject(new k.$UE(r));const D=await this.g(new L.$rK,p,h,s,n);if(!(!D||s.isCancellationRequested))return y.DataTransfer.from(D)}async $hasResolve(r){const h=this.a.get(r);if(!h)throw new k.$UE(r);return h.hasResolve}$resolve(r,h,n){const s=this.a.get(r);if(!s)throw new k.$UE(r);return s.resolveTreeItem(h,n)}$setExpanded(r,h,n){const s=this.a.get(r);if(!s)throw new k.$UE(r);s.setExpanded(h,n)}$setSelectionAndFocus(r,h,n){const s=this.a.get(r);if(!s)throw new k.$UE(r);s.setSelectionAndFocus(h,n)}$setVisible(r,h){const n=this.a.get(r);if(!n)throw new k.$UE(r);n.setVisible(h)}$changeCheckboxState(r,h){const n=this.a.get(r);if(!n)throw new k.$UE(r);n.setCheckboxState(h)}h(r,h,n){const s=new S(r,h,this.d,this.e.converter,this.f,n);return this.a.set(r,s),s}i(r){const h=this.a.get(r.$treeViewId);return h&&"$treeItemHandle"in r?h.getExtensionElement(r.$treeItemHandle):h&&"$focusedTreeItem"in r&&r.$focusedTreeItem?h.focusedElement:null}}e.$J_b=m;class S extends d.$lb{static{this.a="0"}static{this.b="1"}get visible(){return this.k}get selectedElements(){return this.l.map(r=>this.getExtensionElement(r)).filter(r=>!(0,E.$re)(r))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(r,h,n,s,p,D){if(super(),this.D=r,this.F=n,this.G=s,this.H=p,this.I=D,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new P.$7c),this.onDidExpandElement=this.r.event,this.s=this.B(new P.$7c),this.onDidCollapseElement=this.s.event,this.t=this.B(new P.$7c),this.onDidChangeSelection=this.t.event,this.u=this.B(new P.$7c),this.onDidChangeActiveItem=this.u.event,this.v=this.B(new P.$7c),this.onDidChangeVisibility=this.v.event,this.w=this.B(new P.$7c),this.onDidChangeCheckboxState=this.w.event,this.y=this.B(new P.$7c),this.z=Promise.resolve(),this.C=Promise.resolve(),this.J="",this.L="",this.U=new o.$dd,D.contributes&&D.contributes.views)for(const v in D.contributes.views)for(const u of D.contributes.views[v])u.id===r&&(this.L=u.name);this.f=h.treeDataProvider,this.g=h.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(v=>this.y.fire({message:!1,element:v})));let l,g;this.B(P.Event.debounce(this.y.event,(v,u)=>(v||(v={message:!1,elements:[]}),u.element!==!1&&(l||(l=new Promise(f=>g=f),this.z=this.z.then(()=>l)),Array.isArray(u.element)?v.elements.push(...u.element):v.elements.push(u.element)),u.message&&(v.message=!0),v),200,!0)(({message:v,elements:u})=>{u.length&&(this.C=this.C.then(()=>{const f=g;return l=null,this.W(u).then(()=>f())})),v&&this.F.$setMessage(this.D,y.MarkdownString.fromStrict(this.J)??"")}))}async getChildren(r){const h=r?this.getExtensionElement(r):void 0;if(r&&!h)return this.H.error(`No tree item with id '${r}' found.`),Promise.resolve([]);let n=this.R(r);return n||(n=await this.S(h)),n?n.map(s=>s.item):void 0}getExtensionElement(r){return this.i.get(r)}reveal(r,h){h=h||{select:!0,focus:!1};const n=(0,E.$re)(h.select)?!0:h.select,s=(0,E.$re)(h.focus)?!1:h.focus,p=(0,E.$re)(h.expand)?!1:h.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):r?this.z.then(()=>this.O(r)).then(D=>this.Q(r,D[D.length-1]).then(l=>this.F.$reveal(this.D,{item:l.item,parentChain:D.map(g=>g.item)},{select:n,focus:s,expand:p})),D=>this.H.error(D)):this.F.$reveal(this.D,void 0,{select:n,focus:s,expand:p})}get message(){return this.J}set message(r){this.J=r,this.y.fire({message:!0,element:!1})}get title(){return this.L}set title(r){this.L=r,this.F.$setTitle(this.D,r,this.M)}get description(){return this.M}set description(r){this.M=r,this.F.$setTitle(this.D,this.L,r)}get badge(){return this.N}set badge(r){this.N?.value===r?.value&&this.N?.tooltip===r?.tooltip||(this.N=y.ViewBadge.from(r),this.F.$setBadge(this.D,r))}setExpanded(r,h){const n=this.getExtensionElement(r);n&&(h?this.r.fire(Object.freeze({element:n})):this.s.fire(Object.freeze({element:n})))}setSelectionAndFocus(r,h){const n=!(0,c.$af)(this.l,r);this.l=r;const s=this.m!==h;this.m=h,n&&this.t.fire(Object.freeze({selection:this.selectedElements})),s&&this.u.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(r){r!==this.k&&(this.k=r,this.v.fire(Object.freeze({visible:this.k})))}async setCheckboxState(r){const h=(await Promise.all(r.map(async n=>{const s=this.getExtensionElement(n.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:n.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(n=>n!==void 0);h.forEach(n=>{n.treeItem.checkboxState=n.newState?R.TreeItemCheckboxState.Checked:R.TreeItemCheckboxState.Unchecked}),this.w.fire({items:h.map(n=>[n.extensionItem,n.newState])})}async handleDrag(r,h,n){const s=[];for(const p of r){const D=this.getExtensionElement(p);D&&s.push(D)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,h,n),h}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(r,h,n){const s=h?this.getExtensionElement(h):void 0;if(!(!s&&h||!this.g?.handleDrop))return(0,$.$mg)(()=>this.g?.handleDrop?this.g.handleDrop(s,r,n):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(r,h){if(!this.f.resolveTreeItem)return;const n=this.i.get(r);if(n){const s=this.j.get(n);if(s){const p=await this.f.resolveTreeItem(s.extensionItem,n,h)??s.extensionItem;return this.db(p),s.item.tooltip=this.ab(p.tooltip),s.item.command=this.bb(s.disposableStore,p.command),s.item}}}O(r){return this.P(r).then(h=>h?this.O(h).then(n=>this.Q(h,n[n.length-1]).then(s=>(n.push(s),n))):Promise.resolve([]))}P(r){const h=this.j.get(r);return h?Promise.resolve(h.parent?this.i.get(h.parent.item.handle):void 0):(0,$.$mg)(()=>this.f.getParent(r))}Q(r,h){const n=this.j.get(r);return n?Promise.resolve(n):(0,$.$mg)(()=>this.f.getTreeItem(r)).then(s=>this.gb(r,s,h,!0)).then(s=>this.getChildren(h?h.item.handle:void 0).then(()=>{const p=this.getExtensionElement(s);if(p){const D=this.j.get(p);if(D)return Promise.resolve(D)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.I.identifier.value}`)}))}R(r){if(r){let h;if(typeof r=="string"){const n=this.getExtensionElement(r);h=n?this.j.get(n):void 0}else h=r;return h&&h.children||void 0}return this.h}async S(r){this.nb(r);const h=new o.$dd(this.U.token);try{const n=r?this.j.get(r):void 0,s=await this.f.getChildren(r);if(h.token.isCancellationRequested)return;const p=await Promise.all((0,c.$lf)(s||[]).map(async D=>{const l=await this.f.getTreeItem(D);return l&&!h.token.isCancellationRequested?this.$(D,l,n):null}));return h.token.isCancellationRequested?void 0:(0,c.$lf)(p)}finally{h.dispose()}}W(r){if(r.some(n=>!n))return this.U.dispose(!0),this.U=new o.$dd,this.pb(),this.F.$refresh(this.D);{const n=this.X(r);if(n.length)return this.Y(n)}return Promise.resolve(void 0)}X(r){const h=new Set,n=r.map(p=>this.j.get(p));for(const p of n)if(p&&!h.has(p.item.handle)){let D=p;for(;D&&D.parent&&n.findIndex(l=>D&&D.parent&&l&&l.item.handle===D.parent.item.handle)===-1;){const l=this.i.get(D.parent.item.handle);D=l?this.j.get(l):void 0}D&&!D.parent&&h.add(p.item.handle)}const s=[];return h.forEach(p=>{const D=this.i.get(p);if(D){const l=this.j.get(D);l&&(!l.parent||!h.has(l.parent.item.handle))&&s.push(p)}}),s}Y(r){const h={};return Promise.all(r.map(n=>this.Z(n).then(s=>{s&&(h[n]=s.item)}))).then(()=>Object.keys(h).length?this.F.$refresh(this.D,h):void 0)}Z(r){const h=this.getExtensionElement(r);if(h){const n=this.j.get(h);if(n)return this.nb(h),(0,$.$mg)(()=>this.f.getTreeItem(h)).then(s=>{if(s){const p=this.eb(h,s,n.parent);return this.lb(h,p,n,n.parent),n.dispose(),p}return null})}return Promise.resolve(null)}$(r,h,n){const s=this.eb(r,h,n);if(h.id&&this.i.has(s.item.handle))throw new Error((0,w.localize)(0,null,h.id));return this.kb(r,s),this.mb(s,n),s}ab(r){return R.$1J.isMarkdownString(r)?y.MarkdownString.from(r):r}bb(r,h){return h?{...this.G.toInternal(h,r),originalId:h.command}:void 0}cb(r){if(r.checkboxState===void 0)return;let h,n,s;return typeof r.checkboxState=="number"?h=r.checkboxState:(h=r.checkboxState.state,n=r.checkboxState.tooltip,s=r.checkboxState.accessibilityInformation),{isChecked:h===R.TreeItemCheckboxState.Checked,tooltip:n,accessibilityInformation:s}}db(r){if(!R.$mK.isTreeItem(r,this.I))throw new Error(`Extension ${this.I.identifier.value} has provided an invalid tree item.`)}eb(r,h,n){this.db(h);const s=new d.$kb,p=this.gb(r,h,n),D=this.hb(h);return{item:{handle:p,parentHandle:n?n.item.handle:void 0,label:a(h.label,this.I),description:h.description,resourceUri:h.resourceUri,tooltip:this.ab(h.tooltip),command:this.bb(s,h.command),contextValue:h.contextValue,icon:D,iconDark:this.ib(h)||D,themeIcon:this.fb(h),collapsibleState:(0,E.$re)(h.collapsibleState)?R.TreeItemCollapsibleState.None:h.collapsibleState,accessibilityInformation:h.accessibilityInformation,checkbox:this.cb(h)},extensionItem:h,parent:n,children:void 0,disposableStore:s,dispose(){s.dispose()}}}fb(r){return r.iconPath instanceof R.$uK?r.iconPath:void 0}gb(r,{id:h,label:n,resourceUri:s},p,D){if(h)return`${S.b}/${h}`;const l=a(n,this.I),g=p?p.item.handle:S.a;let v=l?l.label:s?(0,I.$5f)(s):"";v=v.indexOf("/")!==-1?v.replace("/","//"):v;const u=this.j.has(r)?this.j.get(r).item.handle:void 0,f=this.R(p)||[];let A,W=0;do{if(A=`${g}/${W}:${v}`,D||!this.i.has(A)||u===A)break;W++}while(W<=f.length);return A}hb(r){if(r.iconPath&&!(r.iconPath instanceof R.$uK))return typeof r.iconPath=="string"||z.URI.isUri(r.iconPath)?this.jb(r.iconPath):this.jb(r.iconPath.light)}ib(r){if(r.iconPath&&!(r.iconPath instanceof R.$uK)&&r.iconPath.dark)return this.jb(r.iconPath.dark)}jb(r){return z.URI.isUri(r)?r:z.URI.file(r)}kb(r,h){this.i.set(h.item.handle,r),this.j.set(r,h)}lb(r,h,n,s){this.i.delete(h.item.handle),this.j.delete(r),h.item.handle!==n.item.handle&&this.i.delete(n.item.handle),this.kb(r,h);const p=this.R(s)||[],D=p.filter(l=>l.item.handle===n.item.handle)[0];D&&p.splice(p.indexOf(D),1,h)}mb(r,h){h?(h.children||(h.children=[]),h.children.push(r)):(this.h||(this.h=[]),this.h.push(r))}nb(r){if(r){const h=this.j.get(r);if(h){if(h.children)for(const n of h.children){const s=this.i.get(n.item.handle);s&&this.ob(s)}h.children=void 0}}else this.pb()}ob(r){const h=this.j.get(r);if(h){if(h.children)for(const n of h.children){const s=this.i.get(n.item.handle);s&&this.ob(s)}this.j.delete(r),this.i.delete(h.item.handle),h.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(r=>r.dispose()),this.j.clear()}dispose(){this.U.dispose(),this.pb(),this.F.$disposeTree(this.D)}}}),define(Ae[212],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionOptions.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveSlashCommands:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveSlashCommands.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageConfigurationAutoClosingPairs:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageConfigurationAutoClosingPairs.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookCodeActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCodeActions.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ae[213],Re([1,0,166,11,29,92,74,30,21,212,176,98]),function($e,e,w,L,I,z,P,d,k,$,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HF=e.$GF=e.$FF=e.$EF=e.$DF=e.$CF=void 0;const c=d.$Rm.as(P.$Sm.JSONContribution);class y{constructor(C,r,h){this.a=C,this.b=r,this.c=h}d(C,r){this.a({type:C,message:r,extensionId:this.b.identifier,extensionPointId:this.c})}error(C){this.d(I.default.Error,C)}warn(C){this.d(I.default.Warning,C)}info(C){this.d(I.default.Info,C)}}e.$CF=y;class b{static a(C){const r=new k.$Gl;for(let h=0,n=C.length;h<n;h++)r.add(C[h].description.identifier);return r}static compute(C,r){if(!C||!C.length)return new b(r,[]);if(!r||!r.length)return new b([],C);const h=this.a(C),n=this.a(r),s=r.filter(D=>!h.has(D.description.identifier)),p=C.filter(D=>!n.has(D.description.identifier));return new b(s,p)}constructor(C,r){this.added=C,this.removed=r}}e.$DF=b;class o{constructor(C,r){this.name=C,this.defaultExtensionKind=r,this.a=null,this.b=null,this.c=null}setHandler(C){if(this.a!==null)throw new Error("Handler already set!");this.a=C,this.d()}acceptUsers(C){this.c=b.compute(this.b,C),this.b=C,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(C){(0,L.$Y)(C)}}}e.$EF=o;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[w.localize(0,null),w.localize(1,null)]},i="vscode://schemas/vscode-extensions";e.$FF={properties:{engines:{type:"object",description:w.localize(2,null),properties:{vscode:{type:"string",description:w.localize(3,null),default:"^1.22.0"}}},publisher:{description:w.localize(4,null),type:"string"},displayName:{description:w.localize(5,null),type:"string"},categories:{description:w.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:k.$El},{type:"string",const:"Languages",deprecationMessage:w.localize(7,null)}]}},galleryBanner:{type:"object",description:w.localize(8,null),properties:{color:{description:w.localize(9,null),type:"string"},theme:{description:w.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:w.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:w.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:w.localize(13,null)},enabledApiProposals:{markdownDescription:w.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}},api:{markdownDescription:w.localize(15,null),type:"string",enum:["none"],enumDescriptions:[w.localize(16,null)]},activationEvents:{description:w.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:w.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:w.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:w.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:w.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:w.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:w.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:w.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:w.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:w.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:w.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:w.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:w.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:w.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:w.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:w.localize(32,null)},{label:"onUri",body:"onUri",description:w.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:w.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:w.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:w.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:w.localize(37,null)},{label:"onRenderer",description:w.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:w.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:w.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:w.localize(41,null)},{label:"*",description:w.localize(42,null),body:"*"}]}},badges:{type:"array",description:w.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:w.localize(44,null)},href:{type:"string",description:w.localize(45,null)},description:{type:"string",description:w.localize(46,null)}}}},markdown:{type:"string",description:w.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:w.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:w.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:z.$Bn}},extensionPack:{description:w.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:z.$Bn}},extensionKind:{description:w.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:w.localize(52,null)},{body:["workspace"],description:w.localize(53,null)},{body:["ui","workspace"],description:w.localize(54,null)},{body:["workspace","ui"],description:w.localize(55,null)},{body:[],description:w.localize(56,null)}]},capabilities:{description:w.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:w.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:w.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(60,null),w.localize(61,null),w.localize(62,null)]},description:{type:"string",markdownDescription:w.localize(63,null)}}},untrustedWorkspaces:{description:w.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:w.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[w.localize(66,null),w.localize(67,null),w.localize(68,null)]},restrictedConfigurations:{description:w.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:w.localize(70,null)}}}}},sponsor:{description:w.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:w.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:w.localize(73,null),type:"string"},"vscode:uninstall":{description:w.localize(74,null),type:"string"}}},icon:{type:"string",description:w.localize(75,null)},l10n:{type:"string",description:w.localize(76,null)}}};class a{constructor(){this.a=new Map}registerExtensionPoint(C){if(this.a.has(C.extensionPoint))throw new Error("Duplicate extension point: "+C.extensionPoint);const r=new o(C.extensionPoint,C.defaultExtensionKind);return this.a.set(C.extensionPoint,r),C.activationEventsGenerator&&E.$hF.register(C.extensionPoint,C.activationEventsGenerator),e.$FF.properties.contributes.properties[C.extensionPoint]=C.jsonSchema,c.registerSchema(i,e.$FF),r}getExtensionPoints(){return Array.from(this.a.values())}}e.$GF=a;const m={ExtensionsRegistry:"ExtensionsRegistry"};d.$Rm.add(m.ExtensionsRegistry,new a),e.$HF=d.$Rm.as(m.ExtensionsRegistry),c.registerSchema(i,e.$FF),c.registerSchema(R.$9i,{properties:{extensionEnabledApiProposals:{description:w.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys($.allApiProposals),markdownEnumDescriptions:Object.values($.allApiProposals)}}]}}}})}),define(Ae[214],Re([1,0,163,12,24,213,31,5]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=void 0;const k={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:w.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:w.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:w.localize(2,null),default:""}}};var $;(function(c){function y(b,o,t){if(!b)return;const i=L.$ie(b.type)?b.type:void 0;if(!i||i.length===0){t.error(w.localize(3,null));return}const a=[];if(Array.isArray(b.required))for(const m of b.required)L.$ie(m)&&a.push(m);return{extensionId:o.value,taskType:i,required:a,properties:b.properties?I.$Fm(b.properties):{},when:b.when?P.$ti.deserialize(b.when):void 0}}c.from=y})($||($={}));const R=z.$HF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(c,y)=>{for(const b of c)b.type&&y.push(`onTaskType:${b.type}`)},jsonSchema:{description:w.localize(4,null),type:"array",items:k}});class E{constructor(){this.d=new d.$7c,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((y,b)=>{R.setHandler((o,t)=>{this.c=void 0;try{for(const i of t.removed){const a=i.value;for(const m of a)this.a&&m.type&&this.a[m.type]&&delete this.a[m.type]}for(const i of t.added){const a=i.value;for(const m of a){const S=$.from(m,i.description.identifier,i.collector);S&&(this.a[S.taskType]=S)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}y(void 0)})})}onReady(){return this.b}get(y){return this.a[y]}all(){return Object.keys(this.a).map(y=>this.a[y])}getJsonSchema(){if(this.c===void 0){const y=[];for(const b of this.all()){const o={type:"object",additionalProperties:!1};b.required.length>0&&(o.required=b.required.slice(0)),b.properties!==void 0?o.properties=I.$Fm(b.properties):o.properties=Object.create(null),o.properties.type={type:"string",enum:[b.taskType]},y.push(o)}this.c={oneOf:y}}return this.c}}e.$QF=new E}),define(Ae[215],Re([1,0,164,12,23,24,31,214]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$1F=e.JsonSchemaVersion=e.ExecutionEngine=e.$ZF=e.$YF=e.$XF=e.$WF=e.$VF=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$UF=e.ShellQuoting=e.$TF=e.$SF=e.$RF=void 0,e.$RF="settings",e.$SF=new P.$Mi("taskRunning",!1,w.localize(0,null)),e.$TF={value:w.localize(1,null),original:"Tasks"};var k;(function(O){O[O.Escape=1]="Escape",O[O.Strong=2]="Strong",O[O.Weak=3]="Weak"})(k||(e.ShellQuoting=k={})),e.$UF="$customized",function(O){function N(ae){if(!ae)return O.Strong;switch(ae.toLowerCase()){case"escape":return O.Escape;case"strong":return O.Strong;case"weak":return O.Weak;default:return O.Strong}}O.from=N}(k||(e.ShellQuoting=k={}));var $;(function(O){O.defaults={cwd:"${workspaceFolder}"}})($||(e.CommandOptions=$={}));var R;(function(O){O[O.Always=1]="Always",O[O.Silent=2]="Silent",O[O.Never=3]="Never"})(R||(e.RevealKind=R={})),function(O){function N(ae){switch(ae.toLowerCase()){case"always":return O.Always;case"silent":return O.Silent;case"never":return O.Never;default:return O.Always}}O.fromString=N}(R||(e.RevealKind=R={}));var E;(function(O){O[O.Never=1]="Never",O[O.OnProblem=2]="OnProblem",O[O.Always=3]="Always"})(E||(e.RevealProblemKind=E={})),function(O){function N(ae){switch(ae.toLowerCase()){case"always":return O.Always;case"never":return O.Never;case"onproblem":return O.OnProblem;default:return O.OnProblem}}O.fromString=N}(E||(e.RevealProblemKind=E={}));var c;(function(O){O[O.Shared=1]="Shared",O[O.Dedicated=2]="Dedicated",O[O.New=3]="New"})(c||(e.PanelKind=c={})),function(O){function N(ae){switch(ae.toLowerCase()){case"shared":return O.Shared;case"dedicated":return O.Dedicated;case"new":return O.New;default:return O.Shared}}O.fromString=N}(c||(e.PanelKind=c={}));var y;(function(O){O.defaults={echo:!0,reveal:R.Always,revealProblems:E.Never,focus:!1,panel:c.Shared,showReuseMessage:!0,clear:!1}})(y||(e.PresentationOptions=y={}));var b;(function(O){O[O.Shell=1]="Shell",O[O.Process=2]="Process",O[O.CustomExecution=3]="CustomExecution"})(b||(e.RuntimeType=b={})),function(O){function N(Q){switch(Q.toLowerCase()){case"shell":return O.Shell;case"process":return O.Process;case"customExecution":return O.CustomExecution;default:return O.Process}}O.fromString=N;function ae(Q){switch(Q){case O.Shell:return"shell";case O.Process:return"process";case O.CustomExecution:return"customExecution";default:return"process"}}O.toString=ae}(b||(e.RuntimeType=b={}));var o;(function(O){function N(ae){return L.$ie(ae)?ae:ae.value}O.value=N})(o||(e.CommandString=o={}));var t;(function(O){O.Clean={_id:"clean",isDefault:!1},O.Build={_id:"build",isDefault:!1},O.Rebuild={_id:"rebuild",isDefault:!1},O.Test={_id:"test",isDefault:!1};function N(Q){return Q===O.Clean._id||Q===O.Build._id||Q===O.Rebuild._id||Q===O.Test._id}O.is=N;function ae(Q){if(Q!==void 0)return L.$ie(Q)?N(Q)?{_id:Q,isDefault:!1}:void 0:Q}O.from=ae})(t||(e.TaskGroup=t={}));var i;(function(O){O[O.Global=1]="Global",O[O.Workspace=2]="Workspace",O[O.Folder=3]="Folder"})(i||(e.TaskScope=i={}));var a;(function(O){O.Workspace="workspace",O.Extension="extension",O.InMemory="inMemory",O.WorkspaceFile="workspaceFile",O.User="user";function N(ae){switch(ae){case O.User:return 2;case O.WorkspaceFile:return 5;default:return 6}}O.toConfigurationTarget=N})(a||(e.TaskSourceKind=a={}));var m;(function(O){O.parallel="parallel",O.sequence="sequence"})(m||(e.DependsOrder=m={}));var S;(function(O){O[O.default=1]="default",O[O.folderOpen=2]="folderOpen"})(S||(e.RunOnOptions=S={}));var C;(function(O){O.defaults={reevaluateOnRerun:!0,runOn:S.default,instanceLimit:1}})(C||(e.RunOptions=C={}));class r{constructor(N,ae,Q,be,ke,Fe){this._label="",this._id=N,ae&&(this._label=ae),Q&&(this.type=Q),this.runOptions=be,this.configurationProperties=ke,this._source=Fe}getDefinition(N){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const N={folder:this.d(),id:this._id};return JSON.stringify(N)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(N,ae=!1){if(N===void 0)return!1;if(L.$ie(N))return N===this._label||N===this.configurationProperties.identifier||ae&&N===this._id;const Q=this.getDefinition(!0);return Q!==void 0&&Q._key===N._key}getQualifiedLabel(){const N=this.getWorkspaceFolder();return N?`${this._label} (${N.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(N){this.c===void 0&&(this.c=[]),N&&(this.c=this.c.concat(N))}get taskLoadMessages(){return this.c}}e.$VF=r;class h extends r{constructor(N,ae,Q,be,ke,Fe,G,Z){super(N,Q,void 0,G,Z,ae),this.command={},this._source=ae,this.hasDefinedMatchers=Fe,ke&&(this.command=ke)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(N=!1){if(N&&this._source.customizes!==void 0)return this._source.customizes;{let ae;switch(this.command?this.command.runtime:void 0){case b.Shell:ae="shell";break;case b.Process:ae="process";break;case b.CustomExecution:ae="customExecution";break;case void 0:ae="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:ae,_key:this._id,id:this._id}}}static is(N){return N instanceof h}getMapKey(){const N=this._source.config.workspaceFolder;return N?`${N.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===a.User?e.$RF:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ae=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(ae+=this._source.kind);const Q={type:e.$UF,folder:N,id:ae};return JSON.stringify(Q)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$5f(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(N){return new h(N._id,N._source,N._label,N.type,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$WF=h;class n extends r{constructor(N,ae,Q,be,ke,Fe,G){super(N,Q,be,Fe,G,ae),this._source=ae,this.configures=ke}static is(N){return N instanceof n}f(N){return N}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$5f(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===a.User?e.$RF:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const N=this.d();if(!N)return;let ae=this.configurationProperties.identifier;this._source.kind!==a.Workspace&&(ae+=this._source.kind);const Q={type:e.$UF,folder:N,id:ae};return JSON.stringify(Q)}}e.$XF=n;class s extends r{constructor(N,ae,Q,be,ke,Fe,G,Z,le){super(N,Q,be,Z,le,ae),this.defines=ke,this.hasDefinedMatchers=G,this.command=Fe,this.icon=le.icon,this.hide=le.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(N){return N instanceof s}getMapKey(){const N=this._source.workspaceFolder;return N?`${this._source.scope.toString()}|${N.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const N={type:"contributed",scope:this._source.scope,id:this._id};return N.folder=this.d(),JSON.stringify(N)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(N){return new s(N._id,N._source,N._label,N.type,N.defines,N.command,N.hasDefinedMatchers,N.runOptions,N.configurationProperties)}}e.$YF=s;class p extends r{constructor(N,ae,Q,be,ke,Fe){super(N,Q,be,ke,Fe,ae),this._source=ae}clone(){return new p(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(N){return N instanceof p}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(N){return new p(N._id,N._source,N._label,N.type,N.runOptions,N.configurationProperties)}}e.$ZF=p;var D;(function(O){O[O.Process=1]="Process",O[O.Terminal=2]="Terminal"})(D||(e.ExecutionEngine=D={})),function(O){O._default=O.Terminal}(D||(e.ExecutionEngine=D={}));var l;(function(O){O[O.V0_1_0=1]="V0_1_0",O[O.V2_0_0=2]="V2_0_0"})(l||(e.JsonSchemaVersion=l={}));class g{constructor(N){this.c=new Map;for(let ae=0;ae<N.length;ae++)this.c.set(N[ae].uri.toString(),ae)}compare(N,ae){const Q=N.getWorkspaceFolder(),be=ae.getWorkspaceFolder();if(Q&&be){let ke=this.c.get(Q.uri.toString());ke=ke===void 0?0:ke+1;let Fe=this.c.get(be.uri.toString());return Fe=Fe===void 0?0:Fe+1,ke===Fe?N._label.localeCompare(ae._label):ke-Fe}else return!Q&&be?-1:Q&&!be?1:0}}e.$1F=g;var v;(function(O){O.DependsOnStarted="dependsOnStarted",O.AcquiredInput="acquiredInput",O.Start="start",O.ProcessStarted="processStarted",O.Active="active",O.Inactive="inactive",O.Changed="changed",O.Terminated="terminated",O.ProcessEnded="processEnded",O.End="end"})(v||(e.TaskEventKind=v={}));var u;(function(O){O.SingleRun="singleRun",O.Background="background"})(u||(e.TaskRunType=u={}));var f;(function(O){O[O.System=0]="System",O[O.User=1]="User",O[O.FolderOpen=2]="FolderOpen",O[O.ConfigurationChange=3]="ConfigurationChange",O[O.Reconnect=4]="Reconnect"})(f||(e.TaskRunSource=f={}));var A;(function(O){function N(ae,Q,be,ke){if(Q){const Fe={kind:ae,taskId:Q._id,taskName:Q.configurationProperties.name,runType:Q.configurationProperties.isBackground?"background":"singleRun",group:Q.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:be,__task:Q};return ae==="start"?Fe.resolvedVariables=ke:ae==="processStarted"?Fe.processId=ke:ae==="processEnded"&&(Fe.exitCode=ke),Object.freeze(Fe)}else return Object.freeze({kind:"changed"})}O.create=N})(A||(e.TaskEvent=A={}));var W;(function(O){function N(Q){const be=Object.keys(Q).sort();let ke="";for(const Fe of be){let G=Q[Fe];G instanceof Object?G=N(G):typeof G=="string"&&(G=G.replace(/,/g,",,")),ke+=Fe+","+G+","}return ke}function ae(Q){const ke={_key:N(Q),type:Q.taskType};return Object.assign(ke,Q),ke}O.create=ae})(W||(e.KeyedTaskIdentifier=W={}));var B;(function(O){O.AutoDetect="task.autoDetect",O.SaveBeforeRun="task.saveBeforeRun",O.ShowDecorations="task.showDecorations",O.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",O.SlowProviderWarning="task.slowProviderWarning",O.QuickOpenHistory="task.quickOpen.history",O.QuickOpenDetail="task.quickOpen.detail",O.QuickOpenSkip="task.quickOpen.skip",O.QuickOpenShowAll="task.quickOpen.showAll",O.AllowAutomaticTasks="task.allowAutomaticTasks",O.Reconnection="task.reconnection"})(B||(e.TaskSettingId=B={}));var V;(function(O){O.Tasks="tasks",O.SuppressTaskName="tasks.suppressTaskName",O.Windows="tasks.windows",O.Osx="tasks.osx",O.Linux="tasks.linux",O.ShowOutput="tasks.showOutput",O.IsShellCommand="tasks.isShellCommand",O.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var U;(function(O){function N(ae,Q){const be=d.$QF.get(ae.type);if(be===void 0){const Z=z.$Fm(ae);return delete Z._key,W.create(Z)}const ke=Object.create(null);ke.type=be.taskType;const Fe=new Set;be.required.forEach(Z=>Fe.add(Z));const G=be.properties;for(const Z of Object.keys(G)){const le=ae[Z];if(le!=null)ke[Z]=le;else if(Fe.has(Z)){const ne=G[Z];if(ne.default!==void 0)ke[Z]=z.$Fm(ne.default);else switch(ne.type){case"boolean":ke[Z]=!1;break;case"number":case"integer":ke[Z]=0;break;case"string":ke[Z]="";break;default:Q.error(w.localize(2,null,JSON.stringify(ae,void 0,0),Z));return}}}return W.create(ke)}O.createTaskIdentifier=N})(U||(e.TaskDefinition=U={}))}),define(Ae[216],Re([1,0,11]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q1b=e.$p1b=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((P,d)=>{this.b=P,this.d=d,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(P){this.f||this.h||(this.f=!0,this.g=P,this.a&&this.b(P))}resolveErr(P){this.f||this.h||(this.h=!0,this.i=P,this.a?this.d(P):(0,w.$Y)(P))}then(P,d){return this.j().then(P,d)}catch(P){return this.j().then(void 0,P)}finally(P){return this.j().finally(P)}}e.$p1b=L;class I extends L{constructor(){super(),this.h=!0,this.i=new w.$3}}e.$q1b=I}),define(Ae[46],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wz=e.$Vz=e.$Uz=e.$Tz=void 0;class w{static{this.count=0}constructor(k){this._proxyIdentifierBrand=void 0,this.sid=k,this.nid=++w.count}}e.$Tz=w;const L=[];function I(d){const k=new w(d);return L[k.nid]=k,k}e.$Uz=I;function z(d){return L[d].sid}e.$Vz=z;class P{constructor(k){this.value=k}}e.$Wz=P}),define(Ae[4],Re([1,0,46]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yJ=e.$xJ=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$wJ=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(L||(e.TextEditorRevealType=L={}));var I;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput"})(I||(e.TabInputKind=I={}));var z;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(z||(e.TabModelOperationKind=z={}));var P;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(P||(e.WebviewEditorCapabilities=P={}));var d;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(d||(e.WebviewMessageArrayBufferViewType=d={}));var k;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(k||(e.CellOutputKind=k={}));var $;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})($||(e.NotebookEditorRevealType=$={}));var R;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class E{static{this.a=0}static mixin(t){return t._id=E.a++,t}}e.$wJ=E;var c;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.kindModifier="m",o.commandIdent="n",o.commandId="o",o.commandArguments="p"})(c||(e.ISuggestDataDtoField=c={}));var y;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(y||(e.ISuggestResultDtoField=y={}));var b;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$xJ={MainThreadAuthentication:(0,w.$Uz)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.$Uz)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.$Uz)("MainThreadClipboard"),MainThreadCommands:(0,w.$Uz)("MainThreadCommands"),MainThreadComments:(0,w.$Uz)("MainThreadComments"),MainThreadConfiguration:(0,w.$Uz)("MainThreadConfiguration"),MainThreadConsole:(0,w.$Uz)("MainThreadConsole"),MainThreadDebugService:(0,w.$Uz)("MainThreadDebugService"),MainThreadDecorations:(0,w.$Uz)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.$Uz)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.$Uz)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.$Uz)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.$Uz)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.$Uz)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.$Uz)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.$Uz)("MainThreadEditorTabs"),MainThreadErrors:(0,w.$Uz)("MainThreadErrors"),MainThreadTreeViews:(0,w.$Uz)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.$Uz)("MainThreadDownloadService"),MainThreadKeytar:(0,w.$Uz)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.$Uz)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.$Uz)("MainThreadLanguages"),MainThreadLogger:(0,w.$Uz)("MainThreadLogger"),MainThreadMessageService:(0,w.$Uz)("MainThreadMessageService"),MainThreadOutputService:(0,w.$Uz)("MainThreadOutputService"),MainThreadProgress:(0,w.$Uz)("MainThreadProgress"),MainThreadQuickDiff:(0,w.$Uz)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,w.$Uz)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.$Uz)("MainThreadStatusBar"),MainThreadSecretState:(0,w.$Uz)("MainThreadSecretState"),MainThreadStorage:(0,w.$Uz)("MainThreadStorage"),MainThreadTelemetry:(0,w.$Uz)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.$Uz)("MainThreadTerminalService"),MainThreadWebviews:(0,w.$Uz)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.$Uz)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.$Uz)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.$Uz)("MainThreadCustomEditors"),MainThreadUrls:(0,w.$Uz)("MainThreadUrls"),MainThreadUriOpeners:(0,w.$Uz)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,w.$Uz)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,w.$Uz)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.$Uz)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.$Uz)("MainThreadExtensionService"),MainThreadSCM:(0,w.$Uz)("MainThreadSCM"),MainThreadSearch:(0,w.$Uz)("MainThreadSearch"),MainThreadShare:(0,w.$Uz)("MainThreadShare"),MainThreadTask:(0,w.$Uz)("MainThreadTask"),MainThreadWindow:(0,w.$Uz)("MainThreadWindow"),MainThreadLabelService:(0,w.$Uz)("MainThreadLabelService"),MainThreadNotebook:(0,w.$Uz)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.$Uz)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.$Uz)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.$Uz)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.$Uz)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.$Uz)("MainThreadInteractive"),MainThreadChat:(0,w.$Uz)("MainThreadChat"),MainThreadInlineChat:(0,w.$Uz)("MainThreadInlineChatShape"),MainThreadTheming:(0,w.$Uz)("MainThreadTheming"),MainThreadTunnelService:(0,w.$Uz)("MainThreadTunnelService"),MainThreadManagedSockets:(0,w.$Uz)("MainThreadManagedSockets"),MainThreadTimeline:(0,w.$Uz)("MainThreadTimeline"),MainThreadTesting:(0,w.$Uz)("MainThreadTesting"),MainThreadLocalization:(0,w.$Uz)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,w.$Uz)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,w.$Uz)("MainThreadIssueReporter")},e.$yJ={ExtHostCommands:(0,w.$Uz)("ExtHostCommands"),ExtHostConfiguration:(0,w.$Uz)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.$Uz)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.$Uz)("ExtHostDebugService"),ExtHostDecorations:(0,w.$Uz)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.$Uz)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.$Uz)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.$Uz)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.$Uz)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.$Uz)("ExtHostEditors"),ExtHostTreeViews:(0,w.$Uz)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.$Uz)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.$Uz)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.$Uz)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.$Uz)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.$Uz)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.$Uz)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,w.$Uz)("ExtHostQuickDiff"),ExtHostStatusBar:(0,w.$Uz)("ExtHostStatusBar"),ExtHostShare:(0,w.$Uz)("ExtHostShare"),ExtHostExtensionService:(0,w.$Uz)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.$Uz)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.$Uz)("ExtHostTerminalService"),ExtHostSCM:(0,w.$Uz)("ExtHostSCM"),ExtHostSearch:(0,w.$Uz)("ExtHostSearch"),ExtHostTask:(0,w.$Uz)("ExtHostTask"),ExtHostWorkspace:(0,w.$Uz)("ExtHostWorkspace"),ExtHostWindow:(0,w.$Uz)("ExtHostWindow"),ExtHostWebviews:(0,w.$Uz)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.$Uz)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.$Uz)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.$Uz)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.$Uz)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.$Uz)("ExtHostEditorTabs"),ExtHostProgress:(0,w.$Uz)("ExtHostProgress"),ExtHostComments:(0,w.$Uz)("ExtHostComments"),ExtHostSecretState:(0,w.$Uz)("ExtHostSecretState"),ExtHostStorage:(0,w.$Uz)("ExtHostStorage"),ExtHostUrls:(0,w.$Uz)("ExtHostUrls"),ExtHostUriOpeners:(0,w.$Uz)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,w.$Uz)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,w.$Uz)("ExtHostOutputService"),ExtHosLabelService:(0,w.$Uz)("ExtHostLabelService"),ExtHostNotebook:(0,w.$Uz)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.$Uz)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.$Uz)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.$Uz)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.$Uz)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,w.$Uz)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,w.$Uz)("ExtHostInteractive"),ExtHostInlineChat:(0,w.$Uz)("ExtHostInlineChatShape"),ExtHostChat:(0,w.$Uz)("ExtHostChat"),ExtHostSemanticSimilarity:(0,w.$Uz)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,w.$Uz)("ExtHostTheming"),ExtHostTunnelService:(0,w.$Uz)("ExtHostTunnelService"),ExtHostManagedSockets:(0,w.$Uz)("ExtHostManagedSockets"),ExtHostAuthentication:(0,w.$Uz)("ExtHostAuthentication"),ExtHostTimeline:(0,w.$Uz)("ExtHostTimeline"),ExtHostTesting:(0,w.$Uz)("ExtHostTesting"),ExtHostTelemetry:(0,w.$Uz)("ExtHostTelemetry"),ExtHostLocalization:(0,w.$Uz)("ExtHostLocalization"),ExtHostIssueReporter:(0,w.$Uz)("ExtHostIssueReporter")}}),define(Ae[80],Re([1,0,3,14,4,17]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P$b=e.$O$b=e.$N$b=void 0,e.$N$b=(0,w.$nh)("IExtHostApiDeprecationService");let P=class{constructor(k,$){this.c=$,this.a=new Set,this.b=k.getProxy(I.$xJ.MainThreadTelemetry)}report(k,$,R){const E=this.d(k,$);this.a.has(E)||(this.a.add(E),$.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${k}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:$.identifier.value,apiId:k}))}d(k,$){return`${k}-${$.identifier.value}`}};e.$O$b=P,e.$O$b=P=qe([Ve(0,z.$zL),Ve(1,L.$Pi)],P),e.$P$b=Object.freeze(new class{report(d,k,$){}})}),define(Ae[217],Re([1,0,5,4,7,21]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jac=void 0;class P{constructor($){this.b=new Map,this.c=[],this.d=new w.$7c,this.onDidChangeSessions=this.d.event,this.f=new d,this.g=new d,this.a=$.getProxy(L.$xJ.MainThreadAuthentication)}$setProviders($){return this.c=$,Promise.resolve()}async getSession($,R,E,c={}){const y=z.$Fl.toKey($.identifier),b=[...E].sort().join(" ");return await this.f.getOrCreate(`${y} ${R} ${b}`,async()=>{await this.a.$ensureProvider(R);const o=$.displayName||$.name;return this.a.$getSession(R,E,y,o,c)})}async getSessions($,R,E){const c=z.$Fl.toKey($.identifier),y=[...E].sort().join(" ");return await this.g.getOrCreate(`${c} ${y}`,async()=>{await this.a.$ensureProvider(R);const b=$.displayName||$.name;return this.a.$getSessions(R,E,c,b)})}async removeSession($,R){const E=this.b.get($);return E?E.provider.removeSession(R):this.a.$removeSession($,R)}registerAuthenticationProvider($,R,E,c){if(this.b.get($))throw new Error(`An authentication provider with id '${$}' is already registered.`);this.b.set($,{label:R,provider:E,options:c??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===$)||this.c.push({id:$,label:R});const y=E.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions($,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider($,R,c?.supportsMultipleAccounts??!1),new I.$zJ(()=>{y.dispose(),this.b.delete($);const b=this.c.findIndex(o=>o.id===$);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider($)})}$createSession($,R,E){const c=this.b.get($);if(c)return Promise.resolve(c.provider.createSession(R,E));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$removeSession($,R){const E=this.b.get($);if(E)return Promise.resolve(E.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$getSessions($,R){const E=this.b.get($);if(E)return Promise.resolve(E.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${$}`)}$onDidChangeAuthenticationSessions($,R){return this.d.fire({provider:{id:$,label:R}}),Promise.resolve()}}e.$jac=P;class d{constructor(){this.a=new Map}getOrCreate($,R){const E=this.a.get($);if(E)return E;const c=R().finally(()=>this.a.delete($));return this.a.set($,c),c}}}),define(Ae[218],Re([1,0,4,17,8]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0;let z=class{constructor(d,k){this.a=d.getProxy(w.$xJ.MainThreadBulkEdits),this.b={getTextDocumentVersion:$=>k.getDocument($)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(d,k,$){const R=I.WorkspaceEdit.from(d,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,$?.isRefactoring??!1)}};e.$pac=z,e.$pac=z=qe([Ve(0,L.$zL)],z)}),define(Ae[219],Re([1,0,16,5,68,6,59,12,146,4,8]),function($e,e,w,L,I,z,P,d,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=void 0;class E{static{this.a=0}constructor(b,o){this.extension=b,this.provider=o,this.handle=E.a++}}class c{static{this.a=0}constructor(b,o){this.i=o,this.b=new Map,this.d=new Map,this.e=new Map,this.g=new L.$7c,this.onDidPerformUserAction=this.g.event,this.h=b.getProxy($.$xJ.MainThreadChat)}registerChatProvider(b,o,t){const i=new E(b,t);return this.b.set(i.handle,i),this.h.$registerChatProvider(i.handle,o),(0,z.$jb)(()=>{this.h.$unregisterChatProvider(i.handle),this.b.delete(i.handle)})}transferChatSession(b,o){const t=I.Iterable.find(this.e.keys(),i=>this.e.get(i)===b)??0;typeof t=="number"&&this.h.$transferChatSession(t,o)}addChatRequest(b){this.h.$addRequest(b)}sendInteractiveRequestToProvider(b,o){this.h.$sendRequestToProvider(b,o)}async $prepareChat(b,o,t){const i=this.b.get(b);if(!i)return;const a=await i.provider.prepareSession(o,t);if(!a)return;const m=c.a++;return this.e.set(m,a),{id:m,requesterUsername:a.requester?.name,requesterAvatarIconUri:a.requester?.icon,responderUsername:a.responder?.name,responderAvatarIconUri:a.responder?.icon,inputPlaceholder:a.inputPlaceholder}}async $resolveRequest(b,o,t,i){const a=this.b.get(b);if(!a)return;const m=this.e.get(o);if(!m||!a.provider.resolveRequest)return;const S=await a.provider.resolveRequest(m,t,i);if(S)return{message:typeof S.message=="string"?S.message:R.ChatReplyFollowup.from(S.message)}}async $provideWelcomeMessage(b,o){const t=this.b.get(b);if(!t||!t.provider.provideWelcomeMessage)return;const i=await t.provider.provideWelcomeMessage(o);if(i)return i.map(a=>typeof a=="string"?a:a.map(m=>R.ChatReplyFollowup.from(m)))}async $provideFollowups(b,o,t){const i=this.b.get(b);if(!i)return;const a=this.e.get(o);return!a||!i.provider.provideFollowups?void 0:(await i.provider.provideFollowups(a,t))?.map(S=>R.ChatFollowup.from(S))}$removeRequest(b,o,t){const i=this.b.get(b);if(!i)return;const a=this.e.get(o);a&&i.provider.removeRequest&&i.provider.removeRequest(a,t)}async $provideReply(b,o,t,i){const a=this.b.get(b);if(!a)return;const m=this.e.get(o);if(!m)return;const S={session:m,message:typeof t.message=="string"?t.message:R.ChatReplyFollowup.to(t.message)},C=P.$3c.create(!1);let r;const h={report:p=>{if(!i.isCancellationRequested)if(typeof r>"u"&&(r=C.elapsed()),"responseId"in p)this.h.$acceptResponseProgress(b,o,{requestId:p.responseId});else if("placeholder"in p&&"resolvedContent"in p){const D=Promise.all([this.h.$acceptResponseProgress(b,o,{placeholder:p.placeholder}),p.resolvedContent]);(0,w.$ig)(D,i).then(l=>{if(!l)return;const[g,v]=l;this.h.$acceptResponseProgress(b,o,v,g??void 0)})}else this.h.$acceptResponseProgress(b,o,p)}};let n;try{n=await a.provider.provideResponseWithProgress(S,h,i),n||(n={errorDetails:{message:(0,k.localize)(0,null)}})}catch(p){n={errorDetails:{message:(0,k.localize)(1,null,p.message),responseIsIncomplete:!0}},this.i.error(p)}try{if(m.saveState&&this.e.has(o)){const p=m.saveState();this.h.$acceptChatState(o,p)}}catch(p){this.i.warn(p)}const s={firstProgress:r??0,totalElapsed:C.elapsed()};return{errorDetails:n.errorDetails,timings:s}}async $provideSlashCommands(b,o,t){const i=this.b.get(b);if(!i)return;const a=this.e.get(o);return!a||!i.provider.provideSlashCommands?void 0:(await i.provider.provideSlashCommands(a,t))?.map(S=>({...S,kind:R.CompletionItemKind.from(S.kind)}))}$releaseSession(b){this.e.delete(b)}async $onDidPerformUserAction(b){this.g.fire(b)}registerSlashCommandProvider(b,o,t){const i=new E(b,t);return this.d.set(i.handle,i),this.h.$registerSlashCommandProvider(i.handle,o),(0,z.$jb)(()=>{this.h.$unregisterSlashCommandProvider(i.handle),this.d.delete(i.handle)})}async $provideProviderSlashCommands(b,o){const t=this.d.get(b);return t?(await t.provider.provideSlashCommands(o))?.map(a=>({...a,kind:R.CompletionItemKind.from(a.kind)})):void 0}async $resolveSlashCommand(b,o,t){const i=this.d.get(b);if(!i)return;const a=await i.provider.resolveSlashCommand(o,t);return(0,d.$Ae)(a)}}e.$Dac=c}),define(Ae[220],Re([1,0,4]),function($e,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S$b=void 0;class L{constructor(z){const P=z.getProxy(w.$xJ.MainThreadClipboard);this.value=Object.freeze({readText(){return P.$readText()},writeText(d){return P.$writeText(d)}})}}e.$S$b=L}),define(Ae[32],Re([1,0,12,7,8,24,4,18,14,70,44,274,2,6,3,17,104,25,46,41,59,53,58]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S,C,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZL=e.$YL=e.$XL=e.$WL=e.$VL=e.$UL=void 0;let h=class{#e;#t;#i;constructor(g,v,u){this.b=new Map,this.c=new Map,this.#e=g.getProxy(P.$xJ.MainThreadCommands),this.d=v,this.#i=u,this.#t=g.getProxy(P.$xJ.MainThreadTelemetry),this.converter=new n(this,f=>{const A=this.c.get(f);return A?.result===p.Void?A:void 0},v),this.f=[{processArgument(f){return(0,$.$Wg)(f)}},{processArgument(f){return(0,z.$Hm)(f,function(A){if(R.$Mr.isIRange(A))return I.Range.to(A);if(E.$Lr.isIPosition(A))return I.Position.to(A);if(R.$Mr.isIRange(A.range)&&c.URI.isUri(A.uri))return I.location.to(A);if(A instanceof i.$Jb)return A.buffer.buffer;if(!Array.isArray(A))return A})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const v=this.registerCommand(!1,g.id,async(...u)=>{const f=g.args.map((W,B)=>{if(!W.validate(u[B]))throw new Error(`Invalid argument '${W.name}' when running '${g.id}', received: ${u[B]}`);return W.convert(u[B])}),A=await this.executeCommand(g.internalId,...f);return g.result.convert(A,u,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new L.$zJ(()=>{v.dispose(),this.c.delete(g.id)})}registerCommand(g,v,u,f,A,W){if(this.d.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this.b.has(v))throw new Error(`command '${v}' already exists`);return this.b.set(v,{callback:u,thisArg:f,description:A,extension:W}),g&&this.#e.$registerCommand(v),new L.$zJ(()=>{this.b.delete(v)&&g&&this.#e.$unregisterCommand(v)})}executeCommand(g,...v){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,v,!0)}async g(g,v,u){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,v,!1);{let f=!1;const A=(0,z.$Hm)(v,function(W){if(W instanceof L.$AJ)return I.Position.from(W);if(W instanceof L.$BJ)return I.Range.from(W);if(W instanceof L.$LJ)return I.location.from(W);if(L.$XK.isNotebookRange(W))return I.NotebookRange.from(W);if(W instanceof ArrayBuffer)return f=!0,i.$Jb.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return f=!0,i.$Jb.wrap(W);if(W instanceof i.$Jb)return f=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(g,f?new a.$Wz(A):A,u);return(0,$.$Wg)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(g,v,!1);throw W}}}async h(g,v,u){const f=this.b.get(g);if(!f)throw new Error("Unknown command");const{callback:A,thisArg:W,description:B}=f;if(B)for(let U=0;U<B.args.length;U++)try{(0,w.$ze)(v[U],B.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${B.args[U].name}' - ${B.args[U].description}`)}const V=S.$3c.create();try{return await A.apply(W,v)}catch(U){if(g===this.converter.delegatingCommandId){const O=this.converter.getActualCommand(...v);O&&(g=O.command)}if(this.d.error(U,g,f.extension?.identifier),!u)throw U;if(f.extension?.identifier){const O=this.#i.onExtensionError(f.extension.identifier,U);this.d.trace("forwarded error to extension?",O,f.extension?.identifier)}throw new class extends Error{constructor(){super((0,m.$$h)(U)),this.id=g,this.source=f.extension?.displayName??f.extension?.name}}}finally{this.j(f,g,V.elapsed())}}j(g,v,u){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new C.$Zn(v),duration:u})}$executeContributedCommand(g,...v){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const u=this.b.get(g);return u?(v=v.map(f=>this.f.reduce((A,W)=>W.processArgument(A,u.extension?.identifier),f)),this.h(g,v,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(v=>(g&&(v=v.filter(u=>u[0]!=="_")),v))}$getContributedCommandHandlerDescriptions(){const g=Object.create(null);for(const[v,u]of this.b){const{description:f}=u;f&&(g[v]=f)}return Promise.resolve(g)}};e.$UL=h,e.$UL=h=qe([Ve(0,o.$zL),Ve(1,k.$Pi),Ve(2,r.$TL)],h),e.$VL=(0,b.$nh)("IExtHostCommands");class n{constructor(g,v,u){this.d=g,this.f=v,this.g=u,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,v){if(!g)return;const u={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return u;const f=this.f(g.command);if(f)u.id=f.internalId,u.arguments=f.args.map((A,W)=>A.convert(g.arguments&&g.arguments[W]));else if((0,d.$pf)(g.arguments)){const A=`${g.command}/${++this.c}`;this.b.set(A,g),v.add((0,y.$jb)(()=>{this.b.delete(A),this.g.trace("CommandsConverter#DISPOSE",A)})),u.$ident=A,u.id=this.delegatingCommandId,u.arguments=[A],this.g.trace("CommandsConverter#CREATE",g.command,A)}return u}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const v=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],v?v.command:"MISSING"),v?this.d.executeCommand(v.command,...v.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$WL=n;class s{static{this.Uri=new s("uri","Uri of a text document",g=>c.URI.isUri(g),g=>g)}static{this.Position=new s("position","A position in a text document",g=>L.$AJ.isPosition(g),I.Position.from)}static{this.Range=new s("range","A range in a text document",g=>L.$BJ.isRange(g),I.Range.from)}static{this.Selection=new s("selection","A selection in a text document",g=>L.$CJ.isSelection(g),I.Selection.from)}static{this.Number=new s("number","",g=>typeof g=="number",g=>g)}static{this.String=new s("string","",g=>typeof g=="string",g=>g)}static{this.CallHierarchyItem=new s("item","A call hierarchy item",g=>g instanceof L.$WJ,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new s("item","A type hierarchy item",g=>g instanceof L.$fL,I.TypeHierarchyItem.from)}static{this.TestItem=new s("testItem","A VS Code TestItem",g=>g instanceof t.$ML,I.TestItem.from)}constructor(g,v,u,f){this.name=g,this.description=v,this.validate=u,this.convert=f}optional(){return new s(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,v){return new s(g??this.name,v??this.description,this.validate,this.convert)}}e.$XL=s;class p{static{this.Void=new p("no result",g=>g)}constructor(g,v){this.description=g,this.convert=v}}e.$YL=p;class D{constructor(g,v,u,f,A){this.id=g,this.internalId=v,this.description=u,this.args=f,this.result=A}}e.$ZL=D}),define(Ae[221],Re([1,0,18,13,2,78,91,31,95,32,8,7]),function($e,e,w,L,I,z,P,d,k,$,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R$b=void 0;const c=[new $.$ZL("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$XL.Uri,$.$XL.Position],new $.$YL("A promise that resolves to an array of DocumentHighlight-instances.",b(R.DocumentHighlight.to))),new $.$ZL("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$XL.Uri],new $.$YL("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,i)=>{if((0,w.$of)(t))return;class a extends E.$QJ{static to(S){const C=new a(S.name,R.SymbolKind.to(S.kind),S.containerName||"",new E.$LJ(i[0],R.Range.to(S.range)));return C.detail=S.detail,C.range=C.location.range,C.selectionRange=R.Range.to(S.selectionRange),C.children=S.children?S.children.map(a.to):[],C}}return t.map(a.to)})),new $.$ZL("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$XL.Uri,new $.$XL("options","Formatting options",t=>!0,t=>t)],new $.$YL("A promise that resolves to an array of TextEdits.",b(R.TextEdit.to))),new $.$ZL("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$XL.Uri,$.$XL.Range,new $.$XL("options","Formatting options",t=>!0,t=>t)],new $.$YL("A promise that resolves to an array of TextEdits.",b(R.TextEdit.to))),new $.$ZL("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$XL.Uri,$.$XL.Position,new $.$XL("ch","Trigger character",t=>typeof t=="string",t=>t),new $.$XL("options","Formatting options",t=>!0,t=>t)],new $.$YL("A promise that resolves to an array of TextEdits.",b(R.TextEdit.to))),new $.$ZL("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$XL.Uri,$.$XL.Position],new $.$YL("A promise that resolves to an array of Location or LocationLink instances.",o)),new $.$ZL("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$XL.Uri,$.$XL.Position],new $.$YL("A promise that resolves to an array of Location or LocationLink instances.",o)),new $.$ZL("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$XL.Uri,$.$XL.Position],new $.$YL("A promise that resolves to an array of Location or LocationLink instances.",o)),new $.$ZL("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$XL.Uri,$.$XL.Position],new $.$YL("A promise that resolves to an array of Location or LocationLink instances.",o)),new $.$ZL("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$XL.Uri,$.$XL.Position],new $.$YL("A promise that resolves to an array of Location-instances.",b(R.location.to))),new $.$ZL("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$XL.Uri,$.$XL.Position],new $.$YL("A promise that resolves to an array of Hover-instances.",b(R.Hover.to))),new $.$ZL("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$XL.Uri,new $.$XL("position","A position in a text document",t=>Array.isArray(t)&&t.every(i=>E.$AJ.isPosition(i)),t=>t.map(R.Position.from))],new $.$YL("A promise that resolves to an array of ranges.",t=>t.map(i=>{let a;for(const m of i.reverse())a=new E.$VJ(R.Range.to(m),a);return a}))),new $.$ZL("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$XL.String.with("query","Search string")],new $.$YL("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(R.WorkspaceSymbol.to))),new $.$ZL("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$XL.Uri,$.$XL.Position],new $.$YL("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(R.CallHierarchyItem.to))),new $.$ZL("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$XL.CallHierarchyItem],new $.$YL("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(R.CallHierarchyIncomingCall.to))),new $.$ZL("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$XL.CallHierarchyItem],new $.$YL("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(R.CallHierarchyOutgoingCall.to))),new $.$ZL("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$XL.Uri,$.$XL.Position],new $.$YL("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:R.Range.to(t.range),placeholder:t.text}})),new $.$ZL("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$XL.Uri,$.$XL.Position,$.$XL.String.with("newName","The new symbol name")],new $.$YL("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return R.WorkspaceEdit.to(t)}})),new $.$ZL("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$XL.Uri,$.$XL.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$YL("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(R.DocumentLink.to))),new $.$ZL("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$XL.Uri],new $.$YL("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new E.$PK(t.tokenTypes,t.tokenModifiers)})),new $.$ZL("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$XL.Uri],new $.$YL("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,P.$A8)(t);if(i.type==="full")return new E.$RK(i.data,void 0)})),new $.$ZL("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$XL.Uri,$.$XL.Range.optional()],new $.$YL("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new E.$PK(t.tokenTypes,t.tokenModifiers)})),new $.$ZL("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$XL.Uri,$.$XL.Range],new $.$YL("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const i=(0,P.$A8)(t);if(i.type==="full")return new E.$RK(i.data,void 0)})),new $.$ZL("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$XL.Uri,$.$XL.Position,$.$XL.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$XL.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$YL("A promise that resolves to a CompletionList-instance.",(t,i,a)=>{if(!t)return new E.$8J([]);const m=t.suggestions.map(S=>R.CompletionItem.to(S,a));return new E.$8J(m,t.incomplete)})),new $.$ZL("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$XL.Uri,$.$XL.Position,$.$XL.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$YL("A promise that resolves to SignatureHelp.",t=>{if(t)return R.SignatureHelp.to(t)})),new $.$ZL("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$XL.Uri,$.$XL.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$YL("A promise that resolves to an array of CodeLens-instances.",(t,i,a)=>b(m=>new E.$ZJ(R.Range.to(m.range),m.command&&a.fromInternal(m.command)))(t))),new $.$ZL("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$XL.Uri,new $.$XL("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>E.$BJ.isRange(t),t=>E.$CJ.isSelection(t)?R.Selection.from(t):R.Range.from(t)),$.$XL.String.with("kind","Code action kind to return code actions for").optional(),$.$XL.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$YL("A promise that resolves to an array of Command-instances.",(t,i,a)=>b(m=>{if(m._isSynthetic){if(!m.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(m.command)}else{const S=new E.$SJ(m.title,m.kind?new E.$TJ(m.kind):void 0);return m.edit&&(S.edit=R.WorkspaceEdit.to(m.edit)),m.command&&(S.command=a.fromInternal(m.command)),S.isPreferred=m.isPreferred,S}})(t))),new $.$ZL("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$XL.Uri],new $.$YL("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(i=>new E.$bK(R.Range.to(i.range),R.Color.to(i.color))):[])),new $.$ZL("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$XL("color","The color to show and insert",t=>t instanceof E.$aK,R.Color.from),new $.$XL("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:R.Range.from(t.range)}))],new $.$YL("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(R.ColorPresentation.to):[])),new $.$ZL("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$XL.Uri,$.$XL.Range],new $.$YL("A promise that resolves to an array of Inlay objects",(t,i,a)=>t.map(R.InlayHint.to.bind(void 0,a)))),new $.$ZL("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$XL.Uri],new $.$YL("A promise that resolves to an array of FoldingRange objects",(t,i)=>{if(t)return t.map(R.FoldingRange.to)})),new $.$ZL("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$YL("A promise that resolves to an array of NotebookContentProvider static info objects.",b(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(i=>R.NotebookExclusiveDocumentPattern.to(i))})))),new $.$ZL("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$XL.Uri,$.$XL.Range],new $.$YL("A promise that resolves to an array of InlineValue objects",t=>t.map(R.InlineValue.to))),new $.$ZL("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$XL("uriOrString","Uri-instance or string (only http/https)",t=>I.URI.isUri(t)||typeof t=="string"&&(0,k.$7Y)(t,L.Schemas.http,L.Schemas.https),t=>t),new $.$XL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional(),$.$XL.String.with("label","").optional()],$.$YL.Void),new $.$ZL("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$XL.Uri.with("resource","Resource to open"),$.$XL.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new $.$XL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[R.ViewColumn.from(t),void 0]:[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)])).optional()],$.$YL.Void),new $.$ZL("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$XL.Uri.with("left","Left-hand side resource of the diff editor"),$.$XL.Uri.with("right","Right-hand side resource of the diff editor"),$.$XL.String.with("title","Human readable title for the diff editor").optional(),new $.$XL("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[R.ViewColumn.from(t.viewColumn),R.TextEditorOpenOptions.from(t)]).optional()],$.$YL.Void),new $.$ZL("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$XL.Uri,$.$XL.Position],new $.$YL("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new $.$ZL("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$XL.TypeHierarchyItem],new $.$YL("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new $.$ZL("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$XL.TypeHierarchyItem],new $.$YL("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(R.TypeHierarchyItem.to))),new $.$ZL("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$XL.TestItem],$.$YL.Void),new $.$ZL("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$XL.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$YL.Void),new $.$ZL("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$XL.String.with("name","The context key name"),new $.$XL("value","The context key value",()=>!0,t=>t)],$.$YL.Void)];class y{static register(i){c.forEach(i.registerApiCommand,i),this.a(i)}static a(i){i.registerCommand(!1,"_validateWhenClauses",d.$ui)}}e.$R$b=y;function b(t){return i=>{if(Array.isArray(i))return i.map(t)}}function o(t){if(!Array.isArray(t))return;const i=[];for(const a of t)z.$os(a)?i.push(R.DefinitionLink.to(a)):i.push(R.location.to(a));return i}}),define(Ae[222],Re([1,0,16,66,5,6,2,78,21,8,7,4,26,12]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=void 0;function b(o,t,i){const a=o.getProxy(E.$xJ.MainThreadComments);class m{static{this.a=0}constructor(){this.b=new Map,this.c=new k.$Hl,t.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const g=this.b.get(l.handle);return g?g.value:l}else if(l&&l.$mid===7){const g=this.b.get(l.commentControlHandle);if(!g)return l;const v=g.getCommentThread(l.commentThreadHandle);return v?v.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const g=this.b.get(l.thread.commentControlHandle);if(!g)return l;const v=g.getCommentThread(l.thread.commentThreadHandle);return v?l.$mid===8?v.value:{thread:v.value,text:l.text}:l}else if(l&&l.$mid===10){const g=this.b.get(l.thread.commentControlHandle);if(!g)return l;const v=g.getCommentThread(l.thread.commentThreadHandle);if(!v)return l;const u=l.commentUniqueId,f=v.getCommentByUniqueId(u);return f||l}else if(l&&l.$mid===11){const g=this.b.get(l.thread.commentControlHandle);if(!g)return l;const v=g.getCommentThread(l.thread.commentThreadHandle);if(!v)return l;const u=l.text,f=l.commentUniqueId,A=v.getCommentByUniqueId(f);return A?(typeof A.body=="string"?A.body=u:A.body=new R.$1J(u),A):l}return l}})}createCommentController(l,g,v){const u=m.a++,f=new C(l,u,g,v);this.b.set(f.handle,f);const A=this.c.get(l.identifier)||[];return A.push(f),this.c.set(l.identifier,A),f.value}$createCommentThreadTemplate(l,g,v){const u=this.b.get(l);u&&u.$createCommentThreadTemplate(g,v)}async $updateCommentThreadTemplate(l,g,v){const u=this.b.get(l);u&&u.$updateCommentThreadTemplate(g,v)}$deleteCommentThread(l,g){this.b.get(l)?.$deleteCommentThread(g)}$provideCommentingRanges(l,g,v){const u=this.b.get(l);if(!u||!u.commentingRangeProvider)return Promise.resolve(void 0);const f=i.getDocument(P.URI.revive(g));return(0,w.$mg)(async()=>{const A=await u.commentingRangeProvider.provideCommentingRanges(f,v);let W;return Array.isArray(A)?W={ranges:A,fileComments:!1}:A?W={ranges:A.ranges||[],fileComments:A.fileComments||!1}:W=(0,y.$Ae)(A),W}).then(A=>{let W;return A&&(W={ranges:A.ranges.map(B=>$.Range.from(B)),fileComments:A.fileComments}),W})}$toggleReaction(l,g,v,u,f){const A=this.b.get(l);return!A||!A.reactionHandler?Promise.resolve(void 0):(0,w.$mg)(()=>{const W=A.getCommentThread(g);if(W){const B=W.getCommentByUniqueId(u.uniqueIdInThread);if(A!==void 0&&B&&A.reactionHandler)return A.reactionHandler(B,n(f))}return Promise.resolve(void 0)})}}class S{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,g,v,u,f,A,W,B){this.m=g,this.n=v,this.o=u,this.p=f,this.q=A,this.extensionDescription=W,this.r=B,this.handle=S.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$7c,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new z.$mb,this.l.value=new z.$kb,this.n===void 0&&(this.n=`${l}.${this.handle}`),a.$createCommentThread(g,this.handle,this.n,this.o,$.Range.from(this.p),W.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=A,this.i.push({dispose:()=>{a.$deleteCommentThread(g,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(U){V.range=U},get comments(){return V.comments},set comments(U){V.comments=U},get collapsibleState(){return V.collapsibleState},set collapsibleState(U){V.collapsibleState=U},get canReply(){return V.canReply},set canReply(U){V.canReply=U},get contextValue(){return V.contextValue},set contextValue(U){V.contextValue=U},get label(){return V.label},set label(U){V.label=U},get state(){return V.state},set state(U){V.state=U},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new z.$kb);const l=v=>Object.prototype.hasOwnProperty.call(this.b,v),g={};l("range")&&(g.range=$.Range.from(this.p)),l("label")&&(g.label=this.label),l("contextValue")&&(g.contextValue=this.contextValue??null),l("comments")&&(g.comments=this.q.map(v=>r(this,v,this.k,this.extensionDescription))),l("collapsibleState")&&(g.collapseState=s(this.g)),l("canReply")&&(g.canReply=this.canReply),l("state")&&(g.state=p(this.h)),l("isTemplate")&&(g.isTemplate=this.r),this.b={},a.$updateCommentThread(this.m,this.handle,this.n,this.o,g)}getCommentByUniqueId(l){for(const g of this.k){const v=g[0],u=g[1];if(l===u)return v}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}qe([(0,L.$Sg)(100)],S.prototype,"eventuallyUpdateCommentThread",null);class C{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,a.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,g,v,u){this.f=l,this.g=g,this.h=v,this.i=u,this.a=new Map,a.$registerCommentController(this.handle,v,u);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(A){f.options=A},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(A){f.commentingRangeProvider=A},get reactionHandler(){return f.reactionHandler},set reactionHandler(A){f.reactionHandler=A},createCommentThread(A,W,B){return f.createCommentThread(A,W,B).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}createCommentThread(l,g,v){g===void 0&&(0,c.$wF)(this.f,"fileComments");const u=new S(this.id,this.handle,void 0,l,g,v,this.f,!1);return this.a.set(u.handle,u),u}$createCommentThreadTemplate(l,g){const v=new S(this.id,this.handle,void 0,P.URI.revive(l),$.Range.to(g),[],this.f,!0);return v.collapsibleState=d.CommentThreadCollapsibleState.Expanded,this.a.set(v.handle,v),v}$updateCommentThreadTemplate(l,g){const v=this.a.get(l);v&&(v.range=$.Range.to(g))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function r(D,l,g,v){let u=g.get(l);return u||(u=++D.commentHandle,g.set(l,u)),l.state!==void 0&&(0,c.$wF)(v,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:u,body:typeof l.body=="string"?l.body:$.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(f=>h(f)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function h(D){return{label:D.label,iconPath:D.iconPath?$.$yL(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted}}function n(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?P.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1}}function s(D){if(D!==void 0)switch(D){case R.CommentThreadCollapsibleState.Expanded:return d.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return d.CommentThreadCollapsibleState.Collapsed}return d.CommentThreadCollapsibleState.Collapsed}function p(D){if(D!==void 0)switch(D){case R.CommentThreadState.Unresolved:return d.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return d.CommentThreadState.Resolved}return d.CommentThreadState.Unresolved}return new m}e.$T$b=b}),define(Ae[223],Re([1,0,24,4,27,17]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=void 0;let P=class{constructor(R,E){this.a=R.getProxy(L.$xJ.MainThreadConsole),this.b=E.consoleForward.includeStack,this.c=E.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,E){const c=this,y=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){c.e(R,E,y,arguments)}})}e(R,E,c,y){this.a.$logExtensionHostMessage({type:"__$console",severity:E,arguments:k(y,this.b)}),this.c&&this.f(R,c,y)}};e.$Lac=P,e.$Lac=P=qe([Ve(0,z.$zL),Ve(1,I.$PL)],P);const d=1e5;function k($,R){const E=[];if($.length)for(let c=0;c<$.length;c++){let y=$[c];if(typeof y>"u")y="undefined";else if(y instanceof Error){const b=y;b.stack?y=b.stack:y=b.toString()}E.push(y)}if(R){const c=new Error().stack;c&&E.push({__$stack:c.split(`
`).slice(3).join(`
`)})}try{const c=(0,w.$Km)(E);return c.length>d?"Output omitted for a large object that exceeds the limits":c}catch(c){return`Output omitted for an object that cannot be inspected ('${c.toString()}')`}}}),define(Ae[107],Re([1,0,2,4,7,3,17,14,18,15,19,26]),function($e,e,w,L,I,z,P,d,k,$,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V_b=e.$U_b=void 0;let c=class Zi{static{this.c=0}static{this.d=250}constructor(b,o){this.h=o,this.f=new Map,this.g=b.getProxy(L.$xJ.MainThreadDecorations)}registerFileDecorationProvider(b,o){const t=Zi.c++;this.f.set(t,{provider:b,extensionDescription:o}),this.g.$registerDecorationProvider(t,o.identifier.value);const i=b.onDidChangeFileDecorations&&b.onDidChangeFileDecorations(a=>{if(!a){this.g.$onDidChange(t,null);return}const m=(0,k.$If)(a);if(m.length<=Zi.d){this.g.$onDidChange(t,m);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,m.length);const S=m.map(h=>({uri:h,rank:(0,$.$od)(h.path,"/")})),C=(0,k.$gf)(S,(h,n)=>h.rank-n.rank||(0,$.$Ed)(h.uri.path,n.uri.path)),r=[];e:for(const h of C){let n;for(const s of h){const p=(0,R.$dc)(s.uri.path);if(n!==p&&(n=p,r.push(s.uri)>=Zi.d))break e}}this.g.$onDidChange(t,r)});return new I.$zJ(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(b,o,t){if(!this.f.has(b))return Object.create(null);const i=Object.create(null),{provider:a,extensionDescription:m}=this.f.get(b);return await Promise.all(o.map(async S=>{try{const{uri:C,id:r}=S,h=await Promise.resolve(a.provideFileDecoration(w.URI.revive(C),t));if(!h)return;try{I.$VK.validate(h),h.badge&&typeof h.badge!="string"&&(0,E.$wF)(m,"codiconDecoration"),i[r]=[h.propagate,h.tooltip,h.badge,h.color]}catch(n){this.h.warn(`INVALID decoration from extension '${m.identifier.value}': ${n}`)}}catch(C){this.h.error(C)}})),i}};e.$U_b=c,e.$U_b=c=qe([Ve(0,P.$zL),Ve(1,d.$Pi)],c),e.$V_b=(0,z.$nh)("IExtHostDecorations")}),define(Ae[224],Re([1,0,147,94,2,4,7,8,5,14,28,39]),function($e,e,w,L,I,z,P,d,k,$,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M$b=e.$L$b=void 0;class c{#e;#t;#i;constructor(o,t,i,a,m,S,C,r){this.d=o,this.e=t,this.f=i,this.g=a,this.h=m,this.c=!1,this.f=Math.max(a,i),this.#i=new R.$li(h=>S.getComparisonKey(h)),this.#e=C,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,t){if(!o){this.clear();return}this.j();let i=[];if(I.URI.isUri(o)){if(!t){this.delete(o);return}this.#i.set(o,t.slice()),i=[o]}else if(Array.isArray(o)){i=[];let S;o=[...o].sort(c.k);for(const C of o){const[r,h]=C;if((!S||r.toString()!==S.toString())&&(S&&this.#i.get(S).length===0&&this.#i.delete(S),S=r,i.push(r),this.#i.set(r,[])),h)this.#i.get(r)?.push(...h);else{const n=this.#i.get(r);n&&(n.length=0)}}}if(this.#t.fire(i),!this.#e)return;const a=[];let m=0;for(const S of i){let C=[];const r=this.#i.get(S);if(r)if(r.length>this.g){C=[];const h=[P.DiagnosticSeverity.Error,P.DiagnosticSeverity.Warning,P.DiagnosticSeverity.Information,P.DiagnosticSeverity.Hint];e:for(let n=0;n<4;n++)for(const s of r)if(s.severity===h[n]&&C.push({...d.Diagnostic.from(s),modelVersionId:this.h(S)})===this.g)break e;C.push({severity:L.MarkerSeverity.Info,message:(0,w.localize)(0,null,r.length-this.g),startLineNumber:C[C.length-1].startLineNumber,startColumn:C[C.length-1].startColumn,endLineNumber:C[C.length-1].endLineNumber,endColumn:C[C.length-1].endColumn})}else C=r.map(h=>({...d.Diagnostic.from(h),modelVersionId:this.h(S)}));if(a.push([S,C]),m+=C.length,m>this.f)break}this.#e.$changeMany(this.e,a)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,t){this.j();for(const[i,a]of this)o.call(t,i,a,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const t=this.#i.get(o);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,t){return o[0].toString()<t[0].toString()?-1:o[0].toString()>t[0].toString()?1:0}}e.$L$b=c;let y=class li{static{this.c=0}static{this.d=1e3}static{this.e=1.1*li.d}static _mapper(o){const t=new R.$li;for(const i of o)t.set(i,i);return{uris:Object.freeze(Array.from(t.values()))}}constructor(o,t,i,a){this.j=t,this.k=i,this.l=a,this.g=new Map,this.h=new k.$$c({merge:m=>m.flat(),delay:50}),this.onDidChangeDiagnostics=k.Event.map(this.h.event,li._mapper),this.f=o.getProxy(z.$xJ.MainThreadDiagnostics)}createDiagnosticCollection(o,t){const{g:i,f:a,h:m,j:S,k:C,l:r}=this,h=new class{$changeMany(p,D){a.$changeMany(p,D),S.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,p,D.length===0?"CLEARING":D)}$clear(p){a.$clear(p),S.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,p)}dispose(){a.dispose()}};let n;if(!t)t="_generated_diagnostic_collection_name_#"+li.c++,n=t;else if(!i.has(t))n=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do n=t+li.c++;while(i.has(n))}return new class extends c{constructor(){super(t,n,li.e,li.d,p=>r.getDocument(p)?.version,C.extUri,h,m),i.set(n,this)}dispose(){super.dispose(),i.delete(n)}}}getDiagnostics(o){if(o)return this.m(o);{const t=new Map,i=[];for(const a of this.g.values())a.forEach((m,S)=>{let C=t.get(m.toString());typeof C>"u"&&(C=i.length,t.set(m.toString(),C),i.push([m,[]])),i[C][1]=i[C][1].concat(...S)});return i}}m(o){let t=[];for(const i of this.g.values())i.has(o)&&(t=t.concat(i.get(o)));return t}$acceptMarkersChange(o){if(!this.n){const t="_generated_mirror",i=new c(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,a=>{},this.k.extUri,void 0,this.h);this.g.set(t,i),this.n=i}for(const[t,i]of o)this.n.set(I.URI.revive(t),i.map(d.Diagnostic.to))}};e.$M$b=y,e.$M$b=y=qe([Ve(1,$.$Pi),Ve(2,E.$K$b)],y)}),define(Ae[225],Re([1,0,2,4,26]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=void 0;class z{constructor(d){this.a=d.getProxy(L.$xJ.MainThreadDialogs)}showOpenDialog(d,k){return k?.allowUIResources&&(0,I.$wF)(d,"showLocal"),this.a.$showOpenDialog(k).then($=>$?$.map(R=>w.URI.revive(R)):void 0)}showSaveDialog(d){return this.a.$showSaveDialog(d).then(k=>k?w.URI.revive(k):void 0)}}e.$2$b=z}),define(Ae[226],Re([1,0,11,2,7,4,13,20,15]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=void 0;class ${static{this.a=0}constructor(E,c,y){this.d=c,this.e=y,this.b=new Map,this.c=E.getProxy(z.$xJ.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(E,c){if(Object.keys(P.Schemas).indexOf(E)>=0)throw new Error(`scheme '${E}' already registered`);const y=$.a++;this.b.set(y,c),this.c.$registerTextContentProvider(y,E);let b;return typeof c.onDidChange=="function"&&(b=c.onDidChange(o=>{if(o.scheme!==E){this.e.warn(`Provider for scheme '${E}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}this.d.getDocument(o)&&this.$provideTextDocumentContent(y,o).then(t=>{if(!t&&typeof t!="string")return;const i=this.d.getDocument(o);if(!i)return;const a=(0,k.$zd)(t);if(!i.equalLines(a))return this.c.$onVirtualDocumentChange(o,t)},w.$Y)})),new I.$zJ(()=>{this.b.delete(y)&&this.c.$unregisterTextContentProvider(y),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(E,c){const y=this.b.get(E);return y?Promise.resolve(y.provideTextDocumentContent(L.URI.revive(c),d.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.$3$b=$}),define(Ae[227],Re([1,0,5,6,2,4,100,8,12,24,7,11]),function($e,e,w,L,I,z,P,d,k,$,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I$b=void 0;class c{constructor(b,o){this.a=new w.$7c({onListenerError:E.$Z}),this.b=new w.$7c({onListenerError:E.$Z}),this.c=new w.$7c({onListenerError:E.$Z}),this.d=new w.$7c({onListenerError:E.$Z}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.$kb,this.h=new Map,this.f=b.getProxy(z.$xJ.MainThreadDocuments),this.g=o,this.g.onDidRemoveDocuments(t=>{for(const i of t)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(t=>{for(const i of t)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const o=this.g.getDocument(b);if(o)return o}getDocument(b){const o=this.getDocumentData(b);if(!o?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return o.document}ensureDocumentData(b){const o=this.g.getDocument(b);if(o)return Promise.resolve(o);let t=this.h.get(b.toString());return t||(t=this.f.$tryOpenDocument(b).then(i=>{this.h.delete(b.toString());const a=I.URI.revive(i);return(0,k.$te)(this.g.getDocument(a))},i=>(this.h.delete(b.toString()),Promise.reject(i))),this.h.set(b.toString(),t)),t}createDocumentData(b){return this.f.$tryCreateDocument(b).then(o=>I.URI.revive(o))}$acceptModelLanguageChanged(b,o){const t=I.URI.revive(b),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(o),this.a.fire(i.document)}$acceptModelSaved(b){const o=I.URI.revive(b),t=this.g.getDocument(o);if(!t)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(t.document)}$acceptDirtyStateChanged(b,o){const t=I.URI.revive(b),i=this.g.getDocument(t);if(!i)throw new Error("unknown document");i._acceptIsDirty(o),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,o,t){const i=I.URI.revive(b),a=this.g.getDocument(i);if(!a)throw new Error("unknown document");a._acceptIsDirty(t),a.onEvents(o);let m;o.isUndoing?m=R.TextDocumentChangeReason.Undo:o.isRedoing&&(m=R.TextDocumentChangeReason.Redo),this.c.fire((0,$.$Gm)({document:a.document,contentChanges:o.changes.map(S=>({range:d.Range.to(S.range),rangeOffset:S.rangeOffset,rangeLength:S.rangeLength,text:S.text})),reason:m}))}setWordDefinitionFor(b,o){(0,P.$BL)(b,o)}}e.$I$b=c}),define(Ae[60],Re([1,0,50,5,6,2,3,4,100,17,105,8,14,28,13,68,67]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.$JL=void 0;class i{constructor(S){this.value=S,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let a=class{constructor(S,C){this.h=S,this.i=C,this.a=null,this.b=new Map,this.c=new y.$li,this.d=new L.$7c,this.e=new L.$7c,this.f=new L.$7c,this.g=new L.$7c,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(S){this.acceptDocumentsAndEditorsDelta(S)}acceptDocumentsAndEditorsDelta(S){const C=[],r=[],h=[];if(S.removedDocuments)for(const n of S.removedDocuments){const s=z.URI.revive(n),p=this.c.get(s);p?.unref()&&(this.c.delete(s),C.push(p.value))}if(S.addedDocuments)for(const n of S.addedDocuments){const s=z.URI.revive(n.uri);let p=this.c.get(s);if(p&&s.scheme!==b.Schemas.vscodeNotebookCell&&s.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);p||(p=new i(new k.$CL(this.h.getProxy(d.$xJ.MainThreadDocuments),s,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(s,p),r.push(p.value)),p.ref()}if(S.removedEditors)for(const n of S.removedEditors){const s=this.b.get(n);this.b.delete(n),s&&h.push(s)}if(S.addedEditors)for(const n of S.addedEditors){const s=z.URI.revive(n.documentUri);w.ok(this.c.has(s),`document '${s}' does not exist`),w.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const p=this.c.get(s).value,D=new R.$IL(n.id,this.h.getProxy(d.$xJ.MainThreadTextEditors),this.i,new t.$T(()=>p.document),n.selections.map(E.Selection.to),n.options,n.visibleRanges.map(l=>E.Range.to(l)),typeof n.editorPosition=="number"?E.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,D)}S.newActiveEditor!==void 0&&(w.ok(S.newActiveEditor===null||this.b.has(S.newActiveEditor),`active editor '${S.newActiveEditor}' does not exist`),this.a=S.newActiveEditor),(0,I.$gb)(C),(0,I.$gb)(h),S.removedDocuments&&this.e.fire(C),S.addedDocuments&&this.d.fire(r),(S.removedEditors||S.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),S.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(S){return this.c.get(S)?.value}allDocuments(){return o.Iterable.map(this.c.values(),S=>S.value)}getEditor(S){return this.b.get(S)}activeEditor(S){if(!this.a)return;const C=this.b.get(this.a);return S?C:C?.value}allEditors(){return[...this.b.values()]}};e.$JL=a,e.$JL=a=qe([Ve(0,$.$zL),Ve(1,c.$Pi)],a),e.$KL=(0,P.$nh)("IExtHostDocumentsAndEditors")}),define(Ae[61],Re([1,0,8,4,2,5,3,7,17,12,65]),function($e,e,w,L,I,z,P,d,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=e.$Z_b=void 0,e.$Z_b=(0,P.$nh)("IExtHostEditorTabs");class E{constructor(t,i,a){this.e=a,this.d=i,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(i)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new d.$gL(I.URI.revive(this.b.input.uri));case 2:return new d.$hL(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new d.$iL(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new d.$jL(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new d.$kL(this.b.input.viewType);case 4:return new d.$lL(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new d.$mL(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new d.$nL;case 9:return new d.$oL(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));default:return}}}class c{constructor(t,i){this.c=[],this.d="",this.b=t,this.e=i;for(const a of t.tabs)a.isActive&&(this.d=a.id),this.c.push(new E(a,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,i={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return w.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(a=>a.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(a=>a.apiObject))}};this.a=Object.freeze(i)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const a=new E(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,a),t.tabDto.isActive&&(this.d=a.tabId),a}else if(t.kind===1){const a=this.c.splice(t.index,1)[0];if(!a)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return a.tabId===this.d&&(this.d=""),a}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const a=this.c.splice(t.oldIndex,1)[0];if(!a)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,a),a}const i=this.c.find(a=>a.tabId===t.tabDto.id);if(!i)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),i.acceptDtoUpdate(t.tabDto),i}activeTabId(){return this.d}}let y=class{constructor(t){this.b=new z.$7c,this.c=new z.$7c,this.e=[],this.a=t.getProxy(L.$xJ.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,i={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(a=>a.apiObject))},get activeTabGroup(){const a=t.d;return(0,$.$te)(t.e.find(S=>S.groupId===a)?.apiObject)},close:async(a,m)=>{const S=Array.isArray(a)?a:[a];return S.length?b(S[0])?this.j(S,m):this.i(S,m):!0}};this.f=Object.freeze(i)}return this.f}$acceptEditorTabModel(t){const i=new Set(this.e.map(n=>n.groupId)),a=new Set(t.map(n=>n.groupId)),m=(0,R.$J)(i,a),S=this.e.filter(n=>m.removed.includes(n.groupId)).map(n=>n.apiObject),C=[],r=[];this.e=t.map(n=>{const s=new c(n,()=>this.d);return m.added.includes(s.groupId)?C.push(s.apiObject):r.push(s.apiObject),s});const h=(0,$.$te)(t.find(n=>n.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:C,closed:S,changed:r}))}$acceptTabGroupUpdate(t){const i=this.e.find(a=>a.groupId===t.groupId);if(!i)throw new Error("Update Group IPC call received before group creation.");i.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[i.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const i=this.e.find(m=>m.groupId===t.groupId);if(!i)throw new Error("Update Tabs IPC call received before group creation.");const a=i.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[a.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[a.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[a.apiObject]}));return}}g(t){for(const i of this.e)for(const a of i.tabs)if(a.apiObject===t)return a}h(t){return this.e.find(i=>i.apiObject===t)}async i(t,i){const a=[];for(const m of t){const S=this.g(m);if(!S)throw new Error("Tab close: Invalid tab not found!");a.push(S.tabId)}return this.a.$closeTab(a,i)}async j(t,i){const a=[];for(const m of t){const S=this.h(m);if(!S)throw new Error("Group close: Invalid group not found!");a.push(S.groupId)}return this.a.$closeGroup(a,i)}};e.$1_b=y,e.$1_b=y=qe([Ve(0,k.$zL)],y);function b(o){return o.tabs!==void 0}}),define(Ae[228],Re([1,0,2,4,6,7,8,275,15,25,26,49]),function($e,e,w,L,I,z,P,d,k,$,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=void 0;class c{constructor(){this.a=[]}add(o){this.b=void 0,this.a.push(o)}delete(o){const t=this.a.indexOf(o);t>=0&&(this.a.splice(t,1),this.b=void 0)}c(){if(!this.b){const o=this.a.sort(),t=[];let i,a,m=14,S=14;for(const C of o){let r=i?(0,k.$Nd)(i,C):0;for(r===0?a=1:a=S;r<C.length;r++)r+1===C.length?(m=S,S=9):S+=1,t.push([a,C.toUpperCase().charCodeAt(r),S]),t.push([a,C.toLowerCase().charCodeAt(r),S]),a=S;i=C,S=m}t.push([9,58,10]),t.push([10,47,12]),this.b=new d.$6W(t)}}provideDocumentLinks(o){this.c();const t=[],i=d.$7W.computeLinks({getLineContent(a){return o.lineAt(a-1).text},getLineCount(){return o.lineCount}},this.b);for(const a of i){const m=P.DocumentLink.to(a);m.target&&t.push(m)}return t}}class y{constructor(o,t){this.i=t,this.b=new c,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=o.getProxy(L.$xJ.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(o,t,i,a={}){if(y.j(i),this.d.has(t))throw new Error(`a provider for the scheme '${t}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(o,"*",this.b));const m=this.h++;this.b.add(t),this.d.add(t),this.c.set(m,i);let S=2;a.isCaseSensitive&&(S+=1024),a.isReadonly&&(S+=2048),typeof i.copy=="function"&&(S+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,R.$wF)(o,"fsChunks"),S+=4);let C;a.isReadonly&&(0,E.$Kj)(a.isReadonly)&&((0,R.$wF)(o,"readonlyMessage"),C={value:a.isReadonly.value,isTrusted:a.isReadonly.isTrusted,supportThemeIcons:a.isReadonly.supportThemeIcons,supportHtml:a.isReadonly.supportHtml,baseUri:a.isReadonly.baseUri,uris:a.isReadonly.uris}),this.a.$registerFileSystemProvider(m,t,S,C).catch(h=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${t}`),console.error(h)});const r=i.onDidChangeFile(h=>{const n=[];for(const s of h){const{uri:p,type:D}=s;if(p.scheme!==t)continue;let l;switch(D){case z.FileChangeType.Changed:l=0;break;case z.FileChangeType.Created:l=1;break;case z.FileChangeType.Deleted:l=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:p,type:l})}this.a.$onFileSystemChange(m,n)});return(0,I.$jb)(()=>{r.dispose(),this.b.delete(t),this.d.delete(t),this.c.delete(m),this.a.$unregisterProvider(m)})}static j(o){if(!o)throw new Error("MISSING provider");if(typeof o.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof o.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof o.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof o.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof o.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof o.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof o.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof o.rename!="function")throw new Error("Provider does NOT implement rename")}static k(o){const{type:t,ctime:i,mtime:a,size:m,permissions:S}=o;return{type:t,ctime:i,mtime:a,size:m,permissions:S}}$stat(o,t){return Promise.resolve(this.l(o).stat(w.URI.revive(t))).then(i=>y.k(i))}$readdir(o,t){return Promise.resolve(this.l(o).readDirectory(w.URI.revive(t)))}$readFile(o,t){return Promise.resolve(this.l(o).readFile(w.URI.revive(t))).then(i=>$.$Jb.wrap(i))}$writeFile(o,t,i,a){return Promise.resolve(this.l(o).writeFile(w.URI.revive(t),i.buffer,a))}$delete(o,t,i){return Promise.resolve(this.l(o).delete(w.URI.revive(t),i))}$rename(o,t,i,a){return Promise.resolve(this.l(o).rename(w.URI.revive(t),w.URI.revive(i),a))}$copy(o,t,i,a){const m=this.l(o);if(!m.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(m.copy(w.URI.revive(t),w.URI.revive(i),a))}$mkdir(o,t){return Promise.resolve(this.l(o).createDirectory(w.URI.revive(t)))}$watch(o,t,i,a){const m=this.l(o).watch(w.URI.revive(i),a);this.f.set(t,m)}$unwatch(o,t){const i=this.f.get(t);i&&(i.dispose(),this.f.delete(t))}$open(o,t,i){const a=this.l(o);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(w.URI.revive(t),i))}$close(o,t){const i=this.l(o);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(o,t,i,a){const m=this.l(o);if(!m.read)throw new Error('FileSystemProvider does not implement "read"');const S=$.$Jb.alloc(a);return Promise.resolve(m.read(t,i,S.buffer,0,a)).then(C=>S.slice(0,C))}$write(o,t,i,a){const m=this.l(o);if(!m.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(m.write(t,i,a.buffer,0,a.byteLength))}l(o){const t=this.c.get(o);if(!t){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return t}}e.$w_b=y}),define(Ae[62],Re([1,0,4,38,7,25,3,17,39,6,16,23,13]),function($e,e,w,L,I,z,P,d,k,$,R,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=e.$c_b=void 0;let y=class ii{constructor(o,t){this.b=new Map,this.c=new R.$Bg,this.a=o.getProxy(w.$xJ.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(a){try{let m;const S=i.b.get(a.scheme);return S?(await i.a.$ensureActivation(a.scheme),m=await S.impl.stat(a)):m=await i.a.$stat(a),{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===L.FilePermission.Readonly?1:void 0}}catch(m){ii.e(m)}},async readDirectory(a){try{const m=i.b.get(a.scheme);return m?(await i.a.$ensureActivation(a.scheme),(await m.impl.readDirectory(a)).slice()):await i.a.$readdir(a)}catch(m){return ii.e(m)}},async createDirectory(a){try{const m=i.b.get(a.scheme);return m&&!m.isReadonly?(await i.a.$ensureActivation(a.scheme),await i.d(m.impl,m.extUri,a)):await i.a.$mkdir(a)}catch(m){return ii.e(m)}},async readFile(a){try{const m=i.b.get(a.scheme);return m?(await i.a.$ensureActivation(a.scheme),(await m.impl.readFile(a)).slice()):(await i.a.$readFile(a)).buffer}catch(m){return ii.e(m)}},async writeFile(a,m){try{const S=i.b.get(a.scheme);return S&&!S.isReadonly?(await i.a.$ensureActivation(a.scheme),await i.d(S.impl,S.extUri,S.extUri.dirname(a)),await i.c.queueFor(a).queue(()=>Promise.resolve(S.impl.writeFile(a,m,{create:!0,overwrite:!0})))):await i.a.$writeFile(a,z.$Jb.wrap(m))}catch(S){return ii.e(S)}},async delete(a,m){try{const S=i.b.get(a.scheme);return S&&!S.isReadonly?(await i.a.$ensureActivation(a.scheme),await S.impl.delete(a,{recursive:!1,...m})):await i.a.$delete(a,{recursive:!1,useTrash:!1,atomic:!1,...m})}catch(S){return ii.e(S)}},async rename(a,m,S){try{return await i.a.$rename(a,m,{overwrite:!1,...S})}catch(C){return ii.e(C)}},async copy(a,m,S){try{return await i.a.$copy(a,m,{overwrite:!1,...S})}catch(C){return ii.e(C)}},isWritableFileSystem(a){const m=t.getCapabilities(a);if(typeof m=="number")return!(m&2048)}})}async d(o,t,i){const a=[];for(;!t.isEqual(i,t.dirname(i));)try{if(!((await o.stat(i)).type&L.FileType.Directory))throw I.$NK.FileExists(`Unable to create folder '${i.scheme===c.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(m){if(L.$6j(m)!==L.FileSystemProviderErrorCode.FileNotFound)throw m;a.push(t.basename(i)),i=t.dirname(i)}for(let m=a.length-1;m>=0;m--){i=t.joinPath(i,a[m]);try{await o.createDirectory(i)}catch(S){if(L.$6j(S)!==L.FileSystemProviderErrorCode.FileExists)throw S}}}static e(o){if(o instanceof I.$NK)throw o;if(o instanceof L.$2j)switch(o.code){case L.FileSystemProviderErrorCode.FileExists:throw I.$NK.FileExists(o.message);case L.FileSystemProviderErrorCode.FileNotFound:throw I.$NK.FileNotFound(o.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw I.$NK.FileNotADirectory(o.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw I.$NK.FileIsADirectory(o.message);case L.FileSystemProviderErrorCode.NoPermissions:throw I.$NK.NoPermissions(o.message);case L.FileSystemProviderErrorCode.Unavailable:throw I.$NK.Unavailable(o.message);default:throw new I.$NK(o.message,o.name)}if(!(o instanceof Error))throw new I.$NK(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw I.$NK.Unavailable(o.message);switch(o.name){case L.FileSystemProviderErrorCode.FileExists:throw I.$NK.FileExists(o.message);case L.FileSystemProviderErrorCode.FileNotFound:throw I.$NK.FileNotFound(o.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw I.$NK.FileNotADirectory(o.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw I.$NK.FileIsADirectory(o.message);case L.FileSystemProviderErrorCode.NoPermissions:throw I.$NK.NoPermissions(o.message);case L.FileSystemProviderErrorCode.Unavailable:throw I.$NK.Unavailable(o.message);default:throw new I.$NK(o.message,o.name)}}addFileSystemProvider(o,t,i){return this.b.set(o,{impl:t,extUri:i?.isCaseSensitive?E.$Xf:E.$Zf,isReadonly:!!i?.isReadonly}),(0,$.$jb)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??E.$Xf}};e.$c_b=y,e.$c_b=y=qe([Ve(0,d.$zL),Ve(1,k.$K$b)],y),e.$d_b=(0,P.$nh)("IExtHostConsumerFileSystem")}),define(Ae[229],Re([1,0,5,37,2,4,8,7]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x_b=void 0;class k{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(E,c,y,b,o,t,i,a){this.a=new w.$7c,this.b=new w.$7c,this.c=new w.$7c;const m=this.h(E,y,o);this.g=0,t&&(this.g+=1),i&&(this.g+=2),a&&(this.g+=4);const S=(0,L.$cj)(o),C=typeof o=="string",r=b(h=>{if(!t)for(const n of h.created){const s=I.URI.revive(n);S(s.fsPath)&&(!C||c.getWorkspaceFolder(s))&&this.a.fire(s)}if(!i)for(const n of h.changed){const s=I.URI.revive(n);S(s.fsPath)&&(!C||c.getWorkspaceFolder(s))&&this.b.fire(s)}if(!a)for(const n of h.deleted){const s=I.URI.revive(n);S(s.fsPath)&&(!C||c.getWorkspaceFolder(s))&&this.c.fire(s)}});this.d=d.$zJ.from(m,this.a,this.b,this.c,r)}h(E,c,y){const b=d.$zJ.from();if(typeof y=="string")return b;const o=E.getProxy(z.$xJ.MainThreadFileSystem);let t=!1;(y.pattern.includes(L.$$i)||y.pattern.includes(L.$_i))&&(t=!0);const i=Math.random();return o.$watch(c.identifier.value,i,y.baseUri,{recursive:t,excludes:[]}),d.$zJ.from({dispose:()=>o.$unwatch(i)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class ${constructor(E,c,y){this.j=E,this.k=c,this.l=y,this.a=new w.$7c,this.b=new w.$7c,this.c=new w.$7c,this.d=new w.$7c,this.g=new w.$9c,this.h=new w.$9c,this.i=new w.$9c,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,c,y,b,o,t){return new k(this.j,E,c,this.a.event,P.GlobPattern.from(y),b,o,t)}$onFileEvent(E){this.a.fire(E)}$onDidRunFileOperation(E,c){switch(E){case 2:this.b.fire(Object.freeze({files:c.map(y=>({oldUri:I.URI.revive(y.source),newUri:I.URI.revive(y.target)}))}));break;case 1:this.d.fire(Object.freeze({files:c.map(y=>I.URI.revive(y.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:c.map(y=>I.URI.revive(y.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,c){return(y,b,o)=>{const t=function(a){y.call(b,a)};return t.extension=E,c.event(t,void 0,o)}}async $onWillRunFileOperation(E,c,y,b){switch(E){case 2:return await this.n(this.g,{files:c.map(o=>({oldUri:I.URI.revive(o.source),newUri:I.URI.revive(o.target)}))},y,b);case 1:return await this.n(this.i,{files:c.map(o=>I.URI.revive(o.target))},y,b);case 0:case 3:return await this.n(this.h,{files:c.map(o=>I.URI.revive(o.target))},y,b)}}async n(E,c,y,b){const o=new Set,t=[];if(await E.fireAsync(c,b,async(a,m)=>{const S=Date.now(),C=await Promise.resolve(a);C instanceof d.$JJ&&(t.push([m.extension,C]),o.add(m.extension.displayName??m.extension.identifier.value)),Date.now()-S>y&&this.k.warn("SLOW file-participant",m.extension.identifier)}),b.isCancellationRequested||t.length===0)return;const i={edits:[]};for(const[,a]of t){const{edits:m}=P.WorkspaceEdit.from(a,{getTextDocumentVersion:S=>this.l.getDocument(S)?.version,getNotebookDocumentVersion:()=>{}});i.edits=i.edits.concat(m)}return{edit:i,extensionNames:Array.from(o)}}}e.$x_b=$}),define(Ae[230],Re([1,0,6,2,4,8,7,32]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;class k{static{this.a=0}constructor(c,y){this.extension=c,this.provider=y,this.handle=k.a++}}class ${constructor(c){this.session=c,this.responses=[]}}class R{static{this.a=0}constructor(c,y,b,o){this.f=b,this.g=o,this.b=new Map,this.d=new Map,this.e=c.getProxy(I.$xJ.MainThreadInlineChat),y.registerApiCommand(new d.$ZL("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new d.$XL("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?z.Range.from(t.initialRange):void 0,message:t.message,autoSend:t.autoSend,position:t.position?z.Position.from(t.position):void 0}})],d.$YL.Void))}registerProvider(c,y){const b=new k(c,y);return this.b.set(b.handle,b),this.e.$registerInteractiveEditorProvider(b.handle,c.identifier.value,typeof y.handleInteractiveEditorResponseFeedback=="function"),(0,w.$jb)(()=>{this.e.$unregisterInteractiveEditorProvider(b.handle),this.b.delete(b.handle)})}async $prepareSession(c,y,b,o){const t=this.b.get(c);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(L.URI.revive(y)),a=z.Selection.to(b),m=await t.provider.prepareInteractiveEditorSession({document:i,selection:a},o);if(!m)return;if(m.wholeRange&&!m.wholeRange.contains(a))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const S=R.a++;return this.d.set(S,new $(m)),{id:S,placeholder:m.placeholder,slashCommands:m.slashCommands?.map(C=>({command:C.command,detail:C.detail,refer:C.refer,executeImmediately:C.executeImmediately})),wholeRange:z.Range.from(m.wholeRange),message:m.message}}async $provideResponse(c,y,b,o){const t=this.b.get(c);if(!t)return;const i=this.d.get(y.id);if(!i)return;const a={session:i.session,prompt:b.prompt,selection:z.Selection.to(b.selection),wholeRange:z.Range.to(b.wholeRange),attempt:b.attempt,live:b.live};let m=!1;const S={report:h=>{if(!b.live)throw new Error("Progress reporting is only supported for live sessions");m||o.isCancellationRequested||!h.message&&!h.edits||this.e.$handleProgressChunk(b.requestId,{message:h.message,edits:h.edits?.map(z.TextEdit.from)})}},C=typeof t.provider.provideInteractiveEditorResponse2=="function"?t.provider.provideInteractiveEditorResponse2(a,S,o):t.provider.provideInteractiveEditorResponse(a,o);Promise.resolve(C).finally(()=>m=!0);const r=await C;if(r){const h=i.responses.push(r)-1,n={wholeRange:z.Range.from(r.wholeRange),placeholder:r.placeholder};if(R.h(r))return{...n,id:h,type:"message",message:z.MarkdownString.from(r.contents)};const{edits:s}=r;if(s instanceof P.$JJ)return{...n,id:h,type:"bulkEdit",edits:z.WorkspaceEdit.from(s)};if(Array.isArray(s))return{...n,id:h,type:"editorEdit",edits:s.map(z.TextEdit.from)}}}$handleFeedback(c,y,b,o){const t=this.b.get(c),i=this.d.get(y),a=i?.responses[b];if(t&&a){let m;switch(o){case 1:m=P.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:m=P.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:m=P.InteractiveEditorResponseFeedbackKind.Undone;break;case 3:m=P.InteractiveEditorResponseFeedbackKind.Accepted;break}t.provider.handleInteractiveEditorResponseFeedback?.(i.session,a,m)}}$releaseSession(c,y){const b=this.d.get(y),o=this.b.get(c);b&&o&&o.provider.releaseInteractiveEditorSession?.(b.session),this.d.delete(y)}static h(c){return typeof c=="object"&&typeof c.contents=="object"}}e.$Eac=R}),define(Ae[231],Re([1,0,2,32]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=void 0;class I{constructor(P,d,k,$,R){this.a=d,this.b=k,this.c=$;const E=new L.$ZL("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.$XL("showOptions","Show Options",c=>!0,c=>c),new L.$XL("resource","Interactive resource Uri",c=>!0,c=>c),new L.$XL("controllerId","Notebook controller Id",c=>!0,c=>c),new L.$XL("title","Interactive editor title",c=>!0,c=>c)],new L.$YL("Notebook and input URI",c=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",c.notebookEditorId),c.notebookEditorId!==void 0){const y=this.a.getEditorById(c.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",y.id),{notebookUri:w.URI.revive(c.notebookUri),inputUri:w.URI.revive(c.inputUri),notebookEditor:y.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",c.notebookUri,c.inputUri),{notebookUri:w.URI.revive(c.notebookUri),inputUri:w.URI.revive(c.inputUri)}}));this.c.registerApiCommand(E)}$willAddInteractiveDocument(P,d,k,$){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:d,lines:[""],languageId:k,uri:P,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(w.URI.revive($))?.apiNotebook}]})}$willRemoveInteractiveDocument(P,d){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[P]})}}e.$Aac=I}),define(Ae[232],Re([1,0,4,7]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=void 0;class I{constructor(P){this.a=new Map,this.b=P.getProxy(w.$xJ.MainThreadIssueReporter)}async $getIssueReporterUri(P,d){if(this.a.size===0)throw new Error("No issue request handlers registered");const k=this.a.get(P);if(!k)throw new Error("Issue request handler not found");const $=await k.handleIssueUrlRequest();if(!$)throw new Error("Issue request handler returned no result");return $}registerIssueUriRequestHandler(P,d){const k=P.identifier.value;return this.a.set(k,d),this.b.$registerIssueUriRequestHandler(k),new L.$zJ(()=>{this.b.$unregisterIssueUriRequestHandler(k),this.a.delete(k)})}}e.$Hac=I}),define(Ae[233],Re([1,0,6,4]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=void 0;class I{constructor(P){this.b=0,this.a=P.getProxy(L.$xJ.MainThreadLabelService)}$registerResourceLabelFormatter(P){const d=this.b++;return this.a.$registerResourceLabelFormatter(d,P),(0,w.$jb)(()=>{this.a.$unregisterResourceLabelFormatter(d)})}}e.$T_b=I}),define(Ae[234],Re([1,0,2,24,8,7,78,4,15,44,18,12,276,20,21,6,91,88,55,59,11,16,26,149]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S,C,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q$b=void 0;class n{constructor(F,q){this.d=F,this.e=q}async provideDocumentSymbols(F,q){const J=this.d.getDocument(F),K=await this.e.provideDocumentSymbols(J,q);if(!(0,R.$of)(K))return K[0]instanceof z.$RJ?K.map(I.DocumentSymbol.from):n.f(K)}static f(F){F=F.slice(0).sort((K,oe)=>{let H=K.location.range.start.compareTo(oe.location.range.start);return H===0&&(H=oe.location.range.end.compareTo(K.location.range.end)),H});const q=[],J=[];for(const K of F){const oe={name:K.name||"!!MISSING: name!!",kind:I.SymbolKind.from(K.kind),tags:K.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:I.Range.from(K.location.range),selectionRange:I.Range.from(K.location.range),children:[]};for(;;){if(J.length===0){J.push(oe),q.push(oe);break}const H=J[J.length-1];if($.$Mr.containsRange(H.range,oe.range)&&!$.$Mr.equalsRange(H.range,oe.range)){H.children?.push(oe),J.push(oe);break}J.pop()}}return q}}class s{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(F,q,J){this.g=F,this.h=q,this.j=J,this.e=new a.$H$b("CodeLens"),this.f=new Map}async provideCodeLenses(F,q){const J=this.g.getDocument(F),K=await this.j.provideCodeLenses(J,q);if(!K||q.isCancellationRequested)return;const oe=this.e.add(K),H=new o.$kb;this.f.set(oe,H);const ce={cacheId:oe,lenses:[]};for(let pe=0;pe<K.length;pe++)ce.lenses.push({cacheId:[oe,pe],range:I.Range.from(K[pe].range),command:this.h.toInternal(K[pe].command,H)});return ce}async resolveCodeLens(F,q){const J=F.cacheId&&this.e.get(...F.cacheId);if(!J)return;let K;if(typeof this.j.resolveCodeLens!="function"||J.isResolved?K=J:K=await this.j.resolveCodeLens(J,q),K||(K=J),q.isCancellationRequested)return;const oe=F.cacheId&&this.f.get(F.cacheId[0]);if(oe)return F.command=this.h.toInternal(K.command??s.d,oe),F}releaseCodeLenses(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}}function p(he){return Array.isArray(he)?he.map(I.DefinitionLink.from):he?[I.DefinitionLink.from(he)]:[]}class D{constructor(F,q){this.d=F,this.e=q}async provideDefinition(F,q,J){const K=this.d.getDocument(F),oe=I.Position.to(q),H=await this.e.provideDefinition(K,oe,J);return p(H)}}class l{constructor(F,q){this.d=F,this.e=q}async provideDeclaration(F,q,J){const K=this.d.getDocument(F),oe=I.Position.to(q),H=await this.e.provideDeclaration(K,oe,J);return p(H)}}class g{constructor(F,q){this.d=F,this.e=q}async provideImplementation(F,q,J){const K=this.d.getDocument(F),oe=I.Position.to(q),H=await this.e.provideImplementation(K,oe,J);return p(H)}}class v{constructor(F,q){this.d=F,this.e=q}async provideTypeDefinition(F,q,J){const K=this.d.getDocument(F),oe=I.Position.to(q),H=await this.e.provideTypeDefinition(K,oe,J);return p(H)}}class u{constructor(F,q){this.d=F,this.e=q}async provideHover(F,q,J){const K=this.d.getDocument(F),oe=I.Position.to(q),H=await this.e.provideHover(K,oe,J);if(!(!H||(0,R.$of)(H.contents)))return H.range||(H.range=K.getWordRangeAtPosition(oe)),H.range||(H.range=new z.$BJ(oe,oe)),I.Hover.from(H)}}class f{constructor(F,q){this.d=F,this.e=q}async provideEvaluatableExpression(F,q,J){const K=this.d.getDocument(F),oe=I.Position.to(q),H=await this.e.provideEvaluatableExpression(K,oe,J);if(H)return I.EvaluatableExpression.from(H)}}class A{constructor(F,q){this.d=F,this.e=q}async provideInlineValues(F,q,J,K){const oe=this.d.getDocument(F),H=await this.e.provideInlineValues(oe,I.Range.to(q),I.InlineValueContext.to(J),K);if(Array.isArray(H))return H.map(ce=>I.InlineValue.from(ce))}}class W{constructor(F,q){this.d=F,this.e=q}async provideDocumentHighlights(F,q,J){const K=this.d.getDocument(F),oe=I.Position.to(q),H=await this.e.provideDocumentHighlights(K,oe,J);if(Array.isArray(H))return H.map(I.DocumentHighlight.from)}}class B{constructor(F,q){this.d=F,this.e=q}async provideLinkedEditingRanges(F,q,J){const K=this.d.getDocument(F),oe=I.Position.to(q),H=await this.e.provideLinkedEditingRanges(K,oe,J);if(H&&Array.isArray(H.ranges))return{ranges:(0,R.$lf)(H.ranges.map(I.Range.from)),wordPattern:H.wordPattern}}}class V{constructor(F,q){this.d=F,this.e=q}async provideReferences(F,q,J,K){const oe=this.d.getDocument(F),H=I.Position.to(q),ce=await this.e.provideReferences(oe,H,J,K);if(Array.isArray(ce))return ce.map(I.location.from)}}class U{static{this.d=1e3}constructor(F,q,J,K,oe,H,ce){this.h=F,this.j=q,this.k=J,this.l=K,this.m=oe,this.n=H,this.o=ce,this.e=new a.$H$b("CodeAction"),this.f=new Map,this.g=new z.$TJ("notebook")}async provideCodeActions(F,q,J,K){const oe=this.h.getDocument(F),H=c.$Ur.isISelection(q)?I.Selection.to(q):I.Range.to(q),ce=[];for(const Qe of this.k.getDiagnostics(F))if(H.intersection(Qe.range)&&ce.push(Qe)>U.d)break;const pe={diagnostics:ce,only:J.only?new z.$TJ(J.only):void 0,triggerKind:I.CodeActionTriggerKind.to(J.trigger)},Oe=await this.l.provideCodeActions(oe,H,pe,K);if(!(0,R.$pf)(Oe)||K.isCancellationRequested)return;const Be=this.e.add(Oe),Ze=new o.$kb;this.f.set(Be,Ze);const Ke=[];for(let Qe=0;Qe<Oe.length;Qe++){const Ge=Oe[Qe];if(Ge)if(U.p(Ge))this.o.report("CodeActionProvider.provideCodeActions - return commands",this.n,"Return 'CodeAction' instances instead."),Ke.push({_isSynthetic:!0,title:Ge.title,command:this.j.toInternal(Ge,Ze)});else{if(pe.triggerKind!==z.CodeActionTriggerKind.Invoke&&Ge.kind&&this.g.contains(Ge.kind))continue;pe.only&&(Ge.kind?pe.only.contains(Ge.kind)||this.m.warn(`${this.n.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${Ge.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.m.warn(`${this.n.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ke.push({cacheId:[Be,Qe],title:Ge.title,command:Ge.command&&this.j.toInternal(Ge.command,Ze),diagnostics:Ge.diagnostics&&Ge.diagnostics.map(I.Diagnostic.from),edit:Ge.edit&&I.WorkspaceEdit.from(Ge.edit,void 0),kind:Ge.kind&&Ge.kind.value,isPreferred:Ge.isPreferred,disabled:Ge.disabled?.reason})}}return{cacheId:Be,actions:Ke}}async resolveCodeAction(F,q){const[J,K]=F,oe=this.e.get(J,K);if(!oe||U.p(oe))return{};if(!this.l.resolveCodeAction)return{};const H=await this.l.resolveCodeAction(oe,q)??oe;let ce;H.edit&&(ce=I.WorkspaceEdit.from(H.edit,void 0));let pe;if(H.command){const Oe=this.f.get(J);Oe&&(pe=this.j.toInternal(H.command,Oe))}return{edit:ce,command:pe}}releaseCodeActions(F){this.f.get(F)?.dispose(),this.f.delete(F),this.e.delete(F)}static p(F){return typeof F.command=="string"&&typeof F.title=="string"}}class O{constructor(F,q,J,K,oe){this.d=F,this.e=q,this.f=J,this.g=K,this.h=oe}async prepareDocumentPaste(F,q,J,K){if(!this.f.prepareDocumentPaste)return;const oe=this.e.getDocument(F),H=q.map(Oe=>I.Range.to(Oe)),ce=I.DataTransfer.toDataTransfer(J,()=>{throw new S.$0});if(await this.f.prepareDocumentPaste(oe,H,ce,K),K.isCancellationRequested)return;const pe=Array.from(ce).filter(([,Oe])=>!(Oe instanceof z.$oK));return I.DataTransfer.from(pe)}async providePasteEdits(F,q,J,K,oe){if(!this.f.provideDocumentPasteEdits)return;const H=this.e.getDocument(q),ce=J.map(Be=>I.Range.to(Be)),pe=I.DataTransfer.toDataTransfer(K,async Be=>(await this.d.$resolvePasteFileData(this.g,F,Be)).buffer),Oe=await this.f.provideDocumentPasteEdits(H,ce,pe,oe);if(Oe)return{id:Oe.id?this.h.identifier.value+"."+Oe.id:this.h.identifier.value,label:Oe.label??(0,h.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,priority:Oe.priority??0,insertText:typeof Oe.insertText=="string"?Oe.insertText:{snippet:Oe.insertText.value},additionalEdit:Oe.additionalEdit?I.WorkspaceEdit.from(Oe.additionalEdit,void 0):void 0}}}class N{constructor(F,q){this.d=F,this.e=q}async provideDocumentFormattingEdits(F,q,J){const K=this.d.getDocument(F),oe=await this.e.provideDocumentFormattingEdits(K,q,J);if(Array.isArray(oe))return oe.map(I.TextEdit.from)}}class ae{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeFormattingEdits(F,q,J,K){const oe=this.d.getDocument(F),H=I.Range.to(q),ce=await this.e.provideDocumentRangeFormattingEdits(oe,H,J,K);if(Array.isArray(ce))return ce.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(F,q,J,K){(0,E.$se)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const oe=this.d.getDocument(F),H=q.map(I.Range.to),ce=await this.e.provideDocumentRangesFormattingEdits(oe,H,J,K);if(Array.isArray(ce))return ce.map(I.TextEdit.from)}}class Q{constructor(F,q){this.d=F,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(F,q,J,K,oe){const H=this.d.getDocument(F),ce=I.Position.to(q),pe=await this.e.provideOnTypeFormattingEdits(H,ce,J,K,oe);if(Array.isArray(pe))return pe.map(I.TextEdit.from)}}class be{constructor(F,q){this.e=F,this.f=q,this.d=new a.$H$b("WorkspaceSymbols")}async provideWorkspaceSymbols(F,q){const J=await this.e.provideWorkspaceSymbols(F,q);if(!(0,R.$pf)(J))return{symbols:[]};const K=this.d.add(J),oe={cacheId:K,symbols:[]};for(let H=0;H<J.length;H++){const ce=J[H];if(!ce||!ce.name){this.f.warn("INVALID SymbolInformation",ce);continue}oe.symbols.push({...I.WorkspaceSymbol.from(ce),cacheId:[K,H]})}return oe}async resolveWorkspaceSymbol(F,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!F.cacheId)return F;const J=this.d.get(...F.cacheId);if(J){const K=await this.e.resolveWorkspaceSymbol(J,q);return K&&(0,L.$Im)(F,I.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(F){this.d.delete(F)}}class ke{static supportsResolving(F){return typeof F.prepareRename=="function"}constructor(F,q,J){this.d=F,this.e=q,this.f=J}async provideRenameEdits(F,q,J,K){const oe=this.d.getDocument(F),H=I.Position.to(q);try{const ce=await this.e.provideRenameEdits(oe,H,J,K);return ce?I.WorkspaceEdit.from(ce):void 0}catch(ce){const pe=ke.g(ce);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(ce)}}async resolveRenameLocation(F,q,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(F),oe=I.Position.to(q);try{const H=await this.e.prepareRename(K,oe,J);let ce,pe;if(z.$BJ.isRange(H)?(ce=H,pe=K.getText(H)):(0,E.$ke)(H)&&(ce=H.range,pe=H.placeholder),!ce||!pe)return;if(ce.start.line>oe.line||ce.end.line<oe.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ce),text:pe}}catch(H){const ce=ke.g(H);return ce?{rejectReason:ce,range:void 0,text:void 0}:Promise.reject(H)}}static g(F){return typeof F=="string"?F:F instanceof Error&&typeof F.message=="string"?F.message:void 0}}class Fe{constructor(F,q){this.resultId=F,this.tokens=q}}class G{constructor(F,q){this.f=F,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(F,q,J){const K=this.f.getDocument(F),oe=q!==0?this.d.get(q):null;let H=typeof oe?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,oe.resultId,J):await this.g.provideDocumentSemanticTokens(K,J);return oe&&this.d.delete(q),H?(H=G.h(H),this.o(G.n(oe,H),H)):null}async releaseDocumentSemanticColoring(F){this.d.delete(F)}static h(F){return G.j(F)?G.k(F)?F:new z.$RK(new Uint32Array(F.data),F.resultId):G.l(F)?G.m(F)?F:new z.$TK(F.edits.map(q=>new z.$SK(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),F.resultId):F}static j(F){return F&&!!F.data}static k(F){return F.data instanceof Uint32Array}static l(F){return F&&Array.isArray(F.edits)}static m(F){for(const q of F.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(F,q){if(!G.j(q)||!F||!F.tokens)return q;const J=F.tokens,K=J.length,oe=q.data,H=oe.length;let ce=0;const pe=Math.min(K,H);for(;ce<pe&&J[ce]===oe[ce];)ce++;if(ce===K&&ce===H)return new z.$TK([],q.resultId);let Oe=0;const Be=pe-ce;for(;Oe<Be&&J[K-Oe-1]===oe[H-Oe-1];)Oe++;return new z.$TK([{start:ce,deleteCount:K-ce-Oe,data:oe.subarray(ce,H-Oe)}],q.resultId)}o(F,q){if(G.j(F)){const J=this.e++;return this.d.set(J,new Fe(F.resultId,F.data)),(0,t.$z8)({id:J,type:"full",data:F.data})}if(G.l(F)){const J=this.e++;return G.j(q)?this.d.set(J,new Fe(q.resultId,q.data)):this.d.set(J,new Fe(F.resultId)),(0,t.$z8)({id:J,type:"delta",deltas:(F.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class Z{constructor(F,q){this.d=F,this.e=q}async provideDocumentRangeSemanticTokens(F,q,J){const K=this.d.getDocument(F),oe=await this.e.provideDocumentRangeSemanticTokens(K,I.Range.to(q),J);return oe?this.f(oe):null}f(F){return(0,t.$z8)({id:0,type:"full",data:F.data})}}class le{static supportsResolving(F){return typeof F.resolveCompletionItem=="function"}constructor(F,q,J,K,oe){this.f=F,this.g=q,this.h=J,this.j=K,this.k=oe,this.d=new a.$H$b("CompletionItem"),this.e=new Map}async provideCompletionItems(F,q,J,K){const oe=this.f.getDocument(F),H=I.Position.to(q),ce=oe.getWordRangeAtPosition(H)||new z.$BJ(H,H),pe=ce.with({end:H}),Oe=new m.$3c,Be=await this.h.provideCompletionItems(oe,H,K,I.CompletionContext.to(J));if(!Be||K.isCancellationRequested)return;const Ze=Array.isArray(Be)?new z.$8J(Be):Be,Ke=le.supportsResolving(this.h)?this.d.add(Ze.items):this.d.add([]),Qe=new o.$kb;this.e.set(Ke,Qe);const Ge=[],ct={x:Ke,b:Ge,a:{replace:I.Range.from(ce),insert:I.Range.from(pe)},c:Ze.isIncomplete||void 0,d:Oe.elapsed()};for(let xe=0;xe<Ze.items.length;xe++){const tt=Ze.items[xe],Ne=this.l(tt,[Ke,xe],pe,ce);Ge.push(Ne)}return ct}async resolveCompletionItem(F,q){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...F);if(!J)return;const K=this.l(J,F),oe=await this.h.resolveCompletionItem(J,q);if(!oe)return;const H=this.l(oe,F);return(K.h!==H.h||K.i!==H.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K.n!==H.n||K.o!==H.o||!(0,L.$Jm)(K.p,H.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,d:H.d,c:H.c,l:H.l,h:H.h,i:H.i,n:H.n,o:H.o,p:H.p}}releaseCompletionItems(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q,J,K){const oe=this.e.get(q[0]);if(!oe)throw Error("DisposableStore is missing...");const H=this.g.toInternal(F.command,oe),ce={x:q,a:F.label,b:F.kind!==void 0?I.CompletionItemKind.from(F.kind):void 0,m:F.tags&&F.tags.map(I.CompletionItemTag.from),c:F.detail,d:typeof F.documentation>"u"?void 0:I.MarkdownString.fromStrict(F.documentation),e:F.sortText!==F.label?F.sortText:void 0,f:F.filterText!==F.label?F.filterText:void 0,g:F.preselect||void 0,i:F.keepWhitespace?1:0,k:F.commitCharacters?.join(""),l:F.additionalTextEdits&&F.additionalTextEdits.map(I.TextEdit.from),n:H?.$ident,o:H?.id,p:H?.$ident?void 0:H?.arguments};F.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ce.h=F.textEdit.newText):typeof F.insertText=="string"?ce.h=F.insertText:F.insertText instanceof z.$KJ&&(ce.h=F.insertText.value,ce.i|=4);let pe;return F.textEdit?pe=F.textEdit.range:F.range&&(pe=F.range),z.$BJ.isRange(pe)?ce.j=I.Range.from(pe):pe&&(!J?.isEqual(pe.inserting)||!K?.isEqual(pe.replacing))&&(ce.j={insert:I.Range.from(pe.inserting),replace:I.Range.from(pe.replacing)}),ce}}class ne{async provideInlineCompletions(F,q,J,K){}disposeCompletions(F){}handleDidShowCompletionItem(F,q,J){}handlePartialAccept(F,q,J){}}class de extends ne{constructor(F,q,J,K){super(),this.f=F,this.g=q,this.h=J,this.j=K,this.d=new ue,this.e=(0,r.$vF)(this.f,"inlineCompletionsAdditions"),this.k={[P.InlineCompletionTriggerKind.Automatic]:z.InlineCompletionTriggerKind.Automatic,[P.InlineCompletionTriggerKind.Explicit]:z.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,r.$vF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(F,q,J,K){const oe=this.g.getDocument(F),H=I.Position.to(q),ce=await this.h.provideInlineCompletionItems(oe,H,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:I.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},K);if(!ce||K.isCancellationRequested)return;const pe=Array.isArray(ce)?ce:ce.items,Oe=this.e?Array.isArray(ce)?[]:ce.commands||[]:[],Be=this.e&&!Array.isArray(ce)?ce.suppressSuggestions:void 0,Ze=this.e&&!Array.isArray(ce)?ce.enableForwardStability:void 0;let Ke;return{pid:this.d.createReferenceId({dispose(){Ke?.dispose()},items:pe}),items:pe.map((Ge,ct)=>{let xe;Ge.command&&(Ke||(Ke=new o.$kb),xe=this.j.toInternal(Ge.command,Ke));const tt=Ge.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ge.filterText,range:Ge.range?I.Range.from(Ge.range):void 0,command:xe,idx:ct,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:Oe.map(Ge=>(Ke||(Ke=new o.$kb),this.j.toInternal(Ge,Ke))),suppressSuggestions:Be,enableForwardStability:Ze}}disposeCompletions(F){this.d.disposeReferenceId(F)?.dispose()}handleDidShowCompletionItem(F,q,J){const K=this.d.get(F)?.items[q];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K,J)}handlePartialAccept(F,q,J){const K=this.d.get(F)?.items[q];K&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(K,J)}}class ue{constructor(){this.d=new Map,this.e=1}createReferenceId(F){const q=this.e++;return this.d.set(q,F),q}disposeReferenceId(F){const q=this.d.get(F);return this.d.delete(F),q}get(F){return this.d.get(F)}}class T{constructor(F,q){this.e=F,this.f=q,this.d=new a.$H$b("SignatureHelp")}async provideSignatureHelp(F,q,J,K){const oe=this.e.getDocument(F),H=I.Position.to(q),ce=this.g(J),pe=await this.f.provideSignatureHelp(oe,H,K,ce);if(pe){const Oe=this.d.add([pe]);return{...I.SignatureHelp.from(pe),id:Oe}}}g(F){let q;if(F.activeSignatureHelp){const J=I.SignatureHelp.to(F.activeSignatureHelp),K=this.d.get(F.activeSignatureHelp.id,0);K?(q=K,q.activeSignature=J.activeSignature,q.activeParameter=J.activeParameter):q=J}return{...F,activeSignatureHelp:q}}releaseSignatureHelp(F){this.d.delete(F)}}class _{constructor(F,q,J,K,oe){this.f=F,this.g=q,this.h=J,this.j=K,this.k=oe,this.d=new a.$H$b("InlayHints"),this.e=new Map}async provideInlayHints(F,q,J){const K=this.f.getDocument(F),oe=I.Range.to(q),H=await this.h.provideInlayHints(K,oe,J);if(!Array.isArray(H)||H.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(J.isCancellationRequested)return;const ce=this.d.add(H);this.e.set(ce,new o.$kb);const pe={hints:[],cacheId:ce};for(let Oe=0;Oe<H.length;Oe++)this.l(H[Oe],oe)&&pe.hints.push(this.m(H[Oe],[ce,Oe]));return this.j.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),pe}async resolveInlayHint(F,q){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...F);if(!J)return;const K=await this.h.resolveInlayHint(J,q);if(K&&this.l(K))return this.m(K,F)}releaseHints(F){this.e.get(F)?.dispose(),this.e.delete(F),this.d.delete(F)}l(F,q){return F.label.length===0||Array.isArray(F.label)&&F.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",F),!1):!(q&&!q.contains(F.position))}m(F,q){const J=this.e.get(q[0]);if(!J)throw Error("DisposableStore is missing...");const K={label:"",cacheId:q,tooltip:I.MarkdownString.fromStrict(F.tooltip),position:I.Position.from(F.position),textEdits:F.textEdits&&F.textEdits.map(I.TextEdit.from),kind:F.kind&&I.InlayHintKind.from(F.kind),paddingLeft:F.paddingLeft,paddingRight:F.paddingRight};return typeof F.label=="string"?K.label=F.label:K.label=F.label.map(oe=>{const H={label:oe.value};return H.tooltip=I.MarkdownString.fromStrict(oe.tooltip),z.$LJ.isLocation(oe.location)&&(H.location=I.location.from(oe.location)),oe.command&&(H.command=this.g.toInternal(oe.command,J)),H}),K}}class ye{constructor(F,q){this.e=F,this.f=q,this.d=new a.$H$b("DocumentLink")}async provideLinks(F,q){const J=this.e.getDocument(F),K=await this.f.provideDocumentLinks(J,q);if(!(!Array.isArray(K)||K.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(ye.g).map(I.DocumentLink.from)};{const oe=this.d.add(K),H={links:[],cacheId:oe};for(let ce=0;ce<K.length;ce++){if(!ye.g(K[ce]))continue;const pe=I.DocumentLink.from(K[ce]);pe.cacheId=[oe,ce],H.links.push(pe)}return H}}}static g(F){return F.target&&F.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(F,q){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...F);if(!J)return;const K=await this.f.resolveDocumentLink(J,q);if(!(!K||!ye.g(K)))return I.DocumentLink.from(K)}releaseLinks(F){this.d.delete(F)}}class Ce{constructor(F,q){this.d=F,this.e=q}async provideColors(F,q){const J=this.d.getDocument(F),K=await this.e.provideDocumentColors(J,q);return Array.isArray(K)?K.map(H=>({color:I.Color.from(H.color),range:I.Range.from(H.range)})):[]}async provideColorPresentations(F,q,J){const K=this.d.getDocument(F),oe=I.Range.to(q.range),H=I.Color.to(q.color),ce=await this.e.provideColorPresentations(H,{document:K,range:oe},J);if(Array.isArray(ce))return ce.map(I.ColorPresentation.from)}}class Se{constructor(F,q){this.d=F,this.e=q}async provideFoldingRanges(F,q,J){const K=this.d.getDocument(F),oe=await this.e.provideFoldingRanges(K,q,J);if(Array.isArray(oe))return oe.map(I.FoldingRange.from)}}class Ee{constructor(F,q,J){this.d=F,this.e=q,this.f=J}async provideSelectionRanges(F,q,J){const K=this.d.getDocument(F),oe=q.map(I.Position.to),H=await this.e.provideSelectionRanges(K,oe,J);if(!(0,R.$pf)(H))return[];if(H.length!==oe.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ce=[];for(let pe=0;pe<oe.length;pe++){const Oe=[];ce.push(Oe);let Be=oe[pe],Ze=H[pe];for(;;){if(!Ze.range.contains(Be))throw new Error("INVALID selection range, must contain the previous range");if(Oe.push(I.SelectionRange.from(Ze)),!Ze.parent)break;Be=Ze.range,Ze=Ze.parent}}return ce}}class Ie{constructor(F,q){this.f=F,this.g=q,this.d=new i.$EL(""),this.e=new Map}async prepareSession(F,q,J){const K=this.f.getDocument(F),oe=I.Position.to(q),H=await this.g.prepareCallHierarchy(K,oe,J);if(!H)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(H)?H.map(pe=>this.h(ce,pe)):[this.h(ce,H)]}async provideCallsTo(F,q,J){const K=this.j(F,q);if(!K)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyIncomingCalls(K,J);if(oe)return oe.map(H=>({from:this.h(F,H.from),fromRanges:H.fromRanges.map(ce=>I.Range.from(ce))}))}async provideCallsFrom(F,q,J){const K=this.j(F,q);if(!K)throw new Error("missing call hierarchy item");const oe=await this.g.provideCallHierarchyOutgoingCalls(K,J);if(oe)return oe.map(H=>({to:this.h(F,H.to),fromRanges:H.fromRanges.map(ce=>I.Range.from(ce))}))}releaseSession(F){this.e.delete(F)}h(F,q){const J=this.e.get(F),K=I.CallHierarchyItem.from(q,F,J.size.toString(36));return J.set(K._itemId,q),K}j(F,q){return this.e.get(F)?.get(q)}}class se{constructor(F,q){this.f=F,this.g=q,this.d=new i.$EL(""),this.e=new Map}async prepareSession(F,q,J){const K=this.f.getDocument(F),oe=I.Position.to(q),H=await this.g.prepareTypeHierarchy(K,oe,J);if(!H)return;const ce=this.d.nextId();return this.e.set(ce,new Map),Array.isArray(H)?H.map(pe=>this.h(ce,pe)):[this.h(ce,H)]}async provideSupertypes(F,q,J){const K=this.j(F,q);if(!K)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySupertypes(K,J);if(oe)return oe.map(H=>this.h(F,H))}async provideSubtypes(F,q,J){const K=this.j(F,q);if(!K)throw new Error("missing type hierarchy item");const oe=await this.g.provideTypeHierarchySubtypes(K,J);if(oe)return oe.map(H=>this.h(F,H))}releaseSession(F){this.e.delete(F)}h(F,q){const J=this.e.get(F),K=I.TypeHierarchyItem.from(q,F,J.size.toString(36));return J.set(K._itemId,q),K}j(F,q){return this.e.get(F)?.get(q)}}class fe{constructor(F,q,J,K,oe){this.d=F,this.e=q,this.f=J,this.g=K,this.h=oe}async provideDocumentOnDropEdits(F,q,J,K,oe){const H=this.e.getDocument(q),ce=I.Position.to(J),pe=I.DataTransfer.toDataTransfer(K,async Be=>(await this.d.$resolveDocumentOnDropFileData(this.g,F,Be)).buffer),Oe=await this.f.provideDocumentDropEdits(H,ce,pe,oe);if(Oe)return{id:Oe.id?this.h.identifier.value+"."+Oe.id:this.h.identifier.value,label:Oe.label??(0,h.localize)(1,null,this.h.displayName||this.h.name),priority:Oe.priority??0,insertText:typeof Oe.insertText=="string"?Oe.insertText:{snippet:Oe.insertText.value},additionalEdit:Oe.additionalEdit?I.WorkspaceEdit.from(Oe.additionalEdit,void 0):void 0}}}class ee{constructor(F,q){this.adapter=F,this.extension=q}}class ie{static{this.d=0}constructor(F,q,J,K,oe,H,ce,pe){this.g=q,this.h=J,this.j=K,this.k=oe,this.l=H,this.m=ce,this.n=pe,this.f=new Map,this.e=F.getProxy(d.$xJ.MainThreadLanguageFeatures)}o(F,q){return I.DocumentSelector.from(F,this.g,q)}p(F){return new z.$zJ(()=>{this.f.delete(F),this.e.$unregister(F)})}q(){return ie.d++}async s(F,q,J,K,oe,H=!1){const ce=this.f.get(F);if(!ce||!(ce.adapter instanceof q))return K;const pe=Date.now();H||this.l.trace(`[${ce.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Oe=J(ce.adapter,ce.extension);return Promise.resolve(Oe).catch(Be=>{(0,S.$2)(Be)||(this.l.error(`[${ce.extension.identifier.value}] provider FAILED`),this.l.error(Be),this.n.onExtensionError(ce.extension.identifier,Be))}).finally(()=>{H||this.l.trace(`[${ce.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),y.CancellationToken.isCancellationToken(oe)?(0,C.$jg)(Oe,oe):Oe}t(F,q){const J=this.q();return this.f.set(J,new ee(F,q)),J}static u(F){return F.displayName||F.name}registerDocumentSymbolProvider(F,q,J,K){const oe=this.t(new n(this.h,J),F),H=K&&K.label||ie.u(F);return this.e.$registerDocumentSymbolProvider(oe,this.o(q,F),H),this.p(oe)}$provideDocumentSymbols(F,q,J){return this.s(F,n,K=>K.provideDocumentSymbols(w.URI.revive(q),J),void 0,J)}registerCodeLensProvider(F,q,J){const K=this.q(),oe=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new ee(new s(this.h,this.j.converter,J),F)),this.e.$registerCodeLensSupport(K,this.o(q,F),oe);let H=this.p(K);if(oe!==void 0){const ce=J.onDidChangeCodeLenses(pe=>this.e.$emitCodeLensEvent(oe));H=z.$zJ.from(H,ce)}return H}$provideCodeLenses(F,q,J){return this.s(F,s,K=>K.provideCodeLenses(w.URI.revive(q),J),void 0,J)}$resolveCodeLens(F,q,J){return this.s(F,s,K=>K.resolveCodeLens(q,J),void 0,void 0)}$releaseCodeLenses(F,q){this.s(F,s,J=>Promise.resolve(J.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(F,q,J){const K=this.t(new D(this.h,J),F);return this.e.$registerDefinitionSupport(K,this.o(q,F)),this.p(K)}$provideDefinition(F,q,J,K){return this.s(F,D,oe=>oe.provideDefinition(w.URI.revive(q),J,K),[],K)}registerDeclarationProvider(F,q,J){const K=this.t(new l(this.h,J),F);return this.e.$registerDeclarationSupport(K,this.o(q,F)),this.p(K)}$provideDeclaration(F,q,J,K){return this.s(F,l,oe=>oe.provideDeclaration(w.URI.revive(q),J,K),[],K)}registerImplementationProvider(F,q,J){const K=this.t(new g(this.h,J),F);return this.e.$registerImplementationSupport(K,this.o(q,F)),this.p(K)}$provideImplementation(F,q,J,K){return this.s(F,g,oe=>oe.provideImplementation(w.URI.revive(q),J,K),[],K)}registerTypeDefinitionProvider(F,q,J){const K=this.t(new v(this.h,J),F);return this.e.$registerTypeDefinitionSupport(K,this.o(q,F)),this.p(K)}$provideTypeDefinition(F,q,J,K){return this.s(F,v,oe=>oe.provideTypeDefinition(w.URI.revive(q),J,K),[],K)}registerHoverProvider(F,q,J,K){const oe=this.t(new u(this.h,J),F);return this.e.$registerHoverProvider(oe,this.o(q,F)),this.p(oe)}$provideHover(F,q,J,K){return this.s(F,u,oe=>oe.provideHover(w.URI.revive(q),J,K),void 0,K)}registerEvaluatableExpressionProvider(F,q,J,K){const oe=this.t(new f(this.h,J),F);return this.e.$registerEvaluatableExpressionProvider(oe,this.o(q,F)),this.p(oe)}$provideEvaluatableExpression(F,q,J,K){return this.s(F,f,oe=>oe.provideEvaluatableExpression(w.URI.revive(q),J,K),void 0,K)}registerInlineValuesProvider(F,q,J,K){const oe=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,H=this.t(new A(this.h,J),F);this.e.$registerInlineValuesProvider(H,this.o(q,F),oe);let ce=this.p(H);if(oe!==void 0){const pe=J.onDidChangeInlineValues(Oe=>this.e.$emitInlineValuesEvent(oe));ce=z.$zJ.from(ce,pe)}return ce}$provideInlineValues(F,q,J,K,oe){return this.s(F,A,H=>H.provideInlineValues(w.URI.revive(q),J,K,oe),void 0,oe)}registerDocumentHighlightProvider(F,q,J){const K=this.t(new W(this.h,J),F);return this.e.$registerDocumentHighlightProvider(K,this.o(q,F)),this.p(K)}$provideDocumentHighlights(F,q,J,K){return this.s(F,W,oe=>oe.provideDocumentHighlights(w.URI.revive(q),J,K),void 0,K)}registerLinkedEditingRangeProvider(F,q,J){const K=this.t(new B(this.h,J),F);return this.e.$registerLinkedEditingRangeProvider(K,this.o(q,F)),this.p(K)}$provideLinkedEditingRanges(F,q,J,K){return this.s(F,B,async oe=>{const H=await oe.provideLinkedEditingRanges(w.URI.revive(q),J,K);if(H)return{ranges:H.ranges,wordPattern:H.wordPattern?ie.w(H.wordPattern):void 0}},void 0,K)}registerReferenceProvider(F,q,J){const K=this.t(new V(this.h,J),F);return this.e.$registerReferenceSupport(K,this.o(q,F)),this.p(K)}$provideReferences(F,q,J,K,oe){return this.s(F,V,H=>H.provideReferences(w.URI.revive(q),J,K,oe),void 0,oe)}registerCodeActionProvider(F,q,J,K){const oe=new o.$kb,H=this.t(new U(this.h,this.j.converter,this.k,J,this.l,F,this.m),F);return this.e.$registerQuickFixSupport(H,this.o(q,F),{providedKinds:K?.providedCodeActionKinds?.map(ce=>ce.value),documentation:K?.documentation?.map(ce=>({kind:ce.kind.value,command:this.j.converter.toInternal(ce.command,oe)}))},ie.u(F),!!J.resolveCodeAction),oe.add(this.p(H)),oe}$provideCodeActions(F,q,J,K,oe){return this.s(F,U,H=>H.provideCodeActions(w.URI.revive(q),J,K,oe),void 0,oe)}$resolveCodeAction(F,q,J){return this.s(F,U,K=>K.resolveCodeAction(q,J),{},void 0)}$releaseCodeActions(F,q){this.s(F,U,J=>Promise.resolve(J.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(F,q,J){const K=this.t(new N(this.h,J),F);return this.e.$registerDocumentFormattingSupport(K,this.o(q,F),F.identifier,F.displayName||F.name),this.p(K)}$provideDocumentFormattingEdits(F,q,J,K){return this.s(F,N,oe=>oe.provideDocumentFormattingEdits(w.URI.revive(q),J,K),void 0,K)}registerDocumentRangeFormattingEditProvider(F,q,J){const K=typeof J.provideDocumentRangesFormattingEdits=="function";K&&(0,r.$wF)(F,"formatMultipleRanges");const oe=this.t(new ae(this.h,J),F);return this.e.$registerRangeFormattingSupport(oe,this.o(q,F),F.identifier,F.displayName||F.name,K),this.p(oe)}$provideDocumentRangeFormattingEdits(F,q,J,K,oe){return this.s(F,ae,H=>H.provideDocumentRangeFormattingEdits(w.URI.revive(q),J,K,oe),void 0,oe)}$provideDocumentRangesFormattingEdits(F,q,J,K,oe){return this.s(F,ae,H=>H.provideDocumentRangesFormattingEdits(w.URI.revive(q),J,K,oe),void 0,oe)}registerOnTypeFormattingEditProvider(F,q,J,K){const oe=this.t(new Q(this.h,J),F);return this.e.$registerOnTypeFormattingSupport(oe,this.o(q,F),K,F.identifier),this.p(oe)}$provideOnTypeFormattingEdits(F,q,J,K,oe,H){return this.s(F,Q,ce=>ce.provideOnTypeFormattingEdits(w.URI.revive(q),J,K,oe,H),void 0,H)}registerWorkspaceSymbolProvider(F,q){const J=this.t(new be(q,this.l),F);return this.e.$registerNavigateTypeSupport(J,typeof q.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(F,q,J){return this.s(F,be,K=>K.provideWorkspaceSymbols(q,J),{symbols:[]},J)}$resolveWorkspaceSymbol(F,q,J){return this.s(F,be,K=>K.resolveWorkspaceSymbol(q,J),void 0,void 0)}$releaseWorkspaceSymbols(F,q){this.s(F,be,J=>J.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(F,q,J){const K=this.t(new ke(this.h,J,this.l),F);return this.e.$registerRenameSupport(K,this.o(q,F),ke.supportsResolving(J)),this.p(K)}$provideRenameEdits(F,q,J,K,oe){return this.s(F,ke,H=>H.provideRenameEdits(w.URI.revive(q),J,K,oe),void 0,oe)}$resolveRenameLocation(F,q,J,K){return this.s(F,ke,oe=>oe.resolveRenameLocation(w.URI.revive(q),J,K),void 0,K)}registerDocumentSemanticTokensProvider(F,q,J,K){const oe=this.t(new G(this.h,J),F),H=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(oe,this.o(q,F),K,H);let ce=this.p(oe);if(H){const pe=J.onDidChangeSemanticTokens(Oe=>this.e.$emitDocumentSemanticTokensEvent(H));ce=z.$zJ.from(ce,pe)}return ce}$provideDocumentSemanticTokens(F,q,J,K){return this.s(F,G,oe=>oe.provideDocumentSemanticTokens(w.URI.revive(q),J,K),null,K)}$releaseDocumentSemanticTokens(F,q){this.s(F,G,J=>J.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(F,q,J,K){const oe=this.t(new Z(this.h,J),F);return this.e.$registerDocumentRangeSemanticTokensProvider(oe,this.o(q,F),K),this.p(oe)}$provideDocumentRangeSemanticTokens(F,q,J,K){return this.s(F,Z,oe=>oe.provideDocumentRangeSemanticTokens(w.URI.revive(q),J,K),null,K)}registerCompletionItemProvider(F,q,J,K){const oe=this.t(new le(this.h,this.j.converter,J,this.m,F),F);return this.e.$registerCompletionsProvider(oe,this.o(q,F),K,le.supportsResolving(J),F.identifier),this.p(oe)}$provideCompletionItems(F,q,J,K,oe){return this.s(F,le,H=>H.provideCompletionItems(w.URI.revive(q),J,K,oe),void 0,oe)}$resolveCompletionItem(F,q,J){return this.s(F,le,K=>K.resolveCompletionItem(q,J),void 0,J)}$releaseCompletionItems(F,q){this.s(F,le,J=>J.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(F,q,J,K){const oe=new de(F,this.h,J,this.j.converter),H=this.t(oe,F);return this.e.$registerInlineCompletionsSupport(H,this.o(q,F),oe.supportsHandleEvents,b.$Fl.toKey(F.identifier.value),K?.yieldTo?.map(ce=>b.$Fl.toKey(ce))||[]),this.p(H)}$provideInlineCompletions(F,q,J,K,oe){return this.s(F,ne,H=>H.provideInlineCompletions(w.URI.revive(q),J,K,oe),void 0,oe)}$handleInlineCompletionDidShow(F,q,J,K){this.s(F,ne,async oe=>{oe.handleDidShowCompletionItem(q,J,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(F,q,J,K){this.s(F,ne,async oe=>{oe.handlePartialAccept(q,J,K)},void 0,void 0)}$freeInlineCompletionsList(F,q){this.s(F,ne,async J=>{J.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(F,q,J,K){const oe=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,H=this.t(new T(this.h,J),F);return this.e.$registerSignatureHelpProvider(H,this.o(q,F),oe),this.p(H)}$provideSignatureHelp(F,q,J,K,oe){return this.s(F,T,H=>H.provideSignatureHelp(w.URI.revive(q),J,K,oe),void 0,oe)}$releaseSignatureHelp(F,q){this.s(F,T,J=>J.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(F,q,J){const K=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,oe=this.t(new _(this.h,this.j.converter,J,this.l,F),F);this.e.$registerInlayHintsProvider(oe,this.o(q,F),typeof J.resolveInlayHint=="function",K,ie.u(F));let H=this.p(oe);if(K!==void 0){const ce=J.onDidChangeInlayHints(pe=>this.e.$emitInlayHintsEvent(K));H=z.$zJ.from(H,ce)}return H}$provideInlayHints(F,q,J,K){return this.s(F,_,oe=>oe.provideInlayHints(w.URI.revive(q),J,K),void 0,K)}$resolveInlayHint(F,q,J){return this.s(F,_,K=>K.resolveInlayHint(q,J),void 0,J)}$releaseInlayHints(F,q){this.s(F,_,J=>J.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(F,q,J){const K=this.t(new ye(this.h,J),F);return this.e.$registerDocumentLinkProvider(K,this.o(q,F),typeof J.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(F,q,J){return this.s(F,ye,K=>K.provideLinks(w.URI.revive(q),J),void 0,J,q.scheme==="output")}$resolveDocumentLink(F,q,J){return this.s(F,ye,K=>K.resolveLink(q,J),void 0,void 0,!0)}$releaseDocumentLinks(F,q){this.s(F,ye,J=>J.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(F,q,J){const K=this.t(new Ce(this.h,J),F);return this.e.$registerDocumentColorProvider(K,this.o(q,F)),this.p(K)}$provideDocumentColors(F,q,J){return this.s(F,Ce,K=>K.provideColors(w.URI.revive(q),J),[],J)}$provideColorPresentations(F,q,J,K){return this.s(F,Ce,oe=>oe.provideColorPresentations(w.URI.revive(q),J,K),void 0,K)}registerFoldingRangeProvider(F,q,J){const K=this.q(),oe=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new ee(new Se(this.h,J),F)),this.e.$registerFoldingRangeProvider(K,this.o(q,F),F.identifier,oe);let H=this.p(K);if(oe!==void 0){const ce=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(oe));H=z.$zJ.from(H,ce)}return H}$provideFoldingRanges(F,q,J,K){return this.s(F,Se,oe=>oe.provideFoldingRanges(w.URI.revive(q),J,K),void 0,K)}registerSelectionRangeProvider(F,q,J){const K=this.t(new Ee(this.h,J,this.l),F);return this.e.$registerSelectionRangeProvider(K,this.o(q,F)),this.p(K)}$provideSelectionRanges(F,q,J,K){return this.s(F,Ee,oe=>oe.provideSelectionRanges(w.URI.revive(q),J,K),[],K)}registerCallHierarchyProvider(F,q,J){const K=this.t(new Ie(this.h,J),F);return this.e.$registerCallHierarchyProvider(K,this.o(q,F)),this.p(K)}$prepareCallHierarchy(F,q,J,K){return this.s(F,Ie,oe=>Promise.resolve(oe.prepareSession(w.URI.revive(q),J,K)),void 0,K)}$provideCallHierarchyIncomingCalls(F,q,J,K){return this.s(F,Ie,oe=>oe.provideCallsTo(q,J,K),void 0,K)}$provideCallHierarchyOutgoingCalls(F,q,J,K){return this.s(F,Ie,oe=>oe.provideCallsFrom(q,J,K),void 0,K)}$releaseCallHierarchy(F,q){this.s(F,Ie,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(F,q,J){const K=this.t(new se(this.h,J),F);return this.e.$registerTypeHierarchyProvider(K,this.o(q,F)),this.p(K)}$prepareTypeHierarchy(F,q,J,K){return this.s(F,se,oe=>Promise.resolve(oe.prepareSession(w.URI.revive(q),J,K)),void 0,K)}$provideTypeHierarchySupertypes(F,q,J,K){return this.s(F,se,oe=>oe.provideSupertypes(q,J,K),void 0,K)}$provideTypeHierarchySubtypes(F,q,J,K){return this.s(F,se,oe=>oe.provideSubtypes(q,J,K),void 0,K)}$releaseTypeHierarchy(F,q){this.s(F,se,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(F,q,J,K){const oe=this.q();return this.f.set(oe,new ee(new fe(this.e,this.h,J,oe,F),F)),this.e.$registerDocumentOnDropEditProvider(oe,this.o(q,F),(0,r.$vF)(F,"dropMetadata")?K:void 0),this.p(oe)}$provideDocumentOnDropEdits(F,q,J,K,oe,H){return this.s(F,fe,ce=>Promise.resolve(ce.provideDocumentOnDropEdits(q,w.URI.revive(J),K,oe,H)),void 0,void 0)}registerDocumentPasteEditProvider(F,q,J,K){const oe=this.q();return this.f.set(oe,new ee(new O(this.e,this.h,J,oe,F),F)),this.e.$registerPasteEditProvider(oe,this.o(q,F),{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this.p(oe)}$prepareDocumentPaste(F,q,J,K,oe){return this.s(F,O,H=>H.prepareDocumentPaste(w.URI.revive(q),J,K,oe),void 0,oe)}$providePasteEdits(F,q,J,K,oe,H){return this.s(F,O,ce=>ce.providePasteEdits(q,w.URI.revive(J),K,oe,H),void 0,H)}static w(F){return{pattern:F.source,flags:(0,k.$yd)(F)}}static y(F){return{decreaseIndentPattern:ie.w(F.decreaseIndentPattern),increaseIndentPattern:ie.w(F.increaseIndentPattern),indentNextLinePattern:F.indentNextLinePattern?ie.w(F.indentNextLinePattern):void 0,unIndentedLinePattern:F.unIndentedLinePattern?ie.w(F.unIndentedLinePattern):void 0}}static z(F){return{beforeText:ie.w(F.beforeText),afterText:F.afterText?ie.w(F.afterText):void 0,previousLineText:F.previousLineText?ie.w(F.previousLineText):void 0,action:F.action}}static B(F){return F.map(ie.z)}setLanguageConfiguration(F,q,J){const{wordPattern:K}=J;if(K&&(0,k.$wd)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(q,K):this.h.setWordDefinitionFor(q,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",F,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",F,"Do not use."),J.autoClosingPairs&&(0,r.$wF)(F,"languageConfigurationAutoClosingPairs");const oe=this.q(),H={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?ie.w(J.wordPattern):void 0,indentationRules:J.indentationRules?ie.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?ie.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs};return this.e.$setLanguageConfiguration(oe,q,H),this.p(oe)}$setWordDefinitions(F){for(const q of F)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.$Q$b=ie}),define(Ae[235],Re([1,0,4,8,7,29,16,6]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=void 0;class k{constructor(R,E,c,y){this.c=E,this.d=c,this.e=y,this.b=[],this.f=0,this.g=new Set,this.a=R.getProxy(w.$xJ.MainThreadLanguages)}$acceptLanguageIds(R){this.b=R}async getLanguages(){return this.b.slice(0)}async changeLanguage(R,E){await this.a.$changeLanguage(R,E);const c=this.c.getDocumentData(R);if(!c)throw new Error(`document '${R.toString()}' NOT found`);return c.document}async tokenAtPosition(R,E){const c=R.version,y=L.Position.from(E),b=await this.a.$tokensAtPosition(R.uri,y),o={type:I.StandardTokenType.Other,range:R.getWordRangeAtPosition(E)??new I.$BJ(E.line,E.character,E.line,E.character)};if(!b)return o;const t={range:L.Range.to(b.range),type:L.TokenType.to(b.type)};return!t.range.contains(E)||c!==R.version?o:t}createLanguageStatusItem(R,E,c){const y=this.f++,b=this.a,o=this.g,t=`${R.identifier.value}/${E}`;if(o.has(t))throw new Error(`LanguageStatusItem with id '${E}' ALREADY exists`);o.add(t);const i={selector:c,id:E,name:R.displayName??R.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let a;const m=new d.$kb,S=()=>{if(a?.dispose(),!o.has(t)){console.warn(`LanguageStatusItem (${E}) from ${R.identifier.value} has been disposed and CANNOT be updated anymore`);return}a=(0,P.$vg)(()=>{m.clear(),this.a.$setLanguageStatus(y,{id:t,name:i.name??R.displayName??R.name,source:R.displayName??R.name,selector:L.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===I.LanguageStatusSeverity.Error?z.default.Error:i.severity===I.LanguageStatusSeverity.Warning?z.default.Warning:z.default.Info,command:i.command&&this.d.toInternal(i.command,m),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},C={dispose(){m.dispose(),a?.dispose(),b.$removeLanguageStatus(y),o.delete(t)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,S()},get selector(){return i.selector},set selector(r){i.selector=r,S()},get text(){return i.text},set text(r){i.text=r,S()},get detail(){return i.detail},set detail(r){i.detail=r,S()},get severity(){return i.severity},set severity(r){i.severity=r,S()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,S()},get command(){return i.command},set command(r){i.command=r,S()},get busy(){return i.busy},set busy(r){i.busy=r,S()}};return S(),C}}e.$y_b=k}),define(Ae[81],Re([1,0,22,15,2,3,14,4,27,17]),function($e,e,w,L,I,z,P,d,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o_b=e.$n_b=void 0;let R=class{constructor(c,y,b){this.f=b,this.d=new Map,this.a=y.getProxy(d.$xJ.MainThreadLocalization),this.b=c.environment.appLanguage,this.c=this.b===w.$f}getMessage(c,y){const{message:b,args:o,comment:t}=y;if(this.c)return(0,L.$ld)(b,o??{});let i=b;t&&t.length>0&&(i+=`/${Array.isArray(t)?t.join(""):t}`);const a=this.d.get(c)?.contents[i];return a||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${i}`),(0,L.$ld)(a??b,o??{})}getBundle(c){return this.d.get(c)?.contents}getBundleUri(c){return this.d.get(c)?.uri}async initializeLocalizedMessages(c){if(this.c||!c.l10n&&!c.isBuiltin||this.d.has(c.identifier.value))return;let y;const b=await this.g(c);if(!b){this.f.error(`No bundle location found for extension ${c.identifier.value}`);return}try{const o=await this.a.$fetchBundleContents(b),t=JSON.parse(o);y=c.isBuiltin?t.contents?.bundle:t}catch(o){this.f.error(`Failed to load translations for ${c.identifier.value} from ${b}: ${o.message}`);return}y&&this.d.set(c.identifier.value,{contents:y,uri:b})}async g(c){if(c.isBuiltin){const y=await this.a.$fetchBuiltInBundleUri(c.identifier.value,this.b);return I.URI.revive(y)}return c.l10n?I.URI.joinPath(c.extensionLocation,c.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$n_b=R,e.$n_b=R=qe([Ve(0,k.$PL),Ve(1,$.$zL),Ve(2,P.$Pi)],R),e.$o_b=(0,z.$nh)("IExtHostLocalizationService")}),define(Ae[236],Re([1,0,14,4,27,17,2,70]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kac=void 0;let k=class extends w.$1i{constructor(E,c){super(c.logLevel,c.logsLocation,c.loggers.map(y=>(0,d.$Wg)(y))),this.n=E.getProxy(L.$xJ.MainThreadLogger)}$setLogLevel(E,c){c?this.setLogLevel(P.URI.revive(c),E):this.setLogLevel(E)}setVisibility(E,c){super.setVisibility(E,c),this.n.$setVisibility(E,c)}m(E,c,y){return new $(this.n,E,c,y)}};e.$Kac=k,e.$Kac=k=qe([Ve(0,z.$zL),Ve(1,I.$PL)],k);class $ extends w.$Vi{constructor(E,c,y,b){super(b?.logLevel==="always"),this.m=E,this.n=c,this.k=!1,this.l=[],this.setLevel(y),this.m.$createLogger(c,b).then(()=>{this.r(this.l),this.k=!0})}g(E,c){const y=[[E,c]];this.k?this.r(y):this.l.push(...y)}r(E){this.m.$log(this.n,E)}flush(){this.m.$flush(this.n)}}}),define(Ae[82],Re([1,0,4,3,6,17,25]),function($e,e,w,L,I,z,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=e.$p_b=void 0,e.$p_b=(0,L.$nh)("IExtHostManagedSockets");let d=class{constructor(E){this.b=0,this.c=null,this.d=new Map,this.a=E.getProxy(w.$xJ.MainThreadManagedSockets)}setFactory(E,c){for(const y of this.d.values())y.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new k(E,c),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(E){if(!this.c||this.c.socketFactoryId!==E)throw new Error(`No socket factory with id ${E}`);const c=++this.b,y=await this.c.makeConnection(),b=new I.$kb;return this.d.set(c,new $(c,y,b)),b.add((0,I.$jb)(()=>this.d.delete(c))),b.add(y.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(c),b.dispose()})),b.add(y.onDidClose(o=>{this.a.$onDidManagedSocketClose(c,o?.stack??o?.message),b.dispose()})),b.add(y.onDidReceiveMessage(o=>this.a.$onDidManagedSocketHaveData(c,P.$Jb.wrap(o)))),c}$remoteSocketWrite(E,c){this.d.get(E)?.actual.send(c.buffer)}$remoteSocketEnd(E){const c=this.d.get(E);c&&(c.actual.end(),c.dispose())}async $remoteSocketDrain(E){await this.d.get(E)?.actual.drain?.()}};e.$q_b=d,e.$q_b=d=qe([Ve(0,z.$zL)],d);class k{constructor(E,c){this.socketFactoryId=E,this.makeConnection=c}}class $ extends I.$lb{constructor(E,c,y){super(),this.socketId=E,this.actual=c,this.B(y)}}}),define(Ae[237],Re([1,0,4,14,26]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z_b=void 0;function z(d){return d&&d.title}let P=class{constructor(k,$){this.b=$,this.a=k.getProxy(w.$xJ.MainThreadMessageService)}showMessage(k,$,R,E,c){const y={source:{identifier:k.identifier,label:k.displayName||k.name}};let b;typeof E=="string"||z(E)?b=[E,...c]:(y.modal=E?.modal,y.useCustom=E?.useCustom,y.detail=E?.detail,b=c),y.useCustom&&(0,I.$wF)(k,"resolvers");const o=[];for(let t=0;t<b.length;t++){const i=b[t];if(typeof i=="string")o.push({title:i,handle:t,isCloseAffordance:!1});else if(typeof i=="object"){const{title:a,isCloseAffordance:m}=i;o.push({title:a,isCloseAffordance:!!m,handle:t})}else this.b.warn("Invalid message item:",i)}return this.a.$showMessage($,R,y,o).then(t=>{if(typeof t=="number")return b[t]})}};e.$z_b=P,e.$z_b=P=qe([Ve(1,L.$Pi)],P)}),define(Ae[238],Re([1,0,151,25,5,6,28,15,12,2,38,55,4,32,8,7,46,205,103,11,24,13]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hac=void 0;class r{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(n=>n.apiEditor)}constructor(n,s,p,D,l){this.q=p,this.r=D,this.s=l,this.f=new Map,this.g=new P.$li,this.h=new Map,this.j=new I.$7c({onListenerError:m.$Z}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$7c({onListenerError:m.$Z}),this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$7c({onListenerError:m.$Z}),this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$7c({onListenerError:m.$Z}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new E.$H$b("NotebookCellStatusBarCache"),this.u=0,this.w=new Map,this.b=n.getProxy(c.$xJ.MainThreadNotebook),this.c=n.getProxy(c.$xJ.MainThreadNotebookDocuments),this.d=n.getProxy(c.$xJ.MainThreadNotebookEditors),this.i=s.converter,s.registerArgumentProcessor({processArgument:g=>{if(g&&g.$mid===13){const v=g.notebookEditor?.notebookUri,u=g.cell.handle,A=this.g.get(v)?.getCell(u);if(A)return A.apiCell}if(g&&g.$mid===14){const v=g.uri,u=this.g.get(v);if(u)return u.apiNotebook}return g}}),r.A(s)}getEditorById(n){const s=this.h.get(n);if(!s)throw new Error(`unknown text editor: ${n}. known editors: ${[...this.h.keys()]} `);return s}getIdByEditor(n){for(const[s,p]of this.h)if(p.apiEditor===n)return s}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(n,s){const p=this.g.get(n);if(!p&&!s)throw new Error(`NO notebook document for '${n}'`);return p}static t(n,s){if(!s)return;const p=s.filenamePattern.map(D=>b.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(s.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${s.filenamePattern}`);return}return{extension:n.identifier,providerDisplayName:n.displayName||n.name,displayName:s.displayName,filenamePattern:p,exclusive:s.exclusive||!1}}registerNotebookCellStatusBarItemProvider(n,s,p){const D=r.a++,l=typeof p.onDidChangeCellStatusBarItems=="function"?r.a++:void 0;this.f.set(D,p),this.b.$registerNotebookCellStatusBarItemProvider(D,l,s);let g;return l!==void 0&&(g=p.onDidChangeCellStatusBarItems(v=>this.b.$emitCellStatusBarEvent(l))),new o.$zJ(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,l),g?.dispose()})}async createNotebookDocument(n){const s=await this.c.$tryCreateNotebook({viewType:n.viewType,content:n.content&&b.NotebookData.from(n.content)});return $.URI.revive(s)}async openNotebookDocument(n){const s=this.g.get(n);if(s)return s.apiNotebook;const p=await this.c.$tryOpenNotebook(n),D=this.g.get($.URI.revive(p));return(0,k.$te)(D?.apiNotebook)}async showNotebookDocument(n,s){$.URI.isUri(n)&&(n=await this.openNotebookDocument(n));let p;typeof s=="object"?p={position:b.ViewColumn.from(s.viewColumn),preserveFocus:s.preserveFocus,selections:s.selections&&s.selections.map(b.NotebookRange.from),pinned:typeof s.preview=="boolean"?!s.preview:void 0}:p={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(n.uri,n.notebookType,p),l=D&&this.h.get(D)?.apiEditor;if(l)return l;throw D?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(n,s,p,D){const l=this.f.get(n),g=$.URI.revive(s),v=this.g.get(g);if(!v||!l)return;const u=v.getCellFromIndex(p);if(!u)return;const f=await l.provideCellStatusBarItems(u.apiCell,D);if(!f)return;const A=new z.$kb,W=this.p.add([A]),V=(Array.isArray(f)?f:[f]).map(U=>b.NotebookStatusBarItem.from(U,this.i,A));return{cacheId:W,items:V}}$releaseNotebookCellStatusBarItems(n){this.p.delete(n)}registerNotebookSerializer(n,s,p,D,l){if((0,d.$jd)(s))throw new Error("viewType cannot be empty or just whitespace");const g=this.u++;return this.w.set(g,{viewType:s,serializer:p,options:D}),this.b.$registerNotebookSerializer(g,{id:n.identifier,location:n.extensionLocation},s,b.NotebookDocumentContentOptions.from(D),r.t(n,l)),(0,z.$jb)(()=>{this.b.$unregisterNotebookSerializer(g)})}async $dataToNotebook(n,s,p){const D=this.w.get(n);if(!D)throw new Error("NO serializer found");const l=await D.serializer.deserializeNotebook(s.buffer,p);return new t.$Wz(b.NotebookData.from(l))}async $notebookToData(n,s,p){const D=this.w.get(n);if(!D)throw new Error("NO serializer found");const l=await D.serializer.serializeNotebook(b.NotebookData.to(s.value),p);return L.$Jb.wrap(l)}async $saveNotebook(n,s,p,D,l){const g=$.URI.revive(s),v=this.w.get(n);if(!v)throw new Error("NO serializer found");const u=this.g.get(g);if(!u)throw new Error("Document NOT found");if(u.versionId!==p)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(g.scheme))throw new R.$$j((0,w.localize)(0,null,this.y(g)),6);await this.x(g,D);const f={metadata:(0,S.$Nm)(u.apiNotebook.metadata,U=>!(v.options?.transientDocumentMetadata??{})[U]),cells:[]};for(const U of u.apiNotebook.getCells()){const O=new o.$YK(U.kind,U.document.getText(),U.document.languageId,U.mime,v.options?.transientOutputs?[]:[...U.outputs],U.metadata,U.executionSummary);O.metadata=(0,S.$Nm)(U.metadata,N=>!(v.options?.transientCellMetadata??{})[N]),f.cells.push(O)}const A=await v.serializer.serializeNotebook(f,l);await this.s.value.writeFile(g,A);const W=this.s.getFileSystemProviderExtUri(g.scheme),B=await this.s.value.stat(g);return{name:W.basename(g),isFile:(B.type&R.FileType.File)!==0,isDirectory:(B.type&R.FileType.Directory)!==0,isSymbolicLink:(B.type&R.FileType.SymbolicLink)!==0,mtime:B.mtime,ctime:B.ctime,size:B.size,readonly:!!((B.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(g.scheme),locked:!!((B.permissions??0)&R.FilePermission.Locked),etag:R.$jk({mtime:B.mtime,size:B.size}),children:void 0}}async x(n,s){const p=await this.s.value.stat(n);if(typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==R.$ik&&typeof p.mtime=="number"&&typeof p.size=="number"&&s.mtime<p.mtime&&s.etag!==R.$jk({mtime:s.mtime,size:p.size}))throw new R.$$j((0,w.localize)(1,null),3,s)}y(n){return n.scheme===C.Schemas.file?n.fsPath:n.toString()}z(n,s,p){if(this.h.has(s))throw new Error(`editor with id ALREADY EXSIST: ${s}`);const D=new a.$gac(s,this.d,n,p.visibleRanges.map(b.NotebookRange.to),p.selections.map(b.NotebookRange.to),typeof p.viewColumn=="number"?b.ViewColumn.to(p.viewColumn):void 0);this.h.set(s,D)}$acceptDocumentAndEditorsDelta(n){if(n.value.removedDocuments)for(const p of n.value.removedDocuments){const D=$.URI.revive(p),l=this.g.get(D);l&&(l.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:l.apiNotebook.getCells().map(g=>g.document.uri)}),this.n.fire(l.apiNotebook));for(const g of this.h.values())g.notebookData.uri.toString()===D.toString()&&this.h.delete(g.id)}if(n.value.addedDocuments){const p=[];for(const D of n.value.addedDocuments){const l=$.URI.revive(D.uri);if(this.g.has(l))throw new Error(`adding EXISTING notebook ${l} `);const g=new i.$fac(this.c,this.q,this.r,l,D);p.push(...D.cells.map(v=>i.$eac.asModelAddData(g.apiNotebook,v))),this.g.get(l)?.dispose(),this.g.set(l,g),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(g.apiNotebook)}}if(n.value.addedEditors)for(const p of n.value.addedEditors){if(this.h.has(p.id))return;const D=$.URI.revive(p.documentUri),l=this.g.get(D);l&&this.z(l,p.id,p)}const s=[];if(n.value.removedEditors)for(const p of n.value.removedEditors){const D=this.h.get(p);D&&(this.h.delete(p),this.k?.id===D.id&&(this.k=void 0),s.push(D))}if(n.value.visibleEditors){this.l=n.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const p=new Set;this.l.forEach(D=>p.add(D.id));for(const D of this.h.values()){const l=p.has(D.id);D._acceptVisibility(l)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}n.value.newActiveEditor===null?this.k=void 0:n.value.newActiveEditor&&(this.h.get(n.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${n.value.newActiveEditor}`),this.k=this.h.get(n.value.newActiveEditor)),n.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static A(n){const s=y.$XL.String.with("notebookType","A notebook type"),p=new y.$ZL("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[s,new y.$XL("data","Bytes to convert to data",l=>l instanceof Uint8Array,l=>L.$Jb.wrap(l))],new y.$YL("Notebook Data",l=>b.NotebookData.to(l.value))),D=new y.$ZL("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[s,new y.$XL("NotebookData","Notebook data to convert to bytes",l=>!0,l=>new t.$Wz(b.NotebookData.from(l)))],new y.$YL("Bytes",l=>l.buffer));n.registerApiCommand(p),n.registerApiCommand(D)}}e.$hac=r}),define(Ae[239],Re([1,0,18,16,20,5,6,28,2,21,14,55,4,32,8,7,77,198,26,46]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wac=e.$vac=void 0;let S=class{constructor(l,g,v,u,f){this.m=g,this.n=v,this.o=u,this.q=f,this.b=new d.$li,this.c=new d.$li,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new E.$H$b("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new z.$7c,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=l.getProxy(c.$xJ.MainThreadNotebookKernels);const A=new y.$ZL("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new y.$XL("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const B=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:B}}else if(W&&"notebookEditor"in W){const B=this.n.getIdByEditor(W.notebookEditor);if(B===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:B}}return W})],y.$YL.Void);this.o.registerApiCommand(A)}createNotebookController(l,g,v,u,f,A){for(const ne of this.j.values())if(ne.controller.id===g&&$.$Fl.equals(l.identifier,ne.extensionId))throw new Error(`notebook controller with id '${g}' ALREADY exist`);const W=this.k++,B=this;this.q.trace(`NotebookController[${W}], CREATED by ${l.identifier.value}, ${g}`);const V=()=>console.warn(`NO execute handler from notebook controller '${Q.id}' of extension: '${l.identifier}'`);let U=!1;const O=new P.$kb,N=new z.$7c,ae=new z.$7c,Q={id:p(l.identifier,g),notebookType:v,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:u||l.identifier.value,preloads:A?A.map(b.NotebookRendererScript.from):[]};let be=f??V,ke;this.a.$addKernel(W,Q).catch(ne=>{console.log(ne),U=!0});let Fe=0;const G=()=>{if(U)return;const ne=++Fe;Promise.resolve().then(()=>{ne===Fe&&this.a.$updateKernel(W,Q)})},Z=new d.$li,le={get id(){return g},get notebookType(){return Q.notebookType},onDidChangeSelectedNotebooks:N.event,get label(){return Q.label},set label(ne){Q.label=ne??l.displayName??l.name,G()},get detail(){return Q.detail??""},set detail(ne){Q.detail=ne,G()},get description(){return Q.description??""},set description(ne){Q.description=ne,G()},get supportedLanguages(){return Q.supportedLanguages},set supportedLanguages(ne){Q.supportedLanguages=ne,G()},get supportsExecutionOrder(){return Q.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){Q.supportsExecutionOrder=ne,G()},get rendererScripts(){return Q.preloads?Q.preloads.map(b.NotebookRendererScript.to):[]},get executeHandler(){return be},set executeHandler(ne){be=ne??V},get interruptHandler(){return ke},set interruptHandler(ne){ke=ne,Q.supportsInterrupt=!!ne,G()},createNotebookCellExecution(ne){if(U)throw new Error("notebook controller is DISPOSED");if(!Z.has(ne.notebook.uri))throw B.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return B._createNotebookCellExecution(ne,p(l.identifier,this.id))},createNotebookExecution(ne){if((0,a.$wF)(l,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!Z.has(ne.uri))throw B.q.trace(`NotebookController[${W}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Z.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return B._createNotebookExecution(ne,p(l.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${W}], DISPOSED`),U=!0,this.j.delete(W),O.dispose(),N.dispose(),ae.dispose(),this.a.$removeKernel(W))},updateNotebookAffinity(ne,de){de===o.NotebookControllerAffinity2.Hidden&&(0,a.$wF)(l,"notebookControllerAffinityHidden"),B.a.$updateNotebookPriority(W,ne.uri,de)},onDidReceiveMessage:ae.event,postMessage(ne,de){return(0,a.$wF)(l,"notebookMessaging"),B.a.$postMessage(W,de&&B.n.getIdByEditor(de),ne)},asWebviewUri(ne){return(0,a.$wF)(l,"notebookMessaging"),(0,t.$dnb)(ne,B.m.remote)}};return this.j.set(W,{extensionId:l.identifier,controller:le,onDidReceiveMessage:ae,onDidChangeSelection:N,associatedNotebooks:Z}),le}getIdByController(l){for(const[g,v]of this.j)if(v.controller===l)return p(v.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,g){const v=this.f++,u=this;this.q.trace(`NotebookControllerDetectionTask[${v}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(v,g);const f={dispose:()=>{this.e.delete(v),u.a.$removeKernelDetectionTask(v)}};return this.e.set(v,f),f}registerKernelSourceActionProvider(l,g,v){const u=this.h++,f=typeof v.onDidChangeNotebookKernelSourceActions=="function"?u:void 0,A=this;this.g.set(u,v),this.q.trace(`NotebookKernelSourceActionProvider[${u}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(u,u,g);let W;return f!==void 0&&(W=v.onDidChangeNotebookKernelSourceActions(B=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.g.delete(u),A.a.$removeKernelSourceActionProvider(u,u),W?.dispose()}}}async $provideKernelSourceActions(l,g){const v=this.g.get(l);if(v){const u=new P.$kb;return this.i.add([u]),(await v.provideNotebookKernelSourceActions(g)??[]).map(A=>b.NotebookKernelSourceAction.from(A,this.o.converter,u))}return[]}$acceptNotebookAssociation(l,g,v){const u=this.j.get(l);if(u){const f=this.n.getNotebookDocument(k.URI.revive(g));v?u.associatedNotebooks.set(f.uri,!0):u.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,f.uri.toString(),v),u.onDidChangeSelection.fire({selected:v,notebook:f.apiNotebook})}}async $executeCells(l,g,v){const u=this.j.get(l);if(!u)return;const f=this.n.getNotebookDocument(k.URI.revive(g)),A=[];for(const W of v){const B=f.getCell(W);B&&A.push(B.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,f.uri.toString(),A.length),await u.controller.executeHandler.call(u.controller,A,f.apiNotebook,u.controller)}catch(W){this.q.error(`NotebookController[${l}] execute cells FAILED`,W),console.error(W)}}async $cancelCells(l,g,v){const u=this.j.get(l);if(!u)return;const f=this.n.getNotebookDocument(k.URI.revive(g));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,f.apiNotebook);else for(const A of v){const W=f.getCell(A);W&&this.b.get(W.uri)?.cancel()}if(u.controller.interruptHandler){const A=this.c.get(f.uri);v.length&&Array.isArray(A)&&A.length&&A.forEach(W=>W.dispose())}}$acceptKernelMessageFromRenderer(l,g,v){const u=this.j.get(l);if(!u)return;const f=this.n.getEditorById(g);u.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:v}))}$cellExecutionChanged(l,g,v){const f=this.n.getNotebookDocument(k.URI.revive(l)).getCell(g);if(f){const A=v?b.NotebookCellExecutionState.to(v):o.NotebookCellExecutionState.Idle;A!==void 0&&this.l.fire({cell:f.apiCell,state:A})}}_createNotebookCellExecution(l,g){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const u=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!u)throw new Error("invalid cell");if(this.b.has(u.uri))throw new Error(`duplicate execution for ${u.uri}`);const f=new r(g,u,this.a);this.b.set(u.uri,f);const A=f.onDidChangeState(()=>{f.state===C.Resolved&&(f.dispose(),A.dispose(),this.b.delete(u.uri))});return f.asApiObject()}_createNotebookExecution(l,g){const v=this.n.getNotebookDocument(l.uri),u=l.getCells().find(W=>{const B=v.getCellFromApiCell(W);return B&&this.b.has(B.uri)});if(u)throw new Error(`duplicate cell execution for ${u.document.uri}`);if(this.c.has(v.uri))throw new Error(`duplicate notebook execution for ${v.uri}`);const f=new n(g,v,this.a),A=f.onDidChangeState(()=>{f.state===h.Resolved&&(f.dispose(),A.dispose(),this.c.delete(v.uri))});return this.c.set(v.uri,[f,A]),f.asApiObject()}};e.$vac=S,e.$vac=S=qe([Ve(4,R.$Pi)],S);var C;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(C||(C={}));class r extends P.$lb{static{this.a=0}get state(){return this.f}constructor(l,g,v){super(),this.j=g,this.k=v,this.b=r.a++,this.c=new z.$7c,this.onDidChangeState=this.c.event,this.f=C.Init,this.g=this.B(new I.$dd),this.h=new s(10,u=>this.m(u)),this.i=g.internalMetadata.executionOrder,this.k.$createExecution(this.b,l,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(l){await this.h.addItem(l)}async m(l){const g=Array.isArray(l)?l:[l];return this.k.$updateExecution(this.b,new m.$Wz(g))}n(){if(this.f===C.Init)throw new Error("Must call start before modifying cell output");if(this.f===C.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(l){let g=this.j;if(l&&(g=this.j.notebook.getCellFromApiCell(l)),!g)throw new Error("INVALID cell");return g.handle}s(l){return l.map(g=>{const v=o.$2K.ensureUniqueMimeTypes(g.items,!0);return v===g.items?b.NotebookCellOutput.from(g):b.NotebookCellOutput.from({items:v,id:g.id,metadata:g.metadata})})}async t(l,g,v){const u=this.r(g),f=this.s((0,w.$If)(l));return this.l({editType:i.CellExecutionUpdateType.Output,cellHandle:u,append:v,outputs:f})}async w(l,g,v){return l=o.$2K.ensureUniqueMimeTypes((0,w.$If)(l),!0),this.l({editType:i.CellExecutionUpdateType.OutputItems,items:l.map(b.NotebookCellOutputItem.from),outputId:g.id,append:v})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.j.apiCell},get executionOrder(){return l.i},set executionOrder(v){l.i=v,l.m([{editType:i.CellExecutionUpdateType.ExecutionState,executionOrder:l.i}])},start(v){if(l.f===C.Resolved||l.f===C.Started)throw new Error("Cannot call start again");l.f=C.Started,l.c.fire(),l.m({editType:i.CellExecutionUpdateType.ExecutionState,runStartTime:v})},end(v,u){if(l.f===C.Resolved)throw new Error("Cannot call resolve twice");l.f=C.Resolved,l.c.fire(),l.h.flush(),l.k.$completeExecution(l.b,new m.$Wz({runEndTime:u,lastRunSuccess:v}))},clearOutput(v){return l.n(),l.t([],v,!1)},appendOutput(v,u){return l.n(),l.t(v,u,!0)},replaceOutput(v,u){return l.n(),l.t(v,u,!1)},appendOutputItems(v,u){return l.n(),l.w(v,u,!0)},replaceOutputItems(v,u){return l.n(),l.w(v,u,!1)}})}}var h;(function(D){D[D.Init=0]="Init",D[D.Started=1]="Started",D[D.Resolved=2]="Resolved"})(h||(h={}));class n extends P.$lb{static{this.a=0}get state(){return this.f}constructor(l,g,v){super(),this.h=g,this.i=v,this.b=n.a++,this.c=new z.$7c,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new I.$dd),this.i.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===h.Resolved||this.f===h.Started)throw new Error("Cannot call start again");this.f=h.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===h.Resolved)throw new Error("Cannot call resolve twice");this.f=h.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}class s{constructor(l,g){this.e=l,this.f=g,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new L.$Ng,this.b=Date.now(),(0,L.$ug)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const g=this.a;return this.a=[],this.f(g).finally(()=>l.complete())}}function p(D,l){return`${D.value}/${l}`}e.$wac=p}),define(Ae[240],Re([1,0,5,4,103]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=void 0;class z{constructor(d,k){this.c=k,this.a=new Map,this.b=d.getProxy(L.$xJ.MainThreadNotebookRenderers)}$postRendererMessage(d,k,$){const R=this.c.getEditorById(d);this.a.get(k)?.fire({editor:R.apiEditor,message:$})}createRendererMessaging(d,k){if(!d.contributes?.notebookRenderer?.some(R=>R.id===k))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${k})`);return{onDidReceiveMessage:(R,E,c)=>this.d(k).event(R,E,c),postMessage:(R,E)=>{I.$gac.apiEditorsToExtHost.has(R)&&([R,E]=[E,R]);const c=E&&I.$gac.apiEditorsToExtHost.get(E);return this.b.$postMessage(c?.id,k,R)}}}d(d){let k=this.a.get(d);return k||(k=new w.$7c({onDidRemoveLastListener:()=>{k?.dispose(),this.a.delete(d)}}),this.a.set(d,k),k)}}e.$xac=z}),define(Ae[241],Re([1,0,6,12,2,26,4]),function($e,e,w,L,I,z,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=void 0;class d{constructor($){this.b=new Map,this.a=$.getProxy(P.$xJ.MainThreadProfileContentHandlers)}registrProfileContentHandler($,R,E){if((0,z.$wF)($,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,E),this.a.$registerProfileContentHandler(R,E.name,E.description,$.identifier.value),(0,w.$jb)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile($,R,E,c){const y=this.b.get($);if(!y)throw new Error(`Unknown handler with id: ${$}`);return y.saveProfile(R,E,c)}async $readProfile($,R,E){const c=this.b.get($);if(!c)throw new Error(`Unknown handler with id: ${$}`);return c.readProfile((0,L.$ie)(R)?R:I.URI.revive(R),E)}}e.$Bac=d}),define(Ae[242],Re([1,0,2,4,16,8]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cac=void 0;class P{static{this.a=0}constructor(k,$){this.d=$,this.c=new Map,this.b=k.getProxy(L.$xJ.MainThreadQuickDiff)}$provideOriginalResource(k,$,R){const E=w.URI.revive($),c=this.c.get(k);return c?(0,I.$mg)(()=>c.provideOriginalResource(E,R)).then(y=>y||null):Promise.resolve(null)}registerQuickDiffProvider(k,$,R,E){const c=P.a++;return this.c.set(c,$),this.b.$registerQuickDiffProvider(c,z.DocumentSelector.from(k,this.d),R,E),{dispose:()=>{this.b.$unregisterQuickDiffProvider(c),this.c.delete(c)}}}}e.$Cac=P}),define(Ae[243],Re([1,0,20,5,6,4,2,7,11,18,29,40,26,8]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D_b=void 0;function b(o,t,i){const a=o.getProxy(z.$xJ.MainThreadQuickOpen);class m{constructor(l,g){this.e=new Map,this.f=0,this.a=l,this.b=g}showQuickPick(l,g,v,u=w.CancellationToken.None){this.c=void 0;const f=Promise.resolve(g),A=++this.f,W=a.$show(A,{title:v?.title,placeHolder:v?.placeHolder,matchOnDescription:v?.matchOnDescription,matchOnDetail:v?.matchOnDetail,ignoreFocusLost:v?.ignoreFocusOut,canPickMany:v?.canPickMany},u),B={},V=W.then(()=>B);return Promise.race([V,f]).then(U=>{if(U===B)return;const O=(0,c.$vF)(l,"quickPickItemTooltip");return f.then(N=>{const ae=[];for(let Q=0;Q<N.length;Q++){const be=N[Q];if(typeof be=="string")ae.push({label:be,handle:Q});else if(be.kind===d.QuickPickItemKind.Separator)ae.push({type:"separator",label:be.label});else{be.tooltip&&!O&&console.warn(`Extension '${l.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${l.identifier.value}`);const ke=be.iconPath?n(be.iconPath):void 0;ae.push({label:be.label,iconPath:ke?.iconPath,iconClass:ke?.iconClass,description:be.description,detail:be.detail,picked:be.picked,alwaysShow:be.alwaysShow,tooltip:O?y.MarkdownString.fromStrict(be.tooltip):void 0,handle:Q})}}return v&&typeof v.onDidSelectItem=="function"&&(this.c=Q=>{v.onDidSelectItem(N[Q])}),a.$setItems(A,ae),W.then(Q=>{if(typeof Q=="number")return N[Q];if(Array.isArray(Q))return Q.map(be=>N[be])})})}).then(void 0,U=>{if(!(0,k.$2)(U))return a.$setError(A,U),Promise.reject(U)})}$onItemSelected(l){this.c?.(l)}showInput(l,g=w.CancellationToken.None){return this.d=l?.validateInput,a.$input(l,typeof this.d=="function",g).then(void 0,v=>{if(!(0,k.$2)(v))return Promise.reject(v)})}async $validateInput(l){if(!this.d)return;const g=await this.d(l);if(!g||typeof g=="string")return g;let v;switch(g.severity){case d.InputBoxValidationSeverity.Info:v=R.default.Info;break;case d.InputBoxValidationSeverity.Warning:v=R.default.Warning;break;case d.InputBoxValidationSeverity.Error:v=R.default.Error;break;default:v=g.message?R.default.Error:R.default.Ignore;break}return{content:g.message,severity:v}}async showWorkspaceFolderPick(l,g=w.CancellationToken.None){const v=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[l]);if(!v)return;const u=await this.a.getWorkspaceFolders2();if(u)return u.find(f=>f.uri.toString()===v.uri.toString())}createQuickPick(l){const g=new s(l,()=>this.e.delete(g._id));return this.e.set(g._id,g),g}createInputBox(l){const g=new p(l,()=>this.e.delete(g._id));return this.e.set(g._id,g),g}$onDidChangeValue(l,g){this.e.get(l)?._fireDidChangeValue(g)}$onDidAccept(l){this.e.get(l)?._fireDidAccept()}$onDidChangeActive(l,g){const v=this.e.get(l);v instanceof s&&v._fireDidChangeActive(g)}$onDidChangeSelection(l,g){const v=this.e.get(l);v instanceof s&&v._fireDidChangeSelection(g)}$onDidTriggerButton(l,g){this.e.get(l)?._fireDidTriggerButton(g)}$onDidTriggerItemButton(l,g,v){const u=this.e.get(l);u instanceof s&&u._fireDidTriggerItemButton(g,v)}$onDidHide(l){this.e.get(l)?._fireDidHide()}}class S{static{this.a=1}constructor(l,g){this.x=l,this.y=g,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.$7c,this.q=new L.$7c,this.r=new L.$7c,this.s=new L.$7c,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(l){this.b=l,this.z({title:l})}get step(){return this.c}set step(l){this.c=l,this.z({step:l})}get totalSteps(){return this.d}set totalSteps(l){this.d=l,this.z({totalSteps:l})}get enabled(){return this.g}set enabled(l){this.g=l,this.z({enabled:l})}get busy(){return this.j}set busy(l){this.j=l,this.z({busy:l})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(l){this.k=l,this.z({ignoreFocusOut:l})}get value(){return this.l}set value(l){this.l=l,this.z({value:l})}get placeholder(){return this.m}set placeholder(l){this.m=l,this.z({placeholder:l})}get buttons(){return this.n}set buttons(l){this.n=l.slice(),this.o.clear(),l.forEach((g,v)=>{const u=g===d.$UK.Back?-1:v;this.o.set(u,g)}),this.z({buttons:l.map((g,v)=>({...n(g.iconPath),tooltip:g.tooltip,handle:g===d.$UK.Back?-1:v}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(l){this.l=l,this.q.fire(l)}_fireDidTriggerButton(l){const g=this.o.get(l);g&&this.r.fire(g)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$gb)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),a.$dispose(this._id))}z(l){if(!this.v){for(const g of Object.keys(l)){const v=l[g];this.u[g]=v===void 0?null:v}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){a.$createOrUpdate(this.u),this.u={id:this._id}}}function C(D){if(D instanceof d.$uK)return{id:D.id};const l=h(D),g=r(D);return{dark:typeof l=="string"?P.URI.file(l):l,light:typeof g=="string"?P.URI.file(g):g}}function r(D){return typeof D=="object"&&"light"in D?D.light:D}function h(D){return typeof D=="object"&&"dark"in D?D.dark:D}function n(D){const l=C(D);let g,v;return"id"in l?v=E.ThemeIcon.asClassName(l):g=l,{iconPath:g,iconClass:v}}class s extends S{constructor(l,g){super(l.identifier,g),this.O=l,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.$7c,this.L=[],this.M=new L.$7c,this.N=new L.$7c,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(l){this.B=l.slice(),this.C.clear(),this.D.clear(),l.forEach((u,f)=>{this.C.set(f,u),this.D.set(u,f)});const g=(0,c.$vF)(this.O,"quickPickItemTooltip"),v=[];for(let u=0;u<l.length;u++){const f=l[u];if(f.kind===d.QuickPickItemKind.Separator)v.push({type:"separator",label:f.label});else{f.tooltip&&!g&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const A=f.iconPath?n(f.iconPath):void 0;v.push({handle:u,label:f.label,iconPath:A?.iconPath,iconClass:A?.iconClass,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:g?y.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((W,B)=>({...n(W.iconPath),tooltip:W.tooltip,handle:B}))})}}this.z({items:v})}get canSelectMany(){return this.E}set canSelectMany(l){this.E=l,this.z({canSelectMany:l})}get matchOnDescription(){return this.F}set matchOnDescription(l){this.F=l,this.z({matchOnDescription:l})}get matchOnDetail(){return this.G}set matchOnDetail(l){this.G=l,this.z({matchOnDetail:l})}get sortByLabel(){return this.H}set sortByLabel(l){this.H=l,this.z({sortByLabel:l})}get keepScrollPosition(){return this.I}set keepScrollPosition(l){this.I=l,this.z({keepScrollPosition:l})}get activeItems(){return this.J}set activeItems(l){this.J=l.filter(g=>this.D.has(g)),this.z({activeItems:this.J.map(g=>this.D.get(g))})}get selectedItems(){return this.L}set selectedItems(l){this.L=l.filter(g=>this.D.has(g)),this.z({selectedItems:this.L.map(g=>this.D.get(g))})}_fireDidChangeActive(l){const g=(0,$.$lf)(l.map(v=>this.C.get(v)));this.J=g,this.K.fire(g)}_fireDidChangeSelection(l){const g=(0,$.$lf)(l.map(v=>this.C.get(v)));this.L=g,this.M.fire(g)}_fireDidTriggerItemButton(l,g){const v=this.C.get(l);if(!v||!v.buttons||!v.buttons.length)return;const u=v.buttons[g];u&&this.N.fire({button:u,item:v})}}class p extends S{constructor(l,g){super(l.identifier,g),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(l){this.B=l,this.z({password:l})}get prompt(){return this.C}set prompt(l){this.C=l,this.z({prompt:l})}get valueSelection(){return this.D}set valueSelection(l){this.D=l,this.z({valueSelection:l})}get validationMessage(){return this.E}set validationMessage(l){this.E=l,l?typeof l=="string"?this.z({validationMessage:l,severity:R.default.Error}):this.z({validationMessage:l.message,severity:l.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new m(t,i)}e.$D_b=b}),define(Ae[244],Re([1,0,2,5,66,6,16,4,18,131,14,21,40,8,26,13]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=e.$E_b=void 0;function t(l){if(l)return typeof l.iconPath=="string"?w.URI.file(l.iconPath):w.URI.isUri(l.iconPath)||c.ThemeIcon.isThemeIcon(l.iconPath)?l.iconPath:void 0}function i(l,g){if(!l.iconPath&&!g.iconPath)return 0;if(l.iconPath){if(!g.iconPath)return 1}else return-1;const v=typeof l.iconPath=="string"?l.iconPath:w.URI.isUri(l.iconPath)?l.iconPath.fsPath:l.iconPath.id,u=typeof g.iconPath=="string"?g.iconPath:w.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,$.$7p)(v,u)}function a(l,g){let v=0;if(l.strikeThrough!==g.strikeThrough)return l.strikeThrough?1:-1;if(l.faded!==g.faded)return l.faded?1:-1;if(l.tooltip!==g.tooltip)return(l.tooltip||"").localeCompare(g.tooltip||"");if(v=i(l,g),v!==0)return v;if(l.light&&g.light)v=i(l.light,g.light);else{if(l.light)return 1;if(g.light)return-1}if(v!==0)return v;if(l.dark&&g.dark)v=i(l.dark,g.dark);else{if(l.dark)return 1;if(g.dark)return-1}return v}function m(l,g){if(l.command!==g.command)return l.command<g.command?-1:1;if(l.title!==g.title)return l.title<g.title?-1:1;if(l.tooltip!==g.tooltip){if(l.tooltip!==void 0&&g.tooltip!==void 0)return l.tooltip<g.tooltip?-1:1;if(l.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(l.arguments===g.arguments)return 0;if(l.arguments)if(g.arguments){if(l.arguments.length!==g.arguments.length)return l.arguments.length-g.arguments.length}else return 1;else return-1;for(let v=0;v<l.arguments.length;v++){const u=l.arguments[v],f=g.arguments[v];if(u!==f)return u<f?-1:1}return 0}function S(l,g){let v=(0,$.$7p)(l.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(v!==0)return v;if(l.command&&g.command)v=m(l.command,g.command);else{if(l.command)return 1;if(g.command)return-1}if(v!==0)return v;if(l.decorations&&g.decorations)v=a(l.decorations,g.decorations);else{if(l.decorations)return 1;if(g.decorations)return-1}return v}function C(l,g){for(let v=0;v<l.length;v++)if(l[v]!==g[v])return!1;return!0}function r(l,g){return l.command===g.command&&l.title===g.title&&l.tooltip===g.tooltip&&(l.arguments&&g.arguments?C(l.arguments,g.arguments):l.arguments===g.arguments)}function h(l,g){return(0,k.$af)(l,g,r)}class n{#e;#t;get value(){return this.d}set value(g){g=g??"",this.#e.$setInputBoxValue(this.l,g),this.n(g)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(g){this.#e.$setInputBoxPlaceholder(this.l,g),this.f=g}get validateInput(){return(0,b.$wF)(this.k,"scmValidation"),this.g}set validateInput(g){if((0,b.$wF)(this.k,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=g,this.#e.$setValidationProviderIsEnabled(this.l,!!g)}get enabled(){return this.h}set enabled(g){g=!!g,this.h!==g&&(this.h=g,this.#e.$setInputBoxEnablement(this.l,g))}get visible(){return this.j}set visible(g){g=!!g,this.j!==g&&(this.j=g,this.#e.$setInputBoxVisibility(this.l,g))}get document(){return(0,b.$wF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(g,v,u,f,A){this.k=g,this.l=f,this.m=A,this.d="",this.e=new L.$7c,this.f="",this.h=!0,this.j=!0,this.#t=v,this.#e=u}showValidationMessage(g,v){(0,b.$wF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,g,v)}$onInputBoxValueChange(g){this.n(g)}n(g){this.d=g,this.e.fire(g)}}e.$E_b=n;class s{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(g){this.v=g,this.q.$updateGroupLabel(this.t,this.handle,g)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(g){this.p=g,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(g){this.f=[...g],this.k.fire()}constructor(g,v,u,f,A){this.q=g,this.s=v,this.t=u,this.u=f,this.v=A,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.$7c,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.$7c,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=s.d++}getResourceState(g){return this.g.get(g)}$executeResourceCommand(g,v){const u=this.h.get(g);return u?(0,P.$mg)(()=>this.s.executeCommand(u.command,...u.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this.f].sort(S),u=(0,k.$hf)(this.o,g,S).map(W=>{const B=W.toInsert.map(V=>{const U=this.e++;this.g.set(U,V);const O=V.resourceUri;let N;if(V.command)if(V.command.command==="vscode.open"||V.command.command==="vscode.diff"){const de=new z.$kb;N=this.s.converter.toInternal(V.command,de),this.j.set(U,de)}else this.h.set(U,V.command);const ae=t(V.decorations),Q=V.decorations&&t(V.decorations.light)||ae,be=V.decorations&&t(V.decorations.dark)||ae,ke=[Q,be],Fe=V.decorations&&V.decorations.tooltip||"",G=V.decorations&&!!V.decorations.strikeThrough,Z=V.decorations&&!!V.decorations.faded,le=V.contextValue||"";return{rawResource:[U,O,ke,Fe,G,Z,le,N],handle:U}});return{start:W.start,deleteCount:W.deleteCount,toInsert:B}}),f=u.map(({start:W,deleteCount:B,toInsert:V})=>[W,B,V.map(U=>U.rawResource)]),A=u.reverse();for(const{start:W,deleteCount:B,toInsert:V}of A){const U=V.map(N=>N.handle),O=this.n.splice(W,B,...U);for(const N of O)this.g.delete(N),this.h.delete(N),this.j.get(N)?.dispose(),this.j.delete(N)}return this.o=g,f}dispose(){this.l=!0,this.m.fire()}}class p{static{this.d=0}#e;get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(g){this.g!==g&&(this.g=g,this.#e.$updateSourceControl(this.t,{count:g}))}get quickDiffProvider(){return this.h}set quickDiffProvider(g){this.h=g;let v;(0,b.$vF)(this.u,"quickDiffProvider")&&(v=g?.label),this.#e.$updateSourceControl(this.t,{hasQuickDiffProvider:!!g,quickDiffLabel:v})}get commitTemplate(){return this.j}set commitTemplate(g){g!==this.j&&(this.j=g,this.#e.$updateSourceControl(this.t,{commitTemplate:g}))}get acceptInputCommand(){return this.l}set acceptInputCommand(g){this.k.value=new z.$kb,this.l=g;const v=this.v.converter.toInternal(g,this.k.value);this.#e.$updateSourceControl(this.t,{acceptInputCommand:v})}get actionButton(){return(0,b.$wF)(this.u,"scmActionButton"),this.n}set actionButton(g){(0,b.$wF)(this.u,"scmActionButton"),this.m.value=new z.$kb,this.n=g;const v=g!==void 0?{command:this.v.converter.toInternal(g.command,this.m.value),secondaryCommands:g.secondaryCommands?.map(u=>u.map(f=>this.v.converter.toInternal(f,this.m.value))),description:g.description,enabled:g.enabled}:void 0;this.#e.$updateSourceControl(this.t,{actionButton:v??null})}get statusBarCommands(){return this.p}set statusBarCommands(g){if(this.p&&g&&h(this.p,g))return;this.o.value=new z.$kb,this.p=g;const v=(g||[]).map(u=>this.v.converter.toInternal(u,this.o.value));this.#e.$updateSourceControl(this.t,{statusBarCommands:v})}get selected(){return this.q}constructor(g,v,u,f,A,W,B){this.u=g,this.v=f,this.w=A,this.x=W,this.y=B,this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new z.$mb,this.l=void 0,this.m=new z.$mb,this.o=new z.$mb,this.p=void 0,this.q=!1,this.s=new L.$7c,this.onDidChangeSelection=this.s.event,this.t=p.d++,this.z=new Map,this.A=new Set,this.#e=u;const V=w.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${A}/scm${this.t}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new n(g,v,this.#e,this.t,V),this.#e.$registerSourceControl(this.t,A,W,B,V)}createResourceGroup(g,v){const u=new s(this.#e,this.v,this.t,g,v),f=L.Event.once(u.onDidDispose)(()=>this.z.delete(u));return this.z.set(u,f),this.eventuallyAddResourceGroups(),u}eventuallyAddResourceGroups(){const g=[],v=[];for(const[u,f]of this.z){f.dispose();const A=u.onDidUpdateResourceStates(()=>{this.A.add(u),this.eventuallyUpdateResourceStates()});L.Event.once(u.onDidDispose)(()=>{this.A.delete(u),A.dispose(),this.e.delete(u.handle),this.#e.$unregisterGroup(this.t,u.handle)}),g.push([u.handle,u.id,u.label,u.features]);const W=u._takeResourceStateSnapshot();W.length>0&&v.push([u.handle,W]),this.e.set(u.handle,u)}this.#e.$registerGroups(this.t,g,v),this.z.clear()}eventuallyUpdateResourceStates(){const g=[];this.A.forEach(v=>{const u=v._takeResourceStateSnapshot();u.length!==0&&g.push([v.handle,u])}),g.length>0&&this.#e.$spliceResourceStates(this.t,g),this.A.clear()}getResourceGroup(g){return this.e.get(g)}setSelectionState(g){this.q=g,this.s.fire(g)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(g=>g.dispose()),this.#e.$unregisterSourceControl(this.t)}}qe([(0,I.$Sg)(100)],p.prototype,"eventuallyAddResourceGroups",null),qe([(0,I.$Sg)(100)],p.prototype,"eventuallyUpdateResourceStates",null);let D=class En{static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(g,v,u,f){this.l=v,this.m=u,this.n=f,this.g=new Map,this.h=new E.$Hl,this.j=new L.$7c,this.e=g.getProxy(d.$xJ.MainThreadSCM),this.f=g.getProxy(d.$xJ.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const W=this.g.get(A.sourceControlHandle);if(!W)return A;const B=W.getResourceGroup(A.groupHandle);return B?B.getResourceState(A.handle):A}else if(A&&A.$mid===4){const W=this.g.get(A.sourceControlHandle);return W?W.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const W=this.g.get(A.handle);return W||A}return A}})}createSourceControl(g,v,u,f){this.n.trace("ExtHostSCM#createSourceControl",g.identifier.value,v,u,f),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const A=En.d++,W=new p(g,this.m,this.e,this.l,v,u,f);this.g.set(A,W);const B=this.h.get(g.identifier)||[];return B.push(W),this.h.set(g.identifier,B),W}getLastInputBox(g){this.n.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const v=this.h.get(g.identifier),u=v&&v[v.length-1];return u&&u.inputBox}$provideOriginalResource(g,v,u){const f=w.URI.revive(v);this.n.trace("ExtHostSCM#$provideOriginalResource",g,f.toString());const A=this.g.get(g);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,P.$mg)(()=>A.quickDiffProvider.provideOriginalResource(f,u)).then(W=>W||null)}$onInputBoxValueChange(g,v){this.n.trace("ExtHostSCM#$onInputBoxValueChange",g);const u=this.g.get(g);return u&&u.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(g,v,u,f){this.n.trace("ExtHostSCM#$executeResourceCommand",g,v,u);const A=this.g.get(g);if(!A)return Promise.resolve(void 0);const W=A.getResourceGroup(v);return W?W.$executeResourceCommand(u,f):Promise.resolve(void 0)}$validateInput(g,v,u){this.n.trace("ExtHostSCM#$validateInput",g);const f=this.g.get(g);return!f||!f.inputBox.validateInput?Promise.resolve(void 0):(0,P.$mg)(()=>f.inputBox.validateInput(v,u)).then(A=>{if(!A)return Promise.resolve(void 0);const W=y.MarkdownString.fromStrict(A.message);return W?Promise.resolve([W,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this.g.get(g)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=g,Promise.resolve(void 0)}};e.$F_b=D,e.$F_b=D=qe([Ve(3,R.$Pi)],D)}),define(Ae[83],Re([1,0,4,5,3]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$l_b=e.$k_b=void 0;class z{constructor(d){this.b=new L.$7c,this.onDidChangePassword=this.b.event,this.a=d.getProxy(w.$xJ.MainThreadSecretState)}async $onDidChangePassword(d){this.b.fire(d)}get(d,k){return this.a.$getPassword(d,k)}store(d,k,$){return this.a.$setPassword(d,k,$)}delete(d,k){return this.a.$deletePassword(d,k)}}e.$k_b=z,e.$l_b=(0,I.$nh)("IExtHostSecretState")}),define(Ae[245],Re([1,0,4,7]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=void 0;class I{constructor(P){this.a=new Map,this.b=0,this.c=P.getProxy(w.$xJ.MainThreadSemanticSimilarity)}async $provideSimilarityScore(P,d,k,$){if(this.a.size===0)throw new Error("No semantic similarity providers registered");const R=this.a.get(P);if(!R)throw new Error("Semantic similarity provider not found");return await R.provideSimilarityScore(d,k,$)}registerSemanticSimilarityProvider(P,d){const k=this.b;return this.b++,this.a.set(k,d),this.c.$registerSemanticSimilarityProvider(k),new L.$zJ(()=>{this.c.$unregisterSemanticSimilarityProvider(k),this.a.delete(k)})}}e.$Gac=I}),define(Ae[246],Re([1,0,4,8,2]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iac=void 0;class z{static{this.a=0}constructor(d,k){this.d=k,this.c=new Map,this.b=d.getProxy(w.$xJ.MainThreadShare)}async $provideShare(d,k,$){return await this.c.get(d)?.provideShare({selection:L.Range.to(k.selection),resourceUri:I.URI.revive(k.resourceUri)},$)??void 0}registerShareProvider(d,k){const $=z.a++;return this.c.set($,k),this.b.$registerShareProvider($,L.DocumentSelector.from(d,this.d),k.id,k.label,k.priority),{dispose:()=>{this.b.$unregisterShareProvider($),this.c.delete($)}}}}e.$Iac=z}),define(Ae[247],Re([1,0,7,4,153,6,8,12]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=e.$G_b=void 0;class k{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new w.$vK("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new w.$vK("statusBarItem.warningForeground")]])}#e;#t;constructor(c,y,b,o,t,i=w.StatusBarAlignment.Left,a){if(this.i=!1,this.k="",this.q=new z.$kb,this.#e=c,this.#t=y,t&&o){this.c=(0,w.$$J)(o.identifier,t);const m=b.get(this.c);m&&(i=m.alignLeft?w.StatusBarAlignment.Left:w.StatusBarAlignment.Right,a=m.priority,this.j=!0,this.name=m.name,this.text=m.text,this.tooltip=m.tooltip,this.command=m.command,this.accessibilityInformation=m.accessibilityInformation)}else this.c=String(k.a++);this.e=o,this.f=t,this.g=i,this.h=this.u(a)}u(c){if((0,d.$me)(c))return c===Number.POSITIVE_INFINITY?Number.MAX_VALUE:c===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:c}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(c){this.k=c,this.v()}set name(c){this.m=c,this.v()}set tooltip(c){this.l=c,this.v()}set color(c){this.n=c,this.v()}set backgroundColor(c){c&&!k.b.has(c.id)&&(c=void 0),this.o=c,this.v()}set command(c){this.r?.fromApi!==c&&(this.p&&this.q.add(this.p),this.p=new z.$kb,typeof c=="string"?this.r={fromApi:c,internal:this.#t.toInternal({title:"",command:c},this.p)}:c?this.r={fromApi:c,internal:this.#t.toInternal(c,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(c){this.t=c,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let c;this.e?this.f?c=`${this.e.identifier.value}.${this.f}`:c=this.e.identifier.value:c=this.f;let y;this.m?y=this.m:y=(0,I.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=k.b.get(this.o.id));const o=P.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,c,this.e?.identifier.value,y,this.k,o,this.r?.internal,b,this.o,this.g===w.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$G_b=k;class ${constructor(c){this.b=[],this.a=c.createStatusBarEntry(void 0,"status.extensionMessage",w.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(c){const y={message:c};return this.b.unshift(y),this.c(),new w.$zJ(()=>{const b=this.b.indexOf(y);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(c,y){this.e=new Map,this.a=c.getProxy(L.$xJ.MainThreadStatusBar),this.b=y,this.c=new $(this)}$acceptStaticEntries(c){for(const y of c)this.e.set(y.entryId,y)}createStatusBarEntry(c,y,b,o){return new k(this.a,this.b,this.e,c,y,b,o)}setStatusBarMessage(c,y){const b=this.c.setMessage(c);let o;return typeof y=="number"?o=setTimeout(()=>b.dispose(),y):typeof y<"u"&&y.then(()=>b.dispose(),()=>b.dispose()),new w.$zJ(()=>{b.dispose(),clearTimeout(o)})}}e.$H_b=R}),define(Ae[84],Re([1,0,4,5,3]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=e.$$$b=void 0;class z{constructor(d,k){this.c=k,this.b=new L.$7c,this.onDidChangeStorage=this.b.event,this.a=d.getProxy(w.$xJ.MainThreadStorage)}registerExtensionStorageKeysToSync(d,k){this.a.$registerExtensionStorageKeysToSync(d,k)}async initializeExtensionStorage(d,k,$){const R=await this.a.$initializeExtensionStorage(d,k);let E;return R&&(E=this.d(d,k,R)),E||$}setValue(d,k,$){return this.a.$setValue(d,k,$)}$acceptValue(d,k,$){const R=this.d(d,k,$);R&&this.b.fire({shared:d,key:k,value:R})}d(d,k,$){try{return JSON.parse($)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${k}, global: ${d}): ${R}`)}}}e.$$$b=z,e.$_$b=(0,I.$nh)("IExtHostStorage")}),define(Ae[85],Re([1,0,3,27,14,62,2]),function($e,e,w,L,I,z,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f_b=e.$e_b=void 0,e.$e_b=(0,w.$nh)("IExtensionStoragePaths");let d=class{constructor($,R,E){this.d=R,this.f=E,this.a=$.workspace??void 0,this.b=$.environment,this.whenReady=this.h().then(c=>this.c=c)}async g($){return P.URI.joinPath(this.b.workspaceStorageHome,$)}async h(){if(!this.a)return Promise.resolve(void 0);const $=this.a.id,R=await this.g($);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(P.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:P.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(E){this.d.error("[ExtHostStorage]",E);return}}workspaceValue($){if(this.c)return P.URI.joinPath(this.c,$.identifier.value)}globalValue($){return P.URI.joinPath(this.b.globalStorageHome,$.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$f_b=d,e.$f_b=d=qe([Ve(0,L.$PL),Ve(1,I.$Pi),Ve(2,z.$d_b)],d)}),define(Ae[63],Re([1,0,5,4,3,2,17,6,7,155,11,182,20,36,183,40,12,16,8,26]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=e.$i_b=e.$h_b=e.$g_b=void 0,e.$g_b=(0,I.$nh)("IExtHostTerminalService");class S{constructor(u,f,A,W){this.k=u,this._id=f,this.l=A,this.m=W,this.a=!1,this.i={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const B=this;this.value={get name(){return B.m||""},get processId(){return B.b},get creationOptions(){return B.l},get exitStatus(){return B.h},get state(){return B.i},get selection(){return B.j},sendText(V,U=!0){B.o(),B.k.$sendText(B._id,V,U)},show(V){B.o(),B.k.$show(B._id,V)},hide(){B.o(),B.k.$hide(B._id)},dispose(){B.a||(B.a=!0,B.k.$dispose(B._id))},get dimensions(){if(!(B.d===void 0||B.g===void 0))return{columns:B.d,rows:B.g}}}}async create(u,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:u.name,shellPath:(0,t.$Ae)(u.shellPath),shellArgs:(0,t.$Ae)(u.shellArgs),cwd:(0,t.$Ae)(u.cwd),env:(0,t.$Ae)(u.env),icon:(0,t.$Ae)(D(u.iconPath)),color:o.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,t.$Ae)(u.message),strictEnv:(0,t.$Ae)(u.strictEnv),hideFromUser:(0,t.$Ae)(u.hideFromUser),isFeatureTerminal:(0,t.$Ae)(f?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.$Ae)(f?.useShellEnvironment),location:f?.location||this.n(u.location,f?.resolvedExtHostIdentifier),isTransient:(0,t.$Ae)(u.isTransient)})}async createExtensionTerminal(u,f,A,W){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:A,color:o.ThemeColor.isThemeColor(W)?W.id:void 0,location:this.n(u,f),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(u,f){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&f?{parentTerminal:f}:"viewColumn"in u?{viewColumn:a.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.m=u}setExitStatus(u,f){this.h=Object.freeze({code:u,reason:f})}setDimensions(u,f){return u===this.d&&f===this.g||u===0||f===0?!1:(this.d=u,this.g=f,!0)}setInteractedWith(){return this.i.isInteractedWith?!1:(this.i={isInteractedWith:!0},!0)}setSelection(u){this.j=u}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(f=>{f!==u&&(this.b=Promise.resolve(u))})}}e.$h_b=S;class C{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new w.$7c,this.onProcessData=this.a.event,this.b=new w.$7c,this.d=new w.$7c,this.onDidChangeProperty=this.d.event,this.f=new w.$7c,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,f){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${f}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,f){this.g.setDimensions?.({columns:u,rows:f})}clearBuffer(){}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(u){this.g.onDidWrite(f=>this.a.fire(f)),this.g.onDidClose?.((f=void 0)=>{this.f.fire(f===void 0?void 0:f)}),this.g.onDidOverrideDimensions?.(f=>{f&&this.d.fire({type:"overrideDimensions",value:{cols:f.columns,rows:f.rows}})}),this.g.onDidChangeName?.(f=>{this.d.fire({type:"title",value:f})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let r=1,h=class extends d.$lb{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}get onDidWriteTerminalData(){return this.H.event}constructor(u,f){super(),this.f=[],this.g=new Map,this.h={},this.i={},this.j={},this.k=new Map,this.s=new Set,this.u=new Map,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new w.$7c,this.onDidCloseTerminal=this.z.event,this.C=new w.$7c,this.onDidOpenTerminal=this.C.event,this.D=new w.$7c,this.onDidChangeActiveTerminal=this.D.event,this.F=new w.$7c,this.onDidChangeTerminalDimensions=this.F.event,this.G=new w.$7c,this.onDidChangeTerminalState=this.G.event,this.I=new w.$7c,this.onDidChangeShell=this.I.event,this.a=f.getProxy(L.$xJ.MainThreadTerminalService),this.n=new b.$7ib(this.a.$sendProcessData),this.H=new w.$7c({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(u),this.B({dispose:()=>{for(const[A,W]of this.g)W.shutdown(!0)}})}getDefaultShell(u){return(u?this.m:this.l)?.path||""}getDefaultShellArgs(u){return(u?this.m:this.l)?.args||[]}createExtensionTerminal(u,f){const A=new S(this.a,(0,y.$5e)(),u,u.name),W=new C(u.pty);return A.createExtensionTerminal(u.location,this.J(u,f).resolvedExtHostIdentifier,D(u.iconPath),l(u.color)).then(B=>{const V=this.L(B,W);this.h[B]=V}),this.f.push(A),A.value}J(u,f){if(f=f||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const A=u.location.parentTerminal;if(A){const W=this.f.find(B=>B.value===A);W&&(f.resolvedExtHostIdentifier=W._id)}}else u.location&&typeof u.location!="object"?f.location=u.location:f.location&&typeof f.location=="object"&&"splitActiveTerminal"in f.location&&(f.location={splitActiveTerminal:!0});return f}attachPtyToTerminal(u,f){if(!this.N(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const W=new C(f),B=this.L(u,W);this.h[u]=B}async $acceptActiveTerminalChanged(u){const f=this.b;if(u===null){this.b=void 0,f!==this.b&&this.D.fire(this.b);return}const A=this.N(u);A&&(this.b=A,f!==this.b&&this.D.fire(this.b.value))}async $acceptTerminalProcessData(u,f){const A=this.N(u);A&&this.H.fire({terminal:A.value,data:f})}async $acceptTerminalDimensions(u,f,A){const W=this.N(u);W&&W.setDimensions(f,A)&&this.F.fire({terminal:W.value,dimensions:W.value.dimensions})}async $acceptTerminalMaximumDimensions(u,f,A){this.g.get(u)?.resize(f,A)}async $acceptTerminalTitleChange(u,f){const A=this.N(u);A&&(A.name=f)}async $acceptTerminalClosed(u,f,A){const W=this.P(this.f,u);if(W!==null){const B=this.f.splice(W,1)[0];B.setExitStatus(f,A),this.z.fire(B.value)}}$acceptTerminalOpened(u,f,A,W){if(f){const U=this.P(this.f,f);if(U!==null){this.f[U]._id=u,this.C.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const B={name:W.name,shellPath:W.executable,shellArgs:W.args,cwd:typeof W.cwd=="string"?W.cwd:z.URI.revive(W.cwd),env:W.env,hideFromUser:W.hideFromUser},V=new S(this.a,u,B,A);this.f.push(V),this.C.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(u,f){this.N(u)?._setProcessId(f)}async $startExtensionTerminal(u,f){const A=this.N(u);if(!A)return{message:(0,$.localize)(0,null,u)};A.isOpen||await new Promise(B=>{const V=this.onDidOpenTerminal(async U=>{U===A.value&&(V.dispose(),B())})});const W=this.g.get(u);W?W.startSendingEvents(f):this.i[u]={initialDimensions:f}}L(u,f){const A=new d.$kb;A.add(f.onProcessReady(B=>this.a.$sendProcessReady(u,B.pid,B.cwd,B.windowsPty))),A.add(f.onDidChangeProperty(B=>this.a.$sendProcessProperty(u,B))),this.n.startBuffering(u,f.onProcessData),A.add(f.onProcessExit(B=>this.M(u,B))),this.g.set(u,f);const W=this.i[u];return W&&f instanceof C&&(f.startSendingEvents(W.initialDimensions),delete this.i[u]),A}$acceptProcessAckDataEvent(u,f){this.g.get(u)?.acknowledgeDataEvent(f)}$acceptProcessInput(u,f){this.g.get(u)?.input(f)}$acceptTerminalInteraction(u){const f=this.N(u);f?.setInteractedWith()&&this.G.fire(f.value)}$acceptTerminalSelection(u,f){this.N(u)?.setSelection(f)}$acceptProcessResize(u,f,A){try{this.g.get(u)?.resize(f,A)}catch(W){if(W.code!=="EPIPE"&&W.code!=="ERR_IPC_CHANNEL_CLOSED")throw W}}$acceptProcessShutdown(u,f){this.g.get(u)?.shutdown(f)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(f=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:f}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(f=>this.a.$sendProcessProperty(u,{type:"cwd",value:f}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.s.add(u),this.s.size===1&&this.a.$startLinkProvider(),new k.$zJ(()=>{this.s.delete(u),this.s.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,f,A){if(this.u.has(f))throw new Error(`Terminal profile provider "${f}" already registered`);return this.u.set(f,A),this.a.$registerProfileProvider(f,u.identifier.value),new k.$zJ(()=>{this.u.delete(f),this.a.$unregisterProfileProvider(f)})}registerTerminalQuickFixProvider(u,f,A){if(this.v.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.v.set(u,A),this.a.$registerQuickFixProvider(u,f),new k.$zJ(()=>{this.v.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,f){const A=new c.$dd().token;if(A.isCancellationRequested)return;const W=this.v.get(u);if(!W)return;const B=await W.provideTerminalQuickFixes(f,A);if(B!==null)return B}async $createContributedProfileTerminal(u,f){const A=new c.$dd().token;let W=await this.u.get(u)?.provideTerminalProfile(A);if(!A.isCancellationRequested){if(W&&!("options"in W)&&(W={options:W}),!W||!("options"in W))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in W.options){this.createExtensionTerminal(W.options,f);return}this.createTerminalFromOptions(W.options,f)}}async $provideLinks(u,f){const A=this.N(u);if(!A)return[];this.w.delete(u),this.y.get(u)?.dispose(!0);const B=new c.$dd;this.y.set(u,B);const V=[],U={terminal:A.value,line:f},O=[];for(const Q of this.s)O.push(i.Promises.withAsyncBody(async be=>{B.token.onCancellationRequested(()=>be({provider:Q,links:[]}));const ke=await Q.provideTerminalLinks(U,B.token)||[];B.token.isCancellationRequested||be({provider:Q,links:ke})}));const N=await Promise.all(O);if(B.token.isCancellationRequested)return[];const ae=new Map;for(const Q of N)Q&&Q.links.length>0&&V.push(...Q.links.map(be=>{const ke={id:r++,startIndex:be.startIndex,length:be.length,label:be.tooltip};return ae.set(ke.id,{provider:Q.provider,link:be}),ke}));return this.w.set(u,ae),V}$activateLink(u,f){const A=this.w.get(u)?.get(f);A&&A.provider.handleTerminalLink(A.link)}M(u,f){this.n.stopBuffering(u),this.g.delete(u),delete this.i[u];const A=this.h[u];A&&(A.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,f)}N(u){return this.O(this.f,u)}O(u,f){const A=this.P(u,f);return A!==null?u[A]:null}P(u,f){const A=u.findIndex(W=>W._id===f);return A===-1?null:A}getEnvironmentVariableCollection(u){let f=this.k.get(u.identifier.value);return f||(f=new n(u),this.R(u.identifier.value,f)),f.getScopedEnvironmentVariableCollection(void 0)}Q(u,f){const A=(0,E.$Xq)(f.map),W=(0,E.$Yq)(f.descriptionMap);this.a.$setEnvironmentVariableCollection(u,f.persistent,A.length===0?void 0:A,W)}$initEnvironmentVariableCollections(u){u.forEach(f=>{const A=f[0],W=new n(void 0,f[1]);this.R(A,W)})}$acceptDefaultProfile(u,f){const A=this.l;this.l=u,this.m=f,A?.path!==u.path&&this.I.fire(u.path)}R(u,f){this.k.set(u,f),f.onDidChangeCollection(()=>{this.Q(u,f)})}};e.$i_b=h,e.$i_b=h=qe([Ve(1,P.$zL)],h);class n{get persistent(){return this.b}set persistent(u){this.b=u,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(u,f){this.f=u,this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new w.$7c,this.map=new Map(f)}getScopedEnvironmentVariableCollection(u){this.f&&u&&(0,m.$wF)(this.f,"envCollectionWorkspace");const f=this.i(u);let A=this.a.get(f);return A||(A=new s(this,u),this.a.set(f,A),A.onDidChangeCollection(()=>this.d.fire())),A}replace(u,f,A,W){this.f&&A&&(0,m.$wF)(this.f,"envCollectionOptions"),this.g(u,{value:f,type:k.EnvironmentVariableMutatorType.Replace,options:A??{},scope:W})}append(u,f,A,W){this.f&&A&&(0,m.$wF)(this.f,"envCollectionOptions"),this.g(u,{value:f,type:k.EnvironmentVariableMutatorType.Append,options:A??{},scope:W})}prepend(u,f,A,W){this.f&&A&&(0,m.$wF)(this.f,"envCollectionOptions"),this.g(u,{value:f,type:k.EnvironmentVariableMutatorType.Prepend,options:A??{},scope:W})}g(u,f){if(f.options&&f.options.applyAtProcessCreation===!1&&!f.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const A=this.h(u,f.scope),W=this.map.get(A);if(!W||W.value!==f.value||W.type!==f.type||W.options?.applyAtProcessCreation!==(f.options.applyAtProcessCreation??!0)||W.options?.applyAtShellIntegration!==(f.options.applyAtShellIntegration??!1)||W.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index){const B=this.h(u,f.scope),V={variable:u,...f,options:{applyAtProcessCreation:f.options.applyAtProcessCreation??!0,applyAtShellIntegration:f.options.applyAtShellIntegration??!1}};this.map.set(B,V),this.d.fire()}}get(u,f){const A=this.h(u,f),W=this.map.get(A);return W?g(W):void 0}h(u,f){const A=this.i(f);return A.length?`${u}:::${A}`:u}i(u){return this.j(u?.workspaceFolder)??""}j(u){return u?u.uri.toString():void 0}getVariableMap(u){const f=new Map;for(const[A,W]of this.map)this.i(W.scope)===this.i(u)&&f.set(W.variable,g(W));return f}delete(u,f){const A=this.h(u,f);this.map.delete(A),this.d.fire()}clear(u){if(u?.workspaceFolder){for(const[f,A]of this.map)A.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(f);this.k(u)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(u,f){const A=this.i(f),W=this.descriptionMap.get(A);if(!W||W.description!==u){let B;typeof u=="string"?B=u:B=u?.value.split(`

`)[0];const V={description:B,scope:f};this.descriptionMap.set(A,V),this.d.fire()}}getDescription(u){const f=this.i(u);return this.descriptionMap.get(f)?.description}k(u){const f=this.i(u);this.descriptionMap.delete(f)}}class s{get persistent(){return this.b.persistent}set persistent(u){this.b.persistent=u}get onDidChangeCollection(){return this.a&&this.a.event}constructor(u,f){this.b=u,this.d=f,this.a=new w.$7c}getScopedEnvironmentVariableCollection(u){return this.b.getScopedEnvironmentVariableCollection(u)}replace(u,f,A){this.b.replace(u,f,A,this.d)}append(u,f,A){this.b.append(u,f,A,this.d)}prepend(u,f,A){this.b.prepend(u,f,A,this.d)}get(u){return this.b.get(u,this.d)}forEach(u,f){this.b.getVariableMap(this.d).forEach((A,W)=>u.call(f,W,A,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(u){this.b.delete(u,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(u){this.b.setDescription(u,this.d)}get description(){return this.b.getDescription(this.d)}}let p=class extends h{constructor(u){super(!1,u)}createTerminal(u,f,A){throw new R.$$}createTerminalFromOptions(u,f){throw new R.$$}};e.$j_b=p,e.$j_b=p=qe([Ve(0,P.$zL)],p);function D(v){if(!(!v||typeof v=="string"))return"id"in v?{id:v.id,color:v.color}:v}function l(v){return o.ThemeColor.isThemeColor(v)?v:void 0}function g(v){const u={...v};return delete u.scope,u.options=u.options??void 0,delete u.variable,u}}),define(Ae[248],Re([1,0,18,16,25,20,5,203,93,6,24,12,36,4,17,104,8,7,45,76,57]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tac=e.$sac=e.$rac=e.$qac=void 0;let C=class{constructor(B,V,U){this.j=U,this.c=new P.$7c,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=B.getProxy(y.$xJ.MainThreadTesting),this.h=new u(this.f),this.g=new s(this.f),V.registerArgumentProcessor({processArgument:O=>{if(O?.$mid!==15)return O;const N=O,ae=N.tests[N.tests.length-1].item.extId;return this.d.get(a.$jI.root(ae))?.collection.tree.get(ae)?.actual??(0,o.$LL)(O)}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const O=await V.executeCommand("_testing.getExplorerSelection"),N=ae=>{const Q=this.d.get(a.$jI.root(ae));if(Q)return a.$jI.isRoot(ae)?Q.controller:Q.collection.tree.get(ae)?.actual};return{include:O?.include.map(N).filter(E.$qe)||[],exclude:O?.exclude.map(N).filter(E.$qe)||[]}})}createTestController(B,V,U,O){if(this.d.has(V))throw new Error(`Attempt to insert a duplicate controller with ID "${V}"`);const N=new $.$kb,ae=N.add(new o.$OL(V,U,this.j));ae.root.label=U;const Q=new Map,be=this.f,ke={items:ae.root.children,get label(){return U},set label(G){U=G,ae.root.label=G,be.$updateController(V,{label:U})},get refreshHandler(){return O},set refreshHandler(G){O=G,be.$updateController(V,{canRefresh:!!G})},get id(){return V},createRunProfile:(G,Z,le,ne,de,ue)=>{let T=(0,k.$bi)(G);for(;Q.has(T);)T++;return new f(this.f,Q,V,T,G,Z,le,ne,de,ue)},createTestItem(G,Z,le){return new o.$ML(V,G,Z,le)},createTestRun:(G,Z,le=!0)=>this.g.createTestRun(V,ae,G,Z,le),invalidateTestResults:G=>{if(G===void 0)this.f.$markTestRetired(void 0);else{const Z=G instanceof Array?G:[G];this.f.$markTestRetired(Z.map(le=>a.$jI.fromExtHostTestItem(le,V).toString()))}},set resolveHandler(G){ae.resolveHandler=G},get resolveHandler(){return ae.resolveHandler},dispose:()=>{N.dispose()}};be.$registerTestController(V,U,!!O),N.add((0,$.$jb)(()=>be.$unregisterTestController(V)));const Fe={controller:ke,collection:ae,profiles:Q};return this.d.set(V,Fe),N.add((0,$.$jb)(()=>this.d.delete(V))),N.add(ae.onDidGenerateDiff(G=>be.$publishDiff(V,G.map(S.TestsDiffOp.serialize)))),ke}createTestObserver(){return this.h.checkout()}async runTests(B,V=z.CancellationToken.None){const U=p(B);if(!U)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const O=this.d.get(U.controllerId);if(!O)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:B.include?.map(N=>a.$jI.fromExtHostTestItem(N,O.collection.root.id).toString())??[O.collection.root.id],profileGroup:A[U.kind],profileId:U.profileId,controllerId:U.controllerId}],exclude:B.exclude?.map(N=>N.id)},V)}$syncTests(){for(const{collection:B}of this.d.values())B.flushDiff();return Promise.resolve()}$provideFileCoverage(B,V,U){return(0,w.$Kf)(this.g.trackers,N=>N.id===B?N.getCoverage(V):void 0)?.provideFileCoverage(U)??Promise.resolve([])}$resolveFileCoverage(B,V,U,O){return(0,w.$Kf)(this.g.trackers,ae=>ae.id===B?ae.getCoverage(V):void 0)?.resolveFileCoverage(U,O)??Promise.resolve([])}$configureRunProfile(B,V){this.d.get(B)?.profiles.get(V)?.configureHandler?.()}async $refreshTests(B,V){await this.d.get(B)?.controller.refreshHandler?.(V)}$publishTestResults(B){this.results=Object.freeze(B.map(V=>(0,R.$Gm)(t.TestResults.to(V))).concat(this.results).sort((V,U)=>U.completedAt-V.completedAt).slice(0,32)),this.c.fire()}async $expandTest(B,V){const U=this.d.get(a.$jI.fromString(B).controllerId)?.collection;U&&(await U.expand(B,V<0?1/0:V),U.flushDiff())}$acceptDiff(B){this.h.applyDiff(B.map(S.TestsDiffOp.deserialize))}async $runControllerTests(B,V){return Promise.all(B.map(U=>this.k(U,!1,V)))}async $startContinuousRun(B,V){const U=new z.$dd(V),O=await Promise.all(B.map(N=>this.k(N,!0,U.token)));return!V.isCancellationRequested&&!O.some(N=>N.error)&&await new Promise(N=>V.onCancellationRequested(N)),U.dispose(!0),O}async k(B,V,U){const O=this.d.get(B.controllerId);if(!O)return{};const{collection:N,profiles:ae}=O,Q=ae.get(B.profileId);if(!Q)return{};const be=B.testIds.map(Z=>N.tree.get(Z)).filter(E.$qe),ke=B.excludeExtIds.map(Z=>O.collection.tree.get(Z)).filter(E.$qe).filter(Z=>be.some(le=>le.fullId.compare(Z.fullId)===2));if(!be.length)return{};const Fe=new i.$9K(be.some(Z=>Z.actual instanceof o.$NL)?void 0:be.map(Z=>Z.actual),ke.map(Z=>Z.actual),Q,V),G=(0,S.$lI)(B)&&this.g.prepareForMainThreadTestRun(Fe,D.fromInternal(B,O.collection),U);try{return await Q.runHandler(Fe,U),{}}catch(Z){return{error:String(Z)}}finally{G&&(G.hasRunningTasks&&!U.isCancellationRequested&&await P.Event.toPromise(G.onEnd),G.dispose())}}$cancelExtensionTestRun(B){B===void 0?this.g.cancelAllRuns():this.g.cancelRunById(B)}};e.$qac=C,e.$qac=C=qe([Ve(0,b.$zL)],C);const r=1e4;var h;(function(W){W[W.Running=0]="Running",W[W.Cancelling=1]="Cancelling",W[W.Ended=2]="Ended"})(h||(h={}));class n extends $.$lb{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(B,V,U){super(),this.k=B,this.l=V,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$7c),this.onEnd=this.j.event,this.h=this.B(new z.$dd(U));const O=this.B(new L.$Eg(()=>this.m(),r));this.B(this.h.token.onCancellationRequested(()=>O.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(B){return this.f.get(B)?.coverage}createRun(B){const V=this.k.id,U=this.k.controllerId,O=(0,c.$5e)(),N=new l(this.l,V,O),ae=Fe=>(G,...Z)=>{if(be){console.warn(`Setting the state of test "${G.id}" is a no-op after the run ends.`);return}this.k.isIncluded(G)&&(this.s(G),Fe(G,...Z))},Q=(Fe,G)=>{const Z=G instanceof Array?G.map(t.TestMessage.from):[t.TestMessage.from(G)];if(Fe.uri&&Fe.range){const le={range:t.Range.from(Fe.range),uri:Fe.uri};for(const ne of Z)ne.location=ne.location||le}this.l.$appendTestMessagesInRun(V,O,a.$jI.fromExtHostTestItem(Fe,U).toString(),Z)};let be=!1;const ke={isPersisted:this.k.isPersisted,token:this.h.token,name:B,get coverageProvider(){return N.coverageProvider},set coverageProvider(Fe){N.coverageProvider=Fe},enqueued:ae(Fe=>{this.l.$updateTestStateInRun(V,O,a.$jI.fromExtHostTestItem(Fe,U).toString(),1)}),skipped:ae(Fe=>{this.l.$updateTestStateInRun(V,O,a.$jI.fromExtHostTestItem(Fe,U).toString(),5)}),started:ae(Fe=>{this.l.$updateTestStateInRun(V,O,a.$jI.fromExtHostTestItem(Fe,U).toString(),2)}),errored:ae((Fe,G,Z)=>{Q(Fe,G),this.l.$updateTestStateInRun(V,O,a.$jI.fromExtHostTestItem(Fe,U).toString(),6,Z)}),failed:ae((Fe,G,Z)=>{Q(Fe,G),this.l.$updateTestStateInRun(V,O,a.$jI.fromExtHostTestItem(Fe,U).toString(),4,Z)}),passed:ae((Fe,G)=>{this.l.$updateTestStateInRun(V,O,a.$jI.fromExtHostTestItem(Fe,this.k.controllerId).toString(),3,G)}),appendOutput:(Fe,G,Z)=>{be||(Z&&(this.k.isIncluded(Z)?this.s(Z):Z=void 0),this.l.$appendOutputToRun(V,O,I.$Jb.fromString(Fe),G&&t.location.from(G),Z&&a.$jI.fromExtHostTestItem(Z,U).toString()))},end:()=>{be||(be=!0,this.l.$finishedTestRunTask(V,O),this.f.delete(O),this.f.size||this.p())}};return this.f.set(O,{run:ke,coverage:N}),this.l.$startedTestRunTask(V,{id:O,name:B,running:!0}),ke}m(){for(const{run:B}of this.f.values())B.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(B){if(!(B instanceof o.$ML))throw new m.$rL(B.id);if(this.g.has(a.$jI.fromExtHostTestItem(B,this.k.controllerId).toString()))return;const V=[],U=this.k.colllection.root;for(;;){const O=t.TestItem.from(B);if(V.unshift(O),this.g.has(O.extId)||(this.g.add(O.extId),B===U))break;B=B.parent||U}this.l.$addTestsToRun(this.k.controllerId,this.k.id,V)}}class s{get trackers(){return this.c.values()}constructor(B){this.d=B,this.c=new Map}prepareForMainThreadTestRun(B,V,U){return this.f(B,V,U)}cancelRunById(B){for(const V of this.c.values())if(V.id===B){V.cancel();return}}cancelAllRuns(){for(const B of this.c.values())B.cancel()}createTestRun(B,V,U,O,N){const ae=this.c.get(U);if(ae)return ae.createRun(O);const Q=D.fromPublic(B,V,U,N),be=p(U);this.d.$startedExtensionTestRun({controllerId:B,continuous:!!U.continuous,profile:be&&{group:A[be.kind],id:be.profileId},exclude:U.exclude?.map(Fe=>a.$jI.fromExtHostTestItem(Fe,V.root.id).toString())??[],id:Q.id,include:U.include?.map(Fe=>a.$jI.fromExtHostTestItem(Fe,V.root.id).toString())??[V.root.id],persist:N});const ke=this.f(U,Q);return ke.onEnd(()=>{this.d.$finishedExtensionTestRun(Q.id),ke.dispose()}),ke.createRun(O)}f(B,V,U){const O=new n(V,this.d,U);return this.c.set(B,O),O.onEnd(()=>this.c.delete(B)),O}}e.$rac=s;const p=W=>{if(W.profile){if(!(W.profile instanceof f))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class D{static fromPublic(B,V,U,O){return new D(B,(0,c.$5e)(),U.include?.map(N=>a.$jI.fromExtHostTestItem(N,B).toString())??[B],U.exclude?.map(N=>a.$jI.fromExtHostTestItem(N,B).toString())??[],O,V)}static fromInternal(B,V){return new D(B.controllerId,B.runId,B.testIds,B.excludeExtIds,!0,V)}constructor(B,V,U,O,N,ae){this.controllerId=B,this.id=V,this.isPersisted=N,this.colllection=ae,this.c=U.map(Q=>Q+"\0"),this.d=O.map(Q=>Q+"\0")}isIncluded(B){const V=a.$jI.fromExtHostTestItem(B,this.controllerId).toString()+"\0";for(const U of this.d)if(V===U||V.startsWith(U))return!1;for(const U of this.c)if(V===U||V.startsWith(U))return!0;return!1}}e.$sac=D;class l{set coverageProvider(B){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");B&&(this.c=B,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(B,V,U){this.f=B,this.g=V,this.h=U}async provideFileCoverage(B){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(B))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(V){throw this.d=void 0,V}}async resolveFileCoverage(B,V){const U=await this.d;let O=U?.[B];return!this.c||!U||!O?[]:(O.detailedCoverage||(O=U[B]=await this.c.resolveFileCoverage?.(O,V)??O),O.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class g{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(B){this.h=B,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(B){this.c.add(B)}update(B){Object.assign(B.revived,t.TestItem.toPlain(B.item)),this.c.has(B)||this.d.add(B)}remove(B){if(this.c.has(B)){this.c.delete(B);return}this.d.delete(B);const V=a.$jI.parentId(B.item.extId);if(V&&this.g.has(V.toString())){this.g.add(B.item.extId);return}this.f.add(B)}getChangeEvent(){const{c:B,d:V,f:U}=this;return{get added(){return[...B].map(O=>O.revived)},get updated(){return[...V].map(O=>O.revived)},get removed(){return[...U].map(O=>O.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class v extends S.$qI{constructor(){super(...arguments),this.q=new P.$7c,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(B){return this.d.get(B)}getMirroredTestDataByReference(B){return this.d.get(B.id)}p(B,V){return{...B,revived:t.TestItem.toPlain(B.item),depth:V?V.depth+1:0,children:new Set}}o(){return new g(this.q)}}class u{constructor(B){this.d=B}checkout(){this.c||(this.c=this.f());const B=this.c;return B.observers++,{onDidChangeTest:B.tests.onDidChangeTests,get tests(){return[...B.tests.rootTests].map(V=>V.revived)},dispose:(0,d.$cb)(()=>{--B.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(B){return this.c?.tests.getMirroredTestDataByReference(B)}applyDiff(B){this.c?.tests.apply(B)}f(){const B=new v;return this.d.$subscribeToDiffs(),{observers:0,tests:B}}}class f{#e;#t;get label(){return this.d}set label(B){B!==this.d&&(this.d=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:B}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(B){B!==this.g&&(this.g=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:B}))}get isDefault(){return this.f}set isDefault(B){B!==this.f&&(this.f=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:B}))}get tag(){return this._tag}set tag(B){B?.id!==this._tag?.id&&(this._tag=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:B?t.TestTag.namespace(this.controllerId,B.id):null}))}get configureHandler(){return this.c}set configureHandler(B){B!==this.c&&(this.c=B,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!B}))}constructor(B,V,U,O,N,ae,Q,be=!1,ke=void 0,Fe=!1){this.controllerId=U,this.profileId=O,this.d=N,this.kind=ae,this.runHandler=Q,this.f=be,this._tag=ke,this.g=Fe,this.#e=B,this.#t=V,V.set(O,this);const G=A[ae];if(typeof G!="number")throw new Error(`Unknown TestRunProfile.group ${ae}`);this.#e.$publishTestRunProfile({profileId:O,controllerId:U,tag:ke?t.TestTag.namespace(this.controllerId,ke.id):null,label:N,group:G,isDefault:be,hasConfigurationHandler:!1,supportsContinuousRun:Fe})}dispose(){this.#t?.delete(this.profileId)&&(this.#t=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$tac=f;const A={[i.TestRunProfileKind.Coverage]:8,[i.TestRunProfileKind.Debug]:4,[i.TestRunProfileKind.Run]:2}}),define(Ae[249],Re([1,0,18,11,5,4,105,8,7]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=void 0;class ${constructor(E,c){this.i=c,this.a=new I.$7c({onListenerError:L.$Z}),this.b=new I.$7c({onListenerError:L.$Z}),this.c=new I.$7c({onListenerError:L.$Z}),this.d=new I.$7c({onListenerError:L.$Z}),this.f=new I.$7c({onListenerError:L.$Z}),this.g=new I.$7c({onListenerError:L.$Z}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=E.getProxy(z.$xJ.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(y=>this.g.fire(y)),this.i.onDidChangeActiveTextEditor(y=>this.f.fire(y))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(E){const c=this.i.allEditors();return E?c:c.map(y=>y.value)}async showTextDocument(E,c,y){let b;typeof c=="number"?b={position:d.ViewColumn.from(c),preserveFocus:y}:typeof c=="object"?b={position:d.ViewColumn.from(c.viewColumn),preserveFocus:c.preserveFocus,selection:typeof c.selection=="object"?d.Range.from(c.selection):void 0,pinned:typeof c.preview=="boolean"?!c.preview:void 0}:b={preserveFocus:!1};const o=await this.h.$tryShowTextDocument(E.uri,b),t=o&&this.i.getEditor(o);if(t)return t.value;throw o?new Error(`Could NOT open editor for "${E.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${E.uri.toString()}".`)}createTextEditorDecorationType(E,c){return new P.$GL(this.h,E,c).value}$acceptEditorPropertiesChanged(E,c){const y=this.i.getEditor(E);if(!y)throw new Error("unknown text editor");if(c.options&&y._acceptOptions(c.options),c.selections){const b=c.selections.selections.map(d.Selection.to);y._acceptSelections(b)}if(c.visibleRanges){const b=w.$lf(c.visibleRanges.map(d.Range.to));y._acceptVisibleRanges(b)}if(c.options&&this.b.fire({textEditor:y.value,options:{...c.options,lineNumbers:d.TextEditorLineNumbersStyle.to(c.options.lineNumbers)}}),c.selections){const b=k.TextEditorSelectionChangeKind.fromValue(c.selections.source),o=c.selections.selections.map(d.Selection.to);this.a.fire({textEditor:y.value,selections:o,kind:b})}if(c.visibleRanges){const b=w.$lf(c.visibleRanges.map(d.Range.to));this.c.fire({textEditor:y.value,visibleRanges:b})}}$acceptEditorPositionData(E){for(const c in E){const y=this.i.getEditor(c);if(!y)throw new Error("Unknown text editor");const b=d.ViewColumn.to(E[c]);y.value.viewColumn!==b&&(y._acceptViewColumn(b),this.d.fire({textEditor:y.value,viewColumn:b}))}}getDiffInformation(E){return Promise.resolve(this.h.$getDiffInformation(E))}}e.$I_b=$}),define(Ae[250],Re([1,0,2,3,4,6,7,8,21,12]),function($e,e,w,L,I,z,P,d,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=e.$kac=void 0,e.$kac=(0,L.$nh)("IExtHostTimeline");class R{constructor(y,b){this.b=new Map,this.c=new Map,this.a=y.getProxy(I.$xJ.MainThreadTimeline),b.registerArgumentProcessor({processArgument:(o,t)=>{if(o&&o.$mid===12)if(this.b.get(o.source)&&k.$Fl.equals(t,this.b.get(o.source)?.extension)){const i=o.uri===void 0?void 0:w.URI.revive(o.uri);return this.c.get(o.source)?.get(E(i))?.get(o.handle)}else return;return o}})}async $getTimeline(y,b,o,t){return this.b.get(y)?.provider.provideTimeline(w.URI.revive(b),o,t)}registerTimelineProvider(y,b,o,t){const i=new z.$kb,a=this.d(b.id,t,i).bind(this);let m;b.onDidChange&&(m=b.onDidChange(C=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...C,id:b.id}),this));const S=this.c;return this.f({...b,scheme:y,onDidChange:void 0,async provideTimeline(C,r,h){r?.resetCache&&(i.clear(),S.get(b.id)?.clear());const n=await b.provideTimeline(C,r,h);if(n==null)return;const s=a(C,r);return{...n,source:b.id,items:n.items.map(s)}},dispose(){for(const C of S.values())C.get(b.id)?.clear();m?.dispose(),i.dispose()}},o)}d(y,b,o){return(t,i)=>{let a;if(i?.cacheResults){let m=this.c.get(y);m===void 0&&(m=new Map,this.c.set(y,m));const S=E(t);a=m.get(S),a===void 0&&(a=new Map,m.set(S,a))}return m=>{const{iconPath:S,...C}=m,r=`${y}|${m.id??m.timestamp}`;a?.set(r,m);let h,n,s;m.iconPath&&(S instanceof P.$uK?s={id:S.id,color:S.color}:w.URI.isUri(S)?(h=S,n=S):{light:h,dark:n}=S);let p;return P.$1J.isMarkdownString(C.tooltip)?p=d.MarkdownString.from(C.tooltip):(0,$.$ie)(C.tooltip)?p=C.tooltip:P.$1J.isMarkdownString(C.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=d.MarkdownString.from(C.detail)):(0,$.$ie)(C.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),p=C.detail),{...C,id:C.id??void 0,handle:r,source:y,command:m.command?b.toInternal(m.command,o):void 0,icon:h,iconDark:n,themeIcon:s,tooltip:p,accessibilityInformation:m.accessibilityInformation}}}}f(y,b){if(this.b.get(y.id))throw new Error(`Timeline Provider ${y.id} already exists.`);return this.a.$registerTimelineProvider({id:y.id,label:y.label,scheme:y.scheme}),this.b.set(y.id,{provider:y,extension:b}),(0,z.$jb)(()=>{for(const t of this.c.values())t.get(y.id)?.clear();this.b.delete(y.id),this.a.$unregisterTimelineProvider(y.id),y.dispose()})}}e.$lac=R;function E(c){return c?.toString()}}),define(Ae[86],Re([1,0,20,5,6,157,3,14,185,4,27,17,7]),function($e,e,w,L,I,z,P,d,k,$,R,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Upb=e.$Tpb=e.TunnelDtoConverter=void 0;class y extends k.$Mz{}var b;(function(t){function i(m){return{remoteAddress:m.remoteAddress,localAddress:m.localAddress,public:!!m.public,privacy:m.privacy??(m.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:m.protocol}}t.fromApiTunnel=i;function a(m){return{remoteAddress:{host:m.tunnelRemoteHost,port:m.tunnelRemotePort},localAddress:m.localAddress,public:m.privacy!==k.TunnelPrivacyId.ConstantPrivate&&m.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:m.privacy,protocol:m.protocol}}t.fromServiceTunnel=a})(b||(e.TunnelDtoConverter=b={})),e.$Tpb=(0,P.$nh)("IExtHostTunnelService");let o=class extends I.$lb{constructor(i,a,m){super(),this.n=m,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new L.$7c,this.onDidChangeTunnels=this.h.event,this.k=0,this.l=new Map,this.a=i.getProxy($.$xJ.MainThreadTunnelService)}async openTunnel(i,a){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${i.identifier.value} called openTunnel API for ${a.remoteAddress.host}:${a.remoteAddress.port}.`);const m=await this.a.$openTunnel(a,i.displayName);if(m){const S=new y(m.remoteAddress,m.localAddress,()=>this.a.$closeTunnel(m.remoteAddress));return this.B(S),S}}async getTunnels(){return this.a.$getTunnels()}p(){return this.k++}registerPortsAttributesProvider(i,a){const m=this.p();return this.l.set(m,{selector:i,provider:a}),this.a.$registerPortsAttributesProvider(i,m),new c.$zJ(()=>{this.l.delete(m),this.a.$unregisterPortsAttributesProvider(m)})}async $providePortAttributes(i,a,m,S,C){const r=[];for(const n of i){const s=this.l.get(n);if(!s)return[];r.push(...await Promise.all(a.map(async p=>({providedAttributes:await s.provider.providePortAttributes(p,m,S,C),port:p}))))}const h=r.filter(n=>!!n.providedAttributes);return h.length>0?h.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(i){}registerTunnelProvider(i,a){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(S,C)=>await i.provideTunnel(S,C,new w.$dd().token)??void 0;const m=a.tunnelFeatures?{elevation:!!a.tunnelFeatures?.elevation,privacyOptions:a.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(m),Promise.resolve((0,I.$jb)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(i){if(i){if(i.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(i.candidatePortSource),i.showCandidatePort&&(this.f=i.showCandidatePort,this.a.$setCandidateFilter()),i.tunnelFactory){this.b=i.tunnelFactory;let a=i.tunnelFeatures?.privacyOptions??[];i.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:z.localize(0,null),themeIcon:"lock"},{id:"public",label:z.localize(1,null),themeIcon:"eye"}]);const m=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,public:!!i.tunnelFeatures?.public,privacyOptions:a}:void 0;this.a.$setTunnelProvider(m)}}else this.b=void 0;return(0,I.$jb)(()=>{this.b=void 0})}async $closeTunnel(i,a){if(this.g.has(i.host)){const m=this.g.get(i.host);m.has(i.port)&&(a&&m.get(i.port).disposeListener.dispose(),await m.get(i.port).tunnel.dispose(),m.delete(i.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(i,a){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const m=this.b(i,a);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),m!==void 0){const S=await m;if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),S===void 0){this.n.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(i.remoteAddress.host)||this.g.set(i.remoteAddress.host,new Map);const C=this.B(S.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(S.remoteAddress))));return this.g.get(i.remoteAddress.host).set(i.remoteAddress.port,{tunnel:S,disposeListener:C}),b.fromApiTunnel(S)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(i){const a=await Promise.all(i.map(S=>this.f(S.host,S.port,S.detail??""))),m=i.filter((S,C)=>a[C]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${i.map(S=>S.port).join(", ")} to ${m.map(S=>S.port).join(", ")}`),m}};e.$Upb=o,e.$Upb=o=qe([Ve(0,E.$zL),Ve(1,R.$PL),Ve(2,d.$Pi)],o)}),define(Ae[251],Re([1,0,6,13,2,4]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uac=void 0;class P{static{this.a=new Set([L.Schemas.http,L.Schemas.https])}constructor(k){this.c=new Map,this.b=k.getProxy(z.$xJ.MainThreadUriOpeners)}registerExternalUriOpener(k,$,R,E){if(this.c.has($))throw new Error(`Opener with id '${$}' already registered`);const c=E.schemes.find(y=>!P.a.has(y));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this.c.set($,R),this.b.$registerUriOpener($,E.schemes,k,E.label),(0,w.$jb)(()=>{this.c.delete($),this.b.$unregisterUriOpener($)})}async $canOpenUri(k,$,R){const E=this.c.get(k);if(!E)throw new Error(`Unknown opener with id: ${k}`);const c=I.URI.revive($);return E.canOpenExternalUri(c,R)}async $openUri(k,$,R){const E=this.c.get(k);if(!E)throw new Error(`Unknown opener id: '${k}'`);return E.openExternalUri(I.URI.revive($.resolvedUri),{sourceUri:I.URI.revive($.sourceUri)},R)}}e.$uac=P}),define(Ae[252],Re([1,0,4,2,6,11,21]),function($e,e,w,L,I,z,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K_b=void 0;class d{static{this.a=0}constructor($){this.c=new P.$Gl,this.d=new Map,this.b=$.getProxy(w.$xJ.MainThreadUrls)}registerUriHandler($,R){const E=$.identifier;if(this.c.has(E))throw new Error(`Protocol handler already registered for extension ${E}`);const c=d.a++;return this.c.add(E),this.d.set(c,R),this.b.$registerUriHandler(c,E,$.displayName||$.name),(0,I.$jb)(()=>{this.c.delete(E),this.d.delete(c),this.b.$unregisterUriHandler(c)})}$handleExternalUri($,R){const E=this.d.get($);if(!E)return Promise.resolve(void 0);try{E.handleUri(L.URI.revive(R))}catch(c){(0,z.$Y)(c)}return Promise.resolve(void 0)}async createAppUri($){return L.URI.revive(await this.b.$createAppUri($))}}e.$K_b=d}),define(Ae[64],Re([1,0,5,13,24,2,169,192,77,4]),function($e,e,w,L,I,z,P,d,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P_b=e.$O_b=e.$N_b=e.$M_b=e.$L_b=void 0;class R{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;constructor(m,S,C,r,h,n,s){this.#s="",this.#o=!1,this.#a=!1,this._onMessageEmitter=new w.$7c,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new w.$7c,this._onDidDispose=this.#h.event,this.#e=m,this.#t=S,this.#r=C,this.#l=r,this.#u=h,this.#n=n,this.#c=E(n),this.#d=c(n),this.#i=s}#h;dispose(){this.#o=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return this.#a=!0,(0,k.$dnb)(m,this.#l)}get cspSource(){const m=this.#n.extensionLocation;if(m.scheme===L.Schemas.https||m.scheme===L.Schemas.http){let S=m.toString();return S.endsWith("/")||(S+="/"),S+" "+k.$cnb}return k.$cnb}get html(){return this.a(),this.#s}set html(m){this.a(),this.#s!==m&&(this.#s=m,this.#d&&!this.#a&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(this.#a=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(m)))}get options(){return this.a(),this.#r}set options(m){this.a(),I.$Jm(this.#r,m)||this.#t.$setOptions(this.#e,o(this.#n,this.#u,m)),this.#r=m}async postMessage(m){if(this.#o)return!1;const S=(0,d.$20)(m,{serializeBuffersForPostMessage:this.#c});return this.#t.$postMessage(this.#e,S.message,...S.buffers)}a(){if(this.#o)throw new Error("Webview is disposed")}b(m){if(!this.#d)return m;const S=this.#n.extensionLocation?.scheme===L.Schemas.vscodeRemote,C=this.#n.extensionLocation.scheme===L.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return m.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,n,s,p,D)=>{const l=z.URI.from({scheme:s||"file",path:decodeURIComponent(p)}),g=(0,k.$dnb)(l,{isRemote:S,authority:C}).toString();return`${h}${g}${D}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,n,s,p,D)=>{const l=z.URI.from({scheme:s||"file",path:decodeURIComponent(p)}),g=(0,k.$dnb)(l,{isRemote:S,authority:C}).toString();return`${h}${g}${D}`})}}e.$L_b=R;function E(a){try{const m=(0,P.$ro)((0,P.$qo)(a.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.$M_b=E;function c(a){try{const m=(0,P.$ro)((0,P.$qo)(a.engines.vscode));return m?m.majorBase<1||m.majorBase===1&&m.minorBase<60:!1}catch{return!1}}class y{constructor(m,S,C,r,h){this.c=S,this.d=C,this.e=r,this.f=h,this.b=new Map,this.a=m.getProxy($.$xJ.MainThreadWebviews)}$onMessage(m,S,C){const r=this.g(m);if(r){const{message:h}=(0,d.$30)(S,C.value);r._onMessageEmitter.fire(h)}}$onMissingCsp(m,S){this.e.warn(`${S} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,S,C){const r=new R(m,this.a,t(S),this.c,this.d,C,this.f);return this.b.set(m,r),r._onDidDispose(()=>{this.b.delete(m)}),r}deleteWebview(m){this.b.delete(m)}g(m){return this.b.get(m)}}e.$N_b=y;function b(a){return{id:a.identifier,location:a.extensionLocation}}e.$O_b=b;function o(a,m,S){return{enableCommandUris:S.enableCommandUris,enableScripts:S.enableScripts,enableForms:S.enableForms,portMapping:S.portMapping,localResourceRoots:S.localResourceRoots||i(a,m)}}e.$P_b=o;function t(a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots?.map(m=>z.URI.from(m))}}function i(a,m){return[...(m?.getWorkspaceFolders()||[]).map(S=>S.uri),a.extensionLocation]}}),define(Ae[253],Re([1,0,20,93,6,13,23,2,8,64,55,4,7]),function($e,e,w,L,I,z,P,d,k,$,R,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;class y{constructor(h,n){this.document=h,this.b=n,this.a=1,this.c=new R.$H$b("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,n){await this.f(h).undo(),n||this.disposeBackup()}async redo(h,n){await this.f(h).redo(),n||this.disposeBackup()}disposeEdits(h){for(const n of h)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=C(this.document.uri)+this.a++;return(0,P.$8f)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const n=this.c.get(h,0);if(!n)throw new Error("No edit found");return n}}class b{constructor(){this.a=new Map}get(h,n){return this.a.get(this.b(h,n))}add(h,n,s){const p=this.b(h,n.uri);if(this.a.has(p))throw new Error(`Document already exists for viewType:${h} resource:${n.uri}`);const D=new y(n,s);return this.a.set(p,D),D}delete(h,n){const s=this.b(h,n.uri);this.a.delete(s)}b(h,n){return`${h}@@@${n}`}}var o;(function(r){r[r.Text=0]="Text",r[r.Custom=1]="Custom"})(o||(o={}));class t{constructor(){this.a=new Map}addTextProvider(h,n,s){return this.b(0,h,n,s)}addCustomProvider(h,n,s){return this.b(1,h,n,s)}get(h){return this.a.get(h)}b(h,n,s,p){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:h,extension:s,provider:p}),new c.$zJ(()=>this.a.delete(n))}}class i{constructor(h,n,s,p,D){this.d=n,this.f=s,this.g=p,this.h=D,this.b=new t,this.c=new b,this.a=h.getProxy(E.$xJ.MainThreadCustomEditors)}registerCustomEditorProvider(h,n,s,p){const D=new I.$kb;return m(s)?(D.add(this.b.addTextProvider(n,h,s)),this.a.$registerTextEditorProvider((0,$.$O_b)(h),n,p.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,$.$M_b)(h))):(D.add(this.b.addCustomProvider(n,h,s)),a(s)&&D.add(s.onDidChangeCustomDocument(l=>{const g=this.i(n,l.document.uri);if(S(l)){const v=g.addEdit(l);this.a.$onDidEdit(l.document.uri,n,v,l.label)}else this.a.$onContentChange(l.document.uri,n)})),this.a.$registerCustomEditorProvider((0,$.$O_b)(h),n,p.webviewOptions||{},!!p.supportsMultipleEditorsPerDocument,(0,$.$M_b)(h))),c.$zJ.from(D,new c.$zJ(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(h,n,s,p,D){const l=this.b.get(n);if(!l)throw new Error(`No provider found for '${n}'`);if(l.type!==1)throw new Error(`Invalid provide type for '${n}'`);const g=d.URI.revive(h),v=await l.provider.openCustomDocument(g,{backupId:s,untitledDocumentData:p?.buffer},D);let u;return a(l.provider)&&this.f&&(u=this.f.workspaceValue(l.extension)??this.f.globalValue(l.extension)),this.c.add(n,v,u),{editable:a(l.provider)}}async $disposeCustomDocument(h,n){const s=this.b.get(n);if(!s)throw new Error(`No provider found for '${n}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${n}'`);const p=d.URI.revive(h),{document:D}=this.i(n,p);this.c.delete(n,D),D.dispose()}async $resolveCustomEditor(h,n,s,p,D,l){const g=this.b.get(s);if(!g)throw new Error(`No provider found for '${s}'`);const v=k.ViewColumn.to(D),u=this.g.createNewWebview(n,p.contentOptions,g.extension),f=this.h.createNewWebviewPanel(n,s,p.title,v,p.options,u,p.active),A=d.URI.revive(h);switch(g.type){case 1:{const{document:W}=this.i(s,A);return g.provider.resolveCustomEditor(W,f,l)}case 0:{const W=this.d.getDocument(A);return g.provider.resolveCustomTextEditor(W,f,l)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,n,s){this.i(n,h).disposeEdits(s)}async $onMoveCustomEditor(h,n,s){const p=this.b.get(s);if(!p)throw new Error(`No provider found for '${s}'`);if(!p.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const D=this.h.getWebviewPanel(h);if(!D)throw new Error("No webview found");const l=d.URI.revive(n),g=this.d.getDocument(l);await p.provider.moveCustomTextEditor(g,D,w.CancellationToken.None)}async $undo(h,n,s,p){return this.i(n,h).undo(s,p)}async $redo(h,n,s,p){return this.i(n,h).redo(s,p)}async $revert(h,n,s){const p=this.i(n,h);await this.j(n).revertCustomDocument(p.document,s),p.disposeBackup()}async $onSave(h,n,s){const p=this.i(n,h);await this.j(n).saveCustomDocument(p.document,s),p.disposeBackup()}async $onSaveAs(h,n,s,p){const D=this.i(n,h);return this.j(n).saveCustomDocumentAs(D.document,d.URI.revive(s),p)}async $backup(h,n,s){const p=this.i(n,h),l=await this.j(n).backupCustomDocument(p.document,{destination:p.getNewBackupUri()},s);return p.updateBackup(l),l.id}i(h,n){const s=this.c.get(h,d.URI.revive(n));if(!s)throw new Error("No custom document found");return s}j(h){const s=this.b.get(h)?.provider;if(!s||!a(s))throw new Error("Custom document is not editable");return s}}e.$oac=i;function a(r){return!!r.onDidChangeCustomDocument}function m(r){return typeof r.resolveCustomTextEditor=="function"}function S(r){return typeof r.undo=="function"&&typeof r.redo=="function"}function C(r){const h=r.scheme===z.Schemas.file||r.scheme===z.Schemas.untitled?r.fsPath:r.toString();return(0,L.$bi)(h)+""}}),define(Ae[254],Re([1,0,5,6,2,36,8,64,4,7]),function($e,e,w,L,I,z,P,d,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=void 0;class R extends L.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;#a;#c;#d;#h;constructor(b,o,t,i){super(),this.#r=void 0,this.#o=!0,this.#c=!1,this.#d=this.B(new w.$7c),this.onDidDispose=this.#d.event,this.#h=this.B(new w.$7c),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=o,this.#l=t,this.#i=i.viewType,this.#u=i.panelOptions,this.#r=i.viewColumn,this.#n=i.title,this.#a=i.active}dispose(){this.#c||(this.#c=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#l.dispose(),super.dispose())}get webview(){return this.c(),this.#l}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(b){this.c(),this.#n!==b&&(this.#n=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#s}set iconPath(b){this.c(),this.#s!==b&&(this.#s=b,this.#t.$setIconPath(this.#e,I.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#u}get viewColumn(){if(this.c(),!(typeof this.#r=="number"&&this.#r<0))return this.#r}get active(){return this.c(),this.#a}get visible(){return this.c(),this.#o}_updateViewState(b){this.#c||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#a=b.active,this.#o=b.visible,this.#r=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,o){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:P.ViewColumn.from(b),preserveFocus:!!o})}c(){if(this.#c)throw new Error("Webview is disposed")}}class E{static c(){return(0,z.$5e)()}constructor(b,o,t){this.g=o,this.h=t,this.e=new Map,this.f=new Map,this.d=b.getProxy(k.$xJ.MainThreadWebviewPanels)}createWebviewPanel(b,o,t,i,a={}){const m=typeof i=="object"?i.viewColumn:i,S={viewColumn:P.ViewColumn.from(m),preserveFocus:typeof i=="object"&&!!i.preserveFocus},C=(0,d.$M_b)(b),r=E.c();this.d.$createWebviewPanel((0,d.$O_b)(b),r,o,{title:t,panelOptions:c(a),webviewOptions:(0,d.$P_b)(b,this.h,a),serializeBuffersForPostMessage:C},S);const h=this.g.createNewWebview(r,a,b);return this.createNewWebviewPanel(r,o,t,m,a,h,!0)}$onDidChangeWebviewPanelViewStates(b){const o=Object.keys(b);o.sort((t,i)=>{const a=b[t],m=b[i];return a.active?1:m.active?-1:+a.visible-+m.visible});for(const t of o){const i=this.getWebviewPanel(t);if(!i)continue;const a=b[t];i._updateViewState({active:a.active,visible:a.visible,viewColumn:P.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.e.delete(b),this.g.deleteWebview(b)}registerWebviewPanelSerializer(b,o,t){if(this.f.has(o))throw new Error(`Serializer for '${o}' already registered`);return this.f.set(o,{serializer:t,extension:b}),this.d.$registerSerializer(o,{serializeBuffersForPostMessage:(0,d.$M_b)(b)}),new $.$zJ(()=>{this.f.delete(o),this.d.$unregisterSerializer(o)})}async $deserializeWebviewPanel(b,o,t,i){const a=this.f.get(o);if(!a)throw new Error(`No serializer found for '${o}'`);const{serializer:m,extension:S}=a,C=this.g.createNewWebview(b,t.webviewOptions,S),r=this.createNewWebviewPanel(b,o,t.title,i,t.panelOptions,C,t.active);await m.deserializeWebviewPanel(r,t.state)}createNewWebviewPanel(b,o,t,i,a,m,S){const C=new R(b,this.d,m,{viewType:o,title:t,viewColumn:i,panelOptions:a,active:S});return this.e.set(b,C),C}getWebviewPanel(b){return this.e.get(b)}}e.$nac=E;function c(y){return{enableFindWidget:y.enableFindWidget,retainContextWhenHidden:y.retainContextWhenHidden}}}),define(Ae[255],Re([1,0,5,6,64,8,4,7]),function($e,e,w,L,I,z,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mac=void 0;class k extends L.$lb{#e;#t;#i;#l;#u;#n;#s;#r;#o;constructor(E,c,y,b,o,t){super(),this.#u=!1,this.#a=this.B(new w.$7c),this.onDidChangeVisibility=this.#a.event,this.#c=this.B(new w.$7c),this.onDidDispose=this.#c.event,this.#i=y,this.#s=b,this.#e=E,this.#t=c,this.#l=o,this.#n=t}dispose(){this.#u||(this.#u=!0,this.#c.fire(),this.#l.dispose(),super.dispose())}#a;#c;get title(){return this.a(),this.#s}set title(E){this.a(),this.#s!==E&&(this.#s=E,this.#t.$setWebviewViewTitle(this.#e,E))}get description(){return this.a(),this.#r}set description(E){this.a(),this.#r!==E&&(this.#r=E,this.#t.$setWebviewViewDescription(this.#e,E))}get visible(){return this.#n}get webview(){return this.#l}get viewType(){return this.#i}_setVisible(E){E===this.#n||this.#u||(this.#n=E,this.#a.fire())}get badge(){return this.a(),this.#o}set badge(E){this.a(),!(E?.value===this.#o?.value&&E?.tooltip===this.#o?.tooltip)&&(this.#o=z.ViewBadge.from(E),this.#t.$setWebviewViewBadge(this.#e,E))}show(E){this.a(),this.#t.$show(this.#e,!!E)}a(){if(this.#u)throw new Error("Webview is disposed")}}class ${constructor(E,c){this.d=c,this.b=new Map,this.c=new Map,this.a=E.getProxy(P.$xJ.MainThreadWebviewViews)}registerWebviewViewProvider(E,c,y,b){if(this.b.has(c))throw new Error(`View provider for '${c}' already registered`);return this.b.set(c,{provider:y,extension:E}),this.a.$registerWebviewViewProvider((0,I.$O_b)(E),c,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$M_b)(E)}),new d.$zJ(()=>{this.b.delete(c),this.a.$unregisterWebviewViewProvider(c)})}async $resolveWebviewView(E,c,y,b,o){const t=this.b.get(c);if(!t)throw new Error(`No view provider found for '${c}'`);const{provider:i,extension:a}=t,m=this.d.createNewWebview(E,{},a),S=new k(E,this.a,c,y,m,!0);this.c.set(E,S),await i.resolveWebviewView(S,{state:b},o)}async $onDidChangeWebviewViewVisibility(E,c){this.e(E)._setVisible(c)}async $disposeWebviewView(E){const c=this.e(E);this.c.delete(E),c.dispose(),this.d.deleteWebview(E)}e(E){const c=this.c.get(E);if(!c)throw new Error("No webview found");return c}}e.$mac=$}),define(Ae[108],Re([1,0,5,4,2,13,15,3,17,26]),function($e,e,w,L,I,z,P,d,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$R_b=e.$Q_b=void 0;let R=class kn{static{this.a={focused:!0,active:!0}}getState(c){const y=this.d;return{get focused(){return y.focused},get active(){return(0,$.$wF)(c,"windowActivity"),y.active}}}constructor(c){this.c=new w.$7c,this.onDidChangeWindowState=this.c.event,this.d=kn.a,this.b=c.getProxy(L.$xJ.MainThreadWindow),this.b.$getInitialState().then(({isFocused:y,isActive:b})=>{this.onDidChangeWindowProperty("focused",y),this.onDidChangeWindowProperty("active",b)})}$onDidChangeWindowFocus(c){this.onDidChangeWindowProperty("focused",c)}$onDidChangeWindowActive(c){this.onDidChangeWindowProperty("active",c)}onDidChangeWindowProperty(c,y){y!==this.d[c]&&(this.d={...this.d,[c]:y},this.c.fire(this.d))}openUri(c,y){let b;if(typeof c=="string"){b=c;try{c=I.URI.parse(c)}catch{return Promise.reject(`Invalid uri - '${c}'`)}}return(0,P.$jd)(c.scheme)?Promise.reject("Invalid scheme - cannot be empty"):c.scheme===z.Schemas.command?Promise.reject(`Invalid scheme '${c.scheme}'`):this.b.$openUri(c,b,y)}async asExternalUri(c,y){if((0,P.$jd)(c.scheme))return Promise.reject("Invalid scheme - cannot be empty");const b=await this.b.$asExternalUri(c,y);return I.URI.from(b)}};e.$Q_b=R,e.$Q_b=R=qe([Ve(0,k.$zL)],R),e.$R_b=(0,d.$nh)("IExtHostWindow")}),define(Ae[256],Re([1,0,223,27,17]),function($e,e,w,L,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;let z=class extends w.$Lac{constructor(d,k){super(d,k)}f(d,k,$){k.apply(console,$)}};e.$Rcc=z,e.$Rcc=z=qe([Ve(0,I.$zL),Ve(1,L.$PL)],z)}),define(Ae[257],Re([1,0,16,25,20,11,5,6,132,216,46]),function($e,e,w,L,I,z,P,d,k,$,R){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$t1b=e.ResponsiveState=e.RequestInitiator=e.$s1b=e.$r1b=void 0;function c(u,f){try{return JSON.stringify(u,f)}catch{return"null"}}const y="$$ref$$",b={[y]:-1};class o{constructor(f,A){this.jsonString=f,this.referencedBuffers=A}}function t(u,f=null,A=!1){const W=[];return{jsonString:(A?c:JSON.stringify)(u,(V,U)=>{if(typeof U>"u")return b;if(typeof U=="object"){if(U instanceof L.$Jb){const O=W.push(U)-1;return{[y]:O}}if(f)return f(V,U)}return U}),referencedBuffers:W}}e.$r1b=t;function i(u,f,A){return JSON.parse(u,(W,B)=>{if(B){const V=B[y];if(typeof V=="number")return f[V];if(A&&B.$mid===1)return A.transformIncoming(B)}return B})}e.$s1b=i;function a(u,f){return JSON.stringify(u,f)}function m(u){return u?(f,A)=>A&&A.$mid===1?u.transformOutgoing(A):A:null}var S;(function(u){u[u.LocalSide=0]="LocalSide",u[u.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));var C;(function(u){u[u.Responsive=0]="Responsive",u[u.Unresponsive=1]="Unresponsive"})(C||(e.ResponsiveState=C={}));const r=()=>{},h=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class s extends d.$lb{static{E=h}static{this.a=3*1e3}constructor(f,A=null,W=null){super(),this[E]=!0,this.b=this.B(new P.$7c),this.onDidChangeResponsiveState=this.b.event,this.c=f,this.f=A,this.g=W,this.h=m(this.g),this.j=!1,this.k=[],this.l=[];for(let B=0,V=R.$Tz.count;B<V;B++)this.k[B]=null,this.l[B]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new w.$Eg(()=>this.C(),1e3)),this.c.onMessage(B=>this.G(B))}dispose(){this.j=!0,Object.keys(this.s).forEach(f=>{this.s[f].resolveErr(z.$4())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(f){this.u===0&&(this.v=Date.now()+s.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(f){this.v=Date.now()+s.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(f){this.t!==f&&(this.t=f,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(f){return this.g?(0,k.$om)(f,this.g):f}getProxy(f){const{nid:A,sid:W}=f;return this.l[A]||(this.l[A]=this.F(A,W)),this.l[A]}F(f,A){const W={get:(B,V)=>(typeof V=="string"&&!B[V]&&V.charCodeAt(0)===36&&(B[V]=(...U)=>this.O(f,V,U)),V===n?A:B[V])};return new Proxy(Object.create(null),W)}set(f,A){return this.k[f.nid]=A,A}assertRegistered(f){for(let A=0,W=f.length;A<W;A++){const B=f[A];if(!this.k[B.nid])throw new Error(`Missing proxy instance ${B.sid}`)}}G(f){if(this.j)return;const A=f.byteLength,W=p.read(f,0),B=W.readUInt8(),V=W.readUInt32();switch(B){case 1:case 2:{let{rpcId:U,method:O,args:N}=l.deserializeRequestJSONArgs(W);this.g&&(N=(0,k.$om)(N,this.g)),this.H(A,V,U,O,N,B===2);break}case 3:case 4:{let{rpcId:U,method:O,args:N}=l.deserializeRequestMixedArgs(W);this.g&&(N=(0,k.$om)(N,this.g)),this.H(A,V,U,O,N,B===4);break}case 5:{this.f?.logIncoming(A,V,0,"ack"),this.z(V);break}case 6:{this.I(A,V);break}case 7:{this.J(A,V,void 0);break}case 9:{let U=l.deserializeReplyOKJSON(W);this.g&&(U=(0,k.$om)(U,this.g)),this.J(A,V,U);break}case 10:{const U=l.deserializeReplyOKJSONWithBuffers(W,this.g);this.J(A,V,U);break}case 8:{const U=l.deserializeReplyOKVSBuffer(W);this.J(A,V,U);break}case 11:{let U=l.deserializeReplyErrError(W);this.g&&(U=(0,k.$om)(U,this.g)),this.L(A,V,U);break}case 12:{this.L(A,V,void 0);break}default:console.error("received unexpected message"),console.error(f)}}H(f,A,W,B,V,U){this.f?.logIncoming(f,A,1,`receiveRequest ${(0,R.$Vz)(W)}.${B}(`,V);const O=String(A);let N,ae;if(U){const be=new I.$dd;V.push(be.token),N=this.M(W,B,V),ae=()=>be.cancel()}else N=this.M(W,B,V),ae=r;this.p[O]=ae;const Q=l.serializeAcknowledged(A);this.f?.logOutgoing(Q.byteLength,A,1,"ack"),this.c.send(Q),N.then(be=>{delete this.p[O];const ke=l.serializeReplyOK(A,be,this.h);this.f?.logOutgoing(ke.byteLength,A,1,"reply:",be),this.c.send(ke)},be=>{delete this.p[O];const ke=l.serializeReplyErr(A,be);this.f?.logOutgoing(ke.byteLength,A,1,"replyErr:",be),this.c.send(ke)})}I(f,A){this.f?.logIncoming(f,A,1,"receiveCancel");const W=String(A);this.p[W]?.()}J(f,A,W){this.f?.logIncoming(f,A,0,"receiveReply:",W);const B=String(A);if(!this.s.hasOwnProperty(B))return;const V=this.s[B];delete this.s[B],V.resolveOk(W)}L(f,A,W){this.f?.logIncoming(f,A,0,"receiveReplyErr:",W);const B=String(A);if(!this.s.hasOwnProperty(B))return;const V=this.s[B];delete this.s[B];let U;W&&(W.$isError?(U=new Error,U.name=W.name,U.message=W.message,U.stack=W.stack):U=W),V.resolveErr(U)}M(f,A,W){try{return Promise.resolve(this.N(f,A,W))}catch(B){return Promise.reject(B)}}N(f,A,W){const B=this.k[f];if(!B)throw new Error("Unknown actor "+(0,R.$Vz)(f));const V=B[A];if(typeof V!="function")throw new Error("Unknown method "+A+" on actor "+(0,R.$Vz)(f));return V.apply(B,W)}O(f,A,W){if(this.j)return new $.$q1b;let B=null;if(W.length>0&&I.CancellationToken.isCancellationToken(W[W.length-1])&&(B=W.pop()),B&&B.isCancellationRequested)return Promise.reject(z.$4());const V=l.serializeRequestArguments(W,this.h),U=++this.m,O=String(U),N=new $.$p1b;B&&B.onCancellationRequested(()=>{const Q=l.serializeCancel(U);this.f?.logOutgoing(Q.byteLength,U,0,"cancel"),this.c.send(l.serializeCancel(U))}),this.s[O]=N,this.y(U);const ae=l.serializeRequest(U,f,A,V,!!B);return this.f?.logOutgoing(ae.byteLength,U,0,`request: ${(0,R.$Vz)(f)}.${A}(`,W),this.c.send(ae),N}}e.$t1b=s;class p{static alloc(f,A,W){const B=new p(L.$Jb.alloc(W+1+4),0);return B.writeUInt8(f),B.writeUInt32(A),B}static read(f,A){return new p(f,A)}get buffer(){return this.a}constructor(f,A){this.a=f,this.b=A}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(f){this.a.writeUInt8(f,this.b),this.b+=1}readUInt8(){const f=this.a.readUInt8(this.b);return this.b+=1,f}writeUInt32(f){this.a.writeUInt32BE(f,this.b),this.b+=4}readUInt32(){const f=this.a.readUInt32BE(this.b);return this.b+=4,f}static sizeShortString(f){return 1+f.byteLength}writeShortString(f){this.a.writeUInt8(f.byteLength,this.b),this.b+=1,this.a.set(f,this.b),this.b+=f.byteLength}readShortString(){const f=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+f).toString();return this.b+=f,W}static sizeLongString(f){return 4+f.byteLength}writeLongString(f){this.a.writeUInt32BE(f.byteLength,this.b),this.b+=4,this.a.set(f,this.b),this.b+=f.byteLength}readLongString(){const f=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+f).toString();return this.b+=f,W}writeBuffer(f){this.a.writeUInt32BE(f.byteLength,this.b),this.b+=4,this.a.set(f,this.b),this.b+=f.byteLength}static sizeVSBuffer(f){return 4+f.byteLength}writeVSBuffer(f){this.a.writeUInt32BE(f.byteLength,this.b),this.b+=4,this.a.set(f,this.b),this.b+=f.byteLength}readVSBuffer(){const f=this.a.readUInt32BE(this.b);this.b+=4;const A=this.a.slice(this.b,this.b+f);return this.b+=f,A}static sizeMixedArray(f){let A=0;A+=1;for(let W=0,B=f.length;W<B;W++){const V=f[W];switch(A+=1,V.type){case 1:A+=this.sizeLongString(V.value);break;case 2:A+=this.sizeVSBuffer(V.value);break;case 3:A+=this.sizeUInt32,A+=this.sizeLongString(V.value);for(let U=0;U<V.buffers.length;++U)A+=this.sizeVSBuffer(V.buffers[U]);break;case 4:break}}return A}writeMixedArray(f){this.a.writeUInt8(f.length,this.b),this.b+=1;for(let A=0,W=f.length;A<W;A++){const B=f[A];switch(B.type){case 1:this.writeUInt8(1),this.writeLongString(B.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(B.value);break;case 3:this.writeUInt8(3),this.writeUInt32(B.buffers.length),this.writeLongString(B.value);for(let V=0;V<B.buffers.length;++V)this.writeBuffer(B.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const f=this.a.readUInt8(this.b);this.b+=1;const A=new Array(f);for(let W=0;W<f;W++)switch(this.readUInt8()){case 1:A[W]=this.readLongString();break;case 2:A[W]=this.readVSBuffer();break;case 3:{const V=this.readUInt32(),U=this.readLongString(),O=[];for(let N=0;N<V;++N)O.push(this.readVSBuffer());A[W]=new R.$Wz(i(U,O,null));break}case 4:A[W]=void 0;break}return A}}var D;(function(u){u[u.Simple=0]="Simple",u[u.Mixed=1]="Mixed"})(D||(D={}));class l{static a(f){for(let A=0,W=f.length;A<W;A++)if(f[A]instanceof L.$Jb||f[A]instanceof R.$Wz||typeof f[A]>"u")return!0;return!1}static serializeRequestArguments(f,A){if(this.a(f)){const W=[];for(let B=0,V=f.length;B<V;B++){const U=f[B];if(U instanceof L.$Jb)W[B]={type:2,value:U};else if(typeof U>"u")W[B]={type:4};else if(U instanceof R.$Wz){const{jsonString:O,referencedBuffers:N}=t(U.value,A);W[B]={type:3,value:L.$Jb.fromString(O),buffers:N}}else W[B]={type:1,value:L.$Jb.fromString(a(U,A))}}return{type:1,args:W}}return{type:0,args:a(f,A)}}static serializeRequest(f,A,W,B,V){switch(B.type){case 0:return this.b(f,A,W,B.args,V);case 1:return this.c(f,A,W,B.args,V)}}static b(f,A,W,B,V){const U=L.$Jb.fromString(W),O=L.$Jb.fromString(B);let N=0;N+=p.sizeUInt8(),N+=p.sizeShortString(U),N+=p.sizeLongString(O);const ae=p.alloc(V?2:1,f,N);return ae.writeUInt8(A),ae.writeShortString(U),ae.writeLongString(O),ae.buffer}static deserializeRequestJSONArgs(f){const A=f.readUInt8(),W=f.readShortString(),B=f.readLongString();return{rpcId:A,method:W,args:JSON.parse(B)}}static c(f,A,W,B,V){const U=L.$Jb.fromString(W);let O=0;O+=p.sizeUInt8(),O+=p.sizeShortString(U),O+=p.sizeMixedArray(B);const N=p.alloc(V?4:3,f,O);return N.writeUInt8(A),N.writeShortString(U),N.writeMixedArray(B),N.buffer}static deserializeRequestMixedArgs(f){const A=f.readUInt8(),W=f.readShortString(),B=f.readMixedArray(),V=new Array(B.length);for(let U=0,O=B.length;U<O;U++){const N=B[U];typeof N=="string"?V[U]=JSON.parse(N):V[U]=N}return{rpcId:A,method:W,args:V}}static serializeAcknowledged(f){return p.alloc(5,f,0).buffer}static serializeCancel(f){return p.alloc(6,f,0).buffer}static serializeReplyOK(f,A,W){if(typeof A>"u")return this.d(f);if(A instanceof L.$Jb)return this.e(f,A);if(A instanceof R.$Wz){const{jsonString:B,referencedBuffers:V}=t(A.value,W,!0);return this.g(f,B,V)}else return this.f(f,c(A,W))}static d(f){return p.alloc(7,f,0).buffer}static e(f,A){let W=0;W+=p.sizeVSBuffer(A);const B=p.alloc(8,f,W);return B.writeVSBuffer(A),B.buffer}static deserializeReplyOKVSBuffer(f){return f.readVSBuffer()}static f(f,A){const W=L.$Jb.fromString(A);let B=0;B+=p.sizeLongString(W);const V=p.alloc(9,f,B);return V.writeLongString(W),V.buffer}static g(f,A,W){const B=L.$Jb.fromString(A);let V=0;V+=p.sizeUInt32,V+=p.sizeLongString(B);for(const O of W)V+=p.sizeVSBuffer(O);const U=p.alloc(10,f,V);U.writeUInt32(W.length),U.writeLongString(B);for(const O of W)U.writeBuffer(O);return U.buffer}static deserializeReplyOKJSON(f){const A=f.readLongString();return JSON.parse(A)}static deserializeReplyOKJSONWithBuffers(f,A){const W=f.readUInt32(),B=f.readLongString(),V=[];for(let U=0;U<W;++U)V.push(f.readVSBuffer());return new R.$Wz(i(B,V,A))}static serializeReplyErr(f,A){const W=A?c(z.$1(A),null):void 0;if(typeof W!="string")return this.h(f);const B=L.$Jb.fromString(W);let V=0;V+=p.sizeLongString(B);const U=p.alloc(11,f,V);return U.writeLongString(B),U.buffer}static deserializeReplyErrError(f){const A=f.readLongString();return JSON.parse(A)}static h(f){return p.alloc(12,f,0).buffer}}var g;(function(u){u[u.RequestJSONArgs=1]="RequestJSONArgs",u[u.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",u[u.RequestMixedArgs=3]="RequestMixedArgs",u[u.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",u[u.Acknowledged=5]="Acknowledged",u[u.Cancel=6]="Cancel",u[u.ReplyOKEmpty=7]="ReplyOKEmpty",u[u.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",u[u.ReplyOKJSON=9]="ReplyOKJSON",u[u.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",u[u.ReplyErrError=11]="ReplyErrError",u[u.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var v;(function(u){u[u.String=1]="String",u[u.VSBuffer=2]="VSBuffer",u[u.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",u[u.Undefined=4]="Undefined"})(v||(v={}))}),define(Ae[258],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;const w=function(z){const P=d=>{globalThis.removeEventListener("message",P);const k=d.data;Object.defineProperties(globalThis,{postMessage:{value($,R){k.postMessage($,R)}},onmessage:{get(){return k.onmessage},set($){k.onmessage=$}}}),k.addEventListener("message",$=>{globalThis.dispatchEvent(new MessageEvent("message",{data:$.data,ports:$.ports?[...$.ports]:void 0}))}),k.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(z)};globalThis.addEventListener("message",P)}.toString();class L extends EventTarget{constructor(z,P,d){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const k=`((${w})('${P}'))`,$=new Blob([k],{type:"application/javascript"}),R=URL.createObjectURL($),E=new MessageChannel,c=R,y={type:"_newWorker",id:c,port:E.port2,url:R,options:d};z(y,[E.port2]),this.postMessage=E.port1.postMessage.bind(E.port1),this.terminate=()=>{z({type:"_terminateWorker",id:c}),URL.revokeObjectURL(R),E.port1.close(),E.port2.close()},Object.defineProperties(this,{onmessage:{get(){return E.port1.onmessage},set(b){E.port1.onmessage=b}},onmessageerror:{get(){return E.port1.onmessageerror},set(b){E.port1.onmessageerror=b}}}),E.port1.addEventListener("messageerror",b=>{const o=new MessageEvent("messageerror",{data:b.data});this.dispatchEvent(o)}),E.port1.addEventListener("message",b=>{const o=new MessageEvent("message",{data:b.data});this.dispatchEvent(o)}),E.port1.start()}}e.$Tcc=L}),define(Ae[259],Re([1,0,5,30,31,3]),function($e,e,w,L,I,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.$LI=e.OutputChannelUpdateMode=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=void 0,e.$AI="text/x-code-output",e.$BI="output",e.$CI="Log",e.$DI="text/x-code-log-output",e.$EI="log",e.$FI="log",e.$GI="workbench.panel.output",e.$HI=new I.$Mi("inOutput",!1),e.$II=new I.$Mi("activeLogOutput",!1),e.$JI=new I.$Mi("outputView.scrollLock",!1),e.$KI=(0,z.$nh)("outputService");var P;(function(k){k[k.Append=1]="Append",k[k.Replace=2]="Replace",k[k.Clear=3]="Clear"})(P||(e.OutputChannelUpdateMode=P={})),e.$LI={OutputChannels:"workbench.contributions.outputChannels"};class d{constructor(){this.a=new Map,this.b=new w.$7c,this.onDidRegisterChannel=this.b.event,this.c=new w.$7c,this.onDidRemoveChannel=this.c.event}registerChannel($){this.a.has($.id)||(this.a.set($.id,$),this.b.fire($.id))}getChannels(){const $=[];return this.a.forEach(R=>$.push(R)),$}getChannel($){return this.a.get($)}removeChannel($){this.a.delete($),this.c.fire($)}}L.$Rm.add(e.$LI.OutputChannels,new d),e.$MI=new I.$Mi("activeOutputChannel","")}),define(Ae[109],Re([1,0,4,3,17,21,14,259,62,27,39,129,25,12,38,5,6]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=e.$A_b=void 0;class i extends P.$Vi{get disposed(){return this.l}constructor(C,r,h,n,s){super(),this.id=C,this.name=r,this.m=h,this.n=n,this.extension=s,this.k=0,this.l=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(p=>this.setLevel(p)))}get logLevel(){return this.getLevel()}appendLine(C){this.append(C+`
`)}append(C){this.info(C)}clear(){const C=this.k;this.m.flush(),this.n.$update(this.id,d.OutputChannelUpdateMode.Clear,C)}replace(C){const r=this.k;this.info(C),this.n.$update(this.id,d.OutputChannelUpdateMode.Replace,r),this.visible&&this.m.flush()}show(C,r){this.m.flush(),this.n.$reveal(this.id,!!(typeof C=="boolean"?C:r))}hide(){this.n.$close(this.id)}g(C,r){this.k+=c.$Jb.fromString(r).byteLength,(0,P.log)(this.m,C,r),this.visible&&(this.m.flush(),this.n.$update(this.id,d.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class a extends i{appendLine(C){this.append(C)}}let m=class{constructor(C,r,h,n,s,p){this.i=r,this.j=h,this.k=n,this.l=s,this.m=p,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=C.getProxy(w.$xJ.MainThreadOutputService),this.b=this.k.extUri.joinPath(r.logsLocation,`output_logging_${(0,E.$Ql)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(C){this.h=C;for(const[r,h]of this.g)h.visible=r===this.h}createOutputChannel(C,r,h){if(C=C.trim(),!C)throw new Error("illegal argument `name`. must not be falsy");const n=typeof r=="object"&&r.log,s=(0,y.$ie)(r)?r:void 0;if((0,y.$ie)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let p;const D=this.i.environment.extensionLogLevel?.find(([g])=>z.$Fl.equals(h.identifier,g))?.[1];D&&(p=(0,P.$6i)(D));const l=n?this.o(C,p,h):this.n(C,s,h);return l.then(g=>{this.g.set(g.id,g),g.visible=g.id===this.h}),n?this.r(C,p??this.m.getLevel(),l):this.q(C,l)}async n(C,r,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,s=this.k.extUri.joinPath(n,`${this.f++}-${C.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),p=this.l.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),D=await this.a.$register(C,s,r,h.identifier.value);return new i(D,C,p,this.a,h)}async o(C,r,h){const n=await this.p(h),s=C.replace(/[\\/:\*\?"<>\|]/g,""),p=this.k.extUri.joinPath(n,`${s}.log`),D=`${h.identifier.value}.${s}`,l=this.l.createLogger(p,{id:D,name:C,logLevel:r,extensionId:h.identifier.value});return new a(D,C,l,this.a,h)}p(C){let r=this.d.get(C.identifier.value);if(!r){const h=this.k.extUri.joinPath(this.i.logsLocation,C.identifier.value);this.d.set(C.identifier.value,r=(async()=>{try{await this.j.value.createDirectory(h)}catch(n){if((0,b.$6j)(n)!==b.FileSystemProviderErrorCode.FileExists)throw n}return h})())}return r}q(C,r){let h=!1;const n=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return C},append(s){n(),r.then(p=>p.append(s))},appendLine(s){n(),r.then(p=>p.appendLine(s))},clear(){n(),r.then(s=>s.clear())},replace(s){n(),r.then(p=>p.replace(s))},show(s,p){n(),r.then(D=>D.show(s,p))},hide(){n(),r.then(s=>s.hide())},dispose(){h=!0,r.then(s=>s.dispose())}}}r(C,r,h){const n=new t.$kb,s=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},p=n.add(new o.$7c);function D(l){r=l,p.fire(l)}return h.then(l=>{n.add(l),l.logLevel!==r&&D(l.logLevel),n.add(l.onDidChangeLogLevel(g=>D(g)))}),{...this.q(C,h),get logLevel(){return r},onDidChangeLogLevel:p.event,trace(l,...g){s(),h.then(v=>v.trace(l,...g))},debug(l,...g){s(),h.then(v=>v.debug(l,...g))},info(l,...g){s(),h.then(v=>v.info(l,...g))},warn(l,...g){s(),h.then(v=>v.warn(l,...g))},error(l,...g){s(),h.then(v=>v.error(l,...g))},dispose(){n.dispose()}}}};e.$A_b=m,e.$A_b=m=qe([Ve(0,I.$zL),Ve(1,$.$PL),Ve(2,k.$d_b),Ve(3,R.$K$b),Ve(4,P.$Qi),Ve(5,P.$Pi)],m),e.$B_b=(0,L.$nh)("IExtHostOutputService")}),define(Ae[260],Re([1,0,3,16]),function($e,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7l=e.$6l=void 0,e.$6l=(0,w.$nh)("remoteAgentService"),e.$7l=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let z=1/0;for(let d=0;d<this.maxSampleCount;d++){const k=await I.getRoundTripTime();if(k===void 0)return;z=Math.min(z,k/2),await(0,L.$ug)(this.sampleDelay)}this.average.push(z),this.average.length>this.maxAverageCount&&this.average.shift();let P;return this.initial.length<this.maxInitialCount?this.initial.push(z):P=this.initial.reduce((d,k)=>d+k,0)/this.initial.length,this.lastMeasurement={initial:P,current:z,average:this.average.reduce((d,k)=>d+k,0)/this.average.length,high:(()=>typeof P>"u"?!1:z>this.highLatencyMaxThreshold||z>this.highLatencyMinThreshold&&z>P*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ae[261],Re([1,0,42,13,19,22,23,2,3,187,54,209,260]),function($e,e,w,L,I,z,P,d,k,$,R,E,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aJ=e.$_I=void 0,e.$_I=(0,k.$nh)("pathService");let y=class Dn{constructor(o,t,i,a){this.d=o,this.e=t,this.f=i,this.g=a,this.a=(async()=>(await this.e.getEnvironment())?.os||z.OS)(),this.b=(async()=>{const m=await this.e.getEnvironment();return this.c=m?.userHome??o})()}hasValidBasename(o,t,i){return typeof t=="string"||typeof t>"u"?this.a.then(a=>this.h(o,a,t)):this.h(o,t,i)}h(o,t,i){return o.scheme===L.Schemas.file||o.scheme===L.Schemas.vscodeRemote?(0,w.$He)(i??(0,P.$5f)(o),t===1):!0}get defaultUriScheme(){return Dn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,t){if(o.remoteAuthority)return L.Schemas.vscodeRemote;const i=(0,$.$9I)(t.getWorkspace());if(i)return i;const a=t.getWorkspace().folders[0];if(a)return a.uri.scheme;const m=t.getWorkspace().configuration;return m?m.scheme:L.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?I.$9b:I.$0b)}async fileURI(o){let t="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const a=o.indexOf("/",2);a===-1?(t=o.substring(2),o="/"):(t=o.substring(2,a),o=o.substring(a)||"/")}return d.URI.from({scheme:L.Schemas.file,authority:t,path:o,query:"",fragment:""})}};e.$aJ=y,e.$aJ=y=qe([Ve(1,c.$6l),Ve(2,E.$NI),Ve(3,R.$wh)],y)}),define(Ae[110],Re([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$PH=e.$OH=void 0;class w{constructor(P,d){this.line=P,this.character=d}isBefore(P){return!1}isBeforeOrEqual(P){return!1}isAfter(P){return!1}isAfterOrEqual(P){return!1}isEqual(P){return!1}compareTo(P){return 0}translate(P,d){return new w(0,0)}with(P){return new w(0,0)}}e.$OH=w;class L{constructor(P,d,k,$){this.isEmpty=!1,this.isSingleLine=!1,this.start=new w(P,d),this.end=new w(k,$)}contains(P){return!1}isEqual(P){return!1}intersection(P){}union(P){return new L(0,0,0,0)}with(P){return new L(0,0,0,0)}}e.$PH=L;var I;(function(z){z[z.Information=1]="Information",z[z.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Ae[47],Re([1,0,18,37,24,42,15,3,19,11,110,16]),function($e,e,w,L,I,z,P,d,k,$,R,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dI=e.$cI=e.$bI=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=e.SearchErrorCode=e.$4H=e.$3H=e.SearchSortOrder=e.ViewMode=e.$2H=e.$1H=e.$ZH=e.$YH=e.SearchCompletionExitCode=e.$XH=e.$WH=e.$VH=e.QueryType=e.SearchProviderType=e.$UH=e.$TH=e.$SH=e.$RH=e.$QH=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$QH="workbench.view.search",e.$RH="workbench.panel.search",e.$SH="workbench.view.search",e.$TH="search.exclude";const c="\u27EA ",y=" characters skipped \u27EB",b=(c.length+y.length+5)*2;e.$UH=(0,d.$nh)("searchService");var o;(function(G){G[G.file=0]="file",G[G.text=1]="text"})(o||(e.SearchProviderType=o={}));var t;(function(G){G[G.File=1]="File",G[G.Text=2]="Text"})(t||(e.QueryType=t={}));function i(G){return!!G.preview}e.$VH=i;function a(G){return!!G.resource}e.$WH=a;function m(G){return!!G.message}e.$XH=m;var S;(function(G){G[G.Normal=0]="Normal",G[G.NewSearchStarted=1]="NewSearchStarted"})(S||(e.SearchCompletionExitCode=S={}));class C{constructor(Z){this.resource=Z,this.results=[]}}e.$YH=C;class r{constructor(Z,le,ne,de){this.ranges=le,this.webviewIndex=de;const ue=Array.isArray(le)?le:[le];if(ne&&ne.matchLines===1&&h(ue)){Z=(0,P.$be)(Z,ne.matchLines);let T="",_=0,ye=0;const Ce=Math.floor(ne.charsPerLine/5),Se=[];for(const Ee of ue){const Ie=Math.max(Ee.startColumn-Ce,0),se=Ee.startColumn+ne.charsPerLine;if(Ie>ye+Ce+b){const fe=c+(Ie-ye)+y;T+=fe+Z.slice(Ie,se),_+=Ie-(ye+fe.length)}else T+=Z.slice(ye,se);Se.push(new s(0,Ee.startColumn-_,Ee.endColumn-_)),ye=se}this.preview={text:T,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const T=Array.isArray(le)?le[0].startLineNumber:le.startLineNumber;this.preview={text:Z,matches:(0,w.$Hf)(le,_=>new n(_.startLineNumber-T,_.startColumn,_.endLineNumber-T,_.endColumn))}}}}e.$ZH=r;function h(G){const Z=G[0].startLineNumber;for(const le of G)if(le.startLineNumber!==Z||le.endLineNumber!==Z)return!1;return!0}class n{constructor(Z,le,ne,de){this.startLineNumber=Z,this.startColumn=le,this.endLineNumber=ne,this.endColumn=de}}e.$1H=n;class s extends n{constructor(Z,le,ne){super(Z,le,Z,ne)}}e.$2H=s;var p;(function(G){G.List="list",G.Tree="tree"})(p||(e.ViewMode=p={}));var D;(function(G){G.Default="default",G.FileNames="fileNames",G.Type="type",G.Modified="modified",G.CountDescending="countDescending",G.CountAscending="countAscending"})(D||(e.SearchSortOrder=D={}));function l(G,Z=!0){const le=G&&G.files&&G.files.exclude,ne=Z&&G&&G.search&&G.search.exclude;if(!le&&!ne)return;if(!le||!ne)return le||ne;let de=Object.create(null);return de=I.$Im(de,I.$Fm(le)),de=I.$Im(de,I.$Fm(ne),!0),de}e.$3H=l;function g(G,Z){return G.excludePattern&&L.$bj(G.excludePattern,Z)?!1:G.includePattern||G.usingSearchPaths?G.includePattern&&L.$bj(G.includePattern,Z)?!0:G.usingSearchPaths?!!G.folderQueries&&G.folderQueries.some(le=>{const ne=le.folder.fsPath;if(z.$Je(Z,ne)){const de=k.$cc(ne,Z);return!le.includePattern||!!L.$bj(le.includePattern,de)}else return!1}):!1:!0}e.$4H=g;var v;(function(G){G[G.unknownEncoding=1]="unknownEncoding",G[G.regexParseError=2]="regexParseError",G[G.globParseError=3]="globParseError",G[G.invalidLiteral=4]="invalidLiteral",G[G.rgProcessError=5]="rgProcessError",G[G.other=6]="other",G[G.canceled=7]="canceled"})(v||(e.SearchErrorCode=v={}));class u extends Error{constructor(Z,le){super(Z),this.code=le}}e.$5H=u;function f(G){const Z=G.message;if((0,$.$2)(G))return new u(Z,v.canceled);try{const le=JSON.parse(Z);return new u(le.message,le.code)}catch{return new u(Z,v.other)}}e.$6H=f;function A(G){const Z={message:G.message,code:G.code};return new Error(JSON.stringify(Z))}e.$7H=A;function W(G){return G.type==="error"?!0:G.type==="success"}e.$8H=W;function B(G){return G.type==="success"}e.$9H=B;function V(G){return!!G.path}e.$0H=V;function U(G,Z){const le=G.searchPath?G.searchPath:G.relativePath;return(0,P.$$d)(le,Z)}e.$$H=U;class O{constructor(Z){this.path=Z,this.results=[]}addMatch(Z){this.results.push(Z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$_H=O;function N(G,Z){const le={...G||{},...Z||{}};return Object.keys(le).filter(ne=>{const de=le[ne];return typeof de=="boolean"&&de})}e.$aI=N;class ae{constructor(Z,le){this.c=null,this.a={...Z.excludePattern||{},...le.excludePattern||{}},this.b=L.$cj(this.a);let ne=Z.includePattern;le.includePattern&&(ne?ne={...ne,...le.includePattern}:ne=le.includePattern),ne&&(this.c=L.$cj(ne))}matchesExcludesSync(Z,le,ne){return!!(this.b&&this.b(Z,le,ne))}includedInQuerySync(Z,le,ne){return!(this.b&&this.b(Z,le,ne)||this.c&&!this.c(Z,le,ne))}includedInQuery(Z,le,ne){const de=this.b(Z,le,ne),ue=()=>this.c?!!this.c(Z,le,ne):!0;return(0,E.$gg)(de)?de.then(T=>T?!1:ue()):ue()}hasSiblingExcludeClauses(){return Q(this.a)}}e.$bI=ae;function Q(G){for(const Z in G)if(typeof G[Z]!="boolean")return!0;return!1}function be(G){if(!G)return;let Z;return le=>(Z||(Z=(G()||Promise.resolve([])).then(ne=>ne?Fe(ne):{})),Z.then(ne=>!!ne[le]))}e.$cI=be;function ke(G){if(!G)return;let Z;return le=>{if(!Z){const ne=G();Z=ne?Fe(ne):{}}return!!Z[le]}}e.$dI=ke;function Fe(G){const Z={};for(const le of G)Z[le]=!0;return Z}}),define(Ae[33],Re([1,0,18,16,20,5,6,48,13,117,23,15,12,2,158,3,14,175,54,39,27,17,8,7,56,47,4]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S,C,r,h,n,s,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X$b=e.$W$b=void 0;function D(B,V,U){return new R.$Wf(O=>u(O,U)).isEqual(B,V)}function l(B,V,U){return D(B.uri,V.uri,U)?0:(0,E.$Ed)(B.uri.toString(),V.uri.toString())}function g(B,V,U){return B.index!==V.index?B.index<V.index?-1:1:D(B.uri,V.uri,U)?(0,E.$Ed)(B.name,V.name):(0,E.$Ed)(B.uri.toString(),V.uri.toString())}function v(B,V,U,O){const N=B.slice(0).sort((Q,be)=>U(Q,be,O)),ae=V.slice(0).sort((Q,be)=>U(Q,be,O));return(0,w.$if)(N,ae,(Q,be)=>U(Q,be,O))}function u(B,V){const U=V.getCapabilities(B.scheme);return!(U&&U&1024)}class f extends a.$Gh{static toExtHostWorkspace(V,U,O,N){if(!V)return{workspace:null,added:[],removed:[]};const{id:ae,name:Q,folders:be,configuration:ke,transient:Fe,isUntitled:G}=V,Z=[],le=U;U?be.forEach((T,_)=>{const ye=y.URI.revive(T.uri),Ce=f.o(O||U,ye,N);Ce?(Ce.name=T.name,Ce.index=T.index,Z.push(Ce)):Z.push({uri:ye,name:T.name,index:_})}):Z.push(...be.map(({uri:T,name:_,index:ye})=>({uri:y.URI.revive(T),name:_,index:ye}))),Z.sort((T,_)=>T.index<_.index?-1:1);const ne=new f(ae,Q,Z,!!Fe,ke?y.URI.revive(ke):null,!!G,T=>u(T,N)),{added:de,removed:ue}=v(le?le.workspaceFolders:[],ne.workspaceFolders,l,N);return{workspace:ne,added:de,removed:ue}}static o(V,U,O){for(let N=0;N<V.folders.length;N++){const ae=V.workspaceFolders[N];if(D(ae.uri,U,O))return ae}}constructor(V,U,O,N,ae,Q,be){super(V,O.map(ke=>new a.$Hh(ke)),N,ae,be),this.t=U,this.u=Q,this.q=[],this.s=d.$th.forUris(be),O.forEach(ke=>{this.q.push(ke),this.s.set(ke.uri,ke)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,U){return U&&this.s.get(V)&&(V=(0,R.$7f)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let A=class{constructor(V,U,O,N,ae){this.c=new z.$7c,this.onDidChangeWorkspace=this.c.event,this.g=new z.$7c,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new z.$9c,this.B=new Map,this.h=N,this.s=O,this.t=ae,this.j=new $.$tl,this.k=new L.$sg,this.o=V.getProxy(p.$xJ.MainThreadWorkspace),this.q=V.getProxy(p.$xJ.MainThreadMessageService);const Q=U.workspace;this.l=Q?new f(Q.id,Q.name,[],!!Q.transient,Q.configuration?y.URI.revive(Q.configuration):null,!!Q.isUntitled,be=>u(be,O)):void 0}$initializeWorkspace(V,U){this.v=U,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?y.URI.from({scheme:k.Schemas.untitled,path:(0,R.$5f)((0,R.$7f)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,U,O,...N){const ae=[];if(Array.isArray(N)&&N.forEach(G=>{y.URI.isUri(G.uri)&&!ae.some(Z=>D(Z.uri,G.uri,this.s))&&ae.push({uri:G.uri,name:G.name||(0,R.$4f)(G.uri)})}),this.n||[U,O].some(G=>typeof G!="number"||G<0)||O===0&&ae.length===0)return!1;const Q=this.x?this.x.workspaceFolders:[];if(U+O>Q.length)return!1;const be=Q.slice(0);be.splice(U,O,...ae.map(G=>({uri:G.uri,name:G.name||(0,R.$4f)(G.uri),index:void 0})));for(let G=0;G<be.length;G++){const Z=be[G];if(be.some((le,ne)=>ne!==G&&D(Z.uri,le.uri,this.s)))return!1}be.forEach((G,Z)=>G.index=Z);const{added:ke,removed:Fe}=v(Q,be,g,this.s);if(ke.length===0&&Fe.length===0)return!1;if(this.o){const G=V.displayName||V.name;this.o.$updateWorkspaceFolders(G,U,O,ae).then(void 0,Z=>{this.n=void 0;const le={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(i.Severity.Error,(0,b.localize)(0,null,G,Z.toString()),le,[])})}return this.y(be),!0}getWorkspaceFolder(V,U){if(this.x)return this.x.getWorkspaceFolder(V,U)}async getWorkspaceFolder2(V,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,U)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,U){let O,N="";if(typeof V=="string"?(O=y.URI.file(V),N=V):typeof V<"u"&&(O=V,N=V.fsPath),!O)return N;const ae=this.getWorkspaceFolder(O,!0);if(!ae)return N;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let Q=(0,R.$0f)(ae.uri,O);return U&&ae.name&&(Q=`${ae.name}/${Q}`),Q}y(V){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:U,added:O,removed:N}=f.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:O,removed:N}))}findFiles(V,U,O,N,ae=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${N.value}, entryPoint: findFiles`);let Q;if(U===null?Q=!1:U&&(typeof U=="string"?Q=U:Q=U.pattern),ae&&ae.isCancellationRequested)return Promise.resolve([]);const{includePattern:be,folder:ke}=W(r.GlobPattern.from(V));return this.o.$startFileSearch((0,c.$Be)(be),(0,c.$Be)(ke),(0,c.$Be)(Q),(0,c.$Be)(O),ae).then(Fe=>Array.isArray(Fe)?Fe.map(G=>y.URI.revive(G)):[])}async findTextInFiles(V,U,O,N,ae=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${N.value}, entryPoint: findTextInFiles`);const Q=this.j.getNext(),be=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:ke,folder:Fe}=W(r.GlobPattern.from(U.include)),G=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,Z={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:be,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:ke,excludePattern:G},le=!1;if(this.u[Q]=ne=>{if(le)return;const de=y.URI.revive(ne.resource);ne.results.forEach(ue=>{(0,s.$VH)(ue)?O({uri:de,preview:{text:ue.preview.text,matches:(0,w.$Hf)(ue.preview.matches,T=>new h.$BJ(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn))},ranges:(0,w.$Hf)(ue.ranges,T=>new h.$BJ(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn))}):O({uri:de,text:ue.text,lineNumber:ue.lineNumber})})},ae.isCancellationRequested)return{};try{const ne=await this.o.$startTextSearch(V,(0,c.$Be)(Fe),Z,Q,ae);return delete this.u[Q],ne||{}}catch(ne){throw delete this.u[Q],ne}}$handleTextSearchResult(V,U){this.u[U]?.(V)}async save(V){const U=await this.o.$save(V,{saveAs:!1});return y.URI.revive(U)}async saveAs(V){const U=await this.o.$save(V,{saveAs:!0});return y.URI.revive(U)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,U){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,U);const O=this.t.transformOutgoingScheme(V),N=this.z++;return this.o.$registerEditSessionIdentityProvider(N,O),(0,P.$jb)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(N)})}async $getEditSessionIdentifier(V,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const O=await this.resolveWorkspaceFolder(y.URI.revive(V));if(!O){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",O);const N=this.w.get(O.uri.scheme);if(this.h.info(`Provider for scheme ${O.uri.scheme} is defined: `,!!N),!N)return;const ae=await N.provideEditSessionIdentity(O,U);if(this.h.info("Provider returned edit session identifier: ",ae),!!ae)return ae}async $provideEditSessionIdentityMatch(V,U,O,N){this.h.info("Getting edit session identifier for workspaceFolder",V);const ae=await this.resolveWorkspaceFolder(y.URI.revive(V));if(!ae){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",ae);const Q=this.w.get(ae.uri.scheme);if(this.h.info(`Provider for scheme ${ae.uri.scheme} is defined: `,!!Q),!Q)return;const be=await Q.provideEditSessionIdentityMatch?.(U,O,N);if(this.h.info("Provider returned edit session identifier match result: ",be),!!be)return be}getOnWillCreateEditSessionIdentityEvent(V){return(U,O,N)=>{const ae=function(be){U.call(O,be)};return ae.extension=V,this.A.event(ae,void 0,N)}}async $onWillCreateEditSessionIdentity(V,U,O){const N=await this.resolveWorkspaceFolder(y.URI.revive(V));if(N===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:N},U,async(ae,Q)=>{const be=Date.now();await Promise.resolve(ae),Date.now()-be>O&&this.h.warn("SLOW edit session create-participant",Q.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(V,U){if(this.B.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.B.set(V,U);const O=this.t.transformOutgoingScheme(V),N=this.z++;return this.o.$registerCanonicalUriProvider(N,O),(0,P.$jb)(()=>{this.B.delete(V),this.o.$unregisterCanonicalUriProvider(N)})}async provideCanonicalUri(V,U,O){const N=this.B.get(V.scheme);if(!N)return;const ae=await N.provideCanonicalUri?.(y.URI.revive(V),U,O);if(ae)return ae}async $provideCanonicalUri(V,U,O){return this.provideCanonicalUri(y.URI.revive(V),{targetScheme:U},O)}};e.$W$b=A,e.$W$b=A=qe([Ve(0,C.$zL),Ve(1,S.$PL),Ve(2,m.$K$b),Ve(3,t.$Pi),Ve(4,n.$U$b)],A),e.$X$b=(0,o.$nh)("IExtHostWorkspace");function W(B){let V,U;return B&&(typeof B=="string"?V=B:(V=B.pattern,U=y.URI.revive(B.baseUri))),{includePattern:V,folder:U}}}),define(Ae[34],Re([1,0,24,5,33,4,7,178,96,12,16,3,17,14,2]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=e.$Z$b=e.$Y$b=void 0;function o(h,n){if(n){const s=n.split(".");let p=h;for(let D=0;p&&D<s.length;D++)p=p[s[D]];return p}}function t(h){return h instanceof b.URI}function i(h){return h&&h.uri instanceof b.URI&&h.languageId&&typeof h.languageId=="string"}function a(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function m(h){return h&&h.uri instanceof b.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function S(h){if(t(h))return{resource:h};if(i(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(a(h))return{overrideIdentifier:h.languageId};if(m(h))return{resource:h.uri};if(h===null)return{resource:null}}let C=class{constructor(n,s,p){this.a=n.getProxy(z.$xJ.MainThreadConfiguration),this.c=s,this.b=p,this.d=new R.$sg,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new r(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,s){this.getConfigProvider().then(p=>p.$acceptConfigurationChanged(n,s))}};e.$Y$b=C,e.$Y$b=C=qe([Ve(0,c.$zL),Ve(1,I.$X$b),Ve(2,y.$Pi)],C);class r{constructor(n,s,p,D){this.a=new L.$7c,this.b=n,this.f=D,this.c=s,this.e=d.$dn.parse(p),this.d=this.k(p.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,s){const p={data:this.e.toData(),workspace:this.c.workspace};this.e=d.$dn.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(s,p))}getConfiguration(n,s,p){const D=S(s)||{},l=this.g(n?o(this.e.getValue(void 0,D,this.c.workspace),n):this.e.getValue(void 0,D,this.c.workspace));n&&this.h(n,D,p?.identifier);function g(u){if(u==null)return null;if(typeof u=="boolean")return u?2:5;switch(u){case P.ConfigurationTarget.Global:return 2;case P.ConfigurationTarget.Workspace:return 5;case P.ConfigurationTarget.WorkspaceFolder:return 6}}const v={has(u){return typeof o(l,u)<"u"},get:(u,f)=>{this.h(n?`${n}.${u}`:u,D,p?.identifier);let A=o(l,u);if(typeof A>"u")A=f;else{let W;const B=(V,U)=>{if((0,$.$ke)(V)){let O;const N=()=>{W=W||(0,w.$Fm)(l),O=O||o(W,U)};return new Proxy(V,{get:(ae,Q)=>{if(typeof Q=="string"&&Q.toLowerCase()==="tojson")return N(),()=>O;if(W)return O=O||o(W,U),O[Q];const be=ae[Q];return typeof Q=="string"?B(be,`${U}.${Q}`):be},set:(ae,Q,be)=>(N(),O&&(O[Q]=be),!0),deleteProperty:(ae,Q)=>(N(),O&&delete O[Q],!0),defineProperty:(ae,Q,be)=>(N(),O&&Object.defineProperty(O,Q,be),!0)})}return Array.isArray(V)?(0,w.$Fm)(V):V};A=B(A,u)}return A},update:(u,f,A,W)=>{u=n?`${n}.${u}`:u;const B=g(A);return f!==void 0?this.b.$updateConfigurationOption(B,u,f,D,W):this.b.$removeConfigurationOption(B,u,D,W)},inspect:u=>{u=n?`${n}.${u}`:u;const f=this.e.inspect(u,D,this.c.workspace);if(f)return{key:u,defaultValue:(0,w.$Fm)(f.policy?.value??f.default?.value),globalValue:(0,w.$Fm)(f.user?.value??f.application?.value),workspaceValue:(0,w.$Fm)(f.workspace?.value),workspaceFolderValue:(0,w.$Fm)(f.workspaceFolder?.value),defaultLanguageValue:(0,w.$Fm)(f.default?.override),globalLanguageValue:(0,w.$Fm)(f.user?.override??f.application?.override),workspaceLanguageValue:(0,w.$Fm)(f.workspace?.override),workspaceFolderLanguageValue:(0,w.$Fm)(f.workspaceFolder?.override),languageIds:(0,w.$Fm)(f.overrideIdentifiers)}}};return typeof l=="object"&&(0,w.$Im)(v,l,!1),Object.freeze(v)}g(n){const s=p=>(0,$.$ke)(p)?new Proxy(p,{get:(D,l)=>s(D[l]),set:(D,l,g)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(D,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(D,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:D=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):p;return s(n)}h(n,s,p){const D=k.$7m.test(n)?4:this.d.get(n),l=p?`[${p.value}] `:"";if(D===4){typeof s?.resource>"u"&&this.f.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(D===3){s?.resource&&this.f.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,s){const p=new d.$fn(n,s,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(D,l)=>p.affectsConfiguration(D,S(l))})}k(n){return n.reduce((s,p)=>(s.set(p[0],p[1]),s),new Map)}}e.$Z$b=r,e.$1$b=(0,E.$nh)("IExtHostConfiguration")}),define(Ae[111],Re([1,0,2,16,5,4,7,33,60,34,20,63,17,27,3,13,22,14,80,215,11]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y_b=e.$X_b=e.$W_b=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var C;(function(B){function V(O){if(O!=null)return O}B.from=V;function U(O){if(O!=null)return O}B.to=U})(C||(C={}));var r;(function(B){function V(O){if(O!=null)return O}B.from=V;function U(O){if(O!=null)return O}B.to=U})(r||(r={}));var h;(function(B){function V(O){if(O!=null)return O}B.from=V;function U(O){if(O!=null)return O}B.to=U})(h||(h={}));var n;(function(B){function V(N){if(N){const ae=N;return ae&&!!ae.process}else return!1}B.is=V;function U(N){if(N==null)return;const ae={process:N.process,args:N.args};return N.options&&(ae.options=h.from(N.options)),ae}B.from=U;function O(N){if(N!=null)return new P.$iK(N.process,N.args,N.options)}B.to=O})(n||(n={}));var s;(function(B){function V(O){if(O!=null)return O}B.from=V;function U(O){if(O!=null)return O}B.to=U})(s||(s={}));var p;(function(B){function V(N){if(N){const ae=N;return ae&&(!!ae.commandLine||!!ae.command)}else return!1}B.is=V;function U(N){if(N==null)return;const ae={};return N.commandLine!==void 0?ae.commandLine=N.commandLine:(ae.command=N.command,ae.args=N.args),N.options&&(ae.options=s.from(N.options)),ae}B.from=U;function O(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new P.$jK(N.commandLine,N.options):new P.$jK(N.command,N.args?N.args:[],N.options)}B.to=O})(p||(p={}));var D;(function(B){function V(N){if(N){const ae=N;return ae&&ae.customExecution==="customExecution"}else return!1}B.is=V;function U(N){return{customExecution:"customExecution"}}B.from=U;function O(N,ae){return ae.get(N)}B.to=O})(D||(e.CustomExecutionDTO=D={}));var l;(function(B){function V(U,O){let N;return U.scope!==void 0&&typeof U.scope!="number"?N=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===P.TaskScope.Workspace&&O&&O.workspaceFile?N=O.workspaceFile:N=m.$RF),{id:U._id,workspaceFolder:N}}B.from=V})(l||(e.TaskHandleDTO=l={}));var g;(function(B){function V(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}B.from=V})(g||(g={}));var v;(function(B){function V(N,ae){if(N==null)return[];const Q=[];for(const be of N){const ke=U(be,ae);ke&&Q.push(ke)}return Q}B.fromMany=V;function U(N,ae){if(N==null)return;let Q;N.execution instanceof P.$iK?Q=n.from(N.execution):N.execution instanceof P.$jK?Q=p.from(N.execution):N.execution&&N.execution instanceof P.$kK&&(Q=D.from(N.execution));const be=C.from(N.definition);let ke;return N.scope?typeof N.scope=="number"?ke=N.scope:ke=N.scope.uri:ke=P.TaskScope.Workspace,!be||!ke?void 0:{_id:N._id,definition:be,name:N.name,source:{extensionId:ae.identifier.value,label:N.source,scope:ke},execution:Q,isBackground:N.isBackground,group:g.from(N.group),presentationOptions:r.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}B.from=U;async function O(N,ae,Q){if(N==null)return;let be;n.is(N.execution)?be=n.to(N.execution):p.is(N.execution)?be=p.to(N.execution):D.is(N.execution)&&(be=D.to(N._id,Q));const ke=C.to(N.definition);let Fe;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?Fe=N.source.scope:Fe=await ae.resolveWorkspaceFolder(w.URI.revive(N.source.scope)):Fe=P.TaskScope.Workspace),!ke||!Fe)return;const G=new P.$lK(ke,Fe,N.name,N.source.label,be,N.problemMatchers);return N.isBackground!==void 0&&(G.isBackground=N.isBackground),N.group!==void 0&&(G.group=P.$hK.from(N.group._id),G.group&&N.group.isDefault&&(G.group=new P.$hK(G.group.id,G.group.label),N.group.isDefault===!0&&(G.group.isDefault=N.group.isDefault))),N.presentationOptions&&(G.presentationOptions=r.to(N.presentationOptions)),N._id&&(G._id=N._id),N.detail&&(G.detail=N.detail),G}B.to=O})(v||(e.TaskDTO=v={}));var u;(function(B){function V(O){return O}B.from=V;function U(O){if(O)return Object.assign(Object.create(null),O)}B.to=U})(u||(u={}));class f{#e;constructor(V,U,O){this._id=U,this.a=O,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let A=class{constructor(V,U,O,N,ae,Q,be,ke){this.q=new I.$7c,this.r=new I.$7c,this.s=new I.$7c,this.t=new I.$7c,this.a=V.getProxy(z.$xJ.MainThreadTask),this.b=O,this.c=N,this.d=ae,this.e=Q,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=be,this.g=ke,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,U,O){if(!O)return new P.$zJ(()=>{});const N=this.w();return this.j.set(N,{type:U,provider:O,extension:V}),this.a.$registerTaskProvider(N,U),new P.$zJ(()=>{this.j.delete(N),this.a.$unregisterTaskProvider(N)})}registerTaskSystem(V,U){this.a.$registerTaskSystem(V,U)}fetchTasks(V){return this.a.$fetchTasks(u.from(V)).then(async U=>{const O=[];for(const N of U){const ae=await v.to(N,this.b,this.m);ae&&O.push(ae)}return O})}get taskExecutions(){const V=[];return this.k.forEach(U=>V.push(U)),V}terminateTask(V){if(!(V instanceof f))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,U,O){const N=this.m.get(V.id);N&&(this.o.set(V.id,N),this.e.attachPtyToTerminal(U,await N.callback(O))),this.p=V.id,this.q.fire({execution:await this.y(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){const U=await this.y(V);this.l.delete(V.id),this.k.delete(V.id),this.A(V),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const U=await this.y(V.id);this.s.fire({execution:U,processId:V.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(V){const U=await this.y(V.id);this.t.fire({execution:U,exitCode:V.exitCode})}$provideTasks(V,U){const O=this.j.get(V);if(!O)return Promise.reject(new Error("no handler found"));const N=[],ae=(0,L.$mg)(()=>O.provider.provideTasks(R.CancellationToken.None)).then(Q=>this.u(U,N,O,Q));return new Promise(Q=>{ae.then(be=>{Promise.all(N).then(()=>{Q(be)})})})}async $resolveTask(V,U){const O=this.j.get(V);if(!O)return Promise.reject(new Error("no handler found"));if(U.definition.type!==O.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${O.type}].`);const N=await v.to(U,this.b,this.m);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const ae=await O.provider.resolveTask(N,R.CancellationToken.None);if(!ae)return;this.z(ae,O);const Q=v.from(ae,O.extension);if(!Q)throw new Error("Unexpected: Task cannot be resolved.");if(ae.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(Q.execution)&&await this.x(Q,ae,!0),await this.v(Q)}w(){return this.h++}async x(V,U,O){const N=await this.a.$createTaskId(V);!O&&!this.m.has(N)&&(this.n.add(N),this.o.set(N,U.execution)),this.m.set(N,U.execution)}async y(V,U){if(typeof V=="string"){const ae=this.l.get(V);if(!ae)throw new S.$ab("Unexpected: The specified task is missing an execution");return ae}const O=this.l.get(V.id);if(O)return O;const N=new Promise((ae,Q)=>{function be(ke,Fe,G){G?ae(new f(ke,Fe.id,G)):Q("Unexpected: Task does not exist.")}U?be(this,V,U):v.to(V.task,this.b,this.m).then(ke=>be(this,V,ke))});return this.l.set(V.id,N),N.then(ae=>(this.k.set(V.id,ae),ae),ae=>Promise.reject(ae))}z(V,U){V._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const O=this.n.values();let N=O.next();for(;!N.done;)!this.o.has(N.value)&&this.p!==N.value&&(this.m.delete(N.value),this.n.delete(N.value)),N=O.next()}};e.$W_b=A,e.$W_b=A=qe([Ve(0,c.$zL),Ve(1,y.$PL),Ve(2,d.$X$b),Ve(3,k.$KL),Ve(4,$.$1$b),Ve(5,E.$g_b),Ve(6,i.$Pi),Ve(7,a.$N$b)],A);let W=class extends A{constructor(V,U,O,N,ae,Q,be,ke){super(V,U,O,N,ae,Q,be,ke),this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:t.$h(0)})}async executeTask(V,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const O=v.from(U,V);if(O===void 0)throw new Error("Task is not valid");if(D.is(O.execution))await this.x(O,U,!1);else throw new S.$$;const N=await this.y(await this.a.$getTaskExecution(O),U);return this.a.$executeTask(O).catch(ae=>{throw new Error(ae)}),N}u(V,U,O,N){const ae=[];if(N)for(const Q of N){this.z(Q,O),(!Q.definition||!V[Q.definition.type])&&this.f.warn(`The task [${Q.source}, ${Q.name}] uses an undefined task type. The task will be ignored in the future.`);const be=v.from(Q,O.extension);be&&D.is(be.execution)?(ae.push(be),U.push(this.x(be,Q,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:ae,extension:O.extension}}async v(V){if(D.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,U,O){}};e.$X_b=W,e.$X_b=W=qe([Ve(0,c.$zL),Ve(1,y.$PL),Ve(2,d.$X$b),Ve(3,k.$KL),Ve(4,$.$1$b),Ve(5,E.$g_b),Ve(6,i.$Pi),Ve(7,a.$N$b)],W),e.$Y_b=(0,b.$nh)("IExtHostTask")}),define(Ae[262],Re([1,0,19,20,41,37,23,59,47]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9_b=void 0;class ${constructor(c,y,b){this.k=c,this.l=y,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=c.filePattern,this.b=c.includePattern&&z.$cj(c.includePattern),this.c=c.maxResults||void 0,this.d=c.exists,this.h=new Set,this.j=c.excludePattern&&z.$cj(c.excludePattern)}cancel(){this.g=!0,this.h.forEach(c=>c.cancel()),this.h=new Set}search(c){const y=this.k.folderQueries||[];return new Promise((b,o)=>{const t=i=>{this.f++,c(i)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(i=>{const a=i.toString(),m=w.$ec(a);this.j&&this.j(a,m)||this.v(t,{base:i,basename:m})}),Promise.all(y.map(i=>this.p(i,t))).then(i=>{b({limitHit:this.e,stats:i[0]||void 0})},i=>{o(new Error((0,I.$$h)(i)))})})}async p(c,y){const b=new L.$dd,o=this.q(c),t=this.r(),i=new k.$bI(this.k,c),a=!i.hasSiblingExcludeClauses();let m;try{this.h.add(b),m=d.$3c.create();const S=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},o,b.token),C=m.elapsed(),r=d.$3c.create();return this.g&&!this.e||(S&&S.forEach(h=>{const n=w.$0b.relative(c.folder.path,h.path);if(a){const s=w.$ec(h.path);this.v(y,{base:c.folder,relativePath:n,basename:s});return}this.s(t,c.folder,n,y)}),this.g&&!this.e)?null:(this.u(t,i,y),{providerTime:C,postProcessTime:r.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(c){const y=(0,k.$aI)(this.k.includePattern,c.includePattern),b=(0,k.$aI)(this.k.excludePattern,c.excludePattern);return{folder:c.folder,excludes:b,includes:y,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}s({pathToEntries:c},y,b,o){if(b===this.a){const i=w.$ec(this.a);this.v(o,{base:y,relativePath:this.a,basename:i})}function t(i){const a=w.$ec(i),m=w.$dc(i);let S=c[m];S||(S=c[m]=[],t(m)),S.push({base:y,relativePath:i,basename:a})}t(b)}u({rootEntries:c,pathToEntries:y},b,o){const t=this,i=this.a;function a(m){const S=(0,k.$dI)(()=>m.map(C=>C.basename));for(let C=0,r=m.length;C<r;C++){const h=m[C],{relativePath:n,basename:s}=h;if(b.matchesExcludesSync(n,s,i!==s?S:void 0))continue;const p=y[n];if(p)a(p);else{if(n===i)continue;t.v(o,h)}if(t.e)break}}a(c)}v(c,y){(!this.b||y.relativePath&&this.b(y.relativePath,y.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||c(y))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(c,y,b,o){const t=this.c(c.cacheKey),i=new $(c,y,t&&t.token);let a=0;const m=S=>{a+=S.length,b(S.map(C=>this.d(C)))};return this.e(i,R.a,m,o).then(S=>({limitHit:S.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:S.stats}}))}clearCache(c){this.c(c)?.cancel()}c(c){if(c)return this.b.has(c)||this.b.set(c,new L.$dd),this.b.get(c)}d(c){return c.relativePath?{resource:P.$8f(c.base,c.relativePath)}:{resource:c.base}}e(c,y,b,o){o.onCancellationRequested(()=>{c.cancel()});const t=a=>{a&&(i.push(a),y>0&&i.length>=y&&(b(i),i=[]))};let i=[];return c.search(t).then(a=>(i.length&&b(i),a),a=>(i.length&&b(i),Promise.reject(a)))}}e.$9_b=R}),define(Ae[263],Re([1,0,18,65,37,90,28,13,19,23,15,12,2,277,167,43,14,54,102,261,47]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cJ=e.$bJ=void 0;let C=class{constructor(u,f,A,W,B){this.a=u,this.b=f,this.c=A,this.d=W,this.e=B}text(u,f,A={}){u=this.f(u,A);const W=this.a.getValue(),B=f&&f.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(f?.map(i.$Ih),A),type:2,contentPattern:u,previewOptions:A.previewOptions,maxFileSize:A.maxFileSize,usePCRE2:W.search.usePCRE2||B||!1,beforeContext:A.beforeContext,afterContext:A.afterContext,userDisabledExcludesAndIgnoreFiles:A.disregardExcludeSettings&&A.disregardIgnoreFiles}}f(u,f){const A=this.a.getValue();u.isRegExp&&(u.pattern=u.pattern.replace(/\r?\n/g,"\\n"));const W={...u,wordSeparators:A.editor.wordSeparators};return this.j(u,f)&&(W.isCaseSensitive=!0),this.k(u)&&(W.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeMarkupPreview&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookMarkdownPreview=f.notebookSearchConfig.includeMarkupPreview),f.notebookSearchConfig?.includeCodeInput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(W.notebookInfo||(W.notebookInfo={}),W.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),W}file(u,f={}){return{...this.h(u,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}g(u,f){return u?(u=Array.isArray(u)?u.map(p):p(u),f?this.parseSearchPaths(u):{pattern:h(...Array.isArray(u)?u:[u])}):{}}h(u=[],f={}){const A=this.g(f.includePattern,f.expandPatterns),W=this.g(f.excludePattern,f.expandPatterns),B=u.length>1,V=(A.searchPaths&&A.searchPaths.length?A.searchPaths.map(N=>this.q(N,f,W)):u.map(N=>this.r(N,f,W,B))).filter(N=>!!N),U={_reason:f._reason,folderQueries:V,usingSearchPaths:!!(A.searchPaths&&A.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:W.pattern,includePattern:A.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const N=w.$lf(w.$xf(this.c.groups.map(be=>be.editors.map(ke=>ke.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const ae=N.filter(be=>(0,S.$4H)(U,be.fsPath)),Q=this.i(ae);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Q)),{...U,...Q}}const O=f.extraFileResources&&f.extraFileResources.filter(N=>(0,S.$4H)(U,N.fsPath));return U.extraFileResources=O&&O.length?O:void 0,U}i(u){const f=[],A=new P.$li,W={};let B=!1;return u.forEach(V=>{if(V.scheme===d.Schemas.walkThrough)return;if((0,$.$_f)(V)){const O=this.b.getWorkspaceFolder(V)?.uri??V.with({path:k.$dc(V.fsPath)});let N=A.get(O);N||(B=!0,N={folder:O,includePattern:{}},f.push(N),A.set(O,N));const ae=k.$cc(O.fsPath,V.fsPath);(0,E.$te)(N.includePattern)[ae.replace(/\\/g,"/")]=!0}else V.fsPath&&(B=!0,W[V.fsPath]=!0)}),{folderQueries:f,includePattern:W,usingSearchPaths:!0,excludePattern:B?void 0:{"**/*":!0}}}j(u,f){if(f.isSmartCase){if(u.isRegExp){if(R.$_d(u.pattern,!0))return!0}else if(R.$_d(u.pattern))return!0}return!!u.isCaseSensitive}k(u){return u.isMultiline||u.isRegExp&&(0,y.$2B)(u.pattern)||u.pattern.indexOf(`
`)>=0?!0:!!u.isMultiline}parseSearchPaths(u){const f=Q=>k.$_b(Q)||/^\.\.?([\/\\]|$)/.test(Q),W=(Array.isArray(u)?u:n(u)).map(Q=>{const be=this.e.resolvedUserHome;return be?(0,z.$1z)(Q,be.scheme===d.Schemas.file?be.fsPath:be.path):Q}),B=L.$I(W,Q=>f(Q)?"searchPaths":"exprSegments"),V=(B.exprSegments||[]).map(Q=>R.$sd(Q,"/")).map(Q=>R.$sd(Q,"\\")).map(Q=>(Q[0]==="."&&(Q="*"+Q),s(Q))),U={},O=this.m(B.searchPaths||[]);O&&O.length&&(U.searchPaths=O);const N=w.$xf(V),ae=h(...N);return ae&&(U.pattern=ae),U}l(u,f){return f.disregardExcludeSettings?void 0:(0,S.$3H)(u,!f.disregardSearchExcludeSettings)}m(u){if(!u||!u.length)return[];const f=u.flatMap(W=>{let{pathPortion:B,globPortion:V}=r(W);return V&&(V=D(V)),this.n(B).flatMap(O=>this.o(O,V))}),A=new Map;return f.forEach(W=>{const B=W.searchPath.toString(),V=A.get(B);V?W.pattern&&(V.pattern=V.pattern||{},V.pattern[W.pattern]=!0):A.set(B,{searchPath:W.searchPath,pattern:W.pattern?h(W.pattern):void 0})}),Array.from(A.values())}n(u){if(k.$_b(u)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==d.Schemas.file?[{searchPath:f[0].uri.with({path:u})}]:[{searchPath:c.URI.file(k.$$b(u))}]}if(this.b.getWorkbenchState()===2){const f=this.b.getWorkspace().folders[0].uri;if(u=p(u),u.startsWith("../")||u===".."){const W=k.$0b.resolve(f.path,u);return[{searchPath:f.with({path:W})}]}const A=D(u);return[{searchPath:f,pattern:A}]}else{if(u==="./"||u===".\\")return[];{const f=u.replace(/^\.[\/\\]/,""),W=this.b.getWorkspace().folders.map(B=>{const V=f.match(new RegExp(`^${R.$nd(B.name)}(?:/(.*)|$)`));return V?{match:V,folder:B}:null}).filter(E.$qe);if(W.length)return W.map(B=>{const V=B.match[1];return{searchPath:B.folder.uri,pattern:V&&D(V)}});{const B=u.match(/\.[\/\\](.+)[\/\\]?/),V=B?B[1]:u,U=b.localize(0,null,V);throw new Error(U)}}}}o(u,f){const A=u.pattern&&f?`${u.pattern}/${f}`:u.pattern||f,W=[{searchPath:u.searchPath,pattern:A}];return A&&!A.endsWith("**")&&W.push({searchPath:u.searchPath,pattern:A+"/**"}),W}q(u,f,A){const W=this.r((0,i.$Ih)(u.searchPath),f,A,!1);return W?{...W,includePattern:u.pattern}:null}r(u,f,A,W){let B;const V=c.URI.isUri(u)?u:u.uri;if(A.searchPaths){const Q=A.searchPaths.filter(be=>(0,$.$1f)(be.searchPath,V))[0];if(Q&&!Q.pattern)return null;Q&&(B=Q.pattern)}const U=this.a.getValue({resource:V}),N={...this.l(U,f)||{},...B||{}},ae=c.URI.isUri(u)?(0,$.$5f)(u):u.name;return{folder:V,folderName:W?ae:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!U.search.followSymlinks}}};e.$bJ=C,e.$bJ=C=qe([Ve(0,o.$Th),Ve(1,i.$wh),Ve(2,a.$MC),Ve(3,t.$Pi),Ve(4,m.$_I)],C);function r(v){const u=v.match(/[\*\{\}\(\)\[\]\?]/);if(u){const f=u.index,A=v.substr(0,f).match(/[/|\\][^/\\]*$/);if(A){let W=v.substr(0,A.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:v.substr((A.index||0)+1)}}}return{pathPortion:v}}function h(...v){return v.length?v.reduce((u,f)=>(u[f]=!0,u),Object.create(null)):void 0}function n(v){return I.$aj(v,",").map(u=>u.trim()).filter(u=>!!u.length)}function s(v){return[`**/${v}/**`,`**/${v}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function p(v){return v.replace(/\\/g,"/")}function D(v){return p(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(v){return v.replace(/([?*[\]])/g,"[$1]")}function g(v,u){v=w.$qf(v,W=>W.toString());const f=[],A=u.getWorkspace();return v&&v.forEach(W=>{let B;if(u.getWorkbenchState()===2)B=(0,$.$0f)(A.folders[0].uri,W),B&&B!=="."&&(B="./"+B);else{const V=u.getWorkspaceFolder(W);if(V){const U=V.name;if(A.folders.filter(N=>N.name===U).length===1){const N=(0,$.$0f)(V.uri,W);N===""?B=`./${V.name}`:B=`./${V.name}/${N}`}else B=W.fsPath}}B&&f.push(l(B))}),f}e.$cJ=g}),define(Ae[264],Re([1,0,23,2,20,11,3,263,47,54]),function($e,e,w,L,I,z,P,d,k,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pjb=e.$Ojb=void 0;const R=7e3;function E(o,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0);const a=[],m=[];for(const s of i)if(/^workspaceContains:/.test(s)){const p=s.substr(18);p.indexOf("*")>=0||p.indexOf("?")>=0||o.forceUsingSearch?m.push(p):a.push(p)}if(a.length===0&&m.length===0)return Promise.resolve(void 0);let S;const C=new Promise((s,p)=>{S=s}),r=s=>S({activationEvent:s}),h=Promise.all(a.map(s=>c(o,s,r))).then(()=>{}),n=y(o,t.identifier,m,r);return Promise.all([h,n]).then(()=>{S(void 0)}),C}e.$Ojb=E;async function c(o,t,i){for(const a of o.folders)if(await o.exists(w.$8f(L.URI.revive(a),t))){i(`workspaceContains:${t}`);return}}async function y(o,t,i,a){if(i.length===0)return Promise.resolve(void 0);const m=new I.$dd,S=o.checkExists(o.folders,i,m.token),C=setTimeout(async()=>{m.cancel(),o.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},R);let r=!1;try{r=await S}catch(h){z.$2(h)||z.$Y(h)}m.dispose(),clearTimeout(C),r&&a(`workspaceContains:${i.join(",")}`)}function b(o,t,i,a){const m=o.get(P.$mh),S=o.get(k.$UH),r=m.createInstance(d.$bJ).file(t.map(h=>(0,$.$Ih)(L.URI.revive(h))),{_reason:"checkExists",includePattern:i,exists:!0});return S.fileSearch(r,a).then(h=>!!h.limitHit,h=>z.$2(h)?!1:Promise.reject(h))}e.$Pjb=b}),define(Ae[35],Re([1,0,148,19,87,23,16,6,48,2,14,4,34,210,84,33,26,106,11,21,25,189,7,97,3,27,85,17,73,86,63,5,264,83,191,13,81,59,22,82]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S,C,r,h,n,s,p,D,l,g,v,u,f,A,W,B,V,U,O,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v_b=e.$u_b=e.$t_b=e.$s_b=e.$r_b=void 0,e.$r_b=(0,n.$nh)("IHostUtils");let ae=class Sn extends d.$lb{constructor(ne,de,ue,T,_,ye,Ce,Se,Ee,Ie,se,fe){super(),this.R=fe,this.a=this.B(new u.$7c),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=de,this.g=ue,this.f=Ce,this.j=T,this.k=_,this.l=ye,this.m=Ee,this.p=Ie,this.s=se,this.t=this.g.getProxy(E.$xJ.MainThreadWorkspace),this.u=this.g.getProxy(E.$xJ.MainThreadTelemetry),this.v=this.g.getProxy(E.$xJ.MainThreadExtensionService),this.w=new P.$sg,this.y=new P.$sg,this.z=new P.$sg,this.C=new P.$sg,this.D=new Z(this.f.activationEvents),this.G=new i.$l1b(this.D,this.f.allExtensions);const ee=new m.$Gl(this.f.myExtensions);this.F=new i.$l1b(this.D,Fe(this.G,ee)),this.H=new b.$$$b(this.g,this.l),this.I=new A.$k_b(this.g),this.J=Se,this.h=ne.createChild(new l.$lh([b.$_$b,this.H],[A.$l_b,this.I])),this.L=this.B(new y.$0$b(this.F,this.G,{onExtensionActivationError:(ie,he,F)=>{this.v.$onExtensionActivationError(ie,a.$1(he),F)},actualActivateExtension:async(ie,he)=>{if(i.$l1b.isHostExtension(ie,this.F,this.G))return await this.v.$activateExtension(ie,he),new y.$9$b;const F=this.F.getExtensionDescription(ie);return this.$(F,he)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(ne){a.$Y(ne)}}async S(){this.J.onWillDeactivateAll();let ne=[];try{ne=this.F.getAllExtensionDescriptions().map(_=>_.identifier).filter(_=>this.isActivated(_)).map(_=>this.Z(_))}catch{}await Promise.all(ne)}terminate(ne,de=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${ne}`),this.l.flush(),this.p.dispose(),this.L.dispose(),a.setUnexpectedErrorHandler(T=>{this.l.error(T)}),this.g.dispose();const ue=this.S();Promise.race([(0,P.$ug)(5e3),ue]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${de}`):this.l.info(`Extension host exiting with code ${de}`),this.l.flush(),this.l.dispose(),this.c.exit(de)})}isActivated(ne){return this.z.isOpen()?this.L.isActivated(ne):!1}async getExtension(ne){const de=await this.v.$getExtension(ne);return de&&{...de,identifier:new m.$Fl(de.identifier.value),extensionLocation:$.URI.revive(de.extensionLocation)}}U(ne,de){return this.L.activateByEvent(ne,de)}W(ne,de){return this.L.activateById(ne,de)}activateByIdWithErrors(ne,de){return this.W(ne,de).then(()=>{const ue=this.L.getActivatedExtension(ne);if(ue.activationFailed)return Promise.reject(ue.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(ne=>this.F)}getExtensionExports(ne){if(this.z.isOpen())return this.L.getActivatedExtension(ne).exports;try{return this.L.getActivatedExtension(ne).exports}catch{return null}}async X(ne){if(ne.scheme===B.Schemas.file&&this.c.fsRealpath){const de=await this.c.fsRealpath(ne.fsPath);return $.URI.file(de)}return ne}async getExtensionPathIndex(){return this.M||(this.M=this.Y(this.F.getAllExtensionDescriptions()).then(ne=>new G(ne))),this.M}async Y(ne){const de=k.$th.forUris(ue=>z.$Yf.ignorePathCasing(ue));return await Promise.all(ne.map(async ue=>{if(this.qb(ue)){const T=await this.X(ue.extensionLocation);de.set(T,ue)}})),de}Z(ne){let de=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(ne))return de;const ue=this.L.getActivatedExtension(ne);if(!ue)return de;try{typeof ue.module.deactivate=="function"&&(de=Promise.resolve(ue.module.deactivate()).then(void 0,T=>(this.l.error(T),Promise.resolve(void 0))))}catch(T){this.l.error(`An error occurred when deactivating the extension '${ne.value}':`),this.l.error(T)}try{(0,d.$gb)(ue.subscriptions)}catch(T){this.l.error(`An error occurred when deactivating the subscriptions for extension '${ne.value}':`),this.l.error(T)}return de}async $(ne,de){return this.f.remote.isRemote?this.v.$onWillActivateExtension(ne.identifier):await this.v.$onWillActivateExtension(ne.identifier),this.bb(ne,de).then(ue=>{const T=ue.activationTimes;return this.v.$onDidActivateExtension(ne.identifier,T.codeLoadingTime,T.activateCallTime,T.activateResolvedTime,de),this.ab(ne,de,"success",T),ue},ue=>{throw this.ab(ne,de,"failure"),ue})}ab(ne,de,ue,T){const _=be(ne,de);this.u.$publicLog2("extensionActivationTimes",{..._,...T||{},outcome:ue})}bb(ne,de){const ue=be(ne,de);this.u.$publicLog2("activatePlugin",ue);const T=this.qb(ne);if(!T)return Promise.resolve(new y.$8$b(y.$5$b.NONE));this.l.info(`ExtensionService#_doActivateExtension ${ne.identifier.value}, startup: ${de.startup}, activationEvent: '${de.activationEvent}'${ne.identifier.value!==de.extensionId.value?`, root cause: ${de.extensionId.value}`:""}`),this.l.flush();const _=new y.$6$b(de.startup);return Promise.all([this.rb(ne,(0,z.$8f)(ne.extensionLocation,T),_),this.cb(ne)]).then(ye=>(I.mark(`code/extHost/willActivateExtension/${ne.identifier.value}`),Sn.db(this.l,ne.identifier,ye[0],ye[1],_))).then(ye=>(I.mark(`code/extHost/didActivateExtension/${ne.identifier.value}`),ye))}cb(ne){const de=new C.$b_b(ne,this.H),ue=new C.$a_b(ne.identifier.value,!1,this.H),T=new W.$m_b(ne,this.I),_=ne.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?r.ExtensionMode.Test:r.ExtensionMode.Development:r.ExtensionMode.Production,ye=this.f.remote.isRemote?r.ExtensionKind.Workspace:r.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${ne.identifier.value}`),Promise.all([de.whenReady,ue.whenReady,this.J.whenReady]).then(()=>{const Ce=this;let Se,Ee;const Ie=(0,t.$vF)(ne,"ipc")?this.f.messagePorts?.get(m.$Fl.toKey(ne.identifier)):void 0;return Object.freeze({globalState:de,workspaceState:ue,secrets:T,subscriptions:[],get extensionUri(){return ne.extensionLocation},get extensionPath(){return ne.extensionLocation.fsPath},asAbsolutePath(se){return L.$ac(ne.extensionLocation.fsPath,se)},get storagePath(){return Ce.J.workspaceValue(ne)?.fsPath},get globalStoragePath(){return Ce.J.globalValue(ne).fsPath},get logPath(){return L.$ac(Ce.f.logsLocation.fsPath,ne.identifier.value)},get logUri(){return $.URI.joinPath(Ce.f.logsLocation,ne.identifier.value)},get storageUri(){return Ce.J.workspaceValue(ne)},get globalStorageUri(){return Ce.J.globalValue(ne)},get extensionMode(){return _},get extension(){return Se===void 0&&(Se=new ke(Ce,ne.identifier,ne,ye,!1)),Se},get extensionRuntime(){return(0,t.$wF)(ne,"extensionRuntime"),Ce.extensionRuntime},get environmentVariableCollection(){return Ce.p.getEnvironmentVariableCollection(ne)},get messagePassingProtocol(){if(!Ee){if(!Ie)return;const se=u.Event.buffer(u.Event.fromDOMEventEmitter(Ie,"message",fe=>fe.data));Ie.start(),Ee={onDidReceiveMessage:se,postMessage:Ie.postMessage.bind(Ie)}}return Ee}})})}static db(ne,de,ue,T,_){return ue=ue||{activate:void 0,deactivate:void 0},this.eb(ne,de,ue,T,_).then(ye=>new y.$7$b(!1,null,_.build(),ue,ye,T.subscriptions))}static eb(ne,de,ue,T,_){if(typeof ue.activate=="function")try{_.activateCallStart(),ne.trace(`ExtensionService#_callActivateOptional ${de.value}`);const ye=typeof global=="object"?global:self,Ce=ue.activate.apply(ye,[T]);return _.activateCallStop(),_.activateResolveStart(),Promise.resolve(Ce).then(Se=>(_.activateResolveStop(),Se))}catch(ye){return Promise.reject(ye)}else return Promise.resolve(ue)}fb(ne,de){this.W(ne.identifier,{startup:!1,extensionId:ne.identifier,activationEvent:de}).then(void 0,ue=>{this.l.error(ue)})}gb(ne,de=0){const T=Date.now();(0,O.$A)(()=>{for(let _=de;_<ne.length;_+=1){const ye=ne[_];for(const Ce of ye.activationEvents??[])if(Ce==="onStartupFinished")if(Date.now()-T>50){this.gb(ne,_);break}else this.fb(ye,Ce)}})}hb(){this.v.$setPerformanceMarks(I.getMarks()),this.k.getConfigProvider().then(ne=>{const de=ne.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ue=this.F.getAllExtensionDescriptions();if(de)this.gb(ue);else for(const T of ue)if(T.activationEvents)for(const _ of T.activationEvents)_==="onStartupFinished"&&this.fb(T,_)})}ib(){const ne=this.U("*",!0).then(void 0,ye=>{this.l.error(ye)});this.B(this.j.onDidChangeWorkspace(ye=>this.jb(ye.added)));const de=this.j.workspace?this.j.workspace.folders:[],ue=this.jb(de),T=this.lb(),_=Promise.all([T,ne,ue]).then(()=>{});return Promise.race([_,(0,P.$ug)(1e4)]).then(()=>{this.hb()}),_}jb(ne){return ne.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(de=>this.kb(ne,de))).then(()=>{})}async kb(ne,de){if(this.isActivated(de.identifier))return;const ue=!this.f.remote.isRemote&&!!this.f.remote.authority,T={logService:this.l,folders:ne.map(ye=>ye.uri),forceUsingSearch:ue||!this.c.fsExists,exists:ye=>this.c.fsExists(ye.fsPath),checkExists:(ye,Ce,Se)=>this.t.$checkExists(ye,Ce,Se)},_=await(0,f.$Ojb)(T,de);if(_)return this.W(de.identifier,{startup:!0,extensionId:de.identifier,activationEvent:_.activationEvent}).then(void 0,ye=>this.l.error(ye))}async lb(){if(this.f.remote.authority)return this.U(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(ne){throw console.error(ne),ne}}async mb(){const{extensionDevelopmentLocationURI:ne,extensionTestsLocationURI:de}=this.f.environment;if(!ne||!de)throw new Error(w.localize(0,null));const ue=await this.rb(null,de,new y.$6$b(!1));if(!ue||typeof ue.run!="function")throw new Error(w.localize(1,null,de.toString()));return new Promise((T,_)=>{const ye=(Ee,Ie)=>{Ee?_(Ee):T(typeof Ie=="number"&&Ie>0?1:0)},Ce=(0,z.$Vf)(de),Se=ue.run(Ce,ye);Se&&Se.then&&Se.then(()=>{T(0)}).catch(Ee=>{_(Ee instanceof Error&&Ee.stack?Ee.stack:String(Ee))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,P.$ug)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ne,de){return this.N[ne]=de,(0,d.$jb)(()=>{delete this.N[ne]})}async getRemoteExecServer(ne){const{resolver:de}=await this.ob(ne);return de?.resolveExecServer?.(ne,{resolveAttempt:0})}async ob(ne){const de=ne.indexOf("+");if(de===-1)throw new r.$FJ("Not an authority that can be resolved!",h.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ue=ne.substr(0,de);return await this.w.wait(),await this.U(`onResolveRemoteAuthority:${ue}`,!1),{authorityPrefix:ue,resolver:this.N[ue]}}async $resolveAuthority(ne,de){const ue=U.$3c.create(!1),T=()=>`[resolveAuthority(${(0,h.$yk)(ne)},${de})][${ue.elapsed()}ms] `,_=J=>this.l.info(`${T()}${J}`),ye=J=>this.l.warn(`${T()}${J}`),Ce=(J,K=void 0)=>this.l.error(`${T()}${J}`,K),Se=J=>{if(J instanceof r.$FJ)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},Ee=async J=>{_(`activating resolver for ${J}...`);const{resolver:K,authorityPrefix:oe}=await this.ob(J);if(!K)throw Ce(`no resolver for ${oe}`),new r.$FJ(`No remote extension installed to resolve ${oe}.`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:oe,remoteAuthority:J}},Ie=ne.split(/@|%40/g).reverse();_(`activating remote resolvers ${Ie.join(" -> ")}`);let se;try{se=await Promise.all(Ie.map(Ee)).catch(async J=>{if(!(J instanceof r.$FJ)||J._code!==h.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return ye(`resolving nested authorities failed: ${J.message}`),[await Ee(ne)]})}catch(J){return Se(J)}const fe=new P.$Dg;fe.cancelAndSet(()=>_("waiting..."),1e3);let ee,ie;for(const[J,{authorityPrefix:K,resolver:oe,remoteAuthority:H}]of se.entries())try{if(J===se.length-1)_("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${K}`),ee=await oe.resolve(H,{resolveAttempt:de,execServer:ie}),I.mark(`code/extHost/didResolveAuthorityOK/${K}`),_("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(oe));else{if(_(`invoking resolveExecServer() for ${H}`),I.mark(`code/extHost/willResolveExecServer/${K}`),ie=await oe.resolveExecServer?.(H,{resolveAttempt:de,execServer:ie}),!ie)throw new r.$FJ(`Exec server was not available for ${H}`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(ce){return I.mark(`code/extHost/didResolveAuthorityError/${K}`),Ce("returned an error",ce),fe.dispose(),Se(ce)}fe.dispose();const he={environmentTunnels:ee.environmentTunnels,features:ee.tunnelFeatures},F={extensionHostEnv:ee.extensionHostEnv,isTrusted:ee.isTrusted,authenticationSession:ee.authenticationSessionForInitializingExtensions?{id:ee.authenticationSessionForInitializingExtensions.id,providerId:ee.authenticationSessionForInitializingExtensions.providerId}:void 0};_(`returned ${r.$EJ.isManagedResolvedAuthority(ee)?"managed authority":`${ee.host}:${ee.port}`}`);let q;if(r.$EJ.isManagedResolvedAuthority(ee)){const J=de;this.R.setFactory(J,ee.makeConnection),q={authority:ne,connectTo:new h.$vk(J),connectionToken:ee.connectionToken}}else q={authority:ne,connectTo:new h.$wk(ee.host,ee.port),connectionToken:ee.connectionToken};return{type:"ok",value:{authority:q,options:F,tunnelInformation:he}}}async $getCanonicalURI(ne,de){this.l.info(`$getCanonicalURI invoked for authority (${(0,h.$yk)(ne)})`);const{resolver:ue}=await this.ob(ne);if(!ue)return null;const T=$.URI.revive(de);if(typeof ue.getCanonicalURI>"u")return T;const _=await(0,P.$mg)(()=>ue.getCanonicalURI(T));return _||T}$startExtensionHost(ne){ne.toAdd.forEach(T=>T.extensionLocation=$.URI.revive(T.extensionLocation));const{globalRegistry:de,myExtensions:ue}=Q(this.D,this.G,this.F,ne);return this.G.set(de.getAllExtensionDescriptions()),this.F.set(ue),this.nb()}$activateByEvent(ne,de){return de===1?this.w.wait().then(ue=>this.U(ne,!1)):this.z.wait().then(ue=>this.U(ne,!1))}async $activate(ne,de){return await this.z.wait(),this.F.getExtensionDescription(ne)?(await this.W(ne,de),!0):!1}async $deltaExtensions(ne){ne.toAdd.forEach(ye=>ye.extensionLocation=$.URI.revive(ye.extensionLocation));const{globalRegistry:de,myExtensions:ue}=Q(this.D,this.G,this.F,ne),T=await this.Y(ue);return(await this.getExtensionPathIndex()).setSearchTree(T),this.G.set(de.getAllExtensionDescriptions()),this.F.set(ue),Promise.resolve(void 0)}async $test_latency(ne){return ne}async $test_up(ne){return ne.byteLength}async $test_down(ne){const de=S.$Jb.alloc(ne),ue=Math.random()%256;for(let T=0;T<ne;T++)de.writeUInt8(ue,T);return de}async $updateRemoteConnectionData(ne){this.Q=ne,this.a.fire()}};e.$s_b=ae,e.$s_b=ae=qe([Ve(0,n.$mh),Ve(1,e.$r_b),Ve(2,D.$zL),Ve(3,o.$X$b),Ve(4,c.$1$b),Ve(5,R.$Pi),Ve(6,s.$PL),Ve(7,p.$e_b),Ve(8,g.$Tpb),Ve(9,v.$g_b),Ve(10,V.$o_b),Ve(11,N.$p_b)],ae);function Q(le,ne,de,ue){le.addActivationEvents(ue.addActivationEvents);const T=new i.$l1b(le,ne.getAllExtensionDescriptions());T.deltaExtensions(ue.toAdd,ue.toRemove);const _=new m.$Gl(de.getAllExtensionDescriptions().map(Ce=>Ce.identifier));for(const Ce of ue.myToRemove)_.delete(Ce);for(const Ce of ue.myToAdd)_.add(Ce);const ye=Fe(T,_);return{globalRegistry:T,myExtensions:ye}}function be(le,ne){return{id:le.identifier.value,name:le.name,extensionVersion:le.version,publisherDisplayName:le.publisher,activationEvents:le.activationEvents?le.activationEvents.join(","):null,isBuiltin:le.isBuiltin,reason:ne.activationEvent,reasonId:ne.extensionId.value}}e.$t_b=(0,n.$nh)("IExtHostExtensionService");class ke{#e;#t;#i;constructor(ne,de,ue,T,_){this.#e=ne,this.#t=de,this.#i=ue.identifier,this.id=ue.identifier.value,this.extensionUri=ue.extensionLocation,this.extensionPath=L.$$b((0,z.$Vf)(ue.extensionLocation)),this.packageJSON=ue,this.extensionKind=T,this.isFromDifferentExtensionHost=_}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$u_b=ke;function Fe(le,ne){return le.getAllExtensionDescriptions().filter(de=>ne.has(de.identifier))}class G{constructor(ne){this.a=ne}setSearchTree(ne){this.a=ne}findSubstr(ne){return this.a.findSubstr(ne)}forEach(ne){return this.a.forEach(ne)}}e.$v_b=G;class Z{constructor(ne){this.a=new m.$Hl,this.addActivationEvents(ne)}readActivationEvents(ne){return this.a.get(ne.identifier)}addActivationEvents(ne){for(const de of Object.keys(ne))this.a.set(de,ne[de])}}}),define(Ae[265],Re([1,0,87,2,4,34,26,21,17,27,3,35,52,14,15]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nac=void 0;let o=class{constructor(C,r,h,n,s,p,D){this.c=C,this.d=r,this.e=h,this.f=n,this.g=s,this.h=p,this.i=D,this.a=new Map,this.b=[]}async install(){this.j(),w.mark("code/extHost/willWaitForConfig");const C=await this.f.getConfigProvider();w.mark("code/extHost/didWaitForConfig");const r=await this.g.getExtensionPathIndex();this.register(new i(this.c,r,this.d,C,this.i)),this.register(this.e.createInstance(a,r)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(m,r,this.h.environment.appUriScheme))}register(C){if("nodeModuleName"in C)if(Array.isArray(C.nodeModuleName))for(const r of C.nodeModuleName)this.a.set(r,C);else this.a.set(C.nodeModuleName,C);typeof C.alternativeModuleName=="function"&&this.b.push(r=>C.alternativeModuleName(r))}};e.$Nac=o,e.$Nac=o=qe([Ve(2,R.$mh),Ve(3,z.$1$b),Ve(4,E.$t_b),Ve(5,$.$PL),Ve(6,y.$Pi)],o);let t=class gn{static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(C){if(C.environment.appRoot&&gn.a.size){const r=(0,b.$nd)(this.c(C.environment.appRoot.fsPath)),h="[a-z0-9_.-]",n=`@${h}+\\/${h}+|${h}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${r}/${s}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(C){if(!this.b)return;const r=this.b.exec(this.c(C));if(!r)return;const[,h,n,s]=r,p=gn.a.get(n);if(p!==void 0)return console.warn(`${n} as been renamed to ${p}, please update your imports`),h+p+s}c(C){return C.replace(/\\/g,"/")}};t=qe([Ve(0,$.$PL)],t);class i{constructor(C,r,h,n,s){this.c=C,this.d=r,this.e=h,this.f=n,this.g=s,this.nodeModuleName="vscode",this.a=new d.$Hl}load(C,r){const h=this.d.findSubstr(r);if(h){let n=this.a.get(h.identifier);return n||(n=this.c(h,this.e,this.f),this.a.set(h.identifier,n)),n}if(!this.b){let n="";this.d.forEach((s,p)=>n+=`	${p} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${r}. These are the extension path mappings: 
${n}`),this.b=this.c(P.$qF,this.e,this.f)}return this.b}}let a=class{constructor(C,r,h){this.d=C,this.nodeModuleName="keytar",this.a=r.getProxy(I.$xJ.MainThreadTelemetry);const{environment:n}=h,s=r.getProxy(I.$xJ.MainThreadKeytar);if(n.appRoot){let p=n.appRoot.fsPath;c.$7b==="win32"&&(p=p.replace(/\\/g,"/")),p[p.length-1]==="/"&&(p=p.substr(0,p.length-1)),this.b=new Set,this.b.add(`${p}/node_modules.asar/keytar`),this.b.add(`${p}/node_modules/keytar`)}this.c={getPassword:(p,D)=>s.$getPassword(p,D),setPassword:(p,D,l)=>s.$setPassword(p,D,l),deletePassword:(p,D)=>s.$deletePassword(p,D),findPassword:p=>s.$findPassword(p),findCredentials(p){return s.$findCredentials(p)}}}load(C,r){const h=this.d.findSubstr(r);return this.a.$publicLog2("shimming.keytar",{extension:h?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(C){const r=C.length;if(r<=7||!this.b)return;const h=r-7;if((C.charAt(h)==="/"||C.charAt(h)==="\\")&&C.endsWith("keytar")&&(C=C.replace(/\\/g,"/"),this.b.has(C)))return"keytar"}};a=qe([Ve(1,k.$zL),Ve(2,$.$PL)],a);let m=class{constructor(C,r,h){this.e=C,this.f=r,this.nodeModuleName=["open","opn"],this.d=h.getProxy(I.$xJ.MainThreadTelemetry);const n=h.getProxy(I.$xJ.MainThreadWindow);this.c=(s,p)=>{const D=L.URI.parse(s);return p?this.g(s,p):D.scheme==="http"||D.scheme==="https"?n.$openUri(D,s,{allowTunneling:!0}):D.scheme==="mailto"||D.scheme===this.f?n.$openUri(D,s,{}):this.g(s,p)}}load(C,r,h){const n=this.e.findSubstr(r);return n&&(this.a=n.identifier.value,this.h()),this.b=h(C),this.c}g(C,r){return this.i(),this.b(C,r)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};m=qe([Ve(2,k.$zL)],m)}),define(Ae[112],Re([1,0,67,6,19,52,3,60,61,35,7,33,201,34]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3_b=e.$2_b=void 0,e.$2_b=(0,P.$nh)("IExtHostVariableResolverProvider");class b extends c.$AM{constructor(i,a,m,S,C,r,h){function n(){if(m){const s=m.activeEditor();if(s)return s.document.uri;const p=S.tabGroups.all.find(D=>D.isActive)?.activeTab;if(p!==void 0){if(p.input instanceof R.$hL||p.input instanceof R.$mL)return p.input.modified;if(p.input instanceof R.$gL||p.input instanceof R.$lL||p.input instanceof R.$jL)return p.input.uri}}}super({getFolderUri:s=>{const p=r.folders.filter(D=>D.name===s);if(p&&p.length>0)return p[0].uri},getWorkspaceFolderCount:()=>r.folders.length,getConfigurationValue:(s,p)=>C.getConfiguration(void 0,s).get(p),getAppRoot:()=>z.cwd(),getExecPath:()=>z.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=n();if(s)return I.$$b(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(a){const s=n();if(s){const p=a.getWorkspaceFolder(s);if(p)return I.$$b(p.uri.fsPath)}}},getSelectedText:()=>{if(m){const s=m.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(m){const s=m.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>i.getExtension(s)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(z.env))}}let o=class extends L.$lb{constructor(i,a,m,S,C){super(),this.b=i,this.c=a,this.g=m,this.h=S,this.i=C,this.a=new w.$T(async()=>{const r=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async s=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.i,r,n,this.j())})}getResolver(){return this.a.value}j(){}};e.$3_b=o,e.$3_b=o=qe([Ve(0,$.$t_b),Ve(1,E.$X$b),Ve(2,d.$KL),Ve(3,y.$1$b),Ve(4,k.$Z_b)],o)}),define(Ae[113],Re([1,0,16,5,12,2,3,4,61,35,17,7,33,194,196,34,112]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=e.$7_b=e.$6_b=e.$5_b=e.$4_b=void 0,e.$4_b=(0,P.$nh)("IExtHostDebugService");let i=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(n,s,p,D,l,g){this.E=s,this.F=p,this.G=D,this.H=l,this.I=g,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new L.$7c,this.n=new L.$7c,this.o=new L.$7c,this.u=new L.$7c,this.k=n.getProxy(d.$xJ.MainThreadDebugService),this.y=new L.$7c,this.A=new L.$7c,this.v=new m(this.k),this.w=new Map,this.F.getExtensionRegistry().then(v=>{v.onDidChange(u=>{this.J(v)}),this.J(v)})}asDebugSourceUri(n,s){const p=n;if(typeof p.sourceReference=="number"&&p.sourceReference>0){let D=`debug:${encodeURIComponent(p.path||"")}`,l="?";return s&&(D+=`${l}session=${encodeURIComponent(s.id)}`,l="&"),D+=`${l}ref=${p.sourceReference}`,z.URI.parse(D)}else{if(p.path)return z.URI.file(p.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(n){const s=[];for(const p of n.getAllExtensionDescriptions())if(p.contributes){const D=p.contributes.debuggers;if(D&&D.length>0)for(const l of D)(0,b.$6E)(l)&&s.push(l.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const n=[];return this.w.forEach(s=>n.push(s)),n}addBreakpoints(n){const s=n.filter(l=>{const g=l.id;return this.w.has(g)?!1:(this.w.set(g,l),!0)});this.U(s,[],[]);const p=[],D=new Map;for(const l of s)if(l instanceof E.$zK){let g=D.get(l.location.uri.toString());g||(g={type:"sourceMulti",uri:l.location.uri,lines:[]},D.set(l.location.uri.toString(),g),p.push(g)),g.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof E.$AK&&p.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(p)}removeBreakpoints(n){const s=n.filter(g=>this.w.delete(g.id));this.U([],s,[]);const p=s.filter(g=>g instanceof E.$zK).map(g=>g.id),D=s.filter(g=>g instanceof E.$AK).map(g=>g.id),l=s.filter(g=>g instanceof E.$BK).map(g=>g.id);return this.k.$unregisterBreakpoints(p,D,l)}startDebugging(n,s,p){return this.k.$startDebugging(n?n.uri:void 0,s,{parentSessionID:p.parentSession?p.parentSession.id:void 0,lifecycleManagedByParent:p.lifecycleManagedByParent,repl:p.consoleMode===E.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:p.noDebug,compact:p.compact,suppressSaveBeforeStart:p.suppressSaveBeforeStart,suppressDebugStatusbar:p.suppressDebugStatusbar??p.debugUI?.simple,suppressDebugToolbar:p.suppressDebugToolbar??p.debugUI?.simple,suppressDebugView:p.suppressDebugView??p.debugUI?.simple})}stopDebugging(n){return this.k.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,s,p){if(!s)return new E.$zJ(()=>{});const D=this.d++;return this.f.push({type:n,handle:D,provider:s}),this.k.$registerDebugConfigurationProvider(n,p,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,D),new E.$zJ(()=>{this.f=this.f.filter(l=>l.provider!==s),this.k.$unregisterDebugConfigurationProvider(D)})}registerDebugAdapterDescriptorFactory(n,s,p){if(!p)return new E.$zJ(()=>{});if(!this.Q(n,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.N(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const D=this.g++;return this.h.push({type:s,handle:D,factory:p}),this.k.$registerDebugAdapterDescriptorFactory(s,D),new E.$zJ(()=>{this.h=this.h.filter(l=>l.factory!==p),this.k.$unregisterDebugAdapterDescriptorFactory(D)})}registerDebugAdapterTrackerFactory(n,s){if(!s)return new E.$zJ(()=>{});const p=this.i++;return this.j.push({type:n,handle:p,factory:s}),new E.$zJ(()=>{this.j=this.j.filter(D=>D.factory!==s)})}async $runInTerminal(n,s){return Promise.resolve(void 0)}async $substituteVariables(n,s){let p;const D=await this.W(n);return D&&(p={uri:D.uri,name:D.name,index:D.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(p,s)}K(n,s){if(n.type==="implementation")return new C(n.implementation)}L(){}async $startDASession(n,s){const p=this,D=await this.V(s);return this.S(this.N(D.type),D).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}' (extension might have failed to activate)`);const g=this.M(l),v=this.K(g,D);if(!v)throw new Error(`Couldn't create a debug adapter for type '${D.type}'.`);const u=v;return this.B.set(n,u),this.R(D).then(f=>(f&&this.C.set(n,f),u.onMessage(async A=>{if(A.type==="request"&&A.command==="handshake"){const W=A,B={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(W.arguments.value);B.body={signature:V},u.sendResponse(B)}else throw new Error("no signer")}catch(V){B.success=!1,B.message=V.message,u.sendResponse(B)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(A),A=(0,b.$$E)(A,!0),p.k.$acceptDAMessage(n,A)}),u.onError(A=>{f&&f.onError&&f.onError(A),this.k.$acceptDAError(n,A.name,A.message,A.stack)}),u.onExit(A=>{f&&f.onExit&&f.onExit((0,I.$Ae)(A),void 0),this.k.$acceptDAExit(n,(0,I.$Ae)(A),void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),u.startSession()))})}$sendDAMessage(n,s){s=(0,b.$0E)(s,!1);const p=this.C.get(n);p&&p.onWillReceiveMessage&&p.onWillReceiveMessage(s),this.B.get(n)?.sendMessage(s)}$stopDASession(n){const s=this.C.get(n);this.C.delete(n),s&&s.onWillStopSession&&s.onWillStopSession();const p=this.B.get(n);return this.B.delete(n),p?p.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const s=[],p=[],D=[];if(n.added)for(const l of n.added){const g=l.id;if(g&&!this.w.has(g)){let v;if(l.type==="function")v=new E.$AK(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")v=new E.$BK(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const u=z.URI.revive(l.uri);v=new E.$zK(new E.$LJ(u,new E.$AJ(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,E.$xK)(v,g),this.w.set(g,v),s.push(v)}}if(n.removed)for(const l of n.removed){const g=this.w.get(l);g&&(this.w.delete(l),p.push(g))}if(n.changed){for(const l of n.changed)if(l.id){const g=this.w.get(l.id);if(g){if(g instanceof E.$AK&&l.type==="function"){const v=g;v.enabled=l.enabled,v.condition=l.condition,v.hitCondition=l.hitCondition,v.logMessage=l.logMessage,v.functionName=l.functionName}else if(g instanceof E.$zK&&l.type==="source"){const v=g;v.enabled=l.enabled,v.condition=l.condition,v.hitCondition=l.hitCondition,v.logMessage=l.logMessage,v.location=new E.$LJ(z.URI.revive(l.uri),new E.$AJ(l.line,l.character))}D.push(g)}}}this.U(s,p,D)}async $acceptStackFrameFocus(n){let s;const p=n.sessionId?await this.V(n.sessionId):void 0;if(!p)throw new Error("no DebugSession found for debug focus context");n.kind==="thread"?s=new E.$HK(p,n.threadId):s=new E.$GK(p,n.threadId,n.frameId),this.z=s,this.A.fire(this.z)}$provideDebugConfigurations(n,s,p){return(0,w.$mg)(async()=>{const D=this.P(n);if(!D)throw new Error("no DebugConfigurationProvider found");if(!D.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(s);return D.provideDebugConfigurations(l,p)}).then(D=>{if(!D)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return D})}$resolveDebugConfiguration(n,s,p,D){return(0,w.$mg)(async()=>{const l=this.P(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const g=await this.W(s);return l.resolveDebugConfiguration(g,p,D)})}$resolveDebugConfigurationWithSubstitutedVariables(n,s,p,D){return(0,w.$mg)(async()=>{const l=this.P(n);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const g=await this.W(s);return l.resolveDebugConfigurationWithSubstitutedVariables(g,p,D)})}async $provideDebugAdapter(n,s){const p=this.O(n);if(!p)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const D=await this.V(s);return this.S(p,D).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${D.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(n){const s=await this.V(n);this.m.fire(s)}async $acceptDebugSessionTerminated(n){const s=await this.V(n);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(n){this.q=n?await this.V(n):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(n,s){(await this.V(n))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(n,s){const D={session:await this.V(n),event:s.event,body:s.body};this.u.fire(D)}M(n){if(n instanceof E.$CK)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof E.$DK)return{type:"server",port:n.port,host:n.host};if(n instanceof E.$EK)return{type:"pipeServer",path:n.path};if(n instanceof E.$FK)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}N(n){const s=this.h.filter(p=>p.type===n);if(s.length>0)return s[0].factory}O(n){const s=this.h.filter(p=>p.handle===n);if(s.length>0)return s[0].factory}P(n){const s=this.f.filter(p=>p.handle===n);if(s.length>0)return s[0].provider}Q(n,s){if(n.contributes){const p=n.contributes.debuggers;if(p&&p.length>0){for(const D of p)if(D.label&&D.type&&D.type===s)return!0}}return!1}R(n){const p=n.configuration.type,D=this.j.filter(l=>l.type===p||l.type==="*").map(l=>(0,w.$mg)(()=>l.factory.createDebugAdapterTracker(n)).then(g=>g,g=>null));return Promise.race([Promise.all(D).then(l=>{const g=l.filter(v=>!!v);if(g.length>0)return new S(g)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(n,s){const p=s.configuration.debugServer;if(typeof p=="number")return Promise.resolve(new E.$DK(p));if(n){const l=await this.F.getExtensionRegistry();return(0,w.$mg)(()=>n.createDebugAdapterDescriptor(s,this.T(s,l))).then(g=>{if(g)return g})}const D=await this.F.getExtensionRegistry();return Promise.resolve(this.T(s,D))}T(n,s){}U(n,s,p){(n.length>0||s.length>0||p.length>0)&&this.y.fire(Object.freeze({added:n,removed:s,changed:p}))}async V(n){if(n)if(typeof n=="string"){const s=this.l.get(n);if(s)return s}else{let s=this.l.get(n.id);if(!s){const p=await this.W(n.folderUri),D=n.parent?this.l.get(n.parent):void 0;s=new a(this.k,n.id,n.type,n.name,p,n.configuration,D),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}W(n){if(n){const s=z.URI.revive(n);return this.E.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.$5_b=i,e.$5_b=i=qe([Ve(0,R.$zL),Ve(1,c.$X$b),Ve(2,$.$t_b),Ve(3,o.$1$b),Ve(4,k.$Z_b),Ve(5,t.$2_b)],i);class a{constructor(n,s,p,D,l,g,v){this.d=n,this.f=s,this.g=p,this.h=D,this.i=l,this.j=g,this.k=v}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(n){this.h=n,this.d.$setDebugSessionName(this.f,n)}get parentSession(){return this.k}_acceptNameChanged(n){this.h=n}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(n,s){return this.d.$customDebugAdapterRequest(this.f,n,s)}getDebugProtocolBreakpoint(n){return this.d.$getDebugProtocolBreakpoint(this.f,n.id)}}e.$6_b=a;class m{constructor(n){this.value=Object.freeze({append(s){n.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.$7_b=m;class S{constructor(n){this.d=n}onWillStartSession(){this.d.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(n):void 0)}onWillStopSession(){this.d.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.d.forEach(s=>s.onError?s.onError(n):void 0)}onExit(n,s){this.d.forEach(p=>p.onExit?p.onExit(n,s):void 0)}}class C extends y.$v${constructor(n){super(),this.h=n,n.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.h.handleMessage(n)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let r=class extends i{constructor(n,s,p,D,l,g){super(n,s,p,D,l,g)}};e.$8_b=r,e.$8_b=r=qe([Ve(0,R.$zL),Ve(1,c.$X$b),Ve(2,$.$t_b),Ve(3,o.$1$b),Ve(4,k.$Z_b),Ve(5,t.$2_b)],r)}),define(Ae[266],Re([1,0,11,87,2,4,257,14,72,73,27,172,17,56,35,58]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pac=e.$Oac=void 0;class t{static async installEarlyHandler(m){Error.stackTraceLimit=100;const S=m.get(d.$Pi),r=m.get(c.$zL).getProxy(z.$xJ.MainThreadErrors);w.setUnexpectedErrorHandler(h=>{S.error(h);const n=w.$1(h);r.$onUnexpectedError(n)})}static async installFullHandler(m){const S=m.get(d.$Pi),C=m.get(c.$zL),r=m.get(b.$t_b),h=m.get(o.$TL),n=C.getProxy(z.$xJ.MainThreadExtensionService),s=C.getProxy(z.$xJ.MainThreadErrors),p=await r.getExtensionPathIndex(),D=new WeakMap;function l(u,f){if(D.has(u))return D.get(u).stack;let A="",W,B;for(const U of f)A+=`
	at ${U.toString()}`,B=U.getFileName(),!W&&B&&(W=p.findSubstr(I.URI.file(B)));const V=`${u.name||"Error"}: ${u.message||""}${A}`;return D.set(u,{extensionIdentifier:W?.identifier,stack:V}),V}const g=Symbol("prepareStackTrace wrapped");let v=l;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return v},set(u){if(u===l||u[g]){v=u;return}v=function(f,A){return l(f,A),u.call(Error,f,A)},Object.assign(v,{[g]:!0})}}),w.setUnexpectedErrorHandler(u=>{S.error(u);const f=w.$1(u),A=D.get(u);if(!A?.extensionIdentifier){s.$onUnexpectedError(f);return}n.$onExtensionRuntimeError(A.extensionIdentifier,f);const W=h.onExtensionError(A.extensionIdentifier,u);S.trace("forwarded error to extension?",W,A)})}}e.$Oac=t;class i{constructor(m,S,C,r,h){this.a=C,this.b=new P.$t1b(m,null,r),S=i.e(S,this.b);const n=new $.$lh(...(0,k.$$q)());n.set(R.$PL,{_serviceBrand:void 0,...S,messagePorts:h}),n.set(c.$zL,new c.$AL(this.b)),n.set(y.$U$b,new y.$V$b(r)),n.set(b.$r_b,C);const s=new E.$Sp(n,!0);s.invokeFunction(t.installEarlyHandler),this.d=s.invokeFunction(p=>p.get(d.$Pi)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",S),this.c=s.invokeFunction(p=>p.get(b.$t_b)),this.c.initialize(),s.invokeFunction(t.installFullHandler)}async asBrowserUri(m){const S=this.b.getProxy(z.$xJ.MainThreadExtensionService);return I.URI.revive(await S.$asBrowserUri(m))}terminate(m){this.c.terminate(m)}static e(m,S){m.allExtensions.forEach(r=>{r.extensionLocation=I.URI.revive(S.transformIncomingURIs(r.extensionLocation))}),m.environment.appRoot=I.URI.revive(S.transformIncomingURIs(m.environment.appRoot));const C=m.environment.extensionDevelopmentLocationURI;return C&&(m.environment.extensionDevelopmentLocationURI=C.map(r=>I.URI.revive(S.transformIncomingURIs(r)))),m.environment.extensionTestsLocationURI=I.URI.revive(S.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=I.URI.revive(S.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=I.URI.revive(S.transformIncomingURIs(m.environment.workspaceStorageHome)),m.environment.extensionTelemetryLogResource=I.URI.revive(S.transformIncomingURIs(m.environment.extensionTelemetryLogResource)),m.nlsBaseUrl=I.URI.revive(S.transformIncomingURIs(m.nlsBaseUrl)),m.logsLocation=I.URI.revive(S.transformIncomingURIs(m.logsLocation)),m.workspace=S.transformIncomingURIs(m.workspace),m}}e.$Pac=i}),define(Ae[267],Re([1,0,18,16,20,41,13,19,23,2,47]),function($e,e,w,L,I,z,P,d,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aac=e.$__b=e.$$_b=e.$0_b=void 0;class E{constructor(a,m,S,C){this.d=a,this.e=m,this.f=S,this.g=C,this.a=null,this.b=!1,this.c=0}search(a,m){const S=this.d.folderQueries||[],C=new I.$dd;return m.onCancellationRequested(()=>C.cancel()),new Promise((r,h)=>{this.a=new y(a);let n=!1;const s=(p,D)=>{if(!n&&!this.b){const l=this.h(p);o(p)&&typeof this.d.maxResults=="number"&&this.c+l>this.d.maxResults&&(this.b=!0,n=!0,C.cancel(),p=this.j(p,this.d.maxResults-this.c));const g=this.h(p);this.c+=g,(g>0||!o(p))&&this.a.add(p,D)}};Promise.all(S.map((p,D)=>this.k(p,l=>s(l,D),C.token))).then(p=>{C.dispose(),this.a.flush();const D=p.some(l=>!!l&&!!l.limitHit);r({limitHit:this.b||D,messages:(0,w.$xf)(p.map(l=>l?.message?Array.isArray(l.message)?l.message:[l.message]:[])),stats:{type:this.g}})},p=>{C.dispose();const D=(0,z.$$h)(p);h(new Error(D))})})}h(a){return o(a)?Array.isArray(a.ranges)?a.ranges.length:1:0}j(a,m){const S=Array.isArray(a.ranges)?a.ranges:[a.ranges],C=Array.isArray(a.preview.matches)?a.preview.matches:[a.preview.matches];return{ranges:S.slice(0,m),preview:{matches:C.slice(0,m),text:a.preview.text},uri:a.uri}}async k(a,m,S){const C=new R.$bI(this.d,a),r=[],h={report:p=>{if(!this.l(p))return;const D=a.folder.scheme===P.Schemas.file?(0,R.$cI)(()=>this.f.readdir(k.$7f(p.uri))):void 0,l=k.$0f(a.folder,p.uri);if(l){const g=C.includedInQuery(l,d.$ec(l),D);(0,L.$gg)(g)?r.push(g.then(v=>{v&&m(p)})):g&&m(p)}}},n=this.n(a),s=await this.e.provideTextSearchResults(c(this.d.contentPattern),n,h,S);return r.length&&await Promise.all(r),s}l(a){if(o(a)){if(Array.isArray(a.ranges)){if(!Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(a.preview.matches.length!==a.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(a.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(a){const m=(0,R.$aI)(this.d.includePattern,a.includePattern),S=(0,R.$aI)(this.d.excludePattern,a.excludePattern),C={folder:$.URI.from(a.folder),excludes:S,includes:m,useIgnoreFiles:!a.disregardIgnoreFiles,useGlobalIgnoreFiles:!a.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!a.disregardParentIgnoreFiles,followSymlinks:!a.ignoreSymlinks,encoding:a.fileEncoding&&this.f.toCanonicalName(a.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return C.usePCRE2=this.d.usePCRE2,C}}e.$0_b=E;function c(i){return{isCaseSensitive:i.isCaseSensitive||!1,isRegExp:i.isRegExp||!1,isWordMatch:i.isWordMatch||!1,isMultiline:i.isMultiline||!1,pattern:i.pattern}}class y{constructor(a){this.e=a,this.b=-1,this.d=null,this.a=new t(512,m=>this.g(m))}add(a,m){this.d&&(this.b!==m||!k.$1f(this.c,a.uri))&&(this.f(),this.d=null),this.d||(this.b=m,this.d={resource:a.uri,results:[]}),this.d.results.push(b(a))}f(){const a=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,a)}flush(){this.f(),this.a.flush()}g(a){this.e(a)}}e.$$_b=y;function b(i){return o(i)?{preview:{matches:(0,w.$Hf)(i.preview.matches,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character})),text:i.preview.text},ranges:(0,w.$Hf)(i.ranges,a=>({startLineNumber:a.start.line,startColumn:a.start.character,endLineNumber:a.end.line,endColumn:a.end.character}))}:{text:i.text,lineNumber:i.lineNumber}}function o(i){return!!i.preview}e.$__b=o;class t{static{this.a=4e3}static{this.b=50}constructor(a,m){this.g=a,this.h=m,this.c=0,this.d=[],this.e=0}addItem(a,m){a&&this.j(a,m)}addItems(a,m){a&&this.k(a,m)}j(a,m){this.d.push(a),this.e+=m,this.l()}k(a,m){this.d=this.d.concat(a),this.e+=m,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$aac=t}),define(Ae[114],Re([1,0,6,4,3,262,17,56,14,2,267]),function($e,e,w,L,I,z,P,d,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dac=e.$cac=e.$bac=void 0,e.$bac=(0,I.$nh)("IExtHostSearch");let E=class{constructor(o,t,i){this.k=o,this.l=t,this.n=i,this.c=this.k.getProxy(L.$xJ.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new z.$9_b}o(o){return this.l.transformOutgoingScheme(o)}registerTextSearchProvider(o,t){if(this.g.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this.g.add(o);const i=this.d++;return this.e.set(i,t),this.c.$registerTextSearchProvider(i,this.o(o)),(0,w.$jb)(()=>{this.g.delete(o),this.e.delete(i),this.c.$unregisterProvider(i)})}registerFileSearchProvider(o,t){if(this.i.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this.i.add(o);const i=this.d++;return this.h.set(i,t),this.c.$registerFileSearchProvider(i,this.o(o)),(0,w.$jb)(()=>{this.i.delete(o),this.h.delete(i),this.c.$unregisterProvider(i)})}$provideFileSearchResults(o,t,i,a){const m=c(i),S=this.h.get(o);if(S)return this.j.fileSearch(m,S,C=>{this.c.$handleFileMatch(o,t,C.map(r=>r.resource))},a);throw new Error("unknown provider: "+o)}$clearCache(o){return this.j.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,t,i,a){const m=this.e.get(o);if(!m||!m.provideTextSearchResults)throw new Error(`Unknown provider ${o}`);const S=c(i);return this.q(S,m).search(r=>this.c.$handleTextMatch(o,t,r),a)}$enableExtensionHostSearch(){}q(o,t){return new R.$0_b(o,t,{readdir:i=>Promise.resolve([]),toCanonicalName:i=>i},"textSearchProvider")}};e.$cac=E,e.$cac=E=qe([Ve(0,P.$zL),Ve(1,d.$U$b),Ve(2,k.$Pi)],E);function c(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(y),extraFileResources:b.extraFileResources&&b.extraFileResources.map(o=>$.URI.revive(o))}}e.$dac=c;function y(b){return{...b,folder:$.URI.revive(b.folder)}}}),define(Ae[268],Re([1,0,20,11,5,29,2,135,278,124,133,38,4,79,221,220,32,222,34,224,225,226,204,227,60,35,228,229,234,235,237,109,208,243,244,247,84,63,249,211,8,7,53,252,64,108,33,21,199,233,51,107,111,113,114,14,56,17,27,238,197,86,80,217,250,85,62,255,253,254,218,39,248,251,83,61,58,239,110,240,13,95,207,190,231,6,26,195,81,186,241,242,219,230,206,245,232,82,246]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S,C,r,h,n,s,p,D,l,g,v,u,f,A,W,B,V,U,O,N,ae,Q,be,ke,Fe,G,Z,le,ne,de,ue,T,_,ye,Ce,Se,Ee,Ie,se,fe,ee,ie,he,F,q,J,K,oe,H,ce,pe,Oe,Be,Ze,Ke,Qe,Ge,ct,xe,tt,Ne,nt,x,Y,me,je,ze,Xe,et,gt,wt,Ot,Jt,Wt,yt,Rt,Ft,Mt,Ut){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=void 0;function Lt(st){const ht=st.get(se.$PL),jt=st.get(Oe.$K$b),Tt=st.get(K.$d_b),kt=st.get(s.$t_b),ot=st.get(Z.$X$b),Pt=st.get(Ge.$TL),zt=st.get(a.$1$b),Pe=st.get(Ee.$U$b),we=st.get(Ie.$zL),ve=st.get(V.$_$b),X=st.get(J.$e_b),Le=st.get(Se.$Qi),Ue=st.get(Se.$Pi),He=st.get(ie.$Tpb),We=st.get(he.$N$b),_e=st.get(G.$R_b),bt=st.get(Ke.$l_b),Dt=st.get(Qe.$Z_b),St=st.get(Mt.$p_b);we.set(c.$yJ.ExtHostFileSystemInfo,jt),we.set(c.$yJ.ExtHostLogLevelServiceShape,Le),we.set(c.$yJ.ExtHostWorkspace,ot),we.set(c.$yJ.ExtHostConfiguration,zt),we.set(c.$yJ.ExtHostExtensionService,kt),we.set(c.$yJ.ExtHostStorage,ve),we.set(c.$yJ.ExtHostTunnelService,He),we.set(c.$yJ.ExtHostWindow,_e),we.set(c.$yJ.ExtHostSecretState,bt),we.set(c.$yJ.ExtHostTelemetry,Pt),we.set(c.$yJ.ExtHostEditorTabs,Dt),we.set(c.$yJ.ExtHostManagedSockets,St);const pt=we.set(c.$yJ.ExtHostDecorations,st.get(T.$V_b)),mt=we.set(c.$yJ.ExtHostDocumentsAndEditors,st.get(n.$KL)),lt=we.set(c.$yJ.ExtHostCommands,st.get(t.$VL)),$t=we.set(c.$yJ.ExtHostTerminalService,st.get(U.$g_b)),ft=we.set(c.$yJ.ExtHostDebugService,st.get(ye.$4_b)),Zt=we.set(c.$yJ.ExtHostSearch,st.get(Ce.$bac)),Bt=we.set(c.$yJ.ExtHostTask,st.get(_.$Y_b)),Qi=we.set(c.$yJ.ExtHostOutputService,st.get(u.$B_b)),hi=we.set(c.$yJ.ExtHostLocalization,st.get(et.$o_b)),di=we.set(c.$yJ.ExtHostUrls,new ke.$K_b(we)),It=we.set(c.$yJ.ExtHostDocuments,new h.$I$b(we,mt)),yi=we.set(c.$yJ.ExtHostDocumentContentProviders,new C.$3$b(we,mt,Ue)),Kt=we.set(c.$yJ.ExtHostDocumentSaveParticipant,new r.$4$b(Ue,It,we.getProxy(c.$xJ.MainThreadBulkEdits))),Et=we.set(c.$yJ.ExtHostNotebook,new fe.$hac(we,lt,mt,It,Tt)),Ei=we.set(c.$yJ.ExtHostNotebookDocuments,new Y.$zac(Et)),fi=we.set(c.$yJ.ExtHostNotebookEditors,new x.$yac(Ue,Et)),ai=we.set(c.$yJ.ExtHostNotebookKernels,new ct.$vac(we,ht,Et,lt,Ue)),_i=we.set(c.$yJ.ExtHostNotebookRenderers,new tt.$xac(we,Et)),ni=we.set(c.$yJ.ExtHostNotebookDocumentSaveParticipant,new yt.$Fac(Ue,Et,we.getProxy(c.$xJ.MainThreadBulkEdits))),At=we.set(c.$yJ.ExtHostEditors,new O.$I_b(we,mt)),gi=we.set(c.$yJ.ExtHostTreeViews,new N.$J_b(we.getProxy(c.$xJ.MainThreadTreeViews),lt,Ue)),ki=we.set(c.$yJ.ExtHostEditorInsets,new ne.$S_b(we.getProxy(c.$xJ.MainThreadEditorInsets),At,ht.remote)),ri=we.set(c.$yJ.ExtHostDiagnostics,new m.$M$b(we,Ue,jt,mt)),si=we.set(c.$yJ.ExtHostLanguages,new g.$y_b(we,It,lt.converter,Pe)),at=we.set(c.$yJ.ExtHostLanguageFeatures,new l.$Q$b(we,Pe,It,lt,ri,Ue,We,Pt)),Di=we.set(c.$yJ.ExtHostFileSystem,new p.$w_b(we,at)),Ht=we.set(c.$yJ.ExtHostFileSystemEventService,new D.$x_b(we,Ue,mt)),xt=we.set(c.$yJ.ExtHostQuickOpen,(0,A.$D_b)(we,ot,lt)),mi=we.set(c.$yJ.ExtHostSCM,new W.$F_b(we,lt,It,Ue)),Oi=we.set(c.$yJ.ExtHostQuickDiff,new Ot.$Cac(we,Pe)),Si=we.set(c.$yJ.ExtHostShare,new Ut.$Iac(we,Pe)),Ii=we.set(c.$yJ.ExtHostComments,(0,i.$T$b)(we,lt,It)),$i=we.set(c.$yJ.ExtHostProgress,new f.$C_b(we.getProxy(c.$xJ.MainThreadProgress))),Ci=we.set(c.$yJ.ExtHosLabelService,new de.$T_b(we)),Pi=we.set(c.$yJ.ExtHostTheming,new ee.$iac(we)),ei=we.set(c.$yJ.ExtHostAuthentication,new F.$jac(we)),Ai=we.set(c.$yJ.ExtHostTimeline,new q.$lac(we,lt)),pi=we.set(c.$yJ.ExtHostWebviews,new Fe.$N_b(we,ht.remote,ot,Ue,We)),bi=we.set(c.$yJ.ExtHostWebviewPanels,new ce.$nac(we,pi,ot)),Ui=we.set(c.$yJ.ExtHostCustomEditors,new H.$oac(we,It,X,pi,bi)),ji=we.set(c.$yJ.ExtHostWebviewViews,new oe.$mac(we,pi)),oi=we.set(c.$yJ.ExtHostTesting,new Be.$qac(we,lt,mt)),xi=we.set(c.$yJ.ExtHostUriOpeners,new Ze.$uac(we)),en=we.set(c.$yJ.ExtHostProfileContentHandlers,new wt.$Bac(we));we.set(c.$yJ.ExtHostInteractive,new me.$Aac(we,Et,mt,lt,Ue));const Ri=we.set(c.$yJ.ExtHostInlineChat,new Wt.$Eac(we,lt,It,Ue)),Qt=we.set(c.$yJ.ExtHostChat,new Jt.$Dac(we,Ue)),tn=we.set(c.$yJ.ExtHostSemanticSimilarity,new Rt.$Gac(we)),nn=we.set(c.$yJ.ExtHostIssueReporter,new Ft.$Hac(we)),Fi=we.set(c.$yJ.ExtHostStatusBar,new B.$H_b(we,lt.converter)),Li=Object.values(c.$yJ);we.assertRegistered(Li);const Bi=new pe.$pac(we,mt),Wi=new o.$S$b(we),vi=new v.$z_b(we,Ue),Vi=new S.$2$b(we);return b.$R$b.register(lt),function(Me,Gt,Xt){const dt=function(){let te=!Me.isUnderDevelopment;function ge(){te||(Ue.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),te=!0)}return function Te(it){if(Array.isArray(it))it.forEach(Te);else if(typeof it=="string")ge();else{const vt=it;typeof vt.scheme>"u"&&ge(),typeof vt.exclusive=="boolean"&&(0,ze.$wF)(Me,"documentFiltersExclusive")}return it}}(),rn={getSession(te,ge,Te){return ei.getSession(Me,te,ge,Te)},getSessions(te,ge){return(0,ze.$wF)(Me,"authGetSessions"),ei.getSessions(Me,te,ge)},async hasSession(te,ge){return(0,ze.$wF)(Me,"authSession"),!!await ei.getSession(Me,te,ge,{silent:!0})},get onDidChangeSessions(){return ei.onDidChangeSessions},registerAuthenticationProvider(te,ge,Te,it){return ei.registerAuthenticationProvider(te,ge,Te,it)}},Vt={registerCommand(te,ge,Te){return lt.registerCommand(!0,te,ge,Te,void 0,Me)},registerTextEditorCommand(te,ge,Te){return lt.registerCommand(!0,te,(...it)=>{const vt=At.getActiveTextEditor();if(!vt){Ue.warn("Cannot execute "+te+" because there is no active text editor.");return}return vt.edit(Ct=>{ge.apply(Te,[vt,Ct,...it])}).then(Ct=>{Ct||Ue.warn("Edits from command "+te+" were not applied.")},Ct=>{Ue.warn("An error occurred while running command "+te,Ct)})},void 0,void 0,Me)},registerDiffInformationCommand:(te,ge,Te)=>((0,ze.$wF)(Me,"diffCommand"),lt.registerCommand(!0,te,async(...it)=>{const vt=mt.activeEditor(!0);if(!vt){Ue.warn("Cannot execute "+te+" because there is no active text editor.");return}const Ct=await At.getDiffInformation(vt.id);ge.apply(Te,[Ct,...it])},void 0,void 0,Me)),executeCommand(te,...ge){return lt.executeCommand(te,...ge)},getCommands(te=!1){return lt.getCommands(te)}},ci={get machineId(){return ht.telemetryInfo.machineId},get sessionId(){return ht.telemetryInfo.sessionId},get language(){return ht.environment.appLanguage},get appName(){return ht.environment.appName},get appRoot(){return ht.environment.appRoot?.fsPath??""},get appHost(){return ht.environment.appHost},get uriScheme(){return ht.environment.appUriScheme},get clipboard(){return Wi.value},get shell(){return $t.getDefaultShell(!1)},get onDidChangeShell(){return(0,ze.$wF)(Me,"envShellEvent"),$t.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,ze.$wF)(Me,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,ze.$wF)(Me,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,Ge.$SL)(ht.telemetryInfo.firstSessionDate)},createTelemetryLogger(te,ge){return Ge.$RL.validateSender(te),Pt.instantiateLogger(Me,te,ge)},openExternal(te,ge){return _e.openUri(te,{allowTunneling:!!ht.remote.authority,allowContributedOpeners:ge?.allowContributedOpeners})},async asExternalUri(te){if(te.scheme===ht.environment.appUriScheme)return di.createAppUri(te);try{return await _e.asExternalUri(te,{allowTunneling:!!ht.remote.authority})}catch(ge){if((0,nt.$6Y)(te,Ne.Schemas.http)||(0,nt.$6Y)(te,Ne.Schemas.https))return te;throw ge}},get remoteName(){return(0,ue.$Ak)(ht.remote.authority)},get remoteAuthority(){return(0,ze.$wF)(Me,"resolvers"),ht.remote.authority},get uiKind(){return ht.uiKind},get logLevel(){return Ue.getLevel()},get onDidChangeLogLevel(){return Ue.onDidChangeLogLevel},registerIssueUriRequestHandler(te){return(0,ze.$wF)(Me,"handleIssueUri"),nn.registerIssueUriRequestHandler(Me,te)},get appQuality(){return(0,ze.$wF)(Me,"resolvers"),ht.quality},get appCommit(){return(0,ze.$wF)(Me,"resolvers"),ht.commit}};ht.environment.extensionTestsLocationURI||Object.freeze(ci);const qi={createTestController(te,ge,Te){return oi.createTestController(Me,te,ge,Te)},createTestObserver(){return(0,ze.$wF)(Me,"testObserver"),oi.createTestObserver()},runTests(te){return(0,ze.$wF)(Me,"testObserver"),oi.runTests(te)},get onDidChangeTestResults(){return(0,ze.$wF)(Me,"testObserver"),oi.onResultsChanged},get testResults(){return(0,ze.$wF)(Me,"testObserver"),oi.results}},ui=ht.remote.isRemote?Q.ExtensionKind.Workspace:Q.ExtensionKind.UI,Ji={getExtension(te,ge){(0,ze.$vF)(Me,"extensionsAny")||(ge=!1);const Te=Gt.mine.getExtensionDescription(te);if(Te)return new s.$u_b(kt,Me.identifier,Te,ui,!1);if(ge){const it=Gt.all.getExtensionDescription(te);if(it)return new s.$u_b(kt,Me.identifier,it,ui,!0)}},get all(){const te=[];for(const ge of Gt.mine.getAllExtensionDescriptions())te.push(new s.$u_b(kt,Me.identifier,ge,ui,!1));return te},get allAcrossExtensionHosts(){(0,ze.$wF)(Me,"extensionsAny");const te=new le.$Gl(Gt.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),ge=[];for(const Te of Gt.all.getAllExtensionDescriptions()){const it=!te.has(Te.identifier);ge.push(new s.$u_b(kt,Me.identifier,Te,ui,it))}return ge},get onDidChange(){return(0,ze.$vF)(Me,"extensionsAny")?I.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},Ki={createDiagnosticCollection(te){return ri.createDiagnosticCollection(Me.identifier,te)},get onDidChangeDiagnostics(){return ri.onDidChangeDiagnostics},getDiagnostics:te=>ri.getDiagnostics(te),getLanguages(){return si.getLanguages()},setTextDocumentLanguage(te,ge){return si.changeLanguage(te.uri,ge)},match(te,ge){const Te=It.getDocumentData(ge.uri)?.notebook;return(0,R.$VE)(ae.LanguageSelector.from(te),ge.uri,ge.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(te,ge,Te){return at.registerCodeActionProvider(Me,dt(te),ge,Te)},registerDocumentPasteEditProvider(te,ge,Te){return(0,ze.$wF)(Me,"documentPaste"),at.registerDocumentPasteEditProvider(Me,dt(te),ge,Te)},registerCodeLensProvider(te,ge){return at.registerCodeLensProvider(Me,dt(te),ge)},registerDefinitionProvider(te,ge){return at.registerDefinitionProvider(Me,dt(te),ge)},registerDeclarationProvider(te,ge){return at.registerDeclarationProvider(Me,dt(te),ge)},registerImplementationProvider(te,ge){return at.registerImplementationProvider(Me,dt(te),ge)},registerTypeDefinitionProvider(te,ge){return at.registerTypeDefinitionProvider(Me,dt(te),ge)},registerHoverProvider(te,ge){return at.registerHoverProvider(Me,dt(te),ge,Me.identifier)},registerEvaluatableExpressionProvider(te,ge){return at.registerEvaluatableExpressionProvider(Me,dt(te),ge,Me.identifier)},registerInlineValuesProvider(te,ge){return at.registerInlineValuesProvider(Me,dt(te),ge,Me.identifier)},registerDocumentHighlightProvider(te,ge){return at.registerDocumentHighlightProvider(Me,dt(te),ge)},registerLinkedEditingRangeProvider(te,ge){return at.registerLinkedEditingRangeProvider(Me,dt(te),ge)},registerReferenceProvider(te,ge){return at.registerReferenceProvider(Me,dt(te),ge)},registerRenameProvider(te,ge){return at.registerRenameProvider(Me,dt(te),ge)},registerDocumentSymbolProvider(te,ge,Te){return at.registerDocumentSymbolProvider(Me,dt(te),ge,Te)},registerWorkspaceSymbolProvider(te){return at.registerWorkspaceSymbolProvider(Me,te)},registerDocumentFormattingEditProvider(te,ge){return at.registerDocumentFormattingEditProvider(Me,dt(te),ge)},registerDocumentRangeFormattingEditProvider(te,ge){return at.registerDocumentRangeFormattingEditProvider(Me,dt(te),ge)},registerOnTypeFormattingEditProvider(te,ge,Te,...it){return at.registerOnTypeFormattingEditProvider(Me,dt(te),ge,[Te].concat(it))},registerDocumentSemanticTokensProvider(te,ge,Te){return at.registerDocumentSemanticTokensProvider(Me,dt(te),ge,Te)},registerDocumentRangeSemanticTokensProvider(te,ge,Te){return at.registerDocumentRangeSemanticTokensProvider(Me,dt(te),ge,Te)},registerSignatureHelpProvider(te,ge,Te,...it){return typeof Te=="object"?at.registerSignatureHelpProvider(Me,dt(te),ge,Te):at.registerSignatureHelpProvider(Me,dt(te),ge,typeof Te>"u"?[]:[Te,...it])},registerCompletionItemProvider(te,ge,...Te){return at.registerCompletionItemProvider(Me,dt(te),ge,Te)},registerInlineCompletionItemProvider(te,ge,Te){return ge.handleDidShowCompletionItem&&(0,ze.$wF)(Me,"inlineCompletionsAdditions"),ge.handleDidPartiallyAcceptCompletionItem&&(0,ze.$wF)(Me,"inlineCompletionsAdditions"),Te&&(0,ze.$wF)(Me,"inlineCompletionsAdditions"),at.registerInlineCompletionsProvider(Me,dt(te),ge,Te)},registerDocumentLinkProvider(te,ge){return at.registerDocumentLinkProvider(Me,dt(te),ge)},registerColorProvider(te,ge){return at.registerColorProvider(Me,dt(te),ge)},registerFoldingRangeProvider(te,ge){return at.registerFoldingRangeProvider(Me,dt(te),ge)},registerSelectionRangeProvider(te,ge){return at.registerSelectionRangeProvider(Me,te,ge)},registerCallHierarchyProvider(te,ge){return at.registerCallHierarchyProvider(Me,te,ge)},registerTypeHierarchyProvider(te,ge){return at.registerTypeHierarchyProvider(Me,te,ge)},setLanguageConfiguration:(te,ge)=>at.setLanguageConfiguration(Me,te,ge),getTokenInformationAtPosition(te,ge){return(0,ze.$wF)(Me,"tokenInformation"),si.tokenAtPosition(te,ge)},registerInlayHintsProvider(te,ge){return at.registerInlayHintsProvider(Me,te,ge)},createLanguageStatusItem(te,ge){return si.createLanguageStatusItem(Me,te,ge)},registerDocumentDropEditProvider(te,ge,Te){return at.registerDocumentOnDropEditProvider(Me,te,ge,(0,ze.$vF)(Me,"dropMetadata")?Te:void 0)}},sn={get activeTextEditor(){return At.getActiveTextEditor()},get visibleTextEditors(){return At.getVisibleTextEditors()},get activeTerminal(){return $t.activeTerminal},get terminals(){return $t.terminals},async showTextDocument(te,ge,Te){const it=await(P.URI.isUri(te)?Promise.resolve(Ti.openTextDocument(te)):Promise.resolve(te));return At.showTextDocument(it,ge,Te)},createTextEditorDecorationType(te){return At.createTextEditorDecorationType(Me,te)},onDidChangeActiveTextEditor(te,ge,Te){return At.onDidChangeActiveTextEditor(te,ge,Te)},onDidChangeVisibleTextEditors(te,ge,Te){return At.onDidChangeVisibleTextEditors(te,ge,Te)},onDidChangeTextEditorSelection(te,ge,Te){return At.onDidChangeTextEditorSelection(te,ge,Te)},onDidChangeTextEditorOptions(te,ge,Te){return At.onDidChangeTextEditorOptions(te,ge,Te)},onDidChangeTextEditorVisibleRanges(te,ge,Te){return At.onDidChangeTextEditorVisibleRanges(te,ge,Te)},onDidChangeTextEditorViewColumn(te,ge,Te){return At.onDidChangeTextEditorViewColumn(te,ge,Te)},onDidCloseTerminal(te,ge,Te){return $t.onDidCloseTerminal(te,ge,Te)},onDidOpenTerminal(te,ge,Te){return $t.onDidOpenTerminal(te,ge,Te)},onDidChangeActiveTerminal(te,ge,Te){return $t.onDidChangeActiveTerminal(te,ge,Te)},onDidChangeTerminalDimensions(te,ge,Te){return(0,ze.$wF)(Me,"terminalDimensions"),$t.onDidChangeTerminalDimensions(te,ge,Te)},onDidChangeTerminalState(te,ge,Te){return $t.onDidChangeTerminalState(te,ge,Te)},onDidWriteTerminalData(te,ge,Te){return(0,ze.$wF)(Me,"terminalDataWriteEvent"),$t.onDidWriteTerminalData(te,ge,Te)},get state(){return _e.getState(Me)},onDidChangeWindowState(te,ge,Te){return _e.onDidChangeWindowState(te,ge,Te)},showInformationMessage(te,...ge){return vi.showMessage(Me,z.default.Info,te,ge[0],ge.slice(1))},showWarningMessage(te,...ge){return vi.showMessage(Me,z.default.Warning,te,ge[0],ge.slice(1))},showErrorMessage(te,...ge){return vi.showMessage(Me,z.default.Error,te,ge[0],ge.slice(1))},showQuickPick(te,ge,Te){return xt.showQuickPick(Me,te,ge,Te)},showWorkspaceFolderPick(te){return xt.showWorkspaceFolderPick(te)},showInputBox(te,ge){return xt.showInput(te,ge)},showOpenDialog(te){return Vi.showOpenDialog(Me,te)},showSaveDialog(te){return Vi.showSaveDialog(te)},createStatusBarItem(te,ge,Te){let it,vt,Ct;return typeof te=="string"?(it=te,vt=ge,Ct=Te):(vt=te,Ct=ge),Fi.createStatusBarEntry(Me,it,vt,Ct)},setStatusBarMessage(te,ge){return Fi.setStatusBarMessage(te,ge)},withScmProgress(te){return We.report("window.withScmProgress",Me,"Use 'withProgress' instead."),$i.withProgress(Me,{location:Q.ProgressLocation.SourceControl},(ge,Te)=>te({report(it){}}))},withProgress(te,ge){return $i.withProgress(Me,te,ge)},createOutputChannel(te,ge){return Qi.createOutputChannel(te,ge,Me)},createWebviewPanel(te,ge,Te,it){return bi.createWebviewPanel(Me,te,ge,Te,it)},createWebviewTextEditorInset(te,ge,Te,it){return(0,ze.$wF)(Me,"editorInsets"),ki.createWebviewEditorInset(te,ge,Te,it,Me)},createTerminal(te,ge,Te){return typeof te=="object"?"pty"in te?$t.createExtensionTerminal(te):$t.createTerminalFromOptions(te):$t.createTerminal(te,ge,Te)},registerTerminalLinkProvider(te){return $t.registerLinkProvider(te)},registerTerminalProfileProvider(te,ge){return $t.registerProfileProvider(Me,te,ge)},registerTerminalQuickFixProvider(te,ge){return(0,ze.$wF)(Me,"terminalQuickFixProvider"),$t.registerTerminalQuickFixProvider(te,Me.identifier.value,ge)},registerTreeDataProvider(te,ge){return gi.registerTreeDataProvider(te,ge,Me)},createTreeView(te,ge){return gi.createTreeView(te,ge,Me)},registerWebviewPanelSerializer:(te,ge)=>bi.registerWebviewPanelSerializer(Me,te,ge),registerCustomEditorProvider:(te,ge,Te={})=>Ui.registerCustomEditorProvider(Me,te,ge,Te),registerFileDecorationProvider(te){return pt.registerFileDecorationProvider(te,Me)},registerUriHandler(te){return di.registerUriHandler(Me,te)},createQuickPick(){return xt.createQuickPick(Me)},createInputBox(){return xt.createInputBox(Me)},get activeColorTheme(){return Pi.activeColorTheme},onDidChangeActiveColorTheme(te,ge,Te){return Pi.onDidChangeActiveColorTheme(te,ge,Te)},registerWebviewViewProvider(te,ge,Te){return ji.registerWebviewViewProvider(Me,te,ge,Te?.webviewOptions)},get activeNotebookEditor(){return Et.activeNotebookEditor},onDidChangeActiveNotebookEditor(te,ge,Te){return Et.onDidChangeActiveNotebookEditor(te,ge,Te)},get visibleNotebookEditors(){return Et.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Et.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(te,ge,Te){return fi.onDidChangeNotebookEditorSelection(te,ge,Te)},onDidChangeNotebookEditorVisibleRanges(te,ge,Te){return fi.onDidChangeNotebookEditorVisibleRanges(te,ge,Te)},showNotebookDocument(te,ge){return Et.showNotebookDocument(te,ge)},registerExternalUriOpener(te,ge,Te){return(0,ze.$wF)(Me,"externalUriOpener"),xi.registerExternalUriOpener(Me.identifier,te,ge,Te)},registerProfileContentHandler(te,ge){return(0,ze.$wF)(Me,"profileContentHandlers"),en.registrProfileContentHandler(Me,te,ge)},registerQuickDiffProvider(te,ge,Te,it){return(0,ze.$wF)(Me,"quickDiffProvider"),Oi.registerQuickDiffProvider(dt(te),ge,Te,it)},get tabGroups(){return Dt.tabGroups},registerShareProvider(te,ge){return(0,ze.$wF)(Me,"shareProvider"),Si.registerShareProvider(dt(te),ge)}},Ti={get rootPath(){return We.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(te){throw L.$7()},getWorkspaceFolder(te){return ot.getWorkspaceFolder(te)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(te){throw L.$7()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(te){throw L.$7()},updateWorkspaceFolders:(te,ge,...Te)=>ot.updateWorkspaceFolders(Me,te,ge||0,...Te),onDidChangeWorkspaceFolders:function(te,ge,Te){return ot.onDidChangeWorkspace(te,ge,Te)},asRelativePath:(te,ge)=>ot.getRelativePath(te,ge),findFiles:(te,ge,Te,it)=>ot.findFiles(te,ge,Te,Me.identifier,it),findTextInFiles:(te,ge,Te,it)=>{(0,ze.$wF)(Me,"findTextInFiles");let vt,Ct;return typeof ge=="object"?(vt=ge,Ct=Te):(vt={},Ct=ge,it=Te),ot.findTextInFiles(te,vt||{},Ct,Me.identifier,it)},save:te=>((0,ze.$wF)(Me,"saveEditor"),ot.save(te)),saveAs:te=>((0,ze.$wF)(Me,"saveEditor"),ot.saveAs(te)),saveAll:te=>ot.saveAll(te),applyEdit(te,ge){return Bi.applyWorkspaceEdit(te,Me,ge)},createFileSystemWatcher:(te,ge,Te,it)=>Ht.createFileSystemWatcher(ot,Me,te,ge,Te,it),get textDocuments(){return It.getAllDocumentData().map(te=>te.document)},set textDocuments(te){throw L.$7()},openTextDocument(te){let ge;const Te=te;if(typeof te=="string")ge=Promise.resolve(P.URI.file(te));else if(P.URI.isUri(te))ge=Promise.resolve(te);else if(!Te||typeof Te=="object")ge=It.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ge.then(it=>It.ensureDocumentData(it).then(vt=>vt.document))},onDidOpenTextDocument:(te,ge,Te)=>It.onDidAddDocument(te,ge,Te),onDidCloseTextDocument:(te,ge,Te)=>It.onDidRemoveDocument(te,ge,Te),onDidChangeTextDocument:(te,ge,Te)=>It.onDidChangeDocument(te,ge,Te),onDidSaveTextDocument:(te,ge,Te)=>It.onDidSaveDocument(te,ge,Te),onWillSaveTextDocument:(te,ge,Te)=>Kt.getOnWillSaveTextDocumentEvent(Me)(te,ge,Te),get notebookDocuments(){return Et.notebookDocuments.map(te=>te.apiNotebook)},async openNotebookDocument(te,ge){let Te;if(P.URI.isUri(te))Te=te,await Et.openNotebookDocument(te);else if(typeof te=="string")Te=P.URI.revive(await Et.createNotebookDocument({viewType:te,content:ge}));else throw new Error("Invalid arguments");return Et.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(te,ge,Te){return Ei.onDidSaveNotebookDocument(te,ge,Te)},onDidChangeNotebookDocument(te,ge,Te){return Ei.onDidChangeNotebookDocument(te,ge,Te)},onWillSaveNotebookDocument(te,ge,Te){return ni.getOnWillSaveNotebookDocumentEvent(Me)(te,ge,Te)},get onDidOpenNotebookDocument(){return Et.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Et.onDidCloseNotebookDocument},registerNotebookSerializer(te,ge,Te,it){return Et.registerNotebookSerializer(Me,te,ge,Te,(0,ze.$vF)(Me,"notebookLiveShare")?it:void 0)},onDidChangeConfiguration:(te,ge,Te)=>Xt.onDidChangeConfiguration(te,ge,Te),getConfiguration(te,ge){return ge=arguments.length===1?void 0:ge,Xt.getConfiguration(te,ge,Me)},registerTextDocumentContentProvider(te,ge){return yi.registerTextDocumentContentProvider(te,ge)},registerTaskProvider:(te,ge)=>(We.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),Bt.registerTaskProvider(Me,te,ge)),registerFileSystemProvider(te,ge,Te){return(0,je.$ib)(Di.registerFileSystemProvider(Me,te,ge,Te),Tt.addFileSystemProvider(te,ge,Te))},get fs(){return Tt.value},registerFileSearchProvider:(te,ge)=>((0,ze.$wF)(Me,"fileSearchProvider"),Zt.registerFileSearchProvider(te,ge)),registerTextSearchProvider:(te,ge)=>((0,ze.$wF)(Me,"textSearchProvider"),Zt.registerTextSearchProvider(te,ge)),registerRemoteAuthorityResolver:(te,ge)=>((0,ze.$wF)(Me,"resolvers"),kt.registerRemoteAuthorityResolver(te,ge)),registerResourceLabelFormatter:te=>((0,ze.$wF)(Me,"resolvers"),Ci.$registerResourceLabelFormatter(te)),getRemoteExecServer:te=>((0,ze.$wF)(Me,"resolvers"),kt.getRemoteExecServer(te)),onDidCreateFiles:(te,ge,Te)=>Ht.onDidCreateFile(te,ge,Te),onDidDeleteFiles:(te,ge,Te)=>Ht.onDidDeleteFile(te,ge,Te),onDidRenameFiles:(te,ge,Te)=>Ht.onDidRenameFile(te,ge,Te),onWillCreateFiles:(te,ge,Te)=>Ht.getOnWillCreateFileEvent(Me)(te,ge,Te),onWillDeleteFiles:(te,ge,Te)=>Ht.getOnWillDeleteFileEvent(Me)(te,ge,Te),onWillRenameFiles:(te,ge,Te)=>Ht.getOnWillRenameFileEvent(Me)(te,ge,Te),openTunnel:te=>((0,ze.$wF)(Me,"tunnels"),He.openTunnel(Me,te).then(ge=>{if(!ge)throw new Error("cannot open tunnel");return ge})),get tunnels(){return(0,ze.$wF)(Me,"tunnels"),He.getTunnels()},onDidChangeTunnels:(te,ge,Te)=>((0,ze.$wF)(Me,"tunnels"),He.onDidChangeTunnels(te,ge,Te)),registerPortAttributesProvider:(te,ge)=>((0,ze.$wF)(Me,"portsAttributes"),He.registerPortsAttributesProvider(te,ge)),registerTunnelProvider:(te,ge)=>((0,ze.$wF)(Me,"tunnelFactory"),He.registerTunnelProvider(te,ge)),registerTimelineProvider:(te,ge)=>((0,ze.$wF)(Me,"timeline"),Ai.registerTimelineProvider(te,ge,Me.identifier,lt.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:te=>((0,ze.$wF)(Me,"workspaceTrust"),ot.requestWorkspaceTrust(te)),onDidGrantWorkspaceTrust:(te,ge,Te)=>ot.onDidGrantWorkspaceTrust(te,ge,Te),registerEditSessionIdentityProvider:(te,ge)=>((0,ze.$wF)(Me,"editSessionIdentityProvider"),ot.registerEditSessionIdentityProvider(te,ge)),onWillCreateEditSessionIdentity:(te,ge,Te)=>((0,ze.$wF)(Me,"editSessionIdentityProvider"),ot.getOnWillCreateEditSessionIdentityEvent(Me)(te,ge,Te)),registerCanonicalUriProvider:(te,ge)=>((0,ze.$wF)(Me,"canonicalUriProvider"),ot.registerCanonicalUriProvider(te,ge)),getCanonicalUri:(te,ge,Te)=>((0,ze.$wF)(Me,"canonicalUriProvider"),ot.provideCanonicalUri(te,ge,Te))},Hi={get inputBox(){return We.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),mi.getLastInputBox(Me)},createSourceControl(te,ge,Te){return mi.createSourceControl(Me,te,ge,Te)}},on={createCommentController(te,ge){return Ii.createCommentController(Me,te,ge)}},an={get activeDebugSession(){return ft.activeDebugSession},get activeDebugConsole(){return ft.activeDebugConsole},get breakpoints(){return ft.breakpoints},get stackFrameFocus(){return ft.stackFrameFocus},onDidStartDebugSession(te,ge,Te){return ft.onDidStartDebugSession(te,ge,Te)},onDidTerminateDebugSession(te,ge,Te){return ft.onDidTerminateDebugSession(te,ge,Te)},onDidChangeActiveDebugSession(te,ge,Te){return ft.onDidChangeActiveDebugSession(te,ge,Te)},onDidReceiveDebugSessionCustomEvent(te,ge,Te){return ft.onDidReceiveDebugSessionCustomEvent(te,ge,Te)},onDidChangeBreakpoints(te,ge,Te){return ft.onDidChangeBreakpoints(te,ge,Te)},onDidChangeStackFrameFocus(te,ge,Te){return(0,ze.$wF)(Me,"debugFocus"),ft.onDidChangeStackFrameFocus(te,ge,Te)},registerDebugConfigurationProvider(te,ge,Te){return ft.registerDebugConfigurationProvider(te,ge,Te||Xe.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(te,ge){return ft.registerDebugAdapterDescriptorFactory(Me,te,ge)},registerDebugAdapterTrackerFactory(te,ge){return ft.registerDebugAdapterTrackerFactory(te,ge)},startDebugging(te,ge,Te){return!Te||typeof Te=="object"&&"configuration"in Te?ft.startDebugging(te,ge,{parentSession:Te}):ft.startDebugging(te,ge,Te||{})},stopDebugging(te){return ft.stopDebugging(te)},addBreakpoints(te){return ft.addBreakpoints(te)},removeBreakpoints(te){return ft.removeBreakpoints(te)},asDebugSourceUri(te,ge){return ft.asDebugSourceUri(te,ge)}},Mi={registerTaskProvider:(te,ge)=>Bt.registerTaskProvider(Me,te,ge),fetchTasks:te=>Bt.fetchTasks(te),executeTask:te=>Bt.executeTask(Me,te),get taskExecutions(){return Bt.taskExecutions},onDidStartTask:(te,ge,Te)=>Bt.onDidStartTask(te,ge,Te),onDidEndTask:(te,ge,Te)=>Bt.onDidEndTask(te,ge,Te),onDidStartTaskProcess:(te,ge,Te)=>Bt.onDidStartTaskProcess(te,ge,Te),onDidEndTaskProcess:(te,ge,Te)=>Bt.onDidEndTaskProcess(te,ge,Te)},Gi={createNotebookController(te,ge,Te,it,vt){return ai.createNotebookController(Me,te,ge,Te,it,(0,ze.$vF)(Me,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(te,ge)=>Et.registerNotebookCellStatusBarItemProvider(Me,te,ge),createRendererMessaging(te){return _i.createRendererMessaging(Me,te)},createNotebookControllerDetectionTask(te){return(0,ze.$wF)(Me,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(Me,te)},registerKernelSourceActionProvider(te,ge){return(0,ze.$wF)(Me,"notebookKernelSource"),ai.registerKernelSourceActionProvider(Me,te,ge)},onDidChangeNotebookCellExecutionState(te,ge,Te){return(0,ze.$wF)(Me,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(te,ge,Te)}},Xi={t(...te){if(typeof te[0]=="string"){const ge=te.shift(),Te=!te||typeof te[0]!="object"?te:te[0];return hi.getMessage(Me.identifier.value,{message:ge,args:Te})}return hi.getMessage(Me.identifier.value,te[0])},get bundle(){return hi.getBundle(Me.identifier.value)},get uri(){return hi.getBundleUri(Me.identifier.value)}},Yi={_version:1,registerInteractiveEditorSessionProvider(te){return(0,ze.$wF)(Me,"interactive"),Ri.registerProvider(Me,te)},registerInteractiveSessionProvider(te,ge){return(0,ze.$wF)(Me,"interactive"),Qt.registerChatProvider(Me,te,ge)},addInteractiveRequest(te){return(0,ze.$wF)(Me,"interactive"),Qt.addChatRequest(te)},sendInteractiveRequestToProvider(te,ge){return(0,ze.$wF)(Me,"interactive"),Qt.sendInteractiveRequestToProvider(te,ge)},get onDidPerformUserAction(){return(0,ze.$wF)(Me,"interactiveUserActions"),Qt.onDidPerformUserAction},transferChatSession(te,ge){return(0,ze.$wF)(Me,"interactive"),Qt.transferChatSession(te,ge)}},cn={registerSlashCommandProvider(te,ge){return(0,ze.$wF)(Me,"interactiveSlashCommands"),Qt.registerSlashCommandProvider(Me,te,ge)}},un={registerSemanticSimilarityProvider(te){return(0,ze.$wF)(Me,"semanticSimilarity"),tn.registerSemanticSimilarityProvider(Me,te)}};return{version:ht.version,ai:un,authentication:rn,commands:Vt,comments:on,debug:an,env:ci,extensions:Ji,interactive:Yi,interactiveSlashCommands:cn,l10n:Xi,languages:Ki,notebooks:Gi,scm:Hi,tasks:Mi,tests:qi,window:sn,workspace:Ti,Breakpoint:Q.$yK,TerminalOutputAnchor:Q.TerminalOutputAnchor,CallHierarchyIncomingCall:Q.$XJ,CallHierarchyItem:Q.$WJ,CallHierarchyOutgoingCall:Q.$YJ,CancellationError:L.$3,CancellationTokenSource:w.$dd,CandidatePortSource:c.CandidatePortSource,CodeAction:Q.$SJ,CodeActionKind:Q.$TJ,CodeActionTriggerKind:Q.CodeActionTriggerKind,CodeLens:Q.$ZJ,Color:Q.$aK,ColorInformation:Q.$bK,ColorPresentation:Q.$cK,ColorThemeKind:Q.ColorThemeKind,CommentMode:Q.CommentMode,CommentState:Q.CommentState,CommentThreadCollapsibleState:Q.CommentThreadCollapsibleState,CommentThreadState:Q.CommentThreadState,CompletionItem:Q.$7J,CompletionItemKind:Q.CompletionItemKind,CompletionItemTag:Q.CompletionItemTag,CompletionList:Q.$8J,CompletionTriggerKind:Q.CompletionTriggerKind,ConfigurationTarget:Q.ConfigurationTarget,CustomExecution:Q.$kK,DebugAdapterExecutable:Q.$CK,DebugAdapterInlineImplementation:Q.$FK,DebugAdapterNamedPipeServer:Q.$EK,DebugAdapterServer:Q.$DK,DebugConfigurationProviderTriggerKind:Xe.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Q.DebugConsoleMode,DecorationRangeBehavior:Q.DecorationRangeBehavior,Diagnostic:Q.$NJ,DiagnosticRelatedInformation:Q.$MJ,DiagnosticSeverity:Q.DiagnosticSeverity,DiagnosticTag:Q.DiagnosticTag,Disposable:Q.$zJ,DocumentHighlight:Q.$PJ,DocumentHighlightKind:Q.DocumentHighlightKind,DocumentLink:Q.$_J,DocumentSymbol:Q.$RJ,EndOfLine:Q.EndOfLine,EnvironmentVariableMutatorType:Q.EnvironmentVariableMutatorType,EvaluatableExpression:Q.$IK,InlineValueText:Q.$JK,InlineValueVariableLookup:Q.$KK,InlineValueEvaluatableExpression:Q.$LK,InlineCompletionTriggerKind:Q.InlineCompletionTriggerKind,EventEmitter:I.$7c,ExtensionKind:Q.ExtensionKind,ExtensionMode:Q.ExtensionMode,ExternalUriOpenerPriority:Q.ExternalUriOpenerPriority,FileChangeType:Q.FileChangeType,FileDecoration:Q.$VK,FileDecoration2:Q.$VK,FileSystemError:Q.$NK,FileType:E.FileType,FilePermission:E.FilePermission,FoldingRange:Q.$OK,FoldingRangeKind:Q.FoldingRangeKind,FunctionBreakpoint:Q.$AK,InlineCompletionItem:Q.$9J,InlineCompletionList:Q.$0J,Hover:Q.$OJ,IndentAction:$.IndentAction,Location:Q.$LJ,MarkdownString:Q.$1J,OverviewRulerLane:k.OverviewRulerLane,ParameterInformation:Q.$2J,PortAutoForwardAction:Q.PortAutoForwardAction,Position:Q.$AJ,ProcessExecution:Q.$iK,ProgressLocation:Q.ProgressLocation,QuickInputButtons:Q.$UK,Range:Q.$BJ,RelativePattern:Q.$wK,Selection:Q.$CJ,SelectionRange:Q.$VJ,SemanticTokens:Q.$RK,SemanticTokensBuilder:Q.$QK,SemanticTokensEdit:Q.$SK,SemanticTokensEdits:Q.$TK,SemanticTokensLegend:Q.$PK,ShellExecution:Q.$jK,ShellQuoting:Q.ShellQuoting,SignatureHelp:Q.$4J,SignatureHelpTriggerKind:Q.SignatureHelpTriggerKind,SignatureInformation:Q.$3J,SnippetString:Q.$KJ,SourceBreakpoint:Q.$zK,StandardTokenType:Q.StandardTokenType,StatusBarAlignment:Q.StatusBarAlignment,SymbolInformation:Q.$QJ,SymbolKind:Q.SymbolKind,SymbolTag:Q.SymbolTag,Task:Q.$lK,TaskGroup:Q.$hK,TaskPanelKind:Q.TaskPanelKind,TaskRevealKind:Q.TaskRevealKind,TaskScope:Q.TaskScope,TerminalLink:Q.$dK,TerminalQuickFixCommand:Q.$fK,TerminalQuickFixOpener:Q.$eK,TerminalLocation:Q.TerminalLocation,TerminalProfile:Q.$gK,TerminalExitReason:Q.TerminalExitReason,TerminalQuickFixType:Q.TerminalQuickFixType,TextDocumentSaveReason:Q.TextDocumentSaveReason,TextEdit:Q.$GJ,SnippetTextEdit:Q.$IJ,TextEditorCursorStyle:d.TextEditorCursorStyle,TextEditorLineNumbersStyle:Q.TextEditorLineNumbersStyle,TextEditorRevealType:Q.TextEditorRevealType,TextEditorSelectionChangeKind:Q.TextEditorSelectionChangeKind,TextDocumentChangeReason:Q.TextDocumentChangeReason,ThemeColor:Q.$vK,ThemeIcon:Q.$uK,TreeItem:Q.$mK,TreeItemCheckboxState:Q.TreeItemCheckboxState,TreeItemCollapsibleState:Q.TreeItemCollapsibleState,TypeHierarchyItem:Q.$fL,UIKind:y.UIKind,Uri:P.URI,ViewColumn:Q.ViewColumn,WorkspaceEdit:Q.$JJ,DocumentDropEdit:Q.$sK,DocumentPasteEdit:Q.$tK,InlayHint:Q.$6J,InlayHintLabelPart:Q.$5J,InlayHintKind:Q.InlayHintKind,RemoteAuthorityResolverError:Q.$FJ,ResolvedAuthority:Q.$DJ,ManagedResolvedAuthority:Q.$EJ,SourceControlInputBoxValidationType:Q.SourceControlInputBoxValidationType,ExtensionRuntime:Q.ExtensionRuntime,TimelineItem:Q.$6K,NotebookRange:Q.$XK,NotebookCellKind:Q.NotebookCellKind,NotebookCellExecutionState:Q.NotebookCellExecutionState,NotebookCellData:Q.$YK,NotebookData:Q.$ZK,NotebookRendererScript:Q.$4K,NotebookCellStatusBarAlignment:Q.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Q.NotebookEditorRevealType,NotebookCellOutput:Q.$2K,NotebookCellOutputItem:Q.$1K,NotebookCellStatusBarItem:Q.$3K,NotebookControllerAffinity:Q.NotebookControllerAffinity,NotebookControllerAffinity2:Q.NotebookControllerAffinity2,NotebookEdit:Q.$HJ,NotebookKernelSourceAction:Q.$5K,PortAttributes:Q.$8K,LinkedEditingRanges:Q.$7K,TestResultState:Q.TestResultState,TestRunRequest:Q.$9K,TestRunRequest2:Q.$0K,TestMessage:Q.$$K,TestTag:Q.$_K,TestRunProfileKind:Q.TestRunProfileKind,TextSearchCompleteMessageType:xe.TextSearchCompleteMessageType,DataTransfer:Q.$rK,DataTransferItem:Q.$nK,CoveredCount:Q.$aL,FileCoverage:Q.$bL,StatementCoverage:Q.$cL,BranchCoverage:Q.$dL,FunctionCoverage:Q.$eL,WorkspaceTrustState:Q.WorkspaceTrustState,LanguageStatusSeverity:Q.LanguageStatusSeverity,QuickPickItemKind:Q.QuickPickItemKind,InputBoxValidationSeverity:Q.InputBoxValidationSeverity,TabInputText:Q.$gL,TabInputTextDiff:Q.$hL,TabInputTextMerge:Q.$iL,TabInputCustom:Q.$jL,TabInputNotebook:Q.$lL,TabInputNotebookDiff:Q.$mL,TabInputWebview:Q.$kL,TabInputTerminal:Q.$nL,TabInputInteractiveWindow:Q.$oL,TelemetryTrustedValue:be.$Zn,LogLevel:Se.LogLevel,EditSessionIdentityMatch:gt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Q.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Q.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Q.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Q.$GK,ThreadFocus:Q.$HK,NotebookCodeActionKind:Q.$UJ}}}e.$Jac=Lt}),define(Ae[269],Re([1,0,72,109,33,107,34,32,60,63,111,113,114,84,86,80,108,62,39,83,58,61,236,14,112,81,82]),function($e,e,w,L,I,z,P,d,k,$,R,E,c,y,b,o,t,i,a,m,S,C,r,h,n,s,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,w.$0q)(s.$o_b,s.$n_b,1),(0,w.$0q)(h.$Qi,r.$Kac,1),(0,w.$0q)(o.$N$b,o.$O$b,1),(0,w.$0q)(d.$VL,d.$UL,0),(0,w.$0q)(P.$1$b,P.$Y$b,0),(0,w.$0q)(i.$d_b,i.$c_b,0),(0,w.$0q)(E.$4_b,E.$8_b,0),(0,w.$0q)(z.$V_b,z.$U_b,0),(0,w.$0q)(k.$KL,k.$JL,0),(0,w.$0q)(p.$p_b,p.$q_b,0),(0,w.$0q)(a.$K$b,a.$J$b,0),(0,w.$0q)(L.$B_b,L.$A_b,1),(0,w.$0q)(c.$bac,c.$cac,0),(0,w.$0q)(y.$_$b,y.$$$b,0),(0,w.$0q)(R.$Y_b,R.$X_b,0),(0,w.$0q)($.$g_b,$.$j_b,0),(0,w.$0q)(b.$Tpb,b.$Upb,0),(0,w.$0q)(t.$R_b,t.$Q_b,0),(0,w.$0q)(I.$X$b,I.$W$b,0),(0,w.$0q)(m.$l_b,m.$k_b,0),(0,w.$0q)(S.$TL,S.$QL,0),(0,w.$0q)(C.$Z_b,C.$1_b,0),(0,w.$0q)(n.$2_b,n.$3_b,0)}),define(Ae[270],Re([1,0,268,35,2,265,7,16,256]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0;class $ extends z.$Nac{j(){}getModule(y,b){for(const o of this.b){const t=o(y);if(t){y=t;break}}if(this.a.has(y))return this.a.get(y).load(y,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends L.$s_b{constructor(){super(...arguments),this.extensionRuntime=P.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(k.$Rcc);const y=this.h.invokeFunction(w.$Jac);this.r=this.h.createInstance($,y,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(y){return y.browser}async rb(y,b,o){b=b.with({path:E(b.path,".js")});const t=y?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const i=I.URI.revive(await this.v.$asBrowserUri(b)),a=await fetch(i.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),a.status!==200)throw new Error(a.statusText);const m=await a.text(),S=`${b.toString(!0)}#vscode-extension`,C=`${m}
//# sourceURL=${S}`;let r;try{r=new Function("module","exports","require",C)}catch(p){throw console.error(t?`Loading code for extension ${t} failed: ${p.message}`:`Loading code failed: ${p.message}`),console.error(`${b.toString(!0)}${typeof p.line=="number"?` line ${p.line}`:""}${typeof p.column=="number"?` column ${p.column}`:""}`),console.error(p),p}y&&await this.s.initializeLocalizedMessages(y);const h={},n={exports:h},s=p=>{const D=this.r.getModule(p,b);if(D===void 0)throw new Error(`Cannot load module '${p}'`);return D};try{return o.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),r(n,h,s),n.exports!==h?n.exports:h}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}}async $setRemoteEnvironment(y){}async vb(y=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+y;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,d.$ug)(10)}}e.$Scc=R;function E(c,y){return c.endsWith(y)?c:c+y}}),define(Ae[271],Re([1,0,71,72,14,35,188,85,270]),function($e,e,w,L,I,z,P,d,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,L.$0q)(I.$Pi,new w.$kh(P.$Mac,[!0],!0)),(0,L.$0q)(z.$t_b,k.$Scc,0),(0,L.$0q)(d.$e_b,d.$f_b,0)}),define(Ae[279],Re([1,0,25,5,79,266,258,19,87,13,2,269,271]),function($e,e,w,L,I,z,P,d,k,$,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const E=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function y(r){return/^(file|vscode-remote):/i.test(r)}const b=fetch.bind(self);function o(r){self.fetch=async function(h,n){return h instanceof Request||y(String(h))&&(h=(await r(R.URI.parse(String(h)))).toString(!0)),b(h,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(h,n,s,p,D){(async()=>(y(n.toString())&&(n=(await r(R.URI.parse(n.toString()))).toString(!0)),super.open(h,n,s??!0,p,D)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const r=self.Worker;Worker=function(h,n){if(/^file:/i.test(h.toString()))h=$.$3e.uriToBrowserUri(R.URI.parse(h.toString())).toString(!0);else if(/^vscode-remote:/i.test(h.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const p=`(${function(v){function u(W){return typeof W=="string"||W instanceof URL?String(W).replace(/^file:\/\//i,"vscode-file://vscode-app"):W}const f=fetch.bind(self);self.fetch=function(W,B){return W instanceof Request?f(W,B):f(u(W),B)},self.XMLHttpRequest=class extends XMLHttpRequest{open(W,B,V,U,O){return super.open(W,u(B),V??!0,U,O)}};const A=importScripts.bind(self);self.importScripts=(...W)=>{A(...W.map(u))},A(v)}.toString()}('${h}'))`;n=n||{},n.name=n.name||d.$ec(h.toString());const D=new Blob([p],{type:"application/javascript"}),l=URL.createObjectURL(D);return new r(l,n)}}else self.Worker=class extends P.$Tcc{constructor(r,h){super(c,r,{name:d.$ec(r.toString()),...h})}};const t=new class{constructor(){this.pid=void 0}exit(r){E()}};class i{constructor(){const h=new MessageChannel,n=new L.$7c;let s=!1;c(h.port2,[h.port2]),h.port1.onmessage=p=>{const{data:D}=p;if(!(D instanceof ArrayBuffer)){console.warn("UNKNOWN data received",D);return}const l=w.$Jb.wrap(new Uint8Array(D,0,D.byteLength));if((0,I.$Ol)(l,2)){s=!0,m("received terminate message from renderer");return}n.fire(l)},this.protocol={onMessage:n.event,send:p=>{if(!s){const D=p.buffer.buffer.slice(p.buffer.byteOffset,p.buffer.byteOffset+p.buffer.byteLength);h.port1.postMessage(D,[D])}}}}}function a(r){return new Promise(h=>{const n=r.onMessage(s=>{n.dispose();const p=JSON.parse(s.toString());r.send((0,I.$Nl)(0)),h({protocol:r,initData:p})});r.send((0,I.$Nl)(1))})}let m=r=>E();function S(r){return!!r&&typeof r=="object"&&r.type==="vscode.init"&&r.data instanceof Map}function C(){k.mark("code/extHost/willConnectToRenderer");const r=new i;return{onmessage(h){S(h)&&a(r.protocol).then(n=>{k.mark("code/extHost/didWaitForInitData");const s=new z.$Pac(n.protocol,n.initData,t,null,h.data);o(p=>s.asBrowserUri(p)),m=p=>s.terminate(p)})}}}e.create=C})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c3e3dba23e8fadc360aed75ce363ba185c49794/core/vs/workbench/api/worker/extensionHostWorker.js.map
