/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableImpl/logging","vs/base/common/errors","vs/base/common/observableImpl/base","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableImpl/autorun","vs/base/common/observableImpl/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/observableImpl/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/base/common/assert","vs/base/common/lazy","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],_=function(z){for(var e=[],k=0,y=z.length;k<y;k++)e[k]=q[z[k]];return e};define(q[21],_([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S=e.$R=void 0,e.$R=!1;class k{static get(){const v=new Map,T=new Map,i=new Map,f=new Map;function t(o,n){o.has(n.detail)||o.set(n.detail,-n.timestamp)}function s(o,n){const a=o.get(n.detail);a&&(a>=0||o.set(n.detail,a+n.timestamp))}let h=[];typeof z=="function"&&typeof z.getStats=="function"&&(h=z.getStats().slice(0).sort((o,n)=>o.timestamp-n.timestamp));for(const o of h)switch(o.type){case 10:t(v,o);break;case 11:case 12:s(v,o);break;case 21:t(T,o);break;case 22:s(T,o);break;case 33:t(i,o);break;case 34:s(i,o);break;case 31:t(f,o);break;case 32:s(f,o);break}let c=0;i.forEach(o=>c+=o);function u(o){const n=[];return o.forEach((a,r)=>n.push([r,a])),n}return{amdLoad:u(v),amdInvoke:u(T),nodeRequire:u(i),nodeEval:u(f),nodeRequireTotal:c}}static toMarkdownTable(v,T){let i="";const f=[];return v.forEach((t,s)=>{f[s]=t.length}),T.forEach(t=>{t.forEach((s,h)=>{typeof s>"u"&&(s=t[h]="-");const c=s.toString().length;f[h]=Math.max(c,f[h])})}),v.forEach((t,s)=>{i+=`| ${t+" ".repeat(f[s]-t.toString().length)} `}),i+=`|
`,v.forEach((t,s)=>{i+=`| ${"-".repeat(f[s])} `}),i+=`|
`,T.forEach(t=>{t.forEach((s,h)=>{typeof s<"u"&&(i+=`| ${s+" ".repeat(f[h]-s.toString().length)} `)}),i+=`|
`}),i}}e.$S=k}),define(q[4],_([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mc=e.$Lc=e.$Kc=void 0;let k;function y(a){k=a}e.$Kc=y;function v(){return k}e.$Lc=v;class T{constructor(){this.a=0,this.d=new WeakMap}b(r){return i([f(o("|  ",this.a)),r])}c(r){return r.didChange?[f(" "),s(h(r.oldValue,70),{color:"red",strikeThrough:!0}),f(" "),s(h(r.newValue,60),{color:"green"})]:[f(" (unchanged)")]}handleObservableChanged(r,m){console.log(...this.b([t("observable value changed"),s(r.debugName,{color:"BlueViolet"}),...this.c(m)]))}formatChanges(r){if(r.size!==0)return s(" (changed deps: "+[...r].map(m=>m.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const m=r.handleChange;this.d.set(r,new Set),r.handleChange=(O,M)=>(this.d.get(r).add(O),m.apply(r,[O,M]))}handleDerivedRecomputed(r,m){const O=this.d.get(r);console.log(...this.b([t("derived recomputed"),s(r.debugName,{color:"BlueViolet"}),...this.c(m),this.formatChanges(O)])),O.clear()}handleFromEventObservableTriggered(r,m){console.log(...this.b([t("observable from event triggered"),s(r.debugName,{color:"BlueViolet"}),...this.c(m)]))}handleAutorunCreated(r){const m=r.handleChange;this.d.set(r,new Set),r.handleChange=(O,M)=>(this.d.get(r).add(O),m.apply(r,[O,M]))}handleAutorunTriggered(r){const m=this.d.get(r);console.log(...this.b([t("autorun"),s(r.debugName,{color:"BlueViolet"}),this.formatChanges(m)])),m.clear()}handleBeginTransaction(r){let m=r.getDebugName();m===void 0&&(m=""),console.log(...this.b([t("transaction"),s(m,{color:"BlueViolet"})])),this.a++}handleEndTransaction(){this.a--}}e.$Mc=T;function i(a){const r=new Array,O={};let M="";function P(d){if("length"in d)for(const $ of d)$&&P($);else"text"in d?(M+=`%c${d.text}`,r.push(d.style),d.data&&Object.assign(O,d.data)):"data"in d&&Object.assign(O,d.data)}P(a);const S=[M,...r];return Object.keys(O).length>0&&S.push(O),S}function f(a){return s(a,{color:"black"})}function t(a){return s(n(`${a}: `,10),{color:"black",bold:!0})}function s(a,r={color:"black"}){function m(M){return Object.entries(M).reduce((P,[S,d])=>`${P}${S}:${d};`,"")}const O={color:r.color};return r.strikeThrough&&(O["text-decoration"]="line-through"),r.bold&&(O["font-weight"]="bold"),{text:a,style:m(O)}}function h(a,r){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=r?`"${a}"`:`"${a.substr(0,r-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?c(a,r):u(a,r);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function c(a,r){let m="[ ",O=!0;for(const M of a){if(O||(m+=", "),m.length-5>r){m+="...";break}O=!1,m+=`${h(M,r-m.length)}`}return m+=" ]",m}function u(a,r){let m="{ ",O=!0;for(const[M,P]of Object.entries(a)){if(O||(m+=", "),m.length-5>r){m+="...";break}O=!1,m+=`${M}: ${h(P,r-m.length)}`}return m+=" }",m}function o(a,r){let m="";for(let O=1;O<=r;O++)m+=a;return m}function n(a,r){for(;a.length<r;)a+=" ";return a}}),define(q[9],_([0,1,42,2,4]),function(z,e,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xc=e.$wc=e.$vc=e.$uc=e.$tc=e.$sc=e.$rc=void 0;function T(o,n){return new c(o,n,void 0,void 0)}e.$rc=T;function i(o,n,a){return new c(o,a,n.createEmptyChangeSummary,n.handleChange)}e.$sc=i;function f(o,n){return s(n,o)}e.$tc=f;function t(o,n,a){const r=new y.$kb,m=i(o,{createEmptyChangeSummary:n.createEmptyChangeSummary,handleChange:n.handleChange},(O,M)=>{r.clear(),a(O,M,r)});return(0,y.$jb)(()=>{m.dispose(),r.dispose()})}e.$uc=t;function s(o,n){const a=new y.$kb,r=T(n,m=>{a.clear(),o(m,a)});return(0,y.$jb)(()=>{r.dispose(),a.dispose()})}e.$vc=s;var h;(function(o){o[o.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",o[o.stale=2]="stale",o[o.upToDate=3]="upToDate"})(h||(h={}));class c{constructor(n,a,r,m){this.debugName=n,this.h=a,this.i=r,this.j=m,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,v.$Lc)()?.handleAutorunCreated(this),this.k()}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear()}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3,(0,v.$Lc)()?.handleAutorunTriggered(this);try{const a=this.g;this.g=this.i?.(),this.h(this,a)}finally{for(const a of this.f)a.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,k.$pc)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,a){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:a,didChange:m=>m===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const a=n.get();return this.e.add(n),this.f.delete(n),a}}e.$wc=c,function(o){o.Observer=c}(T||(e.$rc=T={}));function u(o,n,a){let r;return T(o,m=>{const O=n.read(m),M=r;r=O,a({lastValue:M,newValue:O})})}e.$xc=u}),define(q[6],_([0,1,4]),function(z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=void 0;let y;function v(a){y=a}e.$Rc=v;class T{get TChange(){return null}reportChanges(){this.get()}read(r){return r?r.readObservable(this):this.get()}map(r){return y(()=>{const m=h(r);return m!==void 0?m:`${this.debugName} (mapped)`},m=>r(this.read(m),m))}}e.$Sc=T;class i extends T{constructor(){super(...arguments),this.a=new Set}addObserver(r){const m=this.a.size;this.a.add(r),m===0&&this.b()}removeObserver(r){this.a.delete(r)&&this.a.size===0&&this.c()}b(){}c(){}}e.$Tc=i;function f(a,r){const m=new s(a,r);try{(0,k.$Lc)()?.handleBeginTransaction(m),a(m)}finally{m.finish(),(0,k.$Lc)()?.handleEndTransaction()}}e.$Uc=f;function t(a,r,m){a?r(a):f(r,m)}e.$Vc=t;class s{constructor(r,m){this.b=r,this.c=m,this.a=[]}getDebugName(){return this.c?this.c():h(this.b)}updateObserver(r,m){this.a.push({observer:r,observable:m}),r.beginUpdate(m)}finish(){const r=this.a;this.a=null;for(const{observer:m,observable:O}of r)m.endUpdate(O)}}e.$Wc=s;function h(a){const r=a.toString(),O=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(r);return(O?O[1]:void 0)?.trim()}e.$Xc=h;function c(a,r){return new u(a,r)}e.$Yc=c;class u extends i{constructor(r,m){super(),this.debugName=r,this.d=m}get(){return this.d}set(r,m,O){if(this.d===r)return;let M;m||(m=M=new s(()=>{},()=>`Setting ${this.debugName}`));try{const P=this.d;this.e(r),(0,k.$Lc)()?.handleObservableChanged(this,{oldValue:P,newValue:r,change:O,didChange:!0});for(const S of this.a)m.updateObserver(S,this),S.handleChange(this,O)}finally{M&&M.finish()}}toString(){return`${this.debugName}: ${this.d}`}e(r){this.d=r}}e.$Zc=u;function o(a,r){return new n(a,r)}e.$1c=o;class n extends u{e(r){this.d!==r&&(this.d&&this.d.dispose(),this.d=r)}dispose(){this.d?.dispose()}}e.$2c=n}),define(q[10],_([0,1,5,2,6,4]),function(z,e,k,y,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qc=e.$Pc=e.$Oc=e.$Nc=void 0;function i(c,u){return new h(c,u,void 0,void 0,void 0)}e.$Nc=i;function f(c,u,o){return new h(c,o,u.createEmptyChangeSummary,u.handleChange,void 0)}e.$Oc=f;function t(c,u){const o=new y.$kb;return new h(c,n=>(o.clear(),u(n,o)),void 0,void 0,()=>o.dispose())}e.$Pc=t,(0,v.$Rc)(i);var s;(function(c){c[c.initial=0]="initial",c[c.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",c[c.stale=2]="stale",c[c.upToDate=3]="upToDate"})(s||(s={}));class h extends v.$Tc{get debugName(){return typeof this.k=="function"?this.k():this.k}constructor(u,o,n,a,r=void 0){super(),this.k=u,this.l=o,this.m=n,this.n=a,this.p=r,this.e=0,this.f=void 0,this.g=0,this.h=new Set,this.i=new Set,this.j=void 0,this.j=this.m?.(),(0,T.$Lc)()?.handleDerivedCreated(this)}c(){this.e=0,this.f=void 0;for(const u of this.h)u.removeObserver(this);this.h.clear(),this.p?.()}get(){if(this.a.size===0){const u=this.l(this,this.m?.());return this.c(),u}else{do{if(this.e===1){this.e=3;for(const u of this.h)if(u.reportChanges(),this.e===2)break}this.s()}while(this.e!==3);return this.f}}s(){if(this.e===3)return;const u=this.i;this.i=this.h,this.h=u;const o=this.e!==0,n=this.f;this.e=3;const a=this.j;this.j=this.m?.();try{this.f=this.l(this,a)}finally{for(const m of this.i)m.removeObserver(this);this.i.clear()}const r=o&&n!==this.f;if((0,T.$Lc)()?.handleDerivedRecomputed(this,{oldValue:n,newValue:this.f,change:void 0,didChange:r}),r)for(const m of this.a)m.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(u){this.g++;const o=this.g===1;if(this.e===3&&(this.e=1,!o))for(const n of this.a)n.handlePossibleChange(this);if(o)for(const n of this.a)n.beginUpdate(this)}endUpdate(u){if(this.g--,this.g===0){const o=[...this.a];for(const n of o)n.endUpdate(this)}if(this.g<0)throw new k.$bb}handlePossibleChange(u){if(this.e===3&&this.h.has(u)&&!this.i.has(u)){this.e=1;for(const o of this.a)o.handlePossibleChange(this)}}handleChange(u,o){if(this.h.has(u)&&!this.i.has(u)){const n=this.n?this.n({changedObservable:u,change:o,didChange:r=>r===u},this.j):!0,a=this.e===3;if(n&&(this.e===1||a)&&(this.e=2,a))for(const r of this.a)r.handlePossibleChange(this)}}readObservable(u){u.addObserver(this);const o=u.get();return this.h.add(u),this.i.delete(u),o}addObserver(u){const o=!this.a.has(u)&&this.g>0;super.addObserver(u),o&&u.beginUpdate(this)}removeObserver(u){const o=this.a.has(u)&&this.g>0;super.removeObserver(u),o&&u.endUpdate(this)}}e.$Qc=h}),define(q[22],_([0,1,2,9,6,10,4]),function(z,e,k,y,v,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jc=e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.$Ac=e.$zc=e.$yc=void 0;function f($){return new t($)}e.$yc=f;class t extends v.$Sc{constructor(w){super(),this.a=w}get debugName(){return this.toString()}get(){return this.a}addObserver(w){}removeObserver(w){}toString(){return`Const: ${this.a}`}}function s($){const w=(0,v.$Yc)("promiseValue",{});return $.then(L=>{w.set({value:L},void 0)}),w}e.$zc=s;function h($,w){return new Promise(L=>{let D=!1,g=!1;const C=(0,y.$rc)("waitForState",U=>{const B=$.read(U);w(B)&&(D?C.dispose():g=!0,L(B))});D=!0,g&&C.dispose()})}e.$Ac=h;function c($,w){return new u($,w)}e.$Bc=c;class u extends v.$Tc{constructor(w,L){super(),this.h=w,this.i=L,this.f=!1,this.l=D=>{const g=this.i(D),C=!this.f||this.e!==g;(0,i.$Lc)()?.handleFromEventObservableTriggered(this,{oldValue:this.e,newValue:g,change:void 0,didChange:C}),C&&(this.e=g,this.f&&(0,v.$Uc)(U=>{for(const B of this.a)U.updateObserver(B,this),B.handleChange(this,void 0)},()=>{const U=this.j();return"Event fired"+(U?`: ${U}`:"")}),this.f=!0)}}j(){return(0,v.$Xc)(this.i)}get debugName(){const w=this.j();return"From Event"+(w?`: ${w}`:"")}b(){this.g=this.h(this.l)}c(){this.g.dispose(),this.g=void 0,this.f=!1,this.e=void 0}get(){return this.g?(this.f||this.l(void 0),this.e):this.i(void 0)}}e.$Cc=u,function($){$.Observer=u}(c||(e.$Bc=c={}));function o($,w){return new n($,w)}e.$Dc=o;class n extends v.$Tc{constructor(w,L){super(),this.debugName=w,this.f=L,this.h=()=>{(0,v.$Uc)(D=>{for(const g of this.a)D.updateObserver(g,this),g.handleChange(this,void 0)},()=>this.debugName)}}b(){this.e=this.f(this.h)}c(){this.e.dispose(),this.e=void 0}get(){}}function a($){return new r($)}e.$Ec=a;class r extends v.$Tc{constructor(w){super(),this.debugName=w}trigger(w,L){if(!w){(0,v.$Uc)(D=>{this.trigger(D,L)},()=>`Trigger signal ${this.debugName}`);return}for(const D of this.a)w.updateObserver(D,this),D.handleChange(this,L)}get(){}}function m($,w,L){const D=(0,v.$Yc)("debounced",void 0);let g;return L.add((0,y.$rc)("debounce",C=>{const U=$.read(C);g&&clearTimeout(g),g=setTimeout(()=>{(0,v.$Uc)(B=>{D.set(U,B)})},w)})),D}e.$Fc=m;function O($,w,L){const D=(0,v.$Yc)("triggeredRecently",!1);let g;return L.add($(()=>{D.set(!0,void 0),g&&clearTimeout(g),g=setTimeout(()=>{D.set(!1,void 0)},w)})),D}e.$Gc=O;function M($,w){const L=new P(w??!1);return $.addObserver(L),w&&$.reportChanges(),(0,k.$jb)(()=>{$.removeObserver(L)})}e.$Hc=M;class P{constructor(w){this.b=w,this.a=0}beginUpdate(w){this.a++}endUpdate(w){this.a--,this.a===0&&this.b&&w.reportChanges()}handlePossibleChange(w){}handleChange(w,L){}}function S($,w){let L;return(0,T.$Nc)($,g=>(L=w(g,L),L))}e.$Ic=S;function d($,w){let L;const D=(0,v.$Yc)("derivedObservableWithWritableCache.counter",0),g=(0,T.$Nc)($,C=>(D.read(C),L=w(C,L),L));return Object.assign(g,{clearCache:C=>{L=void 0,D.set(D.get()+1,C)}})}e.$Jc=d});var se=this&&this.__createBinding||(Object.create?function(z,e,k,y){y===void 0&&(y=k);var v=Object.getOwnPropertyDescriptor(e,k);(!v||("get"in v?!e.__esModule:v.writable||v.configurable))&&(v={enumerable:!0,get:function(){return e[k]}}),Object.defineProperty(z,y,v)}:function(z,e,k,y){y===void 0&&(y=k),z[y]=e[k]}),re=this&&this.__exportStar||function(z,e){for(var k in z)k!=="default"&&!Object.prototype.hasOwnProperty.call(e,k)&&se(e,z,k)};define(q[11],_([0,1,6,10,9,22,4]),function(z,e,k,y,v,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derived=e.transaction=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return k.$Yc}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return k.$Uc}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return y.$Nc}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$rc}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$xc}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$sc}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$vc}}),re(T,e),!1&&(0,i.$Kc)(new i.$Mc)}),define(q[23],_([0,1,5,2]),function(z,e,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=void 0;function v(P){const S=P;return S?typeof S.read=="function":!1}e.$ub=v;function T(P){const S=P;return S?[S.on,S.pause,S.resume,S.destroy].every(d=>typeof d=="function"):!1}e.$vb=T;function i(P){const S=P;return S?T(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}e.$wb=i;function f(P,S){return new t(P,S)}e.$xb=f;class t{constructor(S,d){this.e=S,this.f=d,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(d=>this.d.push(d))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(d=>d(S))}h(S){this.c.error.length===0?(0,k.$Y)(S):this.c.error.slice(0).forEach(d=>d(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,d){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(d),this.resume();break;case"end":this.c.end.push(d),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(d),this.a.flowing&&this.k();break}}removeListener(S,d){if(this.a.destroyed)return;let $;switch(S){case"data":$=this.c.data;break;case"end":$=this.c.end;break;case"error":$=this.c.error;break}if($){const w=$.indexOf(d);w>=0&&$.splice(w,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const d=[...this.d];this.d.length=0,d.forEach($=>$())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function s(P,S){const d=[];let $;for(;($=P.read())!==null;)d.push($);return S(d)}e.$yb=s;function h(P,S,d){const $=[];let w;for(;(w=P.read())!==null&&$.length<d;)$.push(w);return w===null&&$.length>0?S($):{read:()=>{if($.length>0)return $.shift();if(typeof w<"u"){const L=w;return w=void 0,L}return P.read()}}}e.$zb=h;function c(P,S){return new Promise((d,$)=>{const w=[];u(P,{onData:L=>{S&&w.push(L)},onError:L=>{S?$(L):d(void 0)},onEnd:()=>{d(S?S(w):void 0)}})})}e.$Ab=c;function u(P,S){let d=!1;return P.on("error",$=>{d||S.onError($)}),P.on("end",()=>{d||S.onEnd()}),P.on("data",$=>{d||S.onData($)}),(0,y.$jb)(()=>d=!0)}e.$Bb=u;function o(P,S){return new Promise((d,$)=>{const w=new y.$kb,L=[],D=U=>{if(L.push(U),L.length>S)return w.dispose(),P.pause(),d({stream:P,buffer:L,ended:!1})},g=U=>$(U),C=()=>d({stream:P,buffer:L,ended:!0});w.add((0,y.$jb)(()=>P.removeListener("error",g))),P.on("error",g),w.add((0,y.$jb)(()=>P.removeListener("end",C))),P.on("end",C),w.add((0,y.$jb)(()=>P.removeListener("data",D))),P.on("data",D)})}e.$Cb=o;function n(P,S){const d=f(S);return d.end(P),d}e.$Db=n;function a(){const P=f(()=>{throw new Error("not supported")});return P.end(),P}e.$Eb=a;function r(P){let S=!1;return{read:()=>S?null:(S=!0,P)}}e.$Fb=r;function m(P,S,d){const $=f(d);return u(P,{onData:w=>$.write(S.data(w)),onError:w=>$.error(S.error?S.error(w):w),onEnd:()=>$.end()}),$}e.$Gb=m;function O(P,S,d){let $=!1;return{read:()=>{const w=S.read();return $?w:($=!0,w!==null?d([P,w]):P)}}}e.$Hb=O;function M(P,S,d){let $=!1;const w=f(d);return u(S,{onData:L=>$?w.write(L):($=!0,w.write(d([P,L]))),onError:L=>w.error(L),onEnd:()=>{$||($=!0,w.write(P)),w.end()}}),w}e.$Ib=M}),define(q[12],_([0,1,43,23]),function(z,e,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=void 0;const v=typeof Buffer<"u",T=new k.$T(()=>new Uint8Array(256));let i,f;class t{static alloc(b){return v?new t(Buffer.allocUnsafe(b)):new t(new Uint8Array(b))}static wrap(b){return v&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new t(b)}static fromString(b,j){return!(j?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(b)):(i||(i=new TextEncoder),new t(i.encode(b)))}static fromByteArray(b){const j=t.alloc(b.length);for(let p=0,W=b.length;p<W;p++)j.buffer[p]=b[p];return j}static concat(b,j){if(typeof j>"u"){j=0;for(let X=0,V=b.length;X<V;X++)j+=b[X].byteLength}const p=t.alloc(j);let W=0;for(let X=0,V=b.length;X<V;X++){const K=b[X];p.set(K,W),W+=K.byteLength}return p}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=t.alloc(this.byteLength);return b.set(this),b}toString(){return v?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(b,j){return new t(this.buffer.subarray(b,j))}set(b,j){if(b instanceof t)this.buffer.set(b.buffer,j);else if(b instanceof Uint8Array)this.buffer.set(b,j);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),j);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return u(this.buffer,b)}writeUInt32BE(b,j){o(this.buffer,b,j)}readUInt32LE(b){return n(this.buffer,b)}writeUInt32LE(b,j){a(this.buffer,b,j)}readUInt8(b){return r(this.buffer,b)}writeUInt8(b,j){m(this.buffer,b,j)}indexOf(b,j=0){return s(this.buffer,b instanceof t?b.buffer:b,j)}}e.$Jb=t;function s(A,b,j=0){const p=b.byteLength,W=A.byteLength;if(p===0)return 0;if(p===1)return A.indexOf(b[0]);if(p>W-j)return-1;const X=T.value;X.fill(b.length);for(let Q=0;Q<b.length;Q++)X[b[Q]]=b.length-Q-1;let V=j+b.length-1,K=V,G=-1;for(;V<W;)if(A[V]===b[K]){if(K===0){G=V;break}V--,K--}else V+=Math.max(b.length-K,X[A[V]]),K=b.length-1;return G}e.$Kb=s;function h(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0}e.$Lb=h;function c(A,b,j){A[j+0]=b&255,b=b>>>8,A[j+1]=b&255}e.$Mb=c;function u(A,b){return A[b]*2**24+A[b+1]*2**16+A[b+2]*2**8+A[b+3]}e.$Nb=u;function o(A,b,j){A[j+3]=b,b=b>>>8,A[j+2]=b,b=b>>>8,A[j+1]=b,b=b>>>8,A[j]=b}e.$Ob=o;function n(A,b){return A[b+0]<<0>>>0|A[b+1]<<8>>>0|A[b+2]<<16>>>0|A[b+3]<<24>>>0}e.$Pb=n;function a(A,b,j){A[j+0]=b&255,b=b>>>8,A[j+1]=b&255,b=b>>>8,A[j+2]=b&255,b=b>>>8,A[j+3]=b&255}e.$Qb=a;function r(A,b){return A[b]}e.$Rb=r;function m(A,b,j){A[j]=b}e.$Sb=m;function O(A){return y.$yb(A,b=>t.concat(b))}e.$Tb=O;function M(A){return y.$Fb(A)}e.$Ub=M;function P(A){return y.$Ab(A,b=>t.concat(b))}e.$Vb=P;async function S(A){return A.ended?t.concat(A.buffer):t.concat([...A.buffer,await P(A.stream)])}e.$Wb=S;function d(A){return y.$Db(A,b=>t.concat(b))}e.$Xb=d;function $(A){return y.$Gb(A,{data:b=>typeof b=="string"?t.fromString(b):t.wrap(b)},b=>t.concat(b))}e.$Yb=$;function w(A){return y.$xb(b=>t.concat(b),A)}e.$Zb=w;function L(A,b){return y.$Hb(A,b,j=>t.concat(j))}e.$1b=L;function D(A,b){return y.$Ib(A,b,j=>t.concat(j))}e.$2b=D;function g(A){let b=0,j=0,p=0;const W=new Uint8Array(Math.floor(A.length/4*3)),X=K=>{switch(j){case 3:W[p++]=b|K,j=0;break;case 2:W[p++]=b|K>>>2,b=K<<6,j=3;break;case 1:W[p++]=b|K>>>4,b=K<<4,j=2;break;default:b=K<<2,j=1}};for(let K=0;K<A.length;K++){const G=A.charCodeAt(K);if(G>=65&&G<=90)X(G-65);else if(G>=97&&G<=122)X(G-97+26);else if(G>=48&&G<=57)X(G-48+52);else if(G===43||G===45)X(62);else if(G===47||G===95)X(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${A[K]}`)}}const V=p;for(;j>0;)X(0);return t.wrap(W).slice(0,V)}e.$3b=g;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function B({buffer:A},b=!0,j=!1){const p=j?U:C;let W="";const X=A.byteLength%3;let V=0;for(;V<A.byteLength-X;V+=3){const K=A[V+0],G=A[V+1],Q=A[V+2];W+=p[K>>>2],W+=p[(K<<4|G>>>4)&63],W+=p[(G<<2|Q>>>6)&63],W+=p[Q&63]}if(X===1){const K=A[V+0];W+=p[K>>>2],W+=p[K<<4&63],b&&(W+="==")}else if(X===2){const K=A[V+0],G=A[V+1];W+=p[K>>>2],W+=p[(K<<4|G>>>4)&63],W+=p[G<<2&63],b&&(W+="=")}return W}e.$4b=B}),define(q[24],_([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0,e.$4c=Symbol("MicrotaskDelay")}),define(q[13],_([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=e.StringEOL=void 0;var k;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(k||(e.StringEOL=k={}));function y(v){let T=0,i=0,f=0,t=0;for(let s=0,h=v.length;s<h;s++){const c=v.charCodeAt(s);c===13?(T===0&&(i=s),T++,s+1<h&&v.charCodeAt(s+1)===10?(t|=2,s++):t|=3,f=s+1):c===10&&(t|=1,T===0&&(i=s),T++,f=s+1)}return T===0&&(i=v.length),[T,i,v.length-f,t]}e.$ds=y}),define(q[14],_([0,1]),function(z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var k;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(k||(e.LanguageId=k={}));var y;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(y||(e.FontStyle=y={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var T;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(T||(e.StandardTokenType=T={}));var i;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(i||(e.MetadataConsts=i={}));class f{static getLanguageId(s){return(s&255)>>>0}static getTokenType(s){return(s&768)>>>8}static containsBalancedBrackets(s){return(s&1024)!==0}static getFontStyle(s){return(s&30720)>>>11}static getForeground(s){return(s&16744448)>>>15}static getBackground(s){return(s&4278190080)>>>24}static getClassNameFromMetadata(s){let c="mtk"+this.getForeground(s);const u=this.getFontStyle(s);return u&1&&(c+=" mtki"),u&2&&(c+=" mtkb"),u&4&&(c+=" mtku"),u&8&&(c+=" mtks"),c}static getInlineStyleFromMetadata(s,h){const c=this.getForeground(s),u=this.getFontStyle(s);let o=`color: ${h[c]};`;u&1&&(o+="font-style: italic;"),u&2&&(o+="font-weight: bold;");let n="";return u&4&&(n+=" underline"),u&8&&(n+=" line-through"),n&&(o+=`text-decoration:${n};`),o}static getPresentationFromMetadata(s){const h=this.getForeground(s),c=this.getFontStyle(s);return{foreground:h,italic:!!(c&1),bold:!!(c&2),underline:!!(c&4),strikethrough:!!(c&8)}}}e.$bs=f}),define(q[25],_([0,1,26]),function(z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=void 0;class y{constructor(i){this.b=i,this.a=[]}get(i){return i<this.a.length?this.a[i]:this.b}set(i,f){for(;i>=this.a.length;)this.a[this.a.length]=this.b;this.a[i]=f}replace(i,f,t){if(i>=this.a.length)return;if(f===0){this.insert(i,t);return}else if(t===0){this.delete(i,f);return}const s=this.a.slice(0,i),h=this.a.slice(i+f),c=v(t,this.b);this.a=s.concat(c,h)}delete(i,f){f===0||i>=this.a.length||this.a.splice(i,f)}insert(i,f){if(f===0||i>=this.a.length)return;const t=[];for(let s=0;s<f;s++)t[s]=this.b;this.a=(0,k.$Cf)(this.a,i,t)}}e.$fC=y;function v(T,i){const f=[];for(let t=0;t<T;t++)f[t]=i;return f}}),define(q[7],_([0,1,14]),function(z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$es=void 0;class y{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(i,f){const t=y.defaultTokenMetadata,s=new Uint32Array(2);return s[0]=i.length,s[1]=t,new y(s,i,f)}constructor(i,f,t){this._lineTokensBrand=void 0,this.a=i,this.b=this.a.length>>>1,this.c=f,this.d=t}equals(i){return i instanceof y?this.slicedEquals(i,0,this.b):!1}slicedEquals(i,f,t){if(this.c!==i.c||this.b!==i.b)return!1;const s=f<<1,h=s+(t<<1);for(let c=s;c<h;c++)if(this.a[c]!==i.a[c])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(i){return i>0?this.a[i-1<<1]:0}getMetadata(i){return this.a[(i<<1)+1]}getLanguageId(i){const f=this.a[(i<<1)+1],t=k.$bs.getLanguageId(f);return this.d.decodeLanguageId(t)}getStandardTokenType(i){const f=this.a[(i<<1)+1];return k.$bs.getTokenType(f)}getForeground(i){const f=this.a[(i<<1)+1];return k.$bs.getForeground(f)}getClassName(i){const f=this.a[(i<<1)+1];return k.$bs.getClassNameFromMetadata(f)}getInlineStyle(i,f){const t=this.a[(i<<1)+1];return k.$bs.getInlineStyleFromMetadata(t,f)}getPresentation(i){const f=this.a[(i<<1)+1];return k.$bs.getPresentationFromMetadata(f)}getEndOffset(i){return this.a[i<<1]}findTokenIndexAtOffset(i){return y.findIndexInTokensArray(this.a,i)}inflate(){return this}sliceAndInflate(i,f,t){return new v(this,i,f,t)}static convertToEndOffset(i,f){const s=(i.length>>>1)-1;for(let h=0;h<s;h++)i[h<<1]=i[h+1<<1];i[s<<1]=f}static findIndexInTokensArray(i,f){if(i.length<=2)return 0;let t=0,s=(i.length>>>1)-1;for(;t<s;){const h=t+Math.floor((s-t)/2),c=i[h<<1];if(c===f)return h+1;c<f?t=h+1:c>f&&(s=h)}return t}withInserted(i){if(i.length===0)return this;let f=0,t=0,s="";const h=new Array;let c=0;for(;;){const u=f<this.b?this.a[f<<1]:-1,o=t<i.length?i[t]:null;if(u!==-1&&(o===null||u<=o.offset)){s+=this.c.substring(c,u);const n=this.a[(f<<1)+1];h.push(s.length,n),f++,c=u}else if(o){if(o.offset>c){s+=this.c.substring(c,o.offset);const n=this.a[(f<<1)+1];h.push(s.length,n),c=o.offset}s+=o.text,h.push(s.length,o.tokenMetadata),t++}else break}return new y(new Uint32Array(h),s,this.d)}}e.$es=y;class v{constructor(i,f,t,s){this.a=i,this.b=f,this.c=t,this.d=s,this.e=i.findTokenIndexAtOffset(f),this.f=0;for(let h=this.e,c=i.getCount();h<c&&!(i.getStartOffset(h)>=t);h++)this.f++}getMetadata(i){return this.a.getMetadata(this.e+i)}getLanguageId(i){return this.a.getLanguageId(this.e+i)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(i){return i instanceof v?this.b===i.b&&this.c===i.c&&this.d===i.d&&this.a.slicedEquals(i.a,this.e,this.f):!1}getCount(){return this.f}getForeground(i){return this.a.getForeground(this.e+i)}getEndOffset(i){const f=this.a.getEndOffset(this.e+i);return Math.min(this.c,f)-this.b+this.d}getClassName(i){return this.a.getClassName(this.e+i)}getInlineStyle(i,f){return this.a.getInlineStyle(this.e+i,f)}getPresentation(i){return this.a.getPresentation(this.e+i)}findTokenIndexAtOffset(i){return this.a.findTokenIndexAtOffset(i+this.b-this.d)-this.e}}}),define(q[27],_([0,1,7]),function(z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=e.$fs=void 0,e.$fs=new Uint32Array(0).buffer;class y{static deleteBeginning(i,f){return i===null||i===e.$fs?i:y.delete(i,0,f)}static deleteEnding(i,f){if(i===null||i===e.$fs)return i;const t=v(i),s=t[t.length-2];return y.delete(i,f,s)}static delete(i,f,t){if(i===null||i===e.$fs||f===t)return i;const s=v(i),h=s.length>>>1;if(f===0&&s[s.length-2]===t)return e.$fs;const c=k.$es.findIndexInTokensArray(s,f),u=c>0?s[c-1<<1]:0,o=s[c<<1];if(t<o){const O=t-f;for(let M=c;M<h;M++)s[M<<1]-=O;return i}let n,a;u!==f?(s[c<<1]=f,n=c+1<<1,a=f):(n=c<<1,a=u);const r=t-f;for(let O=c+1;O<h;O++){const M=s[O<<1]-r;M>a&&(s[n++]=M,s[n++]=s[(O<<1)+1],a=M)}if(n===s.length)return i;const m=new Uint32Array(n);return m.set(s.subarray(0,n),0),m.buffer}static append(i,f){if(f===e.$fs)return i;if(i===e.$fs)return f;if(i===null)return i;if(f===null)return null;const t=v(i),s=v(f),h=s.length>>>1,c=new Uint32Array(t.length+s.length);c.set(t,0);let u=t.length;const o=t[t.length-2];for(let n=0;n<h;n++)c[u++]=s[n<<1]+o,c[u++]=s[(n<<1)+1];return c.buffer}static insert(i,f,t){if(i===null||i===e.$fs)return i;const s=v(i),h=s.length>>>1;let c=k.$es.findIndexInTokensArray(s,f);c>0&&s[c-1<<1]===f&&c--;for(let u=c;u<h;u++)s[u<<1]+=t;return i}}e.$gs=y;function v(T){return T instanceof Uint32Array?T:new Uint32Array(T)}e.$hs=v}),define(q[28],_([0,1,26,12,44,13,27,15]),function(z,e,k,y,v,T,i,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=void 0;class t{static deserialize(h,c,u){const o=new Uint32Array(h.buffer),n=(0,y.$Nb)(h,c);c+=4;const a=(0,y.$Nb)(h,c);c+=4;const r=[];for(let m=0;m<a;m++){const O=(0,y.$Nb)(h,c);c+=4,r.push(o.subarray(c/4,c/4+O/4)),c+=O}return u.push(new t(n,r)),c}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(h,c){this.a=h,this.b=c}getLineRange(){return new f.$Nr(this.a,this.a+this.b.length)}getLineTokens(h){return this.b[h-this.a]}appendLineTokens(h){this.b.push(h)}serializeSize(){let h=0;h+=4,h+=4;for(let c=0;c<this.b.length;c++){const u=this.b[c];if(!(u instanceof Uint32Array))throw new Error("Not supported!");h+=4,h+=u.byteLength}return h}serialize(h,c){(0,y.$Ob)(h,this.a,c),c+=4,(0,y.$Ob)(h,this.b.length,c),c+=4;for(let u=0;u<this.b.length;u++){const o=this.b[u];if(!(o instanceof Uint32Array))throw new Error("Not supported!");(0,y.$Ob)(h,o.byteLength,c),c+=4,h.set(new Uint8Array(o.buffer),c),c+=o.byteLength}return c}applyEdit(h,c){const[u,o]=(0,T.$ds)(c);this.c(h),this.d(new v.$Lr(h.startLineNumber,h.startColumn),u,o)}c(h){if(h.startLineNumber===h.endLineNumber&&h.startColumn===h.endColumn)return;const c=h.startLineNumber-this.a,u=h.endLineNumber-this.a;if(u<0){const o=u-c;this.a-=o;return}if(!(c>=this.b.length)){if(c<0&&u>=this.b.length){this.a=0,this.b=[];return}if(c===u){this.b[c]=i.$gs.delete(this.b[c],h.startColumn-1,h.endColumn-1);return}if(c>=0)if(this.b[c]=i.$gs.deleteEnding(this.b[c],h.startColumn-1),u<this.b.length){const o=i.$gs.deleteBeginning(this.b[u],h.endColumn-1);this.b[c]=i.$gs.append(this.b[c],o),this.b.splice(c+1,u-c)}else this.b[c]=i.$gs.append(this.b[c],null),this.b=this.b.slice(0,c+1);else{const o=-c;this.a-=o,this.b[u]=i.$gs.deleteBeginning(this.b[u],h.endColumn-1),this.b=this.b.slice(u)}}}d(h,c,u){if(c===0&&u===0)return;const o=h.lineNumber-this.a;if(o<0){this.a+=c;return}if(!(o>=this.b.length)){if(c===0){this.b[o]=i.$gs.insert(this.b[o],h.column-1,u);return}this.b[o]=i.$gs.deleteEnding(this.b[o],h.column-1),this.b[o]=i.$gs.insert(this.b[o],h.column-1,u),this.e(h.lineNumber,c)}}e(h,c){if(c===0)return;const u=[];for(let o=0;o<c;o++)u[o]=null;this.b=k.$Cf(this.b,h,u)}}e.$is=t}),define(q[16],_([0,1,12,28]),function(z,e,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=void 0;class v{static deserialize(i){let f=0;const t=(0,k.$Nb)(i,f);f+=4;const s=[];for(let h=0;h<t;h++)f=y.$is.deserialize(i,f,s);return s}constructor(){this.a=[]}add(i,f){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===i){t.appendLineTokens(f);return}}this.a.push(new y.$is(i,[f]))}finalize(){return this.a}serialize(){const i=this.b(),f=new Uint8Array(i);return this.c(f),f}b(){let i=0;i+=4;for(let f=0;f<this.a.length;f++)i+=this.a[f].serializeSize();return i}c(i){let f=0;(0,k.$Ob)(i,this.a.length,f),f+=4;for(let t=0;t<this.a.length;t++)f=this.a[t].serialize(i,f)}}e.$gC=v}),define(q[29],_([0,1,30,3,31,45]),function(z,e,k,y,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=e.$Ee=e.$De=e.$Ce=void 0;function i(g){return g===47||g===92}e.$Ce=i;function f(g){return g.replace(/[\\/]/g,k.$0b.sep)}e.$De=f;function t(g){return g.indexOf("/")===-1&&(g=f(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}e.$Ee=t;function s(g,C=k.$0b.sep){if(!g)return"";const U=g.length,B=g.charCodeAt(0);if(i(B)){if(i(g.charCodeAt(1))&&!i(g.charCodeAt(2))){let b=3;const j=b;for(;b<U&&!i(g.charCodeAt(b));b++);if(j!==b&&!i(g.charCodeAt(b+1))){for(b+=1;b<U;b++)if(i(g.charCodeAt(b)))return g.slice(0,b+1).replace(/[\\/]/g,C)}}return C}else if(m(B)&&g.charCodeAt(1)===58)return i(g.charCodeAt(2))?g.slice(0,2)+C:g.slice(0,2);let A=g.indexOf("://");if(A!==-1){for(A+=3;A<U;A++)if(i(g.charCodeAt(A)))return g.slice(0,A+1)}return""}e.$Fe=s;function h(g){if(!y.$i||!g||g.length<5)return!1;let C=g.charCodeAt(0);if(C!==92||(C=g.charCodeAt(1),C!==92))return!1;let U=2;const B=U;for(;U<g.length&&(C=g.charCodeAt(U),C!==92);U++);return!(B===U||(C=g.charCodeAt(U+1),isNaN(C)||C===92))}e.$Ge=h;const c=/[\\/:\*\?"<>\|]/g,u=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function n(g,C=y.$i){const U=C?c:u;return!(!g||g.length===0||/^\s+$/.test(g)||(U.lastIndex=0,U.test(g))||C&&o.test(g)||g==="."||g===".."||C&&g[g.length-1]==="."||C&&g.length!==g.trim().length||g.length>255)}e.$He=n;function a(g,C,U){const B=g===C;return!U||B?B:!g||!C?!1:(0,v.$Ld)(g,C)}e.$Ie=a;function r(g,C,U,B=k.sep){if(g===C)return!0;if(!g||!C||C.length>g.length)return!1;if(U){if(!(0,v.$Md)(g,C))return!1;if(C.length===g.length)return!0;let b=C.length;return C.charAt(C.length-1)===B&&b--,g.charAt(b)===B}return C.charAt(C.length-1)!==B&&(C+=B),g.indexOf(C)===0}e.$Je=r;function m(g){return g>=65&&g<=90||g>=97&&g<=122}e.$Ke=m;function O(g,C){return y.$i&&g.endsWith(":")&&(g+=k.sep),(0,k.$_b)(g)||(g=(0,k.$ac)(C,g)),g=(0,k.$$b)(g),y.$i?(g=(0,v.$sd)(g,k.sep),g.endsWith(":")&&(g+=k.sep)):(g=(0,v.$sd)(g,k.sep),g||(g=k.sep)),g}e.$Le=O;function M(g){const C=(0,k.$$b)(g);return y.$i?g.length>3?!1:P(C)&&(g.length===2||C.charCodeAt(2)===92):C===k.$0b.sep}e.$Me=M;function P(g,C=y.$i){return C?m(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}e.$Ne=P;function S(g,C=y.$i){return P(g,C)?g[0]:void 0}e.$Oe=S;function d(g,C,U){return C.length>g.length?-1:g===C?0:(U&&(g=g.toLowerCase(),C=C.toLowerCase()),g.indexOf(C))}e.$Pe=d;function $(g){const C=g.split(":");let U,B,A;for(const b of C){const j=Number(b);(0,T.$me)(j)?B===void 0?B=j:A===void 0&&(A=j):U=U?[U,b].join(":"):b}if(!U)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:U,line:B!==void 0?B:void 0,column:A!==void 0?A:B!==void 0?1:void 0}}e.$Qe=$;const w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(g,C,U=8){let B="";for(let b=0;b<U;b++){let j;b===0&&y.$i&&!C&&(U===3||U===4)?j=L:j=w,B+=j.charAt(Math.floor(Math.random()*j.length))}let A;return C?A=`${C}-${B}`:A=B,g?(0,k.$ac)(g,A):A}e.$Re=D}),define(q[17],_([0,1,5,3,8]),function(z,e,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.Schemas=void 0;var T;(function(s){s.inMemory="inmemory",s.vscode="vscode",s.internal="private",s.walkThrough="walkThrough",s.walkThroughSnippet="walkThroughSnippet",s.http="http",s.https="https",s.file="file",s.mailto="mailto",s.untitled="untitled",s.data="data",s.command="command",s.vscodeRemote="vscode-remote",s.vscodeRemoteResource="vscode-remote-resource",s.vscodeManagedRemoteResource="vscode-managed-remote-resource",s.vscodeUserData="vscode-userdata",s.vscodeCustomEditor="vscode-custom-editor",s.vscodeNotebookCell="vscode-notebook-cell",s.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",s.vscodeNotebookCellOutput="vscode-notebook-cell-output",s.vscodeInteractiveInput="vscode-interactive-input",s.vscodeSettings="vscode-settings",s.vscodeWorkspaceTrust="vscode-workspace-trust",s.vscodeTerminal="vscode-terminal",s.vscodeChatSesssion="vscode-chat-editor",s.webviewPanel="webview-panel",s.vscodeWebview="vscode-webview",s.extension="extension",s.vscodeFileResource="vscode-file",s.tmp="tmp",s.vsls="vsls",s.vscodeSourceControl="vscode-scm"})(T||(e.Schemas=T={})),e.$Ve="vscode-tkn",e.$We="tkn";class i{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${T.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${T.vscodeRemoteResource}`}set(h,c,u){this.a[h]=c,this.b[h]=u}setConnectionToken(h,c){this.c[h]=c}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(r){return k.$Y(r),h}const c=h.authority;let u=this.a[c];u&&u.indexOf(":")!==-1&&u.indexOf("[")===-1&&(u=`[${u}]`);const o=this.b[c],n=this.c[c];let a=`path=${encodeURIComponent(h.path)}`;return typeof n=="string"&&(a+=`&${e.$We}=${encodeURIComponent(n)}`),v.URI.from({scheme:y.$o?this.d:T.vscodeRemoteResource,authority:`${u}:${o}`,path:this.f,query:a})}}e.$Xe=new i,e.$Ye="vs/../../extensions",e.$Ze="vs/../../node_modules",e.$1e="vs/../../node_modules.asar",e.$2e="vs/../../node_modules.asar.unpacked";class f{static{this.a="vscode-app"}asBrowserUri(h){const c=this.b(h,z);return this.uriToBrowserUri(c)}uriToBrowserUri(h){return h.scheme===T.vscodeRemote?e.$Xe.rewrite(h):h.scheme===T.file&&(y.$m||y.$p&&y.$g.origin===`${T.vscodeFileResource}://${f.a}`)?h.with({scheme:T.vscodeFileResource,authority:h.authority||f.a,query:null,fragment:null}):h}asFileUri(h){const c=this.b(h,z);return this.uriToFileUri(c)}uriToFileUri(h){return h.scheme===T.vscodeFileResource?h.with({scheme:T.file,authority:h.authority!==f.a?h.authority:null,query:null,fragment:null}):h}b(h,c){return v.URI.isUri(h)?h:v.URI.parse(c.toUrl(h))}}e.$3e=new f;var t;(function(s){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);s.CoopAndCoep=Object.freeze(h.get("3"));const c="vscode-coi";function u(n){let a;typeof n=="string"?a=new URL(n).searchParams:n instanceof URL?a=n.searchParams:v.URI.isUri(n)&&(a=new URL(n.toString(!0)).searchParams);const r=a?.get(c);if(r)return h.get(r)}s.getHeadersFromQuery=u;function o(n,a,r){if(!globalThis.crossOriginIsolated)return;const m=a&&r?"3":r?"2":"1";n instanceof URLSearchParams?n.set(c,m):n[c]=m}s.addSearchParam=o})(t||(e.COI=t={}))}),define(q[32],_([0,1,21,17,3,8]),function(z,e,k,y,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=void 0;class i{constructor(u,o,n){this.id=u,this.dependencies=o,this.callback=n}}class f{static{this.INSTANCE=new f}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(u,o,n)=>{typeof u!="string"&&(n=o,o=u,u=null),(typeof o!="object"||!Array.isArray(o))&&(n=o,o=null),this.c.push(new i(u,o,n))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){if(u.startsWith(window.location.origin)||u.startsWith("vscode-file://vscode-app"))return u;throw new Error(`[trusted_script_src] Invalid script url: ${u}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(u){return u}})))}async load(u){this.g();const o=await(this.a?this.i(u):this.b?this.h(u):this.j(u));if(!o)throw new Error(`Did not receive a define call from script ${u}`);if(Array.isArray(o.dependencies)&&o.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${u}. The dependencies are: ${o.dependencies.join(", ")}`);return typeof o.callback=="function"?o.callback([]):o.callback}h(u){return new Promise((o,n)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const r=()=>{a.removeEventListener("load",m),a.removeEventListener("error",O)},m=M=>{r(),o(this.c.pop())},O=M=>{r(),n(M)};a.addEventListener("load",m),a.addEventListener("error",O),this.f&&(u=this.f.createScriptURL(u)),a.setAttribute("src",u),document.getElementsByTagName("head")[0].appendChild(a)})}i(u){return new Promise((o,n)=>{try{this.f&&(u=this.f.createScriptURL(u)),importScripts(u),o(this.c.pop())}catch(a){n(a)}})}async j(u){try{const o=globalThis._VSCODE_NODE_MODULES.fs,n=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,r=T.URI.parse(u).fsPath,m=o.readFileSync(r).toString(),O=a.wrap(m.replace(/^#!.*/,""));return new n.Script(O).runInThisContext().apply(),this.c.pop()}catch(o){throw o}}}const t=new Map;let s={};typeof globalThis.require=="object"&&(s=globalThis.require.paths??{});async function h(c,u,o){if(k.$R){o===void 0&&(o=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),s[c]&&(c=s[c]);const n=`${c}/${u}`;if(t.has(n))return t.get(n);let a;if(/^\w[\w\d+.-]*:\/\//.test(n))a=n;else{const M=`${o&&!v.$o?y.$1e:y.$Ze}/${n}`;a=y.$3e.asBrowserUri(M).toString(!0)}const r=f.INSTANCE.load(a);return t.set(n,r),r}else return await new Promise((n,a)=>{z([c],n,a)})}e.$UC=h}),define(q[18],_([0,1,29,17,30,3,31,8]),function(z,e,k,y,v,T,i,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fg=e.DataUri=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=void 0;function t(o){return(0,f.$Ue)(o,!0)}e.$Vf=t;class s{constructor(n){this.a=n}compare(n,a,r=!1){return n===a?0:(0,i.$Ed)(this.getComparisonKey(n,r),this.getComparisonKey(a,r))}isEqual(n,a,r=!1){return n===a?!0:!n||!a?!1:this.getComparisonKey(n,r)===this.getComparisonKey(a,r)}getComparisonKey(n,a=!1){return n.with({path:this.a(n)?n.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(n){return this.a(n)}isEqualOrParent(n,a,r=!1){if(n.scheme===a.scheme){if(n.scheme===y.Schemas.file)return k.$Je(t(n),t(a),this.a(n))&&n.query===a.query&&(r||n.fragment===a.fragment);if((0,e.$ag)(n.authority,a.authority))return k.$Je(n.path,a.path,this.a(n),"/")&&n.query===a.query&&(r||n.fragment===a.fragment)}return!1}joinPath(n,...a){return f.URI.joinPath(n,...a)}basenameOrAuthority(n){return(0,e.$5f)(n)||n.authority}basename(n){return v.$0b.basename(n.path)}extname(n){return v.$0b.extname(n.path)}dirname(n){if(n.path.length===0)return n;let a;return n.scheme===y.Schemas.file?a=f.URI.file(v.$dc(t(n))).path:(a=v.$0b.dirname(n.path),n.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${n.toString})) resulted in a relative path`),a="/")),n.with({path:a})}normalizePath(n){if(!n.path.length)return n;let a;return n.scheme===y.Schemas.file?a=f.URI.file(v.$$b(t(n))).path:a=v.$0b.normalize(n.path),n.with({path:a})}relativePath(n,a){if(n.scheme!==a.scheme||!(0,e.$ag)(n.authority,a.authority))return;if(n.scheme===y.Schemas.file){const O=v.$cc(t(n),t(a));return T.$i?k.$De(O):O}let r=n.path||"/";const m=a.path||"/";if(this.a(n)){let O=0;for(const M=Math.min(r.length,m.length);O<M&&!(r.charCodeAt(O)!==m.charCodeAt(O)&&r.charAt(O).toLowerCase()!==m.charAt(O).toLowerCase());O++);r=m.substr(0,O)+r.substr(O)}return v.$0b.relative(r,m)}resolvePath(n,a){if(n.scheme===y.Schemas.file){const r=f.URI.file(v.$bc(t(n),a));return n.with({authority:r.authority,path:r.path})}return a=k.$Ee(a),n.with({path:v.$0b.resolve(n.path,a)})}isAbsolutePath(n){return!!n.path&&n.path[0]==="/"}isEqualAuthority(n,a){return n===a||n!==void 0&&a!==void 0&&(0,i.$Ld)(n,a)}hasTrailingPathSeparator(n,a=v.sep){if(n.scheme===y.Schemas.file){const r=t(n);return r.length>k.$Fe(r).length&&r[r.length-1]===a}else{const r=n.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(n.fsPath)}}removeTrailingPathSeparator(n,a=v.sep){return(0,e.$bg)(n,a)?n.with({path:n.path.substr(0,n.path.length-1)}):n}addTrailingPathSeparator(n,a=v.sep){let r=!1;if(n.scheme===y.Schemas.file){const m=t(n);r=m!==void 0&&m.length===k.$Fe(m).length&&m[m.length-1]===a}else{a="/";const m=n.path;r=m.length===1&&m.charCodeAt(m.length-1)===47}return!r&&!(0,e.$bg)(n,a)?n.with({path:n.path+"/"}):n}}e.$Wf=s,e.$Xf=new s(()=>!1),e.$Yf=new s(o=>o.scheme===y.Schemas.file?!T.$k:!0),e.$Zf=new s(o=>!0),e.$1f=e.$Xf.isEqual.bind(e.$Xf),e.$2f=e.$Xf.isEqualOrParent.bind(e.$Xf),e.$3f=e.$Xf.getComparisonKey.bind(e.$Xf),e.$4f=e.$Xf.basenameOrAuthority.bind(e.$Xf),e.$5f=e.$Xf.basename.bind(e.$Xf),e.$6f=e.$Xf.extname.bind(e.$Xf),e.$7f=e.$Xf.dirname.bind(e.$Xf),e.$8f=e.$Xf.joinPath.bind(e.$Xf),e.$9f=e.$Xf.normalizePath.bind(e.$Xf),e.$0f=e.$Xf.relativePath.bind(e.$Xf),e.$$f=e.$Xf.resolvePath.bind(e.$Xf),e.$_f=e.$Xf.isAbsolutePath.bind(e.$Xf),e.$ag=e.$Xf.isEqualAuthority.bind(e.$Xf),e.$bg=e.$Xf.hasTrailingPathSeparator.bind(e.$Xf),e.$cg=e.$Xf.removeTrailingPathSeparator.bind(e.$Xf),e.$dg=e.$Xf.addTrailingPathSeparator.bind(e.$Xf);function h(o,n){const a=[];for(let r=0;r<o.length;r++){const m=n(o[r]);o.some((O,M)=>M===r?!1:(0,e.$2f)(m,n(O)))||a.push(o[r])}return a}e.$eg=h;var c;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function n(a){const r=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(M=>{const[P,S]=M.split(":");P&&S&&r.set(P,S)});const O=a.path.substring(0,a.path.indexOf(";"));return O&&r.set(o.META_DATA_MIME,O),r}o.parseMetaData=n})(c||(e.DataUri=c={}));function u(o,n,a){if(n){let r=o.path;return r&&r[0]!==v.$0b.sep&&(r=v.$0b.sep+r),o.with({scheme:a,authority:n,path:r})}return o.with({scheme:a})}e.$fg=u}),define(q[19],_([0,1,46,5,33,2,18,3,24]),function(z,e,k,y,v,T,i,f,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qg=e.$Pg=e.$Og=e.Promises=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=void 0;function s(N){return!!N&&typeof N.then=="function"}e.$gg=s;function h(N){const l=new k.$dd,E=N(l.token),I=new Promise((R,F)=>{const H=l.token.onCancellationRequested(()=>{H.dispose(),l.dispose(),F(new y.$3)});Promise.resolve(E).then(Z=>{H.dispose(),l.dispose(),R(Z)},Z=>{H.dispose(),l.dispose(),F(Z)})});return new class{cancel(){l.cancel()}then(R,F){return I.then(R,F)}catch(R){return this.then(void 0,R)}finally(R){return I.finally(R)}}}e.$hg=h;function c(N,l,E){return new Promise((I,R)=>{const F=l.onCancellationRequested(()=>{F.dispose(),I(E)});N.then(I,R).finally(()=>F.dispose())})}e.$ig=c;function u(N,l){return new Promise((E,I)=>{const R=l.onCancellationRequested(()=>{R.dispose(),I(new y.$3)});N.then(E,I).finally(()=>R.dispose())})}e.$jg=u;async function o(N){let l=-1;const E=N.map((I,R)=>I.then(F=>(l=R,F)));try{return await Promise.race(E)}finally{N.forEach((I,R)=>{R!==l&&I.cancel()})}}e.$kg=o;function n(N,l,E){let I;const R=setTimeout(()=>{I?.(void 0),E?.()},l);return Promise.race([N.finally(()=>clearTimeout(R)),new Promise(F=>I=F)])}e.$lg=n;function a(N){return new Promise((l,E)=>{const I=N();s(I)?I.then(l,E):l(I)})}e.$mg=a;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(l){if(this.f)throw new Error("Throttler is disposed");if(this.a){if(this.d=l,!this.b){const E=()=>{if(this.b=null,this.f)return;const I=this.queue(this.d);return this.d=null,I};this.b=new Promise(I=>{this.a.then(E,E).then(I)})}return new Promise((E,I)=>{this.b.then(E,I)})}return this.a=l(),new Promise((E,I)=>{this.a.then(R=>{this.a=null,E(R)},R=>{this.a=null,I(R)})})}dispose(){this.f=!0}}e.$ng=r;class m{constructor(){this.a=Promise.resolve(null)}queue(l){return this.a=this.a.then(()=>l(),()=>l())}}e.$og=m;class O{constructor(){this.a=new Map}queue(l,E){const R=(this.a.get(l)??Promise.resolve()).catch(()=>{}).then(E).finally(()=>{this.a.get(l)===R&&this.a.delete(l)});return this.a.set(l,R),R}}e.$pg=O;const M=(N,l)=>{let E=!0;const I=setTimeout(()=>{E=!1,l()},N);return{isTriggered:()=>E,dispose:()=>{clearTimeout(I),E=!1}}},P=N=>{let l=!0;return queueMicrotask(()=>{l&&(l=!1,N())}),{isTriggered:()=>l,dispose:()=>{l=!1}}};class S{constructor(l){this.defaultDelay=l,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(l,E=this.defaultDelay){this.g=l,this.h(),this.b||(this.b=new Promise((R,F)=>{this.d=R,this.f=F}).then(()=>{if(this.b=null,this.d=null,this.g){const R=this.g;return this.g=null,R()}}));const I=()=>{this.a=null,this.d?.(null)};return this.a=E===t.$4c?P(I):M(E,I),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new y.$3),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$qg=S;class d{constructor(l){this.a=new S(l),this.b=new r}trigger(l,E){return this.a.trigger(()=>this.b.queue(l),E)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$rg=d;class ${constructor(){this.a=!1,this.b=new Promise((l,E)=>{this.d=l})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$sg=$;class w extends ${constructor(l){super(),this.f=setTimeout(()=>this.open(),l)}open(){clearTimeout(this.f),super.open()}}e.$tg=w;function L(N,l){return l?new Promise((E,I)=>{const R=setTimeout(()=>{F.dispose(),E()},N),F=l.onCancellationRequested(()=>{clearTimeout(R),F.dispose(),I(new y.$3)})}):h(E=>L(N,E))}e.$ug=L;function D(N,l=0){const E=setTimeout(N,l);return(0,T.$jb)(()=>clearTimeout(E))}e.$vg=D;function g(N){const l=[];let E=0;const I=N.length;function R(){return E<I?N[E++]():null}function F(H){H!=null&&l.push(H);const Z=R();return Z?Z.then(F):Promise.resolve(l)}return Promise.resolve(null).then(F)}e.$wg=g;function C(N,l=I=>!!I,E=null){let I=0;const R=N.length,F=()=>{if(I>=R)return Promise.resolve(E);const H=N[I++];return Promise.resolve(H()).then(J=>l(J)?Promise.resolve(J):F())};return F()}e.$xg=C;function U(N,l=I=>!!I,E=null){if(N.length===0)return Promise.resolve(E);let I=N.length;const R=()=>{I=-1;for(const F of N)F.cancel?.()};return new Promise((F,H)=>{for(const Z of N)Z.then(J=>{--I>=0&&l(J)?(R(),F(J)):I===0&&F(E)}).catch(J=>{--I>=0&&(R(),H(J))})})}e.$yg=U;class B{constructor(l){this.a=0,this.d=l,this.f=[],this.b=0,this.g=new v.$7c}get onDrained(){return this.g.event}get size(){return this.a}queue(l){return this.a++,new Promise((E,I)=>{this.f.push({factory:l,c:E,e:I}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const l=this.f.shift();this.b++;const E=l.factory();E.then(l.c,l.e),E.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$zg=B;class A extends B{constructor(){super(1)}}e.$Ag=A;class b{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const l=new ee;return this.b.add(l),l.p}d(){for(const[,l]of this.a)if(l.size>0)return!1;return!0}queueFor(l,E=i.$Xf){const I=E.getComparisonKey(l);let R=this.a.get(I);return R||(R=new A,v.Event.once(R.onDrained)(()=>{R?.dispose(),this.a.delete(I),this.f()}),this.a.set(I,R)),R}f(){this.d()&&this.g()}g(){for(const l of this.b)l.complete();this.b.clear()}dispose(){for(const[,l]of this.a)l.dispose();this.a.clear(),this.g()}}e.$Bg=b;class j{constructor(l,E){this.a=-1,typeof l=="function"&&typeof E=="number"&&this.setIfNotSet(l,E)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(l,E){this.cancel(),this.a=setTimeout(()=>{this.a=-1,l()},E)}setIfNotSet(l,E){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,l()},E))}}e.$Cg=j;class p{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(l,E){this.cancel(),this.a=setInterval(()=>{l()},E)}}e.$Dg=p;class W{constructor(l,E){this.b=-1,this.a=l,this.d=E,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(l=this.d){this.cancel(),this.b=setTimeout(this.f,l)}get delay(){return this.d}set delay(l){this.d=l}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Eg=W;class X{constructor(l,E){E%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${E}ms is not a multiple of 1000ms.`),this.a=l,this.b=E,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(l=this.b){l%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${l}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(l/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Fg=X;class V extends W{constructor(l,E){super(l,E),this.j=[]}work(l){this.j.push(l),this.isScheduled()||this.schedule()}h(){const l=this.j;this.j=[],this.a?.(l)}dispose(){this.j=[],super.dispose()}}e.$Gg=V;class K extends T.$lb{constructor(l,E){super(),this.g=l,this.h=E,this.a=[],this.b=this.B(new T.$mb),this.f=!1}get pending(){return this.a.length}work(l){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+l.length>this.g.maxBufferedWork)return!1}else if(this.pending+l.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const E of l)this.a.push(E);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new W(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Hg=K,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.$Ig=N=>{(0,f.$A)(()=>{if(l)return;const E=Date.now()+15;N(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,E-Date.now())}}))});let l=!1;return{dispose(){l||(l=!0)}}}:e.$Ig=(N,l)=>{const E=requestIdleCallback(N,typeof l=="number"?{timeout:l}:void 0);let I=!1;return{dispose(){I||(I=!0,cancelIdleCallback(E))}}}}();class G{constructor(l){this.d=!1,this.a=()=>{try{this.f=l()}catch(E){this.g=E}finally{this.d=!0}},this.b=(0,e.$Ig)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.$Jg=G;async function Q(N,l,E){let I;for(let R=0;R<E;R++)try{return await N()}catch(F){I=F,await L(l)}throw I}e.$Kg=Q;class ae{hasPending(l){return this.a?typeof l=="number"?this.a.taskId===l:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(l,E,I){return this.a={taskId:l,cancel:()=>I?.(),promise:E},E.then(()=>this.d(l),()=>this.d(l)),E}d(l){this.a&&l===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const l=this.b;this.b=void 0,l.run().then(l.promiseResolve,l.promiseReject)}}setNext(l){if(this.b)this.b.run=l;else{let E,I;const R=new Promise((F,H)=>{E=F,I=H});this.b={run:l,promise:R,promiseResolve:E,promiseReject:I}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Lg=ae;class ce{constructor(l,E=()=>Date.now()){this.d=l,this.f=E,this.a=0,this.b=0}increment(){const l=this.f();return l-this.a>this.d&&(this.a=l,this.b=0),this.b++,this.b}}e.$Mg=ce;var x;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(x||(x={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((l,E)=>{this.a=l,this.b=E})}complete(l){return new Promise(E=>{this.a(l),this.d={outcome:0,value:l},E()})}error(l){return new Promise(E=>{this.b(l),this.d={outcome:1,value:l},E()})}cancel(){return this.error(new y.$3)}}e.$Ng=ee;var te;(function(N){async function l(I){let R;const F=await Promise.all(I.map(H=>H.then(Z=>Z,Z=>{R||(R=Z)})));if(typeof R<"u")throw R;return F}N.settled=l;function E(I){return new Promise(async(R,F)=>{try{await I(R,F)}catch(H){F(H)}})}N.withAsyncBody=E})(te||(e.Promises=te={}));var ne;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(ne||(ne={}));class Y{static fromArray(l){return new Y(E=>{E.emitMany(l)})}static fromPromise(l){return new Y(async E=>{E.emitMany(await l)})}static fromPromises(l){return new Y(async E=>{await Promise.all(l.map(async I=>E.emitOne(await I)))})}static merge(l){return new Y(async E=>{await Promise.all(l.map(async I=>{for await(const R of I)E.emitOne(R)}))})}static{this.EMPTY=Y.fromArray([])}constructor(l){this.a=0,this.b=[],this.d=null,this.f=new v.$7c,queueMicrotask(async()=>{const E={emitOne:I=>this.g(I),emitMany:I=>this.h(I),reject:I=>this.k(I)};try{await Promise.resolve(l(E)),this.j()}catch(I){this.k(I)}finally{E.emitOne=void 0,E.emitMany=void 0,E.reject=void 0}})}[Symbol.asyncIterator](){let l=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(l<this.b.length)return{done:!1,value:this.b[l++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(l,E){return new Y(async I=>{for await(const R of l)I.emitOne(E(R))})}map(l){return Y.map(this,l)}static filter(l,E){return new Y(async I=>{for await(const R of l)E(R)&&I.emitOne(R)})}filter(l){return Y.filter(this,l)}static coalesce(l){return Y.filter(l,E=>!!E)}coalesce(){return Y.coalesce(this)}static async toPromise(l){const E=[];for await(const I of l)E.push(I);return E}toPromise(){return Y.toPromise(this)}g(l){this.a===0&&(this.b.push(l),this.f.fire())}h(l){this.a===0&&(this.b=this.b.concat(l),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(l){this.a===0&&(this.a=2,this.d=l,this.f.fire())}}e.$Og=Y;class ie extends Y{constructor(l,E){super(E),this.l=l}cancel(){this.l.cancel()}}e.$Pg=ie;function oe(N){const l=new k.$dd,E=N(l.token);return new ie(l,async I=>{const R=l.token.onCancellationRequested(()=>{R.dispose(),l.dispose(),I.reject(new y.$3)});try{for await(const F of E){if(l.token.isCancellationRequested)return;I.emitOne(F)}R.dispose(),l.dispose()}catch(F){R.dispose(),l.dispose(),I.reject(F)}})}e.$Qg=oe}),define(q[20],_([0,1,34]),function(z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=e.$dC=e.$cC=void 0,e.$cC=new class{clone(){return this}equals(T){return this===T}};function y(T,i){return new k.$ls([new k.$ks(0,"",T)],i)}e.$dC=y;function v(T,i){const f=new Uint32Array(2);return f[0]=0,f[1]=(T<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new k.$ms(f,i===null?e.$cC:i)}e.$eC=v}),define(q[35],_([0,1,19,5,3,36,13,15,47,20,25,16,7]),function(z,e,k,y,v,T,i,f,t,s,h,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=e.$hC=void 0;var o;(function(S){S[S.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(o||(o={}));class n{constructor(d,$){this.tokenizationSupport=$,this.a=this.tokenizationSupport.getInitialState(),this.store=new r(d)}getStartState(d){return this.store.getStartState(d,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$hC=n;class a extends n{constructor(d,$,w,L){super(d,$),this._textModel=w,this._languageIdCodec=L}updateTokensUntilLine(d,$){const w=this._textModel.getLanguageId();for(;;){const L=this.getFirstInvalidLine();if(!L||L.lineNumber>$)break;const D=this._textModel.getLineContent(L.lineNumber),g=M(this._languageIdCodec,w,this.tokenizationSupport,D,!0,L.startState);d.add(L.lineNumber,g.tokens),this.store.setEndState(L.lineNumber,g.endState)}}getTokenTypeIfInsertingCharacter(d,$){const w=this.getStartState(d.lineNumber);if(!w)return 0;const L=this._textModel.getLanguageId(),D=this._textModel.getLineContent(d.lineNumber),g=D.substring(0,d.column-1)+$+D.substring(d.column-1),C=M(this._languageIdCodec,L,this.tokenizationSupport,g,!0,w),U=new u.$es(C.tokens,g,this._languageIdCodec);if(U.getCount()===0)return 0;const B=U.findTokenIndexAtOffset(d.column-1);return U.getStandardTokenType(B)}tokenizeLineWithEdit(d,$,w){const L=d.lineNumber,D=d.column,g=this.getStartState(L);if(!g)return null;const C=this._textModel.getLineContent(L),U=C.substring(0,D-1)+w+C.substring(D-1+$),B=this._textModel.getLanguageIdAtPosition(L,0),A=M(this._languageIdCodec,B,this.tokenizationSupport,U,!0,g);return new u.$es(A.tokens,U,this._languageIdCodec)}isCheapToTokenize(d){const $=this.store.getFirstInvalidEndStateLineNumberOrMax();return d<$||d===$&&this._textModel.getLineLength(d)<2048}tokenizeHeuristically(d,$,w){if(w<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if($<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(d,w),{heuristicTokens:!1};let L=this.b($);const D=this._textModel.getLanguageId();for(let g=$;g<=w;g++){const C=this._textModel.getLineContent(g),U=M(this._languageIdCodec,D,this.tokenizationSupport,C,!0,L);d.add(g,U.tokens),L=U.endState}return{heuristicTokens:!0}}b(d){let $=this._textModel.getLineFirstNonWhitespaceColumn(d);const w=[];let L=null;for(let C=d-1;$>1&&C>=1;C--){const U=this._textModel.getLineFirstNonWhitespaceColumn(C);if(U!==0&&U<$&&(w.push(this._textModel.getLineContent(C)),$=U,L=this.getStartState(C),L))break}L||(L=this.tokenizationSupport.getInitialState()),w.reverse();const D=this._textModel.getLanguageId();let g=L;for(const C of w)g=M(this._languageIdCodec,D,this.tokenizationSupport,C,!1,g).endState;return g}}e.$iC=a;class r{constructor(d){this.d=d,this.a=new m,this.b=new O,this.b.addRange(new t.$bC(1,d+1))}getEndState(d){return this.a.getEndState(d)}setEndState(d,$){if(!$)throw new y.$bb("Cannot set null/undefined state");this.b.delete(d);const w=this.a.setEndState(d,$);return w&&d<this.d&&this.b.addRange(new t.$bC(d+1,d+2)),w}acceptChange(d,$){this.d+=$-d.length,this.a.acceptChange(d,$),this.b.addRangeAndResize(new t.$bC(d.startLineNumber,d.endLineNumberExclusive),$)}acceptChanges(d){for(const $ of d){const[w]=(0,i.$ds)($.text);this.acceptChange(new f.$Nr($.range.startLineNumber,$.range.endLineNumber+1),w+1)}}invalidateEndStateRange(d){this.b.addRange(new t.$bC(d.startLineNumber,d.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(d,$){return d===1?$:this.getEndState(d-1)}getFirstInvalidLine(d){const $=this.getFirstInvalidEndStateLineNumber();if($===null)return null;const w=this.getStartState($,d);if(!w)throw new y.$bb("Start state must be defined");return{lineNumber:$,startState:w}}}e.$jC=r;class m{constructor(){this.a=new h.$fC(null)}getEndState(d){return this.a.get(d)}setEndState(d,$){const w=this.a.get(d);return w&&w.equals($)?!1:(this.a.set(d,$),!0)}acceptChange(d,$){let w=d.length;$>0&&w>0&&(w--,$--),this.a.replace(d.startLineNumber,w,$)}acceptChanges(d){for(const $ of d){const[w]=(0,i.$ds)($.text);this.acceptChange(new f.$Nr($.range.startLineNumber,$.range.endLineNumber+1),w+1)}}}e.$kC=m;class O{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const d=this.a[0];return d.start+1===d.endExclusive?this.a.shift():this.a[0]=new t.$bC(d.start+1,d.endExclusive),d.start}delete(d){const $=this.a.findIndex(w=>w.contains(d));if($!==-1){const w=this.a[$];w.start===d?w.endExclusive===d+1?this.a.splice($,1):this.a[$]=new t.$bC(d+1,w.endExclusive):w.endExclusive===d+1?this.a[$]=new t.$bC(w.start,d):this.a.splice($,1,new t.$bC(w.start,d),new t.$bC(d+1,w.endExclusive))}}addRange(d){t.$bC.addRange(d,this.a)}addRangeAndResize(d,$){let w=0;for(;!(w>=this.a.length||d.start<=this.a[w].endExclusive);)w++;let L=w;for(;!(L>=this.a.length||d.endExclusive<this.a[L].start);)L++;const D=$-d.length;for(let g=L;g<this.a.length;g++)this.a[g]=this.a[g].delta(D);if(w===L){const g=new t.$bC(d.start,d.start+$);g.isEmpty||this.a.splice(w,0,g)}else{const g=Math.min(d.start,this.a[w].start),C=Math.max(d.endExclusive,this.a[L-1].endExclusive),U=new t.$bC(g,C+D);U.isEmpty?this.a.splice(w,L-w):this.a.splice(w,L-w,U)}}toString(){return this.a.map(d=>d.toString()).join(" + ")}}e.$lC=O;function M(S,d,$,w,L,D){let g=null;if($)try{g=$.tokenizeEncoded(w,L,D.clone())}catch(C){(0,y.$Y)(C)}return g||(g=(0,s.$eC)(S.encodeLanguageId(d),D)),u.$es.convertToEndOffset(g.tokens,w.length),g}class P{constructor(d,$){this.b=d,this.d=$,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,k.$Ig)(d=>{this.f=!1,this.h(d)}))}h(d){const $=Date.now()+d.timeRemaining(),w=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<$?(0,v.$A)(w):this.g())};w()}j(){const d=this.b._textModel.getLineCount(),$=new c.$gC,w=T.$3c.create(!1);do if(w.elapsed()>1||this.l($)>=d)break;while(this.k());this.d.setTokens($.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(d){const $=this.b?.getFirstInvalidLine();return $?(this.b.updateTokensUntilLine(d,$.lineNumber),$.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(d,$){this.b.store.invalidateEndStateRange(new f.$Nr(d,$))}}e.$mC=P}),define(q[37],_([0,1,33,2,36,14,34]),function(z,e,k,y,v,T,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8yb=void 0;class f extends y.$lb{constructor(s,h,c,u,o,n,a){super(),this.c=s,this.f=h,this.g=c,this.h=u,this.j=o,this.k=n,this.l=a,this.a=[],this.b=this.B(new k.$7c),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(s,h,c){throw new Error("Not supported!")}createBackgroundTokenizer(s,h){if(this.h)return this.h(s,h)}tokenizeEncoded(s,h,c){const u=Math.random()*1e4<1,o=this.l||u,n=o?new v.$3c(!0):void 0,a=this.c.tokenizeLine2(s,c,500);if(o){const m=n.elapsed();(u||m>32)&&this.k(m,s.length,u)}if(a.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${s.substring(0,100)}`),new i.$ms(a.tokens,c);if(this.g){const m=this.a,O=a.tokens;for(let M=0,P=O.length>>>1;M<P;M++){const S=O[(M<<1)+1],d=T.$bs.getLanguageId(S);m[d]||(m[d]=!0,this.b.fire(d))}}let r;return c.equals(a.ruleStack)?r=c:r=a.ruleStack,new i.$ms(a.tokens,r)}}e.$8yb=f}),define(q[38],_([0,1,20,2,11]),function(z,e,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9yb=void 0;class T extends y.$lb{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(f,t,s){super(),this.a=f,this.b=t,this.c=s,this.B((0,v.$Hc)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(f,t,s){throw new Error("Not supported!")}tokenizeEncoded(f,t,s){return f.length>=this.c.get()?(0,k.$eC)(this.a,s):this.b.tokenizeEncoded(f,t,s)}createBackgroundTokenizer(f,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(f,t)}}e.$9yb=T}),define(q[39],_([0,1,32,19,11,3,15,48,35,16,7,37,38]),function(z,e,k,y,v,T,i,f,t,s,h,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bzb=void 0;class o extends f.$uu{constructor(r,m,O,M,P,S,d,$){super(r,m,O,M),this.s=P,this.t=S,this.u=d,this.a=null,this.b=!1,this.c=(0,v.observableValue)("_maxTokenizationLineLength",-1),this.q=new y.$Eg(()=>this.w(),10),this.c.set($,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(r,m){this.t=r,this.u=m,this.v()}onEvents(r){super.onEvents(r),this.a?.store.acceptChanges(r.changes),this.q.schedule()}acceptMaxTokenizationLineLength(r){this.c.set(r,void 0)}retokenize(r,m){this.a&&(this.a.store.invalidateEndStateRange(new i.$Nr(r,m)),this.q.schedule())}async v(){this.a=null;const r=this.t,m=this.u,O=await this.s.getOrCreateGrammar(r,m);if(!(this.b||r!==this.t||m!==this.u||!O)){if(O.grammar){const M=new u.$9yb(this.u,new c.$8yb(O.grammar,O.initialState,!1,void 0,()=>!1,(P,S,d)=>{this.s.reportTokenizationTime(P,r,O.sourceExtensionId,S,d)},!1),this.c);this.a=new t.$hC(this.f.length,M)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:m}=await(0,k.$UC)("vscode-textmate","release/main.js");this.m=m}const r=new Date().getTime();for(;;){let m=0;const O=new s.$gC,M=new n;for(;;){const d=this.a.getFirstInvalidLine();if(d===null||m>200)break;m++;const $=this.f[d.lineNumber-1],w=this.a.tokenizationSupport.tokenizeEncoded($,!0,d.startState);if(this.a.store.setEndState(d.lineNumber,w.endState)){const D=this.m(d.startState,w.endState);M.setState(d.lineNumber,D)}else M.setState(d.lineNumber,null);if(h.$es.convertToEndOffset(w.tokens,$.length),O.add(d.lineNumber,w.tokens),new Date().getTime()-r>20)break}if(m===0)break;const P=M.getStateDeltas();if(this.s.setTokensAndStates(this.h,O.serialize(),P),new Date().getTime()-r>20){(0,T.$A)(()=>this.w());return}}}}e.$bzb=o;class n{constructor(){this.a=-1,this.b=[]}setState(r,m){r===this.a+1?this.b[this.b.length-1].stateDeltas.push(m):this.b.push({startLineNumber:r,stateDeltas:[m]}),this.a=r}getStateDeltas(){return this.b}}}),define(q[40],_([0,1,18]),function(z,e,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$yb=void 0;class y{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(T){if(this.a[T.scopeName]){const i=this.a[T.scopeName];k.$1f(i.location,T.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${T.scopeName}.
Old grammar file: ${i.location.toString()}.
New grammar file: ${T.location.toString()}`)}this.a[T.scopeName]=T}getGrammarDefinition(T){return this.a[T]||null}}e.$$yb=y}),define(q[41],_([0,1,2,40]),function(z,e,k,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$azb=e.$_yb=void 0,e.$_yb="No TM Grammar registered for this language.";class v extends k.$lb{constructor(i,f,t,s){super(),this.a=i,this.b=t.INITIAL,this.c=new y.$$yb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:s,loadGrammar:async h=>{const c=this.c.getGrammarDefinition(h);if(!c)return this.a.logTrace(`No grammar found for scope ${h}`),null;const u=c.location;try{const o=await this.a.readFile(u);return t.parseRawGrammar(o,u.path)}catch(o){return this.a.logError(`Unable to load and parse grammar for scope ${h} from ${u}`,o),null}},getInjections:h=>{const c=h.split(".");let u=[];for(let o=1;o<=c.length;o++){const n=c.slice(0,o).join(".");u=[...u,...this.f[n]||[]]}return u}}));for(const h of f){if(this.c.register(h),h.injectTo){for(const c of h.injectTo){let u=this.f[c];u||(this.f[c]=u=[]),u.push(h.scopeName)}if(h.embeddedLanguages)for(const c of h.injectTo){let u=this.g[c];u||(this.g[c]=u=[]),u.push(h.embeddedLanguages)}}h.language&&this.h.set(h.language,h.scopeName)}}has(i){return this.h.has(i)}setTheme(i,f){this.j.setTheme(i,f)}getColorMap(){return this.j.getColorMap()}async createGrammar(i,f){const t=this.h.get(i);if(typeof t!="string")throw new Error(e.$_yb);const s=this.c.getGrammarDefinition(t);if(!s)throw new Error(e.$_yb);const h=s.embeddedLanguages;if(this.g[t]){const o=this.g[t];for(const n of o)for(const a of Object.keys(n))h[a]=n[a]}const c=Object.keys(h).length>0;let u;try{u=await this.j.loadGrammarWithConfiguration(t,f,{embeddedLanguages:h,tokenTypes:s.tokenTypes,balancedBracketSelectors:s.balancedBracketSelectors,unbalancedBracketSelectors:s.unbalancedBracketSelectors})}catch(o){throw o.message&&o.message.startsWith("No grammar provided for")?new Error(e.$_yb):o}return{languageId:i,grammar:u,initialState:this.b,containsEmbeddedLanguages:c,sourceExtensionId:s.sourceExtensionId}}}e.$azb=v}),define(q[49],_([0,1,8,41,39]),function(z,e,k,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function T(f,t){return new i(f,t)}e.create=T;class i{constructor(t,s){this.f=s,this.b=new Map,this.c=[],this.a=t.host;const h=s.grammarDefinitions.map(c=>({location:k.URI.revive(c.location),language:c.language,scopeName:c.scopeName,embeddedLanguages:c.embeddedLanguages,tokenTypes:c.tokenTypes,injectTo:c.injectTo,balancedBracketSelectors:c.balancedBracketSelectors,unbalancedBracketSelectors:c.unbalancedBracketSelectors,sourceExtensionId:c.sourceExtensionId}));this.d=this.g(h)}async g(t){const s=this.f.textmateMainUri,h=await new Promise((a,r)=>{z([s],a,r)}),c=await new Promise((a,r)=>{z([this.f.onigurumaMainUri],a,r)}),o=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await c.loadWASM(o);const n=Promise.resolve({createOnigScanner:a=>c.createOnigScanner(a),createOnigString:a=>c.createOnigString(a)});return new y.$azb({logTrace:a=>{},logError:(a,r)=>console.error(a,r),readFile:a=>this.a.readFile(a)},t,h,n)}acceptNewModel(t){const s=k.URI.revive(t.uri),h=this;this.b.set(t.controllerId,new v.$bzb(s,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(c,u){const o=await h.d;return o?(h.c[u]||(h.c[u]=o.createGrammar(c,u)),h.c[u]):Promise.resolve(null)},setTokensAndStates(c,u,o){h.a.setTokensAndStates(t.controllerId,c,u,o)},reportTokenizationTime(c,u,o,n,a){h.a.reportTokenizationTime(c,u,o,n,a)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,s){this.b.get(t).onEvents(s)}retokenize(t,s,h){this.b.get(t).retokenize(s,h)}acceptModelLanguageChanged(t,s,h){this.b.get(t).onLanguageId(s,h)}acceptRemovedModel(t){const s=this.b.get(t);s&&(s.dispose(),this.b.delete(t))}async acceptTheme(t,s){(await this.d)?.setTheme(t,s)}acceptMaxTokenizationLineLength(t,s){this.b.get(t).acceptMaxTokenizationLineLength(s)}}e.TextMateTokenizationWorker=i})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/6c3e3dba23e8fadc360aed75ce363ba185c49794/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
